prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4419
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4419 - Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--
-- Application Export:
--   Application:     4419
--   Name:            Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Lists:                  3
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 2
--           Region:               1
--           Label:                1
--           List:                 1
--           Popup LOV:            1
--           Calendar:             3
--           Breadcrumb:           2
--           Button:               1
--           Report:               1
--         Plug-ins:             133
--       Globalization:
--         Messages:          13,405
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Builder, Wizard Messages and Native Plug-Ins')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110305878239364274')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211020110857'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'ko'
,p_flow_language_derived_from=>'SESSION'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(91645213681389498.4419)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'UNAVAILABLE'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_deep_linking=>'Y'
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'N'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112717'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_global
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562090986404402217.4419)
,p_name=>'Spotlight \ Custom Entries - Global'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48650898565635010.4419)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('\C0AC\C778\C544\C6C3')
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_list_text_01=>unistr('Application Express\C5D0\C11C \C0AC\C778\C544\C6C3')
,p_list_text_09=>'Y'
,p_list_text_10=>unistr('\B85C\ADF8\C544\C6C3 \C885\B8CC \B05D\B0B4\AE30 :q')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(281916990329150760.4419)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('\C2A4\D504\B808\B4DC\C2DC\D2B8\C5D0\C11C \C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131')
,p_list_item_link_target=>'f?p=4000:56:&APP_SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001'
,p_list_text_01=>unistr('Excel \B610\B294 CSV \D30C\C77C \C784\D3EC\D2B8 \BC0F \C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131')
,p_list_text_09=>'Y'
,p_list_text_10=>unistr('Excel CSV XSL XSLS \C2A4\D504\B808\B4DC\C2DC\D2B8 \B370\C774\D130 \BD99\C5EC\B123\AE30 \B85C\B4DC \C784\D3EC\D2B8')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(282255839842182292.4419)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Oracle APEX \D648')
,p_list_item_link_target=>'f?p=4500:1000:&APP_SESSION.'
,p_list_text_10=>unistr('\D648 \D398\C774\C9C0 \C2DC\C791 ')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(296033420364984683.4419)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('\AE00\AF34 APEX \C544\C774\CF58 \CC3E\C544\BCF4\AE30')
,p_list_item_link_target=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/fontapex'');'
,p_list_text_01=>unistr('\AE00\AF34 APEX \C544\C774\CF58\C744 \CC3E\C544\BCF4\ACE0, \C218\C815\C790\B97C \CD94\AC00\D558\ACE0, \D544\C694\D55C CSS \B610\B294 HTML\C744 \BCF5\C0AC\D569\B2C8\B2E4.')
,p_list_text_09=>'Y'
,p_list_text_10=>unistr('\C544\C774\CF58 \AE00\AF34 APEX \B77C\C774\BE0C\B7EC\B9AC \ADF8\B798\D53D')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_app_level
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562091518091404815.4419)
,p_name=>'Spotlight \ Custom Entries - App Level'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562091727563404815.4419)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C775\C2A4\D3EC\D2B8')
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::NO:::'
,p_list_text_01=>unistr('{APP_ID} \C560\D50C\B9AC\CF00\C774\C158\C744 SQL \D30C\C77C\B85C \C775\C2A4\D3EC\D2B8')
,p_list_text_09=>'Y'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562093357853428158.4419)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('\C0AC\C6A9\B418\C9C0 \C54A\C740 \BAA9\B85D')
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_page_designer
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562092153904409717.4419)
,p_name=>'Spotlight \ Custom Entries - Page Designer'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14843831009863117.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14859012524941040.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(86380554411225400.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_RICH_TEXT_EDITOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(91997339122572414.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99844881073888905.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(146861159122292557.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176128961688506820.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176129003012506820.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(183033629816949774.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(460407779408652225.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.STARRATING_MODERN'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(497671453666914719.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_STAR_RATING'
,p_attribute_01=>'fa-star'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592236161067709447.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(631035363954639049.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082458703597614427.4419)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082517678315623391.4419)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765072678475712055.4419)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831649180083980462.4419)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831780276458994154.4419)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1832884277947217587.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COLOR_PICKER'
,p_attribute_01=>'modern'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1840861033969283097.4419)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_DISPLAY_SELECTOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917665913120940054.4419)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1990227023531717243.4419)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_CSS_CALENDAR'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/one_level_tabs
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626406749381989.4419)
,p_theme_id=>1
,p_name=>'One Level Tabs.ko'
,p_internal_name=>'ONE_LEVEL_TABS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>',
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>',
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>',
'  </tr>',
'</table>',
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">',
'  <tr>',
'    <td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>',
'  </tr>',
'  <tr>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_left.png" alt="" /></td>',
'    <td class="t1topbarMiddle" valign="bottom"><table cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="50%"><br /></td></tr><tr><td height="50%">#REGION_POSITION_01#</td></tr></table></td>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>',
'  </tr>',
'<tr>',
'<td><br /></td>',
'<td class="t1PageCenter" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BODY##REGION_POSITION_02##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>',
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>',
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_right.png" alt="" /></td>',
'  </tr>',
'</table>',
'<br />',
'#REGION_POSITION_05#',
'#FORM_CLOSE# ',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>'<div class="t1success">#SUCCESS_MESSAGE#</div>'
,p_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>',
'',
''))
,p_non_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>',
''))
,p_notification_message=>'<div class="t1notification">#MESSAGE#</div>'
,p_navigation_bar=>'<div class="t1NavigationBar">#BAR_BODY#</div>'
,p_navbar_entry=>'<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'12'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001488931349566.4419)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4419)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001517815349566.4419)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4419)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001699115349566.4419)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4419)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001740672349566.4419)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4419)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001820430349566.4419)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4419)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001949447349565.4419)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4419)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002088971349565.4419)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4419)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002117005349565.4419)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4419)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002264345349565.4419)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4419)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/printer_friendly
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626529080381989.4419)
,p_theme_id=>1
,p_name=>'Printer Friendly.ko'
,p_internal_name=>'PRINTER_FRIENDLY'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top">',
'<div style="border:1px solid black;">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>',
'#BODY##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE##DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>5
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'3'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002343913349565.4419)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4419)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002490586349565.4419)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4419)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002552177349565.4419)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4419)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(91626823864381990.4419)
,p_template_name=>'Button'
,p_internal_name=>'BUTTON'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="t1Button" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tr>',
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_left.gif" alt="" width="4" height="24" /></a></td>',
'<td class="t1C"><a href="#LINK#">#LABEL!HTML#</a></td>',
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_right.gif" width="4" height="24" alt="" /></a></td>',
'</tr>',
'</table>'))
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/region/reports_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(91632832228382001.4419)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion" id="#REGION_ID#">',
'<tr>',
'<td class="t1RegionHeader">#TITLE#</td>',
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>',
'</tr>',
'<tr>',
'<td class="t1Body" colspan="2">#BODY#</td>',
'</tr>',
'</table>'))
,p_page_plug_template_name=>'Reports Region'
,p_internal_name=>'REPORTS_REGION'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>1
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
,p_template_comment=>'Red Theme'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382691031344638.4419)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4419)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382773788344638.4419)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4419)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382895312344637.4419)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4419)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382923760344637.4419)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4419)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383001370344637.4419)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4419)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383101590344637.4419)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4419)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383260593344637.4419)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4419)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383343091344637.4419)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4419)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383417298344637.4419)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4419)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383590781344637.4419)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4419)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(91636711305382010.4419)
,p_list_template_current=>'<li class="t1current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'Vertical Unordered List with Bullets'
,p_internal_name=>'VERTICAL_UNORDERED_LIST_WITH_BULLETS'
,p_theme_id=>1
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="t1VerticalUnorderedListwithBullets">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(91638400927382012.4419)
,p_row_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#',
'<tr>',
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t1standard">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr #HIGHLIGHT_ROW#>'
,p_row_template_after_last=>'</tr>'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1header">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>'
,p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>1
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_with_help
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(91641225667382016.4419)
,p_template_name=>'Optional with help'
,p_internal_name=>'OPTIONAL_WITH_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999"><a class="t1OptionalwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_before_label=>'<div class="t1InlineError">'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641730492382017.4419)
,p_name=>'Hierarchical Menu'
,p_internal_name=>'HIERARCHICAL_MENU'
,p_before_first=>'<ul class="t1HierarchicalMenu">'
,p_current_page_option=>'<li class="t1current">#NAME#</li>'
,p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>11
,p_start_with_node=>'CHILD_MENU'
,p_theme_id=>1
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641814330382017.4419)
,p_name=>'Breadcrumb Menu'
,p_internal_name=>'BREADCRUMB_MENU'
,p_before_first=>'<div class="t1BreadcrumbMenu">'
,p_current_page_option=>'<span class="t1current">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>'
,p_between_levels=>'&nbsp;&gt;&nbsp;'
,p_after_last=>'</div>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(91642503902382024.4419)
,p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif'
,p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"'
,p_page_name=>'winlov'
,p_page_title=>unistr('\AC80\C0C9 \B300\D654\C0C1\C790')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#APEX_JAVASCRIPT#',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css">',
'',
'#THEME_CSS#',
'</head>'))
,p_page_body_attr=>'onload="first_field()" style="margin:0;"'
,p_before_field_text=>'<div class="t1PopupHead">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_find_button_text=>unistr('\AC80\C0C9')
,p_close_button_text=>unistr('\B2EB\AE30')
,p_next_button_text=>unistr('\B2E4\C74C >')
,p_prev_button_text=>unistr('< \C774\C804')
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'400'
,p_height=>'450'
,p_result_row_x_of_y=>unistr('<br /><div style="padding:2px; font-size:8pt;">#FIRST_ROW# - #LAST_ROW# \D589</div>')
,p_result_rows_per_pg=>500
,p_before_result_set=>'<div class="t1PopupBody">'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/small_calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91641910982382018.4419)
,p_cal_template_name=>'Small Calendar'
,p_internal_name=>'SMALL_CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#DY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallCalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#" class="t1SmallCalendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>'))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallWeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br />#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1SmallWeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallDayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL#" class="t1SmallDayCalendar">'
,p_daily_month_close_format=>'</table></td></tr></table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642102481382020.4419)
,p_cal_template_name=>'Calendar'
,p_internal_name=>'CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t1Calendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendar">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar_alternative_1
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642303533382020.4419)
,p_cal_template_name=>'Calendar, Alternative 1'
,p_internal_name=>'CALENDAR,_ALTERNATIVE_1'
,p_day_of_week_format=>'<th scope="col" valign="bottom" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarAlternative1Holder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t1CalendarAlternative1">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top" height="100" height="100">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarAlternative1Holder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendarAlternative1">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarAlternative1Holder"> <tr><td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td></tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendarAlternative1">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>2
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_options
begin
null;
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104866575381309369)
,p_name=>'2DCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('2D \C138\B85C \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104868651487309371)
,p_name=>'2DCOLUMN_LINE'
,p_message_language=>'ko'
,p_message_text=>unistr('2D \C138\B85C \B9C9\B300 \C120')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104866629767309369)
,p_name=>'2DDOUGHNUT'
,p_message_language=>'ko'
,p_message_text=>unistr('2D \B3C4\B11B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104868451488309370)
,p_name=>'2DHSTACKED_PCT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\C801 \C218\D3C9 2D \C138\B85C \B9C9\B300(\D37C\C13C\D2B8)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104866755585309369)
,p_name=>'2DLINE'
,p_message_language=>'ko'
,p_message_text=>unistr('2D \C120')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104866822318309369)
,p_name=>'2DPIE'
,p_message_language=>'ko'
,p_message_text=>unistr('2D \D30C\C774')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104868270644309370)
,p_name=>'2DSTACKED_PCT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\C801 2D \C138\B85C \B9C9\B300(\D37C\C13C\D2B8)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104866954082309369)
,p_name=>'3DCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('3D \C138\B85C \B9C9\B300')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104868542397309370)
,p_name=>'3DHSTACKED_PCT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\C801 \C218\D3C9 3D \C138\B85C \B9C9\B300(\D37C\C13C\D2B8)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104867025769309369)
,p_name=>'3DPIE'
,p_message_language=>'ko'
,p_message_text=>unistr('3D \D30C\C774')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104868322951309370)
,p_name=>'3DSTACKED_PCT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\C801 3D \C138\B85C \B9C9\B300(\D37C\C13C\D2B8)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105636437856309973)
,p_name=>'4000.912.0.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131 \B515\C154\B108\B9AC\C5D0 \C0BD\C785\D560 0\AC1C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105636288892309973)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8\D560 0\AC1C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105636647327309973)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131 \B515\C154\B108\B9AC\C758 \C5C5\B370\C774\D2B8\B97C \C704\D55C 0\AC1C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105637067703309974)
,p_name=>'4000.912.0.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131 \B515\C154\B108\B9AC\C5D0 \C0BD\C785\D560 0\AC1C \BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105637225575309974)
,p_name=>'4000.912.0.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131 \B515\C154\B108\B9AC\C758 \C5C5\B370\C774\D2B8\B97C \C704\D55C 0\AC1C \BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105636168124309973)
,p_name=>'4000.912.REVIEW.N.ITEMS.FOR.UPDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8\D560 %0\AC1C \D56D\BAA9 \AC80\D1A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105636825651309973)
,p_name=>'4000:912:0.RC.FOR.UPDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8\D560 0\AC1C \BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105636374019309973)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131 \B515\C154\B108\B9AC\C5D0 \C0BD\C785\D560 %0\AC1C \D56D\BAA9 \AC80\D1A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105636579183309973)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131 \B515\C154\B108\B9AC\C758 \C5C5\B370\C774\D2B8\B97C \C704\D55C %0\AC1C \D56D\BAA9 \AC80\D1A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105636945398309973)
,p_name=>'4000:912:REVIEW.N.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131 \B515\C154\B108\B9AC\C5D0 \C0BD\C785\D560 %0\AC1C \BCF4\ACE0\C11C \C5F4 \AC80\D1A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105636796624309973)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8\D560 %0\AC1C \BCF4\ACE0\C11C \C5F4 \AC80\D1A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105637154433309974)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131 \B515\C154\B108\B9AC\C758 \C5C5\B370\C774\D2B8\B97C \C704\D55C %0\AC1C \BCF4\ACE0\C11C \C5F4 \AC80\D1A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105428821738309801)
,p_name=>'4000_424_VALUE_MUST_BE_NUMERIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C740 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105414057988309783)
,p_name=>'4000_639_SEQ_MESG'
,p_message_language=>'ko'
,p_message_text=>unistr('<span class="fielddata"> \C601\C5ED \C21C\C11C\AC00 \ACE0\C720\D558\C9C0 \C54A\C544 \C7AC\C815\B82C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105414196288309783)
,p_name=>'4000_641_SEQ_MESG'
,p_message_language=>'ko'
,p_message_text=>unistr('<span class="fielddata">\B2E8\CD94 \C21C\C11C\AC00 \ACE0\C720\D558\C9C0 \C54A\C544 \C7AC\C815\B82C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105414267330309789)
,p_name=>'4000_646_SEQ_MESG'
,p_message_language=>'ko'
,p_message_text=>unistr('<span class="fielddata">\D0D0\C0C9\D45C\C2DC\C904 \C21C\C11C\AC00 \ACE0\C720\D558\C9C0 \C54A\C544 \C7AC\C815\B82C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105414345061309789)
,p_name=>'4000_749_SEQ_MESG'
,p_message_language=>'ko'
,p_message_text=>unistr('<span class="fielddata">\C601\C5ED \D56D\BAA9 \C21C\C11C\AC00 \ACE0\C720\D558\C9C0 \C54A\C544 \C7AC\C815\B82C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105483245150309846)
,p_name=>'4000_APPLICATION_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104997993468309468)
,p_name=>'4000_EDIT_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D3B8\C9D1: %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105387540641309763)
,p_name=>'4000_INVALID_DATE_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \B0A0\C9DC \D615\C2DD\C774 \BD80\C801\D569\D569\B2C8\B2E4. \B2EC\B825\C5D0\B294 YYYYMMDD \D615\C2DD\C758 \B0A0\C9DC\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105433517430309805)
,p_name=>'4000_TREE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105483396697309846)
,p_name=>'4000_WORKSPACE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED ID')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105277993783309680)
,p_name=>'4050_106_ENTER_SCHEMA_NAME'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C0DD\C131\D560 \C0C8 \C2A4\D0A4\B9C8 \C774\B984\C744 \C785\B825\D558\C2ED\C2DC\C624. '),
unistr('         \C2A4\D0A4\B9C8 \BE44\BC00\BC88\D638\B97C \C120\D0DD\D558\ACE0, \AE30\BCF8 \D14C\C774\BE14\C2A4\D398\C774\C2A4'),
unistr('         \BC0F \C784\C2DC \D14C\C774\BE14\C2A4\D398\C774\C2A4\B97C \C120\D0DD\D558\C2ED\C2DC\C624.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105278053377309680)
,p_name=>'4050_106_EXISTING_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C2A4\D0A4\B9C8 \C774\B984\C744 \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105278155654309680)
,p_name=>'4050_106_WHEN_DONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC\B418\BA74 <strong>\B2E4\C74C</strong>\C744 \B204\B985\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105148203995309583)
,p_name=>'4050_110_DROP_TABLESPACES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C2A4\D398\C774\C2A4 \BC0F \C5F0\AD00\B41C \B370\C774\D130 \D30C\C77C \C0AD\C81C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105148181659309583)
,p_name=>'4050_110_DROP_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C0AC\C6A9\C790 \C0AD\C81C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106012024186310282)
,p_name=>'4050_139_WEB_SERVICE_ACTIVITY_LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \C791\C5C5 \B85C\ADF8 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104860147992309363)
,p_name=>'4050_162_WEB_SOURCE_SYNC_LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B3D9\AE30\D654 \B85C\ADF8 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104860957404309363)
,p_name=>'4050_182_AUTOMATION_LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654 \B85C\ADF8 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105271872178309675)
,p_name=>'4050_19_LOG_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790 \C791\C5C5 \B85C\ADF8 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104910759537309405)
,p_name=>'4050_31_LOG_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 \C561\C138\C2A4 \B85C\ADF8 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105271360217309674)
,p_name=>'4050_3_CHANGE_REQUESTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105271494823309674)
,p_name=>'4050_3_RUNTIME_REQUESTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105271176347309674)
,p_name=>'4050_3_SERVICE_REQUESTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105273625390309677)
,p_name=>'4050_46_AD_HOC'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BA85\B839 \CC98\B9AC\AE30 \B0B4\C5ED \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105273558463309676)
,p_name=>'4050_46_CONTROL_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \D30C\C77C \C2E4\D589 \B85C\ADF8 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105273494930309676)
,p_name=>'4050_46_SCRIPT_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \D30C\C77C \C2E4\D589 \B85C\ADF8 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105273732969309677)
,p_name=>'4050_46_SQL_ARCHIVES'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C544\CE74\C774\BE0C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105275484337309678)
,p_name=>'4050_61_ACTIVE_LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D65C\C131 \B85C\ADF8 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105275555094309678)
,p_name=>'4050_61_CURRENT_LOG_NO'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \B85C\ADF8 \BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105275669662309678)
,p_name=>'4050_61_CUR_LOG_TIME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \B85C\ADF8 \C2DC\AC04\AE30\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105276217479309679)
,p_name=>'4050_61_HOURS_UNTIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B85C\ADF8 \C804\D658 \AC04\ACA9(\C2DC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105275851097309678)
,p_name=>'4050_61_INTERVAL_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \AC04\ACA9(\C0C1\C218)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105276186898309678)
,p_name=>'4050_61_NEXT_LOG_SWITCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C73C\B85C \C77C\C815\C774 \C7A1\D78C \B85C\ADF8 \C804\D658')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105276518756309679)
,p_name=>'4050_70_DEV_ACT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790 \C791\C5C5 \B85C\ADF8 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105276798244309679)
,p_name=>'4050_71_CLICK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D074\B9AD \B85C\ADF8 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105277539948309679)
,p_name=>'4050_75_AD_HOC'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BA85\B839 \CC98\B9AC\AE30 \B0B4\C5ED \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105277411990309679)
,p_name=>'4050_75_CTRL_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \D30C\C77C \C2E4\D589 \B85C\ADF8 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105277273299309679)
,p_name=>'4050_75_SCRIPT_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \D30C\C77C \C2E4\D589 \B85C\ADF8 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105277605006309680)
,p_name=>'4050_75_SQL_ARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C544\CE74\C774\BE0C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105277793474309680)
,p_name=>'4050_82_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \C791\C5C5\C601\C5ED\C5D0 %2\AC1C\C758 \C560\D50C\B9AC\CF00\C774\C158\ACFC %3\BA85\C758 \C0AC\C6A9\C790\AC00 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105277896169309680)
,p_name=>'4050_85_CLICK_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B9AD \C218 \B85C\ADF8 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105458927166309827)
,p_name=>'4050_PACKAGED_APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C0B0\C131 \BC0F \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105459004927309827)
,p_name=>'4050_PACKAGED_WEBSHEETS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0D8\D50C \C6F9 \C2DC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105458287224309826)
,p_name=>'4050_WORKSPACE_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C218')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105205315401309626)
,p_name=>'4350_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105205477578309626)
,p_name=>'4350_EDIT_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D3B8\C9D1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104925255069309415)
,p_name=>'4500 800 HD DBA'
,p_message_language=>'ko'
,p_message_text=>'Oracle Database Express Edition 2 Day DBA'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104925327565309415)
,p_name=>'4500 800 HD DEV'
,p_message_language=>'ko'
,p_message_text=>'Oracle Database Express Edition 2 Day Developer Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104925107139309415)
,p_name=>'4500 800 HD HTMLDB'
,p_message_language=>'ko'
,p_message_text=>'Oracle Application Express 2 Day Plus Developer Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104925499021309415)
,p_name=>'4500 800 HD JAVA'
,p_message_language=>'ko'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus Java Developer Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104925508209309415)
,p_name=>'4500 800 HD NET'
,p_message_language=>'ko'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus .NET Developer Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104925621684309415)
,p_name=>'4500 800 HD PHP'
,p_message_language=>'ko'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus PHP Developer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104925726507309415)
,p_name=>'4500 800 MSG DBA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18\C801\C778 \C77C\C77C \AD00\B9AC \C791\C5C5\C5D0 \B300\D574 \C124\BA85\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104925831497309415)
,p_name=>'4500 800 MSG DEV'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Database Express Edition \AC1C\BC1C \D658\ACBD\C744 \D65C\C6A9\D558\B294 \BC29\BC95\C5D0 \B300\D574 \C124\BA85\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104925967082309415)
,p_name=>'4500 800 MSG HTMLDB'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C911\C2EC\C758 \C6F9 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\B294 \BC29\BC95\C5D0 \B300\D574 \C124\BA85\D558\B294 \C790\C2B5\C11C \ACC4\C5F4\C744 \C81C\ACF5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104926122281309416)
,p_name=>'4500 800 MSG JAVA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BB38\C11C\B294 Java \BC0F JDBC\B97C \C0AC\C6A9\D558\C5EC Oracle Database XE\C5D0 \C811\C18D\D558\B294 \BC29\BC95, \AC04\B2E8\D55C Java \C560\D50C\B9AC\CF00\C774\C158\C744 \AC1C\BC1C\D558\C5EC \B370\C774\D130\C5D0 \C561\C138\C2A4\D558\ACE0 \C218\C815\D558\B294  \BC29\BC95\C744 \BCF4\C5EC\C8FC\B294 \C790\C2B5\C11C\B97C \C81C\ACF5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104926212447309416)
,p_name=>'4500 800 MSG NET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BB38\C11C\B294 Oracle Data Provider for .NET \BC0F Oracle Developer Tools for Visual Studio .NET\C758 \C8FC\C694 \AE30\B2A5\C744 \C124\BA85\D569\B2C8\B2E4. \B2E8\ACC4\BCC4\B85C \C124\CE58 \BC0F \AD6C\C131 \ACFC\C815\C744 \C548\B0B4\D558\ACE0, Oracle Data Provider for .NET \BC0F Oracle Developer Tools for Visual Studio .NET\C744 \C0AC\C6A9\D558\C5EC \AE30\BCF8 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\B294 \BC29\BC95, PL/SQL \BC0F .NET \B0B4\C7A5 \D504\B85C\C2DC\C800\B97C \C791')
||unistr('\C131\D558\ACE0 \C0AC\C6A9\D558\B294 \BC29\BC95\C744 \BCF4\C5EC\C90D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104926040133309416)
,p_name=>'4500 800 MSG PHP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BB38\C11C\B294 Apache \BC0F Zend Core PHP \B4DC\B77C\C774\BC84\B97C \B2E4\C6B4\B85C\B4DC\D558\ACE0 \C124\CE58\D558\B294 \BC29\BC95, \C124\CE58\D55C PHP\B97C \C0AC\C6A9\D558\C5EC Oracle Database XE\C5D0 \C811\C18D\D558\B294 \BC29\BC95, PHP\B85C \AC04\B2E8\D55C \C560\D50C\B9AC\CF00\C774\C158\C744 \AC1C\BC1C\D558\C5EC \B370\C774\D130\C5D0 \C561\C138\C2A4\D558\ACE0 \C218\C815\D558\B294 \BC29\BC95\C744 \BCF4\C5EC\C8FC\B294 \C790\C2B5\C11C\B97C \C81C\ACF5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104896709117309394)
,p_name=>'4500_1002_QB_CLONE_ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104896625447309394)
,p_name=>'4500_1002_QB_CLONE_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104896949907309394)
,p_name=>'4500_1002_QB_CLONE_CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105328550534309719)
,p_name=>'4500_1002_QB_CLONE_DEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104897369414309395)
,p_name=>'4500_1002_QB_CLONE_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104897474112309395)
,p_name=>'4500_1002_QB_CLONE_GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104896864437309394)
,p_name=>'4500_1002_QB_CLONE_OBJECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104897210809309395)
,p_name=>'4500_1002_QB_CLONE_OUTPUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104897079827309394)
,p_name=>'4500_1002_QB_CLONE_SORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104897116960309395)
,p_name=>'4500_1002_QB_CLONE_SORT_ORDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \C21C\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104899986085309397)
,p_name=>'4500_1002_QB_JOIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104893713033309392)
,p_name=>'4500_1002_QB_JOIN_HINT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\C778\D560 \C5F4\C744 \C120\D0DD\D558\B824\BA74 \C5EC\AE30\B97C \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104900316241309397)
,p_name=>'4500_1002_QB_MAX_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 60\AC1C\C758 \C5F4\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104893660320309391)
,p_name=>'4500_1002_QB_REMOVE_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104893568488309391)
,p_name=>'4500_1002_QB_SHOW_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \D45C\C2DC/\C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104900019940309397)
,p_name=>'4500_1002_QB_TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104892544443309390)
,p_name=>'4500_1220_SCRIPT_RESULT'
,p_message_language=>'ko'
,p_message_text=>unistr('%1\C5D0 \C2E4\D589\B41C %0\C758 \ACB0\ACFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105148801485309584)
,p_name=>'4500_46_RET_TO_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\B798 \C9C8\C758\B85C \B3CC\C544\AC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104907721615309402)
,p_name=>'4500_OBJECT_BROWSER_ONLY_N_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\C74C %0\AC1C\C758 \C5F4\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105356185300309740)
,p_name=>'4500_SESS_EVENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105356078461309740)
,p_name=>'4500_SESS_KILOBYTES'
,p_message_language=>'ko'
,p_message_text=>'KB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105355979664309740)
,p_name=>'4500_SESS_MEGABYTES'
,p_message_language=>'ko'
,p_message_text=>'MB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104928515111309417)
,p_name=>'4500_UI_DEF_HINT_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30\C5D0\C11C \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \AE30\BCF8\AC12\C744 \C0AC\C6A9\D558\C5EC \B2E8\C77C \C560\D50C\B9AC\CF00\C774\C158\C774\B098 \B2E4\C911 \C560\D50C\B9AC\CF00\C774\C158\C758 \B2E4\C911 \D398\C774\C9C0 \AC04\C5D0 \C77C\AD00\C131\C744 \C81C\ACF5\D558\B294 \C601\C5ED \BC0F \D56D\BAA9 \C18D\C131\C5D0 \B300\D55C \CD08\AE30\AC12\C744 \CC44\C6C1\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104958693528309439)
,p_name=>'4550_COOKIES_ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0AC\C6A9\D558\B824\BA74 \CFE0\D0A4\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B418\C5B4 \C788\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104958513112309439)
,p_name=>'4550_JAVASCRIPT_ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0AC\C6A9\D558\B824\BA74 JavaScript\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B418\C5B4 \C788\C5B4\C57C \D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105385859054309762)
,p_name=>'ABOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106079365561310346)
,p_name=>'ABOUT_TO_CREATE_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C %0\BA85\C758 \C0AC\C6A9\C790\B97C \C791\C5C5\C601\C5ED\C5D0 \CD94\AC00\D560\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105397395060309770)
,p_name=>'ACCEPTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2B9\C778\B428')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105365498234309747)
,p_name=>'ACCESSIBILITY_ASSIGNEE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C811\ADFC\C131 \D53C\C9C0\C815\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105363501694309745)
,p_name=>'ACCESSIBILITY_IMPACT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C811\ADFC\C131 \C601\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105365824822309747)
,p_name=>'ACCESSIBILITY_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C811\ADFC\C131 \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106130253826310393)
,p_name=>'ACCESSIBILITY_TESTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C811\ADFC\C131 \D14C\C2A4\D2B8\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105039086237309498)
,p_name=>'ACCESS_CONTROL_ADMIN_AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC \AD8C\D55C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104905358978309401)
,p_name=>'ACCESS_CONTROL_ADMIN_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \AD00\B9AC \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105317770738309711)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105422660407309796)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE_DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\C5D0\AC8C \C9C0\C815\B41C \B864\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104905593172309401)
,p_name=>'ACCESS_CONTROL_APP_ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104906191537309401)
,p_name=>'ACCESS_CONTROL_APP_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BAA8\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104906027387309401)
,p_name=>'ACCESS_CONTROL_APP_MODE_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \C561\C138\C2A4 \C81C\C5B4 \BC29\C2DD\C744 \C9C0\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104907191809309402)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BAA8\B4DC \C124\C815 \C694\CCAD\C744 \CC98\B9AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104907235885309402)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BAA8\B4DC \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105039406809309498)
,p_name=>'ACCESS_CONTROL_CANNOT_DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\C778\C740 \C2A4\C2A4\B85C \C0AD\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105039568311309498)
,p_name=>'ACCESS_CONTROL_CANNOT_REMOVE_ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\C2A4\B85C \AD00\B9AC\C790 \AD8C\D55C\C744 \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104905465103309401)
,p_name=>'ACCESS_CONTROL_CONFIRM_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105317646722309711)
,p_name=>'ACCESS_CONTROL_CONTRIB_AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5 \AD8C\D55C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105317833269309711)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105422766469309796)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE_DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C81C\ACF5\C790\C5D0\AC8C \C9C0\C815\B41C \B864\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105358383663309741)
,p_name=>'ACCESS_CONTROL_CREATE_APP_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C560\D50C\B9AC\CF00\C774\C158 \C124\C815\C774 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105317997364309711)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_ROLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C560\D50C\B9AC\CF00\C774\C158 \C561\C138\C2A4 \B864\C774 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104922797718309413)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104978548085309454)
,p_name=>'ACCESS_CONTROL_CREATE_PAGE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104978467016309454)
,p_name=>'ACCESS_CONTROL_CREATE_TABLE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \D14C\C774\BE14\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105040882392309499)
,p_name=>'ACCESS_CONTROL_DUP_USERNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\BCF5\B41C \C0AC\C6A9\C790 \C774\B984\C744 \C785\B825\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105039136670309498)
,p_name=>'ACCESS_CONTROL_EDIT_AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 - \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104906868798309402)
,p_name=>'ACCESS_CONTROL_FIND_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \C870\AC74(\B300\C18C\BB38\C790 \AD6C\BD84 \C548\D568)\C744 \C785\B825\D55C \B2E4\C74C <strong>\C2E4\D589</strong> \B2E8\CD94\B97C \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104906954057309402)
,p_name=>'ACCESS_CONTROL_GET_APP_MODE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC \BAA8\B4DC\B97C \AC00\C838\C62C \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104906707626309402)
,p_name=>'ACCESS_CONTROL_LAST_CHANGED_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9\C73C\B85C \BCC0\ACBD\D55C \C0AC\B78C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104906407766309402)
,p_name=>'ACCESS_CONTROL_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104905607738309401)
,p_name=>'ACCESS_CONTROL_MODE1'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450\C5D0\AC8C \C804\CCB4 \C561\C138\C2A4. \C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C774 \C0AC\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104905708291309401)
,p_name=>'ACCESS_CONTROL_MODE2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\D55C\B41C \C561\C138\C2A4. \C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0\C11C \C815\C758\B41C \C0AC\C6A9\C790\B9CC \D5C8\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104905815247309401)
,p_name=>'ACCESS_CONTROL_MODE3'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9 \C77D\AE30 \C804\C6A9. \C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0 \C758\D574 \D3B8\C9D1 \BC0F \AD00\B9AC \AD8C\D55C\C774 \C81C\C5B4\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104905931524309401)
,p_name=>'ACCESS_CONTROL_MODE4'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC \C561\C138\C2A4 \C804\C6A9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104907003776309402)
,p_name=>'ACCESS_CONTROL_NO_PRIV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\B3C4\D55C \C791\C5C5\C5D0 \B300\D55C \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104906611156309402)
,p_name=>'ACCESS_CONTROL_PRIV'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105358259018309741)
,p_name=>'ACCESS_CONTROL_READER_AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\D68C\C790 \AD8C\D55C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105358111262309741)
,p_name=>'ACCESS_CONTROL_READER_ROLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\D68C\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105422855119309796)
,p_name=>'ACCESS_CONTROL_READER_ROLE_DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C870\D68C\C790\C5D0\AC8C \C9C0\C815\B41C \B864\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104923537854309414)
,p_name=>'ACCESS_CONTROL_RPT_REGION_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \C778\C99D \CCB4\ACC4\C5D0 \D574\B2F9\D558\B294 \C0AC\C6A9\C790 \C774\B984\C744 \C9C0\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104906238809309401)
,p_name=>'ACCESS_CONTROL_SET_APP_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BAA8\B4DC \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105004613277309473)
,p_name=>'ACCESS_CONTROL_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \D398\C774\C9C0\AC00 \C131\ACF5\C801\C73C\B85C \C791\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105318047031309711)
,p_name=>'ACCESS_CONTROL_USE_AUTH_ROLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C561\C138\C2A4 \C81C\C5B4 \B864 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104923460177309414)
,p_name=>'ACCESS_CONTROL_USE_AUTH_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \AD8C\D55C \BD80\C5EC \CCB4\ACC4 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104922655511309413)
,p_name=>'ACCESS_CONTROL_USE_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \D14C\C774\BE14 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105039247677309498)
,p_name=>'ACCESS_CONTROL_VIEW_AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 - \BCF4\AE30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104926442268309416)
,p_name=>'ACCOUNT_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C815\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105612119045309951)
,p_name=>'ACCOUNT_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C815 \BA54\B274')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105346037895309732)
,p_name=>'ACKNOWLEDGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105346227040309733)
,p_name=>'ACKNOWLEDGED_NO_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C2DD\B428, \C791\C5C5 \C5C6\C74C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105406767188309777)
,p_name=>'ACL_ADD_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106015383630310285)
,p_name=>'ACL_TABLE.ACCESS_DASHBOARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C2DC\BCF4\B4DC \C561\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106015436409310285)
,p_name=>'ACL_TABLE.ACCESS_MONITOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B2C8\D130 \C791\C5C5 \C561\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106014945194310285)
,p_name=>'ACL_TABLE.ADD_MODIFY'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00/\C218\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106015252182310285)
,p_name=>'ACL_TABLE.ADMIN_WHEN_RUNNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C2E4\D589 \C2DC \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106014153852310284)
,p_name=>'ACL_TABLE.ADMIN_WITHIN_BUILDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30 \B0B4\C5D0\C11C \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106014850271310284)
,p_name=>'ACL_TABLE.ANNOTATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\C11D(\D30C\C77C, \D0DC\ADF8, \BA54\BAA8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106013801085310283)
,p_name=>'ACL_TABLE.APEX_AUTH_WO_ACL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C744 \C0AC\C6A9\D558\C9C0 \C54A\B294 Application Express \ACC4\C815 \C778\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106013740222310283)
,p_name=>'ACL_TABLE.AUTH_WITH_ACL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C744 \C0AC\C6A9\D55C \C778\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106014510056310284)
,p_name=>'ACL_TABLE.EDIT_SQL_ACCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C561\C138\C2A4 \BC0F \AD8C\C7A5 \AC1D\CCB4 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106018550547310288)
,p_name=>'ACL_TABLE.INTRO_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0 \C778\C99D\B41C \B2E4\C74C\C5D0\B294 \C561\C138\C2A4 \C81C\C5B4\C5D0 \B530\B77C \C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0\C11C \C218\D589\D560 \C218 \C788\B294 \C791\C5C5\C774 \C9C0\C815\B429\B2C8\B2E4. \C544\B798 \D45C\C5D0\C11C\B294 \C774 \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0\C11C \C0AC\C6A9\B418\B294 \C778\C99D\C744 \AE30\BC18\C73C\B85C \C11C\B85C \B2E4\B978 \C0AC\C6A9\C790 \C720\D615\C5D0 \B530\B77C \C9C0\C815\B420 \AE30\B2A5\C744 \C2DD\BCC4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106015583474310285)
,p_name=>'ACL_TABLE.MAINTAIN_ACL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D \C720\C9C0 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106014675771310284)
,p_name=>'ACL_TABLE.RUN_AND_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \BC0F \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106014330786310284)
,p_name=>'ACL_TABLE.UPDATE_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C18D\C131 \C5C5\B370\C774\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105631668825309969)
,p_name=>'ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106013235011310283)
,p_name=>'ACTION_MENU_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BA54\B274 \C124\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104934932218309422)
,p_name=>'ACTIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D65C\C131:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105325046315309716)
,p_name=>'ACTIVITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105366739525309748)
,p_name=>'ACTIVITY_SUMMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C694\C57D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105567324837309916)
,p_name=>'ADDED_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106009611442310279)
,p_name=>'ADDED_TO_PURGE_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6B0\AE30 \BAA9\B85D\C5D0 \CD94\AC00\B428')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105624559967309962)
,p_name=>'ADDITIONAL_INFORMATION_REQUESTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \C815\BCF4\AC00 \C694\CCAD\B428')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105284859241309685)
,p_name=>'ADD_ARGUEMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C218 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105275211130309678)
,p_name=>'ADD_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105472549835309838)
,p_name=>'ADD_COLUMN_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C5F4 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105114408278309552)
,p_name=>'ADD_CONSTRAINT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C57D \C870\AC74 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105273318465309676)
,p_name=>'ADD_MORE...'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105339182221309727)
,p_name=>'ADD_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105477673292309842)
,p_name=>'ADD_USER_INTERFACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \CD94\AC00')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105481141605309845)
,p_name=>'ADJUST_PROVISIONED_SPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0MB\C529 \B4F1\B85D\B41C \ACF5\AC04 \C870\C815')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105272067802309675)
,p_name=>'ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104860846078309363)
,p_name=>'ADMIN.WORKSPACE_BANNER_COLOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\B108 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104860616906309363)
,p_name=>'ADMIN.WORKSPACE_BANNER_ENABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD \BC30\B108 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104860724264309363)
,p_name=>'ADMIN.WORKSPACE_BANNER_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\B108 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105280035166309681)
,p_name=>'ADMIN.WORKSPACE_BANNER_POS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\B108 \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104918883547309410)
,p_name=>'ADMINISTRATOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \AD00\B9AC\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105366594725309747)
,p_name=>'ADMINISTRATORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105278783979309680)
,p_name=>'ADMIN_EMAIL_MUST_BE_PROV'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790 \C804\C790\BA54\C77C\C744 \C81C\ACF5\D574\C57C \D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105431087003309803)
,p_name=>'ADVISOR.CATEGORY.ACCESSIBILITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C811\ADFC\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104941316930309427)
,p_name=>'ADVISOR.CATEGORY.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104941637682309427)
,p_name=>'ADVISOR.CATEGORY.PERFORMANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104941783974309427)
,p_name=>'ADVISOR.CATEGORY.QA'
,p_message_language=>'ko'
,p_message_text=>unistr('\D488\C9C8 \BCF4\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104941410413309427)
,p_name=>'ADVISOR.CATEGORY.SECURITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104941896807309427)
,p_name=>'ADVISOR.CATEGORY.USABILITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \AC00\B2A5 \C5EC\BD80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104941580021309427)
,p_name=>'ADVISOR.CATEGORY.WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105536082222309891)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.DA'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \D56D\BAA9\C774 \BCF4\D638\B418\C5B4 \C788\C5B4\C11C Ajax \D638\CD9C\C744 \D1B5\D574 \C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105536157311309891)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \D56D\BAA9\C774 \BCF4\D638\B418\C5B4 \C788\C5B4\C11C Ajax \D638\CD9C\C744 \D1B5\D574 \C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105565454703309914)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \D56D\BAA9\C774 \BCF4\D638\B418\C5B4 \C788\C5B4\C11C Ajax \D638\CD9C\C744 \D1B5\D574 \C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104967758824309446)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_MISSING_SYS_PREFIX'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\B77D\B41C SYS \C2A4\D0A4\B9C8 \C811\B450\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105671725015310005)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_WWV_FLOW'
,p_message_language=>'ko'
,p_message_text=>unistr('WWV_FLOW API \C0AC\C6A9\BC95(\B300\C2E0 APEX API \C0AC\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105622043771309960)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IG_COLUMN_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18C\C2A4 SQL \BB38\C5D0 %0 \C5F4\C774 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104951443444309434)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IR_FILTER_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C \C5F4 %0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104949189553309432)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104929469578309418)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_REGION_COLUMN_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18C\C2A4 SQL \BB38\C5D0 %0 \C5F4\C774 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105701826106310034)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_TABFORM_COLUMN_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C \D615\C2DD \D3EC\B7FC \C5F4 %0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104949214687309432)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_WRONG_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \C560\D50C\B9AC\CF00\C774\C158 \B610\B294 \D398\C774\C9C0 \D56D\BAA9 \C774\B984\C73C\B85C \CC38\C870\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106084428036310351)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_APP_PROC_AUTHORIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('Ajax \CF5C\BC31 \C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4\B294 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\C5D0 \C758\D574 \BCF4\D638\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106084070898310350)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_PAGE_AUTHORIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\AC00 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\C5D0 \C758\D574 \BCF4\D638\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104950145158309433)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_TARGET_AUTH_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1 \D398\C774\C9C0 %1(\C560\D50C\B9AC\CF00\C774\C158 %0 \B0B4\BD80)\C5D0 \C815\C758\B41C \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106085713548310352)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_PARENT_PAGE_AUTH_DIFFERENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C758 \AD8C\D55C \BD80\C5EC\AC00 \C0C1\C704 \D398\C774\C9C0 %0\C758 \AD8C\D55C \BD80\C5EC "%1"\ACFC(\C640) \B2E4\B985\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104950205434309433)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_TARGET_AUTH_DIFFERENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1 \D398\C774\C9C0\C758 \AD8C\D55C \BD80\C5EC "%0"\C774(\AC00) "%1"\ACFC(\C640) \B2E4\B985\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104948749719309432)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104948686016309432)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_UNKNOWN_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\C778\B4DC \BCC0\C218 \AD6C\BB38 \AC80\C0AC\B97C \C218\D589\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C624\B958: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104948881653309432)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \BC14\C778\B4DC \BCC0\C218 \AD6C\BB38\C73C\B85C \CC38\C870\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104950824213309434)
,p_name=>'ADVISOR.CHECK.BRANCH_SEQUENCE.MSG_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \BD84\AE30 \C774\C804\C758 \BB34\C870\AC74 \BD84\AE30\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106083886692310350)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_AUTOCOMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9 \C644\C131\C740 \BE44\BC00\BC88\D638 \D56D\BAA9\C744 \D3EC\D568\D558\B294 \D398\C774\C9C0\C5D0 \B300\D574 "\C124\C815"\C73C\B85C \C124\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106083969153310350)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_CACHE'
,p_message_language=>'ko'
,p_message_text=>unistr('"\CE90\C2DC"\B97C \C0AC\C6A9\D558\BA74 \BE0C\B77C\C6B0\C800\AC00 \BBFC\AC10\D55C \B370\C774\D130\B97C \CE90\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105883589465310171)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_FRAME'
,p_message_language=>'ko'
,p_message_text=>unistr('"\D504\B808\C784\C5D0 \D3EC\D568"\C744 \C0AC\C6A9\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C774 \D074\B9AD \AC00\B85C\CC44\AE30(clickjacking) \ACF5\ACA9\C5D0 \CDE8\C57D\D574\C9D1\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105883611056310171)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_HTML_ESCAPING_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('"HTML \C774\C2A4\CF00\C774\D504 \BAA8\B4DC"\C5D0\C11C\B294 \C81C\D55C\B41C \BB38\C790\C138\D2B8\B9CC \C774\C2A4\CF00\C774\D504 \CC98\B9AC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104872131349309374)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_ITEM_OUTPUT_ESCAPING'
,p_message_language=>'ko'
,p_message_text=>unistr('XSS(\C0AC\C774\D2B8\AC04 \C2A4\D06C\B9BD\D305) \ACF5\ACA9\C744 \BC29\C9C0\D558\B824\BA74 \D56D\BAA9\C774 \D2B9\C218 \BB38\C790\B97C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105890695925310177)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_REFERRER_POLICY'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('HTTP "\B808\D37C\B7EC" \C694\CCAD \D5E4\B354\B294 \BBFC\AC10\D55C \C138\C158 \C815\BCF4\B97C \C81C3\C790\C5D0\AC8C \C720\CD9C\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C560\D50C\B9AC\CF00\C774\C158\C740 "\B808\D37C\B7EC \C815\CC45"\C744 "strict-origin"\C73C\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104888269443309387)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_ID_FOUND_IN_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B3D9\C801 \C791\C5C5(%0)\C5D0 \CC38\C870\B41C \B2E8\CD94\C5D0 \B300\D55C \B2E8\CD94 \C18D\C131\C5D0\C11C ID\AC00 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4. '),
'',
unistr('\B2E8\CD94 \C18D\C131\C5D0 ID\AC00 \C815\C758\B41C \ACBD\C6B0, \C774 \B2E8\CD94\B97C \CC38\C870\D558\B294 \B3D9\C801 \C791\C5C5\C774 \C791\B3D9\D558\C9C0 \C54A\AC8C \B429\B2C8\B2E4. \B2E8\CD94\B294 \AE30\BCF8\C801\C73C\B85C ID\B97C \C0DD\C131\D558\BBC0\B85C \C774 ID\B97C \C81C\AC70\D558\C2ED\C2DC\C624.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104888344223309387)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_TEMPLATE_BUTTON_NO_BUTTON_ID'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2E8\CD94\C5D0 \C0AC\C6A9\B418\BA70 \B3D9\C791 \C791\C5C5(%0)\C5D0 \CC38\C870\B418\B294 \B2E8\CD94 \D15C\D50C\B9AC\D2B8\C5D0 #BUTTON_ID# \B300\CCB4 \BB38\C790\C5F4\C774 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.'),
'',
unistr('\D15C\D50C\B9AC\D2B8:'),
'%1',
'',
unistr('#BUTTON_ID# \B300\CCB4 \BB38\C790\C5F4\C744 \C774 \D15C\D50C\B9AC\D2B8\C5D0 \CD94\AC00\D558\AC70\B098, \B2E8\CD94 \D15C\D50C\B9AC\D2B8\B97C #BUTTON_ID# \B300\CCB4 \BB38\C790\C5F4\C744 \D3EC\D568\D558\B294 \D15C\D50C\B9AC\D2B8\B85C \BCC0\ACBD\D558\C2ED\C2DC\C624.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104891682075309390)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_ACTION_NOT_DEFINED_BY_DA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5(%0)\C5D0 \CC38\C870\B41C \B2E8\CD94\C5D0 \B300\D55C \B2E8\CD94 ''\C791\C5C5''\C774 ''\B3D9\C801 \C791\C5C5\C5D0 \C758\D574 \C815\C758\B428''\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104897704166309395)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_NO_BUTTON_DEFINED_FOR_DA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94(%0) ''\C791\C5C5''\C774 ''\B3D9\C801 \C791\C5C5\C5D0 \C758\D574 \C815\C758\B428''\C73C\B85C \C124\C815\B418\C5C8\C9C0\B9CC \C774 \B2E8\CD94\B97C \CC38\C870\D558\B294 \D574\B2F9''\B3D9\C801 \C791\C5C5\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104949848947309433)
,p_name=>'ADVISOR.CHECK.CLEAR_CACHE_PAGE_NUMBER.MSG_OTHER_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE90\C2DC \BE44\C6B0\AE30 \D398\C774\C9C0 %0\C774(\AC00) \D604\C7AC \B610\B294 \B300\C0C1 \D398\C774\C9C0 %1\C774(\AC00) \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104948502262309432)
,p_name=>'ADVISOR.CHECK.COLUMN_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106057607122310326)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_ATTRIBUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C18D\C131\AC12\C740 \B354 \C774\C0C1 \C0AC\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106060189951310328)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_COMPONENT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C \C720\D615\C740 \B354 \C774\C0C1 \C0AC\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105536281736309891)
,p_name=>'ADVISOR.CHECK.DESC_AJAX_ITEMS_WITH_SSP'
,p_message_language=>'ko'
,p_message_text=>unistr('Ajax \D638\CD9C\C5D0\C11C \BCF4\D638\B41C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104967652242309446)
,p_name=>'ADVISOR.CHECK.DESC_APEX_CODE_SMELL'
,p_message_language=>'ko'
,p_message_text=>unistr('Code Smell(APEX \B0B4\BD80)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104946605732309431)
,p_name=>'ADVISOR.CHECK.DESC_APPL_PAGE_ITEM_REF'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9, \D398\C774\C9C0 \D56D\BAA9, \C5F4 \B610\B294 \B300\D654\C2DD \BCF4\ACE0\C11C \D544\D130\C758 \C120\C5B8\C801 \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106083777130310350)
,p_name=>'ADVISOR.CHECK.DESC_AUTHORIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104946329289309430)
,p_name=>'ADVISOR.CHECK.DESC_BIND_VARIABLE_SYNTAX'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\C778\B4DC \BCC0\C218 \AD6C\BB38\C73C\B85C \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104947737946309431)
,p_name=>'ADVISOR.CHECK.DESC_BRANCH_SEQUENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \BD84\AE30 \C774\C804\C758 \BB34\C870\AC74 \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106084255184310350)
,p_name=>'ADVISOR.CHECK.DESC_BROWSER_SECURITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE0C\B77C\C6B0\C800 \BCF4\C548 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104888117426309387)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_COMPATIBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C791 \C791\C5C5\ACFC \D638\D658\B418\C9C0 \C54A\B294 \B2E8\CD94\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104897548510309395)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_INCONSISTENT_REFS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C791 \C791\C5C5\ACFC \B2E8\CD94 \AC04\C758 \CC38\C870\AC00 \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104946932903309431)
,p_name=>'ADVISOR.CHECK.DESC_CLEAR_CACHE_PAGE_NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE90\C2DC \BE44\C6B0\AE30 \D398\C774\C9C0 \BC88\D638\AC00 \B300\C0C1 \B610\B294 \D604\C7AC \D398\C774\C9C0\C640 \B3D9\C77C\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104946254446309430)
,p_name=>'ADVISOR.CHECK.DESC_COLUMN_SYNTAX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AD6C\BB38\C73C\B85C \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106057510129310325)
,p_name=>'ADVISOR.CHECK.DESC_DEPRECATED_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\B418\C9C0 \C54A\B294 \C18D\C131\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104947231800309431)
,p_name=>'ADVISOR.CHECK.DESC_DML_PROCESSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\CD9C, DML, MR* \D504\B85C\C138\C2A4\AC00 \C801\D569\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104947630591309431)
,p_name=>'ADVISOR.CHECK.DESC_HARDCODED_APPLICATION_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B4DC \CF54\B529\B41C \C560\D50C\B9AC\CF00\C774\C158 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105343374803309730)
,p_name=>'ADVISOR.CHECK.DESC_HAS_HELP_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9\C5D0 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\AC00 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105430844039309802)
,p_name=>'ADVISOR.CHECK.DESC_HAS_PAGE_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C5D0 \D398\C774\C9C0 \C81C\BAA9 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105455029253309824)
,p_name=>'ADVISOR.CHECK.DESC_IMAGE_ITEM_HAS_ALT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \D45C\C2DC \D56D\BAA9\C5D0 \C774\BBF8\C9C0 ALT \D14D\C2A4\D2B8\AC00 \C815\C758\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105883378064310171)
,p_name=>'ADVISOR.CHECK.DESC_INSECURE_APPLICATION_DEFAULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE00 \C218 \C788\B294 \C560\D50C\B9AC\CF00\C774\C158 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104946408600309430)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870\B41C \D56D\BAA9\C774 \D604\C7AC \D398\C774\C9C0\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104946588131309430)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_TARGET_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870\B41C \D56D\BAA9\C774 \B300\C0C1 \D398\C774\C9C0\C758 \D398\C774\C9C0 \D56D\BAA9\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105431572420309803)
,p_name=>'ADVISOR.CHECK.DESC_ITEMS_NO_CONTEXT_CHANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9\C73C\B85C \C778\D574 \C608\C0C1\CE58 \C54A\C740 \CEE8\D14D\C2A4\D2B8 \BCC0\ACBD\C0AC\D56D\C774 \BC1C\C0DD\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105432249221309804)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_HAS_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9\C5D0 \B808\C774\BE14 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104947963823309432)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_NAME_LENGTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \B610\B294 \D45C \D615\C2DD \D3FC \C5F4 \C774\B984\C758 \AE38\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104946796816309431)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_ITEM_REF_AS_STRING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C790\C5F4\C758 \D398\C774\C9C0 \D56D\BAA9 \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104946886690309431)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_NUMBER_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870\B41C \D398\C774\C9C0 \BC88\D638\AC00 \C874\C7AC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105431183855309803)
,p_name=>'ADVISOR.CHECK.DESC_REGION_HAS_ROW_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED\C5D0 \D589 \BA38\B9AC\AE00 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104948117856309432)
,p_name=>'ADVISOR.CHECK.DESC_REPORT_DEFAULT_ORDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C5D0 \AE30\BCF8 \C21C\C11C\AC00 \C801\C6A9\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106084366673310350)
,p_name=>'ADVISOR.CHECK.DESC_SESSION_STATE_PROTECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC \BCF4\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104947357821309431)
,p_name=>'ADVISOR.CHECK.DESC_SQL_INJECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4 \AD6C\BB38\C758 \BD80\C801\D569\D55C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104946192299309430)
,p_name=>'ADVISOR.CHECK.DESC_SUBSTITUTION_SYNTAX'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4 \AD6C\BB38\C73C\B85C \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104947152835309431)
,p_name=>'ADVISOR.CHECK.DESC_TARGET_PAGE_AUTH_USABILITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1 \D398\C774\C9C0 \AD8C\D55C \BD80\C5EC\AC00 \D604\C7AC \AD6C\C131\C694\C18C\C5D0 \B300\D574\C11C\B3C4 \C124\C815\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105431370170309803)
,p_name=>'ADVISOR.CHECK.DESC_THEME_STYLE_IS_ACCESSIBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C\C758 \C811\ADFC\C131 \D14C\C2A4\D2B8\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105526193235309883)
,p_name=>'ADVISOR.CHECK.DESC_UI_INCLUDES_COMPATIBILITY_JS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\C5D0 \D638\D658\C131 JavaScript\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104947851579309431)
,p_name=>'ADVISOR.CHECK.DESC_VALIDATION_ASSOCIATED_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C758 \C5F0\AD00\B41C \D56D\BAA9 \B610\B294 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104947092998309431)
,p_name=>'ADVISOR.CHECK.DESC_VALID_SQL_PLSQL_CODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C SQL \B610\B294 PL/SQL \CF54\B4DC\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104947541048309431)
,p_name=>'ADVISOR.CHECK.DESC_VERIFY_CLOB_PROPERTY'
,p_message_language=>'ko'
,p_message_text=>unistr('CLOB \C18D\C131 \D655\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104947408264309431)
,p_name=>'ADVISOR.CHECK.DESC_V_FUNCTION_IN_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BB38\C5D0 \C0AC\C6A9\B41C V \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104948087678309432)
,p_name=>'ADVISOR.CHECK.DESC_WHEN_BUTTON_PRESSED'
,p_message_language=>'ko'
,p_message_text=>unistr('[\B2E8\CD94\B97C \B204\B97C \B54C]\C5D0 \CC38\C870\B41C \B2E8\CD94\AC00 \C874\C7AC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104950479167309433)
,p_name=>'ADVISOR.CHECK.DML_PROCESSES.MSG_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEF4\D30C\C77C \C624\B958 - %0 \BB38: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104950712453309434)
,p_name=>'ADVISOR.CHECK.HARDCODED_APPLICATION_ID.MSG_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C\C5D0 \D604\C7AC \C560\D50C\B9AC\CF00\C774\C158 ID\AC00 \D558\B4DC \CF54\B529\B41C \AC12\C73C\B85C \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105343205346309730)
,p_name=>'ADVISOR.CHECK.HAS_HELP_TEXT.MSG_NOT_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105430947335309803)
,p_name=>'ADVISOR.CHECK.HAS_PAGE_TITLE.MSG_NOT_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0\B294 \D398\C774\C9C0 \C81C\BAA9\C774 \C5C6\C2B5\B2C8\B2E4. \C758\BBF8 \C788\B294 \D398\C774\C9C0 \C81C\BAA9\C740 \C811\ADFC\C131\C5D0 \C911\C694\D558\BA70, \C0AC\C6A9\C790\B294 \D398\C774\C9C0 \C81C\BAA9\C744 \D1B5\D574 \D604\C7AC \D398\C774\C9C0\C758 \CF58\D150\CE20\C640 \C6A9\B3C4\B97C \C27D\AC8C \D30C\C545\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105455134652309824)
,p_name=>'ADVISOR.CHECK.IMAGE_ITEM_HAS_ALT.MSG_NOT_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0\C5D0 \D544\C694\D55C \B300\CCB4 \D14D\C2A4\D2B8\AC00 \D56D\BAA9\C5D0\C11C \B204\B77D\B418\C5C8\C2B5\B2C8\B2E4. \B300\CCB4 \D14D\C2A4\D2B8\C6A9\C73C\B85C \C801\D569\D55C \D14D\C2A4\D2B8\B294 \C774\BBF8\C9C0\C758 \CF58\D150\CE20\B97C \C81C\B300\B85C \C124\BA85\D574\C57C \D558\BA70, \C911\BCF5\C774 \BC1C\C0DD\D558\C9C0 \C54A\B3C4\B85D \C774\BBF8\C9C0 \CEE8\D14D\C2A4\D2B8\C5D0\C11C \D45C\C2DC\B418\B294 \D398\C774\C9C0\C5D0 \BCF4\C774\B294 \C815\BCF4\B97C \BCF5\C81C\D558\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4. \CC38\ACE0: \C0AC\C6A9\C790\AC00 \C774\BBF8\C9C0\B97C \C81C\ACF5\D558\B294 \ACBD\C6B0 \ACE0\D488\C9C8 \D14D\C2A4\D2B8\B97C \C81C\ACF5\D560 \C218 \C788\B3C4\B85D \C801\D569\D55C \C9C0\CE68\ACFC \D568\AED8 \C774\BBF8\C9C0 \B300\CCB4 \D14D\C2A4\D2B8\B3C4 \C81C\ACF5\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105883408229310171)
,p_name=>'ADVISOR.CHECK.INSECURE_APPLICATION_DEFAULTS.MSG_RUNTIME_API_USAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('"\B7F0\D0C0\C784 API \C0AC\C6A9"\C740 \C560\D50C\B9AC\CF00\C774\C158 \BC0F \C791\C5C5\C601\C5ED \C218\C815\C744 \D5C8\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104948977490309432)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_PAGE.MSG_NOT_ITEM_OF_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) %1 \D398\C774\C9C0\C5D0 \C788\B294 \D56D\BAA9\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104949097513309432)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_TARGET_PAGE.MSG_NOT_ITEM_OF_TARGET_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \B300\C0C1 \D398\C774\C9C0 %1\C5D0 \C788\B294 \D56D\BAA9\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105431684249309803)
,p_name=>'ADVISOR.CHECK.ITEMS_NO_CONTEXT_CHANGE.MSG_CAUSES_CHANGE_OF_CONTEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9\C5D0 \B300\D55C ''\C120\D0DD \C2DC \D398\C774\C9C0 \C791\C5C5'' \C124\C815\C73C\B85C \C778\D574 \C0AC\C6A9\C790\C5D0 \B300\D574 \C608\C0C1\CE58 \C54A\C740 \CEE8\D14D\C2A4\D2B8 \BCC0\ACBD\C0AC\D56D\C774 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4. \CEE8\D14D\C2A4\D2B8 \BCC0\ACBD\C0AC\D56D\C774 \BC1C\C0DD\D558\C9C0 \C54A\B3C4\B85D \AC12\C744 ''\C5C6\C74C''\C73C\B85C \C804\D658\D558\ACE0 \AE30\B2A5\C744 \B3D9\C801 \C791\C5C5 \B610\B294 \C885\C18D LOV\B85C \BC14\AFB8\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4(\B3D9\C77C\D55C \D398\C774\C9C0\C5D0 \B0A8\C544 \C788\C5B4\C57C \D558\B294 \ACBD\C6B0). \B610\B294 \C0AC\C6A9\C790\AC00 \BC1C\C0DD\D560 \B3D9\C791\C744 \C778\C2DD\D560 \C218 \C788\B3C4\B85D \C0AC\C6A9\C790\C5D0\AC8C \C815\BCF4\B97C \C81C\ACF5\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4(\C608: \B808\C774\BE14\C5D0 ''\C0C8 \D398\C774\C9C0 \C2E4\D589'' \CD94\AC00). ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105454993616309824)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_NO_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C744 \C815\C758\D574\C57C \D560 \B808\C774\BE14\C785\B2C8\B2E4. \D45C\C2DC \AC00\B2A5\D55C \B808\C774\BE14\C774 \B098\D0C0\B098\C9C0 \C54A\B3C4\B85D \D558\B824\B294 \ACBD\C6B0\C5D0\B3C4 \B808\C774\BE14\C744 \C815\C758\D55C \D6C4 \B808\C774\BE14 \D15C\D50C\B9AC\D2B8 ''\C228\AE40''\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105432366699309804)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_PLACEHOLDER_BUT_NO_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 ''\AC12 \C704\CE58 \D45C\C2DC\C790'' \AC12\C744 \C815\C758\D558\C9C0\B9CC \B808\C774\BE14\C774 \C5C6\C2B5\B2C8\B2E4. \D56D\BAA9 \B808\C774\BE14\C744 \C9C0\C815\D560 \B54C \C704\CE58 \D45C\C2DC\C790 \D14D\C2A4\D2B8\B9CC \C0AC\C6A9\D558\BA74 \C811\ADFC\C131 \BB38\C81C\AC00 \BC1C\C0DD\D558\BBC0\B85C, \C811\ADFC\C131\C744 \D5A5\C0C1\C2DC\D0A4\B824\BA74 \D56D\BAA9 \B808\C774\BE14\C744 \C815\C758\D574\C57C \D569\B2C8\B2E4. \D45C\C2DC \AC00\B2A5\D55C \B808\C774\BE14\C774 \B098\D0C0\B098\C9C0 \C54A\B3C4\B85D \D558\B824\B294 \ACBD\C6B0\C5D0\B3C4 \B808\C774\BE14\C744 \C815\C758\D55C \D6C4 \B808\C774\BE14 \D15C\D50C\B9AC\D2B8 ''\C228\AE40''\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104951198783309434)
,p_name=>'ADVISOR.CHECK.ITEM_NAME_LENGTH.MSG_TOO_LONG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984 \AE38\C774\AC00 %0\C790\C774\C9C0\B9CC \CD5C\B300 30\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104949350697309433)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104949407959309433)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_WRONG_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C774 \C544\B2D0 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104949716603309433)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_CLEAR_CACHE_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE90\C2DC \BE44\C6B0\AE30 \D398\C774\C9C0 %1(\C560\D50C\B9AC\CF00\C774\C158 %0 \B0B4\BD80)\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104949586698309433)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D398\C774\C9C0\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104949684211309433)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_TARGET_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1 \D398\C774\C9C0 %1(\C560\D50C\B9AC\CF00\C774\C158 %0 \B0B4\BD80)\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105358412039309741)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_COL_TOGGLE_NOT_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4 \D1A0\AE00 \C601\C5ED\C5D0\B294 ''\D589 \BA38\B9AC\AE00\B85C \C0AC\C6A9''\C774 ''\C608''\B85C \C124\C815\B41C \C5F4\C774 \C5C6\C2B5\B2C8\B2E4. \D589 \BA38\B9AC\AE00 \C5F4\C740 \D604\C7AC \D589\C744 \AC00\C7A5 \C798 \C2DD\BCC4\D558\B294 \C5F4(\C608: \ACE0\AC1D \C815\BCF4 \BCF4\ACE0\C11C\C758 \ACE0\AC1D \C774\B984)\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105358571330309742)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_REFLOW_NOT_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C7AC\BC30\CE58 \C601\C5ED\C5D0\B294 ''\D589 \BA38\B9AC\AE00\B85C \C0AC\C6A9''\C774 ''\C608''\B85C \C124\C815\B41C \C5F4\C774 \C5C6\C2B5\B2C8\B2E4. \D589 \BA38\B9AC\AE00 \C5F4\C740 \D604\C7AC \D589\C744 \AC00\C7A5 \C798 \C2DD\BCC4\D558\B294 \C5F4(\C608: \ACE0\AC1D \C815\BCF4 \BCF4\ACE0\C11C\C758 \ACE0\AC1D \C774\B984)\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105431297431309803)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_TABFORM_NOT_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D45C \D615\C2DD \D3FC \C601\C5ED\C5D0\B294 "\D589 \BA38\B9AC\AE00\B85C \C0AC\C6A9"\C774 [\C608]\B85C \C124\C815\B41C \C5F4\C774 \C5C6\C2B5\B2C8\B2E4. \D589 \BA38\B9AC\AE00 \C5F4\C740 \D604\C7AC \D589\C744 \AC00\C7A5 \C798 \C2DD\BCC4\D558\B294 \C5F4(\C608: \ACE0\AC1D \C815\BCF4 \D14C\C774\BE14\C758 \ACE0\AC1D \C774\B984)\C774\C5B4\C57C \D569\B2C8\B2E4. \C774 \C815\BCF4\B294 \D45C \D615\C2DD \D3FC\C744 \B80C\B354\B9C1\D560 \B54C \AC01 \D589\C758 \D3FC \D544\B4DC\C5D0 \B300\D55C \ACE0\C720 \B808\C774\BE14\C744 \C81C\ACF5\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104951324083309434)
,p_name=>'ADVISOR.CHECK.REPORT_DEFAULT_ORDER.MSG_NO_DEFAULT_ORDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C5D0 \AE30\BCF8 \C21C\C11C\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105883785194310171)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_BOOKMARK_CHECKSUM_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('"\CC45\AC08\D53C \D574\C2DC \D568\C218"\AC00 \B808\AC70\C2DC \C54C\ACE0\B9AC\C998\C73C\B85C \C124\C815\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105883838090310171)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_APP_PROTECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('"\C138\C158 \C0C1\D0DC \BCF4\D638"\AC00 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106084172626310350)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PAGE_PROTECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\CD9C \D504\B85C\C138\C2A4\AC00 \D3EC\D568\B41C \D398\C774\C9C0\C5D0\C11C\B294 \D398\C774\C9C0 \C561\C138\C2A4 \BCF4\D638\B97C \C0AC\C6A9\D558\ACE0 URL\C744 \D1B5\D574 \C804\B2EC\D558\B294 \D56D\BAA9\C5D0 \B300\D574 \BCF4\D638\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104920928634309412)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PREPARE_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED\C5D0 APEX_UTIL.PREPARE_URL\C744 \D1B5\D574 \C804\B2EC\B418\C9C0 \C54A\C740 "f?p" URL\C774 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104950569488309433)
,p_name=>'ADVISOR.CHECK.SQL_INJECTION.MSG_ITEM_SUBSTITUTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\B2A5\D55C SQL \C0BD\C785\C774 \AC80\C0C9\B418\C5C8\C2B5\B2C8\B2E4. %0\C774(\AC00) SQL, PL/SQL \CF54\B4DC \B610\B294 \D504\B85C\C138\C2A4 \D14C\C774\BE14 \C774\B984\C5D0\C11C \B300\CCB4 \AD6C\BB38\C73C\B85C \C0AC\C6A9\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104948334283309432)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104948422014309432)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \B300\CCB4 \AD6C\BB38\C73C\B85C \CC38\C870\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104950378348309433)
,p_name=>'ADVISOR.CHECK.TARGET_PAGE_AUTH_USABILITY.MSG_NO_AUTH_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1 \D398\C774\C9C0 %1(\C560\D50C\B9AC\CF00\C774\C158 %0 \B0B4\BD80)\C5D0 \C815\C758\B41C \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \C788\C9C0\B9CC \D604\C7AC \AD6C\C131\C694\C18C\C5D0\B294 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105431472137309803)
,p_name=>'ADVISOR.CHECK.THEME_STYLE_IS_ACCESSIBLE.MSG_NOT_ACCESSIBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \D604\C7AC \D14C\B9C8 \C2A4\D0C0\C77C\C758 \C811\ADFC\C131\C774 \D14C\C2A4\D2B8\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. [\C811\ADFC\C131 \D14C\C2A4\D2B8\B428]\C774 [\C608]\B85C \C124\C815\B41C \D14C\B9C8 \C2A4\D0C0\C77C\B85C \C804\D658\D558\AC70\B098, \D604\C7AC \D14C\B9C8 \C2A4\D0C0\C77C\C774 \D14C\C2A4\D2B8\B41C \ACBD\C6B0 \D14C\B9C8 \C124\C815\C5D0\C11C [\C811\ADFC\C131 \D14C\C2A4\D2B8\B428] \C18D\C131\C744 [\C608]\B85C \C124\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105526338895309883)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_JQUERY_MIGRATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\C5D0 jQuery Migrate\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4. jQuery Migrate\B294 \C81C\AC70\B41C API\B97C \BCF5\C6D0\D558\C5EC \CD5C\C2E0 \BC84\C804\C758 jQuery\B85C \C774\C804\D560 \B54C \C774 \C791\C5C5\C744 \C9C0\C6D0\D558\BA70 \C81C\AC70\B418\AC70\B098 \C0AC\C6A9\B418\C9C0 \C54A\B294 API\AC00 \C0AC\C6A9\B420 \B54C \BE0C\B77C\C6B0\C800 \CF58\C194\C5D0 \ACBD\ACE0\B97C \D45C\C2DC\D569\B2C8\B2E4. \C774\B85C \C778\D574 \C571\C758 \BAA8\B4E0 \D398\C774\C9C0\C5D0 \CD94\AC00 JavaScript \D30C\C77C\C774 \D3EC\D568\B429\B2C8\B2E4. \C774 \AE30\B2A5\C744 \C27D\AC8C \C81C\AC70\D558\B824\BA74 jQuery Migrate \C5C5\ADF8\B808\C774\B4DC \C124\BA85\C11C\C5D0\C11C \BCC0\ACBD\B418\C5B4\C57C \D560 API\C758 \C138\BD80\C815\BCF4\B97C \AC80\D1A0')
||unistr('\D55C \D6C4 \B354 \C774\C0C1 \D574\B2F9 API\B97C \C0AC\C6A9\D560 \D544\C694\AC00 \C5C6\B294 \AC83\C774 \D655\C2E4\D560 \B54C [jQuery Migrate \D3EC\D568]\C744 [\C544\B2C8\C624]\B85C \C124\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105526266987309883)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_LEGACY_JS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\C5D0 \C0AC\C6A9\B418\C9C0 \C54A\AC70\B098 \C9C0\C6D0\C774 \C911\B2E8\B41C JavaScript \D568\C218\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4. \C774\B85C \C778\D574 \C571\C758 \BAA8\B4E0 \D398\C774\C9C0\C5D0 \CD94\AC00 JavaScript \D30C\C77C\C774 \D3EC\D568\B429\B2C8\B2E4. \C774 \AE30\B2A5\C744 \C27D\AC8C \C81C\AC70\D558\B824\BA74 \B9B4\B9AC\C2A4 \B178\D2B8\C758 ''\C0AC\C6A9\B418\C9C0 \C54A\B294 \AE30\B2A5'' \C139\C158\C744 \AC80\D1A0\D558\C2ED\C2DC\C624. \C5EC\AE30\C11C \C0AC\C6A9\B418\C9C0 \C54A\AC70\B098 \C9C0\C6D0\C774 \C911\B2E8\B41C \D568\C218\C5D0 \B300\D55C \C885\C18D\C131\C744 \D655\C778\D558\ACE0 \B354 \C774\C0C1 \C571\C5D0 \C774 \D568\C218\B97C \D3EC\D568\D558\C9C0 \C54A\B294 \BC29\BC95\ACFC \AD00\B828\B41C \C9C0\CE68\C744 \D655\C778\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104951075695309434)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B41C \D56D\BAA9 \B610\B294 \C5F4\C774 \C815\C758\B418\C9C0 \C54A\C558\C9C0\B9CC "\C624\B958 \BA54\C2DC\C9C0 \D45C\C2DC \C704\CE58"\B97C \C0AC\C6A9\D558\B824\BA74 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104950995984309434)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_EQUAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B41C \D56D\BAA9 \B610\B294 \C5F4\C774 \AC80\C99D \D45C\D604\C2DD 1\C5D0 \C9C0\C815\B41C "%0"\ACFC(\C640) \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104949988764309433)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEF4\D30C\C77C \C624\B958 - %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104950034807309433)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_NOT_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \B610\B294 PL/SQL \CF54\B4DC\AC00 \C815\C758\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104948276172309432)
,p_name=>'ADVISOR.CHECK.VERIFY_CLOB_PROPERTY.MSG_TOO_LONG'
,p_message_language=>'ko'
,p_message_text=>unistr('32767\BCF4\B2E4 \AE41\B2C8\B2E4. \CC98\C74C 32767\AE4C\C9C0\B9CC \D655\C778\B429\B2C8\B2E4. \AE38\C774: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104950645087309433)
,p_name=>'ADVISOR.CHECK.V_FUNCTION_IN_SQL.MSG_CONTAINS_CALL'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BB38\C5D0 V/NV/DV \D568\C218 \D638\CD9C\C774 \D3EC\D568\B429\B2C8\B2E4(\C131\B2A5 \BB38\C81C\AC00 \B420 \C218 \C788\C74C).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104951277843309434)
,p_name=>'ADVISOR.CHECK.WHEN_BUTTON_PRESSED.MSG_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870\B41C \B2E8\CD94\AC00 \B354 \C774\C0C1 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105330922345309721)
,p_name=>'AFTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\D6C4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105278271596309680)
,p_name=>'AGREEMENT_MISSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C57D \B204\B77D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105072313499309522)
,p_name=>'ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105674534328310007)
,p_name=>'ALLOW_APP_BUILDING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131 \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105615943189309955)
,p_name=>'ALLOW_PACKAGED_APP_INS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C0DD\C0B0\C131 \BC0F \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158\C758 \C124\CE58\B97C \D5C8\C6A9\D569\B2C8\B2E4.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105517781089309875)
,p_name=>'ALLOW_RESTFUL_SERVICES'
,p_message_language=>'ko'
,p_message_text=>unistr('RESTful \C11C\BE44\C2A4 \C0AC\C6A9 \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105674689866310007)
,p_name=>'ALLOW_SQL_WORKSHOP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C6CC\D06C\C20D \C0AC\C6A9 \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105674819987310007)
,p_name=>'ALLOW_TEAM_DEVELOPMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D300 \AC1C\BC1C \C0AC\C6A9 \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105674433194310007)
,p_name=>'ALLOW_TO_BE_PURGED_YN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \BE44\C6B0\AE30 \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105674751858310007)
,p_name=>'ALLOW_WEBSHEET_DEV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \AC1C\BC1C \D5C8\C6A9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105091587067309536)
,p_name=>'ALL_APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104908769299309403)
,p_name=>'ALL_APPLICATIONS_NULL_DISP'
,p_message_language=>'ko'
,p_message_text=>unistr('- \BAA8\B450 - ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104908522415309403)
,p_name=>'ALL_CATEGORIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \BC94\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104908856384309403)
,p_name=>'ALL_CATEGORIES_NULL_DISP'
,p_message_language=>'ko'
,p_message_text=>unistr('- \BAA8\B4E0 \BC94\C8FC -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105677191101310009)
,p_name=>'ALL_MILESTONES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \B9C8\C77C\C2A4\D1A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105456524449309825)
,p_name=>'ALL_RELEASES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \B9B4\B9AC\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105095900054309539)
,p_name=>'ALL_STATIC_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C815\C801 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105094560489309538)
,p_name=>'ALL_THEMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105695270498310025)
,p_name=>'ALL_TYPES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105695628491310025)
,p_name=>'ALL_TYPES_NULL_DISP'
,p_message_language=>'ko'
,p_message_text=>unistr('- \BAA8\B4E0 \C720\D615 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105091614188309536)
,p_name=>'ALL_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C0AC\C6A9\C790')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106079571336310346)
,p_name=>'ALREADY_IN_ACL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C774\BBF8 APEX \ACC4\C815\C744 \AC00\C9C0\ACE0 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106069417491310336)
,p_name=>'ALREADY_IN_WS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C791\C5C5\C601\C5ED\C5D0 \C874\C7AC\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106035897769310305)
,p_name=>'ALWAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\C0C1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105345887091309732)
,p_name=>'ANALYSIS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \BD84\C11D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105345990189309732)
,p_name=>'ANALYZE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BCC4 \BD84\C11D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105473518832309839)
,p_name=>'ANALYZE_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \BA54\C18C\B4DC\B97C \C0AC\C6A9\D558\C5EC \BD84\C11D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105093440594309537)
,p_name=>'ANONYMOUS_BLOCK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C775\BA85 \BE14\B85D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104954551176309436)
,p_name=>'ANSWERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2F5\BCC0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104920693544309412)
,p_name=>'ANY_DEVELOPER'
,p_message_language=>'ko'
,p_message_text=>unistr('(\C784\C758\C758 \AC1C\BC1C\C790)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106121583811310385)
,p_name=>'APEX.ACTIVITY_BY_HOUR.APPCHANGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BCC0\ACBD\C0AC\D56D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106121419262310385)
,p_name=>'APEX.ACTIVITY_BY_HOUR.HOUR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106125574827310388)
,p_name=>'APEX.ACTIVITY_BY_HOUR.K'
,p_message_language=>'ko'
,p_message_text=>'%0 K'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106121675630310385)
,p_name=>'APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCF4\AE30: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105878283818310167)
,p_name=>'APEX.API.RUNTIME_API_USAGE.ERROR'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('API \D638\CD9C\C774 \AE08\C9C0\B418\C5C8\C2B5\B2C8\B2E4.'),
unistr('\AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.'),
unistr('\C774 \C7A5\C560\C5D0 \B300\D55C \C138\BD80\C815\BCF4\B294 \B514\BC84\ADF8 ID "%0"\C744(\B97C) \D1B5\D574 \D655\C778\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104979837564309455)
,p_name=>'APEX.ASSERT.DESUPPORTED_API'
,p_message_language=>'ko'
,p_message_text=>unistr('API \D638\CD9C "%0"\C740(\B294) Application Express \BC84\C804 %1\C5D0\C11C \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \C774 \C7A5\C560\C5D0 \B300\D55C \C138\BD80\C815\BCF4\B294 \B514\BC84\ADF8 ID "%2"\C744(\B97C) \D1B5\D574 \C81C\ACF5\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105355756527309740)
,p_name=>'APEX.AUTO_COMPLETE.NOT_IN_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C774 \BAA9\B85D\C5D0 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105632966637309970)
,p_name=>'APEX.BRANCH.SHOW_ONLY_NOT_SUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30\B9CC \D45C\C2DC\B294 \D398\C774\C9C0 \C18D\C131 "\C81C\CD9C \C2DC \B2E4\C2DC \B85C\B4DC"\AC00 "\C131\ACF5 \C2DC\C5D0\B9CC"\C73C\B85C \C124\C815\B41C \ACBD\C6B0 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105097662025309540)
,p_name=>'APEX.BRANCH.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30\B97C \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104886912002309386)
,p_name=>'APEX.COMPUTATION.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0\C744 \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105077716300309526)
,p_name=>'APEX.CONDITION.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74\C744 \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105129219867309569)
,p_name=>'APEX.CONDITION.UNKNOWN_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C \C218 \C5C6\B294 \C870\AC74 \C720\D615: "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104882987911309383)
,p_name=>'APEX.DATA.LOAD.INVALID_FILE_BROWSE_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \CC3E\C544\BCF4\AE30 \D56D\BAA9 %0\C740(\B294) APEX_APPLICATION_TEMP_FILES \D14C\C774\BE14\C744 \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104860316186309363)
,p_name=>'APEX.DATA.LOAD.MERGE_NOT_ALLOWED_FOR_COLLECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('"\BCD1\D569" \B85C\B4DC \C720\D615\C740 \BAA8\C74C\C73C\B85C \B85C\B4DC\C5D0 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106013530587310283)
,p_name=>'APEX.DATA.LOAD.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'ko'
,p_message_text=>unistr('"\BCD1\D569" \B85C\B4DC \C720\D615\C740 \B370\C774\D130 \D504\B85C\D30C\C77C\C5D0 \AE30\BCF8 \D0A4 \C5F4\C774 \D558\B098 \C774\C0C1 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106013328829310283)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\B4DC \C18C\C2A4 SQL \C9C8\C758\B97C \AD6C\BB38 \BD84\C11D\D560 \C218 \C5C6\C74C: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106013439638310283)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_RETURNS_WRONG_DATA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\B4DC \C18C\C2A4 SQL \C9C8\C758\B294 VARCHAR2, CLOB \B610\B294 BLOB\B97C \BC18\D658\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105290611771309689)
,p_name=>'APEX.DIALOG.PAGE.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 %0 \B300\D654\C0C1\C790 \D398\C774\C9C0 %1\C744(\B97C) \C131\ACF5\C801\C73C\B85C \B80C\B354\B9C1\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \D398\C774\C9C0 %1\C5D0\C11C \C0AC\C6A9 \C911\C778 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\AC00 \C801\D569\D55C JavaScript \B300\D654\C0C1\C790 \CD08\AE30\D654, \B300\D654\C0C1\C790 \B2EB\AE30 \BC0F \B300\D654\C0C1\C790 \CDE8\C18C \CF54\B4DC\AC00 \C815\C758\B41C \D15C\D50C\B9AC\D2B8 \C720\D615 "\B300\D654\C0C1\C790 \D398\C774\C9C0"\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106110526625310374)
,p_name=>'APEX.EMAIL.COPYRIGHT'
,p_message_language=>'ko'
,p_message_text=>'Copyright &copy; %0, All rights reserved.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106111330099310375)
,p_name=>'APEX.EMAIL.CREATE_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106110476482310374)
,p_name=>'APEX.EMAIL.DISCLAIMER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BA54\C2DC\C9C0\B294 \C2DC\C2A4\D15C\C5D0\C11C \C0DD\C131\B41C \BA54\C2DC\C9C0\C785\B2C8\B2E4. \C774 \BA54\C2DC\C9C0\C5D0 \D68C\C2E0\D558\C9C0 \B9C8\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106118946024310382)
,p_name=>'APEX.EMAIL.ENVIRONMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106129545897310392)
,p_name=>'APEX.EMAIL.GENERIC_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Application Express \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106111917757310376)
,p_name=>'APEX.EMAIL.GET_STARTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791\D558\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106110675007310374)
,p_name=>'APEX.EMAIL.GREETING'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\B2D8 \C548\B155\D558\C138\C694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106111611651310375)
,p_name=>'APEX.EMAIL.PASSWORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106119013862310382)
,p_name=>'APEX.EMAIL.PREVENT_PURGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \BE44\C6B0\AE30 \AE08\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106111880623310376)
,p_name=>'APEX.EMAIL.PURGE.BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798 \B2E8\CD94\B97C \B204\B974\ACE0 \D654\BA74\C758 \C9C0\CE68\C5D0 \B530\B77C \C791\C5C5\C601\C5ED\C744 \BE44\C6B0\C9C0 \BABB\D558\B3C4\B85D \CC28\B2E8\D560 \C218 \C788\C2B5\B2C8\B2E4. %0\C77C \C774\B0B4\C5D0 \C870\CE58\D558\C9C0 \C54A\C744 \ACBD\C6B0 \C791\C5C5\C601\C5ED\C774 \C790\B3D9\C73C\B85C \C81C\AC70\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106118725296310382)
,p_name=>'APEX.EMAIL.PURGE.FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C774 \B354 \C774\C0C1 \D544\C694\D558\C9C0 \C54A\C740 \ACBD\C6B0 \BCC4\B3C4\C758 \C791\C5C5\C774 \D544\C694\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106119250988310382)
,p_name=>'APEX.EMAIL.PURGE.HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C744 \BE44\C6B0\B824\ACE0 \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106118527816310382)
,p_name=>'APEX.EMAIL.PURGE.INTRO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C791\C5C5\C601\C5ED\C740 \CD5C\ADFC \D65C\B3D9\C744 \D45C\C2DC\D558\C9C0 \C54A\C73C\BBC0\B85C \ACE7 \BE44\C6B8 \C608\C815\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106118420359310382)
,p_name=>'APEX.EMAIL.PURGE.SUBJECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0! "%0" \C791\C5C5\C601\C5ED\C744 \BE44\C6B0\B824\ACE0 \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106118840620310382)
,p_name=>'APEX.EMAIL.PURGE_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6B0\AE30 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106119575213310383)
,p_name=>'APEX.EMAIL.REQUEST_ACTION_REQ'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C694\CCAD\C744 \C644\B8CC\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106119327134310383)
,p_name=>'APEX.EMAIL.REQUEST_APPROVED'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \C791\C5C5\C601\C5ED\C774 \C900\BE44\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106119608290310383)
,p_name=>'APEX.EMAIL.REQUEST_APPROVE_2'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \C791\C5C5\C601\C5ED\C774 \C2B9\C778\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106119405784310383)
,p_name=>'APEX.EMAIL.REQUEST_DECLINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C694\CCAD\C774 \AC70\C808\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106111218585310375)
,p_name=>'APEX.EMAIL.USERNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106119104538310382)
,p_name=>'APEX.EMAIL.WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106111131434310375)
,p_name=>'APEX.EMAIL.WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106110788327310375)
,p_name=>'APEX.EMAIL.WS_REQ_APPR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C694\CCAD\C774 \C2B9\C778\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106111416976310375)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798 \B2E8\CD94\B97C \B20C\B7EC \C2B9\C778 \D504\B85C\C138\C2A4\B97C \C644\B8CC\D558\ACE0 \BE44\BC00\BC88\D638\B97C \C124\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106110914927310375)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_INTRO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C694\CCAD\C774 \C2B9\C778\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106111591319310375)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791\D558\B824\BA74 \C544\B798 \B2E8\CD94\B97C \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106111767285310375)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_INTRO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C774 \C900\BE44\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106110831230310375)
,p_name=>'APEX.EMAIL.WS_REQ_DECL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C694\CCAD\C774 \AC70\C808\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106111039846310375)
,p_name=>'APEX.EMAIL.WS_REQ_DECL_INTRO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8C4\C1A1\D569\B2C8\B2E4. \C791\C5C5\C601\C5ED \C694\CCAD\C774 \AC70\C808\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104887351873309386)
,p_name=>'APEX.EXPORT.DOWNLOAD_NOT_SUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C18D\C131 "\C81C\CD9C \C2DC \B2E4\C2DC \B85C\B4DC"\AC00 "\C131\ACF5 \C2DC\C5D0\B9CC"\C73C\B85C \C124\C815\B41C \ACBD\C6B0 \B2E4\C6B4\B85C\B4DC\AC00 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \D398\C774\C9C0 \C18D\C131 "\C81C\CD9C \C2DC \B2E4\C2DC \B85C\B4DC"\B97C "\D56D\C0C1"\C73C\B85C \BCC0\ACBD\D558\AC70\B098 \BA38\B9AC\AE00 \C55E \D504\B85C\C138\C2A4\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105421181700309794)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.QUEUED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\AE30\C5F4\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105421250967309795)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.SENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C1A1\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104917117637309409)
,p_name=>'APEX.FEEDBACK.FEEDBACK_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104917250229309409)
,p_name=>'APEX.FEEDBACK.OPEN_FEEDBACK_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\ACB0 \D53C\B4DC\BC31 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104917323886309409)
,p_name=>'APEX.FEEDBACK.USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105256323102309663)
,p_name=>'APEX.GROUP.NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \ADF8\B8F9\C744 \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106091322936310357)
,p_name=>'APEX.HELP.VIEW_DOC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85\C11C \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104999277173309469)
,p_name=>'APEX.HTTP.HEADER.DUPLICATE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('HTTP \D5E4\B354 %0\C774(\AC00) \B450 \BC88 \C804\C1A1\B418\C5C8\C2B5\B2C8\B2E4. \C774\B294 \ACF5\ACA9\C77C \C218 \C788\C2B5\B2C8\B2E4.'),
'<ul>',
unistr('<li>\CCAB\BC88\C9F8 \AC12: "%1"</li>'),
unistr('<li>\B450\BC88\C9F8 \AC12: "%2"</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105036493622309496)
,p_name=>'APEX.INSTANCE_ADMIN.BIPUB_OPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4 \C9C0\C6D0\C740 STANDARD, ADVANCED, APEX_LISTENER, AOP \B610\B294 NONE\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105036508349309496)
,p_name=>'APEX.INSTANCE_ADMIN.FIRST_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4F1\B85D\B41C \CCAB\BC88\C9F8 \C2A4\D0A4\B9C8\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104939813101309426)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID\AC00 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105455964701309824)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_EMAIL_ADDRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C804\C790\BA54\C77C \C8FC\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104932197746309420)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_HISTORY_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C740 0 \B610\B294 \C591\C758 \C815\C218\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105036629325309496)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_PORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \D3EC\D2B8 \BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105483612384309846)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \AC00\C785 ID\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105036736528309496)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WALLET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790 \C9C0\AC11 \ACBD\B85C\B294 file:<filesystempath> \D615\C2DD\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105115667219309553)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105115576115309553)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C791\C5C5\C601\C5ED ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105140912631309578)
,p_name=>'APEX.INSTANCE_ADMIN.LIMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C740 %0\BCF4\B2E4 \D06C\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105051382344309507)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REGEXP_MISMATCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C2A4\D134\C2A4 \B9E4\AC1C\BCC0\C218 "%0"\C758 "%1" \AC12\C774 \C815\ADDC \D45C\D604\C2DD "%2"\ACFC(\C640) \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105051281534309507)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C2A4\D134\C2A4 \B9E4\AC1C\BCC0\C218 "%0"\C5D0 \AC12\C774 \C788\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105036863100309496)
,p_name=>'APEX.INSTANCE_ADMIN.PARM_NOTFOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C2A4\D134\C2A4 \B9E4\AC1C\BCC0\C218\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105479728980309843)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.APEX-AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104887054143309386)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.CLOUD_IDM-AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638(\C791\C5C5\C601\C5ED \C0AC\C6A9\C790 \ACC4\C815 \C800\C7A5\C18C\C5D0 \B300\D55C \C778\C99D\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105672140308310005)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.HEADER-AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638(\C791\C5C5\C601\C5ED \C0AC\C6A9\C790 \ACC4\C815 \C800\C7A5\C18C\C5D0 \B300\D55C \C778\C99D\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105565322807309914)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.LDAP-AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638(\C791\C5C5\C601\C5ED \C0AC\C6A9\C790 \ACC4\C815 \C800\C7A5\C18C\C5D0 \B300\D55C \C778\C99D\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104971342718309449)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SAML-AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638(\C791\C5C5\C601\C5ED \C0AC\C6A9\C790 \ACC4\C815 \C800\C7A5\C18C\C5D0 \B300\D55C \C778\C99D\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105194563900309617)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SOCIAL-AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638(\C791\C5C5\C601\C5ED \C0AC\C6A9\C790 \ACC4\C815 \C800\C7A5\C18C\C5D0 \B300\D55C \C778\C99D\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105479678338309843)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SSO-AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638(\C791\C5C5\C601\C5ED \C0AC\C6A9\C790 \ACC4\C815 \C800\C7A5\C18C\C5D0 \B300\D55C \C778\C99D\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105038740527309498)
,p_name=>'APEX.INSTANCE_ADMIN.PRINTSVR_PROTOCOL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4 \C11C\BC84 \D504\B85C\D1A0\CF5C\C740 http \B610\B294 https\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105038890911309498)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105038920807309498)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_RESTRICTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\D55C\B41C \C2A4\D0A4\B9C8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104912236219309406)
,p_name=>'APEX.ISSUES.APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104912051014309406)
,p_name=>'APEX.ISSUES.APPLICATION_NO_LONGER_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C774 \B354 \C774\C0C1 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105716987377310045)
,p_name=>'APEX.ISSUES.ASSIGN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105113854644309552)
,p_name=>'APEX.ISSUES.ATTACHMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106043970063310313)
,p_name=>'APEX.ISSUES.CARDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104917668366309410)
,p_name=>'APEX.ISSUES.CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\ACB0\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104914182409309407)
,p_name=>'APEX.ISSUES.COMMENTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85\C774 \C791\C131\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104914010984309407)
,p_name=>'APEX.ISSUES.COMMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104917762815309410)
,p_name=>'APEX.ISSUES.COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105299105271309695)
,p_name=>'APEX.ISSUES.CREATED_THIS_ISSUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BB38\C81C %0\C744(\B97C) \C0DD\C131\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104888761592309388)
,p_name=>'APEX.ISSUES.DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104888538545309387)
,p_name=>'APEX.ISSUES.DELETE_COMMENT_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C758\ACAC\C744 \C0AD\C81C\D558\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105701333352310034)
,p_name=>'APEX.ISSUES.DELETE_ISSUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C81C \C0AD\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104898475071309396)
,p_name=>'APEX.ISSUES.DELETE_ISSUE_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BB38\C81C\B97C \C0AD\C81C\D558\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104915752915309408)
,p_name=>'APEX.ISSUES.DOCUMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104914634537309407)
,p_name=>'APEX.ISSUES.DOCUMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104888600814309387)
,p_name=>'APEX.ISSUES.EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105829461004310130)
,p_name=>'APEX.ISSUES.EDIT_COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85 \D3B8\C9D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105829509532310130)
,p_name=>'APEX.ISSUES.EDIT_ISSUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C81C \D3B8\C9D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104912889569309406)
,p_name=>'APEX.ISSUES.ERR_APP_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C560\D50C\B9AC\CF00\C774\C158\C774 \C774 \C791\C5C5\C601\C5ED\C5D0 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104913281378309406)
,p_name=>'APEX.ISSUES.ERR_ATTEMPTING_TO_DELETE_COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85\C744 \C0AD\C81C\D558\B824\ACE0 \C2DC\B3C4\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104913192017309406)
,p_name=>'APEX.ISSUES.ERR_COMMENT_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104913417082309407)
,p_name=>'APEX.ISSUES.ERR_ISSUE_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C81C\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104913599701309407)
,p_name=>'APEX.ISSUES.ERR_MARKING_ISSUE_FOR_DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C81C\B97C \C0AD\C81C \B300\C0C1\C73C\B85C \D45C\C2DC\D558\B824\ACE0 \C2DC\B3C4\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104912944929309406)
,p_name=>'APEX.ISSUES.ERR_PAGE_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \D398\C774\C9C0\AC00 \C774 \C791\C5C5\C601\C5ED \B610\B294 \C81C\ACF5\B41C \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104913315527309406)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_DELETE_COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C5D0\AC8C \C774 \C124\BA85\C744 \C0AD\C81C\D560 \C218 \C788\B294 \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104913653668309407)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_TO_DELETE_ISSUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C5D0\AC8C \C774 \BB38\C81C\B97C \C0AD\C81C\D560 \C218 \C788\B294 \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104913051479309406)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_VISIBILITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C5D0\AC8C \C774 \C124\BA85 \D45C\C2DC \C5EC\BD80\B97C \BCC0\ACBD\D560 \C218 \C788\B294 \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105922930467310201)
,p_name=>'APEX.ISSUES.FILE_SIZE_CHECK_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \D06C\AE30\B97C \D655\C778\D558\B294 \C911 \BB38\C81C\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \C2DC\C2A4\D15C \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105922893518310201)
,p_name=>'APEX.ISSUES.FILE_SIZE_PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \D30C\C77C \C911 \D558\B098\B294 \CD5C\B300 \D30C\C77C \D06C\AE30\C778 %0\BC14\C774\D2B8\BCF4\B2E4 \D07D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105922782381310201)
,p_name=>'APEX.ISSUES.FILE_SIZE_SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D30C\C77C\C740 \CD5C\B300 \D30C\C77C \D06C\AE30\C778 %0\BC14\C774\D2B8\BCF4\B2E4 \D07D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104888810667309388)
,p_name=>'APEX.ISSUES.HIDE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE30\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104915579989309408)
,p_name=>'APEX.ISSUES.IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104914460818309407)
,p_name=>'APEX.ISSUES.IMAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104911892950309405)
,p_name=>'APEX.ISSUES.ISSUE_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C2A4\D15C\C5D0\C11C \CC3E\C744 \C218 \C5C6\B294 \BB38\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104861217421309364)
,p_name=>'APEX.ISSUES.JS.ADD_NOTIFICATION_PREFS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C5D0 \B300\D55C \D658\ACBD\C124\C815 \CD94\AC00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104914254667309407)
,p_name=>'APEX.ISSUES.JS.ATTACH_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \CCA8\BD80')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104913960817309407)
,p_name=>'APEX.ISSUES.JS.CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\ACB0\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106047836052310317)
,p_name=>'APEX.ISSUES.JS.HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104915290860309408)
,p_name=>'APEX.ISSUES.JS.IS_EMPTY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C5B4 \C788\C74C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104915094950309408)
,p_name=>'APEX.ISSUES.JS.ONE_OF_THESE_FILES_IS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \D30C\C77C \C911 \D558\B098\AC00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104913816510309407)
,p_name=>'APEX.ISSUES.JS.OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104916355093309409)
,p_name=>'APEX.ISSUES.JS.PERMANENTLY_DELETE_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \D56D\BAA9 \C601\AD6C \C0AD\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105702268911310034)
,p_name=>'APEX.ISSUES.JS.PURGE_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \BE44\C6B0\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104916291572309409)
,p_name=>'APEX.ISSUES.JS.RESINSTATE_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \D56D\BAA9 \BCF5\C6D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104914324051309407)
,p_name=>'APEX.ISSUES.JS.RESPONSE_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C751\B2F5 \D15C\D50C\B9AC\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104915157317309408)
,p_name=>'APEX.ISSUES.JS.SINGLE_TOO_LARGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B108\BB34 \CEE4\C11C \C5C5\B85C\B4DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. <br>\D30C\C77C\C758 \CD5C\B300 \D06C\AE30:')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104915499156309408)
,p_name=>'APEX.ISSUES.JS.SUPPORTED_FILE_TYPES_ARE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0\B418\B294 \D30C\C77C \C720\D615: ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105897880092310182)
,p_name=>'APEX.ISSUES.JS.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C751\B2F5 \D15C\D50C\B9AC\D2B8 \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104914943434309408)
,p_name=>'APEX.ISSUES.JS.THIS_FILE_IS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \D30C\C77C\C774')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104915327547309408)
,p_name=>'APEX.ISSUES.JS.UNSUPPORTED_FILE_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0\B418\B294 \D30C\C77C \C720\D615\C774 \C544\B2D9\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105644730889309980)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.BUG'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105645390889309981)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.DOCUMENTATIONISSUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85\C11C \BB38\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105644872039309981)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.ENHANCEMENTREQUEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C120 \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105644905407309981)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.FEATUREREQUEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105645268899309981)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.INSTALLATIONISSUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58 \BB38\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105645187206309981)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.PERFORMANCEISSUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\B2A5 \BB38\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105645056133309981)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.SECURITYISSUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548 \BB38\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105645463214309981)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.TRAININGISSUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD50\C721 \BB38\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105646157734309982)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.ADMINISTRATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105645820027309981)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.CSSHTML'
,p_message_language=>'ko'
,p_message_text=>'CSS / HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105645901392309982)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DAJAVASCRIPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5/JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105645628899309981)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DATABASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105646272626309982)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.EXTINTEGRATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\BD80 \C2DC\C2A4\D15C \D1B5\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105645786313309981)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.RESTINTEGRATION'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \D1B5\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105646009221309982)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.SECURITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105645566119309981)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.UIUX'
,p_message_language=>'ko'
,p_message_text=>'UI / UX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105644666064309980)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C81C\C5D0 \C9C0\C815\B41C \BC94\C8FC\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105643715227309980)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105644583718309980)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C81C\B85C \C778\D574 \C601\D5A5\C744 \BC1B\B294 \AE30\B2A5 \C601\C5ED\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105643873786309980)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105644467845309980)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C81C\C5D0 \C9C0\C815\B41C \C911\C694\B3C4 \B808\BCA8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105643982767309980)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\C694\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105644393408309980)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C81C \D574\ACB0\C744 \C704\D55C \D22C\C785 \B808\BCA8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105644019696309980)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D22C\C785 \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105644265029309980)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C81C\C5D0 \B300\D55C \C9C4\D589\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105644104796309980)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105646678092309982)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.BACKLOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC31\B85C\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105646382492309982)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.CRITICAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105646453688309982)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.IMPORTANT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105646578777309982)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.NORMAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105646724528309982)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.WILLNOTADDRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\ACB0 \C548\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105646875802309982)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.EASY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D3B8\D55C \C218\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105647011267309983)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.LARGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\ADDC\BAA8 \AC1C\BC1C \D22C\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105646977531309982)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.MODERATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\D1B5 \D22C\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105647400023309983)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.CANNOTFIX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C815 \BD88\AC00\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105647551328309983)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105647240435309983)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.REQUIRESMOREINFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \C815\BCF4 \D544\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105647304189309983)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WAITINGONTHIRDPARTY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C3\C790 \B300\AE30 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105647156642309983)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WORKINGONIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105657659669309992)
,p_name=>'APEX.ISSUES.LABEL_GROUP_DELETE_WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B098 \C774\C0C1\C758 \BA64\BC84\AC00 \BB38\C81C\C5D0 \C9C0\C815\B418\C5B4 \C788\C73C\BBC0\B85C \C774 \B808\C774\BE14 \ADF8\B8F9\C744 \C0AD\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104917452318309409)
,p_name=>'APEX.ISSUES.LAST_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C885 \C5C5\B370\C774\D2B8 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104913762888309407)
,p_name=>'APEX.ISSUES.MARKED_DUPLICATE_OF'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\BCF5 \D45C\C2DC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105701767600310034)
,p_name=>'APEX.ISSUES.MENU.ASSIGNEES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\C9C0\C815\C790')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105701604093310034)
,p_name=>'APEX.ISSUES.MENU.LABELS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105702116728310034)
,p_name=>'APEX.ISSUES.MENU.MILESTONES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C77C\C2A4\D1A4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105701525148310034)
,p_name=>'APEX.ISSUES.MENU.STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104911681510309405)
,p_name=>'APEX.ISSUES.MILESTONES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C77C\C2A4\D1A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105647926694309983)
,p_name=>'APEX.ISSUES.MILESTONES.CODEFREEZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF54\B4DC \ACE0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105648107734309984)
,p_name=>'APEX.ISSUES.MILESTONES.FINALRELEASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C885 \B9B4\B9AC\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105648037969309983)
,p_name=>'APEX.ISSUES.MILESTONES.UIFREEZE'
,p_message_language=>'ko'
,p_message_text=>unistr('UI \ACE0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104916135628309408)
,p_name=>'APEX.ISSUES.NOTIFY.ADDED_A_COMMENT_TO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) %1 %2\C5D0 \C124\BA85\C744 \CD94\AC00\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104860269634309363)
,p_name=>'APEX.ISSUES.NOTIFY.HAS_CHANGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105665208829309999)
,p_name=>'APEX.ISSUES.NOTIFY.ISSUE_HAS_CHANGED'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \C791\C5C5\C601\C5ED\C758 \BB38\C81C \BC88\D638 %0\C774(\AC00) \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105922659883310201)
,p_name=>'APEX.ISSUES.NO_LABLES_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \B808\C774\BE14\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104917542329309409)
,p_name=>'APEX.ISSUES.OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104914821756309408)
,p_name=>'APEX.ISSUES.OTHER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\D0C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104912369378309406)
,p_name=>'APEX.ISSUES.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104912170484309406)
,p_name=>'APEX.ISSUES.PAGE_NO_LONGER_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\AC00 \B354 \C774\C0C1 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106041415634310310)
,p_name=>'APEX.ISSUES.PURGE_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \BE44\C6B0\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105717064177310045)
,p_name=>'APEX.ISSUES.REMOVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104911960895309405)
,p_name=>'APEX.ISSUES.REMOVED_ASSOCIATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C5D0\C11C \C560\D50C\B9AC\CF00\C774\C158\ACFC \D398\C774\C9C0 \C5F0\AD00\C744 \C81C\AC70\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104912634151309406)
,p_name=>'APEX.ISSUES.REMOVED_THE_ATTACHMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80\B97C \C81C\AC70\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106016174746310286)
,p_name=>'APEX.ISSUES.REPLACE_COMMENT_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C124\BA85\C744 \C774 \D15C\D50C\B9AC\D2B8\B85C \BC14\AFB8\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106018112024310288)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_BODY'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C548\B155\D558\C138\C694! '),
'',
unistr('\CCAB\BC88\C9F8 \BB38\C81C\C785\B2C8\B2E4! \BB38\C81C\B97C \C0DD\C131\D558\C5EC \BAA8\B4E0 APEX \D504\B85C\C81D\D2B8\C5D0 \B300\D55C \C791\C5C5, \AE30\B2A5, \BC84\ADF8 \BC0F \D53C\B4DC\BC31\C744 \CD94\C801\D560 \C218 \C788\C2B5\B2C8\B2E4. \BB38\C81C\C5D0 \B808\C774\BE14\C744 \CD94\AC00\D558\ACE0 \D53C\C9C0\C815\C790\B97C \CD94\AC00\D558\BA70 \B9C8\C77C\C2A4\D1A4\C744 \C124\C815\D558\ACE0 \B9C8\D06C\B2E4\C6B4 \C18D\AE30\B97C \C0AC\C6A9\D558\C5EC \D615\C2DD \C9C0\C815\B3C4 \C801\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.  '),
'',
unistr('\B9C8\D06C\B2E4\C6B4\C73C\B85C \C218\D589\D560 \C218 \C788\B294 \C791\C5C5\C758 \BE60\B978 \C0D8\D50C\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106018021724310288)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle APEX\C5D0\C11C \D300 \AC1C\BC1C \C2DC\C791!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105717195193310045)
,p_name=>'APEX.ISSUES.SELECT'
,p_message_language=>'ko'
,p_message_text=>unistr('- \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104912734189309406)
,p_name=>'APEX.ISSUES.SET_STATUS_TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104889066878309388)
,p_name=>'APEX.ISSUES.SHOW_ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106017941630310287)
,p_name=>'APEX.ISSUES.SHOW_MORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \C815\BCF4 \D45C\C2DC...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104912463101309406)
,p_name=>'APEX.ISSUES.SUBSCRIBED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\C6A9\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105923035170310202)
,p_name=>'APEX.ISSUES.SUMMARY_LINE'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \C791\C5C5\C601\C5ED\C758 %0\C5D0 %2\AC1C\C758 \C0C8 \D1B5\C9C0\AC00 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105641209633309977)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\ADF8 \AE30\B85D\C5D0 \C0AC\C6A9\B418\B294 \D15C\D50C\B9AC\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105641182884309977)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\ADF8 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105641077557309977)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.TEXT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\C608\C0C1 \B3D9\C791**'),
unistr('- \BC1C\C0DD\D560 \AC83\C73C\B85C \C608\C0C1\B418\B294 \B3D9\C791\C744 \C54C\B824\C8FC\C2ED\C2DC\C624.'),
'',
'',
unistr('**\D604\C7AC \B3D9\C791**'),
unistr('- \BC1C\C0DD\D558\ACE0 \C788\B294 \B3D9\C791\C744 \C54C\B824\C8FC\C2ED\C2DC\C624.'),
'',
'',
unistr('**\C601\D5A5\C744 \BC1B\B294 \C0AC\B78C**'),
unistr('- \C601\D5A5\C744 \BC1B\B294 \C0AC\B78C/\AC1D\CCB4\B97C \C54C\B824\C8FC\C2ED\C2DC\C624. '),
'',
unistr('**\AC00\B2A5\D55C \D574\ACB0 \BC29\BC95**'),
unistr('- \AC00\B2A5\D55C \ACBD\C6B0 \C774 \BC84\ADF8\B97C \C218\C815\D560 \BC29\BC95\C744 \C81C\C548\D558\C2ED\C2DC\C624.'),
'',
unistr('**\C7AC\D604 \B2E8\ACC4**'),
unistr('- \C2A4\D06C\B9B0\C0F7 \BC0F \CF54\B4DC \C870\AC01(\D574\B2F9\D558\B294 \ACBD\C6B0)\C744 \BE44\B86F\D558\C5EC \D655\C2E4\D55C \C7AC\D604 \B2E8\ACC4\B97C \C81C\ACF5\D558\C2ED\C2DC\C624.'),
'1.',
'2.',
'3.',
'',
unistr('**\CEE8\D14D\C2A4\D2B8**'),
unistr('- \BC84\ADF8\AC00 \BC1C\C0DD\D560 \B54C \C218\D589\D558\B824\ACE0 \C2DC\B3C4 \C911\C774\B358 \C791\C5C5\C740 \BB34\C5C7\C785\B2C8\AE4C? \BC84\ADF8\AC00 \D2B9\C815 \C870\AC74 \B610\B294 \D2B9\C815 \C2DC\AC04 \B4F1\C5D0\B9CC \BC1C\C0DD\D569\B2C8\AE4C?'),
'',
unistr('**\D658\ACBD**'),
'',
unistr('- \BC84\C804: '),
unistr('- \D50C\B7AB\D3FC: '),
unistr('- \D558\C704 \C2DC\C2A4\D15C:'),
'',
'______',
'',
unistr('_**\CC38\ACE0:** \BB38\C81C\B97C \C560\D50C\B9AC\CF00\C774\C158 \BC0F/\B610\B294 \D398\C774\C9C0\C640 \C5F0\AD00\D558\B824\BA74 \BA3C\C800 \BB38\C81C\B97C \AE30\B85D\D55C \B2E4\C74C **\C791\C5C5** \B4DC\B86D\B2E4\C6B4\C5D0\C11C \C571 \BC0F \D398\C774\C9C0\B97C \C5F0\AD00\D558\C2ED\C2DC\C624._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105642334361309978)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\ADF8\AC00 \C81C\AE30\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105642253417309978)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\ADF8\AC00 \C81C\AE30\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105642442312309978)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.TEXT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\BC84\ADF8**\AC00 \C801\C808\D55C \C678\BD80 \C2DC\C2A4\D15C\C5D0 \C81C\CD9C\B418\C5C8\C2B5\B2C8\B2E4.'),
'',
unistr('- \BC84\ADF8 \CD94\C801 \C2DC\C2A4\D15C: '),
unistr('- \BC84\ADF8 ID: '),
unistr('- \BC84\ADF8 URL: '),
'',
unistr('\C124\BA85:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105641444197309978)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C694\CCAD \AE30\B85D\C5D0 \C0AC\C6A9\B418\B294 \D15C\D50C\B9AC\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105641354822309977)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C694\CCAD \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105641586374309978)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.TEXT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\AE30\B2A5 \C694\C57D**'),
unistr(' - \AE30\B2A5 \C694\CCAD\C758 \C77C\BC18\C801\C778 \AC1C\C694\B97C \D55C \B2E8\B77D\C73C\B85C \C81C\ACF5\D558\C2ED\C2DC\C624.'),
'',
'',
unistr('**\CEE8\D14D\C2A4\D2B8**'),
unistr(' - \C774 \C694\CCAD\C774 \D2B9\C815 \C0C1\D669\C774\B098 \D504\B85C\C138\C2A4(\C608: "[...]\D560 \B54C \D56D\C0C1 \BB38\C81C \BC1C\C0DD")\C640 \AD00\B828\C774 \C788\C2B5\B2C8\AE4C?'),
'',
'',
unistr(' - \C2A4\D06C\B9B0\C0F7, \C0AC\B840 \B4F1 \C9C0\C6D0 \C815\BCF4\B97C \C81C\ACF5\D558\C2ED\C2DC\C624.'),
'',
'',
unistr('**\C120\D638 \D574\ACB0 \BC29\BC95**'),
unistr('- \AD6C\D604\D558\B824\B294 \BC29\BC95\C5D0 \B300\D55C \BA85\D655\D55C \C124\BA85\C744 \C81C\ACF5\D558\C2ED\C2DC\C624.'),
'',
'',
unistr('**\B300\CCB4 \D574\ACB0 \BC29\BC95**'),
unistr('- \ACE0\B824\D55C \B300\CCB4 \D574\ACB0 \BC29\BC95\C774\B098 \AE30\B2A5 \B610\B294 \C0AC\C6A9\D55C \C784\C2DC\D574\ACB0\CC45\C5D0 \B300\D55C \C124\BA85\C744 \C81C\ACF5\D558\C2ED\C2DC\C624.'),
'',
'',
'______',
unistr('_**\CC38\ACE0:** \BB38\C81C\B97C \C560\D50C\B9AC\CF00\C774\C158 \BC0F/\B610\B294 \D398\C774\C9C0\C640 \C5F0\AD00\D558\B824\BA74 \BA3C\C800 \BB38\C81C\B97C \AE30\B85D\D55C \B2E4\C74C **\C791\C5C5** \B4DC\B86D\B2E4\C6B4\C5D0\C11C \C571 \BC0F \D398\C774\C9C0\B97C \C5F0\AD00\D558\C2ED\C2DC\C624._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105642664905309979)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C694\CCAD\C774 \C81C\CD9C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105642523120309978)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C694\CCAD\C774 \C81C\CD9C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105642736791309979)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.TEXT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\AE30\B2A5 \C694\CCAD**\C774 \C801\C808\D55C \C678\BD80 \C2DC\C2A4\D15C\C5D0 \C81C\CD9C\B418\C5C8\C2B5\B2C8\B2E4.'),
'',
unistr('- \AE30\B2A5 \CD94\C801 \C2DC\C2A4\D15C: '),
unistr('- \AE30\B2A5 ID: '),
unistr('- \AE30\B2A5 \C815\C758 URL: '),
'',
unistr('\C124\BA85:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105643519834309979)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\D6C4\C18D \C791\C5C5\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105643411748309979)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D6C4\C18D \C791\C5C5 \D544\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105643612545309979)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.TEXT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2E4\C74C \C791\C5C5\C744 \C218\D589\D558\C2ED\C2DC\C624. '),
'',
'1.',
'2.',
'3.',
'4.',
'',
unistr('\C124\BA85: ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105641720896309978)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C808\CC28\C5D0 \B300\D55C \C9C8\BB38\C5D0 \C0AC\C6A9\B418\B294 \D15C\D50C\B9AC\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105641647196309978)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B4\B5BB\AC8C \D560\AE4C\C694? ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105641807571309978)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.TEXT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\C9C8\BB38**'),
unistr('- \C9C8\BB38 \B610\B294 \C694\CCAD\C744 \CD5C\B300\D55C \AC04\B7B5\D558\AC8C \AE30\C220\D558\C2ED\C2DC\C624.'),
'',
unistr('**\C77C\BC18\C801\C778 \CEE8\D14D\C2A4\D2B8**'),
unistr('- \C2DC\B3C4 \C911\C778 \C791\C5C5\C740 \BB34\C5C7\C785\B2C8\AE4C? '),
'',
'',
unistr('- \D574\ACB0\C744 \C704\D574 \B2E4\B978 \ACF3\C744 \D655\C778\D558\AC70\B098 \B2E4\B978 \C0AC\B78C\C5D0\AC8C \C5F0\B77D\D588\C2B5\B2C8\AE4C?'),
'',
'',
unistr('**\D658\ACBD** '),
unistr('\C774 \C9C8\BB38\C740 \D658\ACBD\ACFC \AD00\B828\B41C \AC83\C785\B2C8\AE4C, \D504\B85C\ADF8\B798\BC0D \C5B8\C5B4\C640 \AD00\B828\B41C \AC83\C785\B2C8\AE4C \C544\B2C8\BA74 \B2E4\B978 \C601\C5ED\ACFC \AD00\B828\B41C \AC83\C785\B2C8\AE4C?'),
'',
'______',
unistr('_**\CC38\ACE0:** \BB38\C81C\B97C \C560\D50C\B9AC\CF00\C774\C158 \BC0F/\B610\B294 \D398\C774\C9C0\C640 \C5F0\AD00\D558\B824\BA74 \BA3C\C800 \BB38\C81C\B97C \AE30\B85D\D55C \B2E4\C74C **\C791\C5C5** \B4DC\B86D\B2E4\C6B4\C5D0\C11C \C571 \BC0F \D398\C774\C9C0\B97C \C5F0\AD00\D558\C2ED\C2DC\C624._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105643260911309979)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C\B824\C9C4 \BB38\C81C\B97C \CC38\C870\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105643123653309979)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C\B824\C9C4 \BB38\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105643390970309979)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.TEXT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\AC80\D1A0 \D6C4 \C774 \BB38\C81C\AC00 \C54C\B824\C9C4 \BB38\C81C\C778\C9C0 \D655\C778\D558\ACE0 \C544\B798 \C138\BD80\C815\BCF4\B97C \CC38\C870\D558\C2ED\C2DC\C624.'),
'',
unistr('- \BC84\ADF8 \CD94\C801 \C2DC\C2A4\D15C: '),
unistr('- \BC84\ADF8 ID: '),
unistr('- \BC84\ADF8 URL: '),
'',
unistr('\C124\BA85: ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105642961262309979)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \C815\BCF4\C5D0 \B300\D55C \C694\CCAD\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105642861281309979)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \C815\BCF4 \D544\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105643017486309979)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.TEXT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\C774 \BB38\C81C\C5D0 \B300\D574 \CD94\AC00 \C815\BCF4\AC00 \D544\C694\D569\B2C8\B2E4.**'),
'',
unistr('\C544\B798\C5D0 \C694\CCAD\B41C \C815\BCF4\B97C \C81C\ACF5\D558\C2ED\C2DC\C624. \C774 \C815\BCF4\B97C \C81C\ACF5\D558\C9C0 \C54A\C744 \ACBD\C6B0 \BD84\B958\AC00 \C5B4\B824\C6B0\BA70 \B354 \C774\C0C1 \BB38\C81C\B97C \D574\ACB0\D558\C9C0 \BABB\D569\B2C8\B2E4.'),
'',
'',
unistr('\C124\BA85:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105642035484309978)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BB38\C81C\C5D0 \B300\D55C \C870\CE58\AC00 \C218\D589\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105641981237309978)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\CE58 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105642158291309978)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.TEXT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C2E0\C911\D788 \ACE0\B824\D55C \D6C4 **\C774 \BB38\C81C\C5D0 \B300\D574 \B354 \C774\C0C1 \C870\CE58\B97C \C218\D589\D558\C9C0 \C54A\AE30\B85C \ACB0\C815\D588\C2B5\B2C8\B2E4**. '),
'',
unistr('\C124\BA85:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104915833615309408)
,p_name=>'APEX.ISSUES.TEXT_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104914714780309407)
,p_name=>'APEX.ISSUES.TEXT_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104911568850309405)
,p_name=>'APEX.ISSUES.THIS_ISSUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BB38\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105666381498310000)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_ATTACHMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %2\C5D0 %0 \CCA8\BD80\B97C %1\C5D0 \CD94\AC00\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105665357351309999)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_LABELS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %2\C5D0 %0\C744(\B97C) %1\C5D0 \CD94\AC00\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105666942426310000)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_MILESTONES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %2\C5D0 %0\C744(\B97C) %1\C5D0 \CD94\AC00\D588\C2B5\B2C8\B2E4.				')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105665542239309999)
,p_name=>'APEX.ISSUES.TIMELINE.ASSIGNED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %2\C5D0 %0\C744(\B97C) %1\C5D0 \C9C0\C815\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105665952663309999)
,p_name=>'APEX.ISSUES.TIMELINE.ASSOCIATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %2\C5D0 %0\C744(\B97C) %1\C5D0 \C5F0\AD00\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104916074014309408)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_A_COMMENT_FOR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0	%1\C5D0 \B300\D55C \C124\BA85\C744 \D3B8\C9D1\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105113754946309552)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_ISSUE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 %1 \BB38\C81C\B97C \D3B8\C9D1\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105666856276310000)
,p_name=>'APEX.ISSUES.TIMELINE.HIDDEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BB38\C81C\AC00 \C228\ACA8\C84C\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105665745302309999)
,p_name=>'APEX.ISSUES.TIMELINE.MARKED_DUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %2\C5D0 %0\C744(\B97C) %1\C758 \C911\BCF5\C73C\B85C \D45C\C2DC\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105666729651310000)
,p_name=>'APEX.ISSUES.TIMELINE.OPENED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C744(\B97C) \C5F4\C5B4\BCF8 \C0AC\B78C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105666421328310000)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_ATTACHMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %2\C5D0 %0 \CCA8\BD80\B97C %1\C5D0\C11C \C81C\AC70\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105665490839309999)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_LABELS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %2\C5D0 %0\C744(\B97C) %1\C5D0\C11C \C81C\AC70\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105667078245310000)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_MILESTONES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %2\C5D0 %0\C744(\B97C) %1\C5D0\C11C \C81C\AC70\D588\C2B5\B2C8\B2E4. 			')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105666525394310000)
,p_name=>'APEX.ISSUES.TIMELINE.STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %2\C5D0 %0\C5D0 \B300\D55C \C0C1\D0DC\B97C %1(\C73C)\B85C \C124\C815\D588\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105666173651310000)
,p_name=>'APEX.ISSUES.TIMELINE.SUBSCRIBED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %1\C5D0 %0\C744(\B97C) \AD6C\B3C5\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105665621754309999)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSIGNED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %2\C5D0 %0\C744(\B97C) %1\C5D0\C11C \C9C0\C815 \CDE8\C18C\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105666084649309999)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSOCIATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %1\C5D0 %0\C5D0\C11C \C560\D50C\B9AC\CF00\C774\C158\ACFC \D398\C774\C9C0 \C5F0\AD00\C744 \C81C\AC70\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105665831512309999)
,p_name=>'APEX.ISSUES.TIMELINE.UNMARKED_DUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %0\C758 %1 \C911\BCF5 \D45C\C2DC\B97C \CDE8\C18C\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105666267157310000)
,p_name=>'APEX.ISSUES.TIMELINE.UNSUBSCRIBED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774(\AC00) %1\C5D0 %0\C758 \AD6C\B3C5\C744 \D574\C81C\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105666686567310000)
,p_name=>'APEX.ISSUES.TIMELINE_MARKED_DUPLICATE_OF'
,p_message_language=>'ko'
,p_message_text=>unistr('%2\C774(\AC00) %0 %1\C758 \C911\BCF5\C744 \D45C\C2DC\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104911734696309405)
,p_name=>'APEX.ISSUES.UNASSIGNED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104888918699309388)
,p_name=>'APEX.ISSUES.UNHIDE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE40 \D574\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104912523945309406)
,p_name=>'APEX.ISSUES.UNSUBSCRIBED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\C6A9 \D574\C81C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105701417827310034)
,p_name=>'APEX.ISSUES.UPDATE_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104915614876309408)
,p_name=>'APEX.ISSUES.ZIP_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('Zip \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104914500041309407)
,p_name=>'APEX.ISSUES.ZIP_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('Zip \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104872825379309374)
,p_name=>'APEX.ITEM.GEOCODE.ERROR_DA_AFFECTED_ELEM'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \C9C0\C624\CF54\B529 \C8FC\C18C \D56D\BAA9\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106011146978310281)
,p_name=>'APEX.ITEM.NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D56D\BAA9\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105901597253310185)
,p_name=>'APEX.PAGE.CHECKSUM.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \CCB4\D06C\C12C\C744 \C0AC\C6A9\D558\BA74 \B3D9\C77C\D55C \D398\C774\C9C0\AC00 \B2E4\B978 \ACF3\C5D0 \BC30\CE58\B418\C5C8\B294\C9C0 \C5EC\BD80\B97C \C27D\AC8C \D655\C778\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \CCB4\D06C\C12C\C744 \BE44\AD50\D558\C5EC \C77C\CE58\D558\B294 \D56D\BAA9\C774 \C788\B294\C9C0 \D655\C778\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \D398\C774\C9C0\C5D0 \C0AC\C6A9\B41C \ACF5\C720 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \BCC0\ACBD\C0AC\D56D\C740 \C774 \CCB4\D06C\C12C\C5D0 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106057159419310325)
,p_name=>'APEX.PAGE_NAME.ABOUT_THIS_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106056964619310325)
,p_name=>'APEX.PAGE_NAME.CONFIGURATION_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131 \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106057082056310325)
,p_name=>'APEX.PAGE_NAME.THEME_STYLE_SELECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104889563268309388)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_FONTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B098\C758 \AE00\AF34\C774 \C788\B294 CFF(Compact Font Format) \AE00\AF34\B9CC \D5C8\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104889631297309388)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_TOP_DICTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B098\C758 \CD5C\C0C1\C704 DICT\AC00 \C788\B294 CFF(Compact Font Format) \AE00\AF34\B9CC \D5C8\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104889766268309388)
,p_name=>'APEX.PDF.ERROR.CFF_NOT_TYPE2_CHARSTRINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('Type 2 CharString \D615\C2DD\C758 CFF(Compact Font Format) \AE00\AF34\B9CC \D5C8\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104901977014309398)
,p_name=>'APEX.PDF.ERROR.FONT_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104901815406309398)
,p_name=>'APEX.PDF.ERROR.INVALID_CMAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD 4 \BC0F 12 cmap \D14C\C774\BE14\B9CC \C9C0\C6D0\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104902223787309398)
,p_name=>'APEX.PDF.ERROR.INVALID_ORIENTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC29\D5A5\C774 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104902046258309398)
,p_name=>'APEX.PDF.ERROR.NOT_INITIALIZED'
,p_message_language=>'ko'
,p_message_text=>unistr('PDF\AC00 \CD08\AE30\D654\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104901726568309398)
,p_name=>'APEX.PDF.ERROR.NO_CMAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34\C5D0\C11C \C801\D569\D55C cmap \D558\C704 \D14C\C774\BE14\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104902147447309398)
,p_name=>'APEX.PDF.ERROR.NO_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('PDF\C5D0 \D398\C774\C9C0\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105337147473309726)
,p_name=>'APEX.PDF.INTERNAL_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('PDF \D30C\C77C\C744 \C0DD\C131\D558\B294 \C911 \B0B4\BD80 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104907523133309402)
,p_name=>'APEX.PROCESS.INVALID_EDITABLE_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D504\B85C\C138\C2A4\C5D0 \BD80\C801\D569\D55C(\B2E4\C911 \D589 \C544\B2D8) \D3B8\C9D1 \AC00\B2A5 \C601\C5ED\C774 \C9C0\C815\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104895638484309393)
,p_name=>'APEX.PROCESS.NATIVE.GET_NEXT_OR_PREV_PK_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B610\B294 \C774\C804 \AE30\BCF8 \D0A4 \AC12\C744 \AC00\C838\C62C \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105565112929309914)
,p_name=>'APEX.PROCESS.NATIVE.WEB_SERVICE.NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105102950077309544)
,p_name=>'APEX.PROCESS.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4\B97C \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104922291340309413)
,p_name=>'APEX.QOS.REQUEST_LIMIT_REACHED'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B370\C774\D130\BCA0\C774\C2A4 \C138\C158 \B9AC\C18C\C2A4 \C81C\D55C\C73C\B85C \C778\D574 Application Express\AC00 \C694\CCAD\C744 \CC98\B9AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \B098\C911\C5D0 \B2E4\C2DC \C2DC\B3C4\D558\C2ED\C2DC\C624.'),
'<p/>',
unistr('\C774 \C7A5\C560\C5D0 \B300\D55C \C138\BD80\C815\BCF4\B294 \B514\BC84\ADF8 ID "%0"\C744(\B97C) \D1B5\D574 \C81C\ACF5\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104896464748309394)
,p_name=>'APEX.REMOTEDEPLOY.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C744 \BC30\CE58\D558\B294 \C911 \B2E4\C74C \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104899177248309396)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C774 \C6D0\ACA9 \C11C\BC84\C5D0 \C131\ACF5\C801\C73C\B85C \BC30\CE58\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104902840047309399)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS2'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C774 %1(\C73C)\B85C \C6D0\ACA9 \C11C\BC84\C5D0 \C131\ACF5\C801\C73C\B85C \BC30\CE58\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105537317354309892)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL \C11C\BE44\C2A4\C5D0 \B300\D55C \C778\C99D\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104922555535309413)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED_FOR_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4. \AC12 \BAA9\B85D\C740 \BD80\C801\D569\D55C \C6F9 \C778\C99D\C11C(\C774 LOV\C5D0 \B300\D55C \C5F4 \C815\BCF4\B97C \D3B8\C9D1\D560 \C218 \C5C6\AC8C \D568)\B97C \CC38\C870\D558\B294 REST \C0AC\C6A9 SQL \B370\C774\D130 \C18C\C2A4\B97C \C0AC\C6A9\D569\B2C8\B2E4. \C778\C99D\C744 \C704\D55C \C778\C99D\C11C\B97C \D655\C778\D558\C2ED\C2DC\C624. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106043648963310313)
,p_name=>'APEX.REMOTESQL.COMMUNICATION_FAILURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C2E0 \C624\B958\C785\B2C8\B2E4. \AC12 \BAA9\B85D\C5D0\C11C \CC38\C870\D558\B294 REST \C0AC\C6A9 SQL \B370\C774\D130 \C18C\C2A4\B97C \D638\CD9C\D558\B294 \C911 \BB38\C81C\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \C774\B85C \C778\D574 LOV\C5D0 \B300\D55C \C5F4 \C815\BCF4\B97C \D3B8\C9D1\D558\C9C0 \BABB\D558\AC8C \B429\B2C8\B2E4. REST \C0AC\C6A9 SQL \B370\C774\D130 \C18C\C2A4\AC00 \C62C\BC14\B974\AC8C \C791\B3D9 \C911\C774\BA70 \D574\B2F9\D558\B294 \C778\C99D \C778\C99D\C11C\AC00 \C62C\BC14\B978\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105538604765309893)
,p_name=>'APEX.REMOTESQL.REMOTE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\ACA9 \C11C\BC84\C5D0\C11C \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105513419698309872)
,p_name=>'APEX.REMOTESQL.SERVER_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C ORDS REST \C0AC\C6A9 SQL \C778\C2A4\D134\C2A4\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105119252281309556)
,p_name=>'APEX.REMOTESQL.SERVER_SENT_REDIRECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\BC84\AC00 %0(\C73C)\B85C \C7AC\C9C0\C815\C744 \C804\C1A1\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105413764989309782)
,p_name=>'APEX.REMOTESQL.SQL_STATEMENT_TOO_LONG'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BB38\C774 32.767\BC14\C774\D2B8\BCF4\B2E4 \AE41\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105432453782309804)
,p_name=>'APEX.REMOTESQL.TEST_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Application Express\B97C \C2DC\C791\D569\B2C8\B2E4! #USER#(\C73C)\B85C \C811\C18D\B418\C5C8\C2B5\B2C8\B2E4.'),
unistr('\B85C\CEEC \B370\C774\D130\BCA0\C774\C2A4 \C2DC\AC04\AE30\B85D\C740 #SYSDATE#\C785\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105657598806309992)
,p_name=>'APEX.REST.DEFAULT_SCHEMA_WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C758 \AE30\BCF8 \C2A4\D0A4\B9C8\C5D0 \B300\D55C \BCC4\CE6D\C744 \D3B8\C9D1\D558\ACE0 \C788\C2B5\B2C8\B2E4. \C774 \BCC4\CE6D\C744 \C124\C815\D558\BA74 \C791\C5C5\C601\C5ED \B808\BCA8\C5D0\C11C \ACBD\B85C \C811\B450\C5B4\AC00 \BCC0\ACBD\B429\B2C8\B2E4. \ADF8\B7EC\BA74 \C815\C758\D55C \BAA8\B4E0 APEX \AE30\BC18 RESTful \C11C\BE44\C2A4\C5D0 \B300\D55C URL\C774 \C601\D5A5\C744 \BC1B\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105411453435309781)
,p_name=>'APEX.SC.REFERENCES'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105648804830309984)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D2F8\B9AC\D2F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105648921678309984)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \C560\D50C\B9AC\CF00\C774\C158 \C720\D2F8\B9AC\D2F0 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105656316387309991)
,p_name=>'APEX.SEARCH.GO_TO_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\B3D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105656257939309991)
,p_name=>'APEX.SEARCH.GO_TO_SHARED_COMPONENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C720 \AD6C\C131\C694\C18C\B85C \C774\B3D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105649057955309984)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105649150639309985)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER_TASKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30 \C791\C5C5 > ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105649219463309985)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105649397858309985)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105649468414309985)
,p_name=>'APEX.SEARCH.SC.APP_LOGIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \B17C\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105649593215309985)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105649676440309985)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \BCF4\C548 \C778\C99D \CCB4\ACC4 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105649729545309985)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105649861820309985)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \BCF4\C548 \AD8C\D55C \BD80\C5EC \CCB4\ACC4 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105649950773309985)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105650005140309985)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \C774\B3D9 \ACBD\B85C \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105650138967309985)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105650284777309985)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \BE4C\B4DC \C635\C158 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105650343085309986)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105650493931309986)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \AD6C\C131\C694\C18C \C124\C815 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105650578466309986)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105650666877309986)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \C560\D50C\B9AC\CF00\C774\C158 \ACC4\C0B0 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105650752883309986)
,p_name=>'APEX.SEARCH.SC.CREATE_APPLICATION_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105650876690309986)
,p_name=>'APEX.SEARCH.SC.CREATE_AUTHENTICATION_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105650918338309986)
,p_name=>'APEX.SEARCH.SC.CREATE_BUILD_OPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105651037213309986)
,p_name=>'APEX.SEARCH.SC.CREATE_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \ACC4\C0B0 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105651127066309986)
,p_name=>'APEX.SEARCH.SC.CREATE_EMAIL_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105651297916309986)
,p_name=>'APEX.SEARCH.SC.CREATE_PLUG-IN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105651336835309986)
,p_name=>'APEX.SEARCH.SC.CREATE_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105651427365309987)
,p_name=>'APEX.SEARCH.SC.CREATE_WEB_CREDENTIALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C778\C99D\C11C \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105651508263309987)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105651614264309987)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \B370\C774\D130 \B85C\B4DC \C815\C758 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105651716781309987)
,p_name=>'APEX.SEARCH.SC.DATA_SOURCES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105651851863309987)
,p_name=>'APEX.SEARCH.SC.DEFINITION_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105651975123309987)
,p_name=>'APEX.SEARCH.SC.EMAIL_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105652094888309987)
,p_name=>'APEX.SEARCH.SC.LAYOUTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \B808\C774\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105652110709309987)
,p_name=>'APEX.SEARCH.SC.LAYOUTS_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \BCF4\ACE0\C11C \B808\C774\C544\C6C3 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105652269902309987)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\AC70\C2DC \C6F9 \C11C\BE44\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105652362700309987)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \B808\AC70\C2DC \C6F9 \C11C\BE44\C2A4 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105652426284309987)
,p_name=>'APEX.SEARCH.SC.LISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105652507361309988)
,p_name=>'APEX.SEARCH.SC.LISTS_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \D074\B798\C2DD \D0D0\C0C9 \BAA9\B85D \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105652621271309988)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105652729582309988)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \AC12 \BAA9\B85D \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105652871787309988)
,p_name=>'APEX.SEARCH.SC.NAVIGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105652971187309988)
,p_name=>'APEX.SEARCH.SC.OTHER_COMPONENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\D0C0 \AD6C\C131\C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105653050699309988)
,p_name=>'APEX.SEARCH.SC.PLUG-INS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105653142294309988)
,p_name=>'APEX.SEARCH.SC.PLUG-INS_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \D50C\B7EC\ADF8\C778 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105653290323309988)
,p_name=>'APEX.SEARCH.SC.PROCESSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105653398715309988)
,p_name=>'APEX.SEARCH.SC.PROCESSES_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105653443430309988)
,p_name=>'APEX.SEARCH.SC.QUERIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105653503961309988)
,p_name=>'APEX.SEARCH.SC.QUERIES_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \BCF4\ACE0\C11C \C9C8\C758 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105653662931309989)
,p_name=>'APEX.SEARCH.SC.REPORTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105653756742309989)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105653888083309989)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C REST \C0AC\C6A9 SQL \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105653999454309989)
,p_name=>'APEX.SEARCH.SC.SECURITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105654048728309989)
,p_name=>'APEX.SEARCH.SC.SESSION_STATE_PROTECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC \BCF4\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105654188080309989)
,p_name=>'APEX.SEARCH.SC.SET_APPLICATION_SESSION_STATE_PROTECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C0C1\D0DC \BCF4\D638 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105654369837309989)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C720 \AD6C\C131\C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105654489639309989)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105654565119309989)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105654673528309989)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \B2E8\CD95\D0A4 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105654764296309989)
,p_name=>'APEX.SEARCH.SC.TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED(\B808\AC70\C2DC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105654816190309990)
,p_name=>'APEX.SEARCH.SC.TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105654967636309990)
,p_name=>'APEX.SEARCH.SC.TEMPLATES_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C UI \D15C\D50C\B9AC\D2B8 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105655039635309990)
,p_name=>'APEX.SEARCH.SC.THEMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105655106557309990)
,p_name=>'APEX.SEARCH.SC.THEMES_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C UI \D14C\B9C8 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105655278078309990)
,p_name=>'APEX.SEARCH.SC.UI'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105655328943309990)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C778\C99D\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105655453294309990)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C \BCF4\C548 \C6F9 \C778\C99D\C11C \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105655524206309990)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105655631871309990)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9: \ACF5\C720 \AD6C\C131\C694\C18C \005C REST \B370\C774\D130 \C18C\C2A4 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105655740212309990)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C6CC\D06C\C20D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105655893145309990)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105655961276309991)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C6CC\D06C\C20D\C5D0\C11C %LIST_ITEM_NAME% \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105656085194309991)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.SCRIPT_EDITOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \D3B8\C9D1\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105656126150309991)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.TASKS'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C6CC\D06C\C20D \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106114967283310378)
,p_name=>'APEX.SESSION_STATE.DB_COLUMN_SOURCE_USED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 %0\C774(\AC00) \B370\C774\D130\BCA0\C774\C2A4 \C5F4\C744 \AE30\C900\C73C\B85C \D558\C9C0\B9CC, ''\C0AC\C6A9\B41C \C18C\C2A4'' \C18D\C131\C774 ''\C138\C158 \C0C1\D0DC\C5D0\C11C \D604\C7AC \AC12\C774 \B110\C77C \B54C\B9CC''\C73C\B85C \C124\C815\B418\C5C8\C2B5\B2C8\B2E4. \C774 \BC29\C2DD\C740 \B9E4\C6B0 \C704\D5D8\D558\BA70 \C5EC\B7EC \B808\CF54\B4DC\B97C \BCF4\ACE0 \C800\C7A5\D560 \B54C \B370\C774\D130\B97C \C6B0\C5F0\D788 \ACB9\CCD0\C4F8 \C218 \C788\C2B5\B2C8\B2E4. \D56D\C0C1 ''\C0AC\C6A9\B41C \C18C\C2A4''\B97C ''\C138\C158 \C0C1\D0DC\C5D0\C11C \D56D\C0C1 \C784\C758\C758 \AE30\C874 \AC12 \BC14\AFB8\AE30''\B85C \C124\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106052219354310321)
,p_name=>'APEX.SESSION_STATE.DISABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC\C5D0 \B300\D55C \C561\C138\C2A4\AC00 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B418\ACE0 \C77D\AE30/\C4F0\AE30 \C2DC\B3C4\AC00 \CC28\B2E8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104935607589309423)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \D504\B85C\C138\C2F1 \C911 \C138\C158 \C0C1\D0DC\C5D0 %0 \D56D\BAA9\C744 \C800\C7A5\D558\B824\ACE0 \D588\C2B5\B2C8\B2E4. \D56D\BAA9\C5D0 \B0B4\BD80 \C804\C6A9 \BCF4\D638\AC00 \C124\C815\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104928459570309417)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION2'
,p_message_language=>'ko'
,p_message_text=>unistr('\D5C8\C6A9 \D504\B85C\C138\C2F1 \C911 \C138\C158 \C0C1\D0DC\C5D0 %0 \D56D\BAA9\C744 \C800\C7A5\D558\B824\ACE0 \D588\C2B5\B2C8\B2E4. \D56D\BAA9\C5D0 \B0B4\BD80 \C804\C6A9 \BCF4\D638\AC00 \C124\C815\B418\C5B4 \C788\AC70\B098 \D56D\BAA9\C774 \AC8C\C2DC\B420 \C218 \C788\B294 \D3FC \D56D\BAA9\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104928290152309417)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION2_FOR_DEVELOPERS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C694\CCAD, \CE90\C2DC \BE44\C6B0\AE30, \C778\C218 \C774\B984 \BC0F \C778\C218 \AC12(%0)\C5D0 \B300\D574 \ACC4\C0B0\B41C \CCB4\D06C\C12C\C774 \D45C\C2DC \D504\B85C\C2DC\C800(%1)\C5D0 \C804\B2EC\B41C \CCB4\D06C\C12C\ACFC \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.'),
'',
unistr('\CC38\ACE0: \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C\B294 \B2E4\B978 \C624\B958 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B420 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104927785067309417)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION_FOR_DEVELOPERS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D45C\C2DC \CC98\B9AC \C911 %0 \D56D\BAA9\C744 \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\D558\B3C4\B85D \C2DC\B3C4\D569\B2C8\B2E4. \D56D\BAA9 \BCF4\D638 \B808\BCA8\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'  %1',
'',
unistr('\CCB4\D06C\C12C\C774 \C804\B2EC\B418\C9C0 \C54A\C558\AC70\B098 \C804\B2EC\B41C \CCB4\D06C\C12C\C774 \BCF4\D638 \B808\BCA8 "%2"\C758 \D56D\BAA9\C5D0 \C801\D569\D569\B2C8\B2E4.'),
'',
unistr('\CC38\ACE0: \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \B2E4\B978 \C624\B958 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105102762405309544)
,p_name=>'APEX.SESSION_STATE.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1022 \C18D\C131\C744 \C800\C7A5\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104872353415309374)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_SDO_GEOMETRY_TO_GEOJSON'
,p_message_language=>'ko'
,p_message_text=>unistr('SDO_GEOMETRY \AC12\C744 GeoJSON\C73C\B85C \BCC0\D658\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104869831579309372)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_TEXT_TO_SDO_GEOMETRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\B97C SDO_GEOMETRY \AC1D\CCB4\B85C \BCC0\D658\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104871003087309373)
,p_name=>'APEX.SPATIAL.INVALID_GEOJSON'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \C801\D569\D55C GeoJSON\C774 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104886607088309386)
,p_name=>'APEX.TABULAR_FORM.COLUMN_DEFAULT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('#COMPONENT_NAME# \C5F4\C758 \AE30\BCF8\AC12\C744 \ACC4\C0B0\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104887533616309386)
,p_name=>'APEX.TABULAR_FORM.MRD.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \D589 \C0AD\C81C \D504\B85C\C138\C2A4\B97C \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105129706204309570)
,p_name=>'APEX.TABULAR_FORM.MRU.FCS_MISSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\C12C \C5F4("FCS")\C774 \D544\C694\D55C\B370 \C81C\ACF5\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105129975850309570)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_PRIM_KEY_VALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\B41C \AE30\BCF8 \D0A4 \AC12\C774 \C5C6\C2B5\B2C8\B2E4. \C5C5\B370\C774\D2B8\B97C \C218\D589\D558\B824\BA74 \C801\C5B4\B3C4 \D55C \AC1C\C758 \D589\C744 \C81C\ACF5\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105130713264309571)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_SEC_KEY_VALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DD\BCC4\B41C \BCF4\C870 \D0A4 \C5F4\C5D0 \B300\D574 \C81C\ACF5\B41C \BCF4\C870 \AC12 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105270340846309674)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C \D615\C2DD \D3FC\C5D0\C11C \B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105129646818309570)
,p_name=>'APEX.TABULAR_FORM.MRU.PRIM_KEY_COL_NOT_SPECIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4\C774 \C9C0\C815\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105130655046309570)
,p_name=>'APEX.TABULAR_FORM.MRU.SEC_KEY_COL_NOT_IN_SELECT_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \C120\D0DD \BAA9\B85D\C5D0\C11C \C9C0\C815\B41C \BCF4\C870 \D0A4 \C5F4\C744 \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105129569375309570)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_NAME_NOT_SPECIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C774\B984\C774 \C9C0\C815\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105129454809309570)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_OWNER_NOT_SPECIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C18C\C720\C790\AC00 \C9C0\C815\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105150673032309585)
,p_name=>'APEX.TABULAR_FORM.MRU.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \D589 \C5C5\B370\C774\D2B8 \D504\B85C\C138\C2A4\B97C \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104910885612309405)
,p_name=>'APEX.THEMES.COPY_THEME_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C560\D50C\B9AC\CF00\C774\C158\C758 "%0" \D14C\B9C8\B97C \BCF5\C0AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106108411534310372)
,p_name=>'APEX.THEMES.INCOMPATIBLE_THEME'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C784\D3EC\D2B8\B41C \D14C\B9C8\B294 \D604\C7AC \D14C\B9C8\C640 \D638\D658\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106090539084310356)
,p_name=>'APEX.THEMES.INVALID_THEME_NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \BC88\D638\AC00 \BD80\C801\D569\D558\AC70\B098 \D14C\B9C8\AC00 \D604\C7AC UI \D14C\B9C8\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106051306442310320)
,p_name=>'APEX.TREE.ID_AND_PARENT_ID_COLUMNS_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\CE35 \ACC4\C0B0\C5D0 \D544\C694\D55C \AE30\BCF8 \D0A4 \BC0F \C0C1\C704 \D0A4 \C5F4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106051440765310320)
,p_name=>'APEX.TREE.NODE_LEVEL_AND_STATUS_COLUMNS_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\CE35\C774 \ACC4\C0B0\B418\C9C0 \C54A\C740 \ACBD\C6B0 \D544\C694\D55C \B178\B4DC \B808\BCA8 \BC0F \B178\B4DC \C0C1\D0DC \C5F4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106069700863310337)
,p_name=>'APEX.UI.APPEARANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105828790073310130)
,p_name=>'APEX.UI.AUTO_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105043243929309501)
,p_name=>'APEX.UI.DARK_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B4\B461\AC8C \BAA8\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105043327544309501)
,p_name=>'APEX.UI.DISABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105828625052310130)
,p_name=>'APEX.UI.LIGHT_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1D\AE30 \BAA8\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105472128941309837)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798 \BAA9\B85D\C5D0\C11C \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105474412819309839)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 - \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105013982324309480)
,p_name=>'APEX.USER.CHECK_SGID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\B418\C9C0 \C54A\C740 \C561\C138\C2A4(\BCF4\C548 \ADF8\B8F9 \D328\D0A4\C9C0 \BCC0\C218\AC00 \C124\C815\B418\C9C0 \C54A\C74C)\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105014339915309480)
,p_name=>'APEX.USER.FETCH_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \CC3E\AE30 \C815\BCF4\B97C \C778\CD9C\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105000183364309470)
,p_name=>'APEX.USER.NOT_ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AC\C6A9\C790\AC00 \C774 \C791\C5C5\C744 \C218\D589\D558\B824\BA74 \AD00\B9AC\C790 \AD8C\D55C\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105014296316309480)
,p_name=>'APEX.USER.NO_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AC\C6A9\C790\AC00 \C804\C790\BA54\C77C \C8FC\C18C\B97C \C81C\ACF5\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104970048905309448)
,p_name=>'APEX.USER.UNAUTHORIZED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\B418\C9C0 \C54A\C740 \C561\C138\C2A4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105014126461309480)
,p_name=>'APEX.USER.USER_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AC\C6A9\C790\B294 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104929130790309418)
,p_name=>'APEX.VALIDATION.INVALID_EDITABLE_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \AC80\C99D\C5D0 \BD80\C801\D569\D55C(\B2E4\C911 \D589 \C544\B2D8) \D3B8\C9D1 \AC00\B2A5 \C601\C5ED\C774 \C9C0\C815\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105102865198309544)
,p_name=>'APEX.VALIDATION.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C744 \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106052624801310321)
,p_name=>'APEX.WEBSRC.CANNOT_PARSE_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('Application Express\B294 %0 \C720\D615\C758 \C751\B2F5 \B370\C774\D130\C5D0\C11C \B370\C774\D130 \D504\B85C\D30C\C77C\C744 \ACC4\C0B0\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105519371438309877)
,p_name=>'APEX.WEBSRC.DATAPROFILE.MANY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105519230524309877)
,p_name=>'APEX.WEBSRC.DATAPROFILE.ONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106039212091310308)
,p_name=>'APEX.WEBSRC.FILTER_EXPR_INVALID_JSON'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \D45C\D604\C2DD\C774 \C801\D569\D55C JSON\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106032433989310302)
,p_name=>'APEX.WEBSRC.FILTER_NOT_SUPPORTED_BY_ORDS'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle REST Data Services\B294 \D544\D130\B97C \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105411395713309781)
,p_name=>'APEX.WEBSRC.HTTP.PAGINATION_PARAMETER_CONFLICT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B9E4\AE40 URL \B9E4\AC1C\BCC0\C218 "%0"\C774(\AC00) REST \C18C\C2A4 \B9E4\AC1C\BCC0\C218\C640 \CDA9\B3CC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105514281080309873)
,p_name=>'APEX.WEBSRC.HTTP200'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 200: \C131\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105514309715309873)
,p_name=>'APEX.WEBSRC.HTTP201'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 201: \C0DD\C131\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105513775303309872)
,p_name=>'APEX.WEBSRC.HTTP400'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 400: \C798\BABB\B41C \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105513546976309872)
,p_name=>'APEX.WEBSRC.HTTP401'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 401: \AD8C\D55C\C774 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105513825100309872)
,p_name=>'APEX.WEBSRC.HTTP403'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 403: \C0AC\C6A9\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105513614438309872)
,p_name=>'APEX.WEBSRC.HTTP404'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 404: \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105513943317309872)
,p_name=>'APEX.WEBSRC.HTTP405'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 405: \BA54\C18C\B4DC\B97C \C0AC\C6A9\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104871681233309373)
,p_name=>'APEX.WEBSRC.HTTP407'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 407: \D504\B85D\C2DC \C778\C99D \D544\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104871901620309373)
,p_name=>'APEX.WEBSRC.HTTP409'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 409: \CDA9\B3CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104871706362309373)
,p_name=>'APEX.WEBSRC.HTTP412'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 412: \C0AC\C804 \C870\AC74 \C2E4\D328')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104871885503309373)
,p_name=>'APEX.WEBSRC.HTTP428'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 428: \C0AC\C804 \C870\AC74 \D544\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105514069645309872)
,p_name=>'APEX.WEBSRC.HTTP500'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 500: \B0B4\BD80 \C11C\BC84 \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105514133960309873)
,p_name=>'APEX.WEBSRC.HTTP502'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 502: \C798\BABB\B41C \AC8C\C774\D2B8\C6E8\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106053092514310321)
,p_name=>'APEX.WEBSRC.HTTP503'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 503: \C11C\BE44\C2A4\B97C \C0AC\C6A9\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106053103709310321)
,p_name=>'APEX.WEBSRC.HTTP504'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP 504: \AC8C\C774\D2B8\C6E8\C774 \C2DC\AC04 \CD08\ACFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105895288895310180)
,p_name=>'APEX.WEBSRC.HTTP_ERROR_OCCURRED'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4\C5D0\C11C HTTP \C624\B958 \BC18\D658: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105513346018309872)
,p_name=>'APEX.WEBSRC.MODULE_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105069165531309520)
,p_name=>'APEX.WEBSRC.NO_ARRAY_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C120\D0DD\AE30 "%0"\C774(\AC00) \D14C\C774\BE14\B85C \CC98\B9AC\B420 \AC1D\CCB4 \BC30\C5F4\C744 \C120\D0DD\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105069242927309520)
,p_name=>'APEX.WEBSRC.NO_SINGLE_ROW_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C120\D0DD\AE30 "%0"\C774(\AC00) \B2E8\C77C \D589\C73C\B85C \CC98\B9AC\B420 \AC1D\CCB4\B97C \C120\D0DD\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104874851367309376)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4 \BE44\C728 \C81C\D55C(%1\CD08 \B0B4 %0\AC1C \C694\CCAD)\C774 \C2E4\D589\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104863803296309366)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED_CANNOT_WAIT'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4 \BE44\C728 \C81C\D55C(%1\CD08 \B0B4 %0\AC1C \C694\CCAD)\C774 \C2E4\D589\B418\C5C8\C73C\BA70 \D544\C694\D55C \B300\AE30 \C2DC\AC04\C774 \B108\BB34 \AE41\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105895132389310180)
,p_name=>'APEX.WEBSRC.REQUIRED_PARAM_MISSING'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C720\D615\C758 \D544\C218 REST \C18C\C2A4 IN \B9E4\AC1C\BCC0\C218 "%0"\C5D0\B294 \AC12\C774 \C788\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105813196641310118)
,p_name=>'APEX.WEBSRC.RESPONSE_BODY_TOO_LARGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C751\B2F5 \BCF8\BB38\C774 \B108\BB34 \CEE4\C11C \D45C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105478578494309843)
,p_name=>'APEX.WEBSRC.SMALL_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\AC70\C2DC ORDS REST \C11C\BE44\C2A4\C5D0 \C791\C740 \ACE0\C815 \D398\C774\C9C0 \D06C\AE30\AC00 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104878426706309379)
,p_name=>'APEX.WEBSRC.SYNC.API_CALL_COMMENT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- \C774 API \D638\CD9C\C740 ALTER TABLE \BB38\C744 \C2E4\D589\D558\C5EC \D14C\C774\BE14 \C5F4\C744 '),
unistr('-- REST \B370\C774\D130 \C18C\C2A4\C758 \B370\C774\D130 \D504\B85C\D30C\C77C\ACFC \B3D9\C801\C73C\B85C \B3D9\AE30\D654\D569\B2C8\B2E4.'),
unistr('-- ALTER TABLE\C744 \C0AC\C6A9\D558\C5EC \C5F4 \B370\C774\D130 \C720\D615\C744 \BCC0\ACBD\D560 \C218 \C5C6\C744 \ACBD\C6B0 '),
unistr('-- \C624\B958 \BA54\C2DC\C9C0\AC00 \C0DD\C131\B429\B2C8\B2E4.'),
'--'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104877352391309378)
,p_name=>'APEX.WEBSRC.SYNC.CANNOT_SYNC_TABLE_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \D504\B85C\D30C\C77C \BCC0\ACBD\C0AC\D56D\C744 \C790\B3D9\C73C\B85C \C801\C6A9\D560 \C218 \C5C6\C73C\BA70, \B85C\CEEC \D14C\C774\BE14 \C5F4\C744 \C218\B3D9\C73C\B85C \C870\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104878586380309379)
,p_name=>'APEX.WEBSRC.SYNC.DDL_CALL_COMMENT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- %0 \AE30\C900 \C2E4\D589 \C608\C815:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104876548173309378)
,p_name=>'APEX.WEBSRC.SYNC.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCD1\D569 \B3D9\AE30\D654 \BC29\BC95\C744 \C0AC\C6A9\D558\B824\BA74 \B370\C774\D130 \D504\B85C\D30C\C77C\C5D0 \AE30\BCF8 \D0A4\AC00 \C815\C758\B418\C5B4 \C788\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104876815627309378)
,p_name=>'APEX.WEBSRC.SYNC.NO_COMMON_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\CEEC \D14C\C774\BE14\ACFC \B370\C774\D130 \D504\B85C\D30C\C77C\C5D0 \ACF5\D1B5\B418\B294 \C5F4\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104863492521309366)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_ABORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C774 \C911\B2E8\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104877014484309378)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_FAILURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D328')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104877101262309378)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_INCOMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\C644\B8CC(\C694\CCAD \C81C\D55C\C774 \CD08\ACFC\B428)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104877225809309378)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_JOB_ALREADY_RUNNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C774 \C774\BBF8 \C2E4\D589 \C911\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104864359029309366)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_RUNNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104864413907309366)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SCHEDULED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C815\C774 \C7A1\D798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104876958291309378)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104876626339309378)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\AE30\D654 \B2E8\ACC4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104876712309309378)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL_COPY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0(\C2E0\ADDC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105361493493309744)
,p_name=>'APEX.WEBSRC.TEST_OPERATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C2A4\D2B8 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105432583651309804)
,p_name=>'APEX.WEBSRC.TIMEOUT_EXCEEDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 REST \C18C\C2A4 \B370\C774\D130\B97C \C778\CD9C\D558\B294 \C911 \C2DC\AC04 \CD08\ACFC \AC12\C774 \CD08\ACFC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105408438206309778)
,p_name=>'APEX.WEBSRC.TOO_MANY_NEXT_PAGE_REQUESTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \B85C\CEEC SQL \D544\D130\C758 \ACBD\C6B0 REST \C11C\BE44\C2A4\C5D0 \B300\D574 \B108\BB34 \B9CE\C740 "\B2E4\C74C \D398\C774\C9C0" \C694\CCAD\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105478435795309842)
,p_name=>'APEX.WEBSRC.UNKNOWN_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\AC70\C2DC ORDS REST \C11C\BE44\C2A4\C5D0 \B300\D55C \ACE0\C815 \D398\C774\C9C0 \D06C\AE30\B97C \C54C \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105184800334309610)
,p_name=>'APEXAPP.BRANCH.ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790 \D398\C774\C9C0\C5D0 \B300\D55C \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105159369484309592)
,p_name=>'APEXAPP.BREADCRUMB.DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105180912415309607)
,p_name=>'APEXAPP.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\C11D \CC98\B9AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105165416206309596)
,p_name=>'APEXAPP.BUTTON.ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105165795782309596)
,p_name=>'APEXAPP.BUTTON.ADD_ENTITY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105166116130309597)
,p_name=>'APEXAPP.BUTTON.ADD_MULTIPLE_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \C0AC\C6A9\C790 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105166264447309597)
,p_name=>'APEXAPP.BUTTON.ADD_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105166353334309597)
,p_name=>'APEXAPP.BUTTON.ADD_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105165160654309596)
,p_name=>'APEXAPP.BUTTON.APPLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105165223885309596)
,p_name=>'APEXAPP.BUTTON.CANCEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105165316308309596)
,p_name=>'APEXAPP.BUTTON.CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EB\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105165018609309596)
,p_name=>'APEXAPP.BUTTON.CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105154300582309588)
,p_name=>'APEXAPP.BUTTON.DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105165514439309596)
,p_name=>'APEXAPP.BUTTON.DELETE_CHECKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \D56D\BAA9 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105165687709309596)
,p_name=>'APEXAPP.BUTTON.EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105165870018309597)
,p_name=>'APEXAPP.BUTTON.FINISH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105154139799309588)
,p_name=>'APEXAPP.BUTTON.GO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105154836969309588)
,p_name=>'APEXAPP.BUTTON.LOAD_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105165985215309597)
,p_name=>'APEXAPP.BUTTON.LOGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C778\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105154538334309588)
,p_name=>'APEXAPP.BUTTON.NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105154487666309588)
,p_name=>'APEXAPP.BUTTON.PREVIOUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105154264031309588)
,p_name=>'APEXAPP.BUTTON.RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105154697933309588)
,p_name=>'APEXAPP.BUTTON.SAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105154743358309588)
,p_name=>'APEXAPP.BUTTON.SUBMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105166457404309597)
,p_name=>'APEXAPP.BUTTON.SUBMIT_FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105166085222309597)
,p_name=>'APEXAPP.BUTTON.VIEW_DETAILS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105159238900309592)
,p_name=>'APEXAPP.CHART.LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105178473485309606)
,p_name=>'APEXAPP.CHART.SERIES'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \ACC4\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105170813785309600)
,p_name=>'APEXAPP.COLUMN.ACL_ROLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105159033676309591)
,p_name=>'APEXAPP.COLUMN.ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105169865572309599)
,p_name=>'APEXAPP.COLUMN.ACTIVITY_BY_HOUR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04\BCC4 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105169181024309599)
,p_name=>'APEXAPP.COLUMN.APPLICATION_SESSIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C138\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105158959109309591)
,p_name=>'APEXAPP.COLUMN.ATTACHMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105158161436309591)
,p_name=>'APEXAPP.COLUMN.AUTOMATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105168742891309599)
,p_name=>'APEXAPP.COLUMN.AVG_ELAPSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3C9\ADE0 \ACBD\ACFC \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105168107207309598)
,p_name=>'APEXAPP.COLUMN.COMPONENT_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105169776719309599)
,p_name=>'APEXAPP.COLUMN.CONTEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE8\D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105167075824309597)
,p_name=>'APEXAPP.COLUMN.CURRENT_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105166721616309597)
,p_name=>'APEXAPP.COLUMN.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105169060757309599)
,p_name=>'APEXAPP.COLUMN.DISTINCT_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BCC4 \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105157918600309591)
,p_name=>'APEXAPP.COLUMN.EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105167860942309598)
,p_name=>'APEXAPP.COLUMN.ELAPSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACFC \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105170711434309600)
,p_name=>'APEXAPP.COLUMN.ENDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105168452818309598)
,p_name=>'APEXAPP.COLUMN.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105158011213309591)
,p_name=>'APEXAPP.COLUMN.ERRORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105170690151309600)
,p_name=>'APEXAPP.COLUMN.ERROR_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105166551650309597)
,p_name=>'APEXAPP.COLUMN.FEATURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105158688168309591)
,p_name=>'APEXAPP.COLUMN.FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105158444273309591)
,p_name=>'APEXAPP.COLUMN.FILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105171051669309600)
,p_name=>'APEXAPP.COLUMN.FILED_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105169508717309599)
,p_name=>'APEXAPP.COLUMN.FULL_PAGE_VIEWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \D398\C774\C9C0 \BDF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105168318217309598)
,p_name=>'APEXAPP.COLUMN.IR_SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('IR \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105167120290309597)
,p_name=>'APEXAPP.COLUMN.LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105167404394309598)
,p_name=>'APEXAPP.COLUMN.LAST_ACTIVITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105168654110309599)
,p_name=>'APEXAPP.COLUMN.MAX_ELAPSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \ACBD\ACFC \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105168882792309599)
,p_name=>'APEXAPP.COLUMN.MEDIAN_ELAPSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\AC04 \ACBD\ACFC \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105170277231309600)
,p_name=>'APEXAPP.COLUMN.MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105170304940309600)
,p_name=>'APEXAPP.COLUMN.MESSAGE_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105168575380309599)
,p_name=>'APEXAPP.COLUMN.MIN_ELAPSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C \ACBD\ACFC \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105170180581309600)
,p_name=>'APEXAPP.COLUMN.MOST_RECENT'
,p_message_language=>'ko'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105168250701309598)
,p_name=>'APEXAPP.COLUMN.NUM_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105169615969309599)
,p_name=>'APEXAPP.COLUMN.OCCURRENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105167926319309598)
,p_name=>'APEXAPP.COLUMN.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105169907860309600)
,p_name=>'APEXAPP.COLUMN.PAGE_EVENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105168040054309598)
,p_name=>'APEXAPP.COLUMN.PAGE_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105167526720309598)
,p_name=>'APEXAPP.COLUMN.PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105169242004309599)
,p_name=>'APEXAPP.COLUMN.PAGE_VIEWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105169447581309599)
,p_name=>'APEXAPP.COLUMN.PARTIAL_PAGE_VIEWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\BD84 \D398\C774\C9C0 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105170408344309600)
,p_name=>'APEXAPP.COLUMN.PK_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4  \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105158595117309591)
,p_name=>'APEXAPP.COLUMN.RATING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4F1\AE09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105170970148309600)
,p_name=>'APEXAPP.COLUMN.REASON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C720')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105158749387309591)
,p_name=>'APEXAPP.COLUMN.RESPONSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C751\B2F5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105170005847309600)
,p_name=>'APEXAPP.COLUMN.ROWS_FETCHED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\CD9C\B41C \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105158383507309591)
,p_name=>'APEXAPP.COLUMN.SCHEDULED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C815\C774 \C7A1\D798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105158296612309591)
,p_name=>'APEXAPP.COLUMN.STARTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105166656360309597)
,p_name=>'APEXAPP.COLUMN.STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105170500276309600)
,p_name=>'APEXAPP.COLUMN.SUCCESSFUL_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5\D55C \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105167796175309598)
,p_name=>'APEXAPP.COLUMN.TIMESTAMP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04\AE30\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105169344461309599)
,p_name=>'APEXAPP.COLUMN.TOTAL_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \D589 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105166939908309597)
,p_name=>'APEXAPP.COLUMN.UPDATED_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \C218\D589\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105166817007309597)
,p_name=>'APEXAPP.COLUMN.UPDATED_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105167621393309598)
,p_name=>'APEXAPP.COLUMN.USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105167370594309598)
,p_name=>'APEXAPP.COLUMN.USERNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105158836333309591)
,p_name=>'APEXAPP.COLUMN.USER_AGENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C5D0\C774\C804\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105167259426309598)
,p_name=>'APEXAPP.COLUMN.VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105168944620309599)
,p_name=>'APEXAPP.COLUMN.WEIGHTED_PERFORMANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C911\CE58 \C131\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105151590038309586)
,p_name=>'APEXAPP.DA.AFTER_CLOSE_DIALOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \B2EB\D798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105164419742309596)
,p_name=>'APEXAPP.DA.CANCEL_BUTTON.DIALOG_CANCEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105164992186309596)
,p_name=>'APEXAPP.DA.CHANGE_FILTERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \BCC0\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105164526666309596)
,p_name=>'APEXAPP.DA.CREATE_BUTTON.DIALOG_CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C0DD\C131 - \B300\D654\C0C1\C790 \B2EB\D798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105164673819309596)
,p_name=>'APEXAPP.DA.EDIT_REPORT.DIALOG_CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D3B8\C9D1 - \B300\D654\C0C1\C790 \B2EB\D798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105164718460309596)
,p_name=>'APEXAPP.DA.PERFORM_SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \C218\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105164854370309596)
,p_name=>'APEXAPP.DA.REFRESH_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C0C8\B85C\ACE0\CE68')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105154091052309588)
,p_name=>'APEXAPP.DATA_LOAD.CHAR_SET_ITEM_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \BB38\C790\C138\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105153609196309587)
,p_name=>'APEXAPP.ITEM.ACL_ROLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105177256081309605)
,p_name=>'APEXAPP.ITEM.ACL_ROLES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C561\C138\C2A4 \C81C\C5B4\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0 \AD00\B9AC\C790\B294 \C778\C99D\B41C \C0AC\C6A9\C790\AC00 \D2B9\C815 \C560\D50C\B9AC\CF00\C774\C158 \AE30\B2A5\C5D0 \C561\C138\C2A4\D558\C9C0 \BABB\D558\B3C4\B85D \C81C\D55C\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \C560\D50C\B9AC\CF00\C774\C158\C740 \C138 \AC00\C9C0 \B864(\C870\D68C\C790, \C81C\ACF5\C790 \BC0F \AD00\B9AC\C790)\C744 \C9C0\C6D0\D569\B2C8\B2E4.<p>'),
'<ul>',
unistr('  <li><strong>\C870\D68C\C790</strong> - \BAA8\B4E0 \C815\BCF4\C5D0 \B300\D55C \C77D\AE30 \C804\C6A9 \C561\C138\C2A4 \AD8C\D55C\C744 \AC00\C9C0\BA70 \BCF4\ACE0\C11C\B3C4 \BCFC \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C81C\ACF5\C790</strong> - \C815\BCF4\B97C \C0DD\C131, \D3B8\C9D1 \BC0F \C0AD\C81C\D560 \C218 \C788\C73C\BA70 \BCF4\ACE0\C11C\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('  <li><strong>\AD00\B9AC\C790</strong> - \C81C\ACF5\C790 \AD8C\D55C \C774\C678\C5D0 \C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\B3C4 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105177002140309605)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\B41C \BAA8\B4E0 \C0AC\C6A9\C790\B294 \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105177154318309605)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C0AC\C6A9\C790\AC00 \C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0 \C815\C758\B41C \ACBD\C6B0 <strong>\C544\B2C8\C624</strong>\B97C \C120\D0DD\D569\B2C8\B2E4. \C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0 \C5C6\B294 \C778\C99D\B41C \C0AC\C6A9\C790\B3C4 <strong>\C608</strong>\B97C \C120\D0DD\D558\BA74 \C774 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105175332218309603)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\D560 \B0A0\C9DC/\C22B\C790 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105175417764309604)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \D615\C2DD \B9C8\C2A4\D06C\B97C \C81C\ACF5\D560\C9C0 \B610\B294 \D45C\C900 \D615\C2DD \B9C8\C2A4\D06C\B97C \C0AC\C6A9\D560\C9C0 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105177842441309605)
,p_name=>'APEXAPP.ITEM.ATTACHMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105176852680309605)
,p_name=>'APEXAPP.ITEM.AUTOMATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105175568551309604)
,p_name=>'APEXAPP.ITEM.CHAR_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \BB38\C790\C138\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105174339643309603)
,p_name=>'APEXAPP.ITEM.COPY_PASTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \B370\C774\D130 \BCF5\C0AC \BC0F \BD99\C5EC\B123\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105175634206309604)
,p_name=>'APEXAPP.ITEM.CURRENCY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\D654 \AE30\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105175769187309604)
,p_name=>'APEXAPP.ITEM.CURRENCY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\AC00 \AD6D\C81C \D1B5\D654 \AE30\D638\B97C \D3EC\D568\D558\B294 \ACBD\C6B0 \C5EC\AE30\C5D0 \D574\B2F9 \AE30\D638\B97C \C785\B825\D558\C2ED\C2DC\C624. \C608\B97C \B4E4\C5B4, \B370\C774\D130\AC00 "&euro;1,234.56" \B610\B294 "&yen;1,234.56"\C744 \D3EC\D568\D558\B294 \ACBD\C6B0 "&euro;" \B610\B294 "&yen;"\C744 \C785\B825\D558\C2ED\C2DC\C624. \ADF8\B807\C9C0 \C54A\C73C\BA74 \B370\C774\D130\AC00 \C81C\B300\B85C \B85C\B4DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105174016632309603)
,p_name=>'APEXAPP.ITEM.DATA_LOAD_IMPORT_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C784\D3EC\D2B8 \CD9C\CC98')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105176058149309604)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C218\C810 \BB38\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105176183744309604)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C18C\C218\C810 \BB38\C790\B294 \C22B\C790\C758 \C815\C218 \BD80\BD84\ACFC \C18C\C218 \BD80\BD84\C744 \AD6C\BD84\D569\B2C8\B2E4.</p>'),
unistr('<p> \C18C\C218\C810 \BB38\C790\B85C \C5B4\B5A4 \BB38\C790\B4E0 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \C18C\C218\C810 \BB38\C790\B294 \B2E8\C77C \BC14\C774\D2B8\B85C \C9C0\C815\D574\C57C \D558\ACE0 \ADF8\B8F9 \AD6C\BD84 \AE30\D638\C640 \B2EC\B77C\C57C \D569\B2C8\B2E4. \ACF5\BC31\C740 \BB38\C790\B85C \AC04\C8FC\D558\C9C0\B9CC \C22B\C790\B098 \B2E4\C74C \BB38\C790\B294 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</p>'),
'<ul class="noIndent">',
unistr('<li>\D50C\B7EC\C2A4 \AE30\D638(+)</li>'),
unistr('<li>\D558\C774\D508(-)</li> '),
unistr('<li>\C5EC\B294 \AEBE\C1E0 \AE30\D638(<)</li>'),
unistr('<li>\B2EB\B294 \AEBE\C1E0 \AE30\D638(>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105153236131309587)
,p_name=>'APEXAPP.ITEM.DISPLAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105177981049309605)
,p_name=>'APEXAPP.ITEM.ENABLE_ATTACHEMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105174676136309603)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\C801 \B458\B7EC\C2F8\AE30 \BB38\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105153533728309587)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84\C790\B97C \C785\B825\D558\C2ED\C2DC\C624. \C774 \BB38\C790\B97C \C0AC\C6A9\D558\C5EC \B370\C774\D130 \AC12\C758 \C2DC\C791 \ACBD\ACC4\C640 \B05D \ACBD\ACC4\B97C \AD6C\BD84\D560 \C218 \C788\C2B5\B2C8\B2E4. \AD6C\BD84\C790\B97C \C9C0\C815\D560 \ACBD\C6B0 \B370\C774\D130 \C6CC\D06C\C20D\C740 \B370\C774\D130 \AC12\C758 \C2DC\C791 \ACBD\ACC4\C640 \B05D \ACBD\ACC4 \C55E\C5D0 \C788\B294 \ACF5\BC31\C744 \BB34\C2DC\D569\B2C8\B2E4. \C774 \C635\C158\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130 \AC12\C744 \C9C0\C815\B41C \AD6C\BD84\C790\B85C \BB36\C744 \C218\B3C4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105177745563309605)
,p_name=>'APEXAPP.ITEM.EXPERIENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\D5D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105175081492309603)
,p_name=>'APEXAPP.ITEM.FAILED_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D328\D55C \D589:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105153746870309587)
,p_name=>'APEXAPP.ITEM.FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105178029545309605)
,p_name=>'APEXAPP.ITEM.FILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105174151011309603)
,p_name=>'APEXAPP.ITEM.FILE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105174202073309603)
,p_name=>'APEXAPP.ITEM.FILE_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B85C\B4DC\D560 \D30C\C77C\C758 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105174705066309603)
,p_name=>'APEXAPP.ITEM.FIRST_ROW.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\C758 \CCAB\BC88\C9F8 \D589\C5D0 \C5F4 \C774\B984\C774 \D3EC\D568\B418\C5B4 \C788\C73C\BA74 \C774 \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105175869989309604)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AD6C\BD84 \AE30\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105175909714309604)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\ADF8\B8F9 \AD6C\BD84 \AE30\D638\B294 \C815\C218 \ADF8\B8F9\C744 \AD6C\BD84\D558\B294 \BB38\C790\C785\B2C8\B2E4. \C608\B97C \B4E4\BA74, \CC9C \B2E8\C704 \BC0F \BC31\B9CC \B2E8\C704\B97C \D45C\C2DC\D558\B294 \BB38\C790\C785\B2C8\B2E4.</p>'),
unistr('<p>\ADF8\B8F9 \AD6C\BD84 \AE30\D638\B85C \C5B4\B5A4 \BB38\C790\B4E0 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \ADF8\B8F9 \AD6C\BD84 \AE30\D638\B294 \B2E8\C77C \BC14\C774\D2B8\B85C \C9C0\C815\D574\C57C \D558\ACE0 \C18C\C218\C810 \BB38\C790\C640 \B2EC\B77C\C57C \D569\B2C8\B2E4. \ACF5\BC31\C740 \BB38\C790\B85C \AC04\C8FC\D558\C9C0\B9CC \C22B\C790\B098 \B2E4\C74C \BB38\C790\B294 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</p>'),
'<ul class="noIndent">',
unistr('<li>\D50C\B7EC\C2A4 \AE30\D638(+)</li>'),
unistr('<li>\D558\C774\D508(-)</li> '),
unistr('<li>\C5EC\B294 \AEBE\C1E0 \AE30\D638(<)</li>'),
unistr('<li>\B2EB\B294 \AEBE\C1E0 \AE30\D638(>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105174861092309603)
,p_name=>'APEXAPP.ITEM.INSERTED_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0BD\C785\B41C \D589:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105153807224309587)
,p_name=>'APEXAPP.ITEM.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105153434208309587)
,p_name=>'APEXAPP.ITEM.PASSWORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105178121154309606)
,p_name=>'APEXAPP.ITEM.RATING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4F1\AE09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105173807570309602)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984 \AE30\C5B5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105173989989309602)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\C774 \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D560 \ACBD\C6B0 \C560\D50C\B9AC\CF00\C774\C158\C740 \C774\B984\C774 "LOGIN_USERNAME_COOKIE"\C778 \C601\AD6C \BE0C\B77C\C6B0\C800 \CFE0\D0A4\C5D0 \C0AC\C6A9\C790 \C774\B984\C744 \C800\C7A5\D569\B2C8\B2E4.'),
unistr('\B2E4\C74C \BC88\C5D0 \B85C\ADF8\C778 \D398\C774\C9C0\B85C \C774\B3D9\D558\BA74'),
unistr('\C790\B3D9\C73C\B85C \C0AC\C6A9\C790 \C774\B984 \D544\B4DC\C5D0 \C774 \AC12\C774 \CC44\C6CC\C9D1\B2C8\B2E4.'),
'</p>',
'<p>',
unistr('\C0AC\C6A9\C790 \C774\B984\C774 \CFE0\D0A4\C5D0 \C774\BBF8 \C800\C7A5\B41C \C0C1\D0DC\C5D0\C11C \C774 \CCB4\D06C\BC15\C2A4\C758 \C120\D0DD\C744 \D574\C81C\D560 \ACBD\C6B0'),
unistr('\C560\D50C\B9AC\CF00\C774\C158\C740 \C0AC\C6A9\C790 \C774\B984\C744 \BE48 \AC12\C73C\B85C \ACB9\CCD0\C501\B2C8\B2E4.'),
unistr('\BE0C\B77C\C6B0\C800\C758 \AC1C\BC1C\C790 \B3C4\AD6C\B97C \C0AC\C6A9\D558\C5EC \CFE0\D0A4\B97C \C644\C804\D788 \C81C\AC70\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105178256318309606)
,p_name=>'APEXAPP.ITEM.RESPONSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C751\B2F5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105175176576309603)
,p_name=>'APEXAPP.ITEM.REVIEW_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\D1A0\D560 \D589:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105153081642309587)
,p_name=>'APEXAPP.ITEM.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105153135515309587)
,p_name=>'APEXAPP.ITEM.SEARCH.PLACEHOLDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105174412011309603)
,p_name=>'APEXAPP.ITEM.SEPARATOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \AE30\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105174526788309603)
,p_name=>'APEXAPP.ITEM.SEPARATOR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AD6C\BD84 \AE30\D638\B97C \C9C0\C815\D558\C2ED\C2DC\C624. \D0ED \AD6C\BD84 \AE30\D638\B85C\B294 <code>\005Ct</code>\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105175272249309603)
,p_name=>'APEXAPP.ITEM.SHOW_ADVANCED_SETTINGS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC\C5D0 \B300\D55C \ACE0\AE09 \C124\C815 \D45C\C2DC: \D1B5\D654 \AE30\D638, \C18C\C218\C810 \BB38\C790, \D30C\C77C \C778\CF54\B529 \B610\B294 \B0A0\C9DC \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105176921204309605)
,p_name=>'APEXAPP.ITEM.STARTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105153965185309588)
,p_name=>'APEXAPP.ITEM.STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105176556922309604)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790 \D14C\B9C8 \D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105176623909309604)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \ACBD\C6B0 \C77C\BC18 \C0AC\C6A9\C790\AC00 [\C0AC\C6A9\C790\C815\C758] \B9C1\D06C\B97C \C0AC\C6A9\D558\C5EC \C790\C2E0\B9CC\C758 \D14C\B9C8 \C2A4\D0C0\C77C\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105176301638309604)
,p_name=>'APEXAPP.ITEM.THEME_STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C2A4\D06C\D1B1 \D14C\B9C8 \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105176439495309604)
,p_name=>'APEXAPP.ITEM.THEME_STYLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D14C\B9C8 \C2A4\D0C0\C77C\C740 \BAA8\B4E0 \C0AC\C6A9\C790\C5D0\AC8C \C801\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105176212877309604)
,p_name=>'APEXAPP.ITEM.TIMEFRAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105174960113309603)
,p_name=>'APEXAPP.ITEM.UPDATED_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8\B41C \D589:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105153316020309587)
,p_name=>'APEXAPP.ITEM.USERNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105177366636309605)
,p_name=>'APEXAPP.ITEM.USERNAMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105177568399309605)
,p_name=>'APEXAPP.ITEM.USERNAMES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF64\B9C8, \C138\BBF8\CF5C\B860 \B610\B294 \ACF5\BC31\C73C\B85C \AD6C\BD84\B418\B294 \C0AC\C6A9\C790 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \AE30\C874 \B610\B294 \C911\BCF5 \C0AC\C6A9\C790 \C774\B984\C740 \C790\B3D9\C73C\B85C \BB34\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105177494287309605)
,p_name=>'APEXAPP.ITEM.USERNAMES.PLACEHOLDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5EC\AE30\C5D0 \C0AC\C6A9\C790 \C774\B984 \C785\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105177614364309605)
,p_name=>'APEXAPP.ITEM.USERNAME_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105178306572309606)
,p_name=>'APEXAPP.ITEM.USER_AGENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C5D0\C774\C804\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105176745937309604)
,p_name=>'APEXAPP.ITEM.VIEW_AS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105156057032309589)
,p_name=>'APEXAPP.LIST.ACCESS_CONTROL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105155934529309589)
,p_name=>'APEXAPP.LIST.ACTIVITY_REPORTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105180651696309607)
,p_name=>'APEXAPP.LIST.APP_ADMINISTRATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105155821174309589)
,p_name=>'APEXAPP.LIST.APP_CONFIGURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105156214396309589)
,p_name=>'APEXAPP.LIST.EMAIL_REPORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105156169456309589)
,p_name=>'APEXAPP.LIST.FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105180533060309607)
,p_name=>'APEXAPP.LIST.HOME_NAVIGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D0D0\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105156318118309589)
,p_name=>'APEXAPP.LIST.JOB_REPORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105180436417309607)
,p_name=>'APEXAPP.LIST.NAVIGATION_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105180721741309607)
,p_name=>'APEXAPP.LIST.NAVIGATION_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \BA54\B274')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105155718987309589)
,p_name=>'APEXAPP.LIST.USER_INTERFACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105180817738309607)
,p_name=>'APEXAPP.LIST_ENTRY.APP_ADMIN.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105156512627309590)
,p_name=>'APEXAPP.LIST_ENTRY.HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105156678861309590)
,p_name=>'APEXAPP.LIST_ENTRY.LOGOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105156489097309590)
,p_name=>'APEXAPP.LIST_ENTRY.STEP'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B2E8\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105178647207309606)
,p_name=>'APEXAPP.LOV.RPT_MAX_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B2F9 \D589 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105180155011309607)
,p_name=>'APEXAPP.LOV_ENTRY.ACKNOWLEDGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105179598044309607)
,p_name=>'APEXAPP.LOV_ENTRY.CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105180396731309607)
,p_name=>'APEXAPP.LOV_ENTRY.CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\ACB0\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105178855533309606)
,p_name=>'APEXAPP.LOV_ENTRY.COPY_PASTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC \BC0F \BD99\C5EC\B123\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105179130918309606)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D45C\C900 \D615\C2DD \B9C8\C2A4\D06C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105179293121309606)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_CUSTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B85C\B4DC\B41C \C5F4\C5D0 \B300\D55C \C0AC\C6A9\C790\C815\C758 \D615\C2DD \C81C\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105179664902309607)
,p_name=>'APEXAPP.LOV_ENTRY.EMAIL_ADDRESSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C8FC\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105179327418309606)
,p_name=>'APEXAPP.LOV_ENTRY.END_USER_THEME_SELECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \D14C\B9C8 \C2A4\D0C0\C77C\C744 \C120\D0DD\D558\B3C4\B85D \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105178933081309606)
,p_name=>'APEXAPP.LOV_ENTRY.FIRST_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8 \D589\C5D0 \C5F4 \C774\B984\C774 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105179901653309607)
,p_name=>'APEXAPP.LOV_ENTRY.NEGATIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C815\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105179834704309607)
,p_name=>'APEXAPP.LOV_ENTRY.NEUTRAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\B9BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105180019683309607)
,p_name=>'APEXAPP.LOV_ENTRY.NO_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105180261531309607)
,p_name=>'APEXAPP.LOV_ENTRY.OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105179796013309607)
,p_name=>'APEXAPP.LOV_ENTRY.POSITIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE0D\C815\C801')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105179483146309606)
,p_name=>'APEXAPP.LOV_ENTRY.REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105179052658309606)
,p_name=>'APEXAPP.LOV_ENTRY.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09 \C124\C815 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105178732956309606)
,p_name=>'APEXAPP.LOV_ENTRY.UPLOAD_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C5C5\B85C\B4DC(\CF64\B9C8 \AD6C\BD84(*.csv) \B610\B294 \D0ED \AD6C\BD84)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105182716995309609)
,p_name=>'APEXAPP.PAGE.ACTIVITY_DASHBOARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \B300\C2DC\BCF4\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105157236610309590)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \C0AC\C6A9\C790 \CD94\AC00 - \B2E8\ACC4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105157499947309590)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \C0AC\C6A9\C790 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105182321297309608)
,p_name=>'APEXAPP.PAGE.ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105182452002309609)
,p_name=>'APEXAPP.PAGE.ADMIN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD00\B9AC \D398\C774\C9C0\C5D0\C11C\B294 \C560\D50C\B9AC\CF00\C774\C158 \C18C\C720\C790(\AD00\B9AC\C790)\AC00 \C560\D50C\B9AC\CF00\C774\C158\C744 \AD6C\C131\D558\ACE0 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C6A9\B418\B294 \C77C\BC18 \B370\C774\D130\B97C \C720\C9C0\BCF4\C218\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C0AC\C6A9 \AC00\B2A5\D55C \C124\C815 \C911 \D558\B098\B97C \C120\D0DD\D558\BA74 \AD00\B9AC\C790\B294 \C560\D50C\B9AC\CF00\C774\C158\C774 \D45C\C2DC\B41C \BC29\BC95 \BC0F/\B610\B294 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C0AC\C6A9 \AC00\B2A5\D55C \AE30\B2A5\C744 \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774 \D398\C774\C9C0\B294 \AD00\B9AC\C790\B9CC \C561\C138\C2A4\D558\B3C4\B85D \C81C\D55C\B418\C5B4\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105182987158309609)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654 \B85C\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105183059805309609)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\B294 \C790\B3D9\D654 \B85C\ADF8\C5D0 \B300\D55C \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774\C804 \C790\B3D9\D654 \C2E4\D589\C5D0 \B300\D574 \AE30\B85D\B41C \C815\BCF4\B97C \AC80\D1A0\D569\B2C8\B2E4. \B85C\ADF8\C5D0\B294 \C2DC\C791 \BC0F \C885\B8CC \C2DC\AC04\AE30\B85D\C740 \BB3C\B860 \CC98\B9AC\B41C \D589\C5D0 \B300\D55C \C138\BD80\C815\BCF4(\C131\ACF5 \BC0F \C624\B958 \D3EC\D568)\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4. \CC98\B9AC\B41C \D589\C5D0 \B300\D55C \AC1C\BCC4 \BA54\C2DC\C9C0\B97C \BCF4\B824\BA74 \BA54\C2DC\C9C0\B85C \B4DC\B9B4\B2E4\C6B4\D569\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105182644573309609)
,p_name=>'APEXAPP.PAGE.CONFIGURATION_SETTINGS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD6C\C131 \C124\C815\C744 \C0AC\C6A9\D558\BA74 \C77C\BC18 \C0AC\C6A9\C790\AC00 \D2B9\C815 \AE30\B2A5\C744 \C0AC\C6A9\D560 \C218 \C788\AC8C(\C0AC\C6A9) \D558\AC70\B098 \C0AC\C6A9\D560 \C218 \C5C6\AC8C(\C0AC\C6A9 \C548\D568) \D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\D2B9\C815 \AE30\B2A5\C774 \C644\C804\D788 \C900\BE44\B418\C9C0 \C54A\C740 \ACBD\C6B0 \B610\B294 \C77C\C2DC\C801\C73C\B85C \C81C\AC70\D574\C57C \D558\B294 \ACBD\C6B0 <strong>\C0AC\C6A9 \C548\D568</strong>\C744 \B204\B985\B2C8\B2E4.'),
unistr('\C0AC\C6A9\D560 \C218 \C788\AC8C \C124\C815\D574\C57C \D558\B294 \ACBD\C6B0 <strong>\C0AC\C6A9</strong>\C744 \D074\B9AD\B9CC \D558\BA74 \B429\B2C8\B2E4.</p>'),
unistr('<p><em><strong>\CC38\ACE0:</strong> \C5EC\AE30\C5D0\C11C \BCC0\ACBD\D55C \B0B4\C6A9\C740 \D604\C7AC \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589 \C911\C778 \AC1C\BCC4 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \BC18\C601\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\AC00 \C0AC\C778\C544\C6C3\D558\ACE0 \B2E4\C2DC \C0AC\C778\C778\D558\BA74 \C218\C815\B41C \AE30\B2A5 \C124\C815\C774 \D638\CD9C\B429\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105184016406309610)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105184180865309610)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C778\C99D\B41C \BAA8\B4E0 \C0AC\C6A9\C790\C5D0 \B300\D574 \C801\D569\D55C \C120\D0DD\C0AC\D56D\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('<strong>\C544\B2C8\C624</strong>\B97C \C120\D0DD\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C774 \B354 \C548\C804\D574\C9C0\AE30 \B54C\BB38\C5D0 \C9C0\C815\B41C \C0AC\C6A9\C790\B9CC \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\D558\C9C0\B9CC \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\ADDC\BAA8 \C0AC\C6A9\C790 \CEE4\BBA4\B2C8\D2F0\AC00 \C788\C5B4\C11C \C0AC\C6A9\C790\B97C \C720\C9C0\D558\B294 \AC83\C774 \BD80\B2F4\C2A4\B7EC\C6B4 \ACBD\C6B0 <strong>\C608</strong>\B97C \B20C\B7EC \C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\C640 \C81C\ACF5\C790\B9CC \B4E4\C5B4\C62C \C218 \C788\AC8C \D560 \C218 \C788\C2B5\B2C8\B2E4.<br>'),
unistr('<strong>\C608</strong>\B97C \C120\D0DD\D558\B294 \ACBD\C6B0 \C0AC\C6A9\C790 \BAA9\B85D\C5D0 \D3EC\D568\B418\C9C0 \C54A\C740 \C0AC\C6A9\C790\B97C \C5B4\B5BB\AC8C \CC98\B9AC\D560\C9C0\B3C4 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\C790 \C774\B984\C5D0 \C804\C790\BA54\C77C \C8FC\C18C \B610\B294 \C601\C22B\C790 \AC12\C744 \C0AC\C6A9\D558\B3C4\B85D \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('\C77C\BC18\C801\C73C\B85C \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C Oracle Access Manager \B610\B294 SSO\C640 \AC19\C740 \C911\C559\D654\B41C \C778\C99D \CCB4\ACC4\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 \B610\B294 \C774\B97C \C0AC\C6A9\D558\B3C4\B85D \AD6C\C131\B41C \ACBD\C6B0 \C774 \C124\C815\C744 <strong>\C804\C790\BA54\C77C \C8FC\C18C</strong>\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p><em><strong>\CC38\ACE0:</strong> \C774 \C560\D50C\B9AC\CF00\C774\C158\C740 \C870\D68C\C790, \C81C\ACF5\C790, \AD00\B9AC\C790\B85C \AD6C\C131\B41C \C138 \AC00\C9C0 \C561\C138\C2A4 \B808\BCA8\C744 \C9C0\C6D0\D569\B2C8\B2E4.'),
'<ul>',
unistr('  <li><strong>\C870\D68C\C790</strong> - \BAA8\B4E0 \C815\BCF4\C5D0 \B300\D55C \C77D\AE30 \C804\C6A9 \C561\C138\C2A4 \AD8C\D55C\C774 \C788\C73C\BA70 \BCF4\ACE0\C11C\B3C4 \BCFC \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C81C\ACF5\C790</strong> - \C815\BCF4\B97C \C0DD\C131, \D3B8\C9D1, \C0AD\C81C\D560 \C218 \C788\ACE0 \BCF4\ACE0\C11C\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('  <li><strong>\AD00\B9AC\C790</strong>- \C81C\ACF5\C790 \AE30\B2A5 \C774\C678\C5D0\B3C4 \C560\D50C\B9AC\CF00\C774\C158\C758 [\AD00\B9AC] \C139\C158\C5D0 \C561\C138\C2A4\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105183510541309609)
,p_name=>'APEXAPP.PAGE.ERROR_LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C624\B958 \B85C\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105183655816309609)
,p_name=>'APEXAPP.PAGE.ERROR_LOG.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\B294 \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \B85C\AE45\D55C \C608\C0C1\CE58 \C54A\C740 \BAA8\B4E0 \C624\B958\C5D0 \B300\D55C \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>\C5F4 \C81C\BAA9\C744 \B20C\B7EC \B370\C774\D130\B97C \C815\B82C\D558\ACE0 \D544\D130\B9C1\D558\AC70\B098 <strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \C5F4 \D45C\C2DC \BC0F \B2E4\C591\D55C \CD94\AC00 \ACE0\AE09 \AE30\B2A5\C744 \C0AC\C6A9\C790\C815\C758\D569\B2C8\B2E4. \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105184325927309610)
,p_name=>'APEXAPP.PAGE.FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105184469307309610)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105184589937309610)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p><strong>\CCA8\BD80 \C0AC\C6A9</strong> - [\C608]\C778 \ACBD\C6B0 \C0AC\C6A9\C790\AC00 \D53C\B4DC\BC31\C744 \C704\D574 \CCA8\BD80\B97C \C5C5\B85C\B4DC\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105157318820309590)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SUBMITTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C81C\CD9C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105157035312309590)
,p_name=>'APEXAPP.PAGE.GLOBAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105156722184309590)
,p_name=>'APEXAPP.PAGE.HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105181472660309608)
,p_name=>'APEXAPP.PAGE.HOME.HELP.FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C758 \BAA8\B4E0 \D398\C774\C9C0\C5D0\C11C \D0D0\C0C9 \D45C\C2DC\C904\C5D0 \C788\B294 \D53C\B4DC\BC31 \C544\C774\CF58( <span class="fa fa-comment-o" aria-hidden="true"></span> )\C744 \B20C\B7EC \C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\C5D0 \B300\D55C \D53C\B4DC\BC31\C744 \B0A8\AE38 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105181298345309608)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIDE_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C758 \D648 \D398\C774\C9C0\C785\B2C8\B2E4. \CE74\B4DC\B97C \B20C\B7EC \C560\D50C\B9AC\CF00\C774\C158\C758 \B2E4\B978 \D398\C774\C9C0\C5D0 \C561\C138\C2A4\D558\AC70\B098 \D398\C774\C9C0 \CE21\BA74\C5D0 \C788\B294 \D0D0\C0C9 \BA54\B274\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105181847150309608)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIGNOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\D0D0\C0C9 \D45C\C2DC\C904\C5D0\C11C \C774\B984 \B4DC\B86D\B2E4\C6B4\C744 \B20C\B7EC \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C778\C544\C6C3\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105181725778309608)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TIMEZONE'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\D0D0\C0C9 \D45C\C2DC\C904\C758 \C0AC\C6A9\C790 \BA54\B274( <span class="fa fa-user" aria-hidden="true"></span> )\B97C \B20C\B7EC \C2DC\AC04\B300 \D658\ACBD\C124\C815\C744 \C5C5\B370\C774\D2B8\D558\ACE0 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C778\C544\C6C3\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105181175966309608)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105181382427309608)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TOP_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C758 \D648 \D398\C774\C9C0\C785\B2C8\B2E4. \CE74\B4DC\B97C \B20C\B7EC \C560\D50C\B9AC\CF00\C774\C158\C758 \B2E4\B978 \D398\C774\C9C0\C5D0 \C561\C138\C2A4\D558\AC70\B098 \D398\C774\C9C0 \B9E8 \C704\C5D0 \C788\B294 \D0D0\C0C9 \BA54\B274\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105181631347309608)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0 \C624\B978\CABD \C704\C5D0 \C788\B294 \D0D0\C0C9 \D45C\C2DC\C904\C758 \C0AC\C6A9\C790 \BA54\B274( <span class="fa fa-user" aria-hidden="true"></span> )\B97C \B20C\B7EC \C0AC\C6A9\C790 \D504\B85C\D30C\C77C\C5D0 \C561\C138\C2A4\D558\ACE0 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C778\C544\C6C3\D569\B2C8\B2E4.<br>'),
unistr('<strong>\B0B4 \D504\B85C\D30C\C77C \BCF4\AE30</strong>\B97C \B204\B974\BA74 <strong>\D504\B85C\D30C\C77C \C5C5\B370\C774\D2B8</strong>\B97C \B20C\B7EC \AC1C\C778 \C138\BD80\C815\BCF4\B97C \C785\B825\D558\ACE0 \C0AC\C9C4\C774\B098 \C544\BC14\D0C0\B97C \C5C5\B85C\B4DC\D560 \C218 \C788\AC8C \B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105181574060309608)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER_TIMEZONE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D0D0\C0C9 \D45C\C2DC\C904\C5D0\C11C \C0AC\C6A9\C790 \BA54\B274( <span class="fa fa-user" aria-hidden="true"></span> )\B97C \B20C\B7EC \C0AC\C6A9\C790 \D504\B85C\D30C\C77C\C5D0 \C561\C138\C2A4\D558\ACE0, \C2DC\AC04\B300 \D658\ACBD\C124\C815\C744 \C5C5\B370\C774\D2B8\D558\ACE0, \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C778\C544\C6C3\D569\B2C8\B2E4.<br>'),
unistr('<strong>\B0B4 \D504\B85C\D30C\C77C \BCF4\AE30</strong>\B97C \B204\B974\BA74 <strong>\D504\B85C\D30C\C77C \C5C5\B370\C774\D2B8</strong>\B97C \B20C\B7EC \AC1C\C778 \C138\BD80\C815\BCF4\B97C \C785\B825\D558\ACE0 \C0AC\C9C4\C774\B098 \C544\BC14\D0C0\B97C \C5C5\B85C\B4DC\D560 \C218 \C788\AC8C \B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105182024612309608)
,p_name=>'APEXAPP.PAGE.IG.HELP.EDITABLE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C2DD \ADF8\B9AC\B4DC \B0B4\C5D0\C11C \B370\C774\D130\B97C \C9C1\C811 \C0BD\C785, \C5C5\B370\C774\D2B8 \BC0F \C0AD\C81C\D560 \C218 \C788\C2B5\B2C8\B2E4.<br>'),
unistr('  [\D589 \CD94\AC00] \B2E8\CD94\B97C \B20C\B7EC \C0C8 \D589\C744 \C0BD\C785\D569\B2C8\B2E4.<br>'),
unistr('  \C140\C744 \B450 \BC88 \B204\B974\AC70\B098 <strong>\D3B8\C9D1</strong> \B2E8\CD94\B97C \B20C\B7EC \C2A4\D504\B808\B4DC\C2DC\D2B8\C5D0\C11C \B370\C774\D130\B97C \D3B8\C9D1\D560 \B54C\C640 \BE44\C2B7\D558\AC8C \B370\C774\D130 \AC12\C744 \C5C5\B370\C774\D2B8\D569\B2C8\B2E4.</p>'),
'',
unistr('<p>\BCF4\ACE0\C11C \B9E8 \C704\C5D0 \C788\B294 [\D589 \C791\C5C5] \BA54\B274(<span class="fa fa-bars" aria-hidden="true"></span>)\B97C \C0AC\C6A9\D558\C5EC \C120\D0DD\D55C \D589\C744 \BCF5\C81C, \C0AD\C81C, \C0C8\B85C\ACE0\CE68 \B610\B294 \CDE8\C18C\D560 \C218 \C788\C2B5\B2C8\B2E4.<br> '),
unistr('  \AC1C\BCC4 \D589\C5D0\C11C [\D589 \C791\C5C5] \BA54\B274\B97C \C0AC\C6A9\D558\C5EC \B2E8\C77C \D589 \BDF0\C5D0 \C561\C138\C2A4\D558\AC70\B098 \C0C8 \D589\C744 \CD94\AC00\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\B370\C774\D130\B97C \CC3E\C73C\B824\BA74 \AC80\C0C9 \B300\D654\C0C1\C790\C5D0 \AC80\C0C9\C5B4\B97C \C785\B825\D558\AC70\B098 \C5F4 \BA38\B9AC\AE00\C744 \B20C\B7EC \BC18\D658\B418\B294 \B808\CF54\B4DC\B97C \C81C\D55C\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \B2E4\C591\D55C \AE30\B2A5\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4. \C5EC\AE30\C5D0\B294 \C5F4 \D45C\C2DC/\C228\AE30\AE30 \BC0F \C5F4 \D45C\C2DC \C21C\C11C \C120\D0DD\ACFC \B2E4\C591\D55C \B370\C774\D130 \BC0F \D615\C2DD \C9C0\C815 \AE30\B2A5\C774 \D3EC\D568\B429\B2C8\B2E4. \CC28\D2B8 \C635\C158\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130\C5D0 \B300\D55C \BDF0\B97C \CD94\AC00\B85C \C815\C758\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\C0AC\C6A9\C790\C815\C758\B97C \C800\C7A5\D558\B824\BA74 \BCF4\ACE0\C11C\B97C \C120\D0DD\D558\AC70\B098 \B2E4\C6B4\B85C\B4DC\B97C \B20C\B7EC \B370\C774\D130\B97C \C5B8\B85C\B4DC\D569\B2C8\B2E4.<p>'),
'',
unistr('<p>\CD94\AC00 \C815\BCF4\B97C \BCF4\B824\BA74 [\C791\C5C5] \BA54\B274 \C544\B798\C5D0 \C788\B294 [\B3C4\C6C0\B9D0]\C744 \B204\B985\B2C8\B2E4.</p> '),
'',
unistr('<p>\B300\D654\C2DD \ADF8\B9AC\B4DC\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105182181715309608)
,p_name=>'APEXAPP.PAGE.IG.HELP.READONLY'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B370\C774\D130\B97C \AC80\C0C9\D558\B824\BA74 \AC80\C0C9 \B300\D654\C0C1\C790\C5D0 \AC80\C0C9\C5B4\B97C \C785\B825\D558\AC70\B098 \C5F4 \C81C\BAA9\C744 \B20C\B7EC \BC18\D658\B418\B294 \B808\CF54\B4DC\B97C \C81C\D55C\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \B2E4\C591\D55C \AE30\B2A5\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4. \C5EC\AE30\C5D0\B294 \D45C\C2DC\B418\AC70\B098 \C228\ACA8\C9C4 \C5F4 \C120\D0DD, \D45C\C2DC \C2DC\D000\C2A4, \B2E4\C591\D55C \B370\C774\D130 \BC0F \D615\C2DD \C9C0\C815 \AE30\B2A5\C774 \D3EC\D568\B429\B2C8\B2E4. \CC28\D2B8 \C635\C158\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130\C5D0 \B300\D55C \BDF0\B97C \CD94\AC00\B85C \C815\C758\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\C0AC\C6A9\C790\C815\C758 \B0B4\C6A9\C744 \C800\C7A5\D558\B824\BA74 \BCF4\ACE0\C11C\B97C \C120\D0DD\D558\AC70\B098 \B2E4\C6B4\B85C\B4DC\B97C \B20C\B7EC \B370\C774\D130\B97C \C5B8\B85C\B4DC\D569\B2C8\B2E4.<p>'),
'<br>',
unistr('<p>\CD94\AC00 \C815\BCF4\B97C \BCF4\B824\BA74 [\C791\C5C5] \BA54\B274 \C544\B798\C5D0 \C788\B294 [\B3C4\C6C0\B9D0]\C744 \B204\B974\C2ED\C2DC\C624.</p>'),
'',
unistr('<p>\B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105181937481309608)
,p_name=>'APEXAPP.PAGE.IR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B370\C774\D130\B97C \AC80\C0C9\D558\B824\BA74 \AC80\C0C9 \B300\D654\C0C1\C790\C5D0 \AC80\C0C9\C5B4\B97C \C785\B825\D558\AC70\B098 \C5F4 \C81C\BAA9\C744 \B20C\B7EC \BC18\D658\B418\B294 \B808\CF54\B4DC\B97C \C81C\D55C\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \B2E4\C591\D55C \AE30\B2A5\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4. \C5EC\AE30\C5D0\B294 \D45C\C2DC\B418\AC70\B098 \C228\ACA8\C9C4 \C5F4 \C120\D0DD, \D45C\C2DC \C2DC\D000\C2A4\C640 \B2E4\C591\D55C \B370\C774\D130 \BC0F \D615\C2DD \C9C0\C815 \AE30\B2A5\C774 \D3EC\D568\B429\B2C8\B2E4. \CC28\D2B8, \ADF8\B8F9 \AE30\C900, \D53C\BC97 \C635\C158\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130 \BDF0\B97C \CD94\AC00\B85C \C815\C758\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\C0AC\C6A9\C790\C815\C758 \B0B4\C6A9\C744 \C800\C7A5\D558\B824\BA74 \BCF4\ACE0\C11C\B97C \C120\D0DD\D558\AC70\B098 \B2E4\C6B4\B85C\B4DC\B97C \B20C\B7EC \B370\C774\D130\B97C \C5B8\B85C\B4DC\D569\B2C8\B2E4. \AC00\C785 \C2DC \C815\AE30\C801\C73C\B85C \B370\C774\D130\B97C \C804\C1A1\D560 \C804\C790\BA54\C77C \C8FC\C18C\C640 \C2DC\AC04\BC94\C704\B97C \C785\B825\D569\B2C8\B2E4.<p>'),
'',
unistr('<p>\CD94\AC00 \C815\BCF4\B97C \BCF4\B824\BA74 [\C791\C5C5] \BA54\B274\C758 \C544\B798\CABD\C5D0 \C788\B294 [\B3C4\C6C0\B9D0]\C744 \B204\B974\C2ED\C2DC\C624.</p>'),
'',
unistr('<p>\B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105156822626309590)
,p_name=>'APEXAPP.PAGE.LOGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105156957122309590)
,p_name=>'APEXAPP.PAGE.LOGIN.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 - \B85C\ADF8\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105183799436309610)
,p_name=>'APEXAPP.PAGE.LOG_MESSAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105184690577309610)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105184734250309610)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\B294 \C560\D50C\B9AC\CF00\C774\C158 \B0B4 \BAA8\B4E0 \C77C\BC18 \D398\C774\C9C0\C5D0\C11C \D53C\B4DC\BC31\C744 \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774 \BCF4\ACE0\C11C\B294 \C785\B825\D55C \D53C\B4DC\BC31\ACFC \AD00\B9AC\C790\AC00 \C785\B825\D55C \C751\B2F5 \BC0F \D53C\B4DC\BC31 \C0C1\D0DC\B97C \BCF4\C5EC\C90D\B2C8\B2E4.</p>'),
unistr('<p>\D3B8\C9D1 \C544\C774\CF58(\B178\B780\C0C9 \C5F0\D544)\C744 \B20C\B7EC \C751\B2F5\C744 \C785\B825\D558\AC70\B098 \D53C\B4DC\BC31 \C0C1\D0DC\B97C \C5C5\B370\C774\D2B8\D569\B2C8\B2E4.</p>'),
unistr('<p><em><strong>\CC38\ACE0:</strong> \D53C\B4DC\BC31 \C218\C2E0\C790\AC00 \C815\C758\B418\C5B4 \C788\C73C\BA74 \D53C\B4DC\BC31 \C81C\CD9C \B0B4\C6A9\B3C4 \C804\C790\BA54\C77C\C744 \D1B5\D574 \D53C\B4DC\BC31 \C218\C2E0\C790 \BAA9\B85D\C758 \C804\C790\BA54\C77C \C8FC\C18C\B85C \C804\C1A1\B429\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105183857979309610)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C561\C138\C2A4 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105183909080309610)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\B294 \C560\D50C\B9AC\CF00\C774\C158 \C0AC\C6A9\C790 \BC0F \BD80\C5EC\B41C \C561\C138\C2A4 \B808\BCA8\C5D0 \B300\D55C \BCF4\ACE0\C11C\B97C \BCF4\C5EC\C90D\B2C8\B2E4.</p>'),
unistr('<p>\C5F4 \C81C\BAA9\C744 \B20C\B7EC \B370\C774\D130\B97C \C815\B82C \BC0F \D544\D130\B9C1\D558\AC70\B098 <strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \C5F4 \D45C\C2DC \BC0F \B2E4\C591\D55C \CD94\AC00 \ACE0\AE09 \AE30\B2A5\C744 \C0AC\C6A9\C790\C815\C758\D569\B2C8\B2E4.<br>'),
unistr('\B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\C790 \C138\BD80\C815\BCF4 \BC0F \C561\C138\C2A4 \B808\BCA8\C744 \D3B8\C9D1\D558\AC70\B098 \C0AC\C6A9\C790\B97C \C0AD\C81C\D558\B824\BA74 \D3B8\C9D1 \C544\C774\CF58(\B178\B780\C0C9 \C5F0\D544)\C744 \B204\B985\B2C8\B2E4.</p>'),
unistr('<p>\C0C8 \C0AC\C6A9\C790 \BC0F \C774\B4E4\C758 \C561\C138\C2A4 \B808\BCA8\C744 \CD94\AC00\D558\B824\BA74 \BCF4\ACE0\C11C \B9E8 \C704\C5D0\C11C <strong>\C0AC\C6A9\C790 \CD94\AC00</strong>\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105184283655309610)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS_FORM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D3FC\C744 \C0AC\C6A9\D558\C5EC \C0AC\C6A9\C790, \C0AC\C6A9\C790\C758 \C804\C790\BA54\C77C \C8FC\C18C\B97C \C785\B825\D558\ACE0 \C561\C138\C2A4 \B808\BCA8\C744 \C124\C815\D569\B2C8\B2E4.'),
unistr('<em>\C561\C138\C2A4 \C81C\C5B4 \AD6C\C131</em> \C544\B798\C5D0\C11C \C815\C758\B41C \C774 \C124\C815\C740 \C0AC\C6A9\C790 \C774\B984\C774 \C804\C790\BA54\C77C \C8FC\C18C\C5EC\C57C \D558\B294\C9C0 \B610\B294 \C601\C22B\C790 \D56D\BAA9\C77C \C218 \C788\B294\C9C0\B97C \ACB0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C560\D50C\B9AC\CF00\C774\C158\C740 \C870\D68C\C790, \C81C\ACF5\C790, \AD00\B9AC\C790\B85C \AD6C\C131\B41C \C138 \AC00\C9C0 \C561\C138\C2A4 \B808\BCA8\C744 \C9C0\C6D0\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\C870\D68C\C790</strong> - \BAA8\B4E0 \C815\BCF4\C5D0 \B300\D55C \C77D\AE30 \C804\C6A9 \C561\C138\C2A4 \AD8C\D55C\C774 \C788\C73C\BA70 \BCF4\ACE0\C11C\B3C4 \BCFC \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C81C\ACF5\C790</strong> - \C815\BCF4\B97C \C0DD\C131, \D3B8\C9D1, \C0AD\C81C\D560 \C218 \C788\ACE0 \BCF4\ACE0\C11C\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('  <li><strong>\AD00\B9AC\C790</strong> - \C81C\ACF5\C790 \AE30\B2A5 \C774\C678\C5D0\B3C4 \C560\D50C\B9AC\CF00\C774\C158\C758 [\AD00\B9AC] \C139\C158\C5D0 \C561\C138\C2A4\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
'</ul>',
unistr('<p>\AE30\C874 \C0AC\C6A9\C790\B97C \D3B8\C9D1\D558\B294 \ACBD\C6B0 \C0AC\C6A9\C790 \ACC4\C815\C744 \C7A0\AC00 \C774\B4E4\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C561\C138\C2A4\D558\C9C0 \BABB\D558\B3C4\B85D \D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p><em><strong>\CC38\ACE0:</strong>   Oracle Application Express \ACC4\C815\C744 \C0AC\C6A9\D558\B294 \ACBD\C6B0 \C791\C5C5\C601\C5ED \AD00\B9AC\C790\B294 \C5EC\AE30\C5D0 \C785\B825\B41C \C0AC\C6A9\C790\B3C4 \BE44\BC00\BC88\D638\B97C \C124\C815\D560 \C218 \C788\B294 \C77C\BC18 \C0AC\C6A9\C790\B85C \C815\C758\D574\C57C \D569\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105182265208309608)
,p_name=>'APEXAPP.PAGE.MD.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \BCF4\ACE0\C11C \D398\C774\C9C0\C5D0\B294 \D398\C774\C9C0 \CE21\BA74 \C120\D0DD\AE30\C758 \AE30\BCF8 \B808\CF54\B4DC\AC00 \D45C\C2DC\B429\B2C8\B2E4. '),
unistr('  \C815\C758\B41C \B9C8\C2A4\D130 \B808\CF54\B4DC \BC0F \B514\D14C\C77C \B808\CF54\B4DC\B97C \D655\C778\D558\B824\BA74 \B808\CF54\B4DC\B97C \C120\D0DD\D569\B2C8\B2E4.<br> '),
unistr('  \B9C8\C2A4\D130 \B808\CF54\B4DC\B97C \D3B8\C9D1\D558\B824\BA74 \D3B8\C9D1 \C544\C774\CF58(<span class="fa fa-pencil-square-o" aria-hidden="true"></span>)\C744 \B204\B985\B2C8\B2E4.'),
unistr('  \B514\D14C\C77C \B808\CF54\B4DC\B97C \D3B8\C9D1\D558\B824\BA74 \AC01 \D589\C758 \B9E8 \C55E\C5D0 \C788\B294 \C5F0\D544\C744 \B204\B985\B2C8\B2E4.</p>'),
unistr('<p>\C120\D0DD\AE30\C5D0 \D45C\C2DC\B418\B294 \B370\C774\D130\B97C \C81C\D55C\D558\B824\BA74 \AC80\C0C9 \B300\D654\C0C1\C790\C5D0 \AC80\C0C9\C5B4\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
'',
unistr('<p>\C0C8 \B9C8\C2A4\D130 \B808\CF54\B4DC\B97C \CD94\AC00\D558\B824\BA74 \D398\C774\C9C0 \C0C1\B2E8\C758 <strong>\C0DD\C131</strong>\C744 \B204\B985\B2C8\B2E4.'),
unistr('  \B514\D14C\C77C \B808\CF54\B4DC\B97C \CD94\AC00\D558\B824\BA74 \B514\D14C\C77C \C601\C5ED \C0C1\B2E8\C758 \B354\D558\AE30 \C544\C774\CF58(+)\C744 \B204\B985\B2C8\B2E4.</p>'),
'',
unistr('<p>\C774\C804\C5D0 \C815\C758\B41C \AC80\C0C9\C5B4\B97C \C81C\AC70\D558\C5EC \D398\C774\C9C0\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 \D398\C774\C9C0 \C0C1\B2E8\C758 <strong>\C7AC\C124\C815</strong>\C744 \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105183376981309609)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C131\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105183438094309609)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\B294 \D398\C774\C9C0 \C131\B2A5 \BC0F \C778\AE30\C5D0 \B300\D55C \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C81C\ACF5\D569\B2C8\B2E4. \C774 \BCF4\ACE0\C11C\B294 \C911\AC04 \ACBD\ACFC \C2DC\AC04\ACFC \D398\C774\C9C0 \BDF0 \C218\B97C \ACF1\D558\C5EC \ACC4\C0B0\B41C <strong>\AC00\C911 \C131\B2A5</strong>\BCC4\B85C \C815\B82C\B429\B2C8\B2E4.</p>'),
unistr('<p>\D544\C694\C5D0 \B530\B77C \D398\C774\C9C0 \B9E8 \C704\C5D0\C11C \BCF4\ACE0 \C2DC\AC04\BC94\C704(\AE30\BCF8\AC12=1\C77C)\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \C81C\BAA9\C744 \B20C\B7EC \B370\C774\D130\B97C \C815\B82C\D558\ACE0 \D544\D130\B9C1\D558\AC70\B098 <strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \C5F4 \D45C\C2DC \BC0F \B2E4\C591\D55C \CD94\AC00 \ACE0\AE09 \AE30\B2A5\C744 \C0AC\C6A9\C790\C815\C758\D569\B2C8\B2E4. \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105183117352309609)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105183244057309609)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\B294 \AC00\C7A5 \B9CE\C740 \CD5C\ADFC \D398\C774\C9C0 \BDF0\C5D0 \B300\D55C \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>\D544\C694\C5D0 \B530\B77C \D398\C774\C9C0 \B9E8 \C704\C5D0\C11C \BCF4\ACE0 \C2DC\AC04\BC94\C704(\AE30\BCF8\AC12=1\C77C)\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \C81C\BAA9\C744 \B20C\B7EC \B370\C774\D130\B97C \C815\B82C \BC0F \D544\D130\B9C1\D558\AC70\B098 <strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \C5F4 \D45C\C2DC \BC0F \B2E4\C591\D55C \CD94\AC00 \ACE0\AE09 \AE30\B2A5\C744 \C0AC\C6A9\C790\C815\C758\D569\B2C8\B2E4. \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105182504140309609)
,p_name=>'APEXAPP.PAGE.THEME_SELECTOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \AE30\BCF8 \C0C9\C0C1 \CCB4\ACC4\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\C77C\BC18 \C0AC\C6A9\C790\AC00 \D14C\B9C8 \C2A4\D0C0\C77C\C744 \C120\D0DD\D558\B3C4\B85D \D5C8\C6A9</strong>\C744 \C120\D0DD\D55C \ACBD\C6B0 \AC01 \C77C\BC18 \C0AC\C6A9\C790\B294 \D648 \D398\C774\C9C0\C758 \C67C\CABD \C544\B798\C5D0 \C788\B294 <em>\C0AC\C6A9\C790\C815\C758</em> \B9C1\D06C\B97C \B20C\B7EC \C0AC\C6A9 \AC00\B2A5\D55C \D14C\B9C8 \C2A4\D0C0\C77C \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105157157888309590)
,p_name=>'APEXAPP.PAGE.TOP_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704 \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105182870111309609)
,p_name=>'APEXAPP.PAGE.TOP_USERS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \BCF4\ACE0\C11C \BC0F \CC28\D2B8\B97C \C0AC\C6A9\D558\C5EC \C9C0\C815\B41C \C2DC\AC04\BC94\C704 \B3D9\C548 \D398\C774\C9C0 \BDF0\AC00 \AC00\C7A5 \B9CE\C740 \C0AC\C6A9\C790\B97C \D655\C778\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\BCF4\ACE0 \C2DC\AC04\BC94\C704(\AE30\BCF8\AC12=1\C77C)\C744 \C120\D0DD\D558\ACE0 \D398\C774\C9C0 \B9E8 \C704\C758 \BCF4\ACE0\C11C \BC0F \CC28\D2B8 \C544\C774\CF58 \C911\C5D0\C11C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\B300\D654\C2DD \BCF4\ACE0\C11C\C758 \ACBD\C6B0 \AC80\C0C9 \D544\B4DC\B97C \C0AC\C6A9\D558\AC70\B098 <strong>\C0AC\C6A9\C790</strong> \C5F4 \C81C\BAA9\C744 \C120\D0DD\D558\C5EC \D2B9\C815 \C0AC\C6A9\C790\B97C \C120\D0DD\D569\B2C8\B2E4. \D45C\C2DC\B418\AC70\B098 \C228\ACA8\C9C4 \C5F4, \D398\C774\C9C0\BCC4 \D589, \D544\D130 \B4F1\ACFC \AC19\C740 <strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \B2E4\C591\D55C \AE30\B2A5\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4. \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105173204188309602)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0 \C0AC\C6A9\C790 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105173311361309602)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105171524418309601)
,p_name=>'APEXAPP.PROCESS.CLEAR_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \CE90\C2DC \BE44\C6B0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105155171942309588)
,p_name=>'APEXAPP.PROCESS.CLOSE_DIALOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \B2EB\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105173136516309602)
,p_name=>'APEXAPP.PROCESS.CREATE_COLLECTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C74C \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105155452611309589)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105155516126309589)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31\C774 \C0AD\C81C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105173092747309602)
,p_name=>'APEXAPP.PROCESS.DML_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D3FC \CC98\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105173726880309602)
,p_name=>'APEXAPP.PROCESS.GET_FILE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C ID \AC00\C838\C624\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105172738545309602)
,p_name=>'APEXAPP.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8 \C138\BD80\C815\BCF4 \AC00\C838\C624\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105172017255309601)
,p_name=>'APEXAPP.PROCESS.GET_NEXT_PREV_PK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B610\B294 \C774\C804 \AE30\BCF8 \D0A4 \AC12 \AC00\C838\C624\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105171471304309601)
,p_name=>'APEXAPP.PROCESS.GET_USERNAME_COOKIE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984 \CFE0\D0A4 \AC00\C838\C624\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105171155626309600)
,p_name=>'APEXAPP.PROCESS.IG_DML'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 - \B300\D654\C2DD \ADF8\B9AC\B4DC \B370\C774\D130 \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105172993173309602)
,p_name=>'APEXAPP.PROCESS.INIT_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D3FC \CD08\AE30\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105171986051309601)
,p_name=>'APEXAPP.PROCESS.LEGACY_FORM_DML.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C774 \CC98\B9AC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105155233624309589)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105172136215309601)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C2E4\D328')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105155324353309589)
,p_name=>'APEXAPP.PROCESS.REPLY_TO_FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31\C5D0 \D68C\C2E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105154902899309588)
,p_name=>'APEXAPP.PROCESS.RESET_PAGINATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105171253844309601)
,p_name=>'APEXAPP.PROCESS.RESET_RPT_SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \AC80\C0C9 \C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105155059038309588)
,p_name=>'APEXAPP.PROCESS.SET_ACL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105172822514309602)
,p_name=>'APEXAPP.PROCESS.SET_ACL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \C124\C815\C744 \C800\C7A5\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105172543724309601)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105172670160309602)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131 \C635\C158\C744 \C5C5\B370\C774\D2B8\D588\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105173609410309602)
,p_name=>'APEXAPP.PROCESS.SET_FEEDBACK_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815 \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105171372585309601)
,p_name=>'APEXAPP.PROCESS.SET_USERNAME_COOKIE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984 \CFE0\D0A4 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105173498606309602)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105173585934309602)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C81C\CD9C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105171643123309601)
,p_name=>'APEXAPP.PROCESS.TABFORM_DELETE.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('#MRD_COUNT#\AC1C\C758 \D589\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105171786223309601)
,p_name=>'APEXAPP.PROCESS.TABFORM_PLSQL.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8\AC00 \C801\C6A9\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105171814464309601)
,p_name=>'APEXAPP.PROCESS.TABFORM_UPDATE_INSERT.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('#MRU_COUNT#\AC1C\C758 \D589\C774 \C5C5\B370\C774\D2B8\B418\C5C8\ACE0, #MRI_COUNT#\AC1C\C758 \D589\C774 \C0BD\C785\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105172462608309601)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790 \C2A4\D0C0\C77C \D658\ACBD\C124\C815 \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105155691969309589)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BAA8\C591 \C124\C815\C744 \C800\C7A5\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105172229796309601)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105172357414309601)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BAA8\C591 \C124\C815\C744 \C800\C7A5\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105161918795309594)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105161895356309594)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105163612484309595)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_CONFIG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105162021341309594)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('ACL \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105161622602309593)
,p_name=>'APEXAPP.REGION.ACTIVITY_REPORTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105152600985309587)
,p_name=>'APEXAPP.REGION.ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105161487691309593)
,p_name=>'APEXAPP.REGION.APP_CONFIGURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105163464498309595)
,p_name=>'APEXAPP.REGION.AUTOMATION_EXECUTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654 \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105151748309309586)
,p_name=>'APEXAPP.REGION.BREADCRUMB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105160531430309593)
,p_name=>'APEXAPP.REGION.BUTTONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105152581037309587)
,p_name=>'APEXAPP.REGION.COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105161339764309593)
,p_name=>'APEXAPP.REGION.CONFIGURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105161771100309594)
,p_name=>'APEXAPP.REGION.CONFIG_APPEARANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591 \AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105152005605309586)
,p_name=>'APEXAPP.REGION.DASHBOARD_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105160990093309593)
,p_name=>'APEXAPP.REGION.DATA_LOAD_FAILED_RECORDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D328\D55C \B808\CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105161044590309593)
,p_name=>'APEXAPP.REGION.DATA_LOAD_JUST_CHANGED_RECORDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \C0AC\C6A9\C790\AC00 \BCC0\ACBD\D55C \B808\CF54\B4DC\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105160823425309593)
,p_name=>'APEXAPP.REGION.DATA_LOAD_PROGRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \B9C8\BC95\C0AC \C9C4\D589 \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105152393640309586)
,p_name=>'APEXAPP.REGION.DEFAULT.MAX_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BCF4\ACE0\C11C\C758 \CD5C\B300 \D589 \C218\B294 %0\AC1C \D589\C785\B2C8\B2E4. \C9C8\C758 \B808\CF54\B4DC \C218\B97C \C904\C774\B824\BA74 \D544\D130\B97C \C801\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105152213432309586)
,p_name=>'APEXAPP.REGION.DEFAULT.NO_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105162403610309594)
,p_name=>'APEXAPP.REGION.EMAIL_REPORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105163874911309595)
,p_name=>'APEXAPP.REGION.EXCEPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608\C678\C0AC\D56D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105162124790309594)
,p_name=>'APEXAPP.REGION.FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105152979264309587)
,p_name=>'APEXAPP.REGION.FEEDBACK_SUBMITTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C81C\CD9C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105163126127309595)
,p_name=>'APEXAPP.REGION.FILTERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105164304834309595)
,p_name=>'APEXAPP.REGION.FORM_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \D56D\BAA9 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105152154570309586)
,p_name=>'APEXAPP.REGION.FORM_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105164202130309595)
,p_name=>'APEXAPP.REGION.HIDDEN_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\ACA8\C9C4 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105162688818309594)
,p_name=>'APEXAPP.REGION.HOURLY_PAGE_EVENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04\BCC4 \D398\C774\C9C0 \C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105160718412309593)
,p_name=>'APEXAPP.REGION.INFORMATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105162530578309594)
,p_name=>'APEXAPP.REGION.JOB_REPORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105162290677309594)
,p_name=>'APEXAPP.REGION.LANGUAGE_SELECTOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4 \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105162985958309594)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C2E0 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105163055347309594)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY.NO_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C744 \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105161129682309593)
,p_name=>'APEXAPP.REGION.MASTER_RECORDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \B808\CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105163587387309595)
,p_name=>'APEXAPP.REGION.MESSAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105162711328309594)
,p_name=>'APEXAPP.REGION.MOST_ACTIVE_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C7A5 \D65C\C131\D654\B41C \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105152480825309587)
,p_name=>'APEXAPP.REGION.NAVIGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D0D0\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105151934134309586)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \B808\CF54\B4DC \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105161216092309593)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED.NO_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \B808\CF54\B4DC \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105164026019309595)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \C0AC\C6A9\C790\AC00 \C874\C7AC\D558\C9C0 \C54A\C74C - \D398\C774\C9C0 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105164156917309595)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST.SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \C0C8 \C0AC\C6A9\C790\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105162855231309594)
,p_name=>'APEXAPP.REGION.RECENT_ERRORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105151863402309586)
,p_name=>'APEXAPP.REGION.REGION_DISPLAY_SELECTOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D45C\C2DC \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105152754371309587)
,p_name=>'APEXAPP.REGION.REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105151693294309586)
,p_name=>'APEXAPP.REGION.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105163223491309595)
,p_name=>'APEXAPP.REGION.TOP_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704 \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105163332000309595)
,p_name=>'APEXAPP.REGION.TOP_USERS_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704 \C0AC\C6A9\C790 \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105152841774309587)
,p_name=>'APEXAPP.REGION.USERS_TO_ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00\D560 \C0AC\C6A9\C790 %0\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105162363022309594)
,p_name=>'APEXAPP.REGION.USER_COUNTS_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C218 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105161581284309593)
,p_name=>'APEXAPP.REGION.USER_INTERFACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105163904336309595)
,p_name=>'APEXAPP.REGION.VALID_USERS_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \C0AC\C6A9\C790\AC00 \C874\C7AC\D568 - \D398\C774\C9C0 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105163750663309595)
,p_name=>'APEXAPP.REGION.WIZARD_CONTAINER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\BC95\C0AC \CEE8\D14C\C774\B108')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105160613411309593)
,p_name=>'APEXAPP.REGION.WIZARD_PROGRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\BC95\C0AC \C9C4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105181099611309608)
,p_name=>'APEXAPP.RELEASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9B4\B9AC\C2A4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105178569225309606)
,p_name=>'APEXAPP.SHORTCUT.GET_NEXT_PREV_PK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B97C \C800\C7A5\D558\C9C0 \C54A\C740 \CC44 \C885\B8CC\D558\ACA0\C2B5\B2C8\AE4C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105159129809309591)
,p_name=>'APEXAPP.SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \D589\C774 \C5C5\B370\C774\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105160352993309593)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B098 \C774\C0C1\C758 \D53C\B4DC\BC31 \D544\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105160420057309593)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \B610\B294 \ACBD\D5D8\C744 \C81C\ACF5\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105160149180309592)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\C2E0\C744 \AD00\B9AC\C790\C5D0\C11C \C81C\AC70\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105160222650309592)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\C2A4\B85C \AD00\B9AC\C790 \B864\C744 \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105159684451309592)
,p_name=>'APEXAPP.VALIDATION.COLUMN.DATE.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('#COLUMN_HEADER#\B294 \C801\D569\D55C \B0A0\C9DC\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105159424245309592)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NOT_NULL.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('#COLUMN_HEADER# \AC12\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105159517863309592)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NUMERIC.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('#COLUMN_HEADER#\B294 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105159734599309592)
,p_name=>'APEXAPP.VALIDATION.COLUMN.TIMESTAMP.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('#COLUMN_HEADER#\B294 \C801\D569\D55C \C2DC\AC04\AE30\B85D \AC12\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105157729702309590)
,p_name=>'APEXAPP.VALIDATION.DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \C801\D569\D55C \B0A0\C9DC\C5EC\C57C \D569\B2C8\B2E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105159938781309592)
,p_name=>'APEXAPP.VALIDATION.ITEM.DATE.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740 \C801\D569\D55C \B0A0\C9DC\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105159864665309592)
,p_name=>'APEXAPP.VALIDATION.ITEM.NOT_NULL.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL# \AC12\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105160058820309592)
,p_name=>'APEXAPP.VALIDATION.ITEM.TIMESTAMP.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740 \C801\D569\D55C \C2DC\AC04\AE30\B85D\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105157506796309590)
,p_name=>'APEXAPP.VALIDATION.NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \B110\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105157673307309590)
,p_name=>'APEXAPP.VALIDATION.NUMERIC'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \C22B\C790\C5EC\C57C \D569\B2C8\B2E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105157832739309591)
,p_name=>'APEXAPP.VALIDATION.TIMESTAMP'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \C801\D569\D55C \C2DC\AC04\AE30\B85D\C774\C5B4\C57C \D569\B2C8\B2E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106075057436310342)
,p_name=>'APEXDEV.IG.COLUMN_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5 ''#COMPONENT_NAME#''\C5D0 \B300\D574 \C9C0\C815\B41C \B300\D654\C2DD \ADF8\B9AC\B4DC \C5F4 ''%0''\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106075269168310342)
,p_name=>'APEXDEV.IG.DML.COMPLEX_VIEW_LOCK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C7A0\AE08\C744 \C218\D589\D558\B294 \C911 ''%0'' \D504\B85C\C138\C2A4\C5D0\C11C ''%1''\C774(\AC00) \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \D504\B85C\C138\C2A4 \C911\C5D0 \D589\C744 \C7A0\ADF8\AE30 \C704\D574 \C778\C2A4\D134\C2A4 \D2B8\B9AC\AC70\B97C \C0AC\C6A9\D558\C5EC \BCF5\C7A1\D55C \BCF4\AE30\C5D0\C11C SELECT FOR UPDATE\B97C \C2E4\D589\D558\B294 \ACBD\C6B0\C5D0 \C774 \C624\B958\AC00 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4. ''\D589 \C7A0\ADF8\AE30'' \D504\B85C\C138\C2A4 \C18D\C131\C744 \C544\B2C8\C624 \B610\B294 PL/SQL \CF54\B4DC\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106075136231310342)
,p_name=>'APEXDEV.IG.DML.VIRTUAL_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('DML \BA85\B839\C744 \C2E4\D589\D558\B294 \C911 ''%0'' \D504\B85C\C138\C2A4\C5D0\C11C ''%1''\C774(\AC00) \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \C774 \C624\B958\B294 \C5F4\C774 \C9D1\ACC4 \B610\B294 SQL \D45C\D604\C2DD\C744 \AE30\BC18\C73C\B85C \D558\B294 \ACBD\C6B0\C5D0 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4. INSERT \BC0F UPDATE \BB38\C5D0\C11C \C5F4\C744 \C81C\C678\D558\B824\BA74 ''\C9C8\C758 \C804\C6A9'' \C5F4 \C18D\C131\C744 \C608\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105696865262310026)
,p_name=>'APEXDEV.IG.MASTER_DETAIL_COLUMN_NOT_POPULATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \B514\D14C\C77C \C5F4 ''%0''\C5D0 \AC12\C774 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4. ''%1'' \D504\B85C\C138\C2A4\AC00 \B9C8\C2A4\D130 \C601\C5ED\C758 \D574\B2F9\D558\B294 \D504\B85C\C138\C2A4 \C774\D6C4 \C2E4\D589\B418\C5C8\B294\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106057339435310325)
,p_name=>'APEXDEV.IG.NO_MASTER_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC ''%0''\C5D0 \B9C8\C2A4\D130 \B514\D14C\C77C \AD00\ACC4\B97C \C704\D574 \D544\C694\D55C \B9C8\C2A4\D130 \C5F4\C774 \C815\C758\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105471761762309837)
,p_name=>'APEXDEV.IG.NO_PK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC ''%0''\C5D0 \D3B8\C9D1\C744 \C704\D574 \B610\B294 \B9C8\C2A4\D130 \B514\D14C\C77C \AD00\ACC4\C5D0\C11C \D544\C694\D55C \AE30\BCF8 \D0A4 \C5F4\C774 \C815\C758\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106034786169310304)
,p_name=>'APEXDEV.IG.RELOAD_ON_SUBMIT_EDITABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1 \AC00\B2A5\D55C \B300\D654\C2DD \ADF8\B9AC\B4DC\C758 \ACBD\C6B0, \D398\C774\C9C0 \C18D\C131 ''\C81C\CD9C \C2DC \B2E4\C2DC \B85C\B4DC''\AC00 ''\C131\ACF5 \C2DC\C5D0\B9CC''\C73C\B85C \C124\C815\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106005717403310276)
,p_name=>'APEXDEV.PE.CODE_EDITOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF54\B4DC \D3B8\C9D1\AE30: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106005895111310276)
,p_name=>'APEXDEV.PE.COLLAPSE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CD95\C18C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106005983133310276)
,p_name=>'APEXDEV.PE.COLOR_PICKER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 \C120\D0DD\AE30: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106006043019310276)
,p_name=>'APEXDEV.PE.EDIT_COMPONENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \D3B8\C9D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106006190492310276)
,p_name=>'APEXDEV.PE.ERROR_POSTFIX'
,p_message_language=>'ko'
,p_message_text=>unistr(' (\C624\B958)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106006203678310276)
,p_name=>'APEXDEV.PE.EXPAND'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D655\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106005638698310276)
,p_name=>'APEXDEV.PE.FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106006301106310276)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACB0\ACFC\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106006468223310276)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH_COMMON'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACB0\ACFC\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C704\C758 ''\BAA8\B450 \D45C\C2DC'' \B2E8\CD94\B97C \B20C\B7EC \BAA8\B4E0 \C18D\C131\C744 \AC80\C0C9\D574 \BCF4\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106006599222310276)
,p_name=>'APEXDEV.PE.FILTER_PROPERTIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \C18D\C131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106006648611310276)
,p_name=>'APEXDEV.PE.INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('%0(\BD80\C801\D569)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106006704515310277)
,p_name=>'APEXDEV.PE.LIST_OF_VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106006889822310277)
,p_name=>'APEXDEV.PE.NO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106006984908310277)
,p_name=>'APEXDEV.PE.NO_COMMON_PROPERTIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \AD6C\C131\C694\C18C\C5D0 \ACF5\D1B5 \C18D\C131\C774 \C5C6\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106008126137310278)
,p_name=>'APEXDEV.PE.NO_COMPONENTS_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C120\D0DD\B41C \AD6C\C131\C694\C18C\AC00 \C5C6\C2B5\B2C8\B2E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106007012347310277)
,p_name=>'APEXDEV.PE.PICK'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106007174015310277)
,p_name=>'APEXDEV.PE.PIN_FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \ACE0\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106007205729310277)
,p_name=>'APEXDEV.PE.QUICK_PICK'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE60\B978 \C120\D0DD: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106007373390310277)
,p_name=>'APEXDEV.PE.QUICK_PICK.CLEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD \C9C0\C6B0\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106007414028310277)
,p_name=>'APEXDEV.PE.REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C218')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106007511563310277)
,p_name=>'APEXDEV.PE.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106007652828310277)
,p_name=>'APEXDEV.PE.SELECT'
,p_message_language=>'ko'
,p_message_text=>unistr('- \C120\D0DD -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106007785156310278)
,p_name=>'APEXDEV.PE.VALUE_VARIES_POSTFIX'
,p_message_language=>'ko'
,p_message_text=>unistr(' (\AC12\C774 \B2E4\B97C \C218 \C788\C74C)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106007842968310278)
,p_name=>'APEXDEV.PE.WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106007998252310278)
,p_name=>'APEXDEV.PE.WARNING_POSTFIX'
,p_message_language=>'ko'
,p_message_text=>unistr(' (\ACBD\ACE0)')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106008095904310278)
,p_name=>'APEXDEV.PE.YES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106034872360310304)
,p_name=>'APEXDEV.TABFORM.RELOAD_ON_SUBMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C \D615\C2DD \D3FC\C758 \ACBD\C6B0, \D398\C774\C9C0 \C18D\C131 ''\C81C\CD9C \C2DC \B2E4\C2DC \B85C\B4DC''\AC00 ''\D56D\C0C1''\C73C\B85C \C124\C815\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105814401072310119)
,p_name=>'APEXIG_MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C5D0 \C5EC\B7EC \B300\D654\C2DD \ADF8\B9AC\B4DC\AC00 \D3EC\D568\B418\C5B4 \C788\C73C\BBC0\B85C \C601\C5ED \C815\C801 ID\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105039639079309498)
,p_name=>'APEXIR_3D'
,p_message_language=>'ko'
,p_message_text=>'3D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105150134705309585)
,p_name=>'APEXIR_ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105632316266309969)
,p_name=>'APEXIR_ADD_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C785 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105289179667309688)
,p_name=>'APEXIR_AGGREGATE_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D1\ACC4\B294 \AC01 \C81C\C5B4 \CC28\B2E8 \B4A4\C640 \BCF4\ACE0\C11C \B05D\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105205045536309625)
,p_name=>'APEXIR_AGG_COUNT_DISTINCT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \AC1C\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105150589770309585)
,p_name=>'APEXIR_AGG_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106032533824310302)
,p_name=>'APEXIR_AREA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105630128155309967)
,p_name=>'APEXIR_BLACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C815\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105150823819309585)
,p_name=>'APEXIR_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105256768261309663)
,p_name=>'APEXIR_COLUMN_HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106064720034310332)
,p_name=>'APEXIR_DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105185088001309610)
,p_name=>'APEXIR_DELETE_CHECKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \D56D\BAA9 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105289486772309688)
,p_name=>'APEXIR_DELETE_CONFIRM_JS_DIALOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C0AD\C81C \C791\C5C5\C744 \C218\D589\D558\ACA0\C2B5\B2C8\AE4C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105268423403309672)
,p_name=>'APEXIR_DISABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105039896085309499)
,p_name=>'APEXIR_DISPLAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105017514016309482)
,p_name=>'APEXIR_DONUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\B11B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104889103217309388)
,p_name=>'APEXIR_DOWNLOAD_DATA_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B9CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105039728739309498)
,p_name=>'APEXIR_DO_NOT_AGGREGATE'
,p_message_language=>'ko'
,p_message_text=>unistr('- \C9D1\ACC4 \C548\D568 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106015731290310285)
,p_name=>'APEXIR_EDIT_ALTERNATIVE_DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4 \AE30\BCF8\AC12 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105268324860309672)
,p_name=>'APEXIR_ENABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105289213240309688)
,p_name=>'APEXIR_FLASHBACK_ERROR_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B798\C2DC\BC31 \C694\CCAD\C744 \C218\D589\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105619403433309958)
,p_name=>'APEXIR_FUNCTION_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \C5F4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105630233738309967)
,p_name=>'APEXIR_GRAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68C\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105017313895309482)
,p_name=>'APEXIR_HIGHLIGHT_WHEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC \C2DC\C810')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105565285196309914)
,p_name=>'APEXIR_LABEL_PREFIX'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \C811\B450\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105621270597309959)
,p_name=>'APEXIR_MANAGE_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C785\C744 \AD00\B9AC\D558\B824\BA74 <a href=''%0''>\C5EC\AE30</a>\B97C \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105290078861309689)
,p_name=>'APEXIR_MORE_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105035463783309495)
,p_name=>'APEXIR_NEW_CATEGORY'
,p_message_language=>'ko'
,p_message_text=>unistr('- \C0C8 \BC94\C8FC -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105185168307309611)
,p_name=>'APEXIR_NO_AGGREGATION_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \C9D1\ACC4\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105113216640309551)
,p_name=>'APEXIR_NO_COLUMN_INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\D560 \C218 \C788\B294 \C5F4 \C815\BCF4\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105185206860309611)
,p_name=>'APEXIR_NO_COMPUTATION_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \ACC4\C0B0\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106064655273310332)
,p_name=>'APEXIR_NO_END_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('- \C885\B8CC \B0A0\C9DC \C5C6\C74C -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106118339003310382)
,p_name=>'APEXIR_PIVOT_ROW_COLUMN_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \D589 \C5F4\C744 \C120\D0DD\D558\C2ED\C2DC\C624. \D589 \C5F4\C758 HTML \D45C\D604\C2DD \B610\B294 \B9C1\D06C\C5D0 \D53C\BC97 \B610\B294 \C9D1\ACC4 \C5F4\B85C \C815\C758\B41C \C5F4\C774 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105150241033309585)
,p_name=>'APEXIR_REMOVE_AGGREGATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D1\ACC4 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105518910210309876)
,p_name=>'APEXIR_REPORT_DISPLAY_COLUMN_LIMIT_REACHED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C758 \D45C\C2DC \C5F4 \C218\AC00 \D55C\B3C4\C5D0 \B3C4\B2EC\D588\C2B5\B2C8\B2E4. [\C791\C5C5] \BA54\B274 \C544\B798\C5D0\C11C [\C5F4 \C120\D0DD]\C744 \B20C\B7EC \BCF4\ACE0\C11C \D45C\C2DC \C5F4 \BAA9\B85D\C744 \CD5C\C18C\D654\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105124439296309562)
,p_name=>'APEXIR_ROW_ORDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C21C\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104888448802309387)
,p_name=>'APEXIR_RPT_DISP_COL_EXCEED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C758 \D45C\C2DC \C5F4 \C218\AC00 \D55C\B3C4\C5D0 \B3C4\B2EC\D588\C2B5\B2C8\B2E4. [\C791\C5C5] \BA54\B274 \C544\B798\C5D0\C11C [\C5F4 \C120\D0DD]\C744 \B20C\B7EC \BCF4\ACE0\C11C \D45C\C2DC \C5F4 \BAA9\B85D\C744 \CD5C\C18C\D654\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105184905383309610)
,p_name=>'APEXIR_SAVE_AS_DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12\C73C\B85C \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105017413558309482)
,p_name=>'APEXIR_SELECT_CATEGORY'
,p_message_language=>'ko'
,p_message_text=>unistr('- \BC94\C8FC \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105290184966309689)
,p_name=>'APEXIR_SELECT_COLUMNS_FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0\B41C \C5F4 \C55E\C5D0\B294 **\AC00 \BD99\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106064536999310332)
,p_name=>'APEXIR_SELECT_SORT_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('- \C815\B82C \C5F4 \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105289909863309689)
,p_name=>'APEXIR_SELECT_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106064407208310332)
,p_name=>'APEXIR_SORT_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \C5F4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105619385006309958)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING_UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B2E8\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105289372004309688)
,p_name=>'APEXIR_UNAUTHORIZED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105266638200309671)
,p_name=>'APEXIR_UNIQUE_COLUMN_HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \BA38\B9AC\AE00\C740 \ACE0\C720\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106064854449310332)
,p_name=>'APEXIR_WEEK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104885799727309385)
,p_name=>'APEX_ADMIN_SERVICES'
,p_message_language=>'ko'
,p_message_text=>unistr('Application Express \AD00\B9AC \C11C\BE44\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106016012939310286)
,p_name=>'APEX_AUTHENTICATION.NOT_CONFIGURED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D574 \AD6C\C131\B41C \C778\C99D\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105328390644309719)
,p_name=>'APEX_SAMPLE_LOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\AC00 \C120\D0DD\B41C \C2A4\D0A4\B9C8\C5D0 %0\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105328425934309719)
,p_name=>'APEX_SAMPLE_LOAD_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\AC00 \C131\ACF5\C801\C73C\B85C %0\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105703587416310035)
,p_name=>'APEX_SCROLL_DOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\B85C \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105703677084310035)
,p_name=>'APEX_SCROLL_TO_TOP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E8 \C704\B85C \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104891827352309390)
,p_name=>'APEX_WIZARD_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106015636229310285)
,p_name=>'APEX_WS_EDIT_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105483418890309846)
,p_name=>'APEX_WS_INVALID_OBJECTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106068801200310336)
,p_name=>'APEX_WS_NO_PEER_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\C5B4 \D398\C774\C9C0\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106018957165310289)
,p_name=>'APEX_WS_SETUP_CREATE_OBJ'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\D560 \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106019144541310289)
,p_name=>'APEX_WS_SETUP_DELETE_TABLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C5D0\C11C \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106019328840310289)
,p_name=>'APEX_WS_SETUP_DROP_OBJECTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105638354732309975)
,p_name=>'APEX_WS_SETUP_DROP_TABLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105637634807309974)
,p_name=>'APEX_WS_SETUP_MSG1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC1D\CCB4\B294 <strong>%0</strong> \C2A4\D0A4\B9C8\C5D0 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106019420287310289)
,p_name=>'APEX_WS_SETUP_MSG10'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B7EC\D55C \AC1D\CCB4\B294 <strong>%0</strong> \C2A4\D0A4\B9C8 \B0B4\C5D0 \C874\C7AC\D558\BA70 \B2E4\B978 \C791\C5C5\C601\C5ED\C5D0\C11C \C0AC\C6A9\B429\B2C8\B2E4. \ACC4\C18D\D558\BA74 <strong>%0</strong>\C5D0\C11C \C18C\C720\D558\ACE0 \C788\B294 \AE30\C874 \C6F9 \C2DC\D2B8 \AC1D\CCB4\AC00 \C774 \C791\C5C5\C601\C5ED\ACFC\B3C4 \C5F0\AD00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106019533857310289)
,p_name=>'APEX_WS_SETUP_MSG11'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC1D\CCB4\C5D0 \C0AC\C6A9\D560 \C2A4\D0A4\B9C8\B97C \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106019643842310289)
,p_name=>'APEX_WS_SETUP_MSG12'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\D560 \AE30\C874 \D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106020406072310290)
,p_name=>'APEX_WS_SETUP_MSG13'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C815\BCF4\B97C \C0AC\C6A9\D558\C5EC Websheet \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\AC00 \C7AC\C0AC\C6A9\B429\B2C8\B2E4. \C694\CCAD \B0B4\C6A9\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105637748376309974)
,p_name=>'APEX_WS_SETUP_MSG2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C2A4\D0A4\B9C8\C5D0\C11C \C6F9 \C2DC\D2B8 \AC1D\CCB4\B97C \C0DD\C131\D558\B824\B294 \ACBD\C6B0\C5D0\B294 <a href=%0>\B370\C774\D130\BCA0\C774\C2A4 \C2A4\D0A4\B9C8 \C694\CCAD</a> \B9C8\BC95\C0AC\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105637852925309974)
,p_name=>'APEX_WS_SETUP_MSG3'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8\B97C \C2E4\D589\D558\B824\BA74 \B2E4\C74C \AC1D\CCB4\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105637969551309974)
,p_name=>'APEX_WS_SETUP_MSG5'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C815\BCF4\B97C \C0AC\C6A9\D558\C5EC Websheet \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\AC00 \C0DD\C131\B429\B2C8\B2E4. \C694\CCAD \B0B4\C6A9\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105638095801309974)
,p_name=>'APEX_WS_SETUP_MSG6'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\D560 \D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105638134984309975)
,p_name=>'APEX_WS_SETUP_MSG7'
,p_message_language=>'ko'
,p_message_text=>unistr('Websheet \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C81C\AC70\D558\B824\ACE0 \D569\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \C6F9 \C2DC\D2B8 \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\BFD0\B9CC \C544\B2C8\B77C \C791\C5C5\C601\C5ED\C758 \C6F9 \C2DC\D2B8 \AD6C\C131\C694\C18C\B97C \D3EC\D568\D558\B294 \B0B4\BD80 \B370\C774\D130\B3C4 \C0AD\C81C\B429\B2C8\B2E4. \ACC4\C18D\D558\ACA0\C2B5\B2C8\AE4C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105638426171309975)
,p_name=>'APEX_WS_SETUP_MSG8'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8\B97C \C62C\BC14\B974\AC8C \C2E4\D589\D558\B824\BA74 \B2E4\C74C\ACFC \AC19\C740 \BD80\C801\D569\D55C \AC1D\CCB4\B97C \C218\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106019009243310289)
,p_name=>'APEX_WS_SETUP_MSG9'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C601\C5ED\C5D0 \B300\D55C \C6F9 \C2DC\D2B8 \C815\C758\B97C \C81C\AC70\D558\B824\ACE0 \D569\B2C8\B2E4. \C6F9 \C2DC\D2B8 \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B294 \B2E4\B978 \C791\C5C5\C601\C5ED\C5D0\C11C\B3C4 \C0AC\C6A9\B418\BBC0\B85C \C0AD\C81C\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C601\C5ED\ACFC \C5F0\AD00\B41C \B808\CF54\B4DC\B294 \C0AD\C81C\B429\B2C8\B2E4. \ACC4\C18D\D558\ACA0\C2B5\B2C8\AE4C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105638549568309975)
,p_name=>'APEX_WS_SETUP_OBJECT_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105638636644309975)
,p_name=>'APEX_WS_SETUP_OBJECT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105638210505309975)
,p_name=>'APEX_WS_SETUP_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106018863803310288)
,p_name=>'APEX_WS_SETUP_USE_EXISTING_OBJ'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\D560 \AE30\C874 \AC1D\CCB4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104941121474309427)
,p_name=>'APPLICACTION_COMPUTATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104941069531309427)
,p_name=>'APPLICACTION_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105477203925309842)
,p_name=>'APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105538218723309893)
,p_name=>'APPLICATION BUILDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105392934173309767)
,p_name=>'APPLICATION COMPUTATION CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \ACC4\C0B0 \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105395788832309769)
,p_name=>'APPLICATION IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105393093630309767)
,p_name=>'APPLICATION PROCESS CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4 \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105324073554309716)
,p_name=>'APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105458561548309826)
,p_name=>'APPLICATIONS_INITCAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105367153814309748)
,p_name=>'APPLICATION_ACTIVITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105405137206309776)
,p_name=>'APPLICATION_ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105403271554309775)
,p_name=>'APPLICATION_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104885588581309385)
,p_name=>'APPLICATION_DEVELOPMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AC1C\BC1C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105404104265309775)
,p_name=>'APPLICATION_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C744 \C2DD\BCC4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105363982595309746)
,p_name=>'APPLICATION_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105263805728309669)
,p_name=>'APPLICATION_ID_RESERVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID\B294 \C608\C57D\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105263723252309669)
,p_name=>'APPLICATION_ID_VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID\B294 \C591\C758 \C815\C218\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105678521049310011)
,p_name=>'APPLICATION_IMAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105433206734309804)
,p_name=>'APPLICATION_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104967059403309445)
,p_name=>'APPLICATION_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104935984011309423)
,p_name=>'APPLICATION_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105405026767309776)
,p_name=>'APPLICATION_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106068482839310335)
,p_name=>'APPLICATION_NAMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105514900243309873)
,p_name=>'APPLICATION_OVERRIDE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BB34\D6A8\D654 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105402779634309774)
,p_name=>'APPLICATION_OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106068346329310335)
,p_name=>'APPLICATION_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105042404437309500)
,p_name=>'APPLICATION_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105402916771309774)
,p_name=>'APPLICATION_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105478800942309843)
,p_name=>'APPLICATION_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BC84\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104900677919309397)
,p_name=>'APPLICATION_X'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105351581629309736)
,p_name=>'APPROVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2B9\C778\B428')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105409349690309779)
,p_name=>'APP_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C774 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106070932203310338)
,p_name=>'APP_TEMPLATE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104933867272309421)
,p_name=>'APP_TYPE_DATABASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104933930432309421)
,p_name=>'APP_TYPE_PACKAGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C0B0\C131 \B610\B294 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105430177173309802)
,p_name=>'APP_TYPE_PACKAGED_WS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0D8\D50C \C6F9 \C2DC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104933707044309421)
,p_name=>'APP_TYPE_WEBSHEET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105351090550309736)
,p_name=>'ARCHIVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\CE74\C774\BE0C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104936269930309423)
,p_name=>'ARCHIVELOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8 \C544\CE74\C774\BE0C: \C124\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105187144364309612)
,p_name=>'ARGUMENTS_MUST_HAVE_CHECKSUM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C218\C5D0 \CCB4\D06C\C12C\C774 \C788\C5B4\C57C \D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105274799867309677)
,p_name=>'ARGUMENT_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C218 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105274942789309678)
,p_name=>'ARGUMENT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C218 \C720\D615')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105345250912309732)
,p_name=>'ASAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\B2A5\D55C \BE68\B9AC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105342556798309730)
,p_name=>'ASSIGNED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105040014051309499)
,p_name=>'ASSIGNEE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\C9C0\C815\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106090698811310356)
,p_name=>'ASSIGN_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C9C0\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105096000187309539)
,p_name=>'ASSOCIATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105041684602309500)
,p_name=>'ASSOCIATED_FEATURES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B41C \AE30\B2A5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105372316150309752)
,p_name=>'ATTACHMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \D30C\C77C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106098403515310363)
,p_name=>'AT_RISK_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\D5D8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105067525667309518)
,p_name=>'AUTH.CONFIRM_MIGRATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \C0AC\C6A9\C790\C815\C758 \C778\C99D \C635\C158\C744 \C778\C99D \CCB4\ACC4\B85C \C774\C804\D558\B824\ACE0 \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105067003791309518)
,p_name=>'AUTH.CURRENT_AUTH_METHOD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C778\C99D \BC29\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105067422102309518)
,p_name=>'AUTH.CUSTOM_AUTH_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C778\C99D \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105067177876309518)
,p_name=>'AUTH.LOGIN_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105067387735309518)
,p_name=>'AUTH.LOGIN_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105067244214309518)
,p_name=>'AUTH.NONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105072587658309522)
,p_name=>'AUTHENTICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105393990786309768)
,p_name=>'AUTHENTICATION FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105393601769309767)
,p_name=>'AUTHENTICATION SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105087516919309533)
,p_name=>'AUTHENTICATION.CONFIRM_DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C778\C99D \CCB4\ACC4\B97C \C0AD\C81C\D558\B824\ACE0 \D569\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158\C774 \D604\C7AC "\CCB4\ACC4" \C778\C99D\C744 \C0AC\C6A9\D558\ACE0 \C788\C9C0 \C54A\AC70\B098 \D574\B2F9 \CCB4\ACC4\AC00 \D604\C7AC \C778\C99D \CCB4\ACC4\AC00 \C544\B2CC \ACBD\C6B0, \CCB4\ACC4\B97C \C0AD\C81C\D574\B3C4 \C560\D50C\B9AC\CF00\C774\C158 \C791\C5C5\C774 \C601\D5A5\C744 \BC1B\C9C0 \C54A\C2B5\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158\C774 "\CCB4\ACC4" \C778\C99D\C744 \C0AC\C6A9\D558\ACE0 \C788\ACE0 \C774 \CCB4\ACC4\AC00 \D604\C7AC \C778\C99D \CCB4\ACC4\C778 \ACBD\C6B0, \C560\D50C\B9AC\CF00\C774\C158\C740 "\CCB4\ACC4" \C778\C99D\C744 \C0AC\C6A9\D558\C5EC \ACC4\C18D \C2E4\D589\B418\C9C0\B9CC \AE30\BCF8 \C778\C99D \CCB4\ACC4\B3C4 \C0AC\C6A9\D569\B2C8\B2E4. \B530\B77C\C11C "\ACF5\AC1C" \C99D\BA85\C11C \D655\C778\C744 \C0AC\C6A9\D558\B294 \B0B4\C7A5 \B85C\ADF8\C778 \D398\C774\C9C0\B97C \C0AC\C6A9\D569\B2C8')
||unistr('\B2E4. \C989, \B204\AD6C\B4E0\C9C0 \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D560 \C218 \C788\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105089516225309534)
,p_name=>'AUTHENTICATION.MAKE_CURRENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C774 \C774 \C778\C99D \CCB4\ACC4\B97C \C0AC\C6A9\D558\B3C4\B85D \D558\B824\BA74 <b>\D604\C7AC\B85C \C124\C815</b> \B2E8\CD94\B97C \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105565525096309914)
,p_name=>'AUTHENTICATION_NAME.NATIVE_APEX_ACCOUNTS'
,p_message_language=>'ko'
,p_message_text=>unistr('Application Express \ACC4\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104882124169309382)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Cloud ID \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105565641742309914)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CUSTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105565984250309915)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105565754355309915)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DB_ACCOUNTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \ACC4\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105827393149310129)
,p_name=>'AUTHENTICATION_NAME.NATIVE_HTTP_HEADER_VARIABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP \BA38\B9AC\AE00 \BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105566130747309915)
,p_name=>'AUTHENTICATION_NAME.NATIVE_IAS_SSO'
,p_message_language=>'ko'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105565883184309915)
,p_name=>'AUTHENTICATION_NAME.NATIVE_LDAP'
,p_message_language=>'ko'
,p_message_text=>unistr('LDAP \B514\B809\D1A0\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105566076314309915)
,p_name=>'AUTHENTICATION_NAME.NATIVE_OPEN_DOOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\AC1C \C99D\BA85\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104860059367309363)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SAML'
,p_message_language=>'ko'
,p_message_text=>unistr('SAML \C0AC\C778\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104910660831309405)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SOCIAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C15C \C0AC\C778\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105434266042309805)
,p_name=>'AUTHENTICATION_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105393590190309767)
,p_name=>'AUTHORIZATION SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104882208861309382)
,p_name=>'AUTHORIZATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Cloud ID \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104900845362309397)
,p_name=>'AUTHORIZATION_NAME.NATIVE_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('Exists SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104900915829309398)
,p_name=>'AUTHORIZATION_NAME.NATIVE_FUNCTION_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C6B8 \BC18\D658 PL/SQL \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105256455200309663)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_IN_GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864 \B610\B294 \ADF8\B8F9\C5D0 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105256599681309663)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_NOT_IN_GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864 \B610\B294 \ADF8\B8F9\C5D0 \D3EC\D568 \C548\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104901029508309398)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_EQUALS_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD 1\C758 \D56D\BAA9 \AC12\C774 \D45C\D604\C2DD 2\C640 \AC19\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104901118296309398)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD 1\C5D0 \C788\B294 \D56D\BAA9\C740 \B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104901214312309398)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD 1\C5D0 \C788\B294 \D56D\BAA9\C740 \B110\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104901379801309398)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_NOT_EQUALS_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD 1\C758 \D56D\BAA9 \AC12\C740 \D45C\D604\C2DD 2\C640 \AC19\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104901452905309398)
,p_name=>'AUTHORIZATION_NAME.NATIVE_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('Not Exists SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104901578482309398)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_EQUALS_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD 1\C5D0 \C788\B294 \D658\ACBD\C124\C815\C758 \AC12\C740 \D45C\D604\C2DD 2\C640 \AC19\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104901677811309398)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_NOT_EQUALS_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD 1\C5D0 \C788\B294 \D658\ACBD\C124\C815\C758 \AC12\C740 \D45C\D604\C2DD 2\C640 \AC19\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104952728904309435)
,p_name=>'AUTHZ_CACHE_PER_PAGE_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCF4\AE30\B9C8\B2E4 \D3C9\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104952865910309435)
,p_name=>'AUTHZ_CACHE_PER_SESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158\B2F9 \D55C \BC88 \D3C9\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104904514129309400)
,p_name=>'AUTH_ACCOUNT_EXPIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C815\C774 \B9CC\AE30\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104904432259309400)
,p_name=>'AUTH_ACCOUNT_LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C815\C774 \C7A0\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104904875529309400)
,p_name=>'AUTH_ATTEMPTS_EXCEEDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \B85C\ADF8\C778 \C2DC\B3C4 \D69F\C218\AC00 \CD08\ACFC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104904946881309400)
,p_name=>'AUTH_INTERNAL_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C \C218 \C5C6\B294 \B0B4\BD80 \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104904755260309400)
,p_name=>'AUTH_PASSWORD_FIRST_USE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638 \CC98\C74C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104904677214309400)
,p_name=>'AUTH_PASSWORD_INCORRECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C815\D655\D55C \BE44\BC00\BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104904266690309400)
,p_name=>'AUTH_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C0C1, \C778\C99D \C131\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104904307275309400)
,p_name=>'AUTH_UNKNOWN_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C \C218 \C5C6\B294 \C0AC\C6A9\C790 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104999117283309469)
,p_name=>'AUTH_UNKNOWN_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C \C218 \C5C6\B294 \C791\C5C5\C601\C5ED \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105009239856309476)
,p_name=>'AUTH_UNKNOWN_WORKSPACE_COLON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C \C218 \C5C6\B294 \C791\C5C5\C601\C5ED \C774\B984: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105130268676309570)
,p_name=>'AUTOCOMMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE4\BC0B \BA85\B839\BB38\C744 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \BAA8\B4E0 \BA85\B839\BB38\C774 \C790\B3D9\C73C\B85C \CEE4\BC0B\B418\C5C8\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105828329087310130)
,p_name=>'AUTOMATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105828407656310130)
,p_name=>'AUTOMATION_ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654 \C791\C5C5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105459147763309827)
,p_name=>'AUTOPROVISION_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4F1\B85D \BAA8\B4DC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104879709927309380)
,p_name=>'AUTO_FIRST_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8 \D56D\BAA9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105480677895309844)
,p_name=>'AVAILABILITY_INIT_CAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C6A9\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104908997439309403)
,p_name=>'AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \AC00\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105615552668309954)
,p_name=>'AVAILABLE_TO_DEVELOPERS_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790\B9CC \C0AC\C6A9\D560 \C218 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105615494278309954)
,p_name=>'AVAILABLE_WITH_EDIT_LINKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790 \B3C4\AD6C \BAA8\C74C\C5D0\C11C \C0AC\C6A9 \AC00\B2A5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105367952691309748)
,p_name=>'AVERAGE_RENDER_TIME_SECONDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3C9\ADE0 \B80C\B354\B9C1 \C2DC\AC04(\CD08)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105349445010309735)
,p_name=>'BAR_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300 \CC28\D2B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105667251406310001)
,p_name=>'BASIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104922827324309413)
,p_name=>'BASIC_DEVELOPER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \AC1C\BC1C\C790')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105330864452309721)
,p_name=>'BEFORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106073728774310340)
,p_name=>'BEFORE LIST ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D56D\BAA9 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106089769684310355)
,p_name=>'BEFORE_FIRST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \C804')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105396830827309770)
,p_name=>'BIND_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\C778\B4DC \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105396266193309769)
,p_name=>'BIND_VARIABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\C778\B4DC \BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105396301375309769)
,p_name=>'BIND_VARIABLE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\C778\B4DC \BCC0\C218 \B808\C774\BE14')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105410867399309780)
,p_name=>'BLACK_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C815\C0C9 \D14D\C2A4\D2B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104886116491309385)
,p_name=>'BLANK'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\BC31')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105371530269309751)
,p_name=>'BLOB_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('BLOB \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105516618983309875)
,p_name=>'BLOB_DOWNLOAD_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104934863231309422)
,p_name=>'BLOB_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('Blob \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105517022549309875)
,p_name=>'BLOB_FORMAT_ATTACHMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105516712589309875)
,p_name=>'BLOB_FORMAT_DOWNLOAD'
,p_message_language=>'ko'
,p_message_text=>'DOWNLOAD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105516876680309875)
,p_name=>'BLOB_FORMAT_IMAGE'
,p_message_language=>'ko'
,p_message_text=>'IMAGE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105516971239309875)
,p_name=>'BLOB_FORMAT_INLINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105372545857309752)
,p_name=>'BLOB_FORMAT_MASK'
,p_message_language=>'ko'
,p_message_text=>unistr('BLOB \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105372084582309752)
,p_name=>'BLOB_LAST_UPDATED_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('BLOB \CD5C\C885 \C5C5\B370\C774\D2B8 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105371430697309751)
,p_name=>'BLOB_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('BLOB \D14C\C774\BE14')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105410723645309780)
,p_name=>'BLUE_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\B780\C0C9 \D14D\C2A4\D2B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105387973892309763)
,p_name=>'BRANCH CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30 \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104956593886309438)
,p_name=>'BRANCHES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105151029233309585)
,p_name=>'BREADCRUMB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105331509933309722)
,p_name=>'BREADCRUMB LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105331635496309722)
,p_name=>'BREADCRUMB LONG NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C\C758 \AE34 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105151135986309585)
,p_name=>'BREADCRUMBS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105419624155309793)
,p_name=>'BREADCRUMB_ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105433408297309805)
,p_name=>'BREADCRUMB_ENTRY_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D56D\BAA9: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105264170238309669)
,p_name=>'BREADCRUMB_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105339055939309727)
,p_name=>'BREADCRUMB_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105013129440309479)
,p_name=>'BREADCRUMB_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C\AC00 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105334117857309724)
,p_name=>'BROWSE_ICON'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC3E\C544\BCF4\AE30 \C544\C774\CF58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105333944677309724)
,p_name=>'BROWSE_PACKAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D0A4\C9C0 \CC3E\C544\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105274585520309677)
,p_name=>'BROWSE_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \CC3E\C544\BCF4\AE30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104865896169309368)
,p_name=>'BU.APPLICATION_ACLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ACL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104862154911309364)
,p_name=>'BU.APPLICATION_COMPUTATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104910478252309404)
,p_name=>'BU.APPLICATION_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C744 \BC31\C5C5\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104862260084309365)
,p_name=>'BU.APPLICATION_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104862443248309365)
,p_name=>'BU.APPLICATION_PROCESSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104910191623309404)
,p_name=>'BU.APPLICATION_RESTORED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C774 %1 \AC1C\C815\C5D0\C11C \BCF5\C6D0\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104862078505309364)
,p_name=>'BU.APPLICATION_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105672989824310006)
,p_name=>'BU.APP_PROPS_MODIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C18D\C131: \C218\C815\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105416202922309790)
,p_name=>'BU.AUTHENTICATION_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104863129766309365)
,p_name=>'BU.AUTHENTICATION_SCHEMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104863275024309365)
,p_name=>'BU.AUTHORIZATION_SCHEMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104864854690309367)
,p_name=>'BU.BREADCRUMBS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104864991753309367)
,p_name=>'BU.BREADCRUMB_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104862388538309365)
,p_name=>'BU.BUILD_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104865196956309367)
,p_name=>'BU.BUTTON_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104865007386309367)
,p_name=>'BU.CALENDAR_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105416018234309790)
,p_name=>'BU.COMPONENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105827204927310129)
,p_name=>'BU.COMPONENTS_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AD\C81C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105827183676310129)
,p_name=>'BU.COMPONENTS_MODIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C218\C815\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105827088004310129)
,p_name=>'BU.COMPONENTS_NEW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0C8\B85C \B9CC\B4E4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104863567031309366)
,p_name=>'BU.COMPONENT_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104870036012309372)
,p_name=>'BU.CREDENTIALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104866302160309368)
,p_name=>'BU.DATA_LOADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104874247864309376)
,p_name=>'BU.DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AD\C81C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104874310657309376)
,p_name=>'BU.DEVELOPERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104863777866309366)
,p_name=>'BU.EMAIL_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104910528367309404)
,p_name=>'BU.IN_PROGRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BC31\C5C5\C774 \C9C4\D589 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104865401503309367)
,p_name=>'BU.LABEL_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105416429282309790)
,p_name=>'BU.LAST_BACKUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C885 \BC31\C5C5: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105415970651309790)
,p_name=>'BU.LAST_UPDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C885 \C5C5\B370\C774\D2B8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104862558286309365)
,p_name=>'BU.LISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104865300668309367)
,p_name=>'BU.LIST_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104910274688309404)
,p_name=>'BU.LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104862833642309365)
,p_name=>'BU.LOVS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104865716407309368)
,p_name=>'BU.LOV_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('LOV \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104869953558309372)
,p_name=>'BU.MESSAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104874129741309375)
,p_name=>'BU.MODIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C218\C815\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104863013537309365)
,p_name=>'BU.NAVIGATION_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \BA54\B274')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105416194620309790)
,p_name=>'BU.NEW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0C8\B85C \B9CC\B4E4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104864702081309367)
,p_name=>'BU.PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105826906645310128)
,p_name=>'BU.PAGES_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AD\C81C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105826806148310128)
,p_name=>'BU.PAGES_MODIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C218\C815\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105826773217310128)
,p_name=>'BU.PAGES_NEW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0C8\B85C \B9CC\B4E4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104862976541309365)
,p_name=>'BU.PLUGINS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104865215655309367)
,p_name=>'BU.REGION_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104870272783309372)
,p_name=>'BU.REMOTE_SERVERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\BC84 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104866113063309368)
,p_name=>'BU.REPORT_LAYOUTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \B808\C774\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104865666058309368)
,p_name=>'BU.REPORT_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105371217689309751)
,p_name=>'BU.RESTORED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C6D0\B41C \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104900564555309397)
,p_name=>'BU.RESTORED_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C774 \BC31\C5C5 \AC1C\C815 %0\C5D0\C11C \BCF5\C6D0\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104864211376309366)
,p_name=>'BU.REST_ENABLED_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104866020072309368)
,p_name=>'BU.SHARED_QUERIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C720 \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104863691571309366)
,p_name=>'BU.SHORTCUTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104863907522309366)
,p_name=>'BU.STATIC_APPLICATION_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \C560\D50C\B9AC\CF00\C774\C158 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104864027003309366)
,p_name=>'BU.STATIC_WORKSPACE_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \C791\C5C5\C601\C5ED \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104907475868309402)
,p_name=>'BU.SUMMARY_NOT_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD \C694\C57D\C744 \C0AC\C6A9\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104865592747309367)
,p_name=>'BU.TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104864181517309366)
,p_name=>'BU.TEXT_MESSAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104862722741309365)
,p_name=>'BU.THEMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104865936164309368)
,p_name=>'BU.TREES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104910332326309404)
,p_name=>'BU.UNLOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE08 \D574\C81C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104862649111309365)
,p_name=>'BU.USER_INTERFACES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \C18D\C131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104863356655309365)
,p_name=>'BU.WEB_CREDENTIALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C778\C99D\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104866283657309368)
,p_name=>'BU.WEB_SERVICES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104870152156309372)
,p_name=>'BU.WEB_SOURCES'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104890087193309389)
,p_name=>'BUFFER CACHE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\D37C \CE90\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105345763156309732)
,p_name=>'BUG'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105369052042309749)
,p_name=>'BUGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105390481511309765)
,p_name=>'BUGS_ASSIGNED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \BC84\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105427624828309800)
,p_name=>'BUGS_ASSIGNED_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \BC84\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104918663646309410)
,p_name=>'BUGS_CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\ACB0\B41C \BC84\ADF8(%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105696173356310026)
,p_name=>'BUGS_PERCENT_CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\ADF8 \C885\ACB0\C728(%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105427747091309800)
,p_name=>'BUGS_UNASSIGNED_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B418\C9C0 \C54A\C740 \BC84\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105427869361309800)
,p_name=>'BUGS_WITHOUT_FIXBY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC\BCC4 \C218\C815 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105696545811310026)
,p_name=>'BUG_FEEDBACK_DASH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\ADF8: %1/%0 \C885\ACB0\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106095084880310360)
,p_name=>'BUG_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\ADF8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105384190628309761)
,p_name=>'BUILD QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \C791\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104873900919309375)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVA'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104873872616309375)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVASCRIPT'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104873756888309375)
,p_name=>'BUILDER.CODE_LANGUAGE.PLSQL'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104874062787309375)
,p_name=>'BUILDER.CODE_LANGUAGE.PYTHON'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104873652680309375)
,p_name=>'BUILDER.CODE_LANGUAGE.SQL'
,p_message_language=>'ko'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105478254491309842)
,p_name=>'BUILDER.PLUGINS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105475603122309840)
,p_name=>'BUILDER.UNSUPPORTED_COMPONENT'
,p_message_language=>'ko'
,p_message_text=>unistr('[\C9C0\C6D0\B418\C9C0 \C54A\B294 \D56D\BAA9]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105674965960310008)
,p_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105079737540309527)
,p_name=>'BUILD_OPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105525250764309882)
,p_name=>'BUILD_OPTION_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106093707655310359)
,p_name=>'BUILD_STATUS_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C0C1\D0DC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105526013139309883)
,p_name=>'BUILD_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \BC84\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105421559706309795)
,p_name=>'BUILT_IN_REPORT_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105330162835309720)
,p_name=>'BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105518366413309876)
,p_name=>'BUTTON.ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104898270045309395)
,p_name=>'BUTTON.DA.INVALID.BUTTON_ATTR_CONTAIN_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \B2E8\CD94\C758 \B2E8\CD94 \C18D\C131\C5D0\B294 ID\AC00 \D3EC\D568\B420 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104898149791309395)
,p_name=>'BUTTON.DA.INVALID.NOT_DEFINED_BY_DA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \B2E8\CD94\B294 \C791\C5C5\C774 ''\B3D9\C801 \C791\C5C5\C5D0 \C758\D574 \C815\C758\B428''\C73C\B85C \C124\C815\B41C \B2E8\CD94\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104898371452309396)
,p_name=>'BUTTON.DA.INVALID.TEMPLATE_NO_BUTTON_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \B2E8\CD94\AC00 #BUTTON_ID# \B300\CCB4 \BB38\C790\C5F4\C744 \D3EC\D568\D558\C9C0 \C54A\C740 ''\B2E8\CD94 \D15C\D50C\B9AC\D2B8''\B97C \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105518194149309876)
,p_name=>'BUTTON.DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104956702778309438)
,p_name=>'BUTTON.INVALID.ACTION.REDIRECT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104935456392309423)
,p_name=>'BUTTON.INVALID.ACTION.REPORT_QRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C9C8\C758\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104933551647309421)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C694\CCAD \C18C\C2A4 \C720\D615\C774 "\D56D\C0C1 \B110"\C774 \C544\B2D0 \ACBD\C6B0 \BAA8\B4E0 \B2E8\CD94 \C694\CCAD \C18C\C2A4 \C720\D615\C5D0 \B300\D574 \B2E8\CD94 \C694\CCAD\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104934244552309422)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C694\CCAD \C18C\C2A4 \C720\D615\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104956869381309438)
,p_name=>'BUTTON.INVALID.ACTION.URL_TARGET'
,p_message_language=>'ko'
,p_message_text=>unistr('URL \B300\C0C1\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104900257816309397)
,p_name=>'BUTTON.INVALID.BUTTON_ATTR_HAS_ID_WHEN_DA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C774 ''\B3D9\C801 \C791\C5C5\C5D0 \C758\D574 \C815\C758\B428''\C778 \ACBD\C6B0 \B2E8\CD94 \C18D\C131\C5D0\B294 ID\AC00 \D3EC\D568\B420 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104957987405309439)
,p_name=>'BUTTON.INVALID.STYLE.IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104958017829309439)
,p_name=>'BUTTON.INVALID.STYLE.NO_STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0C0\C77C\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104957829208309439)
,p_name=>'BUTTON.INVALID.STYLE.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104900121678309397)
,p_name=>'BUTTON.INVALID.TEMPLATE_NO_BUTTON_ID_WHEN_DA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C2A4\D0C0\C77C\C774 ''\D15C\D50C\B9AC\D2B8 \AE30\BC18 \B2E8\CD94''\C774\ACE0 \C791\C5C5\C774 ''\B3D9\C801 \C791\C5C5\C5D0 \C758\D574 \C815\C758\B428''\C778 \ACBD\C6B0 \C120\D0DD\D55C \B2E8\CD94 \D15C\D50C\B9AC\D2B8\C5D0\B294 #BUTTON_ID# \B300\CCB4 \BB38\C790\C5F4\C774 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104888068421309387)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_AFFECTED_ELEMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94\AC00 \B3D9\C801 \C791\C5C5(\D398\C774\C9C0: %0, \B3D9\C801 \C791\C5C5: ''%1'', \C791\C5C5: ''%2'', \C18D\C131: ''\C601\D5A5\C744 \BC1B\B294 \C694\C18C'')\C5D0\C11C \CC38\C870\B418\BBC0\B85C \B2E8\CD94\B97C \C0AD\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104887977166309387)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_WHEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94\AC00 \B3D9\C801 \C791\C5C5(\D398\C774\C9C0: %0, \B3D9\C801 \C791\C5C5: ''%1'', \C18D\C131: ''\C2DC\AE30'')\C5D0\C11C \CC38\C870\B418\BBC0\B85C \B2E8\CD94\B97C \C0AD\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105518282668309876)
,p_name=>'BUTTON.SUBMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105514454965309873)
,p_name=>'BUTTON.TEMPLATE.JAVASCRIPT'
,p_message_language=>'ko'
,p_message_text=>unistr('"onclick" \C18D\C131\C5D0 \C0AC\C6A9\B420 \C608\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105517697118309875)
,p_name=>'BUTTON.TEMPLATE.LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('"href" \C18D\C131\C5D0 \C0AC\C6A9\B420 \C608\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104956677589309438)
,p_name=>'BUTTONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105397284195309770)
,p_name=>'BUTTON_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106093567437310359)
,p_name=>'BUTTON_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105401585803309773)
,p_name=>'BUTTON_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D15C\D50C\B9AC\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104953934769309436)
,p_name=>'BYTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\C774\D2B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105345306777309732)
,p_name=>'BY_NEXT_PATCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \D328\CE58\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105345435926309732)
,p_name=>'BY_NEXT_RELEASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B9B4\B9AC\C2A4\B85C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106168165853310426)
,p_name=>'CA.ABOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106134478327310397)
,p_name=>'CA.ABOUT.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106134388034310397)
,p_name=>'CA.ABOUT.PAGE.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \C124\BA85, \C560\D50C\B9AC\CF00\C774\C158 \BC84\C804 \BC0F \D398\C774\C9C0 \C218\B97C \B098\D0C0\B0B4\B294 \C774 \C560\D50C\B9AC\CF00\C774\C158 \C815\BCF4 \D398\C774\C9C0\B97C \D3EC\D568\D569\B2C8\B2E4.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105057338024309511)
,p_name=>'CA.ABOUT.PAGE.HELP.CONTENT.CONTAINER'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20 \CEE8\D14C\C774\B108')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106168356885310426)
,p_name=>'CA.ABOUT.THIS.APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106168446598310426)
,p_name=>'CA.ABOUT.THIS.APPLICATION.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \D14D\C2A4\D2B8\B97C \C5EC\AE30\C5D0 \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106168015440310426)
,p_name=>'CA.ABOUT.THIS.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106179240176310434)
,p_name=>'CA.ABOUT.THIS.PREVIEW.RELEASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BBF8\B9AC\BCF4\AE30 \B9B4\B9AC\C2A4 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105017298228309482)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\C2E0\C744 \AD00\B9AC\C790\C5D0\C11C \C81C\AC70\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105017156723309482)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\C2A4\B85C \AD00\B9AC\C790 \B864\C744 \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106134718679310397)
,p_name=>'CA.ACCESS.CONTROL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106170645587310428)
,p_name=>'CA.ACCESS.CONTROL.ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106160132503310420)
,p_name=>'CA.ACCESS.CONTROL.CONFIGURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106133116690310395)
,p_name=>'CA.ACCESS.CONTROL.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864 \AE30\BC18 \C0AC\C6A9\C790 \AD8C\D55C \BD80\C5EC \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106134819354310397)
,p_name=>'CA.ACCESS.CONTROL.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0\C11C \B864 \AE30\BC18 \C0AC\C6A9\C790 \C778\C99D\C744 \D1B5\D569\D569\B2C8\B2E4.'),
unistr('\C0AC\C6A9\C790\B294 \AD00\B9AC\C790, \C81C\ACF5\C790 \B610\B294 \C870\D68C\C790\B85C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\ADF8\B7EC\BA74 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \D398\C774\C9C0, \BA54\B274 \D56D\BAA9, \C601\C5ED, \C5F4, \D56D\BAA9, \B2E8\CD94 \B4F1\ACFC \AC19\C740 \B2E4\C591\D55C \AD6C\C131\C694\C18C\C5D0 \B300\D55C \C11C\B85C \B2E4\B978 \B864\C5D0 \B300\D574 \B2E4\B978 \C561\C138\C2A4 \AD8C\D55C\C744 \C190\C27D\AC8C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B429\B2C8\B2E4.'),
'<ul>',
unistr('<li>\C81C\C5B4 \AE30\B2A5\C5D0 \C561\C138\C2A4\D560 \C218 \C788\B294 \B9C1\D06C\AC00 \C81C\ACF5\B418\B294 \AD00\B9AC \D398\C774\C9C0 \C601\C5ED</li>'),
unistr('<li>\C561\C138\C2A4 \C81C\C5B4\B97C \AD00\B9AC\D560 \C218 \C788\B294 \C0AC\C6A9\C790 \D14C\C774\BE14</li>'),
unistr('<li>\C778\C99D\B41C \C0AC\C6A9\C790\C758 \C561\C138\C2A4 \B808\BCA8\C744 \C124\C815\D560 \C218 \C788\B294 \AD6C\C131 \D398\C774\C9C0</li>'),
unistr('<li>\C0AC\C6A9\C790 \C774\B984\C774 \C804\C790\BA54\C77C \C8FC\C18C\C778\C9C0 \C5EC\BD80\B97C \C9C0\C815\D560 \C218 \C788\B294 \AD6C\C131 \D398\C774\C9C0</li>'),
unistr('<li>\C0AC\C6A9\C790 \C561\C138\C2A4\B97C \BCF4\ACE0\D558\ACE0 \D3B8\C9D1\D560 \C218 \C788\B294 \C0AC\C6A9\C790 \C561\C138\C2A4 \D398\C774\C9C0 \AD00\B9AC</li>'),
unistr('<li>\B2E8\C77C \C0AC\C6A9\C790\B97C \CD94\AC00\D560 \C218 \C788\B294 \AE30\B2A5\C744 \C0AC\C6A9\D558\C5EC \C0AC\C6A9\C790 \D398\C774\C9C0 \CD94\AC00</li>'),
unistr('<li>\C5EC\B7EC \C0AC\C6A9\C790(\C804\C790\BA54\C77C \C0AC\C6A9\C790 \C774\B984\B9CC \D574\B2F9)\B97C \CD94\AC00\D560 \C218 \C788\B294 \AE30\B2A5\C744 \C0AC\C6A9\D558\C5EC \C5EC\B7EC \C0AC\C6A9\C790 \D398\C774\C9C0 \CD94\AC00</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106159042624310419)
,p_name=>'CA.ACCESS.ROLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106159713910310420)
,p_name=>'CA.ACCESS.ROLE.ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \B864 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104988810478309461)
,p_name=>'CA.ACCESS.ROLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106159144561310419)
,p_name=>'CA.ACCOUNT.LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C815\C774 \C7A0\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105016725714309482)
,p_name=>'CA.ACKNOWLEDGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106170472325310428)
,p_name=>'CA.ACL.INFORMATION'
,p_message_language=>'ko'
,p_message_text=>unistr('ACL \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106171147493310428)
,p_name=>'CA.ACL.NOT.ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C\C774 \CDA9\BD84\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\AC00 \AD00\B9AC\C790\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106171209975310428)
,p_name=>'CA.ACL.NOT.AUTHORIZED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C744 \BCFC \C218 \C788\B294 \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4. \C561\C138\C2A4\AC00 \BD80\C5EC\B418\C9C0 \C54A\C558\AC70\B098 \ACC4\C815\C774 \C7A0\ACA8 \C788\C2B5\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106171396136310428)
,p_name=>'CA.ACL.NOT.CONTRIBUTOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C\C774 \CDA9\BD84\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\AC00 \C81C\ACF5\C790\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106160897696310421)
,p_name=>'CA.ACL.SAVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \C124\C815\C744 \C800\C7A5\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106165541040310424)
,p_name=>'CA.ACTION.BUTTON.HTML'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \B2E8\CD94 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106164410952310423)
,p_name=>'CA.ACTION.LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106164529876310423)
,p_name=>'CA.ACTION.LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106167170979310425)
,p_name=>'CA.ACTION.LINK.HTML'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \B9C1\D06C HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106152678185310414)
,p_name=>'CA.ACTION.PROCESSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C774 \CC98\B9AC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106158114946310419)
,p_name=>'CA.ACTIVITY.BY.HOUR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04\BCC4 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106191306824310443)
,p_name=>'CA.ACTIVITY.DASHBOARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \B300\C2DC\BCF4\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106134990538310397)
,p_name=>'CA.ACTIVITY.REPORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106134164122310396)
,p_name=>'CA.ACTIVITY.REPORTING.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C791\C5C5 \BC0F \C624\B958 \BCF4\ACE0\C11C \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106135001011310397)
,p_name=>'CA.ACTIVITY.REPORTING.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BC18 \C0AC\C6A9\C790 \C791\C5C5\C5D0 \B300\D55C \B2E4\C591\D55C \BCF4\ACE0\C11C\B97C \D3EC\D568\D569\B2C8\B2E4. \AC00\C7A5 \D65C\BC1C\D55C \C0AC\C6A9\C790, \AC00\C7A5 \B9CE\C774 \C0AC\C6A9\B41C \D398\C774\C9C0, \D398\C774\C9C0\C758 \C131\ACFC \BC0F \BC1C\C0DD\D55C \C624\B958\B97C \D655\C778\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C774 \C5B4\B5BB\AC8C \D65C\C6A9\B418\ACE0 \C788\B294\C9C0 \BC0F \AC1C\C120 \C601\C5ED\C744 \B354 \D6A8\C728\C801\C73C\B85C \D30C\C545\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B429\B2C8\B2E4.'),
'<ul>',
unistr('<li>\C0C1\C704 \C0AC\C6A9\C790 \BCF4\ACE0\C11C</li>'),
unistr('<li>\C560\D50C\B9AC\CF00\C774\C158 \C624\B958 \B85C\ADF8 \BCF4\ACE0\C11C</li>'),
unistr('<li>\D398\C774\C9C0\BCC4 \D398\C774\C9C0 \C131\ACFC, \C791\C5C5 \BC0F \C131\B2A5</li>'),
unistr('<li>\D398\C774\C9C0\BCC4 \C560\D50C\B9AC\CF00\C774\C158 \C791\C5C5 \BCF4\ACE0\C11C</li>'),
unistr('<li>\D398\C774\C9C0 \BDF0 \C138\BD80\C815\BCF4 \BCF4\ACE0\C11C</li>'),
'',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105381156384309758)
,p_name=>'CA.ACTUAL.START.DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\C81C \C2DC\C791 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106170353693310427)
,p_name=>'CA.ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106165701640310424)
,p_name=>'CA.ADD.EMAIL.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106182242914310436)
,p_name=>'CA.ADD.MULTI.USERS.STEP.2'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \C0AC\C6A9\C790 \CD94\AC00 - \B2E8\ACC4 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106168626583310426)
,p_name=>'CA.ADD.NEW.WIDGET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 %0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106151605834310413)
,p_name=>'CA.ADD.NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106057281353310325)
,p_name=>'CA.ADD.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106159882208310420)
,p_name=>'CA.ADD.USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106182657241310437)
,p_name=>'CA.ADD.USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106136500996310399)
,p_name=>'CA.ADDING.PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106137042307310399)
,p_name=>'CA.ADDING.PAGES.DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('<p><strong>\D398\C774\C9C0 \CD94\AC00</strong>\B97C \B20C\B7EC \C560\D50C\B9AC\CF00\C774\C158\C5D0 \D398\C774\C9C0\B97C \CD94\AC00\D569\B2C8\B2E4. \ADF8\B7F0 \B2E4\C74C \D398\C774\C9C0 \C720\D615(\C608: \BE44\C5B4 \C788\C74C, \CC28\D2B8, \D3FC, \BCF4\ACE0\C11C \B4F1)\C744 \C120\D0DD\D558\ACE0 \D574\B2F9 \C18D\C131\C744 \C815\C758\D569\B2C8\B2E4. \C801\D569\D55C \D14C\C774\BE14 \B610\B294 \BDF0\B97C \C9C0\C815\D558\AC70\B098 SQL \C6CC\D06C\C20D\C744 \C0AC\C6A9\D558\C5EC \C791\C5C5\C601\C5ED\C5D0\C11C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C900\BE44\D574\C57C \D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106166549370310425)
,p_name=>'CA.ADDITIONAL.HTML.TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105380476609309758)
,p_name=>'CA.ADDITIONAL.INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106159521634310420)
,p_name=>'CA.ADDRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106139739090310402)
,p_name=>'CA.ADMIN.ACCESS.CONTROL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106140341944310402)
,p_name=>'CA.ADMIN.ACCESS.CONTROL.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \C778\C99D\B41C \C0AC\C6A9\C790\C5D0 \B300\D55C \C561\C138\C2A4 \B808\BCA8 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106138868273310401)
,p_name=>'CA.ADMIN.ACTIVITY.REPORTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106139885770310402)
,p_name=>'CA.ADMIN.ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106141571421310403)
,p_name=>'CA.ADMIN.ADMINISTRATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106140286353310402)
,p_name=>'CA.ADMIN.ADMINISTRATORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105413652528309782)
,p_name=>'CA.ADMIN.APP.CONFIGURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105513270307309872)
,p_name=>'CA.ADMIN.APP.USER_INTERFACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106175110635310431)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106175263227310431)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106138443319310400)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106138527914310400)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C560\D50C\B9AC\CF00\C774\C158 \BAA8\C591 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106138127714310400)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131 \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106138079305310400)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AE30\B2A5 \C0AC\C6A9 \B610\B294 \C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106139142597310401)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C624\B958 \B85C\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106139265025310401)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C774 \B85C\AE45\D55C \C624\B958 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106138654482310401)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106138715827310401)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C774\B984 \BC0F \AC04\B2E8\D55C \C124\BA85 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106138291326310400)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106138373275310400)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C5C5\B370\C774\D2B8 \BAA9\B85D \C720\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106137746962310400)
,p_name=>'CA.ADMIN.CONFIGURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106140166181310402)
,p_name=>'CA.ADMIN.CONTRIBUTORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106190147433310442)
,p_name=>'CA.ADMIN.DASHBOARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C2DC\BCF4\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106190062753310442)
,p_name=>'CA.ADMIN.DASHBOARD.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C791\C5C5 \CE21\C815\D56D\BAA9 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106143230795310405)
,p_name=>'CA.ADMIN.DEFAULT.TZ'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C2DC\AC04\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106143333265310405)
,p_name=>'CA.ADMIN.DEFAULT.TZ.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \AE30\BCF8 \C2DC\AC04\B300 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106141082972310403)
,p_name=>'CA.ADMIN.EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106143434528310405)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106143557355310405)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C\C744 \C804\C1A1\D574\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C124\C815\D558\ACE0 \C804\C1A1\D560 \ACBD\C6B0 \D68C\C2E0 \B300\C0C1 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106140507522310402)
,p_name=>'CA.ADMIN.FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106140821536310403)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106140998471310403)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80\B97C \D5C8\C6A9\D574\C57C \D560\C9C0 \C5EC\BD80\B97C \AD00\B9AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106140612865310402)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D53C\B4DC\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106140770133310403)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C0AC\C6A9\C790\AC00 \C81C\CD9C\D55C \BAA8\B4E0 \D53C\B4DC\BC31 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106141148630310403)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106141203543310403)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C6A9\D558\B294 \C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8 HTML \BC0F CSS \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106137855752310400)
,p_name=>'CA.ADMIN.NOTIFICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106137994719310400)
,p_name=>'CA.ADMIN.NOTIFICATIONS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648 \D398\C774\C9C0\C5D0 \D1B5\C9C0 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106175806978310432)
,p_name=>'CA.ADMIN.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106057951652310326)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654 \B85C\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106058023936310326)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C774 \B85C\AE45\D55C \C790\B3D9\D654 \C2E4\D589 \BC0F \BA54\C2DC\C9C0 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106139300858310401)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C131\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106139438666310401)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D398\C774\C9C0\BCC4 \C791\C5C5 \BC0F \C131\B2A5 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106139560959310401)
,p_name=>'CA.ADMIN.PAGE.VIEWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106139666057310402)
,p_name=>'CA.ADMIN.PAGE.VIEWS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \B0A0\C9DC \BC0F \ACBD\ACFC \C2DC\AC04\C744 \D3EC\D568\D558\C5EC \C0AC\C6A9\C790\BCC4 \AC01 \D398\C774\C9C0 \BDF0 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106140048392310402)
,p_name=>'CA.ADMIN.READERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\D68C\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106183347765310437)
,p_name=>'CA.ADMIN.SEND.EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C804\C1A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106183444551310437)
,p_name=>'CA.ADMIN.SEND.EMAIL.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \D15C\D50C\B9AC\D2B8 \AE30\BC18 \C804\C790\BA54\C77C \C804\C1A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106138936375310401)
,p_name=>'CA.ADMIN.TOP.USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704 \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106139097443310401)
,p_name=>'CA.ADMIN.TOP.USERS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\BCC4\B85C \C9D1\ACC4\B41C \D398\C774\C9C0 \BDF0 \BCF4\ACE0\C11C\C785\B2C8\B2E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106139935057310402)
,p_name=>'CA.ADMIN.USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106140439822310402)
,p_name=>'CA.ADMIN.USERS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \C124\C815 \BCC0\ACBD \BC0F \C561\C138\C2A4 \C81C\C5B4 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106141301044310403)
,p_name=>'CA.ADMIN.VIEW.LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \B85C\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106141439255310403)
,p_name=>'CA.ADMIN.VIEW.LOG.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C774 \BCF4\B0B8 \C804\C790\BA54\C77C\C5D0 \B300\D55C \B85C\ADF8 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105148915426309584)
,p_name=>'CA.ADVANCED'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>\ACE0\AE09</strong> - \ACE0\AE09 \C635\C158\C744 \D45C\C2DC\D558\B824\BA74 \D655\C7A5\D569\B2C8\B2E4.'),
'    <ul>',
unistr('      <li><strong>\D648 \D398\C774\C9C0\B85C \C124\C815</strong> - \C774 \D398\C774\C9C0\B97C \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \D648 \D398\C774\C9C0\B85C \B9CC\B4E4\B824\BA74 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;\C774\C804\C5D0 \D648 \D398\C774\C9C0\B85C \C815\C758\B41C \BAA8\B4E0 \D398\C774\C9C0\B294 \C5C5\B370\C774\D2B8\B429\B2C8\B2E4.</li>'),
unistr('      <li><strong>\AD00\B9AC \D398\C774\C9C0\B85C \C124\C815</strong> - \C774 \D398\C774\C9C0\B97C \C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BC18 \D398\C774\C9C0\AC00 \C544\B2CC \AD00\B9AC \D398\C774\C9C0\B85C \CD94\AC00\D569\B2C8\B2E4. \AE30\BCF8 \BA54\B274\C5D0\C11C [\AD00\B9AC]\B97C \B204\B978 \B2E4\C74C [\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC] \BAA9\B85D\C5D0\C11C \C120\D0DD\D558\C5EC \C561\C138\C2A4\D569\B2C8\B2E4.<br>'),
unistr('        <em><strong>\CC38\ACE0:</strong> \D55C \D398\C774\C9C0\B97C \D648 \D398\C774\C9C0\C640 \AD00\B9AC \D398\C774\C9C0\B85C \C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</em></li>'),
'      &nbsp;<br>',
unistr('      <li><strong>\D398\C774\C9C0 \B3C4\C6C0\B9D0</strong> - \D398\C774\C9C0\C5D0 \B300\D55C \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\C5D0 \CD94\AC00\D560 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105036021100309496)
,p_name=>'CA.ADVANCED.PAGE_HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>\ACE0\AE09</strong> - \ACE0\AE09 \C635\C158\C744 \BCF4\B824\BA74 \D655\C7A5\D569\B2C8\B2E4.'),
'    <ul>',
unistr('      <li><strong>\D398\C774\C9C0 \B3C4\C6C0\B9D0</strong> - \D398\C774\C9C0\C758 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\C5D0 \CD94\AC00\D560 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106176222544310432)
,p_name=>'CA.ADVANCED.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106176384447310432)
,p_name=>'CA.ADVANCED.SETTINGS.DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\CD94\AC00 \C815\C758, \BCF4\C548 \BC0F \C804\C5ED\D654 \C124\C815\C744 \AD6C\C131\D569\B2C8\B2E4. \D574\B2F9 \C124\C815\C740 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D560 \B54C \C801\C6A9\D560 \C218 \C788\C73C\BA70 \C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131 \D6C4\C5D0\B3C4 \D3B8\C9D1\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106178264220310433)
,p_name=>'CA.ADVANCED.SETTINGS.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C790\C138\D55C \B0B4\C6A9\C740 \AC01 \C124\C815\C5D0 \B300\D55C \D56D\BAA9 \B3C4\C6C0\B9D0(<span class="fa fa-question-circle" aria-hidden="true"></span>)\C744 \D655\C778\D558\C2ED\C2DC\C624.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106184045759310438)
,p_name=>'CA.AFTER.ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106165403534310424)
,p_name=>'CA.AFTER.ROWS.HTML'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \B4A4 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106168534082310426)
,p_name=>'CA.ALL.COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106164641730310423)
,p_name=>'CA.ALLOW.OPT.OUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C2E0 \AC70\BD80 \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105374019804309753)
,p_name=>'CA.ALLOW.RUNS.IN.RESTRICTED.MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\D55C \BAA8\B4DC\B85C \C2E4\D589 \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106158040624310418)
,p_name=>'CA.APP.ERROR.LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C624\B958 \B85C\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106153998628310415)
,p_name=>'CA.APP.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105424082699309797)
,p_name=>'CA.APP.SETTING.ACL_ENABLED.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4\AC00 \C124\C815\B418\C5B4 \C788\B294\C9C0 \C5EC\BD80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105424102234309797)
,p_name=>'CA.APP.SETTING.ACL_SCOPE.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0 \C5C6\B294 \C778\C99D\B41C \C0AC\C6A9\C790\C5D0\AC8C \C81C\ACF5\B418\B294 \AE30\BCF8 \C561\C138\C2A4 \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106154379753310415)
,p_name=>'CA.APP.SETTINGS.UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C124\C815\C744 \C5C5\B370\C774\D2B8\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106154129500310415)
,p_name=>'CA.APP.SUBTITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\B2E8\D55C \C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106154255520310415)
,p_name=>'CA.APP.SUBTITLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5EC\AE30\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\B294 \C560\D50C\B9AC\CF00\C774\C158\C758 \D648 \D398\C774\C9C0\C5D0 \C788\B294 \C560\D50C\B9AC\CF00\C774\C158 \C774\B984 \C544\B798\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106143679014310405)
,p_name=>'CA.APPEARANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106143707278310405)
,p_name=>'CA.APPEARANCE.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AE30\BCF8 \C560\D50C\B9AC\CF00\C774\C158 \C0C9\C0C1 \CCB4\ACC4(\D14C\B9C8 \C2A4\D0C0\C77C), \D0D0\C0C9\C774 \C788\B294 \C704\CE58 \BC0F \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C0AC\C6A9\B41C \C544\C774\CF58\C744 \C815\C758\D569\B2C8\B2E4.</p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106163132850310422)
,p_name=>'CA.APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106150215153310411)
,p_name=>'CA.APPLICATION.APPEARANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BAA8\C591')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106144268380310406)
,p_name=>'CA.APPLICATION.ICON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C544\C774\CF58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106144358925310406)
,p_name=>'CA.APPLICATION.ICON.DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('<p><strong>\C0C8 \C544\C774\CF58 \C120\D0DD</strong>\C744 \B20C\B7EC \C544\C774\CF58 \C0C9\C0C1 \BC0F \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58 \C911 \D558\B098\B97C \C120\D0DD\D569\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \D648 \D398\C774\C9C0\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106144667604310406)
,p_name=>'CA.APPLICATION.ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106144772377310406)
,p_name=>'CA.APPLICATION.ID.DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \ACE0\C720\D55C \C22B\C790 \C2DD\BCC4\C790\B97C \C785\B825\D569\B2C8\B2E4. \C774 \D544\B4DC\C5D0\B294 \AE30\BCF8\C801\C73C\B85C \C790\B3D9\C73C\B85C \C0DD\C131\B41C \C2DD\BCC4\C790\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106163708408310423)
,p_name=>'CA.APPLICATION.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106155950846310417)
,p_name=>'CA.APPLICATION.SESSIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C138\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106134595526310397)
,p_name=>'CA.APPLICATION.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106133418293310396)
,p_name=>'CA.APPLICATION.SETTINGS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C774\B984 \BC0F \AC04\B2E8\D55C \C124\BA85 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106134648488310397)
,p_name=>'CA.APPLICATION.SETTINGS.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158 \C774\B984 \BC0F \C124\BA85, \AE30\BCF8 \C2DC\AC04\B300 \B4F1\ACFC \AC19\C740 \B2E4\C591\D55C \C124\C815\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B429\B2C8\B2E4.'),
'<ul>',
unistr('<li>\AD00\B9AC \D398\C774\C9C0 \BAA9\B85D \D56D\BAA9 \BC0F \D3FC</li>'),
unistr('<li>\C560\D50C\B9AC\CF00\C774\C158 \C774\B984 \C124\C815 \AE30\B2A5</li>'),
unistr('<li>\D648 \D398\C774\C9C0 \C8FC \C601\C5ED \BD80\C81C \C124\C815 \AE30\B2A5</li>'),
unistr('<li>\D53C\B4DC\BC31\C744 \C0AC\C6A9\D558\B294 \ACBD\C6B0 \D53C\B4DC\BC31 \C218\C2E0\C790 \C124\C815 \AE30\B2A5</li>'),
unistr('<li>\C560\D50C\B9AC\CF00\C774\C158 \AE30\BCF8 \C2DC\AC04\B300 \C124\C815 \AE30\B2A5</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106189183585310441)
,p_name=>'CA.APPLICATIONITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106190964497310443)
,p_name=>'CA.APPLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106192760340310444)
,p_name=>'CA.APPLY.APP.DEFAULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AE30\BCF8\AC12 \C801\C6A9 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106149479100310411)
,p_name=>'CA.APPLY.CHANGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106190709675310443)
,p_name=>'CA.APPLY.FILTERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105511325691309870)
,p_name=>'CA.APP_BANNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131 \B9C8\BC95\C0AC %0\C5D0\C11C \C0DD\C131\B41C \C560\D50C\B9AC\CF00\C774\C158\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105512654668309871)
,p_name=>'CA.APP_SETTING.SAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815 \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106194954540310446)
,p_name=>'CA.ATTACHMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105250856578309659)
,p_name=>'CA.ATTACHMENT.COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \D30C\C77C \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106195071916310446)
,p_name=>'CA.ATTACHMENT.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105250700970309659)
,p_name=>'CA.ATTACHMENT.SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \D30C\C77C \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106191030197310443)
,p_name=>'CA.ATTR.DEFAULT.DUPLICATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 %0\C5D0 \B300\D55C \C18D\C131 \AE30\BCF8\AC12\C774 \C774\BBF8 \C815\C758\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106160230186310420)
,p_name=>'CA.AUTH.USER.MAY.ACCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\B41C \BAA8\B4E0 \C0AC\C6A9\C790\B294 \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106145421399310407)
,p_name=>'CA.AUTHENTICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106145569739310407)
,p_name=>'CA.AUTHENTICATION.DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D574 \C778\C99D\D558\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105376799616309755)
,p_name=>'CA.AUTO.DROP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106058622595310326)
,p_name=>'CA.AUTOMATION_EXECUTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654 \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106156639708310417)
,p_name=>'CA.AVG.ELAPSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3C9\ADE0 \ACBD\ACFC \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105421314650309795)
,p_name=>'CA.BACK.TO.JOBS.REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BCF4\ACE0\C11C\B85C \B3CC\C544\AC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105251535698309660)
,p_name=>'CA.BCC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\C740 \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106183967316310438)
,p_name=>'CA.BEFORE.ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106165338834310424)
,p_name=>'CA.BEFORE.ROWS.HTML'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C55E HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106166838427310425)
,p_name=>'CA.BEGIN.ROW.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C55E \CF58\D150\CE20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106142108784310404)
,p_name=>'CA.BLANK'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE48 \D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106142296512310404)
,p_name=>'CA.BLANK.DETAILS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BE48 \D398\C774\C9C0\B97C \C704\CE58 \D45C\C2DC\C790\B85C \C0DD\C131\D569\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D55C \D6C4\C5D0\B294 \D398\C774\C9C0 \B514\C790\C774\B108\C5D0\C11C \AC04\D3B8\D558\AC8C \D398\C774\C9C0\C5D0 \C601\C5ED\C744 \C0DD\C131\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\D398\C774\C9C0 \C774\B984</strong>(\D544\C218) - \C774 \D398\C774\C9C0\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C544\C774\CF58 \C124\C815</strong> - \C774 \D398\C774\C9C0\C758 \D0D0\C0C9 \BA54\B274\C5D0 \D45C\C2DC\D560 \C544\C774\CF58\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('<!--  <li><strong>\D398\C774\C9C0 \D0D0\C0C9 \D3EC\D568</strong> - \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C815\C758\B41C \AE30\D0C0 \BAA8\B4E0 \D398\C774\C9C0\C758 \CE74\B4DC \BAA9\B85D\C744 \D45C\C2DC\D558\B824\BA74 \C774 \C635\C158\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;\C774 \C635\C158\C740 \C560\D50C\B9AC\CF00\C774\C158 \D648 \D398\C774\C9C0\C5D0 \C77C\BC18\C801\C73C\B85C \C0AC\C6A9\B429\B2C8\B2E4.</li>'),
'-->',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106175511043310431)
,p_name=>'CA.BLUEPRINT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \CCAD\C0AC\C9C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106175608190310431)
,p_name=>'CA.BLUEPRINT.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CCAD\C0AC\C9C4\C5D0\B294 JSON \D615\C2DD\C758 \C560\D50C\B9AC\CF00\C774\C158 \C815\C758\AC00 \B098\C5F4\B429\B2C8\B2E4.</p>'),
unistr('<p>\C774 \D654\BA74\C744 \CC98\C74C \C2DC\C791\D558\B294 \ACBD\C6B0 \D604\C7AC \C560\D50C\B9AC\CF00\C774\C158 \C815\C758\AC00 JSON \BB38\C11C\B85C \BCC0\D658\B418\C5B4 \D45C\C2DC\B429\B2C8\B2E4. \BB38\C11C\B97C \D3B8\C9D1\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158 \C18D\C131\C744 \C5C5\B370\C774\D2B8\D558\ACE0 <strong>\CCAD\C0AC\C9C4 \C801\C6A9</strong>\C744 \B20C\B7EC \D604\C7AC \C560\D50C\B9AC\CF00\C774\C158 \C138\BD80\C815\BCF4\B97C \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<p>&nbsp;</p>',
unistr('<p>\C720\C0AC\D55C \D398\C774\C9C0\B97C \B9CE\C774 \C0DD\C131\D574\C57C \D558\B294 \ACBD\C6B0 \D55C \D398\C774\C9C0\C5D0 \B300\D574 \C801\C808\D55C JSON \CF54\B4DC\B97C \BCF5\C0AC\D558\C5EC \C5EC\B7EC \BC88 \BD99\C5EC\B123\ACE0 JSON\C744 \C870\AE08\C529 \C870\C815\D558\B294 \AC83\C774 \AC01 \D398\C774\C9C0\C5D0 \B300\D574 <strong>\D398\C774\C9C0 \CD94\AC00</strong>\B97C \C0AC\C6A9\D558\C5EC \C218\B3D9\C73C\B85C \C791\C5C5\D558\B294 \AC83\BCF4\B2E4 \BE60\B985\B2C8\B2E4.</p>'),
unistr('<p>\CCAD\C0AC\C9C4\C744 \C774\C804\C5D0 \C0DD\C131\B41C \C560\D50C\B9AC\CF00\C774\C158\C758 \C815\C758\B85C \BC14\AFB8\B824\BA74 <strong>\C774\C804 \CCAD\C0AC\C9C4 \B85C\B4DC</strong>\B97C \B204\B985\B2C8\B2E4. \ADF8\B7EC\BA74 \C560\D50C\B9AC\CF00\C774\C158\C744 \B2E4\C2DC \C0DD\C131\D558\AE30 \C804\C5D0 \B2E4\B978 \D398\C774\C9C0\B97C \CD94\AC00\D558\AC70\B098 \AE30\B2A5\C744 \BCC0\ACBD\D558\AC70\B098 \C124\C815\C744 \C870\C815\D558\C5EC \B9E4\C6B0 \AC04\D3B8\D558\AC8C \C560\D50C\B9AC\CF00\C774\C158 \C124\ACC4\B97C \BC18\BCF5\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106164240268310423)
,p_name=>'CA.BODY1.TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB381 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106164377886310423)
,p_name=>'CA.BODY2.TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB382 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106184305889310438)
,p_name=>'CA.BOTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106150685658310412)
,p_name=>'CA.BRANCH.TO.ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790 \D398\C774\C9C0\C5D0 \B300\D55C \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105147547688309583)
,p_name=>'CA.BUTTON.BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \BAA8\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106150349663310412)
,p_name=>'CA.BUTTONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106142843600310404)
,p_name=>'CA.CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825 \D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106142929156310405)
,p_name=>'CA.CALENDAR.DETAILS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2EC\B825\C744 \D45C\C2DC\D558\B294 \D398\C774\C9C0\B97C \C0DD\C131\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\D398\C774\C9C0 \C774\B984</strong>(\D544\C218) - \C774 \D398\C774\C9C0\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C544\C774\CF58 \C124\C815</strong> - \C774 \D398\C774\C9C0\C5D0 \B300\D55C \D0D0\C0C9 \BA54\B274\C5D0 \D45C\C2DC\D560 \C544\C774\CF58\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\D14C\C774\BE14 \B610\B294 \BDF0</strong>(\D544\C218) - \B2EC\B825\C5D0 \B300\D55C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\D45C\C2DC \C5F4</strong>(\D544\C218) - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \B2EC\B825 \C774\BCA4\D2B8\C5D0 \D45C\C2DC\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C2DC\C791 \B0A0\C9DC \C5F4</strong>(\D544\C218) - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \B2EC\B825 \C774\BCA4\D2B8\C5D0 \B300\D55C \C2DC\C791 \B0A0\C9DC\B85C \C0AC\C6A9\D560 \B0A0\C9DC \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C885\B8CC \B0A0\C9DC \C5F4</strong> - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \B2EC\B825 \C774\BCA4\D2B8\C5D0 \B300\D55C \C885\B8CC \B0A0\C9DC\B85C \C0AC\C6A9\D560 \B0A0\C9DC \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;\C885\B8CC \B0A0\C9DC\AC00 \C9C0\C815\B41C \ACBD\C6B0 \AE30\AC04\C744 \AE30\BC18\C73C\B85C \D558\B294 \C774\BCA4\D2B8\AC00 \D45C\C2DC\B429\B2C8\B2E4. </li>'),
unistr('  <li><strong>\C2DC\AC04 \D45C\C2DC</strong> - \C774\BCA4\D2B8\C758 \C2DC\AC04 \BD80\BD84\C744 \D45C\C2DC\D558\ACE0 \C8FC \B2E8\C704 \BC0F \C77C \B2E8\C704 \B2EC\B825 \BDF0\B3C4 \C0AC\C6A9\C73C\B85C \C124\C815\D558\B824\BA74 <strong>\C608</strong>\B97C \C120\D0DD\D569\B2C8\B2E4. \C774\BCA4\D2B8\C5D0 \B300\D55C \B0A0\C9DC\B9CC \D45C\C2DC\D558\B824\BA74 <strong>\C544\B2C8\C624</strong>\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106149319093310411)
,p_name=>'CA.CANCEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106151248760310412)
,p_name=>'CA.CANCEL.DIALOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105128549647309569)
,p_name=>'CA.CANCEL.MODAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B2EC \CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106161129644310421)
,p_name=>'CA.CANNOT.REMOVE.ADMIN.RIGHTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \ACE0\C720 \B808\CF54\B4DC\C5D0\C11C \AD00\B9AC\C790 \AD8C\D55C\C744 \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106191953654310443)
,p_name=>'CA.CARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC \D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106191825795310443)
,p_name=>'CA.CARD.DETAILS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CE74\B4DC\B97C \D45C\C2DC\D558\B294 \D398\C774\C9C0\B97C \C0DD\C131\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\D398\C774\C9C0 \C774\B984</strong>(\D544\C218) - \C774 \D398\C774\C9C0\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C544\C774\CF58 \C124\C815</strong> - \C774 \D398\C774\C9C0\C758 \D0D0\C0C9 \BA54\B274\C5D0 \D45C\C2DC\D560 \C544\C774\CF58\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\D14C\C774\BE14 \B610\B294 \BDF0</strong>(\D544\C218) - \CE74\B4DC\C5D0 \B300\D55C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\CE74\B4DC \C81C\BAA9</strong>(\D544\C218) - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \CE74\B4DC\C5D0 \B300\D55C \C81C\BAA9\C73C\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C124\BA85 \C5F4</strong>(\D544\C218) - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \CE74\B4DC\C5D0 \B300\D55C \C124\BA85\C73C\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\CD94\AC00 \D14D\C2A4\D2B8 \C5F4</strong> - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \CE74\B4DC\C5D0 \B300\D55C \BCF4\C870 \C124\BA85\C73C\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106190444386310442)
,p_name=>'CA.CARDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106190557237310442)
,p_name=>'CA.CARDS.VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC \BDF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105251615307309660)
,p_name=>'CA.CC'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105512001516309871)
,p_name=>'CA.CHANGE_FILTERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \BCC0\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106141924877310404)
,p_name=>'CA.CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106142006098310404)
,p_name=>'CA.CHART.DETAILS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C601\C5ED, \B9C9\B300, \AEBE\C740\C120\D615 \B610\B294 \D30C\C774 \CC28\D2B8\B97C \D45C\C2DC\D558\B294 \D398\C774\C9C0\B97C \C0DD\C131\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\D398\C774\C9C0 \C774\B984</strong>(\D544\C218) - \C774 \D398\C774\C9C0\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C544\C774\CF58 \C124\C815</strong> - \C774 \D398\C774\C9C0\C758 \D0D0\C0C9 \BA54\B274\C5D0 \D45C\C2DC\D560 \C544\C774\CF58\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\CC28\D2B8 \C720\D615</strong> - \D45C\C2DC\D560 \CC28\D2B8 \C720\D615[<strong>\C601\C5ED</strong>, <strong>\B9C9\B300</strong>, <strong>\AEBE\C740\C120\D615</strong>, <strong>\D30C\C774</strong>]\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\D14C\C774\BE14 \B610\B294 \BDF0</strong>(\D544\C218) - \CC28\D2B8\C5D0 \B300\D55C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\B808\C774\BE14 \C5F4</strong>(\D544\C218) - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \CC28\D2B8\C5D0 \B300\D55C \B808\C774\BE14\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\AC12 \C9D1\ACC4</strong> - \AC12 \C5F4\C744 \D45C\C2DC\D558\AC70\B098 \C9D1\ACC4\D558\B294 \BC29\BC95<br>'),
unistr('      &nbsp;&nbsp;&nbsp;[\C5F4 \AC12, \D569\ACC4, \AC1C\C218]\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\AC12 \C5F4</strong>(\D544\C218) - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \D45C\C2DC\B41C \CC28\D2B8 \AC12\C744 \ACC4\C0B0\D558\B294 \B370 \C0AC\C6A9\D560 \C22B\C790 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106142324945310404)
,p_name=>'CA.CHART.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<h3>\C608\C81C</h3>'),
unistr('<p>\B2E4\C591\D55C <strong>\C694\C57D</strong> \C720\D615\C744 \D65C\C6A9\D558\B294 \BC29\BC95\C5D0 \B300\D55C \C608\C81C\B97C \AC80\D1A0\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\C608\C81C 1:</strong> \AC01 \C0AC\C6D0\C5D0 \B300\D55C \AD00\B9AC\C790\C758 \C0AC\C6D0 \BC88\D638\AC00 \B098\C640 \C788\B294 \C0AC\C6D0\C5D0 \B300\D55C \CC28\D2B8\B97C \D45C\C2DC\D569\B2C8\B2E4.'),
'<code><ul>',
unistr('  <li>\D14C\C774\BE14 \B610\B294 \BDF0 - EMP\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li>\B808\C774\BE14 \C5F4 - ENAME\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li>\C694\C57D - <u><strong>\C5F4 \AC12</strong></u>\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li>\AC12 \C5F4 - MGR\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
'</ul></code>',
'</p>',
unistr('<p><strong>\C608\C81C 2:</strong> \AC01 \C9C1\BB34\C5D0 \B300\D55C \CD1D \C6D4\AE09\C774 \B098\C640 \C788\B294 \C9C1\C6D0\C5D0 \B300\D55C \CC28\D2B8\B97C \D45C\C2DC\D569\B2C8\B2E4.'),
'<code><ul>',
unistr('  <li>\D14C\C774\BE14 \B610\B294 \BDF0 - EMP\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li>\B808\C774\BE14 \C5F4 - JOB\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li>\C694\C57D - <u><strong>\D569\ACC4</strong></u>\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li>\AC12 \C5F4 - SAL\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
'</ul></code>',
'</p>',
unistr('<p><strong>\C608\C81C 3:</strong> \AC01 \BD80\C11C\C758 \C9C1\C6D0 \C218\AC00 \B098\C640 \C788\B294 \C9C1\C6D0\C5D0 \B300\D55C \CC28\D2B8\B97C \D45C\C2DC\D569\B2C8\B2E4.'),
'<code><ul>',
unistr('  <li>\D14C\C774\BE14 \B610\B294 \BDF0 - EMP\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li>\B808\C774\BE14 \C5F4 - DEPTNO\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li>\C694\C57D - <u><strong>\AC1C\C218</strong></u>\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li>\AC12 \C5F4 - EMPNO\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
'</ul></code>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105378799164309757)
,p_name=>'CA.CLIENT.ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106195106136310446)
,p_name=>'CA.CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EB\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105016674775309482)
,p_name=>'CA.CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\ACB0\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106193167304310444)
,p_name=>'CA.COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106170195207310427)
,p_name=>'CA.COLUMN.1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106170207449310427)
,p_name=>'CA.COLUMN.2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106157570743310418)
,p_name=>'CA.COLUMN.ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106188993059310441)
,p_name=>'CA.COMMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106155274372310416)
,p_name=>'CA.COMPONENT.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106160025504310420)
,p_name=>'CA.CONFIG.ACCESS.CONTROL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106150472651310412)
,p_name=>'CA.CONFIG.APPEARANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591 \AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106150535127310412)
,p_name=>'CA.CONFIG.APPEARANCE.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C758 \BAA8\C591\C740 \D14C\B9C8 \C2A4\D0C0\C77C\C5D0\C11C \C815\C758\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106153896866310415)
,p_name=>'CA.CONFIG.OPTION.UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131 \C635\C158\C744 \C5C5\B370\C774\D2B8\D588\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106135726535310398)
,p_name=>'CA.CONFIGURATION.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131 \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106134006807310396)
,p_name=>'CA.CONFIGURATION.SETTINGS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AE30\B2A5 \C0AC\C6A9 \B610\B294 \C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106135819081310398)
,p_name=>'CA.CONFIGURATION.SETTINGS.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158 \B0B4 \D2B9\C815 \AE30\B2A5\C744 \C0AC\C6A9 \B610\B294 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D560 \C218 \C788\B3C4\B85D \D569\B2C8\B2E4. \C774 \AE30\B2A5\C740 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C0AC\C6A9\D558\AE30 \C804 \CD94\AC00 \AC1C\BC1C \C791\C5C5\C774 \D544\C694\D55C \AE30\B2A5\C744 \C120\D0DD\D558\B294 \ACBD\C6B0 \C720\C6A9\D569\B2C8\B2E4.<br>'),
unistr('\C774 \AE30\B2A5\C740 \C560\D50C\B9AC\CF00\C774\C158 \D2B9\C815 \AE30\B2A5\C73C\B85C \D655\C7A5\B420 \C218\B3C4 \C788\C2B5\B2C8\B2E4. \AC1C\BC1C\C790\AC00 \CD94\AC00 \BE4C\B4DC \C635\C158\C744 \C815\C758\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158 \C804\CCB4\C5D0\C11C \D2B9\C815 \AE30\B2A5\ACFC \C5F0\AD00\C2DC\D0A4\B294 \ACBD\C6B0 \AD00\B9AC\C790\C6A9 \AD6C\C131 \C124\C815\C5D0 \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4. \C608\B97C \B4E4\C5B4, Customer Tracker App \B0B4\C5D0\C11C \AD00\B9AC\C790\B294 \C5F0\B77D\CC98, \B370\C774\D130 \B85C\B529, \C9C0\C5ED \B4F1\ACFC \AC19\C740 \AE30\B2A5\C744 \C124\C815\D558\AC70\B098 \D574\C81C\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'</p>',
unistr('<p>\B2E4\C74C \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B429\B2C8\B2E4.'),
'<ul>',
unistr('<li>\C560\D50C\B9AC\CF00\C774\C158 \AE30\B2A5\C744 \C0AC\C6A9 \BC0F \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D560 \C218 \C788\B3C4\B85D \D5C8\C6A9</li>'),
unistr('<li>\AC1C\BC1C\B9C8\B2E4 \C120\D0DD\C801\C778 \AE30\B2A5\C744 \D5C8\C6A9\D560 \C218 \C788\B294 \AE30\B2A5 \C0AC\C6A9</li>'),
unistr('<li>\AD00\B828 \C560\D50C\B9AC\CF00\C774\C158 \C124\C815\C758 \ADF8\B8F9\D654 \C9C0\C6D0</li>'),
unistr('<li>\C560\D50C\B9AC\CF00\C774\C158 \AC1C\BC1C\C790\AC00 \BE4C\B4DC \C635\C158\C744 \C0AC\C6A9\D558\C5EC \AD6C\C131\C694\C18C\B97C \C81C\C5B4\D560 \C218 \C788\B3C4\B85D \D568</li>'),
unistr('<li>\AD00\B9AC \D398\C774\C9C0\C5D0\C11C \C0AC\C6A9 \AC00\B2A5</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105373604272309753)
,p_name=>'CA.CONNECT.CREDENTIAL.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\C11C \C774\B984 \C811\C18D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105373746197309753)
,p_name=>'CA.CONNECT.CREDENTIAL.OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C811\C18D \C778\C99D\C11C \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106040115211310309)
,p_name=>'CA.CONTEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE8\D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106160529238310420)
,p_name=>'CA.CONTRIBUTOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105380684603309758)
,p_name=>'CA.CPU.USED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\B41C CPU')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106169066563310427)
,p_name=>'CA.CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106174138968310430)
,p_name=>'CA.CREATE.ADMIN.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106171743841310429)
,p_name=>'CA.CREATE.APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106172872211310429)
,p_name=>'CA.CREATE.APP.COMP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \ACC4\C0B0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106172147309310429)
,p_name=>'CA.CREATE.APP.ICON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C544\C774\CF58 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106172738087310429)
,p_name=>'CA.CREATE.APP.ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106172908550310429)
,p_name=>'CA.CREATE.APP.PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106049236628310318)
,p_name=>'CA.CREATE.APP.SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C124\C815 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106179051438310434)
,p_name=>'CA.CREATE.APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105422519342309796)
,p_name=>'CA.CREATE.APP_ROLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \B864 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106172367283310429)
,p_name=>'CA.CREATE.AUTH.SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106173152239310430)
,p_name=>'CA.CREATE.BLANK.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE48 \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106172202055310429)
,p_name=>'CA.CREATE.BUILD.OPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106173578436310430)
,p_name=>'CA.CREATE.CALENDAR.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825 \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106185354657310439)
,p_name=>'CA.CREATE.CARDS.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC \D398\C774\C9C0 \C0DD\C131 \C911')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106173311688310430)
,p_name=>'CA.CREATE.CHART.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106173808609310430)
,p_name=>'CA.CREATE.CR.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B798\C2DD \BCF4\ACE0\C11C \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106173498754310430)
,p_name=>'CA.CREATE.DASHBOARD.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C2DC\BCF4\B4DC \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106171625048310428)
,p_name=>'CA.CREATE.END'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\BB34\B9AC \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106192631855310444)
,p_name=>'CA.CREATE.FACETED_SEARCH.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \D398\C774\C9C0\B97C \C0DD\C131\D558\B294 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106174495158310430)
,p_name=>'CA.CREATE.FEATURES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106189918860310442)
,p_name=>'CA.CREATE.FILTERED.CONTENT.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130\B9C1\B41C \CF58\D150\CE20 \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106173228131310430)
,p_name=>'CA.CREATE.FORM.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106171826365310429)
,p_name=>'CA.CREATE.GLOBAL.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106174057505310430)
,p_name=>'CA.CREATE.HOMEPAGE.NAV.LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648 \D398\C774\C9C0 \D0D0\C0C9 \BAA9\B85D \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106173917034310430)
,p_name=>'CA.CREATE.IG.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106173777797310430)
,p_name=>'CA.CREATE.IR.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104883157548309383)
,p_name=>'CA.CREATE.MAP.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5 \D398\C774\C9C0 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106178700942310434)
,p_name=>'CA.CREATE.MD.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \B514\D14C\C77C \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106172523131310429)
,p_name=>'CA.CREATE.NAV.BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \D45C\C2DC\C904 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106175701449310431)
,p_name=>'CA.CREATE.PAGE.GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \ADF8\B8F9 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106174351303310430)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\D658 \C218\D589 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106174252618310430)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION.V'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \BCC0\D658 \C218\D589 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106173649303310430)
,p_name=>'CA.CREATE.REPORT.FORM.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \BC0F \D3FC \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106178954080310434)
,p_name=>'CA.CREATE.SAVE_BLUE.PRINT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAD\C0AC\C9C4 \C800\C7A5 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106172638368310429)
,p_name=>'CA.CREATE.SHORT.CUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\B85C\AC00\AE30 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106173068985310429)
,p_name=>'CA.CREATE.SIGN.IN.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C778\C778 \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104882879519309383)
,p_name=>'CA.CREATE.SMART_FILTERS.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\B9C8\D2B8 \D544\D130 \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106171524254310428)
,p_name=>'CA.CREATE.START'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106171909604310429)
,p_name=>'CA.CREATE.SUP.OBJ.SCRIPTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0 \AC1D\CCB4 \C2A4\D06C\B9BD\D2B8 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106172400551310429)
,p_name=>'CA.CREATE.TEXT.MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \BA54\C2DC\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106185499825310439)
,p_name=>'CA.CREATE.TIMELINE.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0C0\C784\B77C\C778 \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106192820950310444)
,p_name=>'CA.CREATE.WIZARD.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\BC95\C0AC \D398\C774\C9C0 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106153197025310414)
,p_name=>'CA.CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106153265222310414)
,p_name=>'CA.CREATED.BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106141658712310403)
,p_name=>'CA.CREATING.APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131 \C911 ...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105374395145309753)
,p_name=>'CA.CREDENTIAL.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\C11C \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105380536945309758)
,p_name=>'CA.CREDENTIAL.OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\C11C \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106153720447310415)
,p_name=>'CA.CURRENT.STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106174739093310431)
,p_name=>'CA.CUSTOM.QRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105463532139309830)
,p_name=>'CA.CUSTOM.THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \D14C\B9C8 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105463665083309831)
,p_name=>'CA.CUSTOM.THEME.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BC94\C6A9 \D14C\B9C8 \B300\C2E0 \C0AC\C6A9\C790\C815\C758 \D14C\B9C8\B97C \C0AC\C6A9\D558\B3C4\B85D \B9C8\BC95\C0AC\B97C \C804\D658\D569\B2C8\B2E4.</p>'),
'',
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \C791\C5C5\C601\C5ED \D14C\B9C8\B97C \C120\D0DD\D569\B2C8\B2E4. \D14C\B9C8\AC00 \D14C\B9C8 \C2A4\D0C0\C77C\C744 \C9C0\C6D0\D558\B294 \ACBD\C6B0 \C2A4\D0C0\C77C\B3C4 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105128285059309569)
,p_name=>'CA.CUSTOM_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \D14C\B9C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106175399283310431)
,p_name=>'CA.DASHBOARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C2DC\BCF4\B4DC \D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106039115119310308)
,p_name=>'CA.DASHBOARD.CHART.N'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106175489332310431)
,p_name=>'CA.DASHBOARD.DETAILS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C5EC\B7EC \AC1C\C758 \CC28\D2B8\B85C \AD6C\C131\B41C \B300\C2DC\BCF4\B4DC \D398\C774\C9C0\B97C \C0DD\C131\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\D398\C774\C9C0 \C774\B984</strong>(\D544\C218) - \C774 \D398\C774\C9C0\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C544\C774\CF58 \C124\C815</strong> - \C774 \D398\C774\C9C0\C758 \D0D0\C0C9 \BA54\B274\C5D0 \D45C\C2DC\D560 \C544\C774\CF58\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
'  </ul>',
'</ul>',
'&nbsp;<br>',
unistr('<p>\AC01 \CC28\D2B8(\CC28\D2B8 1, \CC28\D2B8 2, \CC28\D2B8 3 \BC0F \CC28\D2B8 4)\B294 \CC28\D2B8 \C720\D615 \AE30\BCF8\AC12\C774 \B2E4\B974\AC8C \C124\C815\B418\BA70 <em>\C0D8\D50C \B370\C774\D130</em>\B97C \AE30\BC18\C73C\B85C \D569\B2C8\B2E4. '),
unistr('  \B530\B77C\C11C \C774 \D398\C774\C9C0\B97C \CD94\AC00\D558\AE30 \C704\D574 \B2E4\B978 \C138\BD80\C815\BCF4\B97C \C785\B825\D560 \D544\C694\AC00 \C5C6\C2B5\B2C8\B2E4.'),
unistr('  \D558\C9C0\B9CC \ACE0\C720 \AC12\C744 \C120\D0DD\D558\C5EC \AE30\BCF8\AC12\C744 \BC14\AFB8\B294 \BC29\C2DD\C73C\B85C \AC01 \CC28\D2B8\B97C \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.<br>'),
unistr('  \CC28\D2B8\B97C \C0AC\C6A9\C790\C815\C758\D558\B824\BA74 \B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\CC28\D2B8 \C774\B984</strong>(\D544\C218) - \CC28\D2B8\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\CC28\D2B8 \C720\D615</strong> - \D45C\C2DC\D560 \CC28\D2B8 \C720\D615[<strong>\C601\C5ED</strong>, <strong>\B9C9\B300</strong>, <strong>\AEBE\C740\C120\D615</strong>, <strong>\D30C\C774</strong>]\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\D14C\C774\BE14 \B610\B294 \BDF0</strong>(\D544\C218) - \CC28\D2B8\C5D0 \B300\D55C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\B808\C774\BE14 \C5F4</strong>(\D544\C218) - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \CC28\D2B8\C5D0 \B300\D55C \B808\C774\BE14\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\AC12 \C9D1\ACC4</strong> - \AC12 \C5F4\C744 \D45C\C2DC\D558\AC70\B098 \C9D1\ACC4\D558\B294 \BC29\BC95<br>'),
unistr('      &nbsp;&nbsp;&nbsp;[\C5F4 \AC12, \D569\ACC4, \AC1C\C218]\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\AC12 \C5F4</strong>(\D544\C218) - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \D45C\C2DC\B41C \CC28\D2B8 \AC12\C744 \ACC4\C0B0\D558\B294 \B370 \C0AC\C6A9\D560 \C22B\C790 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106186048446310439)
,p_name=>'CA.DATATYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106187118029310440)
,p_name=>'CA.DATEFORMATMASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \D615\C2DD \B9C8\C2A4\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106154483841310415)
,p_name=>'CA.DEFAULT.TIME.ZONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C2DC\AC04\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106154599135310416)
,p_name=>'CA.DEFAULT.TIME.ZONE.UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C2DC\AC04\B300\B97C \C5C5\B370\C774\D2B8\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106176195081310432)
,p_name=>'CA.DEFAULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C18D\C131 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106176453653310432)
,p_name=>'CA.DEFAULTS.DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 JSON \BB38\C11C\B294 \BCF4\ACE0\C11C \BC0F \D3FC \C5F4 \C774\B984 \C0DD\C131, \D615\C2DD \B9C8\C2A4\D06C \B4F1\C5D0 \B300\D574 \C138\BD84\D654\B41C \C81C\C5B4\B97C \D5C8\C6A9\D569\B2C8\B2E4. \AC12 \BAA9\B85D \BC0F \AE30\D0C0 \ACF5\C720 \AD6C\C131\C694\C18C\B97C \C815\C758\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106192483175310444)
,p_name=>'CA.DEFAULTS.LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106192557191310444)
,p_name=>'CA.DEFAULTS.LOV.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>LOV(\AC12 \BAA9\B85D) \C18D\C131\C744 \CD94\AC00\D569\B2C8\B2E4. LOV\B294 \D14C\C774\BE14 \C5F4 \C815\C758\C5D0 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.'),
'  <ul>',
unistr('    <li><strong>\C774\B984</strong>(\D544\C218) - \AC12 \BAA9\B85D\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\C720\D615</strong> - \AC12 \BAA9\B85D \C720\D615[\AD6C\C870\D654\B428, \B3D9\C801, \C815\C801]\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('      \C720\D615\C774 <u>\AD6C\C870\D654\B428</u>\C778 \ACBD\C6B0 - '),
'      <ul>',
unistr('          <li><strong>\D14C\C774\BE14</strong>(\D544\C218) - \AC12 \BAA9\B85D\C758 \AE30\BC18\C73C\B85C \C0AC\C6A9\D560 \D14C\C774\BE14 \B610\B294 \BDF0\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('          <li><strong>\D45C\C2DC \C5F4</strong>(\D544\C218) - \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('          <li><strong>\D0A4 \C5F4</strong>(\D544\C218) - \BC18\D658\D560 \C5F4 \AC12\C744 \C120\D0DD\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \D14C\C774\BE14\C5D0 \B300\D55C \AE30\BCF8 \D0A4\C785\B2C8\B2E4.</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      \C720\D615\C774 <u>\B3D9\C801</u>\C778 \ACBD\C6B0 -'),
'      <ul>',
unistr('          <li><strong>SQL \C9C8\C758</strong>(\D544\C218) - \B450 \AC1C\C758 \AC12(\D45C\C2DC \AC12\ACFC \BC18\D658 \AC12)\C744 \BC18\D658\D558\B294 \C801\D569\D55C SQL Select \BB38\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      \C720\D615\C774 <u>\C815\C801</u>\C778 \ACBD\C6B0 -'),
'      <ul>',
unistr('          <li><strong>\C815\C801 \AC12 \BAA9\B85D</strong>(\D544\C218) - \B2E4\C74C \D615\C2DD\C758 \C801\D569\D55C \C815\C801 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.'),
'          <ul>',
unistr('            <li><code>STATIC2:Display1;Value1,Display2;Value2,...</code><br>\C785\B825\B41C \C21C\C11C\B300\B85C \BAA9\B85D\C774 \D45C\C2DC\B429\B2C8\B2E4.</li>'),
unistr('            <li><code>STATIC:Display1;Value1,Display2;Value2,...</code><br>\BB38\C790\C21C\C73C\B85C \BAA9\B85D\C774 \C815\B82C\B429\B2C8\B2E4.</li>'),
unistr('            <li><code>STATIC2|STATIC:Value1,Value2,...</code><br>\D45C\C2DC \AC12\ACFC \BC18\D658 \AC12\C774 \B3D9\C77C\D569\B2C8\B2E4.</li>'),
'          </ul>',
'      </ul>',
'    </li>',
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106193618199310445)
,p_name=>'CA.DEFAULTS.REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106193758916310445)
,p_name=>'CA.DEFAULTS.REPORT.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BAA8\B4E0 \BCF4\ACE0\C11C\C5D0 \B300\D55C \C18D\C131\C744 \D3B8\C9D1\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.'),
'  <ul>',
unistr('    <li><strong>\D398\C774\C9C0\B2F9 \D589</strong> - \AE30\BCF8\C801\C73C\B85C \D45C\C2DC\D560 \BCF4\ACE0\C11C \D589 \C218\B97C \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\D398\C774\C9C0 \B9E4\AE40 \BC29\BC95</strong> - \BCF4\ACE0\C11C \D398\C774\C9C0 \B9E4\AE40 \D45C\C2DC \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\C22B\C790 \D615\C2DD \B9C8\C2A4\D06C</strong> - \C22B\C790 \C5F4 \BC0F \D56D\BAA9\C5D0 \C801\C6A9\D560 \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\B0A0\C9DC \D615\C2DD \B9C8\C2A4\D06C</strong> - \B0A0\C9DC \C5F4 \BC0F \D56D\BAA9\C5D0 \C801\C6A9\D560 \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D569\B2C8\B2E4.</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106193429718310445)
,p_name=>'CA.DEFAULTS.TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106193287471310444)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C5F4 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106193328083310445)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C120\D0DD\B41C \D14C\C774\BE14 \C5F4\C5D0 \B300\D55C \C18D\C131\C744 \D3B8\C9D1\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.'),
'  <ul>',
unistr('    <li><strong>\D14C\C774\BE14</strong>(\D45C\C2DC \C804\C6A9) - \C5F0\AD00\B41C \D14C\C774\BE14\C785\B2C8\B2E4.</li>'),
unistr('    <li><strong>\C5F4</strong>(\D45C\C2DC \C804\C6A9) - \C18D\C131\C774 \C815\C758\B41C \C5F4\C785\B2C8\B2E4.</li>'),
unistr('    <li><strong>\B808\C774\BE14</strong> - \BCF4\ACE0\C11C \BA38\B9AC\AE00 \BC0F \D3FC \B808\C774\BE14\C5D0 \C0AC\C6A9\D560 \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\D3FC \CF58\D2B8\B864</strong> - \D3FC\C5D0 \C0AC\C6A9\D560 \D56D\BAA9 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\AC12 \BAA9\B85D</strong> - \C801\C808\D55C \ACBD\C6B0 \C0AC\C6A9\C790\C5D0\AC8C \CE5C\C219\D55C \C774\B984\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\D560 \AE30\C874 \AC12 \BAA9\B85D\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\D615\C2DD \B9C8\C2A4\D06C</strong> - \C5F4 \C720\D615(\D14D\C2A4\D2B8, \C22B\C790, \B0A0\C9DC \B4F1)\C744 \AE30\BC18\C73C\B85C \C801\C808\D55C \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\C815\C801 \AE30\BCF8\AC12</strong> - \C5F4\C5D0 \B300\D55C \D14D\C2A4\D2B8 \AE30\BCF8\AC12\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\D3FC\C5D0 \D3EC\D568</strong> - \D3FC\C5D0 \C5F4\C744 \D3EC\D568\D574\C57C \D558\B294 \ACBD\C6B0 [\C608]\B97C \B204\B985\B2C8\B2E4.</li>'),
unistr('    <li><strong>\BCF4\ACE0\C11C\C5D0 \D3EC\D568</strong> - \BCF4\ACE0\C11C\C5D0 \C5F4\C744 \D3EC\D568\D574\C57C \D558\B294 \ACBD\C6B0 [\C608]\B97C \B204\B985\B2C8\B2E4.</li>'),
unistr('    <li><strong>\D544\C218</strong> - \D3FC\C758 \C774 \C5F4\C5D0 \B370\C774\D130\B97C \C785\B825\D574\C57C \D558\B294 \ACBD\C6B0 [\C608]\B97C \B204\B985\B2C8\B2E4.</li>'),
unistr('    <li><strong>\B3C4\C6C0\B9D0</strong> - \D56D\BAA9 \B3C4\C6C0\B9D0 \C18D\C131\C5D0 \CD94\AC00\B418\B294 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.</li>'),
'  </ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106193591709310445)
,p_name=>'CA.DEFAULTS.TABLE.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C120\D0DD\B41C \D14C\C774\BE14\C5D0 \B300\D55C \C18D\C131\C744 \D3B8\C9D1\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.'),
'  <ul>',
unistr('    <li><strong>\D14C\C774\BE14</strong>(\D45C\C2DC \C804\C6A9) - \C5F0\AD00\B41C \D14C\C774\BE14\C785\B2C8\B2E4.</li>'),
unistr('    <li><strong>\B808\C774\BE14, \B2E8\C218</strong>(\D544\C218) - \D3FC \D398\C774\C9C0\C5D0 \C0AC\C6A9\D560 \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\B808\C774\BE14, \BCF5\C218</strong>(\D544\C218) - \BCF4\ACE0\C11C \BA38\B9AC\AE00 \BC0F \D398\C774\C9C0 \C774\B984\C5D0 \C0AC\C6A9\D560 \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\AE30\BCF8 \D45C\C2DC \C5F4</strong> - \CE74\B4DC \C601\C5ED \B4F1\C5D0 \D45C\C2DC\D560 \CCAB\BC88\C9F8 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\BCF4\C870 \D45C\C2DC \C5F4</strong> - \CE74\B4DC \C601\C5ED \B4F1\C5D0 \D45C\C2DC\D560 \B450\BC88\C9F8 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\AE30\BCF8 \D0A4 \C5F4</strong> - \D14C\C774\BE14\C5D0 \B300\D55C \ACE0\C720 \AE30\BCF8 \D0A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\C124\BA85</strong> - \D14C\C774\BE14\C5D0 \B300\D55C \C124\BA85\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105374178173309753)
,p_name=>'CA.DEFERRED.DROP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C5F0\B41C \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106187719199310440)
,p_name=>'CA.DEFINITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106171410012310428)
,p_name=>'CA.DEINSTALL.COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58 \C81C\AC70\AC00 \C644\B8CC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106151775788310413)
,p_name=>'CA.DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106171031172310428)
,p_name=>'CA.DELETE.CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C0AD\C81C \C791\C5C5\C744 \C218\D589\D558\ACA0\C2B5\B2C8\AE4C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106137370068310399)
,p_name=>'CA.DELETE.PAGE.CONFIRM.MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B97C \C0AD\C81C\D558\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106161511319310421)
,p_name=>'CA.DELETE.PHOTO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C9C4 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106152470959310414)
,p_name=>'CA.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106169600905310427)
,p_name=>'CA.DESKTOP.NAVIGATION.BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106169520833310427)
,p_name=>'CA.DESKTOP.NAVIGATION.MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \BA54\B274')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106150701365310412)
,p_name=>'CA.DESKTOP.THEME.STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C2A4\D06C\D1B1 \D14C\B9C8 \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106150893815310412)
,p_name=>'CA.DESKTOP.THEME.STYLE.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D14C\B9C8 \C2A4\D0C0\C77C\C740 \BAA8\B4E0 \C0AC\C6A9\C790\C5D0\AC8C \C801\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105374533561309753)
,p_name=>'CA.DESTINATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105374690214309754)
,p_name=>'CA.DESTINATION.OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105128373686309569)
,p_name=>'CA.DIALOG.BUTTONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106166075343310424)
,p_name=>'CA.DISPATCH.EMAILS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C791\C5C5 \D560\B2F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106184565618310438)
,p_name=>'CA.DISPATCH.EMAILS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D504\B808\C784\C6CC\D06C\C5D0\C11C \C804\C790\BA54\C77C\C744 \C804\C1A1\D574\C57C \D560\C9C0 \C5EC\BD80\B97C \ACB0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106152242485310413)
,p_name=>'CA.DISPLAY.FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106152188768310413)
,p_name=>'CA.DISPLAY.SEQUENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C21C\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106152390822310413)
,p_name=>'CA.DISPLAY.UNTIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C885\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106186292940310439)
,p_name=>'CA.DISPLAYCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106155848897310417)
,p_name=>'CA.DISTINCT .USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BCC4 \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106169125544310427)
,p_name=>'CA.DOWNLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106176030543310432)
,p_name=>'CA.DRAG.TO.REORDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B04C\C5B4\C11C \D398\C774\C9C0 \C7AC\C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105149064957309584)
,p_name=>'CA.DRILL.DOWN.LINK'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr('  <li><strong>\B4DC\B9B4\B2E4\C6B4 \B9C1\D06C</strong> - \B4DC\B9B4\B2E4\C6B4 \B9C1\D06C \C815\C758 \C18D\C131\C744 \D45C\C2DC\D558\B824\BA74 \D655\C7A5\D569\B2C8\B2E4.'),
'&nbsp;<br>',
unistr('    <em><strong>\CC38\ACE0:</strong> \B4DC\B9B4\B2E4\C6B4 \B9C1\D06C\B294 \D604\C7AC \D398\C774\C9C0\AC00 \D14C\C774\BE14 \B610\B294 \BDF0\B97C \AE30\BC18\C73C\B85C \D558\BA70 \D604\C7AC \D398\C774\C9C0\C758 \BCF4\ACE0\C11C \C720\D615\C774 \B300\D654\C2DD \BCF4\ACE0\C11C\C774\ACE0 \C0AC\C6A9\C790\AC00 \B300\D654\C2DD \BCF4\ACE0\C11C \B610\B294 \B9C8\C2A4\D130 \B514\D14C\C77C \D398\C774\C9C0\B97C \C815\C758\D55C \ACBD\C6B0\C5D0\B9CC \D45C\C2DC\B429\B2C8\B2E4.</em>'),
'  <ul>',
unistr('    <li><strong>\B9C1\D06C \C5F4</strong> - \BCF4\ACE0\C11C\C5D0\C11C \B9C1\D06C \C5F4\B85C \BCC0\ACBD\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\B9C1\D06C \D0A4</strong> - \B9C1\D06C\D558\B824\B294 \D398\C774\C9C0\C5D0\C11C \D2B9\C815 \B808\CF54\B4DC\B97C \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\B418\B294 \B9C1\D06C \D0A4(\C678\B798 \D0A4) \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\B9C1\D06C \B300\C0C1 \D398\C774\C9C0</strong> - \B9C1\D06C\AC00 \C774\B3D9\D560 \BCF4\ACE0\C11C \B610\B294 \D3FC \D398\C774\C9C0\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\B300\C0C1 \D0A4</strong> - \B9C1\D06C\AC00 \C774\B3D9\D560 \BCF4\ACE0\C11C \D398\C774\C9C0\AC00 \AE30\BC18\C73C\B85C \D558\B294 \D14C\C774\BE14\C5D0\C11C \B300\C0C1 \D0A4(\AE30\BCF8 \D0A4) \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.'),
'  </ul>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106154987795310416)
,p_name=>'CA.ELAPSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACFC \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106137594751310399)
,p_name=>'CA.EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D504\B808\C784\C6CC\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106184176592310438)
,p_name=>'CA.EMAIL.ADDRESSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C8FC\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106194110197310445)
,p_name=>'CA.EMAIL.DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106137493418310399)
,p_name=>'CA.EMAIL.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C\C744 \AD6C\C131\D558\ACE0 \BCF4\B0BC \C218 \C788\B294 \AE30\B2A5 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106137699604310400)
,p_name=>'CA.EMAIL.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C804\C790\BA54\C77C\C744 \C804\C1A1\D560 \C218 \C788\B294 \AE30\B2A5\C744 \D3EC\D568\D569\B2C8\B2E4. \C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8 \C608\C81C\B97C \C0AC\C6A9\D558\C5EC \C804\BB38\AC00 \C218\C900\C758 \C804\C790\BA54\C77C\C744 \C0AC\C6A9\C790\C5D0\AC8C \C804\C1A1\D560 \C218 \C788\C2B5\B2C8\B2E4. \C804\C1A1\B41C \C804\C790\BA54\C77C\C740 \B85C\AE45\B418\BBC0\B85C \AD00\B9AC\C790\AC00 \C804\C790\BA54\C77C \C791\C5C5\C744 \CD94\C801\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B429\B2C8\B2E4.'),
'<ul>',
unistr('<li>\D655\C7A5 \AC00\B2A5\D55C HTML \C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8 \C2DC\C2A4\D15C</li>'),
unistr('<li>APEX \D328\D0A4\C9C0\B97C \D1B5\D574 \BA54\C77C\C744 \C804\C1A1\D558\AE30 \C704\D55C PL/SQL \D328\D0A4\C9C0</li>'),
unistr('<li>\C804\C790\BA54\C77C \C791\C5C5 \BC0F \C0C1\D0DC \B85C\AE45</li>'),
unistr('<li>\D15C\D50C\B9AC\D2B8 \AD00\B9AC\B97C \C704\D55C \AD00\B9AC UI</li>'),
unistr('<li>\C804\C790\BA54\C77C \B85C\ADF8 \D655\C778\C744 \C704\D55C \AD00\B9AC UI</li>'),
unistr('<li>\C804\C790\BA54\C77C \C804\C1A1\C744 \C704\D55C \AD00\B9AC UI</li>'),
'</ul>',
'</p>',
unistr('<p><em>\CC38\ACE0: \C774 \AE30\B2A5\C740 \D53C\B4DC\BC31\C774 \C120\D0DD\B41C \ACBD\C6B0 \C0AC\C6A9\C73C\B85C \C124\C815\B429\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106189879955310442)
,p_name=>'CA.EMAIL.FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \BCF4\B0B8 \C0AC\B78C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106165064967310424)
,p_name=>'CA.EMAIL.LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \B85C\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106194787798310446)
,p_name=>'CA.EMAIL.P10940.EMAIL.DETAILS.REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C124\C815 \C138\BD80\C815\BCF4\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106194256670310445)
,p_name=>'CA.EMAIL.P10940.EMAILS.FROM.INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \BCF4\B0B8 \C0AC\B78C \C8FC\C18C\B294 \C801\D569\D55C \C804\C790\BA54\C77C\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106185742431310439)
,p_name=>'CA.EMAIL.P11030.EMAILS.FROM.INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \BCF4\B0B8 \C0AC\B78C \C8FC\C18C\B294 \C801\D569\D55C \C804\C790\BA54\C77C\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106184995883310438)
,p_name=>'CA.EMAIL.PROCESSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C\C774 \CC98\B9AC\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105251931450309660)
,p_name=>'CA.EMAIL.REPORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105424202705309797)
,p_name=>'CA.EMAIL.REPORTING.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\AE30\C5F4\C5D0 \C788\B294 \C804\C1A1 \C608\C815 \C804\C790\BA54\C77C\ACFC \C774\BBF8 \C804\C1A1\B41C \C804\C790\BA54\C77C\C5D0 \B300\D55C \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106165901303310424)
,p_name=>'CA.EMAIL.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106166329062310425)
,p_name=>'CA.EMAIL.SETTINGS.UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C124\C815\C744 \C5C5\B370\C774\D2B8\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106190294037310442)
,p_name=>'CA.EMAIL.STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106166409082310425)
,p_name=>'CA.EMAIL.TEMPLATE.DETAILS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8 \C138\BD80\C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105672677976310005)
,p_name=>'CA.EMAIL.TEMPLATE.SUBJECT_EXAMPLE.SO'
,p_message_language=>'ko'
,p_message_text=>unistr('#SERVICE_NAME#\C5D0 \B300\D55C \C77C\C815\C774 \C7A1\D78C \C6B4\C6A9\C911\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105470987773309836)
,p_name=>'CA.EMAIL2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106164982546310424)
,p_name=>'CA.EMAILS.SENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C1A1\B41C \C804\C790\BA54\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106194360507310445)
,p_name=>'CA.ENABLE.ATTACHMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105379647163309757)
,p_name=>'CA.ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105376867550309755)
,p_name=>'CA.END.DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106167052676310425)
,p_name=>'CA.END.ROW.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \B4A4 \CF58\D150\CE20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106058364425310326)
,p_name=>'CA.ENDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106182005386310436)
,p_name=>'CA.ENTER.USERNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5EC\AE30\C5D0 \C0AC\C6A9\C790 \C774\B984 \C785\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106155523954310416)
,p_name=>'CA.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106157853489310418)
,p_name=>'CA.ERROR.BACKTRACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \C5ED\CD94\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106157720561310418)
,p_name=>'CA.ERROR.CODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106157081240310418)
,p_name=>'CA.ERROR.MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105381384344309758)
,p_name=>'CA.ERROR.NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105380362650309758)
,p_name=>'CA.ERRORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106058515465310326)
,p_name=>'CA.ERROR_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105377291566309755)
,p_name=>'CA.EVENT.CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105377341794309756)
,p_name=>'CA.EVENT.QUEUE.AGENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \B300\AE30\C5F4 \C5D0\C774\C804\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105377443449309756)
,p_name=>'CA.EVENT.QUEUE.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \B300\AE30\C5F4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105377522464309756)
,p_name=>'CA.EVENT.QUEUE.OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \B300\AE30\C5F4 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105377176308309755)
,p_name=>'CA.EVENT.RULE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \ADDC\CE59')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106182371497310436)
,p_name=>'CA.EXCEPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608\C678\C0AC\D56D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106195283626310446)
,p_name=>'CA.EXPERIENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\D5D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105379366823309757)
,p_name=>'CA.FAILURE.COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D328 \D69F\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106153523479310415)
,p_name=>'CA.FEATURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105828173632310129)
,p_name=>'CA.FEATURE.ABOUT_PAGE.APP_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BC84\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105828213924310129)
,p_name=>'CA.FEATURE.ABOUT_PAGE.PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105512414366309871)
,p_name=>'CA.FEATURE.ACL.ADD_USERS_TO_ACL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0 \C0AC\C6A9\C790 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105512213461309871)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.ADD.NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B2E8\ACC4\B85C \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105512353098309871)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.CREATE_COLLECTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C74C \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105512100853309871)
,p_name=>'CA.FEATURE.ACL.USER.EDIT.CANNOT_CHANGE_LAST_ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9 \AD00\B9AC\C790\B97C \BCC0\ACBD\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105827834410310129)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.LAST_ACTIVITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105511906510309871)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.NO_ACTIVITY_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C744 \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105828085515310129)
,p_name=>'CA.FEATURE.EXCEPTION.REASON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C720')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105512553689309871)
,p_name=>'CA.FEATURE.FEEDBACK.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B098 \C774\C0C1\C758 \D53C\B4DC\BC31 \D544\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105512844673309872)
,p_name=>'CA.FEATURE.FEEDBACK.GET_FILE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C ID \AC00\C838\C624\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105511485784309870)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105511552460309870)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE_USER_PREF'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790 \C2A4\D0C0\C77C \D658\ACBD\C124\C815 \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105827986083310129)
,p_name=>'CA.FEATURE.USERNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106141782117310403)
,p_name=>'CA.FEATURES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106141877788310404)
,p_name=>'CA.FEATURES.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5\C740 \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8 \AE30\B2A5\C744 \C81C\ACF5\D558\BA70 \C77C\BC18\C801\C73C\B85C \C560\D50C\B9AC\CF00\C774\C158\B2F9 \D55C \BC88 \CD94\AC00\B429\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158\ACFC \D568\AED8 \D3EC\D568\D560 \AE30\B2A5\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106135622392310398)
,p_name=>'CA.FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106133619563310396)
,p_name=>'CA.FEEDBACK.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \D53C\B4DC\BC31\C744 \C81C\ACF5\D558\B3C4\B85D \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106135571398310398)
,p_name=>'CA.FEEDBACK.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790 \BC0F \AC1C\BC1C\C790\C5D0\AC8C \C77C\BC18 \C758\ACAC\C744 \AC8C\C2DC\D560 \C218 \C788\B294 \BC29\C2DD\C744 \C81C\ACF5\D569\B2C8\B2E4. \C774\B7EC\D55C \AC8C\C2DC\BB3C\C5D0\B294 \C77C\BC18 \C0AC\C6A9\C790\AC00 \D53C\B4DC\BC31\C744 \BCF4\B0B8 \C704\CE58\B97C \D655\C778\D558\B294 \B370 \B3C4\C6C0\C774 \B418\B294 \C720\C6A9\D55C \C138\C158 \C0C1\D0DC \C815\BCF4\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4. \C774\C640 \AC19\C740 \C190\C26C\C6B4 \D53C\B4DC\BC31 \B8E8\D504\B97C \C81C\ACF5\D558\BA74 \C0AC\C6A9\C790 \CEE4\BBA4\B2C8\D2F0\C640 \C560\D50C\B9AC\CF00\C774\C158 \C18C\C720\C790 \AC04 \D1B5\C2E0\C744 \D5A5\C0C1\C2DC\CF1C \C77C\BC18 \C0AC\C6A9\C790 \B9CC\C871\B3C4\B97C \D06C\AC8C \AC1C\C120\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B429\B2C8\B2E4.'),
'<ul>',
unistr('<li>\C77C\BC18 \C0AC\C6A9\C790\AC00 \D0D0\C0C9 \D45C\C2DC\C904 \C544\C774\CF58\C744 \B20C\B7EC \D53C\B4DC\BC31\C744 \B0A8\AE38 \C218 \C788\B294 \AE30\B2A5</li>'),
unistr('<li>\D53C\B4DC\BC31\C744 \BCF4\ACE0 \C5C5\B370\C774\D2B8\D558\AE30 \C704\D55C \AD00\B9AC \BCF4\ACE0\C11C</li>'),
unistr('<li>\D53C\B4DC\BC31\C740 \C0AC\C6A9\C790, \B0A0\C9DC \BC0F \C2DC\AC04, \C0AC\C6A9\C790 \C5D0\C774\C804\D2B8 \C815\BCF4\B97C \CEA1\CC98\D569\B2C8\B2E4.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106195622981310446)
,p_name=>'CA.FEEDBACK.OR_EXPERIENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \B610\B294 \ACBD\D5D8\C744 \C81C\ACF5\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106194637986310445)
,p_name=>'CA.FEEDBACK.RECIPIENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1B\B294 \C0AC\B78C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106194008020310445)
,p_name=>'CA.FEEDBACK.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106163090803310422)
,p_name=>'CA.FEEDBACK.SETTINGS.UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C124\C815\C774 \C5C5\B370\C774\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106194844054310446)
,p_name=>'CA.FEEDBACK.SUBMITTED.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C81C\CD9C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105376921363309755)
,p_name=>'CA.FILE.WATCHER.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \AC10\C2DC \D504\B85C\ADF8\B7A8 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105377048284309755)
,p_name=>'CA.FILE.WATCHER.OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \AC10\C2DC \D504\B85C\ADF8\B7A8 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105035130095309495)
,p_name=>'CA.FILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105035296844309495)
,p_name=>'CA.FILED.BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106190346606310442)
,p_name=>'CA.FILTER.REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D544\D130\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106167410939310425)
,p_name=>'CA.FILTERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106193044934310444)
,p_name=>'CA.FINISH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106161707330310421)
,p_name=>'CA.FIRST.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105373997297309753)
,p_name=>'CA.FLAGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B798\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106143139961310405)
,p_name=>'CA.FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106143038438310405)
,p_name=>'CA.FORM.DETAILS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \B370\C774\D130 \C720\C9C0\BCF4\C218\C5D0 \C0AC\C6A9\D560 \D3FC \D398\C774\C9C0\B97C \D45C\C2DC\D558\B294 \D398\C774\C9C0\B97C \C0DD\C131\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\D398\C774\C9C0 \C774\B984</strong>(\D544\C218) - \C774 \D398\C774\C9C0\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C544\C774\CF58 \C124\C815</strong> - \C774 \D398\C774\C9C0\C758 \D0D0\C0C9 \BA54\B274\C5D0 \D45C\C2DC\D560 \C544\C774\CF58\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\D14C\C774\BE14</strong>(\D544\C218) - \D3FC\C5D0 \B300\D55C \D14C\C774\BE14\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('<li><strong>\BCF4\ACE0\C11C \D3EC\D568</strong>(\D544\C218) - \BCF4\ACE0\C11C \BC0F \D3FC\C744 \C0DD\C131\D558\B824\BA74 \C774 \C635\C158\C744 \C120\D0DD\D569\B2C8\B2E4. \CCAB\BC88\C9F8 \D398\C774\C9C0\B294 \B300\D654\C2DD \BCF4\ACE0\C11C\C785\B2C8\B2E4. \AC01 \D589\C740 \C0AC\C6A9\C790\AC00 \B808\CF54\B4DC\B97C \C5C5\B370\C774\D2B8\D560 \C218 \C788\B294 \D3FC\C5D0 \B300\D55C \B9C1\D06C\B97C \C81C\ACF5\D569\B2C8\B2E4. </li>'),
'  &nbsp;<br>',
unistr('<li><strong>\ACE0\AE09</strong> - \ACE0\AE09 \C635\C158\C744 \D45C\C2DC\D558\B824\BA74 \D655\C7A5\D569\B2C8\B2E4.'),
'     <ul>',
unistr('      <li><strong>\D398\C774\C9C0 \B3C4\C6C0\B9D0</strong> - \D398\C774\C9C0\C5D0 \B300\D55C \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\C5D0 \CD94\AC00\D560 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.</li>'),
'      </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105147616719309583)
,p_name=>'CA.FORM.ITEM.REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \D56D\BAA9 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106169372263310427)
,p_name=>'CA.FORM.ON'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106181891950310436)
,p_name=>'CA.FORM.TYPE.NOT.VALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \D3FC \C720\D615\C740 \C801\D569\D55C \C720\D615\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106188200254310441)
,p_name=>'CA.FORMATMASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \B9C8\C2A4\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106187202387310440)
,p_name=>'CA.FORMCONTROL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \CF58\D2B8\B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106152980083310414)
,p_name=>'CA.FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD9C\CC98')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106166159572310424)
,p_name=>'CA.FROM.ADDRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\B0B8 \C0AC\B78C \C8FC\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106189723080310442)
,p_name=>'CA.FROM.ADDRESS.EMAIL.SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('"\BCF4\B0B8 \C0AC\B78C \C8FC\C18C" \C804\C790\BA54\C77C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106185680675310439)
,p_name=>'CA.FROM.EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\B0B8 \C0AC\B78C \C804\C790\BA54\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106185552108310439)
,p_name=>'CA.FROM.WHO'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\B0B8 \C0AC\B78C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105878529842310167)
,p_name=>'CA.FS.SEARCH.TABLE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106156430221310417)
,p_name=>'CA.FULL.PAGE.VIEWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \D398\C774\C9C0 \BDF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106165107989310424)
,p_name=>'CA.FULL.TEMPLATE.HTML'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \D15C\D50C\B9AC\D2B8 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106186700176310440)
,p_name=>'CA.FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106136072042310398)
,p_name=>'CA.GLOBAL.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106133897118310396)
,p_name=>'CA.GLOBAL.SEARCH.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AC80\C0C9 \AE30\B2A5 \C81C\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106135918681310398)
,p_name=>'CA.GLOBAL.SEARCH.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158 \B0B4 \D0A4 \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \D14D\C2A4\D2B8\B97C \AC80\C0C9\D560 \C218 \C788\C2B5\B2C8\B2E4. \ACE0\AE09 \AC80\C0C9 \D398\C774\C9C0\C5D0\B294 \C77C\BC18 \C0AC\C6A9\C790\AC00 \ACB0\ACFC\B97C \AC04\B2E8\D788 \C881\D790 \C218 \C788\B294 \D544\D130\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.<br>'),
unistr('\C774\C640 \AC19\C740 \AC15\B825\D55C \AE30\B2A5\C744 \C0AC\C6A9\D558\B824\BA74 \C81C\ACF5\B41C \C608\C81C\B97C \AE30\BC18\C73C\B85C SQL\C744 \C815\C758\D558\B824\B294 \AC1C\BC1C \B178\B825\C774 \D544\C694\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B429\B2C8\B2E4.'),
'<ul>',
unistr('<li>\BA38\B9AC\AE00 \D45C\C2DC\C904\C5D0 \AC80\C0C9 \C544\C774\CF58 \D45C\C2DC</li>'),
unistr('<li>\CE21\BA74 \B9C9\B300 \D544\D130\AC00 \C788\B294 \C138\BD80\C815\BCF4 \AC80\C0C9 \ACB0\ACFC \D398\C774\C9C0 \D3EC\D568</li>'),
unistr('<li>\AC1C\BC1C\C790\AC00 \C571 \AC80\C0C9\C744 \C815\C758\D558\B3C4\B85D SQL\C744 \AD6C\D604\D574\C57C \D568</li>'),
unistr('<li>\ADF8\B9BC\C5D0 \B300\D55C \C0D8\D50C \B370\C774\D130 \D3EC\D568</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105378636168309756)
,p_name=>'CA.GLOBAL.UID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \ACE0\C720 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105511019169309870)
,p_name=>'CA.GLOBAL_PAGE.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \D398\C774\C9C0 - \B370\C2A4\D06C\D1B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105128464555309569)
,p_name=>'CA.GO.TO.ADMIN.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC \D398\C774\C9C0\B85C \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106142692455310404)
,p_name=>'CA.GRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC \D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106142757408310404)
,p_name=>'CA.GRID.DETAILS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C2A4\D504\B808\B4DC\C2DC\D2B8\C640 \C720\C0AC\D55C \B300\D654\C2DD \ADF8\B9AC\B4DC\B85C \D45C\C2DC\B418\B294 \D398\C774\C9C0\B97C \C0DD\C131\D569\B2C8\B2E4. \D3B8\C9D1 \AC00\B2A5\D55C \ACBD\C6B0([\D3B8\C9D1 \D5C8\C6A9]\C774 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0) \C0AC\C6A9\C790\B294 \D398\C774\C9C0\C5D0\C11C \C9C1\C811 \B2E4\C911 \D589\C744 \D3B8\C9D1\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\D398\C774\C9C0 \C774\B984</strong>(\D544\C218) - \C774 \D398\C774\C9C0\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C544\C774\CF58 \C124\C815</strong> - \C774 \D398\C774\C9C0\C758 \D0D0\C0C9 \BA54\B274\C5D0 \D45C\C2DC\D560 \C544\C774\CF58\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C9C8\C758 \C720\D615</strong> - \BCF4\ACE0\C11C \C18C\C2A4[<strong>\D14C\C774\BE14 \B610\B294 \BDF0</strong>, <strong>SQL \C9C8\C758</strong>]\B97C \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('    <strong>\D14C\C774\BE14 \B610\B294 \BDF0</strong>:'),
'    <ul>',
unistr('      <li><strong>\D14C\C774\BE14 \B610\B294 \BDF0</strong>(\D544\C218) - \ADF8\B9AC\B4DC\C5D0 \B300\D55C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
'    </ul>',
unistr('    <strong>SQL \C9C8\C758</strong>:'),
'    <ul>',
unistr('      <li><strong>SQL \C9C8\C758</strong>(\D544\C218) - \ACE0\C720 \C5F4\C744 \BC18\D658\D558\B294 \C801\D569\D55C SQL \BB38\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>\ADF8\B9AC\B4DC \C720\D615</strong> - \C0AC\C6A9\C790\AC00 \ADF8\B9AC\B4DC\C5D0\C11C \D589\C744 \D3B8\C9D1\D560 \C218 \C788\B294\C9C0 \C5EC\BD80[<strong>\D3B8\C9D1 \D5C8\C6A9</strong> \B610\B294 <strong>\C77D\AE30 \C804\C6A9</strong>]\B97C \C120\D0DD\D569\B2C8\B2E4. \D3B8\C9D1\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D558\B824\BA74 <strong>\D3B8\C9D1 \D5C8\C6A9</strong>\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
'  &nbsp;<br>',
unistr('  <em><strong>\ACBD\ACE0:</strong> \C9C8\C758 \C720\D615\C73C\B85C <strong>SQL \C9C8\C758</strong>, \ADF8\B9AC\B4DC \C720\D615\C73C\B85C <strong>\D3B8\C9D1 \D5C8\C6A9</strong>\C744 \C120\D0DD\D55C \C0C1\D0DC\C5D0\C11C \C9C8\C758\AC00 \D14C\C774\BE14 \B450 \AC1C \C774\C0C1\C744 \C870\C778\D558\B294 \ACBD\C6B0 \C0AC\C6A9\C790\AC00 \B808\CF54\B4DC\B97C \C5C5\B370\C774\D2B8\D558\B824\ACE0 \C2DC\B3C4\D558\BA74 \C0DD\C131\B41C \B300\D654\C2DD \ADF8\B9AC\B4DC\AC00 \C2E4\D328\D569\B2C8\B2E4.'),
unistr('\B610\D55C \ADF8\B9AC\B4DC \C720\D615\C73C\B85C <strong>\D3B8\C9D1 \D5C8\C6A9</strong>\C744 \C120\D0DD\D55C \C0C1\D0DC\C5D0\C11C \C9C8\C758(\B610\B294 \C120\D0DD\D55C \D14C\C774\BE14 \B610\B294 \BDF0)\AC00 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\B294 \BDF0\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 \C0AC\C6A9\C790\AC00 \B808\CF54\B4DC\B97C \C5C5\B370\C774\D2B8\D558\B824\ACE0 \C2DC\B3C4\D558\BA74 \C0DD\C131\B41C \B300\D654\C2DD \ADF8\B9AC\B4DC\AC00 \C2E4\D328\D569\B2C8\B2E4.</em><br>'),
'  </li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106167969375310426)
,p_name=>'CA.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106058149924310326)
,p_name=>'CA.HELP.ACTIVITY.REPORTING.AUTOMATIONS.LOG'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\B294 \C790\B3D9\D654 \B85C\ADF8\C5D0 \B300\D55C \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774\C804 \C790\B3D9\D654 \C2E4\D589\C5D0 \B300\D574 \AE30\B85D\B41C \C815\BCF4\B97C \AC80\D1A0\D569\B2C8\B2E4. \B85C\ADF8\C5D0\B294 \C2DC\C791 \BC0F \C885\B8CC \C2DC\AC04\AE30\B85D\C740 \BB3C\B860 \CC98\B9AC\B41C \D589\C5D0 \B300\D55C \C138\BD80\C815\BCF4(\C131\ACF5 \BC0F \C624\B958 \D3EC\D568)\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4. \CC98\B9AC\B41C \D589\C5D0 \B300\D55C \AC1C\BCC4 \BA54\C2DC\C9C0\B97C \BCF4\B824\BA74 \BA54\C2DC\C9C0\B85C \B4DC\B9B4\B2E4\C6B4\D569\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106160323385310420)
,p_name=>'CA.HELP.ALLOW.OTHER.USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C0AC\C6A9\C790\AC00 \C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0 \C815\C758\B41C \ACBD\C6B0 <strong>\C544\B2C8\C624</strong>\B97C \C120\D0DD\D569\B2C8\B2E4. \C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0 \C5C6\B294 \C778\C99D\B41C \C0AC\C6A9\C790\B3C4 <strong>\C608</strong>\B97C \C120\D0DD\D558\BA74 \C774 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106154063833310415)
,p_name=>'CA.HELP.APP.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5EC\AE30\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\B294 \C560\D50C\B9AC\CF00\C774\C158 \C804\CCB4\C5D0\C11C \C0AC\C6A9\B418\BA70 \BAA8\B4E0 \D398\C774\C9C0\C5D0\C11C \C67C\CABD \C704\C5D0 \D45C\C2DC\B418\B294 \ACBD\C6B0\AC00 \AC00\C7A5 \B208\C5D0 \B755\B2C8\B2E4. \BCC0\ACBD\C0AC\D56D\C740 \AD00\B9AC\C790\AC00 \BCC0\ACBD\C744 \C218\D589\D55C \C989\C2DC \C801\C6A9\B418\C9C0\B9CC \B2E4\B978 \C0AC\C6A9\C790\B294 \C0C8 \C138\C158(\C608: \B2E4\C74C \B85C\ADF8\C778 \C2DC)\C744 \C5BB\AC8C \B418\B294 \ACBD\C6B0\C5D0\B9CC \D574\B2F9 \BCC0\ACBD\C0AC\D56D\C744 \D655\C778\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106148644479310410)
,p_name=>'CA.HELP.HOME.FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C758 \BAA8\B4E0 \D398\C774\C9C0\C5D0\C11C \D0D0\C0C9 \D45C\C2DC\C904\C5D0 \C788\B294 \D53C\B4DC\BC31 \C544\C774\CF58( <span class="fa fa-comment-o" aria-hidden="true"></span> )\C744 \B20C\B7EC \C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\C5D0 \B300\D55C \D53C\B4DC\BC31\C744 \B0A8\AE38 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106148327872310410)
,p_name=>'CA.HELP.HOME.MAIN.SIDE.MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C758 \D648 \D398\C774\C9C0\C785\B2C8\B2E4. \CE74\B4DC\B97C \B20C\B7EC \C560\D50C\B9AC\CF00\C774\C158\C758 \B2E4\B978 \D398\C774\C9C0\C5D0 \C561\C138\C2A4\D558\AC70\B098 \D398\C774\C9C0 \CE21\BA74\C5D0 \C788\B294 \D0D0\C0C9 \BA54\B274\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106148570527310410)
,p_name=>'CA.HELP.HOME.MAIN.TOP.MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C758 \D648 \D398\C774\C9C0\C785\B2C8\B2E4. \CE74\B4DC\B97C \B20C\B7EC \C560\D50C\B9AC\CF00\C774\C158\C758 \B2E4\B978 \D398\C774\C9C0\C5D0 \C561\C138\C2A4\D558\AC70\B098 \D398\C774\C9C0 \B9E8 \C704\C5D0 \C788\B294 \D0D0\C0C9 \BA54\B274\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106148735059310410)
,p_name=>'CA.HELP.HOME.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \D398\C774\C9C0\C758 <strong>\C560\D50C\B9AC\CF00\C774\C158 \AC80\C0C9</strong> \D544\B4DC\C5D0 \AC80\C0C9\C5B4\B97C \C785\B825\D558\AC70\B098 \BAA8\B4E0 \D398\C774\C9C0\C5D0\C11C \D0D0\C0C9 \D45C\C2DC\C904\C758 \AC80\C0C9 \C544\C774\CF58( <span class="fa fa-search" aria-hidden="true"></span> )\C744 \B20C\B7EC \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0\C11C \D574\B2F9 \C6A9\C5B4\B97C \AC80\C0C9\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106149065745310410)
,p_name=>'CA.HELP.HOME.SIGN.OUT'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\D0D0\C0C9 \D45C\C2DC\C904\C5D0\C11C \C774\B984 \B4DC\B86D\B2E4\C6B4\C744 \B20C\B7EC \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C778\C544\C6C3\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106148904651310410)
,p_name=>'CA.HELP.HOME.TIME'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\D0D0\C0C9 \D45C\C2DC\C904\C758 \C0AC\C6A9\C790 \BA54\B274( <span class="fa fa-user" aria-hidden="true"></span> )\B97C \B20C\B7EC \C2DC\AC04\B300 \D658\ACBD\C124\C815\C744 \C5C5\B370\C774\D2B8\D558\ACE0 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C778\C544\C6C3\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106148408756310410)
,p_name=>'CA.HELP.HOME.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106149105570310410)
,p_name=>'CA.HELP.HOME.USER'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0 \C624\B978\CABD \C704\C5D0 \C788\B294 \D0D0\C0C9 \D45C\C2DC\C904\C758 \C0AC\C6A9\C790 \BA54\B274( <span class="fa fa-user" aria-hidden="true"></span> )\B97C \B20C\B7EC \C0AC\C6A9\C790 \D504\B85C\D30C\C77C\C5D0 \C561\C138\C2A4\D558\ACE0 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C778\C544\C6C3\D569\B2C8\B2E4.<br>'),
unistr('<strong>\B0B4 \D504\B85C\D30C\C77C \BCF4\AE30</strong>\B97C \B204\B974\BA74 <strong>\D504\B85C\D30C\C77C \C5C5\B370\C774\D2B8</strong>\B97C \B20C\B7EC \AC1C\C778 \C138\BD80\C815\BCF4\B97C \C785\B825\D558\ACE0 \C0AC\C9C4\C774\B098 \C544\BC14\D0C0\B97C \C5C5\B85C\B4DC\D560 \C218 \C788\AC8C \B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106148843455310410)
,p_name=>'CA.HELP.HOME.USER.TIME'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D0D0\C0C9 \D45C\C2DC\C904\C5D0\C11C \C0AC\C6A9\C790 \BA54\B274( <span class="fa fa-user" aria-hidden="true"></span> )\B97C \B20C\B7EC \C0AC\C6A9\C790 \D504\B85C\D30C\C77C\C5D0 \C561\C138\C2A4\D558\ACE0, \C2DC\AC04\B300 \D658\ACBD\C124\C815\C744 \C5C5\B370\C774\D2B8\D558\ACE0, \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C778\C544\C6C3\D569\B2C8\B2E4.<br>'),
unistr('<strong>\B0B4 \D504\B85C\D30C\C77C \BCF4\AE30</strong>\B97C \B204\B974\BA74 <strong>\D504\B85C\D30C\C77C \C5C5\B370\C774\D2B8</strong>\B97C \B20C\B7EC \AC1C\C778 \C138\BD80\C815\BCF4\B97C \C785\B825\D558\ACE0 \C0AC\C9C4\C774\B098 \C544\BC14\D0C0\B97C \C5C5\B85C\B4DC\D560 \C218 \C788\AC8C \B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106174918695310431)
,p_name=>'CA.HELP.IG.PAGE.READONLY'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B370\C774\D130\B97C \AC80\C0C9\D558\B824\BA74 \AC80\C0C9 \B300\D654\C0C1\C790\C5D0 \AC80\C0C9\C5B4\B97C \C785\B825\D558\AC70\B098 \C5F4 \C81C\BAA9\C744 \B20C\B7EC \BC18\D658\B418\B294 \B808\CF54\B4DC\B97C \C81C\D55C\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \B2E4\C591\D55C \AE30\B2A5\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4. \C5EC\AE30\C5D0\B294 \D45C\C2DC\B418\AC70\B098 \C228\ACA8\C9C4 \C5F4 \C120\D0DD, \D45C\C2DC \C2DC\D000\C2A4, \B2E4\C591\D55C \B370\C774\D130 \BC0F \D615\C2DD \C9C0\C815 \AE30\B2A5\C774 \D3EC\D568\B429\B2C8\B2E4. \CC28\D2B8 \C635\C158\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130\C5D0 \B300\D55C \BDF0\B97C \CD94\AC00\B85C \C815\C758\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\C0AC\C6A9\C790\C815\C758 \B0B4\C6A9\C744 \C800\C7A5\D558\B824\BA74 \BCF4\ACE0\C11C\B97C \C120\D0DD\D558\AC70\B098 \B2E4\C6B4\B85C\B4DC\B97C \B20C\B7EC \B370\C774\D130\B97C \C5B8\B85C\B4DC\D569\B2C8\B2E4.<p>'),
'<br>',
unistr('<p>\CD94\AC00 \C815\BCF4\B97C \BCF4\B824\BA74 [\C791\C5C5] \BA54\B274 \C544\B798\C5D0 \C788\B294 [\B3C4\C6C0\B9D0]\C744 \B204\B974\C2ED\C2DC\C624.</p>'),
'',
unistr('<p>\B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106174865011310431)
,p_name=>'CA.HELP.IG.PAGE.UPDATABLE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C2DD \ADF8\B9AC\B4DC \B0B4\C5D0\C11C \B370\C774\D130\B97C \C9C1\C811 \C0BD\C785, \C5C5\B370\C774\D2B8 \BC0F \C0AD\C81C\D560 \C218 \C788\C2B5\B2C8\B2E4.<br>'),
unistr('  [\D589 \CD94\AC00] \B2E8\CD94\B97C \B20C\B7EC \C0C8 \D589\C744 \C0BD\C785\D569\B2C8\B2E4.<br>'),
unistr('  \C140\C744 \B450 \BC88 \B204\B974\AC70\B098 <strong>\D3B8\C9D1</strong> \B2E8\CD94\B97C \B20C\B7EC \C2A4\D504\B808\B4DC\C2DC\D2B8\C5D0\C11C \B370\C774\D130\B97C \D3B8\C9D1\D560 \B54C\C640 \BE44\C2B7\D558\AC8C \B370\C774\D130 \AC12\C744 \C5C5\B370\C774\D2B8\D569\B2C8\B2E4.</p>'),
'',
unistr('<p>\BCF4\ACE0\C11C \B9E8 \C704\C5D0 \C788\B294 [\D589 \C791\C5C5] \BA54\B274(<span class="fa fa-bars" aria-hidden="true"></span>)\B97C \C0AC\C6A9\D558\C5EC \C120\D0DD\D55C \D589\C744 \BCF5\C81C, \C0AD\C81C, \C0C8\B85C\ACE0\CE68 \B610\B294 \CDE8\C18C\D560 \C218 \C788\C2B5\B2C8\B2E4.<br> '),
unistr('  \AC1C\BCC4 \D589\C5D0\C11C [\D589 \C791\C5C5] \BA54\B274\B97C \C0AC\C6A9\D558\C5EC \B2E8\C77C \D589 \BDF0\C5D0 \C561\C138\C2A4\D558\AC70\B098 \C0C8 \D589\C744 \CD94\AC00\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\B370\C774\D130\B97C \CC3E\C73C\B824\BA74 \AC80\C0C9 \B300\D654\C0C1\C790\C5D0 \AC80\C0C9\C5B4\B97C \C785\B825\D558\AC70\B098 \C5F4 \BA38\B9AC\AE00\C744 \B20C\B7EC \BC18\D658\B418\B294 \B808\CF54\B4DC\B97C \C81C\D55C\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \B2E4\C591\D55C \AE30\B2A5\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4. \C5EC\AE30\C5D0\B294 \C5F4 \D45C\C2DC/\C228\AE30\AE30 \BC0F \C5F4 \D45C\C2DC \C21C\C11C \C120\D0DD\ACFC \B2E4\C591\D55C \B370\C774\D130 \BC0F \D615\C2DD \C9C0\C815 \AE30\B2A5\C774 \D3EC\D568\B429\B2C8\B2E4. \CC28\D2B8 \C635\C158\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130\C5D0 \B300\D55C \BDF0\B97C \CD94\AC00\B85C \C815\C758\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\C0AC\C6A9\C790\C815\C758\B97C \C800\C7A5\D558\B824\BA74 \BCF4\ACE0\C11C\B97C \C120\D0DD\D558\AC70\B098 \B2E4\C6B4\B85C\B4DC\B97C \B20C\B7EC \B370\C774\D130\B97C \C5B8\B85C\B4DC\D569\B2C8\B2E4.<p>'),
'',
unistr('<p>\CD94\AC00 \C815\BCF4\B97C \BCF4\B824\BA74 [\C791\C5C5] \BA54\B274 \C544\B798\C5D0 \C788\B294 [\B3C4\C6C0\B9D0]\C744 \B204\B985\B2C8\B2E4.</p> '),
'',
unistr('<p>\B300\D654\C2DD \ADF8\B9AC\B4DC\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106148202094310410)
,p_name=>'CA.HELP.IR.PAGE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B370\C774\D130\B97C \AC80\C0C9\D558\B824\BA74 \AC80\C0C9 \B300\D654\C0C1\C790\C5D0 \AC80\C0C9\C5B4\B97C \C785\B825\D558\AC70\B098 \C5F4 \C81C\BAA9\C744 \B20C\B7EC \BC18\D658\B418\B294 \B808\CF54\B4DC\B97C \C81C\D55C\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \B2E4\C591\D55C \AE30\B2A5\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4. \C5EC\AE30\C5D0\B294 \D45C\C2DC\B418\AC70\B098 \C228\ACA8\C9C4 \C5F4 \C120\D0DD, \D45C\C2DC \C2DC\D000\C2A4\C640 \B2E4\C591\D55C \B370\C774\D130 \BC0F \D615\C2DD \C9C0\C815 \AE30\B2A5\C774 \D3EC\D568\B429\B2C8\B2E4. \CC28\D2B8, \ADF8\B8F9 \AE30\C900, \D53C\BC97 \C635\C158\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130 \BDF0\B97C \CD94\AC00\B85C \C815\C758\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\C0AC\C6A9\C790\C815\C758 \B0B4\C6A9\C744 \C800\C7A5\D558\B824\BA74 \BCF4\ACE0\C11C\B97C \C120\D0DD\D558\AC70\B098 \B2E4\C6B4\B85C\B4DC\B97C \B20C\B7EC \B370\C774\D130\B97C \C5B8\B85C\B4DC\D569\B2C8\B2E4. \AC00\C785 \C2DC \C815\AE30\C801\C73C\B85C \B370\C774\D130\B97C \C804\C1A1\D560 \C804\C790\BA54\C77C \C8FC\C18C\C640 \C2DC\AC04\BC94\C704\B97C \C785\B825\D569\B2C8\B2E4.<p>'),
'',
unistr('<p>\CD94\AC00 \C815\BCF4\B97C \BCF4\B824\BA74 [\C791\C5C5] \BA54\B274\C758 \C544\B798\CABD\C5D0 \C788\B294 [\B3C4\C6C0\B9D0]\C744 \B204\B974\C2ED\C2DC\C624.</p>'),
'',
unistr('<p>\B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106182840266310437)
,p_name=>'CA.HELP.MD.PAGE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \BCF4\ACE0\C11C \D398\C774\C9C0\C5D0\B294 \D398\C774\C9C0 \CE21\BA74 \C120\D0DD\AE30\C758 \AE30\BCF8 \B808\CF54\B4DC\AC00 \D45C\C2DC\B429\B2C8\B2E4. '),
unistr('  \C815\C758\B41C \B9C8\C2A4\D130 \B808\CF54\B4DC \BC0F \B514\D14C\C77C \B808\CF54\B4DC\B97C \D655\C778\D558\B824\BA74 \B808\CF54\B4DC\B97C \C120\D0DD\D569\B2C8\B2E4.<br> '),
unistr('  \B9C8\C2A4\D130 \B808\CF54\B4DC\B97C \D3B8\C9D1\D558\B824\BA74 \D3B8\C9D1 \C544\C774\CF58(<span class="fa fa-pencil-square-o" aria-hidden="true"></span>)\C744 \B204\B985\B2C8\B2E4.'),
unistr('  \B514\D14C\C77C \B808\CF54\B4DC\B97C \D3B8\C9D1\D558\B824\BA74 \AC01 \D589\C758 \B9E8 \C55E\C5D0 \C788\B294 \C5F0\D544\C744 \B204\B985\B2C8\B2E4.</p>'),
unistr('<p>\C120\D0DD\AE30\C5D0 \D45C\C2DC\B418\B294 \B370\C774\D130\B97C \C81C\D55C\D558\B824\BA74 \AC80\C0C9 \B300\D654\C0C1\C790\C5D0 \AC80\C0C9\C5B4\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
'',
unistr('<p>\C0C8 \B9C8\C2A4\D130 \B808\CF54\B4DC\B97C \CD94\AC00\D558\B824\BA74 \D398\C774\C9C0 \C0C1\B2E8\C758 <strong>\C0DD\C131</strong>\C744 \B204\B985\B2C8\B2E4.'),
unistr('  \B514\D14C\C77C \B808\CF54\B4DC\B97C \CD94\AC00\D558\B824\BA74 \B514\D14C\C77C \C601\C5ED \C0C1\B2E8\C758 \B354\D558\AE30 \C544\C774\CF58(+)\C744 \B204\B985\B2C8\B2E4.</p>'),
'',
unistr('<p>\C774\C804\C5D0 \C815\C758\B41C \AC80\C0C9\C5B4\B97C \C81C\AC70\D558\C5EC \D398\C774\C9C0\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 \D398\C774\C9C0 \C0C1\B2E8\C758 <strong>\C7AC\C124\C815</strong>\C744 \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106146240224310408)
,p_name=>'CA.HELP.P10000.ADMINISTRATION.PAGE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD00\B9AC \D398\C774\C9C0\C5D0\C11C\B294 \C560\D50C\B9AC\CF00\C774\C158 \C18C\C720\C790(\AD00\B9AC\C790)\AC00 \C560\D50C\B9AC\CF00\C774\C158\C744 \AD6C\C131\D558\ACE0 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C6A9\B418\B294 \C77C\BC18 \B370\C774\D130\B97C \C720\C9C0\BCF4\C218\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C0AC\C6A9 \AC00\B2A5\D55C \C124\C815 \C911 \D558\B098\B97C \C120\D0DD\D558\BA74 \AD00\B9AC\C790\B294 \C560\D50C\B9AC\CF00\C774\C158\C774 \D45C\C2DC\B41C \BC29\BC95 \BC0F/\B610\B294 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C0AC\C6A9 \AC00\B2A5\D55C \AE30\B2A5\C744 \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774 \D398\C774\C9C0\B294 \AD00\B9AC\C790\B9CC \C561\C138\C2A4\D558\B3C4\B85D \C81C\D55C\B418\C5B4\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106147418638310409)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.CONFIGURE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C778\C99D\B41C \BAA8\B4E0 \C0AC\C6A9\C790\C5D0 \B300\D574 \C801\D569\D55C \C120\D0DD\C0AC\D56D\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('<strong>\C544\B2C8\C624</strong>\B97C \C120\D0DD\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C774 \B354 \C548\C804\D574\C9C0\AE30 \B54C\BB38\C5D0 \C9C0\C815\B41C \C0AC\C6A9\C790\B9CC \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\D558\C9C0\B9CC \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\ADDC\BAA8 \C0AC\C6A9\C790 \CEE4\BBA4\B2C8\D2F0\AC00 \C788\C5B4\C11C \C0AC\C6A9\C790\B97C \C720\C9C0\D558\B294 \AC83\C774 \BD80\B2F4\C2A4\B7EC\C6B4 \ACBD\C6B0 <strong>\C608</strong>\B97C \B20C\B7EC \C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\C640 \C81C\ACF5\C790\B9CC \B4E4\C5B4\C62C \C218 \C788\AC8C \D560 \C218 \C788\C2B5\B2C8\B2E4.<br>'),
unistr('<strong>\C608</strong>\B97C \C120\D0DD\D558\B294 \ACBD\C6B0 \C0AC\C6A9\C790 \BAA9\B85D\C5D0 \D3EC\D568\B418\C9C0 \C54A\C740 \C0AC\C6A9\C790\B97C \C5B4\B5BB\AC8C \CC98\B9AC\D560\C9C0\B3C4 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\C790 \C774\B984\C5D0 \C804\C790\BA54\C77C \C8FC\C18C \B610\B294 \C601\C22B\C790 \AC12\C744 \C0AC\C6A9\D558\B3C4\B85D \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('\C77C\BC18\C801\C73C\B85C \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C Oracle Access Manager \B610\B294 SSO\C640 \AC19\C740 \C911\C559\D654\B41C \C778\C99D \CCB4\ACC4\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 \B610\B294 \C774\B97C \C0AC\C6A9\D558\B3C4\B85D \AD6C\C131\B41C \ACBD\C6B0 \C774 \C124\C815\C744 <strong>\C804\C790\BA54\C77C \C8FC\C18C</strong>\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p><em><strong>\CC38\ACE0:</strong> \C774 \C560\D50C\B9AC\CF00\C774\C158\C740 \C870\D68C\C790, \C81C\ACF5\C790, \AD00\B9AC\C790\B85C \AD6C\C131\B41C \C138 \AC00\C9C0 \C561\C138\C2A4 \B808\BCA8\C744 \C9C0\C6D0\D569\B2C8\B2E4.'),
'<ul>',
unistr('  <li><strong>\C870\D68C\C790</strong> - \BAA8\B4E0 \C815\BCF4\C5D0 \B300\D55C \C77D\AE30 \C804\C6A9 \C561\C138\C2A4 \AD8C\D55C\C774 \C788\C73C\BA70 \BCF4\ACE0\C11C\B3C4 \BCFC \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C81C\ACF5\C790</strong> - \C815\BCF4\B97C \C0DD\C131, \D3B8\C9D1, \C0AD\C81C\D560 \C218 \C788\ACE0 \BCF4\ACE0\C11C\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('  <li><strong>\AD00\B9AC\C790</strong>- \C81C\ACF5\C790 \AE30\B2A5 \C774\C678\C5D0\B3C4 \C560\D50C\B9AC\CF00\C774\C158\C758 [\AD00\B9AC] \C139\C158\C5D0 \C561\C138\C2A4\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106147658837310409)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.USERS.FORM'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D3FC\C744 \C0AC\C6A9\D558\C5EC \C0AC\C6A9\C790, \C0AC\C6A9\C790\C758 \C804\C790\BA54\C77C \C8FC\C18C\B97C \C785\B825\D558\ACE0 \C561\C138\C2A4 \B808\BCA8\C744 \C124\C815\D569\B2C8\B2E4.'),
unistr('<em>\C561\C138\C2A4 \C81C\C5B4 \AD6C\C131</em> \C544\B798\C5D0\C11C \C815\C758\B41C \C774 \C124\C815\C740 \C0AC\C6A9\C790 \C774\B984\C774 \C804\C790\BA54\C77C \C8FC\C18C\C5EC\C57C \D558\B294\C9C0 \B610\B294 \C601\C22B\C790 \D56D\BAA9\C77C \C218 \C788\B294\C9C0\B97C \ACB0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C560\D50C\B9AC\CF00\C774\C158\C740 \C870\D68C\C790, \C81C\ACF5\C790, \AD00\B9AC\C790\B85C \AD6C\C131\B41C \C138 \AC00\C9C0 \C561\C138\C2A4 \B808\BCA8\C744 \C9C0\C6D0\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\C870\D68C\C790</strong> - \BAA8\B4E0 \C815\BCF4\C5D0 \B300\D55C \C77D\AE30 \C804\C6A9 \C561\C138\C2A4 \AD8C\D55C\C774 \C788\C73C\BA70 \BCF4\ACE0\C11C\B3C4 \BCFC \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C81C\ACF5\C790</strong> - \C815\BCF4\B97C \C0DD\C131, \D3B8\C9D1, \C0AD\C81C\D560 \C218 \C788\ACE0 \BCF4\ACE0\C11C\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('  <li><strong>\AD00\B9AC\C790</strong> - \C81C\ACF5\C790 \AE30\B2A5 \C774\C678\C5D0\B3C4 \C560\D50C\B9AC\CF00\C774\C158\C758 [\AD00\B9AC] \C139\C158\C5D0 \C561\C138\C2A4\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
'</ul>',
unistr('<p>\AE30\C874 \C0AC\C6A9\C790\B97C \D3B8\C9D1\D558\B294 \ACBD\C6B0 \C0AC\C6A9\C790 \ACC4\C815\C744 \C7A0\AC00 \C774\B4E4\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C561\C138\C2A4\D558\C9C0 \BABB\D558\B3C4\B85D \D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p><em><strong>\CC38\ACE0:</strong>   Oracle Application Express \ACC4\C815\C744 \C0AC\C6A9\D558\B294 \ACBD\C6B0 \C791\C5C5\C601\C5ED \AD00\B9AC\C790\B294 \C5EC\AE30\C5D0 \C785\B825\B41C \C0AC\C6A9\C790\B3C4 \BE44\BC00\BC88\D638\B97C \C124\C815\D560 \C218 \C788\B294 \C77C\BC18 \C0AC\C6A9\C790\B85C \C815\C758\D574\C57C \D569\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106147549940310409)
,p_name=>'CA.HELP.P10110.ACCESS.CONTROL.USERS.REPORT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\B294 \C560\D50C\B9AC\CF00\C774\C158 \C0AC\C6A9\C790 \BC0F \BD80\C5EC\B41C \C561\C138\C2A4 \B808\BCA8\C5D0 \B300\D55C \BCF4\ACE0\C11C\B97C \BCF4\C5EC\C90D\B2C8\B2E4.</p>'),
unistr('<p>\C5F4 \C81C\BAA9\C744 \B20C\B7EC \B370\C774\D130\B97C \C815\B82C \BC0F \D544\D130\B9C1\D558\AC70\B098 <strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \C5F4 \D45C\C2DC \BC0F \B2E4\C591\D55C \CD94\AC00 \ACE0\AE09 \AE30\B2A5\C744 \C0AC\C6A9\C790\C815\C758\D569\B2C8\B2E4.<br>'),
unistr('\B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\C790 \C138\BD80\C815\BCF4 \BC0F \C561\C138\C2A4 \B808\BCA8\C744 \D3B8\C9D1\D558\AC70\B098 \C0AC\C6A9\C790\B97C \C0AD\C81C\D558\B824\BA74 \D3B8\C9D1 \C544\C774\CF58(\B178\B780\C0C9 \C5F0\D544)\C744 \B204\B985\B2C8\B2E4.</p>'),
unistr('<p>\C0C8 \C0AC\C6A9\C790 \BC0F \C774\B4E4\C758 \C561\C138\C2A4 \B808\BCA8\C744 \CD94\AC00\D558\B824\BA74 \BCF4\ACE0\C11C \B9E8 \C704\C5D0\C11C <strong>\C0AC\C6A9\C790 \CD94\AC00</strong>\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106161021440310421)
,p_name=>'CA.HELP.P10120.ACCESS.ROLE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C561\C138\C2A4 \C81C\C5B4\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0 \AD00\B9AC\C790\B294 \C778\C99D\B41C \C0AC\C6A9\C790\AC00 \D2B9\C815 \C560\D50C\B9AC\CF00\C774\C158 \AE30\B2A5\C5D0 \C561\C138\C2A4\D558\C9C0 \BABB\D558\B3C4\B85D \C81C\D55C\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \C560\D50C\B9AC\CF00\C774\C158\C740 \C138 \AC00\C9C0 \B864(\C870\D68C\C790, \C81C\ACF5\C790 \BC0F \AD00\B9AC\C790)\C744 \C9C0\C6D0\D569\B2C8\B2E4.<p>'),
'<ul>',
unistr('  <li><strong>\C870\D68C\C790</strong> - \BAA8\B4E0 \C815\BCF4\C5D0 \B300\D55C \C77D\AE30 \C804\C6A9 \C561\C138\C2A4 \AD8C\D55C\C744 \AC00\C9C0\BA70 \BCF4\ACE0\C11C\B3C4 \BCFC \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C81C\ACF5\C790</strong> - \C815\BCF4\B97C \C0DD\C131, \D3B8\C9D1 \BC0F \C0AD\C81C\D560 \C218 \C788\C73C\BA70 \BCF4\ACE0\C11C\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('  <li><strong>\AD00\B9AC\C790</strong> - \C81C\ACF5\C790 \AD8C\D55C \C774\C678\C5D0 \C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\B3C4 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106181976610310436)
,p_name=>'CA.HELP.P10140_PRELIM_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF64\B9C8, \C138\BBF8\CF5C\B860 \B610\B294 \ACF5\BC31\C73C\B85C \AD6C\BD84\B418\B294 \C0AC\C6A9\C790 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \AE30\C874 \B610\B294 \C911\BCF5 \C0AC\C6A9\C790 \C774\B984\C740 \C790\B3D9\C73C\B85C \BB34\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106146497074310408)
,p_name=>'CA.HELP.P10200.CONFIGURATION.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD6C\C131 \C124\C815\C744 \C0AC\C6A9\D558\BA74 \C77C\BC18 \C0AC\C6A9\C790\AC00 \D2B9\C815 \AE30\B2A5\C744 \C0AC\C6A9\D560 \C218 \C788\AC8C(\C0AC\C6A9) \D558\AC70\B098 \C0AC\C6A9\D560 \C218 \C5C6\AC8C(\C0AC\C6A9 \C548\D568) \D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\D2B9\C815 \AE30\B2A5\C774 \C644\C804\D788 \C900\BE44\B418\C9C0 \C54A\C740 \ACBD\C6B0 \B610\B294 \C77C\C2DC\C801\C73C\B85C \C81C\AC70\D574\C57C \D558\B294 \ACBD\C6B0 <strong>\C0AC\C6A9 \C548\D568</strong>\C744 \B204\B985\B2C8\B2E4.'),
unistr('\C0AC\C6A9\D560 \C218 \C788\AC8C \C124\C815\D574\C57C \D558\B294 \ACBD\C6B0 <strong>\C0AC\C6A9</strong>\C744 \D074\B9AD\B9CC \D558\BA74 \B429\B2C8\B2E4.</p>'),
unistr('<p><em><strong>\CC38\ACE0:</strong> \C5EC\AE30\C5D0\C11C \BCC0\ACBD\D55C \B0B4\C6A9\C740 \D604\C7AC \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589 \C911\C778 \AC1C\BCC4 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \BC18\C601\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\AC00 \C0AC\C778\C544\C6C3\D558\ACE0 \B2E4\C2DC \C0AC\C778\C778\D558\BA74 \C218\C815\B41C \AE30\B2A5 \C124\C815\C774 \D638\CD9C\B429\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106146590128310408)
,p_name=>'CA.HELP.P10300.THEME.SELECTOR'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \AE30\BCF8 \C0C9\C0C1 \CCB4\ACC4\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\C77C\BC18 \C0AC\C6A9\C790\AC00 \D14C\B9C8 \C2A4\D0C0\C77C\C744 \C120\D0DD\D558\B3C4\B85D \D5C8\C6A9</strong>\C744 \C120\D0DD\D55C \ACBD\C6B0 \AC01 \C77C\BC18 \C0AC\C6A9\C790\B294 \D648 \D398\C774\C9C0\C758 \C67C\CABD \C544\B798\C5D0 \C788\B294 <em>\C0AC\C6A9\C790\C815\C758</em> \B9C1\D06C\B97C \B20C\B7EC \C0AC\C6A9 \AC00\B2A5\D55C \D14C\B9C8 \C2A4\D0C0\C77C \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106147172567310409)
,p_name=>'CA.HELP.P10400.ACTIVITY.REPORTING.ERROR.LOG'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\B294 \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \B85C\AE45\D55C \C608\C0C1\CE58 \C54A\C740 \BAA8\B4E0 \C624\B958\C5D0 \B300\D55C \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>\C5F4 \C81C\BAA9\C744 \B20C\B7EC \B370\C774\D130\B97C \C815\B82C\D558\ACE0 \D544\D130\B9C1\D558\AC70\B098 <strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \C5F4 \D45C\C2DC \BC0F \B2E4\C591\D55C \CD94\AC00 \ACE0\AE09 \AE30\B2A5\C744 \C0AC\C6A9\C790\C815\C758\D569\B2C8\B2E4. \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106147003843310408)
,p_name=>'CA.HELP.P10500.ACTIVITY.REPORTING.TOP.USERS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \BCF4\ACE0\C11C \BC0F \CC28\D2B8\B97C \C0AC\C6A9\D558\C5EC \C9C0\C815\B41C \C2DC\AC04\BC94\C704 \B3D9\C548 \D398\C774\C9C0 \BDF0\AC00 \AC00\C7A5 \B9CE\C740 \C0AC\C6A9\C790\B97C \D655\C778\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\BCF4\ACE0 \C2DC\AC04\BC94\C704(\AE30\BCF8\AC12=1\C77C)\C744 \C120\D0DD\D558\ACE0 \D398\C774\C9C0 \B9E8 \C704\C758 \BCF4\ACE0\C11C \BC0F \CC28\D2B8 \C544\C774\CF58 \C911\C5D0\C11C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\B300\D654\C2DD \BCF4\ACE0\C11C\C758 \ACBD\C6B0 \AC80\C0C9 \D544\B4DC\B97C \C0AC\C6A9\D558\AC70\B098 <strong>\C0AC\C6A9\C790</strong> \C5F4 \C81C\BAA9\C744 \C120\D0DD\D558\C5EC \D2B9\C815 \C0AC\C6A9\C790\B97C \C120\D0DD\D569\B2C8\B2E4. \D45C\C2DC\B418\AC70\B098 \C228\ACA8\C9C4 \C5F4, \D398\C774\C9C0\BCC4 \D589, \D544\D130 \B4F1\ACFC \AC19\C740 <strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \B2E4\C591\D55C \AE30\B2A5\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4. \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106147238826310409)
,p_name=>'CA.HELP.P10510.ACTIVITY.REPORTING.PERFORMANCE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\B294 \D398\C774\C9C0 \C131\B2A5 \BC0F \C778\AE30\C5D0 \B300\D55C \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C81C\ACF5\D569\B2C8\B2E4. \C774 \BCF4\ACE0\C11C\B294 \C911\AC04 \ACBD\ACFC \C2DC\AC04\ACFC \D398\C774\C9C0 \BDF0 \C218\B97C \ACF1\D558\C5EC \ACC4\C0B0\B41C <strong>\AC00\C911 \C131\B2A5</strong>\BCC4\B85C \C815\B82C\B429\B2C8\B2E4.</p>'),
unistr('<p>\D544\C694\C5D0 \B530\B77C \D398\C774\C9C0 \B9E8 \C704\C5D0\C11C \BCF4\ACE0 \C2DC\AC04\BC94\C704(\AE30\BCF8\AC12=1\C77C)\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \C81C\BAA9\C744 \B20C\B7EC \B370\C774\D130\B97C \C815\B82C\D558\ACE0 \D544\D130\B9C1\D558\AC70\B098 <strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \C5F4 \D45C\C2DC \BC0F \B2E4\C591\D55C \CD94\AC00 \ACE0\AE09 \AE30\B2A5\C744 \C0AC\C6A9\C790\C815\C758\D569\B2C8\B2E4. \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106147352606310409)
,p_name=>'CA.HELP.P10520.ACTIVITY.REPORTING.VIEWS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\B294 \AC00\C7A5 \B9CE\C740 \CD5C\ADFC \D398\C774\C9C0 \BDF0\C5D0 \B300\D55C \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>\D544\C694\C5D0 \B530\B77C \D398\C774\C9C0 \B9E8 \C704\C5D0\C11C \BCF4\ACE0 \C2DC\AC04\BC94\C704(\AE30\BCF8\AC12=1\C77C)\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \C81C\BAA9\C744 \B20C\B7EC \B370\C774\D130\B97C \C815\B82C \BC0F \D544\D130\B9C1\D558\AC70\B098 <strong>\C791\C5C5</strong> \B2E8\CD94\B97C \B20C\B7EC \C5F4 \D45C\C2DC \BC0F \B2E4\C591\D55C \CD94\AC00 \ACE0\AE09 \AE30\B2A5\C744 \C0AC\C6A9\C790\C815\C758\D569\B2C8\B2E4. \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 <strong>\C7AC\C124\C815</strong> \B2E8\CD94\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106146380787310408)
,p_name=>'CA.HELP.P10600.NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D1B5\C9C0\AC00 \D65C\C131 \C0C1\D0DC\C774\BA74 \D648 \D398\C774\C9C0\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\C774 \BCF4\ACE0\C11C\B294 \C815\C758\B41C \D1B5\C9C0\C640 \D1B5\C9C0\AC00 \D45C\C2DC\B418\B294 \AE30\AC04\C744 \BCF4\C5EC\C90D\B2C8\B2E4.</p>'),
unistr('<p>\D3B8\C9D1 \C544\C774\CF58(\B178\B780\C0C9 \C5F0\D544)\C744 \B20C\B7EC \AE30\C874 \D1B5\C9C0\B97C \D3B8\C9D1\D558\AC70\B098 <strong>\D1B5\C9C0 \CD94\AC00</strong>\B97C \B20C\B7EC \C0C8 \D1B5\C9C0\B97C \C0BD\C785\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106146697764310408)
,p_name=>'CA.HELP.P10700.APPLICATION.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \C560\D50C\B9AC\CF00\C774\C158 \C774\B984 \BC0F \AC04\B2E8\D55C \C124\BA85\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \C774\B984\C740 \D648 \D398\C774\C9C0\C5D0 \D45C\C2DC\B418\BA70, \AC04\B2E8\D55C \C124\BA85\C740 \C560\D50C\B9AC\CF00\C774\C158 \C774\B984 \C544\B798\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106146841820310408)
,p_name=>'CA.HELP.P10920.FEEDBACK.REPORT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\B294 \C560\D50C\B9AC\CF00\C774\C158 \B0B4 \BAA8\B4E0 \C77C\BC18 \D398\C774\C9C0\C5D0\C11C \D53C\B4DC\BC31\C744 \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774 \BCF4\ACE0\C11C\B294 \C785\B825\D55C \D53C\B4DC\BC31\ACFC \AD00\B9AC\C790\AC00 \C785\B825\D55C \C751\B2F5 \BC0F \D53C\B4DC\BC31 \C0C1\D0DC\B97C \BCF4\C5EC\C90D\B2C8\B2E4.</p>'),
unistr('<p>\D3B8\C9D1 \C544\C774\CF58(\B178\B780\C0C9 \C5F0\D544)\C744 \B20C\B7EC \C751\B2F5\C744 \C785\B825\D558\AC70\B098 \D53C\B4DC\BC31 \C0C1\D0DC\B97C \C5C5\B370\C774\D2B8\D569\B2C8\B2E4.</p>'),
unistr('<p><em><strong>\CC38\ACE0:</strong> \D53C\B4DC\BC31 \C218\C2E0\C790\AC00 \C815\C758\B418\C5B4 \C788\C73C\BA74 \D53C\B4DC\BC31 \C81C\CD9C \B0B4\C6A9\B3C4 \C804\C790\BA54\C77C\C744 \D1B5\D574 \D53C\B4DC\BC31 \C218\C2E0\C790 \BAA9\B85D\C758 \C804\C790\BA54\C77C \C8FC\C18C\B85C \C804\C1A1\B429\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106162923543310422)
,p_name=>'CA.HELP.P10940.COMMA.SEP.EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF64\B9C8\B85C \AD6C\BD84\B41C \C804\C790\BA54\C77C \C8FC\C18C \BAA9\B85D\C744 \C81C\ACF5\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106146945203310408)
,p_name=>'CA.HELP.P10940.FEEDBACK.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('<p><strong>\CCA8\BD80 \C0AC\C6A9</strong> - [\C608]\C778 \ACBD\C6B0 \C0AC\C6A9\C790\AC00 \D53C\B4DC\BC31\C744 \C704\D574 \CCA8\BD80\B97C \C5C5\B85C\B4DC\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106147976051310409)
,p_name=>'CA.HELP.P11000.EMAIL.TEMPLATES.REPORT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\C5D0\B294 \C815\C758\B41C \C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8 \BC0F \C804\C1A1\B41C \C804\C790\BA54\C77C\C5D0\C11C \D15C\D50C\B9AC\D2B8\AC00 \CC38\C870\B41C \D69F\C218\AC00 \B098\C5F4\B429\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106147703306310409)
,p_name=>'CA.HELP.P11010.EMAIL.LOG'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\C5D0\B294 \C804\C1A1\B41C \C804\C790\BA54\C77C\C774 \B098\C5F4\B429\B2C8\B2E4.</p>'),
unistr('<p>\C804\C1A1\B41C \C804\C790\BA54\C77C\C5D0 \B300\D55C \C138\BD80\C815\BCF4\B97C \BCF4\B824\BA74 \B3CB\BCF4\AE30 \C544\C774\CF58\C744 \B204\B985\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106147851224310409)
,p_name=>'CA.HELP.P11020.EMAIL.TEMPLATES.FORM.EDIT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8\B97C \C815\C758\D558\B824\BA74 \B2E4\C74C \D544\B4DC\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\D15C\D50C\B9AC\D2B8 \C774\B984</strong>(\D544\C218) - \D15C\D50C\B9AC\D2B8\C5D0 \B300\D55C \C758\BBF8 \C788\B294 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>HTML \D15C\D50C\B9AC\D2B8</strong>(\D544\C218) - HTML \AE30\BC18 \C804\C790\BA54\C77C \C804\B2EC\C744 \D5C8\C6A9\D558\B294 \C218\C2E0\C790\C5D0\AC8C \C804\C1A1\D560 \C804\C790\BA54\C77C\C744 \AD6C\C131\D558\B294 \B370 \C0AC\C6A9\B418\B294 HTML \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('    \B300\CCB4 \AC12\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'    <ul>',
unistr('        <li><strong>#APP_NAME#</strong> - \C560\D50C\B9AC\CF00\C774\C158 \C774\B984\C73C\B85C \BC14\B01D\B2C8\B2E4.</li>'),
unistr('        <li><strong>#BODY1#</strong> - p_body1_text\B85C \C804\B2EC\B41C \AC12\C73C\B85C \BC14\B01D\B2C8\B2E4.</li> '),
unistr('        <li><strong>#TABLE#</strong> - \D14C\C774\BE14 \C5F4\AE30 HTML, \D14C\C774\BE14 \D589 HTML \BC0F \D14C\C774\BE14 \B2EB\AE30 HTML\C744 \C0AC\C6A9\D558\C5EC p_table_content\B85C \C804\B2EC\B41C \AC12\C73C\B85C \BC14\B01D\B2C8\B2E4.</li> '),
unistr('        <li><strong>#BODY2#</strong> - p_body2_text\B85C \C804\B2EC\B41C \AC12\C73C\B85C \BC14\B01D\B2C8\B2E4.</li> '),
unistr('        <li><strong>#ACTION#</strong> - \C791\C5C5 \B9C1\D06C \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D558\C5EC p_action_label \BC0F p_action_link\B85C \C804\B2EC\B41C \AC12\C73C\B85C \BC14\B01D\B2C8\B2E4.</li>'),
'     </ul></li>',
unistr('  <li><strong>\C77C\BC18 \D14D\C2A4\D2B8 \D15C\D50C\B9AC\D2B8</strong>(\D544\C218) - HTML \AE30\BC18 \C804\C790\BA54\C77C\C744 \D5C8\C6A9\D558\C9C0 \C54A\B294 \C218\C2E0\C790\C5D0\AC8C \C804\C1A1\D560 \C804\C790\BA54\C77C\C744 \AD6C\C131\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C77C\BC18 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. HTML \D15C\D50C\B9AC\D2B8\C640 \B3D9\C77C\D55C \B300\CCB4 \AC12\C774 \C0AC\C6A9\B429\B2C8\B2E4. \B2E8, #TABLE# \BC0F #ACTION#\C740 \C77C\BC18 \D14D\C2A4\D2B8\B85C \B80C\B354\B9C1\B429\B2C8\B2E4.</li>'),
'<ul>',
unistr('<p>\ACE0\AE09 \C804\C790\BA54\C77C\C758 \ACBD\C6B0 \CD94\AC00 HTML \D15C\D50C\B9AC\D2B8\AC00 \D5C8\C6A9\B429\B2C8\B2E4. \D574\B2F9 \D56D\BAA9\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\D589 \C55E</strong> - HTML \D15C\D50C\B9AC\D2B8\C5D0\C11C #TABLE#\C744 \BC14\AFC0 HTML\C744 \C785\B825\D569\B2C8\B2E4. p_table_content\AC00 \C804\B2EC\B41C \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</li>'),
unistr('  <li><strong>\D589 \D15C\D50C\B9AC\D2B8</strong> - \D14C\C774\BE14\C758 \AC01 \D589\C744 \B80C\B354\B9C1\D560 HTML\C744 \C785\B825\D569\B2C8\B2E4. #LABEL# \BC0F #VALUE# \B300\CCB4 \AC12\C744 \C0AC\C6A9\D558\B294 \D589 \C5F4\AE30/\B2EB\AE30 \BC0F \B370\C774\D130 \C5F4\AE30/\B2EB\AE30\AC00 \D3EC\D568\B429\B2C8\B2E4. p_table_content\AC00 \C804\B2EC\B41C \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</li>'),
unistr('  <li><strong>\D589 \B4A4</strong> - \D14C\C774\BE14 \B610\B294 div\B97C \B2EB\C744 HTML\C744 \C785\B825\D569\B2C8\B2E4. p_table_content\AC00 \C804\B2EC\B41C \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C791\C5C5 \B9C1\D06C HTML</strong> - HTML \D15C\D50C\B9AC\D2B8\C5D0\C11C #ACTION#\C744 \BC14\AFC0 HTML\C744 \C785\B825\D569\B2C8\B2E4. #ACTION_LINK# \BC0F #ACTION_TEXT#\AC00 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4. p_action_label \BC0F p_action_link\AC00 \C804\B2EC\B41C \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</li>'),
'</ul>',
unistr('<p><em><strong>\CC38\ACE0:</strong> <strong>\AE30\BCF8 \D15C\D50C\B9AC\D2B8</strong> \B0B4\C5D0 \C788\B294 \D56D\BAA9\C744 \C608\C81C\B85C \C0AC\C6A9\D558\C5EC \ACE0\C720 \D15C\D50C\B9AC\D2B8\B97C \AC1C\BC1C\D558\C2ED\C2DC\C624. \AE30\BCF8 \D15C\D50C\B9AC\D2B8\C5D0 \C0AC\C6A9\B418\B294 \BAA8\B4E0 \B300\CCB4 \BCC0\C218\B294 \ACE0\C720 \C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8 \B0B4\C5D0 \D3EC\D568\D560 \C218\B3C4 \C788\ACE0 \D3EC\D568\D558\C9C0 \C54A\C744 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106148029987310409)
,p_name=>'CA.HELP.P11030.EMAIL.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>\C804\C790\BA54\C77C \C791\C5C5 \D560\B2F9</strong> \C635\C158 \C911 \D558\B098\B97C \C120\D0DD\D558\C5EC \C804\C790\BA54\C77C \C804\C1A1\C744 \C0AC\C6A9 \B610\B294 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \BB38\C81C\B97C \BB38\C758\D560 \C218 \C788\B294 \AE30\BCF8 \C5F0\B77D\CC98\C758 \C804\C790\BA54\C77C \C8FC\C18C\B97C \C0AC\C6A9\D558\C5EC <strong>\B2E4\C74C\C5D0\C11C \C804\C1A1\B41C \C804\C790\BA54\C77C</strong>\C744 \C785\B825\D569\B2C8\B2E4. \C804\C790\BA54\C77C \AE30\B2A5\C744 \C0AC\C6A9\D560 \B54C \C774 \AC12\C744 \C0AC\C6A9\D558\AC70\B098 \ACB9\CCD0\C4F8 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106166207802310425)
,p_name=>'CA.HELP.P11030.EMAILS.FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C804\C1A1\C5D0 \C0AC\C6A9\B420 \BCF4\B0B8 \C0AC\B78C \C8FC\C18C\C785\B2C8\B2E4. \C804\C790\BA54\C77C \AE30\B2A5\C744 \C0AC\C6A9\D560 \B54C \C774 \AC12\C744 \ACB9\CCD0\C4F8 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106183598727310437)
,p_name=>'CA.HELP.P11060.SEND.EMAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2E4\C74C \D56D\BAA9\C744 \CC44\C6B0\ACE0 [\C804\C790\BA54\C77C \C804\C1A1]\C744 \B204\B985\B2C8\B2E4. \C804\C1A1\B41C \BAA8\B4E0 \C804\C790\BA54\C77C\C740 \C804\C790\BA54\C77C \B85C\ADF8\C5D0 \B85C\AE45\B429\B2C8\B2E4.'),
'    <ul>',
unistr('        <li><strong>\BCF4\B0B8 \C0AC\B78C</strong> - [\C804\C790\BA54\C77C \C124\C815]\C5D0\C11C "\BCF4\B0B8 \C0AC\B78C \C8FC\C18C"\B97C \C124\C815\D558\BA74 \D574\B2F9 \C804\C790\BA54\C77C \C8FC\C18C\AC00 \BCF4\B0B8 \C0AC\B78C \C635\C158\C73C\B85C \C81C\ACF5\B429\B2C8\B2E4. \C774 \C560\D50C\B9AC\CF00\C774\C158\C774 \C804\C790\BA54\C77C \C8FC\C18C\B97C \C0AC\C6A9\C790 \C774\B984\C73C\B85C \C0AC\C6A9\D558\B294 \ACBD\C6B0 \C804\C790\BA54\C77C \C804\C1A1 \C2DC \BCF4\B0B8 \C0AC\B78C\C744 \C804\C790\BA54\C77C \C8FC\C18C\B85C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4. \D56D\C0C1 \BCF4\B0B8 \C0AC\B78C\C774 \BC1B\B294 \C0AC\B78C\ACFC \B3D9\C77C\D558\B3C4\B85D \C124\C815\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('        <li><strong>\BC1B\B294 \C0AC\B78C</strong> - \C774 \C560\D50C\B9AC\CF00\C774\C158\C774 \C804\C790\BA54\C77C \C8FC\C18C\B97C \C0AC\C6A9\C790 \C774\B984\C73C\B85C \C0AC\C6A9\D558\B294 \ACBD\C6B0 \C804\C790\BA54\C77C \C804\C1A1 \C2DC \BC1B\B294 \C0AC\B78C\C744 \C804\C790\BA54\C77C \C8FC\C18C \BC0F/\B610\B294 \C0AC\C6A9\C790\B85C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('        <li><strong>\C804\C790\BA54\C77C \C8FC\C18C</strong> - \C804\C790\BA54\C77C\C744 \BC1B\C744 \CF64\B9C8\B85C \AD6C\BD84\B41C \C804\C790\BA54\C77C \C8FC\C18C \BAA9\B85D\C785\B2C8\B2E4. \BD80\C801\D569\D55C \AC83\C73C\B85C \D655\C778\B41C \C804\C790\BA54\C77C \C8FC\C18C\B294 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</li>'),
unistr('        <li><strong>\B864</strong> - \C120\D0DD\B41C \B864\C758 \BAA8\B4E0 \C0AC\C6A9\C790 \B610\B294 \C815\C758\B41C \BAA8\B4E0 \C0AC\C6A9\C790\C5D0\AC8C \C804\C790\BA54\C77C\C744 \C804\C1A1\D569\B2C8\B2E4. \C120\D0DD \BAA9\B85D\C5D0\B294 \B864 \BAA9\B85D \BC0F \D574\B2F9 \B864\C758 \C0AC\C6A9\C790 \C218\AC00 \D3EC\D568\B429\B2C8\B2E4.</li>'),
unistr('        <li><strong>\D15C\D50C\B9AC\D2B8</strong> - \C804\C790\BA54\C77C \BCF8\BB38 \C0DD\C131\C5D0 \C0AC\C6A9\D560 \C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('        <li><strong>\C81C\BAA9</strong> - \C804\C790\BA54\C77C \C81C\BAA9\C785\B2C8\B2E4.</li>'),
unistr('        <li><strong>\C804\C790\BA54\C77C \BCF8\BB38</strong> - \C804\C790\BA54\C77C \BCF8\BB38\C73C\B85C \D3EC\D568\D560 \D14D\C2A4\D2B8\C785\B2C8\B2E4.</li>'),
unistr('        <li><strong>\C218\C2E0 \AC70\BD80 \D5C8\C6A9</strong> - \C77C\BD80 \C804\C790\BA54\C77C\C740 \C0AC\C6A9\C790\C758 \C804\C790\BA54\C77C \C218\C2E0 \AC70\BD80\C5D0 \AD00\ACC4\C5C6\C774 \C804\C1A1\B418\C5B4\C57C \D569\B2C8\B2E4. \C7A5\C560 \BA54\C2DC\C9C0 \B4F1\C774 \C774\C5D0 \D574\B2F9\D569\B2C8\B2E4. \C774 \D50C\B798\ADF8\B294 \D574\B2F9 \C804\C790\BA54\C77C\C758 \C218\C2E0 \AC70\BD80\AC00 \D5C8\C6A9\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80 \B610\B294 \C804\C790\BA54\C77C\C774 \C0AC\C6A9\C790 \D658\ACBD\C124\C815\C5D0 \AD00\ACC4\C5C6\C774 \C804\C1A1\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C2DD\BCC4\D569\B2C8\B2E4.</li>'),
'</ul>',
'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106185233071310439)
,p_name=>'CA.HELP.P11060.SEND.EMAIL.NO.ACL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2E4\C74C \D56D\BAA9\C744 \CC44\C6B0\ACE0 [\C804\C790\BA54\C77C \C804\C1A1]\C744 \B204\B985\B2C8\B2E4. \C804\C1A1\B41C \BAA8\B4E0 \C804\C790\BA54\C77C\C740 \C804\C790\BA54\C77C \B85C\ADF8\C5D0 \B85C\AE45\B429\B2C8\B2E4.'),
'    <ul>',
unistr('        <li><strong>\BCF4\B0B8 \C0AC\B78C</strong> - [\C804\C790\BA54\C77C \C124\C815]\C5D0\C11C "\BCF4\B0B8 \C0AC\B78C \C8FC\C18C"\B97C \C124\C815\D558\BA74 \D574\B2F9 \C804\C790\BA54\C77C \C8FC\C18C\AC00 \BCF4\B0B8 \C0AC\B78C \C635\C158\C73C\B85C \C81C\ACF5\B429\B2C8\B2E4. \B610\B294 \D56D\C0C1 \BCF4\B0B8 \C0AC\B78C\C774 \BC1B\B294 \C0AC\B78C\ACFC \B3D9\C77C\D558\B3C4\B85D \C124\C815\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('        <li><strong>\C804\C790\BA54\C77C \C8FC\C18C</strong> - \C804\C790\BA54\C77C\C744 \BC1B\C744 \CF64\B9C8\B85C \AD6C\BD84\B41C \C804\C790\BA54\C77C \C8FC\C18C \BAA9\B85D\C785\B2C8\B2E4. \BD80\C801\D569\D55C \AC83\C73C\B85C \D655\C778\B41C \C804\C790\BA54\C77C \C8FC\C18C\B294 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</li>'),
unistr('        <li><strong>\D15C\D50C\B9AC\D2B8</strong> - \C804\C790\BA54\C77C \BCF8\BB38 \C0DD\C131\C5D0 \C0AC\C6A9\D560 \C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('        <li><strong>\C81C\BAA9</strong> - \C804\C790\BA54\C77C \C81C\BAA9\C785\B2C8\B2E4.</li>'),
unistr('        <li><strong>\C804\C790\BA54\C77C \BCF8\BB38</strong> - \C804\C790\BA54\C77C \BCF8\BB38\C73C\B85C \D3EC\D568\D560 \D14D\C2A4\D2B8\C785\B2C8\B2E4.</li>'),
unistr('        <li><strong>\C218\C2E0 \AC70\BD80 \D5C8\C6A9</strong> - \C77C\BD80 \C804\C790\BA54\C77C\C740 \C0AC\C6A9\C790\C758 \C804\C790\BA54\C77C \C218\C2E0 \AC70\BD80\C5D0 \AD00\ACC4\C5C6\C774 \C804\C1A1\B418\C5B4\C57C \D569\B2C8\B2E4. \C7A5\C560 \BA54\C2DC\C9C0 \B4F1\C774 \C774\C5D0 \D574\B2F9\D569\B2C8\B2E4. \C774 \D50C\B798\ADF8\B294 \D574\B2F9 \C804\C790\BA54\C77C\C758 \C218\C2E0 \AC70\BD80\AC00 \D5C8\C6A9\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80 \B610\B294 \C804\C790\BA54\C77C\C774 \C0AC\C6A9\C790 \D658\ACBD\C124\C815\C5D0 \AD00\ACC4\C5C6\C774 \C804\C1A1\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C2DD\BCC4\D569\B2C8\B2E4.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106146707813310408)
,p_name=>'CA.HELP.P12000.TIME.ZONE.SUPPORT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \BAA8\B4E0 \C0AC\C6A9\C790\C5D0 \B300\D55C \AE30\BCF8 \C2DC\AC04\B300\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\AC1C\BCC4 \C0AC\C6A9\C790\B294 \C0AC\C6A9\C790 \C774\B984(\C624\B978\CABD \B9E8 \C704)\C744 \B204\B974\ACE0 <strong>\D658\ACBD\C124\C815</strong>\C744 \C120\D0DD\D558\C5EC \C774 \C124\C815\C744 \BB34\D6A8\D654\D560 \C218 \C788\C2B5\B2C8\B2E4. \B610\B294 \D648 \D398\C774\C9C0 \C544\B798\CABD\C5D0 \D45C\C2DC\B418\B294 \C2DC\AC04\B300 \B9C1\D06C\B97C \B204\B97C \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106162621434310422)
,p_name=>'CA.HELP.P2000.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B294 UI\B97C \D1B5\D574 \C9C1\C811 \C561\C138\C2A4\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C774 \D398\C774\C9C0\B294 \D504\B85C\D30C\C77C \C0AC\C9C4 \B2E4\C6B4\B85C\B4DC\C5D0 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106162360179310422)
,p_name=>'CA.HELP.P20000.USER.PROFILE'
,p_message_language=>'ko'
,p_message_text=>unistr('[\C0AC\C6A9\C790 \D504\B85C\D30C\C77C \D398\C774\C9C0]\C5D0\C11C\B294 \C0AC\C6A9\D558\AE30 \C26C\C6B4 \D654\BA74 \D558\B098\C5D0\C11C \C0AC\C6A9\C790\C5D0 \B300\D55C \AD00\B828 \C815\BCF4\B97C \D655\C778\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106162023258310421)
,p_name=>'CA.HELP.P20030.PHOTO.UPLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\AC01\D615 \AC00\B85C \C138\B85C \BE44\C728\B85C \B41C \C0AC\C9C4\C744 \C5C5\B85C\B4DC\D558\C2ED\C2DC\C624. \ADF8\B807\C9C0 \C54A\C740 \ACBD\C6B0 \C0AC\C9C4\C774 \C65C\ACE1\B420 \C218 \C788\C2B5\B2C8\B2E4. \C120\D638 \C774\BBF8\C9C0 \D06C\AE30\B294 250x250\D53D\C140\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106148187836310409)
,p_name=>'CA.HELP.P20200.USER.PROFILE.MODAL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D3FC\C744 \C0AC\C6A9\D558\BA74 \AC1C\C778 \C138\BD80\C815\BCF4\B97C \C5C5\B370\C774\D2B8\D558\ACE0 \C0AC\C9C4 \B610\B294 \C544\BC14\D0C0\B97C \C5C5\B85C\B4DC\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774\BBF8\C9C0\B97C \C5C5\B85C\B4DC\D558\B824\BA74 <strong>\CC3E\C544\BCF4\AE30</strong>\B97C \B204\B974\AC70\B098 \C774\BBF8\C9C0\B97C \B2E8\CD94 \C704\B85C \B04C\C5B4 \B193\C2B5\B2C8\B2E4.<br>'),
unistr('\C0AC\AC01\D615 \AC00\B85C \C138\B85C \BE44\C728\B85C \B41C \C0AC\C9C4\C744 \C5C5\B85C\B4DC\D558\C2ED\C2DC\C624. \ADF8\B807\C9C0 \C54A\C740 \ACBD\C6B0 \C0AC\C9C4\C774 \C65C\ACE1\B420 \C218 \C788\C2B5\B2C8\B2E4. \C120\D638 \C774\BBF8\C9C0 \D06C\AE30\B294 250x250\D53D\C140\C785\B2C8\B2E4.</p>'),
unistr('<p><strong>\C0AC\C9C4 \C0AD\C81C</strong>\B97C \B20C\B7EC \C774\BBF8\C9C0\B97C \C81C\AC70\D569\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106168281260310426)
,p_name=>'CA.HELP.P20210.ABOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0\C11C \BAA8\B4E0 \C560\D50C\B9AC\CF00\C774\C158 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4. "\C124\BA85\C11C" \C601\C5ED\C758 \B9C1\D06C\B294 \C560\D50C\B9AC\CF00\C774\C158\C758 \AE30\B2A5\C5D0 \B300\D55C \AE4A\C774 \C788\B294 \C124\BA85\C744 \C81C\ACF5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106149281145310410)
,p_name=>'CA.HELP.P20400.APP.PREF'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0\C11C \C0AC\C6A9\C790 \ACC4\C815\C5D0 \B300\D55C \C560\D50C\B9AC\CF00\C774\C158 \D658\ACBD\C124\C815\C744 \C9C0\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \D658\ACBD\C124\C815\C740 \C2DC\AC04\B300\C640 \AC19\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \C5EC\B7EC \CE21\BA74\C5D0 \C601\D5A5\C744 \C904 \C218 \C788\C2B5\B2C8\B2E4. \D56D\BAA9 \B808\BCA8 \B3C4\C6C0\B9D0 \C544\C774\CF58\C744 \B20C\B7EC \AC01 \D658\ACBD\C124\C815\C774 \C5B4\B5A4 \C791\C5C5\C744 \C218\D589\D558\B294\C9C0 \C54C\C544\BD05\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105252090451309660)
,p_name=>'CA.HELP.P20500.EMAIL.REPORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \BCF4\ACE0\C11C\B294 \B300\AE30\C5F4\C5D0 \C788\B294 \C804\C1A1 \C608\C815 \C804\C790\BA54\C77C\ACFC \C774\BBF8 \C804\C1A1\B41C \C804\C790\BA54\C77C\C744 \BCF4\C5EC\C90D\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105373561044309753)
,p_name=>'CA.HELP.P20600.JOB.REPORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \BCF4\ACE0\C11C\C5D0\B294 \D574\B2F9 \C560\D50C\B9AC\CF00\C774\C158\C774 \BAA8\B2C8\D130\D558\B3C4\B85D \C120\D0DD\B41C \BAA8\B4E0 \C791\C5C5\C774 \D3EC\D568\B429\B2C8\B2E4. \C791\C5C5 \C774\B984\C744 \B20C\B7EC \AC01 \C791\C5C5\C5D0 \B300\D55C \CD94\AC00 \C138\BD80\C815\BCF4\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105380177762309758)
,p_name=>'CA.HELP.P20610.JOB.RUN.DETAILS'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \BCF4\ACE0\C11C\C5D0\B294 \D574\B2F9 \C560\D50C\B9AC\CF00\C774\C158\C774 \BAA8\B2C8\D130\D558\B3C4\B85D \C120\D0DD\B41C \C791\C5C5\C5D0 \B300\D55C \C2E4\D589 \C138\BD80\C815\BCF4\AC00 \D3EC\D568\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106133516561310396)
,p_name=>'CA.HELP.PAGE.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158 \C815\BCF4 \D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106149911710310411)
,p_name=>'CA.HELP.RECEIVE.EMAILS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C804\C790\BA54\C77C\C744 \BC1B\C9C0 \C54A\C73C\B824\BA74 \C774 \C635\C158\C744 [\C544\B2C8\C624]\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106183015103310437)
,p_name=>'CA.HELP.SEARCH.PAGE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AC80\C0C9 \B300\D654\C0C1\C790\C5D0 \AC80\C0C9\C5B4\B97C \C785\B825\D558\ACE0 <strong>\AC80\C0C9</strong>\C744 \B204\B985\B2C8\B2E4.<br>'),
unistr('\ACB0\ACFC \C81C\BAA9\C744 \B204\B974\BA74 \D574\B2F9\D558\B294 \D2B9\C815 \B808\CF54\B4DC\B85C \C774\B3D9\B429\B2C8\B2E4.</p>'),
unistr('<p>\AC80\C0C9\C744 \C81C\D55C\D558\B824\BA74 \D558\B098 \C774\C0C1\C758 \C18C\C2A4\B97C \C120\D0DD \CDE8\C18C\D569\B2C8\B2E4. \ADF8\B7EC\BA74 \AC80\C0C9 \ACB0\ACFC\C5D0\C11C \D574\B2F9 \BCF4\ACE0\C11C\AC00 \C81C\AC70\B429\B2C8\B2E4.</p>'),
unistr('<p>\D604\C7AC \AC80\C0C9\C5B4\B97C \C81C\AC70\D558\ACE0 \BAA8\B4E0 \C18C\C2A4\B97C \C120\D0DD\D558\B824\BA74 <strong>\C7AC\C124\C815</strong>\C744 \B204\B985\B2C8\B2E4.</p> ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106149725036310411)
,p_name=>'CA.HELP.TIME.ZONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C6A9\D560 \C120\D638 \C2DC\AC04\B300\B97C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105147904715309583)
,p_name=>'CA.HIDDEN.ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\ACA8\C9C4 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106169803770310427)
,p_name=>'CA.HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106175924120310432)
,p_name=>'CA.HOME.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106191256691310443)
,p_name=>'CA.HOURLY.PAGE.EVENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04\BCC4 \D398\C774\C9C0 \C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105251100363309659)
,p_name=>'CA.HTML.BODY.SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \BCF8\BB38 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106166633790310425)
,p_name=>'CA.HTML.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106163314586310422)
,p_name=>'CA.IN.PROGRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C4\D589 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106187457706310440)
,p_name=>'CA.INCLUDEONFORMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC\C5D0 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106187349072310440)
,p_name=>'CA.INCLUDEONREPORTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C5D0 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106172041733310429)
,p_name=>'CA.INSTALL.SUP.OBJ.SCRIPTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0 \AC1D\CCB4 \C2A4\D06C\B9BD\D2B8 \C124\CE58 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105374247158309753)
,p_name=>'CA.INSTANCE.ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C2A4\D134\C2A4 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105375481030309754)
,p_name=>'CA.INSTANCE.STICKINESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C2A4\D134\C2A4 \ACE0\C815\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106145718109310407)
,p_name=>'CA.INTRO.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BCF4\B2E4 \C644\BCBD\D55C \AE30\B2A5\C774 \C81C\ACF5\B418\B294 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D560 \C218 \C788\B294 \C0C8\B86D\ACE0 \AC1C\C120\B41C \BC29\C2DD\C744 \C81C\ACF5\D558\B294 \D074\B77C\C6B0\B4DC \C804\C6A9 \BBF8\B9AC\BCF4\AE30\B97C \C2DC\C791\D569\B2C8\B2E4. \D45C\C900 \C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131 \B9C8\BC95\C0AC\B97C \C0AC\C6A9\D558\BA74 \C0DD\C131\D560 \D398\C774\C9C0\B9CC \C120\D0DD\D560 \C218 \C788\C5C8\C9C0\B9CC \C774 \B9C8\BC95\C0AC\B294 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C218\B9CE\C740 \CD94\AC00 \AE30\B2A5\C744 \BE60\B974\AC8C \BBF8\B9AC \B85C\B4DC\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774 \B9C8\BC95\C0AC\B97C \C0AC\C6A9\D558\C5EC \C0DD\C131\B41C \C560\D50C\B9AC\CF00\C774\C158\C740 \C644\C804\D788 \C9C0\C6D0\B418\BA70 \C561\C138\C2A4 \C81C\C5B4, \C804\C790\BA54\C77C \D504\B808\C784\C6CC\D06C, \D53C\B4DC\BC31 \B4F1\ACFC \AC19\C740 \C120\D0DD\D55C \AE30\B2A5\C5D0 \B300\D55C \C9C0\C6D0 \AC1D\CCB4\B3C4 \D3EC\D568\B420 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106145929067310407)
,p_name=>'CA.INTRO.HOWTO.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \C774\B984 \C785\B825\BD80\D130 \C2DC\C791\D569\B2C8\B2E4. \ADF8\B7F0 \B2E4\C74C \C560\D50C\B9AC\CF00\C774\C158\C5D0 \D398\C774\C9C0\B97C \D558\B098 \C774\C0C1 \CD94\AC00\D569\B2C8\B2E4. \C6D0\D558\B294 \AE30\B2A5\C774 \D3EC\D568\B418\C5C8\B294\C9C0 \D655\C778\D569\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158 \BAA8\C591\C744 \C120\D0DD\D55C \B2E4\C74C \C124\C815\C744 \AC80\D1A0\D569\B2C8\B2E4.<br>'),
unistr('<strong>\C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131</strong>\C744 \B204\B974\BA74 \B05D\C785\B2C8\B2E4!</p>'),
unistr('<p>\C774\C804\C5D0 \C0DD\C131\D55C \C560\D50C\B9AC\CF00\C774\C158\C758 \BAA8\B378\C744 \C7AC\C0AC\C6A9\D558\AC70\B098 \D398\C774\C9C0\B97C \BE60\B974\AC8C \BCF5\C81C\D558\B824\BA74 <strong>\CCAD\C0AC\C9C4 \BCF4\AE30</strong>\B97C \B204\B985\B2C8\B2E4.</p>'),
unistr('<p><em><strong>\CC38\ACE0:</strong> \AC01 \C139\C158\ACFC \AC01 ''\D398\C774\C9C0 \CD94\AC00''\C5D0\B294 \B3C4\C6C0\C774 \B420 \B9CC\D55C \C790\C138\D55C \B3C4\C6C0\B9D0\C774 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.</em></p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106145866788310407)
,p_name=>'CA.INTRO.HOWTO.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9C8\BC95\C0AC\B97C \C0AC\C6A9\D558\B294 \BC29\BC95')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106179418636310434)
,p_name=>'CA.INTRO.KNOWN.ISSUES.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B9B4\B9AC\C2A4 \C2DC \D655\C778\B41C \C911\C694\D55C \BB38\C81C\AC00 \C544\B798\C5D0 \B098\C5F4\B429\B2C8\B2E4.'),
'<ol>',
unistr('  <li>\CCAD\C0AC\C9C4 \B9C8\BC95\C0AC\C758 \C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131\C774 \BC88\C5ED\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</li>'),
unistr('  <li>\C774 \B9C8\BC95\C0AC\B85C \C0DD\C131\B418\C5B4 \BC88\C5ED\B41C \C560\D50C\B9AC\CF00\C774\C158\C774 \BD80\BD84\C801\C73C\B85C\B9CC \BC88\C5ED\B429\B2C8\B2E4.</li>'),
unistr('  <li>\BCF4\ACE0\C11C \B4DC\B9B4 \B2E4\C6B4\C5D0\C11C \D558\B098\C758 \B4DC\B9B4 \B2E4\C6B4 \C5F4\B9CC \D5C8\C6A9\B429\B2C8\B2E4.</li>'),
unistr('  <li>\BCF4\ACE0\C11C \D544\D130\B9C1 \D398\C774\C9C0\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</li>'),
unistr('  <li>\C804\C790\BA54\C77C \AE30\B2A5\C774 \B0AE\C740 \B808\BCA8\C758 API\B97C \C81C\ACF5\D558\C9C0\B9CC \BCF4\B2E4 \B192\C740 \B808\BCA8\C758 \C804\C790\BA54\C77C \AE30\B2A5\C744 \D3EC\D568\D558\C9C0 \C54A\C2B5\B2C8\B2E4.</li>'),
unistr('  <li>\B204\B77D\B41C \D14C\C774\BE14\C744 \CC38\C870\D558\B294 \CCAD\C0AC\C9C4\C5D0 \AE30\BC18\D55C \C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131\C744 \C2E4\D328\D569\B2C8\B2E4.</li>'),
unistr('  <li>\ACE0\AE09 \C124\C815 - \C0DD\C131\B41C \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B0A0\C9DC \D615\C2DD\C774 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</li>'),
'</ol>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106179373757310434)
,p_name=>'CA.INTRO.KNOWN.ISSUES.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C\B824\C9C4 \BB38\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106146109121310408)
,p_name=>'CA.INTRO.RELEASE.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B9B4\B9AC\C2A4: %0.</p>'),
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106146041679310408)
,p_name=>'CA.INTRO.RELEASE.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9B4\B9AC\C2A4 \C138\BD80\C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106145640824310407)
,p_name=>'CA.INTRO.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAD\C0AC\C9C4\C5D0\C11C \C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131 \B9C8\BC95\C0AC {\D074\B77C\C6B0\B4DC \C804\C6A9 \BBF8\B9AC\BCF4\AE30}')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106157280165310418)
,p_name=>'CA.IP.ADDRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('IP \C8FC\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106155410699310416)
,p_name=>'CA.IR.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('IR \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106158445879310419)
,p_name=>'CA.IR.SEARCHES'
,p_message_language=>'ko'
,p_message_text=>unistr('IR \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106185857198310439)
,p_name=>'CA.ITEMNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105378223960309756)
,p_name=>'CA.JOB.ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C870\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105379733823309757)
,p_name=>'CA.JOB.CLASS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105378806351309757)
,p_name=>'CA.JOB.CREATOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C0DD\C131\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105379973090309757)
,p_name=>'CA.JOB.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105376411660309755)
,p_name=>'CA.JOB.PRIORITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C6B0\C120\C21C\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105373426514309753)
,p_name=>'CA.JOB.REPORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105413579346309782)
,p_name=>'CA.JOB.REPORTING.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C744 \C9C0\C6D0\D558\B294 \C791\C5C5\C758 \C0C1\D0DC \BC0F \C2E4\D589 \C138\BD80\C815\BCF4 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105380049888309758)
,p_name=>'CA.JOB.RUN.DETAILS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C2E4\D589 \C138\BD80\C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105378995103309757)
,p_name=>'CA.JOB.STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105379046116309757)
,p_name=>'CA.JOB.SUBNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \D558\C704 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105378361994309756)
,p_name=>'CA.JOB.TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105375054699309754)
,p_name=>'CA.JOB.WEIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \AC00\C911\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106186348003310439)
,p_name=>'CA.KEYCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106188125139310441)
,p_name=>'CA.LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106186616205310440)
,p_name=>'CA.LABELCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106188375182310441)
,p_name=>'CA.LABELPLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \BCF5\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106188019919310441)
,p_name=>'CA.LABELSINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \B2E8\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106144832713310406)
,p_name=>'CA.LANGUAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106144938241310407)
,p_name=>'CA.LANGUAGE.DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \AE30\BCF8 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106178822413310434)
,p_name=>'CA.LANGUAGE.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AE30\BCF8 \C5B8\C5B4\C5D0 \B530\B77C \C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30\C5D0\C11C \C0DD\C131\B41C \D398\C774\C9C0 \BC0F \AD6C\C131\C694\C18C\B97C \D45C\C2DC\D560 \B54C \C0AC\C6A9\B418\B294 \C5B8\C5B4\AC00 \ACB0\C815\B429\B2C8\B2E4. \B2E4\AD6D\C5B4 \BC88\C5ED\C744 \C120\D0DD\D558\BA74 \C77C\BC18 \C0AC\C6A9\C790\B294 \B7F0\D0C0\C784 \C560\D50C\B9AC\CF00\C774\C158\C774 \B80C\B354\B9C1\B420 \B54C \C0AC\C6A9\D560 \C5B8\C5B4\B97C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105511232905309870)
,p_name=>'CA.LANGUAGE_SELECTOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4 \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106161833119310421)
,p_name=>'CA.LAST.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105379152064309757)
,p_name=>'CA.LAST.RUN.DURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9 \C2E4\D589 \AE30\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105379257456309757)
,p_name=>'CA.LAST.START.DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9 \C2DC\C791 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106191689194310443)
,p_name=>'CA.LATEST.ACTIVITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C2E0 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106187512845310440)
,p_name=>'CA.LISTOFVALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106182947376310437)
,p_name=>'CA.LOAD.BLUEPRINT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAD\C0AC\C9C4 \B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105381519261309759)
,p_name=>'CA.LOG.DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105381668099309759)
,p_name=>'CA.LOG.ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105375785055309754)
,p_name=>'CA.LOGGING.LEVEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\AE45 \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106058984878310327)
,p_name=>'CA.LOG_MESSAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105149105656309584)
,p_name=>'CA.LOOKUP.COLUMNS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>\C870\D68C \C5F4</strong> - \B2E4\B978 \D14C\C774\BE14\C5D0 \B300\D55C \C870\D68C \C815\C758 \C18D\C131\C744 \D45C\C2DC\D558\B824\BA74 \D655\C7A5\D569\B2C8\B2E4. \C870\D68C \C5F4\C744 \C0AC\C6A9\D558\C5EC \C2DD\BCC4\C790\B97C \D45C\C2DC \C5F4\B85C \BC14\AFC0 \C218 \C788\C2B5\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \BD80\C11C \BC88\D638 \B300\C2E0 \BD80\C11C \C774\B984\C744 \D45C\C2DC\D569\B2C8\B2E4.<br>'),
unistr('<em><strong>\CC38\ACE0:</strong> \C870\D68C \C5F4\C740 \D604\C7AC \D398\C774\C9C0\AC00 \D14C\C774\BE14 \B610\B294 \BDF0\B97C \AE30\BC18\C73C\B85C \D558\BA70 \B2E4\B978 \D14C\C774\BE14\C5D0 \B300\D55C \C678\B798 \D0A4 \C81C\C57D \C870\AC74\C744 \AC00\C9C0\B294 \ACBD\C6B0\C5D0\B9CC \D45C\C2DC\B429\B2C8\B2E4.'),
'  <ul>',
unistr('    <li><strong>\C870\D68C \D0A4</strong> - \D45C\C2DC \C5F4\C744 \CD9C\B825\D558\B3C4\B85D \BCC0\ACBD\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>\D45C\C2DC \C5F4</strong> - \C870\D68C \D14C\C774\BE14\C5D0\C11C \D45C\C2DC\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
'    &nbsp;<br>',
unistr('    <em><strong>\CC38\ACE0:</strong> \C678\B798 \D0A4\B97C \C0AC\C6A9\D558\C5EC \B2E4\B978 \D14C\C774\BE14\C744 \CC38\C870\D558\B294 \C5F4\B9CC \C120\D0DD\D558\C2ED\C2DC\C624.</em></li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106165851012310424)
,p_name=>'CA.MANAGE.EMAIL.TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106163834743310423)
,p_name=>'CA.MANAGE.FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106159903929310420)
,p_name=>'CA.MANAGE.USER.ACCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C561\C138\C2A4 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106192249902310444)
,p_name=>'CA.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \B514\D14C\C77C \D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106192314301310444)
,p_name=>'CA.MASTER.DETAILS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \B370\C774\D130 \D655\C778 \BC0F \C720\C9C0\BCF4\C218\C5D0 \C0AC\C6A9\D560 \B9C8\C2A4\D130-\B514\D14C\C77C \D398\C774\C9C0\B97C \D45C\C2DC\D558\B294 \D398\C774\C9C0\B97C \C0DD\C131\D569\B2C8\B2E4.<br>'),
'&nbsp;</p>',
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\D398\C774\C9C0 \C774\B984</strong>(\D544\C218) - \C774 \D398\C774\C9C0\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C544\C774\CF58 \C124\C815</strong> - \C774 \D398\C774\C9C0\C758 \D0D0\C0C9 \BA54\B274\C5D0 \D45C\C2DC\D560 \C544\C774\CF58\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\D398\C774\C9C0 \C720\D615</strong> - \D398\C774\C9C0 \C720\D615 [\C138\B85C \C815\B82C, \B204\C801]\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('    <strong>\C138\B85C \C815\B82C</strong>: <br>'),
unistr('<em>\BAA8\B2EC \D3B8\C9D1 \CC3D\C774 \D3EC\D568\B41C \BCF4\ACE0\C11C \C601\C5ED\ACFC \C138\B85C \C815\B82C \B808\C774\C544\C6C3\C744 \C0AC\C6A9\D558\B294 \B2E8\C77C \D398\C774\C9C0 \B9C8\C2A4\D130-\B514\D14C\C77C\C785\B2C8\B2E4.</em>'),
'    <ul>',
unistr('      <li><strong>\D14C\C774\BE14</strong>(\D544\C218) - \D398\C774\C9C0\C758 \B9C8\C2A4\D130 \D14C\C774\BE14\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('      <li><strong>\AE30\BCF8 \D45C\C2DC \C5F4</strong>(\D544\C218) - \B9C8\C2A4\D130 \B808\CF54\B4DC \BAA9\B85D\C5D0 \D45C\C2DC\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('      <li><strong>\BCF4\C870 \D45C\C2DC \C5F4</strong>(\D544\C218) - \B9C8\C2A4\D130 \B808\CF54\B4DC \BAA9\B85D\C758 [\AE30\BCF8 \D45C\C2DC \C5F4] \C544\B798\C5D0 \D45C\C2DC\D560 \BCF4\C870 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('      <li><strong>\B514\D14C\C77C \D14C\C774\BE14 1</strong>(\D544\C218) - \D398\C774\C9C0\C758 \CCAB\BC88\C9F8 \B514\D14C\C77C \D14C\C774\BE14\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('      <li><strong>\B514\D14C\C77C \D14C\C774\BE14 2</strong> - \D398\C774\C9C0\C758 \B450\BC88\C9F8 \B514\D14C\C77C \D14C\C774\BE14\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('      <li><strong>\B514\D14C\C77C \D14C\C774\BE14 3</strong> - \D398\C774\C9C0\C758 \C138\BC88\C9F8 \B514\D14C\C77C \D14C\C774\BE14\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('      <li><strong>\B514\D14C\C77C \D14C\C774\BE14 4</strong> - \D398\C774\C9C0\C758 \B124\BC88\C9F8 \B514\D14C\C77C \D14C\C774\BE14\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
'    </ul>',
unistr('   <strong>\B204\C801</strong>: <br>'),
unistr('<em>\D3B8\C9D1 \AC00\B2A5 \B300\D654\C2DD \ADF8\B9AC\B4DC\B97C \C0AC\C6A9\D558\B294 \B2E8\C77C \D398\C774\C9C0 \B9C8\C2A4\D130-\B514\D14C\C77C\C785\B2C8\B2E4.</em>'),
'    <ul>',
unistr('      <li><strong>\D14C\C774\BE14</strong>(\D544\C218) - \D3B8\C9D1 \AC00\B2A5 \B300\D654\C2DD \ADF8\B9AC\B4DC\C758 \B9C8\C2A4\D130 \D14C\C774\BE14\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('      <li><strong>\B514\D14C\C77C \D14C\C774\BE14</strong>(\D544\C218) - \D398\C774\C9C0\C758 \B514\D14C\C77C \D14C\C774\BE14\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('      <em><strong>\CC38\ACE0:</strong> \B9C8\BC95\C0AC\B97C \D1B5\D574\C11C\B294 \B514\D14C\C77C \D14C\C774\BE14(\D3B8\C9D1 \AC00\B2A5 \B300\D654\C2DD \ADF8\B9AC\B4DC)\C744 \D558\B098\B9CC \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4. \C0DD\C131 \D6C4 \AC04\D3B8\D558\AC8C \B2E4\B978 \B514\D14C\C77C \D14C\C774\BE14\C744 \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</em>'),
'    </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105511196399309870)
,p_name=>'CA.MASTER_RECORDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \B808\CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106156181063310417)
,p_name=>'CA.MAX.ELAPSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \ACBD\ACFC \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105376266296309755)
,p_name=>'CA.MAX.FAILURES'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \C2E4\D328')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105375848281309754)
,p_name=>'CA.MAX.RUN.DURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \C2E4\D589 \AE30\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105376339595309755)
,p_name=>'CA.MAX.RUNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106186578885310439)
,p_name=>'CA.MAXIMUMROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106189516321310442)
,p_name=>'CA.MAXIMUMWIDTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106180119260310435)
,p_name=>'CA.MD.ADD.FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106180524421310435)
,p_name=>'CA.MD.ADD.ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106180071887310435)
,p_name=>'CA.MD.APPLY.FILTERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106180985340310435)
,p_name=>'CA.MD.DATE.VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106181016088310435)
,p_name=>'CA.MD.DATE.VALUE.2'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \AC12 2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106180219589310435)
,p_name=>'CA.MD.EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106179672606310434)
,p_name=>'CA.MD.FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106179523686310434)
,p_name=>'CA.MD.FILTERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106180608377310435)
,p_name=>'CA.MD.NO.FILTERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106179964369310435)
,p_name=>'CA.MD.NO.RECORD.SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \B808\CF54\B4DC \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106179879377310435)
,p_name=>'CA.MD.NO.RECORDS.FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\CF54\B4DC\B97C \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106180463131310435)
,p_name=>'CA.MD.ROWS.DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AD\C81C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106180349608310435)
,p_name=>'CA.MD.ROWS.UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C5C5\B370\C774\D2B8\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106179790203310434)
,p_name=>'CA.MD.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106180780918310435)
,p_name=>'CA.MD.VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106180850271310435)
,p_name=>'CA.MD.VALUE.2'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106155656886310417)
,p_name=>'CA.MEDIAN.ELAPSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\AC04 \ACBD\ACFC \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106164785732310423)
,p_name=>'CA.MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106058757415310326)
,p_name=>'CA.MESSAGE_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106189075346310441)
,p_name=>'CA.METRIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE21\C815\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106156542263310417)
,p_name=>'CA.MIN.ELAPSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C \ACBD\ACFC \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106159320979310419)
,p_name=>'CA.MOBILE.PHONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \C804\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106155144621310416)
,p_name=>'CA.MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106168924504310426)
,p_name=>'CA.MORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B354 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106158561967310419)
,p_name=>'CA.MOST RECENT'
,p_message_language=>'ko'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106191423821310443)
,p_name=>'CA.MOST.ACTIVE.PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C7A5 \D65C\C131\D654\B41C \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105149271016309584)
,p_name=>'CA.MULTIPLE.REPORTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105149332139309584)
,p_name=>'CA.MULTIPLE.REPORTS.DETAILS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D558\B098 \C774\C0C1\C758 \D14C\C774\BE14 \B610\B294 \BDF0 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \B610\B294 \BA38\B9AC\AE00\C758 \CCB4\D06C\BC15\C2A4\B97C \B20C\B7EC \B098\C5F4\B41C \BAA8\B4E0 \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C120\D0DD \B610\B294 \C120\D0DD \D574\C81C\D569\B2C8\B2E4.</p>'),
unistr('<p>\C120\D0DD\B41C \AC01 \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\C5D0 \B300\D574 \B300\D654\C2DD \BCF4\ACE0\C11C\AC00 \D3EC\D568\B41C \D398\C774\C9C0\AC00 \CD94\AC00\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106152599031310414)
,p_name=>'CA.MUST.BE.VALID.TIMESTAMP'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740 \C801\D569\D55C \C2DC\AC04\AE30\B85D\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106188869276310441)
,p_name=>'CA.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106144001222310406)
,p_name=>'CA.NAVIGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106144182465310406)
,p_name=>'CA.NAVIGATION.DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\BA54\B274\B97C \C560\D50C\B9AC\CF00\C774\C158 \CE21\BA74\C5D0 \D45C\C2DC\D560\C9C0 \C544\B2C8\BA74 \C560\D50C\B9AC\CF00\C774\C158 \C0C1\B2E8\C5D0 \AC00\B85C\B85C \D45C\C2DC\D560\C9C0 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106195580616310446)
,p_name=>'CA.NEGATIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C815\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106195420580310446)
,p_name=>'CA.NEUTRAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\B9BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106181572660310436)
,p_name=>'CA.NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105376041793309755)
,p_name=>'CA.NEXT.RUN.DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C2E4\D589 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105374901818309754)
,p_name=>'CA.NLS.ENV'
,p_message_language=>'ko'
,p_message_text=>unistr('NLS \D658\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105463906842309831)
,p_name=>'CA.NO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106163497802310422)
,p_name=>'CA.NO.ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106175074819310431)
,p_name=>'CA.NO.HELP.AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0 \B300\D55C \B3C4\C6C0\B9D0\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105148099473309583)
,p_name=>'CA.NO.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \C0AC\C6A9\C790\AC00 \C874\C7AC\D558\C9C0 \C54A\C74C - \D398\C774\C9C0 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106182535485310436)
,p_name=>'CA.NO.VALID.USER.FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \C0C8 \C0AC\C6A9\C790\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106178621244310434)
,p_name=>'CA.NONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106159613257310420)
,p_name=>'CA.NOTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106135152616310397)
,p_name=>'CA.NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106133906321310396)
,p_name=>'CA.NOTIFICATION.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648 \D398\C774\C9C0\C5D0 \D1B5\C9C0 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106135256913310397)
,p_name=>'CA.NOTIFICATION.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158 \D648 \D398\C774\C9C0\C5D0\C11C \BAA8\B4E0 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \ACBD\BCF4(\B178\B780\C0C9) \B610\B294 \C624\B958(\BE68\AC04\C0C9)\B97C \C9C0\C815\D560 \C218 \C788\B3C4\B85D \D569\B2C8\B2E4. \C774 \AE30\B2A5\C740 \C77C\BC18 \C0AC\C6A9\C790 \CEE4\BBA4\B2C8\D2F0\C5D0 \C911\C694\D55C \C815\BCF4\B97C \B9B4\B808\C774\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B429\B2C8\B2E4.<ul>'),
unistr('<li>\D1B5\C9C0 \C815\C758 \AE30\B2A5</li>'),
unistr('<li>\C560\D50C\B9AC\CF00\C774\C158 \D648 \D398\C774\C9C0\C5D0 \D1B5\C9C0 \D45C\C2DC</li>'),
unistr('<li>\D1B5\C9C0 \D45C\C2DC\C758 \C2DC\AC04 \BC94\C704 \C81C\C5B4 \AE30\B2A5</li>'),
unistr('<li>\C720\D615\BCC4 \D1B5\C9C0\C5D0 \B300\D55C \C0C9\C0C1 \AD6C\BD84 \C9C0\C6D0</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106151883284310413)
,p_name=>'CA.NOTIFICATION.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106155334240310416)
,p_name=>'CA.NUM.ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105378142998309756)
,p_name=>'CA.NUMBER.OF.ARGUMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C218 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105374739911309754)
,p_name=>'CA.NUMBER.OF.DESTINATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106187054400310440)
,p_name=>'CA.NUMBERFORMATMASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C22B\C790 \D615\C2DD \B9C8\C2A4\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106156852160310418)
,p_name=>'CA.OCCURRENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106195754056310446)
,p_name=>'CA.ONE.ADMIN.REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \AD00\B9AC\C790\AC00 \C5C6\C744 \ACBD\C6B0 \C774 \C791\C5C5\C744 \C218\D589\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106163654761310423)
,p_name=>'CA.OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106136647898310399)
,p_name=>'CA.ORGANIZING.PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106136947452310399)
,p_name=>'CA.ORGANIZING.PAGES.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \D398\C774\C9C0\B97C \D45C\C2DC\D560 \C21C\C11C\B300\B85C \D398\C774\C9C0\B97C \C815\B82C\D569\B2C8\B2E4. <br>'),
unistr('\BAA9\B85D\C5D0\C11C \D398\C774\C9C0\B97C \C7AC\C815\B82C\D558\B824\BA74 \AC01 \D398\C774\C9C0 \BAA9\B85D \B05D\C5D0 \C788\B294 <em>\B04C\C5B4\C11C \D398\C774\C9C0 \C7AC\C815\B82C</em> \C544\C774\CF58(<span class="fa fa-bars" aria-hidden="true"></span>)\C744 \B204\B978 \C0C1\D0DC\C5D0\C11C \D574\B2F9 \D398\C774\C9C0\B97C \C704\CABD\C774\B098 \C544\B798\CABD\C73C\B85C \B04C\C5B4 \B193\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\D648 \D398\C774\C9C0\B294 \D56D\C0C1 \BA3C\C800 \D45C\C2DC\B418\BA70 \C7AC\C815\B82C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.<br>'),
unistr('\AD00\B9AC \D398\C774\C9C0\B294 \D56D\C0C1 \BAA9\B85D \C544\B798\CABD\C5D0 \D45C\C2DC\B418\BA70, \C774 \C21C\C11C\C5D0 \B530\B77C [\AD00\B9AC] \D398\C774\C9C0\C758 [\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC] \BAA9\B85D\C5D0 \D45C\C2DC\B418\B294 \C21C\C11C\AC00 \ACB0\C815\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105380235908309758)
,p_name=>'CA.OUTPUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD9C\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105381404525309759)
,p_name=>'CA.OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106155025337310416)
,p_name=>'CA.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106158211779310419)
,p_name=>'CA.PAGE.EVENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106170778845310428)
,p_name=>'CA.PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B3C4\C6C0\B9D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106157359819310418)
,p_name=>'CA.PAGE.ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105512924525309872)
,p_name=>'CA.PAGE.MD.EDIT_MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \B808\CF54\B4DC \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105513183242309872)
,p_name=>'CA.PAGE.MD.PERFORM_SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \C218\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106154681872310416)
,p_name=>'CA.PAGE.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106170077471310427)
,p_name=>'CA.PAGE.NAVIGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D0D0\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106156785554310417)
,p_name=>'CA.PAGE.PERFORMANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C131\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106181604133310436)
,p_name=>'CA.PAGE.TYPE.NOT.VALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C720\D615 "%0"\C740(\B294) \C801\D569\D55C \C720\D615\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106156080563310417)
,p_name=>'CA.PAGE.VIEWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106137146625310399)
,p_name=>'CA.PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106137212381310399)
,p_name=>'CA.PAGES.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CD08\AE30 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \D3EC\D568\D560 \D398\C774\C9C0\B97C \C815\C758\D569\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\AE30 \C804\C5D0 \D398\C774\C9C0\B97C \D558\B098 \C774\C0C1 \C815\C758\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \B9C8\BC95\C0AC\B97C \D1B5\D574 \C6D0\D558\B294 \C218\C758 \D398\C774\C9C0\B97C \C0DD\C131\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C758 \C2DC\C791\D2C0\C744 \B9CC\B4E4 \C218 \C788\C2B5\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D55C \D6C4 \D398\C774\C9C0 \C0DD\C131 \B9C8\BC95\C0AC\B97C \C0AC\C6A9\D558\C5EC \B354 \B9CE\C740 \D398\C774\C9C0\B97C \CD94\AC00\D569\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106186954305310440)
,p_name=>'CA.PAGINATIONMETHOD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B9E4\AE40 \BC29\BC95')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106156323932310417)
,p_name=>'CA.PARTIAL.PAGE.VIEWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\BD84 \D398\C774\C9C0 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106162163725310421)
,p_name=>'CA.PHOTO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C9C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106162743168310422)
,p_name=>'CA.PHOTO.DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C9C4\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106162246159310422)
,p_name=>'CA.PHOTO.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C9C4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106161901923310421)
,p_name=>'CA.PHOTO.UPLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C9C4 \C5C5\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106058868392310327)
,p_name=>'CA.PK_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4  \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106166744070310425)
,p_name=>'CA.PLAIN.TEXT.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \D14D\C2A4\D2B8 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106195324790310446)
,p_name=>'CA.POSITIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE0D\C815\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106149572821310411)
,p_name=>'CA.PREFERENCES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106192955908310444)
,p_name=>'CA.PREVIOUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106187692572310440)
,p_name=>'CA.PRIMARYDISPLAYCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D45C\C2DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106188547263310441)
,p_name=>'CA.PRIMARYKEYCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106188644658310441)
,p_name=>'CA.PRIMARYPARENTTABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C0C1\C704 \D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106156973527310418)
,p_name=>'CA.PROCEDURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C2DC\C800')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106150176091310411)
,p_name=>'CA.PROCESS.EMAIL.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D658\ACBD\C124\C815\C744 \C5C5\B370\C774\D2B8\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105512794079309871)
,p_name=>'CA.PROCESS.FETCH_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C778\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106059011543310327)
,p_name=>'CA.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8 \C138\BD80\C815\BCF4 \AC00\C838\C624\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106151347542310413)
,p_name=>'CA.PROCESS.THEME.PREFERENCE.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BAA8\C591 \C124\C815\C744 \C800\C7A5\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106150091150310411)
,p_name=>'CA.PROCESS.TIME.ZONE.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04\B300 \D658\ACBD\C124\C815\C744 \C5C5\B370\C774\D2B8\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106162591974310422)
,p_name=>'CA.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\D30C\C77C \C0AC\C9C4 \B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105378402793309756)
,p_name=>'CA.PROGRAM.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\ADF8\B7A8 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105378595144309756)
,p_name=>'CA.PROGRAM.OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\ADF8\B7A8 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104891428929309390)
,p_name=>'CA.PWA'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\ADF8\B808\C2DC\BE0C \C6F9 \C571 \C124\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104891322732309390)
,p_name=>'CA.PWA.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C571\C5D0 \C124\CE58 \AD8C\D55C \BD80\C5EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104891505528309390)
,p_name=>'CA.PWA.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D504\B85C\ADF8\B808\C2DC\BE0C \C6F9 \C571\C740 \AE30\B2A5, \C548\C815\C131\C744 \AC16\CD94\ACE0 \C124\CE58\AC00 \AC00\B2A5\D558\B3C4\B85D \C124\ACC4\B41C \C6F9 \C560\D50C\B9AC\CF00\C774\C158\C785\B2C8\B2E4. \D504\B85C\ADF8\B808\C2DC\BE0C \C6F9 \C571\C740 \D50C\B7AB\D3FC\BCC4 \C560\D50C\B9AC\CF00\C774\C158\CC98\B7FC \B290\AEF4\C9D1\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C635\C158\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D558\BA74 \B2E4\C74C\C774 \AC00\B2A5\D574\C9D1\B2C8\B2E4.</p>'),
'<ul>',
unistr('<li>\C0C8 \D0D0\C0C9\D45C\C2DC\C904 \D56D\BAA9 \CD94\AC00: \C571 \C124\CE58</li>'),
unistr('<li>\C0AC\C6A9\C790\AC00 \C7A5\CE58\C5D0 \C774 APEX \C571\C744 \C124\CE58\D558\B3C4\B85D \D5C8\C6A9</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104887402874309386)
,p_name=>'CA.PWA.INSTALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C571 \C124\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106187979268310441)
,p_name=>'CA.QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105375263227309754)
,p_name=>'CA.RAISE.EVENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105016993073309482)
,p_name=>'CA.RATING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4F1\AE09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106160489734310420)
,p_name=>'CA.READERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\D68C\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106149808573310411)
,p_name=>'CA.RECEIVE.EMAILS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C218\C2E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106191563915310443)
,p_name=>'CA.RECENT.ERRORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105827645720310129)
,p_name=>'CA.RECENT.ERRORS.LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105827728208310129)
,p_name=>'CA.RECENT.ERRORS.VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106152073606310413)
,p_name=>'CA.RED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE68\AC04\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106165662635310424)
,p_name=>'CA.REFERENCED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105511805768309871)
,p_name=>'CA.REFRESH.ADMIN_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105129130862309569)
,p_name=>'CA.REFRESH.ON.DIALOG.CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790\B97C \B2EB\C744 \B54C \C0C8\B85C\ACE0\CE68')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105513066571309872)
,p_name=>'CA.REFRESH_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C0C8\B85C\ACE0\CE68')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106151530015310413)
,p_name=>'CA.REGION.BUTTONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106151415920310413)
,p_name=>'CA.REGION.FORM.ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \D56D\BAA9 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106157441348310418)
,p_name=>'CA.REGION.ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106169402008310427)
,p_name=>'CA.RELEASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9B4\B9AC\C2A4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106136794096310399)
,p_name=>'CA.REMOVING.PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106136867591310399)
,p_name=>'CA.REMOVING.PAGES.DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('<p><strong>\D3B8\C9D1</strong>\C744 \B20C\B7EC \D398\C774\C9C0\B97C \C120\D0DD\D55C \B2E4\C74C <strong>\D398\C774\C9C0 \C0AD\C81C</strong>\B97C \B20C\B7EC \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \D398\C774\C9C0\B97C \C81C\AC70\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105379868457309757)
,p_name=>'CA.REPEAT.INTERVAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\BCF5 \AC04\ACA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105251700286309660)
,p_name=>'CA.REPLY.TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68C\C2E0 \B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106142540512310404)
,p_name=>'CA.REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106142426066310404)
,p_name=>'CA.REPORT.DETAILS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B300\D654\C2DD \BCF4\ACE0\C11C \B610\B294 \D074\B798\C2DD \BCF4\ACE0\C11C\B85C \D45C\C2DC\B418\B294 \D398\C774\C9C0\B97C \C0DD\C131\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\D398\C774\C9C0 \C774\B984</strong>(\D544\C218) - \C774 \D398\C774\C9C0\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C544\C774\CF58 \C124\C815</strong> - \C774 \D398\C774\C9C0\C758 \D0D0\C0C9 \BA54\B274\C5D0 \D45C\C2DC\D560 \C544\C774\CF58\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C9C8\C758 \C720\D615</strong> - \BCF4\ACE0\C11C \C18C\C2A4[<strong>\D14C\C774\BE14 \B610\B294 \BDF0</strong>, <strong>SQL \C9C8\C758</strong>]\B97C \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('    <strong>\D14C\C774\BE14 \B610\B294 \BDF0</strong>:'),
'    <ul>',
unistr('      <li>\D14C\C774\BE14 \B610\B294 \BDF0(\D544\C218) - \BCF4\ACE0\C11C\C5D0 \B300\D55C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('      <li>\D3FC \D3EC\D568 - \C0AC\C6A9\C790\AC00 \D14C\C774\BE14 \AC12 \C720\C9C0\BCF4\C218\C5D0 \C0AC\C6A9\D560 \B9C1\D06C\B41C \D3FC \D398\C774\C9C0\B97C \D3EC\D568\D558\B824\BA74 \C120\D0DD\D569\B2C8\B2E4.</li>'),
'    </ul>',
unistr('    <strong>SQL \C9C8\C758</strong>:'),
'    <ul>',
unistr('      <li>SQL \C9C8\C758(\D544\C218) - \ACE0\C720 \C5F4\C744 \BC18\D658\D558\B294 \C801\D569\D55C SQL \BB38\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>\BCF4\ACE0\C11C \C720\D615</strong> - \BCF4\ACE0\C11C \C720\D615(<strong>\B300\D654\C2DD \BCF4\ACE0\C11C</strong> \B610\B294 <strong>\D074\B798\C2DD \BCF4\ACE0\C11C</strong>)\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106134267950310396)
,p_name=>'CA.REPORT.N.WITH.FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC\C774 \C788\B294 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106016837204310286)
,p_name=>'CA.REPORT.TABLE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106190632395310442)
,p_name=>'CA.REPORT.VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106189294778310441)
,p_name=>'CA.REPORTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105381223125309758)
,p_name=>'CA.REQ.START.DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\B41C \C2DC\C791 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106189415989310442)
,p_name=>'CA.REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106167596730310425)
,p_name=>'CA.RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106163533621310422)
,p_name=>'CA.RESOLVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\ACB0\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106163221842310422)
,p_name=>'CA.RESPONSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C751\B2F5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105376580219309755)
,p_name=>'CA.RESTART.ON.FAILURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D328 \C2DC \C7AC\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105376698903309755)
,p_name=>'CA.RESTART.ON.RECOVERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\AD6C \C2DC \C7AC\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105373837854309753)
,p_name=>'CA.RESTARTABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C2DC\C791 \AC00\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105376100202309755)
,p_name=>'CA.RETRY.COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C2DC\B3C4 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106184446915310438)
,p_name=>'CA.ROLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106157628240310418)
,p_name=>'CA.ROW.NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106166956564310425)
,p_name=>'CA.ROW.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106183819210310437)
,p_name=>'CA.ROW.TEMPLATE.HTML'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \D15C\D50C\B9AC\D2B8 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106185179424310438)
,p_name=>'CA.ROWS.CONTENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \CF58\D150\CE20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106158344717310419)
,p_name=>'CA.ROWS.FETCHED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\CD9C\B41C \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106186883531310440)
,p_name=>'CA.ROWSPERPAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B2F9 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105379404011309757)
,p_name=>'CA.RUN.COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \D69F\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105381040853309758)
,p_name=>'CA.RUN.DURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \AE30\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105375900319309754)
,p_name=>'CA.SCHEDULE.LIMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C815 \C81C\D55C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105377954493309756)
,p_name=>'CA.SCHEDULE.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C815 \C774\B984')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105378091257309756)
,p_name=>'CA.SCHEDULE.OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C815 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105377885050309756)
,p_name=>'CA.SCHEDULE.TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C815 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106145019252310407)
,p_name=>'CA.SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106145173216310407)
,p_name=>'CA.SCHEMA.DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C6A9\D560 \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C800\C7A5\D558\B294 \B370\C774\D130\BCA0\C774\C2A4 \C2A4\D0A4\B9C8\B97C \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106185964093310439)
,p_name=>'CA.SCOPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106167655663310426)
,p_name=>'CA.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106167794849310426)
,p_name=>'CA.SEARCH.APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106167824029310426)
,p_name=>'CA.SEARCH.DIALOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \B300\D654\C0C1\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106190802007310443)
,p_name=>'CA.SEARCH.FILTERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106174567479310431)
,p_name=>'CA.SEARCH.HIDDEN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D398\C774\C9C0\B294 \AC80\C0C9\B41C \D14C\C774\BE14\C774\B77C\B294 \ACF5\C720 \AD6C\C131\C694\C18C \BAA9\B85D\C5D0\C11C \D30C\C0DD\B429\B2C8\B2E4.'),
'',
unistr('\CC98\C74C\C5D0 \C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131 \B9C8\BC95\C0AC\C5D0\C11C \C0DD\C131\B41C \BAA8\B4E0 \B300\D654\C2DD \BCF4\ACE0\C11C \D398\C774\C9C0\AC00 \C790\B3D9\C73C\B85C \BAA9\B85D\C5D0 \CD94\AC00\B429\B2C8\B2E4. '),
unistr('\BAA9\B85D\C5D0 \ACE0\C720 \D14C\C774\BE14\C744 \CD94\AC00\D55C \B2E4\C74C [\ACF5\C720 \AD6C\C131\C694\C18C]\B85C \C774\B3D9\D558\B824\BA74 [\BAA9\B85D]\C744 \C120\D0DD\D558\ACE0 [\AC80\C0C9\B41C \D14C\C774\BE14]\C744 \B204\B985\B2C8\B2E4.'),
unistr('  \B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('    \D56D\BAA9: \BAA9\B85D \D56D\BAA9 \B808\C774\BE14 - \D14C\C774\BE14\C5D0 \B300\D55C \D45C\C2DC \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('    \B300\C0C1: \D398\C774\C9C0 - \B300\D654\C2DD \BCF4\ACE0\C11C \B4F1\C73C\B85C \C774\B3D9\D558\B824\BA74 \C801\C808\D55C \D398\C774\C9C0\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('    \B300\C0C1: \CE90\C2DC \C9C0\C6B0\AE30 - \C9C0\C6CC\C57C \D560 \D398\C774\C9C0(\C77C\BC18\C801\C73C\B85C \D398\C774\C9C0 \C544\B798\C5D0 \C785\B825\B41C \BC88\D638\C640 \B3D9\C77C\D55C \BC88\D638)\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('       \B300\D654\C2DD \BCF4\ACE0\C11C \D398\C774\C9C0\B85C \C774\B3D9\D558\B824\BA74 CIR,RIR\C744 \CD94\AC00\D558\C5EC \AE30\C874 \D544\D130 \B4F1\C744 \C9C0\C6C1\B2C8\B2E4.'),
unistr('    \B300\C0C1: \D56D\BAA9 \C774\B984 - \CC44\C6B0\B824\B294 \C801\C808\D55C \D398\C774\C9C0 \D56D\BAA9\C744 \C120\D0DD(\B610\B294 \C785\B825)\D569\B2C8\B2E4.'),
unistr('       \B300\D654\C2DD \BCF4\ACE0\C11C \D398\C774\C9C0\B85C \C774\B3D9\D558\B824\BA74 IR_[COLUMN_NAME]\C744(\B97C) \C785\B825\D569\B2C8\B2E4.'),
unistr('    \B300\C0C1: \D56D\BAA9 \AC12 - =PK=\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('    \C0AC\C6A9\C790\C815\C758 \C18D\C131: 1 - \AC80\C0C9\D560 \D14C\C774\BE14 \C774\B984\C744 \B300\BB38\C790\B85C \C785\B825\D569\B2C8\B2E4.'),
unistr('    \C0AC\C6A9\C790\C815\C758 \C18D\C131: 2 - \AE30\BCF8 \C5F4 \C774\B984\C744 \B300\BB38\C790\B85C \C785\B825\D569\B2C8\B2E4.'),
unistr('    \C0AC\C6A9\C790\C815\C758 \C18D\C131: 3(\C120\D0DD\C0AC\D56D) - \AC80\C0C9\D560 \CF64\B9C8\B85C \AD6C\BD84\B41C \C5F4 \BAA9\B85D\C785\B2C8\B2E4.'),
unistr('       \C9C0\C815\B41C \C5F4\C774 \C5C6\C744 \ACBD\C6B0 \BAA8\B4E0 \D14D\C2A4\D2B8(varchar2) \BC0F clob(character large object) \C5F4\C774 \AC80\C0C9\B429\B2C8\B2E4.'),
'',
unistr('\CC38\ACE0: \D14C\C774\BE14\C774 \B450 \AC1C \C774\C0C1 \B098\C5F4\B418\B294 \ACBD\C6B0\C5D0\B9CC \AC80\C0C9\C5D0 \C0AC\C6A9 \AC00\B2A5\D55C \D14C\C774\BE14 \BAA9\B85D\C774 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106167347151310425)
,p_name=>'CA.SEARCH.RESULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \ACB0\ACFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106188410547310441)
,p_name=>'CA.SECONDARYDISPLAYCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C870 \D45C\C2DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106163998091310423)
,p_name=>'CA.SELECTED.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105251017827309659)
,p_name=>'CA.SEND.BEGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C1A1 \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105251443796309660)
,p_name=>'CA.SEND.COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C1A1 \D69F\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105250909476309659)
,p_name=>'CA.SEND.END'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C1A1 \C885\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105251316214309660)
,p_name=>'CA.SEND.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C1A1 \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106194452043310445)
,p_name=>'CA.SEND.FEEDBACK.EMAILS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C804\C1A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106194526230310445)
,p_name=>'CA.SEND.FEEDBACK.EMAILS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \D53C\B4DC\BC31\C774 \C218\C2E0\B420 \B54C \C804\C790\BA54\C77C\C744 \C804\C1A1\D574\C57C \D560\C9C0 \C5EC\BD80\B97C \ACB0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106191165657310443)
,p_name=>'CA.SEND.FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\B0B8 \C0AC\B78C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106183667349310437)
,p_name=>'CA.SEND.TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1B\B294 \C0AC\B78C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106169210479310427)
,p_name=>'CA.SERIES'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \ACC4\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105380944755309758)
,p_name=>'CA.SESSION.ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106186163393310439)
,p_name=>'CA.SESSIONSTATEPROTECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC \BCF4\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106144423976310406)
,p_name=>'CA.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106144524797310406)
,p_name=>'CA.SETTINGS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131\C5D0 \C0AC\C6A9\B418\B294 \C124\C815\C744 \C9C0\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106168832808310426)
,p_name=>'CA.SHOW.ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105128699877309569)
,p_name=>'CA.SHOW.HIDE.SCOPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C704 \D45C\C2DC/\C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106169998453310427)
,p_name=>'CA.SHOW.TIMEZONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04\B300 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106169772206310427)
,p_name=>'CA.SIGN.IN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C778\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106170993770310428)
,p_name=>'CA.SIGN.OUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C778\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105380893854309758)
,p_name=>'CA.SLAVE.PID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2AC\B808\C774\BE0C PID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105374897981309754)
,p_name=>'CA.SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106181742760310436)
,p_name=>'CA.SOURCE.TYPE.NOT.VALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \C18C\C2A4 \C720\D615\C740 \C801\D569\D55C \C720\D615\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106174658327310431)
,p_name=>'CA.SOURCES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105377745990309756)
,p_name=>'CA.START.DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106058234807310326)
,p_name=>'CA.STARTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105379592244309757)
,p_name=>'CA.STATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106189323390310442)
,p_name=>'CA.STATICDEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106153674433310415)
,p_name=>'CA.STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105375594867309754)
,p_name=>'CA.STOP.ON.WINDOW.CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC3D \B2EB\C744 \B54C \C815\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105375641243309754)
,p_name=>'CA.STORE.OUTPUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD9C\B825 \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106164132519310423)
,p_name=>'CA.SUBJECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106162840556310422)
,p_name=>'CA.SUBMIT.FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106058497800310326)
,p_name=>'CA.SUCCESSFUL_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5\D55C \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106186415426310439)
,p_name=>'CA.SUGGESTEDVISULIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C548\B41C \C2DC\AC01\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106178313920310433)
,p_name=>'CA.SUPPORTING.OBJECTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0 \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106178416810310433)
,p_name=>'CA.SUPPORTING.OBJECTS.DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C124\CE58 \C2A4\D06C\B9BD\D2B8\C5D0 \C785\B825\D558\B294 \CF54\B4DC\B294 \C77C\BC18\C801\C73C\B85C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C0DD\C131 \B610\B294 \C870\C791\D558\AC70\B098 \AE30\C874 \B808\CF54\B4DC\C5D0 \B300\D574 \C0BD\C785/\C5C5\B370\C774\D2B8/\C0AD\C81C\B97C \C218\D589\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4. \C124\CE58 \C81C\AC70 \C2A4\D06C\B9BD\D2B8\C5D0 \C785\B825\D558\B294 \CF54\B4DC\B294 \C77C\BC18\C801\C73C\B85C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C81C\AC70(\C0AD\C81C)\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4. \C774\B7EC\D55C \C2A4\D06C\B9BD\D2B8\B294 \C9C0\C6D0 \AC1D\CCB4\C5D0 \D1B5\D569\B418\BBC0\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C775\C2A4\D3EC\D2B8\D560 \B54C \D14C\C2A4\D2B8 \BC0F \C6B4\C6A9 \D658\ACBD\C5D0\C11C \C774\C640 \AC19\C740 \B3D9\C77C\D55C \C5C5\B370\C774\D2B8\AC00 \C218\D589\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106178570296310434)
,p_name=>'CA.SUPPORTING.OBJECTS.PAGE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C774 \C784\D3EC\D2B8\B420 \B54C \C2E4\D589\B418\B294 \C801\D569\D55C SQL \BC0F/\B610\B294 PL/SQL \BB38\C744 \C124\CE58 \C2A4\D06C\B9BD\D2B8\C5D0 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C774 \B2E4\B978 \D658\ACBD\C5D0 \C784\D3EC\D2B8\B420 \B54C\BFD0\B9CC \C544\B2C8\B77C \D604\C7AC \D658\ACBD\C5D0\C11C\B3C4 \D574\B2F9 \BA85\B839\BB38\C774 \C2E4\D589\B418\B3C4\B85D \D558\B824\BA74 <strong>\C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131 \C2DC \C2E4\D589</strong>\C744 \B204\B985\B2C8\B2E4.</p>'),
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C774 \C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30\C5D0\C11C \C0AD\C81C\B420 \B54C \C2E4\D589\B418\B294 \C801\D569\D55C SQL \BC0F/\B610\B294 PL/SQL \BB38\C744 \C124\CE58 \C81C\AC70 \C2A4\D06C\B9BD\D2B8\C5D0 \C785\B825\D569\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105375109919309754)
,p_name=>'CA.SYSTEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C2A4\D15C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106187896369310440)
,p_name=>'CA.TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106145219537310407)
,p_name=>'CA.TABLE.PREFIX'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B808\C784\C6CC\D06C \AC1D\CCB4 \C811\B450\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106145346761310407)
,p_name=>'CA.TABLE.PREFIX.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C6A9 \AC1D\CCB4 \C811\B450\C5B4\B97C \C785\B825\D569\B2C8\B2E4. \C77C\BD80 \AE30\B2A5\C740 \C0DD\C131\D558\B294 \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4(\D328\D0A4\C9C0 \BC0F \D14C\C774\BE14 \D3EC\D568)\C5D0 \C774 \C811\B450\C5B4\B97C \CD94\AC00\D569\B2C8\B2E4.</p>'),
unistr('<p>\ACBD\ACE0: \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C6A9\B418\C9C0 \C54A\C740 \ACE0\C720 \C811\B450\C5B4\B97C \C785\B825\D574\C57C \D569\B2C8\B2E4. \ACE0\C720\D558\C9C0 \C54A\C744 \ACBD\C6B0 \C560\D50C\B9AC\CF00\C774\C158\C774 \C0DD\C131\B420 \B54C \C624\B958\AC00 \BC1C\C0DD\D558\ACE0 \C81C\B300\B85C \C791\B3D9\D558\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106188721118310441)
,p_name=>'CA.TABLECOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106183734496310437)
,p_name=>'CA.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106167282954310425)
,p_name=>'CA.TEMPLATE.EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D15C\D50C\B9AC\D2B8 \C774\B984\C740 \C0AC\C6A9 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106164013471310423)
,p_name=>'CA.TEMPLATE.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106152769332310414)
,p_name=>'CA.TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105251230217309660)
,p_name=>'CA.TEXT.BODY.SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \BCF8\BB38 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106165216805310424)
,p_name=>'CA.TEXT.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106150961505310412)
,p_name=>'CA.THEME.PREFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790 \D14C\B9C8 \D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106151122197310412)
,p_name=>'CA.THEME.PREFERENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \ACBD\C6B0 \C77C\BC18 \C0AC\C6A9\C790\AC00 [\C0AC\C6A9\C790\C815\C758] \B9C1\D06C\B97C \C0AC\C6A9\D558\C5EC \C790\C2E0\B9CC\C758 \D14C\B9C8 \C2A4\D0C0\C77C\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106151050680310412)
,p_name=>'CA.THEME.PREFERENCE.LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \D14C\B9C8 \C2A4\D0C0\C77C\C744 \C120\D0DD\D558\B3C4\B85D \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106135362262310397)
,p_name=>'CA.THEME.SELECTOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106133787533310396)
,p_name=>'CA.THEME.SELECTOR.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C560\D50C\B9AC\CF00\C774\C158 \BAA8\C591 \C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106135420929310398)
,p_name=>'CA.THEME.SELECTOR.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD00\B9AC\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \AE30\BCF8 \C0C9\C0C1\D45C(\D14C\B9C8 \C2A4\D0C0\C77C)\B97C \C120\D0DD\D560 \C218 \C788\B3C4\B85D \D569\B2C8\B2E4. \AD00\B9AC\C790\B294 \C77C\BC18 \C0AC\C6A9\C790\C758 \ACE0\C720 \D14C\B9C8 \C2A4\D0C0\C77C \C120\D0DD\C744 \D5C8\C6A9\D558\B3C4\B85D \C120\D0DD\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\B294 \D648 \D398\C774\C9C0 \D558\B2E8\C5D0 \C788\B294 <em>\C0AC\C6A9\C790\C815\C758</em> \B2E8\CD94\B97C \B204\B974\ACE0 \C0AC\C6A9 \AC00\B2A5\D55C \D14C\B9C8 \C2A4\D0C0\C77C \C911\C5D0\C11C \C120\D0DD\D558\AE30\B9CC \D558\BA74 \B429\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \C2DC\AC01 \C7A5\C560\AC00 \C788\B294 \C0AC\C6A9\C790\B294 \B354 \B192\C740 \C0C9\C0C1 \B300\BE44\AC00 \C81C\ACF5\B418\B294 <em>Vista</em> \D14C\B9C8 \C2A4\D0C0\C77C\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B429\B2C8\B2E4.'),
'<ul>',
unistr('<li>\AD00\B9AC\C790\AC00 \AE30\BCF8 \D14C\B9C8 \C2A4\D0C0\C77C\C744 \C815\C758\D560 \C218 \C788\B3C4\B85D \D5C8\C6A9</li>'),
unistr('<li>\C77C\BC18 \C0AC\C6A9\C790\AC00 \B2E4\C591\D55C \D14C\B9C8 \C2A4\D0C0\C77C\C744 \C120\D0DD\D560 \C218 \C788\B3C4\B85D \D568</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106143892320310405)
,p_name=>'CA.THEME.STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106143962623310406)
,p_name=>'CA.THEME.STYLE.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \AE30\BCF8 \D14C\B9C8 \C2A4\D0C0\C77C\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\C2A4\D0C0\C77C\C740 \BBF8\B9AC \C815\C758\B41C \B2E4\B978 \C2A4\D0C0\C77C\B85C \C190\C27D\AC8C \BCC0\ACBD\D558\AC70\B098 \C0DD\C131 \D6C4 \C218\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \C2A4\D0C0\C77C\C744 \BCC0\ACBD\D558\B824\BA74 \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D55C \B2E4\C74C \AC1C\BC1C\C790 \B3C4\AD6C \BAA8\C74C\C5D0\C11C <strong>\D14C\B9C8 \B864\B7EC</strong>\B97C \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106157958636310418)
,p_name=>'CA.TIME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106149615767310411)
,p_name=>'CA.TIME.ZONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106136494632310398)
,p_name=>'CA.TIME.ZONE.SUPPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04\B300 \C9C0\C6D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106133364562310396)
,p_name=>'CA.TIME.ZONE.SUPPORT.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12 \BC0F \C0AC\C6A9\C790 \C2DC\AC04\B300 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106136124384310398)
,p_name=>'CA.TIME.ZONE.SUPPORT.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \B85C\CEEC \C2DC\AC04\B300\B97C \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158 \D14C\C774\BE14\C5D0 \C2DC\AC04\B300\B97C \C778\C2DD\D558\B294 \B370\C774\D130 \C720\D615(\C608: \B85C\CEEC \C2DC\AC04\B300\B97C \C0AC\C6A9\D558\B294 \C2DC\AC04\AE30\B85D)\C744 \D65C\C6A9\D558\B294 \ACBD\C6B0 \BCF4\ACE0\C11C \BC0F \B370\C774\D130 \D56D\BAA9\C774 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C788\B294 \C704\CE58\B97C \BC18\C601\D558\BBC0\B85C \C911\C694\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B429\B2C8\B2E4.'),
'<ul>',
unistr('<li>\AD00\B9AC\C790\AC00 \AE30\BCF8 \C2DC\AC04\B300\B97C \C124\C815\D560 \C218 \C788\B3C4\B85D \D5C8\C6A9</li>'),
unistr('<li>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C2DC\AC04\B300 \D658\ACBD\C124\C815\C744 \C120\D0DD\D560 \C218 \C788\B3C4\B85D \D5C8\C6A9</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106191731568310443)
,p_name=>'CA.TIMEFRAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106192051201310444)
,p_name=>'CA.TIMELINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0C0\C784\B77C\C778 \D398\C774\C9C0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106192111167310444)
,p_name=>'CA.TIMELINE.DETAILS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C2DC\AC04 \D45C\C2DC\B97C \D45C\C2DC\D558\B294 \D398\C774\C9C0\B97C \C0DD\C131\D569\B2C8\B2E4. \C774 \D398\C774\C9C0\B294 \C5C5\B370\C774\D2B8 \D45C\C2DC\C5D0 \D2B9\D788 \C720\C6A9\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\D398\C774\C9C0 \C774\B984</strong>(\D544\C218) - \C774 \D398\C774\C9C0\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C544\C774\CF58 \C124\C815</strong> - \C774 \D398\C774\C9C0\C758 \D0D0\C0C9 \BA54\B274\C5D0 \D45C\C2DC\D560 \C544\C774\CF58\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\D14C\C774\BE14 \B610\B294 \BDF0</strong>(\D544\C218) - \C2DC\AC04 \D45C\C2DC\C5D0 \B300\D55C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C0AC\C6A9\C790 \C774\B984</strong>(\D544\C218) - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \C2DC\AC04 \D45C\C2DC \D56D\BAA9\C5D0 \B300\D574 \D45C\C2DC\B418\B294 \C0AC\C6A9\C790\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\B0A0\C9DC</strong>(\D544\C218) - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \C2DC\AC04 \D45C\C2DC \D56D\BAA9\C5D0 \B300\D55C \B0A0\C9DC\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C774\BCA4\D2B8 \C774\B984</strong>(\D544\C218) - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \C2DC\AC04 \D45C\C2DC \D56D\BAA9\C5D0 \B300\D55C \C81C\BAA9\C73C\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C124\BA85</strong> - \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \C2DC\AC04 \D45C\C2DC \D56D\BAA9\C5D0 \B300\D55C \C124\BA85\C73C\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106154899121310416)
,p_name=>'CA.TIMESTAMP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04\AE30\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106159406025310420)
,p_name=>'CA.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105251889029309660)
,p_name=>'CA.TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1B\B294 \C0AC\B78C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106158661502310419)
,p_name=>'CA.TOP.USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704 \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106158788942310419)
,p_name=>'CA.TOP.USERS.CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704 \C0AC\C6A9\C790 \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106156268206310417)
,p_name=>'CA.TOTAL.ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \D589 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106160651223310420)
,p_name=>'CA.TREAT.AUTH.USERS.NO.IN.ACL.AS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0 \C5C6\B294 \C0AC\C6A9\C790\C758 \AE30\BCF8 \B864:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106152818087310414)
,p_name=>'CA.TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105463372576309830)
,p_name=>'CA.UI.DEFAULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105463434651309830)
,p_name=>'CA.UI.DEFAULTS.DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \C124\C815(\C608: \D398\C774\C9C0\B2F9 \D589)\C5D0 \B300\D55C \AE30\BCF8\AC12\C744 \C124\C815\D558\ACE0 \AC12 \BAA9\B85D \C815\C758\B97C \CD94\AC00\D569\B2C8\B2E4. \D574\B2F9 \C124\C815\C740 \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0\C11C \AD6C\C131\C694\C18C\B97C \C0DD\C131\D560 \B54C \C0AC\C6A9\B429\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106153077113310414)
,p_name=>'CA.UNTIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105511670335309871)
,p_name=>'CA.UPDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106162431990310422)
,p_name=>'CA.UPDATE.PROFILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\D30C\C77C \C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106153387596310414)
,p_name=>'CA.UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106153472554310415)
,p_name=>'CA.UPDATED.BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \C218\D589\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106154772062310416)
,p_name=>'CA.USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106181233731310436)
,p_name=>'CA.USER.ADD_MULTIPLE_1'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \C0AC\C6A9\C790 \CD94\AC00 - \B2E8\ACC4 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106181357699310436)
,p_name=>'CA.USER.ADD_MULTIPLE_2'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \C0AC\C6A9\C790 \CD94\AC00 - \B2E8\ACC4 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106181466280310436)
,p_name=>'CA.USER.ADD_MULTIPLE_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \C0AC\C6A9\C790 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106157178428310418)
,p_name=>'CA.USER.AGENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C5D0\C774\C804\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106170556797310428)
,p_name=>'CA.USER.COUNTS.REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C218 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106158979457310419)
,p_name=>'CA.USER.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106161400561310421)
,p_name=>'CA.USER.PROFILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D504\B85C\D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106136360823310398)
,p_name=>'CA.USER.PROFILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D504\B85C\D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106133226388310396)
,p_name=>'CA.USER.PROFILES.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \D504\B85C\D30C\C77C\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C788\B3C4\B85D \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106136211020310398)
,p_name=>'CA.USER.PROFILES.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C790\C2E0\C758 \ACC4\C815\C744 \AC1C\BCC4\D654\D558\AE30 \C704\D574 \ADF8\B9BC \B610\B294 \C544\BC14\D0C0\B97C \BE44\B86F\D55C \C790\C2E0\C5D0 \B300\D55C \CD94\AC00 \C815\BCF4\B97C \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B429\B2C8\B2E4.'),
'<ul>',
unistr('<li>\C77C\BC18 \C0AC\C6A9\C790\AC00 \D504\B85C\D30C\C77C\C744 \C124\C815\D558\AE30 \C704\D574 \D398\C774\C9C0 \C124\C815</li>'),
unistr('<li>\C0AC\C9C4/\C544\BC14\D0C0\B97C \C5C5\B85C\B4DC\D558\B294 \AE30\B2A5</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106161621214310421)
,p_name=>'CA.USERNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106160707798310420)
,p_name=>'CA.USERNAME.FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106182141602310436)
,p_name=>'CA.USERNAMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105470801940309836)
,p_name=>'CA.USERNAME_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106182728584310437)
,p_name=>'CA.USERS.ADDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106184251302310438)
,p_name=>'CA.USERS.BY.ROLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864\BCC4 \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106164808596310423)
,p_name=>'CA.USERS.INCLUDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\D568\B41C \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106182465862310436)
,p_name=>'CA.USERS.TO.ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00\D560 \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106160933676310421)
,p_name=>'CA.USRENAME.FORMAT.UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984 \D615\C2DD\C744 \C5C5\B370\C774\D2B8\D588\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105147892466309583)
,p_name=>'CA.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \C0AC\C6A9\C790\AC00 \C874\C7AC\D568 - \D398\C774\C9C0 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106176575557310432)
,p_name=>'CA.VALIDATION.APP.ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID\AC00 \C874\C7AC\D558\AC70\B098 \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C608\C57D\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105418199473309792)
,p_name=>'CA.VALIDATION.APP.NAME.NOT.NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C774\B984\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106184831076310438)
,p_name=>'CA.VALIDATION.EMAIL.REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C\C744 \BC1B\C744 \C804\C790\BA54\C77C \C8FC\C18C\B97C \C81C\ACF5\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106184662728310438)
,p_name=>'CA.VALIDATION.EMAIL.ROLE.REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C8FC\C18C\B97C \C81C\ACF5\D558\AC70\B098 \C804\C790\BA54\C77C\C744 \BC1B\C744 \C77C\B828\C758 \C0AC\C6A9\C790\B97C \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106184749138310438)
,p_name=>'CA.VALIDATION.ROLE.REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C\C744 \BC1B\C744 \C77C\B828\C758 \C0AC\C6A9\C790\B97C \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106176626322310432)
,p_name=>'CA.VALIDATION.TABLE.PREFIX'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C811\B450\C5B4\B294 6\C790\B97C \CD08\ACFC\D558\C9C0 \C54A\C544\C57C \D558\BA70 \BB38\C790\B85C \C2DC\C791\D558\ACE0 \BB38\C790, \C22B\C790 \BC0F \BC11\C904\B9CC \D3EC\D568\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106176776551310432)
,p_name=>'CA.VALIDATION.TABLE.PREFIX.USED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \D14C\C774\BE14 \C811\B450\C5B4\B97C \C785\B825\D558\C2ED\C2DC\C624. \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4 %0\C774(\AC00) \C874\C7AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106161355129310421)
,p_name=>'CA.VERIFY.EMAIL.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984\C774 \BD80\C801\D569\D55C \C804\C790\BA54\C77C \C8FC\C18C \D615\C2DD\C73C\B85C \B418\C5B4 \C788\C2B5\B2C8\B2E4. \C544\B798 \C560\D50C\B9AC\CF00\C774\C158 \C0AC\C6A9\C790 \C774\B984 \D615\C2DD\C744 \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106161253042310421)
,p_name=>'CA.VERIFY.EMAIL.FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D615\C2DD \D655\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106158893076310419)
,p_name=>'CA.VIEW.AS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106179104867310434)
,p_name=>'CA.VIEW.BLUEPRINT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAD\C0AC\C9C4 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106168746239310426)
,p_name=>'CA.VIEW.DETAILS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106185055898310438)
,p_name=>'CA.VIEW.EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106170877972310428)
,p_name=>'CA.VIEW.MY.PROFILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4 \D504\B85C\D30C\C77C \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106155745835310417)
,p_name=>'CA.WEIGHTED.PERFORMANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C911\CE58 \C131\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106189653983310442)
,p_name=>'CA.WIDTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106193856472310445)
,p_name=>'CA.WIZARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\BC95\C0AC \D398\C774\C9C0 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105147769114309583)
,p_name=>'CA.WIZARD.CONTAINER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\BC95\C0AC \CEE8\D14C\C774\B108')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106193963614310445)
,p_name=>'CA.WIZARD.DETAILS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B9C8\BC95\C0AC\B85C \C0AC\C6A9\D560 \D398\C774\C9C0 \BAA8\C74C\C744 \C0DD\C131\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \B9C8\BC95\C0AC\B294 \C5EC\B7EC \B2E8\ACC4\C5D0\C11C \B370\C774\D130\B97C \C785\B825\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\B9C8\BC95\C0AC \C774\B984</strong>(\D544\C218) - \C774 \D398\C774\C9C0\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C544\C774\CF58 \C124\C815</strong> - \C774 \D398\C774\C9C0\C758 \D0D0\C0C9 \BA54\B274\C5D0 \D45C\C2DC\D560 \C544\C774\CF58\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\D398\C774\C9C0 \BAA8\B4DC</strong>(\D544\C218) - \B9C8\BC95\C0AC \B2E8\ACC4\B97C \BAA8\B2EC \D398\C774\C9C0\B85C \D45C\C2DC\D560\C9C0 \C544\B2C8\BA74 \C77C\BC18 \D398\C774\C9C0\B85C \D45C\C2DC\D560\C9C0 \C120\D0DD\D569\B2C8\B2E4. <strong>\BAA8\B2EC \D398\C774\C9C0</strong> \B610\B294 <strong>\C804\CCB4 \D398\C774\C9C0</strong>\B97C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\B2E8\ACC4 1 ... 8</strong> - \B9C8\BC95\C0AC \B2E8\ACC4\C758 \D398\C774\C9C0 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.<br><em><strong>\CC38\ACE0:</strong> \B2E8\ACC4 5 - 8\C740 \AC01 \C774\C804 \B2E8\ACC4\C5D0 \B300\D55C \C774\B984\C774 \C785\B825\B420 \B54C \D45C\C2DC\B429\B2C8\B2E4.</em></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106159219966310419)
,p_name=>'CA.WORK.PHONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C1\C7A5 \C804\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106151934744310413)
,p_name=>'CA.YELLOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\B178\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105463802011309831)
,p_name=>'CA.YES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105016804706309482)
,p_name=>'CACHED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE90\C2DC\C5D0 \C800\C7A5\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104920099573309411)
,p_name=>'CACHE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE90\C2DC \C0DD\C131\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104907665886309402)
,p_name=>'CALENDAR.CHECK.AJAX_DELETE_NOT_ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C0AD\C81C \AE30\B2A5\C744 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104892699498309391)
,p_name=>'CALENDAR.CHECK.AJAX_INSERT_NOT_ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \CD94\AC00 \AE30\B2A5\C744 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104892777660309391)
,p_name=>'CALENDAR.CHECK.AJAX_UPDATE_NOT_ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C5C5\B370\C774\D2B8 \AE30\B2A5\C744 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105045583662309503)
,p_name=>'CALENDAR.NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105045406385309503)
,p_name=>'CALENDAR.PREVIOUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104931826189309420)
,p_name=>'CALENDAR_EASY_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\B2E8\D55C \B2EC\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105949775619310225)
,p_name=>'CALENDAR_ENTRY_EDIT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825 \D56D\BAA9 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104881138709309381)
,p_name=>'CALENDAR_POPUP'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \B2EC\B825 \D31D\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105012510368309479)
,p_name=>'CALENDAR_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825\C774 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105402140669309774)
,p_name=>'CALENDAR_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\AC70\C2DC \B2EC\B825 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104931700595309420)
,p_name=>'CALENDAR_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105265152879309670)
,p_name=>'CAL_TEMPLATE_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\ACFC \D15C\D50C\B9AC\D2B8 ID %1\C5D0\C11C \BCF5\C0AC\D558\B824\ACE0 \C2DC\B3C4\D560 \B54C \B2EC\B825 \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105403546538309775)
,p_name=>'CANCEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104887685144309386)
,p_name=>'CARD_ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105635566316309972)
,p_name=>'CASCADING STYLE SHEETS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\C18D\D615 \C2DC\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105482948670309846)
,p_name=>'CHANGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD\C0AC\D56D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106060019176310328)
,p_name=>'CHANGE_AUTHENTICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \BCC0\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105398858130309771)
,p_name=>'CHANGE_DATABASE_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \D06C\AE30 \BCC0\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105398619232309771)
,p_name=>'CHANGE_REQUEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105612351177309952)
,p_name=>'CHANGE_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \BCC0\ACBD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105372110112309752)
,p_name=>'CHARACTER_SET_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C790\C138\D2B8 \C5F4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105093738733309537)
,p_name=>'CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104876416767309377)
,p_name=>'CHART.CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\BD80\C801\D569\D55C \CC28\D2B8 \C9C8\C758: %0<br><br>'),
unistr('\B2E4\C74C \AD6C\BB38\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624.'),
'<pre>',
'SELECT LINK, LABEL, VALUE',
'FROM   ...',
'</pre>',
'<table class="instructiontext">',
'<tr><td>LINK</td><td>URL</td></tr>',
unistr('<tr><td>LABEL</td><td>\B9C9\B300\C5D0 \D45C\C2DC\D560 \D14D\C2A4\D2B8</td></tr>'),
unistr('<tr><td>VALUE</td><td>\B9C9\B300 \D06C\AE30\B97C \C815\C758\D558\B294 \C22B\C790 \C5F4</td></tr>'),
'</table>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105041332781309500)
,p_name=>'CHART.DIAL_CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\BD80\C801\D569\D55C \CC28\D2B8 \C9C8\C758\C785\B2C8\B2E4.<br /><br /> \B2E4\C74C \AD6C\BB38\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624. <pre> SELECT VALUE, MAX, (LOW), (HIGH) VALUE FROM ... </pre>'),
'<table class="instructiontext">',
'<tr>',
'<td>VALUE</td>',
unistr('<td>\B2E4\C774\C5BC \AC12\C744 \C815\C758\D558\B294 \C22B\C790 \C5F4\C785\B2C8\B2E4.</td>'),
'</tr>',
'<tr>',
'<td>MAX</td>',
unistr('<td>\CD5C\B300 \B2E4\C774\C5BC \AC12\C744 \C815\C758\D558\B294 \C22B\C790 \C5F4\C785\B2C8\B2E4.</td>'),
'</tr>',
'<tr>',
unistr('<td>LOW(\C120\D0DD\C0AC\D56D)</td>'),
unistr('<td>\C774\C804 \CD5C\C18C \B2E4\C774\C5BC \AC12\C744 \C815\C758\D558\B294 \C22B\C790 \C5F4\C785\B2C8\B2E4.</td>'),
'</tr>',
'<tr>',
unistr('<td>HIGH(\C120\D0DD\C0AC\D56D)</td>'),
unistr('<td>\C774\C804 \CD5C\B300 \B2E4\C774\C5BC \AC12\C744 \C815\C758\D558\B294 \C22B\C790 \C5F4\C785\B2C8\B2E4.</td>'),
'</tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105108192379309548)
,p_name=>'CHART.INVALID_CHART_TYPE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \CC28\D2B8 \C720\D615\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104876350094309377)
,p_name=>'CHART.INVALID_QUERY'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL \C9C8\C758 \AD6C\BB38 \BD84\C11D \C2E4\D328!'),
'<p>%0</p>',
unistr('\D2B9\C815 \C9C8\C758\B294 \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D560 \B54C\B9CC \C2E4\D589\B420 \C218 \C788\C2B5\B2C8\B2E4. \C9C8\C758 \AD6C\BB38\C774 \C815\D655\D55C \ACBD\C6B0 \AC80\C99D \C5C6\C774 \C9C8\C758\B97C \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4(\C9C8\C758 \C18C\C2A4 \C544\B798\C758 \C635\C158 \CC38\C870).')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106099655455310364)
,p_name=>'CHART_DEGREES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105349663550309735)
,p_name=>'CHART_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104908148459309403)
,p_name=>'CHART_SERIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \ACC4\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105395393831309769)
,p_name=>'CHART_SERIES_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('%1\C5D0 \B300\D55C \CC28\D2B8 \ACC4\C5F4 \C624\B958 %0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105004357791309473)
,p_name=>'CHART_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\AC00 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105353413880309738)
,p_name=>'CHECKSUM_REQUIRED_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\C12C \D544\C694 - \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105186517841309612)
,p_name=>'CHECKSUM_REQUIRED_SESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\C12C \D544\C694 - \C138\C158 \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105186455330309611)
,p_name=>'CHECKSUM_REQUIRED_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\C12C \D544\C694 - \C0AC\C6A9\C790 \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105186333728309611)
,p_name=>'CHECKSUM_REQUIRED_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\C12C \D544\C694 - \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106100453427310365)
,p_name=>'CHECK_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \C120\D0DD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105338952960309727)
,p_name=>'CLASSIC_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B798\C2DD \B2EC\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105341648257309729)
,p_name=>'CLASSIC_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B798\C2DD \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105040197371309499)
,p_name=>'CLASSIC_REPORT_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B798\C2DD \BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105339374225309727)
,p_name=>'CLASSIC_TREE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B798\C2DD \D2B8\B9AC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105337207867309726)
,p_name=>'CLEAN_UP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C9C0\C6B0\AE30')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104902918727309399)
,p_name=>'CLEAR_COMMAND'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA85\B839 \C9C0\C6B0\AE30')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105346506389309733)
,p_name=>'CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\ACB0\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105392122482309766)
,p_name=>'CLOSED_LAST_7_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC 7\C77C\AC04 \C885\ACB0\B41C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105145260457309581)
,p_name=>'CLOSE_WINDOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC3D \B2EB\AE30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105880626805310169)
,p_name=>'CODE_EDITOR.ACCESSIBILITY_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C811\ADFC\C131 \BAA8\B4DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106176829628310432)
,p_name=>'CODE_EDITOR.CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EB\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106177854347310433)
,p_name=>'CODE_EDITOR.FIND'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC3E\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106177776062310433)
,p_name=>'CODE_EDITOR.HINT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9 \C644\C131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106005402117310275)
,p_name=>'CODE_EDITOR.INDENTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4E4\C5EC\C4F0\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106177190313310433)
,p_name=>'CODE_EDITOR.INDENT_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4E4\C5EC\C4F0\AE30 \D06C\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106177303230310433)
,p_name=>'CODE_EDITOR.INDENT_WITH_TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED\C744 \ACF5\BC31\C73C\B85C \C785\B825')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105880791858310169)
,p_name=>'CODE_EDITOR.ITEM_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 %0\C774(\AC00) \C5C6\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105881852804310170)
,p_name=>'CODE_EDITOR.MINIMAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\B2C8\B9F5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105881799465310170)
,p_name=>'CODE_EDITOR.MINIMAP_CONDITIONAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 100\AC1C\B97C \CD08\ACFC\D558\B294 \ACBD\C6B0\B9CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106181123855310435)
,p_name=>'CODE_EDITOR.QUERY_BUILDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \C791\C131\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106177911357310433)
,p_name=>'CODE_EDITOR.REDO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C2E4\D589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106177589850310433)
,p_name=>'CODE_EDITOR.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106177414087310433)
,p_name=>'CODE_EDITOR.SHOW_LINE_NUMBERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BC88\D638 \D45C\C2DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106176990638310432)
,p_name=>'CODE_EDITOR.SHOW_RULER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B208\AE08\C790 \D45C\C2DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105881699519310170)
,p_name=>'CODE_EDITOR.SUGGESTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C548 \D45C\C2DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106177207044310433)
,p_name=>'CODE_EDITOR.TAB_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \D06C\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106177085652310432)
,p_name=>'CODE_EDITOR.THEMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105881573758310170)
,p_name=>'CODE_EDITOR.THEME_AUTOMATIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105881474124310170)
,p_name=>'CODE_EDITOR.THEME_DARK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B4\B450\C6C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105881205466310169)
,p_name=>'CODE_EDITOR.THEME_HIGH_CONTRAST_DARK'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\B300\BE44 \C5B4\B450\C6C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105881369817310170)
,p_name=>'CODE_EDITOR.THEME_LIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1D\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105881127617310169)
,p_name=>'CODE_EDITOR.TRANSFORM_CODE_CASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\D658 \CF54\B4DC \C0AC\B840')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106178042539310433)
,p_name=>'CODE_EDITOR.UNDO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \CDE8\C18C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105880981915310169)
,p_name=>'CODE_EDITOR.UTIL_OFF'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105881017573310169)
,p_name=>'CODE_EDITOR.UTIL_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106177615693310433)
,p_name=>'CODE_EDITOR.VALIDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106178123592310433)
,p_name=>'CODE_EDITOR.VALIDATION_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C131\ACF5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105880840799310169)
,p_name=>'CODE_EDITOR.WHITESPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\BC31 \D45C\C2DC')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105284363437309684)
,p_name=>'COLLAPSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95\C18C ')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104915930659309408)
,p_name=>'COLOR_PALETTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 \D314\B808\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105105326075309546)
,p_name=>'COLOR_PALETTE_ANALOGIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B0A0\B85C\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105104964089309545)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105105550326309546)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY_COLORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105105447564309546)
,p_name=>'COLOR_PALETTE_MONOTONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B178\D1A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105105087897309546)
,p_name=>'COLOR_PALETTE_SPLIT_COMPLEMENTARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C870 \BD84\D560')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105105289448309546)
,p_name=>'COLOR_PALETTE_TETRADE'
,p_message_language=>'ko'
,p_message_text=>unistr('4\C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105105167094309546)
,p_name=>'COLOR_PALETTE_TRIADE'
,p_message_language=>'ko'
,p_message_text=>unistr('3\C911')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106093306813310359)
,p_name=>'COLUMN_DISPLAY_NAME_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C774\B984: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105276848408309679)
,p_name=>'COLUMN_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105465079331309832)
,p_name=>'COM.ORACLE.APEX.ACL_ALL_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\B41C \BAA8\B4E0 \C0AC\C6A9\C790\AC00 \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105465170214309832)
,p_name=>'COM.ORACLE.APEX.ACL_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0 \C815\C758\B41C \C0AC\C6A9\C790\B9CC \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105465204501309832)
,p_name=>'COM.ORACLE.APEX.ACL_SETTING_VALUE_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608\C0C1\CE58 \C54A\C740 \C561\C138\C2A4 \C81C\C5B4 \C124\C815 \AC12: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104909082455309403)
,p_name=>'COMING_SOON'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE7 \CD9C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105277363883309679)
,p_name=>'COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105146302716309582)
,p_name=>'COMPILE_FAILURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEF4\D30C\C77C \C2E4\D328, <a href="javascript:goToLine(''%0'')">%0</a> \D589(%2)<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105477554434309842)
,p_name=>'COMPILE_FAILURE_TRIGGER'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEF4\D30C\C77C \C2E4\D328, %0 \D589(%2). \CEF4\D30C\C77C \C624\B958\C640 \C5F0\AD00\B41C \D589\C758 \C22B\C790\B294 \CCAB\BC88\C9F8 BEGIN \BB38\ACFC \AD00\B828\B429\B2C8\B2E4. \C774\B294 \B370\C774\D130\BCA0\C774\C2A4 \D2B8\B9AC\AC70 \CEF4\D30C\C77C\C5D0\B9CC \C601\D5A5\C744 \B07C\CE69\B2C8\B2E4.<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105146226729309582)
,p_name=>'COMPILE_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \CF54\B4DC\AC00 \C131\ACF5\C801\C73C\B85C \CEF4\D30C\C77C\B418\C5C8\C2B5\B2C8\B2E4(%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105343992078309731)
,p_name=>'COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105350972392309736)
,p_name=>'COMPLETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105357841081309741)
,p_name=>'COMPLETE_NO_ISSUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC/\BB38\C81C \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105392638317309767)
,p_name=>'COMPONENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105520789689309878)
,p_name=>'COMPONENT_NAME_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \C774\B984: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105711795728310041)
,p_name=>'COMPONENT_NOT_ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105007965577309475)
,p_name=>'COMPONENT_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\AC00 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106091083321310357)
,p_name=>'COMPONENT_SUMMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \C694\C57D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104956475097309438)
,p_name=>'COMPUTATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105414865685309789)
,p_name=>'COMP_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\C694\C18C\AC00 \C131\ACF5\C801\C73C\B85C \C124\CE58\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105146831239309582)
,p_name=>'CONDITIONAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74\BD80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105262527724309668)
,p_name=>'CONDITIONS_POPUP_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105336744483309726)
,p_name=>'CONDITIONS_SHORTCUT_ALWAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105068346005309519)
,p_name=>'CONDITIONS_SHORTCUT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C874\C7AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105067777333309519)
,p_name=>'CONDITIONS_SHORTCUT_EXPRESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105067869558309519)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_E_VAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9/\C5F4=\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105067960501309519)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9/\C5F4\C774 \B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105881976820310170)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9/\C5F4 \B110')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105068431485309519)
,p_name=>'CONDITIONS_SHORTCUT_NEVER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\C870\AC74 \BD80\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105068573066309519)
,p_name=>'CONDITIONS_SHORTCUT_NONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105068157148309519)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_IN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C5D0 \C874\C7AC\D558\B294 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105068293249309519)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_NOT_IN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C5D0 \C874\C7AC\D558\C9C0 \C54A\B294 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105068094670309519)
,p_name=>'CONDITIONS_SHORTCUT_REQ_E_E1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD=e1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105079471585309527)
,p_name=>'CONDITION_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74 \C720\D615')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105299741150309696)
,p_name=>'CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104868869508309371)
,p_name=>'CONFIRM.2_PAGE_MASTER_DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B9C8\C2A4\D130 \B514\D14C\C77C 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104868752728309371)
,p_name=>'CONFIRM.3_PAGE_MASTER_DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B9C8\C2A4\D130 \B514\D14C\C77C 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105054217658309509)
,p_name=>'CONFIRM.ACTUAL_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\C81C \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105343768242309731)
,p_name=>'CONFIRM.AGG_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\BCC4 \C9D1\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105343879294309731)
,p_name=>'CONFIRM.AGG_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\D560 \C9D1\ACC4 \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105051654522309507)
,p_name=>'CONFIRM.APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105065168708309517)
,p_name=>'CONFIRM.APPLICATION_ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105065223644309517)
,p_name=>'CONFIRM.APPLICATION_DEFAULT_LANG'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105065000260309517)
,p_name=>'CONFIRM.APPLICATION_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104962045163309442)
,p_name=>'CONFIRM.ARRAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \ACB0\ACFC \D2B8\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104962149069309442)
,p_name=>'CONFIRM.ARRAY_PARMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \ACB0\ACFC \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105065318937309517)
,p_name=>'CONFIRM.AUTHENTICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105518884619309876)
,p_name=>'CONFIRM.BRANCH_TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105268098050309672)
,p_name=>'CONFIRM.BREAK_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105054007157309509)
,p_name=>'CONFIRM.BUTTON_BRANCH'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B2E8\CD94 \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105053966162309509)
,p_name=>'CONFIRM.BUTTON_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B2E8\CD94 \D45C\C2DC \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104889303186309388)
,p_name=>'CONFIRM.CALENDAR_ENABLE_AJAX_DATA_ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \CD94\AC00 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104889213216309388)
,p_name=>'CONFIRM.CALENDAR_ENABLE_DRAG_AND_DROP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B04C\C5B4 \B193\AE30 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105467301617309833)
,p_name=>'CONFIRM.CANCEL_BRANCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30 \CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105518641304309876)
,p_name=>'CONFIRM.CANCEL_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C \B2E8\CD94 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105510723798309870)
,p_name=>'CONFIRM.CASE_SENSITIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C18C\BB38\C790 \AD6C\BD84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105144710002309581)
,p_name=>'CONFIRM.CHANGE_INTERACTIVE_RPT_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C \C9C8\C758\B97C \BCC0\ACBD\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C9C8\C758\C5D0\C11C \C5F4\C744 \C81C\AC70\D55C \ACBD\C6B0 \AE30\C874 \D544\D130, \AC15\C870 \D45C\C2DC \ADDC\CE59 \BC0F \D574\B2F9 \C5F4\C744 \CC38\C870\D558\B294 \AE30\D0C0 \BCF4\ACE0\C11C \C124\C815\C774 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B429\B2C8\B2E4. \C694\CCAD\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105055148003309510)
,p_name=>'CONFIRM.CHART_AXIS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \CD95')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105403947363309775)
,p_name=>'CONFIRM.CHART_DIAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C774\C5BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105404023840309775)
,p_name=>'CONFIRM.CHART_DIALSWEEP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C774\C5BC(Sweep)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105055850503309510)
,p_name=>'CONFIRM.CHART_HORIZONTAL_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\D3C9 \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105056064226309510)
,p_name=>'CONFIRM.CHART_LINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105055390522309510)
,p_name=>'CONFIRM.CHART_NUMBER_MASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C22B\C790 \B9C8\C2A4\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105055919929309510)
,p_name=>'CONFIRM.CHART_PIE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105055035495309510)
,p_name=>'CONFIRM.CHART_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105055247952309510)
,p_name=>'CONFIRM.CHART_SCALE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C218\C810 \C774\D558 \C790\B9BF\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105056127165309510)
,p_name=>'CONFIRM.CHART_SCATTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0B0\D3EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105055660417309510)
,p_name=>'CONFIRM.CHART_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105055509899309510)
,p_name=>'CONFIRM.CHART_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105055421417309510)
,p_name=>'CONFIRM.CHART_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105055762048309510)
,p_name=>'CONFIRM.CHART_VERTICAL_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C9C1 \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104962279348309442)
,p_name=>'CONFIRM.COLLECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C784\C2DC \ACB0\ACFC \C9D1\D569 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105052430273309508)
,p_name=>'CONFIRM.COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105267868242309672)
,p_name=>'CONFIRM.COLUMN_HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105430597920309802)
,p_name=>'CONFIRM.COLUMN_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105467563270309834)
,p_name=>'CONFIRM.COLUMN_NAMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105064783398309516)
,p_name=>'CONFIRM.COL_HEAD_SORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \BA38\B9AC\AE00 \C815\B82C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105188783427309613)
,p_name=>'CONFIRM.COPY_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C744 \BCF5\C0AC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105063398481309515)
,p_name=>'CONFIRM.COPY_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \D398\C774\C9C0\B97C \BCF5\C0AC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105052930241309508)
,p_name=>'CONFIRM.CREATE.NEW.TABSET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \D0ED \C9D1\D569 "%0"\C774(\AC00) \C0DD\C131\B418\C5B4 \C774 \D398\C774\C9C0\C5D0 \C758\D574 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105064913587309517)
,p_name=>'CONFIRM.CREATE_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105057424856309511)
,p_name=>'CONFIRM.CREATE_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \B2EC\B825 \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105060687690309514)
,p_name=>'CONFIRM.CREATE_DRILL_DOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \B4DC\B9B4 \B2E4\C6B4 \BCF4\ACE0\C11C \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105113560643309552)
,p_name=>'CONFIRM.CREATE_DYNAMIC_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \B300\D654\C2DD \BCF4\ACE0\C11C \D398\C774\C9C0\B97C \C0DD\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105063644377309516)
,p_name=>'CONFIRM.CREATE_EASY_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \BCF4\ACE0\C11C \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106072003909310339)
,p_name=>'CONFIRM.CREATE_FLOW_APP_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C791\C5C5\C601\C5ED\C5D0\C11C \AE30\C874 \B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158\ACFC \B3D9\C77C\D55C ID\B97C \C0AC\C6A9\D558\B294 \B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \AE30\C874 \B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158\C774 \C0AD\C81C\B418\ACE0 \C0C8 \B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \BC14\B01D\B2C8\B2E4. \C120\D0DD \D56D\BAA9\C744 \D655\C778\D558\C2ED\C2DC\C624. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105427474791309800)
,p_name=>'CONFIRM.CREATE_FORM_AND_LIST_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \D3FC \BC0F \BAA9\B85D \BCF4\AE30 \D398\C774\C9C0\B97C \C0DD\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105343494861309731)
,p_name=>'CONFIRM.CREATE_FORM_AND_REPORT_WITH_ANALYSIS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\C11D \D398\C774\C9C0\B97C \C0AC\C6A9\D558\C5EC \D3FC \BC0F \BCF4\ACE0\C11C \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105057007988309511)
,p_name=>'CONFIRM.CREATE_FORM_ON_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC SQL \C9C8\C758\C5D0 \D3FC\C744 \C0DD\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105056958279309511)
,p_name=>'CONFIRM.CREATE_FORM_ON_SP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \B0B4\C7A5 \D504\B85C\C2DC\C800\C5D0 \D3FC\C744 \C0DD\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105056863371309511)
,p_name=>'CONFIRM.CREATE_FORM_ON_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \D14C\C774\BE14 \D398\C774\C9C0\C5D0 \D3FC\C744 \C0DD\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104932512566309420)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \C6F9 \C11C\BE44\C2A4 \CC38\C870 \D398\C774\C9C0\C5D0 \D3FC\C744 \C0DD\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104972727709309450)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS_RPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \D3FC\C744 \C0DD\C131\D558\ACE0 \C6F9 \C11C\BE44\C2A4 \CC38\C870 \D398\C774\C9C0\C5D0 \B300\D574 \BCF4\ACE0\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105371021320309751)
,p_name=>'CONFIRM.CREATE_MAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \B9F5 \D398\C774\C9C0\B97C \C0DD\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104866474660309368)
,p_name=>'CONFIRM.CREATE_MASTER_DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \B9C8\C2A4\D130 \B514\D14C\C77C \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105058602192309512)
,p_name=>'CONFIRM.CREATE_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \C774\B3D9 \ACBD\B85C \C601\C5ED \BC0F \C774\B3D9 \ACBD\B85C \C635\C158\C744 \C0DD\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105349769844309735)
,p_name=>'CONFIRM.CREATE_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131 \BAA8\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105056638494309511)
,p_name=>'CONFIRM.CREATE_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106121013266310384)
,p_name=>'CONFIRM.CREATE_PAGE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106121138001310384)
,p_name=>'CONFIRM.CREATE_PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\B984 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105059405370309513)
,p_name=>'CONFIRM.CREATE_QUERY_AND_UPDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \D3FC \BC0F \BCF4\ACE0\C11C \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106067940928310335)
,p_name=>'CONFIRM.CREATE_REGION_PLUGIN_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105063426613309516)
,p_name=>'CONFIRM.CREATE_REPORT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \BCF4\ACE0\C11C \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105057123680309511)
,p_name=>'CONFIRM.CREATE_SIMPLE_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC HTML \B9C9\B300 \CC28\D2B8 \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105063093754309515)
,p_name=>'CONFIRM.CREATE_SUMMARY_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \C694\C57D \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \B2E4\B978 \D398\C774\C9C0 \BC0F/\B610\B294 \C601\C5ED\C5D0\C11C \CD94\AC00 \D56D\BAA9\C744 \CD94\AC00\D558\B824\BA74 "\CD94\AC00" \B2E8\CD94\B97C \B204\B974\ACE0, \C694\C57D \D56D\BAA9\C744 \C0DD\C131\D558\B824\BA74 "\C644\B8CC"\B97C \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105057249785309511)
,p_name=>'CONFIRM.CREATE_SVG_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC SVG \CC28\D2B8 \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105056569878309511)
,p_name=>'CONFIRM.CREATE_TABULAR_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \D45C \D615\C2DD \D3FC \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105057729939309511)
,p_name=>'CONFIRM.CREATE_TREE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \D2B8\B9AC \D398\C774\C9C0\B97C \C791\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105056775991309511)
,p_name=>'CONFIRM.CREATE_WIZARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \B9C8\BC95\C0AC\B97C \C0DD\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106071997150310339)
,p_name=>'CONFIRM.CREATE_WS_APP_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C791\C5C5\C601\C5ED\C5D0\C11C \AE30\C874 \C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\ACFC \B3D9\C77C\D55C ID\B97C \C0AC\C6A9\D558\B294 \C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \AE30\C874 \C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C774 \C0AD\C81C\B418\ACE0 \C0C8 \C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \BC14\B01D\B2C8\B2E4. \C120\D0DD \D56D\BAA9\C744 \D655\C778\D558\C2ED\C2DC\C624. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105264551539309669)
,p_name=>'CONFIRM.CSV_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106008604531310278)
,p_name=>'CONFIRM.DATA_LOAD_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C815\C758 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106079021581310345)
,p_name=>'CONFIRM.DATA_LOAD_NAME_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B370\C774\D130 \B85C\B4DC \C815\C758\B294 \AE30\C874 \D14C\C774\BE14 \C870\D68C \BC0F \BCC0\D658 \ADDC\CE59\C744 \C0AC\C6A9\D558\C5EC \C7AC\C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105510804280309870)
,p_name=>'CONFIRM.DATA_LOAD_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105057537418309511)
,p_name=>'CONFIRM.DATE_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105349803496309735)
,p_name=>'CONFIRM.DEFAULT_AUTH_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C778\C99D \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105056468860309511)
,p_name=>'CONFIRM.DELETE_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105061382105309514)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80 %0 \D45C\C2DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104869246357309371)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B514\D14C\C77C \D45C\C2DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105062969969309515)
,p_name=>'CONFIRM.DETAIL_MENU_COL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80 \C774\B3D9 \ACBD\B85C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105062121550309515)
,p_name=>'CONFIRM.DETAIL_ORDER_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \D14C\C774\BE14 %0 \C815\B82C \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105060868478309514)
,p_name=>'CONFIRM.DETAIL_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \D398\C774\C9C0 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104869133875309371)
,p_name=>'CONFIRM.DETAIL_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B514\D14C\C77C \D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105061183531309514)
,p_name=>'CONFIRM.DETAIL_TABLE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \D14C\C774\BE14 \C774\B984 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105060977986309514)
,p_name=>'CONFIRM.DETAIL_TAB_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80 \D0ED \B808\C774\BE14 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105467839623309834)
,p_name=>'CONFIRM.DISPLAY_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B85C\B4DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105054564690309509)
,p_name=>'CONFIRM.DISPLAY_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105430200901309802)
,p_name=>'CONFIRM.DISPLAY_COLUMN_2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B85C\B4DC \C5F4 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105430328996309802)
,p_name=>'CONFIRM.DISPLAY_COLUMN_3'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B85C\B4DC \C5F4 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105058854536309512)
,p_name=>'CONFIRM.DISPLAY_POINT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106128636704310391)
,p_name=>'CONFIRM.EDIT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106128733608310391)
,p_name=>'CONFIRM.EDIT_PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\B984 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105254425609309662)
,p_name=>'CONFIRM.ENABLE_CSV_OUTPUT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSV \CD9C\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105255172013309662)
,p_name=>'CONFIRM.ENABLE_PRINT_OUTPUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD9C\B825 \C778\C1C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105255780513309663)
,p_name=>'CONFIRM.ENABLE_SORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \BA38\B9AC\AE00 \C815\B82C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105301693848309697)
,p_name=>'CONFIRM.EXISTING_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \AD00\B9AC \D398\C774\C9C0\C5D0 \C601\C5ED\C774 \CD94\AC00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105467479687309834)
,p_name=>'CONFIRM.FINISH_BRANCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30 \C644\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105059985980309513)
,p_name=>'CONFIRM.FORM_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105060097090309513)
,p_name=>'CONFIRM.FORM_PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \D398\C774\C9C0 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105060268819309513)
,p_name=>'CONFIRM.FORM_PAGE_TAB_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \D398\C774\C9C0 \D0ED \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105060187579309513)
,p_name=>'CONFIRM.FORM_PAGE_TAB_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \D398\C774\C9C0 \D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105349905453309735)
,p_name=>'CONFIRM.IMPORT_SHARED_COMPONENTS_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C5D0\C11C \ACF5\C720 \AD6C\C131\C694\C18C \C784\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105696733020310026)
,p_name=>'CONFIRM.INCLUDE_CUSTOM_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \B2EC\B825 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104869425698309371)
,p_name=>'CONFIRM.INCLUDE_MASTER_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \BCF4\ACE0\C11C\B97C \D3EC\D568\C2DC\D0A4\ACA0\C2B5\B2C8\AE4C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105062678733309515)
,p_name=>'CONFIRM.INC_BREAD_CRUMB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105053796663309509)
,p_name=>'CONFIRM.INFORMATION_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105053876656309509)
,p_name=>'CONFIRM.INFORMATION_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4 \AE30\BCF8 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104932730922309420)
,p_name=>'CONFIRM.INPUT_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104962498333309442)
,p_name=>'CONFIRM.INPUT_REGION_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104962361211309442)
,p_name=>'CONFIRM.INPUT_REGION_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \C601\C5ED \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105056272632309510)
,p_name=>'CONFIRM.INSERT_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0BD\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105053526655309508)
,p_name=>'CONFIRM.ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105467705234309834)
,p_name=>'CONFIRM.KEY_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\D658 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105466631045309833)
,p_name=>'CONFIRM.KEY_COLUMN_1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\D68C \D0A4 \C5F4 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105466752598309833)
,p_name=>'CONFIRM.KEY_COLUMN_2'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0A4 \C5F4 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105466896785309833)
,p_name=>'CONFIRM.KEY_COLUMN_3'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0A4 \C5F4 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105057686464309511)
,p_name=>'CONFIRM.LABEL_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105430455884309802)
,p_name=>'CONFIRM.LOOKUP_OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\D68C \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105467685812309834)
,p_name=>'CONFIRM.LOOKUP_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\D68C \D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104869571255309371)
,p_name=>'CONFIRM.MASTER_DETAIL_LAYOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \B514\D14C\C77C \B808\C774\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104869048146309371)
,p_name=>'CONFIRM.MASTER_DISPLAY_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \D45C\C2DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104869361361309371)
,p_name=>'CONFIRM.MASTER_SORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \B808\CF54\B4DC \C774\B3D9 \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104868984291309371)
,p_name=>'CONFIRM.MASTER_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105267974224309672)
,p_name=>'CONFIRM.MAXIMUM_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \C5F4 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105264307364309669)
,p_name=>'CONFIRM.MAX_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B2F9 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105120648845309557)
,p_name=>'CONFIRM.MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105059180534309512)
,p_name=>'CONFIRM.MENU_LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105062739893309515)
,p_name=>'CONFIRM.MENU_ROOT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \B8E8\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105058919266309512)
,p_name=>'CONFIRM.MENU_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105059211451309512)
,p_name=>'CONFIRM.MENU_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104935287556309422)
,p_name=>'CONFIRM.MIGRATE_HTML_TO_HTML5'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \CC28\D2B8\B97C \C0C8 HTML5 \CC28\D2B8\B97C \C5C5\ADF8\B808\C774\B4DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C694\CCAD\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106087672374310354)
,p_name=>'CONFIRM.MIGRATE_JSTREE_TO_APEXTREE'
,p_message_language=>'ko'
,p_message_text=>unistr('jsTree\B97C \C0C8 \D2B8\B9AC\B85C \C5C5\ADF8\B808\C774\B4DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C694\CCAD\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105045321140309503)
,p_name=>'CONFIRM.MIGRATE_SVG_RESTRICTION'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SVG \CC28\D2B8\B97C \C5C5\ADF8\B808\C774\B4DC\D560 \B54C\B294 \B2E4\C74C\ACFC \AC19\C740 \C81C\D55C \C0AC\D56D\C774 \C788\C2B5\B2C8\B2E4.  '),
'<ul>',
'<li>',
unistr('\CD95 \D615\C2DD \BB38\C790\C5F4\C5D0 \C815\C758\B41C \C22B\C790 \D615\C2DD\B9CC \C774\C804\B429\B2C8\B2E4. \B0A0\C9DC \BC0F \C2DC\AC04 \D615\C2DD\C740 \BB34\C2DC\B429\B2C8\B2E4.'),
'</li>',
'<li>',
unistr('\B2E4\C74C\C744 \D3EC\D568\D558\B294 \C22B\C790 \D615\C2DD \C694\C18C\B9CC \C774\C804\B429\B2C8\B2E4.'),
'<br />',
unistr('0,9,D,G,,(\CF64\B9C8),.(\B9C8\CE68\D45C),$,C,L,FM'),
'</li>',
'<li>',
unistr('\D50C\B798\C2DC \CC28\D2B8\C758 \AC01 \ACC4\C5F4\C5D0 \B300\D55C \B808\C774\BE14\C740 \AC01 \ACC4\C5F4\C758 \C5F4 \BCC4\CE6D\C5D0\C11C \D30C\C0DD\B429\B2C8\B2E4.  '),
unistr('\C774\B294 \AC01 \ACC4\C5F4\C758 \B808\C774\BE14\C774 \ACC4\C5F4 \C774\B984 \C18D\C131\C5D0\C11C \D30C\C0DD\B418\B294 SVG \CC28\D2B8\C640 \B2E4\B985\B2C8\B2E4.'),
'</li>',
'<li>',
unistr('\D50C\B798\C2DC \B2E4\C774\C5BC \CC28\D2B8\B294 \BC31\BD84\C728 \B300\C2E0 \C2E4\C81C \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.'),
'</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105009326240309476)
,p_name=>'CONFIRM.MIGRATE_SVG_TO_HTML5'
,p_message_language=>'ko'
,p_message_text=>unistr('SVG \CC28\D2B8\B97C HTML5 \CC28\D2B8\B85C \C5C5\ADF8\B808\C774\B4DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C694\CCAD\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106067731447310335)
,p_name=>'CONFIRM.NAVIGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105065610775309517)
,p_name=>'CONFIRM.NAV_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105679026239310011)
,p_name=>'CONFIRM.NAV_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \BA54\B274 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105361225181309744)
,p_name=>'CONFIRM.NEW_ADMIN_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \AD00\B9AC \D398\C774\C9C0\AC00 \CD94\AC00\B429\B2C8\B2E4. \D398\C774\C9C0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105144923327309581)
,p_name=>'CONFIRM.NEW_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105054379363309509)
,p_name=>'CONFIRM.NEW_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105518454248309876)
,p_name=>'CONFIRM.NEXT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B2E8\CD94 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105052886768309508)
,p_name=>'CONFIRM.NO.TABSET.SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0 \B300\D574 \C120\D0DD\B41C \D0ED \C9D1\D569\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105053405374309508)
,p_name=>'CONFIRM.NO_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104932805164309421)
,p_name=>'CONFIRM.OUTPUT_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD9C\B825 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105054731154309509)
,p_name=>'CONFIRM.OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105051778092309507)
,p_name=>'CONFIRM.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105065495123309517)
,p_name=>'CONFIRM.PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105051854507309507)
,p_name=>'CONFIRM.PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105052751465309508)
,p_name=>'CONFIRM.PAGE_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105061265813309514)
,p_name=>'CONFIRM.PARENT_DISPLAY_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D45C\C2DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105059317971309513)
,p_name=>'CONFIRM.PARENT_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105062817541309515)
,p_name=>'CONFIRM.PARENT_MENU_COL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \C774\B3D9 \ACBD\B85C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105061419550309514)
,p_name=>'CONFIRM.PARENT_ORDER_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D14C\C774\BE14 \C815\B82C \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105060778307309514)
,p_name=>'CONFIRM.PARENT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105061073667309514)
,p_name=>'CONFIRM.PARENT_TABLE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D14C\C774\BE14 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105053331866309508)
,p_name=>'CONFIRM.PARENT_TAB_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105053296613309508)
,p_name=>'CONFIRM.PARENT_TAB_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105144662698309581)
,p_name=>'CONFIRM.PARSING_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BB38\BD84\C11D \C2A4\D0A4\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105151370805309586)
,p_name=>'CONFIRM.PARTIAL_REFRESH_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\BD84 \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105518503891309876)
,p_name=>'CONFIRM.PREVIOUS_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804 \B2E8\CD94 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105052694280309508)
,p_name=>'CONFIRM.PRIMARY_KEY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105060380335309513)
,p_name=>'CONFIRM.PRIMARY_KEY_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105264683441309669)
,p_name=>'CONFIRM.PRINT_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD9C\B825 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105268167319309672)
,p_name=>'CONFIRM.PRINT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4 \B9C1\D06C \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105264754303309669)
,p_name=>'CONFIRM.PRINT_OUTPUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C778\C1C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105054693671309509)
,p_name=>'CONFIRM.PROCESS_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105264455322309669)
,p_name=>'CONFIRM.REGION_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105053658709309509)
,p_name=>'CONFIRM.REGION_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105051982943309507)
,p_name=>'CONFIRM.REGION_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105058751744309512)
,p_name=>'CONFIRM.REGION_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105144840927309581)
,p_name=>'CONFIRM.REMOVED_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\AC70\B41C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105060410438309513)
,p_name=>'CONFIRM.REPORT_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105284466837309684)
,p_name=>'CONFIRM.REPORT_IMPLEMENTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \AD6C\D604')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105059533483309513)
,p_name=>'CONFIRM.REPORT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105059632502309513)
,p_name=>'CONFIRM.REPORT_PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105059883402309513)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0 \D0ED \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105059735561309513)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0 \D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104962634491309442)
,p_name=>'CONFIRM.REPORT_REGION_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104962514788309442)
,p_name=>'CONFIRM.REPORT_REGION_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C601\C5ED \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105063780691309516)
,p_name=>'CONFIRM.REPORT_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104965164192309444)
,p_name=>'CONFIRM.ROW_VERSION_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BC84\C804 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105063981028309516)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME1'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12: HTML(\D45C\C900)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105064205808309516)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME11'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12: \BAA8\C591 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105064362694309516)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME12'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12: \BAA8\C591 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105144493528309581)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME13'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12: \BAA8\C591 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105144552693309581)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME14'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12: \BAA8\C591 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104963165639309442)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME15'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12: \BAA8\C591 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105064029440309516)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME2'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12: \C138\B85C\D615 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105064487458309516)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME21'
,p_message_language=>'ko'
,p_message_text=>unistr('\C775\C2A4\D3EC\D2B8: CSV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105064534132309516)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME22'
,p_message_language=>'ko'
,p_message_text=>unistr('\C775\C2A4\D3EC\D2B8: XML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105064119303309516)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME3'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12: \C138\B85C\D615 \BCF4\ACE0\C11C, \BAA8\C591 1(\B110 \C5F4 \D3EC\D568)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105144259789309580)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME4'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12: \C138\B85C\D615 \BCF4\ACE0\C11C, \BAA8\C591 2(\B110 \C5F4 \C81C\C678)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105144370359309581)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME5'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12: \C138\B85C\D615 \BCF4\ACE0\C11C, \BAA8\C591 2(\B110 \C5F4 \D3EC\D568)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105467968750309834)
,p_name=>'CONFIRM.RULE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADDC\CE59 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105468149148309834)
,p_name=>'CONFIRM.RULE_SEQUENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105468284306309834)
,p_name=>'CONFIRM.RULE_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADDC\CE59 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104907801832309403)
,p_name=>'CONFIRM.RUN_SCRIPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C2A4\D06C\B9BD\D2B8\B97C \C2E4\D589\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C694\CCAD \B0B4\C6A9\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105059077695309512)
,p_name=>'CONFIRM.SEQUENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105063833033309516)
,p_name=>'CONFIRM.SORT_OPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105054929071309509)
,p_name=>'CONFIRM.SQL_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105151298234309586)
,p_name=>'CONFIRM.STANDARD_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105299391910309695)
,p_name=>'CONFIRM.STARTING_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \D398\C774\C9C0\AC00 \C0DD\C131\B429\B2C8\B2E4. \C2DC\C791 \D398\C774\C9C0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105054879018309509)
,p_name=>'CONFIRM.STORED_PROCEDURE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \D504\B85C\C2DC\C800 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105146168500309582)
,p_name=>'CONFIRM.STORED_PROCEDURE_OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \D504\B85C\C2DC\C800 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105518705800309876)
,p_name=>'CONFIRM.SUBMIT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC \B2E8\CD94 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106083023040310349)
,p_name=>'CONFIRM.SUBSCRIBE_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105054174078309509)
,p_name=>'CONFIRM.SUGGESTED_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\C7A5 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105343587018309731)
,p_name=>'CONFIRM.TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14/\BDF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105343620879309731)
,p_name=>'CONFIRM.TABLE_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\BCC4 \C694\C57D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105529867170309886)
,p_name=>'CONFIRM.TABLE_LOOKUPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C870\D68C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105052309431309508)
,p_name=>'CONFIRM.TABLE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105052279180309508)
,p_name=>'CONFIRM.TABLE_OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105629997655309967)
,p_name=>'CONFIRM.TABLE_RULE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\D658 \ADDC\CE59')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105468353756309834)
,p_name=>'CONFIRM.TABLE_RULES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\D658 \ADDC\CE59')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105145103112309581)
,p_name=>'CONFIRM.TABLE_VIEW_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14/\BDF0 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105145012372309581)
,p_name=>'CONFIRM.TABLE_VIEW_OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14/\BDF0 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105065505631309517)
,p_name=>'CONFIRM.TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105053167223309508)
,p_name=>'CONFIRM.TABSET.INCOMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: \D0ED \C9D1\D569 \C815\BCF4\AC00 \BD88\C644\C804\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105052146403309507)
,p_name=>'CONFIRM.TAB_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105063560857309516)
,p_name=>'CONFIRM.TAB_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105052015252309507)
,p_name=>'CONFIRM.TAB_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105064645506309516)
,p_name=>'CONFIRM.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105058396497309512)
,p_name=>'CONFIRM.TREE_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D\C744 \C0AC\C6A9\D558\B294 \C0C8 \D56D\BAA9\C744 \AE30\C900\C73C\B85C \D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105058060752309512)
,p_name=>'CONFIRM.TREE_MAX_LEVEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105057862308309512)
,p_name=>'CONFIRM.TREE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105058292200309512)
,p_name=>'CONFIRM.TREE_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105058470698309512)
,p_name=>'CONFIRM.TREE_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758 \AE30\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105058111507309512)
,p_name=>'CONFIRM.TREE_START'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105058597023309512)
,p_name=>'CONFIRM.TREE_STATIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105057919710309512)
,p_name=>'CONFIRM.TREE_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105065756575309517)
,p_name=>'CONFIRM.UI_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105065869082309517)
,p_name=>'CONFIRM.UI_THEME1'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAD\AC08\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105065902539309517)
,p_name=>'CONFIRM.UI_THEME2'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE68\AC04\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105066070768309517)
,p_name=>'CONFIRM.UI_THEME4'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A8\D68C\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105066159936309517)
,p_name=>'CONFIRM.UI_THEME5'
,p_message_language=>'ko'
,p_message_text=>unistr('\C62C\B9AC\BE0C\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105066217996309518)
,p_name=>'CONFIRM.UI_THEME6'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\AC08\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105066361340309518)
,p_name=>'CONFIRM.UI_THEME7'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C21C \CCAD\AC08\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105066435291309518)
,p_name=>'CONFIRM.UI_THEME8'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105066587934309518)
,p_name=>'CONFIRM.UI_THEME_NONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105052517186309508)
,p_name=>'CONFIRM.UPDATEABLE_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105056317800309510)
,p_name=>'CONFIRM.UPDATE_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105053016380309508)
,p_name=>'CONFIRM.USE.EXISTING.TABSET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B294 \AE30\C874 \D0ED \C9D1\D569 "%0"\C744(\B97C) \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104932669707309420)
,p_name=>'CONFIRM.WEB_SERVICE_REF'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \CC38\C870, \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105060531153309513)
,p_name=>'CONFIRM.WHERE_CLAUSE'
,p_message_language=>'ko'
,p_message_text=>unistr('Where \C808')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105334015673309724)
,p_name=>'CONFIRMATION_ICON'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778 \C544\C774\CF58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105344365407309731)
,p_name=>'CONFIRMED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105344626062309731)
,p_name=>'CONFIRMED_BY_QA'
,p_message_language=>'ko'
,p_message_text=>unistr('QA \D655\C778\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105264993392309670)
,p_name=>'CONFIRM_BREAK_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105264839242309669)
,p_name=>'CONFIRM_PRINT_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4 \D615\C2DD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105372266671309752)
,p_name=>'CONTENT_DISPOSITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20 \CC98\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105404989428309776)
,p_name=>'CONTENT_SERVED_IN_KBYTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\B41C \CF58\D150\CE20')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106183118209310437)
,p_name=>'CONTRIBUTORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\C790')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106097767149310363)
,p_name=>'COPY.PAGE.NEW_STATIC_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C815\C801 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105144094793309580)
,p_name=>'COPY_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105009192507309476)
,p_name=>'COPY_APP_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C774 \BCF5\C0AC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105123476611309562)
,p_name=>'COPY_BUTTON.EXECUTION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('copy_button\C744 \C2E4\D589\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105189354101309613)
,p_name=>'COPY_DEPLOYMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4 \C815\C758 \C18D\C131 \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104984214470309458)
,p_name=>'COPY_EXISTING_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105428252380309800)
,p_name=>'COPY_FEATURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC \AE30\B2A5: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105188958084309613)
,p_name=>'COPY_FROM_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105569852384309918)
,p_name=>'COPY_FROM_APP_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C560\D50C\B9AC\CF00\C774\C158 \AE30\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105189059693309613)
,p_name=>'COPY_FROM_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C5D0\C11C \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105012924750309479)
,p_name=>'COPY_LIST_ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D56D\BAA9 \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105123892776309562)
,p_name=>'COPY_NAMED_LOV.EXECUTION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('copy_named_lov\B97C \C2E4\D589\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105123700341309562)
,p_name=>'COPY_NAMED_LOV.NOT_FOUND_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D ID "%0"\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105123652086309562)
,p_name=>'COPY_NAMED_LOV.NUMERIC_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D ID "%0"\C740(\B294) \C22B\C790\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105409763607309779)
,p_name=>'COPY_PAGE.COPY_FROM_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C5D0\C11C \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105409846184309779)
,p_name=>'COPY_PAGE.COPY_TO_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B85C \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105408823292309779)
,p_name=>'COPY_PAGE.SELECT_AUTHORIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('- \AD8C\D55C \BD80\C5EC \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105408734646309779)
,p_name=>'COPY_PAGE.SELECT_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('- \BAA9\B85D \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105408626109309779)
,p_name=>'COPY_PAGE.SELECT_NAMED_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('- \AC12 \BAA9\B85D \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105473073785309838)
,p_name=>'COPY_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D14C\C774\BE14\C5D0 %0 \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105189110484309613)
,p_name=>'COPY_TO_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105189270583309613)
,p_name=>'COPY_TO_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C73C\B85C \BCF5\C0AC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105095886893309539)
,p_name=>'CORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF54\C5B4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105538866591309893)
,p_name=>'CREATE APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105538969933309893)
,p_name=>'CREATE OBJECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105427902921309800)
,p_name=>'CREATED_LAST_7_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC 7\C77C\AC04 \C0DD\C131\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104984377164309458)
,p_name=>'CREATE_APP_FROM_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D15C\D50C\B9AC\D2B8\C5D0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106011456493310281)
,p_name=>'CREATE_APP_WIZ.CANDLE_CHARTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1B\B300 \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106011200789310281)
,p_name=>'CREATE_APP_WIZ.COL_CHARTS'
,p_message_language=>'ko'
,p_message_text=>unistr('2D \BC0F 3D \C5F4, \B9C9\B300 \BC0F \B204\C801 \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106011947494310282)
,p_name=>'CREATE_APP_WIZ.GAUGE_CHARTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C774\C5BC \BC0F \B2E4\C774\C5BC(\D37C\C13C\D2B8) \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106011344322310281)
,p_name=>'CREATE_APP_WIZ.PIE_CHARTS'
,p_message_language=>'ko'
,p_message_text=>unistr('2D \BC0F 3D \D30C\C774 \BC0F \B3C4\B11B \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106011614128310281)
,p_name=>'CREATE_APP_WIZ.PROJECTGANTT_CHARTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C81D\D2B8 \AC04\D2B8 \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106011866502310281)
,p_name=>'CREATE_APP_WIZ.RANGE_CHARTS'
,p_message_language=>'ko'
,p_message_text=>unistr('2D \BC0F 3D \BC94\C704 \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106011759006310281)
,p_name=>'CREATE_APP_WIZ.RESOURCEGANTT_CHARTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9AC\C18C\C2A4 \AC04\D2B8 \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106011502944310281)
,p_name=>'CREATE_APP_WIZ.SCATTER_CHARTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\C0B0 \D45C\C2DC\C790 \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105089227234309534)
,p_name=>'CREATE_CONDITION.AND'
,p_message_language=>'ko'
,p_message_text=>'AND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105089041586309534)
,p_name=>'CREATE_CONDITION.ARROW_DOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\CABD \D654\C0B4\D45C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105089195673309534)
,p_name=>'CREATE_CONDITION.ARROW_RIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD \D654\C0B4\D45C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105088803923309534)
,p_name=>'CREATE_CONDITION.COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105088980674309534)
,p_name=>'CREATE_CONDITION.CONDITIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105089313143309534)
,p_name=>'CREATE_CONDITION.OR'
,p_message_language=>'ko'
,p_message_text=>'OR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105089495396309534)
,p_name=>'CREATE_CONDITION.PREVIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74 \BBF8\B9AC\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105428697528309801)
,p_name=>'CREATE_DEMO_APP.GRANT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\AE08 %0\C5D0\AC8C \D574\B2F9 \AD8C\D55C\C744 \BD80\C5EC\D558\B824\BA74 \C544\B798 <b>\AD8C\D55C \BD80\C5EC</b> \B2E8\CD94\B97C \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105428414879309800)
,p_name=>'CREATE_DEMO_APP.NO_CREATE_PRIV'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) CREATE TABLE, CREATE VIEW, CREATE TRIGGER, CREATE SEQUENCE \B610\B294 CREATE PROCEDURE \AD8C\D55C\C774 \C5C6\ACE0 \B370\BAA8 \C560\D50C\B9AC\CF00\C774\C158\C744 \C124\CE58\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105428504258309801)
,p_name=>'CREATE_DEMO_APP.NO_EXEC_PRIV'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('%0\C740(\B294) CTX_DOC \BC0F CTX_DDL\C5D0 \B300\D55C \C2E4\D589 \AD8C\D55C\C774 \C5C6\ACE0 \B300\D1B5\B839 \CDE8\C784 \C5F0\C124 \B370\BAA8\B97C \C124\CE58\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \AD8C\D55C\C744 \AC00\C9C4 \C0AC\C6A9\C790\B85C \B2E4\C74C \AD8C\D55C \BD80\C5EC\B97C \C218\D589\D558\C2ED\C2DC\C624.'),
'<pre>',
'GRANT EXECUTE ON CTXSYS.CTX_DDL TO %0; ',
'GRANT EXECUTE ON CTXSYS.CTX_DOC TO %0;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105672490710310005)
,p_name=>'CREATE_DIALOG_CLOSED_DA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C0DD\C131 - \B300\D654\C0C1\C790 \B2EB\D798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104905284356309401)
,p_name=>'CREATE_DYNAMIC_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \BAA9\B85D \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105145967486309582)
,p_name=>'CREATE_DYNAMIC_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \AC12 \BAA9\B85D \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104883278863309383)
,p_name=>'CREATE_FLOW.CLOUD_IDM'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Cloud ID \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104922358022309413)
,p_name=>'CREATE_FLOW.DBACCOUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \ACC4\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105563521251309913)
,p_name=>'CREATE_FLOW.HTMLDB_AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('Application Express \C778\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105429043670309801)
,p_name=>'CREATE_FLOW.LDAP'
,p_message_language=>'ko'
,p_message_text=>'LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106067806820310335)
,p_name=>'CREATE_FLOW.NAVIGATION_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \BA54\B274 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105563621383309913)
,p_name=>'CREATE_FLOW.NO_AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105563223295309913)
,p_name=>'CREATE_FLOW.NO_TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105563333273309913)
,p_name=>'CREATE_FLOW.ONE_LEVEL_TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D55C \B808\BCA8\C758 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105429165610309801)
,p_name=>'CREATE_FLOW.SSO'
,p_message_language=>'ko'
,p_message_text=>'SSO(Single Sign On)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105563472703309913)
,p_name=>'CREATE_FLOW.TWO_LEVEL_TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B450 \B808\BCA8\C758 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104984162716309458)
,p_name=>'CREATE_FROM_SPREADSHEET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D504\B808\B4DC\C2DC\D2B8\C5D0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104877858406309379)
,p_name=>'CREATE_GLOBAL_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \D398\C774\C9C0 \AD6C\C131\C694\C18C\B294 \D574\B2F9 \C601\C5ED\C758 \D45C\C2DC \C9C0\C810\C774 \C120\D0DD\D55C \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8 \B0B4\C5D0 \D3EC\D568\B418\B294 \ACBD\C6B0 \BAA8\B4E0 \D398\C774\C9C0\C5D0 \D45C\C2DC\B429\B2C8\B2E4. \C870\AC74\BD80 \D45C\C2DC \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\C9C0 \C54A\B3C4\B85D \D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105114581913309552)
,p_name=>'CREATE_INDEX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B371\C2A4 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105287897004309687)
,p_name=>'CREATE_ITEM_WIZ.NO_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B41C \C601\C5ED \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105095543924309539)
,p_name=>'CREATE_NEW_LOGIN_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \B85C\ADF8\C778 \D398\C774\C9C0 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105090945259309535)
,p_name=>'CREATE_PACKAGE.BACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C0DD\C131 \B9C8\BC95\C0AC\B85C \B3CC\C544\AC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105090433756309535)
,p_name=>'CREATE_PACKAGE.BROWSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D0A4\C9C0 \CC3E\C544\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105090386179309535)
,p_name=>'CREATE_PACKAGE.CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C2A4\D0A4\B9C8\C5D0 "%0" \D328\D0A4\C9C0\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105091093122309535)
,p_name=>'CREATE_PACKAGE.FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D14C\C774\BE14 \C0DD\C131\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105090824198309535)
,p_name=>'CREATE_PACKAGE.HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105090693885309535)
,p_name=>'CREATE_PACKAGE.RETURN_TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3CC\C544\AC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105090710181309535)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL&nbsp;\C6CC\D06C\C20D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105090573561309535)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP_HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C6CC\D06C\C20D \D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105086177573309532)
,p_name=>'CREATE_PAGE_ITEM.NO_ITEM_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C744 \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105085713266309532)
,p_name=>'CREATE_PAGE_ITEM.PAGE_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105086099315309532)
,p_name=>'CREATE_PAGE_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B86C\D504\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105085855801309532)
,p_name=>'CREATE_PAGE_ITEM.REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105085909689309532)
,p_name=>'CREATE_PAGE_ITEM.SET_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED\C744 \C124\C815\D558\B824\BA74 \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105083889956309530)
,p_name=>'CREATE_PROCESS.PAGE_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105083981141309530)
,p_name=>'CREATE_PROCESS.REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105090254930309535)
,p_name=>'CREATE_TABLE.HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105090078006309535)
,p_name=>'CREATE_TABLE.RETURN_TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3CC\C544\AC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105089907028309535)
,p_name=>'CREATE_TABLE.RUN_SCRIPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105089656783309534)
,p_name=>'CREATE_TABLE.SCRIPT_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D14C\C774\BE14\C5D0 \B300\D55C \D14C\C774\BE14 \C0DD\C131 \C2A4\D06C\B9BD\D2B8\AC00 SQL \C2A4\D06C\B9BD\D2B8 \C800\C7A5\C18C\C5D0 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105089730493309534)
,p_name=>'CREATE_TABLE.SCRIPT_REPOSITORY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \C800\C7A5\C18C\B85C \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105090197225309535)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL&nbsp;\C6CC\D06C\C20D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105089864325309535)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP_HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C6CC\D06C\C20D \D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105519444204309877)
,p_name=>'CREATE_TABULAR_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C \D615\C2DD \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106085693028310352)
,p_name=>'CREATE_TO_DO'
,p_message_language=>'ko'
,p_message_text=>unistr('\D560 \C77C \C0DD\C131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105473653621309839)
,p_name=>'CREATE_TRIGGER'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D2B8\B9AC\AC70 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105419966858309793)
,p_name=>'CREATE_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105374446472309753)
,p_name=>'CREDENTIAL.OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\C11C \C18C\C720\C790')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105338876314309727)
,p_name=>'CSS_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105262255785309668)
,p_name=>'CURRENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105331349146309722)
,p_name=>'CURRENT ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105331021132309721)
,p_name=>'CURRENT FORM ELEMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D3FC \C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105105676968309546)
,p_name=>'CURRENT ITEM HELP TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D56D\BAA9 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105331199382309721)
,p_name=>'CURRENT ITEM IDENTIFICATION NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D56D\BAA9 \C2DD\BCC4 \BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105331259240309722)
,p_name=>'CURRENT ITEM LABEL NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D56D\BAA9 \B808\C774\BE14 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105386963748309763)
,p_name=>'CURRENT TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105072258440309522)
,p_name=>'CURRENT_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105079080349309527)
,p_name=>'CURRENT_IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105612526789309952)
,p_name=>'CURRENT_ITEM_CONTAINER_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('[\B808\C774\BE14 \BC0F \D56D\BAA9 \C55E] \C18D\C131\C5D0\C11C \D604\C7AC \D544\B4DC\B97C \B458\B7EC\C2F8\B294 \CEE8\D14C\C774\B108 \C694\C18C\C5D0 \C0AC\C6A9\D560 \C218 \C788\B294 ID\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106090373266310356)
,p_name=>'CURRENT_ITEM_HELP_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D56D\BAA9 \B3C4\C6C0\B9D0 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105040722246309499)
,p_name=>'CURRENT_MILESTONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \B9C8\C77C\C2A4\D1A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105078190050309526)
,p_name=>'CURRENT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105355610051309739)
,p_name=>'CURRENT_PAGE_CONTAINS_NO_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\C5D0 \D3EC\D568\B41C \D56D\BAA9\C774 \C5C6\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105326932650309718)
,p_name=>'CUSTOMIZE LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105886526936310174)
,p_name=>'CUSTOM_APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104904190939309400)
,p_name=>'CUSTOM_AUTH_SCHEME_DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790\AC00 \C815\C758\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105119374455309556)
,p_name=>'CUSTOM_AUTH_SSO_GENERIC_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105040907534309499)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C138\C158 \B3D9\C548 \C0AC\C6A9\C790 \C2DD\BCC4\C790\B85C \C0AC\C6A9\D560 \BB38\C790\C5F4\C744 \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105041057755309499)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_2'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AC\C6A9\C790 \C774\B984 \BC0F \BE44\BC00\BC88\D638\B97C \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105041162041309499)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_3'
,p_message_language=>'ko'
,p_message_text=>unistr('LDAP \D638\C2A4\D2B8\C5D0\C11C \D655\C778\C744 \C704\D55C \C0AC\C6A9\C790 \C774\B984 \BC0F \BE44\BC00\BC88\D638 \C785\B825: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105041205107309500)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_4'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C2A4\D0A4\B9C8 \C0AC\C6A9\C790 \C774\B984 \BC0F \BE44\BC00\BC88\D638\B97C \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105697009760310027)
,p_name=>'CUSTOM_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105702040880310034)
,p_name=>'CUSTOM_CALENDAR.END_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105701927838310034)
,p_name=>'CUSTOM_CALENDAR.START_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105474507758309839)
,p_name=>'DA.SET_VALUE.SQL.HELP_MSG'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>True \C791\C5C5\C774 SQL \BB38\C758 \C124\C815 \C720\D615\C774 \D3EC\D568\B41C \AC12 \C124\C815\C778 \ACBD\C6B0 SQL \BB38\C758 \C5F4 \C21C\C11C\C640 \B3D9\C77C\D55C \C21C\C11C\B85C \C601\D5A5\C744 \BC1B\B294 \C694\C18C\B97C \C815\C758\D574\C57C \D569\B2C8\B2E4. \C815\C758\D55C SQL \BB38\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<pre>%0</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105272159540309675)
,p_name=>'DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105538403369309893)
,p_name=>'DATA WORKSHOP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C6CC\D06C\C20D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105127267330309568)
,p_name=>'DATA.LOAD.ALL_COL_MAPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 %0\AC1C \C5F4\C774 \C790\B3D9\C73C\B85C %1 \D14C\C774\BE14\C5D0 \B9E4\D551\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105128095606309569)
,p_name=>'DATA.LOAD.APPEND_INCOMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('<code>%0</code> \D14C\C774\BE14\C758 \B370\C774\D130\C5D0 <b id="incompl_success_row_count"></b>\AC1C\C758 \C0C8 \D589\C774 \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4. <b class="u-danger-text" id="incompl_fail_row_count"></b>\AC1C \D589\C774 \AC70\BD80\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105127690326309568)
,p_name=>'DATA.LOAD.APPEND_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('<code>%0</code> \D14C\C774\BE14\C758 \B370\C774\D130\C5D0 <b id="success_row_count"></b>\AC1C\C758 \C0C8 \D589\C774 \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105127847858309568)
,p_name=>'DATA.LOAD.APPEND_WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('<code>%0</code> \D14C\C774\BE14\C758 \B370\C774\D130\C5D0 <b id="err_success_row_count"></b>\AC1C\C758 \C0C8 \D589\C774 \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4. <b class="u-danger-text" id="err_fail_row_count"></b>\AC1C \D589\C774 \AC70\BD80\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104880375119309381)
,p_name=>'DATA.LOAD.CHOOSE_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104874943230309376)
,p_name=>'DATA.LOAD.COLUMN_MAPPING_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C5F4 \B9E4\D551\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104917989709309410)
,p_name=>'DATA.LOAD.CONFIGURATION_SAVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C774 \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104879957555309381)
,p_name=>'DATA.LOAD.DATA_PROFILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \D504\B85C\D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104880086756309381)
,p_name=>'DATA.LOAD.DATA_PROFILE_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \D504\B85C\D30C\C77C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104879325514309380)
,p_name=>'DATA.LOAD.DATA_SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105127349486309568)
,p_name=>'DATA.LOAD.DEFINE_COL_MAPPING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B370\C774\D130\B97C %0 \D14C\C774\BE14\B85C \B85C\B4DC\D558\B824\BA74 \C5F4 \B9E4\D551\C744 \C815\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104879852329309380)
,p_name=>'DATA.LOAD.DEFINITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104880213764309381)
,p_name=>'DATA.LOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5EC\AE30\B85C \D30C\C77C \B04C\C5B4 \B193\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104880165312309381)
,p_name=>'DATA.LOAD.FILE_FORMATS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0\B418\B294 \D615\C2DD CSV, XLSX, TXT, XML, JSON')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105536443313309891)
,p_name=>'DATA.LOAD.JOB_INTERMITTENTLY_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C791\C5C5 \C2E4\D589\C774 \C608\AE30\CE58 \C54A\AC8C \C815\C9C0\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105479347764309843)
,p_name=>'DATA.LOAD.JOB_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C791\C5C5, \C791\C5C5\C601\C5ED %0: \D14C\C774\BE14 %1\C5D0 \B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104879544340309380)
,p_name=>'DATA.LOAD.LOADED_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\B4DC\B41C \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105127469767309568)
,p_name=>'DATA.LOAD.MAP_REMAINING_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0/%1\AC1C \C5F4\C774 \C790\B3D9\C73C\B85C %2 \D14C\C774\BE14\C5D0 \B9E4\D551\B418\C5C8\C2B5\B2C8\B2E4. \B0A8\C740 %3\AC1C \C5F4\C744 \AD6C\C131\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105517584412309875)
,p_name=>'DATA.LOAD.PASTED_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD99\C5EC\B123\C740 \B370\C774\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105128147281309569)
,p_name=>'DATA.LOAD.REPLACE_INCOMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('<code>%0</code> \D14C\C774\BE14\C758 \B370\C774\D130\AC00 <b id="incompl_success_row_count"></b>\AC1C\C758 \C0C8 \D589\C73C\B85C \BC14\B00C\C5C8\C2B5\B2C8\B2E4. <b class="u-danger-text" id="incompl_fail_row_count"></b>\AC1C \D589\C774 \AC70\BD80\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105127768428309568)
,p_name=>'DATA.LOAD.REPLACE_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('<code>%0</code> \D14C\C774\BE14\C758 \B370\C774\D130\AC00 <b id="success_row_count"></b>\AC1C\C758 \C0C8 \D589\C73C\B85C \BC14\B00C\C5C8\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105127988014309569)
,p_name=>'DATA.LOAD.REPLACE_WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('<code>%0</code> \D14C\C774\BE14\C758 \B370\C774\D130\AC00 <b id="err_success_row_count"></b>\AC1C\C758 \C0C8 \D589\C73C\B85C \BC14\B00C\C5C8\C2B5\B2C8\B2E4. <b class="u-danger-text" id="err_fail_row_count"></b>\AC1C \D589\C774 \AC70\BD80\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105127542671309568)
,p_name=>'DATA.LOAD.SELECT_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\B4DC\D560 \C5F4\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104860428916309363)
,p_name=>'DATA.LOAD.SUPPORTED_FORMATS_N'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0\B418\B294 \D615\C2DD %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104879428535309380)
,p_name=>'DATA.LOAD.UPLOAD_A_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C5C5\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104879675515309380)
,p_name=>'DATA.LOAD.XLSX_WORKSHEET'
,p_message_language=>'ko'
,p_message_text=>unistr('XLSX \C6CC\D06C\C2DC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106079790700310346)
,p_name=>'DATABASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105539070967309893)
,p_name=>'DATABASE BROWSER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \BE0C\B77C\C6B0\C800')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106024841234310294)
,p_name=>'DATABASE.DEMO.SAMPLE.APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0D8\D50C \B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106079885701310346)
,p_name=>'DATABASE_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104923826174309414)
,p_name=>'DATABASE_APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104939406518309425)
,p_name=>'DATABASE_APPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105414647490309789)
,p_name=>'DATABASE_APP_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong> \C560\D50C\B9AC\CF00\C774\C158\C774 \C131\ACF5\C801\C73C\B85C \C124\CE58\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105317387430309711)
,p_name=>'DATABASE_LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105366801750309748)
,p_name=>'DATABASE_OBJECT_COUNTS_BY_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4 \C720\D615\BCC4 \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105370068803309750)
,p_name=>'DATABASE_ROLE_PRIVILEGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \B864 \AD8C\D55C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104935147780309422)
,p_name=>'DATABASE_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105468834784309835)
,p_name=>'DATA_GRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \ADF8\B9AC\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106014793917310284)
,p_name=>'DATA_GRIDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \ADF8\B9AC\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106015102036310285)
,p_name=>'DATA_GRID_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \ADF8\B9AC\B4DC \B370\C774\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106001655247310272)
,p_name=>'DATA_LOAD.ADVANCED_SETTINGS_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \ACE0\AE09 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105014800542309480)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\D560 \B0A0\C9DC/\C22B\C790 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105014948850309481)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \D615\C2DD \B9C8\C2A4\D06C\B97C \C81C\ACF5\D560\C9C0 \B610\B294 \D45C\C900 \D615\C2DD \B9C8\C2A4\D06C\B97C \C0AC\C6A9\D560\C9C0 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104935538790309423)
,p_name=>'DATA_LOAD.CHARSET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \BB38\C790\C138\D2B8 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105528282897309885)
,p_name=>'DATA_LOAD.COLUMN_NAMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105412763836309782)
,p_name=>'DATA_LOAD.COLUMN_NAME_ALIASES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984 \BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105667615189310001)
,p_name=>'DATA_LOAD.CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\AC00 \D14C\C774\BE14\C5D0 \C131\ACF5\C801\C73C\B85C \C5C5\B85C\B4DC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105673198928310006)
,p_name=>'DATA_LOAD.COPY_PASTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC \BC0F \BD99\C5EC\B123\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105662018232309996)
,p_name=>'DATA_LOAD.COPY_PASTE_TEXTAREA'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \B370\C774\D130 \BCF5\C0AC \BC0F \BD99\C5EC\B123\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106044108787310313)
,p_name=>'DATA_LOAD.CURRENCY_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\D654 \AE30\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106044256112310313)
,p_name=>'DATA_LOAD.CURRENCY_ITEM_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\AC00 \AD6D\C81C \D1B5\D654 \AE30\D638\B97C \D3EC\D568\D558\B294 \ACBD\C6B0 \C5EC\AE30\C5D0 \D574\B2F9 \AE30\D638\B97C \C785\B825\D558\C2ED\C2DC\C624. \C608\B97C \B4E4\C5B4, \B370\C774\D130\AC00 "&euro;1,234.56" \B610\B294 "&yen;1,234.56"\C744 \D3EC\D568\D558\B294 \ACBD\C6B0 "&euro;" \B610\B294 "&yen;"\C744 \C785\B825\D558\C2ED\C2DC\C624. \ADF8\B807\C9C0 \C54A\C73C\BA74 \B370\C774\D130\AC00 \C81C\B300\B85C \B85C\B4DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104940249554309426)
,p_name=>'DATA_LOAD.DATA_LOADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106001709564310272)
,p_name=>'DATA_LOAD.DATE_FORMAT_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D45C\C900 \D615\C2DD \B9C8\C2A4\D06C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106001875753310272)
,p_name=>'DATA_LOAD.DATE_FORMAT_CUSTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B85C\B4DC\B41C \C5F4\C5D0 \B300\D55C \C0AC\C6A9\C790\C815\C758 \D615\C2DD \C81C\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106045489637310314)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C18C\C218\C810 \BB38\C790\B294 \C22B\C790\C758 \C815\C218 \BD80\BD84\ACFC \C18C\C218 \BD80\BD84\C744 \AD6C\BD84\D569\B2C8\B2E4.</p>'),
unistr('<p> \C18C\C218\C810 \BB38\C790\B85C \C5B4\B5A4 \BB38\C790\B4E0 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \C18C\C218\C810 \BB38\C790\B294 \B2E8\C77C \BC14\C774\D2B8\B85C \C9C0\C815\D574\C57C \D558\ACE0 \ADF8\B8F9 \AD6C\BD84 \AE30\D638\C640 \B2EC\B77C\C57C \D569\B2C8\B2E4. \ACF5\BC31\C740 \BB38\C790\B85C \AC04\C8FC\D558\C9C0\B9CC \C22B\C790\B098 \B2E4\C74C \BB38\C790\B294 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</p>'),
'<ul class="noIndent">',
unistr('<li>\D50C\B7EC\C2A4 \AE30\D638(+)</li>'),
unistr('<li>\D558\C774\D508(-)</li> '),
unistr('<li>\C5EC\B294 \AEBE\C1E0 \AE30\D638(<)</li>'),
unistr('<li>\B2EB\B294 \AEBE\C1E0 \AE30\D638(>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106044588137310313)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C218\C810 \BB38\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105043480471309501)
,p_name=>'DATA_LOAD.DECIMAL_CHAR_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D14C\C774\BE14 \C5F4\C5D0 \B300\D574 \ADF8\B8F9 \AD6C\BD84 \AE30\D638\AC00 \C815\C758\B41C \ACBD\C6B0 \C18C\C218\C810 \BB38\C790\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105412906881309782)
,p_name=>'DATA_LOAD.DISPLAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105479482264309843)
,p_name=>'DATA_LOAD.DUPLICATE_MAPPING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5EC\B7EC \C18C\C2A4 \C5F4\C774 %0 \D14C\C774\BE14 \C5F4\C5D0 \B9E4\D551\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105810868924310116)
,p_name=>'DATA_LOAD.FAILED_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D328\D55C \D589:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106026262213310296)
,p_name=>'DATA_LOAD.FAILED_RECORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D328\D55C \B808\CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106043720287310313)
,p_name=>'DATA_LOAD.FILE_NAME_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B85C\B4DC\D560 \D30C\C77C\C758 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105670200581310003)
,p_name=>'DATA_LOAD.FIRST_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8 \D589\C5D0 \C5F4 \C774\B984\C774 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106043843851310313)
,p_name=>'DATA_LOAD.FIRST_ROW_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\C758 \CCAB\BC88\C9F8 \D589\C5D0 \C5F4 \C774\B984\C774 \D3EC\D568\B418\C5B4 \C788\C73C\BA74 \C774 \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106044063031310313)
,p_name=>'DATA_LOAD.GLOBALIZATION_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106044462314310313)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\ADF8\B8F9 \AD6C\BD84 \AE30\D638\B294 \C815\C218 \ADF8\B8F9\C744 \AD6C\BD84\D558\B294 \BB38\C790\C785\B2C8\B2E4. \C608\B97C \B4E4\BA74, \CC9C \B2E8\C704 \BC0F \BC31\B9CC \B2E8\C704\B97C \D45C\C2DC\D558\B294 \BB38\C790\C785\B2C8\B2E4.</p>'),
unistr('<p>\ADF8\B8F9 \AD6C\BD84 \AE30\D638\B85C \C5B4\B5A4 \BB38\C790\B4E0 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \ADF8\B8F9 \AD6C\BD84 \AE30\D638\B294 \B2E8\C77C \BC14\C774\D2B8\B85C \C9C0\C815\D574\C57C \D558\ACE0 \C18C\C218\C810 \BB38\C790\C640 \B2EC\B77C\C57C \D569\B2C8\B2E4. \ACF5\BC31\C740 \BB38\C790\B85C \AC04\C8FC\D558\C9C0\B9CC \C22B\C790\B098 \B2E4\C74C \BB38\C790\B294 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</p>'),
'<ul class="noIndent">',
unistr('<li>\D50C\B7EC\C2A4 \AE30\D638(+)</li>'),
unistr('<li>\D558\C774\D508(-)</li> '),
unistr('<li>\C5EC\B294 \AEBE\C1E0 \AE30\D638(<)</li>'),
unistr('<li>\B2EB\B294 \AEBE\C1E0 \AE30\D638(>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106044344409310313)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AD6C\BD84 \AE30\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105810673988310116)
,p_name=>'DATA_LOAD.INSERTED_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0BD\C785\B41C \D589:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106041209344310310)
,p_name=>'DATA_LOAD.IR_MAX_ROW_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C9C8\C758\B294 #MAX_ROW_COUNT#\AC1C \C774\C0C1\C758 \D589\C744 \BC18\D658\D569\B2C8\B2E4. \BCF4\B2E4 \C815\D655\D55C \ACB0\ACFC\B97C \C5BB\C73C\B824\BA74 \B370\C774\D130\B97C \D544\D130\B9C1\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105411640041309781)
,p_name=>'DATA_LOAD.JUSTCHANGED_RECORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \C0AC\C6A9\C790\AC00 \BCC0\ACBD\D55C \B808\CF54\B4DC\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105034855256309495)
,p_name=>'DATA_LOAD.LABEL_CASE_SENSITIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C18C\BB38\C790 \AD6C\BD84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105034726453309495)
,p_name=>'DATA_LOAD.LABEL_UNIQUE_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105633786330309971)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C2E4\D328')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105633879034309971)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C774 \CC98\B9AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105657815438309992)
,p_name=>'DATA_LOAD.LOAD_TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C784\D3EC\D2B8 \CD9C\CC98')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105467030141309833)
,p_name=>'DATA_LOAD.MAPPING_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\ACC4 2 - \D398\C774\C9C0 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106092186711310358)
,p_name=>'DATA_LOAD.NO_PREVIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \AC00\B2A5\D55C \D30C\C77C \BBF8\B9AC\BCF4\AE30 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106042953542310312)
,p_name=>'DATA_LOAD.OPTIONAL_ENCLOSE_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\C801 \B458\B7EC\C2F8\AE30 \BB38\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106005105591310275)
,p_name=>'DATA_LOAD.PROGRESS_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \B9C8\BC95\C0AC \C9C4\D589 \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105467276924309833)
,p_name=>'DATA_LOAD.RESULTS_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\ACC4 4 - \D398\C774\C9C0 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105412865879309782)
,p_name=>'DATA_LOAD.RETURN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3CC\C544\AC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105411105927309780)
,p_name=>'DATA_LOAD.REVIEW_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\D1A0\D560 \D589:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105525397234309882)
,p_name=>'DATA_LOAD.RULES_PLSQL_EXPRESSION_EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'to_char(sysdate)',
'',
'my_func (',
'    p_1 => :SAL,',
'    p_2 => :COMM)',
'',
unistr('\C5EC\AE30\C11C SAL \BC0F COMM\C740 \C5C5\B85C\B4DC\B41C \B370\C774\D130\C758 \C5F4 \C774\B984\C774\BA70'),
unistr('my_func\B294 \C774 \BCC0\D658 \ADDC\CE59\C774 \C815\C758\B41C \C5F4\C5D0 \B300\D55C \C0C8 \AC12\C774 \B418\B294 \AC12\C744'),
unistr('\BC18\D658\D558\B294 \D568\C218\C785\B2C8\B2E4.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105525584393309882)
,p_name=>'DATA_LOAD.RULES_PLSQL_FUNCTION_EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_result number;',
'begin',
'    l_result := :SAL * :COMM;',
'    return l_result;',
'end;',
'',
unistr('\C5EC\AE30\C11C\B3C4 \BC18\D658\B41C \ACB0\ACFC\B294 \C774 \BCC0\D658 \ADDC\CE59\C774 \C815\C758\B41C \C5F4\C758 \C0C8 \AC12\C774 \B429\B2C8\B2E4.'),
'',
unistr(':SAL \BC0F :COMM\C740 \C5C5\B85C\B4DC\B41C \B370\C774\D130\C758 SAL \BC0F COMM \C5F4 \C774\B984\C744 \CC38\C870\D569\B2C8\B2E4.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105525442804309882)
,p_name=>'DATA_LOAD.RULES_SQL_QUERY_EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select depno',
' from dept',
'where dname = :DEPTNAME',
'  and loc   = :LOC',
'',
unistr('\C5EC\AE30\C11C :DEPNAME \BC0F :LOC\B294 \C5C5\B85C\B4DC\B41C \B370\C774\D130\C758 DEPNAME \BC0F LOC \C5F4 \C774\B984\C744 \CC38\C870\D569\B2C8\B2E4.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105051594071309507)
,p_name=>'DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D14C\C774\BE14 \C5F4\C5D0\C11C \B3D9\C77C\D55C \BB38\C790\B97C \ADF8\B8F9 \AD6C\BD84 \AE30\D638\C640 \C18C\C218\C810 \BB38\C790\B85C \C815\C758\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \B2E4\B978 \BB38\C790\B97C \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106042736476310312)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AD6C\BD84 \AE30\D638\B97C \C9C0\C815\D558\C2ED\C2DC\C624. \D0ED \AD6C\BD84 \AE30\D638\B85C\B294 <code>\005Ct</code>\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106042809189310312)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \AE30\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105413000764309782)
,p_name=>'DATA_LOAD.SEQUENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106001480877310272)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09 \C124\C815 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106001545886310272)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC\C5D0 \B300\D55C \ACE0\AE09 \C124\C815 \D45C\C2DC: \D1B5\D654 \AE30\D638, \C18C\C218\C810 \BB38\C790, \D30C\C77C \C778\CF54\B529 \B610\B294 \B0A0\C9DC \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105677761581310010)
,p_name=>'DATA_LOAD.SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105466916983309833)
,p_name=>'DATA_LOAD.SOURCE_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\ACC4 1 - \D398\C774\C9C0 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106080068614310347)
,p_name=>'DATA_LOAD.TAB_SEPARTOR_NOTE'
,p_message_language=>'ko'
,p_message_text=>unistr('(\D0ED\C758 \ACBD\C6B0 \005Ct)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106041502722310310)
,p_name=>'DATA_LOAD.UNIQUE_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \C5F4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105810765159310116)
,p_name=>'DATA_LOAD.UPDATED_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8\B41C \D589:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106121375520310384)
,p_name=>'DATA_LOAD.UPLOADED_NULL_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \AC12\C774 \C5C5\B85C\B4DC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105673073856310006)
,p_name=>'DATA_LOAD.UPLOAD_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C5C5\B85C\B4DC(\CF64\B9C8 \AD6C\BD84(*.csv) \B610\B294 \D0ED \AD6C\BD84)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105677929815310010)
,p_name=>'DATA_LOAD.UPLOAD_RESULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \ACB0\ACFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105677874428310010)
,p_name=>'DATA_LOAD.VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \AC80\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105467125464309833)
,p_name=>'DATA_LOAD.VALIDATION_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\ACC4 3 - \D398\C774\C9C0 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105471235361309836)
,p_name=>'DATA_LOAD_WIZARD_CREATED_SUCCESSFULLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \B9C8\BC95\C0AC \D398\C774\C9C0\AC00 \C131\ACF5\C801\C73C\B85C \C791\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105633932579309971)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130/\D14C\C774\BE14 \B9E4\D551 \C2E4\D328')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105634052400309971)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C774 \CC98\B9AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105340069130309728)
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C5C5\B85C\B4DC \C5F4 \B9E4\D551')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105064801128309517)
,p_name=>'DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C720\D615: %0 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104926619062309416)
,p_name=>'DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C218\C810 \BB38\C790: \C5F4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104926876699309416)
,p_name=>'DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \B9C8\C2A4\D06C: \C5F4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104926771615309416)
,p_name=>'DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AD6C\BD84 \AE30\D638: \C5F4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104927060995309416)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\D551 \B300\C0C1: \C5F4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105113978993309552)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \AE38\C774: %0 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104926997938309416)
,p_name=>'DATA_WORKSHOP.CONFIGURE.UNMAPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('- \B9E4\D551\B418\C9C0 \C54A\C740 \C5F4 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105460174372309828)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D56D\BAA9\C5D0 \B300\D574 \C785\B825\B41C \AC15\C870 \D45C\C2DC\B41C \B0A0\C9DC \C18D\C131\AC12 %0\C774(\AC00) %2 \D615\C2DD\ACFC \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105465361335309832)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID_RELATIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D56D\BAA9\C5D0 \B300\D574 \C785\B825\B41C \AC15\C870 \D45C\C2DC\B41C \B0A0\C9DC \C18D\C131\AC12 %0\C774(\AC00) \C801\D569\D55C \B0A0\C9DC\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105460301311309828)
,p_name=>'DATEPICKER.MAX_DATE_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D56D\BAA9\C5D0 \B300\D574 \C785\B825\B41C \CD5C\B300 \B0A0\C9DC \C18D\C131\AC12 %0\C774(\AC00) %2 \D615\C2DD\ACFC \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105465550721309832)
,p_name=>'DATEPICKER.MAX_DATE_INVALID_RELATIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D56D\BAA9\C5D0 \B300\D574 \C785\B825\B41C \CD5C\B300 \B0A0\C9DC \C18D\C131\AC12 %0\C774(\AC00) \C801\D569\D55C \B0A0\C9DC\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104877691126309378)
,p_name=>'DATEPICKER.MAX_STATIC_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D56D\BAA9\C5D0 \B300\D574 \C785\B825\B41C \CD5C\B300 \C815\C801 \C18D\C131\AC12 %0\C774(\AC00) %2 \D615\C2DD\ACFC \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105460291011309828)
,p_name=>'DATEPICKER.MIN_DATE_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D56D\BAA9\C5D0 \B300\D574 \C785\B825\B41C \CD5C\C18C \B0A0\C9DC \C18D\C131\AC12 %0\C774(\AC00) %2 \D615\C2DD\ACFC \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105465484572309832)
,p_name=>'DATEPICKER.MIN_DATE_INVALID_RELATIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D56D\BAA9\C5D0 \B300\D574 \C785\B825\B41C \CD5C\C18C \B0A0\C9DC \C18D\C131\AC12 %0\C774(\AC00) \C801\D569\D55C \B0A0\C9DC\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104877591766309378)
,p_name=>'DATEPICKER.MIN_STATIC_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D56D\BAA9\C5D0 \B300\D574 \C785\B825\B41C \CD5C\C18C \C815\C801 \C18D\C131\AC12 %0\C774(\AC00) %2 \D615\C2DD\ACFC \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105567496098309916)
,p_name=>'DATE_ADDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00\B41C \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106012175701310282)
,p_name=>'DATE_OF_LAST_RUN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9 \C2E4\D589 \C2DC\AC04\C744 \D3EC\D568\D558\B294 Oracle APEX \B370\C774\D130\BCA0\C774\C2A4 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105389917655309765)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C885 \B9C8\C77C\C2A4\D1A4\AE4C\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105390029671309765)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE_OF_RELASE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B9B4\B9AC\C2A4\C758 \CD5C\C885 \B9C8\C77C\C2A4\D1A4\AE4C\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105464729063309831)
,p_name=>'DA_NAME.NATIVE_ADD_CLASS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B798\C2A4 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106017542419310287)
,p_name=>'DA_NAME.NATIVE_ALERT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106016323824310286)
,p_name=>'DA_NAME.NATIVE_CANCEL_EVENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106017755513310287)
,p_name=>'DA_NAME.NATIVE_CLEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6B0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106017646380310287)
,p_name=>'DA_NAME.NATIVE_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104857045429309360)
,p_name=>'DA_NAME.NATIVE_DIALOG_CANCEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104857120968309360)
,p_name=>'DA_NAME.NATIVE_DIALOG_CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \B2EB\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105009039680309476)
,p_name=>'DA_NAME.NATIVE_DISABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105008975342309476)
,p_name=>'DA_NAME.NATIVE_ENABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106009227988310279)
,p_name=>'DA_NAME.NATIVE_EXECUTE_PLSQL_CODE'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \CF54\B4DC \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105008866647309476)
,p_name=>'DA_NAME.NATIVE_HIDE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105385241297309761)
,p_name=>'DA_NAME.NATIVE_JAVASCRIPT_CODE'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \CF54\B4DC \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105639443234309976)
,p_name=>'DA_NAME.NATIVE_REFRESH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C\ACE0\CE68')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105464818383309831)
,p_name=>'DA_NAME.NATIVE_REMOVE_CLASS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B798\C2A4 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105464936758309832)
,p_name=>'DA_NAME.NATIVE_SET_CSS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0C0\C77C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105622389570309960)
,p_name=>'DA_NAME.NATIVE_SET_FOCUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\CEE4\C2A4 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105385115999309761)
,p_name=>'DA_NAME.NATIVE_SET_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105008757490309476)
,p_name=>'DA_NAME.NATIVE_SHOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105622440178309960)
,p_name=>'DA_NAME.NATIVE_SUBMIT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105603901140309945)
,p_name=>'DA_NAME.NATIVE_TREE_COLLAPSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC \CD95\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105603807653309945)
,p_name=>'DA_NAME.NATIVE_TREE_EXPAND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC \D655\C7A5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104906360741309401)
,p_name=>'DBACCOUNT_AUTH_SCHEME_DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \ACC4\C815')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105381808432309759)
,p_name=>'DB_COLS_CASE_SEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14 \BC0F \C5F4 \C774\B984\C740 \B300\C18C\BB38\C790\B97C \AD6C\BD84\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105481569853309845)
,p_name=>'DB_OBJECT_CREATION_EXCEPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('DB \AC1D\CCB4 \C0DD\C131 \C608\C678\C0AC\D56D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104919967936309411)
,p_name=>'DB_PRODUCT_NAME'
,p_message_language=>'ko'
,p_message_text=>'Oracle Database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106070298199310337)
,p_name=>'DB_SERVICES_ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106066997204310334)
,p_name=>'DB_SERVICES_ALL_MIMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 MIME')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106069906418310337)
,p_name=>'DB_SERVICES_CREATE_HANDLER'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\AE30 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106067235361310334)
,p_name=>'DB_SERVICES_CREATE_METHOD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131 \BC29\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106067084549310334)
,p_name=>'DB_SERVICES_CREATE_PARAMETER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106067113102310334)
,p_name=>'DB_SERVICES_CREATE_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106074186731310341)
,p_name=>'DB_SERVICES_DB_SERVICES_MODULE'
,p_message_language=>'ko'
,p_message_text=>unistr('RESTful \C11C\BE44\C2A4 \BAA8\B4C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106069889124310337)
,p_name=>'DB_SERVICES_HANDLER'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106074645362310341)
,p_name=>'DB_SERVICES_HANDLER_BIND_VARIABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\AE30 \BC14\C778\B4DC \BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106047030381310316)
,p_name=>'DB_SERVICES_HANDLER_METHOD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\AE30 \BA54\C18C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106074978501310342)
,p_name=>'DB_SERVICES_HANDLER_SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\AE30 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106047166850310316)
,p_name=>'DB_SERVICES_HANDLER_SRC_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\AE30 \C18C\C2A4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106066734292310334)
,p_name=>'DB_SERVICES_METHOD'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C18C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106074211451310341)
,p_name=>'DB_SERVICES_MODULE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4C8 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106074723792310341)
,p_name=>'DB_SERVICES_MODULE_URI'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4C8 URI \C811\B450\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106067392831310334)
,p_name=>'DB_SERVICES_NO_SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106066674081310334)
,p_name=>'DB_SERVICES_PARAMETER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106074427167310341)
,p_name=>'DB_SERVICES_RESTFUL_SERVICES'
,p_message_language=>'ko'
,p_message_text=>unistr('RESTful \C11C\BE44\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106066831381310334)
,p_name=>'DB_SERVICES_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106074884235310341)
,p_name=>'DB_SERVICES_TEMPLATE_URI'
,p_message_language=>'ko'
,p_message_text=>unistr('URI \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106046987033310316)
,p_name=>'DB_SERVICES_URI'
,p_message_language=>'ko'
,p_message_text=>'URI(Uniform Resource Identifier)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106073965569310341)
,p_name=>'DB_SERVICES_URI_PRIFIX'
,p_message_language=>'ko'
,p_message_text=>unistr('URI \C811\B450\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106074033544310341)
,p_name=>'DB_SERVICES_URI_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('URI \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106047250696310316)
,p_name=>'DB_SERVICE_QUERY_ONE_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C \D589 \C9C8\C758')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105291178964309689)
,p_name=>'DEBUG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B514\BC84\ADF8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105397562112309770)
,p_name=>'DECLINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC70\BD80\B428')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106119814116310383)
,p_name=>'DEFAULT_DIALOGBTNR_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \B300\D654\C0C1\C790 \B2E8\CD94 \C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106119798936310383)
,p_name=>'DEFAULT_DIALOGR_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \B300\D654\C0C1\C790 \CF58\D150\CE20 \C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105634674876309971)
,p_name=>'DEFAULT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105276968190309679)
,p_name=>'DEFAULT_TABLESPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D14C\C774\BE14\C2A4\D398\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105278556830309680)
,p_name=>'DEFAULT_TABLESPACE_INIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D14C\C774\BE14\C2A4\D398\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105527083603309884)
,p_name=>'DEFAULT_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D15C\D50C\B9AC\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104902372829309399)
,p_name=>'DEFINED_BY_DA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5\C5D0 \C758\D574 \C815\C758\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105693399178310023)
,p_name=>'DEFINED_TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C %0\AC1C\C758 \D0ED\C774 %1\AC1C\C758 \D0ED \C9D1\D569\C73C\B85C \AD6C\C131\B418\C5C8\C73C\BA70, \C815\C758\B41C \C0C1\C704 \D0ED\C774 %2\AC1C \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105145863705309582)
,p_name=>'DEFINE_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105327019289309718)
,p_name=>'DEFINITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105479244618309843)
,p_name=>'DEINSTALLATION_SCRIPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58 \C81C\AC70 \C2A4\D06C\B9BD\D2B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104997586351309468)
,p_name=>'DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106014256183310284)
,p_name=>'DELETE_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105519505501309877)
,p_name=>'DELETE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105511783928309871)
,p_name=>'DELETE_LINK_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104929590927309418)
,p_name=>'DELETE_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C0AD\C81C \C791\C5C5\C744 \C218\D589\D558\ACA0\C2B5\B2C8\AE4C?')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104953865425309436)
,p_name=>'DEMO.COLLECT.DESCR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C74C \C804\C2DC\B97C \C0AC\C6A9\D558\BA74 Oracle APEX \C138\C158 \B0B4\C5D0 \C0AC\C6A9\D558\B3C4\B85D \B370\C774\D130 \D589\C744 \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C\B294 PL/SQL\C744 \C0AC\C6A9\D558\C5EC \BAA8\C74C \AE30\BC18 \C138\C158 \C0C1\D0DC\B97C \C0DD\C131 \BC0F \AD00\B9AC\D558\B294 \BC29\BC95\C744 \BCF4\C5EC \C90D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104953660284309436)
,p_name=>'DEMO.SAMPLE.APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104953758259309436)
,p_name=>'DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'ko'
,p_message_text=>unistr('Product Portal\C740 \ACF5\D1B5 \B514\C790\C778 \AC1C\B150\C744 \BCF4\C5EC \C8FC\B294 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158\C785\B2C8\B2E4. \C5EC\AE30\C5D0\C11C\B294 \ACE0\AC1D, \C81C\D488 \BC0F \C8FC\BB38\C5D0 \B300\D55C \C804\C6A9 \D398\C774\C9C0\B97C \D3EC\D568\D560 \BFD0\B9CC \C544\B2C8\B77C \BCF4\ACE0\C11C, \CC28\D2B8, \B2EC\B825, \B9F5 \BC0F \D2B8\B9AC \C0AC\C6A9\C744 \BCF4\C5EC \C90D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105347903612309734)
,p_name=>'DEMONSTRABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\BAA8 \AC00\B2A5 \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105074639706309524)
,p_name=>'DEMO_APPLICATION.ABOUT_BUSINESS_LOOK'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\B825\D55C \AE30\B2A5\C744 \C81C\ACF5\D558\B294 \BCF4\ACE0\C11C \BC0F \D398\C774\C9C0 \BC88\D638 \B9E4\AE30\AE30 \AC1C\B150\C5D0 \B300\D55C \C608\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105074354636309523)
,p_name=>'DEMO_APPLICATION.ABOUT_PETSTORE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C744(\B97C) \C0AC\C6A9\D558\C5EC \C0DD\C131\B41C \C628\B77C\C778 \C800\C7A5\C18C\C5D0 \B300\D55C \C608\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105075004613309524)
,p_name=>'DEMO_APPLICATION.ABOUT_PRESIDENTIAL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C744 \C0AC\C6A9\D558\C5EC Oracle Text\B97C \C0AC\C6A9\D558\B294 \BC29\BC95\C744 \C775\D788\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105075444998309524)
,p_name=>'DEMO_APPLICATION.ABOUT_PROJ_TRACKING'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C744(\B97C) \C0AC\C6A9\D558\C5EC \C0DD\C131\B41C \D504\B85C\C81D\D2B8 \C0C1\D0DC \CD94\C801 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \C608\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105074873750309524)
,p_name=>'DEMO_APPLICATION.ABOUT_WEBSERVICES'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C744(\B97C) \C0AC\C6A9\D558\C5EC \C6F9 \C11C\BE44\C2A4 \C0AC\C6A9 \BC29\BC95\C744 \C775\D788\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105073277520309523)
,p_name=>'DEMO_APPLICATION.ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105071132202309521)
,p_name=>'DEMO_APPLICATION.APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105070865078309521)
,p_name=>'DEMO_APPLICATION.BASIC_LEXER'
,p_message_language=>'ko'
,p_message_text=>'BASIC_LEXER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105074558753309524)
,p_name=>'DEMO_APPLICATION.BUSINESS_LOOK'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C988\B2C8\C2A4 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105073376244309523)
,p_name=>'DEMO_APPLICATION.COLLECTION_SHOWCASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C74C \C804\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105070961417309521)
,p_name=>'DEMO_APPLICATION.CONTEXT_INDEX'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE8\D14D\C2A4\D2B8 \C778\B371\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105070386524309520)
,p_name=>'DEMO_APPLICATION.CREATE_BASIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C608\C81C \B370\BAA8 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\B824\ACE0 \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105068932850309519)
,p_name=>'DEMO_APPLICATION.CREATE_BUSINESS_LOOK'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C988\B2C8\C2A4 \BCF4\AE30 \B370\BAA8 \C560\D50C\B9AC\CF00\C774\C158\C744 (\C7AC)\C0DD\C131\D558\B824\ACE0 \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105070494130309521)
,p_name=>'DEMO_APPLICATION.CREATE_COLLECTION_SHOWCASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C74C \C804\C2DC \B370\BAA8 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\B824\ACE0 \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105070593850309521)
,p_name=>'DEMO_APPLICATION.CREATE_OR_RECREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C2A4\D0A4\B9C8\C5D0\C11C (\C7AC)\C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105068862511309519)
,p_name=>'DEMO_APPLICATION.CREATE_WEB_SERVICES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4\B97C \C2DC\C5F0\D560 \C608\C81C \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105069072220309520)
,p_name=>'DEMO_APPLICATION.CREATE_WORLDCUP_MANIA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4\B4DC\CEF5 \B9E4\B2C8\C544 \B370\BAA8 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\B824\ACE0 \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104910092760309404)
,p_name=>'DEMO_APPLICATION.DEINSTALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105073048114309522)
,p_name=>'DEMO_APPLICATION.DEMO_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\BAA8 \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105071496598309521)
,p_name=>'DEMO_APPLICATION.FREE_SPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \AC00\B2A5\D55C \ACF5\AC04\C740 \C57D %0MB\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105073860122309523)
,p_name=>'DEMO_APPLICATION.INSTALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105073515966309523)
,p_name=>'DEMO_APPLICATION.INSTALLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105205504443309626)
,p_name=>'DEMO_APPLICATION.INSTALL_DEMO_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C758 \C8FC\C694 \AE30\B2A5\C744 \BCF4\C5EC\C8FC\B294 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158\C744 \C124\CE58\D558\B824\ACE0 \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105074404885309523)
,p_name=>'DEMO_APPLICATION.INSTALL_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\AE08 \C124\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105073462196309523)
,p_name=>'DEMO_APPLICATION.LEARN_ABOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C1FC\D551 \CE74\D2B8 \AC1C\B150\C744 \C775\D788\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105514568806309873)
,p_name=>'DEMO_APPLICATION.LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105071298083309521)
,p_name=>'DEMO_APPLICATION.NEED_7M'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D1B5\B839 \CDE8\C784 \C5F0\C124 \B370\BAA8\B294 7MB \C815\B3C4\C758 \C0AC\C6A9 \AC00\B2A5\D55C \B514\C2A4\D06C \ACF5\AC04\C744 \D544\C694\B85C \D558\BA70 \C2A4\D0A4\B9C8\C5D0 \C124\CE58\D558\B294 \B370 \CD5C\B300 2\BD84\C774 \AC78\B9B4 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105205221609309626)
,p_name=>'DEMO_APPLICATION.NOT_ENOUGH_SPACE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B370\BAA8\B97C \C0DD\C131\D558\AE30 \C704\D55C \ACF5\AC04\C774 \BD80\C871\D569\B2C8\B2E4. \AD00\B9AC \D398\C774\C9C0\B85C \C774\B3D9\D558\C5EC \CD94\AC00 \C800\C7A5 \C601\C5ED\C744 \C694\CCAD\D558\ACE0 \B4F1\B85D \C11C\BE44\C2A4\B85C \C774\B3D9\D55C \B2E4\C74C \CD94\AC00 \C800\C7A5 \C601\C5ED\C744 \C694\CCAD\D558\B294 \B9C1\D06C\B97C \B204\B974\C2ED\C2DC\C624. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105073730206309523)
,p_name=>'DEMO_APPLICATION.NOT_INSTALLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105069739714309520)
,p_name=>'DEMO_APPLICATION.OBJECT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C874\C7AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105068610954309519)
,p_name=>'DEMO_APPLICATION.OBJECT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C874\C7AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105069626415309520)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105070767436309521)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME2'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105068754982309519)
,p_name=>'DEMO_APPLICATION.OBJECT_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C874\C7AC\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105069398706309520)
,p_name=>'DEMO_APPLICATION.OBJECT_RECREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\AC00 \C874\C7AC\D558\B294 \ACBD\C6B0 \C7AC\C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105069506132309520)
,p_name=>'DEMO_APPLICATION.OBJECT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105070236832309520)
,p_name=>'DEMO_APPLICATION.PACKAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D0A4\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105074203557309523)
,p_name=>'DEMO_APPLICATION.PETSTORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3AB \C2A4\D1A0\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105074949587309524)
,p_name=>'DEMO_APPLICATION.PRESIDENTIAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D1B5\B839 \CDE8\C784 \C5F0\C124')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105075288672309524)
,p_name=>'DEMO_APPLICATION.PROJECT_TRACKING'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C81D\D2B8 \CD94\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105282463586309683)
,p_name=>'DEMO_APPLICATION.RE_INSTALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105073693881309523)
,p_name=>'DEMO_APPLICATION.RUN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105069404617309520)
,p_name=>'DEMO_APPLICATION.SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105070089440309520)
,p_name=>'DEMO_APPLICATION.SEQUENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105073185368309523)
,p_name=>'DEMO_APPLICATION.STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105069892652309520)
,p_name=>'DEMO_APPLICATION.TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105072969270309522)
,p_name=>'DEMO_APPLICATION.TABLE_SUMMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\BAA8 \C560\D50C\B9AC\CF00\C774\C158 \C124\CE58 \C0C1\D0DC \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105070124810309520)
,p_name=>'DEMO_APPLICATION.TRIGGER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105514645085309873)
,p_name=>'DEMO_APPLICATION.UNLOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE08 \D574\C81C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104935339695309422)
,p_name=>'DEMO_APPLICATION.UPDATE_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \AC00\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106092975809310358)
,p_name=>'DEMO_APPLICATION.WEBSHEET_OBJECT_VALIDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8\B97C \C62C\BC14\B974\AC8C \C2E4\D589\D558\B824\BA74 \B2E4\C74C\ACFC \AC19\C740 \BD80\C801\D569\D55C \AC1D\CCB4\B97C \C218\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105074738239309524)
,p_name=>'DEMO_APPLICATION.WEB_SERVICES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105071514040309521)
,p_name=>'DEMO_APPLICATION.WILL_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B370\BAA8\B97C \C7AC\C0DD\C131\D558\C9C0 \C54A\C73C\BA74 \C624\B958\AC00 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105016541998309482)
,p_name=>'DEMO_FLOW.CREATED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B370\BAA8\B97C \C0DD\C131\D558\AE30 \C704\D55C \ACF5\AC04\C774 \BD80\C871\D569\B2C8\B2E4. \AD00\B9AC \D398\C774\C9C0\B85C \C774\B3D9\D558\C5EC "\D604\C7AC \C11C\BE44\C2A4\C5D0 \B300\D55C \BCC0\ACBD \C694\CCAD" \B9C1\D06C\B97C \B20C\B7EC \CD94\AC00 \C800\C7A5 \C601\C5ED\C744 \C694\CCAD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105016435108309482)
,p_name=>'DEMO_FLOW.CREATED_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B370\BAA8 \C560\D50C\B9AC\CF00\C774\C158\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105671826816310005)
,p_name=>'DEPRECATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\B418\C9C0 \C54A\C74C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104967567614309446)
,p_name=>'DERIVED$'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C0DD\B41C \C5F4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105347851081309734)
,p_name=>'DESIRABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105420655760309794)
,p_name=>'DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B514\D14C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105477337998309842)
,p_name=>'DETAILS_FOR_ALT_TAG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105420768085309794)
,p_name=>'DETAIL_2'
,p_message_language=>'ko'
,p_message_text=>unistr('\B514\D14C\C77C 2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104918947924309411)
,p_name=>'DEVELOPER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105482722783309846)
,p_name=>'DEVELOPERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105367456715309748)
,p_name=>'DEVELOPER_ACTIVITY_SUMMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790 \C791\C5C5 \C694\C57D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105391230613309766)
,p_name=>'DEVELOPER_SUMMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790 \C694\C57D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104875723799309377)
,p_name=>'DEVELOPER_TOOLBAR_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C571 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105384536555309761)
,p_name=>'DEVELOPER_TOOLBAR_APP_CUSTOMIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C571 \C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105540670950309895)
,p_name=>'DEVELOPER_TOOLBAR_CLEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6B0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105540567267309894)
,p_name=>'DEVELOPER_TOOLBAR_COPY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105888919784310176)
,p_name=>'DEVELOPER_TOOLBAR_CUSTOMIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105566887962309916)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B514\BC84\ADF8(%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105566300441309915)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \B514\BC84\ADF8 \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105566570220309915)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL4'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4(\AE30\BCF8\AC12)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105566642699309915)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL6'
,p_message_language=>'ko'
,p_message_text=>unistr('\C571 \CD94\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105566751788309915)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL9'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \CD94\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104875801491309377)
,p_name=>'DEVELOPER_TOOLBAR_EDIT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105529769585309886)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\AC00 \B85C\B4DC\B41C \D6C4 \D558\B098 \C774\C0C1\C758 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \BE0C\B77C\C6B0\C800\C758 JavaScript \CF58\C194\C744 \C5F4\C5B4 \C624\B958\B97C \D655\C778\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105529950325309886)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS_BTN'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \C624\B958')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105889071008310176)
,p_name=>'DEVELOPER_TOOLBAR_LOGO_EDITOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ACE0 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105603567319309944)
,p_name=>'DEVELOPER_TOOLBAR_NO_BUILDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AE30\B2A5\C744 \C0AC\C6A9\D558\B824\BA74 Application Express \C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30 \CC3D\C744 \C5F4\C5B4\C57C \D569\B2C8\B2E4. \C774 \CC3D\C5D0\C11C \C0DD\C131\AE30\B97C \C5EC\C2DC\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105599624088309941)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790 \B3C4\AD6C \BAA8\C74C \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105601384182309943)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_AUTO_HIDE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9 \C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105601537983309943)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_DISPLAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105601449078309943)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_ICONS_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \D45C\C2DC\B9CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105601701209309943)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_BOTTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105601646997309943)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_LEFT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105601858589309943)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_RIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105603165804309944)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_TOP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105535625005309891)
,p_name=>'DEVELOPER_TOOLBAR_PAGE_INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105535841336309891)
,p_name=>'DEVELOPER_TOOLBAR_PERF_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C131\B2A5 \D0C0\C774\BC0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105599792064309941)
,p_name=>'DEVELOPER_TOOLBAR_QUICK_EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE60\B978 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105535740203309891)
,p_name=>'DEVELOPER_TOOLBAR_SHOW_PERF'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D0C0\C774\BC0D \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106100647979310365)
,p_name=>'DEVELOPER_TOOLBAR_THEME_ROLLER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \B864\B7EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105601211151309943)
,p_name=>'DEVELOPER_TOOLBAR_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790 \B3C4\AD6C \BAA8\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105342167592309730)
,p_name=>'DEVELOPMENT_TASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C \C791\C5C5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105510409492309870)
,p_name=>'DIAL_CHART_ALERT_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105510338263309870)
,p_name=>'DIAL_CHART_HIGH_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105510264459309869)
,p_name=>'DIAL_CHART_LOW_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C704 \AC12')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104859539812309362)
,p_name=>'DICTIONARY.APEX_APPL_PAGE_ITEM_GROUPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104941935896309427)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104944385169309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104944481533309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTHORIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104943584454309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BC_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104943401120309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BREADCRUMBS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106130044297310393)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BUILD_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104943147191309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_COMPUTATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104943325913309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104943693358309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104943754081309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LIST_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104943846503309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOVS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104893135466309391)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104943972644309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104944001298309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_NAV_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104942007728309427)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104943046911309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BRANCHES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104942455700309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BUTTONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105316822019309710)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHARTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105317073729309710)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_A'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105316964447309710)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_S'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104942702966309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_COMP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104983670825309458)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104983722952309458)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA_ACTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5 - \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104942549902309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR'
,p_message_language=>'ko'
,p_message_text=>unistr('IR \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104942629894309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR_COL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104942248368309427)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104942979177309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_PROC'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104942153642309427)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REGIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105883109374310171)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REG_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104942388419309427)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_RPT_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106065197615310332)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_TREES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104942813741309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_VAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104944121283309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PARENT_TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104943287734309428)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PROCESSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106090848808310356)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_LAYOUTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \B808\C774\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106091175094310357)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QRY_STMTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C9C8\C758 SQL \BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106090728575310356)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QUERIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106039833423310309)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104944503199309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SHORTCUTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104940045445309426)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_STATIC_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104946017603309430)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUBSTITUTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106129751564310392)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJECTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0 \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106129866242310392)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_BOPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0\B418\B294 \AC1D\CCB4-\BE4C\B4DC \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104945853141309430)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_CHCK'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4-\AC80\C99D \C9C0\C6D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104945911738309430)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_SCR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4-\C2A4\D06C\B9BD\D2B8 \C9C0\C6D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104944208652309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104944954859309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104945064410309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104945166431309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105008456332309476)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_GRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B9AC\B4DC \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104945223630309430)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104945335913309430)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104945492772309430)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104945507917309430)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_POPUPLOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 LOV \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104945663093309430)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104945712894309430)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104944820912309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104933476296309421)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104881284353309382)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_STYLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105372616629309752)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANSLATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104927216962309416)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_DYNAMIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \BC88\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104927358162309417)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_REPOS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC88\C5ED \AC00\B2A5\D55C \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104944742405309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TREES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104944651064309429)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_WEB_SERVICES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106056725498310325)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_ROLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106056837014310325)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105411893414309781)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USER_ROLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4 \C0AC\C6A9\C790 \B864 \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104870300394309372)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104870538938309372)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATION_ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654 - \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106092644498310358)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_CONCATENATED_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\ACB0\B41C \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104897806359309395)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_LOADS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105324326922309716)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \AD6C\BB38\BD84\C11D \D504\B85C\D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105324481476309716)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILE_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \AD6C\BB38\BD84\C11D \D504\B85C\D30C\C77C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106108055125310372)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DEVELOPER_COMMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790 \C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106071723779310339)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_EMAIL_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105629808072309967)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105624178005309962)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105624237522309962)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_LOOKUPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \D14C\C774\BE14 \C870\D68C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105624331373309962)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_RULES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \D14C\C774\BE14 \BCC0\D658 \ADDC\CE59')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104887783322309387)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CALENDARS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104886746182309386)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104886865839309386)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARD_ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105600713912309942)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105600833465309942)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105600963850309942)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COL_GROUPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104861718500309364)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104861853559309364)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAP_LAYERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5 \CE35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104959679810309440)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGINS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104959753703309440)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105371115021309751)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTR_VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105014628819309480)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_EVENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104961871384309442)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105420996365309794)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ITEM_FILTERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \C5F0\C0B0\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106129960970310392)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106070638862310337)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_STD_ATTRS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778 \D45C\C900 \C18D\C131 \BA54\D0C0\B370\C774\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105324284069309716)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_REMOTE_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL \C11C\BC84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105883049081310171)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106129679043310392)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GROUPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C635\C158 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106045946797310315)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GRP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C635\C158 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106099174608310364)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_PAGE_DP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106099206344310364)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_REGION_DP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105013035203309479)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_THEME_DISPLAY_POINTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \D45C\C2DC \C9C0\C810')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104939934946309426)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_USER_INTERFACES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105324964210309716)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_COMP_PARAMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C REST \C18C\C2A4 \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105324635197309716)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_MODULES'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105324734113309716)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_OPERATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105324836803309716)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_PARAMETERS'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105324597465309716)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SERVERS'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \C6D0\ACA9 \C11C\BC84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104870826208309373)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SYNC_STEPS'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B3D9\AE30\D654 \B2E8\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104870796906309372)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654 \B85C\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104870905953309373)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_MSG_LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654 \BA54\C2DC\C9C0 \B85C\ADF8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106073304878310340)
,p_name=>'DISABLED_NEXT_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B41C \B2E4\C74C \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106073217835310340)
,p_name=>'DISABLED_PREVIOUS_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B41C \C774\C804 \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105473934182309839)
,p_name=>'DISABLE_TRIGGER'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D2B8\B9AC\AC70\B97C \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105079385979309527)
,p_name=>'DISPLAY_CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105079514306309527)
,p_name=>'DISPLAY_CONDITION_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C870\AC74 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105519670136309877)
,p_name=>'DISPLAY_ORDER_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C21C\C11C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104965808752309444)
,p_name=>'DISPLAY_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106129326358310392)
,p_name=>'DISPLAY_VALUE.N'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \AC12: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106068680254310336)
,p_name=>'DISTINCT_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BCC4 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106068739463310336)
,p_name=>'DISTINCT_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BCC4 \C0AC\C6A9\C790')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104892837472309391)
,p_name=>'DML_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('DML \D3FC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105187099951309612)
,p_name=>'DO NOT UPDATE PAGE ITEMS'
,p_message_language=>'ko'
,p_message_text=>'DO_NOT_UPDATE_PAGE_ITEMS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105363256266309745)
,p_name=>'DOC_IMPACT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85\C11C \C601\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105364410546309746)
,p_name=>'DOC_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C11C \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105364629486309746)
,p_name=>'DOC_WRITER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85\C11C \C791\C131\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105252208597309660)
,p_name=>'DOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105372431027309752)
,p_name=>'DOWNLOAD_LINK_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC \B9C1\D06C \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105186736849309612)
,p_name=>'DO_NOT_UPDATE_APPLICATION_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C5C5\B370\C774\D2B8\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105186874081309612)
,p_name=>'DO_NOT_UPDATE_DATA_ENTRY_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C785\B825 \D56D\BAA9\C744 \C5C5\B370\C774\D2B8\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105186961385309612)
,p_name=>'DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C804\C6A9 \D56D\BAA9\C744 \C5C5\B370\C774\D2B8\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105186651673309612)
,p_name=>'DO_NOT_UPDATE_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B97C \C5C5\B370\C774\D2B8\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105187445838309612)
,p_name=>'DO_NOT_UPDATE_PAGE_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9\C744 \C5C5\B370\C774\D2B8\D558\C9C0 \C54A\C74C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105049444323309506)
,p_name=>'DRAG_AND_DROP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B04C\C5B4 \B193\AE30')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104957288913309438)
,p_name=>'DRILLDOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4DC\B9B4 \B2E4\C6B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104957144832309438)
,p_name=>'DRILLUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4DC\B9B4 \C5C5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105094798163309538)
,p_name=>'DRIVEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\B3D9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105473729147309839)
,p_name=>'DROP TRIGGER'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D2B8\B9AC\AC70 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105472835230309838)
,p_name=>'DROP_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C5F4 \C0AD\C81C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105620277178309958)
,p_name=>'DS_ACCESS_METHOD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \BC29\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105620094395309958)
,p_name=>'DS_BIND_VARIABLE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\C778\B4DC \BCC0\C218 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105620410525309959)
,p_name=>'DS_HANDLER'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105620892277309959)
,p_name=>'DS_ITEMS_PER_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B2F9 \BB38\C81C \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105620695835309959)
,p_name=>'DS_MIME_TYPES_ALLOWED'
,p_message_language=>'ko'
,p_message_text=>unistr('MIME \C720\D615 \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105620772965309959)
,p_name=>'DS_ORIGINS_ALLOWED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD9C\CC98 \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105620381657309958)
,p_name=>'DS_PARAMETER_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105620963149309959)
,p_name=>'DS_SECURITY_CONSTRAINT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548 \C81C\C57D \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105620189245309958)
,p_name=>'DS_SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105620551733309959)
,p_name=>'DS_SOURCE_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105621020754309959)
,p_name=>'DS_URI_PREFIX'
,p_message_language=>'ko'
,p_message_text=>unistr('URI \C811\B450\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105619782405309958)
,p_name=>'DS_URI_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('URI \D15C\D50C\B9AC\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106091208671310357)
,p_name=>'DUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\D55C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105364266256309746)
,p_name=>'DUE_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9CC\AE30 \B0A0\C9DC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105344785813309731)
,p_name=>'DUPLICATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\BCF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106069384462310336)
,p_name=>'DUPLICATE_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D\C5D0 \C911\BCF5\B41C \C0AC\C6A9\C790 \C788\C74C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104881671106309382)
,p_name=>'DYNAMIC ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104881525873309382)
,p_name=>'DYNAMIC ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104891765437309390)
,p_name=>'DYNAMIC_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104997674517309468)
,p_name=>'DYNAMIC_HTML'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105048344714309505)
,p_name=>'DYNAMIC_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104874750530309376)
,p_name=>'DYNAMIC_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \CC38\C870')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105144167764309580)
,p_name=>'EASY_REPORT.INVALID_CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \C911\C778 \C870\AC74\C73C\B85C \C778\D574 \C9C8\C758\AC00 \BD80\C801\D569\D574\C84C\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104886232134309385)
,p_name=>'EDIT PAGE GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \ADF8\B8F9 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105404820101309776)
,p_name=>'EDITOR_EXIT'
,p_message_language=>'ko'
,p_message_text=>unistr('<b>\D655\C778</b>\C744 \C120\D0DD\D558\BA74 \C800\C7A5\D558\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D\C774 \C190\C2E4\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104918262249309410)
,p_name=>'EDIT_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105145337189309581)
,p_name=>'EDIT_ALL_PAGE_DEFINITION_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \D398\C774\C9C0 \C815\C758 \C18D\C131 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105399748190309772)
,p_name=>'EDIT_ALL_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C601\C5ED\C758 \BAA8\B4E0 \D56D\BAA9 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105330487079309721)
,p_name=>'EDIT_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105419419656309793)
,p_name=>'EDIT_ATTRIBUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106014438386310284)
,p_name=>'EDIT_AUTHENTICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105409229994309779)
,p_name=>'EDIT_COMPONENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105419569655309793)
,p_name=>'EDIT_COMPONENT_DEF'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \C815\C758 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105510983469309870)
,p_name=>'EDIT_LINK_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105419329416309793)
,p_name=>'EDIT_LIST_DEV'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \C815\C758 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106083241935310349)
,p_name=>'EDIT_LOCK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE08 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105290916283309689)
,p_name=>'EDIT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105147470812309583)
,p_name=>'EDIT_PAGE_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C18D\C131 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105678327167310011)
,p_name=>'EDIT_PROFILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\D30C\C77C \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105695713033310026)
,p_name=>'EDIT_PROFILE.USER_NO_PRIV_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 0%\C5D0\AC8C \B2E4\B978 \C0AC\C6A9\C790\C5D0 \B300\D55C \C815\BCF4\B97C \C5C5\B370\C774\D2B8\D560 \C218 \C788\B294 \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105409025334309779)
,p_name=>'EDIT_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105483576418309846)
,p_name=>'EDIT_REPORTING_TIMEFRAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0 \C2DC\AC04\BC94\C704 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105409101054309779)
,p_name=>'EDIT_REPORT_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105672514320310005)
,p_name=>'EDIT_REPORT_DIALOG_CLOSED_DA'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D3B8\C9D1 - \B300\D654\C0C1\C790 \B2EB\D798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105399097217309771)
,p_name=>'EDIT_SYSTEM_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C2A4\D15C \BA54\C2DC\C9C0 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105634467125309971)
,p_name=>'EDIT_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105420800774309794)
,p_name=>'EDIT_THIS_ATTRIBUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C18D\C131 \D3B8\C9D1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105273219865309676)
,p_name=>'ELAPSED_TIME'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACFC \C2DC\AC04')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105351860258309737)
,p_name=>'EMAIL.TEMPLATE.FOOTER_EXAMPLE'
,p_message_language=>'ko'
,p_message_text=>unistr('<a href="#MY_APPLICATION_LINK#">\B0B4 \C560\D50C\B9AC\CF00\C774\C158\C744 \BC29\BB38\D558\C5EC \C804\C790\BA54\C77C \D658\ACBD\C124\C815\C744 \AD00\B9AC\D558\C2ED\C2DC\C624</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105358769181309742)
,p_name=>'EMAIL.TEMPLATE.HEADER_EXAMPLE'
,p_message_language=>'ko'
,p_message_text=>unistr('<b style="font-size: 24px;">\B0B4 \C560\D50C\B9AC\CF00\C774\C158</b>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105473240223309838)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.EV'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>#INVITEE#\B2D8, \C548\B155\D558\C138\C694.</strong><br>'),
'<br>',
unistr('\CD08\B300 \BC1B\C740 \C774\BCA4\D2B8 \C608\C815\C5D0 \B300\D55C \BBF8\B9AC \C54C\B9BC\C785\B2C8\B2E4. \C544\B798\C758 \C774\BCA4\D2B8 \C138\BD80\C815\BCF4\B97C \D655\C778\D558\C2ED\C2DC\C624.<br>'),
'<br>',
'<table width="100%">',
'  <tr>',
unistr('    <th align="left">\C8FC\CD5C\C790</th>'),
'    <td>#ORGANIZER#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\C774\BCA4\D2B8 \B0A0\C9DC</th>'),
'    <td>#EVENT_DATE#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\C2DC\C791 \C2DC\AC04</th>'),
'    <td>#START_TIME#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\AE30\AC04</th>'),
'    <td>#DURATION#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\C704\CE58</th>'),
'    <td>#LOCATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">URL</th>',
'    <td><a href="#URL_LINK#">#URL_NAME#</a></td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\CC38\ACE0</th>'),
'    <td>#NOTES#</td>',
'  </tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105351704928309737)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.OD'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>#CUSTOMER_NAME#\B2D8, \C548\B155\D558\C138\C694.</strong><br>'),
'<br>',
unistr('\C8FC\BB38\D574 \C8FC\C154\C11C \AC10\C0AC\D569\B2C8\B2E4!<br>'),
'<br>',
unistr('<strong>\C8FC\BB38 \C138\BD80\C815\BCF4</strong><br>'),
'<br>',
'<table width="100%">',
'  <tr>',
unistr('    <th align="left">\C8FC\BB38 \B0A0\C9DC</th>'),
'    <td>#ORDER_DATE#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\C8FC\BB38 \BC88\D638</th>'),
'    <td>#ORDER_NUMBER#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\BC30\C1A1\C9C0</th>'),
'    <td>#SHIP_TO#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\BC30\C1A1 \C8FC\C18C</th>'),
'    <td>',
'      #SHIPPING_ADDRESS_LINE_1#<br>',
'      #SHIPPING_ADDRESS_LINE_2#',
'    </td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\C8FC\BB38\D55C \D488\BAA9</th>'),
'    <td>#ITEMS_ORDERED#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\C8FC\BB38 \D569\ACC4</th>'),
'    <td>#ORDER_TOTAL#</td>',
'  </tr>',
'</table>',
'<br>',
'<br>',
unistr('\C8FC\BB38\C744 \BCC0\ACBD\D574\C57C \D569\B2C8\AE4C? <a href="#ORDER_URL#">\C5EC\AE30\C11C #ORDER_NUMBER# \C8FC\BB38\C744 \AD00\B9AC\D558\C2ED\C2DC\C624.</a>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105672860202310006)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.SO'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#SERVICE_USER#\B2D8, \C548\B155\D558\C138\C694.<br>'),
'<br>',
unistr('#SERVICE_NAME# \C11C\BE44\C2A4\C5D0 \C77C\C815\C774 \C7A1\D78C \C6B4\C6A9\C911\B2E8\C774 \C608\C815\B418\C5B4 \C788\C2B5\B2C8\B2E4.<br>'),
unistr('\C6B4\C6A9\C911\B2E8\C740 #OUTAGE_START#\C5D0 \C2DC\C791\D558\B3C4\B85D \C77C\C815\C774 \C7A1\D600 \C788\C73C\BA70 #OUTAGE_DURATION# #OUTAGE_TIMEFRAME# \B3D9\C548 \C0AC\C6A9\D560 \C218 \C5C6\C744 \C608\C815\C785\B2C8\B2E4.<br>'),
'<br>',
unistr('\C774 \C77C\C815\C774 \C7A1\D78C \C6B4\C6A9\C911\B2E8 \B3D9\C548 \B2E4\C74C\C774 \C218\D589\B429\B2C8\B2E4.<br>'),
'#OUTAGE_REASON#<br>',
'<br>',
'<br>',
unistr('\C774 \C6B4\C6A9\C911\B2E8\ACFC \AD00\B828\B41C \BB38\C81C\B294 #OUTAGE_CONTACT#\C5D0 \BB38\C758\D558\C2ED\C2DC\C624.<br>'),
'<br>',
unistr('\C774\D574\D574 \C8FC\C154\C11C \AC10\C0AC\D569\B2C8\B2E4.<br>'),
'#SERVICE_TEAM#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105672225723310005)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.EV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \BBF8\B9AC \C54C\B9BC: #EVENT_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105672336539310005)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.OD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\BB38(#ORDER_NUMBER#) \D655\C815!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105473454891309839)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.EV'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#INVITEE#\B2D8, \C548\B155\D558\C138\C694.'),
'',
unistr('\C774 \C804\C790\BA54\C77C\C740 \C5F0\AD00\B41C \C774\BCA4\D2B8 \C608\C815\C5D0 \B300\D55C \BBF8\B9AC \C54C\B9BC\C785\B2C8\B2E4.'),
'',
unistr('\C774\BCA4\D2B8 \B0A0\C9DC: #EVENT_DATE#'),
unistr('\C2DC\C791 \C2DC\AC04: #START_TIME#'),
unistr('\AE30\AC04:   #DURATION#'),
unistr('\C8FC\CD5C\C790:  #ORGANIZER#'),
unistr('\C704\CE58:   #LOCATION#'),
'URL:        #URL_NAME# (#URL_LINK#)',
unistr('\CC38\ACE0:      #NOTES#'),
'',
unistr('\C5EC\AE30\C11C \CD94\AC00 \C774\BCA4\D2B8 \C138\BD80\C815\BCF4\B97C \D655\C778\D558\C2ED\C2DC\C624. #EVENT_LINK#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105473318414309838)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.OD'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#CUSTOMER_NAME#\B2D8, \C548\B155\D558\C138\C694.'),
'',
unistr('\C8FC\BB38\D574 \C8FC\C154\C11C \AC10\C0AC\D569\B2C8\B2E4!'),
'',
unistr('\C8FC\BB38 \C138\BD80\C815\BCF4'),
'--------------------------------------------------------------------------------',
unistr('  \C8FC\BB38 \B0A0\C9DC:       #ORDER_DATE#'),
unistr('  \C8FC\BB38 \BC88\D638:     #ORDER_NUMBER#'),
unistr('  \BC30\C1A1\C9C0:          #SHIP_TO#'),
unistr('  \BC30\C1A1 \C8FC\C18C: #SHIPPING_ADDRESS_LINE_1#'),
'                    #SHIPPING_ADDRESS_LINE_2#',
unistr('  \C8FC\BB38\D55C \D488\BAA9:    #ITEMS_ORDERED#'),
unistr('  \C8FC\BB38 \D569\ACC4:      #ORDER_TOTAL#'),
'--------------------------------------------------------------------------------',
'',
unistr('\C8FC\BB38\C744 \BCC0\ACBD\D574\C57C \D569\B2C8\AE4C? \C5EC\AE30\C11C #ORDER_NUMBER# \C8FC\BB38\C744 \AD00\B9AC\D558\C2ED\C2DC\C624. #ORDER_URL#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105672788547310006)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.SO'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#SERVICE_USER#\B2D8, \C548\B155\D558\C138\C694.'),
'',
unistr('#SERVICE_NAME# \C11C\BE44\C2A4\C5D0 \C77C\C815\C774 \C7A1\D78C \C6B4\C6A9\C911\B2E8\C774 \C608\C815\B418\C5B4 \C788\C2B5\B2C8\B2E4.'),
unistr('\C6B4\C6A9\C911\B2E8\C740 #OUTAGE_START#\C5D0 \C2DC\C791\D558\B3C4\B85D \C77C\C815\C774 \C7A1\D600 \C788\C73C\BA70 #OUTAGE_DURATION# #OUTAGE_TIMEFRAME# \B3D9\C548 \C0AC\C6A9\D560 \C218 \C5C6\C744 \C608\C815\C785\B2C8\B2E4.'),
'',
unistr('\C774 \C77C\C815\C774 \C7A1\D78C \C6B4\C6A9\C911\B2E8 \B3D9\C548 \B2E4\C74C\C774 \C218\D589\B429\B2C8\B2E4.'),
'#OUTAGE_REASON#',
'',
unistr('\C774 \C6B4\C6A9\C911\B2E8\ACFC \AD00\B828\B41C \BB38\C81C\B294 #OUTAGE_CONTACT#\C5D0 \BB38\C758\D558\C2ED\C2DC\C624.'),
'',
unistr('\C774\D574\D574 \C8FC\C154\C11C \AC10\C0AC\D569\B2C8\B2E4.'),
'#SERVICE_TEAM#',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105403015850309774)
,p_name=>'ENABLE_DEBUGGING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B514\BC84\AE45\C744 \C0AC\C6A9\C73C\B85C \C124\C815(\C608 \B610\B294 \C544\B2C8\C624)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105473819864309839)
,p_name=>'ENABLE_TRIGGER'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D2B8\B9AC\AC70\B97C \C0AC\C6A9\C73C\B85C \C124\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104920449313309412)
,p_name=>'ENCRYPTION_INPUT_TOO_LONG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C554\D638\D654\D560 \AC12 \AE38\C774\B294 4000\BC14\C774\D2B8\B97C \CD08\ACFC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104919035755309411)
,p_name=>'END_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105341843608309729)
,p_name=>'ENHANCEMENT_REQUEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C120 \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105696429517310026)
,p_name=>'ENHANCEMENT_REQUEST_DASH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C120 \C694\CCAD: %1/%0 \C885\ACB0\B428')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105344265825309731)
,p_name=>'ENTERED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104885419151309385)
,p_name=>'ENTER_WEBSHEETS_CREDENTIALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C778\C99D\C11C\B97C \C785\B825\D558\C2ED\C2DC\C624.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105332080979309722)
,p_name=>'ENTRY LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105331985306309722)
,p_name=>'ENTRY TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \D14D\C2A4\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105387358960309763)
,p_name=>'ERROR PAGE TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105250432600309659)
,p_name=>'ERRORPAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \BC1C\C0DD \C2DC \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105400005535309772)
,p_name=>'ERRORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105333259937309723)
,p_name=>'ERROR_ICON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \C544\C774\CF58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106090218262310356)
,p_name=>'ERROR_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \BA54\C2DC\C9C0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105325440512309717)
,p_name=>'ESCAPED_COL_TOO_LARGE'
,p_message_language=>'ko'
,p_message_text=>unistr('<br><strong>\C774\C2A4\CF00\C774\D504 \B370\C774\D130\AC00 \D5C8\C6A9\B41C \C81C\D55C\C744 \CD08\ACFC\D558\C5EC \ACB0\ACFC\AC00 32k\AE4C\C9C0 \C798\B838\C2B5\B2C8\B2E4.</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105093941579309538)
,p_name=>'ESCAPE_SC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C2A4\CF00\C774\D504 \D2B9\C218 \BB38\C790')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105365665418309747)
,p_name=>'ESTIMATED_EFFORT_IN_HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608\C0C1 \C2DC\AC04(\C2DC\AC04)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105619949196309958)
,p_name=>'ETAG_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('ETAG \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105619847011309958)
,p_name=>'ETAG_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('ETAG \C720\D615')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105342305515309730)
,p_name=>'EVENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105676977962310009)
,p_name=>'EVENT.APEX.APEXAFTERREFRESH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C\ACE0\CE68 \C774\D6C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105677257478310010)
,p_name=>'EVENT.APEX.APEXBEFOREPAGESUBMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\CD9C \C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105676833054310009)
,p_name=>'EVENT.APEX.APEXBEFOREREFRESH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C\ACE0\CE68 \C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105679425534310012)
,p_name=>'EVENT.BROWSER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE0C\B77C\C6B0\C800 \C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105140585767309578)
,p_name=>'EVENT.BROWSER.APEXDOUBLETAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B450 \BC88 \B204\B974\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105140708440309578)
,p_name=>'EVENT.BROWSER.APEXPAN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105140692030309578)
,p_name=>'EVENT.BROWSER.APEXPRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\B974\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105140808137309578)
,p_name=>'EVENT.BROWSER.APEXSWIPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C9C0\B974\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105140441101309578)
,p_name=>'EVENT.BROWSER.APEXTAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\B974\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105676310608310009)
,p_name=>'EVENT.BROWSER.CHANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105675610489310008)
,p_name=>'EVENT.BROWSER.CLICK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B9AD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105675725018310008)
,p_name=>'EVENT.BROWSER.DBLCLICK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B354\BE14\D074\B9AD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105675128113310008)
,p_name=>'EVENT.BROWSER.FOCUSIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\CEE4\C2A4 \D68D\B4DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105675095458310008)
,p_name=>'EVENT.BROWSER.FOCUSOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\CEE4\C2A4 \C190\C2E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105676508205310009)
,p_name=>'EVENT.BROWSER.KEYDOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0A4 \C544\B798\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105676675367310009)
,p_name=>'EVENT.BROWSER.KEYPRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0A4 \B204\B974\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105676795782310009)
,p_name=>'EVENT.BROWSER.KEYUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0A4 \D574\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105675294463310008)
,p_name=>'EVENT.BROWSER.LOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9AC\C18C\C2A4 \B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105675814564310008)
,p_name=>'EVENT.BROWSER.MOUSEDOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C6B0\C2A4 \B2E8\CD94 \B204\B974\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105676104090310009)
,p_name=>'EVENT.BROWSER.MOUSEENTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C6B0\C2A4 \C9C4\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105676296838310009)
,p_name=>'EVENT.BROWSER.MOUSELEAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C6B0\C2A4 \B5A0\B0A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105676033167310008)
,p_name=>'EVENT.BROWSER.MOUSEMOVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C6B0\C2A4 \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105675935580310008)
,p_name=>'EVENT.BROWSER.MOUSEUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C6B0\C2A4 \B2E8\CD94 \D574\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104884409559309384)
,p_name=>'EVENT.BROWSER.ORIENTATIONCHANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\D5A5 \BCC0\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105682733222310014)
,p_name=>'EVENT.BROWSER.READY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105675341355310008)
,p_name=>'EVENT.BROWSER.RESIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D06C\AE30 \C870\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105675473481310008)
,p_name=>'EVENT.BROWSER.SCROLL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104884543119309384)
,p_name=>'EVENT.BROWSER.SCROLLSTART'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B864 \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104884611776309384)
,p_name=>'EVENT.BROWSER.SCROLLSTOP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B864 \C815\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105676423232310009)
,p_name=>'EVENT.BROWSER.SELECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104883671294309383)
,p_name=>'EVENT.BROWSER.SWIPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C9C0\B974\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104883790481309383)
,p_name=>'EVENT.BROWSER.SWIPELEFT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD\C73C\B85C \BB38\C9C0\B974\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104883897964309384)
,p_name=>'EVENT.BROWSER.SWIPERIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD\C73C\B85C \BB38\C9C0\B974\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104883463016309383)
,p_name=>'EVENT.BROWSER.TAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\B974\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104883554287309383)
,p_name=>'EVENT.BROWSER.TAPHOLD'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE38\AC8C \B204\B974\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105675549993310008)
,p_name=>'EVENT.BROWSER.UNLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B85C\B4DC \CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104884289526309384)
,p_name=>'EVENT.BROWSER.VCLICK'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C0C1 \D074\B9AD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104884394439309384)
,p_name=>'EVENT.BROWSER.VMOUSECANCEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D130\CE58 \CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104883990990309384)
,p_name=>'EVENT.BROWSER.VMOUSEDOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D130\CE58 \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104884072258309384)
,p_name=>'EVENT.BROWSER.VMOUSEMOVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D130\CE58 \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104884120769309384)
,p_name=>'EVENT.BROWSER.VMOUSEUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D130\CE58 \C885\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105679694327310012)
,p_name=>'EVENT.COMPONENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104880448138309381)
,p_name=>'EVENT.CUSTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104880596926309381)
,p_name=>'EVENT.CUSTOM.CUSTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105679580898310012)
,p_name=>'EVENT.FRAMEWORK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B808\C784\C6CC\D06C \C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105256852543309664)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSECANCELDIALOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \B2EB\D798 \B610\B294 \CDE8\C18C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105408991767309779)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSEDIALOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \B2EB\D798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106098125144310363)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERREFRESH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C\ACE0\CE68 \C774\D6C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106098269187310363)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREPAGESUBMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\CD9C \C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106098084531310363)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREREFRESH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C\ACE0\CE68 \C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105327147029309718)
,p_name=>'EVENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105364359576309746)
,p_name=>'EVENT_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C77C\C2A4\D1A4 \BC88\D638')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105405236297309776)
,p_name=>'EXACT_SUBS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\D655\D55C \B300\CCB4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105519022183309877)
,p_name=>'EXAMPLE_1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105519123529309877)
,p_name=>'EXAMPLE_2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106019257589310289)
,p_name=>'EXAMPLE_OF_XML_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('XML \B370\C774\D130\BCA0\C774\C2A4 \C5F4 \B0B4\C5D0 \D3EC\D568\B41C \B370\C774\D130\C758 \C608\C81C\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106069272902310336)
,p_name=>'EXAMPLE_URI'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608\C81C URI')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105474908663309840)
,p_name=>'EXCLUDE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C678')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105454560839309823)
,p_name=>'EXISTING_SCHEMA_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C2A4\D0A4\B9C8 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105396566552309770)
,p_name=>'EXISTS'
,p_message_language=>'ko'
,p_message_text=>'Exists'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104951871873309434)
,p_name=>'EXISTS_SQL_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('EXISTS SQL \C9C8\C758')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105667161666310000)
,p_name=>'EXPANDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C7A5\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106065096050310332)
,p_name=>'EXPAND_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \D655\C7A5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105017024346309482)
,p_name=>'EXPIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9CC\AE30\B428')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105330694456309721)
,p_name=>'EXPLAIN PLAN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \C124\BA85 \ACC4\D68D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105327417522309718)
,p_name=>'EXPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105635761832309972)
,p_name=>'EXPORT REPOSITORY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\C18C \C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105409507000309779)
,p_name=>'EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \C791\C5C5\C601\C5ED \B610\B294 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C775\C2A4\D3EC\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105409675082309779)
,p_name=>'EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C791\C5C5\C601\C5ED\C5D0\C11C \C775\C2A4\D3EC\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105478967325309843)
,p_name=>'EXPORT_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105483150591309846)
,p_name=>'EXPORT_PKG_APP_FOR_DEPLOYMENT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \B9C1\D06C\B97C \C0AC\C6A9\D558\C5EC \C774 \C560\D50C\B9AC\CF00\C774\C158 \BC0F \B2E4\B978 Oracle APEX \C124\CE58\C5D0\C11C\C758 \BC30\D3EC\B97C \C704\D55C \D574\B2F9 \B370\C774\D130\BCA0\C774\C2A4 \C9C0\C6D0 \AC1D\CCB4\B97C \B2E4\C6B4\B85C\B4DC\D558\C2ED\C2DC\C624. \B2E4\C6B4\B85C\B4DC \D30C\C77C\C740 SQL*Plus, SQL Developer \B610\B294 Oracle APEX \B0B4\C758 SQL \C2A4\D06C\B9BD\D2B8\C5D0\C11C \C2E4\D589\D560 \C218 \C788\B294 SQL \C2A4\D06C\B9BD\D2B8\C785\B2C8\B2E4.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105479094163309843)
,p_name=>'EXPORT_SUPPORTING_OBJECTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0 \AC1D\CCB4 \C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105327700363309719)
,p_name=>'EXPORT_TYPES.APP_EXPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105327986352309719)
,p_name=>'EXPORT_TYPES.CSS_EXPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\C18D\D615 \C2DC\D2B8 \C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105328100118309719)
,p_name=>'EXPORT_TYPES.FILE_EXPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \D30C\C77C \C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105328006989309719)
,p_name=>'EXPORT_TYPES.IMAGE_EXPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105327864376309719)
,p_name=>'EXPORT_TYPES.PAGE_EXPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105328271860309719)
,p_name=>'EXPORT_TYPES.SCRIPT_FILE_EXPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \D30C\C77C \C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105324114769309716)
,p_name=>'EXPORT_TYPES.UI_DEFAULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \AE30\BCF8\AC12')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105255233356309662)
,p_name=>'F4000.APPLICATION_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105253273062309661)
,p_name=>'F4000.APPLICATION_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105255011517309662)
,p_name=>'F4000.APPLICATION_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105069976725309520)
,p_name=>'F4000.APPLICATION_RESERVED'
,p_message_language=>'ko'
,p_message_text=>unistr('3000-8999\C758 \C560\D50C\B9AC\CF00\C774\C158 ID\AC00 \C608\C57D\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104953057657309435)
,p_name=>'F4000.APP_EXPORT_CURR_WS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C740 \D604\C7AC \C791\C5C5\C601\C5ED\C5D0\C11C \C775\C2A4\D3EC\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104953167421309435)
,p_name=>'F4000.APP_EXPORT_NON_CURR_WS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C740 \B2E4\B978 \C791\C5C5\C601\C5ED\C5D0\C11C \C775\C2A4\D3EC\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105886844772310174)
,p_name=>'F4000.APP_PRINT_CREDENTIALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 %0 \C6D0\ACA9 \C778\C1C4 \C11C\BC84 \C778\C99D\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105886661981310174)
,p_name=>'F4000.APP_REMOTE_PRINT_SERVER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 %0 \C6D0\ACA9 \C778\C1C4 \C11C\BC84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105254940875309662)
,p_name=>'F4000.BRANCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105268822742309672)
,p_name=>'F4000.BRANCH_FROM_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C5D0\C11C \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105269007179309673)
,p_name=>'F4000.BRANCH_TO_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105254532404309662)
,p_name=>'F4000.BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105395591062309769)
,p_name=>'F4000.BUTTON.ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105008395561309476)
,p_name=>'F4000.CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105130811401309571)
,p_name=>'F4000.CALENDAR_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825 \C5F4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105269498052309673)
,p_name=>'F4000.COLUMN_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106033467076310303)
,p_name=>'F4000.COLUMN_NAME_RESERVED_WORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4 \C774\B984\C740 Oracle \C608\C57D\C5B4\C785\B2C8\B2E4. \B2E4\B978 \C774\B984\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105396978462309770)
,p_name=>'F4000.COPY_LIST_ENTRY_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D56D\BAA9 \BCF5\C0AC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105282793878309683)
,p_name=>'F4000.DYNAMIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104967264929309446)
,p_name=>'F4000.DYNAMIC ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104952959289309435)
,p_name=>'F4000.EXPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105284938470309685)
,p_name=>'F4000.FIX_ME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \C218\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105282355114309683)
,p_name=>'F4000.FOR_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105282285830309683)
,p_name=>'F4000.FOR_USER_SESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C138\C158\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105269113940309673)
,p_name=>'F4000.FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD9C\CC98')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105071013685309521)
,p_name=>'F4000.HEADER_VALIDATION1'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00\C5D0\B294 <strong>&lt;head&gt;</strong> \BC0F <strong>&lt;/head&gt;</strong> \D0DC\ADF8\AC00 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105071381513309521)
,p_name=>'F4000.HEADER_VALIDATION2'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>#HEAD#</strong> \B300\CCB4 \BB38\C790\C5F4\C740 <strong>&lt;head&gt;</strong> \D0DC\ADF8\C640 <strong>&lt;/head&gt;</strong> \D0DC\ADF8 \C0AC\C774\C5D0 \B098\D0C0\B098\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105339915857309728)
,p_name=>'F4000.INVALID_FILE_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D30C\C77C\C740 \BD80\C801\D569\D55C \C720\D615\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105254272669309662)
,p_name=>'F4000.ITEM_DISPLAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105254301547309662)
,p_name=>'F4000.ITEM_READ_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77D\AE30 \C804\C6A9 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104899629297309397)
,p_name=>'F4000.LEGACY_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\AC70\C2DC SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105422964346309796)
,p_name=>'F4000.LINK_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105287491669309687)
,p_name=>'F4000.LIST_INITCAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105255601109309663)
,p_name=>'F4000.LIST_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104899565699309396)
,p_name=>'F4000.LOCAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\CEEC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105255912792309663)
,p_name=>'F4000.LOV_ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105269261437309673)
,p_name=>'F4000.MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105255804756309663)
,p_name=>'F4000.MENU_OPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105299239950309695)
,p_name=>'F4000.MUST_SELECT_AT_LEAST_ONE_TO_COPY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC \B610\B294 \C801\C6A9\D560 \D56D\BAA9\C744 \D55C \AC1C \C774\C0C1 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105255316929309662)
,p_name=>'F4000.NAVIGATION_BAR_ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105186056064309611)
,p_name=>'F4000.NAVIGATION_BAR_ICON'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9&nbsp;\B3C4\AD6C \BAA8\C74C&nbsp;\C544\C774\CF58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105253197002309661)
,p_name=>'F4000.NO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105282801897309683)
,p_name=>'F4000.NOT_REFERENCED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105267319932309671)
,p_name=>'F4000.NO_DATA_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106092757684310358)
,p_name=>'F4000.P1.APP_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C774 \D604\C7AC \C791\C5C5\C601\C5ED\C5D0 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105693652109310024)
,p_name=>'F4000.P1000.UPDATE_CHECK_DISABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \AC80\C0AC \C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105292046703309690)
,p_name=>'F4000.P104.PARENT_TAB_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104955750491309437)
,p_name=>'F4000.P111.CANCEL_BUTTON_BRANCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C \B2E8\CD94 \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104955352675309437)
,p_name=>'F4000.P111.CANCEL_BUTTON_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C \B2E8\CD94 \D45C\C2DC \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104955887062309437)
,p_name=>'F4000.P111.FINISH_BUTTON_BRANCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC \B2E8\CD94 \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104955483444309437)
,p_name=>'F4000.P111.FINISH_BUTTON_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC \B2E8\CD94 \D45C\C2DC \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104955626665309437)
,p_name=>'F4000.P111.NEXT_BUTTON_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B2E8\CD94 \D45C\C2DC \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104955593409309437)
,p_name=>'F4000.P111.PREVIOUS_BUTTON_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804 \B2E8\CD94 \D45C\C2DC \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105292127998309690)
,p_name=>'F4000.P112.TREE_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105292273405309690)
,p_name=>'F4000.P119.GO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105292347250309690)
,p_name=>'F4000.P130.USING_SAME_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C560\D50C\B9AC\CF00\C774\C158\ACFC \B3D9\C77C\D55C \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106095248220310360)
,p_name=>'F4000.P135.COPY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106096957594310362)
,p_name=>'F4000.P149.PUBLISH_AUTHORIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106097292704310362)
,p_name=>'F4000.P149.PUBLISH_BREADCRUMB_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8\B97C \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106097325226310362)
,p_name=>'F4000.P149.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \B2E8\CD94 \D15C\D50C\B9AC\D2B8\B97C \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106097468169310362)
,p_name=>'F4000.P149.PUBLISH_CALENDAR_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \B2EC\B825 \D15C\D50C\B9AC\D2B8\B97C \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104879063024309380)
,p_name=>'F4000.P149.PUBLISH_DATA_LOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \B370\C774\D130 \B85C\B4DC \C815\C758\B97C \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106096840841310362)
,p_name=>'F4000.P149.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \B808\C774\BE14 \D15C\D50C\B9AC\D2B8\B97C \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106096620163310362)
,p_name=>'F4000.P149.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \BAA9\B85D \D15C\D50C\B9AC\D2B8\B97C \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106096348984310361)
,p_name=>'F4000.P149.PUBLISH_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \AC12 \BAA9\B85D\C744 \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106097130829310362)
,p_name=>'F4000.P149.PUBLISH_NAVBAR'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \D0D0\C0C9\D45C\C2DC\C904 \D56D\BAA9\C744 \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106096478818310362)
,p_name=>'F4000.P149.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B97C \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106097546811310362)
,p_name=>'F4000.P149.PUBLISH_PLUGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \D50C\B7EC\ADF8\C778\C744 \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106097641057310363)
,p_name=>'F4000.P149.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \D31D\C5C5 \AC12 \BAA9\B85D \D15C\D50C\B9AC\D2B8\B97C \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106096578330310362)
,p_name=>'F4000.P149.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \C601\C5ED \D15C\D50C\B9AC\D2B8\B97C \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106096706100310362)
,p_name=>'F4000.P149.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\B97C \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106097070444310362)
,p_name=>'F4000.P149.PUBLISH_SHORTCUT'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C \BC14\B85C\AC00\AE30\B97C \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105455691278309824)
,p_name=>'F4000.P149.PUBLISH_WEB_SRC_MODULE'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C744(\B97C) \AC8C\C2DC\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \B2E4\C74C REST \B370\C774\D130 \C18C\C2A4\AC00 \C0C8\B85C\ACE0\CE68\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105300028389309696)
,p_name=>'F4000.P158.COPY_OF'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C758 \BCF5\C0AC\BCF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106095180065310360)
,p_name=>'F4000.P1701.LOOKUP_DEFINITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\D68C \C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106092882710310358)
,p_name=>'F4000.P1704.REGION_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105070659258309521)
,p_name=>'F4000.P19.VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110\C774 \C544\B2CC \AC80\C99D\C744 \C0DD\C131\D558\B824\BA74 \D56D\BAA9\C744 \D55C \AC1C \C774\C0C1 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106005069350310275)
,p_name=>'F4000.P1935.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C571 %0 \C778\C1C4 \C11C\BC84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105716848245310045)
,p_name=>'F4000.P2.UPDATE_EXPORT_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C775\C2A4\D3EC\D2B8 \C124\C815 \C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105828551360310130)
,p_name=>'F4000.P203.ACTION='
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105336228979309725)
,p_name=>'F4000.P203.COMMENT='
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105334397666309724)
,p_name=>'F4000.P203.COMP.MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \C2E4\D589\C5D0 \C0AC\C6A9\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106101661762310366)
,p_name=>'F4000.P203.CONCATENATED_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\ACB0\B41C \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105334961747309724)
,p_name=>'F4000.P203.DISPVAL='
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \AC12=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106101522089310366)
,p_name=>'F4000.P203.FILE='
,p_message_language=>'ko'
,p_message_text=>'file='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105334641798309724)
,p_name=>'F4000.P203.ICONBAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105335170895309724)
,p_name=>'F4000.P203.LOV='
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105334896070309724)
,p_name=>'F4000.P203.LOVDATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \B370\C774\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105334707000309724)
,p_name=>'F4000.P203.NAME='
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105334285998309724)
,p_name=>'F4000.P203.PAGE.MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D45C\C2DC\C5D0 \C0AC\C6A9\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105336195503309725)
,p_name=>'F4000.P203.PAGEBRANCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105335268251309725)
,p_name=>'F4000.P203.PGTEMP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105334572118309724)
,p_name=>'F4000.P203.PROC.MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 \C2E4\D589\C5D0 \C0AC\C6A9\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105334430250309724)
,p_name=>'F4000.P203.PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105335091024309724)
,p_name=>'F4000.P203.RETVAL='
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\D658 \AC12=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106097860280310363)
,p_name=>'F4000.P2222.REPARENT_LIST_ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D56D\BAA9 \C0C1\C704 \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105130403347309570)
,p_name=>'F4000.P254.VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\D560 \C601\C5ED\C744 \D55C \AC1C \C774\C0C1 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105252838624309661)
,p_name=>'F4000.P277.WORKSPACE_NOT_CREATED_ALREADY_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C774 \C874\C7AC\D558\BBC0\B85C \C0DD\C131\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105252921371309661)
,p_name=>'F4000.P277.WORKSPACE_WILL_BE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C774 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106098657927310363)
,p_name=>'F4000.P291.VIEW_LOCK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE08 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105130559022309570)
,p_name=>'F4000.P295.VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C131\D560 \D398\C774\C9C0\B97C \D55C \AC1C \C774\C0C1 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106098776347310364)
,p_name=>'F4000.P337.PAGE_UNLOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B294 \D604\C7AC \C7A0\AE08 \D574\C81C\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105662198159309996)
,p_name=>'F4000.P371.POPUP_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105292749520309691)
,p_name=>'F4000.P374.POS.1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105292840345309691)
,p_name=>'F4000.P374.POS.2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105292980851309691)
,p_name=>'F4000.P374.POS.3'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105293036595309691)
,p_name=>'F4000.P374.POS.4'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104890974731309389)
,p_name=>'F4000.P374.POS.5'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105459844635309828)
,p_name=>'F4000.P374.POS.6'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58 6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105459956748309828)
,p_name=>'F4000.P374.POS.7'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58 7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105460098568309828)
,p_name=>'F4000.P374.POS.8'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58 8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105293126725309691)
,p_name=>'F4000.P381_XBUTTON_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('DML \BC0F \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \B2E8\CD94\C5D0\B294 \D2B9\C815 \B2E8\CD94 \C774\B984, \CC38\C870 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106095376618310360)
,p_name=>'F4000.P386.CLASS_MATCHES'
,p_message_language=>'ko'
,p_message_text=>unistr('%0(\D074\B798\C2A4 \C77C\CE58)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105293249797309691)
,p_name=>'F4000.P4001.AUTH_HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106101902284310366)
,p_name=>'F4000.P4001.ORIGINAL_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\B798 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105293387458309691)
,p_name=>'F4000.P4001.SUBSTITUTION_STR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4 \BB38\C790\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105293416180309691)
,p_name=>'F4000.P4001.SUBSTITUTION_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105266777489309671)
,p_name=>'F4000.P4017.HELP_REGION_SOURCE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<font class="instructiontext">\C774 \C601\C5ED\C740 \B2E4\C74C \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC \D638\CD9C\B41C \D604\C7AC \D398\C774\C9C0\C758 \D398\C774\C9C0 \BC0F \D56D\BAA9 \B3C4\C6C0\B9D0\C744 \D45C\C2DC\D569\B2C8\B2E4.<br>'),
'<pre><escape sc>f?p=&AMP;APP_ID.:Page:Session:&APP_PAGE_ID.</pre></font>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105293520899309691)
,p_name=>'F4000.P4039.FORM_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105293632320309691)
,p_name=>'F4000.P404.VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105017706587309483)
,p_name=>'F4000.P4045.BRANCH='
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105285885547309686)
,p_name=>'F4000.P4045.BUTTON='
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104908454347309403)
,p_name=>'F4000.P4045.CHART_SERIES='
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \ACC4\C5F4=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105286058155309686)
,p_name=>'F4000.P4045.COMPUTATION='
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105285467033309685)
,p_name=>'F4000.P4045.ICON_SUBTEXT='
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \D558\C704 \D14D\C2A4\D2B8=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105285344318309685)
,p_name=>'F4000.P4045.IMAGE='
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105285984754309686)
,p_name=>'F4000.P4045.ITEM='
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105285574123309685)
,p_name=>'F4000.P4045.LIST='
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105017811081309483)
,p_name=>'F4000.P4045.MENU_OPTION='
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D56D\BAA9=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105285796394309685)
,p_name=>'F4000.P4045.PAGE='
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105286108976309686)
,p_name=>'F4000.P4045.PROCESS='
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104908390252309403)
,p_name=>'F4000.P4045.REGION='
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105282912169309683)
,p_name=>'F4000.P4045.REQUIRED_BY_EVERY_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C758 \BAA8\B4E0 \D398\C774\C9C0\C5D0 \D544\C694\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105285022857309685)
,p_name=>'F4000.P4045.REQUIRED_TO_DISPLAY_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105285127571309685)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105285226335309685)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105286300971309686)
,p_name=>'F4000.P4045.TAB_NAME='
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C774\B984=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105286474331309686)
,p_name=>'F4000.P4045.TAB_SET='
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C9D1\D569=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105285624502309685)
,p_name=>'F4000.P4045.TEXT='
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105286254015309686)
,p_name=>'F4000.P4045.VALIDATION='
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105295338377309693)
,p_name=>'F4000.P420.CSV_EXPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105295910036309693)
,p_name=>'F4000.P420.CVS'
,p_message_language=>'ko'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105294966382309692)
,p_name=>'F4000.P420.DEFAULT_LOOK1'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BAA8\C591 1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105295044612309692)
,p_name=>'F4000.P420.DEFAULT_LOOK2'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BAA8\C591 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105295178807309692)
,p_name=>'F4000.P420.DEFAULT_LOOK3'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BAA8\C591 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105295274409309692)
,p_name=>'F4000.P420.DEFAULT_LOOK4'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BAA8\C591 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105294056523309692)
,p_name=>'F4000.P420.EXTERNAL_PAGINATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\BD80\C5D0\C11C \C0DD\C131\B41C \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \B2E8\CD94 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105294838116309692)
,p_name=>'F4000.P420.HTML_STD'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D45C\C900 \BAA8\C591')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105295535678309693)
,p_name=>'F4000.P420.LOOK1'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105295674455309693)
,p_name=>'F4000.P420.LOOK2'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105295743082309693)
,p_name=>'F4000.P420.LOOK3'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105295836002309693)
,p_name=>'F4000.P420.LOOK4'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105294521445309692)
,p_name=>'F4000.P420.ROWS_X_TO_Y'
,p_message_language=>'ko'
,p_message_text=>unistr('X-Y \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105294209065309692)
,p_name=>'F4000.P420.ROW_RANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD \BAA9\B85D\C758 \D589 \BC94\C704 1-15 16-30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105294771822309692)
,p_name=>'F4000.P420.SEARCH_ENGINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \C5D4\C9C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105294376903309692)
,p_name=>'F4000.P420.SEARCH_ENGINE_123'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \C5D4\C9C4 1,2,3,4(\D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C744 \AE30\C900\C73C\B85C \C124\C815)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105294671806309692)
,p_name=>'F4000.P420.SELECT_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105293887269309691)
,p_name=>'F4000.P420.SET_DEFAULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105293907798309691)
,p_name=>'F4000.P420.TURN_OFF_PAGINATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \D574\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105294460355309692)
,p_name=>'F4000.P420.USE_PAGINATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \B2E8\CD94 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105296071337309693)
,p_name=>'F4000.P420.XML'
,p_message_language=>'ko'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105295421321309693)
,p_name=>'F4000.P420.XML_EXPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('XML \C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105296101210309693)
,p_name=>'F4000.P422.GEN_LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105294120743309692)
,p_name=>'F4000.P429.ROWS_X_TO_Y'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BC94\C704 X-Y(\B2E4\C74C \BC0F \C774\C804 \B9C1\D06C \C0AC\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106121235032310384)
,p_name=>'F4000.P4311.P371.ALWAYS_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105420151176309794)
,p_name=>'F4000.P4311.P371.DB_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('DB \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105420384367309794)
,p_name=>'F4000.P4311.P371.PLSQL_EXP'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105420450220309794)
,p_name=>'F4000.P4311.P371.PLSQL_FUNC_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105420260426309794)
,p_name=>'F4000.P4311.P371.SQL_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105420035420309794)
,p_name=>'F4000.P4311.P371.STATIC_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105296205917309693)
,p_name=>'F4000.P4314_XBUTTON_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('DML \B2E8\CD94\C5D0\B294 \D2B9\C815 \B2E8\CD94 \C774\B984 \C989, \CC38\C870 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104962885237309442)
,p_name=>'F4000.P4450.ACTION_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C0C8 \D50C\B7EC\ADF8\C778\C774 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104962763077309442)
,p_name=>'F4000.P4450.ACTION_REPLACE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C788\B294 \AE30\C874 \D50C\B7EC\ADF8\C778\C774 \BC14\B01D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105296307567309693)
,p_name=>'F4000.P4651.HTML_W_SHORTCUTS'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML(\B2E8\CD95\D0A4 \C0AC\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105296509704309693)
,p_name=>'F4000.P4651.PLSQL'
,p_message_language=>'ko'
,p_message_text=>'PLSQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105287238292309687)
,p_name=>'F4000.P4656.DEFAULT_BUTTON_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \B2E8\CD94 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105008294897309476)
,p_name=>'F4000.P4656.DEFAULT_CALENDAR_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \B2EC\B825 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106117596301310381)
,p_name=>'F4000.P4656.DEFAULT_CHART_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \CC28\D2B8 \C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105008081182309475)
,p_name=>'F4000.P4656.DEFAULT_DIALOG_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \B300\D654\C0C1\C790 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106117662276310381)
,p_name=>'F4000.P4656.DEFAULT_FORM_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D3FC \C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106118024667310381)
,p_name=>'F4000.P4656.DEFAULT_IRR_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \B300\D654\C2DD \BCF4\ACE0\C11C \C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105287103249309686)
,p_name=>'F4000.P4656.DEFAULT_LABEL_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \B808\C774\BE14 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106117787363310381)
,p_name=>'F4000.P4656.DEFAULT_LISTR_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BAA9\B85D \C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105287057254309686)
,p_name=>'F4000.P4656.DEFAULT_LIST_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106118251309310381)
,p_name=>'F4000.P4656.DEFAULT_MENUR_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C774\B3D9 \ACBD\B85C \C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105287345244309687)
,p_name=>'F4000.P4656.DEFAULT_MENU_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106117358826310381)
,p_name=>'F4000.P4656.DEFAULT_NAV_BAR_LIST_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0D0\C0C9\D45C\C2DC\C904 \BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106117028468310380)
,p_name=>'F4000.P4656.DEFAULT_NAV_LIST_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0D0\C0C9 \BA54\B274 \BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106116856436310380)
,p_name=>'F4000.P4656.DEFAULT_OPTION_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C120\D0DD\C801 \B808\C774\BE14 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105286783238309686)
,p_name=>'F4000.P4656.DEFAULT_PAGE_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105286802540309686)
,p_name=>'F4000.P4656.DEFAULT_REGION_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106117826450310381)
,p_name=>'F4000.P4656.DEFAULT_REPORTR_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BCF4\ACE0\C11C \C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105286919419309686)
,p_name=>'F4000.P4656.DEFAULT_REPORT_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106116939811310380)
,p_name=>'F4000.P4656.DEFAULT_REQUIRED_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D544\C218 \B808\C774\BE14 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106117237451310381)
,p_name=>'F4000.P4656.DEFAULT_SIDE_NAV_LIST_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \CE21\BA74 \D0D0\C0C9 \BA54\B274 \BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106117946024310381)
,p_name=>'F4000.P4656.DEFAULT_TABFORM_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D45C \D615\C2DD \D3FC \C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106117114073310380)
,p_name=>'F4000.P4656.DEFAULT_TOP_NAV_LIST_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C704\CABD \D0D0\C0C9 \BA54\B274 \BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106118156871310381)
,p_name=>'F4000.P4656.DEFAULT_WIZARD_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \B9C8\BC95\C0AC \C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105286670930309686)
,p_name=>'F4000.P4656.ERROR_PAGE_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C624\B958 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106117486425310381)
,p_name=>'F4000.P4656.LOGIN_PAGE_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \B85C\ADF8\C778 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105286515425309686)
,p_name=>'F4000.P4656.PRINT_MODE_PAGE_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C778\C1C4 \BAA8\B4DC \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105293769614309691)
,p_name=>'F4000.P4703.REPORT_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105290394869309689)
,p_name=>'F4000.P4717.ALERT_INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\BCF4 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105290544296309689)
,p_name=>'F4000.P4717.NEW_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105290203682309689)
,p_name=>'F4000.P4717.REGION_MUST_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9\C744 \C0DD\C131\D558\B824\BA74 \C601\C5ED\C744 \D55C \AC1C \C774\C0C1 \C0DD\C131\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105290447772309689)
,p_name=>'F4000.P4717.USE_WIZARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\BC95\C0AC\B97C \C0AC\C6A9\D558\C5EC \C0C8 \C601\C5ED \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105291716102309690)
,p_name=>'F4000.P4719.ALPHABETIC_SORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C790\C21C\C73C\B85C \C815\B82C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105291906502309690)
,p_name=>'F4000.P4719.BIND_VAR_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608 4: \BC14\C778\B4DC \BCC0\C218\B97C \C0AC\C6A9\D558\B294 \AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105291854200309690)
,p_name=>'F4000.P4719.CREATION_SORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\C21C\C73C\B85C \C815\B82C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105291402465309690)
,p_name=>'F4000.P4719.D_R_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608 2: \B3D9\C77C\D55C \D45C\C2DC \AC12\ACFC \BC18\D658 \AC12\C744 \C0AC\C6A9\D558\B294 \AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105384264464309761)
,p_name=>'F4000.P4719.INLINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608\C81C 5: \C9C8\C758\C5D0 \C778\B77C\C778 \C9C8\C758\AC00 \D3EC\D568\B429\B2C8\B2E4. SQL \BB38\C758 \CCAB\BC88\C9F8 FROM \C808\C774 \C778\B77C\C778 \C9C8\C758\C5D0 \C18D\D558\C9C0 \C54A\B294\C9C0 \D655\C778\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105291322370309690)
,p_name=>'F4000.P4719.SQL_QUERY_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608 1: SQL \C9C8\C758 \AE30\BC18 \AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105291612511309690)
,p_name=>'F4000.P4719.STATIC_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608 3: \C815\C801 \BAA9\B85D \C608')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105291554616309690)
,p_name=>'F4000.P4719.USE_ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B458 \B2E4\C5D0 \B300\D574 \B3D9\C77C\D55C \C5F4\C744 \C120\D0DD\D558\BA74 \D45C\C2DC \AC12\ACFC \BC18\D658 \AC12\C740 \C5F4 \BCC4\CE6D\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104961757000309441)
,p_name=>'F4000.P4719.YN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608/\C544\B2C8\C624 \D45C\C2DC, Y \BC0F N \BC18\D658')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105297136053309694)
,p_name=>'F4000.P4728.AFTER_PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC \D6C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105296860658309694)
,p_name=>'F4000.P4728.BEFORE_COMPUTATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105297040252309694)
,p_name=>'F4000.P4728.BEFORE_PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC \C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105296962193309694)
,p_name=>'F4000.P4728.BEFORE_VALIDATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104968141219309446)
,p_name=>'F4000.P4731.ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105297283651309694)
,p_name=>'F4000.P4731.APPLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104965083372309444)
,p_name=>'F4000.P4731.DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105297465692309694)
,p_name=>'F4000.P4731.FINISH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105297315565309694)
,p_name=>'F4000.P4731.SUBMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105297645078309694)
,p_name=>'F4000.P4735_RP_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C740 \C774 \D504\B85C\C2DC\C800\AC00 \C2E4\D589\B420 \B54C \C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \BAA8\B4E0 \D398\C774\C9C0\C5D0 \B300\D574 \C7AC\C124\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105309749246309704)
,p_name=>'F4000.P4738.REGEXP_WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: \C815\ADDC \D45C\D604\C2DD \C720\D615\C758 \AC80\C99D\C744 \C120\D0DD\D588\C9C0\B9CC \C0AC\C6A9\C790\C758 \B370\C774\D130\BCA0\C774\C2A4 \BC84\C804\C774 \C774\B97C \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \C774 \AC80\C99D\C740 \D56D\C0C1 True\B97C \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106046630176310315)
,p_name=>'F4000.P4761.TRANSLATIONS_NOT_USED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \BC88\C5ED\C774 \D604\C7AC \C0AC\C6A9\C73C\B85C \C124\C815\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4. <a href="%0">\C804\C5ED \C18D\C131</a>\C758 <em>\B2E4\C74C\C5D0\C11C \D30C\C0DD\B41C \C560\D50C\B9AC\CF00\C774\C158 \C5B8\C5B4</em> \C124\C815\C744 \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106108816027310373)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_IDLE_SEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \C138\C158 \C720\D734 \C2DC\AC04\C774 \C124\C815\B418\C9C0 \C54A\C740 \ACBD\C6B0, \C791\C5C5\C601\C5ED \B808\BCA8 \B610\B294 \C778\C2A4\D134\C2A4 \B808\BCA8 \AC12\C774 \C0AC\C6A9\B429\B2C8\B2E4(\D604\C7AC %0\CD08).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106108935272310373)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \C138\C158 \AE38\C774\AC00 \C124\C815\B418\C9C0 \C54A\C740 \ACBD\C6B0, \C791\C5C5\C601\C5ED \B808\BCA8 \B610\B294 \C778\C2A4\D134\C2A4 \B808\BCA8 \AC12\C774 \C0AC\C6A9\B429\B2C8\B2E4(\D604\C7AC %0\CD08).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106099356345310364)
,p_name=>'F4000.P593.NEW_BRANCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105410405377309780)
,p_name=>'F4000.P598.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \AD6C\C131\C694\C18C\B294 \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C774\B098 \B2E4\B978 \C791\C5C5\C601\C5ED\C758 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C775\C2A4\D3EC\D2B8\B418\C5C8\C2B5\B2C8\B2E4. \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \AD6C\C131\C694\C18C\B97C \C124\CE58\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105414487507309789)
,p_name=>'F4000.P612.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \D30C\C77C\C774 \B2E4\B978 \C791\C5C5\C601\C5ED\C5D0\C11C \C775\C2A4\D3EC\D2B8\B418\C5C8\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C601\C5ED\C5D0 \D30C\C77C\C744 \C124\CE58\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106099415395310364)
,p_name=>'F4000.P622.TO_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106100231365310365)
,p_name=>'F4000.P623.COPY_OPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC \C635\C158: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106100330497310365)
,p_name=>'F4000.P623.EXISTING_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \AC12 \BAA9\B85D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105351373478309736)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B294 \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C774\B098 \B2E4\B978 \C791\C5C5\C601\C5ED\C758 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C775\C2A4\D3EC\D2B8\B418\C5C8\C2B5\B2C8\B2E4. \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \D398\C774\C9C0\B97C \C124\CE58\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105252766819309661)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B294 \B2E4\B978 \C791\C5C5\C601\C5ED\C758 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C775\C2A4\D3EC\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105252661989309661)
,p_name=>'F4000.P67.EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B294 \D604\C7AC \C791\C5C5\C601\C5ED\C758 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C775\C2A4\D3EC\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105671678697310005)
,p_name=>'F4000.P67.PAGE_LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B294 \D604\C7AC \C7A0\ACA8 \C788\C2B5\B2C8\B2E4. \C7A0\AE34 \D398\C774\C9C0\B85C \C784\D3EC\D2B8\D560 \C218\B294 \C5C6\C2B5\B2C8\B2E4. \D398\C774\C9C0 \C7A0\AE08\C744 \D574\C81C\D55C \B2E4\C74C \C124\CE58\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106097906630310363)
,p_name=>'F4000.P712.CLEAR_PARENT_ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D56D\BAA9 \C9C0\C6B0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106099723322310364)
,p_name=>'F4000.P765.SELECT_PARAM'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B9E4\AC1C\BCC0\C218 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105071692733309521)
,p_name=>'F4000.P818.VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC\B420 \CCB4\ACC4\B97C \D55C \AC1C \C774\C0C1 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106099965925310365)
,p_name=>'F4000.P875.HTTP_HEADER_VAL'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP \D5E4\B354 %0\C758 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106099838465310365)
,p_name=>'F4000.P875.INPUT_PARAM_VAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825 \B9E4\AC1C\BCC0\C218 %0\C758 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106100147572310365)
,p_name=>'F4000.P876.DELETE_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D5E4\B354 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106100087406310365)
,p_name=>'F4000.P876.DELETE_PARAM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218 \C0AD\C81C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105299458721309696)
,p_name=>'F4000.P904.REQUIRED_STYLE_SHEET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C218 \C2A4\D0C0\C77C \C2DC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105268524689309672)
,p_name=>'F4000.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105283115823309684)
,p_name=>'F4000.PAGE_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105254679488309662)
,p_name=>'F4000.PAGE_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105009428092309476)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B3D9\C801 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104870403921309372)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B3D9\C801 \C791\C5C5 - \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105253355941309661)
,p_name=>'F4000.PAGE_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104872691307309374)
,p_name=>'F4000.PAGE_ITEM_GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105287572750309687)
,p_name=>'F4000.PAGE_MAYBE_PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105268688431309672)
,p_name=>'F4000.PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105254786726309662)
,p_name=>'F4000.PAGE_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105283045044309683)
,p_name=>'F4000.PAGE_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105283288766309684)
,p_name=>'F4000.PAGE_VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AC80\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105255515142309663)
,p_name=>'F4000.PARENT_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105269572997309673)
,p_name=>'F4000.POPUP_LOV_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105886741836310174)
,p_name=>'F4000.PRINT_CREDENTIALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\ACA9 \C778\C1C4 \C11C\BC84 \C778\C99D\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105270194584309673)
,p_name=>'F4000.PUBLISH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC8C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105254149720309662)
,p_name=>'F4000.REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105883255044310171)
,p_name=>'F4000.REGION_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105268783849309672)
,p_name=>'F4000.RELATED_PAGES_AND_COMPONENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B828 \D398\C774\C9C0 \BC0F \AD6C\C131\C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105886900685310174)
,p_name=>'F4000.REMOTE_DATABASE'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105384045501309761)
,p_name=>'F4000.REPORT_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104899748190309397)
,p_name=>'F4000.REST_ENABLED_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105270053232309673)
,p_name=>'F4000.SEED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105255409724309663)
,p_name=>'F4000.STANDARD_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105282665489309683)
,p_name=>'F4000.STATIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105269325078309673)
,p_name=>'F4000.TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105269677725309673)
,p_name=>'F4000.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105113482056309552)
,p_name=>'F4000.TEMPLATE_NAME_ALREADY_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C774\B984 %0\C774(\AC00) \C874\C7AC\D569\B2C8\B2E4. \C0C8 \C774\B984\C744 \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105071755235309522)
,p_name=>'F4000.TEMPLATE_NAME_MAND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C774\B984\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105269840601309673)
,p_name=>'F4000.THEME_IMPORT_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C0C8 \D14C\B9C8\AC00 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105269966173309673)
,p_name=>'F4000.THEME_IMPORT_REPLACE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C788\B294 \AE30\C874 \D14C\B9C8\AC00 \BC14\B01D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105268971912309673)
,p_name=>'F4000.TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105256025387309663)
,p_name=>'F4000.UNKNOWN_APPLICATION_ELEMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C \C218 \C5C6\B294 \C560\D50C\B9AC\CF00\C774\C158 \C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105270262205309674)
,p_name=>'F4000.UPDATEABLE_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105395411324309769)
,p_name=>'F4000.UTILITIES.INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D2F8\B9AC\D2F0\C5D0\B294 \C120\D0DD\D55C \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0 \C788\B294 \BAA8\B4E0 \D398\C774\C9C0\C758 \ADF8\B9AC\B4DC \D3B8\C9D1 \D398\C774\C9C0 \BC0F \BCF4\ACE0\C11C\AC00 \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105254890335309662)
,p_name=>'F4000.VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104899830271309397)
,p_name=>'F4000.WEB_SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105887058201310174)
,p_name=>'F4000.WEB_SRC_MODULE'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105253024389309661)
,p_name=>'F4000.YES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105329183568309720)
,p_name=>'F4000_4738_DATE_MMDDYYY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC: MMDDYYYY')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105482805146309846)
,p_name=>'F4000_APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105034991370309495)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14\C758 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105287988322309687)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14\C758 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105299510907309696)
,p_name=>'F4000_BUTTON_POS_NOT_IN_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD94 \C704\CE58\AC00 \C601\C5ED \D15C\D50C\B9AC\D2B8\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106035598834310305)
,p_name=>'F4000_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105299819333309696)
,p_name=>'F4000_CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EB\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105316402469309710)
,p_name=>'F4000_COPY_AND_SUBSCRIBE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC \BC0F \C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105300102513309696)
,p_name=>'F4000_DATE_NOT_REC'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \D615\C2DD\C744 \C778\C2DD\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104967890417309446)
,p_name=>'F4000_F1500_LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105399284246309772)
,p_name=>'F4000_HELP_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105481979080309845)
,p_name=>'F4000_LOV_NAME_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \C774\B984 %0\C774(\AC00) \C874\C7AC\D569\B2C8\B2E4. \C0C8 \C774\B984\C744 \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105323071900309715)
,p_name=>'F4000_NONE_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \D56D\BAA9 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105279343695309681)
,p_name=>'F4000_NO_APP_ASSOC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B41C \C560\D50C\B9AC\CF00\C774\C158 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104911165537309405)
,p_name=>'F4000_OFF'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104911023769309405)
,p_name=>'F4000_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104971496174309449)
,p_name=>'F4000_P122_CAL_TEMPL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D15C\D50C\B9AC\D2B8\B97C \CC38\C870\D558\B294 \B2EC\B825 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105352261781309737)
,p_name=>'F4000_P128.VIEW_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \C720\D615\C758 \D398\C774\C9C0 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105080758068309528)
,p_name=>'F4000_P173_NO_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C5D0 \B300\D55C \B3C4\C6C0\B9D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105072702717309522)
,p_name=>'F4000_P1_AUTHENTICATION_HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105072645216309522)
,p_name=>'F4000_P1_EDIT_THIS_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D15C\D50C\B9AC\D2B8 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105088229212309533)
,p_name=>'F4000_P232_RESET_CSS'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105693768013310024)
,p_name=>'F4000_P295_PAGE_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C788\B294 \D398\C774\C9C0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104968207389309446)
,p_name=>'F4000_P295_PAGE_MUST_BE_NUMERIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B294 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104968314207309446)
,p_name=>'F4000_P295_PAGE_MUST_BE_POSITIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B294 \C591\C218\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104968410463309446)
,p_name=>'F4000_P295_PAGE_MUST_BE_WHOLE_NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B294 \C815\C218\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105400530105309773)
,p_name=>'F4000_P3005.IMPORT_AUTHORIZATION SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4 \C784\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105350068930309735)
,p_name=>'F4000_P3005.IMPORT_AUTH_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4 \C784\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105400633954309773)
,p_name=>'F4000_P3005.IMPORT_NAVBAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904 \C784\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105350132337309735)
,p_name=>'F4000_P3005.IMPORT_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C784\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105298057792309694)
,p_name=>'F4000_P33_REGION_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C \D615\C2DD \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105328865793309719)
,p_name=>'F4000_P3890_AUTHENTICATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\B418\C5C8\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105328948944309719)
,p_name=>'F4000_P3890_AUTH_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105320725034309713)
,p_name=>'F4000_P395_NO_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105301389017309697)
,p_name=>'F4000_P4001_UNAVAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C740 \D604\C7AC \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105050269240309506)
,p_name=>'F4000_P430_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105050357253309506)
,p_name=>'F4000_P430_DATE2'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\B3D9 \AC00\B2A5\D55C \B0A0\C9DC: %0(\C784\C758\C758 \AD6C\BD84 \AE30\D638 \C0AC\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105051082664309507)
,p_name=>'F4000_P430_DATE2_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \D615\C2DD\C744 \C778\C2DD\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105050943635309507)
,p_name=>'F4000_P430_DATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC\B294 %0 \D615\C2DD\C774\C5B4\C57C \D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105049765015309506)
,p_name=>'F4000_P430_IP'
,p_message_language=>'ko'
,p_message_text=>unistr('IP \C8FC\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105050533699309506)
,p_name=>'F4000_P430_IP_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C IP \C8FC\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105049811189309506)
,p_name=>'F4000_P430_PHONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\D654\BC88\D638, \BBF8\AD6D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105049969314309506)
,p_name=>'F4000_P430_PHONE2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\D654\BC88\D638, \BBF8\AD6D(\C790\C720 \D615\C2DD): 999.999.9999, (999)-999-9999, 999 999 9999, \B4F1...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105050710623309506)
,p_name=>'F4000_P430_PHONE2_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\D654\BC88\D638 \D615\C2DD\C744 \C778\C2DD\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105050659925309506)
,p_name=>'F4000_P430_PHONE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\D654\BC88\D638\B294 %0 \D615\C2DD\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105049656017309506)
,p_name=>'F4000_P430_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('URL: http(s)://domain/path/doc.(pdf)(html)(\B4F1...)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105050418770309506)
,p_name=>'F4000_P430_URL_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105050026924309506)
,p_name=>'F4000_P430_ZIP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6B0\D3B8 \BC88\D638: 99999')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105050174391309506)
,p_name=>'F4000_P430_ZIP2'
,p_message_language=>'ko'
,p_message_text=>'ZIP + 4: 99999-9999'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105050872313309507)
,p_name=>'F4000_P430_ZIP_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6B0\D3B8 \BC88\D638\B294 %0 \D615\C2DD\C774\C5B4\C57C \D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104981165269309456)
,p_name=>'F4000_P4495.COPIED_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104981214008309456)
,p_name=>'F4000_P4495.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C778\C99D \CCB4\ACC4\C758 "\B9C8\C2A4\D130" \BCF5\C0AC\BCF8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104981487844309456)
,p_name=>'F4000_P4495.NO_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C778\C99D \CCB4\ACC4\C5D0 \B300\D55C \AC00\C785\C790\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104981305946309456)
,p_name=>'F4000_P4495.REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C778\C99D \CCB4\ACC4\C5D0 \C801\C6A9 \C911\C778 \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105036153189309496)
,p_name=>'F4000_P4495_LOV_NO_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('- \CCB4\ACC4 \C5C6\C74C -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105296613172309693)
,p_name=>'F4000_P4701_PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105301452244309697)
,p_name=>'F4000_P4705_FORM_ON_A_PROC'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \D504\B85C\C2DC\C800 \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105296797333309694)
,p_name=>'F4000_P4710_PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105300782085309697)
,p_name=>'F4000_P4717_DISPLAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C804\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105300639466309696)
,p_name=>'F4000_P4717_HIDDEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105300381683309696)
,p_name=>'F4000_P4734_CLEAR_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \CE90\C2DC \BE44\C6B0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105300294109309696)
,p_name=>'F4000_P4734_CLEAR_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \CE90\C2DC \BE44\C6B0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105323346565309715)
,p_name=>'F4000_P4734_RESET_PAG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105300590390309696)
,p_name=>'F4000_P4734_SET_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38\C744 \C0AC\C6A9\D558\C5EC \D56D\BAA9 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105300437997309696)
,p_name=>'F4000_P4734_STATIC_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \D56D\BAA9 \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105297582889309694)
,p_name=>'F4000_P4735_INITIALIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C560\D50C\B9AC\CF00\C774\C158\C5D0 \CE90\C2DC\B418\C9C0 \C54A\C740 \BAA8\B4E0 \D398\C774\C9C0 \D56D\BAA9\C740 \B110\B85C \CD08\AE30\D654\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105301190003309697)
,p_name=>'F4000_P4737_EXISTS'
,p_message_language=>'ko'
,p_message_text=>'Exists'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105300823355309697)
,p_name=>'F4000_P4737_ITEM_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110\C774 \C544\B2CC \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105300910353309697)
,p_name=>'F4000_P4737_ITEM_NOT_ZERO'
,p_message_language=>'ko'
,p_message_text=>unistr('0\C774 \C544\B2CC \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105301020742309697)
,p_name=>'F4000_P4737_PLSQL_EXP'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105329317794309720)
,p_name=>'F4000_P4738_DATE_DDMMYYYY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC DDMMYYYY')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105329230371309720)
,p_name=>'F4000_P4738_PHONE_NUM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\D654\BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106067625568310335)
,p_name=>'F4000_P473_DATABASE_OBJECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105297735528309694)
,p_name=>'F4000_P4759_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE0C\B77C\C6B0\C800\C5D0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105297881309309694)
,p_name=>'F4000_P4785_REGION_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105036390512309496)
,p_name=>'F4000_P4790_DATE_TIMESTAMP_NOTE'
,p_message_language=>'ko'
,p_message_text=>unistr('(\B0A0\C9DC \B610\B294 \C2DC\AC04 \C2A4\D0EC\D504 \C5F4 \D3EC\D568)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105516135489309874)
,p_name=>'F4000_P4790_SYNTAX_HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BB38: select id, name, date from ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105516471257309874)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE1'
,p_message_language=>'ko'
,p_message_text=>unistr('ROWID \C758\C0AC \C5F4\C744 \C0AC\C6A9\D558\B294 \C608\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105516501935309874)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4 \D14C\C774\BE14 \AE30\BCF8 \D0A4\B97C \C0AC\C6A9\D558\B294 \C608\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105516282359309874)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE1'
,p_message_language=>'ko'
,p_message_text=>unistr('1. \CD5C\C18C\D55C \C5F4 2\AC1C\B97C \D3EC\D568\D574\C57C \D558\BA70 \ADF8 \C911 \D558\B098\B294 DATE \C5F4\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105516379551309874)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE2'
,p_message_language=>'ko'
,p_message_text=>unistr('2. \CCAB\BC88\C9F8 \C5F4\C740 DML(\B370\C774\D130 \C870\C791 \C5B8\C5B4) \C791\C5C5 \AD00\B9AC\B97C \C704\D574 \C0AC\C6A9\B418\B294 \AE30\BCF8 \D0A4 \C5F4\C744 \C2DD\BCC4\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105297960284309694)
,p_name=>'F4000_P4810_PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105411035044309780)
,p_name=>'F4000_P48_MANIFEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \C775\C2A4\D3EC\D2B8 Manifest    ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105352167270309737)
,p_name=>'F4000_P497.VIEW_PAGE_DEF'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C815\C758 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105298190426309695)
,p_name=>'F4000_P5100_PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\C57D \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105316744036309710)
,p_name=>'F4000_P52_TAB_LINK_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C9D1\D569\C744 \C124\C815\D558\B824\BA74 \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105570838558309919)
,p_name=>'F4000_P643_NO_PARENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B294 \B450 \B808\BCA8\C758 \D0ED\C744 \C9C0\C6D0\D558\C9C0\B9CC \D45C\C900 \D0ED\C740 \C0C1\C704 \D0ED \C9D1\D569\C744 \C2DD\BCC4\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105570743497309919)
,p_name=>'F4000_P643_NO_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C5C6\C74C, \C774 \D398\C774\C9C0\B294 \D0ED\C744 \D45C\C2DC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105570514713309918)
,p_name=>'F4000_P643_ONE_LVL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B294 \D55C \B808\BCA8\C758 \D0ED\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105570991050309919)
,p_name=>'F4000_P643_PAGE_NO_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED\C774 \C5C6\B294 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105571066435309919)
,p_name=>'F4000_P643_PAGE_NO_TAB_TTL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D %0\D398\C774\C9C0\C5D0 \C815\C758\B41C \D0ED\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105570422388309918)
,p_name=>'F4000_P643_TAB_DISPLAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105570655064309919)
,p_name=>'F4000_P643_TWO_LVL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B294 \B450 \B808\BCA8\C758 \D0ED\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106018350195310288)
,p_name=>'F4000_P78_UPGRADE_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>Oracle APEX %0\C744(\B97C) \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</strong> \C778\C2A4\D134\C2A4\AC00 <strong>%1</strong>\C5D0\C11C \C790\B3D9\C73C\B85C \C5C5\ADF8\B808\C774\B4DC\B429\B2C8\B2E4. \AD00\B9AC \C11C\BE44\C2A4\C5D0\C11C \C774 \B0A0\C9DC \C804 \C5B8\C81C\B77C\B3C4 \C778\C2A4\D134\C2A4 \AD00\B9AC\C790\AC00 \C5C5\ADF8\B808\C774\B4DC\B97C \C2DC\C791\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>Oracle APEX %0\C758 \C0C8 \AE30\B2A5 \BC0F \D5A5\C0C1\B41C \AE30\B2A5\C5D0 \B300\D55C \C790\C138\D55C \B0B4\C6A9\C740 <a href="%2" target="_blank" rel="noreferrer">\ACF5\ACE0</a>\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106018252407310288)
,p_name=>'F4000_P78_UPGRADING'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0 \C778\C2A4\D134\C2A4\B97C \C0C8 \B9B4\B9AC\C2A4\B85C \C5C5\ADF8\B808\C774\B4DC\D558\B294 \C911\C785\B2C8\B2E4.</strong> \C5C5\ADF8\B808\C774\B4DC \D504\B85C\C138\C2A4 \C911\C5D0\B294 \C77C\C815 \AE30\AC04 \B3D9\C548 \C560\D50C\B9AC\CF00\C774\C158 \BCC0\ACBD\C774 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B429\B2C8\B2E4. \CD5C\B300 %1\BD84 \B3D9\C548 \C560\D50C\B9AC\CF00\C774\C158 \BC0F %0 \AC1C\BC1C \D658\ACBD \C561\C138\C2A4\AC00 \C911\B2E8\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104980091616309455)
,p_name=>'F4000_P801_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104980968068309456)
,p_name=>'F4000_P801_ACTIVATE1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CCB4\ACC4\B97C \D604\C7AC\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104981092388309456)
,p_name=>'F4000_P801_ACTIVATE2'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105035983848309496)
,p_name=>'F4000_P801_CURRENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104980775312309456)
,p_name=>'F4000_P801_DEACTIVATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\D65C\C131 \C0C1\D0DC\B85C \BCC0\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104979579185309455)
,p_name=>'F4000_P801_DETAILS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104979661815309455)
,p_name=>'F4000_P801_DETAILS_BI1'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B0B4\BD80 "\CFE0\D0A4 \C0AC\C6A9\C790" \ACC4\C815 \C800\C7A5\C18C\C5D0 \B300\D55C \B0B4\C7A5 \C138\C158 \AD00\B9AC \B17C\B9AC, \B0B4\C7A5 \B85C\ADF8\C778 \D398\C774\C9C0 \BC0F \C0AC\C6A9\C790 \C778\C99D\C785\B2C8\B2E4.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104979754709309455)
,p_name=>'F4000_P801_DETAILS_OBS1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BC29\C2DD\C740 "\CCB4\ACC4" \C778\C99D\C73C\B85C \AD50\CCB4\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105033952866309494)
,p_name=>'F4000_P801_EDIT_DEPRECATED1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\B418\C9C0 \C54A\B294 \C778\C99D \C18D\C131 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105034065343309494)
,p_name=>'F4000_P801_EDIT_DEPRECATED2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\B418\C9C0 \C54A\B294 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105034178834309494)
,p_name=>'F4000_P801_EDIT_DEPRECATED3'
,p_message_language=>'ko'
,p_message_text=>unistr('\B610\B294 \C778\C99D \BC29\C2DD\C744 %0(\C73C)\B85C \BCC0\ACBD\D560 \C900\BE44\AC00 \B420 \B54C\AE4C\C9C0 \ADF8\B300\B85C \B450\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105034474285309495)
,p_name=>'F4000_P801_EDIT_DEPRECATED4'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B098 \C774\C0C1\C758 \C0AC\C6A9\B418\C9C0 \C54A\B294 \C778\C99D \C18D\C131\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105034607703309495)
,p_name=>'F4000_P801_EDIT_DEPRECATED5'
,p_message_language=>'ko'
,p_message_text=>unistr('\B610\B294 \C778\C99D \CCB4\ACC4\B85C \C774\C804\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105033683575309494)
,p_name=>'F4000_P801_FLOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104980615681309455)
,p_name=>'F4000_P801_MANAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704 \BCF4\ACE0\C11C\B97C \C0AC\C6A9\D558\C5EC \C778\C99D \CCB4\ACC4\B97C \AD00\B9AC\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104979417812309455)
,p_name=>'F4000_P801_METHOD'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C18C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105035887571309496)
,p_name=>'F4000_P801_NO_EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('(\D3B8\C9D1\D560 \C218 \C5C6\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104980889312309456)
,p_name=>'F4000_P801_PAREN_CURRENT'
,p_message_language=>'ko'
,p_message_text=>unistr('(\D604\C7AC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105033723303309494)
,p_name=>'F4000_P801_PAREN_DEPRECATED'
,p_message_language=>'ko'
,p_message_text=>unistr('(\C0AC\C6A9\B418\C9C0 \C54A\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104980506892309455)
,p_name=>'F4000_P801_PAREN_NONE'
,p_message_language=>'ko'
,p_message_text=>unistr('(\C5C6\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104979946663309455)
,p_name=>'F4000_P801_PUBLIC_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104980123620309455)
,p_name=>'F4000_P801_REVIEW1'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\D1A0 \B610\B294 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104980299140309455)
,p_name=>'F4000_P801_REVIEW2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104980330239309455)
,p_name=>'F4000_P801_REVIEW3'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C5D0\C11C \C774 \D50C\B85C\C6B0\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104980408795309455)
,p_name=>'F4000_P801_REVIEW4'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C18D\C131 \D398\C774\C9C0\C758 \C774 \C560\D50C\B9AC\CF00\C774\C158 \B610\B294 \C704 \BCF4\ACE0\C11C\B97C \C0AC\C6A9\D558\C5EC \C778\C99D \BC29\C2DD\C744 %0(\C73C)\B85C \BCC0\ACBD\D560 \B54C \C0AC\C6A9\D560 \C218 \C788\B294 \C778\C99D \CCB4\ACC4\B97C \C0DD\C131 \BC0F \AD00\B9AC\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105034233794309494)
,p_name=>'F4000_P801_REVIEW5'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C138\C158 \AD00\B9AC \C18D\C131 \AC80\D1A0 \B610\B294 \D3B8\C9D1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105034514371309495)
,p_name=>'F4000_P801_REVIEW6'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \D56D\BAA9 \AC80\D1A0 \B610\B294 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105033818046309494)
,p_name=>'F4000_P801_SCHEME_CONVERT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C778\C99D\C740 \C0AC\C6A9\B418\C9C0 \C54A\B294 \BC29\C2DD\C785\B2C8\B2E4. \C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \C778\C99D \CCB4\ACC4 \C911 \D558\B098\C5D0\C11C "\D604\C7AC\B85C \C124\C815" \B9C1\D06C(\C704\C5D0 \D45C\C2DC\B428)\B97C \B204\B974\AC70\B098, \C0C8 \C778\C99D \CCB4\ACC4\B97C \C0DD\C131\D558\C5EC \D604\C7AC\B85C \C124\C815\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4. INTERNAL-SETUP \C778\C99D \CCB4\ACC4\B294 \AE30\B2A5\BA74\C5D0\C11C %0 \BC29\C2DD\ACFC \AC19\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105034350417309495)
,p_name=>'F4000_P801_SCHEME_DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4\B97C \C0AC\C6A9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \C0AC\C6A9\C790 \C778\C99D \BC0F \B2E4\B978 \BAA8\B4E0 \C138\C158 \AD00\B9AC \C694\C18C\B97C \C81C\C5B4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105298467591309695)
,p_name=>'F4000_P805_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804 \B2E8\ACC4\C5D0\C11C \D398\C774\C9C0 \AC10\C2DC \D568\C218\B97C \C9C0\C815\D588\C2B5\B2C8\B2E4. \C774 \D568\C218\AC00 \AC01 \D398\C774\C9C0\C5D0 \B300\D574 \C138\C158 \D655\C778 \C791\C5C5\C744 \C218\D589\D560 \AC83\C774\BBC0\B85C \C5EC\AE30\C5D0 \C138\C158 \D655\C778 \D568\C218\B97C \C785\B825\D558\C9C0 \C54A\C544\B3C4 \B429\B2C8\B2E4. \C774 \BC29\BC95\C744 \C6D0\D558\C9C0 \C54A\C73C\BA74 \C774 \B9C8\BC95\C0AC\C758 \C774\C804 \B2E8\ACC4\B85C \B418\B3CC\C544\AC00 \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105036941034309496)
,p_name=>'F4000_P806_BUILTIN_LOGIN_PG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \B85C\ADF8\C778 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105037338751309497)
,p_name=>'F4000_P806_NONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105037014670309497)
,p_name=>'F4000_P806_PAGE_IN_THIS_FLOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105037255795309497)
,p_name=>'F4000_P806_SSO_SERVER'
,p_message_language=>'ko'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105037165272309497)
,p_name=>'F4000_P806_URL'
,p_message_language=>'ko'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105037431517309497)
,p_name=>'F4000_P808_AUTH_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \ACC4\C815 \C0AC\C6A9\C790 \C774\B984 \BC0F \BE44\BC00\BC88\D638\B97C \C0AC\C6A9\D558\C5EC \C778\C99D\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104923241225309414)
,p_name=>'F4000_P808_DBAUTH_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \ACC4\C815 \C0AC\C6A9\C790 \C774\B984 \BC0F \BE44\BC00\BC88\D638\B97C \C0AC\C6A9\D558\C5EC \C778\C99D\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105037594557309497)
,p_name=>'F4000_P808_NO_VERIFY_CRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C99D\BA85\C11C \D655\C778 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105037772122309497)
,p_name=>'F4000_P808_USE_CUSTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4 \C0AC\C6A9\C790\C815\C758 \D568\C218\B97C \C0AC\C6A9\D558\C5EC \C778\C99D\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105037692862309497)
,p_name=>'F4000_P808_USE_LDAP'
,p_message_language=>'ko'
,p_message_text=>unistr('LDAP \C11C\BC84\B97C \C0AC\C6A9\D558\C5EC \C778\C99D\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105301585670309697)
,p_name=>'F4000_P80_NO_PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('- \D398\C774\C9C0 \C774\B984 \C5C6\C74C -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104982167644309457)
,p_name=>'F4000_P811_AUTH'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C778\C99D \D568\C218'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104982971152309457)
,p_name=>'F4000_P811_C_DOMAIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\CFE0\D0A4 \B3C4\BA54\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104982737924309457)
,p_name=>'F4000_P811_C_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\CFE0\D0A4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104982869281309457)
,p_name=>'F4000_P811_C_PATH'
,p_message_language=>'ko'
,p_message_text=>unistr('\CFE0\D0A4 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104920326702309411)
,p_name=>'F4000_P811_C_SECURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104981987811309456)
,p_name=>'F4000_P811_INV_SESS_TGT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C138\C158 \B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104982457457309457)
,p_name=>'F4000_P811_LDAP_DN'
,p_message_language=>'ko'
,p_message_text=>unistr('LDAP \AC80\C0C9 \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104982526154309457)
,p_name=>'F4000_P811_LDAP_EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('LDAP \C0AC\C6A9\C790 \C774\B984 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104982273619309457)
,p_name=>'F4000_P811_LDAP_HOST'
,p_message_language=>'ko'
,p_message_text=>unistr('LDAP \D638\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104982353804309457)
,p_name=>'F4000_P811_LDAP_PORT'
,p_message_language=>'ko'
,p_message_text=>unistr('LDAP \D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104983054208309457)
,p_name=>'F4000_P811_LOGOUT_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C544\C6C3 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104981683179309456)
,p_name=>'F4000_P811_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104981534623309456)
,p_name=>'F4000_P811_PAREN_BUILTIN'
,p_message_language=>'ko'
,p_message_text=>unistr('(\B0B4\C7A5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104983148506309457)
,p_name=>'F4000_P811_PAREN_DBAUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('(\B370\C774\D130\BCA0\C774\C2A4 \C778\C99D)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104981702858309456)
,p_name=>'F4000_P811_PG_SENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AC10\C2DC \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104982689982309457)
,p_name=>'F4000_P811_POST_AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\D6C4 \C778\C99D \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104982053043309456)
,p_name=>'F4000_P811_PRE_AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \C778\C99D \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104981878594309456)
,p_name=>'F4000_P811_SESS_VERIFY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \D655\C778 \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105037997843309497)
,p_name=>'F4000_P815_COPY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C778\C99D \CCB4\ACC4\C758 \BCF5\C0AC\BCF8\C73C\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105038076534309497)
,p_name=>'F4000_P815_GALLERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC24\B7EC\B9AC\C758 \BBF8\B9AC \AD6C\C131\B41C \CCB4\ACC4\B97C \AE30\C900\C73C\B85C \D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105037831298309497)
,p_name=>'F4000_P815_SCRATCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC24\B7EC\B9AC\C758 \BBF8\B9AC \AD6C\C131\B41C \CCB4\ACC4\B97C \AE30\C900\C73C\B85C \D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104995729065309467)
,p_name=>'F4000_P817_REFRESH_AUTH_SCHEME_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4\B97C \C0C8\B85C\ACE0\CE68\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104983359607309457)
,p_name=>'F4000_P819_AUTH_METHOD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \BC29\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105051155289309507)
,p_name=>'F4000_P819_CURR_WARN'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \D604\C7AC \C778\C99D \CCB4\ACC4\B97C \C0AD\C81C\D558\B824\ACE0 \D569\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104983570702309458)
,p_name=>'F4000_P819_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104983282052309457)
,p_name=>'F4000_P819_FLOW_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104983453511309457)
,p_name=>'F4000_P819_SCHEME_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\ACC4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105038523622309498)
,p_name=>'F4000_P820_MY_PARTNER'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Application Server Single Sign-On(\B0B4 \C560\D50C\B9AC\CF00\C774\C158\C744 \D611\B825 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105038132541309497)
,p_name=>'F4000_P820_SHOW_ACCOUNT_CRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 \D398\C774\C9C0 \D45C\C2DC \BC0F %0 \ACC4\C815 \C99D\BA85\C11C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105038291810309497)
,p_name=>'F4000_P820_SHOW_BUILTIN_PG_OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \B85C\ADF8\C778 \D398\C774\C9C0 \D45C\C2DC \BC0F \ACF5\AC1C \C99D\BA85\C11C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105038336486309497)
,p_name=>'F4000_P820_SHOW_USE_LDAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 \D398\C774\C9C0 \D45C\C2DC \BC0F LDAP \B514\B809\D1A0\B9AC \C99D\BA85\C11C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105038440551309498)
,p_name=>'F4000_P820_SSO_HTMLDB_PARTNER'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Application Server Single Sign-On(%0 \C5D4\C9C4\C744 \D611\B825 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104983898723309458)
,p_name=>'F4000_P822_CURR_METHOD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C778\C99D \BC29\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104995892769309467)
,p_name=>'F4000_P826_CREATE1'
,p_message_language=>'ko'
,p_message_text=>unistr('Single Sign-On(Oracle \C0AC\C6A9 \C804\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104995994509309467)
,p_name=>'F4000_P826_CREATE2'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Application Server Single Sign-On(%0\C744(\B97C) \D611\B825 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104996020646309467)
,p_name=>'F4000_P826_CREATE3'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Application Server Single Sign-On(\B0B4 \C560\D50C\B9AC\CF00\C774\C158\C744 \D611\B825 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104996108538309467)
,p_name=>'F4000_P826_CREATE4'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \B85C\ADF8\C778 \D398\C774\C9C0: %0 \ACC4\C815 \C99D\BA85\C11C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105018621817309483)
,p_name=>'F4000_P826_CREATE4A'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C \C791\C131\B41C \B85C\ADF8\C778 \D398\C774\C9C0: %0 \ACC4\C815 \C99D\BA85\C11C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105018791354309483)
,p_name=>'F4000_P826_CREATE4B'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \B85C\ADF8\C778 \D398\C774\C9C0: %0 \ACC4\C815 \C99D\BA85\C11C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104996218238309467)
,p_name=>'F4000_P826_CREATE5'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \B85C\ADF8\C778 \D398\C774\C9C0: \ACF5\AC1C \C99D\BA85\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104996304796309467)
,p_name=>'F4000_P826_CREATE6'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \B85C\ADF8\C778 \D398\C774\C9C0: LDAP \B514\B809\D1A0\B9AC \C99D\BA85\C11C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105018481687309483)
,p_name=>'F4000_P826_CREATE6A'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C \C791\C131\B41C \B85C\ADF8\C778 \D398\C774\C9C0: LDAP \B514\B809\D1A0\B9AC \C99D\BA85\C11C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105018594741309483)
,p_name=>'F4000_P826_CREATE6B'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \B85C\ADF8\C778 \D398\C774\C9C0: LDAP \B514\B809\D1A0\B9AC \C99D\BA85\C11C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104996415916309467)
,p_name=>'F4000_P826_CREATE7'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC24\B7EC\B9AC\C758 \C778\C99D \CCB4\ACC4\B97C \AE30\C900\C73C\B85C \D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105038647213309498)
,p_name=>'F4000_P826_NEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C \B9CC\B4E4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105075374787309524)
,p_name=>'F4000_P88_FLASHBACK_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C758 \C2E4\D589 \CDE8\C18C \AE30\B2A5\C740 "\D50C\B798\C2DC\BC31 \C9C8\C758"\B77C\B294 \B0B4\C7A5 \B370\C774\D130\BCA0\C774\C2A4 \AE30\B2A5\C744 \C0AC\C6A9\D558\BBC0\B85C, \D2B9\C815 \C2DC\AC04\C758 \B370\C774\D130\B97C \C9C8\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105075135186309524)
,p_name=>'F4000_P88_SELECT_TIME'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3CC\C544\AC00\B824\B294 \C2DC\AC04\C744 \C120\D0DD\D55C \B2E4\C74C "\C801\C6A9"\C744 \B20C\B7EC \C18C\C2A4\B97C \B2E4\C2DC \C601\C5ED \D3B8\C9D1 \D398\C774\C9C0\C5D0 \C4F0\ACE0 \C774 \B300\D654\C0C1\C790\B97C \B2EB\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105075546378309524)
,p_name=>'F4000_P88_UNDO_RETENTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \B9E4\AC1C\BCC0\C218 "UNDO_RETENTION"\C5D0 \C900\D558\C5EC \CD5C\ADFC %0\C2DC\AC04 \B0B4\C5D0 \BC1C\C0DD\D55C \BCC0\ACBD\C0AC\D56D\B9CC \CDE8\C18C\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105076059066309525)
,p_name=>'F4000_P92_CONFIRM_CREATE_STD_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C560\D50C\B9AC\CF00\C774\C158\C5D0 \D45C\C900 \D0ED \C0DD\C131 \D655\C778:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105076423125309525)
,p_name=>'F4000_P92_NEW_TABSET_WILL_BE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \D0ED \C9D1\D569 %0\C774(\AC00) \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105076313027309525)
,p_name=>'F4000_P92_PAGE_WILL_USE_EXISTNG_TABSET'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D398\C774\C9C0\B294 \AE30\C874 \D0ED \C9D1\D569 "%1"\C744(\B97C) \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105076147124309525)
,p_name=>'F4000_P92_TABSET_INFO_INCOMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: \D0ED \C9D1\D569 \C815\BCF4\AC00 \BD88\C644\C804\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105517883926309876)
,p_name=>'F4000_P975_VALUE_FOR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105299996708309696)
,p_name=>'F4000_PREV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105288226889309687)
,p_name=>'F4000_QUICK_APP_FINISH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\AC70\B098 \D655\C7A5\D558\B824\BA74 <strong>\C644\B8CC</strong>\B97C \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105288082879309687)
,p_name=>'F4000_QUICK_APP_OPT_DISP1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D0D0\C0C9 \C9C0\C6D0 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105288177739309687)
,p_name=>'F4000_QUICK_APP_OPT_DISP2'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0\C5D0\C11C \AE30\BCF8 \D0A4 \C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105433747497309805)
,p_name=>'F4000_SHORTCUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105194385320309617)
,p_name=>'F4000_SVG_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('SVG \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105299676951309696)
,p_name=>'F4000_TOP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105399328819309772)
,p_name=>'F4000_TREE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105514717696309873)
,p_name=>'F4000_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104951606275309434)
,p_name=>'F4000_WS_ENTIRE_RESPONSE_DOC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \C751\B2F5 \BB38\C11C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104961622873309441)
,p_name=>'F400_P107_STEP'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B2E8\ACC4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104932347950309420)
,p_name=>'F4050.ACCEPTED'
,p_message_language=>'ko'
,p_message_text=>'DELETE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105516085271309874)
,p_name=>'F4050.ACCEPTED_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2B9\C778\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105386051982309762)
,p_name=>'F4050.ACTION_ASSIGN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8\AC00 \C791\C5C5\C601\C5ED\C5D0 \C9C0\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105386121565309762)
,p_name=>'F4050.ACTION_NO_ASSIGN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\ACFC \AC19\C740 \C774\C720\B85C \C2A4\D0A4\B9C8\AC00 \C791\C5C5\C601\C5ED\C5D0 \C9C0\C815\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105385610848309762)
,p_name=>'F4050.ADDITIONAL_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \C2A4\D0A4\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105280855734309682)
,p_name=>'F4050.ADJUST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105280134359309681)
,p_name=>'F4050.ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105515533518309874)
,p_name=>'F4050.APPROVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2B9\C778\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104936190240309423)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_DISPLAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C5D0 \B300\D55C \C694\CCAD\C774 \C2B9\C778\B418\ACE0 \C778\C99D\C11C\AC00 \B4F1\B85D \C911\C5D0 \C81C\ACF5\D55C \C804\C790\BA54\C77C \C8FC\C18C\B85C \C804\C1A1\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105354210217309738)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C815\C5D0 \B300\D55C \C694\CCAD\C774 \C2B9\C778\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105354155424309738)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2B9\C778\B428: %0\C5D0 \B300\D55C \ACC4\C815 \C694\CCAD ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105354611158309739)
,p_name=>'F4050.APPROVE_ADD_STORAGE_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %1\C5D0 \C788\B294 \C800\C7A5 \C601\C5ED\C758 \CD94\AC00 %0MB\C5D0 \B300\D55C \C694\CCAD\C774 \C2B9\C778\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105515271711309873)
,p_name=>'F4050.ASSIGNED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106026539439310296)
,p_name=>'F4050.AUTOMATIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105515160012309873)
,p_name=>'F4050.AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \AC00\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106106751734310371)
,p_name=>'F4050.BROKEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C190\C0C1\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106107179138310371)
,p_name=>'F4050.CHAIN_STALLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\C778\C774 \C911\B2E8\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105355030447309739)
,p_name=>'F4050.CHANGE_APPROVED_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD \C694\CCAD\C774 \C2B9\C778\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105355124160309739)
,p_name=>'F4050.CHANGE_DENIED_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD \C694\CCAD\C774 \AC70\BD80\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106106633677310371)
,p_name=>'F4050.COMPLETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105385707492309762)
,p_name=>'F4050.CREATE_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8\AC00 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105515642375309874)
,p_name=>'F4050.DECLINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC70\BD80\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105354525390309739)
,p_name=>'F4050.DECLINED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC70\C808\B428: %0\C5D0 \B300\D55C \ACC4\C815 \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105354959259309739)
,p_name=>'F4050.DENY_ADD_STORAGE_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %1\C5D0 \C788\B294 \C800\C7A5 \C601\C5ED\C758 \CD94\AC00 %0MB\C5D0 \B300\D55C \C694\CCAD\C774 \AC70\BD80\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105354791400309739)
,p_name=>'F4050.DENY_NEW_SCHEMA_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %1\C5D0 \C788\B294 \B370\C774\D130\BCA0\C774\C2A4 \C2A4\D0A4\B9C8 %0\C5D0 \B300\D55C \C694\CCAD\C774 \AC70\BD80\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105354867603309739)
,p_name=>'F4050.DENY_REMOVE_SERVICE_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %0\C5D0 \B300\D55C \C11C\BE44\C2A4 \D574\C9C0 \C694\CCAD\C774 \AC70\BD80\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106106346582310371)
,p_name=>'F4050.DISABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104932207899309420)
,p_name=>'F4050.EMAIL_CLICK_ON_LINK'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C544\B798 \B9C1\D06C\B97C \B20C\B7EC \C2B9\C778 \D504\B85C\C138\C2A4\B97C \C644\B8CC\D558\C2ED\C2DC\C624. \C644\B8CC\B418\BA74 \D6C4\C18D \C804\C790\BA54\C77C\C5D0\C11C \C791\C5C5\C601\C5ED \C778\C99D\C11C\B97C \BC1B\AC8C \B429\B2C8\B2E4.'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105354463670309739)
,p_name=>'F4050.EMAIL_GETSTARTED'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C2DC\C791\D558\B824\BA74 \C544\B798 \B9C1\D06C\B97C \B204\B974\C2ED\C2DC\C624.'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106106882763310371)
,p_name=>'F4050.FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D328')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104959935748309440)
,p_name=>'F4050.HTML_EMAIL_CLICK_ON_LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2B9\C778 \D504\B85C\C138\C2A4\B97C \C644\B8CC\D558\ACE0 \C99D\BA85\C11C\B97C \BC1B\C73C\B824\BA74 <a href=''%0''>\C5EC\AE30</a>\B97C \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105270472107309674)
,p_name=>'F4050.INFORMATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105281626937309682)
,p_name=>'F4050.INSTALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105515782118309874)
,p_name=>'F4050.IN_PROGRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C4\D589 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105280417418309682)
,p_name=>'F4050.NO_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105298558116309695)
,p_name=>'F4050.P23.USE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106109870090310374)
,p_name=>'F4050.P3.UPDATE_CHECK_DISABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \AC80\C0AC\AC00 \C804\CCB4 \C778\C2A4\D134\C2A4\C5D0 \B300\D574 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105298611187309695)
,p_name=>'F4050.P39_OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105385525669309762)
,p_name=>'F4050.PRIMARY_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C2A4\D0A4\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105280729607309682)
,p_name=>'F4050.PROVISION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4F1\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105353952637309738)
,p_name=>'F4050.PROV_CHANGE_REQ_APPROVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD \C694\CCAD\C774 \C2B9\C778\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105353895668309738)
,p_name=>'F4050.PROV_SCHEMA_REQ_APPROVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %1\C5D0 \C788\B294 \B370\C774\D130\BCA0\C774\C2A4 \C2A4\D0A4\B9C8 %0\C5D0 \B300\D55C \C694\CCAD\C774 \C2B9\C778\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106106923569310371)
,p_name=>'F4050.REMOTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\ACA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105515890500309874)
,p_name=>'F4050.REQUESTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105279909091309681)
,p_name=>'F4050.RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105354009527309738)
,p_name=>'F4050.RESTRICTED_ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: \C694\CCAD\B41C \C2A4\D0A4\B9C8\AC00 Oracle \AE30\BCF8 \C2A4\D0A4\B9C8\C774\AC70\B098 \C0AC\C774\D2B8\BCC4 \C815\CC45\C73C\B85C \C778\D574 \C81C\D55C\B418\C5B4 \C788\C2B5\B2C8\B2E4. \C81C\D55C\B41C \C2A4\D0A4\B9C8\B294 \C791\C5C5\C601\C5ED\C5D0 \C9C0\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106106484925310371)
,p_name=>'F4050.RETRY SCHEDULED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C2DC\B3C4 \C77C\C815\C774 \C7A1\D798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105385945179309762)
,p_name=>'F4050.REUSE_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C2A4\D0A4\B9C8\AC00 \C7AC\C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106106596229310371)
,p_name=>'F4050.RUNNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106106212210310370)
,p_name=>'F4050.SCHEDULED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C815\C774 \C7A1\D798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105353685988309738)
,p_name=>'F4050.SCHEMA_ASSIGNED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: \C694\CCAD\B41C \C2A4\D0A4\B9C8\AC00 \C774\BBF8 \D558\B098 \C774\C0C1\C758 \C791\C5C5\C601\C5ED\C5D0 \C9C0\C815\B418\C5C8\C2B5\B2C8\B2E4. \C774 \C694\CCAD\C744 \C2B9\C778\D558\AE30 \C804\C5D0 \D574\B2F9 \C0AC\C774\D2B8\C758 \BCF4\C548 \C815\CC45\C774 \B3D9\C77C\D55C \C2A4\D0A4\B9C8\C5D0 \B2E4\C911 \C791\C5C5\C601\C5ED \C561\C138\C2A4 \AD8C\D55C\C744 \BD80\C5EC\D558\B3C4\B85D \D5C8\C6A9\D558\B294\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105353557075309738)
,p_name=>'F4050.SCHEMA_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: \C694\CCAD\B41C \C2A4\D0A4\B9C8\AC00 \C874\C7AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105386256646309762)
,p_name=>'F4050.SCHEMA_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105386499186309762)
,p_name=>'F4050.SCHEMA_RESERVED_NO_WARN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8\AC00 \C608\C57D\B418\C5B4 \C791\C5C5\C601\C5ED\C5D0 \C9C0\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105353744832309738)
,p_name=>'F4050.SCHEMA_RESTRICTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: \C694\CCAD\B41C \C2A4\D0A4\B9C8\B294 Oracle \AE30\BCF8 \C2A4\D0A4\B9C8\C774\AE30 \B54C\BB38\C5D0 \B610\B294 \C0AC\C774\D2B8\BCC4 \C815\CC45 \B54C\BB38\C5D0 \C81C\D55C\B418\C5C8\C2B5\B2C8\B2E4. \ACC4\C18D\D574\C11C \C774 \C2A4\D0A4\B9C8\B97C \C791\C5C5\C601\C5ED\C5D0 \C9C0\C815\D558\BA74 \D574\B2F9 \C791\C5C5\C601\C5ED\C758 \AC1C\BC1C\C790\C5D0\AC8C \C2A4\D0A4\B9C8\C5D0 \B300\D55C \BAA8\B4E0 \C561\C138\C2A4 \AD8C\D55C\C774 \BD80\C5EC\B429\B2C8\B2E4. \C774 \C694\CCAD\C744 \C2B9\C778\D558\AE30 \C804\C5D0 \C774 \C791\C5C5\C774 \D574\B2F9 \C0AC\C774\D2B8\C758 \BCF4\C548 \C815\CC45\ACFC \C77C\CE58\D558\B294\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105386350761309762)
,p_name=>'F4050.SCHEMA_RESTRICTED_NO_WARN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8\AC00 \BCF4\C548 \C815\CC45\C5D0 \C758\D574 \C81C\D55C\B418\C5B4 \C788\C2B5\B2C8\B2E4. \C81C\D55C\B41C \C2A4\D0A4\B9C8\B294 \C791\C5C5\C601\C5ED\C5D0 \C9C0\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105355233714309739)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\BE44\C2A4\AC00 \D574\C9C0\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105355340617309739)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C \C11C\BE44\C2A4 "%0"\C774(\AC00) \D574\C9C0\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106107000112310371)
,p_name=>'F4050.SUCCEEDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105515386986309874)
,p_name=>'F4050.SUSPENDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C2DC \C911\C9C0\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105515478562309874)
,p_name=>'F4050.TERMINATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105515911269309874)
,p_name=>'F4050.TERMINATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\C9C0\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106106118607310370)
,p_name=>'F4050.TERMINATION_IN_PROGRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\C9C0 \C9C4\D589 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105281053878309682)
,p_name=>'F4050.VIEW_REQUEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105281452348309682)
,p_name=>'F4050.WORKSPACE_EXPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105047460619309504)
,p_name=>'F4050.WORKSPACE_HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105047566288309504)
,p_name=>'F4050.WORKSPACE_LOGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \B85C\ADF8\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105351282935309736)
,p_name=>'F4050.WSID_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C77C\D55C ID\B97C \AC00\C9C4 \C791\C5C5\C601\C5ED\C774 \C788\AE30 \B54C\BB38\C5D0 \C791\C5C5\C601\C5ED\C774 \C0DD\C131\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105351179452309736)
,p_name=>'F4050.WSNAME_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C77C\D55C \C774\B984\C744 \AC00\C9C4 \C791\C5C5\C601\C5ED\C774 \C788\AE30 \B54C\BB38\C5D0 \C791\C5C5\C601\C5ED\C774 \C0DD\C131\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105124068137309562)
,p_name=>'F4050.WS_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C791\C5C5\C601\C5ED\C774 %1\C5D0\C11C \C0DD\C131\B418\C5C8\C73C\BA70 \B4F1\B85D \C911\C5D0 \C81C\ACF5\D55C \C804\C790\BA54\C77C \C8FC\C18C\B85C \D655\C778\C774 \C804\C1A1\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104953243739309435)
,p_name=>'F4050.WS_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C774 \C874\C7AC\D558\BBC0\B85C \C0DD\C131\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104953328165309435)
,p_name=>'F4050.WS_TOBE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C774 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105188464713309613)
,p_name=>'F4050_EMAIL_BODY_NEW_PASSWORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \BE44\BC00\BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105188362203309613)
,p_name=>'F4050_EMAIL_BODY_PASSWORD_CHANGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 %0\C5D0 \B300\D55C \ACC4\C815 \BE44\BC00\BC88\D638\AC00 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105188209612309613)
,p_name=>'F4050_EMAIL_SUBJECT_PASSWORD_CHANGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\AC00 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106071345902310338)
,p_name=>'F4050_P158_INTRO_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B294 \B2E4\C74C \B9B4\B9AC\C2A4\AC00 \CD9C\C2DC\B420 \B54C %0\C774(\AC00) \C989\C2DC \C5C5\ADF8\B808\C774\B4DC\B418\B294\C9C0 \B610\B294 \C5C5\ADF8\B808\C774\B4DC\AC00 \CD5C\B300 %1\C77C\AE4C\C9C0 \C9C0\C5F0\B418\B294\C9C0 \C5EC\BD80\B97C \C81C\C5B4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106071414726310338)
,p_name=>'F4050_P158_UPGRADE_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B300\C2E0 \C9C0\AE08 \C5C5\ADF8\B808\C774\B4DC\B97C \C2DC\C791\D558\B824\BA74 [\C9C0\AE08 \C5C5\ADF8\B808\C774\B4DC]\B97C \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106071071586310338)
,p_name=>'F4050_P3_SYSTEM_UP_TO_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C2A4\D15C\C774 \CD5C\C2E0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106071122814310338)
,p_name=>'F4050_P3_UPGRADE_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 %1\C744(\B97C) <a href="%2" target="_blank" rel="noreferrer">\C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106070122772310337)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_N'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C\C6B4 %0 \B9B4\B9AC\C2A4\AC00 \CD9C\C2DC\B418\BA74 \C778\C2A4\D134\C2A4\AC00 <strong>\C989\C2DC</strong> \C5C5\ADF8\B808\C774\B4DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106070841245310338)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_P'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C2A4\D134\C2A4\AC00 <strong>%0</strong>\C5D0 \C790\B3D9\C73C\B85C \C5C5\ADF8\B808\C774\B4DC\B429\B2C8\B2E4. \C9C0\AE08 \C5C5\ADF8\B808\C774\B4DC\D558\B824\BA74 \D1B1\B2C8\BC14\D034 \C544\C774\CF58\C744 \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106070050962310337)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_Y'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C2A4\D134\C2A4\C758 %0 \C5C5\ADF8\B808\C774\B4DC\AC00 <strong>\C9C0\C5F0</strong>\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105612098057309951)
,p_name=>'F4050_P3_UPGRADING'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \D604\C7AC %1(\C73C)\B85C \C5C5\ADF8\B808\C774\B4DC\B418\B294 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104940146210309426)
,p_name=>'F4050_P74_PROVISION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \D30C\C77C %2\C744(\B97C) \C0AC\C6A9\D558\ACE0 \AE30\BCF8 \D14C\C774\BE14\C2A4\D398\C774\C2A4 %1(\C73C)\B85C \D560\B2F9\B41C \B370\C774\D130\BCA0\C774\C2A4 \C0AC\C6A9\C790 %0\C774(\AC00) \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104956967973309438)
,p_name=>'F4050_P74_PROVISION1'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \AD00\B9AC\C790\B85C \B4F1\B85D\B41C %0 \C791\C5C5\C601\C5ED\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105088754588309534)
,p_name=>'F4050_SHOW_ALL_WORKSPACES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C791\C5C5\C601\C5ED \D45C\C2DC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105080001734309527)
,p_name=>'F4300.COL_LENGTH_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AE38\C774\B294 \B110\C77C \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105079923258309527)
,p_name=>'F4300.COL_LENGTH_NOT_ZERO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AE38\C774\B294 0\C774 \B420 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105080282054309528)
,p_name=>'F4300.COL_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984\C740 %0\C790\B97C \CD08\ACFC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105080381730309528)
,p_name=>'F4300.COL_NAMES_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984\C740 \B110\C77C \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105080845524309528)
,p_name=>'F4300.F4500.NAME_ALREADY_USED'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C740(\B294) \AE30\C874 \AC1D\CCB4\C5D0 \C758\D574 \C774\BBF8 \C0AC\C6A9\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105081071179309528)
,p_name=>'F4300.F4500.NOT_VALID_SEQ_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C740(\B294) \C801\D569\D55C \C2DC\D000\C2A4 \C774\B984\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105079643071309527)
,p_name=>'F4300.F4500.TABLE_ALREADY_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C774\B984\C774 \C874\C7AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105080699675309528)
,p_name=>'F4300.NOT_VALID_PK_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C740(\B294) \C801\D569\D55C \AE30\BCF8 \D0A4 \C774\B984\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105298773516309695)
,p_name=>'F4300.P180_FILE_FORMAT'
,p_message_language=>'ko'
,p_message_text=>'DOS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105269762891309673)
,p_name=>'F4300.SPREADSHEET_IMPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D504\B808\B4DC\C2DC\D2B8 \C784\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105080577887309528)
,p_name=>'F4300.TABLE_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C774\B984\C740 %0\C790 \BBF8\B9CC\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105091263187309536)
,p_name=>'F4300_INSTRUCT_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8 \D589\C740 \C5F4 \C774\B984 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105417036856309791)
,p_name=>'F4300_TEXT_IMPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \C784\D3EC\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105117073638309554)
,p_name=>'F4350.APPLICATION_OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105279764279309681)
,p_name=>'F4350.AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('(\C0AC\C6A9 \AC00\B2A5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105279530752309681)
,p_name=>'F4350.CHANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105454678485309823)
,p_name=>'F4350.CONFIRM_SCHEMA_EXISTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C2A4\D0A4\B9C8 %0\C744(\B97C) \C791\C5C5\C601\C5ED\C5D0 \C9C0\C815\D558\B3C4\B85D \C694\CCAD\D558\B294 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105454781975309824)
,p_name=>'F4350.CONFIRM_SCHEMA_NEW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C2A4\D0A4\B9C8\B97C \C0DD\C131\D558\C5EC \C791\C5C5\C601\C5ED\C5D0 \C9C0\C815\D558\B3C4\B85D \C694\CCAD\D558\B294 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105279232448309681)
,p_name=>'F4350.CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105123152125309561)
,p_name=>'F4350.CREATING_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105279694057309681)
,p_name=>'F4350.CURRENT'
,p_message_language=>'ko'
,p_message_text=>unistr('(\D604\C7AC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105117517819309555)
,p_name=>'F4350.CURRENT_TIME_ON_SERVER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C2DC\AC04(\C11C\BC84)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105117341735309554)
,p_name=>'F4350.CURRENT_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105279473847309681)
,p_name=>'F4350.DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105124287846309562)
,p_name=>'F4350.DISABLE.WORK.PROV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C0DD\C131\C774 \C77C\C2DC\C801\C73C\B85C \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105116933566309554)
,p_name=>'F4350.HOST_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\D638\C2A4\D2B8 \C2A4\D0A4\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105278982036309681)
,p_name=>'F4350.INSERTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0BD\C785\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105117417170309555)
,p_name=>'F4350.LANGUAGE_PREFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4 \D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105116802793309554)
,p_name=>'F4350.LAST_DDL_TIME'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C885 DDL \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105600654951309942)
,p_name=>'F4350.LAST_PATCH_TIME'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C885 \D328\CE58 \C801\C6A9 \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104923738290309414)
,p_name=>'F4350.MORE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B0A8\C74C...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105600572462309942)
,p_name=>'F4350.PATCH_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\CE58 \BC84\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105116670702309554)
,p_name=>'F4350.PRODUCT_BUILD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\D488 \BE4C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105648484348309984)
,p_name=>'F4350.RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105116791555309554)
,p_name=>'F4350.SCHEMA_COMPATIBILITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8 \D638\D658\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104923685325309414)
,p_name=>'F4350.TRANSLATED_APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('(+%0 \BCC0\D658\B41C \C560\D50C\B9AC\CF00\C774\C158)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105279196365309681)
,p_name=>'F4350.UNKNOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105279038605309681)
,p_name=>'F4350.UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105117163974309554)
,p_name=>'F4350.WORKSPACE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105117231293309554)
,p_name=>'F4350.WORKSPACE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105825381614310127)
,p_name=>'F4350_AJAX'
,p_message_language=>'ko'
,p_message_text=>'AJAX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105825299646310127)
,p_name=>'F4350_AUTHENTICATION_CALLBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CF5C\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105280699217309682)
,p_name=>'F4350_CLICKTHRU_LOG_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D074\B9AD \B85C\ADF8 \D56D\BAA9:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105280598248309682)
,p_name=>'F4350_DEV_LOG_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790 \C791\C5C5 \B85C\ADF8 \D56D\BAA9:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105281120543309682)
,p_name=>'F4350_DISTINCT_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C138\C158\C5D0 \B300\D55C \AC1C\BCC4 \C0AC\C6A9\C790 = %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105281587664309682)
,p_name=>'F4350_NO_USER_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \C0AC\C6A9\C790 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105281862798309683)
,p_name=>'F4350_PREFS_EXISTS_FOR'
,p_message_language=>'ko'
,p_message_text=>unistr('"%2" \C791\C5C5\C601\C5ED\C5D0 %1\BA85\C758 \C0AC\C6A9\C790\C5D0 \B300\D55C \D658\ACBD\C124\C815\C774 %0\AC1C \C874\C7AC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104898094678309395)
,p_name=>'F4350_PREFS_EXISTS_FOR2'
,p_message_language=>'ko'
,p_message_text=>unistr('%1\BA85\C758 \C0AC\C6A9\C790\C5D0 \B300\D55C \D658\ACBD\C124\C815\C774 %0\AC1C \C874\C7AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105280372515309682)
,p_name=>'F4350_RESET_PREFS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \C124\C815\B41C \AC12 \C5C6\C774 \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D558\B824\BA74 \D658\ACBD\C124\C815\C744 \C7AC\C124\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104955033469309437)
,p_name=>'F4350_RESET_SESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C0AC\C804 \C124\C815\B41C \AC12 \C5C6\C774 \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D558\ACE0\C790 \D558\B294 \ACBD\C6B0 \C138\C158 \C0C1\D0DC\B97C \C7AC\C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105281923657309683)
,p_name=>'F4350_SELECTED_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105281240784309682)
,p_name=>'F4350_SESSIONS_OLDER_THAN'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C77C\C774 \ACBD\ACFC\D55C \C138\C158 = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105281351710309682)
,p_name=>'F4350_SESSIONS_OLDER_THAN_MINS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BD84\C744 \CD08\ACFC\D55C \C138\C158 = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105279860613309681)
,p_name=>'F4350_SESSION_STATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158\C740 %0(\C73C)\B85C \C2DD\BCC4\B418\ACE0 %1\AC1C\C758 \D56D\BAA9\C744 \D3EC\D568\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105282591269309683)
,p_name=>'F4350_SQL'
,p_message_language=>'ko'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105281722608309683)
,p_name=>'F4350_SUMMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\C57D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105280932692309682)
,p_name=>'F4350_TOTAL_SESSIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \C791\C5C5\C601\C5ED\C5D0 \B300\D55C \CD1D \C138\C158 \C218\B294 %1\AC1C\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104897959044309395)
,p_name=>'F4350_TOTAL_SESSIONS2'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \C138\C158: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105282059288309683)
,p_name=>'F4350_USER_HAS_X_PREFS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AC\C6A9\C790\C758 \D658\ACBD\C124\C815\C740 %1\AC1C\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105280218854309681)
,p_name=>'F4350_USER_PREFS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C0AC\C6A9\C790 %0\C5D0\AC8C %1\AC1C\C758 \D658\ACBD\C124\C815\C774 \C124\C815\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105282184907309683)
,p_name=>'F4350_WORKSPACE_SCHEMAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C2A4\D0A4\B9C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105284653714309685)
,p_name=>'F4500.DISPLAY_SEQ_IN_FORM_NUMERIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \D45C\C2DC \C21C\C11C\B294 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105284759524309685)
,p_name=>'F4500.DISPLAY_SEQ_IN_REPORT_NUMERIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D45C\C2DC \C21C\C11C\B294 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105088137831309533)
,p_name=>'F4500.DUP_ARG_NAMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D568\C218\C5D0\C11C \C778\C218 \C774\B984 <strong>%0</strong>\C774(\AC00) \B450 \BC88 \C774\C0C1 \C0AC\C6A9\B418\C5C8\C2B5\B2C8\B2E4.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105287701466309687)
,p_name=>'F4500.EXECUTION_ORDER_MAND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \C21C\C11C\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105287615835309687)
,p_name=>'F4500.EXECUTION_ORDER_NUMERIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \C21C\C11C\B294 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105270559658309674)
,p_name=>'F4500.FIND'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC3E\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105298937920309695)
,p_name=>'F4500.HIDE_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105270926307309674)
,p_name=>'F4500.MAGNIFY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105270864659309674)
,p_name=>'F4500.MOVE_COLUMN_DOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\B85C \C5F4 \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105270781567309674)
,p_name=>'F4500.MOVE_COLUMN_UP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\B85C \C5F4 \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105081837743309529)
,p_name=>'F4500.NEED_UNIQUE_EXECUTION_ORDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \C2E4\D589 \C21C\C11C \BC88\D638\B97C \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104883035143309383)
,p_name=>'F4500.NEW_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00\D560 \C0C8 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105081403731309529)
,p_name=>'F4500.NOT_VALID_OBJECT_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C740(\B294) \C801\D569\D55C \AC1D\CCB4 \C774\B984\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105081225996309528)
,p_name=>'F4500.NOT_VALID_TABLE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C740(\B294) \C801\D569\D55C \D14C\C774\BE14 \C774\B984\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105270663129309674)
,p_name=>'F4500.NO_IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105271017215309674)
,p_name=>'F4500.NULLABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \AC00\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105384313459309761)
,p_name=>'F4500.P40.PREVIOUS.RUNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804 \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105087663089309533)
,p_name=>'F4500.P602.DUP_COL_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D14C\C774\BE14\C5D0\C11C \C5F4 \C774\B984 <strong>%0</strong>\C774(\AC00) \B450 \BC88 \C774\C0C1 \C0AC\C6A9\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105088099676309533)
,p_name=>'F4500.P602.ENTER_AT_LEAST_ONE_COL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\C5B4\B3C4 \D55C \AC1C\C758 \C5F4 \C774\B984\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105087930598309533)
,p_name=>'F4500.P602.INVALID_COL_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984 <strong>%0</strong>\C774(\AC00) \BD80\C801\D569\D569\B2C8\B2E4.<br />')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105087703439309533)
,p_name=>'F4500.P602.INVALID_PRECISION'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong> \C5F4\C758 \C804\CCB4 \C790\B9BF\C218\AC00 \BD80\C801\D569\D569\B2C8\B2E4.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105087855015309533)
,p_name=>'F4500.P602.INVALID_SCALE'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong> \C5F4\C758 \C18C\C218\C810 \C774\D558 \C790\B9BF\C218\AC00 \BD80\C801\D569\D569\B2C8\B2E4.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104938136624309424)
,p_name=>'F4500.P602.SCALE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong> \C5F4\C758 \C18C\C218\C810 \C774\D558 \C790\B9BF\C218\AC00 \D544\C694\D569\B2C8\B2E4.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105299097440309695)
,p_name=>'F4500.P99.CREATE_SYNONYM_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C758\C5B4 \C0DD\C131 \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105298801983309695)
,p_name=>'F4500.SHOW_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105081541784309529)
,p_name=>'F4500.TABLE_NOT_FOUND_IN_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%1</strong> \C2A4\D0A4\B9C8\C5D0\C11C <strong>%0</strong> \D14C\C774\BE14\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104887136588309386)
,p_name=>'F4500.WARNING_STATEMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0 \BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105283724365309684)
,p_name=>'F4500_BROKEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C190\C0C1\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105284271865309684)
,p_name=>'F4500_BYTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105284114342309684)
,p_name=>'F4500_CARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105283565946309684)
,p_name=>'F4500_CHECK'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105276040296309678)
,p_name=>'F4500_CLICK_POP_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \D544\B4DC\B97C \CC44\C6B0\B824\BA74 \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105284003228309684)
,p_name=>'F4500_COST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105275353048309678)
,p_name=>'F4500_CREATE_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131 \C791\C5C5\C744 \C131\ACF5\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106053450810310322)
,p_name=>'F4500_DICTIONARY_OBJECTS_WO_DEFAULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12\C774 \C5C6\B294 \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106053342756310322)
,p_name=>'F4500_DICTIONARY_OBJECTS_W_DEFAULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12\C774 \C788\B294 \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105274695144309677)
,p_name=>'F4500_DROP_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C \C791\C5C5\C744 \C131\ACF5\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104927131489309416)
,p_name=>'F4500_FOREIGN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\B798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105188644430309613)
,p_name=>'F4500_FOREIGN_KEY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\B798 \D0A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105088422648309534)
,p_name=>'F4500_NATIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \D30C\C77C \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105274319104309677)
,p_name=>'F4500_NOT_AVAIL_EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105283875449309684)
,p_name=>'F4500_NOT_AVAIL_SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105283623895309684)
,p_name=>'F4500_OF'
,p_message_language=>'ko'
,p_message_text=>'/'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105283995952309684)
,p_name=>'F4500_OPTIMIZER'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C801\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105276366835309679)
,p_name=>'F4500_OP_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C744 \C131\ACF5\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105264059861309669)
,p_name=>'F4500_P1000_NO_WS_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \BA54\C2DC\C9C0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105416925401309791)
,p_name=>'F4500_P101_NO_VARCHAR'
,p_message_language=>'ko'
,p_message_text=>unistr('VARCHAR \C5F4 \C720\D615\C774 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104961382303309441)
,p_name=>'F4500_P1023_PARSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \AD6C\BB38\BD84\C11D \C911 - \AE30\B2E4\B9AC\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104908013250309403)
,p_name=>'F4500_P10_NUM_STMTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA85\B839\BB38 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105149864417309584)
,p_name=>'F4500_P10_ON_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('%1\C5D0 \C758\D574 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105271779022309675)
,p_name=>'F4500_P10_PARAMETERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8\C5D0 \B9E4\AC1C\BCC0\C218\AC00 \C788\C73C\BA74 \C2E4\D589\D558\AE30 \C804\C5D0 \C815\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104907905167309403)
,p_name=>'F4500_P10_SCRIPT_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105149793386309584)
,p_name=>'F4500_P10_SCRIPT_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \D06C\AE30(\BC14\C774\D2B8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105146032844309582)
,p_name=>'F4500_P10_UPDATED_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \C218\D589\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105271910286309675)
,p_name=>'F4500_P10_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105430615000309802)
,p_name=>'F4500_P115.CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C2A4\D06C\B9BD\D2B8\B97C \C784\D3EC\D2B8\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C694\CCAD \B0B4\C6A9\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105430702611309802)
,p_name=>'F4500_P115.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C784\D3EC\D2B8\D558\B3C4\B85D \C694\CCAD\D55C \C2A4\D06C\B9BD\D2B8\AC00 \D5C8\C6A9\B41C \CD5C\B300 \C800\C7A5 \C601\C5ED\C744 \CD08\ACFC\D569\B2C8\B2E4. %0 \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105431716160309803)
,p_name=>'F4500_P115.SCRIPTS_TO_INSTALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C784\D3EC\D2B8\D560 \C2A4\D06C\B9BD\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105272447040309675)
,p_name=>'F4500_P11_NO_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105272231334309675)
,p_name=>'F4500_P11_NUM'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105252143173309660)
,p_name=>'F4500_P1224_VIEW_OUTPUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD9C\B825 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105333007006309723)
,p_name=>'F4500_P129_BROWSE_SEQ'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4 \CC3E\C544\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105333181584309723)
,p_name=>'F4500_P129_NO_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4 \C0DD\C131 \C791\C5C5\C758 \C2E4\D328 \C6D0\C778\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105332921894309723)
,p_name=>'F4500_P129_SEQUENCE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C2A4\D0A4\B9C8\C5D0 "%0" \C2DC\D000\C2A4\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105272673041309676)
,p_name=>'F4500_P12_STATEMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA85\B839\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105333405721309723)
,p_name=>'F4500_P130_BROWSE_DB_SYN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \B3D9\C758\C5B4 \CC3E\C544\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105333674657309723)
,p_name=>'F4500_P130_CREATE_NOT_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C758\C5B4 \C0DD\C131 \C791\C5C5\C758 \C2E4\D328 \C6D0\C778\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105333302727309723)
,p_name=>'F4500_P130_SYNONYM_CREATE_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C2A4\D0A4\B9C8\C5D0 "%0" \B3D9\C758\C5B4\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105333726256309723)
,p_name=>'F4500_P132_CREATE_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D0A4\C9C0 \C0DD\C131 \C791\C5C5\C758 \C2E4\D328 \C6D0\C778\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105333873210309723)
,p_name=>'F4500_P132_PACKAGE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C2A4\D0A4\B9C8\C5D0 "%0" \D328\D0A4\C9C0\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105115439374309553)
,p_name=>'F4500_P24_SAVE_TO_WORKSHEET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6CC\D06C\C2DC\D2B8\C5D0 \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105272938690309676)
,p_name=>'F4500_P25_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C131\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105272821794309676)
,p_name=>'F4500_P25_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105272776329309676)
,p_name=>'F4500_P25_FILE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104928839071309418)
,p_name=>'F4500_P2610_EXPIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9CC\AE30\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104928947383309418)
,p_name=>'F4500_P2610_EXPIRED_AND_LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9CC\AE30 \D6C4 \C7A0\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104928769881309418)
,p_name=>'F4500_P2610_LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104928675940309417)
,p_name=>'F4500_P2610_OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105332813405309723)
,p_name=>'F4500_P402_OPERATION_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C2E4\D328 \C6D0\C778\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105309977237309704)
,p_name=>'F4500_P51_NOT_AVAIL_INSERT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B97C \C0BD\C785\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105332798076309723)
,p_name=>'F4500_P54_BROWSE_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \BDF0 \CC3E\C544\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105332406976309722)
,p_name=>'F4500_P54_NOT_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30 \C0DD\C131 \C791\C5C5\C758 \C2E4\D328 \C6D0\C778\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105332571951309723)
,p_name=>'F4500_P54_SQL_WORKSHOP_HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C6CC\D06C\C20D \D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105332640447309723)
,p_name=>'F4500_P54_VIEW_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C2A4\D0A4\B9C8\C5D0 "%0" \BCF4\AE30\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105301256911309697)
,p_name=>'F4500_P553_GET_COLUMN_COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C124\BA85 \AC00\C838\C624\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105458820683309827)
,p_name=>'F4500_P602_IDENTITY'
,p_message_language=>'ko'
,p_message_text=>'ID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104959897006309440)
,p_name=>'F4500_P602_NO_DATATYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D574 \C9C0\C815\B41C \B370\C774\D130 \C720\D615\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105274476535309677)
,p_name=>'F4500_P68_TABLE_OP_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C791\C5C5\C744 \C131\ACF5\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105271532821309675)
,p_name=>'F4500_P6_STATEMENT_CNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D30C\C77C\C5D0 %0\AC1C\C758 \BA85\B839\BB38\C774 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105271634875309675)
,p_name=>'F4500_P6_USER_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \B2E4\C74C %0\AC1C\C758 \B9E4\AC1C\BCC0\C218\B97C \C815\C758\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105088665507309534)
,p_name=>'F4500_PARSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \AD6C\BB38\BD84\C11D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105283399846309684)
,p_name=>'F4500_PRIMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104892287624309390)
,p_name=>'F4500_REFERENTIAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105088566277309534)
,p_name=>'F4500_TEXT_FILE_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\B85C \BB38\C11C \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105283419032309684)
,p_name=>'F4500_UNIQUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106132830787310395)
,p_name=>'F4550.STATIC_FILES_NOT_CONFIGURED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D658\ACBD\C5D0\C11C \C815\C801 \D30C\C77C \AD6C\C131\C5D0 \BB38\C81C\AC00 \C788\C2B5\B2C8\B2E4. Application Express Installation Guide\C758 "Configuring Static File Support" \C808\C744 \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105476207818309841)
,p_name=>'F4550.WELCOME_TO_APEX_ADB'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle APEX \C2DC\C791! Autonomous Database\C758 \AD00\B9AC\C790(ADMIN) \BE44\BC00\BC88\D638\B97C \C0AC\C6A9\D558\C5EC \C0AC\C778\C778\D558\C2ED\C2DC\C624.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106128972670310392)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle APEX \C791\C5C5\C601\C5ED\C744 \C694\CCAD\D588\AE30 \B54C\BB38\C5D0 \C774 \C804\C790\BA54\C77C\C744 \C218\C2E0\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106128857702310391)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \D544\C694: %0\C5D0 \B300\D55C \ACC4\C815 \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105352573369309737)
,p_name=>'F4700.EMAIL_NOTE'
,p_message_language=>'ko'
,p_message_text=>unistr('(\C804\C790\BA54\C77C\B85C \C99D\BA85\C11C\B97C \BCF4\B0B4\B294 \B370 \C0AC\C6A9\B428)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105352747775309737)
,p_name=>'F4700.EXISTING_SCHEMA_HINT'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle \B370\C774\D130\BCA0\C774\C2A4\C5D0 \D604\C7AC \C874\C7AC\D558\B294 \B370\C774\D130\BCA0\C774\C2A4 \C2A4\D0A4\B9C8\B97C \C785\B825\D558\C2ED\C2DC\C624. \BCF4\C548\C744 \C704\D574 \AC12 \BAA9\B85D\C740 \C81C\ACF5\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105352603871309737)
,p_name=>'F4700.NEW_SCHEMA_HINT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C5D0 \B300\D574 \C0DD\C131\D558\B824\B294 Oracle \B370\C774\D130\BCA0\C774\C2A4 \C2A4\D0A4\B9C8 \C774\B984\C744 \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105351972298309737)
,p_name=>'F4700.P26_JUSTIFY_RESTRICTED_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C544\B798 \C124\BA85\C5D0\C11C \C81C\D55C\B41C \C2A4\D0A4\B9C8\B97C \C694\CCAD \C911\C778 \C774\C720\B97C \C124\BA85\D558\C2ED\C2DC\C624.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105352077415309737)
,p_name=>'F4700.P26_JUSTIFY_SHARED_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798 \C124\BA85\C5D0\C11C \D558\B098 \C774\C0C1\C758 \B2E4\B978 \C791\C5C5\C601\C5ED\C5D0 \C758\D574 \C774\BBF8 \C0AC\C6A9 \C911\C778 \C2A4\D0A4\B9C8\B97C \C694\CCAD \C911\C778 \C774\C720\B97C \C124\BA85\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105352465542309737)
,p_name=>'F4700.P26_WARN_RESTRICTED_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: \C694\CCAD \C911\C778 \C2A4\D0A4\B9C8\B294 \BCF4\C548\C0C1\C758 \C774\C720\B85C \C81C\D55C\B418\C5C8\C2B5\B2C8\B2E4. %0 \AD00\B9AC\C790\AC00 \C774 \C2A4\D0A4\B9C8\B97C \C791\C5C5\C601\C5ED\C5D0 \C9C0\C815\D558\B294 \C694\CCAD\C744 \AC70\BD80\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105352319659309737)
,p_name=>'F4700.P26_WARN_SHARED_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: \C694\CCAD \C911\C778 \C2A4\D0A4\B9C8\B294 \C774\BBF8 \B2E4\B978 \C791\C5C5\C601\C5ED\C5D0\C11C \C0AC\C6A9\D558\ACE0 \C788\C2B5\B2C8\B2E4. %0 \AD00\B9AC\C790\AC00 \C774 \C2A4\D0A4\B9C8\B97C \C791\C5C5\C601\C5ED\C5D0 \C9C0\C815\D558\B77C\B294 \C694\CCAD\C744 \AC70\BD80\D560 \C218 \C788\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105349360630309735)
,p_name=>'F4700.SCHEMA_RESTRICTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C5D0 \B300\D574 \C694\CCAD\D55C \C0C8 \C2A4\D0A4\B9C8\B294 Oracle \AE30\BCF8 \C2A4\D0A4\B9C8\C774\AC70\B098 \D574\B2F9 \C0AC\C774\D2B8\C5D0\C11C \BCF4\C548\C744 \C704\D574 \D2B9\BCC4\D788 \C81C\D55C\B420 \C218 \C788\C73C\BA70 \C791\C5C5\C601\C5ED\C5D0 \C9C0\C815\D558\B294 \B370 \BD80\C801\D569\D560 \C218 \C788\C2B5\B2C8\B2E4. \D574\B2F9 \C0AC\C774\D2B8\C758 \BCF4\C548 \C815\CC45\C744 \C704\BC18\D558\BA74 \C0AC\C774\D2B8 \AD00\B9AC\C790\AC00 \B4F1\B85D \C694\CCAD\C744 \AC70\BD80\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105349295038309735)
,p_name=>'F4700.SCHEMA_USED_BY_WORKSPACES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C5D0 \B300\D574 \C694\CCAD\D55C \C2A4\D0A4\B9C8\AC00 \C774\BBF8 %0\AC1C\C758 \C791\C5C5\C601\C5ED\C5D0 \C9C0\C815\B418\C5C8\C2B5\B2C8\B2E4. \D574\B2F9 \C0AC\C774\D2B8\C758 \BCF4\C548 \C815\CC45\C744 \C704\BC18\D558\BA74 \C0AC\C774\D2B8 \AD00\B9AC\C790\AC00 \B4F1\B85D \C694\CCAD\C744 \AC70\BD80\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104924519976309415)
,p_name=>'F4700P1_A'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle APEX\B97C \D1B5\D574 Oracle \B370\C774\D130\BCA0\C774\C2A4 \BC0F \BE0C\B77C\C6B0\C800 \AE30\BC18 \AC1C\BC1C \B3C4\AD6C\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104924611386309415)
,p_name=>'F4700P1_B'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\C5B8\C801\C73C\B85C \C6F9 \C560\D50C\B9AC\CF00\C774\C158 \C791\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104924737149309415)
,p_name=>'F4700P1_C'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4 \C0DD\C131 \BC0F \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104924868759309415)
,p_name=>'F4700P1_D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C77C\C2A4\D1A4, \BC84\ADF8, \AE30\B2A5 \BC0F \D560 \C77C \CD94\C801<')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106063345269310331)
,p_name=>'F4750.P209.DB_APP_USER_SETUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C774 \C131\ACF5\C801\C73C\B85C \C124\CE58\B418\C5C8\C9C0\B9CC Application Express \ACC4\C815 \C778\C99D\C73C\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D558\B824\BA74 Application Express \C0AC\C6A9\C790 \ACC4\C815\C744 \C124\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106063437598310331)
,p_name=>'F4750.P209.WEBSHEET_ADMIN_SETUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8\AC00 \C131\ACF5\C801\C73C\B85C \C124\CE58\B418\C5C8\C9C0\B9CC Application Express \ACC4\C815 \C778\C99D\C73C\B85C \C6F9 \C2DC\D2B8\B97C \C2E4\D589\D558\B824\BA74 Application Express \ACC4\C815\C744 \AC00\C9C4 \AD00\B9AC\C790\B97C \C124\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105417174242309791)
,p_name=>'F4750.VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\C804')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106087464312310353)
,p_name=>'F4850.P1.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0D8\D50C RESTful \C11C\BE44\C2A4 \C0C1\D0DC\B97C \C7AC\C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4. <code>%0</code> \C2A4\D0A4\B9C8\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105662269455309996)
,p_name=>'F4900_P11_AUTH_TYPE_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C740 %0 \C778\C99D \CCB4\ACC4\B97C \C0AC\C6A9\D569\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105696611341310026)
,p_name=>'FACETED_SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105670076800310003)
,p_name=>'FACETED_SEARCH.INVALID.SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\BC95\C0AC\B294 \BCF4\ACE0\C11C \C18C\C2A4\B97C \C0AC\C6A9\D558\C5EC \D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \AC80\C0C9\D560 \C5F4\C774 \C5C6\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105481834071309845)
,p_name=>'FAILURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D328')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105273198745309676)
,p_name=>'FAILURES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D328')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105347516625309734)
,p_name=>'FDASH1'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C \AE30\B2A5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105389028614309764)
,p_name=>'FEATURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106107899084310372)
,p_name=>'FEATURE OWNERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105061542840309514)
,p_name=>'FEATURE.ABOUT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105062260341309515)
,p_name=>'FEATURE.ABOUT_PAGE.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158 \C815\BCF4 \D398\C774\C9C0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105061621387309514)
,p_name=>'FEATURE.ACCESS_CONTROL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105062386640309515)
,p_name=>'FEATURE.ACCESS_CONTROL.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0\C11C \B864 \AE30\BC18 \C0AC\C6A9\C790 \C778\C99D\C744 \D1B5\D569\D558\ACE0 \C560\D50C\B9AC\CF00\C774\C158 \B864\C5D0 \B300\D55C \C0AC\C6A9\C790 \C774\B984 \B9E4\D551\C744 \AD00\B9AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105061720443309514)
,p_name=>'FEATURE.ACTIVITY_REPORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105062425249309515)
,p_name=>'FEATURE.ACTIVITY_REPORTING.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790 \C791\C5C5\C5D0 \B300\D55C \B2E4\C591\D55C \BCF4\ACE0\C11C \BC0F \CC28\D2B8\B97C \D3EC\D568\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105061890119309514)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131 \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105063230261309515)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0\C11C Application Express \BE4C\B4DC \C635\C158\ACFC \C5F0\AD00\B41C \D2B9\C815 \AE30\B2A5\C744 \C0AC\C6A9 \B610\B294 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D560 \C218 \C788\B3C4\B85D \D5C8\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105361364813309744)
,p_name=>'FEATURE.CREATE_BUILD_OPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \BE4C\B4DC \C635\C158\C774 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105422050507309795)
,p_name=>'FEATURE.EMAIL_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105422139096309795)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIOTION'
,p_message_language=>'ko'
,p_message_text=>unistr('APEX_SEND() \C804\C790\BA54\C77C \B300\AE30\C5F4\C5D0 \B300\D55C \BCF4\ACE0\C11C\B97C \D3EC\D568\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105478721369309843)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8 \C804\C1A1\B41C \C804\C790\BA54\C77C\C758 \B85C\ADF8\C640 \D568\AED8 \ACB0\D569\B41C \C804\C1A1 \C608\C815 \BA54\C77C\C744 \D45C\C2DC\D558\B294 \BCF4\ACE0\C11C\B97C \D3EC\D568\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105061959508309514)
,p_name=>'FEATURE.FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105062505335309515)
,p_name=>'FEATURE.FEEDBACK.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\B97C \B300\C0C1\C73C\B85C \C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790 \BC0F \AC1C\BC1C\C790\C5D0\AC8C \C77C\BC18 \C124\BA85\C744 \B2E4\C2DC \AC8C\C2DC\D560 \C218 \C788\B294 \BC29\C2DD\C744 \C81C\ACF5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105422215161309795)
,p_name=>'FEATURE.JOB_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105422362971309795)
,p_name=>'FEATURE.JOB_REPORT.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B9\C815 \C791\C5C5\C744 \B4DC\B9B4\B2E4\C6B4\D558\C5EC \CD94\AC00 \C138\BD80\C815\BCF4\B97C \D655\C778\D560 \C218 \C788\B294 \AE30\B2A5\ACFC \D568\AED8 \B370\C774\D130\BCA0\C774\C2A4 \C791\C5C5\C5D0 \B300\D55C \BCF4\ACE0\C11C\B97C \D3EC\D568\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105062006568309515)
,p_name=>'FEATURE.THEME_STYLE_SELECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105063112267309515)
,p_name=>'FEATURE.THEME_STYLE_SELECTION.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \AE30\BCF8 \C0C9\C0C1\D45C(\D14C\B9C8 \C2A4\D0C0\C77C)\B97C \C120\D0DD\D560 \C218 \C788\B3C4\B85D \D5C8\C6A9\D569\B2C8\B2E4. \AD00\B9AC\C790\B294 \C77C\BC18 \C0AC\C6A9\C790\C758 \ACE0\C720 \D14C\B9C8 \C2A4\D0C0\C77C \C120\D0DD\C744 \D5C8\C6A9\D558\B3C4\B85D \C120\D0DD\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105369227494309749)
,p_name=>'FEATURES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105677372440310010)
,p_name=>'FEATURES_100_PCT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 100%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105426472251309799)
,p_name=>'FEATURES_100_PERCENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 100%(%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105391688502309766)
,p_name=>'FEATURES_80_PCT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 80%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104919634153309411)
,p_name=>'FEATURES_AT_LEAST_80'
,p_message_language=>'ko'
,p_message_text=>' %0 >= 80%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104918479011309410)
,p_name=>'FEATURES_COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C644\B8CC(%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104919533648309411)
,p_name=>'FEATURES_COMPLETED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C \C644\B8CC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105679832547310012)
,p_name=>'FEATURES_FOR_RELEASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9B4\B9AC\C2A4 %0 \AE30\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105426653546309799)
,p_name=>'FEATURES_PAST_DUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\AC04 \ACBD\ACFC(%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105695951429310026)
,p_name=>'FEATURES_PERCENT_COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5\C801\C73C\B85C \C644\B8CC\B41C \AE30\B2A5 \BE44\C728(%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105426594731309799)
,p_name=>'FEATURES_WITH_DATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \D3EC\D568(%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105458741849309827)
,p_name=>'FEATURE_CONFIGURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105364738107309746)
,p_name=>'FEATURE_CONTRIBUTOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105426376767309799)
,p_name=>'FEATURE_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105673309677310006)
,p_name=>'FEATURE_DASH_01'
,p_message_language=>'ko'
,p_message_text=>unistr('%2\AC1C\C758 \B9B4\B9AC\C2A4\C5D0\C11C %0\AC1C\C758 \AE30\B2A5, %1\C774(\AC00) \C644\C804\D788 \C644\B8CC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105673436477310006)
,p_name=>'FEATURE_DASH_02'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \CD5C\C0C1\C704 \B808\BCA8 \AE30\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105673537874310006)
,p_name=>'FEATURE_DASH_03'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C758 \ACBD\C6B0 \B9CC\AE30 \B0A0\C9DC\AC00 \C5C6\C73C\BA70, %1\C758 \ACBD\C6B0 \B9CC\AE30 \B0A0\C9DC\AC00 \ACBD\ACFC\D588\B294\B370 \C644\B8CC\C728\C774 80% \BBF8\B9CC\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105673639596310006)
,p_name=>'FEATURE_DASH_04'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \AE30\B2A5\C774 \AE30\B2A5\C0C1\C73C\B85C \C644\B8CC\B418\C5C8\C73C\BA70, %1\C740(\B294) \C644\B8CC\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105677089217310009)
,p_name=>'FEATURE_DASH_05'
,p_message_language=>'ko'
,p_message_text=>unistr('%0%\AC1C\C758 \AE30\B2A5\C774 100% \C644\B8CC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105363067038309745)
,p_name=>'FEATURE_DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105364022897309746)
,p_name=>'FEATURE_DESIRABILITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106094972843310360)
,p_name=>'FEATURE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105362679872309745)
,p_name=>'FEATURE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105362746959309745)
,p_name=>'FEATURE_OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105363737271309745)
,p_name=>'FEATURE_PRIORITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6B0\C120\C21C\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105363884398309745)
,p_name=>'FEATURE_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105363642383309745)
,p_name=>'FEATURE_TAGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0DC\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106107930124310372)
,p_name=>'FEATURE_WITHOUT_OWNERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106110315122310374)
,p_name=>'FEEBACK.LOGGED.AS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \AE30\B85D \BC0F %1\C5D0 \C9C0\C815\B428')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105388952963309764)
,p_name=>'FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105404551019309776)
,p_name=>'FEEDBACK_ATTRIBUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C815\BCF4\B97C \D53C\B4DC\BC31\C73C\B85C \B85C\AE45\D558\B3C4\B85D \C81C\ACF5\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105475089649309840)
,p_name=>'FEEDBACK_DASHBOARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \B300\C2DC\BCF4\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105368887356309749)
,p_name=>'FEEDBACK_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104918721645309410)
,p_name=>'FEEDBACK_ENTRIES_CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('%2\AC1C \D53C\B4DC\BC31 \D56D\BAA9 \BBF8\ACB0(%0\AC1C \C885\ACB0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105404389049309775)
,p_name=>'FEEDBACK_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31\C744 \C785\B825\D558\ACE0 [\D53C\B4DC\BC31 \C81C\CD9C] \B2E8\CD94\B97C \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105696222045310026)
,p_name=>'FEEDBACK_PERCENT_CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C885\ACB0\C728(%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105399540520309772)
,p_name=>'FEEDBACK_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105404429143309775)
,p_name=>'FEEDBACK_TYPE_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5 \C911\C778 \D53C\B4DC\BC31 \C720\D615\C744 \C2DD\BCC4\D558\C2ED\C2DC\C624.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105567200518309916)
,p_name=>'FILENAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105371912205309751)
,p_name=>'FILENAME_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C774\B984 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105614644111309953)
,p_name=>'FILENAME_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C774\B984: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105370488858309750)
,p_name=>'FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106049916519310318)
,p_name=>'FILES_WITH_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105369961546309750)
,p_name=>'FILES_WITH_COUNT_AND_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\D30C\C77C, %1K \C18C\BE44')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106094764433310360)
,p_name=>'FILE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104897666806309395)
,p_name=>'FILE_TOO_BIG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D14D\C2A4\D2B8 \D30C\C77C\C740 \B108\BB34 \CEE4\C11C \D3B8\C9D1\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \B0B4\C6A9\C744 \BCC0\ACBD\D558\B824\BA74 \B85C\CEEC \C2DC\C2A4\D15C\C5D0\C11C \D30C\C77C\C744 \D3B8\C9D1\D558\ACE0 \B2E4\C2DC \C5C5\B85C\B4DC\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104932001989309420)
,p_name=>'FILE_UPLOAD_NOSESSION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \C138\C158\C774 \C874\C7AC\D558\C9C0 \C54A\C73C\BA70 \D558\B098 \C774\C0C1\C758 \D30C\C77C\C774 \C5C5\B85C\B4DC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104931945865309420)
,p_name=>'FILE_UPLOAD_TOOMANYFILES_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C694\CCAD\C73C\B85C \D398\C774\C9C0\C5D0 \C815\C758\B41C \D30C\C77C \D56D\BAA9 \C720\D615 \C218\BCF4\B2E4 \B9CE\C740 \D30C\C77C\C774 \C5C5\B85C\B4DC\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105422431106309796)
,p_name=>'FIND_MY_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4 \C791\C5C5\C601\C5ED \CC3E\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104903017998309399)
,p_name=>'FIND_TABLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \CC3E\AE30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106130103368310393)
,p_name=>'FINISH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105275034678309678)
,p_name=>'FIRST_ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8 \D56D\BAA9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105428193149309800)
,p_name=>'FIXBY_PAST_DUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC\BCC4 \C218\C815 \AE30\AC04 \ACBD\ACFC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105344559515309731)
,p_name=>'FIXED_IN_DEVELOPMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C \C2DC \C218\C815\B428')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105362809042309745)
,p_name=>'FOCUS_AREA'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\CEE4\C2A4 \C601\C5ED')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105145517402309581)
,p_name=>'FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\B2E5\AE00 \D14D\C2A4\D2B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104884715530309384)
,p_name=>'FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106093491661310359)
,p_name=>'FORMAT_MASK_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \B9C8\C2A4\D06C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105426787036309799)
,p_name=>'FORM_AND_LIST_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \BC0F \BAA9\B85D \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105426890583309799)
,p_name=>'FORM_AND_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC\C774 \C788\B294 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105262795085309668)
,p_name=>'FORM_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C758 \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105004276646309473)
,p_name=>'FORM_ON_A_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C758 \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105406075422309777)
,p_name=>'FORM_QUERY_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\C758 \D3FC\C774 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105406367518309777)
,p_name=>'FORM_REPORT_WS_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \CC38\C870 \D3FC \BC0F \BCF4\ACE0\C11C\AC00 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105403632892309775)
,p_name=>'FORM_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC\C774 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105406178371309777)
,p_name=>'FORM_SUMMARY_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\C57D \D398\C774\C9C0\AC00 \C131\ACF5\C801\C73C\B85C \C791\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105405747690309776)
,p_name=>'FORM_TABLE_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C758 \D3FC\C774 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105406262803309777)
,p_name=>'FORM_WS_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \CC38\C870 \D3FC\C774 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104953437093309436)
,p_name=>'FORWARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C55E\C73C\B85C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105463219058309830)
,p_name=>'FROM_ATTRIBUTE_DICTIONARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131 \B515\C154\B108\B9AC\C5D0\C11C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105091785643309536)
,p_name=>'FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105353079084309738)
,p_name=>'FUNCTIONALLY_COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \C644\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105342818056309730)
,p_name=>'FUNCTIONAL_IMPLEMENTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \AD6C\D604')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105147150391309583)
,p_name=>'FUNCTION_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105093180948309537)
,p_name=>'FUNCTION_BODY_RETURNING_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105403355838309775)
,p_name=>'FUNCTION_RETURNING_REF_CURSOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870 \CEE4\C11C\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105396418767309770)
,p_name=>'FUNC_BODY_RETURNING_BOOLEAN	'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C6B8 \BC18\D658 PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104952202198309435)
,p_name=>'FUNC_RET_BOOLEAN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C6B8 \BC18\D658 PL/SQL \D568\C218')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105390180389309765)
,p_name=>'FUTURE_MILESTONES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\B798 \B9C8\C77C\C2A4\D1A4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106042636846310311)
,p_name=>'GANTT_BASELINEDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C900\C120 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106042536447310311)
,p_name=>'GANTT_BASELINEEND'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C900\C120 \B05D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106042445433310311)
,p_name=>'GANTT_BASELINESTART'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C900\C120 \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105396040528309769)
,p_name=>'GANTT_CHART.END_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105395917424309769)
,p_name=>'GANTT_CHART.START_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105630095115309967)
,p_name=>'GANTT_CHART.TASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106042150105310311)
,p_name=>'GANTT_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106042099067310311)
,p_name=>'GANTT_END'
,p_message_language=>'ko'
,p_message_text=>unistr('\B05D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106042219981310311)
,p_name=>'GANTT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106042376194310311)
,p_name=>'GANTT_PROGRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106041883716310311)
,p_name=>'GANTT_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106041965315310311)
,p_name=>'GANTT_START'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105827482470310129)
,p_name=>'GATHER_TABLE_STATS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \D1B5\ACC4 \C218\C9D1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105345639872309732)
,p_name=>'GENERAL_COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105696364409310026)
,p_name=>'GENERAL_COMMENT_DASH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C124\BA85: %1/%0 \C885\ACB0\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104957334216309438)
,p_name=>'GENERATED_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D14C\C774\BE14\C740 \D14C\C774\BE14 \B9C8\BC95\C0AC\B97C \C0AC\C6A9\D558\C5EC \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105041764481309500)
,p_name=>'GENERIC.CHANGES_SAVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD\C0AC\D56D \C800\C7A5\B428.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105351659190309737)
,p_name=>'GET_STATIC_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12 \BAA9\B85D \C0DD\C131 \B610\B294 \D3B8\C9D1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105364925008309746)
,p_name=>'GLOBALIZATION_ASSIGNEE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED\D654 \D53C\C9C0\C815\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105363115771309745)
,p_name=>'GLOBALIZATION_IMPACT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED\D654 \C601\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105365939231309747)
,p_name=>'GLOBALIZATION_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED\D654 \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104885919766309385)
,p_name=>'GLOBAL_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \D398\C774\C9C0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105410502336309780)
,p_name=>'GRAY_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68C\C0C9 \D14D\C2A4\D2B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105385499561309762)
,p_name=>'GRID_DEBUG_OFF'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\C544\C6C3 \C5F4 \C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105385394060309761)
,p_name=>'GRID_DEBUG_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\C544\C6C3 \C5F4 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104984075330309458)
,p_name=>'GRID_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B9AC\B4DC \D15C\D50C\B9AC\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105327508125309718)
,p_name=>'GROUPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105520044889309878)
,p_name=>'GROUP_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105145461840309581)
,p_name=>'HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \D14D\C2A4\D2B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105519856746309878)
,p_name=>'HEADING_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106090414274310356)
,p_name=>'HELP_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105093500560309537)
,p_name=>'HELP_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0 \D14D\C2A4\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105188536305309613)
,p_name=>'HIDDEN_AND_PROTECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE40 \BC0F \BCF4\D638\B428')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105346792678309733)
,p_name=>'HIGHLY_DESIRABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\C6B0 \AD8C\C7A5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106049446818310318)
,p_name=>'HIGH_CONTRAST'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\B300\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105811007226310116)
,p_name=>'HIGH_CONTRAST_TOGGLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\B300\BE44 \D1A0\AE00')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105327335644309718)
,p_name=>'HISTORY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C5ED')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105403153301309774)
,p_name=>'HOME_LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648 \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104881802002309382)
,p_name=>'HOME_NAV'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle APEX \D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104934669930309422)
,p_name=>'HOME_PAGE_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105120514921309557)
,p_name=>'HORIZONTAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\D3C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104867188993309369)
,p_name=>'HORIZONTAL2DCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\D3C9 2D \C138\B85C \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104867266421309369)
,p_name=>'HORIZONTAL3DCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\D3C9 3D \C138\B85C \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104867300101309369)
,p_name=>'HORIZONTALRANGE2DCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\D3C9 \BC94\C704 2D \C138\B85C \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104867407144309370)
,p_name=>'HORIZONTALRANGE3DCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\D3C9 \BC94\C704 3D \C138\B85C \B9C9\B300')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106089883680310356)
,p_name=>'HOT_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56B \D15C\D50C\B9AC\D2B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104925001870309415)
,p_name=>'HR_ACCOUNT_UNLOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('HR \ACC4\C815\C758 \C7A0\AE08\C774 \D574\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105094656769309538)
,p_name=>'HTML'
,p_message_language=>'ko'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105113657686309552)
,p_name=>'HTMLWITHSHORTCUTS'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML(\B2E8\CD95\D0A4 \C0AC\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105113377280309552)
,p_name=>'HTML_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104955994054309437)
,p_name=>'HTML_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104965328149309444)
,p_name=>'HTML_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105145788595309582)
,p_name=>'HTML_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104965473444309444)
,p_name=>'HTML_SLASH_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML/\D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105093268007309537)
,p_name=>'HTML_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104965588510309444)
,p_name=>'HTML_TEXT_WITH_SHORTCUTS'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D14D\C2A4\D2B8(\B2E8\CD95\D0A4 \C0AC\C6A9)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106090030842310356)
,p_name=>'ICON_CSS_CLASSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 CSS \D074\B798\C2A4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106025700475310295)
,p_name=>'IE6_COMPATIBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8\B294 IE 6\ACFC \D638\D658\B429\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105432806821309804)
,p_name=>'IG_ALLOW_EDITING'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1 \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105432941452309804)
,p_name=>'IG_READ_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77D\AE30 \C804\C6A9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105094842455309538)
,p_name=>'IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105635685137309972)
,p_name=>'IMAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105079294622309527)
,p_name=>'IMAGE_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105402596770309774)
,p_name=>'IMAGE_PREFIX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \C811\B450\C5B4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105340471735309728)
,p_name=>'IMPORT FROM APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C784\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106101730909310366)
,p_name=>'IMPORT_APP_NEW_SUBSTRING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4 \BB38\C790\C5F4 %0\C758 \C0C8 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105570353378309918)
,p_name=>'IMPORT_APP_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C784\D3EC\D2B8\D55C \D30C\C77C\C774 <a href="%0">\C775\C2A4\D3EC\D2B8 \C800\C7A5\C18C</a>\C5D0 \C788\C2B5\B2C8\B2E4. \B2E4\C2DC \C124\CE58\D558\C9C0 \C54A\C73C\B824\BA74 \D574\B2F9 \D30C\C77C\C744 \C81C\AC70\D574\C57C \D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105275920754309678)
,p_name=>'IN/OUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825/\CD9C\B825')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104892479407309390)
,p_name=>'INACTIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\D65C\C131')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105474839202309840)
,p_name=>'INCLUDE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106094368733310360)
,p_name=>'INCLUDE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\D568: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105091898366309536)
,p_name=>'INDEX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B371\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105472204266309837)
,p_name=>'INDEX_NOUN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B371\C2A4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105036235407309496)
,p_name=>'INITCAP_REFRESH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C\ACE0\CE68')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105250282855309659)
,p_name=>'INLINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106039711734310309)
,p_name=>'INLINE_HELP_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \B3C4\C6C0\B9D0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105250144300309659)
,p_name=>'INLINE_NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \BC0F \D1B5\C9C0\C5D0 \D3EC\D568')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105396103467309769)
,p_name=>'INPUT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825 \C720\D615')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105092583551309536)
,p_name=>'INSERT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0BD\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105481639339309845)
,p_name=>'INSERT_EXCEPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('wwv_flow_companies\B85C\C758 \C0BD\C785 \C608\C678\C0AC\D56D:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105412276560309781)
,p_name=>'INSTALLER.APPLICATION_CSS'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS(\C560\D50C\B9AC\CF00\C774\C158)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105412057951309781)
,p_name=>'INSTALLER.APPLICATION_IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0(\C560\D50C\B9AC\CF00\C774\C158)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105412468186309781)
,p_name=>'INSTALLER.APPLICATION_STATIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \D30C\C77C(\C560\D50C\B9AC\CF00\C774\C158)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104921340714309412)
,p_name=>'INSTALLER.BUILD_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104978861259309454)
,p_name=>'INSTALLER.BUILD_OPTIONS_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \BE4C\B4DC \C635\C158\C744 \D3EC\D568\D558\B3C4\B85D \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104921220772309412)
,p_name=>'INSTALLER.CONFIGURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \B300\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104978768100309454)
,p_name=>'INSTALLER.CONFIGURATION_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C758 \B2E4\C74C \C18D\C131\C744 \AD6C\C131\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104921526803309412)
,p_name=>'INSTALLER.CONFIRMATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58 \D655\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104979020803309454)
,p_name=>'INSTALLER.CONFIRMATION_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \C9C0\C6D0 \AC1D\CCB4\B97C \C124\CE58\D560 \AC83\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104921921133309413)
,p_name=>'INSTALLER.CONFIRM_DEINSTALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58 \C81C\AC70 \D655\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104896522862309394)
,p_name=>'INSTALLER.DEINSTALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58 \C81C\AC70 \C2A4\D06C\B9BD\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104922030415309413)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58 \C81C\AC70 \C131\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104979397648309455)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58 \C81C\AC70\AC00 \C644\B8CC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105266272724309671)
,p_name=>'INSTALLER.ERROR.IN_CHECK'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C124\CE58 \AC80\C0AC "%0"\C744(\B97C) \C218\D589\D560 \B54C \C624\B958 \BC1C\C0DD:'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105266389546309671)
,p_name=>'INSTALLER.ERROR.IN_SCRIPT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C124\CE58 \C2A4\D06C\B9BD\D2B8 "%0"\C744(\B97C) \C2E4\D589\D560 \B54C \C624\B958 \BC1C\C0DD:'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104921184398309412)
,p_name=>'INSTALLER.EXISTENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C874\C7AC \D655\C778 \C2E4\D328')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104921787754309413)
,p_name=>'INSTALLER.FAILURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\D6C4 \C124\CE58 \C2E4\D328')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104979298528309454)
,p_name=>'INSTALLER.FAILURE_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4 \BC0F \C2DC\B4DC \B370\C774\D130\C758 \C124\CE58\B97C \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105328657486309719)
,p_name=>'INSTALLER.INSTALL_FAILURE_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C124\CE58 \D504\B85C\ADF8\B7A8\C744 \D1B5\D574 \C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \C9C0\C6D0 \AC1D\CCB4\AC00 \C774\BBF8 \C124\CE58\B41C \AC83\C73C\B85C \AC10\C9C0\B418\C5C8\C2B5\B2C8\B2E4. \C774 \C560\D50C\B9AC\CF00\C774\C158\C744 \C124\CE58\D558\B824\BA74 SQL Workshop\C744 \D1B5\D574 \D574\B2F9 \AC1D\CCB4\B97C \C81C\AC70\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104921882427309413)
,p_name=>'INSTALLER.LICENSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B77C\C774\C13C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104917035056309409)
,p_name=>'INSTALLER.SCRIPT.FAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104916990569309409)
,p_name=>'INSTALLER.SCRIPT.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104921647617309412)
,p_name=>'INSTALLER.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\D6C4 \C124\CE58 \C131\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104979174421309454)
,p_name=>'INSTALLER.SUCCESS_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C758 \C9C0\C6D0 \AC1D\CCB4\AC00 \C124\CE58\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105018185968309483)
,p_name=>'INSTALLER.UPGRADE_CONFIRM_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \C9C0\C6D0 \AC1D\CCB4\B97C \C5C5\ADF8\B808\C774\B4DC\D560 \AC83\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105018049382309483)
,p_name=>'INSTALLER.UPGRADE_FAILURE_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \C9C0\C6D0 \AC1D\CCB4 \C5C5\ADF8\B808\C774\B4DC\B97C \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105017656091309482)
,p_name=>'INSTALLER.UPGRADE_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804\C5D0 \C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \C9C0\C6D0 \AC1D\CCB4\AC00 \C124\CE58\B418\C5C8\C2B5\B2C8\B2E4. \C774 \B9C8\BC95\C0AC\B294 \C774\B7EC\D55C \C9C0\C6D0 \AC1D\CCB4\C758 \C5C5\ADF8\B808\C774\B4DC \ACFC\C815\C744 \C548\B0B4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105017993696309483)
,p_name=>'INSTALLER.UPGRADE_SUCCESS_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C758 \C9C0\C6D0 \AC1D\CCB4\AC00 \C5C5\ADF8\B808\C774\B4DC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104921418910309412)
,p_name=>'INSTALLER.VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104978994834309454)
,p_name=>'INSTALLER.VALIDATION_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C2A4\D15C\C774 \C774 \C560\D50C\B9AC\CF00\C774\C158\ACFC \D638\D658\B418\B294\C9C0 \D655\C778\D558\AE30 \C704\D574 \B2E4\C74C \AC80\C99D\C774 \C218\D589\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104921024035309412)
,p_name=>'INSTALLER.WELCOME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104978619139309454)
,p_name=>'INSTALLER.WELCOME_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C124\CE58 \D504\B85C\ADF8\B7A8\C740 \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4 \BC0F \C2DC\B4DC \B370\C774\D130\C758 \C0DD\C131 \D504\B85C\C138\C2A4\B97C \C548\B0B4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105412145398309781)
,p_name=>'INSTALLER.WORKSPACE_CSS'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS(\C791\C5C5\C601\C5ED)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105411916952309781)
,p_name=>'INSTALLER.WORKSPACE_IMAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0(\C791\C5C5\C601\C5ED)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105412338994309781)
,p_name=>'INSTALLER.WORKSPACE_STATIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \D30C\C77C(\C791\C5C5\C601\C5ED)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104909300395309404)
,p_name=>'INSTALL_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C571 \C124\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105412527099309781)
,p_name=>'INSTALL_SAMPLE_APPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158 \C124\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105810404324310116)
,p_name=>'INSTANCE_ADMIN_HOME_NAV'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle APEX \AD00\B9AC \C11C\BE44\C2A4 \D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105459707202309827)
,p_name=>'INSTANCE_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C2A4\D134\C2A4 \C124\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105361744918309744)
,p_name=>'INST_RUNNING_IN_MAN_MODE_4050'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C778\C2A4\D134\C2A4\B294 \C218\B3D9 \B4F1\B85D \BAA8\B4DC\B85C \C2E4\D589 \C911\C774\BBC0\B85C \C11C\BE44\C2A4 \C694\CCAD\C744 \D5C8\C6A9\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105454860484309824)
,p_name=>'INSUFFICIENT_INSTALL_SPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C744 \C124\CE58\D560 \C218 \C788\B294 \ACF5\AC04\C774 \BD80\C871\D569\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105342970085309730)
,p_name=>'INTEGRATION_COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\D569 \C644\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105348109554309734)
,p_name=>'INTEGRATION_SIGNOFF'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\D569 \C0AC\C778\C624\D504')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105338638977309727)
,p_name=>'INTERACTIVE_GRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105114314556309552)
,p_name=>'INTERACTIVE_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105368174230309749)
,p_name=>'INTERACTIVE_REPORT_SEARCHES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104933328442309421)
,p_name=>'INTERNAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\BD80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104885669349309385)
,p_name=>'INTERNAL_ADMINISTRATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\BD80 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104935029488309422)
,p_name=>'INTERNAL_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\BD80')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105262320749309668)
,p_name=>'INVALID_APPLICATION_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \C774\B984\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104892347790309390)
,p_name=>'INVALID_APP_ARCHIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C774 \C801\D569\D55C \C560\D50C\B9AC\CF00\C774\C158 \C544\CE74\C774\BE0C\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105262887590309668)
,p_name=>'INVALID_GROUP_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \ADF8\B8F9 \C774\B984\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104954101880309436)
,p_name=>'INVALID_OBJECT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \AC1D\CCB4\AC00 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105616003187309955)
,p_name=>'INVALID_PAGE_GROUP_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \D398\C774\C9C0 \ADF8\B8F9 \C774\B984\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106130620374310393)
,p_name=>'INVALID_POSITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C704\CE58 [\B80C\B354\B9C1\B418\C9C0 \C54A\C74C]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105481366746309845)
,p_name=>'INVALID_SCHEMA_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C2A4\D0A4\B9C8 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105395147175309769)
,p_name=>'INVALID_SORT_ORDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \BD80\C801\D569\D569\B2C8\B2E4. \AC12\C740 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106079432900310346)
,p_name=>'INVALID_USERS_NOT_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \BB38\C790\C5F4\C740 \BD80\C801\D569\D55C \C0AC\C6A9\C790 \C774\B984\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105481233583309845)
,p_name=>'INVALID_WORKSPACE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C791\C5C5\C601\C5ED \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105421820164309795)
,p_name=>'INVALID_WS_OBJ'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C6F9 \C2DC\D2B8 \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105419711390309793)
,p_name=>'INVALID_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C6F9 \C2DC\D2B8 \AC1D\CCB4\B97C \C218\C815\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105421958789309795)
,p_name=>'INVALID_WS_OBJ_WARNING_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\B294 \B370 \D544\C694\D55C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\AC00 \BD80\C801\D569\D558\AC70\B098 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \C791\C5C5\C601\C5ED \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104867580403309370)
,p_name=>'INVERSE2DLINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5ED 2D \C120')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105344447944309731)
,p_name=>'IN_PROGRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C4\D589 \C911')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105040291848309499)
,p_name=>'IR_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105288631837309688)
,p_name=>'IR_DEVELOPER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105288583271309687)
,p_name=>'IR_END_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105288974901309688)
,p_name=>'IR_INTERACTIVE_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105265022871309670)
,p_name=>'IR_ONLY_ONE_PER_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B098\C758 \B300\D654\C2DD \BCF4\ACE0\C11C\B9CC \D398\C774\C9C0\C5D0 \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105288733693309688)
,p_name=>'IR_SAVE_ONLY_FOR_DEV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B300\D654\C0C1\C790\B294 \AC1C\BC1C\C790\C5D0 \B300\D574\C11C\B9CC \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105288456120309687)
,p_name=>'IR_SAVE_REPORT_STAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C800\C7A5 *')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105288899518309688)
,p_name=>'IR_SAVE_STAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5 *')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106093995279310359)
,p_name=>'IR_SUBSCRIPTION_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158: %0, \D398\C774\C9C0: %1, \AC00\C785\C790: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105407785571309778)
,p_name=>'IR_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C \D398\C774\C9C0\AC00 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105289004684309688)
,p_name=>'IR_UNITS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C704')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105829160655310130)
,p_name=>'ISSUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C81C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105276642750309679)
,p_name=>'IS_WRAPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C904\BC14\AFC8\B428')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105387871057309763)
,p_name=>'ITEM CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104965709628309444)
,p_name=>'ITEM NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104933032890309421)
,p_name=>'ITEM.BUTTONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106114655381310378)
,p_name=>'ITEM_COLUMN_SPAN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D56D\BAA9 \C5F4 \D655\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104952566627309435)
,p_name=>'ITEM_EXP1_EQ_EXP2'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD 1\C758 \D56D\BAA9 \AC12\C740 \D45C\D604\C2DD 2\C640 \AC19\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104952665931309435)
,p_name=>'ITEM_EXP1_NE_EXP2'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD 1\C758 \D56D\BAA9 \AC12\C740 \D45C\D604\C2DD 2\C640 \AC19\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104952172969309435)
,p_name=>'ITEM_IN_EXP1_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD 1\C5D0 \C788\B294 \D56D\BAA9\C740 \B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104952061627309434)
,p_name=>'ITEM_IN_EXP1_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD 1\C5D0 \C788\B294 \D56D\BAA9\C740 \B110\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106093169607310358)
,p_name=>'ITEM_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105010276703309477)
,p_name=>'ITEM_NAME.DATE_PICKER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105010329662309477)
,p_name=>'ITEM_NAME.HIDDEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105353122670309738)
,p_name=>'ITEM_NAME.NATIVE_AUTO_COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \D544\B4DC(\C790\B3D9 \C644\C131 \C0AC\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105638839009309975)
,p_name=>'ITEM_NAME.NATIVE_CHECKBOX'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\BC15\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106008563462310278)
,p_name=>'ITEM_NAME.NATIVE_COLOR_PICKER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105468412145309834)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105631039803309968)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_CLASSIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \C120\D0DD\AE30(\D074\B798\C2DD)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104877724366309378)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_HTML5'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \C120\D0DD\AE30(HTML5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105673293432310006)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105632550283309969)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C804\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105672062264310005)
,p_name=>'ITEM_NAME.NATIVE_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \CC3E\C544\BCF4\AE30...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106008335654310278)
,p_name=>'ITEM_NAME.NATIVE_HIDDEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105678918867310011)
,p_name=>'ITEM_NAME.NATIVE_LIST_MANAGER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \AD00\B9AC\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105695172685310025)
,p_name=>'ITEM_NAME.NATIVE_MARKDOWN_EDITOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\D06C\B2E4\C6B4 \D3B8\C9D1\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105622984399309961)
,p_name=>'ITEM_NAME.NATIVE_NUMBER_FIELD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C22B\C790 \D544\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105624446287309962)
,p_name=>'ITEM_NAME.NATIVE_PASSWORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105631713383309969)
,p_name=>'ITEM_NAME.NATIVE_POPUP_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105638763208309975)
,p_name=>'ITEM_NAME.NATIVE_RADIOGROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B77C\B514\C624 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105384692210309761)
,p_name=>'ITEM_NAME.NATIVE_RICH_TEXT_EDITOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\C2DD \C788\B294 \D14D\C2A4\D2B8 \D3B8\C9D1\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105631195924309968)
,p_name=>'ITEM_NAME.NATIVE_SELECT_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105633144362309970)
,p_name=>'ITEM_NAME.NATIVE_SHUTTLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C154\D2C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104898873644309396)
,p_name=>'ITEM_NAME.NATIVE_SLIDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2AC\B77C\C774\B354')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105010415670309477)
,p_name=>'ITEM_NAME.NATIVE_STOP_AND_START_HTML_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B9AC\B4DC \B808\C774\C544\C6C3 \C815\C9C0 \BC0F \C2DC\C791(\C0AC\C6A9\B418\C9C0 \C54A\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105386632422309762)
,p_name=>'ITEM_NAME.NATIVE_TEXTAREA'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106008419425310278)
,p_name=>'ITEM_NAME.NATIVE_TEXT_FIELD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \D544\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104898553568309396)
,p_name=>'ITEM_NAME.NATIVE_YES_NO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608/\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104960084255309440)
,p_name=>'ITEM_NAME.PLUGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105010502815309477)
,p_name=>'ITEM_NAME.POPUP_LIST_OF_VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105647851484309983)
,p_name=>'ITEM_NAME.STAR_RATING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\C810 \D3C9\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105010629109309477)
,p_name=>'ITEM_NAME.TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106048018972310317)
,p_name=>'ITEM_POST_TEXT_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C0AC\D6C4 \D14D\C2A4\D2B8 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106047946034310317)
,p_name=>'ITEM_PRE_TEXT_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C0AC\C804 \D14D\C2A4\D2B8 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105413179327309782)
,p_name=>'ITEM_ROW_2'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105413299907309782)
,p_name=>'ITEM_ROW_3'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105413394188309782)
,p_name=>'ITEM_ROW_4'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105413409598309782)
,p_name=>'ITEM_ROW_5'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105622874518309961)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MAX_VALUE_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D56D\BAA9\C5D0 \B300\D574 \C785\B825\D55C \CD5C\B300\AC12 %0\C774(\AC00) \C22B\C790\AC00 \C544\B2D9\B2C8\B2E4. \AC12\C5D0 \C18C\C218\C810 \C790\B9BF\C218\AC00 \D3EC\D568\B420 \ACBD\C6B0 \B9C8\CE68\D45C\B97C \C18C\C218\C810 \AD6C\BD84\C790\B85C \C9C0\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105622716092309961)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MIN_VALUE_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D56D\BAA9\C5D0 \B300\D574 \C785\B825\D55C \CD5C\C18C\AC12 %0\C774(\AC00) \C22B\C790\AC00 \C544\B2D9\B2C8\B2E4. \AC12\C5D0 \C18C\C218\C810 \C790\B9BF\C218\AC00 \D3EC\D568\B420 \ACBD\C6B0 \B9C8\CE68\D45C\B97C \C18C\C218\C810 \AD6C\BD84\C790\B85C \C9C0\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104898756757309396)
,p_name=>'ITEM_TYPE.ATTRIBUTE.STEP_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D56D\BAA9\C5D0 \B300\D574 \C785\B825\D55C \B2E8\ACC4 \AC12 %0\C774(\AC00) \C22B\C790\AC00 \C544\B2D9\B2C8\B2E4. \AC12\C5D0 \C18C\C218\C810 \C790\B9AC\AC00 \D3EC\D568\B418\C5B4 \C788\C73C\BA74 \C18C\C218 \AD6C\BD84 \AE30\D638\B85C \B9C8\CE68\D45C\B97C \C9C0\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104960489768309441)
,p_name=>'ITEM_TYPE.BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104960516452309441)
,p_name=>'ITEM_TYPE.FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \CC3E\C544\BCF4\AE30...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104960694827309441)
,p_name=>'ITEM_TYPE.HIDDEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104960775942309441)
,p_name=>'ITEM_TYPE.HIDDEN_PROTECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE40 \BC0F \BCF4\D638\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104960828488309441)
,p_name=>'ITEM_TYPE.POPUP_COLOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \C0C9\C0C1 \C120\D0DD\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104960972189309441)
,p_name=>'ITEM_TYPE.TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \D544\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104961042420309441)
,p_name=>'ITEM_TYPE.TEXT_DISABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \D544\B4DC(\C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B428, \C0C1\D0DC\B97C \C800\C7A5\D558\C9C0 \C54A\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104961180109309441)
,p_name=>'ITEM_TYPE.TEXT_DISABLED_AND_SAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \D544\B4DC(\C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B428, \C0C1\D0DC \C800\C7A5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104961228698309441)
,p_name=>'ITEM_TYPE.TEXT_WITH_ENTER_SUBMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \D544\B4DC(Enter \D0A4\B97C \B204\B97C \B54C \D56D\C0C1 \D398\C774\C9C0 \C81C\CD9C)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105338489758309727)
,p_name=>'JET_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('JET \CC28\D2B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105273843180309677)
,p_name=>'JOB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105339652320309728)
,p_name=>'JQM COLUMN TOGGLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \D1A0\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105339514948309728)
,p_name=>'JQM REFLOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\BC30\CE58 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105415176341309789)
,p_name=>'JQM_FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\B2E5\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105415093172309789)
,p_name=>'JQM_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105341554565309729)
,p_name=>'JQM_LIST_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \BCF4\AE30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105338778190309727)
,p_name=>'JSTREE'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D2B8\B9AC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105364873492309746)
,p_name=>'JUSTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADFC\AC70')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105829209832310130)
,p_name=>'LABELS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106114557921310378)
,p_name=>'LABEL_COLUMN_SPAN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \B808\C774\BE14 \C5F4 \D655\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106108145486310372)
,p_name=>'LABEL_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D56D\BAA9 \B808\C774\BE14 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105401612472309773)
,p_name=>'LABEL_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105066699349309518)
,p_name=>'LABEL_TEMPLATE.COPIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105066773926309518)
,p_name=>'LABEL_TEMPLATE.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D15C\D50C\B9AC\D2B8\C758 "\B9C8\C2A4\D130" \BCF5\C0AC\BCF8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105066928502309518)
,p_name=>'LABEL_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\B418\B294 \D15C\D50C\B9AC\D2B8\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105066837044309518)
,p_name=>'LABEL_TEMPLATE.REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9 \C911\C778 \B808\C774\BE14 \D15C\D50C\B9AC\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104909819524309404)
,p_name=>'LANGUAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105367666256309748)
,p_name=>'LAST_CHANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C885 \BCC0\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105275106134309678)
,p_name=>'LAST_ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105370546879309750)
,p_name=>'LAST_LOGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9 \B85C\ADF8\C778')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104887282528309386)
,p_name=>'LAYOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 - \B808\C774\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104924260740309414)
,p_name=>'LAYOUT.AFTER_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105263517069309668)
,p_name=>'LAYOUT.AFTER_ERROR_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D398\C774\C9C0 \BA38\B9AC\AE00 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105263279152309668)
,p_name=>'LAYOUT.AFTER_FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\B2E5\AE00 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105329536081309720)
,p_name=>'LAYOUT.AFTER_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105678142663310010)
,p_name=>'LAYOUT.AFTER_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105612723310309952)
,p_name=>'LAYOUT.AFTER_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105613128072309952)
,p_name=>'LAYOUT.AFTER_LABEL_AND_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \BC0F \D56D\BAA9 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105014503545309480)
,p_name=>'LAYOUT.AFTER_LOGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \D6C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105254034017309662)
,p_name=>'LAYOUT.AFTER_PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC \D6C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105263036316309668)
,p_name=>'LAYOUT.AFTER_REGIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105263328071309668)
,p_name=>'LAYOUT.AFTER_SUBMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C \D6C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104924180968309414)
,p_name=>'LAYOUT.BEFORE_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105253751171309661)
,p_name=>'LAYOUT.BEFORE_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105263606161309669)
,p_name=>'LAYOUT.BEFORE_ERROR_FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D398\C774\C9C0 \BC14\B2E5\AE00 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105263190980309668)
,p_name=>'LAYOUT.BEFORE_FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\B2E5\AE00 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105253685119309661)
,p_name=>'LAYOUT.BEFORE_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105678060535310010)
,p_name=>'LAYOUT.BEFORE_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105612617452309952)
,p_name=>'LAYOUT.BEFORE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105613052324309952)
,p_name=>'LAYOUT.BEFORE_LABEL_AND_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \BC0F \D56D\BAA9 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105253939703309661)
,p_name=>'LAYOUT.BEFORE_PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC \C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105262916996309668)
,p_name=>'LAYOUT.BEFORE_REGIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105253813434309661)
,p_name=>'LAYOUT.BEFORE_VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105323257645309715)
,p_name=>'LAYOUT.BRANCHES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105005275502309473)
,p_name=>'LAYOUT.BUTTON.ABOVE_BOX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C790 \C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105005386308309474)
,p_name=>'LAYOUT.BUTTON.BELOW_BOX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C790 \C544\B798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105005434680309474)
,p_name=>'LAYOUT.BUTTON.BOTTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105005570209309474)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CHANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \BCC0\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105005674388309474)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \B2EB\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105005721450309474)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_COPY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105005826714309474)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105005972558309474)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105006029611309474)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105006120567309474)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EXPAND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \D655\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105006257828309474)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105006332930309474)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_PREVIOUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105006452701309474)
,p_name=>'LAYOUT.BUTTON.TOP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105246404670309656)
,p_name=>'LAYOUT.CHANGE_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105317177384309710)
,p_name=>'LAYOUT.CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105465932577309832)
,p_name=>'LAYOUT.CHART_SERIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105245668086309655)
,p_name=>'LAYOUT.CLOSE_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EB\AE30 \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105246160705309656)
,p_name=>'LAYOUT.COPY_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105245898396309656)
,p_name=>'LAYOUT.CREATE2_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131 2 \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104877947978309379)
,p_name=>'LAYOUT.CUSTOM_POSITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105465612206309832)
,p_name=>'LAYOUT.DA_EVENT_FALSE'
,p_message_language=>'ko'
,p_message_text=>'False'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105465785155309832)
,p_name=>'LAYOUT.DA_EVENT_TRUE'
,p_message_language=>'ko'
,p_message_text=>'True'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105246011279309656)
,p_name=>'LAYOUT.DELETE_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105682564310310014)
,p_name=>'LAYOUT.EMPTY_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE48 \B808\C774\BE14 - #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106090149489310356)
,p_name=>'LAYOUT.ERROR_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105245713392309656)
,p_name=>'LAYOUT.EXPAND_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C7A5 \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105187760737309612)
,p_name=>'LAYOUT.FUNCTION_RETURNING_SQL_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105466031317309832)
,p_name=>'LAYOUT.GLOBAL_PAGE_REGION_PREFIX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \D398\C774\C9C0: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105245946744309656)
,p_name=>'LAYOUT.HELP_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0 \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105678284349310010)
,p_name=>'LAYOUT.HELP_LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \B3C4\C6C0\B9D0 \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105682615756310014)
,p_name=>'LAYOUT.HIDDEN_FIELD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\ACA8\C9D0 - #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105187668639309612)
,p_name=>'LAYOUT.HTML_TEXT_ESCAPE_SC'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D14D\C2A4\D2B8(\C774\C2A4\CF00\C774\D504 \D2B9\C218 \BB38\C790)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106039602680310309)
,p_name=>'LAYOUT.INLINE_HELP_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106048261012310317)
,p_name=>'LAYOUT.ITEM_POST_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C0AC\D6C4 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106048192626310317)
,p_name=>'LAYOUT.ITEM_PRE_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C0AC\C804 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105246262365309656)
,p_name=>'LAYOUT.NEXT_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105323149016309715)
,p_name=>'LAYOUT.NOREGION_AT_DISP_POINT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C9C0\C810\C5D0 \C601\C5ED \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105466144702309833)
,p_name=>'LAYOUT.NO_REGION_ASSIGNED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED\C774 \C5C6\B294 \D398\C774\C9C0 \D56D\BAA9 \BC0F \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105355873797309740)
,p_name=>'LAYOUT.ON_DEMAND'
,p_message_language=>'ko'
,p_message_text=>unistr('Ajax \CF5C\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105612902458309952)
,p_name=>'LAYOUT.ON_ERROR_AFTER_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \BC1C\C0DD \C2DC \B808\C774\BE14 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105612847142309952)
,p_name=>'LAYOUT.ON_ERROR_BEFORE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \BC1C\C0DD \C2DC \B808\C774\BE14 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105256141918309663)
,p_name=>'LAYOUT.ON_NEW_INSTANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C778\C2A4\D134\C2A4 \C2DC\C791 \C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105256290405309663)
,p_name=>'LAYOUT.ON_SUBMIT_BEFORE_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C \C2DC \BC0F \ACC4\C0B0 \C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105246385260309656)
,p_name=>'LAYOUT.PREVIOUS_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804 \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105466351173309833)
,p_name=>'LAYOUT.PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104855390555309359)
,p_name=>'LAYOUT.REGION_POS_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105466474573309833)
,p_name=>'LAYOUT.REGION_POS_BODY_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38(#0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105466558651309833)
,p_name=>'LAYOUT.REGION_POS_NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58 #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105465882171309832)
,p_name=>'LAYOUT.REPORT_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105468722446309835)
,p_name=>'LAYOUT.RUN_JAVASCRIPT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105187888093309612)
,p_name=>'LAYOUT.SIMPLE_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\B2E8\D55C \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105188145119309613)
,p_name=>'LAYOUT.STRUCTURED_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C870\D654\B41C \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105468626672309834)
,p_name=>'LAYOUT.SUBMIT_AS'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0"(\C73C)\B85C \C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105340151414309728)
,p_name=>'LAYOUT.SUB_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C704 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105188044497309613)
,p_name=>'LAYOUT.SVG_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('SVG \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104972814634309450)
,p_name=>'LAYOUT.T_#APEX_CSS#'
,p_message_language=>'ko'
,p_message_text=>unistr('&PRODUCT_NAME.\C5D0 \C758\D574 \C0AC\C6A9\B418\B294 \C885\C18D\D615 \C2DC\D2B8 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104973243300309450)
,p_name=>'LAYOUT.T_#APEX_JAVASCRIPT#'
,p_message_language=>'ko'
,p_message_text=>unistr('&PRODUCT_NAME.\C5D0 \C758\D574 \C0AC\C6A9\B418\B294 JavaScript \D30C\C77C \BC0F \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106092258266310358)
,p_name=>'LAYOUT.T_#APPLICATION_CSS#'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \B808\BCA8\C5D0\C11C \C815\C758\B41C \C885\C18D\D615 \C2DC\D2B8 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104973468848309450)
,p_name=>'LAYOUT.T_#APPLICATION_JAVASCRIPT#'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \B808\BCA8\C5D0 \C815\C758\B41C JavaScript \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105418987157309793)
,p_name=>'LAYOUT.T_#DIALOG_ATTRIBUTES#'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \C18D\C131, \C120\C5B8\C801\C73C\B85C \C9C0\C6D0\B418\C9C0 \C54A\B294 \B300\D654\C0C1\C790 \C18D\C131 \C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106041372235310310)
,p_name=>'LAYOUT.T_#DIALOG_CSS_CLASSES#'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105418536296309792)
,p_name=>'LAYOUT.T_#DIALOG_HEIGHT#'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \B192\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105418743708309793)
,p_name=>'LAYOUT.T_#DIALOG_MAX_WIDTH#'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \CD5C\B300 \B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105418653416309792)
,p_name=>'LAYOUT.T_#DIALOG_WIDTH#'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106113066450310377)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_NAV_LABEL#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \D655\C7A5/\CD95\C18C \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106113195819310377)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_SIDE_COL_LABEL#'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE21\BA74 \C5F4 \D655\C7A5/\CD95\C18C \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106082551865310349)
,p_name=>'LAYOUT.T_#FAVICONS#'
,p_message_language=>'ko'
,p_message_text=>unistr('Favicon HTML \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104973122507309450)
,p_name=>'LAYOUT.T_#GENERATED_CSS#'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\C5D0 \C758\D574 \C989\C2DC \C0DD\C131\B41C \C885\C18D\D615 \C2DC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104973521450309450)
,p_name=>'LAYOUT.T_#GENERATED_JAVASCRIPT#'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\C5D0 \C758\D574 \C989\C2DC \C0DD\C131\B41C JavaScript \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105418854596309793)
,p_name=>'LAYOUT.T_#IS_MODAL#'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \D398\C774\C9C0 \BAA8\B4DC(\C608: \BAA8\B2EC\C758 \ACBD\C6B0 ''true'', \BE44\BAA8\B2EC\C758 \ACBD\C6B0 ''false'')')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104973029682309450)
,p_name=>'LAYOUT.T_#PAGE_CSS#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B808\BCA8\C5D0\C11C \C815\C758\B41C \C885\C18D\D615 \C2DC\D2B8 \D30C\C77C \BC0F \C778\B77C\C778 \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104966788741309445)
,p_name=>'LAYOUT.T_#PAGE_CSS_CLASSES#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105622166280309960)
,p_name=>'LAYOUT.T_#PAGE_JAVASCRIPT#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B808\BCA8\C5D0\C11C \C815\C758\B41C JavaScript \D30C\C77C \BC0F \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104884982620309384)
,p_name=>'LAYOUT.T_#PAGE_STATIC_ID#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C815\C801 ID(\C608: ''P100'')')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104881304159309382)
,p_name=>'LAYOUT.T_#PAGE_TRANSITION#'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \D398\C774\C9C0\B85C \C774\B3D9\D558\AE30 \C704\D574 \C0AC\C6A9\B41C \BCC0\D658\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105418464971309792)
,p_name=>'LAYOUT.T_#PAGE_URL#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104881413100309382)
,p_name=>'LAYOUT.T_#POPUP_TRANSITION#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5\C744 \C5F4\AE30 \C704\D574 \C0AC\C6A9\B41C \BCC0\D658\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105421614771309795)
,p_name=>'LAYOUT.T_#REQUESTED_URL#'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE0C\B77C\C6B0\C800\C5D0\C11C \C694\CCAD\B41C \D398\C774\C9C0 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106092440468310358)
,p_name=>'LAYOUT.T_#SIDE_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \BA54\B274(\CE21\BA74)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104972980701309450)
,p_name=>'LAYOUT.T_#TEMPLATE_CSS#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8\C5D0\C11C \C815\C758\B41C \C885\C18D\D615 \C2DC\D2B8 \D30C\C77C \BC0F \C778\B77C\C778 \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104973326424309450)
,p_name=>'LAYOUT.T_#TEMPLATE_JAVASCRIPT#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8\C5D0\C11C \C815\C758\B41C JavaScript \D30C\C77C \BC0F \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104973657945309450)
,p_name=>'LAYOUT.T_#THEME_CSS#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \B808\BCA8\C5D0 \C815\C758\B41C \C885\C18D\D615 \C2DC\D2B8 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106101202502310366)
,p_name=>'LAYOUT.T_#THEME_JAVASCRIPT#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \B808\BCA8\C5D0 \C815\C758\B41C JavaScript \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106101375529310366)
,p_name=>'LAYOUT.T_#THEME_STYLE_CSS#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C \B808\BCA8\C5D0 \C815\C758\B41C \C885\C18D\D615 \C2DC\D2B8 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106092392879310358)
,p_name=>'LAYOUT.T_#TOP_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \BA54\B274(\C704\CABD)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105419024624309793)
,p_name=>'LAYOUT.T_#TRIGGERING_ELEMENT#'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC\AC70 \C774\BCA4\D2B8(\C608: \D604\C7AC DOM \C694\C18C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105032056357309493)
,p_name=>'LAYOUT.T_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105622272305309960)
,p_name=>'LAYOUT.T_AFFECTED_ELEMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105029041857309491)
,p_name=>'LAYOUT.T_ALT_APPLICATION_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105025089535309488)
,p_name=>'LAYOUT.T_ALT_ARROW_DOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105028622889309490)
,p_name=>'LAYOUT.T_ALT_BODY_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38 \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105024494871309487)
,p_name=>'LAYOUT.T_ALT_BRANCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105025193792309488)
,p_name=>'LAYOUT.T_ALT_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105027738020309490)
,p_name=>'LAYOUT.T_ALT_CHANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105026869897309489)
,p_name=>'LAYOUT.T_ALT_CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EB\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105029156012309491)
,p_name=>'LAYOUT.T_ALT_COMPANY_IMG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105024246241309487)
,p_name=>'LAYOUT.T_ALT_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105027460044309490)
,p_name=>'LAYOUT.T_ALT_COPY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105026663468309489)
,p_name=>'LAYOUT.T_ALT_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105026748649309489)
,p_name=>'LAYOUT.T_ALT_CREATE2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105027362191309489)
,p_name=>'LAYOUT.T_ALT_DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105026496149309489)
,p_name=>'LAYOUT.T_ALT_EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105026506393309489)
,p_name=>'LAYOUT.T_ALT_EXPAND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105027134014309489)
,p_name=>'LAYOUT.T_ALT_FORM_CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \B2EB\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105027014518309489)
,p_name=>'LAYOUT.T_ALT_FORM_OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \C5F4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105028268039309490)
,p_name=>'LAYOUT.T_ALT_GLOBAL_NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \D1B5\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105027288637309489)
,p_name=>'LAYOUT.T_ALT_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105025249952309488)
,p_name=>'LAYOUT.T_ALT_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105028029240309490)
,p_name=>'LAYOUT.T_ALT_NAV_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105027558075309490)
,p_name=>'LAYOUT.T_ALT_NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105028125557309490)
,p_name=>'LAYOUT.T_ALT_NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105028938241309491)
,p_name=>'LAYOUT.T_ALT_PARENT_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105027619396309490)
,p_name=>'LAYOUT.T_ALT_PREVIOUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105024146020309487)
,p_name=>'LAYOUT.T_ALT_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105024049453309487)
,p_name=>'LAYOUT.T_ALT_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105026955333309489)
,p_name=>'LAYOUT.T_ALT_REGION_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105028719331309491)
,p_name=>'LAYOUT.T_ALT_REGION_POSITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105026347712309489)
,p_name=>'LAYOUT.T_ALT_REGION_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105028802458309491)
,p_name=>'LAYOUT.T_ALT_STD_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105028425591309490)
,p_name=>'LAYOUT.T_ALT_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105028376674309490)
,p_name=>'LAYOUT.T_ALT_TEMPLATE_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105028522164309490)
,p_name=>'LAYOUT.T_ALT_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105024328956309487)
,p_name=>'LAYOUT.T_ALT_VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105023980809309487)
,p_name=>'LAYOUT.T_ALT_WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105469310502309835)
,p_name=>'LAYOUT.T_AUTHORIZATION_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106089652998310355)
,p_name=>'LAYOUT.T_BC_LABEL_ESC_SC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \B808\C774\BE14(HTML \BB38\C790 \C774\C2A4\CF00\C774\D504)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105679934432310012)
,p_name=>'LAYOUT.T_BIND_EVENT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('When \C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105029550143309491)
,p_name=>'LAYOUT.T_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104916864175309409)
,p_name=>'LAYOUT.T_BRANCH2'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105022369765309486)
,p_name=>'LAYOUT.T_BRANCHING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105470784633309836)
,p_name=>'LAYOUT.T_BRANCH_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105006882754309475)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B97C \BC18\D658\D558\B294 \D568\C218 \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105006964535309475)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('URL\C744 \BC18\D658\D558\B294 \D568\C218 \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105006511763309474)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_ACCEPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BD84\AE30 \D5C8\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105006680234309474)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_IDENTIFIED_BY_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C73C\B85C \BD84\AE30\D560 \D398\C774\C9C0 \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105032574625309493)
,p_name=>'LAYOUT.T_BRANCH_TO_PG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9\D560 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105007035160309475)
,p_name=>'LAYOUT.T_BRANCH_TO_PLSQL'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D504\B85C\C2DC\C800 \BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105006764737309475)
,p_name=>'LAYOUT.T_BRANCH_TO_URL_IDENTIFIED_BY_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C73C\B85C \BD84\AE30\D560 URL \C9C0\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105469436803309835)
,p_name=>'LAYOUT.T_BUILD_OPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105021029068309485)
,p_name=>'LAYOUT.T_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105032436428309493)
,p_name=>'LAYOUT.T_BUTTON2'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105470128721309836)
,p_name=>'LAYOUT.T_BUTTON_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105648317559309984)
,p_name=>'LAYOUT.T_BUTTON_EXECUTE_VAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105025971985309488)
,p_name=>'LAYOUT.T_BUTTON_W_NO_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED\C774 \C5C6\B294 \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105470598394309836)
,p_name=>'LAYOUT.T_CHART_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105470431283309836)
,p_name=>'LAYOUT.T_COLUMN_HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106089444906310355)
,p_name=>'LAYOUT.T_COMPONENT_CSS_CLASSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105021204018309485)
,p_name=>'LAYOUT.T_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105033111611309494)
,p_name=>'LAYOUT.T_COMPUTATION2'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105021365755309485)
,p_name=>'LAYOUT.T_COMPUTATION_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('0\D398\C774\C9C0\B294 \ACC4\C0B0\C744 \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \BAA8\B4E0 \D398\C774\C9C0\C5D0\C11C \BC1C\C0DD\D574\C57C \D558\B294 \ACC4\C0B0\C740 \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8 \ACC4\C0B0\C5D0 \C758\D574 \CC98\B9AC\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105469824442309835)
,p_name=>'LAYOUT.T_COMPUTATION_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105032197487309493)
,p_name=>'LAYOUT.T_CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105469162673309835)
,p_name=>'LAYOUT.T_CONDITION_EXPR1'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105469257689309835)
,p_name=>'LAYOUT.T_CONDITION_EXPR2'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105469098707309835)
,p_name=>'LAYOUT.T_CONDITION_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105019373707309484)
,p_name=>'LAYOUT.T_COPY_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105019102768309484)
,p_name=>'LAYOUT.T_CREATE_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106087570391310353)
,p_name=>'LAYOUT.T_CURRENT_PROGRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>APEX.CURRENT_PROGRESS</em> \B0B4\BD80 \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\C5D0\C11C \D30C\C0DD\B418\B294 \D14D\C2A4\D2B8\C785\B2C8\B2E4(\AE30\BCF8\AC12 <em>\D604\C7AC \C9C4\D589\B960</em>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105030018553309491)
,p_name=>'LAYOUT.T_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105032330245309493)
,p_name=>'LAYOUT.T_DISPLAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105470287042309836)
,p_name=>'LAYOUT.T_DISPLAY_AS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105020843638309485)
,p_name=>'LAYOUT.T_DISPLAY_PT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC&nbsp;\C9C0\C810:&nbsp;')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106018447966310288)
,p_name=>'LAYOUT.T_DYNAMIC_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105019279593309484)
,p_name=>'LAYOUT.T_EDIT_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104916745483309409)
,p_name=>'LAYOUT.T_EDIT_PAGE_IN_BUILDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C131\AE30\C5D0\C11C \D398\C774\C9C0 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105004422034309473)
,p_name=>'LAYOUT.T_EDIT_REGION_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18D\C131 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105005056819309473)
,p_name=>'LAYOUT.T_ERROR_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105032228390309493)
,p_name=>'LAYOUT.T_EXP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105023809012309487)
,p_name=>'LAYOUT.T_FLOW_NO_BRANCHING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105023570878309487)
,p_name=>'LAYOUT.T_FLOW_NO_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105023331701309487)
,p_name=>'LAYOUT.T_FLOW_NO_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \D398\C774\C9C0\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105023657472309487)
,p_name=>'LAYOUT.T_FLOW_NO_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105023481205309487)
,p_name=>'LAYOUT.T_FLOW_NO_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105023723738309487)
,p_name=>'LAYOUT.T_FLOW_NO_VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105029641056309491)
,p_name=>'LAYOUT.T_FOOTER_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\B2E5\AE00 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105030975259309492)
,p_name=>'LAYOUT.T_FORM_CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D3FC \B2EB\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105030436744309492)
,p_name=>'LAYOUT.T_FORM_OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D3FC \C5F4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105029993213309491)
,p_name=>'LAYOUT.T_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD9C\CC98')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105021852337309486)
,p_name=>'LAYOUT.T_GLOBAL_PAGE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \D398\C774\C9C0\C5D0\C11C \BD84\AE30, \ACC4\C0B0, \D504\B85C\C138\C2A4 \B610\B294 \AC80\C99D\C744 \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \BAA8\B4E0 \D398\C774\C9C0\C5D0\C11C \BC1C\C0DD\D574\C57C \D558\B294 \ACC4\C0B0 \BC0F \D504\B85C\C138\C2A4\B294 \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8 \ACC4\C0B0 \BC0F \D504\B85C\C138\C2A4\C5D0\C11C \CC98\B9AC\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105682369423310014)
,p_name=>'LAYOUT.T_GRID_COLUMN_NO'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B9AC\B4DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105401231131309773)
,p_name=>'LAYOUT.T_GRID_COLUMN_SPAN'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B9AC\B4DC \C5F4 \BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105029451943309491)
,p_name=>'LAYOUT.T_HEADER_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105004864533309473)
,p_name=>'LAYOUT.T_INLINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105004720135309473)
,p_name=>'LAYOUT.T_INLINE_PLUS_NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778+\D1B5\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105020039325309484)
,p_name=>'LAYOUT.T_INVALID_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105021152820309485)
,p_name=>'LAYOUT.T_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105353251997309738)
,p_name=>'LAYOUT.T_ITEM2'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105026235409309489)
,p_name=>'LAYOUT.T_ITEM_EXCEEDS_MAX'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C218\AC00 \CD5C\B300\AC12\C778 200\AC1C\B97C \CD08\ACFC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105470308509309836)
,p_name=>'LAYOUT.T_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104890573711309389)
,p_name=>'LAYOUT.T_LISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106073840474310341)
,p_name=>'LAYOUT.T_LIST_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \BAA9\B85D ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105005169068309473)
,p_name=>'LAYOUT.T_LOCATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105049107831309505)
,p_name=>'LAYOUT.T_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104890425594309389)
,p_name=>'LAYOUT.T_MENUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105682409330310014)
,p_name=>'LAYOUT.T_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105032775693309493)
,p_name=>'LAYOUT.T_NAVIGATE_TO_PG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \D398\C774\C9C0\B85C \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105023074206309486)
,p_name=>'LAYOUT.T_NAV_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9&nbsp;\B3C4\AD6C \BAA8\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105348271531309734)
,p_name=>'LAYOUT.T_NAV_LISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \BA54\B274')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105007459755309475)
,p_name=>'LAYOUT.T_NEVER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\C870\AC74 \BD80\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105400910420309773)
,p_name=>'LAYOUT.T_NEW_GRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \ADF8\B9AC\B4DC \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105401122843309773)
,p_name=>'LAYOUT.T_NEW_GRID_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \ADF8\B9AC\B4DC \C5F4 \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105401076363309773)
,p_name=>'LAYOUT.T_NEW_GRID_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \ADF8\B9AC\B4DC \D589 \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105029380577309491)
,p_name=>'LAYOUT.T_NO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105007126544309475)
,p_name=>'LAYOUT.T_NONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105004973359309473)
,p_name=>'LAYOUT.T_NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105030537349309492)
,p_name=>'LAYOUT.T_NOTIFICATION_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C9C0 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105022468015309486)
,p_name=>'LAYOUT.T_NO_BRANCHING'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D398\C774\C9C0\C5D0 \BD84\AE30\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105026032701309489)
,p_name=>'LAYOUT.T_NO_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D398\C774\C9C0\C5D0 \B2E8\CD94\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105026122944309489)
,p_name=>'LAYOUT.T_NO_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D398\C774\C9C0\C5D0 \D56D\BAA9\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104890774888309389)
,p_name=>'LAYOUT.T_NO_LISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\B41C \BAA9\B85D\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105049249063309505)
,p_name=>'LAYOUT.T_NO_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\B41C \ACF5\C720 \AC12 \BAA9\B85D\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104890870098309389)
,p_name=>'LAYOUT.T_NO_MENUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\B41C \C774\B3D9 \ACBD\B85C\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105023131020309486)
,p_name=>'LAYOUT.T_NO_NAV_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \C560\D50C\B9AC\CF00\C774\C158\C5D0 \D0D0\C0C9\D45C\C2DC\C904\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105021588747309485)
,p_name=>'LAYOUT.T_NO_ONLOAD_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D398\C774\C9C0\C5D0 onLoad \ACC4\C0B0\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105021742627309485)
,p_name=>'LAYOUT.T_NO_ONLOAD_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D398\C774\C9C0\C5D0 onLoad \D504\B85C\C138\C2A4\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105021995267309486)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D398\C774\C9C0\C5D0 onSubmit \ACC4\C0B0\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105022205438309486)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D398\C774\C9C0\C5D0 onSubmit \D504\B85C\C138\C2A4\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105018901697309483)
,p_name=>'LAYOUT.T_NO_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \D398\C774\C9C0\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105022655547309486)
,p_name=>'LAYOUT.T_NO_PARENT_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \B808\BCA8 \D0ED \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105020917820309485)
,p_name=>'LAYOUT.T_NO_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D398\C774\C9C0\C5D0 \C601\C5ED\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105022986302309486)
,p_name=>'LAYOUT.T_NO_TAB_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D398\C774\C9C0\C5D0 \D0ED \C9D1\D569\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105049378492309505)
,p_name=>'LAYOUT.T_NO_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\B41C \D15C\D50C\B9AC\D2B8\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105022186618309486)
,p_name=>'LAYOUT.T_NO_VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D398\C774\C9C0\C5D0 \AC80\C99D\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105004573496309473)
,p_name=>'LAYOUT.T_NUMBER_OF_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105019003214309483)
,p_name=>'LAYOUT.T_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105019832663309484)
,p_name=>'LAYOUT.T_PAGE_ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105020469362309484)
,p_name=>'LAYOUT.T_PAGE_AUTHENTICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105020249990309484)
,p_name=>'LAYOUT.T_PAGE_AUTHORIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105030780580309492)
,p_name=>'LAYOUT.T_PAGE_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105030835385309492)
,p_name=>'LAYOUT.T_PAGE_BODY_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCF8\BB38 \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105020315814309484)
,p_name=>'LAYOUT.T_PAGE_BUILD_OPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105030306586309492)
,p_name=>'LAYOUT.T_PAGE_HEAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105019657727309484)
,p_name=>'LAYOUT.T_PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105019504320309484)
,p_name=>'LAYOUT.T_PAGE_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105030125467309492)
,p_name=>'LAYOUT.T_PAGE_ONLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('Onload \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105020527411309485)
,p_name=>'LAYOUT.T_PAGE_PUBLIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105020623484309485)
,p_name=>'LAYOUT.T_PAGE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105020155646309484)
,p_name=>'LAYOUT.T_PAGE_TABSET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105019926593309484)
,p_name=>'LAYOUT.T_PAGE_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105019789041309484)
,p_name=>'LAYOUT.T_PAGE_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105030285738309492)
,p_name=>'LAYOUT.T_PAGE_TITLE2'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105022530068309486)
,p_name=>'LAYOUT.T_PARENT_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105021639031309485)
,p_name=>'LAYOUT.T_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105033061318309494)
,p_name=>'LAYOUT.T_PROCESS2'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105021441105309485)
,p_name=>'LAYOUT.T_PROCESS_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('0\D398\C774\C9C0\B294 \D504\B85C\C138\C2A4\B97C \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \BAA8\B4E0 \D398\C774\C9C0\C5D0\C11C \BC1C\C0DD\D574\C57C \D558\B294 \D504\B85C\C138\C2A4\B294 \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8 \D504\B85C\C138\C2A4\C5D0 \C758\D574 \CC98\B9AC\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105470619970309836)
,p_name=>'LAYOUT.T_PROCESS_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105032696434309493)
,p_name=>'LAYOUT.T_REDIRECT_TO_PG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9\D560 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105029806583309491)
,p_name=>'LAYOUT.T_REFERENCED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106089503753310355)
,p_name=>'LAYOUT.T_REFERENCED_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870 \CD9C\CC98')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105020710062309485)
,p_name=>'LAYOUT.T_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105033458442309494)
,p_name=>'LAYOUT.T_REGION2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105341780459309729)
,p_name=>'LAYOUT.T_REGION_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104880908534309381)
,p_name=>'LAYOUT.T_REGION_CSS_CLASSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105340573249309728)
,p_name=>'LAYOUT.T_REGION_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \C601\C5ED ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105399826466309772)
,p_name=>'LAYOUT.T_REGION_POS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105031083886309492)
,p_name=>'LAYOUT.T_REGION_POS1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105335477635309725)
,p_name=>'LAYOUT.T_REGION_POS10'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105335533786309725)
,p_name=>'LAYOUT.T_REGION_POS11'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105335612459309725)
,p_name=>'LAYOUT.T_REGION_POS12'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105335760801309725)
,p_name=>'LAYOUT.T_REGION_POS13'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105335851915309725)
,p_name=>'LAYOUT.T_REGION_POS14'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105335987816309725)
,p_name=>'LAYOUT.T_REGION_POS15'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105336003273309725)
,p_name=>'LAYOUT.T_REGION_POS16'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105031148474309492)
,p_name=>'LAYOUT.T_REGION_POS2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105031200107309492)
,p_name=>'LAYOUT.T_REGION_POS3'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105031301573309492)
,p_name=>'LAYOUT.T_REGION_POS4'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105031453140309492)
,p_name=>'LAYOUT.T_REGION_POS5'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105031502098309492)
,p_name=>'LAYOUT.T_REGION_POS6'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105031656389309493)
,p_name=>'LAYOUT.T_REGION_POS7'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105031750416309493)
,p_name=>'LAYOUT.T_REGION_POS8'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105335327297309725)
,p_name=>'LAYOUT.T_REGION_POS9'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105340680718309728)
,p_name=>'LAYOUT.T_REGION_STATIC_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C815\C801 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105682275236310014)
,p_name=>'LAYOUT.T_REGION_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105007378796309475)
,p_name=>'LAYOUT.T_STANDARD_CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105022792029309486)
,p_name=>'LAYOUT.T_STD_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900&nbsp;\D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105029704002309491)
,p_name=>'LAYOUT.T_SUBSTITUTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105341329240309729)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_ENTRY_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C704 \C601\C5ED - \BA38\B9AC\AE00 \D56D\BAA9 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105341475650309729)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C704 \C601\C5ED - \BA38\B9AC\AE00 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105341275808309729)
,p_name=>'LAYOUT.T_SUB_PLUG_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C704 \C601\C5ED - \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105341028166309729)
,p_name=>'LAYOUT.T_SUB_REGIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C704 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105341144249309729)
,p_name=>'LAYOUT.T_SUB_REGION_HEADERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C704 \C601\C5ED \BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105340965108309729)
,p_name=>'LAYOUT.T_SUB_REGION_HEADER_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C704 \C601\C5ED \BA38\B9AC\AE00 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105340762108309729)
,p_name=>'LAYOUT.T_SUB_REGION_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C704 \C601\C5ED\C758 \C815\C801 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105340807569309729)
,p_name=>'LAYOUT.T_SUB_REGION_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C704 \C601\C5ED\C758 \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105030639526309492)
,p_name=>'LAYOUT.T_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104890215179309389)
,p_name=>'LAYOUT.T_TABULAR_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C \D615\C2DD \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105022869214309486)
,p_name=>'LAYOUT.T_TAB_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105027870852309490)
,p_name=>'LAYOUT.T_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105048469447309505)
,p_name=>'LAYOUT.T_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105024966210309488)
,p_name=>'LAYOUT.T_TITLE_CREATE_BRANCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105025489431309488)
,p_name=>'LAYOUT.T_TITLE_CREATE_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105024619200309488)
,p_name=>'LAYOUT.T_TITLE_CREATE_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105025602222309488)
,p_name=>'LAYOUT.T_TITLE_CREATE_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105024756158309488)
,p_name=>'LAYOUT.T_TITLE_CREATE_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105024595686309487)
,p_name=>'LAYOUT.T_TITLE_CREATE_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105024875367309488)
,p_name=>'LAYOUT.T_TITLE_CREATE_VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105025596451309488)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105025731133309488)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D56D\BAA9 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105025882409309488)
,p_name=>'LAYOUT.T_TITLE_EDIT_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105025320656309488)
,p_name=>'LAYOUT.T_TITLE_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105470095258309836)
,p_name=>'LAYOUT.T_TRIGGERING_CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('When \C870\AC74')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105469922415309835)
,p_name=>'LAYOUT.T_TRIGGERING_ELEMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('When \C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105007259914309475)
,p_name=>'LAYOUT.T_UNCONDITIONAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105022015022309486)
,p_name=>'LAYOUT.T_VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105032967836309494)
,p_name=>'LAYOUT.T_VALIDATION2'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105648292331309984)
,p_name=>'LAYOUT.T_VALIDATION_ALWAYS_EXEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\C0C1 \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105469687595309835)
,p_name=>'LAYOUT.T_VALIDATION_EXPR1'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \D45C\D604\C2DD 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105469741336309835)
,p_name=>'LAYOUT.T_VALIDATION_EXPR2'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \D45C\D604\C2DD 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105469558395309835)
,p_name=>'LAYOUT.T_VALIDATION_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105019480634309484)
,p_name=>'LAYOUT.T_VIEW_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105468973671309835)
,p_name=>'LAYOUT.T_WHEN_BUTTON_PRESSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94\B97C \B204\B97C \B54C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105029244288309491)
,p_name=>'LAYOUT.T_YES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105187956008309613)
,p_name=>'LAYOUT.UPDATABLE_SQL_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \AC00\B2A5\D55C SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105149977732309585)
,p_name=>'LAYOUT.USE_APP_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105466288982309833)
,p_name=>'LAYOUT.VALIDATING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105146934205309582)
,p_name=>'LAYOUT_NEVER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\C870\AC74 \BD80\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105189656321309614)
,p_name=>'LAYOUT_RUN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105394155084309768)
,p_name=>'LDAP USERNAME EDIT FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('LDAP \C0AC\C6A9\C790 \C774\B984 \D3B8\C9D1 \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104906520492309402)
,p_name=>'LDAP_AUTH_SCHEME_DESC'
,p_message_language=>'ko'
,p_message_text=>'LDAP'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104924954884309415)
,p_name=>'LEARN MORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\C138\D788')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105042893637309501)
,p_name=>'LEARN_MORE_APEX_HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle APEX\C5D0 \B300\D55C \C790\C138\D55C \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105042604446309501)
,p_name=>'LEARN_MORE_APP_BUILDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30\C5D0 \B300\D55C \C790\C138\D55C \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105051444086309507)
,p_name=>'LEARN_MORE_PAGE_DESIGNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B514\C790\C774\B108\C5D0 \B300\D55C \C790\C138\D55C \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105042786107309501)
,p_name=>'LEARN_MORE_PROD_APPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C0B0\C131 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \C790\C138\D55C \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105042543613309501)
,p_name=>'LEARN_MORE_SQL_WORKSHOP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C6CC\D06C\C20D\C5D0 \B300\D574 \C790\C138\D788 \C54C\C544\BCF4\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105647603304309983)
,p_name=>'LEARN_WEBSHEETS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8\C5D0 \B300\D55C \C790\C138\D55C \B0B4\C6A9\C744 \BCF4\B824\BA74 \C5EC\AE30\B97C \B204\B974\C2ED\C2DC\C624.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105456791627309825)
,p_name=>'LEFT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106101111191310366)
,p_name=>'LEGACY_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\AC70\C2DC \B2EC\B825')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104931627160309420)
,p_name=>'LINES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105696917164310027)
,p_name=>'LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104967425154309446)
,p_name=>'LINK$'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105368643026309749)
,p_name=>'LINKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106094646892310360)
,p_name=>'LINK_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105474218535309839)
,p_name=>'LINK_TO_THIS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 %0\C5D0 \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105288345114309687)
,p_name=>'LINK_TO_THIS_PAGE_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0 \D56D\BAA9 %0\C5D0 \B9C1\D06C\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105094438714309538)
,p_name=>'LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105393157499309767)
,p_name=>'LIST ITEM CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D56D\BAA9 \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105389615649309765)
,p_name=>'LIST OF VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104962963436309442)
,p_name=>'LISTVIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105426973368309799)
,p_name=>'LISTVIEW_FORM_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \BC0F \BAA9\B85D \BCF4\AE30\AC00 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105433321258309805)
,p_name=>'LIST_ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106133097240310395)
,p_name=>'LIST_ENTRY_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D56D\BAA9 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105421408057309795)
,p_name=>'LIST_INITCAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105537840449309892)
,p_name=>'LIST_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105338324746309727)
,p_name=>'LIST_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105401765498309773)
,p_name=>'LIST_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105114140987309552)
,p_name=>'LIST_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105149606500309584)
,p_name=>'LIST_UTILIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D65C\C6A9\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105427239628309799)
,p_name=>'LIST_VIEW_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \BCF4\AE30 \D398\C774\C9C0 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105427543889309800)
,p_name=>'LIST_VIEW_PAGE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \BCF4\AE30 \D398\C774\C9C0 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105427130930309799)
,p_name=>'LIST_VIEW_PAGE_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \BCF4\AE30 \D398\C774\C9C0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106080143809310347)
,p_name=>'LOAD_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105476682149309841)
,p_name=>'LOCK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105564695927309914)
,p_name=>'LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105262492028309668)
,p_name=>'LOCKED BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C5D0 \C758\D574 \C7A0\AE40: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106082990038310349)
,p_name=>'LOCKED_DATE_BY_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('%1\C5D0 \C758\D574 %0\C774(\AC00) \C7A0\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106083121318310349)
,p_name=>'LOCK_SCRIPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \C7A0\AE08')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105274830418309677)
,p_name=>'LOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105402640859309774)
,p_name=>'LOGGING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\AE45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105471062155309836)
,p_name=>'LOGIN.REMEMBER_USERNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984 \AE30\C5B5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105471165755309836)
,p_name=>'LOGIN.REMEMBER_USERNAME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\C774 \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D560 \ACBD\C6B0 \C560\D50C\B9AC\CF00\C774\C158\C740 \C774\B984\C774 "LOGIN_USERNAME_COOKIE"\C778 \C601\AD6C \BE0C\B77C\C6B0\C800 \CFE0\D0A4\C5D0 \C0AC\C6A9\C790 \C774\B984\C744 \C800\C7A5\D569\B2C8\B2E4.'),
unistr('\B2E4\C74C \BC88\C5D0 \B85C\ADF8\C778 \D398\C774\C9C0\B85C \C774\B3D9\D558\BA74'),
unistr('\C790\B3D9\C73C\B85C \C0AC\C6A9\C790 \C774\B984 \D544\B4DC\C5D0 \C774 \AC12\C774 \CC44\C6CC\C9D1\B2C8\B2E4.'),
'</p>',
'<p>',
unistr('\C0AC\C6A9\C790 \C774\B984\C774 \CFE0\D0A4\C5D0 \C774\BBF8 \C800\C7A5\B41C \C0C1\D0DC\C5D0\C11C \C774 \CCB4\D06C\BC15\C2A4\C758 \C120\D0DD\C744 \D574\C81C\D560 \ACBD\C6B0'),
unistr('\C560\D50C\B9AC\CF00\C774\C158\C740 \C0AC\C6A9\C790 \C774\B984\C744 \BE48 \AC12\C73C\B85C \ACB9\CCD0\C501\B2C8\B2E4.'),
unistr('\BE0C\B77C\C6B0\C800\C758 \AC1C\BC1C\C790 \B3C4\AD6C\B97C \C0AC\C6A9\D558\C5EC \CFE0\D0A4\B97C \C644\C804\D788 \C81C\AC70\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105402413117309774)
,p_name=>'LOGIN_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105402358500309774)
,p_name=>'LOGO'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105888700113310175)
,p_name=>'LOGO.DEFAULT.IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815\B41C \C774\BBF8\C9C0\AC00 \C5C6\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105888816647310175)
,p_name=>'LOGO.DEFAULT.TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \B85C\ACE0 \D14D\C2A4\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105887235966310174)
,p_name=>'LOGO.EDITOR.APP.GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \B85C\ACE0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105887759250310175)
,p_name=>'LOGO.FILE.SIZE.EXCEEDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D30C\C77C\C740 %0\C758 \D5C8\C6A9 \D55C\B3C4\B97C \CD08\ACFC\D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105888218899310175)
,p_name=>'LOGO.LABEL.CUSTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131\AE30\C5D0\C11C \C0AC\C6A9\C790\C815\C758 \B85C\ACE0 \B9C8\D06C\C5C5\C744 \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105888147758310175)
,p_name=>'LOGO.LABEL.DRAG_AND_DROP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C744 \B04C\C5B4 \B193\AC70\B098 \B20C\B7EC\C11C \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105888071005310175)
,p_name=>'LOGO.LABEL.IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105888328876310175)
,p_name=>'LOGO.LABEL.NONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C571\C5D0 \B300\D574 \B85C\ACE0\AC00 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105887951701310175)
,p_name=>'LOGO.LABEL.TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105887858353310175)
,p_name=>'LOGO.LABEL.TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105888503131310175)
,p_name=>'LOGO.MSG.IMAGE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B85C\ACE0 \C720\D615\C5D0\B294 \B85C\ACE0 \C774\BBF8\C9C0\AC00 \D544\C694\D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105888642724310175)
,p_name=>'LOGO.MSG.SAVE_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ACE0\AC00 \C131\ACF5\C801\C73C\B85C \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105888469166310175)
,p_name=>'LOGO.MSG.TEXT_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B85C\ACE0 \C720\D615\C5D0\B294 \B85C\ACE0 \D14D\C2A4\D2B8\AC00 \D544\C694\D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105887674228310175)
,p_name=>'LOGO.WRONG.MIME.TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0\B9CC \D5C8\C6A9\B429\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106069025333310336)
,p_name=>'LOG_FEEDBACK_AS_BUG_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31\C744 \C81C\ACF5\D574 \C8FC\C154\C11C \AC10\C0AC\D569\B2C8\B2E4. \C774 \BB38\C81C\C5D0 \B300\D55C \BC84\ADF8\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106070543165310337)
,p_name=>'LOG_FEEDBACK_AS_FEATURE_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31\C744 \C81C\ACF5\D574 \C8FC\C154\C11C \AC10\C0AC\D569\B2C8\B2E4. \C774 \C694\CCAD\C740 \D6C4\C18D \B9B4\B9AC\C2A4\C5D0\C11C \ACE0\B824\B420 \C608\C815\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105693822086310024)
,p_name=>'LOG_FEEDBACK_AS_ISSUE_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31\C744 \C8FC\C154\C11C \AC10\C0AC\D569\B2C8\B2E4. \BB38\C81C\AC00 \C2DC\C2A4\D15C\C5D0 \AE30\B85D\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106070757963310338)
,p_name=>'LOG_FEEDBACK_AS_TODO_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31\C744 \C81C\ACF5\D574 \C8FC\C154\C11C \AC10\C0AC\D569\B2C8\B2E4. \C774 \BB38\C81C\B97C \D574\ACB0\D558\AE30 \C704\D55C \C791\C5C5\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106098508796310363)
,p_name=>'LOG_IN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105275776888309678)
,p_name=>'LOG_INTERVAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8 \AC04\ACA9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105389584053309765)
,p_name=>'LOV ITEM CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \D56D\BAA9 \C870\AC74')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105347496280309733)
,p_name=>'LOW_PRIORITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0AE\C740 \C6B0\C120\C21C\C704')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104890669556309389)
,p_name=>'MANAGE PAGE GROUPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \ADF8\B8F9 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105539363205309894)
,p_name=>'MANAGE SERVICE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\BE44\C2A4 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105539105545309893)
,p_name=>'MANAGE USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105538596106309893)
,p_name=>'MANAGE WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105483040746309846)
,p_name=>'MANAGE_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105104623046309545)
,p_name=>'MANAGE_UNASSIGNED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B418\C9C0 \C54A\C740 \D56D\BAA9 \AD00\B9AC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104922194481309413)
,p_name=>'MANUAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\B3D9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104860540310309363)
,p_name=>'MAP_LAYER='
,p_message_language=>'ko'
,p_message_text=>unistr('\CE35=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104861905131309364)
,p_name=>'MAP_LAYERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5 \CE35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105007839721309475)
,p_name=>'MAP_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C774 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105346617382309733)
,p_name=>'MARQUEE_FEATURE'
,p_message_language=>'ko'
,p_message_text=>unistr('Marquee \AE30\B2A5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105420507566309794)
,p_name=>'MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105405808642309776)
,p_name=>'MASTERDETAIL_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \B514\D14C\C77C \D398\C774\C9C0\AC00 \C131\ACF5\C801\C73C\B85C \C791\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104859282031309362)
,p_name=>'MASTER_DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \B514\D14C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104859416919309362)
,p_name=>'MASTER_DETAIL_DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C138\BD80\C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104859300352309362)
,p_name=>'MASTER_DETAIL_EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D3B8\C9D1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105472386039309837)
,p_name=>'MATERIALIZED_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\CCB4\D654\B41C \BDF0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105368013821309749)
,p_name=>'MAXIMUM_RENDER_TIME_SECONDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \B80C\B354\B9C1 \C2DC\AC04(\CD08)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105459262255309827)
,p_name=>'MAXIMUM_SESSION_IDLE_TIME'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \C138\C158 \C720\D734 \C2DC\AC04(\CD08)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105459376282309827)
,p_name=>'MAXIMUM_SESSION_LENGTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \C138\C158 \AE38\C774(\CD08)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105042362944309500)
,p_name=>'MAY_NOT_DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B41C \AE30\B2A5\C774 \C788\B294 \B9C8\C77C\C2A4\D1A4\C740 \C0AD\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104934562133309422)
,p_name=>'MEMORY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\BAA8\B9AC:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105092811515309537)
,p_name=>'MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105393251708309767)
,p_name=>'MENU ITEM CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D56D\BAA9 \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105402017871309774)
,p_name=>'MENU_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105635130115309972)
,p_name=>'MIGRATION FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804 \D30C\C77C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105389119909309764)
,p_name=>'MILESTONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C77C\C2A4\D1A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105369185918309749)
,p_name=>'MILESTONES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C77C\C2A4\D1A4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105825445562310127)
,p_name=>'MILLISECONDS_MS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC00\B9AC\CD08')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105371838713309751)
,p_name=>'MIME_TYPE_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('MIME \C720\D615 \C5F4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105345130224309732)
,p_name=>'MINIMAL_IMPACT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C \C601\D5A5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104909660102309404)
,p_name=>'MIN_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C \BC84\C804')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106069658022310337)
,p_name=>'MISSING_AT_SIGN'
,p_message_language=>'ko'
,p_message_text=>unistr('@ \AE30\D638 \B204\B77D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105292652857309691)
,p_name=>'MODEL_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D398\C774\C9C0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105346898241309733)
,p_name=>'MODERATELY_DESIRABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\D1B5 \AD8C\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105345047504309732)
,p_name=>'MODERATE_IMPACT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\D1B5 \C601\D5A5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105031881623309493)
,p_name=>'MODIFIED_ATTRIBUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C815\B41C \C18D\C131\C744 \B098\D0C0\B0C5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105472644322309838)
,p_name=>'MODIFY_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C5F4 \C218\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105272336847309675)
,p_name=>'MONITOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B2C8\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105539243456309893)
,p_name=>'MONITOR ACTIVITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BAA8\B2C8\D130')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105398485404309771)
,p_name=>'MORE_DOT_DOT_DOT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B354 \BCF4\AE30...')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105367577871309748)
,p_name=>'MOST_ACTIVE_APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C7A5 \D65C\B3D9\C801\C778 %0\AC1C \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105362585947309744)
,p_name=>'MOST_RECENT_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C7A5 \CD5C\ADFC \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105663122149309997)
,p_name=>'MOST_RECENT_FILE_UPLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C7A5 \CD5C\ADFC \D30C\C77C\C740 %1 %2\C5D0 \C758\D574 \C5C5\B85C\B4DC\B41C %0\C785\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105130973784309571)
,p_name=>'MRU.ERROR_IN_MRU'
,p_message_language=>'ko'
,p_message_text=>unistr('MRU\C5D0 \C624\B958 \BC1C\C0DD: \D589= %0, %1, %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105129824882309570)
,p_name=>'MRU.INVALID_PRIM_KEY_COL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \C120\D0DD \BAA9\B85D\C5D0\C11C \C9C0\C815\B41C \AE30\BCF8 \D0A4 \C5F4\C744 \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105131029692309571)
,p_name=>'MRU.LOST_UPDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C5C5\B370\C774\D2B8 \D504\B85C\C138\C2A4\B97C \C2DC\C791\D588\C73C\BBC0\B85C \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C788\B294 \B370\C774\D130\C758 \D604\C7AC \BC84\C804\C774 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4. \D604\C7AC \CCB4\D06C\C12C = "%0", \D56D\BAA9 \CCB4\D06C\C12C = "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105129374048309570)
,p_name=>'MRU.NO_ROWS_TO_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\D560 \D589 \C5C6\C74C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105047250659309504)
,p_name=>'MUST_BE_XSL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \B808\C774\C544\C6C3 \D30C\C77C\C758 \D30C\C77C \C720\D615\C774 ''.xsl''\C744 \D30C\C77C \D655\C7A5\C790\B85C \C0AC\C6A9\D558\B294 XSL-FO\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104956195404309437)
,p_name=>'MY_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4 \D398\C774\C9C0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106068524443310336)
,p_name=>'NAMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105476580793309841)
,p_name=>'NAVBAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105389389865309764)
,p_name=>'NAVBAR ITEM CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904 \D56D\BAA9 \C870\AC74')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106072133233310339)
,p_name=>'NAVIGATE_GO_TO_TOP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E8 \C704\B85C \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105387273621309763)
,p_name=>'NAVIGATION BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105402216443309774)
,p_name=>'NAVIGATION_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104890388228309389)
,p_name=>'NAVIGATION_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \D398\C774\C9C0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104881767537309382)
,p_name=>'NAV_APP_BUILDER_HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30 \D648 \D398\C774\C9C0\B85C \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106108361343310372)
,p_name=>'NAV_BAR_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\D604: \BAA9\B85D %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106108298882310372)
,p_name=>'NAV_BAR_TRADITIONAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\D604: \D074\B798\C2DD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105357515676309741)
,p_name=>'NEEDS_REVIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\D1A0 \D544\C694')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105350688298309736)
,p_name=>'NEED_INFORMATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4 \D544\C694')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105368779407309749)
,p_name=>'NEWS_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \D56D\BAA9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106102006815310367)
,p_name=>'NEW_BIND_VARIABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\C778\B4DC \BCC0\C218 %0\C758 \C0C8 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105111639714309550)
,p_name=>'NEW_EMAIL_ADDRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('Application Express \ACC4\C815\C5D0 \B300\D55C \C0C8 \C804\C790\BA54\C77C \C8FC\C18C\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105346101691309732)
,p_name=>'NEW_FEATURE_REQUEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C\C6B4 \AE30\B2A5 \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105278314397309680)
,p_name=>'NEW_OR_EXISTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E0\ADDC \B610\B294 \AE30\C874')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105454471214309823)
,p_name=>'NEW_SCHEMA_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C2A4\D0A4\B9C8 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105361857171309744)
,p_name=>'NEW_SERVICE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C11C\BE44\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105092725859309537)
,p_name=>'NEW_TABSET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106087373246310353)
,p_name=>'NEW_TOP_LEVEL'
,p_message_language=>'ko'
,p_message_text=>unistr('- \C120\D0DD\B41C \C0C1\C704 \D56D\BAA9 \C5C6\C74C - ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105398784890309771)
,p_name=>'NEW_WORKSPACE_REQUEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C791\C5C5\C601\C5ED \C694\CCAD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105406918025309777)
,p_name=>'NO CORRESPONDING REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \C601\C5ED \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105340231496309728)
,p_name=>'NO PRIMARY KEY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C5D0 \C815\C758\B41C \AE30\BCF8 \D0A4\AC00 \C5C6\C2B5\B2C8\B2E4. \AE30\BCF8 \D0A4\B294 \D3FC\C744 \C0AC\C6A9\D558\C5EC \BCF4\ACE0\C11C\B97C \C0DD\C131\D560 \B54C \D544\C694\D569\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104936333299309423)
,p_name=>'NOARCHIVELOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8 \C544\CE74\C774\BE0C: \D574\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105331432521309722)
,p_name=>'NON CURRENT ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC\AC00 \C544\B2CC \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105387046733309763)
,p_name=>'NON CURRENT TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC\AC00 \C544\B2CC \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105391597895309766)
,p_name=>'NONE_SPECIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105079143447309527)
,p_name=>'NON_CURRENT_IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC\AC00 \C544\B2CC \C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105456101090309825)
,p_name=>'NON_PACKAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('-\BE44\C0DD\C0B0\C131 \B610\B294 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105347327447309733)
,p_name=>'NORMAL_PRIORITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\D1B5 \C6B0\C120\C21C\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106069108552310336)
,p_name=>'NOT AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106094573550310360)
,p_name=>'NOTE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\ACE0: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105250334749309659)
,p_name=>'NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105344078176309731)
,p_name=>'NOT_A_BUG'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\ADF8 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106101058498310366)
,p_name=>'NOT_CURRENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105347028864309733)
,p_name=>'NOT_DESIRABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\C7A5 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105396694962309770)
,p_name=>'NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C874\C7AC\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104951913060309434)
,p_name=>'NOT_EXISTS_SQL_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('NOT EXISTS SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105344116278309731)
,p_name=>'NOT_FEASIBLE_TO_FIX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C815 \AC00\B2A5\C131 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105476349351309841)
,p_name=>'NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106107707359310372)
,p_name=>'NOT_FUNCTIONALLY_COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('80% \C774\D558 \C644\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105409444356309779)
,p_name=>'NOT_INSTALLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105092600985309537)
,p_name=>'NOT_IN_DATA_DICT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B515\C154\B108\B9AC\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105347750797309734)
,p_name=>'NOT_PRIORITIZED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6B0\C120\C21C\C704\AC00 \C9C0\C815\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105345516332309732)
,p_name=>'NOT_PRORITIZED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6B0\C120\C21C\C704\AC00 \C9C0\C815\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105391752686309766)
,p_name=>'NOT_PROVIDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105667424260310001)
,p_name=>'NOT_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C694\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105350404551309736)
,p_name=>'NOT_STARTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105428985712309801)
,p_name=>'NOT_VALID_VIEW_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>%0</strong>\C740(\B294) \C801\D569\D55C \BDF0 \C774\B984\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104909152064309403)
,p_name=>'NO_APPLICATIONS_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105412666127309782)
,p_name=>'NO_APPLICATION_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \C560\D50C\B9AC\CF00\C774\C158\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105187254974309612)
,p_name=>'NO_ARGUMENTS_ALLOWED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D5C8\C6A9\B41C \C778\C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105343105714309730)
,p_name=>'NO_ASSIGNED_PRIORITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C6B0\C120\C21C\C704 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104954971716309437)
,p_name=>'NO_AUTHORIZATION_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105391995422309766)
,p_name=>'NO_AVAIL_JOBS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C0AC\C6A9 \AC00\B2A5\D55C \B370\C774\D130\BCA0\C774\C2A4 \C791\C5C5 \B300\AE30\C5F4 \D504\B85C\C138\C2A4\AC00 \C5C6\C2B5\B2C8\B2E4.<br> \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C5EC JOB_QUEUE_PROCESSES \CD08\AE30\D654 \B9E4\AC1C\BCC0\C218\C758 \AC12\C744 \B192\C774\AC70\B098 <br>'),
unistr('\B2E4\B978 \C791\C5C5\C774 \C644\B8CC\B420 \B54C\AE4C\C9C0 \AE30\B2E4\B9AC\C2ED\C2DC\C624.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105265895118309670)
,p_name=>'NO_BREADCRUMB_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8\C5D0\C11C \C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C801\C5B4\B3C4 \D558\B098\C758 \C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105265906498309670)
,p_name=>'NO_BUTTON_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8\C5D0\C11C \B2E8\CD94 \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C801\C5B4\B3C4 \D558\B098\C758 \B2E8\CD94 \D15C\D50C\B9AC\D2B8\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105265424237309670)
,p_name=>'NO_CALENDAR_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8\C5D0\C11C \B2EC\B825 \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C801\C5B4\B3C4 \D558\B098\C758 \B2EC\B825 \D15C\D50C\B9AC\D2B8\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105041412008309500)
,p_name=>'NO_DATE_SPECIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \B0A0\C9DC\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105291238584309689)
,p_name=>'NO_DEBUG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B514\BC84\ADF8 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104903366203309399)
,p_name=>'NO_DEVELOPER_PRIV'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790 \AD8C\D55C\C774 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104964788098309444)
,p_name=>'NO_DISPLAY_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('- \D45C\C2DC \C5C6\C74C -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104919836645309411)
,p_name=>'NO_FEATURES_TARGETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1 \AE30\B2A5\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105263486725309668)
,p_name=>'NO_HELP_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0 \D56D\BAA9\C5D0 \C81C\ACF5\B41C \B3C4\C6C0\B9D0\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106128499523310391)
,p_name=>'NO_ICON_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58\C744 \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105013670609309480)
,p_name=>'NO_IMAGES_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105250664863309659)
,p_name=>'NO_IMAGE_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105095080967309538)
,p_name=>'NO_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105456605505309825)
,p_name=>'NO_JOB_QUEUE_PROCESSES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B370\C774\D130\BCA0\C774\C2A4 \C791\C5C5 \B300\AE30\C5F4 \D504\B85C\C138\C2A4\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C5EC<br>'),
unistr('JOB_QUEUE_PROCESSE \CD08\AE30\D654 \B9E4\AC1C\BCC0\C218\B97C \C124\C815\D558\C2ED\C2DC\C624.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105265529252309670)
,p_name=>'NO_LABEL_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8\C5D0\C11C \B808\C774\BE14 \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C801\C5B4\B3C4 \D558\B098\C758 \B808\C774\BE14 \D15C\D50C\B9AC\D2B8\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104997265021309468)
,p_name=>'NO_LAYOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105265702368309670)
,p_name=>'NO_LIST_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8\C5D0\C11C \BAA9\B85D \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C801\C5B4\B3C4 \D558\B098\C758 \BAA9\B85D \D15C\D50C\B9AC\D2B8\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105346310527309733)
,p_name=>'NO_LONGER_AN_ISSUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B354 \C774\C0C1 \BB38\C81C\AC00 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104954708924309436)
,p_name=>'NO_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105390215935309765)
,p_name=>'NO_MILESTONES_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \B9C8\C77C\C2A4\D1A4 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105616944241309956)
,p_name=>'NO_NAVIGATION_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \BA54\B274 \BAA9\B85D \D45C\C2DC \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104997196349309468)
,p_name=>'NO_PAGE_DEV_PRIV'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790\C5D0\AC8C\B294 \C774 \D398\C774\C9C0\C5D0 \AD6C\C131\C694\C18C\B97C \C0DD\C131\D560 \C218 \C788\B294 \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105266153318309670)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8\B97C \BCF5\C0AC\D558\B824\ACE0 \C2DC\B3C4\D560 \B54C %0 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105265252674309670)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8\C5D0\C11C \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C801\C5B4\B3C4 \D558\B098\C758 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105188886986309613)
,p_name=>'NO_PARENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \C774\B3D9 \ACBD\B85C \D56D\BAA9\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105637377525309974)
,p_name=>'NO_PARENT_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \C0C1\C704 \D0ED \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105398333243309771)
,p_name=>'NO_PENDING_REQUESTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\B958 \C911\C778 \C694\CCAD\C774 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105266003826309670)
,p_name=>'NO_POPUP_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8\C5D0\C11C \D31D\C5C5 \AC12 \BAA9\B85D \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C801\C5B4\B3C4 \D558\B098\C758 \D31D\C5C5 \AC12 \BAA9\B85D \D15C\D50C\B9AC\D2B8\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105347694418309734)
,p_name=>'NO_PRIORITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6B0\C120\C21C\C704 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105434646053309806)
,p_name=>'NO_REGION_POSITION_IN_PAGE_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C601\C5ED \C704\CE58\B294 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C5D0 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105265352315309670)
,p_name=>'NO_REGION_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8\C5D0\C11C \C601\C5ED \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C801\C5B4\B3C4 \D558\B098\C758 \C601\C5ED \D15C\D50C\B9AC\D2B8\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105265681997309670)
,p_name=>'NO_REPORT_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8\C5D0\C11C \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C801\C5B4\B3C4 \D558\B098\C758 \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104954836130309437)
,p_name=>'NO_SHORTCUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105350332555309736)
,p_name=>'NO_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105398996159309771)
,p_name=>'NO_SYSTEM_MESSAGE_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \C2DC\C2A4\D15C \BA54\C2DC\C9C0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105693280964310023)
,p_name=>'NO_TABS_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D574 \C815\C758\B41C \D0ED\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105637520419309974)
,p_name=>'NO_TABS_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED\C744 \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105634743869309971)
,p_name=>'NO_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \D0ED \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105637417344309974)
,p_name=>'NO_TABS_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \D0ED \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106068939773310336)
,p_name=>'NO_TAGS_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0DC\ADF8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105094971754309538)
,p_name=>'NO_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105187342045309612)
,p_name=>'NO_URL_ACCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('URL \C561\C138\C2A4 \AD8C\D55C \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105679264074310011)
,p_name=>'NO_WHITE_LIST_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548\C0C1\C758 \C774\C720\B85C SQL \D0DC\ADF8\B97C \C0AC\C6A9\D558\B824\BA74 \BA3C\C800 \D5C8\C6A9\B418\B294 \D14C\C774\BE14 \BAA9\B85D\C744 \C815\C758\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105344836938309732)
,p_name=>'NO_WORKAROUND_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\ACB0 \BC29\BC95 \C5C6\C74C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105091157246309535)
,p_name=>'NULL_IN_PAREN'
,p_message_language=>'ko'
,p_message_text=>unistr('(\B110)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105475703718309840)
,p_name=>'NUMBER_OF_FEEDBACK_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105428792082309801)
,p_name=>'NUMBER_OF_USERS_FILING_FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104919770803309411)
,p_name=>'NUM_TOTAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D569\ACC4: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105327290370309718)
,p_name=>'OBJECTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105622679637309961)
,p_name=>'OBJECTS_WITHOUT_DEFAULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12\C774 \C5C6\B294 \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105622530964309961)
,p_name=>'OBJECTS_WITH_DEFAULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12\C774 \C788\B294 \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106094163232310359)
,p_name=>'OBJECT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105415538142309790)
,p_name=>'OB_CASCADE_DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\B2E8\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105356841871309740)
,p_name=>'OB_CHECK_CON_NN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0AC \C81C\C57D \C870\AC74\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104910924818309405)
,p_name=>'OB_COMPILE_ERRORS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105416602296309790)
,p_name=>'OB_CONSTRAINT_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C57D \C870\AC74 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105416785810309791)
,p_name=>'OB_CONS_INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4/\AC80\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105356673996309740)
,p_name=>'OB_CONS_NAME_NN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C57D \C870\AC74 \C774\B984\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105357082037309740)
,p_name=>'OB_CONS_NAME_USED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8 \C0AC\C6A9\B41C \C81C\C57D \C870\AC74 \C774\B984\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105415295048309789)
,p_name=>'OB_FK_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\B798 \D0A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105356227958309740)
,p_name=>'OB_FK_NAME_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\B798 \D0A4 \C774\B984\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105356909476309740)
,p_name=>'OB_FK_NAME_USED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\B798 \D0A4 \C774\B984\C774 \C774\BBF8 \C0AC\C6A9\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105415381508309789)
,p_name=>'OB_FK_REFERENCED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870\B41C \D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105415478829309789)
,p_name=>'OB_FK_REFERENCED_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870\B41C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105356508508309740)
,p_name=>'OB_FK_REF_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\B798 \D0A4 \CC38\C870 \C5F4\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105356445519309740)
,p_name=>'OB_FK_REF_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\B798 \D0A4 \CC38\C870 \D14C\C774\BE14\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105356334176309740)
,p_name=>'OB_FK_SEL_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\B798 \D0A4 \C5F4\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105477060089309841)
,p_name=>'OB_POSITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105416870005309791)
,p_name=>'OB_SELECT_DATATYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('- \B370\C774\D130 \C720\D615 \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105415640070309790)
,p_name=>'OB_SET_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105356742993309740)
,p_name=>'OB_UK_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \D0A4\C5D0 \B300\D574 \C5F4\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105825661230310128)
,p_name=>'ODG.API.START'
,p_message_language=>'ko'
,p_message_text=>'%0  START'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105825574085310127)
,p_name=>'ODG.API.UNHANDLED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CC98\B9AC\B418\C9C0 \C54A\C740 \C608\C678\C0AC\D56D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105825794346310128)
,p_name=>'ODG.API.UNHANDLED_BUILTIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\B418\C9C0 \C54A\C740 \B0B4\C7A5 data_source: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105826502331310128)
,p_name=>'ODG.BLUEPRINT.BLUEPRINT_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAD\C0AC\C9C4\C744 \CC3E\C744 \C218 \C5C6\AC70\B098 \C0DD\C131\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104878197908309379)
,p_name=>'ODG.BLUEPRINT.DATA_SOURCE_NAME_26'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C18C\C2A4 \C774\B984\C740 26\C790 \C774\D558\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104878097807309379)
,p_name=>'ODG.BLUEPRINT.ERROR_IMPORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C784\D3EC\D2B8 \C624\B958: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105826479915310128)
,p_name=>'ODG.BLUEPRINT.ERR_INSERT_SELECT'
,p_message_language=>'ko'
,p_message_text=>unistr('INSERT-SELECT SQL \BB38\C744 \C791\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105825926157310128)
,p_name=>'ODG.BLUEPRINT.ERR_JSON_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) JSON \B370\C774\D130\B97C \AC00\C838\C624\B294 \C911\C785\B2C8\B2E4. URL: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105826676857310128)
,p_name=>'ODG.BLUEPRINT.INSERT_INTO_SCRIPT'
,p_message_language=>'ko'
,p_message_text=>unistr('INSERT INTO \C2A4\D06C\B9BD\D2B8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104878366964309379)
,p_name=>'ODG.BLUEPRINT.INVALID_BUILTIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \AE30\BCF8 \C81C\ACF5 \B370\C774\D130 \C18C\C2A4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105826339428310128)
,p_name=>'ODG.BLUEPRINT.JSON_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958: JSON \B370\C774\D130\AC00 \B110\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105826088887310128)
,p_name=>'ODG.BLUEPRINT.NOT_VALID_OBJECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105826101086310128)
,p_name=>'ODG.BLUEPRINT.NO_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 - \C694\CCAD\B41C \D589\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105825844378310128)
,p_name=>'ODG.BLUEPRINT.TO_MANY_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\B41C \D589\C774 \B108\BB34 \B9CE\C2B5\B2C8\B2E4. \D5C8\C6A9\B418\B294 \CD5C\B300 \D589\C740 %0\AC1C\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105826213416310128)
,p_name=>'ODG.BLUEPRINT.UNEXPECTED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C744(\B97C) \B85C\B4DC\D558\B294 \C911 \C608\C0C1\CE58 \C54A\C740 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104878276664309379)
,p_name=>'ODG.BLUEPRINT.VALUE_Y_N'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) Y \B610\B294 N\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104956080386309437)
,p_name=>'ONE'
,p_message_language=>'ko'
,p_message_text=>'1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104908632759309403)
,p_name=>'ONLY_INSTALLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58\B41C \D56D\BAA9\B9CC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105145651035309581)
,p_name=>'ON_LOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\B4DC \C2DC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105346413465309733)
,p_name=>'OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105392008357309766)
,p_name=>'OPENED_LAST_7_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC 7\C77C\AC04 \BBF8\ACB0\B41C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105391175268309766)
,p_name=>'OPEN_BUGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\ACB0 \BC84\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105390805682309765)
,p_name=>'OPEN_FEATURES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\ACB0 \AE30\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105624664287309962)
,p_name=>'OPEN_PROCESSING_FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\ACB0, \D53C\B4DC\BC31 \CC98\B9AC \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105391036616309766)
,p_name=>'OPEN_TO_DOS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\ACB0 \D560 \C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104998208104309468)
,p_name=>'OPEN_WEBSHEET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 %0 \C5F4\AE30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105332251256309722)
,p_name=>'OPTIONAL ATTRIBUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\C801 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106112400891310376)
,p_name=>'OPTIONAL ICON CSS CLASSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\C801\C778 \C544\C774\CF58 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105332177215309722)
,p_name=>'OPTIONAL IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\C801 \C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105332306366309722)
,p_name=>'OPTIONAL IMAGE ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\C801 \C774\BBF8\C9C0 \C18D\C131')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105635255399309972)
,p_name=>'ORACLE FORMS'
,p_message_language=>'ko'
,p_message_text=>'Oracle Forms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106040074205310309)
,p_name=>'ORDS_BASED_PRINTING_DESUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle REST Data Services \AE30\BC18 \C778\C1C4\B294 Oracle APEX 19.1\C5D0\C11C \B354 \C774\C0C1 \C0AC\C6A9\B418\C9C0 \C54A\C73C\BA70 \C9C0\C6D0\C774 \C911\B2E8\B418\C5C8\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104890142675309389)
,p_name=>'OTHER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\D0C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105635831518309972)
,p_name=>'OTHER WORKSPACE FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \C791\C5C5\C601\C5ED \D30C\C77C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105384766760309761)
,p_name=>'OTN'
,p_message_language=>'ko'
,p_message_text=>'Oracle Technology Network'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105384870617309761)
,p_name=>'OTN_FORUM'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Technology Network \D1A0\B860 \D3EC\B7FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105514894557309873)
,p_name=>'OVERRIDE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\D6A8\D654 ID')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106090910449310356)
,p_name=>'OVERVIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C694')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105072428509309522)
,p_name=>'OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104919430533309411)
,p_name=>'OWNERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C720\C790')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105296434257309693)
,p_name=>'P4000.P4651.SQL_QUERY.FUNC_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758 \D568\C218 \BCF8\BB38')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105434002830309805)
,p_name=>'P4001_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105046877983309504)
,p_name=>'P4111_USED_ON_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 LOV\B294 \C0AD\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0 \D398\C774\C9C0\C5D0\C11C \C0AC\C6A9\B429\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105396775756309770)
,p_name=>'P4316_BIND_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\C778\B4DC \D56D\BAA9(\D56D\BAA9 \C774\B984 \C785\B825)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106045586713310314)
,p_name=>'P473_NEEDS_REFRESH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C\ACE0\CE68\D574\C57C \D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106048303222310317)
,p_name=>'P4905_BUTTON_ALT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\CE58 \C11C\BC84 \CD94\AC00')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105322966425309715)
,p_name=>'P58_BROWSE_SEQ'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \B9C1\D06C \CC3E\C544\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105318993200309712)
,p_name=>'P58_NO_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \B9C1\D06C \C0DD\C131 \C791\C5C5\C758 \C2E4\D328 \C6D0\C778\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105319086554309712)
,p_name=>'P58_SEQUENCE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C2A4\D0A4\B9C8\C5D0 \B370\C774\D130\BCA0\C774\C2A4 \B9C1\D06C "%0"\C774(\AC00) \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105091999597309536)
,p_name=>'PACKAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D0A4\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105266544610309671)
,p_name=>'PACKAGED_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C0B0\C131 \B610\B294 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104929274994309418)
,p_name=>'PACKAGED_APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C0B0\C131 \BC0F \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105478363873309842)
,p_name=>'PACKAGED_APP_INSTALL_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C124\CE58 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105309689754309704)
,p_name=>'PACKAGE_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D0A4\C9C0 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105456068200309825)
,p_name=>'PACKAGE_GLOBALS'
,p_message_language=>'ko'
,p_message_text=>unistr('-\C804\C5ED-')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105073947283309523)
,p_name=>'PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105394314024309768)
,p_name=>'PAGE COMPUTATION CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \ACC4\C0B0 \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105474693322309839)
,p_name=>'PAGE HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105386805684309763)
,p_name=>'PAGE HEADER, BODY, AND FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BA38\B9AC\AE00, \BCF8\BB38 \BC0F \BC14\B2E5\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105394687456309768)
,p_name=>'PAGE ITEM DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105394860978309768)
,p_name=>'PAGE ITEM DISPLAY CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 \D45C\C2DC \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105395034304309769)
,p_name=>'PAGE ITEM LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 \AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105394710620309768)
,p_name=>'PAGE ITEM POST COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 \C0AC\D6C4 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105394935040309768)
,p_name=>'PAGE ITEM READ-ONLY DISPLAY CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 \C77D\AE30 \C804\C6A9 \D45C\C2DC \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105394558141309768)
,p_name=>'PAGE ITEM SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105310097623309704)
,p_name=>'PAGE ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105387666625309763)
,p_name=>'PAGE PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105387791720309763)
,p_name=>'PAGE PROCESS CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D504\B85C\C138\C2A4 \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105394412423309768)
,p_name=>'PAGE VALIDATION CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AC80\C99D \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105323912710309716)
,p_name=>'PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105538034922309893)
,p_name=>'PAGE_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105368529825309749)
,p_name=>'PAGE_EVENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105404745925309776)
,p_name=>'PAGE_EVENTS_FOR_LAST_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\BCA4\D2B8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106120988637310384)
,p_name=>'PAGE_FINDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AC80\C0C9\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104883357361309383)
,p_name=>'PAGE_GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105404298081309775)
,p_name=>'PAGE_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0 \C788\B294 \D398\C774\C9C0\B97C \C2DD\BCC4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105569456240309918)
,p_name=>'PAGE_ID_LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D398\C774\C9C0 \C7A0\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105569521683309918)
,p_name=>'PAGE_ID_UNLOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D398\C774\C9C0 \C7A0\AE08 \D574\C81C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105414744572309789)
,p_name=>'PAGE_INSTALL_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D398\C774\C9C0\AC00 \C131\ACF5\C801\C73C\B85C \C124\CE58\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105310545857309705)
,p_name=>'PAGE_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105520645464309878)
,p_name=>'PAGE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105355499642309739)
,p_name=>'PAGE_LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\AC00 \C7A0\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105263980021309669)
,p_name=>'PAGE_LOCKED_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \C758\D574 \D398\C774\C9C0\AC00 \C7A0\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105384458691309761)
,p_name=>'PAGE_NAME_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\B984\C740 \BAA8\B4E0 \D398\C774\C9C0\C5D0 \D544\C218\C801\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105368394000309749)
,p_name=>'PAGE_POSTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AC8C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105538142051309893)
,p_name=>'PAGE_PROCESSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104920168191309411)
,p_name=>'PAGE_PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D504\B85C\C138\C2F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105405584412309776)
,p_name=>'PAGE_PROTECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCF4\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105085403788309531)
,p_name=>'PAGE_REGION.LIST_ITEM_SEQ'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105085648102309532)
,p_name=>'PAGE_REGION.LIST_ITEM_TARGET'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105085503896309532)
,p_name=>'PAGE_REGION.LIST_ITEM_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105085239012309531)
,p_name=>'PAGE_REGION.LIST_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105085376513309531)
,p_name=>'PAGE_REGION.LIST_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105085138099309531)
,p_name=>'PAGE_REGION.QUERY_HIDE_SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4 \C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105085053811309531)
,p_name=>'PAGE_REGION.QUERY_SHOW_SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105084860762309531)
,p_name=>'PAGE_REGION.TREE_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105084603279309531)
,p_name=>'PAGE_REGION.TREE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105084964981309531)
,p_name=>'PAGE_REGION.TREE_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105084735477309531)
,p_name=>'PAGE_REGION.TREE_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105007625301309475)
,p_name=>'PAGE_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D398\C774\C9C0\AC00 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105386709877309762)
,p_name=>'PAGE_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105355540967309739)
,p_name=>'PAGE_UNLOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C758 \C7A0\AE08\C774 \D574\C81C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105368417652309749)
,p_name=>'PAGE_VIEWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCF4\AE30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105364194807309746)
,p_name=>'PARENT_FEATURE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \AE30\B2A5 \BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105474353605309839)
,p_name=>'PARENT_REPORT_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105636008551309973)
,p_name=>'PARENT_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105634309142309971)
,p_name=>'PARENT_TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105078615971309526)
,p_name=>'PARENT_TAB_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105078720888309527)
,p_name=>'PARENT_TAB_SET_NEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C0C1\C704 \D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105078840606309527)
,p_name=>'PARENT_TAB_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED \D14D\C2A4\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105635038200309972)
,p_name=>'PARRENT_TAB_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED \C9D1\D569')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104923300994309414)
,p_name=>'PARSING_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BB38\BD84\C11D \C2A4\D0A4\B9C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104920207667309411)
,p_name=>'PARTIAL_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\BD84 \D398\C774\C9C0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104903564011309399)
,p_name=>'PASSWORD_EXPIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\AC00 \B9CC\AE30\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104891221205309389)
,p_name=>'PASSWORD_MUST_BE_CHANGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \ACC4\C815\C5D0 \B300\D55C \BE44\BC00\BC88\D638\B97C \BCC0\ACBD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104903496845309399)
,p_name=>'PASSWORD_VALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\AC00 \C801\D569\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104911213650309405)
,p_name=>'PASSWORD_WITH_SUBMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638(Enter\B97C \B204\B97C \B54C \C81C\CD9C)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105428047652309800)
,p_name=>'PAST_DUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\D55C \ACBD\ACFC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105517987785309876)
,p_name=>'PATH'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\B85C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105677473002310010)
,p_name=>'PCT_CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('% \C885\ACB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105673781859310006)
,p_name=>'PCT_GRAPH_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC31\BD84\C728\C5D0 \B300\D55C \ADF8\B798\D53D \D615\C2DD: 0 - 100 \BC94\C704\C758 \C815\C218')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105586570678309931)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105586653772309931)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105923197633310202)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105923240393310202)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105588567084309933)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105588699309309933)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105923396632310202)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105923429826310202)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105588953125309933)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105589004174309933)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105589109626309933)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105589269277309933)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105823787982310126)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105823849279310126)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106060463980310328)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106060500409310328)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105592728989309936)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105592857099309936)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105589357912309933)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105589486018309933)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105923548837310202)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105923663921310202)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105587992458309932)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105588099823309932)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105588711620309933)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105588863449309933)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105591563546309935)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105591665013309935)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105587547468309932)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105587650175309932)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105588127704309932)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\AC70\C2DC \B2EC\B825 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105588283702309932)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\AC70\C2DC \B2EC\B825 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105903902120310187)
,p_name=>'PE.COMPONEN.TYPE.CARD.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105904005382310187)
,p_name=>'PE.COMPONEN.TYPE.CARD.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105904183617310187)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105904214577310188)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105606133913309947)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105606279484309947)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105594357084309937)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105594440158309937)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105594552266309937)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105594696434309937)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105683765235310015)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105683877511310015)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105890708490310177)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105890855605310177)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105590337374309934)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\AC70\C2DC \B370\C774\D130 \B85C\B4DC \C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105590431044309934)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\AC70\C2DC \B370\C774\D130 \B85C\B4DC \C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105591944215309935)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105592031888309935)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105591711596309935)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105591812619309935)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105148305555309583)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105148430696309583)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105824038394310126)
,p_name=>'PE.COMPONEN.TYPE.FACET.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105824152892310126)
,p_name=>'PE.COMPONEN.TYPE.FACET.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105895349458310181)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105895408636310181)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105895508539310181)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\BC15\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105895665484310181)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\BC15\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105587393587309932)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\B4DC \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105587449340309932)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\B4DC \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105434881322309806)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105434988810309806)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105435251087309806)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105435316695309806)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105435083387309806)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105435103010309806)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105435480332309806)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105435507183309806)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105902154875310186)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B41C \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105902871238310186)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B41C \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105592959461309936)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105593017555309936)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105593571714309937)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105593601993309937)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105593357648309936)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105593418348309937)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105683525055310015)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105683623264310015)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105593136397309936)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B41C \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105593205317309936)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B41C \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105482260252309845)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105482373472309846)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105482057113309845)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105482127058309845)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105482496043309846)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105482506422309846)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106052849911310321)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106052903720310321)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105589508617309933)
,p_name=>'PE.COMPONEN.TYPE.LIST.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105589658453309934)
,p_name=>'PE.COMPONEN.TYPE.LIST.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105923753829310202)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105923861413310202)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105587738609309932)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105587812710309932)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105589716191309934)
,p_name=>'PE.COMPONEN.TYPE.LOV.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105589873655309934)
,p_name=>'PE.COMPONEN.TYPE.LOV.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105923981052310202)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105924028768310202)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105829867191310131)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105829982966310131)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105830085094310131)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105830175454310131)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105829632740310130)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105829713694310131)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105591119730309935)
,p_name=>'PE.COMPONEN.TYPE.PAGE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105591216840309935)
,p_name=>'PE.COMPONEN.TYPE.PAGE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105592370389309936)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105592458931309936)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105590905054309935)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105591041709309935)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105289589874309688)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105289662887309688)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105592511757309936)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105592687112309936)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105594113047309937)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C778\C99D \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105594269278309937)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C778\C99D \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105593733595309937)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('In \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105593873190309937)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('In \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105593928566309937)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('Out \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105594015250309937)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('Out \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105586956598309931)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105587034266309931)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105924571880310203)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105924637104310203)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105591317637309935)
,p_name=>'PE.COMPONEN.TYPE.REGION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105591476505309935)
,p_name=>'PE.COMPONEN.TYPE.REGION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105882584518310170)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105882616097310171)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105819292468310123)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105819306313310123)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105587130052309932)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105587297998309932)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105530316039309887)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105530493197309887)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105310960209309705)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\ACA9 \B370\C774\D130\BCA0\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105311078548309705)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105690791568310021)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \B808\C774\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105690890755310021)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \B808\C774\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105588336625309933)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B798\C2DD \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105588446417309933)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B798\C2DD \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105256996322309664)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105257060732309664)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105257165833309664)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \D544\D130\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105257278530309664)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105257397506309664)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\BC15\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105257491996309664)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\BC15\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105924158924310202)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105924205543310202)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105590541985309934)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105590692071309934)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105596512624309939)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105596645881309939)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105596745793309939)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105596889345309939)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105683996563310015)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105684016077310016)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105586754483309931)
,p_name=>'PE.COMPONEN.TYPE.THEME.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105586885575309931)
,p_name=>'PE.COMPONEN.TYPE.THEME.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105924320002310203)
,p_name=>'PE.COMPONEN.TYPE.TREE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105924405695310203)
,p_name=>'PE.COMPONEN.TYPE.TREE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105590789730309934)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105590812464309934)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105592120154309936)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105592236710309936)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105589959459309934)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105590038847309934)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105590168151309934)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105590298000309934)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106059556540310327)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C778\C99D \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106059695662310327)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C778\C99D \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106059749831310327)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP \D5E4\B354 \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106059804732310328)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('HTTP \D5E4\B354 \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106059118601310327)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('In \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106059243666310327)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('In \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106059386094310327)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('Out \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106059463023310327)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('Out \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105424355620309797)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105424435655309797)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105535087433309890)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105535133915309890)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105530147784309886)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105530280399309886)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105535240900309890)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \C791\C5C5 \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105535333269309891)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \C791\C5C5 \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105535455239309891)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105535510569309891)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105424569176309797)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105424600016309797)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105545929313309899)
,p_name=>'PE.DISPLAY_GROUP.ACTIONS_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BA54\B274')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106060605162310328)
,p_name=>'PE.DISPLAY_GROUP.ADDITIONAL_CODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \CF54\B4DC \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105207348794309627)
,p_name=>'PE.DISPLAY_GROUP.ADVANCED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105207686895309627)
,p_name=>'PE.DISPLAY_GROUP.AFFECTED_ELEMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105484631287309847)
,p_name=>'PE.DISPLAY_GROUP.ANIMATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\B2C8\BA54\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105208642345309628)
,p_name=>'PE.DISPLAY_GROUP.APPEARANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105205845445309626)
,p_name=>'PE.DISPLAY_GROUP.ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104855571152309359)
,p_name=>'PE.DISPLAY_GROUP.AUDIT_INFORMATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC10\C0AC \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105207441884309627)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105924813585310203)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105603498787309944)
,p_name=>'PE.DISPLAY_GROUP.AUTOMATIC_REFRESH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9 \C0C8\B85C\ACE0\CE68')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105208516839309628)
,p_name=>'PE.DISPLAY_GROUP.BEHAVIOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105578561998309925)
,p_name=>'PE.DISPLAY_GROUP.BLOB'
,p_message_language=>'ko'
,p_message_text=>unistr('BLOB \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105904518802310188)
,p_name=>'PE.DISPLAY_GROUP.BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105580813053309927)
,p_name=>'PE.DISPLAY_GROUP.BREAK_FORMATTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \C11C\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105613509711309952)
,p_name=>'PE.DISPLAY_GROUP.CALENDAR_STATE_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825 \C0C1\D0DC \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105904384142310188)
,p_name=>'PE.DISPLAY_GROUP.CARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105570083752309918)
,p_name=>'PE.DISPLAY_GROUP.CASCADING_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\C18D \AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105605085197309946)
,p_name=>'PE.DISPLAY_GROUP.CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106075477592310342)
,p_name=>'PE.DISPLAY_GROUP.CLIENT_SIDE_CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8\CE21 \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106060730364310328)
,p_name=>'PE.DISPLAY_GROUP.CODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105606755931309947)
,p_name=>'PE.DISPLAY_GROUP.COLORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105684491261310016)
,p_name=>'PE.DISPLAY_GROUP.COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105682802080310015)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105540738636309895)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FORMATTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105684347931310016)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_HEADINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105483943715309847)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_MAPPING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \B9E4\D551')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105205960083309626)
,p_name=>'PE.DISPLAY_GROUP.COMMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105207226272309627)
,p_name=>'PE.DISPLAY_GROUP.COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105206171535309626)
,p_name=>'PE.DISPLAY_GROUP.CONFIGURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105117673432309555)
,p_name=>'PE.DISPLAY_GROUP.CONFIRMATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105616143692309955)
,p_name=>'PE.DISPLAY_GROUP.CONTROLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D2B8\B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105206208530309626)
,p_name=>'PE.DISPLAY_GROUP.CSS'
,p_message_language=>'ko'
,p_message_text=>'CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105302895347309698)
,p_name=>'PE.DISPLAY_GROUP.CUSTOMIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105606551887309947)
,p_name=>'PE.DISPLAY_GROUP.DAILY_WEEKLY_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BCC4 \BC0F \C8FC\BCC4 \B2EC\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105924928588310203)
,p_name=>'PE.DISPLAY_GROUP.DATABASE_SESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C138\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105605158029309946)
,p_name=>'PE.DISPLAY_GROUP.DATAGRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \ADF8\B9AC\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105483860396309847)
,p_name=>'PE.DISPLAY_GROUP.DATA_CURSOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \CEE4\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105207716317309627)
,p_name=>'PE.DISPLAY_GROUP.DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105569952158309918)
,p_name=>'PE.DISPLAY_GROUP.DEPENDING_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\C18D \B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105546044072309899)
,p_name=>'PE.DISPLAY_GROUP.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105546141537309899)
,p_name=>'PE.DISPLAY_GROUP.DETAIL_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105614741989309954)
,p_name=>'PE.DISPLAY_GROUP.DIALOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105546214211309899)
,p_name=>'PE.DISPLAY_GROUP.DOWNLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105606839426309947)
,p_name=>'PE.DISPLAY_GROUP.DRAG_AND_DROP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B04C\C5B4 \B193\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105484599192309847)
,p_name=>'PE.DISPLAY_GROUP.DUAL_Y_AXES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C911 Y\CD95')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105435722352309806)
,p_name=>'PE.DISPLAY_GROUP.EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105568066155309917)
,p_name=>'PE.DISPLAY_GROUP.EDIT_AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105207810085309627)
,p_name=>'PE.DISPLAY_GROUP.ELEMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105435680936309806)
,p_name=>'PE.DISPLAY_GROUP.ENABLE_USER_TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C791\C5C5\C744 \C0AC\C6A9\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105613636066309953)
,p_name=>'PE.DISPLAY_GROUP.ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105206018726309626)
,p_name=>'PE.DISPLAY_GROUP.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105206327093309626)
,p_name=>'PE.DISPLAY_GROUP.ERROR_HANDLING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \CC98\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105207129378309627)
,p_name=>'PE.DISPLAY_GROUP.EXECUTION_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105574421707309922)
,p_name=>'PE.DISPLAY_GROUP.EXPORT_PRINTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C775\C2A4\D3EC\D2B8/\C778\C1C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105580921361309927)
,p_name=>'PE.DISPLAY_GROUP.EXTERNAL_PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\BD80 \CC98\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105828816940310130)
,p_name=>'PE.DISPLAY_GROUP.GANTT_START_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105604966689309946)
,p_name=>'PE.DISPLAY_GROUP.GANTT_TIMELINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0C0\C784\B77C\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106026662564310296)
,p_name=>'PE.DISPLAY_GROUP.GANTT_VIEWPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BDF0\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105604506446309946)
,p_name=>'PE.DISPLAY_GROUP.GAUGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC8C\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105206456552309626)
,p_name=>'PE.DISPLAY_GROUP.HEADER_AND_FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \BC0F \BC14\B2E5\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105581141563309927)
,p_name=>'PE.DISPLAY_GROUP.HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105206595456309627)
,p_name=>'PE.DISPLAY_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105207922362309628)
,p_name=>'PE.DISPLAY_GROUP.HELP_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105206668684309627)
,p_name=>'PE.DISPLAY_GROUP.HTML_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105904784022310188)
,p_name=>'PE.DISPLAY_GROUP.ICON_AND_BADGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \BC0F \BC30\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105546393549309900)
,p_name=>'PE.DISPLAY_GROUP.ICON_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105205674538309626)
,p_name=>'PE.DISPLAY_GROUP.IDENTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DD\BCC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105206705098309627)
,p_name=>'PE.DISPLAY_GROUP.JAVASCRIPT'
,p_message_language=>'ko'
,p_message_text=>'JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105208078439309628)
,p_name=>'PE.DISPLAY_GROUP.LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105208789591309628)
,p_name=>'PE.DISPLAY_GROUP.LAYOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105604077551309945)
,p_name=>'PE.DISPLAY_GROUP.LEGEND'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\B840')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105484037868309847)
,p_name=>'PE.DISPLAY_GROUP.LINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105561137514309911)
,p_name=>'PE.DISPLAY_GROUP.LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105668069319310001)
,p_name=>'PE.DISPLAY_GROUP.LIST_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105208119546309628)
,p_name=>'PE.DISPLAY_GROUP.LIST_OF_VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105606644659309947)
,p_name=>'PE.DISPLAY_GROUP.LIST_VIEW_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C815 \BDF0 \B2EC\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106036467385310306)
,p_name=>'PE.DISPLAY_GROUP.LOCAL_POST_PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\CEEC \C0AC\D6C4 \CC98\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105302272536309698)
,p_name=>'PE.DISPLAY_GROUP.LOGIN_PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 \D504\B85C\C138\C2F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105484280232309847)
,p_name=>'PE.DISPLAY_GROUP.MAJOR_TICKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC \B208\AE08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105830362797310131)
,p_name=>'PE.DISPLAY_GROUP.MAP_LAYER_ZOOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\B300/\CD95\C18C \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105830283149310131)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105830804100310131)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_FEATURE_INFO_WINDOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4 \CC3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105830484997310131)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_INIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \C704\CE58 \BC0F \D655\B300/\CD95\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105830626715310131)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_CLUSTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\C778\D2B8 \D074\B7EC\C2A4\D130\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105830578113310131)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_FEATURE_STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\C778\D2B8 \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105830741712310131)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_ROW_SELECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105604154469309945)
,p_name=>'PE.DISPLAY_GROUP.MARGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5EC\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105484179331309847)
,p_name=>'PE.DISPLAY_GROUP.MARKER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105629696095309967)
,p_name=>'PE.DISPLAY_GROUP.MASTER_DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \B514\D14C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105904842208310188)
,p_name=>'PE.DISPLAY_GROUP.MEDIA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105581054378309927)
,p_name=>'PE.DISPLAY_GROUP.MESSAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105484304462309847)
,p_name=>'PE.DISPLAY_GROUP.MINOR_TICKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80 \B208\AE08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105606352221309947)
,p_name=>'PE.DISPLAY_GROUP.MONTHLY_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4\BCC4 \B2EC\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105008665072309476)
,p_name=>'PE.DISPLAY_GROUP.MULTIPLE_VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105337962922309726)
,p_name=>'PE.DISPLAY_GROUP.MULTI_SERIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \ACC4\C5F4 \CC28\D2B8 \B370\C774\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105925009977310203)
,p_name=>'PE.DISPLAY_GROUP.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105348579705309734)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106112539537310376)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \BA54\B274')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105692451728310023)
,p_name=>'PE.DISPLAY_GROUP.OUTPUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD9C\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105483735648309847)
,p_name=>'PE.DISPLAY_GROUP.OVERVIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105684246521310016)
,p_name=>'PE.DISPLAY_GROUP.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105684649718310016)
,p_name=>'PE.DISPLAY_GROUP.PAGE_FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC14\B2E5\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105684543928310016)
,p_name=>'PE.DISPLAY_GROUP.PAGE_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105546401951309900)
,p_name=>'PE.DISPLAY_GROUP.PAGINATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105566474474309915)
,p_name=>'PE.DISPLAY_GROUP.PARAMETER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105435989296309807)
,p_name=>'PE.DISPLAY_GROUP.PERFORMANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105302306105309698)
,p_name=>'PE.DISPLAY_GROUP.POST_LOGOUT_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\D6C4 \B85C\ADF8\C544\C6C3 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105598904834309941)
,p_name=>'PE.DISPLAY_GROUP.PRIMARY_KEY_SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105684119694310016)
,p_name=>'PE.DISPLAY_GROUP.PRINTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105924742687310203)
,p_name=>'PE.DISPLAY_GROUP.QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105208277851309628)
,p_name=>'PE.DISPLAY_GROUP.QUICK_PICKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE60\B978 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105206830611309627)
,p_name=>'PE.DISPLAY_GROUP.READ_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77D\AE30 \C804\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105302475518309698)
,p_name=>'PE.DISPLAY_GROUP.REAL_APPLICATION_SECURITY'
,p_message_language=>'ko'
,p_message_text=>'Real Application Security'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105047627970309504)
,p_name=>'PE.DISPLAY_GROUP.REFERENCE_LINES'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870\C120')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105567572158309916)
,p_name=>'PE.DISPLAY_GROUP.REFRESH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C\ACE0\CE68')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105311143516309705)
,p_name=>'PE.DISPLAY_GROUP.REMOTE_CACHE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\ACA9 \CE90\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105526791871309883)
,p_name=>'PE.DISPLAY_GROUP.SEARCH_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \B3C4\AD6C \BAA8\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105904641625310188)
,p_name=>'PE.DISPLAY_GROUP.SECONDARY_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C870 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105206923462309627)
,p_name=>'PE.DISPLAY_GROUP.SECURITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105604206714309945)
,p_name=>'PE.DISPLAY_GROUP.SERIES_COLOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C5F4 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105207006911309627)
,p_name=>'PE.DISPLAY_GROUP.SERVER_CACHE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\BC84 \CE90\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106075308581310342)
,p_name=>'PE.DISPLAY_GROUP.SERVER_SIDE_CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\BC84\CE21 \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105925125694310203)
,p_name=>'PE.DISPLAY_GROUP.SESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105302549968309698)
,p_name=>'PE.DISPLAY_GROUP.SESSION_COOKIE_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \CFE0\D0A4 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105302694279309698)
,p_name=>'PE.DISPLAY_GROUP.SESSION_NOT_VALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C138\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105205775841309626)
,p_name=>'PE.DISPLAY_GROUP.SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105546693320309900)
,p_name=>'PE.DISPLAY_GROUP.SINGLE_ROW_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C \D589 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105546501768309900)
,p_name=>'PE.DISPLAY_GROUP.SORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105208321667309628)
,p_name=>'PE.DISPLAY_GROUP.SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105302735504309698)
,p_name=>'PE.DISPLAY_GROUP.SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105904486260310188)
,p_name=>'PE.DISPLAY_GROUP.SUB_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105562016896309912)
,p_name=>'PE.DISPLAY_GROUP.SUCCESS_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105257592442309664)
,p_name=>'PE.DISPLAY_GROUP.SUGGESTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C548\C0AC\D56D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106112664008310376)
,p_name=>'PE.DISPLAY_GROUP.TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104940391401309426)
,p_name=>'PE.DISPLAY_GROUP.THRESHOLDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C784\ACC4\AC12')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105484472505309847)
,p_name=>'PE.DISPLAY_GROUP.TICK_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B208\AE08 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105818720445310122)
,p_name=>'PE.DISPLAY_GROUP.TIME_SCALE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04 \AC04\ACA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105604885228309946)
,p_name=>'PE.DISPLAY_GROUP.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105435837595309807)
,p_name=>'PE.DISPLAY_GROUP.TOOLBAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\AD6C \BAA8\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105604768010309946)
,p_name=>'PE.DISPLAY_GROUP.TOOLTIP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\AD6C \C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105597798106309940)
,p_name=>'PE.DISPLAY_GROUP.UI_DEFAULTS_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('UI \AE30\BCF8 \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105208458701309628)
,p_name=>'PE.DISPLAY_GROUP.VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105604633521309946)
,p_name=>'PE.DISPLAY_GROUP.VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105606454465309947)
,p_name=>'PE.DISPLAY_GROUP.WEEKLY_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC \B2E8\C704 \B2EC\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105207588495309627)
,p_name=>'PE.DISPLAY_GROUP.WHEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105604326838309945)
,p_name=>'PE.DISPLAY_GROUP.X_AXIS'
,p_message_language=>'ko'
,p_message_text=>unistr('X \CD95')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105604405560309945)
,p_name=>'PE.DISPLAY_GROUP.Y_AXIS'
,p_message_language=>'ko'
,p_message_text=>unistr('Y \CD95')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105530581408309887)
,p_name=>'PE.DISPLAY_GROUP.ZOOM_SCALE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\B300/\CD95\C18C \BC30\C728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105437622995309809)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D589\C744 \CD94\AC00\D560 \C218 \C788\B294 \C0AC\C6A9\C790\B97C \C81C\D55C\D558\AE30 \C704\D55C \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \D589\C744 \CD94\AC00\D558\B824\BA74 \C774 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \D574\B2F9 \C0AC\C6A9\C790\C5D0 \B300\D574 TRUE\B85C \D3C9\AC00\B418\C5B4\C57C \D569\B2C8\B2E4.'),
unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \C81C\ACF5\B418\C9C0 \C54A\C73C\BA74 \BAA8\B4E0 \C0AC\C6A9\C790\AC00 \C774 \B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0\C11C \D589\C744 \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105437519817309808)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105440629358309811)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CD94\AC00 \B2E8\CD94\C5D0 \B300\D55C \B300\CCB4 \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \AE30\BCF8 \B808\C774\BE14\C740 <em>\D589 \CD94\AC00</em>\C785\B2C8\B2E4.</p>'),
unistr('        <p>\C608\B97C \B4E4\C5B4, \C9C1\C6D0\C774 \C720\C9C0 \AD00\B9AC\B418\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC\C758 \ACBD\C6B0 <em>\C9C1\C6D0 \CD94\AC00</em>\B97C \C785\B825\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105440568466309811)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \B2E8\CD94 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105438894010309810)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0 \D604\C7AC \BC18\D658\B41C \B808\CF54\B4DC\AC00 \C5C6\B294 \ACBD\C6B0 \C0C8 \D589\C744 \CD94\AC00\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('        \D56D\C0C1 \C801\C5B4\B3C4 \D558\B098\C758 \D45C\C2DC\B41C \B808\CF54\B4DC\AC00 \C788\C73C\BBC0\B85C <em>\B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C74C</em> \BA54\C2DC\C9C0\B294 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \CD94\AC00\B41C \B808\CF54\B4DC\C5D0 \B300\D55C \C5C5\B370\C774\D2B8\AC00 \C5C6\C744 \ACBD\C6B0 \C601\C5ED\C774 \C800\C7A5\B420 \B54C \C0BD\C785\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105438762146309810)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C5B4 \C788\B294 \ACBD\C6B0 \D589 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105922327827310201)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D328\C2EF\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105897328024310182)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D328\C2EF \ADF8\B8F9\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105454057058309823)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \D074\B798\C2A4\B97C \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \AC1C \C785\B825\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0: \C774 \C18D\C131\C744 \C0AC\C6A9\D558\BA74 \B300\D654\C2DD \ADF8\B9AC\B4DC\B97C \D3B8\C9D1\D560 \C218 \C788\C744 \ACBD\C6B0 \D574\B2F9\D558\B294 \D56D\BAA9\C758 \C2A4\D0C0\C77C\C744 \C218\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105899023286310183)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \D074\B798\C2A4\B97C \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \AC1C \C785\B825\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0: \D574\B2F9 CSS \D074\B798\C2A4\B294 HTML \D3FC \C694\C18C \D0DC\ADF8\C5D0 \C801\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105260911654309667)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D544\D130\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105261615593309667)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D544\D130 \ADF8\B8F9\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105898407460310183)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>CSS \D074\B798\C2A4 <code>articlenumber</code> \BC0F <code>highlight</code>\B97C \AD6C\C131\C694\C18C\C758 HTML \D0DC\ADF8\C5D0 \CD94\AC00</dt>'),
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105898300194310183)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\C5D0 \D3EC\D568\D560 \ACF5\BC31\C73C\B85C \AD6C\BD84\B41C \CD94\AC00 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105898228674310183)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105240762758309652)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C758 \C601\D5A5\C744 \BC1B\B294 \B2E8\CD94\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105240610936309652)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106076315397310343)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \C791\C5C5\C758 \C601\D5A5\C744 \BC1B\B294 \C5F4\C744 \D558\B098 \C774\C0C1 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C5F4\C774 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \AC01 \C5F4 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\D569\B2C8\B2E4.'),
unistr('<p>\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \C5F4 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \B54C \C774\BBF8 \C785\B825\B41C \D14D\C2A4\D2B8\AC00 \C788\C73C\BA74 \AE30\C874 \D14D\C2A4\D2B8 \B05D\C5D0 \CF64\B9C8\AC00 \D45C\C2DC\B418\ACE0 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \C5F4 \C774\B984\C774 \CD94\AC00\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106076226500310343)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105241103773309652)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>DOM \AC1D\CCB4(<code>document</code>, <code>window</code>) \B610\B294 DOM \AC1D\CCB4\C758 <em>id</em>(<code>myElementID</code>)\B97C \C774 \C791\C5C5\C758 \C601\D5A5\C744 \BC1B\B294 \C694\C18C\B85C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: <em>DOM \AC1D\CCB4</em>\B294 \B354 \C774\C0C1 \C0AC\C6A9\B418\C9C0 \C54A\C73C\BA70 <em>JavaScript \D45C\D604\C2DD</em> \B610\B294 <em>jQuery \C120\D0DD\AE30</em>\B85C \BC14\AFD4\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105241016456309652)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('DOM \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105240928764309652)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \C791\C5C5\C758 \C601\D5A5\C744 \BC1B\B294 \D398\C774\C9C0 \D56D\BAA9\C744 \D558\B098 \C774\C0C1 \C785\B825\D569\B2C8\B2E4.'),
unistr('\D56D\BAA9\C774 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \AC01 \D56D\BAA9 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\D569\B2C8\B2E4.'),
unistr('<p>\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \B54C \C774\BBF8 \C785\B825\B41C \D14D\C2A4\D2B8\AC00 \C788\C73C\BA74 \AE30\C874 \D14D\C2A4\D2B8 \B05D\C5D0 \CF64\B9C8\AC00 \D45C\C2DC\B418\ACE0 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \D56D\BAA9 \C774\B984\C774 \CD94\AC00\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105240841002309652)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106072744399310339)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\BE0C\B77C\C6B0\C800\C758 <code>window</code> DOM \AC1D\CCB4\C5D0 \B300\D55C \CC38\C870\B97C \BC18\D658\D569\B2C8\B2E4.</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>\BE0C\B77C\C6B0\C800\C758 <code>document</code> DOM \AC1D\CCB4\C5D0 \B300\D55C \CC38\C870\B97C \BC18\D658\D569\B2C8\B2E4.</dt>'),
'<dd>document</dd>',
unistr('<dt>jQuery \C120\D0DD\AE30\B294 ''alert'' \D074\B798\C2A4\B97C \D3EC\D568\D558\B294 \BAA8\B4E0 DIV \C694\C18C\B97C \C120\D0DD\D55C \D6C4 \BAA8\B4E0 \D574\B2F9 \C0C1\C704 \D56D\BAA9\C774 \D3EC\D568\B41C jQuery \AC1D\CCB4\B97C \BC18\D658\D569\B2C8\B2E4.</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106072646854310339)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C DOM \AC1D\CCB4, DOM \AC1D\CCB4 \BC30\C5F4 \B610\B294 jQuery \AC1D\CCB4\B97C \C774 \C791\C5C5\C758 \C601\D5A5\C744 \BC1B\B294 \C694\C18C\B85C \BC18\D658\D558\AE30 \C704\D574 \D3C9\AC00\D560 JavaScript \D45C\D604\C2DD\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106072580437310339)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105731101243310056)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>DOM ID\AC00 <code>my_id</code>\C778 \D398\C774\C9C0 \C694\C18C \C120\D0DD</dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>\D074\B798\C2A4\AC00 <code>my_class</code>\C778 \BAA8\B4E0 \D398\C774\C9C0 \C694\C18C \C120\D0DD</dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>\C785\B825\C778 \BAA8\B4E0 \D398\C774\C9C0 \C694\C18C \C120\D0DD</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105241321249309652)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C791\C5C5\C758 \C601\D5A5\C744 \BC1B\B294 \D398\C774\C9C0 \C694\C18C\B97C \D558\B098 \C774\C0C1 \BC18\D658\D558\AE30 \C704\D55C jQuery \C120\D0DD\AE30 \AD6C\BB38\C744 \C785\B825\D569\B2C8\B2E4. jQuery \B77C\C774\BE0C\B7EC\B9AC\B294 \D398\C774\C9C0\C5D0\C11C \D558\B098 \C774\C0C1\C758 \C694\C18C\C5D0 \C27D\AC8C \C561\C138\C2A4\D560 \C218 \C788\B294 \BC29\BC95\C744 \C81C\ACF5\D558\B294 \B9E4\C6B0 \AC15\B825\D55C \C120\D0DD\AE30 \AD6C\BB38\C744 \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>\C120\D0DD\AE30 \AD6C\BB38\C5D0 \B300\D55C \C790\C138\D55C \B0B4\C6A9\C740 <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">jQuery \D648 \D398\C774\C9C0</a>\C5D0\C11C \C81C\ACF5\B418\B294 \ACF5\C2DD \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105241278818309652)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('jQuery \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105240593760309652)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C758 \C601\D5A5\C744 \BC1B\B294 \C601\C5ED\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105240417182309652)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105240355534309652)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C774 \C2E4\D589\B420 \B54C \C601\D5A5\C744 \BC1B\B294 \D398\C774\C9C0 \AD6C\C131\C694\C18C\B97C \C815\C758\D558\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105729931111310055)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105730008241310055)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C740 \C0AC\C6A9\C790\AC00 \C120\D0DD\D55C \B2E8\CD94\C5D0 \C601\D5A5\C744 \C90D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106075637442310342)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106075729152310342)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C740 \C0AC\C6A9\C790\AC00 \C785\B825\D558\B294 \D558\B098 \C774\C0C1\C758 \C5F4\C5D0 \C601\D5A5\C744 \C90D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105730357609310055)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('DOM \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105730496512310056)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C740 \C0AC\C6A9\C790\AC00 \C785\B825\D55C DOM \AC1D\CCB4 \B610\B294 DOM ID\B85C \C2DD\BCC4\B418\B294 \D398\C774\C9C0 \C694\C18C\C5D0 \C601\D5A5\C744 \C90D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105730940309310056)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105731099273310056)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C791\C5C5\C740 \C77C\BD80 \ACBD\C6B0\C758 "\D2B8\B9AC\AC70 \C694\C18C"\C640 \B2E4\B97C \C218 \C788\B294, \C774\BCA4\D2B8\AC00 \BC1C\C0DD\D55C \C704\CE58\C758 \D398\C774\C9C0 \C694\C18C\C5D0 \C601\D5A5\C744 \C90D\B2C8\B2E4.</p>'),
unistr('<p>\C774 \ACE0\AE09 \AD6C\C131\C5D0\C11C \C9C0\C815\B41C \D2B8\B9AC\AC70 \C774\BCA4\D2B8\B294 \C77C\BC18\C801\C73C\B85C \BAA8\B4E0 \D574\B2F9 \D558\C704 \C694\C18C(\C608: \D574\B2F9 \C601\C5ED\C758 \D398\C774\C9C0 \D56D\BAA9)\C5D0\C11C \BC1C\C0DD\D55C \C774\BCA4\D2B8\B97C \CC98\B9AC\D558\B294 \CEE8\D14C\C774\B108 \C694\C18C(\C608: \C601\C5ED)\C785\B2C8\B2E4.'),
unistr('\ADF8\B7F0 \B2E4\C74C \C774 \C120\D0DD \C720\D615\C740 \CEE8\D14C\C774\B108 \C694\C18C\AC00 \C544\B2C8\B77C \C774\BCA4\D2B8\B97C \D2B8\B9AC\AC70\D55C \D558\C704 \C694\C18C\C5D0 \B530\B77C \C791\C5C5\C744 \C218\D589\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, \D398\C774\C9C0\C758 \C601\C5ED\C5D0\C11C <strong>''\BCC0\ACBD''</strong> \C774\BCA4\D2B8\B97C \C815\C758\D558\B294 \B3D9\C801 \C791\C5C5\C774 \C788\B294 \ACBD\C6B0, \C774 \C791\C5C5\C740 \D574\B2F9 \C601\C5ED\C5D0\C11C \BCC0\ACBD\B41C \C2E4\C81C \D56D\BAA9\C5D0 \C601\D5A5\C744 \C90D\B2C8\B2E4.</p>'),
unistr('<p><em>''\C774\BCA4\D2B8 \C18C\C2A4''</em>\B97C \C0AC\C6A9\D558\BA74 \C5EC\B7EC \D398\C774\C9C0 \C694\C18C\C5D0 \C601\D5A5\C744 \C8FC\B294 \ACF5\D1B5 \B3D9\C791\C744 \BCF4\B2E4 \D6A8\ACFC\C801\C73C\B85C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\CEE8\D14C\C774\B108 \C694\C18C\AC00 \D558\C704 \C694\C18C\C5D0 \C758\D574 \BC1C\C0DD\D55C \C774\BCA4\D2B8\B97C \CEA1\CC98\D558\B294 \AE30\B2A5\C740 \C774\BCA4\D2B8 \C720\D615\C5D0 \B530\B77C \ACB0\C815\B429\B2C8\B2E4.'),
unistr('\C774\B97C \C9C0\C6D0\D558\B294 \C774\BCA4\D2B8 \C720\D615\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\C0C8\B85C\ACE0\CE68 \C774\D6C4</strong>(apexafterrefresh)</li>'),
unistr('  <li><strong>\C0C8\B85C\ACE0\CE68 \C774\C804</strong>(apexbeforerefresh)</li>'),
unistr('  <li><strong>\BCC0\ACBD</strong>(change)</li>'),
unistr('  <li><strong>\D074\B9AD</strong>(click)</li>'),
unistr('  <li><strong>\B354\BE14\D074\B9AD</strong>(dblclick)</li>'),
unistr('  <li><strong>\D3EC\CEE4\C2A4 \D68D\B4DD</strong>(focus)</li>'),
unistr('  <li><strong>\D0A4 \C544\B798\B85C</strong>(keydown)</li>'),
unistr('  <li><strong>\D0A4 \B204\B974\AE30</strong>(keypress)</li>'),
unistr('  <li><strong>\D0A4 \D574\C81C</strong>(keyup)</li>'),
unistr('  <li><strong>\D3EC\CEE4\C2A4 \C190\C2E4</strong>(blur)</li>'),
unistr('  <li><strong>\B9C8\C6B0\C2A4 \B2E8\CD94 \B204\B974\AE30</strong>(mousedown)</li>'),
unistr('  <li><strong>\B9C8\C6B0\C2A4 \B2E8\CD94 \D574\C81C</strong>(mouseup)</li>'),
unistr('  <li><strong>\B9C8\C6B0\C2A4 \C774\B3D9</strong>(mousemove)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105729747390310055)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105729852603310055)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C740 \C0AC\C6A9\C790\AC00 \C785\B825\D558\B294 \D558\B098 \C774\C0C1\C758 \D398\C774\C9C0 \D56D\BAA9\C5D0 \C601\D5A5\C744 \C90D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106072370795310339)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106072460279310339)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C740 \C0AC\C6A9\C790\AC00 \C785\B825\D55C JavaScript \D45C\D604\C2DD\C744 \C0AC\C6A9\D574\C11C \BC18\D658\B418\B294 \D398\C774\C9C0 \C694\C18C\C5D0 \C601\D5A5\C744 \C90D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105730505094310056)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('jQuery \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105730693423310056)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C740 \C0AC\C6A9\C790\AC00 \C785\B825\D55C jQuery \C120\D0DD\AE30 \AD6C\BB38\C744 \C0AC\C6A9\D574\C11C \BC18\D658\B418\B294 \D398\C774\C9C0 \C694\C18C\C5D0 \C601\D5A5\C744 \C90D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105730119178310055)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105730265219310055)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C740 \C0AC\C6A9\C790\AC00 \C120\D0DD\D55C \C601\C5ED\C5D0 \C601\D5A5\C744 \C90D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105730793423310056)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC\AC70 \C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105730886094310056)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C740 \B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D55C \D398\C774\C9C0 \C694\C18C \B610\B294 \AD6C\C131\C694\C18C\C5D0 \C601\D5A5\C744 \C90D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105240277954309651)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105352866059309737)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D1\ACC4 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105352960930309737)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \C5F4\C744 \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106003134991310273)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B41C \CC28\D2B8 \AC12 \C5F4\C744 \C9D1\ACC4\D558\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106004600460310275)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\B7B5\C801 \ACE0\C720 \AC1C\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106004785273310275)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\B7B5\C801\C778 \ACE0\C720 \AC12 \C218\B97C \BC18\D658\D569\B2C8\B2E4. \C774 \C9D1\ACC4\B294 \B9CE\C740 \C591\C758 \B370\C774\D130\B97C \CC98\B9AC\D560 \B54C <em>\ACE0\C720 \AC1C\C218</em>\BCF4\B2E4 \D6E8\C52C \BE60\B985\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106003611539310274)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3C9\ADE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106003756258310274)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \C5F4\C758 \D3C9\ADE0\C744 \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106003204784310273)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106003352053310274)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\CF54\B4DC \C218\B97C \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106004458037310274)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \AC1C\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106004588274310275)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\D655\D55C \ACE0\C720 \AC12 \C218\B97C \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106004245588310274)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106004374360310274)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300\AC12\C744 \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106003882798310274)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\AC04\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106003959755310274)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110\C744 \BB34\C2DC\D55C \C911\AC04 \C218\CE58\B97C \BC18\D658\D569\B2C8\B2E4. \C774 \C9D1\ACC4\B294 \C911\AC04 \C218\CE58\B97C \BC18\D658\D558\BBC0\B85C \C5F0\C18D \BD84\BC30 \BAA8\B378\C5D0 \AC00\C7A5 \C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106004063871310274)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106004143448310274)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C\AC12\C744 \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106003489581310274)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D569\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106003583416310274)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \C5F4\C758 \D569\ACC4\B97C \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106003057034310273)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \C9D1\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105219697081309636)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \B3D9\C77C\D55C \D398\C774\C9C0\B97C \B450 \BC88 \C774\C0C1 \C81C\CD9C\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C774 \AE30\B2A5\C744 \C0AC\C6A9\D558\BA74 \B3D9\C77C\D55C \D398\C774\C9C0\C5D0 \B300\D55C \C911\BCF5 \C0BD\C785\C744 \BC29\C9C0\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C911\BCF5 \C0BD\C785\C740 \C77C\BC18 \C0AC\C6A9\C790\AC00 \BE0C\B77C\C6B0\C800\C758 \B4A4\B85C \B2E8\CD94\B97C \B204\B974\ACE0 \D398\C774\C9C0\B97C \B2E4\C2DC \C81C\CD9C\D55C \ACBD\C6B0 \B610\B294 \C77C\BC18 \C0AC\C6A9\C790\AC00 \BE0C\B77C\C6B0\C800\C758 \B2E4\C2DC \B85C\B4DC \B2E8\CD94\B97C \B204\B97C \B54C \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105721200558310049)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624 - \D398\C774\C9C0 \C7AC\AC8C\C2DC \AE08\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105721312592310049)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608 - \D398\C774\C9C0 \C7AC\AC8C\C2DC\B97C \C0AC\C6A9\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105219510649309636)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\BCF5 \D398\C774\C9C0 \C81C\CD9C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105549460486309902)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C \B808\CF54\B4DC \BCF4\AE30\C5D0\C11C \B110 \AC12\C774 \C228\ACA8\C9C0\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105549308409309902)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \AC12 \C81C\C678')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105549680685309902)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C \B808\CF54\B4DC \BDF0\C5D0\C11C \D604\C7AC \D45C\C2DC\B41C \C5F4\B9CC \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <strong>\D574\C81C</strong>\B97C \C9C0\C815\D558\BA74 \D45C\C2DC\B418\C9C0 \C54A\C740 \BCF4\ACE0\C11C \C5F4\B3C4 \B2E8\C77C \B808\CF54\B4DC \BDF0\C5D0 \D45C\C2DC\B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105549539783309902)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\B41C \C5F4\B9CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105543550222309897)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \C5F4\C744 \C9D1\ACC4\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105543415405309897)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D1\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105543985719309898)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \CC28\D2B8 \B0B4\C5D0\C11C \C774 \C5F4\C744 \C0AC\C6A9\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105543836137309898)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105543758264309898)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C815\C758\D55C \ACC4\C0B0 \C5F4\C5D0\C11C \C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \C5F4\C744 \D65C\C6A9\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105543603058309897)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105543391542309897)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C81C\C5B4 \CC28\B2E8\C5D0\C11C \C774 \C5F4\C744 \D65C\C6A9\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105543251849309897)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \CC28\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105542920055309896)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \C5F4\C744 \D544\D130\B9C1\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105542806353309896)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105544185036309898)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \C5F4\C744 \ADF8\B8F9\D654\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105544051089309898)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105542586644309896)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \C5F4\C744 \C228\AE38 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105542413126309896)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105543152156309897)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \C5F4\C744 \AC15\C870 \D45C\C2DC\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105543020201309897)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104856327856309359)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \BCF4\ACE0\C11C \B0B4\C5D0\C11C \D53C\BC97 \BD84\C11D\C744 \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104856287656309359)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105557405172309908)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C790\C2E0\C758 \D604\C7AC \BCF4\ACE0\C11C \C815\C758\B97C <em>\ACF5\C6A9</em> \BCF4\ACE0\C11C\B85C \C800\C7A5\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\ACF5\C6A9 \BCF4\ACE0\C11C\B294 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C5D0\C11C \C0AC\C6A9 \AC00\B2A5\D55C \BCF4\ACE0\C11C \C120\D0DD \BAA9\B85D\C5D0 \D45C\C2DC\B418\BA70 \BAA8\B4E0 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('\C791\C5C5 \BA54\B274\C758 \C635\C158\C740 \C778\C99D\B41C \C0AC\C6A9\C790\C5D0\AC8C\B9CC \C81C\ACF5\B418\BA70 <strong>\ACF5\C6A9 \BCF4\ACE0\C11C \C800\C7A5 \AD8C\D55C \BD80\C5EC</strong>\B3C4 \CC44\C6B8 \ACBD\C6B0 \CD94\AC00\B85C \C81C\D55C\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105557362570309908)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9 \BCF4\ACE0\C11C \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105557292219309908)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C790\C2E0\C758 \D604\C7AC \BCF4\ACE0\C11C \C815\C758\B97C <em>\C804\C6A9</em> \BCF4\ACE0\C11C\B85C \C800\C7A5\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\C804\C6A9 \BCF4\ACE0\C11C\B294 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C5D0\C11C \C0AC\C6A9 \AC00\B2A5\D55C \BCF4\ACE0\C11C \C120\D0DD \BAA9\B85D\C5D0 \D45C\C2DC\B418\BA70 \C0AC\C6A9\C790\AC00 \C778\C99D\B41C \ACBD\C6B0 \BCF4\ACE0\C11C\B97C \C800\C7A5\D55C \C0AC\C6A9\C790\C5D0\AC8C\B9CC \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('\C791\C5C5 \BA54\B274\C758 \C635\C158\C740 \C778\C99D\B41C \C0AC\C6A9\C790\C5D0\AC8C\B9CC \C81C\ACF5\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105557189289309908)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105557684372309908)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \BCF4\ACE0\C11C \BC94\C8FC\B97C \C800\C7A5\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105557584979309908)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \BC94\C8FC \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105542707574309896)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \C5F4\C744 \C815\B82C\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105542650754309896)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105444383816309814)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B300\D654\C0C1\C790 \BC0F \B2E8\C77C \D589 \BCF4\AE30\C5D0\C11C \C0AC\C6A9\D560 \B300\CCB4 \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('        \BA38\B9AC\AE00\C5D0 HTML \D0DC\ADF8\C640 \AC19\C774 \C81C\B300\B85C \D45C\C2DC\B418\C9C0 \C54A\B294 \CD94\AC00 \D615\C2DD \C9C0\C815\C774 \D3EC\D568\B41C \ACBD\C6B0 \B300\CCB4 \B808\C774\BE14\C744 \C0AC\C6A9\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105444247210309814)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105321167633309714)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC80\C99D\C774 \D56D\C0C1 \C2E4\D589\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('<strong>\C124\C815</strong>\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \D398\C774\C9C0\B97C \C81C\CD9C\D55C \B2E8\CD94\C5D0 \B300\D574 \C815\C758\B41C <em>\AC80\C99D \C2E4\D589</em> \C124\C815\C5D0 \AD00\ACC4\C5C6\C774 \C774 \AC80\C99D\C774 \D56D\C0C1 \D3C9\AC00\B429\B2C8\B2E4.'),
unistr('<strong>\D574\C81C</strong>\B85C \C124\C815\D558\BA74 \D2B8\B9AC\AC70 \B2E8\CD94\C758 <em>\AC80\C99D \C2E4\D589</em> \C124\C815\C774 <strong>\C124\C815</strong>\C778 \ACBD\C6B0\C5D0\B9CC \C774 \AC80\C99D\C774 \D3C9\AC00\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C774 \AC80\C99D\C774 \D3C9\AC00\B418\B824\BA74 \BA3C\C800 \C9C0\C815\B41C \C870\AC74\C744 \C900\C218\D574\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105321005327309714)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\C0C1 \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105487217063309849)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CC28\D2B8\C5D0\C11C \B370\C774\D130\AC00 \BCC0\ACBD\B420 \B54C \C560\B2C8\BA54\C774\C158\C774 \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4. \CC28\D2B8\AC00 \C790\B3D9\C73C\B85C \C0C8\B85C\ACE0\CE68\B418\B294 \ACBD\C6B0, \BC94\B840 \D56D\BAA9\C744 \B204\B97C \B54C \C228\AE30\AE30 \BC0F \D45C\C2DC \B3D9\C791\C774 \C218\D589\B418\B294 \ACBD\C6B0 \B610\B294 \CC28\D2B8 \B370\C774\D130\AC00 \C77C\BD80 \C0AC\C6A9\C790\C815\C758 JavaScript \CF54\B4DC\B098 \B3D9\C801 \C791\C5C5\C744 \D1B5\D574 \D504\B85C\ADF8\B798\BC0D\C801\C73C\B85C \C5C5\B370\C774\D2B8\B418\B294 \ACBD\C6B0 \B370\C774\D130 \BCC0\ACBD\C774 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p><strong>\C67C\CABD\C73C\B85C \C2AC\B77C\C774\B4DC</strong> \BC0F <strong>\C624\B978\CABD\C73C\B85C \C2AC\B77C\C774\B4DC</strong> \C635\C158\C740 \B2E4\C774\C5BC \CC28\D2B8\C5D0 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>  ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105487369519309849)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105617898980309956)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0 \B300\D55C Oracle JET \C815\C758 \AE30\BCF8 \C560\B2C8\BA54\C774\C158 \C124\C815\C744 \C801\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105487678313309850)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105627397846309965)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\AC00 \BCC0\ACBD\B420 \B54C \CC28\D2B8\C5D0 \C560\B2C8\BA54\C774\C158\C774 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105487405612309850)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD\C73C\B85C \C2AC\B77C\C774\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105627178409309965)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\AC00 \BCC0\ACBD\B420 \B54C \B370\C774\D130 \C694\C18C\AC00 \C67C\CABD\C73C\B85C \C2AC\B77C\C774\B4DC\B429\B2C8\B2E4. \AC04\D2B8 \CC28\D2B8\C5D0\B294 \C774 \C124\C815\C774 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105487598878309850)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD\C73C\B85C \C2AC\B77C\C774\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105627248183309965)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\AC00 \BCC0\ACBD\B420 \B54C \B370\C774\D130 \C694\C18C\AC00 \C624\B978\CABD\C73C\B85C \C2AC\B77C\C774\B4DC\B429\B2C8\B2E4. \AC04\D2B8 \CC28\D2B8\C5D0\B294 \C774 \C124\C815\C774 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105487115804309849)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \BCC0\ACBD \C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105486679571309849)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CC98\C74C\C5D0 \CC28\D2B8\B97C \D45C\C2DC\D560 \B54C \C0AC\C6A9\B418\B294 \C560\B2C8\BA54\C774\C158 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('        <p><strong>\C54C\D30C \D398\C774\B4DC</strong> \BC0F <strong>\D655\B300/\CD95\C18C</strong> \C635\C158\C740 \B2E4\C774\C5BC \CC28\D2B8\C5D0 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105486887475309849)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C\D30C \D398\C774\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105617501321309956)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\C74C\C5D0 \D45C\C2DC\B420 \B54C \CC28\D2B8\B97C \C11C\C11C\D788 \B610\B837\D558\AC8C \D569\B2C8\B2E4. \AC04\D2B8 \CC28\D2B8\C5D0\B294 \C774 \C124\C815\C774 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105486700682309849)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105617474652309956)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0 \B300\D55C Oracle JET \C815\C758 \AE30\BCF8 \C560\B2C8\BA54\C774\C158 \C124\C815\C744 \C801\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105487079363309849)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105617796226309956)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\C74C\C5D0 \D45C\C2DC\B420 \B54C \CC28\D2B8\C5D0 \C801\C6A9\B41C \C560\B2C8\BA54\C774\C158\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105486916552309849)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\B300/\CD95\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105617642702309956)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\C74C\C5D0 \D45C\C2DC\B420 \B54C \CC28\D2B8\B97C \D655\B300\D569\B2C8\B2E4. \AC04\D2B8 \CC28\D2B8\C5D0\B294 \C774 \C124\C815\C774 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105486500297309849)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105899192040310183)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105922242912310201)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105899951537310184)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C5D0 \CD94\AC00\D560 \ACF5\BC31\C73C\B85C \AD6C\BD84\B41C \CD94\AC00 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C5D0\B294 <code>#COMPONENT_CSS_CLASSES#</code> \B300\CCB4 \BB38\C790\C5F4\C774 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105453891814309823)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \D074\B798\C2A4\B97C \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \AC1C \C785\B825\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('        <p>\CC38\ACE0: \D574\B2F9 CSS \D074\B798\C2A4\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC\C758 \C140\C5D0 \C801\C6A9\B429\B2C8\B2E4. \D574\B2F9\D558\B294 \D56D\BAA9\C5D0 CSS \D074\B798\C2A4\B97C \C801\C6A9\D558\B824\BA74 \ACE0\AE09 \ADF8\B8F9\C758 CSS \D074\B798\C2A4 \C18D\C131\C744 \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105898887257310183)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105898924631310183)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D56D\BAA9\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.<p/>'),
unistr('        <p>\C774 \C18D\C131\C744 \C0AC\C6A9\D558\BA74 \D15C\D50C\B9AC\D2B8 \C635\C158\C744 \BC97\C5B4\B098\C11C \D56D\BAA9\C5D0 \B300\D55C \C2A4\D0C0\C77C\C744 \C218\C815\D558\AC70\B098, JavaScript\B97C \D1B5\D574 \C774 \D56D\BAA9\C744 \C120\D0DD\D558\B294 \B354 \AC04\B2E8\D55C \BC29\BC95\C744 \C81C\ACF5\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0: CSS \D074\B798\C2A4\B97C HTML \D3FC \C694\C18C \D0DC\ADF8\C5D0 \C801\C6A9\D558\B824\BA74 \ACE0\AE09 \ADF8\B8F9 \C544\B798\C5D0 \C788\B294 CSS \D074\B798\C2A4 \C18D\C131\C744 \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105899270766310184)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105900122815310184)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105900052701310184)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C5D0 \CD94\AC00\D560 \ACF5\BC31\C73C\B85C \AD6C\BD84\B41C \CD94\AC00 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C5D0\B294 <code>#COMPONENT_CSS_CLASSES#</code> \B300\CCB4 \BB38\C790\C5F4\C774 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105898758901310183)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\AD6C\C131\C694\C18C\C5D0 CSS \D074\B798\C2A4 <code>articlenumber</code> \BC0F <code>highlight</code> \CD94\AC00</dt>'),
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105898699143310183)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105898534048310183)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104857833319309361)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C758 \BC94\C704\B97C \C120\D0DD\D569\B2C8\B2E4. &PRODUCT_NAME. \C138\C158\C774 \B450 \AC1C \C774\C0C1\C758 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \ACF5\C720\B418\ACE0 \D56D\BAA9 \AC12\C774 \BAA8\B4E0 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \B3D9\C77C\D574\C57C \D558\B294 \ACBD\C6B0 <strong>\C804\C5ED</strong>\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\ADF8\B807\C9C0 \C54A\C73C\BA74 \AE30\BCF8 \BC94\C704\C778 <strong>\C560\D50C\B9AC\CF00\C774\C158</strong>\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\D574\B2F9 \C778\C99D\C5D0 \B3D9\C77C\D55C <em>\C138\C158 \CFE0\D0A4 \C18D\C131</em>\C774 \C0AC\C6A9\B418\B294 \ACBD\C6B0 \C560\D50C\B9AC\CF00\C774\C158\C774 \B3D9\C77C\D55C \C138\C158\C744 \ACF5\C720\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\B610\D55C \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C758 \BC94\C704 \C18D\C131\C740 \C774\B7EC\D55C \C560\D50C\B9AC\CF00\C774\C158 \AC04\C5D0 \B3D9\C77C\D574\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105753027253310073)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.APP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105753124868310073)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.GLOBAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104857701407309360)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105503878101309864)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \ACC4\C5F4\C774 \CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\B41C Y2\CD95\C5D0 \C9C0\C815\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105503772998309864)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Y2\CD95\C5D0 \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105321736004309714)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0 \CC98\B9AC \AD6C\C131\C694\C18C\C640 \C5F0\AD00\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105321608892309714)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B41C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105321580418309714)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \AC80\C99D \C624\B958 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B418\B294 \C704\CE58\C758 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\D56D\BAA9\C744 \C120\D0DD\D558\ACE0 <em>\C624\B958 \BA54\C2DC\C9C0 \D45C\C2DC \C704\CE58</em>\C5D0 "\D544\B4DC\C5D0 \D3EC\D568"\C774 \D3EC\D568\B41C \ACBD\C6B0 \C624\B958 \BA54\C2DC\C9C0\AC00 \C9C0\C815\B41C \D56D\BAA9\C758 \B808\C774\BE14 \C544\B798\C5D0 \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('<em>\C624\B958 \BA54\C2DC\C9C0 \D45C\C2DC \C704\CE58</em>\C5D0 "\D544\B4DC\C5D0 \D3EC\D568"\C774 \D3EC\D568\B418\C9C0 \C54A\C740 \ACBD\C6B0 \C774 \C18D\C131\C740 \C624\B958 \BA54\C2DC\C9C0\C758 \D45C\C2DC\C5D0 \C601\D5A5\C744 \C8FC\C9C0 \C54A\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105321466537309714)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B41C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105925277563310203)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.LOV.NATIVE_CUSTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105303585042309699)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\ACC4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105249143202309658)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0\C5D0 \C801\C6A9\D560 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \C120\D0DD\D569\B2C8\B2E4. \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B294 \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8\C5D0\C11C \C815\C758\B418\BA70 \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C758 \C5EC\B7EC \C694\C18C\C5D0 \C801\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\AD8C\D55C \BD80\C5EC \CCB4\ACC4\B294 \AC01 \C560\D50C\B9AC\CF00\C774\C158 \C138\C158\C5D0 \B300\D574 \D55C \BC88(\C138\C158 \C0DD\C131 \C2DC) \B610\B294 \AC01 \D398\C774\C9C0 \BCF4\AE30\C5D0 \B300\D574 \D55C \BC88 \D3C9\AC00\B429\B2C8\B2E4. \C120\D0DD\B41C \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 <strong>TRUE</strong>\B85C \D3C9\AC00\B420 \ACBD\C6B0 \D398\C774\C9C0\AC00 \D45C\C2DC\B418\ACE0 \B2E4\B978 \C815\C758\B41C \C870\AC74\C758 \C601\D5A5\C744 \BC1B\C2B5\B2C8\B2E4. <strong>FALSE</strong>\B85C \D3C9\AC00\B420 \ACBD\C6B0\C5D0\B294 \D398\C774\C9C0\AC00 \D45C\C2DC\B418\C9C0 \C54A\C73C\BA70 \C624\B958 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105218890734309636)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\B97C \C81C\C5B4\D558\AE30 \C704\D55C \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \C120\D0DD\D569\B2C8\B2E4. \C774 \AD6C\C131\C694\C18C\AC00 \B80C\B354\B9C1 \B610\B294 \C2E4\D589\B418\B824\BA74 \AD8C\D55C \BD80\C5EC\AC00 TRUE\B85C \D3C9\AC00\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105218754347309635)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105209743295309629)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C801\C6A9\B418\B294 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \C120\D0DD\D569\B2C8\B2E4. \C9C0\C6D0\B418\B294 \AD8C\D55C \BD80\C5EC \C720\D615\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\C5D0 \B530\B77C \C5EC\AE30\C5D0\C11C \CD94\AC00 \AD8C\D55C \BD80\C5EC \C720\D615 \D50C\B7EC\ADF8\C778\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \D50C\B7EC\ADF8\C778\C740 <em>&lt;My Plug-in&gt; [Plug-in]</em>\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('\B2E4\C74C \D50C\B7EC\ADF8\C778\C740 \C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \ACF5\C720 \AD6C\C131\C694\C18C \B0B4\C5D0 \C124\CE58\B429\B2C8\B2E4.</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105209659582309629)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106061686582310329)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106061970771310329)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106061865071310329)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106061732699310329)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106062045127310330)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106061533563310329)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106062857476310330)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654\B97C \C2E4\D589\D558\B294 \B3D9\C548 \D3C9\AC00\B418\B294 \B370\C774\D130\C758 \C18C\C2A4\B97C \C9C0\C815\D569\B2C8\B2E4. \C790\B3D9\D654\B294 \D14C\C774\BE14, SQL \C9C8\C758 \B610\B294 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218\B97C \AE30\BC18\C73C\B85C \D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106062793072310330)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106062649040310330)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106062596886310330)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654\B97C \C2E4\D589\D558\B294 \B3D9\C548 \D3C9\AC00\B418\B294 \B370\C774\D130\C758 \C18C\C2A4\B97C \C9C0\C815\D569\B2C8\B2E4. \C790\B3D9\D654\B294 \D14C\C774\BE14, SQL \C9C8\C758 \B610\B294 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218\B97C \AE30\BC18\C73C\B85C \D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106062484206310330)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106062345238310330)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106062232532310330)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654\B97C \C2E4\D589\D558\B294 \B3D9\C548 \D3C9\AC00\B418\B294 \B370\C774\D130\C758 \C18C\C2A4\B97C \C9C0\C815\D569\B2C8\B2E4. \C790\B3D9\D654\B294 \D14C\C774\BE14, SQL \C9C8\C758 \B610\B294 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218\B97C \AE30\BC18\C73C\B85C \D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106062117690310330)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106063064979310330)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654\B97C \C2E4\D589\D558\B294 \B3D9\C548 \D3C9\AC00\B418\B294 \B370\C774\D130\C758 \C18C\C2A4\B97C \C9C0\C815\D569\B2C8\B2E4. \C790\B3D9\D654\B294 \D14C\C774\BE14, SQL \C9C8\C758 \B610\B294 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218\B97C \AE30\BC18\C73C\B85C \D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106062928100310330)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106061193828310329)
,p_name=>'PE.PROPERTY.AUTOMATION_ADDL_PLSQL_CODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106061068365310329)
,p_name=>'PE.PROPERTY.AUTOMATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106060963043310329)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654\B97C \C2E4\D589\D558\B294 \B3D9\C548 \D3C9\AC00\B418\B294 \B370\C774\D130\C758 \C18C\C2A4\B97C \C9C0\C815\D569\B2C8\B2E4. \C790\B3D9\D654\B294 \D14C\C774\BE14, SQL \C9C8\C758 \B610\B294 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218\B97C \AE30\BC18\C73C\B85C \D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106060838140310328)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106061429605310329)
,p_name=>'PE.PROPERTY.AUTO_ACTION_CODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106061339644310329)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106061274778310329)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105360191094309743)
,p_name=>'PE.PROPERTY.AUTO_DETECT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C801\D569\D55C \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C790\B3D9\C73C\B85C \AC80\C0C9\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C790\B3D9 \AC80\C0C9\C774 <strong>\C124\C815</strong>\C778 \ACBD\C6B0 \C0AC\C6A9 \C911\C778 \C7A5\CE58 \D06C\AE30\C5D0 \B530\B77C \AC00\C7A5 \C801\D569\D55C \B85C\ADF8\C778 \D398\C774\C9C0 \B610\B294 \D648 \D398\C774\C9C0\B85C \C0AC\C6A9\C790\AC00 \C790\B3D9\C73C\B85C \C7AC\C9C0\C815\B429\B2C8\B2E4.'),
unistr('\D45C\C2DC\D560 \D574\B2F9 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \ACB0\C815\D558\AE30 \C704\D574\C11C\B294 \B9E4\CCB4 \C9C8\C758\AC00 \C0AC\C6A9\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105360006700309743)
,p_name=>'PE.PROPERTY.AUTO_DETECT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9 \AC10\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105505898615309866)
,p_name=>'PE.PROPERTY.AXIS_MAX.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95\C758 \CD5C\B300\AC12\C744 \C785\B825\D569\B2C8\B2E4. \AE30\BCF8\C801\C73C\B85C \B370\C774\D130\B97C \AE30\C900\C73C\B85C \C790\B3D9 \ACC4\C0B0\C758 \ACBD\C6B0 \B110\C785\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105505793796309866)
,p_name=>'PE.PROPERTY.AXIS_MAX.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105505630881309865)
,p_name=>'PE.PROPERTY.AXIS_MIN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95\C758 \CD5C\C18C\AC12\C744 \C785\B825\D569\B2C8\B2E4. \AE30\BCF8\C801\C73C\B85C \B370\C774\D130\B97C \AE30\C900\C73C\B85C \C790\B3D9 \ACC4\C0B0\C758 \ACBD\C6B0 \B110\C785\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105505539162309865)
,p_name=>'PE.PROPERTY.AXIS_MIN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105506653966309866)
,p_name=>'PE.PROPERTY.AXIS_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\D560 \B808\C774\BE14\C758 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105506766986309866)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105507180374309867)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105506923303309867)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.END.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B05D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105506812274309866)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.START.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105507006160309867)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105506584677309866)
,p_name=>'PE.PROPERTY.AXIS_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105529035209309885)
,p_name=>'PE.PROPERTY.AXIS_SCALING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95 \BC30\C728\C744 \C120\D0DD\D569\B2C8\B2E4. \C22B\C790 \CD95\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105529148224309886)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LINEAR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105529279360309886)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LOG.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105528926028309885)
,p_name=>'PE.PROPERTY.AXIS_SCALING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C218\C810 \C774\D558 \C790\B9BF\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105506431588309866)
,p_name=>'PE.PROPERTY.AXIS_STEP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC \B208\AE08 \D45C\C2DC \C0AC\C774\C758 \C99D\BD84\C744 \C785\B825\D569\B2C8\B2E4. \AE30\BCF8\C801\C73C\B85C \B370\C774\D130\B97C \AE30\C900\C73C\B85C \C790\B3D9 \ACC4\C0B0\C758 \ACBD\C6B0 \B110\C785\B2C8\B2E4. \C2DC\AC04 \BC0F \C22B\C790 \CD95\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105506399918309866)
,p_name=>'PE.PROPERTY.AXIS_STEP.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105913390480310194)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\C9C0\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105913220846310194)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\C9C0 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105913551870310195)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105913431355310194)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\C9C0 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105913876429310195)
,p_name=>'PE.PROPERTY.BADGE_LABEL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\C601\D654 \B4F1\AE09 \D45C\C2DC</dt>'),
unistr('    <dd>\BC30\C9C0 \C5F4\C774 RATING \C5F4\C778 \ACBD\C6B0 \BC30\C9C0 \B808\C774\BE14\C740 "\BCC4\C810"\C77C \C218 \C788\C2B5\B2C8\B2E4.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105913752231310195)
,p_name=>'PE.PROPERTY.BADGE_LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\C9C0 \AC12\C744 \C124\BA85\D560 \BC30\C9C0 \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105913699761310195)
,p_name=>'PE.PROPERTY.BADGE_LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\C9C0 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105608812958309949)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2EC\B825\C774 \C2DC\C791\B418\B294 \C2DC\AC04\C744 \C9C0\C815\D569\B2C8\B2E4. \C774 \C635\C158\C744 \C120\D0DD\D558\BA74 \D55C \B2EC\ACFC \AC19\C774 \C804\CCB4 \AE30\AC04\C744 \D3EC\D568\D558\B294 \B2EC\B825\C774 \C0DD\C131\B429\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li>[\AC04\ACA9 \C2DC\C791 \C2DC \C2DC\C791]\C774 <strong>\C124\C815</strong>\C774\BA70 \B0A0\C9DC\AC00 6\C6D4 15\C77C\C774\ACE0 \D45C\C2DC\AC00 \C6D4\AC04\C778 \ACBD\C6B0, \ACB0\ACFC \B2EC\B825\C5D0 6\C6D4 1\C77C\BD80\D130 30\C77C\AE4C\C9C0 \D3EC\D568\B429\B2C8\B2E4.</li>'),
unistr('  <li>[\AC04\ACA9 \C2DC\C791 \C2DC \C2DC\C791]\C774 <strong>\D574\C81C</strong>\C774\BA70 \B0A0\C9DC\AC00 6\C6D4 15\C77C\C774\ACE0 \D45C\C2DC\AC00 \C6D4\AC04\C778 \ACBD\C6B0, \ACB0\ACFC \B2EC\B825\C5D0 6\C6D4 15\C77C\BD80\D130 30\C77C\AE4C\C9C0 \D3EC\D568\B429\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105608713964309949)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\ACA9 \C2DC\C791 \C2DC \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105580105838309926)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\D558\B824\B294 BLOB \CF58\D150\CE20\AC00 \C800\C7A5\B41C \D14C\C774\BE14\C5D0\C11C \BB38\C790\C138\D2B8 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C798\BABB\B41C \B370\C774\D130 \C720\D615\C758 \C5F4\C744 \C120\D0DD\D558\BA74 \C774\BBF8\C9C0\AC00 \D45C\C2DC\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105580008978309926)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C790\C138\D2B8 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105579177538309925)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\D558\B824\B294 BLOB \CF58\D150\CE20\AC00 \C800\C7A5\B41C \D14C\C774\BE14\C5D0\C11C BLOB \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C798\BABB\B41C \B370\C774\D130 \C720\D615\C758 \C5F4\C744 \C120\D0DD\D558\BA74 \C774\BBF8\C9C0\AC00 \D45C\C2DC\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105579038594309925)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('BLOB \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105579935220309926)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\D558\B824\B294 BLOB \CF58\D150\CE20\AC00 \C800\C7A5\B41C \D14C\C774\BE14\C5D0\C11C \D30C\C77C \C774\B984 \C5F4\C744 \C785\B825\D569\B2C8\B2E4. \C798\BABB\B41C \B370\C774\D130 \C720\D615\C758 \C5F4\C744 \C120\D0DD\D558\BA74 \C774\BBF8\C9C0\AC00 \D45C\C2DC\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105579823220309926)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C774\B984 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105580314995309926)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\D558\B824\B294 BLOB \CF58\D150\CE20\AC00 \C800\C7A5\B41C \D14C\C774\BE14\C5D0\C11C \B9C8\C9C0\B9C9\C73C\B85C \C5C5\B370\C774\D2B8\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \B0A0\C9DC\B97C \C720\C9C0 \AD00\B9AC\D558\AE30 \C704\D574 \C5F0\AD00\B41C \D2B8\B9AC\AC70\AC00 \D3EC\D568\B41C <code>UPDATED</code> \C5F4\C774 \C774\BBF8 \C788\C73C\BA74 \C774\BBF8\C9C0\AC00 \B9C8\C9C0\B9C9\C73C\B85C \C5C5\B370\C774\D2B8\B418\C5C8\C744 \B54C \D2B9\BCC4\D788 \C0C8 \C5F4\C744 \C815\C758\D558\B294 \B300\C2E0 \C774 \C5F4\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \D558\C9C0\B9CC BLOB \CF58\D150\CE20 \C774\C678\C758 \C5F4\C774 \C815\AE30\C801\C73C\B85C \C5C5\B370\C774\D2B8\B420 \ACBD\C6B0\C5D0\B294 \C774\BBF8\C9C0 \CE90\C2F1\C5D0 \BD80\C815\C801\C778 \C601\D5A5\C744 \C904 \C218 \C788\C2B5\B2C8\B2E4. \C798\BABB\B41C \B370\C774\D130 \C720\D615\C758 \C5F4\C744 \C120\D0DD\D558\BA74 \C774\BBF8\C9C0\AC00')
||unistr(' \D45C\C2DC\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105580278689309926)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9\C73C\B85C \C5C5\B370\C774\D2B8\B41C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105579706076309926)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\D558\B824\B294 BLOB \CF58\D150\CE20\AC00 \C800\C7A5\B41C \D14C\C774\BE14\C5D0\C11C MIME \C720\D615 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C798\BABB\B41C \B370\C774\D130 \C720\D615\C758 \C5F4\C744 \C120\D0DD\D558\BA74 \C774\BBF8\C9C0\AC00 \D45C\C2DC\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105579620856309926)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('MIME \C720\D615 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105579308383309925)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\D558\B824\B294 BLOB \CF58\D150\CE20\AC00 \C800\C7A5\B41C \D14C\C774\BE14\C5D0\C11C \CCAB\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \D14C\C774\BE14\C758 \AE30\BCF8 \D0A4\AC00 \B450 \AC1C \C774\C0C1\C758 \C5F4\C744 \D3EC\D568\D558\B294 \ACBD\C6B0 <code>ROWID</code> \C5F4\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4. \C798\BABB\B41C \B370\C774\D130 \C720\D615\C758 \C5F4\C744 \C120\D0DD\D558\BA74 \C774\BBF8\C9C0\AC00 \D45C\C2DC\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105579258098309925)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105579553828309926)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C5D0 \B300\D55C \AE30\BCF8 \D0A4\AC00 \B450 \AC1C\C758 \C5F4\C744 \D3EC\D568\D558\B294 \ACBD\C6B0 \B450\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4\B9CC \C120\D0DD\D569\B2C8\B2E4. \CCAB\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4\C5D0 \B300\D574 <code>ROWID</code>\B97C \C120\D0DD\D55C \ACBD\C6B0\C5D0\B294 \C774 \C5F4\C744 \CC44\C6B0\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4. \C798\BABB\B41C \B370\C774\D130 \C720\D615\C758 \C5F4\C744 \C120\D0DD\D558\BA74 \C774\BBF8\C9C0\AC00 \D45C\C2DC\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105579474079309926)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105578917740309925)
,p_name=>'PE.PROPERTY.BLOB_TABLE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D45C\C2DC\D558\B824\B294 BLOB \CF58\D150\D2B8\AC00 \C800\C7A5\B41C \D14C\C774\BE14 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\D14C\C774\BE14 \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D14C\C774\BE14 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105578872377309925)
,p_name=>'PE.PROPERTY.BLOB_TABLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105578765974309925)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\D558\B824\B294 BLOB \CF58\D150\CE20\AC00 \C800\C7A5\B41C \D14C\C774\BE14\C744 \C18C\C720\D558\B294 \C2A4\D0A4\B9C8\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105578646484309925)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105908917763310191)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\AC00 \C5F4\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\B294\C9C0 \C544\B2C8\BA74 HTML \D45C\D604\C2DD \BC0F \C9C0\C6D0\B418\B294 \B300\CCB4 \BB38\C790\C5F4\C744 \D1B5\D55C \ACE0\AE09 \D615\C2DD \C9C0\C815\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\B294\C9C0 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105908863760310191)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09 \D615\C2DD \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105909122096310191)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38\C73C\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105909059921310191)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105909653087310192)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105909500892310192)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105218409601309635)
,p_name=>'PE.PROPERTY.BODY_HEADER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \C911\C778 \D398\C774\C9C0\C5D0 \D45C\C2DC\B418\B294 \C601\C5ED\C758 \C55E\C5D0 \D45C\C2DC\D560 \D14D\C2A4\D2B8 \B610\B294 HTML\C744 \C785\B825\D569\B2C8\B2E4. \C5EC\AE30\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\B294 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C758 <code>#BODY#</code> \B300\CCB4 \BB38\C790\C5F4 \C55E\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105218364750309635)
,p_name=>'PE.PROPERTY.BODY_HEADER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38 \BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105909462213310191)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\BC30\ACBD \BC0F \D14D\C2A4\D2B8 \C0C9\C0C1 \BCC0\ACBD</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\C81C\BAA9 2 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL \C9C8\C758\C5D0\C11C \B3D9\C801 \D074\B798\C2A4 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \C774 \C608\C5D0\C11C <code>&COLUMN_CLASS.</code> \BC0F <code>&EMPLOYEE_STATUS.</code> \B300\CCB4\B294 \BCF4\ACE0\C11C SQL \C9C8\C758\C5D0\C11C \C120\D0DD\B41C \C5F4\C785\B2C8\B2E4.</dd>'),
unistr('  <dt>\C774\BBF8\C9C0 \D45C\C2DC \BC0F \CEE4\C11C\B97C \C704\B85C \AC00\C838\AC08 \B54C \B3C4\AD6C \C124\BA85 \D45C\C2DC</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105909333328310191)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C5D0 \D45C\C2DC\D560 HTML \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4. <code>&COLUMN.</code> \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC HTML\C5D0 \C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105909212562310191)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105600033634309942)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30 \B9C1\D06C \B0B4\C5D0 \D3EC\D568\D560 \C694\CCAD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105599993749309942)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105998317231310269)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105998685971310269)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105998527180310269)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105998419243310269)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105998798172310269)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105998272196310269)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105573779283309921)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C7AC\C9C0\C815\D560 \D398\C774\C9C0 \BC88\D638 \B610\B294 URL\C774 \D3EC\D568\B41C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C774 \D56D\BAA9\C740 \D398\C774\C9C0\AC00 \CC98\C74C \B85C\B4DC\B420 \B54C \D638\CD9C \D398\C774\C9C0 \B610\B294 \D504\B85C\C138\C2A4\C5D0 \C758\D574 \C124\C815\B420 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C5EC\B7EC \B2E4\B978 \D398\C774\C9C0\C5D0\C11C \D638\CD9C\B418\B294 \D398\C774\C9C0\C5D0 \B300\D574 \BD84\AE30\B97C \B3D9\C801\C73C\B85C \C124\C815\D558\B824\BA74 \D56D\BAA9\C744 \C9C0\C815\D558\B294 \AC83\C774 \AC00\C7A5 \C26C\C6B4 \BC29\BC95\C785\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105573684024309921)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105999566344310270)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C9C0\C815\D560 \D398\C774\C9C0 \BC88\D638 \B610\B294 URL\C744 \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105999436187310270)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105999365345310270)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105999280968310270)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C9C0\C815\D560 \D398\C774\C9C0 \BC88\D638 \B610\B294 URL\C744 \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105999187206310270)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105320039996309713)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BD84\AE30\AC00 \C7AC\C9C0\C815\B418\B294 \D398\C774\C9C0\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105319915648309713)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105320236943309713)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30\C5D0 \C758\D574 \C2E4\D589\B418\B294 PL/SQL \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4. \C774 PL/SQL \D504\B85C\C2DC\C800\B294 \D544\C694\D55C URL\C744 \D638\CD9C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105320127323309713)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105999044281310270)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105998968396310269)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C9C0\C815\D560 \D398\C774\C9C0 \BC88\D638 \B610\B294 URL\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105998816316310269)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105319618687309713)
,p_name=>'PE.PROPERTY.BRANCH_POINT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B80C\B354\B9C1 \B610\B294 \CC98\B9AC \C2DC \C774 \BD84\AE30\AC00 \C2E4\D589\B418\B294 \C2DC\C810\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105741585893310064)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC \D6C4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106031173419310301)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC: \CC98\B9AC\AC00 \C218\D589\B41C \D6C4 \BD84\AE30\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105741298970310064)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C \D6C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106030887437310300)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC: \D398\C774\C9C0\B97C \C81C\CD9C\D55C \D6C4 \ACC4\C0B0, \AC80\C99D \BC0F \D504\B85C\C138\C2A4\AC00 \C2E4\D589\B418\AE30 \C804 \BD84\AE30\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105741693752310064)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106031231716310301)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1: \D398\C774\C9C0\AC00 \B80C\B354\B9C1\B418\AE30 \C804 \BD84\AE30\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105741437713310064)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106031056811310300)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC: \CC98\B9AC\AC00 \C218\D589\B418\AE30 \C804 \BD84\AE30\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105741352714310064)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106030929172310300)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC: \AC80\C99D\C774 \C218\D589\B418\AE30 \C804 \BD84\AE30\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105319575732309712)
,p_name=>'PE.PROPERTY.BRANCH_POINT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C810')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105999705917310270)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C9C0\C815\D560 \D398\C774\C9C0 \BC88\D638 \B610\B294 URL\C744 \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105999670726310270)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105319452001309712)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C218\D589\D560 \D398\C774\C9C0 \BD84\AE30 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
'<dl>',
unistr('<dt>\BD84\AE30 \C7AC\C9C0\C815</dt>'),
unistr('<dd>&PRODUCT_NAME.\C774(\AC00) \BE0C\B77C\C6B0\C800\C5D0 \C0C8 \D398\C774\C9C0 \B610\B294 URL\C744 \BC18\D658\D558\C5EC, \ACB0\ACFC \D398\C774\C9C0\B97C \D45C\C2DC\D558\AE30 \C804\C5D0 \C0C8 \C694\CCAD\C744 \C218\D589\D569\B2C8\B2E4.'),
unistr('\C774 \BC29\BC95\C758 \C8FC\C694 \C774\C810\C740 \BE0C\B77C\C6B0\C800 \C8FC\C18C\C5D0 \C804\CCB4 \D398\C774\C9C0 URL\C774 \D3EC\D568\B418\AE30 \B54C\BB38\C5D0 \C77C\BC18 \C0AC\C6A9\C790\AC00 \CEE8\D14D\C2A4\D2B8\B97C \C783\C9C0 \C54A\ACE0\B3C4 \D398\C774\C9C0\B97C \C0C8\B85C\ACE0\CE68\D560 \C218 \C788\B2E4\B294 \AC83\C785\B2C8\B2E4.'),
unistr('\B2E8\C810\C740 \D398\C774\C9C0\B97C \D45C\C2DC\D558\AE30 \C704\D574 \BE0C\B77C\C6B0\C800\AC00 \CD94\AC00 \C694\CCAD\C744 \C218\D589\D55C\B2E4\B294 \AC83\C785\B2C8\B2E4.</dd>'),
unistr('<dt>\BD84\AE30\B9CC \D45C\C2DC</dt>'),
unistr('<dd>&PRODUCT_NAME.\C774(\AC00) \B2E4\B978 \C694\CCAD\C744 \C218\D589\D558\C9C0 \C54A\ACE0 \D604\C7AC \D398\C774\C9C0 \CC98\B9AC \C911\C5D0 \C0C8 \D398\C774\C9C0\B97C \C989\C2DC \B80C\B354\B9C1\D569\B2C8\B2E4.'),
unistr('\C774 \BC29\BC95\C758 \C774\C810\C740 \BE0C\B77C\C6B0\C800\AC00 \CD94\AC00 \C694\CCAD\C744 \C218\D589\D560 \D544\C694\AC00 \C5C6\B2E4\B294 \AC83\C785\B2C8\B2E4.'),
unistr('\C8FC\C694 \B2E8\C810\C740 \BE0C\B77C\C6B0\C800 \C8FC\C18C\AC00 <code>wwv_flow.accept</code> \D615\D0DC\AC00 \B41C\B2E4\B294 \AC83\C785\B2C8\B2E4.'),
unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \D398\C774\C9C0\B97C \C0C8\B85C\ACE0\CE68\D558\BA74 \BE0C\B77C\C6B0\C800 \C8FC\C18C\AC00 \C804\CCB4 \D398\C774\C9C0 URL\C774 \C544\B2C8\AE30 \B54C\BB38\C5D0 \BE0C\B77C\C6B0\C800\C5D0\C11C \B370\C774\D130 \C7AC\C804\C1A1\C744 \C694\CCAD\D569\B2C8\B2E4.</dd>'),
'</dl>',
unistr('<p>Oracle\C740 \BCF4\B2E4 \D6A8\C728\C801\C778 \C77C\BC18 \C0AC\C6A9\C790 \D658\ACBD\C744 \C81C\ACF5\D558\AE30 \C704\D574 \BD84\AE30 \C7AC\C9C0\C815 \C720\D615 \C911 \D558\B098\B97C \C120\D0DD\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105740699018310063)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_PAGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC18\D658 \D568\C218(\D45C\C2DC \C804\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105740797529310063)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_URL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('URL \BC18\D658 \D568\C218(\C7AC\C9C0\C815)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105741126652310064)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_ACCEPT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \CC98\B9AC{\C77C\BC18\C801\C774\C9C0 \C54A\C74C}')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105740991072310063)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_IDENT_BY_ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\BCC4 \C2DD\BCC4 \D398\C774\C9C0(\D45C\C2DC \C804\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105740571796310063)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_STEP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0(\D45C\C2DC \C804\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105741089745310064)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_URL_IDENT_BY_ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\BCC4 \C2DD\BCC4 URL(\C7AC\C9C0\C815)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105740800047310063)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D504\B85C\C2DC\C800[\B808\AC70\C2DC]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105740448558310063)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B610\B294 URL(\C7AC\C9C0\C815)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105319336703309712)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104857650657309360)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C774\B3D9 \ACBD\B85C\C5D0 \C0AC\C6A9\B41C \C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104857502890309360)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105585752927309930)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \D589\C744 \D45C\C2DC\D560 \B54C \AD6C\BD84 \C5F4 \B4A4\C5D0 \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105585613288309930)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105585336287309930)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \D589\C744 \D45C\C2DC\D560 \B54C \AD6C\BD84 \C5F4 \C55E\C5D0 \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105585299957309930)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105596015520309939)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105597231106309939)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105584519931309930)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \C11C\C2DD\C5D0 \C0AC\C6A9\B418\B294 \BCF4\ACE0\C11C \C5F4 \C218\B97C \C120\D0DD\D569\B2C8\B2E4. \C5F4\C740 \BCF4\ACE0\C11C\C5D0 \D45C\C2DC\B41C \CCAB\BC88\C9F8 \C5F4\BD80\D130 \C2DC\C791\D574\C11C \C5F0\C18D\C801\C778 \C5F4\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105763528354310081)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105763637048310081)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8 \BC0F \B450\BC88\C9F8 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105763702657310081)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2:3.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8, \B450\BC88\C9F8 \BC0F \C138\BC88\C9F8 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105584442015309929)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105584726197309930)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C758 \D45C\C2DC\AC04 \D615\C2DD\C5D0 \C601\D5A5\C744 \C8FC\B294 \AD6C\BD84 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105764022063310081)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \AD6C\BD84 \C11C\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105764139256310081)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01 \AD6C\BD84\C120\C5D0 \B300\D55C \C81C\BAA9\C744 \BC18\BCF5\D558\C9C0 \C54A\B294 \B2E8\C77C \BCF4\ACE0\C11C\C5D0 \AD6C\BD84\C120\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105763881160310081)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AD6C\BD84 \C2DC \BA38\B9AC\AE00 \BC18\BCF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105763907697310081)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\B294 \AC01 \AD6C\BD84\C120\C5D0 \B300\D574 \BC18\BCF5\B418\B294 \C81C\BAA9\C744 \D3EC\D568\D558\B294 \C5EC\B7EC \AC1C\C758 \D558\C704 \BCF4\ACE0\C11C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105584652688309930)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105585155429309930)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \AD6C\BD84\C5D0 \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. <code>#SUM_COLUMN_HEADER#</code> \B300\CCB4 \D56D\BAA9\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105585000888309930)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \AD6C\BD84 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105585533715309930)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \AD6C\BD84\C744 \D45C\C2DC\D560 \B54C \AD6C\BD84 \C5F4\C5D0 \B300\D55C \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. <code>#COLUMN_VALUE#</code> \B300\CCB4 \D56D\BAA9\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105585474851309930)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AD6C\BD84 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105584952197309930)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \AD6C\BD84\C744 \C704\D574 \D45C\C2DC\B418\B294 \BC18\BCF5 \BA38\B9AC\AE00\C5D0 \B300\D55C \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. <code>#COLUMN_VALUE#</code> \B300\CCB4 \D56D\BAA9\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105584855743309930)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\BCF5 \BA38\B9AC\AE00 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105595235473309938)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106036389764310306)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BCF4\C548 \C18D\C131\C5D0 \C815\C758\B41C \C124\C815\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105220428778309637)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CE90\C2DC\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0 \BE0C\B77C\C6B0\C800\AC00 \CE90\C2DC(\BA54\BAA8\B9AC \BC0F \B514\C2A4\D06C)\C5D0 \C560\D50C\B9AC\CF00\C774\C158 \D398\C774\C9C0\C758 \CF58\D150\CE20\B97C \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C0AC\C6A9\C790\AC00 \BE0C\B77C\C6B0\C800\C5D0\C11C \B4A4\B85C \B2E8\CD94\B97C \B204\B974\BA74 \D398\C774\C9C0\AC00 \C11C\BC84\C5D0\C11C \B85C\B4DC\B418\C9C0 \C54A\ACE0 \C77C\BC18\C801\C73C\B85C \CE90\C2DC\C5D0\C11C \B85C\B4DC\B429\B2C8\B2E4.'),
unistr('\CE90\C2DC\AC00 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B418\BA74 \BE0C\B77C\C6B0\C800\AC00 \D398\C774\C9C0 \CF58\D150\CE20\B97C \C800\C7A5\D558\C9C0 \C54A\B3C4\B85D \C9C0\C815\B418\ACE0, \BE0C\B77C\C6B0\C800\AC00 \C11C\BC84\C5D0\C11C \D398\C774\C9C0\B97C \C0C8\B85C \C694\CCAD\D569\B2C8\B2E4.</p>'),
unistr('<p>Oracle\C740 \BCF4\C548 \AD00\C810\C5D0\C11C \CE90\C2DC\B97C \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D574\C11C \BE0C\B77C\C6B0\C800\AC00 \BBFC\AC10\D55C \B370\C774\D130\B97C \C800\C7A5\D558\C9C0 \C54A\ACE0 URL\C774 \BCC0\ACBD\B420 \ACBD\C6B0 \D56D\C0C1 \D398\C774\C9C0\B97C \C694\CCAD\D558\B3C4\B85D \D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.'),
unistr('\ADF8\B807\C9C0 \C54A\C73C\BA74 \B85C\ADF8\C544\C6C3\D55C \D6C4\C5D0\B3C4 \BE0C\B77C\C6B0\C800 \B0B4\C5ED\C5D0\C11C \B4A4\B85C \C774\B3D9\D558\C5EC \C774\C804 \C138\C158\C5D0\C11C \CE90\C2DC\C5D0 \C800\C7A5\B41C \CF58\D150\CE20\B97C \D655\C778\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('\BE0C\B77C\C6B0\C800 \CE90\C2DC\B97C \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D558\BA74 \B300\D654\C2DD \BCF4\ACE0\C11C\C640 \AC19\C774 \BD80\BD84 \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68\C744 \C0AC\C6A9\D558\B294 \D398\C774\C9C0\C640 \AD00\B828\D574\C11C \CC3E\AE30 \C5B4\B824\C6B4 \B4A4\B85C \B2E8\CD94 \BB38\C81C\B97C \BC29\C9C0\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C18D\C131\C774 <strong>\C0AC\C6A9 \C548\D568</strong>\C73C\B85C \C124\C815\B418\C5B4 \C788\B294 \ACBD\C6B0 &PRODUCT_NAME.\C740(\B294) \D398\C774\C9C0 \CF58\D150\CE20\B97C \B514\C2A4\D06C \B610\B294 \BA54\BAA8\B9AC\C758 \CE90\C2DC\C5D0 \C800\C7A5\D558\C9C0 \C54A\B3C4\B85D \BE0C\B77C\C6B0\C800\C5D0 \C9C0\C815\D558\B294 HTTP \D5E4\B354 <em>cache-control: no-store</em>\B97C \C804\C1A1\D569\B2C8\B2E4.'),
unistr('<strong>\C560\D50C\B9AC\CF00\C774\C158 \AE30\BCF8\AC12</strong>\C73C\B85C \C124\C815\B41C \ACBD\C6B0, \C560\D50C\B9AC\CF00\C774\C158\C758 <em>\BE0C\B77C\C6B0\C800 \CE90\C2DC</em> \C18D\C131\C5D0\C11C \B7F0\D0C0\C784\C5D0 \AC12\C744 \AC00\C838\C635\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C774 \AE30\B2A5\C744 \C0AC\C6A9\D558\B824\BA74 HTTP \D5E4\B354 \C751\B2F5 \BCC0\C218\C778 <code>cache-control</code>\C744 \C9C0\C6D0\D558\B294 \CD5C\C2E0 \BE0C\B77C\C6B0\C800\AC00 \D544\C694\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105723678505310050)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105723588525310050)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105220383819309637)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE0C\B77C\C6B0\C800 \CE90\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106105275721310370)
,p_name=>'PE.PROPERTY.BUILD_OPTION.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>1. \B9CE\C740 \C124\CE58\B97C \D3EC\D568\D560 \C560\D50C\B9AC\CF00\C774\C158\C744 \AC1C\BC1C\D558\ACE0 \C788\C2B5\B2C8\B2E4.'),
unistr('                                        \B610\D55C \AC01 \C124\CE58\C5D0\C11C\B294 \D2B9\C815 \C560\D50C\B9AC\CF00\C774\C158 \AE30\B2A5\C744 \C0AC\C6A9 \B610\B294 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('                                        \BE4C\B4DC \C635\C158\C744 \C0AC\C6A9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C744 \AC1C\BC1C\D560 \C218 \C788\C2B5\B2C8\B2E4. \C124\CE58\B41C \ACBD\C6B0 \C5F0\ACB0\B41C \C560\D50C\B9AC\CF00\C774\C158 \AE30\B2A5\C744 \D3EC\D568\D558\AC70\B098 \C81C\C678\D558\B3C4\B85D \BE4C\B4DC \C635\C158\C744 \AD6C\C131\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('                                        API\B97C \C0AC\C6A9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0\C11C \C774 \AE30\B2A5\C744 \B178\CD9C\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('                                        \ADF8\B7EC\BA74 \AD8C\D55C\C744 \AC00\C9C4 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158 \AE30\B2A5\C744 \C120\D0DD\C801\C73C\B85C \C0AC\C6A9 \B610\B294 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('                                      <p>2. \AE30\B2A5\C744 \AC1C\BC1C\D558\ACE0 \C788\C9C0\B9CC \C544\C9C1 \C644\C131\B418\C9C0 \C54A\C544\C11C \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \B178\CD9C\D558\C9C0 \C54A\C73C\B824\ACE0 \D569\B2C8\B2E4.'),
unistr('									    \BE4C\B4DC \C635\C158\C744 \C0AC\C6A9\D558\BA74 \D14C\C2A4\D2B8 \BC0F \C6B4\C6A9 \D658\ACBD\C5D0\C11C \C791\C131\B418\B294 \ACBD\C6B0\C5D0 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C774 \AE30\B2A5\C744 \C0AC\C6A9\D558\C9C0 \C54A\B3C4\B85D \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('									    \C774 \BC29\BC95\C740 \C644\C131\B418\C9C0 \C54A\C740 \AE30\B2A5\C744 \D3EC\D568\D558\C9C0 \C54A\ACE0\B3C4 \C560\D50C\B9AC\CF00\C774\C158\C744 \BC30\CE58\D560 \C218 \C788\B2E4\B294 \C774\C810\C774 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('                                      <p>3. \C560\D50C\B9AC\CF00\C774\C158\C5D0 \D544\C694\D558\C9C0 \C54A\B2E4\ACE0 \C0DD\AC01\B418\B294 \AE30\B2A5\C744 \C81C\AC70\D558\B824\ACE0 \D558\C9C0\B9CC \C774\B807\AC8C \D574\B3C4 \C548\C804\D55C\C9C0 \D655\C2E4\D558\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('									    \C774 \ACBD\C6B0 \BE4C\B4DC \C635\C158\C744 \C0AC\C6A9\D558\C5EC \D2B9\C815 \AE30\B2A5\C744 "\C8FC\C11D \CC98\B9AC"\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('									    \BC30\D3EC\D560 \B54C \C81C\AC70\B41C \AE30\B2A5\C774 \D544\C694\D560 \ACBD\C6B0 \D574\B2F9 \AE30\B2A5\C744 \BCF5\C6D0\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('									    \C774 \AE30\B2A5\C774 \D544\C694\D558\C9C0 \C54A\C744 \ACBD\C6B0 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C548\C804\D558\AC8C \C81C\AC70\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105220682603309637)
,p_name=>'PE.PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \BE4C\B4DC \C635\C158\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('                                     <p>\BE4C\B4DC \C635\C158\C744 \C0AC\C6A9\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C744 \C124\CE58\D560 \B54C \B610\B294 API\B97C \D1B5\D574 \B7F0\D0C0\C784\C5D0 \C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\C694\C18C \BC0F \AE30\B2A5\C744 \C870\AC74\BD80\B85C \C0AC\C6A9 \B610\B294 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4(APEX_UTIL.SET_BUILD_OPTION_STATUS).<br>'),
unistr('                                       \BE4C\B4DC \C635\C158\C740 \B7F0\D0C0\C784 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C774 \AD6C\C131\C694\C18C\B97C \D3EC\D568 \B610\B294 \C81C\C678\B85C \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('									 <p><strong>\D3EC\D568</strong> - \C0AC\C6A9\C73C\B85C \C124\C815\D558\BA70 \C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BD80\C785\B2C8\B2E4.</p>'),
unistr('									 <p><strong>\C81C\C678</strong> - \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BD80\AC00 \C544\B2D9\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105220529991309637)
,p_name=>'PE.PROPERTY.BUILD_OPTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105209197085309628)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \BE4C\B4DC \C635\C158 \C0C1\D0DC\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105717577469310046)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C678')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105717688972310046)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('&PRODUCT_NAME. \C5D4\C9C4\C740 \C774 \AD6C\C131\C694\C18C\AC00 \C874\C7AC\D558\C9C0 \C54A\B294 \AC83\C73C\B85C \AC04\C8FC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105717337421310046)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105717495512310046)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('&PRODUCT_NAME. \C5D4\C9C4\C740 \B7F0\D0C0\C784\C5D0 \C774 \AD6C\C131\C694\C18C\B97C \C560\D50C\B9AC\CF00\C774\C158 \C815\C758\C758 \C77C\BD80\B85C \AC04\C8FC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105209031078309628)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105322790503309715)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD94\B97C \B204\B97C \B54C \C218\D589\D560 \C791\C5C5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105743333791310065)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5\C5D0 \C758\D574 \C815\C758\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105743413178310065)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B97C \C81C\CD9C\D558\C9C0 \C54A\AC70\B098 \B2E4\B978 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \B300\C2E0 \B2E8\CD94\C758 \B3D9\C791\C774 \B3D9\C801 \C791\C5C5\C5D0 \C758\D574 \C815\C758\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105743778445310066)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105743855214310066)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \D398\C774\C9C0\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105743926898310066)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105744084178310066)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105742960824310065)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105743048138310065)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0 \B9E4\AE40 \C7AC\C124\C815, \C694\CCAD \AC12 \C124\C815, \CE90\C2DC \BE44\C6B0\AE30 \BC0F \D56D\BAA9 \AC12 \C124\C815\C5D0 \B300\D55C \C120\D0DD\C801\C778 \CD94\AC00 \C18D\C131\ACFC \D568\AED8 \B300\C0C1 \D398\C774\C9C0\C5D0\C11C \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\D558\AE30 \C704\D574\C11C\B294 \B300\C0C1 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \B525 \B9C1\D06C\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4. \B525 \B9C1\D06C\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D558\B824\BA74 \C560\D50C\B9AC\CF00\C774\C158\C758 <em>\BCF4\C548</em> \C18D\C131\C73C\B85C \C774\B3D9\D558\C5EC <em>\B525 \B9C1\D06C</em>\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105742743367310065)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105742876062310065)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C7AC\C124\C815, \C694\CCAD \AC12 \C124\C815, \CE90\C2DC \BE44\C6B0\AE30 \BC0F \D56D\BAA9 \AC12 \C124\C815\C5D0 \B300\D55C \C120\D0DD\C801\C778 \CD94\AC00 \C18D\C131\ACFC \D568\AED8 \B300\C0C1 \D398\C774\C9C0\C5D0\C11C \D604\C7AC \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105743102920310065)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('URL\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105743222074310065)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\D55C \B300\C0C1 URL\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105743535188310065)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105743611179310066)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('PPR(\BD80\BD84 \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68)\C774 \C544\B2CC \C804\CCB4 \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68\C744 \C218\D589\D574\C11C \D398\C774\C9C0\B97C \C7AC\C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105742508923310065)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105742696991310065)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C774\B984\ACFC \B3D9\C77C\D55C REQUEST \AC12\C73C\B85C \D604\C7AC \D398\C774\C9C0\B97C \C81C\CD9C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105322685490309715)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105226006764309641)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \B2E8\CD94\B97C \B20C\B7EC\C11C \C218\D589\B418\B294 SQL \C791\C5C5\C758 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C774 \C120\D0DD\C0AC\D56D\C740 \B0B4\C7A5\B41C \C790\B3D9 \D589 \D504\B85C\C138\C2F1(DML) \B0B4\C5D0\C11C \C9C0\C815\B41C \B370\C774\D130\BCA0\C774\C2A4 \C791\C5C5\C744 \D2B8\B9AC\AC70\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.'),
unistr('\C720\D615\C744 \C120\D0DD\D558\C9C0 \C54A\C73C\BA74 \C774 \B2E8\CD94\C5D0 \B300\D574 \C815\C758\B41C <strong>\B2E8\CD94 \C774\B984</strong>\C744 \AE30\C900\C73C\B85C \C124\C815\B418\B294 REQUEST \AC12\C5D0 \B530\B77C \B370\C774\D130\BCA0\C774\C2A4 \CC98\B9AC\AC00 \C2E4\D589\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105737591189310061)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.DELETE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL DELETE \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105737376707310061)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.INSERT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL INSERT \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105737411317310061)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.UPDATE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL UPDATE \C791\C5C5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105225951152309641)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105920784474310200)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD94\C758 \BAA8\C591\C744 \C815\C758\D560 \B2E8\CD94 \D45C\C2DC \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105921041133310200)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105921118062310200)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58\B9CC \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105920838056310200)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105920901994310200)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \B808\C774\BE14\B9CC \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105921225774310200)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\C640 \C544\C774\CF58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105921372413310200)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \B808\C774\BE14 \C606\C5D0 \C544\C774\CF58\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105920629878310200)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106022542666310292)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B77C\B514\C624 \ADF8\B8F9 \B610\B294 \CCB4\D06C\BC15\C2A4 \C9D1\D569\C5D0 \AC1C\BCC4 \C635\C158\C744 \D45C\C2DC\D558\B294 HTML \D14C\C774\BE14 \C140 \B2E4\C74C\C5D0 \D45C\C2DC\B418\B294 \CD94\AC00 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('HTML, JavaScript \BC0F \BC14\B85C\AC00\AE30\B97C \D3EC\D568\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \B300\CCB4 \BB38\C790\C5F4\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\C774 \D398\C774\C9C0 \D56D\BAA9\C774 \C5F0\AD00\B41C HTML \D3FC \C694\C18C\C758 \C774\B984\C744 \AC00\C838\C635\B2C8\B2E4.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\D604\C7AC \D398\C774\C9C0 \D56D\BAA9\C758 \C774\B984\C744 \AC00\C838\C635\B2C8\B2E4.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106022447830310292)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\D6C4 \D14D\C2A4\D2B8 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106022317169310292)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B77C\B514\C624 \ADF8\B8F9 \B610\B294 \CCB4\D06C\BC15\C2A4 \C9D1\D569\C5D0 \AC1C\BCC4 \C635\C158\C744 \D45C\C2DC\D558\B294 HTML \D14C\C774\BE14 \C140 \C774\C804\C5D0 \D45C\C2DC\B418\B294 \CD94\AC00 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('HTML, JavaScript \BC0F \BC14\B85C\AC00\AE30\B97C \D3EC\D568\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \B300\CCB4 \BB38\C790\C5F4\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\C774 \D398\C774\C9C0 \D56D\BAA9\C774 \C5F0\AD00\B41C HTML \D3FC \C694\C18C\C758 \C774\B984\C744 \AC00\C838\C635\B2C8\B2E4.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\D604\C7AC \D398\C774\C9C0 \D56D\BAA9\C758 \C774\B984\C744 \AC00\C838\C635\B2C8\B2E4.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106022270452310292)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105225866390309641)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0\AC00 \C81C\CD9C\B418\ACE0 \C774 \C18D\C131\C774 <strong>\C124\C815</strong>\C73C\B85C \C124\C815\B418\BA74 \D398\C774\C9C0\C5D0 \B300\D574 \C815\C758\B41C \BAA8\B4E0 \AC80\C99D \BC0F \B0B4\C7A5\B41C \AC80\C99D\C774 \C11C\BC84\CE21\C5D0\C11C \C2E4\D589\B429\B2C8\B2E4(\C608: \D544\C218, \C801\D569\D55C \BC88\D638 \B610\B294 \C801\D569\D55C \B0A0\C9DC).'),
unistr('\B610\D55C \C560\D50C\B9AC\CF00\C774\C158\C758 <em>\D638\D658\C131 \BAA8\B4DC</em>\AC00 <strong>5.1</strong> \C774\C0C1\C73C\B85C \C124\C815\B418\B294 \ACBD\C6B0 &PRODUCT_NAME.\C740(\B294) \D074\B77C\C774\C5B8\D2B8\CE21 \AC80\C99D\B3C4 \C218\D589\D569\B2C8\B2E4(\C608: \D56D\BAA9 \D544\C694). \C790\C138\D55C \B0B4\C6A9\C740 \B9B4\B9AC\C2A4 \B178\D2B8\C758 "\D638\D658\C131 \BAA8\B4DC"\B97C \CC38\C870\D558\C2ED\C2DC\C624.'),
unistr('\BAA8\B4E0 \BB38\C81C\AC00 \D574\ACB0\B420 \B54C\AE4C\C9C0 \D398\C774\C9C0\AC00 \C81C\CD9C\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
unistr('<p><strong>\D574\C81C</strong>\B85C \C124\C815\D560 \ACBD\C6B0 \C815\C758\B41C \AC80\C99D \B610\B294 \B0B4\C7A5\B41C \AC80\C99D\C774 \C2E4\D589\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('\C774 \C124\C815\ACFC \BCC4\AC1C\B85C \C2E4\D589\D560 \D2B9\C815 \AC80\C99D\C774 \C788\C73C\BA74 \D574\B2F9 \AC80\C99D\C744 \C218\C815\D558\ACE0 \AC80\C99D \C18D\C131 <strong>\D56D\C0C1 \C2E4\D589</strong>\C744 <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C18D\C131\C740 \AC80\C99D\C744 \B300\BD80\BD84 \C2E4\D589\D558\C9C0 \C54A\C544\C57C \D558\B294 \C0AD\C81C \B610\B294 \CDE8\C18C\C640 \AC19\C740 \B2E8\CD94\C5D0 \D2B9\D788 \C720\C6A9\D569\B2C8\B2E4.'),
unistr('\D56D\BAA9\C774 \B110\C774\AC70\B098 \C798\BABB\B41C \C720\D615\C778 \ACBD\C6B0\C5D0\B294 \C77C\BC18\C801\C73C\B85C \C0AC\C6A9\C790\AC00 \C774\B7EC\D55C \C791\C5C5\C744 \C218\D589\D560 \C218 \C5C6\B3C4\B85D \CC28\B2E8\B418\C5B4\C11C\B294 \C548\B429\B2C8\B2E4.'),
unistr('\D558\C9C0\B9CC \C0AD\C81C\C640 \AC19\C740 \C791\C5C5\C744 \AD8C\D55C\C774 \BD80\C5EC\B41C \C0AC\C6A9\C790\B9CC \C218\D589\D574\C57C \D560 \ACBD\C6B0\C5D0\B294 \D574\B2F9 \AC80\C99D \C18D\C131 <strong>\D56D\C0C1 \C2E4\D589</strong>\C744 <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D558\AC70\B098 \AD8C\D55C\C774 \BD80\C5EC\B41C \C0AC\C6A9\C790\C5D0\AC8C\B9CC \B2E8\CD94\AC00 \D45C\C2DC\B418\B3C4\B85D \B2E8\CD94 \C790\CCB4\C5D0 \C801\D569\D55C \C870\AC74\C774 \C815\C758\B418\C5B4 \C788\B294\C9C0 \D655\C778\D558\B294 \AC83\C774 \C911\C694\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105225763405309641)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105922126808310201)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD94\B97C \B80C\B354\B9C1\D560 \B54C <strong>\C77C\BC18</strong> \B2E8\CD94\B97C \C0AC\C6A9\D560\C9C0 \C544\B2C8\BA74 <strong>\D56B</strong> \B2E8\CD94\B97C \C0AC\C6A9\D560\C9C0 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105225475596309640)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD94\B97C \B80C\B354\B9C1\D560 \B54C <strong>\C77C\BC18</strong> \B610\B294 <strong>\D56B</strong> \B2E8\CD94 \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D560\C9C0\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105225333456309640)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105921908828310201)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94\C5D0 \D45C\C2DC\B420 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \B2E8\CD94 \D45C\C2DC \C720\D615\C774 \C544\C774\CF58\C778 \ACBD\C6B0 \C774 \D14D\C2A4\D2B8\AC00 \C544\C774\CF58 \C774\BBF8\C9C0\C5D0 \B300\D55C ALT \D14D\C2A4\D2B8\B85C \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105238701990309650)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94\AC00 \D14D\C2A4\D2B8\C774\BA74 \B2E8\CD94\C5D0 \D45C\C2DC\D560 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \B2E8\CD94\AC00 \C774\BBF8\C9C0\C774\BA74 \C774 \D14D\C2A4\D2B8\AC00 \C774\BBF8\C9C0\C5D0 \B300\D55C ALT \D14D\C2A4\D2B8\B85C \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105238691816309650)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105249685292309658)
,p_name=>'PE.PROPERTY.BUTTON_NAME.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B20C\B9B0 \C0C1\D0DC\C758 \B2E8\CD94\B97C \CC38\C870\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774 \D398\C774\C9C0\AC00 \C81C\CD9C\B418\BA74 REQUEST\C758 \AC12\C774 \C774 \B2E8\CD94 \C774\B984\C73C\B85C \C124\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105238554708309650)
,p_name=>'PE.PROPERTY.BUTTON_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D6C4\C18D \D398\C774\C9C0 \CC98\B9AC \B0B4\C5D0 \C774 \B2E8\CD94\B97C \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\D398\C774\C9C0\AC00 \C81C\CD9C\B420 \B54C \C774 \B2E8\CD94\B97C \B204\B974\BA74 REQUEST \AC12\C774 \C785\B825\B41C \C774\B984\C73C\B85C \C124\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>\B3D9\C77C \D398\C774\C9C0 \B610\B294 \B3D9\C77C \C601\C5ED\C5D0 \C788\B294 \B2E8\CD94\C758 \ACBD\C6B0 \B2E8\CD94 \C774\B984\C740 \ACE0\C720\D560 \D544\C694\AC00 \C5C6\C2B5\B2C8\B2E4.'),
unistr('\B20C\B800\C744 \B54C \B3D9\C77C\D55C REQUEST \AC12\C744 \C124\C815\D558\B294, \B3D9\C77C\D55C \C774\B984\C758 \B2E8\CD94\B97C \C5EC\B7EC \AC1C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774 \AE30\B2A5\C740 \B2E8\C21C\D788 \ACF5\D1B5 REQUEST \AC12\C744 \D3C9\AC00\D558\C5EC \B3D9\C77C\D55C \D398\C774\C9C0 \CC98\B9AC\B97C \C2E4\D589\D574\C57C \D558\B294 \C11C\B85C \B2E4\B978 <strong>\B2E8\CD94 \B808\C774\BE14</strong> \B610\B294 \C870\AC74\C744 \C0AC\C6A9\D574\C11C \B2E8\CD94\B97C \C815\C758\D560 \B54C \C720\C6A9\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E8\CD94 \C774\B984\C744 <code>FLOW_RESET_BUTTON</code>\C73C\B85C \C9C0\C815\D558\BA74 \D398\C774\C9C0 \C81C\CD9C\C744 \C218\D589\D558\C9C0 \C54A\ACE0\B3C4 \B2E8\CD94\AC00 \D604\C7AC \D398\C774\C9C0\B97C \C7AC\C124\C815\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105238469192309650)
,p_name=>'PE.PROPERTY.BUTTON_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106021946695310291)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD94\B97C \B204\B974\BA74 \D398\C774\C9C0\AC00 \C81C\CD9C\B418\ACE0 \D398\C774\C9C0 \C694\CCAD\C774 \C774 \AC12\C73C\B85C \C124\C815\B429\B2C8\B2E4. \C774 \AC12\C774 \B110\C774\ACE0 <em>\C694\CCAD \C18C\C2A4 \C720\D615</em>\C774 <em>\C815\C801 \AC12</em>\C774\BA74 \B2E8\CD94 \C774\B984\C774 \C694\CCAD \AC12\C73C\B85C \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106021832386310291)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106019810867310289)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD \C18C\C2A4 \C720\D615\C740 \C694\CCAD \C18C\C2A4 \C18D\C131\C5D0 \D3EC\D568\B41C \D45C\D604\C2DD\C758 \C720\D615\C744 \C2DD\BCC4\D569\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106021604857310291)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106021765182310291)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110\B85C \C124\C815.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106020139456310290)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106020277566310290)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\B370\C774\D130\BCA0\C774\C2A4 \C5F4</em>\C5D0 \C785\B825\B41C \C5F4 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4. \C774 \AC12\C740 \B0B4\C7A5 \D589 \C778\CD9C \D504\B85C\C138\C2A4\C5D0\C11C \AC80\C0C9\B41C \AC12\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106021027191310291)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106021171263310291)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>PL/SQL \D45C\D604\C2DD</em> \C2E4\D589 \ACB0\ACFC \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106021283759310291)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106021341432310291)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>PL/SQL \D568\C218 \BCF8\BB38</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106020320200310290)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106020511589310290)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106021439910310291)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106021545669310291)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>\D658\ACBD\C124\C815</em>\C758 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106020676231310290)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758(\B2E8\C77C \AC12 \BC18\D658)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106020779675310290)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>SQL \C9C8\C758</em>\C5D0\C11C \BC18\D658\B41C \CCAB\BC88\C9F8 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106020811436310290)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758(\CF5C\B860\C73C\B85C \AD6C\BD84\B41C \AC12 \BC18\D658)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106020926991310290)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>SQL \C9C8\C758</em>\C5D0\C11C \BC18\D658\B41C \B2E8\C77C \AC12(\AC01 \D589 \AC12\C744 \CF5C\B860\C73C\B85C \AD6C\BD84\D558\C5EC \C5F0\ACB0\D55C \AC12)\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106019946268310289)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106020018991310290)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\C815\C801 \AC12</em>\C5D0 \C785\B825\B41C \D14D\C2A4\D2B8\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106019771903310289)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD \C18C\C2A4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105225620604309641)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B2EC \B300\D654\C0C1\C790\B97C \D638\CD9C\D558\AE30 \C704\D55C \B300\C0C1\C744 \B204\B985\B2C8\B2E4. \C774 \B2E8\CD94\B97C \B204\B97C \B54C \D638\CD9C\D560 \B300\C0C1\C744 \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4. \B20C\B800\C744 \B54C \D398\C774\C9C0 \CC98\B9AC\B97C \D638\CD9C\D558\C9C0 \C54A\B294 \B2E8\CD94\C758 \B300\C0C1\B9CC \C785\B825\D558\C2ED\C2DC\C624(\C608: \CDE8\C18C \B2E8\CD94).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105225514177309640)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105225298569309640)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD94\C758 \BAA8\C591\C744 \C815\C758\D560 \B2E8\CD94 \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105225168519309640)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105901453000310185)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105922532987310201)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B808\BCA8\C5D0\C11C \AC80\C0AC\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0 \B2E8\CD94\B97C \B204\B97C \B54C \C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D\C744 \AC80\C0AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105901176712310185)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C5D0 \C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D\C774 \C788\B294\B370 \B2E8\CD94\B97C \B20C\B7EC \D398\C774\C9C0\C5D0\C11C \B098\AC00\B824\ACE0 \D560 \B54C \C0AC\C6A9\C790\C5D0\AC8C \ACBD\ACE0\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105901242873310185)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105903804343310187)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94\B97C \B204\B97C \B54C \C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D \AC80\C0AC\AC00 \C218\D589\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \C774 \C124\C815\C740 \CDE8\C18C, \C0AD\C81C \BC0F \BCC0\ACBD\C0AC\D56D \C801\C6A9 \B2E8\CD94\C5D0 \B300\D574 \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105901024752310185)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D \ACBD\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105951723874310226)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D45C\D604\C2DD\C744 \D3C9\AC00\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105952127298310227)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105952096421310227)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105951992360310226)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105952272356310227)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105951875661310226)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ko'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105951625672310226)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105953737188310228)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105954088890310228)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105953947528310228)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105953849244310228)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105954143941310228)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105953654747310228)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105227237576309642)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105227191215309642)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105228691299309643)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105228580137309643)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105953311152310228)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C Java \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105953262271310227)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105954989516310229)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105954884745310229)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105953114414310227)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105953055661310227)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C JavaScript \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105952988311310227)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105954721382310229)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105954614344310229)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105954506775310228)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105227438659309642)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \CF5C\B860(:)\C73C\B85C \AD6C\BD84\B41C \AC12 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105227309738309642)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105227873031309642)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \D398\C774\C9C0 \BC88\D638\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105227728883309642)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105228084150309642)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \D398\C774\C9C0 \BC88\D638 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105227971115309642)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105952869000310227)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105952748847310227)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105952602292310227)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105954405499310228)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105954339619310228)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105954226971310228)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105227633362309642)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \C9C0\C815\B41C \AC12\ACFC \BE44\AD50\B418\B294 \C0AC\C6A9\C790 \D658\ACBD\C124\C815\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105227595120309642)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105953518214310228)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C Python \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105953418355310228)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105955180445310229)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105955015146310229)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105952579109310227)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \AD00\B9AC\C790\C774\ACE0 \BD80\C11C\AC00 \C2DC\CE74\ACE0\C5D0 \C788\C744 \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105952428906310227)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105952361595310227)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106105770343310370)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\B294\C9C0 \D655\C778\D560 \B54C \D558\B098 \C774\C0C1\C758 \D589\C774 \C874\C7AC\D558\BA74 \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\C9C1\C6D0\C774 \BD80\C11C 40\C5D0 \C18D\D558\B294\C9C0 \D655\C778\D560 \B54C \D589\C774 \C874\C7AC\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105226896665309641)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105226781407309641)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105228208191309642)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \D14D\C2A4\D2B8 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105228170807309642)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105228852557309643)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 <code>&ITEM.</code> \B300\CCB4 \BB38\C790\C5F4\C744 \D3EC\D568\D558\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105228752322309643)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105309265244309704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED\C744 \CE90\C2DC\C5D0 \C800\C7A5\D558\AE30 \C704\D574 \CDA9\C871\B418\C5B4\C57C \D558\B294 \C870\AC74 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105226688640309641)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74\C744 \C9C0\C815\D569\B2C8\B2E4. \C870\AC74\C774 <strong>TRUE</strong>\B97C \BC18\D658\D558\BA74 \D398\C774\C9C0\AC00 \CE90\C2DC\C5D0\C11C \D45C\C2DC\B429\B2C8\B2E4. \C870\AC74\C774 <strong>FALSE</strong>\B97C \BC18\D658\D558\BA74 \D398\C774\C9C0\AC00 \B3D9\C801\C73C\B85C \B80C\B354\B9C1\B418\ACE0 \CE90\C2DC\C5D0\C11C \AC80\C0C9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105791934224310102)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105933410996310213)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\B294 \D56D\C0C1 \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105790523917310101)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 Microsoft Internet Explorer 7.0 \C774\C0C1\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105790685002310101)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 XHTML / CSS \C9C0\C6D0 \BE0C\B77C\C6B0\C800\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105790438720310101)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 Mozilla, Netscape 6.x/7x \C774\C0C1\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105790752321310101)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 \AE30\D0C0 \BE0C\B77C\C6B0\C800(\B610\B294 \C774\C804 \BC84\C804)\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105789138372310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\AC00 \D56D\BAA9\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105791169657310101)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105937027989310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105790862078310101)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4\AC00 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105937227016310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4 \C911 \D558\B098\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105791016154310101)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105937101071310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D558\ACE0 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105790943013310101)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4\AC00 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105937376308310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4 \C911 \D558\B098\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D558\ACE0 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105788373351310099)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 = \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105935810591310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \AC12\ACFC \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105788543381310099)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105936007966310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105788491380310099)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 != \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105935965541310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \AC12\ACFC \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105788697017310099)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105936172790310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105791291168310101)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105791364543310101)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105790042398310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D45C\C2DC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105936891924310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\CD9C \D6C4 \C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D398\C774\C9C0\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105789443952310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105789211563310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\AC00 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105789373631310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\AC00 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105789503644310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105786045854310097)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \BC18\D658\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105933519791310213)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\AC00 \D558\B098 \C774\C0C1\C758 \D589\C744 \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105951400251310226)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105951570902310226)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD\C774 TRUE\B85C \D3C9\AC00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105786203781310098)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105933756600310213)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38\C774 TRUE\B97C \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105791612704310102)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105791748357310102)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105789766456310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0/\C601\C5ED\C774 \C77D\AE30 \C804\C6A9\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105936560144310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B610\B294 \C0C1\C704 \C601\C5ED(\D574\B2F9\D558\B294 \ACBD\C6B0)\C774 \C815\C0C1\C801\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105789647242310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0/\C601\C5ED\C774 \C77D\AE30 \C804\C6A9\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105936440876310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B610\B294 \C0C1\C704 \C601\C5ED(\D574\B2F9\D558\B294 \ACBD\C6B0) \C911 \D558\B098\C785\B2C8\B2E4. ''\C77D\AE30 \C804\C6A9'' \C870\AC74\C740 TRUE\B85C \D3C9\AC00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105787586703310099)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \ACF5\BC31\C744 \D3EC\D568\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105935094583310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \ACF5\BC31\C744 \D3EC\D568\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105787851487310099)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C601\C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105935330529310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BB38\C790 \B610\B294 \C22B\C790\B9CC \D3EC\D568\D558\ACE0 \D2B9\C218 \BB38\C790\B294 \D3EC\D568\D558\C9C0 \C54A\B294 \C601\C22B\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105787052774310098)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105934549657310213)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105787742305310099)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C22B\C790\AC00 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105935280003310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105787202840310098)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 0\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105934727838310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790 0\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105786932326310098)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \B110\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105934475286310213)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105787383012310098)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 NULL \B610\B294 0\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105934874277310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\AC70\B098 \C22B\C790 0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105787639689310099)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105935122877310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105787186770310098)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 0\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105934657924310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790 0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105787451401310099)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 NULL\B3C4 \C544\B2C8\ACE0 0\B3C4 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105934987746310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\C9C0 \C54A\ACE0 \C22B\C790 0\B3C4 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105790236718310101)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BCF4\ACE0\C11C(\C55E\C73C\B85C \B2E8\CD94\B97C \D45C\C2DC\D558\B824\BA74 <b>\D655\C778</b> \B204\B974\AE30)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105790301831310101)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BCF4\ACE0\C11C(\B4A4\B85C \B2E8\CD94\B97C \D45C\C2DC\D558\B824\BA74 <b>\D655\C778</b> \B204\B974\AE30)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105791890084310102)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\C870\AC74 \BD80\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105790112490310101)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D45C\C2DC\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105936944370310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D398\C774\C9C0\C5D0 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105786195262310098)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \BC18\D658\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105933620449310213)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\AC00 \D589\C744 \BC18\D658\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105788958464310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 \C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105936234032310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\B294 \C77C\BC18 \C0AC\C6A9\C790\C5D0 \C758\D574 ''\C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC''\B85C \D1A0\AE00\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105789090780310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\B294 \C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC\AC00 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105936335918310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\B294 \C77C\BC18 \C0AC\C6A9\C790\C5D0 \C758\D574 ''\C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC''\B85C \D1A0\AE00\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105786361731310098)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105933881467310213)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105786553433310098)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\C774 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105934061508310213)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105786425766310098)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105933917424310213)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105786631143310098)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\C774 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105934135556310213)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105791450686310102)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105791539745310102)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105789853673310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C778\C99D\B428(\ACF5\AC1C \C0AC\C6A9\C790\AC00 \C544\B2D8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105936618713310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B85C\ADF8\C778\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105789950210310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \ACF5\AC1C \C0AC\C6A9\C790\C784(\C0AC\C6A9\C790\AC00 \C778\C99D\B418\C9C0 \C54A\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105936721254310215)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B85C\ADF8\C778\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105788157570310099)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D658\ACBD\C124\C815 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105935642833310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\D55C <em>\D658\ACBD\C124\C815</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105788293570310099)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D658\ACBD\C124\C815 != \AC12')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105935726780310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\D55C <em>\D658\ACBD\C124\C815</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105787926937310099)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105935430757310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C644\C804\D788 \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105788040252310099)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105935573398310214)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12 \C77C\BD80\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105786724444310098)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105934270102310213)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105786864230310098)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105934382262310213)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105788858257310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 != \C81C\CD9C\B41C \D398\C774\C9C0(\AC8C\C2DC\B428)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105788773506310100)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 = \C81C\CD9C\B41C \D398\C774\C9C0(\AC8C\C2DC\B428)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105226515730309641)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105227069686309642)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74\ACFC \BE44\AD50\D560 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105226949746309641)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105228441322309643)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 <code>&ITEM.</code> \B300\CCB4 \BB38\C790\C5F4\C744 \D3EC\D568\D558\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105228358258309643)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106046372254310315)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE90\C2DC\B41C \CF58\D150\CE20\AC00 \C885\C18D\B41C \D56D\BAA9\C744 \CF64\B9C8\B85C \AD6C\BD84\D55C \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106046278490310315)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C5D0 \C885\C18D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106040311376310309)
,p_name=>'PE.PROPERTY.CACHE_MODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('&PRODUCT_NAME. \C5D4\C9C4\C774 HTML \D14D\C2A4\D2B8\B97C \C11C\BC84\CE21\C5D0\C11C \CE90\C2DC\C5D0 \C800\C7A5\D560 \C218 \C788\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4. \CE90\C2F1\C744 \C0AC\C6A9\D560 \C218 \C788\C73C\BA74 \B2E4\C2DC \ACC4\C0B0\D558\B294 \B300\C2E0 \CE90\C2DC\C5D0 \C800\C7A5\B41C \ACB0\ACFC\B97C \B0B4\BCF4\B0C5\B2C8\B2E4. \C774\B807\AC8C \D558\BA74 \C11C\BC84\C5D0\C11C \AE34 \ACC4\C0B0 \C2DC\AC04\C744 \C904\C77C \C218 \C788\C2B5\B2C8\B2E4. \C774 \AE30\B2A5\C740 \BE0C\B77C\C6B0\C800\C758 \CE90\C2F1 \AE30\B2A5\ACFC \AD00\B828\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106040643248310310)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106040757684310310)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20\AC00 \CE90\C2DC\B418\C5B4 \BAA8\B4E0 \C0AC\C6A9\C790\C5D0 \C758\D574 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106040453765310309)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106040581263310310)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20\AC00 \CE90\C2DC\B418\C9C0 \C54A\ACE0 \AC01 \C694\CCAD\C5D0 \B300\D574 \ACC4\C0B0\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106041012286310310)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158\BCC4 \CE90\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106041159238310310)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20\AC00 \C138\C158\BCC4\B85C \CE90\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106040836701310310)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\BCC4 \CE90\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106040911665310310)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20\AC00 \C0AC\C6A9\C790\BCC4\B85C \CE90\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106040221133310309)
,p_name=>'PE.PROPERTY.CACHE_MODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE90\C2F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105220224846309637)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE90\C2DC\C5D0 \C800\C7A5\B41C \D398\C774\C9C0\C758 \C720\D6A8 \AE30\AC04\C744 \C120\D0DD\D569\B2C8\B2E4. \C81C\D55C \C2DC\AC04\C774 \B9CC\B8CC\B41C \C774\D6C4\C5D0\B294 \D398\C774\C9C0 \C694\CCAD \C2DC\C5D0 \CE90\C2DC\C5D0 \C800\C7A5\B41C \D398\C774\C9C0\AC00 \C0AC\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105721604180310049)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10.D'
,p_message_language=>'ko'
,p_message_text=>unistr('10\CD08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105722250960310049)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10800.D'
,p_message_language=>'ko'
,p_message_text=>unistr('3\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105723135506310050)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1209600.D'
,p_message_language=>'ko'
,p_message_text=>unistr('2\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105722328947310050)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.14400.D'
,p_message_language=>'ko'
,p_message_text=>unistr('4\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105722793760310050)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.172800.D'
,p_message_language=>'ko'
,p_message_text=>unistr('2\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105721918819310049)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1800.D'
,p_message_language=>'ko'
,p_message_text=>unistr('30\BD84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105722455320310050)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.21600.D'
,p_message_language=>'ko'
,p_message_text=>unistr('6\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105723280947310050)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.2419200.D'
,p_message_language=>'ko'
,p_message_text=>unistr('4\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105722887910310050)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.259200.D'
,p_message_language=>'ko'
,p_message_text=>unistr('3\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105723404539310050)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.31536000.D'
,p_message_language=>'ko'
,p_message_text=>unistr('1\B144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105722905678310050)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.345600.D'
,p_message_language=>'ko'
,p_message_text=>unistr('4\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105722023111310049)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.3600.D'
,p_message_language=>'ko'
,p_message_text=>unistr('1\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105722592736310050)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.43200.D'
,p_message_language=>'ko'
,p_message_text=>unistr('12\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105721799820310049)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.60.D'
,p_message_language=>'ko'
,p_message_text=>unistr('1\BD84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105721801654310049)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.600.D'
,p_message_language=>'ko'
,p_message_text=>unistr('10\BD84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105723005870310050)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.604800.D'
,p_message_language=>'ko'
,p_message_text=>unistr('1\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105723372286310050)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.6048000.D'
,p_message_language=>'ko'
,p_message_text=>unistr('10\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105722179132310049)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.7200.D'
,p_message_language=>'ko'
,p_message_text=>unistr('2\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105722614865310050)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.86400.D'
,p_message_language=>'ko'
,p_message_text=>unistr('1\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105220104993309637)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE90\C2DC \C2DC\AC04 \CD08\ACFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105767276910310083)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C5F4 \AC12 \D45C\C2DC</dt>'),
'<dd><pre>',
'#FIRST_NAME# <strong>#LAST_NAME#</strong>',
'</pre></dd>',
unistr('<dt>\B2EC\B825 \C774\BCA4\D2B8\C5D0 \C774\BBF8\C9C0\B97C \D45C\C2DC\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'&lt;img src="#IMAGE_NAME#"&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105613461767309952)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825 \C140\C5D0 \D45C\C2DC\D560 \C0AC\C6A9\C790\C815\C758 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. HTML \D45C\D604\C2DD\C744 \C785\B825\D558\ACE0 <code>#COLUMN_NAME#</code> \AD6C\BB38\C744 \C0AC\C6A9\D574\C11C \C5F4 \AC12\C744 \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \D45C\C2DC \C720\D615\C744 \C0AC\C6A9\D558\BA74 \D45C\C2DC\C5D0 \C5EC\B7EC \C5F4\C744 \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105613310160309952)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \D45C\C2DC \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105607647029309948)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \B2EC\B825\C758 \C2DC\C791 \B0A0\C9DC\B97C \C800\C7A5\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C774 \D56D\BAA9\C740 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C774\C804 \B610\B294 \B2E4\C74C \AE30\AC04\C73C\B85C \C774\B3D9\D558\B3C4\B85D \C120\D0DD\D560 \B54C &PRODUCT_NAME. \C5D4\C9C4\C5D0 \C758\D574 \C0AC\C6A9\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105607522879309948)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105608204355309948)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825\C5D0 \D45C\C2DC\B418\B294 \AC12\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105766625916310083)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105766763704310083)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>\D45C\C2DC \C5F4</strong> \C18D\C131\C744 \C0AC\C6A9\D574\C11C \B2EC\B825 \C140\C5D0 \D45C\C2DC\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105766859804310083)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105766930104310083)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D45C\D604\C2DD \BC0F \C9C0\C6D0\B418\B294 \B300\CCB4 \BB38\C790\C5F4\C744 \C0AC\C6A9\D574\C11C \C0AC\C6A9\C790\C815\C758 \C5F4 \D615\C2DD\C744 \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105767094429310083)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \AC12 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105767178329310083)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\AC00 \B2EC\B825 \C140\C5D0 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105608159923309948)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105607843986309948)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \B2EC\B825\C758 \C885\B8CC \B0A0\C9DC\B97C \C800\C7A5\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C774 \D56D\BAA9\C740 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C774\C804 \B610\B294 \B2E4\C74C \AE30\AC04\C73C\B85C \C774\B3D9\D558\B3C4\B85D \C120\D0DD\D560 \B54C &PRODUCT_NAME. \C5D4\C9C4\C5D0 \C758\D574 \C0AC\C6A9\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105607780650309948)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105607069879309948)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825\C774 \B80C\B354\B9C1\B420 \B54C \C0AC\C6A9\D560 \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105606967830309947)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105608073795309948)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \B2EC\B825 \C720\D615\C744 \C800\C7A5\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105607987675309948)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105920432405310200)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B2F9 \D45C\C2DC\D560 \CE74\B4DC \C218\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105920356513310199)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B2F9 \CE74\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105919217269310199)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC\C5D0\C11C \B2E8\CD94\AC00 \BC30\CE58\B418\B294 \C704\CE58\B97C \ACB0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105919369315310199)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.PRIMARY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105919404075310199)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.SECONDARY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105919139920310199)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105918079389310198)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CE74\B4DC \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \C791\C5C5\C758 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\B3D9\C77C\D55C \C720\D615\C758 \C5EC\B7EC \C791\C5C5\C744 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4. \B2E8, \B2E8\CD94 \C791\C5C5\B9CC \C5EC\B7EC \BC88 \B80C\B354\B9C1\B429\B2C8\B2E4.'),
unistr('\AE30\D0C0 \BAA8\B4E0 \C791\C5C5 \C720\D615\C758 \ACBD\C6B0 \CCAB\BC88\C9F8 TRUE \D45C\C2DC \C870\AC74\C774 \B80C\B354\B9C1\B418\BA70 \B098\BA38\C9C0\B294 \BB34\C2DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\C2E4\D589 \C870\AC74\C774 \AC01 \D589\C5D0\C11C \D655\C778\B418\B3C4\B85D \C124\C815\B41C \ACBD\C6B0 \C5F4 \AC12\C744 \AE30\BC18\C73C\B85C \D45C\C2DC \C870\AC74\C744 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105918122421310198)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105918229802310198)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC\C5D0 \B2E8\CD94\B97C \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105918314295310198)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \CE74\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105918425289310198)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C804\CCB4 \CE74\B4DC\C5D0 \B9C1\D06C\B97C \CD94\AC00\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \C774 \C791\C5C5 \C720\D615 \C911 \D558\B098\B97C \C815\C758\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C5EC\B7EC \AC1C \C815\C758\D558\B294 \ACBD\C6B0 \C5F4 \AC12\C744 \AE30\BC18\C73C\B85C \D45C\C2DC \C870\AC74\C744 \CD94\AC00\D558\ACE0 \AC01 \D589\C5D0\C11C \D655\C778\B418\B3C4\B85D \C124\C815\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105918935160310198)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105919042802310199)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\CE74\B4DC \B9E4\CCB4\C5D0 \B9C1\D06C\B97C \CD94\AC00\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \C774 \C791\C5C5 \C720\D615 \C911 \D558\B098\B97C \C815\C758\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C5EC\B7EC \AC1C \C815\C758\D558\B294 \ACBD\C6B0 \CE74\B4DC \C5F4 \AC12\C744 \AE30\BC18\C73C\B85C \D45C\C2DC \C870\AC74\C744 \CD94\AC00\D558\ACE0 \AC01 \D589\C5D0\C11C \D655\C778\B418\B3C4\B85D \C124\C815\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105918757388310198)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105918884447310198)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\CE74\B4DC \BD80\C81C\C5D0 \B9C1\D06C\B97C \CD94\AC00\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \C774 \C791\C5C5 \C720\D615 \C911 \D558\B098\B97C \C815\C758\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C5EC\B7EC \AC1C \C815\C758\D558\B294 \ACBD\C6B0 \C5F4 \AC12\C744 \AE30\BC18\C73C\B85C \D45C\C2DC \C870\AC74\C744 \CD94\AC00\D558\ACE0 \AC01 \D589\C5D0\C11C \D655\C778\B418\B3C4\B85D \C124\C815\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105918581321310198)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105918695710310198)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\CE74\B4DC \C81C\BAA9\C5D0 \B9C1\D06C\B97C \CD94\AC00\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \C774 \C791\C5C5 \C720\D615 \C911 \D558\B098\B97C \C815\C758\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C5EC\B7EC \AC1C \C815\C758\D558\B294 \ACBD\C6B0 \C5F4 \AC12\C744 \AE30\BC18\C73C\B85C \D45C\C2DC \C870\AC74\C744 \CD94\AC00\D558\ACE0 \AC01 \D589\C5D0\C11C \D655\C778\B418\B3C4\B85D \C124\C815\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105917992444310198)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105906971983310190)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BCC4\C801\C73C\B85C \AC01 \CE74\B4DC\C5D0 \C801\C6A9\D560 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105906855289310190)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105912145562310193)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C624\B978\CABD\C744 \AC00\B9AC\D0A4\B294 \D654\C0B4\D45C \D45C\C2DC</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105912067073310193)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \C544\C774\CF58\C5D0 \B300\D55C \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\D14C\B9C8\C5D0\C11C \AE00\AF34 APEX\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>\C744 \AC80\D1A0\D558\C5EC \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58\ACFC \C218\C815\C790\B97C \D655\C778\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105911926464310193)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106013022239310283)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C624\B978\CABD\C744 \AC00\B9AC\D0A4\B294 \D654\C0B4\D45C \D45C\C2DC</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106012915287310283)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \C544\C774\CF58\C5D0 \B300\D55C \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\D14C\B9C8\C5D0\C11C \AE00\AF34 APEX\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>\C744 \AC80\D1A0\D558\C5EC \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58\ACFC \C218\C815\C790\B97C \D655\C778\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106012843512310282)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105905301248310188)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C18D\C131\C5D0 \B530\B77C \CE74\B4DC\B97C \D398\C774\C9C0\C5D0\C11C \C815\B82C\D558\B294 \BC29\C2DD\C774 \ACB0\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105905685476310189)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105905712092310189)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC\AC00 \D654\BA74\C5D0\C11C \B354 \C774\C0C1 \AC00\B85C\B85C \B9DE\C9C0 \C54A\C744 \ACBD\C6B0 \C904\BC14\AFC8\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105905483716310188)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B9AC\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105905528933310189)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \ADF8\B9AC\B4DC\C5D0\C11C \CE74\B4DC\B97C \C815\B82C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105905808718310189)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\B85C(\D589)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105905904653310189)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC\AC00 \CE35\CE35\C774 \BC30\CE58\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105905287551310188)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105919650494310199)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C791\C5C5 \C720\D615\C744 \B204\B97C \B54C \C218\D589\D560 \C791\C5C5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105919930661310199)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105920093814310199)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0 \B9E4\AE40 \C7AC\C124\C815, \C694\CCAD \AC12 \C124\C815, \CE90\C2DC \BE44\C6B0\AE30 \BC0F \D56D\BAA9 \AC12 \C124\C815\C5D0 \B300\D55C \C120\D0DD\C801\C778 \CD94\AC00 \C18D\C131\ACFC \D568\AED8 \B300\C0C1 \D398\C774\C9C0\C5D0\C11C \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\D558\AE30 \C704\D574\C11C\B294 \B300\C0C1 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \B525 \B9C1\D06C\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4. \B525 \B9C1\D06C\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D558\B824\BA74 \C560\D50C\B9AC\CF00\C774\C158\C758 <em>\BCF4\C548</em> \C18D\C131\C73C\B85C \C774\B3D9\D558\C5EC <em>\B525 \B9C1\D06C</em>\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105919717211310199)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105919808903310199)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C7AC\C124\C815, \C694\CCAD \AC12 \C124\C815, \CE90\C2DC \BE44\C6B0\AE30 \BC0F \D56D\BAA9 \AC12 \C124\C815\C5D0 \B300\D55C \C120\D0DD\C801\C778 \CD94\AC00 \C18D\C131\ACFC \D568\AED8 \B300\C0C1 \D398\C774\C9C0\C5D0\C11C \D604\C7AC \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105920163309310199)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('URL\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105920292740310199)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\D55C \B300\C0C1 URL\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105919572439310199)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106032796823310302)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18C\C2A4\C5D0\C11C \CCAB\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \D14C\C774\BE14\C758 \AE30\BCF8 \D0A4\AC00 \B450 \AC1C \C774\C0C1\C758 \C5F4\C744 \D3EC\D568\D558\B294 \ACBD\C6B0 <code>ROWID</code> \C5F4\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4. \C601\C5ED\C774 \C2A4\D06C\B864 \D398\C774\C9C0 \B9E4\AE40\C744 \D45C\C2DC\D558\B3C4\B85D \C124\C815\B41C \ACBD\C6B0 \AE30\BCF8 \D0A4\B97C \C0AC\C6A9\D558\C5EC \C911\BCF5 \D589 \D45C\C2DC\B97C \D53C\D560 \C218 \C788\C2B5\B2C8\B2E4. \C601\C5ED\C774 BLOB \C5F4\C758 \C774\BBF8\C9C0\B97C \D45C\C2DC\D558\B294 \ACBD\C6B0 \AE30\BCF8 \D0A4\B97C \C0AC\C6A9\D558\C5EC \C774\BBF8\C9C0\B97C \AC00\C838\C62C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106032656507310302)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106033140571310303)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18C\C2A4\C5D0\C11C \CCAB\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \D14C\C774\BE14\C758 \AE30\BCF8 \D0A4\AC00 \B450 \AC1C \C774\C0C1\C758 \C5F4\C744 \D3EC\D568\D558\B294 \ACBD\C6B0 <code>ROWID</code> \C5F4\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4. \C601\C5ED\C774 \C2A4\D06C\B864 \D398\C774\C9C0 \B9E4\AE40\C744 \D45C\C2DC\D558\B3C4\B85D \C124\C815\B41C \ACBD\C6B0 \AE30\BCF8 \D0A4\B97C \C0AC\C6A9\D558\C5EC \C911\BCF5 \D589 \D45C\C2DC\B97C \D53C\D560 \C218 \C788\C2B5\B2C8\B2E4. \C601\C5ED\C774 BLOB \C5F4\C758 \C774\BBF8\C9C0\B97C \D45C\C2DC\D558\B294 \ACBD\C6B0 \AE30\BCF8 \D0A4\B97C \C0AC\C6A9\D558\C5EC \C774\BBF8\C9C0\B97C \AC00\C838\C62C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106033025325310302)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106032935779310302)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18C\C2A4\C5D0 \B300\D55C \AE30\BCF8 \D0A4\AC00 \B450 \AC1C\C758 \C5F4\C744 \D3EC\D568\D558\B294 \ACBD\C6B0\C5D0\B9CC \B450\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \CCAB\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4\C5D0 \B300\D574 <code>ROWID</code>\B97C \C120\D0DD\D55C \ACBD\C6B0\C5D0\B294 \C774 \C5F4\C744 \CC44\C6B0\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4. \C601\C5ED\C774 \C2A4\D06C\B864 \D398\C774\C9C0 \B9E4\AE40\C744 \D45C\C2DC\D558\B3C4\B85D \C124\C815\B41C \ACBD\C6B0 \B450\BC88\C9F8 \AE30\BCF8 \D0A4\B97C \C0AC\C6A9\D558\C5EC \C911\BCF5 \D589 \D45C\C2DC\B97C \D53C\D560 \C218 \C788\C2B5\B2C8\B2E4. \C601\C5ED\C774 BLOB \C5F4\C758 \C774\BBF8\C9C0\B97C \D45C\C2DC\D558\B294 \ACBD\C6B0 \B450\BC88\C9F8 \AE30\BCF8 \D0A4\B97C \C0AC\C6A9\D558\C5EC \C774\BBF8\C9C0\B97C \AC00\C838\C62C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106032837187310302)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106033306467310303)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18C\C2A4\C5D0 \B300\D55C \AE30\BCF8 \D0A4\AC00 \B450 \AC1C\C758 \C5F4\C744 \D3EC\D568\D558\B294 \ACBD\C6B0\C5D0\B9CC \B450\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \CCAB\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4\C5D0 \B300\D574 <code>ROWID</code>\B97C \C120\D0DD\D55C \ACBD\C6B0\C5D0\B294 \C774 \C5F4\C744 \CC44\C6B0\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4. \C601\C5ED\C774 \C2A4\D06C\B864 \D398\C774\C9C0 \B9E4\AE40\C744 \D45C\C2DC\D558\B3C4\B85D \C124\C815\B41C \ACBD\C6B0 \B450\BC88\C9F8 \AE30\BCF8 \D0A4\B97C \C0AC\C6A9\D558\C5EC \C911\BCF5 \D589 \D45C\C2DC\B97C \D53C\D560 \C218 \C788\C2B5\B2C8\B2E4. \C601\C5ED\C774 BLOB \C5F4\C758 \C774\BBF8\C9C0\B97C \D45C\C2DC\D558\B294 \ACBD\C6B0 \B450\BC88\C9F8 \AE30\BCF8 \D0A4\B97C \C0AC\C6A9\D558\C5EC \C774\BBF8\C9C0\B97C \AC00\C838\C62C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106033238112310303)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105920533547310200)
,p_name=>'PE.PROPERTY.CARD_USES_BLOB_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC\C5D0 BLOB \C5F4 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105573231194309921)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D328\C2EF \B610\B294 \D544\D130 \AC12\C744 \D1B5\D55C \C9C8\C758\C5D0 \C0AC\C6A9\B418\B294 \AC12 \BAA9\B85D\C758 \B370\C774\D130\BCA0\C774\C2A4 \C5F4 \C774\B984(\B300\C18C\BB38\C790 \AD6C\BD84)\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105573153730309921)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('LOV \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106110117747310374)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C758 \C0C8\B85C\ACE0\CE68\C744 \D2B8\B9AC\AC70\D558\B294 \C5F4\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C5F4\C774 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \AC01 \C5F4 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\D569\B2C8\B2E4.'),
unistr('\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \C5F4 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \B54C \C774\BBF8 \C785\B825\B41C \D14D\C2A4\D2B8\AC00 \C788\C73C\BA74 \AE30\C874 \D14D\C2A4\D2B8 \B05D\C5D0 \CF64\B9C8\AC00 \D45C\C2DC\B418\ACE0 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \C5F4 \C774\B984\C774 \CD94\AC00\B429\B2C8\B2E4.</p>'),
unistr('<p>\C774 \AC12 \BAA9\B85D\C740 \C774 \D398\C774\C9C0\C5D0\C11C \C9C0\C815\B41C \C5F4\C758 \AC12\C774 \BCC0\ACBD\B420 \B54C\B9C8\B2E4 \C0C8\B85C\ACE0\CE68\B429\B2C8\B2E4.</p>'),
unistr('<p>\BC18\D658\B418\B294 \AC12\C744 \C81C\D55C\D558\B824\BA74 \C774 \AC12 \BAA9\B85D SQL \C9C8\C758\C758 <em>WHERE \C808</em> \B0B4\C5D0\C11C \C774 \C18D\C131\C5D0 \C9C0\C815\B41C \C5F4\C744 \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\C608\B97C \B4E4\C5B4, Car Make \BC0F Model\C5D0 \B300\D55C \C5F4\C774 \C788\C73C\BA74, Model\C758 \AC12 \BAA9\B85D \C815\C758 \B0B4\C5D0\C11C Car Make\B97C \C885\C18D LOV \C0C1\C704 \C5F4\B85C \C9C0\C815\D558\ACE0 \D574\B2F9 \AC12 \BAA9\B85D\C5D0 \B300\D55C WHERE \C808 \B0B4\C5D0\C11C Car Make\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\ADF8\B7F0 \D6C4 Car Make\AC00 \BCC0\ACBD\B420 \B54C\B9C8\B2E4 Model\C758 LOV\AC00 \C0C8\B85C\ACE0\CE68\B418\ACE0 \BAA9\B85D\C5D0\B294 \D604\C7AC \C120\D0DD\B41C Car Make\C5D0 \B300\D55C \AC12\B9CC \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106110063515310374)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105573414333309921)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC12 \BAA9\B85D\C758 \C0C8\B85C\ACE0\CE68\C744 \D2B8\B9AC\AC70\D558\B294 \D328\C2EF\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105573367767309921)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D328\C2EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105259848353309666)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC12 \BAA9\B85D\C758 \C0C8\B85C\ACE0\CE68\C744 \D2B8\B9AC\AC70\D558\B294 \D544\D130\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105259749454309666)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105224932531309640)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C758 \C0C8\B85C\ACE0\CE68\C744 \D2B8\B9AC\AC70\D558\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\D56D\BAA9\C774 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \AC01 \D56D\BAA9 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\D569\B2C8\B2E4.'),
unistr('\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \B54C \C774\BBF8 \C785\B825\B41C \D14D\C2A4\D2B8\AC00 \C788\C73C\BA74 \AE30\C874 \D14D\C2A4\D2B8 \B05D\C5D0 \CF64\B9C8\AC00 \D45C\C2DC\B418\ACE0 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \D56D\BAA9 \C774\B984\C774 \CD94\AC00\B429\B2C8\B2E4.</p>'),
unistr('<p>\C774 \AC12 \BAA9\B85D\C740 \C774 \D398\C774\C9C0\C5D0\C11C \C9C0\C815\B41C \D56D\BAA9\C758 \AC12\C774 \BCC0\ACBD\B420 \B54C\B9C8\B2E4 \C0C8\B85C \ACE0\CCD0\C9D1\B2C8\B2E4.</p>'),
unistr('<p>\BC18\D658\B418\B294 \AC12\C744 \C81C\D55C\D558\B824\BA74 \C774 \AC12 \BAA9\B85D SQL \C9C8\C758\C758 <em>WHERE \C808</em> \B0B4\C5D0\C11C \C774 \C18D\C131\C5D0 \C9C0\C815\B41C \D398\C774\C9C0 \D56D\BAA9\C744 \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\C608\B97C \B4E4\C5B4, Car Make \BC0F Model\C5D0 \B300\D55C \D398\C774\C9C0 \D56D\BAA9\C774 \C788\C73C\BA74, Model\C758 \AC12 \BAA9\B85D \C815\C758 \B0B4\C5D0\C11C Car Make\B97C \C885\C18D LOV \C0C1\C704 \D56D\BAA9\C73C\B85C \C9C0\C815\D558\ACE0 \D574\B2F9 \AC12 \BAA9\B85D\C5D0 \B300\D55C WHERE \C808 \B0B4\C5D0\C11C Car Make\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\ADF8\B7F0 \D6C4 Car Make\AC00 \BCC0\ACBD\B420 \B54C\B9C8\B2E4 Model\C758 LOV\AC00 \C0C8\B85C \ACE0\CCD0\C9C0\ACE0 \BAA9\B85D\C5D0\B294 \D604\C7AC \C120\D0DD\B41C Car Make\C5D0 \B300\D55C \AC12\B9CC \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105224811967309640)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105570294924309918)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C774 \C0C8\B85C\ACE0\CE68\B418\B294 \C870\AC74\C744 \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\C124\C815</strong>\C73C\B85C \C124\C815\D560 \ACBD\C6B0 <em>\C885\C18D LOV \C0C1\C704 \D56D\BAA9</em>\C774 \B110\C774 \C544\B2D0 \B54C\B9CC \C0C8 \AC12\C744 \AC00\C838\C624\B294 \C0C8\B85C\ACE0\CE68 \D638\CD9C\C774 \C218\D589\B429\B2C8\B2E4.'),
unistr('\D55C \D56D\BAA9\C774 \B110\C774\BA74 LOV \C9C8\C758\AC00 \D589\C744 \BC18\D658\D558\C9C0 \C54A\B294 \AC83\C73C\B85C \AC04\C8FC\B429\B2C8\B2E4.'),
unistr('\C774 \ACBD\C6B0\C5D0\B294 \C0C8\B85C\ACE0\CE68\C744 \C218\D589\D558\C9C0 \C54A\ACE0 \B2E8\C21C\D788 \BE0C\B77C\C6B0\C800\C5D0\C11C \C120\D0DD \BAA9\B85D \D56D\BAA9\C774 \C9C0\C6CC\C9D1\B2C8\B2E4.</p>'),
unistr('<p><strong>\D574\C81C</strong>\B85C \C124\C815\D560 \ACBD\C6B0 \D56D\C0C1 \C0C8\B85C\ACE0\CE68\C774 \C218\D589\B429\B2C8\B2E4.'),
unistr('\C774 \C635\C158\C740 \D574\B2F9 \AC12 \BAA9\B85D SQL \C9C8\C758\C758 <em>WHERE \C808</em>\C5D0\C11C \D2B9\BCC4\D788 \B110\C744 \D5C8\C6A9\D558\B294 <em>\C885\C18D LOV \C0C1\C704 \D56D\BAA9</em>\C744 \CC98\B9AC\D558\B294 \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.'),
unistr('\B110\C744 \D5C8\C6A9\D558\B294 \D398\C774\C9C0 \D56D\BAA9\C774 \C62C\BC14\B974\AC8C \CC98\B9AC\B418\C9C0 \C54A\C73C\BA74 \D589\C744 \BC18\D658\D558\C9C0\B3C4 \C54A\B294 \BD88\D544\C694\D55C \C0C8\B85C\ACE0\CE68 \D638\CD9C\C774 \C2E4\D589\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105570165690309918)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D544\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104855779000309359)
,p_name=>'PE.PROPERTY.CHANGED_BY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C18D\C131\C744 \B9C8\C9C0\B9C9\C73C\B85C \C5C5\B370\C774\D2B8\D55C \AC1C\BC1C\C790\C758 \C0AC\C6A9\C790 \C778\C99D\C11C\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104855650438309359)
,p_name=>'PE.PROPERTY.CHANGED_BY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104855935368309359)
,p_name=>'PE.PROPERTY.CHANGED_ON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C18D\C131\C774 \C5B8\C81C \B9C8\C9C0\B9C9\C73C\B85C \C5C5\B370\C774\D2B8\B418\C5C8\B294\C9C0 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104855898377309359)
,p_name=>'PE.PROPERTY.CHANGED_ON.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD \C77C\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105605774215309947)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CC28\D2B8\C758 \B192\C774\B97C \D53D\C140 \B2E8\C704\B85C \C785\B825\D569\B2C8\B2E4. \B192\C774\C5D0 \B530\B77C \CC28\D2B8 \C601\C5ED\C758 \ACE0\C815 \B192\C774\AC00 \C815\C758\B429\B2C8\B2E4. \ADF8\B807\C9C0 \C54A\ACE0 \CC28\D2B8 \B192\C774 \D06C\AE30\AC00 \C790\B3D9\C73C\B85C \C870\C815\B418\B3C4\B85D \D558\B824\BA74 \C774 \D56D\BAA9\C744 \BE44\C6CC\B461\B2C8\B2E4.'),
unistr('\ADF8\B7EC\BA74 \B192\C774\AC00 \BE0C\B77C\C6B0\C800\C758 \B192\C774\B97C \AE30\C900\C73C\B85C \C870\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>\AE30\BCF8\C801\C73C\B85C jQuery \BAA8\BC14\C77C \C2A4\B9C8\D2B8\D3F0 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C0AC\C6A9\D574\C11C \D398\C774\C9C0\C5D0 \C0DD\C131\B41C \CC28\D2B8\B294 \B192\C774\C5D0 \B300\D574 \C124\C815\B41C \AC12\C774 \C5C6\C73C\BA70 \D604\C7AC \B80C\B354\B9C1 \C911\C778 \C7A5\CE58\C5D0 \B9DE\AC8C \C62C\BC14\B978 \D06C\AE30\B85C \C870\C815\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105605682742309946)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B192\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105605870012309947)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53D\C140')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105629571972309967)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CC28\D2B8\C758 \CD5C\B300 \B108\BE44\B97C \D53D\C140 \B2E8\C704\B85C \C785\B825\D569\B2C8\B2E4. \CD5C\B300 \B108\BE44\C5D0 \B530\B77C \CC28\D2B8 \C601\C5ED\C758 \ACE0\C815 \B108\BE44\AC00 \C815\C758\B429\B2C8\B2E4.'),
unistr('\ADF8\B807\C9C0 \C54A\ACE0 \CC28\D2B8 \B108\BE44 \D06C\AE30\AC00 \C790\B3D9\C73C\B85C \C870\C815\B418\B3C4\B85D \D558\B824\BA74 \C774 \D56D\BAA9\C744 \BE44\C6CC\B461\B2C8\B2E4.'),
unistr('\ADF8\B7EC\BA74 \B108\BE44\AC00 \D574\B2F9 \C601\C5ED\C758 100%\B85C \C790\B3D9\C73C\B85C \C124\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>\AE30\BCF8\C801\C73C\B85C jQuery \BAA8\BC14\C77C \C2A4\B9C8\D2B8\D3F0 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C0AC\C6A9\D574\C11C \D398\C774\C9C0\C5D0 \C0DD\C131\B41C \CC28\D2B8\B294 \B108\BE44\C5D0 \B300\D574 \C124\C815\B41C \AC12\C774 \C5C6\C73C\BA70 \D604\C7AC \B80C\B354\B9C1 \C911\C778 \C7A5\CE58\C5D0 \B9DE\AC8C \C62C\BC14\B978 \D06C\AE30\B85C \C870\C815\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105623969994309962)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105624037020309962)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53D\C140')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105602661629309944)
,p_name=>'PE.PROPERTY.CHART_TITLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B9E8 \C704\C5D0 \D45C\C2DC\D560 \C81C\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \AC04\D2B8 \CC28\D2B8\C758 \ACBD\C6B0 \C774 \AC12\C740 \C561\C138\C2A4 \AC00\B2A5\D55C \CC28\D2B8 \C81C\BAA9\C744 \C815\C758\D558\B294 \B370\B9CC \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105602564147309944)
,p_name=>'PE.PROPERTY.CHART_TITLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105831008359310131)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\C758 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105831120076310132)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\CEEC \B370\C774\D130\BCA0\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105831248964310132)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\CEEC \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \B370\C774\D130\B97C \AC00\C838\C635\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105831761598310132)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105831873996310132)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18C\C2A4 \C815\C758\C5D0 \C9C0\C815\B41C \C704\CE58\C5D0\C11C \B370\C774\D130\B97C \AC00\C838\C635\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105831353653310132)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105831489236310132)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL\C744 \C0AC\C6A9\D558\C5EC \C811\C18D\C774 \C815\C758\B41C \C6D0\ACA9 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \B370\C774\D130\B97C \AC00\C838\C635\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105831587456310132)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105831644226310132)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4\B97C \C0AC\C6A9\D558\C5EC \C815\C758\B41C RESTful \C6F9 \C11C\BE44\C2A4\C5D0\C11C \B370\C774\D130\B97C \AC00\C838\C635\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105830931074310131)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105596337398309939)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BCF4\ACE0\C11C \C5F4\C758 \AE30\C900\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105754164658310073)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('* \B0A0\C9DC \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105754021791310073)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('* \B0A0\C9DC \C120\D0DD\AE30(\D074\B798\C2DD)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105753940612310073)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('* \D14D\C2A4\D2B8\B85C \D45C\C2DC(\C0C1\D0DC \C800\C7A5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105753616118310073)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('BLOB \B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105931056878310208)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \D30C\C77C\C744 \B2E4\C6B4\B85C\B4DC\D560 \C218 \C788\B294 \B9C1\D06C\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105753856028310073)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\ACA8\C9C4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105931257561310208)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \D45C\C2DC\D558\C9C0 \C54A\C9C0\B9CC \D574\B2F9 \C5F4\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105754686287310074)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('* \C228\ACA8\C9C4 \D544\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105753519894310073)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105930924078310208)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \C774\BBF8\C9C0\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105753481540310073)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105930867154310207)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \B9C1\D06C\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105753749531310073)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C728 \ADF8\B798\D504')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105931126188310208)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \BC31\BD84\C728 \ADF8\B798\D504\B85C \D45C\C2DC\D569\B2C8\B2E4. \AC80\C0C9\B41C \AC12\C740 0\C5D0\C11C 100 \C0AC\C774\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105753201824310073)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105930606096310207)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105753382409310073)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \D14D\C2A4\D2B8(\AC12 \BAA9\B85D \AE30\C900)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105930788139310207)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \AC12 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105754735382310074)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('* \D31D\C5C5 LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105754854671310074)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('* \D31D\C5C5 \D0A4 LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105754529856310074)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('* \B77C\B514\C624 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106002101057310272)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\C2DD \C788\B294 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106002258886310273)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \B610\B294 \B9C8\D06C\B2E4\C6B4\C744 \C0AC\C6A9\D558\C5EC \C5F4\C744 \B80C\B354\B9C1\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105755062589310074)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('* \D589 \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105754419082310074)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('* \C120\D0DD \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105754900125310074)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'ko'
,p_message_text=>unistr('* \B2E8\C21C \CCB4\D06C\BC15\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105754271471310073)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('* \D14D\C2A4\D2B8 \D544\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105754310478310074)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('* \D14D\C2A4\D2B8 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105596259858309939)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105595917866309938)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C5C6\C74C(\BAA8\B4E0 \D589 \D45C\C2DC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105597101144309939)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C5C6\C74C(\BAA8\B4E0 \D589 \D45C\C2DC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105582320947309928)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \BCF4\ACE0\C11C\C5D0\C11C \C0AC\C6A9\D560 \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C77C\BC18\C801\C73C\B85C \ACB0\ACFC\C758 \D558\C704 \C9D1\D569\B9CC \D604\C7AC \BCF4\ACE0\C11C\C5D0 \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C740 \D589 \C218 \BC0F \ACB0\ACFC \C9D1\D569 \B0B4\C5D0\C11C \D604\C7AC \C704\CE58\C5D0 \B300\D55C \C815\BCF4\B97C \C0AC\C6A9\C790\C5D0\AC8C \C81C\ACF5\D569\B2C8\B2E4. \D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C740 \B610\D55C \B2E4\C74C \B610\B294 \C774\C804 \D398\C774\C9C0\B85C \C774\B3D9\D560 \B54C \C0AC\C6A9\B418\B294 \B9C1\D06C \B610\B294 \B2E8\CD94\C758 \C2A4\D0C0\C77C\B3C4 \C815\C758\D569\B2C8\B2E4.</p>'),
unistr('<p>\D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C740 \BCF4\ACE0\C11C \C704 \B610\B294 \C544\B798(\B610\B294 \BAA8\B450)\C5D0 \D45C\C2DC\D560 \C218 \C788\C73C\BA70 \C67C\CABD \B610\B294 \C624\B978\CABD\C5D0 \BC30\CE58\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B610\D55C <strong>\D589 \BC94\C704 X-Y(\B2E4\C74C \BC0F \C774\C804 \B9C1\D06C \C0AC\C6A9)</strong>\C640 \AC19\C774 \AC04\C18C\D654\B41C \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C2A4\D0C0\C77C\C744 \C0AC\C6A9\D574\C11C \C131\B2A5\C744 \D5A5\C0C1\C2DC\D0AC \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('"X-Y/Z"\C640 \AC19\C740 \D615\C2DD\C758 \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C720\D615\C744 \C0AC\C6A9\D558\B824\BA74 &PRODUCT_NAME. \C5D4\C9C4\C774 \ACB0\ACFC\B97C \BC18\D658\D558\AE30 \C704\D574 \B450 \AC1C\C758 \C9C8\C758\B97C \C218\D589\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C5EC\AE30\C11C \CCAB\BC88\C9F8 \C9C8\C758\B294 \D45C\C2DC\D560 \D604\C7AC \B808\CF54\B4DC\B97C \AC80\C0C9\D558\ACE0 \B450\BC88\C9F8 \C9C8\C758\B294 \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C81C\C5B4\C5D0 \D45C\C2DC\D560 \CD1D \B808\CF54\B4DC \C218\B97C \AC00\C838\C635\B2C8\B2E4.'),
unistr('\B9E4\C6B0 \D070 \B370\C774\D130\C138\D2B8\C744 \AE30\C900\C73C\B85C \D558\B294 \BCF4\ACE0\C11C \B610\B294 \BE44\CD5C\C801 \D14C\C774\BE14 \C870\C778 \B610\B294 \D3EC\AD04\C801\C778 \C870\AC74\C774 \BB34\C218\D788 \B9CE\C740 CPU \C0AC\C6A9\B7C9\C774 \B9E4\C6B0 \B192\C740 \C9C8\C758\B97C \D3EC\D568\D558\B294 \BCF4\ACE0\C11C\C758 \ACBD\C6B0\C5D0\B294 \C774\B7EC\D55C \CD94\AC00 \C9C8\C758\B85C \C778\D574 \CC98\B9AC \C2DC\AC04\C774 \B298\C5B4\B098\ACE0 \ACB0\ACFC\C801\C73C\B85C \BCF4\ACE0\C11C\B97C \B80C\B354\B9C1\D558\B294 \B370 \B354 \B9CE\C740 \C2DC\AC04\C774 \AC78\B9B4 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105762760874310080)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.COMPUTED_BUT_NOT_DISPLAYED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\BD80\C5D0\C11C \C0DD\C131\B41C \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \B2E8\CD94 \C0AC\C6A9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105762805189310080)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.NEXT_PREVIOUS_LINKS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BC94\C704 X-Y(\B2E4\C74C \BC0F \C774\C804 \B9C1\D06C \C0AC\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105762150544310080)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BC94\C704 X-Y(\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C5C6\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105762229993310080)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'ko'
,p_message_text=>unistr('Z\C758 \D589 \BC94\C704 X-Y(\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C5C6\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105762470235310080)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BC94\C704 1-15 16-30(\C124\C815\B41C \D398\C774\C9C0 \BC88\D638 \B9E4\AE40)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105762513784310080)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_IN_SELECT_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD \BAA9\B85D\C758 \D589 \BC94\C704 1-15 16-30(\D398\C774\C9C0 \BC88\D638 \B9E4\AE40)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105762300085310080)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_WITH_LINKS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('Z\C758 \D589 \BC94\C704 X-Y(\D398\C774\C9C0 \BC88\D638 \B9E4\AE40)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105762697672310080)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.SEARCH_ENGINE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \C5D4\C9C4 1,2,3,4(\D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C744 \AE30\C900\C73C\B85C \C124\C815)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105582264700309928)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105551867950309904)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \BCF4\AE30\C5D0\C11C \D589\B2F9 \D45C\C2DC\D560 \C544\C774\CF58 \C218\B97C \C120\D0DD\D569\B2C8\B2E4. \AC12\C774 5\BA74 \BCF4\ACE0\C11C\C758 \D589\B2F9 5\AC1C \C544\C774\CF58\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105750268581310071)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.1.D'
,p_message_language=>'ko'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105750354263310071)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.2.D'
,p_message_language=>'ko'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105750465652310071)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.3.D'
,p_message_language=>'ko'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105750503853310071)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.4.D'
,p_message_language=>'ko'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105750645992310071)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.5.D'
,p_message_language=>'ko'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105750752042310071)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.6.D'
,p_message_language=>'ko'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105750811528310071)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.7.D'
,p_message_language=>'ko'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105750926812310071)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.8.D'
,p_message_language=>'ko'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105751027962310071)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.9.D'
,p_message_language=>'ko'
,p_message_text=>'9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105551739027309904)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\B2F9 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105542396266309896)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \D45C\C2DC \B9DE\CDA4\C744 \C120\D0DD\D569\B2C8\B2E4. \C120\D0DD\D55C \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C5D0\C11C \C9C0\C6D0\D558\B294 \B9DE\CDA4\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105746316228310068)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C6B4\B370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105746275734310068)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105746475456310068)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B05D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105542272783309896)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105598619147309941)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C5F4 \AC12 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105766244735310083)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.FUNCTION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105766176240310082)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105598516222309940)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105453529281309822)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \BA38\B9AC\AE00 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105541556332309895)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4 \BA38\B9AC\AE00 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105541446230309895)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104971202320309448)
,p_name=>'PE.PROPERTY.COLUMN_IS_SORTABLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \AC00\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105880424405310169)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C2DD\BCC4\C744 \C704\D574 \ACE0\C720 \D0A4\AC00 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C0AC\C6A9\C790\C815\C758 JavaScript \CF54\B4DC \B610\B294 \B9F5 \C774\BCA4\D2B8 \CC98\B9AC\AE30\C5D0 \ACE0\C720 \D0A4 \AC12\C744 \C81C\ACF5\D558\AE30 \C704\D574 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105880385881310169)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105540968830309895)
,p_name=>'PE.PROPERTY.COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BCF4\ACE0\C11C \C5F4\C5D0 \B300\D55C \C5F4 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105540887806309895)
,p_name=>'PE.PROPERTY.COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105596169683309939)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B984\CC28\C21C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105597570342309940)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B984\CC28\C21C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105576620124309923)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C744 \B0B4\B9BC\CC28\C21C\C73C\B85C \C815\B82C\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C9C0\C815\D558\C9C0 \C54A\C73C\BA74 \C5F4\C774 \C624\B984\CC28\C21C(\AE30\BCF8\AC12)\C73C\B85C \C815\B82C\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105759445981310078)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.LOV.DESC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\B9BC\CC28\C21C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105576503653309923)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105576495276309923)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \C5F4\C5D0 \B300\D55C \C815\B82C \C21C\C11C\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\BCF4\ACE0\C11C \CD9C\B825\C744 \C62C\BC14\B974\AC8C \C815\B82C\D558\B824\BA74 \AC01 \C5F4\C758 \C21C\C11C\AC00 \ACE0\C720\D574\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105758658513310077)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.1.D'
,p_message_language=>'ko'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105758751698310077)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.2.D'
,p_message_language=>'ko'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105758827525310077)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.3.D'
,p_message_language=>'ko'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105758903581310077)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.4.D'
,p_message_language=>'ko'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105759043492310077)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.5.D'
,p_message_language=>'ko'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105759100781310077)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.6.D'
,p_message_language=>'ko'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105759292403310077)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.7.D'
,p_message_language=>'ko'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105759333399310077)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.8.D'
,p_message_language=>'ko'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105576324551309923)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C21C\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105541138130309895)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4\C5D0 \B300\D55C \B370\C774\D130 \C720\D615\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105541065425309895)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105574807049309922)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \B108\BE44(\D53D\C140)\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\BE0C\B77C\C6B0\C800\C5D0 \BCF4\ACE0\C11C\B97C \D45C\C2DC\D560 \B54C \C774 \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4.'),
unistr('\C5F4 \B108\BE44 \C124\C815\C740 \C120\D0DD\D55C \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C5D0\C11C \C9C0\C6D0\B418\C5B4\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105574738659309922)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C140 \B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105605284925309946)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53D\C140')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105209552768309629)
,p_name=>'PE.PROPERTY.COMMENTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790 \C124\BA85 \B610\B294 \CC38\ACE0 \C0AC\D56D\C744 \C5EC\AE30\C5D0 \C785\B825\D569\B2C8\B2E4. \C774\B7EC\D55C \C124\BA85\C740 \C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30 \B0B4\C5D0\B9CC \D45C\C2DC\B418\ACE0 \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D560 \B54C\B294 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105209400901309629)
,p_name=>'PE.PROPERTY.COMMENTS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105906786534310189)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \C801\C6A9\D560 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \C774 \D074\B798\C2A4\B294 \CE74\B4DC \CEE8\D14C\C774\B108\C5D0 \C801\C6A9\B429\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105906606504310189)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105966722819310237)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D45C\D604\C2DD\C744 \D3C9\AC00\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105967115914310238)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105967081163310238)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105966925808310238)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105967298752310238)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105966857018310238)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ko'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105966651364310237)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105968740490310239)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105969077673310239)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105968989011310239)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105968813930310239)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105969113071310239)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105968682296310239)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105213579272309632)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \ACC4\C0B0\C73C\B85C \CC44\C6CC\C9C0\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105213476957309632)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105214322842309632)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \AC12\C774 \ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105214253468309632)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105968345565310239)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 Java \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105968289299310239)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105969924121310240)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105969850892310240)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105968154079310238)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105968072577310238)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 JavaScript \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105967959675310238)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105969732442310240)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105969649646310240)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105969515190310240)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105967893943310238)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105967715759310238)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105967613669310238)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105969441873310239)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105969369794310239)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105969200177310239)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105214962419309633)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D398\C774\C9C0 \B80C\B354\B9C1 \B610\B294 \CC98\B9AC \C2DC \C774 \ACC4\C0B0\C774 \C2E4\D589\B418\B294 \C2DC\C810\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\AC00\C7A5 \C77C\BC18\C801\C778 \ACC4\C0B0 \C2DC\C810\C740 <strong>\C81C\CD9C \D6C4</strong>\C785\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105726970085310053)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106028352820310298)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1: \C601\C5ED\C774 \B80C\B354\B9C1\B41C \D6C4 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105727114254310053)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\B2E5\AE00 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106028560510310298)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1: \BC14\B2E5\AE00\C774 \B80C\B354\B9C1\B41C \D6C4 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105726782970310053)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106028143531310298)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1: \BA38\B9AC\AE00\C774 \B80C\B354\B9C1\B41C \D6C4 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105727232915310053)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C \D6C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106028603512310298)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC: \D398\C774\C9C0\AC00 \C81C\CD9C\B41C \D6C4 \D398\C774\C9C0 \CC98\B9AC \C804 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105726879520310053)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106028270982310298)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1: \C601\C5ED\C774 \B80C\B354\B9C1\B418\AE30 \C804 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105727033590310053)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\B2E5\AE00 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106028453759310298)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1: \BC14\B2E5\AE00\C774 \B80C\B354\B9C1\B418\AE30 \C804 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105726606277310053)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106028077078310297)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1: \D398\C774\C9C0\AC00 \B80C\B354\B9C1\B418\AE30 \C804 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105726577083310053)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C138\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106027938791310297)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C138\C158\C774 \C0DD\C131\B420 \B54C \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105214846377309633)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C810')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105214504467309632)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \D3EC\D568\D558\B294 \C0AC\C6A9\C790 \D658\ACBD\C124\C815\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105214409249309632)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105968587372310239)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 Python \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105968453508310239)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105970112399310240)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105970049889310240)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105933359640310213)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \C81C\ACF5\D558\B294 SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4. \ACB0\ACFC\C5D0 \D589\C774 \C5EC\B7EC \AC1C \D3EC\D568\B41C \ACBD\C6B0 \AC01 \D589\C758 \AC12\C744 \CF5C\B860\C73C\B85C \AD6C\BD84\D558\C5EC \C5F0\ACB0\D55C \B2E8\C77C \AC12\C774 \D615\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105933222488310212)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105967537447310238)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \AD00\B9AC\C790\C774\ACE0 \BD80\C11C\AC00 \C2DC\CE74\ACE0\C5D0 \C788\C744 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105967450366310238)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105967331514310238)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105214158838309632)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \C81C\ACF5\D558\B294 SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4. \ACB0\ACFC\C5D0 \D589\C774 \C5EC\B7EC \AC1C \C788\B294 \ACBD\C6B0 \CCAB\BC88\C9F8 \D589\C758 \AC12\B9CC \BC18\D658\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105214065847309632)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105213991075309632)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D56D\BAA9\C744 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B418\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105213893268309632)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105213778063309632)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \BAA9\B85D\C5D0\C11C \ACC4\C0B0 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105949868805310225)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105949940643310225)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>\D45C\D604\C2DD</em> \C2E4\D589 \ACB0\ACFC \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105726018776310052)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105928400746310206)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>\D568\C218 \BCF8\BB38</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105726375742310052)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105928131024310205)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105726156671310052)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758(\B2E8\C77C \AC12 \BC18\D658)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105928267604310205)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>SQL \C9C8\C758</em>\C5D0\C11C \BC18\D658\B41C \CCAB\BC88\C9F8 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105726207245310052)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758(\CF5C\B860\C73C\B85C \AD6C\BD84\B41C \AC12 \BC18\D658)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105928317913310205)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>SQL \C9C8\C758</em>\C5D0\C11C \BC18\D658\B41C \B2E8\C77C \AC12(\AC01 \D589 \AC12\C744 \CF5C\B860\C73C\B85C \AD6C\BD84\D558\C5EC \C5F0\ACB0\D55C \AC12)\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105726435935310053)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105928547654310206)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>\D658\ACBD\C124\C815</em>\C758 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105725911089310052)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105928074971310205)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\C815\C801 \AC12</em>\C5D0 \C785\B825\B41C \D14D\C2A4\D2B8\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105213637639309632)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105574668683309922)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \C5F4\C5D0 \B300\D574, \D569\ACC4\B97C \ACC4\C0B0\D574\C11C \BCF4\ACE0\C11C \B05D\C5D0 \D45C\C2DC\D560\C9C0\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\AD6C\BD84 \C5F4\ACFC \D568\AED8 \C0AC\C6A9\D560 \B54C\B294 \CD1D\ACC4 \BC0F \AC01 \AD6C\BD84 \C5F4\C5D0 \B300\D55C \D569\ACC4\AC00 \D45C\C2DC\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105574535785309922)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D569\ACC4 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105959368433310232)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D45C\D604\C2DD\C744 \D3C9\AC00\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105959730970310232)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105959683361310232)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105959562866310232)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105959812852310232)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105959466103310232)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ko'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105959265112310232)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105961320993310234)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105961694619310234)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105961547067310234)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105961457505310234)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105961712719310234)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105961235084310233)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105247003368309656)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105246944251309656)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105248432562309658)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105248388021309657)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105960922571310233)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C Java \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105960874062310233)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105962501171310234)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105962428348310234)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105960746923310233)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105960620673310233)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C JavaScript \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105960541423310233)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105962306653310234)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105962229180310234)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105962159900310234)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105247288811309657)
,p_name=>'PE.PROPERTY.CONDITION_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \CF5C\B860(:)\C73C\B85C \AD6C\BD84\B41C \AC12 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105247180411309657)
,p_name=>'PE.PROPERTY.CONDITION_LIST.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105247658760309657)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \D398\C774\C9C0 \BC88\D638\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105247587228309657)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105247840247309657)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \D398\C774\C9C0 \BC88\D638 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105247712940309657)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105960438284310233)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105960335946310233)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105960234301310233)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105962004609310234)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105961970374310234)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105961848274310234)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105247489964309657)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \C9C0\C815\B41C \AC12\ACFC \BE44\AD50\B418\B294 \C0AC\C6A9\C790 \D658\ACBD\C124\C815\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105247364651309657)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105961117364310233)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C Python \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105961011791310233)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105962756202310235)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105962605409310234)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105960159328310233)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \AD00\B9AC\C790\C774\ACE0 \BD80\C11C\AC00 \C2DC\CE74\ACE0\C5D0 \C788\C744 \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105960000950310232)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105959900981310232)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106105995557310370)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\B294\C9C0 \D655\C778\D560 \B54C \D558\B098 \C774\C0C1\C758 \D589\C774 \C874\C7AC\D558\BA74 \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\C9C1\C6D0\C774 \BD80\C11C 40\C5D0 \C18D\D558\B294\C9C0 \D655\C778\D560 \B54C \D589\C774 \C874\C7AC\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105246622231309656)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105246531430309656)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105248052559309657)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \D14D\C2A4\D2B8 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105247992389309657)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105248638783309658)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 <code>&ITEM.</code> \B300\CCB4 \BB38\C790\C5F4\C744 \D3EC\D568\D558\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105248558517309658)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105621950229309960)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C744 \D65C\C131\D654\D558\AE30 \C704\D574 \CDA9\C871\B418\C5B4\C57C \D558\B294 \C870\AC74 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105249561048309658)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B3D9\C801 \C791\C5C5\C744 \D65C\C131\D654\D558\AE30 \C704\D574 \CDA9\C871\B418\C5B4\C57C \D558\B294 \C870\AC74 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105245536940309655)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\B97C \B80C\B354\B9C1\D558\AC70\B098 \CC98\B9AC\D558\AE30 \C704\D574 \CDA9\C871\B418\C5B4\C57C \D558\B294 \C870\AC74 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105803973963310111)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105941564797310219)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\B294 \D56D\C0C1 \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105802566742310110)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 Microsoft Internet Explorer 7.0 \C774\C0C1\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105802656562310110)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 XHTML / CSS \C9C0\C6D0 \BE0C\B77C\C6B0\C800\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105802437293310110)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 Mozilla, Netscape 6.x/7x \C774\C0C1\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105802712093310110)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 \AE30\D0C0 \BE0C\B77C\C6B0\C800(\B610\B294 \C774\C804 \BC84\C804)\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105801138858310109)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\AC00 \D56D\BAA9\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105803100256310110)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105945151408310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105802881848310110)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4\AC00 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105945382846310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4 \C911 \D558\B098\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105803088655310110)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105945293951310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D558\ACE0 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105802958899310110)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4\AC00 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105945406307310222)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4 \C911 \D558\B098\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D558\ACE0 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105800381721310108)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 = \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105943929410310220)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \AC12\ACFC \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105800541327310108)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105944138811310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105800495394310108)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 != \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105944089736310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \AC12\ACFC \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105800670384310108)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105944211083310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105803233519310111)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105803308864310111)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105802005338310110)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D45C\C2DC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105944905460310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\CD9C \D6C4 \C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D398\C774\C9C0\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105801489378310109)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105801246624310109)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\AC00 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105801329524310109)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\AC00 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105801543954310109)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 != \AC12')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105798049858310106)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \BC18\D658\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105941635860310219)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\AC00 \D558\B098 \C774\C0C1\C758 \D589\C744 \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105959073551310232)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105959121269310232)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD\C774 TRUE\B85C \D3C9\AC00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105798254879310107)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105941861730310219)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38\C774 TRUE\B97C \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105803660851310111)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105803733802310111)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105801778853310109)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0/\C601\C5ED\C774 \C77D\AE30 \C804\C6A9\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105944662445310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B610\B294 \C0C1\C704 \C601\C5ED(\D574\B2F9\D558\B294 \ACBD\C6B0)\C774 \C815\C0C1\C801\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105801664141310109)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0/\C601\C5ED\C774 \C77D\AE30 \C804\C6A9\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105944548967310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B610\B294 \C0C1\C704 \C601\C5ED(\D574\B2F9\D558\B294 \ACBD\C6B0) \C911 \D558\B098\C785\B2C8\B2E4. ''\C77D\AE30 \C804\C6A9'' \C870\AC74\C740 TRUE\B85C \D3C9\AC00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105799591181310108)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \ACF5\BC31\C744 \D3EC\D568\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105943197734310220)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \ACF5\BC31\C744 \D3EC\D568\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105799845272310108)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C601\C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105943416901310220)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BB38\C790 \B610\B294 \C22B\C790\B9CC \D3EC\D568\D558\ACE0 \D2B9\C218 \BB38\C790\B294 \D3EC\D568\D558\C9C0 \C54A\B294 \C601\C22B\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105799038866310107)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105942620257310219)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105799754410310108)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C22B\C790\AC00 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105943358418310220)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105799271810310107)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 0\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105942816010310220)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790 0\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105798935942310107)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \B110\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105942561138310219)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105799337170310107)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 NULL \B610\B294 0\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105942929092310220)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\AC70\B098 \C22B\C790 0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105799691673310108)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105943201475310220)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105799126543310107)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 0\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105942727812310220)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790 0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105799472838310108)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 NULL\B3C4 \C544\B2C8\ACE0 0\B3C4 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105943007162310220)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\C9C0 \C54A\ACE0 \C22B\C790 0\B3C4 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105802251227310110)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BCF4\ACE0\C11C(\C55E\C73C\B85C \B2E8\CD94\B97C \D45C\C2DC\D558\B824\BA74 <b>\D655\C778</b> \B204\B974\AE30)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105802375319310110)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BCF4\ACE0\C11C(\B4A4\B85C \B2E8\CD94\B97C \D45C\C2DC\D558\B824\BA74 <b>\D655\C778</b> \B204\B974\AE30)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105803853443310111)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\C870\AC74 \BD80\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105945596987310222)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD6C\C131\C694\C18C\AC00 \B80C\B354\B9C1\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C870\AC74\C744 <strong>\BB34\C870\AC74 \BD80\C815</strong>\C73C\B85C \BCC0\ACBD\D558\BA74 \AE30\C874 \C870\AC74\C774 \BAA8\B450 \C81C\AC70\B429\B2C8\B2E4. \AD6C\C131\C694\C18C\B97C \C77C\C2DC\C801\C73C\B85C \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D558\B824\BA74 <em>\BE4C\B4DC \C635\C158</em> \C18D\C131\C744 \C0AC\C6A9\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105802180212310110)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D45C\C2DC\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105945008278310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D398\C774\C9C0\C5D0 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105798189947310106)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \BC18\D658\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105941731550310219)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\AC00 \D589\C744 \BC18\D658\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105800908247310109)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 \C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105944332776310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\B294 \C77C\BC18 \C0AC\C6A9\C790\C5D0 \C758\D574 ''\C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC''\B85C \D1A0\AE00\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105801034041310109)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\B294 \C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC\AC00 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105944436245310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\B294 \C77C\BC18 \C0AC\C6A9\C790\C5D0 \C758\D574 ''\C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC''\B85C \D1A0\AE00\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105798346728310107)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105941984207310219)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105798579141310107)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\C774 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105942161993310219)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105798498218310107)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105942041740310219)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105798625135310107)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\C774 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105942289586310219)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105803461250310111)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105803590625310111)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105801826851310109)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C778\C99D\B428(\ACF5\AC1C \C0AC\C6A9\C790\AC00 \C544\B2D8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105944739462310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B85C\ADF8\C778\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105801983934310110)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \ACF5\AC1C \C0AC\C6A9\C790\C784(\C0AC\C6A9\C790\AC00 \C778\C99D\B418\C9C0 \C54A\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105944809066310221)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B85C\ADF8\C778\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105800189890310108)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D658\ACBD\C124\C815 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105943734089310220)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\D55C <em>\D658\ACBD\C124\C815</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105800219901310108)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D658\ACBD\C124\C815 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105943877147310220)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\D55C <em>\D658\ACBD\C124\C815</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105799915920310108)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105943582675310220)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C644\C804\D788 \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105800037504310108)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105943654941310220)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12 \C77C\BD80\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105798733359310107)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105942308159310219)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105798816277310107)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105942472976310219)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105800812413310109)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 != \C81C\CD9C\B41C \D398\C774\C9C0(\AC8C\C2DC\B428)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105800795470310109)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 = \C81C\CD9C\B41C \D398\C774\C9C0(\AC8C\C2DC\B428)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105245471012309655)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105246864104309656)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74\ACFC \BE44\AD50\D560 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105246761075309656)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105248269003309657)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 <code>&ITEM.</code> \B300\CCB4 \BB38\C790\C5F4\C744 \D3EC\D568\D558\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105248100447309657)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105117814599309555)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D655\C778 \D504\B86C\D504\D2B8\B85C \B2E8\CD94\C758 \B3D9\C791\C744 \BCF4\D638\D558\C2ED\C2DC\C624. \B2E8\CD94\B97C \B204\B974\BA74 \D655\C778 \B300\D654\C0C1\C790\AC00 \D45C\C2DC\B429\B2C8\B2E4. \C774\B54C \C0AC\C6A9\C790\B294 \B2E8\CD94 \C791\C5C5\C774 \C218\D589\B418\AE30 \C804\C5D0 \D655\C778\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \AE30\B2A5\C744 \C0AC\C6A9\D558\BA74 \C0AC\C6A9\C790\AC00 \B808\CF54\B4DC \C0AD\C81C\C640 \AC19\C740 \C911\C694\D55C \C791\C5C5\C744 \C2E4\C218\B85C \C218\D589\D558\C9C0 \C54A\B3C4\B85D \D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \B300\D654\C0C1\C790\C758 \D655\C778 \B2E8\CD94\B294 \AE30\BCF8 \B2E8\CD94 \B808\C774\BE14\C5D0\C11C \D574\B2F9 \B808\C774\BE14\C744 \AC00\C838\C635\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105117779321309555)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778 \D544\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105118180932309555)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>unistr('<pre>\C9C1\C6D0 &amp;P1_ENAME.\C744(\B97C) &lt;strong&gt;\C0AD\C81C\D558\C2DC\ACA0\C2B5\B2C8\AE4C&lt;&#x2F;strong&gt;?</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105118098331309555)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778 \B300\D654\C0C1\C790\C5D0 \D45C\C2DC\D560 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105117967964309555)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105118867888309556)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105118322272309555)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \C2A4\D0C0\C77C\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105118647023309555)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.DANGER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\D5D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105118461956309555)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.INFORMATION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105118779430309555)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.SUCCESS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105118518150309555)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.WARNING.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105118215129309555)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105580722767309927)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \AC00\B2A5\D55C \BAA9\B85D\C5D0\C11C \CF58\D150\CE20 \CC98\B9AC\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105759667100310078)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.ATTACHMENT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105759758885310078)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.INLINE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105580600116309926)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20 \CC98\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105305912514309701)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C138\C158 \CFE0\D0A4\C5D0 \B300\D55C URL \B3C4\BA54\C778 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C694\CCAD URL\C758 \B9C8\C9C0\B9C9 \BE44\AD50\AC00 \C9C0\C815\B41C \B3C4\BA54\C778\ACFC \C77C\CE58\D558\C9C0 \C54A\C744 \ACBD\C6B0 \CFE0\D0A4\AC00 \BE0C\B77C\C6B0\C800\C5D0 \C804\C1A1\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('\AE30\BCF8\AC12\C740 \C694\CCAD URL\C758 \D638\C2A4\D2B8 \C774\B984\C785\B2C8\B2E4.</p>'),
unistr('<p>\ACF5\D1B5 \B3C4\BA54\C778\C744 \D3EC\D568\D558\B294 \C560\D50C\B9AC\CF00\C774\C158 \C0AC\C774\C5D0 \C138\C158 \CFE0\D0A4\B97C \ACF5\C720\D558\B824\BA74 \C774 \C18D\C131\C744 \C0AC\C6A9\D574\C11C \B35C \C81C\D55C\C801\C778 \B3C4\BA54\C778\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, <code>my.yahoo.com</code>, <code>sport.yahoo.com</code> \BC0F <code>finance.yahoo.com</code>\C740 <code>yahoo.com</code>\C758 \B3C4\BA54\C778\C774 \C785\B825\B41C \ACBD\C6B0 \B3D9\C77C\D55C \CFE0\D0A4\C5D0 \BAA8\B450 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105305833376309701)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CFE0\D0A4 \B3C4\BA54\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105305526966309700)
,p_name=>'PE.PROPERTY.COOKIE_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>URL\C758 \C138\C158 ID\C640 \D568\AED8 &PRODUCT_NAME. \C138\C158\C744 \C2DD\BCC4\D558\B294 \B370 \D544\C694\D55C \C138\C158 \CFE0\D0A4\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C138\C158 \CFE0\D0A4 \C774\B984\C744 \C9C0\C815\D558\C9C0 \C54A\C744 \ACBD\C6B0 &PRODUCT_NAME.\C5D0\B294 \AE30\BCF8\AC12\C774 \C0AC\C6A9\B429\B2C8\B2E4.</p>'),
unistr('<p>\C5EC\B7EC \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B3D9\C77C\D55C \CFE0\D0A4 \C774\B984\C744 \C785\B825\D558\BA74 \AC01 \C560\D50C\B9AC\CF00\C774\C158\C774 \B3D9\C77C\D55C \C138\C158 \CFE0\D0A4\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\B530\B77C\C11C \B3D9\C77C\D55C \CFE0\D0A4 \C774\B984\C744 \C0AC\C6A9\D574\C11C \D55C &PRODUCT_NAME. \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \B2E4\B978 &PRODUCT_NAME. \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C URL\C744 \D638\CD9C\D560 \B54C\B294 \C0C8 \C560\D50C\B9AC\CF00\C774\C158\C774 \AE30\C874 \C138\C158 \CFE0\D0A4\B97C \C0AC\C6A9\D560 \C218 \C788\C73C\BBC0\B85C \C0AC\C6A9\C790\AC00 \C778\C99D\C744 \B2E4\C2DC \C218\D589\D560 \D544\C694\AC00 \C5C6\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105305459057309700)
,p_name=>'PE.PROPERTY.COOKIE_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CFE0\D0A4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105305727978309701)
,p_name=>'PE.PROPERTY.COOKIE_PATH.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C138\C158 \CFE0\D0A4\C5D0 \B300\D55C URL \ACBD\B85C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C694\CCAD URL\C758 \C2DC\C791\C774 \C9C0\C815\B41C \ACBD\B85C\C640 \C77C\CE58\D558\C9C0 \C54A\C744 \ACBD\C6B0 \CFE0\D0A4\AC00 \BE0C\B77C\C6B0\C800\C5D0 \C804\C1A1\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('\AE30\BCF8\AC12\C740 \C694\CCAD URL\C758 \ACBD\B85C\C785\B2C8\B2E4.</p>'),
unistr('<p>\CC98\C74C\C5D0 \C900\C218 URL \ACBD\B85C\B97C \D3EC\D568\D558\B294 \C560\D50C\B9AC\CF00\C774\C158 \C0AC\C774\C5D0 \C138\C158 \CFE0\D0A4\B97C \ACF5\C720\D558\B824\BA74 \C774 \C18D\C131\C744 \C0AC\C6A9\D574\C11C \B35C \C81C\D55C\C801\C778 \ACBD\B85C\B97C \C9C0\C815\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105305601580309701)
,p_name=>'PE.PROPERTY.COOKIE_PATH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CFE0\D0A4 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105725774906310052)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\D45C\C900 \D30C\C77C \CC38\C870</dt>'),
'<dd><pre>/mycss/main.css</pre></dd>',
unistr('<dt>\C77C\BC18 \D398\C774\C9C0 \BCF4\AE30\B97C \C704\D574 /mycss/minified/\C5D0\C11C \CD5C\C18C\D654\B41C \D30C\C77C main.min.css\B97C \B85C\B4DC\D558\ACE0 \B514\BC84\ADF8 \BAA8\B4DC\B85C \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30\C5D0\C11C \C560\D50C\B9AC\CF00\C774\C158 \C2E4\D589 \C2DC /mycss/\C5D0\C11C main.css\B97C \B85C\B4DC\D558\B294 \D45C\C900 \D30C\C77C \CC38\C870\C785\B2C8\B2E4.</dt>'),
'<dd><pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre></dd>',
unistr('<dt>\C870\AC74\BD80 \B9E4\CCB4 \C9C8\C758</dt>'),
'<dd><pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre></dd>',
unistr('<dt>\C560\D50C\B9AC\CF00\C774\C158\C744 \C5C5\ADF8\B808\C774\B4DC\D560 \B54C\C640 \AC19\C774(\BC84\C804\C774 \C99D\BD84\B428) \C560\D50C\B9AC\CF00\C774\C158 \BC84\C804\C744 \CC38\C870\D558\B294 URL\C758 \C9C8\C758 \BB38\C790\C5F4\C744 \C0AC\C6A9\D558\B294 \D30C\C77C \CC38\C870\C785\B2C8\B2E4. \BE0C\B77C\C6B0\C800\AC00 \D56D\C0C1 \C0C8 \D30C\C77C\C744 \B85C\B4DC\D558\ACE0 \C774\C804\C5D0 \CE90\C2DC\B41C \D30C\C77C\C740 \BB34\C2DC\D558\B3C4\B85D \C9C0\C815\B429\B2C8\B2E4.</dt>'),
'<dd><pre>/mycss/main.css?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105212380096309631)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\C5D0 \B85C\B4DC\B41C CSS(\C885\C18D\D615 \C2DC\D2B8) \D30C\C77C URL\C744 \C785\B825\D569\B2C8\B2E4. \AC01 URL\C740 \C0C8 \D589\C5D0 \C791\C131\D574\C57C \D569\B2C8\B2E4.'),
unistr('\D30C\C77C\C758 \CD5C\C18C\D654\B41C \BC84\C804\C744 \C81C\ACF5\D560 \ACBD\C6B0, \C77C\BC18 \D398\C774\C9C0 \BCF4\AE30\B97C \C704\D574 \D30C\C77C URL\C5D0 <code>.min</code>\C744 \D3EC\D568\D558\B3C4\B85D \B300\CCB4 \BB38\C790\C5F4 <code>#MIN#</code>\C744 \C0AC\C6A9\D558\AC70\B098 <code>.minified</code>\B97C \D3EC\D568\D558\B3C4\B85D <code>#MIN_DIRECTORY#</code>\B97C \C0AC\C6A9\D560 \C218 \C788\C73C\BA70, \D398\C774\C9C0\B97C \B514\BC84\ADF8 \BAA8\B4DC\B85C \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30\C5D0\C11C \C560\D50C\B9AC\CF00\C774\C158 \C2E4\D589 \C2DC \D45C\C2DC\D560 \B54C\B294 \BE48 \BB38\C790\C5F4\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\B610\D55C \D30C\C77C URL\C5D0 \C560\D50C\B9AC\CF00\C774\C158\C758 \BC84\C804\C744 \D3EC\D568\D558\B824\B294 \ACBD\C6B0 \B300\CCB4 \BB38\C790\C5F4 <code>#APP_VERSION#</code>\C5D0 \C561\C138\C2A4\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C5EC\AE30\C5D0 \C785\B825\D55C \D30C\C77C URL\B85C \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C5D0 \C788\B294 <code>#PAGE_CSS#</code> \B300\CCB4 \BB38\C790\C5F4\C774 \BC14\B01D\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C5F4\AE30 \B610\B294 \B2EB\AE30 <code>link</code> \D0DC\ADF8\B294 \D3EC\D568\D558\C9C0 \C54A\C544\B3C4 \B429\B2C8\B2E4. \D30C\C77C URL\B9CC \D3EC\D568\D558\C2ED\C2DC\C624.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105212233961309631)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105758572152310077)
,p_name=>'PE.PROPERTY.CSS_STYLE.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C774 \C18D\C131\C744 <code>color:#FF0000;</code>\C73C\B85C \C124\C815\D558\BA74 \C5F4\C758 \D14D\C2A4\D2B8 \C0C9\C0C1\C774 \BE68\AC04\C0C9\C73C\B85C \BCC0\ACBD\B418\ACE0 \B2E4\C74C HTML\C774 \C0DD\C131\B429\B2C8\B2E4.</dt>'),
'<dd><pre>',
'&lt;span style="color:#FF0000"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105576005196309923)
,p_name=>'PE.PROPERTY.CSS_STYLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C758 \AC12\C5D0 \C801\C6A9\D560 CSS \C2A4\D0C0\C77C\C744 \C785\B825\D569\B2C8\B2E4. CSS \C2A4\D0C0\C77C\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105575962089309923)
,p_name=>'PE.PROPERTY.CSS_STYLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105549005787309902)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \AC12\C758 \C2DC\C791 \BC0F \C885\B8CC \D14C\B450\B9AC\B97C \AD6C\BD84\D558\AE30 \C704\D55C \AD6C\BD84 \BB38\C790\B97C \C785\B825\D569\B2C8\B2E4. \AE30\BCF8 \AD6C\BD84\C790\B294 \D070 \B530\C634\D45C\C785\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105548968518309901)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSV \B458\B7EC\C2F8\AE30 \BB38\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105583930164309929)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \BCF4\ACE0\C11C \CF58\D150\CE20\B97C CSV \D30C\C77C\B85C \B2E4\C6B4\B85C\B4DC\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <em>CSV \B2E4\C6B4\B85C\B4DC</em>\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D558\B824\BA74 <code>#CSV_LINK#</code> \B300\CCB4 \BB38\C790\C5F4\C774 \D3EC\D568\B41C \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D558\ACE0 \C774 \C635\C158\C744 <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105583866082309929)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSV \C775\C2A4\D3EC\D2B8 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105548868122309901)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AD6C\BD84 \AE30\D638\B97C \C785\B825\D569\B2C8\B2E4. \AC12\C744 \C785\B825\D558\C9C0 \C54A\C73C\BA74 \D604\C7AC NLS \C124\C815\C5D0 \B530\B77C \CF64\B9C8 \B610\B294 \C138\BBF8\CF5C\B860\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105548771094309901)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSV \AD6C\BD84 \AE30\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105216887083309634)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C5D0 \CC98\C74C \B4E4\C5B4\AC08 \B54C \CEE4\C11C\C5D0 \D3EC\CEE4\C2A4\B97C \C9C0\C815\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105719366319310047)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C758 \CCAB\BC88\C9F8 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105719451026310047)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE4\C11C \CD08\C810\C740 &PRODUCT_NAME. \C5D4\C9C4\C73C\B85C \C0DD\C131\B41C JavaScript\B97C \C0AC\C6A9\D574\C11C \D398\C774\C9C0\C758 \CCAB\BC88\C9F8 \D544\B4DC\C5D0 \BC30\CE58\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105719591146310047)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE4\C11C\B97C \B450\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105719699273310047)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\CEE4\C11C\C5D0 \D3EC\CEE4\C2A4\AC00 \D45C\C2DC\B418\C9C0 \C54A\ACE0 JavaScript\AC00 \C0DD\C131\B418\C9C0 \C54A\C2B5\B2C8\B2E4.<br>'),
unistr('\C0DD\C131\B41C JavaScript\AC00 \C0AC\C6A9\C790\C815\C758 JavaScript\C640 \CDA9\B3CC\D560 \ACBD\C6B0 \C774 \C635\C158\C744 \C120\D0DD\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105211447884309630)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE4\C11C \D3EC\CEE4\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105309593808309704)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C601\C5ED\C758 \D45C\C2DC \C18D\C131\C744 \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105740387748310063)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.0.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105740231557310063)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\C73C\BA70 \AE30\BCF8\C801\C73C\B85C \D45C\C2DC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105740147168310063)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\C73C\BA70 \AE30\BCF8\C801\C73C\B85C \D45C\C2DC\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105309460528309704)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \AC00\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105308573305309703)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \C601\C5ED \C544\B798\C5D0 \D45C\C2DC\B418\B294 \B9C1\D06C\C758 \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C774 \B9C1\D06C\B294 \C601\C5ED \C0AC\C6A9\C790\C815\C758 \D398\C774\C9C0\C5D0 \B300\D55C \C561\C138\C2A4\B97C \C81C\ACF5\D569\B2C8\B2E4.'),
unistr('\C774 \B808\C774\BE14\C740 \C0AC\C6A9\C790\C815\C758 \AC00\B2A5\D55C \C601\C5ED\C5D0 \B300\D574\C11C\B9CC \D45C\C2DC\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105308449331309703)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105614022475309953)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \B2E8\CD94\C5D0 \D3EC\D568\D560 HTML \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.'),
'<ul>',
unistr('  <li><strong>HTML \B2E8\CD94</strong> \C720\D615\C758 \B2E8\CD94\C758 \ACBD\C6B0, \C774 \D14D\C2A4\D2B8\AC00 HTML \C694\C18C \C815\C758\C5D0 \CD94\AC00\B429\B2C8\B2E4.</li>'),
unistr('  <li>\D15C\D50C\B9AC\D2B8\B97C \AE30\BC18\C73C\B85C \D558\B294 \B2E8\CD94\C758 \ACBD\C6B0 \D15C\D50C\B9AC\D2B8\C5D0 <code>#BUTTON_ATTRIBUTES#</code> \B300\CCB4 \BB38\C790\C5F4\C774 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.</li>'),
'</ul>',
unistr('<p>\C774 \C18D\C131\C744 \C0AC\C6A9\D574\C11C \D0ED \C815\C9C0\B97C \C81C\C5B4\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105614217815309953)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C758 \B300\CCB4 \BB38\C790\C5F4 <code>#REPORT_ATTRIBUTES#</code>\AC00 \C774 \AC12\C73C\B85C \BC14\B01D\B2C8\B2E4. <code>#REPORT_ATTRIBUTES#</code> \B300\CCB4 \BB38\C790\C5F4\C740 \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C758 \D589 \C55E \C18D\C131\C5D0\C11C\B9CC \BC14\B01D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105454134545309823)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \C694\C18C HTML \D0DC\ADF8\C5D0 \D3EC\D568\D560 \CD94\AC00 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4. <code>size</code> \BC0F <code>id</code> HTML \C18D\C131\C740 \C0DD\C131\B418\BBC0\B85C \C81C\ACF5\D558\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4. <code>class</code> HTML \C18D\C131\C758 \ACBD\C6B0 \B300\C2E0 \C804\C6A9 <em>CSS \D074\B798\C2A4</em> \C18D\C131\C744 \C0AC\C6A9\D558\B294 \AC83\C774 \B354 \C88B\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105613926105309953)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \C694\C18C HTML \D0DC\ADF8\C5D0 \D3EC\D568\D560 \CD94\AC00 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4. <code>size</code> \BC0F <code>id</code> HTML \C18D\C131\C740 \C0DD\C131\B418\BBC0\B85C \C81C\ACF5\D558\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4. <code>class</code> HTML \C18D\C131\C758 \ACBD\C6B0 \B300\C2E0 \C804\C6A9 <em>CSS \D074\B798\C2A4</em> \C18D\C131\C744 \C0AC\C6A9\D558\B294 \AC83\C774 \B354 \C88B\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105614153864309953)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18D\C131\C5D0 \B300\CCB4\B41C \AC12\C744 \C785\B825\D569\B2C8\B2E4. \B300\CCB4 \BB38\C790\C5F4 <code>#REGION_ATTRIBUTES#</code>\B97C \D3EC\D568\D558\B294 \C601\C5ED \D15C\D50C\B9AC\D2B8\B294 \C774 \AC12\C73C\B85C \B300\CCB4\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105614300359309953)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C758 \B300\CCB4 \BB38\C790\C5F4 <code>#REPORT_ATTRIBUTES#</code>\AC00 \C774 \AC12\C73C\B85C \BC14\B01D\B2C8\B2E4. <code>#REPORT_ATTRIBUTES#</code> \B300\CCB4 \BB38\C790\C5F4\C740 \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C758 \D589 \C55E \C18D\C131\C5D0\C11C\B9CC \BC14\B01D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105613863096309953)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \D0DC\ADF8\C5D0 \D3EC\D568\D560 \ACF5\BC31\C73C\B85C \AD6C\BD84\B41C \CD94\AC00 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('HTML CLASS \C18D\C131\C758 \ACBD\C6B0 Oracle\C740 \C804\C6A9 CSS \D074\B798\C2A4 \C18D\C131\C744 \C0AC\C6A9\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105613705915309953)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105525131647309882)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C694\C18C\C5D0 \C0AC\C6A9\D560 \C0AC\C6A9\C790\C815\C758 \B3C4\AD6C \C124\BA85 \B610\B294 \B370\C774\D130\BCA0\C774\C2A4 \AE30\BC18 \C0C9\C0C1\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\B294 \C0AC\C6A9\C790\C815\C758 \C5F4 \C774\B984\C744 \C9C0\C815\D569\B2C8\B2E4. \C0C1\C790 \ADF8\B9BC \CC28\D2B8\C758 \ACBD\C6B0 \C120\D0DD\B41C \AC12 \C5F4 \B9E4\D551\ACFC \C5F4\C774 \C77C\CE58\D558\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4. \AC12 \C5F4 \B9E4\D551\ACFC \C77C\CE58\D558\B294 \C5F4\C744 \C120\D0DD\D558\BA74 \CC28\D2B8\C5D0 \C0AC\C6A9\C790\C815\C758 \C5F4\C774 \C0AC\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105525082478309882)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105215308004309633)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\B41C \C120\C5B8\C801\C778 \C774\BCA4\D2B8\AC00 \CDA9\BD84\D558\C9C0 \C54A\C740 \ACBD\C6B0 \C0AC\C6A9\C790\C815\C758 JavaScript \C774\BCA4\D2B8 \C774\B984\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105215243135309633)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105531809183309888)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C791\C5C5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105532383038309888)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.DELETE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105531976663309888)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_COLLECTION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C778\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105532043938309888)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_SINGLE_ROW.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C \D589 \C778\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105532133391309888)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.INSERT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C0BD\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105532217099309888)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.UPDATE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105531701358309888)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105769633912310085)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105610278812309950)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B2EC\B825\C5D0 \D45C\C2DC\B418\B294 \B370\C774\D130\C758 \BC30\ACBD\C5D0 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105610118968309950)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \BC30\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105045048813309502)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D56D\BAA9 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \B370\C774\D130\BCA0\C774\C2A4 \C5F4 \C774\B984(\B300\C18C\BB38\C790 \AD6C\BD84)\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C5F4\C740 \D3FC \C601\C5ED \B0B4\C5D0 \C9C0\C815\B41C \B370\C774\D130 \C18C\C2A4\C5D0 \C874\C7AC\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C5F4 \C774\B984\C774 \CC38\C870\B418\B294 \D14C\C774\BE14\C5D0 \C874\C7AC\D558\C9C0 \C54A\C73C\BA74 \B7F0\D0C0\C784 \C2DC \C624\B958\AC00 \BC1C\C0DD\D558\ACE0 \D398\C774\C9C0\AC00 \B85C\B4DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('\B9C8\CC2C\AC00\C9C0\B85C, \C815\C758\B41C \B0B4\C7A5\B41C \C778\CD9C \D589 \D504\B85C\C138\C2A4\AC00 \C5C6\ACE0 \C18C\C2A4 \C720\D615\C774 <strong>\B370\C774\D130\BCA0\C774\C2A4 \C5F4</strong>\C778 \D56D\BAA9\C774 \C788\C73C\BA74 \C624\B958\AC00 \BC1C\C0DD\D558\ACE0 \D398\C774\C9C0\B97C \B80C\B354\B9C1\D558\B824\ACE0 \C2DC\B3C4\D560 \B54C \D398\C774\C9C0\AC00 \B85C\B4DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105044949389309502)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105044894220309502)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0 \D56D\BAA9\C5D0 \B300\D55C \C5F0\AD00\B41C \D3FC \C601\C5ED\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105044709915309502)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105810197454310116)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105610471620309950)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B2EC\B825\C758 \B370\C774\D130\C5D0 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105610398766309950)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105450037529309819)
,p_name=>'PE.PROPERTY.DATA_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \B370\C774\D130\BCA0\C774\C2A4 \C5F4\C758 \B370\C774\D130 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106116420999310380)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BFILE.D'
,p_message_language=>'ko'
,p_message_text=>'BFILE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106116210396310380)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BLOB.D'
,p_message_language=>'ko'
,p_message_text=>'BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106116170329310380)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.CLOB.D'
,p_message_language=>'ko'
,p_message_text=>'CLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106115501242310379)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.DATE.D'
,p_message_language=>'ko'
,p_message_text=>'DATE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106116017277310379)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_D2S.D'
,p_message_language=>'ko'
,p_message_text=>'INTERVAL DAY TO SECOND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106115924971310379)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_Y2M.D'
,p_message_language=>'ko'
,p_message_text=>'INTERVAL YEAR TO MONTH'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106115453640310379)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.NUMBER.D'
,p_message_language=>'ko'
,p_message_text=>'NUMBER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106116389174310380)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.ROWID.D'
,p_message_language=>'ko'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105115701256309553)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'ko'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106115613882310379)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_language=>'ko'
,p_message_text=>'TIMESTAMP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106115831974310379)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_LTZ.D'
,p_message_language=>'ko'
,p_message_text=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106115783305310379)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_TZ.D'
,p_message_language=>'ko'
,p_message_text=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106115313923310379)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.VARCHAR2.D'
,p_message_language=>'ko'
,p_message_text=>'VARCHAR2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105449941113309819)
,p_name=>'PE.PROPERTY.DATA_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105607214975309948)
,p_name=>'PE.PROPERTY.DATE_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825\C5D0 \BC30\CE58\B420 \B0A0\C9DC\B97C \D3EC\D568\D558\B294 \D14C\C774\BE14\C774\B098 \C9C8\C758\C758 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105607113783309948)
,p_name=>'PE.PROPERTY.DATE_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105607453870309948)
,p_name=>'PE.PROPERTY.DATE_FORMAT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825\C5D0 \C2DC\AC04 \B610\B294 \B0A0\C9DC \AC12\B9CC \D45C\C2DC\D558\B824\B294\C9C0\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105607332877309948)
,p_name=>'PE.PROPERTY.DATE_FORMAT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105575204200309922)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C5D0 \B300\D574 \B0A0\C9DC \C120\D0DD\AE30\C5D0 \C801\C6A9\D560 \D615\C2DD \B9C8\C2A4\D06C\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105755685868310075)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY.D'
,p_message_language=>'ko'
,p_message_text=>'DD/MM/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105755407918310074)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DASH.D'
,p_message_language=>'ko'
,p_message_text=>'DD-MM-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105755550000310074)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DOT.D'
,p_message_language=>'ko'
,p_message_text=>'DD.MM.YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105756255472310075)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI.D'
,p_message_language=>'ko'
,p_message_text=>'DD/MM/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105756008406310075)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DASH.D'
,p_message_language=>'ko'
,p_message_text=>'DD-MM-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105756114124310075)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DOT.D'
,p_message_language=>'ko'
,p_message_text=>'DD.MM.YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105755964857310075)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI.D'
,p_message_language=>'ko'
,p_message_text=>'DD/MM/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105755704284310075)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DASH.D'
,p_message_language=>'ko'
,p_message_text=>'DD-MM-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105755850554310075)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DOT.D'
,p_message_language=>'ko'
,p_message_text=>'DD.MM.YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105756333642310075)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR.D'
,p_message_language=>'ko'
,p_message_text=>'DD-MON-RR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105756545517310075)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH24_MI.D'
,p_message_language=>'ko'
,p_message_text=>'DD-MON-RR HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105756471910310075)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH_MI.D'
,p_message_language=>'ko'
,p_message_text=>'DD-MON-RR HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105756637299310075)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY.D'
,p_message_language=>'ko'
,p_message_text=>'DD-MON-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105756812724310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH24_MI.D'
,p_message_language=>'ko'
,p_message_text=>'DD-MON-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105756761925310075)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH_MI.D'
,p_message_language=>'ko'
,p_message_text=>'DD-MON-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105756910395310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY.D'
,p_message_language=>'ko'
,p_message_text=>'MM/DD/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105757195501310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH24_MI.D'
,p_message_language=>'ko'
,p_message_text=>'MM/DD/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105757059730310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH_MI.D'
,p_message_language=>'ko'
,p_message_text=>'MM/DD/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105757294026310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD.D'
,p_message_language=>'ko'
,p_message_text=>'RR-MON-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105757479206310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH24_MI.D'
,p_message_language=>'ko'
,p_message_text=>'RR-MON-DD HH24:MI'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105757322726310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH_MI.D'
,p_message_language=>'ko'
,p_message_text=>'RR-MON-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105755110822310074)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_DATE_FORMAT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \B0A0\C9DC \D615\C2DD \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105755253573310074)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_FORMAT_MASK.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D615\C2DD \B9C8\C2A4\D06C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105755383636310074)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_FORMAT_MASK.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \D615\C2DD \B9C8\C2A4\D06C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105757531908310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_DOT.D'
,p_message_language=>'ko'
,p_message_text=>'YYYY.DD.MM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105757750351310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH24_MI_DOT.D'
,p_message_language=>'ko'
,p_message_text=>'YYYY.DD.MM HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105757631823310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH_MI_DOT.D'
,p_message_language=>'ko'
,p_message_text=>'YYYY.DD.MM HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105757829638310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD.D'
,p_message_language=>'ko'
,p_message_text=>'YYYY-MM-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105758207165310077)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI.D'
,p_message_language=>'ko'
,p_message_text=>'YYYY-MM-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105758359020310077)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH.D'
,p_message_language=>'ko'
,p_message_text=>'YYYY/MM/DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105758086404310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI.D'
,p_message_language=>'ko'
,p_message_text=>'YYYY-MM-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105758133088310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI_SLASH.D'
,p_message_language=>'ko'
,p_message_text=>'YYYY/MM/DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105757906440310076)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_SLASH.D'
,p_message_language=>'ko'
,p_message_text=>'YYYY/MM/DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105575111209309922)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \B9C8\C2A4\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105611521374309951)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B2EC \B300\D654\C0C1\C790\B97C \D638\CD9C\D558\B824\B294 \B300\C0C1\C744 \B204\B985\B2C8\B2E4. \AE30\C874 \C774\BCA4\D2B8 \C678\BD80\C5D0\C11C \B2EC\B825 \C140\C744 \B20C\B7EC\C11C \C774\BCA4\D2B8\B97C \C0DD\C131\D560 \B54C \B2EC\B825\C774 \D638\CD9C\D558\B294 \B300\C0C1 \B9C1\D06C\B97C \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105611408938309951)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105239708489309651)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C218\D589\D558\B824\B294 \C791\C5C5\C744 \C9C0\C815\D569\B2C8\B2E4. \C9C0\C6D0\B418\B294 \C791\C5C5\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\C5D0 \B530\B77C \C5EC\AE30\C5D0\C11C \CD94\AC00 \B3D9\C801 \C791\C5C5 \D50C\B7EC\ADF8\C778\C744 \C0AC\C6A9\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \D50C\B7EC\ADF8\C778\C740 <em>&lt;My Plug-in&gt; [Plug-in]</em>\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('\B2E4\C74C \D50C\B7EC\ADF8\C778\C740 \C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \ACF5\C720 \AD6C\C131\C694\C18C \B0B4\C5D0 \C124\CE58\B429\B2C8\B2E4.</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105239620819309651)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105563105591309913)
,p_name=>'PE.PROPERTY.DA_EVENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \AC00\B2A5\D55C \BAA9\B85D\C5D0\C11C \C801\D569\D55C \B3D9\C801 \C791\C5C5 \C774\BCA4\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105563051684309912)
,p_name=>'PE.PROPERTY.DA_EVENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105926246002310204)
,p_name=>'PE.PROPERTY.DB_SESSION_CLEANUP.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B9AC PL/SQL \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105926160515310204)
,p_name=>'PE.PROPERTY.DB_SESSION_INIT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30\D654 PL/SQL \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105595107974309938)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106036205101310306)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BCF4\C548 \C18D\C131\C5D0 \C815\C758\B41C \C124\C815\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105219211898309636)
,p_name=>'PE.PROPERTY.DEEP_LINKING.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D398\C774\C9C0\C5D0 \B300\D55C \C678\BD80 URL \C694\CCAD \CC98\B9AC \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C774 \D398\C774\C9C0\C5D0 \B300\D55C \C774 \C560\D50C\B9AC\CF00\C774\C158 \B0B4\BD80\C758 \D398\C774\C9C0 \C694\CCAD\C740 \B525 \B9C1\D06C\B85C \AC04\C8FC\B418\C9C0 \C54A\C73C\BA70 \C774 \C18D\C131\C758 \C124\C815\C5D0 \C758\D574 \C81C\C5B4\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105720278848310048)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105720365240310048)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('URL\C5D0 \C801\D569\D55C \C138\C158 ID\AC00 \D3EC\D568\B418\C9C0 \C54A\C740 \ACBD\C6B0 &PRODUCT_NAME.\C774(\AC00) \C0C8 \C138\C158\C744 \C2DC\C791\D558\ACE0 \C774 \D398\C774\C9C0\AC00 \C544\B2CC \C560\D50C\B9AC\CF00\C774\C158 \D648 \D398\C774\C9C0\B85C \C0AC\C6A9\C790\B97C \C7AC\C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105720082166310048)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105720166437310048)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D398\C774\C9C0\AC00 URL\C5D0\C11C \B300\C0C1 \D398\C774\C9C0\B85C \C9C0\C815\B41C \ACBD\C6B0\C5D0\B294 \ACB0\ACFC\C801\C73C\B85C \C774 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\B429\B2C8\B2E4.<br>'),
unistr('\C0AC\C6A9\C790\AC00 \C544\C9C1 \C778\C99D\B418\C9C0 \C54A\C558\ACE0 \D398\C774\C9C0\AC00 \ACF5\C6A9\C774 \C544\B2C8\BA74 \C0AC\C6A9\C790\C5D0\AC8C \B85C\ADF8\C778 \D504\B86C\D504\D2B8\AC00 \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0 \C131\ACF5\C801\C73C\B85C \B85C\ADF8\C778\B41C \B2E4\C74C\C5D0\B294 \C0AC\C6A9\C790\AC00 \C774 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105219149447309636)
,p_name=>'PE.PROPERTY.DEEP_LINKING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B525 \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105360386791309743)
,p_name=>'PE.PROPERTY.DEFAULT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\AC00 \AE30\BCF8 \C560\D50C\B9AC\CF00\C774\C158 \C778\D130\D398\C774\C2A4\C778\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105360229260309743)
,p_name=>'PE.PROPERTY.DEFAULT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105209322450309629)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C775\C2A4\D3EC\D2B8\D560 \B54C \C774 \AD6C\C131\C694\C18C\C5D0 \C801\C6A9\B418\B294 \AE30\BCF8 \BE4C\B4DC \C635\C158\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C635\C158\C740 \C775\C2A4\D3EC\D2B8 \C635\C158\C5D0 \C758\D574 \BB34\D6A8\D654\B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105717722788310046)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C678')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106027797177310297)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B418\BA70 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105717898062310046)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106027890281310297)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815\B418\BA70 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105209244616309628)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C775\C2A4\D3EC\D2B8 \C2DC \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105450821941309820)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C758 \AE30\BCF8\AC12\C774 \ACB0\C815\B418\B294 \BC29\C2DD\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105950822762310226)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105950923737310226)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>\D45C\D604\C2DD</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105951039717310226)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105951169088310226)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>\D568\C218 \BCF8\BB38</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105451134335309820)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105451283021309820)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \C138\C158 \C0C1\D0DC\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105451778150309821)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105451809958309821)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C785\B825\D55C <em>\C2DC\D000\C2A4</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4. \C774\AC83\C740 "\D2B9\C218" \AE30\BCF8 \C720\D615\C73C\B85C, \B300\D654\C2DD \ADF8\B9AC\B4DC DML \D504\B85C\C138\C2A4\C758 \C77C\BD80\B85C \C2E4\D589\B418\BA70 \D398\C774\C9C0 \B85C\B4DC \C911\C5D0\B294 \C2E4\D589\B418\C9C0 <em>\C54A\C2B5\B2C8\B2E4</em>. <strong>\C0BD\C785 \D6C4 \AE30\BCF8 \D0A4 \BC18\D658</strong>\C744 \C0AC\C6A9\D560 \C218 \C5C6\B294 \ACBD\C6B0, \C608\B97C \B4E4\C5B4 \BDF0 \BC0F INSTEAD OF \D2B8\B9AC\AC70\C5D0 \B300\D574 \C791\C5C5\D558\AC70\B098 \B370\C774\D130\BCA0\C774\C2A4 \B9C1\D06C\C5D0 \B300\D574 \C791\C5C5\D558\B294 \ACBD\C6B0 \C790\B3D9 \C0DD\C131\B41C \AE30\BCF8 \D0A4 \AC12\C5D0 \C774 \C720\D615\C744 \C0AC\C6A9\D569\B2C8\B2E4. \C2DC\D000\C2A4 \C774\B984\C740 ')
||unistr('\B300\C18C\BB38\C790\B97C \AD6C\BD84\D569\B2C8\B2E4. \B300\C18C\BB38\C790\AC00 \D63C\D569 \B41C \C2DC\D000\C2A4 \C774\B984\C744 \B098\D0C0\B0B4\B824\BA74 \D070 \B530\C634\D45C\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624("mySequence").</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105451398565309820)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105451462499309821)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>SQL \C9C8\C758</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105451563714309821)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF5C\B860\C73C\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \BC18\D658\D558\B294 SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105451661776309821)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C785\B825\B41C <em>SQL \C9C8\C758</em>\C5D0\C11C \BC18\D658\B41C \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \AC12 \BAA9\B85D\C73C\B85C \C124\C815\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \BAA9\B85D\C740 \C5F4\C774 \CCB4\D06C\BC15\C2A4, \B77C\B514\C624 \ADF8\B8F9 \B610\B294 \C154\D2C0\B85C \D45C\C2DC\B41C \ACBD\C6B0 \D544\C694\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105450926950309820)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105451070140309820)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\C815\C801</em> \AC12\C5D0 \C785\B825\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105450722082309820)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105973995021310243)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D45C\D604\C2DD\C744 \D3C9\AC00\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105974395692310243)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105974235313310243)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105974117769310243)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105974446965310247)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105974098507310243)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ko'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105973885812310243)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105975938233310248)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105976254908310248)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105976104643310248)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105976050997310248)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105976362658310248)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105975846713310248)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105598868638309941)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12\C744 \C800\C7A5\D558\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105598741765309941)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105975530255310248)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C758 \AC12\C744 \C0DD\C131\D558\B294 Java \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105975462518310247)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105977167118310249)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C5D0 \B300\D55C \AC12\C744 \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105977001959310249)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105975381409310247)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105975251096310247)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C758 \AC12\C744 \C0DD\C131\D558\B294 JavaScript \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105975143404310247)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105976931178310249)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105976813255310249)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C5D0 \B300\D55C \AC12\C744 \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105976762072310249)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105975019857310247)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105974942211310247)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C758 \AC12\C744 \C0DD\C131\D558\B294 PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105974873577310247)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105976611811310249)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105976552945310249)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C5D0 \B300\D55C \AC12\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105976427631310248)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105975712165310248)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C758 \AC12\C744 \C0DD\C131\D558\B294 Python \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105975615936310248)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105977355934310249)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C5D0 \B300\D55C \AC12\C744 \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105977249942310249)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105452492078309822)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C5D0 \B300\D55C \AE30\BCF8\AC12\C744 \BC18\D658\D558\B294 \B370\C774\D130\BCA0\C774\C2A4 \C2DC\D000\C2A4\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105452342827309821)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105974753143310247)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \AD00\B9AC\C790\C774\ACE0 \BD80\C11C\AC00 \C2DC\CE74\ACE0\C5D0 \C788\C744 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105974641473310247)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C758 \AC12\C744 \C0DD\C131\D558\B294 SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105974551636310247)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105452091349309821)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C5D0 \B300\D55C \AE30\BCF8\AC12\C744 \BC18\D658\D558\B294 SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105451926697309821)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105452270676309821)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C5D0 \B300\D55C \AE30\BCF8\AC12\C778 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \AC12 \BAA9\B85D\C744 \BC18\D658\D558\B294 SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105452102272309821)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758 \CF5C\B860')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105232929284309646)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C5D0 \B300\D55C \AE30\BCF8\AC12\C744 \C9C0\C815\D569\B2C8\B2E4. \AE30\BCF8\AC12\C740 \D56D\BAA9 \AC12\C774 \C138\C158 \C0C1\D0DC\C5D0\C11C \D30C\C0DD\B418\C9C0 \C54A\C744 \B54C\C640 \C18C\C2A4 \AC12\C774 \B110\C77C \B54C \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105232850298309646)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105232772298309646)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C758 \AE30\BCF8\AC12 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105950210906310225)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105950393207310225)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>\D45C\D604\C2DD</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105950453691310225)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105950587804310225)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>\D568\C218 \BCF8\BB38</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105043624369309501)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105043754966309501)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \C138\C158 \C0C1\D0DC\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105044280818309502)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105044380103309502)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C785\B825\D55C <em>\C2DC\D000\C2A4</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4. \C774\AC83\C740 "\D2B9\C218" \AE30\BCF8 \C720\D615\C73C\B85C, \D3FC \C601\C5ED DML \D504\B85C\C138\C2A4\C758 \C77C\BD80\B85C \C2E4\D589\B418\BA70 \D398\C774\C9C0 \B85C\B4DC \C911\C5D0\B294 \C2E4\D589\B418\C9C0 <em>\C54A\C2B5\B2C8\B2E4</em>. <strong>\C0BD\C785 \D6C4 \AE30\BCF8 \D0A4 \BC18\D658</strong>\C744 \C0AC\C6A9\D560 \C218 \C5C6\B294 \ACBD\C6B0, \C608\B97C \B4E4\C5B4 \BDF0 \BC0F INSTEAD OF \D2B8\B9AC\AC70\C5D0 \B300\D574 \C791\C5C5\D558\AC70\B098 \B370\C774\D130\BCA0\C774\C2A4 \B9C1\D06C\C5D0 \B300\D574 \C791\C5C5\D558\B294 \ACBD\C6B0 \C790\B3D9 \C0DD\C131\B41C \AE30\BCF8 \D0A4 \AC12\C5D0 \C774 \C720\D615\C744 \C0AC\C6A9\D569\B2C8\B2E4. \C2DC\D000\C2A4 \C774\B984\C740 \B300\C18C\BB38')
||unistr('\C790\B97C \AD6C\BD84\D569\B2C8\B2E4. </p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105043809208309501)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105043979174309502)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>SQL \C9C8\C758</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105044046072309502)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF5C\B860\C73C\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \BC18\D658\D558\B294 SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105044130671309502)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C785\B825\B41C <em>SQL \C9C8\C758</em>\C5D0\C11C \BC18\D658\B41C \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \AC12 \BAA9\B85D\C73C\B85C \C124\C815\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \BAA9\B85D\C740 \C5F4\C774 \CCB4\D06C\BC15\C2A4, \B77C\B514\C624 \ADF8\B8F9 \B610\B294 \C154\D2C0\B85C \D45C\C2DC\B41C \ACBD\C6B0 \D544\C694\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105735036603310059)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105043592489309501)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\C815\C801</em> \AC12\C5D0 \C785\B825\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105232619719309646)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105462453783309830)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0 \B300\D574 \CC28\D2B8\B97C \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105462314678309830)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \BDF0 \C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105438099364309809)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D589\C744 \C0AD\C81C\D560 \C218 \C788\B294 \C0AC\C6A9\C790\B97C \C81C\D55C\D558\AE30 \C704\D55C \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \D589\C744 \C0AD\C81C\D558\B824\BA74 \C774 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \D574\B2F9 \C0AC\C6A9\C790\C5D0 \B300\D574 TRUE\B85C \D3C9\AC00\B418\C5B4\C57C \D569\B2C8\B2E4.'),
unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \C81C\ACF5\B418\C9C0 \C54A\C73C\BA74 \BAA8\B4E0 \C0AC\C6A9\C790\AC00 \C774 \B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0\C11C \D589\C744 \C0AD\C81C\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105437976329309809)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105571461777309919)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D328\C2EF \B610\B294 \D544\D130\AC00 \D45C\C2DC\B418\C5B4\C57C \D560\C9C0 \C5EC\BD80\B97C \C81C\C5B4\D558\B824\BA74 \B2E4\B978 \D328\C2EF \B610\B294 \D544\D130\C758 \AC12\C744 \D655\C778\D558\B294 \C870\AC74\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105571587813309919)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC19\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105571616564309919)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\C18D \B300\C0C1 <em>\D328\C2EF \B610\B294 \D544\D130</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\ACFC \AC19\C740\C9C0 \C5EC\BD80\B97C \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105571986667309920)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105572081032309920)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\C18D \B300\C0C1 <em>\D328\C2EF \B610\B294 \D544\D130</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\BAA9\B85D</em>\C5D0 \C788\B294\C9C0 \C5EC\BD80\B97C \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105571708911309919)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC19\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105571878510309920)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\C18D \B300\C0C1 <em>\D328\C2EF \B610\B294 \D544\D130</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\ACFC \AC19\C9C0 \C54A\C740\C9C0 \C5EC\BD80\B97C \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105572125652309920)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105572267797309920)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\C18D \B300\C0C1 <em>\D328\C2EF \B610\B294 \D544\D130</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\BAA9\B85D</em>\C5D0 \C5C6\B294\C9C0 \C5EC\BD80\B97C \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105572579871309920)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C774 \B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105572647140309920)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\C18D \B300\C0C1 <em>\D328\C2EF \B610\B294 \D544\D130</em>\C758 \AC12\C774 \BE44\C5B4 \C788\C9C0 \C54A\C740\C9C0 \C5EC\BD80\B97C \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105572316881309920)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C774 \B110\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105572410903309920)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\C18D \B300\C0C1 <em>\D328\C2EF \B610\B294 \D544\D130</em>\C758 \AC12\C774 \BE44\C5B4 \C788\B294\C9C0 \C5EC\BD80\B97C \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105571373903309919)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105573072545309920)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \AC12 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105572985766309920)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105572825590309920)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105572733090309920)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105571276633309919)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D328\C2EF\C774 \D45C\C2DC\B418\C5B4\C57C \D560\C9C0 \C5EC\BD80\B97C \ACB0\C815\D558\B824\BA74 \D655\C778\D574\C57C \D560 \C5F0\AD00\B41C \D328\C2EF\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105571136904309919)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105896735952310182)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \CCB4\D06C\BC15\C2A4\AC00 \D45C\C2DC\B418\C5B4\C57C \D560\C9C0 \C5EC\BD80\B97C \ACB0\C815\D558\AE30 \C704\D574 \C120\D0DD\D574\C57C \D560 \C5F0\AD00\B41C \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105896601811310182)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\BC15\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105259247757309665)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D544\D130\AC00 \D45C\C2DC\B418\C5B4\C57C \D560\C9C0 \C5EC\BD80\B97C \ACB0\C815\D558\B824\BA74 \D655\C778\D574\C57C \D560 \C5F0\AD00\B41C \D544\D130\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105259189563309665)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105259403381309665)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \CCB4\D06C\BC15\C2A4\AC00 \D45C\C2DC\B418\C5B4\C57C \D560\C9C0 \C5EC\BD80\B97C \ACB0\C815\D558\AE30 \C704\D574 \C120\D0DD\D574\C57C \D560 \C5F0\AD00\B41C \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105259328958309665)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\BC15\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105811383963310117)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('$$$ DJP \D604\C7AC \C228\ACA8\C9D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105602269347309943)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C0DD \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106116724178310380)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B300\D654\C2DD \BCF4\ACE0\C11C\C5D0 \B300\D55C \C124\BA85\C744 \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105545849870309899)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \ADF8\B8F9\C5D0 \B300\D55C \C124\BA85\C744 \C785\B825\D569\B2C8\B2E4. \C774 \C124\BA85\C740 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105213350455309632)
,p_name=>'PE.PROPERTY.DESCRIPTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85\C744 \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105213292605309631)
,p_name=>'PE.PROPERTY.DESCRIPTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105751785128310072)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;/table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105554011799309905)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D589 \B4A4\C5D0 \D45C\C2DC\D560 HTML\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105553952862309905)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105751569526310071)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105553675287309905)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D589 \C55E\C5D0 \D45C\C2DC\D560 HTML\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105553511562309905)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105453360783309822)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \BCF4\AE30\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <strong>\C124\C815</strong>\C744 \C120\D0DD\D558\BA74 \C138\BD80\C815\BCF4 \BCF4\AE30 \C544\C774\CF58\C774 \B300\D654\C2DD \BCF4\ACE0\C11C\C758 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C \B610\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC \BDF0 \B2E8\CD94\C5D0 \CD94\AC00\B418\ACE0, \C0AC\C6A9\C790\AC00 \D574\B2F9 \C544\C774\CF58\C744 \D1B5\D574 \C774 \BDF0\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105553401029309905)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \BCF4\AE30\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <strong>\C124\C815</strong>\C744 \C120\D0DD\D558\BA74 \C138\BD80\C815\BCF4 \BCF4\AE30 \C544\C774\CF58\C774 \B300\D654\C2DD \BCF4\ACE0\C11C\C758 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C \B610\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC \BDF0 \B2E8\CD94\C5D0 \CD94\AC00\B418\ACE0, \C0AC\C6A9\C790\AC00 \D574\B2F9 \C544\C774\CF58\C744 \D1B5\D574 \C774 \BDF0\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105553397196309905)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106114258517310378)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;&ENAME_LABEL.:&lt;/td&gt;&lt;td&gt;&ENAME.&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;&JOB_LABEL.:&lt;/td&gt;&lt;td&gt;&JOB.&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106114342648310378)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C138\BD80\C815\BCF4 \BCF4\AE30\C5D0 \BCF4\ACE0\C11C \D589\C5D0 \B300\D55C \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C\ACFC \AC19\C740 \B300\CCB4 \BB38\C790\C5F4\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - \C5F4 \C774\B984\C5D0 \B300\D55C \B300\CCB4 \BB38\C790\C5F4</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - \C5F4 \B808\C774\BE14\C5D0 \B300\D55C \B300\CCB4 \BB38\C790\C5F4</li>'),
unistr('<li><code>&APEX$ROW_ID.</code> - \D589\C5D0 \B300\D55C \B808\CF54\B4DC \C2DD\BCC4\C790</li>'),
unistr('<li><code>&APEX$ROW_INDEX.</code> - \B808\CF54\B4DC \D45C\C2DC \C2DC\D000\C2A4 \BC88\D638</li>'),
unistr('<li><code>&APEX$ROW_STATE_CLASSES.</code> - \B808\CF54\B4DC \C0C1\D0DC(\C608: <code>is-inserted</code> \B610\B294 <code>is-deleted</code>)</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105751680745310072)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;#ENAME_LABEL#:&lt;/td&gt;&lt;td&gt;#ENAME#&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;#JOB_LABEL#:&lt;/td&gt;&lt;td&gt;#JOB#&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105553831363309905)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \BCF4\AE30\C5D0 \BCF4\ACE0\C11C \D589\C5D0 \B300\D55C \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4. \C5F4 \C774\B984 \BC0F \C5F4 \B808\C774\BE14\C5D0 \B300\D574 <code>#COLUMN_NAME#</code> \B300\CCB4 \BB38\C790\C5F4\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105553747547309905)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01 \D589\C5D0 \B300\D574')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105213119631309631)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>&PRODUCT_NAME.\C758 \B300\D654\C0C1\C790 \C9C0\C6D0\C740 \D398\C774\C9C0\C758 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.'),
unistr('\B300\D654\C0C1\C790 \C18D\C131\C758 \BD80\BD84 \C9D1\D569 <em>\B192\C774, \B108\BE44 \BC0F \CD5C\B300 \B108\BE44</em>\B294 \C120\C5B8\C801\C73C\B85C \C9C0\C6D0\B429\B2C8\B2E4.'),
unistr('\B300\D654\C0C1\C790\C758 \CD94\AC00 \C18D\C131\C744 \C815\C758\D558\B824\BA74 \C774\B984/\AC12 \C30D\C744 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C73C\B85C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8 \B808\BCA8\C5D0 \C815\C758\B41C \B300\D654\C0C1\C790 \CD08\AE30\D654 \CF54\B4DC\C758 \B300\CCB4 \BB38\C790\C5F4 <code>#DIALOG_ATTRIBUTES#</code>\C740 \C774 \D56D\BAA9\C5D0 \C785\B825\B41C \AC12\C73C\B85C \BC14\B01D\B2C8\B2E4.</p>'),
unistr('<p>\B370\C2A4\D06C\D1B1 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C0AC\C6A9\D558\B294 \D398\C774\C9C0\C758 \ACBD\C6B0 jQuery UI \B300\D654\C0C1\C790 \C704\C82F\C774 \C0AC\C6A9\B429\B2C8\B2E4.'),
unistr('jQuery Mobile \C2A4\B9C8\D2B8\D3F0 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C0AC\C6A9\D558\B294 \D398\C774\C9C0\C758 \ACBD\C6B0\C5D0\B294 jQuery Mobile \B300\D654\C0C1\C790 \C704\C82F\C774 \C0AC\C6A9\B429\B2C8\B2E4.</p>'),
unistr('<p>\C608\B97C \B4E4\C5B4, \B370\C2A4\D06C\D1B1 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C0AC\C6A9\D558\B294 \B300\D654\C0C1\C790 \D398\C774\C9C0\C5D0\B294 <code>resizable:true, draggable:true</code>\C640 \AC19\C740 \C18D\C131\C774 \C815\C758\B420 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9 \AC00\B2A5\D55C \C18D\C131\C5D0 \B300\D55C \C790\C138\D55C \B0B4\C6A9\C740 <a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">jQuery UI \B300\D654\C0C1\C790 \C704\C9C0\D2B8 \C124\BA85\C11C</a> \BC0F <a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">jQuery Mobile \B300\D654\C0C1\C790 \C704\C82F \C124\BA85\C11C</a>\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105213049598309631)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105903690642310187)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2E4\B978 \B300\D654\C0C1\C790\AC00 \C774 \B300\D654\C0C1\C790\B97C \C5F4 \B54C \B3D9\C77C\D55C \B300\D654\C0C1\C790 \CC3D\C744 \C7AC\C0AC\C6A9\D574\C57C \D558\B294 \ACBD\C6B0 <strong>\C124\C815</strong>\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, \C774 \B300\D654\C0C1\C790\AC00 \C5EC\B7EC \D398\C774\C9C0\B85C \AD6C\C131\B41C \B300\D654\C0C1\C790 \B9C8\BC95\C0AC\C758 \C77C\BD80\C774\ACE0 \B9C8\BC95\C0AC\C758 \AC01 \B2E8\ACC4\C5D0 \B300\D574 \D574\B2F9 \B300\D654\C0C1\C790 \CC3D\C744 \C7AC\C0AC\C6A9\D558\B824\B294 \ACBD\C6B0\AC00 \C5EC\AE30\C5D0 \D574\B2F9\D569\B2C8\B2E4.<p><p>'),
unistr('\B2E4\B978 \B300\D654\C0C1\C790\AC00 \C774 \B300\D654\C0C1\C790\B97C \C5F4 \B54C \C0C8 \B300\D654\C0C1\C790 \CC3D\C5D0\C11C \C5F4\C5B4\C57C \D558\B294 \ACBD\C6B0 <strong>\D574\C81C</strong>\B97C \C120\D0DD\D569\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \C774 \B300\D654\C0C1\C790\AC00 \BAA8\B2EC\C774\ACE0'),
unistr('\C0C1\C704 \BAA8\B2EC \B300\D654\C0C1\C790 \CC3D \B0B4\BD80\C5D0 \C774 \B300\D654\C0C1\C790\B97C \C5F4\B824\B294 \ACBD\C6B0\AC00 \C5EC\AE30\C5D0 \D574\B2F9\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105903535106310187)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\C778\D654\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105614966028309954)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105614824700309954)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105303400132309699)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B300\D654\C0C1\C790\C758 \B192\C774\B97C \D53D\C140 \B2E8\C704\B85C \C785\B825\D569\B2C8\B2E4(\C608: <strong><em>500</em></strong>).'),
unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C758 \B300\D654\C0C1\C790 \CD08\AE30\D654 \CF54\B4DC\C5D0\C11C \B300\CCB4 \BB38\C790\C5F4 <code>#DIALOG_HEIGHT#</code>\B294 \C785\B825\D55C \AC12\C73C\B85C \BC14\B01D\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105303348502309699)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B192\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105212930248309631)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B300\D654\C0C1\C790\C758 \CD5C\B300 \B108\BE44\B97C \D53D\C140 \B2E8\C704\B85C \C785\B825\D569\B2C8\B2E4.'),
unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C758 \B300\D654\C0C1\C790 \CD08\AE30\D654 \CF54\B4DC\C5D0 \C788\B294 \B300\CCB4 \BB38\C790\C5F4 <code>#DIALOG_MAX_WIDTH#</code>\B294 \C774 \D56D\BAA9\C5D0 \C785\B825\D55C \AC12\C73C\B85C \BC14\B01D\B2C8\B2E4.</p>'),
unistr('<p>jQuery Mobile \C2A4\B9C8\D2B8\D3F0 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C0AC\C6A9\D558\B294 \D398\C774\C9C0\C758 \ACBD\C6B0 \CD5C\B300 \B108\BE44\B294 <strong><em>500</em></strong>\C785\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105212895990309631)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105594891510309938)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105348466826309734)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\C758 \BAA8\C591\ACFC \B808\C774\C544\C6C3\C744 \C815\C758\D560 \B300\D654\C0C1\C790 \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('        <p>\B300\D654\C0C1\C790 \D15C\D50C\B9AC\D2B8\B294 \C560\D50C\B9AC\CF00\C774\C158 \D14C\B9C8\C5D0\C11C \C815\C758\B429\B2C8\B2E4.'),
unistr('        \B300\D654\C0C1\C790 \D398\C774\C9C0\AC00 \C0DD\C131\B418\BA74 \D15C\D50C\B9AC\D2B8\B294 \D604\C7AC \D14C\B9C8\C5D0 \C815\C758\B41C \AE30\BCF8 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D558\C5EC \D398\C774\C9C0\B97C \B80C\B354\B9C1\D558\B294 <em>\D14C\B9C8 \AE30\BCF8\AC12</em>\C73C\B85C \C790\B3D9\C73C\B85C \C124\C815\B429\B2C8\B2E4.'),
unistr('        \C5EC\AE30\C11C \C120\D0DD\D558\BA74 \AE30\BCF8 \B300\D654\C0C1\C790 \D15C\D50C\B9AC\D2B8\B294 \BB34\D6A8\D654\B429\B2C8\B2E4.</p>'),
unistr('        <p>\BC94\C6A9 \D14C\B9C8\B294 \B2E4\C74C\ACFC \AC19\C740 \B300\D654\C0C1\C790 \D15C\D50C\B9AC\D2B8\B97C \C81C\ACF5\D569\B2C8\B2E4.'),
'          <dl>',
unistr('            <dt>\BAA8\B2EC \B300\D654\C0C1\C790</dt>'),
unistr('              <dd>\B300\BD80\BD84\C758 \B300\D654\C0C1\C790 \C0AC\C6A9 \C0AC\B840\C5D0 \C720\C6A9\D569\B2C8\B2E4.</dd>'),
unistr('            <dt>\B9C8\BC95\C0AC \BAA8\B2EC \B300\D654\C0C1\C790</dt>'),
unistr('              <dd>\AC04\C0AC\D654\B41C \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C81C\ACF5\D558\BA70 \BAA8\B2EC \B300\D654\C0C1\C790 \B9C8\BC95\C0AC, \ACBD\BCF4, \C54C\B9BC \B610\B294 \C18C\D615 \D3FC\C5D0 \C801\D569\D569\B2C8\B2E4.</dd>'),
'          </dl>',
unistr('          \CC38\ACE0: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105348348739309734)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105212733454309631)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B300\D654\C0C1\C790\C758 \B108\BE44\B97C \D53D\C140 \B610\B294 \BC31\BD84\C728\B85C \C785\B825\D569\B2C8\B2E4.'),
unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C758 \B300\D654\C0C1\C790 \CD08\AE30\D654 \CF54\B4DC\C5D0 \C788\B294 \B300\CCB4 \BB38\C790\C5F4 <code>#DIALOG_WIDTH#</code>\B294 \C774 \D56D\BAA9\C5D0 \C785\B825\D55C \AC12\C73C\B85C \BC14\B01D\B2C8\B2E4.</p>'),
unistr('<p>\B370\C2A4\D06C\D1B1 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C0AC\C6A9\D558\B294 \D398\C774\C9C0\C758 \ACBD\C6B0 \AC12\C774 \D53D\C140\B85C \C124\C815\B429\B2C8\B2E4(\C608: <strong><em>500</em></strong>).'),
unistr('\D558\C9C0\B9CC jQuery Mobile \C2A4\B9C8\D2B8\D3F0 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C0AC\C6A9\D558\B294 \D398\C774\C9C0\C758 \ACBD\C6B0 \AC12\C774 \BC31\BD84\C728\B85C \C124\C815\B429\B2C8\B2E4(\C608: <strong><em>80%</em></strong>).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105212601028309631)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105530734184309887)
,p_name=>'PE.PROPERTY.DIRECTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218\C758 \BC29\D5A5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105530850998309887)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105531091011309887)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN_OUT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825/\CD9C\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105530955434309887)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.OUT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD9C\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105530669857309887)
,p_name=>'PE.PROPERTY.DIRECTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105576819505309923)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \C5F4\C744 \C0AC\C6A9\D574\C11C \BCF4\ACE0\C11C\B97C \C815\B82C\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105576759069309923)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \AC00\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105608473975309949)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825 \C140\C5D0 \D45C\C2DC\D560 \B2E8\C77C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105608317862309948)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105224174682309639)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9\C740 \C81C\ACF5\B41C \AC12 \BAA9\B85D \C815\C758\C5D0 \D3EC\D568\B418\C9C0 \C54A\C740 \C138\C158 \C0C1\D0DC \AC12\C744 \AC00\C9C8 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\AC12 \BAA9\B85D\C5D0 \C774\B7EC\D55C \CD94\AC00 \C138\C158 \C0C1\D0DC \AC12\C774 \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \CD94\AC00 \C138\C158 \C0C1\D0DC \AC12\C744 \D45C\C2DC\D558\C9C0 \C54A\B3C4\B85D \C120\D0DD\D588\ACE0 \AC12 \BAA9\B85D \C815\C758\C5D0 \C77C\CE58\D558\B294 \AC12\C774 \C5C6\C73C\BA74 \AC12 \BAA9\B85D\C758 \CCAB\BC88\C9F8 \AC12\C774 \C120\D0DD\B418\ACE0 \AC12\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105224006312309639)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \AC12 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105224358872309640)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C5D0 \C0AC\C6A9\B41C \AC12 \BAA9\B85D\C5D0\C11C \BAA9\B85D \B9E8 \C704\C5D0 \B110 \AC12\C774 \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105224272930309640)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \AC12 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105266943889309671)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\B97C \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4. \C704\CE58\B294 \C801\C808\D55C \D398\C774\C9C0 \B610\B294 \C601\C5ED \D15C\D50C\B9AC\D2B8 \D45C\C2DC \C9C0\C810\C5D0\C11C \D30C\C0DD\B429\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105266856065309671)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105922065351310201)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \C791\C5C5\C5D0 \B300\D55C \D45C\C2DC \C21C\C11C\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\D45C\C2DC \C870\AC74\C744 \D3C9\AC00\D558\ACE0 \C815\C758\B41C \C21C\C11C\B300\B85C \B80C\B354\B9C1\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105453723269309823)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C5F4\C758 \D45C\C2DC \C21C\C11C\B97C \C785\B825\D569\B2C8\B2E4. \C21C\C11C \C124\C815\C5D0 \B530\B77C \C601\C5ED \B0B4 \B2E4\B978 \C5F4\ACFC \AD00\B828\B41C \C774 \C5F4\C758 \D45C\C2DC \C704\CE58\AC00 \ACB0\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \B3D9\C77C \C601\C5ED \B0B4\C5D0 \C788\B294 \B450 \AC1C \C5F4\C774 \B3D9\C77C\D55C \C21C\C11C \AC12\C744 \AC16\B294 \ACBD\C6B0 \C560\D50C\B9AC\CF00\C774\C158\C744 \C775\C2A4\D3EC\D2B8\D558\ACE0 \B2E4\B978 \D658\ACBD(\C608: \D14C\C2A4\D2B8 \B610\B294 \C6B4\C6A9 \D658\ACBD)\C5D0 \C784\D3EC\D2B8\D558\BA74 \D45C\C2DC \C21C\C11C\AC00 \B2EC\B77C\C9C8 \C218 \C788\C2B5\B2C8\B2E4. \C77C\AD00\C131\C744 \BCF4\C7A5\D560 \C218 \C788\B3C4\B85D Oracle\C740 \BAA8\B4E0 \D56D\BAA9\C5D0 \B300\D574 \B610\B294 \C801\C5B4\B3C4 \B3D9\C77C\D55C \C601\C5ED \B0B4\C5D0 \C788\B294 \D56D\BAA9\B4E4\C5D0 \B300\D574\C11C\B294 \ACE0\C720\D55C \C21C\C11C \BC88\D638\B97C \C9C0\C815\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105545783126309899)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4 \ADF8\B8F9\C5D0 \B300\D55C \D45C\C2DC \C21C\C11C\B97C \C785\B825\D569\B2C8\B2E4. \D45C\C2DC \C21C\C11C\B294 \C138\BD80\C815\BCF4 \BCF4\AE30\C5D0\C11C \C5F4 \ADF8\B8F9\C774 \D45C\C2DC\B418\B294 \C21C\C11C\B97C \ACB0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105879572898310168)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \CE35\C758 \D45C\C2DC \C21C\C11C\B97C \C785\B825\D569\B2C8\B2E4. \C21C\C11C \C124\C815\C5D0 \B530\B77C \B9F5 \CE35\C774 \C11C\B85C \C704\C5D0 \D45C\C2DC\B418\B294 \C21C\C11C\AC00 \ACB0\C815\B429\B2C8\B2E4. \BC88\D638\AC00 \B192\C740 \CE35\C774 \B0AE\C740 \BC88\D638\C758 \CE35 \C704\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \B450 \AC1C\C758 \B9F5 \CE35\C774 \B3D9\C77C\D55C \C21C\C11C \AC12\C744 \AC16\B294 \ACBD\C6B0 \C560\D50C\B9AC\CF00\C774\C158\C744 \C775\C2A4\D3EC\D2B8\D558\ACE0 \B2E4\B978 \D658\ACBD(\C608: \D14C\C2A4\D2B8 \B610\B294 \C6B4\C6A9 \D658\ACBD)\C5D0 \C784\D3EC\D2B8\D558\BA74 \D45C\C2DC \C21C\C11C\AC00 \B2EC\B77C\C9C8 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C77C\AD00\C131\C744 \BCF4\C7A5\D560 \C218 \C788\B3C4\B85D Oracle\C740 \BAA8\B4E0 \CE35\C5D0 \B300\D574 \B610\B294 \C801\C5B4\B3C4 \B3D9\C77C\D55C \B9F5 \C601\C5ED \B0B4\C5D0 \C788\B294 \CE35\C5D0 \B300\D574\C11C\B294 \ACE0\C720\D55C \C21C\C11C \BC88\D638\B97C \C9C0\C815\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105242543057309653)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D56D\BAA9\C758 \D45C\C2DC \C21C\C11C\B97C \C785\B825\D569\B2C8\B2E4. \C21C\C11C \BC0F \AE30\D0C0 \B808\C774\C544\C6C3 \C124\C815\C5D0 \B530\B77C \C601\C5ED \B0B4 \B2E4\B978 \D56D\BAA9\ACFC \AD00\B828\B41C \C774 \D56D\BAA9\C758 \D45C\C2DC \C704\CE58\AC00 \ACB0\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \B3D9\C77C \C601\C5ED \B0B4\C5D0 \C788\B294 \B450 \AC1C \D56D\BAA9\C774 \B3D9\C77C\D55C \C21C\C11C \AC12\C744 \AC16\B294 \ACBD\C6B0 \C560\D50C\B9AC\CF00\C774\C158\C744 \C775\C2A4\D3EC\D2B8\D558\ACE0 \B2E4\B978 \D658\ACBD(\C608: \D14C\C2A4\D2B8 \B610\B294 \C6B4\C6A9 \D658\ACBD)\C5D0 \C784\D3EC\D2B8\D558\BA74 \D45C\C2DC \C21C\C11C\AC00 \B2EC\B77C\C9C8 \C218 \C788\C2B5\B2C8\B2E4. \C77C\AD00\C131\C744 \BCF4\C7A5\D560 \C218 \C788\B3C4\B85D Oracle\C740 \BAA8\B4E0 \D56D\BAA9\C5D0 \B300\D574 \B610\B294 \C801\C5B4\B3C4 \B3D9\C77C\D55C \C601\C5ED \B0B4\C5D0 \C788\B294 \D56D\BAA9\B4E4\C5D0 \B300\D574\C11C\B294 \ACE0\C720\D55C \C21C\C11C \BC88\D638\B97C \C9C0\C815\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105242413695309653)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106063697039310331)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2E4\C6B4\B85C\B4DC\D560 \C218 \C788\B294 \C0AC\C6A9\C790\B97C \C81C\D55C\D558\AE30 \C704\D55C \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('		\C77C\BC18 \C0AC\C6A9\C790\AC00 \B2E4\C6B4\B85C\B4DC\D560 \C218 \C788\B3C4\B85D \D558\B824\BA74 \C774 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \D574\B2F9 \C0AC\C6A9\C790\C5D0 \B300\D574 TRUE\B85C \D3C9\AC00\B418\C5B4\C57C \D569\B2C8\B2E4.</p>'),
unistr('		<p>\CC38\ACE0 - \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \C81C\ACF5\B418\C9C0 \C54A\C73C\BA74 \C544\BB34 \C0AC\C6A9\C790\B098 \B2E4\C6B4\B85C\B4DC\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106063530518310331)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105586266988309931)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('CSV \B2E4\C6B4\B85C\B4DC \D30C\C77C\C758 \C774\B984\C744 \C9C0\C815\D569\B2C8\B2E4. \C774\B984\C744 \C9C0\C815\D558\C9C0 \C54A\C744 \ACBD\C6B0 \C601\C5ED \C774\B984\C774 \C0AC\C6A9\B418\ACE0 \ADF8 \B4A4\C5D0 .csv \D655\C7A5\C790\AC00 \BD99\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105597352403309940)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('CSV \B2E4\C6B4\B85C\B4DC \D30C\C77C\C758 \C774\B984\C744 \C9C0\C815\D569\B2C8\B2E4. \C774\B984\C744 \C9C0\C815\D558\C9C0 \C54A\C744 \ACBD\C6B0 \C601\C5ED \C774\B984\C774 \C0AC\C6A9\B418\ACE0 \ADF8 \B4A4\C5D0 .csv \D655\C7A5\C790\AC00 \BD99\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105581319195309927)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC\B41C \BB38\C11C\C758 \D30C\C77C \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \D30C\C77C \D655\C7A5\C790\B97C \C9C0\C815\D558\C9C0 \B9C8\C2ED\C2DC\C624. \D655\C7A5\C790\B294 \C790\B3D9\C73C\B85C \CD94\AC00\B429\B2C8\B2E4. \C774 \C18D\C131\C744 \BE44\C6CC\B450\BA74 \C601\C5ED \C774\B984\C774 \D30C\C77C \C774\B984\C73C\B85C \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105581258334309927)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105548662573309901)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C0AC\C6A9\C790\AC00 \D604\C7AC \D45C\C2DC\B41C \C5F4\C744 \B2E4\C6B4\B85C\B4DC\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\B294 \B2E4\C6B4\B85C\B4DC \D615\C2DD\C744 \D655\C778\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105749030316310070)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'ko'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105749103082310070)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'ko'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105749234680310070)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'ko'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105823905552310126)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'ko'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105548508484309901)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105584114421309929)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('CSV \B2E4\C6B4\B85C\B4DC\B97C \D638\CD9C\D560 \B9C1\D06C\C5D0 \B300\D55C \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105584050867309929)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105580546691309926)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C5D0\C11C \B2E4\C6B4\B85C\B4DC \B9C1\D06C\C5D0 \C0AC\C6A9\D560 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\B294 \C774 \B9C1\D06C\B97C \C0AC\C6A9\D574\C11C BLOB \CF58\D150\CE20\B97C \B2E4\C6B4\B85C\B4DC\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105580445481309926)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105611967077309951)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B04C\C5B4 \B193\AE30\B97C \C0AC\C6A9\D558\C5EC \AE30\C874 \B2EC\B825 \C774\BCA4\D2B8\B97C \C5C5\B370\C774\D2B8\D560 \C218 \C788\B294 \AD8C\D55C\C744 \AC00\C9C4 \C0AC\C6A9\C790\B97C \C81C\D55C\D558\B824\BA74 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C9C0\C815\B41C \ACBD\C6B0 \B04C\C5B4 \B193\AE30\AC00 \CC98\B9AC\B418\B3C4\B85D \D558\B824\BA74 \C774 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 TRUE\B85C \D3C9\AC00\B418\C5B4\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105611884188309951)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105770567820310086)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C0AC\C6A9\C790\C815\C758 \D504\B85C\C138\C2A4</dt>'),
'<dd><pre>',
'declare',
'    l_date_value        varchar2(32767) := apex_application.g_x01;',
'    l_primary_key_value varchar2(32767) := apex_application.g_x02;',
'begin',
'    update emp',
'       set hiredate = to_date(l_date_value, ''YYYYMMDD HH24MISS'')',
'     where rowid    = l_primary_key_value;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105611743567309951)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825 \D56D\BAA9\C744 \B04C\C5B4 \B193\C744 \B54C \C2E4\D589\D560 \D504\B85C\C138\C2A4\B97C \C815\C758\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105611649667309951)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105452658127309822)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\CF54\B4DC\B97C \BCF5\C81C\D560 \B54C \C5F4\C774 \AE30\BCF8\C801\C73C\B85C \AE30\C874 \C5F4 \AC12\C73C\B85C \B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105452586631309822)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C81C \C2DC \AE30\C874 \AC12 \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105250568100309659)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C0\C6D0\B418\B294 DML(\B370\C774\D130 \C870\C791 \C5B8\C5B4) \C791\C5C5\C744 \D655\C778\D569\B2C8\B2E4. \C774 \D504\B85C\C138\C2A4\B294 \D398\C774\C9C0 \C81C\CD9C \B2E8\CD94\C758 <strong>\B370\C774\D130\BCA0\C774\C2A4 \C791\C5C5</strong> \C18D\C131\C5D0 \B530\B77C DML \C791\C5C5\C744 \C218\D589\D569\B2C8\B2E4. \C774 \C18D\C131\C774 \C124\C815\B418\C9C0 \C54A\C740 \ACBD\C6B0, \B2E4\C74C\ACFC \AC19\C774 \B2E8\CD94 \C774\B984\C5D0 \C900\D558\C5EC \C124\C815\B41C \B2E8\CD94 \C694\CCAD \AC12\C5D0 \B530\B77C \C791\C5C5\C774 \ACB0\C815\B429\B2C8\B2E4.</p>'),
'<ul>',
unistr('<li><strong>\D589 \CD94\AC00</strong>\AC00 \D2B8\B9AC\AC70\B418\B294 \C694\CCAD \AC12: INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN</li>'),
unistr('<li><strong>\D589 \C5C5\B370\C774\D2B8</strong>\AC00 \D2B8\B9AC\AC70\B418\B294 \C694\CCAD \AC12: SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%</li>'),
unistr('<li><strong>\D589 \C0AD\C81C</strong>\AC00 \D2B8\B9AC\AC70\B418\B294 \C694\CCAD \AC12: DELETE, REMOVE, DELETE ROW, DROP</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105436904417309808)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0\C11C \D5C8\C6A9\B418\B294 \B370\C774\D130 \C870\C791 \C791\C5C5\C744 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105437221049309808)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.D.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105437005321309808)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.I.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105437124047309808)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.U.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105436874178309807)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D5C8\C6A9\B41C \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105437419168309808)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 \D589\C744 \C5C5\B370\C774\D2B8 \BC0F/\B610\B294 \C0AD\C81C\D560 \C218 \C788\B294\C9C0 \B098\D0C0\B0B4\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \D5C8\C6A9 \AC00\B2A5\D55C \AC12\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'        <dl>',
'          <dt>U</dt>',
unistr('            <dd>\D589\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C788\C2B5\B2C8\B2E4.</dd>'),
'          <dt>D</dt>',
unistr('            <dd>\D589\C744 \C0AD\C81C\D560 \C218 \C788\C2B5\B2C8\B2E4.</dd>'),
'          <dt>UD</dt>',
unistr('            <dd>\D589\C744 \C5C5\B370\C774\D2B8\D558\AC70\B098 \C0AD\C81C\D560 \C218 \C788\C2B5\B2C8\B2E4.</dd>'),
'        </dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105437380792309808)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D5C8\C6A9\B41C \D589 \C791\C5C5 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105229107391309643)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \D56D\BAA9\C744 \B458\B7EC\C2F8\B294 HTML \D14C\C774\BE14 \C140 \B0B4\C758 \D56D\BAA9 \B9DE\CDA4\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105732759353310057)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\C559 \D558\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105732849596310057)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\C559 \AC00\C6B4\B370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105732994298310057)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\C559 \C0C1\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105732609655310057)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C6B4\B370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105733194230310058)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD \D558\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105733294978310058)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD \C911\C559')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105733375166310058)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD \C0C1\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105733072011310058)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105733553590310058)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD \D558\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105733683984310058)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD \C911\C559')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105733708993310058)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD \C0C1\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105733447119310058)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105225003077309640)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105229703817309644)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B192\C774 \C18D\C131 \D3EC\D568 \C18D\C131\C744 \C9C0\C6D0\D558\B294 \D50C\B7EC\ADF8\C778 \D56D\BAA9 \C720\D615, \D14D\C2A4\D2B8 \C601\C5ED, \C154\D2C0 \BC0F \B2E4\C911 \C120\D0DD \BAA9\B85D\C5D0 \B300\D55C \B192\C774(\B300\B7B5\C801\C778 \D589 \C218)\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105229660653309643)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B192\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105615202650309954)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105229548472309643)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C774 \D56D\BAA9\C5D0 \C785\B825\D560 \C218 \C788\B294 \CD5C\B300 \BB38\C790 \C218\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105229411260309643)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \AE38\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105615357211309954)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105230185135309644)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B77C\B514\C624 \ADF8\B8F9\C774\B098 \CCB4\D06C\BC15\C2A4 \C9D1\D569\C5D0 \AC01 \AC1C\BCC4 \C635\C158\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 HTML \D14C\C774\BE14 \C140\C758 \ACF5\BC31\C73C\B85C \AD6C\BD84\B41C \CD94\AC00 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105230076558309644)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C635\C158 HTML \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105230508610309644)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B77C\B514\C624 \ADF8\B8F9 \B610\B294 \CCB4\D06C\BC15\C2A4 \C9D1\D569\C5D0 \AC1C\BCC4 \C635\C158\C744 \D45C\C2DC\D558\B294 HTML \D14C\C774\BE14 \C140 \B2E4\C74C\C5D0 \D45C\C2DC\B418\B294 \CD94\AC00 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('HTML, JavaScript \BC0F \BC14\B85C\AC00\AE30\B97C \D3EC\D568\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \B300\CCB4 \BB38\C790\C5F4\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\C774 \D398\C774\C9C0 \D56D\BAA9\C774 \C5F0\AD00\B41C HTML \D3FC \C694\C18C\C758 \C774\B984\C744 \AC00\C838\C635\B2C8\B2E4.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\D604\C7AC \D398\C774\C9C0 \D56D\BAA9\C758 \C774\B984\C744 \AC00\C838\C635\B2C8\B2E4.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105230473380309644)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\D6C4 \D14D\C2A4\D2B8 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105230392704309644)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B77C\B514\C624 \ADF8\B8F9 \B610\B294 \CCB4\D06C\BC15\C2A4 \C9D1\D569\C5D0 \AC1C\BCC4 \C635\C158\C744 \D45C\C2DC\D558\B294 HTML \D14C\C774\BE14 \C140 \C774\C804\C5D0 \D45C\C2DC\B418\B294 \CD94\AC00 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('HTML, JavaScript \BC0F \BC14\B85C\AC00\AE30\B97C \D3EC\D568\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \B300\CCB4 \BB38\C790\C5F4\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\C774 \D398\C774\C9C0 \D56D\BAA9\C774 \C5F0\AD00\B41C HTML \D3FC \C694\C18C\C758 \C774\B984\C744 \AC00\C838\C635\B2C8\B2E4.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\D604\C7AC \D398\C774\C9C0 \D56D\BAA9\C758 \C774\B984\C744 \AC00\C838\C635\B2C8\B2E4.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105230240303309644)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105229966756309644)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D56D\BAA9\C5D0 \B300\D55C \AC12\C774 \C785\B825\B418\C9C0 \C54A\C558\C744 \B54C \C774 \D56D\BAA9\C5D0 \D45C\C2DC\B418\B294 \D78C\D2B8 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \D14D\C2A4\D2B8\AC00 \D56D\BAA9\C5D0 \C785\B825\B41C \B2E4\C74C\C5D0\B294 \D78C\D2B8\AC00 \C81C\AC70\B429\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C704\CE58 \D45C\C2DC\C790 \C18D\C131\C740 \D398\C774\C9C0 \D56D\BAA9\C758 \C608\C0C1 \AC12\C744 \AE30\C220\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\B294 \AC04\B2E8\D55C \D78C\D2B8\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \D78C\D2B8\B294 \C0D8\D50C \AC12 \B610\B294 \C608\C0C1 \D615\C2DD \C608 \B610\B294 \C81C\BAA9, \C124\BA85 \BC0F \D0DC\ADF8 \AC80\C0C9\ACFC \AC19\C740 \C9C0\CE68\C744 \C81C\ACF5\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4.'),
unistr('\C811\ADFC\C131\C744 \C704\D574\C11C\B294 \C798 \C815\C758\B41C \C758\BBF8 \C788\B294 \B808\C774\BE14\C5D0 \B300\D55C \B300\C548\C73C\B85C \C774 \C18D\C131\C744 \C0AC\C6A9\D558\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\C8FC\C758:</strong> \C774 \AE30\B2A5\C740 HTML5 \AE30\B2A5\C774\BA70 \CD5C\C2E0 \BE0C\B77C\C6B0\C800\C5D0\C11C\B9CC \C791\B3D9\D569\B2C8\B2E4! \C774\C804 \BE0C\B77C\C6B0\C800\C5D0\C11C\B294 \C774 \C18D\C131\C5D0 \C785\B825\B41C \D14D\C2A4\D2B8\AC00 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105229896655309644)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \C704\CE58 \D45C\C2DC\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105229308871309643)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\D560 \D3FC \C694\C18C\C758 \B108\BE44\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105229228973309643)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105615173834309954)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105750133552310070)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@abc.com</code></li>',
'<li><code>&amp;MY_APP_EMAIL_FROM.</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105551456135309903)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \BCF4\ACE0\C11C\C5D0\C11C \C804\C790\BA54\C77C\C744 \C804\C1A1\D560 \B54C <em>\BCF4\B0B8 \C0AC\B78C</em> \C8FC\C18C\B85C \C0AC\C6A9\D560 \C801\D569\D55C \C804\C790\BA54\C77C \C8FC\C18C\B97C \C785\B825\D569\B2C8\B2E4. \C804\C790\BA54\C77C \C720\D615\C758 \B2E4\C6B4\B85C\B4DC \BC0F \AC00\C785\C758 \ACBD\C6B0 \C774 \BCF4\ACE0\C11C\C5D0\C11C \C804\C790\BA54\C77C\C774 \C804\C1A1\B429\B2C8\B2E4.</p>'),
unistr('<p>\C774 \AC12\C740 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C815\C758\B41C \C801\D569\D55C \C804\C790\BA54\C77C \C8FC\C18C \B610\B294 \C815\C801 \B300\CCB4 \CC38\C870\B97C \D3EC\D568\D558\B294 \B9AC\D130\B7F4 \BB38\C790\C5F4\C77C \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \B300\CCB4 \C0AC\C6A9\C740 \C804\C790\BA54\C77C \B2E4\C6B4\B85C\B4DC\C5D0\C11C\B9CC \C791\B3D9\D558\BBC0\B85C \AD8C\C7A5\B418\C9C0 \C54A\C73C\BA70, \C774\B7EC\D55C \D56D\BAA9\C744 \C801\D569\D55C \C138\C158 \C678\BD80\C5D0\C11C \C561\C138\C2A4\D560 \C218 \C5C6\AE30 \B54C\BB38\C5D0 \AC00\C785 \C804\C790\BA54\C77C\C774 \C2E4\D328\D569\B2C8\B2E4.'),
unistr('\AC00\C785\C740 \C0AC\C6A9\C790 \C138\C158\C774 \C544\B2C8\B77C &PRODUCT_NAME. \C5D4\C9C4\C5D0\C11C \C9C1\C811 \C804\C1A1\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105551363864309903)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \BCF4\B0B8 \C0AC\B78C \C8FC\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105463021732309830)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C81C\C5B4 \CC28\B2E8 \BC0F \C9D1\ACC4\C5D0\C11C \C774 \C5F4\C744 \C0AC\C6A9\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \C774\B7EC\D55C \C791\C5C5\C744 \D5C8\C6A9\D558\BA74 \D2B9\D788 \D070 \B370\C774\D130 \C9D1\D569\C5D0\C11C \B610\B294 \C54C\B9DE\C740 \C5F4 \C778\B371\C2A4\B97C \C0AC\C6A9\D560 \C218 \C5C6\B294 \ACBD\C6B0 \C131\B2A5 \BB38\C81C\B85C \C774\C5B4\C9C8 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105462976276309830)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \CC28\B2E8/\C9D1\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105441487118309812)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C9C0\C815\B41C \B2E4\C6B4\B85C\B4DC \D615\C2DD \C911 \D558\B098\B85C \BCF4\ACE0\C11C\B97C \B2E4\C6B4\B85C\B4DC\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105441316484309812)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105445508689309815)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \C5F4\C744 \D544\D130\B9C1\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105445406143309815)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105462211577309829)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0 \B300\D574 \C77C\BC18 \C0AC\C6A9\C790\AC00 \D50C\B798\C2DC\BC31 \C9C8\C758\B97C \C0AC\C6A9\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\D50C\B798\C2DC\BC31 \C9C8\C758\B294 Oracle Flashback Technology \BC0F \B370\C774\D130\BCA0\C774\C2A4 \C801\C2DC \BCF5\AD6C\B97C \C0AC\C6A9\D574\C11C \C774\C804 \C2DC\C810\C5D0 \C874\C7AC\D55C \B370\C774\D130\B97C \D574\B2F9 \C2DC\C810 \ADF8\B300\B85C \D655\C778\D560 \C218 \C788\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\B294 \C774 \B370\C774\D130\B97C \C9C8\C758\B9CC \D560 \C218 \C788\C73C\BA70, \B370\C774\D130 \BCC0\ACBD\C0AC\D56D\C744 \B418\B3CC\B9B4 \C218 \C5C6\C2B5\B2C8\B2E4. \C774 \AE30\C220\C5D0\B294 RMAN \BC31\C5C5\C774 \C0AC\C6A9\B418\AE30 \B54C\BB38\C5D0 \C0AC\C6A9\C790\AC00 \D50C\B798\C2DC\BC31 \C9C8\C758\B97C \C131\ACF5\C801\C73C\B85C \C218\D589\D560 \C218 \C788\B294 \AE30\AC04\C740 Oracle \B370\C774\D130\BCA0\C774\C2A4 \B0B4\C5D0\C11C \B9C8\C9C0\B9C9\C73C\B85C \B9AC\B450 \B85C\ADF8 \D30C\C77C\C774 \C804\D658\B41C \C2DC\AC04\C5D0 \B530\B77C \ACB0')
||unistr('\C815\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105462114695309829)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B798\C2DC\BC31')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105462838106309830)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \C5F4\C744 \C228\AE38 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105462772476309830)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105442032279309812)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \CCA8\BD80 \D30C\C77C\B85C \D3EC\D568\B41C \BCF4\ACE0\C11C \B2E4\C6B4\B85C\B4DC\C640 \D568\AED8 \C804\C790\BA54\C77C\C744 \C804\C1A1\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\C804\C790\BA54\C77C\C740 \C778\C99D\B41C \C0AC\C6A9\C790\C5D0\AC8C\B9CC \C81C\ACF5\B418\BA70 &PRODUCT_NAME. \AD00\B9AC \C11C\BE44\C2A4 \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0\C11C \C778\C2A4\D134\C2A4 \AD00\B9AC\C790\AC00 SMTP\B97C \AD6C\C131\D574\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105441995879309812)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C\B85C \C804\C1A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105691038425310022)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C778\C1C4\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <strong>\C124\C815</strong>\C744 \C120\D0DD\D558\BA74 \C0AC\C6A9\C790\AC00 PDF, Microsoft Word, Microsoft Excel \BC0F HTML \B4F1 \B2E4\C591\D55C \D615\C2DD\C758 \BCF4\ACE0\C11C\B97C \B2E4\C6B4\B85C\B4DC\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105690972517310021)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105440859698309811)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C790\C2E0\C758 \D604\C7AC \BCF4\ACE0\C11C \C815\C758\B97C <em>\ACF5\C6A9</em> \BCF4\ACE0\C11C\B85C \C800\C7A5\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\ACF5\C6A9 \BCF4\ACE0\C11C\B294 \B3C4\AD6C \BAA8\C74C\C5D0\C11C \C0AC\C6A9 \AC00\B2A5\D55C \BCF4\ACE0\C11C \C120\D0DD \BAA9\B85D\C5D0 \D45C\C2DC\B418\BA70 \BAA8\B4E0 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B429\B2C8\B2E4.</p>'),
unistr('		<p>\CC38\ACE0 - \C774 \C635\C158\C740 \C778\C99D\B41C \C0AC\C6A9\C790\C5D0\AC8C\B9CC \C81C\ACF5\B418\BA70 <strong>\ACF5\C6A9 \BCF4\ACE0\C11C \C800\C7A5 \AD8C\D55C \BD80\C5EC</strong>\B3C4 \CC44\C6B8 \ACBD\C6B0 \CD94\AC00\B85C \C81C\D55C\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105440726367309811)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9 \BCF4\ACE0\C11C \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105450600728309820)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \C5F4\C744 \C815\B82C\C5D0 \C0AC\C6A9\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \C815\B82C \C791\C5C5\C744 \D5C8\C6A9\D558\BA74 \D2B9\D788 \D070 \B370\C774\D130 \C9D1\D569\C5D0\C11C \B610\B294 \C54C\B9DE\C740 \C5F4 \C778\B371\C2A4\B97C \C0AC\C6A9\D560 \C218 \C5C6\B294 \ACBD\C6B0 \C131\B2A5 \BB38\C81C\B85C \C774\C5B4\C9C8 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105450594194309820)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105441214564309812)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \AC00\C785 \C124\C815\C744 \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105441186328309811)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105237906570309650)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\B420 \B54C \C774 \D56D\BAA9\C744 \C554\D638\D654\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\D56D\BAA9 \CF58\D150\CE20\C5D0 \BBFC\AC10\D55C \B370\C774\D130\AC00 \D3EC\D568\B41C \ACBD\C6B0 &PRODUCT_NAME. \C138\C158 \C0C1\D0DC \AD00\B9AC \D14C\C774\BE14\C5D0 \C800\C7A5\B420 \B54C \AC12\C744 \C554\D638\D654\D574\C57C \D569\B2C8\B2E4.'),
unistr('\ADF8\B807\C9C0 \C54A\C73C\BA74 &PRODUCT_NAME. \BA54\D0C0\B370\C774\D130 \D14C\C774\BE14\C5D0 \B300\D55C \C77D\AE30 \AD8C\D55C\C774 \C788\B294 \BAA8\B4E0 \C0AC\C6A9\C790\AC00 \C774 \BBFC\AC10\D55C \B370\C774\D130\B97C \CD94\CD9C\D558\AE30 \C704\D55C \C9C8\C758\B97C \C791\C131\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105237876241309649)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC\C5D0 \C554\D638\D654\B41C \AC12 \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105609492369309949)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\AC04 \B2EC\B825\C5D0 \D45C\C2DC\B418\B294 \C8FC\C758 \B9C8\C9C0\B9C9 \C694\C77C\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\D45C\C2DC\B41C \C8FC\AC04 \C694\C77C\C744 \C81C\D55C\D558\AE30 \C704\D574 <strong>\C2DC\C791\C77C</strong>\ACFC \D568\AED8 \C774 \C18D\C131\C744 \C0AC\C6A9\D558\AC70\B098 7\AC1C \C694\C77C\C744 \BAA8\B450 \D45C\C2DC\D558\AE30 \C704\D574 <strong>\C2DC\C791\C77C</strong> \AC12 \C774\C804\C758 \C694\C77C\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105768715807310084)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105768824565310084)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105768910290310085)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D654\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105769031068310085)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105769163111310085)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105769296754310085)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE08\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105769385084310085)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1A0\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105609312406309949)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105610059457309950)
,p_name=>'PE.PROPERTY.END_TIME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\AC04 \BC0F \C77C\AC04 \B2EC\B825\C758 \D45C\C2DC\C5D0 \D3EC\CEE4\C2A4\B97C \C9C0\C815\D558\AE30 \C704\D55C \C885\B8CC \C2DC\AC04\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105609935263309950)
,p_name=>'PE.PROPERTY.END_TIME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105611397107309951)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B2EC \B300\D654\C0C1\C790\B97C \D638\CD9C\D558\B824\B294 \B300\C0C1\C744 \B204\B985\B2C8\B2E4. \B2EC\B825\C774 \D638\CD9C\D558\B294 \B300\C0C1 \B9C1\D06C\B97C \C785\B825\D558\C5EC \AE30\C874 \C774\BCA4\D2B8\C758 \C138\BD80\C815\BCF4\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105611259550309951)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105211566020309630)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0 \C624\B958\AC00 \BC1C\C0DD\D560 \B54C \D638\CD9C\B418\B294 PL/SQL \D568\C218\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C774 \D568\C218\B97C \C0AC\C6A9\D574\C11C Oracle \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \B098\C624\B294 \CF54\B4DC\B97C \D3EC\D568\D574\C11C \C5EC\B7EC \AC00\C9C0 \C624\B958 \CF54\B4DC\C5D0 \B300\D55C \C791\C5C5\C744 \C218\D589\D558\ACE0 \D544\C694\C5D0 \B530\B77C \C815\C758\D55C \C0AC\C6A9\C790\C815\C758 \D14C\C774\BE14\C5D0 \C774\B7EC\D55C \C624\B958\B97C \AE30\B85D\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774 \D568\C218\B294 \C624\B958 \BA54\C2DC\C9C0\B97C \C218\C815\D558\ACE0 \C704\CE58\B97C \D45C\C2DC\D558\B294 \B17C\B9AC\B97C \D3EC\D568\D558\C5EC Oracle \B370\C774\D130\BCA0\C774\C2A4 \C624\B958\B97C \C0AC\C6A9\C790\C5D0\AC8C \D3B8\B9AC\D55C \BA54\C2DC\C9C0\B85C \BCC0\D658\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, <code>DEMO_CUSTOMERS</code>\C5D0 \B300\D55C \ACE0\C720 \D0A4 \C704\BC18\C744 \CEA1\CC98\D558\ACE0 <code>ORA-00001</code> \BA54\C2DC\C9C0\B97C Customer Name must be unique\C640 \AC19\C740 \D14D\C2A4\D2B8\B85C \BC14\AFC0 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\D328\D0A4\C9C0\D654\B41C \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0D8\D50C \B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158\C744 \C124\CE58\D558\BA74 <code>demo_error_handling</code> \D568\C218\AC00 \D3EC\D568\B41C <code>SAMPLE_PKG</code> \D328\D0A4\C9C0\AC00 \C0DD\C131\B429\B2C8\B2E4.'),
unistr('\C774 \C0D8\D50C \C624\B958 \CC98\B9AC \D568\C218\B294 \ACE0\C720 \D568\C218\B97C \C815\C758\D558\AE30 \C704\D55C \AE30\C900\C73C\B85C \C27D\AC8C \C0AC\C6A9\D560 \C218 \C788\B3C4\B85D \C790\C138\D55C \C124\BA85\C744 \D3EC\D568\D569\B2C8\B2E4.</p>'),
unistr('<p>\C785\B825\D55C \D568\C218 \C774\B984\C740 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \D328\D0A4\C9C0 \D568\C218 \B610\B294 \B3C5\B9BD\D615 \D568\C218\B97C \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4. \C608:'),
'<pre>',
'log_apex_error',
'</pre>',
'</p>',
unistr('<p>\B370\C774\D130\BCA0\C774\C2A4 PL/SQL \D328\D0A4\C9C0 \B610\B294 \B3C5\B9BD\D615 \D568\C218\B97C \CC38\C870\D560 \ACBD\C6B0 <code>#OWNER#</code> \B300\CCB4 \BB38\C790\C5F4\C744 \C0AC\C6A9\D558\C5EC \D604\C7AC \C560\D50C\B9AC\CF00\C774\C158\C758 \AD6C\BB38 \BD84\C11D \C2A4\D0A4\B9C8\B97C \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4. \C608:'),
'<pre>#OWNER#.log_apex_error</pre>',
'</p>',
unistr('<p>\C624\B958 \CC98\B9AC \D568\C218\AC00 \D398\C774\C9C0\C5D0 \C9C0\C815\B418\C5C8\C73C\BA74 \D574\B2F9 \D398\C774\C9C0\C5D0 \B300\D574 \C774 \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8 \C124\C815 \B300\C2E0 \C624\B958 \CC98\B9AC \D568\C218\AC00 \C0AC\C6A9\B429\B2C8\B2E4.</p>'),
unistr('<p>\C624\B958 \CC98\B9AC \D568\C218\B294 \B2E4\C74C \C778\D130\D398\C774\C2A4\B97C \AD6C\D604\D574\C57C \D569\B2C8\B2E4.'),
'<pre>',
'function &lt;name of function> (',
'    p_error in apex_error.t_error )',
'    return apex_error.t_error_result',
'</pre>',
'</p>',
unistr('<p><code>apex_error</code> \D328\D0A4\C9C0\C5D0 \B300\D55C \C124\BA85\C740 API \CC38\C870 \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105221102442309637)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \CC98\B9AC \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105927705610310205)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.APP_COMPUTATION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \ACC4\C0B0\C774 \C2E4\D328\D560 \ACBD\C6B0 \D45C\C2DC\B418\B294 \C624\B958 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('    \C2E4\D328\D55C \ACC4\C0B0\C73C\B85C \C778\D574 \BC1C\C0DD\D558\B294 SQL \C624\B958 \BA54\C2DC\C9C0\C5D0 \B300\D55C \B300\CCB4 \BB38\C790\C5F4\B85C <code>#SQLERRM#</code>\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
unistr('    <p>\ACC4\C0B0\C740 \D56D\C0C1 \C131\ACF5\D558\B3C4\B85D \B514\C790\C778\B418\BA70 \C608\C0C1\CE58 \BABB\D55C \C624\B958\AC00 \BC1C\C0DD\D560 \B54C\B9CC \C2E4\D328\D569\B2C8\B2E4.'),
unistr('    \C815\AE30\C801\C73C\B85C \C2E4\D328\D558\ACE0 \C774 \C624\B958 \BA54\C2DC\C9C0\B97C \C0AC\C6A9\D574\C11C \C758\C0AC \AC80\C99D\C73C\B85C \C791\B3D9\D558\B294 \ACC4\C0B0\C740 \AD6C\D604\D558\C9C0 \C54A\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105249352746309658)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_COMPUTATION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \ACC4\C0B0\C774 \C2E4\D328\D560 \ACBD\C6B0 \D45C\C2DC\B418\B294 \C624\B958 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('    \C2E4\D328\D55C \ACC4\C0B0\C73C\B85C \C778\D574 \BC1C\C0DD\D558\B294 SQL \C624\B958 \BA54\C2DC\C9C0\C5D0 \B300\D55C \B300\CCB4 \BB38\C790\C5F4\B85C <code>#SQLERRM#</code>\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
unistr('    <p>\ACC4\C0B0\C740 \D56D\C0C1 \C131\ACF5\D558\B3C4\B85D \B514\C790\C778\B418\BA70 \C608\C0C1\CE58 \BABB\D55C \C624\B958\AC00 \BC1C\C0DD\D560 \B54C\B9CC \C2E4\D328\D569\B2C8\B2E4.'),
unistr('    \C815\AE30\C801\C73C\B85C \C2E4\D328\D558\ACE0 \C774 \C624\B958 \BA54\C2DC\C9C0\B97C \C0AC\C6A9\D574\C11C \C758\C0AC \AC80\C99D\C73C\B85C \C791\B3D9\D558\B294 \ACC4\C0B0\C740 \AD6C\D604\D558\C9C0 \C54A\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105562982098309912)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D504\B85C\C138\C2A4\C5D0 \B300\D55C \C624\B958 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\C774 \BA54\C2DC\C9C0\B294 \CC98\B9AC\B418\C9C0 \C54A\C740 \C608\C678\C0AC\D56D\C774 \BC1C\C0DD\D560 \B54C \D45C\C2DC\B429\B2C8\B2E4. \C624\B958 \CC98\B9AC\AC00 \C815\C9C0\B41C \D6C4\C5D0\B294 \B864\BC31\C774 \C2E4\D589\B418\ACE0 \C624\B958 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: SQL \C624\B958 \BA54\C2DC\C9C0(sqlerrm)\B294 <strong>\C624\B958 \BC1C\C0DD \C2DC \D398\C774\C9C0</strong>\AC00 \C624\B958 \D45C\C2DC \C704\CE58\B85C \C815\C758\B418\C5C8\ACE0 \C624\B958 \D14D\C2A4\D2B8\C5D0 <code>#SQLERRM#</code>\C744 \CD94\AC00\D560 \D544\C694\AC00 \C5C6\B294 \ACBD\C6B0\C5D0 \AE30\BCF8\C801\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\C624\B958 \BA54\C2DC\C9C0\B294 \B2E4\C74C\ACFC \AC19\C740 \B300\CCB4 \BB38\C790\C5F4\C744 \D3EC\D568\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt><code>#SQLERRM_TEXT#</code></dt>',
unistr('  <dd>\C624\B958 \BC88\D638\AC00 \C5C6\B294 \C624\B958 \BA54\C2DC\C9C0\C758 \D14D\C2A4\D2B8\C785\B2C8\B2E4.</dd>'),
'  <dt><code>#SQLERRM#</code></dt>',
unistr('  <dd>\C644\C804\D55C \C624\B958 \BA54\C2DC\C9C0\C785\B2C8\B2E4.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106122108342310385)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL# \AC12\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105209970330309629)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AC80\C99D\C774 \D1B5\ACFC\B418\C9C0 \C54A\B294 \ACBD\C6B0\C5D0 \D45C\C2DC\B420 \D14D\C2A4\D2B8\B97C \C785\B825\D558\C2ED\C2DC\C624.</p>'),
unistr('<p>\C5F0\AD00\B41C \D398\C774\C9C0 \D56D\BAA9\C758 \B808\C774\BE14\C5D0 \B300\D55C \C704\CE58 \D45C\C2DC\C790\B85C <code>#LABEL#</code>\C744 \C0AC\C6A9\D558\AC70\B098 \C5F0\AD00\B41C \D3B8\C9D1 \AC00\B2A5\D55C \C601\C5ED \C5F4\C758 \BA38\B9AC\AE00\C5D0 \B300\D55C <code>#COLUMN_HEADER#</code>\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \C624\B958 \D45C\C2DC \C704\CE58\AC00 \C624\B958 \BC1C\C0DD \C2DC \D398\C774\C9C0\B85C \C124\C815\B41C \ACBD\C6B0 \C704\CE58 \D45C\C2DC\C790\AC00 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105209800172309629)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105321364529309714)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \AC80\C99D\C5D0 \B300\D574 \C624\B958 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B418\B294 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\AC80\C99D \C624\B958 \BA54\C2DC\C9C0\B294 \BCC4\AC1C\C758 \C624\B958 \D398\C774\C9C0 \B610\B294 \AE30\C874 \D398\C774\C9C0\C5D0 \C778\B77C\C778\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('\C778\B77C\C778 \C624\B958 \BA54\C2DC\C9C0\B294 <em>\C5F0\AD00\B41C \D56D\BAA9</em> \B808\C774\BE14 \C544\B798 \BC0F/\B610\B294 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C758 \C77C\BD80\B85C \C815\C758\B41C \D1B5\C9C0 \C601\C5ED\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105741972786310064)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C9C0\C5D0 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105741807807310064)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\B4DC\C5D0 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105741755757310064)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD_AND_NOTIFICATION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\B4DC\C5D0 \D3EC\D568 \BC0F \D1B5\C9C0\C5D0 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105742026125310064)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \BC1C\C0DD \C2DC \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105321217315309714)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105238117831309650)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('XSS(\C0AC\C774\D2B8\AC04 \C2A4\D06C\B9BD\D305) \ACF5\ACA9\C744 \BC29\C9C0\D558\AE30 \C704\D574\C11C\B294 \D56D\C0C1 \C774 \C18D\C131\C744 <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D569\B2C8\B2E4.'),
unistr('\D398\C774\C9C0 \D56D\BAA9 \B610\B294 \AC12 \BAA9\B85D\C758 \D56D\BAA9\C5D0 \C800\C7A5\B41C HTML \D0DC\ADF8\B97C \B80C\B354\B9C1\D574\C57C \D560 \ACBD\C6B0 \C774 \D50C\B798\ADF8\B97C <strong>\D574\C81C</strong>\B85C \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \ACBD\C6B0 \CD94\AC00\C801\C778 \C8FC\C758\B97C \D1B5\D574 \D574\B2F9 \D544\B4DC\C5D0 \B300\D55C \C0AC\C6A9\C790 \C785\B825\C774 \C218\D589\B420 \B54C \C785\B825\C744 \C800\C7A5\D558\AE30 \C804\C5D0 \C785\B825 \D56D\BAA9\C774 \C62C\BC14\B974\AC8C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\B418\B3C4\B85D \BCF4\C7A5\D574\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105238018851309650)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C2A4\CF00\C774\D504 \D2B9\C218 \BB38\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105210153455309629)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD8C\D55C \BD80\C5EC \CCB4\ACC4\B294 \C138\C158\C5D0\C11C \CC98\C74C \C0AC\C6A9\D560 \B54C \D3C9\AC00\B429\B2C8\B2E4.'),
unistr('\C81C\ACF5\B41C \AD8C\D55C \BD80\C5EC\B97C \C774\D6C4\C5D0 \C0AC\C6A9\D560 \B54C \BA54\BAA8\B9AC\C5D0\C11C \ACB0\ACFC\B97C \AC00\C838\C62C\C9C0 \C544\B2C8\BA74 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \B2E4\C2DC \D3C9\AC00\D560\C9C0 \D655\C778\D558\AE30 \C704\D574 \C801\D569\D55C \D3C9\AC00 \C9C0\C810\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
'#LOV_VALUES#',
unistr('<p>\AE30\BCF8\AC12 <em>\C138\C158\B2F9 \D55C \BC88\C529</em>\C774 \AC00\C7A5 \D6A8\C728\C801\C785\B2C8\B2E4.'),
unistr('\AD8C\D55C \BD80\C5EC \AC80\C0AC\AC00 \C138\C158 \C0C1\D0DC \BCC0\ACBD \B610\B294 \C804\CCB4 \C138\C158\C5D0\C11C \C77C\AD00\B418\C9C0 \C54A\C740 \B2E4\B978 \C694\C18C\C5D0 \B530\B77C \B2EC\B77C\C9C0\B294 \ACBD\C6B0 \B2E4\B978 \AC12\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.'),
unistr('<em>\AD6C\C131\C694\C18C\B2F9 \D55C \BC88\C529</em> \BC0F <em>\D56D\C0C1(\CE90\C2F1 \C548\D568)</em> \C635\C158\C740 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\C5D0\C11C \C0AC\C6A9\D558\B3C4\B85D \C815\C758\D560 \C218 \C788\B294 \CD94\AC00 \B9E4\AC1C\BCC0\C218\B97C \C81C\ACF5\D569\B2C8\B2E4.'),
unistr('\AD8C\D55C \BD80\C5EC \D50C\B7EC\ADF8\C778\C5D0\C11C\B294 <em>t_authorization</em> \B9E4\AC1C\BCC0\C218\C758 <em>component.type</em>, <em>component.id</em> \BC0F <em>component.name</em> \C18D\C131\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\B0B4\C7A5\B41C <em>Exists SQL \C9C8\C758</em> \BC0F <em>\D568\C218 \BCF8\BB38</em> \CCB4\ACC4 \C720\D615\C758 \ACBD\C6B0 \C774\C5D0 \C0C1\C751\D558\B294 \BC14\C778\B4DC \BCC0\C218 <em>:APP_COMPONENT_TYPE</em>, <em>:APP_COMPONENT_ID</em> \BC0F <em>:APP_COMPONENT_NAME</em>\C774 \C81C\ACF5\B429\B2C8\B2E4.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105718332744310046)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\B2F9 \D55C \BC88\C529')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105718408234310046)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \CC38\C870\D558\B294 \AC01 \AD6C\C131\C694\C18C\B2F9 \D55C \BC88\B9CC \D3C9\AC00\B418\C9C0\B9CC \ACB0\ACFC\B97C \C138\C158\C5D0 \C800\C7A5\D569\B2C8\B2E4. \C774\D6C4 \CCB4\ACC4 \B80C\B354\B9C1 \B610\B294 \CC98\B9AC \C694\CCAD \C2DC\C5D0\B294 \BA54\BAA8\B9AC\C5D0 \C788\B294 \ACB0\ACFC\AC00 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105718160873310046)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCF4\AE30\B2F9 \D55C \BC88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105718296847310046)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\B41C \AC01 \C694\CCAD\C5D0 \B300\D574 \D55C \BC88\B9CC \D3C9\AC00\B429\B2C8\B2E4. \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \D398\C774\C9C0\C5D0\C11C \B450 \AC1C \C774\C0C1\C758 \AD6C\C131\C694\C18C\C5D0 \CC38\C870\B418\B294 \ACBD\C6B0 \BA54\BAA8\B9AC\C5D0 \C788\B294 \ACB0\ACFC\B97C \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105717993509310046)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158\B2F9 \D55C \BC88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105718084452310046)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D55C \BC88\B9CC \D3C9\AC00\B418\ACE0 \C774\D6C4\C5D0\B294 \BA54\BAA8\B9AC\C5D0 \C788\B294 \ACB0\ACFC\B97C \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105718559413310047)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\C0C1(\CE90\C2F1 \C548\D568)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105718635362310047)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \D56D\C0C1 \D3C9\AC00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105210007027309629)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3C9\AC00 \C9C0\C810')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105215126305309633)
,p_name=>'PE.PROPERTY.EVENT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B3D9\C801 \C791\C5C5\C744 \BC1C\C0DD\C2DC\D0A4\B294 \C774\BCA4\D2B8\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\D2B9\C815 \C774\BCA4\D2B8\C5D0 \B300\D55C \C790\C138\D55C \B0B4\C6A9\C740 <em>App Builder User''s Guide</em>\C5D0\C11C \AD00\B828 \C139\C158\C744 \CC38\C870\D558\C2ED\C2DC\C624.</p>'),
unistr('\C774\BCA4\D2B8\B294 \B2E4\C74C \C720\D615\C73C\B85C \BC94\C8FC\D654\B429\B2C8\B2E4.'),
'<dl>',
unistr('  <dt>\BE0C\B77C\C6B0\C800 \C774\BCA4\D2B8</dt>'),
unistr('    <dd>\D45C\C900 \BE0C\B77C\C6B0\C800 \C774\BCA4\D2B8\C785\B2C8\B2E4.</dd>'),
unistr('  <dt>\D504\B808\C784\C6CC\D06C \C774\BCA4\D2B8</dt>'),
unistr('    <dd>\D504\B808\C784\C6CC\D06C \C774\BCA4\D2B8\B294 Application Express \D504\B808\C784\C6CC\D06C \B0B4\C5D0\C11C \D2B8\B9AC\AC70\B429\B2C8\B2E4.</dd>'),
unistr('  <dt>\AD6C\C131\C694\C18C \C774\BCA4\D2B8</dt>'),
unistr('    <dd>\C560\D50C\B9AC\CF00\C774\C158\C5D0 \C0AC\C6A9\C790\C815\C758 \C774\BCA4\D2B8\B97C \D2B8\B9AC\AC70\D558\B294 \AD6C\C131\C694\C18C\AC00 \C81C\ACF5\B41C \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774\B7EC\D55C \C774\BCA4\D2B8\B294 \ACE0\C720 \AD6C\C131\C694\C18C \B610\B294 \C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C124\CE58\D55C \D50C\B7EC\ADF8\C778 \AD6C\C131\C694\C18C\C5D0\C11C \D2B8\B9AC\AC70\B429\B2C8\B2E4.</dd>'),
unistr('  <dt>\C0AC\C6A9\C790\C815\C758 \C774\BCA4\D2B8</dt>'),
unistr('    <dd>\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \D2B8\B9AC\AC70\B41C \C0AC\C6A9\C790\C815\C758 \C774\BCA4\D2B8\C785\B2C8\B2E4.</dd>'),
'</dl>',
unistr('<p>\CC38\ACE0: \D45C\C2DC\B418\B294 \C774\BCA4\D2B8\B294 \D398\C774\C9C0\C758 \D604\C7AC \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \C720\D615\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.'),
unistr('\B2E4\B978 \C720\D615\C5D0 \D574\B2F9\D558\B294 \C774\BCA4\D2B8\B97C \C120\D0DD\D558\B824\BA74 <strong>\C9C0\C6D0\B418\C9C0 \C54A\B294 \D56D\BAA9 \D45C\C2DC</strong>\B97C \C120\D0DD\D558\BA74 \B429\B2C8\B2E4.'),
unistr('\C774 \C635\C158\C744 \C120\D0DD\D558\BA74 \D604\C7AC \C720\D615\C5D0 \D574\B2F9\D558\C9C0 \C54A\B294 \C774\BCA4\D2B8\B97C \D3EC\D568\D558\C5EC \BAA8\B4E0 \C774\BCA4\D2B8\AC00 \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105215022612309633)
,p_name=>'PE.PROPERTY.EVENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105239335242309651)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B450\BC88\C9F8 \C2DC\AC04\C5D0 \B610\B294 \C5F0\C18D\C801\C73C\B85C \C774\BCA4\D2B8\AC00 \D3C9\AC00\B420 \B54C\B97C \ACB0\C815\D558\B294 \C774\BCA4\D2B8 \BC94\C704\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105728987274310054)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105729032928310054)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\C758 \C218\BA85 \C8FC\AE30 \B3D9\C548 \C774\BCA4\D2B8 \CC98\B9AC\AE30\B97C \D2B8\B9AC\AC70 \C694\C18C\C5D0 \BC14\C778\B4DC\D558\C9C0\B9CC \D2B8\B9AC\AC70 \C774\BCA4\D2B8\AC00 PPR(\BD80\BD84 \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68)\C744 \D1B5\D574 \C5C5\B370\C774\D2B8\B420 \ACBD\C6B0\C5D0\B294 \B354 \C774\C0C1 \BC14\C778\B4DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105729187016310055)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105729249132310055)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('PPR(\BD80\BD84 \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68)\C744 \D1B5\D574 \C7AC\C0DD\C131 \C911\C778 \D2B8\B9AC\AC70 \C694\C18C\C5D0 \AD00\ACC4\C5C6\C774 \D604\C7AC \D398\C774\C9C0\C758 \C218\BA85 \C8FC\AE30 \B3D9\C548 \C774\BCA4\D2B8 \CC98\B9AC\AE30\B97C \D2B8\B9AC\AC70 \C774\BCA4\D2B8\C5D0 \BC14\C778\B4DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105729324278310055)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D55C \BC88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105729413034310055)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \CC98\B9AC\AE30\B97C \D2B8\B9AC\AC70 \C694\C18C\C5D0 \D55C \BC88\B9CC \BC14\C778\B4DC\D569\B2C8\B2E4. \D398\C774\C9C0\AC00 \C644\C804\D788 \C0C8\B85C \ACE0\CCD0\C9C4 \B2E4\C74C\C774 \B420 \B54C\AE4C\C9C0\B294 \B3D9\C801 \C791\C5C5\C774 \B2E4\C2DC \D2B8\B9AC\AC70\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105239281383309651)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106046810935310316)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC88\C5ED\C5D0\C11C \C774 \C81C\BAA9\C744 \C81C\C678\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158\C744 \B2E4\B978 \C5B8\C5B4\B85C \BC88\C5ED\D560 \B54C\B97C \C81C\C678\D558\BA74 \C774 \C18D\C131\C740 \D6A8\ACFC\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106046709155310316)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC88\C5ED\C5D0\C11C \C81C\BAA9 \C81C\C678')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105880042423310169)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \CE35 \C870\AC74\C774 \C2E4\D589\B418\B294 \D69F\C218\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C870\AC74\C5D0\C11C <em>\C5F4</em>\C744 \CC38\C870\D560 \ACBD\C6B0 \CE35 \C9C8\C758\C758 \AC01 \D589\C5D0 \B300\D574 \C870\AC74\C774 \D3C9\AC00\B418\B3C4\B85D \D558\B824\BA74 <strong>\AC01 \D589\C5D0 \B300\D574</strong>\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.'),
unistr('\ADF8\B807\C9C0 \C54A\C73C\BA74 <strong>\D55C \BC88</strong>\C73C\B85C \C124\C815\D574\C11C \AC80\C99D\C744 \D55C \BC88\B9CC \C2E4\D589\D569\B2C8\B2E4.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105322194909309714)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D3B8\C9D1 \AC00\B2A5\D55C \C601\C5ED \AC80\C99D\C774 \C2E4\D589\B418\B294 \D69F\C218\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C870\AC74\C5D0\C11C <em>\C5F4</em>\C744 \CC38\C870\D560 \ACBD\C6B0 \D3B8\C9D1 \AC00\B2A5\D55C \C601\C5ED\C758 \AC01 \D589\C5D0 \B300\D574 \C870\AC74\C774 \D3C9\AC00\B418\B3C4\B85D \D558\B824\BA74 <strong>\AC01 \D589\C5D0 \B300\D574</strong>\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.'),
unistr('\ADF8\B807\C9C0 \C54A\C73C\BA74 <strong>\D55C \BC88</strong>\C73C\B85C \C124\C815\D574\C11C \AC80\C99D\C744 \D55C \BC88\B9CC \C2E4\D589\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105742431525310065)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D55C \BC88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105742344712310065)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01 \D589\C5D0 \B300\D574')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105322069349309714)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105452858358309822)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C77D\AE30 \C804\C6A9 \C870\AC74\C774 \C5B8\C81C \C2E4\D589\B418\B294\C9C0 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('        <p>\C77D\AE30 \C804\C6A9 \C870\AC74\C5D0\C11C <em>\C5F4</em>\C744 \CC38\C870\D560 \ACBD\C6B0 \B300\D654\C2DD \ADF8\B9AC\B4DC\C758 \AC01 \D589\C5D0 \B300\D574 \C870\AC74\C774 \D3C9\AC00\B418\B3C4\B85D \D558\B824\BA74 <strong>\AC01 \D589\C5D0 \B300\D574</strong>\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.'),
unistr('		\ADF8\B807\C9C0 \C54A\C73C\BA74 <strong>\D55C \BC88</strong>\C73C\B85C \C124\C815\D574\C11C \C870\AC74\C744 \C601\C5ED\C5D0 \B300\D574 \D55C \BC88\B9CC \D3C9\AC00\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105453072282309822)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D55C \BC88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105568831788309917)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \C601\C5ED\C5D0 \B300\D574 \D55C \BC88\B9CC \C77D\AE30 \C804\C6A9 \C870\AC74\C744 \D3C9\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105452950773309822)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01 \D589\C5D0 \B300\D574')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105568791261309917)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01 \D589\C5D0 \B300\D574 \B3C5\B9BD\C801\C73C\B85C \C77D\AE30 \C804\C6A9 \C870\AC74\C744 \D3C9\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105452704524309822)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105321965432309714)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D3B8\C9D1 \AC00\B2A5\D55C \C601\C5ED \AC80\C99D\C5D0 \B300\D55C \C2E4\D589 \BC94\C704\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\D3B8\C9D1 \AC00\B2A5\D55C \C601\C5ED\C5D0\C11C \C0C8 \D589 \BC0F \C5C5\B370\C774\D2B8\B41C \D589\C5D0 \B300\D574 \C774 \AC80\C99D\C744 \D3C9\AC00\D558\B824\BA74 <strong>\C0DD\C131 \BC0F \C218\C815\B41C \D589</strong>\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C81C\CD9C\B41C \BAA8\B4E0 \D589\C5D0 \B300\D574 \AC80\C99D\C744 \D3C9\AC00\D558\B824\BA74 <strong>\C81C\CD9C\B41C \BAA8\B4E0 \D589</strong>\C744 \C120\D0DD\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105742296481310064)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C\B41C \BAA8\B4E0 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105742190605310064)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131 \BC0F \C218\C815\B41C \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105321808111309714)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105214715790309633)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \C2DC\D000\C2A4\B97C \C9C0\C815\D569\B2C8\B2E4. \C774 \C2DC\D000\C2A4\C5D0 \B530\B77C \C2E4\D589 \C21C\C11C\AC00 \ACB0\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \B450 \AD6C\C131\C694\C18C\C758 \C2DC\D000\C2A4 \AC12\C774 \B3D9\C77C\D55C \ACBD\C6B0 \C560\D50C\B9AC\CF00\C774\C158\C744 \C775\C2A4\D3EC\D2B8\D558\ACE0 \B2E4\B978 \D658\ACBD\C73C\B85C \C784\D3EC\D2B8\D588\C744 \B54C \B450 \AD6C\C131\C694\C18C\C758 \C2E4\D589 \C21C\C11C\AC00 \B2EC\B77C\C9C8 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105214642505309633)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106038353585310308)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>ORDS REST \C11C\BE44\C2A4\C758 \ACBD\C6B0 "sal" \C18D\C131\C774 3000 \BBF8\B9CC\C778 \BAA8\B4E0 \B808\CF54\B4DC\B97C \D544\D130\B9C1\D558\C5EC \C81C\C678\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'{"sal": {"$lt": 3000}}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106038256291310307)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\BD80 REST \C11C\BE44\C2A4\B85C \C804\B2EC\D560 \D544\D130 \D45C\D604\C2DD\C744 \C81C\ACF5\D569\B2C8\B2E4. \D45C\D604\C2DD\C740 \ADF8\B300\B85C \C6D0\ACA9 \C11C\BC84\B85C \C804\B2EC\B429\B2C8\B2E4. \AD6C\BB38\C740 REST \B370\C774\D130 \C18C\C2A4\C758 \C720\D615\C5D0 \B530\B77C \B2E4\B985\B2C8\B2E4. \C608\B97C \B4E4\C5B4, ORDS(Oracle REST Data Services)\C5D0\B294 JSON \AD6C\BB38\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106038114172310307)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\BD80 \D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106038601574310308)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>ORDS REST \C11C\BE44\C2A4\C758 \ACBD\C6B0 "job" \C18D\C131\C744 \AE30\C900\C73C\B85C \C624\B984\CC28\C21C\C73C\B85C \C815\B82C\D55C \B2E4\C74C "ename"\C744 \AE30\C900\C73C\B85C \B0B4\B9BC\CC28\C21C\C73C\B85C \C815\B82C\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'{"job": "asc", "ename": "desc"}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106038570270310308)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\BD80 REST \C11C\BE44\C2A4\B85C \C804\B2EC\D560 \C815\B82C \AE30\C900 \D45C\D604\C2DD\C744 \C81C\ACF5\D569\B2C8\B2E4. \D45C\D604\C2DD\C740 \ADF8\B300\B85C \C6D0\ACA9 \C11C\BC84\B85C \C804\B2EC\B429\B2C8\B2E4. \AD6C\BB38\C740 REST \B370\C774\D130 \C18C\C2A4\C758 \C720\D615\C5D0 \B530\B77C \B2E4\B985\B2C8\B2E4. \C608\B97C \B4E4\C5B4, ORDS(Oracle REST Data Services)\C5D0\B294 JSON \AD6C\BB38\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106038402702310308)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\BD80 \C815\B82C \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105586404850309931)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \C678\BD80 \C0AC\D6C4 \CC98\B9AC\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105586305592309931)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105586136253309931)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C678\BD80 \CC98\B9AC \C5D4\C9C4\C744 \D638\CD9C\D558\AE30 \C704\D574 \B204\B974\B294 \B9C1\D06C\C5D0 \B300\D55C \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105586078455309931)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105585960288309931)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BCF4\ACE0\C11C\C758 \C0AC\D6C4 \CC98\B9AC\B97C \C704\D55C \C11C\BC84 URL\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105585873417309931)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105895997014310181)
,p_name=>'PE.PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CCB4\D06C\BC15\C2A4\AC00 \C5F0\AD00\B41C \D328\C2EF \ADF8\B8F9\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105895854145310181)
,p_name=>'PE.PROPERTY.FACET_GROUP.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105824326359310126)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \C720\D615 \BAA9\B85D\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105825063312310127)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105825190294310127)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D\C740 \ACE0\C720 \C5F4 \AC12\C744 \C120\D0DD\D558\B294 \C790\B3D9 \C0DD\C131 \C9C8\C758\B97C \AE30\BC18\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105951257594310226)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105951342889310226)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \AC12 \BAA9\B85D\C740 \C785\B825\B41C \D568\C218 \BCF8\BB38\C73C\B85C \BC18\D658\B418\B294 SQL \C9C8\C758\B97C \AE30\C900\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105824401817310127)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C720 \AD6C\C131\C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105824551282310127)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D\C740 \ACF5\C720 \AD6C\C131\C694\C18C\C5D0 \C815\C758\B41C \BBF8\B9AC \C815\C758\B41C \AC12 \BAA9\B85D\C744 \AE30\C900\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105824699015310127)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105824711475310127)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \AC12 \BAA9\B85D\C740 \C785\B825\D55C SQL \C9C8\C758\B97C \AE30\C900\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105824890062310127)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105824911065310127)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12 \BAA9\B85D\C740 \C785\B825\D55C \D14D\C2A4\D2B8 \AC12\C744 \AE30\C900\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105824227343310126)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105669236444310002)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\D328\C2EF \CD95\C18C \AC00\B2A5 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \BAA9\B85D \D56D\BAA9 \D45C\C2DC/\C228\AE30\AE30\B97C \C804\D658\D560 \C218 \C788\B3C4\B85D \D328\C2EF \C67C\CABD\C5D0 \D1A0\AE00\C774 \D45C\C2DC\B429\B2C8\B2E4. <strong>\D574\C81C</strong>\B85C \C124\C815\D560 \ACBD\C6B0 \D328\C2EF\ACFC \BAA9\B85D \D56D\BAA9\C774 \D56D\C0C1 \D45C\C2DC\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105669179807310002)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95\C18C \AC00\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106087901324310354)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\D328\C2EF \B610\B294 \D544\D130\C5D0 \B300\D55C \BAA9\B85D \D56D\BAA9 \C218\B97C \ACC4\C0B0\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C774 \C635\C158\C744 \C0AC\C6A9\D558\BA74 \C774\B85C \C778\D574 \C131\B2A5\C774 \C601\D5A5\C744 \BC1B\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106087831836310354)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C218 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105896174122310181)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \ADF8\B8F9 \B0B4\C5D0 \D544\D130\B97C \ACB0\D569\D558\B294 \BC29\BC95\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105896463419310181)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.D'
,p_message_language=>'ko'
,p_message_text=>unistr('AND(\AD50\C9D1\D569)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105896589344310181)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130\B294 "AND"\B97C \C0AC\C6A9\D558\C5EC \ACB0\D569\B418\BBC0\B85C \ACB0\ACFC\B294 \BAA8\B4E0 \AC1C\BCC4 \D544\D130\C758 \AD50\C9D1\D569\C774 \B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105896265022310181)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('OR(\D569\C9D1\D569)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105896324354310181)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130\B294 "OR"\B97C \C0AC\C6A9\D558\C5EC \ACB0\D569\B418\BBC0\B85C \ACB0\ACFC\B294 \AC1C\BCC4 \D544\D130\C758 \D569\C9D1\D569\C774 \B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105896009728310181)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \ACB0\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105668695054310002)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\D328\C2EF \B610\B294 \D544\D130\C5D0 \B300\D55C \BAA9\B85D \D56D\BAA9\C758 \D074\B77C\C774\C5B8\D2B8\CE21 \D544\D130\B9C1\C744 \D5C8\C6A9\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \C77C\BC18 \C0AC\C6A9\C790\C758 \BAA9\B85D \D544\D130\B9C1\C774 \C9C0\C6D0\B418\B3C4\B85D \BAA9\B85D \D56D\BAA9 \C704\C5D0 \AC80\C0C9 \D544\B4DC\AC00 \B80C\B354\B9C1\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105668564766310002)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8\CE21 \D544\D130\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105897136759310182)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\CC28\D2B8\B97C \CC98\C74C\C5D0 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C774 \C18D\C131\C740 \D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \C601\C5ED \C18D\C131 [\CC28\D2B8 \D45C\C2DC]\AC00 [\C120\D0DD\AE30]\C778 \ACBD\C6B0\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4. \BE0C\B77C\C6B0\C800 \C138\C158\C5D0\C11C\B294 \C0AC\C6A9\C790\AC00 \D45C\C2DC\D55C \CC28\D2B8 \C9D1\D569\C774 \C720\C9C0\B418\AE30 \B54C\BB38\C5D0 \C774 \C18D\C131\C5D0 \B300\D55C \BCC0\ACBD\C0AC\D56D\C774 \C989\C2DC \D45C\C2DC\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4. \C774 \C18D\C131\C758 \BCC0\ACBD \ACB0\ACFC\B97C \D655\C778\D558\B824\BA74 \B9C8\BC95\C0AC\C5D0\C11C \C0DD\C131\D55C \C7AC\C124\C815 \B2E8\CD94\C640 \AC19\C740 [\C601\C5ED \C7AC\C124\C815] \CE90\C2DC \C81C\C5B4 \C635\C158 \B9C1\D06C\B97C \C0AC\C6A9\D558\C5EC \BCF4\ACE0\C11C\B97C \C7AC\C124\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105897008728310182)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\C74C\C5D0 \CC28\D2B8 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105669444957310003)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\D328\C2EF\C744 \CC98\C74C\C5D0 \CD95\C18C\B41C \C0C1\D0DC\B85C \B80C\B354\B9C1\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \BE0C\B77C\C6B0\C800 \C138\C158\C5D0\C11C\B294 \D655\C7A5 \C0C1\D0DC\B85C \C720\C9C0\B418\AE30 \B54C\BB38\C5D0 \C774 \C18D\C131\C5D0 \B300\D55C \BCC0\ACBD\C0AC\D56D\C774 \C989\C2DC \D45C\C2DC\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4. \C774 \C18D\C131\C758 \BCC0\ACBD \ACB0\ACFC\B97C \D655\C778\D558\B824\BA74 \B9C8\BC95\C0AC\C5D0\C11C \C0DD\C131\D55C \C7AC\C124\C815 \B2E8\CD94\C640 \AC19\C740 [\C601\C5ED \C7AC\C124\C815] \CE90\C2DC \C81C\C5B4 \C635\C158 \B9C1\D06C\B97C \C0AC\C6A9\D558\C5EC \BCF4\ACE0\C11C\B97C \C7AC\C124\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105669312312310002)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \CD95\C18C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105902057832310186)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\D328\C2EF\C744 \AE30\BCF8\C801\C73C\B85C \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \ACB0\C815\D569\B2C8\B2E4. \BE0C\B77C\C6B0\C800 \C138\C158\C5D0\C11C\B294 \D45C\C2DC \C0C1\D0DC\AC00 \C720\C9C0\B418\AE30 \B54C\BB38\C5D0 \C774 \C18D\C131\C5D0 \B300\D55C \BCC0\ACBD\C0AC\D56D\C774 \C989\C2DC \D45C\C2DC\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4. \C774 \C18D\C131\C758 \BCC0\ACBD \ACB0\ACFC\B97C \D655\C778\D558\B824\BA74 \B9C8\BC95\C0AC\C5D0\C11C \C0DD\C131\D55C \C7AC\C124\C815 \B2E8\CD94\C640 \AC19\C740 [\C601\C5ED \C7AC\C124\C815] \CE90\C2DC \C81C\C5B4 \C635\C158 \B9C1\D06C\B97C \C0AC\C6A9\D558\C5EC \BCF4\ACE0\C11C\B97C \C7AC\C124\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105901929543310186)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\C74C\C5D0 \D45C\C2DC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105669624960310003)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF\C758 \CD5C\B300 \B192\C774(\D53D\C140)\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105669500476310003)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \B192\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105669701308310003)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53D\C140')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105011976961309478)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130\B9C1\D560 \B54C \AC1C\BCC4 \AC12\C758 \ACB0\D569 \BC29\BC95\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105012253137309479)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.D'
,p_message_language=>'ko'
,p_message_text=>unistr('AND(\AD50\C9D1\D569)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105012329549309479)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C774 "AND"\B97C \C0AC\C6A9\D558\C5EC \ACB0\D569\B418\BBC0\B85C \ACB0\ACFC\B294 \BAA8\B4E0 \AC1C\BCC4 \AC12\C758 \AD50\C9D1\D569\C774 \B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105012029511309478)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('OR(\D569\C9D1\D569)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105012169039309478)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C774 "OR"\B97C \C0AC\C6A9\D558\C5EC \ACB0\D569\B418\BBC0\B85C \ACB0\ACFC\B294 \AC1C\BCC4 \AC12\C758 \D569\C9D1\D569\C774 \B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105011830973309478)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \C870\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105011501676309478)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C77C\BC18 \BB38\C790:</dt>'),
'<dd><pre>,</pre></dd>',
'<dd><pre>:</pre></dd>',
unistr('<dt>\C81C\C5B4 \BB38\C790:</dt>'),
unistr('<dd>\D0ED(<em>ASCII: 9</em>) <pre>\005Ct</pre></dd>'),
unistr('<dd>\C904 \BC14\AFC8(<em>ASCII: 10</em>) <pre>\005Cn</pre></dd>'),
unistr('<dt>\AE30\D0C0 \BB38\C790:</dt>'),
unistr('<dd>''\005Cxxxx'' \D615\C2DD\C758 \C720\B2C8\CF54\B4DC \C778\CF54\B529 \AC12\C744 \C0AC\C6A9\D569\B2C8\B2E4. \C5EC\AE30\C11C ''xxxx''\B294 UCS-2 \C778\CF54\B529 \D615\C2DD\C758 \BB38\C790 16\C9C4\C218 \AC12\C785\B2C8\B2E4.</dd>'),
unistr('<dd>\BA38\B9AC\AE00 \C2DC\C791(<em>ASCII: 1</em>) <pre>\005C0001</pre></dd>'),
unistr('<dd>"@"-\AE30\D638(<em>ASCII: 64</em>) <pre>\005C0040</pre></dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105011447031309478)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AC12\C744 \C11C\B85C \AD6C\BD84\D558\B294 \BB38\C790\B97C \C2DD\BCC4\D569\B2C8\B2E4. <strong>"</strong>(\D070 \B530\C634\D45C) \BC0F <strong>\005C</strong>(\BC31\C2AC\B798\C2DC) \BB38\C790\B294 \AC12 \AD6C\BD84 \AE30\D638\B85C \C9C0\C6D0\B418\C9C0 \C54A\C73C\BA70, <strong>\005Cxxxx</strong> \D615\C2DD\C5D0\C11C\B3C4 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105011363768309478)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \AE30\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105011778128309478)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BD84\D560 \D6C4 \AC1C\BCC4 \AC12\C5D0\C11C \C120\D589 \BC0F \D6C4\D589 \ACF5\BC31\C744 \C81C\AC70\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4.</p>'),
'<pre>',
'APEX:SQL:Spatial :Oracle TEXT: Data Warehouse',
'APEX :SQL:Data Warehouse',
'</pre>',
'<dl>',
unistr('<dt>\ACF5\BC31 \C790\B974\AE30\B97C <em>\C0AC\C6A9 \C548\D568</em>\C73C\B85C \C124\C815\D558\BA74 \B2E4\C74C\ACFC \AC19\C740 \AC1C\BCC4 \AC12\C774 \ACC4\C0B0\B429\B2C8\B2E4.</dt>'),
'<dd><pre>',
'"APEX":            1',
'"APEX ":           1',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  1',
'" Data Warehouse": 1',
'</pre></dd>',
unistr('<dt>\ACF5\BC31 \C790\B974\AE30\B97C <em>\C0AC\C6A9</em>\C73C\B85C \C124\C815\D558\BA74 \B2E4\C74C\ACFC \AC19\C740 \AC1C\BCC4 \AC12\C774 \ACC4\C0B0\B429\B2C8\B2E4.</dt>'),
'<dd><pre>',
'"APEX":            2',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  2',
'</pre></dd>',
unistr('<p>\ACF5\BC31 \C790\B974\AE30\B294 \C9C8\C758 \C131\B2A5\C5D0 \C0C1\B2F9\D55C \C601\D5A5\C744 \BBF8\CE60 \C218 \C788\C2B5\B2C8\B2E4. \B300\D615 \B370\C774\D130 \C9D1\D569\C758 \ACBD\C6B0 \B370\C774\D130 \C815\B9AC\B97C \B300\C2E0 \ACE0\B824\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105011640803309478)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\BC31 \C790\B974\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105012600066309479)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105012733568309479)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C5D0 \C5EC\B7EC \AC12\C774 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105261120570309667)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105261271060309667)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C5D0 \C5EC\B7EC \AC12\C774 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105010853312309477)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C18C\C2A4 \C5F4\C5D0 \C5EC\B7EC \AC12\C774 \D3EC\D568\B418\C5B4 \C788\B294\C9C0 \C5EC\BD80\C640 \C774\B7EC\D55C \AC12\C758 \C778\CF54\B529 \BC29\C2DD\C744 \ACB0\C815\D569\B2C8\B2E4.</p><p><em>\B2E4\C911 \AC12 \D328\C2EF \B610\B294 \D544\D130\B294 Oracle 12.2 \C774\C0C1\C758 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C\B9CC \C9C0\C6D0\B429\B2C8\B2E4. 12.1 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \B2E4\C911 \AC12 \D328\C2EF \B610\B294 \D544\D130\AC00 \C815\C758\B41C \ACBD\C6B0 &PRODUCT_NAME.\C5D0\C11C \B7F0\D0C0\C784 \C624\B958\AC00 \BC1C\C0DD\D569\B2C8\B2E4.</em></p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105011160306309478)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('JSON \BC30\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105011282956309478)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C18C\C2A4 \C5F4\C5D0 \C2A4\CE7C\B77C \AC12\C758 JSON \BC30\C5F4\C774 \D3EC\D568\B429\B2C8\B2E4. \C5F4\C5D0 \BD80\C801\D569\D55C JSON \AD6C\BB38\C774 \D3EC\D568\B41C \ACBD\C6B0 &PRODUCT_NAME.\C5D0\C11C \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D569\B2C8\B2E4.</p><pre>["APEX", "SQL", "PL/SQL"]</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105010962038309478)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105011058180309478)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C5F4\C5D0 \AC12\C774 \AD6C\BD84 \BAA9\B85D\C73C\B85C \D3EC\D568\B429\B2C8\B2E4.</p><pre>APEX,SQL,PL/SQL</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105010738936309477)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105896935871310182)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C0AC\C6A9\C790\AC00 \D328\C2EF \BAA9\B85D \D56D\BAA9 \C218 \CC28\D2B8\B97C \D45C\C2DC\D560 \C218 \C788\B3C4\B85D \D328\C2EF \C606\C5D0 \B2E8\CD94\B97C \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C774 \C18D\C131\C740 \D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \C601\C5ED \C18D\C131 [\CC28\D2B8 \D45C\C2DC]\AC00 [\C544\B2C8\C624]\AC00 \C544\B2CC \ACBD\C6B0\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105896804395310182)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105668456122310002)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\D328\C2EF \B610\B294 \D544\D130\C5D0 \B300\D55C \BAA9\B85D \D56D\BAA9 \BC1C\C0DD \D69F\C218\B97C \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \BAA9\B85D \D56D\BAA9 \C606\C758 \AD04\D638 \C548\C5D0 \AC1C\C218\AC00 \D45C\C2DC\B429\B2C8\B2E4. KING (3)\C744 \C608\B85C \B4E4 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105668356587310001)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C218 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105669002544310002)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\D328\C2EF\C5D0 \B300\D574 \D45C\C2DC\D560 \CD5C\B300 \BAA9\B85D \D56D\BAA9 \C218\B97C \C9C0\C815\D569\B2C8\B2E4. \AC12\C774 \C9C0\C815\B418\ACE0 \BAA9\B85D\C5D0 \C774 \D56D\BAA9 \C218\B97C \CD08\ACFC\D558\B294 \D56D\BAA9\C774 \D3EC\D568\B418\B294 \ACBD\C6B0 \BAA9\B85D \C544\B798\CABD\C5D0 <strong>\B354 \BCF4\AE30</strong> \B9C1\D06C\AC00 \B80C\B354\B9C1\B429\B2C8\B2E4. \AC12\C744 \C9C0\C815\D558\C9C0 \C54A\C744 \ACBD\C6B0 \BAA8\B4E0 \BAA9\B85D \D56D\BAA9\C774 \D45C\C2DC\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105668995264310002)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \D45C\C2DC\B418\B294 \D56D\BAA9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105668896219310002)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C120\D0DD\B41C \BAA9\B85D \D56D\BAA9\C774 \D328\C2EF \B610\B294 \D544\D130\C5D0 \B300\D55C \BAA9\B85D\C5D0\C11C \BA3C\C800 \D45C\C2DC\B420\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C774 \C18D\C131\C740 \D328\C2EF\ACFC \C5F0\AD00\B41C \AC12 \BAA9\B85D\C774 \ADF8\B8F9\C744 \C815\C758\D558\B294 \ACBD\C6B0 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105668770721310002)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \D56D\BAA9 \BA3C\C800 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105298359138309695)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF \B610\B294 \D544\D130\C5D0 \B300\D55C \BAA9\B85D \D56D\BAA9\C744 \C815\B82C\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \AC1C\C218 \B0B4\B9BC\CC28\C21C\C73C\B85C \BAA9\B85D \D56D\BAA9\C774 \C815\B82C\B429\B2C8\B2E4. <strong>\D574\C81C</strong>\B85C \C124\C815\D560 \ACBD\C6B0 \AC12 \BAA9\B85D\C73C\B85C \C815\C758\B41C \C21C\C11C\B300\B85C \BAA9\B85D \D56D\BAA9\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105298263789309695)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \AC1C\C218\B85C \C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105901855691310186)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \D328\C2EF\C744 \D45C\C2DC\D558\AC70\B098 \C228\AE38 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \D558\B098 \C774\C0C1\C758 \D328\C2EF\C5D0 \C774 \C635\C158\C774 \C124\C815\B418\C5B4 \C788\C73C\BA74 \D45C\C2DC\D558\AC70\B098 \C228\AE38 \D328\C2EF\C744 \C120\D0DD\D558\B294 \B370 \C0AC\C6A9\B418\B294 "\CD94\AC00 \D328\C2EF" \B2E8\CD94\AC00 \CD94\AC00\B429\B2C8\B2E4. \D45C\C2DC\B418\C9C0 \C54A\B294 \D328\C2EF \C218\B97C \ACC4\C0B0\D558\B294 \B370\C5D0\B294 \C131\B2A5 \BE44\C6A9\C774 \C5C6\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105901708641310185)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \D1A0\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106088122839310354)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\D328\C2EF \B610\B294 \D544\D130\C5D0 \B300\D574 \AC1C\C218\AC00 0\C778 \BAA9\B85D \D56D\BAA9\C774 \D45C\C2DC\B418\B294 \BC29\C2DD\C744 \C9C0\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106088479458310354)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106088504403310354)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\BAA8\B4E0 \D56D\BAA9\C744 \D45C\C2DC\D558\B418 \D544\D130\B9C1\D560 \C218 \C5C6\B294 \D56D\BAA9\C740 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106088215745310354)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106088342310310354)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\D544\D130\B9C1 \AC00\B2A5\D55C \BAA9\B85D \D56D\BAA9\B9CC \D45C\C2DC\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106088641074310354)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106088703872310355)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\BAA8\B4E0 \D56D\BAA9\C744 \D45C\C2DC\D558\B418 \D544\D130\B9C1\D560 \C218 \C5C6\B294 \D56D\BAA9\C740 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D558\ACE0, \D328\C2EF \B610\B294 \D544\D130\C5D0 \B300\D55C \BAA9\B85D\C5D0\C11C \B9C8\C9C0\B9C9\C5D0 \D45C\C2DC\D569\B2C8\B2E4. \C5F0\AD00\B41C \ACF5\C720 \AC12 \BAA9\B85D\C5D0\C11C \ADF8\B8F9 \AE30\B2A5\C744 \C0AC\C6A9\D558\B294 \ACBD\C6B0 \C774 \C635\C158\C740 \BB34\C2DC\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106088093076310354)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('0 \AC1C\C218 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105221597265309638)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \B808\C774\BE14\C744 \D3EC\D568\D558\B294 HTML \D14C\C774\BE14 \C140\C5D0 \C0AC\C6A9\B418\B294 \CD94\AC00 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105221446115309637)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C140 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105577448199309924)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C \D615\C2DD \D3FC \D544\B4DC\B97C \B80C\B354\B9C1\D560 \B54C \C0AC\C6A9\D560 \D544\B4DC \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4. \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D558\C9C0 \C54A\C740 \ACBD\C6B0 \D544\B4DC\AC00 \AE30\BCF8 \C811\ADFC\C131 \C900\C218 \B808\C774\BE14\C744 \C0AC\C6A9\D558\C5EC \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105597667547309940)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C \D615\C2DD \D3FC \D544\B4DC\B97C \B80C\B354\B9C1\D560 \B54C \C0AC\C6A9\D560 \D544\B4DC \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4. \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D558\C9C0 \C54A\C740 \ACBD\C6B0 \D544\B4DC\AC00 \AE30\BCF8 \C811\ADFC\C131 \C900\C218 \B808\C774\BE14\C744 \C0AC\C6A9\D558\C5EC \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105221358969309637)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D56D\BAA9 \B808\C774\BE14\C758 \BAA8\C591\ACFC \B808\C774\C544\C6C3\C744 \C815\C758\D560 \B808\C774\BE14 \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('        <p>\B808\C774\BE14 \D15C\D50C\B9AC\D2B8\B294 \C560\D50C\B9AC\CF00\C774\C158 \D14C\B9C8\C5D0\C11C \C815\C758\B429\B2C8\B2E4.'),
unistr('        \D56D\BAA9\C774 \C0DD\C131\B418\BA74 \D15C\D50C\B9AC\D2B8\B294 \D604\C7AC \D14C\B9C8\C5D0 \C815\C758\B41C \AE30\BCF8 \D56D\BAA9 \D15C\D50C\B9AC\D2B8\B85C \C790\B3D9\C73C\B85C \C124\C815\B429\B2C8\B2E4.</p>'),
unistr('        <p>\B300\BD80\BD84\C758 \D14C\B9C8\C5D0\B294 \D544\C218, \C120\D0DD\C0AC\D56D, \C228\AE40 \B808\C774\BE14\C744 \D45C\C2DC\D558\AE30 \C704\D55C \B808\C774\BE14 \D15C\D50C\B9AC\D2B8\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.<br>'),
unistr('        \BC94\C6A9 \D14C\B9C8\B294 \B2E4\C74C\ACFC \AC19\C740 \B808\C774\BE14 \D15C\D50C\B9AC\D2B8\B97C \C81C\ACF5\D569\B2C8\B2E4.'),
'          <dl>',
unistr('            <dt>\C228\AE40</dt>'),
unistr('              <dd>\B808\C774\BE14\C774 \D654\BA74\C5D0 \D45C\C2DC\B418\C9C0 \C54A\C544\C57C \D560 \ACBD\C6B0 \C774 \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D569\B2C8\B2E4. \BCF4\C870 \ACF5\D559\C744 \C0AC\C6A9\D558\C5EC \B808\C774\BE14\C744 \C77D\C744 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('              \CCB4\D06C\BC15\C2A4 \B4A4\C5D0 \B808\C774\BE14\C774 \D45C\C2DC\B418\C5B4\C57C \D558\BBC0\B85C \CCB4\D06C\BC15\C2A4 \D56D\BAA9\C5D0\B294 \C228\AE40\C774 \BB34\C2DC\B429\B2C8\B2E4.</dd>'),
unistr('            <dt>\C120\D0DD\C0AC\D56D</dt>'),
unistr('              <dd>\C120\D0DD\C0AC\D56D\C778 \D3FC \D56D\BAA9\C5D0 \B300\D574 \C774 \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D569\B2C8\B2E4. \B808\C774\BE14\C774 \D56D\BAA9\C758 \CE21\BA74\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</dd>'),
unistr('            <dt>\C120\D0DD\C0AC\D56D - \C704</dt>'),
unistr('              <dd>\C120\D0DD\C0AC\D56D\C778 \D3FC \D56D\BAA9\C5D0 \B300\D574 \C774 \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D569\B2C8\B2E4. \B808\C774\BE14\C774 \D56D\BAA9 \C704\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</dd>'),
unistr('            <dt>\C120\D0DD\C0AC\D56D - \BD80\B3D9</dt>'),
unistr('              <dd>\C120\D0DD\C0AC\D56D\C778 \D3FC \D56D\BAA9\C5D0 \B300\D574 \C774 \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D569\B2C8\B2E4. \B808\C774\BE14\C774 \C785\B825 \D56D\BAA9 \C548\C5D0 \D45C\C2DC\B418\BA70 \C785\B825 \D544\B4DC\C5D0 \AC12\C774 \CC44\C6CC\C9C4 \D6C4 \C790\B3D9\C73C\B85C \CD95\C18C\B429\B2C8\B2E4.</dd>'),
unistr('            <dt>\D544\C218</dt>'),
unistr('              <dd>\C774 \B808\C774\BE14 \D15C\D50C\B9AC\D2B8\B294 \B808\C774\BE14 \C606\C5D0 \BE68\AC04\C0C9 \BCC4\D45C\AC00 \D45C\C2DC\B418\BA70 \C0AC\C6A9\C790 \C785\B825\C774 \D544\C694\D55C \D3FC \D56D\BAA9\C5D0 \C0AC\C6A9\B429\B2C8\B2E4. \B808\C774\BE14\C774 \D56D\BAA9\C758 \CE21\BA74\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</dd>'),
unistr('            <dt>\D544\C218 - \C704</dt>'),
unistr('              <dd>\C774 \B808\C774\BE14 \D15C\D50C\B9AC\D2B8\B294 \B808\C774\BE14 \C606\C5D0 \BE68\AC04\C0C9 \BCC4\D45C\AC00 \D45C\C2DC\B418\BA70 \C0AC\C6A9\C790 \C785\B825\C774 \D544\C694\D55C \D3FC \D56D\BAA9\C5D0 \C0AC\C6A9\B429\B2C8\B2E4. \B808\C774\BE14\C774 \D56D\BAA9 \C704\C5D0 \D45C\C2DC\B429\B2C8\B2E4. \D56D\BAA9 \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D558\C5EC \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \C18D\C131\C744 \D14C\B9C8\C758 \C77C\BD80\B85C \C815\C758\D558\ACE0 \B9CE\C740 \D398\C774\C9C0 \D56D\BAA9 \AC04\C5D0 \D574\B2F9 \C815\C758\B97C \ACF5\C720\D560 \C218 \C788\C2B5\B2C8\B2E4.</dd>'),
unistr('            <dt>\D544\C218 - \BD80\B3D9</dt>'),
unistr('              <dd>\C774 \B808\C774\BE14 \D15C\D50C\B9AC\D2B8\B294 \B808\C774\BE14 \C606\C5D0 \BE68\AC04\C0C9 \BCC4\D45C\AC00 \D45C\C2DC\B418\BA70 \C0AC\C6A9\C790 \C785\B825\C774 \D544\C694\D55C \D3FC \D56D\BAA9\C5D0 \C0AC\C6A9\B429\B2C8\B2E4. \B808\C774\BE14\C774 \C785\B825 \D56D\BAA9 \C548\C5D0 \D45C\C2DC\B418\BA70 \C785\B825 \D544\B4DC\C5D0 \AC12\C774 \CC44\C6CC\C9C4 \D6C4 \C790\B3D9\C73C\B85C \CD95\C18C\B429\B2C8\B2E4. \D56D\BAA9 \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D558\C5EC \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \C18D\C131\C744 \D14C\B9C8\C758 \C77C\BD80\B85C \C815\C758\D558\ACE0 \B9CE\C740 \D398\C774\C9C0 \D56D\BAA9 \AC04\C5D0 \D574\B2F9 \C815\C758\B97C \ACF5\C720\D560 \C218 \C788\C2B5\B2C8\B2E4.</dd>'),
'          </dl>',
unistr('          \CC38\C870: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105221294496309637)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106034511351310304)
,p_name=>'PE.PROPERTY.FILTER_DATA_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C720\D615 \D544\D130\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105448548619309818)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C5F4 \D544\D130\C5D0 \D14D\C2A4\D2B8\B97C \C785\B825\D560 \B54C \C815\D655\D55C \C77C\CE58 \AC80\C0C9\C744 \C218\D589\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('      <strong>\D574\C81C</strong>\B85C \C124\C815\D560 \ACBD\C6B0 \D544\D130\AC00 \AC19\C74C \AC80\C0C9\C774 \C544\B2CC \D3EC\D568 \AC80\C0C9\C744 \C218\D589\D569\B2C8\B2E4.</p>'),
unistr('      <p>\C608\B97C \B4E4\C5B4, TAGS\B77C\B294 \C5F4\C758 \ACBD\C6B0 TAGS = ''<<value>>''\C640 \B3D9\B4F1\D569\B2C8\B2E4. \C815\D655\D55C \C77C\CE58\B97C <strong>\D574\C81C</strong>\B85C \C124\C815\D560 \ACBD\C6B0 TAGS LIKE ''%<<value>>%''\C640 \B3D9\B4F1\D569\B2C8\B2E4. ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105448435974309818)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\D655\D55C \C77C\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105446993951309816)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D544\D130\AC00 \C774 \C5F4\C5D0 \B300\D574 \D56D\C0C1 \D544\C694\D55C\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \D544\D130\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC \C18D\C131\C758 <strong>\D544\D130 \D544\C694</strong> \C635\C158\ACFC \C0C1\AD00 \C5C6\C774 \B370\C774\D130\AC00 \BC18\D658\B418\AE30 \C804\C5D0 \C774 \D2B9\C815 \C5F4\C5D0 \B300\D574 \D56D\C0C1 \D544\C694\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105446854259309816)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105447169980309817)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C5F4 \BA38\B9AC\AE00\C774\B098 \D544\D130 \B300\D654\C0C1\C790\C5D0\C11C \B204\B97C \B54C \D544\D130\C5D0 \B300\D55C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D560 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105447411581309817)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105447588034309817)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \C5F4 \AC12\C740 VARCHAR2 \BC0F NUMBER \C5F4\C5D0 \B300\D574 \D45C\C2DC\B429\B2C8\B2E4. DATE \BC0F TIMESTAMP \C5F4\C740 \B0B4\C7A5\B418\ACE0 \C0AC\C804 \C815\C758\B41C \B0A0\C9DC \BC94\C704\B97C \D65C\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106033507636310303)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106033676574310303)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C740 \AC12 \BAA9\B85D\C5D0\C11C \D30C\C0DD\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105447290217309817)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105447306108309817)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D544\D130\C5D0 \D45C\C2DC\B418\B294 \BAA8\B4E0 \AC12\C744 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4.'),
unistr('        \C774 \C635\C158\C740 \C77C\BC18\C801\C73C\B85C \AC00\C7A5 \D070 \AC12\C774 50\C790\B97C \CD08\ACFC\D558\B294 \D070 \C5F4\C774\B098 \BAA9\B85D\C774 \D2B9\C815 \B808\CF54\B4DC\B97C \C120\D0DD\D558\B294 \B370 \BCC4\B85C \C720\C6A9\D558\C9C0 \C54A\C740 \ACBD\C6B0 \C801\D569\D569\B2C8\B2E4.'),
unistr('        \B300\C2E0 \C77C\BC18 \C0AC\C6A9\C790\B294 \AC12\C758 \C77C\BD80\B9CC \C785\B825\D558\BA74 \ACB0\ACFC\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105448260310309818)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105448382269309818)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C774 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C5D0\C11C \D30C\C0DD\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105447890242309817)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C720 \AD6C\C131\C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105447983917309817)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C774 \AE30\C874 \AC12 \BAA9\B85D\C5D0\C11C \D30C\C0DD\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105447684938309817)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105447727212309817)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C774 SQL \C9C8\C758 \C815\C758\C5D0\C11C \D30C\C0DD\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105448027908309817)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105448136398309818)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C774 \C815\C801 \AC12 \BAA9\B85D\C5D0\C11C \D30C\C0DD\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105447006386309816)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('LOV \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105445700713309815)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \C5F4\C5D0 \B300\D574 \D65C\C6A9\D560 \C218 \C788\B294 \D544\D130 \C791\C5C5\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('        <p>\B370\C774\D130\C138\D2B8 \BC0F \C5F4 \C778\B371\C2A4\C758 \D06C\AE30\C5D0 \B530\B77C \C77C\BC18 \C0AC\C6A9\C790\C5D0 \B300\D55C \C131\B2A5 \BB38\C81C\B97C \D53C\D558\AE30 \C704\D574 \D2B9\C815 \D544\D130 \C791\C5C5\C744 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D558\B3C4\B85D \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('        \D2B9\C815 \C791\C5C5\C740 \C5F4 \C778\B371\C2A4\B97C \C0AC\C6A9\D558\B294 \B300\C2E0 \C804\CCB4 \D14C\C774\BE14 \C2A4\CE94\C744 \C720\BC1C\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105617060355309956)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105617103655309956)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D544\D130\AC00 \D544\D130 \AC12\C744 \D3EC\D568\D558\B294 \C5F4 \AC12\C758 \ACB0\ACFC\B97C \BC18\D658\D569\B2C8\B2E4.'),
unistr('        &PRODUCT_NAME.\C740(\B294) where \C808\C5D0\C11C <code>column LIKE <strong>%</strong>filtervalue<strong>%</strong></code>\B97C \D65C\C6A9\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \C774 \C5F0\C0B0\C790\B294 \C5F4 \C778\B371\C2A4\AC00 \C0AC\C6A9\B418\B294 \AC83\C744 \B9C9\C73C\BBC0\B85C \C804\CCB4 \D14C\C774\BE14 \C2A4\CE94\C774 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105445993996309816)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C18C\BB38\C790 \BB34\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105568552233309917)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D544\D130\AC00 \C5F4 \AC12\ACFC \D544\D130 \AC12\C758 \CC28\C774\C640 \C0C1\AD00 \C5C6\C774 \C5F4 \AC12\C758 \ACB0\ACFC\B97C \BC18\D658\D569\B2C8\B2E4.'),
unistr('        &PRODUCT_NAME.\C740(\B294) where \C808\C5D0\C11C <code>UPPER(column) <em>operator</em> UPPER(filtervalue)</code>\B97C \D65C\C6A9\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \C77C\BC18\C801\C73C\B85C \C5F4\ACFC \D544\D130 \AC12 \BAA8\B450\C5D0 \B300\D574 UPPER\B97C \C218\D589\D558\BA74 UPPER(<em>column</em>)\C758 \D568\C218 \AE30\BC18 \C5F4 \C778\B371\C2A4\B97C \C81C\C678\D558\ACE0 \C5F4 \C778\B371\C2A4\B97C \C0AC\C6A9\D558\C9C0 \BABB\D558\AC8C \B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105445858152309816)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\ADDC \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105568621269309917)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D544\D130\AC00 \C785\B825\B41C \C815\ADDC \D45C\D604\C2DD\C744 \AE30\C900\C73C\B85C \ACB0\ACFC\B97C \BC18\D658\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - REGEXP \C5F0\C0B0\C790\B97C \C0AC\C6A9\D558\B294 \AC83\C740 \BCF5\C7A1\D558\BA70 \C77C\BC18\C801\C73C\B85C \ACE0\AE09 \C0AC\C6A9\C790\C5D0 \C758\D574\C11C\B9CC \C0AC\C6A9\B429\B2C8\B2E4. \C774\B7EC\D55C \C5F0\C0B0\C790\B294 \C131\B2A5\C744 \D06C\AC8C \C800\D558\C2DC\D0AC \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105617240033309956)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C73C\B85C \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105617391853309956)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D544\D130\AC00 \D544\D130 \AC12\C73C\B85C \C2DC\C791\D558\B294 \C5F4 \AC12\C758 \ACB0\ACFC\B97C \BC18\D658\D569\B2C8\B2E4.'),
unistr('        &PRODUCT_NAME.\C740(\B294) where \C808\C5D0\C11C <code>column LIKE filtervalue<strong>%</strong></code>\B97C \D65C\C6A9\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \C774 \C5F0\C0B0\C790\B294 \C0AC\C6A9 \AC00\B2A5\D55C \C5F4 \C778\B371\C2A4\B97C \D65C\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. {\C608\C678\C0AC\D56D\C740 <strong>\B300\C18C\BB38\C790 \BB34\C2DC</strong>\B97C \AC80\D1A0\D558\C2ED\C2DC\C624.}</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105445611078309815)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\B2A5\C5D0 \C601\D5A5\C744 \C8FC\B294 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105446169340309816)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C5F4 \AC12\C774 \C800\C7A5\B418\B294 \D14D\C2A4\D2B8\C758 \B300\C18C\BB38\C790\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('        <p>\C5F4\C744 \D56D\C0C1 \B300\BB38\C790\B85C \C9C0\C815\D560 \C218 \C788\B294 \ACBD\C6B0(\C608: <em>Username</em>) \B610\B294 \D56D\C0C1 \C18C\BB38\C790\B85C \C9C0\C815\D560 \C218 \C788\B294 \ACBD\C6B0 \D544\D130 \ACB0\ACFC \AC80\C0C9 \C131\B2A5\C774 \D5A5\C0C1\B420 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('          <strong>\B300\BB38\C790</strong> \B610\B294 <strong>\C18C\BB38\C790</strong>\AC00 \C120\D0DD\B418\BA74 \AC80\C0C9\C5D0\C11C \D56D\C0C1 \B300\C18C\BB38\C790 \AD6C\BD84 \AC80\C0C9\C744 \C218\D589\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - [\D63C\D569]\C774 \C120\D0DD\B418\BA74 \C77C\BC18 \C0AC\C6A9\C790\B294 \AC80\C0C9 \BC0F \D544\D130 \B300\D654\C0C1\C790\C5D0\C11C <strong>\B300\C18C\BB38\C790 \AD6C\BD84</strong>\C744 \C9C0\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105446403689309816)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\BB38\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105446519558309816)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 \D56D\C0C1 \C18C\BB38\C790\B85C \C800\C7A5\B418\B294 \ACBD\C6B0\C5D0 \C0AC\C6A9\D569\B2C8\B2E4.'),
unistr('        &PRODUCT_NAME.\C740(\B294) where \C808\C5D0\C11C <code>column <em>operator</em> LOWER(filtervalue)</code>\B97C \D65C\C6A9\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105446613621309816)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D63C\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105446718185309816)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AC12\C774 \D63C\D569\B41C \B300\C18C\BB38\C790\B85C \C800\C7A5\B418\B294 \ACBD\C6B0\C5D0 \C0AC\C6A9\D569\B2C8\B2E4. <strong>\B300\C18C\BB38\C790 \BB34\C2DC</strong> \C5F0\C0B0\C790\C5D0 \B300\D55C \C124\C815\C774 \D65C\C6A9\B418\B294 where \C808\C744 \ACB0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105446219750309816)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\BB38\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105446339633309816)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 \D56D\C0C1 \B300\BB38\C790\B85C \C800\C7A5\B418\B294 \ACBD\C6B0\C5D0 \C0AC\C6A9\D569\B2C8\B2E4.'),
unistr('        &PRODUCT_NAME.\C740(\B294) where \C808\C5D0\C11C <code>column <em>operator</em> UPPER(filtervalue)</code>\B97C \D65C\C6A9\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105446040472309816)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \B300\C18C\BB38\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105240188303309651)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CD08\AE30\D654 \C2DC \C791\C5C5\C774 \C2E4\D589\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('        							<p>\B3D9\C801 \C791\C5C5\C774 \C815\C758\B41C \BC29\BC95\C5D0 \B530\B77C \CD08\AE30\D654\C758 \C758\BBF8\AC00 \C870\AE08\C529 \B2EC\B77C\C9D1\B2C8\B2E4. \B300\D654\C2DD'),
unistr('        							\ADF8\B9AC\B4DC \C5F4\C5D0\C11C \B3D9\C801 \C791\C5C5\C744 \C2E4\D589\D558\B3C4\B85D \C815\C758\D55C \ACBD\C6B0 \D3B8\C9D1\C744 \C704\D574 \B300\D654\C2DD \ADF8\B9AC\B4DC \D589\C774 \D65C\C131\D654\B418\BA74'),
unistr('        							\C791\C5C5\C774 \C2E4\D589\B429\B2C8\B2E4. \BAA8\B4E0 \B2E4\B978 \B3D9\C801 \C791\C5C5\C758 \ACBD\C6B0 \D398\C774\C9C0\AC00 \B85C\B4DC\B420 \B54C \C791\C5C5\C774'),
unistr('        							\C2E4\D589\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105240012342309651)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30\D654 \C2DC \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105239999715309651)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>True</strong>(True \C791\C5C5)\B97C \C120\D0DD\D558\C5EC \D2B8\B9AC\AC70 \C694\C18C \C870\AC74\C774 \CDA9\C871\B420 \B54C \B610\B294 <strong>False</strong>(False \C791\C5C5)\B97C \C120\D0DD\D558\C5EC \CDA9\C871\B418\C9C0 \C54A\C744 \B54C \C774 \C791\C5C5\C774 \C2E4\D589\B418\B294\C9C0\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C870\AC74\C774 \C9C0\C815\B418\C9C0 \C54A\C558\C73C\BA74 <strong>True</strong> \C791\C5C5\B9CC \C2E4\D589\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105729616313310055)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.FALSE.D'
,p_message_language=>'ko'
,p_message_text=>'False'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105729537374310055)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.TRUE.D'
,p_message_language=>'ko'
,p_message_text=>'True'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105239866299309651)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \ACB0\ACFC\AC00 \B2E4\C74C \C870\AC74\C77C \B54C \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106113781655310377)
,p_name=>'PE.PROPERTY.FIXED_HEADER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C758 \C5F4 \BA38\B9AC\AE00\C744 <strong>\D398\C774\C9C0</strong> \C0C1\B2E8 \B610\B294 <strong>\C601\C5ED</strong> \C0C1\B2E8\C5D0 \ACE0\C815\D558\C5EC \C0AC\C6A9\C790\AC00 \BCF4\ACE0\C11C\B97C \C138\B85C\B85C \C2A4\D06C\B864 \D560 \B54C \C5F4 \BA38\B9AC\AE00\C774 \ACC4\C18D \D45C\C2DC\B418\B3C4\B85D \D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106114739759310378)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106114830961310378)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \BA38\B9AC\AE00\C774 \ACE0\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106113996893310378)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106114131339310378)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \BA38\B9AC\AE00\C744 \D398\C774\C9C0 \C0C1\B2E8\C5D0 \ACE0\C815\D569\B2C8\B2E4. \C0AC\C6A9\C790\AC00 \D398\C774\C9C0\B97C \C138\B85C\B85C \C2A4\D06C\B864\D560 \B54C \BCF4\ACE0\C11C \BA38\B9AC\AE00\C774 \D398\C774\C9C0 \C0C1\B2E8\C5D0 \ACE0\C815\B41C \C0C1\D0DC\B85C \C720\C9C0\B429\B2C8\B2E4. <strong>\D398\C774\C9C0</strong> \B808\BCA8 \ACE0\C815 \BA38\B9AC\AE00\C740 \BCF4\ACE0\C11C\AC00 \D398\C774\C9C0\C758 \AE30\BCF8 \CF58\D150\CE20\C778 \ACBD\C6B0 \C720\C6A9\D569\B2C8\B2E4. \C774 \C124\C815\C740 \C601\C5ED\C774 \B300\D654\C0C1\C790\C5D0 \C788\C744 \ACBD\C6B0 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106113855444310377)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106114097661310378)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \BA38\B9AC\AE00\C744 \D604\C7AC \C601\C5ED \C0C1\B2E8\C5D0 \ACE0\C815\D569\B2C8\B2E4. \C0AC\C6A9\C790\AC00 \C601\C5ED \B0B4\C5D0\C11C \C138\B85C\B85C \C2A4\D06C\B864\D560 \B54C \BCF4\ACE0\C11C \BA38\B9AC\AE00\C774 \C601\C5ED \C0C1\B2E8\C5D0 \ACE0\C815\B41C \C0C1\D0DC\B85C \C720\C9C0\B429\B2C8\B2E4. <strong>\C601\C5ED</strong> \B808\BCA8 \ACE0\C815 \BA38\B9AC\AE00\C740 \C5EC\B7EC \C601\C5ED\C774 \D3EC\D568\B418\C5B4 \C788\B294 \D398\C774\C9C0(\C608: \B300\C2DC\BCF4\B4DC \D398\C774\C9C0)\C5D0 \C720\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106113657328310377)
,p_name=>'PE.PROPERTY.FIXED_HEADER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C815 \C0AC\D56D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106115110566310379)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C758 \CD5C\B300 \B192\C774(\D53D\C140)\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106115061238310379)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \BCF4\ACE0\C11C \B192\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106115235344310379)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53D\C140')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105623101126309961)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C758 \ACE0\C815 \B192\C774(\D53D\C140)\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105623082354309961)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C815 \BCF4\ACE0\C11C \B192\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105623271494309961)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53D\C140')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105439692246309810)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\ACE0\C815 \D589 \B192\C774\B85C \B300\D654\C2DD \ADF8\B9AC\B4DC\B97C \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('        <p><em>\C608</em>\B85C \C124\C815\B418\BA74 \B108\BB34 \C881\C544\C11C \BAA8\B4E0 \B370\C774\D130\B97C \D45C\C2DC\D560 \C218 \C5C6\B294 \C5F4\C758 \ACBD\C6B0 \B370\C774\D130 \B05D\C5D0 \B9D0\C904\C784\D45C(...)\AC00 \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('        <em>\C544\B2C8\C624</em>\B85C \C124\C815\B418\BA74 \B370\C774\D130\AC00 \D544\C694\C5D0 \B530\B77C \C5EC\B7EC \C904\C5D0 \AC78\CCD0 \C904\BC14\AFC8\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105439574082309810)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C815 \D589 \B192\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105309002635309704)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C601\C5ED \D15C\D50C\B9AC\D2B8\C5D0\C11C <code>#BODY#</code> \B2E4\C74C\C758 \BCF8\BB38 \CF58\D150\CE20 \BC14\B85C \B2E4\C74C\C5D0 \D45C\C2DC\B418\B294 \C601\C5ED \BC14\B2E5\AE00\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\B300\CCB4 \BB38\C790\C5F4 <code>#TIMING#</code>\C740 \BB3C\B860 \BC14\B85C\AC00\AE30\B97C \C0AC\C6A9\D574\C11C \C601\C5ED\C744 \B80C\B354\B9C1\D558\B294 \B370 \C18C\BE44\B418\B294 \C2DC\AC04\C744 \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\BCF4\ACE0\C11C \C601\C5ED\C5D0 \B300\D574\C11C\B294 \B2E4\C74C \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \B300\CCB4 \BB38\C790\C5F4\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>\BCF4\ACE0 \C5D4\C9C4\C5D0 \C758\D574 \C778\CD9C\B418\B294 \D589 \C218(\D398\C774\C9C0 \D06C\AE30)\B97C \D45C\C2DC\D569\B2C8\B2E4. \B2E4\C74C\ACFC \AC19\C740 \B300\CCB4 \BB38\C790\C5F4\C744 \C0AC\C6A9\D574\C11C \C0AC\C6A9\C790\C5D0\AC8C \C0AC\C6A9\C790\C815\C758\B41C \BA54\C2DC\C9C0\B97C \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
unistr('    <dd>\BCF4\ACE0\C11C\C5D0 \C0AC\C6A9\B41C SQL \C9C8\C758\B97C \B9CC\C871\C2DC\D0A4\B294 \CD1D \D589 \C218\B97C \D45C\C2DC\D569\B2C8\B2E4. \C608: X - Y/Z \D589\C5D0\C11C Z</dd>'),
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
unistr('    <dd>X - Y/Z \D589\C5D0\C11C X</dd>'),
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
unistr('    <dd>X - Y/Z \D589\C5D0\C11C Y</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105218679655309635)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8 \BC14\B2E5\AE00 \C55E\C5D0 \D45C\C2DC\D560 \D14D\C2A4\D2B8 \B610\B294 HTML\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105218567753309635)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\B2E5\AE00 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105758441910310077)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C774 \C18D\C131\C744 <code>fielddatabold</code>\B85C \C124\C815\D558\BA74 \B2E4\C74C HTML\C774 \C0DD\C131\B429\B2C8\B2E4.</dt>'),
'<dd><pre>',
'&lt;span class="fielddatabold"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105575864556309923)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C5F4\C758 \AC12\C5D0 \C801\C6A9\D560 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. CSS \D074\B798\C2A4\B97C \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774 \D074\B798\C2A4\B294 \AE30\BCF8\C801\C73C\B85C \BAA8\B4E0 &PRODUCT_NAME. \D398\C774\C9C0\C5D0 \D3EC\D568\B418\BA70 <code>''.fielddatabold{font-size: 10pt; font-weight: bold; color: #000000;}''</code> \C815\C758\B97C \AC16\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105575701636309923)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105577317562309924)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C5F4\C5D0 \C801\C6A9\D560 \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('    \D615\C2DD \B9C8\C2A4\D06C\C758 \D45C\C2DC \BC29\BC95\C5D0 \B300\D55C \C0D8\D50C \D45C\C2DC\C5D0 \B530\B77C \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D558\AC70\B098 \BBF8\B9AC \C815\C758\B41C \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('    <p>\C22B\C790 \D615\C2DD \B9C8\C2A4\D06C\B294 \C22B\C790\B97C \D3EC\D568\D558\B294 \C5F4\C5D0\B9CC \C801\C6A9\B418\ACE0 \B0A0\C9DC \D615\C2DD \B9C8\C2A4\D06C\B294 \B0A0\C9DC\B97C \D3EC\D568\D558\B294 \C5F4\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.'),
unistr('    \ADF8\B807\C9C0 \C54A\ACE0 \C9C0\C815\B41C \D615\C2DD \B9C8\C2A4\D06C\B97C \C0AC\C6A9\D574\C11C \BCC0\D658\D560 \C218 \C5C6\B294 \AC12\C774 \B808\CF54\B4DC\C5D0 \D3EC\D568\B41C \ACBD\C6B0\C5D0\B294 \B7F0\D0C0\C784 \C624\B958\AC00 \BC1C\C0DD\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105597497588309940)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C5F4\C5D0 \C801\C6A9\D560 \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('    \D615\C2DD \B9C8\C2A4\D06C\C758 \D45C\C2DC \BC29\BC95\C5D0 \B300\D55C \C0D8\D50C \D45C\C2DC\C5D0 \B530\B77C \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D558\AC70\B098 \BBF8\B9AC \C815\C758\B41C \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('    <p>\C22B\C790 \D615\C2DD \B9C8\C2A4\D06C\B294 \C22B\C790\B97C \D3EC\D568\D558\B294 \C5F4\C5D0\B9CC \C801\C6A9\B418\ACE0 \B0A0\C9DC \D615\C2DD \B9C8\C2A4\D06C\B294 \B0A0\C9DC\B97C \D3EC\D568\D558\B294 \C5F4\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.'),
unistr('    \ADF8\B807\C9C0 \C54A\ACE0 \C9C0\C815\B41C \D615\C2DD \B9C8\C2A4\D06C\B97C \C0AC\C6A9\D574\C11C \BCC0\D658\D560 \C218 \C5C6\B294 \AC12\C774 \B808\CF54\B4DC\C5D0 \D3EC\D568\B41C \ACBD\C6B0\C5D0\B294 \B7F0\D0C0\C784 \C624\B958\AC00 \BC1C\C0DD\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105223341409309639)
,p_name=>'PE.PROPERTY.FORMAT_MASK.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\C5D0 \C801\C6A9\D560 \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('    \D615\C2DD \B9C8\C2A4\D06C\C758 \D45C\C2DC \BC29\BC95\C5D0 \B300\D55C \C0D8\D50C \D45C\C2DC\C5D0 \B530\B77C \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D558\AC70\B098 \BBF8\B9AC \C815\C758\B41C \D615\C2DD \B9C8\C2A4\D06C \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('    <p>\C22B\C790 \D615\C2DD \B9C8\C2A4\D06C\B294 \C22B\C790\B97C \D3EC\D568\D558\B294 \AD6C\C131\C694\C18C\C5D0\B9CC \C801\C6A9\B418\ACE0 \B0A0\C9DC \D615\C2DD \B9C8\C2A4\D06C\B294 \B0A0\C9DC\B97C \D3EC\D568\D558\B294 \AD6C\C131\C694\C18C\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.'),
unistr('    \ADF8\B807\C9C0 \C54A\ACE0 \C9C0\C815\B41C \D615\C2DD \B9C8\C2A4\D06C\B97C \C0AC\C6A9\D574\C11C \BCC0\D658\D560 \C218 \C5C6\B294 \AC12\C774 \AD6C\C131\C694\C18C\C5D0 \D3EC\D568\B41C \ACBD\C6B0\C5D0\B294 \B7F0\D0C0\C784 \C624\B958\AC00 \BC1C\C0DD\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105223214617309639)
,p_name=>'PE.PROPERTY.FORMAT_MASK.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \B9C8\C2A4\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105223564480309639)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \C801\C6A9\D560 \B0A0\C9DC \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\D615\C2DD \B9C8\C2A4\D06C\C758 \D45C\C2DC \BC29\BC95\C5D0 \B300\D55C \C0D8\D50C \D45C\C2DC\C5D0 \B530\B77C \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D558\AC70\B098 \BBF8\B9AC \C815\C758\B41C \D615\C2DD \B9C8\C2A4\D06C \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\B610\D55C \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D574\C11C \C560\D50C\B9AC\CF00\C774\C158 \B610\B294 \D398\C774\C9C0 \D56D\BAA9\C5D0\C11C \B3D9\C801 \D615\C2DD \B9C8\C2A4\D06C\B97C \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105223469518309639)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \B9C8\C2A4\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105223771271309639)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \C801\C6A9\D560 \C22B\C790 \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\D615\C2DD \B9C8\C2A4\D06C\C758 \D45C\C2DC \BC29\BC95\C5D0 \B300\D55C \C0D8\D50C \D45C\C2DC\C5D0 \B530\B77C \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D558\AC70\B098 \BBF8\B9AC \C815\C758\B41C \D615\C2DD \B9C8\C2A4\D06C \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\B610\D55C \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D574\C11C \C560\D50C\B9AC\CF00\C774\C158 \B610\B294 \D398\C774\C9C0 \D56D\BAA9\C5D0\C11C \D615\C2DD \B9C8\C2A4\D06C\B97C \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105223674771309639)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \B9C8\C2A4\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105220047372309636)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D398\C774\C9C0\C5D0 \B300\D574 \C790\B3D9 \C644\C131\C744 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <strong>\C124\C815</strong> \AC12\C740 \C774 \D398\C774\C9C0\C5D0 \C601\D5A5\C744 \C8FC\C9C0 \C54A\C2B5\B2C8\B2E4. <strong>\D574\C81C</strong> \AC12\C740 FROM \D0DC\ADF8\C5D0 \B2E4\C74C HTML\C744 \C0DD\C131\D569\B2C8\B2E4.'),
'<pre>',
'autocomplete="off"',
'</pre>',
unistr('<p>\CC38\ACE0: <code>autocomplete="off"</code>\AC00 \C801\C6A9 \B610\B294 \BB34\C2DC\B418\B294 \ACBD\C6B0 \BE0C\B77C\C6B0\C800\B9C8\B2E4 \ADDC\CE59\C774 \B2E4\B97C \C218 \C788\C73C\BBC0\B85C, \C774 \C18D\C131\C744 <strong>\D574\C81C</strong>\B85C \C124\C815\D560 \B54C \D2B9\D788 \C8FC\C758\D558\C5EC \B300\C0C1 \BE0C\B77C\C6B0\C800\C5D0\C11C \D14C\C2A4\D2B8\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105721593160310049)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.OFF.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105721469756310049)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.ON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105219970564309636)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \C790\B3D9 \C644\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104931430216309419)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B808\C774\BE14 \C815\C758\C5D0 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104931352506309419)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105574357394309921)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \BCF4\ACE0\C11C \C5F4\C758 \CD5C\B300 \C218\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\C77C\BC18 \C5F4 \C774\B984\C744 \C0AC\C6A9\D558\B294 \BCF4\ACE0\C11C\B294 \B7F0\D0C0\C784\C5D0\B9CC \AD6C\BB38\BD84\C11D\B418\BBC0\B85C \BCF4\ACE0\C11C\B97C \D3B8\C9D1\D560 \B54C\B294 \C5F4 \C218\B97C \C54C \C218 \C5C6\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\BCF4\ACE0\C11C \C5F4\C758 \CD5C\B300 \C218\B294 \C608\C0C1\B418\B294 \BCF4\ACE0\C11C \C5F4 \C218\C640 \C77C\CE58\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C2E4\C81C \AC1C\C218\AC00 \B354 \C791\C73C\BA74 \C2E4\C81C \C5F4 \C218\B9CC\D07C \BCF4\ACE0\C11C\AC00 \B80C\B354\B9C1\B429\B2C8\B2E4.'),
unistr('\D558\C9C0\B9CC \C2E4\C81C \AC1C\C218\AC00 \CD5C\B300\AC12\BCF4\B2E4 \B354 \B9CE\C73C\BA74 \B7F0\D0C0\C784\C5D0 \C624\B958 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105574251674309921)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C5F4 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105361154926309743)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C9C1 \C815\C758\B41C \D56D\BAA9\C774 \C5C6\C73C\BA74 \D604\C7AC \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\C5D0 \B300\D55C \C804\C5ED \D398\C774\C9C0\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105361050732309743)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106022053674310292)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105595381977309938)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105595634809309938)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105222317840309638)
,p_name=>'PE.PROPERTY.GRID_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B9\C815 \B808\C774\C544\C6C3 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \AD6C\C131\C694\C18C\AC00 \D45C\C2DC\B418\B294 \C0AC\C6A9 \AC00\B2A5\D55C \B2E4\C74C \B808\C774\C544\C6C3 \C5F4\C744 \C790\B3D9\C73C\B85C \ACB0\C815\D558\B824\BA74 <strong>\C790\B3D9</strong>\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105222267956309638)
,p_name=>'PE.PROPERTY.GRID_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105223113258309639)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\C544\C6C3 \C5F4\C5D0 \B300\D55C \CD94\AC00 \C18D\C131 \C9D1\D569\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \B808\C774\C544\C6C3 \C5F4 \D15C\D50C\B9AC\D2B8\C5D0\C11C <code>#ATTRIBUTES#</code> \B300\CCB4 \C704\CE58 \D45C\C2DC\C790\B97C \BC14\AFC9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105223038448309639)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105921559604310200)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105906196065310189)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\AC00 \D45C\C2DC\B418\B294 \B808\C774\C544\C6C3 \C5F4 \C218\B97C \C120\D0DD\D569\B2C8\B2E4. \B3D9\C77C\D55C \D589\C758 \BAA8\B4E0 \AD6C\C131\C694\C18C \AC04\C5D0 \C0AC\C6A9 \AC00\B2A5\D55C \B808\C774\C544\C6C3 \C5F4\C744 \ADE0\D615\C801\C73C\B85C \C870\C815\D558\B824\BA74 [\C790\B3D9]\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
'<dl>',
unistr('  <dt>\C790\B3D9</dt>'),
unistr('    <dd>\CE74\B4DC\C5D0\B294 \CD08\AE30 \B108\BE44\AC00 \C124\C815\B418\BA70 \CE74\B4DC\AC00 \B354 \C774\C0C1 \D3B8\C758\C5D0 \B9DE\C9C0 \C54A\C744 \ACBD\C6B0 \C790\B3D9\C73C\B85C \CE74\B4DC\AC00 \C0C8 \D589\C73C\B85C \C904\BC14\AFC8\B429\B2C8\B2E4.</dd>'),
unistr('  <dt>2, 3, 4, 5\AC1C \C5F4</dt>'),
unistr('    <dd>\C120\D0DD\B41C \D589\B2F9 \C5F4 \C218\C5D0 \B9DE\AC8C \CE74\B4DC\AC00 \C815\B82C\B429\B2C8\B2E4. \BDF0\D3EC\D2B8 \B108\BE44\B97C \AE30\BC18\C73C\B85C \B808\C774\C544\C6C3\C5D0\C11C \C5F4 \C218\AC00 \C904\C5B4\B4E4 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</dd>'),
unistr('  <dt>CSS \BCC0\C218\B97C \C124\C815\D558\C5EC \CE74\B4DC\C758 \B108\BE44\B97C \AD6C\C131\D560 \C218 \C788\C2B5\B2C8\B2E4.</dt>'),
unistr('    <dd>\C608\B97C \B4E4\C5B4, \CE74\B4DC \B108\BE44\AC00 320px\B85C \C124\C815\B418\B3C4\B85D \B2E4\C74C \C870\AC01\C744 \CD94\AC00\D569\B2C8\B2E4. <pre>:root {'),
'  --a-cv-item-width: 320px;',
'}</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105906249577310189)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('2\AC1C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105906338887310189)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.3.D'
,p_message_language=>'ko'
,p_message_text=>unistr('3\AC1C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105906468783310189)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.4.D'
,p_message_language=>'ko'
,p_message_text=>unistr('4\AC1C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105906544666310189)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.5.D'
,p_message_language=>'ko'
,p_message_text=>unistr('5\AC1C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105906026792310189)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B9AC\B4DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106116678116310380)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C601\C5ED\C744 \D3EC\D568\D558\B294 \B808\C774\C544\C6C3 \C5F4\C5D0 \C801\C6A9\D560 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \C5EC\B7EC \D074\B798\C2A4\B97C \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\C774 \C18D\C131\C744 \C0AC\C6A9\D558\BA74 \BDF0\D3EC\D2B8 \D06C\AE30\AC00 \BCC0\ACBD\B420 \B54C \C601\C5ED \B808\C774\C544\C6C3 \C5F4\C758 \C751\B2F5\C131\ACFC \B808\C774\C544\C6C3\C744 \C138\BD80\C801\C73C\B85C \C81C\C5B4\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('        \BC94\C6A9 \D14C\B9C8 \C560\D50C\B9AC\CF00\C774\C158\C758 \ACBD\C6B0 \D398\C774\C9C0 \AD6C\C131\C694\C18C\B97C \D655\C7A5\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\B294 \B9CE\C740 CSS \C218\C815\C790\AC00 \C788\C2B5\B2C8\B2E4. \C790\C138\D55C \B0B4\C6A9\C740 \BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158\C758 \CC38\C870 \C139\C158\C744 \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106116512616310380)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106022127680310292)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105595437965309938)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105595707555309938)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105222795797309638)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\AC00 \D45C\C2DC\B418\B294 \B808\C774\C544\C6C3 \C5F4 \C218\B97C \C120\D0DD\D569\B2C8\B2E4. \B3D9\C77C \B808\C774\C544\C6C3 \D589\C758 \BAA8\B4E0 \AD6C\C131\C694\C18C \AC04\C5D0 \C0AC\C6A9 \AC00\B2A5\D55C \B808\C774\C544\C6C3 \C5F4\C744 \ADE0\D615\C801\C73C\B85C \C870\C815\D558\B824\BA74 <strong>\C790\B3D9</strong>\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105222628262309638)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \D655\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106113530429310377)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106113421049310377)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14\C774 \C788\B294 \B808\C774\C544\C6C3 \C5F4 \C218\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106113314853310377)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \C5F4 \D655\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105222543175309638)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\AC00 \B2E4\C74C \C5F4\C5D0 \D45C\C2DC\B418\B294\C9C0 \B610\B294 \C774\C804 \AD6C\C131\C694\C18C\C640 \B3D9\C77C\D55C \C5F4\C5D0 \D45C\C2DC\B418\B294\C9C0\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105222488326309638)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105221906421309638)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\AC00 \C0C8 \B808\C774\C544\C6C3\C5D0 \D45C\C2DC\B418\AC70\B098 \C774\C804 \AD6C\C131\C694\C18C\C640 \B3D9\C77C\D55C \B808\C774\C544\C6C3\C5D0 \D45C\C2DC\B418\B294\C9C0 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105221868537309638)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \B808\C774\C544\C6C3 \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105222124493309638)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\AC00 \C774\C804 \AD6C\C131\C694\C18C \B4A4\C5D0 \C788\B294 \B2E4\C74C \D589\C5D0 \D45C\C2DC\B418\B294\C9C0 \B610\B294 \B3D9\C77C\D55C \D589\C5D0 \D45C\C2DC\B418\B294\C9C0\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105222064566309638)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \D589 \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105880249163310169)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C601\C5ED\C744 \D3EC\D568\D558\B294 \B808\C774\C544\C6C3 \D589\C5D0 \C801\C6A9\D560 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \C5EC\B7EC \D074\B798\C2A4\B97C \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\C774 \C18D\C131\C744 \C0AC\C6A9\D558\BA74 \BDF0\D3EC\D2B8 \D06C\AE30\AC00 \BCC0\ACBD\B420 \B54C \C601\C5ED \B808\C774\C544\C6C3 \D589\C758 \C751\B2F5\C131\ACFC \B808\C774\C544\C6C3\C744 \C138\BD80\C801\C73C\B85C \C81C\C5B4\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('        \BC94\C6A9 \D14C\B9C8 \C560\D50C\B9AC\CF00\C774\C158\C758 \ACBD\C6B0 \D398\C774\C9C0 \AD6C\C131\C694\C18C\B97C \D655\C7A5\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\B294 \B9CE\C740 CSS \C218\C815\C790\AC00 \C788\C2B5\B2C8\B2E4. \C790\C138\D55C \B0B4\C6A9\C740 \BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158\C758 \CC38\C870 \C139\C158\C744 \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105880146607310169)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105222950387309639)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\AC00 \D45C\C2DC\B418\B294 HTML \D14C\C774\BE14 \B0B4\C758 \C5F4 \C218\B97C \C785\B825\D569\B2C8\B2E4. \AD6C\C131\C694\C18C\B294 HTML \D14C\C774\BE14\C5D0 \BC30\CE58\B429\B2C8\B2E4. \C774 \C18D\C131\C740 \C774 \AD6C\C131\C694\C18C\C758 \D14C\C774\BE14 \C140\C5D0\C11C <em>ROWSPAN</em> \C18D\C131\C5D0 \B300\D574 \C0AC\C6A9\D560 \AC12\C744 \ACB0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105222803257309639)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \D655\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105499406706309860)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \BC94\B840\C758 \ACC4\C5F4 \C774\B984\C5D0\C11C \AD6C\CCB4\C801\C778 \C9E7\C740 \C0AC\C6A9\C790\C815\C758 \B3C4\AD6C \C124\BA85\C744 \C815\C758\D560 \B54C \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \C0C1\C790 \ADF8\B9BC \CC28\D2B8\C758 \ACBD\C6B0 \C120\D0DD\B41C \AC12 \C5F4 \B9E4\D551\ACFC \C5F4\C774 \C77C\CE58\D558\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4. \AC12 \C5F4 \B9E4\D551\ACFC \C77C\CE58\D558\B294 \C5F4\C744 \C120\D0DD\D558\BA74 \CC28\D2B8\C5D0\C11C \BC94\B840 \B3C4\AD6C \C124\BA85\C774 \B80C\B354\B9C1\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105499307313309860)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\B840 \B3C4\AD6C \C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105499641270309860)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 x\CD95 \B808\C774\BE14\C5D0\C11C \AD6C\CCB4\C801\C778 \C9E7\C740 \C0AC\C6A9\C790\C815\C758 \B3C4\AD6C \C124\BA85\C744 \C815\C758\D560 \B54C \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \C0C1\C790 \ADF8\B9BC \CC28\D2B8\C758 \ACBD\C6B0 \C120\D0DD\B41C \AC12 \C5F4 \B9E4\D551\ACFC \C5F4\C774 \C77C\CE58\D558\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4. \AC12 \C5F4 \B9E4\D551\ACFC \C77C\CE58\D558\B294 \C5F4\C744 \C120\D0DD\D558\BA74 \CC28\D2B8\C5D0\C11C \B808\C774\BE14 \B3C4\AD6C \C124\BA85\C774 \B80C\B354\B9C1\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105499578930309860)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \B3C4\AD6C \C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105574182846309921)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \C815\C758\AC00 SQL \C9C8\C758\C5D0\C11C \D30C\C0DD\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C774\B807\AC8C \D558\B824\BA74 &PRODUCT_NAME.\C774(\AC00) \C9C8\C758\B97C \AD6C\BB38\BD84\C11D\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C544\C9C1 \C9C8\C758\B97C \AD6C\BB38\BD84\C11D\D558\C9C0 \C54A\C73C\B824\BA74 \C704\CE58 \D45C\C2DC\C790 \C5F4 \C815\C758\B97C \C0DD\C131\D558\B294 \C77C\BC18 \C5F4 \C774\B984\C744 \C0AC\C6A9\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105574074660309921)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C5F4 \C774\B984 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105308932810309703)
,p_name=>'PE.PROPERTY.HEADER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<code>#BODY#</code> \CF58\D150\CE20 \C774\C804\C5D0 \C601\C5ED \C704\C5D0 \D45C\C2DC\B418\B294 HTML \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105218247168309635)
,p_name=>'PE.PROPERTY.HEADER_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BA38\B9AC\AE00 \BC14\B85C \B4A4\C640 \BCF8\BB38 \B0B4\C6A9 \C55E\C5D0 \D45C\C2DC\D560 \D14D\C2A4\D2B8 \B610\B294 HTML\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105218170007309635)
,p_name=>'PE.PROPERTY.HEADER_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105581509612309927)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C758 \BA38\B9AC\AE00 \C815\C758 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105760244240310078)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105760331130310078)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \C81C\BAA9\C744 \C785\B825\D560 \C218 \C788\AC8C \D569\B2C8\B2E4. \C81C\BAA9\C740 \CC98\C74C\C5D0 \C5F4 \C774\B984\C758 \C9C8\C758\B97C \AE30\C900\C73C\B85C \AE30\BCF8\C801\C73C\B85C \C124\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105760418022310078)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105760530018310078)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF5C\B860\C73C\B85C \AD6C\BD84\B41C \C774\B984 \BAA9\B85D\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218\B97C \AE30\C900\C73C\B85C \C81C\BAA9\C744 \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105760656576310078)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105760744928310078)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C81C\BAA9 \C5C6\C774 \BCF4\ACE0\C11C\AC00 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105759894610310078)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105759909678310078)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984\C758 \C9C8\C758\B97C \AE30\C900\C73C\B85C \C81C\BAA9\C744 \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105760057834310078)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.D'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('\C5F4 \C774\B984(INITCAP)')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105760120169310078)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984\C758 \C9C8\C758\B97C \AE30\C900\C73C\B85C \CD08\AE30 \B300\BB38\C790\D654\B85C \BCC0\D658\B41C \C81C\BAA9\C744 \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105581416996309927)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105542193410309896)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \B9DE\CDA4\C744 \C120\D0DD\D569\B2C8\B2E4. \C120\D0DD\D55C \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C5D0\C11C \C9C0\C6D0\D558\B294 \B9DE\CDA4\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105746000429310067)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C6B4\B370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105745950522310067)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105746165683310067)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B05D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105542005109309896)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105760865358310079)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>DEPT \D14C\C774\BE14\C744 \AE30\C900\C73C\B85C \BCF4\ACE0\C11C\C5D0 \B300\D55C \C81C\BAA9\C744 \C81C\ACF5\D569\B2C8\B2E4.</dt>'),
'<dd><pre>return ''Deptno:DName:Loc'';</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105581794900309927)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF5C\B860\C73C\B85C \AD6C\BD84\B41C \C5F4 \BA38\B9AC\AE00\C758 \BB38\C790\C5F4\C744 \BC18\D658\D558\AE30 \C704\D55C PL/SQL \D568\C218\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105581634729309927)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105453443245309822)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0 \B300\D55C \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \C785\B825\B41C \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B294 \C791\C5C5 \BA54\B274 \B3C4\C6C0\B9D0 \C544\B798\C5D0 \AE30\BCF8 \B3C4\C6C0\B9D0 \B0B4\C6A9\ACFC \D568\AED8 \D45C\C2DC\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105454388543309823)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C5D0 \B300\D55C \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105596458578309939)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C5D0 \B300\D55C \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B294 \D544\B4DC \B808\BCA8\C758 \BB38\B9E5\C5D0 \B530\B978 \B3C4\C6C0\B9D0\C744 \C81C\ACF5\D558\B294 \B370 \C0AC\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105221014910309637)
,p_name=>'PE.PROPERTY.HELP_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D604\C7AC \D398\C774\C9C0\C5D0 \B300\D55C \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B97C \C785\B825\D558\B824\BA74 \C774 \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4. \D398\C774\C9C0 \B808\BCA8 \B3C4\C6C0\B9D0\C740 \B2E4\C74C \AD6C\BB38\C744 \C0AC\C6A9\D55C \BC14\B85C\AC00\AE30\B97C \C9C0\C6D0\D569\B2C8\B2E4.</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>\D398\C774\C9C0 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B294 \AE30\BCF8\C801\C73C\B85C \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \D558\C9C0\B9CC \C774 \D14D\C2A4\D2B8\B97C \D45C\C2DC\D558\B294 \B3C4\C6C0\B9D0 \C2DC\C2A4\D15C\C744 \C27D\AC8C \AC1C\BC1C\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105220982226309637)
,p_name=>'PE.PROPERTY.HELP_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105475428684309840)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D604\C7AC \D398\C774\C9C0\C5D0 \B300\D55C \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B97C \C785\B825\D558\B824\BA74 \C774 \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4. \D398\C774\C9C0 \B808\BCA8 \B3C4\C6C0\B9D0\C740 \B2E4\C74C \AD6C\BB38\C744 \C0AC\C6A9\D55C \BC14\B85C\AC00\AE30\B97C \C9C0\C6D0\D569\B2C8\B2E4.</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>\D398\C774\C9C0 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B294 \AE30\BCF8\C801\C73C\B85C \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \D558\C9C0\B9CC \C774 \D14D\C2A4\D2B8\B97C \D45C\C2DC\D558\B294 \B3C4\C6C0\B9D0 \C2DC\C2A4\D15C\C744 \C27D\AC8C \AC1C\BC1C\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105475366126309840)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105257669171309664)
,p_name=>'PE.PROPERTY.HIDDEN_PARENT_REGION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105882758249310171)
,p_name=>'PE.PROPERTY.HIDDEN_REGION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105495332912309856)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\BC94\B840 \D56D\BAA9\C744 \B204\B97C \B54C \C218\D589\B418\B294 \C228\AE30\AE30 \BC0F \D45C\C2DC \B3D9\C791\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('        \C608\B97C \B4E4\C5B4, \BC94\B840 \D56D\BAA9\C744 \C120\D0DD \D574\C81C\D558\BA74 \CC28\D2B8\C5D0\C11C \C5F0\AD00\B41C \B370\C774\D130 \ACC4\C5F4\C774 \C228\ACA8\C9D1\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105495490692309856)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105619054913309957)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr(' \CC28\D2B8\C5D0\C11C \C228\AE30\AE30 \BC0F \D45C\C2DC \B3D9\C791\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105495694836309856)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\C728 \C870\C815 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105619280555309957)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr(' \CC28\D2B8 \CD95 \BC30\C728\C774 \C870\C815\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \C774 \AE30\B2A5\C740 \C0AC\C6A9\C790\B97C \CEE8\D14D\C2A4\D2B8\C5D0 \C720\C9C0\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105495575490309856)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\C728 \C870\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105619120623309957)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr(' \D45C\C2DC \AC00\B2A5\D55C \B370\C774\D130\C758 \CD5C\C18C\AC12\ACFC \CD5C\B300\AC12\C774 \C99D\AC00\D558\AC70\B098 \AC10\C18C\D568\C5D0 \B530\B77C \CC28\D2B8 \CD95 \BC30\C728\C774 \C870\C815\B429\B2C8\B2E4. \C774 \AE30\B2A5\C740 \D06C\AC8C \BCC0\B3D9\D558\B294 \AC12\C774 \C788\B294 \ACC4\C5F4\C5D0 \C720\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105495297831309856)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE30\AE30 \BC0F \D45C\C2DC \B3D9\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105576224089309923)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\BCF4\ACE0\C11C \C5F4\C5D0\C11C \AC15\C870 \D45C\C2DC\D560 \D14D\C2A4\D2B8 \BB38\C790\C5F4\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C5EC\B7EC \B2E8\C5B4\AC00 \AC15\C870 \D45C\C2DC\B41C \ACBD\C6B0, \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \C0AC\C6A9\D569\B2C8\B2E4.'),
unistr('\B610\D55C <code>&amp;ITEM.</code> \AD6C\BB38\C744 \C0AC\C6A9\D574\C11C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \CC38\C870\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, \AC80\C0C9 \D544\B4DC\C5D0 \C785\B825\B41C \BB38\C790\C5F4\C744 \AC15\C870 \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105576109962309923)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C5B4 \AC15\C870 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105360545914309743)
,p_name=>'PE.PROPERTY.HOME_URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\C758 \C560\D50C\B9AC\CF00\C774\C158 \D648 \D398\C774\C9C0\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105360473888309743)
,p_name=>'PE.PROPERTY.HOME_URL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105238991652309650)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C9C0\C815\B41C \D15C\D50C\B9AC\D2B8 \C704\CE58 \B0B4\C5D0\C11C \C774 \B2E8\CD94\C5D0 \B300\D55C \AC00\B85C \B9DE\CDA4\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105737130903310061)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105737230736310061)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105238803488309650)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\B85C \B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105748023489310069)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\BC30\ACBD \BC0F \D14D\C2A4\D2B8 \C0C9 \BCC0\ACBD</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">#EMPLOYEE_STATUS#&lt;/span></pre></dd>',
unistr('  <dt>\C81C\BAA9 2 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;h2>#EMPLOYEE_NAME#&lt;/h2></pre></dd>',
unistr('  <dt>SQL \C9C8\C758\C5D0\C11C \B3D9\C801 \D074\B798\C2A4 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;span class="#COLUMN_CLASS#">#EMPLOYEE_STATUS#&lt;/span></pre><br>',
unistr('    \C774 \C608\C5D0\C11C <code>#COLUMN_CLASS#</code> \BC0F <code>#EMPLOYEE_STATUS#</code> \B300\CCB4\B294 \BCF4\ACE0\C11C SQL \C9C8\C758\C5D0\C11C \C120\D0DD\D55C \C5F4\C785\B2C8\B2E4.</dd>'),
unistr('  <dt>\C774\BBF8\C9C0 \D45C\C2DC \BC0F \CEE4\C11C\B97C \C704\B85C \AC00\C838\AC08 \B54C \B3C4\AD6C \C124\BA85 \D45C\C2DC</dt>'),
'    <dd><pre>&lt;img src="#IMAGE_NAME#" title="#EMPLOYEE_NAME#"&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105544760239309898)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C5D0 \D45C\C2DC\D560 HTML \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4. <code>#COLUMN#</code> \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC HTML\C5D0 \C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105544601749309898)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105217834563309635)
,p_name=>'PE.PROPERTY.HTML_HEADER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8 \BA38\B9AC\AE00\C5D0\C11C <code>#HEAD#</code> \B300\CCB4 \BB38\C790\C5F4\C744 \BC14\AFC0 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\C5EC\AE30\C5D0 \C785\B825\D55C \AC12\C740 HTML <code>&lt;head&gt;</code> \D0DC\ADF8 \B2E4\C74C\C5D0 \C0BD\C785\B429\B2C8\B2E4. \C774 \D398\C774\C9C0 \C18D\C131\C744 \C0AC\C6A9\D574\C11C \D398\C774\C9C0 \D2B9\C815 \BA54\D0C0 \D0DC\ADF8\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'</p>',
unistr('<p>\CC38\ACE0: JavaScript \CF54\B4DC \B610\B294 \C885\C18D\D615 \C2DC\D2B8\B294 \C804\C6A9 JavaScript \BC0F CSS \C18D\C131\C5D0 \CD94\AC00\D574\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105217727250309635)
,p_name=>'PE.PROPERTY.HTML_HEADER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105911664739310193)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C774\BBF8\C9C0 \C18C\C2A4\C5D0 \B300\D574 BLOB\C744 \BC18\D658\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105911542804310193)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105911488470310193)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C774\BBF8\C9C0 \C18C\C2A4\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105911315810310193)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105260180284309666)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D328\C2EF\C744 \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\D560 \C544\C774\CF58\C5D0 \B300\D55C \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('            <p>\D14C\B9C8\C5D0\C11C \AE00\AF34 APEX\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>\C744 \AC80\D1A0\D558\C5EC \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58\ACFC \C218\C815\C790\B97C \D655\C778\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105260272469309666)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D328\C2EF\C744 \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\D560 \C544\C774\CF58\C5D0 \B300\D55C \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('            <p>\D14C\B9C8\C5D0\C11C \AE00\AF34 APEX\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>\C744 \AC80\D1A0\D558\C5EC \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58\ACFC \C218\C815\C790\B97C \D655\C778\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105260379287309666)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D328\C2EF\C744 \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\D560 \C544\C774\CF58\C5D0 \B300\D55C \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('            <p>\D14C\B9C8\C5D0\C11C \AE00\AF34 APEX\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>\C744 \AC80\D1A0\D558\C5EC \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58\ACFC \C218\C815\C790\B97C \D655\C778\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106039033202310308)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \C544\C774\CF58\C5D0 \B300\D55C \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\D14C\B9C8\C5D0\C11C \AE00\AF34 APEX\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>\C744 \AC80\D1A0\D558\C5EC \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58\ACFC \C218\C815\C790\B97C \D655\C778\D558\C2ED\C2DC\C624.</p>'),
unistr('        <p>\CC38\ACE0: \C774 \C544\C774\CF58\C740 \D56D\BAA9\C758 \B0B4\BD80\C5D0 \D45C\C2DC\B418\BA70 \B808\C774\BE14\C758 \C77C\BD80\AC00 \C544\B2D9\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106038938740310308)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \C544\C774\CF58\C5D0 \B300\D55C \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\D14C\B9C8\C5D0\C11C \AE00\AF34 APEX\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>\C744 \AC80\D1A0\D558\C5EC \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58\ACFC \C218\C815\C790\B97C \D655\C778\D558\C2ED\C2DC\C624.</p>'),
unistr('        <p>\CC38\ACE0: \C774 \C544\C774\CF58\C740 \D56D\BAA9\C758 \B0B4\BD80\C5D0 \D45C\C2DC\B418\BA70 \B808\C774\BE14\C758 \C77C\BD80\AC00 \C544\B2D9\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105260507162309666)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D544\D130\B97C \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\D560 \C544\C774\CF58\C5D0 \B300\D55C \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('            <p>\D14C\B9C8\C5D0\C11C \AE00\AF34 APEX\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>\C744 \AC80\D1A0\D558\C5EC \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58\ACFC \C218\C815\C790\B97C \D655\C778\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105261449757309667)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D544\D130\B97C \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\D560 \C544\C774\CF58\C5D0 \B300\D55C \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('            <p>\D14C\B9C8\C5D0\C11C \AE00\AF34 APEX\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>\C744 \AC80\D1A0\D558\C5EC \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58\ACFC \C218\C815\C790\B97C \D655\C778\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105261883194309667)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D544\D130\B97C \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\D560 \C544\C774\CF58\C5D0 \B300\D55C \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('            <p>\D14C\B9C8\C5D0\C11C \AE00\AF34 APEX\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>\C744 \AC80\D1A0\D558\C5EC \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58\ACFC \C218\C815\C790\B97C \D655\C778\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105898176127310183)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C624\B978\CABD\C744 \AC00\B9AC\D0A4\B294 \D654\C0B4\D45C \D45C\C2DC</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105898090337310183)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \C544\C774\CF58\C5D0 \B300\D55C \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\D14C\B9C8\C5D0\C11C \AE00\AF34 APEX\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>\C744 \AC80\D1A0\D558\C5EC \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58\ACFC \C218\C815\C790\B97C \D655\C778\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105897907660310183)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105913135755310194)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D14D\C2A4\D2B8\B294 \C544\C774\CF58\C744 \C124\BA85\D558\BA70 \C774\BBF8\C9C0\C5D0 \B300\D55C \B3C4\AD6C \C124\BA85 \BC0F \B300\CCB4 \D14D\C2A4\D2B8\C5D0 \C0AC\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105913040260310194)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105911862448310193)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C774\BBF8\C9C0 \C18C\C2A4\C5D0 \B300\D55C URL\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105911767760310193)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105912331741310194)
,p_name=>'PE.PROPERTY.ICON_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC \BA38\B9AC\AE00\C5D0\C11C \C544\C774\CF58\C758 \C704\CE58\B97C \ACB0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105912852046310194)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B05D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105912952306310194)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00\C758 \B05D \C704\CE58(\C77C\BC18\C801\C73C\B85C \C624\B978\CABD)\C5D0 \C544\C774\CF58\C744 \B9DE\CDA5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105912696849310194)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105912790453310194)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00\C758 \C2DC\C791 \C704\CE58(\C77C\BC18\C801\C73C\B85C \C67C\CABD)\C5D0 \C544\C774\CF58\C744 \B9DE\CDA5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105912465592310194)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105912521980310194)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \C0C1\B2E8\C5D0 \C544\C774\CF58\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105912201904310193)
,p_name=>'PE.PROPERTY.ICON_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105921671205310200)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105910777160310192)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC \AD6C\C131\C694\C18C\C758 \BA38\B9AC\AE00\C5D0 \D45C\C2DC\B418\B294 \C544\C774\CF58\C758 \C544\C774\CF58 \C18C\C2A4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105911260191310193)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 BLOB \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105911075072310193)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \D074\B798\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105910836705310192)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.INITIALS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B2C8\C15C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105910985768310193)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105911125005310193)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105910614972310192)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105442309018309812)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="&APEX$ROW_URL!ATTR."&gt;&lt;img src="&EMP_IMG!ATTR." title="&ENAME!ATTR." alt="&ENAME!ATTR."&gt;&lt;br&gt;&ENAME.&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105442274102309812)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('</p>\C544\C774\CF58 \BCF4\AE30\C5D0 \B300\D55C \C0AC\C6A9\C790\C815\C758 \C5F4 HTML\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C\ACFC \AC19\C740 \B300\CCB4 \BB38\C790\C5F4\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - \C5F4 \C774\B984\C5D0 \B300\D55C \B300\CCB4 \BB38\C790\C5F4</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - \C5F4 \B808\C774\BE14\C5D0 \B300\D55C \B300\CCB4 \BB38\C790\C5F4</li>'),
unistr('<li><code>&APEX$ROW_ID.</code> - \D589\C5D0 \B300\D55C \B808\CF54\B4DC \C2DD\BCC4\C790</li>'),
unistr('<li><code>&APEX$ROW_INDEX.</code> - \B808\CF54\B4DC \D45C\C2DC \C2DC\D000\C2A4 \BC88\D638</li>'),
unistr('<li><code>&APEX$ROW_URL.</code> - \C9C0\C815\B41C \B9C1\D06C \B300\C0C1 \CC38\C870</li>'),
unistr('<li><code>&APEX$ROW_STATE_CLASSES.</code> - \B808\CF54\B4DC \C0C1\D0DC(\C608: <code>is-inserted</code> \B610\B294 <code>is-deleted</code>)</li>'),
'</ul>',
'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105442138489309812)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C544\C774\CF58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105751498187310071)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="#EMP_LINK#"&gt;&lt;img src="#EMP_IMG#" title="#ENAME#" alt="#ENAME#"&gt;&lt;br&gt;#ENAME#&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105553250299309905)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \BCF4\AE30\C5D0 \B300\D55C \C5F4 \B9C1\D06C\B97C \C785\B825\D569\B2C8\B2E4. \D544\C694\C5D0 \B530\B77C \C5F4 \C774\B984\C5D0 \B300\D574 <code>#COLUMN_NAME#</code> \B300\CCB4 \BB38\C790\C5F4\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105553108775309905)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105453204081309822)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \BCF4\AE30\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <strong>\C124\C815</strong>\C744 \C120\D0DD\D558\BA74 \C544\C774\CF58 \BCF4\AE30 \C544\C774\CF58\C774 \B300\D654\C2DD \BCF4\ACE0\C11C\C758 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C \B610\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC \BDF0 \B2E8\CD94\C5D0 \CD94\AC00\B418\ACE0, \C0AC\C6A9\C790\AC00 \D574\B2F9 \C544\C774\CF58\C744 \D1B5\D574 \C774 \BDF0\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105551618605309904)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \BCF4\AE30\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <strong>\C124\C815</strong>\C744 \C120\D0DD\D558\BA74 \C544\C774\CF58 \BCF4\AE30 \C544\C774\CF58\C774 \B300\D654\C2DD \BCF4\ACE0\C11C\C758 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C \B610\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC \BDF0 \B2E8\CD94\C5D0 \CD94\AC00\B418\ACE0, \C0AC\C6A9\C790\AC00 \D574\B2F9 \C544\C774\CF58\C744 \D1B5\D574 \C774 \BDF0\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105551566466309903)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105552861408309904)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0\C758 HTML ALT \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105552771984309904)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \B300\CCB4 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105553096377309905)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0\C758 HTML TITLE \D0DC\ADF8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105552968209309905)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \C81C\BAA9 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105443539867309814)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML IMG \D0DC\ADF8\C5D0 \C0AC\C6A9\B418\B294 \C544\C774\CF58 \C774\BBF8\C9C0 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105443471813309813)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105442949520309813)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C774\BBF8\C9C0 \C18C\C2A4\C5D0 \B300\D574 BLOB\C744 \BC18\D658\D558\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105442860378309813)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105443364068309813)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C774\BBF8\C9C0 \C18C\C2A4\C5D0 \B300\D574 CSS \D074\B798\C2A4\B97C \BC18\D658\D558\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105443286043309813)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105442547834309813)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C774\BBF8\C9C0 \C18C\C2A4\B97C \D3EC\D568\D558\B294 \C5F4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105442732232309813)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.CSS_CLASSES.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105442611921309813)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.URL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('URL\C758 \C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105442497238309813)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105443130341309813)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C774\BBF8\C9C0 \C18C\C2A4\C5D0 \B300\D574 URL\C744 \BC18\D658\D558\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105443011077309813)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105552628486309904)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML IMG \D0DC\ADF8\C5D0 \C0AC\C6A9\B418\B294 \C774\BBF8\C9C0 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105552594329309904)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105751275373310071)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt><code>IMAGE</code> \C5F4 \AC80\C0AC</dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105552212283309904)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \C18C\C2A4\B97C \BC18\D658\D558\B294 \BCF4\ACE0\C11C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105552138219309904)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \C18C\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105751318075310071)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt><code>ENAME</code> \C5F4 \AC80\C0AC</dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105552403754309904)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \B808\C774\BE14\C744 \BC18\D658\D558\B294 \BCF4\ACE0\C11C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105552340161309904)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105425668590309798)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt><code>ENAME</code> \C5F4\C744 \AC80\C0AC\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'select empno,',
'       ename,',
'       job,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105425574702309798)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \B808\C774\BE14\C744 \BC18\D658\D558\B294 \BCF4\ACE0\C11C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105425415089309798)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105443978286309814)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01 <strong>\B9C1\D06C \B300\C0C1</strong> \D45C\C2DC\C640 \C5F0\AD00\B41C HTML \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105443858790309814)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105751149015310071)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt><code>LINK</code> \C5F4 \AC80\C0AC</dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105552007945309904)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58\C758 \B9C1\D06C \B300\C0C1\C744 \BC18\D658\D558\B294 \BCF4\ACE0\C11C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105551945902309904)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105979162545310251)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105979430050310251)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105979334771310251)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105979226985310251)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105979589105310251)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105979063831310251)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105980355388310252)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B0\AE30 \C704\D574 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>SQL \C9C8\C758\B294 \D558\B098\C758 \C5F4\B9CC \BC18\D658\D574\C57C \D569\B2C8\B2E4. \C9C8\C758\AC00 \C5EC\B7EC \C5F4\C744 \BC18\D658\D558\B294 \ACBD\C6B0 \CCAB\BC88\C9F8 \C5F4\B9CC \D544\D130 \AC80\C0C9\C5D0\C11C \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105980242727310252)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105980120891310252)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\BD80\C11C \C774\B984 \D45C\C2DC \BC0F \BD80\C11C \BC88\D638 \C124\C815</dt>'),
'<dd><pre>',
'return "select dname as d from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105980025492310252)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B0\AE30 \C704\D574 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>SQL \C9C8\C758\B294 \D558\B098\C758 \C5F4\B9CC \BC18\D658\D574\C57C \D569\B2C8\B2E4. \C9C8\C758\AC00 \C5EC\B7EC \C5F4\C744 \BC18\D658\D558\B294 \ACBD\C6B0 \CCAB\BC88\C9F8 \C5F4\B9CC \D544\D130 \AC80\C0C9\C5D0\C11C \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105979921575310252)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105979818110310252)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\BD80\C11C \C774\B984\C744 \BC18\D658\D558\B824\BA74 \B2E4\C74C\ACFC \AC19\C774 \D558\C2ED\C2DC\C624.</dt>'),
'<dd><pre>',
'begin',
'    return ''select dname as d from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105979711275310251)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B0\AE30 \C704\D574 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>SQL \C9C8\C758\B294 \D558\B098\C758 \C5F4\B9CC \BC18\D658\D574\C57C \D569\B2C8\B2E4. \C9C8\C758\AC00 \C5EC\B7EC \C5F4\C744 \BC18\D658\D558\B294 \ACBD\C6B0 \CCAB\BC88\C9F8 \C5F4\B9CC \D544\D130 \AC80\C0C9\C5D0\C11C \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105979676192310251)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105980579572310252)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B0\AE30 \C704\D574 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>SQL \C9C8\C758\B294 \D558\B098\C758 \C5F4\B9CC \BC18\D658\D574\C57C \D569\B2C8\B2E4. \C9C8\C758\AC00 \C5EC\B7EC \C5F4\C744 \BC18\D658\D558\B294 \ACBD\C6B0 \CCAB\BC88\C9F8 \C5F4\B9CC \D544\D130 \AC80\C0C9\C5D0\C11C \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105980432462310252)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105448819516309818)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>'<pre>Cow,Dog,Cat,Lion</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105448750422309818)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C815\C801 \BAA9\B85D\C5D0 \B300\D574 \CF64\B9C8\B85C \AD6C\BD84\B41C \AC12 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \C815\C801 \AC12\C740 \C54C\D30C\BCB3 \C21C\C11C\AC00 \C544\B2CC \AC12\C774 \C9C0\C815\B41C \B3D9\C77C\D55C \C21C\C11C\B85C \D56D\C0C1 \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105448600611309818)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105444587321309814)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \C5F4\C5D0 \B300\D55C \ADF8\B8F9\C744 \C120\D0DD\D569\B2C8\B2E4. \ADF8\B8F9\C740 \ADF8\B9AC\B4DC \BC0F \B2E8\C77C \D589 \BCF4\AE30\C758 \C5F4\C744 \D568\AED8 \C5F0\AD00\C2DC\D0A4\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \ADF8\B8F9\C744 \CD94\AC00\D558\B824\BA74 \B80C\B354\B9C1 \D2B8\B9AC \B0B4\C758 \C18D\C131 \D3F4\B354\B97C \D655\C7A5\D558\ACE0 \C5F4 \ADF8\B8F9\C744 \B9C8\C6B0\C2A4 \C624\B978\CABD \B2E8\CD94\B85C \B20C\B7EC \C0C8 \ADF8\B8F9\C744 \C0DD\C131\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105444491448309814)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105449054703309818)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4 \AC12\C758 \AE30\C900\C73C\B85C \C0AC\C6A9\B418\B294 \C18C\C2A4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105449164782309818)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105449220587309818)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\B370\C774\D130\BCA0\C774\C2A4 \C5F4</em>\C5D0 \C785\B825\B41C \C5F4 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4. \C774 \AC12\C740 \C601\C5ED \C18C\C2A4 SQL \C9C8\C758\C5D0\C11C \AC80\C0C9\B41C \AC12\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105449577855309819)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105449652742309819)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AC12\C774 \BAA8\B4E0 \C18C\C2A4\C5D0\C11C \AC80\C0C9\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \C608\B97C \B4E4\C5B4, APEX$ROW_SELECTOR \BC0F APEX$ROW_ACTION \C5F4\C5D0\B294 \C18C\C2A4\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105449331533309819)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105449419231309819)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>SQL \D45C\D604\C2DD</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105448951394309818)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105441636975309812)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C0AC\C6A9\C790\AC00 \D604\C7AC \D45C\C2DC\B41C \C5F4\C744 \B2E4\C6B4\B85C\B4DC\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\B294 \B2E4\C6B4\B85C\B4DC \D615\C2DD\C744 \D655\C778\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105441706463309812)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'ko'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105441878435309812)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'ko'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105599892530309941)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'ko'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104885185401309385)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'ko'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105441550563309812)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105443738531309814)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B2EC \B300\D654\C0C1\C790\B97C \D638\CD9C\D558\B824\B294 \B9C1\D06C \B300\C0C1\C744 \B204\B985\B2C8\B2E4. \C544\C774\CF58\C744 \B204\B97C \B54C \D638\CD9C\D560 \C0AC\C6A9\C790\C815\C758 \B300\C0C1\C744 \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105443628021309814)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105439816603309810)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \BCF4\ACE0\C11C\C758 \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4. \C77C\BD80 \BCF4\ACE0\C11C \D589\C740 \C601\C5ED\C5D0 \D45C\C2DC\B418\C9C0 \C54A\C744 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('		\CD94\AC00 \D589\C744 \D45C\C2DC\D558\AE30 \C704\D574 \C77C\BC18 \C0AC\C6A9\C790\B294 \C81C\ACF5\B41C \D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('		<p>\D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C740 \D45C\C2DC\B418\B294 \D589 \C218 \BC0F \ACB0\ACFC \C9D1\D569 \B0B4\C5D0\C11C \D604\C7AC \C704\CE58\C5D0 \B300\D55C \C815\BCF4\B97C \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \C81C\ACF5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105440042393309811)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105568459857309917)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\CC98\C74C\C5D0\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC\C758 \B192\C774\C5D0 \B9DE\B294 \CDA9\BD84\D55C \C218\C758 \D589\C774 \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('        \C77C\BC18 \C0AC\C6A9\C790\AC00 \C2A4\D06C\B864\D558\BA74 \B354 \B9CE\C740 \D589\C774 \D45C\C2DC\B429\B2C8\B2E4. \D544\C694\D55C \ACBD\C6B0 \C11C\BC84\C5D0\C11C \B354 \B9CE\C740 \B370\C774\D130\B97C \AC00\C838\C635\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105439994200309810)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105568334330309917)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\CCAB\BC88\C9F8 \D589\C774 <em>\D398\C774\C9C0\B2F9 \D589</em>\C5D0 \C9C0\C815\B41C \C22B\C790\B97C \AE30\C900\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('        \CD94\AC00 \D589\C774 \C788\B294 \ACBD\C6B0 \C77C\BC18 \C0AC\C6A9\C790\AC00 \D589 \C9D1\D569 \C0AC\C774\B97C \C55E/\B4A4\B85C \C774\B3D9\D560 \C218 \C788\B294 \CEE8\D2B8\B864\C774 \BCF4\ACE0\C11C \BC14\B2E5\AE00\C5D0 \CD94\AC00\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105439712157309810)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106109998554310374)
,p_name=>'PE.PROPERTY.IG_REGION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105903314657310187)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B41C \C774 \BCF4\ACE0\C11C\C758 \BCC4\CE6D\C744 \C785\B825\D569\B2C8\B2E4. \C774 \BCC4\CE6D\C744 \C0AC\C6A9\D558\BA74 \C800\C7A5\B41C \D2B9\C815 \BCF4\ACE0\C11C\C5D0 \B300\D574 \BCF4\B2E4 \C758\BBF8 \C788\B294 URL \B9C1\D06C\B97C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \B9C1\D06C\B97C \C0AC\C6A9\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C758 \C5B4\B290 \ACF3\C5D0\C11C\B4E0 \C9C1\C811 \C5F0\ACB0\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105902395295310186)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105903436686310187)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C120\D0DD \BAA9\B85D \B0B4\C5D0\C11C \C774 \BCF4\ACE0\C11C\AC00 \D45C\C2DC\B418\B294 \C704\CE58\B97C \B098\D0C0\B0B4\B294 \C800\C7A5\B41C \BCF4\ACE0\C11C \BC94\C8FC\B97C \D655\C778\D569\B2C8\B2E4. \C774 \C18D\C131\C740 \BCF4\AE30 \C804\C6A9\C774\BA70 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105902562037310186)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105903017325310187)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790\AC00 \C800\C7A5\D55C \D6C4\C18D \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C73C\B85C, \C77C\BC18 \C0AC\C6A9\C790\AC00 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105902458970310186)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105902980819310186)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790\AC00 \C800\C7A5\D55C \BCF4\ACE0\C11C\B85C, \AE30\BCF8\C801\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105902744226310186)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105903275063310187)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C800\C7A5\D55C \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C73C\B85C, \D574\B2F9 \B808\C774\C544\C6C3\C744 \C800\C7A5\D55C \C77C\BC18 \C0AC\C6A9\C790\B9CC \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105902634115310186)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105903115428310187)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C800\C7A5\D55C \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C73C\B85C \B2E4\B978 \BAA8\B4E0 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105902277494310186)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105444722359309815)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C744 \D45C\C2DC\D558\AE30 \C704\D574 \ADF8\B8F9\C774 \C5B4\B514\C5D0\C11C \C0AC\C6A9\B418\B294\C9C0 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105444841655309815)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105444973304309815)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9\C774 \BCF4\ACE0\C11C \BA38\B9AC\AE00 \BC0F \B2E8\C77C \D589 \BCF4\AE30\C5D0 \BAA8\B450 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105445212495309815)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105445395263309815)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9\C774 \BCF4\ACE0\C11C \BA38\B9AC\AE00\C5D0\B9CC \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105445062378309815)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C \D589 \BCF4\AE30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105445163101309815)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9\C774 \B2E8\C77C \D589 \BCF4\AE30\C5D0\B9CC \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105444645469309814)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \C6A9\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105308323956309703)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774\BBF8\C9C0 HTML\C5D0 \D3EC\D568\B41C \C774\BBF8\C9C0 \D0DC\ADF8 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4. \B192\C774, \B108\BE44 \B610\B294 \C774\BBF8\C9C0 ALT \D14D\C2A4\D2B8\C640 \AC19\C740 \C18D\C131\C5D0 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4(\C774\BBF8\C9C0\AC00 \C7A5\C2DD\C6A9\C778 \ACBD\C6B0).</p>'),
unistr('<p>\CC38\ACE0: ALT\AC00 \C774\BBF8\C9C0 \D0DC\ADF8 \C18D\C131\C5D0 \C815\C758\B418\C9C0 \C54A\C740 \ACBD\C6B0 &PRODUCT_NAME.\C740(\B294) \AE30\BCF8\C801\C73C\B85C \C774\BBF8\C9C0\B97C \C7A5\C2DD\C6A9 \C774\BBF8\C9C0\B85C \B80C\B354\B9C1\D569\B2C8\B2E4(\C608: \BE48 ALT \D0DC\ADF8 \C0AC\C6A9).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105308289421309703)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \D0DC\ADF8 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105577048022309924)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\B97C CSV\B85C \C775\C2A4\D3EC\D2B8\D558\AC70\B098 \C778\C1C4\D560 \B54C \C774 \C5F4\C774 \D3EC\D568\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105576906979309924)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C775\C2A4\D3EC\D2B8/\C778\C1C4\C5D0 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106088979609310355)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D\C5D0\C11C \BAA9\B85D \B9E8 \C704\C5D0 \B110 \C635\C158\C744 \D3EC\D568\D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106088854221310355)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \C635\C158 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105429426009309801)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C758\C0AC \C5F4 ROWID\B97C \C120\D0DD\D574\C57C \D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105429381847309801)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('ROWID \C5F4 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105546866352309900)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C740 \BCF4\ACE0\C11C \C704\C5D0 \D45C\C2DC\B429\B2C8\B2E4. \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C744 \D3EC\D568\D560 \ACBD\C6B0 \D45C\C2DC\D560 \D568\C218\B97C \C644\C804\D788 \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('\AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C740 \B2E4\C74C\ACFC \AC19\C740 \AD6C\C131\C694\C18C\B97C \D3EC\D568\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'<dl>',
unistr('  <dt>\AC80\C0C9 \D544\B4DC</dt>'),
unistr('    <dd>\AC80\C0C9 \C870\AC74\C744 \C785\B825\D558\B294 \B370 \C0AC\C6A9\B418\B294 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C5D0 \D14D\C2A4\D2B8 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4.</dd>'),
unistr('  <dt>\AC80\C0C9\AE30 \B4DC\B86D\B2E4\C6B4</dt>'),
unistr('    <dd><em>\AC80\C0C9 \D544\B4DC</em> \B0B4\C5D0 \D3EC\D568\B418\C5B4 \D45C\C2DC\B41C \C5F4\C758 \B4DC\B86D\B2E4\C6B4 \BAA9\B85D\C744 \D45C\C2DC\D569\B2C8\B2E4. \C5F4\C774 \C120\D0DD\B418\C5C8\C73C\BA74 \C120\D0DD\D55C \C5F4\C758 \AC12\C5D0 \B300\D574\C11C\B9CC \AC80\C0C9\C774 \C218\D589\B429\B2C8\B2E4.</dd>'),
unistr('  <dt>\BCF4\ACE0\C11C \C120\D0DD \BAA9\B85D</dt>'),
unistr('    <dd>\AE30\BCF8, \B300\CCB4, \ACF5\C6A9 \BC0F \AC1C\C778 \BCF4\ACE0\C11C\B97C \D3EC\D568\D574\C11C \C0AC\C6A9\C790\C5D0\AC8C \C81C\ACF5\B418\B294 \BAA8\B4E0 \BCF4\ACE0\C11C \BAA9\B85D\C744 \D45C\C2DC\D569\B2C8\B2E4. \C774 \BAA9\B85D\C740 \D574\B2F9 \C0AC\C6A9\C790\AC00 \AE30\BCF8 \BCF4\ACE0\C11C \C774\C678\C758 \BCF4\ACE0\C11C\C5D0 \C561\C138\C2A4\D560 \C218 \C788\B294 \ACBD\C6B0\C5D0\B9CC \D45C\C2DC\B429\B2C8\B2E4.</dd>'),
unistr('  <dt>\D398\C774\C9C0\B2F9 \D589 \C120\D0DD\AE30</dt>'),
unistr('    <dd>\D398\C774\C9C0\B2F9 \D45C\C2DC\D560 \D589 \C218\B97C \C120\D0DD\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C120\D0DD \BAA9\B85D\C744 \D45C\C2DC\D569\B2C8\B2E4.</dd>'),
unistr('  <dt>\C791\C5C5 \BA54\B274</dt>'),
unistr('    <dd>\C77C\BC18\C801\C73C\B85C \D3EC\AD04\C801\C778 \C635\C158 \C9D1\D569\C744 \D3EC\D568\D558\B294 \C791\C5C5 \BA54\B274 \B2E8\CD94\B97C \D45C\C2DC\D569\B2C8\B2E4. \C774\B7EC\D55C \C635\C158\C744 \D1B5\D574 \C77C\BC18 \C0AC\C6A9\C790\B294 \C81C\ACF5\B41C \D568\C218\B97C \AE30\BC18\C73C\B85C \BCF4\ACE0\C11C\B97C \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105546745894309900)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \B3C4\AD6C \BAA8\C74C \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105217637309309635)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>&PRODUCT_NAME.\C5D0\B294 \C77C\BC18\C801\C73C\B85C \D2B9\C815 JavaScript \BC0F CSS \D30C\C77C\C774 \D544\C694\D569\B2C8\B2E4.'),
unistr('\BAA8\BC14\C77C \C560\D50C\B9AC\CF00\C774\C158\ACFC \AC19\C740 \C77C\BD80 \C560\D50C\B9AC\CF00\C774\C158\C758 \ACBD\C6B0 \D398\C774\C9C0\C5D0\C11C \C774\B7EC\D55C \D30C\C77C\C774 \D3EC\D568\B418\C9C0 \C54A\B3C4\B85D \D574\C57C \D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\D45C\C900 &PRODUCT_NAME. \BC0F JavaScript \D30C\C77C\C744 \D3EC\D568\D558\B824\BA74 <strong>\C124\C815</strong>\C744 \C120\D0DD\D569\B2C8\B2E4. <strong>\D574\C81C</strong>\B97C \C120\D0DD\D558\BA74 HTML \D5E4\B354\C5D0 \C774\B7EC\D55C \D30C\C77C\C774 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774\B7EC\D55C \D30C\C77C\C744 \D3EC\D568\D558\C9C0 \C54A\B3C4\B85D \C124\C815\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \BD80\C815\C801\C778 \C601\D5A5\C744 \C904 \C218 \C788\C73C\BA70, \C560\D50C\B9AC\CF00\C774\C158\C774 \C911\B2E8\B420 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\B530\B77C\C11C \C774 \C18D\C131\C744 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D558\B294 \AC83\C740 \ACE0\AE09 \AC1C\BC1C\C790\C5D0\AC8C\B9CC \AD8C\C7A5\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105217572490309635)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 JavaScript \BC0F CSS \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105839327323310138)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \B9F5 \C704\CE58\B97C GeoJSON \D3EC\C778\D2B8 \AC1D\CCB4\B85C \D3EC\D568\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105839237733310138)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('GeoJSON \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105839145968310138)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \B9F5 \C704\CE58\B97C \D3EC\C778\D2B8 \AC1D\CCB4\B85C \D3EC\D568\D558\B294 SDO_GEOMETRY \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105839003607310138)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\BA74 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105838360662310137)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \B9F5 \C704\CE58\C5D0 \C0AC\C6A9\D560 \C5F4 \C720\D615\C744 \C2DD\BCC4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105838661574310137)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'ko'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105838778003310137)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('VARCHAR2 \B610\B294 CLOB \C5F4 \C720\D615\C778 GeoJSON\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105838842641310137)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\B3C4/\C704\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105838947645310137)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('NUMBER \C5F4 2\AC1C\B85C \D45C\C2DC\B418\B294 \ACBD\B3C4 \BC0F \C704\B3C4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105838453636310137)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'ko'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105838535253310137)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle SDO_GEOMETRY \C720\D615\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105838219459310137)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\BA74 \C5F4 \B370\C774\D130 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105837229927310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\BE0C\B77C\C6B0\C800\C5D0\C11C \D604\C7AC \C704\CE58\B97C \B9F5 \AC00\C6B4\B370\C5D0 \D45C\C2DC\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4. \C0AC\C6A9\C73C\B85C \C124\C815\B418\ACE0, \BE0C\B77C\C6B0\C800\AC00 \D604\C7AC \C704\CE58\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C73C\BA74 \C704\C5D0 \AD6C\C131\B41C \B300\B85C \C815\C801 \AC12, SQL \C9C8\C758 \B610\B294 \ACF5\AC04 \ACB0\ACFC \AE30\BC18\C73C\B85C \D655\C778\B41C \CD08\AE30 \C704\CE58\BCF4\B2E4 \C6B0\C120 \C801\C6A9\B429\B2C8\B2E4.</p><p>\C774 \C124\C815\C740 APEX \C138\C158 \B0B4\C5D0\C11C \CCAB\BC88\C9F8 \D398\C774\C9C0 \B85C\B4DC\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4. APEX \C138\C158\C5D0\C11C \B9F5 \D398\C774\C9C0\B97C \B2E4\C2DC \BC29\BB38\D558\BA74 \B9C8\C9C0\B9C9 \C704\CE58\AC00 \B9F5 \AC00\C6B4\B370\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105837167629310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE0C\B77C\C6B0\C800\C5D0\C11C \C704\CE58 \AC00\C838\C624\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105839708365310138)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \B9F5 \C704\CE58\C758 \C704\B3C4\B97C \D3EC\D568\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \BC18\D658\B41C \AC12\C740 -90~90 \C0AC\C774\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105839660518310138)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \C704\B3C4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105837997242310137)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \B9F5 \C704\CE58\C758 \C704\B3C4\B97C \C9C0\C815\D569\B2C8\B2E4. -90(\B0A8\CABD) \BC0F 90(\BD81\CABD) \C0AC\C774\C758 \AC12\C744 \C0AC\C6A9\D558\ACE0, \C18C\C218\C810 \BB38\C790\B85C "."\B97C \C0AC\C6A9\D569\B2C8\B2E4. \C608: <strong>45.5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105837850069310137)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105839577213310138)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \B9F5 \C704\CE58\C758 \ACBD\B3C4\B97C \D3EC\D568\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \BC18\D658\B41C \AC12\C740 -180~180 \C0AC\C774\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105839427585310138)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \ACBD\B3C4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105837706431310137)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \B9F5 \C704\CE58\C758 \ACBD\B3C4\B97C \C9C0\C815\D569\B2C8\B2E4. -180(\C11C\CABD) \BC0F 180(\B3D9\CABD) \C0AC\C774\C758 \AC12\C744 \C0AC\C6A9\D558\ACE0, \C18C\C218\C810 \BB38\C790\B85C "."\B97C \C0AC\C6A9\D569\B2C8\B2E4. \C608: <strong>100.5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105837609790310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105837528632310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CD08\AE30 \B9F5 \C704\CE58 \BC0F \D655\B300/\CD95\C18C \B808\BCA8\C744 \ACB0\C815\D558\AE30 \C704\D574 NUMBER \C5F4\C744 \BC18\D658\D558\B294 \C9C8\C758:   :</p>'),
'<pre>',
'select -133.5 longituide,',
'         35.2 latitude,',
'            3 zoom',
'  from sys.dual',
'</pre>',
unistr('<p>\CD08\AE30 \B9F5 \C704\CE58\B97C \ACB0\C815\D558\AE30 \C704\D574 SDO_GEOMETRY \C5F4\C744 \BC18\D658\D558\ACE0 \D655\B300/\CD95\C18C \B808\BCA8\C744 \C704\D574 NUMBER \C5F4\C744 \BC18\D658\D558\B294 \C9C8\C758\C785\B2C8\B2E4.</p>'),
'<pre>',
'select sdo_geometry( 2001,                                 -- 2 dimensional point',
'                     4326,                                 -- longitude/latitude (WGS84)',
'                     sdo_point_type( -133.5, 35.2, null ), -- concrete coordinates',
'                     null,                                 -- not used for points',
'                     null                                  -- not used for points',
'       )                   as geometry,',
'       3                   as zoom',
'  from sys.dual',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105837457146310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \B9F5 \C704\CE58 \BC0F \D655\B300/\CD95\C18C \B808\BCA8\C744 \ACB0\C815\D558\AE30 \C704\D574 SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105837370387310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105836498473310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 APEX \C138\C158\C5D0 \B300\D574 \B610\B294 \B9F5 \C601\C5ED <strong>\C9C0\C6B0\AE30</strong> \B610\B294 <strong>\C7AC\C124\C815</strong> \C791\C5C5 \C774\D6C4 \CD08\AE30 \B9F5 \C704\CE58 \BC0F \D655\B300/\CD95\C18C \B808\BCA8\C744 \ACB0\C815\D558\B294 \BC29\BC95\C744 \C9C0\C815\D569\B2C8\B2E4. APEX \C138\C158 \B0B4\C5D0\C11C \B9F5 \C601\C5ED\C740 \D398\C774\C9C0 \C694\CCAD \C2DC \D604\C7AC \C704\CE58 \BC0F \D655\B300/\CD95\C18C \B808\BCA8\C744 \AE30\C5B5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105836932226310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\AC04 \ACB0\ACFC \AE30\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105837037429310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE35 \C9C8\C758 \ACB0\ACFC\AC00 \D45C\C2DC\B418\B3C4\B85D \B9F5\C774 \BC30\CE58\B429\B2C8\B2E4. <em>\CE35 \B3C4\BA74 \C5F4 \C720\D615\C73C\B85C GeoJSON\C774 \C120\D0DD\B41C \ACBD\C6B0\C5D0\B294 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105836700019310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105836809719310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \B9F5 \C704\CE58\C5D0 \B300\D574 \AC12\C744 \BC18\D658\D558\B294 SQL \C9C8\C758\B97C \C81C\ACF5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105836593450310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105836684017310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \B9F5 \C704\CE58\C5D0 \B300\D574 \C815\C801 \AC12\C744 \C81C\ACF5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105836375720310136)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105839926874310138)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \D655\B300/\CD95\C18C \B808\BCA8\C744 \D3EC\D568\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \BC18\D658\B41C \AC12\C740 1~18 \C0AC\C774\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105839804287310138)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \D655\B300/\CD95\C18C \B808\BCA8 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105838147015310137)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \D655\B300/\CD95\C18C \B808\BCA8\C744 \C9C0\C815\D569\B2C8\B2E4. 1\C5D0\C11C 18 \C0AC\C774\C758 \C815\C218 \AC12\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105838020272310137)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\B300/\CD95\C18C \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105725849015310052)
,p_name=>'PE.PROPERTY.INLINE_CSS.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>CSS \D074\B798\C2A4 <code>display_only</code>\B97C \AD75\C740\CCB4\B85C \C124\C815\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'.display_only {',
'  font-weight: bold;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105212596199309631)
,p_name=>'PE.PROPERTY.INLINE_CSS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\C5D0 \C0AC\C6A9\B418\B294 CSS(\C885\C18D\D615 \C2DC\D2B8) \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\B3D9\C77C\D55C CSS\AC00 \C5EC\B7EC \D398\C774\C9C0\C5D0 \D544\C694\D55C \ACBD\C6B0 \C911\BCF5\C744 \BC29\C9C0\D558\ACE0 \C815\C801 \D30C\C77C\C758 \BE0C\B77C\C6B0\C800 \CE90\C2F1\C744 \D65C\C6A9\D558\AE30 \C704\D574 \CF54\B4DC\B97C \C678\BD80 \D30C\C77C\C5D0 \B123\B3C4\B85D \ACE0\B824\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C5EC\AE30\C5D0 \C785\B825\D558\B294 \CF54\B4DC\B85C \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C5D0 \C788\B294 <code>#PAGE_CSS#</code> \B300\CCB4 \BB38\C790\C5F4\C774 \BC14\B01D\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C5F4\AE30 \B610\B294 \B2EB\AE30 <code>style</code> \D0DC\ADF8\B294 \D3EC\D568\D558\C9C0 \C54A\C544\B3C4 \B429\B2C8\B2E4. \C885\C18D\D615 \C2DC\D2B8 \CF54\B4DC\B9CC \D3EC\D568\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105212467398309631)
,p_name=>'PE.PROPERTY.INLINE_CSS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105220850815309637)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0\C11C \C624\B958\AC00 \BC1C\C0DD\D560 \B54C \D45C\C2DC\B418\B294 \C624\B958 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4. \C624\B958 \BA54\C2DC\C9C0\B294 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C758 <code>#NOTIFICATION_MESSAGE#</code>\C5D0 \B300\D574 \B300\CCB4\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105220754097309637)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \C624\B958 \D1B5\C9C0 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106038837887310308)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C5D0 \B300\D55C \C778\B77C\C778 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B294 \D56D\BAA9\ACFC \D568\AED8 \C989\C2DC \D45C\C2DC\B418\BA70 \D544\B4DC \B808\BCA8\C758 \BB38\B9E5\C5D0 \B530\B978 \B3C4\C6C0\B9D0\C744 \C81C\ACF5\D558\B294 \B370 \C0AC\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106038704246310308)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105304368795309699)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C138\C158\C774 \BD80\C801\D569\D560 \ACBD\C6B0 &PRODUCT_NAME.\C774(\AC00) \C7AC\C9C0\C815\B418\B294 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C774 \ACBD\C6B0\B294 <strong>\AC10\C2DC \D568\C218</strong> \B610\B294 <strong>\D655\C778 \D568\C218</strong>\AC00 Ajax \C694\CCAD\C774 \C544\B2CC \C77C\BC18 \D398\C774\C9C0 \C694\CCAD\C5D0 \B300\D574 FALSE\B97C \BC18\D658\D560 \B54C \BC1C\C0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: <strong>''\C0AC\C6A9\C790\C815\C758''</strong> \C778\C99D \CCB4\ACC4 \C720\D615\C744 \C0AC\C6A9\D560 \B54C\B294 \C778\C99D \CCB4\ACC4\C758 <strong>''\AC10\C2DC \D568\C218''</strong> \C18D\C131\B3C4 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\D50C\B7EC\ADF8\C778 \C778\C99D \CCB4\ACC4 \C720\D615\C758 \ACBD\C6B0 <strong>''\C138\C158 \AC10\C2DC \D568\C218 \C774\B984''</strong> \CF5C\BC31\C758 \D50C\B7EC\ADF8\C778 \AC1C\BC1C\C790\C5D0 \C758\D574 \C815\C758\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105738807787310062)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \B85C\ADF8\C778 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105738912599310062)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('&PRODUCT_NAME.\C5D0\C11C \C81C\ACF5\B41C <code>wwv_flow_custom_auth_std.login_page</code>\C5D0 \C815\C758\B41C URL\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105738660134310062)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105738714752310062)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C18D\C131\C5D0 \C815\C758\B41C \B85C\ADF8\C778 URL\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105739056288310062)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.D'
,p_message_language=>'ko'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105739193999310062)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\D55C URL\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4(\C608: <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105304243997309699)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C138\C158 \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105304508345309700)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \AC10\C2DC \D568\C218\AC00 FALSE\B97C \BC18\D658\D560 \ACBD\C6B0 &PRODUCT_NAME.\C774(\AC00) \C7AC\C9C0\C815\D558\B294 URL\C744 \C785\B825\D569\B2C8\B2E4. \C774 URL\C740 \C77C\BC18\C801\C73C\B85C \B85C\ADF8\C778 \D398\C774\C9C0 \B610\B294 Single Sign-On \D3EC\D138\C5D0 \B300\D55C URL\C785\B2C8\B2E4. \C608: f?p=&amp;APP_ID.:101:&amp;SESSION')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105304446713309700)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C138\C158 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105545504629309899)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AC12 \D45C\C2DC \BC29\BC95\C744 \C815\C758\D558\AE30 \C704\D55C \AD00\B828 \C5F4 \D45C\C2DC \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105745544125310067)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('BLOB \B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105929861564310207)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \D30C\C77C\C744 \B2E4\C6B4\B85C\B4DC\D560 \C218 \C788\B294 \B9C1\D06C\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105745853881310067)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\ACA8\C9C4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105930179894310207)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \D45C\C2DC\D558\C9C0 \C54A\C9C0\B9CC \D574\B2F9 \C5F4\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105745421059310067)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105929775895310207)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \C774\BBF8\C9C0\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105745395674310067)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105929682025310206)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \B9C1\D06C\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105745614115310067)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C728 \ADF8\B798\D504')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105929929004310207)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \BC31\BD84\C728 \ADF8\B798\D504\B85C \D45C\C2DC\D569\B2C8\B2E4. \AC80\C0C9\B41C \AC12\C740 0\C5D0\C11C 100 \C0AC\C774\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105745124425310067)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105929463734310206)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105745238293310067)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \D14D\C2A4\D2B8(\AC12 \BAA9\B85D \AE30\C900)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105929531531310206)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \AC12 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106001948029310272)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\C2DD \C788\B294 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106002031958310272)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \B610\B294 \B9C8\D06C\B2E4\C6B4\C744 \C0AC\C6A9\D558\C5EC \C5F4\C744 \B80C\B354\B9C1\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105745785838310067)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.D'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105930067103310207)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AC12\C744 HTML \D0DC\ADF8\B97C \C81C\AC70\D558\ACE0 \D2B9\C218 \BB38\C790\B97C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D55C \D6C4\C5D0 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105545407388309899)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105629784538309967)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\BD80\C11C \C774\B984\C744 \BC18\D658\D558\B824\BA74 \B2E4\C74C\ACFC \AC19\C774 \D558\C2ED\C2DC\C624.</dt>'),
'<dd><pre>select dname from dept order by 1</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105563846005309913)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D558\B098\C758 \C5F4\C744 \BC18\D658\D574\C57C \D558\B294 SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4. \C9C8\C758\B85C \C5EC\B7EC \AC1C\C758 \C5F4\C774 \BC18\D658\B418\B294 \ACBD\C6B0 \CCAB\BC88\C9F8 \C5F4\B9CC \AC12 \BAA9\B85D\C5D0\C11C \C0AC\C6A9\B429\B2C8\B2E4.</p>'),
unistr('<p>SQL \C9C8\C758\B97C \C785\B825\D558\BA74 \C77C\BD80 \BCF4\ACE0\C11C\C5D0\C11C \C131\B2A5\C774 \D5A5\C0C1\B418\AC70\B098 \D45C\C2DC\B418\B294 \AC12\C744 \C81C\D55C\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105563713515309913)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105683236055310015)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \C774\B984\C774 \C9C0\C815\B41C \AC12 \BAA9\B85D\C744 \C120\D0DD\D569\B2C8\B2E4. \C5F4 \D544\D130\AC00 \B3D9\C801 \AC12 \BAA9\B85D \C9C8\C758\C758 \CCAB\BC88\C9F8 \C5F4 \B610\B294 \C815\C801 \AC12 \BAA9\B85D\C758 \D45C\C2DC \AC12\B9CC \C0AC\C6A9\D558\C5EC \BCF4\ACE0\C11C \B370\C774\D130\B97C \D544\D130\B9C1\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105683107592310015)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 \C9C0\C815\B41C LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105544303157309898)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4 \B4DC\B86D\B2E4\C6B4 \BAA9\B85D\C5D0 \C81C\ACF5\B41C \D544\D130\B97C \D30C\C0DD\D558\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105747371444310068)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 \C9C0\C815\B41C \AC12 \BAA9\B85D\C744 \C0AC\C6A9\D558\C5EC \C815\D655\D55C \C77C\CE58 \D56D\BAA9 \D544\D130\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105747427614310068)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 \C9C0\C815\B41C \AC12 \BAA9\B85D\C5D0\C11C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D558\C5EC \AC19\C74C \D544\D130\B97C \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105747588173310069)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 \C9C0\C815\B41C \AC12 \BAA9\B85D\C744 \C0AC\C6A9\D558\C5EC \B2E8\C5B4 \D3EC\D568 \D56D\BAA9 \D544\D130\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105747631175310069)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 \C9C0\C815\B41C \AC12 \BAA9\B85D\C5D0\C11C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D558\C5EC \D3EC\D568 \D544\D130\B97C \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105747186799310068)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \AC12 \BAA9\B85D\C744 \C0AC\C6A9\D558\C5EC \B2E8\C5B4 \D3EC\D568 \D544\D130\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105747247226310068)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C SQL \C9C8\C758 \AC12 \BAA9\B85D\C5D0\C11C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D558\C5EC \D3EC\D568 \D544\D130\B97C \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105746755048310068)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12(\C5F4 \C720\D615 \AE30\C900)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105746800567310068)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('STRING \BC0F NUMBER \C5F4\C740 \ACE0\C720 \C5F4 \AC12\C5D0\C11C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D569\B2C8\B2E4. DATE \C5F4\C740 \BBF8\B9AC \C815\C758\B41C \B0A0\C9DC \BC94\C704\C5D0\C11C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105746578947310068)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105746676965310068)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \C81C\ACF5\B41C \C5F4 \D544\D130\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105746986875310068)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \AC12 \BAA9\B85D\C744 \C0AC\C6A9\D558\C5EC \C815\D655\D55C \C77C\CE58 \D56D\BAA9 \D544\D130\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105747044200310068)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C SQL \C9C8\C758 \AC12 \BAA9\B85D\C5D0\C11C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D558\C5EC \AC19\C74C \C77C\CE58 \D544\D130\B97C \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105544243982309898)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105545324680309899)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C5D0 \B300\D55C \ADF8\B8F9\C744 \C120\D0DD\D569\B2C8\B2E4. \ADF8\B8F9\C740 \B2E8\C77C \D589 \BCF4\AE30\C758 \B17C\B9AC\C801 \ADF8\B8F9\C5D0 \C5F4\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105545249493309899)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105549207880309902)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \BCF4\ACE0\C11C\C758 \B9C1\D06C \C5F4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\B9C1\D06C \C5F4\C744 \C120\D0DD\D560 \ACBD\C6B0 \BCF4\ACE0\C11C\C5D0\C11C \D56D\C0C1 \CCAB\BC88\C9F8 \C5F4\B85C \D45C\C2DC\B418\BA70 \C0AC\C6A9\C790\AC00 \C228\AE38 \C218 \C5C6\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105749525796310070)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \B300\C0C1\C5D0 \B300\D55C \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105749644845310070)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\D55C \B300\C0C1 URL\C5D0 \B530\B77C \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \B2E4\B978 \D398\C774\C9C0\AC00 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105749777281310070)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C5F4 \C81C\C678')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105749867004310070)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C5F4\C774 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105749386350310070)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C \D589 \BCF4\AE30\C5D0 \B300\D55C \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105749421692310070)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \D589\C5D0 \B300\D55C \C5F4 \AC12\C744 \D45C\C2DC\D558\B294 \D398\C774\C9C0\AC00 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B429\B2C8\B2E4. \D45C\C2DC\D560 \C5F4 \BC0F \C5F4 \D45C\C2DC \BC29\BC95\C740 \C5EC\B7EC \AC00\C9C0 \BCF4\ACE0\C11C \BC0F \C5F4 \C18D\C131\C5D0 \C758\D574 \C81C\C5B4\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105549158706309902)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105595832191309938)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.COMPONENT_PROPERTY.IR_ATTRIBUTES.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105547075807309900)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \BCF4\ACE0\C11C\C758 \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \BCF4\ACE0\C11C\C758 \D2B9\C815 \D589 \C218\B9CC \D55C \D398\C774\C9C0\C5D0 \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('\CD94\AC00 \D589\C744 \D3EC\D568\D558\AE30 \C704\D574\C11C\B294 \C560\D50C\B9AC\CF00\C774\C158 \C77C\BC18 \C0AC\C6A9\C790\AC00 \BCF4\ACE0\C11C\C758 \B2E4\C74C \D398\C774\C9C0\B85C \C774\B3D9\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C740 \D589 \C218 \BC0F \ACB0\ACFC \C9D1\D569 \B0B4\C5D0\C11C \D604\C7AC \C704\CE58\C5D0 \B300\D55C \C815\BCF4\B97C \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>\D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C740 \BCF4\ACE0\C11C \C704 \B610\B294 \C544\B798(\B610\B294 \BAA8\B450)\C5D0 \D45C\C2DC\D560 \C218 \C788\C73C\BA70 \C67C\CABD \B610\B294 \C624\B978\CABD\C5D0 \BC30\CE58\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105748303371310069)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BC94\C704 X-Y')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105748263458310069)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BC94\C704 X-Y/Z')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105546952307309900)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105561510685309911)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B41C \C774 \BCF4\ACE0\C11C\C758 \BCC4\CE6D\C744 \C785\B825\D569\B2C8\B2E4. \C774 \BCC4\CE6D\C744 \C0AC\C6A9\D558\BA74 \C800\C7A5\B41C \D2B9\C815 \BCF4\ACE0\C11C\C5D0 \B300\D574 \BCF4\B2E4 \C758\BBF8 \C788\B294 URL \B9C1\D06C\B97C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \B9C1\D06C\B97C \C0AC\C6A9\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C758 \C5B4\B290 \ACF3\C5D0\C11C\B4E0 \C9C1\C811 \C5F0\ACB0\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105561457864309911)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105561958146309912)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C120\D0DD \BAA9\B85D \B0B4\C5D0\C11C \C774 \BCF4\ACE0\C11C\AC00 \D45C\C2DC\B418\B294 \C704\CE58\B97C \B098\D0C0\B0B4\B294 \C800\C7A5\B41C \BCF4\ACE0\C11C \BC94\C8FC\B97C \D655\C778\D569\B2C8\B2E4. \C774 \C18D\C131\C740 \BCF4\AE30 \C804\C6A9\C774\BA70 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105751920844310072)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105930380051310207)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790\AC00 \C800\C7A5\D55C \D6C4\C18D \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C73C\B85C, \C77C\BC18 \C0AC\C6A9\C790\AC00 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105751840475310072)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105930298435310207)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790\AC00 \C800\C7A5\D55C \BCF4\ACE0\C11C\B85C, \AE30\BCF8\C801\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105752181685310072)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105930582499310207)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C800\C7A5\D55C \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C73C\B85C, \D574\B2F9 \B808\C774\C544\C6C3\C744 \C800\C7A5\D55C \C77C\BC18 \C0AC\C6A9\C790\B9CC \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105752024402310072)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105930457349310207)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C800\C7A5\D55C \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C73C\B85C \B2E4\B978 \BAA8\B4E0 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105561835209309911)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105395879459309769)
,p_name=>'PE.PROPERTY.IS_EDITABLE.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \D3FC \C601\C5ED\C744 \D3B8\C9D1\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \D3FC \C601\C5ED\C744 \D3B8\C9D1\D560 \C218 \C788\AC8C \B418\BA74 \D589\C744 \CC98\B9AC\D560 \D504\B85C\C138\C2A4\AC00 \C790\B3D9\C73C\B85C \C0DD\C131\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105436701313309807)
,p_name=>'PE.PROPERTY.IS_EDITABLE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \B300\D654\C2DD \ADF8\B9AC\B4DC\B97C \D3B8\C9D1\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \B300\D654\C2DD \ADF8\B9AC\B4DC\B97C \D3B8\C9D1\D560 \C218 \C788\AC8C \B418\BA74 \B808\CF54\B4DC\B97C \CC98\B9AC\D560 \D504\B85C\C138\C2A4\AC00 \C790\B3D9\C73C\B85C \C0DD\C131\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105436642696309807)
,p_name=>'PE.PROPERTY.IS_EDITABLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106034658748310304)
,p_name=>'PE.PROPERTY.IS_GLOBAL_PAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \D398\C774\C9C0\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105450424474309820)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \AE30\BCF8 \D14C\C774\BE14\C5D0 \B300\D55C \AE30\BCF8 \D0A4 \AC12 \C911 \D558\B098\C778\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105450352970309820)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105450229194309819)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>DML \C791\C5C5\C5D0\C11C \C5F4\C744 \C81C\C678\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('        <p><strong>\C124\C815</strong>\C73C\B85C \C124\C815\D560 \ACBD\C6B0 &PRODUCT_NAME.\C5D0\C11C \B300\D654\C2DD \ADF8\B9AC\B4DC - \C790\B3D9 \D589 \D504\B85C\C138\C2F1(DML)\C744 \C2E4\D589\D560 \B54C \C5F4\C744 \D65C\C6A9\D558\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('        \C608\B97C \B4E4\C5B4, \D45C\D604\C2DD\C744 \AE30\C900\C73C\B85C \D558\B294 \C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BDF0\C758 \C5F4, \D568\C218 \D638\CD9C, \B0B4\BD80 \C120\D0DD \B610\B294 \C5F0\ACB0\C774 \C815\C758\C5D0 \D3EC\D568\B418\C5B4 \C788\B294 \C5F4\C744 \C81C\C678\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('        <p>INSERT \B610\B294 UPDATE \BB38\C5D0 \D3EC\D568\B418\C5B4\C57C \D558\B294 \BAA8\B4E0 \C5F4\C758 \ACBD\C6B0 \C774 \C635\C158\C774 <strong>\D574\C81C</strong>\B85C \C124\C815\B418\C5B4\C57C \D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0: \C774 \C635\C158\C774 <strong>\C124\C815</strong>\C73C\B85C \BC14\B00C\C9C0 \C54A\B294 \ACBD\C6B0 <em>\D45C\C2DC \C804\C6A9</em> \C720\D615\C758 \C5F4\C740 \C790\B3D9 \D589 \D504\B85C\C138\C2F1<u>\C5D0\B3C4</u> \D3EC\D568\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105450100540309819)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \C804\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105531237255309887)
,p_name=>'PE.PROPERTY.IS_STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218\B97C \C815\C801 \AC12\C73C\B85C \D55C \BC88\B9CC \C124\C815\D560 \C218 \C788\B294\C9C0 \C544\B2C8\BA74 \AD6C\C131\C694\C18C \B808\BCA8\C5D0\C11C \BB34\D6A8\D654\D560 \C218 \C788\B294\C9C0 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105531118781309887)
,p_name=>'PE.PROPERTY.IS_STATIC.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105882905937310171)
,p_name=>'PE.PROPERTY.IS_VISIBLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C744 \D45C\C2DC\D560\C9C0 \C228\AE38\C9C0 \C9C0\C815\D569\B2C8\B2E4. \C228\ACA8\C9C4 \C5F4\B3C4 \C5B8\C81C\B098 \B300\CCB4 \AD6C\BB38\C778 <code>&amp;COLUMN_NAME.</code>\C744 \C0AC\C6A9\D558\C5EC \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105882826927310171)
,p_name=>'PE.PROPERTY.IS_VISIBLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105423380701309796)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C5D0\C11C \C0C1\C704 \AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \C120\D0DD\B41C \C5F4\C774 \C5C6\C744 \ACBD\C6B0 \C0C1\C790 \ADF8\B9BC \CC28\D2B8\C758 \CD5C\C0C1\C704 \AC12\C740 \B370\C774\D130\C138\D2B8\C744 \AE30\BC18\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105423162512309796)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105423267573309796)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C5D0\C11C \D558\C704 \AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \C120\D0DD\B41C \C5F4\C774 \C5C6\C744 \ACBD\C6B0 \C0C1\C790 \ADF8\B9BC \CC28\D2B8\C758 \CD5C\D558\C704 \AC12\C740 \B370\C774\D130\C138\D2B8\C744 \AE30\BC18\C73C\B85C \D569\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105423055433309796)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\D55C\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105498229796309859)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C758 \C885\AC00 \AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105498118919309859)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EB\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105497866475309859)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C758 \C0C1\D55C\AC00 \AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105497785039309859)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105499830211309861)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 x\CD95 \B808\C774\BE14\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \C8FC\C2DD \CC28\D2B8\C758 \ACBD\C6B0, \C2DC\AC04 \CD95\C5D0\C11C \C8FC\C2DD \C815\BCF4\B97C \D45C\C2DC\D558\AE30 \C704\D574 \C5F4\C740 \B0A0\C9DC/\C2DC\AC04\AE30\B85D \B370\C774\D130 \C720\D615\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105499797170309861)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105329051550309719)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.COMPONENT_PROPERTY.JET_CHART_SERIES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'font-size:14px;color:white;</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105505257807309865)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \CC28\D2B8\C5D0\C11C \B808\C774\BE14\C758 \C2A4\D0C0\C77C\C744 \C815\C758\D558\B294 CSS \C2A4\D0C0\C77C \BB38\C790\C5F4\C744 \C785\B825\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105505159334309865)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \C2A4\D0C0\C77C \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105529437619309886)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BC94\C704 \ACC4\C5F4\C758 \ACBD\C6B0, \B450 \AC12\C758 \BC30\C5F4\C774 \C81C\ACF5\B418\BA74 \CCAB\BC88\C9F8\C640 \B450\BC88\C9F8 \AC12\C774 \AC01\AC01 \D558\C704\C640 \C0C1\C704 \D3EC\C778\D2B8\C5D0 \C801\C6A9\B429\B2C8\B2E4. <strong>\C870\AC01 \C678\BD80</strong> \AC12\C740 \D30C\C774 \CC28\D2B8\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.'),
unistr('        <strong>\D45C\C2DC\C790 \C704</strong>, <strong>\D45C\C2DC\C790 \C544\B798</strong>, <strong>\D45C\C2DC\C790 \C55E</strong> \BC0F <strong>\D45C\C2DC\C790 \B4A4</strong> \AC12\C740 \C120, \C601\C5ED, \C0B0\D3EC \BC0F \BC84\BE14 \ACC4\C5F4\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4. <strong>\B9C9\B300 \AC00\C7A5\C790\B9AC \B0B4\BD80</strong> \BC0F <strong>\B9C9\B300 \AC00\C7A5\C790\B9AC \C678\BD80</strong> \AC12\C740'),
unistr('        \BE44\ADF9\C120 \B9C9\B300 \ACC4\C5F4\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4. \B204\C801 \B9C9\B300\B294 <strong>\B9C9\B300 \AC00\C7A5\C790\B9AC \C678\BD80</strong>\B97C \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4. <strong>\C2DC\C791</strong> \AC12\C740 \AC00\B85C \BC0F \C138\B85C \C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0 \CC28\D2B8\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4. \CC28\D2B8\B294 \D604\C7AC \B808\C774\C544\C6C3\C744 \C870\C815\D558\C5EC \AD6C\D68D \C601\C5ED \B0B4\C5D0\C11C \B808\C774\BE14\C744 \B9DE\CD94\AC70\B098 \B808\C774\BE14 \C0AC\C774\C758 \ACB9\CE68\C744 \D574\ACB0\D558\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105504271948309864)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\D560 \B808\C774\BE14\C758 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105504455618309864)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.ABOVEMARKER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\C790 \C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105504761001309865)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AFTERMARKER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\C790 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105505044578309865)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105504602516309865)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BEFOREMARKER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\C790 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105504558453309865)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BELOWMARKER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\C790 \C544\B798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105504372931309864)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C6B4\B370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105504872451309865)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.INSIDEBAREDGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300 \AC00\C7A5\C790\B9AC \B0B4\BD80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105528869013309885)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105504907441309865)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDEBAREDGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300 \AC00\C7A5\C790\B9AC \C678\BD80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105528768014309885)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDESLICE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC01 \C678\BD80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104964661638309444)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.START.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105504117036309864)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105504095011309864)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \B808\C774\BE14\C774 \B80C\B354\B9C1\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C774 \C124\C815\C740 \B2E4\C774\C5BC \CC28\D2B8\C5D0\C11C \CE21\C815\D56D\BAA9 \AC12\C758 \D45C\C2DC\C5D0 \C801\C6A9\B429\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105503955913309864)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105497647417309858)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C758 \D558\D55C\AC00 \AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105497500089309858)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\D55C\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105499225959309860)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C758 \CD5C\B300\AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105499194686309860)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105601124165309942)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C758 \CD5C\C18C\AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105601068366309942)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105498070077309859)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C758 \C2DC\AC00 \AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105497908240309859)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105500005361309861)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B370\C774\D130 \D3EC\C778\D2B8\C5D0\C11C \AD6C\CCB4\C801\C778 \C9E7\C740 \C0AC\C6A9\C790\C815\C758 \B3C4\AD6C \C124\BA85\C744 \C815\C758\D560 \B54C \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \CC28\D2B8 \B370\C774\D130 \D3EC\C778\D2B8\C5D0\C11C \B3C4\AD6C \C124\BA85\C744 \B80C\B354\B9C1\D558\B824\BA74 \CC28\D2B8 \B3C4\AD6C \C124\BA85 \C18D\C131 <strong>\D45C\C2DC</strong>\AC00 <strong>\C124\C815</strong>\C73C\B85C \C124\C815\B418\C5C8\B294\C9C0 \D655\C778\D569\B2C8\B2E4. \C0C1\C790 \ADF8\B9BC \CC28\D2B8\C758 \ACBD\C6B0 \C120\D0DD\B41C \AC12 \C5F4 \B9E4\D551\ACFC \C5F4\C774 \C77C\CE58\D558\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4. \AC12 \C5F4 \B9E4\D551\ACFC \C77C\CE58\D558\B294 \C5F4\C744 \C120\D0DD\D558\BA74 \CC28\D2B8\C5D0\C11C \C0AC\C6A9\C790\C815\C758 \B3C4\AD6C \C124\BA85\C774 \B80C\B354\B9C1\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105499991315309861)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \B3C4\AD6C \C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105499030332309860)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C758 \BAA9\D45C \AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \C124\C815\B418\BA74 \AC12 \C18D\C131\C740 \C870\AC01 \B0B4\C5D0\C11C \CC44\C6CC\C9C4 \C601\C5ED\C744 \C815\C758\D558\ACE0 \C774\AC83\C740 \C804\CCB4 \C870\AC01\C758 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105498952038309860)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\D45C \AC12')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105497474694309858)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C5D0\C11C \AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \C0C1\C790 \ADF8\B9BC \CC28\D2B8\C758 \ACBD\C6B0 \C774 \C5F4\C740 \C22B\C790 \B370\C774\D130\C138\D2B8\C758 \CD5C\C18C\AC12, \C0AC\BD84\C704\C218 \AC12, \C911\AC04\AC12 \BC0F \CD5C\B300\AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105497364146309858)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105498427698309859)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C758 \AC70\B798\B7C9 \AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \AC12\C774 \C81C\ACF5\B418\BA74 \AC70\B798\B7C9\C774 y2\CD95\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105498393295309859)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC70\B798\B7C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105498658308309859)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C758 x \AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105498571367309859)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>'X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105498827134309860)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C758 y \AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105498781565309860)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105496200905309857)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C5D0\C11C z \AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. z \AC12\C740 \BC84\BE14 \CC28\D2B8\C5D0 \B300\D55C \BC84\BE14 \BC18\C9C0\B984, \C0C1\C790 \ADF8\B9BC \D56D\BAA9\C758 \B108\BE44 \BC0F \B9C9\B300\B098 \C870\D569 \CC28\D2B8\C5D0 \B300\D55C \B9C9\B300 \B108\BE44\B97C \C815\C758\D569\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105496116587309857)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>'Z'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105307764351309702)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \AD6C\C131\C694\C18C(\D558\C704 \C601\C5ED, \D56D\BAA9, \B2E8\CD94)\B97C \AE30\BCF8 \C601\C5ED \CF58\D150\CE20 \C704 \B610\B294 \C544\B798\C5D0 \D45C\C2DC\D560\C9C0\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105739909123310063)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.ABOVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20 \C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105740097002310063)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.BELOW.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20 \C544\B798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105307667180309702)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \B80C\B354\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105242376276309653)
,p_name=>'PE.PROPERTY.ITEM_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \D56D\BAA9 \C774\B984\C740 \C801\D569\D55C Oracle \C2DD\BCC4\C790\C5EC\C57C \D569\B2C8\B2E4. \D56D\BAA9 \C774\B984\C740 SQL \C9C8\C758\C5D0 \BC14\C778\B4DC \BCC0\C218\B85C \C0AC\C6A9\B420 \C218 \C788\B3C4\B85D 30\BC14\C774\D2B8 \C774\D558\B85C \C9C0\C815\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105242261512309653)
,p_name=>'PE.PROPERTY.ITEM_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105453691477309823)
,p_name=>'PE.PROPERTY.ITEM_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C5F4\C758 \B80C\B354\B9C1 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4. \C9C0\C6D0\B418\B294 \C5F4 \C720\D615\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\C5D0 \B530\B77C \C5EC\AE30\C5D0\C11C \CD94\AC00 \C5F4 \C720\D615 \D50C\B7EC\ADF8\C778\C744 \C0AC\C6A9\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \D50C\B7EC\ADF8\C778\C740 <em>&lt;My Plug-in&gt; [Plug-in]</em>\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('\B2E4\C74C \D50C\B7EC\ADF8\C778\C740 \C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \ACF5\C720 \AD6C\C131\C694\C18C\C5D0 \C124\CE58\B429\B2C8\B2E4.</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105241979523309653)
,p_name=>'PE.PROPERTY.ITEM_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D56D\BAA9\C758 \B80C\B354\B9C1 \BC29\BC95\C744 \C9C0\C815\D569\B2C8\B2E4. \C9C0\C6D0\B418\B294 \D56D\BAA9 \C720\D615\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\C5D0 \B530\B77C \C5EC\AE30\C5D0\C11C \CD94\AC00 \D56D\BAA9 \C720\D615 \D50C\B7EC\ADF8\C778\C744 \C0AC\C6A9\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \D50C\B7EC\ADF8\C778\C740 <em>&lt;My Plug-in&gt; [Plug-in]</em>\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('\B2E4\C74C \D50C\B7EC\ADF8\C778\C740 \C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \ACF5\C720 \AD6C\C131\C694\C18C\C5D0 \C124\CE58\B429\B2C8\B2E4.</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105241829380309653)
,p_name=>'PE.PROPERTY.ITEM_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105901322995310185)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105922409612310201)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B808\BCA8\C5D0\C11C \AC80\C0AC\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0 \C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D \AC80\C0AC\C5D0 \D56D\BAA9\C744 \D3EC\D568\C2DC\D0B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105900820614310185)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C5D0 \C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D\C774 \C788\B294\B370 \D398\C774\C9C0\C5D0\C11C \B098\AC00\B824\ACE0 \D560 \B54C \C0AC\C6A9\C790\C5D0\AC8C \ACBD\ACE0\D558\B294 \C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D \AC80\C0AC\C5D0 \D398\C774\C9C0 \D56D\BAA9\C774 \D3EC\D568\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C77C\BD80 \D56D\BAA9\C740 \AC80\C0AC\D560 \D544\C694\AC00 \C5C6\C73C\BBC0\B85C(\C608\B97C \B4E4\C5B4, \AC80\C0C9 \D56D\BAA9\ACFC \AC19\C774 \B370\C774\D130\BCA0\C774\C2A4 \C5F4\C744 \AE30\BC18\C73C\B85C \D558\C9C0 \C54A\B294 \ACBD\C6B0) \BB34\C2DC\D558\B3C4\B85D \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105900936221310185)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105903714584310187)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C5D0 \B300\D55C \BCC0\ACBD\C0AC\D56D\C774 \C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D \AC80\C0AC\C5D0\C11C \BB34\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105900755308310185)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D \ACBD\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106045681975310314)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.toolbar = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105464188143309831)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0 \B300\D55C \AD6C\C131 \AC1D\CCB4\B97C \AC00\C838\C628 \B2E4\C74C \AC1D\CCB4\B97C \C218\C815\D558\C5EC \BC18\D658\D558\B294 JavaScript \D568\C218\B97C \C785\B825\D569\B2C8\B2E4. \C774 \D568\C218\B97C \C0AC\C6A9\D558\BA74 \B300\D654\C2DD \ADF8\B9AC\B4DC\C758 \BAA8\C591, \AE30\B2A5 \BC0F \B3D9\C791(\B3C4\AD6C \BAA8\C74C, \BA54\B274 \BC0F \C791\C5C5\C744 \D3EC\D568)\C5D0 \B300\D55C \ACE0\AE09 \C0AC\C6A9\C790\C815\C758\AC00 \AC00\B2A5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106045787133310315)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.features = options.features || {};',
'    options.features.sort = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105600459655309942)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C5D0 \B300\D55C \AD6C\C131 \AC1D\CCB4\B97C \AC00\C838\C628 \B2E4\C74C \AC1D\CCB4\B97C \C218\C815\D558\C5EC \BC18\D658\D558\B294 JavaScript \D568\C218\B97C \C785\B825\D569\B2C8\B2E4. \C774 \D568\C218\B97C \C0AC\C6A9\D558\BA74 \C5F4 \BAA8\C591, \AE30\B2A5 \BC0F \B3D9\C791\C5D0 \B300\D55C \ACE0\AE09 \C0AC\C6A9\C790\C815\C758\AC00 \AC00\B2A5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106045882761310315)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ){',
unistr('    // \B370\C774\D130\AC00 \AC80\C0C9\B420 \B54C \D638\CD9C\B418\B294 \CF5C\BC31 \D568\C218\B97C \C124\C815\D569\B2C8\B2E4. \ACC4\C5F4 \C870\C791\C744 \D5C8\C6A9\D569\B2C8\B2E4.'),
'    options.dataFilter = function( data ) {',
'        data.series[ 0 ].color = "#00FF00";',
'        return data;',
'    };',
unistr('    // \CC28\D2B8 \CD08\AE30\D654 \C635\C158\C744 \C124\C815\D569\B2C8\B2E4.'),
'    options.type = "line";',
'    return options;',
'}</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105509885945309869)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\CC28\D2B8\B97C \C0AC\C6A9\C790\AC00 \C815\C758\D560 JavaScript \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106046494535310315)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'  options.advancedOption = true;',
'  return options;',
'}',
'</pre>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105444134297309814)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AD6C\C131\C694\C18C\C5D0 \B300\D55C \AD6C\C131 \AC1D\CCB4\B97C \AC00\C838\C628 \B2E4\C74C \AC1D\CCB4\B97C \C218\C815\D558\C5EC \BC18\D658\D558\B294 JavaScript \D568\C218\B97C \C785\B825\D569\B2C8\B2E4. \C774 \D568\C218\B97C \C0AC\C6A9\D558\BA74 \AD6C\C131\C694\C18C\C758 \BAA8\C591, \AE30\B2A5 \BC0F \B3D9\C791\C5D0 \B300\D55C \ACE0\AE09 \C0AC\C6A9\C790\C815\C758\AC00 \AC00\B2A5\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105444011052309814)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \CD08\AE30\D654 \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105815183830310119)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \C8FC \BC0F \BCF4\C870 \CD95\C758 \C704\CE58\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105815830967310120)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105815735244310120)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105815066246310119)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95 \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105818687995310122)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \CD95\C5D0 \C0AC\C6A9\D560 \C2DC\AC04 \AC04\ACA9\C744 \C9C0\C815\D569\B2C8\B2E4. \C774\B294 \AC04\D2B8\B97C \C81C\B300\B85C \B80C\B354\B9C1\D558\B294 \B370 \D544\C694\D569\B2C8\B2E4. \C120\D0DD\B41C \C2DC\AC04 \AC04\ACA9\C740 \D655\B300/\CD95\C18C \BC30\C728 \C635\C158\C774 \C120\D0DD\B418\C9C0 \C54A\C740 \ACBD\C6B0 \D655\B300/\CD95\C18C\C5D0 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105816702789310121)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.DAYS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105816624781310121)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.HOURS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105816365882310120)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MINUTES.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105817106037310121)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MONTHS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105817309001310121)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.QUARTERS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105816263356310120)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.SECONDS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105816951214310121)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.WEEKS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105817505247310121)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.YEARS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105818541785310122)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C218\C810 \C774\D558 \C790\B9BF\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105484872962309848)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4. \CC28\D2B8 \C720\D615\C5D0 \B530\B77C \CC28\D2B8\B97C \B80C\B354\B9C1\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C2DC\AC01\D654\AC00 \ACB0\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105484901350309848)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105625633334309963)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \CC28\D2B8\B294 \B9E4\CD9C\C561 \CD94\C138 \BD84\C11D\ACFC \AC19\C774 \C2DC\AC04\C5D0 \B530\B978 \B204\C801 \AC12 \CD94\C138\B97C \BE44\AD50\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105485040371309848)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105625743237309963)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300 \CC28\D2B8\B294 \BC94\C8FC\C5D0 \AC78\CCD0 \B610\B294 \C2DC\AC04\C5D0 \B530\B77C \AC12\C744 \BE44\AD50\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105406546526309777)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C790 \ADF8\B9BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105406695067309777)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C790 \ADF8\B9BC \CC28\D2B8\B294 \B370\C774\D130 \BD84\D3EC\B97C \BD84\C11D\D558\ACE0 \C22B\C790 \B370\C774\D130 \ADF8\B8F9\C758 \CD5C\C18C\AC12, \C0AC\BD84\C704\C218 \AC12, \C911\AC04\AC12 \BC0F \CD5C\B300\AC12\C744 \D45C\C2DC\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4. \C0C1\C790 \ADF8\B9BC\C740 \C0C1\C790 \C218\C5FC \B2E4\C774\C5B4\ADF8\B7A8\C774\B77C\ACE0\B3C4 \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105485165290309848)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105625890870309964)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\BE14 \CC28\D2B8\B294 x, y \BC0F z \AC12\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130 \D56D\BAA9\C744 \C815\C758\D558\C5EC 3\CC28\C6D0 \C0AC\C774\C758 \AD00\ACC4\B97C \BCF4\B294 \B370 \C720\C6A9\D569\B2C8\B2E4. \C138\BC88\C9F8 \CC28\C6D0\C740 \BC84\BE14\C758 \D06C\AE30\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105485224715309848)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105625937793309964)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\D569 \CC28\D2B8\B294 \B9C9\B300, \C120 \BC0F \C601\C5ED \ACC4\C5F4\C774 \B3D9\C77C\D55C \CC28\D2B8\C5D0 \D45C\C2DC\B418\B3C4\B85D \D569\B2C8\B2E4. \AC00\C7A5 \C77C\BC18\C801\C778 \C0AC\C6A9 \C0AC\B840\B294 \C120\ACFC \B9C9\B300 \B610\B294 \C120\ACFC \B204\C801 \B9C9\B300\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105485304952309848)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105626098572309964)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0\B294 \CE21\C815\D56D\BAA9 \AC12\ACFC \D574\B2F9 \CE21\C815\D56D\BAA9\C5D0 \AC00\B2A5\D55C \CD5C\C18C\AC12 \BC0F \CD5C\B300\AC12\C744 \BE44\AD50\D558\C5EC \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105520461044309878)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\B11B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105626129719309964)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\B11B \CC28\D2B8\B294 \AC00\C6B4\B370 \AD6C\BA4D\C774 \C788\B294 \D30C\C774 \CC28\D2B8\C785\B2C8\B2E4. \C804\CCB4 \C911 \C77C\BD80\B97C \C2DC\AC01\C801\C73C\B85C \D45C\C2DC\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105485478207309848)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D37C\B110')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105626274983309964)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D37C\B110 \CC28\D2B8\B294 \D310\B9E4 \D504\B85C\C138\C2A4\C758 \B2E8\ACC4\C640 \AC19\C774 \D504\B85C\C138\C2A4\C758 \B2E8\ACC4\C5D0 \B300\D55C \B370\C774\D130\B97C \BCF4\B294 \B370 \C720\C6A9\D569\B2C8\B2E4. \D37C\B110 \C870\AC01\C758 \C601\C5ED\C740 \D574\B2F9\D558\B294 \B2E8\ACC4\C5D0 \B300\D55C \AC12\ACFC \BE44\B840\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105815597585310120)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105815684874310120)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\B294 \D504\B85C\C81D\D2B8 \C77C\C815 \D45C\C2DC(\C791\C5C5 \C2DC\C791 \BC0F \C885\B8CC \B0A0\C9DC\B97C \B098\D0C0\B0B4\B294 \B9C9\B300 \D45C\C2DC)\C5D0 \C720\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105485582895309848)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105626363468309964)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120 \CC28\D2B8\B294 \C2DC\AC04\C5D0 \B530\B978 \AC12 \C9D1\D569\C758 \CD94\C138\B97C \C2DC\AC01\C801\C73C\B85C \D45C\C2DC\D558\ACE0 \C774\B7EC\D55C \AC12\C744 \ACC4\C5F4\C5D0 \B530\B77C \BE44\AD50\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105485679737309848)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\ACFC \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105626475625309964)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\ACFC \C601\C5ED \CC28\D2B8\B294 \C120 \CC28\D2B8\C640 \B3D9\C77C\D558\BA70, \AC01 \C120 \C544\B798\C5D0 \C601\C5ED\C774 \CC44\C6CC\C9D1\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105485795785309848)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105626529800309964)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C774 \CC28\D2B8\B294 \C804\CCB4 \C911 \C77C\BD80\B97C \C2DC\AC01\C801\C73C\B85C \D45C\C2DC\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105520151260309878)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF9\C120')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105626694029309964)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF9\C120 \CC28\D2B8\B294 \BC29\C0AC\C0C1\C758 y\CD95\ACFC \C811\C120\C758 x\CD95\C744 \AC00\C9D1\B2C8\B2E4. \ADF9\C120 \CC28\D2B8\B294 \B9C9\B300, \C120, \C601\C5ED, \C870\D569, \C0B0\D3EC \B610\B294 \BC84\BE14 \CC28\D2B8 \ACC4\C5F4 \C720\D615\C73C\B85C \B80C\B354\B9C1\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105319108956309712)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B77C\BBF8\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105319264393309712)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B77C\BBF8\B4DC \CC28\D2B8\B294 \ACC4\CE35 \AD00\ACC4, \BE44\B840 \AD00\ACC4, \D558\BD80 \AD6C\C870\C5D0 \AE30\CD08\D55C \AD00\ACC4, \D504\B85C\C138\C2A4 \B2E8\ACC4, \AD6C\C870\C801 \CE35 \B610\B294 \D56D\BAA9 \C0C1\D638 \C5F0\ACB0\C744 \C2DC\AC01\D654\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4. \D53C\B77C\BBF8\B4DC \C870\AC01\C758 \C601\C5ED\C740 \D574\B2F9\D558\B294 \B2E8\ACC4\C758 \AC12\C5D0 \BE44\B840\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105520274801309878)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105626744875309964)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\C0AC \CC28\D2B8\B294 \C6D0\D615 \B458\B808 \B300\C2E0 \B2E4\AC01\D615 \ADF8\B9AC\B4DC \BAA8\C591\C758 \ADF9\C120 \CC28\D2B8\C785\B2C8\B2E4. \C120 \BC0F \C601\C5ED \CC28\D2B8 \ACC4\C5F4 \C720\D615\C5D0 \B300\D574 \C9C0\C6D0\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105520304986309878)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105626854902309964)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C704 \CC28\D2B8\B294 \B9C9\B300\B098 \C601\C5ED\C744 \C0AC\C6A9\D558\C5EC \AC01 \D56D\BAA9\C5D0 \B300\D55C \CD5C\B300\AC12/\CD5C\C18C\AC12(\C0C1\C704\AC12/\D558\C704\AC12)\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105485879811309848)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0B0\D3EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105626957967309965)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0B0\D3EC \CC28\D2B8\B294 x \BC0F y \AC12\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130 \D56D\BAA9\C744 \C815\C758\D558\C5EC 2\CC28\C6D0 \C0AC\C774\C758 \AD00\ACC4\B97C \BCF4\B294 \B370 \C720\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105485984480309848)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105627063420309965)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\C2DD \CC28\D2B8\B294 \C2DC\AC04 \CD95\C5D0\C11C \C8FC\C2DD\C5D0 \B300\D55C \C815\BCF4\B97C \D45C\C2DC\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4. \C8FC\C2DD \CC28\D2B8\C5D0 \ACE0\C720\D55C \CD1B\B300 <strong>\B2E4\C74C\C73C\B85C \C8FC\C2DD \B80C\B354\B9C1</strong> \C18D\C131\C744 \D1B5\D574 \C8FC\AC00\C5D0 \B300\D55C \C2DC\AC00, \C885\AC00, \C0C1\D55C\AC00, \D558\D55C\AC00 \C815\BCF4\B97C \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105484749420309847)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105423555243309796)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2E4\C911 \ACC4\C5F4 \CC28\D2B8 \B370\C774\D130\C758 \AC04\ACA9\C744 \AC12 0 \B610\B294 \B110\B85C \C124\C815\D574\C57C \D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('        <p><strong>\C124\C815</strong>\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \B370\C774\D130\C758 \AC04\ACA9\C774 0\C73C\B85C \CC98\B9AC\B429\B2C8\B2E4. \AEBE\C740\C120\D615 \CC28\D2B8\C758 \ACBD\C6B0 \C774\C640 \AC19\C774 \C124\C815\D558\BA74 \C120\C774 \C2E4\C120\C73C\B85C \B80C\B354\B9C1\B429\B2C8\B2E4. \B204\C801 \B808\C774\BE14\C774 [\C124\C815]\C73C\B85C \C124\C815\B41C \B204\C801 \B9C9\B300 \CC28\D2B8\C758 \ACBD\C6B0 \AC01 \B204\C801\C5D0 \B300\D55C \B204\C801 \B808\C774\BE14\C774 \B80C\B354\B9C1\B429\B2C8\B2E4.</p>'),
unistr('        <p><strong>\D574\C81C</strong>\B85C \C124\C815\D560 \ACBD\C6B0 \B370\C774\D130\C758 \AC04\ACA9\C774 \B110\B85C \CC98\B9AC\B429\B2C8\B2E4. \AEBE\C740\C120\D615 \CC28\D2B8\C758 \ACBD\C6B0 \C120\C774 \D30C\C120\C73C\B85C \B80C\B354\B9C1\B418\BA70 \B110 \B370\C774\D130 \D3EC\C778\D2B8\B97C \B098\D0C0\B0B4\B294 \AC04\ACA9\C774 \C0DD\AE41\B2C8\B2E4.<p>'),
unistr('        <p>\C774 \C124\C815\C740 \B9C9\B300 \BC0F \C120\C73C\B85C\C758 \B80C\B354\B9C1\C744 \C9C0\C6D0\D558\B294 \B2E4\C911 \ACC4\C5F4 \CC28\D2B8 \C720\D615(\C608: \B9C9\B300, \AEBE\C740\C120\D615, \AEBE\C740\C120\D615\ACFC \C601\C5ED, \C870\D569, \C601\C5ED, \ADF9\C120\D615, \BC29\C0AC\D615 \BC0F \C0B0\D3EC\B3C4)\C5D0 \C801\C6A9\B429\B2C8\B2E4. \AE30\BCF8\AC12\C740 <strong>\C124\C815</strong>\C785\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105423466414309796)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\ACA9\C744 0\C73C\B85C \B80C\B354\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105487809864309850)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CC28\D2B8\C5D0\C11C \B370\C774\D130 \CEE4\C11C\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B418\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('        \B370\C774\D130 \CEE4\C11C\B294 \D2B9\D788 \D130\CE58 \C7A5\CE58\C5D0\C11C \B370\C774\D130 \D56D\BAA9\C73C\B85C \C774\B3D9\D558\AE30 \C5B4\B824\C6B8 \B54C \B3C4\AD6C \C124\BA85\C5D0 \B300\D55C \C720\C6A9\D55C \B300\CCB4 \C218\B2E8\C785\B2C8\B2E4.<p/>'),
unistr('        <p><strong>\C790\B3D9</strong>\C73C\B85C \C124\C815\B418\BA74 \D130\CE58 \C7A5\CE58\C5D0\C11C \C120\C774\B098 \C601\C5ED \CC28\D2B8\C5D0 \B300\D574\C11C\B9CC \B370\C774\D130 \CEE4\C11C\AC00 \D45C\C2DC\B429\B2C8\B2E4.<p/>'),
unistr('        <p>\CC38\ACE0 - \B370\C774\D130 \CC28\D2B8\B294 \B3C4\AD6C \C124\BA85\C774 \B110\C778 \ACBD\C6B0 \D45C\C2DC\B418\C9C0 \C54A\C73C\BA70 \ADF9\C120 \CC28\D2B8\C5D0\C11C\B294 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105487988499309850)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105627494021309965)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0 \B300\D55C Oracle JET \C815\C758 \AE30\BCF8 \B370\C774\D130 \CEE4\C11C \D45C\C2DC\B97C \C801\C6A9\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105488180105309850)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105627613630309965)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \CEE4\C11C\AC00 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105488018869309850)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105627587150309965)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \CEE4\C11C\AC00 \D56D\C0C1 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105487791107309850)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE4\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105488310203309850)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \B370\C774\D130 \CEE4\C11C\C758 \B3D9\C791\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105488430859309850)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105617969792309956)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0 \B300\D55C Oracle JET \C815\C758 \AE30\BCF8 \B370\C774\D130 \CEE4\C11C \B3D9\C791\C744 \C801\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105488503112309850)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\B4DC\B7FD\AC8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105627733798309965)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B370\C774\D130 \CEE4\C11C\AC00 \B9C8\C6B0\C2A4/\D130\CE58 \C774\B3D9\C744 \BD80\B4DC\B7FD\AC8C \B530\B77C\AC00\BA74\C11C \B370\C774\D130 \CEE4\C11C\B97C \D2B9\C815 \B370\C774\D130 \D3EC\C778\D2B8\BFD0 \C544\B2C8\B77C \B370\C774\D130 \C694\C18C\C758 \BD80\BD84 \C704\B85C \AC00\C838\AC08 \B54C\B9C8\B2E4 \B3C4\AD6C \C124\BA85\C774 \D45C\C2DC\B429\B2C8\B2E4. \D45C\C2DC\AE30\B294 \D604\C7AC \C120\D0DD\B41C \B370\C774\D130 \C694\C18C\B97C \C2DD\BCC4\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \C774 \C2DC\AC01\D654\AC00 \C81C\B300\B85C \C791\B3D9\D558\B3C4\B85D \D558\B824\BA74 <strong>\CEE4\C11C</strong>\B97C <strong>\C608</strong>\B85C \C124\C815\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105488677800309850)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\B0C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105627806015309965)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CC28\D2B8 \C704\C5D0\C11C \B9C8\C6B0\C2A4/\D130\CE58 \C774\B3D9\C774 \BC1C\C0DD\D560 \B54C \B370\C774\D130 \CEE4\C11C\AC00 \B370\C774\D130 \C694\C18C\B85C \C2A4\B0C5(\C810\D504)\B418\C5B4 \B370\C774\D130 \CEE4\C11C\B97C \B370\C774\D130 \C694\C18C \C704\B85C \AC00\C838\AC08 \B54C\B9C8\B2E4 \B3C4\AD6C \C124\BA85\C774 \D45C\C2DC\B429\B2C8\B2E4. \D45C\C2DC\AE30\B294 \D604\C7AC \C120\D0DD\B41C \B370\C774\D130 \C694\C18C\B97C \C2DD\BCC4\D569\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \C774 \C2DC\AC01\D654\AC00 \C81C\B300\B85C \C791\B3D9\D558\B3C4\B85D \D558\B824\BA74 <strong>\CEE4\C11C</strong>\B97C <strong>\C608</strong>\B85C \C124\C815\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105488222996309850)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105338117582309727)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \ACC4\C5F4 \CC28\D2B8 \B370\C774\D130\C758 \AC04\ACA9\C774 \C790\B3D9\C73C\B85C \CC44\C6CC\C838\C57C \D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C774 \C124\C815\C740 \B2E8\C77C \ACC4\C5F4 \CC28\D2B8\B098 \BC84\BE14, \B3C4\B11B, \D37C\B110, \AC04\D2B8, \D30C\C774, \D53C\B77C\BBF8\B4DC, \C0B0\D3EC\B3C4, \C8FC\C2DD \CC28\D2B8 \C720\D615\C5D0 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4. <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D560 \ACBD\C6B0 Oracle Application Express 5.1.3\C5D0\C11C \B3C4\C785\B41C \B370\C774\D130 \CE58\BC00\D654 \B17C\B9AC\AC00 \CC28\D2B8 \B370\C774\D130\C5D0 \C801\C6A9\B429\B2C8\B2E4. <strong>\D574\C81C</strong>\B85C \C124\C815\D560 \ACBD\C6B0 \B370\C774\D130\C758 \AC04\ACA9\C774 \CC44\C6CC\C9C0\C9C0 \C54A\C73C\BA70')
||unistr(' \C774\B85C \C778\D574 \BD80\C815\D655\D55C \CC28\D2B8 \B80C\B354\B9C1\C774 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4. \AE30\BCF8\AC12\C740 <strong>\C124\C815</strong>\C785\B2C8\B2E4.  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105338034434309727)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \B370\C774\D130\C758 \AC04\ACA9 \CC44\C6B0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106052081992310320)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AC04\D2B8 \CC28\D2B8\C758 \AE30\C900 \D45C\C2DC\C904\C5D0 \C801\C6A9\D560 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \D074\B798\C2A4\B97C \C5EC\B7EC \AC1C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4. <code>&COLUMN_VALUE.</code> \B300\CCB4\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106051936227310320)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C900 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105822266197310125)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \AE30\C900 \C885\B8CC \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \AE30\C900 \C885\B8CC \B0A0\C9DC\B294 \C791\C5C5\C758 \C6D0\B798 \ACC4\D68D \C885\B8CC \B0A0\C9DC\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105822152804310125)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C900 \C885\B8CC \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105822087033310125)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \AE30\C900 \C2DC\C791 \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \AE30\C900 \C2DC\C791 \B0A0\C9DC\B294 \C791\C5C5\C758 \C6D0\B798 \ACC4\D68D \C2DC\C791 \B0A0\C9DC\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105821938995310125)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C900 \C2DC\C791 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105820460486310124)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C758 \C885\B8CC \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105820391133310123)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105820634062310124)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C758 \C885\B8CC \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105820501769310124)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105819645480310123)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C758 \C885\B8CC \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C18C\C2A4\B97C \C120\D0DD\D569\B2C8\B2E4. \CC28\D2B8\B97C \B80C\B354\B9C1\D558\B824\BA74 \C885\B8CC \B0A0\C9DC\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105819831192310123)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105819908896310123)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\C885\B8CC \B0A0\C9DC \C5F4</em>\C5D0 \C785\B825\B41C \C5F4 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105820129715310123)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105820239479310123)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C <em>\C885\B8CC \B0A0\C9DC \D56D\BAA9</em>\C758 \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105819786074310123)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC \C18C\C2A4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105822407909310125)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \C791\C5C5 \C9C4\D589\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \C9C4\D589 \AC12\C740 0\C5D0\C11C 1 \C0AC\C774\C5EC\C57C \D569\B2C8\B2E4. \AC12\C774 \BD80\C801\D569\D558\BA74 \C9C4\D589\C774 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105822319730310125)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106051846998310320)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AC04\D2B8 \CC28\D2B8\C758 \C9C4\D589\B960 \D45C\C2DC\C904\C5D0 \C801\C6A9\D560 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \D074\B798\C2A4\B97C \C5EC\B7EC \AC1C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4. <code>&COLUMN_VALUE.</code> \B300\CCB4\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106051744620310320)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C4\D589\B960 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105820890626310124)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \D589 ID\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \D589\B2F9 \C5EC\B7EC \C791\C5C5\C744 \B80C\B354\B9C1\D558\B824\BA74 \D589 ID\AC00 \D544\C694\D569\B2C8\B2E4. \D589 ID \C5F4 \B9E4\D551\C774 \C815\C758\B418\C9C0 \C54A\C740 \ACBD\C6B0, \AC01 \C791\C5C5\C740 \D589\B2F9 \D558\B098\C758 \C791\C5C5\C73C\B85C \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105820780697310124)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105821017352310124)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \D589 \C774\B984\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105820965000310124)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105819533445310123)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C758 \C2DC\C791 \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105819443743310123)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105829037904310130)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C758 \C2DC\C791 \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105820058442310123)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105816030493310120)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C758 \C2DC\C791 \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C18C\C2A4\B97C \C120\D0DD\D569\B2C8\B2E4. \CC28\D2B8\B97C \B80C\B354\B9C1\D558\B824\BA74 \C2DC\C791 \B0A0\C9DC\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105818800055310122)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105818913903310122)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\C2DC\C791 \B0A0\C9DC \C5F4</em>\C5D0 \C785\B825\B41C \C5F4 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105819085591310122)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105819173918310123)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C <em>\C2DC\C791 \B0A0\C9DC \D56D\BAA9</em>\C758 \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105815975561310120)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC \C18C\C2A4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106051655318310320)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AC04\D2B8 \CC28\D2B8\C758 \C791\C5C5 \D45C\C2DC\C904\C5D0 \C801\C6A9\D560 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \D074\B798\C2A4\B97C \C5EC\B7EC \AC1C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4. <code>&COLUMN_VALUE.</code> \B300\CCB4\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106051527883310320)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105821853556310125)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \C791\C5C5 \C885\B8CC \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105821742836310124)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C885\B8CC \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105821260363310124)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \C791\C5C5 ID\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105821138604310124)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105821433369310124)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \C791\C5C5 \C774\B984\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. \D589 \C774\B984 \C5F4 \B9E4\D551\C774 \C815\C758\B418\C9C0 \C54A\C740 \ACBD\C6B0, \C791\C5C5 \C774\B984\C740 \CC28\D2B8\C758 \D589 \CD95\C5D0\C11C \D589 \B808\C774\BE14\B85C \C0AC\C6A9\B429\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105821354361310124)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105821676847310124)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \C791\C5C5 \C2DC\C791 \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105821555402310124)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C2DC\C791 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106032248349310302)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C758 \BDF0\D3EC\D2B8 \C885\B8CC \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106027268245310297)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106032367893310302)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C758 \BDF0\D3EC\D2B8 \C885\B8CC \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106027090214310296)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106031922123310301)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C758 \BDF0\D3EC\D2B8 \C885\B8CC \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C18C\C2A4\B97C \C120\D0DD\D569\B2C8\B2E4. \BDF0\D3EC\D2B8\B294 \B0A0\C9DC \BC94\C704(\C815\C758\B41C \ACBD\C6B0 \B80C\B354\B9C1\B420 \B54C \CC28\D2B8\C758 \CD08\AE30 \D655\B300/\CD95\C18C\B97C \C81C\C5B4\D560 \C218 \C788\C74C)\C785\B2C8\B2E4. \C9C0\C815\B41C \B0A0\C9DC \BC94\C704\B85C \CC28\D2B8\AC00 \D655\B300\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106027483453310297)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106032090748310301)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\C885\B8CC \B0A0\C9DC \C5F4</em>\C5D0 \C785\B825\B41C \C5F4 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106027620126310297)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106032124234310302)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C <em>\C885\B8CC \B0A0\C9DC \D56D\BAA9</em>\C758 \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106026929618310296)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC \C18C\C2A4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106031742954310301)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C758 \BDF0\D3EC\D2B8 \C2DC\C791 \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106027130707310297)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106031807339310301)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C758 \BDF0\D3EC\D2B8 \C2DC\C791 \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106026856882310296)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106031421717310301)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C758 \BDF0\D3EC\D2B8 \C2DC\C791 \B0A0\C9DC\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C18C\C2A4\B97C \C120\D0DD\D569\B2C8\B2E4. \BDF0\D3EC\D2B8\B294 \B0A0\C9DC \BC94\C704(\C815\C758\B41C \ACBD\C6B0 \B80C\B354\B9C1\B420 \B54C \CC28\D2B8\C758 \CD08\AE30 \D655\B300/\CD95\C18C\B97C \C81C\C5B4\D560 \C218 \C788\C74C)\C785\B2C8\B2E4. \C9C0\C815\B41C \B0A0\C9DC \BC94\C704\B85C \CC28\D2B8\AC00 \D655\B300\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106027332549310297)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106031591327310301)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\C2DC\C791 \B0A0\C9DC \C5F4</em>\C5D0 \C785\B825\B41C \C5F4 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106027545087310297)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106031693607310301)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C <em>\C2DC\C791 \B0A0\C9DC \D56D\BAA9</em>\C758 \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106026794038310296)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC \C18C\C2A4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104931097383309419)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\D5A5\C774 \C6D0\D615\C778 \C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0 \CC28\D2B8\C758 \AC01\B3C4 \BC94\C704(\B3C4)\B97C \C785\B825\D569\B2C8\B2E4. \AC01\B3C4 \BC94\C704\B294 \C6D0\D615 \BC29\D5A5\C758 \C2E4\C81C \AC01\B3C4\C785\B2C8\B2E4. \C591\C218 \AC12\C740 \C2DC\ACC4 \BC29\D5A5\C758 \C2DC\C791 \AC01\B3C4\B97C \B098\D0C0\B0C5\B2C8\B2E4. \C74C\C218 \AC12\C740 \C2DC\ACC4 \BC18\B300 \BC29\D5A5\C758 \C2DC\C791 \AC01\B3C4\B97C \B098\D0C0\B0C5\B2C8\B2E4. \C6D0\D558\B294 \AC01\B3C4\B85C \C6D0 \AC8C\C774\C9C0\B97C \ADF8\B9B4 \C218 \C788\C73C\BA70, \C120\D0DD\D55C \AC01\B3C4\C5D0 \B530\B77C \BAA8\C591\C744 \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4. \AC8C\C774\C9C0 \BAA8\C591\C740 \B450 \AC00\C9C0 \C124\C815(<strong>\C2DC\C791 \AC01\B3C4</strong> \BC0F <strong>\AC01\B3C4 \BC94\C704</strong>)\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104930818421309419)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01\B3C4 \BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104930423644309419)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\D68D \C601\C5ED\C5D0 \C0C1\B300\C801\C778 \D45C\C2DC\AE30 \B450\AED8\C758 \BE44\C728\C744 \C9C0\C815\D569\B2C8\B2E4. \AE30\BCF8\AC12\C740 1\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104930360759309419)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\AE30 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104930543780309419)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\D5A5\C774 \C6D0\D615\C778 \C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0 \CC28\D2B8\C758 \B0B4\BD80 \BC18\ACBD(\AC8C\C774\C9C0 \C911\C2EC\C5D0\C11C \D45C\C2DC\AE30 \BC0F \AD6C\D68D \C601\C5ED \AC00\C7A5 \C548\CABD \BAA8\C11C\B9AC\AE4C\C9C0\C758 \AC70\B9AC\B85C \C815\C758\B428)\C744 \C9C0\C815\D569\B2C8\B2E4. \C801\D569\D55C \AC12\C740 \D37C\C13C\D2B8 \B610\B294 \BE44\C728(0~1)\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104930636983309419)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\BD80 \BC18\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104930072575309418)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1\D560 \C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0 \CC28\D2B8\C758 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104929783851309418)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.CIRCULAR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104929894468309418)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\D3C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104929937206309418)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104929625597309418)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104930210497309419)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0 \CC28\D2B8\C758 \AD6C\D68D \C601\C5ED\C744 \B80C\B354\B9C1\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104930173562309419)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\D68D \C601\C5ED \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105044454434309502)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104940692716309426)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0 \CC28\D2B8\C758 \AD6C\D68D \C601\C5ED\C5D0 \B300\D574 \D45C\C2DC\D560 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4. <code>&COLUMN_VALUE.</code> \B300\CCB4\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \C0C9\C0C1\C740 \CC28\D2B8\C5D0 \B300\D55C \C784\ACC4\AC12 \C0C9\C0C1\C774 \C815\C758\B418\C9C0 \C54A\C740 \ACBD\C6B0\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104940537035309426)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B9BC \C601\C5ED \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104930949013309419)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\D5A5\C774 \C6D0\D615\C778 \C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0 \CC28\D2B8\C758 \C2DC\C791 \AC01\B3C4(\B3C4)\B97C \C785\B825\D569\B2C8\B2E4. \C591\C218 \AC12\C740 \C2DC\ACC4 \BC29\D5A5\C758 \C2DC\C791 \AC01\B3C4\B97C \B098\D0C0\B0C5\B2C8\B2E4. \C74C\C218 \AC12\C740 \C2DC\ACC4 \BC18\B300 \BC29\D5A5\C758 \C2DC\C791 \AC01\B3C4\B97C \B098\D0C0\B0C5\B2C8\B2E4. \C6D0\D558\B294 \AC01\B3C4\B85C \C6D0 \AC8C\C774\C9C0\B97C \ADF8\B9B4 \C218 \C788\C73C\BA70, \C120\D0DD\D55C \AC01\B3C4\C5D0 \B530\B77C \BAA8\C591\C744 \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4. \AC8C\C774\C9C0 \BAA8\C591\C740 \B450 \AC00\C9C0 \C124\C815(<strong>\C2DC\C791 \AC01\B3C4</strong> \BC0F <strong>\AC01\B3C4 \BC94\C704</strong>)\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104930730357309419)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \AC01\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105815463683310120)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0 \AC00\B85C \ACA9\C790\C120\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105814755952310119)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\B85C \ADF8\B9AC\B4DC \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105488868743309851)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\CC28\D2B8\C5D0\C11C \B370\C774\D130 \D56D\BAA9 \C704\B85C \AC00\C838\AC08 \B54C \C801\C6A9\D560 \B3D9\C791\C744 \C9C0\C815\D569\B2C8\B2E4.<p/>'),
unistr('        \D604\C7AC \C704\B85C \AC00\C838\AC00\C9C0 \C54A\C740 \ACBD\C6B0 \BAA8\B4E0 \B370\C774\D130 \D56D\BAA9\C744 \D750\B9AC\AC8C \D45C\C2DC\D558\ACE0 \D604\C7AC \C704\B85C \AC00\C838\AC04 \B370\C774\D130 \D56D\BAA9\B9CC \AC15\C870 \D45C\C2DC\D558\B824\BA74 <strong>\C124\C815</strong>\C744 \C120\D0DD\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105488734372309851)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\B85C \AC00\C838\AC08 \B54C \D750\B9AC\AC8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106076560032310343)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \CD08\AE30 \D655\B300/\CD95\C18C\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106076625589310343)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106076788284310343)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\C74C\C5D0 \CC28\D2B8 \AD6C\D68D \C601\C5ED\C5D0 \B4E4\C5B4\AC08 \C218 \C788\B294 \CCAB\BC88\C9F8 \B370\C774\D130 \D3EC\C778\D2B8\C5D0 \B9DE\AC8C \D655\B300/\CD95\C18C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106076834968310343)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106076937787310343)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\C74C\C5D0 \CC28\D2B8 \AD6C\D68D \C601\C5ED\C5D0 \B4E4\C5B4\AC08 \C218 \C788\B294 \B9C8\C9C0\B9C9 \B370\C774\D130 \D3EC\C778\D2B8\C5D0 \B9DE\AC8C \D655\B300/\CD95\C18C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106077012490310344)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106077162148310344)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \D655\B300/\CD95\C18C\B97C \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106076484768310343)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \D655\B300/\CD95\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105462099223309829)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105204787983309625)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C0\C815\B41C \C18D\C131\C5D0 \B300\D574 \AE00\AF34\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105201716744309623)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105203312861309624)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \ACC4\C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105201936827309623)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'ko'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105201847623309623)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'ko'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105202027999309623)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'ko'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105202165718309623)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'ko'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105202387970309623)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'ko'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105202215926309623)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ko'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105202458119309623)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'ko'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105202576381309623)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'ko'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105202679435309624)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ko'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105202712498309624)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'ko'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105202802073309624)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'ko'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105203018774309624)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'ko'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105202989600309624)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ko'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105203182964309624)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'ko'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105203208362309624)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'ko'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105201475545309623)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \ACC4\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105203834924309625)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105204051429309625)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'ko'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105204102211309625)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'ko'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105204290369309625)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'ko'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105204373470309625)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'ko'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105204488116309625)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'ko'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105204574609309625)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'ko'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105204693565309625)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'ko'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105203935856309625)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'ko'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105201682715309623)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105203453311309624)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C2A4\D0C0\C77C\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105203669528309624)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C6B8\C784\AF34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105203588234309624)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105203793500309624)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\BE14\B9AC\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105201530357309623)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105012453509309479)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14\C744 \D30C\C774 \CC28\D2B8 \C870\AC01\C5D0 \D45C\C2DC\D560 \BC29\BC95\C744 \C9C0\C815\D569\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106056027342310324)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 - \BC31\BD84\C728( \AC12 )')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106056563837310324)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\B808\C774\BE14 - \BC31\BD84\C728( \AC12 ) \D615\C2DD\C73C\B85C \B808\C774\BE14, \AC12 \BC0F \BC31\BD84\C728 \C815\BCF4\AC00 \B808\C774\BE14\C5D0 \D45C\C2DC\B429\B2C8\B2E4(\C608: <strong>\BC84\ADF8 - 15%( 18 )</strong>).</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106056137619310324)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC31\BD84\C728( \AC12 )')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106056655746310325)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C120\D0DD\B41C \AC12 \C5F4 \B9E4\D551\C744 \AE30\BC18\C73C\B85C \B808\C774\BE14\C774 \C22B\C790 \AC12\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4(\C608: <strong>15%( 18 )</strong>).</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106055738738310324)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106056247122310324)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C120\D0DD\B41C \B808\C774\BE14 \C5F4 \B9E4\D551\C744 \AE30\BC18\C73C\B85C \B808\C774\BE14\C774 \CC28\D2B8 \C870\AC01\C5D0 \D45C\C2DC\B429\B2C8\B2E4(\C608: <strong>\BC84\ADF8</strong>).</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105400309117309772)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 - \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105400490304309772)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\B808\C774\BE14 - \AC12 \D615\C2DD\C73C\B85C \B808\C774\BE14 \BC0F \AC12 \C815\BCF4\AC00 \B808\C774\BE14\C5D0 \D45C\C2DC\B429\B2C8\B2E4(\C608: <strong>\BC84\ADF8 - 18</strong>).</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106055878742310324)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC31\BD84\C728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106056387017310324)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C120\D0DD\B41C \AC12 \C5F4 \B9E4\D551\C744 \AE30\BC18\C73C\B85C \B808\C774\BE14\C774 0%\C5D0\C11C 100% \C0AC\C774\C758 \AC12\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4. \AC12\C740 \CC28\D2B8\C5D0 \D45C\C2DC\B418\B294 \CD1D \AC12\C758 \BC31\BD84\C728\C785\B2C8\B2E4(\C608: <strong>15%</strong>).</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106055993704310324)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106056483246310324)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C120\D0DD\B41C \AC12 \C5F4 \B9E4\D551\C744 \AE30\BC18\C73C\B85C \B808\C774\BE14\C774 \C22B\C790 \AC12\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106055685085310324)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105461997893309829)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105198778112309620)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C0\C815\B41C \C18D\C131\C5D0 \B300\D574 \AE00\AF34\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105198337007309620)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105198432560309620)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \ACC4\C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105198927736309621)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'ko'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105198800078309620)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'ko'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105199008219309621)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'ko'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105199111720309621)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'ko'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105199312834309621)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'ko'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105199273758309621)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ko'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105199490030309621)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'ko'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105199583564309621)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'ko'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105199699673309621)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ko'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105199788631309621)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'ko'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105199871470309621)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'ko'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105200016775309621)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'ko'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105199968677309621)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ko'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105200145411309621)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'ko'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105200277138309622)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'ko'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105198016146309620)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \ACC4\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105198628773309620)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105200791386309622)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.10.D'
,p_message_language=>'ko'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105200836346309622)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.12.D'
,p_message_language=>'ko'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105200998978309622)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.14.D'
,p_message_language=>'ko'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105201030559309622)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.16.D'
,p_message_language=>'ko'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105201161476309622)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.18.D'
,p_message_language=>'ko'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105201218024309623)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.20.D'
,p_message_language=>'ko'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105201305317309623)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.22.D'
,p_message_language=>'ko'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105200672684309622)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.8.D'
,p_message_language=>'ko'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105198277131309620)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105198513039309620)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C2A4\D0C0\C77C\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105200475671309622)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C6B8\C784\AF34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105200396969309622)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105200525732309622)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\BE14\B9AC\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105198173333309620)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105048228399309505)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\CF64\B9C8\B85C \AD6C\BD84\B41C \C0C9\C0C1 \BAA9\B85D:</dt>'),
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
unistr('<dt>\B2E4\C74C\C744 \C0AC\C6A9\D558\C5EC \C0C9\C0C1\C744 \BC18\D658\D558\B294 \CF64\B9C8\B85C \AD6C\BD84\B41C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \BAA9\B85D:</dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code> \AD6C\BB38. \C608: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\B2E4\C74C\C744 \C0AC\C6A9\D558\C5EC \C0C9\C0C1 \AC12\C744 \BC18\D658\D558\B294 \CF64\B9C8\B85C \AD6C\BD84\B41C \C5F4 \BAA9\B85D:</dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code> \AD6C\BB38. \C608: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105048140458309505)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0 \CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\D560 \CC38\C870\C120\C744 \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\B2E4\C911 \CC38\C870\C120\C758 \ACBD\C6B0 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \C0AC\C6A9\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105047823444309504)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105048001674309505)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\CF64\B9C8\B85C \AD6C\BD84\B41C \C815\C801 \C22B\C790 \AC12 \BAA9\B85D:</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>\B2E4\C74C\C744 \C0AC\C6A9\D558\C5EC \C22B\C790 \AC12\C744 \BC18\D658\D558\B294 \CF64\B9C8\B85C \AD6C\BD84\B41C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \BAA9\B85D:</dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code> \AD6C\BB38. \C608: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\B2E4\C74C\C744 \C0AC\C6A9\D558\C5EC \C22B\C790 \AC12\C744 \BC18\D658\D558\B294 \CF64\B9C8\B85C \AD6C\BD84\B41C \C5F4 \BAA9\B85D:</dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code> \AD6C\BB38. \C608: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105047978758309504)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0 \CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\D560 \CC38\C870\C120\C744 \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C22B\C790\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\B2E4\C911 \CC38\C870\C120\C758 \ACBD\C6B0 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \C0AC\C6A9\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105047714177309504)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105815229946310120)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \D589 \B808\C774\BE14\C744 \B80C\B354\B9C1\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105814967091310119)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \CD95 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105500350768309861)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105500297795309861)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \CC28\D2B8 \ACC4\C5F4\ACFC \C5F0\AD00\B41C \B370\C774\D130 \D56D\BAA9\C5D0 \B300\D574 \D45C\C2DC\D560 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4. <code>&COLUMN_VALUE.</code> \B300\CCB4\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0 \CC28\D2B8\C758 \ACBD\C6B0 \C774 \C0C9\C0C1\C774 \D45C\C2DC\AE30\C5D0 \C801\C6A9\B429\B2C8\B2E4. \B2E8, \C784\ACC4\AC12\C774 \C815\C758\B418\C5C8\C73C\BA70 <strong>\C784\ACC4\AC12 \D45C\C2DC</strong> \C18D\C131\C774 <strong>\D45C\C2DC\AE30\C5D0</strong>\B85C \C124\C815\B41C \ACBD\C6B0\C5D0\B294 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105500109354309861)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105426101351309799)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105425995753309798)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0C1\C790 \ADF8\B9BC \CC28\D2B8 \ACC4\C5F4\C758 q2 \C138\ADF8\BA3C\D2B8\C5D0 \B300\D574 \D45C\C2DC\D560 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4. <code>&COLUMN_VALUE.</code> \B300\CCB4\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105425707586309798)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Q2 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105426203477309799)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105426070802309799)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0C1\C790 \ADF8\B9BC \CC28\D2B8 \ACC4\C5F4\C758 q3 \C138\ADF8\BA3C\D2B8\C5D0 \B300\D574 \D45C\C2DC\D560 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4. <code>&COLUMN_VALUE.</code> \B300\CCB4\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105425895356309798)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Q3 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105421022750309794)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \ACC4\C5F4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105407955760309778)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.AREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105408011064309778)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BAR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105407860887309778)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BOXPLOT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C790 \ADF8\B9BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105408122178309778)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105408233303309778)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINEWITHAREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\ACFC \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105408383482309778)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105522302359309880)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COLUMN_MAPPING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C5F4 \C720\D615 \C5F4 \B9E4\D551')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105522556470309880)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \ACC4\C5F4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4. \B610\D55C \B3D9\C77C\D55C \B370\C774\D130 \D50C\B86F\C5D0\C11C \C5EC\B7EC \C720\D615\C758 \ACC4\C5F4\C774 \C870\D569\B41C \CC28\D2B8\B3C4 \C0DD\C131\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105522635054309880)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105523156794309880)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREARANGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105522743572309880)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BAR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105523071477309880)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BARRANGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300 \BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105522818620309880)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105522912140309880)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINEWITHAREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\ACFC \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105522479878309880)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105523773547309881)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \ACC4\C5F4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105523808487309881)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105524445021309881)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREARANGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105523992709309881)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BAR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105524330555309881)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BARRANGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300 \BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105524243041309881)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BUBBLE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105524041208309881)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105811571594310117)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINEWITHAREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\ACFC \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105524144586309881)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.SCATTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0B0\D3EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105523632571309881)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105524661924309882)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \ACC4\C5F4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105524704724309882)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105524854632309882)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREARANGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105524916192309882)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.LINE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105524516673309881)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105523387428309880)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \ACC4\C5F4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105523530067309881)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.AREARANGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105523400166309881)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.BARRANGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300 \BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105523239618309880)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105505408888309865)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \CD95\C774 \B80C\B354\B9C1\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105505398085309865)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105046733739309504)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B3C4\AD6C \C124\BA85\C5D0 \AE30\C900 \C815\BCF4\B97C \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105046151697309503)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C900 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105046597323309503)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B3C4\AD6C \C124\BA85\C5D0 \C885\B8CC \B0A0\C9DC\B97C \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105045936244309503)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105046627744309503)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B3C4\AD6C \C124\BA85\C5D0 \C9C4\D589\B960\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105046027893309503)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C4\D589\B960 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105046274181309503)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B3C4\AD6C \C124\BA85\C5D0 \D589 \C815\BCF4\B97C \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105045647619309503)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105046469153309503)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B3C4\AD6C \C124\BA85\C5D0 \C2DC\C791 \B0A0\C9DC\B97C \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105045894077309503)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104931297916309419)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \AC12\C774 \B80C\B354\B9C1\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104931124577309419)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105046303431309503)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B3C4\AD6C \C124\BA85\C5D0 \B808\C774\BE14\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105045756920309503)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105493692242309854)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \B3C4\AD6C \C124\BA85\C774 \B80C\B354\B9C1\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105493560629309854)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105494244922309855)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B3C4\AD6C \C124\BA85\C5D0 \AC12\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \AC12\C740 \CC28\D2B8 \C9C8\C758\C5D0\C11C \D30C\C0DD\B418\ACE0 \CC28\D2B8 \B370\C774\D130 \C606\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105494189099309855)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105828982916310130)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \AC12 \B610\B294 \B808\C774\BE14\C744 \AE30\BC18\C73C\B85C \B2E4\C911 \ACC4\C5F4 \CC28\D2B8\C758 \B370\C774\D130\C5D0 \B300\D55C \CC28\D2B8 \C815\B82C \C21C\C11C\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105813509159310118)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 - \C624\B984\CC28\C21C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105813925908310119)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815\D558\C5EC X\CD95 \B808\C774\BE14\C744 \AE30\BC18\C73C\B85C \C624\B984\CC28\C21C\C73C\B85C \CC28\D2B8\B97C \C815\B82C\D569\B2C8\B2E4. \AE30\BCF8 \C815\B82C \C21C\C11C\C785\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105813698850310118)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 - \B0B4\B9BC\CC28\C21C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105814014956310119)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815\D558\C5EC X\CD95 \B808\C774\BE14\C744 \AE30\BC18\C73C\B85C \B0B4\B9BC\CC28\C21C\C73C\B85C \CC28\D2B8\B97C \C815\B82C\D569\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105813317047310118)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 - \C624\B984\CC28\C21C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105813754950310118)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815\D558\C5EC \AC12\C744 \AE30\BC18\C73C\B85C \C624\B984\CC28\C21C(1, 2, 3, ...)\C73C\B85C \CC28\D2B8\B97C \C815\B82C\D569\B2C8\B2E4. \C774 \C124\C815\C740 \D30C\C774 \CC28\D2B8, \ACC4\C5F4\C774 \D558\B098\C778 \B9C9\B300/\C120/\C601\C5ED \CC28\D2B8 \B610\B294 \B204\C801 \B9C9\B300/\C601\C5ED \CC28\D2B8\C5D0\B9CC \C0AC\C6A9\B418\C5B4\C57C \D569\B2C8\B2E4. \ACC4\CE35\C801 \ADF8\B8F9 \CD95\C744 \C0AC\C6A9\D558\B294 \ACBD\C6B0 \C815\B82C\C774 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105813422996310118)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 - \B0B4\B9BC\CC28\C21C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105813872427310118)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815\D558\C5EC \AC12\C744 \AE30\BC18\C73C\B85C \B0B4\B9BC\CC28\C21C(10, 9, 8, ...)\C73C\B85C \CC28\D2B8\B97C \C815\B82C\D569\B2C8\B2E4. \C774 \C124\C815\C740 \D30C\C774 \CC28\D2B8, \ACC4\C5F4\C774 \D558\B098\C778 \B9C9\B300/\C120/\C601\C5ED \CC28\D2B8 \B610\B294 \B204\C801 \B9C9\B300/\C601\C5ED \CC28\D2B8\C5D0\B9CC \C0AC\C6A9\B418\C5B4\C57C \D569\B2C8\B2E4. \ACC4\CE35\C801 \ADF8\B8F9 \CD95\C744 \C0AC\C6A9\D558\B294 \ACBD\C6B0 \C815\B82C\C774 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105813205685310118)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \C21C\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105658763847309993)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105658619333309993)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C0\C815\B41C \C18D\C131\C5D0 \B300\D574 \AE00\AF34\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105658262361309993)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105658388263309993)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \ACC4\C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105660030995309994)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'ko'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105659924669309994)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'ko'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105660158152309994)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'ko'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105660276312309994)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'ko'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105660465790309995)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'ko'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105660358486309994)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ko'
,p_message_text=>'Courier'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105660598358309995)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'ko'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105660651120309995)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'ko'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105660704183309995)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ko'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105660895222309995)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'ko'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105660960396309995)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'ko'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105661150523309995)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'ko'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105661047605309995)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ko'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105661275195309995)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'ko'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105661368424309995)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'ko'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105657916706309992)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \ACC4\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105658513176309993)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105658935738309993)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.10.D'
,p_message_language=>'ko'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105659060131309993)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.12.D'
,p_message_language=>'ko'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105659183007309993)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.14.D'
,p_message_language=>'ko'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105659297461309994)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.16.D'
,p_message_language=>'ko'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105659354506309994)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.18.D'
,p_message_language=>'ko'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105659484111309994)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.20.D'
,p_message_language=>'ko'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105659550810309994)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.22.D'
,p_message_language=>'ko'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105658806967309993)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.8.D'
,p_message_language=>'ko'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105658126421309993)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105658418418309993)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C2A4\D0C0\C77C\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105659755225309994)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C6B8\C784\AF34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105659652068309994)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105659821525309994)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\BE14\B9AC\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105658096506309992)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105822631101310125)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \C791\C5C5 \B808\C774\BE14\C758 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105822947443310125)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B05D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105823309850310126)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \C791\C5C5 \D45C\C2DC\C904 \B9E8 \B05D\C5D0 \C791\C5C5 \B808\C774\BE14\C774 \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105823047471310125)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C548\CABD \AC00\C6B4\B370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105823435178310126)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \C791\C5C5 \D45C\C2DC\C904 \C548\CABD \AC00\C6B4\B370\C5D0 \C791\C5C5 \B808\C774\BE14\C774 \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105823291247310126)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C548\CABD \B05D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105823610914310126)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \C791\C5C5 \D45C\C2DC\C904 \C548\CABD \B05D\C5D0 \C791\C5C5 \B808\C774\BE14\C774 \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105823196010310126)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C548\CABD \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105823516904310126)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \C791\C5C5 \D45C\C2DC\C904 \C548\CABD \C55E\C5D0 \C791\C5C5 \B808\C774\BE14\C774 \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105822779757310125)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105822860794310125)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D2B8 \CC28\D2B8\C5D0\C11C \C791\C5C5 \D45C\C2DC\C904 \B9E8 \C55E\C5D0 \C791\C5C5 \B808\C774\BE14\C774 \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105822586427310125)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \B808\C774\BE14 \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104959542131309440)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\CF64\B9C8\B85C \AD6C\BD84\B41C \C0C9\C0C1 \BAA9\B85D:</dt>'),
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
unistr('<dt>\B2E4\C74C\C744 \C0AC\C6A9\D558\C5EC \C0C9\C0C1\C744 \BC18\D658\D558\B294 \CF64\B9C8\B85C \AD6C\BD84\B41C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \BAA9\B85D:</dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code> \AD6C\BB38. \C608: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\B2E4\C74C\C744 \C0AC\C6A9\D558\C5EC \C0C9\C0C1 \AC12\C744 \BC18\D658\D558\B294 \CF64\B9C8\B85C \AD6C\BD84\B41C \C5F4 \BAA9\B85D:</dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code> \AD6C\BB38. \C608: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104959415069309440)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0 \CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\D560 \C784\ACC4\AC12\C758 \C0C1\D55C\C744 \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\B2E4\C911 \C784\ACC4\AC12\C758 \ACBD\C6B0 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \C0AC\C6A9\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104940826472309426)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105044505084309502)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0 \CC28\D2B8\C5D0 \C784\ACC4\AC12\C744 \D45C\C2DC\D560 \BC29\BC95\C744 \C9C0\C815\D569\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104958991071309439)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104959039044309440)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>\C784\ACC4\AC12</strong> \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \C815\C758\B41C \BAA8\B4E0 \C784\ACC4\AC12\C774 \CC28\D2B8\C758 \AD6C\D68D \C601\C5ED\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104959231721309440)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C784\ACC4\AC12\B9CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104959323615309440)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>\C784\ACC4\AC12</strong> \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \C815\C758\B41C \D604\C7AC \C784\ACC4\AC12\C774 \CC28\D2B8\C758 \AD6C\D68D \C601\C5ED\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104959175591309440)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\AE30\C5D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105044648646309502)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>\C784\ACC4\AC12</strong> \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \C815\C758\B41C \D604\C7AC \C784\ACC4\AC12\C774 \CC28\D2B8\C758 \D45C\C2DC\AE30\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104958809029309439)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104958740041309439)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\CF64\B9C8\B85C \AD6C\BD84\B41C \C815\C801 \C22B\C790 \AC12 \BAA9\B85D:</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>\B2E4\C74C\C744 \C0AC\C6A9\D558\C5EC \C22B\C790 \AC12\C744 \BC18\D658\D558\B294 \CF64\B9C8\B85C \AD6C\BD84\B41C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \BAA9\B85D:</dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code> \AD6C\BB38. \C608: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\B2E4\C74C\C744 \C0AC\C6A9\D558\C5EC \C22B\C790 \AC12\C744 \BC18\D658\D558\B294 \CF64\B9C8\B85C \AD6C\BD84\B41C \C5F4 \BAA9\B85D:</dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code> \AD6C\BB38. \C608: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104940742744309426)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C0C1\D0DC \CE21\C815\AE30 \AC8C\C774\C9C0 \CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\D560 \C784\ACC4\AC12\C758 \C0C1\D55C\C744 \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C22B\C790\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\B2E4\C911 \C784\ACC4\AC12\C758 \ACBD\C6B0 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \C0AC\C6A9\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104940434357309426)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105461884635309829)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105197940806309620)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C0\C815\B41C \C18D\C131\C5D0 \B300\D574 \AE00\AF34\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105194917882309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105196583567309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \ACC4\C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105195145155309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'ko'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105195014480309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'ko'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105195220892309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'ko'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105195326828309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'ko'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105195535315309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'ko'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105195422999309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ko'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105195607409309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'ko'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105195708954309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'ko'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105195812058309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ko'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105195940028309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'ko'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105196036637309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'ko'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105196234365309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'ko'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105196194367309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ko'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105196335119309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'ko'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105196464092309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'ko'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105194641476309617)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \ACC4\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105197027412309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105197246322309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'ko'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105197325470309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'ko'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105197490659309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'ko'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105197571043309620)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'ko'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105197668568309620)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'ko'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105197723763309620)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'ko'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105197871227309620)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'ko'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105197130540309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'ko'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105194882071309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105196625585309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C2A4\D0C0\C77C\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105196851628309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C6B8\C784\AF34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105196722753309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105196955780309619)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\BE14\B9AC\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105194700399309618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105489020727309851)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0 \D45C\C2DC\D560 \C2DC\AC04 \CD95 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C124\C815\C740 \CC28\D2B8 \B370\C774\D130\B97C \C790\B3D9\C73C\B85C \C2DC\AC04\C21C\C73C\B85C \B80C\B354\B9C1\D558\BA70, \B370\C774\D130\B97C \C5ED\C21C\C73C\B85C \B80C\B354\B9C1\D574\C57C \D558\B294 \ACBD\C6B0 \C0AC\C6A9\D558\BA74 \C548\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105489145295309851)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105618052744309956)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1\B418\B294 \B370\C774\D130\B97C \AE30\C900\C73C\B85C \CC28\D2B8\C5D0 \B300\D55C Oracle JET \C815\C758 \AE30\BCF8 \C2DC\AC04 \CD95 \C124\C815\C744 \C801\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105489208423309851)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105618114069309957)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0 \C2DC\AC04 \CD95 \C720\D615 \C124\C815\C744 \C801\C6A9\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105489343877309851)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105618236915309957)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0 \C2DC\AC04 \CD95 \C720\D615 \C124\C815\C744 \C801\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105489438497309851)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D63C\D569 \BE48\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105528333868309885)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04 \AC12\C774 \D63C\D569 \BE48\B3C4\C758 \CC28\D2B8 \CD95\C5D0 \D45C\C2DC\B418\C5C8\C2B5\B2C8\B2E4. \B370\C774\D130\C758 \C2DC\AC04 \AC12\C740 \B2E4\B97C \C218 \C788\C73C\BBC0\B85C \B204\C801\C740 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105528424660309885)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC74\B108\B6F0\AE30 \AC04\ACA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105528560428309885)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \CD95\C5D0 \D45C\C2DC\B41C \C2DC\AC04 \AC12\C740 \B370\C774\D130\C5D0 \C874\C7AC\D560 \C218 \C788\B294 \C2DC\AC04 \AC04\ACA9\ACFC \C0C1\AD00 \C5C6\C774 \C77C\BC18\C801\C778 \AC04\ACA9\C73C\B85C \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105488999416309851)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04 \CD95 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105461757360309829)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105194166615309617)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C0\C815\B41C \C18D\C131\C5D0 \B300\D574 \AE00\AF34\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105194082215309617)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105193728621309617)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \ACC4\C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105192316240309616)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'ko'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105192256295309616)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'ko'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105192405332309616)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'ko'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105192591340309616)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'ko'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105192773753309616)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'ko'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105192651690309616)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ko'
,p_message_text=>'Courier'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105192872367309616)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'ko'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105192979912309616)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'ko'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105193049329309616)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ko'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105193160216309616)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'ko'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105193289291309616)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'ko'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105193450015309617)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'ko'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105193345004309616)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ko'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105193516507309617)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'ko'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105193690536309617)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'ko'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105190804444309615)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \ACC4\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105193950361309617)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105191515984309615)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.10.D'
,p_message_language=>'ko'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105191662014309615)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.12.D'
,p_message_language=>'ko'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105191792070309615)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.14.D'
,p_message_language=>'ko'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105191879078309615)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.16.D'
,p_message_language=>'ko'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105191944093309615)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.18.D'
,p_message_language=>'ko'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105192079234309615)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.20.D'
,p_message_language=>'ko'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105192194029309616)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.22.D'
,p_message_language=>'ko'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105191459447309615)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.8.D'
,p_message_language=>'ko'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105191055492309615)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105193806655309617)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C2A4\D0C0\C77C\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105191235252309615)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C6B8\C784\AF34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105191171763309615)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105191331486309615)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\BE14\B9AC\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105190982898309615)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105815396838310120)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0 \C138\B85C \ACA9\C790\C120\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105814867527310119)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\B85C \ADF8\B9AC\B4DC \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105529365791309886)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CC28\D2B8\C758 \D655\B300/\CD95\C18C \BC0F \C2A4\D06C\B864 \B3D9\C791\C744 \C9C0\C815\D569\B2C8\B2E4. <strong>\C2E4\C2DC\AC04</strong> \B3D9\C791\C740 \CC28\D2B8\AC00 \C870\C791\B428\C5D0 \B530\B77C \C790\B3D9\C73C\B85C \C5C5\B370\C774\D2B8\B428\C744 \C758\BBF8\D569\B2C8\B2E4.'),
unistr('        \BC18\BA74 <strong>\C9C0\C5F0</strong>\C740 \D655\B300/\CD95\C18C/\C2A4\D06C\B864 \C791\C5C5\C774 \C644\B8CC\B420 \B54C\AE4C\C9C0 \C5C5\B370\C774\D2B8\AC00 \B300\AE30\B428\C744 \C758\BBF8\D569\B2C8\B2E4. <strong>\C2E4\C2DC\AC04</strong> \D655\B300/\CD95\C18C \BC0F \C2A4\D06C\B864\C740 \CD5C\C0C1\C758 \C77C\BC18 \C0AC\C6A9\C790 \ACBD\D5D8\C744 \C81C\ACF5\D558\C9C0\B9CC'),
unistr('        \D070 \B370\C774\D130\C138\D2B8\C5D0 \B300\D55C \B80C\B354\B9C1 \C131\B2A5\C774\B098 \C720\C6A9\C131 \B610\B294 \B290\B9B0 \D074\B77C\C774\C5B8\D2B8 \D658\ACBD\C5D0 \B300\D574\C11C\B294 \BCF4\C7A5\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C131\B2A5\C774 \BB38\C81C\C778 \ACBD\C6B0 <strong>\C9C0\C5F0</strong> \D655\B300/\CD95\C18C \BC0F \C2A4\D06C\B864\C744 \B300\C2E0 \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105489671412309851)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\CC28\D2B8\C758 \D655\B300/\CD95\C18C \BC0F \C2A4\D06C\B864 \B3D9\C791\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('        \D655\B300/\CD95\C18C \BC0F \C2A4\D06C\B864\C744 \D1B5\D574 \C77C\BC18 \C0AC\C6A9\C790\B294 \AD6C\D68D \C601\C5ED\C5D0\C11C \B04C\AE30, \B9C8\C6B0\C2A4 \D720 \C0AC\C6A9 \B610\B294 \B450 \C190\AC00\B77D \BAA8\C73C\AE30\C640 \AC19\C740 \C81C\C2A4\CC98\B97C \C0AC\C6A9\D558\C5EC \D45C\C2DC\B41C \AC12\C758 \D06C\AE30\B97C \C870\C815\D558\ACE0 \CC28\D2B8 \B0B4\C5D0\C11C \C774\B3D9\D558\C5EC \B2E4\B978 \CC28\D2B8 \AC12\C744 \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105489864451309851)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C5F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105569015270309917)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\B300/\CD95\C18C/\C2A4\D06C\B864 \C791\C5C5\C774 \C644\B8CC\B420 \B54C\AE4C\C9C0 \B370\C774\D130 \D45C\C2DC\C5D0 \B300\D55C \BCC0\ACBD\C0AC\D56D\C774 \B300\AE30\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105489992148309851)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C5F0\B41C \C2A4\D06C\B864\B9CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105569144766309917)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B864 \C791\C5C5\C774 \C644\B8CC\B420 \B54C\AE4C\C9C0 \B370\C774\D130 \D45C\C2DC\C5D0 \B300\D55C \BCC0\ACBD\C0AC\D56D\C774 \B300\AE30\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105490006890309852)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105569287797309917)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C2E4\C2DC\AC04 \B3D9\C791\C740 \CC28\D2B8\AC00 \C870\C791\B428\C5D0 \B530\B77C \ACC4\C18D\C801\C73C\B85C \C5C5\B370\C774\D2B8\B428\C744 \C758\BBF8\D569\B2C8\B2E4.'),
unistr('        \D070 \B370\C774\D130\C138\D2B8 \B610\B294 \B290\B9B0 \D074\B77C\C774\C5B8\D2B8 \D658\ACBD\C758 \ACBD\C6B0 <strong>\C9C0\C5F0</strong>\C744 \C120\D0DD\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105490147227309852)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\C2DC\AC04 \C2A4\D06C\B864\B9CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105569373641309918)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C2E4\C2DC\AC04 \C2A4\D06C\B864\B9CC \B3D9\C791\C740 \CC28\D2B8\AC00 \C2A4\D06C\B864\B428\C5D0 \B530\B77C \ACC4\C18D\C801\C73C\B85C \C5C5\B370\C774\D2B8\B428\C744 \C758\BBF8\D569\B2C8\B2E4.'),
unistr('        \D070 \B370\C774\D130\C138\D2B8 \B610\B294 \B290\B9B0 \D074\B77C\C774\C5B8\D2B8 \D658\ACBD\C758 \ACBD\C6B0 <strong>\C9C0\C5F0\B41C \C2A4\D06C\B864\B9CC</strong>\C744 \C120\D0DD\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105489769806309851)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105568903670309917)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\B300/\CD95\C18C \BC0F \C2A4\D06C\B864\C774 \CC28\D2B8\C5D0 \B300\D574 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105489525752309851)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\B300/\CD95\C18C \BC0F \C2A4\D06C\B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106033890792310303)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \D655\B300/\CD95\C18C \BC29\D5A5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106033965593310303)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C591\CABD \CD95')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106034013120310303)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('x\CD95\ACFC y\CD95 \BC29\D5A5\C73C\B85C \BAA8\B450 \D655\B300/\CD95\C18C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106034130129310304)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.D'
,p_message_language=>'ko'
,p_message_text=>unistr('X\CD95')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106034246105310304)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('x\CD95 \BC29\D5A5\C73C\B85C\B9CC \D655\B300/\CD95\C18C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106034315607310304)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('Y\CD95')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106034404392310304)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('y\CD95 \BC29\D5A5\C73C\B85C\B9CC \D655\B300/\CD95\C18C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106033769118310303)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\B300/\CD95\C18C \BC29\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105818002731310122)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \C77C \B2E8\C704\B85C \D655\B300/\CD95\C18C\B97C \D5C8\C6A9\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105816868608310121)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105817936641310122)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \C2DC \B2E8\C704\B85C \D655\B300/\CD95\C18C\B97C \D5C8\C6A9\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105816547586310121)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105817852473310122)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \BD84 \B2E8\C704\B85C \D655\B300/\CD95\C18C\B97C \D5C8\C6A9\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105816460308310120)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105818200299310122)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \C6D4 \B2E8\C704\B85C \D655\B300/\CD95\C18C\B97C \D5C8\C6A9\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105817244358310121)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105818340905310122)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \BD84\AE30 \B2E8\C704\B85C \D655\B300/\CD95\C18C\B97C \D5C8\C6A9\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105817445874310121)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105817737818310121)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \CD08 \B2E8\C704\B85C \D655\B300/\CD95\C18C\B97C \D5C8\C6A9\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105816139163310120)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105818187521310122)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \C8FC \B2E8\C704\B85C \D655\B300/\CD95\C18C\B97C \D5C8\C6A9\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105817089600310121)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105818460513310122)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \C5F0\B3C4 \B2E8\C704\B85C \D655\B300/\CD95\C18C\B97C \D5C8\C6A9\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105817655183310121)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105621603141309960)
,p_name=>'PE.PROPERTY.JS_CONDITION.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C774 \C2E4\D589\B418\B294\C9C0 \C5EC\BD80\B97C \C81C\C5B4\D558\B824\BA74 \D074\B77C\C774\C5B8\D2B8\CE21 \C870\AC74\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105216787990309634)
,p_name=>'PE.PROPERTY.JS_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('True \B610\B294 False \C791\C5C5\C774 \C2E4\D589\B418\B294\C9C0 \C5EC\BD80\B97C \C81C\C5B4\D560 \D074\B77C\C774\C5B8\D2B8\CE21 \C870\AC74\C744 \C9C0\C815\D569\B2C8\B2E4. \C870\AC74\C774'),
unistr('                                  True\B85C \D3C9\AC00\B418\BA74 True \C791\C5C5\C774 \C2E4\D589\B418\ACE0, \C870\AC74\C774 False\B85C \D3C9\AC00\B418\BA74 False \C791\C5C5\C774 \C2E4\D589\B429\B2C8\B2E4.'),
unistr('                                  \C870\AC74\C744 \C9C0\C815\D558\C9C0 \C54A\C740 \ACBD\C6B0 True \C791\C5C5\B9CC \C2E4\D589\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105727817796310054)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106084580648310351)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\ACFC \AC19\C740\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105728065681310054)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 > \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106084710336310351)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\BCF4\B2E4 \D070\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105728194466310054)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 >= \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106084829325310351)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\BCF4\B2E4 \D06C\AC70\B098 \AC19\C740\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105728694358310054)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \BAA9\B85D\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106085303447310351)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\BAA9\B85D</em>\C5D0 \C788\B294\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105728850158310054)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106085576832310352)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C JavaScript \D45C\D604\C2DD\C744 \D3C9\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105728214469310054)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 < \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106084925469310351)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\BCF4\B2E4 \C791\C740\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105728346219310054)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 <= \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106085070246310351)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\BCF4\B2E4 \C791\AC70\B098 \AC19\C740\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105727963963310054)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106084624962310351)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\ACFC \AC19\C9C0 \C54A\C740\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105728703021310054)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \BAA9\B85D\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106085429657310351)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\BAA9\B85D</em>\C5D0 \C5C6\B294\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105728562457310054)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106085252487310351)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C774 \BE44\C5B4 \C788\C9C0 \C54A\C740\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105728487633310054)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \B110\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106085182105310351)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C774 \BE44\C5B4 \C788\B294\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105216691757309634)
,p_name=>'PE.PROPERTY.JS_CONDITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106085958596310352)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C870\AC74\C5D0 \C0AC\C6A9\B418\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \B300\BD80\BD84\C758 \ACBD\C6B0 \C704\C758 <em>\C2DC\AE30 \C5F4</em>\C5D0\C11C \C9C0\C815\D55C \C5F4\C774\BBC0\B85C,'),
unistr('\AE30\BCF8\C801\C73C\B85C \C774 \C5F4\B85C \C9C0\C815\B429\B2C8\B2E4. \D558\C9C0\B9CC \B2E4\B978 \C5F4\C758 \C870\AC74\C744 \AE30\BC18\C73C\B85C \D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, \B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0\C11C EMP \D14C\C774\BE14\C744 \AE30\BC18\C73C\B85C \D560 \B54C <code>SAL</code>\C774 \BCC0\ACBD\B420 \B54C\B9C8\B2E4'),
unistr('<code>JOB</code>\C774 <em>SALESMAN</em>\ACFC \AC19\C740 \ACBD\C6B0\C5D0 \D55C\D574 \B3D9\C801 \C791\C5C5\C744 \C2E4\D589\D558\B824\BA74 \C774 \C18D\C131\C744 <code>JOB</code>\C73C\B85C \BCC0\ACBD\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106080530710310347)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106087283948310353)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\D56D\BAA9</em> \B610\B294 <em>\C5F4</em>\C774 \C774 \C870\AC74\C5D0\C11C \C0AC\C6A9\B418\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106076086938310343)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106075947289310343)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106075861969310342)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105621782201309960)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \C870\AC74\C5D0 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105621561784309959)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \C870\AC74\C5D0 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106086045464310352)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C870\AC74\C5D0 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \B300\BD80\BD84\C758 \ACBD\C6B0 \C704\C758 <em>\C2DC\AE30 \D56D\BAA9</em>\C5D0\C11C \C9C0\C815\D55C \D56D\BAA9\C774\BBC0\B85C,'),
unistr('\AE30\BCF8\C801\C73C\B85C \C774 \D56D\BAA9\C73C\B85C \C9C0\C815\B429\B2C8\B2E4. \D558\C9C0\B9CC \B2E4\B978 \D398\C774\C9C0 \D56D\BAA9\C758 \C870\AC74\C744 \AE30\BC18\C73C\B85C \D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, \D3FC\C5D0\C11C EMP \D14C\C774\BE14\C744 \AE30\BC18\C73C\B85C \D560 \B54C <code>P2_SAL</code>\C774 \BCC0\ACBD\B420 \B54C\B9C8\B2E4'),
unistr('<code>P2_JOB</code>\C774 <em>SALESMAN</em>\ACFC \AC19\C740 \ACBD\C6B0\C5D0 \D55C\D574 \B3D9\C801 \C791\C5C5\C744 \C2E4\D589\D558\B824\BA74 \C774 \C18D\C131\C744 <code>P2_JOB</code>\C73C\B85C \BCC0\ACBD\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106076165475310343)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106085859933310352)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106080419025310347)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105621829341309960)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C774 \C2E4\D589\B418\B294\C9C0 \C5EC\BD80\B97C \C81C\C5B4\D558\B824\BA74 \D074\B77C\C774\C5B8\D2B8\CE21 \C870\AC74\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106080796451310347)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('True \B610\B294 False \C791\C5C5\C774 \C2E4\D589\B418\B294\C9C0 \C5EC\BD80\B97C \C81C\C5B4\D560 \D074\B77C\C774\C5B8\D2B8\CE21 \C870\AC74\C744 \C9C0\C815\D569\B2C8\B2E4. \C870\AC74\C774'),
unistr('                                  True\B85C \D3C9\AC00\B418\BA74 True \C791\C5C5\C774 \C2E4\D589\B418\ACE0, \C870\AC74\C774 False\B85C \D3C9\AC00\B418\BA74 False \C791\C5C5\C774 \C2E4\D589\B429\B2C8\B2E4.'),
unistr('                                  \C870\AC74\C744 \C9C0\C815\D558\C9C0 \C54A\C740 \ACBD\C6B0 True \C791\C5C5\B9CC \C2E4\D589\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106080806080310347)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9/\C5F4 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106086124648310352)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em> \B610\B294 <em>\C5F4</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\ACFC \AC19\C740\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106081007230310347)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9/\C5F4 > \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106086342800310352)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em> \B610\B294 <em>\C5F4</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\BCF4\B2E4 \D070\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106081123393310348)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9/\C5F4 >= \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106086455315310352)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em> \B610\B294 <em>\C5F4</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\BCF4\B2E4 \D06C\AC70\B098 \AC19\C740\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106081666338310348)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9/\C5F4\C774 \BAA9\B85D\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106086942212310353)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em> \B610\B294 <em>\C5F4</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\BAA9\B85D</em>\C5D0 \C788\B294\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106081882355310348)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106087189904310353)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C JavaScript \D45C\D604\C2DD\C744 \D3C9\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106081297352310348)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9/\C5F4 < \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106086536480310353)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em> \B610\B294 <em>\C5F4</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\BCF4\B2E4 \C791\C740\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106081359634310348)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9/\C5F4 <= \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106086606644310353)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em> \B610\B294 <em>\C5F4</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\BCF4\B2E4 \C791\AC70\B098 \AC19\C740\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106080997319310347)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9/\C5F4 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106086227380310352)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em> \B610\B294 <em>\C5F4</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\AC12</em>\ACFC \AC19\C9C0 \C54A\C740\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106081754642310348)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9/\C5F4\C774 \BAA9\B85D\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106087043881310353)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em> \B610\B294 <em>\C5F4</em>\C758 \AC12\C774 \C9C0\C815\B41C <em>\BAA9\B85D</em>\C5D0 \C5C6\B294\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106081509347310348)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9/\C5F4\C774 \B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106086861751310353)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em> \B610\B294 <em>\C5F4</em>\C774 \BE44\C5B4 \C788\C9C0 \C54A\C740\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106081412625310348)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9/\C5F4\C774 \B110\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106086734664310353)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em> \B610\B294 <em>\C5F4</em>\C774 \BE44\C5B4 \C788\B294\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106080652152310347)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105621497482309959)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C870\AC74\C5D0 \B300\D574 \D3C9\AC00\D560 JavaScript \D45C\D604\C2DD\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C774 \CF54\B4DC\B294 \B2E4\C74C \B3D9\C801 \C791\C5C5 \AD00\B828 \C18D\C131\C5D0 \B300\D55C \C561\C138\C2A4 \AD8C\D55C\C744 \AC16\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>\B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D55C \C694\C18C\C758 DOM \AC1D\CCB4\C5D0 \B300\D55C \CC38\C870\C785\B2C8\B2E4.</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>\C774\BCA4\D2B8\B97C \D2B8\B9AC\AC70\D55C \C774\BCA4\D2B8 \AC1D\CCB4\C785\B2C8\B2E4. \CC38\ACE0: \B85C\B4DC \C2DC \C774 \AC12\C740 ''load''\C640 \B3D9\C77C\D569\B2C8\B2E4.</dd>'),
'  <dt>this.data</dt>',
unistr('    <dd>\C774\BCA4\D2B8 \CC98\B9AC\AE30\C5D0\C11C \C804\B2EC\B420 \C218 \C788\B294 \C120\D0DD\C801\C778 \CD94\AC00 \B370\C774\D130\C785\B2C8\B2E4.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105621302749309959)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106082411331310349)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C870\AC74\C5D0 \B300\D574 \D3C9\AC00\D560 JavaScript \D45C\D604\C2DD\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C774 \CF54\B4DC\B294 \B2E4\C74C \B3D9\C801 \C791\C5C5 \AD00\B828 \C18D\C131\C5D0 \B300\D55C \C561\C138\C2A4 \AD8C\D55C\C744 \AC16\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>\B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D55C \C694\C18C\C758 DOM \AC1D\CCB4\C5D0 \B300\D55C \CC38\C870\C785\B2C8\B2E4.</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>\C774\BCA4\D2B8\B97C \D2B8\B9AC\AC70\D55C \C774\BCA4\D2B8 \AC1D\CCB4\C785\B2C8\B2E4. \CC38\ACE0: \B85C\B4DC \C2DC \C774 \AC12\C740 ''load''\C640 \B3D9\C77C\D569\B2C8\B2E4.</dd>'),
'  <dt>this.data</dt>',
unistr('    <dd>\C774\BCA4\D2B8 \CC98\B9AC\AE30\C5D0\C11C \C804\B2EC\B420 \C218 \C788\B294 \C120\D0DD\C801\C778 \CD94\AC00 \B370\C774\D130\C785\B2C8\B2E4.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106082352218310349)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106080336746310347)
,p_name=>'PE.PROPERTY.JS_COND_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \AC12 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106080252937310347)
,p_name=>'PE.PROPERTY.JS_COND_LIST.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106082286147310349)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF64\B9C8\B85C \AD6C\BD84\B41C \D14C\C2A4\D2B8\D560 \C870\AC74 \AC12 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106082106962310348)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106120813116310384)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106120725207310384)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106082073365310348)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C2A4\D2B8\D560 \C870\AC74 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106081922975310348)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105217470254309635)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0\AC00 \B85C\B4DC\B420 \B54C \C2E4\D589\D560 JavaScript \CF54\B4DC\B97C \C785\B825\D558\C2ED\C2DC\C624.'),
unistr('\C774 \CF54\B4DC\B294 &PRODUCT_NAME.\C5D0\C11C \C0DD\C131\B41C JavaScript \CF54\B4DC \B2E4\C74C\C5D0 \C2E4\D589\B429\B2C8\B2E4.</p>'),
unistr('<p>\C5EC\AE30\C5D0 \C785\B825\D558\B294 \CF54\B4DC\B294 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C5D0\C11C <code>#GENERATED_JAVASCRIPT#</code> \B300\CCB4 \BB38\C790\C5F4\C744 \BC14\AFC9\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C5F4\AE30 \B610\B294 \B2EB\AE30 <code>script</code> \D0DC\ADF8\B97C \CD94\AC00\D560 \D544\C694\AC00 \C5C6\C73C\BA70 JavaScript \CF54\B4DC\B9CC \C785\B825\D558\BA74 \B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105217304664309634)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B85C\B4DC \C2DC \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105719750690310048)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\D45C\C900 \D30C\C77C \CC38\C870</dt>'),
'<dd><pre>/myjs/main.js</pre></dd>',
unistr('<dt>\C77C\BC18 \D398\C774\C9C0 \BCF4\AE30\B97C \C704\D574 <code>/myjs/minified/</code>\C5D0\C11C \CD5C\C18C\D654\B41C \D30C\C77C <code>main.min.js</code>\B97C \B85C\B4DC\D558\ACE0 \B514\BC84\ADF8 \BAA8\B4DC\B85C \B610\B294 \C571 \C791\C131\AE30\C5D0\C11C \C560\D50C\B9AC\CF00\C774\C158 \C2E4\D589 \C2DC <code>/myjs/</code>\C5D0\C11C <code>main.js</code>\B97C \B85C\B4DC\D558\B294 \D45C\C900 \D30C\C77C \CC38\C870\C785\B2C8\B2E4.</dt>'),
'<dd><pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre></dd>',
unistr('<dt>\B77C\C774\BE0C\B7EC\B9AC\AC00 RequireJS \D544\C218 \D638\CD9C\C5D0\C11C\B3C4 \C0AC\C6A9\B418\B294 \ACBD\C6B0 \C774 \AD6C\BB38\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624. \C815\C758 \C774\B984\C740 requirejs.config \ACBD\B85C\C5D0\C11C \C0AC\C6A9\B418\B294 \AC83\ACFC \C77C\CE58\D574\C57C \D558\ACE0 \AC12\C740 \B77C\C774\BE0C\B7EC\B9AC\AC00 \BCF4\C5EC\C8FC\B294 \C804\C5ED \AE30\D638\C5EC\C57C \D569\B2C8\B2E4. RequireJS\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4. \C774\B294 RequireJS\AC00 \B77C\C774\BE0C\B7EC\B9AC\B97C \B450 \BC88 \B85C\B4DC\D558\B294 \AC83\C744 \BC29\C9C0\D569\B2C8\B2E4.</dt>'),
'<dd><pre>[define hammerjs=Hammer]/myjs/hammer.js</pre></dd>',
unistr('<dt>\D30C\C77C\C5D0 RequireJS\C758 \C885\C18D\C131\C774 \C788\B294 \ACBD\C6B0 \C774 \AD6C\BB38\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624. \C774 \D30C\C77C \C804\C5D0 RequireJS\B97C \C790\B3D9\C73C\B85C \B85C\B4DC\D569\B2C8\B2E4.</dt>'),
'<dd><pre>[require requirejs]/myjs/main.js</pre></dd>',
unistr('<dt>\D30C\C77C\C5D0 Oracle JET\C758 \C885\C18D\C131\C774 \C788\B294 \ACBD\C6B0 \C774 \AD6C\BB38\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624. \C774 \D30C\C77C \C804\C5D0 RequireJS\C640 Oracle JET RequireJS \AD6C\C131\C744 \C790\B3D9\C73C\B85C \B85C\B4DC\D569\B2C8\B2E4.</dt>'),
'<dd><pre>[require jet]/myjs/main.js</pre></dd>',
unistr('<dt>\C560\D50C\B9AC\CF00\C774\C158\C744 \C5C5\ADF8\B808\C774\B4DC\D560 \B54C\C640 \AC19\C774(\BC84\C804\C774 \C99D\BD84\B428) \C560\D50C\B9AC\CF00\C774\C158 \BC84\C804\C744 \CC38\C870\D558\B294 URL\C758 \C9C8\C758 \BB38\C790\C5F4\C744 \C0AC\C6A9\D558\B294 \D30C\C77C \CC38\C870\C785\B2C8\B2E4. \BE0C\B77C\C6B0\C800\AC00 \D56D\C0C1 \C0C8 \D30C\C77C\C744 \B85C\B4DC\D558\ACE0 \C774\C804\C5D0 \CE90\C2DC\B41C \D30C\C77C\C740 \BB34\C2DC\D558\B3C4\B85D \C9C0\C815\B429\B2C8\B2E4.</dt>'),
'<dd><pre>/myjs/main.js?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105217094248309634)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\C5D0 \B85C\B4DC\B41C \CF54\B4DC\C5D0 \B300\D55C JavaScript \D30C\C77C URL\C744 \C785\B825\D569\B2C8\B2E4. \AC01 URL\C740 \C0C8 \D589\C5D0 \C791\C131\D574\C57C \D569\B2C8\B2E4.'),
unistr('\D30C\C77C\C758 \CD5C\C18C\D654\B41C \BC84\C804\C744 \C81C\ACF5\D560 \ACBD\C6B0, \C77C\BC18 \D398\C774\C9C0 \BCF4\AE30\B97C \C704\D574 \D30C\C77C URL\C5D0 <code>.min</code>\C744 \D3EC\D568\D558\B3C4\B85D \B300\CCB4 \BB38\C790\C5F4 <code>#MIN#</code>\C744 \C0AC\C6A9\D558\AC70\B098 <code>.minified</code>\B97C \D3EC\D568\D558\B3C4\B85D <code>#MIN_DIRECTORY#</code>\B97C \C0AC\C6A9\D560 \C218 \C788\C73C\BA70, \D398\C774\C9C0\B97C \B514\BC84\ADF8 \BAA8\B4DC\B85C \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30\C5D0\C11C \C560\D50C\B9AC\CF00\C774\C158 \C2E4\D589 \C2DC \D45C\C2DC\D560 \B54C\B294 \BE48 \BB38\C790\C5F4\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\B610\D55C \C560\D50C\B9AC\CF00\C774\C158\C758 \BC84\C804\C744 \D30C\C77C URL\C5D0 \D3EC\D568\D558\B824\B294 \ACBD\C6B0 \B300\CCB4 \BB38\C790\C5F4 <code>#APP_VERSION#</code>\C5D0 \C561\C138\C2A4\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C5EC\AE30\C5D0 \C785\B825\D55C JavaScript \D30C\C77C URL\B85C \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C5D0 \C788\B294 <code>#PAGE_JAVASCRIPT#</code> \B300\CCB4 \BB38\C790\C5F4\C774 \BC14\B01D\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C5F4\AE30 \B610\B294 \B2EB\AE30 <code>script</code> \D0DC\ADF8\B294 \D3EC\D568\D558\C9C0 \C54A\C544\B3C4 \B429\B2C8\B2E4. URL\B9CC \C9C0\C815\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105216906109309634)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105217222852309634)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\C5D0\C11C \CC38\C870\B418\B294 \D568\C218 \B610\B294 \C804\C5ED \BCC0\C218 \C120\C5B8\ACFC \AC19\C740 JavaScript \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\BC14\B85C\AC00\AE30\B97C \CC38\C870\D558\B824\BA74 <code>"SHORTCUTNAME"</code>\C744 \C0AC\C6A9\D569\B2C8\B2E4.'),
unistr('\B3D9\C77C\D55C JavaScript\AC00 \C5EC\B7EC \D398\C774\C9C0\C5D0 \D544\C694\D55C \ACBD\C6B0 \C911\BCF5\C744 \BC29\C9C0\D558\ACE0 \C815\C801 \D30C\C77C\C758 \BE0C\B77C\C6B0\C800 \CE90\C2F1\C744 \D65C\C6A9\D558\AE30 \C704\D574 \CF54\B4DC\B97C \C678\BD80 JavaScript \D30C\C77C\C5D0 \B123\B3C4\B85D \ACE0\B824\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C5EC\AE30\C5D0 \C785\B825\D558\B294 \CF54\B4DC\B85C \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C5D0 \C788\B294 <code>#PAGE_JAVASCRIPT#</code> \B300\CCB4 \BB38\C790\C5F4\C774 \BC14\B01D\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C5F4\AE30 \B610\B294 \B2EB\AE30 <code>script</code> \D0DC\ADF8\B294 \D3EC\D568\D558\C9C0 \C54A\C544\B3C4 \B429\B2C8\B2E4. JavaScript \CF54\B4DC\B9CC \D3EC\D568\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105217153799309634)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BC0F \C804\C5ED \BCC0\C218 \C120\C5B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106057807857310326)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D328\C2EF\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('    \D328\C2EF\C774 \D45C\C2DC\B418\B294 \ACBD\C6B0\C5D0\B9CC \D398\C774\C9C0\C5D0 \B808\C774\BE14\C774 \D45C\C2DC\B429\B2C8\B2E4. <strong>\AC80\C0C9</strong> \C720\D615\C5D0 \B300\D55C \B808\C774\BE14\C740 \C2DC\AC01\C801\C73C\B85C \C228\ACA8\C9C0\C9C0\B9CC \BCF4\C870 \ACF5\D559\C5D0 \C81C\ACF5\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105897201565310182)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('~\D328\C2EF \ADF8\B8F9\C758 \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4.~')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105897493633310182)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D328\C2EF\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('    \D328\C2EF\C774 \D45C\C2DC\B418\B294 \ACBD\C6B0\C5D0\B9CC \D398\C774\C9C0\C5D0 \B808\C774\BE14\C774 \D45C\C2DC\B429\B2C8\B2E4. <strong>\AC80\C0C9</strong> \C720\D615\C5D0 \B300\D55C \B808\C774\BE14\C740 \C2DC\AC01\C801\C73C\B85C \C228\ACA8\C9C0\C9C0\B9CC \BCF4\C870 \ACF5\D559\C5D0 \C81C\ACF5\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105260442322309666)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D544\D130\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('    \D544\D130\AC00 \D45C\C2DC\B418\B294 \ACBD\C6B0\C5D0\B9CC \D398\C774\C9C0\C5D0 \B808\C774\BE14\C774 \D45C\C2DC\B429\B2C8\B2E4. <strong>\AC80\C0C9</strong> \C720\D615\C5D0 \B300\D55C \B808\C774\BE14\C740 \C2DC\AC01\C801\C73C\B85C \C228\ACA8\C9C0\C9C0\B9CC \BCF4\C870 \ACF5\D559\C5D0 \C81C\ACF5\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105261399393309667)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('~\D544\D130 \ADF8\B8F9\C758 \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4.~')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105261727838309667)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D544\D130\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('    \D544\D130\AC00 \D45C\C2DC\B418\B294 \ACBD\C6B0\C5D0\B9CC \D398\C774\C9C0\C5D0 \B808\C774\BE14\C774 \D45C\C2DC\B429\B2C8\B2E4. <strong>\AC80\C0C9</strong> \C720\D615\C5D0 \B300\D55C \B808\C774\BE14\C740 \C2DC\AC01\C801\C73C\B85C \C228\ACA8\C9C0\C9C0\B9CC \BCF4\C870 \ACF5\D559\C5D0 \C81C\ACF5\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105242988277309653)
,p_name=>'PE.PROPERTY.LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0 \D56D\BAA9\C758 \D544\B4DC \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\D56D\BAA9\C774 \D45C\C2DC\B418\B294 \ACBD\C6B0\C5D0\B9CC \B808\C774\BE14\C774 \D398\C774\C9C0\C5D0 \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('\B808\C774\BE14 \B9DE\CDA4 \BC0F \D45C\C2DC\C5D0 \B530\B77C \B808\C774\BE14\C740 \ACE0\C720\D55C HTML \D14C\C774\BE14 \C140 \B610\B294 \B3D9\C77C\D55C \C140\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\D56D\BAA9 \B808\C774\BE14\C740 <code>"SHORTCUT_NAME"</code> \AD6C\BB38\C744 \C0AC\C6A9\D574\C11C \BC14\B85C\AC00\AE30\B97C \D3EC\D568\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105242851593309653)
,p_name=>'PE.PROPERTY.LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105243168587309654)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B808\C774\BE14 \B9DE\CDA4\C744 \C120\D0DD\D569\B2C8\B2E4. \B808\C774\BE14\C740 \D56D\BAA9\C758 \C704\CABD, \C544\B798\CABD \B610\B294 \C67C\CABD\C5D0 \D45C\C2DC\B420 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\B808\C774\BE14\C774 \D3FC \C694\C18C \C606\C5D0 \D45C\C2DC\B420 \ACBD\C6B0 \ACE0\C720\D55C HTML \D14C\C774\BE14 \C140\C744 \CC28\C9C0\D569\B2C8\B2E4.'),
unistr('\C774 \B808\C774\BE14 \B9DE\CDA4\C744 \BCC0\ACBD\D558\BA74 \D574\B2F9 \D14C\C774\BE14 \C140 \B0B4\C758 \B808\C774\BE14 \C704\CE58\B97C \C81C\C5B4\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105731296226310056)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.ABOVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105731375428310056)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.BELOW.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105731554277310056)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\C559 \D558\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105731683008310056)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\C559 \AC00\C6B4\B370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105731730325310056)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\C559 \C0C1\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105731416952310056)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C6B4\B370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105731930751310057)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD \D558\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105732064703310057)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD \C911\C559')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105732195922310057)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD \C0C1\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105731806019310057)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105732358102310057)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD \D558\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105732430985310057)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD \C911\C559')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105732551771310057)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD \C0C1\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105732261245310057)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105243033177309654)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106060311110310328)
,p_name=>'PE.PROPERTY.LAZY_LOADING.COMPONENT_PROPERTY.CARD.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C601\C5ED\C5D0 \B300\D55C \B370\C774\D130\C640 \C0C1\AD00\C5C6\C774 \C601\C5ED\C744 \B85C\B4DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('        <p>\C9C0\C5F0 \B85C\B529\C774 \C9C0\C815\B418\BA74 \D398\C774\C9C0\AC00 \C989\C2DC \B80C\B354\B9C1\B418\C5B4 \B370\C774\D130\AC00 \B85C\B4DC\B420 \B54C\AE4C\C9C0 \BE48 \C601\C5ED\C774 \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('        \C77C\BC18\C801\C73C\B85C \BAA8\B4E0 \D398\C774\C9C0\AC00 \B85C\B4DC\B418\ACE0 \B80C\B354\B9C1\B420 \C900\BE44\AC00 \B420 \B54C\AE4C\C9C0 \D398\C774\C9C0\B294 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('        \B530\B77C\C11C \C601\C5ED\C5D0 \B300\D55C \BAA8\B4E0 \B370\C774\D130\B97C \B85C\B4DC\D558\B294 \B370 5\CD08\AC00 \AC78\B9AC\B294 \ACBD\C6B0 \C9C0\C5F0 \B85C\B529\C774 \C5C6\C73C\BA74 \C77C\BC18 \C0AC\C6A9\C790\B294 5\CD08\B97C \AE30\B2E4\B824\C57C \D398\C774\C9C0 \B80C\B354\B9C1\C774 \C2DC\C791\B429\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \BE60\B974\AC8C \B85C\B4DC\B418\B294 \C601\C5ED\C758 \ACBD\C6B0 \C9C0\C5F0 \B85C\B529\C73C\B85C \C778\D574 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \B300\D574 \BD88\D544\C694\D55C \D504\B85C\C138\C2F1 \C624\BC84\D5E4\B4DC\AC00 \CD94\AC00\B85C \BC1C\C0DD\D558\BBC0\B85C \B85C\B4DC\D558\B294 \B370 \C0C1\B2F9\D55C \C2DC\AC04\C774 \AC78\B9AC\B294 \B370\C774\D130 \C9D1\D569\C5D0 \B300\D574\C11C\B9CC \C9C0\C5F0 \B85C\B529\C744 \D65C\C6A9\D574\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105439258952309810)
,p_name=>'PE.PROPERTY.LAZY_LOADING.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C601\C5ED\C5D0 \B300\D55C \B370\C774\D130\C640 \C0C1\AD00\C5C6\C774 \C601\C5ED\C744 \B85C\B4DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('        <p>\C9C0\C5F0 \B85C\B529\C774 \C9C0\C815\B418\BA74 \D398\C774\C9C0\AC00 \C989\C2DC \B80C\B354\B9C1\B418\C5B4 \B370\C774\D130\AC00 \B85C\B4DC\B420 \B54C\AE4C\C9C0 \BE48 \C601\C5ED\C774 \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('        \C77C\BC18\C801\C73C\B85C \BAA8\B4E0 \D398\C774\C9C0\AC00 \B85C\B4DC\B418\ACE0 \B80C\B354\B9C1\B420 \C900\BE44\AC00 \B420 \B54C\AE4C\C9C0 \D398\C774\C9C0\B294 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('        \B530\B77C\C11C \C601\C5ED\C5D0 \B300\D55C \BAA8\B4E0 \B370\C774\D130\B97C \B85C\B4DC\D558\B294 \B370 5\CD08\AC00 \AC78\B9AC\B294 \ACBD\C6B0 \C9C0\C5F0 \B85C\B529\C774 \C5C6\C73C\BA74 \C77C\BC18 \C0AC\C6A9\C790\B294 5\CD08\B97C \AE30\B2E4\B824\C57C \D398\C774\C9C0 \B80C\B354\B9C1\C774 \C2DC\C791\B429\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \BE60\B974\AC8C \B85C\B4DC\B418\B294 \C601\C5ED\C758 \ACBD\C6B0 \C9C0\C5F0 \B85C\B529\C73C\B85C \C778\D574 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \B300\D574 \BD88\D544\C694\D55C \D504\B85C\C138\C2F1 \C624\BC84\D5E4\B4DC\AC00 \CD94\AC00\B85C \BC1C\C0DD\D558\BBC0\B85C \B85C\B4DC\D558\B294 \B370 \C0C1\B2F9\D55C \C2DC\AC04\C774 \AC78\B9AC\B294 \B370\C774\D130 \C9D1\D569\C5D0 \B300\D574\C11C\B9CC \C9C0\C5F0 \B85C\B529\C744 \D65C\C6A9\D574\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105439157639309810)
,p_name=>'PE.PROPERTY.LAZY_LOADING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C5F0 \B85C\B529')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105878941069310168)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\B840\C5D0\C11C \D574\B2F9 \C774\B984\C744 \B20C\B7EC\C11C \CE35 \AC00\C2DC\C131\C744 \D1A0\AE00\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105878897294310168)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE30\B824\BA74 \C0AC\C6A9\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105879114702310168)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CE35\C5D0 \B300\D574 \BC94\B840\C5D0 \D45C\C2DC\D560 \C544\C774\CF58\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105879008757310168)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105494676893309855)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \BC94\B840\C758 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105494783365309855)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105495055190309856)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.BOTTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105494973997309855)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.END.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B05D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105494805479309855)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.START.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105495147297309856)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.TOP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105494560713309855)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105494480516309855)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \BC94\B840\AC00 \B80C\B354\B9C1\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105494382637309855)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105879360043310168)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.COMPONENT_PROPERTY.MAP_REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\B840 \C81C\BAA9\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105605516066309946)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \BC94\B840\C758 \B9E8 \C704\C5D0 \D45C\C2DC\D560 \C81C\BAA9\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105605467659309946)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105500535768309861)
,p_name=>'PE.PROPERTY.LINE_STYLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\D560 \C120\C758 \C2A4\D0C0\C77C\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105500779424309861)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DASHED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C120')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105500660825309861)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DOTTED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C810\C120')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105500879686309862)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.SOLID.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\C120')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105500463371309861)
,p_name=>'PE.PROPERTY.LINE_STYLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105501354258309862)
,p_name=>'PE.PROPERTY.LINE_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\D560 \C120\C758 \C720\D615\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105501498392309862)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105501723248309862)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSEGMENTED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\C559\C810 \BD84\D560\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105501582469309862)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSTEPPED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\C559\C810 \ACC4\B2E8\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105501646502309862)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CURVED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE1\C120')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105502001534309863)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105501912383309862)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.SEGMENTED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\D560\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105501834706309862)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STEPPED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\B2E8\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105502141809309863)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STRAIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C1\C120')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105501259278309862)
,p_name=>'PE.PROPERTY.LINE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105501075702309862)
,p_name=>'PE.PROPERTY.LINE_WIDTH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\D560 \C120\C758 \B108\BE44\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105500995388309862)
,p_name=>'PE.PROPERTY.LINE_WIDTH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105501170075309862)
,p_name=>'PE.PROPERTY.LINE_WIDTH.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53D\C140')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105748119184310069)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C0C8 \CC3D\C5D0\C11C \B9C1\D06C \C5F4\AE30</dt>'),
'<dd><pre>target="_blank"</pre></dd>',
unistr('<dt>\CEE4\C11C\B97C \C704\B85C \AC00\C838\AC08 \B54C \B3C4\AD6C \C124\BA85 \D45C\C2DC</dt>'),
'<dd><pre>title="Click to edit"</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105545108628309899)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \B300\C0C1, \D074\B798\C2A4 \B610\B294 \C2A4\D0C0\C77C\C744 \D3EC\D568\D574\C11C <code>&lt;a href=...&gt;</code> \D0DC\ADF8\C5D0 \D3EC\D568\D560 \CD94\AC00 \C5F4 \B9C1\D06C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105545032026309899)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105550871490309903)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C5F4\ACFC \C5F0\AD00\C2DC\D0AC \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \C120\D0DD\D569\B2C8\B2E4. \B9C1\D06C \C5F4\C774 \BCF4\ACE0\C11C\C5D0 \B80C\B354\B9C1\B420 \C218 \C788\C73C\B824\BA74 \C774 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 TRUE\B85C \D3C9\AC00\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105550709354309903)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105963164687310235)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D45C\D604\C2DD\C744 \D3C9\AC00\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105963509264310235)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105963488037310235)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105963341124310235)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105963644995310235)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105963264025310235)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ko'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105963050786310235)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105965131342310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105965405226310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105965378518310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105965225390310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105965592095310237)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105965093975310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105559440869309910)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105559377020309910)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105560880979309911)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105560716446309911)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105964705613310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C Java \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105964634621310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105966340315310237)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105966255212310237)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105964580870310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105964460021310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C JavaScript \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105964322655310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105966159244310237)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105966027083310237)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105965934519310237)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105559694960309910)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \CF5C\B860(:)\C73C\B85C \AD6C\BD84\B41C \AC12 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105559533179309910)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105560051201309910)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \D398\C774\C9C0 \BC88\D638\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105559923157309910)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105560287780309910)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \D398\C774\C9C0 \BC88\D638 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105560117606309910)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105964298674310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105964195464310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105964027433310235)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105965882040310237)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105965797296310237)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105965688279310237)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105559884084309910)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \C9C0\C815\B41C \AC12\ACFC \BE44\AD50\B418\B294 \C0AC\C6A9\C790 \D658\ACBD\C124\C815\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105559720640309910)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105964904238310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C Python \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105964859380310236)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105966533069310237)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105966474452310237)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105963944441310235)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \AD00\B9AC\C790\C774\ACE0 \BD80\C11C\AC00 \C2DC\CE74\ACE0\C5D0 \C788\C744 \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105963887708310235)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105963742591310235)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106106095669310370)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\B294\C9C0 \D655\C778\D560 \B54C \D558\B098 \C774\C0C1\C758 \D589\C774 \C874\C7AC\D558\BA74 \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\C9C1\C6D0\C774 \BD80\C11C 40\C5D0 \C18D\D558\B294\C9C0 \D655\C778\D560 \B54C \D589\C774 \C874\C7AC\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105559016010309909)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105558957277309909)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105560435215309910)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \D14D\C2A4\D2B8 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105560316811309910)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105561033742309911)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 <code>&ITEM.</code> \B300\CCB4 \BB38\C790\C5F4\C744 \D3EC\D568\D558\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105560904983309911)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105558857852309909)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9C1\D06C\B97C \B80C\B354\B9C1\D558\AE30 \C704\D574 \CDA9\C871\B418\C5B4\C57C \D558\B294 \C870\AC74 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105809911259310116)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105945607976310222)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\B294 \D56D\C0C1 \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105808525196310114)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 Microsoft Internet Explorer 7.0 \C774\C0C1\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105808653449310115)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 XHTML / CSS \C9C0\C6D0 \BE0C\B77C\C6B0\C800\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105808409002310114)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 Mozilla, Netscape 6.x/7x \C774\C0C1\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105808789817310115)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 \AE30\D0C0 \BE0C\B77C\C6B0\C800(\B610\B294 \C774\C804 \BC84\C804)\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105807144975310113)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\AC00 \D56D\BAA9\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105809110554310115)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105949248432310224)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105808822246310115)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4\AC00 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105949466031310225)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4 \C911 \D558\B098\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105809036340310115)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105949313517310225)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D558\ACE0 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105808959730310115)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4\AC00 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105949565574310225)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4 \C911 \D558\B098\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D558\ACE0 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105806365488310113)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 = \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105948095994310224)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \AC12\ACFC \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105806542516310113)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105948222414310224)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105806432157310113)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 != \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105948159698310224)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \AC12\ACFC \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105806688380310113)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105948366404310224)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105809236309310115)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105809396031310115)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105808012072310114)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D45C\C2DC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105949020465310224)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\CD9C \D6C4 \C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D398\C774\C9C0\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105807455244310114)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105807293426310113)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\AC00 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105807305488310114)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\AC00 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105807577431310114)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105804007597310111)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \BC18\D658\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105945725023310222)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\AC00 \D558\B098 \C774\C0C1\C758 \D589\C744 \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105962882474310235)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105962945728310235)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD\C774 TRUE\B85C \D3C9\AC00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105804265676310111)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105945935206310222)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38\C774 TRUE\B97C \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105809691971310115)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \AC12')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105809736486310115)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105807753102310114)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0/\C601\C5ED\C774 \C77D\AE30 \C804\C6A9\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105948737312310224)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B610\B294 \C0C1\C704 \C601\C5ED(\D574\B2F9\D558\B294 \ACBD\C6B0)\C774 \C815\C0C1\C801\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105807611686310114)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0/\C601\C5ED\C774 \C77D\AE30 \C804\C6A9\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105948629612310224)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B610\B294 \C0C1\C704 \C601\C5ED(\D574\B2F9\D558\B294 \ACBD\C6B0) \C911 \D558\B098\C785\B2C8\B2E4. ''\C77D\AE30 \C804\C6A9'' \C870\AC74\C740 TRUE\B85C \D3C9\AC00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105805500082310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \ACF5\BC31\C744 \D3EC\D568\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105947204099310223)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \ACF5\BC31\C744 \D3EC\D568\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105805884760310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C601\C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105947548042310223)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BB38\C790 \B610\B294 \C22B\C790\B9CC \D3EC\D568\D558\ACE0 \D2B9\C218 \BB38\C790\B294 \D3EC\D568\D558\C9C0 \C54A\B294 \C601\C22B\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105805056346310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105946745937310222)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105805740193310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C22B\C790\AC00 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105947471906310223)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105805241473310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 0\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105946999768310223)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790 0\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105804923506310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \B110\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105946654100310222)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105805355488310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 NULL \B610\B294 0\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105947036136310223)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\AC70\B098 \C22B\C790 0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105805655287310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105947340055310223)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105805146328310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 0\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105946835085310223)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790 0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105805498250310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 NULL\B3C4 \C544\B2C8\ACE0 0\B3C4 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105947164304310223)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\C9C0 \C54A\ACE0 \C22B\C790 0\B3C4 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105808228917310114)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BCF4\ACE0\C11C(\C55E\C73C\B85C \B2E8\CD94\B97C \D45C\C2DC\D558\B824\BA74 <b>\D655\C778</b> \B204\B974\AE30)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105808378261310114)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BCF4\ACE0\C11C(\B4A4\B85C \B2E8\CD94\B97C \D45C\C2DC\D558\B824\BA74 <b>\D655\C778</b> \B204\B974\AE30)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105809807129310115)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\C870\AC74 \BD80\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105949604019310225)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD6C\C131\C694\C18C\AC00 \B80C\B354\B9C1\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C870\AC74\C744 <strong>\BB34\C870\AC74 \BD80\C815</strong>\C73C\B85C \BCC0\ACBD\D558\BA74 \AE30\C874 \C870\AC74\C774 \BAA8\B450 \C81C\AC70\B429\B2C8\B2E4. \AD6C\C131\C694\C18C\B97C \C77C\C2DC\C801\C73C\B85C \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D558\B824\BA74 <em>\BE4C\B4DC \C635\C158</em> \C18D\C131\C744 \C0AC\C6A9\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105808127001310114)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D45C\C2DC\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105949188140310224)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D398\C774\C9C0\C5D0 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105804199676310111)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \BC18\D658\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105945821399310222)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\AC00 \D589\C744 \BC18\D658\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105806994493310113)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 \C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105948479197310224)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\B294 \C77C\BC18 \C0AC\C6A9\C790\C5D0 \C758\D574 ''\C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC''\B85C \D1A0\AE00\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105807039584310113)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\B294 \C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC\AC00 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105948545689310224)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\B294 \C77C\BC18 \C0AC\C6A9\C790\C5D0 \C758\D574 ''\C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC''\B85C \D1A0\AE00\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105804308211310111)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105946094428310222)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105804596183310111)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\C774 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105946227269310222)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105804402680310111)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105946139918310222)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105804683008310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\C774 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105946326221310222)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105809445629310115)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105809571313310115)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105807827667310114)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C778\C99D\B428(\ACF5\AC1C \C0AC\C6A9\C790\AC00 \C544\B2D8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105948894895310224)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B85C\ADF8\C778\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105807908907310114)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \ACF5\AC1C \C0AC\C6A9\C790\C784(\C0AC\C6A9\C790\AC00 \C778\C99D\B418\C9C0 \C54A\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105948912283310224)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B85C\ADF8\C778\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105806175286310113)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D658\ACBD\C124\C815 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105947806970310223)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\D55C <em>\D658\ACBD\C124\C815</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105806218466310113)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D658\ACBD\C124\C815 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105947922902310223)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\D55C <em>\D658\ACBD\C124\C815</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105805994671310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105947658383310223)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C644\C804\D788 \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105806060742310113)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105947785907310223)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12 \C77C\BD80\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105804710673310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105946458329310222)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105804899361310112)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105946585686310222)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105806823058310113)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 != \C81C\CD9C\B41C \D398\C774\C9C0(\AC8C\C2DC\B428)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105806707353310113)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 = \C81C\CD9C\B41C \D398\C774\C9C0(\AC8C\C2DC\B428)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105558723706309909)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105559209644309909)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74\ACFC \BE44\AD50\D560 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105559150774309909)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105560640297309911)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 <code>&ITEM.</code> \B300\CCB4 \BB38\C790\C5F4\C744 \D3EC\D568\D558\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105560583875309910)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105692362963310023)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BCF4\ACE0\C11C \C601\C5ED\C740 \BCF4\ACE0\C11C \C601\C5ED \C544\B798\C5D0 \D45C\C2DC\B41C \D45C\C900 \C778\C1C4 \B9C1\D06C \B610\B294 \B2E8\CD94\B97C \C0AC\C6A9\D574\C11C \C778\C1C4\D560 \C218 \C788\C2B5\B2C8\B2E4. \B2E8\CD94\B97C \C0AC\C6A9\D558\B824\B294 \ACBD\C6B0 \B9C1\D06C \B808\C774\BE14\C744 \C81C\AC70\D558\ACE0 \B2E8\CD94 \B300\C0C1\C73C\B85C \C778\C1C4 URL\C5D0 \D45C\C2DC\B41C URL\C744 \C0AC\C6A9\D574\C11C \D398\C774\C9C0\C5D0\C11C \B2E8\CD94\B97C \C0DD\C131\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E8\CD94\B97C \C0AC\C6A9\D574\C11C \BCF4\ACE0\C11C \C601\C5ED\C744 \C778\C1C4\D558\BA74 \C138\C158 \C0C1\D0DC\B97C \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \AE30\B2A5\C740 \C5EC\B7EC \AC00\C9C0 \CD9C\B825 \D615\C2DD(Word, Excel, PDF \B4F1)\C73C\B85C \C778\C1C4\B97C \C9C0\C6D0\D558\ACE0 \AC01 \C635\C158\C5D0 \B300\D574 \B2E8\CD94, \B9C1\D06C \B610\B294 \C774\BBF8\C9C0\B97C \D45C\C2DC\D558\B824\B294 \ACBD\C6B0\C5D0 \C720\C6A9\D569\B2C8\B2E4. \C774 \AD6C\D604\C744 \C704\D574\C11C\B294 \D56D\BAA9 \C635\C158\C5D0\C11C \D30C\C0DD\B41C \CD9C\B825 \D615\C2DD\C744 \C0AC\C6A9\D558\ACE0 \D56D\BAA9 \C774\B984 \BC0F \AC12\C744 \C778\C1C4 URL\C5D0 \D3EC\D568\C2DC\D0B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105921445543310200)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.IG_SAVED_REPORT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C800\C7A5\B41C \C774 \BCF4\ACE0\C11C\C5D0 \B300\D55C URL \B9C1\D06C\B97C \D655\C778\D569\B2C8\B2E4. \C774 \C18D\C131\C740 \BCF4\AE30 \C804\C6A9\C774\BA70 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</p>'),
unistr('    <p>\C774 \C18D\C131\C744 \C0AC\C6A9\D558\BA74 \D45C\C2DC\B41C URL\C744 \C2E0\C18D\D558\AC8C \BCF5\C0AC\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 URL\C744 \C0AC\C6A9\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C758 \C5B4\B290 \ACF3\C5D0\C11C\B4E0 \C800\C7A5\B41C \D2B9\C815 \BCF4\ACE0\C11C\C5D0 \C9C1\C811 \C5F0\ACB0\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105692914246310023)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BCF4\ACE0\C11C \C601\C5ED\C740 \BCF4\ACE0\C11C \C601\C5ED \C544\B798\C5D0 \D45C\C2DC\B41C \D45C\C900 \C778\C1C4 \B9C1\D06C \B610\B294 \B2E8\CD94\B97C \C0AC\C6A9\D574\C11C \C778\C1C4\D560 \C218 \C788\C2B5\B2C8\B2E4. \B2E8\CD94\B97C \C0AC\C6A9\D558\B824\B294 \ACBD\C6B0 \B9C1\D06C \B808\C774\BE14\C744 \C81C\AC70\D558\ACE0 \B2E8\CD94 \B300\C0C1\C73C\B85C \C778\C1C4 URL\C5D0 \D45C\C2DC\B41C URL\C744 \C0AC\C6A9\D574\C11C \D398\C774\C9C0\C5D0\C11C \B2E8\CD94\B97C \C0DD\C131\D569\B2C8\B2E4.</p>'),
unistr('<p>\B2E8\CD94\B97C \C0AC\C6A9\D574\C11C \BCF4\ACE0\C11C \C601\C5ED\C744 \C778\C1C4\D558\BA74 \C138\C158 \C0C1\D0DC\B97C \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \AE30\B2A5\C740 \C5EC\B7EC \AC00\C9C0 \CD9C\B825 \D615\C2DD(Word, Excel, PDF \B4F1)\C73C\B85C \C778\C1C4\B97C \C9C0\C6D0\D558\ACE0 \AC01 \C635\C158\C5D0 \B300\D574 \B2E8\CD94, \B9C1\D06C \B610\B294 \C774\BBF8\C9C0\B97C \D45C\C2DC\D558\B824\B294 \ACBD\C6B0\C5D0 \C720\C6A9\D569\B2C8\B2E4. \C774 \AD6C\D604\C744 \C704\D574\C11C\B294 \D56D\BAA9 \C635\C158\C5D0\C11C \D30C\C0DD\B41C \CD9C\B825 \D615\C2DD\C744 \C0AC\C6A9\D558\ACE0 \D56D\BAA9 \C774\B984 \BC0F \AC12\C744 \C778\C1C4 URL\C5D0 \D3EC\D568\C2DC\D0B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105561719832309911)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C800\C7A5\B41C \C774 \BCF4\ACE0\C11C\C5D0 \B300\D55C URL \B9C1\D06C\B97C \D655\C778\D569\B2C8\B2E4. \C774 \C18D\C131\C740 \BCF4\AE30 \C804\C6A9\C774\BA70 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C18D\C131\C744 \C0AC\C6A9\D558\BA74 \D45C\C2DC\B41C URL\C744 \C2E0\C18D\D558\AC8C \BCF5\C0AC\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 URL\C744 \C0AC\C6A9\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C758 \C5B4\B290 \ACF3\C5D0\C11C\B4E0 \C800\C7A5\B41C \D2B9\C815 \BCF4\ACE0\C11C\C5D0 \C9C1\C811 \C5F0\ACB0\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105561662044309911)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C608\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105550641113309903)
,p_name=>'PE.PROPERTY.LINK_ICON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C\C5D0 \C0AC\C6A9\D560 HTML\C744 \C785\B825\D569\B2C8\B2E4. \C774\BBF8\C9C0 \D0DC\ADF8\B97C \C0AC\C6A9\D574\C11C \C774\BBF8\C9C0\B97C \D45C\C2DC\D558\AC70\B098 \AE30\BCF8 \C774\BBF8\C9C0 \BAA9\B85D\C5D0\C11C \C120\D0DD\D569\B2C8\B2E4. \C815\C758\B418\C9C0 \C54A\C558\C73C\BA74 <code>#IMAGE_PREFIX#ws/small_page.gif</code>\AC00 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105550515922309903)
,p_name=>'PE.PROPERTY.LINK_ICON.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C544\C774\CF58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105561309583309911)
,p_name=>'PE.PROPERTY.LINK_TARGET.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BAA8\B2EC \B300\D654\C0C1\C790\B97C \D638\CD9C\D558\B824\B294 \B300\C0C1\C744 \B204\B985\B2C8\B2E4. \B9C1\D06C \C5F4\C744 \B204\B97C \B54C \D638\CD9C\D560 \C0AC\C6A9\C790\C815\C758 \B300\C0C1\C744 \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\C694\AD6C\C0AC\D56D\C5D0 \B530\B77C \B9C1\D06C \C791\C131\AE30 - \B300\C0C1\C5D0\C11C \C801\D569\D55C \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.'),
'        <dl>',
unistr('        <dt>\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0</dt>'),
unistr('        <dd>\B2E4\C74C\C744 \C785\B825\D569\B2C8\B2E4.'),
'        <ul>',
unistr('        <li>\D398\C774\C9C0 - \C774\B3D9\D560 \D398\C774\C9C0 \BC88\D638 \B610\B294 \D398\C774\C9C0 \BCC4\CE6D\C744 \C785\B825\D569\B2C8\B2E4. \C120\D0DD \BAA9\B85D\C5D0\C11C \D398\C774\C9C0 \BC88\D638\B97C \C120\D0DD\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('        <li>\D56D\BAA9 \C124\C815: \C774\B984 - \C138\C158 \C0C1\D0DC\C5D0\C11C \C124\C815\D560 \D398\C774\C9C0 \D56D\BAA9(<code>P3_ID</code>), \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9(<code>LAST_PAGE</code>) \B610\B294 \B300\D654\C2DD \BCF4\ACE0\C11C \D544\D130(<code>IR_EMPNO</code>)\B97C \C785\B825\D558\AC70\B098 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('        <li>\D56D\BAA9 \C124\C815: \AC12 - \BCF4\ACE0\C11C \C5F4(<code>#ID#</code>)\C744 \C785\B825 \B610\B294 \C120\D0DD\D558\AC70\B098, \C560\D50C\B9AC\CF00\C774\C158 \B610\B294 \D398\C774\C9C0 \D56D\BAA9(<code>&P2_EMPNO.</code>)\C744 \C785\B825\D558\AC70\B098, \C815\C801 \AC12(<code>2</code>)\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('        <li>\CE90\C2DC \BE44\C6B0\AE30 - \C9C0\C6B8 \D398\C774\C9C0 \BC88\D638(<code>2,3</code>), \D56D\BAA9(<code>P3_EMPNO,LAST_PAGE</code>) \BC0F \BCF4\ACE0\C11C \C124\C815\C758 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4. \BCF4\ACE0\C11C\C5D0 \B300\D55C \D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C744 \C7AC\C124\C815\D558\B824\BA74 <code>RP</code>\B97C \C785\B825\D569\B2C8\B2E4. \B300\D654\C2DD \BCF4\ACE0\C11C \C124\C815\C744 \C9C0\C6B0\AC70\B098 \C7AC\C124\C815\D558\B824\BA74 <code>CIR</code> \B610\B294 <code>RIR</code>\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('        <li>\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C7AC\C124\C815 - \B300\C0C1 \D398\C774\C9C0\C758 \BCF4\ACE0\C11C\C5D0 \B300\D574 \D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C744 \CCAB\BC88\C9F8 \B808\CF54\B4DC \C9D1\D569\C73C\B85C \C7AC\C124\C815\D558\B824\BA74 [\C608]\B97C \C120\D0DD\D569\B2C8\B2E4. \C774\B807\AC8C \D558\BA74 \CE90\C2DC \BE44\C6B0\AE30\C5D0\C11C <code>RP</code>\B97C \C804\B2EC\D558\B294 \AC83\ACFC \B3D9\C77C\D55C \D6A8\ACFC\AC00 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('        <li>\ACE0\AE09: \C694\CCAD - \C0AC\C6A9\D560 \C694\CCAD\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
'        </ul>',
'        </dd>',
unistr('        <dt>\B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0</dt>'),
unistr('        <dd>\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\C5D0 \B300\D574 \B098\C5F4\B41C \AC83\ACFC \B3D9\C77C\D55C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4. \C774\B54C \C560\D50C\B9AC\CF00\C774\C158 ID \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \BCC4\CE6D\C744 \D568\AED8 \C785\B825\D574\C57C \D569\B2C8\B2E4.</dd>'),
'        <dt>URL</dt>',
unistr('        <dd>URL\C744 \C785\B825\D569\B2C8\B2E4.</dd>'),
'        </dl></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105561282064309911)
,p_name=>'PE.PROPERTY.LINK_TARGET.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105879781959310168)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C758 \AC1D\CCB4\B97C \B204\B97C \B54C \C218\D589\D560 \C791\C5C5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105496458553309857)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\B97C \B204\B97C \B54C \C218\D589\D560 \C791\C5C5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105455753836309824)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8 \C5F4\C774 \BC18\D658\D55C URL\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105455878795309824)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\C758 \CCAB\BC88\C9F8 \C5F4\C774 \BC18\D658\D55C \B300\C0C1 URL\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105496754564309857)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105496848119309857)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0 \B9E4\AE40 \C7AC\C124\C815, \C694\CCAD \AC12 \C124\C815, \CE90\C2DC \BE44\C6B0\AE30 \BC0F \D56D\BAA9 \AC12 \C124\C815\C5D0 \B300\D55C \C120\D0DD\C801\C778 \CD94\AC00 \C18D\C131\ACFC \D568\AED8 \B300\C0C1 \D398\C774\C9C0\C5D0\C11C \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\D558\AE30 \C704\D574\C11C\B294 \B300\C0C1 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \B525 \B9C1\D06C\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4. \B525 \B9C1\D06C\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D558\B824\BA74 \C560\D50C\B9AC\CF00\C774\C158\C758 <em>\BCF4\C548</em> \C18D\C131\C73C\B85C \C774\B3D9\D558\C5EC <em>\B525 \B9C1\D06C</em>\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D558\C2ED\C2DC\C624.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105496568605309857)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105496676672309857)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C7AC\C124\C815, \C694\CCAD \AC12 \C124\C815, \CE90\C2DC \BE44\C6B0\AE30 \BC0F \D56D\BAA9 \AC12 \C124\C815\C5D0 \B300\D55C \C120\D0DD\C801\C778 \CD94\AC00 \C18D\C131\ACFC \D568\AED8 \B300\C0C1 \D398\C774\C9C0\C5D0\C11C \D604\C7AC \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105496933039309857)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('URL\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105497045087309858)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\D55C \B300\C0C1 URL\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105496338814309857)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105544992344309898)
,p_name=>'PE.PROPERTY.LINK_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C\B85C \D45C\C2DC\B420 HTML \D14D\C2A4\D2B8\B97C \C785\B825\D558\C2ED\C2DC\C624. \C774\BBF8\C9C0 \D0DC\ADF8\B97C \C0AC\C6A9\D558\C5EC \C774\BBF8\C9C0\B97C \D45C\C2DC\D558\AC70\B098, \AE30\BCF8 \C774\BBF8\C9C0 \BAA9\B85D\C5D0\C11C \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105544841713309898)
,p_name=>'PE.PROPERTY.LINK_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104857494316309360)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \BAA9\B85D\C758 \BAA8\C591\ACFC \B808\C774\C544\C6C3\C744 \C815\C758\D560 \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('        <p>\BAA9\B85D \D15C\D50C\B9AC\D2B8\B294 \C560\D50C\B9AC\CF00\C774\C158 \D14C\B9C8\C5D0\C11C \C815\C758\B429\B2C8\B2E4.'),
unistr('        \BAA9\B85D \C601\C5ED\C774 \C0DD\C131\B418\BA74 \D15C\D50C\B9AC\D2B8\B294 \D604\C7AC \D14C\B9C8\C5D0 \C815\C758\B41C \AE30\BCF8 \BAA9\B85D \D15C\D50C\B9AC\D2B8\B85C \C790\B3D9\C73C\B85C \C124\C815\B429\B2C8\B2E4.</p>'),
unistr('        <p>\BC94\C6A9 \D14C\B9C8\B294 \B2E4\C74C\ACFC \AC19\C740 \BAA9\B85D \D15C\D50C\B9AC\D2B8\B97C \C81C\ACF5\D569\B2C8\B2E4.'),
'          <dl>',
unistr('            <dt>\BC30\C9C0 \BAA9\B85D</dt>'),
unistr('            <dt>\CE74\B4DC</dt>'),
unistr('            <dt>\B9C1\D06C \BAA9\B85D</dt>'),
unistr('            <dt>\BBF8\B514\C5B4 \BAA9\B85D</dt>'),
unistr('            <dt>\BA54\B274 \BAA8\C74C</dt>'),
unistr('            <dt>\BA54\B274 \D31D\C5C5</dt>'),
unistr('            <dt>\D0D0\C0C9 \BAA8\C74C</dt>'),
unistr('            <dt>\CE21\BA74 \D0D0\C0C9 \BA54\B274</dt>'),
unistr('            <dt>\D0ED</dt>'),
unistr('            <dt>\C704\CABD \D0D0\C0C9 \BA54\B274</dt>'),
unistr('            <dt>\B9C8\BC95\C0AC \C9C4\D589</dt>'),
'          </dl>',
unistr('          \CC38\ACE0: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104857336864309360)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105925481584310203)
,p_name=>'PE.PROPERTY.LIST_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105925999624310204)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105926098490310204)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \BAA9\B85D\C740 \C785\B825\B41C PL/SQL \D568\C218 \BCF8\BB38\C73C\B85C \BC18\D658\B418\B294 SQL \C9C8\C758\B97C \AE30\C900\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105925779981310204)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105925853039310204)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \BAA9\B85D\C740 \C785\B825\B41C SQL \C9C8\C758\B97C \AE30\C900\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105925519864310203)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105925602901310204)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \BAA9\B85D\C740 \C785\B825\B41C \D14D\C2A4\D2B8 \AC12\C744 \AE30\C900\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105925381795310203)
,p_name=>'PE.PROPERTY.LIST_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105610817612309950)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C815 \BDF0\C5D0 \D45C\C2DC\D560 \CD1D \C77C \C218\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105610717113309950)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105610925864309950)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105610668463309950)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \BDF0\C5D0 \D45C\C2DC\D560 \C694\C77C\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105770164597310085)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105770273769310086)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\D55C \C77C \C218\B97C \AE30\C900\C73C\B85C \B2EC\B825 \D56D\BAA9\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105769712133310085)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \AC1C\C6D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105769824725310085)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C6D4\C758 \B2EC\B825 \D56D\BAA9\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105769923025310085)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5F0\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105770037104310085)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5F0\B3C4\C758 \B2EC\B825 \D56D\BAA9\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105610597957309950)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105360745110309743)
,p_name=>'PE.PROPERTY.LOGIN_URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\C758 \C560\D50C\B9AC\CF00\C774\C158 \B85C\ADF8\C778 \D398\C774\C9C0\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105360616092309743)
,p_name=>'PE.PROPERTY.LOGIN_URL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105305193983309700)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C544\C6C3 \C774\D6C4 &PRODUCT_NAME.\C774(\AC00) \C7AC\C9C0\C815\B418\B294 \C704\CE58\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105739201219310062)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105739349452310062)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C18D\C131\C5D0 \C9C0\C815\B41C \D648 \B9C1\D06C \AC12\C73C\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105739444772310062)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.D'
,p_message_language=>'ko'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105739519370310062)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\D55C URL\B85C \C7AC\C9C0\C815\D569\B2C8\B2E4(\C608: <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105305027646309700)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C544\C6C3 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105438290303309809)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C190\C2E4\B41C \C5C5\B370\C774\D2B8\B85C\BD80\D130 \B370\C774\D130\B97C \BCF4\D638\D558\AE30 \C704\D55C \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('		\C190\C2E4\B41C \C5C5\B370\C774\D2B8\B294 2\BA85 \C774\C0C1\C774 \B3D9\C77C\D55C \B370\C774\D130\B97C \C5C5\B370\C774\D2B8\D558\B824\ACE0 \C2DC\B3C4\D558\ACE0 \CD5C\C885 \C5C5\B370\C774\D2B8\AC00 \CCAB\BC88\C9F8 \C0AC\C6A9\C790\C758 \C5C5\B370\C774\D2B8\B97C \ACB9\CCD0\C4F0\BA74\C11C \BCC0\ACBD\C0AC\D56D\C744 \C800\C7A5\D560 \B54C \BC1C\C0DD\D569\B2C8\B2E4.'),
unistr('		\C774 \C0C1\D669\C774 \BC1C\C0DD\D558\C9C0 \C54A\B3C4\B85D \D558\AE30 \C704\D574 \C5C5\B370\C774\D2B8\C5D0\C11C\B294 \B370\C774\D130\BCA0\C774\C2A4\C758 \AE30\C874 \C5F4 \AC12\ACFC \B808\CF54\B4DC\AC00 \CC98\C74C\C5D0 \C9C8\C758\B420 \B54C \AC80\C0C9\B41C \AC12\C744 \BE44\AD50\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('		<p>\C608:'),
'          <ol>',
unistr('            <li>\C0AC\C6A9\C790 A\AC00 \C9C1\C6D0(EMP) \B808\CF54\B4DC\B97C \C9C8\C758\D569\B2C8\B2E4.</li>'),
unistr('		    <li>\C0AC\C6A9\C790 B\AC00 \B3D9\C77C\D55C \C9C1\C6D0 \B808\CF54\B4DC\B97C \C9C8\C758\D569\B2C8\B2E4.</li>'),
unistr('		    <li>\C0AC\C6A9\C790 B\AC00 EMPNO = 7839\C5D0 \B300\D55C \C9C1\C6D0 \C138\BD80\C815\BCF4\B97C \C5C5\B370\C774\D2B8\D558\ACE0 \BCC0\ACBD\C0AC\D56D\C744 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C801\C6A9(\CEE4\BC0B)\D569\B2C8\B2E4.</li>'),
unistr('		    <li>\C0AC\C6A9\C790 A\AC00 EMPNO = 7839\C5D0 \B300\D55C \C9C1\C6D0 \C138\BD80\C815\BCF4\B97C \C5C5\B370\C774\D2B8\D558\ACE0 \BCC0\ACBD\C0AC\D56D\C744 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C801\C6A9\D558\B824\ACE0 \C2DC\B3C4 \C911\C785\B2C8\B2E4.</li>'),
'          </ol>',
unistr('          \C0AC\C6A9\C790 A\AC00 \B3D9\C77C\D55C \B808\CF54\B4DC\B97C \C131\ACF5\C801\C73C\B85C \C5C5\B370\C774\D2B8\D560 \ACBD\C6B0 \C0AC\C6A9\C790 B\C758 \BCC0\ACBD\C0AC\D56D\C740 \C190\C2E4\B429\B2C8\B2E4.</p>'),
unistr('         <p>\C0AC\C6A9\C790 A\AC00 \C9C1\C6D0 \B808\CF54\B4DC\B97C \C800\C7A5\D558\B824\ACE0 \C2DC\B3C4 \C911\C77C \B54C \B370\C774\D130\BCA0\C774\C2A4\C758 \B370\C774\D130\B294 \C0AC\C6A9\C790 A\AC00 \CC98\C74C\C5D0 \C9C8\C758\D588\C744 \B54C\C640 \B2E4\B985\B2C8\B2E4.'),
unistr('		  \C704\C758 1\B2E8\ACC4\C5D0\C11C \C0AC\C6A9\C790 A\AC00 \CC98\C74C\C5D0 \C9C8\C758\D55C \C5F4 \AC12\C744 \CEA1\CC98\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('		  \ADF8\B7F0 \B2E4\C74C \C704\C758 4\B2E8\ACC4\C5D0\C11C \AC12\C744 \B370\C774\D130\BCA0\C774\C2A4\C758 \D604\C7AC \AC12\ACFC \BE44\AD50\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('		  \B370\C774\D130\BCA0\C774\C2A4 \AC12\C774 3\B2E8\ACC4\C5D0\C11C \C0AC\C6A9\C790 B\C5D0 \C758\D574 \C5C5\B370\C774\D2B8\B418\C5C8\C73C\BBC0\B85C \C774 \BE44\AD50\B294 \C0AC\C6A9\C790 A\C5D0 \B300\D55C \C624\B958\B97C \BC1C\C0DD\C2DC\D0B5\B2C8\B2E4.'),
unistr('		  \ADF8\B7EC\BA74 \D55C \C0AC\C6A9\C790\AC00 \B2E4\B978 \C0AC\C6A9\C790\C758 \BCC0\ACBD\C0AC\D56D\C744 \B3D9\C77C\D55C \D589\C5D0 \ACB9\CCD0\C4F0\C9C0 \BABB\D558\AC8C \B429\B2C8\B2E4.</p>'),
unistr('		  <p>\CC38\ACE0 - \C190\C2E4\B41C \C5C5\B370\C774\D2B8 \C720\D615\C740 \D574\B2F9\D558\B294 \D504\B85C\C138\C2A4\C778 \B300\D654\C2DD \ADF8\B9AC\B4DC - \C790\B3D9 \D589 \D504\B85C\C138\C2F1(DML)\C5D0\C11C <strong>\C190\C2E4\B41C \C5C5\B370\C774\D2B8 \BC29\C9C0</strong>\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105438430422309809)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BC84\C804 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105568212465309917)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14\C5D0 \B808\CF54\B4DC\AC00 \C5C5\B370\C774\D2B8\B420 \B54C\B9C8\B2E4 \C99D\BD84(\B370\C774\D130\BCA0\C774\C2A4 \D2B8\B9AC\AC70\C5D0 \C758\D574)\B418\B294 \C5F4\C774 \D3EC\D568\B418\C5B4 \C788\C73C\BA74 \CCB4\D06C\C12C\C744 \ACC4\C0B0\D558\B294 \B300\C2E0 \C774 \C5F4\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('        \C774 \C635\C158\C740 \B300\D654\C2DD \ADF8\B9AC\B4DC\AC00 \C5EC\B7EC \D14C\C774\BE14\C5D0\C11C \B370\C774\D130\B97C \C5C5\B370\C774\D2B8\D558\B294 \ACBD\C6B0 \C0AC\C6A9\D574\C11C\B294 \C548\B429\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \D589 \BC84\C804 \C5F4\C774 \C601\C5ED\C5D0 \B300\D55C SQL \C18C\C2A4\C5D0 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105438396834309809)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105568134356309917)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CCB4\D06C\C12C \AC12\C740 \CC98\C74C\C5D0 \B370\C774\D130\B97C \C9C8\C758\D560 \B54C \AC01 \D589\C5D0 \B300\D574 \ACC4\C0B0\B429\B2C8\B2E4.'),
unistr('        \CCB4\D06C\C12C\C740 \C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BAA8\B4E0 \C5F4\C744 \BB38\C790\C5F4\B85C \C5F0\ACB0\D55C \B2E4\C74C \ACE0\C720\D55C \AC12\C744 \C0DD\C131\D558\C5EC \ACC4\C0B0\B429\B2C8\B2E4.'),
unistr('        \C5C5\B370\C774\D2B8\B41C \B808\CF54\B4DC\B97C \CEE4\BC0B\D560 \B54C \C774 \CCB4\D06C\C12C\C740 \D604\C7AC \B370\C774\D130\BCA0\C774\C2A4 \B808\CF54\B4DC\C758 \CCB4\D06C\C12C \AC12\ACFC \BE44\AD50\B429\B2C8\B2E4.'),
unistr('        \B3D9\C77C\D558\C9C0 \C54A\C744 \ACBD\C6B0 \C624\B958\AC00 \BC1C\C0DD\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105438176223309809)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C190\C2E4\B41C \C5C5\B370\C774\D2B8 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105977515839310249)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105977813302310250)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105977712293310250)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105977690953310250)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105977902719310250)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105977401537310249)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105978743496310251)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B0\AE30 \C704\D574 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \AC12 \BAA9\B85D \C9C8\C758\C758 \D615\C2DD\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\C120\D0DD\B41C \AC01 \C5F4\C740 \ACE0\C720\D55C \C774\B984 \B610\B294 \BCC4\CE6D\C744 \AC00\C838\C57C \D569\B2C8\B2E4. Oracle\C740 SQL \D45C\D604\C2DD\C774 \D3EC\D568\B41C \BAA8\B4E0 \C5F4\C5D0\C11C \BCC4\CE6D\C744 \C0AC\C6A9\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105978686087310250)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105978582265310250)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\BD80\C11C \C774\B984 \D45C\C2DC \BC0F \BD80\C11C \BC88\D638 \C124\C815</dt>'),
'<dd><pre>',
'return "select dname as d, deptno as r from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105978431919310250)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B0\AE30 \C704\D574 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \AC12 \BAA9\B85D \C9C8\C758\C758 \D615\C2DD\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\C120\D0DD\B41C \AC01 \C5F4\C740 \ACE0\C720\D55C \C774\B984 \B610\B294 \BCC4\CE6D\C744 \AC00\C838\C57C \D569\B2C8\B2E4. Oracle\C740 SQL \D45C\D604\C2DD\C774 \D3EC\D568\B41C \BAA8\B4E0 \C5F4\C5D0\C11C \BCC4\CE6D\C744 \C0AC\C6A9\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105978319792310250)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105573973917309921)
,p_name=>'PE.PROPERTY.LOV_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC12 \BAA9\B85D\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105573827617309921)
,p_name=>'PE.PROPERTY.LOV_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105303081555309698)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C0\C815\B41C \C885\C18D LOV \C0C1\C704 \D56D\BAA9\C758 \AC12\C774 \C774 \D398\C774\C9C0\C5D0\C11C \BCC0\ACBD\B420 \B54C \C138\C158 \C0C1\D0DC\B85C \C124\C815\D560 \C5F4, \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\D56D\BAA9\C774 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \AC01 \D56D\BAA9 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\D569\B2C8\B2E4.'),
unistr('\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \B54C \C774\BBF8 \C785\B825\B41C \D14D\C2A4\D2B8\AC00 \C788\C73C\BA74 \AE30\C874 \D14D\C2A4\D2B8 \B05D\C5D0 \CF64\B9C8\AC00 \D45C\C2DC\B418\ACE0 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \D56D\BAA9 \C774\B984\C774 \CD94\AC00\B429\B2C8\B2E4.</p>'),
unistr('<p>\BC18\D658\B418\B294 \AC12\C744 \C81C\D55C\D558\B824\BA74 \C774 \AC12 \BAA9\B85D SQL \C9C8\C758\C758 <em>WHERE \C808</em> \B0B4\C5D0\C11C \C774 \C18D\C131\C5D0 \C9C0\C815\B41C \D398\C774\C9C0 \D56D\BAA9\C744 \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: <em>\C885\C18D LOV \C0C1\C704 \D56D\BAA9</em>\C5D0 \C815\C758\B41C \D398\C774\C9C0 \D56D\BAA9\C740 \C790\B3D9\C73C\B85C \C804\C1A1\B418\BA70 \C774 \C18D\C131\C5D0 \C785\B825\D560 \D544\C694\AC00 \C5C6\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105302917408309698)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C\D560 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105978260200310250)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\BD80\C11C \C774\B984\C744 \D45C\C2DC\D558\ACE0 \BD80\C11C \BC88\D638 \C124\C815</dt>'),
'<dd><pre>',
'begin',
'    return ''select dname as d, deptno as r from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105978175427310250)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B0\AE30 \C704\D574 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \AC12 \BAA9\B85D \C9C8\C758\C758 \D615\C2DD\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\C120\D0DD\B41C \AC01 \C5F4\C740 \ACE0\C720\D55C \C774\B984 \B610\B294 \BCC4\CE6D\C744 \AC00\C838\C57C \D569\B2C8\B2E4. Oracle\C740 SQL \D45C\D604\C2DD\C774 \D3EC\D568\B41C \BAA8\B4E0 \C5F4\C5D0\C11C \BCC4\CE6D\C744 \C0AC\C6A9\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105978038292310250)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105978916034310251)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B0\AE30 \C704\D574 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \AC12 \BAA9\B85D \C9C8\C758\C758 \D615\C2DD\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\C120\D0DD\B41C \AC01 \C5F4\C740 \ACE0\C720\D55C \C774\B984 \B610\B294 \BCC4\CE6D\C744 \AC00\C838\C57C \D569\B2C8\B2E4. Oracle\C740 SQL \D45C\D604\C2DD\C774 \D3EC\D568\B41C \BAA8\B4E0 \C5F4\C5D0\C11C \BCC4\CE6D\C744 \C0AC\C6A9\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105978834178310251)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106041765626310311)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B8 SQL \C9C8\C758 \C815\C758\B97C \C785\B825\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \AC12 \BAA9\B85D \C9C8\C758\C758 \D615\C2DD\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\C120\D0DD\B41C \AC01 \C5F4\C5D0\B294 \ACE0\C720 \C774\B984 \B610\B294 \BCC4\CE6D\C774 \C788\C5B4\C57C \D569\B2C8\B2E4. SQL \D45C\D604\C2DD\C744 \D3EC\D568\D558\B294 \C5F4\C5D0\C11C \BCC4\CE6D\C744 \C0AC\C6A9\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \D31D\C5C5 LOV \D56D\BAA9 \C720\D615\C744 \C815\C758\D560 \B54C \D31D\C5C5\C5D0 \B2E4\C911 \C5F4\C744 \D45C\C2DC\D558\B824\B294 \ACBD\C6B0 \D544\C694\D55C \CD94\AC00 \BA54\D0C0\B370\C774\D130\B97C \C0AC\C6A9\D558\C5EC \ACF5\C720 \AD6C\C131\C694\C18C\C5D0\C11C \AC12 \BAA9\B85D\C744 \C815\C758\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C778\B77C\C778 \AC12 \BAA9\B85D\C740 \D31D\C5C5 LOV\C5D0 \B300\D55C \B2E8\C77C \C5F4\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105897568583310182)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B8 SQL \C9C8\C758 \C815\C758\B97C \C785\B825\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \AC12 \BAA9\B85D \C9C8\C758\C758 \D615\C2DD\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\C120\D0DD\B41C \AC01 \C5F4\C5D0\B294 \ACE0\C720 \C774\B984 \B610\B294 \BCC4\CE6D\C774 \C788\C5B4\C57C \D569\B2C8\B2E4. SQL \D45C\D604\C2DD\C744 \D3EC\D568\D558\B294 \C5F4\C5D0\C11C \BCC4\CE6D\C744 \C0AC\C6A9\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \D31D\C5C5 LOV \D56D\BAA9 \C720\D615\C744 \C815\C758\D560 \B54C \D31D\C5C5\C5D0 \B2E4\C911 \C5F4\C744 \D45C\C2DC\D558\B824\B294 \ACBD\C6B0 \D544\C694\D55C \CD94\AC00 \BA54\D0C0\B370\C774\D130\B97C \C0AC\C6A9\D558\C5EC \ACF5\C720 \AD6C\C131\C694\C18C\C5D0\C11C \AC12 \BAA9\B85D\C744 \C815\C758\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C778\B77C\C778 \AC12 \BAA9\B85D\C740 \D31D\C5C5 LOV\C5D0 \B300\D55C \B2E8\C77C \C5F4\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106057764915310326)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B8 SQL \C9C8\C758 \C815\C758\B97C \C785\B825\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \AC12 \BAA9\B85D \C9C8\C758\C758 \D615\C2DD\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\C120\D0DD\B41C \AC01 \C5F4\C5D0\B294 \ACE0\C720 \C774\B984 \B610\B294 \BCC4\CE6D\C774 \C788\C5B4\C57C \D569\B2C8\B2E4. SQL \D45C\D604\C2DD\C744 \D3EC\D568\D558\B294 \C5F4\C5D0\C11C \BCC4\CE6D\C744 \C0AC\C6A9\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \D31D\C5C5 LOV \D56D\BAA9 \C720\D615\C744 \C815\C758\D560 \B54C \D31D\C5C5\C5D0 \B2E4\C911 \C5F4\C744 \D45C\C2DC\D558\B824\B294 \ACBD\C6B0 \D544\C694\D55C \CD94\AC00 \BA54\D0C0\B370\C774\D130\B97C \C0AC\C6A9\D558\C5EC \ACF5\C720 \AD6C\C131\C694\C18C\C5D0\C11C \AC12 \BAA9\B85D\C744 \C815\C758\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C778\B77C\C778 \AC12 \BAA9\B85D\C740 \D31D\C5C5 LOV\C5D0 \B300\D55C \B2E8\C77C \C5F4\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106041697083310311)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B8 SQL \C9C8\C758 \C815\C758\B97C \C785\B825\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \AC12 \BAA9\B85D \C9C8\C758\C758 \D615\C2DD\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\C120\D0DD\B41C \AC01 \C5F4\C5D0\B294 \ACE0\C720 \C774\B984 \B610\B294 \BCC4\CE6D\C774 \C788\C5B4\C57C \D569\B2C8\B2E4. SQL \D45C\D604\C2DD\C744 \D3EC\D568\D558\B294 \C5F4\C5D0\C11C \BCC4\CE6D\C744 \C0AC\C6A9\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \D31D\C5C5 LOV \D56D\BAA9 \C720\D615\C744 \C815\C758\D560 \B54C \D31D\C5C5\C5D0 \B2E4\C911 \C5F4\C744 \D45C\C2DC\D558\B824\B294 \ACBD\C6B0 \D544\C694\D55C \CD94\AC00 \BA54\D0C0\B370\C774\D130\B97C \C0AC\C6A9\D558\C5EC \ACF5\C720 \AD6C\C131\C694\C18C\C5D0\C11C \AC12 \BAA9\B85D\C744 \C815\C758\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C778\B77C\C778 \AC12 \BAA9\B85D\C740 \D31D\C5C5 LOV\C5D0 \B300\D55C \B2E8\C77C \C5F4\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105260680108309666)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B8 SQL \C9C8\C758 \C815\C758\B97C \C785\B825\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \AC12 \BAA9\B85D \C9C8\C758\C758 \D615\C2DD\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\C120\D0DD\B41C \AC01 \C5F4\C5D0\B294 \ACE0\C720 \C774\B984 \B610\B294 \BCC4\CE6D\C774 \C788\C5B4\C57C \D569\B2C8\B2E4. SQL \D45C\D604\C2DD\C744 \D3EC\D568\D558\B294 \C5F4\C5D0\C11C \BCC4\CE6D\C744 \C0AC\C6A9\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \D31D\C5C5 LOV \D56D\BAA9 \C720\D615\C744 \C815\C758\D560 \B54C \D31D\C5C5\C5D0 \B2E4\C911 \C5F4\C744 \D45C\C2DC\D558\B824\B294 \ACBD\C6B0 \D544\C694\D55C \CD94\AC00 \BA54\D0C0\B370\C774\D130\B97C \C0AC\C6A9\D558\C5EC \ACF5\C720 \AD6C\C131\C694\C18C\C5D0\C11C \AC12 \BAA9\B85D\C744 \C815\C758\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C778\B77C\C778 \AC12 \BAA9\B85D\C740 \D31D\C5C5 LOV\C5D0 \B300\D55C \B2E8\C77C \C5F4\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105261977677309667)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B8 SQL \C9C8\C758 \C815\C758\B97C \C785\B825\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \AC12 \BAA9\B85D \C9C8\C758\C758 \D615\C2DD\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\C120\D0DD\B41C \AC01 \C5F4\C5D0\B294 \ACE0\C720 \C774\B984 \B610\B294 \BCC4\CE6D\C774 \C788\C5B4\C57C \D569\B2C8\B2E4. SQL \D45C\D604\C2DD\C744 \D3EC\D568\D558\B294 \C5F4\C5D0\C11C \BCC4\CE6D\C744 \C0AC\C6A9\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \D31D\C5C5 LOV \D56D\BAA9 \C720\D615\C744 \C815\C758\D560 \B54C \D31D\C5C5\C5D0 \B2E4\C911 \C5F4\C744 \D45C\C2DC\D558\B824\B294 \ACBD\C6B0 \D544\C694\D55C \CD94\AC00 \BA54\D0C0\B370\C774\D130\B97C \C0AC\C6A9\D558\C5EC \ACF5\C720 \AD6C\C131\C694\C18C\C5D0\C11C \AC12 \BAA9\B85D\C744 \C815\C758\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C778\B77C\C778 \AC12 \BAA9\B85D\C740 \D31D\C5C5 LOV\C5D0 \B300\D55C \B2E8\C77C \C5F4\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105813079584310118)
,p_name=>'PE.PROPERTY.LOV_SQL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\BD80\C11C \C774\B984\C744 \D45C\C2DC\D558\ACE0 \BD80\C11C \BC88\D638 \C124\C815</dt>'),
'<dd><pre>',
'select dname  as d,',
'       deptno as r',
'  from dept',
' order by 1',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105564059416309913)
,p_name=>'PE.PROPERTY.LOV_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC12 \BAA9\B85D\C744 \CC44\C6B0\AE30 \C704\D574 SQL \C9C8\C758 \C815\C758\B97C \C785\B825\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \AC12 \BAA9\B85D \C9C8\C758\C758 \D615\C2DD\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\C120\D0DD\B41C \AC01 \C5F4\C740 \ACE0\C720\D55C \C774\B984 \B610\B294 \BCC4\CE6D\C744 \AC00\C838\C57C \D569\B2C8\B2E4. Oracle\C740 SQL \D45C\D604\C2DD\C774 \D3EC\D568\B41C \BAA8\B4E0 \C5F4\C5D0\C11C \BCC4\CE6D\C744 \C0AC\C6A9\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105563955429309913)
,p_name=>'PE.PROPERTY.LOV_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105564401133309914)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C815\C801 \AC12 \BAA9\B85D\C5D0 \B300\D55C \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105564347030309913)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105564212245309913)
,p_name=>'PE.PROPERTY.LOV_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \C720\D615 \BAA9\B85D\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105950653772310225)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105950733144310226)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \AC12 \BAA9\B85D\C740 \C785\B825\B41C \D568\C218 \BCF8\BB38\C73C\B85C \BC18\D658\B418\B294 SQL \C9C8\C758\B97C \AE30\C900\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105436002289309807)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C720 \AD6C\C131\C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105436172408309807)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D\C740 \ACF5\C720 \AD6C\C131\C694\C18C\C5D0 \C815\C758\B41C \BBF8\B9AC \C815\C758\B41C \AC12 \BAA9\B85D\C744 \AE30\C900\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105436247974309807)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105436392844309807)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \AC12 \BAA9\B85D\C740 \C785\B825\D55C SQL \C9C8\C758\B97C \AE30\C900\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105752820647310072)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105752946975310073)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12 \BAA9\B85D\C740 \C785\B825\D55C \D14D\C2A4\D2B8 \AC12\C744 \AE30\C900\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105564120613309913)
,p_name=>'PE.PROPERTY.LOV_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105232598012309646)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC\AC00 \C720\C9C0\BCF4\C218\B418\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105190054325309614)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\B2F9(\BA54\BAA8\B9AC \C804\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105190110467309614)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4\C5D0 \C0C1\D0DC\B97C \C800\C7A5\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \C0C1\D0DC\B294 \D604\C7AC \C694\CCAD\C744 \CC98\B9AC\D560 \B54C\B9CC \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. AJAX \C694\CCAD\C5D0 \D56D\BAA9\C744 \C0AC\C6A9\D574\C57C \D558\B294 \ACBD\C6B0 "\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9"\C744 \D1B5\D574 \D56D\BAA9 \C774\B984\C744 \C804\B2EC\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105734941499310059)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\B2F9(\B514\C2A4\D06C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106029405287310299)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \AC04\C5D0 \C561\C138\C2A4\D560 \C218 \C788\B3C4\B85D \B370\C774\D130\BCA0\C774\C2A4\C5D0 \AC12\C744 \C800\C7A5\D558\C5EC \C0AC\C6A9\C790\B97C \C720\C9C0 \AD00\B9AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105734862475310059)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158\B2F9(\B514\C2A4\D06C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106029306600310299)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD \AC04\C5D0 \C561\C138\C2A4\D560 \C218 \C788\B3C4\B85D \B370\C774\D130\BCA0\C774\C2A4\C5D0 \AC12\C744 \C800\C7A5\D558\C5EC \AC01 \C138\C158\C744 \C720\C9C0 \AD00\B9AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105232449019309646)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC \C720\C9C0 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105190326472309614)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC\AC00 \C720\C9C0\BCF4\C218\B418\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105190472415309614)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\B2F9(\BA54\BAA8\B9AC \C804\C6A9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105190581583309614)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4\C5D0 \C0C1\D0DC\B97C \C800\C7A5\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \C0C1\D0DC\B294 \D604\C7AC \C694\CCAD\C744 \CC98\B9AC\D560 \B54C\B9CC \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. AJAX \C694\CCAD\C5D0 \D56D\BAA9\C744 \C0AC\C6A9\D574\C57C \D558\B294 \ACBD\C6B0 "\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9"\C744 \D1B5\D574 \D56D\BAA9 \C774\B984\C744 \C804\B2EC\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105190632389309614)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158\B2F9(\B514\C2A4\D06C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105190782625309614)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD \AC04\C5D0 \C561\C138\C2A4\D560 \C218 \C788\B3C4\B85D \B370\C774\D130\BCA0\C774\C2A4\C5D0 \AC12\C744 \C800\C7A5\D558\C5EC \AC01 \C138\C158\C744 \C720\C9C0 \AD00\B9AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105190228833309614)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC \C720\C9C0 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105507351324309867)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC \B208\AE08 \D45C\C2DC\AC00 \B80C\B354\B9C1\B418\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105507445539309867)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105507691473309867)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.OFF.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105507525711309867)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.ON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105507295329309867)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105852469623310148)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105852322184310147)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D3EC\C778\D2B8 \D074\B7EC\C2A4\D130\B97C \D45C\C2DC\D560 \CC44\C6B0\AE30 \C0C9\C0C1\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 3\AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105852251004310147)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC44\C6C0 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105851687936310147)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\C778\D2B8 \D074\B7EC\C2A4\D130 \D45C\C2DC\C5D0 \C0AC\C6A9\D560 \C544\C774\CF58 CSS \D074\B798\C2A4\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105851569073310147)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105851492006310147)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\C778\D2B8 \D074\B7EC\C2A4\D130 \D45C\C2DC\C5D0 \C0AC\C6A9\D560 \C774\BBF8\C9C0 URL\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105851339898310147)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105851826556310147)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\C778\D2B8 \D074\B7EC\C2A4\D130\B97C \D45C\C2DC\D560 SVG \BAA8\C591\C744 \C9C0\C815\D569\B2C8\B2E4. \C0AC\C804 \C815\C758\B41C \BAA8\C591\C5D0\C11C \C120\D0DD\D558\AC70\B098 <strong>\C0AC\C6A9\C790\C815\C758 SVG \C2A4\D0C0\C77C</strong> \B9F5 \C601\C5ED \C18D\C131\C5D0 \C9C0\C815\B41C <em>\C0AC\C6A9\C790\C815\C758 SVG \BAA8\C591</em>\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C9C0\C815\B41C \C774\B984\C774 \AE30\BCF8 \B610\B294 \C0AC\C6A9\C790\C815\C758 SVG \C2A4\D0C0\C77C \BAA9\B85D\C5D0 \C5C6\C73C\BA74 <strong>\AE30\BCF8 \D45C\C2DC\C790</strong>\AC00 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105885316573310173)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\BA54\B77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105893165496310179)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105889925477310176)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105894423899310180)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105885409969310173)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0 \B300\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105893307167310179)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105852041882310147)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105893239688310179)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105885223501310173)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105893064687310179)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105885523273310173)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC0C\D478\B9B0 \C5BC\AD74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105893427799310179)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105885652376310173)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B530\BD84\D55C \C5BC\AD74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105893539786310179)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105885790415310173)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6C3\B294 \C5BC\AD74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105893642714310179)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105890464275310177)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0BC\AC01 \AE43\BC1C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105894937590310180)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105890551569310177)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BE44\AF2C\B9AC \AE43\BC1C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105895080200310180)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105886172951310173)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105894155054310180)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105890002189310176)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105894531295310180)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105886228633310173)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\AC01\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105894254161310180)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105885949819310173)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0 \ACE0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105893919738310179)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105886042877310173)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\AC01\D615 \ACE0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105894013853310179)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105890226042310177)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE5B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105894736330310180)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105890173551310176)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2AC\B798\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105894637174310180)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105885873071310173)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\AC01\D615 \B300\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105893895315310179)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105851960868310147)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\AC01\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105893726343310179)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105890362947310177)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC70\B9AC \BDF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105894890543310180)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105852176737310147)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0BC\AC01\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105894355707310180)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105851790121310147)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105886493855310174)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SVG \BAA8\C591\C774 \D3EC\C778\D2B8 \D074\B7EC\C2A4\D130\B97C \D45C\C2DC\D558\AE30 \C704\D55C \BC30\C728 \C778\C218\B97C \C9C0\C815\D569\B2C8\B2E4. \CD5C\B300 \BC30\C728\C740 <strong>10</strong>\C774\ACE0, \B9F5 \AD6C\C131\C694\C18C\AC00 \AC12\C744 \CCAB\BC88\C9F8 \C18C\C218\C810 \C790\B9BF\C218\B85C \BC18\C62C\B9BC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105886356436310173)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591 \BC30\C728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105855611453310150)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53D\C140 \B2E8\C704\C758 \D074\B7EC\C2A4\D130\D654 \BC18\ACBD\C785\B2C8\B2E4. \AC12\C774 <strong>80</strong>\C73C\B85C \C9C0\C815\B418\C5C8\C73C\BA74 \C11C\B85C 80\D53D\C140 \C774\B0B4\C758 \D3EC\C778\D2B8\AC00 \D3EC\C778\D2B8 \D074\B7EC\C2A4\D130\B85C \C9D1\ACC4\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105855593254310150)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B7EC\C2A4\D130\D654 \BC18\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105855714688310150)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53D\C140')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105876452828310166)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C5D0\C11C \D074\B7EC\C2A4\D130 \D45C\C2DC\C790 \C704\B85C \B9C8\C6B0\C2A4\B97C \AC00\C838\AC08 \B54C \B3C4\AD6C \C124\BA85\C73C\B85C \D45C\C2DC\D560 HTML \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4. <strong>&LAYER.</strong> \BC0F <strong>&COUNT.</strong> \C704\CE58 \D45C\C2DC\C790\B97C \C0AC\C6A9\D558\C5EC \CE35 \C774\B984 \BC0F \D074\B7EC\C2A4\D130\C758 \B9F5 \AC1D\CCB4 \C218\B7C9\C744 \CC38\C870\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105876368697310166)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\AD6C \C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105841915261310140)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C758 \BC14\B2E5\AE00\C5D0 \D45C\C2DC\D560 \C800\C791\AD8C \ACF5\C9C0\B97C \C81C\ACF5\D569\B2C8\B2E4. \BE44\C5B4 \C788\C73C\BA74 \C0AC\C6A9\B41C \BC31\ADF8\B77C\C6B4\B4DC \B9F5\C758 \ACF5\C9C0\AC00 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105841865973310140)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C791\AD8C \ACF5\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105843681345310141)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[',
'    {',
'        "name": "MyCamera",',
'        "width": 20,',
'        "height": 20,',
'        "paint-order": "stroke",',
'        "viewBox": "0 0 20 20",',
'        "elements": [',
'            {',
'                "type": "path",',
'                "d": "M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1'
||'.1 2.5 2.5S11.4 11 10 11z"',
'            }',
'        ]',
'    },',
'    {',
'        "name": "MyCompany",',
'        "width": 20,',
'        "height": 20,',
'        :',
'    }',
']</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105843565504310141)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B9F5 \D45C\C2DC\C790\B85C \C0AC\C6A9\B420 \C218 \C788\B294 \C0AC\C6A9\C790\C815\C758 SVG \BAA8\C591\C5D0 \B300\D55C \C815\C758\B97C \C81C\ACF5\D569\B2C8\B2E4. \C5EC\AE30\C5D0 \C815\C758\B41C \C2A4\D0C0\C77C\C740 \D3EC\C778\D2B8 \CE35 \B0B4\C758 <strong>SVG \BAA8\C591</strong> \C18D\C131\C73C\B85C \C0AC\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>SVG \BAA8\C591\C740 \B108\BE44 \BC0F \B192\C774\AC00 <strong>20</strong>\C774\C5B4\C57C \D569\B2C8\B2E4. \D45C\C2DC\C790\AC00 \B9F5\C5D0 \BC30\CE58\B418\BBC0\B85C, \C544\B798\CABD \BAA8\C591\C758 \AC00\C6B4\B370(SVG \C88C\D45C <strong>10</strong>, <strong>20</strong>)\AC00 \B9F5 \AC1D\CCB4\B97C \AC00\B9AC\D0B5\B2C8\B2E4.</p>'),
'<svg aria-labelledby="prop1526_SvgTitle" role="img" xmlns="http://www.w3.org/2000/svg" width="100px" height="100px" paint-order="stroke" viewBox="-5 -5 30 40">',
unistr('<title id="prop1526_SvgTitle">SVG \D45C\C2DC\C790\B294 \B108\BE44 \BC0F \B192\C774\AC00 20\C774\ACE0 x=10 \BC0F y=20 \C704\CE58\C758 \B9F5 \C704\CE58\B97C \AC00\B9AC\D0B5\B2C8\B2E4.</title>'),
'<path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/>',
'<rect x="0" y="0" width="20" height="20" style="stroke-dasharray:1 1;fill:none;stroke-width:0.5;stroke:black;"/>',
'<line x1="7" y1="17" x2="13" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<line x1="13" y1="17" x2="7" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<text x="10" y="30" text-anchor="middle" style="font: 6px Sans-Serif; fill: red;">[10 20]</text>',
'</svg>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105843425675310141)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 SVG \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105874190021310164)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3CC\CD9C\B41C \B2E4\AC01\D615\C758 \B192\C774\B97C \ACB0\C815\D558\AE30 \C704\D574 \AC12\C744 \BC18\D658\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105874099480310164)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3CC\CD9C \AC12 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105875849446310165)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3CC\CD9C\B41C \B2E4\AC01\D615\C758 \B192\C774\B97C \ACB0\C815\D558\AE30 \C704\D55C \B2E8\C704\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105876193059310165)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.FOOT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105876049224310165)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.KM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0AC\B85C\BBF8\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105875920131310165)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.M.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105876221131310165)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.MILE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105875743292310165)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105848365757310144)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105848294302310144)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\CC44\C6B0\AE30 \C0C9\C0C1\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 3\AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105848189397310144)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC44\C6B0\AE30 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105857175686310151)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CE35\C5D0 <em>\C0C9\C0C1\D45C</em>\B97C \C0AC\C6A9\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C0C9\C0C1\D45C\B294 \C0C9\C0C1 \BAA9\B85D\C785\B2C8\B2E4. \D2B9\C815 \AC12\ACFC \CD5C\C18C\AC12 \BC0F \CD5C\B300\AC12\C744 \AE30\C900\C73C\B85C \B9F5 \C704\C82F\C774 \BAA9\B85D\C5D0\C11C \C774 \AC1D\CCB4\C5D0 \C0AC\C6A9\D560 \C2E4\C81C \D45C\C2DC \C0C9\C0C1\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105857089849310151)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1\D45C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106009921340310280)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\BE68\AC04\C0C9\BD80\D130 \D770\C0C9\AE4C\C9C0\C758 \C0C9\C0C1 \BAA9\B85D</dt>'),
unistr('    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>\D30C\B780\C0C9\BD80\D130 \AC80\C815\C0C9\AE4C\C9C0\C758 \C0C9\C0C1 \BAA9\B85D</dt>'),
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105857348612310151)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CE35\C758 \C0AC\C6A9\C790\C815\C758 <em>\C0C9\C0C1\D45C</em>\B97C \C9C0\C815\D569\B2C8\B2E4. \C0C9\C0C1\D45C\B294 \C0C9\C0C1 \BAA9\B85D\C785\B2C8\B2E4. \D2B9\C815 \AC12\ACFC \CD5C\C18C\AC12 \BC0F \CD5C\B300\AC12\C744 \AE30\C900\C73C\B85C \B9F5 \C704\C82F\C774 \BAA9\B85D\C5D0\C11C \C774 \AC1D\CCB4\C5D0 \C0AC\C6A9\D560 \C2E4\C81C \D45C\C2DC \C0C9\C0C1\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105857250422310151)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C0C9\C0C1 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105857519526310151)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1\D45C\C5D0\C11C \D45C\C2DC \C0C9\C0C1\C744 \ACB0\C815\D558\AE30 \C704\D574 \AC12\C744 \BC18\D658\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105857437868310151)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 \AC12 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105848532079310145)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC44\C6B0\AE30 \BD88\D22C\BA85\B3C4\B97C \C9C0\C815\D569\B2C8\B2E4. \BC94\C704\B294 0(\C644\C804 \D22C\BA85)\BD80\D130 1.0(\BD88\D22C\BA85)\AE4C\C9C0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105848416881310144)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC44\C6B0\AE30 \BD88\D22C\BA85\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105857701388310152)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1\D45C\C5D0\C11C \D45C\C2DC \C0C9\C0C1\C744 \ACB0\C815\D558\AE30 \C704\D574 \AC12\C744 \BC18\D658\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C120\D0DD\D55C \C5F4\C774 \C5C6\C73C\BA74 \D3EC\C778\D2B8 \BC00\B3C4\C5D0\C11C\B9CC \D45C\C2DC \C0C9\C0C1\C774 \ACB0\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105857680992310151)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105853590221310148)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D45C\D604\C2DD \B610\B294 \C9C0\C6D0\B418\B294 \B300\CCB4 \BB38\C790\C5F4\C744 \D1B5\D574 \C5F4 \B610\B294 \ACE0\AE09 \D615\C2DD \C9C0\C815\C744 \C0AC\C6A9\D558\C5EC \C815\BCF4 \CC3D\C774 \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C815\BCF4 \CC3D\C740 \B9F5\C5D0\C11C \AC1D\CCB4\B97C \B204\B97C \B54C \D31D\C5C5\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105853470084310148)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09 \D615\C2DD \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105853921764310149)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4 \CC3D \BCF8\BB38\C73C\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C815\BCF4 \CC3D\C740 \B9F5\C5D0\C11C \AC1D\CCB4\B97C \B20C\B800\C744 \B54C \D31D\C5C5\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105853810776310149)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105854413188310149)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4 \CC3D \D31D\C5C5\C744 \B80C\B354\B9C1\D560 \B54C \C0AC\C6A9\D560 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105854310143310149)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105854297966310149)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\BC30\ACBD \BC0F \D14D\C2A4\D2B8 \C0C9\C0C1 \BCC0\ACBD</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\C81C\BAA9 2 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL \C9C8\C758\C5D0\C11C \B3D9\C801 \D074\B798\C2A4 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \C774 \C608\C5D0\C11C <code>&COLUMN_CLASS.</code> \BC0F <code>&EMPLOYEE_STATUS.</code> \B300\CCB4\B294 \BCF4\ACE0\C11C SQL \C9C8\C758\C5D0\C11C \C120\D0DD\B41C \C5F4\C785\B2C8\B2E4.</dd>'),
unistr('  <dt>\C774\BBF8\C9C0 \D45C\C2DC \BC0F \CEE4\C11C\B97C \C704\B85C \AC00\C838\AC08 \B54C \B3C4\AD6C \C124\BA85 \D45C\C2DC</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105854165107310149)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\AC04 \AC1D\CCB4\B97C \B204\B97C \B54C \C815\BCF4 \D31D\C5C5\C73C\B85C \D45C\C2DC\D560 HTML \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4. <code>&COLUMN.</code> \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC HTML\C5D0 \C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105854060052310149)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105853728602310149)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4 \CC3D \C81C\BAA9\C73C\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C815\BCF4 \CC3D\C740 \B9F5\C5D0\C11C \AC1D\CCB4\B97C \B20C\B800\C744 \B54C \D31D\C5C5\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105853685068310148)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105877357783310166)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\B840 \B610\B294 \B3C4\AD6C \C124\BA85\C5D0 \D45C\C2DC\D558\AE30 \C704\D574 \C0AC\C6A9\D560 \B808\C774\BE14\C785\B2C8\B2E4. \C9C0\C815\D558\C9C0 \C54A\C73C\BA74 <strong>\C774\B984</strong> \C18D\C131\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105877186633310166)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CE35\C5D0 \B300\D574 \BC94\B840 \BC0F \B3C4\AD6C \C124\BA85 \B0B4\C5D0 \C0AC\C6A9\D560 \B808\C774\BE14\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105877014613310166)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105876933033310166)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105876802320310166)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D45C\C2DC\C790 \CC44\C6B0\AE30 \C0C9\C0C1\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 3\AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105876770751310166)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC44\C6C0 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105876664374310166)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC44\C6B0\AE30 \BD88\D22C\BA85\B3C4\B97C \C9C0\C815\D569\B2C8\B2E4. \BC94\C704\B294 0(\C644\C804 \D22C\BA85)\BD80\D130 1.0(\BD88\D22C\BA85)\AE4C\C9C0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105876512051310166)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC44\C6B0\AE30 \BD88\D22C\BA85\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105874445361310164)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105874339257310164)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D68D \C0C9\C0C1\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 3\AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105874200261310164)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68D \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105874676999310164)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68D \B108\BE44\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105874551527310164)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68D \B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105854662014310149)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18C\C2A4\C5D0\C11C \C774 \CE35\C73C\B85C \D589\C744 \C9C0\C815\D558\AE30 \C704\D574 \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105854591892310149)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105854897642310149)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18C\C2A4\C5D0\C11C \C774 \CE35\C73C\B85C \D589\C744 \C9C0\C815\D558\B294 <strong>\D589 \C9C0\C815 \C5F4</strong> <em>\AC12</em>\C744 \C81C\ACF5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105854775729310149)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CE35\C758 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105847898513310144)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105847725887310144)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D68D \C0C9\C0C1\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 3\AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105847627777310144)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68D \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105855056060310150)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68D \C2A4\D0C0\C77C\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105855387378310150)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DASHED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C120')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105855239676310150)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOTTED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C810\C120')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105855420699310150)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOT_DASHED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C810 \C1C4\C120')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105855178974310150)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.SOLID.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\C120')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105854900621310150)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68D \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105848026592310144)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68D \B108\BE44\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105847939559310144)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68D \B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105852699188310148)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B3C4\AD6C \C124\BA85\C774 \C5F4\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\B294\C9C0 \C544\B2C8\BA74 HTML \D45C\D604\C2DD \BC0F \C9C0\C6D0\B418\B294 \B300\CCB4 \BB38\C790\C5F4\C744 \D1B5\D55C \ACE0\AE09 \D615\C2DD \C9C0\C815\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\B294\C9C0 \C9C0\C815\D569\B2C8\B2E4. \B3C4\AD6C \C124\BA85\C740 \B9F5\C5D0\C11C \AC1D\CCB4 \C704\B85C \B9C8\C6B0\C2A4\B97C \AC00\C838\AC08 \B54C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105852554736310148)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09 \D615\C2DD \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105852874633310148)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\AD6C\C124\BA85\C73C\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105852789151310148)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105853370114310148)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\AD6C\C124\BA85\C744 \B80C\B354\B9C1\D560 \B54C \C0AC\C6A9\D560 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105853274744310148)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105853163913310148)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\BC30\ACBD \BC0F \D14D\C2A4\D2B8 \C0C9\C0C1 \BCC0\ACBD</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\C81C\BAA9 2 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL \C9C8\C758\C5D0\C11C \B3D9\C801 \D074\B798\C2A4 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \C774 \C608\C5D0\C11C <code>&COLUMN_CLASS.</code> \BC0F <code>&EMPLOYEE_STATUS.</code> \B300\CCB4\B294 \BCF4\ACE0\C11C SQL \C9C8\C758\C5D0\C11C \C120\D0DD\B41C \C5F4\C785\B2C8\B2E4.</dd>'),
unistr('  <dt>\C774\BBF8\C9C0 \D45C\C2DC \BC0F \CEE4\C11C\B97C \C704\B85C \AC00\C838\AC08 \B54C \B3C4\AD6C \C124\BA85 \D45C\C2DC</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105853025456310148)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C5D0\C11C \AC1D\CCB4 \C704\B85C \B9C8\C6B0\C2A4\B97C \AC00\C838\AC08 \B54C \B3C4\AD6C\C124\BA85\C73C\B85C \D45C\C2DC\D560 HTML \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4. <code>&COLUMN.</code> \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC HTML\C5D0 \C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105852909919310148)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105846931507310143)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C5D0 \D45C\C2DC\D560 GeoJSON \AC1D\CCB4\B97C \BC18\D658\D558\B294 \C5F4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105846879668310143)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('GeoJSON \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105847126231310144)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C5D0 \D45C\C2DC\D560 \B3C4\BA74 \AC1D\CCB4\B97C \BC18\D658\D558\B294 SDO_GEOMETRY \C5F4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105847036166310143)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\BA74 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105845532493310142)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\BA74 \C5F4\C758 \B370\C774\D130 \C720\D615\C744 \C2DD\BCC4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105845818368310143)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'ko'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105845907402310143)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('VARCHAR2 \B610\B294 CLOB \C720\D615\C778 GeoJSON\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105846042462310143)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\B3C4/\C704\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105846154056310143)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('NUMBER \C5F4 2\AC1C\B85C \D45C\C2DC\B418\B294 \ACBD\B3C4 \BC0F \C704\B3C4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105845671427310142)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'ko'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105845789772310142)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle SDO_GEOMETRY \C720\D615\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105845446319310142)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\BA74 \C5F4 \B370\C774\D130 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105846362559310143)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\BA74 \C5F4\C758 \B370\C774\D130 \C720\D615\C744 \C2DD\BCC4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105846462819310143)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.D'
,p_message_language=>'ko'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105846539442310143)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('VARCHAR2 \B610\B294 CLOB \C720\D615\C778 GeoJSON\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105846656620310143)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\B3C4/\C704\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105846782003310143)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('NUMBER \C5F4 2\AC1C\B85C \D45C\C2DC\B418\B294 \ACBD\B3C4 \BC0F \C704\B3C4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105846261426310143)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\BA74 \C5F4 \B370\C774\D130 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105845379258310142)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AE30\BCF8 \D14C\C774\BE14\C5D0 \ACF5\AC04 \C778\B371\C2A4\AC00 \C788\ACE0 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \D589\C744 \C778\CD9C\D560 \B54C \B9F5 \C704\C82F\C774 \C774\B97C \C0AC\C6A9\D574\C57C \D560 \ACBD\C6B0 \C774 \C2A4\C704\CE58\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D569\B2C8\B2E4. \C774 \ACBD\C6B0 \C704\C82F\C740 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \D604\C7AC \B9F5 \CC3D\C5D0 <em>\B300\D574\C11C\B9CC</em> \D589\C744 \C778\CD9C\D569\B2C8\B2E4. \B530\B77C\C11C \B370\C774\D130 \C18C\C2A4\C5D0 \B300\B7C9\C758 \D589\C774 \D3EC\D568\B41C \ACBD\C6B0 \C131\B2A5 \C774\C810\C744 \C81C\ACF5\D569\B2C8\B2E4.</p><p>\ACF5\AC04 \C778\B371\C2A4\B294 SQL \C6CC\D06C\C20D\C5D0\C11C SDO_GEOMETRY \C5F4\C5D0 \C0DD\C131\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C0C1\D669\C5D0\C11C\B294 \ACF5\AC04 \C778\B371\C2A4\AC00 \C0AC\C6A9\B418\C9C0 <em>\C54A\C2B5\B2C8\B2E4</em>.</p>'),
'<ul>',
unistr('<li>\B450 \AC1C \C774\C0C1\C758 \CE35\C774 <strong>\C601\C5ED \C18C\C2A4</strong>\B97C \D574\B2F9 \B370\C774\D130 \C18C\C2A4\B85C \CC38\C870\D569\B2C8\B2E4.</li>'),
unistr('<li>\B9F5 \CC3D\C774 \B108\BB34 \D07D\B2C8\B2E4. \C989, \C804 \C138\ACC4 \C808\BC18 \C774\C0C1\C5D0 \AC78\CCD0\C9D1\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105845209694310142)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\AC04 \C778\B371\C2A4 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105847593139310144)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C5D0 \D45C\C2DC\D560 \ACF5\AC04 \AC1D\CCB4\C758 \C704\B3C4\B97C \D3EC\D568\D558\B294 NUMBER \C5F4\C785\B2C8\B2E4. \BC18\D658\B41C \AC12\C740 -90~90 \C0AC\C774\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105847401225310144)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\B3C4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105863182411310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \C815\C758\B41C \BC1C\C0B0\D615 \C0C9\C0C1\D45C \C911 \D558\B098\B97C \C120\D0DD\D569\B2C8\B2E4. \D55C \ADF9\B2E8\C5D0\C11C \B2E4\B978 \ADF9\B2E8\C73C\B85C \C774\B3D9\D558\B294 \BC1C\C0B0\D615 \AC12\C744 \C2DC\AC01\D654\D558\B294 \B370 \C801\D569\D569\B2C8\B2E4. cartocolor\C758 \C0C9\C0C1\D45C\C785\B2C8\B2E4(<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub\C758 CARTOcolor)</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105863247553310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('"\C721\AD70" - \B85C\C988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105863378108310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105864446147310157)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\AD6C \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105864579671310157)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105863402637310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B099\C5FD \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105863567406310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105863635586310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D5D0\CC9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105863701812310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105864099651310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAD\B85D - \B85C\C988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105864168584310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105863826613310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C784\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105863999691310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105864277775310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\B300 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105864318298310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105863065675310156)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\ACC4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105864786804310157)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \C815\C758\B41C \BC94\C8FC\D615 \C0C9\C0C1\D45C \C911 \D558\B098\B97C \C120\D0DD\D569\B2C8\B2E4. \ACE0\C720 \AC12\C744 \C2DC\AC01\D654\D558\B294 \B370 \C801\D569\D569\B2C8\B2E4. cartocolor\C758 \C0C9\C0C1\D45C\C785\B2C8\B2E4(<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub\C758 CARTOcolor)</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105864873607310157)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C564\D2F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105864975142310157)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105865051655310157)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD75\C740\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105865187792310157)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105865243346310157)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C2A4\D154')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105865318305310157)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105865462897310157)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B9AC\C998')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105865502416310157)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105865612307310157)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE08\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105865769428310158)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105865855568310158)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\BA85\D55C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105865929034310158)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105864623501310157)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\ACC4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105859146145310153)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \C815\C758\B41C \C21C\CC28\D615 \C0C9\C0C1\D45C \C911 \D558\B098\B97C \C120\D0DD\D569\B2C8\B2E4. \B0AE\C740 \AC12\BD80\D130 \B192\C740 \AC12\AE4C\C9C0 \C21C\CC28\D615 \AC12\C744 \C2DC\AC01\D654\D558\B294 \B370 \C801\D569\D569\B2C8\B2E4. cartocolor\C758 \C0C9\C0C1\D45C\C785\B2C8\B2E4(<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub\C758 CARTOcolor)</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105860699304310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\B780\C0C9 - \B179\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105860769116310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105861209078310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\B780\C0C9 - \B178\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105861383860310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105862899826310155)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC08\C0C9 - \B178\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105862922732310155)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105859225112310153)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\AC74\B514')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105859330817310153)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105859424861310153)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\AC74\B514 - \B178\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105859567032310153)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105860867197310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C4\D55C \BBFC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105860955751310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105861061842310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5D0\BA54\B784\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105861102853310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105862469089310155)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C820\D0C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105862503780310155)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105860428426310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBFC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105860572990310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105859844760310153)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\D669\C0C9 - \B178\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105859996904310153)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105860039436310153)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C22D\C544')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105860136007310153)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105860269339310153)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\D64D\C0C9 - \B178\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105860333741310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105861857098310155)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105861941587310155)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105862018946310155)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\C8FC - \C8FC\D669\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105862102202310155)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105859637871310153)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE68\AC04\C0C9 - \C8FC\D669\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105859736466310153)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105862209215310155)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BAB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105862395762310155)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105862617004310155)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D9\C740 \C77C\BAB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105862767760310155)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105861476430310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAD\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105861555666310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105861678787310154)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAD\B85D - \B179\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105861706103310155)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105859013295310153)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\ACC4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105877707930310167)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105877866441310167)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF64\B9C8\B85C \AD6C\BD84\B41C HTML \C0C9\C0C1(#rrggbb) \BAA9\B85D\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105858379733310152)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1\D45C \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105858674492310152)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1C\C0B0\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105858743665310152)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C0C9\C0C1\D45C\B294 \D558\B098\C758 \ADF9\B2E8\C5D0\C11C \B2E4\B978 \ADF9\B2E8\C73C\B85C \C774\B3D9\D558\B294 \BC1C\C0B0\D615 \AC12\C744 \C2DC\AC01\D654\D558\B294 \B370 \C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105858834654310152)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C8FC\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105858954915310152)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C0C9\C0C1\D45C\B294 \ACE0\C720 \AC12\C744 \C2DC\AC01\D654\D558\B294 \B370 \C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105858437258310152)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C21C\CC28\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105858506368310152)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C0C9\C0C1\D45C\B294 \B0AE\C740 \AC12\C5D0\C11C \B192\C740 \AC12\AE4C\C9C0 \C21C\CC28\D615 \AC12\C744 \C2DC\AC01\D654\D558\B294 \B370 \C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105858260722310152)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1\D45C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106010311189310280)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\BE68\AC04\C0C9\BD80\D130 \D770\C0C9\AE4C\C9C0\C758 \C0C9\C0C1 \BAA9\B85D</dt>'),
unistr('    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>\D30C\B780\C0C9\BD80\D130 \AC80\C815\C0C9\AE4C\C9C0\C758 \C0C9\C0C1 \BAA9\B85D</dt>'),
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105873949597310164)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D788\D2B8 \B9F5 \CE35\C758 \C0AC\C6A9\C790\C815\C758 <em>\C0C9\C0C1\D45C</em>\B97C \C9C0\C815\D569\B2C8\B2E4. \C0C9\C0C1\D45C\B294 \C0C9\C0C1 \BAA9\B85D\C785\B2C8\B2E4. \D2B9\C815 \AC12\ACFC \CD5C\C18C\AC12 \BC0F \CD5C\B300\AC12\C744 \AE30\C900\C73C\B85C \B9F5 \C704\C82F\C774 \BAA9\B85D\C5D0\C11C \C774 \AC1D\CCB4\C5D0 \C0AC\C6A9\D560 \C2E4\C81C \D45C\C2DC \C0C9\C0C1\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105873816929310164)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C0C9\C0C1 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105870922414310161)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \C815\C758\B41C \BC1C\C0B0\D615 \C0C9\C0C1\D45C \C911 \D558\B098\B97C \C120\D0DD\D569\B2C8\B2E4. \D55C \ADF9\B2E8\C5D0\C11C \B2E4\B978 \ADF9\B2E8\C73C\B85C \C774\B3D9\D558\B294 \BC1C\C0B0\D615 \AC12\C744 \C2DC\AC01\D654\D558\B294 \B370 \C801\D569\D569\B2C8\B2E4. cartocolor\C758 \C0C9\C0C1\D45C\C785\B2C8\B2E4(<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub\C758 CARTOcolor)</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105871094540310162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('"\C721\AD70" - \B85C\C988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105871171902310162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105872209569310162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\AD6C \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105872335391310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105871269636310162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B099\C5FD \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105871301955310162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105871481269310162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\D5D0\CC9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105871550526310162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105871860704310162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAD\B85D - \B85C\C988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105871961945310162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105871680326310162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C784\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105871736234310162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105872010366310162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\B300 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105872142332310162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105870817997310161)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\ACC4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105872552770310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \C815\C758\B41C \BC94\C8FC\D615 \C0C9\C0C1\D45C \C911 \D558\B098\B97C \C120\D0DD\D569\B2C8\B2E4. \ACE0\C720 \AC12\C744 \C2DC\AC01\D654\D558\B294 \B370 \C801\D569\D569\B2C8\B2E4. cartocolor\C758 \C0C9\C0C1\D45C\C785\B2C8\B2E4(<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub\C758 CARTOcolor)</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105872615068310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C564\D2F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105872783790310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105872863201310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD75\C740\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105872972348310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105873051623310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C2A4\D154')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105873193168310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105873297102310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B9AC\C998')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105873397218310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105873409345310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE08\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105873550541310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105873658700310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\BA85\D55C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105873753247310164)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105872479074310163)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\ACC4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105866960798310158)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \C815\C758\B41C \C21C\CC28\D615 \C0C9\C0C1\D45C \C911 \D558\B098\B97C \C120\D0DD\D569\B2C8\B2E4. \B0AE\C740 \AC12\BD80\D130 \B192\C740 \AC12\AE4C\C9C0 \C21C\CC28\D615 \AC12\C744 \C2DC\AC01\D654\D558\B294 \B370 \C801\D569\D569\B2C8\B2E4. cartocolor\C758 \C0C9\C0C1\D45C\C785\B2C8\B2E4(<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub\C758 CARTOcolor)</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105868462538310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\B780\C0C9 - \B179\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105868501755310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105869018162310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\B780\C0C9 - \B178\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105869123220310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105870635771310161)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC08\C0C9 - \B178\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105870762746310161)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105867049523310159)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\AC74\B514')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105867137361310159)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105867298431310159)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\AC74\B514 - \B178\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105867397377310159)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105868681766310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C4\D55C \BBFC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105868725486310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105868892749310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5D0\BA54\B784\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105868912051310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105870265498310161)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C820\D0C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105870392201310161)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105868225493310159)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBFC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105868300675310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105867627844310159)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\D669\C0C9 - \B178\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105867793566310159)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105867811682310159)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C22D\C544')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105867978071310159)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105868033357310159)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\D64D\C0C9 - \B178\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105868107199310159)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105869605031310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105869786493310161)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105869838466310161)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\C8FC - \C8FC\D669\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105869908383310161)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105867446339310159)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE68\AC04\C0C9 - \C8FC\D669\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105867580114310159)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105870097462310161)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BAB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105870108092310161)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105870496447310161)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D9\C740 \C77C\BAB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105870555179310161)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105869283709310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAD\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105869308534310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105869480903310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAD\B85D - \B179\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105869579955310160)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'ko'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105866827899310158)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\ACC4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105877982066310167)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105878026559310167)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF64\B9C8\B85C \AD6C\BD84\B41C HTML \C0C9\C0C1(#rrggbb) \BAA9\B85D\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105866173052310158)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1\D45C \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105866433110310158)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1C\C0B0\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105866587754310158)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C0C9\C0C1\D45C\B294 \D558\B098\C758 \ADF9\B2E8\C5D0\C11C \B2E4\B978 \ADF9\B2E8\C73C\B85C \C774\B3D9\D558\B294 \BC1C\C0B0\D615 \AC12\C744 \C2DC\AC01\D654\D558\B294 \B370 \C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105866666923310158)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C8FC\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105866799704310158)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C0C9\C0C1\D45C\B294 \ACE0\C720 \AC12\C744 \C2DC\AC01\D654\D558\B294 \B370 \C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105866249237310158)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C21C\CC28\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105866342915310158)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C0C9\C0C1\D45C\B294 \B0AE\C740 \AC12\C5D0\C11C \B192\C740 \AC12\AE4C\C9C0 \C21C\CC28\D615 \AC12\C744 \C2DC\AC01\D654\D558\B294 \B370 \C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105866063204310158)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1\D45C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105855917180310150)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CE35\C758 \C720\D615\C744 \C2DD\BCC4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105856681789310151)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D788\D2B8 \B9F5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105856793455310151)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D788\D2B8 \B9F5\C73C\B85C \D45C\C2DC\B418\B294 \D3EC\C778\D2B8 \AC1D\CCB4\C785\B2C8\B2E4. \D788\D2B8 \B9F5\C740 \D3EC\C778\D2B8 \AC1D\CCB4\C758 \BC00\B3C4\B97C \C2DC\AC01\D654\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105856246697310150)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105856359564310151)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B77C\C778 \AC1D\CCB4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105856022954310150)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C810')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105856130954310150)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\C778\D2B8 \AC1D\CCB4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105856494852310151)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\AC01\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105856526374310151)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\AC01\D615 \AC1D\CCB4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105856898852310151)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3CC\CD9C\B41C \B2E4\AC01\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105856970524310151)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('3D \AC1D\CCB4\B85C "\B3CC\CD9C\B41C" \B2E4\AC01\D615\C785\B2C8\B2E4. \B192\C774\B294 \ACB0\ACFC \C5F4 \AC12\C744 \AE30\C900\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105855848775310150)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE35 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105858181062310152)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CE35\C744 \D45C\C2DC \C0C1\D0DC\B85C \C720\C9C0\D558\AE30 \C704\D55C \CD5C\B300 \D655\B300/\CD95\C18C \B808\BCA8\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105858090281310152)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105857943648310152)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CE35\C744 \D45C\C2DC\D558\AE30 \C704\D55C \CD5C\C18C \D655\B300/\CD95\C18C \B808\BCA8\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105857877336310152)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105847339817310144)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C5D0 \D45C\C2DC\D560 \ACF5\AC04 \AC1D\CCB4\C758 \ACBD\B3C4\B97C \D3EC\D568\D558\B294 NUMBER \C5F4\C785\B2C8\B2E4. \BC18\D658\B41C \AC12\C740 -180~180 \C0AC\C774\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105847280569310144)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\B3C4 \C5F4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105851241132310147)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C5D0 \ACF5\B3D9 \BC30\CE58 \D3EC\C778\D2B8\B97C \D074\B7EC\C2A4\D130\D654\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105851160247310146)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105848701235310145)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\C778\D2B8 \AC1D\CCB4\B97C \D45C\C2DC\D560 \BC29\BC95\C744 \C2DD\BCC4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105849078785310145)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105849196392310145)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105848841746310145)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.D'
,p_message_language=>'ko'
,p_message_text=>'SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105848983707310145)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SVG \BAA8\C591\C73C\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105848625044310145)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105850772069310146)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\C778\D2B8 \AC1D\CCB4\B97C \D45C\C2DC\D560 SVG \BAA8\C591\C744 \C9C0\C815\D569\B2C8\B2E4. \C0AC\C804 \C815\C758\B41C \BAA8\C591\C5D0\C11C \C120\D0DD\D558\AC70\B098 <strong>\C0AC\C6A9\C790\C815\C758 SVG \C2A4\D0C0\C77C</strong> \B9F5 \C601\C5ED \C18D\C131\C5D0 \C9C0\C815\B41C <em>\C0AC\C6A9\C790\C815\C758 SVG \BAA8\C591</em>\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C774 \C9C0\C815\B418\C9C0 \C54A\C558\AC70\B098 \C9C0\C815\B41C \C774\B984\C774 \AE30\BCF8 \B610\B294 \C0AC\C6A9\C790\C815\C758 SVG \BAA8\C591 \BAA9\B85D\C5D0 \C5C6\C73C\BA74 <strong>\AE30\BCF8\AC12</strong> \BAA8\C591\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105884015516310172)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\BA54\B77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105891040290310177)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105889279715310176)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105892367060310178)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105884196900310172)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0 \B300\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105891211762310177)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105850965134310146)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105891138490310177)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105883903268310172)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105890942462310177)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105884290166310172)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC0C\D478\B9B0 \C5BC\AD74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105891372013310177)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105884339487310172)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B530\BD84\D55C \C5BC\AD74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105891427865310177)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105884498452310172)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6C3\B294 \C5BC\AD74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105891583732310178)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105889742878310176)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0BC\AC01 \AE43\BC1C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105892864897310179)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105889816038310176)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BE44\AF2C\B9AC \AE43\BC1C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105892906457310179)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105884866327310172)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105892001727310178)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105889368468310176)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105892462470310178)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105884946234310172)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\AC01\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105892118414310178)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105884657466310172)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0 \ACE0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105891810823310178)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105884762697310172)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\AC01\D615 \ACE0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105891937677310178)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105889582325310176)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE5B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105892688179310178)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105889491773310176)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2AC\B798\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105892575166310178)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105884511298310172)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\AC01\D615 \B300\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105891774744310178)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105850846724310146)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\AC01\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105891688982310178)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105889639462310176)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC70\B9AC \BDF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105892754386310178)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105851089183310146)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0BC\AC01\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105892266714310178)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'ko'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105850658352310146)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105885161087310172)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SVG \BAA8\C591\C758 \BC30\C728 \C778\C218\B97C \C9C0\C815\D569\B2C8\B2E4. \CD5C\B300 \BC30\C728\C740 <strong>10</strong>\C785\B2C8\B2E4. \C5F4 \B300\CCB4 \D56D\BAA9\C774 \C0AC\C6A9\B418\ACE0 \AC12\C774 <strong>10</strong>\BCF4\B2E4 \D06C\BA74 JavaScript \CF58\C194\C5D0 \BA54\C2DC\C9C0\AC00 \AE30\B85D\B418\ACE0 <strong>10</strong> \BC30\C728 \C778\C218\B85C \D45C\C2DC\C790\AC00 \D45C\C2DC\B429\B2C8\B2E4. \B9F5 \AD6C\C131\C694\C18C\B294 \AC12\C744 \CCAB\BC88\C9F8 \C18C\C218\C810 \C790\B9BF\C218\B85C \BC18\C62C\B9BC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105885015815310172)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591 \BC30\C728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105850109356310146)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 CSS \D074\B798\C2A4\AC00 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105850067597310146)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105850592680310146)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C18C\C2A4\B85C \C0AC\C6A9\D560 CSS \D074\B798\C2A4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105850419259310146)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105850328236310146)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \C18C\C2A4\C5D0 \B300\D55C URL\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105850201774310146)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105849399835310145)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C5D0 \D3EC\C778\D2B8\B97C \D45C\C2DC\D560 \C544\C774\CF58\C758 \C18C\C2A4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105849687818310145)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \D074\B798\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105849729055310145)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01 \D589\C5D0 \B300\D574 \AC1C\BCC4 CSS \D074\B798\C2A4\B97C \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105849405751310145)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105849587394310145)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \D589\C5D0 \B300\D574 \C815\C801 CSS \D074\B798\C2A4\B97C \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105849864098310146)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105849982323310146)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\C778\D2B8 \D45C\C2DC\C5D0 \C0AC\C6A9\D560 \C774\BBF8\C9C0 URL\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105849203010310145)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105840125940310138)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\D0C0 \B9F5 \C704\C82F \D56D\BAA9\C744 \C0AC\C6A9 \B610\B294 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105841237172310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE0C\B77C\C6B0\C800 \C704\CE58 \AC00\C838\C624\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105841378505310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE0C\B77C\C6B0\C800\C5D0\C11C \C0AC\C6A9\C790\C758 \D604\C7AC \C704\CE58\B97C \AC00\C838\C635\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105841469291310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0 \B3C4\AD6C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105841526028310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0 \B3C4\AD6C\B97C \C0AC\C6A9\D558\C5EC \C77C\BC18 \C0AC\C6A9\C790\AC00 \B9F5\C5D0 \C6D0\C744 \ADF8\B9B4 \C218 \C788\C2B5\B2C8\B2E4. \C644\B8CC\B418\BA74 \C774\BCA4\D2B8\AC00 \D2B8\B9AC\AC70\B418\ACE0, Dynamic Actions \B610\B294 JavaScript \CF54\B4DC\B85C \C6D0\C774 \CC98\B9AC\B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105841642567310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC70\B9AC \B3C4\AD6C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105841798023310140)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \B9F5\C5D0\C11C \D3EC\C778\D2B8 \AC04 \AC70\B9AC\B97C \CE21\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105841092949310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\D55C \B9F5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105841147779310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\D55C \B9F5 \C2A4\D06C\B864\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105840202800310138)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C6B0\C2A4 \D720 \D655\B300/\CD95\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105840349244310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C6B0\C2A4 \D720\C744 \C0AC\C6A9\D558\C5EC \D655\B300\D558\AC70\B098 \CD95\C18C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105840892993310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C694 \B9F5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105840915540310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD \C544\B798\C5D0 \AC1C\C694 \B9F5\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105840481801310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C1\C0AC\AC01\D615 \D655\B300/\CD95\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105840532695310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C5D0 \C9C1\C0AC\AC01\D615\C744 \ADF8\B824\C11C \B9F5\C744 \D2B9\C815 \C601\C5ED\C73C\B85C \D655\B300\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105840669177310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\C728 \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105840731718310139)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C5D0 \BC30\C728 \B9C9\B300\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105840098556310138)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105845012070310142)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5 \C601\C5ED\C758 \B192\C774\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105844970951310142)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B192\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105845135324310142)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53D\C140')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105843339462310141)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\B840\C5D0 \CD94\AC00\D560 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105843232242310141)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105843155142310141)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\B840\B97C \D45C\C2DC\D560 \C694\C18C\C758 jQuery \C120\D0DD\AE30\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105843026494310141)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105842332969310140)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\B840 \C704\CE58\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105842600157310140)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B05D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105842721284310140)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \C704\CE58(\C77C\BC18\C801\C73C\B85C \B9F5\C758 \C544\B798\CABD)\C5D0 \BC94\B840\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105842876247310140)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105842994493310140)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\B840\B97C \D45C\C2DC\D560 \C694\C18C\C758 jQuery \C120\D0DD\AE30\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105842477889310140)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105842568849310140)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \C704\CE58(\C77C\BC18\C801\C73C\B85C \B9F5\C758 \C704\CABD)\C5D0 \BC94\B840\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105842218652310140)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105877208600310166)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106010195400310280)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE35 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105843872801310141)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5 \CE35\C5D0 \B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C74C \BC0F \B354 \B9CE\C740 \B370\C774\D130\B97C \BC1C\ACAC\D568 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D560 \C704\CE58\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105843924591310141)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105844043644310141)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5 \C704\C5D0 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105844117360310141)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105844202361310141)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5 \C544\B798\C5D0 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105844356624310141)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105844483446310142)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0\B97C \D45C\C2DC\D560 \C694\C18C\C5D0 \B300\D574 jQuery \C120\D0DD\AE30\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105843701750310141)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0 \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105844625328310142)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0\B97C \D45C\C2DC\D560 \C694\C18C\C758 jQuery \C120\D0DD\AE30\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105844558122310142)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0 \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105842110447310140)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\B840 \D45C\C2DC \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105842049024310140)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105844839124310142)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0 \D56D\BAA9\C744 \C120\D0DD\D558\BA74 \B9F5 \C601\C5ED\C774 \D56D\C0C1 \D604\C7AC \B9F5 \ACBD\ACC4 \C0C1\C790\B97C \C774 \D56D\BAA9\C758 \AC12\C5D0 \B530\B77C GeoJSON \D615\C2DD\C73C\B85C \C720\C9C0\D569\B2C8\B2E4. \C774\AC83\C740 \B9F5\C744 \B2E4\B978 APEX \AD6C\C131\C694\C18C(\C608: \AE30\BCF8 \B610\B294 \B300\D654\C2DD \BCF4\ACE0\C11C)\C5D0 \C811\C18D\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4. \ACBD\ACC4 \C0C1\C790 \D56D\BAA9\C758 \B0B4\C6A9\C740 \B2E4\B978 \AD6C\C131\C694\C18C\C5D0\C11C \ACF5\AC04 \C9C8\C758\B97C \C218\D589\D558\AC70\B098 \B9F5\C5D0 \D45C\C2DC \AC00\B2A5\D55C \B370\C774\D130\B9CC \D45C\C2DC\D558\AE30 \C704\D55C \C6A9\B3C4\B85C \C0AC\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C77C\BD80 \B9F5 \C774\B3D9 \B610\B294 \D655\B300/\CD95\C18C \B808\BCA8 \BCC0\ACBD \D6C4 \ACBD\ACC4 \C0C1\C790 \D56D\BAA9\C758 \CF58\D150\CE20 \C608:</p>'),
'<pre>',
'{',
'  "type": "Polygon",',
'  "coordinates": [[',
'                    [-5.499,46.380],',
'                    [ 8.187,46.380],',
'                    [ 8.187,49.550],',
'                    [-5.499,49.550],',
'                    [-5.499,46.380]]]',
'}',
'</pre>',
'<p>',
unistr('<strong>\C0C8\B85C\ACE0\CE68</strong> \B3D9\C801 \C791\C5C5\C744 \C0AC\C6A9\D558\C5EC \B9F5\C744 \BCF4\ACE0\C11C \C601\C5ED\C5D0 \C5F0\ACB0\D560 \C218 \C788\C2B5\B2C8\B2E4. \BCF4\ACE0\C11C \C601\C5ED\C740 \ACF5\AC04 \D544\D130\B97C \C801\C6A9\D558\C5EC \B9F5\C5D0\C11C\B3C4 \D45C\C2DC \AC00\B2A5\D55C \ACB0\ACFC\B9CC \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\BCF4\ACE0\C11C \C9C8\C758 \C608:</p>'),
'<pre>',
'select [column1],',
'       [column2],',
'       ...',
'  from ...',
' where sdo_anyinteract(',
'           [geometry-column],',
'           sdo_util.from_geojson( :[item-name-of-bounding-box-item] )',
'       ) = ''TRUE''',
'   and ...',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105844779534310142)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACC4 \C0C1\C790 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105874826794310164)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\C728 \B9C9\B300 \BC0F \AC70\B9AC \B3C4\AD6C\C5D0 \C0AC\C6A9\D560 \B2E8\C704 \C2DC\C2A4\D15C\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105875155571310165)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\AD6D\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105875206736310165)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\AD6D\C2DD \C2DC\C2A4\D15C\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105875360145310165)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C5D0\C11C \D30C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105875494420310165)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C758 \AC12 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C5D0\C11C \B2E8\C704 \C2DC\C2A4\D15C\C744 \D30C\C0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105874933861310164)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE21\C815\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105875033872310165)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE21\C815\D56D\BAA9 \C2DC\C2A4\D15C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105874732131310164)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C704 \C2DC\C2A4\D15C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105875632356310165)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<strong>METRIC</strong>(<strong>M</strong>) \B610\B294 <strong>IMPERIAL</strong>(<strong>I</strong>)\ACFC \AC19\C774 \B9F5 \B2E8\C704 \C2DC\C2A4\D15C\C73C\B85C \C0AC\C6A9\D560 \AC12\C774 \D3EC\D568\B41C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105875573470310165)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C704 \C2DC\C2A4\D15C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105502397686309863)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B370\C774\D130 \D56D\BAA9\C5D0\C11C \D45C\C2DC\C790\AC00 \B80C\B354\B9C1\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105502442877309863)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105502671029309863)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.OFF.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105502512363309863)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.ON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105502228501309863)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105502819730309863)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B370\C774\D130 \D56D\BAA9\C5D0\C11C \B80C\B354\B9C1\D560 \D45C\C2DC\C790\C758 \BAA8\C591\C744 \C120\D0DD\D569\B2C8\B2E4. \BC94\C704 \ACC4\C5F4\C5D0 \B300\D574\C11C\B294 <strong>\C790\B3D9</strong>\B9CC \C9C0\C6D0\B429\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105502977008309863)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105503030469309863)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105503198648309863)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.DIAMOND.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C774\C544\BAAC\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105503297628309863)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.HUMAN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\B78C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105503350592309864)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.PLUS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B354\D558\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105503463426309864)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.SQUARE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\AC01\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105528663857309885)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.STAR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105503590724309864)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEDOWN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5ED\C0BC\AC01\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105503631156309864)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEUP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0BC\AC01\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105502720902309863)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105618745593309957)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C5F4\C774 \C601\C5ED \C124\C815\C758 <strong>\B9C8\C2A4\D130 \C601\C5ED</strong>\C5D0\C11C \C9C0\C815\B41C \B300\B85C \B9C8\C2A4\D130 \B300\D654\C2DD \ADF8\B9AC\B4DC \C601\C5ED\C5D0 \B300\D55C \C678\B798 \D0A4 \C5F4\C778 \ACBD\C6B0 \B9C8\C2A4\D130 \D14C\C774\BE14\C5D0\C11C \D574\B2F9\D558\B294 \AE30\BCF8 \D0A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('        <p>\C608\B97C \B4E4\C5B4, \B9C8\C2A4\D130 \C601\C5ED\C774 DEPT\C774\ACE0 \C774 \B300\D654\C2DD \ADF8\B9AC\B4DC\AC00 EMP\C778 \ACBD\C6B0 EMP \B300\D654\C2DD \ADF8\B9AC\B4DC \B0B4\C5D0\C11C DEPTNO \C5F4\C744 \C120\D0DD\D55C \B2E4\C74C \B9C8\C2A4\D130 \C5F4\C5D0 \B300\D55C DEPT \C5F4 \BAA9\B85D\C5D0\C11C DEPTNO \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105618662114309957)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105436510270309807)
,p_name=>'PE.PROPERTY.MASTER_REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B514\D14C\C77C \C601\C5ED\C774 \C18D\D558\B294 \B9C8\C2A4\D130 \C601\C5ED\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('        \C774 \C601\C5ED\C774 \C774 \D398\C774\C9C0\C5D0 \C788\B294 \B2E4\B978 \C601\C5ED\ACFC \B9C8\C2A4\D130-\B514\D14C\C77C \AD00\ACC4\C758 \B514\D14C\C77C \C601\C5ED\C77C \B54C \C124\C815\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('        <p>\B9C8\C2A4\D130-\B514\D14C\C77C \AD00\ACC4\AC00 \C62C\BC14\B974\AC8C \C791\B3D9\D558\B3C4\B85D \D558\B824\BA74 \B9C8\C2A4\D130 \C601\C5ED\C5D0 \B300\D55C \C678\B798 \D0A4\C778 \C774 \C601\C5ED\C758 \C5F4\C744 \C120\D0DD\D558\ACE0 \ADF8\C5D0 \B530\B77C <strong>\B9C8\C2A4\D130 \C5F4</strong>\C744 \C9C0\C815\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105436453549309807)
,p_name=>'PE.PROPERTY.MASTER_REGION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105548470000309901)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B2F9 \D589 \C120\D0DD\AE30\C5D0 \D45C\C2DC\D560 \CD5C\B300 \C218\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105548383536309901)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B2F9 \CD5C\B300 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105879970482310168)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CE35\C5D0\C11C \CC98\B9AC\D560 \C218 \C788\B294 \CD5C\B300 \D589 \C218\B97C \C785\B825\D569\B2C8\B2E4. \B108\BB34 \B9CE\C774 \B2E4\C6B4\B85C\B4DC\B418\ACE0 \B9F5\C5D0 \D45C\C2DC\B418\B294 \ACF5\AC04 \AC1D\CCB4\C5D0 \B300\D55C \CE21\C815 \B2E8\C704\B85C \C0AC\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105547697409309901)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C8\C758\C5D0\C11C \CC98\B9AC\D560 \C218 \C788\B294 \CD5C\B300 \D589 \C218\B97C \C785\B825\D569\B2C8\B2E4. \CC98\B9AC\D560 \CD5C\B300 \D589 \C218\AC00 \C81C\D55C\C744 \CD08\ACFC\D558\BA74 \B370\C774\D130 \B300\C2E0 \C624\B958 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('<strong>\B354 \B9CE\C740 \B370\C774\D130\B97C \BC1C\ACAC\D568</stron>\C5D0\C11C \BA54\C2DC\C9C0\B97C \C9C0\C815\D558\C5EC \C0AC\C6A9\C790\C815\C758 \BA54\C2DC\C9C0\B97C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C18D\C131\C740 \B9E4\C6B0 \D070 \D14C\C774\BE14 \B610\B294 \BCF4\AE30\C5D0 \C788\B294 \BAA8\B4E0 \B808\CF54\B4DC\C5D0 \B300\D574 \C791\C5C5(\C608: \C815\B82C \B610\B294 \C9D1\ACC4)\C744 \C218\D589\D558\B294 \C77C\BC18 \C0AC\C6A9\C790\B97C \BCF4\D638\D558\AE30 \C704\D55C \AC83\C785\B2C8\B2E4. \C774\B7EC\D55C \C791\C5C5\C740 \C218\D589\B418\C9C0 \C54A\C744 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774 \ACBD\C6B0 \D544\D130\B97C \CD94\AC00\D558\AE30 \C804\C5D0 \CC98\B9AC\D560 \B808\CF54\B4DC \C218\B97C \C904\C5EC\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105547522854309900)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\D560 \CD5C\B300 \D589 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105914056500310195)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\AC00 \C5F4\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\B294\C9C0 \C544\B2C8\BA74 HTML \D45C\D604\C2DD \BC0F \C9C0\C6D0\B418\B294 \B300\CCB4 \BB38\C790\C5F4\C744 \D1B5\D55C \ACE0\AE09 \D615\C2DD \C9C0\C815\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\B294\C9C0 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105913994289310195)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09 \D615\C2DD \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105921802840310201)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105916423294310197)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B9E4\CCB4\C5D0 \B300\D55C \AC00\B85C \C138\B85C \BE44\C728\C744 \ACB0\C815\D569\B2C8\B2E4.'),
unistr('<strong>\C790\B3D9</strong>: \C790\B3D9 \B9DE\CDA4\C744 \C0AC\C6A9\D558\C5EC \C6D0\B798 \B9E4\CCB4 \D06C\AE30\B97C \C720\C9C0\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105916512804310197)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\AC01\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105916668517310197)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\AC01\D615 \AC00\B85C \C138\B85C \BE44\C728\C744 \C801\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105916789327310197)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C640\C774\B4DC\C2A4\D06C\B9B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105916867345310197)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C640\C774\B4DC\C2A4\D06C\B9B0 \AC00\B85C \C138\B85C \BE44\C728\C744 \C801\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105916355511310197)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105915425515310196)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\CCB4 \C18C\C2A4\C5D0 \B300\D574 BLOB\C744 \BC18\D658\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105915340910310196)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('BLOB \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105917671657310197)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105917597245310197)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105917866782310198)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D14D\C2A4\D2B8\B294 \B9E4\CCB4\B97C \C124\BA85\D558\BA70 \C774\BBF8\C9C0\C5D0 \B300\D55C \B3C4\AD6C \C124\BA85 \BC0F \B300\CCB4 \D14D\C2A4\D2B8\C5D0 \C0AC\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105917750229310198)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105915641494310196)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC\C5D0\C11C \B9E4\CCB4 \AD6C\C131\C694\C18C\AC00 \BC30\CE58\B418\B294 \C704\CE58\B97C \ACB0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105916103451310196)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\ACBD \C774\BBF8\C9C0\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105916245449310196)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC \BC30\ACBD\C73C\B85C \B9E4\CCB4\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105915961949310196)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105916045446310196)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC \BCF8\BB38 \B0B4\C5D0 \B9E4\CCB4\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105915700874310196)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105915894423310196)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC \BA38\B9AC\AE00 \C55E\C5D0 \B9E4\CCB4\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105915564512310196)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105914305538310195)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\BC30\ACBD \BC0F \D14D\C2A4\D2B8 \C0C9\C0C1 \BCC0\ACBD</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\C81C\BAA9 2 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL \C9C8\C758\C5D0\C11C \B3D9\C801 \D074\B798\C2A4 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \C774 \C608\C5D0\C11C <code>&COLUMN_CLASS.</code> \BC0F <code>&EMPLOYEE_STATUS.</code> \B300\CCB4\B294 \BCF4\ACE0\C11C SQL \C9C8\C758\C5D0\C11C \C120\D0DD\B41C \C5F4\C785\B2C8\B2E4.</dd>'),
unistr('  <dt>\C774\BBF8\C9C0 \D45C\C2DC \BC0F \CEE4\C11C\B97C \C704\B85C \AC00\C838\AC08 \B54C \B3C4\AD6C \C124\BA85 \D45C\C2DC</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105914259500310195)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C5D0 \D45C\C2DC\D560 HTML \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4. <code>&COLUMN.</code> \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC HTML\C5D0 \C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105914155966310195)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105917060133310197)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\CCB4 \AD6C\C131\C694\C18C \B0B4\C5D0\C11C \B9E4\CCB4\C758 \D06C\AE30 \C870\C815 \BC29\C2DD\C744 \ACB0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105917309459310197)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE4\BC84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105917436001310197)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\CCB4\AC00 \B9E4\CCB4 \D45C\C2DC \C601\C5ED\C744 \CC44\C6B0\B3C4\B85D \D06C\AE30\B97C \C870\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105917111684310197)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105917287348310197)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\CCB4 \D45C\C2DC \C601\C5ED \B0B4\C5D0 \B9E4\CCB4\AC00 \D3EC\D568\B418\B3C4\B85D \D06C\AE30\B97C \C870\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105916992685310197)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D06C\AE30 \C870\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105921774453310201)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\CCB4 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105914563250310195)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\CCB4 \C18C\C2A4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105914834053310195)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'ko'
,p_message_text=>unistr('BLOB \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105914785596310195)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.DYNAMIC_URL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('URL \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105914635642310195)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.STATIC_URL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105914448627310195)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105212160243309631)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C778\D130\B137 \B9E4\CCB4 \C720\D615\C744 \C785\B825\D569\B2C8\B2E4. \C778\D130\B137 \B9E4\CCB4 \C720\D615\C740 \C778\D130\B137\C758 \D30C\C77C \D615\C2DD\C5D0 \B300\D55C \B450 \BD80\BD84\C73C\B85C \AD6C\C131\B41C \C2DD\BCC4\C790\C785\B2C8\B2E4.'),
unistr('\B9E4\CCB4 \C720\D615\C740 \C720\D615 \BC0F \D558\C704 \C720\D615\C758 \CD5C\C18C \B450 \BD80\BD84\C73C\B85C \AD6C\C131\B418\BA70, \D558\B098 \C774\C0C1\C758 \C120\D0DD\C801 \B9E4\AC1C\BCC0\C218\B97C \D3EC\D568\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774 \B9E4\CCB4 \C720\D615\C740 \D398\C774\C9C0\B97C \B80C\B354\B9C1\D560 \B54C \CF58\D150\CE20-\C720\D615 HTTP \D5E4\B354\C5D0\C11C \C0AC\C6A9\B429\B2C8\B2E4.</p>'),
unistr('<p>\D398\C774\C9C0 \B808\BCA8 \B9E4\CCB4 \C720\D615\C740 \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8 \B9E4\CCB4 \C720\D615\BCF4\B2E4 \C6B0\C120 \C801\C6A9\B429\B2C8\B2E4.'),
unistr('\B9E4\CCB4 \C720\D615\C5D0 \B300\D574 \D398\C774\C9C0 \B808\BCA8 \BC0F \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8 \AC12\C774 \BAA8\B450 <code>NULL</code>\C774\BA74 \B9E4\CCB4 \C720\D615 <code>text/html</code>\C774 \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105212076588309631)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\CCB4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105915095030310196)
,p_name=>'PE.PROPERTY.MEDIA_URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\CCB4 \C18C\C2A4\C5D0 \B300\D55C URL\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105914912033310196)
,p_name=>'PE.PROPERTY.MEDIA_URL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105915226462310196)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\CCB4 \C18C\C2A4\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105915170352310196)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('URL \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105508218662309868)
,p_name=>'PE.PROPERTY.MINOR_STEP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80 \B208\AE08 \D45C\C2DC \C0AC\C774\C758 \C99D\BD84\C744 \C785\B825\D569\B2C8\B2E4. \AE30\BCF8\C801\C73C\B85C \B370\C774\D130\B97C \AE30\C900\C73C\B85C \C790\B3D9 \ACC4\C0B0\C758 \ACBD\C6B0 \B110\C785\B2C8\B2E4. \C22B\C790 \CD95\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105508170921309868)
,p_name=>'PE.PROPERTY.MINOR_STEP.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105508092134309868)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80 \B208\AE08 \D45C\C2DC\AC00 \B80C\B354\B9C1\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105507926484309867)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105507802058309867)
,p_name=>'PE.PROPERTY.MIN_STEP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC \B208\AE08 \D45C\C2DC \C0AC\C774\C758 \CD5C\C18C \C99D\BD84\C744 \C785\B825\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \AD6C\BD84\B41C \CE21\C815 \B2E8\C704\C5D0 \B300\D574 \B2E8\D3B8\D654\B41C \CD95 \AC12\C744 \BC29\C9C0\D558\AE30 \C704\D574 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105507765574309867)
,p_name=>'PE.PROPERTY.MIN_STEP.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C \B2E8\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105927834396310205)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\AC1C\BC1C\C790\AC00 \C27D\AC8C \C2DD\BCC4\D560 \C218 \C788\B3C4\B85D \C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105309353291309704)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHENTICATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C778\C99D \CCB4\ACC4\B97C \CC38\C870\D558\AE30 \C704\D574 \C560\D50C\B9AC\CF00\C774\C158 \AC1C\BC1C\C790\AC00 \C0AC\C6A9\D558\B294 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105248812823309658)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHORIZATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \C2DD\BCC4\D558\B294 \ACE0\C720 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105322550266309715)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BRANCH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790\AC00 \C27D\AC8C \C2DD\BCC4\D560 \C218 \C788\B294 \BD84\AE30 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105359406039309742)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8\C5D0 \B300\D55C \AD6C\CCB4\C801\C778 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105248716538309658)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BE4C\B4DC \C635\C158\C5D0 \B300\D55C \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \BE4C\B4DC \C635\C158\C740 \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C758 \AD6C\C131\C694\C18C\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B418\B294\C9C0 \C5EC\BD80\B97C \ACB0\C815\D558\B294 \BBF8\B9AC \C815\C758\B41C \C124\C815\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105359140070309742)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD94 \D15C\D50C\B9AC\D2B8\C5D0 \B300\D55C \AD6C\CCB4\C801\C778 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105359536913309742)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2EC\B825 \D15C\D50C\B9AC\D2B8\C5D0 \B300\D55C \AD6C\CCB4\C801\C778 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105249443023309658)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105359286048309742)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \D15C\D50C\B9AC\D2B8\C5D0 \B300\D55C \AD6C\CCB4\C801\C778 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105545665810309899)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \ADF8\B8F9\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774 \C774\B984\C740 \C138\BD80 \BCF4\AE30\C5D0\C11C \C601\C5ED \BA38\B9AC\AE00\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105359365426309742)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BAA9\B85D \D15C\D50C\B9AC\D2B8\C5D0 \B300\D55C \AD6C\CCB4\C801\C778 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105879427260310168)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \C124\BA85\C801 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \B9F5 \C601\C5ED\C5D0\C11C \B808\C774\BE14 \D45C\C2DC\B97C \C704\D574 HTML \B610\B294 \B300\CCB4 \D56D\BAA9\C774 \D544\C694\D55C \ACBD\C6B0 <strong>\B808\C774\BE14</strong> \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105248924571309658)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774 \C774\B984\C740 \D398\C774\C9C0 \BC88\D638 \BC0F \C81C\BAA9\ACFC \D568\AED8 \C5EC\B7EC &PRODUCT_NAME. \D398\C774\C9C0 \BC0F \BCF4\ACE0\C11C\C5D0 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105249278571309658)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \ADF8\B8F9\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105250099568309659)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\AC1C\BC1C\C790\AC00 \C27D\AC8C \C2DD\BCC4\D560 \C218 \C788\B3C4\B85D \D398\C774\C9C0 \D504\B85C\C138\C2A4 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105358999726309742)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D2B9\C815 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C5D0 \B300\D55C \AD6C\CCB4\C801\C778 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105359060749309742)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C601\C5ED \D15C\D50C\B9AC\D2B8\C5D0 \B300\D55C \AD6C\CCB4\C801\C778 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105359606462309742)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C5D0 \B300\D55C \AD6C\CCB4\C801\C778 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105358819908309742)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.THEME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D14C\B9C8\C5D0 \B300\D55C \AD6C\CCB4\C801\C778 \C9E7\C740 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105359798553309742)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C740 \D14C\B9C8 \C0DD\C131 \B9C8\BC95\C0AC\C640 \AC19\C740 \C5EC\B7EC \B9C8\BC95\C0AC\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105322241588309714)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.VALIDATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774 \C774\B984\C740 \AC1C\BC1C\C790\AC00 \AC80\C0AC \C911\C778 \C870\AC74\C744 \C27D\AC8C \C2DD\BCC4\D560 \C218 \C788\B3C4\B85D \AD6C\CCB4\C801\C73C\B85C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105208971011309628)
,p_name=>'PE.PROPERTY.NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \AD6C\CCB4\C801\C778 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105208804697309628)
,p_name=>'PE.PROPERTY.NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105223947963309639)
,p_name=>'PE.PROPERTY.NAMED_LOV.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \AC12 \BAA9\B85D\C758 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105223897628309639)
,p_name=>'PE.PROPERTY.NAMED_LOV.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105835866119310135)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C5D0\C11C \D0D0\C0C9\D45C\C2DC\C904\C758 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105836161140310135)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B05D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105836216105310135)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C758 \C885\B8CC \C704\CE58(\C77C\BC18\C801\C73C\B85C \C624\B978\CABD)\C5D0 \D0D0\C0C9\D45C\C2DC\C904\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105835954092310135)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105836009061310135)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5\C758 \C2DC\C791 \C704\CE58(\C77C\BC18\C801\C73C\B85C \C67C\CABD)\C5D0 \D0D0\C0C9\D45C\C2DC\C904\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105835700589310135)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904 \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105835082230310135)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\D560 \D0D0\C0C9\D45C\C2DC\C904\C758 \C720\D615\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105835567079310135)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\B300/\CD95\C18C \BC0F \CEF4\D37C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105835607149310135)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5 \BC29\D5A5\C744 \C81C\C5B4\D558\AE30 \C704\D55C \D655\B300/\CD95\C18C \CF58\D2B8\B864 \BC0F \CEF4\D37C\C2A4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105835113375310135)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105835244729310135)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105835330872310135)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\B300/\CD95\C18C\B9CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105835413765310135)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\B300 \BC0F \CD95\C18C \CF58\D2B8\B864\B9CC \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105834963393310134)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106092043875310357)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \BA54\B274 \BAA9\B85D \D45C\C2DC \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105348999889309735)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0\C11C \D0D0\C0C9\C5D0 \C0AC\C6A9\B418\B294 \D0D0\C0C9 \BA54\B274 \BAA9\B85D\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105348887084309734)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106091517059310357)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0\C11C \D0D0\C0C9 \BA54\B274 \BAA9\B85D\C758 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106091703421310357)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.SIDE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE21\BA74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106091617708310357)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.TOP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C0C1\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106091438393310357)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105349122946309735)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0\C11C \D0D0\C0C9 \BA54\B274 \BAA9\B85D\C5D0 \C0AC\C6A9\B418\B294 \D0D0\C0C9 \BA54\B274 \BAA9\B85D \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105349041475309735)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106091933169310357)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \D0D0\C0C9 \BAA9\B85D\C758 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C0AC\C6A9\C790\AC00 \C815\C758\D560 \D15C\D50C\B9AC\D2B8 \C635\C158\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106091831498310357)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105905129325310188)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C624\B978\CABD\C744 \AC00\B9AC\D0A4\B294 \D654\C0B4\D45C \D45C\C2DC</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105905043998310188)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \C544\C774\CF58\C5D0 \B300\D55C \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\D14C\B9C8\C5D0\C11C \AE00\AF34 APEX\B97C \C0AC\C6A9\D558\B294 \ACBD\C6B0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>\C744 \AC80\D1A0\D558\C5EC \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58\ACFC \C218\C815\C790\B97C \D655\C778\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105904911476310188)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C74C \C544\C774\CF58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106089292868310355)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BAA9\B85D\C758 \B9E8 \C704\C5D0 \C788\B294 \BAA9\B85D \B110 \C635\C158 \B0B4\C5D0 \D45C\C2DC\D560 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105897671520310182)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BAA9\B85D\C758 \B9E8 \C704\C5D0 \C788\B294 \BAA9\B85D \B110 \C635\C158 \B0B4\C5D0 \D45C\C2DC\D560 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105260753913309666)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BAA9\B85D\C758 \B9E8 \C704\C5D0 \C788\B294 \BAA9\B85D \B110 \C635\C158 \B0B4\C5D0 \D45C\C2DC\D560 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105262011603309667)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BAA9\B85D\C758 \B9E8 \C704\C5D0 \C788\B294 \BAA9\B85D \B110 \C635\C158 \B0B4\C5D0 \D45C\C2DC\D560 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105224500007309640)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BAA9\B85D\C758 \B9E8 \C704\C5D0 \C788\B294 \BAA9\B85D \B110 \C635\C158 \B0B4\C5D0 \D45C\C2DC\D560 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \AC12\C774 \B110\C774\BA74 \D56D\BAA9\C744 \B80C\B354\B9C1\D560 \B54C\C5D0\B3C4 \C774 \AC12\C774 \D45C\C2DC\B429\B2C8\B2E4. \D14D\C2A4\D2B8\B97C \C785\B825\D558\C9C0 \C54A\C73C\BA74 \BAA9\B85D\C5D0\C11C \BE48 \D589\C73C\B85C \D45C\C2DC\B418\ACE0 \B80C\B354\B9C1 \C2DC\C5D0 \BE48 \D56D\BAA9\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105224493248309640)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \D45C\C2DC \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105224711158309640)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC12 \BAA9\B85D\C5D0\C11C \B110 \AC12\C774 \C120\D0DD\B41C \ACBD\C6B0 \BC18\D658\D560 \AC12\C744 \C785\B825\D569\B2C8\B2E4. \AC12\C744 \C81C\ACF5\D558\C9C0 \C54A\C73C\BA74 \C774 \BAA9\B85D\C5D0\C11C \B110 \C635\C158\C744 \C120\D0DD\D560 \B54C \D56D\BAA9 \AC12\C774 \B110\B85C \B0A8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105224652556309640)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \BC18\D658 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105582982794309928)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0\B2F9 \D45C\C2DC\D560 \BCF4\ACE0\C11C \D589 \C218\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105582873973309928)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105583128208309928)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0\B2F9 \D45C\C2DC\D560 \BCF4\ACE0\C11C \D589\C218\B97C \C9C0\C815\D558\B294 \AC12\C5D0 \B300\D55C \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105583068477309928)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105582763402309928)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \D589 \C218\B97C \C785\B825\D558\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105763087494310080)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \AC12 \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105762997884310080)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.STATIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105582687215309928)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C218 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105219853040309636)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \B450\BC88\C9F8 \D398\C774\C9C0 \C81C\CD9C\C744 \C218\D589\D558\B824\ACE0 \C2DC\B3C4\D560 \B54C\C758 URL \B300\C0C1\C744 \C785\B825\D569\B2C8\B2E4. &PRODUCT_NAME.\C740(\B294) \C0AC\C6A9\C790\AC00 \C791\C5C5\C744 \ACC4\C18D \C218\D589\D560 \C218 \C788\B3C4\B85D \C624\B958 \BA54\C2DC\C9C0 \BC0F \C774 URL\C5D0 \B300\D55C \B9C1\D06C\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105219773193309636)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\BCF5 \D398\C774\C9C0 \C81C\CD9C \C2DC \C774 URL\B85C \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105611176221309951)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B610\B294 URL\C774 \D604\C7AC \D398\C774\C9C0\B97C \BC14\AFB8\B294\C9C0 \C544\B2C8\BA74 \B300\D654\C0C1\C790\C5D0 \C5F4\B9AC\B294\C9C0\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105770423070310086)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.P.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105770343772310086)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.W.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C77C\D55C \CC3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105611017406309951)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C\B97C \C5F4 \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105534977486309890)
,p_name=>'PE.PROPERTY.OPERATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105423824715309797)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt><code>employee</code> \D14C\C774\BE14\C5D0 \C561\C138\C2A4\D560 \B54C <code>emp_department_ix</code> \C778\B371\C2A4\B97C \C0AC\C6A9\D574\BCF4\C2ED\C2DC\C624.</dt>'),
'<dd><pre>INDEX (employees emp_department_ix)</pre></dd>',
unistr('<dt>SQL \C9C8\C758 \B0B4\C5D0\C11C <code>WITH plsql_declarations</code> \C808\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D569\B2C8\B2E4.</dt>'),
'<dd><pre>WITH_PLSQL</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105423701016309797)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>SQL \C9C8\C758 \C2E4\D589 \C2DC \CD5C\C0C1\C704 \B808\BCA8 \BA85\B839\BB38\C5D0 \CD94\AC00\B418\B294 Oracle \CD5C\C801\AE30 \D78C\D2B8\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('        \D78C\D2B8\B294 \CD5C\C801\AE30\C5D0 \C804\B2EC\B418\B294 \BA85\B839\C785\B2C8\B2E4. SQL \C791\C131 \C2DC \CD5C\C801\AE30\C5D0 \C54C\B824\C9C0\C9C0 \C54A\C740 \B370\C774\D130\C5D0 \B300\D55C \C815\BCF4\AC00 \D30C\C545\B418\AE30\B3C4 \D569\B2C8\B2E4. \C774 \ACBD\C6B0 \D78C\D2B8\B97C \D1B5\D574 \C77C\BC18\C801\C73C\B85C \CD5C\C801\AE30\AC00 \ACB0\C815\D558\B294 \C0AC\D56D\C744 \C0AC\C6A9\C790\AC00 \ACB0\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('        \CD5C\C801\AE30\AC00 \BCF4\B2E4 \B9CE\C740 \BE44\C6A9\C774 \B4DC\B294 \AC83\C73C\B85C \D655\C778\B41C \ACC4\D68D\C744 \C120\D0DD\D558\B294 \ACBD\C6B0\B3C4 \C788\AE30 \B54C\BB38\C785\B2C8\B2E4.</p>'),
unistr('        <p>\C608\B97C \B4E4\C5B4, \D2B9\C815 \C778\B371\C2A4\AC00 \D2B9\C815 \C9C8\C758\C5D0 \B300\D574 \BCF4\B2E4 \B9CE\C774 \C120\D0DD\B428\C744 \C54C\ACE0 \C788\C744 \ACBD\C6B0 \C774 \C815\BCF4\B97C \AE30\BC18\C73C\B85C \CD5C\C801\AE30\BCF4\B2E4 \D6A8\C728\C801\C778 \C2E4\D589 \ACC4\D68D\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('        \C774\B7EC\D55C \ACBD\C6B0 \D78C\D2B8\B97C \C0AC\C6A9\D558\C5EC \CD5C\C801\AE30\AC00 \CD5C\C801\C758 \C2E4\D589 \ACC4\D68D\C744 \C0AC\C6A9\D558\B3C4\B85D \AC15\C81C \C801\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105423670810309797)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C801\AE30 \D78C\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106096289179310361)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Oracle Text \C778\B371\C2A4\C5D0 \C758\D574 \C778\B371\C2A4\D654\B418\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\D589 \AC80\C0C9\C740 \C785\B825\B41C Oracle Text \C5F0\C0B0\C790\B97C \AE30\BC18\C73C\B85C \ACB0\ACFC\B97C \BC18\D658\D569\B2C8\B2E4(\D574\B2F9\D558\B294 Oracle Text \C778\B371\C2A4\AC00 \C5F4\C5D0 \B300\D574 \C0DD\C131\B41C \ACBD\C6B0).'),
unistr('\C774 \C635\C158\C740 \D544\C694\D55C \C778\B371\C2A4\AC00 \C874\C7AC\D558\ACE0 \C77C\BC18 \C0AC\C6A9\C790\AC00 Oracle Text \AC80\C0C9 \C5F0\C0B0\C790 \D65C\C6A9 \BC29\BC95\C744 \BC30\C6B4 \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\C73C\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4.'),
unistr('\C77C\BC18 \C0AC\C6A9\C790\B97C \C704\D55C Oracle Text \AD6C\BB38\C744 \AC04\C18C\D654\D558\B824\B294 \ACBD\C6B0 \ACF5\C720 \AD6C\C131\C694\C18C\C5D0\C11C \B300\D654\C2DD \ADF8\B9AC\B4DC\C758 <em>Oracle Text PL/SQL \D568\C218 \C774\B984</em> \AD6C\C131\C694\C18C \C124\C815\C5D0 \B300\D55C \D568\C218\B97C \C9C0\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.<br>'),
unistr('<a rel="noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/oracle-database/19/ccapp/index.html">Oracle Text Application Developers Guide</a>\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>'),
unistr('<p>\CC38\ACE0 - \C77C\BC18 \C0AC\C6A9\C790\AC00 Oracle Text \C5F0\C0B0\C790\B97C \C62C\BC14\B974\AC8C \C785\B825\D55C \ACBD\C6B0 \AC80\C0C9 \C131\B2A5\C740 \D6E8\C52C \B354 \C6B0\C218\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106096197988310361)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Text \C778\B371\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105927590435310205)
,p_name=>'PE.PROPERTY.ORDS_CLEANUP_CODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B9AC \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105927436541310205)
,p_name=>'PE.PROPERTY.ORDS_INIT_CODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30\D654 \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105486193072309849)
,p_name=>'PE.PROPERTY.ORIENTATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CC28\D2B8\C758 \BC29\D5A5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105486201500309849)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\D3C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105616889671309955)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B370\C774\D130 \D56D\BAA9\C744 \AC00\B85C\B85C \D45C\C2DC\D569\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \B9C9\B300 \CC28\D2B8\C758 \B9C9\B300\AC00 \AC00\B85C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105616600797309955)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105616714888309955)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \B370\C774\D130 \D56D\BAA9\C744 \C138\B85C\B85C \D45C\C2DC\D569\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \B9C9\B300 \CC28\D2B8\C758 \B9C9\B300\AC00 \C138\B85C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105486069926309848)
,p_name=>'PE.PROPERTY.ORIENTATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105496032156309857)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\D560 \AC1C\C694 \C2A4\D06C\B864 \B9C9\B300\C758 \B192\C774\B97C \D53D\C140(\C608: 50px) \B610\B294 \BC31\BD84\C728(\C608: 15%)\B85C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105495934856309857)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B192\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105495825791309856)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AC1C\C694 \C2A4\D06C\B864 \B9C9\B300\AC00 \CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('        \D604\C7AC \C774 \C635\C158\C740 \C138\B85C \B9C9\B300, \C120, \C601\C5ED, \C120\ACFC \C601\C5ED, \C8FC\C2DD \BC0F \C870\D569 \CC28\D2B8\C5D0 \B300\D574\C11C\B9CC \C9C0\C6D0\B429\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \AC1C\C694 \C2A4\D06C\B864 \B9C9\B300\B97C \D45C\C2DC\D558\B824\BA74 <strong>\D655\B300/\CD95\C18C \BC0F \C2A4\D06C\B864</strong> \C635\C158\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105495714194309856)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105348785753309734)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \B808\BCA8 \D0D0\C0C9\C744 \B36E\C5B4\C4F8\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \D604\C7AC \D398\C774\C9C0\C5D0 \B300\D55C \D0D0\C0C9\C774 \C5C6\AC70\B098 \D604\C7AC \D398\C774\C9C0\C5D0 \B300\D55C \B300\CCB4 \D0D0\C0C9\C744 \C120\D0DD\D558\B294 \B370(\C608: \C560\D50C\B9AC\CF00\C774\C158\C758 \D558\C704 \C139\C158 \C8FC\C704\C5D0 \B2E4\B978 \D0D0\C0C9 \C81C\ACF5) \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105348610456309734)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \B808\BCA8 \BB34\D6A8\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105219442407309636)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0 \B300\D574 \AD6C\D604\B418\B294 \C138\C158 \C0C1\D0DC \BCF4\D638 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105720687008310048)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C218\C5D0 \CCB4\D06C\C12C\C774 \C788\C5B4\C57C \D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105720718887310048)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C694\CCAD, \CE90\C2DC \BE44\C6B0\AE30 \B610\B294 \C774\B984/\AC12 \C30D \C778\C218\AC00 URL\C5D0 \D45C\C2DC\B420 \ACBD\C6B0 \CCB4\D06C\C12C\B3C4 \C81C\ACF5\D574\C57C \D569\B2C8\B2E4.<br>'),
unistr('\CCB4\D06C\C12C \C720\D615\C740 \C778\C218\B85C \C804\B2EC\B41C \BAA8\B4E0 \D56D\BAA9\C5D0 \B300\D574 \AC00\C7A5 \C5C4\ACA9\D55C <em>\C138\C158 \C0C1\D0DC \BCF4\D638</em> \C18D\C131\ACFC \D638\D658\B418\C5B4\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105721024908310049)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.D'
,p_message_language=>'ko'
,p_message_text=>unistr('URL \C561\C138\C2A4 \AD8C\D55C \C5C6\C74C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105721169635310049)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('URL\C744 \C0AC\C6A9\D574\C11C \D398\C774\C9C0\C5D0 \C561\C138\C2A4\D558\C9C0 \BABB\D560 \C218 \C788\C2B5\B2C8\B2E4.<br>'),
unistr('\D558\C9C0\B9CC URL \C7AC\C9C0\C815\C744 \C218\D589\D558\C9C0 \C54A\C73C\BBC0\B85C \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0 \BD84\AE30</em> \BD84\AE30 \C720\D615\C758 \B300\C0C1\C77C \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105720449300310048)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\D55C \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105720582390310048)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC \C778\C218\C5D0 \AD00\ACC4\C5C6\C774 \ADF8\B9AC\ACE0 \CCB4\D06C\C12C\C744 \D3EC\D568\D560 \D544\C694 \C5C6\C774 URL\C744 \C0AC\C6A9\D574\C11C \D398\C774\C9C0\B97C \C694\CCAD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105720810463310048)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0\B418\B294 \C778\C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105720962620310048)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('URL\C744 \C0AC\C6A9\D574\C11C \D398\C774\C9C0\B97C \C694\CCAD\D560 \C218 \C788\C9C0\B9CC URL\C740 \C694\CCAD, \CE90\C2DC \BE44\C6B0\AE30 \B610\B294 \C774\B984/\AC12 \C30D \C778\C218\B97C \D3EC\D568\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105219351853309636)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C561\C138\C2A4 \BCF4\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105210313480309629)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D398\C774\C9C0\C758 \C601\C22B\C790 \BCC4\CE6D\C744 \C785\B825\D569\B2C8\B2E4. \D398\C774\C9C0 \BC88\D638 \B300\C2E0 \C774 \BCC4\CE6D\C744 \C0AC\C6A9\D574\C11C \D398\C774\C9C0\B97C \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, \C560\D50C\B9AC\CF00\C774\C158 100\C758 \D398\C774\C9C0 1\C5D0\C11C \C791\C5C5 \C911\C778 \ACBD\C6B0 <code>home</code>\C774\B77C\B294 \BCC4\CE6D\C744 \C0DD\C131\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\ADF8\B7F0 \D6C4 \B2E4\C74C f?p \AD6C\BB38\C744 \C0AC\C6A9\D574\C11C \B2E4\B978 \D398\C774\C9C0\C5D0\C11C \C774 \D398\C774\C9C0\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'<pre>f?p=100:home</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105210282623309629)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105219042487309636)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D398\C774\C9C0\AC00 \ACF5\C6A9\C778\C9C0 \C544\B2C8\BA74 \C774 \D398\C774\C9C0\C5D0 \C778\C99D\C774 \D544\C694\D55C\C9C0 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\D398\C774\C9C0\AC00 \ACF5\C6A9\C73C\B85C \C2DD\BCC4\B418\BA74 \D398\C774\C9C0\C5D0 \C561\C138\C2A4\D558\B294 \BAA8\B4E0 \C0AC\C6A9\C790\AC00 \D574\B2F9 \D398\C774\C9C0\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0 \AC10\C2DC \D568\C218\B294 \C774 \D398\C774\C9C0 \C18D\C131\C5D0 \C561\C138\C2A4\D558\C5EC \C0AC\C804 \C778\C99D \C5C6\C774 \BCFC \C218 \C788\B294 \D398\C774\C9C0\B97C \C2DD\BCC4\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C778\C99D \CCB4\ACC4\C758 \D398\C774\C9C0 \AC10\C2DC \D568\C218\C5D0 \B300\D55C \AD6C\D604 \C5EC\BD80\C5D0 \B530\B77C \C774 \C18D\C131\C758 \C801\C6A9 \C5EC\BD80\AC00 \ACB0\C815\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105719878496310048)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\C744 \D544\C694\B85C \D558\B294 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105719982160310048)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105218941573309636)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105210550993309629)
,p_name=>'PE.PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D398\C774\C9C0\C640 \C5F0\AD00\C2DC\D0A4\B824\B294 \D398\C774\C9C0 \ADF8\B8F9\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\D398\C774\C9C0 \ADF8\B8F9\C740 \AE30\B2A5\C5D0 \C601\D5A5\C744 \C8FC\C9C0 \C54A\C9C0\B9CC \AC1C\BC1C\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0\C11C \D398\C774\C9C0\B97C \AD00\B9AC\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105210425188309629)
,p_name=>'PE.PROPERTY.PAGE_GROUP.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105218081144309635)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C758 <code>#ONLOAD#</code> \B300\CCB4 \BB38\C790\C5F4\C5D0 \B300\D574 \B300\CCB4\B418\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\C774 \AE30\B2A5\C744 \C0AC\C6A9\D558\B824\BA74 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\AC00 <code>#ONLOAD#</code> \B300\CCB4 \BB38\C790\C5F4\C744 \D3EC\D568\D574\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105217989957309635)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 HTML \BCF8\BB38 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105210792037309630)
,p_name=>'PE.PROPERTY.PAGE_MODE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\C5D0 \B300\D55C \D398\C774\C9C0 \BAA8\B4DC\B97C \C120\D0DD\D558\C2ED\C2DC\C624.</p>'),
'#LOV_VALUES#',
unistr('<p><em>\BAA8\B2EC</em> \BC0F <em>\BE44\BAA8\B2EC \B300\D654\C0C1\C790</em> \C635\C158\C740 \D604\C7AC \C560\D50C\B9AC\CF00\C774\C158 \D14C\B9C8\C5D0 \AE30\BCF8 <em>\B300\D654\C0C1\C790 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8</em>\AC00 \D3EC\D568\B418\C5B4 \C788\B294 \ACBD\C6B0\C5D0\B9CC \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105718996647310047)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B2EC \B300\D654\C0C1\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105719042773310047)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D398\C774\C9C0\AC00 \BAA8\B2EC \B300\D654\C0C1\C790\B85C \D45C\C2DC\B429\B2C8\B2E4.<br>'),
unistr('\BAA8\B2EC \B300\D654\C0C1\C790\B294 \C77C\BC18 \C0AC\C6A9\C790\AC00 \B300\D654\C0C1\C790\B97C \D574\C81C(\B2EB\AE30)\D560 \B54C\AE4C\C9C0 \D65C\C131 \BC0F \D3EC\CEE4\C2A4\B41C \C0C1\D0DC\B85C \C720\C9C0\B418\B294 \BDF0\D3EC\D2B8 \B0B4\C5D0 \BC30\CE58\B41C \C624\BC84\B808\C774 \CC3D\C785\B2C8\B2E4.'),
unistr('\AE30\BCF8 \D398\C774\C9C0\B294 \D68C\C0C9\C73C\B85C \CC98\B9AC\B418\ACE0 \B300\D654\C0C1\C790\AC00 \B2EB\D790 \B54C\AE4C\C9C0 \C77C\BC18 \C0AC\C6A9\C790\AC00 \D398\C774\C9C0\C758 \B0A8\C740 \BD80\BD84\C744 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105719141434310047)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BAA8\B2EC \B300\D654\C0C1\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105719211930310047)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D398\C774\C9C0\AC00 \BE44\BAA8\B2EC \B300\D654\C0C1\C790\B85C \D45C\C2DC\B429\B2C8\B2E4.<br>'),
unistr('\BE44\BAA8\B2EC \B300\D654\C0C1\C790\B294 \C77C\BC18 \C0AC\C6A9\C790\AC00 \B300\D654\C0C1\C790\B97C \C0AC\C6A9\D560 \C218 \C788\ACE0 \B300\D654\C0C1\C790\B97C \C2E4\D589\D55C \D398\C774\C9C0\C758 \CF58\D150\CE20\B97C \C0AC\C6A9\D560 \C218 \C788\B294 \BDF0\D3EC\D2B8 \B0B4\C5D0 \BC30\CE58\B418\B294 \C624\BC84\B808\C774 \CC3D\C785\B2C8\B2E4.'),
unistr('\BE44\BAA8\B2EC \B300\D654\C0C1\C790\B294 \C694\CCAD\B41C \C815\BCF4\AC00 \C9C0\C18D\B420 \D544\C694\AC00 \C5C6\C744 \B54C \C0AC\C6A9\D560 \C218 \C788\C73C\BA70, \CC3D\C774 \C5EC\C804\D788 \C5F4\B9B0 \C0C1\D0DC\C5D0\C11C\B3C4 \B2E4\B978 \ACF3\C5D0\C11C \C791\C5C5\C744 \ACC4\C18D \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105718717101310047)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105718867977310047)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\AC00 \C77C\BC18 &PRODUCT_NAME. \C560\D50C\B9AC\CF00\C774\C158 \D398\C774\C9C0\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105210677691309629)
,p_name=>'PE.PROPERTY.PAGE_MODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BAA8\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106060283139310328)
,p_name=>'PE.PROPERTY.PAGE_NAVIGATION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105419200964309793)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C2E4\D589\D560 \D504\B85C\C138\C2A4 \C720\D615\C744 \C9C0\C815\D569\B2C8\B2E4. \C9C0\C6D0\B418\B294 \D504\B85C\C138\C2A4 \C720\D615\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\C5D0 \B530\B77C \C5EC\AE30\C5D0\C11C \CD94\AC00 \D504\B85C\C138\C2A4 \C720\D615 \D50C\B7EC\ADF8\C778\C744 \C0AC\C6A9\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \D50C\B7EC\ADF8\C778\C740 <em>&lt;My Plug-in&gt; [Plug-in]</em>\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('\B2E4\C74C \D50C\B7EC\ADF8\C778\C740 \C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \ACF5\C720 \AD6C\C131\C694\C18C \B0B4\C5D0 \C124\CE58\B429\B2C8\B2E4.</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105242127000309653)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106043373811310312)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106043283616310312)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106043151740310312)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \B9E4\AC1C\BCC0\C218\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106043035846310312)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106043527555310312)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B9E4\AC1C\BCC0\C218\C758 \B300\C0C1\C73C\B85C \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \D558\B098 \C774\C0C1 \C785\B825\D569\B2C8\B2E4. \D56D\BAA9\C774 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \AC01 \D56D\BAA9 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \B54C \C774\BBF8 \C785\B825\B41C \D14D\C2A4\D2B8\AC00 \C788\C73C\BA74 \AE30\C874 \D14D\C2A4\D2B8 \B05D\C5D0 \CF64\B9C8\AC00 \D45C\C2DC\B418\ACE0 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \D56D\BAA9 \C774\B984\C774 \CD94\AC00\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106043424347310312)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106044789804310314)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \AC00\B2A5\D55C \BAA9\B85D\C5D0\C11C \B9E4\AC1C\BCC0\C218\C5D0 \B300\D55C \C18C\C2A4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106045222366310314)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106045359076310314)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>PL/SQL \D568\C218 \BCF8\BB38</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106044862489310314)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106044994869310314)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106045039722310314)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106045130232310314)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\C815\C801 \AC12</em>\C5D0 \C785\B825\B41C \D14D\C2A4\D2B8\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106044620758310313)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105567002105309916)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218\C5D0 \B300\D55C \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105566977466309916)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105594752760309938)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105210985394309630)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\C758 \BAA8\C591\ACFC \B808\C774\C544\C6C3\C744 \C815\C758\D560 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('        <p>\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B294 \C560\D50C\B9AC\CF00\C774\C158 \D14C\B9C8\C5D0\C11C \C815\C758\B429\B2C8\B2E4.'),
unistr('        \D398\C774\C9C0\AC00 \C0DD\C131\B418\BA74 \D15C\D50C\B9AC\D2B8\B294 <em>\D14C\B9C8 \AE30\BCF8\AC12</em>\C73C\B85C \C790\B3D9\C73C\B85C \C124\C815\B429\B2C8\B2E4. \C774 \C124\C815\C5D0\C11C\B294 \D604\C7AC \D14C\B9C8\C5D0 \C815\C758\B41C \AE30\BCF8 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D558\C5EC \D398\C774\C9C0\B97C \B80C\B354\B9C1\D569\B2C8\B2E4.'),
unistr('        \C5EC\AE30\C11C \C120\D0DD\D558\BA74 \AE30\BCF8 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B294 \BB34\D6A8\D654\B429\B2C8\B2E4.</p>'),
unistr('        <p>\B300\BD80\BD84\C758 \D14C\B9C8\C5D0\B294 \D2B9\C815 \C6A9\B3C4(\C608: \CE21\BA74 \C5F4, \B85C\ADF8\C778 \D398\C774\C9C0, \B300\D654\C0C1\C790 \D398\C774\C9C0 \B4F1\C744 \D3EC\D568\D558\B294 \CF58\D150\CE20 \D45C\C2DC)\C758 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.<br>'),
unistr('        \BC94\C6A9 \D14C\B9C8\B294 \B2E4\C74C\ACFC \AC19\C740 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B97C \C81C\ACF5\D569\B2C8\B2E4.'),
'          <dl>',
unistr('            <dt>\D45C\C900</dt>'),
unistr('              <dd>\AE30\BCF8 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C785\B2C8\B2E4. \D654\BA74 \C790\C0B0\C744 \CD5C\B300\D654\D558\B294 \AC83\C774 \C88B\C740 \D648 \D398\C774\C9C0, \B300\C2DC\BCF4\B4DC, \B300\C6A9\B7C9 \BCF4\ACE0\C11C \BC0F \AE30\D0C0 \B808\C774\C544\C6C3\C5D0 \C801\D569\D569\B2C8\B2E4.</dd>'),
unistr('            <dt>\C67C\CABD \C5F4</dt>'),
unistr('              <dd>\AC80\C0C9 \BC0F \D544\D130 \D398\C774\C9C0\C5D0 \C720\C6A9\D55C \C67C\CABD \D45C\C2DC \C704\CE58\B97C \C81C\ACF5\D569\B2C8\B2E4.</dd>'),
unistr('            <dt>\C624\B978\CABD \C5F4</dt>'),
unistr('              <dd>\C791\C5C5 \C9C0\D5A5 \CF58\D2B8\B864(\C608: \B2E8\CD94, \BAA9\B85D)\C744 \D45C\C2DC\D558\B294 \B370 \C720\C6A9\D55C \CD95\C18C \AC00\B2A5\D55C \C624\B978\CABD \D45C\C2DC \C704\CE58\B97C \C81C\ACF5\D569\B2C8\B2E4.</dd>'),
unistr('            <dt>\C67C\CABD \BC0F \C624\B978\CABD \C5F4</dt>'),
unistr('              <dd>\B9E4\C6B0 \BCF5\C7A1\D55C \D398\C774\C9C0\C5D0 \C801\D569\D55C \C67C\CABD \C5F4\ACFC \CD95\C18C \AC00\B2A5\D55C \C624\B978\CABD \C5F4\C744 \BAA8\B450 \C81C\ACF5\D569\B2C8\B2E4.</dd>'),
unistr('            <dt>\B85C\ADF8\C778</dt>'),
unistr('              <dd>\C560\D50C\B9AC\CF00\C774\C158 \B85C\ADF8\C778 \D398\C774\C9C0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</dd>'),
'            <dt>Marquee</dt>',
unistr('              <dd>\AE30\BCF8 \C815\BCF4\B97C \D3EC\D568\D558\B294 \C81C\BAA9 \D45C\C2DC\C904 \C601\C5ED\ACFC \CD95\C18C \AC00\B2A5\D55C \C624\B978\CABD \C5F4\C744 \C81C\ACF5\D569\B2C8\B2E4.'),
unistr('              \C774 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B294 \C5EC\B7EC \AD00\B828 \BCF4\ACE0\C11C \B610\B294 \B370\C774\D130\B97C \AC00\C9C4 \B2E8\C77C \B808\CF54\B4DC\B97C \D45C\C2DC\D558\B294 \B370 \C801\D569\D569\B2C8\B2E4.'),
unistr('              Marquee\B294 \BCF4\ACE0\C11C\C5D0\C11C \B2E8\C77C \B9C8\C2A4\D130 \B808\CF54\B4DC\B97C \CC98\C74C\C73C\B85C \C120\D0DD\D558\B294 \B9C8\C2A4\D130-\B514\D14C\C77C \AD00\ACC4\B97C \D45C\C2DC\D558\B294 \B370 \C77C\BC18\C801\C73C\B85C \C0AC\C6A9\B429\B2C8\B2E4. </dd>'),
unistr('            <dt>\CD5C\C18C(\D0D0\C0C9 \C5C6\C74C)</dt>'),
unistr('              <dd>\B9E4\C6B0 \AC04\B2E8\D55C \D398\C774\C9C0, \BD80\C778 \B610\B294 \B2E8\C77C \D398\C774\C9C0 \C560\D50C\B9AC\CF00\C774\C158\C774\B098 \D0D0\C0C9\C774 \D544\C694\D558\C9C0 \C54A\C740 \ACBD\C6B0\C5D0 \C720\C6A9\D569\B2C8\B2E4.</dd>'),
'          </dl>',
unistr('          \CC38\ACE0: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105210831702309630)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105594941369309938)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106035911535310305)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \AE30\BCF8\AC12 \B0B4\C5D0 \C815\C758\B41C \C124\C815\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105211742526309630)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0C8 \D398\C774\C9C0\B85C \C774\B3D9\D560 \B54C \B610\B294 \D398\C774\C9C0\B97C \C81C\CD9C\D560 \B54C \C0AC\C6A9\B418\B294 \BCC0\D658\C744 \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>3D \BCC0\D658\C744 \C9C0\C6D0\D558\C9C0 \C54A\B294 \C774\C804 \BE0C\B77C\C6B0\C800\C5D0\C11C\B294 \B300\BD80\BD84\C758 \BCC0\D658\C744 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.'),
unistr('\AE30\BCF8\C801\C73C\B85C 3D \C9C0\C6D0\C774 \BD80\C871\D55C \C7A5\CE58(\C608: Android 2.x)\B294 \BAA8\B4E0 \BCC0\D658 \C720\D615\C5D0 \B300\D574 \D22C\BA85\D55C \BCC0\D658\C73C\B85C \BCF5\AD6C\B429\B2C8\B2E4.'),
unistr('\C138\BD80\C815\BCF4\B294 jQuery Mobile \BB38\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105723862095310051)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FADE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105723977976310051)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLIP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B9BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105724058605310051)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLOW.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B85C\C6B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105723706385310051)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105724105992310051)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.POP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105724232181310051)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2AC\B77C\C774\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105724358766310051)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\B85C \BC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105724479415310051)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2AC\B77C\C774\B4DC \D398\C774\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105724511432310051)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\B85C \BC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105724663768310051)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.TURN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68C\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105211604851309630)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCC0\D658')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105899889206310184)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0\C5D0 \C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D\C774 \C788\B294\B370 \D398\C774\C9C0\C5D0\C11C \B098\AC00\B824\ACE0 \D560 \B54C \C0AC\C6A9\C790\C5D0\AC8C \ACBD\ACE0\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('        \D398\C774\C9C0 \D56D\BAA9 \BC0F \B2E8\CD94\B3C4 \C774 \AC80\C0AC\AC00 \C5B8\C81C \C218\D589\B418\ACE0 \BB34\C5C7\C774 \D3EC\D568\B418\B294\C9C0\C5D0 \B300\D574 \B354\C6B1 \C138\BC00\D55C \C81C\C5B4\B97C \C81C\ACF5\D569\B2C8\B2E4.'),
unistr('        \B2E8\CD94\C758 \ACBD\C6B0 \B2E8\CD94\B97C \B204\B974\BA74 \AC80\C0AC\B97C \C218\D589\D558\B3C4\B85D \C9C0\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('        \D398\C774\C9C0 \D56D\BAA9\C758 \ACBD\C6B0 \AC80\C0AC\C5D0\C11C \D56D\BAA9\C5D0 \B300\D55C \BCC0\ACBD\C0AC\D56D\C774 \D3EC\D568\B418\B294\C9C0 \B610\B294 \BB34\C2DC\B418\B294\C9C0 \C9C0\C815\D560 \C218 \C788\C2B5\B2C8\B2E4(\C774 \B458\C5D0 \B300\D574 <em>\C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D \ACBD\ACE0</em> \C18D\C131 \CC38\C870).</p>'),
unistr('        <p>\CC38\ACE0: \C774 \C124\C815\C740 \BAA8\B2EC \B300\D654\C0C1\C790 \D398\C774\C9C0\B97C \B2EB\C740 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105899762710310184)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D \ACBD\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105547237193309900)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C774 \D45C\C2DC\B418\B294 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105748444795310069)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_LEFT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B2E8 - \C67C\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105748546215310069)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_RIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B2E8 - \C624\B978\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105748833328310069)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_LEFT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\B2E8 \BC0F \D558\B2E8 - \C67C\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105748948835310070)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_RIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\B2E8 \BC0F \D558\B2E8 - \C624\B978\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105748693868310069)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_LEFT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\B2E8 - \C67C\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105748743940310069)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_RIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\B2E8 - \C624\B978\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105547122719309900)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106059925303310328)
,p_name=>'PE.PROPERTY.PARAMETER_ID.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105531486635309887)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218\AC00 \D544\C218\C774\BA70 \D56D\C0C1 \C124\C815\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105531324659309887)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105531625782309888)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218\C5D0 \B300\D55C \AE30\BCF8\AC12 \B610\B294 \C815\C801 \AC12\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105531578502309888)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105267292308309671)
,p_name=>'PE.PROPERTY.PARENT_REGION.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105226239860309641)
,p_name=>'PE.PROPERTY.PARENT_REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C601\C5ED\C774 \D45C\C2DC\B420 \C0C1\C704 \C601\C5ED\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105226110366309641)
,p_name=>'PE.PROPERTY.PARENT_REGION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105582540806309928)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>PPR(\BD80\BD84 \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68)\C744 \C0AC\C6A9\D574\C11C \BCF4\ACE0\C11C \D45C\C2DC\B97C \C5C5\B370\C774\D2B8\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('\D398\C774\C9C0 \B9E4\AE40 \C694\CCAD \B610\B294 \C0C8 \C815\B82C \C5F4 \C120\D0DD\ACFC \AC19\C774 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C791\C5C5\C744 \C218\D589\D560 \ACBD\C6B0\C5D0\B294 \D604\C7AC \BCF4\ACE0\C11C \D589\C744 \C0C8\B85C\ACE0\CE68\D574\C57C \D569\B2C8\B2E4. \C774 \C18D\C131\C744 <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D558\BA74 \BCF4\ACE0\C11C \C601\C5ED\B9CC \C0C8\B85C\ACE0\CE68\B429\B2C8\B2E4. \C774 \C18D\C131\C744 <strong>\D574\C81C</strong>\B85C \C124\C815\D558\BA74 \C804\CCB4 \D398\C774\C9C0\AC00 \C0C8\B85C\ACE0\CE68\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105582432300309928)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\BD84 \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105759558792310078)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105578064180309924)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \ADF8\B798\D504\C758 \BC30\ACBD\C5D0 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105577964153309924)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\ACBD\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105578443389309925)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9C9\B300 \CC28\D2B8\C758 \B108\BE44(\D53D\C140)\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105578360673309925)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300 \B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105605369209309946)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53D\C140')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105810004448310116)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105578220507309925)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \ADF8\B798\D504\C758 \C804\ACBD\C5D0 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105578116019309925)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\ACBD\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105490369012309852)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C870\AC01\C774 "\AE30\D0C0" \C870\AC01\C73C\B85C \C9D1\ACC4\B418\B294 \C804\CCB4 \D30C\C774 \CC28\D2B8\C758 \BD80\BD84\C744 \C785\B825\D569\B2C8\B2E4. \C801\D569\D55C \AC12 \BC94\C704\B294 0(\AE30\BCF8\AC12) - 1\C785\B2C8\B2E4.</p>'),
unistr('        <p>\C608\B97C \B4E4\C5B4, \AC12 0.15\B294 \D30C\C774\C758 15% \BBF8\B9CC\C778 \BAA8\B4E0 \C870\AC01\C774 "\AE30\D0C0" \C870\AC01\C73C\B85C \C9D1\ACC4\B418\B3C4\B85D \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105490209890309852)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C774 \CC28\D2B8 \AE30\D0C0 \C784\ACC4\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105520992041309879)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C774 \C138\ADF8\BA3C\D2B8\B97C \C120\D0DD\D55C \ACBD\C6B0\C5D0 \C801\C6A9\B418\B294 \D6A8\ACFC\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105521074614309879)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.EXPLODE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105521275697309879)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105521175821309879)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHTANDEXPLODE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC \BC0F \D655\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105520804427309878)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C774 \C120\D0DD \D6A8\ACFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105599322023309941)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4\C5D0 \B300\D55C \AC12\C744 \C81C\ACF5\D558\B294 PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105599269099309941)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105599511869309941)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4\C5D0 \B300\D55C \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105599476824309941)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105599144241309941)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4\C5D0 \B300\D55C \C18C\C2A4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105766411302310083)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.F.D'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105766597565310083)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.S.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C21C\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105766330719310083)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.T.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \D2B8\B9AC\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105599075857309941)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105683472743310015)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \C5F4 \AC12\C744 \C120\D0DD\D558\B294 \C790\B3D9\C73C\B85C \C0DD\C131\B41C \C9C8\C758 \B300\C2E0 \C0AC\C6A9\D560 SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4. SQL \C9C8\C758\B294 \D558\B098\C758 \C5F4\C744 \BC18\D658\D574\C57C \D569\B2C8\B2E4. SQL \C9C8\C758\B97C \C785\B825\D558\BA74 \C77C\BD80 \BCF4\ACE0\C11C\C5D0\C11C \C131\B2A5\C774 \D5A5\C0C1\B420 \C218 \C788\C2B5\B2C8\B2E4. \C774 \AC12 \BAA9\B85D\C740 \C0AC\C6A9\C790\AC00 \C5F4 \BA38\B9AC\AE00\C744 \B204\B97C \B54C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105683355879310015)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105683067048310015)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4 \B4DC\B86D\B2E4\C6B4 \BAA9\B85D\C5D0\C11C \D544\D130\C5D0 \B300\D55C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D560 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105771463313310086)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 \C9C0\C815\B41C \AC12 \BAA9\B85D\C744 \C0AC\C6A9\D558\C5EC \C815\D655\D55C \C77C\CE58 \D56D\BAA9 \D544\D130\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105771583897310086)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 \C9C0\C815\B41C \AC12 \BAA9\B85D\C5D0\C11C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D558\C5EC \AC19\C74C \D544\D130\B97C \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105771694503310087)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 \C9C0\C815\B41C \AC12 \BAA9\B85D\C744 \C0AC\C6A9\D558\C5EC \B2E8\C5B4 \D3EC\D568 \D56D\BAA9 \D544\D130\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105771723078310087)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 \C9C0\C815\B41C \AC12 \BAA9\B85D\C5D0\C11C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D558\C5EC \D3EC\D568 \D544\D130\B97C \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105771298946310086)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \AC12 \BAA9\B85D\C744 \C0AC\C6A9\D558\C5EC \B2E8\C5B4 \D3EC\D568 \D544\D130\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105771389018310086)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C SQL \C9C8\C758 \AC12 \BAA9\B85D\C5D0\C11C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D558\C5EC \D3EC\D568 \D544\D130\B97C \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105770890315310086)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12(\C5F4 \C720\D615 \AE30\C900)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105770919800310086)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('STRING \BC0F NUMBER \C5F4\C740 \ACE0\C720 \C5F4 \AC12\C5D0\C11C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D569\B2C8\B2E4. DATE \C5F4\C740 \BBF8\B9AC \C815\C758\B41C \B0A0\C9DC \BC94\C704\C5D0\C11C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105770628663310086)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105770708864310086)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D\C5D0 \B300\D55C \D544\D130\B97C \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105771024885310086)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \AC12 \BAA9\B85D\C744 \C0AC\C6A9\D558\C5EC \C815\D655\D55C \C77C\CE58 \D56D\BAA9 \D544\D130\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105771121536310086)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C SQL \C9C8\C758 \AC12 \BAA9\B85D\C5D0\C11C \AC12 \BAA9\B85D\C744 \D30C\C0DD\D558\C5EC \AC19\C74C \D544\D130\B97C \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105682963322310015)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105927938646310205)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589\D560 PL/SQL \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105537271743309892)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\ACA9 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \C2E4\D589\D560 PL/SQL \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105537177446309892)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \CD9C\B825\C744 \C0DD\C131\D560 PL/SQL \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105303949642309699)
,p_name=>'PE.PROPERTY.PLSQL_CODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C778\C99D \CCB4\ACC4 \B0B4\C5D0\C11C \C0AC\C6A9\B418\B294 PL/SQL \C18C\C2A4\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105303851993309699)
,p_name=>'PE.PROPERTY.PLSQL_CODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105536607680309891)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4\AC00 \C2E4\D589\B418\B294 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105536718437309892)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\CEEC \B370\C774\D130\BCA0\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105536849366309892)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\CEEC \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C PL/SQL \CF54\B4DC\AC00 \C2E4\D589\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105536941797309892)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105537041149309892)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL\C744 \C0AC\C6A9\D558\C5EC \C811\C18D\C774 \C815\C758\B41C \C6D0\ACA9 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C PL/SQL \CF54\B4DC\AC00 \C2E4\D589\B429\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105536564252309891)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105418330673309792)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\C5D0 \D50C\B7EC\ADF8\C778\C774 \D45C\C2DC\B418\B294 \BC94\C8FC\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105744348940310066)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.COMPONENT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105744426237310066)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EFFECT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D6A8\ACFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105744522172310066)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EXECUTE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105744690696310066)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.INIT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105744718318310066)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.MISC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\D0C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105744812963310066)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NAVIGATION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105744988272310066)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NOTIFICATION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105745038393310067)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.STYLE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105418268828309792)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106070454877310337)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C2E4\D589 \AC00\B2A5\D55C JavaScript \CF54\B4DC\B97C \C785\B825\D558\C2ED\C2DC\C624. \CC38\ACE0: \C774 \CF54\B4DC \AE30\B2A5\C758 \C815\D655\D55C \D2B9\C131\C740 \D604\C7AC \D50C\B7EC\ADF8\C778\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106070350219310337)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \CD08\AE30\D654 \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105595092851309938)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106036086599310305)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \AE30\BCF8\AC12 \B0B4\C5D0 \C815\C758\B41C \C124\C815\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105211960959309630)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D31D\C5C5\C774 \C5F4\B9B4 \B54C \C0AC\C6A9\B418\B294 \BCC0\D658\C744 \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>3D \BCC0\D658\C744 \C9C0\C6D0\D558\C9C0 \C54A\B294 \C774\C804 \BE0C\B77C\C6B0\C800\C5D0\C11C\B294 \B300\BD80\BD84\C758 \BCC0\D658\C744 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.'),
unistr('\AE30\BCF8\C801\C73C\B85C 3D \C9C0\C6D0\C774 \BD80\C871\D55C \C7A5\CE58(\C608: Android 2.x)\B294 \BAA8\B4E0 \BCC0\D658 \C720\D615\C5D0 \B300\D574 \D22C\BA85\D55C \BCC0\D658\C73C\B85C \BCF5\AD6C\B429\B2C8\B2E4.'),
unistr('\C790\C138\D55C \B0B4\C6A9\C740 jQuery Mobile \BB38\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105724896328310051)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FADE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105724989977310051)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLIP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B9BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105725058222310052)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLOW.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B85C\C6B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105724725421310051)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105725174644310052)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.POP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105725272619310052)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2AC\B77C\C774\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105725307765310052)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\B85C \BC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105725498036310052)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2AC\B77C\C774\B4DC \D398\C774\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105725555421310052)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\B85C \BC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105725657863310052)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.TURN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68C\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105211897626309630)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \BCC0\D658')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105304984475309700)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C778\C99D \B2E8\ACC4(\B85C\ADF8\C778 \C778\C99D\C11C \D655\C778) \C774\D6C4 &PRODUCT_NAME. \B85C\ADF8\C778 \D504\B85C\C2DC\C800(\B85C\ADF8\C778 API)\B85C \C2E4\D589\D560 \D504\B85C\C2DC\C800\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\B85C\ADF8\C778 \D504\B85C\C2DC\C800\B294 \CFE0\D0A4 \C124\C815 \BC0F \C138\C158 \B4F1\B85D\C774 \D3EC\D568\B41C \C815\C0C1\C801\C778 \B85C\ADF8\C778 \D504\B85C\C2DC\C800 \C791\C5C5\C744 \C218\D589\D55C \D6C4, \D558\C9C0\B9CC \C6D0\D558\B294 \C560\D50C\B9AC\CF00\C774\C158 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\B418\AE30 \C804\C5D0 \C774 \CF54\B4DC\B97C \C2E4\D589\D569\B2C8\B2E4.'),
unistr('\C774 \D504\B85C\C2DC\C800\B294 "PL/SQL \CF54\B4DC" \C18D\C131 \B610\B294 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105304805349309700)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\D6C4 \C778\C99D \D504\B85C\C2DC\C800 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105232332193309645)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D56D\BAA9 \AC12\C744 \C138\BD84\D654\D558\AE30 \C704\D55C PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C608\B97C \B4E4\C5B4, \C774 \D56D\BAA9 \C774\B984\C774 <code>P1_X</code>\C774\BA74 <code>UPPER(:P1_X)</code>, <code>INITCAP(:P2_Y)</code>, <code>MIN(:P1_X, :P2_Y - 200)</code>, <code>NVL(:P1_X, :P2_Y)</code>\C640 \AC19\C740 \C0AC\D6C4 \ACC4\C0B0 \D45C\D604\C2DD \B610\B294 <code>my_func(:P1_X)</code>\C640 \AC19\C740 \D568\C218 \D638\CD9C\C744 \C0AC\C6A9\D574\C11C \D56D\BAA9\C758 \CD5C\C885 \AC12\C744 \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \C608\C81C\C5D0\C11C\B294 \D45C\D604\C2DD\C774 \D604\C7AC \D56D\BAA9\C744 \CC38\C870\D560 \C218 \C788\AC70\B098 \C138\C158 \C0C1\D0DC\C758 \B2E4\B978 \D56D\BAA9\C744 \CC38\C870\D560 \C218 \C788\C74C\C744 \BCF4\C5EC\C90D\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105232214189309645)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\D6C4 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105305303641309700)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('&PRODUCT_NAME.\C774(\AC00) \C0AC\C6A9\C790 \C138\C158\C744 \C815\B9AC\D55C \D6C4 \C560\D50C\B9AC\CF00\C774\C158\C774 \C7AC\C9C0\C815\B418\B294 URL\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105305249571309700)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\D6C4 \B85C\ADF8\C544\C6C3 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105982399643310254)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105982656705310254)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105982500459310254)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105982447762310254)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105982790332310254)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105982238652310254)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105983586727310255)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\D658\B418\B294 SQL \C9C8\C758\AC00 \C6F9 \C18C\C2A4\C5D0\C11C \AC80\C0C9\B41C \B370\C774\D130\B97C \BCC0\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4. Java \D568\C218 \BCF8\BB38\C744 \D1B5\D574 \BC18\D658\B418\B294 SQL \C9C8\C758\B294 #APEX$SOURCE_DATA# \C758\C0AC \D14C\C774\BE14\C5D0\C11C \C120\D0DD\B418\C5B4\C57C \D558\BA70 \B370\C774\D130 \D504\B85C\D30C\C77C\C5D0\C11C \C0AC\C6A9 \AC00\B2A5\D55C \C5F4\C744 \C77D\C5B4\C57C \D569\B2C8\B2E4. \C5EC\AE30\C11C\B294 SQL WITH \C808\C744 \C0AC\C6A9\D558\B294 \D558\C704 \C9C8\C758 \D329\D1A0\B9C1\C774 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105983423510310255)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105983301636310255)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>EMPNO, ENAME \BC0F SAL \C5F4\C744 \C120\D0DD\D558\ACE0 SAL\C774 3000 \BBF8\B9CC\C778 \BAA8\B4E0 \D589\C744 \D544\D130\B9C1\D558\C5EC \C81C\C678\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105983223772310255)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\D658\B418\B294 SQL \C9C8\C758\AC00 \C6F9 \C18C\C2A4\C5D0\C11C \AC80\C0C9\B41C \B370\C774\D130\B97C \BCC0\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4. JavaScript \D568\C218 \BCF8\BB38\C744 \D1B5\D574 \BC18\D658\B418\B294 SQL \C9C8\C758\B294 #APEX$SOURCE_DATA# \C758\C0AC \D14C\C774\BE14\C5D0\C11C \C120\D0DD\B418\C5B4\C57C \D558\BA70 \B370\C774\D130 \D504\B85C\D30C\C77C\C5D0\C11C \C0AC\C6A9 \AC00\B2A5\D55C \C5F4\C744 \C77D\C5B4\C57C \D569\B2C8\B2E4. \C5EC\AE30\C11C\B294 SQL WITH \C808\C744 \C0AC\C6A9\D558\B294 \D558\C704 \C9C8\C758 \D329\D1A0\B9C1\C774 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105983145345310255)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106037820750310307)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\ACE0\C6A9\C744 \CD5C\C2E0 \AC83 \BA3C\C800 \D45C\C2DC\D558\ACE0 \BE44\ACE0\C6A9\C744 \B9C8\C9C0\B9C9\C5D0 \D45C\C2DC\D569\B2C8\B2E4. \B0A0\C9DC\AC00 \AC19\C744 \ACBD\C6B0 \BD80\C11C \BC88\D638\BCC4\B85C \C815\B82C\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106037787636310307)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C0\C2DC\C5B4\B97C \D3EC\D568\D558\C5EC \B808\CF54\B4DC \AC80\C0C9 \C21C\C11C\B97C \C815\C758\D560 \CF64\B9C8\B85C \AD6C\BD84\B41C \D558\B098 \C774\C0C1\C758 \C5F4 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('        <p>\C9C0\C2DC\C5B4\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'          <ul>',
unistr('            <li>ASC - \C624\B984\CC28\C21C\C73C\B85C \C5F4\C744 \BC18\D658\D569\B2C8\B2E4.</li>'),
unistr('            <li>DESC - \B0B4\B9BC\CC28\C21C\C73C\B85C \C5F4\C744 \BC18\D658\D569\B2C8\B2E4.</li>'),
unistr('            <li>NULLS FIRST - \AC12\C774 \C5C6\B294 \C5F4\C744 \AC12\C774 \C788\B294 \C5F4\BCF4\B2E4 \BA3C\C800 \BC18\D658\D569\B2C8\B2E4.</li>'),
unistr('            <li>NULLS LAST - \AC12\C774 \C788\B294 \C5F4\C744 \AC12\C774 \C5C6\B294 \C5F4\BCF4\B2E4 \BA3C\C800 \BC18\D658\D569\B2C8\B2E4.</li>'),
'          </ul>',
'        </p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106037687754310307)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105983023549310255)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>EMPNO, ENAME \BC0F SAL \C5F4\C744 \C120\D0DD\D558\ACE0 SAL\C774 3000 \BBF8\B9CC\C778 \BAA8\B4E0 \D589\C744 \D544\D130\B9C1\D558\C5EC \C81C\C678\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105982966514310255)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\D658\B418\B294 SQL \C9C8\C758\AC00 \C6F9 \C18C\C2A4\C5D0\C11C \AC80\C0C9\B41C \B370\C774\D130\B97C \BCC0\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4. PL/SQL \D568\C218 \BCF8\BB38\C744 \D1B5\D574 \BC18\D658\B418\B294 SQL \C9C8\C758\B294 #APEX$SOURCE_DATA# \C758\C0AC \D14C\C774\BE14\C5D0\C11C \C120\D0DD\B418\C5B4\C57C \D558\BA70 \B370\C774\D130 \D504\B85C\D30C\C77C\C5D0\C11C \C0AC\C6A9 \AC00\B2A5\D55C \C5F4\C744 \C77D\C5B4\C57C \D569\B2C8\B2E4. \C5EC\AE30\C11C\B294 SQL WITH \C808\C744 \C0AC\C6A9\D558\B294 \D558\C704 \C9C8\C758 \D329\D1A0\B9C1\C774 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105982866599310255)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105983765391310255)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\D658\B418\B294 SQL \C9C8\C758\AC00 \C6F9 \C18C\C2A4\C5D0\C11C \AC80\C0C9\B41C \B370\C774\D130\B97C \BCC0\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4. Python \D568\C218 \BCF8\BB38\C744 \D1B5\D574 \BC18\D658\B418\B294 SQL \C9C8\C758\B294 #APEX$SOURCE_DATA# \C758\C0AC \D14C\C774\BE14\C5D0\C11C \C120\D0DD\B418\C5B4\C57C \D558\BA70 \B370\C774\D130 \D504\B85C\D30C\C77C\C5D0\C11C \C0AC\C6A9 \AC00\B2A5\D55C \C5F4\C744 \C77D\C5B4\C57C \D569\B2C8\B2E4. \C5EC\AE30\C11C\B294 SQL WITH \C808\C744 \C0AC\C6A9\D558\B294 \D558\C704 \C9C8\C758 \D329\D1A0\B9C1\C774 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105983620802310255)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106039398065310308)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>EMPNO, ENAME \BC0F SAL \C5F4\C744 \C120\D0DD\D558\ACE0 SAL\C774 3000 \BBF8\B9CC\C778 \BAA8\B4E0 \D589\C744 \D544\D130\B9C1\D558\C5EC \C81C\C678\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'select EMPNO, ENAME, SAL',
'  from #APEX$SOURCE_DATA#',
' where SAL < 3000',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106038050654310307)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4\C5D0\C11C \AC80\C0C9\B41C \B370\C774\D130\B97C \BCC0\D658\D560 SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4. #APEX$SOURCE_DATA# \C758\C0AC \D14C\C774\BE14\C5D0\C11C \C120\D0DD\D558\ACE0 \B370\C774\D130 \D504\B85C\D30C\C77C\C5D0\C11C \C0AC\C6A9 \AC00\B2A5\D55C \C5F4\C744 \C9C0\C815\D569\B2C8\B2E4. \C5EC\AE30\C11C\B294 SQL WITH \C808\C744 \C0AC\C6A9\D558\B294 \D558\C704 \C9C8\C758 \D329\D1A0\B9C1\C774 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106037990125310307)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106037570429310307)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\AD00\B9AC\C790\AC00 \C788\AC70\B098 \C9C1\BB34\AC00 \C601\C5C5\C0AC\C6D0\C778 \C0AC\C6D0\B9CC \D3EC\D568\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'( MGR is not null or JOB = ''SALESMAN'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106037491711310307)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\B41C \B808\CF54\B4DC\B97C \C81C\D55C\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C801\D569\D55C SQL Where \C870\AC74\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106037347138310307)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Where \C808')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105304731183309700)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B85C\ADF8\C778 \D398\C774\C9C0\B97C \C81C\CD9C\D55C \D6C4 \C778\C99D\C11C \AC80\C0AC\B97C \C218\D589\D558\AE30 \BC14\B85C \C804\C5D0 \C2E4\D589\D560 \D504\B85C\C2DC\C800 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C774 \D504\B85C\C2DC\C800\B294 "PL/SQL \CF54\B4DC" \C18D\C131 \B610\B294 \B370\C774\D130\BCA0\C774\C2A4 \B0B4\C5D0 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>&PRODUCT_NAME. \C678\BD80\C5D0\C11C \C0AC\C6A9\C790 \C778\C99D\C11C \AC80\C0AC\B97C \C218\D589\D558\B294 \C778\C99D \CCB4\ACC4\C5D0\C11C\B294 \C77C\BC18\C801\C73C\B85C \C0AC\C804 \C778\C99D \D504\B85C\C2DC\C800\AC00 \C218\D589\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, <em>HTTP \BA38\B9AC\AE00 \BCC0\C218</em>, <em>Oracle \C560\D50C\B9AC\CF00\C774\C158 \C11C\BC84 Single Sign-On</em> \BC0F <code>apex_authentication.login</code> \B300\C2E0 <code>apex_authentication.post_login</code>\C744 \C0AC\C6A9\D558\B294 \C0AC\C6A9\C790\C815\C758 \C778\C99D \CCB4\ACC4\AC00 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105304669985309700)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \C778\C99D \D504\B85C\C2DC\C800 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105608676604309949)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C5D0 \B300\D55C \AE30\BCF8 \D0A4\B97C \C800\C7A5\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105608586535309949)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105773228584310088)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105686217319310017)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C0\C815\B41C \C18D\C131\C5D0 \B300\D574 \D14C\B450\B9AC\B97C \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105686103266310017)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B450\B9AC \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105686074981310017)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \D14C\B450\B9AC\C758 \B108\BE44\B97C \D53D\C140\B85C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105685923431310017)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B450\B9AC \B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105810393975310116)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105689401585310020)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\C758 \BC30\ACBD\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105689314377310020)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\ACBD\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105775383942310089)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105689265673310020)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\B97C \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105689127473310020)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105688610704310019)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \AE00\AF34 \C11C\CCB4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105775067621310089)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ko'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105774828666310089)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ko'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105774937616310089)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ko'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105688573379310019)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105689067672310020)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \AE00\AF34 \D06C\AE30\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105688932072310020)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105688826509310020)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \AE00\AF34 \AD75\AE30\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105775201161310089)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD75\C740\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105775119660310089)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105688747671310020)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \AD75\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105810297280310116)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105688437677310019)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\C758 \BC30\ACBD\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105688315431310019)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\ACBD\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105774739778310089)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105688218597310019)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\B97C \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105688176156310019)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105687659223310019)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \AE00\AF34 \C11C\CCB4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105774436961310089)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ko'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105774280317310089)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ko'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105774363086310089)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ko'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105687531334310019)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105688072515310019)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \AE00\AF34 \D06C\AE30\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105687953281310019)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105687872357310019)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \AE00\AF34 \AD75\AE30\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105774600337310089)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD75\C740\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105774586914310089)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105687765593310019)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \AD75\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105577237707309924)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\B97C \C778\C1C4\D560 \B54C \C774 \C5F4\C758 \D06C\AE30\B97C \C9C0\C815\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5F4 \B108\BE44\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105577169812309924)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4 \B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105692095293310022)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \B108\BE44 \AC12\C744 \C815\C758\D558\B294 \B370 \C0AC\C6A9\B418\B294 \B2E8\C704\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105776875592310091)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.PERCENTAGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D37C\C13C\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105776998489310091)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.POINTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\C778\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105691954527310022)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B108\BE44 \B2E8\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105691219696310022)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2E4\C6B4\B85C\B4DC\B41C \BB38\C11C\C758 \C774\B984\C744 \C785\B825\D558\C2ED\C2DC\C624. \BE44\C6CC \B450\BA74 \C601\C5ED \C774\B984\C774 \D30C\C77C \C774\B984\C73C\B85C \C0AC\C6A9\B429\B2C8\B2E4.'),
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105691104046310022)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105685827823310017)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C758 \B192\C774\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105685708037310017)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B192\C774')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105692607285310023)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2E4\C6B4\B85C\B4DC \B9C1\D06C\C5D0 \B300\D55C \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \B9C1\D06C\B97C \B2E8\CD94\C640 \AC19\C740 \B2E4\B978 \D0D0\C0C9 \AD6C\C131\C694\C18C\B85C \BC14\AFB8\B824\BA74 \C774 \D544\B4DC\B97C \BE44\C6CC \B461\B2C8\B2E4. \B2E4\C74C \AD6C\BB38\C774 \D3EC\D568\B41C URL\C744 \B300\C0C1\C73C\B85C \C0AC\C6A9\D574\C11C \C778\C1C4 \D504\B85C\C138\C2A4\B97C \C2DC\C791\D558\B3C4\B85D \B2E4\B978 \AD6C\C131\C694\C18C\B97C \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<p><pre>f?p=&amp;APP_ID.:&amp;SESSION.:FLOW_XMLP_OUTPUT_R[REGION_ID]</pre></p>',
unistr('<p><strong>\CC38\ACE0</strong>: \C704 \BB38\C790\C5F4\C5D0\C11C <code>[REGION_ID]</code>\B97C \C601\C5ED ID\B85C \BC14\AFC9\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105692597428310023)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105685271084310017)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC29\D5A5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105772711181310087)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105772679249310087)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105685136878310016)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105692184263310022)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C5D0\C11C \D30C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105692778476310023)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C5D0\C11C \D30C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105691495286310022)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \CD9C\B825 \D615\C2DD\C744 \C120\D0DD\D569\B2C8\B2E4. \CD9C\B825 \D615\C2DD\C744 \D56D\BAA9\BCC4\B85C \C9C0\C815\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105776648623310090)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.HTM.D'
,p_message_language=>'ko'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105776325425310090)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.PDF.D'
,p_message_language=>'ko'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105776403131310090)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.RTF.D'
,p_message_language=>'ko'
,p_message_text=>'Word'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105776594321310090)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XLS.D'
,p_message_language=>'ko'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105776751706310090)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XML.D'
,p_message_language=>'ko'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105691362428310022)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105691660698310022)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D615\C2DD \AC12\C744 \C800\C7A5\D558\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C0AC\C6A9\C790\AC00 \B7F0\D0C0\C784\C5D0 \CD9C\B825 \D615\C2DD\C744 \C120\D0DD\D560 \C218 \C788\B3C4\B85D <em>\C120\D0DD \BAA9\B85D</em> \D398\C774\C9C0 \D56D\BAA9\C744 \D3EC\D568\D560 \C218 \C788\C2B5\B2C8\B2E4. \C801\D569\D55C \AC12\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'<dt>PDF</dt>',
unistr('<dd>PDF \BBF8\B9AC\BCF4\AE30\C5D0\C11C \BB38\C11C\B97C \C5FD\B2C8\B2E4.</dd>'),
'<dt>RTF</dt>',
unistr('<dd>Microsoft Word\C5D0\C11C \BB38\C11C\B97C \C5FD\B2C8\B2E4.</dd>'),
'<dt>XLS</dt>',
unistr('<dd>Microsoft Excel\C5D0\C11C \BB38\C11C\B97C \C5FD\B2C8\B2E4.</dd>'),
'<dt>HTM</dt>',
unistr('<dd>\BB38\C11C\B97C HTML \D30C\C77C\B85C \B2E4\C6B4\B85C\B4DC\D569\B2C8\B2E4.</dd>'),
'<dt>XML</dt>',
unistr('<dd>\BB38\C11C\B97C XML \D30C\C77C\B85C \B2E4\C6B4\B85C\B4DC\D569\B2C8\B2E4.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105691537719310022)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105690491680310021)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC14\B2E5\AE00\C758 \B9DE\CDA4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105776157592310090)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C6B4\B370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105776081520310090)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105776287515310090)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B05D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105690397823310021)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105775903065310090)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105690285607310021)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\B97C \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105690145755310021)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105689635688310020)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \AE00\AF34 \C11C\CCB4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105775655155310090)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ko'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105775456668310089)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ko'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105775514754310090)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ko'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105689512574310020)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105690077136310021)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \AE00\AF34 \D06C\AE30\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105689902761310021)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105689874265310020)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \AE00\AF34 \AD75\AE30\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105775890613310090)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD75\C740\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105775765353310090)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105689723273310020)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \AD75\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105690656604310021)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C11C\C758 \BC14\B2E5\AE00 \C139\C158\C5D0 \D45C\C2DC\D560 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C758 \AC12\C744 \D45C\C2DC\D558\B824\BA74 <code>&amp;ITEM_NAME.</code> \AD6C\BB38\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105690598964310021)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC14\B2E5\AE00 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105687256450310018)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BA38\B9AC\AE00\C758 \B9DE\CDA4\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105774087341310088)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C6B4\B370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105773937769310088)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105774144198310089)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B05D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105687173198310018)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105773870490310088)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105687049733310018)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\B97C \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 \C138 \AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105686993729310018)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105686432615310018)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \AE00\AF34 \C11C\CCB4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105773524918310088)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ko'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105773334424310088)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ko'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105773484033310088)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ko'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105686330061310018)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105686861816310018)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \AE00\AF34 \D06C\AE30\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105686717424310018)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105686625605310018)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \AE00\AF34 \AD75\AE30\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105773776335310088)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD75\C740\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105773607233310088)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105686580240310018)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\AF34 \AD75\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105687406000310018)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C11C\C758 \BA38\B9AC\AE00 \C139\C158\C5D0 \D45C\C2DC\D560 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C758 \AC12\C744 \D45C\C2DC\D558\B824\BA74 <code>&amp;ITEM_NAME.</code> \AD6C\BB38\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105687335204310018)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D5E4\B354 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105685045401310016)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0 \D06C\AE30\B97C \C120\D0DD\D569\B2C8\B2E4. \D398\C774\C9C0 \B108\BE44\C640 \B192\C774\B97C \C9C1\C811 \C785\B825\D558\B824\BA74 <strong>\C0AC\C6A9\C790\C815\C758</strong>\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105772449039310087)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'ko'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105772375130310087)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'ko'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105772530551310087)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105772167012310087)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'ko'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105772040235310087)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'ko'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105772220917310087)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'ko'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105684921323310016)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105685425350310017)
,p_name=>'PE.PROPERTY.PRINT_UNITS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B108\BE44 \BC0F \B192\C774\B97C \C9C0\C815\D558\B294 \B370 \C0AC\C6A9\B418\B294 \B2E8\C704\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105773001900310088)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.CENTIMETERS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C13C\D2F0\BBF8\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105772822390310088)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.INCHES.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105772972201310088)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.MILLIMETERS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC00\B9AC\BBF8\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105773189576310088)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.POINTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C810')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105685371554310017)
,p_name=>'PE.PROPERTY.PRINT_UNITS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105684824043310016)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4 \BB38\C11C\C5D0 \B300\D55C \CF58\D150\CE20 \CC98\B9AC\B97C \C120\D0DD\D569\B2C8\B2E4. \CF58\D150\CE20 \CC98\B9AC\B294 \BB38\C11C \D45C\C2DC \BC29\BC95\C744 \BE0C\B77C\C6B0\C800\C5D0 \C9C0\C2DC\D558\B294 MIME \D504\B85C\D1A0\CF5C\C5D0 \B300\D55C \D655\C7A5\C785\B2C8\B2E4. <strong>\CCA8\BD80 \D30C\C77C</strong>\C744 \C120\D0DD\D558\BA74 \D30C\C77C\C744 \C778\B77C\C778\C73C\B85C \D45C\C2DC\D558\B294 \B300\C2E0 \B514\C2A4\D06C\C5D0 \C800\C7A5\D558\B3C4\B85D \BE0C\B77C\C6B0\C800\C5D0 \C9C0\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105771824761310087)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.ATTACHMENT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105771927718310087)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.INLINE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105684703841310016)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \BCF4\AE30 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105685659864310017)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C758 \B108\BE44\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105685532375310017)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105045205538309502)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0 \D56D\BAA9\C5D0 \B300\D55C \C5F0\AD00\B41C \D3FC \C601\C5ED\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105045151865309502)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105562555940309912)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D504\B85C\C138\C2A4 \C624\B958 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B418\B294 \C704\CE58, \D504\B85C\C138\C2A4\C758 \C131\ACF5\C801\C778 \C644\B8CC\AC00 \C2E4\D328\D558\B294 \ACBD\C6B0\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105752461348310072)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C9C0\C5D0 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105752511759310072)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 \C624\B958 \BA54\C2DC\C9C0\AC00 "\D1B5\C9C0" \C601\C5ED\C5D0 \D45C\C2DC\B429\B2C8\B2E4(\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C758 \C77C\BD80\B85C \C815\C758\B428).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105752633261310072)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \BC1C\C0DD \C2DC \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105752741021310072)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 \C624\B958 \BA54\C2DC\C9C0\AC00 \C624\B958 \D398\C774\C9C0\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105562484316309912)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105226453674309641)
,p_name=>'PE.PROPERTY.PROCESS_POINT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B80C\B354\B9C1 \B610\B294 \CC98\B9AC \C2DC \C774 \D504\B85C\C138\C2A4\AC00 \C2E4\D589\B418\B294 \C2DC\C810\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105738087634310061)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106029945823310299)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1: \C601\C5ED\C774 \B80C\B354\B9C1\B41C \D6C4 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105738258828310061)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\B2E5\AE00 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106030143043310300)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1: \D398\C774\C9C0\AC00 \B80C\B354\B9C1\B41C \D6C4 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105737882890310061)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106029729852310299)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1: \BA38\B9AC\AE00\C774 \B80C\B354\B9C1\B41C \D6C4 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105738415634310062)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106030326930310300)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC: \AC80\C99D \BC0F \ACC4\C0B0\C774 \C218\D589\B41C \D6C4 \D398\C774\C9C0 \CC98\B9AC\AC00 \C218\D589\B420 \B54C \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105737911492310061)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106029882364310299)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1: \C601\C5ED\C774 \B80C\B354\B9C1\B418\AE30 \C804 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105738112977310061)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\B2E5\AE00 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106030025339310299)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1: \BC14\B2E5\AE00\C774 \B80C\B354\B9C1\B418\AE30 \C804 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105737761245310061)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106029633722310299)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1: \D398\C774\C9C0\AC00 \B80C\B354\B9C1\B418\AE30 \C804 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105738511438310062)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.D'
,p_message_language=>'ko'
,p_message_text=>unistr('Ajax \CF5C\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106030496340310300)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('apex.server JavaScript API\AC00 \D638\CD9C\D560 \B54C \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105737664486310061)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C138\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106029587051310299)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C138\C158\C774 \C0DD\C131\B420 \B54C \C2E4\D589\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105738365947310062)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C \D6C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106030273611310300)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC: \D398\C774\C9C0\AC00 \C81C\CD9C\B41C \D6C4 \ACC4\C0B0, \AC80\C99D \BC0F \D398\C774\C9C0 \D504\B85C\C138\C2A4\AC00 \C218\D589\B418\AE30 \C804 \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105226345583309641)
,p_name=>'PE.PROPERTY.PROCESS_POINT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C810')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105562778036309912)
,p_name=>'PE.PROPERTY.PROCESS_REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D504\B85C\C138\C2A4\C640 \C5F0\AD00\C2DC\D0AC \C601\C5ED\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105562694365309912)
,p_name=>'PE.PROPERTY.PROCESS_REGION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1 \AC00\B2A5 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105441002102309811)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\ACF5\C6A9 \BCF4\ACE0\C11C \C815\C758\B97C \C800\C7A5\D560 \C218 \C788\B294 \C0AC\C6A9\C790\B97C \C81C\D55C\D558\AE30 \C704\D55C \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \ACF5\C6A9 \BCF4\ACE0\C11C\B97C \C800\C7A5\D560 \C218 \C788\B3C4\B85D \D558\B824\BA74 \C774 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \D574\B2F9 \C0AC\C6A9\C790\C5D0 \B300\D574 TRUE\B85C \D3C9\AC00\B418\C5B4\C57C \D569\B2C8\B2E4.</p>'),
unistr('		<p>\CC38\ACE0 - \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \C81C\ACF5\B418\C9C0 \C54A\C73C\BA74 \C544\BB34 \C0AC\C6A9\C790\B098 \BCF4\ACE0\C11C\B97C \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105440902778309811)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9 \BCF4\ACE0\C11C \C800\C7A5 \AD8C\D55C \BD80\C5EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105811242855310117)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('$$$ DJP \D604\C7AC \C228\ACA8\C9D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105601945473309943)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4 \C9C8\C758 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105233540694309646)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C774 \B808\C774\BE14\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105233413041309646)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105233995271309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B450\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C774 \B808\C774\BE14\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105233814426309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105234353513309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C774 \B808\C774\BE14\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105234232500309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105234798019309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B124\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C774 \B808\C774\BE14\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105234679961309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105235168880309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C12F\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C774 \B808\C774\BE14\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105235099534309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105235575874309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5EC\C12F\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C774 \B808\C774\BE14\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105235487330309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105235952947309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\ACF1\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C774 \B808\C774\BE14\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105235817325309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105236316908309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5EC\B35F\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C774 \B808\C774\BE14\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105236267015309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105236721880309649)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\D649\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C774 \B808\C774\BE14\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105236633255309649)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105237161778309649)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\C5D0 \B300\D55C \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C774 \B808\C774\BE14\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105237070565309649)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105233362354309646)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01 <strong>\BE60\B978 \C120\D0DD</strong> \B9C1\D06C \D45C\C2DC\C640 \C5F0\AD00\B41C HTML \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105233297916309646)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105233720915309646)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\ACFC \C5F0\AD00\B41C \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C0AC\C6A9\C790\AC00 \C774 \BE60\B978 \C120\D0DD\C744 \B204\B97C \B54C \AE30\C874 \D56D\BAA9 \AC12\C744 \BC14\AFC9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105233659063309646)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105234150730309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B450\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\ACFC \C5F0\AD00\B41C \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C0AC\C6A9\C790\AC00 \C774 \BE60\B978 \C120\D0DD\C744 \B204\B97C \B54C \AE30\C874 \D56D\BAA9 \AC12\C744 \BC14\AFC9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105234098643309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105234538206309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\ACFC \C5F0\AD00\B41C \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C0AC\C6A9\C790\AC00 \C774 \BE60\B978 \C120\D0DD\C744 \B204\B97C \B54C \AE30\C874 \D56D\BAA9 \AC12\C744 \BC14\AFC9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105234400453309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105234962509309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B124\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\ACFC \C5F0\AD00\B41C \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C0AC\C6A9\C790\AC00 \C774 \BE60\B978 \C120\D0DD\C744 \B204\B97C \B54C \AE30\C874 \D56D\BAA9 \AC12\C744 \BC14\AFC9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105234828501309647)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105235386485309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C12F\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\ACFC \C5F0\AD00\B41C \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C0AC\C6A9\C790\AC00 \C774 \BE60\B978 \C120\D0DD\C744 \B204\B97C \B54C \AE30\C874 \D56D\BAA9 \AC12\C744 \BC14\AFC9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105235253515309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105235712548309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5EC\C12F\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\ACFC \C5F0\AD00\B41C \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C0AC\C6A9\C790\AC00 \C774 \BE60\B978 \C120\D0DD\C744 \B204\B97C \B54C \AE30\C874 \D56D\BAA9 \AC12\C744 \BC14\AFC9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105235686677309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105236105569309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\ACF1\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\ACFC \C5F0\AD00\B41C \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C0AC\C6A9\C790\AC00 \C774 \BE60\B978 \C120\D0DD\C744 \B204\B97C \B54C \AE30\C874 \D56D\BAA9 \AC12\C744 \BC14\AFC9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105236008454309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105236574561309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5EC\B35F\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\ACFC \C5F0\AD00\B41C \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C0AC\C6A9\C790\AC00 \C774 \BE60\B978 \C120\D0DD\C744 \B204\B97C \B54C \AE30\C874 \D56D\BAA9 \AC12\C744 \BC14\AFC9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105236476179309648)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105236968820309649)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\D649\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\ACFC \C5F0\AD00\B41C \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C0AC\C6A9\C790\AC00 \C774 \BE60\B978 \C120\D0DD\C744 \B204\B97C \B54C \AE30\C874 \D56D\BAA9 \AC12\C744 \BC14\AFC9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105236826159309649)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105237388908309649)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\BC88\C9F8 <strong>\BE60\B978 \C120\D0DD</strong>\ACFC \C5F0\AD00\B41C \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C0AC\C6A9\C790\AC00 \C774 \BE60\B978 \C120\D0DD\C744 \B204\B97C \B54C \AE30\C874 \D56D\BAA9 \AC12\C744 \BC14\AFC9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105237260465309649)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105575446523309922)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B77C\B514\C624 \ADF8\B8F9 \C5F4\C5D0 \B300\D574 \D45C\C2DC\D560 \C5F4 \C218\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105575307673309922)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105306537809309701)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Real Application Security \B3D9\C801 \B864\C758 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4. \C608:'),
'<pre>',
'DB_EMP:DB_DEPT',
'</pre></p>',
unistr('<p>&PRODUCT_NAME.\C740(\B294) <em>sys.dbms_xs_sessions.assign_user</em>\C758 <em>enable_dynamic_roles</em> \B9E4\AC1C\BCC0\C218\B97C \D1B5\D574 \C804\B2EC\D558\C5EC \B85C\ADF8\C778 \C2DC\C5D0 \C774\B7EC\D55C \B864\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105306442433309701)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105306305879309701)
,p_name=>'PE.PROPERTY.RAS_MODE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C Oracle RAS(Real Application Security)\AC00 \C0AC\C6A9\B418\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>RAS \BAA8\B4DC\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D55C \ACBD\C6B0 \C0AC\C6A9\C790\C5D0\AC8C \C560\D50C\B9AC\CF00\C774\C158\C758 \C2A4\D0A4\B9C8 \AC1D\CCB4\C5D0 \C561\C138\C2A4\D560 \C218 \C788\B294 \AD8C\D55C\C774 \C788\C5B4\C57C \D569\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, <strong>\C678\BD80 \C0AC\C6A9\C790</strong>\C758 \ACBD\C6B0 <em>RAS \B3D9\C801 \C560\D50C\B9AC\CF00\C774\C158 \B864</em>\C5D0 \B370\C774\D130\BCA0\C774\C2A4 \AD8C\D55C\C744 \BD80\C5EC\D558\ACE0 \C774 \C778\C99D \CCB4\ACC4\C5D0\C11C <em>\B3D9\C801 \B864</em>\B85C \AD6C\C131\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C0AC\D6C4 \C778\C99D \D504\B85C\C2DC\C800 \B4F1\C5D0\C11C <em>apex_authorization.enable_dynamic_groups</em>\C5D0 \B300\D55C \D638\CD9C\C744 \D1B5\D574 \B864\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105739654223310063)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106030594175310300)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('Real Application Security\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105739790088310063)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\BD80 \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106030675321310300)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('&PRODUCT_NAME.\C740(\B294) \BAA8\B4E0 \C0AC\C6A9\C790\B97C \B0B4\BD80 \C0AC\C6A9\C790\B85C \AC04\C8FC\D558\ACE0 <em>is_external</em> \B9E4\AC1C\BCC0\C218\B97C \D1B5\D574 <em>sys.dbms_xs_sessions.assign_user</em>\C5D0 <em>false</em>\B97C \C804\B2EC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105739891688310063)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\BD80 \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106030703268310300)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('&PRODUCT_NAME.\C774(\AC00) <em>is_external</em> \B9E4\AC1C\BCC0\C218\B97C \D1B5\D574 <em>sys.dbms_xs_sessions.assign_user</em>\C5D0 <em>true</em>\B97C \C804\B2EC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105306212798309701)
,p_name=>'PE.PROPERTY.RAS_MODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('RAS \BAA8\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105306741173309702)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Real Application Security \B124\C784\C2A4\D398\C774\C2A4 \D15C\D50C\B9AC\D2B8\C758 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4. \C608:'),
'<pre>',
'NS1:NS2',
'</pre></p>',
unistr('<p>&PRODUCT_NAME.\C740(\B294) <em>sys.dbms_xs_sessions.assign_user</em>\C758 <em>namespaces</em> \B9E4\AC1C\BCC0\C218\B97C \D1B5\D574 \C804\B2EC\D558\C5EC \B85C\ADF8\C778 \C2DC\C5D0 \C774\B7EC\D55C \B124\C784\C2A4\D398\C774\C2A4\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105306687045309701)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B124\C784\C2A4\D398\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105955516176310229)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D45C\D604\C2DD\C744 \D3C9\AC00\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105955920545310229)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105955897071310229)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105955752527310229)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105956053525310230)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105955639569310229)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ko'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105955442944310229)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105957537405310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105957867663310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105957754645310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105957641756310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105957945689310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105957444916310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105243762582309654)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105243694900309654)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105245140195309655)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105245025003309655)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105957179800310230)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C Java \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105957088354310230)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105958749866310232)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105958623188310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105956909898310230)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105956838525310230)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C JavaScript \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105956777841310230)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105958506547310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105958407699310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105958338678310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105243982978309654)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \CF5C\B860(:)\C73C\B85C \AD6C\BD84\B41C \AC12 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105243822356309654)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105244331745309654)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \D398\C774\C9C0 \BC88\D638\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105244299914309654)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105244518502309655)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \D398\C774\C9C0 \BC88\D638 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105244430896309655)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105956625568310230)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105956581159310230)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105956461916310230)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105958274119310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105958188611310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105958078470310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105244128541309654)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \C9C0\C815\B41C \AC12\ACFC \BE44\AD50\B418\B294 \C0AC\C6A9\C790 \D658\ACBD\C124\C815\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105244062770309654)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105957349873310231)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C Python \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105957278021310230)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105958992424310232)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105958862657310232)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105956397659310230)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \AD00\B9AC\C790\C774\ACE0 \BD80\C11C\AC00 \C2DC\CE74\ACE0\C5D0 \C788\C744 \B54C \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105956294718310230)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105956127601310230)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106105850933310370)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\B294\C9C0 \D655\C778\D560 \B54C \D558\B098 \C774\C0C1\C758 \D589\C774 \C874\C7AC\D558\BA74 \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\C9C1\C6D0\C774 \BD80\C11C 40\C5D0 \C18D\D558\B294\C9C0 \D655\C778\D560 \B54C \D589\C774 \C874\C7AC\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\C801\C73C\B85C \BC18\D658\D558\B824\BA74:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105243332616309654)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105243262592309654)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105244771290309655)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D55C \D14D\C2A4\D2B8 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105244629510309655)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105245310773309655)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 <code>&ITEM.</code> \B300\CCB4 \BB38\C790\C5F4\C744 \D3EC\D568\D558\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105245255013309655)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105454256175309823)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\B97C \C77D\AE30 \C804\C6A9\C73C\B85C \B80C\B354\B9C1\D558\AE30 \C704\D574 \CDA9\C871\C2DC\CF1C\C57C \D558\B294 \C870\AC74 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C870\AC74\C744 \C120\D0DD\D558\C9C0 \C54A\C73C\BA74 \D56D\BAA9\C774 \C77C\BC18\C801\C73C\B85C \B80C\B354\B9C1\B429\B2C8\B2E4.'),
unistr('\C77D\AE30 \C804\C6A9 \D56D\BAA9\C740 \D45C\C2DC \C804\C6A9 \D56D\BAA9\ACFC \B3D9\C77C\D55C \C124\C815\C744 \C0AC\C6A9\D574\C11C \B80C\B354\B9C1\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \D56D\BAA9\C744 \D56D\C0C1 \C785\B825 \AC00\B2A5\D55C \D544\B4DC\B85C \B80C\B354\B9C1\D558\B824\BA74 \C870\AC74 \C720\D615\C744 <strong>\BB34\C870\AC74 \BD80\C815</strong>\C73C\B85C \C124\C815\D569\B2C8\B2E4.'),
unistr('\C774 \C124\C815\C740 \D574\B2F9 \C601\C5ED \B610\B294 \D398\C774\C9C0 \B808\BCA8\C5D0 \C788\B294 \BAA8\B4E0 \C77D\AE30 \C804\C6A9 \C870\AC74 \C124\C815\C744 \ACB9\CCD0\C501\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104858254825309361)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\B97C \C77D\AE30 \C804\C6A9\C73C\B85C \B80C\B354\B9C1\D558\AE30 \C704\D574 \CDA9\C871\C2DC\CF1C\C57C \D558\B294 \C870\AC74 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C870\AC74\C744 \C120\D0DD\D558\C9C0 \C54A\C73C\BA74 \D56D\BAA9\C774 \C77C\BC18\C801\C73C\B85C \B80C\B354\B9C1\B429\B2C8\B2E4.'),
unistr('\C77D\AE30 \C804\C6A9 \D56D\BAA9\C740 \D45C\C2DC \C804\C6A9 \D56D\BAA9\ACFC \B3D9\C77C\D55C \C124\C815\C744 \C0AC\C6A9\D574\C11C \B80C\B354\B9C1\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \D56D\BAA9\C744 \D56D\C0C1 \C785\B825 \AC00\B2A5\D55C \D544\B4DC\B85C \B80C\B354\B9C1\D558\B824\BA74 \C870\AC74 \C720\D615\C744 <strong>\BB34\C870\AC74 \BD80\C815</strong>\C73C\B85C \C124\C815\D569\B2C8\B2E4.'),
unistr('\C774 \C124\C815\C740 \D574\B2F9 \C601\C5ED \B610\B294 \D398\C774\C9C0 \B808\BCA8\C5D0 \C788\B294 \BAA8\B4E0 \C77D\AE30 \C804\C6A9 \C870\AC74 \C124\C815\C744 \ACB9\CCD0\C501\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105309108582309704)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C601\C5ED\C5D0\C11C \D398\C774\C9C0 \D56D\BAA9\C744 \C77D\AE30 \C804\C6A9\C73C\B85C \B80C\B354\B9C1\D558\AE30 \C704\D574 \CDA9\C871\C2DC\CF1C\C57C \D558\B294 \C870\AC74 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C870\AC74\C744 \C120\D0DD\D558\C9C0 \C54A\C73C\BA74 \D398\C774\C9C0 \D56D\BAA9\C774 \C77C\BC18\C801\C73C\B85C \B80C\B354\B9C1\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C774 \C601\C5ED\C758 \D398\C774\C9C0 \D56D\BAA9(\C608: \AC80\C0C9 \D544\B4DC)\C774 \D56D\C0C1 \C774 \C870\AC74\C758 \D3C9\AC00 \BC29\BC95\C5D0 \AD00\ACC4\C5C6\C774 \C785\B825 \AC00\B2A5\D55C \D398\C774\C9C0 \D56D\BAA9\C73C\B85C \B80C\B354\B9C1\B418\B3C4\B85D \D558\B824\B294 \ACBD\C6B0 \C601\C5ED \C124\C815\C744 \ACB9\CCD0\C4F0\B824\BA74 \D574\B2F9 \D398\C774\C9C0 \D56D\BAA9\C758 \C77D\AE30 \C804\C6A9 \C870\AC74\C744 "\BB34\C870\AC74 \BD80\C815"\C73C\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105229002408309643)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\C5D0\C11C \D398\C774\C9C0 \D56D\BAA9\C744 \C77D\AE30 \C804\C6A9\C73C\B85C \B80C\B354\B9C1\D558\AE30 \C704\D574 \CDA9\C871\B418\C5B4\C57C \D558\B294 \C870\AC74 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4. \C870\AC74\C744 \C120\D0DD\D558\C9C0 \C54A\C73C\BA74 \D398\C774\C9C0 \D56D\BAA9\C774 \C77C\BC18\C801\C73C\B85C \B80C\B354\B9C1\B429\B2C8\B2E4.'),
unistr('\C77D\AE30 \C804\C6A9 \C870\AC74\C740 <em>\BA38\B9AC\AE00 \C55E</em> \CC98\B9AC \C9C0\C810\C5D0\C11C \D504\B85C\C138\C2A4\B97C \C2E4\D589\D55C \D6C4 \D3C9\AC00\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C774 \C870\AC74\C758 \D3C9\AC00 \BC29\BC95\C5D0 \AD00\ACC4\C5C6\C774 \D2B9\C815 \C601\C5ED\C758 \C77C\BD80 \D398\C774\C9C0 \D56D\BAA9(\C608: \AC80\C0C9 \D544\B4DC) \B610\B294 \BAA8\B4E0 \D398\C774\C9C0 \D56D\BAA9\C774 \D56D\C0C1 \C785\B825 \AC00\B2A5\D55C \D398\C774\C9C0 \D56D\BAA9\C73C\B85C \B80C\B354\B9C1\B418\B3C4\B85D \D558\B824\B294 \ACBD\C6B0 \C0C1\C704 \C124\C815\C744 \ACB9\CCD0\C4F0\B3C4\B85D \D574\B2F9 \C601\C5ED/\D398\C774\C9C0 \D56D\BAA9\C758 \C77D\AE30 \C804\C6A9 \C870\AC74\C744 <strong>\BB34\C870\AC74 \BD80\C815</strong>\C73C\B85C \C124\C815\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105797983779310106)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105937411735310216)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\B294 \D56D\C0C1 \C77D\AE30 \C804\C6A9\C73C\B85C \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105796508229310105)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 Microsoft Internet Explorer 7.0 \C774\C0C1\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105796699293310105)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 XHTML / CSS \C9C0\C6D0 \BE0C\B77C\C6B0\C800\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105796459074310105)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 Mozilla, Netscape 6.x/7x \C774\C0C1\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105796708120310105)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \BE0C\B77C\C6B0\C800\AC00 \AE30\D0C0 \BE0C\B77C\C6B0\C800(\B610\B294 \C774\C804 \BC84\C804)\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105795198557310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\AC00 \D56D\BAA9\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105797168854310106)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105941082478310218)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105796868662310106)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4\AC00 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105941230046310218)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4 \C911 \D558\B098\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105797091749310106)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105941188424310218)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D558\ACE0 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105796991881310106)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C5B8\C5B4\AC00 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105941320602310219)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C77C\BC18 \C0AC\C6A9\C790\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C5B8\C5B4 \C911 \D558\B098\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D558\ACE0 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105794356931310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 = \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105939812431310217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \AC12\ACFC \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105794526760310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105940052636310218)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105794456103310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 != \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105939930541310217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \AC12\ACFC \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105794691092310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105940131302310218)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 <em>\D398\C774\C9C0</em>\C5D0 \C785\B825\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105797236415310106)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105797323363310106)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105796082721310105)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D45C\C2DC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105940891079310218)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\CD9C \D6C4 \C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D398\C774\C9C0\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105795462870310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105795243554310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\AC00 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105795312455310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8\AC00 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105795516486310105)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105792049664310102)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \BC18\D658\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105937526474310216)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\AC00 \D558\B098 \C774\C0C1\C758 \D589\C744 \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105955200678310229)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105955379262310229)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD\C774 TRUE\B85C \D3C9\AC00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105792231499310102)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105937787255310216)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38\C774 TRUE\B97C \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105797605578310106)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105797780519310106)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105795786696310105)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0/\C601\C5ED\C774 \C77D\AE30 \C804\C6A9\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105940540782310218)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B610\B294 \C0C1\C704 \C601\C5ED(\D574\B2F9\D558\B294 \ACBD\C6B0)\C774 \C815\C0C1\C801\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105795681113310105)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0/\C601\C5ED\C774 \C77D\AE30 \C804\C6A9\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105940498864310218)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B610\B294 \C0C1\C704 \C601\C5ED(\D574\B2F9\D558\B294 \ACBD\C6B0) \C911 \D558\B098\C785\B2C8\B2E4. ''\C77D\AE30 \C804\C6A9'' \C870\AC74\C740 TRUE\B85C \D3C9\AC00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105793521388310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \ACF5\BC31\C744 \D3EC\D568\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105939031324310217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \ACF5\BC31\C744 \D3EC\D568\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105793876612310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C601\C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105939345789310217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BB38\C790 \B610\B294 \C22B\C790\B9CC \D3EC\D568\D558\ACE0 \D2B9\C218 \BB38\C790\B294 \D3EC\D568\D558\C9C0 \C54A\B294 \C601\C22B\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105793011276310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105938584799310216)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105793710579310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C22B\C790\AC00 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105939292305310217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105793280619310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 0\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105938744604310217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790 0\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105792956582310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \B110\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105938487640310216)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105793307449310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 NULL \B610\B294 0\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105938809141310217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\AC70\B098 \C22B\C790 0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105793658460310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105939155644310217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105793110536310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 0\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105938638997310216)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \C22B\C790 0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105793465715310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 NULL\B3C4 \C544\B2C8\ACE0 0\B3C4 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105938928706310217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 \BE44\C5B4 \C788\C9C0 \C54A\ACE0 \C22B\C790 0\B3C4 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105796224083310105)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BCF4\ACE0\C11C(\C55E\C73C\B85C \B2E8\CD94\B97C \D45C\C2DC\D558\B824\BA74 <b>\D655\C778</b> \B204\B974\AE30)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105796305720310105)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BCF4\ACE0\C11C(\B4A4\B85C \B2E8\CD94\B97C \D45C\C2DC\D558\B824\BA74 <b>\D655\C778</b> \B204\B974\AE30)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105797883994310106)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\C870\AC74 \BD80\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105941464634310219)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \AD6C\C131\C694\C18C\C758 \C77D\AE30 \C804\C6A9 \C870\AC74\C5D0 \AD00\ACC4\C5C6\C774 \AD6C\C131\C694\C18C\AC00 \C815\C0C1\C801\C73C\B85C \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105796161171310105)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D45C\C2DC\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105940919367310218)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \AC80\C99D \C624\B958\AC00 \D398\C774\C9C0\C5D0 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105792103416310102)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \BC18\D658\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105937624107310216)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\AC00 \D589\C744 \BC18\D658\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105794955709310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\AC00 \C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105940289544310218)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\B294 \C77C\BC18 \C0AC\C6A9\C790\C5D0 \C758\D574 ''\C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC''\B85C \D1A0\AE00\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105795016363310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\B294 \C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC\AC00 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105940350543310218)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0\B294 \C77C\BC18 \C0AC\C6A9\C790\C5D0 \C758\D574 ''\C778\C1C4\C6A9 \D654\BA74 \BAA8\B4DC''\B85C \D1A0\AE00\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105792309968310102)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD = \AC12')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105937859855310216)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105792539378310102)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\C774 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105938063778310216)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105792438825310102)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105937942582310216)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105792649651310102)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\C774 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105938176278310216)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105797483182310106)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105797564008310106)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105795827105310105)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C778\C99D\B428(\ACF5\AC1C \C0AC\C6A9\C790\AC00 \C544\B2D8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105940613977310218)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B85C\ADF8\C778\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105795992937310105)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \ACF5\AC1C \C0AC\C6A9\C790\C784(\C0AC\C6A9\C790\AC00 \C778\C99D\B418\C9C0 \C54A\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105940714495310218)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B85C\ADF8\C778\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105794116808310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D658\ACBD\C124\C815 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105939671213310217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\D55C <em>\D658\ACBD\C124\C815</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105794210062310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \D658\ACBD\C124\C815 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105939750540310217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\D55C <em>\D658\ACBD\C124\C815</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105793923207310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105939488973310217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C644\C804\D788 \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105794077386310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \BAA9\B85D\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105939570284310217)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12 \C77C\BD80\AC00 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105792795931310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105938282236310216)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105792825296310103)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105938388534310216)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105794837474310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 != \C81C\CD9C\B41C \D398\C774\C9C0(\AC8C\C2DC\B428)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105794789723310104)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D398\C774\C9C0 = \C81C\CD9C\B41C \D398\C774\C9C0(\AC8C\C2DC\B428)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105228957200309643)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105243513812309654)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74\ACFC \BE44\AD50\D560 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105243406368309654)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105244974784309655)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C870\AC74\C5D0 \B300\D574 <code>&ITEM.</code> \B300\CCB4 \BB38\C790\C5F4\C744 \D3EC\D568\D558\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105244844746309655)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105735176338310059)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>'<pre>bgcolor="#FF0000"</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105237566526309649)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77D\AE30 \C804\C6A9 \BAA8\B4DC\B85C \D45C\C2DC\B420 \B54C \D56D\BAA9 HTML \D14C\C774\BE14 \C140 \D0DC\ADF8 <code>&lt;td&gt;</code>\C5D0 \D3EC\D568\B418\B294 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105237413177309649)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77D\AE30 \C804\C6A9 HTML \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105522137368309879)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C5C5\B370\C774\D2B8 \C0AC\C774\C758 \AC04\ACA9(\CD08)\C744 \C785\B825\D569\B2C8\B2E4. 2\CD08\C640 \AC19\C774 \B9E4\C6B0 \C9E7\C740 \C5C5\B370\C774\D2B8 \AC04\ACA9\C740 \C2EC\AC01\D55C \B370\C774\D130\BCA0\C774\C2A4 \C131\B2A5 \BB38\C81C\B97C \C77C\C73C\D0AC \C218 \C788\C73C\BBC0\B85C \AD8C\C7A5\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105522028483309879)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\ACA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105522266583309880)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105249819857309658)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94\AC00 \D45C\C2DC\B420 \C601\C5ED\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105267168016309671)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104858168830309361)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \D45C\C2DC\B420 \C601\C5ED\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105267083196309671)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105242726725309653)
,p_name=>'PE.PROPERTY.REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\AC00 \C5F0\AD00\B41C \C601\C5ED\C744 \C120\D0DD\D569\B2C8\B2E4. \AD6C\C131\C694\C18C\AC00 \D45C\C2DC\B420 \ACBD\C6B0\C5D0\B294 \C9C0\C815\B41C \C601\C5ED \B0B4\C5D0 \ADF8\B9AC\ACE0 \C774 \C601\C5ED \B0B4\C758 \B2E4\B978 \AD6C\C131\C694\C18C\C640 \C0C1\B300\C801\C778 \C704\CE58\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105242629319309653)
,p_name=>'PE.PROPERTY.REGION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105307913385309703)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C601\C5ED\C744 \C601\C5ED \D45C\C2DC \C120\D0DD\AE30\C5D0 \D3EC\D568\D558\B824\B294 \ACBD\C6B0 <strong>\C124\C815</strong>\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C774 \C18D\C131\C740 <em>\C601\C5ED \D45C\C2DC \C120\D0DD\AE30</em>\C758 \C601\C5ED \C720\D615\C774 \C815\C758\B418\C5C8\ACE0 \D398\C774\C9C0\C5D0\C11C \D45C\C2DC\D560 \C218 \C788\B294 \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\C790\AC00 \C601\C5ED \D45C\C2DC \C120\D0DD\AE30\C5D0 \D3EC\D568\B41C \C601\C5ED \C774\B984\C744 \B204\B974\BA74 \C120\D0DD\B41C \C601\C5ED\B9CC \D45C\C2DC\B418\ACE0 \B2E4\B978 \B098\C5F4\B41C \BAA8\B4E0 \C601\C5ED\C740 \C228\ACA8\C9D1\B2C8\B2E4.'),
unistr('\C601\C5ED \D45C\C2DC \C120\D0DD\AE30 \B0B4\C758 \CCAB\BC88\C9F8 \D56D\BAA9\C740 \C0AC\C6A9\C790\AC00 \C774\C804\C5D0 \C120\D0DD\D55C \C601\C5ED\B9CC\C774 \C544\B2C8\B77C \C0AC\C6A9 \AC00\B2A5\D55C \BAA8\B4E0 \C601\C5ED\C744 \D45C\C2DC\D560 \C218 \C788\AC8C \D574\C8FC\B294 <em>\BAA8\B450 \D45C\C2DC</em>\C785\B2C8\B2E4.</p>'),
unistr('<p>\C601\C5ED \C870\AC74\C5D0 \B530\B77C \C601\C5ED\C744 \D45C\C2DC\D560 \C218 \C5C6\C73C\BA74 \C601\C5ED \D45C\C2DC \C120\D0DD\AE30 \B0B4\C758 \C601\C5ED \BAA9\B85D\C5D0 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105307898311309702)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D45C\C2DC \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105308785146309703)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C601\C5ED\C5D0 \B300\D55C \AE30\C900\C73C\B85C \C0AC\C6A9\B418\B294 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105308633412309703)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105306996362309702)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C <em>\C601\C5ED \C720\D615</em>\C5D0 \B530\B77C \C601\C5ED \C18C\C2A4 \B610\B294 \CF58\D150\CE20\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105306827300309702)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105308166116309703)
,p_name=>'PE.PROPERTY.REGION_IMAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED\C758 \C67C\CABD \C0C1\B2E8\C5D0 \D45C\C2DC\B418\B294 \C774\BBF8\C9C0\C5D0 \B300\D55C \CC38\C870\B97C \C785\B825\D569\B2C8\B2E4. \C774 \C774\BBF8\C9C0\B97C \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \D14C\C774\BE14 \D0DC\ADF8\B294 \C81C\C5B4\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105308011527309703)
,p_name=>'PE.PROPERTY.REGION_IMAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105602121211309943)
,p_name=>'PE.PROPERTY.REGION_PLAIN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \D14D\C2A4\D2B8 \C18C\C2A4\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105602071717309943)
,p_name=>'PE.PROPERTY.REGION_PLAIN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105303290259309699)
,p_name=>'PE.PROPERTY.REGION_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C SQL \C18C\C2A4\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105303173182309698)
,p_name=>'PE.PROPERTY.REGION_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105307537400309702)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C601\C5ED\C758 \BAA8\C591\ACFC \B808\C774\C544\C6C3\C744 \C815\C758\D560 \C601\C5ED \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('        <p>\C601\C5ED \D15C\D50C\B9AC\D2B8\B294 \C560\D50C\B9AC\CF00\C774\C158 \D14C\B9C8\C5D0\C11C \C815\C758\B429\B2C8\B2E4.'),
unistr('        \C601\C5ED\C774 \C0DD\C131\B418\BA74 \D15C\D50C\B9AC\D2B8\B294 \D604\C7AC \D14C\B9C8\C5D0 \C815\C758\B41C \AE30\BCF8 \C601\C5ED \D15C\D50C\B9AC\D2B8\B85C \C790\B3D9\C73C\B85C \C124\C815\B429\B2C8\B2E4.</p>'),
unistr('        <p>\B300\BD80\BD84\C758 \D14C\B9C8\C5D0\B294 \BCF4\ACE0\C11C, \D3FC, \ACBD\BCF4, \B2E8\CD94, \CD95\C18C \AC00\B2A5\D55C(\C228\AE30\AE30/\D45C\C2DC) \CF58\D150\CE20, \B85C\ADF8\C778 \D3FC \B4F1\C744 \D45C\C2DC\D558\AE30 \C704\D55C \C601\C5ED \D15C\D50C\B9AC\D2B8\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.<br>'),
unistr('        \BC94\C6A9 \D14C\B9C8\B294 \B2E4\C74C\ACFC \AC19\C740 \C601\C5ED \D15C\D50C\B9AC\D2B8\B97C \C81C\ACF5\D569\B2C8\B2E4.'),
'          <dl>',
unistr('            <dt>\ACBD\BCF4</dt>'),
unistr('            <dt>\C18D\C131 \C788\B294 \ACF5\BC31</dt>'),
unistr('            <dt>\B2E8\CD94 \CEE8\D14C\C774\B108</dt>'),
unistr('            <dt>\CF00\B7EC\C140 \CEE8\D14C\C774\B108</dt>'),
unistr('            <dt>\CD95\C18C \AC00\B2A5</dt>'),
unistr('            <dt>\CF58\D150\CE20 \BE14\B85D</dt>'),
unistr('            <dt>\BA54\C778</dt>'),
unistr('            <dt>\C778\B77C\C778 \B300\D654\C0C1\C790</dt>'),
unistr('            <dt>\C778\B77C\C778 \D31D\C5C5</dt>'),
unistr('            <dt>\B300\D654\C2DD \BCF4\ACE0\C11C</dt>'),
unistr('            <dt>\B85C\ADF8\C778</dt>'),
unistr('            <dt>\D45C\C900</dt>'),
unistr('            <dt>\D0ED \CEE8\D14C\C774\B108</dt>'),
unistr('            <dt>\C81C\BAA9 \D45C\C2DC\C904</dt>'),
unistr('            <dt>\B9C8\BC95\C0AC \CEE8\D14C\C774\B108</dt>'),
'          </dl>',
unistr('          \CC38\ACE0: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105307449485309702)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105419193448309793)
,p_name=>'PE.PROPERTY.REGION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C601\C5ED\C758 \B80C\B354\B9C1 \BC29\BC95\C744 \C9C0\C815\D569\B2C8\B2E4. \C9C0\C6D0\B418\B294 \C601\C5ED \C720\D615\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\C5D0 \B530\B77C \C5EC\AE30\C5D0\C11C \CD94\AC00 \C601\C5ED \C720\D615 \D50C\B7EC\ADF8\C778\C744 \C0AC\C6A9\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \D50C\B7EC\ADF8\C778\C740 <em>&lt;My Plug-in&gt; [Plug-in]</em>\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('\B2E4\C74C \D50C\B7EC\ADF8\C778\C740 \C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \ACF5\C720 \AD6C\C131\C694\C18C \B0B4\C5D0 \C124\CE58\B429\B2C8\B2E4.</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105242014732309653)
,p_name=>'PE.PROPERTY.REGION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105681143368310013)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC80\C99D\C5D0 \B300\D574 \D14C\C2A4\D2B8\D560 \D488\C9C8 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4. \C120\D0DD\C5D0 \B530\B77C \C774 \AC80\C99D\C744 \C644\C804\D788 \C815\C758\D558\B824\BA74 \D558\B098 \C774\C0C1\C758 \CD94\AC00 \C18D\C131\C774 \D544\C694\D569\B2C8\B2E4.</p>'),
unistr('<p>\AC80\C99D\C73C\B85C \D488\C9C8 \D14C\C2A4\D2B8\AC00 \C804\B2EC\B418\AC70\B098 \AC80\C99D\C774 TRUE\B85C \D3C9\AC00\B418\BA74 \AC80\C99D \C624\B958 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('\AC80\C99D\C774 \D488\C9C8 \D14C\C2A4\D2B8\B97C \C2E4\D328\D558\AC70\B098 FALSE\B85C \D3C9\AC00\B418\AC70\B098 \BE44\C5B4 \C788\C9C0 \C54A\C740 \D14D\C2A4\D2B8 \BB38\C790\C5F4\C774 \BC18\D658\B418\BA74 \AC80\C99D \C624\B958 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\AC80\C99D\C774 \C2E4\D328\D574\B3C4 \D6C4\C18D \AC80\C99D \C2E4\D589\C774 \C815\C9C0\B418\C9C0\B294 \C54A\C73C\BBC0\B85C \AC01 \D6C4\C18D \AC80\C99D\C73C\B85C \C778\D574 \CD94\AC00\C801\C778 \AC80\C99D \C624\B958 \BA54\C2DC\C9C0\AC00 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4. \D6C4\C18D \AC80\C99D\C774 \C2E4\D589\B418\C9C0 \C54A\B3C4\B85D \D558\B824\BA74 \D398\C774\C9C0 \D56D\BAA9\C744 \D2B9\C815 \AC12\C73C\B85C \C124\C815\D55C \D6C4 \D544\C694\C5D0 \B530\B77C \D6C4\C18D \AC80\C99D\C5D0 \B300\D55C \C870\AC74\BD80 \B17C\B9AC\B97C \C801\C6A9\D558\B294 \B4F1 \CCAB\BC88\C9F8 \C2E4\D328\D55C \AC80\C99D\C5D0 \B17C\B9AC\B97C \CD94\AC00\D574\C57C \D569\B2C8\B2E4. \D558\B098 \C774\C0C1\C758 \AC80\C99D\C5D0 \B300\D55C \D3C9\AC00\AC00 \C2E4\D328\D558\BA74 \D6C4\C18D \D504\B85C\C138\C2A4 \BC0F \BD84\AE30\AC00 \C2E4\D589\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105781805912310094)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \BC18\D658\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105781991677310094)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL \C9C8\C758\AC00 \D589\C744 \D558\B098 \C774\C0C1 \BC18\D658\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('SQL \C9C8\C758\AC00 \D589\C744 \BC18\D658\D558\C9C0 \C54A\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105989285577310260)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105989335450310261)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D45C\D604\C2DD\C774 TRUE\B85C \D3C9\AC00\B418\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D45C\D604\C2DD\C774 FALSE\B85C \D3C9\AC00\B418\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105782424702310095)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38(\BD80\C6B8 \BC18\D658)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105782576393310095)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D568\C218 \BCF8\BB38\C774 TRUE\B97C \BC18\D658\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D568\C218 \BCF8\BB38\C774 FALSE\B97C \BC18\D658\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.<br>'),
unistr('\CC38\ACE0: \D568\C218\C5D0\C11C \BC18\D658\B418\B294 \ACB0\ACFC\B294 \BD80\C6B8\C774\C5B4\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105782695199310095)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38(\C624\B958 \D14D\C2A4\D2B8 \BC18\D658)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105782775478310095)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D568\C218 \BCF8\BB38\C774 \BE48 \BB38\C790\C5F4\C744 \BC18\D658\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D568\C218 \BCF8\BB38\C774 \BE44\C5B4 \C788\C9C0 \C54A\C740 \BB38\C790\C5F4\C744 \BC18\D658\D558\BA74 \C2E4\D328\D569\B2C8\B2E4. \BC18\D658\B41C \BB38\C790\C5F4\C740 \AC80\C99D\C5D0 \B300\D55C \C624\B958 \BA54\C2DC\C9C0\B85C \D45C\C2DC\B429\B2C8\B2E4.<br>'),
unistr('\CC38\ACE0: \D568\C218\C5D0\C11C \BC18\D658\B418\B294 \ACB0\ACFC\B294 \D14D\C2A4\D2B8 \BB38\C790\C5F4\C774\C5B4\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105783418672310095)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \ACF5\BC31\C744 \D3EC\D568\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105783572820310096)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 \ACF5\BC31\C744 \D3EC\D568\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C774 \ACF5\BC31\C744 \D3EC\D568\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105785416409310097)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \AC12\C5D0 \C788\B294 \BB38\C790 \C911 \D558\B098 \C774\C0C1\C744 \D3EC\D568\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105785569458310097)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C758 \BB38\C790\B97C \D558\B098 \C774\C0C1 \D3EC\D568\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C758 \BB38\C790\B97C \D3EC\D568\D558\C9C0 \C54A\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105785673638310097)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \AC12\C5D0 \C788\B294 \BB38\C790\B97C \D3EC\D568\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105785790597310097)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C758 \BB38\C790\B97C \D3EC\D568\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C758 \BB38\C790\B97C \D558\B098 \C774\C0C1 \D3EC\D568\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105785229822310097)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \AC12\C5D0 \C9C0\C815\B41C \BB38\C790\B9CC \D3EC\D568\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105785358873310097)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C788\B294 \BB38\C790\B9CC \D3EC\D568\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C788\C9C0 \C54A\B294 \BB38\C790\B97C \D3EC\D568\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105784447395310096)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105784599853310096)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105784851607310097)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105784934947310097)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C644\C804\D788 \D3EC\D568\B418\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C644\C804\D788 \D3EC\D568\B418\C9C0 \C54A\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105784655434310096)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105784706748310096)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105785073135310097)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105785133569310097)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C644\C804\D788 \D3EC\D568\B418\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C644\C804\D788 \D3EC\D568\B418\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105783606750310096)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \C601\C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105783705717310096)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 \BB38\C790 \BC0F \C22B\C790\B9CC \D3EC\D568\D558\ACE0 \D2B9\C218 \BB38\C790\B97C \D3EC\D568\D558\C9C0 \C54A\B294 \C601\C22B\C790\C774\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C5D0 \D2B9\C218 \BB38\C790\AC00 \D3EC\D568\B418\C5B4 \C788\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105784008854310096)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \C801\D569\D55C \B0A0\C9DC\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105784132044310096)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 \C801\D569\D55C \B0A0\C9DC\C774\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C774 \C801\D569\D55C \B0A0\C9DC\AC00 \C544\B2C8\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105783817125310096)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105783903128310096)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 \C22B\C790\C774\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C5D0 \ACF5\BC31(\C120\D589 \ACF5\BC31\C740 \C81C\C678)\C744 \BE44\B86F\D558\C5EC \C22B\C790\AC00 \C544\B2CC \BB38\C790\AC00 \D3EC\D568\B418\C5B4 \C788\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105784276959310096)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \C801\D569\D55C \C2DC\AC04\AE30\B85D\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105784337648310096)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 \C801\D569\D55C \C2DC\AC04\AE30\B85D\C774\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C774 \C801\D569\D55C \C2DC\AC04\AE30\B85D\C774 \C544\B2C8\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105782871404310095)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105782977595310095)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 \BE44\C5B4 \C788\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C774 \BE44\C5B4 \C788\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105783088047310095)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \B110\C774 \C544\B2C8\AC70\B098 0\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105783150097310095)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 \BE44\C5B4 \C788\C9C0 \C54A\ACE0 \C22B\C790 0\C774 \C544\B2C8\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C774 \BE44\C5B4 \C788\AC70\B098 \C22B\C790 0\C774\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105783294142310095)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 0\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105783330134310095)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 \C22B\C790 0\C774 \C544\B2C8\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \AC12\C774 \C22B\C790 0\C774\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105782098382310094)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \BC18\D658\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105782189730310094)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL \C9C8\C758\AC00 \D589\C744 \BC18\D658\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('SQL \C9C8\C758\AC00 \D589\C744 \D558\B098 \C774\C0C1 \BC18\D658\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105782224675310095)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105782360721310095)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('PL/SQL \CF54\B4DC\AC00 \C2E4\D589\B420 \B54C \C624\B958\AC00 \BC1C\C0DD\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('PL/SQL \D45C\D604\C2DD\C774 \C2E4\D589\B420 \B54C \C624\B958\AC00 \BC1C\C0DD\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105785891872310097)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \C815\ADDC \D45C\D604\C2DD\ACFC \C77C\CE58\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105785918018310097)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C815\ADDC \D45C\D604\C2DD\ACFC \C77C\CE58\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.'),
unistr('\C5F4 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C815\ADDC \D45C\D604\C2DD\ACFC \C77C\CE58\D558\C9C0 \C54A\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.<br>'),
unistr('\CC38\ACE0: \C815\ADDC \D45C\D604\C2DD\C744 \C0AC\C6A9\D558\BA74 \B2E8\C21C \BB38\C790 \BE44\AD50 \B300\C2E0 \D45C\C900\D654\B41C \AD6C\BB38 \ADDC\C57D\C744 \C0AC\C6A9\D574\C11C \BB38\C790\C5F4 \B370\C774\D130\C5D0\C11C \D328\D134\C744 \AC80\C0C9\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105681085043310013)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105681704355310014)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C5D0 \B300\D55C \B300\C18C\BB38\C790 \AD6C\BD84 \C5F4 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \C5F4 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105681607583310013)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105991181878310262)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D45C\D604\C2DD\C744 \D3C9\AC00\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105991529863310263)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105991460256310263)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105991302848310262)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105991678512310263)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105991260132310262)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ko'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105991054219310262)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105993148288310264)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105993471677310264)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105993325568310264)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105993265375310264)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105993572625310264)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105993051492310264)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105989515457310261)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105989865258310261)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105989777031310261)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105989659827310261)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105989979227310261)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105989458559310261)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105992720857310264)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C744 \C815\C758\D558\AE30 \C704\D55C Java \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105992625971310264)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105994338223310265)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C BOOLEAN \AC12\C744 \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105994233413310265)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105990751843310262)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C \C624\B958 \BA54\C2DC\C9C0 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105990662206310262)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105992580466310264)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105992465699310263)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C744 \C815\C758\D558\AE30 \C704\D55C JavaScript \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105992368771310263)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105994192198310265)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105994044433310265)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C BOOLEAN \AC12\C744 \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105993942299310265)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105990523212310262)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C9C0\C815\B41C \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105990493137310262)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C \C624\B958 \BA54\C2DC\C9C0 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105990330769310262)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106105614475310370)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C9C0\C815\B41C \C624\B958\B97C \BC1C\C0DD\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105681501017310013)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C \C624\B958\B97C \C77C\C73C\D0A4\B294 PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105681407306310013)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \CF54\B4DC \BC1C\C0DD \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105992201395310263)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105992180716310263)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C744 \C815\C758\D558\AE30 \C704\D55C PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105992036944310263)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105993873415310265)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105993724555310265)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105993610073310265)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105990204194310261)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C9C0\C815\B41C \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105990109660310261)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C \C624\B958 \BA54\C2DC\C9C0 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105990079508310261)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D14D\C2A4\D2B8 \BC18\D658 PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105992951275310264)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C744 \C815\C758\D558\AE30 \C704\D55C Python \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105992850332310264)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105994582208310265)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C BOOLEAN \AC12\C744 \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105994480530310265)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105990913586310262)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C \C624\B958 \BA54\C2DC\C9C0 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105990894646310262)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105682116391310014)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C5D0 \C9C0\C815\B41C \C5F4\ACFC \C77C\CE58\C2DC\D0A4\B294 \B370 \C0AC\C6A9\B418\B294 \C815\ADDC \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105682052065310014)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\ADDC \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105991932759310263)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \AD00\B9AC\C790\C774\AC70\B098 \BD80\C11C\AC00 \C2DC\CE74\ACE0\C5D0 \C788\C744 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105991896569310263)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C744 \C815\C758\D558\AE30 \C704\D55C SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105991756849310263)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106105584289310370)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt><strong>\D589\C774 \BC18\D658\B428</strong>\C758 \ACBD\C6B0 \C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt><strong>\D589\C774 \BC18\D658\B418\C9C0 \C54A\C74C</strong>\C758 \ACBD\C6B0 \C9C1\C6D0\C774 \BD80\C11C 40\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105681337092310013)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C744 \C815\C758\D558\AE30 \C704\D55C SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105681279975310013)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105681989853310014)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C5D0 \C9C0\C815\B41C \C5F4\C758 \AC12\C5D0 \B300\D574 \BE44\AD50\D558\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105681820274310014)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105695552250310025)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106036140357310305)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D574 \C815\C758\B41C \C124\C815\C744 \C0C1\C18D\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105695446924310025)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C18D\C131\C744 \C0AC\C6A9\D558\C5EC &PRODUCT_NAME.\C5D0\C11C \C138\C158 ID\AC00 \D3EC\D568\B418\C9C0 \C54A\B294 \C560\D50C\B9AC\CF00\C774\C158 URL\C744 \C9C0\C6D0\D560\C9C0 \C5EC\BD80\B97C \C81C\C5B4\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C7AC\C870\C778 \C138\C158\C774 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0, &PRODUCT_NAME.\C740(\B294) URL\C5D0 \C138\C158 ID\AC00 \D3EC\D568\B418\C9C0 \C54A\C558\C744 \B54C \AE30\C874 \C138\C158\C5D0 \C870\C778\D558\AE30 \C704\D574 \C138\C158 \CFE0\D0A4\B97C \C0AC\C6A9\D558\B824\ACE0 \C2DC\B3C4\D569\B2C8\B2E4.'),
'</p>',
unistr('<p>\BCF4\B2E4 \C81C\D55C\C801\C778 \C778\C2A4\D134\C2A4 \B808\BCA8 \C124\C815\C740 \C774 \D398\C774\C9C0 \B808\BCA8 \AC12\C744 \BB34\D6A8\D654\D569\B2C8\B2E4.'),
'</p>',
unistr('<p><em><strong>\CC38\ACE0:</em></strong> \C7AC\C870\C778 \C138\C158\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D558\BA74 \ACF5\ACA9\C790\AC00 \AE30\C874 \C77C\BC18 \C0AC\C6A9\C790 \C138\C158\C744 \D68D\B4DD\D560 \C218 \C788\C73C\BBC0\B85C,'),
unistr('\C560\D50C\B9AC\CF00\C774\C158\C774 \BCF4\C548 \ACF5\ACA9\C5D0 \B178\CD9C\B420 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C790\C138\D55C \B0B4\C6A9\C740 App Builder User''s Guide\C758 "Managing Application Security"\C5D0\C11C <em>Rejoin Sessions</em> \C139\C158\C744 \CC38\C870\D558\C2ED\C2DC\C624.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105777078517310091)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105777173294310091)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('URL\C5D0 \C138\C158 ID\AC00 \D3EC\D568\B418\C9C0 \C54A\C740 \ACBD\C6B0 &PRODUCT_NAME.\C740(\B294) \C0C8 \C138\C158\C744 \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105777298363310091)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9 \C138\C158\C5D0 \C0AC\C6A9\C73C\B85C \C124\C815\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105777319756310091)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('URL\C774 \ACF5\C6A9 \D398\C774\C9C0\B85C \C774\B3D9\D558\ACE0 \C138\C158 ID\B97C \D3EC\D568\D558\ACE0 \C788\C9C0 \C54A\C740 \ACBD\C6B0  &PRODUCT_NAME.\C740(\B294) \D574\B2F9 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D574 \C124\C815\B41C \AE30\C874 \C138\C158 \CFE0\D0A4\B97C \C0AC\C6A9\D558\B824\ACE0 \C2DC\B3C4\D569\B2C8\B2E4.'),
unistr('\ACF5\C6A9 \D398\C774\C9C0\C640 \C778\C99D\B41C \D398\C774\C9C0\B97C \BAA8\B450 \D3EC\D568\D558\B294 \C560\D50C\B9AC\CF00\C774\C158\C758 \ACBD\C6B0 \C138\C158 ID\B294 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C778\C99D\D55C \D6C4 \C815\C758\B429\B2C8\B2E4.'),
unistr('&PRODUCT_NAME.\C740(\B294) \C138\C158\C774 \C544\C9C1 \C778\C99D\B418\C9C0 \C54A\C740 \ACBD\C6B0\C5D0\B9CC \CFE0\D0A4\B97C \C0AC\C6A9\D558\C5EC \C870\C778\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105777406500310091)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C138\C158\C5D0 \B300\D574 \C0AC\C6A9\C73C\B85C \C124\C815\B428')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105777591884310091)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>URL\C5D0 \C138\C158 ID\AC00 \D3EC\D568\B418\C9C0 \C54A\C740 \ACBD\C6B0 \B2E4\C74C \C870\AC74\C774 \CDA9\C871\B418\BA74 &PRODUCT_NAME.\C740(\B294) \D574\B2F9 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D574 \C124\C815\B41C \AE30\C874 \C138\C158 \CFE0\D0A4\B97C \C0AC\C6A9\D558\B824\ACE0 \C2DC\B3C4\D569\B2C8\B2E4.</p>'),
'<p><ul>',
unistr('  <li>\C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D574 \C138\C158 \C0C1\D0DC \BCF4\D638\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B418\ACE0 URL\C5D0 \C801\D569\D55C \CCB4\D06C\C12C\C774 \D3EC\D568\B41C \ACBD\C6B0.'),
unistr('   \ACF5\C6A9 \CC45\AC08\D53C\C758 \ACBD\C6B0 \AC00\C7A5 \C81C\D55C\C801\C778 \D56D\BAA9 \B808\BCA8 \BCF4\D638\B294 <em>\C81C\D55C \C5C6\C74C</em> \B610\B294 <em>\CCB4\D06C\C12C \D544\C694 - \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8</em>\C785\B2C8\B2E4.</li>'),
unistr('  <li>\B610\B294 URL\C774 \D398\C774\B85C\B4DC(\C694\CCAD \B9E4\AC1C\BCC0\C218, \CE90\C2DC \BE44\C6B0\AE30 \B610\B294 \B370\C774\D130 \AC12 \C30D)\B97C \D3EC\D568\D558\C9C0 \C54A\B294 \ACBD\C6B0</li>'),
'</ul></p>',
unistr('<p>\C774 \C124\C815\C744 \C0AC\C6A9\D558\B824\BA74 \D574\B2F9 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D574 <em>\D504\B808\C784\C5D0 \B0B4\C7A5</em>\C774 <em>\B3D9\C77C \CD9C\CC98\C5D0\C11C \D5C8\C6A9</em> \B610\B294 <em>\AC70\BD80</em>\B85C \C124\C815\B418\C5B4 \C788\C5B4\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105695343629310025)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C7AC\C870\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105623492885309961)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\CD9C \D6C4 \D398\C774\C9C0\AC00 \B2E4\C2DC \B85C\B4DC\B418\C5B4\C57C \D560 \B54C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105623549547309961)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105623666697309962)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\C0C1 \D398\C774\C9C0\B97C \B2E4\C2DC \B85C\B4DC\D558\C5EC \C624\B958 \BC0F \C131\ACF5 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105623744868309962)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5 \C2DC\C5D0\B9CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105623839125309962)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B2E4\C2DC \B85C\B4DC \C5C6\C774 \C624\B958\B97C \B3D9\C801\C73C\B85C \D45C\C2DC\D558\C9C0\B9CC, \C131\ACF5\C801\C778 \CC98\B9AC \D6C4\C5D0\B294 \B2E4\C2DC \B85C\B4DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105623330580309961)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C \C2DC \B2E4\C2DC \B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106004891756310275)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106004986514310275)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\AC00 \CE90\C2DC\C5D0 \C800\C7A5\B418\C9C0 \C54A\C73C\BBC0\B85C \B9E4\BC88 \C694\CCAD\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105877562273310166)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105877661370310167)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\AC00 \CE90\C2DC\C5D0 \C800\C7A5\B418\C9C0 \C54A\C73C\BBC0\B85C \B9E4\BC88 \C694\CCAD\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105314964490309709)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105315079589309709)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACB0\ACFC\AC00 \CE90\C2DC\C5D0 \C800\C7A5\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \AC01 \C694\CCAD\C5D0 \B300\D574 \C6D0\ACA9 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \B370\C774\D130\AC00 \C778\CD9C\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105313123587309707)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('&PRODUCT_NAME. \C5D4\C9C4\C774 \B85C\CEEC \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \B370\C774\D130\B97C \CE90\C2DC\C5D0 \C800\C7A5\D560 \C218 \C788\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('        \CE90\C2F1\C744 \C0AC\C6A9\D560 \C218 \C788\C744 \ACBD\C6B0 \C6D0\ACA9 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \C778\CD9C\D558\B294 \B300\C2E0 \CE90\C2DC\C5D0 \C800\C7A5\B41C \ACB0\ACFC\B97C \AE30\BC18\C73C\B85C \AD6C\C131\C694\C18C\AC00 \B80C\B354\B9C1\B429\B2C8\B2E4.'),
unistr('        \CE90\C2DC\C5D0 \C800\C7A5\B41C \ACB0\ACFC\B97C \C0AC\C6A9\D558\BA74 \C131\B2A5\C774 \D06C\AC8C \D5A5\C0C1\B429\B2C8\B2E4. \B85C\CEEC \B370\C774\D130\BCA0\C774\C2A4\C640 \C6D0\ACA9 \B370\C774\D130\BCA0\C774\C2A4 \AC04\C5D0 \B300\AE30 \C2DC\AC04\C774 \C788\C744 \ACBD\C6B0 \D2B9\D788 \ADF8\B807\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105313260594309707)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C0AC\C6A9\C790\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105313354194309707)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACB0\ACFC\AC00 \CE90\C2DC\C5D0 \C800\C7A5\B418\C5B4 \BAA8\B4E0 \C0AC\C6A9\C790\C5D0 \C758\D574 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105313615658309708)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158\BCC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105313780445309708)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACB0\ACFC\AC00 \C0AC\C6A9\C790 \C138\C158\BCC4\B85C \CE90\C2DC\C5D0 \C800\C7A5\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105313430027309707)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\BCC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105313501976309707)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACB0\ACFC\AC00 \C138\C158 \C804\CCB4\C5D0\C11C \C0AC\C6A9\C790\BCC4\B85C \CE90\C2DC\C5D0 \C800\C7A5\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105313033553309707)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE90\C2F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105314095183309708)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\CE90\C2DC\C5D0 \C800\C7A5\B418\ACE0 15\BD84 \D6C4 \B370\C774\D130\B97C \B9CC\B8CC\D569\B2C8\B2E4.</dt>'),
'  <dd><pre>15</pre></dd>',
unistr('<dt>\B9E4 \C815\C2DC\C5D0 \B370\C774\D130\B97C \B9CC\B8CC\D569\B2C8\B2E4.</dt>'),
'  <dd><pre>FREQ=HOURLY;BYMINUTE=0;BYSECOND=0</pre></dd>',
unistr('<dt>\C790\C815\C5D0 \B370\C774\D130\B97C \B9CC\B8CC\D569\B2C8\B2E4.</dt>'),
'  <dd><pre>FREQ=DAILY;BYHOUR=0;BYMINUTE=0;BYSECOND=0</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105313987648309708)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CE90\C2DC\C5D0 \C800\C7A5\B41C \B370\C774\D130\AC00 \BB34\D6A8\D654\B420 \C2DC\AE30\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('        \C2DC\AC04(\BD84) \B610\B294 DBMS_SCHEDULER \B2EC\B825 \BB38\C790\C5F4\C744 \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('        <p>DBMS_SCHEDULER \B2EC\B825 \BB38\C790\C5F4\C758 \ACBD\C6B0 \CE90\C2DC\C5D0 \C800\C7A5\B41C \B370\C774\D130\AC00 \B9E4 \C815\C2DC, \C790\C815 \B610\B294 \B2E4\B978 \D2B9\C815 \BC18\BCF5 \C2DC\C810\C5D0 \BB34\D6A8\D654\B418\B3C4\B85D \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('        \C790\C138\D55C \B0B4\C6A9\C740 DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING\C5D0 \B300\D55C \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105313863011309708)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE90\C2DC \C2DC\AC04 \CD08\ACFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105551039151309903)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \B300\D654\C2DD \BCF4\ACE0\C11C \C601\C5ED\C5D0 \B300\D55C \C601\C22B\C790 \BCC4\CE6D\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\BCC4\CE6D\C740 \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0\C11C \ACE0\C720\D574\C57C \D569\B2C8\B2E4.'),
unistr('\BCC4\CE6D\C744 \C0AC\C6A9\D558\BA74 \C0AC\C6A9\C790\C815\C758 API \D638\CD9C\C5D0\C11C \B300\D654\C2DD \BCF4\ACE0\C11C \C601\C5ED\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, <code>APEX_APPLICATION_PAGE_IR</code> \BCF4\AE30\C5D0\C11C <code>ALIAS</code> \C5F4\C744 \C9C8\C758\D558\C5EC <code>INTERACTIVE_REPORT_ID</code>\B97C \BC18\D658\D558\B294 \D568\C218\B97C \C791\C131\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C560\D50C\B9AC\CF00\C774\C158\C744 \C775\C2A4\D3EC\D2B8\D558\ACE0 \B2E4\B978 \C778\C2A4\D134\C2A4\B85C \C784\D3EC\D2B8\D560 \B54C <code>INTERACTIVE_REPORT_ID</code> \AC12\C774 \BCC0\ACBD\B420 \C218 \C788\C73C\BBC0\B85C, \BCC4\CE6D\C744 \C0AC\C6A9\D55C \B300\D654\C2DD \BCF4\ACE0\C11C \C601\C5ED \CC38\C870\AC00 \C120\D638\B420 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105550930407309903)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105544569800309898)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\AC12 \BAA9\B85D \B0A0\C9DC \C81C\D55C\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\B0A0\C9DC \C5F4\C758 \ACBD\C6B0 \BCF4\ACE0\C11C \C5F4 \B4DC\B86D\B2E4\C6B4 \BAA9\B85D\C5D0 \B300\D55C \D544\D130\B97C \C0AC\C6A9\D574\C11C \AC12 \BAA9\B85D\C5D0 \ACFC\AC70 \C2DC\AC04, \BBF8\B798 \C2DC\AC04 \B610\B294 \B458 \B2E4\B97C \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105747784156310069)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.ALL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105747983290310069)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.FUTURE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\B798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105747821182310069)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.PAST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACFC\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105544479464309898)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C790 \BC94\C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105551279282309903)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B41C \BCF4\ACE0\C11C ID\B97C \C800\C7A5\D558\B294 \AC12\C744 \AC00\C9C4 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4. \B300\D654\C2DD \BCF4\ACE0\C11C\B294 \C774 \D56D\BAA9 \AC12\C744 \C0AC\C6A9\D558\C5EC \C800\C7A5\B41C \BCF4\ACE0\C11C\C5D0 \B9C1\D06C\D569\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \C815\C758\B41C \D56D\BAA9 \C774\B984 \BC0F \C800\C7A5\B41C \BCF4\ACE0\C11C ID\B97C \D574\B2F9 \AC12\C73C\B85C \AC00\C9C0\B294 \B9C1\D06C\C640 \D568\AED8 \C800\C7A5\B41C \BCF4\ACE0\C11C \BAA9\B85D\C744 \C815\C758\D558\C5EC \C800\C7A5\B41C \AE30\BCF8 \BCF4\ACE0\C11C, \ACF5\C6A9 \B610\B294 \C804\C6A9 \BCF4\ACE0\C11C\C5D0 \B9C1\D06C\D560 \C218 \C788\C2B5\B2C8\B2E4. \C800\C7A5\B41C \BCF4\ACE0\C11C ID\B294 <code>APEX_APPLICATION_PAGE_IR_RPT</code> \BDF0\C5D0\C11C \C81C\AC70')
||unistr('\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105551123799309903)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C ID \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105692202370310023)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BCF4\ACE0\C11C \B808\C774\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105692803414310023)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BCF4\ACE0\C11C \B808\C774\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105691846467310022)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\B97C \C778\C1C4\D560 \B584 \C0AC\C6A9\D560 \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105691753630310022)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105582111192309928)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BCF4\ACE0\C11C\C758 \D45C\C2DC\B97C \C81C\C5B4\D558\AE30 \C704\D55C \BBF8\B9AC \C815\C758\B41C \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105761331335310079)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.D'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML(\D45C\C900)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105761408611310079)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 HTML \D14C\C774\BE14\C744 \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105761511699310079)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\B85C\D615 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105761621550310079)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\B3C4\C758 \D589\C5D0 \AC01 \C5F4\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105761760446310079)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.D'
,p_message_language=>'ko'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105761822800310079)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\B97C CSV \D30C\C77C\B85C \C775\C2A4\D3EC\D2B8\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105761935292310079)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.D'
,p_message_language=>'ko'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105762075340310079)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\B97C XML \D30C\C77C\B85C \C775\C2A4\D3EC\D2B8\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105582098449309928)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105584343326309929)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D569\ACC4 \AC12\ACFC \C778\C811\D558\C5EC \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105584294558309929)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D569\ACC4 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105577681341309924)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D074\B798\C2DD \BCF4\ACE0\C11C\C758 \BAA8\C591\ACFC \B808\C774\C544\C6C3\C744 \C815\C758\D560 \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('        <p>\BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\B294 \C560\D50C\B9AC\CF00\C774\C158 \D14C\B9C8\C5D0\C11C \C815\C758\B429\B2C8\B2E4.'),
unistr('        \D074\B798\C2DD \BCF4\ACE0\C11C\AC00 \C0DD\C131\B418\BA74 \D15C\D50C\B9AC\D2B8\B294 \D604\C7AC \D14C\B9C8\C5D0 \C815\C758\B41C \AE30\BCF8 \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\B85C \C790\B3D9\C73C\B85C \C124\C815\B429\B2C8\B2E4.</p>'),
unistr('        <p>\B300\BD80\BD84\C758 \D14C\B9C8\C5D0\B294 \D14C\C774\BE14, \D0A4 \AC12 \C30D, \AC80\C0C9 \ACB0\ACFC, \CE74\B4DC \B4F1\C744 \D45C\C2DC\D558\AE30 \C704\D55C \D074\B798\C2DD \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.'),
unistr('        \C77C\BD80 \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8(\C608: \CE74\B4DC \BC0F \AC80\C0C9 \ACB0\ACFC)\B294 "\D589 \AE30\BC18"\C774\BA70 SQL \C9C8\C758\AC00 \D15C\D50C\B9AC\D2B8\C5D0\C11C \B300\CCB4\B420 \D2B9\C815 \C5F4 \BCC4\CE6D \C138\D2B8\B97C \BC18\D658\D560 \AC83\C73C\B85C \AE30\B300\D569\B2C8\B2E4.<br>'),
unistr('        \BC94\C6A9 \D14C\B9C8\B294 \B2E4\C74C\ACFC \AC19\C740 \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\B97C \C81C\ACF5\D569\B2C8\B2E4.'),
'          <dl>',
unistr('            <dt>\ACBD\BCF4</dt>'),
unistr('              <dd>\D398\C774\C9C0\C5D0 \AC00\B85C \ACBD\BCF4 \B610\B294 \C54C\B9BC\C744 \D45C\C2DC\D569\B2C8\B2E4.</dd>'),
unistr('            <dt>\BC30\C9C0 \BAA9\B85D</dt>'),
unistr('              <dd>\B300\C2DC\BCF4\B4DC\C640 \C720\C0AC\D55C \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\C5D0 \D0A4 \AC12 \C30D\C744 \D45C\C2DC\D569\B2C8\B2E4.</dd>'),
unistr('            <dt>\CE74\B4DC</dt>'),
unistr('              <dd>\CE74\B4DC \B610\B294 \C791\C740 \BE14\B85D\C5D0 \BCF4\ACE0\C11C \B370\C774\D130\B97C \D45C\C2DC\D558\BA70 \B2E4\C591\D55C \C815\BCF4\B97C \B098\D0C0\B0B4\B294 \B370 \C720\C6A9\D569\B2C8\B2E4. \D15C\D50C\B9AC\D2B8 \C635\C158\C744 \D1B5\D574 \CE74\B4DC\B97C \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.</dd>'),
unistr('            <dt>\C124\BA85</dt>'),
unistr('              <dd>\C124\BA85 \BC0F \AE30\D0C0 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D569\B2C8\B2E4.</dd>'),
unistr('            <dt>\AC80\C0C9 \ACB0\ACFC</dt>'),
unistr('              <dd>\AC80\C0C9 \C5D4\C9C4 \C2A4\D0C0\C77C \AC80\C0C9 \ACB0\ACFC\B97C \D45C\C2DC\D569\B2C8\B2E4.</dd>'),
unistr('            <dt>\D45C\C900</dt>'),
unistr('              <dd>\D14C\C774\BE14\C5D0 \B370\C774\D130\B97C \D45C\C2DC\D558\AE30 \C704\D55C \AE30\BCF8 \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C774\BA70 \D15C\D50C\B9AC\D2B8 \C635\C158\C744 \D1B5\D574 \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.</dd>'),
unistr('            <dt>\D0C0\C784\B77C\C778</dt>'),
unistr('              <dd>\C791\C5C5 \D0C0\C784\B77C\C778\C744 \D45C\C2DC\D558\BA70, \CD5C\ADFC \C791\C5C5\C5D0 \B300\D55C \D65C\B3D9 \D53C\B4DC\AC00 \D544\C694\D55C \D648 \D398\C774\C9C0, \BCC0\ACBD \B85C\ADF8 \BC0F \AE30\D0C0 \C601\C5ED\C5D0 \C801\D569\D569\B2C8\B2E4.</dd>'),
unistr('            <dt>\AC12 \C18D\C131 \C30D - \C5F4</dt>'),
unistr('              <dd>\C5F4 \AE30\BC18 \C9C8\C758\C5D0 \B300\D55C \D0A4-\AC12 \C30D\C744 \D45C\C2DC\D558\BA70, \C5F4 \BA38\B9AC\AE00\C744 \AC01 \D56D\BAA9\C5D0 \B300\D55C \B808\C774\BE14\B85C \C0AC\C6A9\D569\B2C8\B2E4.</dd>'),
unistr('            <dt>\AC12 \C18D\C131 \C30D - \D589</dt>'),
unistr('              <dd>\D589 \AE30\BC18 \C9C8\C758\C5D0 \B300\D55C \D0A4-\AC12 \C30D\C744 \D45C\C2DC\D558\BA70, \B808\C774\BE14\C5D0 \B300\D574 \CCAB\BC88\C9F8 \C5F4\C744 \C0AC\C6A9\D558\ACE0 \AC12\C5D0 \B300\D574 \B450\BC88\C9F8 \B808\C774\BE14\C744 \C0AC\C6A9\D569\B2C8\B2E4.</dd>'),
'          </dl>',
unistr('          \CC38\ACE0: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\BC94\C6A9 \D14C\B9C8 \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105577512255309924)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105439489924309810)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C801\C5B4\B3C4 \D558\B098\C758 \D544\D130\AC00 \BCF4\ACE0\C11C \C5F4 \C911 \D558\B098\C5D0\C11C \C815\C758\B418\C9C0 \C54A\C73C\BA74 \B300\D654\C2DD \ADF8\B9AC\B4DC\AC00 \B370\C774\D130\B97C \D45C\C2DC\D558\C9C0 \C54A\B3C4\B85D \D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('		\C774 \C635\C158\C740 \D544\D130\B97C \AE30\C900\C73C\B85C \BC18\D658\B418\B294 \D589\C744 \C81C\D55C\D568\C73C\B85C\C368 \B9E4\C6B0 \D070 \B370\C774\D130\C138\D2B8\C5D0\C11C \B85C\B4DC\B418\B294 \B370\C774\D130\B97C \C81C\D55C\D558\AE30 \C704\D574 \ACE0\C548\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('		<p>\AC1C\BCC4 \C5F4\C5D0\B294 <strong>\C5F4 \D544\D130 \D544\C694</strong>\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B418\C5B4 \D574\B2F9 \C5F4\C5D0 \B300\D574 \D544\D130\AC00 \D544\C694\D558\B3C4\B85D \D560 \C218 \C788\C9C0\B9CC, \C774 \C635\C158\C740 \BAA8\B4E0 \C5F4\C5D0\C11C \D558\B098\C758 \D544\D130\B9CC \C694\AD6C\D569\B2C8\B2E4.</p>'),
unistr('		<p>\CC38\ACE0 - \C774 \C635\C158\C774 \C124\C815\B418\ACE0 \D604\C7AC \C815\C758\B41C \D544\D130\AC00 \C5C6\B294 \ACBD\C6B0 \C0AC\C6A9\C790\C5D0\AC8C \D544\D130 \C785\B825\C744 \C694\AD6C\D558\B294 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105439386594309810)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \D544\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105595574079309938)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \BB38\C790\B97C \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105238369157309650)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\D560 \C218 \C788\B294 \BB38\C790\B97C \C81C\D55C\D558\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C0AC\C6A9\C790\AC00 \C120\D0DD\D55C \BB38\C790 \C81C\D55C\C744 \B530\B974\C9C0 \C54A\B294 \B370\C774\D130\B97C \C800\C7A5\D558\B824\ACE0 \C2DC\B3C4\D558\BA74 &PRODUCT_NAME.\C774(\AC00) \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D569\B2C8\B2E4.</p>'),
unistr('<p>\BB38\C790\B97C \C81C\D55C\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158 \BCF4\C548\C774 \AC15\D654\B418\BA70 XSS(\C0AC\C774\D2B8\AC04 \C2A4\D06C\B9BD\D305) \ACF5\ACA9\C744 \BC29\C9C0\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105736611125310060)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('&<>"/;,*|=% \BC0F -- \CC28\B2E8 \BAA9\B85D\C5D0 \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105736700069310060)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('&amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, % \BC0F "--"(PL/SQL \C8FC\C11D) \BB38\C790\B294 \C800\C7A5\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105736834468310060)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('&<>"/;,*|=% \B610\B294 -- \BC0F \C0C8 \D589 \CC28\B2E8 \BAA9\B85D\C5D0 \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105736922421310061)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('&amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, %, "--" \BC0F \C904 \BC14\AFC8 \BB38\C790\B294 \C800\C7A5\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105736233125310060)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('a-Z, 0-9 \BC0F \ACF5\BC31 \D5C8\C6A9 \BAA9\B85D\C5D0 \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105736316930310060)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('a-z, A-Z, 0-9 \BB38\C790 \BC0F \ACF5\BC31\B9CC \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105736429582310060)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \BA85\B839 \BB38\C790(<>") \CC28\B2E8 \BAA9\B85D\C5D0 \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105736525675310060)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608\C57D\B41C HTML \BB38\C790\B294 \C800\C7A5\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105737058557310061)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WORKSPACE_SCHEMA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C2A4\D0A4\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105238256700309650)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\D55C\B41C \BB38\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106002470768310273)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1\B41C \CF58\D150\CE20\C758 \C785\B825 \D615\C2DD\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106002521949310273)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.D'
,p_message_language=>'ko'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106002657657310273)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20\AC00 HTML \D0DC\ADF8\B97C \D3EC\D568\D558\ACE0 \C788\C73C\BA70 \D2B9\C218 \BB38\C790 \C774\C2A4\CF00\C774\D504\B97C \C801\C6A9\D558\C9C0 \C54A\ACE0 \B80C\B354\B9C1\B429\B2C8\B2E4. XSS(\C0AC\C774\D2B8 \AC04 \C2A4\D06C\B9BD\D305) \CDE8\C57D\C810\C744 \BC29\C9C0\D558\AE30 \C704\D574 \B370\C774\D130\AC00 \C548\C804\D558\ACE0 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C785\B825\D55C \B370\C774\D130\AC00 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C740\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106002744741310273)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\D06C\B2E4\C6B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106002875070310273)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20\AC00 \B9C8\D06C\B2E4\C6B4 \D0DC\ADF8\B97C \D3EC\D568\D558\ACE0 \C788\C73C\BA70 \B80C\B354\B9C1 \C804\C5D0 \C548\C804\D55C HTML \D0DC\ADF8\B85C \BC88\C5ED\B429\B2C8\B2E4. \C798 \C54C\B824\C9C4 \B9C8\D06C\B2E4\C6B4 \D0DC\ADF8\C758 \BC88\C5ED\C740 XSS(\C0AC\C774\D2B8 \AC04 \C2A4\D06C\B9BD\D305) \CDE8\C57D\C810\C744 <strong>\BC29\C9C0</strong>\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106002350068310273)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105438688078309809)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \C911\C778 \D14C\C774\BE14\C5D0 \B300\D55C \D589 \BC84\C804 \BC88\D638\B97C \C800\C7A5\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C5F4\C740 \C190\C2E4\B41C \C5C5\B370\C774\D2B8 \D655\C778\C5D0\C11C \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105438517099309809)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BC84\C804 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105562232628309912)
,p_name=>'PE.PROPERTY.RUN_PROCESS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D504\B85C\C138\C2A4\AC00 \C2E4\D589\B418\B294 \BE48\B3C4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105752385918310072)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC29\BB38\B2F9 \D55C \BC88\C529(\AE30\BCF8\AC12)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105752214847310072)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.Y.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158\B2F9 \B610\B294 \C7AC\C124\C815 \C2DC \D55C \BC88\C529')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105562196539309912)
,p_name=>'PE.PROPERTY.RUN_PROCESS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105548015547309901)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\ACF5\C6A9 \BCF4\ACE0\C11C \C815\C758\B97C \C800\C7A5\D560 \C218 \C788\B294 \C0AC\C6A9\C790\B97C \C81C\D55C\D558\AE30 \C704\D55C \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \ACF5\C6A9 \BCF4\ACE0\C11C\B97C \C800\C7A5\D560 \C218 \C788\B3C4\B85D \D558\B824\BA74 \C774 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 TRUE\B85C \D3C9\AC00\B418\C5B4\C57C \D569\B2C8\B2E4.'),
unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \C81C\ACF5\B418\C9C0 \C54A\C73C\BA74 \C544\BB34 \C0AC\C6A9\C790\B098 \BCF4\ACE0\C11C\B97C \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105547909992309901)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9 \BCF4\ACE0\C11C \C800\C7A5 \AD8C\D55C \BD80\C5EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105320470122309713)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\BD84\AE30\AC00 \C2E4\D589\B418\AE30 \C804\C5D0 \C138\C158 \C0C1\D0DC\C758 \AC12\C774 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C800\C7A5\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C138\C158 \C0C1\D0DC \AC12\C5D0 \C561\C138\C2A4\D558\B294 \B370 \D544\C694\D55C \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \C774\B3D9\D558\B294 \ACBD\C6B0 \C774 \C18D\C131\C744 <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D558\B294 \AC83\C774 \C911\C694\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105320304795309713)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30 \C804 \C0C1\D0DC \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105307394514309702)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\D6A8\D654 \AD6C\BB38 \BD84\C11D \C2A4\D0A4\B9C8\B85C \C0AC\C6A9\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \B0B4\BD80 \C560\D50C\B9AC\CF00\C774\C158 \C804\C6A9\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105307273622309702)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8 \BB34\D6A8\D654 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105927275439310205)
,p_name=>'PE.PROPERTY.SCHEME_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105927185537310205)
,p_name=>'PE.PROPERTY.SCHEME_SQL_STATEMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105926485147310204)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \C801\C6A9\B420 \BC29\C2DD\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105926513458310204)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('Exists SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105926644939310204)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\AC00 \AC12\C744 \BC18\D658\D560 \B54C \AD8C\D55C \BD80\C5EC\AC00 \C804\B2EC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105926922074310204)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C6B8 \BC18\D658 PL/SQL \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105927051328310205)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105926701692310204)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('Not Exists SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105926878249310204)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\AC00 \AC12\C744 \BC18\D658\D558\C9C0 \C54A\C744 \B54C \AD8C\D55C \BD80\C5EC\AC00 \C804\B2EC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105926390892310204)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\ACC4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105548291873309901)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \B2E8\CD94 \B808\C774\BE14\C5D0 \B300\D55C \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105548160948309901)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \B2E8\CD94 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105909882697310192)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\AC00 \C5F4\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\B294\C9C0 \C544\B2C8\BA74 HTML \D45C\D604\C2DD \BC0F \C9C0\C6D0\B418\B294 \B300\CCB4 \BB38\C790\C5F4\C744 \D1B5\D55C \ACE0\AE09 \D615\C2DD \C9C0\C815\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\B294\C9C0 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105909720493310192)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09 \D615\C2DD \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105910080755310192)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C870 \BCF8\BB38\C73C\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105909959031310192)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105910582480310192)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105910460371310192)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105910316055310192)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\BC30\ACBD \BC0F \D14D\C2A4\D2B8 \C0C9\C0C1 \BCC0\ACBD</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\C81C\BAA9 2 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL \C9C8\C758\C5D0\C11C \B3D9\C801 \D074\B798\C2A4 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \C774 \C608\C5D0\C11C <code>&COLUMN_CLASS.</code> \BC0F <code>&EMPLOYEE_STATUS.</code> \B300\CCB4\B294 \BCF4\ACE0\C11C SQL \C9C8\C758\C5D0\C11C \C120\D0DD\B41C \C5F4\C785\B2C8\B2E4.</dd>'),
unistr('  <dt>\C774\BBF8\C9C0 \D45C\C2DC \BC0F \CEE4\C11C\B97C \C704\B85C \AC00\C838\AC08 \B54C \B3C4\AD6C \C124\BA85 \D45C\C2DC</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105910286072310192)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C5D0 \D45C\C2DC\D560 HTML \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4. <code>&COLUMN.</code> \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC HTML\C5D0 \C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105910156567310192)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105306124532309701)
,p_name=>'PE.PROPERTY.SECURE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D504\B85C\D1A0\CF5C\C774 HTTPS\C77C \ACBD\C6B0\C5D0\B9CC \C138\C158 \AD00\B9AC \CFE0\D0A4\B97C \BE0C\B77C\C6B0\C800\C5D0\C11C \C804\C1A1\D560 \C218 \C788\B3C4\B85D \D558\B824\BA74 <strong>\C124\C815</strong>\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\D504\B85C\D1A0\CF5C\C774 HTTP \B610\B294 HTTPS\C77C \B54C \C138\C158 \AD00\B9AC \CFE0\D0A4\B97C \BE0C\B77C\C6B0\C800\C5D0\C11C \C804\C1A1\D560 \C218 \C788\B3C4\B85D \D558\B824\BA74 <strong>\D574\C81C</strong>\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>SSL\C774 \C6F9 \C11C\BC84\C5D0 \AD6C\C131\B41C \ACBD\C6B0\C5D0\B294 \C554\D638\D654\B418\C9C0 \C54A\C740 HTTP \D2B8\B798\D53D\C744 \BC29\C9C0\D574\C11C \C560\D50C\B9AC\CF00\C774\C158\C758 \BCF4\C548\C744 \AC15\D654\D558\B3C4\B85D <strong>\C124\C815</strong>\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105306093118309701)
,p_name=>'PE.PROPERTY.SECURE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105462662285309830)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8 \D589\C774 \C790\B3D9\C73C\B85C \C120\D0DD\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105462533119309830)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8 \D589 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105602729015309944)
,p_name=>'PE.PROPERTY.SERIES_CHART_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\B9AC\C988 \CC28\D2B8 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105497204431309858)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \ACC4\C5F4 \B3D9\C801 \C9C8\C758\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\D560 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105497199076309858)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C5F4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105237763299309649)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC \BCF4\D638 \B808\BCA8\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105735414805310059)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\C12C \D544\C694 - \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105735534365310059)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C740 URL\C5D0\C11C \C791\C5C5\C601\C5ED \BC0F \C560\D50C\B9AC\CF00\C774\C158\C5D0 \D574\B2F9\D558\B294 \CCB4\D06C\C12C\C774 \D3EC\D568\B41C \D56D\BAA9\C744 \C804\B2EC\D558\C5EC \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105736005833310060)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\D55C\B428 - \BE0C\B77C\C6B0\C800\C5D0\C11C \C124\C815\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105736168531310060)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D56D\BAA9\C740 URL \B610\B294 POSTDATA\B97C \C0AC\C6A9\D574\C11C \BCC0\ACBD\D560 \C218 \C5C6\C2B5\B2C8\B2E4.'),
unistr('\D56D\BAA9 \AC12\C744 \B0B4\BD80 \D504\B85C\C138\C2A4, \ACC4\C0B0 \B4F1\C73C\B85C \C124\C815\D560 \C218 \C788\B294 \C8FC\CCB4\B97C \C81C\D55C\D558\B824\BA74 \C774 \C635\C158\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C774 \C18D\C131\C740 \B370\C774\D130 \C785\B825 \D56D\BAA9\C73C\B85C \C0AC\C6A9\B418\C9C0 \C54A\B294 \D56D\BAA9\C5D0\B9CC \C801\C6A9\B418\BA70 \C138\C158 \C0C1\D0DC \BCF4\D638\AC00 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B418\C5B4 \C788\B294 \ACBD\C6B0\C5D0\B3C4 \D56D\C0C1 \BCF4\C874\B429\B2C8\B2E4.'),
unistr('\B2E4\C74C <strong>\D45C\C2DC \D615\C2DD</strong> \C720\D615\C744 \D3EC\D568\D558\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C5D0 \B300\D574 \C774 \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4.'),
'<ul>',
unistr('  <li>\D45C\C2DC \C804\C6A9(\C800\C7A5 \C0C1\D0DC=No)</li>'),
unistr('  <li>\D14D\C2A4\D2B8 \D544\B4DC(\C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B428, \C0C1\D0DC\B97C \C800\C7A5\D558\C9C0 \C54A\C74C)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105735244148310059)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\D55C \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105735308318310059)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C740 URL \B610\B294 \D3FC\C5D0\C11C \D56D\BAA9\C744 \C804\B2EC\D558\C5EC \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. URL\C5D0\B294 \CCB4\D06C\C12C\C774 \D544\C694\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105735694951310060)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\C12C \D544\C694 - \C0AC\C6A9\C790 \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105735748037310060)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C740 URL\C5D0\C11C \C791\C5C5\C601\C5ED, \C560\D50C\B9AC\CF00\C774\C158 \BC0F \C0AC\C6A9\C790\C5D0 \D574\B2F9\D558\B294 \CCB4\D06C\C12C\C774 \D3EC\D568\B41C \D56D\BAA9\C744 \C804\B2EC\D558\C5EC \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105735890493310060)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\C12C \D544\C694 - \C138\C158 \B808\BCA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105735953866310060)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C740 URL\C5D0\C11C \C138\C158\C5D0 \D574\B2F9\D558\B294 \CCB4\D06C\C12C\C774 \D3EC\D568\B41C \D56D\BAA9\C744 \C804\B2EC\D558\C5EC \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105237663622309649)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC \BCF4\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105259648240309666)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CCB4\D06C\BC15\C2A4\AC00 \C5F0\AD00\B41C \D544\D130 \ADF8\B8F9\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105259509620309666)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106022997516310292)
,p_name=>'PE.PROPERTY.SHORTCUT_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105927315648310205)
,p_name=>'PE.PROPERTY.SHORTCUT_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106023079757310293)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105558496541309909)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\C791\C5C5</em> \BA54\B274\AC00 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C \B0B4\C5D0 \D3EC\D568\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105558385283309909)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BA54\B274 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105555610093309907)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \C9D1\ACC4\B97C \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105555501403309907)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D1\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105541375580309895)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C774 \BCF4\ACE0\C11C\C5D0 \AE30\BCF8\C801\C73C\B85C \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105541238997309895)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\C73C\B85C \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105555884937309907)
,p_name=>'PE.PROPERTY.SHOW_CHART.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \CC28\D2B8\B97C \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105555794341309907)
,p_name=>'PE.PROPERTY.SHOW_CHART.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105555413926309906)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \ACC4\C0B0 \C5F4\C744 \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105555330146309906)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105555071883309906)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \C81C\C5B4 \CC28\B2E8\C744 \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105554970645309906)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \CC28\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105260026681309666)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D328\C2EF \BAA9\B85D\C5D0\C11C \C120\D0DD\B41C \AC12 \C606\C5D0 \D328\C2EF \B808\C774\BE14\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C120\D0DD\B41C \AC12\C774 \C8FC\BB38 \C0C1\D0DC\C640 \AC19\C740 \C790\CCB4 \C124\BA85\D615\C774\BA74 \B808\C774\BE14\C744 \C228\AE41\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105259996585309666)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D328\C2EF\C758 \B808\C774\BE14 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105558023558309909)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\BCC4\B3C4\C758 \B4DC\B86D\B2E4\C6B4 \D589 \C120\D0DD\AE30\AC00 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C \B0B4\C5D0 \D3EC\D568\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C774 \C18D\C131\ACFC <strong>\D398\C774\C9C0\B2F9 \D589</strong>\C740 \B3D9\C2DC\C5D0 \C120\D0DD\D558\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105557947712309908)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B2F9 \D589 \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105556899536309908)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C9C0\C815\B41C \B2E4\C6B4\B85C\B4DC \D615\C2DD \C911 \D558\B098\B85C \BCF4\ACE0\C11C\B97C \B2E4\C6B4\B85C\B4DC\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105556724313309908)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105554216352309906)
,p_name=>'PE.PROPERTY.SHOW_FILTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \D544\D130\B97C \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105554119822309905)
,p_name=>'PE.PROPERTY.SHOW_FILTER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105557859108309908)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\AC80\C0C9 \B3C4\AD6C \BAA8\C74C \B0B4\C5D0 \C788\B294 \AC80\C0C9 \D544\B4DC\C758 \C2DC\C791 \BD80\BD84\C5D0 \AC80\C0C9\AE30 \B4DC\B86D\B2E4\C6B4\C774 \D3EC\D568\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\AC80\C0C9\AE30 \B4DC\B86D\B2E4\C6B4\C740 \C0AC\C6A9\C790\AC00 \AC80\C0C9\C744 \D2B9\C815 \C5F4\B85C \C81C\D55C\D560 \C218 \C788\AC8C \D574\C8FC\B294 \C5F4 \BAA9\B85D\C785\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105557747204309908)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\AE30 \B4DC\B86D\B2E4\C6B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105556438616309907)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \C77C\BC18 \C0AC\C6A9\C790\AC00 \D50C\B798\C2DC\BC31 \C9C8\C758\B97C \C0AC\C6A9\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\D50C\B798\C2DC\BC31 \C9C8\C758\B294 Oracle Flashback Technology \BC0F \B370\C774\D130\BCA0\C774\C2A4 \C801\C2DC \BCF5\AD6C\B97C \C0AC\C6A9\D574\C11C \C774\C804 \C2DC\C810\C5D0 \C874\C7AC\D55C \B370\C774\D130\B97C \D574\B2F9 \C2DC\C810 \ADF8\B300\B85C \D655\C778\D560 \C218 \C788\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\B294 \C774 \B370\C774\D130\B97C \C9C8\C758\B9CC \D560 \C218 \C788\C73C\BA70, \B370\C774\D130 \BCC0\ACBD\C0AC\D56D\C744 \B418\B3CC\B9B4 \C218 \C5C6\C2B5\B2C8\B2E4. \C774 \AE30\C220\C5D0\B294 RMAN \BC31\C5C5\C774 \C0AC\C6A9\B418\AE30 \B54C\BB38\C5D0 \C0AC\C6A9\C790\AC00 \D50C\B798\C2DC\BC31 \C9C8\C758\B97C \C131\ACF5\C801\C73C\B85C \C218\D589\D560 \C218 \C788\B294 \AE30\AC04\C740 Oracle \B370\C774\D130\BCA0\C774\C2A4 \B0B4\C5D0\C11C \B9C8\C9C0\B9C9\C73C\B85C \B9AC\B450 \B85C\ADF8 \D30C\C77C\C774 \C804\D658\B41C \C2DC\AC04\C5D0 \B530\B77C \ACB0')
||unistr('\C815\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105556399962309907)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B798\C2DC\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105556246272309907)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \ADF8\B8F9 \AE30\C900 \BD84\C11D\C744 \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105556101443309907)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105494010245309855)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\B41C \B3C4\AD6C \C124\BA85\C5D0 \ADF8\B8F9 \C774\B984\C774 \D45C\C2DC\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105493926990309855)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \C774\B984 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105557012103309908)
,p_name=>'PE.PROPERTY.SHOW_HELP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \B300\D654\C2DD \BCF4\ACE0\C11C\C5D0 \B300\D574 \B0B4\C7A5\B41C \B3C4\C6C0\B9D0 \BAA8\B2EC \B300\D654\C0C1\C790\B97C \D638\CD9C\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\B3C4\C6C0\B9D0 \B300\D654\C0C1\C790\C5D0\B294 \D604\C7AC \C0AC\C6A9\C790\C5D0\AC8C \C81C\ACF5\B418\B294 \C635\C158\B9CC \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105556984639309908)
,p_name=>'PE.PROPERTY.SHOW_HELP.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105555274144309906)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \AC15\C870 \D45C\C2DC\B97C \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105555171166309906)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105878759726310167)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CE35\C774 \BC94\B840\C5D0 \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105878602296310167)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105556097218309907)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \AC00\C785 \C124\C815\C744 \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105555931966309907)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105547403159309900)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \C5F4\C5D0 \B300\D574 \D45C\C2DC\D558\B824\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105547345139309900)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C73C\B85C \B110 \AC12 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104856165766309359)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \D53C\BC97 \BD84\C11D\C744 \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104856093298309359)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105233168611309646)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BE60\B978 \C120\D0DD\C774 \C774 \D398\C774\C9C0 \D56D\BAA9\C5D0 \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\BE60\B978 \C120\D0DD\C744 \C0AC\C6A9\D558\BA74 \C0AC\C6A9\C790\AC00 \D14D\C2A4\D2B8\B97C \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \C635\C158 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D558\B294 \B300\C2E0 \B9C8\C6B0\C2A4\B97C \D55C \BC88\B9CC \B20C\B7EC\C11C \BBF8\B9AC \C815\C758\B41C \AC12\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\BE44\AD50\C801 \D06C\AE30\AC00 \C791\ACE0 \C5F0\C18D\C801\C774\C9C0 \C54A\C740 <em>\ACF5\D1B5</em> \C785\B825 \AC12\C774 \C788\C744 \B54C\B294 \BE60\B978 \C120\D0DD\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.'),
unistr('\D56D\BAA9\C5D0 \B300\D574 \C815\C758\D560 \C218 \C788\B294 \BE60\B978 \C120\D0DD \C218\B294 \CD5C\B300 10\AC1C\C785\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \C0AC\C6A9\C790 \C9C0\C6D0 \AE30\B2A5\C740 \C0AC\C6A9 \AC00\B2A5\D55C \AC12\C758 \C120\D0DD \BAA9\B85D\C774 \AE34 \D56D\BAA9\C5D0 \B300\D574 \C815\C758\D560 \ACBD\C6B0\C5D0 \D2B9\D788 \C720\C6A9\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105233026535309646)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE60\B978 \C120\D0DD \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105558623791309909)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BCF4\ACE0\C11C \C120\D0DD \BAA9\B85D\C774 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C5D0 \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\BCF4\ACE0\C11C \C120\D0DD \BAA9\B85D\C740 \C0AC\C6A9\C790\AC00 \AE30\BCF8 \BCF4\ACE0\C11C \C774\C678\C758 \BCF4\ACE0\C11C\C5D0 \C561\C138\C2A4\D560 \C218 \C788\B294 \ACBD\C6B0\C5D0\B9CC \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105558575094309909)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C120\D0DD \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105556682085309907)
,p_name=>'PE.PROPERTY.SHOW_RESET.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \C791\C5C5 \BA54\B274\C5D0\C11C \C790\C2E0\C758 \BCF4\ACE0\C11C\B97C \C7AC\C124\C815\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\BCF4\ACE0\C11C\B97C \C7AC\C124\C815\D558\BA74 \C0AC\C6A9\C790\AC00 \C218\D589\D588\AC70\B098 URL\C744 \D638\CD9C\D558\C5EC \C9C0\C815\B41C \BAA8\B4E0 \C0AC\C6A9\C790\C815\C758\B97C \B418\B3CC\B9AC\ACE0 \AE30\BCF8 \BCF4\ACE0\C11C\B97C \D45C\C2DC\D569\B2C8\B2E4.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105556540989309907)
,p_name=>'PE.PROPERTY.SHOW_RESET.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105554687924309906)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \D45C\C2DC\B418\B294 \D589 \C218\B97C \BCC0\ACBD\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105554589506309906)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B2F9 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105558241580309909)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \D544\B4DC\AC00 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C \B0B4\C5D0 \D3EC\D568\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105558116823309909)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \D544\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105554477219309906)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C791\C5C5 \BA54\B274\C5D0\C11C <strong>\C5F4 \C120\D0DD</strong>\C744 \C0AC\C6A9\D574\C11C \C774 \BCF4\ACE0\C11C\C5D0 \D45C\C2DC\B418\B294 \C5F4\C744 \BCC0\ACBD\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C0AC\C6A9\C790\AC00 \C774 \C635\C158\C744 \C0AC\C6A9\D574\C11C \C5EC\B7EC \C5F4\C744 \C120\D0DD(\B610\B294 \D45C\C2DC), \C120\D0DD \D574\C81C(\B610\B294 \C228\AE30\AE30) \BC0F \C7AC\C815\B82C\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105554338522309906)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105493898391309855)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \B80C\B354\B9C1\B41C \B3C4\AD6C \C124\BA85\C5D0 \ACC4\C5F4 \C774\B984\C774 \D45C\C2DC\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105493777830309854)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C5F4 \C774\B984 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105554848663309906)
,p_name=>'PE.PROPERTY.SHOW_SORT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \BCF4\ACE0\C11C\C5D0 \B300\D574 \C815\B82C \C5F4\C744 \C815\C758\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105554762881309906)
,p_name=>'PE.PROPERTY.SHOW_SORT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105259075715309665)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \B808\C774\BE14\C744 \D45C\C2DC\D560\C9C0 \B610\B294 \C81C\C548 \CE69\C758 \AC12\B9CC \D45C\C2DC\D560\C9C0 \C9C0\C815\D569\B2C8\B2E4. \C81C\C548\B41C \AC12\C774 \C8FC\BB38 \C0C1\D0DC\C640 \AC19\C740 \C790\CCB4 \C124\BA85\D615\C774\BA74 \B808\C774\BE14\C744 \C228\AE41\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105258946915309665)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105440434316309811)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\AD6C \BAA8\C74C\C774 \BCF4\ACE0\C11C \C704\C5D0 \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \B3C4\AD6C \BAA8\C74C\C5D0\B294 \AC80\C0C9, \BCF4\ACE0\C11C \C720\D615, \C800\C7A5\B41C \BCF4\ACE0\C11C, \C791\C5C5, \BCC0\ACBD \BC0F \C7AC\C124\C815 \AE30\B2A5\C774 \D3EC\D568\B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105440359933309811)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105440215927309811)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BCF4\ACE0\C11C \BC14\B2E5\AE00\C5D0 \CD1D \D589 \C218\B97C \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.<p/>'),
unistr('        <p>\CC38\ACE0 - \CD1D \D589 \C218\B97C \AC00\C838\C624\AE30 \C704\D574 \CD94\AC00 \C9C8\C758\AC00 \C218\D589\B418\BA70, \D2B9\D788 \B9E4\C6B0 \D070 \B370\C774\D130\C138\D2B8\C5D0\C11C\B294 \C131\B2A5 \C800\D558\AC00 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105440122244309811)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \D589 \C218 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105575649969309923)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2E8\C21C \CCB4\D06C\BC15\C2A4 \D45C\C2DC \C720\D615\C758 \ACBD\C6B0 \D558\B098\C758 \AC12 \B610\B294 \B450 \AC1C\C758 \CF64\B9C8\B85C \AD6C\BD84\B41C \AC12\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\CCAB\BC88\C9F8 \AC12\C740 \CCB4\D06C\BC15\C2A4\AC00 \C120\D0DD\B41C \ACBD\C6B0\C5D0 \C81C\CD9C\B429\B2C8\B2E4. \B450\BC88\C9F8 \AC12\C740(\C815\C758\B41C \ACBD\C6B0) \CCB4\D06C\BC15\C2A4\AC00 \C120\D0DD \D574\C81C\B41C \ACBD\C6B0\C5D0 \C81C\CD9C\B429\B2C8\B2E4.'),
'        p_examples           => q''~<dl>',
unistr('<dt>\C120\D0DD\B41C \ACBD\C6B0 Yes\B97C \C81C\CD9C\D558\ACE0 \C120\D0DD \D574\C81C\B41C \ACBD\C6B0 No\B97C \C81C\CD9C\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'Yes,No',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105575520460309922)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\BC15\C2A4 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105541906107309896)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C \D589 \BCF4\AE30\C5D0 \C0AC\C6A9\D560 \C5F4 \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105541891280309896)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105583596384309929)
,p_name=>'PE.PROPERTY.SORT_NULLS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \BA38\B9AC\AE00 \C815\B82C\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D558\B294 \BCF4\ACE0\C11C \C5F4\C758 \ACBD\C6B0 \B110\C774 \C544\B2CC \AC12\C744 \D3EC\D568\D558\B294 \B808\CF54\B4DC\C640 \AD00\B828\D574\C11C \B110 \AC12\C744 \D3EC\D568\D558\B294 \B808\CF54\B4DC\B97C \C815\B82C\D560 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105763166405310080)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105763215258310080)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \AC12\C744 \D3EC\D568\D558\B294 \B808\CF54\B4DC\B294 \B110\C774 \C544\B2CC \AC12\C744 \D3EC\D568\D558\B294 \BAA8\B4E0 \C5F4 \C55E\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105763365461310080)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105763437979310080)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110\C774 \C544\B2CC \AC12\C744 \D3EC\D568\D558\B294 \B808\CF54\B4DC\B294 \B110 \AC12\C744 \D3EC\D568\D558\B294 \BAA8\B4E0 \C5F4 \C55E\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105583447558309929)
,p_name=>'PE.PROPERTY.SORT_NULLS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104856811361309360)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C640 \C5F0\AD00\B41C \C774\B3D9 \ACBD\B85C \BAA9\B85D\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104856713125309360)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106089306131310355)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \D328\C2EF\C5D0 \B300\D55C \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \B370\C774\D130\BCA0\C774\C2A4 \C5F4 \C774\B984(\B300\C18C\BB38\C790 \AD6C\BD84)\C744 \C785\B825\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105897743156310182)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \D328\C2EF\C5D0 \B300\D55C \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \B370\C774\D130\BCA0\C774\C2A4 \C5F4 \C774\B984(\B300\C18C\BB38\C790 \AD6C\BD84)\C744 \C785\B825\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105261088318309667)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \D544\D130\C5D0 \B300\D55C \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \B370\C774\D130\BCA0\C774\C2A4 \C5F4 \C774\B984(\B300\C18C\BB38\C790 \AD6C\BD84)\C744 \C785\B825\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105262150750309667)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \D544\D130\C5D0 \B300\D55C \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \B370\C774\D130\BCA0\C774\C2A4 \C5F4 \C774\B984(\B300\C18C\BB38\C790 \AD6C\BD84)\C744 \C785\B825\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105231947085309645)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D56D\BAA9 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\B294 \B370\C774\D130\BCA0\C774\C2A4 \C5F4 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C5F4\C740 \C774 \D398\C774\C9C0\C5D0 \C815\C758\B41C \B0B4\C7A5\B41C \C778\CD9C \D589 \D504\B85C\C138\C2A4 \B0B4\C5D0 \C9C0\C815\B41C \D14C\C774\BE14\C5D0 \C874\C7AC\D574\C57C \D569\B2C8\B2E4.'),
unistr('\B370\C774\D130\BCA0\C774\C2A4 \C5F4 \C774\B984\C774 \CC38\C870\B418\B294 \D14C\C774\BE14\C5D0 \C874\C7AC\D558\C9C0 \C54A\C73C\BA74 \C624\B958\AC00 \BC1C\C0DD\D558\ACE0 \D398\C774\C9C0\AC00 \B85C\B4DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('\B9C8\CC2C\AC00\C9C0\B85C, \C815\C758\B41C \B0B4\C7A5\B41C \C778\CD9C \D589 \D504\B85C\C138\C2A4\AC00 \C5C6\ACE0 \C18C\C2A4 \C720\D615\C774 <strong>\B370\C774\D130\BCA0\C774\C2A4 \C5F4</strong>\C778 \D56D\BAA9\C774 \C788\C73C\BA74 \C624\B958\AC00 \BC1C\C0DD\D558\ACE0 \D398\C774\C9C0\B97C \B80C\B354\B9C1\D558\B824\ACE0 \C2DC\B3C4\D560 \B54C \D398\C774\C9C0\AC00 \B85C\B4DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105231840021309645)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105970389558310240)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D45C\D604\C2DD\C744 \D3C9\AC00\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105970725608310240)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105970690597310240)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105970558897310240)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105970864114310240)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105970459229310240)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ko'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105970211450310240)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105668223885310001)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D328\C2EF \AC80\C0C9 \B610\B294 \C2A4\B9C8\D2B8 \D544\D130 \C601\C5ED\ACFC \C5F0\AD00\B41C \C601\C5ED\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105668155764310001)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130\B9C1\B428 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105972332027310242)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105972604965310242)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105972517045310242)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105972430117310242)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105972747779310242)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105972240445310242)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105231767579309645)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D56D\BAA9 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105231608608309645)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106001179553310272)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589\D560 Java \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106001097579310271)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105971968868310241)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 Java \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105971855291310241)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105973541588310243)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105973404629310243)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106000941341310271)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C784\AE08 \C778\C0C1\C5D0 \C801\ACA9\D55C \C9C1\C6D0\C5D0 \B300\D574 \C784\AE08\C744 3% \C778\C0C1\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'var rows;',
'',
'function needsSalaryRaise( empno ) {',
'    // placeholder for some complicated logic to calculate if employee needs a raise',
'    return true;',
'}',
'',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'    if ( needsSalaryRaise( row.EMPNO )) {',
'      apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'    }',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106000858664310271)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589\D560 JavaScript \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106000700471310271)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105971700882310241)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105971624004310241)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 JavaScript \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105971571953310241)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105973347141310242)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105973244878310242)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105973120023310242)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104856677247309360)
,p_name=>'PE.PROPERTY.SOURCE_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BAA9\B85D\C758 \C18C\C2A4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104856521913309359)
,p_name=>'PE.PROPERTY.SOURCE_LIST.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105314255145309708)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\C758 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105314371732309708)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\CEEC \B370\C774\D130\BCA0\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105314489720309708)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\CEEC \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \B370\C774\D130\B97C \AC00\C838\C635\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105314564245309708)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105314663372309708)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL\C744 \C0AC\C6A9\D558\C5EC \C811\C18D\C774 \C815\C758\B41C \C6D0\ACA9 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \B370\C774\D130\B97C \AC00\C838\C635\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105424729083309797)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106031362421310301)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4\B97C \C0AC\C6A9\D558\C5EC \C815\C758\B41C RESTful \C6F9 \C11C\BE44\C2A4\C5D0\C11C \B370\C774\D130\B97C \AC00\C838\C635\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105314164809309708)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105509971059309869)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BCC4 \C694\CCAD\C73C\B85C \CC28\D2B8 \B370\C774\D130\B97C \C77D\C744 \B54C \C138\C158 \C0C1\D0DC\B85C \C124\C815\D560 \D604\C7AC \D398\C774\C9C0\C758 \CF64\B9C8\B85C \AD6C\BD84\B41C \D398\C774\C9C0 \D56D\BAA9 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105877410124310166)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\B3C4 \C694\CCAD\C73C\B85C \B9F5 \B370\C774\D130\B97C \C778\CD9C\D560 \B54C \C138\C158 \C0C1\D0DC\B85C \C124\C815\D560 \D604\C7AC \D398\C774\C9C0\C758 \CF64\B9C8\B85C \AD6C\BD84\B41C \D398\C774\C9C0 \D56D\BAA9 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105307104503309702)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BD80\BD84 \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68\C73C\B85C \C601\C5ED\C744 \C0C8\B85C\ACE0\CE68\D560 \B54C \C138\C158 \C0C1\D0DC\B85C \C124\C815\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\D56D\BAA9\C774 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \AC01 \D56D\BAA9 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\D569\B2C8\B2E4.'),
unistr('\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \B54C \C774\BBF8 \C785\B825\B41C \D14D\C2A4\D2B8\AC00 \C788\C73C\BA74 \AE30\C874 \D14D\C2A4\D2B8 \B05D\C5D0 \CF64\B9C8\AC00 \D45C\C2DC\B418\ACE0 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \D56D\BAA9 \C774\B984\C774 \CD94\AC00\B429\B2C8\B2E4.</p>'),
unistr('<p>\C601\C5ED\C740 \D398\C774\C9C0 \B9E4\AE40 \C911 \BD80\BD84 \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68\C744 \C0AC\C6A9\D558\AC70\B098(<em>\BD80\BD84 \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68 \C0AC\C6A9</em>\C774 <strong>\C124\C815</strong>\C73C\B85C \C124\C815\B41C \ACBD\C6B0) \B3D9\C801 \C791\C5C5 \B0B4\C5D0\C11C \C0C8\B85C\ACE0\CE68 \C791\C5C5\C744 \C0AC\C6A9\D574\C11C \C0C8\B85C\ACE0\CE68\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('\ADF8\B7F0 \B2E4\C74C\C5D0\B294 \C601\C5ED \C18C\C2A4 SQL \C9C8\C758\C758 <em>where \C870\AC74</em>\C5D0\C11C \C774\B7EC\D55C \D398\C774\C9C0 \D56D\BAA9\C744 \C0AC\C6A9\D558\C5EC \C9C8\C758 \ACB0\ACFC\B97C \C81C\D55C\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105307041433309702)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106000633994310271)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C784\AE08 \C778\C0C1\C5D0 \C801\ACA9\D55C \C9C1\C6D0\C5D0 \B300\D574 \C784\AE08\C744 3% \C778\C0C1\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106000545173310271)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589\D560 PL/SQL \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106000444396310271)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105971486731310241)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105971307314310241)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105971212500310241)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105973033527310242)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105972932193310242)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105972801563310242)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106036657805310306)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\CEEC \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \AC80\C0C9\B41C REST \C18C\C2A4 \B370\C774\D130\B97C \C0AC\D6C4 \CC98\B9AC\D558\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106037110236310306)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106037226636310306)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\D658\B41C SQL \C9C8\C758\AC00 \AC80\C0C9\B41C \B370\C774\D130\B97C \BCC0\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106036944893310306)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106037024132310306)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\B41C \B370\C774\D130\B97C \BCC0\D658\D560 SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106036776495310306)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('Where/Order By \C808')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106036841791310306)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\B41C \B370\C774\D130\B97C \C81C\D55C\D558\ACE0 \C815\B82C\D560 Where \BC0F/\B610\B294 Order By \C808\C744 \C785\B825\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106036507472310306)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105232172144309645)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \AC12\C5D0 \B300\D55C \C18C\C2A4\B85C \C0AC\C6A9\D560 \C0AC\C6A9\C790 \D658\ACBD\C124\C815\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105232072727309645)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106001350190310272)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589\D560 Python \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106001206563310272)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \CF54\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105972158946310242)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 Python \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105972063756310241)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105973782571310243)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105973650165310243)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105231344165309645)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \AC12\C5D0 \B300\D55C \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4. \D589\C774 \B450 \AC1C \C774\C0C1 \BC18\D658\B418\B294 \ACBD\C6B0 \CCAB\BC88\C9F8 \D589\C758 \AC12\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105231229158309645)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105231540591309645)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\D560 \D589\C744 \D558\B098 \C774\C0C1 \BC18\D658\D558\B294 SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4. \ACB0\ACFC\C5D0 \D589\C774 \C5EC\B7EC \AC1C \D3EC\D568\B418\B294 \ACBD\C6B0 \AC01 \D589\C5D0 \B300\D55C \AC12\C740 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \B2E8\C77C \AC12\C73C\B85C \D615\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105231471623309645)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105980707993310252)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105981086292310253)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105980944050310253)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105980818004310253)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105981191725310253)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105980603037310252)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105981902547310254)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \ACC4\C5F4\C5D0 \B300\D574 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105981878920310254)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105981736601310253)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>EMPNO, ENAME \BC0F SAL \C5F4\C744 \C120\D0DD\D558\ACE0 SAL\C774 3000 \BBF8\B9CC\C778 \BAA8\B4E0 \D589\C744 \D544\D130\B9C1\D558\C5EC \C81C\C678\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from EMP where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105981647945310253)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \ACC4\C5F4\C5D0 \B300\D574 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105981520637310253)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105312799803309707)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\ACE0\C6A9\C744 \CD5C\C2E0 \AC83 \BA3C\C800 \D45C\C2DC\D558\ACE0 \BE44\ACE0\C6A9\C744 \B9C8\C9C0\B9C9\C5D0 \D45C\C2DC\D569\B2C8\B2E4. \B0A0\C9DC\AC00 \AC19\C744 \ACBD\C6B0 \BD80\C11C \BC88\D638\BCC4\B85C \C815\B82C\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105312614406309707)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C0\C2DC\C5B4\B97C \D3EC\D568\D558\C5EC \B808\CF54\B4DC \AC80\C0C9 \C21C\C11C\B97C \C815\C758\D560 \CF64\B9C8\B85C \AD6C\BD84\B41C \D558\B098 \C774\C0C1\C758 \C5F4 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('        <p>\C9C0\C2DC\C5B4\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'          <ul>',
unistr('            <li>ASC - \C624\B984\CC28\C21C\C73C\B85C \C5F4\C744 \BC18\D658\D569\B2C8\B2E4.</li>'),
unistr('            <li>DESC - \B0B4\B9BC\CC28\C21C\C73C\B85C \C5F4\C744 \BC18\D658\D569\B2C8\B2E4.</li>'),
unistr('            <li>NULLS FIRST - \AC12\C774 \C5C6\B294 \C5F4\C744 \AC12\C774 \C788\B294 \C5F4\BCF4\B2E4 \BA3C\C800 \BC18\D658\D569\B2C8\B2E4.</li>'),
unistr('            <li>NULLS LAST - \AC12\C774 \C788\B294 \C5F4\C744 \AC12\C774 \C5C6\B294 \C5F4\BCF4\B2E4 \BA3C\C800 \BC18\D658\D569\B2C8\B2E4.</li>'),
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105312544455309707)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105311903379309706)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C744 \C18C\C720\D558\B294 \C2A4\D0A4\B9C8\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105311853152309706)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105425358691309798)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C601\C5ED\C5D0 \B300\D55C \AE30\C900\C73C\B85C \C0AC\C6A9\B418\B294 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105425225234309798)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105981420237310253)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>EMPNO, ENAME \BC0F SAL \C5F4\C744 \C120\D0DD\D558\ACE0 SAL\C774 3000 \BBF8\B9CC\C778 \BAA8\B4E0 \D589\C744 \D544\D130\B9C1\D558\C5EC \C81C\C678\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from EMP where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105981336739310253)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \ACC4\C5F4\C5D0 \B300\D574 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105981249015310253)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105982197718310254)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \ACC4\C5F4\C5D0 \B300\D574 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105982003627310254)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105312123806309706)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\B294 \D14C\C774\BE14 \B610\B294 \BDF0 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105312081495309706)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105311581282309706)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\AC00 \C9C8\C758\B418\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105424862179309798)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105424986624309798)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\C5EC \BC18\D658\B418\B294 SQL \C9C8\C758\B97C \AE30\BC18\C73C\B85C \B370\C774\D130\AC00 \AC80\C0C9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105314792489309708)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105314885734309708)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \AE30\BC18\C73C\B85C \B370\C774\D130\AC00 \AC80\C0C9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105311644620309706)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14/\BDF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105311723420309706)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \B610\B294 \BDF0\B97C \AE30\BC18\C73C\B85C \B370\C774\D130\AC00 \AC80\C0C9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105311497167309706)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105312408748309706)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\AD00\B9AC\C790\AC00 \C788\AC70\B098 \C9C1\BB34\AC00 \C601\C5C5\C0AC\C6D0\C778 \C0AC\C6D0\B9CC \D3EC\D568\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'( MGR is not null or JOB = ''SALESMAN'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105312307993309706)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\B41C \B808\CF54\B4DC\B97C \C81C\D55C\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C801\D569\D55C SQL Where \C870\AC74\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105312241552309706)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Where \C808')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105311344632309706)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\ACA9 \B370\C774\D130\BCA0\C774\C2A4 \C11C\BC84\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105311279111309705)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\ACA9 \C11C\BC84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105999991263310270)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \CF54\B4DC\B97C \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106000202335310271)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106000191952310271)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106000005642310271)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106000352204310271)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105999830949310270)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105625573329309963)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\B450 \C5F4\C744 \D568\AED8 \C5F0\ACB0\D558\B824\BA74 \B2E4\C74C\ACFC \AC19\C774 \D558\C2ED\C2DC\C624.</dt>'),
'<dd><pre>',
'FIRSTNAME || '' '' || LASTNAME',
'</pre></dd>',
unistr('<dt>\B0B4\BD80 select \D3EC\D568:</dt>'),
'<dd><pre>',
'(select count(*) from emp e where e.deptno = DEPTNO)',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105449869565309819)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105449774870309819)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105971120372310241)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \AD00\B9AC\C790\C774\ACE0 \BD80\C11C\AC00 \C2DC\CE74\ACE0\C5D0 \C788\C744 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105971029288310241)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105970945620310241)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105879645055310168)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.COMPONENT_PROPERTY.MAP_LAYER.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\ACBD\B3C4 \BC0F \C704\B3C4 \AC12\C744 NUMBER \C5F4\B85C \BC18\D658\D558\B294 \C9C8\C758:</p>'),
'<pre>',
'select lon,',
'       lat,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>',
unistr('<p>\ACE0\AC1D \C704\CE58\B97C SDO_GEOMETRY \C5F4\B85C \BC18\D658\D558\B294 \C9C8\C758:</p>'),
'<pre>',
'select cust_location,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105312956765309707)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C SQL \C18C\C2A4\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105312804715309707)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105231170768309645)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \AC12\C5D0 \B300\D55C \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \C815\C801 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105231073785309644)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105230967910309644)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D56D\BAA9 \AC12\C774 \AE30\BC18\C73C\B85C \D558\B294 \C18C\C2A4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: <strong>\C18C\C2A4: \C0AC\C6A9\B428</strong>\C774 <em>\C138\C158 \C0C1\D0DC\C5D0\C11C \D604\C7AC \AC12\C774 \B110\C77C \B54C\B9CC</em>\C73C\B85C \C124\C815\B41C \ACBD\C6B0 \AC12\C774 \C774 \D56D\BAA9\C5D0 \B300\D55C \C138\C158 \C0C1\D0DC\B85C \C124\C815\B41C \ACBD\C6B0\C5D0\B294 \C18C\C2A4\AC00 \C0AC\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105734092911310058)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105929399857310206)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \AC12\C774 \C5C6\C73C\BBC0\B85C \B110\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105734271885310058)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105928713269310206)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\B370\C774\D130\BCA0\C774\C2A4 \C5F4</em>\C5D0 \C785\B825\B41C \C5F4 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4. \C774 \AC12\C740 \B0B4\C7A5 \D589 \C778\CD9C \D504\B85C\C138\C2A4\C5D0\C11C \AC80\C0C9\B41C \AC12\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105950084487310225)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105950185108310225)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>\D45C\D604\C2DD</em> \C2E4\D589 \ACB0\ACFC \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105734550386310059)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105929163818310206)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>\D568\C218 \BCF8\BB38</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105734684083310059)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105928819671310206)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105734709108310059)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105929236981310206)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>\D658\ACBD\C124\C815</em>\C758 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105734350114310059)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758(\B2E8\C77C \AC12 \BC18\D658)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105928937303310206)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>SQL \C9C8\C758</em>\C5D0\C11C \BC18\D658\B41C \CCAB\BC88\C9F8 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105734490678310059)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758(\CF5C\B860\C73C\B85C \AD6C\BD84\B41C \AC12 \BC18\D658)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105929058237310206)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>SQL \C9C8\C758</em>\C5D0\C11C \BC18\D658\B41C \B2E8\C77C \AC12(\AC01 \D589 \AC12\C744 \CF5C\B860\C73C\B85C \AD6C\BD84\D558\C5EC \C5F0\ACB0\D55C \AC12)\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105734134143310058)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105928624423310206)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\C815\C801 \AC12</em>\C5D0 \C785\B825\B41C \D14D\C2A4\D2B8\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105230833065309644)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105230769926309644)
,p_name=>'PE.PROPERTY.SOURCE_USED.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C138\C158 \C0C1\D0DC\C758 \AC12 \B610\B294 \D56D\BAA9 \C18C\C2A4 \AC12 \C911\C5D0\C11C \C6B0\C120 \C801\C6A9\B418\B294 \AC12\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\C18C\C2A4 \C720\D615\C774 <strong>\B370\C774\D130\BCA0\C774\C2A4 \C5F4</strong>\C778 \D56D\BAA9\C758 \ACBD\C6B0 \D398\C774\C9C0\AC00 \ADF8 \C790\CCB4\B85C \B2E4\C2DC \BD84\AE30\B418\B294 \ACBD\C6B0 \AD00\B828 \D589 \C778\CD9C \C791\C5C5\C73C\B85C \D56D\BAA9\C744 \CC44\C6B0\C9C0 \C54A\C73C\B824\ACE0 \D558\C9C0 \C54A\B294 \D55C <strong>\C138\C158 \C0C1\D0DC\C5D0\C11C \D56D\C0C1 \C784\C758\C758 \AE30\C874 \AC12 \BC14\AFB8\AE30</strong>\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\B2E4\B978 \C18C\C2A4 \C720\D615\C758 \ACBD\C6B0 \D398\C774\C9C0 \C0AC\C6A9 \BC29\BC95\C5D0 \B530\B77C \C774\C804\C5D0 \C81C\ACF5\B41C \AC12\C774 \D45C\C2DC\B418\AC70\B098 \C18C\C2A4 \C720\D615\C774 \AC01 \D398\C774\C9C0 \BCF4\AE30\C5D0 \B300\D574 \C0C8\B85C \C801\C6A9\B418\B294\C9C0\B97C \ACB0\C815\D574\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105733812480310058)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.NO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC\C5D0\C11C \D56D\C0C1 \C784\C758\C758 \AE30\C874 \AC12 \BC14\AFB8\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105733947016310058)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.YES.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC\C5D0\C11C \D604\C7AC \AC12\C774 \B110\C77C \B54C\B9CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105230604223309644)
,p_name=>'PE.PROPERTY.SOURCE_USED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105425173503309798)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C74C \C778\CD9C\C744 \C9C0\C6D0\D558\B294 REST \B370\C774\D130 \C18C\C2A4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105425036184309798)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105509728931309869)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\D560\B41C \C774\C911 Y \CC28\D2B8\C5D0\C11C Y\CD95 \D558\C704 \CC28\D2B8\C5D0 \C81C\ACF5\B41C \ACF5\AC04\C758 \BD80\BD84\C744 \C9C0\C815\D569\B2C8\B2E4. \C801\D569\D55C \AC12\C740 0 - 1 \C0AC\C774\C758 \C22B\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105509673337309869)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\D560\C120 \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105509292344309869)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 Y\CD95\C5D0 \C9C0\C815\B41C \B370\C774\D130\C138\D2B8\AC00 \AD6C\D68D \C601\C5ED\C758 \B2E4\B978 \BD80\BD84\C5D0 \B098\D0C0\B098\B3C4\B85D \AD6C\D68D \C601\C5ED\C774 \B450 \C139\C158\C73C\B85C \BD84\D560\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C8FC\C2DD \CC28\D2B8\B294 <strong>\C544\B2C8\C624</strong>\B97C \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105509343012309869)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105509580223309869)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.OFF.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105509469662309869)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.ON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105509154310309868)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105486411066309849)
,p_name=>'PE.PROPERTY.STACK.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\B370\C774\D130 \D56D\BAA9\C774 \B204\C801\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105486340135309849)
,p_name=>'PE.PROPERTY.STACK.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105110572564309549)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \ACC4\C5F4\C744 \C9C0\C815\D560 \C2A4\D0DD \BC94\C8FC \C774\B984\C744 \C9C0\C815\D569\B2C8\B2E4. \AE30\BCF8\C801\C73C\B85C \B204\C801 \CC28\D2B8\C758 \BAA8\B4E0 \ACC4\C5F4\C740 \B3D9\C77C\D55C \C2A4\D0DD\C5D0 \D568\AED8 \ADF8\B8F9\D654\B429\B2C8\B2E4. \C774 \ACC4\C5F4\C744 \BCC4\B3C4\C758 \C2A4\D0DD\C5D0 \ADF8\B8F9\D654\D558\B824\BA74 \C2A4\D0DD \BC94\C8FC\B97C \C124\C815\D558\C2ED\C2DC\C624. <code>&COLUMN_VALUE.</code> \CE58\D658\C744 \D65C\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105110406973309549)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0DD \BC94\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105110320298309549)
,p_name=>'PE.PROPERTY.STACK_LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\B204\C801 \B370\C774\D130 \D56D\BAA9\C758 \CD1D \AC12\C744 \D45C\C2DC\D574\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \B9C9\B300 \CC28\D2B8\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105110273988309549)
,p_name=>'PE.PROPERTY.STACK_LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0DD \B808\C774\BE14')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105211167851309630)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0 \C0AC\C6A9\B418\B294 \D45C\C900 \D0ED \C9D1\D569\C744 \C120\D0DD\D569\B2C8\B2E4. \D45C\C900 \D0ED \C9D1\D569\C740 \D2B9\C815 \D398\C774\C9C0 \BC88\D638\C640 \C5F0\AD00\B429\B2C8\B2E4. \D45C\C900 \D0ED\C744 \C0AC\C6A9\D574\C11C \C0AC\C6A9\C790\B97C \D2B9\C815 \D398\C774\C9C0\C5D0 \C5F0\ACB0\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105211011950309630)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105609232516309949)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\AC04 \B2EC\B825\C5D0 \D45C\C2DC\B418\B294 \C8FC\C758 \CCAB\BC88\C9F8 \C694\C77C\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\D45C\C2DC\B41C \C8FC\AC04 \C694\C77C\C744 \C81C\D55C\D558\AE30 \C704\D574 <strong>\C885\B8CC \C694\C77C</strong>\ACFC \D568\AED8 \C774 \C18D\C131\C744 \C0AC\C6A9\D558\AC70\B098 \B2E8\C21C\D788 \D45C\C2DC\B41C \C8FC\C758 \CCAB\BC88\C9F8 \C694\C77C\C744 \C9C0\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105768037213310084)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105768131991310084)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105768229995310084)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D654\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105768389856310084)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105768472844310084)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105768574292310084)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE08\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105768602271310084)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1A0\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105609125298309949)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105609058013309949)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4\AC04 \B2EC\B825\C774 \C2DC\C791\B418\B294 \C694\C77C\C744 \ACB0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105767342407310083)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105767434326310083)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105767520518310084)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D654\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105767688417310084)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105767784573310084)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105767824520310084)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE08\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105767975827310084)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1A0\C694\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105608982159309949)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105609806457309950)
,p_name=>'PE.PROPERTY.START_TIME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\AC04 \BC0F \C77C\AC04 \B2EC\B825\C758 \D45C\C2DC\C5D0 \D3EC\CEE4\C2A4\B97C \C9C0\C815\D558\AE30 \C704\D55C \C2DC\C791 \C2DC\AC04\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105609797169309950)
,p_name=>'PE.PROPERTY.START_TIME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105239510365309651)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \B3D9\C801 \C791\C5C5\C5D0 \B300\D574 \C0AC\C6A9\D560 jQuery \C120\D0DD\AE30\C758 \C815\C801 \CEE8\D14C\C774\B108\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('<strong>\B3D9\C801</strong> \C774\BCA4\D2B8 \BC94\C8FC\B97C \D3EC\D568\D558\B294 \B3D9\C801 \C791\C5C5\C758 \C131\B2A5\C744 \D5A5\C0C1\C2DC\D0AC \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774 \C694\C18C\B294 \C790\CCB4\C801\C73C\B85C \C7AC\C0DD\C131\B418\C9C0 \C54A\C9C0\B9CC PPR(\BD80\BD84 \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68)\C744 \C0AC\C6A9\D574\C11C \C7AC\C0DD\C131\B418\B294 \D2B8\B9AC\AC70 \C694\C18C\B97C \D3EC\D568\D558\B294 \D398\C774\C9C0\C758 \C694\C18C\C5EC\C57C \D569\B2C8\B2E4.'),
unistr('\C774 \C694\C18C \CC38\C870\B294 jQuery \C120\D0DD\AE30\B85C \C815\C758\B418\C5B4\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105239495583309651)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \CEE8\D14C\C774\B108(jQuery \C120\D0DD\AE30)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105249720598309658)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2E8\CD94\C5D0 \B300\D55C \C815\C801 ID\B97C \C785\B825\D569\B2C8\B2E4. \C815\C758\B41C \ACBD\C6B0, \C815\C801 ID\B294 \D574\B2F9 \B2E8\CD94\C758 ID\B85C \C0AC\C6A9\B429\B2C8\B2E4. \C815\C801 ID\B294 \D574\B2F9 \B2E8\CD94\C5D0 \B300\D574 \C0AC\C6A9\C790\C815\C758 JavaScript \B3D9\C791\C744 \AC1C\BC1C\D560 \B54C \C720\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \C815\C801 ID\AC00 \C815\C758\B418\C9C0 \C54A\C740 \ACBD\C6B0 \B2E8\CD94\AC00 \B0B4\BD80 ID\B97C \C0DD\C131\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \B2E8\CD94\AC00 \C785\B825\B41C \C815\C801 ID\B97C \C0AC\C6A9\D560 \C218 \C788\C73C\B824\BA74 \D15C\D50C\B9AC\D2B8\C5D0 <code>#BUTTON_ID#</code> \B300\CCB4 \BB38\C790\C5F4\C774 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105453944422309823)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C5D0 \B300\D55C \C815\C801 ID\B97C \C785\B825\D569\B2C8\B2E4. \C815\C801 ID\B294 \C5F4 \D56D\BAA9\C5D0 \B300\D55C \C0AC\C6A9\C790\C815\C758 JavaScript \B3D9\C791 \B610\B294 \C0AC\C6A9\C790\C815\C758 \C2A4\D0C0\C77C\C744 \AC1C\BC1C\D560 \B54C \C720\C6A9\D569\B2C8\B2E4. \C815\C801 ID\AC00 \C815\C758\B418\C9C0 \C54A\C740 \ACBD\C6B0 \B0B4\BD80 ID\AC00 \C5F4 \D56D\BAA9 ID\C5D0 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106131105294310394)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IR_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C5D0 \B300\D55C \C815\C801 ID\B97C \C785\B825\D558\C2ED\C2DC\C624. \C815\C758\B41C \ACBD\C6B0 \C815\C801 ID\B294 \D574\B2F9 TH(\D14C\C774\BE14 \BA38\B9AC\B9D0) \C140\C5D0 \B300\D55C ID, \D574\B2F9 TD(\D14C\C774\BE14 \B370\C774\D130) \C140\C5D0 \B300\D55C HEADERS \AC12\C73C\B85C \C0AC\C6A9\B429\B2C8\B2E4. \C815\C801 ID\B294 \C0AC\C6A9\C790\C815\C758 JavaScript \B3D9\C791 \B610\B294 \C5F4\C5D0 \B300\D55C \C0AC\C6A9\C790\C815\C758 \C2A4\D0C0\C77C\C744 \AC1C\BC1C\D558\B294 \ACBD\C6B0 \C720\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \C815\C801 ID\AC00 \C815\C758\B418\C5B4 \C788\C9C0 \C54A\C740 \ACBD\C6B0 \D14C\C774\BE14\C740 \C774\B7EC\D55C \C18D\C131\AC12\C5D0 \B300\D55C \B0B4\BD80 ID\B97C \C0DD\C131\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105510170430309869)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \CD95\C5D0 \B300\D55C \C815\C801 ID\B97C \C785\B825\D569\B2C8\B2E4. \C815\C801 ID\B294 \CC28\D2B8 \CD95\C5D0 \B300\D574 \C0AC\C6A9\C790\C815\C758 JavaScript \B3D9\C791\C744 \AC1C\BC1C\D560 \B54C \C720\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105510002257309869)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \ACC4\C5F4\C5D0 \B300\D55C \C815\C801 ID\B97C \C785\B825\D569\B2C8\B2E4. \C815\C801 ID\B294 \CC28\D2B8 \ACC4\C5F4\C5D0 \B300\D574 \C0AC\C6A9\C790\C815\C758 JavaScript \B3D9\C791\C744 \AC1C\BC1C\D560 \B54C \C720\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105308823896309703)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C601\C5ED\C5D0 \B300\D55C \C815\C801 ID\B97C \C785\B825\D569\B2C8\B2E4. \C815\C758\B41C \ACBD\C6B0, \C774 ID\B294 \B300\CCB4 \BB38\C790\C5F4 <code>#REGION_STATIC_ID#</code>\B97C \C0AC\C6A9\D574\C11C \C601\C5ED\C5D0 \B300\D55C ID\B85C \C0AC\C6A9\B429\B2C8\B2E4. \C774\B807\AC8C \D558\BA74 \D574\B2F9 \C601\C5ED\C5D0 \B300\D55C \C0AC\C6A9\C790\C815\C758 JavaScript \B3D9\C791\C744 \AC1C\BC1C\D558\B294 \B370 \C720\C6A9\D558\AC8C \D65C\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4. \C774 ID\AC00 \C815\C758\B418\C9C0 \C54A\C558\C73C\BA74 \C601\C5ED\C774 \B0B4\BD80 ID\B97C \C0DD\C131\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C601\C5ED\C774 \C785\B825\B41C \C815\C801 ID\B97C \C0AC\C6A9\D560 \C218 \C788\C73C\B824\BA74 \D15C\D50C\B9AC\D2B8\C5D0 <code>#REGION_STATIC_ID#</code> \B300\CCB4 \BB38\C790\C5F4\C774 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105239185454309651)
,p_name=>'PE.PROPERTY.STATIC_ID.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \C815\C801 ID\B97C \C785\B825\D569\B2C8\B2E4. \C815\C758\B41C \ACBD\C6B0 \C774 ID\B294 \AD6C\C131\C694\C18C\C5D0 \B300\D574 \C0AC\C6A9\C790\C815\C758 JavaScript \B3D9\C791\C744 \AC1C\BC1C\D560 \B54C \C720\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105239028937309651)
,p_name=>'PE.PROPERTY.STATIC_ID.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105521422165309879)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1\B41C \C8FC\C2DD \CC28\D2B8\C5D0 \C801\C6A9\D560 \ACC4\C5F4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105521516648309879)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.AREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105521670935309879)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.BAR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105521726716309879)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.CANDLESTICK.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1B\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105521829526309879)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105521900961309879)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINEWITHAREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\ACFC \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105521355586309879)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C73C\B85C \B80C\B354\B9C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105241541780309652)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D604\C7AC \C791\C5C5\C744 \C2E4\D589\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D560 \ACBD\C6B0 \BCF4\B958 \C911\C778 \B2E4\B978 \BAA8\B4E0 \C791\C5C5\C758 \CC98\B9AC\B97C \C815\C9C0\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \D2B9\C815 \C791\C5C5\C758 \C2E4\D589 \C21C\C11C\B294 \AC01 \C791\C5C5\C5D0 \B300\D574 \C9C0\C815\B41C \C21C\C11C\C5D0 \B530\B77C \ACB0\C815\B429\B2C8\B2E4. \C791\C5C5\C774 \B3D9\C77C\D55C \C21C\C11C\B85C \C2E4\D589\B420 \C218 \C788\B3C4\B85D Oracle\C740 \BAA8\B4E0 True \C791\C5C5 \BC0F \BAA8\B4E0 False \C791\C5C5\C5D0 \B300\D574 \C21C\C11C \BC88\D638\B97C \B3D9\C77C\D558\AC8C \C124\C815\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105241470067309652)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \C2DC \C2E4\D589 \C815\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105318773857309712)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C124\C815 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105318846824309712)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C5F4 \B298\C774\AE30 \C5EC\BD80\B97C \C815\C758\D558\AE30 \C704\D574 \AD6C\C131\D55C <strong>\B298\C774\AE30</strong> \BCF4\ACE0\C11C \C124\C815\C744 \C5F4\C5D0 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105318228600309711)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDA9\BD84\D55C \D654\BA74 \ACF5\AC04\C774 \C788\C744 \ACBD\C6B0 \C5F4\C5D0 \B298\C774\AE30\B97C \C801\C6A9\D574\C57C \D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105318596819309712)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105318614552309712)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \AD6C\C131\D55C <strong>\B298\C774\AE30</strong> \BCF4\ACE0\C11C \C124\C815\C5D0 \AD00\ACC4\C5C6\C774 \D56D\C0C1 \C5F4\C5D0 \B298\C774\AE30\B97C \C801\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105318319035309712)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\C870\AC74 \BD80\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105318425957309712)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C5D0 \B298\C774\AE30\B97C \C801\C6A9\D558\C9C0 \C54A\ACE0 \D56D\C0C1 \C9C0\C815\B41C \B108\BE44\B9CC \C0AC\C6A9\D569\B2C8\B2E4. \C774\B294 \C608/\C544\B2C8\C624 \B610\B294 \C22B\C790\C640 \AC19\C774 \CF58\D150\CE20\AC00 \C9E7\C740 \C5F4\C5D0 \C720\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105318187855309711)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B298\C774\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105583399763309929)
,p_name=>'PE.PROPERTY.STRIP_HTML.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C6D0\BCF8 \C5F4 \AC12\C5D0\C11C HTML \D0DC\ADF8\B97C \C81C\AC70\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C774 \AE30\B2A5\C740 HTML \D45C\D604\C2DD\C744 \C0AC\C6A9\D558\AC70\B098, \C5F4 \B9C1\D06C\C5D0 \C0AC\C6A9\B418\AC70\B098, CSV \D30C\C77C\B85C \C775\C2A4\D3EC\D2B8\B418\B294 \C5F4\C758 \ACBD\C6B0 \D2B9\D788 \C911\C694\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774\BBF8 HTML \D0DC\ADF8\AC00 \D3EC\D568\B41C \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \AC12\C744 \C120\D0DD\D558\BA74 \D574\B2F9 \D0DC\ADF8\B85C \C778\D574 HTML \D45C\D604\C2DD\C5D0 \B300\D574 \C0DD\C131\B41C HTML \B610\B294 \C5F4 \B9C1\D06C\C5D0 \B300\D574 \C0DD\C131\B41C URL\ACFC \CDA9\B3CC\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \AC12\C744 \C775\C2A4\D3EC\D2B8\D560 \B54C\B294 \AE30\C874 HTML \D0DC\ADF8\AC00 \C0DD\C131\B41C CSV \D30C\C77C\C5D0 \C77C\BC18 \D14D\C2A4\D2B8\B85C \D3EC\D568\B429\B2C8\B2E4.'),
unistr('\C774 \C635\C158\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D558\BA74 \C5F4 \AC12\C758 \C2E4\C81C \B370\C774\D130 \BD80\BD84\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105583206373309929)
,p_name=>'PE.PROPERTY.STRIP_HTML.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \C2A4\D2B8\B9BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105439044134309810)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0 \D504\B85C\C138\C2F1\C5D0\C11C \D655\C778\B41C \D589\C744 \D3EC\D568\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C <strong>\C644\B8CC\B428\C73C\B85C \D45C\C2DC</strong>\C640 \AC19\C740 \C0AC\C6A9\C790\C815\C758 \B2E8\CD94\B85C \C2DC\C791\B429\B2C8\B2E4.'),
unistr('        \C774\B7EC\D55C \D655\C778\B41C \D589\C740 \C0AC\C6A9\C790\C815\C758 \D504\B85C\C138\C2A4\C5D0\C11C \D544\C694\D55C \C791\C5C5\C744 \C218\D589\D558\B294 \B370 \D65C\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \C120\D0DD\D55C \D589\C740 \D589\C5D0\C11C \C544\BB34\AC83\B3C4 \C5C5\B370\C774\D2B8\B418\C9C0 \C54A\C558\B354\B77C\B3C4 \CC98\B9AC\B429\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \C0BD\C785, \C5C5\B370\C774\D2B8 \B610\B294 \C0AD\C81C\B41C \D589\B9CC \CC98\B9AC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105438946044309810)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C \C2DC \C120\D0DD\D55C \D589 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105303757154309699)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CCB4\ACC4\C758 \C801\C6A9 \B300\C0C1\C774 \B418\B294 \C778\C99D \CCB4\ACC4\B97C \AC00\C9C0\B294 \C560\D50C\B9AC\CF00\C774\C158\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105303659597309699)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C5D0\C11C \C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105908084874310190)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\AC00 \C5F4\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\B294\C9C0 \C544\B2C8\BA74 HTML \D45C\D604\C2DD \BC0F \C9C0\C6D0\B418\B294 \B300\CCB4 \BB38\C790\C5F4\C744 \D1B5\D55C \ACE0\AE09 \D615\C2DD \C9C0\C815\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\B294\C9C0 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105907902798310190)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09 \D615\C2DD \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105908205918310191)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C81C\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105908181833310190)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105908779657310191)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105908625544310191)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105908577365310191)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\BC30\ACBD \BC0F \D14D\C2A4\D2B8 \C0C9\C0C1 \BCC0\ACBD</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\C81C\BAA9 2 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL \C9C8\C758\C5D0\C11C \B3D9\C801 \D074\B798\C2A4 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \C774 \C608\C5D0\C11C <code>&COLUMN_CLASS.</code> \BC0F <code>&EMPLOYEE_STATUS.</code> \B300\CCB4\B294 \BCF4\ACE0\C11C SQL \C9C8\C758\C5D0\C11C \C120\D0DD\B41C \C5F4\C785\B2C8\B2E4.</dd>'),
unistr('  <dt>\C774\BBF8\C9C0 \D45C\C2DC \BC0F \CEE4\C11C\B97C \C704\B85C \AC00\C838\AC08 \B54C \B3C4\AD6C \C124\BA85 \D45C\C2DC</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105908491639310191)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C5D0 \D45C\C2DC\D560 HTML \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4. <code>&COLUMN.</code> \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC HTML\C5D0 \C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105908348104310191)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105562815872309912)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D504\B85C\C138\C2A4\C5D0 \B300\D55C \C131\ACF5 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\D504\B85C\C138\C2A4\AC00 \C2E4\D589\B418\ACE0 \C624\B958\AC00 \BC1C\C0DD\D558\C9C0 \C54A\C73C\BA74 \C774 \D504\B85C\C138\C2A4\C758 \C131\ACF5 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B41C \ACB0\ACFC \D398\C774\C9C0\C758 \D1B5\C9C0 \C139\C158\C5D0 \D45C\C2DC\B429\B2C8\B2E4.'),
unistr('URL \C7AC\C9C0\C815\C744 \D1B5\D574 \B2E4\B978 \D398\C774\C9C0\B85C \BD84\AE30\D558\B294 \ACBD\C6B0\C5D0\B294 <em>\C131\ACF5 \BA54\C2DC\C9C0 \BCF4\C874</em> \C18D\C131\C744 \C120\D0DD\D574\C57C \D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C911 \D589 \D504\B85C\C138\C2A4\C758 \ACBD\C6B0 \B2E4\C74C \B300\CCB4 \BB38\C790\C5F4\C744 \C0AC\C6A9\D574\C11C \CC98\B9AC\B41C \B808\CF54\B4DC \C218\B97C \AC00\C838\C62C \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li>\C0BD\C785: <code>#MRI_COUNT#</code></li>'),
unistr('  <li>\C5C5\B370\C774\D2B8: <code>#MRU_COUNT#</code></li>'),
unistr('  <li>\C0AD\C81C: <code>#MRD_COUNT#</code></li>'),
'</ul>',
unistr('<p>\C804\C790\BA54\C77C \C804\C1A1 \D504\B85C\C138\C2A4 \C720\D615\C758 \ACBD\C6B0 \B300\CCB4 \BB38\C790\C5F4 <code>#TO#</code>\B97C \C0AC\C6A9\D574\C11C \C804\C790\BA54\C77C\C758 \C8FC\C18C\B97C \AC00\C838\C62C \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\D50C\B7EC\ADF8\C778\B3C4 \B2E4\B978 \B300\CCB4 \BB38\C790\C5F4\C744 \AC00\C9C8 \C218 \C788\C2B5\B2C8\B2E4. \C790\C138\D55C \B0B4\C6A9\C740 \D50C\B7EC\ADF8\C778 \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105717274133310046)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D504\B85C\C138\C2A4\AC00 \C131\ACF5\C801\C73C\B85C \C644\B8CC\B420 \B54C "\D1B5\C9C0" \C601\C5ED\C5D0 \D45C\C2DC\D560 \D14D\C2A4\D2B8(\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C758 \C77C\BD80\B85C \C815\C758\B428)\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105562306550309912)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105258804827309665)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C81C\C548\C0AC\D56D\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \AC12\C774 \BC18\D658\B41C \C21C\C11C\C5D0 \B530\B77C \AC12\C774 \D45C\C2DC\B418\B294 \C21C\C11C\AC00 \ACB0\C815\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105258702679309665)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105258642642309665)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C81C\C548\C0AC\D56D\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \C815\C801 \AC12\C744 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C73C\B85C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \AC12\C774 \C9C0\C815\B41C \C21C\C11C\C5D0 \B530\B77C \AC12\C774 \D45C\C2DC\B418\B294 \C21C\C11C\AC00 \ACB0\C815\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105258576139309665)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105260888708309667)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105261595396309667)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER_GROUP.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105257842367309664)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D544\D130\C5D0 \B300\D55C \C81C\C548\C0AC\D56D\C744 \ACB0\C815\D558\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C81C\ACF5\B41C \AC12\C740 \AC12 \BAA9\B85D\C758 \BCF4\C774\B294 \D56D\BAA9\C5D0 \B300\D574 \ACC4\C18D \AC80\C0AC\B418\ACE0 \C77C\CE58\D558\B294 \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.'),
unistr('\AC12\C744 \CC3E\C744 \C218 \C5C6\C73C\BA74 \AC74\B108\B6F0\ACE0 \B2E4\C74C \AC12\C744 \AC80\C0AC\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105257933904309664)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105258096677309664)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D\C5D0\C11C <strong>\CCAB\BC88\C9F8</strong> \BCF4\C774\B294 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105258389998309665)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105258415740309665)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>SQL \C9C8\C758</em>\C5D0\C11C \AC12\C774 \BC18\D658\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105258177906309665)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105258228736309665)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF64\B9C8\B85C \AD6C\BD84\B41C \AC12 \BAA9\B85D\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105257752744309664)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105526587693309883)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2E4\C6B4\B85C\B4DC \D30C\C77C \C0C1\B2E8\C5D0 \B098\D0C0\B098\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \D30C\C77C\C758 \B370\C774\D130\C5D0 \B300\D55C \B370\C774\D130 \BD84\B958, \BC95\C801 \B610\B294 \ACBD\ACE0 \BA54\C2DC\C9C0\B97C \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0 - \C785\B825\B41C \D14D\C2A4\D2B8\B294 \BAA8\B4E0 \BCF4\ACE0\C11C \B2E4\C6B4\B85C\B4DC \D615\C2DD\C5D0 \D3EC\D568\B429\B2C8\B2E4. CSV \B2E4\C6B4\B85C\B4DC\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B418\BA74 \C815\C758\B41C \D14D\C2A4\D2B8\AC00 CSV \D30C\C77C \D615\C2DD\C744 \BB34\D6A8\D654\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105526418553309883)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C644 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105541770529309895)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \BCF4\AE30\C5D0\C11C \C5F4 \BA38\B9AC\AE00 \D14D\C2A4\D2B8\B97C \B808\C774\BE14\B85C \C0AC\C6A9\D558\B824\BA74 \C774 \C18D\C131\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105541687492309895)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \BA38\B9AC\AE00 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105597012706309939)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D45C \D615\C2DD \D3FC \C5F4\C5D0 \B300\D55C \AE30\C900\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\C120\D0DD\C5D0 \B530\B77C \D45C \D615\C2DD \D3FC \B0B4\C5D0\C11C \C774 \C5F4\C774 \C5C5\B370\C774\D2B8 \AC00\B2A5\D55C\C9C0 \C5EC\BD80\AC00 \ACB0\C815\B429\B2C8\B2E4.'),
unistr('\B2E4\C911 \D589 \C5C5\B370\C774\D2B8\AC00 \C815\C758\B418\C5C8\AC70\B098 \C5C5\B370\C774\D2B8\B41C \B370\C774\D130\B97C \CC98\B9AC\D558\B3C4\B85D PL/SQL \D504\B85C\C138\C2A4\AC00 \AD6C\D604\B41C \ACBD\C6B0\C5D0\B9CC \C5C5\B370\C774\D2B8\B97C \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105764473037310081)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105932855566310212)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC\B97C \C785\B825\D558\AC70\B098 \B0A0\C9DC \C120\D0DD\AE30\B97C \C774\C6A9\D558\C5EC \B0A0\C9DC\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105764398574310081)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \C120\D0DD\AE30(\D074\B798\C2DD)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105932974991310212)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC\B97C \C785\B825\D558\AC70\B098 \B0A0\C9DC \C120\D0DD\AE30\B97C \C774\C6A9\D558\C5EC \B0A0\C9DC\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105764273877310081)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \D14D\C2A4\D2B8(\C0C1\D0DC \C800\C7A5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105931556075310208)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AC12\C744 \D45C\C2DC\D558\ACE0 \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\D569\B2C8\B2E4. \D398\C774\C9C0 \CC98\B9AC \C2DC \C774 \C5F4\C744 \D65C\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105765972289310082)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('BLOB \B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105931999221310211)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \D30C\C77C\C744 \B2E4\C6B4\B85C\B4DC\D560 \C218 \C788\B294 \B9C1\D06C\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105765409667310082)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\ACA8\C9C4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105933028222310212)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \D45C\C2DC\D558\C9C0 \C54A\C9C0\B9CC \D574\B2F9 \C5F4\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105764929166310082)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\ACA8\C9C4 \C5F4(\C0C1\D0DC \C800\C7A5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105933154949310212)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \D45C\C2DC\D558\C9C0 \C54A\C9C0\B9CC \D574\B2F9 \C5F4\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4. \D398\C774\C9C0 \CC98\B9AC \C2DC \C774 \C5F4\C744 \D65C\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105765899744310082)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105931816239310211)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \C774\BBF8\C9C0\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105765745890310082)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105931773232310208)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \B9C1\D06C\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105766053648310082)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C728 \ADF8\B798\D504')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105932036975310211)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \BC31\BD84\C728 \ADF8\B798\D504\B85C \D45C\C2DC\D569\B2C8\B2E4. \AC80\C0C9\B41C \AC12\C740 0\C5D0\C11C 100 \C0AC\C774\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105765574383310082)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105931481664310208)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105765617930310082)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \D14D\C2A4\D2B8(\AC12 \BAA9\B85D \AE30\C900)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105931681144310208)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \AC12 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105765067371310082)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 LOV(\BC18\D658 \AC12 \D45C\C2DC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105932529459310212)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5\C5D0\C11C \AC12\C744 \C120\D0DD\D569\B2C8\B2E4. \AC12 \BAA9\B85D\C758 \BC18\D658 \AC12\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105765169697310082)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 LOV(\D45C\C2DC \AC12 \D45C\C2DC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105932401220310212)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5\C5D0\C11C \AC12\C744 \C120\D0DD\D569\B2C8\B2E4. \AC12 \BAA9\B85D\C758 \D45C\C2DC \AC12\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105764802521310082)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B77C\B514\C624 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105932657738310212)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \AC12 \BAA9\B85D\C5D0\C11C \B2E8\C77C \B77C\B514\C624 \ADF8\B8F9\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105765354619310082)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105931322400310208)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01 \D589\C758 \C2DC\C791 \BD80\BD84\C5D0 \CCB4\D06C\BC15\C2A4\B97C \D3EC\D568\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105764711880310081)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105932335976310212)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \AC12 \BAA9\B85D\C5D0\C11C \AC12\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105765222833310082)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C21C \CCB4\D06C\BC15\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105932789056310212)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D558\AC70\B098 \C120\D0DD \D574\C81C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105764566765310081)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \D544\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105932118097310212)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \D544\B4DC\C5D0 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105764604063310081)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105932294749310212)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \C601\C5ED \D544\B4DC\C5D0 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105596929394309939)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105319878403309713)
,p_name=>'PE.PROPERTY.TARGET.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B2EC \B300\D654\C0C1\C790\B97C \D638\CD9C\D558\B824\B294 \B300\C0C1\C744 \B204\B985\B2C8\B2E4. \C774 \BD84\AE30\B97C \D638\CD9C\D560 \B54C \D638\CD9C\B418\B294 \B300\C0C1\C744 \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105319757377309713)
,p_name=>'PE.PROPERTY.TARGET.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105900388669310184)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\C758 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C0AC\C6A9\C790\AC00 \C815\C758\D560 \D15C\D50C\B9AC\D2B8 \C635\C158\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\B77C\C774\BE0C \D15C\D50C\B9AC\D2B8 \C635\C158</strong>\C744 \C0AC\C6A9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D560 \B54C \D15C\D50C\B9AC\D2B8 \C635\C158\C744 \C218\C815\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('\B77C\C774\BE0C \D15C\D50C\B9AC\D2B8 \C635\C158\C744 \C0AC\C6A9\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\C2DC\AC04\C73C\B85C \C0AC\C6A9\C790\C815\C758\D558\C5EC \B2E4\C591\D55C \C635\C158\C744 \BBF8\B9AC \BCF4\ACE0 \C801\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\B77C\C774\BE0C \D15C\D50C\B9AC\D2B8 \C635\C158\C5D0 \C561\C138\C2A4\D558\B824\BA74 \C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131\AE30\C5D0\C11C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D558\ACE0 \AC1C\BC1C\C790 \B3C4\AD6C \BAA8\C74C\C5D0\C11C <em>\BE60\B978 \D3B8\C9D1</em>\C744 \B204\B985\B2C8\B2E4.'),
unistr('\D398\C774\C9C0 \AD6C\C131\C694\C18C(\C608: \C601\C5ED) \C704\B85C \CEE4\C11C\B97C \AC00\C838\AC04 \B2E4\C74C \C0C1\B2E8 \C67C\CABD \BAA8\C11C\B9AC\C5D0 \D45C\C2DC\B418\B294 \B80C\CE58 \C544\C774\CF58( <span class="a-Icon icon-util" aria-hidden="true"></span> )\C744 \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105900237198310184)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105900597123310185)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\C758 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C0AC\C6A9\C790\AC00 \C815\C758\D560 \D15C\D50C\B9AC\D2B8 \C635\C158\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\B77C\C774\BE0C \D15C\D50C\B9AC\D2B8 \C635\C158</strong>\C744 \C0AC\C6A9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D560 \B54C \D15C\D50C\B9AC\D2B8 \C635\C158\C744 \C218\C815\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
unistr('\B77C\C774\BE0C \D15C\D50C\B9AC\D2B8 \C635\C158\C744 \C0AC\C6A9\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\C2DC\AC04\C73C\B85C \C0AC\C6A9\C790\C815\C758\D558\C5EC \B2E4\C591\D55C \C635\C158\C744 \BBF8\B9AC \BCF4\ACE0 \C801\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\B77C\C774\BE0C \D15C\D50C\B9AC\D2B8 \C635\C158\C5D0 \C561\C138\C2A4\D558\B824\BA74 \C560\D50C\B9AC\CF00\C774\C158 \C0DD\C131\AE30\C5D0\C11C \C560\D50C\B9AC\CF00\C774\C158\C744 \C2E4\D589\D558\ACE0 \AC1C\BC1C\C790 \B3C4\AD6C \BAA8\C74C\C5D0\C11C <em>\BE60\B978 \D3B8\C9D1</em>\C744 \B204\B985\B2C8\B2E4.'),
unistr('\D398\C774\C9C0 \AD6C\C131\C694\C18C(\C608: \C601\C5ED) \C704\B85C \CEE4\C11C\B97C \AC00\C838\AC04 \B2E4\C74C \C0C1\B2E8 \C67C\CABD \BAA8\C11C\B9AC\C5D0 \D45C\C2DC\B418\B294 \B80C\CE58 \C544\C774\CF58( <span class="a-Icon icon-util" aria-hidden="true"></span> )\C744 \B204\B985\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105900447331310184)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105148639199309584)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8 \B0B4\C758 \C704\CE58 \D45C\C2DC\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105148567547309584)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C704\CE58 \D45C\C2DC\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105581947226309928)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BCF4\ACE0\C11C\C5D0 \B300\D55C \D15C\D50C\B9AC\D2B8 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105761102996310079)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\B9AC \C815\C758\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105761227119310079)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8\C640 \C9C1\C811 \C5F0\AD00\B418\C9C0 \C54A\C740 \BBF8\B9AC \C815\C758\B41C \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C785\B2C8\B2E4. \BBF8\B9AC \C815\C758\B41C \D15C\D50C\B9AC\D2B8\C640 \D604\C7AC \D14C\B9C8 \C0AC\C774\C758 \C0C1\AD00 \AD00\ACC4\AC00 \C5C6\C73C\BBC0\B85C \C560\D50C\B9AC\CF00\C774\C158 \D14C\B9C8\B97C \BCC0\ACBD\D558\B354\B77C\B3C4 \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C774 \B3D9\C77C\D558\AC8C \C720\C9C0\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105760921949310079)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105761063099310079)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C758 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\C5D0 \B300\D55C \D604\C7AC \D14C\B9C8\B97C \AE30\C900\C73C\B85C \D574\B2F9 \D14C\B9C8\C5D0\C11C \C0AC\C6A9\D560 \C218 \C788\B294 \BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105581870328309927)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106089165409310355)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C0\C815\B41C <strong>\AC80\C0C9 \C720\D615</strong>\C5D0 \B530\B77C \D14D\C2A4\D2B8 \AC80\C0C9\C5D0 \C0AC\C6A9\B418\B294 \B370\C774\D130\BCA0\C774\C2A4 \C5F4 \C774\B984\C744 \D558\B098 \B610\B294 \BAA9\B85D\C73C\B85C \C785\B825\D569\B2C8\B2E4.</p>'),
'<ul>',
unistr('  <li><strong>\D589 \AC80\C0C9</strong>: \D14D\C2A4\D2B8 \AC80\C0C9\C5D0 \C0AC\C6A9\B418\B294 VARCHAR2 \C720\D615\C758 \B370\C774\D130\BCA0\C774\C2A4 \C5F4 \C774\B984(\B300\C18C\BB38\C790 \AD6C\BD84)\C744 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C73C\B85C \C785\B825\D569\B2C8\B2E4. \C9C0\C815\B41C \C5F4\C774 \C5C6\C73C\BA74 \BAA8\B4E0 VARCHAR2 \C5F4\C774 \C790\B3D9\C73C\B85C \C0AC\C6A9\B429\B2C8\B2E4.</li>'),
unistr('  <li><strong>Oracle Text</strong>: Oracle Text \C778\B371\C2A4\B97C \D3EC\D568\D558\B294 \B370\C774\D130\BCA0\C774\C2A4 \C5F4 \C774\B984(\B300\C18C\BB38\C790 \AD6C\BD84)\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106089008167310355)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105360910167309743)
,p_name=>'PE.PROPERTY.THEME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\C640 \C5F0\AD00\C2DC\D0AC \D14C\B9C8\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105360838217309743)
,p_name=>'PE.PROPERTY.THEME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105508847519309868)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\D68D \C601\C5ED\ACFC \C0C1\B300\C801\C778 \B208\AE08 \B808\C774\BE14\C758 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105509077127309868)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.INSIDE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\BD80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105508960393309868)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.OUTSIDE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\BD80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105508782252309868)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105508430303309868)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B208\AE08 \B808\C774\BE14\C774 \B80C\B354\B9C1\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105508326019309868)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105508660367309868)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\CD95\C5D0 \B354 \B9CE\C740 \B808\C774\BE14\C744 \B9DE\CD94\AE30 \C704\D574 \CC28\D2B8\C5D0\C11C \B808\C774\BE14\C744 \C790\B3D9\C73C\B85C 90\B3C4 \D68C\C804\C2DC\D0A4\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('        \D68C\C804\C740 \AC00\B85C \CD95\C5D0 \B300\D55C \BC94\C8FC \B808\C774\BE14\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105508532578309868)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D68C\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105879207116310168)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0E0\B2E4\B4DC\C640 \B3D9\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106010055929310280)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1D\C74C \BC0F \C5B4\B450\C6C0 \BAA8\B4DC\C5D0 \B3D9\C77C\D55C \BC31\ADF8\B77C\C6B4\B4DC \B9F5\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105833893245310134)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B4\B461\AC8C \BAA8\B4DC\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B418\C5C8\C744 \B54C \BC31\ADF8\B77C\C6B4\B4DC \B9F5\C73C\B85C \C0AC\C6A9\D560 \D0C0\C77C \CE35\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105834775680310134)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.D'
,p_message_language=>'ko'
,p_message_text=>'Oracle BI World Map'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105834821420310134)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>HERE \B9F5 \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \B2E8\C21C\D654\B41C \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130\C758 \C704\CE58 \CEE8\D14D\C2A4\D2B8\B97C \C81C\ACF5\D558\ACE0 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>\BBF8\AD6D \C624\B77C\D074\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105834364658310134)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('OpenStreetMap \BC1D\AC8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105834412036310134)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>OpenStreetMap \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \BC94\C6A9 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5\C740 \D574\B2F9 \B370\C774\D130\C758 \C790\C138\D55C \C704\CE58 \CEE8\D14D\C2A4\D2B8\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>"Mapbox Open Styles"\C5D0\C11C \D30C\C0DD\B41C KlokanTech.com & OpenMapTiles \C81C\ACF5\C790\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4. BSD/CC-BY \B77C\C774\C13C\C2A4\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">GitHub\C5D0\C11C \BCF4\AE30</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105833961261310134)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('OpenStreetMap \C5B4\B461\AC8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105834004266310134)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \B2E8\C21C\D654\B41C \BC1D\C740 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>"Mapbox Open Styles"\C5D0\C11C \D30C\C0DD\B41C KlokanTech.com & OpenMapTiles \C81C\ACF5\C790\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4. BSD/CC-BY \B77C\C774\C13C\C2A4\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4. Stamen Design\C758 \C9C0\B3C4\C81C\C791\C740 CC0\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">GitHub\C5D0\C11C \BCF4\AE30</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105834193185310134)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('OpenStreetMap \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105834253427310134)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \B2E8\C21C\D654\B41C \C5B4\B450\C6B4 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>"Mapbox Open Styles"\C5D0\C11C \D30C\C0DD\B41C KlokanTech.com & OpenMapTiles \C81C\ACF5\C790\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4. BSD/CC-BY \B77C\C774\C13C\C2A4\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4. Stamen Design\C758 \C9C0\B3C4\C81C\C791\C740 CC0\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">GitHub\C5D0\C11C \BCF4\AE30</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105834525134310134)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.D'
,p_message_language=>'ko'
,p_message_text=>'Oracle World Map'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105834609800310134)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>HERE \B9F5 \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \BC94\C6A9 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130\C758 \C704\CE58 \CEE8\D14D\C2A4\D2B8\B97C \C81C\ACF5\D558\ACE0 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>\BBF8\AD6D \C624\B77C\D074\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105833799747310134)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B4\B461\AC8C \BAA8\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105832682272310133)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC31\ADF8\B77C\C6B4\B4DC \B9F5\C73C\B85C \C0AC\C6A9\D560 \D0C0\C77C \CE35\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105833574291310133)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.D'
,p_message_language=>'ko'
,p_message_text=>'Oracle BI World Map'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105833654309310133)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>HERE \B9F5 \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \B2E8\C21C\D654\B41C \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130\C758 \C704\CE58 \CEE8\D14D\C2A4\D2B8\B97C \C81C\ACF5\D558\ACE0 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>\BBF8\AD6D \C624\B77C\D074\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105833107572310133)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('OpenStreetMap \BC1D\AC8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105833232946310133)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>OpenStreetMap \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \BC94\C6A9 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5\C740 \D574\B2F9 \B370\C774\D130\C758 \C790\C138\D55C \C704\CE58 \CEE8\D14D\C2A4\D2B8\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>"Mapbox Open Styles"\C5D0\C11C \D30C\C0DD\B41C KlokanTech.com & OpenMapTiles \C81C\ACF5\C790\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4. BSD/CC-BY \B77C\C774\C13C\C2A4\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">GitHub\C5D0\C11C \BCF4\AE30</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105832907240310133)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('OpenStreetMap \C5B4\B461\AC8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105833005687310133)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \B2E8\C21C\D654\B41C \C5B4\B450\C6B4 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>"Mapbox Open Styles"\C5D0\C11C \D30C\C0DD\B41C KlokanTech.com & OpenMapTiles \C81C\ACF5\C790\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4. BSD/CC-BY \B77C\C774\C13C\C2A4\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4. Stamen Design\C758 \C9C0\B3C4\C81C\C791\C740 CC0\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">GitHub\C5D0\C11C \BCF4\AE30</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105832759025310133)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('OpenStreetMap \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105832865005310133)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \B2E8\C21C\D654\B41C \BC1D\C740 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>"Mapbox Open Styles"\C5D0\C11C \D30C\C0DD\B41C KlokanTech.com & OpenMapTiles \C81C\ACF5\C790\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4. BSD/CC-BY \B77C\C774\C13C\C2A4\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4. Stamen Design\C758 \C9C0\B3C4\C81C\C791\C740 CC0\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">GitHub\C5D0\C11C \BCF4\AE30</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105833388720310133)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.D'
,p_message_language=>'ko'
,p_message_text=>'Oracle World Map'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105833406348310133)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>HERE \B9F5 \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \BC94\C6A9 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130\C758 \C704\CE58 \CEE8\D14D\C2A4\D2B8\B97C \C81C\ACF5\D558\ACE0 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>\BBF8\AD6D \C624\B77C\D074\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105832581655310133)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105832076298310132)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\D560 \BC31\ADF8\B77C\C6B4\B4DC \B9F5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105832369708310132)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105832481031310133)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC31\ADF8\B77C\C6B4\B4DC \B9F5\C5D0 \C0AC\C6A9\D560 \B9F5 \D0C0\C77C \CE35\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105832179748310132)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105832208183310132)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BC31\ADF8\B77C\C6B4\B4DC \B9F5 \C124\C815\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105831949163310132)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105609687856309949)
,p_name=>'PE.PROPERTY.TIME_FORMAT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04 \D615\C2DD\C744 \D45C\C2DC\D560 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105769401271310085)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.12HOUR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('12\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105769573425310085)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.24HOUR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('24\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105609517949309949)
,p_name=>'PE.PROPERTY.TIME_FORMAT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106098331260310363)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95\C5D0 \B300\D55C \C81C\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774 \C81C\BAA9\C740 \CC28\D2B8\C758 \CD95\C5D0 \D45C\C2DC\B418\B294 \C815\BCF4\B97C \C124\BA85\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105249034114309658)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE0C\B77C\C6B0\C800 \CC3D\C758 \C81C\BAA9 \D45C\C2DC\C904\C5D0 \D45C\C2DC\D560 \C81C\BAA9\C744 \C785\B825\D569\B2C8\B2E4. &PRODUCT_NAME. \C5D4\C9C4\C740 \C5EC\AE30\C5D0 \C9C0\C815\B41C \C81C\BAA9\C744 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C5D0 \C0AC\C6A9\B41C <code>#TITLE#</code> \B300\CCB4 \BB38\C790\C5F4 \B300\C2E0 \C0AC\C6A9\D569\B2C8\B2E4. \C774 \C81C\BAA9\C740 HTML \D0DC\ADF8 <code>&lt;TITLE&gt;</code>\ACFC <code>&lt;/TITLE&gt;</code> \C0AC\C774\C5D0 \C0BD\C785\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105249968739309659)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C81C\BAA9\C744 \C785\B825\D558\C2ED\C2DC\C624. \C601\C5ED \C81C\BAA9\C740 \C601\C5ED \D15C\D50C\B9AC\D2B8\C5D0 \C815\C758\B418\C5B4 \C788\C744 \B54C\B9CC \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105211323133309630)
,p_name=>'PE.PROPERTY.TITLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \D398\C774\C9C0 \C81C\BAA9\C740 \BE0C\B77C\C6B0\C800 \CC3D\C758 \C81C\BAA9 \D45C\C2DC\C904\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105211282321309630)
,p_name=>'PE.PROPERTY.TITLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105907175384310190)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\AC00 \C5F4\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\B294\C9C0 \C544\B2C8\BA74 HTML \D45C\D604\C2DD \BC0F \C9C0\C6D0\B418\B294 \B300\CCB4 \BB38\C790\C5F4\C744 \D1B5\D55C \ACE0\AE09 \D615\C2DD \C9C0\C815\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\B294\C9C0 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105907028336310190)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09 \D615\C2DD \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105907396496310190)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9\C73C\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105907277542310190)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105907896751310190)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\C5D0 \CD94\AC00\D560 \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4. \ACF5\BC31\C73C\B85C \AD6C\BD84\D558\C5EC \C5EC\B7EC \D074\B798\C2A4\B97C \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105907796162310190)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105907638467310190)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\BC30\ACBD \BC0F \D14D\C2A4\D2B8 \C0C9\C0C1 \BCC0\ACBD</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\C81C\BAA9 2 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL \C9C8\C758\C5D0\C11C \B3D9\C801 \D074\B798\C2A4 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \C774 \C608\C5D0\C11C <code>&COLUMN_CLASS.</code> \BC0F <code>&EMPLOYEE_STATUS.</code> \B300\CCB4\B294 \BCF4\ACE0\C11C SQL \C9C8\C758\C5D0\C11C \C120\D0DD\B41C \C5F4\C785\B2C8\B2E4.</dd>'),
unistr('  <dt>\C774\BBF8\C9C0 \D45C\C2DC \BC0F \CEE4\C11C\B97C \C704\B85C \AC00\C838\AC08 \B54C \B3C4\AD6C \C124\BA85 \D45C\C2DC</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105907514720310190)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C5D0 \D45C\C2DC\D560 HTML \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4. <code>&COLUMN.</code> \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC HTML\C5D0 \C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105907402826310190)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105460615515309828)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\AD6C \BAA8\C74C\C5D0 \D45C\C2DC\D560 \CD94\AC00 \CF58\D2B8\B864\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105461154800309829)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BA54\B274')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105461209062309829)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18\C801\C73C\B85C \D3EC\AD04\C801\C778 \C635\C158 \C9D1\D569\C774 \D3EC\D568\B41C \C791\C5C5 \BA54\B274 \B2E8\CD94\B97C \D45C\C2DC\D569\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\B294 \C774\B7EC\D55C \C635\C158\C744 \C0AC\C6A9\D558\C5EC \C81C\ACF5\B41C \AE30\B2A5\C5D0 \B530\B77C \BCF4\ACE0\C11C\B97C \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105461315922309829)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\C815 \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105461429598309829)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\C815 \B2E8\CD94\B97C \D45C\C2DC\D569\B2C8\B2E4. \C774 \B2E8\CD94\B97C \B204\B974\BA74 \D544\D130, \C5F4 \B108\BE44 \BC0F \C21C\C11C \C9C0\C815\ACFC \AC19\C740 \BAA8\B4E0 \C0AC\C6A9\C790\C815\C758\AC00 \C81C\AC70\B418\ACE0, \BCF4\ACE0\C11C \C815\C758\AC00 \C11C\BC84\C5D0\C11C \B2E4\C2DC \B85C\B4DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105461517970309829)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5 \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105461645138309829)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C800\C7A5 \B2E8\CD94\B97C \D45C\C2DC\D569\B2C8\B2E4. \C804\CCB4 \D398\C774\C9C0\B97C \C800\C7A5\D560 \D544\C694 \C5C6\C774 \C774 \B2E8\CD94\B97C \B204\B974\BA74 \C774 \B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0 \C218\D589\B41C \BCC0\ACBD\C0AC\D56D\B9CC \C800\C7A5\B429\B2C8\B2E4.'),
unistr('        <p>\C800\C7A5 \B2E8\CD94\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC\AC00 \D3B8\C9D1 \AC00\B2A5\C77C \B54C\B9CC \D45C\C2DC\B418\ACE0, \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \CD94\AC00, \C5C5\B370\C774\D2B8 \B610\B294 \C0AD\C81C \AD8C\D55C\C774 \BD80\C5EC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105460787887309828)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \C5F4 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105460846298309828)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\B41C \BE44\C22B\C790 \C5F4\C758 \B4DC\B86D\B2E4\C6B4 \BAA9\B85D\C744 \D45C\C2DC\D569\B2C8\B2E4. \C5F4\C774 \C120\D0DD\B41C \ACBD\C6B0 \C120\D0DD\B41C \C5F4\C5D0 \C788\B294 \AC12\C5D0 \B300\D574\C11C\B9CC \AC80\C0C9\C774 \C218\D589\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105460988132309828)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \D544\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105461094077309829)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \C870\AC74 \C785\B825\C5D0 \C0AC\C6A9\B418\B294 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C5D0 \D14D\C2A4\D2B8 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105460581999309828)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D2B8\B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106023169657310293)
,p_name=>'PE.PROPERTY.TREE_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105927692591310205)
,p_name=>'PE.PROPERTY.TREE_SQL_STATEMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106023239287310293)
,p_name=>'PE.PROPERTY.TREE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105565060355309914)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C774 \C2DC\AC04\B300 \C778\C2DD \C5F4\C778\C9C0 \C5EC\BD80\B97C \B098\D0C0\B0C5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105564989107309914)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04\B300 \C778\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105598301860309940)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \BCF4\ACE0\C11C \C5F4\C774 \CC38\C870\D558\B294 \C5F4 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C774 \C18D\C131\C740 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \AE30\BCF8\AC12\C744 \C0AC\C6A9\D558\B294 \C560\D50C\B9AC\CF00\C774\C158 \AC04\C5D0 \C5F4\C5D0 \B300\D55C \CC38\C870\B97C \BE44\AD50\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.'),
unistr('\C774 \CC38\C870\B294 \AC00\B2A5\D560 \B54C\B9C8\B2E4 \B9C8\BC95\C0AC\C5D0 \C758\D574 \CD08\AE30\D654\B41C \C774\D6C4 \C218\B3D9\C73C\B85C \C720\C9C0 \AD00\B9AC\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105598299070309940)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105598146389309940)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \C5F4\C774 \CC38\C870\D558\B294 \D14C\C774\BE14 \B610\B294 \BDF0\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C774 \C18D\C131\C740 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \AE30\BCF8\AC12\C744 \C0AC\C6A9\D558\B294 \C560\D50C\B9AC\CF00\C774\C158 \AC04\C5D0 \C5F4\C5D0 \B300\D55C \CC38\C870\B97C \BE44\AD50\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.'),
unistr('\C774 \CC38\C870\B294 \AC00\B2A5\D560 \B54C\B9C8\B2E4 \B9C8\BC95\C0AC\C5D0 \C758\D574 \CD08\AE30\D654\B41C \C774\D6C4 \C218\B3D9\C73C\B85C \C720\C9C0 \AD00\B9AC\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105598010821309940)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105597959697309940)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\CC38\C870 \D14C\C774\BE14\C744 \C18C\C720\D558\B294 \C2A4\D0A4\B9C8\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C774 \C18D\C131\C740 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \AE30\BCF8\AC12\C744 \C0AC\C6A9\D558\B294 \C560\D50C\B9AC\CF00\C774\C158 \AC04\C5D0 \C5F4\C5D0 \B300\D55C \CC38\C870\B97C \BE44\AD50\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.'),
unistr('\C774 \CC38\C870\B294 \AC00\B2A5\D560 \B54C\B9C8\B2E4 \B9C8\BC95\C0AC\C5D0 \C758\D574 \CD08\AE30\D654\B41C \C774\D6C4 \C218\B3D9\C73C\B85C \C720\C9C0 \AD00\B9AC\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105597829748309940)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105549808982309902)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B9C1\D06C \C5F4\C744 \C0AC\C6A9\D560 \B54C \D604\C7AC \C5F4\C744 \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5F4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\AE30\BCF8\C801\C73C\B85C <strong>ROWID</strong>\B97C \C0AC\C6A9\D574\C11C \BCF4\ACE0\C11C\C758 \D589\C744 \ACE0\C720\D558\AC8C \C2DD\BCC4\D569\B2C8\B2E4. \D558\C9C0\B9CC <strong>\ACE0\C720 \C5F4</strong>\C744 \C120\D0DD\D574\C11C \B2E4\B978 \C5F4\C744 \C0AC\C6A9\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105750030327310070)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105749957993310070)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.ROWID.D'
,p_message_language=>'ko'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105549786070309902)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \ACE0\C720 \C2DD\BCC4 \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105550063757309902)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D574 \D589\C744 \ACE0\C720\D558\AC8C \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\B418\B294 \CCAB\BC88\C9F8 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>ROWID</strong>\B294 \C5ED \D638\D658\C131\C744 \C704\D574 \C0AC\C6A9 \AC00\B2A5\D55C \C5F4 \BAA9\B85D\C5D0\B3C4 \D3EC\D568\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: <em>\B9C1\D06C \C5F4</em> \C18D\C131\C774 <strong>\B2E8\C77C \D589 \BCF4\AE30\C5D0 \B300\D55C \B9C1\D06C</strong>\B85C \C124\C815\B41C \B300\D654\C2DD \BCF4\ACE0\C11C\C758 \ACBD\C6B0 \B2E8\C77C \ACE0\C720 \C5F4\B9CC \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4. \B2E4\B978 \AD6C\C131\C694\C18C\C5D0\C11C\B294 \CD5C\B300 3\AC1C\AE4C\C9C0 \C5F4 \C120\D0DD\C774 \C9C0\C6D0\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105549973062309902)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105550227386309902)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D574 \D589\C744 \ACE0\C720\D558\AC8C \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\D560 \B450\BC88\C9F8 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \D14C\C774\BE14\C5D0 \B450 \BD80\BD84\C73C\B85C \AD6C\C131\B41C \AE30\BCF8 \D0A4\AC00 \D3EC\D568\B41C \ACBD\C6B0 \C774 \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>ROWID</strong>\B294 \C5ED \D638\D658\C131\C744 \C704\D574 \C0AC\C6A9 \AC00\B2A5\D55C \C5F4 \BAA9\B85D\C5D0\B3C4 \D3EC\D568\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105550196829309902)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \C5F4 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105550452708309903)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AD6C\C131\C694\C18C\C5D0 \B300\D574 \D589\C744 \ACE0\C720\D558\AC8C \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\D560 \C138\BC88\C9F8 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \D14C\C774\BE14\C5D0 \C138 \BD80\BD84\C73C\B85C \AD6C\C131\B41C \AE30\BCF8 \D0A4\AC00 \D3EC\D568\B41C \ACBD\C6B0 \C774 \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>ROWID</strong>\B294 \C5ED \D638\D658\C131\C744 \C704\D574 \C0AC\C6A9 \AC00\B2A5\D55C \C5F4 \BAA9\B85D\C5D0\B3C4 \D3EC\D568\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \D14C\C774\BE14\C758 \AE30\BCF8 \D0A4\C5D0 \D3EC\D568\B41C \C5F4\C774 3\AC1C\B97C \B118\C73C\BA74 <strong>ROWID</strong>\B97C \C0AC\C6A9\D574\C11C \D589\C744 \ACE0\C720\D558\AC8C \C2DD\BCC4\D574\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105550395661309903)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \C5F4 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105437855901309809)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D589\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C788\B294 \C0AC\C6A9\C790\B97C \C81C\D55C\D558\AE30 \C704\D55C \AD8C\D55C \BD80\C5EC \CCB4\ACC4\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \D589\C744 \C5C5\B370\C774\D2B8\D558\B824\BA74 \C774 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \D574\B2F9 \C0AC\C6A9\C790\C5D0 \B300\D574 TRUE\B85C \D3C9\AC00\B418\C5B4\C57C \D569\B2C8\B2E4.'),
unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \C81C\ACF5\B418\C9C0 \C54A\C73C\BA74 \BAA8\B4E0 \C0AC\C6A9\C790\AC00 \C774 \B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0\C11C \D589\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105437775362309809)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105325398323309717)
,p_name=>'PE.PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C758 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105325226760309717)
,p_name=>'PE.PROPERTY.USER_INTERFACE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105359950674309743)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0 \B300\D55C \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4. \C8FC\B85C \B370\C2A4\D06C\D1B1 \C0AC\C6A9\C744 \C704\D574 \B514\C790\C778\B41C \D398\C774\C9C0\C758 \ACBD\C6B0 <strong>\B370\C2A4\D06C\D1B1</strong>\C744 \C120\D0DD\D569\B2C8\B2E4. \C2A4\B9C8\D2B8\D3F0 \B610\B294 \D0DC\BE14\B9BF\ACFC \AC19\C740 \B2E4\B978 \C778\D130\D398\C774\C2A4\C758 \ACBD\C6B0\C5D0\B294 \D574\B2F9 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105744194002310066)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.DESKTOP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C2A4\D06C\D1B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105744299350310066)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.JQM_SMARTPHONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('jQuery \BAA8\BC14\C77C \C2A4\B9C8\D2B8\D3F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105359888824309742)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105575026098309922)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C5F4\C744 \D589 \BA38\B9AC\AE00\C5D0\B3C4 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C5F4 \AC12\C744 \D3EC\D568\D558\BA74 \BCF4\ACE0\C11C\C5D0\C11C \B80C\B354\B9C1\B41C \D3FC \D544\B4DC\C5D0 \B300\D55C \C811\ADFC\C131\C774 \D06C\AC8C \D5A5\C0C1\B420 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C9C0\C815\B41C \ACBD\C6B0\C5D0\B294 \D589 \BA38\B9AC\AE00\C774 \C5F4 \BA38\B9AC\AE00\ACFC \D568\AED8 \C0AC\C6A9\B418\C5B4 <code>''&lt;Column Header&gt; : &lt;Row Header&gt;''</code> \D615\C2DD\C744 \C0AC\C6A9\D574\C11C \BCF4\ACE0\C11C\C758 \D3FC \D544\B4DC\C5D0 \B300\D574 \B808\C774\BE14\C774 \B80C\B354\B9C1\B429\B2C8\B2E4.</p>'),
unistr('<p>\C608\B97C \B4E4\C5B4, EMP \D14C\C774\BE14\C5D0 \BCF4\ACE0\C11C\AC00 \C788\ACE0 ENAME \C5F4\C744 \D589 \BA38\B9AC\AE00\B85C \C815\C758\D55C\B2E4\ACE0 \AC00\C815\D574\BCF4\C2ED\C2DC\C624. ENAME\C774 ''JONES''\C778 \D589\C758 \ACBD\C6B0, \D574\B2F9 \D589\C5D0 \C788\B294 Salary \D544\B4DC\C5D0 \B300\D55C \B808\C774\BE14\C740 "Salary : JONES"\AC00 \B429\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \BC29\C2DD\C5D0 \B530\B77C \C2A4\D06C\B9B0 \B9AC\B354 \C0AC\C6A9\C790\B294 \BCF4\ACE0\C11C\C758 \D3FC \D544\B4DC\B97C \B530\B77C \C774\B3D9\D558\ACE0 \C5B4\B5A4 \D3FC \D544\B4DC\AC00 \C5B4\B5A4 \D589\ACFC \AD00\B828\B418\C5B4 \C788\B294\C9C0 \ACC4\C18D \D30C\C545\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105574950426309922)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BA38\B9AC\AE00\B85C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105603309679309944)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \BCF4\AE30\C5D0 \B300\D574 \C0AC\C6A9\C790\C815\C758 \B9C1\D06C\B97C \C815\C758\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C774 \C635\C158\C744 \C0AC\C6A9\D558\BA74 \B450 \AC1C \C774\C0C1\C758 \C5F4\C744 \C0AC\C6A9\D558\B294 \AE30\B2A5\C744 \D3EC\D568\D574\C11C \C544\C774\CF58 \BCF4\AE30\C758 \CF58\D150\CE20\B97C \BCF4\B2E4 \C720\C5F0\D558\AC8C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105603269683309944)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105322430053309715)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C5D0 \B300\D55C \C5F0\AD00\B41C \C601\C5ED\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105322339389309714)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1 \AC00\B2A5 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105320929474309713)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \AC80\C99D\C5D0 \B300\D574 \D14C\C2A4\D2B8\D560 \D488\C9C8 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4. \C120\D0DD\C5D0 \B530\B77C \C774 \AC80\C99D\C744 \C644\C804\D788 \C815\C758\D558\B824\BA74 \D558\B098 \C774\C0C1\C758 \CD94\AC00 \C18D\C131\C774 \D544\C694\D569\B2C8\B2E4.</p>'),
unistr('<p>\AC80\C99D\C73C\B85C \D488\C9C8 \D14C\C2A4\D2B8\AC00 \C804\B2EC\B418\AC70\B098 \AC80\C99D\C774 TRUE\B85C \D3C9\AC00\B418\BA74 \AC80\C99D \C624\B958 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('\AC80\C99D\C774 \D488\C9C8 \D14C\C2A4\D2B8\B97C \C2E4\D328\D558\AC70\B098 FALSE\B85C \D3C9\AC00\B418\AC70\B098 \BE44\C5B4 \C788\C9C0 \C54A\C740 \D14D\C2A4\D2B8 \BB38\C790\C5F4\C774 \BC18\D658\B418\BA74 \AC80\C99D \C624\B958 \BA54\C2DC\C9C0\AC00 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\AC80\C99D\C774 \C2E4\D328\D574\B3C4 \D6C4\C18D \AC80\C99D \C2E4\D589\C774 \C815\C9C0\B418\C9C0\B294 \C54A\C73C\BBC0\B85C \AC01 \D6C4\C18D \AC80\C99D\C73C\B85C \C778\D574 \CD94\AC00\C801\C778 \AC80\C99D \C624\B958 \BA54\C2DC\C9C0\AC00 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4. \D6C4\C18D \AC80\C99D\C774 \C2E4\D589\B418\C9C0 \C54A\B3C4\B85D \D558\B824\BA74 \D398\C774\C9C0 \D56D\BAA9\C744 \D2B9\C815 \AC12\C73C\B85C \C124\C815\D55C \D6C4 \D544\C694\C5D0 \B530\B77C \D6C4\C18D \AC80\C99D\C5D0 \B300\D55C \C870\AC74\BD80 \B17C\B9AC\B97C \C801\C6A9\D558\B294 \B4F1 \CCAB\BC88\C9F8 \C2E4\D328\D55C \AC80\C99D\C5D0 \B17C\B9AC\B97C \CD94\AC00\D574\C57C \D569\B2C8\B2E4. \D558\B098 \C774\C0C1\C758 \AC80\C99D\C5D0 \B300\D55C \D3C9\AC00\AC00 \C2E4\D328\D558\BA74 \D6C4\C18D \D504\B85C\C138\C2A4 \BC0F \BD84\AE30\AC00 \C2E4\D589\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105777636131310091)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \BC18\D658\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105777779219310091)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL \C9C8\C758\AC00 \D589\C744 \D558\B098 \C774\C0C1 \BC18\D658\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('SQL \C9C8\C758\AC00 \D589\C744 \BC18\D658\D558\C9C0 \C54A\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105983812228310256)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105983983180310256)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D45C\D604\C2DD\C774 TRUE\B85C \D3C9\AC00\B418\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D45C\D604\C2DD\C774 FALSE\B85C \D3C9\AC00\B418\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105778289278310092)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38(\BD80\C6B8 \BC18\D658)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105778309289310092)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D568\C218 \BCF8\BB38\C774 TRUE\B97C \BC18\D658\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D568\C218 \BCF8\BB38\C774 FALSE\B97C \BC18\D658\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.<br>'),
unistr('\CC38\ACE0: \D568\C218\C5D0\C11C \BC18\D658\B418\B294 \ACB0\ACFC\B294 \BD80\C6B8\C774\C5B4\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105778413881310092)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BCF8\BB38(\C624\B958 \D14D\C2A4\D2B8 \BC18\D658)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105778578357310092)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D568\C218 \BCF8\BB38\C774 \BE48 \BB38\C790\C5F4\C744 \BC18\D658\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D568\C218 \BCF8\BB38\C774 \BE44\C5B4 \C788\C9C0 \C54A\C740 \BB38\C790\C5F4\C744 \BC18\D658\D558\BA74 \C2E4\D328\D569\B2C8\B2E4. \BC18\D658\B41C \BB38\C790\C5F4\C740 \AC80\C99D\C5D0 \B300\D55C \C624\B958 \BA54\C2DC\C9C0\B85C \D45C\C2DC\B429\B2C8\B2E4.<br>'),
unistr('\CC38\ACE0: \D568\C218\C5D0\C11C \BC18\D658\B418\B294 \ACB0\ACFC\B294 \D14D\C2A4\D2B8 \BB38\C790\C5F4\C774\C5B4\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105779201049310092)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \ACF5\BC31\C744 \D3EC\D568\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105779353128310092)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 \ACF5\BC31\C744 \D3EC\D568\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 \ACF5\BC31\C744 \D3EC\D568\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105781251586310094)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \AC12\C5D0 \C788\B294 \BB38\C790 \C911 \D558\B098 \C774\C0C1\C744 \D3EC\D568\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105781321600310094)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C758 \BB38\C790\B97C \D558\B098 \C774\C0C1 \D3EC\D568\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C758 \BB38\C790\B97C \D3EC\D568\D558\C9C0 \C54A\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105781443935310094)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \AC12\C5D0 \C788\B294 \BB38\C790\B97C \D3EC\D568\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105781542359310094)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C758 \BB38\C790\B97C \D3EC\D568\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C758 \BB38\C790\B97C \D558\B098 \C774\C0C1 \D3EC\D568\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105781073539310094)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \AC12\C5D0 \C9C0\C815\B41C \BB38\C790\B9CC \D3EC\D568\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105781184664310094)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C788\B294 \BB38\C790\B9CC \D3EC\D568\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C788\C9C0 \C54A\B294 \BB38\C790\B97C \D3EC\D568\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105780248721310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 = \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105780348765310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105780608460310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \AC12\C5D0 \D3EC\D568\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105780757314310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C644\C804\D788 \D3EC\D568\B418\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C644\C804\D788 \D3EC\D568\B418\C9C0 \C54A\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105780493603310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 != \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105780598624310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C640 \B3D9\C77C\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105780829064310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \AC12\C5D0 \D3EC\D568\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105780937825310094)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C644\C804\D788 \D3EC\D568\B418\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0 \C644\C804\D788 \D3EC\D568\B418\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105779449382310092)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C601\C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105779500314310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 \BB38\C790 \BC0F \C22B\C790\B9CC \D3EC\D568\D558\ACE0 \D2B9\C218 \BB38\C790\B97C \D3EC\D568\D558\C9C0 \C54A\B294 \C601\C22B\C790\C774\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 \D2B9\C218 \BB38\C790\B97C \D3EC\D568\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105779885407310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C801\D569\D55C \B0A0\C9DC\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105779955944310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 \C801\D569\D55C \B0A0\C9DC\C774\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 \C801\D569\D55C \B0A0\C9DC\AC00 \C544\B2C8\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105779646195310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105779722460310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 \C22B\C790\C774\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 \C120\D589 \ACF5\BC31 \C774\C678\C758 \ACF5\BC31\C744 \D3EC\D568\D55C \BE44\C22B\C790 \BB38\C790\B97C \D3EC\D568\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105780069398310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C801\D569\D55C \C2DC\AC04\AE30\B85D\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105780145832310093)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 \C801\D569\D55C \C2DC\AC04\AE30\B85D\C774\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 \C801\D569\D55C \C2DC\AC04\AE30\B85D\C774 \C544\B2C8\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105778625692310092)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105778723087310092)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 \BE44\C5B4 \C788\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 \BE44\C5B4 \C788\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105778875527310092)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \B110\C774 \C544\B2C8\AC70\B098 0\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105778924563310092)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 \BE44\C5B4 \C788\C9C0 \C54A\ACE0 \C22B\C790 0\C774 \C544\B2C8\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 \BE44\C5B4 \C788\AC70\B098 \C22B\C790 0\C774\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105779051407310092)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 0\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105779107050310092)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 \C22B\C790 0\C774 \C544\B2C8\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('\D56D\BAA9 \AC12\C774 \C22B\C790 0\C774\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105777866251310091)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \BC18\D658\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105777929809310091)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL \C9C8\C758\AC00 \D589\C744 \BC18\D658\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('SQL \C9C8\C758\AC00 \D589\C744 \D558\B098 \C774\C0C1 \BC18\D658\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105778044561310091)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105778108587310091)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('PL/SQL \CF54\B4DC\AC00 \C2E4\D589\B420 \B54C \C624\B958\AC00 \BC1C\C0DD\D558\C9C0 \C54A\C73C\BA74 \C131\ACF5\D569\B2C8\B2E4.<br>'),
unistr('PL/SQL \D45C\D604\C2DD\C774 \C2E4\D589\B420 \B54C \C624\B958\AC00 \BC1C\C0DD\D558\BA74 \C2E4\D328\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105781626313310094)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C774 \C815\ADDC \D45C\D604\C2DD\ACFC \C77C\CE58\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105781731653310094)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C815\ADDC \D45C\D604\C2DD\ACFC \C77C\CE58\D558\BA74 \C131\ACF5\D569\B2C8\B2E4.'),
unistr('\D56D\BAA9 \AC12\C774 <em>\AC12</em> \C18D\C131\C5D0 \C785\B825\D55C \C815\ADDC \D45C\D604\C2DD\ACFC \C77C\CE58\D558\C9C0 \C54A\C73C\BA74 \C2E4\D328\D569\B2C8\B2E4.<br>'),
unistr('\CC38\ACE0: \C815\ADDC \D45C\D604\C2DD\C744 \C0AC\C6A9\D558\BA74 \B2E8\C21C \BB38\C790 \BE44\AD50 \B300\C2E0 \D45C\C900\D654\B41C \AD6C\BB38 \ADDC\C57D\C744 \C0AC\C6A9\D574\C11C \BB38\C790\C5F4 \B370\C774\D130\C5D0\C11C \D328\D134\C744 \AC80\C0C9\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105320879129309713)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105506016306309866)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95 \AE30\C900\C120\C774 \B370\C774\D130\C758 \CD5C\C18C\AC12 \B610\B294 0\C5D0\C11C \C2DC\C791\D558\B294\C9C0 \C120\D0DD\D569\B2C8\B2E4. \C22B\C790 \B370\C774\D130 \CD95\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105506189285309866)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.MIN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105506221202309866)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.ZERO.D'
,p_message_language=>'ko'
,p_message_text=>'0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105505913520309866)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C900\C120 \BC30\C728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105537762171309892)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C74C \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774 \B9E4\AC1C\BCC0\C218 \AC12\C5D0 \B300\D55C \C18C\C2A4\B294 \BAA8\C74C\C758 \CCAB\BC88\C9F8 \D589\C5D0\C11C CLOB \C5F4\C758 \AC12\C744 \AE30\BC18\C73C\B85C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105537621340309892)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105492338302309853)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\CC28\D2B8\C758 \AC12\C744 \D615\C2DD \C9C0\C815\D560 \B54C \C0AC\C6A9\D560 \D1B5\D654\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('        \AC12\C740 ISO 4217 \C601\BB38\C790 \D1B5\D654 \CF54\B4DC\C5EC\C57C \D569\B2C8\B2E4. \D615\C2DD\C774 \D1B5\D654\B85C \C124\C815\B418\C5C8\ACE0 <strong>\D1B5\D654</strong> \C18D\C131\C5D0 \C815\C758\B41C \D1B5\D654\AC00 \C5C6\C73C\BA74 \CC28\D2B8\B97C \B80C\B354\B9C1\D560 \B54C \C560\D50C\B9AC\CF00\C774\C158 \C5B8\C5B4\B85C\BD80\D130 \D1B5\D654\AC00 \C790\B3D9\C73C\B85C \D30C\C0DD\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105492253396309853)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105618433797309957)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \C22B\C790 \AC12\C5D0 \C801\C6A9\D560 \C18C\C218\C810 \C790\B9BF\C218\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105606081073309947)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \B808\C774\BE14\C5D0\C11C \C0AC\C6A9\D560 \C18C\C218\C810 \C790\B9BF\C218\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105605919766309947)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C218\C810 \C790\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105994760437310266)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D45C\D604\C2DD\C744 \D3C9\AC00\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105995118720310266)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105995035227310266)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105994978265310266)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105995243224310266)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105994833156310266)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ko'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105994645720310265)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105492743375309854)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \AC12\C758 \BC30\C728 \B3D9\C791\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105492980887309854)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105493233174309854)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.BILLION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2ED\C5B5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105493110536309854)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.MILLION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC31\B9CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105492898920309854)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.NONE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105493455867309854)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.QUADRILLION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC9C\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105493054882309854)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.THOUSAND.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105493315389309854)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.TRILLION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105492674360309854)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \BC30\C728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105618386373309957)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CC28\D2B8\C758 \AC12\C5D0 \C801\C6A9\D560 \D615\C2DD \C9C0\C815 \C720\D615\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('        <strong>\C18C\C218\C810</strong>,<strong>\BC31\BD84\C728</strong> \B610\B294 <strong>\D1B5\D654</strong> \D615\C2DD\C740 \C22B\C790 \AC12\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.'),
unistr('        <strong>\B0A0\C9DC</strong>,<strong>\C2DC\AC04</strong> \BC0F <strong>\B0A0\C9DC \C2DC\AC04</strong> \D615\C2DD\C740 \CC28\D2B8\C758 \D574\B2F9 \B370\C774\D130 \C720\D615 \AC12\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105490789868309852)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \AC12\C5D0 \C801\C6A9\D560 \C22B\C790, \B0A0\C9DC \BC0F/\B610\B294 \C2DC\AC04 \D615\C2DD \C9C0\C815 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4. \B0A0\C9DC \BC0F/\B610\B294 \C2DC\AC04 \D615\C2DD \C9C0\C815\C758 \ACBD\C6B0 \CC28\D2B8 \B370\C774\D130\C5D0 \B530\B77C <strong>\C2DC\AC04 \CD95 \C720\D615</strong> \CC28\D2B8 \C18D\C131\C774 <strong>\C0AC\C6A9\C73C\B85C \C124\C815\B428</strong>, <strong>\D63C\D569 \BE48\B3C4</strong> \B610\B294 <strong>\AC74\B108\B6F0\AE30 \AC04\ACA9</strong> \C911 \D558\B098\B85C \C124\C815\B418\C5B4 \C788\B294\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105492000832309853)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105629374191309967)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C22B\C790\AC00 \D1B5\D654\B85C \D615\C2DD \C9C0\C815\B418\BA74 [\D1B5\D654] \C18D\C131\C744 \C124\C815\D558\C5EC \C22B\C790 \D615\C2DD\C744 \C9C0\C815\D560 \B54C \C0AC\C6A9\D560 \D1B5\D654\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105491177902309852)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC - \C804\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105628291740309966)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B0A0\C9DC\AC00 \C804\CCB4 \D615\C2DD\C73C\B85C \C9C0\C815\B418\BA74 \D615\C2DD \C9C0\C815\B41C \B0A0\C9DC\C5D0\B294 \AE34 \C694\C77C(EEEE), \C5F0\B3C4(y), \AE34 \C6D4(MMMM), \C77C(d)\C774 \D3EC\D568\B429\B2C8\B2E4(\C608: Wednesday, January 6, 2016).'),
unistr('        \C77C\BD80 \C5B8\C5B4\C758 \ACBD\C6B0 \AE34 \C6D4\C774 \C0AC\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \C77C\BCF8\C5B4\C5D0\C11C\B294 \C22B\C790 \C6D4\C774 \D328\D134\C73C\B85C \C0AC\C6A9\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105491062704309852)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC - \AE38\AC8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105628131414309966)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC\AC00 \AE34 \D615\C2DD\C73C\B85C \C9C0\C815\B418\BA74 \D615\C2DD \C9C0\C815\B41C \B0A0\C9DC\C5D0\B294 \C5F0\B3C4, \AE34 \C6D4, \C77C\C774 \D3EC\D568\B429\B2C8\B2E4(\C608: January 6, 2016).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105490921067309852)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC - \C911\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105628078811309965)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B0A0\C9DC\AC00 \C911\AC04 \D615\C2DD\C73C\B85C \C9C0\C815\B418\BA74 \D615\C2DD \C9C0\C815\B41C \B0A0\C9DC\C5D0\B294 \C5F0\B3C4, \CD95\C57D\D615 \C6D4(MMM), \C77C\C774 \D3EC\D568\B429\B2C8\B2E4(\C608: Jan 6, 2016).'),
unistr('        \C77C\BD80 \C5B8\C5B4\C758 \ACBD\C6B0 \CD95\C57D\D615 \C6D4\C774 \C0AC\C6A9\B418\C9C0 \C54A\C73C\BA70 \C911\AC04 \D615\C2DD\C5D0\B294 \C22B\C790 \C6D4(MM/M)\C774 \D3EC\D568\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105490837384309852)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC - \C9E7\AC8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105627999333309965)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC\AC00 \C9E7\C740 \D615\C2DD\C73C\B85C \C9C0\C815\B418\BA74 \D615\C2DD \C9C0\C815\B41C \B0A0\C9DC\C5D0\B294 \C5F0\B3C4, \C22B\C790 \C6D4(MM/M), \C77C\C774 \D3EC\D568\B429\B2C8\B2E4(\C608: 1/6/16).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105629075642309966)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \C2DC\AC04 - \C804\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105629185784309966)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B0A0\C9DC-\C2DC\AC04\C774 \C804\CCB4 \D615\C2DD\C73C\B85C \C9C0\C815\B418\BA74 \D615\C2DD \C9C0\C815\B41C \B0A0\C9DC-\C2DC\AC04\C5D0\B294 \AE34 \C694\C77C(EEEE), \C5F0\B3C4(y), \AE34 \C6D4(MMMM), \C77C(d), \C2DC(h/H), \BD84(mm), \CD08(ss) \BC0F \C2DC\AC04\B300(zzzz)\AC00 \D3EC\D568\B429\B2C8\B2E4(\C608: Wednesday, January 6, 2016 7 h 30 min 21 s).'),
unistr('        \C2DC\AC04 \D615\C2DD\C740 \C560\D50C\B9AC\CF00\C774\C158 \C5B8\C5B4\C5D0\C11C 12\C2DC\AC04\C81C \C0AC\C6A9 \C5EC\BD80\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105491854544309853)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \C2DC\AC04 - \AE38\AC8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105628958335309966)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B0A0\C9DC-\C2DC\AC04\C774 \AE34 \D615\C2DD\C73C\B85C \C9C0\C815\B418\BA74 \D615\C2DD \C9C0\C815\B41C \B0A0\C9DC-\C2DC\AC04\C5D0\B294 \C5F0\B3C4, \AE34 \C6D4, \C77C, \C2DC, \BD84, \CD08 \BC0F \C2DC\AC04\B300(z)\AC00 \D3EC\D568\B429\B2C8\B2E4(\C608: Jan 6, 2016 7:30:21 AM).'),
unistr('        \C2DC\AC04 \D615\C2DD\C740 \C560\D50C\B9AC\CF00\C774\C158 \C5B8\C5B4\C5D0\C11C 12\C2DC\AC04\C81C \C0AC\C6A9 \C5EC\BD80\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105491704008309853)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \C2DC\AC04 - \C911\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105628829154309966)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B0A0\C9DC-\C2DC\AC04\C774 \C911\AC04 \D615\C2DD\C73C\B85C \C9C0\C815\B418\BA74 \D615\C2DD \C9C0\C815\B41C \B0A0\C9DC-\C2DC\AC04\C5D0\B294 \C5F0\B3C4, \CD95\C57D\D615 \C6D4(MMM), \C77C, \C2DC, \BD84, \CD08 \BC0F \C2DC\AC04\B300(z)\AC00 \D3EC\D568\B429\B2C8\B2E4(\C608: Jan 6, 2016 7:30:21 AM).'),
unistr('        \C2DC\AC04 \D615\C2DD\C740 \C560\D50C\B9AC\CF00\C774\C158 \C5B8\C5B4\C5D0\C11C 12\C2DC\AC04\C81C \C0AC\C6A9 \C5EC\BD80\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105491621816309853)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC \C2DC\AC04 - \C9E7\AC8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105628728910309966)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B0A0\C9DC-\C2DC\AC04\C774 \C9E7\C740 \D615\C2DD\C73C\B85C \C9C0\C815\B418\BA74 \D615\C2DD \C9C0\C815\B41C \B0A0\C9DC-\C2DC\AC04\C5D0\B294 \C5F0\B3C4, \C22B\C790 \C6D4(MM/M), \C77C, \C2DC, \BD84\C774 \D3EC\D568\B429\B2C8\B2E4(\C608: 1/6/16 7:30 AM).'),
unistr('        \C2DC\AC04 \D615\C2DD\C740 \C560\D50C\B9AC\CF00\C774\C158 \C5B8\C5B4\C5D0\C11C 12\C2DC\AC04\C81C \C0AC\C6A9 \C5EC\BD80\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105491948037309853)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C218\C810')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105629230312309967)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C22B\C790\AC00 \C18C\C218\C810\C73C\B85C \D615\C2DD \C9C0\C815\B418\BA74 \C18C\C218\C810 \BB38\C790\AC00 \B85C\CF00\C77C\C5D0 \AC00\C7A5 \C54C\B9DE\C740 \AE30\D638\B85C \BC14\B01D\B2C8\B2E4. \C601\C5B4\C5D0\C11C\B294 \C18C\C218\C810(".")\C774\ACE0, \B9CE\C740 \B85C\CF00\C77C\C5D0\C11C\B294 \C18C\C218\C810 \CF64\B9C8(",")\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105492196541309853)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D37C\C13C\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105629403189309967)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C22B\C790\AC00 \BC31\BD84\C728\B85C \D615\C2DD \C9C0\C815\B418\BA74 \CC28\D2B8\C758 \AC12\C5D0 100\C744 \ACF1\D558\C5EC \BC31\BD84\C728 \D615\C2DD\C73C\B85C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105491575754309853)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04 - \C804\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105628670404309966)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C2DC\AC04\C774 \C804\CCB4 \D615\C2DD\C73C\B85C \C9C0\C815\B418\BA74 \D615\C2DD \C9C0\C815\B41C \C2DC\AC04\C5D0\B294 \C2DC(h/H), \BD84(mm), \CD08(ss) \BC0F \C2DC\AC04\B300(zzzz)\AC00 \D3EC\D568\B429\B2C8\B2E4(\C608: 7 h 30 min 21 s).'),
unistr('        \C2DC\AC04 \D615\C2DD\C740 \C560\D50C\B9AC\CF00\C774\C158 \C5B8\C5B4\C5D0\C11C 12\C2DC\AC04\C81C \C0AC\C6A9 \C5EC\BD80\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105491497287309853)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04 - \AE38\AC8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105628531778309966)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C2DC\AC04\C774 \AE34 \D615\C2DD\C73C\B85C \C9C0\C815\B418\BA74 \D615\C2DD \C9C0\C815\B41C \C2DC\AC04\C5D0\B294 \C2DC, \BD84, \CD08 \BC0F \C2DC\AC04\B300(z)\AC00 \D3EC\D568\B429\B2C8\B2E4(\C608: 7:30:21 AM).'),
unistr('        \C2DC\AC04 \D615\C2DD\C740 \C560\D50C\B9AC\CF00\C774\C158 \C5B8\C5B4\C5D0\C11C 12\C2DC\AC04\C81C \C0AC\C6A9 \C5EC\BD80\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105491332417309853)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04 - \C911\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105628491627309966)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C2DC\AC04\C774 \C911\AC04 \D615\C2DD\C73C\B85C \C9C0\C815\B418\BA74 \D615\C2DD \C9C0\C815\B41C \C2DC\AC04\C5D0\B294 \C2DC, \BD84, \CD08\AC00 \D3EC\D568\B429\B2C8\B2E4(\C608: 7:30:21 AM).'),
unistr('        \C2DC\AC04 \D615\C2DD\C740 \C560\D50C\B9AC\CF00\C774\C158 \C5B8\C5B4\C5D0\C11C 12\C2DC\AC04\C81C \C0AC\C6A9 \C5EC\BD80\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105491234181309852)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04 - \C9E7\AC8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105628324402309966)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C2DC\AC04\C774 \C9E7\C740 \D615\C2DD\C73C\B85C \C9C0\C815\B418\BA74 \D615\C2DD \C9C0\C815\B41C \C2DC\AC04\C5D0\B294 \C2DC, \BD84\C774 \D3EC\D568\B429\B2C8\B2E4(\C608: 7:30 AM).'),
unistr('        \C2DC\AC04 \D615\C2DD\C740 \C560\D50C\B9AC\CF00\C774\C158 \C5B8\C5B4\C5D0\C11C 12\C2DC\AC04\C81C \C0AC\C6A9 \C5EC\BD80\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105490663922309852)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105996796941310267)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105997093658310268)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105996980625310268)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105996833943310267)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105997122032310268)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105996605801310267)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105534679842309890)
,p_name=>'PE.PROPERTY.VALUE_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \B9E4\AC1C\BCC0\C218 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105534598895309890)
,p_name=>'PE.PROPERTY.VALUE_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105996303436310267)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 Java \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105996239775310267)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105997941724310269)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105997831626310268)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105996145727310267)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105996000472310267)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 JavaScript \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105995963432310267)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105997743405310268)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105997665789310268)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105997538795310268)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105490586778309852)
,p_name=>'PE.PROPERTY.VALUE_MIN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0 \B300\D55C \CD5C\C18C\AC12\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105490428787309852)
,p_name=>'PE.PROPERTY.VALUE_MIN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105618593797309957)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C758 \C22B\C790 \AC12\C5D0 \C801\C6A9\D560 \C22B\C790 \D328\D134\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106110296562310374)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C628\B3C4\B97C \D654\C528\B85C \B098\D0C0\B0B4\AE30 \C704\D55C \C22B\C790 \D328\D134(\C608: 15&deg;F):</dt>'),
'<dd><pre>',
'#&deg;F',
'</pre></dd>',
unistr('<dt>\C22B\C790\B97C \D2B9\C815 \D615\C2DD\C73C\B85C \B098\D0C0\B0B4\AE30 \C704\D55C \C22B\C790 \D328\D134(\C608: 12,30,00):</dt>'),
'<dd><pre>',
'##,##,##',
'</pre></dd>',
unistr('<dt>\C22B\C790\B97C mm \B2E8\C704\B85C \B098\D0C0\B0B4\AE30 \C704\D55C \C22B\C790 \D328\D134:</dt>'),
'<dd><pre>',
'# mm',
'</pre></dd>',
unistr('<dt>\B0A0\C9DC\B97C \B144, \C6D4\B85C \B098\D0C0\B0B4\AE30 \C704\D55C \B0A0\C9DC \D328\D134(\C608: 2016\B144 7\C6D4):</dt>'),
'<dd><pre>',
'MMM yyyy',
'</pre></dd>',
unistr('<dt>\B0A0\C9DC\B97C \C6D4\B85C \B098\D0C0\B0B4\AE30 \C704\D55C \B0A0\C9DC \D328\D134(\C608: 7\C6D4):</dt>'),
'<dd><pre>',
'MMMM',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105492570398309853)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C120\D0DD\C801\C73C\B85C \D604\C9C0\D654\B41C \C22B\C790 \B610\B294 \B0A0\C9DC \D328\D134\C744 \C785\B825\D569\B2C8\B2E4. \D328\D134\C5D0\C11C \C0AC\C6A9\B418\B294 \BB38\C790\B294 \B0A0\C9DC \C2DC\AC04 \D615\C2DD\C5D0 \B300\D55C \C720\B2C8\CF54\B4DC CLDR\C744 \C900\C218\D569\B2C8\B2E4.'),
unistr('        \C785\B825\B418\BA74 \C120\D0DD\B41C \D615\C2DD\C744 \BB34\D6A8\D654\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105492437496309853)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D134')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105995815748310267)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105995720900310266)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105995619176310266)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105997496877310268)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105997397067310268)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105997202697310268)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104963950953309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\C5D0\C11C \AC12\C774 \D45C\C2DC\B418\C5B4\C57C \D560 \C704\CE58\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104963304964309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104964098580309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AC12\C774 \CC28\D2B8\C758 \AE30\BCF8 \C704\CE58(\AD6C\D68D \C601\C5ED \C678\BD80)\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104963424129309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C6B4\B370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104964148163309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AC12\C774 \CC28\D2B8\C5D0\C11C \D45C\C2DC\AE30 \AC00\C6B4\B370\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104963581446309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\AE30 \AC00\C7A5\C790\B9AC \B0B4\BD80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104964266641309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AC12\C774 \CC28\D2B8\C5D0\C11C \D45C\C2DC\AE30 \BAA8\C11C\B9AC \B0B4\BD80\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104963631366309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\AE30 \AC00\C7A5\C790\B9AC \C678\BD80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104964321626309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AC12\C774 \CC28\D2B8\C5D0\C11C \D45C\C2DC\AE30 \BAA8\C11C\B9AC \C678\BD80\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104963772479309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\D68D \C601\C5ED \C678\BD80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104964483455309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AC12\C774 \CC28\D2B8\C758 \AD6C\D68D \C601\C5ED \C678\BD80\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104963802512309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104964527252309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\B808\C774\BE14\C774 \B80C\B354\B9C1\B418\BA74 \AC12\C774 \B808\C774\BE14\ACFC \B3D9\C77C\D55C \C704\CE58\C5D0 \D45C\C2DC\B429\B2C8\B2E4. \B808\C774\BE14\C774 \B80C\B354\B9C1\B418\C9C0 \C54A\C73C\BA74 \AC12\C774 \CC28\D2B8\C758 \AD6C\D68D \C601\C5ED \C678\BD80\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104963242908309443)
,p_name=>'PE.PROPERTY.VALUE_POSITION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105534877929309890)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218 \AC12\C5D0 \B300\D55C \C18C\C2A4\B85C \C0AC\C6A9\D560 \C0AC\C6A9\C790 \D658\ACBD\C124\C815\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105534758533309890)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105996514500310267)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 Python \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105996466035310267)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105998155115310269)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105998073489310269)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105534469502309890)
,p_name=>'PE.PROPERTY.VALUE_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218 \AC12\C5D0 \B300\D55C \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4. \D589\C774 \B450 \AC1C \C774\C0C1 \BC18\D658\B418\B294 \ACBD\C6B0 \CCAB\BC88\C9F8 \D589\C758 \AC12\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105534386690309890)
,p_name=>'PE.PROPERTY.VALUE_QUERY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105221721601309638)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>\C124\C815</strong>\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \D398\C774\C9C0 \D56D\BAA9\C744 \BCFC \C218 \C788\C73C\BA74 \D398\C774\C9C0\AC00 \C81C\CD9C\B420 \B54C &PRODUCT_NAME.\C774(\AC00) NOT NULL \AC80\C99D\C744 \C790\B3D9\C73C\B85C \C218\D589\D569\B2C8\B2E4.</p>'),
unistr('<p>\ACF5\C720 \AD6C\C131\C694\C18C > \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\C5D0\C11C <strong>APEX.PAGE_ITEM_IS_REQUIRED</strong>\B77C\B294 \BA54\C2DC\C9C0\B97C \C815\C758\D558\C5EC \BBF8\B9AC \C815\C758\B41C \C624\B958 \D14D\C2A4\D2B8\B97C \C560\D50C\B9AC\CF00\C774\C158 \D2B9\C815 \C624\B958 \BA54\C2DC\C9C0\B85C \BC14\AFC0 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\BA54\C2DC\C9C0\C758 \D45C\C2DC \C704\CE58\B294 \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8 \C124\C815 <strong>\AE30\BCF8 \C624\B958 \D45C\C2DC \C704\CE58</strong>\B85C \C815\C758\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105221693057309638)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C218 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105995585121310266)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \AD00\B9AC\C790\C774\ACE0 \BD80\C11C\AC00 \C2DC\CE74\ACE0\C5D0 \C788\C744 \B54C YES\B97C \BC18\D658\D558\B824\BA74</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105995459918310266)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218 \AC12\C758 \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \AC12\C744 \C0DD\C131\D558\B294 SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105995384852310266)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105534299644309890)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218 \AC12\C5D0 \B300\D55C \C18C\C2A4\B85C \C0AC\C6A9\B418\B294 \C815\C801 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105534142935309890)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105616559957309955)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C774 \CC28\D2B8\C5D0 \D45C\C2DC\B418\C5B4\C57C \D558\B294 \BC29\C2DD(\C22B\C790 \B610\B294 \CD1D \AC12\C758 \BC31\BD84\C728\B85C)\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105616377341309955)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C22B\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105618811381309957)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AC12\C774 \CC28\D2B8\C5D0 \C22B\C790\B85C \D45C\C2DC\B429\B2C8\B2E4.</p> <p>\CC38\ACE0: <strong>\D615\C2DD</strong> \C18D\C131\C740 \CC28\D2B8\C5D0 \D45C\C2DC\B418\B294 \B808\C774\BE14 \BC0F \AC12\C5D0 \C0AC\C6A9\C790\C815\C758 \C18C\C218\C810 \B610\B294 \D1B5\D654 \D615\C2DD \C9C0\C815\C744 \C801\C6A9\D558\B294 \B370\B9CC \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105616493458309955)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D37C\C13C\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105618905712309957)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\AC12\C774 0%\C640 100% \C0AC\C774\C758 \D37C\C13C\D2B8\B85C \D45C\C2DC\B429\B2C8\B2E4.</p> <p>\CC38\ACE0: <strong>\D615\C2DD</strong>\C774 <strong>\D37C\C13C\D2B8</strong>\B85C \C124\C815\B41C \ACBD\C6B0 \CC28\D2B8\C758 \AC12\C5D0 100\C744 \ACF1\D558\C5EC \D37C\C13C\D2B8 \D615\C2DD\C73C\B85C \D45C\C2DC\D569\B2C8\B2E4. [\D615\C2DD] \C18D\C131\C744 \C0AC\C6A9\D558\B824\BA74 [\B808\C774\BE14 \C720\D615]\C774 \C22B\C790\B85C \C124\C815\B418\C5C8\B294\C9C0 \D655\C778\D558\C2ED\C2DC\C624.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105616237067309955)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105532657745309888)
,p_name=>'PE.PROPERTY.VALUE_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9E4\AC1C\BCC0\C218\AC00 \CC44\C6CC\C9C0\B294 \BC29\C2DD\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105537478382309892)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C74C(CLOB)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105537577723309892)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>\BAA8\C74C</em>\C5D0\C11C \CCAB\BC88\C9F8 \D589\C758 CLOB \C5F4 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105814525553310119)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.D'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C18C\C2A4 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105814611014310119)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4 \B0B4\C5D0 \AE30\BCF8\AC12\C73C\B85C \C815\C758\B41C \AC12\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105532902693309889)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105533098932309889)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C <em>\D56D\BAA9</em>\C758 \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105533947747309889)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105534093645309890)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \AC12\C774 \C5C6\C73C\BBC0\B85C \B110\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105533373329309889)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105533473192309889)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>PL/SQL \D45C\D604\C2DD</em> \C2E4\D589 \ACB0\ACFC \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105533516454309889)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105533687343309889)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>PL/SQL \D568\C218 \BCF8\BB38</em>\C5D0\C11C \BC18\D658\B41C \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105533718329309889)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105533884938309889)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>\D658\ACBD\C124\C815</em>\C758 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105533146147309889)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758(\B2E8\C77C \AC12 \BC18\D658)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105533279207309889)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C <em>SQL \C9C8\C758</em>\C5D0\C11C \BC18\D658\B41C \CCAB\BC88\C9F8 \AC12\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105532747578309889)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105532837816309889)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<em>\C815\C801 \AC12</em>\C5D0 \C785\B825\B41C \D14D\C2A4\D2B8\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105532563500309888)
,p_name=>'PE.PROPERTY.VALUE_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105985725870310257)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D45C\D604\C2DD\C744 \D3C9\AC00\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105986121913310258)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105986091491310258)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105985916068310257)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105986288033310258)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105985883204310257)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ko'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105985616890310257)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105987780896310259)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105988044313310259)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105987925514310259)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105987852833310259)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105988118010310260)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105987640116310259)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105984113314310256)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \D568\C218 \BCF8\BB38\C744 \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105984435963310256)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'ko'
,p_message_text=>'Java(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105984359357310256)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'ko'
,p_message_text=>'JavaScript(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105984200033310256)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105984558239310256)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'ko'
,p_message_text=>'Python(MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105984059358310256)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105680566127310012)
,p_name=>'PE.PROPERTY.VAL_ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C5D0 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105680464960310012)
,p_name=>'PE.PROPERTY.VAL_ITEM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105987394517310259)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C744 \C815\C758\D558\AE30 \C704\D55C Java \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105987206446310259)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105988928751310260)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C BOOLEAN \AC12\C744 \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105988888926310260)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105985333420310257)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C \C624\B958 \BA54\C2DC\C9C0 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105985203237310257)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 Java \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105987160041310259)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105987084318310258)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C744 \C815\C758\D558\AE30 \C704\D55C JavaScript \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105986909670310258)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105988785256310260)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105988615724310260)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C BOOLEAN \AC12\C744 \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105988550010310260)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105985114877310257)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C9C0\C815\B41C \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105985051607310257)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C \C624\B958 \BA54\C2DC\C9C0 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105984979962310257)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 JavaScript \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106105474869310370)
,p_name=>'PE.PROPERTY.VAL_PLSQL.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C9C0\C815\B41C \C624\B958\B97C \BC1C\C0DD\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105680344651310012)
,p_name=>'PE.PROPERTY.VAL_PLSQL.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C \C624\B958\B97C \C77C\C73C\D0A4\B294 PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105680257511310012)
,p_name=>'PE.PROPERTY.VAL_PLSQL.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \CF54\B4DC \BC1C\C0DD \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105986886685310258)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D558\AC70\B098 \AD00\B9AC\C790\C77C \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105986701051310258)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C744 \C815\C758\D558\AE30 \C704\D55C PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105986643562310258)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105988459565310260)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105988305904310260)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105988246338310260)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105984829064310256)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C9C0\C815\B41C \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105984797518310256)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C \C624\B958 \BA54\C2DC\C9C0 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105984654748310256)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D14D\C2A4\D2B8 \BC18\D658 PL/SQL \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105987510282310259)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C744 \C815\C758\D558\AE30 \C704\D55C Python \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105987443244310259)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105989199229310260)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C BOOLEAN \AC12\C744 \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105989036263310260)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105985575017310257)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C758 \AE30\C900\C73C\B85C \C624\B958 \BA54\C2DC\C9C0 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105985470760310257)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 Python \D568\C218 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105680900777310013)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C5D0 \C9C0\C815\B41C \D56D\BAA9\ACFC \C77C\CE58\C2DC\D0A4\B294 \B370 \C0AC\C6A9\B418\B294 \C815\ADDC \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105680805474310013)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\ADDC \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105986594990310258)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\C9C1\C6D0\C774 \AD00\B9AC\C790\C774\AC70\B098 \BD80\C11C\AC00 \C2DC\CE74\ACE0\C5D0 \C788\C744 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105986450403310258)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C744 \C815\C758\D558\AE30 \C704\D55C SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105986382853310258)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106105311618310370)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt><strong>\D589\C774 \BC18\D658\B428</strong>\C758 \ACBD\C6B0 \C9C1\C6D0\C774 \BD80\C11C 30\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt><strong>\D589\C774 \BC18\D658\B418\C9C0 \C54A\C74C</strong>\C758 \ACBD\C6B0 \C9C1\C6D0\C774 \BD80\C11C 40\C5D0 \C18D\D560 \B54C \AC80\C99D\C744 \D1B5\ACFC\D558\ACE0 \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C73C\B824\BA74:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105680151186310012)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C744 \C815\C758\D558\AE30 \C704\D55C SQL \C9C8\C758\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105680044180310012)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105680742480310013)
,p_name=>'PE.PROPERTY.VAL_VALUE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC80\C99D\C5D0 \C9C0\C815\B41C \D56D\BAA9 \C5F4\C758 \AC12\C5D0 \B300\D574 \BE44\AD50\D558\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105680610353310013)
,p_name=>'PE.PROPERTY.VAL_VALUE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105811423813310117)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C560\D50C\B9AC\CF00\C774\C158 \C0AC\C6A9\C744 \D2B9\C815 \C5C5\BB34 \C2DC\AC04\C73C\B85C \C81C\D55C</dt>'),
'<dd><pre>',
'function check_business_hours return boolean',
'is',
'begin',
'    return to_char(to_char(sysdate, ''hh24:mi'')) between ''08:00'' and ''17:00'';',
'end check_business_hours;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105304137288309699)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C138\C158 \AC10\C2DC\AC00 \C131\ACF5\C801\C73C\B85C \BC18\D658\B41C \B2E4\C74C\C5D0 \D638\CD9C\B418\B294 \D568\C218\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\D568\C218\B294 "PL/SQL \CF54\B4DC" \C18D\C131 \B610\B294 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C815\C758\B420 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\ACB0\ACFC\B294 \C0AC\C6A9\C790\AC00 \D655\C778\B418\C5C8\C74C\C744 \B098\D0C0\B0B4\B294 "True" \B610\B294 \C0AC\C6A9\C790 \D655\C778\C744 \C2E4\D328\D588\C74C\C744 \B098\D0C0\B0B4\B294 "False"\C758 \BD80\C6B8\C774\C5B4\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105304099955309699)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \C774\B984 \D655\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105241739562309653)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BAA8\B4E0 \BCF4\B958 \C911\C778 \C791\C5C5\C774 \D604\C7AC \C791\C5C5\C758 \ACB0\ACFC\B97C \B300\AE30\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\BCF4\B958 \C911\C778 \C791\C5C5\C774 \C774 \C791\C5C5\C758 \ACB0\ACFC\C5D0 \C885\C18D\B41C \ACBD\C6B0 \C774 \C18D\C131\C744 <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D569\B2C8\B2E4.'),
unistr('\C885\C18D \AD00\ACC4\AC00 \C5C6\ACE0 \B300\AE30\D558\C9C0 \C54A\ACE0 \BE44\B3D9\AE30\C801\C73C\B85C \C791\C5C5\C744 \C2E4\D589\D560 \C218 \C788\B294 \ACBD\C6B0 <strong>\D574\C81C</strong>\B85C \C124\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \D2B9\C815 \C791\C5C5\C758 \C2E4\D589 \C21C\C11C\B294 \AC01 \C791\C5C5\C5D0 \B300\D574 \C9C0\C815\B41C \C21C\C11C\C5D0 \B530\B77C \ACB0\C815\B429\B2C8\B2E4.'),
unistr('\C791\C5C5\C774 \B3D9\C77C\D55C \C21C\C11C\B85C \C2E4\D589\B420 \C218 \C788\B3C4\B85D Oracle\C740 \BAA8\B4E0 True \C791\C5C5 \BC0F \BAA8\B4E0 False \C791\C5C5\C5D0 \B300\D574 \C21C\C11C \BC88\D638\B97C \B3D9\C77C\D558\AC8C \C124\C815\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105241694837309652)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACB0\ACFC \B300\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105329793424309720)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4\C5D0 \B85C\CEEC \B3D9\AE30\D654 \D14C\C774\BE14\C774 \C788\B294\C9C0 \C5EC\BD80\B97C \C2DD\BCC4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105329697921309720)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4\C5D0 \B3D9\AE30\D654 \D14C\C774\BE14\C774 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105532481306309888)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105329986918309720)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C678\BD80 REST \C11C\BE44\C2A4\C5D0 \C5F0\ACB0\D558\B294 \B300\C2E0 REST \B370\C774\D130 \C18C\C2A4\C758 <strong>\B3D9\AE30\D654</strong> \C139\C158 \B0B4\C5D0\C11C \AD6C\C131\B41C \B85C\CEEC \D14C\C774\BE14\C744 \C0AC\C6A9\D558\B824\BA74 \C774\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105329875132309720)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\AE30\D654 \D14C\C774\BE14 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105215972950309633)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D560 \B2E8\CD94\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105215811189309633)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105320676816309713)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \B2E8\CD94\B97C \B204\B97C \B54C\B9CC \C774 \D398\C774\C9C0 \CC98\B9AC \AD6C\C131\C694\C18C\AC00 \C2E4\D589\B418\B3C4\B85D \D558\B824\BA74 \BAA9\B85D\C5D0\C11C \B2E8\CD94\B97C \C120\D0DD\D569\B2C8\B2E4. \C774 \B2E8\CD94 \C870\AC74\C744 \B2E4\B978 \C870\AC74\ACFC \D568\AED8 \C0AC\C6A9\D558\C5EC \C774 \D398\C774\C9C0 \CC98\B9AC \AD6C\C131\C694\C18C\C758 \C2E4\D589 \C2DC\AC04\C744 \C138\BD80\C801\C73C\B85C \C870\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105320566143309713)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94\B97C \B204\B97C \B54C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106077365747310344)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D560 \C5F4\C744 \D558\B098 \C774\C0C1 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C5F4\C774 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \AC01 \D56D\BAA9 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\D569\B2C8\B2E4.'),
unistr('\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \C5F4 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \B54C \C774\BBF8 \C785\B825\B41C \D14D\C2A4\D2B8\AC00 \C788\C73C\BA74 \AE30\C874 \D14D\C2A4\D2B8 \B05D\C5D0 \CF64\B9C8\AC00 \D45C\C2DC\B418\ACE0 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \C5F4 \C774\B984\C774 \CD94\AC00\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106077215431310344)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105216305752309634)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>DOM \AC1D\CCB4(<code>document</code>, <code>window</code>) \B610\B294 DOM \AC1D\CCB4\C758 <em>id</em>(<code>myElementID</code>)\B97C \B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D560 \C694\C18C\B85C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: <em>DOM \AC1D\CCB4</em>\B294 \B354 \C774\C0C1 \C0AC\C6A9\B418\C9C0 \C54A\C73C\BA70 <em>JavaScript \D45C\D604\C2DD</em> \B610\B294 <em>jQuery \C120\D0DD\AE30</em>\B85C \BC14\AFD4\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105216289872309634)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('DOM \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105216119146309634)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\D56D\BAA9\C774 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \AC01 \D56D\BAA9 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\D569\B2C8\B2E4.'),
unistr('\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \B54C \C774\BBF8 \C785\B825\B41C \D14D\C2A4\D2B8\AC00 \C788\C73C\BA74 \AE30\C874 \D14D\C2A4\D2B8 \B05D\C5D0 \CF64\B9C8\AC00 \D45C\C2DC\B418\ACE0 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \D56D\BAA9 \C774\B984\C774 \CD94\AC00\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105216001054309634)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106073051365310340)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\BE0C\B77C\C6B0\C800\C758 <code>window</code> DOM \AC1D\CCB4\C5D0 \B300\D55C \CC38\C870\B97C \BC18\D658\D569\B2C8\B2E4.</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>\BE0C\B77C\C6B0\C800\C758 <code>document</code> DOM \AC1D\CCB4\C5D0 \B300\D55C \CC38\C870\B97C \BC18\D658\D569\B2C8\B2E4.</dt>'),
'<dd><code>document</code></dd>',
unistr('<dt>jQuery \C120\D0DD\AE30\B294 ''alert'' \D074\B798\C2A4\B97C \D3EC\D568\D558\B294 \BAA8\B4E0 DIV \C694\C18C\B97C \C120\D0DD\D55C \D6C4 \BAA8\B4E0 \D574\B2F9 \C0C1\C704 \D56D\BAA9\C774 \D3EC\D568\B41C jQuery \AC1D\CCB4\B97C \BC18\D658\D569\B2C8\B2E4.</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106072950427310340)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C DOM \AC1D\CCB4, DOM \AC1D\CCB4 \BC30\C5F4 \B610\B294 jQuery \AC1D\CCB4\B97C \B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D560 \C694\C18C\B85C \BC18\D658\D558\AE30 \C704\D574 \D3C9\AC00\D560 JavaScript \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106072815032310340)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105727742162310053)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>DOM ID\AC00 <code>my_id</code>\C778 \D398\C774\C9C0 \C694\C18C \C120\D0DD</dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>\D074\B798\C2A4\AC00 <code>my_class</code>\C778 \BAA8\B4E0 \D398\C774\C9C0 \C694\C18C \C120\D0DD</dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>\C785\B825\C778 \BAA8\B4E0 \D398\C774\C9C0 \C694\C18C \C120\D0DD</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105216583433309634)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D560 \D398\C774\C9C0 \C694\C18C\B97C \D558\B098 \C774\C0C1 \BC18\D658\D558\AE30 \C704\D55C jQuery \C120\D0DD\AE30 \AD6C\BB38\C744 \C785\B825\D569\B2C8\B2E4. jQuery \B77C\C774\BE0C\B7EC\B9AC\B294 \D398\C774\C9C0\C5D0\C11C \D558\B098 \C774\C0C1\C758 \C694\C18C\C5D0 \C27D\AC8C \C561\C138\C2A4\D560 \C218 \C788\B294 \BC29\BC95\C744 \C81C\ACF5\D558\B294 \B9E4\C6B0 \AC15\B825\D55C \C120\D0DD\AE30 \AD6C\BB38\C744 \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>\C120\D0DD\AE30 \AD6C\BB38\C5D0 \B300\D55C \C790\C138\D55C \B0B4\C6A9\C740 <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">jQuery \D648 \D398\C774\C9C0</a>\C5D0\C11C \C81C\ACF5\B418\B294 \ACF5\C2DD \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105216452899309634)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('jQuery \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105453107739309822)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\CC98\B9AC\D560 \CD5C\B300 \D589</strong> \C81C\D55C\C744 \CD08\ACFC\D560 \B54C \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\AE30\BCF8 \BA54\C2DC\C9C0\B294 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \CC98\B9AC\D560 \B808\CF54\B4DC \C218\B97C \C81C\D55C\D558\B294 \D544\D130\B97C \CD94\AC00\D558\B3C4\B85D \C9C0\C2DC\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105598405030309940)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825\B41C \CD5C\B300 \D589 \C218\BCF4\B2E4 \B354 \B9CE\C740 \D589\C774 \C9C8\C758\C5D0\C11C \BC18\D658\B41C \ACBD\C6B0 \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105879819855310168)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE35\C5D0 \B300\D574 <strong>\CC98\B9AC\D560 \CD5C\B300 \D589</strong> \C81C\D55C\C744 \CD08\ACFC\D560 \B54C <strong>\BA54\C2DC\C9C0</strong> \C601\C5ED\C5D0 \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4. \C2E4\C81C\B85C \C778\CD9C\D55C \D589 \C218\C5D0 \B300\D574 <strong>#MAX_ROW_COUNT#</strong> \B300\CCB4 \D56D\BAA9\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105583745531309929)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B354 \B9CE\C740 \BCF4\ACE0\C11C \D589\C774 \C874\C7AC\D560 \B54C \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('\D2B9\D788 \BCF4\ACE0\C11C\AC00 \C77C\BC18\C801\C73C\B85C \BCC4\AC1C\C758 \B808\CF54\B4DC \C9D1\D569\B9CC \D3EC\D568\D558\B294 \ACBD\C6B0\C5D0\B294 \D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C5D0 \B300\D55C \B300\C548\C73C\B85C \C774 \BC29\BC95\C744 \C0AC\C6A9\D569\B2C8\B2E4.'),
unistr('\BCF4\ACE0\C11C \C9C8\C758\AC00 \CD94\AC00 \D589\C744 \BC18\D658\D560 \ACBD\C6B0\C5D0\B294 \B2E8\C21C\D788 \C57D\AC04 \B2E4\B978 \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C81C\C5B4\B97C \D45C\C2DC\D558\B294 \B300\C2E0 \C774 \BA54\C2DC\C9C0\B97C \C0AC\C6A9\D574\C11C \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \BE44\C815\C0C1 \C0C1\D0DC\B97C \ACBD\BCF4\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C774\B7EC\D55C \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\B294 "\C870\CE58 \C694\CCAD" \C0C1\D669\C744 \C27D\AC8C \AC00\C838\C62C \C218 \C788\C73C\BBC0\B85C, \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \BE44\C815\C0C1\C801\C778 \C9C8\C758 \ACB0\ACFC\C5D0 \B300\D55C \B300\C751 \BC29\BC95\C744 \C548\B0B4\D558\ACE0 \D398\C774\C9C0 \B610\B294 URL \B9C1\D06C\B97C \D3EC\D568\C2DC\D0AC \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\BA54\C2DC\C9C0\C5D0\C11C\B294 \B2E4\C74C\ACFC \AC19\C740 \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \B300\CCB4 \BB38\C790\C5F4\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>\D45C\C2DC\B418\B294 \D589 \C218(\D398\C774\C9C0 \D06C\AE30)</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
unistr('    <dd>"X - Y/Z \D589"\C5D0\C11C "Z"</dd>'),
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
unistr('    <dd>"X - Y/Z \D589"\C5D0\C11C "X"</dd>'),
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
unistr('    <dd>"X - Y/Z \D589"\C5D0\C11C "Y"</dd>'),
'  <dt><code>#ROW_RANGES"</code></dt>',
unistr('    <dd>\D45C\C2DC: \D589 1-15 16-30 30-32</dd>'),
'  <dt><code>#ROW_RANGES_IN_SELECT_LIST</code></dt>',
unistr('    <dd>\D589 \BC94\C704\C640 \B3D9\C77C\D558\C9C0\B9CC \C120\D0DD \BAA9\B85D\C5D0 \D3EC\D568\B428<dd>'),
'  <dt><code>#INTERNET_PAGINATION#</code></dt>',
unistr('    <dd>\D398\C774\C9C0 \C9D1\D569: 1 2 3 4 5 6</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105583633969309929)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B354 \B9CE\C740 \B370\C774\D130\B97C \CC3E\C558\C744 \B54C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106057483909310325)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C9C8\C758\B85C \D589\C774 \BC18\D658\B418\C9C0 \C54A\B294 \ACBD\C6B0 \D45C\C2DC\D560 \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4. \BE44\C6CC \B458 \ACBD\C6B0 Oracle JET\C5D0\C11C \C790\B3D9\C73C\B85C \AE30\BCF8 \BA54\C2DC\C9C0\C778 "\D45C\C2DC\D560 \B370\C774\D130 \C5C6\C74C"\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106010241296310280)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE35 \C9C8\C758\AC00 \D589\C744 \BC18\D658\D558\C9C0 \C54A\C744 \B54C <strong>\BA54\C2DC\C9C0</strong> \C601\C5ED\C5D0 \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105547833525309901)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\B85C \D589\C774 \BC18\D658\B418\C9C0 \C54A\B294 \ACBD\C6B0 \D45C\C2DC\D560 \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105547751273309901)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C744 \B54C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105215784972309633)
,p_name=>'PE.PROPERTY.WHEN_REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D558\B294 \C601\C5ED\C758 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, \BCF4\ACE0\C11C\B97C \C0C8\B85C\ACE0\CE68\D560 \B54C\B9C8\B2E4 \C2E4\D589\B418\B294 \B3D9\C801 \C791\C5C5\C744 \C815\C758\D558\AE30 \C704\D574 ''\C0C8\B85C\ACE0\CE68 \D6C4'' \C774\BCA4\D2B8\C640 \D568\AED8 \C0AC\C6A9\B418\B294 ''\B300\D654\C2DD \BCF4\ACE0\C11C'' \C601\C5ED\C77C \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\D55C \C601\C5ED\C5D0\C11C \C5EC\B7EC \D398\C774\C9C0 \D56D\BAA9\C5D0 \B300\D574 \BE44\C2B7\D55C \B3D9\C791\C744 \C815\C758\D558\B824\B294 \ACBD\C6B0 \C601\C5ED\C774 \B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D558\B3C4\B85D \C124\C815\D558\B294 \AC83\C774 \C720\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \D558\C9C0\B9CC \C774\B7EC\D55C \C791\C5C5\C740 \D574\B2F9 \C601\C5ED \B0B4\C758 \D56D\BAA9\B4E4\C5D0 \C758\D574 \BC1C\C0DD\D558\B294 \D2B9\C815 \C774\BCA4\D2B8\C5D0\C11C\B9CC \AC00\B2A5\D569\B2C8\B2E4.'),
unistr('\C774 \C815\C758 \C720\D615\C744 \C9C0\C6D0\D558\B294 \C774\BCA4\D2B8 \BAA9\B85D\ACFC \D65C\C6A9 \AC00\B2A5\D55C \BC29\BC95 \C608\B97C \BCF4\B824\BA74 \C791\C5C5 \D398\C774\C9C0\C5D0\C11C \C774\BCA4\D2B8 \BC94\C704\C758 <em>\C601\D5A5\C744 \C8FC\B294 \C694\C18C</em> &gt; <em>\C120\D0DD \C720\D615</em>\C5D0 \B300\D55C \D56D\BAA9 \B3C4\C6C0\B9D0\C744 \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105215606332309633)
,p_name=>'PE.PROPERTY.WHEN_REGION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105215507569309633)
,p_name=>'PE.PROPERTY.WHEN_TYPE.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8\B97C \D2B8\B9AC\AC70\D558\B294 \B370 \C0AC\C6A9\D560 \D398\C774\C9C0 \C694\C18C \B610\B294 \C0DD\C131 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4. \D2B9\C815 \C120\D0DD \C720\D615\C744 \C0AC\C6A9\D558\B294 \C608\C81C\B294 \AD00\B828 \C18D\C131\C5D0 \B300\D55C \B3C4\C6C0\B9D0\C744 \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105727493947310053)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106028812256310298)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94\C5D0 \C758\D574 \D2B8\B9AC\AC70\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106075501359310342)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106029078340310298)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D558\B098 \C774\C0C1\C758 \C5F4\C5D0 \C758\D574 \D2B8\B9AC\AC70\B429\B2C8\B2E4.'' );'),
'    --',
'    store_property_lov_values (',
'        p_property_id   => l_property_id,',
'        p_display_value => ''DOM Object'',',
'        p_return_value  => ''DOM_OBJECT'',',
'        p_is_deprecated => ''Y'',',
unistr('        p_help_text     => q''~<p>DOM \AC1D\CCB4(<code>document</code>, <code>window</code>) \B610\B294 DOM \AC1D\CCB4\C758 <em>ID</em>(<code>myElementID</code>)\C5D0 \C758\D574 \D2B8\B9AC\AC70\B429\B2C8\B2E4.</p>'),
unistr('        <p>\CC38\ACE0: <em>DOM \AC1D\CCB4</em>\B294 \B354 \C774\C0C1 \C0AC\C6A9\B418\C9C0 \C54A\C73C\BA70 <em>JavaScript \D45C\D604\C2DD</em> \B610\B294 <em>jQuery \C120\D0DD\AE30</em>\B85C \BC14\B00C\C5B4\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105727309004310053)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106028789086310298)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B098 \C774\C0C1\C758 \D398\C774\C9C0 \D56D\BAA9\C5D0 \C758\D574 \D2B8\B9AC\AC70\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106072214546310339)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106029206448310299)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript \D45C\D604\C2DD\C73C\B85C \BC18\D658\B41C \D398\C774\C9C0 \C694\C18C\C5D0 \C758\D574 \D2B8\B9AC\AC70\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105727692183310053)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'ko'
,p_message_text=>unistr('jQuery \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106029117379310299)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('jQuery \C120\D0DD\AE30\AC00 \BC18\D658\D55C \D558\B098 \C774\C0C1\C758 \D398\C774\C9C0 \C694\C18C\C5D0 \C758\D574 \D2B8\B9AC\AC70\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105727531638310053)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106028985275310298)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED\C5D0 \C758\D574 \D2B8\B9AC\AC70\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105215438735309633)
,p_name=>'PE.PROPERTY.WHEN_TYPE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105271271158309674)
,p_name=>'PENDING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\B958 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105361690232309744)
,p_name=>'PENDING_ENTRIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\B958 \C911\C778 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105370350320309750)
,p_name=>'PENDING_REQUESTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\B958 \C911\C778 \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105392466880309767)
,p_name=>'PERCENT_CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\ACB0 \BE44\C728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105390333357309765)
,p_name=>'PERCENT_COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC\C728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105392546942309767)
,p_name=>'PERCENT_OPENED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\ACB0 \BE44\C728')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105349502541309735)
,p_name=>'PIE_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C774 \CC28\D2B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105371617577309751)
,p_name=>'PKC1'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4 1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105371768892309751)
,p_name=>'PKC2'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \C5F4 2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106063947908310331)
,p_name=>'PKG.APP.AVAILABLE.TO.INSTALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58\D560 \C218 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106064007531310331)
,p_name=>'PKG.APP.AVAILABLE.TO.UPGRADE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\ADF8\B808\C774\B4DC\D560 \C218 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106064117453310331)
,p_name=>'PKG.APP.EVENTS_FOR_LAST_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C0B0\C131/\C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158 \C774\BCA4\D2B8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106067520898310335)
,p_name=>'PKG.APP.USER_ACTIVITY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BA85\C758 \C0AC\C6A9\C790 - %1 \BDF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106107241355310371)
,p_name=>'PKG_APP_INSTALL.PREREQ_CHECK_FAILED'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2E4\C74C \D544\C694 \C870\AC74 \AC80\C0AC\B97C \C2E4\D328\D588\C2B5\B2C8\B2E4. \C774\B7EC\D55C \BB38\C81C\AC00 \D574\ACB0\B420 \B54C\AE4C\C9C0\B294 \C774 \C560\D50C\B9AC\CF00\C774\C158 \BC0F \D574\B2F9 \C9C0\C6D0 \AC1D\CCB4 \C124\CE58\B97C \ACC4\C18D\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106107403406310372)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_EXISTS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\AC1D\CCB4\AC00 \C874\C7AC\D568: <br />'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106107361790310371)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_REQUIRED_PRIVS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D544\C694\D55C \AD8C\D55C: <br />'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106092557964310358)
,p_name=>'PKG_APP_USER_TYPE_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\C5D0\C11C\B294 Application Express \C791\C5C5\C601\C5ED \AD00\B9AC\C790, \C560\D50C\B9AC\CF00\C774\C158 \AC1C\BC1C\C790 \BC0F \C77C\BC18 \C0AC\C6A9\C790\C5D0 \B300\D55C \C561\C138\C2A4\B97C \C81C\C5B4\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C791\C5C5\C601\C5ED \AD00\B9AC\C790</strong>\B294 \C560\D50C\B9AC\CF00\C774\C158\C744 \C124\CE58, \C81C\AC70 \B610\B294 \C5C5\ADF8\B808\C774\B4DC\D558\ACE0, \C0AC\C6A9\C790 \ACC4\C815 \BC0F \AC1C\BC1C \C11C\BE44\C2A4\B97C \AD00\B9AC\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\AC1C\BC1C\C790</strong>\B294 \C560\D50C\B9AC\CF00\C774\C158\C744 \C124\CE58, \C81C\AC70 \B610\B294 \C5C5\ADF8\B808\C774\B4DC\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C77C\BC18 \C0AC\C6A9\C790</strong>\B294 \AC1C\BC1C \AD8C\D55C\C774 \C5C6\C73C\BA70, \C678\BD80 \C778\C99D \CCB4\ACC4\B97C \C0AC\C6A9\D558\C9C0 \C54A\B294 \C560\D50C\B9AC\CF00\C774\C158\B9CC \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106063895898310331)
,p_name=>'PLEASE_SELECT_A_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798 \BAA9\B85D\C5D0\C11C \C791\C5C5\C601\C5ED\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105333590824309723)
,p_name=>'PLSQL'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105147306040309583)
,p_name=>'PLSQL_EXPRESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('PLSQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105400261950309772)
,p_name=>'PLSQL_FUNCTION_BODY_LOV_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BB38\C744 \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38 \AE30\BC18 \AC12 \BAA9\B85D\C5D0 \C624\B958\AC00 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105093335755309537)
,p_name=>'PLSQL_PROCEDURE'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105339838197309728)
,p_name=>'PLSQL_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \C601\C5ED')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105634858139309972)
,p_name=>'PLUG-IN FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105613231754309952)
,p_name=>'PLUGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106017479677310287)
,p_name=>'PLUGIN.CATEGORY.COMPONENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106017163154310287)
,p_name=>'PLUGIN.CATEGORY.EFFECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D6A8\ACFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106017319773310287)
,p_name=>'PLUGIN.CATEGORY.EXECUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106068206968310335)
,p_name=>'PLUGIN.CATEGORY.INIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106016975172310287)
,p_name=>'PLUGIN.CATEGORY.MISC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\D0C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106008214395310278)
,p_name=>'PLUGIN.CATEGORY.NAVIGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106017240127310287)
,p_name=>'PLUGIN.CATEGORY.NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106017076347310287)
,p_name=>'PLUGIN.CATEGORY.STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105567120886309916)
,p_name=>'PLUGIN.DEPRECATED'
,p_message_language=>'ko'
,p_message_text=>unistr(' [\B354 \C774\C0C1 \C0AC\C6A9\B418\C9C0 \C54A\C74C]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105353367058309738)
,p_name=>'PLUGIN.DISPLAY_NAME_POSTFIX'
,p_message_language=>'ko'
,p_message_text=>unistr(' [\D50C\B7EC\ADF8\C778]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105899691577310184)
,p_name=>'PLUGIN.LEGACY'
,p_message_language=>'ko'
,p_message_text=>unistr(' [\B808\AC70\C2DC]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105519738940309877)
,p_name=>'PLUGIN.TYPE.AUTHENTICATION_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104899494843309396)
,p_name=>'PLUGIN.TYPE.AUTHORIZATION TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104967146229309446)
,p_name=>'PLUGIN.TYPE.DYNAMIC ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104966539423309445)
,p_name=>'PLUGIN.TYPE.ITEM TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105664709112309998)
,p_name=>'PLUGIN.TYPE.PROCESS TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104966604613309445)
,p_name=>'PLUGIN.TYPE.REGION TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105383991841309760)
,p_name=>'PLUGIN.TYPE.REPORT COLUMN TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106129185908310392)
,p_name=>'PLUGIN_LINK_HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>URL\C744 \C785\B825\D558\B294 \ACBD\C6B0 <code>&amp;APP_ID.</code>, <code>&amp;SESSION.</code> \BC0F <code>&amp;DEBUG.</code> \B300\CCB4 \BB38\C790\C5F4\ACFC <code>&amp;COLUMN_NAME.</code> \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC \B300\C0C1 \D398\C774\C9C0\C758 \D589 ID \B610\B294 \AE30\BCF8 \D0A4\B97C \C124\C815\D558\AC70\B098 \CD94\AC00 \C18D\C131\AC12\C744 \C124\C815\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\C608\C81C</strong></p>'),
'<p><pre>f?p=&amp;APP_ID.:10:&amp;SESSION.::&amp;DEBUG.:10:P10_EMPNO:&amp;EMPNO.</pre></p>',
unistr('<p><code>f?p</code> \AD6C\BB38\C5D0 \B300\D55C \C790\C138\D55C \B0B4\C6A9\C740 Application Express \C0DD\C131\AE30 \C0AC\C6A9 \C124\BA85\C11C\B97C \AC80\D1A0\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105385058200309761)
,p_name=>'PLUGIN_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778\C774 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105716791494310045)
,p_name=>'PNONUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\AD6D \C678\BD80\C5D0 \AC70\C8FC\D558\B294 \C9C1\C6D0 \BE44\C728')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105095195975309538)
,p_name=>'POPUP_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105433652029309805)
,p_name=>'POPUP_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105394073761309768)
,p_name=>'POST AUTH PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\D6C4 \C778\C99D \D504\B85C\C138\C2A4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105393810852309768)
,p_name=>'PRE AUTH PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \C778\C99D \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105277181314309679)
,p_name=>'PRECISION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \C790\B9BF\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105614408768309953)
,p_name=>'PREFERENCES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105086227056309532)
,p_name=>'PREFS_APPLY_PERMISSIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105086852948309532)
,p_name=>'PREFS_NOACTION_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C694\D55C \C791\C5C5 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105086567755309532)
,p_name=>'PREFS_REVOKE_PERMISSIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104952319101309435)
,p_name=>'PREF_EQ_EXP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD\C5D0 \C788\B294 \D658\ACBD\C124\C815\C758 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104952440983309435)
,p_name=>'PREF_NE_EXP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD 1\C5D0 \C788\B294 \D658\ACBD\C124\C815\C758 \AC12\C740 \D45C\D604\C2DD 2\C640 \AC19\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105054443733309509)
,p_name=>'PRESENTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B9AC\C820\D14C\C774\C158')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105114049978309552)
,p_name=>'PRINT SERVER NOT CONFIGURED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4 \C11C\BC84\AC00 \AD6C\C131\B418\C5B4 \C788\C9C0 \C54A\C73C\BBC0\B85C \D604\C7AC \BCF4\ACE0\C11C \C778\C1C4\B97C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105362010349309744)
,p_name=>'PRINT_SERVER_ADVANCED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09(Oracle BI Publisher \D544\C694)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105362112257309744)
,p_name=>'PRINT_SERVER_STANDARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105347240568309733)
,p_name=>'PRIORITIZED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6B0\C120\C21C\C704 \C9C0\C815\B428')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105357767722309741)
,p_name=>'PROBLEMS_CORRECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C815\B41C \BB38\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105357683803309741)
,p_name=>'PROBLEMS_IDENTIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DD\BCC4\B41C \BB38\C81C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105092096023309536)
,p_name=>'PROCEDURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C2DC\C800')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106005577413310275)
,p_name=>'PROCESS.NATIVE_DATA_LOADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104869631641309371)
,p_name=>'PROCESS.NATIVE_PLSQL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF54\B4DC \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104869773331309371)
,p_name=>'PROCESS.NATIVE_SEND_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C804\C1A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104956382641309438)
,p_name=>'PROCESSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104889849755309388)
,p_name=>'PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\C744 \CC98\B9AC\D558\B294 \C911\C785\B2C8\B2E4. \AE30\B2E4\B9AC\C2ED\C2DC\C624.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105679339341310011)
,p_name=>'PRODUCTION_DOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\B355\C158 \C791\B3D9 \C911\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106079693854310346)
,p_name=>'PRODUCT_PORTAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\D488 \D3EC\D138')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106094426137310360)
,p_name=>'PROMPT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B86C\D504\D2B8: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104909404413309404)
,p_name=>'PROVIDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104909565593309404)
,p_name=>'PROVIDER_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\C790 \C804\C790\BA54\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105366405821309747)
,p_name=>'PROVISIONED'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B4F1\B85D\B428'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105480992097309844)
,p_name=>'PROVISIONED_SPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4F1\B85D\B41C \AE30\C874 \ACF5\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105362216906309744)
,p_name=>'PROVISIONING_MODE_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D655\C778\C744 \D3EC\D568\D55C \C0AC\C6A9\C790 \C694\CCAD\C73C\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105362437466309744)
,p_name=>'PROVISIONING_MODE_MANUAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105362322665309744)
,p_name=>'PROVISIONING_MODE_REQUEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C694\CCAD\C73C\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105100661569309542)
,p_name=>'PROVISION_REQUEST.ADMIN_INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105101699823309543)
,p_name=>'PROVISION_REQUEST.CREATE_TBLSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C2A4\D398\C774\C2A4\AC00 \C0DD\C131\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105101892356309543)
,p_name=>'PROVISION_REQUEST.DATAFILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C2A4\D398\C774\C2A4\C5D0 \B300\D55C \B370\C774\D130 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105100403371309542)
,p_name=>'PROVISION_REQUEST.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105100868314309542)
,p_name=>'PROVISION_REQUEST.EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105101782758309543)
,p_name=>'PROVISION_REQUEST.FLOW_XXX'
,p_message_language=>'ko'
,p_message_text=>'APEX_XXX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105100165004309542)
,p_name=>'PROVISION_REQUEST.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105099917114309542)
,p_name=>'PROVISION_REQUEST.NEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 %0\C744(\B97C) \B4F1\B85D\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105101484845309543)
,p_name=>'PROVISION_REQUEST.NO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105101252933309543)
,p_name=>'PROVISION_REQUEST.REUSE_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C2A4\D0A4\B9C8 \C7AC\C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105101181248309543)
,p_name=>'PROVISION_REQUEST.SCHEMA_INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105101553132309543)
,p_name=>'PROVISION_REQUEST.SCHEMA_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105100264595309542)
,p_name=>'PROVISION_REQUEST.SGID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105100304263309542)
,p_name=>'PROVISION_REQUEST.SYSTEM_ASSIGNED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C2A4\D15C\C774 \C9C0\C815\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105100947210309543)
,p_name=>'PROVISION_REQUEST.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105100779595309542)
,p_name=>'PROVISION_REQUEST.USER_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105100042128309542)
,p_name=>'PROVISION_REQUEST.WORKSPACE_INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105101392676309543)
,p_name=>'PROVISION_REQUEST.YES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105405486038309776)
,p_name=>'PROXY_SERVER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85D\C2DC \C11C\BC84')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105087385393309533)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \D56D\BAA9 \B3C4\C6C0\B9D0\C744 \C0C8\B85C\ACE0\CE68\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105087446959309533)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\D655\D558\BA74 <b>\BAA8\B450 \C0C8\B85C\ACE0\CE68</b>\C744 \B204\B974\ACE0, \ADF8\B807\C9C0 \C54A\C73C\BA74 <b>\CDE8\C18C</b>\B97C \B204\B974\C2ED\C2DC\C624.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105711114573310041)
,p_name=>'PURGE.ADMINISTRATORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105706885675310038)
,p_name=>'PURGE.BEGIN_DELETE_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %0 \C0AD\C81C \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105706688359310038)
,p_name=>'PURGE.BEGIN_DROP_TABLESPACE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C791\C5C5\C601\C5ED %1\C5D0 \B300\D55C \D14C\C774\BE14\C2A4\D398\C774\C2A4 %0 \C0AD\C81C \C2DC\C791'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105706224013310037)
,p_name=>'PURGE.BEGIN_DROP_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %1\C5D0 \B300\D55C \C0AC\C6A9\C790 %0 \C0AD\C81C \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105705854018310037)
,p_name=>'PURGE.BEGIN_PURGE_OF_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C791\C5C5\C601\C5ED \BE44\C6B0\AE30 \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105711073987310041)
,p_name=>'PURGE.BYTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105707159799310038)
,p_name=>'PURGE.DELETE_WORKSPACE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %0 \C0AD\C81C \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105706782518310038)
,p_name=>'PURGE.DROP_TABLESPACE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %1\C5D0 \B300\D55C \D14C\C774\BE14\C2A4\D398\C774\C2A4 %0 \C0AD\C81C \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105706531095310037)
,p_name=>'PURGE.DROP_USER_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %1\C5D0 \B300\D55C \C0AC\C6A9\C790 %0 \C0AD\C81C \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105705685589310037)
,p_name=>'PURGE.EMAIL_BODY'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Oracle APEX \C0AC\C6A9\C790\B2D8,'),
'',
unistr('%1\C5D0 \C788\B294 %0 \C791\C5C5\C601\C5ED\C5D0 \CD5C\ADFC \C791\C5C5\C774 \D45C\C2DC\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \BE44\D65C\C131 \C0C1\D0DC\C758 \C791\C5C5\C601\C5ED\C740 \D604\C7AC %2 \C774\D6C4\C5D0 \BE44\C6CC\C9C0\B3C4\B85D \C77C\C815\C774 \C7A1\D614\C2B5\B2C8\B2E4.'),
'',
unistr('\C791\C5C5\C601\C5ED\C774 \C81C\AC70\B418\C9C0 \C54A\B3C4\B85D \D558\B824\BA74 \C544\B798 URL\C744 \B204\B974\ACE0 \C791\C5C5\C601\C5ED\C744 \BE44\C6B0\C9C0 \C54A\B3C4\B85D \C120\D0DD\D558\C2ED\C2DC\C624. \C774 \C791\C5C5\C740 \B2E4\C74C %3\C77C \C774\B0B4\C5D0 \C218\D589\D574\C57C \D569\B2C8\B2E4. \C774 \C791\C5C5\C601\C5ED\C774 \B354 \C774\C0C1 \D544\C694\D558\C9C0 \C54A\C73C\BA74 \C544\BB34\B7F0 \C870\CE58\B3C4 \C218\D589\D560 \D544\C694\AC00 \C5C6\C2B5\B2C8\B2E4.'),
'',
unistr('\D655\C778 \B9C1\D06C: %4')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105705715167310037)
,p_name=>'PURGE.EMAIL_SUBJECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6CC\C9C8 Oracle APEX \C791\C5C5\C601\C5ED: %1\C758 %0 \C791\C5C5\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105706947279310038)
,p_name=>'PURGE.END_DELETE_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %0 \C0AD\C81C \C885\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106017898255310287)
,p_name=>'PURGE.END_DROP_TABLESPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %1\C5D0 \B300\D55C \D14C\C774\BE14\C2A4\D398\C774\C2A4 %0 \C0AD\C81C \C885\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105706445345310037)
,p_name=>'PURGE.END_DROP_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %1\C5D0 \B300\D55C \C0AC\C6A9\C790 %0 \C0AD\C81C \C885\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105703786491310035)
,p_name=>'PURGE.LOG.ADD_TO_PURGE_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6B0\AE30 \BAA9\B85D\C5D0 \C791\C5C5\C601\C5ED %0\C744(\B97C) \CD94\AC00\D569\B2C8\B2E4. %1\C77C \B3D9\C548 \C0AC\C6A9\D558\C9C0 \C54A\C740 \C791\C5C5\C601\C5ED\C740 \BE44\D65C\C131\D654\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105703834240310035)
,p_name=>'PURGE.LOG.REMOVE_FROM_PURGE_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC \C791\C5C5\C73C\B85C \C778\D574 \BE44\C6B0\AE30 \BAA9\B85D\C5D0\C11C \C791\C5C5\C601\C5ED %0\C744(\B97C) \C81C\AC70\D558\B294 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105703998213310036)
,p_name=>'PURGE.LOG.SENT_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C\C744 %0(\C73C)\B85C \C804\C1A1\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105704340246310036)
,p_name=>'PURGE.MOVED_TO_PURGE_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C874 \BAA9\B85D\C5D0\C11C \BE44\C6B0\AE30 \BAA9\B85D\C73C\B85C %0 \C791\C5C5\C601\C5ED\C744 \C774\B3D9\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105710289544310040)
,p_name=>'PURGE.REPORT_BYTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105707630059310038)
,p_name=>'PURGE.REPORT_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105710109172310040)
,p_name=>'PURGE.REPORT_DATAFILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105709872561310040)
,p_name=>'PURGE.REPORT_SCHEMAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105707530536310038)
,p_name=>'PURGE.REPORT_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105707917283310039)
,p_name=>'PURGE.REPORT_SUMMARY_DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6B0\AE30 \BAA9\B85D\C5D0\C11C \C81C\AC70\B428(\CD5C\ADFC \C791\C5C5\C73C\B85C \C778\D574)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105708666531310039)
,p_name=>'PURGE.REPORT_SUMMARY_MOVED_TO_NEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6B0\AE30 \BAA9\B85D\C5D0 \B2E4\C2DC \CD94\AC00\B428(\C774\C804\C5D0 \BCF4\C874\B418\C5C8\C9C0\B9CC %0\C77C \B3D9\C548 \C791\C5C5 \C5C6\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105708305020310039)
,p_name=>'PURGE.REPORT_SUMMARY_NEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6B0\AE30 \BAA9\B85D\C5D0 \C0C8\B85C \CD94\AC00\B428(%0\C77C \B3D9\C548 \C791\C5C5 \C5C6\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105709298473310040)
,p_name=>'PURGE.REPORT_SUMMARY_PURGED_TODAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B298 \BE44\C6CC\C9D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105708162115310039)
,p_name=>'PURGE.REPORT_SUMMARY_RETAIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C874\B428(\AD00\B9AC\C790\AC00 \C791\C5C5\C601\C5ED\C744 \C0AD\C81C\D558\C9C0 \C54A\B3C4\B85D \C694\CCAD\D568)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105708821340310039)
,p_name=>'PURGE.REPORT_SUMMARY_TO_BE_PURGED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C77C \D6C4 \BE44\C6B0\AE30 \C608\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105709979565310040)
,p_name=>'PURGE.REPORT_TABLESPACES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C2A4\D398\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105709713666310040)
,p_name=>'PURGE.REPORT_WORKSPACES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105709318260310040)
,p_name=>'PURGE.REPORT_WORKSPACES_REMAINING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A8\C740 \C791\C5C5\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105704137622310036)
,p_name=>'PURGE.SAVE_RESPONSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C %0\C5D0\C11C \BCF4\B0B8 \C751\B2F5: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105710844903310041)
,p_name=>'PURGE.SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105705927909310037)
,p_name=>'PURGE.SET_SCHEMA_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('%2 \C791\C5C5\C601\C5ED\C5D0 \B300\D55C \C2A4\D0A4\B9C8 %0\C758 \C0C1\D0DC\B97C \C0C1\D0DC %1(\C73C)\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105706061616310037)
,p_name=>'PURGE.SET_TABLESPACE_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('%2 \C791\C5C5\C601\C5ED\C5D0 \B300\D55C \D14C\C774\BE14\C2A4\D398\C774\C2A4 %0\C758 \C0C1\D0DC\B97C \C0C1\D0DC %1(\C73C)\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105716302847310045)
,p_name=>'PURGE.SUBJECT_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('Application Express \C77C\C77C \C791\C5C5\C601\C5ED \BE44\C6B0\AE30 \C694\C57D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105710917423310041)
,p_name=>'PURGE.TABLESPACE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C2A4\D398\C774\C2A4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105711431841310041)
,p_name=>'PURGE.WORKSPACES_ADDED_BACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6B0\AE30 \BAA9\B85D\C5D0 \C791\C5C5\C601\C5ED\C774 \B2E4\C2DC \CD94\AC00\B428(\C774\C804\C5D0 \BCF4\C874\B418\C5C8\C9C0\B9CC %0\C77C \B3D9\C548 \C791\C5C5 \C5C6\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105711332035310041)
,p_name=>'PURGE.WORKSPACES_NEWLY_ADDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6B0\AE30 \BAA9\B85D\C5D0 \C791\C5C5\C601\C5ED\C774 \C0C8\B85C \CD94\AC00\B428(%0\C77C \B3D9\C548 \C791\C5C5 \C5C6\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105710355983310040)
,p_name=>'PURGE.WORKSPACES_PURGED_SUMMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6CC\C9C4 \C791\C5C5\C601\C5ED \C694\C57D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105710510309310040)
,p_name=>'PURGE.WORKSPACES_PURGED_TODAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B298 \BE44\C6CC\C9C4 \C791\C5C5\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105711576055310041)
,p_name=>'PURGE.WORKSPACES_REMOVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6B0\AE30 \BAA9\B85D\C5D0\C11C \C791\C5C5\C601\C5ED\C774 \C81C\AC70\B428(\CD5C\ADFC \C791\C5C5\C73C\B85C \C778\D574)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105711659366310041)
,p_name=>'PURGE.WORKSPACES_RETAINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C774 \BCF4\C874\B428(\AD00\B9AC\C790\AC00 \C791\C5C5\C601\C5ED\C744 \C0AD\C81C\D558\C9C0 \C54A\B3C4\B85D \C694\CCAD\D568)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105711231080310041)
,p_name=>'PURGE.WORKSPACES_TO_BE_PURGED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C77C \D6C4 \BE44\C6CC\C9C8 \C608\C815\C778 \C791\C5C5\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105710796706310041)
,p_name=>'PURGE.WORKSPACE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105707444097310038)
,p_name=>'PURGE.WORKSPACE_PURGE_COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED %0 \BE44\C6B0\AE30 \C644\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106009333527310279)
,p_name=>'PURGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6CC\C9D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106094055223310359)
,p_name=>'PURGE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6B0\AE30: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105471545404309837)
,p_name=>'QB_ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('&nbsp;\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105148792210309584)
,p_name=>'QB_CREATE_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACB0\ACFC\B97C \D655\C778\D558\B824\BA74 \C801\D569\D55C \C9C8\C758\B97C \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105471356391309837)
,p_name=>'QB_DUPLICATE_QUERY'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C9C8\C758 \C791\C131\AE30 \B610\B294 SQL \BA85\B839 \CC98\B9AC\AE30\C5D0 \C788\B294 \AE30\C874 \C9C8\C758\C5D0\C11C \C774\BBF8 \C0AC\C6A9\B41C \C774\B984\C785\B2C8\B2E4.<br> '),
unistr('\C0C8 \C774\B984\C744 \C120\D0DD\D558\C5EC \B2E4\C2DC \C800\C7A5\D558\C2ED\C2DC\C624.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105330006482309720)
,p_name=>'QB_NOTHING_TO_SAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5 \C0AC\D56D\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105310259631309705)
,p_name=>'QB_SAVE_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\AC00 \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105476856324309841)
,p_name=>'QB_TABLE_ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105476957992309841)
,p_name=>'QB_VIEW_ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105429682737309801)
,p_name=>'QB_WARN_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C2DC\AC01\C801 \C9C8\C758 \C791\C131\AE30\AC00 \D604\C7AC \C9C8\C758\B97C \C5F4 \C218 \C5C6\C2B5\B2C8\B2E4.<br>'),
unistr('\D604\C7AC \C9C8\C758\B97C \C0C8 \C9C8\C758\B85C \BC14\AFB8\B824\BA74 [\C0DD\C131]\C744 \B204\B974\ACE0, \D604\C7AC \C9C8\C758\B97C \ADF8\B300\B85C \C0AC\C6A9\D558\B824\BA74 [\B3CC\C544\AC00\AE30]\B97C \B204\B985\B2C8\B2E4.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105429508430309801)
,p_name=>'QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104954648176309436)
,p_name=>'QUERY BUILDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \C791\C131\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105121517805309558)
,p_name=>'QUERY.INVALID_NO_SELECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C9C8\C758\C785\B2C8\B2E4. Select \BB38\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104954447519309436)
,p_name=>'QUESTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\BB38')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105673856760310007)
,p_name=>'QUICKPICK_NUMERIC_MASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C22B\C790 \D615\C2DD \B9C8\C2A4\D06C: 999G999G999G999G990')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105479811339309844)
,p_name=>'QUICKSQL.ABOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('Quick SQL \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105479919700309844)
,p_name=>'QUICKSQL.ABOUT.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quick SQL\C740 \B4E4\C5EC\C4F4 \D14D\C2A4\D2B8 \BB38\C11C\C5D0\C11C \AD00\ACC4\D615 \B370\C774\D130 \BAA8\B378\C744 \C0DD\C131\D558\B294 \B370 \D544\C694\D55C SQL\C744 \BE60\B974\AC8C \C0DD\C131\D560 \C218 \C788\B294 \BC29\BC95\C744 \C81C\ACF5\D569\B2C8\B2E4. \C774 \D234\C740 SQL \D14C\C774\BE14, \D2B8\B9AC\AC70 \BC0F \C778\B371\C2A4 \AD6C\C870 \C0DD\C131\C5D0 \D544\C694\D55C \C2DC\AC04\ACFC \C791\C5C5\C744 \C904\C77C \C218 \C788\B3C4\B85D \C124\ACC4\B418\C5C8\C2B5\B2C8\B2E4. \C774 \D234\C740 \B370\C774\D130 \BAA8\B378\B9C1\C744 \B300\CCB4\D558\B294 \D234\C774 \C544\B2C8\B77C, \B2E8\C21C \D14C\C774\BE14 \BC0F \BDF0\C5D0 \B300\D55C \C2A4\D06C\B9BD\D2B8\B97C \BE60\B974\AC8C \AC1C\BC1C\D558\AE30 \C704\D55C \C6A9\B3C4\B85C\B9CC \C0AC\C6A9\B429\B2C8\B2E4. SQL\C774 \C0DD\C131\B418\BA74 \D574\B2F9 SQL\C744 \C870\C815 \BC0F \D655\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\CD5C\C0C1\C758 \C0AC\C6A9 \C0AC\B840:'),
'<ul>',
unistr('  <li>\BE60\B974\AC8C \AC15\B825\D55C \B370\C774\D130 \BAA8\B378 \C0DD\C131</li>'),
unistr('  <li>Quick SQL \C18D\AE30 \AD6C\BB38\C744 \BAA8\B378\B85C \C800\C7A5\D558\C5EC \BAA8\B378 \BCC0\ACBD\C0AC\D56D\C744 \BC18\BCF5\D558\AC70\B098 \D15C\D50C\B9AC\D2B8 \BAA8\B378\B85C \C0AC\C6A9\D558\C5EC \BC14\B85C \B2E4\C74C \BAA8\B378 \C124\ACC4 \C2DC\C791</li>'),
unistr('  <li>\AC04\D3B8\D558\AC8C \BB34\C791\C704 \B370\C774\D130 \C0DD\C131</li>'),
unistr('  <li>SQL create table, select, insert, index, trigger, PL/SQL \D328\D0A4\C9C0 \C775\D788\AE30 \BC0F \C81C\ACF5\B41C \C608\B97C \C0AC\C6A9\D558\C5EC \AD6C\BB38 \D655\C778</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105372752815309752)
,p_name=>'QUICKSQL.APEX_SETTING_PART1'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \C124\C815\C5D0 \B530\B77C \AC10\C0AC \C5F4\C744 \C9C0\C6D0\D558\B3C4\B85D \C0DD\C131\B418\B294 \AD6C\BB38\C774 \C81C\C5B4\B429\B2C8\B2E4. \D2B9\D788 \AC10\C0AC \C5F4\C774 \C0AC\C6A9\C73C\B85C \C124\C815\B418\BA74 \D589\C744 \C0DD\C131\D55C \C0AC\C6A9\C790 \BC0F \D589\C744 \B9C8\C9C0\B9C9\C73C\B85C \C5C5\B370\C774\D2B8\D55C \C0AC\C6A9\C790\B97C \C720\C9C0\BCF4\C218\D560 \D2B8\B9AC\AC70\AC00 \C0DD\C131\B429\B2C8\B2E4. \C0AC\C6A9\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \B2E4\C74C \D568\C218\AC00 \C0AC\C6A9\B429\B2C8\B2E4.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105372868310309752)
,p_name=>'QUICKSQL.APEX_SETTING_PART2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815\D558\C9C0 \C54A\C744 \ACBD\C6B0 \B2E4\C74C \D568\C218\AC00 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105372947152309752)
,p_name=>'QUICKSQL.API_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \D14C\C774\BE14\C5D0 \B300\D574 \C0DD\C131, \C0BD\C785, \C5C5\B370\C774\D2B8, \C0AD\C81C \BC0F \C9C8\C758\C6A9 PL/SQL API\B97C \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105373079887309752)
,p_name=>'QUICKSQL.AUDITCOLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\B41C \BAA8\B4E0 \D14C\C774\BE14\C5D0 created, created_by, updated \BC0F updated_by \C5F4\C744 \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105373191934309752)
,p_name=>'QUICKSQL.COMPRESS_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \BAA8\B4E0 \D14C\C774\BE14\C744 \C555\CD95\D558\C5EC \C0DD\C131\D569\B2C8\B2E4. \AE30\BCF8\AC12\C740 \C555\CD95\D558\C9C0 \C54A\B294 \AC83\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105373231093309752)
,p_name=>'QUICKSQL.CREATEDBYCOL_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC10\C0AC \C5F4\C774 \C0AC\C6A9\C73C\B85C \C124\C815\B418\BA74 \D589\C744 \C0DD\C131\D55C \C0AC\C6A9\C790\B97C \CD94\C801\D558\B294 \B370 \C0AC\C6A9\B418\B294 \AE30\BCF8 \C5F4\C774 CREATED_BY\C785\B2C8\B2E4. \C774 \C124\C815\C744 \C0AC\C6A9\D558\C5EC \AE30\BCF8 \AC10\C0AC \C5F4 \C774\B984\C744 \BB34\D6A8\D654\D560 \C218 \C788\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105373338637309752)
,p_name=>'QUICKSQL.CREATED_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC10\C0AC \C5F4\C774 \C0AC\C6A9\C73C\B85C \C124\C815\B418\BA74 \D589\C744 \C0DD\C131\D55C \C0AC\C6A9\C790\B97C \CD94\C801\D558\B294 \B370 \C0AC\C6A9\B418\B294 \AE30\BCF8 \C5F4\C774 CREATED\C785\B2C8\B2E4. \C774 \C124\C815\C744 \C0AC\C6A9\D558\C5EC \AE30\BCF8 \AC10\C0AC \C5F4 \C774\B984\C744 \BB34\D6A8\D654\D560 \C218 \C788\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105375308561309754)
,p_name=>'QUICKSQL.DATE_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\C801\C73C\B85C \BAA8\B4E0 DATE \C5F4\C740 Oracle DATE \B370\C774\D130 \C720\D615\C744 \C0AC\C6A9\D558\C5EC \C0DD\C131\B429\B2C8\B2E4. \C774 \C124\C815\C744 \C0AC\C6A9\D558\C5EC \D574\B2F9 \AE30\BCF8\AC12\C744 \BB34\D6A8\D654\D560 \C218 \C788\C2B5\B2C8\B2E4. \C801\D569\D55C \AC12\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105377681086309756)
,p_name=>'QUICKSQL.DB_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BB38\C774 \D638\D658\B418\C5B4\C57C \D560 \B370\C774\D130\BCA0\C774\C2A4 \BC84\C804\C744 \C9C0\C815\D569\B2C8\B2E4. \C801\D569\D55C \AC12\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105382002631309759)
,p_name=>'QUICKSQL.DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106049629012310318)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C11C \BC0F \C0AC\C6D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106050228811310319)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES_DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C870\C778 VIEW\B85C DEPARTMENTS \BC0F EMPLOYEES \D14C\C774\BE14\C744 \C0DD\C131\D558\B294 \C18D\AE30 SQL \AD6C\BB38\C785\B2C8\B2E4. \B610\D55C /INSERT \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC \BB34\C791\C704 \B370\C774\D130\B97C \C0DD\C131\D569\B2C8\B2E4. /NN\C740 NOT NULL SQL \C5F4 \C81C\C57D \C870\AC74\C744 \CD94\AC00\D569\B2C8\B2E4. \B4E4\C5EC\C4F4 \BAA9\B85D\C740 \D14C\C774\BE14, \C5F4 \BC0F \D558\C704 \D14C\C774\BE14 \C815\C758\C5D0 \C0AC\C6A9\B429\B2C8\B2E4. \AE30\BCF8 \BC0F \C678\B798 \D0A4 \C5F4\C740 \C790\B3D9\C73C\B85C \CD94\AC00\B429\B2C8\B2E4. \B530\B77C\C11C \AE30\BCF8 \B610\B294 \C678\B798 \D0A4 \C5F4\C740 \C81C\ACF5\D560 \D544\C694\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105302158550309698)
,p_name=>'QUICKSQL.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105380775672309758)
,p_name=>'QUICKSQL.DROP_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\B41C \AC01 \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C0AD\C81C\D560 SQL \BA85\B839\C744 \D3EC\D568\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106049845373310318)
,p_name=>'QUICKSQL.EMPLOYEESKILLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6D0 \AE30\C220')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106050095127310319)
,p_name=>'QUICKSQL.EMPLOYEESKILLS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4E4\C5EC\C4F0\AE30\B97C \C0AC\C6A9\D558\C5EC \C0C1\C704 \BC0F \D558\C704 \D14C\C774\BE14\C744 \C2DD\BCC4\D558\B294 DEPARTMENTS, EMPLOYEES \BC0F SKILLS \D14C\C774\BE14\C744 \C0DD\C131\D569\B2C8\B2E4. \C18D\AE30 \AD6C\BB38 VC255\B294 SQL \B370\C774\D130 \C720\D615 \C9C0\C815\C5D0 \C0AC\C6A9\B418\BA70, /INSERT \AD6C\BB38\C740 \BB34\C791\C704 \B370\C774\D130 \C0DD\C131\C5D0 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105301994745309697)
,p_name=>'QUICKSQL.EXAMPLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105480285885309844)
,p_name=>'QUICKSQL.EXAMPLE_N'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105382771310309760)
,p_name=>'QUICKSQL.GENPK_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01 \D14C\C774\BE14\C5D0 \B300\D574 \C790\B3D9\C73C\B85C ID \AE30\BCF8 \D0A4 \C5F4\C744 \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105480077289309844)
,p_name=>'QUICKSQL.GETTING_STARTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791\D558\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105480183304309844)
,p_name=>'QUICKSQL.GETTING_STARTED.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B4E4\C5EC\C4F0\AE30 \C5C6\C774 \C0C1\C704 \D14C\C774\BE14 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \B450 \AC1C \C774\C0C1\C758 \ACF5\AC04\C5D0 \B3D9\C77C\D55C \B4E4\C5EC\C4F0\AE30\B97C \C801\C6A9\D558\C5EC \D14C\C774\BE14 \C5F4\C744 \C785\B825\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \C2DC\C2A4\D15C\C5D0\C11C \C790\B3D9\C73C\B85C \C0DD\C131\D558\B3C4\B85D \AE30\BCF8 \D0A4\B97C \C9C0\C815\D558\C9C0 \C54A\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4. \C0C1\C704 \D14C\C774\BE14 \C544\B798\C5D0 \D558\C704 \D14C\C774\BE14\C744 \B4E4\C5EC\C4F0\BA74 \C0C1\C704-\D558\C704 \AD00\ACC4\AC00 \C0DD\C131\B429\B2C8\B2E4.</p>'),
'',
unistr('<p>\C77C\BC18\C801\C73C\B85C \B370\C774\D130 \C720\D615\C758 \AE30\BCF8\AC12\C740 VARCHAR2\B85C \C124\C815\B429\B2C8\B2E4. \B2E4\B978 \B370\C774\D130 \C720\D615\C758 \C5F4\C744 \C0AC\C6A9\D558\B824\BA74 \C5F4 \C774\B984 \B05D\C5D0 \ACF5\BC31\ACFC \D568\AED8 NUM, INT, DATE\B97C \CD94\AC00\D569\B2C8\B2E4. \C2DC\C2A4\D15C\C5D0\C11C\B294 \C9C0\C815\B41C \B370\C774\D130 \C720\D615\C774 \C5C6\C744 \ACBD\C6B0 \C5F4 \C774\B984\C5D0 \D3EC\D568\B41C \C601\C5B4 \D14D\C2A4\D2B8\B97C \AE30\BC18\C73C\B85C \C77C\BD80 \C5F4 \C774\B984\C744 \C801\C808\D788 \CD94\B860\D569\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \C5F4 \C774\B984\C5D0 DATE\B77C\B294 \B2E8\C5B4\AC00 \D3EC\D568\B41C \ACBD\C6B0 \B370\C774\D130 \C720\D615\C774 \B0A0\C9DC\B85C \AC04\C8FC\B418\ACE0, \C5F4 \C774\B984\C5D0 NUMBER \B610\B294 NUM\C774\B77C\B294 \B2E8\C5B4\AC00 \D3EC\D568\B41C \ACBD\C6B0 \B370\C774')
||unistr('\D130 \C720\D615\C774 \C22B\C790\B85C \AC04\C8FC\B429\B2C8\B2E4. \D2B9\C815 VARCHAR2 \AE38\C774\B97C \C9C0\C815\D558\B824\BA74 VCn\C744 \C785\B825\D569\B2C8\B2E4. \C5EC\AE30\C11C "n"\C740 VARCHAR2\C758 \AE38\C774\C785\B2C8\B2E4. [\AD6C\BB38] \B2E8\CD94\B97C \B204\B974\BA74 \C0AC\C6A9 \AC00\B2A5\D55C \AD6C\BB38\C774 \D45C\C2DC\B429\B2C8\B2E4. \AC1D\CCB4 \C774\B984\C740 \C790\B3D9\C73C\B85C \D615\C2DD\C774 \C9C0\C815\B418\BA70 \ACF5\BC31\C740 \BC11\C904\B85C \BC14\B00C\BBC0\B85C \C5F4 \BC0F \D14C\C774\BE14 \C774\B984\C5D0 \ACF5\BC31\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>[\C124\C815] \B2E8\CD94\B97C \B204\B974\BA74 \B2E4\C591\D55C \C0DD\C131 \C635\C158\C774 \D45C\C2DC\B429\B2C8\B2E4. \C790\B3D9\C73C\B85C "\C0AC\C6A9\C790 \C5F4"(\C608: \C81C\ACF5\B41C \D589\C758 \C0DD\C131\C790 \B610\B294 \CD5C\C885 \C5C5\B370\C774\D2B8 \C218\D589\C790 \BC0F \C0DD\C131 \B0A0\C9DC \B610\B294 \CD5C\C885 \C5C5\B370\C774\D2B8 \B0A0\C9DC)\C744 \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4. \D589\C774 \C5C5\B370\C774\D2B8\B420 \B54C\B9C8\B2E4 \C790\B3D9\C73C\B85C 1\C529 \C99D\BD84\B418\B294 \D589 \C2DC\D000\C2A4 \C5F4\C744 \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4. \D589 \C2DC\D000\C2A4\B294 \B193\CE5C \C5C5\B370\C774\D2B8\B97C \AC04\B2E8\D558\AC8C \AC10\C9C0\D558\B294 \B370 \C720\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \D328\D0A4\C9C0\B97C \D14C\C774\BE14\B2F9 \D558\B098\C529 \C81C\ACF5\D558\BA70 \D589 \C9C8\C758/\C0BD\C785/\C5C5\B370\C774\D2B8/\C0AD\C81C \D504\B85C\C2DC\C800\B97C \C81C\ACF5\D558\B294 PL/SQ')
||unistr('L API\B3C4 \C0DD\C131\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106054915194310323)
,p_name=>'QUICKSQL.HELP.API'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \B0B4\C5D0\C11C \B370\C774\D130\B97C \C9C8\C758, \C0BD\C785, \C5C5\B370\C774\D2B8 \BC0F \C0AD\C81C\D560 PL/SQL \D328\D0A4\C9C0 API\B97C \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106055011273310323)
,p_name=>'QUICKSQL.HELP.AUDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle \AC10\C0AC(\AE30\BCF8\C801\C73C\B85C AUDIT ALL ON [TABLE NAME])\B97C \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106055193473310323)
,p_name=>'QUICKSQL.HELP.AUDITCOLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\C73C\B85C UPDATED, UPDATED_BY, INSERTED \BC0F INSERTED_BY \C5F4\ACFC \C5F4 \AC12\C744 \C124\C815\D560 \D2B8\B9AC\AC70 \B17C\B9AC\B97C \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106054345610310322)
,p_name=>'QUICKSQL.HELP.BETWEEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C5D0 \B300\D574 \B2E4\C74C \C0AC\C774 \AC80\C0AC \C81C\C57D \C870\AC74(\C608: /between 1 and 100)\C744 \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106053752467310322)
,p_name=>'QUICKSQL.HELP.CHECK'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF64\B9C8 \B610\B294 \ACF5\BC31\C73C\B85C \AD6C\BD84\B41C \AC12\C744 \C0AC\C6A9\D558\C5EC \AC80\C0AC \C81C\C57D \C870\AC74(\C608: /check Yes, No)\C744 \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105383884219309760)
,p_name=>'QUICKSQL.HELP.COLPREFIX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\B41C \D14C\C774\BE14\C758 \BAA8\B4E0 \C5F4\C5D0 \C774 \AC12\C744 \C811\B450\C5B4\B85C \BD99\C785\B2C8\B2E4. \C81C\ACF5\D558\C9C0 \C54A\C744 \ACBD\C6B0 \C790\B3D9\C73C\B85C \BC11\C904\C744 \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105423974182309797)
,p_name=>'QUICKSQL.HELP.COLUMN_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106054760340310323)
,p_name=>'QUICKSQL.HELP.COMMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\AD04\D638 \B610\B294 \B300\C2DC \B300\C2DC(--) \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC \C124\BA85\C744 \BB36\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106055230431310323)
,p_name=>'QUICKSQL.HELP.COMPRESSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C774 \C555\CD95\B418\C5B4 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106053896164310322)
,p_name=>'QUICKSQL.HELP.CONSTANT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B97C \C0DD\C131\D560 \B54C \C774 \C5F4\C744 \C81C\C57D \C870\AC74 \AC12(\C608: /constant NYC)\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105887118641310174)
,p_name=>'QUICKSQL.HELP.DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \B110\C774\BA74 \AE30\BCF8\AC12\C744 \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105383758115309760)
,p_name=>'QUICKSQL.HELP.FILE_DATATYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('BLOB \C5F4\ACFC \BE0C\B77C\C6B0\C800\B97C \D1B5\D55C \D30C\C77C \B2E4\C6B4\B85C\B4DC \AE30\B2A5\C744 \D5A5\C0C1\C2DC\D0A4\B294 _FILENAME, _CHARSET, _MIMETYPE, _LASTUPD \C5F4\C744 \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106054553339310323)
,p_name=>'QUICKSQL.HELP.FK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\B798 \D0A4 \CC38\C870(\C608: /references table_name)\C785\B2C8\B2E4. \BAA8\B378\C5D0 \C18D\D558\C9C0 \C54A\B294 \D14C\C774\BE14\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106054424231310323)
,p_name=>'QUICKSQL.HELP.HIDDEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\ACA8\C9C4 \C5F4\C740 select * from table\C744 \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105647715715309983)
,p_name=>'QUICKSQL.HELP.INDEX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B41C \C5F4\C5D0 \ACE0\C720\D558\C9C0 \C54A\C740 \C778\B371\C2A4\B97C \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106055373918310323)
,p_name=>'QUICKSQL.HELP.INSERT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB34\C791\C704 \B370\C774\D130\B85C <strong>NN</strong> SQL INSERT \BB38(\C608: /INSERT 20)\C744 \C0DD\C131\D569\B2C8\B2E4(\CD5C\B300\AC12 = 1000).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106054137628310322)
,p_name=>'QUICKSQL.HELP.LOWER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AC12\C744 \C18C\BB38\C790\B85C \AC15\C81C \BCC0\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106054849892310323)
,p_name=>'QUICKSQL.HELP.NNN'
,p_message_language=>'ko'
,p_message_text=>unistr('NNN\C740 1\C5D0\C11C 32767 \C0AC\C774\C758 \C22B\C790\B97C \C2DD\BCC4\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106054271920310322)
,p_name=>'QUICKSQL.HELP.NOTNULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C5D0 \B300\D574 \B110\C774 \C544\B2CC \C81C\C57D \C870\AC74\C744 \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106054694481310323)
,p_name=>'QUICKSQL.HELP.PK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \D14C\C774\BE14\C758 \AE30\BCF8 \D0A4\B85C \C2DD\BCC4\D569\B2C8\B2E4. \C218\B3D9\C73C\B85C \AE30\BCF8 \D0A4\B97C \C9C0\C815\D558\C9C0 \C54A\ACE0 \C774 \C571\C5D0\C11C \C790\B3D9\C73C\B85C \AE30\BCF8 \D0A4 \C5F4\C744 \C0DD\C131\D558\B3C4\B85D \D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106055562800310324)
,p_name=>'QUICKSQL.HELP.REST'
,p_message_language=>'ko'
,p_message_text=>unistr('ORDS(Oracle REST Data Services)\B97C \C0AC\C6A9\D558\C5EC \D14C\C774\BE14\C758 REST \C0AC\C6A9\C744 \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106055421090310323)
,p_name=>'QUICKSQL.HELP.SELECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01 \D14C\C774\BE14\C5D0 \B300\D55C \B370\C774\D130\B97C \C0DD\C131\D55C \D6C4 SQL SELECT \BB38\C744 \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105189466688309614)
,p_name=>'QUICKSQL.HELP.TABLE_UNIQUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \B808\BCA8 \ACE0\C720 \C81C\C57D \C870\AC74 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106053636776310322)
,p_name=>'QUICKSQL.HELP.UNIQUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \C81C\C57D \C870\AC74\C744 \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106054072253310322)
,p_name=>'QUICKSQL.HELP.UPPER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AC12\C744 \B300\BB38\C790\B85C \AC15\C81C \BCC0\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106053941598310322)
,p_name=>'QUICKSQL.HELP.VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B97C \C0DD\C131\D560 \B54C \C0AC\C6A9\D560 \CF64\B9C8\B85C \AD6C\BD84\B41C \AC12 \BAA9\B85D(\C608: /values 1, 2, 3, 4 \B610\B294 /values Yes, No)\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105482623876309846)
,p_name=>'QUICKSQL.IMPLEMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4 \C0DD\C131 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105510519939309870)
,p_name=>'QUICKSQL.IMPLEMENT.DETAIL'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quick SQL \C18D\AE30 \C785\B825 \BC0F \C801\C808\D55C \C124\C815 \C801\C6A9\C744 \C644\B8CC\D558\BA74 SQL\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C0DD\C131\D558\ACE0 \D14C\C774\BE14\C5D0 \BB34\C791\C704 \B370\C774\D130\B97C \CC44\C6B8 \C218 \C788\B294 \C900\BE44\AC00 \B05D\B09C \AC83\C785\B2C8\B2E4. \B2E4\C74C \B2E8\ACC4\B97C \C218\D589\D558\C2ED\C2DC\C624.<br>'),
'<ol>',
unistr('  <li><strong>\BAA8\B378 \C800\C7A5</strong>\C744 \B20C\B7EC \B098\C911\C5D0 \C7AC\C0AC\C6A9\D560 \C218 \C788\B3C4\B85D Quick SQL \C18D\AE30 \AD6C\BB38\C744 \BAA8\B378\B85C \C800\C7A5\D569\B2C8\B2E4.</li>'),
unistr('  <li>\BAA8\B378 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>SQL \C2A4\D06C\B9BD\D2B8 \C800\C7A5</strong>\C744 \B20C\B7EC \CD9C\B825\C744 \C2A4\D06C\B9BD\D2B8\B85C \C800\C7A5\D569\B2C8\B2E4.</li>'),
unistr('  <li>\C2A4\D06C\B9BD\D2B8 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\AC80\D1A0 \BC0F \C2E4\D589</strong>\C744 \B20C\B7EC \C2A4\D06C\B9BD\D2B8 \D3B8\C9D1\AE30\B85C \C774\B3D9\D569\B2C8\B2E4.</li>'),
unistr('  <li>\C2A4\D06C\B9BD\D2B8 \D3B8\C9D1\AE30 \B0B4\C5D0\C11C \C2A4\D06C\B9BD\D2B8 \CF58\D150\CE20\AC00 \C62C\BC14\B978\C9C0 \AC80\D1A0\D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C2E4\D589</strong>\C744 \B20C\B7EC \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C0DD\C131\D569\B2C8\B2E4.</li>'),
unistr('  <li>\C2A4\D06C\B9BD\D2B8 \D655\C778 \D398\C774\C9C0\C5D0\C11C <strong>\C9C0\AE08 \C2E4\D589</strong>\C744 \B204\B985\B2C8\B2E4.</li>'),
unistr('  <li>\ACB0\ACFC \D398\C774\C9C0\C5D0\C11C \CC98\B9AC\B41C \BA85\B839\BB38, \C131\ACF5\D55C \BA85\B839\BB38 \BC0F \C624\B958\AC00 \C788\B294 \BA85\B839\BB38\C744 \AC80\D1A0\D569\B2C8\B2E4.<br>'),
unistr('  \BCF4\ACE0\B41C \C624\B958\AC00 \C788\C744 \ACBD\C6B0 \ACB0\ACFC \D398\C774\C9C0\B97C \D0D0\C0C9\D558\C5EC \D2B9\C815 Oracle \C624\B958 \BA54\C2DC\C9C0\B97C \D655\C778\D569\B2C8\B2E4.</li>'),
unistr('  <li>\C120\D0DD\C801\C73C\B85C <strong>\C2A4\D06C\B9BD\D2B8\C5D0\C11C \C571 \C0DD\C131</strong>\C744 \B20C\B7EC \C571 \C0DD\C131 \B9C8\BC95\C0AC\B85C \C774\B3D9\D558\ACE0 \C2A4\D06C\B9BD\D2B8\C5D0 \C9C0\C815\B41C \D14C\C774\BE14 \BC0F \BDF0\B97C \AE30\BC18\C73C\B85C \D398\C774\C9C0\AC00 \C790\B3D9\C73C\B85C \C0DD\C131\B418\B3C4\B85D \D569\B2C8\B2E4.</li>'),
'</ol>',
'</p>',
'',
unistr('<p><em><strong>\CC38\ACE0:</strong> Oracle\C740 \B098\C911\C5D0 \B3D9\C77C\D55C SQL \C18D\AE30\B97C \C5C5\B370\C774\D2B8\D558\B824\B294 \ACBD\C6B0 \CEF4\D4E8\D130\C5D0 SQL \C18D\AE30\B97C \B2E4\C6B4\B85C\B4DC\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4. \C124\C815\C744 \C9C0\C815\D55C \ACBD\C6B0 [Oracle SQL \CD9C\B825] \CC3D \D558\B2E8\C73C\B85C \C774\B3D9\D558\C5EC <code># settings =</code>\B85C \C2DC\C791\D558\B294 \D589\C744 [Quick SQL \C18D\AE30] \CC3D \C0C1\B2E8\C5D0 \BCF5\C0AC\D558\C2ED\C2DC\C624.<br>'),
unistr('\ADF8\B7F0 \B2E4\C74C <strong>\B2E4\C6B4\B85C\B4DC</strong>\B97C \B20C\B7EC \CEF4\D4E8\D130\C5D0 SQL \D30C\C77C\C744 \C800\C7A5\D558\C2ED\C2DC\C624.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105381700366309759)
,p_name=>'QUICKSQL.LANGUAGE_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5B8\C5B4\B97C \C0AC\C6A9\D558\C5EC insert \BB38\C5D0 \C0AC\C6A9\B418\B294 \B370\C774\D130\B97C \C0DD\C131\D569\B2C8\B2E4. \AE30\BCF8\AC12\C740 [\C601\C5B4]\C785\B2C8\B2E4. \C9C0\C6D0\B418\B294 \C5B8\C5B4\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105381938915309759)
,p_name=>'QUICKSQL.LONGID_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4 \C774\B984\C5D0 \C0AC\C6A9\D560 \BCF4\B2E4 \AE34 \C2DD\BCC4\C790\B97C \C2DD\BCC4\D569\B2C8\B2E4. \C0AC\C6A9\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \BCF4\B2E4 \AE34 \C2DD\BCC4\C790\B97C \D1B5\D574 \AC1D\CCB4 \C774\B984\C758 \CD5C\B300 \AE38\C774\AC00 128\C790\AE4C\C9C0 \D5C8\C6A9\B429\B2C8\B2E4. \C0AC\C6A9\C73C\B85C \C124\C815\D558\C9C0 \C54A\C744 \ACBD\C6B0 \AC1D\CCB4 \C774\B984\C758 \CD5C\B300 \AE38\C774\AC00 30\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105382167462309759)
,p_name=>'QUICKSQL.LONGVC_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4 \C774\B984\C5D0 \BCF4\B2E4 \AE34 \C2DD\BCC4\C790\B97C \C0AC\C6A9\D560 \C218 \C788\B3C4\B85D \D5C8\C6A9\D569\B2C8\B2E4. \BCF4\B2E4 \AE34 \C2DD\BCC4\C790\B97C \D1B5\D574 VARCHAR2 \C5F4 \B370\C774\D130 \C720\D615\C758 \CD5C\B300 \AE38\C774\AC00 32767\C790\AE4C\C9C0 \D5C8\C6A9\B429\B2C8\B2E4. \C124\C815\D558\C9C0 \C54A\C744 \ACBD\C6B0 VARCHAR2 \C5F4 \B370\C774\D130 \C720\D615\C758 \CD5C\B300 \AE38\C774\AC00 4000\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105382266248309759)
,p_name=>'QUICKSQL.ONDELETE_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C124\C815\C5D0 \B530\B77C \C678\B798 \D0A4 ON DELETE \C124\C815 \BC29\BC95\C774 \C81C\C5B4\B429\B2C8\B2E4. \C801\D569\D55C \AC12\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105382310586309759)
,p_name=>'QUICKSQL.OVERRIDESETTINGS_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \CF58\C194\C744 \D1B5\D574 \AD6C\C131\B41C \BAA8\B4E0 \C560\D50C\B9AC\CF00\C774\C158 \C124\C815\C774 \BB34\C2DC\B418\ACE0 \C2A4\D06C\B9BD\D2B8\C5D0\C11C \AD6C\C131\B41C \C124\C815\B9CC \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105382443230309759)
,p_name=>'QUICKSQL.PK_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4\AC00 \C124\C815\B420 \BC29\BC95\C744 \ACB0\C815\D569\B2C8\B2E4. \AE30\BCF8 \D0A4\B294 SYS_GUID, ID \C5F4 \B610\B294 \C21C\C11C\B97C \C0AC\C6A9\D558\C5EC \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \C801\D569\D55C \AC12\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105382614522309759)
,p_name=>'QUICKSQL.PREFIXPKWITHTNAME_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14 \C5F4\C5D0 \D14C\C774\BE14 \C774\B984\C744 \C811\B450\C5B4\B85C \BD99\C785\B2C8\B2E4. \C608\B97C \B4E4\C5B4, EMPLOYEE \D14C\C774\BE14\C758 \AE30\BCF8 \D0A4\B294 EMPLOYEE_ID\AC00 \B429\B2C8\B2E4. \C124\C815\D558\C9C0 \C54A\C744 \ACBD\C6B0 \C554\C2DC\C801\C73C\B85C \C0DD\C131\B418\B294 \AE30\BCF8 \D0A4 \C5F4\C758 \C774\B984\C740 ID\AC00 \B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105382550802309759)
,p_name=>'QUICKSQL.PREFIX_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4 \C811\B450\C5B4\C785\B2C8\B2E4. \C81C\ACF5\D558\C9C0 \C54A\C744 \ACBD\C6B0 \BC11\C904\C774 \CD94\AC00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106049789633310318)
,p_name=>'QUICKSQL.PRODUCTSALES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\D488 \D310\B9E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106050395568310319)
,p_name=>'QUICKSQL.PRODUCTSALES_DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('PRODUCTS, CUSTOMERS, CHANNELS, PROMOTIONS \BC0F SALES \D14C\C774\BE14\B85C \C2A4\D0C0 \C2A4\D0A4\B9C8\B97C \C0DD\C131\D558\B294 \C18D\AE30 \AD6C\BB38\C785\B2C8\B2E4. SALES \D14C\C774\BE14\C5D0\B294 \B2E4\B978 \D14C\C774\BE14\C5D0 \B300\D55C \C678\B798 \D0A4 \CC38\C870\AC00 \D3EC\D568\B429\B2C8\B2E4. \B2E4\C12F \AC1C\C758 \D14C\C774\BE14\C744 \BAA8\B450 \C870\C778\D558\B294 SQL VIEW\B3C4 \C0DD\C131\B429\B2C8\B2E4. \B610\D55C \BB34\C791\C704 \C0D8\D50C \B370\C774\D130\AC00 \C0DD\C131\B429\B2C8\B2E4. \C22B\C790 \C5F4\C740 NUM \AD6C\BB38\C73C\B85C \C2DD\BCC4\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106049552661310318)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C81D\D2B8 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106050153637310319)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT_DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('PROJECT_MANAGEMENT \BC0F \B124 \AC1C\C758 \B514\D14C\C77C \D14C\C774\BE14\C744 \C0DD\C131\D569\B2C8\B2E4. /VIEW \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC \B450 \AC1C\C758 \BDF0\B97C \C0DD\C131\D569\B2C8\B2E4. /CHECK \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130\BCA0\C774\C2A4 CHECK \C81C\C57D \C870\AC74\B3C4 \CD94\AC00\D569\B2C8\B2E4. \B610\D55C #APEX \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC SQL \AD6C\BB38 \C0DD\C131\C744 \C81C\C5B4\D558\B294 \C124\C815\C744 \AD6C\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105382859552309760)
,p_name=>'QUICKSQL.RESETSETTINGS_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C560\D50C\B9AC\CF00\C774\C158 \C124\C815\C744 \AE30\BCF8\AC12\C73C\B85C \C7AC\C124\C815\D569\B2C8\B2E4. \D3EC\D568\D560 \ACBD\C6B0 \C138\C158\C5D0 \B300\D574 \D604\C7AC \D65C\C131\D654\B41C \BAA8\B4E0 \C560\D50C\B9AC\CF00\C774\C158 \C124\C815\C774 \BB34\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105382900673309760)
,p_name=>'QUICKSQL.ROWKEY_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\B41C \AC01 \D14C\C774\BE14\C5D0 \B300\D574 \C601\C22B\C790 \C2DD\BCC4\C790\B97C \C0DD\C131\D558\B294 ROW_KEY \C5F4\C744 \CD94\AC00\D569\B2C8\B2E4. ROW_KEY \C5F4\C758 \AC12\C740 \C0DD\C131\B41C \B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14 \D2B8\B9AC\AC70 \B17C\B9AC\B97C \D1B5\D574 \C124\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105383101483309760)
,p_name=>'QUICKSQL.ROWVERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\B41C \AC01 \D14C\C774\BE14\C5D0 \B300\D574 \C5C5\B370\C774\D2B8\B9C8\B2E4 1\C529 \C99D\BD84\B418\B294 ROW_VERSION \C5F4\C744 \CD94\AC00\D569\B2C8\B2E4. \C0AC\C6A9\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \C5C5\B370\C774\D2B8 \C2DC \D589 \BC84\C804\C744 \C99D\BD84\D560 \B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14 \D2B8\B9AC\AC70 \B17C\B9AC\AC00 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105383210479309760)
,p_name=>'QUICKSQL.SCHEMA_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4 \C774\B984\C5D0 \C2A4\D0A4\B9C8 \C774\B984\C744 \C811\B450\C5B4\B85C \BD99\C785\B2C8\B2E4. \AE30\BCF8\AC12\C740 \AC1D\CCB4 \C774\B984\C5D0 \C2A4\D0A4\B9C8 \C811\B450\C5B4\B97C \C0AC\C6A9\D558\C9C0 \C54A\B294 \AC83\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105383026165309760)
,p_name=>'QUICKSQL.SECURITYGROUPID_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01 \D14C\C774\BE14\C5D0 \B300\D574 \B2E4\C911 \D14C\B10C\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C744 \C9C0\C6D0\D558\B3C4\B85D TENANT_ID \C5F4\C744 \CD94\AC00\D569\B2C8\B2E4. \C774 \C5F4\C758 \AC12\C740 \D14C\C774\BE14\C5D0 \CD94\AC00\B429\B2C8\B2E4. \AC1C\BC1C\C790\AC00 \C774 \AC12\C744 \C720\C9C0\BCF4\C218\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105383645227309760)
,p_name=>'QUICKSQL.SEMANTICS_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C758\BBF8 \C5C6\C74C, BYTE \B610\B294 CHAR \C758\BBF8\B97C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105302029304309698)
,p_name=>'QUICKSQL.SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105365223981309747)
,p_name=>'QUICKSQL.SETTINGS_DESC'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C778\B77C\C778 \C124\C815\C744 \C785\B825\D558\C5EC \BA85\C2DC\C801\C73C\B85C SQL \AD6C\BB38 \C0DD\C131 \C635\C158\C744 \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \B610\B294 \C624\B978\CABD \CC3D \C0C1\B2E8\C5D0 \C788\B294 <strong>\C124\C815</strong>\C744 \B20C\B7EC \C120\C5B8\C801\C73C\B85C \C0DD\C131 \C635\C158\C744 \C124\C815\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>Quick SQL \C18D\AE30 \CC3D\C5D0 \C9C1\C811 \C124\C815\C744 \C785\B825\D558\BA74 \C2A4\D06C\B9BD\D2B8\B97C \B2E4\C6B4\B85C\B4DC\D558\C5EC \B098\C911\C5D0 \B2E4\C2DC \BD99\C5EC \B123\B294 \ACBD\C6B0\C5D0\B3C4 \B3D9\C77C\D55C SQL \C0DD\C131 \C635\C158\C774 \C0AC\C6A9\B429\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \B2E4\C74C\C744 \C785\B825\D558\C5EC \BAA8\B4E0 \D14C\C774\BE14 \C774\B984\C5D0 TEST\B97C \C811\B450\C5B4\B85C \BD99\C774\ACE0 \C2A4\D0A4\B9C8 OBE\C5D0 \B300\D574 \C0DD\C131\D569\B2C8\B2E4.<br>'),
'<code># settings = { prefix: "test", schema: "OBE" }</code><br>',
unistr('\B610\B294 \C124\C815\C744 \D55C \D589\C5D0 \D558\B098\C529 \C785\B825\D574\B3C4 \B3D9\C77C\D55C \ACB0\ACFC\AC00 \BC1C\C0DD\D569\B2C8\B2E4.<br>'),
'<code># prefix: "test"<br>',
'# schema: "OBE"</code>',
'</p>',
unistr('<p><em><strong>\CC38\ACE0:</strong> \C124\C815\C740 \C0C8 \D589\C5D0\C11C \C2DC\C791\D558\ACE0 <code># settings = </code>(\C124\C815\C744 \C5EC\B7EC \AC1C \C785\B825\D558\B294 \ACBD\C6B0) \B610\B294 <code># </code>(\C124\C815\C744 \D55C \D589\C5D0 \D558\B098\C529 \C785\B825\D558\B294 \ACBD\C6B0)\C73C\B85C \C2DC\C791\D574\C57C \D569\B2C8\B2E4. \BAA8\B4E0 \AC12\C740 \B300\C18C\BB38\C790\B97C \BB34\C2DC\D569\B2C8\B2E4. \AD04\D638, \ACF5\BC31 \BC0F \CF64\B9C8\B294 \BA85\D655\D55C \D45C\D604\C744 \C704\D574 \CD94\AC00\D560 \C218 \C788\C9C0\B9CC \BB34\C2DC\B429\B2C8\B2E4. \BAA8\B4E0 \C124\C815\C774 \C0DD\C131\B418\B3C4\B85D \D558\B824\BA74 <code># verbose: true</code>\B97C \C0AC\C6A9')
||unistr('\D558\C2ED\C2DC\C624.</em> '),
'</p>',
'&nbsp;<br>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105301721124309697)
,p_name=>'QUICKSQL.SYNTAX'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106071571981310338)
,p_name=>'QUICKSQL.TODOS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D560 \C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106071675354310338)
,p_name=>'QUICKSQL.TODOS_DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('ASSIGNEES \BC0F TODOS \D14C\C774\BE14\C744 \C0DD\C131\D569\B2C8\B2E4. \C774\AC83\C740 \C0AC\C6A9\C790\C815\C758\B41C ToDo \C2DC\C2A4\D15C\C744 \BA87 \BD84 \B0B4\C5D0 \C0DD\C131\D558\AE30 \C704\D55C \C2DC\C791\C810\C73C\B85C \B514\C790\C778\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105383375750309760)
,p_name=>'QUICKSQL.UPDATEDBYCOL_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC10\C0AC \C5F4\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \C774 \C124\C815\C744 \C0AC\C6A9\D558\C5EC \AE30\BCF8 \AC10\C0AC \C5F4 \C774\B984\C744 \BB34\D6A8\D654\D569\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105383464018309760)
,p_name=>'QUICKSQL.UPDATEDCOL_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC10\C0AC \C5F4\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \C774 \C124\C815\C744 \C0AC\C6A9\D558\C5EC \AE30\BCF8 \AC10\C0AC \C5F4 \C774\B984\C744 \BB34\D6A8\D654\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105383505449309760)
,p_name=>'QUICKSQL.VERBOSE_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12\ACFC \B2E4\B978 \C124\C815\BFD0\B9CC \C544\B2C8\B77C \BAA8\B4E0 \C124\C815\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105301823381309697)
,p_name=>'QUICKSQL.VIEW_SYNTAX_DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\BDF0 \C774\B984\C5D0 \ACF5\BC31\C774 \C5C6\C73C\BA70 \D14C\C774\BE14 \C774\B984\C5D0 \ACF5\BC31\C774 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C740\C9C0 \D655\C778\D558\C2ED\C2DC\C624. \ACF5\BC31 \B610\B294 \CF64\B9C8\B85C \D14C\C774\BE14\C744 \C774\B984\C744 \AD6C\BD84\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105510641153309870)
,p_name=>'QUICK_APP.LOAD_DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105150048151309585)
,p_name=>'QUICK_APP_ANALYSIS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\C11D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105357941283309741)
,p_name=>'QUICK_APP_AVERAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3C9\ADE0 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105033316677309494)
,p_name=>'QUICK_APP_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BCC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105150432351309585)
,p_name=>'QUICK_APP_CHARTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105033251509309494)
,p_name=>'QUICK_APP_CHART_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BCC4 \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105031953210309493)
,p_name=>'QUICK_APP_DETAIL_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105150370471309585)
,p_name=>'QUICK_APP_REPORTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105358030809309741)
,p_name=>'QUICK_APP_SUM'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D569\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105525957851309883)
,p_name=>'QUICK_SQL'
,p_message_language=>'ko'
,p_message_text=>'Quick SQL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104867619641309370)
,p_name=>'RANGE2DCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C704 2D \C138\B85C \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104867706325309370)
,p_name=>'RANGE3DCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C704 3D \C138\B85C \B9C9\B300')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106183215130310437)
,p_name=>'READERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\D68C\C790')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106099500668310364)
,p_name=>'REASSIGN_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C7AC\C9C0\C815: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104891065301309389)
,p_name=>'REASSIGN_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C7AC\C9C0\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105276492163309679)
,p_name=>'RECYCLE_BIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D734\C9C0\D1B5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105480392301309844)
,p_name=>'REDIRECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105480513062309844)
,p_name=>'REDIRECT_BUTTON_WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD94\B97C \B204\B974\BA74 URL\C740 \C7AC\C9C0\C815\B418\C9C0\B9CC \D398\C774\C9C0\B294 \C81C\CD9C\B418\C9C0 \C54A\C744 \AC00\B2A5\C131\C774 \B192\C2B5\B2C8\B2E4. \C774 \B2E8\CD94\B97C \B204\B97C \B54C \D398\C774\C9C0\AC00 \C81C\CD9C\B418\B3C4\B85D \D558\B824\BA74 \C7AC\C9C0\C815 \D398\C774\C9C0 \B610\B294 URL\C744 \C9C0\C815\D558\C9C0 \B9C8\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105146719582309582)
,p_name=>'REDIRECT_TO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0(\C73C)\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105612492781309952)
,p_name=>'REDIRECT_TO_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 %0, \D398\C774\C9C0 %1(\C73C)\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105146610647309582)
,p_name=>'REDIRECT_TO_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D398\C774\C9C0\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104954287863309436)
,p_name=>'REDIRECT_TO_PAGE_IN_THIS_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104954301087309436)
,p_name=>'REDIRECT_TO_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('URL\B85C \C7AC\C9C0\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105327683779309718)
,p_name=>'REFERENCED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870\B428')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104955271737309437)
,p_name=>'REGEN_VER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778 \CF54\B4DC \C7AC\C0DD\C131')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105330268865309720)
,p_name=>'REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105474743252309840)
,p_name=>'REGION BUTTON POSITONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \B2E8\CD94 \C704\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105394291611309768)
,p_name=>'REGION CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105387448698309763)
,p_name=>'REGION CONTENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \CF58\D150\CE20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104933144876309421)
,p_name=>'REGION.BUTTONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \B2E8\CD94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104956241599309438)
,p_name=>'REGIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105114241718309552)
,p_name=>'REGIONS_LIST_TEMPLATE_OVERRIDE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \BAA9\B85D \D15C\D50C\B9AC\D2B8 \C6B0\C120 \C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105338526278309727)
,p_name=>'REGION_DISPLAY_SELECTOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D45C\C2DC \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104856909553309360)
,p_name=>'REGION_NAME.NATIVE_BREADCRUMB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105602875786309944)
,p_name=>'REGION_NAME.NATIVE_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104875183738309376)
,p_name=>'REGION_NAME.NATIVE_CARDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105322863296309715)
,p_name=>'REGION_NAME.NATIVE_CSS_CALENDAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104899390694309396)
,p_name=>'REGION_NAME.NATIVE_DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C5C5\B85C\B4DC \C5F4 \B9E4\D551')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105336968805309726)
,p_name=>'REGION_NAME.NATIVE_DISPLAY_SELECTOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D45C\C2DC \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105667535642310001)
,p_name=>'REGION_NAME.NATIVE_FACETED_SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105456868527309825)
,p_name=>'REGION_NAME.NATIVE_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104858060090309361)
,p_name=>'REGION_NAME.NATIVE_HELP_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105464041048309831)
,p_name=>'REGION_NAME.NATIVE_IG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105577708188309924)
,p_name=>'REGION_NAME.NATIVE_IR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105317213065309711)
,p_name=>'REGION_NAME.NATIVE_JET_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106035676304310305)
,p_name=>'REGION_NAME.NATIVE_JQM_COLUMN_TOGGLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \D1A0\AE00 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104899247236309396)
,p_name=>'REGION_NAME.NATIVE_JQM_LIST_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106035754052310305)
,p_name=>'REGION_NAME.NATIVE_JQM_REFLOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\BC30\CE58 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105603053915309944)
,p_name=>'REGION_NAME.NATIVE_JSTREE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104856448798309359)
,p_name=>'REGION_NAME.NATIVE_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106039507139310309)
,p_name=>'REGION_NAME.NATIVE_MAP_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105677520057310010)
,p_name=>'REGION_NAME.NATIVE_PLSQL'
,p_message_language=>'ko'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105602434915309944)
,p_name=>'REGION_NAME.NATIVE_SIMPLE_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8(HTML - \B808\AC70\C2DC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105573503133309921)
,p_name=>'REGION_NAME.NATIVE_SQL_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105677611312310010)
,p_name=>'REGION_NAME.NATIVE_STATIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \CF58\D150\CE20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105602348749309943)
,p_name=>'REGION_NAME.NATIVE_SVG_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8(SVG - \B808\AC70\C2DC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105577890078309924)
,p_name=>'REGION_NAME.NATIVE_TABFORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C \D615\C2DD \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105602909207309944)
,p_name=>'REGION_NAME.NATIVE_TREE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B798\C2DD \D2B8\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104857228369309360)
,p_name=>'REGION_NAME.NATIVE_URL'
,p_message_language=>'ko'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105023261411309487)
,p_name=>'REGION_TEMPLATES_NO_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C5C6\C74C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105342258533309730)
,p_name=>'REJECTED_OR_DUPLICATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC70\BD80\B428 \B610\B294 \C911\BCF5\B428')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105362901063309745)
,p_name=>'RELEASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9B4\B9AC\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104909702666309404)
,p_name=>'RELEASED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9B4\B9AC\C2A4\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105392869052309767)
,p_name=>'RELEASE_SUMMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9B4\B9AC\C2A4 \C694\C57D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105392777783309767)
,p_name=>'RELEASE_SUMMARY_FOR_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C5D0 \B300\D55C \B9B4\B9AC\C2A4 \C694\C57D: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106068112485310335)
,p_name=>'REMOTE.MORE_INFORMATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106109258575310373)
,p_name=>'REMOTE.OWA_TOOLKIT_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \C6F9 \D234\D0B7 %0 \D544\C694 <a href="%1" target="_blank">[\CD94\AC00 \C815\BCF4]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106109097853310373)
,p_name=>'REMOTE.PATCHSET_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\CE58 \C9D1\D569 %0 \C0AC\C6A9 \AC00\B2A5 <a href="%1" target="_blank">[\CD94\AC00 \C815\BCF4]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106109162184310373)
,p_name=>'REMOTE.RELEASE_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle APEX %0 \C0AC\C6A9 \AC00\B2A5 <a href="%1" target="_blank">[\CD94\AC00 \C815\BCF4]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106068032010310335)
,p_name=>'REMOTE.SYSTEM_UP_TO_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C2A4\D15C\C774 \CD5C\C2E0\C785\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106009581640310279)
,p_name=>'REMOVED_DUE_TO_ACTIVITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C73C\B85C \C778\D574 \C81C\AC70\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104909292374309404)
,p_name=>'REMOVE_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105900692037310185)
,p_name=>'REMOVE_DB_PKG_APP_WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C815\C758 \BC0F \C0DD\C131\B41C \BAA8\B4E0 \C9C0\C6D0 \AC1D\CCB4\AC00 \C81C\AC70\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105408535299309778)
,p_name=>'REMOVE_WORKSPACE_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C774 \C131\ACF5\C801\C73C\B85C \C81C\AC70\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105472791131309838)
,p_name=>'RENAME_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0\C11C %1(\C73C)\B85C \C5F4 \C774\B984 \BC14\AFB8\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105472986320309838)
,p_name=>'RENAME_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0\C11C %1(\C73C)\B85C \D14C\C774\BE14 \C774\B984 \BC14\AFB8\AE30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105189877382309614)
,p_name=>'REORDER_BUTTONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \B2E8\CD94 \C7AC\C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105204919985309625)
,p_name=>'REORDER_NAVBAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904 \D56D\BAA9 \C7AC\C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105189909704309614)
,p_name=>'REORDER_REGIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C7AC\C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105189505461309614)
,p_name=>'REORDER_REGION_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D56D\BAA9 \C7AC\C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105204850509309625)
,p_name=>'REORDER_TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C7AC\C815\B82C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105310101759309705)
,p_name=>'REPORT COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106093236528310359)
,p_name=>'REPORT_ALIAS_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \BCC4\CE6D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105310424225309705)
,p_name=>'REPORT_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105427029077309799)
,p_name=>'REPORT_COLUMNS_PAGE_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105401877890309773)
,p_name=>'REPORT_COLUMN_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105401473961309773)
,p_name=>'REPORT_FORM_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \BC0F \BCF4\ACE0\C11C\AC00 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105366250459309747)
,p_name=>'REPORT_GENERATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\AC00 \C791\C131\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105433957268309805)
,p_name=>'REPORT_LAYOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \B808\C774\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105262655468309668)
,p_name=>'REPORT_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105427335584309800)
,p_name=>'REPORT_PAGE_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105018826508309483)
,p_name=>'REPORT_QUERIES.VALID_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\AC00 \C801\D569\D569\B2C8\B2E4. \BC14\C778\B4DC \BCC0\C218\C758 \AD6C\BB38\C774 \BD84\C11D\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105433877623309805)
,p_name=>'REPORT_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105267403095309671)
,p_name=>'REPORT_QUERY_STEP1'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\ACC4 1 - XML \D30C\C77C \B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105267597642309671)
,p_name=>'REPORT_QUERY_STEP2'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\ACC4 2 - \BCF4\ACE0\C11C \B808\C774\C544\C6C3 \C124\ACC4 \BC0F RTF \D30C\C77C\B85C \C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105267734170309672)
,p_name=>'REPORT_QUERY_STEP2_XSL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\ACC4 2 - XSL-FO \D30C\C77C \C5C5\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105267618179309672)
,p_name=>'REPORT_QUERY_STEP3'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\ACC4 3 - RTF \D30C\C77C \C5C5\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105399967556309772)
,p_name=>'REPORT_ROWS_FETCHED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\CD9C\B41C \D589 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105468027759309834)
,p_name=>'REPORT_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\AC00 \C131\ACF5\C801\C73C\B85C \C791\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105401921547309774)
,p_name=>'REPORT_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105407163526309777)
,p_name=>'REPORT_WS_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4\C5D0 \B300\D55C \BCF4\ACE0\C11C \D398\C774\C9C0\AC00 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105323790983309716)
,p_name=>'REQUEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105397400568309770)
,p_name=>'REQUESTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105661636772309996)
,p_name=>'REQUEST_CHANGE_DB_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C791\C5C5\C601\C5ED\C758 %0\C774(\AC00) \CD94\AC00 %2\C758 \B370\C774\D130\BCA0\C774\C2A4 \D06C\AE30 \BCC0\ACBD\C744 \C694\CCAD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105661584839309995)
,p_name=>'REQUEST_NEW_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) %2\C744(\B97C) \D3EC\D568\D558\B294 "%1" \C791\C5C5\C601\C5ED\C5D0 \B300\D55C \C0C8 \C2A4\D0A4\B9C8\B97C \C694\CCAD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105661475493309995)
,p_name=>'REQUEST_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) %2 \D06C\AE30\C758 \C0C8 \C791\C5C5\C601\C5ED "%1"\C744(\B97C) \C694\CCAD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104911439783309405)
,p_name=>'REQUEST_WORKSPACE_EXISTING_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0C8 \C791\C5C5\C601\C5ED \C694\CCAD "%1"')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105350548449309736)
,p_name=>'RESEARCHING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\C0AC \C911')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104886071875309385)
,p_name=>'RESET_4000'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104932916809309421)
,p_name=>'RESET_TO_NULL_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \AC12\C73C\B85C \C7AC\C124\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104917835671309410)
,p_name=>'RESOURCE_MANAGER_CONSUMER_GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9AC\C18C\C2A4 \AD00\B9AC\C790 \C18C\BE44\C790 \ADF8\B8F9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105615678638309954)
,p_name=>'RESTRICTED_ACCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\D55C\B41C \C561\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105186184443309611)
,p_name=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\D55C\B428 - \BE0C\B77C\C6B0\C800\C5D0\C11C \C124\C815\D560 \C218 \C5C6\C74C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105403785650309775)
,p_name=>'REST_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \CC38\C870\AC00 %0 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105015778177309481)
,p_name=>'REST_WS.ALIASED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D \C9C0\C815\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105814358398310119)
,p_name=>'REST_WS.APEX_READ_ONLY'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>APEX RESTful \C11C\BE44\C2A4\B294 \C77D\AE30 \C804\C6A9 \BAA8\B4DC\C785\B2C8\B2E4.</p>'),
'',
unistr('<p>APEX \AE30\BC18 RESTful \C11C\BE44\C2A4\B97C \C815\C758\B41C \B300\B85C \C0AC\C6A9\D560 \C218 \C788\C9C0\B9CC, <strong>ORDS RESTful \C11C\BE44\C2A4\B85C \C774\C804</strong>\C744 \B20C\B7EC \D574\B2F9 \C11C\BE44\C2A4\B97C ORDS\B85C \C774\C804\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105810965359310116)
,p_name=>'REST_WS.CURR_VESION_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('ORDS\C758 \D604\C7AC \C2E4\D589 \C911\C778 \BC84\C804\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105015154214309481)
,p_name=>'REST_WS.DISABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105814287530310119)
,p_name=>'REST_WS.DROP_REST_WARNING'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C791\C5C5\C744 \C218\D589\D558\BA74 \C120\D0DD\B41C \C2A4\D0A4\B9C8\C5D0 \B300\D55C \BAA8\B4E0 ORDS REST \C11C\BE44\C2A4 \C815\C758\AC00 \B4F1\B85D \D574\C81C\B418\ACE0 \C81C\AC70\B429\B2C8\B2E4. \C774\D6C4 \C2E4\D589\CDE8\C18C\B294 \BD88\AC00\D569\B2C8\B2E4.</p>'),
'',
unistr('<p>\C774 \C2A4\D0A4\B9C8\B97C \B4F1\B85D \D574\C81C\D558\ACA0\C2B5\B2C8\AE4C?</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105264220307309669)
,p_name=>'REST_WS.DUPLICATE_PATH_PREFIX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC12\C758 APEX \ACBD\B85C \C811\B450\C5B4\AC00 \C774\BBF8 \B2E4\B978 \C791\C5C5\C601\C5ED\C5D0 \C815\C758\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105325514479309717)
,p_name=>'REST_WS.DUPLICATE_SCHEMA_ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C2A4\D0A4\B9C8 \BCC4\CE6D\C740 \C774\BBF8 \B2E4\B978 \C2A4\D0A4\B9C8\C5D0\C11C \C0AC\C6A9 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105015048405309481)
,p_name=>'REST_WS.ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106050732366310319)
,p_name=>'REST_WS.ENABLED_OBJECT_COUNT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \C0AC\C6A9 \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104998877434309469)
,p_name=>'REST_WS.GLOB_MUST_BE_LAST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED(*) \BB38\C790\B294 \B9C8\C9C0\B9C9 \BB38\C790\B85C \ACBD\B85C \C9C0\C815 \D328\D134\C5D0\B9CC \B098\D0C0\B0A0 \C218 \C788\C73C\BA70 \BA85\BA85\B41C \B9E4\AC1C\BCC0\C218 \B610\B294 \C2AC\B798\C2DC(/) \B4A4\C5D0 \C640\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105663847554309998)
,p_name=>'REST_WS.HANDLER_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\AE30\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105664011735309998)
,p_name=>'REST_WS.HANDLER_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\AE30\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105633597585309970)
,p_name=>'REST_WS.HANDLER_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\AE30 ID\AC00 \D544\C694\D558\C9C0\B9CC NULL\C774 \C218\C2E0\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105663981492309998)
,p_name=>'REST_WS.HANDLER_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC98\B9AC\AE30\AC00 \C5C5\B370\C774\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104998773453309469)
,p_name=>'REST_WS.INVALID_CHARS_IN_LITERAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\B85C \C9C0\C815 \D328\D134\C758 \B9AC\D130\B7F4 \BD80\BD84\C5D0\C11C \BD80\C801\D569\D55C \BB38\C790\AC00 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105035603799309496)
,p_name=>'REST_WS.METADATA_ACCESS_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \D544\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106083638283310350)
,p_name=>'REST_WS.MIGRATION_CONFIRMATION'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding: 20px; font-size: 12px;">[\C774\C804] \B2E8\CD94\B97C \B204\B974\BA74 \BAA8\B4E0 APEX \AE30\BC18 REST \C11C\BE44\C2A4\C758 \BA54\D0C0\B370\C774\D130\AC00 ORDS\B85C \BCF5\C0AC\B429\B2C8\B2E4. \AE30\C874 APEX \AE30\BC18 \C11C\BE44\C2A4\C758 \C815\C758\B294 \ADF8\B300\B85C \C720\C9C0\B418\C9C0\B9CC ORDS\C5D0 \C77C\CE58\D558\B294 \C11C\BE44\C2A4\AC00 \C874\C7AC\D558\B294 \D55C \C2E4\D589\B418\C9C0 \C54A\C2B5\B2C8\B2E4. '),
'',
unistr('\C774\C804 \D6C4 \C774\C804\B41C ORDS \AE30\BC18 \C11C\BE44\C2A4\B97C \AC80\C99D\D558\ACE0 \D14C\C2A4\D2B8\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4. \AC80\C99D\B418\BA74 \C775\C2A4\D3EC\D2B8\D558\ACE0 APEX \AE30\BC18 \C11C\BE44\C2A4\B97C \C0AD\C81C\D569\B2C8\B2E4.</div>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106083575020310350)
,p_name=>'REST_WS.MIGRATION_WARNING_18_2_PLUS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX\AC00 \C791\C5C5\C601\C5ED\C5D0 NULL URI \C811\B450\C5B4\AC00 \C788\B294 APEX \AE30\BC18 REST \BAA8\B4C8\C774 \B458 \C774\C0C1 \D3EC\D568\B418\C5B4 \C788\C74C\C744 \AC10\C9C0\D588\C2B5\B2C8\B2E4. ORDS\C5D0\B294 \B458 \C774\C0C1\C758 \BAA8\B4C8\C5D0 \B3D9\C77C\D55C \AE30\BCF8 URI \C811\B450\C5B4\AC00 \C788\C744 \C218 \C5C6\C2B5\B2C8\B2E4. </p>'),
'',
unistr('<p>\C774\B7EC\D55C \C11C\BE44\C2A4\B97C ORDS\B85C \C774\C804\D558\AE30 \C704\D574 \B2E4\C74C \ADDC\CE59\C774 \C801\C6A9\B429\B2C8\B2E4. </p>'),
'',
'<ul>',
unistr('<li>\C601\D5A5\C744 \BC1B\B294 \BAA8\B4E0 \BAA8\B4C8\C774 <em><strong>merged.apex.rest.services</strong></em>\B77C\B294 \B2E8\C77C ORDS \BAA8\B4C8\B85C \CD95\C18C\B429\B2C8\B2E4.</li>'),
unistr('<li>\BCD1\D569\B418\B294 APEX \AE30\BC18 \BAA8\B4C8 \C911 <strong><em>\C5B4\B290 \D558\B098\AC00 \AC8C\C2DC\B418\BA74</em></strong> \BCD1\D569\B41C \C0C8 \BAA8\B4C8\C774 <strong><em>\AC8C\C2DC\B429\B2C8\B2E4</em></strong>.</li>'),
unistr('<li>\BCD1\D569\B418\B294 APEX \AE30\BC18 \BAA8\B4C8 \C911 <strong><em>\C5B4\B290 \AC83\B3C4 \AC8C\C2DC\B418\C9C0 \C54A\C73C\BA74</em></strong> \BCD1\D569\B41C \C0C8 \BAA8\B4C8\C774 <strong><em>\AC8C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4</em></strong>.</li>'),
unistr('<li>\BCD1\D569\B418\B294 APEX \AE30\BC18 \BAA8\B4C8\ACFC \C5F0\AD00\B41C <strong><em>\BAA8\B4E0 \B864</em></strong>\C740 <strong><em>\BCD1\D569\B41C \C0C8 \BAA8\B4C8\C5D0 \C9C0\C815\B429\B2C8\B2E4</em></strong>.</li>'),
unistr('<li>\BCD1\D569\B41C \BAA8\B4C8\C758 <strong><em>\D398\C774\C9C0 \B9E4\AE40 \D06C\AE30</em></strong>\B294 \BCD1\D569\B418\B294 \BAA8\B4C8\C758 <strong><em>\AC00\C7A5 \D070 \D398\C774\C9C0 \B9E4\AE40 \D06C\AE30</em></strong>\B85C \C124\C815\B429\B2C8\B2E4.</li>'),
unistr('<li>\C911\BCF5 \D15C\D50C\B9AC\D2B8 URI\B3C4 \D3EC\D568\B41C NULL \AE30\BC18 URI\C758 APEX \BAA8\B4C8\C774 \C788\B294 \ACBD\C6B0 \B2E4\C74C \C0AC\D56D\C774 \BC1C\C0DD\D569\B2C8\B2E4.'),
'',
'<ul>',
unistr('<li>\AC00\C7A5 \CD5C\ADFC\C5D0 \C5C5\B370\C774\D2B8\B41C \D15C\D50C\B9AC\D2B8\C5D0 \C911\BCF5 URI\AC00 \C720\C9C0\B429\B2C8\B2E4.</li>'),
unistr('<li>\B2E4\B978 \BAA8\B4E0 \D15C\D50C\B9AC\D2B8\C5D0\B294 \C811\B450\C5B4\B85C dup001_*\AC00 \BD99\C2B5\B2C8\B2E4.</li>'),
unistr('<li>\D15C\D50C\B9AC\D2B8\C758 \C124\BA85\C5D0\B294 \C774\C804\B41C \C6D0\B798 \BAA8\B4C8 \C774\B984\ACFC \C6D0\B798 \D15C\D50C\B9AC\D2B8 URI\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.</li>'),
'</ul></li>',
'</ul>',
'</div>',
'<hr/>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106083484289310350)
,p_name=>'REST_WS.MIGRATION_WARNING_PRE_18_2'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX\AC00 \C791\C5C5\C601\C5ED\C5D0 NULL URI \C811\B450\C5B4\AC00 \C788\B294 APEX \AE30\BC18 REST \BAA8\B4C8\C774 \B458 \C774\C0C1 \D3EC\D568\B418\C5B4 \C788\C74C\C744 \AC10\C9C0\D588\C2B5\B2C8\B2E4. ORDS\C5D0\B294 \B458 \C774\C0C1\C758 \BAA8\B4C8\C5D0 \B3D9\C77C\D55C \AE30\BCF8 URI \C811\B450\C5B4\AC00 \C788\C744 \C218 \C5C6\C2B5\B2C8\B2E4. </p>'),
'',
unistr('<p>\D604\C7AC APEX \AE30\BC18 REST \C11C\BE44\C2A4\B97C ORDS\B85C \C774\C804\D560 \C218 \C5C6\C2B5\B2C8\B2E4. ORDS \BC84\C804 18.2 \C774\C0C1\BD80\D130 \C774\C804\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106050436823310319)
,p_name=>'REST_WS.MODULE_COUNT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \BAA8\B4C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105663283874309997)
,p_name=>'REST_WS.MODULE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4C8\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105663420203309997)
,p_name=>'REST_WS.MODULE_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4C8\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105633374166309970)
,p_name=>'REST_WS.MODULE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4C8 ID\AC00 \D544\C694\D558\C9C0\B9CC NULL\C774 \C218\C2E0\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105663321625309997)
,p_name=>'REST_WS.MODULE_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4C8\C774 \C5C5\B370\C774\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104998567928309469)
,p_name=>'REST_WS.NAMED_PARAM_CONTAINS_INVALID_CHARS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\B85C \C9C0\C815 \D328\D134 \B0B4 \BA85\BA85\B41C \B9E4\AC1C\BCC0\C218\C5D0 \BD80\C801\D569\D55C \BB38\C790\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105880557184310169)
,p_name=>'REST_WS.NOT_ORDS_ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C2A4\D0A4\B9C8\B294 ORDS RESTful \B370\C774\D130 \C11C\BE44\C2A4\C5D0 \B4F1\B85D\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \C774 \C2A4\D0A4\B9C8\B97C \B4F1\B85D\D558\B824\BA74 <strong>ORDS\C5D0 \B4F1\B85D</strong>\C744 \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104998940424309469)
,p_name=>'REST_WS.NOT_URI_OR_ROUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('URI\AC00 URI \B610\B294 ROUTE \C2A4\D0C0\C77C \D328\D134\ACFC \C77C\CE58\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104999036192309469)
,p_name=>'REST_WS.NO_MORE_THAN_ONE_FORWARD_SLASH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\C18D \C2AC\B798\C2DC\B97C \B450 \AC1C \C774\C0C1 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104998474781309468)
,p_name=>'REST_WS.NO_QUERY_STRING_IN_ROUTE_PATTERN'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\B85C \C9C0\C815 \D328\D134\C5D0 \B300\D574 \C9C8\C758 \BB38\C790\C5F4\C744 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104902444601309399)
,p_name=>'REST_WS.NO_REST_IN_CDB'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>APEX\AC00 \D604\C7AC CDB\C5D0\C11C \C2E4\D589\B418\ACE0 \C788\C2B5\B2C8\B2E4. CDB\C5D0\C11C ORDS \AE30\BC18 REST \C11C\BE44\C2A4\B97C \C815\C758\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</p><p>APEX \AE30\BC18 RESTful \C11C\BE44\C2A4\B97C \ACC4\C18D \C0AC\C6A9\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105814192954310119)
,p_name=>'REST_WS.OLD_ORDS_VERSION'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D604\C7AC \C124\CE58\B41C ORDS \BC84\C804(%0)\C740 Application Express\C5D0\C11C ORDS \AE30\BC18 RESTful \C11C\BE44\C2A4\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D558\B294 \B370 \D544\C694\D55C \C77C\BD80 \AE30\B2A5\C744 \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \CD5C\C18C \BC84\C804 %1\C744(\B97C) \C124\CE58\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>APEX \AE30\BC18 RESTful \C11C\BE44\C2A4\B97C \ACC4\C18D \C0AC\C6A9\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104998627137309469)
,p_name=>'REST_WS.OPTIONAL_CHAR_MUST_BE_LAST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\C801(?) \BB38\C790\B294 \B9C8\C9C0\B9C9 \BB38\C790\B85C \ACBD\B85C \C9C0\C815 \D328\D134\C5D0\B9CC \B098\D0C0\B0A0 \C218 \C788\C73C\BA70 \BA85\BA85\B41C \B9E4\AC1C\BCC0\C218 \B4A4\C5D0 \C640\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104997430409309468)
,p_name=>'REST_WS.ORDS_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C2DC\C2A4\D15C\C5D0\C11C ORDS REST \C6CC\D06C\C20D\C744 \C0AC\C6A9\D558\B294 \B370 \D544\C694\D55C ORDS_METADATA \C2A4\D0A4\B9C8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C124\CE58 \B2E8\ACC4\C778 \ACBD\C6B0 Oracle REST Data Services \C124\CE58 \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p> <p>APEX \AE30\BC18 RESTful \C11C\BE44\C2A4\B97C \ACC4\C18D \C0AC\C6A9\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105015655637309481)
,p_name=>'REST_WS.PARTIALLY_SECURED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BD80 \BCF4\C548\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104997385167309468)
,p_name=>'REST_WS.PLSQL_GATEWAY'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \C2DC\C2A4\D15C\C5D0\C11C \D604\C7AC Oracle Embedded PL/SQL Gateway\B97C \C0AC\C6A9\D558\ACE0 \C788\C2B5\B2C8\B2E4. ORDS REST \C6CC\D06C\C20D\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C73C\B824\BA74 Oracle REST Data Services \BC84\C804 %0 \C774\C0C1\C744 \C124\CE58\D574\C57C \D569\B2C8\B2E4.</p> <p>APEX \AE30\BC18 RESTful \C11C\BE44\C2A4\B97C \ACC4\C18D \C0AC\C6A9\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106050512854310319)
,p_name=>'REST_WS.PRIVILEGE_COUNT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \AD8C\D55C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105664404781309998)
,p_name=>'REST_WS.PRIVILEGE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105664601484309998)
,p_name=>'REST_WS.PRIVILEGE_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105664563201309998)
,p_name=>'REST_WS.PRIVILEGE_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C\C774 \C5C5\B370\C774\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105015285903309481)
,p_name=>'REST_WS.PUBLISHED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC8C\C2DC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105016381988309482)
,p_name=>'REST_WS.RESET_SAMPLE_WARNING'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \C791\C5C5\C740 \D604\C7AC \C120\D0DD\B41C \C2A4\D0A4\B9C8\C5D0\C11C <strong>oracle.example.hr</strong> \BAA8\B4C8 \BC0F \AD00\B828 \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C0AD\C81C\D558\ACE0 \C7AC\C0DD\C131\D569\B2C8\B2E4. \C218\D589\B41C \BAA8\B4E0 \BCC0\ACBD \B610\B294 \CD94\AC00 \C791\C5C5\C774 \C190\C2E4\B418\BA70, \C774 \C791\C5C5\C740 \C2E4\D589\CDE8\C18C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C0D8\D50C \C11C\BE44\C2A4\B97C \C7AC\C124\C815\D558\ACA0\C2B5\B2C8\AE4C?</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106050668566310319)
,p_name=>'REST_WS.ROLE_COUNT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105664149104309998)
,p_name=>'REST_WS.ROLE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105664383065309998)
,p_name=>'REST_WS.ROLE_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105664209365309998)
,p_name=>'REST_WS.ROLE_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864\C774 \C5C5\B370\C774\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105035565532309495)
,p_name=>'REST_WS.SCHEMA_ACCESS_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105035783010309496)
,p_name=>'REST_WS.SCHEMA_ALIAS_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8 \BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105811170811310116)
,p_name=>'REST_WS.SCRIPT_TOO_LONG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B85C\B4DC\B41C \C2A4\D06C\B9BD\D2B8\AC00 \B108\BB34 \D07D\B2C8\B2E4. Application Express\B294 32MB(32767\BC14\C774\D2B8)\B85C \C81C\D55C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105015414066309481)
,p_name=>'REST_WS.SECURED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105633430499309970)
,p_name=>'REST_WS.SEQ_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218\C5D0 \B300\D55C \C2DC\D000\C2A4 ID\AC00 \D544\C694\D558\C9C0\B9CC NULL\C774 \C218\C2E0\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106050981131310319)
,p_name=>'REST_WS.SIMPLE_STATUS_FAILURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D328')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106050813205310319)
,p_name=>'REST_WS.SIMPLE_STATUS_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106051003286310319)
,p_name=>'REST_WS.SIMPLE_STATUS_WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105663502018309997)
,p_name=>'REST_WS.TEMPLATE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105663701656309997)
,p_name=>'REST_WS.TEMPLATE_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105633645452309970)
,p_name=>'REST_WS.TEMPLATE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 ID\AC00 \D544\C694\D558\C9C0\B9CC NULL\C774 \C218\C2E0\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104933617444309421)
,p_name=>'REST_WS.TEMPLATE_MAY_NOT_BE_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('URI \D15C\D50C\B9AC\D2B8\B294 \B110\C77C \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105663692630309997)
,p_name=>'REST_WS.TEMPLATE_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8\AC00 \C5C5\B370\C774\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105015992086309481)
,p_name=>'REST_WS.TREE_ENABLED_OBJECTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105016014036309481)
,p_name=>'REST_WS.TREE_MODULES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105016107282309481)
,p_name=>'REST_WS.TREE_PRIVILEGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105016296805309481)
,p_name=>'REST_WS.TREE_ROLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106039491315310309)
,p_name=>'REST_WS.TREE_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('RESTful \B370\C774\D130 \C11C\BE44\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105015810517309481)
,p_name=>'REST_WS.UNALIASED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D \C9C0\C815\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105015308935309481)
,p_name=>'REST_WS.UNPUBLISHED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC8C\C2DC\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105015561843309481)
,p_name=>'REST_WS.UNSECURED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104998378711309468)
,p_name=>'REST_WS.VARIABLE_SYNTAX_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B098 \C774\C0C1\C758 URI \BCC0\C218\C5D0 \AD6C\BB38 \C624\B958\AC00 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105614568999309953)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\B4DC\D558\B824\B294 \C2A4\D06C\B9BD\D2B8\B294 APEX \AE30\BC18 RESTful \C11C\BE44\C2A4 \C775\C2A4\D3EC\D2B8\C785\B2C8\B2E4. ORDS RESTful \C11C\BE44\C2A4 \C784\D3EC\D2B8 \D398\C774\C9C0\C5D0\C11C \B85C\B4DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105878106592310167)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE_APEX'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\B4DC\D558\B824\B294 \C2A4\D06C\B9BD\D2B8\B294 ORDS \AE30\BC18 RESTful \C11C\BE44\C2A4 \C775\C2A4\D3EC\D2B8\C785\B2C8\B2E4. APEX RESTful \C11C\BE44\C2A4 \C784\D3EC\D2B8 \D398\C774\C9C0\C5D0\C11C \B85C\B4DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106051175273310320)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B9BD\BCF4\B4DC\B85C \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106051269223310320)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD_ARIA'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B9BD\BCF4\B4DC\B85C \C804\CCB4 URL \BCF5\C0AC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106009420168310279)
,p_name=>'RETAINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C874\B428')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105124187742309562)
,p_name=>'RETURN_TO_LOGIN_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B85C\ADF8\C778 \D398\C774\C9C0\B85C \B3CC\C544\AC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106129418634310392)
,p_name=>'RETURN_VALUE.N'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\D658 \AC12: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105350855180309736)
,p_name=>'REVIEWING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\D1A0 \C911')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105612223683309951)
,p_name=>'ROLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105130381501309570)
,p_name=>'ROLLBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864\BC31 \BA85\B839\BB38\C744 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \BAA8\B4E0 \BA85\B839\BB38\C774 \C790\B3D9\C73C\B85C \CEE4\BC0B\B418\C5C8\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105474142486309839)
,p_name=>'ROWS_IN_SECONDS'
,p_message_language=>'ko'
,p_message_text=>unistr('%1\CD08 \B3D9\C548 %0\AC1C\C758 \D589\C774 \BC18\D658\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104954086591309436)
,p_name=>'ROWS_RETURNED_IN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BC18\D658 \C704\CE58')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105564891018309914)
,p_name=>'RUN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104879150313309380)
,p_name=>'RUN_AND_BUILD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \BC0F \AC1C\BC1C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105330354269309720)
,p_name=>'RUN_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105567670385309916)
,p_name=>'RUN_APPLICATION_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C2E4\D589: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105127071486309568)
,p_name=>'RUN_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589\B9CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105569606176309918)
,p_name=>'RUN_PAGE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C2E4\D589: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104933236212309421)
,p_name=>'SAMPLE APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105527461087309884)
,p_name=>'SAMPLE_DS.COUNTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6D\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105527768527309884)
,p_name=>'SAMPLE_DS.COUNTRY.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6D\AC00, \C778\AD6C \BC0F \C218\B3C4 \BAA9\B85D\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105114822574309553)
,p_name=>'SAMPLE_DS.EMP_DEPT'
,p_message_language=>'ko'
,p_message_text=>'EMP / DEPT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105114910773309553)
,p_name=>'SAMPLE_DS.EMP_DEPT.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 EMP \BC0F DEPT \D14C\C774\BE14\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105527563031309884)
,p_name=>'SAMPLE_DS.F1'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\BBAC\B7EC \C6D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105527984079309884)
,p_name=>'SAMPLE_DS.F1.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\BBAC\B7EC \C6D0 \C6D4\B4DC \CC54\D53C\C5B8\C27D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106008773956310278)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C758\B8CC \C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106008831131310279)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C758\B8CC \C81C\ACF5\C790\B97C \C704\D574 \AC04\C18C\D654\B41C \D658\C790 \BCF4\ACE0 \C758\B8CC \C0C1\D0DC \C5C5\B370\C774\D2B8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105115044492309553)
,p_name=>'SAMPLE_DS.OEHR'
,p_message_language=>'ko'
,p_message_text=>unistr('HR \B370\C774\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105115163959309553)
,p_name=>'SAMPLE_DS.OEHR.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Education\C5D0 \ACF5\D1B5\C801\C73C\B85C \C0AC\C6A9\B418\B294 \C77C\BC18 HR \D14C\C774\BE14\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105567766406309916)
,p_name=>'SAMPLE_DS.ORDERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AC1D \C8FC\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105567812220309916)
,p_name=>'SAMPLE_DS.ORDERS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AC1D, \C0C1\C810, \C81C\D488 \BC0F \C8FC\BB38\C758 \BAA8\C74C\C785\B2C8\B2E4. \C774 \B370\C774\D130 \C9D1\D569\C5D0\B294 \C81C\D488 \C124\BA85, \C0C1\C810\C758 \ACBD\B3C4/\C704\B3C4\C5D0 \B300\D55C JSON \B370\C774\D130\AC00 \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105114633564309552)
,p_name=>'SAMPLE_DS.PROJECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C81D\D2B8 \B370\C774\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105114787167309553)
,p_name=>'SAMPLE_DS.PROJECT.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C81D\D2B8, \B9C8\C77C\C2A4\D1A4, \C791\C5C5 \B4F1\C758 \BAA8\C74C\C785\B2C8\B2E4. \C774 \B370\C774\D130 \C9D1\D569\C5D0\B294 \B9C8\C2A4\D130-\B514\D14C\C77C-\B514\D14C\C77C \AD00\ACC4 \BC0F \CC28\D2B8 \C791\C131\C5D0 \C720\C6A9\D55C \BDF0\AC00 \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105115250652309553)
,p_name=>'SAMPLE_DS.TASKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C2A4\D504\B808\B4DC\C2DC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105115361001309553)
,p_name=>'SAMPLE_DS.TASKS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5, \B0A0\C9DC, \C0C1\D0DC, \C9C0\C815 \B300\C0C1, \BE44\C6A9 \BC0F \C608\C0B0\C744 \D3EC\D568\D558\B294 \C815\ADDC\D654\B418\C9C0 \C54A\C740 \B370\C774\D130\AC00 \B4E4\C5B4 \C788\B294 \B2E8\C77C \D14C\C774\BE14\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105527335148309884)
,p_name=>'SAMPLE_DS.TENNIS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B2C8\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105527815819309884)
,p_name=>'SAMPLE_DS.TENNIS.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B79C\B4DC \C2AC\B7A8 \C774\BCA4\D2B8\C758 \B0A8\C131 \BC0F \C5EC\C131 \C6B0\C2B9\C790\C640 \C785\C0C1\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105527628715309884)
,p_name=>'SAMPLE_DS.WORLD_CUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4\B4DC\CEF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105528054845309885)
,p_name=>'SAMPLE_DS.WORLD_CUP.DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\CEE4 \C6D4\B4DC\CEF5 \ACB0\ACFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105411261493309781)
,p_name=>'SAMPLE_WEBSHEET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0D8\D50C \C6F9 \C2DC\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105398020924309771)
,p_name=>'SAVED_REPORTS.LINK_ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105398194453309771)
,p_name=>'SAVED_REPORTS.LINK_EXAMPLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C608\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105398215301309771)
,p_name=>'SAVED_REPORTS.MORE_SAVED_REPORTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \C800\C7A5\B41C \BCF4\ACE0\C11C...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105397792977309770)
,p_name=>'SAVED_REPORTS.PRIMARY_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105397063238309770)
,p_name=>'SAVED_REPORTS.PRIVATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105397103997309770)
,p_name=>'SAVED_REPORTS.PRIVATE.NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C6A9 \AC00\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105397642304309770)
,p_name=>'SAVED_REPORTS.PUBLIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105397954032309771)
,p_name=>'SAVED_REPORTS.REPORT_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105397827565309771)
,p_name=>'SAVED_REPORTS.REPORT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C720\D615')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105042093496309500)
,p_name=>'SC.BC.BCE_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D56D\BAA9\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105042289303309500)
,p_name=>'SC.BC.BCE_INSERTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D56D\BAA9\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105042195634309500)
,p_name=>'SC.BC.BCE_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D56D\BAA9\C774 \C5C5\B370\C774\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105041952207309500)
,p_name=>'SC.BC.BC_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105041821983309500)
,p_name=>'SC.BC.BC_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C\AC00 \C5C5\B370\C774\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105013844202309480)
,p_name=>'SC.LOV.IG_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105013782521309480)
,p_name=>'SC.LOV.PAGE_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105370295243309750)
,p_name=>'SCHEMAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105481755692309845)
,p_name=>'SCHEMA_INSERT_EXCEPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('wwv_flow_companies \C2A4\D0A4\B9C8 \C0BD\C785 \C608\C678\C0AC\D56D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105480759280309844)
,p_name=>'SCHEMA_IS_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \C2A4\D0A4\B9C8\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105480830185309844)
,p_name=>'SCHEMA_IS_NOT_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC "%0" \C2A4\D0A4\B9C8\B97C \C0AC\C6A9\D560 \C218 \C5C6\C73C\BA70 \AE30\C874 \C0AC\C6A9\C790\C640 \CDA9\B3CC\D558\BBC0\B85C \C0DD\C131\D560 \C218\B3C4 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105278451936309680)
,p_name=>'SCHEMA_PASSWORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8 \BE44\BC00\BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105095299654309538)
,p_name=>'SCHEMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106049345254310318)
,p_name=>'SCREEN_READER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9B0 \B9AC\B354')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105401385668309773)
,p_name=>'SCREEN_READER_TOGGLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D654\BA74 \D310\B3C5\AE30 \D1A0\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105431942273309803)
,p_name=>'SCRIPT_EXPORTED_FROM_FOREIGN_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D30C\C77C\C740 \B2E4\B978 \C791\C5C5\C601\C5ED(%0)\C5D0\C11C \C775\C2A4\D3EC\D2B8\B418\C5C8\C73C\BA70, \B2E4\B978 %1 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \C775\C2A4\D3EC\D2B8\B418\C5C8\C744 \C218\B3C4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106073569871310340)
,p_name=>'SCRIPT_NAME_LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C2A4\D06C\B9BD\D2B8\AC00 \C7A0\ACBC\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106073427740310340)
,p_name=>'SCRIPT_NAME_UNLOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C2A4\D06C\B9BD\D2B8\AC00 \C7A0\AE08 \D574\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106082616419310349)
,p_name=>'SCRIPT_NOT_LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8\AC00 \C7A0\AE30\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105358662609309742)
,p_name=>'SC_DESCRIBE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
unistr('\AC1D\CCB4\C5D0 \B300\D574 \C124\BA85\D558\B824\BA74 <br><br> '),
'',
unistr('\C704 \BA85\B839 \CC3D\C5D0 DESCRIBE &lt \AC1D\CCB4 \C774\B984 &gt\C744 \C785\B825\D558\ACE0 <b>\C2E4\D589</b>\C744 \B204\B974\C2ED\C2DC\C624.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105388173486309764)
,p_name=>'SC_NAME_NN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \C774\B984\C740 \B110\C77C \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105400126108309772)
,p_name=>'SC_NOT_VALID_OBJECT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre><br>',
unistr('\C124\BA85\D560 \AC1D\CCB4\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105390774048309765)
,p_name=>'SC_SC'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C2DC\AC01\C801 \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105325152935309717)
,p_name=>'SC_SQL_RUNNING'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BB38 \C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105390663593309765)
,p_name=>'SC_VQ'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC01\C801 \C9C8\C758')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106013151454310283)
,p_name=>'SEARCH_BAR_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \B3C4\AD6C \BAA8\C74C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105433149447309804)
,p_name=>'SEARCH_FIELD'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \D544\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105278861545309680)
,p_name=>'SEARCH_NOT_ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C9C8\C758\C5D0 varchar \C5F4\C774 \C5C6\C2B5\B2C8\B2E4. \AC80\C0C9\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105268250548309672)
,p_name=>'SEARCH_NOT_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\D560 varchar \C5F4\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105433083384309804)
,p_name=>'SEARCH_PACKAGED_APPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C0B0\C131 \BC0F \C0D8\D50C \C560\D50C\B9AC\CF00\C774\C158 \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105827594311310129)
,p_name=>'SEARCH_RESULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \ACB0\ACFC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106015018827310285)
,p_name=>'SECTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C139\C158')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105074058910309523)
,p_name=>'SECURITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105365333365309747)
,p_name=>'SECURITY_ASSIGNEE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548 \D53C\C9C0\C815\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105716235582310045)
,p_name=>'SECURITY_GROUP_ID_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548 \ADF8\B8F9 ID(\C791\C5C5\C601\C5ED ID)\AC00 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105363403768309745)
,p_name=>'SECURITY_IMPACT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548 \C601\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105405318626309776)
,p_name=>'SECURITY_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105391851550309766)
,p_name=>'SECURITY_SCHEME.MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\AC1C \C0AC\C6A9\C790\AC00 \C544\B2C8\C5B4\C57C \D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105365735391309747)
,p_name=>'SECURITY_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548 \C0C1\D0DC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105391304018309766)
,p_name=>'SEE_ATTACHED_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80\B41C \BCF4\ACE0\C11C \CC38\C870')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104926558798309416)
,p_name=>'SELECT_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105272521175309675)
,p_name=>'SELECT_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104881083728309381)
,p_name=>'SELECT_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C5D0\C11C \B0A0\C9DC\B97C \C120\D0DD\D558\C2ED\C2DC\C624. \D604\C7AC \C6D4 = %0, \D604\C7AC \C5F0\B3C4 = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105899511188310184)
,p_name=>'SELECT_DYNAMIC_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105083653711309530)
,p_name=>'SELECT_LABEL_TEMPLATE.THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105083580826309530)
,p_name=>'SELECT_LIST_TEMPLATE.THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105083491873309530)
,p_name=>'SELECT_PAGE_TEMPLATE.THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105083373896309530)
,p_name=>'SELECT_REGION_TEMPLATE.THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105083788439309530)
,p_name=>'SELECT_REPORT_TEMPLATE.THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106100565643310365)
,p_name=>'SELECT_ROW_C'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C120\D0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105535943384309891)
,p_name=>'SELECT_WORKSPACE_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('Application Express \AC1C\BC1C \D658\ACBD\C744 \C5F4\B824\BA74 \C544\B798\C5D0\C11C \C791\C5C5\C601\C5ED\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105459598653309827)
,p_name=>'SELF_SERVICE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C140\D504 \C11C\BE44\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105459417960309827)
,p_name=>'SELF_SERVICE_WITH_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \D655\C778\C744 \D3EC\D568\D55C \C140\D504 \C11C\BE44\C2A4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106073147005310340)
,p_name=>'SEPARATOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84 \AE30\D638')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105092109186309536)
,p_name=>'SEQUENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105520556956309878)
,p_name=>'SEQUENCE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104957443859309438)
,p_name=>'SERIES'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \ACC4\C5F4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105361935490309744)
,p_name=>'SERVICE_CHANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\BE44\C2A4 \BCC0\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104905050437309401)
,p_name=>'SERVICE_LOGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C774\D2B8 \AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105342060409309730)
,p_name=>'SERVICE_REQUEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\BE44\C2A4 \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105099724622309542)
,p_name=>'SERVICE_SIGNUP.ACCEPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778 \CF54\B4DC\B97C \B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\C5EC \C785\B825\D558\ACE0 <strong>\C694\CCAD \C81C\CD9C</strong>\C744 \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105098689440309541)
,p_name=>'SERVICE_SIGNUP.ADMIN_INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105099688217309542)
,p_name=>'SERVICE_SIGNUP.DB_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105098527766309541)
,p_name=>'SERVICE_SIGNUP.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105098972111309541)
,p_name=>'SERVICE_SIGNUP.EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105098705634309541)
,p_name=>'SERVICE_SIGNUP.FIRST_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105098310383309541)
,p_name=>'SERVICE_SIGNUP.JUSTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105098877547309541)
,p_name=>'SERVICE_SIGNUP.LAST_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105098230851309541)
,p_name=>'SERVICE_SIGNUP.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105099407414309541)
,p_name=>'SERVICE_SIGNUP.NO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105099068845309541)
,p_name=>'SERVICE_SIGNUP.PHONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\D654\BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105099246751309541)
,p_name=>'SERVICE_SIGNUP.REUSE_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C2A4\D0A4\B9C8 \C7AC\C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105099102292309541)
,p_name=>'SERVICE_SIGNUP.SCHEMA_INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105099541754309542)
,p_name=>'SERVICE_SIGNUP.SCHEMA_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105098140033309540)
,p_name=>'SERVICE_SIGNUP.WORKSPACE_INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105099337212309541)
,p_name=>'SERVICE_SIGNUP.YES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105291047230309689)
,p_name=>'SESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105393785661309768)
,p_name=>'SESSION VERIFY FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \D655\C778 \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104934714657309422)
,p_name=>'SESSIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105457405247309826)
,p_name=>'SESSION_MON_BUFFER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\D37C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105457228991309825)
,p_name=>'SESSION_MON_CPU'
,p_message_language=>'ko'
,p_message_text=>'CPU:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105456908311309825)
,p_name=>'SESSION_MON_CURRENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105457359961309825)
,p_name=>'SESSION_MON_DISK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B514\C2A4\D06C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105457112092309825)
,p_name=>'SESSION_MON_ELAPSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACFC \C2DC\AC04:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105457031746309825)
,p_name=>'SESSION_MON_PREVIOUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105018391387309483)
,p_name=>'SET_BINDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\B97C \D14C\C2A4\D2B8\D560 \B54C\B294 \BAA8\B4E0 \BC14\C778\B4DC \BCC0\C218\C758 \AC12\C744 \C124\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104920560972309412)
,p_name=>'SET_FEATURE_DUE_DATE_TO_MILESTONE_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('%2 \B9B4\B9AC\C2A4\C758 %1\C5D0 \C9C0\C815\B41C %0\AC1C \BBF8\C644\B8CC \AE30\B2A5\C758 \B9CC\AE30 \B0A0\C9DC\B97C \B9C8\C77C\C2A4\D1A4 \B0A0\C9DC\B85C \C124\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105040316964309499)
,p_name=>'SET_MILESTONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C77C\C2A4\D1A4 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104920849577309412)
,p_name=>'SET_MILESTONES_NOT_YET_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C77C\C2A4\D1A4\C774 \B204\B77D\B41C \AE30\B2A5\C744 %2 \B9B4\B9AC\C2A4\C758 %1\C5D0 \C9C0\C815\B41C %0\AC1C\C758 \BBF8\C644\B8CC \AE30\B2A5\C5D0 \B300\D55C \B9C8\C77C\C2A4\D1A4(%3)\C73C\B85C \C124\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104920706163309412)
,p_name=>'SET_MILESTONE_OF_INCOMPLETE_FEATURES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\D55C\C774 \ACBD\ACFC\D55C \B9C8\C77C\C2A4\D1A4\C5D0 \D574\B2F9\D558\B294 %2 \B9B4\B9AC\C2A4\C758 %1\C5D0 \C9C0\C815\B41C %0\AC1C \BBF8\C644\B8CC \AE30\B2A5\C758 \B9C8\C77C\C2A4\D1A4\C744 %3 \B9C8\C77C\C2A4\D1A4\C73C\B85C \BCC0\ACBD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105039989932309499)
,p_name=>'SET_OPEN_FEATURES_M1'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \BBF8\ACB0 \AE30\B2A5\C774 \C120\D0DD\D55C \B9C8\C77C\C2A4\D1A4\C5D0 \C9C0\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105040460359309499)
,p_name=>'SET_OPEN_FEATURES_M2'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \BBF8\ACB0 \B9CC\AE30 \B0A0\C9DC\AC00 \B9C8\C77C\C2A4\D1A4 \B0A0\C9DC\B85C \C124\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106077628630310344)
,p_name=>'SET_PREFERENCES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D658\ACBD\C124\C815 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105040652169309499)
,p_name=>'SET_RELEASE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9B4\B9AC\C2A4 \C124\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105456238125309825)
,p_name=>'SHARED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C720\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105635424487309972)
,p_name=>'SHARED COMPONENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C720 \AD6C\C131\C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105393405526309767)
,p_name=>'SHARED DYNAMIC LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C720\B41C \B3D9\C801 \AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104889996028309388)
,p_name=>'SHARED POOL'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C720 \D480')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105393336450309767)
,p_name=>'SHARED STATIC LOV CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C720\B41C \C815\C801 \AC12 \BAA9\B85D \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104964902565309444)
,p_name=>'SHARED_COMPONENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C720 \AD6C\C131\C694\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105632717034309970)
,p_name=>'SHARED_VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C720 \AC80\C99D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105095326917309539)
,p_name=>'SHORTCUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105537981313309893)
,p_name=>'SHORTCUTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105344970252309732)
,p_name=>'SIGNIFICANT_IMPACT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2EC\AC01\D55C \C601\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105348047108309734)
,p_name=>'SIGNIFICANT_PROGRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18 \C774\C0C1 \C9C4\D589\B41C \C0C1\D0DC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105093809497309537)
,p_name=>'SIMPLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C21C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105339451386309728)
,p_name=>'SIMPLE_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\B2E8\D55C \CC28\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105416586850309790)
,p_name=>'SINCE_DATE_MASK'
,p_message_language=>'ko'
,p_message_text=>unistr('16\C2DC\AC04 \C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105476029651309841)
,p_name=>'SINCE_DAY_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('1\C77C \C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105475952224309841)
,p_name=>'SINCE_HOUR_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('1\C2DC\AC04 \C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106095977682310361)
,p_name=>'SINCE_SHORT_DATE_MASK'
,p_message_language=>'ko'
,p_message_text=>unistr('16\C2DC\AC04 \B0B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105476109586309841)
,p_name=>'SINCE_WEEK_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('1\C8FC \C804')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104931537315309420)
,p_name=>'SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D06C\AE30')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106052355010310321)
,p_name=>'SL.APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C571')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106048430700310317)
,p_name=>'SL.EDIT.PAGE.IN.APP'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \C560\D50C\B9AC\CF00\C774\C158\C758 %0 \D398\C774\C9C0 \D3B8\C9D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106048569659310317)
,p_name=>'SL.GO.TO.APP'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \C774\B3D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105878381148310167)
,p_name=>'SL.MATCH.FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('1\AC1C\C758 \C77C\CE58 \D56D\BAA9\C774 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105878483798310167)
,p_name=>'SL.N.MATCHES.FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \C77C\CE58 \D56D\BAA9\C774 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105895757101310181)
,p_name=>'SL.NO.MATCH.FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\CE58 \D56D\BAA9\C744 \CC3E\C744 \C218 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106052489561310321)
,p_name=>'SL.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105569716267309918)
,p_name=>'SL.PLACEHOLDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105615073123309954)
,p_name=>'SL.SEARCH.ALLAPPS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \BAA8\B4E0 \C560\D50C\B9AC\CF00\C774\C158 \AC80\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106048844441310317)
,p_name=>'SL.SEARCH.APP'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \C774 \C571 \AC80\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105810520109310116)
,p_name=>'SL.SEARCH.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\D560 \BB38\C790\B97C 2\C790 \C774\C0C1 \C785\B825\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106048727097310317)
,p_name=>'SL.SEARCH.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \D398\C774\C9C0 \AC80\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106048996079310318)
,p_name=>'SL.SEARCH.TEAM.DEV'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \D300 \AC1C\BC1C \AC80\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106049065247310318)
,p_name=>'SL.SEARCH.USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 %0 \AC80\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106049170349310318)
,p_name=>'SL.SEARCH.WP'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \C791\C5C5\C601\C5ED \AC80\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106048680768310317)
,p_name=>'SL.SHARED.COMP.APP'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C571\C758 \ACF5\C720 \AD6C\C131\C694\C18C')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105341946635309729)
,p_name=>'SOFTWARE_DEFECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\D504\D2B8\C6E8\C5B4 \ACB0\D568')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105346962025309733)
,p_name=>'SOMEWHAT_DESIRABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C18C \AD8C\C7A5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105674323054310007)
,p_name=>'SOURCE_IDENTIFIER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4 \C2DD\BCC4\C790')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105481025533309845)
,p_name=>'SPACE_UTILIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \ACF5\AC04 \D65C\C6A9\B3C4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105330598170309721)
,p_name=>'SQL NOT AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL\C744 \C0AC\C6A9\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105538343384309893)
,p_name=>'SQL WORKSHOP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C6CC\D06C\C20D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105474000494309839)
,p_name=>'SQL_COMMANDS'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BA85\B839')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105369344865309750)
,p_name=>'SQL_COMMAND_HISTORY'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BA85\B839 \B0B4\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105147251626309583)
,p_name=>'SQL_EXPRESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105407681271309778)
,p_name=>'SQL_INJECT_LINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105407367275309778)
,p_name=>'SQL_INJECT_PACKAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D0A4\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105407401645309778)
,p_name=>'SQL_INJECT_PROCEDURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C2DC\C800')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105407259973309778)
,p_name=>'SQL_INJECT_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105407528811309778)
,p_name=>'SQL_INJECT_VAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105693010956310023)
,p_name=>'SQL_NOT_ENABLED_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C SQL \BC0F PL/SQL \C561\C138\C2A4\B97C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105693140144310023)
,p_name=>'SQL_NOT_ENABLED_INST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C778\C2A4\D134\C2A4\C5D0\C11C SQL \BC0F PL/SQL \C561\C138\C2A4\B97C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105092995944309537)
,p_name=>'SQL_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104898914026309396)
,p_name=>'SQL_QUERY_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C9C8\C758\C785\B2C8\B2E4. Select \BB38\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105194488453309617)
,p_name=>'SQL_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104997898278309468)
,p_name=>'SQL_REPORT_WIZ.APPEND'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105086667450309532)
,p_name=>'SQL_REPORT_WIZ.DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105087166846309533)
,p_name=>'SQL_REPORT_WIZ.DISABLE_SORT_COL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \C5F4\C744 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105086369789309532)
,p_name=>'SQL_REPORT_WIZ.DISPLAY_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105086719787309532)
,p_name=>'SQL_REPORT_WIZ.PRIMARY_SORT_COL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C815\B82C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104997783981309468)
,p_name=>'SQL_REPORT_WIZ.REPLACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\AFB8\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105086437029309532)
,p_name=>'SQL_REPORT_WIZ.RETURN_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\D658 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105086935318309532)
,p_name=>'SQL_REPORT_WIZ.SECONDARY_SORT_COL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C870 \C815\B82C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105087062815309533)
,p_name=>'SQL_REPORT_WIZ.SELECT_COL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105369552849309750)
,p_name=>'SQL_SCRIPTS'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C2A4\D06C\B9BD\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105369441265309750)
,p_name=>'SQL_SCRIPT_RESULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C2A4\D06C\B9BD\D2B8 \ACB0\ACFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105679146933310011)
,p_name=>'SQL_TAG_REF_NOT_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D5C8\C6A9\B418\B294 \D14C\C774\BE14 \BAA9\B85D\C5D0 \B2E4\C74C \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C815\C758\D574\C57C \D568: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105369645427309750)
,p_name=>'SQL_WORKSHOP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C6CC\D06C\C20D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105149551418309584)
,p_name=>'SQL_WS.OB.DUPLICATE_ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \BCC4\CE6D\C740 \B2E4\B978 \AC1D\CCB4\C5D0\C11C \C774\BBF8 \C0AC\C6A9 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105149411819309584)
,p_name=>'SQL_WS.OB.INVALID_ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\D55C \AC1D\CCB4 \BCC4\CE6D\C740 \BD80\C801\D569\D569\B2C8\B2E4. \C801\D569\D55C \BCC4\CE6D\C5D0\B294 \BB38\C790, \C22B\C790, \BC11\C904 \BC0F \B300\C2DC\B9CC \D3EC\D568\B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105463196766309830)
,p_name=>'SQL_WS.OB.NOT_ORDS_ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C2A4\D0A4\B9C8\B294 ORDS RESTful \B370\C774\D130 \C11C\BE44\C2A4\C5D0 \B4F1\B85D\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \C774 \C2A4\D0A4\B9C8\B97C \B4F1\B85D\D558\B824\BA74 <strong>RESTful \C11C\BE44\C2A4 > ORDS Restful \C11C\BE44\C2A4</strong>\B85C \C774\B3D9\D558\ACE0 <strong>ORDS\C5D0 \C2A4\D0A4\B9C8 \B4F1\B85D</strong> \B2E8\CD94\B97C \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105478131382309842)
,p_name=>'SQL_WS.OB.NO_REST_IN_CDB'
,p_message_language=>'ko'
,p_message_text=>unistr('APEX\AC00 \D604\C7AC CDB\C5D0\C11C \C2E4\D589\B418\ACE0 \C788\C2B5\B2C8\B2E4. CDB\C5D0\C11C\B294 ORDS \AE30\BC18 REST \C11C\BE44\C2A4\B97C \C815\C758\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105477979102309842)
,p_name=>'SQL_WS.OB.OLD_ORDS_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C124\CE58\B41C ORDS \BC84\C804(%0)\C740 \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\C5D0 REST\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D558\B294 \B370 \D544\C694\D55C \BAA8\B4E0 \AE30\B2A5\C744 \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \CD5C\C18C\D55C %1 \BC84\C804\C744 \C124\CE58\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105477721842309842)
,p_name=>'SQL_WS.OB.ORDS_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('ORDS RESTful \C11C\BE44\C2A4\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D558\AE30 \C704\D574 \D544\C694\D55C ORDS_METADATA \C2A4\D0A4\B9C8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C124\CE58 \B2E8\ACC4\B294 Oracle REST Data Services Installation Guide\B97C \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105478048030309842)
,p_name=>'SQL_WS.OB.ORDS_VERION'
,p_message_language=>'ko'
,p_message_text=>unistr('ORDS \BC84\C804 <strong>%0</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105477835015309842)
,p_name=>'SQL_WS.OB.PLSQL_GATEWAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C2DC\C2A4\D15C\C740 \D604\C7AC Oracle Embedded PL/SQL Gateway\B97C \C0AC\C6A9\D558\ACE0 \C788\C2B5\B2C8\B2E4. \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\C5D0 REST\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D558\B824\BA74 %0 \C774\C0C1\C758 Oracle REST Data Service \BC84\C804\C744 \C124\CE58\D574\C57C \D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104867822629309370)
,p_name=>'STACKED2DCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\C801 2D \C138\B85C \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104867978434309370)
,p_name=>'STACKED3DCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\C801 3D \C138\B85C \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104868009659309370)
,p_name=>'STACKEDHORIZONTAL2DCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\C801 \C218\D3C9 2D \C138\B85C \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104868152270309370)
,p_name=>'STACKEDHORIZONTAL3DCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\C801 \C218\D3C9 3D \C138\B85C \B9C9\B300')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105634278980309971)
,p_name=>'STANDARD _TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105635974593309973)
,p_name=>'STANDARD_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105074175249309523)
,p_name=>'STANDARD_TAB_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D0ED \C9D1\D569')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104960397579309440)
,p_name=>'STATIC APPLICATION FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \C560\D50C\B9AC\CF00\C774\C158 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104960206913309440)
,p_name=>'STATIC WORKSPACE FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \C791\C5C5\C601\C5ED \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106130974979310393)
,p_name=>'STATICSEARCH.MINIMUM_LENGTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\B450 \C790 \C774\C0C1\C758 \D0A4\C6CC\B4DC\B97C \D558\B098 \C774\C0C1 \C785\B825\D558\C2ED\C2DC\C624. ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106131006703310393)
,p_name=>'STATICSEARCH.NO_RESULTS_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \C9C8\C758\C640 \C77C\CE58\D558\B294 \ACB0\ACFC\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105147086122309582)
,p_name=>'STATIC_ASSIGNMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105479532042309843)
,p_name=>'STATIC_FILES_NO_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B41C \C560\D50C\B9AC\CF00\C774\C158 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104891181801309389)
,p_name=>'STATIC_HTML'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104874625930309376)
,p_name=>'STATIC_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105338247005309727)
,p_name=>'STATIC_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105402807714309774)
,p_name=>'STATIC_SUBSTITUTION_STRINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \B300\CCB4 \BB38\C790\C5F4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106093684945310359)
,p_name=>'STATUS_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105274099028309677)
,p_name=>'STATUS_MODIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC\AC00 \C218\C815\B428')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105389404897309764)
,p_name=>'STD TAB CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D0ED \C870\AC74')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106082779049310349)
,p_name=>'STEAL_LOCK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE08 \B3C4\C6A9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104934456539309422)
,p_name=>'STORAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5 \C601\C5ED:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105093076147309537)
,p_name=>'STRUCTURED_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C870\D654\B41C \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105194298791309617)
,p_name=>'STRUCTURED_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C870\D654\B41C \BCF4\ACE0\C11C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105480454178309844)
,p_name=>'SUBMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105273929982309677)
,p_name=>'SUBMITTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105189721806309614)
,p_name=>'SUBMIT_AS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105399671636309772)
,p_name=>'SUBMIT_FEEDBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31 \C81C\CD9C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105331795449309722)
,p_name=>'SUBORDINATE CURRENT ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C885\C18D \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105331856835309722)
,p_name=>'SUBORDINATE NON CURRENT ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC\AC00 \C544\B2CC \C885\C18D \D56D\BAA9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106108559240310373)
,p_name=>'SUBSCRIBED_FROM.NONEXISTING_MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C874\C7AC\D558\C9C0 \C54A\B294 \B9C8\C2A4\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106108713219310373)
,p_name=>'SUBSCRIBED_FROM.THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106108605160310373)
,p_name=>'SUBSCRIBED_FROM.THEME_REPOSITORY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C800\C7A5\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105076277404309525)
,p_name=>'SUBSCRIBE_AUTHORIZATION.COPIED_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105076579230309525)
,p_name=>'SUBSCRIBE_AUTHORIZATION.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\C758 "\B9C8\C2A4\D130" \BCF5\C0AC\BCF8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105076796921309525)
,p_name=>'SUBSCRIBE_AUTHORIZATION.NO_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\C5D0 \C801\C6A9\B418\B294 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105076640303309525)
,p_name=>'SUBSCRIBE_AUTHORIZATION.REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\C5D0 \C801\C6A9 \C911\C778 \AD8C\D55C \BD80\C5EC \CCB4\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104878610775309379)
,p_name=>'SUBSCRIBE_DATA_LOAD.COPIED_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104878971289309380)
,p_name=>'SUBSCRIBE_DATA_LOAD.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B370\C774\D130 \B85C\B4DC \C815\C758\C758 "\B9C8\C2A4\D130" \BCF5\C0AC\BCF8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104878863566309380)
,p_name=>'SUBSCRIBE_DATA_LOAD.NO_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C815\C758\C5D0 \C801\C6A9\B418\B294 \B370\C774\D130 \B85C\B4DC \C815\C758\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104878762779309379)
,p_name=>'SUBSCRIBE_DATA_LOAD.REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C815\C758\C5D0 \C801\C6A9\B418\B294 \B370\C774\D130 \B85C\B4DC \C815\C758\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105075646049309524)
,p_name=>'SUBSCRIBE_ITEM_HELP.COPIED_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105075770457309524)
,p_name=>'SUBSCRIBE_ITEM_HELP.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \B3C4\C6C0\B9D0\C758 "\B9C8\C2A4\D130" \BCF5\C0AC\BCF8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105075963098309525)
,p_name=>'SUBSCRIBE_ITEM_HELP.NO_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\C5D0 \C801\C6A9\B418\B294 \D56D\BAA9\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105075878281309524)
,p_name=>'SUBSCRIBE_ITEM_HELP.REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\C5D0 \C801\C6A9 \C911\C778 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105078230132309526)
,p_name=>'SUBSCRIBE_LOV.COPIED_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105078332088309526)
,p_name=>'SUBSCRIBE_LOV.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC12 \BAA9\B85D\C758 "\B9C8\C2A4\D130" \BCF5\C0AC\BCF8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105078528315309526)
,p_name=>'SUBSCRIBE_LOV.NO_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC12 \BAA9\B85D\C5D0 \C801\C6A9\B418\B294 \AC12 \BAA9\B85D\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105078474814309526)
,p_name=>'SUBSCRIBE_LOV.REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC12 \BAA9\B85D\C5D0 \C801\C6A9 \C911\C778 \AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104966383265309445)
,p_name=>'SUBSCRIBE_NAVBAR.COPIED_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105079820370309527)
,p_name=>'SUBSCRIBE_NAVBAR.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D0D0\C0C9\D45C\C2DC\C904\C758 "\B9C8\C2A4\D130" \BCF5\C0AC\BCF8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105080449301309528)
,p_name=>'SUBSCRIBE_NAVBAR.NO_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D0D0\C0C9\D45C\C2DC\C904\C5D0 \C801\C6A9\B418\B294 \D0D0\C0C9\D45C\C2DC\C904\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105080150916309528)
,p_name=>'SUBSCRIBE_NAVBAR.REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D0D0\C0C9\D45C\C2DC\C904\C5D0 \C801\C6A9 \C911\C778 \D0D0\C0C9\D45C\C2DC\C904')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104965986147309445)
,p_name=>'SUBSCRIBE_PLUGIN.COPIED_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104966035465309445)
,p_name=>'SUBSCRIBE_PLUGIN.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D50C\B7EC\ADF8\C778\C758 "\B9C8\C2A4\D130" \BCF5\C0AC\BCF8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104966287070309445)
,p_name=>'SUBSCRIBE_PLUGIN.NO_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D50C\B7EC\ADF8\C778\C5D0 \C801\C6A9\B418\B294 \D50C\B7EC\ADF8\C778\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104966125505309445)
,p_name=>'SUBSCRIBE_PLUGIN.REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D50C\B7EC\ADF8\C778\C5D0 \C801\C6A9 \C911\C778 \D50C\B7EC\ADF8\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105077042512309525)
,p_name=>'SUBSCRIBE_SHORTCUT.COPIED_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105077252446309525)
,p_name=>'SUBSCRIBE_SHORTCUT.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD95\D0A4\C758 "\B9C8\C2A4\D130" \BCF5\C0AC\BCF8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105077587020309526)
,p_name=>'SUBSCRIBE_SHORTCUT.NO_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD95\D0A4\C5D0 \C801\C6A9\B418\B294 \B2E8\CD95\D0A4\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105077414740309526)
,p_name=>'SUBSCRIBE_SHORTCUT.REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BC14\B85C\AC00\AE30\C5D0 \C801\C6A9 \C911\C778 \BC14\B85C\AC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105071823881309522)
,p_name=>'SUBSCRIBE_TEMPLATE.COPIED_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105072020528309522)
,p_name=>'SUBSCRIBE_TEMPLATE.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D15C\D50C\B9AC\D2B8\C758 "\B9C8\C2A4\D130" \BCF5\C0AC\BCF8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105072135746309522)
,p_name=>'SUBSCRIBE_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\B418\B294 \D15C\D50C\B9AC\D2B8\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105071988113309522)
,p_name=>'SUBSCRIBE_TEMPLATE.POPUP_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105082956167309530)
,p_name=>'SUBSCRIBE_TEMPLATE.REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9 \C911\C778 \D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106047301270310316)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D14C\B9C8\C5D0 \C801\C6A9\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106089950116310356)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D14C\B9C8\C5D0 \C801\C6A9\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106047710568310316)
,p_name=>'SUBSCRIBE_THEME.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D14C\B9C8\C758 "\B9C8\C2A4\D130" \BCF5\C0AC\BCF8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106047687017310316)
,p_name=>'SUBSCRIBE_THEME.NO_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D14C\B9C8\B97C \C801\C6A9\D558\B294 \D14C\B9C8\AC00 \C5C6\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106047407961310316)
,p_name=>'SUBSCRIBE_THEME.POPUP_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D \D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106047591918310316)
,p_name=>'SUBSCRIBE_THEME.REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D14C\B9C8\C5D0 \C801\C6A9 \C911\C778 \D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105455292608309824)
,p_name=>'SUBSCRIBE_WEB_SRC.COPIED_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105455300141309824)
,p_name=>'SUBSCRIBE_WEB_SRC.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 REST \B370\C774\D130 \C18C\C2A4\C758 "\B9C8\C2A4\D130" \BCF5\C0AC\BCF8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105455593179309824)
,p_name=>'SUBSCRIBE_WEB_SRC.NO_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C18C\C2A4\C5D0 \C801\C6A9\B418\B294 REST \B370\C774\D130 \C18C\C2A4\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105455447440309824)
,p_name=>'SUBSCRIBE_WEB_SRC.REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C18C\C2A4\C5D0 \C801\C6A9\B418\B294 REST \B370\C774\D130 \C18C\C2A4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105081953454309529)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.COPIED_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105082777696309529)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD94 \D15C\D50C\B9AC\D2B8\C758 "\B9C8\C2A4\D130" \BCF5\C0AC\BCF8\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105083145429309530)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.NO_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD94 \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\B418\B294 \D15C\D50C\B9AC\D2B8\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105083037828309530)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD94 \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9 \C911\C778 \B2E8\CD94 \D15C\D50C\B9AC\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104909932292309404)
,p_name=>'SUBSTITUTION_STRING_USAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4 \BB38\C790\C5F4 \C0AC\C6A9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105310656529309705)
,p_name=>'SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105387150403309763)
,p_name=>'SUCCESS MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105273021804309676)
,p_name=>'SUCCESSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105139775843309577)
,p_name=>'SUCCESS_MSG.CLUSTER_TRUNCATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B7EC\C2A4\D130\AC00 \C798\B838\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105136068619309574)
,p_name=>'SUCCESS_MSG.CMD_EXECUTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA85\B839\C774 \C2E4\D589\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105138877221309576)
,p_name=>'SUCCESS_MSG.CONTEXT_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE8\D14D\C2A4\D2B8\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105139089147309577)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \B9C1\D06C\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105138963845309577)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \B9C1\D06C\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105139980192309577)
,p_name=>'SUCCESS_MSG.FUNCTION_ALTERED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218\AC00 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105134944039309574)
,p_name=>'SUCCESS_MSG.FUNCTION_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105137850177309576)
,p_name=>'SUCCESS_MSG.FUNCTION_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105139563473309577)
,p_name=>'SUCCESS_MSG.INDEXTYPE_ALTERED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B371\C2A4 \C720\D615\C774 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105138776413309576)
,p_name=>'SUCCESS_MSG.INDEXTYPE_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B371\C2A4 \C720\D615\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105135347218309574)
,p_name=>'SUCCESS_MSG.INDEX_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B371\C2A4\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105138195007309576)
,p_name=>'SUCCESS_MSG.INDEX_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B371\C2A4\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105135661171309574)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\CCB4\D654\B41C \BDF0\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105138257106309576)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\CCB4\D654\B41C \BDF0\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105139806713309577)
,p_name=>'SUCCESS_MSG.PACKAGE_ALTERED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D0A4\C9C0\AC00 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105135135888309574)
,p_name=>'SUCCESS_MSG.PKG_BODY_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D0A4\C9C0 \BCF8\BB38\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105135284516309574)
,p_name=>'SUCCESS_MSG.PKG_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D0A4\C9C0\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105137145351309575)
,p_name=>'SUCCESS_MSG.PKG_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D0A4\C9C0\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105140036008309577)
,p_name=>'SUCCESS_MSG.PROCEDURE_ALTERED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C2DC\C800\AC00 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105135084827309574)
,p_name=>'SUCCESS_MSG.PROCEDURE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C2DC\C800\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105137907473309576)
,p_name=>'SUCCESS_MSG.PROCEDURE_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C2DC\C800\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105135788736309574)
,p_name=>'SUCCESS_MSG.ROLE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105138347573309576)
,p_name=>'SUCCESS_MSG.ROLE_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B864\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105136556499309575)
,p_name=>'SUCCESS_MSG.ROWS_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \D589\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105136392241309575)
,p_name=>'SUCCESS_MSG.ROWS_INSERTED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \D589\C774 \C0BD\C785\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105136296886309575)
,p_name=>'SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \D589\C774 \C5C5\B370\C774\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105140161114309577)
,p_name=>'SUCCESS_MSG.SEQ_ALTERED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4\AC00 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105135852474309574)
,p_name=>'SUCCESS_MSG.SEQ_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105137596700309576)
,p_name=>'SUCCESS_MSG.SEQ_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104861542327309364)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104861436783309364)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104861350681309364)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C774 \C5C5\B370\C774\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104896385321309394)
,p_name=>'SUCCESS_MSG.STMT_PROCESSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA85\B839\BB38\C774 \CC98\B9AC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105135957899309574)
,p_name=>'SUCCESS_MSG.SYNONYM_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C758\C5B4\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105138429667309576)
,p_name=>'SUCCESS_MSG.SYNONYM_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C758\C5B4\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105137611612309576)
,p_name=>'SUCCESS_MSG.TABLE_ALTERED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C774 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105134527762309573)
,p_name=>'SUCCESS_MSG.TABLE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105137083521309575)
,p_name=>'SUCCESS_MSG.TABLE_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105139154254309577)
,p_name=>'SUCCESS_MSG.TABLE_RENAMED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C774\B984\C774 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105139601963309577)
,p_name=>'SUCCESS_MSG.TABLE_TRUNCATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C774 \C798\B838\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105139440698309577)
,p_name=>'SUCCESS_MSG.TRIGGER_ALTERED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC\AC70\AC00 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105134829085309574)
,p_name=>'SUCCESS_MSG.TRIGGER_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC\AC70\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105138560585309576)
,p_name=>'SUCCESS_MSG.TRIGGER_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC\AC70\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105139300371309577)
,p_name=>'SUCCESS_MSG.TYPE_ALTERED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615\C774 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105135478278309574)
,p_name=>'SUCCESS_MSG.TYPE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105138611932309576)
,p_name=>'SUCCESS_MSG.TYPE_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105140295841309578)
,p_name=>'SUCCESS_MSG.USER_ALTERED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105135536596309574)
,p_name=>'SUCCESS_MSG.USER_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105137216186309575)
,p_name=>'SUCCESS_MSG.USER_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105139291217309577)
,p_name=>'SUCCESS_MSG.VIEW_ALTERED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BDF0\AC00 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105134687069309573)
,p_name=>'SUCCESS_MSG.VIEW_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BDF0\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105137378395309575)
,p_name=>'SUCCESS_MSG.VIEW_DROPPED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BDF0\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105479162625309843)
,p_name=>'SUPPORTING_OBJECTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0 \AC1D\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106015834048310285)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4 \C815\C758\AC00 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106015925660310286)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4\AC00 \B354 \C774\C0C1 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105339741648309728)
,p_name=>'SVG CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('SVG \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105429258425309801)
,p_name=>'SVG PLUGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\B97C \BCF4\B824\BA74 SVG Viewer\B97C \C124\CE58\D558\C2ED\C2DC\C624.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104859855711309362)
,p_name=>'SW_EMPTY_SCRIPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE48 SQL \C2A4\D06C\B9BD\D2B8\B294 \D3B8\C9D1\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104859981878309363)
,p_name=>'SW_GREATER_THAN_30K'
,p_message_language=>'ko'
,p_message_text=>unistr('30KB\AC00 \B118\B294 \C2A4\D06C\B9BD\D2B8\B294 \D3B8\C9D1\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105092250407309536)
,p_name=>'SYNONYM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C758\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105693506483310024)
,p_name=>'SYNONYM_IN_PAREN'
,p_message_language=>'ko'
,p_message_text=>unistr('(\B3D9\C758\C5B4)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105472452690309838)
,p_name=>'SYNONYM_NOUN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C758\C5B4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105603606792309945)
,p_name=>'SYSTEM_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C2A4\D15C \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105274136625309677)
,p_name=>'SYSTEM_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C2A4\D15C \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105274269381309677)
,p_name=>'SYSTEM_STATUS_MODIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C2A4\D15C \C0C1\D0DC\AC00 \C218\C815\B428')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105092318575309536)
,p_name=>'TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105340377940309728)
,p_name=>'TABLE NOT FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \C801\D569\D55C \D14C\C774\BE14 \B610\B294 \BDF0 \C774\B984\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105370188155309750)
,p_name=>'TABLESPACES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C2A4\D398\C774\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105091302398309536)
,p_name=>'TABLE_IN_PAREN'
,p_message_language=>'ko'
,p_message_text=>unistr('(\D14C\C774\BE14)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105386569444309762)
,p_name=>'TABLE_NAME_TOO_LONG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C774\B984 %0\C774(\AC00) \D5C8\C6A9\B41C \D06C\AE30\B97C \CD08\ACFC\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105399456623309772)
,p_name=>'TABULAR_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C \D615\C2DD \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105405912445309777)
,p_name=>'TABULAR_FORM_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C \D615\C2DD \D3FC\C774 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105087236373309533)
,p_name=>'TAB_MANAGER.WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: \C0C1\C704 \D0ED \B300\C0C1 "%0"\C740(\B294) \C874\C7AC\D558\C9C0 \C54A\B294 \D398\C774\C9C0\B97C \CC38\C870\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105078911698309527)
,p_name=>'TAB_SEQUENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C21C\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105077846036309526)
,p_name=>'TAB_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105634194161309971)
,p_name=>'TAB_SETS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105078024084309526)
,p_name=>'TAB_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \D14D\C2A4\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106094837467310360)
,p_name=>'TAG_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0DC\ADF8: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104919389437309411)
,p_name=>'TARGETED_FEATURES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1 \AE30\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106132941864310395)
,p_name=>'TARGET_PAGE_ID_OR_CUSTOM_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1 \D398\C774\C9C0 ID \B610\B294 \C0AC\C6A9\C790\C815\C758 URL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105343016553309730)
,p_name=>'TASK_COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C644\B8CC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105367288610309748)
,p_name=>'TEAM_DEVELOPMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D300 \AC1C\BC1C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105072897440309522)
,p_name=>'TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106122052967310385)
,p_name=>'TEMPLATE.ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105326786038309718)
,p_name=>'TEMPLATE.AFTER_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105326859673309718)
,p_name=>'TEMPLATE.BEFORE_FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\B2E5\AE00 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106121775461310385)
,p_name=>'TEMPLATE.COPY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \BCF5\C0AC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106121955780310385)
,p_name=>'TEMPLATE.NEW_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \D15C\D50C\B9AC\D2B8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104855478649309359)
,p_name=>'TEMPLATE.PAGE_TMP_BDY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105326484630309718)
,p_name=>'TEMPLATE.PAGE_TMP_BDY1'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8 \BCF8\BB38 (1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105326583338309718)
,p_name=>'TEMPLATE.PAGE_TMP_BDY2'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8 \BCF8\BB38 (2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105326677541309718)
,p_name=>'TEMPLATE.PAGE_TMP_BDY3'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8 \BCF8\BB38 (3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106121886719310385)
,p_name=>'TEMPLATE.PREVIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \BBF8\B9AC\BCF4\AE30: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105325678628309717)
,p_name=>'TEMPLATE.T_REGION_POS09'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105325776092309717)
,p_name=>'TEMPLATE.T_REGION_POS10'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105325894775309717)
,p_name=>'TEMPLATE.T_REGION_POS11'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105325950155309717)
,p_name=>'TEMPLATE.T_REGION_POS12'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105326007955309717)
,p_name=>'TEMPLATE.T_REGION_POS13'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105326116819309717)
,p_name=>'TEMPLATE.T_REGION_POS14'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105326231723309717)
,p_name=>'TEMPLATE.T_REGION_POS15'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105326334705309717)
,p_name=>'TEMPLATE.T_REGION_POS16'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704\CE58 16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105829381435310130)
,p_name=>'TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105459647069309827)
,p_name=>'TEMPLATE_APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104889467316309388)
,p_name=>'TEMPLATE_APP_INSTALL_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C744 \AE30\C900\C73C\B85C \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105526626849309883)
,p_name=>'TEMPLATE_DRIVEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \AD6C\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105457700663309826)
,p_name=>'TEMPLATE_OPTIONS.ADVANCED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105457614638309826)
,p_name=>'TEMPLATE_OPTIONS.COMMON'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\D1B5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105901660331310185)
,p_name=>'TEMPLATE_OPTIONS.DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105457575226309826)
,p_name=>'TEMPLATE_OPTIONS.GENERAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106018787752310288)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTIONS_DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\CE58\D558\B294 \D15C\D50C\B9AC\D2B8 \C635\C158\C774 \C815\C758\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106026485576310296)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTION_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('- \C120\D0DD\B41C \C635\C158 \C5C6\C74C -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106002984180310273)
,p_name=>'TEMPLATE_OPTIONS.USE_TEMPLATE_DEFAULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \AE30\BCF8\AC12 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106109371714310373)
,p_name=>'TEMPLATE_OPTIONS_MISMATCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C635\C158 \BD88\C77C\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106130478811310393)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D15C\D50C\B9AC\D2B8\B294 \B9C8\C2A4\D130 \D14C\B9C8\C758 \D574\B2F9 \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\B429\B2C8\B2E4. \C774 \D15C\D50C\B9AC\D2B8\B97C \C218\C815\D558\B824\BA74 \B9C8\C2A4\D130 \D15C\D50C\B9AC\D2B8\B97C \D3B8\C9D1\D55C \D6C4 \D14C\B9C8\B97C \C0C8\B85C\ACE0\CE68\D569\B2C8\B2E4. \B610\B294 \C774 \D15C\D50C\B9AC\D2B8\C758 \C801\C6A9 \D574\C81C\B41C \B85C\CEEC \BCF5\C0AC\BCF8\C744 \C0DD\C131\D560 \C218 \C788\C2B5\B2C8\B2E4. \C801\C6A9 \D574\C81C\B41C \D15C\D50C\B9AC\D2B8\B294 \D3B8\C9D1 \AC00\B2A5\D558\BA70 \D14C\B9C8 \C0C8\B85C\ACE0\CE68\C744 \C218\D589\D574\B3C4 \ACB9\CCD0\C4F0\C5EC\C9C0\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106130339437310393)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D15C\D50C\B9AC\D2B8\B294 \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C\B9CC \C0AC\C6A9\D560 \C218 \C788\C73C\BA70 \C801\C6A9\C744 \D574\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4. '),
unistr('\C5F0\AD00\B41C \D14C\B9C8\AC00 \C801\C6A9\B41C \ACBD\C6B0 \AC1C\BCC4 \D15C\D50C\B9AC\D2B8\B97C \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.'),
unistr('\B85C\CEEC \D15C\D50C\B9AC\D2B8\B97C \C815\C758\D558\B294 \B2E4\B978 \BC29\BC95\C73C\B85C, \B9C8\C2A4\D130 \D14C\B9C8\C5D0 \C0C8 \D15C\D50C\B9AC\D2B8\B97C \CD94\AC00\D55C \B2E4\C74C \C774 \D15C\D50C\B9AC\D2B8\B97C \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \C190\C27D\AC8C \B0B4\BCF4\B0B4\AC70\B098 \AC00\C838\C62C \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105084058384309530)
,p_name=>'TEMPLATE_UTILIZATION.DEFAULT_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AE30\BCF8 \D15C\D50C\B9AC\D2B8\B85C \CC38\C870\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105084244001309531)
,p_name=>'TEMPLATE_UTILIZATION.ERROR_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D15C\D50C\B9AC\D2B8\B85C \CC38\C870\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105084498850309531)
,p_name=>'TEMPLATE_UTILIZATION.NOT_REFERENCED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B294 \CC38\C870\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105084590510309531)
,p_name=>'TEMPLATE_UTILIZATION.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B294')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105084341876309531)
,p_name=>'TEMPLATE_UTILIZATION.PAGE_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C5D0\C11C \CC38\C870\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105084152573309530)
,p_name=>'TEMPLATE_UTILIZATION.PRINTER_FRIENDLY_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4\C6A9 \D654\BA74 \D15C\D50C\B9AC\D2B8\B85C \CC38\C870\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105278644438309680)
,p_name=>'TEMPORARY_TABLESPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C784\C2DC \D14C\C774\BE14\C2A4\D398\C774\C2A4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105140371520309578)
,p_name=>'TEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105365167934309746)
,p_name=>'TESTING_ASSIGNEE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C2A4\D2B8 \D53C\C9C0\C815\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105363399706309745)
,p_name=>'TESTING_IMPACT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C2A4\D2B8 \C601\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105365585939309747)
,p_name=>'TESTING_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C2A4\D2B8 \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105431837765309803)
,p_name=>'TEST_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \D14C\C2A4\D2B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105635369109309972)
,p_name=>'TEXT FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \D30C\C77C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105033563778309494)
,p_name=>'THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104960108074309440)
,p_name=>'THEME FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105634935674309972)
,p_name=>'THEME IMAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106096043093310361)
,p_name=>'THEME.COMPATIBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D638\D658 \AC00\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105887371716310174)
,p_name=>'THEME.SELECTOR.APP.GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105027910052309490)
,p_name=>'THEMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106130593686310393)
,p_name=>'THEME_IS_SUBSCRIBED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \B808\BCA8\C758 \B2E4\B978 \D14C\B9C8\C5D0 \C801\C6A9\B418\AE30 \B54C\BB38\C5D0 \D14C\B9C8\C758 \C77C\BD80\C778 \AC1C\BCC4 \D15C\D50C\B9AC\D2B8\C758 \C801\C6A9\C744 \D574\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106130871452310393)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TO_TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C740 \BAA9\B85D \AE30\BC18 \D0D0\C0C9\C744 \C0AC\C6A9\D558\AE30 \B54C\BB38\C5D0 \D0ED \AE30\BC18 \D0D0\C0C9\C744 \C0AC\C6A9\D558\B294 \D14C\B9C8\B85C \BCC0\D658\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106130738775310393)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TWO_LEVEL_TABS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C740 \B450 \B808\BCA8 \D0ED\C744 \C0AC\C6A9\D558\AE30 \B54C\BB38\C5D0 \BAA9\B85D \AE30\BC18 \D0D0\C0C9\C744 \C0AC\C6A9\D558\B294 \D14C\B9C8\B85C \BCC0\D658\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \D14C\B9C8\B97C \C804\D658\D558\AE30 \C804\C5D0 \D55C \B808\BCA8 \D0ED\B9CC \C0AC\C6A9\D558\B3C4\B85D \D558\B824\BA74 \C560\D50C\B9AC\CF00\C774\C158\C744 \C5C5\B370\C774\D2B8\D558\ACE0 \D604\C7AC \D0ED \C124\C815\C744 \C124\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105347191144309733)
,p_name=>'THEME_SWITCH.CANNOT_SWITCH_DESKTOP_TO_MOBILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C2A4\D06C\D1B1 \D14C\B9C8\B97C \BAA8\BC14\C77C \D14C\B9C8\B85C \C804\D658\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105253587880309661)
,p_name=>'THEME_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C720\D615')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106094258068310359)
,p_name=>'TITLE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105342457541309730)
,p_name=>'TO DO'
,p_message_language=>'ko'
,p_message_text=>unistr('\D560 \C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105389270931309764)
,p_name=>'TODO'
,p_message_language=>'ko'
,p_message_text=>unistr('\D560 \C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105368940391309749)
,p_name=>'TODOS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D560 \C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104918594267309410)
,p_name=>'TODO_COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D560 \C77C \C644\B8CC(%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105673925141310007)
,p_name=>'TODO_DASH_1'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \D56D\BAA9 \C911 %1\AC1C\AC00 \C5F4\B824 \C788\ACE0, %2\AC1C\AC00 \C644\B8CC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105674035108310007)
,p_name=>'TODO_DASH_2'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \D56D\BAA9\C774 \BD80\BD84\C801\C73C\B85C \C644\B8CC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105674175260310007)
,p_name=>'TODO_DASH_3'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \D56D\BAA9\C774 \BD80\BD84\C801\C73C\B85C \C644\B8CC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105367768980309748)
,p_name=>'TOP_TABLES_BY_ROW_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8\B85C \BCF4\ACE0\B41C \D589 \C218\BCC4 %0 \CD5C\C0C1\C704 \D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105392315554309767)
,p_name=>'TOTAL_CLOSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \C885\ACB0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105389850601309765)
,p_name=>'TOTAL_MILESTONES'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \B9C8\C77C\C2A4\D1A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105392235969309766)
,p_name=>'TOTAL_OPENED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \BBF8\ACB0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105367810368309748)
,p_name=>'TOTAL_RENDER_ELAPSED_SECONDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \B80C\B354\B9C1 \C2DC\AC04(\CD08)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106009703455310279)
,p_name=>'TO_BE_PURGED_IN_NEXT_7_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C6B0\AE30\AC00 \C608\C815\B428(\B2E4\C74C 7\C77C \C774\B0B4)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105390926975309766)
,p_name=>'TO_DOS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D560 \C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105696070393310026)
,p_name=>'TO_DO_PERCENT_COMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D560 \C77C \C644\B8CC\C728(%0/%1):')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105094373016309538)
,p_name=>'TREE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105517137015309875)
,p_name=>'TREE_EXAMPLES_EXISTING_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \D56D\BAA9\C744 \AE30\C900\C73C\B85C \D2B8\B9AC \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105517225983309875)
,p_name=>'TREE_EXAMPLES_SQL_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \AE30\C900\C73C\B85C \D2B8\B9AC \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105517482877309875)
,p_name=>'TREE_EXAMPLES_START_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \D2B8\B9AC \AC12\C774 NULL\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105517339682309875)
,p_name=>'TREE_EXAMPLES_STATIC_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 \AC12\C744 \AE30\C900\C73C\B85C \D2B8\B9AC \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105007579372309475)
,p_name=>'TREE_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC\AC00 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105092401037309536)
,p_name=>'TRIGGER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104969207441309447)
,p_name=>'TRIGGER.BUTTON_TAB_NAMES_NOT_EQUAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C774\B984\C740 \AE30\C874 \D0ED\ACFC \B3D9\C77C\D55C \C774\B984\C774\BA74 \C548\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105475203034309840)
,p_name=>'TRIGGER.FLOWID_SGID_MISMATCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID \BC0F \D604\C7AC \BCF4\C548 \ADF8\B8F9 ID\AC00 \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104969187424309447)
,p_name=>'TRIGGER.SGID_RESERVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548 \ADF8\B8F9 ID 20\C740 ''ORACLE'' \C791\C5C5\C601\C5ED\C6A9\C73C\B85C \C608\C57D\B418\C5B4 \C788\C74C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105473128695309838)
,p_name=>'TRUNCATE_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D14C\C774\BE14 \C0AD\C81C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105518062925309876)
,p_name=>'TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105519964197309878)
,p_name=>'TYPE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105468505916309834)
,p_name=>'UI_DEF_CUSTOM_ITEM_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \D56D\BAA9 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105475155144309840)
,p_name=>'UI_DEF_VIEW_DB_COL_DEFN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C5F4 \C815\C758 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105361538633309744)
,p_name=>'UI_PAGE_SKIP_TO_CONTENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \CF58\D150\CE20\B85C \AC74\B108\B6F0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104882341991309382)
,p_name=>'UI_TYPE.DESKTOP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C2A4\D06C\D1B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104882441396309382)
,p_name=>'UI_TYPE.JQM_SMARTPHONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\BC14\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104882510073309383)
,p_name=>'UI_TYPE.JQM_TABLET'
,p_message_language=>'ko'
,p_message_text=>unistr('jQuery \BAA8\BC14\C77C \D0DC\BE14\B9BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104882621153309383)
,p_name=>'UI_TYPE.PHONEGAP_JQM_SMARTPHONE'
,p_message_language=>'ko'
,p_message_text=>unistr('PhoneGap\C6A9 jQuery \BAA8\BC14\C77C \C2A4\B9C8\D2B8\D3F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104882777187309383)
,p_name=>'UI_TYPE.PHONEGAP_JQM_TABLET'
,p_message_language=>'ko'
,p_message_text=>unistr('PhoneGap\C6A9 jQuery \BAA8\BC14\C77C \D0DC\BE14\B9BF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105040594186309499)
,p_name=>'UNABLE_TO_DETERMINE_MS_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C77C\C2A4\D1A4 \B0A0\C9DC\B97C \D655\C778\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105411798499309781)
,p_name=>'UNASSIGNED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105434788042309806)
,p_name=>'UNAUTHENTICATED_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\B418\C9C0 \C54A\C740 \C0AC\C6A9\C790')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105615862729309955)
,p_name=>'UNAVAILABLE_REDIRECT_TO_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \BD88\AC00(URL\B85C \C7AC\C9C0\C815)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105615727906309955)
,p_name=>'UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \BD88\AC00(PL/SQL\B85C \D45C\C2DC\B41C \C0C1\D0DC)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105350231695309735)
,p_name=>'UNDER_CONSIDERATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\B824 \C911')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104965207898309444)
,p_name=>'UNEXPIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9CC\AE30\B418\C9C0 \C54A\C74C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105476752903309841)
,p_name=>'UNLOCK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE08 \D574\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105564727464309914)
,p_name=>'UNLOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE08 \D574\C81C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104929378844309418)
,p_name=>'UNLOCKED_APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE08 \D574\C81C\B41C \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104926316240309416)
,p_name=>'UNLOCK_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE08 \D574\C81C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105186249769309611)
,p_name=>'UNRESTRICTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\D55C \C5C6\C74C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105141029205309578)
,p_name=>'UP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\B3D9 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105094184109309538)
,p_name=>'UPDATEABLE_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105674210444310007)
,p_name=>'UPDATED_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \C218\D589\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105124310317309562)
,p_name=>'UPDATED_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105526809463309883)
,p_name=>'UPDATE_APP_DISP_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BC84\C804\C5D0 \B300\D55C \C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105526991187309884)
,p_name=>'UPDATE_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\C804 \C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106026301606310296)
,p_name=>'UPGRADE_APP.UNSUPPORTED_DATE_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0\B418\B294 \B0A0\C9DC \D615\C2DD\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105697122308310027)
,p_name=>'UPGRADE_APPLICATION.INVALID_DATE_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0\B418\C9C0 \C54A\B294 \B0A0\C9DC \D615\C2DD\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106077475061310344)
,p_name=>'UPGRADE_CANDLESTICK_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\ADF8\B808\C774\B4DC \D6C4 \B808\C774\BE14 \C5F4 \ACC4\C5F4 \C18D\C131\C774 \B0A0\C9DC/\C2DC\AC04\AE30\B85D \C5F4\C5D0 \B9E4\D551\B418\B294\C9C0 \D655\C778\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105094212515309538)
,p_name=>'URL'
,p_message_language=>'ko'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105330796187309721)
,p_name=>'URL LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('URL \B9C1\D06C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105354352247309738)
,p_name=>'USERID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 ID')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105370646462309750)
,p_name=>'USERS_AND_MOST_RECENT_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AC\C6A9\C790, \C0DD\C131\B41C \AC00\C7A5 \CD5C\ADFC \C0AC\C6A9\C790 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105475532182309840)
,p_name=>'USER_INTERFACE.NO_GLOBAL_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C758\B41C \C804\C5ED \D398\C774\C9C0\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105365079447309746)
,p_name=>'USER_INTERFACE_ASSIGNEE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \D53C\C9C0\C815\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105364566662309746)
,p_name=>'USER_INTERFACE_IMPACT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \C601\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105366081364309747)
,p_name=>'USER_INTERFACE_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4 \C0C1\D0DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104983936262309458)
,p_name=>'USER_TYPE_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\C5D0\C11C\B294 Application Express \C791\C5C5\C601\C5ED \AD00\B9AC\C790, \C560\D50C\B9AC\CF00\C774\C158 \AC1C\BC1C\C790 \BC0F \C77C\BC18 \C0AC\C6A9\C790\C5D0 \B300\D55C \C561\C138\C2A4\B97C \C81C\C5B4\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C791\C5C5\C601\C5ED \AD00\B9AC\C790</strong>\B294 \C560\D50C\B9AC\CF00\C774\C158 \BC0F \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C0DD\C131 \BC0F \C218\C815\D558\ACE0, \C0AC\C6A9\C790 \ACC4\C815, \ADF8\B8F9 \BC0F \AC1C\BC1C \C11C\BE44\C2A4\B97C \AD00\B9AC\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\AC1C\BC1C\C790</strong>\B294 \C560\D50C\B9AC\CF00\C774\C158 \BC0F \B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4\B97C \C0DD\C131 \BC0F \C218\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C77C\BC18 \C0AC\C6A9\C790</strong>\B294 \AC1C\BC1C \AD8C\D55C\C774 \C5C6\C73C\BA70 \C678\BD80 \C778\C99D \CCB4\ACC4\B97C \C0AC\C6A9\D558\C9C0 \C54A\B294 \C560\D50C\B9AC\CF00\C774\C158\B9CC \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p><a target="_blank" href="%0/aeadm/managing-users-in-a-workspace.html">\C790\C138\D788...</a></p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105008155310309476)
,p_name=>'USER_TYPE_DESCRIPTION_CLOUD'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D398\C774\C9C0\C5D0\C11C Application Express \C77C\BC18 \C0AC\C6A9\C790\C5D0 \B300\D55C \C561\C138\C2A4\B97C \C81C\C5B4\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C77C\BC18 \C0AC\C6A9\C790</strong>\B294 \AC1C\BC1C \AD8C\D55C\C744 \AC00\C9C0\ACE0 \C788\C9C0 \C54A\C73C\BA70 \C678\BD80 \C778\C99D \CCB4\ACC4\B97C \C0AC\C6A9\D558\C9C0 \C54A\B294 \C560\D50C\B9AC\CF00\C774\C158\C5D0\B9CC \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C791\C5C5\C601\C5ED \AD00\B9AC\C790</strong> \BC0F <strong>\AC1C\BC1C\C790</strong>\B294 ID \CF58\C194\C744 \C0AC\C6A9\D558\C5EC \AD00\B9AC\B429\B2C8\B2E4. \C791\C5C5\C601\C5ED \AD00\B9AC\C790 \B610\B294 \AC1C\BC1C\C790\AC00 Application Express\C5D0 \B85C\ADF8\C778\D560 \B54C\B9C8\B2E4 "\C100\B3C4\C6B0" \ACC4\C815\C774 \C0DD\C131\B429\B2C8\B2E4. \C774\B7EC\D55C "\C100\B3C4\C6B0" \C0AC\C6A9\C790\B294 \C6D0\D560 \ACBD\C6B0 \C81C\AC70\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105095641862309539)
,p_name=>'USE_BUILTIN_LOGIN_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \B85C\ADF8\C778 \D398\C774\C9C0 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105095434554309539)
,p_name=>'USE_PAGE_AS_LOGIN_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D398\C774\C9C0\B97C \B85C\ADF8\C778 \D398\C774\C9C0\B85C \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105458429005309826)
,p_name=>'USING_CLEAR_CACHE_AND_PAGE_LINKS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\CE90\C2DC \BE44\C6B0\AE30</strong> \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \D398\C774\C9C0\C758 \CF64\B9C8\B85C \AD6C\BD84\B418\B294 \BAA9\B85D\C5D0 \B300\D55C \C138\C158 \C0C1\D0DC\B97C \C81C\AC70\D558\C2ED\C2DC\C624. \B2E4\C74C \CE90\C2DC \BE44\C6B0\AE30 \AD6C\BB38\B3C4 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'<ul>',
unistr('<li>RIR - \B300\D654\C2DD \BCF4\ACE0\C11C \C7AC\C124\C815</li>'),
unistr('<li>CIR - \B300\D654\C2DD \BCF4\ACE0\C11C \C9C0\C6B0\AE30</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105481410059309845)
,p_name=>'USING_EXISTING_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C2A4\D0A4\B9C8 \C0AC\C6A9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106103171666310368)
,p_name=>'UTR.BUTTONS.CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EB\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106103403690310368)
,p_name=>'UTR.BUTTONS.CODE_EDITOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF54\B4DC \D3B8\C9D1\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106103378531310368)
,p_name=>'UTR.BUTTONS.MAXIMIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300\D654')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106103256467310368)
,p_name=>'UTR.BUTTONS.MINIMIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C\D654')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106104577474310369)
,p_name=>'UTR.CHANGE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C\C744 \BCC0\ACBD\D558\BA74 \C800\C7A5\D558\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D\C774 \C7AC\C124\C815\B429\B2C8\B2E4. \C774 \C791\C5C5\C740 \C2E4\D589 \CDE8\C18C\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \ACC4\C18D\D558\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106131869076310394)
,p_name=>'UTR.CHANGE_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \BCC0\ACBD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106103060741310368)
,p_name=>'UTR.COMMON.BASE_STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0C0\C77C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106102815225310367)
,p_name=>'UTR.COMMON.CANCEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106102227414310367)
,p_name=>'UTR.COMMON.CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106131582196310394)
,p_name=>'UTR.COMMON.COPY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106102642611310367)
,p_name=>'UTR.COMMON.NO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106102714678310367)
,p_name=>'UTR.COMMON.OK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106131467756310394)
,p_name=>'UTR.COMMON.SET_CURRENT_WHEN_READ_ONLY_PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr(' \C77D\AE30 \C804\C6A9 \D14C\B9C8\B97C \BCC0\ACBD\D588\C2B5\B2C8\B2E4. \D604\C7AC \D14C\B9C8\B85C \C124\C815\D560 \ACBD\C6B0 \BCC0\ACBD\C0AC\D56D\C774 \C9C0\C6CC\C9D1\B2C8\B2E4. \ACC4\C18D\D558\ACA0\C2B5\B2C8\AE4C? ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106102926569310367)
,p_name=>'UTR.COMMON.STYLE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0C0\C77C \C774\B984')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106102333478310367)
,p_name=>'UTR.COMMON.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106131614894310394)
,p_name=>'UTR.COMMON.WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106102536214310367)
,p_name=>'UTR.COMMON.YES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106128187349310391)
,p_name=>'UTR.CONFIG_OUTPUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \CF54\B4DC \D589\C744 JS \CF58\C194\C5D0 \BD99\C5EC\B123\C5B4 \D604\C7AC \AD6C\C131\C744 \D14C\B9C8 \B864\B7EC\C5D0 \B85C\B4DC\D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106128278824310391)
,p_name=>'UTR.CONFIG_OUTPUT_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \B864\B7EC\AC00 \C5F4\B824 \C788\C5B4\C57C \D558\BA70 \AD6C\C131\C744 \CD9C\B825\D558\B824\BA74 \D604\C7AC \C2A4\D0C0\C77C\C774 \C801\D569\D574\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106016265981310286)
,p_name=>'UTR.CONTRAST_DIALOG.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\BE44 \BE44\C728:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106109690473310374)
,p_name=>'UTR.CONTRAST_VALIDATION.FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D328')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106112047124310376)
,p_name=>'UTR.CONTRAST_VALIDATION.LARGE_TEXT_NOTICE'
,p_message_language=>'ko'
,p_message_text=>unistr('18pt \C774\C0C1 \D14D\C2A4\D2B8 \B610\B294 14pt \C774\C0C1 \AD75\C740\CCB4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106109747567310374)
,p_name=>'UTR.CONTRAST_VALIDATION.MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D\C740 \C815\C0C1 \D06C\AE30 \AE00\AF34\C758 \C0C9\C0C1 \B300\BE44\C5D0 \B300\D55C WCAG(Web Content Accessibility Guidelines) 2.0 Guidelines\C5D0 \B530\B77C \C218\D589\B429\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106109544273310373)
,p_name=>'UTR.CONTRAST_VALIDATION.PASSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\ACFC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106109406515310373)
,p_name=>'UTR.CONTRAST_VALIDATION.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 \B300\BE44')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106131366521310394)
,p_name=>'UTR.CURRENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106104390710310369)
,p_name=>'UTR.CUSTOM_CSS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 CSS')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106104493215310369)
,p_name=>'UTR.CUSTOM_CSS.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CF54\B4DC\B294 \C2A4\D0C0\C77C\C2DC\D2B8\C758 \B05D\C5D0 \D3EC\D568\B429\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106113248071310377)
,p_name=>'UTR.CUSTOM_CSS.WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 CSS \CF54\B4DC\B294 \D14C\B9C8 \B864\B7EC \B300\D654\C0C1\C790\B97C \C228\AE41\B2C8\B2E4. \D398\C774\C9C0\C5D0 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105694033416310024)
,p_name=>'UTR.DOWNLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105694338789310024)
,p_name=>'UTR.DRAG_AND_DROP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C744 \B04C\C5B4 \B193\AC70\B098 \B20C\B7EC\C11C \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105694581034310025)
,p_name=>'UTR.ENABLE_LESS_COMPILATION'
,p_message_language=>'ko'
,p_message_text=>unistr('LESS \CEF4\D30C\C77C \C0AC\C6A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106102405667310367)
,p_name=>'UTR.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106104984339310369)
,p_name=>'UTR.ERROR.CREATE_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106112924224310377)
,p_name=>'UTR.ERROR.INPUT_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B098 \C774\C0C1\C758 CSS \D30C\C77C URL\C744 \B85C\B4DC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106104780015310369)
,p_name=>'UTR.ERROR.INVALID_STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D14C\B9C8 \C2A4\D0C0\C77C\C5D0 \B300\D55C LESS \CF54\B4DC\AC00 \BD80\C801\D569\D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106105159210310369)
,p_name=>'UTR.ERROR.LOAD_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C\C744 \B85C\B4DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30 \CC3D\C774 \C5F4\B824 \C788\B294\C9C0, \C138\C158\C774 \C801\D569\D55C\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106131766903310394)
,p_name=>'UTR.ERROR.SET_AS_CURRENT_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \D14C\B9C8\B294 \C560\D50C\B9AC\CF00\C774\C158\C758 \D604\C7AC \D14C\B9C8\B85C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106104653310310369)
,p_name=>'UTR.ERROR.UNSUPPORTED_STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D14C\B9C8 \C2A4\D0C0\C77C\C5D0\C11C\B294 \D14C\B9C8 \B864\B7EC \C0AC\C6A9\C790\C815\C758\AC00 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106104873886310369)
,p_name=>'UTR.ERROR.UNSUPPORTED_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D14C\B9C8\B294 \D14C\B9C8 \C2A4\D0C0\C77C\C774 \C5C6\C2B5\B2C8\B2E4. \D14C\B9C8 \B864\B7EC\B97C \C0AC\C6A9\D558\B824\BA74 \D14C\B9C8 \C2A4\D0C0\C77C\C774 \D3EC\D568\B41C \D14C\B9C8\B97C \C120\D0DD\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106105044836310369)
,p_name=>'UTR.ERROR.UPDATE_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106005256072310275)
,p_name=>'UTR.FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106112104017310376)
,p_name=>'UTR.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106112276336310376)
,p_name=>'UTR.HELP.P1'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \B864\B7EC\B97C \C0AC\C6A9\D558\BA74 \C0AC\C6A9\C790\AC00 \C0C9\C744 \C120\D0DD\D558\ACE0 \B2E4\C591\D55C \C560\D50C\B9AC\CF00\C774\C158 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \C2A4\D0C0\C77C\C744 \C124\C815\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C758 \C0AC\C6A9\C790 \C778\D130\D398\C774\C2A4\B97C \C190\C27D\AC8C \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158\C5D0\B294 \C2A4\D0C0\C77C \AC1C\C218\B97C \BB34\C81C\D55C\C73C\B85C \C815\C758\D560 \C218 \C788\C9C0\B9CC \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \C560\D50C\B9AC\CF00\C774\C158\C744 \D45C\C2DC\D558\B294 \B370\B294 ''\D604\C7AC'' \D14C\B9C8 \C2A4\D0C0\C77C\B9CC \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106112347874310376)
,p_name=>'UTR.HELP.P2'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\BCC0\ACBD\C744 \C218\D589\D55C \D6C4 [\C7AC\C124\C815] \B2E8\CD94\B97C \B204\B974\AC70\B098 \ADF8\B8F9\C5D0 \B300\D55C \C544\C774\CF58 \C7AC\C124\C815\C744 \B20C\B7EC \C804\CCB4 \D14C\B9C8 \C2A4\D0C0\C77C\C5D0 \B300\D55C \C18D\C131\C744 \C190\C27D\AC8C \BCF5\C6D0\D560 \C218 \C788\C2B5\B2C8\B2E4. '),
'',
unistr('\C804\ACBD\C0C9 \BC0F \BC30\ACBD\C0C9 \C120\D0DD\C744 \D5C8\C6A9\D558\B294 \C18D\C131\C758 \ACBD\C6B0 \B450 \AC00\C9C0 \C0C9\C0C1 \C120\D0DD \C55E\C5D0 \C788\B294 \CCB4\D06C\BC15\C2A4\B294 WCAG(Web Content Accessibility Guidelines) 2.0\C744 \AE30\BC18\C73C\B85C \D55C \C0C9\C0C1 \B300\BE44 \C815\BCF4\B97C \B098\D0C0\B0C5\B2C8\B2E4. \B354 \B192\AC8C \ACC4\C0B0\B41C \B300\BE44 \C810\C218\B294 \C774 \C0C9 \C870\D569\C5D0 \B354 \B9CE\C774 \C561\C138\C2A4\D560 \C218 \C788\C74C\C744 \B098\D0C0\B0C5\B2C8\B2E4.')))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105889146268310176)
,p_name=>'UTR.INLINE_EDITOR_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \D3B8\C9D1\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105413862219309782)
,p_name=>'UTR.LESS.ACCENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C13C\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106123940315310387)
,p_name=>'UTR.LESS.ACTIONS_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C5F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106127430166310390)
,p_name=>'UTR.LESS.ACTIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D65C\C131:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106128010698310391)
,p_name=>'UTR.LESS.ACTIVE_STATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D65C\C131 \C0C1\D0DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106125950159310389)
,p_name=>'UTR.LESS.BACKGROUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\ACBD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105413942192309782)
,p_name=>'UTR.LESS.BADGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\C9C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106123879696310387)
,p_name=>'UTR.LESS.BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106123771000310387)
,p_name=>'UTR.LESS.BODY_ACCENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38 \C561\C13C\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106128378411310391)
,p_name=>'UTR.LESS.BODY_CONTENT_MAX_WIDTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38 \CF58\D150\CE20 \CD5C\B300 \B108\BE44')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106124542168310387)
,p_name=>'UTR.LESS.BORDER_RADIUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B450\B9AC \BC18\C9C0\B984')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106122685331310386)
,p_name=>'UTR.LESS.BUTTONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106126116574310389)
,p_name=>'UTR.LESS.COLOR_1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106126991828310390)
,p_name=>'UTR.LESS.COLOR_10'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 10')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106095409116310361)
,p_name=>'UTR.LESS.COLOR_11'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 11')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106095562744310361)
,p_name=>'UTR.LESS.COLOR_12'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106095667477310361)
,p_name=>'UTR.LESS.COLOR_13'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 13')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106095720990310361)
,p_name=>'UTR.LESS.COLOR_14'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106095889296310361)
,p_name=>'UTR.LESS.COLOR_15'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 15')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106126299622310389)
,p_name=>'UTR.LESS.COLOR_2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106127029431310390)
,p_name=>'UTR.LESS.COLOR_3'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106126347961310389)
,p_name=>'UTR.LESS.COLOR_4'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106126457647310389)
,p_name=>'UTR.LESS.COLOR_5'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106126564551310389)
,p_name=>'UTR.LESS.COLOR_6'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106126690772310389)
,p_name=>'UTR.LESS.COLOR_7'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106126733943310389)
,p_name=>'UTR.LESS.COLOR_8'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106126824010310390)
,p_name=>'UTR.LESS.COLOR_9'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106122782731310386)
,p_name=>'UTR.LESS.CONTAINERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE8\D14C\C774\B108')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106127102989310390)
,p_name=>'UTR.LESS.CONTAINER_BORDER_RADIUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE8\D14C\C774\B108 \D14C\B450\B9AC \BC18\C9C0\B984')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106124930647310388)
,p_name=>'UTR.LESS.DANGER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\D5D8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106125363406310388)
,p_name=>'UTR.LESS.DISABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106124267810310387)
,p_name=>'UTR.LESS.FOCUS_OUTLINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\CEE4\C2A4 \C724\ACFD\C120')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106125764463310389)
,p_name=>'UTR.LESS.FOREGROUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\ACBD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106132593121310395)
,p_name=>'UTR.LESS.FORMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106122423387310385)
,p_name=>'UTR.LESS.GLOBAL_COLORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \C0C9\C0C1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106126094126310389)
,p_name=>'UTR.LESS.HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106123646145310387)
,p_name=>'UTR.LESS.HEADER_ACCENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \C561\C13C\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105416301482309790)
,p_name=>'UTR.LESS.HEADER_HEIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \B192\C774')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106124791821310388)
,p_name=>'UTR.LESS.HOT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106127743463310390)
,p_name=>'UTR.LESS.HOVER'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE4\C11C \AC00\C838\AC00\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106127821867310390)
,p_name=>'UTR.LESS.HOVER_STATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE4\C11C \AC00\C838\AC00\AE30 \C0C1\D0DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106127357156310390)
,p_name=>'UTR.LESS.ICON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106125457341310388)
,p_name=>'UTR.LESS.INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106123586102310386)
,p_name=>'UTR.LESS.INTERACTIVE_REPORTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106132603109310395)
,p_name=>'UTR.LESS.ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106132775689310395)
,p_name=>'UTR.LESS.LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106122829670310386)
,p_name=>'UTR.LESS.LAYOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\C544\C6C3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106124486821310387)
,p_name=>'UTR.LESS.LEFT_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD \C5F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106124135855310387)
,p_name=>'UTR.LESS.LINK_COLOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C0C9\C0C1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106125645183310388)
,p_name=>'UTR.LESS.MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\B274')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106118626362310382)
,p_name=>'UTR.LESS.MENUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\B274')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105460424850309828)
,p_name=>'UTR.LESS.MENU_ITEM_HOVER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\B274 \D56D\BAA9 \C704 \CEE4\C11C \C0C1\D0DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106122927881310386)
,p_name=>'UTR.LESS.NAVIGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106127227696310390)
,p_name=>'UTR.LESS.NAVIGATION_TREE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \D2B8\B9AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106124646976310387)
,p_name=>'UTR.LESS.NORMAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106127564778310390)
,p_name=>'UTR.LESS.NOT_ACTIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\D65C\C131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106123294423310386)
,p_name=>'UTR.LESS.PALETTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D314\B808\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106124801977310388)
,p_name=>'UTR.LESS.PRIMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105289746554309688)
,p_name=>'UTR.LESS.PRIMARY_ACCENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C561\C13C\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106122524493310386)
,p_name=>'UTR.LESS.REGIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106124301326310387)
,p_name=>'UTR.LESS.REGION_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106107550257310372)
,p_name=>'UTR.LESS.REPORTS_GRIDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \BC0F \ADF8\B9AC\B4DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106024796924310294)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_BACKGROUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38 \BC30\ACBD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106024647515310294)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38 \BA38\B9AC\AE00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106025460511310295)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \BAA8\B4DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106025641354310295)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.COMPACT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\B2E8\D788')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106025506692310295)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.STANDARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900(\AE30\BCF8\AC12)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106009180468310279)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\C544\C6C3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106012700010310282)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.CONTAINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\D568\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106012580478310282)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.EDGE_TO_EDGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C7A5\C790\B9AC-\AC00\C7A5\C790\B9AC(\AE30\BCF8\AC12)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106012620286310282)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.FLOATING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\B3D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106009093130310279)
,p_name=>'UTR.LESS.RW.CLASSES.MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106012379116310282)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B4\B450\C6C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106012470071310282)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B4\B450\C6C0 \BCF8\BB38')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106025896851310295)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B4\B450\C6C0(\AE30\BCF8\AC12)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106012202975310282)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1D\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106025918525310295)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT_DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1D\C74C(\AE30\BCF8\AC12)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106008997201310279)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\B7EC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106024462082310294)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.BEIGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCA0\C774\C9C0\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106024063712310293)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.LILAC'
,p_message_language=>'ko'
,p_message_text=>unistr('\B77C\C77C\B77D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106023484995310293)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.NEUTRAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\AC04(\AE30\BCF8\AC12)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106023965374310293)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.OCEAN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\C591')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106023576364310293)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PEBBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\AC08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106023749260310293)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\B098\BB34\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106024327430310294)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PLUM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B450\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106024160892310294)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.ROSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A5\BBF8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106024250118310294)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SIENNA'
,p_message_language=>'ko'
,p_message_text=>unistr('\D669\D1A0\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106023683837310293)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2AC\B808\C774\D2B8\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106023849351310293)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.TEAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAD\B85D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106024579263310294)
,p_name=>'UTR.LESS.RW.GROUP.APPEARANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106023393918310293)
,p_name=>'UTR.LESS.RW.GROUP.CLASSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\B4DC\C6B0\B4DC \C635\C158')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105205115759309625)
,p_name=>'UTR.LESS.SCALE_LEVEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C218\C810 \C774\D558 \C790\B9BF\C218')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105289841549309688)
,p_name=>'UTR.LESS.SECONDARY_ACCENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C870 \C561\C13C\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106127633593310390)
,p_name=>'UTR.LESS.SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B428')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106127999231310391)
,p_name=>'UTR.LESS.SELECTED_STATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \C0C1\D0DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106125272356310388)
,p_name=>'UTR.LESS.SIMPLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C21C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106123092488310386)
,p_name=>'UTR.LESS.STATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106125143779310388)
,p_name=>'UTR.LESS.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106125806361310389)
,p_name=>'UTR.LESS.TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106124033212310387)
,p_name=>'UTR.LESS.TITLE_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9 \D45C\C2DC\C904')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106125095161310388)
,p_name=>'UTR.LESS.WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106005328661310275)
,p_name=>'UTR.LOADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\B4DC \C911...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105007736831309475)
,p_name=>'UTR.LOGO.ALT_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4 \D14D\C2A4\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105657466500309992)
,p_name=>'UTR.LOGO.CUSTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105657351764309992)
,p_name=>'UTR.LOGO.CUSTOM.MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30\C5D0\C11C \B85C\ACE0 \B9C8\D06C\C5C5\C744 \D3B8\C9D1\D560 \C218 \C788\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105695045644310025)
,p_name=>'UTR.LOGO.ERROR_LOAD_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ACE0 \B370\C774\D130\B97C \B85C\B4DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30 \CC3D\C774 \C5F4\B824 \C788\B294\C9C0, \C138\C158\C774 \C801\D569\D55C\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105657200732309992)
,p_name=>'UTR.LOGO.IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105697209538310027)
,p_name=>'UTR.LOGO.IMAGE_DEFAULT_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\B4DC\B41C \C774\BBF8\C9C0\AC00 \C5C6\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105657180008309992)
,p_name=>'UTR.LOGO.IMAGE_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \BC0F \D14D\C2A4\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105694607434310025)
,p_name=>'UTR.LOGO.MAX_FILESIZE_IN_KB'
,p_message_language=>'ko'
,p_message_text=>unistr('%0KB\BCF4\B2E4 \C791\C740 \D30C\C77C\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105657009326309992)
,p_name=>'UTR.LOGO.NONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105694710015310025)
,p_name=>'UTR.LOGO.ONLY_IMAGE_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \D30C\C77C\B9CC \D5C8\C6A9\B429\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105693989557310024)
,p_name=>'UTR.LOGO.SAVE_LOGO'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ACE0 \C800\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105694883702310025)
,p_name=>'UTR.LOGO.SET_LOGO_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ACE0\B97C \C800\C7A5\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105694952196310025)
,p_name=>'UTR.LOGO.SET_LOGO_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ACE0\AC00 \C131\ACF5\C801\C73C\B85C \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105656949061309991)
,p_name=>'UTR.LOGO.TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105656719631309991)
,p_name=>'UTR.LOGO.TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105656652354309991)
,p_name=>'UTR.LOGO.UPLOAD_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C744 \B04C\C5B4 \B193\AC70\B098 \B20C\B7EC\C11C \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105887413371310174)
,p_name=>'UTR.LOGO_EDITOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ACE0 \D3B8\C9D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105694487865310024)
,p_name=>'UTR.ONLY_JSON_ALLOWED'
,p_message_language=>'ko'
,p_message_text=>unistr('JSON \D30C\C77C\B9CC \D5C8\C6A9\B429\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106120232376310383)
,p_name=>'UTR.PALETTE_GENERATOR.ADJACENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C811')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106120080642310383)
,p_name=>'UTR.PALETTE_GENERATOR.BASE_RGB'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 RGB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106132387030310395)
,p_name=>'UTR.PALETTE_GENERATOR.DUAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C911')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106120169935310383)
,p_name=>'UTR.PALETTE_GENERATOR.MONOCHROMATIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B178')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106120634307310384)
,p_name=>'UTR.PALETTE_GENERATOR.SEPARATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BD84')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106120484598310384)
,p_name=>'UTR.PALETTE_GENERATOR.TETRAD'
,p_message_language=>'ko'
,p_message_text=>unistr('4\C911')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106120372109310383)
,p_name=>'UTR.PALETTE_GENERATOR.TRIAD'
,p_message_language=>'ko'
,p_message_text=>unistr('3\C911')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106120566277310384)
,p_name=>'UTR.PALETTE_GENERATOR.WITH_COMPLEMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C870 \D3EC\D568')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105415787651309790)
,p_name=>'UTR.PENDING_LOGO_CHANGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9AC\B450 \BCC0\ACBD\C0AC\D56D\C744 \C800\C7A5\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105415876594309790)
,p_name=>'UTR.PENDING_THEME_CHANGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \BCC0\ACBD\C0AC\D56D\C744 \C800\C7A5\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106123425726310386)
,p_name=>'UTR.REDO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C2E4\D589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106104162871310369)
,p_name=>'UTR.RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106104211285310369)
,p_name=>'UTR.RESET.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS\B97C \C7AC\C124\C815\D558\ACA0\C2B5\B2C8\AE4C? \BAA8\B4E0 \BCC0\ACBD\C0AC\D56D\C774 \C190\C2E4\B429\B2C8\B2E4. \C774 \C791\C5C5\C740 \C2E4\D589 \CDE8\C18C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106131951546310394)
,p_name=>'UTR.RESET.STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0C0\C77C \C7AC\C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106103885276310368)
,p_name=>'UTR.SAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106103934905310368)
,p_name=>'UTR.SAVE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D14C\B9C8 \C2A4\D0C0\C77C\C758 \C774\B984\C744 \BC14\AFB8\B824\BA74 \C774\B984\C744 \C5C5\B370\C774\D2B8\D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106104090306310368)
,p_name=>'UTR.SAVE.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C\C774 \C131\ACF5\C801\C73C\B85C \C5C5\B370\C774\D2B8\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106103584190310368)
,p_name=>'UTR.SAVE_AS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \C774\B984\C73C\B85C \C800\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106103623589310368)
,p_name=>'UTR.SAVE_AS.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C\C6B4 \D14C\B9C8 \C2A4\D0C0\C77C \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106103753578310368)
,p_name=>'UTR.SAVE_AS.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C\C774 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106119901643310383)
,p_name=>'UTR.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105887548721310174)
,p_name=>'UTR.SELECT_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106131271747310394)
,p_name=>'UTR.SET_AS_CURRENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC\B85C \C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106132070841310394)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D14C\B9C8 \C2A4\D0C0\C77C\B85C \C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106132138819310395)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \D14C\B9C8\B294 \C9C0\AE08 \C560\D50C\B9AC\CF00\C774\C158\C758 \D604\C7AC \D14C\B9C8\C785\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106132284679310395)
,p_name=>'UTR.SET_AS_CURRENT_WHEN_READ_ONLY.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77D\AE30 \C804\C6A9 \D14C\B9C8\B97C \BCC0\ACBD\D588\C2B5\B2C8\B2E4. \C774 \D14C\B9C8\B97C \C560\D50C\B9AC\CF00\C774\C158\C758 "\D604\C7AC" \D14C\B9C8\B85C \C124\C815\D560 \ACBD\C6B0 \BCC0\ACBD\C0AC\D56D\C774 \C9C0\C6CC\C9D1\B2C8\B2E4. \ACC4\C18D\D558\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105656590105309991)
,p_name=>'UTR.TABS.LOGO'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ACE0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105656427019309991)
,p_name=>'UTR.TABS.THEME_STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106102122135310367)
,p_name=>'UTR.THEME_ROLLER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \B864\B7EC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106112851852310377)
,p_name=>'UTR.TOOLBAR.BUTTONS.ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \D45C\C2DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106112738149310376)
,p_name=>'UTR.TOOLBAR.BUTTONS.COMMON'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\D1B5 \D45C\C2DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106129049422310392)
,p_name=>'UTR.TOOLBAR.BUTTONS.PALETTE_GENERATOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 \D720')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106123396889310386)
,p_name=>'UTR.UNDO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \CDE8\C18C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105694153061310024)
,p_name=>'UTR.UPLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B85C\B4DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105694224691310024)
,p_name=>'UTR.UPLOAD_CONFIG_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131 \D30C\C77C \C5C5\B85C\B4DC')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105104066377309545)
,p_name=>'V.ALIAS_CONVERSION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1812 \C560\D50C\B9AC\CF00\C774\C158 \BCC4\CE6D(%0)\C744 \BCC0\D658\D558\B294 \C911 \C608\C0C1\CE58 \C54A\C740 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106093001004310358)
,p_name=>'VALIDATION_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104885261412309385)
,p_name=>'VIEW ALL PAGE GROUPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \D398\C774\C9C0 \ADF8\B8F9 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104885322442309385)
,p_name=>'VIEW ALL PAGE TYPES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \D398\C774\C9C0 \C720\D615 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105032836951309493)
,p_name=>'VIEWS2'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105633215332309970)
,p_name=>'VIEW_DEBUG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B514\BC84\ADF8 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104908292309309403)
,p_name=>'VIEW_DETAILS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105477461657309842)
,p_name=>'VIEW_FOR_ALT_TAG'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104903237143309399)
,p_name=>'VIEW_FOR_PRINTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4 \D654\BA74 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105661752976309996)
,p_name=>'VIEW_HISTORY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C5ED \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106052125509310320)
,p_name=>'VIEW_IN_BUILDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105091422469309536)
,p_name=>'VIEW_IN_PAREN'
,p_message_language=>'ko'
,p_message_text=>unistr('(\BDF0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106082846474310349)
,p_name=>'VIEW_LOCK_HISTORY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7A0\AE08 \B0B4\C5ED \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106013650516310283)
,p_name=>'VIEW_OUTPUT_OF_XML_DEMO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 SQL \C9C8\C758\B294 <strong>XML \BCF4\AE30</strong> \B2E8\CD94\B97C \B204\B978 \B2E4\C74C \D45C\C2DC\B418\B294 XML\C744 \C0DD\C131\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104885895347309385)
,p_name=>'VIEW_PAGES_OF_THIS_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \C720\D615\C758 \D398\C774\C9C0 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105656862295309991)
,p_name=>'VIEW_PAGE_HISTORY'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D398\C774\C9C0 \BCC0\ACBD \B0B4\C5ED \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104998040197309468)
,p_name=>'VIEW_USER_ACTIVITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C5D0 \B300\D55C \C791\C5C5 \BCF4\AE30: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105405622180309776)
,p_name=>'VPD'
,p_message_language=>'ko'
,p_message_text=>unistr('VPD(\AC00\C0C1 \C804\C6A9 \B370\C774\D130\BCA0\C774\C2A4)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105417658697309791)
,p_name=>'WAITING.APP_DEFINITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C124\CE58 \C911...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106098899042310364)
,p_name=>'WAITING.APP_REMOVAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C81C\AC70 \C911...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106099094424310364)
,p_name=>'WAITING.APP_UNLOCK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C7A0\AE08 \D574\C81C \C911...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106098985926310364)
,p_name=>'WAITING.APP_UPDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C5C5\B370\C774\D2B8 \C911...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105417758943309791)
,p_name=>'WAITING.GENERIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD \CC98\B9AC \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105417853921309791)
,p_name=>'WAITING.SUPPORTING_OBJECTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0 \AC1D\CCB4 \C124\CE58 \C911')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105527242593309884)
,p_name=>'WARNING_MISSING_CLASS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\CE58\D558\B294 \D074\B798\C2A4 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105527154370309884)
,p_name=>'WARNING_MULTIPLE_MATCHES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5EC\B7EC \C77C\CE58 \D56D\BAA9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104872508434309374)
,p_name=>'WEB.SOURCE.ADD_FROM_CATALOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\BE44\C2A4 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104873500700309375)
,p_name=>'WEB.SOURCE.SERVICE_FROM_CATALOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\D0C8\B85C\ADF8\C5D0\C11C \CD94\AC00\B420 \C608\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104873383230309375)
,p_name=>'WEB.SOURCE.UNADD_FROM_CATALOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\BE44\C2A4 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105339207449309727)
,p_name=>'WEBSHEET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105369842465309750)
,p_name=>'WEBSHEET ATTACHMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \CCA8\BD80 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106079203343310346)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP'
,p_message_language=>'ko'
,p_message_text=>'AnyCo IT Department'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106079147781310346)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP.DESCR'
,p_message_language=>'ko'
,p_message_text=>unistr('AnyCo IT Department\B294 \C5C5\BB34\C5D0 \C911\C694\D55C \B370\C774\D130\C5D0\C11C \C6F9 \AE30\BC18 \CF58\D150\CE20 \ACF5\C720 \BC0F \BCF4\ACE0\C5D0 \B300\D574 Websheets\C758 \AE30\B2A5\C744 \C0AC\C6A9\D558\B294 \BC29\BC95\C744 \BCF4\C5EC \C90D\B2C8\B2E4. \C774 \C0D8\D50C Websheet \C560\D50C\B9AC\CF00\C774\C158\C5D0\B294 \C5EC\B7EC \B370\C774\D130 \ADF8\B9AC\B4DC\AC00 \D3EC\D568\B418\C5B4 \C788\C73C\BA70, \D3EC\D568\B41C \BCF4\ACE0\C11C \BC0F \CC28\D2B8\C758 \B370\C774\D130\B97C \D3EC\D568\D558\B294 \BC29\BC95\C744 \BCF4\C5EC \C90D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106024929108310294)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP'
,p_message_language=>'ko'
,p_message_text=>'Big Cats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106025214021310295)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'ko'
,p_message_text=>unistr('Big Cats\B294 \D3EC\D568\B41C \C774\BBF8\C9C0 \BC0F \D398\C774\C9C0 \B9C1\D06C\B97C \D3EC\D568\D55C \C6F9 \C2DC\D2B8\C758 \C5EC\B7EC \AE30\B2A5\B4E4\C744 \BCF4\C5EC \C90D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104939399250309425)
,p_name=>'WEBSHEETS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105715709701310044)
,p_name=>'WEBSHEETS_FAQ_A1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C740 \D14D\C2A4\D2B8\C640 \B370\C774\D130\B97C \C870\D569\D558\B294 \C6F9 \D398\C774\C9C0\B85C \AD6C\C131\B429\B2C8\B2E4. \C774\B7EC\D55C \C560\D50C\B9AC\CF00\C774\C158\C740 \B9E4\C6B0 \B3D9\C801\C778 \D2B9\C131\C744 \C9C0\B2C8\BA70 \D574\B2F9 \C0AC\C6A9\C790\C5D0 \C758\D574 \C815\C758\B429\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158\C5D0\B294 \D0D0\C0C9 \CF58\D2B8\B864, \AC80\C0C9 \AE30\B2A5 \BC0F \D30C\C77C, \BA54\BAA8, \D0DC\ADF8\C640 \AC19\C740 \C8FC\C11D\C744 \CD94\AC00\D560 \C218 \C788\B294 \AE30\B2A5\C774 \D3EC\D568\B429\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158\C740 \C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D \BC0F \C77C\BD80 \B0B4\C7A5\B41C \C778\C99D \BAA8\B378\C744 \C0AC\C6A9\D558\C5EC \BCF4\D638\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105715825432310045)
,p_name=>'WEBSHEETS_FAQ_A2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0AC\C6A9\D558\BA74 \C81C\ACF5\C790 \ADF8\B8F9\C774 \C6F9 \BE0C\B77C\C6B0\C800\B9CC \C0AC\C6A9\D558\C5EC \BCF4\ACE0\C11C \BC0F \CC28\D2B8\B97C \D3EC\D568\D558\B294 \C815\BCF4 \D398\C774\C9C0\B97C \C2E0\C18D\D558\AC8C \C791\C131\D560 \C218 \C788\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\B294 \D14D\C2A4\D2B8 \BC0F \B85C\CEEC \B370\C774\D130(\B370\C774\D130 \ADF8\B9AC\B4DC)\B97C \C27D\AC8C \C720\C9C0 \AD00\B9AC\D560 \C218 \C788\C744 \BFD0\B9CC \C544\B2C8\B77C SQL \C9C8\C758\B85C \B370\C774\D130\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105715964334310045)
,p_name=>'WEBSHEETS_FAQ_A3'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C740 \C704\D0A4\C640 \AE30\B2A5\C774 \BE44\C2B7\D558\C9C0\B9CC \B370\C774\D130 \D1B5\D569 \BC0F \D45C\C2DC\C5D0 \B9DE\AC8C \CD5C\C801\D654\B418\C5B4 \C788\C2B5\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \D45C \D615\C2DD \C815\BCF4\B97C \C800\C7A5\D558\B3C4\B85D \B370\C774\D130 \ADF8\B9AC\B4DC\B97C \C815\C758\D558\AC70\B098, \AE30\C874 \D14C\C774\BE14\C5D0 \B300\D574 \BCF4\ACE0\C11C\B97C \C815\C758\D558\AC70\B098, \B2E8\C21C\D788 SQL \D0DC\ADF8\B97C \C0AC\C6A9\D558\C5EC \D398\C774\C9C0 \B0B4\C5D0 \B370\C774\D130\BCA0\C774\C2A4 \B370\C774\D130\B97C \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105716054691310045)
,p_name=>'WEBSHEETS_FAQ_A4'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \ADF8\B9AC\B4DC\B294 \C2A4\D504\B808\B4DC\C2DC\D2B8\C640 \BE44\C2B7\D55C \C6F9 \C2DC\D2B8 \AD6C\C131\C694\C18C\B85C\C11C \D45C \D615\C2DD \C815\BCF4\B97C \C27D\AC8C \C720\C9C0 \AD00\B9AC\D560 \C218 \C788\AC8C \D574\C90D\B2C8\B2E4. \C911\C694\D55C \CC28\C774\C810\C740 \D30C\C77C\C5D0 \B85C\CEEC\B85C \C800\C7A5\B418\B294 \B300\C2E0 \BAA8\B4E0 \C6F9 \C2DC\D2B8 \B370\C774\D130\AC00 Oracle \B370\C774\D130\BCA0\C774\C2A4 \B0B4\C5D0 \C911\C559\C73C\B85C \C800\C7A5\B41C\B2E4\B294 \C810\C785\B2C8\B2E4. \B370\C774\D130 \ADF8\B9AC\B4DC\B97C \C0AC\C6A9\D558\BA74 \D30C\C77C, \BA54\BAA8, \D0DC\ADF8 \BC0F \B9C1\D06C\B97C \D3EC\D568\D558\C5EC \AC01 \B370\C774\D130 \D589\C5D0 \C8FC\C11D\C744 \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4. \B610\D55C \C560\D50C\B9AC\CF00\C774\C158 \AC80\C0C9\C744 \C0AC\C6A9\D558\C5EC \BAA8\B4E0 \B370\C774\D130\B97C \AC80\C0C9\D560 \C218 \C788\B2E4\B294 \C774\C810\B3C4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105716400479310045)
,p_name=>'WEBSHEETS_FAQ_A5'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL \D0DC\ADF8\B97C \C0AC\C6A9\D558\BA74 \C0AC\C6A9\C790\AC00 \B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14\C5D0 \B300\D574 \C791\C131\B41C SQL \BB38\C744 \AE30\BC18\C73C\B85C \BCF4\ACE0\C11C\B97C \D398\C774\C9C0\C5D0 \C27D\AC8C \D3EC\D568\C2DC\D0AC \C218 \C788\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\B294 SQL\C744 \C0AC\C6A9\D558\C5EC \C6D0\D558\B294 \D14C\C774\BE14\C5D0\C11C \B370\C774\D130\B97C \C27D\AC8C \C9C1\C811 \AC80\C0C9\D560 \C218 \C788\C2B5\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \B9CC\AE30\B41C \BBF8\ACB0 \BC84\ADF8\B97C \BAA8\B450 \BCF4\B824\BA74 \B2E4\C74C \D0DC\ADF8\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624. '),
'<pre>[[SQL: select * from bugs where due_date < sysdate and status = ''OPEN'']] </pre>',
unistr('\C774 \C9C8\C758\B294 \D398\C774\C9C0\AC00 \D45C\C2DC\B420 \B54C\B9C8\B2E4 \C2E4\D589\B418\C5B4 \C77C\BC18\C801\C778 \C2DC\C810 \C2A4\B0C5\C0F7\BCF4\B2E4 \B3D9\C801\C778 \B370\C774\D130\B97C \C81C\ACF5\D569\B2C8\B2E4.  ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105716172662310045)
,p_name=>'WEBSHEETS_FAQ_A6'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0AC\C6A9\D558\BA74 \CF58\D150\CE20\B97C \BCF4\B2E4 \C27D\AC8C \ACF5\C720\D558\ACE0 \BE44\ACF5\C2DD\C801\C778 \AE30\BCF8 \BCF4\ACE0 \AE30\B2A5\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C758 \BAA8\B4E0 \AD6C\C870 \BC0F \CF58\D150\CE20\B294 \C0AC\C6A9\C790(\C989, \C81C\ACF5\C790 \BC0F \AD00\B9AC\C790)\C5D0 \C758\D574 \C81C\C5B4\B429\B2C8\B2E4. \BC18\BA74\C5D0 \B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158\C740 \BCF4\B2E4 \ACF5\C2DD\C801\C774\ACE0, \BCF5\C7A1\D558\BA70, \C804\BB38\C801\C778 \B370\C774\D130 \C720\C9C0 \AD00\B9AC \BC0F \BCF4\ACE0 \BAA9\C801\C5D0 \C0AC\C6A9\B429\B2C8\B2E4. \B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158\C758 \AD6C\C870\B294 \AC1C\BC1C\C790\C5D0 \C758\D574 \C81C\C5B4\B418\C9C0\B9CC \CF58\D150\CE20\B294 \C77C\BC18\C801\C73C\B85C \C77C\BC18 \C0AC\C6A9\C790\C5D0 \C758\D574 \C81C\C5B4\B429\B2C8\B2E4.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105715224845310044)
,p_name=>'WEBSHEETS_FAQ_Q1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8\B780?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105715402317310044)
,p_name=>'WEBSHEETS_FAQ_Q2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D574\C57C \D558\B294 \C774\C720\B294 \BB34\C5C7\C785\B2C8\AE4C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105715559151310044)
,p_name=>'WEBSHEETS_FAQ_Q3'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C740 \C704\D0A4\C640 \C5B4\B5BB\AC8C \B2E4\B985\B2C8\AE4C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105715661925310044)
,p_name=>'WEBSHEETS_FAQ_Q4'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C740 \C628\B77C\C778 \C2A4\D504\B808\B4DC\C2DC\D2B8\C785\B2C8\AE4C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105716593603310045)
,p_name=>'WEBSHEETS_FAQ_Q5'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D0DC\ADF8\B780?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105715389491310044)
,p_name=>'WEBSHEETS_FAQ_Q6'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C740 \B370\C774\D130\BCA0\C774\C2A4 \C560\D50C\B9AC\CF00\C774\C158\ACFC \C5B4\B5BB\AC8C \B2E4\B985\B2C8\AE4C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104998145358309468)
,p_name=>'WEBSHEETS_NOT_INSTALLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\AC00 \C124\CE58\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106100965055310366)
,p_name=>'WEBSHEET_ACCESS_CONTROL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C561\C138\C2A4 \C81C\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106079955488310346)
,p_name=>'WEBSHEET_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104923992039309414)
,p_name=>'WEBSHEET_APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105667365225310001)
,p_name=>'WEBSHEET_APPLICATION_NOT_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C740 \D604\C7AC \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105370989183309751)
,p_name=>'WEBSHEET_ATTACHMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \CCA8\BD80 \D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105661867800309996)
,p_name=>'WEBSHEET_CONTENT_LAST_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20\AC00 %0\C5D0 %1\C5D0 \C758\D574 \B9C8\C9C0\B9C9\C73C\B85C \C5C5\B370\C774\D2B8\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105661940618309996)
,p_name=>'WEBSHEET_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\AC00 %0\C5D0 %1\C5D0 \C758\D574 \C0DD\C131\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106025390783310295)
,p_name=>'WEBSHEET_INSTALLATION_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0D8\D50C \C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158\C744 \C124\CE58\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106093822151310359)
,p_name=>'WEBSHEET_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105654266396309989)
,p_name=>'WEBSHEET_LAST_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\AC00 %0\C5D0 %1\C5D0 \C758\D574 \B9C8\C9C0\B9C9\C73C\B85C \C5C5\B370\C774\D2B8\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105369797406309750)
,p_name=>'WEBSHEET_NON_BLOB_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \BE44 BLOB \B370\C774\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106064943122310332)
,p_name=>'WEBSHEET_OBJECTS_NOT_VALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \AC1D\CCB4\AC00 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105414591611309789)
,p_name=>'WEBSHEET_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158 %0\C774(\AC00) \C124\CE58\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105678845542310011)
,p_name=>'WEBSHEET_TABLE_ACCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \AC1D\CCB4\B294 SQL \B9C8\D06C\C5C5 \D0DC\ADF8\B97C \C0AC\C6A9\D558\C5EC \C9C8\C758\D558\AC70\B098, \BCF4\ACE0\C11C \B0B4\C5D0\C11C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\B294 \AC1D\CCB4 \C774\B984\C744 \C2DD\BCC4\D558\B294 \B370 \D070 \B530\C634\D45C\AC00 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105368251025309749)
,p_name=>'WEBSHEET_VIEWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \D398\C774\C9C0 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105399163256309771)
,p_name=>'WEB_SERVICE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105093682075309537)
,p_name=>'WEB_SERVICE_RESULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \ACB0\ACFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104859074522309362)
,p_name=>'WEB_SOURCE.NATIVE_ADFBC'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Cloud Applications(SaaS) REST \C11C\BE44\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104858844282309362)
,p_name=>'WEB_SOURCE.NATIVE_HTTP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C21C HTTP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104859117495309362)
,p_name=>'WEB_SOURCE.NATIVE_OCI'
,p_message_language=>'ko'
,p_message_text=>'OCI(Oracle Cloud Infrastructure)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104858967095309362)
,p_name=>'WEB_SOURCE.NATIVE_ORDS'
,p_message_language=>'ko'
,p_message_text=>'Oracle REST Data Services'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104919140445309411)
,p_name=>'WELCOME_TEXT_4700_P1'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle APEX \C791\C5C5\C601\C5ED\C744 \C694\CCAD\D558\B824\BA74 \C774 \B4F1\B85D \B9C8\BC95\C0AC\B97C \C644\B8CC\D558\C2ED\C2DC\C624.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105410657972309780)
,p_name=>'WHITE_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D770\C0C9 \D14D\C2A4\D2B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104951719840309434)
,p_name=>'WITHIN_NEXT_1_DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C 1\C77C \C774\B0B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106018668477310288)
,p_name=>'WITHIN_NEXT_X_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C %0\C77C \C774\B0B4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105370712655309751)
,p_name=>'WITH_ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790 \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105094028887309538)
,p_name=>'WITH_SHORTCUTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4 \C0AC\C6A9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105476485212309841)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638\AC00 \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C874\C7AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105475866365309840)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.RESERVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638\AC00 \C608\C57D\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105127163386309568)
,p_name=>'WIZAPI_DELETE_CHECKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \D56D\BAA9 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105004152385309473)
,p_name=>'WIZARD.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\C11D \CC98\B9AC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104861691062309364)
,p_name=>'WIZARD.CLEAR_CACHE_PROCESS_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C7AC\C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105899427174310184)
,p_name=>'WIZARD.CREATE.FS.CARD_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104875079568309376)
,p_name=>'WIZARD.CREATE.PAGE.CARDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105702585851310034)
,p_name=>'WIZARD.CREATE.PAGE.CLASSIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B798\C2DD \BCF4\ACE0\C11C \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105667780092310001)
,p_name=>'WIZARD.CREATE.PAGE.FACETED_SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105703013979310035)
,p_name=>'WIZARD.CREATE.PAGE.FORMNLISTVIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \BC0F \BAA9\B85D \BCF4\AE30 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105703413008310035)
,p_name=>'WIZARD.CREATE.PAGE.FORMONPROCEDURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C2DC\C800 \D3FC \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105703367428310035)
,p_name=>'WIZARD.CREATE.PAGE.FORMONSQL'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758 \D3FC \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105703299008310035)
,p_name=>'WIZARD.CREATE.PAGE.FORMONTABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106077576091310344)
,p_name=>'WIZARD.CREATE.PAGE.FORMONWEBSERVICE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \D3FC \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104881984894309382)
,p_name=>'WIZARD.CREATE.PAGE.FS.FACET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105702470616310034)
,p_name=>'WIZARD.CREATE.PAGE.GRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105702339202310034)
,p_name=>'WIZARD.CREATE.PAGE.INTERACTIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104873276706309375)
,p_name=>'WIZARD.CREATE.PAGE.MAP_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5 \D398\C774\C9C0 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105702696647310035)
,p_name=>'WIZARD.CREATE.PAGE.MD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \B514\D14C\C77C \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105702801280310035)
,p_name=>'WIZARD.CREATE.PAGE.REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105702914504310035)
,p_name=>'WIZARD.CREATE.PAGE.REPORTWFORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC\C774 \C788\B294 \BCF4\ACE0\C11C \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104880899592309381)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\B9C8\D2B8 \D544\D130 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104882020434309382)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS.FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105703127936310035)
,p_name=>'WIZARD.CREATE.PAGE.TABULARFORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C \D615\C2DD \D3FC \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105702767581310035)
,p_name=>'WIZARD.CREATE.PAGE.WEBSERVICE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \BCF4\ACE0\C11C \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105047199357309504)
,p_name=>'WIZARD.CREATE_PAGE.UT.REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B9C8\BC95\C0AC\B97C \C0AC\C6A9\D558\B824\BA74 \BC94\C6A9 \D14C\B9C8 \AE30\BC18 \C560\D50C\B9AC\CF00\C774\C158\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104861150643309364)
,p_name=>'WIZARD.FORM.DML_PROCESS_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D3FC \CC98\B9AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104861046215309363)
,p_name=>'WIZARD.FORM.INIT_PROCESS_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D3FC \CD08\AE30\D654')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105457933048309826)
,p_name=>'WIZARD.FORM.QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105457839869309826)
,p_name=>'WIZARD.FORM.TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105471699601309837)
,p_name=>'WIZARD.IG.DML_PROCESS_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 - \B300\D654\C2DD \ADF8\B9AC\B4DC \B370\C774\D130 \C800\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105464416119309831)
,p_name=>'WIZARD.REPORT.CLASSIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B798\C2DD \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105464315688309831)
,p_name=>'WIZARD.REPORT.GRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105464281640309831)
,p_name=>'WIZARD.REPORT.INTERACTIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105464676074309831)
,p_name=>'WIZARD.REPORT.REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105464598521309831)
,p_name=>'WIZARD.REPORT.WEBSERVICE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105067655752309519)
,p_name=>'WIZARD.VALIDATION.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL# \AC12\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105388399378309764)
,p_name=>'WIZARD.VALIDATION.PAGE_LEVEL_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105388249607309764)
,p_name=>'WIZARD.VALIDATION.TABFORM_COLUMN_IS_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('#COLUMN_HEADER# \AC12\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105421786219309795)
,p_name=>'WIZARD_PAGES_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\BC95\C0AC \D398\C774\C9C0\AC00 \C131\ACF5\C801\C73C\B85C \C791\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106128590751310391)
,p_name=>'WIZARD_PROGRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\BC95\C0AC \C9C4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105407007823309777)
,p_name=>'WIZARD_REPORT_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\BC95\C0AC \BCF4\ACE0\C11C \D398\C774\C9C0\AC00 \C131\ACF5\C801\C73C\B85C \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105095791824309539)
,p_name=>'WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105395622727309769)
,p_name=>'WORKSPACE IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105458181343309826)
,p_name=>'WORKSPACES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105367017501309748)
,p_name=>'WORKSPACE_APPLICATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C560\D50C\B9AC\CF00\C774\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105367318198309748)
,p_name=>'WORKSPACE_APPLICATION_ACTIVITY_SUMMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C560\D50C\B9AC\CF00\C774\C158 \C791\C5C5 \C694\C57D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106009878052310280)
,p_name=>'WORKSPACE_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C791\C5C5\C601\C5ED \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105366336526309747)
,p_name=>'WORKSPACE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105678490439310011)
,p_name=>'WORKSPACE_IMAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C774\BBF8\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105458662289309827)
,p_name=>'WORKSPACE_INITCAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105277060312309679)
,p_name=>'WORKSPACE_INIT_CAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104936040607309423)
,p_name=>'WORKSPACE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104905161100309401)
,p_name=>'WORKSPACE_LOGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \B85C\ADF8\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105603746677309945)
,p_name=>'WORKSPACE_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105366136765309747)
,p_name=>'WORKSPACE_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105515099726309873)
,p_name=>'WORKSPACE_OVERRIDE_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \BB34\D6A8\D654 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105398573973309771)
,p_name=>'WORKSPACE_REQUEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105366906691309748)
,p_name=>'WORKSPACE_SCHEMAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C2A4\D0A4\B9C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104955128754309437)
,p_name=>'WORKSPACE_SIGNUP_SUCCESS_01'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C694\CCAD\C774 \C2B9\C778\B418\BA74 \C791\C5C5\C601\C5ED\C744 \D65C\C131\D654\D558\AE30 \C704\D55C \C804\C790\BA54\C77C\C774 \C218\C2E0\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105458355927309826)
,p_name=>'WORKSPACE_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105370848411309751)
,p_name=>'WORKSPACE_WEBSHEETS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED \C6F9 \C2DC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105366677515309748)
,p_name=>'WORKSPACE_WORKSPACE_SUMMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C791\C5C5\C601\C5ED \C694\C57D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105342660619309730)
,p_name=>'WORK_INITIATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C2DC\C791\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105342718617309730)
,p_name=>'WORK_PROGRESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \C9C4\D589 \C911')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105350780939309736)
,p_name=>'WRITING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C4F0\B294 \C911')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106014002166310284)
,p_name=>'WS.CAPABILITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106013967072310284)
,p_name=>'WS.READER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\D68C\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105406499253309777)
,p_name=>'WSDL_SUCCESS_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C11C\BE44\C2A4 \CC38\C870\AC00 %0 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104895519850309393)
,p_name=>'WS_ACCESS_CONTROL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4 \C81C\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105639523439309976)
,p_name=>'WS_ADD_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106077713146310344)
,p_name=>'WS_ADD_FILE_NOT_ENOUGH_SPACE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C744 \CD94\AC00\D558\AE30 \C704\D55C \ACF5\AC04\C774 \BD80\C871\D569\B2C8\B2E4. \AD00\B9AC \D398\C774\C9C0\B85C \C774\B3D9\D558\C5EC \CD94\AC00 \C800\C7A5 \C601\C5ED\C744 \C694\CCAD\D558\ACE0, \AD00\B9AC \C11C\BE44\C2A4\B85C \C774\B3D9\D558\ACE0, \C800\C7A5 \C601\C5ED \C694\CCAD\C744 \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105662907440309997)
,p_name=>'WS_ADD_LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105697842127310027)
,p_name=>'WS_ADD_NEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \D56D\BAA9 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105663093554309997)
,p_name=>'WS_ADD_NOTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\ACE0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105662490735309996)
,p_name=>'WS_ADD_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105662894981309997)
,p_name=>'WS_ADD_TAGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0DC\ADF8 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105707082745310038)
,p_name=>'WS_ADD_VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104895315491309393)
,p_name=>'WS_ADMINISTRATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105639126853309975)
,p_name=>'WS_ALIAS_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104887898642309387)
,p_name=>'WS_ALIAS_NOT_VALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D\C740 \C601\C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104899077510309396)
,p_name=>'WS_ALIAS_TOO_LONG'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D\C774 \B108\BB34 \AE41\B2C8\B2E4. \C81C\D55C\C740 255\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105704057856310036)
,p_name=>'WS_ALL_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105697951314310027)
,p_name=>'WS_ANNOTATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\C11D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104895489540309393)
,p_name=>'WS_APPLICATION_PROPERTIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105712597872310042)
,p_name=>'WS_CANNOT_USE_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \D45C\C2DC \C720\D615\C5D0\C11C \AC12 \BAA9\B85D\C744 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105714982290310044)
,p_name=>'WS_CHANGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105699384005310029)
,p_name=>'WS_CHANGE_COLUMN_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C720\D615 \BCC0\ACBD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105715127179310044)
,p_name=>'WS_CHG_WS_RPT_QRY_HLP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C9C8\C758\B97C \BCC0\ACBD\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C9C8\C758\C5D0 \C5F4\C744 \CD94\AC00\D55C \ACBD\C6B0 \D574\B2F9 \C5F4\C740 \BCF4\ACE0\C11C \C2E4\D589 \C2DC \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \C791\C5C5 \BA54\B274\B97C \C0AC\C6A9\D558\C5EC \C5F4\C744 \C120\D0DD\D558\AC70\B098 <strong>\C7AC\C124\C815</strong>\C744 \B20C\B7EC\C57C \D569\B2C8\B2E4. \C9C8\C758\C5D0\C11C \C5F4\C744 \C81C\AC70\D55C \ACBD\C6B0 \D574\B2F9 \C5F4\C744 \CC38\C870\D558\B294 \AE30\C874 \D544\D130, \AC15\C870 \D45C\C2DC \ADDC\CE59 \BC0F \AE30\D0C0 \BCF4\ACE0\C11C \C124\C815\C774 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B429\B2C8\B2E4. \C694\CCAD \B0B4\C6A9\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104892926070309391)
,p_name=>'WS_CHOOSE_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105699859289310029)
,p_name=>'WS_COLUMN_ALIGNMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105662769156309997)
,p_name=>'WS_COLUMN_GROUPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106074322750310341)
,p_name=>'WS_COLUMN_NAME_NOT_UNIQUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984\C774 \C874\C7AC\D569\B2C8\B2E4. \B2E4\B978 \C774\B984\C744 \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105662687519309996)
,p_name=>'WS_COLUMN_PROPERTIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105700815260310033)
,p_name=>'WS_COL_CONFIRM_DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C0AD\C81C \C791\C5C5 \C218\D589 \D655\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105712309128310042)
,p_name=>'WS_COL_LABEL_MUST_BE_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \B808\C774\BE14\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105713618379310043)
,p_name=>'WS_COL_MUST_BE_SEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C744 \BCC0\ACBD\D560 \C5F4\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105713843476310043)
,p_name=>'WS_COL_MUST_BE_SEL_REP'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C744 \BC14\AFC0 \C5F4\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105712991168310042)
,p_name=>'WS_COL_NAME_MUST_BE_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105712299599310042)
,p_name=>'WS_COL_SEL_TO_EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1\D560 \C5F4\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105713082393310042)
,p_name=>'WS_COL_SEL_TO_REMOVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\AC70\D560 \C5F4\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105698832442310028)
,p_name=>'WS_COMMA_SEP_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105700540133310033)
,p_name=>'WS_COMMA_SEP_LIST2'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105711938700310042)
,p_name=>'WS_CONF_DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C\D560\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106087766469310354)
,p_name=>'WS_CONTROL_PANEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4\D310')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106010882375310280)
,p_name=>'WS_COPY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105625468596309963)
,p_name=>'WS_COPY_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC\BCF8\C73C\B85C \C0C8 \D398\C774\C9C0 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105648533447309984)
,p_name=>'WS_CREATE_APP_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \C6F9 \C2DC\D2B8\B97C \C0DD\C131\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C120\D0DD\C0AC\D56D\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105624851254309963)
,p_name=>'WS_CREATE_CHART_SECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C139\C158 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105403894389309775)
,p_name=>'WS_CREATE_DATA_GRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \ADF8\B9AC\B4DC \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105624940027309963)
,p_name=>'WS_CREATE_DATA_SECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C139\C158 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105699094232310028)
,p_name=>'WS_CREATE_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105625182699309963)
,p_name=>'WS_CREATE_NAV_SECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \C139\C158 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105625390422309963)
,p_name=>'WS_CREATE_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104929038565309418)
,p_name=>'WS_CREATE_PLSQL_SECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \C139\C158 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105624776288309963)
,p_name=>'WS_CREATE_SECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C139\C158 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105625032161309963)
,p_name=>'WS_CREATE_TEXT_SECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \C139\C158 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105699119250310028)
,p_name=>'WS_CURRENT_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104895187096309393)
,p_name=>'WS_DASHBOARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C2DC\BCF4\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104872488806309374)
,p_name=>'WS_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105384919739309761)
,p_name=>'WS_DATA_GRID_COLUMN_LIMIT_REACHED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C720\D615\C5D0 \B300\D574 \C0AC\C6A9\D560 \C218 \C788\B294 \CD5C\B300 \C5F4 \C218\C5D0 \B3C4\B2EC\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106074529442310341)
,p_name=>'WS_DATA_GRID_DUP_COL_NAME_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\BCF5\B41C \C5F4 \C774\B984\C774 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4. \C5F4 \C774\B984\C740 \ACE0\C720\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106039976742310309)
,p_name=>'WS_DATA_GRID_NAME_NOT_UNIQUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \ADF8\B9AC\B4DC \C774\B984\C774 \C874\C7AC\D569\B2C8\B2E4. \B2E4\B978 \C774\B984\C744 \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105699249271310029)
,p_name=>'WS_DEFAULT_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D14D\C2A4\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105698927483310028)
,p_name=>'WS_DEFAULT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106101435600310366)
,p_name=>'WS_DEFINE_DATA_GRID_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \ADF8\B9AC\B4DC \C5F4 \C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105700698072310033)
,p_name=>'WS_DELETE_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105634512731309971)
,p_name=>'WS_DELETE_DATA_GRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \ADF8\B9AC\B4DC \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105705025481310036)
,p_name=>'WS_DELETE_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C0AD\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105700703848310033)
,p_name=>'WS_DEL_COL_DIALOG_HLP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\C640 \D568\AED8 \C601\AD6C\C801\C73C\B85C \C81C\AC70\D560 \C5F4\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104918075237309410)
,p_name=>'WS_DGQ_FIRST_COL_MUST_BE_PK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \CD94\AC00 \B610\B294 \D3B8\C9D1 \B9C1\D06C\B97C \D45C\C2DC\D558\B824\BA74 \CCAB\BC88\C9F8 \C5F4\C774 \B370\C774\D130 \ADF8\B9AC\B4DC\C758 \AE30\BCF8 \D0A4\C5EC\C57C \D569\B2C8\B2E4. \AE30\BCF8 \D0A4\B97C \D3EC\D568\C2DC\D0A4\B824\BA74 "APXWS_DATA_GRID_PK" \B300\CCB4 \BB38\C790\C5F4\C744 SELECT \BB38\C758 \CCAB\BC88\C9F8 \C5F4\B85C \CD94\AC00\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104911331546309405)
,p_name=>'WS_DGQ_MORE_THAN_ONE_DATA_GRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \CD94\AC00 \B610\B294 \D3B8\C9D1 \B9C1\D06C\B97C \D45C\C2DC\D558\B824\BA74 \C9C8\C758\AC00 \B370\C774\D130 \ADF8\B9AC\B4DC\B97C \D55C \BC88\B9CC \CC38\C870\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104918136079309410)
,p_name=>'WS_DGQ_MULTI_SELECT_STMT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\C5D0 SELECT \BB38\C774 \C5EC\B7EC \AC1C \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4. \D589 \CD94\AC00 \B610\B294 \D3B8\C9D1 \B9C1\D06C\B97C \D45C\C2DC\D558\B824\BA74 "APXWS_DATA_GRID_PK" \B300\CCB4 \BB38\C790\C5F4\C744 SELECT \BB38\C758 \CCAB\BC88\C9F8 \C5F4\B85C \CD94\AC00\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105716650621310045)
,p_name=>'WS_DGQ_SQLVALUE_EXAMPLE'
,p_message_language=>'ko'
,p_message_text=>unistr('SQLVALUE \D0DC\ADF8 \AD6C\BB38:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105463711916309831)
,p_name=>'WS_DGQ_SQL_EXAMPLE'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \D0DC\ADF8 \AD6C\BB38:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105698498499310028)
,p_name=>'WS_DISPLAY_AS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105698343598310028)
,p_name=>'WS_DOCUMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105639093072309975)
,p_name=>'WS_DUPLICATE_PK_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4\B85C \B3D9\C77C\D55C \C5F4\C744 \C120\D0DD\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105697695938310027)
,p_name=>'WS_EDIT_ATTACHMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \D30C\C77C \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106010917369310280)
,p_name=>'WS_EDIT_ATTRIBUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104894278366309392)
,p_name=>'WS_EDIT_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104893843822309392)
,p_name=>'WS_EDIT_NOTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\BAA8 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105625298651309963)
,p_name=>'WS_EDIT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106011030778310281)
,p_name=>'WS_EDIT_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105632489258309969)
,p_name=>'WS_EDIT_SECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C139\C158 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105695865997310026)
,p_name=>'WS_EDIT_SECTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C139\C158 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104894355694309392)
,p_name=>'WS_EDIT_TAG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0DC\ADF8 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104958112126309439)
,p_name=>'WS_EDIT_TAGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0DC\ADF8 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104934390821309422)
,p_name=>'WS_EMAIL_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C\B85C \D398\C774\C9C0 \BCF4\B0B4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105701264124310034)
,p_name=>'WS_EMPTY_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE48 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105633014205309970)
,p_name=>'WS_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105710666288310041)
,p_name=>'WS_ERR_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105714354893310043)
,p_name=>'WS_ERR_MSG_MUST_BE_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \BA54\C2DC\C9C0\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105664877522309998)
,p_name=>'WS_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105640663900309977)
,p_name=>'WS_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106123128638310386)
,p_name=>'WS_FILE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C5D0 \AC12\C774 \C788\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105704646795310036)
,p_name=>'WS_FILL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC44\C6B0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105704752437310036)
,p_name=>'WS_FILL_HLP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C140 \C704\C5D0\C11C \C5F4 \AC12\C73C\B85C \B110 \C5F4 \AC12\C744 \CC44\C6B0\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105704456571310036)
,p_name=>'WS_FIND_WHAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC3E\C744 \B0B4\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105619519515309958)
,p_name=>'WS_GETTING_STARTED_CONTENT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Websheet \C560\D50C\B9AC\CF00\C774\C158\C744 \C0AC\C6A9\D558\C5EC \C77C\BC18 \C0AC\C6A9\C790\B294 \AC1C\BC1C\C790 \C5C6\C774 \AD6C\C870\D654\B41C \B370\C774\D130 \BC0F \AD6C\C870\D654\B418\C9C0 \C54A\C740 \B370\C774\D130\B97C \AD00\B9AC\D560 \C218 \C788\C2B5\B2C8\B2E4. Websheet\B97C \D1B5\D574 \C0AC\C6A9\C790\B294 \B2E4\C74C \C791\C5C5\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'<ul>',
unistr('<li>\C6F9 \BE0C\B77C\C6B0\C800\B97C \C0AC\C6A9\D558\C5EC \C6F9\C744 \D1B5\D574 \CF58\D150\CE20\B97C \C0DD\C131\D558\ACE0 \ACF5\C720\D569\B2C8\B2E4.</li>'),
unistr('<li>\ACC4\CE35 \B0B4\C5D0\C11C \D398\C774\C9C0\B97C \AD6C\C131\D558\ACE0 \D398\C774\C9C0\B97C \C0C1\D638 \AC04\C5D0 \B9C1\D06C\D569\B2C8\B2E4.</li>'),
unistr('<li>\B370\C774\D130 \ADF8\B9AC\B4DC\B77C\B294 \D3EC\D568\B41C \AE30\B2A5\C744 \C0AC\C6A9\D558\C5EC \D45C \D615\C2DD\C758 \B370\C774\D130\B97C \C0DD\C131\D558\ACE0 \AD00\B9AC\D569\B2C8\B2E4.</li>'),
unistr('<li>SQL\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130\BCA0\C774\C2A4 \B0B4 \AE30\C874 \B370\C774\D130 \AD6C\C870\C5D0 \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C0DD\C131\D569\B2C8\B2E4.</li>'),
unistr('<li>\B370\C774\D130 \ADF8\B9AC\B4DC \BC0F \BCF4\ACE0\C11C \B370\C774\D130\B97C \D398\C774\C9C0\C5D0 \CC28\D2B8 \B610\B294 \BCF4\ACE0\C11C\B85C \D45C\C2DC\D569\B2C8\B2E4.</li>'),
unistr('<li>\D30C\C77C, \D0DC\ADF8 \BC0F \BA54\BAA8\B97C \C0AC\C6A9\D558\C5EC \D398\C774\C9C0\C5D0 \C8FC\C11D\C744 \CD94\AC00\D569\B2C8\B2E4. \C5F0\AD00\B41C \C774\BBF8\C9C0\B97C \D398\C774\C9C0 \CF58\D150\CE20\C5D0 \C778\B77C\C778\C73C\B85C \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('<li>\B0B4\C7A5\B41C \AC80\C0C9 \AE30\B2A5\C744 \C0AC\C6A9\D558\C5EC \D398\C774\C9C0 \CF58\D150\CE20\B97C \AC80\C0C9\D569\B2C8\B2E4.</li>'),
unistr('<li>\C560\D50C\B9AC\CF00\C774\C158\C5D0 \B85C\ADF8\C778\D558\ACE0 \B85C\ADF8\C778\D55C \B2E4\C74C\C5D0\B294 \C560\D50C\B9AC\CF00\C774\C158\C744 \C77D\AC70\B098 \C4F0\AC70\B098 \AD00\B9AC\D560 \C218 \C788\B294 \C0AC\C6A9\C790\B97C \AD00\B9AC\D569\B2C8\B2E4(\C778\C99D \BC0F \AD8C\D55C \BD80\C5EC).</li>'),
'</ul>',
unistr('<p>\B354 \C790\C138\D55C \C815\BCF4\B97C \BCF4\B824\BA74 [\B3C4\C6C0\B9D0]\C744 \B204\B974\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105699449525310029)
,p_name=>'WS_GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105705486001310037)
,p_name=>'WS_GROUP_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105713396970310043)
,p_name=>'WS_GROUP_NAME_MUST_BE_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \C774\B984\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105699770393310029)
,p_name=>'WS_HEADING_ALIGNMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105700188329310033)
,p_name=>'WS_HEIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B192\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105713588823310043)
,p_name=>'WS_INVALID_COL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105712196723310042)
,p_name=>'WS_INVALID_COL_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C5F4 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105670330622310003)
,p_name=>'WS_INVALID_DATA_GRID_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \B370\C774\D130 \ADF8\B9AC\B4DC \C774\B984 \B610\B294 \BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105640889266309977)
,p_name=>'WS_LINKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105706162895310037)
,p_name=>'WS_LINK_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105639319211309976)
,p_name=>'WS_LINK_TO_THIS_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0 \B300\D55C \B9C1\D06C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105704930802310036)
,p_name=>'WS_LOAD_ORDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\B4DC \C21C\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105712700981310042)
,p_name=>'WS_LOV_ALREADY_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D\C774 \C874\C7AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105698743052310028)
,p_name=>'WS_LOV_DEF'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105712890470310042)
,p_name=>'WS_LOV_DEF_MUST_BE_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \C815\C758\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105700336265310033)
,p_name=>'WS_LOV_DIALOG_HLP1'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D\C740 \C0AC\C6A9\C790\AC00 \C785\B825\D560 \C218 \C788\B294 \C5F4 \AC12\C744 \C81C\D55C\D558\AE30 \C704\D574 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105700464530310033)
,p_name=>'WS_LOV_DIALOG_HLP2'
,p_message_language=>'ko'
,p_message_text=>unistr('[\C5F4 \C18D\C131] \D3B8\C9D1 \C2DC \C5F4\C5D0 \C815\C758\B41C \AC12 \BAA9\B85D\C744 \C5F0\AD00\C2DC\D0AC \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105712494931310042)
,p_name=>'WS_LOV_MUST_BE_DEF'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \D45C\C2DC \C720\D615\C5D0 \B300\D574 \AC12 \BAA9\B85D\C744 \C815\C758\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105712641495310042)
,p_name=>'WS_LOV_MUST_BE_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \C774\B984\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105698662139310028)
,p_name=>'WS_LOV_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105640403143309977)
,p_name=>'WS_MAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9F5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105700052638310032)
,p_name=>'WS_MAX_WIDTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105472048872309837)
,p_name=>'WS_MAX_WIDTH_LIMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \B108\BE44\B294 4000\BCF4\B2E4 \D074 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105697780465310027)
,p_name=>'WS_MINIMIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C\D654')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105662544730309996)
,p_name=>'WS_MOVE_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106025128921310295)
,p_name=>'WS_MUST_BE_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) %1\C758 \B0A0\C9DC \D615\C2DD\ACFC \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105713401561310043)
,p_name=>'WS_NAME_MUST_BE_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \B370\C774\D130 \ADF8\B9AC\B4DC \C774\B984\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105638918632309975)
,p_name=>'WS_NAME_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105701087537310033)
,p_name=>'WS_NEW_COL_VAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C5F4 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104894987643309393)
,p_name=>'WS_NEW_DATA_GRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \B370\C774\D130 \ADF8\B9AC\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105705280779310036)
,p_name=>'WS_NEW_DATA_GRID_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \B370\C774\D130 \ADF8\B9AC\B4DC \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105705382014310037)
,p_name=>'WS_NEW_GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \ADF8\B8F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105698528770310028)
,p_name=>'WS_NEW_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105700211394310033)
,p_name=>'WS_NEW_LOV_BASED_ON_CURR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \AC12 \AE30\BC18\C758 \C0C8 \AC12 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104894759460309392)
,p_name=>'WS_NEW_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104895008481309393)
,p_name=>'WS_NEW_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104894656206309392)
,p_name=>'WS_NEW_SECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C139\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105707226287310038)
,p_name=>'WS_NEW_VALIDATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \AC80\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105714713087310044)
,p_name=>'WS_NEW_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105600272787309942)
,p_name=>'WS_NOTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105640791830309977)
,p_name=>'WS_NOTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105600323856309942)
,p_name=>'WS_NOTE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\ACE0 \AC12\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104894522745309392)
,p_name=>'WS_NO_COLUMNS_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104894125065309392)
,p_name=>'WS_NO_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104893034223309391)
,p_name=>'WS_NO_FILE_CHOSEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \D30C\C77C \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104893900284309392)
,p_name=>'WS_NO_NOTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\BAA8 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104894455199309392)
,p_name=>'WS_NO_TAGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0DC\ADF8 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105698280671310028)
,p_name=>'WS_NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C22B\C790')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105714631413310044)
,p_name=>'WS_OLD_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105704866318310036)
,p_name=>'WS_ORDER_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105665075449309999)
,p_name=>'WS_PAGE_ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCC4\CE6D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104934196716309422)
,p_name=>'WS_PAGE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\AC00 \C791\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105665106570309999)
,p_name=>'WS_PAGE_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104894837929309393)
,p_name=>'WS_PAGE_DIRECTORY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B514\B809\D1A0\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104895261103309393)
,p_name=>'WS_PAGE_HISTORY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B0B4\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106063203124310331)
,p_name=>'WS_PAGE_LIST_WITH_CHILD_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C704 \D398\C774\C9C0\AC00 \C788\B294 \ACC4\CE35\C801 \D398\C774\C9C0 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106010528693310280)
,p_name=>'WS_PROPERTIES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105711818056310041)
,p_name=>'WS_QRY_MORE_10K'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C9C8\C758\B294 10,000\AC1C \C774\C0C1\C758 \D589\C744 \BC18\D658\D569\B2C8\B2E4. \BCF4\B2E4 \C815\D655\D55C \ACB0\ACFC\B97C \C5BB\C73C\B824\BA74 \B370\C774\D130\B97C \D544\D130\B9C1\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105678714411310011)
,p_name=>'WS_QUERY_NOT_ALLOWED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\BD80 \C560\D50C\B9AC\CF00\C774\C158 \AC1D\CCB4\C5D0 \B300\D55C \C9C8\C758\B294 \D5C8\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105699621869310029)
,p_name=>'WS_READ_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77D\AE30 \C804\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105714485895310043)
,p_name=>'WS_RECENT_CHGS_LISTED_BELOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC \BCC0\ACBD\C0AC\D56D\C774 \C544\B798\C5D0 \B098\C5F4\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106010777550310280)
,p_name=>'WS_REPLACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\AFB8\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105704520193310036)
,p_name=>'WS_REPLACE_WITH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\AFC0 \B0B4\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105714513136310044)
,p_name=>'WS_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105705123862310036)
,p_name=>'WS_ROWS_W_EMPTY_COL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE48 \C5F4\C744 \D3EC\D568\D558\B294 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106022760820310292)
,p_name=>'WS_ROW_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D589\C774 %1\C5D0 %2\C5D0 \C758\D574 \C0DD\C131\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106022692899310292)
,p_name=>'WS_ROW_KEY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \D0A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106022808153310292)
,p_name=>'WS_ROW_LAST_UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20\AC00 %0\C5D0 %1\C5D0 \C758\D574 \B9C8\C9C0\B9C9\C73C\B85C \C5C5\B370\C774\D2B8\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105713706838310043)
,p_name=>'WS_ROW_MUST_BE_SEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AC12\C744 \C124\C815\D560 \D589\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105640577330309977)
,p_name=>'WS_ROW_ORDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C21C\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105712016396310042)
,p_name=>'WS_ROW_SELECTED_DEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C\D560 \D589\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105648671941309984)
,p_name=>'WS_SAMPLE_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0D8\D50C \D648 \D398\C774\C9C0\AC00 \C0DD\C131\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105662318119309996)
,p_name=>'WS_SAVE_ADD_ANOTHER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5 \D6C4 \B2E4\B978 \D56D\BAA9 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106064289372310332)
,p_name=>'WS_SEARCH_REPORT_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \BCF4\ACE0\C11C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105664915735309998)
,p_name=>'WS_SECTION_CONTENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C139\C158 \CF58\D150\CE20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104934008652309421)
,p_name=>'WS_SECTION_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C139\C158\C774 \C791\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105648762166309984)
,p_name=>'WS_SECTION_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C139\C158 \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105701148717310033)
,p_name=>'WS_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105704272816310036)
,p_name=>'WS_SELECTED_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105699584040310029)
,p_name=>'WS_SELECT_COLUMN_GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \ADF8\B8F9 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105621176811309959)
,p_name=>'WS_SELECT_RPT_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C744 \BCF4\B824\BA74 \BCF4\ACE0\C11C \C774\B984\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105713232870310042)
,p_name=>'WS_SEQ_MUST_BE_NUM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C21C\C11C\B294 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105713140712310042)
,p_name=>'WS_SEQ_MUST_BE_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C21C\C11C\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105700928569310033)
,p_name=>'WS_SET_COL_VAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AC12 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106071230243310338)
,p_name=>'WS_SIGNUP.PRIVACY_POLICY'
,p_message_language=>'ko'
,p_message_text=>unistr('<a href="https://www.oracle.com/legal/privacy/index.html" target="_new">\C624\B77C\D074 \AC1C\C778\C815\BCF4 \BCF4\D638\C815\CC45</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106063736286310331)
,p_name=>'WS_SIGNUP.TERMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798 "\B2E4\C74C" \B2E8\CD94\B97C \D074\B9AD\D558\BA74 \C624\B77C\D074 \C6F9 \C0AC\C774\D2B8\C758 \C0AC\C6A9\C5D0\B294 <a href="https://www.oracle.com/us/legal/terms/index.html" target="_new">Oracle.com \C774\C6A9\C57D\AD00</a>\C774 \C801\C6A9\B428\C744 \C774\D574\D558\ACE0 \B3D9\C758\D558\AC8C \B429\B2C8\B2E4. \C561\C138\C2A4, \BCF4\C720, \AC1C\C815, \C0AD\C81C, \BCF4\C548, \AD6D\C678 \C774\C804 \BC0F \AE30\D0C0 \D56D\BAA9\C744 \D3EC\D568\D558\C5EC \C624\B77C\D074\C758 \AC1C\C778\C815\BCF4 \C218\C9D1 \BC0F \C0AC\C6A9\C5D0 \B300\D55C \CD94\AC00\C801\C778 \C138\BD80 \C0AC\D56D\C740 <a href="https://www.oracle.')
||unistr('com/legal/privacy/index.html" target="_new">\C624\B77C\D074 \AC1C\C778\C815\BCF4 \BCF4\D638\C815\CC45</a>\C5D0\C11C \D655\C778\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105698107840310028)
,p_name=>'WS_STRING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB38\C790\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105713977523310043)
,p_name=>'WS_STR_MUST_BE_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\D560 \BB38\C790\C5F4\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105640997754309977)
,p_name=>'WS_TAGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0DC\ADF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106010662449310280)
,p_name=>'WS_TOGGLE_CHECKBOXES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1A0\AE00 \D655\C778\B780')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105707353839310038)
,p_name=>'WS_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105705561528310037)
,p_name=>'WS_UNASSIGNED_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B418\C9C0 \C54A\C740 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105698083489310028)
,p_name=>'WS_UNIQUE_IDENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \C2DD\BCC4\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105706349793310037)
,p_name=>'WS_URL_TARGET'
,p_message_language=>'ko'
,p_message_text=>unistr('URL \B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105714069312310043)
,p_name=>'WS_URL_TARGET_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('URL \B300\C0C1\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105714810931310044)
,p_name=>'WS_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106069547713310336)
,p_name=>'WS_USERNAME_TOO_LONG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984\C774 \B108\BB34 \AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106025066357310294)
,p_name=>'WS_VALUE_NUMERIC'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105600144670309942)
,p_name=>'WS_VALUE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('(\AC12 \D544\C694)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105710443300310040)
,p_name=>'WS_VAL_EXPRESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD \AC80\C99D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105714110836310043)
,p_name=>'WS_VAL_NAME_MUST_BE_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C774\B984\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105708212029310039)
,p_name=>'WS_VAL_NOT_EQ_STR_EXP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C774 \D45C\D604\C2DD\C5D0 \C788\B294 \BB38\C790\C5F4 \B9AC\D130\B7F4\ACFC \AC19\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105714210776310043)
,p_name=>'WS_VAL_SEQ_MUST_BE_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C21C\C11C\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105707817105310038)
,p_name=>'WS_VAL_TYPE_CHAR_IN_EXP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C5D0 \D45C\D604\C2DD\C5D0 \C788\B294 \C801\C5B4\B3C4 \D558\B098 \C774\C0C1\C758 \BB38\C790\AC00 \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105709582280310040)
,p_name=>'WS_VAL_TYPE_COL_ALPHA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C740 \C601\C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105708922293310039)
,p_name=>'WS_VAL_TYPE_COL_IN_EXP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C774 \D45C\D604\C2DD\C5D0 \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105709091188310039)
,p_name=>'WS_VAL_TYPE_COL_NOT_0'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C740 0\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105708706680310039)
,p_name=>'WS_VAL_TYPE_COL_NOT_EXP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C774 \D45C\D604\C2DD\C5D0 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105709462919310040)
,p_name=>'WS_VAL_TYPE_COL_NOT_NULL_OR_0'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C740 NOT NULL \B610\B294 0\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105709138555310039)
,p_name=>'WS_VAL_TYPE_COL_NO_SP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C740 \ACF5\BC31\C744 \D3EC\D568\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105709633790310040)
,p_name=>'WS_VAL_TYPE_COL_NUM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C740 \C22B\C790\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105710042667310040)
,p_name=>'WS_VAL_TYPE_COL_VAL_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C740 \C801\D569\D55C \B0A0\C9DC\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105708576511310039)
,p_name=>'WS_VAL_TYPE_EQ_STR_EXP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C774 \D45C\D604\C2DD\C5D0 \C788\B294 \BB38\C790\C5F4 \B9AC\D130\B7F4\ACFC \AC19\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105708452708310039)
,p_name=>'WS_VAL_TYPE_NOT_ANY_CHAR_EXP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C5D0 \D45C\D604\C2DD\C5D0 \C788\B294 \BB38\C790\AC00 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105707751629310038)
,p_name=>'WS_VAL_TYPE_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C774 \B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105708060212310039)
,p_name=>'WS_VAL_TYPE_ONLY_CHAR_EXP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C5F4\C5D0 \D45C\D604\C2DD\C5D0 \C788\B294 \BB38\C790\B9CC \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105715055425310044)
,p_name=>'WS_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106063188276310331)
,p_name=>'WS_VIEW_DATA_GRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \ADF8\B9AC\B4DC \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105697350593310027)
,p_name=>'WS_VIEW_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105697550429310027)
,p_name=>'WS_VIEW_NOTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\ACE0 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105697483947310027)
,p_name=>'WS_VIEW_TAGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0DC\ADF8 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105639224824309976)
,p_name=>'WS_WEBSHEET_ALIAS_NOT_UNIQUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D\C774 \C874\C7AC\D569\B2C8\B2E4. \B2E4\B978 \BCC4\CE6D\C744 \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106010409628310280)
,p_name=>'WS_WEBSHEET_PROP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6F9 \C2DC\D2B8 \C18D\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105619680917309958)
,p_name=>'WS_WELCOME'
,p_message_language=>'ko'
,p_message_text=>unistr('Websheets \C2DC\C791')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105699979736310029)
,p_name=>'WS_WIDTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\B108\BE44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105639718850309976)
,p_name=>'WS_WITHOUT_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \D3EC\D568 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105640119758309976)
,p_name=>'WS_WITHOUT_LINKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \D3EC\D568 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105640328754309977)
,p_name=>'WS_WITHOUT_LOCATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58 \D3EC\D568 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105639955028309976)
,p_name=>'WS_WITHOUT_NOTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\ACE0 \D3EC\D568 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105639655542309976)
,p_name=>'WS_WITH_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105640086627309976)
,p_name=>'WS_WITH_LINKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105640222961309976)
,p_name=>'WS_WITH_LOCATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\CE58 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105639864426309976)
,p_name=>'WS_WITH_NOTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\ACE0 \D3EC\D568')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105391473054309766)
,p_name=>'WWV_CALENDAR_INVALID_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C9C8\C758\B294 \C801\C5B4\B3C4 \D558\B098\C758 \B0A0\C9DC \B610\B294 \C2DC\AC04\AE30\B85D \C5F4\C744 \D3EC\D568\D574\C57C \D569\B2C8\B2E4. \C9C8\C758\B97C \D655\C778\D558\C2ED\C2DC\C624. (%0) </p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105126700826309568)
,p_name=>'WWV_CRYPT.KEY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0A4\B294 8\BC14\C774\D2B8, 16\BC14\C774\D2B8 \B610\B294 24\BC14\C774\D2B8\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104895991066309393)
,p_name=>'WWV_DATA_PKG.APP_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C791\C5C5\C601\C5ED\C5D0 \C560\D50C\B9AC\CF00\C774\C158 %0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104896118534309394)
,p_name=>'WWV_DATA_PKG.LOAD_TABLE_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D14C\C774\BE14 \B85C\B4DC\B97C \C2E4\D328\D588\C2B5\B2C8\B2E4. %1 \D14C\C774\BE14\C5D0 \C624\B958\AC00 \B85C\AE45\B418\C5C8\C2B5\B2C8\B2E4. \C774 \D14C\C774\BE14\C740 \C7AC\C2E4\D589 \C804\C5D0 \C0AD\C81C\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104895892360309393)
,p_name=>'WWV_DATA_PKG.NO_FILE_GENERATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\B41C \D30C\C77C \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104895726232309393)
,p_name=>'WWV_DATA_PKG.ROWS_EXPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C775\C2A4\D3EC\D2B8\B41C \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104896216735309394)
,p_name=>'WWV_DATA_PKG.TABLE_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D14C\C774\BE14 %0\C774(\AC00) \C774\BBF8 \C874\C7AC\D569\B2C8\B2E4. \C774 \D14C\C774\BE14\C740 \C7AC\C2E4\D589 \C804\C5D0 \C0AD\C81C\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104896054316309394)
,p_name=>'WWV_DATA_PKG.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \D3EC\D568\B41C \C5F4\C740 \C9C0\C6D0\B418\C9C0 \C54A\B294 \B370\C774\D130 \C720\D615\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104873138647309375)
,p_name=>'WWV_DBMS_CLOUD.DATA_PUMP_DIR_PRIVS_MISSING'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C2A4\D0A4\B9C8\B97C \C0AC\C6A9\D558\B824\BA74 DATA_PUMP_DIR \B514\B809\D1A0\B9AC\C5D0 \B300\D55C READ \BC0F WRITE \AD8C\D55C\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104877403167309378)
,p_name=>'WWV_DBMS_CLOUD.FILE_TOO_LARGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \AC1D\CCB4 \C800\C7A5\C18C \D30C\C77C\C774 \B108\BB34 \D07D\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104864513720309367)
,p_name=>'WWV_DBMS_CLOUD.INTERNAL_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('DBMS_CLOUD \C694\CCAD\C744 \CC98\B9AC\D558\B294 \C911 \B0B4\BD80 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104864629757309367)
,p_name=>'WWV_DBMS_CLOUD.INVALID_CREDENTIAL_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1D\CCB4 \C800\C7A5\C18C \CC38\C870\C5D0 \B300\D55C \C778\C99D\C11C \C720\D615\C774 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104873086411309374)
,p_name=>'WWV_DBMS_CLOUD.NO_DATA_PUMP_DIR_ACCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C2A4\D0A4\B9C8\B97C \C0AC\C6A9\D558\B824\BA74 DATA_PUMP_DIR \B514\B809\D1A0\B9AC\C5D0 \B300\D55C \C561\C138\C2A4 \AD8C\D55C\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104876012308309377)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C2DC\C2A4\D15C\C5D0\C11C DBMS_CLOUD \D328\D0A4\C9C0\B97C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104872938790309374)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD_ACCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C2A4\D0A4\B9C8\B97C \C0AC\C6A9\D558\B824\BA74 DBMS_CLOUD \D328\D0A4\C9C0\C5D0 \B300\D55C EXECUTE \AD8C\D55C\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105108474340309548)
,p_name=>'WWV_DBMS_SQL.FUNC_BODY_NULL_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BB38\BD84\C11D \C624\B958: \D568\C218 \BCF8\BB38\C740 \B110\C774\BA74 \C548\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105108548642309548)
,p_name=>'WWV_DBMS_SQL.PARSE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BB38\BD84\C11D \C624\B958: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105101040386309543)
,p_name=>'WWV_FLOW.APP_NOT_FND_FOOTER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158=%0 \D604\C7AC \C791\C5C5\C601\C5ED=%1 \C694\CCAD\B41C \C791\C5C5\C601\C5ED=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105100565865309542)
,p_name=>'WWV_FLOW.APP_NOT_FND_INV_COMP_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1014 \C560\D50C\B9AC\CF00\C774\C158\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C791\C5C5\C601\C5ED\C774 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105102609771309544)
,p_name=>'WWV_FLOW.APP_PAGE_REQUEST_FOOTER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158=%0 \D398\C774\C9C0=%1 \C694\CCAD=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105096633362309539)
,p_name=>'WWV_FLOW.AUTH_SCHEME_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1082 \AD8C\D55C \BD80\C5EC \CCB4\ACC4 \CF54\B4DC\B97C \C2E4\D589\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105097425792309540)
,p_name=>'WWV_FLOW.BRANCH_POINT_NULL_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1007 \BD84\AE30 \C9C0\C810\C740 \B110\C77C \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105097542443309540)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1008 %0 \D398\C774\C9C0\B85C\C758 \BD84\AE30\B97C \C218\D589\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104857963198309361)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_MODE_PAGE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-7746 \B300\D654\C0C1\C790 \D398\C774\C9C0\C5D0\C11C \B2E4\B978 \D398\C774\C9C0 \BAA8\B4DC\C758 \D398\C774\C9C0\B85C\C758 \BD84\AE30\B97C \CC98\B9AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105105867370309546)
,p_name=>'WWV_FLOW.BUTTON_TEMP_FETCH_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D15C\D50C\B9AC\D2B8 ID %0\C744(\B97C) \C778\CD9C\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105096251522309539)
,p_name=>'WWV_FLOW.CLICK_TO_LOGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\B85C\ADF8\C778\D558\B824\BA74 <a href="%0">\C5EC\AE30</a>\B97C \B204\B974\C2ED\C2DC\C624.</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105096959009309540)
,p_name=>'WWV_FLOW.COMP_EXP_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1030 \ACC4\C0B0 \D45C\D604\C2DD\C744 \C2E4\D589\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105097034272309540)
,p_name=>'WWV_FLOW.COMP_FUNCTION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1004 \D568\C218\B97C \ACC4\C0B0\D560 \C218 \C5C6\C2B5\B2C8\B2E4. computation_point=%0 computation_type=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105096806798309540)
,p_name=>'WWV_FLOW.COMP_QUERY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1003 \ACC4\C0B0 \C9C8\C758\B97C \C2E4\D589\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105096793000309539)
,p_name=>'WWV_FLOW.CREATE_ITEM_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1001 \B2E4\C74C \D56D\BAA9\C744 \C0DD\C131\D558\B294 \C911 \C608\C0C1\CE58 \C54A\C740 \C624\B958 \BC1C\C0DD: FSP_PROCESS_STATE_%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105096443107309539)
,p_name=>'WWV_FLOW.DEEPLINKING_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1001 make_deeplinking_item \C138\C158 %0\C5D0 \C608\C0C1\CE58 \C54A\C740 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105098041342309540)
,p_name=>'WWV_FLOW.DET_COMPANY_FOOTER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C18C\C720\C790\C758 \BCF4\C548 \ADF8\B8F9 ID\B97C \D3EC\D568\D560 p_company \B610\B294 wwv_flow_company \CFE0\D0A4\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105102367638309544)
,p_name=>'WWV_FLOW.DET_COMPANY_ON_ACCEPT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-7621 \C560\D50C\B9AC\CF00\C774\C158 \D5C8\C6A9 \C2DC \C560\D50C\B9AC\CF00\C774\C158(%0)\C5D0 \B300\D55C \C791\C5C5\C601\C5ED\C744 \D655\C778\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105102460092309544)
,p_name=>'WWV_FLOW.DET_COMP_FOR_FLOW_FOOTER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C18C\C720\C790\C758 \BCF4\C548 \ADF8\B8F9 ID\B97C \D3EC\D568\D560 p_company \B610\B294 wwv_flow_company \CFE0\D0A4\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105097834344309540)
,p_name=>'WWV_FLOW.EVAL_TYPE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1011 \BD80\C801\D569\D55C \D3C9\AC00 \C720\D615: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105105759439309546)
,p_name=>'WWV_FLOW.FETCH_VALUE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('fetch_value\C5D0 \C560\D50C\B9AC\CF00\C774\C158 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105096507990309539)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1902 find_item_name \B8E8\D2F4\C5D0\C11C \D56D\BAA9 ID\AC00 \B110\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105097348856309540)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_BOOL_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1021 "\BD80\C6B8\C744 \BC18\D658\D558\B294 \D568\C218 \BCF8\BB38" \AC80\C99D\C744 \C2E4\D589\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105097294363309540)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_TEXT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1024 "\D14D\C2A4\D2B8\B97C \BC18\D658\D558\B294 \D568\C218 \BCF8\BB38" \AC80\C99D\C744 \C2E4\D589\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105097961397309540)
,p_name=>'WWV_FLOW.G_FLOW_ID_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1812 G_FLOW_ID(%0)\B97C \C9C0\C815\D558\B294 \C911 \C608\C0C1\CE58 \C54A\C740 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105102550073309544)
,p_name=>'WWV_FLOW.INSUFFICENT_INFO_ON_REQ_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-9988 \C774 \C694\CCAD\C5D0 \C81C\ACF5\B41C \C815\BCF4\AC00 \BD88\CDA9\BD84\D568: \C774\C804 \D398\C774\C9C0\AC00 \C644\C804\D788 \B85C\B4DC\B420 \B54C\AE4C\C9C0 \AE30\B2E4\B9AC\C9C0 \C54A\C558\C744 \C218 \C788\C2B5\B2C8\B2E4. \BE0C\B77C\C6B0\C800\C758 [\B4A4\B85C] \B610\B294 [\C7AC\B85C\B4DC] \B2E8\CD94\B97C \B204\B974\AC70\B098, \C560\D50C\B9AC\CF00\C774\C158 \D648 \D398\C774\C9C0\B85C \C774\B3D9\D558\C5EC \ACC4\C18D\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105098486129309541)
,p_name=>'WWV_FLOW.LOGIN_SERVER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1555 Oracle Login Server\C5D0 \B85C\ADF8\C778\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \C9C0\C815\B41C \ACF5\AC1C \C0AC\C6A9\C790\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105102005867309543)
,p_name=>'WWV_FLOW.LOGOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C544\C6C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105096139022309539)
,p_name=>'WWV_FLOW.NOT_LOGGED_IN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \C778\C99D\C5D0 \D544\C694\D55C \CFE0\D0A4\AC00 \B204\B77D\B418\C5C8\AC70\B098 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105103031296309544)
,p_name=>'WWV_FLOW.NO_PAGE_TO_BRANCH_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1777: %0 \D398\C774\C9C0\AC00 \BD84\AE30\D560 \D398\C774\C9C0\B97C \C81C\ACF5\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\C5D0\AC8C \C774 \C624\B958\B97C \BCF4\ACE0\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105102194660309543)
,p_name=>'WWV_FLOW.NO_PRIV_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1013 %0 \C0AC\C6A9\C790\AC00 \C2DC\B3C4\D55C \C791\C5C5\C5D0 \B300\D55C \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4. %1 \B864\C774 \D544\C694\D569\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104927932791309417)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.CHECKSUM_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\C12C\C774 \D45C\C2DC \D504\B85C\C2DC\C800\C5D0 \C804\B2EC\B420 \ACBD\C6B0 \C778\C218\B97C \C0AC\C6A9\D558\C5EC \D398\C774\C9C0\B97C \C694\CCAD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104928149181309417)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.DIRECT_BRANCH_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('"\D398\C774\C9C0 \BD84\AE30" \C720\D615 \BD84\AE30\B97C \C0AC\C6A9\D560 \ACBD\C6B0\C5D0\B9CC \B2E4\B978 \D398\C774\C9C0\C5D0\C11C \D574\B2F9 \D398\C774\C9C0\B85C \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104928048440309417)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.NO_ARGS_ALLOWED '
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C218\B97C \C0AC\C6A9\D558\C9C0 \C54A\ACE0 \D398\C774\C9C0\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104928349560309417)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_ARGS_ALLOWED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C218(\C694\CCAD, \CE90\C2DC \BE44\C6B0\AE30, \D56D\BAA9 \AC12)\B97C \D5C8\C6A9\D558\C9C0 \C54A\B294 \D398\C774\C9C0\C5D0 \C778\C218\AC00 \C804\B2EC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104927877056309417)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.UNPROTECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C5D0 \C124\C815\B41C \BCF4\D638\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105101928081309543)
,p_name=>'WWV_FLOW.REQUIRED_ROLE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C218 \B864\C774 \C0AC\C6A9\C73C\B85C \C124\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105103140061309544)
,p_name=>'WWV_FLOW.RESTART_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('<a href="f?p=%0">\C560\D50C\B9AC\CF00\C774\C158 \C7AC\C2DC\C791</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105096392286309539)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1001 \C800\C7A5 \B8E8\D2F4\C5D0 \C608\C0C1\CE58 \C54A\C740 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105097758172309540)
,p_name=>'WWV_FLOW.SQL_EXP_HEADING_TEXT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1910 \BA38\B9AC\AE00 \D14D\C2A4\D2B8\C5D0\C11C SQL \D45C\D604\C2DD\C744 \D3C9\AC00\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105128985520309569)
,p_name=>'WWV_FLOW.UNABLE_HOME_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648 \D398\C774\C9C0\B85C \C774\B3D9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105102299828309543)
,p_name=>'WWV_FLOW.UNABLE_RESOLVE_ALIAS_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1512 \D398\C774\C9C0 \BCC4\CE6D(%0)\C744 \BD84\C11D\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105106015555309546)
,p_name=>'WWV_FLOW.UNABLE_SET_TIMED_STAT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('timed_statistics\B97C \C124\C815\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105105944122309546)
,p_name=>'WWV_FLOW.UNABLE_TO_TRACE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\C801\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105099883799309542)
,p_name=>'WWV_FLOW.UNSUPP_AUTH_SCHEME_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1444 \C9C0\C6D0\B418\C9C0 \C54A\B294 \C778\C99D \CCB4\ACC4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105097122806309540)
,p_name=>'WWV_FLOW.VALIDATION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1006 \AC80\C99D \B8E8\D2F4\C5D0 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105108630944309548)
,p_name=>'WWV_FLOW_ADMINISTRATION.DEPRECATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105136840205309575)
,p_name=>'WWV_FLOW_ADMIN_API.DELETE_DEV_ROLE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790 \B864\C744 \C0AD\C81C\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105136762201309575)
,p_name=>'WWV_FLOW_ADMIN_API.FETCH_FND_USER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \CC3E\AE30 \C815\BCF4\B97C \C778\CD9C\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105336848027309726)
,p_name=>'WWV_FLOW_ADMIN_API.NO_DEV_PRIV'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: %0 \C0AC\C6A9\C790\C5D0\AC8C \AC1C\BC1C\C790 \AD8C\D55C \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105003988584309473)
,p_name=>'WWV_FLOW_API.COMPATIBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D638\D658(\C774 \C784\D3EC\D2B8\B97C \BB38\C81C \C5C6\C774 \C2E4\D589\D560 \C218 \C788\C5B4\C57C \D569\B2C8\B2E4.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105882144914310170)
,p_name=>'WWV_FLOW_API.CREDENTIAL_WARNING'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('"%0" \C778\C99D\C11C(\C815\C801 ID)\C5D0 \B300\D55C \ACBD\ACE0:'),
'',
unistr('- Application Express \C775\C2A4\D3EC\D2B8 \D30C\C77C\C5D0 \C778\C99D\C11C \C815\BCF4\AC00 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('- \C560\D50C\B9AC\CF00\C774\C158\C774 \C784\D3EC\D2B8\B41C \D6C4 APEX_CREDENTIAL.SET_PERSISTENT_CREDENTIAL'),
unistr('- \D504\B85C\C2DC\C800\B97C \C0AC\C6A9\D558\C5EC \C778\C99D\C11C\B97C \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \C778\C99D\C11C\AC00'),
unistr('- \C815\C801 ID "%0"\C744(\B97C) \C0AC\C6A9\D558\C5EC \CC38\C870\B418\ACE0 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104999403585309469)
,p_name=>'WWV_FLOW_API.CURRENT_FLOWS_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \BC84\C804:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105471965058309837)
,p_name=>'WWV_FLOW_API.DELETE_APP_IN_DIFFERENT_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0AD\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \B2E4\B978 \C791\C5C5\C601\C5ED\C5D0 \C124\CE58\B418\C5B4 \C788\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105003522951309472)
,p_name=>'WWV_FLOW_API.ERR_AUTH_SCHEME_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4 %0\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105002186448309471)
,p_name=>'WWV_FLOW_API.ERR_BRANCH_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30 ID "%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105003302539309472)
,p_name=>'WWV_FLOW_API.ERR_BUG_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\ADF8 ID "%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105000662347309470)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158 \C774\B984 %0\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105000713170309470)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE4C\B4DC \C635\C158 ID "%0"\C744(\B97C) \C124\C815\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105002071344309471)
,p_name=>'WWV_FLOW_API.ERR_BUTTON_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \C774\B984 "%0", ID "%1"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105357442933309741)
,p_name=>'WWV_FLOW_API.ERR_DA_ACTION_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5 \D558\C704 \C791\C5C5 \C774\B984="%0", ID="%1"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105357399958309741)
,p_name=>'WWV_FLOW_API.ERR_DA_EVENT_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5 \D398\C774\C9C0="%0", \C774\B984="%1", ID="%2"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105041583100309500)
,p_name=>'WWV_FLOW_API.ERR_DUP_PAGE_ITEM_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D398\C774\C9C0=%0, \D56D\BAA9="%1", ID="%2"\C5D0 \AE30\C874 \C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8 \D56D\BAA9\ACFC \B3D9\C77C\D55C \C774\B984\C774 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105001256045309471)
,p_name=>'WWV_FLOW_API.ERR_FLOW_COMPUTATION_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \ACC4\C0B0 \D56D\BAA9 "%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105001152415309470)
,p_name=>'WWV_FLOW_API.ERR_FLOW_ITEM_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 ID "%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104958499969309439)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778 \C18D\C131 ID="%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD	')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105371352171309751)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_VALUE_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778 \C18D\C131\AC12 ID="%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104958389631309439)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778 ID="%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105014736671309480)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_EVENT_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778 \C774\BCA4\D2B8 ID="%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105000966824309470)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PROCESS_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4 ID "%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106046159677310315)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPTION_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D15C\D50C\B9AC\D2B8 \C635\C158 ID "%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106046025244310315)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPT_GROUP_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D15C\D50C\B9AC\D2B8 \C635\C158 \ADF8\B8F9  ID "%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105003113375309472)
,p_name=>'WWV_FLOW_API.ERR_FORM_ADDED_TO_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC\C774 \AE30\C874 \D398\C774\C9C0 %0\C5D0 \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104978132655309454)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \AC1D\CCB4 \C124\CE58 \C18D\C131 ID="%0"\C744(\B97C) \C784\D3EC\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104978288543309454)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_SCRIPT_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58 \C2A4\D06C\B9BD\D2B8 ID "%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105002872350309472)
,p_name=>'WWV_FLOW_API.ERR_INVALID_REPORT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \BCF4\ACE0\C11C \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105002693997309472)
,p_name=>'WWV_FLOW_API.ERR_LANG_MAP_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BC88\C5ED \B9F5\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104900402560309397)
,p_name=>'WWV_FLOW_API.ERR_LOV_COL_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \C5F4 ID="%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105001605826309471)
,p_name=>'WWV_FLOW_API.ERR_LOV_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D ID "%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105000837000309470)
,p_name=>'WWV_FLOW_API.ERR_NAV_BAR_ITEM_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904 \D56D\BAA9 ID "%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105002380045309471)
,p_name=>'WWV_FLOW_API.ERR_PAGE_COMPUTATION_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \ACC4\C0B0 \D398\C774\C9C0 %0, \D56D\BAA9 %1, ID "%2"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105001715235309471)
,p_name=>'WWV_FLOW_API.ERR_PAGE_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\B984 "%0", ID "%1"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105411562074309781)
,p_name=>'WWV_FLOW_API.ERR_PAGE_GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \ADF8\B8F9\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105003045537309472)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HAS_BUTTONS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D398\C774\C9C0\C5D0\B294 \B2E8\CD94\AC00 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105001817492309471)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HELP_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 %0 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B97C \C791\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105002281274309471)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ITEM_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D398\C774\C9C0: %0, \D56D\BAA9: "%1", ID: "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105001950563309471)
,p_name=>'WWV_FLOW_API.ERR_PAGE_NAME_UPD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C774\B984 "%0", ID %1\C744(\B97C) \C5C5\B370\C774\D2B8\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105002764123309472)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ON_TABLE_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D14C\C774\BE14\C5D0 \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105002571249309472)
,p_name=>'WWV_FLOW_API.ERR_PAGE_PROCESS_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D504\B85C\C138\C2A4 \D398\C774\C9C0 %0, \C774\B984 %1\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105002435438309471)
,p_name=>'WWV_FLOW_API.ERR_PAGE_VALIDATION_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AC80\C99D \D398\C774\C9C0 %0, \C774\B984 %1\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105001588189309471)
,p_name=>'WWV_FLOW_API.ERR_PARENT_TAB_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED ID "%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105001032108309470)
,p_name=>'WWV_FLOW_API.ERR_PROCESS_SQL_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 SQL ID "%0"\C744(\B97C) \C124\C815\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105002904564309472)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0 %0\C774(\AC00) \C874\C7AC\D569\B2C8\B2E4. \BCF4\ACE0\C11C \C601\C5ED\C774 \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105003216146309472)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS2'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D398\C774\C9C0\B294 \C874\C7AC\D558\BBC0\B85C \C791\C131\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105003405764309472)
,p_name=>'WWV_FLOW_API.ERR_SHORTCUT_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4 ID "%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105001303425309471)
,p_name=>'WWV_FLOW_API.ERR_STD_TAB_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D14C\C774\BE14 ID "%0"\C744(\B97C) \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105001491616309471)
,p_name=>'WWV_FLOW_API.ERR_TABSET_RENAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C9D1\D569 %1\C758 \C774\B984\C744 %0(\C73C)\B85C \BC14\AFB8\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105000530738309470)
,p_name=>'WWV_FLOW_API.ERR_TEMPL_CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 %0\C744(\B97C) \C791\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104999314036309469)
,p_name=>'WWV_FLOW_API.FLOWS_API_LAST_EXTENDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C885\C73C\B85C \D655\C7A5\B41C API:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105003869800309472)
,p_name=>'WWV_FLOW_API.FLOWS_API_RUNTIME_INCOMPATIBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C775\C2A4\D3EC\D2B8 \D30C\C77C\C740 \D30C\C77C\C744 \C784\D3EC\D2B8\D558\B824\B294 Application Express\C758 \BC84\C804\ACFC \D638\D658\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105000383256309470)
,p_name=>'WWV_FLOW_API.FLOW_ID_MISSING'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D504\B85C\C2DC\C800\AC00 p_id \AC12 \C5C6\C774 \D638\CD9C\B418\C5C8\C2B5\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158 ID\B97C \C81C\ACF5\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104859687803309362)
,p_name=>'WWV_FLOW_API.FLOW_ID_OUT_OF_RANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID "%0"\C774(\AC00) \D5C8\C6A9\B418\B294 \BC94\C704(%1 - %2)\C5D0 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105471477479309837)
,p_name=>'WWV_FLOW_API.FLOW_ID_RANGE_RESERVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID "%0"\C744(\B97C) \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \BC94\C704(%1 - %2)\AC00 \C608\C57D\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105003718916309472)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID %0\C740(\B294) \C624\B77C\D074\C6A9\C73C\B85C \C608\C57D\B418\C5B4 \C788\C74C ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104859758280309362)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED_FOR_OTHER_WORKSPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID "%0"\C774(\AC00) \B2E4\B978 \C791\C5C5\C601\C5ED\C5D0 \C608\C57D\B418\C5B4 \C788\C73C\BA70 \C5EC\AE30\C5D0\C11C \C0AC\C6A9\B420 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105000401751309470)
,p_name=>'WWV_FLOW_API.FLOW_NOT_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C774 \C0AD\C81C\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \C784\D3EC\D2B8\AC00 \C2DC\B3C4\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104999566971309469)
,p_name=>'WWV_FLOW_API.IMPORT_COMPATIBLE_WITH_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C784\D3EC\D2B8\C640 \D638\D658\B418\B294 \BC84\C804:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105429977016309802)
,p_name=>'WWV_FLOW_API.IMPORT_SCRIPT_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8\B97C \C784\D3EC\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105000083914309470)
,p_name=>'WWV_FLOW_API.INVALID_CREDENTIALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C0AC\C6A9\C790 \C774\B984, \BE44\BC00\BC88\D638 \B610\B294 \C791\C5C5\C601\C5ED \C870\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104999670136309469)
,p_name=>'WWV_FLOW_API.MISSING_EXPORT_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C784\D3EC\D2B8\AC00 \C775\C2A4\D3EC\D2B8 \BC84\C804\C744 \C81C\ACF5\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105882000086310170)
,p_name=>'WWV_FLOW_API.MUST_USE_APEX_APP_INSTALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 ID\AC00 "%0"\C778 \C6D0\ACA9 \C11C\BC84\C5D0 \B300\D574 \C81C\ACF5\B41C \AC12\C774 \C5C6\C2B5\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158\C744 \C124\CE58\D558\AE30 \C804\C5D0 APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105429840260309802)
,p_name=>'WWV_FLOW_API.NEW_SCRIPT_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C \B9CC\B4E4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105004027766309473)
,p_name=>'WWV_FLOW_API.NOT_COMPATIBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D638\D658\B418\C9C0 \C54A\C74C(\C775\C2A4\D3EC\D2B8\C5D0 %0 \BC84\C804\C5D0\C11C \C9C0\C6D0\D558\C9C0 \C54A\B294 \D638\CD9C\C774 \D3EC\D568\B418\C5B4 \C788\C744 \C218 \C788\C2B5\B2C8\B2E4.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105882475983310170)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_1'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C6D0\ACA9 \C11C\BC84 "%0"(\C815\C801 ID)\C5D0 \B300\D55C \ACBD\ACE0:'),
'',
unistr('- APEX_APPLICATION_INSTALL\C744 \D1B5\D574 \C774 \C6D0\ACA9 \C11C\BC84\C5D0 \B300\D55C \C18D\C131\C774 \C124\C815\B418\C5C8\C2B5\B2C8\B2E4.'),
unistr('- \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C\B3C4 \C774 \C6D0\ACA9 \C11C\BC84 \AC1D\CCB4\B97C \C0AC\C6A9\D569\B2C8\B2E4.'),
'',
unistr('\B530\B77C\C11C \C791\C5C5\C601\C5ED \C6D0\ACA9 \C11C\BC84 \C18D\C131\C774 \C5C5\B370\C774\D2B8\B418\C5C8\C2B5\B2C8\B2E4.'),
unistr('- \AE30\BCF8 URL:      %1'),
unistr('- HTTPS \D638\C2A4\D2B8:    %2'),
unistr('- ORDS \C2DC\AC04\B300: %3')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105882342326310170)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_2'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C6D0\ACA9 \C11C\BC84 "%0"(\C815\C801 ID)\C5D0 \B300\D55C \ACBD\ACE0:'),
'',
unistr('- PROMPT_ON_INSTALL \C18D\C131\C774 YES\B85C \C124\C815\B418\C5B4 \C788\C2B5\B2C8\B2E4.'),
unistr('- APEX_APPLICATION_INSTALL\C744 \D1B5\D574 \C81C\ACF5\B41C \C18D\C131\C774 \C5C6\C2B5\B2C8\B2E4.'),
'',
unistr('\B530\B77C\C11C \C791\C5C5\C601\C5ED \C6D0\ACA9 \C11C\BC84 \C124\C815\C740 \BCC0\ACBD\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('- \AE30\BCF8 URL:      %1'),
unistr('- HTTPS \D638\C2A4\D2B8:    %2'),
unistr('- ORDS \C2DC\AC04\B300: %3'),
'',
unistr('APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER\B97C \C0AC\C6A9\D558\C5EC \C18D\C131\C744 \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105882283123310170)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_3'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C6D0\ACA9 \C11C\BC84 "%0"(\C815\C801 ID)\C5D0 \B300\D55C \ACBD\ACE0:'),
'',
unistr('- PROMPT_ON_INSTALL \C18D\C131\C774 NO\B85C \C124\C815\B418\C5B4 \C788\C2B5\B2C8\B2E4.'),
unistr('- \C560\D50C\B9AC\CF00\C774\C158 \C784\D3EC\D2B8 \D30C\C77C\C758 \C124\C815\C774 \AE30\C874 \C18D\C131\ACFC \B2E4\B985\B2C8\B2E4.'),
unistr('- \C774 \C6D0\ACA9 \C11C\BC84\B294 \D574\B2F9 \C791\C5C5\C601\C5ED\C758 \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C\B3C4 \C0AC\C6A9\B429\B2C8\B2E4.'),
'',
unistr('\B530\B77C\C11C \C791\C5C5\C601\C5ED \C6D0\ACA9 \C11C\BC84 \C124\C815\C740 \BCC0\ACBD\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('- \AE30\BCF8 URL:      %1'),
unistr('- HTTPS \D638\C2A4\D2B8:    %2'),
unistr('- ORDS \C2DC\AC04\B300: %3'),
'',
unistr('APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER\B97C \C0AC\C6A9\D558\C5EC \C18D\C131\C744 \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105429791000309802)
,p_name=>'WWV_FLOW_API.REPLACE_SCRIPT_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\AFB8\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105667960503310001)
,p_name=>'WWV_FLOW_API.SAME_SOURCE_IDENTIFIER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\B4DC\BC31\C744 \B3D9\C77C\D55C \C2DC\C2A4\D15C\C73C\B85C \C784\D3EC\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105430015393309802)
,p_name=>'WWV_FLOW_API.SCRIPT_EXCEEDS_MAX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \D06C\AE30 %0\BC14\C774\D2B8\AC00 \D5C8\C6A9\B41C \CD5C\B300 \D06C\AE30\B97C \CD08\ACFC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105003685083309472)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D0A4\C9C0 \BCC0\C218 g_security_group_id\B97C \C124\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105000243816309470)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET_IMPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C744 \C784\D3EC\D2B8\D558\B824\BA74 \D328\D0A4\C9C0 \BCC0\C218 g_security_group_id\B97C \C124\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104999814642309470)
,p_name=>'WWV_FLOW_API.UNKOWN_API_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5D4\C9C4\C758 \CD5C\C885 API \BC84\C804\C744 \C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104999706022309469)
,p_name=>'WWV_FLOW_API.UNKOWN_ENGINE_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5D4\C9C4 \BC84\C804\C744 \C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104999930525309470)
,p_name=>'WWV_FLOW_API.UPGRADE_NEEDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158 \C775\C2A4\D3EC\D2B8\B97C \C784\D3EC\D2B8\D558\B824\BA74 \C5C5\ADF8\B808\C774\B4DC\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105667839873310001)
,p_name=>'WWV_FLOW_API.WRONG_DEPLOYMENT_SYSTEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BC30\CE58 \C2DC\C2A4\D15C\C5D0 \B300\D55C \D53C\B4DC\BC31\C774 \C775\C2A4\D3EC\D2B8\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104872233356309374)
,p_name=>'WWV_FLOW_AUTOMATION.CANNOT_COPY_WSM_AUTOMATION'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4\B97C \CC38\C870\D558\B294 \C790\B3D9\D654\B97C \B2E4\B978 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \BCF5\C0AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104870607441309372)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.NEW_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105048770752309505)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.PLSQL_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758 \BC18\D658 PL/SQL \D568\C218 \BCF8\BB38\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105048673487309505)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.QUERY_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B294 \D544\C218\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105048880054309505)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.REMOTE_SERVER_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \C0AC\C6A9 SQL \C11C\BE44\C2A4\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105048551891309505)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.TABLE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14 \C774\B984\C740 \D544\C218\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105048952864309505)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WEB_SRC_MODULE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105049094187309505)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WHERE_ORDERBY_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('WHERE \B610\B294 ORDER BY \C808\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105104102092309545)
,p_name=>'WWV_FLOW_BUILDER.APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105120479026309557)
,p_name=>'WWV_FLOW_BUILDER.NO_FLOW_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \C560\D50C\B9AC\CF00\C774\C158\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105104475801309545)
,p_name=>'WWV_FLOW_BUILDER.NO_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('<span class="tiny">\D398\C774\C9C0\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.</font>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105104221999309545)
,p_name=>'WWV_FLOW_BUILDER.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105104520712309545)
,p_name=>'WWV_FLOW_BUILDER.PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 <font size=-2>\D398\C774\C9C0</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105290708048309689)
,p_name=>'WWV_FLOW_BUILDER.PAGE_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C218:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105290800007309689)
,p_name=>'WWV_FLOW_BUILDER.PAGE_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105104397788309545)
,p_name=>'WWV_FLOW_BUILDER.PLSQL_LINES_SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL %0 %1\C774(\AC00) \C18C\C2A4 \CF54\B4DC\C758 %2\AC1C \D589\C744 \D3EC\D568\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105539420891309894)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.CODE_COMPLETION_NOT_SUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\ACA9 SQL\C5D0 \B300\D574\C11C\B294 \CF54\B4DC \C644\C131\C774 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105538759567309893)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.QUERY_BUILDER_NOT_SUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\ACA9 SQL\C5D0 \B300\D574\C11C\B294 \C9C8\C758 \C791\C131\AE30\AC00 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105136902959309575)
,p_name=>'WWV_FLOW_BUILDER.UPDATABLE_REPORT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BCF4\ACE0\C11C \AD6C\BB38\BD84\C11D \C624\B958: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106071869935310339)
,p_name=>'WWV_FLOW_BUTTON.REDIRECT_TO_PAGE_MODE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C0C1\C790 \D398\C774\C9C0\C5D0\C11C \C77C\BC18 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105108839037309548)
,p_name=>'WWV_FLOW_CACHE.OBSOLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105108758828309548)
,p_name=>'WWV_FLOW_CACHE.PURGE_DUP_SESSIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \C911\BCF5\B41C \C138\C158\C774 \BE44\C6CC\C84C\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105077107669309525)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_CHG_ONLY_YOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\C2E0\C758 \BE44\BC00\BC88\D638\B9CC \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105077392722309526)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638 \BCC0\ACBD \C694\CCAD\C744 \CC98\B9AC\D558\B294 \C911 \C608\C0C1\CE58 \C54A\C740 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105076801789309525)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NOT_SUPPLIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638 \BC0F \D655\C778\C6A9 \BE44\BC00\BC88\D638\B294 \BC18\B4DC\C2DC \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105076965079309525)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NO_MATCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\AC00 \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \B2E4\C2DC \C2DC\B3C4\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105077987756309526)
,p_name=>'WWV_FLOW_CHECK.ERR_ORCL'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle \C624\B958: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105077683271309526)
,p_name=>'WWV_FLOW_CHECK.ERR_PROC_PLSQL'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1025 PLSQL \D45C\D604\C2DD\C744 \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104968545611309447)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \BA64\BC84 \C18D\C131 \BC88\D638 %0\C740(\B294) \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105109288673309549)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_EXISTS_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C870\AC74\C774 \C874\C7AC\D558\AC70\B098 \C870\AC74\C774 \C874\C7AC\D558\C9C0 \C54A\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105109042622309548)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_FUNC_BODY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \D568\C218 \BCF8\BB38 \C870\AC74: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105108968943309548)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_PLSQL_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C PL/SQL \D45C\D604\C2DD \C870\AC74: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105109146215309548)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_SQL_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C SQL \D45C\D604\C2DD \C870\AC74: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105123388467309562)
,p_name=>'WWV_FLOW_COPY.EXECUTION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('wwv_flow_copy\B97C \C2E4\D589\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104858360899309361)
,p_name=>'WWV_FLOW_COPY.INVALID_TRANSLATED_APPLICATION_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\D658\B41C \C560\D50C\B9AC\CF00\C774\C158 ID\AC00 \BD80\C801\D569\D569\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158 ID\B97C \AE30\C874 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C6A9 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105123218017309562)
,p_name=>'WWV_FLOW_COPY.NO_SGID_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548 \ADF8\B8F9 ID(\C791\C5C5\C601\C5ED ID)\AC00 \C124\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105410945183309780)
,p_name=>'WWV_FLOW_COPY_METADATA.COMPATIBILITY_MODE_210200'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8\B97C \C0C8\B85C\ACE0\CE68\D558\B824\BA74 \C560\D50C\B9AC\CF00\C774\C158 "%0" \D638\D658\C131 \BAA8\B4DC\AC00 21.2 \C774\C0C1\C774\C5B4\C57C \D569\B2C8\B2E4. [\C18D\C131] \C544\B798\C758 [\C560\D50C\B9AC\CF00\C774\C158 \C815\C758]\C5D0\C11C \D638\D658\C131 \BAA8\B4DC\B97C \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106107661035310372)
,p_name=>'WWV_FLOW_COPY_METADATA.INCOMPATIBLE_THEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D14C\B9C8\B294 \C120\D0DD\B41C \B9C8\C2A4\D130 \D14C\B9C8\C640 \D638\D658\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \D14C\B9C8 \C2DD\BCC4\C790\AC00 \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105536322989309891)
,p_name=>'WWV_FLOW_COPY_METADATA.PARENT_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8\B97C \C0C8\B85C\ACE0\CE68\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C0C1\C704 \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104976532454309452)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_AUTH_SETUP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C778\C99D \CCB4\ACC4\B97C \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104975926915309452)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2E8\CD94 \D15C\D50C\B9AC\D2B8\B97C \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105130172879309570)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_CAL_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2EC\B825 \D15C\D50C\B9AC\D2B8\B97C \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104975725142309452)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\B4DC \D15C\D50C\B9AC\D2B8\B97C \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104976610374309453)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_ITEM_HELP'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D56D\BAA9 \B3C4\C6C0\B9D0\C744 \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104975509790309452)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D15C\D50C\B9AC\D2B8\B97C \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104976431065309452)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LOV'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\AC12 \BAA9\B85D\C744 \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104976086638309452)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_MENU_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8\B97C \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104976302179309452)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_NAVBAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904\C744 \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104975370764309452)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B97C \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104975824350309452)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D \D15C\D50C\B9AC\D2B8\B97C \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104975462098309452)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D15C\D50C\B9AC\D2B8\B97C \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104975666827309452)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\B97C \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104976116075309452)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SECURITY_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548 \CCB4\ACC4\B97C \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104976284452309452)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SHORTCUT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2E8\CD95\D0A4\B97C \AC8C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104973753679309450)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_AUTH_SETUP_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4 \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104972601340309450)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_BUTTON_TEMPLATE_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D15C\D50C\B9AC\D2B8 \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105130042569309570)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_CAL_TEMPLATE_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2EC\B825 \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104971995540309449)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_FIELD_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\B4DC \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104973893261309450)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_ITEM_HELP_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \B3C4\C6C0\B9D0 \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104971778483309449)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LIST_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104972339753309449)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LOV_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104972535879309449)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_MENU_TEMPLATE_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8 \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104972215398309449)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_NAVBAR_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904 \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104971583608309449)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_PAGE_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104972405000309449)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_POPUP_LOV_TEMPLATE_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D \D15C\D50C\B9AC\D2B8 \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104971655006309449)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REGION_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104971887169309449)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REPORT_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104972015338309449)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SECURITY_SCHEME_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548 \CCB4\ACC4 \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104972105081309449)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SHORTCUT_REFERENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4 \CC38\C870 ID\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104975199784309451)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_AUTH_SETUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104974622914309451)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_BUTTON_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106067449054310335)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_CAL_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2EC\B825 \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104974355576309451)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_FIELD_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\B4DC \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104975282680309452)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_ITEM_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \B3C4\C6C0\B9D0\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104974174339309451)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LIST_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104975004183309451)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104974592796309451)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_MENU_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104974922805309451)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_NAVBAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104973961681309451)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_PAGE_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104974495340309451)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_POPUP_LOV_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104974043624309451)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REGION_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104974253975309451)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REPORT_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104974785443309451)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SECURITY_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548 \CCB4\ACC4\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104974873398309451)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SHORTCUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4\C5D0 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106046536390310315)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_THEME_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C635\C158\C744 \C801\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105137463145309575)
,p_name=>'WWV_FLOW_COPY_PAGE.EXECUTION_PAGE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('wwv_flow_copy_page\B97C \C2E4\D589\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105123543274309562)
,p_name=>'WWV_FLOW_COPY_PAGE_ITEM.EXECUTION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('wwv_flow_copy_page_item\C744 \C2E4\D589\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104996535444309467)
,p_name=>'WWV_FLOW_COPY_UTIL.OBJ_NOT_FOUND_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC\D560 %0(%1)\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105323870366309716)
,p_name=>'WWV_FLOW_COPY_UTIL.SHORTCUT_NAME_UNAVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 %0\C778 \B2E8\CD95\D0A4\AC00 \C874\C7AC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105123964709309562)
,p_name=>'WWV_FLOW_COPY_UTIL.UNABLE_TO_FIND_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC\D560 \B2E8\CD95\D0A4(%0)\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105124927531309566)
,p_name=>'WWV_FLOW_CREATE_FLOW.CREATE_RPT_TEMPLATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8 \C0DD\C131)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105125508061309567)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COMPUTE_TAB_TARGET_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\D0ED \B300\C0C1 \C218 \ACC4\C0B0)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105128846436309569)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHENTICATION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\C778\C99D \CCB4\ACC4 \BCF5\C0AC)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105128714019309569)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHORIZATION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\AD8C\D55C \BD80\C5EC \CCB4\ACC4 \BCF5\C0AC)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105126388152309567)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_BUTTON_TEMPLATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\B2E8\CD94 \D15C\D50C\B9AC\D2B8 \BCF5\C0AC)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105125884119309567)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_FIELD_TEMPLATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\D544\B4DC \D15C\D50C\B9AC\D2B8 \BCF5\C0AC)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105126181393309567)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LIST_TEMPLATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\BAA9\B85D \D15C\D50C\B9AC\D2B8 \BCF5\C0AC)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105126569383309568)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LOV_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\AC12 \BAA9\B85D \BCF5\C0AC)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105126227722309567)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_MENU_TEMPLATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8 \BCF5\C0AC)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105126402349309567)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_NAVBAR_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\D0D0\C0C9\D45C\C2DC\C904 \BCF5\C0AC)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105125753918309567)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_PAGE_TEMPLATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8 \BCF5\C0AC)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105126017887309567)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REGION_TEMPLATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\C601\C5ED \D15C\D50C\B9AC\D2B8 \BCF5\C0AC)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105125960921309567)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REPORT_TEMPLATES_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8 \BCF5\C0AC)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105126694848309568)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_SECURITY_SCHEME_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\BCF4\C548 \CCB4\ACC4 \BCF5\C0AC)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105124899099309566)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_FIELD_TEMPLATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\D544\B4DC \D15C\D50C\B9AC\D2B8 \C0DD\C131)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105125104586309566)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_LIST_TEMPLATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\BAA9\B85D \D15C\D50C\B9AC\D2B8 \C0DD\C131)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105125208087309567)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_MENU_TEMPLATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8 \C0DD\C131)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105124620622309562)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PAGE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\D398\C774\C9C0 \C0DD\C131)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105125616053309567)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PARENT_TABS_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\C0C1\C704 \D0ED \C0DD\C131)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105124753976309563)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PG_TEMPLATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8 \C0DD\C131)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105125348996309567)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_POPUP_TEMPLATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\D31D\C5C5 \AC12 \BAA9\B85D \D15C\D50C\B9AC\D2B8 \C0DD\C131)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105125001263309566)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_REGION_TEMPLATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\C601\C5ED \D15C\D50C\B9AC\D2B8 \C0DD\C131)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105125493177309567)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_STANDARD_TABS_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158(\D45C\C900 \D0ED \C0DD\C131)\C744 \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105124592469309562)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.VERIFY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D655\C778 \C624\B958: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105323612051309715)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.ADD_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105323552266309715)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRD'
,p_message_language=>'ko'
,p_message_text=>unistr('MRD \C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105323496448309715)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRU'
,p_message_language=>'ko'
,p_message_text=>unistr('MRU \C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105310717867309705)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105388497951309764)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_FORM_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105414921681309789)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_GLOBAL_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C5ED \D398\C774\C9C0\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105899394154310184)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_IG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC \D398\C774\C9C0\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105388666046309764)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C0DD\C131 \C624\B958\C785\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105388573036309764)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_TABULAR_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C \D615\C2DD \D3FC \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105388754457309764)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.FETCH_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0\C11C \D589 \C778\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105432135850309804)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.GET_USERNAME_COOKIE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984 \CFE0\D0A4 \AC00\C838\C624\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105528119457309885)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.MENUBAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \BA54\B274')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105388087980309763)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\B274 \D398\C774\C9C0 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105388838784309764)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.PROCESS_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C758 \D589 \CC98\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105477155485309841)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RELEASE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B9B4\B9AC\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105316373345309710)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_HIDDEN_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\ACA8\C9C4 \D56D\BAA9 \C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105309865569309704)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_RPT_SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \AC80\C0C9 \C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105404638919309776)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RPT_MAX_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B2F9 \D589 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105400767933309773)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RUNNING_SCRIPT_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \C911\C778 \C2A4\D06C\B9BD\D2B8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105432089870309803)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.SET_USERNAME_COOKIE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984 \CFE0\D0A4 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105317567403309711)
,p_name=>'WWV_FLOW_CREDENTIAL.INVALID_CONTEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D504\B85C\C2DC\C800\B294 \C560\D50C\B9AC\CF00\C774\C158 \C138\C158 \B0B4\C5D0\C11C \D638\CD9C\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104879205630309380)
,p_name=>'WWV_FLOW_CREDENTIAL.NOT_VALID_FOR_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\C11C\B97C \C774 URL \B05D\C810\C5D0 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104872767537309374)
,p_name=>'WWV_FLOW_CREDENTIAL.URL_MUST_START_WITH_HTTP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D\C758 URL\C740 http:// \B610\B294 https://\B85C \C2DC\C791\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105418041756309792)
,p_name=>'WWV_FLOW_CREDENTIAL_DEV.CREDENTIALS_FOR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \C778\C99D\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105126872118309568)
,p_name=>'WWV_FLOW_CSS_API.UNABLE_TO_REMOVE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('CSS\B97C \C81C\AC70\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105432774972309804)
,p_name=>'WWV_FLOW_CSS_CALENDAR.DRAG_DROP_NOT_SUPPORTED_FOR_WEB_SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4\C5D0 \B300\D574\C11C\B294 \B04C\C5B4 \B193\AE30\AC00 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105108352488309548)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_APPLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104989832826309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION1'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AC10\C2DC \D568\C218\B294 \B0B4\C7A5 \C138\C158 \D655\C778 \AC80\C0AC\C5D0 \B300\D55C \BD80\C6B8 \ACB0\ACFC\B97C \C5D4\C9C4\C5D0 \BC18\D658\D569\B2C8\B2E4. \ACB0\ACFC\AC00 True\C774\BA74 \C5D4\C9C4\C740 \ACC4\C18D \D398\C774\C9C0\B97C \D45C\C2DC\D558\AC70\B098 \D5C8\C6A9\D569\B2C8\B2E4. \ACB0\ACFC\AC00 False\C774\BA74 \C5D4\C9C4\C740 \C774 \C778\C99D \CCB4\ACC4\C5D0 \C9C0\C815\B41C \BD80\C801\D569\D55C \C138\C158 \D398\C774\C9C0 \B610\B294 URL\B85C \C7AC\C9C0\C815\B429\B2C8\B2E4. (\C544\B798 \CC38\C870)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104991101149309463)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION10'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AC10\C2DC \D568\C218\AC00 TRUE\B97C \BC18\D658\D558\BA74 \D398\C774\C9C0 \B80C\B354\B9C1 \B610\B294 \D504\B85C\C138\C2F1\C774 \ACC4\C18D\B429\B2C8\B2E4. \ACB0\ACFC\AC00 FALSE\C774\BA74 \C778\C99D \CCB4\ACC4\C5D0 \BD80\C801\D569\D55C \C138\C158 \B300\C0C1\C774 \C9C0\C815\B418\C9C0 \C54A\C558\C73C\BBC0\B85C \C5D4\C9C4\C744 \C885\B8CC\D574\C57C \D569\B2C8\B2E4. \C774 \ACBD\C6B0, \C0AC\C6A9\C790 \C81C\ACF5 \D398\C774\C9C0 \AC10\C2DC \D568\C218\B294 %0 \D658\ACBD \C678\BD80\C758 \B85C\ADF8\C778 \D398\C774\C9C0(\C678\BD80 \C778\C99D \D3EC\D138\C77C \C218\B3C4 \C788\C74C)\C5D0 \C7AC\C9C0\C815\B41C \AC83\C73C\B85C \AC04\C8FC\D569\B2C8\B2E4. \D574\B2F9 \D568\C218\B294 \B610\D55C \C804\C5ED \BCC0\C218 g_unrecoverable_error\B97C true\B85C \C124\C815\D558\C5EC \C5D4\C9C4\C774 \C624\B958 \D398\C774\C9C0\B97C \D45C\C2DC\D558\C9C0 \C54A\C740 \CC44 ')
||unistr('\C885\B8CC\D558\B3C4\B85D \C9C0\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104991267597309463)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION11'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5D4\C9C4\C740 \C774 \C778\C99D \CCB4\ACC4\C758 \C0AC\C804 \C778\C99D \D504\B85C\C138\C2A4\B85C \C9C0\C815\B418\B294 \B2E4\C74C \CF54\B4DC\B97C \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104991331298309463)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION12'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C744 \BC18\D658\D558\C9C0 \C54A\B294 \C775\BA85 \BE14\B85D\C73C\B85C \C2E4\D589\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104991452051309463)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION13'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CCB4\ACC4\C5D0 \C9C0\C815\B41C \C0AC\C6A9\C790\C815\C758 \C0AC\C804 \C778\C99D \CF54\B4DC\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104991692829309463)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION14'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 \D3FC\C5D0 \C785\B825\B41C \BAA8\B4E0 \C0AC\C6A9\C790 \C774\B984/\BE44\BC00\BC88\D638 \C870\D569\C740 \C801\D569\D55C \AC83\C73C\B85C \AC04\C8FC\B429\B2C8\B2E4. \C785\B825\B41C \C0AC\C6A9\C790 \C774\B984\C740 \C138\C158 \C218\BA85 \B3D9\C548 \B85C\ADF8\C778 \C0AC\C6A9\C790 \C774\B984\C73C\B85C \C0AC\C6A9\B429\B2C8\B2E4. \C774 \AE30\C220\C740 \C2E4\C81C \C0AC\C6A9\C790 \ACC4\C815\C774 \C124\C815\B418\AE30 \C804\C5D0 \C560\D50C\B9AC\CF00\C774\C158\C744 \AC1C\BC1C\D558\B294 \B3D9\C548 \C720\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104991741124309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 \D3FC\C5D0 \C785\B825\B41C \C0AC\C6A9\C790 \C774\B984\ACFC \BE44\BC00\BC88\D638\B97C \C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30(\CFE0\D0A4 \C0AC\C6A9\C790) \ACC4\C815\ACFC \BE44\AD50\D558\C2ED\C2DC\C624. \C774\B7EC\D55C \ACC4\C815\C740 %0\C5D0 \B85C\ADF8\C778\D558\AE30 \C704\D574 \C791\C5C5\C601\C5ED\C5D0 \C0AC\C6A9\B418\B294 \ACC4\C815\ACFC \B3D9\C77C\D569\B2C8\B2E4. \C774 \AE30\C220\C740 \C560\D50C\B9AC\CF00\C774\C158 \C0AC\C6A9\C790\AC00 \AC1C\BC1C\C790\B85C\C11C \B3D9\C77C\D55C \B370\C774\D130\BCA0\C774\C2A4\C640 \C791\C5C5\C601\C5ED\C5D0 %0 \ACC4\C815\C744 \AC00\C9C0\ACE0 \C788\B294 \ACBD\C6B0\C5D0 \C720\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104924055719309414)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15A'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle \B370\C774\D130\BCA0\C774\C2A4 \ACC4\C815\C5D0 \B300\D574 \B85C\ADF8\C778 \D3FC\C5D0 \C785\B825\B41C \C0AC\C6A9\C790 \C774\B984 \BC0F \BE44\BC00\BC88\D638\B97C \D655\C778\D558\C2ED\C2DC\C624. \C774 \AE30\C220\C740 \C560\D50C\B9AC\CF00\C774\C158 \C0AC\C6A9\C790\AC00 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \ACC4\C815\C744 \AC00\C9C0\ACE0 \C788\B294 \ACBD\C6B0\C5D0 \C720\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104991846114309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION16'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C778\C99D \CCB4\ACC4\C5D0 \C9C0\C815\B41C LDAP \B514\B809\D1A0\B9AC\B97C \C0AC\C6A9\D558\C5EC \B85C\ADF8\C778 \D3FC\C5D0 \C785\B825\B41C \C0AC\C6A9\C790 \C774\B984 \BC0F \BE44\BC00\BC88\D638\B97C \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104991913693309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION17'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C73C\B85C LDAP \B9E4\AC1C\BCC0\C218 \C124\C815:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104992696201309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION18'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C0AC\C6A9\C790\C815\C758 \CF54\B4DC\B97C \C2E4\D589\D558\C5EC \C99D\BA85\C11C \D655\C778:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104992865949309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION19'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \C138\C158 \D14C\C774\BE14\C5D0 \B0B4\C7A5 \B85C\ADF8\C778 \D398\C774\C9C0\C5D0 \C0AC\C6A9\B418\B294 \C138\C158\C774 \C788\B294\C9C0 \D655\C778\D558\C2ED\C2DC\C624. \D574\B2F9 \C138\C158\C774 \C874\C7AC\D558\ACE0 \B2E4\B978 \C0AC\C6A9\C790\AC00 \C18C\C720\D558\C9C0 \C54A\C740 \ACBD\C6B0, \B85C\ADF8\C778 \D3FC\C758 \C0AC\C6A9\C790 \C774\B984\C744 \C0AC\C6A9\D558\C5EC \C778\C99D\B41C \C0AC\C6A9\C790\AC00 \C774\C81C \D574\B2F9 \C138\C158\C744 \C18C\C720\D558\B294 \AC83\C73C\B85C \D45C\C2DC\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104989955117309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION2'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AC10\C2DC \D568\C218\B294 \B0B4\C7A5 \C138\C158 \D655\C778 \AC80\C0AC\C640 \C0AC\C6A9\C790 \C81C\ACF5 \C138\C158 \D655\C778 \AC80\C0AC\AC00 AND\B85C \ACB0\D569\B41C \BD80\C6B8 \ACB0\ACFC\B97C \C5D4\C9C4\C5D0 \BC18\D658\D569\B2C8\B2E4. \ACB0\ACFC\AC00 True\C774\BA74 \C5D4\C9C4\C740 \ACC4\C18D \D398\C774\C9C0\B97C \D45C\C2DC\D558\AC70\B098 \D5C8\C6A9\D569\B2C8\B2E4. \ACB0\ACFC\AC00 False\C774\BA74 \C5D4\C9C4\C740 \C774 \C778\C99D \CCB4\ACC4\C5D0 \C9C0\C815\B41C \BD80\C801\D569\D55C \C138\C158 \B300\C0C1\C73C\B85C \C7AC\C9C0\C815\B429\B2C8\B2E4. (\C544\B798 \CC38\C870)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104992915317309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION20'
,p_message_language=>'ko'
,p_message_text=>unistr('%0(\C774)\B77C\B294 \CFE0\D0A4\B97C \B0B4\BD80 \C138\C158 \D14C\C774\BE14\C5D0\C11C \D589\C744 \CC3E\B294 \AC12\C73C\B85C \C124\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104993069287309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION22'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \D398\C774\C9C0\B85C \C7AC\C9C0\C815\B420 URL\C744 \ACB0\C815\D558\C2ED\C2DC\C624. \B80C\B354\B9C1 \C5D4\C9C4\C5D0 \C758\D574 "\B525 \B9C1\D06C"\AC00 \C138\C158 \C0C1\D0DC\C5D0 \AE30\B85D\B41C \ACBD\C6B0 \D574\B2F9 \B9C1\D06C\B97C \C774\B3D9\D560 URL\B85C \C0AC\C6A9\D558\C2ED\C2DC\C624. \ADF8\B807\C9C0 \C54A\C73C\BA74 \C560\D50C\B9AC\CF00\C774\C158\C758 \D648 \B9C1\D06C \C18D\C131\C73C\B85C \C9C0\C815\B41C URL\B85C \C774\B3D9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104993261836309465)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION23'
,p_message_language=>'ko'
,p_message_text=>unistr('\C99D\BA85\C11C \D655\C778 \D6C4 \C5D4\C9C4\C740 \C774 \C778\C99D \CCB4\ACC4\C758 \C0AC\D6C4 \C778\C99D \D504\B85C\C138\C2A4\B85C \C9C0\C815\B418\B294 \B2E4\C74C \CF54\B4DC\B97C \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104993364681309465)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION24'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C744 \BC18\D658\D558\C9C0 \C54A\B294 \C775\BA85 \BE14\B85D\C73C\B85C \C2E4\D589\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104993440070309465)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION25'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CCB4\ACC4\C5D0 \C9C0\C815\B41C \C0AC\C6A9\C790\C815\C758 \C0AC\D6C4 \C778\C99D \CF54\B4DC\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104993522147309465)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION26'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\C5D0\C11C \ACB0\C815\D55C URL\B85C \C7AC\C9C0\C815\D558\C2ED\C2DC\C624. URL\C774 \D638\CD9C\D558\B294 \B0B4\C7A5 \B85C\ADF8\C778 \D398\C774\C9C0 \BC0F API\B97C \C0AC\C6A9\D558\C5EC \B85C\ADF8\C778 \D504\B85C\C138\C2F1 \B05D\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104990038441309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION3'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \B17C\B9AC\B97C \C0AC\C6A9\D558\C5EC \D398\C774\C9C0 \AC10\C2DC \C791\C5C5\C744 \C218\D589\D569\B2C8\B2E4. \AC01 \D398\C774\C9C0 \C694\CCAD\C5D0 \B300\D574 \C5D4\C9C4\C740 \B2E4\C74C \CF54\B4DC\B97C \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104990180407309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION4'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704 \BE14\B85D\C5D0 \B300\D55C \BD80\C6B8 \ACB0\ACFC\AC00 \C5D4\C9C4\C5D0 \BC18\D658\B429\B2C8\B2E4. \ACB0\ACFC\AC00 True\C774\BA74 \C5D4\C9C4\C740 \ACC4\C18D \D398\C774\C9C0\B97C \D45C\C2DC\D558\AC70\B098 \D5C8\C6A9\D569\B2C8\B2E4. \ACB0\ACFC\AC00 False\C774\BA74 \C5D4\C9C4\C740 \C774 \C778\C99D \CCB4\ACC4\C5D0 \C9C0\C815\B41C \BD80\C801\D569\D55C \C138\C158 \B300\C0C1\C73C\B85C \C7AC\C9C0\C815\B429\B2C8\B2E4. (\C544\B798 \CC38\C870)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104990297785309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION5'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \D655\C778\C744 \C704\D55C \B0B4\C7A5 \BA54\C18C\B4DC\B294 API \D638\CD9C\C744 \C0AC\C6A9\D558\B294 %0 \AC1C\BC1C\C790\C5D0\AC8C \C81C\ACF5\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104990356882309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION6'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BD80\C6B8 \D568\C218 \ACB0\ACFC\B294 \C778\C99D \CCB4\ACC4\C5D0 \C9C0\C815\B41C \C0AC\C6A9\C790 \C81C\ACF5 \D398\C774\C9C0 \AC10\C2DC \D568\C218\C5D0\C11C \B2E4\B978 \AC80\C0AC\C640 \C870\D569\B420 \C218 \C788\C2B5\B2C8\B2E4. \C774 API\B294 \D638\CD9C\B418\BA74 %0(\C774)\B77C\B294 \CFE0\D0A4\B97C \AC80\C0AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104990418145309463)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION7'
,p_message_language=>'ko'
,p_message_text=>unistr('\CFE0\D0A4\AC00 \C874\C7AC\D558\ACE0 \B514\CF54\B4DC\B41C \AC12\C774 \B0B4\BD80 \C138\C158 \D14C\C774\BE14\C5D0\C11C \D589\C744 \CC3E\C544\B0B4\BA74 \C138\C158\C740 \C801\D569\D55C \AC83\C73C\B85C \AC04\C8FC\B418\ACE0, TRUE \AC12\C774 \D638\CD9C\D55C \D398\C774\C9C0 \AC10\C2DC \D568\C218\C5D0 \BC18\D658\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104990623108309463)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION8'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AC10\C2DC \D568\C218\AC00 TRUE\B97C \BC18\D658\D558\BA74 \D398\C774\C9C0 \B80C\B354\B9C1 \B610\B294 \D504\B85C\C138\C2F1\C774 \ACC4\C18D\B429\B2C8\B2E4. \ACB0\ACFC\AC00 FALSE\C774\BA74 \C5D4\C9C4\C740 %0 \D398\C774\C9C0\B97C \D45C\C2DC\D569\B2C8\B2E4. \C774 \D398\C774\C9C0\B294 \C774 \C778\C99D \CCB4\ACC4\C5D0 \C9C0\C815\B41C \C0AC\D56D\C744 \AE30\BC18\C73C\B85C \D558\B294 \C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \B85C\ADF8\C778 \D398\C774\C9C0\B97C \BD80\C801\D569\D55C \C138\C158 \D398\C774\C9C0\B85C \AC04\C8FC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104991012382309463)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION9'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AC10\C2DC \D568\C218\B294 \BD80\C6B8 \ACB0\ACFC\B97C \C5D4\C9C4\C5D0 \BC18\D658\D569\B2C8\B2E4. \ACB0\ACFC\AC00 TRUE\C774\BA74 \D398\C774\C9C0 \B80C\B354\B9C1 \B610\B294 \D504\B85C\C138\C2F1\C774 \ACC4\C18D\B429\B2C8\B2E4. \ACB0\ACFC\AC00 FALSE\C774\BA74 \C5D4\C9C4\C740 %0(\C73C)\B85C \C7AC\C9C0\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104993619618309465)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18\C801\C778 \C811\ADFC \BC29\BC95\C740 \D398\C774\C9C0\C5D0 \C0AC\C6A9\C790 \C99D\BA85\C11C\B97C \CEA1\CC98\D558\B294 \B85C\ADF8\C778 \D3FC\C774 \D3EC\D568\B418\B3C4\B85D \D558\B294 \AC83\C785\B2C8\B2E4. \ADF8\B7EC\BA74 \D398\C774\C9C0\C758 \C81C\CD9C \D6C4 \D504\B85C\C138\C2A4\AC00 \C99D\BA85\C11C\B97C \D655\C778\D558\B294 \C778\C99D \BAA8\B4C8\C744 \D638\CD9C\D569\B2C8\B2E4. \C778\C99D \D6C4\C5D0\B294 \D398\C774\C9C0\C5D0\C11C \C138\C158 \B4F1\B85D \BC0F \CFE0\D0A4 \C124\C815 \C791\C5C5\C774 \C218\D589\B429\B2C8\B2E4. \CD5C\C885\C801\C73C\B85C \D574\B2F9 \D398\C774\C9C0\AC00 \C560\D50C\B9AC\CF00\C774\C158\C758 \C2DC\C791 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104993756901309465)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON2'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 API: wwv_flow_custom_auth_std\B294 \C81C\CD9C \D6C4 \D504\B85C\C138\C2A4\C5D0 \C758\D574 \D638\CD9C\B418\C5B4 \BC29\AE08 \C124\BA85\D55C \D574\B2F9 \B2E8\ACC4 \C911 \D558\B098\B97C \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4. \B2E4\C74C \B450 \AC1C\C758 \C2DC\C791\C810\C774 \C0AC\C6A9 \AC00\B2A5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104993879516309465)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON3'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5D4\C9C4\C774 \BAA8\B4E0 \B2E8\ACC4\B97C \C218\D589\D558\B3C4\B85D \B85C\ADF8\C778 \D504\B85C\C2DC\C800\B97C \D638\CD9C\D558\C2ED\C2DC\C624. \C5D4\C9C4\C740 \B0B4\C7A5 \C138\C158 \D14C\C774\BE14\C744 \C0AC\C6A9\D558\BA70, \C138\C158 \B4F1\B85D \BC0F \CFE0\D0A4 \C124\C815 \C791\C5C5\C744 \C218\D589\D569\B2C8\B2E4. \C0AC\C6A9\C790\AC00 \C774 \C778\C99D \CCB4\ACC4\C5D0 \C81C\ACF5\D558\B294 \C0AC\C6A9\C790\C815\C758 \CF54\B4DC\B294 \C778\C99D \C804, \C778\C99D \C2DC \B610\B294 \C778\C99D \D6C4\C5D0 \C2E4\D589\B429\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104993934121309465)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON4'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C790\C2E0\C744 \C778\C99D\D558\B418, %0\C774(\AC00) \BAA8\B4E0 \C0AC\D6C4 \C778\C99D \C791\C5C5\C744 \CC98\B9AC\D558\B3C4\B85D \D558\B824\B294 \ACBD\C6B0, post_login \D504\B85C\C2DC\C800\B97C \D638\CD9C\D558\C2ED\C2DC\C624. \C774\B7EC\D55C \B450 \AC1C\C758 \C2DC\C791\C810\C744 \C0AC\C6A9\D558\B294 \ACBD\C6B0, \B0B4\C7A5 \B85C\ADF8\C778 \D504\B85C\C138\C2F1 \B2E8\ACC4\B97C \ACE0\C720 \B85C\ADF8\C778 \D398\C774\C9C0 \BC0F \C774 \D398\C774\C9C0\C5D0\C11C \C2E4\D589\B418\B294 \C784\C758\C758 \D504\B85C\C138\C2A4\C640 \ACB0\D569\D558\C5EC \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \B0B4\C7A5 \C0AC\D6C4 \C778\C99D \D504\B85C\C138\C2F1\C744 \C0AC\C6A9\D558\B294 \ACBD\C6B0, \B0B4\C7A5 \D398\C774\C9C0 \AC10\C2DC\C640 \C138\C158 \D655\C778 \D504\B85C\C138\C2F1\B3C4 \D65C\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104990769149309463)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.BUILTIN_LOGIN_PG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \B85C\ADF8\C778 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104994059382309465)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C678\BD80 \B85C\ADF8\C778 \D504\B85C\C138\C2F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104994817425309466)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN12'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 URL %0\C740(\B294) %1 \C560\D50C\B9AC\CF00\C774\C158 \D398\C774\C9C0\B97C \BD80\C801\D569\D55C \C138\C158 \B300\C0C1\C73C\B85C \C9C0\C815\D55C \AC83\C73C\B85C \B098\D0C0\B098\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \B610\D55C \C778\C99D \CCB4\ACC4\C5D0 \B85C\ADF8\C778 \D504\B85C\C138\C2F1 \AC12\C774 \C5C6\C2B5\B2C8\B2E4. \C774 \D398\C774\C9C0\C5D0\C11C\B294 \B2E4\C74C \B2E8\ACC4\B97C \C218\D589\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104994969872309466)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN13'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 URL\C5D0\C11C \D638\CD9C\B41C \C11C\BE44\C2A4\AC00 %0 wwv_custom_auth_std API\B97C \C0AC\C6A9\D558\C5EC \C138\C158 \B4F1\B85D \C791\C5C5\C744 \C9C0\C6D0\D558\C9C0 \C54A\C73C\BA74 \C560\D50C\B9AC\CF00\C774\C158\C740 \B0B4\C7A5 \D398\C774\C9C0 \AC10\C2DC \B610\B294 \C138\C158 \D655\C778 \D504\B85C\C138\C2A4\B97C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \B530\B77C\C11C \C774 \C791\C5C5\C740 \AC01\C790\AC00 \BC29\BC95\C744 \ACE0\C548\D558\C5EC \C218\D589\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104995263630309466)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN14'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 URL %0\C740(\B294) %1 \C560\D50C\B9AC\CF00\C774\C158 \D398\C774\C9C0\B97C \BD80\C801\D569\D55C \C138\C158 \B300\C0C1\C73C\B85C \C9C0\C815\D55C \AC83\C73C\B85C \B098\D0C0\B098\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \C774 \D398\C774\C9C0\C5D0\C11C\B294 \B2E4\C74C \B2E8\ACC4\B97C \C218\D589\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104995314238309466)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN15'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4\C758 \B85C\ADF8\C778 \D504\B85C\C138\C2F1\C5D0 \B300\D574 \C124\C815\B41C \AC12\C774 \C544\B798\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104995472937309466)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN16'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CCB4\ACC4\C5D0 \C9C0\C815\B41C \B85C\ADF8\C778 \D398\C774\C9C0\B294 \C774 \C560\D50C\B9AC\CF00\C774\C158\C758 [%0] \D398\C774\C9C0\C785\B2C8\B2E4. \C774 \D398\C774\C9C0\C5D0\C11C\B294 \B2E4\C74C \B2E8\ACC4\B97C \C218\D589\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104995577788309466)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN17'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C9C0\B9CC \C778\C99D \CCB4\ACC4\C5D0 \B85C\ADF8\C778 \D504\B85C\C138\C2F1 \AC12\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104995604687309466)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN18'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D398\C774\C9C0\B294 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D574 \C9C0\C815\B41C \B85C\ADF8\C778 \D398\C774\C9C0\C774\BBC0\B85C, \CC98\C74C \D45C\C2DC\B420 \B54C \D574\B2F9 \D398\C774\C9C0\C5D0\C11C \D2B9\C815 \C791\C5C5\C744 \C218\D589\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C0AC\C6A9\C790 \C778\C99D\C774 \C544\C9C1 \C218\D589\B418\C9C0 \C54A\C558\AE30 \B54C\BB38\C785\B2C8\B2E4. \B610\D55C \D2B9\C815 \C138\C158 \C0C1\D0DC \BC0F \C138\C158 \C2DD\BCC4 \BCC0\C218\B294 \C778\C99D \D6C4 \CC98\B9AC\B418\B294 \C77C\BC18 \D398\C774\C9C0\C5D0 \C788\AE30 \B54C\BB38\C5D0 \D398\C774\C9C0 \ACC4\C0B0 \B610\B294 \D504\B85C\C138\C2A4\C5D0 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C774\B7EC\D55C \C774\C720\B85C \C778\D574 \C778\C99D \CCB4\ACC4\C5D0\C11C \B85C\ADF8\C778 \D398\C774\C9C0\B97C \D398\C774\C9C0 \BC88\D638\BCC4\B85C \C9C0\C815\D558\B294 \AC83\C740 \B85C\ADF8\C778 \D3FC \D504\B85C\C138\C2F1 \C774\C678\C758 \AE30\B2A5\C774 \C804\D600 \C5C6\AC70\B098 \AC70\C758 \C5C6')
||unistr('\B294 \D398\C774\C9C0\C5D0\B9CC \C801\D569\D569\B2C8\B2E4. \B85C\ADF8\C778 \D398\C774\C9C0\B97C \BCF4\B2E4 \B3D9\C801\C73C\B85C \B9CC\B4E4\BA74 \C778\C99D \CCB4\ACC4 \B9C8\BC95\C0AC \B610\B294 \D3B8\C9D1 \D398\C774\C9C0\C5D0\C11C \B85C\ADF8\C778 URL \C9C0\C815\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624. \C0DD\C131\AE30\C758 \D398\C774\C9C0 \C18D\C131 \D3FC\C744 \C0AC\C6A9\D558\C5EC \ACF5\C6A9 \D398\C774\C9C0 \C18D\C131\C744 ''\C608 - \ACF5\C6A9 \D398\C774\C9C0''\B85C \C124\C815\D558\BA74'),
unistr('\B85C\ADF8\C778 \D398\C774\C9C0\B294 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \B85C\ADF8\C778 \D398\C774\C9C0 \C5ED\D560\C744 \C218\D589\D560 \BFD0\B9CC \C544\B2C8\B77C %0\C758 \BAA8\B4E0 \AE30\B2A5\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104994121694309465)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C778\C99D \CCB4\ACC4\B294 \BD80\C801\D569\D55C \C138\C158 \B300\C0C1\C5D0 \C0AC\C6A9\B418\B294 \B85C\ADF8\C778 \D398\C774\C9C0 \B610\B294 URL\C744 \C9C0\C815\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \C774\B294 \D398\C774\C9C0 \AC10\C2DC \D568\C218\B97C \D1B5\D574 \C774\B7EC\D55C \ACBD\C6B0\AC00 \CC98\B9AC\B41C\B2E4\B294 \AC83\C744 \C758\BBF8\D569\B2C8\B2E4. \B85C\ADF8\C778 \D398\C774\C9C0 \B610\B294 URL\C740 Single Sign-On \D3EC\D138 \B610\B294 \C77C\BD80 \B2E4\B978 \B85C\ADF8\C778 \C11C\BC84\B85C \C7AC\C9C0\C815\B420 \C218\B3C4 \C788\C2B5\B2C8\B2E4. \B610\D55C \C778\C99D \CCB4\ACC4\C5D0 \B85C\ADF8\C778 \D504\B85C\C138\C2F1 \AC12\C774 \C5C6\C2B5\B2C8\B2E4. \C774\B7EC\D55C \C0C1\D669\C744 \C6D0\D558\C9C0 \C54A\B294 \ACBD\C6B0 \C774 \C778\C99D \CCB4\ACC4\B97C \D3B8\C9D1\D558\ACE0 \BD80\C801\D569\D55C \C138\C158 \D398\C774\C9C0 \B610\B294 URL\C744 \C81C\ACF5\D55C \B2E4\C74C \C774 \CC28\D2B8')
||unistr(' \BCF4\AE30\B97C \B2E4\C2DC \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104994275226309465)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN3'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C778\C99D \CCB4\ACC4\B294 \BD80\C801\D569\D55C \C138\C158 \B300\C0C1\C5D0 \C0AC\C6A9\B418\B294 \B85C\ADF8\C778 \D398\C774\C9C0 \B610\B294 URL\C744 \C9C0\C815\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \C774\B294 \D398\C774\C9C0 \AC10\C2DC \D568\C218\B97C \D1B5\D574 \C774\B7EC\D55C \ACBD\C6B0\AC00 \CC98\B9AC\B41C\B2E4\B294 \AC83\C744 \C758\BBF8\D569\B2C8\B2E4. \B85C\ADF8\C778 \D398\C774\C9C0 \B610\B294 URL\C740 Single Sign-On \D3EC\D138 \B610\B294 \C77C\BD80 \B2E4\B978 \B85C\ADF8\C778 \C11C\BC84\B85C \C7AC\C9C0\C815\B420 \C218\B3C4 \C788\C2B5\B2C8\B2E4. \D558\C9C0\B9CC \C544\B798\C5D0 \D45C\C2DC\B41C \AC83\ACFC \AC19\C774 \C778\C99D \CCB4\ACC4\C5D0\B294 \B85C\ADF8\C778 \D504\B85C\C138\C2F1 \AC12 \C9D1\D569\C774 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104994347925309465)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN4'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 URL %0\C740(\B294) %1 \C560\D50C\B9AC\CF00\C774\C158 \D398\C774\C9C0\B97C \BD80\C801\D569\D55C \C138\C158 \B300\C0C1\C73C\B85C \C9C0\C815\D569\B2C8\B2E4. \D558\C9C0\B9CC \C778\C99D \CCB4\ACC4\C5D0 \B85C\ADF8\C778 \D504\B85C\C138\C2F1 \AC12\C774 \C5C6\C2B5\B2C8\B2E4. \C774 \D398\C774\C9C0\C5D0\C11C\B294 \B2E4\C74C \B2E8\ACC4\B97C \C218\D589\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104994478180309466)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN6'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C5D4\C9C4\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B85C\ADF8\C778 \D398\C774\C9C0\B97C \D45C\C2DC\D558\AC70\B098 \D5C8\C6A9\D560 \C218 \C788\B3C4\B85D \D558\B824\BA74 \C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30\C758 \D398\C774\C9C0 \C18D\C131 \D398\C774\C9C0\C5D0\C11C \D398\C774\C9C0 \C18D\C131 ''\C608 - \ACF5\C6A9 \D398\C774\C9C0''\B97C \C120\D0DD\D574\C57C \D569\B2C8\B2E4. \C774\B807\AC8C \D558\C9C0 \C54A\C73C\BA74 \C5D4\C9C4\C740 \D398\C774\C9C0\AC00 \D45C\C2DC\B418\AE30 \C804\C5D0 \D398\C774\C9C0 \AC10\C2DC \D568\C218 \C2E4\D589\C744 \C2DC\B3C4\D569\B2C8\B2E4. \C544\C9C1 \B85C\ADF8\C778\D558\C9C0 \C54A\C740 \ACBD\C6B0 \B3D9\C77C\D55C URL\B85C\C758 \C7AC\C9C0\C815\C774 \C2DC\B3C4\B429\B2C8\B2E4. \C774\B85C \C778\D574 \AC00\C7A5 \BD80\C801\D569\D55C \B8E8\D504\AC00 \BC1C\C0DD\D558\AC8C \B429\B2C8\B2E4. \ACE0\C720\C758 \D398\C774\C9C0 \AC10\C2DC \D568\C218\B97C \CF54\B4DC\D654\D558\B294 \ACBD\C6B0, \D604\C7AC \D398\C774\C9C0\AC00 \C774 \B85C')
||unistr('\ADF8\C778 \D398\C774\C9C0\AC00 \B418\B294 \C2DC\AE30\B97C \D30C\C545\D558\C5EC \C774\B97C \B2E4\B978 \D398\C774\C9C0\C640 \B2E4\B974\AC8C \CC98\B9AC\D574\C57C \D569\B2C8\B2E4. \D398\C774\C9C0 \BC88\D638\B85C \D398\C774\C9C0\B97C \C2DD\BCC4\D560 \C218 \C788\B294 \ACBD\C6B0\C5D0\B294 \AD1C\CC2E\C2B5\B2C8\B2E4. \BCF4\B2E4 \C77C\BC18\C801\C778 \AE30\C220\C740 \BD80\C6B8 \D568\C218 wwv_flow_custom_auth.current_page_is_public\C744 \C0AC\C6A9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \B85C\ADF8\C778 \D398\C774\C9C0 \B610\B294 \B2E4\B978 \D398\C774\C9C0\C758 \C774 \ACF5\C6A9 \C18D\C131\C744 \D30C\C545\D558\B294 \AC83\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104994527176309466)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN7'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 URL %0\C740(\B294) %1 \C560\D50C\B9AC\CF00\C774\C158 \D398\C774\C9C0\B97C \BD80\C801\D569\D55C \C138\C158 \B300\C0C1\C73C\B85C \C9C0\C815\D569\B2C8\B2E4. \C774 \D398\C774\C9C0\C5D0\C11C\B294 \B2E4\C74C \B2E8\ACC4\B97C \C218\D589\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104994644741309466)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN8'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4\C758 \B85C\ADF8\C778 \D504\B85C\C138\C2F1\C5D0 \B300\D574 \C124\C815\B41C \AC12\C774 \C544\B798\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104994711028309466)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN9'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Application Server Single Sign-On \C11C\BC84\B294 \C0AC\C6A9\C790 \C778\C99D \D6C4 \C774 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \C7AC\C9C0\C815\B429\B2C8\B2E4. \C2DC\C791\C810\C740 %0 \C2A4\D0A4\B9C8\C5D0 \C788\B294 wwv_flow_custom_auth_sso.process_success \D504\B85C\C2DC\C800\C785\B2C8\B2E4. %0\C740(\B294) Oracle Application Server Single Sign-On \D611\B825 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \B4F1\B85D\B418\BA70 \B85C\ADF8\C778 \C11C\BC84\C5D0 \B300\D55C \BAA8\B4E0 \C778\D130\D398\C774\C2A4\B97C \AD00\B9AC\D569\B2C8\B2E4. \D558\C9C0\B9CC \C6D0\D558\B294 \ACBD\C6B0 \ACE0\C720 \C2A4\D0A4\B9C8\C5D0')
||unistr(' \ACE0\C720 \C560\D50C\B9AC\CF00\C774\C158\C744 \B4F1\B85D\D560 \C218 \C788\C2B5\B2C8\B2E4. \ACE0\C720 \D398\C774\C9C0 \AC10\C2DC\B97C \C791\C131\D558\AC70\B098, \C778\C99D \CCB4\ACC4 \AC24\B7EC\B9AC\C5D0\C11C Portal-SSO \CCB4\ACC4(\B0B4 \C560\D50C\B9AC\CF00\C774\C158\C744 \D611\B825 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C)\B97C \AE30\BC18\C73C\B85C \C778\C99D \CCB4\ACC4\B97C \AC04\B2E8\D558\AC8C \C0DD\C131\D560 \C218 \C788\C2B5\B2C8\B2E4. \ADF8 \ACB0\ACFC\B85C \C0DD\C131\B41C \CCB4\ACC4\B294 \B0B4\C7A5 SSO \D398\C774\C9C0 \AC10\C2DC wwv_flow_custom_auth_std.portal_sso_sentry_v1\C744 \D638\CD9C\D569\B2C8\B2E4. \C774 \D568\C218\C5D0\C11C\B294 \D604\C7AC \C778\C99D \CCB4\ACC4\AC00 Oracle Application Server Sin')
||unistr('gle Sign-On\C5D0 \B4F1\B85D\B41C \D611\B825 \C560\D50C\B9AC\CF00\C774\C158 \C774\B984\C744 \C54C\ACE0 \C788\C5B4\C57C \D569\B2C8\B2E4. \C778\C99D \CCB4\ACC4 \C0DD\C131 \B9C8\BC95\C0AC\AC00 \D611\B825 \C560\D50C\B9AC\CF00\C774\C158 \C774\B984\C744 \C694\AD6C\D569\B2C8\B2E4. \B610\B294 \C778\C99D \CCB4\ACC4 \C0DD\C131 \D6C4 \D574\B2F9 \CCB4\ACC4\B97C \D3B8\C9D1\D558\C5EC \C774\B984\C744 \CD94\AC00\D558\AC70\B098 \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774\B984\C740 \B4F1\B85D\B41C \B300\B85C \B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\C5EC \C815\D655\D558\AC8C \C785\B825\D574\C57C \D569\B2C8\B2E4. \B610\D55C \ACE0\C720 URLC \C218\C2E0\C790 \D504\B85C\C2DC\C800\B97C \C791\C131\D558\ACE0 wwv_flow_custom_auth_sso.process_success API\B97C \D574\B2F9 \D504\B85C\C2DC\C800\C5D0\C11C \D638\CD9C\D558\C5EC ')
||unistr('Oracle Application Server Single Sign-On\C5D0 \B4F1\B85D\B41C \B300\B85C \C560\D50C\B9AC\CF00\C774\C158 \C774\B984\C744 \C804\B2EC\D574\C57C \D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4. \C774\B807\AC8C \D558\BA74 \C778\C99D \D6C4 %0\C5D0 \C138\C158\C774 \B4F1\B85D\B429\B2C8\B2E4. \ACE0\C720 \D398\C774\C9C0 \AC10\C2DC\B97C \C791\C131\D558\B294 \ACBD\C6B0, \C778\C99D\C774 \D544\C694\D558\B2E4\ACE0 \ACB0\C815\B418\BA74 \B85C\ADF8\C778 \C11C\BC84\B85C\C758 \C7AC\C9C0\C815\C744 \C218\D589\D558\AE30 \C704\D574 \D398\C774\C9C0 \AC10\C2DC\C5D0 \C758\D574 wwv_flow_custom_auth_sso.portal_sso_redirect API\AC00 \D638\CD9C\B420 \C218 \C788\C2B5\B2C8\B2E4. \D611\B825 \C560\D50C\B9AC\CF00\C774\C158\C758 \B4F1\B85D\B41C \C774\B984')
||unistr('\C744 \C774 \D504\B85C\C2DC\C800\C5D0 \C804\B2EC\D574\C57C \D569\B2C8\B2E4. \C790\C138\D55C \B0B4\C6A9\C740 %0 \C124\BA85\C11C \BC0F %1 \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104995156728309466)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_POST_AUTH_PROC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\D6C4 \C778\C99D \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104995018350309466)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_PRE_AUTH_PROC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \C778\C99D \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104989528428309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHK_COOKIE1'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \B17C\B9AC\B97C \C0AC\C6A9\D558\C5EC [%0](\C774)\B77C\B294 \CFE0\D0A4\B97C \AC80\C0AC\D569\B2C8\B2E4. \D574\B2F9 \CFE0\D0A4\AC00 \C874\C7AC\D558\ACE0 \B514\CF54\B4DC\B41C \AC12\C774 \B0B4\BD80 \C138\C158 \D14C\C774\BE14\C5D0\C11C \D589\C744 \CC3E\C544\B0B4\BA74 \C138\C158\C740 \C801\D569\D55C \AC83\C73C\B85C \AC04\C8FC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104989766965309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.COMPUTE_RETURN_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\D658\AC12 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104991508826309463)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CREDENTIALS_VERIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C99D\BA85\C11C \D655\C778(\C778\C99D)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104993157278309465)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CUST_POST_AUTH_PROC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C0AC\D6C4 \C778\C99D \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104986298740309460)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_MALFORMED_LOGIN_ARGS2'
,p_message_language=>'ko'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2\C5D0 \B300\D55C \C2DC\C791\C810 \C778\C218\AC00 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4.  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104986126783309459)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_NULL_LOGIN_ARG'
,p_message_language=>'ko'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:%0\C5D0 \B300\D55C p_session_id \C778\C218\AC00 \B110\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104986023126309459)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_RUN_CRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C99D\BA85\C11C \D655\C778 \D568\C218\B97C \C2E4\D589\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104990596092309463)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.INVALID_SESS_TARGET'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C138\C158 \B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104992253942309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_DN'
,p_message_language=>'ko'
,p_message_text=>unistr('LDAP \AC80\C0C9 \AE30\C900:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104992313642309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \BE14\B85D\C740 DBMS_LDAP.SIMPLE_BIND_S\B97C \D638\CD9C\D558\AE30 \C804\C5D0 \D568\C218\B97C \D638\CD9C\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4. \B85C\ADF8\C778 \D3FC\C5D0\C11C \CEA1\CC98\B41C \C0AC\C6A9\C790 \C774\B984\C740 LDAP \AC80\C0C9 \AE30\C900\C5D0\C11C %LDAP_USER%\B97C \BC14\AFB8\B294 \B370 \C0AC\C6A9\B418\B294 \AC12\C744 \BC18\D658\D558\B294 \D568\C218\C5D0 \C804\B2EC\B429\B2C8\B2E4. (\C704 \CC38\C870)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104992476872309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CF54\B4DC \BE14\B85D\C5D0\B294 \B2E4\C74C \C11C\BA85\C774 \C788\C5B4\C57C \D568:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104992539138309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN3'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AE30\B2A5\C744 \C0AC\C6A9\D558\C5EC \B85C\ADF8\C778 \D3FC\C5D0 \C785\B825\B41C \C0AC\C6A9\C790 \C774\B984\C744 LDAP \B514\B809\D1A0\B9AC \D56D\BAA9\ACFC \C77C\CE58\D558\B294 \D615\C2DD\C73C\B85C \BCC0\D658\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104992089409309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_HOST'
,p_message_language=>'ko'
,p_message_text=>unistr('LDAP \D638\C2A4\D2B8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104992147763309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_PORT'
,p_message_language=>'ko'
,p_message_text=>unistr('LDAP \D3EC\D2B8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104989053371309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158(%0)\C740 %1 \D398\C774\C9C0\B97C \B85C\ADF8\C778 \D398\C774\C9C0\B85C \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104989157164309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG2'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D398\C774\C9C0\AC00 \C694\CCAD\B420 \B54C\B9C8\B2E4 \CD94\AC00 \C778\C99D \AC80\C0AC\B97C \C218\D589\D558\C9C0 \C54A\ACE0 \D398\C774\C9C0\AC00 \D45C\C2DC\B418\AC70\B098 \D5C8\C6A9\B429\B2C8\B2E4. \C774\B807\AC8C \D558\BA74 \C778\C99D\B418\AE30 \C804\C5D0 \B85C\ADF8\C778 \D398\C774\C9C0\B97C \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104988973207309461)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG_HANDLING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 \D398\C774\C9C0 \CC98\B9AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104989274216309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PAGE_SENTRY_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AC10\C2DC \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104989346165309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PG_SENTRY1'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C7A5 \B17C\B9AC\B97C \C0AC\C6A9\D558\C5EC \D398\C774\C9C0 \AC10\C2DC \C791\C5C5\C744 \C218\D589\D569\B2C8\B2E4. \AC01 \D398\C774\C9C0 \C694\CCAD\C5D0 \B300\D574 \D398\C774\C9C0 \AC10\C2DC \D568\C218\B294 \C138\C158 \D655\C778\C744 \C218\D589\D558\ACE0 \BC18\D658\AC12\C744 \ACC4\C0B0\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104992763544309464)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.POST_AUTH_PROC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\D6C4 \C778\C99D \D504\B85C\C138\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104989654566309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY1'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \C0AC\C6A9\C790 \C81C\ACF5 \CF54\B4DC\B97C \C0AC\C6A9\D558\C5EC \C138\C158\C774 \C801\D569\D55C\C9C0 \D655\C778\D569\B2C8\B2E4. \C704\C758 \B0B4\C7A5 \C138\C158 \D655\C778 \AC80\C0AC \ACB0\ACFC\AC00 TRUE\C774\BA74 \B2E4\C74C \CF54\B4DC\B97C \C2E4\D589\D558\ACE0 \D574\B2F9 \BD80\C6B8 \BC18\D658\AC12\C744 \AE30\C5B5\D574 \B450\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104989435359309462)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \D655\C778 \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104990826493309463)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SSO_SERVER'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Application Server Single Sign-On \C11C\BC84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104990907198309463)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.THE_URL'
,p_message_language=>'ko'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105137707840309576)
,p_name=>'WWV_FLOW_DATALOAD_XML.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104876154450309377)
,p_name=>'WWV_FLOW_DATA_LOADER.LOADING_JOB_STARTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C791\C5C5\C774 \C2DC\C791\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105047094294309504)
,p_name=>'WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'
,p_message_language=>'ko'
,p_message_text=>unistr('%1MB\BCF4\B2E4 \D070 %0 \D30C\C77C\C740 \B370\C774\D130 \B85C\B4DC\C5D0 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105432637866309804)
,p_name=>'WWV_FLOW_DATA_PROFILE.INVALID_SQL_EXPR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C SQL \D45C\D604\C2DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104966434590309445)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.ANALYZE_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \BD84\C11D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104966884110309445)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.VIEW_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30 \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105126988116309568)
,p_name=>'WWV_FLOW_DEBUGTAB_BIU_FER.INVALID_DATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \B0A0\C9DC \D615\C2DD\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105106529466309547)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.DEBUG'
,p_message_language=>'ko'
,p_message_text=>unistr('\B514\BC84\ADF8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105106619652309547)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FEATURE_NOT_SUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BC84\C804\C5D0\C11C \C9C0\C6D0\D558\C9C0 \C54A\B294 \AE30\B2A5\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105103733891309545)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FUNC_RETURN_QUERY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1101 \C9C8\C758\B97C \BC18\D658\D558\B294 \D568\C218 \BCF8\BB38\C744 \CC98\B9AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105106814047309547)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.HELP_REQUEST_ERR2'
,p_message_language=>'ko'
,p_message_text=>unistr('ERROR 4323- \B3C4\C6C0\B9D0 \C694\CCAD \C2DC \B3C4\C6C0\B9D0\C744 \D45C\C2DC\D560 \C22B\C790 \D398\C774\C9C0 ID\B97C \C81C\ACF5\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105103593721309544)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1025 PLSQL \D45C\D604\C2DD\C744 \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105103649990309544)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_FOOTER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158=%0 \D398\C774\C9C0=%1 SQLERRM=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105106342333309546)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PRINT_SHORTCUT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD95\D0A4\B97C \C778\C1C4\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105103845735309545)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PROC_CURR_COND_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1108 \D56D\BAA9 \D604\C7AC \C870\AC74\C744 \CC98\B9AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105106440005309547)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_CHART_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8\B97C \B80C\B354\B9C1\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105256662270309663)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_COMP_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\B97C \B80C\B354\B9C1\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104900781298309397)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_DYN_LIST_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \BAA9\B85D \C601\C5ED\C744 \B80C\B354\B9C1\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105106745926309547)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.REQUEST_FOR_HELP_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERROR 4322- \B3C4\C6C0\B9D0 \C694\CCAD\C5D0 \C801\C808\D55C \AD6C\BB38\C744 \C0AC\C6A9\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \C801\D569\D55C \D398\C774\C9C0 \BC88\D638\AC00 \D544\C694\D558\C9C0\B9CC \C694\CCAD\C774 \B110\C774\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105133314192309572)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.UNABLE_TO_BIND_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0"\C744(\B97C) \BC14\C778\B4DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \BA40\D2F0 \BC14\C774\D2B8 \D56D\BAA9\C5D0 \B300\D574 \D070 \B530\C634\D45C\B97C \C0AC\C6A9\D558\AC70\B098 \D56D\BAA9 \AE38\C774\AC00 30\BC14\C774\D2B8 \C774\D558\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624. \AE38\C774\AC00 30\BC14\C774\D2B8\B97C \CD08\ACFC\D558\B294 \D56D\BAA9\C744 \CC38\C870\D558\B824\BA74 v() \AD6C\BB38\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105671493555310004)
,p_name=>'WWV_FLOW_DML.BLOB_COLUMN_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4 \D615\C2DD \B9C8\C2A4\D06C DOWNLOAD:TABLE_NAME:BLOB_COLUMN\C5D0 BLOB \C5F4 \C774\B984\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106026077484310295)
,p_name=>'WWV_FLOW_DML.COLUMN_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D14C\C774\BE14\C5D0\C11C %0 \C5F4\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105129084615309569)
,p_name=>'WWV_FLOW_DML.DML_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('DML\C5D0 \C624\B958 \BC1C\C0DD: p_rowid=%0, p_alt_rowid=%1, p_rowid2=%2, p_alt_rowid2=%3. %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104963017724309442)
,p_name=>'WWV_FLOW_DML.DML_INSERT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0BD\C785 \C791\C5C5\C744 \C218\D589\D560 \C218 \C5C6\C2B5\B2C8\B2E4.  %0  %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105284529157309685)
,p_name=>'WWV_FLOW_DML.DML_INVALID_NUMBER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) %1 \C5F4\C5D0 \BD80\C801\D569\D55C \C22B\C790 \AC12\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104969760946309447)
,p_name=>'WWV_FLOW_DML.INVALID_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AC1D\CCB4\C5D0 \BD80\C801\D569\D55C \C791\C5C5 %0\C774(\AC00) \C788\C2B5\B2C8\B2E4. (%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105670592033310004)
,p_name=>'WWV_FLOW_DML.INVALID_TABLE_OWNER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \D14C\C774\BE14 \C18C\C720\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105670635353310004)
,p_name=>'WWV_FLOW_DML.INVALID_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105670498108310003)
,p_name=>'WWV_FLOW_DML.LAST_UPDATED_COLUMN_HAS_TO_BE_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('"%2"\C5D0 \B300\D55C \C5C5\B370\C774\D2B8 \C0AC\D56D\C744 \CD94\C801\D558\B294 \B370 \C0AC\C6A9\B418\B294 \B9C8\C9C0\B9C9\C73C\B85C \C5C5\B370\C774\D2B8\B41C \B370\C774\D130 \C5F4 "%0"\C758 \B370\C774\D130 \C720\D615 "%1"\C740(\B294) \B0A0\C9DC \B610\B294 \C2DC\AC04\AE30\B85D \B370\C774\D130 \C720\D615\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105670729869310004)
,p_name=>'WWV_FLOW_DML.NOT_CALLED_FROM_PAGE_WHICH_CONTAINS_FILE_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958: FILE \C720\D615\C758 \D56D\BAA9 \C774\B984\C744 \D3EC\D568\D558\B294 \D398\C774\C9C0\C5D0\C11C \D638\CD9C\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105671082654310004)
,p_name=>'WWV_FLOW_DML.NO_FORMAT_MASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \B9C8\C2A4\D06C\B97C \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105671501433310004)
,p_name=>'WWV_FLOW_DML.PK_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4 \D615\C2DD \B9C8\C2A4\D06C DOWNLOAD:TABLE_NAME:BLOB_COLUMN:PK1_COL_NAME\C5D0 \AE30\BCF8 \D0A4 1 \C5F4 \C774\B984\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106026170118310296)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \BDF0 \B610\B294 \D14C\C774\BE14\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105671348709310004)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4 \D615\C2DD \B9C8\C2A4\D06C DOWNLOAD:TABLE_NAME\C5D0 \D14C\C774\BE14 \C774\B984\C774 \D544\C694\D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105671288026310004)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \B9C8\C2A4\D06C\B294 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C 4\AC1C \C774\C0C1\C758 \C778\C218\B97C \D3EC\D568\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105671113815310004)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK_PREFIX'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \B9C8\C2A4\D06C\B294 DOWNLOAD \B610\B294 IMAGE\B85C \C2DC\C791\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105316627616309710)
,p_name=>'WWV_FLOW_EXEC.INVALID_COLUMN_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984 "%0"\C740(\B294) SQL \C9C8\C758\C5D0 \B300\D574 \BD80\C801\D569\D569\B2C8\B2E4. \C5F4\C5D0 \B300\D574 \ACE0\C720\D55C \BCC4\CE6D \C774\B984\C744 \C0AC\C6A9 \C911\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104961920553309442)
,p_name=>'WWV_FLOW_EXEC.NOT_ALLOWED_ON_WEB_SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4\C5D0 \B300\D574\C11C\B294 \C774 \C791\C5C5\C774 \D5C8\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105316570601309710)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\C5D0\C11C \C120\D0DD\B41C \C5F4 \C218\AC00 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4. \C790\C138\D55C \B0B4\C6A9\C740 \C18D\C131 \B3C4\C6C0\B9D0\C744 \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104872013800309374)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C758 SQL \BB38\C5D0\C11C \B370\C774\D130 \C720\D615\C774 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4. Column# %1\C740(\B294) %2\C778\B370 %3\C774(\AC00) \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105417587979309791)
,p_name=>'WWV_FLOW_EXEC_DEV.COLUMN_NOT_UNIQUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984 "%0"\C740(\B294) SQL \C9C8\C758\C5D0 \C774\BBF8 \C0AC\C6A9 \C911\C785\B2C8\B2E4. \C5F4\C5D0 \B300\D574 \ACE0\C720\D55C \BCC4\CE6D \C774\B984\C744 \C0AC\C6A9 \C911\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105417469368309791)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_COLUMN_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984 "%0"\C740(\B294) LOV SQL \C9C8\C758\C5D0 \B300\D574 \BD80\C801\D569\D569\B2C8\B2E4. \C5F4\C5D0 \B300\D574 \C801\D569\D55C \BCC4\CE6D \C774\B984\C744 \C0AC\C6A9 \C911\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105417284416309791)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\D658\B41C \C9C8\C758 \AD6C\BB38\BD84\C11D \ACB0\ACFC\B294 "%0"\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105417372272309791)
,p_name=>'WWV_FLOW_EXEC_DEV.WRONG_COLUMN_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\C5D0\C11C \C120\D0DD\B41C \C5F4 \C218\AC00 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4. \C790\C138\D55C \B0B4\C6A9\C740 \C18D\C131 \B3C4\C6C0\B9D0\C744 \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104871583711309373)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.MODULE_TYPE_NOT_SUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4 \C720\D615 %0\C740(\B294) \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104873440529309375)
,p_name=>'WWV_FLOW_EXPORT_INT.DUPLICATE_FILENAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\BCF5 \D30C\C77C \C774\B984: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106065884798310333)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.APPLICATION_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106065626968310333)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.CONSTANT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106065391679310333)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106066478326310334)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.KEYWORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0A4\C6CC\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106066363031310334)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.MATERIALIZED VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\CCB4\D654\B41C \BDF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106065920047310333)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PACKAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\D0A4\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106065753597310333)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PAGE_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106065265256310332)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PROCEDURE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C2DC\C800')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106066048023310333)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.SEQUENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106066182245310333)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106066577262310334)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106065493294310333)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106065542303310333)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VARIABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106066227427310333)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105630434172309968)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_LOV_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('LOV SQL \C9C8\C758 \AD6C\BB38\BD84\C11D \C2E4\D328! %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105395260810309769)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_QUERY_FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C9C8\C758 \D544\D130\AC00 \C81C\CD9C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105631388531309968)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984 "%0"\C740(\B294) LOV SQL \C9C8\C758\C5D0 \C774\BBF8 \C0AC\C6A9 \C911\C785\B2C8\B2E4. \C5F4\C5D0 \B300\D574 \ACE0\C720\D55C \BCC4\CE6D \C774\B984\C744 \C0AC\C6A9 \C911\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105631285864309968)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984 "%0"\C740(\B294) LOV SQL \C9C8\C758\C5D0 \B300\D574 \BD80\C801\D569\D569\B2C8\B2E4. \C5F4\C5D0 \B300\D574 \C801\D569\D55C \BCC4\CE6D \C774\B984\C744 \C0AC\C6A9 \C911\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105630366184309968)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('LOV SQL \C9C8\C758\C5D0\C11C \C120\D0DD\B41C \C5F4 \C218\AC00 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4. \C801\D569\D55C \BA85\B839\BB38\C740 \C608\C81C\B97C \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104969548308309447)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D30C\C77C \C81C\AC70\B97C \C2DC\B3C4\D558\B294 \C911 \C11C\BC84\C5D0 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104969695175309447)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE2'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D30C\C77C\C744 \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104969390025309447)
,p_name=>'WWV_FLOW_FILE_API.ERROR_WRITING_TO_DIRECTORY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BB3C\B9AC\C801 \D30C\C77C \B514\B809\D1A0\B9AC "%0"\C5D0 \C4F0\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. (%1: %2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105104836695309545)
,p_name=>'WWV_FLOW_FILE_API.EXCEEDED_WORKSPACE_NON_INTERNAL_FILES_LIMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\B0B4\BD80 \C791\C5C5\C601\C5ED \D30C\C77C\C5D0 \B300\D55C \CD5C\B300 \D06C\AE30 \C81C\D55C\C744 \CD08\ACFC\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104969424452309447)
,p_name=>'WWV_FLOW_FILE_API.NO_FILE_TO_WRITE'
,p_message_language=>'ko'
,p_message_text=>unistr('ID %0\C5D0 \B300\D574 \C4F8 \D30C\C77C\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105104710884309545)
,p_name=>'WWV_FLOW_FILE_API.WORKSPACE_MAX_FILE_BYTES.EXCEEDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C791\C5C5\C601\C5ED \D30C\C77C\C5D0 \B300\D55C \CD5C\B300 \D06C\AE30 \C81C\D55C\C744 \CD08\ACFC\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105138051961309576)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.DEV_ROLE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790 \B864\C744 \C0AD\C81C\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105014071400309480)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_FND_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C0DD\C131\B418\C9C0 \C54A\C740 \C774\C720: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105678653612310011)
,p_name=>'WWV_FLOW_FND_USER_API.INVALID_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \BD80\C801\D569\D55C \C804\C790\BA54\C77C \C8FC\C18C\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105131790309309571)
,p_name=>'WWV_FLOW_FORMS.COMBO_JS_NO_QUERY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('w/js \C7AC\C9C0\C815\C744 \C0AC\C6A9\D558\B294 \C120\D0DD \BAA9\B85D \C720\D615\C758 %0 \D56D\BAA9\C5D0 \C9C8\C758\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105131668988309571)
,p_name=>'WWV_FLOW_FORMS.COMBO_NO_QUERY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615 \C120\D0DD \BAA9\B85D\C758 %0 \D56D\BAA9\C5D0 \C9C8\C758\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105131825973309571)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('URL \C7AC\C9C0\C815\C744 \C0AC\C6A9\D558\B294 \C120\D0DD \BAA9\B85D \C720\D615\C758 %0 \D56D\BAA9\C5D0 \C9C8\C758\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105131986794309571)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_PAGE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 URL \C7AC\C9C0\C815\C744 \C0AC\C6A9\D558\B294 \C120\D0DD \BAA9\B85D \C720\D615\C758 %0 \D56D\BAA9\C5D0 \C9C8\C758\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105106264688309546)
,p_name=>'WWV_FLOW_FORMS.EDIT ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 - %1 \D56D\BAA9 \D3B8\C9D1, \C2DC\D000\C2A4: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105103349558309544)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_FUNC_BODY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1904 \D56D\BAA9 \AE30\BCF8\AC12\C744 \ACC4\C0B0\D560 \C218 \C5C6\C74C: \C720\D615 = \D568\C218 \BCF8\BB38 computation_type= %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105103272837309544)
,p_name=>'WWV_FLOW_FORMS.PLSQL_ITEM_PROC_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1020 PLSQL \D56D\BAA9(\D568\C218)\C744 \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105103498349309544)
,p_name=>'WWV_FLOW_FORMS.SPELL_CHK'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA0\C790\BC95 \AC80\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105106121073309546)
,p_name=>'WWV_FLOW_FORMS.UNABLE_CAST_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \AC12\C758 \B370\C774\D130\D615\C744 \B0A0\C9DC \D615\C2DD \B9C8\C2A4\D06C %1(\C73C)\B85C \BCC0\D658\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104871277878309373)
,p_name=>'WWV_FLOW_FORM_REGION.BLOB_NOT_SUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('BLOB \B370\C774\D130 \C720\D615\C758 \D56D\BAA9\C740 REST \C0AC\C6A9 SQL \B610\B294 REST \B370\C774\D130 \C18C\C2A4\C5D0 \B300\D574 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104871470953309373)
,p_name=>'WWV_FLOW_FORM_REGION.CANNOT_FETCH_META_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED ID %s\C5D0 \B300\D55C \BA54\D0C0\B370\C774\D130\B97C \C778\CD9C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105351409520309736)
,p_name=>'WWV_FLOW_FORM_REGION.FORM_REGION_IS_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC DML \B610\B294 \CD08\AE30\D654 \D504\B85C\C138\C2A4\C5D0 \C9C0\C815\B41C \D3FC \C601\C5ED\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105357156947309741)
,p_name=>'WWV_FLOW_FORM_REGION.MIGRATE_FORM_REGION_DESCRIBE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\AC70\C2DC \D3FC \D398\C774\C9C0\B97C \D3FC \C601\C5ED\C73C\B85C \C774\C804 \C624\B958: DML \D504\B85C\C138\C2A4\C5D0\C11C \CC38\C870\B41C \D14C\C774\BE14\C744 \C124\BA85\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105088389738309533)
,p_name=>'WWV_FLOW_FORM_REGION.NO_CHECKSUM_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C190\C2E4\B41C \C5C5\B370\C774\D2B8 \AC10\C9C0\C5D0 \B300\D55C \CCB4\D06C\C12C\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \AE30\C874 \D589\C5D0\B9CC UPDATE \B610\B294 DELETE\B97C \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105657719122309992)
,p_name=>'WWV_FLOW_FORM_REGION.NO_DML_ON_WSM_SYNC_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\AE30\D654\AC00 \C0AC\C6A9 \C124\C815\B41C REST \C18C\C2A4\C5D0\C11C \D3FC DML\C744 \C2E4\D589\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104871137389309373)
,p_name=>'WWV_FLOW_FORM_REGION.NO_PRIMARY_KEY_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \C601\C5ED %0\C5D0 \B300\D574 \C815\C758\B41C \AE30\BCF8 \D0A4 \D56D\BAA9\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104871396540309373)
,p_name=>'WWV_FLOW_FORM_REGION.WRONG_ITEM_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D56D\BAA9\C758 \B370\C774\D130 \C720\D615\C774 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105039323558309498)
,p_name=>'WWV_FLOW_GENERATE_DDL.DOMAIN_INDEX_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C %0\C5D0 \B3C4\BA54\C778 \C778\B371\C2A4\AC00 \C788\C2B5\B2C8\B2E4. DDL \C0DD\C131\C740 \B3C4\BA54\C778 \C778\B371\C2A4\C5D0 \B300\D55C DDL\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104977890986309453)
,p_name=>'WWV_FLOW_GENERATE_DDL.GENERATE_DDL_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('Rem %0\C5D0 \B300\D574 DDL\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105008534249309476)
,p_name=>'WWV_FLOW_GENERATE_DDL.NO_DDL'
,p_message_language=>'ko'
,p_message_text=>unistr('DDL \C0DD\C131\C5D0 \D544\C694\D55C %0\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104978018896309454)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('Save_ddl \C624\B958 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104965663250309444)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('DDL\C744 \C2A4\D06C\B9BD\D2B8 \D30C\C77C\B85C \C800\C7A5\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104977960036309454)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_PARSE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('DDL \C2A4\D06C\B9BD\D2B8\C758 \AD6C\BB38\C744 \BD84\C11D\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105132085287309571)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.PACKAGE_INVALID_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958\C785\B2C8\B2E4. \D328\D0A4\C9C0 \C774\B984 %0\C774(\AC00) \BD80\C801\D569\D558\AC70\B098 \C774\BBF8 \C0AC\C6A9 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105113182013309551)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('--%0 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \D14C\C774\BE14 API\AC00 %1\C744(\B97C) \C0DD\C131\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105111895095309550)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_CREATE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2E4\C74C \D504\B85C\C2DC\C800\B97C \C0AC\C6A9\D558\C5EC PL/SQL \D328\D0A4\C9C0 %0 \C0DD\C131:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105112798362309551)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC1'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B97C %0\C5D0 \C0BD\C785\D558\B294 \B370 \C0AC\C6A9\D558\BA70, \AE30\BCF8 \D0A4\B97C \C81C\ACF5\D574\C57C \D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105112888668309551)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC2'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0\C11C \AE30\BCF8 \D0A4\B85C \C2DD\BCC4\B41C \B370\C774\D130\B97C \C5C5\B370\C774\D2B8\D558\B294 \B370 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105112977795309551)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC3'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4\C5D0 \C900\D558\C5EC %0\C5D0\C11C \B370\C774\D130\B97C \C0AD\C81C\D558\B294 \B370 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105113064688309551)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC4'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4\C5D0 \C900\D558\C5EC %0\C5D0\C11C \B370\C774\D130\B97C \AC80\C0C9\D558\B294 \B370 \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105112613738309551)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105112438521309551)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38 \B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105112345386309551)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C591 \B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105112209146309551)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38 \C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105112042333309551)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C591 \C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105185832185309611)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_BODY_COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('-- \D328\D0A4\C9C0 \BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105185969690309611)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_SPEC_COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('-- \D328\D0A4\C9C0 \C0AC\C591')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105112123933309551)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105111910453309551)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_SPEC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C591 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105112565179309551)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SUBPROGRAM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C704 \D504\B85C\ADF8\B7A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105185322932309611)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_CREATE_COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('-- "%0" \D14C\C774\BE14\C5D0 \B300\D55C \C0DD\C131 \D504\B85C\C2DC\C800')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105185518572309611)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_DELETE_COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('-- "%0" \D14C\C774\BE14\C5D0 \B300\D55C \C0AD\C81C \D504\B85C\C2DC\C800')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105185617962309611)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_GET_COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('-- "%0" \D14C\C774\BE14\C5D0 \B300\D55C \AC00\C838\C624\AE30 \D504\B85C\C2DC\C800')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105185773789309611)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_MD5_COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('-- "%0" \D14C\C774\BE14\C5D0 \B300\D55C MD5 \D568\C218 \C791\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105185415841309611)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_UPDATE_COMMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('-- "%0" \D14C\C774\BE14\C5D0 \B300\D55C \C5C5\B370\C774\D2B8 \D504\B85C\C2DC\C800')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105132164612309572)
,p_name=>'WWV_FLOW_GENERIC_ATTR.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105669872819310003)
,p_name=>'WWV_FLOW_GEN_API2.COMPANY_SOURCE_IDENTIFIER_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C758 \C18C\C2A4 \C2DD\BCC4\C790\B97C \C815\C758\D574\C57C \D569\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105669986959310003)
,p_name=>'WWV_FLOW_GEN_API2.DEPLOYMENT_SYSTEM_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\CE58 \C2DC\C2A4\D15C\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105010159517309477)
,p_name=>'WWV_FLOW_GRID_LAYOUT.FIXED_POSITION_CONFLICT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2E4\B978 \AD6C\C131\C694\C18C\AC00 \C774 \C5F4 \B0B4\C5D0 \C874\C7AC\D558\BBC0\B85C, <strong>%0</strong> \AD6C\C131\C694\C18C\B97C <strong>\C5F4 %1</strong>\C5D0\C11C \B80C\B354\B9C1\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C77C\BC18\C801\C73C\B85C \C5F4\C744 <strong>\C790\B3D9</strong>\C73C\B85C \C124\C815\D558\BA74 \C774 \BB38\C81C\AC00 \D574\ACB0\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106114441156310378)
,p_name=>'WWV_FLOW_GRID_LAYOUT.LABEL_COLUMN_SPAN_TOO_BIG'
,p_message_language=>'ko'
,p_message_text=>unistr('<p>\C774 \D398\C774\C9C0 \D56D\BAA9\C758 \B808\C774\BE14 \C5F4 \D655\C7A5 \ADF8\B9AC\B4DC \C124\C815\C774 \BD80\C801\D569\D558\BBC0\B85C \D398\C774\C9C0 \D56D\BAA9 <strong>%0</strong>\C758 \B808\C774\BE14\C744 \B80C\B354\B9C1\D560 \C218 \C5C6\C2B5\B2C8\B2E4. <strong>%1\C758 \B808\C774\BE14 \C5F4 \D655\C7A5</strong>\ACFC \D568\AED8 \D45C\C2DC\B418\B3C4\B85D \C124\C815\B418\C5C8\C2B5\B2C8\B2E4. \D398\C774\C9C0 \D56D\BAA9 \C790\CCB4\C5D0\B294 \C0AC\C6A9\D560 \C218 \C788\B294 <strong>%2 \C5F4</strong>\B9CC \D3EC\D568\B418\BBC0\B85C \C774 \BC29\C2DD\C774 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105009960369309477)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_CALCULATED_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>%0</strong> \AD6C\C131\C694\C18C\B294 \C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \ADF8\B9AC\B4DC \C124\C815\C774 \BD80\C801\D569\D558\BBC0\B85C \B80C\B354\B9C1\D560 \C218 \C5C6\C2B5\B2C8\B2E4. <span>%2\C758 \C5F4 \D655\C7A5</strong>\C73C\B85C <strong>\C5F4 %1</strong>\C5D0 \D45C\C2DC\B418\B3C4\B85D \C124\C815\B418\C5C8\C2B5\B2C8\B2E4. \C774 \D398\C774\C9C0\C758 \ADF8\B9AC\B4DC\C5D0\C11C \CD5C\B300 <strong>%3 \C5F4</strong>\AE4C\C9C0\B9CC \C9C0\C6D0\B418\BBC0\B85C \C774\B7EC\D55C \C124\C815\C740 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\BAA8\B4E0 \AD6C\C131\C694\C18C\C5D0 \B300\D574 \C5F4 \BC0F \C5F4 \D655\C7A5\C744 <strong>\C790\B3D9</strong>\C73C\B85C \C124\C815\D558\BA74 \C77C\BC18\C801\C73C\B85C \C774 \BB38\C81C\AC00 \D574\ACB0\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105010034436309477)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_SUPPORTED_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>%0</strong> \AD6C\C131\C694\C18C\B294 \C774 \AD6C\C131\C694\C18C\C5D0 \B300\D55C \ADF8\B9AC\B4DC \C124\C815\C774 \BD80\C801\D569\D558\BBC0\B85C \B80C\B354\B9C1\D560 \C218 \C5C6\C2B5\B2C8\B2E4. <strong>%2\C758 \C5F4 \D655\C7A5</strong>\C73C\B85C <strong>\C5F4 %1</strong>\C5D0 \D45C\C2DC\B418\B3C4\B85D \C124\C815\B418\C5C8\C2B5\B2C8\B2E4. \C774 \D398\C774\C9C0\C758 \ADF8\B9AC\B4DC\C5D0\C11C <strong>%3 \C5F4</strong>\AE4C\C9C0\B9CC \C9C0\C6D0\B418\BBC0\B85C \C774\B7EC\D55C \C124\C815\C740 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\BAA8\B4E0 \AD6C\C131\C694\C18C\C5D0 \B300\D574 \C5F4 \BC0F \C5F4 \D655\C7A5\C744 <strong>\C790\B3D9</strong>\C73C\B85C \C124\C815\D558\BA74 \C77C\BC18\C801\C73C\B85C \C774 \BB38\C81C\AC00 \D574\ACB0\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104892121436309390)
,p_name=>'WWV_FLOW_HELP.2_DAY_DBA'
,p_message_language=>'ko'
,p_message_text=>'2 Day DBA'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104892012421309390)
,p_name=>'WWV_FLOW_HELP.2_DAY_DEV'
,p_message_language=>'ko'
,p_message_text=>unistr('2 Day + \AC1C\BC1C\C790 \C124\BA85\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104858416078309361)
,p_name=>'WWV_FLOW_HELP.ADMIN_GUIDE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC \C124\BA85\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104858525619309361)
,p_name=>'WWV_FLOW_HELP.API'
,p_message_language=>'ko'
,p_message_text=>unistr('API \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105434330436309805)
,p_name=>'WWV_FLOW_HELP.CONTENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105428320161309800)
,p_name=>'WWV_FLOW_HELP.CONTEXT_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105434493095309805)
,p_name=>'WWV_FLOW_HELP.FIND'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC3E\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104891961059309390)
,p_name=>'WWV_FLOW_HELP.HTMLDB_USER_GUIDE'
,p_message_language=>'ko'
,p_message_text=>'App Builder User''s Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105540380655309894)
,p_name=>'WWV_FLOW_HELP.INITIAL_INDEX_CREATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \C778\B371\C2A4 \C0DD\C131\C5D0 \C57D\AC04\C758 \C2DC\AC04\C774 \C18C\C694\B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104858652791309361)
,p_name=>'WWV_FLOW_HELP.MIGRATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C774\C804 \C124\BA85\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105434194159309805)
,p_name=>'WWV_FLOW_HELP.NO_INDEX_MAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85\C11C \B9E4\D551 \D30C\C77C %0\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105434507736309806)
,p_name=>'WWV_FLOW_HELP.SCORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C810\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104858729266309361)
,p_name=>'WWV_FLOW_HELP.SQL_WORKSHOP'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C6CC\D06C\C20D \BC0F \C720\D2F8\B9AC\D2F0 \C124\BA85\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105141299887309578)
,p_name=>'WWV_FLOW_HINT.CREATE_NORMALIZE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\ADDC\D654 \C0DD\C131 \C624\B958: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105317486568309711)
,p_name=>'WWV_FLOW_HINT.NO_PRIVS_ON_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C784\D3EC\D2B8 \C911\C778 \C2A4\D0A4\B9C8\C5D0 \C561\C138\C2A4\D560 \C218 \C788\B294 \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4. \C784\D3EC\D2B8\B97C \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105141197386309578)
,p_name=>'WWV_FLOW_HINT.REMOVE_TABLE_HINT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('remove_table_hint\AC00 p_table_id \C5C6\C774 \D638\CD9C\B418\C5C8\C2B5\B2C8\B2E4. \D14C\C774\BE14\C744 \C81C\ACF5\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105046902222309504)
,p_name=>'WWV_FLOW_IMP_PARSER.CREATE_WS_SEC_VIOLATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C744 \C124\CE58\D558\B294 \C911 \B450\BC88\C9F8 create_company \D638\CD9C\C774 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105009792665309477)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_BLOCK'
,p_message_language=>'ko'
,p_message_text=>unistr('GET_BLOCK \C624\B958\C785\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105009671498309477)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_STMT'
,p_message_language=>'ko'
,p_message_text=>unistr('GET_STMT \C624\B958\C785\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105009890067309477)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_FILE_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104875954922309377)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_INSTALL_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('Zip \C544\CE74\C774\BE0C\AC00 \BD80\C801\D569\D569\B2C8\B2E4. \C124\CE58 \B9E4\B2C8\D398\C2A4\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105013293030309479)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_PRIV'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C2A4\D0A4\B9C8\C5D0 \B300\D55C \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105009521498309477)
,p_name=>'WWV_FLOW_IMP_PARSER.RUN_STMT_ERROR'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\BA85\B839\BB38 \C2E4\D589\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4. %0'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105049528728309506)
,p_name=>'WWV_FLOW_IMP_PARSER.SEC_VIOLATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C775\C2A4\D3EC\D2B8 \D30C\C77C\C758 \B300\D615 \BE14\B85D \B0B4\C5D0\C11C remove_page \D504\B85C\C2DC\C800\C5D0 \B300\D55C API \D638\CD9C\C774 \AC10\C9C0\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105310858396309705)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_LABEL_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C5D0 \B300\D55C \B808\C774\BE14\C774 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104927674126309417)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_CONTAINS_WRONG_VERSION'
,p_message_language=>'ko'
,p_message_text=>unistr('Application Express \D30C\C77C\C774 \CD5C\C2E0\C774 \C544\B2C8\BBC0\B85C \D658\ACBD\C5D0 \BB38\C81C\AC00 \C788\C2B5\B2C8\B2E4! #LOADED_VERSION# \BC84\C804\C5D0 \B300\D55C \D30C\C77C\C774 \B85C\B4DC\B418\C5C8\C9C0\B9CC %0\C774(\AC00) \D544\C694\D569\B2C8\B2E4. \C124\CE58 \C124\BA85\C11C\C758 \C9C0\CE68\B300\B85C \C774\BBF8\C9C0 \B514\B809\D1A0\B9AC\B97C \C560\D50C\B9AC\CF00\C774\C158 \C11C\BC84\C5D0 \BCF5\C0AC\D588\B294\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104927521214309417)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_NOT_COPIED'
,p_message_language=>'ko'
,p_message_text=>unistr('Application Express \D30C\C77C\C774 \B85C\B4DC\B418\C9C0 \C54A\C558\C73C\BBC0\B85C \D658\ACBD\C5D0 \BB38\C81C\AC00 \C788\C2B5\B2C8\B2E4. \C124\CE58 \C124\BA85\C11C\C758 \C9C0\CE68\B300\B85C \C774\BBF8\C9C0 \B514\B809\D1A0\B9AC\B97C \C560\D50C\B9AC\CF00\C774\C158 \C11C\BC84\C5D0 \BCF5\C0AC\D588\B294\C9C0 \D655\C778\D558\C2ED\C2DC\C624. \B610\D55C \C774\BBF8\C9C0 \C811\B450\C5B4 \ACBD\B85C\AC00 \C62C\BC14\B978\C9C0 \D655\C778\D558\C2ED\C2DC\C624. \D604\C7AC \ACBD\B85C\B294 %0\C785\B2C8\B2E4(\C5EC\AE30\C5D0\B294 \C2DC\C791 \BC0F \C885\B8CC \C2AC\B798\C2DC\AC00 \BAA8\B450 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4. \C608: \AE30\BCF8\AC12 /i/). \ACBD\B85C\B97C \BCC0\ACBD\D574\C57C \D558\B294 \ACBD\C6B0 SQL \C2A4\D06C\B9BD\D2B8 reset_image_prefix.sql\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105131151363309571)
,p_name=>'WWV_FLOW_JOB.UNAUTHORIZED_ATTEMPT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('%2 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C %1 \C2A4\D0A4\B9C8\AC00 %0 \C791\C5C5\C744 \BB34\B2E8\C73C\B85C \C2E4\D589\D558\B824\ACE0 \D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105141721033309579)
,p_name=>'WWV_FLOW_LOAD_DATA.COLLECTION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C74C\C744 \C0DD\C131\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105141397600309578)
,p_name=>'WWV_FLOW_LOAD_DATA.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105141461067309578)
,p_name=>'WWV_FLOW_LOAD_DATA.FIND_DATA_TYPE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C720\D615 \CC3E\AE30 \C624\B958: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105141683478309579)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_DATATYPE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C720\D615 \AC00\C838\C624\AE30 \C624\B958: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105141559536309578)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_MAX_COL_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 \C5F4 \AE38\C774 \AC00\C838\C624\AE30 \C624\B958 1: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105329488962309720)
,p_name=>'WWV_FLOW_LOAD_DATA.NO_32KB_INSERT'
,p_message_language=>'ko'
,p_message_text=>unistr('32KB\B97C \CD08\ACFC\D558\B294 \B370\C774\D130\AC00 \C788\B294 \D589\C744 \C0BD\C785\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105141875437309579)
,p_name=>'WWV_FLOW_LOOKUP_TABLES.PRIVS_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 %0\C5D0\AC8C %1 \C2A4\D0A4\B9C8\C5D0 \B300\D55C \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105132806394309572)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.BRANCH_COND_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BD84\AE30 \C870\AC74 \C720\D615\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105132716386309572)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_BUTTON_COND_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B2E8\CD94 \C870\AC74 \C720\D615\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105132536399309572)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_COMP_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \ACC4\C0B0 \C720\D615\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105132444878309572)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_PROC_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74 \C720\D615\C774 \B2E4\C74C\ACFC \AC19\C744 \B54C \C560\D50C\B9AC\CF00\C774\C158 \D504\B85C\C138\C2A4\B97C \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105133249160309572)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_MISSPELL_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA0\C790\AC00 \C798\BABB\B41C \B2E8\C5B4\B97C \C5C5\B370\C774\D2B8\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105132344275309572)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_NAVBAR_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904 \D45C\C2DC \C870\AC74 \C720\D615\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105132920406309572)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_COMP_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \ACC4\C0B0 \C720\D615\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105133190162309572)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_PROC_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D504\B85C\C138\C2A4 \C720\D615\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105132686044309572)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_SUBTITLE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D558\C704 \C81C\BAA9 \C720\D615\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105133072257309572)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_VALID_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \AC80\C99D \C720\D615\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105679707677310012)
,p_name=>'WWV_FLOW_NATIVE_ITEM.AUTOCOMPLETE_RESTRICTION'
,p_message_language=>'ko'
,p_message_text=>unistr('%0: "\C885\C18D LOV \C0C1\C704 \D56D\BAA9"\C740 "\C9C0\C5F0 \B85C\B529"\C774 [\C608]\B85C \C124\C815\B41C \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105670915029310004)
,p_name=>'WWV_FLOW_NATIVE_ITEM.MULTIPLE_DML_PROCESSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958: \D398\C774\C9C0\B2F9 \D55C \AC1C\C758 DML \D504\B85C\C138\C2A4\B9CC \C120\C5B8\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105670803322310004)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_DML_PROCESS_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958: %0 \D398\C774\C9C0\C5D0 \B300\D55C \D574\B2F9 DML \D504\B85C\C138\C2A4\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105671989746310005)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_VALID_BLOB_SOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0\B294 \C801\D569\D55C BLOB \C5F4\C774 \C18C\C2A4\B85C \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105632648588309970)
,p_name=>'WWV_FLOW_NATIVE_ITEM.PLSQL_CODE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML\C744 \B0B4\BCF4\B0B4\B294 PL/SQL \CF54\B4DC\B97C %0 \D56D\BAA9\C5D0 \B300\D574 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105142766399309579)
,p_name=>'WWV_FLOW_PARSER.BULK_COLLECT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\B7C9\C73C\B85C \C218\C9D1\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105142441794309579)
,p_name=>'WWV_FLOW_PARSER.CHECK_CODE_PARSE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF54\B4DC \AD6C\BB38\C774 \BD84\C11D\B418\C5C8\B294\C9C0 \C5EC\BD80\B97C \D655\C778\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105142506678309579)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \D30C\C77C\C744 \C2E4\D589\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105143288624309580)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_STATS_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \D30C\C77C \D1B5\ACC4\B97C \AC80\C0AC\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105143113265309580)
,p_name=>'WWV_FLOW_PARSER.DELETE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BB38\BD84\C11D\B41C \C815\BCF4\B97C \C0AD\C81C\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105143063512309580)
,p_name=>'WWV_FLOW_PARSER.EXECUTION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA85\B839\BB38 \C2E4\D589 \C2E4\D328: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105141979073309579)
,p_name=>'WWV_FLOW_PARSER.FIND_FILE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105142144118309579)
,p_name=>'WWV_FLOW_PARSER.GET_STATEMENT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA85\B839\BB38\C744 \AC00\C838\C62C \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105108264829309548)
,p_name=>'WWV_FLOW_PARSER.LINE_TOO_LONG'
,p_message_language=>'ko'
,p_message_text=>unistr('%2 \D589\C5D0\C11C \D589 \AE38\C774 %0\C774(\AC00) \CD5C\B300\AC12 %1\C744(\B97C) \CD08\ACFC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105142904553309579)
,p_name=>'WWV_FLOW_PARSER.PACKAGE_COMP_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: \CEF4\D30C\C77C \C624\B958\C640 \D568\AED8 \D328\D0A4\C9C0 \BCF8\BB38\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105142617000309579)
,p_name=>'WWV_FLOW_PARSER.RUN_CODE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF54\B4DC\B97C \C2E4\D589\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105142830276309579)
,p_name=>'WWV_FLOW_PARSER.RUN_STATEMENT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA85\B839\BB38\C744 \C2E4\D589\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105142288513309579)
,p_name=>'WWV_FLOW_PARSER.SAVE_PARAMETER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4\C5D0 \B9E4\AC1C\BCC0\C218\B97C \C800\C7A5\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105142092670309579)
,p_name=>'WWV_FLOW_PARSER.UNABLE_GET_CODE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF54\B4DC \BE14\B85D\C744 \AC00\C838\C62C \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105142305570309579)
,p_name=>'WWV_FLOW_PARSER.VALIDATE_FILE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D30C\C77C\C744 \AC80\C99D\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105143351181309580)
,p_name=>'WWV_FLOW_PARSER_PUBLIC.PARSE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \AD6C\BB38\C744 \BD84\C11D\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105525781885309882)
,p_name=>'WWV_FLOW_PLUGIN.NO_AUTHENTICATION_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D50C\B7EC\ADF8\C778\C5D0 \B300\D574 \C815\C758\B41C \C778\C99D \D568\C218\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105525876266309883)
,p_name=>'WWV_FLOW_PLUGIN.NO_POST_LOGOUT_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D50C\B7EC\ADF8\C778\C5D0 \B300\D574 \C815\C758\B41C \C0AC\D6C4 \B85C\ADF8\C544\C6C3 \D568\C218\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105525658984309882)
,p_name=>'WWV_FLOW_PLUGIN.NO_SESSION_SENTRY_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D50C\B7EC\ADF8\C778\C5D0 \B300\D574 \C815\C758\B41C \C138\C158 \AC10\C2DC \D568\C218\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106078904136310345)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106078160963310345)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_DEFINED_BY_DA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5\C5D0 \C758\D574 \C815\C758\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106077853552310344)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106078057510310344)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('URL\B85C \C7AC\C9C0\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106077958215310344)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_SUBMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106078589413310345)
,p_name=>'WWV_FLOW_PLUGIN_DEV.CLEAR_CACHE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE90\C2DC \BE44\C6B0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105630593764309968)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_LEGACY_LOV_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('LOV \C9C8\C758\AC00 \BD80\C801\D569\D569\B2C8\B2E4. \D45C\C2DC \AC12\ACFC \BC18\D658 \AC12\C774 \D544\C694\D558\ACE0 \C5F4 \C774\B984\C774 \B2EC\B77C\C57C \D569\B2C8\B2E4. \C9C8\C758\C5D0 \C778\B77C\C778 \C9C8\C758\AC00 \D3EC\D568\B41C \ACBD\C6B0 SQL \BB38\C758 \CCAB\BC88\C9F8 FROM \C808\C740 \C778\B77C\C778 \C9C8\C758\C5D0 \C18D\D558\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105632246959309969)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_REGION_SOURCE_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18C\C2A4 \C9C8\C758\C758 \AD6C\BB38\BD84\C11D\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4! %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105013397039309479)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758 \AD6C\BB38\BD84\C11D \C2E4\D328! %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106101832361310366)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL_SIMPLE'
,p_message_language=>'ko'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105630650996309968)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_STATIC_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 LOV\AC00 \BD80\C801\D569\D569\B2C8\B2E4. \D45C\C2DC \AC12\ACFC \BC18\D658 \AC12\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105566292883309915)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14, \BDF0 \B610\B294 \B3D9\C758\C5B4\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105012860681309479)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_OPTIONAL'
,p_message_language=>'ko'
,p_message_text=>unistr('- \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105630942578309968)
,p_name=>'WWV_FLOW_PLUGIN_DEV.LOV_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('LOV(\AC12 \BAA9\B85D) \C9C8\C758 \B610\B294 \C774\B984\C774 \C9C0\C815\B41C \AC12 \BAA9\B85D\C744 \C774 \D45C\C2DC\B97C \C720\D615\C73C\B85C \C0AC\C6A9\D558\B294 \D56D\BAA9\C5D0 \B300\D574 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105630834186309968)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NAMED_LOV_NOT_ALLOWED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 \C9C0\C815\B41C LOV(\AC12 \BAA9\B85D) \C0AC\C6A9\C740 \C801\C5B4\B3C4 \B450 \AC1C\C758 LOV \C5F4\C774 \D544\C694\D55C \D56D\BAA9 \C720\D615\C5D0 \B300\D574\C11C\B9CC \C9C0\C6D0\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105013588113309479)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_INTEGER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C740 \C815\C218\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105013448137309479)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C740 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106078228004310345)
,p_name=>'WWV_FLOW_PLUGIN_DEV.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104939172409309425)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C758 \B370\C774\D130 \C720\D615\C774 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4. \C774 \C18D\C131\C744 \C0AC\C6A9\D558\B824\BA74 \C5F4\C5D0 \B2E4\C74C \B370\C774\D130 \C720\D615 \C911 \D558\B098\AC00 \C788\C5B4\C57C \D569\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104927498353309417)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 \C874\C7AC\D558\C9C0 \C54A\AC70\B098 \C601\C5ED \C18C\C2A4 \C9C8\C758\AC00 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104939222111309425)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_WRONG_DATA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C798\BABB\B41C \B370\C774\D130 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105631872782309969)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C601\C5ED \C720\D615\C758 \C601\C5ED\C5D0 \B300\D574 \C601\C5ED \C18C\C2A4\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105631956403309969)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984 "%0"\C740(\B294) \C601\C5ED \C18C\C2A4 \C9C8\C758\C5D0 \C774\BBF8 \C0AC\C6A9 \C911\C785\B2C8\B2E4. \C5F4\C5D0 \B300\D574 \ACE0\C720\D55C \BCC4\CE6D \C774\B984\C744 \C0AC\C6A9 \C911\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105632043566309969)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984 "%0"\C740(\B294) \C601\C5ED \C18C\C2A4 \C9C8\C758\C5D0 \B300\D574 \BD80\C801\D569\D569\B2C8\B2E4. \C5F4\C5D0 \B300\D574 \ACE0\C720\D55C \BCC4\CE6D \C774\B984\C744 \C0AC\C6A9 \C911\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105632167981309969)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C18C\C2A4 \C9C8\C758\C5D0\C11C \C120\D0DD\B41C \C5F4 \C218\AC00 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4. \C801\D569\D55C \BA85\B839\BB38\C740 \C608\C81C\B97C \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106078495527310345)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REQUEST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106078371224310345)
,p_name=>'WWV_FLOW_PLUGIN_DEV.RESET_PAGINATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0 \B300\D55C \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106078600339310345)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SET_THESE_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105631532945309969)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984 "%0"\C740(\B294) SQL \C9C8\C758\C5D0 \C774\BBF8 \C0AC\C6A9 \C911\C785\B2C8\B2E4. \C5F4\C5D0 \B300\D574 \ACE0\C720\D55C \BCC4\CE6D \C774\B984\C744 \C0AC\C6A9 \C911\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105631492630309968)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_INVALID_COLUMN_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C774\B984 "%0"\C740(\B294) SQL \C9C8\C758\C5D0 \B300\D574 \BD80\C801\D569\D569\B2C8\B2E4. \C5F4\C5D0 \B300\D574 \ACE0\C720\D55C \BCC4\CE6D \C774\B984\C744 \C0AC\C6A9 \C911\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105014418576309480)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\C5D0\C11C \C120\D0DD\B41C \C5F4 \C218\AC00 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4. \C790\C138\D55C \B0B4\C6A9\C740 \C18D\C131 \B3C4\C6C0\B9D0\C744 \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105630720869309968)
,p_name=>'WWV_FLOW_PLUGIN_DEV.STATIC_LOV_NOT_ALLOWED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 LOV(\AC12 \BAA9\B85D)\B294 \C801\C5B4\B3C4 \B450 \AC1C\C758 LOV \C5F4\C774 \D544\C694\D55C \D56D\BAA9 \C720\D615\C5D0 \B300\D574\C11C\B9CC \C9C0\C6D0\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106078852609310345)
,p_name=>'WWV_FLOW_PLUGIN_DEV.URL_TARGET'
,p_message_language=>'ko'
,p_message_text=>unistr('URL \B300\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106078789920310345)
,p_name=>'WWV_FLOW_PLUGIN_DEV.WITH_THESE_VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105133492742309573)
,p_name=>'WWV_FLOW_POPUP_LOV.CONVERT_ID_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1711 \C694\CCAD\C5D0 \C788\B294 \D31D\C5C5 LOV ID\B97C \BCC0\D658\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105133598228309573)
,p_name=>'WWV_FLOW_POPUP_LOV.FIND_ITEM_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1721 \C694\CCAD\C5D0\C11C \D31D\C5C5 LOV ID\C5D0 \B300\D55C \D56D\BAA9\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104907391675309402)
,p_name=>'WWV_FLOW_PRINT_UTIL.INVALID_PROXY_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\D55C URL\C774 \BD80\C815\D655\D558\AC70\B098 \D504\B85D\C2DC URL\C744 \C9C0\C815\D574\C57C \D558\AE30 \B54C\BB38\C5D0 \C778\C1C4 \C5D4\C9C4\C5D0 \B3C4\B2EC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105811903908310117)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.ABOVE_BOX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C704')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105812308008310117)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BELOW_BOX'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C544\B798')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105812493260310117)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BOTTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D558\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105812072110310117)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.LEFT_OF_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9 \C67C\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105811621151310117)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_IR_SEARCH_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C758 \C624\B978\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105812119570310117)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9 \C624\B978\CABD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105812263515310117)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TEMPLATE_DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105811753687310117)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C0C1\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105811893193310117)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP_AND_BOTTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C0C1\B2E8 \BC0F \D558\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105812540044310118)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.AFTER_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \B4A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105812629487310118)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.BEFORE_FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC14\B2E5\AE00 \C55E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106035135604310305)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \B2E4\B978 \C0AC\C6A9\C790\AC00 \C0AD\C81C\D588\C744 \C218 \C788\C2B5\B2C8\B2E4. \D398\C774\C9C0\B97C \B2E4\C2DC \B85C\B4DC\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106035079863310304)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED'
,p_message_language=>'ko'
,p_message_text=>unistr('''%0'' \AD6C\C131\C694\C18C\AC00 \C774 \AD6C\C131\C694\C18C\B97C \CC38\C870\D558\BBC0\B85C \C0AD\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106034916768310304)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D398\C774\C9C0\C758 ''%0'' \AD6C\C131\C694\C18C\AC00 \C774 \AD6C\C131\C694\C18C\B97C \CC38\C870\D558\BBC0\B85C \C0AD\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106035291248310305)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_CHANGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18D\C131\C744 \B2E4\B978 \C0AC\C6A9\C790\AC00 \C774\BBF8 \BCC0\ACBD\D588\C2B5\B2C8\B2E4. \D398\C774\C9C0\B97C \B2E4\C2DC \B85C\B4DC\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106035476199310305)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \CEE8\D14D\C2A4\D2B8\C5D0\C11C\B294 \C18D\C131\C744 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106035339329310305)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\C694\C18C\B97C \B2E4\B978 \C0AC\C6A9\C790\AC00 \C774\BBF8 \BCC0\ACBD\D588\C73C\BA70 \C774 \C18D\C131\C740 \B354 \C774\C0C1 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \D398\C774\C9C0\B97C \B2E4\C2DC \B85C\B4DC\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105529634115309886)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\D658\B41C \C9C8\C758 \AD6C\BB38\BD84\C11D \ACB0\ACFC\B294 "%0"\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106122260241310385)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BB38\BD84\C11D\C73C\B85C "%0"\C5D0 \C9C8\C758 \ACB0\ACFC\AC00 \BC18\D658\B418\C5C8\C2B5\B2C8\B2E4. \C9C8\C758\AC00 \AD6C\BB38\C801\C73C\B85C \C62C\BC14\B974\B2E4\ACE0 \C0DD\AC01\D558\B294 \ACBD\C6B0 \AD6C\BB38\BD84\C11D \C5C6\C774 \ACC4\C18D\D558\B824\BA74 \C544\B798 "\C77C\BC18 \C5F4 \C774\B984 \C0AC\C6A9" \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106073657230310340)
,p_name=>'WWV_FLOW_PROPERTY_DEV.MUST_BE_UNIQUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720\D574\C57C \D569\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105812750819310118)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NO_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105529562470309886)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('pl/sql \BE14\B85D\C73C\B85C \BC18\D658\B41C \C9C8\C758\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106122326350310385)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \BE14\B85D\C5D0\C11C \BC18\D658\D55C \C9C8\C758\AC00 \C5C6\C2B5\B2C8\B2E4. \CF54\B4DC\AC00 \AD6C\BB38\C801\C73C\B85C \C62C\BC14\B974\B2E4\ACE0 \C0DD\AC01\D558\B294 \ACBD\C6B0 \AD6C\BB38\BD84\C11D \C5C6\C774 \ACC4\C18D\D558\B824\BA74 \C544\B798 "\C77C\BC18 \C5F4 \C774\B984 \C0AC\C6A9" \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105812970143310118)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B97C \B2E4\B978 \C0AC\C6A9\C790\AC00 \C7A0\AC14\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105812892283310118)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED_SAVE_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\AC00 \D604\C7AC %0\C5D0 \C758\D574 \C7A0\ACA8 \C788\C2B5\B2C8\B2E4. \BCC0\ACBD\C0AC\D56D\C744 \C800\C7A5\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105419895399309793)
,p_name=>'WWV_FLOW_PROVISION.CANNOT_EXTEND_TS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 %0\C5D0 \B300\D55C \C2A4\D0A4\B9C8\AC00 \B354 \C774\C0C1 \C874\C7AC\D558\C9C0 \C54A\C544 \D14C\C774\BE14\C2A4\D398\C774\C2A4\B97C \D655\C7A5\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105133651794309573)
,p_name=>'WWV_FLOW_PROVISION.DROP_TABLESPACE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('drop_tablespace\C5D0 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. p_name\C774 \B110\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105133896396309573)
,p_name=>'WWV_FLOW_PROVISION.DROP_USER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('drop_user\C5D0 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. l_username\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106129245653310392)
,p_name=>'WWV_FLOW_PROVISION.ENCRYPTION_WALLET_NOT_OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C554\D638\D654 Wallet\C774 \C5F4\B824 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104932410768309420)
,p_name=>'WWV_FLOW_PROVISION.ILLEGAL_PASSWORD'
,p_message_language=>'ko'
,p_message_text=>unistr('wwv_flow_provision.create_user\C5D0 \C798\BABB\B41C \BE44\BC00\BC88\D638 \BB38\C790\C5F4\C774 \C804\B2EC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105134410035309573)
,p_name=>'WWV_FLOW_PROVISION.REMOVE_COMPANY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('remove_provisioned_company.\C5D0 \C624\B958\AC00 \C788\C2B5\B2C8\B2E4. \C791\C5C5\C601\C5ED\C774 \B110\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105134260873309573)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_TABLESPACE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C2A4\D398\C774\C2A4\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105134170489309573)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_USER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105133721212309573)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_TABLESPACE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C2A4\D398\C774\C2A4\B97C \C0AD\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C624\B958: %0 \005CnSQL:\005Cn %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105133946392309573)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_USER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\B97C \C0AD\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C624\B958: %0 \005CnSQL:\005Cn %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105134388846309573)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_GRANT_PRIVS_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \AD8C\D55C\C744 \BD80\C5EC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104898697389309396)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_TO_CREATE_TABLESPACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\AE08 \D14C\C774\BE14\C2A4\D398\C774\C2A4\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \B098\C911\C5D0 \B2E4\C2DC \C2DC\B3C4\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105134057634309573)
,p_name=>'WWV_FLOW_PROVISION.WITH_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \BC1C\C0DD: %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104977005832309453)
,p_name=>'WWV_FLOW_PROVISIONING.AUTO_PROVISION_FAILURE'
,p_message_language=>'ko'
,p_message_text=>unistr('"MAKE_REQUEST" \B2E8\ACC4\B97C \C218\D589\D558\B294 \C911 \C790\B3D9 \B4F1\B85D\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104996687493309467)
,p_name=>'WWV_FLOW_PROVISIONING.CANNOT_FIND_SGID'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C9C0\C815\B41C \C791\C5C5\C601\C5ED ID "%0"\C5D0 \B300\D55C \BCF4\C548 \ADF8\B8F9 ID\B97C \D655\C778\D560 \C218 \C5C6\C74C'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104977382893309453)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_RESERVED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C791\C5C5\C601\C5ED\C740 \C608\C57D\B41C \C774\B984\C774\BBC0\B85C \C694\CCAD\C774 \AC70\BD80\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104977119057309453)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_USER_ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C791\C5C5\C601\C5ED\C5D0 \C0AC\C6A9\C790\B97C \CD94\AC00\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105134722792309574)
,p_name=>'WWV_FLOW_PROVISIONING.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105116593228309554)
,p_name=>'WWV_FLOW_PROVISIONING.NOT_IMPLEMENTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\D604\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104976863815309453)
,p_name=>'WWV_FLOW_PROVISIONING.NO_COMPANY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C791\C5C5\C601\C5ED ID\B97C \C0AC\C6A9\D558\B294 \C791\C5C5\C601\C5ED\C744 \CC3E\C744 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104976918297309453)
,p_name=>'WWV_FLOW_PROVISIONING.NO_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C791\C5C5\C601\C5ED ID\C5D0 \B300\D574 \C9C0\C815\B41C \C2A4\D0A4\B9C8 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104996739706309467)
,p_name=>'WWV_FLOW_PROVISIONING.REMOVE_LAST_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AE30\B2A5\C744 \C0AC\C6A9\D558\C5EC \C791\C5C5\C601\C5ED\C758 \B9C8\C9C0\B9C9 \C2A4\D0A4\B9C8\B97C \C81C\AC70\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104977754212309453)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C694\CCAD\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104977522699309453)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_PROCESSED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C694\CCAD\C744 \CC98\B9AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.  %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104977220869309453)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_PROCESSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C694\CCAD\C774 \CC98\B9AC\B418\C5C8\AC70\B098 \CC98\B9AC \C911\C785\B2C8\B2E4. \C0C1\D0DC\B294 "%0"\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104997016935309467)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_COMPANY'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \C791\C5C5\C601\C5ED\C5D0 \C0AC\C6A9\C790 \C774\B984 %0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104996977118309467)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\ACFC \C5F0\AD00\B418\C9C0 \C54A\C740 \C2A4\D0A4\B9C8\C5D0 \B300\D574\C11C\B294 \BE44\BC00\BC88\D638 \C7AC\C124\C815\C774 \D5C8\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104996837782309467)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_RESERVED_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C2A4\D0A4\B9C8\C5D0 \B300\D55C \BE44\BC00\BC88\D638\B97C \C7AC\C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104977682176309453)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \C2A4\D0A4\B9C8\AC00 %2 \D14C\C774\BE14\C5D0 \C874\C7AC\D558\BBC0\B85C %0 \C694\CCAD\C744 \CC98\B9AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104977403920309453)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_RESERVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0A4\B9C8 \C774\B984 %0\C740(\B294) \C608\C57D\B41C \C2A4\D0A4\B9C8\C774\BBC0\B85C \B4F1\B85D\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104976765516309453)
,p_name=>'WWV_FLOW_PROVISIONING.USER_NO_PRIVILEGES'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('%0 \C0AC\C6A9\C790\C5D0\AC8C %1 \C2A4\D0A4\B9C8\C5D0 \B300\D55C \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104936725023309423)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYSIS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \BD84\C11D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104939598122309425)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\C11D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104922428516309413)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_DBACCOUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \ACC4\C815 \C99D\BA85\C11C\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104953598405309436)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_INTERNAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B0B4\BD80 %0 \ACC4\C815 \C99D\BA85\C11C \BC0F \B85C\ADF8\C778 \D398\C774\C9C0\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105632866615309970)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_SSO'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Application Server Single Sign-On\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104936823021309424)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CC28\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104936608685309423)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHOOSE_A_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104938803914309425)
,p_name=>'WWV_FLOW_QUICK_FLOW.CLEAR_CACHE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE90\C2DC\B97C \BE44\C6B8 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106016479167310286)
,p_name=>'WWV_FLOW_QUICK_FLOW.COLUMN_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('#COLUMN_HEADER# \AC12\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104966963377309445)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_ANALYZE_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\C11D \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104985148209309459)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_BUTTON_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D15C\D50C\B9AC\D2B8\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104985997111309459)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_CHART_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104984505622309458)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_FLOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104986383220309460)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_HOME_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648 \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104985765734309459)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_INSERT_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0BD\C785 \D3FC\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104984700091309458)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LABEL_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \D15C\D50C\B9AC\D2B8\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104986444721309460)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104986511799309460)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D56D\BAA9\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104984458133309458)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D15C\D50C\B9AC\D2B8\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104985507777309459)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104985063841309459)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104986911147309460)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MODULES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4C8\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104985428426309459)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NAVBAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9\D45C\C2DC\C904\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104937077344309424)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 %0 \C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104939730515309426)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C \B9CC\B4E4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104984657914309458)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_PAGE_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104984956033309459)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REGION_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D15C\D50C\B9AC\D2B8\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104985663436309459)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104984843008309458)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104986643944309460)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_SUCCESS_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5 \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104985361481309459)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D0ED\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104985850792309459)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_UPDATE_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \D3FC\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104938799848309425)
,p_name=>'WWV_FLOW_QUICK_FLOW.CSV_LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D504\B808\B4DC\C2DC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106016622085310286)
,p_name=>'WWV_FLOW_QUICK_FLOW.DATE_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('#COLUMN_HEADER#\B294 \C801\D569\D55C \B0A0\C9DC\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104986707378309460)
,p_name=>'WWV_FLOW_QUICK_FLOW.DEFINE_DEFAULT_TEMPLATES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D15C\D50C\B9AC\D2B8\B97C \C815\C758\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104941238883309427)
,p_name=>'WWV_FLOW_QUICK_FLOW.DISPLAY_REGION_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C601\C5ED\C744 \D45C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104938203188309425)
,p_name=>'WWV_FLOW_QUICK_FLOW.HELP_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0\B294 \D398\C774\C9C0\C5D0 \B300\D55C \B3C4\C6C0\B9D0\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104938550042309425)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0BD\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104936966329309424)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \C0BD\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104937783659309424)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ANOTHER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \D56D\BAA9 \C0BD\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104939036960309425)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \D589\C744 \C0BD\C785\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104937698232309424)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\AC00 \C131\ACF5\C801\C73C\B85C \C0BD\C785\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105400865913309773)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740 \C801\D569\D55C \B0A0\C9DC\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104937480645309424)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_NUM'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105337086205309726)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_TIMESTAMP'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740 \C801\D569\D55C \C2DC\AC04\AE30\B85D\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104938442907309425)
,p_name=>'WWV_FLOW_QUICK_FLOW.MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C774\B3D9 \ACBD\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104937392994309424)
,p_name=>'WWV_FLOW_QUICK_FLOW.NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \AC12\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106016520140310286)
,p_name=>'WWV_FLOW_QUICK_FLOW.NUMERIC_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('#COLUMN_HEADER#\B294 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104985262206309459)
,p_name=>'WWV_FLOW_QUICK_FLOW.POPUP_LOV_TEMPLATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D \D15C\D50C\B9AC\D2B8\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104939607089309426)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_AND_EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0 \BC0F \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104938687492309425)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\B97C \D45C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104938952258309425)
,p_name=>'WWV_FLOW_QUICK_FLOW.RESET_PAGINATION_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C744 \C7AC\C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104937915850309424)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648\C73C\B85C \B3CC\C544\AC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104938382899309425)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_PREV_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804 \D398\C774\C9C0\B85C \B3CC\C544\AC00\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104936419994309423)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106053554673310322)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.ALL_APPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C560\D50C\B9AC\CF00\C774\C158 \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106052702989310321)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.APPS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106052597945310321)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.TEAM.DEV'
,p_message_language=>'ko'
,p_message_text=>unistr('\D300 \AC1C\BC1C \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106053202878310321)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104936571523309423)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_CHART_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \D45C\C2DC \AE30\C900')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104940969664309427)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_MENU_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C\B97C \D45C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104938025372309424)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104937553262309424)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5 \D398\C774\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106016731392310286)
,p_name=>'WWV_FLOW_QUICK_FLOW.TIMESTAMP_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('#COLUMN_HEADER#\B294 \C801\D569\D55C \C2DC\AC04\AE30\B85D \AC12\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104937219874309424)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104937191595309424)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104986821261309460)
,p_name=>'WWV_FLOW_QUICK_FLOW.USE_ONE_LEVEL_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D55C \B808\BCA8\C758 \D0ED\C744 \C0AC\C6A9\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C744 \C0DD\C131\B9CC \D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104937836335309424)
,p_name=>'WWV_FLOW_QUICK_FLOW.VIEW_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104967910313309446)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ABOUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104968008230309446)
,p_name=>'WWV_FLOW_REGION_LAYOUT.BRANCHING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105132230790309572)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104958231982309439)
,p_name=>'WWV_FLOW_REGION_NATIVE.JQM_LIST_VIEW.NESTED_LIST_CLIENT_SEARCH_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\CCA9\B41C \BAA9\B85D\C774 \AC80\C0C9 \C720\D615\C73C\B85C "\D074\B77C\C774\C5B8\D2B8\CE21"\B9CC \C9C0\C6D0\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105120370164309557)
,p_name=>'WWV_FLOW_REGION_TREE.UNEXPECTED_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608\C0C1\CE58 \C54A\C740 \C624\B958 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105103992544309545)
,p_name=>'WWV_FLOW_REGION_TREES.ROOT_NOT_FND_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: \D2B8\B9AC \B8E8\D2B8 ID "%0"\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105316248512309710)
,p_name=>'WWV_FLOW_REMOTE_EXEC.RUN_PLSQL_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0\ACA9 SQL \CC98\B9AC \C911 \BC1C\C0DD\D55C PLSQL \CF54\B4DC\C5D0 \C624\B958\AC00 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104876250572309377)
,p_name=>'WWV_FLOW_REPORT_DEV.CREATE_CARDS_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE74\B4DC \D398\C774\C9C0\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105458055779309826)
,p_name=>'WWV_FLOW_REST.NOT_ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('RESTful \C561\C138\C2A4\AC00 \C774 \C778\C2A4\D134\C2A4\C5D0 \B300\D574 \C0AC\C6A9\C73C\B85C \C124\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105456341996309825)
,p_name=>'WWV_FLOW_REST.NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED\C744 \CC3E\C744 \C218 \C5C6\AC70\B098 REST\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105456485990309825)
,p_name=>'WWV_FLOW_REST.NO_OUTPUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD9C\B825 \BA54\C18C\B4DC\AC00 \C9C0\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105106961723309547)
,p_name=>'WWV_FLOW_SECURITY.COMPANY_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105107033932309547)
,p_name=>'WWV_FLOW_SECURITY.FLOW_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105107127551309547)
,p_name=>'WWV_FLOW_SECURITY.INVALID_USER_PASS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984 "%0" \B610\B294 \BE44\BC00\BC88\D638\AC00 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105336429742309725)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.INSERTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C18D\C131 %0\C774(\AC00) \C0BD\C785\B418\C5B4 \BC88\C5ED\C774 \D544\C694\D560 \C218 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105336506402309725)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.PURGED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C18D\C131\C774 \BE44\C6CC\C84C\C73C\BBC0\B85C \B354 \C774\C0C1 \BC88\C5ED\C774 \D544\C694\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104968862963309447)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_DELETE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\B4DC \C0AD\C81C \C624\B958: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104968754929309447)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_INSERT_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\B4DC \C0BD\C785 \C624\B958: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105336612382309726)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TOTAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D %0\AC1C\C758 \C18D\C131\C5D0 \BC88\C5ED\C774 \D544\C694\D560 \C218 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104968665213309447)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TRANSLATION_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \C560\D50C\B9AC\CF00\C774\C158\C758 %0 \BC88\C5ED\C744 \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105336313779309725)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C18D\C131 %0\C774(\AC00) \C5C5\B370\C774\D2B8\B418\C5B4 \BC88\C5ED\C774 \D544\C694\D560 \C218 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105143472329309580)
,p_name=>'WWV_FLOW_SERIES_ATTR.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105406822976309777)
,p_name=>'WWV_FLOW_SESSION_MON.NO_INDEX'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \C778\B371\C2A4 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105337554814309726)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_INCOMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('<code>%0</code> \BAA8\C74C\C758 \B370\C774\D130\C5D0 <b id="incompl_success_row_count"></b>\AC1C\C758 \C0C8 \BB38\C11C\AC00 \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4. <b class="u-danger-text" id="incompl_fail_row_count"></b>\AC1C \BB38\C11C\AC00 \AC70\BD80\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105337388022309726)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('<code>%0</code> \BAA8\C74C\C758 \B370\C774\D130\C5D0 <b id="success_row_count"></b>\AC1C\C758 \C0C8 \BB38\C11C\AC00 \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104875397498309376)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CF58\D150\CE20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105337749990309726)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D06C\AE30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104875547790309377)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104875299101309376)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_KEY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104875674081309377)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_LASTMODIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C885 \C218\C815 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104875480950309377)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_MEDIA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\CCB4 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104880677578309381)
,p_name=>'WWV_FLOW_SODA_DEV.DATA_GUIDE_NOT_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \AC00\C774\B4DC\B97C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \BAA8\C74C\C5D0 \B370\C774\D130\AC00 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\AC70\B098 \C0DD\C131\B41C JSON \AC80\C0C9 \C778\B371\C2A4\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104874503592309376)
,p_name=>'WWV_FLOW_SODA_DEV.FILE_FORMATS'
,p_message_language=>'ko'
,p_message_text=>unistr('JSON, TXT \B610\B294 ZIP \D30C\C77C\C744 \C5C5\B85C\B4DC\D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104880720573309381)
,p_name=>'WWV_FLOW_SODA_DEV.META_DATA_NOT_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C74C \BA54\D0C0\B370\C774\D130\B97C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \BAA8\C74C \C774\B984\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105337694075309726)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_INCOMPLETE'
,p_message_language=>'ko'
,p_message_text=>unistr('<code>%0</code> \BAA8\C74C\C758 \B370\C774\D130\AC00 <b id="incompl_success_row_count"></b>\AC1C\C758 \C0C8 \BB38\C11C\B85C \BC14\B00C\C5C8\C2B5\B2C8\B2E4. <b class="u-danger-text" id="incompl_fail_row_count"></b>\AC1C \BB38\C11C\AC00 \AC70\BD80\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105337453594309726)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('<code>%0</code> \BAA8\C74C\C758 \B370\C774\D130\AC00 <b id="success_row_count"></b>\AC1C\C758 \C0C8 \BB38\C11C\B85C \BC14\B00C\C5C8\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105121204096309557)
,p_name=>'WWV_FLOW_SVG.AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: \CD95 \AC04\ACA9\C740 0\BCF4\B2E4 \CEE4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105121082163309557)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: \CD95 \CD5C\B300\AC12\C740 \CD95 \CD5C\C18C\AC12\BCF4\B2E4 \CEE4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105121488830309557)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: \CD95 \CD5C\B300\AC12\C740 0\BCF4\B2E4 \CEE4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105121374617309557)
,p_name=>'WWV_FLOW_SVG.AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: \CD95 \CD5C\C18C\AC12\C740 0\BCF4\B2E4 \D06C\AC70\B098 \AC19\C544\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105121137600309557)
,p_name=>'WWV_FLOW_SVG.BAR_WIDTH_GT_ZERO_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: \B9C9\B300 \B108\BE44\B294 0\BCF4\B2E4 \CEE4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105120724454309557)
,p_name=>'WWV_FLOW_SVG.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105122790081309561)
,p_name=>'WWV_FLOW_SVG.FETCH_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\CD9C \C624\B958: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105122548457309561)
,p_name=>'WWV_FLOW_SVG.FUNC_RET_SQL_QRY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 \D568\C218: \C560\D50C\B9AC\CF00\C774\C158 \C791\C131\AE30 \B0B4\C5D0\C11C \C9C8\C758 \AD6C\BB38\C744 \BD84\C11D\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105121606953309560)
,p_name=>'WWV_FLOW_SVG.GAPS_GT_ZERO_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: \B9C9\B300 \C0AC\C774\C758 \AC04\ACA9\C740 0\BCF4\B2E4 \D06C\AC70\B098 \AC19\C544\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105120890664309557)
,p_name=>'WWV_FLOW_SVG.MAX_ROWS_GT_ZERO_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: \D45C\C2DC\D560 \CD5C\B300 \D589\C740 0\BCF4\B2E4 \CEE4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105123043967309561)
,p_name=>'WWV_FLOW_SVG.MORE_DATA_FND_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B354 \B9CE\C740 \B370\C774\D130\B97C \CC3E\C558\C9C0\B9CC \CD5C\B300 31\AC1C\C758 \AC12\B9CC \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105122688410309561)
,p_name=>'WWV_FLOW_SVG.PARSE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BB38\BD84\C11D \C624\B958: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105122948965309561)
,p_name=>'WWV_FLOW_SVG.SVG_CHART_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('SVG \CC28\D2B8 \C624\B958: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105122816574309561)
,p_name=>'WWV_FLOW_SVG.UNABLE_CALC_GRAPH_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B798\D504 \D640\B354 \C704\CE58\B97C \ACC4\C0B0\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105122483411309561)
,p_name=>'WWV_FLOW_SVG.UNABLE_GET_COLOR_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1\C744 \AC00\C838\C62C \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105121826805309560)
,p_name=>'WWV_FLOW_SVG.X_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: X\CD95 \AC04\ACA9\C740 0\BCF4\B2E4 \CEE4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105122270432309561)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: X\CD95 \CD5C\B300\AC12\C740 0\BCF4\B2E4 \CEE4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105122013814309561)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: X\CD95 \CD5C\C18C\AC12\C740 0\BCF4\B2E4 \D06C\AC70\B098 \AC19\C544\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105121909565309561)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: Y\CD95 \AC04\ACA9\C740 0\BCF4\B2E4 \CEE4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105121748686309560)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: Y\CD95 \CD5C\B300\AC12\C740 \CD95 \CD5C\C18C\AC12\BCF4\B2E4 \CEE4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105122351124309561)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: Y\CD95\C740 0\BCF4\B2E4 \CEE4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105122177392309561)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D \C2E4\D328: Y\CD95 \CD5C\C18C\AC12\C740 0\BCF4\B2E4 \D06C\AC70\B098 \AC19\C544\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105118919829309556)
,p_name=>'WWV_FLOW_SW_API.ADD_MEMBER_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA64\BC84 \CD94\AC00 \C624\B958\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104923114964309414)
,p_name=>'WWV_FLOW_SW_API.CANNOT_RUN_CMD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\B2E8\B41C %0 \BA85\B839\C785\B2C8\B2E4. SQL \C6CC\D06C\C20D\C5D0\C11C \C2E4\D589\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105115811961309553)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 %0\C5D0\AC8C %1 \C2A4\D0A4\B9C8\C5D0 \B300\D55C \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104935825197309423)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV_OBJ'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C2A4\D0A4\B9C8\C5D0 \D14C\C774\BE14 \B610\B294 \BDF0 %1\C5D0 \B300\D55C \C120\D0DD \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105119109743309556)
,p_name=>'WWV_FLOW_SW_API.CREATE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8\B97C \C791\C131\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105115920308309553)
,p_name=>'WWV_FLOW_SW_API.CREATE_PLAN_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \ACC4\D68D \C124\BA85\BB38\C744 \C27D\AC8C \C0AC\C6A9\D560 \C218 \C788\B3C4\B85D \D558\B294 \ACC4\D68D \D14C\C774\BE14\C774 \C0DD\C131\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105116429214309554)
,p_name=>'WWV_FLOW_SW_API.CREATE_SCRIPT_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \D30C\C77C \C0DD\C131 \C624\B958\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105116054815309553)
,p_name=>'WWV_FLOW_SW_API.ERROR_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D589\C5D0 \C624\B958 \BC1C\C0DD: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105116226826309554)
,p_name=>'WWV_FLOW_SW_API.INSERT_SCRIPT_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \D14C\C774\BE14\C5D0 \C2A4\D06C\B9BD\D2B8\B97C \C0BD\C785\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106064314237310332)
,p_name=>'WWV_FLOW_SW_API.INVALID_ROWID'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \D589 ID: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105116394202309554)
,p_name=>'WWV_FLOW_SW_API.PARSE_SCRIPT_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \AD6C\BB38\C744 \BD84\C11D\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105116168172309554)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4\C5D0 "%0" \C2A4\D0A4\B9C8\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \C791\C5C5\C601\C5ED \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C5EC \C815\D655\D55C \AE30\BCF8 \C2A4\D0A4\B9C8\B97C \C124\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104916603060309409)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL_ARR'
,p_message_language=>'ko'
,p_message_text=>unistr('run_sql_arr\C5D0\C11C \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105119071175309556)
,p_name=>'WWV_FLOW_SW_API.UPDATE_MEMBER_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA64\BC84 \C5C5\B370\C774\D2B8 \C624\B958\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104935751582309423)
,p_name=>'WWV_FLOW_SW_PARSER.LINE_EXCEEDS_32K'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8 \D589\C774 32767\BC14\C774\D2B8\B97C \CD08\ACFC\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104902689289309399)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105151415523309586)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELING'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104903601998309400)
,p_name=>'WWV_FLOW_SW_SCRIPT.COMPLETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104904064362309400)
,p_name=>'WWV_FLOW_SW_SCRIPT.ELAPSED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\CD08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104902797914309399)
,p_name=>'WWV_FLOW_SW_SCRIPT.EXECUTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104961510568309441)
,p_name=>'WWV_FLOW_SW_SCRIPT.INVALID_STMT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C \C218 \C5C6\B294 \BA85\B839\BB38\C774 \D3EC\D568\B41C \C2A4\D06C\B9BD\D2B8\B97C \C2E4\D589\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \B2E4\C74C \BA85\B839\BB38\C744 \C81C\AC70\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104903737227309400)
,p_name=>'WWV_FLOW_SW_SCRIPT.IN_PROGRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C4\D589 \C911')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104961430067309441)
,p_name=>'WWV_FLOW_SW_SCRIPT.LINE_NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104923019030309413)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_NEST_LEVEL'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1004 \C2A4\D06C\B9BD\D2B8\B97C %0 \B808\BCA8 \C774\C0C1\C73C\B85C \C911\CCA9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104924354122309414)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_OUTPUT_REACHED'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1005 \C2A4\D06C\B9BD\D2B8 \ACB0\ACFC\AC00 \CD5C\B300 \D06C\AE30 \C81C\D55C\C5D0 \B3C4\B2EC\D588\C2B5\B2C8\B2E4. \ACB0\ACFC\AC00 \C774\BCF4\B2E4 \C801\AC8C \C0DD\C131\B418\B3C4\B85D \C2A4\D06C\B9BD\D2B8\B97C \BCC0\ACBD\D558\AC70\B098 \AD00\B9AC\C790\C5D0\AC8C \C694\CCAD\D558\C5EC \CD5C\B300 \C2A4\D06C\B9BD\D2B8 \ACB0\ACFC \D06C\AE30\B97C \B298\B9AC\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105252544808309660)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8\AC00 \CD5C\B300 \D5C8\C6A9 \D06C\AE30 %0\BC14\C774\D2B8\B97C \CD08\ACFC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104924415654309414)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_WORKSPACE_OUTPUT_REACHED'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1005 \C2A4\D06C\B9BD\D2B8 \ACB0\ACFC\AC00 \CD5C\B300 \C791\C5C5\C601\C5ED \ACB0\ACFC \D06C\AE30 \C81C\D55C\C5D0 \B3C4\B2EC\D588\C2B5\B2C8\B2E4. \AE30\C874 \ACB0\ACFC\B97C \C0AD\C81C\D558\AC70\B098 \AD00\B9AC\C790\C5D0\AC8C \C694\CCAD\D558\C5EC \CD5C\B300 \C791\C5C5\C601\C5ED \ACB0\ACFC \D06C\AE30\B97C \B298\B9AC\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105187507407309612)
,p_name=>'WWV_FLOW_SW_SCRIPT.NO_STMT_BUFFER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\D37C\C5D0 \C2E4\D589\D560 \BA85\B839\BB38\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104918325601309410)
,p_name=>'WWV_FLOW_SW_SCRIPT.QUERY_LIMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('SELECT \BB38\C740 32KB\B97C \CD08\ACFC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104903872257309400)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104903915495309400)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104919219689309411)
,p_name=>'WWV_FLOW_SW_SCRIPT.ROWS_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \D589\C774 \C120\D0DD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105146580723309582)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_EMPTY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \AC00\B2A5\D55C \BA85\B839\BB38\C774 \D3EC\D568\B418\C9C0 \C54A\C740 \C2A4\D06C\B9BD\D2B8\B97C \C2E4\D589\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104916487021309409)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_FILE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D06C\B9BD\D2B8\B97C \C2E4\D589\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104916522839309409)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_STMT_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('run_statement\C5D0\C11C \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105146430207309582)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('SQL \C6CC\D06C\C20D\C5D0\C11C \BB34\C2DC\D560 \BA85\B839\BB38\C774 \D3EC\D568\B41C \C2A4\D06C\B9BD\D2B8\B97C \C2E4\D589\D558\B3C4\B85D \C694\CCAD\D588\C2B5\B2C8\B2E4. \C694\CCAD \B0B4\C6A9\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104922950190309413)
,p_name=>'WWV_FLOW_SW_SCRIPT.SCRIPT_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1001 \C2A4\D06C\B9BD\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104902516643309399)
,p_name=>'WWV_FLOW_SW_SCRIPT.SUBMITTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105150979905309585)
,p_name=>'WWV_FLOW_SW_SCRIPT.UNKNOWN_STATEMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C \C218 \C5C6\B294 \BA85\B839\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105150788274309585)
,p_name=>'WWV_FLOW_SW_SCRIPT.USED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0%\C774(\AC00) \C0AC\C6A9\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105136463785309575)
,p_name=>'WWV_FLOW_SW_UTIL.PACKAGE_CREATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C SQL \AD6C\BB38\C73C\B85C \C778\D574 \D328\D0A4\C9C0 \C0DD\C131\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105136159369309575)
,p_name=>'WWV_FLOW_SW_UTIL.TABLE_CREATE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C SQL \AD6C\BB38\C73C\B85C \C778\D574 \D14C\C774\BE14 \C0DD\C131\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104969099308309447)
,p_name=>'WWV_FLOW_SYNC_TRANSLATIONS.SYNC_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\AE30\D654 \C624\B958: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105292533007309690)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCED_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105292479396309690)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCES'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104967387875309446)
,p_name=>'WWV_FLOW_TABULAR_FORM.MAX_COLUMN_NO'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \BC30\C5F4 apex_application.g_f%0\C5D0 \B9E4\D551\B418\B294 \D45C \D615\C2DD \D3FC \C5F4\C5D0 \C561\C138\C2A4\D558\B824\ACE0 \C2DC\B3C4\D588\C9C0\B9CC \C0C1\D0DC\B97C \C800\C7A5\D558\B294 %1 \C5F4\B9CC \C9C0\C6D0\B429\B2C8\B2E4. \C0C1\D0DC\B97C \C800\C7A5\D558\B294 \C5F4 \C218\B97C \C904\C774\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105530016354309886)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_PARENT_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C0C1\C704 \D0ED \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105315471314309709)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_STD_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \D45C\C900 \D0ED \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105316060502309710)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \D0ED \C9D1\D569(\C0C8 \D0ED \C9D1\D569\C5D0 <b>\D45C\C900 \D0ED</b>\C744 \C0DD\C131\D560 \C218 \C788\C74C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105143708289309580)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED ID %0\C5D0 \B300\D55C \C0C8 \D0ED \C9D1\D569\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105143660407309580)
,p_name=>'WWV_FLOW_TAB_MGR.OLD_TABSET_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED ID %0\C5D0 \B300\D55C \C774\C804 \D0ED \C9D1\D569\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105143817023309580)
,p_name=>'WWV_FLOW_TAB_MGR.PAGE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 ID %0\C740(\B294) \C22B\C790\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105315523834309709)
,p_name=>'WWV_FLOW_TAB_MGR.PAR_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED \C21C\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105315965388309709)
,p_name=>'WWV_FLOW_TAB_MGR.PSEDUO_DESC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \D0ED\ACFC \C5F0\AD00\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. <b>\C758\C0AC \C0C1\C704 \D0ED</b>\C73C\B85C \D45C\C2DC\B418\ACE0 \C788\C73C\BBC0\B85C \C774 \D0ED \C9D1\D569\C758 <b>\D45C\C900 \D0ED</b>\C744 \D3B8\C9D1\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105316194973309710)
,p_name=>'WWV_FLOW_TAB_MGR.SELECT_STD_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D0ED \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105315757758309709)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PAR_TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \C0C1\C704 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105315643492309709)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PSD_PAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \C758\C0AC \C0C1\C704 \D0ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105143519575309580)
,p_name=>'WWV_FLOW_TAB_MGR.SGID_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548 \ADF8\B8F9 ID\B97C \C124\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105143989288309580)
,p_name=>'WWV_FLOW_TAB_MGR.SPEC_NEW_TABSET_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED ID %0\C5D0 \B300\D55C \C0C8 \D0ED \C9D1\D569\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105315313957309709)
,p_name=>'WWV_FLOW_TAB_MGR.STD_TAB_SEQ'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900 \D0ED \C21C\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105315292923309709)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_ALSO_CUR_FOR_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \D398\C774\C9C0\C5D0 \B300\D574\C11C\B3C4 \C774 \D0ED\C744 \D604\C7AC \D0ED\C73C\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105315108508309709)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_CUR_FOR_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \D398\C774\C9C0\C5D0 \B300\D574 \D604\C7AC\B85C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105315806103309709)
,p_name=>'WWV_FLOW_TAB_MGR.THE_TAB_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104970287841309448)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C560\D50C\B9AC\CF00\C774\C158\C758 "%2" \C791\C5C5\C601\C5ED\C5D0\C11C \BCF5\C0AC\D560 \B2E8\CD94 \D15C\D50C\B9AC\D2B8(%0)\B97C \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104971182369309448)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_REPLACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \D15C\D50C\B9AC\D2B8\B97C \BC14\AFC0 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105136637375309575)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104969950232309448)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C560\D50C\B9AC\CF00\C774\C158\C758 "%2" \C791\C5C5\C601\C5ED\C5D0\C11C \BCF5\C0AC\D560 \D544\B4DC \D15C\D50C\B9AC\D2B8(%0)\B97C \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104970812206309448)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_REPLACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\B4DC \D15C\D50C\B9AC\D2B8\B97C \BC14\AFC0 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104970701557309448)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.LIST_TEMPLATE_REPLACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \D15C\D50C\B9AC\D2B8\B97C \BC14\AFC0 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104970157236309448)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C560\D50C\B9AC\CF00\C774\C158\C758 "%2" \C791\C5C5\C601\C5ED\C5D0\C11C \BCF5\C0AC\D560 \C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8(%0)\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104970976812309448)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_REPLACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \ACBD\B85C \D15C\D50C\B9AC\D2B8\B97C \BC14\AFC0 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104970412599309448)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.PAGE_TEMPLATE_REPLACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B97C \BC14\AFC0 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104971016241309448)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_LOV_TEMPLATE_REPLACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D \D15C\D50C\B9AC\D2B8\B97C \BC14\AFC0 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105253487052309661)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_TEMPLATE_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C560\D50C\B9AC\CF00\C774\C158\C758 "%2" \C791\C5C5\C601\C5ED\C5D0\C11C \BCF5\C0AC\D560 \D31D\C5C5 \D15C\D50C\B9AC\D2B8(%0)\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104970506106309448)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REGION_TEMPLATE_REPLACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D15C\D50C\B9AC\D2B8\B97C \BC14\AFC0 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104970699125309448)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REPORT_TEMPLATE_REPLACE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D15C\D50C\B9AC\D2B8\B97C \BC14\AFC0 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104969878408309448)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC\D560 \D15C\D50C\B9AC\D2B8(%0)\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104970342253309448)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_REPLACE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D15C\D50C\B9AC\D2B8\B97C \BC14\AFC0 \C218 \C5C6\C2B5\B2C8\B2E4. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106083375594310350)
,p_name=>'WWV_FLOW_THEME.STYLE_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C\C774 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106100863343310366)
,p_name=>'WWV_FLOW_THEME_DEV.IS_READ_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\D0C0\C77C\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C77D\AE30 \C804\C6A9\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106100791940310365)
,p_name=>'WWV_FLOW_THEME_DEV.WWV_FLOW_THEME_STYLE_UK'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C2A4\D0C0\C77C\C5D0\C11C \C774\BBF8 \C0AC\C6A9 \C911\C778 \C774\B984\C785\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104968933856309447)
,p_name=>'WWV_FLOW_TRANSLATIONS.SEED_UPDATE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\B4DC \C5C5\B370\C774\D2B8 \C624\B958: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105417952500309792)
,p_name=>'WWV_FLOW_UPGRADE.METADATA_DML_DISABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('Application Express\B97C \CD5C\C2E0 \BC84\C804\C73C\B85C \C5C5\ADF8\B808\C774\B4DC\D558\ACE0 \C788\C2B5\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158 \BCC0\ACBD\C0AC\D56D\C740 \C5C5\ADF8\B808\C774\B4DC\AC00 \C644\B8CC\B420 \B54C\AE4C\C9C0 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105081173595309528)
,p_name=>'WWV_FLOW_UTILITIES.ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104886442865309386)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C0AC\C6A9\C790 %1(\C73C)\B85C \B85C\ADF8\C778\D558\C5EC %0 \C560\D50C\B9AC\CF00\C774\C158\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104886588091309386)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_PAGE_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C0AC\C6A9\C790 %2(\C73C)\B85C \B85C\ADF8\C778\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158 %0 \D398\C774\C9C0 %1\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105082113022309529)
,p_name=>'WWV_FLOW_UTILITIES.CAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105110145005309549)
,p_name=>'WWV_FLOW_UTILITIES.CHECKBOX_QUERY_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\BC15\C2A4 \C9C8\C758\B97C \D3C9\AC00\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105082210521309529)
,p_name=>'WWV_FLOW_UTILITIES.CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EB\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105109706865309549)
,p_name=>'WWV_FLOW_UTILITIES.DISP_ONLY_LIST_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958: \D45C\C2DC \C804\C6A9 \AC12 \BAA9\B85D\C740 \B450 \AC1C\C758 \C5F4\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105080921157309528)
,p_name=>'WWV_FLOW_UTILITIES.ERR_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D\C744 \D655\C778\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105082589062309529)
,p_name=>'WWV_FLOW_UTILITIES.FIND'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CC3E\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105131541767309571)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_POPUP_LOV_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D\C744 \C0DD\C131\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105109450403309549)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_QUERY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\B97C \C0DD\C131\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105109501996309549)
,p_name=>'WWV_FLOW_UTILITIES.INIT_LOV_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D\C744 \CD08\AE30\D654\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105110089782309549)
,p_name=>'WWV_FLOW_UTILITIES.INIT_QUERY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\B97C \CD08\AE30\D654\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105035329218309495)
,p_name=>'WWV_FLOW_UTILITIES.INVALID_LOV_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D \C9C8\C758\AC00 \BD80\C801\D569\D569\B2C8\B2E4. \D45C\C2DC \AC12\ACFC \BC18\D658 \AC12\C774 \D544\C694\D558\BA70 \C5F4 \C774\B984\C774 \B2EC\B77C\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105082625227309529)
,p_name=>'WWV_FLOW_UTILITIES.JS_NO_SUPPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript\AC00 \C9C0\C6D0\B418\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105082854627309530)
,p_name=>'WWV_FLOW_UTILITIES.LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105083200439309530)
,p_name=>'WWV_FLOW_UTILITIES.LOV2_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \C9C8\C758\B97C \C2E4\D589\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105082032288309529)
,p_name=>'WWV_FLOW_UTILITIES.NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105081632661309529)
,p_name=>'WWV_FLOW_UTILITIES.NO_MATCHES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\CE58\D558\B294 \D56D\BAA9\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105082318249309529)
,p_name=>'WWV_FLOW_UTILITIES.OK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105131226914309571)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_BG_SELECT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D\C740 "select"\B85C \C2DC\C791\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105109374522309549)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130\B97C \D3EC\D568\D558\B294 \D31D\C5C5 \AC12 \BAA9\B85D\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105131454473309571)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_INIT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130\B97C \C0AC\C6A9\D558\C5EC \D31D\C5C5 \AC12 \BAA9\B85D\C744 \CD08\AE30\D654\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105131385660309571)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_INIT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D\C744 \CD08\AE30\D654\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105109826865309549)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_AUTH_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D \C778\C99D\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105109975978309549)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_CHECK_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D \CCB4\D06C\C12C \D655\C778\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105081713291309529)
,p_name=>'WWV_FLOW_UTILITIES.PREV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105081352619309528)
,p_name=>'WWV_FLOW_UTILITIES.REMOVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105082488853309529)
,p_name=>'WWV_FLOW_UTILITIES.SEARCH_DIALOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \B300\D654\C0C1\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105693471404310024)
,p_name=>'WWV_FLOW_UTILITIES.SHOW_IMAGE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0\B97C \D45C\C2DC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105110601120309550)
,p_name=>'WWV_FLOW_UTILITIES.T_BOLD'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD75\C740\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105111006061309550)
,p_name=>'WWV_FLOW_UTILITIES.T_BULL_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE00\BA38\B9AC \AE30\D638 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105111415393309550)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_LEFT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD \B4E4\C5EC\C4F0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105111573917309550)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_RIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD \B4E4\C5EC\C4F0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105110734412309550)
,p_name=>'WWV_FLOW_UTILITIES.T_ITALICS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C6B8\C784\AF34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105111234513309550)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_CEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C6B4\B370 \B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105111169253309550)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_LEFT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C67C\CABD \B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105111364152309550)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_RT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD \B9DE\CDA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105110958650309550)
,p_name=>'WWV_FLOW_UTILITIES.T_NO_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC88\D638\AC00 \B9E4\ACA8\C9C4 \BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105110831212309550)
,p_name=>'WWV_FLOW_UTILITIES.T_UNDERLINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC11\C904')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105109688032309549)
,p_name=>'WWV_FLOW_UTILITIES.UNABLE_TO_BIND_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0"\C744(\B97C) \BC14\C778\B4DC\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104886306099309385)
,p_name=>'WWV_FLOW_UTILITIES.WEBSHEET_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C0AC\C6A9\C790 %1(\C73C)\B85C \B85C\ADF8\C778\D558\C5EC \C6F9 \C2DC\D2B8 \C560\D50C\B9AC\CF00\C774\C158 %0\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105310315724309705)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_PROXY_OR_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\D55C URL\C774 \BD80\C801\D569\D558\AC70\B098, \C0AC\C6A9\C790 \D658\ACBD\C5D0 HTTP \C694\CCAD\C5D0 \B300\D574 \C801\D569\D55C \D504\B85D\C2DC \C11C\BC84 \C8FC\C18C\AC00 \D544\C694\D558\AC70\B098, \C694\CCAD \C2DC\AC04\C774 \CD08\ACFC\B418\C5C8\AC70\B098, HTTPS \C694\CCAD\C5D0 \B300\D574 \C804\C790 \C9C0\AC11\C774 \AD6C\C131\B418\C9C0 \C54A\C544 \D574\B2F9 \C6F9 \C11C\BE44\C2A4\C5D0 \C811\ADFC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.  SQLERRM: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104957030457309438)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNRETRIEVABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\D55C URL\C774 \BD80\C801\D569\D558\AC70\B098 \C0AC\C6A9\C790 \D658\ACBD\C5D0 HTTP \C694\CCAD\C5D0 \C801\D569\D55C \D504\B85D\C2DC \C11C\BC84 \C8FC\C18C\AC00 \D544\C694\D558\C9C0\B9CC \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \D504\B85D\C2DC \C11C\BC84 \C8FC\C18C\AC00 \C815\C758\B418\C9C0 \C54A\C558\AC70\B098, HTTPS \C694\CCAD\C5D0 \B300\D574 \C774 &PRODUCT_NAME. \C778\C2A4\D134\C2A4\C6A9 \C804\C790 \C9C0\AC11\C774 \AD6C\C131\B418\C9C0 \C54A\C544 WSDL \BB38\C11C\B97C \AC80\C0C9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104957740536309439)
,p_name=>'WWV_FLOW_WIZARD_API.ACTION_PROCESSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C774 \CC98\B9AC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105539749041309894)
,p_name=>'WWV_FLOW_WIZARD_API.ADD_ROW_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C744 \CD94\AC00\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104951577329309434)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104988041650309461)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CALENDAR_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EC\B825 \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104987777846309461)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CHART_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105670106192310003)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_DATA_LOAD_WIZARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \D504\B85C\C138\C2A4\B97C \C644\B8CC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104988446506309461)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_EXCEL_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('Excel \CC28\D2B8\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104988179248309461)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_EQUIJOIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4F1\AC00 \C870\C778\C5D0 \D3FC\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104987350453309460)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_SP'
,p_message_language=>'ko'
,p_message_text=>unistr('SP\C5D0 \D3FC\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104987413166309460)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_TABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\C774\BE14\C5D0 \D3FC\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104987518119309460)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_INSERT_FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0BD\C785 \D3FC\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105471861809309837)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_JET_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle JET \CC28\D2B8\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104874487762309376)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_MASTER_DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \B514\D14C\C77C \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105357256596309741)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_PAGE_DA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9\C801 \C791\C5C5\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104987602325309461)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_QUERY_AND_UPDATE_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \BC0F \C5C5\B370\C774\D2B8 \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104987968970309461)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_REPORT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104988591003309461)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SUMMARY_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\C57D \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104988634624309461)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SVG_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('SVG \CC28\D2B8 \D398\C774\C9C0\B97C \C791\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104988336024309461)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_TREE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104987240563309460)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_UPDATEABLE_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BCF4\ACE0\C11C\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104988275290309461)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_WIZARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\BC95\C0AC\B97C \C0DD\C131\D558\B294 \B9C8\BC95\C0AC\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105539632258309894)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C\B97C \CC98\B9AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105540098709309894)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('#MRD_COUNT#\AC1C\C758 \D589\C774 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104893494903309391)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B610\B294 \C774\C804 \AE30\BCF8 \D0A4 \AC12 \AC00\C838\C624\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104893389863309391)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B2E8\CD94\B294 \B2E4\C74C \B610\B294 \C774\C804 \AE30\BCF8 \D0A4 \AC12 \AC00\C838\C624\AE30 \D504\B85C\C138\C2A4\C5D0 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104893288587309391)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_ITEM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C740 \B2E4\C74C \B610\B294 \C774\C804 \AE30\BCF8 \D0A4 \AC12 \AC00\C838\C624\AE30 \D504\B85C\C138\C2A4\C5D0 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104894095915309392)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B610\B294 \C774\C804 \AE30\BCF8 \D0A4 \AC12 \AC00\C838\C624\AE30 \D504\B85C\C138\C2A4\B97C \C2E4\D589\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104903174496309399)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_SHORTCUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B97C \C800\C7A5\D558\C9C0 \C54A\C740 \CC44 \C885\B8CC\D558\ACA0\C2B5\B2C8\AE4C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105252472177309660)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK2_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C870 \D0A4 \D56D\BAA9 \AC12\C744 \AC00\C838\C62C \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105252362830309660)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0A4 \D56D\BAA9 \AC12\C744 \AC00\C838\C62C \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104987893835309461)
,p_name=>'WWV_FLOW_WIZARD_API.INVALID_REPORT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \BCF4\ACE0\C11C \C720\D615\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105266451138309671)
,p_name=>'WWV_FLOW_WIZARD_API.IR_REPORT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C\AC00 \C874\C7AC\D569\B2C8\B2E4. \D398\C774\C9C0\B2F9 \D558\B098\C758 \B300\D654\C2DD \BCF4\ACE0\C11C\B9CC \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104978336124309454)
,p_name=>'WWV_FLOW_WIZARD_API.NEXT_PREV_PK_PROCESS_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \B610\B294 \C774\C804 \AE30\BCF8 \D0A4 \AC12 \AC00\C838\C624\AE30 \D504\B85C\C138\C2A4\B97C \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105539564663309894)
,p_name=>'WWV_FLOW_WIZARD_API.NO_PAGE_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0 \B300\D55C \B3C4\C6C0\B9D0\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104987117099309460)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR1'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BB38\BD84\C11D \C624\B958: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104987029776309460)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR2'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\BB38\BD84\C11D \C624\B9582: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105540121036309894)
,p_name=>'WWV_FLOW_WIZARD_API.REQUEST_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\C744 \BCF4\B0B4\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105540436096309894)
,p_name=>'WWV_FLOW_WIZARD_API.SHOW_TREE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105540286809309894)
,p_name=>'WWV_FLOW_WIZARD_API.TREE_ROOT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC \B8E8\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104957534091309438)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_FETCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589\C744 \C778\CD9C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104957657510309439)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D14C\C774\BE14\C758 \D589\C744 \CC98\B9AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104988765941309461)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATEABLE_QUERY_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \AC00\B2A5\D55C SQL \C9C8\C758\AC00 \C874\C7AC\D569\B2C8\B2E4. \C5C5\B370\C774\D2B8 \AC00\B2A5\D55C SQL \C9C8\C758\B294 \D398\C774\C9C0\B2F9 \D55C \AC1C\B9CC \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105539875413309894)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_APPLIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8\AC00 \C801\C6A9\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105539930527309894)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_INSERT_SUCCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('#MRU_COUNT#\AC1C\C758 \D589\C774 \C5C5\B370\C774\D2B8\B418\C5C8\ACE0, #MRI_COUNT#\AC1C\C758 \D589\C774 \C0BD\C785\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105410337215309780)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_AUTH_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC \CCB4\ACC4 \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105410147980309780)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105409918906309780)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D \BCF5\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105410289608309780)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \BAA9\B85D \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105410031311309780)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LOV'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \AC12 \BAA9\B85D \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105111722907309550)
,p_name=>'WWV_FLOW_WORKSHEET.SHOW_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\B97C \B80C\B354\B9C1\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105567945817309916)
,p_name=>'WWV_FLOW_WORKSPACE_REPORTS.TABLESPACE1'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D %0GB | %1GB \C0AC\C6A9\B428 | %2\D37C\C13C\D2B8 \C0AC\C6A9\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104885065668309384)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_PGA_AGG_TARGET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 PGA \C9D1\ACC4 \B300\C0C1\C744 \C124\C815\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104884896917309384)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_SGA_TARGET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 SGA \B300\C0C1\C744 \C124\C815\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106132490901310395)
,p_name=>'WWV_FLOW_XLIFF.ERROR_PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CC98\B9AC \C911 \C624\B958 \BC1C\C0DD: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105107467159309547)
,p_name=>'WWV_RENDER_CHART2.T_AVERAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3C9\ADE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105107377143309547)
,p_name=>'WWV_RENDER_CHART2.T_AXIS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105107973263309548)
,p_name=>'WWV_RENDER_CHART2.T_FIRST'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105108014024309548)
,p_name=>'WWV_RENDER_CHART2.T_GO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105107841207309547)
,p_name=>'WWV_RENDER_CHART2.T_LAST'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105107623298309547)
,p_name=>'WWV_RENDER_CHART2.T_MAXIMUM'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105107704991309547)
,p_name=>'WWV_RENDER_CHART2.T_MINIMUM'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105107257028309547)
,p_name=>'WWV_RENDER_CHART2.T_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105107509843309547)
,p_name=>'WWV_RENDER_CHART2.T_SUM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D569\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105042907767309501)
,p_name=>'WWV_RENDER_REPORT3.CURSOR_NOT_OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \AD6C\BB38\C744 \BD84\C11D\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \CEE4\C11C\AC00 \C544\C9C1 \C5F4\B9AC\C9C0 \C54A\C558\AC70\B098, SQL \C9C8\C758\B97C \BC18\D658\D558\B294 \D568\C218\AC00 \AC12 \C5C6\C774 \BC18\D658\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105403470140309775)
,p_name=>'WWV_RENDER_REPORT3.DUBLICATE_ALIAS_NAMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\C5D0 \C911\BCF5\B418\B294 \BCC4\CE6D \C774\B984\C774 \C788\C2B5\B2C8\B2E4. \BCF4\ACE0\C11C\C5D0 \C0AC\C6A9\D558\B294 \C9C8\C758\C5D0\B294 \ACE0\C720\D55C \BCC4\CE6D \C774\B984\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105035037783309495)
,p_name=>'WWV_RENDER_REPORT3.ERR_PROC_FUNCTION_BODY'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C9C8\C758\B97C \BC18\D658\D558\B294 \D568\C218 \BCF8\BB38\C744 \CC98\B9AC\D560 \C218 \C5C6\C74C:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105120955152309557)
,p_name=>'WWV_RENDER_REPORT3.INVALID_COL_NUM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\C5D0 \C815\C758\B41C \C5F4 \C218\AC00 \BD80\C801\D569\D569\B2C8\B2E4. \C774 \C601\C5ED \C720\D615\C5D0 \B300\D574 %0\AC1C\C758 \C5F4\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105043047428309501)
,p_name=>'WWV_RENDER_REPORT3.QUERY_CANNOT_BE_PARSED'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL \C9C8\C758\B97C \BC18\D658\D558\B294 \D568\C218: \C791\C131\AE30 \B0B4\C5D0\C11C \C9C8\C758 \AD6C\BB38\C744 \BD84\C11D\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C9C8\C758 \AD6C\BB38\C774 \C815\D655\D55C \ACBD\C6B0 \C601\C5ED \C18C\C2A4 \C544\B798\C758 <strong>\C77C\BC18 \C5F4</strong> \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D558\C5EC \AD6C\BB38 \BD84\C11D \C5C6\C774 \ACC4\C18D\D558\C2ED\C2DC\C624.'),
'<br/>',
'(%0)'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105043120754309501)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR2'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C791\C131\AE30 \B0B4\C5D0\C11C \C9C8\C758 \AD6C\BB38\C744 \BD84\C11D\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C9C8\C758 \AD6C\BB38\C774 \C815\D655\D55C \ACBD\C6B0 \C601\C5ED \C18C\C2A4 \C544\B798\C5D0 \C788\B294 "\C77C\BC18 \C5F4" \D655\C778\B780\C744 \C120\D0DD\D558\C5EC \AD6C\BB38\BD84\C11D \C5C6\C774 \ACC4\C18D\D558\C2ED\C2DC\C624.'),
'%0</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105119474401309556)
,p_name=>'WWV_SPELING.ADD_WORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C5B4 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105120031097309556)
,p_name=>'WWV_SPELING.BUTTON_ADD_TO_DICTIONARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B515\C154\B108\B9AC\C5D0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105119997465309556)
,p_name=>'WWV_SPELING.BUTTON_APPLY_CHANGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105119896023309556)
,p_name=>'WWV_SPELING.BUTTON_CANCEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105119778060309556)
,p_name=>'WWV_SPELING.BUTTON_DONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105478692183309843)
,p_name=>'WWV_SPELING.BUTTON_SUBMIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\CD9C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105119682600309556)
,p_name=>'WWV_SPELING.DUP_WORD_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B515\C154\B108\B9AC\C5D0 %0\C774(\AC00) \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105120216858309557)
,p_name=>'WWV_SPELING.ENTER_NEW_WORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \B2E8\C5B4\B97C \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105120138564309557)
,p_name=>'WWV_SPELING.PICK_A_WORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C5B4 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105337885150309726)
,p_name=>'WWV_SPELING.SPELL_CHECKER'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA0\C790 \AC80\C0AC\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105119586846309556)
,p_name=>'WWV_SPELING.WORD_ADDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B515\C154\B108\B9AC\C5D0 %0\C774(\AC00) \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104964814083309444)
,p_name=>'XML_LOAD_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('XML \B85C\B4DC \C624\B958\C785\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105389721455309765)
,p_name=>'X_ADDITIONAL_TAGS_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 %0 \D0DC\ADF8\AC00 \C874\C7AC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105390515039309765)
,p_name=>'X_BUGS_HAVE_NO_FIX_DATES'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \BC84\ADF8\C5D0 \B0A0\C9DC\BCC4 \C218\C815\C774 \C5C6\C74C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105564552534309914)
,p_name=>'YEARLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B144')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105018213414309483)
,p_name=>'YES_BY_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608, \C0AC\C6A9\C790\BCC4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105047360905309504)
,p_name=>'YOUR_EMAIL_IUWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C8FC\C18C\AC00 \B2E4\C74C \C791\C5C5\C601\C5ED\C5D0 \C0AC\C6A9\C790\B85C \B4F1\B85D\B418\C5B4 \C788\C74C:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(105328719303309719)
,p_name=>'YOU_ARE_NOW_LOGGED_OUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C544\C6C3\B418\C5C8\C2B5\B2C8\B2E4.')
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(91645213681389498.4419)
,p_name=>'no auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_15=>'91645213681389498'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_comments=>'Based on authentication scheme from gallery:No Authentication (using DAD)'
);
end;
/
prompt --application/shared_components/plugins/region_type/breadcrumb
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3708767719669.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'BREADCRUMB'
,p_display_name=>unistr('\C774\B3D9 \ACBD\B85C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','BREADCRUMB'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D604\C7AC \D398\C774\C9C0\C758 \C774\B3D9 \ACBD\B85C\B97C \D45C\C2DC\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3709973247475.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'LIST'
,p_display_name=>unistr('\BAA9\B85D')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','LIST'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C815\C801 \B610\B294 \B3D9\C801 \BAA9\B85D\C744 \AE30\C900\C73C\B85C \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \C774\B7EC\D55C \AC12\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \D398\C774\C9C0\B85C \C774\B3D9\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_cancel
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734497742532.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CANCEL'
,p_display_name=>unistr('\B300\D654\C0C1\C790 \CDE8\C18C')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CANCEL'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D604\C7AC \B300\D654\C0C1\C790 \D398\C774\C9C0\B97C \CDE8\C18C\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_close
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734500756040.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CLOSE'
,p_display_name=>unistr('\B300\D654\C0C1\C790 \B2EB\AE30')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CLOSE'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D604\C7AC \B300\D654\C0C1\C790 \D398\C774\C9C0\B97C \B2EB\C2B5\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3788410042953.4419)
,p_plugin_id=>wwv_flow_api.id(3734500756040.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\BC18\D658\D560 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D574\B2F9 \B300\D654\C0C1\C790\B85C \BC18\D658\D560 \D558\B098 \C774\C0C1\C758 \D398\C774\C9C0 \D56D\BAA9\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \D56D\BAA9\C774 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \AC01 \D56D\BAA9 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\B300\D654\C0C1\C790 \BC18\D658 \D56D\BAA9</strong>\C758 <strong>\AC12 \C124\C815</strong> \BC0F <em>\C720\D615 \C124\C815</em> \C791\C5C5\ACFC \D568\AED8 \C694\C18C\C5D0\C11C \B300\D654\C0C1\C790\B97C \C5EC\B294 <strong>\B300\D654\C0C1\C790 \B2EB\D798</strong> \C774\BCA4\D2B8 \BC1C\C0DD \C2DC \B3D9\C801 \C791\C5C5\C774 \C2E4\D589\B418\B3C4\B85D \C815\C758\D558\C5EC \BC18\D658\B41C \D56D\BAA9 \AC12\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/display_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3782395890396.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DISPLAY_SELECTOR'
,p_display_name=>unistr('\C601\C5ED \D45C\C2DC \C120\D0DD\AE30')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DISPLAY_SELECTOR'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\AC00\B85C \BAA9\B85D\C5D0 \C601\C5ED \C774\B984\C744 \D45C\C2DC\D558\C5EC \C77C\BC18 \C0AC\C6A9\C790\AC00 \D45C\C2DC\D560 \C601\C5ED\C744 \D558\B098 \C120\D0DD\D558\ACE0 \B2E4\B978 \C601\C5ED\C740 \C228\AE30\B3C4\B85D \C124\C815\D569\B2C8\B2E4. <em>\C601\C5ED \D45C\C2DC \C120\D0DD\AE30</em>\AC00 <strong>\C608</strong>\B85C \C124\C815\B41C \D398\C774\C9C0 \C601\C5ED\B9CC \C774 \C601\C5ED\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1764737380560506621.4419)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C2AC\B77C\C774\B354 \D3EC\D568')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\D45C\C2DC\B41C \C601\C5ED \C774\B984\C774 \C601\C5ED \B108\BE44\B97C \CD08\ACFC\D558\B294 \ACBD\C6B0 \C601\C5ED\C5D0 \C2AC\B77C\C774\B354\B97C \B3D9\C801\C73C\B85C \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763653631955156043.4419)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\BAA8\B4DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STANDARD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('[<em>\C601\C5ED \D45C\C2DC \C120\D0DD\AE30</em>\AC00 \C788\B294 \C601\C5ED\C744 <strong>\C608</strong>\B85C \C124\C815\D558\B294 \BC29\BC95\C744 \C120\D0DD\D558\C2ED\C2DC\C624.]\AC00 \D398\C774\C9C0\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654080157157624.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\B2E8\C77C \C601\C5ED \BCF4\AE30')
,p_return_value=>'STANDARD'
,p_help_text=>unistr('\C601\C5ED\C744 \D0ED\C73C\B85C \D45C\C2DC\D569\B2C8\B2E4. \D0ED\C744 \C120\D0DD\D558\BA74 \D574\B2F9 \C601\C5ED\C774 \D45C\C2DC\B418\ACE0 \B2E4\B978 \C120\D0DD\C0AC\D56D\C744 \C228\AE41\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654509981158498.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\CC3D \C2A4\D06C\B864')
,p_return_value=>'JUMP'
,p_help_text=>unistr('\D398\C774\C9C0\C5D0 \BAA8\B4E0 \C601\C5ED\C744 \D56D\C0C1 \D45C\C2DC\D569\B2C8\B2E4. \D0ED\C744 \C120\D0DD\D558\BA74 \D574\B2F9 \C601\C5ED\C73C\B85C \CC3D\C774 \C2A4\D06C\B864\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763973139934187732.4419)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('''\BAA8\B450 \D45C\C2DC'' \D3EC\D568')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1763653631955156043.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STANDARD'
,p_help_text=>unistr('\C120\D0DD\B41C \ACBD\C6B0 \D398\C774\C9C0\C5D0 \BAA8\B4E0 \C601\C5ED\C744 \D45C\C2DC\D558\B294 "\BAA8\B450 \D45C\C2DC" \D0ED\C744 \C55E\C5D0 \BD99\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763975939882192484.4419)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\B9C8\C9C0\B9C9 \C120\D0DD\C0AC\D56D \AE30\C5B5')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\D398\C774\C9C0 \B85C\B4DC \C2DC \B9C8\C9C0\B9C9\C5D0 \C120\D0DD\D55C \C601\C5ED\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/region_type/url
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783484270249.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'URL'
,p_display_name=>'URL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','URL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('URL\C5D0\C11C \AC00\C838\C628 \C6D0\ACA9 \CF58\D150\CE20\B97C \D45C\C2DC\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783486275401.4419)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\C6D0\ACA9 \CF58\D150\CE20\C758 URL\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783489372727.4419)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D3EC\D568 \BAA8\B4DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IFRAME'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('URL\C758 \C6D0\ACA9 \CF58\D150\CE20\B97C \D398\C774\C9C0\C5D0 \D3EC\D568\D560 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783492373852.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4419)
,p_display_sequence=>10
,p_display_value=>'IFrame'
,p_return_value=>'IFRAME'
,p_help_text=>unistr('\C6D0\ACA9 \CF58\D150\CE20\B97C iframe\C73C\B85C \D3EC\D568\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783496377152.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C778\B77C\C778(\C774\C2A4\CF00\C774\D504 \D2B9\C218 \BB38\C790)')
,p_return_value=>'ESC_INLINE'
,p_help_text=>unistr('\D398\C774\C9C0 \B80C\B354\B9C1 \C2DC\AC04\C5D0 \C6D0\ACA9 \CF58\D150\CE20\B97C \C77D\ACE0 \D3EC\D568\C2DC\D0A4\C9C0\B9CC \C0AC\C774\D2B8\AC04 \C2A4\D06C\B9BD\D305\C744 \BC29\C9C0\D558\AE30 \C704\D574 \D2B9\C218 HTML \BB38\C790\B97C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783504380866.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C778\B77C\C778(\C774\C2A4\CF00\C774\D504 \CC98\B9AC \C5C6\C74C)')
,p_return_value=>'NOESC_INLINE'
,p_help_text=>unistr('\D398\C774\C9C0 \B80C\B354\B9C1 \C2DC\AC04\C5D0 \C6D0\ACA9 \CF58\D150\CE20\B97C \C77D\ACE0 \D3EC\D568\C2DC\D0B5\B2C8\B2E4. \C774 \C635\C158\C740 HTML \C774\C2A4\CF00\C774\D504 \CC98\B9AC\AC00 \C218\D589\B418\C9C0 \C54A\C73C\BBC0\B85C \C6D0\ACA9 \CF58\D150\CE20\B97C \C644\C804\D788 \C2E0\B8B0\D560 \C218 \C788\B294 \ACBD\C6B0\C5D0\B9CC \C120\D0DD\D574\C57C \D569\B2C8\B2E4. \C774 \C635\C158\C744 \C0AC\C6A9\D558\BA74 \C601\C5ED\C774 \C0AC\C774\D2B8\AC04 \C2A4\D06C\B9BD\D305\C5D0 \CDE8\C57D\D574\C9C8 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783511409602.4419)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('IFrame \C18D\C131')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IFRAME'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'width="300" height="300"',
'</pre>'))
,p_help_text=>unistr('iframe \D0DC\ADF8\C5D0 \B300\D55C \CD94\AC00 HTML \C694\C18C \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783517424673.4419)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\B2E4\C74C\AE4C\C9C0 HTML \C0AD\C81C')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('\D070 \BB38\C11C\C5D0\C11C HTML \C139\C158\C744 \C798\B77C\B0BC \B54C \C774 \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4. \B300\C0C1 \C139\C158\C758 \C2DC\C791 \BD80\BD84\C744 \C2DD\BCC4\D558\B294 \BB38\C790\C5F4 \B610\B294 HTML\C774 \C0AD\C81C\B418\C5B4\C57C \D558\B294 \C9C0\C810\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783520428341.4419)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\B2E4\C74C \C774\D6C4 HTML \C0AD\C81C')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('\D070 HTML \BB38\C11C\C5D0\C11C HTML \C139\C158\C744 \C798\B77C\B0B4\B824\BA74 \C774 \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4. \B300\C0C1 \C139\C158\C758 \B05D \BD80\BD84\C744 \C2DD\BCC4\D558\B294 \BB38\C790\C5F4 \B610\B294 \B0A8\C740 HTML\C774 \C0AD\C81C\B418\C5B4\C57C \D558\B294 \C9C0\C810\C744 \C785\B825\D569\B2C8\B2E4. \B300\C0C1 \C139\C158\C758 \B05D \BD80\BD84\C744 \C2DD\BCC4\D558\B294 \C774 \BB38\C790\C5F4\C740 \BC18\D658\B41C \D14D\C2A4\D2B8\C5D0 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/region_type/help_text
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783523603076.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'HELP_TEXT'
,p_display_name=>unistr('\B3C4\C6C0\B9D0 \D14D\C2A4\D2B8')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','HELP_TEXT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C804\C6A9 \B3C4\C6C0\B9D0 \D398\C774\C9C0\C5D0\C11C \C0AC\C6A9\B418\B294 \D2B9\BCC4\D55C \B3C4\C6C0\B9D0 \C601\C5ED\C744 \D45C\C2DC\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/faceted_search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1370261776191667.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FACETED_SEARCH'
,p_display_name=>unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FACETED_SEARCH'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>\C5F0\AD00\B41C \D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9\C758 \C18C\C2A4\C5D0 \AE30\BC18\D55C \C601\C5ED\C73C\B85C, \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \B7F0\D0C0\C784 \C2DC \AC80\C0C9 \ACB0\ACFC \C81C\D55C\C5D0 \C0AC\C6A9\B418\B294 \B2E4\C591\D55C \D328\C2EF\C744 \C81C\ACF5\D569\B2C8\B2E4. </p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1370473361191712.4419)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C77C\AD04 \D328\C2EF \BCC0\ACBD\C0AC\D56D')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \BCF4\ACE0\C11C\C5D0\C11C \C120\D0DD\B41C \D328\C2EF\C744 \C77C\AD04 \C801\C6A9\D560\C9C0 \C544\B2C8\BA74 \AC1C\BCC4\C801\C73C\B85C \C801\C6A9\D560\C9C0 \C120\D0DD\D569\B2C8\B2E4. [\C608]\C778 \ACBD\C6B0 [\C801\C6A9] \B2E8\CD94\B97C \B204\B97C \B54C \BCF4\ACE0\C11C \D544\D130\B9C1\C774 \C2E4\D589\B429\B2C8\B2E4. [\C544\B2C8\C624]\C778 \ACBD\C6B0 \D328\C2EF \AC12\C774 \BCC0\ACBD\B41C \D6C4 \BC14\B85C \BCF4\ACE0\C11C \D544\D130\B9C1\C774 \C2E4\D589\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2517816294852101.4419)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\D604\C7AC \D328\C2EF \D45C\C2DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D604\C7AC \D328\C2EF \C601\C5ED\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \D604\C7AC \D328\C2EF \C601\C5ED\C5D0\B294 \D604\C7AC \C120\D0DD\B41C \D328\C2EF\C774 \B098\C5F4\B418\BA70 \D328\C2EF\C744 \AC1C\BCC4\C801\C73C\B85C \B610\B294 \D55C \BC88\C5D0 \BAA8\B450 \C81C\AC70\D560 \C218 \C788\B294 \AC04\B2E8\D55C \BC29\BC95\C774 \C81C\ACF5\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518140718854747.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C608')
,p_return_value=>'Y'
,p_help_text=>unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \C601\C5ED \C0C1\B2E8\C5D0 \D604\C7AC \D328\C2EF \BAA9\B85D\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518542510858430.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C544\B2C8\C624')
,p_return_value=>'N'
,p_help_text=>unistr('\D604\C7AC \D328\C2EF \BAA9\B85D\C774 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518915492864304.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C120\D0DD\AE30')
,p_return_value=>'E'
,p_help_text=>unistr('\C774 \C120\D0DD\AE30\B85C \C9C0\C815\B41C \C694\C18C \B0B4\C5D0 \D604\C7AC \D328\C2EF \C601\C5ED\C774 \D45C\C2DC\B429\B2C8\B2E4. \C774\B97C \D1B5\D574 \D398\C774\C9C0\C758 \C5B4\B290 \ACF3\C5D0\B4E0 \D604\C7AC \D328\C2EF \C601\C5ED\C744 \BC30\CE58\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728482701453610313.4419)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\D604\C7AC \D328\C2EF \C120\D0DD\AE30')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2517816294852101.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#currentFacetsArea'
,p_help_text=>unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \C601\C5ED\C5D0 \D604\C7AC \D328\C2EF\C774 \D45C\C2DC\B418\B294 \D398\C774\C9C0\C5D0\C11C \C694\C18C\C758 \C120\D0DD\AE30\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1501356115247921.4419)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\CD1D \D589 \C218 \D45C\C2DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\CD1D \D589 \C218\B97C \D45C\C2DC\D560 \C704\CE58\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1501661440256814.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C544\B2C8\C624')
,p_return_value=>'N'
,p_help_text=>unistr('\CD1D \D589 \C218\AC00 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502011338258911.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C608')
,p_return_value=>'Y'
,p_help_text=>unistr('\CD1D \D589 \C218\AC00 \D604\C7AC \D328\C2EF \C601\C5ED\C758 \B9E8 \C704\C5D0 \D45C\C2DC\B418\AC70\B098, \D604\C7AC \D328\C2EF \D45C\C2DC\AC00 [\C544\B2C8\C624]\C778 \ACBD\C6B0 \D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \C601\C5ED\C758 \B9E8 \C704\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502458150261854.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C120\D0DD\AE30')
,p_return_value=>'E'
,p_help_text=>unistr('\CD1D \D589 \C218(\B808\C774\BE14 \C5C6\C74C)\AC00 \C774 \C120\D0DD\AE30\B85C \C9C0\C815\B41C \C694\C18C \B0B4\C5D0 \D45C\C2DC\B429\B2C8\B2E4. \B530\B77C\C11C \D398\C774\C9C0\C758 \C5B4\B290 \ACF3\C5D0\B4E0 \CD1D \D589 \C218\B97C \BC30\CE58\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503042014268412.4419)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\CD1D \D589 \C218 \B808\C774\BE14')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\CD1D \D589 \C218\C5D0 \C0AC\C6A9\D560 \B808\C774\BE14\C785\B2C8\B2E4. \C5EC\AE30\C5D0 \C81C\ACF5\B41C \B808\C774\BE14\C774 \C5C6\C744 \ACBD\C6B0 APEX\B294 APEX.FS.TOTAL_ROW_COUNT_LABEL \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\B97C \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503328055272516.4419)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\CD1D \D589 \C218 \C120\D0DD\AE30')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \C601\C5ED\C5D0 \CD1D \D589 \C218\AC00 \D45C\C2DC\B418\B294 \D398\C774\C9C0\C5D0\C11C \C694\C18C\C758 \C120\D0DD\AE30\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(556135859462274866.4419)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>20
,p_prompt=>unistr('\C555\CD95 \BC88\D638 \C784\ACC4\AC12')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('\C555\CD95 \BC88\D638 \D615\C2DD\C744 \C0AC\C6A9\D558\C5EC \D328\C2EF \C218\AC00 \D45C\C2DC\B418\B294 \CD5C\C18C \C784\ACC4\AC12\C744 \C81C\ACF5\D569\B2C8\B2E4. \C555\CD95 \BC88\D638 \D615\C2DD\C744 \C0AC\C6A9\D560 \ACBD\C6B0 \AC12 <strong>1,234</strong>\AC00 <strong>1K</strong>\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2600957382075036.4419)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\CC28\D2B8 \D45C\C2DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D328\C2EF \AC12 \CC28\D2B8\B97C \D45C\C2DC\D560 \C704\CE58\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601268677075657.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\B300\D654\C0C1\C790')
,p_return_value=>'Y'
,p_help_text=>unistr('\D328\C2EF \AC12 \CC28\D2B8\AC00 \BE44\BAA8\B2EC \B300\D654\C0C1\C790\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601607534076237.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C544\B2C8\C624')
,p_return_value=>'N'
,p_help_text=>unistr('\C0AC\C6A9\C790\AC00 \D328\C2EF \AC12 \CC28\D2B8\B97C \D45C\C2DC\D560 \C218 \C788\B294 \B2E8\CD94\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2602011048076805.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C120\D0DD\AE30')
,p_return_value=>'E'
,p_help_text=>unistr('\D328\C2EF \AC12 \CC28\D2B8\AC00 \C774 \C120\D0DD\AE30\B85C \C9C0\C815\B41C \C694\C18C\C5D0 \CD94\AC00\B429\B2C8\B2E4. \B530\B77C\C11C \D328\C2EF \AC12 \CC28\D2B8 \B300\C2DC\BCF4\B4DC\B97C \C0DD\C131\D558\B294 \D398\C774\C9C0\C758 \C5B4\B290 \ACF3\C5D0\B4E0 \CC28\D2B8\B97C \BC30\CE58\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2602471299081559.4419)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\CC28\D2B8 \C120\D0DD\AE30')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_help_text=>unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \C601\C5ED\C5D0 \D328\C2EF \CC28\D2B8\AC00 \D45C\C2DC\B418\B294 \D398\C774\C9C0\C5D0\C11C \C694\C18C\C758 \C120\D0DD\AE30\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3900223688176537.4419)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\CD5C\C0C1\C704 N \AC12\C5D0 \B300\D55C \CC28\D2B8 \D45C\C2DC')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'Y,E'
,p_help_text=>unistr('\AC01 \D328\C2EF \CC28\D2B8\C5D0 \D45C\C2DC\B420 \AC12 \C218\B97C \C81C\ACF5\D569\B2C8\B2E4. \AC12 <strong>10</strong>\C740 \D328\C2EF \CC28\D2B8\C5D0\C11C <em>\CC98\C74C 10</em>\AC1C \D56D\BAA9\C774 \D328\C2EF \C544\B798\C5D0 \C21C\C11C\B300\B85C \D45C\C2DC\B428\C744 \C758\BBF8\D569\B2C8\B2E4. \D328\C2EF \C18D\C131 [\C0C1\C704 \AC1C\C218\B85C \C815\B82C]\C774 \C124\C815\B41C \ACBD\C6B0 \BC1C\C0DD \D69F\C218\B97C \AE30\C900\C73C\B85C <em>\CD5C\C0C1\C704 10</em>\AC1C \D56D\BAA9\C774 \D45C\C2DC\B429\B2C8\B2E4. \C774 \C18D\C131\C744 \BCC0\ACBD\D560 \ACBD\C6B0 \D604\C7AC \D65C\C131 \BE0C\B77C\C6B0\C800 \C138\C158\C5D0 \BC14\B85C \D45C\C2DC\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4. \C774 \AC12\ACFC \C0AC\C6A9\C790\AC00 \C120\D0DD\D55C \D30C\C774 \B610\B294 \B9C9\B300 \CC28\D2B8\B294 \BE0C\B77C\C6B0\C800 \C138\C158\C5D0 \C800')
||unistr('\C7A5\B429\B2C8\B2E4. \C774 \C18D\C131\C758 \BCC0\ACBD \ACB0\ACFC\B97C \D655\C778\D558\B824\BA74 \B9C8\BC95\C0AC\C5D0\C11C \C0DD\C131\D55C \C7AC\C124\C815 \B2E8\CD94\C640 \AC19\C740 [\C601\C5ED \C7AC\C124\C815] \CE90\C2DC \C81C\C5B4 \C635\C158 \B9C1\D06C\B97C \C0AC\C6A9\D558\C5EC \BCF4\ACE0\C11C\B97C \C7AC\C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603063046957961274.4419)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4419)
,p_name=>'facetsafterremovechart'
,p_display_name=>unistr('\CC28\D2B8 \C81C\AC70 \D6C4')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603062764743961271.4419)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4419)
,p_name=>'facetsbeforeaddchart'
,p_display_name=>unistr('\CC28\D2B8 \CD94\AC00 \C804')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1372274287191736.4419)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4419)
,p_name=>'facetschange'
,p_display_name=>unistr('\D328\C2EF \BCC0\ACBD')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1381216513007333.4419)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SAML'
,p_display_name=>unistr('SAML \C0AC\C778\C778')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SAML'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007334.4419)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>70
,p_prompt=>unistr('\C694\CCAD \C11C\BA85\C5D0 \B300\D55C \C778\C99D\C11C \C800\C7A5\C18C')
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ID \C81C\ACF5\C790\C5D0 \B300\D55C \BA54\C2DC\C9C0 \C11C\BA85\C5D0 \C0AC\C6A9\B418\B294 \ACF5\C6A9 \C778\C99D\C11C \BC0F \C804\C6A9 \D0A4\AC00 \D3EC\D568\B41C \C778\C99D\C11C \C800\C7A5\C18C\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('ID \C81C\ACF5\C790\C5D0\C11C \C778\C99D\C11C\B97C \B4F1\B85D\D574\C57C \D569\B2C8\B2E4.'),
unistr('&PRODUCT_NAME.\C740(\B294) \C804\C6A9 \D0A4\B97C \C0AC\C6A9\D558\C5EC \C694\CCAD\C744 \C11C\BA85\D569\B2C8\B2E4.'),
unistr('\C774 \C18D\C131\C774 \C120\D0DD\C0AC\D56D\C774\AE30\B294 \D558\C9C0\B9CC \BCF4\C548\C0C1 \C694\CCAD\C744 \C11C\BA85\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007335.4419)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\B2E4\C74C\C758 SAML \C18D\C131 \C0AC\C6A9')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSTANCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'APP'
,p_help_text=>unistr('\C778\C2A4\D134\C2A4 \B808\BCA8 SAML \AD6C\C131\C744 \C0AC\C6A9\D560\C9C0 \C544\B2C8\BA74 \C560\D50C\B9AC\CF00\C774\C158 \AD00\B828 SAML \AD6C\C131\C744 \C0AC\C6A9\D560\C9C0 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007332.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C778\C2A4\D134\C2A4')
,p_return_value=>'INSTANCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C804\CCB4 &PRODUCT_NAME. \C778\C2A4\D134\C2A4\C5D0 \B300\D55C \ACF5\C720 SAML \AD6C\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4.'),
unistr('\C774\B97C \C704\D574\C11C\B294 \C778\C2A4\D134\C2A4 \AD00\B9AC\C790\AC00 \C778\C2A4\D134\C2A4 \B808\BCA8 SAML \C18D\C131\C744 \AD6C\C131\D588\C5B4\C57C \D569\B2C8\B2E4.'),
unistr('\ADF8\B807\C9C0 \C54A\C740 \ACBD\C6B0 \B7F0\D0C0\C784 \C624\B958\AC00 \BC1C\C0DD\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007331.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
,p_return_value=>'APP'
,p_is_deprecated=>true
,p_help_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD00\B828 SAML \AD6C\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007336.4419)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('ID \C81C\ACF5\C790 Single Sign-On URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>unistr('ID \C81C\ACF5\C790\C758 Single Sign-On POST URL\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007337.4419)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('ID \C81C\ACF5\C790 \C2F1\AE00 \C0AC\C778\C544\C6C3 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ID \C81C\ACF5\C790\C758 \C2F1\AE00 \C0AC\C778\C544\C6C3 POST URL\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\BE44\C6CC \B458 \ACBD\C6B0 \C2F1\AE00 \C0AC\C778\C544\C6C3 URL\C774 \C0AC\C6A9\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007338.4419)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('ID \C81C\ACF5\C790 \BC1C\D589\C790')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ID \C81C\ACF5\C790\C758 "\BC1C\D589\C790" \AC12\C744 \C120\D0DD\D569\B2C8\B2E4.'),
unistr('&PRODUCT_NAME.\C740(\B294) ID \C81C\ACF5\C790\C758 \BA54\C2DC\C9C0\C5D0\C11C \C774 \AC12\C744 \D655\C778\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007339.4419)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('\C0AC\C6A9\C790 \C774\B984 \C18D\C131')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C0AC\C6A9\C790 \C774\B984\C744 \D3EC\D568\D558\B294 SAML \C18D\C131\C785\B2C8\B2E4.'),
unistr('"\AC80\C99D/\C8FC\CCB4/NameID" \B178\B4DC\C758 \AC12\C774 \AE30\BCF8\AC12\C73C\B85C \C124\C815\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007340.4419)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>60
,p_prompt=>unistr('ID \C81C\ACF5\C790 \C11C\BA85 \C778\C99D\C11C')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ID \C81C\ACF5\C790\AC00 \BA54\C2DC\C9C0 \C11C\BA85\C5D0 \C0AC\C6A9\D558\B294 \C778\C99D\C11C\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('&PRODUCT_NAME.\C740(\B294) \C774 \C778\C99D\C11C\B97C \C0AC\C6A9\D558\C5EC ID \C81C\ACF5\C790\C758 \C751\B2F5 \BA54\C2DC\C9C0\B97C \D655\C778\D569\B2C8\B2E4.'),
unistr('\C774 \C18D\C131\C774 \C120\D0DD\C0AC\D56D\C774\AE30\B294 \D558\C9C0\B9CC \BCF4\C548\C0C1 \C751\B2F5\C744 \D655\C778\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549695930675668342.4419)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\C0AC\C6A9\C790 \C774\B984\C744 \B300\BB38\C790\B85C \BCC0\D658')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\C0AC\C6A9\C790 \C774\B984\C758 \C18D\C131\AC12\C744 \B300\BB38\C790\B85C \BCC0\D658\D574\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \AD6C\C131\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/item_type/input
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1401075215817352.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'INPUT'
,p_display_name=>unistr('\C785\B825 \D544\B4DC')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','INPUT'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1401202979819499.4419)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\BE44\AD50 \C5F0\C0B0\C790')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1401536563820127.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\AC19\C74C')
,p_return_value=>'EQUALS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402360244821204.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\BBF8\B9CC')
,p_return_value=>'LT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402711336822152.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\C791\AC70\B098 \AC19\C74C')
,p_return_value=>'LTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403187913822669.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4419)
,p_display_sequence=>50
,p_display_value=>unistr('\CD08\ACFC')
,p_return_value=>'GT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403530010823859.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4419)
,p_display_sequence=>60
,p_display_value=>unistr('\D06C\AC70\B098 \AC19\C74C')
,p_return_value=>'GTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1574661752077055.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4419)
,p_display_sequence=>70
,p_display_value=>unistr('\B2E4\C74C\C73C\B85C \C2DC\C791')
,p_return_value=>'STARTS_WITH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403924638824893.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4419)
,p_display_sequence=>80
,p_display_value=>unistr('\D3EC\D568')
,p_return_value=>'CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1404353085828349.4419)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\B300\C18C\BB38\C790 \AD6C\BD84')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1401202979819499.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STARTS_WITH,CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1581137453249138.4419)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\AC12 \B300\C18C\BB38\C790')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MIXED'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1404353085828349.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\BAA8\B4E0 \B370\C774\D130 \AC12\C774 \C774\BBF8 \C18C\BB38\C790 \B610\B294 \B300\BB38\C790\C778 \ACBD\C6B0 \C5EC\AE30\C11C \C120\C5B8\D560 \C218 \C788\C2B5\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\AC00 \B300\C18C\BB38\C790 \BB34\C2DC \AC80\C0C9\C744 \C218\D589\D574\B3C4 \C2E4\C81C\B85C \B370\C774\D130\BCA0\C774\C2A4\B294 \C77C\BC18\C801\C778 \B300\C18C\BB38\C790 \AD6C\BD84 \AC80\C0C9\C744 \C218\D589\D558\B3C4\B85D \C77C\BC18 \C0AC\C6A9\C790\AC00 \C81C\ACF5\D558\B294 \D544\D130\AC00 \C120\C5B8\B41C \B300\C18C\BB38\C790\B85C \C790\B3D9 \BCC0\D658\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581469548249721.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\B300\C18C\BB38\C790 \D63C\D569')
,p_return_value=>'MIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581879901250301.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C18C\BB38\C790')
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1582278689250872.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\B300\BB38\C790')
,p_return_value=>'UPPER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1573402545049808.4419)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\D604\C7AC \B808\C774\BE14')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>unistr('%0\C5D0 \B300\D55C \D544\D130\B9C1')
,p_help_text=>unistr('\D604\C7AC \D328\C2EF \C601\C5ED\C5D0\C11C \C774 \D328\C2EF\C5D0 \B300\D574 \D45C\C2DC\B420 \D14D\C2A4\D2B8\B97C \C81C\ACF5\D569\B2C8\B2E4. \D604\C7AC \AC12\C740 <strong>%0</strong> \C704\CE58 \D45C\C2DC\C790\AC00 \C788\B294 \CC38\C870\C77C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1594998866512975.4419)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\C811\B450\C5B4 \D14D\C2A4\D2B8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\C785\B825 \D544\B4DC \C55E\C5D0 \D45C\C2DC\B420 \D14D\C2A4\D2B8\B97C \C81C\ACF5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1595229523514009.4419)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\C811\BBF8\C5B4 \D14D\C2A4\D2B8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\C785\B825 \D544\B4DC \B4A4\C5D0 \D45C\C2DC\B420 \D14D\C2A4\D2B8\B97C \C81C\ACF5\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/region_type/cards
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1602002675849340.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CARDS'
,p_display_name=>unistr('\CE74\B4DC')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CARDS'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\CE74\B4DC\C758 \AC01 \D589\C5D0 \B300\D55C \B370\C774\D130\B97C \D45C\C2DC\D558\B294 SQL \C9C8\C758 \AE30\BC18 \BCF4\ACE0\C11C\C785\B2C8\B2E4. \CE74\B4DC\B97C \C0AC\C6A9\D558\C5EC \CF58\D150\CE20 \BE14\B85D\C5D0\C11C \B370\C774\D130\B97C \AC04\D3B8\D558\AC8C \C2DC\AC01\D654\D560 \C218 \C788\C2B5\B2C8\B2E4. \BA38\B9AC\AE00, \B9E4\CCB4, \BCF8\BB38 \B610\B294 \C791\C5C5\C744 \C120\C5B8\C801\C73C\B85C \C0AC\C6A9\C790\C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(1602292184849355.4419)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4419)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(633822552473663477.4419)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4419)
,p_name=>'tablemodelviewpagechange'
,p_display_name=>unistr('\D398\C774\C9C0 \BCC0\ACBD')
);
end;
/
prompt --application/shared_components/plugins/web_source_type/http
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1677862467038200.4419)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'HTTP'
,p_display_name=>'HTTP'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','HTTP'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1901267720643867.4419)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\D398\C774\C9C0 \B9E4\AE40 \C5C6\C74C')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901523910653468.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D398\C774\C9C0 \D06C\AE30 \BC0F \C778\CD9C \C624\D504\C14B')
,p_return_value=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\AC00 <em>\D398\C774\C9C0 \D06C\AE30</em> \BC0F <em>\C624\D504\C14B</em> ("\D589\C5D0 \C2DC\C791") \B9E4\AC1C\BCC0\C218\B97C \C0AC\C6A9\D558\C5EC \D2B9\C815 \D589 \C9D1\D569\C744 \C694\CCAD\D560 \C218 \C788\B294 \C720\C5F0\D55C \D398\C774\C9C0 \B9E4\AE40\C785\B2C8\B2E4. URL\C740 \C77C\BC18\C801\C73C\B85C \B2E4\C74C \C608\C640 \BE44\C2B7\D569\B2C8\B2E4. \C5EC\AE30\C11C <strong>20</strong>\AC1C \D589\C744 \AC74\B108\B6F0\ACE0 \B2E4\C74C <strong>100</strong>\AC1C \D589\C744 \C778\CD9C\D569\B2C8\B2E4.</p>'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?limit=100&offset=20',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901988519660109.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D398\C774\C9C0 \D06C\AE30 \BC0F \D398\C774\C9C0 \BC88\D638')
,p_return_value=>'PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\AC00 <em>\D398\C774\C9C0 \D06C\AE30</em> \BC0F <em>\D398\C774\C9C0 \BC88\D638</em> \B9E4\AC1C\BCC0\C218\B97C \C0AC\C6A9\D558\C5EC \D589 \C9D1\D569\C744 \C694\CCAD\D560 \C218 \C788\B294 \D398\C774\C9C0 \B9E4\AE40\C785\B2C8\B2E4. URL\C740 \C77C\BC18\C801\C73C\B85C \B2E4\C74C \C608\C640 \BE44\C2B7\D569\B2C8\B2E4. \C5EC\AE30\C11C \D398\C774\C9C0 \BC88\D638 <strong>2</strong>\B97C \D398\C774\C9C0 \D06C\AE30 <strong>100</strong>\C73C\B85C \C694\CCAD\D558\BA74 101 ~ 200 \D589\C774 \BC18\D658\B429\B2C8\B2E4.'),
'</p>',
'<pre>',
'http://hostname.domain.com/path/to/rest_api?size=100&page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1902974368668773.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\D398\C774\C9C0 \BC88\D638')
,p_return_value=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\AC00 <em>\D398\C774\C9C0</em> \B9E4\AC1C\BCC0\C218\B97C \C0AC\C6A9\D558\C5EC \D589 \C9D1\D569\C744 \C694\CCAD\D560 \C218 \C788\B294 \D398\C774\C9C0 \B9E4\AE40\C785\B2C8\B2E4. \D398\C774\C9C0 \D06C\AE30\B294 \ACE0\C815\C774\ACE0 REST API\C5D0 \C758\D574 \ACB0\C815\B429\B2C8\B2E4. URL\C740 \C77C\BC18\C801\C73C\B85C \B2E4\C74C \C608\C640 \BE44\C2B7\D569\B2C8\B2E4. \C5EC\AE30\C11C \D398\C774\C9C0 \BC88\D638 <strong>2</strong>\B97C \C694\CCAD\D558\ACE0 REST API\AC00 \ACE0\C815 \D398\C774\C9C0 \D06C\AE30 <strong>20</strong>\C744 \C0AC\C6A9\D558\B294 \ACBD\C6B0 21 ~ 40 \D589\C774 \BC18\D658\B429\B2C8\B2E4.'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904445073685723.4419)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D398\C774\C9C0 \D06C\AE30 URL \B9E4\AC1C\BCC0\C218')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'FLEXIBLE,PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\C5D0\C11C \C694\CCAD\D560 <em>\D398\C774\C9C0 \D06C\AE30</em>\B97C \C9C0\C815\D558\B294 URL \B9E4\AC1C\BCC0\C218\B97C \C81C\ACF5\D569\B2C8\B2E4. \C77C\BC18\C801\C778 \AC12\C740 <strong>limit</strong>, <strong>page_size</strong> \B610\B294 </strong>per_page</strong>\C785\B2C8\B2E4.</p>'),
unistr('<p><em>REST \B370\C774\D130 \C18C\C2A4 <strong>\B9E4\AC1C\BCC0\C218</strong> \C548\C5D0 \C774 \B9E4\AC1C\BCC0\C218\B97C \CD94\AC00\D558\C9C0 \B9C8\C2ED\C2DC\C624</em>. &PRODUCT_NAME.\C774(\AC00) HTTP \C694\CCAD\C744 \C2E4\D589\D560 \B54C \C790\B3D9\C73C\B85C \CD94\AC00\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904796837692405.4419)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\D398\C774\C9C0 \D06C\AE30 \CD5C\B300\AC12')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>10
,p_unit=>unistr('\D589')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\AC00 \C778\CD9C\D560 \C218 \C788\B294 \D398\C774\C9C0\B2F9 \CD5C\B300 \D589 \C218\B97C \C81C\ACF5\D569\B2C8\B2E4. &PRODUCT_NAME.\C740(\B294) \D398\C774\C9C0\B2F9 \B354 \B9CE\C740 \D589\C744 \C694\CCAD\D558\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
unistr('<p>REST API\AC00 \D574\B2F9 \D589 \C218\B97C <em>\C2E4\C81C\B85C \BC18\D658</em>\D558\B294\C9C0 \D655\C778\D558\C2ED\C2DC\C624. &PRODUCT_NAME.\C740(\B294) \C694\CCAD\B41C \AC83\BCF4\B2E4 \C801\C740 \D589\C774 \C751\B2F5\C5D0 \B4E4\C5B4 \C788\C73C\BA74 \C694\CCAD\B41C \D398\C774\C9C0\B97C \B9C8\C9C0\B9C9 \D398\C774\C9C0\B85C \AC00\C815\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905045481696652.4419)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\D398\C774\C9C0 \BC88\D638 URL \B9E4\AC1C\BCC0\C218')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\C5D0\C11C \C694\CCAD\D560 <em>\D398\C774\C9C0 \BC88\D638</em>\B97C \C9C0\C815\D558\B294 URL \B9E4\AC1C\BCC0\C218\B97C \C81C\ACF5\D569\B2C8\B2E4. \C77C\BC18\C801\C778 \AC12\C740 <strong>page</strong>\C785\B2C8\B2E4.</p>'),
unistr('<p><em>REST \B370\C774\D130 \C18C\C2A4 <strong>\B9E4\AC1C\BCC0\C218</strong> \C548\C5D0 \C774 \B9E4\AC1C\BCC0\C218\B97C \CD94\AC00\D558\C9C0 \B9C8\C2ED\C2DC\C624</em>. &PRODUCT_NAME.\C774(\AC00) HTTP \C694\CCAD\C744 \C2E4\D589\D560 \B54C \C790\B3D9\C73C\B85C \CD94\AC00\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905385707699679.4419)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\CCAB\BC88\C9F8 \D398\C774\C9C0\C758 \C778\B371\C2A4')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>REST API\AC00 \D398\C774\C9C0 \CE74\C6B4\D305\C744 \C778\B371\C2A4 <strong>"0"</strong> \B610\B294 <strong>"1"</strong>\C5D0\C11C \C2DC\C791\D558\B294\C9C0 \C9C0\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1905636932702605.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4419)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
,p_is_quick_pick=>true
,p_help_text=>unistr('REST API\AC00 \CCAB\BC88\C9F8 \D398\C774\C9C0\B97C <strong>1</strong> \D398\C774\C9C0\B77C\ACE0 \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1906025829704631.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4419)
,p_display_sequence=>20
,p_display_value=>'0'
,p_return_value=>'0'
,p_is_quick_pick=>true
,p_help_text=>unistr('REST API\AC00 \CCAB\BC88\C9F8 \D398\C774\C9C0\B97C <strong>0</strong> \D398\C774\C9C0\B77C\ACE0 \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906661765710861.4419)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\ACE0\C815 \D398\C774\C9C0 \D06C\AE30')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>10
,p_unit=>unistr('\D589')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\C5D0 \C758\D574 \ACB0\C815\B41C <em>\D398\C774\C9C0 \D06C\AE30</em>(\D398\C774\C9C0\B2F9 \D589 \C218)\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>\C77C\BC18\C801\C73C\B85C \C774 \C815\BCF4\B294 REST API \C124\BA85\C11C\C5D0\C11C \CC3E\C744 \C218 \C788\C2B5\B2C8\B2E4. \C5EC\AE30\C5D0 \C815\D655\D55C \AC12\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4. \AC12\C774 \C815\D655\D558\C9C0 \C54A\C73C\BA74 &PRODUCT_NAME.\C774(\AC00) REST API\C5D0\C11C \B370\C774\D130\B97C \C778\CD9C\D560 \B54C \D589\C774 \B204\B77D\B418\AC70\B098 \C911\BCF5\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906984049714159.4419)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\D589 \C624\D504\C14B URL \B9E4\AC1C\BCC0\C218')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_unit=>unistr('\D589')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CCAB\BC88\C9F8 \D589\C774 \BC18\D658\B418\AE30 \C804\C5D0 \AC74\B108\B6F8 \D589 \C218\B97C \B098\D0C0\B0B4\B294 <em>\C624\D504\C14B</em>\C744 \C9C0\C815\D560 URL \B9E4\AC1C\BCC0\C218\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p><em>REST \B370\C774\D130 \C18C\C2A4 <strong>\B9E4\AC1C\BCC0\C218</strong> \C548\C5D0 \C774 \B9E4\AC1C\BCC0\C218\B97C \CD94\AC00\D558\C9C0 \B9C8\C2ED\C2DC\C624</em>. &PRODUCT_NAME.\C774(\AC00) HTTP \C694\CCAD\C744 \C2E4\D589\D560 \B54C \C790\B3D9\C73C\B85C \CD94\AC00\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1907222147716823.4419)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\D589 \C624\D504\C14B \C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OFFSET'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p><strong>\C624\D504\C14B</strong> \B9E4\AC1C\BCC0\C218\AC00 <em>\AC74\B108\B6F8 \D589 \C218</em> \B610\B294 <em>\C778\CD9C\D560 \CCAB\BC88\C9F8 \D589</em>\C744 \C9C0\C815\D560\C9C0 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907577038717722.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\AC74\B108\B6F8 \D589')
,p_return_value=>'OFFSET'
,p_help_text=>unistr('\C624\D504\C14B \AC12\C774 \AC74\B108\B6F8 \D589 \C218\B97C \B098\D0C0\B0C5\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \AC12 100\C774 \C81C\ACF5\B418\BA74 REST API\B294 \C778\B371\C2A4 101\C5D0\C11C \C2DC\C791\D574 \D589\C744 \BC18\D658\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907904681718986.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C778\CD9C\D560 \CCAB\BC88\C9F8 \D589')
,p_return_value=>'START'
,p_help_text=>unistr('\C624\D504\C14B \AC12\C774 \C778\CD9C\C744 \C2DC\C791\D560 \D589\C744 \B098\D0C0\B0C5\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \AC12 100\C774 \C81C\ACF5\B418\BA74 REST API\B294 99\AC1C \D589\C744 \AC74\B108\B6F0\ACE0 \C778\B371\C2A4 100\C5D0\C11C \C778\CD9C\C744 \C2DC\C791\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908579263746808.4419)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\B354 \B9CE\C740 \D589 \C788\C74C \C120\D0DD\AE30')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\AC00 \B2E4\C74C JSON \C751\B2F5\C744 \BC18\D658\D558\B294 \ACBD\C6B0:</p>'),
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('<strong>\B354 \B9CE\C740 \D589 \C788\C74C \C120\D0DD\AE30</strong>\B294 <strong>metadata.pagination.moreRows</strong>\C785\B2C8\B2E4.'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C751\B2F5 REST API\AC00 \CD94\AC00 \D398\C774\C9C0\AC00 \C788\B294\C9C0 \C5EC\BD80\C5D0 \B300\D55C \C815\BCF4\B97C \BC18\D658\D558\B294 \ACBD\C6B0, \C5EC\AE30\C5D0 \C774 \C18D\C131\C744 \CD94\CD9C\D560 <em>\C120\D0DD\AE30</em>\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\B354 \B9CE\C740 \D589 \C788\C74C \C120\D0DD\AE30</strong> \C9C0\C815\C774 \D544\C218\B294 \C544\B2C8\C9C0\B9CC, \BAA8\B4E0 \B370\C774\D130\AC00 \C774\BBF8 \C778\CD9C\B418\C5C8\C744 \B54C &PRODUCT_NAME.\C774(\AC00) \CD94\AC00 HTTP \C694\CCAD(\B370\C774\D130 \C5C6\C74C \BC18\D658)\C744 \C800\C7A5\D558\B294 \B370 \B3C4\C6C0\C744 \C90D\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908849697751769.4419)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\B354 \B9CE\C740 \D589 \C788\C74C \C870\AC74 \AC12')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908579263746808.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p><strong>\B354 \B9CE\C740 \D589 \C788\C74C \C120\D0DD\AE30</strong>\C5D0\C11C \CC38\C870\B41C \C751\B2F5 \C18D\C131\AC12\C744 \D574\C11D\D558\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909141279756289.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\AC19\C74C')
,p_return_value=>'EQUALS'
,p_is_quick_pick=>true
,p_help_text=>unistr('<strong>\B354 \B9CE\C740 \D589 \C788\C74C \C120\D0DD\AE30</strong>\C5D0\C11C \CC38\C870\B41C \C751\B2F5 \C18D\C131\C774 \AC12\ACFC \AC19\C744 \B54C \B354 \B9CE\C740 \D589\C774 \C0AC\C6A9 \AC00\B2A5\D558\B2E4\ACE0 \AC00\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909569602757607.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\B110\C774 \C544\B2D8')
,p_return_value=>'NOT_NULL'
,p_is_quick_pick=>true
,p_help_text=>unistr('<strong>\B354 \B9CE\C740 \D589 \C788\C74C \C120\D0DD\AE30</strong>\C5D0\C11C \CC38\C870\B41C \C751\B2F5 \C18D\C131\C774 \C874\C7AC\D558\ACE0 \BE44\C5B4 \C788\C9C0 \C54A\C744 \B54C \B354 \B9CE\C740 \D589\C774 \C0AC\C6A9 \AC00\B2A5\D558\B2E4\ACE0 \AC00\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911015518771444.4419)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\B354 \B9CE\C740 \D589 \C788\C74C \C18D\C131\AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'true'
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908849697751769.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'EQUALS'
,p_help_text=>unistr('<p>&PRODUCT_NAME.\C740(\B294) <strong>\B354 \B9CE\C740 \D589 \C788\C74C \C120\D0DD\AE30</strong>\C5D0\C11C \CC38\C870\B41C \C751\B2F5 \C18D\C131\C5D0 \C774 \AC12\C774 \D3EC\D568\B41C \ACBD\C6B0 \B354 \B9CE\C740 \D589\C774 \C0AC\C6A9 \AC00\B2A5\D558\B2E4\ACE0 \AC00\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911713410779146.4419)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\CD1D \D589 \C120\D0DD\AE30')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\AC00 \B2E4\C74C JSON \C751\B2F5\C744 \BC18\D658\D558\B294 \ACBD\C6B0 ...</p>'),
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('... <strong>\B354 \B9CE\C740 \D589 \C788\C74C \C120\D0DD\AE30</strong>\B294 <strong>metadata.pagination.totalRows</strong>\C785\B2C8\B2E4.'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\AC00 \C751\B2F5\C758 \C77C\BD80\B85C (\BAA8\B4E0 \D398\C774\C9C0\C5D0 \AC78\CCD0) <em>\CD1D \D589 \C218\B7C9</em>\C744 \BC18\D658\D558\B294 \ACBD\C6B0, \C5EC\AE30\C5D0 \C774 \C18D\C131\C744 \CD94\CD9C\D560 <em>\C120\D0DD\AE30</em>\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\B354 \B9CE\C740 \D589 \C788\C74C \C120\D0DD\AE30</strong> \C9C0\C815\C774 \D544\C218\B294 \C544\B2C8\C9C0\B9CC, <em>\B370\C774\D130\AC00 \B354 \C774\C0C1 \D544\D130\B9C1\B418\C9C0 \C54A\B294 \ACBD\C6B0</em> &PRODUCT_NAME. \AD6C\C131\C694\C18C\C758 \CD1D \D589 \C218\B7C9\C744 \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/geocoded_address
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1700838675352758.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'GEOCODED_ADDRESS'
,p_display_name=>unistr('\C9C0\C624\CF54\B529 \C8FC\C18C')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','GEOCODED_ADDRESS'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#model#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.tableModelViewBase#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.grid#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.iconList#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.geoCoder#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D56D\BAA9 \C720\D615\C740 \C9C0\C624\CF54\B529(\C6B0\D3B8 \C8FC\C18C\B97C \C88C\D45C\B85C \BCC0\D658) \AE30\B2A5\C744 \C81C\ACF5\D569\B2C8\B2E4.<p>'),
unistr('<p>\C9C0\C624\CF54\B529\C740 <em>\BE0C\B77C\C6B0\C800</em>\C5D0\C11C <strong>Oracle Elocation</strong> \C9C0\C624\CF54\B529 \C11C\BE44\C2A4(elocation.oracle.com)\C5D0 REST \C694\CCAD\C744 \C218\D589\D558\C5EC \C218\D589\B429\B2C8\B2E4. \B530\B77C\C11C \C9C0\C624\CF54\B529\C774 \C791\B3D9\D558\B824\BA74 \BE0C\B77C\C6B0\C800\AC00 \C778\D130\B137\C5D0 \C811\C18D\B418\C5B4 \C788\C5B4\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\C9C0\C624\CF54\B529 \C785\B825 \B370\C774\D130\B294 \B2E4\B978 \D398\C774\C9C0 \D56D\BAA9\C5D0\C11C \AC00\C838\C624\BA70, \AC70\B9AC, \D638, \C6B0\D3B8 \BC88\D638 \B610\B294 \AD6C/\AD70/\C2DC \B4F1\C758 \C8FC\C18C \BD80\BD84\C5D0 \B9E4\D551\B429\B2C8\B2E4. \C9C0\C624\CF54\B354\B294 \AC00\B2A5\D55C \C77C\CE58 \D56D\BAA9 \BAA9\B85D\C774 \C788\B294 \D31D\C5C5 \CC3D\C744 \D45C\C2DC\D569\B2C8\B2E4. \C77C\CE58 \D56D\BAA9\C744 \C120\D0DD\D558\BA74 \D56D\BAA9\C758 \C138\C158 \C0C1\D0DC \AC12\C774 GeoJSON \D615\C2DD\C758 \C8FC\C18C \C88C\D45C\AC00 \B429\B2C8\B2E4. <strong>\C8FC\C18C \C815\B9AC</strong>\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0 \C8FC\C18C \BD80\BD84 \D398\C774\C9C0 \D56D\BAA9\C774 \C9C0\C624\CF54\B529 \C11C\BE44\C2A4\C5D0\C11C \C218\C2E0\D55C \C815\B9AC\B41C \AC12\C73C\B85C \ACB9\CCD0\C4F0\C5EC\C9D1\B2C8\B2E4.</p>'),
unistr('<p>\AC04\B2E8\D55C \C0AC\C6A9 \C0AC\B840\C758 \ACBD\C6B0 <strong>\AD6C\C870\D654\B418\C9C0 \C54A\C740 \C8FC\C18C</strong> \BAA8\B4DC\B97C \C0AC\C6A9\D558\BA74 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C8FC\C18C \BD80\BD84\C744 \CF64\B9C8\B85C \AD6C\BD84\D558\C5EC \C785\B825\D558\B294 \D14D\C2A4\D2B8 \D544\B4DC \B610\B294 \D14D\C2A4\D2B8 \C601\C5ED \D558\B098\B9CC \B9E4\D551\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \ACBD\C6B0 <strong>\C8FC\C18C \C815\B9AC</strong> \BAA8\B4DC\B97C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1701330611413991.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C9C0\C624\CF54\B354 \C77C\CE58 \BAA8\B4DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'RELAX_HOUSE_NUMBER'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p><strong>\C77C\CE58 \BAA8\B4DC</strong>\B294 \C785\B825 \C8FC\C18C\C758 \C18D\C131\C774 \C9C0\C624\CF54\B529\C5D0 \C0AC\C6A9\B418\B294 \B370\C774\D130\C640 \C5BC\B9C8\B098 \BC00\C811\D558\AC8C \C77C\CE58\D574\C57C \D558\B294\C9C0\B97C \ACB0\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702013128418533.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C815\D655')
,p_return_value=>'EXACT'
,p_help_text=>unistr('<p>\C81C\ACF5\B41C \C8FC\C18C \BD80\BD84\C774 \BAA8\B450 \C77C\CE58\D574\C57C \D569\B2C8\B2E4. \ADF8\B7EC\B098 \D638, \AC70\B9AC \C774\B984 \B610\B294 \AC70\B9AC \C720\D615\C774 <em>\BAA8\B450</em> \C77C\CE58\D558\C9C0 \C54A\B294 \ACBD\C6B0 \C6B0\D3B8 \BC88\D638, \C2DC/\B3C4, \AD6C/\AD70/\C2DC \B610\B294 \B3D9/\BA74\C5D0\C11C \CCAB\BC88\C9F8 \C77C\CE58 \D56D\BAA9\C774 \BC18\D658\B429\B2C8\B2E4. \C608\B97C \B4E4\C5B4 \AC70\B9AC \C774\B984\C740 \C62C\BC14\B974\C9C0 \C54A\C9C0\B9CC \C801\D569\D55C \C6B0\D3B8 \BC88\D638\AC00 \C9C0\C815\B41C \ACBD\C6B0 \C6B0\D3B8 \BC88\D638\C758 \C704\CE58\AC00 \BC18\D658\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702860244421796.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\AC70\B9AC \C720\D615 \D574\C81C')
,p_return_value=>'RELAX_STREET_TYPE'
,p_help_text=>unistr('<p>\C81C\ACF5\B41C <em>\AC70\B9AC \C720\D615</em>\C774 \C9C0\C624\CF54\B529\C5D0 \C0AC\C6A9\B41C \B370\C774\D130\C640 \B2E4\B97C \C218 \C788\C2B5\B2C8\B2E4. \C608\B97C \B4E4\C5B4 <strong>Main Street</strong> \B610\B294 <strong>Main Blvd</strong>\B294 \D574\B2F9 \C9C0\C5ED\C5D0 \B2E4\B978 <strong>Main Blvd</strong> \B610\B294 <strong>Main Street</strong>\AC00 \C5C6\B2E4\BA74 <strong>Main St</strong>\C640 \C77C\CE58\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1708669966452560.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\D638 \D574\C81C')
,p_return_value=>'RELAX_HOUSE_NUMBER'
,p_help_text=>unistr('<p>\D638 \BC0F \AC70\B9AC \C720\D615\C774 \C9C0\C624\CF54\B529\C5D0 \C0AC\C6A9\B41C \B370\C774\D130\C640 \B2E4\B97C \C218 \C788\C2B5\B2C8\B2E4. \C608\B97C \B4E4\C5B4 <strong>123 Main St</strong>\B294 \BAA8\D638\D568\C774\B098 \B2E4\B978 \C77C\CE58 \D56D\BAA9\C774 \C5C6\B294 \D55C <strong>123 Main Lane</strong> \BC0F <strong>124 Main St</strong>\C640 \C77C\CE58\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702428218420313.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\AC70\B9AC \C774\B984 \D574\C81C')
,p_return_value=>'RELAX_BASE_NAME'
,p_help_text=>unistr('<p>\AC70\B9AC\C758 <em>\AE30\BCF8 \C774\B984</em>, \D638 \BC0F \AC70\B9AC \C720\D615\C774 \C9C0\C624\CF54\B529\C5D0 \C0AC\C6A9\B41C \B370\C774\D130\C640 \B2E4\B97C \C218 \C788\C2B5\B2C8\B2E4. \C608\B97C \B4E4\C5B4 <strong>Pleasant Vale</strong>\C740 \B370\C774\D130\C5D0 \BAA8\D638\D568\C774\B098 \B2E4\B978 \C77C\CE58 \D56D\BAA9\C774 \C5C6\B294 \D55C <strong>Pleasant Valley</strong>\C640 \C77C\CE58\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703440180425368.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4419)
,p_display_sequence=>50
,p_display_value=>unistr('\C6B0\D3B8 \BC88\D638 \D574\C81C')
,p_return_value=>'RELAX_POSTAL_CODE'
,p_help_text=>unistr('<p>\C6B0\D3B8\BC88\D638(\C81C\ACF5\B41C \ACBD\C6B0), \AC70\B9AC \C774\B984, \AC70\B9AC \C720\D615 \BC0F \D638\AC00 \C9C0\C624\CF54\B529\C5D0 \C0AC\C6A9\B41C \B370\C774\D130\C640 \B2E4\B97C \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703985342434956.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4419)
,p_display_sequence=>60
,p_display_value=>unistr('\BAA8\B450 \D574\C81C')
,p_return_value=>'RELAX_ALL'
,p_help_text=>unistr('<p>\C8FC\C18C\B294 \B3D9\C77C\D55C \CE74\C6B4\D2F0 \B0B4\C5D0 \C788\B294 \D55C \C9C0\C815\B41C \B3C4\C2DC \C678\BD80\C5D0 \C788\C744 \C218 \C788\C2B5\B2C8\B2E4. \B610\D55C <strong>\C6B0\D3B8 \BC88\D638 \D574\C81C</strong> \D2B9\C131\B3C4 \D3EC\D568\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709401396458135.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D31D\C5C5\C5D0 \C88C\D45C \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3010200212280744.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'GRID'
,p_help_text=>unistr('<p>\C8FC\C18C \C88C\D45C(\ACBD\B3C4, \C704\B3C4)\B97C \C9C0\C624\CF54\B529 \ACB0\ACFC \D31D\C5C5 \B300\D654\C0C1\C790\C5D0 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \ACB0\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2105827892587713.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C9C0\B3C4 \BBF8\B9AC\BCF4\AE30')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'POPUP:ITEM'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\C9C0\B3C4\C5D0\C11C \C9C0\C624\CF54\B529\B41C \C8FC\C18C \BBF8\B9AC\BCF4\AE30\B97C \D5C8\C6A9\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601067718431827.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\ACB0\ACFC \D31D\C5C5')
,p_return_value=>'POPUP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0AC\C6A9\C790\AC00 \ACB0\ACFC\B97C \C120\D0DD\D558\AE30 \C804\C5D0 \C704\CE58\B97C \AC80\D1A0\D560 \C218 \C788\B3C4\B85D \C9C0\C624\CF54\B529 \ACB0\ACFC \D31D\C5C5\C5D0 \C9C0\B3C4\B97C \D45C\C2DC\D569\B2C8\B2E4.</p>'),
unistr('<p>"\D45C\C2DC \D615\C2DD - \ADF8\B9AC\B4DC \BDF0"\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0\C5D0\B9CC \C9C0\C6D0\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601404353432915.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D56D\BAA9')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\D56D\BAA9 \C704\CE58\C5D0\C11C \C8FC\C18C \C704\CE58\B97C \C2DC\AC01\D654\D55C \C9C0\B3C4\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1744825789778265.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\BC30\ACBD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\C9C0\C624\CF54\B529 \ACB0\ACFC\B97C \D45C\C2DC\D560 \BC30\ACBD \C9C0\B3C4\B97C \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746613534792926.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4419)
,p_display_sequence=>5
,p_display_value=>unistr('\AE30\BCF8\AC12')
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AE30\BCF8 \C9C0\B3C4 \BC30\ACBD\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
unistr('<p>\C5B4\B450\C6B4 \D14C\B9C8\C5D0\B294 "OpenStreetMap Bright" \B610\B294 "OpenStreetMap Dark"\B97C \C0AC\C6A9\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745320076781973.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4419)
,p_display_sequence=>10
,p_display_value=>unistr('OpenStreetMap \BC1D\AC8C')
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \BC94\C6A9 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5\C740 \D574\B2F9 \B370\C774\D130\C758 \C790\C138\D55C \C704\CE58 \CEE8\D14D\C2A4\D2B8\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>"Mapbox Open Styles"\C5D0\C11C \D30C\C0DD\B41C KlokanTech.com & OpenMapTiles \C81C\ACF5\C790\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4. BSD/CC-BY \B77C\C774\C13C\C2A4\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">GitHub\C5D0\C11C \BCF4\AE30</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745780305787850.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4419)
,p_display_sequence=>20
,p_display_value=>unistr('OpenStreetMap \C5B4\B461\AC8C')
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \B2E8\C21C\D654\B41C \C5B4\B450\C6B4 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>"Mapbox Open Styles"\C5D0\C11C \D30C\C0DD\B41C KlokanTech.com & OpenMapTiles \C81C\ACF5\C790\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4. BSD/CC-BY \B77C\C774\C13C\C2A4\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4. Stamen Design\C758 \C9C0\B3C4\C81C\C791\C740 CC0\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">GitHub\C5D0\C11C \BCF4\AE30</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746150917790500.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4419)
,p_display_sequence=>30
,p_display_value=>unistr('OpenStreetMap \C704\CE58')
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \B2E8\C21C\D654\B41C \BC1D\C740 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>"Mapbox Open Styles"\C5D0\C11C \D30C\C0DD\B41C KlokanTech.com & OpenMapTiles \C81C\ACF5\C790\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4. BSD/CC-BY \B77C\C774\C13C\C2A4\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4. Stamen Design\C758 \C9C0\B3C4\C81C\C791\C740 CC0\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">GitHub\C5D0\C11C \BCF4\AE30</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601367265556756.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4419)
,p_display_sequence=>40
,p_display_value=>'Oracle World Map'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>HERE \B9F5 \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \BC94\C6A9 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130\C758 \C704\CE58 \CEE8\D14D\C2A4\D2B8\B97C \C81C\ACF5\D558\ACE0 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>\BBF8\AD6D \C624\B77C\D074\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2206585812380955.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\B192\C774')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>unistr('\D53D\C140')
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D45C\C2DC\B41C \C9C0\B3C4\C758 \B192\C774(\D53D\C140)\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\C9C0\B3C4\C758 \AE30\BCF8 \B192\C774\B294 \AC00\B85C \C138\B85C \BE44\C728\C774 3:2\C778 \B108\BE44\B97C \AE30\C900\C73C\B85C \ACC4\C0B0\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3010200212280744.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>unistr('\D45C\C2DC \D615\C2DD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'LIST'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\C9C0\C624\CF54\B529 \ACB0\ACFC\AC00 \D45C\C2DC\B418\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011428457283918.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\BAA9\B85D \BCF4\AE30')
,p_return_value=>'LIST'
,p_help_text=>unistr('<p>\ACB0\ACFC\AC00 \BAA9\B85D \BDF0\B85C \D45C\C2DC\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011010596282953.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\ADF8\B9AC\B4DC \BDF0')
,p_return_value=>'GRID'
,p_help_text=>unistr('<p>\ACB0\ACFC\AC00 \ADF8\B9AC\B4DC \BDF0\B85C \D45C\C2DC\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709967230470781.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>60
,p_prompt=>unistr('\AD6C\C870\D654\B41C \C8FC\C18C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C8FC\C18C \BD80\BD84\C774 \C9C0\C624\CF54\B529 \C11C\BE44\C2A4\C5D0 <em>\AD6C\C870\D654\B41C</em> \BC29\C2DD \B610\B294 <em>\AD6C\C870\D654\B418\C9C0 \C54A\C740</em> \BC29\C2DD\C73C\B85C \C81C\ACF5\B418\B294\C9C0 \C5EC\BD80\C785\B2C8\B2E4.</p>'),
unistr('<p>\AD6C\C870\D654\B41C \BC29\C2DD\C758 \ACBD\C6B0 \BA85\C2DC\C801 \D398\C774\C9C0 \D56D\BAA9\C774 \C9C0\C5ED, \AD6C/\AD70/\C2DC, \C6B0\D3B8 \BC88\D638, \AC70\B9AC\C640 \AC19\C740 \C8FC\C18C \BD80\BD84\C5D0 \B9E4\D551\B429\B2C8\B2E4. \B530\B77C\C11C \B354 \C815\D655\D55C \C9C0\C624\CF54\B529 \ACB0\ACFC\B97C \C5BB\ACE0'),
unistr('\C218\C815\B41C \C8FC\C18C\B97C \D398\C774\C9C0 \D56D\BAA9\C5D0 \B2E4\C2DC \C81C\ACF5\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\AD6C\C870\D654\B418\C9C0 \C54A\C740 \BC29\C2DD\C758 \ACBD\C6B0 \C804\CCB4 \C8FC\C18C\C5D0 \B300\D574 \D558\B098\C758 \D56D\BAA9\B9CC \C0AC\C6A9\B418\BA70, \BD80\BD84\C740 \CF64\B9C8\B85C \AD6C\BD84\B429\B2C8\B2E4. \C774 \BAA8\B4DC\C5D0\C11C\B294 \C218\C815\B41C \C8FC\C18C\B97C \D398\C774\C9C0 \D56D\BAA9\C5D0 \B2E4\C2DC \C81C\ACF5\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1710428568474713.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('\AD6D\AC00 \C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\C9C0\C624\CF54\B529\C5D0 \C815\C801 \AD6D\AC00\B97C \C0AC\C6A9\D560\C9C0 \B610\B294 \D56D\BAA9\C5D0\C11C \AD6D\AC00\B97C \D30C\C0DD\D560\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1710966154475523.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C815\C801')
,p_return_value=>'STATIC'
,p_help_text=>unistr('<p>\C120\D0DD \BAA9\B85D\C758 \C815\C801 \AD6D\AC00\B97C \C0AC\C6A9\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1711762868476607.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D56D\BAA9')
,p_return_value=>'ITEM'
,p_help_text=>unistr('<p>\C560\D50C\B9AC\CF00\C774\C158 \B610\B294 \D398\C774\C9C0 \D56D\BAA9\C5D0\C11C \AD6D\AC00\B97C \AC00\C838\C635\B2C8\B2E4. \D56D\BAA9\C5D0\B294 \B450 \C790\B9BF\C218 ISO \AD6D\AC00 \CF54\B4DC\AC00 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4. </p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712263798480014.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\AD6D\AC00')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('<li><strong>US</strong>: \BBF8\AD6D</li>'),
unistr('<li><strong>UK</strong>: \C601\AD6D</li>'),
unistr('<li><strong>DE</strong>: \B3C5\C77C</li>'),
unistr('<li><strong>AT</strong>: \C624\C2A4\D2B8\B9AC\C544</li>'),
'</ul>'))
,p_help_text=>unistr('<p>\C9C0\C624\CF54\B529\D560 \AD6D\AC00\B97C \AC00\C838\C62C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4. \D56D\BAA9\C5D0\B294 \B450 \C790\B9BF\C218 ISO \AD6D\AC00 \CF54\B4DC\AC00 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712712695483947.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>unistr('\AD6D\AC00')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'US'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\C9C0\C624\CF54\B529\C5D0 \C0AC\C6A9\D560 \AD6D\AC00\B97C \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713260223484493.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\BBF8\AD6D')
,p_return_value=>'US'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713640362485278.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C601\AD6D')
,p_return_value=>'UK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1714942400488162.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\B3C5\C77C')
,p_return_value=>'DE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715315187488602.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\D504\B791\C2A4')
,p_return_value=>'FR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715776600489110.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>50
,p_display_value=>unistr('\C774\D0C8\B9AC\C544 ')
,p_return_value=>'IT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732218107588818.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>60
,p_display_value=>unistr('\CE90\B098\B2E4')
,p_return_value=>'CA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732613691589456.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>70
,p_display_value=>unistr('\B124\B35C\B780\B4DC')
,p_return_value=>'NL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733039072590094.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>80
,p_display_value=>unistr('\BCA8\AE30\C5D0')
,p_return_value=>'BE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733467346590779.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>90
,p_display_value=>unistr('\C624\C2A4\D2B8\B9AC\C544')
,p_return_value=>'AT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733819745591632.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>100
,p_display_value=>unistr('\C2A4\C704\C2A4')
,p_return_value=>'CH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734205667592050.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>110
,p_display_value=>unistr('\C2A4\D398\C778')
,p_return_value=>'ES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734685684592583.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>120
,p_display_value=>unistr('\D3EC\B974\D22C\AC08')
,p_return_value=>'PT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735060793593960.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>130
,p_display_value=>unistr('\B7EC\C2DC\C544 \C5F0\BC29')
,p_return_value=>'RU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735422526594737.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>140
,p_display_value=>unistr('\C5D0\C2A4\D1A0\B2C8\C544')
,p_return_value=>'EE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735848786595289.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>150
,p_display_value=>unistr('\C778\B3C4')
,p_return_value=>'IN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736299306596060.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>160
,p_display_value=>unistr('\BA55\C2DC\CF54')
,p_return_value=>'MX'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736643807596659.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>170
,p_display_value=>unistr('\C624\C2A4\D2B8\B808\C77C\B9AC\C544')
,p_return_value=>'AU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737040872597462.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>180
,p_display_value=>unistr('\BE0C\B77C\C9C8')
,p_return_value=>'BR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737421643598208.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>190
,p_display_value=>unistr('\CE60\B808')
,p_return_value=>'CL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737878315598644.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>200
,p_display_value=>unistr('\CCB4\CF54 \ACF5\D654\AD6D')
,p_return_value=>'CZ'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738298290599154.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>210
,p_display_value=>unistr('\B178\B974\C6E8\C774')
,p_return_value=>'NO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738640811599640.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>220
,p_display_value=>unistr('\D540\B780\B4DC')
,p_return_value=>'FI'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739045295600254.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>230
,p_display_value=>unistr('\B374\B9C8\D06C')
,p_return_value=>'DK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739492220600840.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>240
,p_display_value=>unistr('\D64D\CF69')
,p_return_value=>'HK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739888238601924.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>250
,p_display_value=>unistr('\C544\C77C\B79C\B4DC')
,p_return_value=>'IE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740248023602467.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>260
,p_display_value=>unistr('\B77C\D2B8\BE44\C544')
,p_return_value=>'LV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740660821603187.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>270
,p_display_value=>unistr('\B8E8\B9C8\B2C8\C544')
,p_return_value=>'RO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741021923603709.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>280
,p_display_value=>unistr('\CF5C\B86C\BE44\C544')
,p_return_value=>'CO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741493695604368.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>290
,p_display_value=>unistr('\D3F4\B780\B4DC')
,p_return_value=>'PL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741819445604954.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>300
,p_display_value=>unistr('\C544\B78D\C5D0\BBF8\B808\C774\D2B8')
,p_return_value=>'AE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742273782605774.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>310
,p_display_value=>unistr('\D5DD\AC00\B9AC')
,p_return_value=>'HU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742644763606445.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>320
,p_display_value=>unistr('\C0AC\C6B0\B514\C544\B77C\BE44\C544')
,p_return_value=>'SA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1743094899606998.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4419)
,p_display_sequence=>330
,p_display_value=>unistr('\B0A8\C544\D504\B9AC\CE74 \ACF5\D654\AD6D')
,p_return_value=>'ZA'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1716542235497108.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>70
,p_prompt=>unistr('\C8FC\C18C \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('<p>\AD6C\C870\D654\B418\C9C0 \C54A\C740 \C8FC\C18C \BD80\BD84(\CF64\B9C8\B85C \AD6C\BD84\B428)\C774 \D3EC\D568\B41C \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720233540512149.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>80
,p_prompt=>unistr('\AC70\B9AC \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\C8FC\C18C\C758 <em>\AC70\B9AC</em> \BD80\BD84\C774 \D3EC\D568\B41C \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
end;
/
begin
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720738899514712.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>90
,p_prompt=>unistr('\D638 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\C8FC\C18C\C758 <em>\D638</em> \BD80\BD84\C774 \D3EC\D568\B41C \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721280838517001.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>120
,p_prompt=>unistr('\AD6C/\AD70/\C2DC \D558\C704 \C9C0\C5ED \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\C8FC\C18C\C758 <em>\D558\C704 \C9C0\C5ED(\AD6C/\AD70/\C2DC \B0B4)</em> \BD80\BD84\C774 \D3EC\D568\B41C \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721711111518708.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>110
,p_prompt=>unistr('\AD6C/\AD70/\C2DC \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\C8FC\C18C\C758 <em>\AD6C/\AD70/\C2DC</em> \BD80\BD84\C774 \D3EC\D568\B41C \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722254500520558.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\C6B0\D3B8 \BC88\D638 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\C8FC\C18C\C758 <em>\C6B0\D3B8 \BC88\D638</em> \BD80\BD84\C774 \D3EC\D568\B41C \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722749669524835.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>130
,p_prompt=>unistr('\C9C0\C5ED \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\C8FC\C18C\C758 <em>\C9C0\C5ED(\C2DC/\B3C4)</em> \BD80\BD84\C774 \D3EC\D568\B41C \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1723298553527158.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>unistr('\C8FC\C18C \C815\B9AC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\C9C0\C624\CF54\B529 \C11C\BE44\C2A4\C758 \C8FC\C18C \B370\C774\D130\B97C \B9E4\D551\B41C \D56D\BAA9\C5D0 \B2E4\C2DC \C81C\ACF5\D558\B824\BA74 \C774 \C2A4\C704\CE58\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727004690548379.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>135
,p_prompt=>unistr('\C77C\CE58 \BCA1\D130 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C0\C624\CF54\B354\C5D0\C11C <em>\C77C\CE58 \BCA1\D130</em>\B97C \BC18\D658\D560 \D398\C774\C9C0 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4. \C77C\CE58 \BCA1\D130\B294 17\C790\B9AC \BB38\C790\C5F4\B85C, \AC01 \C8FC\C18C \C18D\C131\C774 \C9C0\C624\CF54\B529\C5D0 \C0AC\C6A9\B41C \B370\C774\D130\C640 \C77C\CE58\D558\B294 \C815\B3C4\C5D0 \B300\D55C \C790\C138\D55C \C815\BCF4\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\B9E4\CE58 \BCA1\D130 \C790\B9BF\C218\B294 \B2E4\C74C\ACFC \AC19\C740 \AC12\C744 \AC00\C9C8 \C218 \C788\C2B5\B2C8\B2E4.</strong></p>'),
'<ul>',
unistr('<li><p>0: \C785\B825 \C18D\C131\C774 \B110\C774 \C544\B2C8\BA70 \B110\C774 \C544\B2CC \AC12\ACFC \C77C\CE58\D569\B2C8\B2E4.</p></li>'),
unistr('<li><p>1: \C785\B825 \C18D\C131\C774 \B110\C774\BA70 \B110 \AC12\ACFC \C77C\CE58\D569\B2C8\B2E4.</p></li>'),
unistr('<li><p>2: \C785\B825 \C18D\C131\C774 \B110\C774 \C544\B2C8\BA70 \B110\C774 \C544\B2CC \B2E4\B978 \AC12\C73C\B85C \B300\CCB4\B429\B2C8\B2E4.</p></li>'),
unistr('<li><p>3: \C785\B825 \C18D\C131\C774 \B110\C774 \C544\B2C8\BA70 \B110 \AC12\C73C\B85C \B300\CCB4\B429\B2C8\B2E4.</p></li>'),
unistr('<li><p>4: \C785\B825 \C18D\C131\C774 \B110\C774\BA70 \B110\C774 \C544\B2CC \AC12\C73C\B85C \B300\CCB4\B429\B2C8\B2E4.</p></li>'),
'</ul>',
'<br>',
unistr('<p><strong>\C77C\CE58 \BCA1\D130 \BC0F \AC01\AC01\C5D0 \D574\B2F9\D558\B294 \C8FC\C18C \C18D\C131 \C77C\CE58:</strong></p>'),
'<ul>',
unistr('<li><p>3: \C8FC\C18C \D3EC\C778\D2B8(\C9C0\C624\CF54\B529\C5D0 \C0AC\C6A9\B41C \B370\C774\D130\C5D0\C11C \C77C\CE58\D558\B294 \C815\D655\D55C \C8FC\C18C)</p></li>'),
unistr('<li><p>4: \AD00\C2EC \C9C0\C810 \C774\B984</p></li>'),
unistr('<li><p>5: \D638</p></li>'),
unistr('<li><p>6: \AC70\B9AC \C811\B450\C5B4</p></li>'),
unistr('<li><p>7: \AC70\B9AC \C774\B984</p></li>'),
unistr('<li><p>8: \AC70\B9AC \C811\BBF8\C5B4</p></li>'),
unistr('<li><p>9: \AC70\B9AC \C720\D615</p></li>'),
unistr('<li><p>10: \BCF4\C870 \B2E8\C704</p></li>'),
unistr('<li><p>11: \AD6C/\AD70/\C2DC</p></li>'),
unistr('<li><p>14: \C9C0\C5ED</p></li>'),
unistr('<li><p>15: \AD6D\AC00</p></li>'),
unistr('<li><p>16: \C6B0\D3B8 \BC88\D638</p></li>'),
unistr('<li><p>17: \CD94\AC00 \C6B0\D3B8 \BC88\D638</p></li>'),
unistr('<li><p><em>\B2E4\B978 \C22B\C790\B294 \C544\C9C1 \C0AC\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</em></p></li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727549870549765.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\C9C0\C624\CF54\B529 \D2B8\B9AC\AC70')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AUTOMATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\C9C0\C624\CF54\B529\C744 \D2B8\B9AC\AC70\D560 \C2DC\AE30\B97C \ACB0\C815\D569\B2C8\B2E4. \C5EC\AE30\C5D0\B294 \C9C0\C624\CF54\B529 \C11C\BE44\C2A4\C5D0 \B300\D55C REST \C694\CCAD\C744 \C218\D589\D558\ACE0 \AC00\B2A5\D55C \C77C\CE58 \D56D\BAA9\C774 \C788\B294 \D31D\C5C5 \CC3D\C744 \D45C\C2DC\D558\B294 \BE0C\B77C\C6B0\C800\AC00 \D3EC\D568\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728048005551626.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C790\B3D9')
,p_return_value=>'AUTOMATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D398\C774\C9C0\AC00 \C81C\CD9C\B418\AE30 \C804\C5D0 \C9C0\C624\CF54\B529\C774 \C790\B3D9\C73C\B85C \D2B8\B9AC\AC70\B429\B2C8\B2E4.</p>'),
unistr('<p>\C608\B97C \B4E4\C5B4 <em>P1_STREET</em> \AC12\ACFC \AC19\C740 \C885\C18D \D56D\BAA9 \AC12\C774 \BCC0\ACBD\B418\C5C8\ACE0 \C9C0\C624\CF54\B529\C774 \C9C0\AE08\AE4C\C9C0 \C2E4\D589\B418\C9C0 \C54A\C558\AC70\B098 \C801\D569\D55C \C8FC\C18C\AC00 \C120\D0DD\B418\C9C0 \C54A\C740 \ACBD\C6B0, \C9C0\C624\CF54\B529\C774 \C790\B3D9\C73C\B85C \D2B8\B9AC\AC70\B418\B3C4\B85D \D569\B2C8\B2E4. \C774 \ACBD\C6B0 \D604\C7AC \D398\C774\C9C0 \C81C\CD9C\C758 \C81C\CD9C \D50C\B85C\C6B0\B97C \C911\B2E8\D558\ACE0 \BA3C\C800 \AC00\B2A5\D55C \C77C\CE58\D56D\BAA9\C774 \C788\B294 \D31D\C5C5 \CC3D\C744 \D45C\C2DC\D569\B2C8\B2E4. \C0AC\C6A9\C790\AC00 \C77C\CE58 \ACB0\ACFC\B97C \C120\D0DD\D558\BA74 \B354 \C774\C0C1\C758 \C911\B2E8 \C5C6\C774 \D398\C774\C9C0\B97C \B2E4\C2DC \C81C\CD9C\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728439221554365.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\B3D9\C801 \C791\C5C5')
,p_return_value=>'DYNAMIC_ACTION'
,p_help_text=>unistr('<p>\B3D9\C801 \C791\C5C5 <em>\C9C0\C624\CF54\B529 \D2B8\B9AC\AC70</em>\B97C \D398\C774\C9C0\C5D0 \CD94\AC00\D558\C5EC \C9C0\C624\CF54\B529\C774 \D2B8\B9AC\AC70\B418\C5B4\C57C \D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728803167561342.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4419)
,p_display_sequence=>30
,p_display_value=>unistr('jQuery \C120\D0DD\AE30')
,p_return_value=>'JQUERY_SELECTOR'
,p_help_text=>unistr('<p>\C120\D0DD\AE30\AC00 \B300\C0C1\C73C\B85C \D558\B294 DOM \C694\C18C\C758 \C774\BCA4\D2B8\B97C \AE30\C900\C73C\B85C \C9C0\C624\CF54\B529\C774 \D2B8\B9AC\AC70\B429\B2C8\B2E4. \C785\B825 \D544\B4DC\AC00 \CC38\C870\B420 \ACBD\C6B0 \C694\C18C <em>\BCC0\ACBD</em> \C2DC \C9C0\C624\CF54\B529\C774 \D2B8\B9AC\AC70\B418\ACE0, \B2E8\CD94\AC00 \CC38\C870\B420 \ACBD\C6B0 <em>\B204\B97C \B54C</em> \C9C0\C624\CF54\B529\C774 \D2B8\B9AC\AC70\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1747463542804307.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\C120\D0DD\AE30')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1727549870549765.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JQUERY_SELECTOR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><em>P1_STREET</em> \BC0F <em>P1_ZIP_CODE</em> \D56D\BAA9\C774 \BCC0\ACBD\B420 \B54C \D504\B85C\C138\C2A4\B97C \C2E4\D589\D569\B2C8\B2E4. jQuery \C120\D0DD\AE30:</p>'),
'<pre>',
'#P1_STREET,#P1_ZIP_CODE',
'</pre>'))
,p_help_text=>unistr('<p>\C9C0\C624\CF54\B529 \D2B8\B9AC\AC70 \C694\C18C\B97C \CC38\C870\D558\B294 jQuery \C120\D0DD\AE30\B97C \C81C\ACF5\D569\B2C8\B2E4. \B2E8\CD94\C77C \ACBD\C6B0 <em>\B204\B97C \B54C</em> \C9C0\C624\CF54\B529\C774 \D2B8\B9AC\AC70\B418\ACE0, \B2E4\B978 \C694\C18C\C77C \ACBD\C6B0 <em>\BCC0\ACBD \C2DC</em> \D2B8\B9AC\AC70\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982963519254231.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_name=>'apexgeocoderresponse'
,p_display_name=>unistr('\C9C0\C624\CF54\B529 \C751\B2F5')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982639254254214.4419)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4419)
,p_name=>'apexgeocoderselection'
,p_display_name=>unistr('\ACB0\ACFC \C120\D0DD')
);
end;
/
prompt --application/shared_components/plugins/region_type/smart_filters
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800664597261423.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SMART_FILTERS'
,p_display_name=>unistr('\C2A4\B9C8\D2B8 \D544\D130')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SMART_FILTERS'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>\C5F0\AD00\B41C \C2A4\B9C8\D2B8 \D544\D130\C758 \C18C\C2A4\C5D0 \AE30\BC18\D55C \C601\C5ED\C73C\B85C, \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \B7F0\D0C0\C784 \C2DC \AC80\C0C9 \ACB0\ACFC \C81C\D55C\C5D0 \C0AC\C6A9\B418\B294 \B2E4\C591\D55C \D544\D130\B97C \C81C\ACF5\D569\B2C8\B2E4. </p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816085788971276.4419)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\CD5C\B300 \C81C\C548 \CE69')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('\D45C\C2DC\D560 \CD5C\B300 \C81C\C548 \CE69 \C218\B97C \C9C0\C815\D569\B2C8\B2E4. \C9C0\C815\B418\C9C0 \C54A\C740 \ACBD\C6B0 \AE30\BCF8\AC12 5\AC00 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816321935999387.4419)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\CD94\AC00 \D544\D130 \C81C\C548 \CE69')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\C81C\C548 \CE69\C73C\B85C \D45C\C2DC\B418\C9C0 \C54A\C740 \D544\D130\B97C [\CD94\AC00 \D544\D130] \B4DC\B86D\B2E4\C6B4 \BA54\B274 \B2E8\CD94\B97C \D1B5\D574 \C120\D0DD\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1808803156261456.4419)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C555\CD95 \BC88\D638 \C784\ACC4\AC12')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('\C555\CD95 \BC88\D638 \D615\C2DD\C744 \C0AC\C6A9\D558\C5EC \AC1C\C218\AC00 \D45C\C2DC\B418\B294 \CD5C\C18C \C784\ACC4\AC12\C744 \C81C\ACF5\D569\B2C8\B2E4. \C555\CD95 \BC88\D638 \D615\C2DD\C744 \C0AC\C6A9\D560 \ACBD\C6B0 \AC12 <strong>1,234</strong>\AC00 <strong>1K</strong>\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801137838146661.4419)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\CD1D \D589 \C218 \D45C\C2DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\CD1D \D589 \C218\B97C \D45C\C2DC\D560 \C704\CE58\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801499572149580.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C544\B2C8\C624')
,p_return_value=>'N'
,p_help_text=>unistr('\CD1D \D589 \C218\AC00 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801880772227865.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C608')
,p_return_value=>'Y'
,p_help_text=>unistr('\CD1D \D589 \C218\AC00 \C81C\C548 \CE69 \C544\B798\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1802207279232480.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C120\D0DD\AE30')
,p_return_value=>'E'
,p_help_text=>unistr('\CD1D \D589 \C218(\B808\C774\BE14 \C5C6\C74C)\AC00 \C774 \C120\D0DD\AE30\B85C \C9C0\C815\B41C \C694\C18C \B0B4\C5D0 \D45C\C2DC\B429\B2C8\B2E4. \B530\B77C\C11C \D398\C774\C9C0\C758 \C5B4\B290 \ACF3\C5D0\B4E0 \CD1D \D589 \C218\B97C \BC30\CE58\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802866258261858.4419)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\CD1D \D589 \C218 \B808\C774\BE14')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\CD1D \D589 \C218\C5D0 \C0AC\C6A9\D560 \B808\C774\BE14\C785\B2C8\B2E4. \C5EC\AE30\C5D0 \C81C\ACF5\B41C \B808\C774\BE14\C774 \C5C6\C744 \ACBD\C6B0 APEX\B294 APEX.FS.TOTAL_ROW_COUNT_LABEL \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\B97C \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803111571268834.4419)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\CD1D \D589 \C218 \C120\D0DD\AE30')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('\C2A4\B9C8\D2B8 \D544\D130 \C601\C5ED\C5D0 \CD1D \D589 \C218\AC00 \D45C\C2DC\B418\B294 \D398\C774\C9C0\C5D0\C11C \C694\C18C\C758 \C120\D0DD\AE30\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1812244001261470.4419)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4419)
,p_name=>'facetschange'
,p_display_name=>unistr('\D544\D130 \BCC0\ACBD')
);
end;
/
prompt --application/shared_components/plugins/web_source_type/oci
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1900426248156512.4419)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'OCI'
,p_display_name=>'OCI'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','OCI'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/adfbc
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2200372246708480.4419)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ADFBC'
,p_display_name=>'ADF BC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ADFBC'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/ords
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2302882720656544.4419)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ORDS'
,p_display_name=>'ORDS'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ORDS'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700889063556536.4419)
,p_plugin_id=>wwv_flow_api.id(2302882720656544.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B808\AC70\C2DC ORDS JSON\C744 \BC18\D658\D569\B2C8\B2E4.')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\C774 ORDS REST \C11C\BE44\C2A4\AC00 <em>ORDS \B808\AC70\C2DC JSON \D45C\D604</em>\C73C\B85C \B370\C774\D130\B97C \BC18\D658\D558\B294 \ACBD\C6B0 \C0AC\C6A9\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/item_type/search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2606845974894125.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SEARCH'
,p_display_name=>unistr('\AC80\C0C9')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SEARCH'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:PLACEHOLDER:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \C601\C5ED\C5D0\C11C \D328\C2EF\C758 \BAA9\B85D \D56D\BAA9\C744 \AC80\C0C9\D560 \C218 \C788\B3C4\B85D \D14D\C2A4\D2B8 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4. \D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \C601\C5ED\C740 \C21C\C11C\C5D0 \AD00\ACC4\C5C6\C774 \D56D\C0C1 \D328\C2EF \BAA9\B85D \B9E8 \C704\C5D0 \C788\B294 \D558\B098\C758 \AC80\C0C9 \D328\C2EF\C744 \C9C0\C6D0\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2607008165899744.4419)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\AC80\C0C9 \C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ROW'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607312816901820.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D589 \AC80\C0C9')
,p_return_value=>'ROW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607759273903144.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4419)
,p_display_sequence=>20
,p_display_value=>'Oracle Text'
,p_return_value=>'ORACLE_TEXT'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2608156895911496.4419)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C785\B825 \D544\B4DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FACET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608417903912546.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \C601\C5ED \C0C1\B2E8')
,p_return_value=>'FACET'
,p_help_text=>unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \C601\C5ED \C0C1\B2E8\C758 \D328\C2EF \C704\C5D0 \AC80\C0C9 \D544\B4DC\AC00 \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608887428914009.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C678\BD80 \D398\C774\C9C0 \D56D\BAA9')
,p_return_value=>'PAGE_ITEM'
,p_help_text=>unistr('\C5F0\AD00\B41C \C678\BD80 \D398\C774\C9C0 \D56D\BAA9 \C18D\C131\C744 \C0AC\C6A9\D558\C5EC \D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \C601\C5ED\C5D0 \B300\D55C \AC80\C0C9 \D544\B4DC\B85C \C0AC\C6A9\D560 \D398\C774\C9C0 \D56D\BAA9\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2609288187919863.4419)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C678\BD80 \D398\C774\C9C0 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2608156895911496.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2205297904876322.4419)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\CD95\C18C\B41C \AC80\C0C9 \D544\B4DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_SFILTERS'
,p_is_translatable=>false
,p_help_text=>unistr('\C2A4\B9C8\D2B8 \D544\D130\C758 \AC80\C0C9 \D544\B4DC\AC00 \CC98\C74C\C5D0 \CD95\C18C\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/region_type/map_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2801375174221512.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'MAP_REGION'
,p_display_name=>unistr('\B9F5')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','MAP_REGION'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.spatialMap#MIN#.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl-apex.css',
''))
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(2801502987221529.4419)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4419)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501189800179937.4419)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4419)
,p_name=>'spatialmapchanged'
,p_display_name=>unistr('\B9F5 \BCC0\ACBD\B428')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501913148179938.4419)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4419)
,p_name=>'spatialmapclick'
,p_display_name=>unistr('\B9F5 \B20C\B9BC')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2500840574179919.4419)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4419)
,p_name=>'spatialmapinitialized'
,p_display_name=>unistr('\B9F5 \CD08\AE30\D654\B428')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501516390179938.4419)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4419)
,p_name=>'spatialmapobjectclick'
,p_display_name=>unistr('\B9F5 \AC1D\CCB4 \B20C\B9BC')
);
end;
/
prompt --application/shared_components/plugins/region_type/form
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3128550315022076.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FORM'
,p_display_name=>unistr('\D3FC')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FORM'),'')
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:EDITABLE'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\C5EC\B7EC \B370\C774\D130 \C18C\C2A4\B97C \C9C0\C6D0\D558\B294 \D3FC \C601\C5ED\C785\B2C8\B2E4. \C774 \D3FC \C601\C5ED\C5D0\B294 \B370\C774\D130 \C18C\C2A4(\B85C\CEEC, \C6D0\ACA9 \B610\B294 REST \C11C\BE44\C2A4\C77C \C218 \C788\C74C)\C5D0 \B300\D55C \C815\BCF4\AC00 \D3EC\D568\B418\BA70 \D398\C774\C9C0 \D56D\BAA9\C774 \C9C0\C815\B429\B2C8\B2E4. \AC01 \D56D\BAA9\C740 \D3FC \C601\C5ED \BC0F \D45C\C2DC \C601\C5ED\C5D0 \C9C0\C815\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3128740851022088.4419)
,p_plugin_id=>wwv_flow_api.id(3128550315022076.4419)
,p_name=>'SOURCE_LOCATION'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3129968725049081.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_DML'
,p_display_name=>unistr('\D3FC - \C790\B3D9 \D589 \D504\B85C\C138\C2F1(DML)')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_DML'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D3FC \C601\C5ED \D589\C744 \C0BD\C785, \C5C5\B370\C774\D2B8 \B610\B294 \C0AD\C81C\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3130191485054761.4419)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B300\C0C1 \C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D3FC \C601\C5ED\C5D0 \B300\D55C \B370\C774\D130 \BCC0\ACBD\C0AC\D56D\C744 \C800\C7A5\D558\AE30 \C704\D574 \C218\D589\B418\B294 \D589 \D504\B85C\C138\C2F1 \AE30\C220\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3130418909057477.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C601\C5ED \C18C\C2A4')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0BD\C785, \C5C5\B370\C774\D2B8 \BC0F \C0AD\C81C\B294 \C601\C5ED \C18C\C2A4 SQL \C9C8\C758\B97C \D65C\C6A9\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0 - \C0BD\C785\C774\B098 \C5C5\B370\C774\D2B8\AC00 \AC00\B2A5\D558\C9C0 \C54A\C740 \C5F4\C758 \ACBD\C6B0 <strong>\C9C8\C758 \C804\C6A9</strong>\C744 <code>\C608</code>\B85C \C124\C815\D558\C5EC \CC98\B9AC\C5D0\C11C \C81C\C678\B418\B3C4\B85D \D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131111455059474.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D14C\C774\BE14/\BDF0')
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0BD\C785, \C5C5\B370\C774\D2B8 \BC0F \C0AD\C81C\B294 \C601\C5ED \C18C\C2A4 SQL \C9C8\C758\C5D0\C11C \C815\C758\B41C \AC83\ACFC \B2E4\B978 \D14C\C774\BE14\C774\B098 \BDF0\B97C \D65C\C6A9\D569\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, SQL \C9C8\C758\AC00 \D14C\C774\BE14 \C870\C778 \B610\B294 \C5C5\B370\C774\D2B8 \BD88\AC00\B2A5\D55C \BDF0\C5D0\C11C \B370\C774\D130\B97C \AC80\C0C9\D558\ACE0 DML \D504\B85C\C138\C2F1\C744 \B2E8\C77C \AE30\BCF8 \D14C\C774\BE14 \B610\B294 \C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BDF0\C5D0 \B300\D574 \C218\D589\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0 - \C0BD\C785\C774\B098 \C5C5\B370\C774\D2B8\AC00 \AC00\B2A5\D558\C9C0 \C54A\C740 \C5F4\C758 \ACBD\C6B0 <strong>\C9C8\C758 \C804\C6A9</strong>\C744 <code>\C608</code>\B85C \C124\C815\D558\C5EC \CC98\B9AC\C5D0\C11C \C81C\C678\B418\B3C4\B85D \D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131849869061275.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4419)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \CF54\B4DC')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D504\B85C\C138\C2F1\C774 \C0AC\C6A9\C790\C815\C758 PL/SQL \CF54\B4DC\B97C \AE30\BC18\C73C\B85C \D569\B2C8\B2E4. \C774 \C635\C158\C744 \D1B5\D574 PL/SQL \CF54\B4DC\B97C \C2E4\D589\D568\C73C\B85C\C368 \AE30\BCF8 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \B370\C774\D130 \C870\C791\C744 \AD6C\D604\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C635\C158\C740 \D14C\C774\BE14 API \B610\B294 RESTful \C6F9 \C11C\BE44\C2A4 \D638\CD9C\ACFC \AC19\C740 \B370\C774\D130\BCA0\C774\C2A4 \D328\D0A4\C9C0\B97C \C0AC\C6A9\D558\C5EC \BE44\C988\B2C8\C2A4 \B17C\B9AC\B97C \AD6C\D604\D560 \B54C \D65C\C6A9\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0 - PL/SQL \CF54\B4DC\B294 \C0BD\C785, \C5C5\B370\C774\D2B8 \B610\B294 \C0AD\C81C\B41C \AC01 \D589\C5D0 \B300\D574 \D638\CD9C\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132468628068159.4419)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D14C\C774\BE14 \C18C\C720\C790')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\D14C\C774\BE14 \C18C\C720\C790(\C2A4\D0A4\B9C8) \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132746852071841.4419)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\D14C\C774\BE14 \C774\B984')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(3132468628068159.4419)
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\B294 \D14C\C774\BE14 \B610\B294 \BDF0 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133042217093897.4419)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C0BD\C785/\C5C5\B370\C774\D2B8/\C0AD\C81C\B97C \C704\D55C PL/SQL \CF54\B4DC')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D3FC \C601\C5ED\C5D0\C11C \C870\C791\B41C \B370\C774\D130\C758 \AC01 \D589\C744 \CC98\B9AC\D558\AE30 \C704\D55C PL/SQL \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C5F4 \C774\B984\C744 \BC14\C778\B4DC \BCC0\C218\B85C \C0AC\C6A9\D558\C5EC \C5F4\C758 \AC12\C5D0 \C561\C138\C2A4\D569\B2C8\B2E4. \C2DC\C2A4\D15C \BCC0\C218 <code>APEX$ROW_STATUS</code>\B294 \D589\C758 \C0C1\D0DC\B97C \BC18\D658\D558\BA70 \D589\C774 \C0DD\C131, \C5C5\B370\C774\D2B8 \B610\B294 \C0AD\C81C\B418\C5C8\B294\C9C0 \C5EC\BD80\B97C \D655\C778\D558\B294 \B370 \C0AC\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4(\D655\C778 \BC29\BC95\C740 \C544\B798 \C608 \CC38\C870).</p>'),
unistr('<p><em>\CC38\ACE0:</em> \AE30\BCF8 \D0A4 \C5F4\C774 \D2B8\B9AC\AC70 \B610\B294 PL/SQL \CF54\B4DC\B85C \CC44\C6CC\C9C0\B294 \ACBD\C6B0 \AE30\BCF8 \D0A4 \C5F4\C758 \BC14\C778\B4DC \BCC0\C218\C5D0 \C0C8 \AC12\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4. &PRODUCT_NAME.\C5D0\C11C\B294 \D574\B2F9 \AC12\C744 \C0AC\C6A9\D558\C5EC \C0BD\C785 \B610\B294 \C5C5\B370\C774\D2B8 \D6C4 \D589\C744 \C778\CD9C\D569\B2C8\B2E4.</p>'),
unistr('<p>Oracle\C740 \C7AC\C0AC\C6A9 \BC0F \C720\C9C0 \AD00\B9AC\C131\C774 \C6A9\C774\D558\B3C4\B85D PL/SQL \D328\D0A4\C9C0 \B0B4\C758 \D504\B85C\C2DC\C800 \B610\B294 \D568\C218\B97C \D638\CD9C\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133532996097347.4419)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\C190\C2E4\B41C \C5C5\B370\C774\D2B8 \BC29\C9C0')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C5EC\B7EC \C0AC\C6A9\C790\AC00 \B3D9\C77C\D55C \B370\C774\D130\BCA0\C774\C2A4 \B808\CF54\B4DC\B97C \C5C5\B370\C774\D2B8\D560 \B54C \D504\B85C\C138\C2F1\C5D0\C11C \C5C5\B370\C774\D2B8\AC00 \C190\C2E4\B418\C9C0 \C54A\B3C4\B85D \D574\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p> '),
unistr('<p>\C190\C2E4\B41C \C5C5\B370\C774\D2B8\B294 2\BA85 \C774\C0C1\C758 \C0AC\B78C\C774 \B3D9\C77C\D55C \B370\C774\D130\B97C \C5C5\B370\C774\D2B8\D558\B824\ACE0 \C2DC\B3C4\D558\ACE0 \CD5C\C885 \C5C5\B370\C774\D2B8\AC00 \CCAB\BC88\C9F8 \C0AC\C6A9\C790\C758 \C5C5\B370\C774\D2B8\B97C \ACB9\CCD0\C4F0\BA74\C11C \BCC0\ACBD\C0AC\D56D\C744 \C800\C7A5\D560 \B54C \BC1C\C0DD\D569\B2C8\B2E4. \C774 \C0C1\D669\C774 \BC1C\C0DD\D558\C9C0 \C54A\B3C4\B85D \B9C9\AE30 \C704\D574 \C5C5\B370\C774\D2B8\C5D0\C11C\B294 \B370\C774\D130\BCA0\C774\C2A4\C758 \AE30\C874 \C5F4 \AC12\ACFC \D589\C774 \CC98\C74C\C5D0 \C9C8\C758\B420 \B54C \AC80\C0C9\B41C \AC12\C744 \BE44\AD50\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C608:'),
'  <ol>',
unistr('    <li>\C0AC\C6A9\C790 A\AC00 \C9C1\C6D0(EMP) \B808\CF54\B4DC\B97C \C9C8\C758\D569\B2C8\B2E4.</li>'),
unistr('    <li>\C0AC\C6A9\C790 B\AC00 \B3D9\C77C\D55C \C9C1\C6D0 \B808\CF54\B4DC\B97C \C9C8\C758\D569\B2C8\B2E4.</li>'),
unistr('    <li>\C0AC\C6A9\C790 B\AC00 EMPNO = 7839\C5D0 \B300\D55C \C9C1\C6D0 \C138\BD80\C815\BCF4\B97C \C5C5\B370\C774\D2B8\D558\ACE0 \BCC0\ACBD\C0AC\D56D\C744 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C801\C6A9(\CEE4\BC0B)\D569\B2C8\B2E4.</li>'),
unistr('    <li>\C0AC\C6A9\C790 A\AC00 EMPNO = 7839\C5D0 \B300\D55C \C9C1\C6D0 \C138\BD80\C815\BCF4\B97C \C5C5\B370\C774\D2B8\D558\ACE0 \BCC0\ACBD\C0AC\D56D\C744 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C801\C6A9\D558\B824\ACE0 \C2DC\B3C4 \C911\C785\B2C8\B2E4.</li>'),
'  </ol>',
unistr('\C0AC\C6A9\C790 A\AC00 \B3D9\C77C\D55C \D589\C744 \C131\ACF5\C801\C73C\B85C \C5C5\B370\C774\D2B8\D560 \ACBD\C6B0 \C0AC\C6A9\C790 B\C758 \BCC0\ACBD\C0AC\D56D\C740 \C190\C2E4\B429\B2C8\B2E4.'),
unistr('\C0AC\C6A9\C790 A\AC00 \C9C1\C6D0 \D589\C744 \C800\C7A5\D558\B824\ACE0 \C2DC\B3C4 \C911\C77C \B54C \B370\C774\D130\BCA0\C774\C2A4\C758 \B370\C774\D130\B294 \C0AC\C6A9\C790 A\AC00 \CC98\C74C\C5D0 \C9C8\C758\D588\C744 \B54C\C640 \B2E4\B985\B2C8\B2E4. \C704\C758 \B2E8\ACC4 1\C5D0\C11C \C0AC\C6A9\C790 A\AC00 \CC98\C74C\C5D0 \C9C8\C758\D55C \C5F4 \AC12\C744 \CEA1\CC98\D560 \C218 \C788\C2B5\B2C8\B2E4. \ADF8\B7F0 \B2E4\C74C \C704\C758 \B2E8\ACC4 4\C5D0\C11C \AC12\C744 \B370\C774\D130\BCA0\C774\C2A4\C758 \D604\C7AC \AC12\ACFC \BE44\AD50\D560 \C218 \C788\C2B5\B2C8\B2E4. \B370\C774\D130\BCA0\C774\C2A4 \AC12\C774 \B2E8\ACC4 3\C5D0\C11C \C0AC\C6A9\C790 B\C5D0 \C758\D574 \C5C5\B370\C774\D2B8\B418\C5C8\C73C\BBC0\B85C \C774 \BE44\AD50\B294 \C0AC\C6A9\C790 A\C5D0 \B300\D55C \C624\B958\B97C \BC1C\C0DD\C2DC\D0B5\B2C8\B2E4. \ADF8\B7EC\BA74 \D55C \C0AC\C6A9\C790\AC00 \B2E4\B978 \C0AC\C6A9\C790\C758 \BCC0\ACBD\C0AC\D56D\C744 \B3D9\C77C\D55C \D589\C5D0 \ACB9')
||unistr('\CCD0\C4F0\C9C0 \BABB\D558\AC8C \B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0 - \C190\C2E4\B41C \C5C5\B370\C774\D2B8\AC00 \AC10\C9C0\B418\B294 \BC29\C2DD\C740 <strong>\C190\C2E4\B41C \C5C5\B370\C774\D2B8 \C720\D615</strong>\C5D0 \B300\D55C \C124\C815\C744 \AE30\C900\C73C\B85C \B300\D654\C2DD \ADF8\B9AC\B4DC \C601\C5ED\C5D0 \B300\D55C \C18D\C131\C5D0\C11C \C9C0\C815\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3134090605099409.4419)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\D589 \C7A0\ADF8\AE30')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\D589\C744 \CC98\B9AC\D558\AE30 \C804\C5D0 \C5C5\B370\C774\D2B8\D558\AC70\B098 \C0AD\C81C\D560 \AC01 \D589\C774 \AE30\BCF8 \D14C\C774\BE14\C5D0\C11C \C7A0\AE30\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3134396093101055.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C608')
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C5C5\B370\C774\D2B8\B418\AC70\B098 \C0AD\C81C\B420 \D589\C774 SELECT ... FOR UPDATE\B97C \C0AC\C6A9\D558\C5EC \C7A0\AE40\C73C\B85C\C368 \D2B8\B79C\C7AD\C158\C774 \CEE4\BC0B\B420 \B54C\AE4C\C9C0 \D574\B2F9 \D589\C5D0\C11C \B2E4\B978 \D2B8\B79C\C7AD\C158\C774 \C218\D589\B418\C9C0 \C54A\B3C4\B85D \D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0 - \C7A0\AE08\C744 \C9C0\C6D0\D558\C9C0 \C54A\B294 \C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BDF0\C758 \ACBD\C6B0\C640 \AC19\C774 \C624\B958\AC00 \BC1C\C0DD\D558\BA74 PL/SQL \CF54\B4DC\B97C \D65C\C6A9\D558\C5EC \AD6C\B3D9 \D14C\C774\BE14\C744 \C7A0\AE00 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135017839102248.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C544\B2C8\C624')
,p_return_value=>'N'
,p_help_text=>unistr('\D589\C774 \C7A0\AE30\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135486454103394.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4419)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \CF54\B4DC')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('\C0AC\C6A9\C790\C815\C758 PL/SQL \CF54\B4DC\B97C \C0AC\C6A9\D558\C5EC \D2B8\B79C\C7AD\C158\C774 \CEE4\BC0B\B420 \B54C\AE4C\C9C0 \D589\C744 \C7A0\AE09\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136083157108563.4419)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\D589 \C7A0\ADF8\AE30\B97C \C704\D55C PL/SQL \CF54\B4DC')
,p_attribute_type=>'PLSQL'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3134090605099409.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('\C5C5\B370\C774\D2B8 \BC0F \C0AD\C81C\D560 \B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14 \D589\C744 \C7A0\ADF8\B824\BA74 PL/SQL \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136593347114047.4419)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\C0BD\C785 \D6C4 \AE30\BCF8 \D0A4 \BC18\D658')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D589\C774 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C0BD\C785\B418\BA74 \AE30\BCF8 \D0A4 \C5F4\C774 \D574\B2F9\D558\B294 \C601\C5ED \D56D\BAA9\C5D0 \BC18\D658\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C77C\BC18\C801\C73C\B85C \C774 \C635\C158\C740 \AE30\BCF8 \D0A4 \C5F4\C774 \B370\C774\D130\BCA0\C774\C2A4 \D2B8\B9AC\AC70 \B610\B294 Oracle Database 12 <em>c</em> ID \C5F4\C5D0\C11C \CC44\C6CC\C9C8 \B54C \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0 - RETURNING INTO \C808\C774 \D5C8\C6A9\B418\C9C0 \C54A\B294\B2E4\B294 \C624\B958\AC00 \BC1C\C0DD\D560 \ACBD\C6B0 \C774 \C635\C158\C744 [\C544\B2C8\C624]\B85C \C124\C815\D558\ACE0 \AE30\BCF8 \D0A4 \C5F4\C744 \BBF8\B9AC \CC44\C6CC\C57C \D569\B2C8\B2E4.</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_init
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3136784192133583.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_INIT'
,p_display_name=>unistr('\D3FC - \CD08\AE30\D654')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_INIT'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D3FC \C601\C5ED \D56D\BAA9\C744 \CD08\AE30\D654\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4. \CD08\AE30\D654\B294 \AE30\BCF8 \D0A4 \AC12\C744 \C0AC\C6A9\D558\C5EC \C601\C5ED \C18C\C2A4\C5D0\C11C \B370\C774\D130\B97C \C778\CD9C\D558\B294 \AC83\C774\AC70\B098 \D3FC \C601\C5ED \D56D\BAA9\C758 \B2E8\C21C \CD08\AE30\D654\C77C \C218 \C788\C2B5\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1672950586323461.4419)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B2E4\C74C \AE30\BCF8 \D0A4 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673291445325769.4419)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C774\C804 \AE30\BCF8 \D0A4 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673579797330204.4419)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\D604\C7AC \D589/\CD1D \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/process_type/data_loading
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3205849286768480.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'DATA_LOADING'
,p_display_name=>unistr('\B370\C774\D130 \B85C\B4DC')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','DATA_LOADING'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C9C0\C815\B41C \B370\C774\D130 \B85C\B4DC \C815\C758\B97C \AE30\C900\C73C\B85C \B300\C0C1 \D14C\C774\BE14 \B610\B294 \BAA8\C74C\C5D0 \B370\C774\D130\B97C \B85C\B4DC\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206362206778771.4419)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B370\C774\D130 \B85C\B4DC \C815\C758')
,p_attribute_type=>'DATA LOAD DEFINITION ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\ACF5\C720 \AD6C\C131\C694\C18C\C5D0\C11C <strong>\B370\C774\D130 \B85C\B4DC \C815\C758</strong>\B97C \C120\D0DD\D569\B2C8\B2E4. \B2E4\B978 \C18D\C131 \C911\C5D0\C11C\B3C4 \B370\C774\D130 \B85C\B4DC \C815\C758\B294 \B300\C0C1 \D14C\C774\BE14 \B610\B294 \BAA8\C74C, \B85C\B4DC \BC29\C2DD \BC0F <em>\B370\C774\D130 \D504\B85C\D30C\C77C</em>\C744 \C815\C758\D569\B2C8\B2E4. \BAA8\B4E0 \C5F4 \C774\B984, \C5F4 \B9E4\D551 \BC0F \B370\C774\D130 \C720\D615 \C815\BCF4\B294 \B370\C774\D130 \D504\B85C\D30C\C77C\C5D0 \C800\C7A5\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206568816782155.4419)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C18C\C2A4 \B370\C774\D130 \C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FILE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\B85C\B4DC\D560 \B370\C774\D130\C758 \C18C\C2A4\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3206878557783527.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D30C\C77C \CC3E\C544\BCF4\AE30 \D56D\BAA9')
,p_return_value=>'FILE'
,p_help_text=>unistr('\D604\C7AC \D398\C774\C9C0\C5D0\C11C \D30C\C77C \CC3E\C544\BCF4\AE30 \D56D\BAA9\C758 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4. APEX\B294 \C120\D0DD\D55C \D30C\C77C\C5D0\C11C \B370\C774\D130\B97C \B85C\B4DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207319585784462.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D14D\C2A4\D2B8 \C601\C5ED \D56D\BAA9 \C774\B984')
,p_return_value=>'TEXT'
,p_help_text=>unistr('\B85C\B4DC\D560 \B370\C774\D130\AC00 \D3EC\D568\B41C \D14D\C2A4\D2B8 \C601\C5ED \D56D\BAA9\C758 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207692626786156.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4419)
,p_display_sequence=>30
,p_display_value=>unistr('SQL \C9C8\C758')
,p_return_value=>'SQL_QUERY'
,p_help_text=>unistr('\B85C\B4DC\D560 \B370\C774\D130\AC00 \D3EC\D568\B41C CLOB \B610\B294 BLOB\B97C \BC18\D658\D558\B294 SQL \C9C8\C758\B97C \C81C\ACF5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208086445789769.4419)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\D30C\C77C \CC3E\C544\BCF4\AE30 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FILE'
,p_help_text=>unistr('\B370\C774\D130\B97C \B85C\B4DC\D560 \D30C\C77C \CC3E\C544\BCF4\AE30 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4. \D56D\BAA9\C740 <strong>APEX_APPLICATION_TEMP_FILES</strong>\B97C <strong>\C2A4\D1A0\B9AC\C9C0 \C720\D615</strong>\C73C\B85C \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208411305791534.4419)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\D14D\C2A4\D2B8 \C601\C5ED \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('\B85C\B4DC\D560 \B370\C774\D130\AC00 \D3EC\D568\B41C \D14D\C2A4\D2B8 \C601\C5ED \D56D\BAA9\C758 \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208742752793524.4419)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('SQL \C9C8\C758')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_QUERY'
,p_help_text=>unistr('\D589 \D558\B098\C640 \C5F4 \D558\B098\B97C \BC18\D658\D558\B294 SQL \C9C8\C758\B97C \C81C\ACF5\D569\B2C8\B2E4. \C5EC\AE30\C5D0\B294 \B370\C774\D130\B97C \B85C\B4DC\D560 BLOB \B610\B294 CLOB\AC00 \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3209026300796805.4419)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('XLSX \C2DC\D2B8 \C774\B984\C774 \D3EC\D568\B41C \D398\C774\C9C0 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C5C5\B85C\B4DC\B41C XLSX \D30C\C77C\C5D0\C11C \C0AC\C6A9 \AC00\B2A5\D55C \C6CC\D06C\C2DC\D2B8\B97C \D45C\C2DC\D558\AE30 \C704\D55C \C120\D0DD \BAA9\B85D \B610\B294 \D31D\C5C5 LOV \D56D\BAA9\C5D0\B294 \B2E4\C74C <em>\AC12 \BAA9\B85D SQL \C9C8\C758</em>\AC00 \C0AC\C6A9\B429\B2C8\B2E4(<strong>PX_FILE</strong>\C740 XLSX \D30C\C77C\C744 \C5C5\B85C\B4DC\D558\AE30 \C704\D574 \C0AC\C6A9\B418\B294 \D30C\C77C \CC3E\C544\BCF4\AE30 \D56D\BAA9).</p><p><strong>SHEET_FILE_NAME</strong> \C18D\C131\C740 LOV \BC18\D658 \C5F4\B85C \C0AC\C6A9\B418\C5B4\C57C \D569\B2C8\B2E4.</p>'),
'<pre>',
'select s.sheet_display_name display, ',
'       s.sheet_file_name    return',
'  from apex_application_temp_files f,',
'       table( <strong>apex_data_parser.get_xlsx_worksheets</strong>( p_content => f.blob_content ) ) s',
' where f.name = :PX_FILE',
'</pre>'))
,p_help_text=>unistr('<p>XLSX \D30C\C77C \B85C\B4DC\B97C \C704\D574 \C6CC\D06C\C2DC\D2B8 \C774\B984\C774 \D3EC\D568\B41C \D398\C774\C9C0 \D56D\BAA9\C744 \C81C\ACF5\D569\B2C8\B2E4. \B370\C774\D130\B294 \C9C0\C815\B41C \C6CC\D06C\C2DC\D2B8\C5D0\C11C \B85C\B4DC\B429\B2C8\B2E4. \C81C\ACF5\D558\C9C0 \C54A\C73C\BA74 APEX\AC00 XLSX \D30C\C77C\C758 \CCAB\BC88\C9F8 \C6CC\D06C\C2DC\D2B8\C5D0\C11C \B370\C774\D130\B97C \B85C\B4DC\D569\B2C8\B2E4.</p><p>\C77C\BC18\C801\C73C\B85C <em>select list</em> \D56D\BAA9\C740 \B2E4\C74C\C744 \C704\D574 \C0AC\C6A9\B429\B2C8\B2E4. <em>\AC12 \BAA9\B85D \C9C8\C758</em>\C5D0\C11C \C6CC\D06C\C2DC\D2B8 \D45C\C2DC \BC0F \B0B4\BD80 \C774\B984\C744 \AC80\C0C9\D558\AE30 \C704\D574 <strong>APEX_DATA_PARSER.GET_XLSX_WORKS')
||unistr('HEETS</strong>\B97C \C0AC\C6A9\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1319771677848714.4419)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\CC98\B9AC\B41C \D589 \C218 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('\C5C5\B85C\B4DC\B41C(\BC0F \CC98\B9AC\B41C) \D589\C744 \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4. \AC12\C740 \B370\C774\D130 \B85C\B4DC \D504\B85C\C138\C2A4\AC00 \C644\B8CC\B41C \D6C4 \C0AC\C6A9\D560 \C218 \C788\C73C\BA70, \BA54\C2DC\C9C0\C5D0 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1320047176851343.4419)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\C624\B958 \D589 \C218 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('\C624\B958 \D589\C744 \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4. \AC12\C740 \B370\C774\D130 \B85C\B4DC \D504\B85C\C138\C2A4\AC00 \C644\B8CC\B41C \D6C4 \C0AC\C6A9\D560 \C218 \C788\C73C\BA70, \BA54\C2DC\C9C0\C5D0 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/item_type/range
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4386180889228297.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RANGE'
,p_display_name=>unistr('\BC94\C704')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RANGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT:LOV:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>\AC12 \BAA9\B85D \C120\D0DD\AE30\AC00 \B0B4\C7A5\B41C \D56D\BAA9\C744 \D45C\C2DC\D569\B2C8\B2E4. \D328\C2EF\C740 \B2E8\C77C \B610\B294 \B2E4\C911 \C120\D0DD\ACFC \C218\B3D9 \C785\B825\C744 \C9C0\C6D0\D569\B2C8\B2E4. \B2E8\C77C \C120\D0DD \C9C0\C6D0\C758 \ACBD\C6B0 \C77C\BC18 \C0AC\C6A9\C790\AC00 \B2E8\C77C \AC12\C744 \C120\D0DD\D560 \C218 \C788\B3C4\B85D \B2E4\C911 \AC12\C744 \B77C\B514\C624 \ADF8\B8F9 \C635\C158\C73C\B85C \D45C\C2DC\D569\B2C8\B2E4. \B2E4\C911 \C120\D0DD \C9C0\C6D0\C758 \ACBD\C6B0 \C77C\BC18 \C0AC\C6A9\C790\AC00 \B2E4\C911 \AC12\C744 \C120\D0DD\D560 \C218 \C788\B3C4\B85D \B2E4\C911 \AC12\C744 \CCB4\D06C\BC15\C2A4\B85C \D45C\C2DC\D569\B2C8\B2E4. \C218\B3D9 \C785\B825 \C9C0\C6D0\C758 \ACBD\C6B0 \C77C\BC18 \C0AC\C6A9\C790\AC00 \D544\D130\B9C1\B428 \C601\C5ED\C744 \D544\D130\B9C1\D558\B294 \B370 \C0AC\C6A9\D560 \AC12 \BC94\C704\B97C \C218\B3D9\C73C\B85C \C785\B825\D560 \C218 \C788\B3C4\B85D \D328\C2EF \C544\B798\C5D0 \D14D\C2A4\D2B8')
||unistr(' \D544\B4DC\AC00 \B80C\B354\B9C1\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513920677752961.4419)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C5EC\B7EC \AC1C \C120\D0DD')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\D328\C2EF\C774 \B2E4\C911 \BAA9\B85D \D56D\BAA9 \C120\D0DD\C744 \C9C0\C6D0\D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \B2E4\C911 \C120\D0DD\C774 \C9C0\C6D0\B418\B3C4\B85D \D328\C2EF\C774 \CCB4\D06C\BC15\C2A4\B85C \B80C\B354\B9C1\B429\B2C8\B2E4. <strong>\D574\C81C</strong>\B85C \C124\C815\D560 \ACBD\C6B0 \B2E8\C77C \C120\D0DD\C774 \C9C0\C6D0\B418\B3C4\B85D \D328\C2EF\C774 \B77C\B514\C624 \ADF8\B8F9 \C635\C158\C73C\B85C \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513635447749258.4419)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C218\B3D9 \C785\B825')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\BC94\C704 \D328\C2EF\C774 \C218\B3D9 \C785\B825\C744 \C9C0\C6D0\D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. <strong>\C124\C815</strong>\C73C\B85C \C124\C815\D560 \ACBD\C6B0 \C77C\BC18 \C0AC\C6A9\C790\AC00 \D544\D130\B9C1\B428 \C601\C5ED\C744 \D544\D130\B9C1\D558\B294 \B370 \C0AC\C6A9\D560 \AC12 \BC94\C704\B97C \C218\B3D9\C73C\B85C \C785\B825\D560 \C218 \C788\B3C4\B85D \D328\C2EF \C544\B798\C5D0 \D14D\C2A4\D2B8 \D544\B4DC\AC00 \B80C\B354\B9C1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4386359236228299.4419)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\BC94\C704 \D14D\C2A4\D2B8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\C218\B3D9 \C785\B825 \D14D\C2A4\D2B8 \D544\B4DC \C0AC\C774\C5D0 \D45C\C2DC\B420 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476028199560899.4419)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\D604\C7AC \B808\C774\BE14')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'0% - %1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728478221838569501.4419)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\D604\C7AC \B808\C774\BE14 \C2DC\AC00 \ACE0\AC00')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('%0 \C774\C0C1')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476302635562853.4419)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\D604\C7AC \B808\C774\BE14 \C2DC\AC00 \C800\AC00')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('%0 \C774\D558')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(4390664988228304.4419)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4419)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL \C9C8\C758 \AE30\C900 \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\D45C\C2DC \BC0F \BC18\D658 \AC12\C774 \B3D9\C77C\D55C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: \D45C\C2DC \BC0F \BC18\D658 \AC12 \BAA8\B450 \B3D9\C77C\D55C \C5F4\C744 \C120\D0DD\D55C \ACBD\C6B0 \C5F4 \BCC4\CE6D\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
'</dd>',
unistr('<dt>\BC14\C778\B4DC \BCC0\C218\AC00 \D3EC\D568\B41C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: <code>P3_DEPTNO</code>\AC00 \B3D9\C77C\D55C \D398\C774\C9C0\C5D0 \C788\B294 \C218\C815 \AC00\B2A5\D55C \D398\C774\C9C0 \D56D\BAA9\C778 \ACBD\C6B0 <em>\C885\C18D LOV \C0C1\C704 \D56D\BAA9</em> \C18D\C131\C744 <code>P3_DEPTNO</code>\B85C \C124\C815\D569\B2C8\B2E4.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/display_map
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8870444141116576.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_MAP'
,p_display_name=>unistr('\C9C0\B3C4 \D45C\C2DC')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_MAP'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.displayMap#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('GeoJSON \D3EC\C778\D2B8 \D615\C2DD\C758 \C88C\D45C\B97C \AE30\C900\C73C\B85C \C9C0\B3C4\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9070464796133078.4419)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\BC30\ACBD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C0AC\C6A9\D560 \BC31\ADF8\B77C\C6B4\B4DC \B9F5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9070760381135077.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\AE30\BCF8\AC12')
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AE30\BCF8 \C9C0\B3C4 \BC30\ACBD\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
unistr('<p>\C5B4\B450\C6B4 \D14C\B9C8\C5D0\B294 "OpenStreetMap Bright" \B610\B294 "OpenStreetMap Dark"\B97C \C0AC\C6A9\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071162492136081.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4419)
,p_display_sequence=>20
,p_display_value=>unistr('OpenStreetMap \BC1D\AC8C')
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \BC94\C6A9 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5\C740 \D574\B2F9 \B370\C774\D130\C758 \C790\C138\D55C \C704\CE58 \CEE8\D14D\C2A4\D2B8\B97C \C81C\ACF5\D569\B2C8\B2E4.</p>'),
unistr('<p>"Mapbox Open Styles"\C5D0\C11C \D30C\C0DD\B41C KlokanTech.com & OpenMapTiles \C81C\ACF5\C790\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4. BSD/CC-BY \B77C\C774\C13C\C2A4\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">GitHub\C5D0\C11C \BCF4\AE30</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071529690137784.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4419)
,p_display_sequence=>30
,p_display_value=>unistr('OpenStreetMap \C5B4\B461\AC8C')
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \B2E8\C21C\D654\B41C \C5B4\B450\C6B4 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>"Mapbox Open Styles"\C5D0\C11C \D30C\C0DD\B41C KlokanTech.com & OpenMapTiles \C81C\ACF5\C790\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4. BSD/CC-BY \B77C\C774\C13C\C2A4\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4. Stamen Design\C758 \C9C0\B3C4\C81C\C791\C740 CC0\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">GitHub\C5D0\C11C \BCF4\AE30</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071983425139542.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4419)
,p_display_sequence=>40
,p_display_value=>unistr('OpenStreetMap \C704\CE58')
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \B2E8\C21C\D654\B41C \BC1D\C740 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>"Mapbox Open Styles"\C5D0\C11C \D30C\C0DD\B41C KlokanTech.com & OpenMapTiles \C81C\ACF5\C790\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4. BSD/CC-BY \B77C\C774\C13C\C2A4\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4. Stamen Design\C758 \C9C0\B3C4\C81C\C791\C740 CC0\C5D0 \C758\D574 \C0AC\C6A9\C774 \D5C8\AC00\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">GitHub\C5D0\C11C \BCF4\AE30</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9072395929141067.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4419)
,p_display_sequence=>50
,p_display_value=>'Oracle World Map'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>HERE \B9F5 \B370\C774\D130\B97C \AE30\BC18\C73C\B85C \D558\B294 \BC94\C6A9 \AE30\BCF8 \B9F5\C785\B2C8\B2E4. \C774 \AE30\BCF8 \B9F5 \C2A4\D0C0\C77C\C740 \B370\C774\D130\C758 \C704\CE58 \CEE8\D14D\C2A4\D2B8\B97C \C81C\ACF5\D558\ACE0 \B370\C774\D130 \C2DC\AC01\D654\B97C \AC15\C870\D569\B2C8\B2E4.</p>'),
unistr('<p>\BBF8\AD6D \C624\B77C\D074\C758 \C2A4\D0C0\C77C \C2A4\D0A4\B9C8 \BC0F \C815\C758\C785\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9072916496197068.4419)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D655\B300/\CD95\C18C \B808\BCA8')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'14'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \CE35\C744 \D45C\C2DC\D560 \D655\B300/\CD95\C18C \B808\BCA8\C744 \C9C0\C815\D569\B2C8\B2E4.</p>'),
'<p>',
unistr('\CD5C\C18C\AC12: 1<br>'),
unistr('\CD5C\B300\AC12: 18'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073279785199355.4419)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\D45C\C2DC\C790 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('<p>\D45C\C2DC\C790 \D45C\C2DC \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073555327202501.4419)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\D45C\C2DC\C790 \C0C9\C0C1')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D45C\C2DC\C790 \CC44\C6B0\AE30 \C0C9\C0C1\C744 \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D558\C5EC \C9C0\C815\B429\B2C8\B2E4. 16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B4A4\C5D0 3\AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \BC94\C704\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9075223673219708.4419)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\B3C4\AD6C \C124\BA85')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D45C\C2DC\B41C \D45C\C2DC\C790\C758 \B3C4\AD6C \C124\BA85 \D14D\C2A4\D2B8\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\B3C4\AD6C \C124\BA85 \C18D\C131\C740 HTML \BC0F APEX \D15C\D50C\B9AC\D2B8 \C9C0\C2DC\C5B4\B97C \C9C0\C6D0\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073839532205482.4419)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\C9C0\B3C4 \CF58\D2B8\B864 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C0\B3C4 \CF58\D2B8\B864 \D45C\C2DC \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\D655\B300/\CD95\C18C \BC0F \D68C\C804 \CF58\D2B8\B864\C774 \C9C0\B3C4\C5D0 \CD94\AC00\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9074137581210550.4419)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\B300\D654\C2DD \C9C0\B3C4')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B300\D654\C2DD \C9C0\B3C4\C778\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>"\C544\B2C8\C624"\B85C \C124\C815\D560 \ACBD\C6B0 \C0C1\D638\C791\C6A9\C774 \C5C6\B294 \C815\C801 \C9C0\B3C4\AC00 \C0DD\C131\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11976499186792296.4419)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\B192\C774')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>unistr('\D53D\C140')
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D45C\C2DC\B41C \C9C0\B3C4\C758 \B192\C774(\D53D\C140)\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\C9C0\B3C4\C758 \AE30\BCF8 \B192\C774\B294 \AC00\B85C \C138\B85C \BE44\C728\C774 3:2\C778 \B108\BE44\B97C \AE30\C900\C73C\B85C \ACC4\C0B0\B429\B2C8\B2E4.</p>')))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11251017839289082.4419)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'EXISTS'
,p_display_name=>unistr('Exists SQL \C9C8\C758')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C801\C5B4\B3C4 \D558\B098\C758 \D589\C744 \BC18\D658\D558\BA74 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \D1B5\ACFC\B418\ACE0 \D589\C744 \BC18\D658\D558\C9C0 \C54A\C73C\BA74 \CCB4\ACC4\AC00 \D1B5\ACFC\B418\C9C0 \C54A\B3C4\B85D \D558\B294 \C9C8\C758\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11251530568311696.4419)
,p_plugin_id=>wwv_flow_api.id(11251017839289082.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('SQL \C9C8\C758')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''ADMIN''',
'</pre>'))
,p_help_text=>unistr('\C801\C5B4\B3C4 \D558\B098\C758 \D589\C744 \BC18\D658\D558\BA74 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \D1B5\ACFC\B418\ACE0 \D589\C744 \BC18\D658\D558\C9C0 \C54A\C73C\BA74 \CCB4\ACC4\AC00 \D1B5\ACFC\B418\C9C0 \C54A\B3C4\B85D \D558\B294 \C9C8\C758\C785\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/not_exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252021695318665.4419)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'NOT_EXISTS'
,p_display_name=>unistr('Not Exists SQL \C9C8\C758')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','NOT_EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D589\C744 \BC18\D658\D558\C9C0 \C54A\C73C\BA74 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \D1B5\ACFC\B418\ACE0 \D558\B098 \C774\C0C1\C758 \D589\C744 \BC18\D658\D558\BA74 \CCB4\ACC4\AC00 \D1B5\ACFC\B418\C9C0 \C54A\B3C4\B85D \D558\B294 \C9C8\C758\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252200009321795.4419)
,p_plugin_id=>wwv_flow_api.id(11252021695318665.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('SQL \C9C8\C758')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''GUEST''',
'</pre>'))
,p_help_text=>unistr('\C801\C5B4\B3C4 \D558\B098\C758 \D589\C744 \BC18\D658\D558\BA74 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \C2E4\D328\D558\ACE0 \D589\C744 \BC18\D658\D558\C9C0 \C54A\C73C\BA74 \CCB4\ACC4\AC00 \C131\ACF5\D558\B3C4\B85D \D558\B294 \C9C8\C758\C785\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252712476325388.4419)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NULL'
,p_display_name=>unistr('\D56D\BAA9\C774 \B110\C784')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D56D\BAA9\C758 \AC12\C774 \B110\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252900140331368.4419)
,p_plugin_id=>wwv_flow_api.id(11252712476325388.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \D56D\BAA9\C758 \AC12\C774 \B110\C778 \ACBD\C6B0 \AD8C\D55C \BD80\C5EC\AC00 \C131\ACF5\D558\ACE0, \ADF8\B807\C9C0 \C54A\C740 \ACBD\C6B0 \C2E4\D328\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_not_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11253409836334113.4419)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NOT_NULL'
,p_display_name=>unistr('\D56D\BAA9\C774 \B110\C774 \C544\B2D8')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NOT_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D56D\BAA9\C758 \AC12\C774 \B110\C774 \C544\B2D9\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11253615031335591.4419)
,p_plugin_id=>wwv_flow_api.id(11253409836334113.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \D56D\BAA9\C758 \AC12\C774 \B110\C774 \C544\B2CC \ACBD\C6B0 \AD8C\D55C \BD80\C5EC\AC00 \C131\ACF5\D558\ACE0, \ADF8\B807\C9C0 \C54A\C740 \ACBD\C6B0 \C2E4\D328\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/function_body
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11254106158342546.4419)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'FUNCTION_BODY'
,p_display_name=>unistr('\BD80\C6B8 \BC18\D658 PL/SQL \D568\C218')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','FUNCTION_BODY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('True \B610\B294 False\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218 \BCF8\BB38\C785\B2C8\B2E4. False \AC12\C774 \BC18\D658\B418\BA74 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \D1B5\ACFC\B418\C9C0 \C54A\ACE0 True \AC12\C774 \BC18\D658\B418\BA74 \D1B5\ACFC\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11254314469344909.4419)
,p_plugin_id=>wwv_flow_api.id(11254106158342546.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
,p_attribute_type=>'PLSQL FUNCTION BODY BOOLEAN'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('True \B610\B294 False\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218\C785\B2C8\B2E4. False \AC12\C774 \BC18\D658\B418\BA74 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \D1B5\ACFC\B418\C9C0 \C54A\ACE0, True \AC12\C774 \BC18\D658\B418\BA74 \AD8C\D55C \BD80\C5EC \CCB4\ACC4\AC00 \D1B5\ACFC\B429\B2C8\B2E4'),
'<p/>',
unistr('\C608:'),
'<pre>',
'return to_char(sysdate,''hh24'') between ''08'' and ''17'';',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11255012523353865.4419)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_EQUALS_VALUE'
,p_display_name=>unistr('\D658\ACBD\C124\C815\C774 \AC12\ACFC \B3D9\C77C\D568')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D658\ACBD\C124\C815 \AC12\C774 \D574\B2F9 \AC12\ACFC \AC19\C2B5\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255227067358013.4419)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D658\ACBD\C124\C815 \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \D658\ACBD\C124\C815\C758 \AC12\C774 \C544\B798 \D544\B4DC\C758 \AC12\ACFC \AC19\C744 \ACBD\C6B0 \AD8C\D55C \BD80\C5EC\AC00 \C131\ACF5\D558\ACE0, \AC12\C774 \B2E4\B97C \ACBD\C6B0 \C2E4\D328\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255701918360235.4419)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C704 \B0B4\C6A9\C744 \CC38\C870\D558\C2ED\C2DC\C624.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11257015209373543.4419)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_NOT_EQUALS_VALUE'
,p_display_name=>unistr('\D658\ACBD\C124\C815\C774 \AC12\ACFC \B3D9\C77C\D558\C9C0 \C54A\C74C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D658\ACBD\C124\C815 \AC12\C774 \D574\B2F9 \AC12\ACFC \AC19\C9C0 \C54A\C2B5\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257220750375150.4419)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D658\ACBD\C124\C815 \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \D658\ACBD\C124\C815\C758 \AC12\C774 \C544\B798 \D544\B4DC\C758 \AC12\ACFC \B2E4\B97C \ACBD\C6B0 \AD8C\D55C \BD80\C5EC\AC00 \C131\ACF5\D558\ACE0, \AC12\C774 \AC19\C744 \ACBD\C6B0 \C2E4\D328\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257725944376646.4419)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C704 \B0B4\C6A9\C744 \CC38\C870\D558\C2ED\C2DC\C624.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11258208760381085.4419)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_EQUALS_VALUE'
,p_display_name=>unistr('\D56D\BAA9\C774 \AC12\ACFC \B3D9\C77C\D568')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D56D\BAA9 \AC12\C774 \D574\B2F9 \AC12\ACFC \AC19\C2B5\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258417764383723.4419)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \D56D\BAA9\C758 \AC12\C774 \C544\B798 \D544\B4DC\C758 \AC12\ACFC \AC19\C744 \ACBD\C6B0 \AD8C\D55C \BD80\C5EC\AC00 \C131\ACF5\D558\ACE0, \AC12\C774 \B2E4\B97C \ACBD\C6B0 \C2E4\D328\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258925383385933.4419)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C704 \B0B4\C6A9\C744 \CC38\C870\D558\C2ED\C2DC\C624.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11259414086392075.4419)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_NOT_EQUALS_VALUE'
,p_display_name=>unistr('\D56D\BAA9\C774 \AC12\ACFC \B3D9\C77C\D558\C9C0 \C54A\C74C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D56D\BAA9 \AC12\C774 \D574\B2F9 \AC12\ACFC \AC19\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11259621358394213.4419)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \D56D\BAA9\C758 \AC12\C774 \C544\B798 \D544\B4DC\C758 \AC12\ACFC \B2E4\B97C \ACBD\C6B0 \AD8C\D55C \BD80\C5EC\AC00 \C131\ACF5\D558\ACE0, \AC12\C774 \AC19\C744 \ACBD\C6B0 \C2E4\D328\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11260124128395028.4419)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C704 \B0B4\C6A9\C744 \CC38\C870\D558\C2ED\C2DC\C624.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/geocoding_trigger
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12476487024106188.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'GEOCODING_TRIGGER'
,p_display_name=>unistr('\C9C0\C624\CF54\B529 \D2B8\B9AC\AC70')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','GEOCODING_TRIGGER'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p><em>\C9C0\C624\CF54\B529 \C8FC\C18C</em> \D56D\BAA9\C758 \C9C0\C624\CF54\B529 \AC80\C0C9\C744 \C218\B3D9\C73C\B85C \D2B8\B9AC\AC70\D569\B2C8\B2E4.</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(15242808636946504.4419)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SOCIAL'
,p_display_name=>unistr('\C18C\C15C \C0AC\C778\C778')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SOCIAL'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Google, Facebook, \C77C\BC18 OpenID Connect \BC0F \C77C\BC18 OAuth2 ID \C81C\ACF5\C790\B97C \D1B5\D55C \C778\C99D\C744 \C9C0\C6D0\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15243730328988135.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C778\C99D\C11C \C800\C7A5\C18C')
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C778\C99D \C81C\ACF5\C790\C5D0 \B300\D55C \D074\B77C\C774\C5B8\D2B8 ID \BC0F \C554\D638\B97C \D3EC\D568\D558\B294 \C778\C99D\C11C \C800\C7A5\C18C\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249686303031715.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C778\C99D \C81C\ACF5\C790')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18383539811983244.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4419)
,p_display_sequence=>10
,p_display_value=>unistr('OpenID Connect \C81C\ACF5\C790')
,p_return_value=>'OPENID_CONNECT'
,p_help_text=>unistr('OpenID Connect \AE30\BC18 \C778\C99D \C81C\ACF5\C790\B97C \C0AC\C6A9\D569\B2C8\B2E4. \C544\B798\C5D0 \C81C\ACF5\C790\C758 OpenID \AC80\C0C9 URL\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18384865200013886.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C77C\BC18 OAuth2 \C81C\ACF5\C790')
,p_return_value=>'OAUTH2'
,p_help_text=>unistr('OAuth2 \C778\C99D \C81C\ACF5\C790\B97C \C0AC\C6A9\D569\B2C8\B2E4. \C544\B798\C5D0 \AD8C\D55C \BD80\C5EC, \D1A0\D070 \BC0F \C0AC\C6A9\C790 \C815\BCF4 \B05D\C810\C5D0 \B300\D55C URL\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650405105549494.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4419)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
,p_help_text=>unistr('Google \B85C\ADF8\C778\C5D0 \B300\D574 \BBF8\B9AC \C815\C758\B41C \C124\C815\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650810905551172.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4419)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
,p_help_text=>unistr('Facebook \B85C\ADF8\C778\C5D0 \B300\D574 \BBF8\B9AC \C815\C758\B41C \C124\C815\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249997224035381.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\AC80\C0C9 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>unistr('OpenID Connect \C81C\ACF5\C790\C758 \AC80\C0C9 URL\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385430957035861.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\AD8C\D55C \BD80\C5EC \B05D\C810 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('OAuth2 \C81C\ACF5\C790\C758 \AD8C\D55C \BD80\C5EC \B05D\C810 URL\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385701636038222.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\D1A0\D070 \B05D\C810 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('OAuth2 \C81C\ACF5\C790\C758 \D1A0\D070 \B05D\C810 URL\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386081451040404.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\C0AC\C6A9\C790 \C815\BCF4 \B05D\C810 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('OAuth2 \C81C\ACF5\C790\C758 \C0AC\C6A9\C790 \C815\BCF4 \B05D\C810 URL\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386627580109078.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\BC94\C704')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_examples=>'email,profile'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\B85C\ADF8\C778\D55C \C0AC\C6A9\C790\B97C \C694\CCAD\D558\B294 \B370 \D544\C694\D55C \CF64\B9C8\B85C \AD6C\BD84\B41C \AD8C\D55C \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\D5C8\C6A9\B418\B294 \AC12\C740 \C778\C99D \C81C\ACF5\C790\C5D0 \B530\B77C \B2E4\B985\B2C8\B2E4.'),
unistr('OpenID Connect \BC0F Google\C758 \ACBD\C6B0 Application Express\B294 \C790\B3D9\C73C\B85C "openid" \BC94\C704\B97C \CD94\AC00\D569\B2C8\B2E4.'),
unistr('\C778\C99D \C81C\ACF5\C790\B294 \D574\B2F9 \AD8C\D55C\C744 \AE30\BC18\C73C\B85C \C0AC\C6A9\C790 \C18D\C131\C744 \BC18\D658\D569\B2C8\B2E4.'),
unistr('\C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C5D0 \C18D\C131\C744 \B9E4\D551\D558\AC70\B098, \C0AC\D6C4 \C778\C99D \D504\B85C\C2DC\C800\B97C \D1B5\D574 APEX_JSON.GET_% \D568\C218\B97C \C0AC\C6A9\D558\C5EC \CC98\B9AC\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'</p><p>',
unistr('OpenID Connect \BC94\C704 \BC0F \C18D\C131(\D074\B808\C784\C774\B77C\ACE0\B3C4 \D568)\C740 \C5EC\AE30\C5D0 \B098\C5F4\B429\B2C8\B2E4. https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(226010579134296999.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\C778\C99D URI \B9E4\AC1C\BCC0\C218')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'prompt=consent'
,p_help_text=>unistr('\C778\C99D URI\C5D0 \B300\D55C \B9E4\AC1C\BCC0\C218(\C120\D0DD\C0AC\D56D)\B97C \C785\B825\D569\B2C8\B2E4. \C9C0\C6D0\B418\B294 \B9E4\AC1C\BCC0\C218\B294 \C778\C99D \C81C\ACF5\C790\C758 \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386934074146656.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\C0AC\C6A9\C790 \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'#sub# (#APEX_AUTH_NAME#)'
,p_is_translatable=>false
,p_examples=>'#sub# (#APEX_AUTH_NAME#)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\C0AC\C6A9\C790 \C774\B984\C744 \D3EC\D568\D558\B294 \C18D\C131\C744 \C785\B825\D558\AC70\B098, "#"\C73C\B85C \B458\B7EC\C2F8\C778 \D558\B098 \C774\C0C1\C758 \C18D\C131\C774 \CE58\D658\B418\B294 \C790\C720 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('#APEX_AUTH_NAME#\C73C\B85C \C778\C99D \CCB4\ACC4\C758 \C774\B984\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, "#email# (#APEX_AUTH_NAME#)"\C744 \C2E4\D589\D558\BA74 \C804\C790\BA54\C77C \C8FC\C18C \B4A4\C5D0 " ("\AC00 \C624\ACE0 \ADF8 \B4A4\C5D0 \C778\C99D \CCB4\ACC4 \C774\B984\ACFC ")"\B85C \AD6C\C131\B41C \C0AC\C6A9\C790 \C774\B984\C774 \D45C\C2DC\B429\B2C8\B2E4. \C608: "jane.doe@example.com (Google)".'),
'</p><p>',
unistr('\C9C0\C6D0\B418\B294 \C18D\C131\C740 \C778\C99D \C81C\ACF5\C790\C758 \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.'),
unistr('\D544\C694\D55C \BC94\C704\B97C \C124\C815\D574\C57C \D569\B2C8\B2E4. \ADF8\B807\C9C0 \C54A\C73C\BA74 \C778\C99D \C81C\ACF5\C790\AC00 \BAA8\B4E0 \C18D\C131\C744 \BCF4\B0B4\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('OpenID Connect \BC94\C704 \BC0F \C18D\C131(\D074\B808\C784\C774\B77C\ACE0\B3C4 \D568)\C740 \C5EC\AE30\C5D0 \B098\C5F4\B429\B2C8\B2E4. https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18652865850779852.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\CD94\AC00 \C0AC\C6A9\C790 \C18D\C131')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'link,picture,email'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\CF64\B9C8\B85C \AD6C\BD84\B41C \CD94\AC00 \C0AC\C6A9\C790 \B370\C774\D130 \C18D\C131 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.'),
'</p><p>',
unistr('\C9C0\C6D0\B418\B294 \C18D\C131\C740 \C778\C99D \C81C\ACF5\C790\C758 \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.'),
unistr('\D544\C694\D55C \BC94\C704\B97C \C124\C815\D574\C57C \D569\B2C8\B2E4. \ADF8\B807\C9C0 \C54A\C73C\BA74 \C778\C99D \C81C\ACF5\C790\AC00 \BAA8\B4E0 \C18D\C131\C744 \BCF4\B0B4\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('OpenID Connect \BC94\C704 \BC0F \C18D\C131(\D074\B808\C784\C774\B77C\ACE0\B3C4 \D568)\C740 \C5EC\AE30\C5D0 \B098\C5F4\B429\B2C8\B2E4. https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(118623542514218726.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>95
,p_prompt=>unistr('\C0AC\C6A9\C790 \C774\B984\C744 \B300\BB38\C790\B85C \BCC0\D658')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\C0AC\C6A9\C790 \C774\B984\C758 \C18D\C131\AC12\C744 \B300\BB38\C790\B85C \BCC0\D658\D574\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \AD6C\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(545768003551719989.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>unistr('\D1A0\D070 \C778\C99D \BC29\C2DD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C778\C99D\C11C\C758 \D074\B77C\C774\C5B8\D2B8 ID\C640 \D074\B77C\C774\C5B8\D2B8 \C554\D638\B97C \C11C\BC84\C5D0 \C804\B2EC\D574\C57C \D560 \BC29\BC95\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768719525723870.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\AE30\BCF8 \C778\C99D')
,p_return_value=>'BASIC'
,p_help_text=>unistr('\AE30\BCF8 \C778\C99D \D5E4\B354\B97C \D1B5\D574 \D074\B77C\C774\C5B8\D2B8 ID\C640 \D074\B77C\C774\C5B8\D2B8 \C554\D638\B97C \C804\C1A1\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768336282722977.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4419)
,p_display_sequence=>22
,p_display_value=>unistr('\BCF8\BB38\C5D0 \AE30\BCF8 \C778\C99D \BC0F \D074\B77C\C774\C5B8\D2B8 ID \D3EC\D568')
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>unistr('\AE30\BCF8 \C778\C99D \D5E4\B354\B97C \D1B5\D574 \D074\B77C\C774\C5B8\D2B8 ID\C640 \D074\B77C\C774\C5B8\D2B8 \C554\D638\B97C \C804\C1A1\D558\B418, \C694\CCAD \BCF8\BB38\C5D0\B3C4 \D074\B77C\C774\C5B8\D2B8 ID\B97C \C804\C1A1\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545769143256728532.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\BCF8\BB38\C5D0 \D074\B77C\C774\C5B8\D2B8 ID \BC0F \D074\B77C\C774\C5B8\D2B8 \C554\D638 \D3EC\D568')
,p_return_value=>'BODY'
,p_help_text=>unistr('\C694\CCAD \BCF8\BB38\C744 \D1B5\D574 \D074\B77C\C774\C5B8\D2B8 ID\C640 \D074\B77C\C774\C5B8\D2B8 \C554\D638\B97C \C804\C1A1\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(829911196403661792.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\BCF8\BB38\C758 \D074\B77C\C774\C5B8\D2B8 ID')
,p_return_value=>'CLID'
,p_help_text=>unistr('\C694\CCAD \BCF8\BB38\C758 \D074\B77C\C774\C5B8\D2B8 ID\B9CC \C804\C1A1\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328064759558360148.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>120
,p_prompt=>unistr('\C18D\C131 \D655\C778')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\C0AC\C6A9\C73C\B85C \C124\C815\B418\C5C8\C73C\BA74 &PRODUCT_NAME.\C774(\AC00) "#name#_verified" \C18D\C131\C744 \CC3E\C2B5\B2C8\B2E4(\C608: "email" \C18D\C131\C5D0 \B300\D55C "email_verified").'),
unistr('OpenID\B294 ID \C81C\ACF5\C790\AC00 \D655\C778\B418\C9C0 \C54A\C740 "email" \BC0F "phone_number" \C18D\C131\C5D0 \B300\D574 <code>"#name#_verified":false</code>\B97C \C804\C1A1\D558\B3C4\B85D \C815\C758\D569\B2C8\B2E4.'),
unistr('&PRODUCT_NAME.\C740(\B294) \C774\B7EC\D55C \D655\C778\B418\C9C0 \C54A\C740 \C18D\C131\C744 \BB34\C2DC\D569\B2C8\B2E4.'),
unistr('\ADF8 \ACB0\ACFC "#name#"\C774 \C0AC\C6A9\C790 \C774\B984 \C18D\C131\C774\BA74 \C778\C99D\C774 \C2E4\D328\D569\B2C8\B2E4.'),
'</p><p>',
unistr('ID \C81C\ACF5\C790\B97C \D1B5\D574 \ACF5\ACA9\C790\AC00 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C778\C99D\C744 \C704\D574 \C0AC\C6A9\B418\B294 \D655\C778\B418\C9C0 \C54A\C740 \B370\C774\D130\B97C \C785\B825\D560 \C218 \C788\C73C\BA74,'),
unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \B2E4\B978 \C0AC\C6A9\C790\B97C \AC00\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('"\C18D\C131 \D655\C778" \AC80\C0AC\B294 \C774\B97C \BC29\C9C0\D569\B2C8\B2E4.'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388762589390412438.4419)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>110
,p_prompt=>unistr('\CD94\AC00 \C0AC\C6A9\C790 \C18D\C131 \B9E4\D551 \B300\C0C1')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'G_EMAIL,G_PROFILE,G_PICTURE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<em>\CD94\AC00 \C0AC\C6A9\C790 \C18D\C131</em>\C774 \B9E4\D551\B420 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C73C\B85C \C81C\ACF5\D569\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \B2E4\C74C\ACFC \AC19\C774 \C124\C815\D560 \ACBD\C6B0'),
'<ul>',
unistr('<li>\CD94\AC00 \C0AC\C6A9\C790 \C18D\C131: email,profile,picture</li>'),
unistr('<li>\CD94\AC00 \C0AC\C6A9\C790 \C18D\C131 \B9E4\D551 \B300\C0C1: G_EMAIL,G_PROFILE,G_PICTURE</li>'),
'</ul>',
unistr('APEX\B294 \D574\B2F9 \D56D\BAA9\C5D0 \B300\D55C \C18D\C131\AC12\C744 \C138\C158 \C0C1\D0DC\C5D0 \C790\B3D9\C73C\B85C \C800\C7A5\D569\B2C8\B2E4.')))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_list_view
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(37314610637444633.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_LIST_VIEW'
,p_display_name=>unistr('\BAA9\B85D \BCF4\AE30')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_LIST_VIEW'),'')
,p_api_version=>1
,p_ajax_function=>'x'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\AC04\D3B8\D55C \BAA9\B85D \D0D0\C0C9\C73C\B85C \B370\C774\D130\B97C \D45C\C2DC\D569\B2C8\B2E4. \B610\D55C \C5EC\B7EC \AE30\B2A5\C744 \C0AC\C6A9\D574\C11C \BAA9\B85D \BCF4\AE30\B97C \D5A5\C0C1\C2DC\D0AC \C218 \C788\C2B5\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37319921504457296.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\AE30\B2A5')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C774 \BAA9\B85D \BCF4\AE30\C5D0 \B300\D574 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \AE30\B2A5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507022952387983.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_display_sequence=>5
,p_display_value=>unistr('\ACE0\AE09 \D615\C2DD \C9C0\C815')
,p_return_value=>'ADVANCED_FORMATTING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342207873614875.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C774\BBF8\C9C0 \D45C\C2DC')
,p_return_value=>'IMAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341804410613872.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\BAA9\B85D \AD6C\BD84\C120 \D45C\C2DC')
,p_return_value=>'DIVIDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24343018955618095.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_display_sequence=>50
,p_display_value=>unistr('\BD84\D560 \B2E8\CD94\AC00 \C788\C74C')
,p_return_value=>'SPLIT_BUTTON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341429213611599.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_display_sequence=>55
,p_display_value=>unistr('\AC80\C0C9 \C0AC\C6A9')
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342612721616279.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_display_sequence=>65
,p_display_value=>unistr('\C911\CCA9\B41C \BAA9\B85D \BCF4\AE30')
,p_return_value=>'NESTED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507428146389462.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_display_sequence=>70
,p_display_value=>unistr('\C0BD\C785 \BAA9\B85D')
,p_return_value=>'INSET'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37321616440465218.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D14D\C2A4\D2B8 \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('\BAA9\B85D \BCF4\AE30 \D56D\BAA9\C5D0 \B300\D55C \AE30\BCF8 \CF58\D150\CE20\B97C \D3EC\D568\D558\B294 \B370\C774\D130\BCA0\C774\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18004831401462408.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\BAA9\B85D \C18D\C131')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\D074\B77C\C774\C5B8\D2B8\AC00 \BAA9\B85D \D56D\BAA9 \D14D\C2A4\D2B8\B97C \AE30\BC18\C73C\B85C \AD6C\BD84\C120 \C0DD\C131</dt>'),
'<dd><pre>',
'data-autodividers=true',
'</pre></dd>',
unistr('<dt>\C544\C774\CF58 \BCC0\ACBD</dt>'),
'<dd><pre>',
'data-icon="fa-gear"',
'</pre></dd>',
unistr('<dt>\BD84\D560 \B2E8\CD94 \C544\C774\CF58 \BCC0\ACBD</dt>'),
'<dd><pre>',
'data-split-icon="fa-gear"',
'</pre></dd>',
'</dl>'))
,p_help_text=>unistr('\BAA9\B85D \C694\C18C\C5D0 \B300\D574 \C124\C815\D560 \CD94\AC00 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4. \BAA9\B85D \BDF0\C5D0 \C601\D5A5\C744 \B07C\CE58\B294 \C77C\BD80 \C18D\C131\C740 \C608\B97C \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18003624513413103.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\BAA9\B85D \D56D\BAA9 \C18D\C131')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C0AD\C81C\D560 \BAA9\B85D \D56D\BAA9 \B9C1\D06C \C544\C774\CF58\C744 \C124\C815\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'data-icon="delete"',
'</pre></dd>',
'</dl>'))
,p_help_text=>unistr('\BAA9\B85D \D56D\BAA9 \C694\C18C\C5D0 \B300\D574 \C124\C815\D560 \CD94\AC00 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4. \BAA9\B85D \BDF0\C5D0 \C601\D5A5\C744 \B07C\CE58\B294 \C77C\BD80 \C18D\C131\C740 \C608\B97C \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322140682472248.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\D14D\C2A4\D2B8 \D615\C2DD \C9C0\C815')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C774\B984 \D45C\C2DC \BC0F \C544\B798\C5D0 \C9C1\C6D0\C758 \ACE0\C6A9 \B0A0\C9DC \D45C\C2DC</dt>'),
'<dd><pre>',
'&lt;h3&gt;&amp;ENAME.&lt;/h3&gt;',
'&lt;p&gt;Hire date: &amp;HIREDATE.&lt;/p&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BAA9\B85D \BDF0 \D56D\BAA9\C758 \AE30\BCF8 \CF58\D150\CE20\B97C \B80C\B354\B9C1\D558\AE30 \C704\D55C HTML \B9C8\D06C\C5C5\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\BAA9\B85D \BDF0 SQL \BB38\C758 \C5F4 \AC12\C744 \CC38\C870\D558\B824\BA74 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323637481490256.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\BCF4\CDA9 \C815\BCF4 \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('\BAA9\B85D \BCF4\AE30 \D56D\BAA9\C5D0 \B300\D55C \BCF4\CDA9 \C815\BCF4\B97C \D3EC\D568\D558\B294 \B370\C774\D130\BCA0\C774\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37512329447408820.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\BCF4\CDA9 \C815\BCF4 \D615\C2DD \C9C0\C815')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\AE09\C5EC\B97C \AD75\AC8C \D45C\C2DC</dt>'),
'<dd><pre>',
'USD &lt;strong&gt;&amp;SAL.&lt;/strong&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BAA9\B85D \BDF0 \D56D\BAA9\C758 \BCF4\CDA9 \C815\BCF4\B97C \B80C\B354\B9C1\D558\AE30 \C704\D55C HTML \B9C8\D06C\C5C5\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\BAA9\B85D \BDF0 SQL \BB38\C758 \C5F4 \AC12\C744 \CC38\C870\D558\B824\BA74 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323130554488257.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\CE74\C6B4\D130 \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_is_translatable=>false
,p_help_text=>unistr('\CE74\C6B4\D2B8 \BC84\BE14\C5D0 \D45C\C2DC\D560 \AC12\C774 \D3EC\D568\B41C \B370\C774\D130\BCA0\C774\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42537525650337692.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\C774\BBF8\C9C0 \C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IMAGE_BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D45C\C2DC\B418\B294 \C774\BBF8\C9C0 \C885\B958 \BC0F \C77D\AE30 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4. \D45C\C2DC\B418\B294 \C774\BBF8\C9C0\B294 16x16 \D06C\AE30\C758 \C544\C774\CF58 \B610\B294 80x80 \D06C\AE30\C758 \C791\C740 \ADF8\B9BC\C77C \C218 \C788\C2B5\B2C8\B2E4. \C774\BBF8\C9C0 \C18C\C2A4\B294 \B370\C774\D130\BCA0\C774\C2A4 BLOB \C5F4 \B610\B294 \C815\C801 \D30C\C77C\C5D0 \B300\D55C URL\C77C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42538712275343327.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4419)
,p_display_sequence=>20
,p_display_value=>unistr('BLOB\C5D0 \C800\C7A5\B41C \C544\C774\CF58')
,p_return_value=>'ICON_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539233400349414.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4419)
,p_display_sequence=>30
,p_display_value=>unistr('URL\C5D0\C11C \C77D\C740 \C544\C774\CF58')
,p_return_value=>'ICON_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539638940351053.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4419)
,p_display_sequence=>40
,p_display_value=>unistr('BLOB\C5D0 \C800\C7A5\B41C \C774\BBF8\C9C0')
,p_return_value=>'IMAGE_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42540042403352086.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4419)
,p_display_sequence=>50
,p_display_value=>unistr('URL\C5D0\C11C \C77D\C740 \C774\BBF8\C9C0')
,p_return_value=>'IMAGE_URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324142675491770.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\C774\BBF8\C9C0 BLOB \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('\C774\BBF8\C9C0\B97C \D3EC\D568\D558\B294 \B370\C774\D130 \C720\D615 BLOB\C758 \B370\C774\D130\BCA0\C774\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42541812668371813.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\C774\BBF8\C9C0 \AE30\BCF8 \D0A4 \C5F4 1')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S:ROWID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('\C774\BBF8\C9C0\B97C \C870\D68C\D558\B294 \B370 \C0AC\C6A9\B418\B294 \AE30\BCF8 \D0A4 \C5F4 \B610\B294 \ACE0\C720 \B370\C774\D130\BCA0\C774\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24272827642729595.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\C774\BBF8\C9C0 \AE30\BCF8 \D0A4 \C5F4 2')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42541812668371813.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\C774\BBF8\C9C0\B97C \C870\D68C\D558\B294 \B370 \C0AC\C6A9\B418\B294 \B450\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4 \B610\B294 \ACE0\C720 \B370\C774\D130\BCA0\C774\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24218503552483082.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\C774\BBF8\C9C0 URL \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_URL,IMAGE_URL'
,p_help_text=>unistr('\C544\C774\CF58/\C774\BBF8\C9C0\C5D0 \B300\D55C URL\C744 \D3EC\D568\D558\B294 \B370\C774\D130\BCA0\C774\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324722720495516.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\BAA9\B85D \AD6C\BD84\C120 \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIVIDER'
,p_help_text=>unistr('\AD6C\BD84\C120\C744 \D3EC\D568\D558\B294 \B370\C774\D130\BCA0\C774\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \AD6C\BD84\C120 \AC12\C774 \BCC0\ACBD\B420 \B54C\B9C8\B2E4 \BAA9\B85D \BCF4\AE30 \D56D\BAA9 \C0AC\C774\C5D0 \C0C8\B85C\C6B4 \AD6C\BD84\C120\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24027626694091285.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\BAA9\B85D \AD6C\BD84\C120 \D615\C2DD \C9C0\C815')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\BC30\C9C0\B85C \BD80\C11C \C774\B984 \BC0F \C0AC\C6D0 \C218 \D45C\C2DC</dt>'),
'<dd><pre>',
'&amp;DNAME. &lt;span class="t-MediaList-badge"&gt;&amp;EMP_COUNT.&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BAA9\B85D \BDF0\C758 \AD6C\BD84\C120\C744 \B80C\B354\B9C1\D558\AE30 \C704\D55C HTML \B9C8\D06C\C5C5\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\BAA9\B85D \BDF0 SQL \BB38\C758 \C5F4 \AC12\C744 \CC38\C870\D558\B824\BA74 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322614971483782.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_prompt=>unistr('\B9C1\D06C \B300\C0C1')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\C0AC\C6A9\C790\AC00 \BAA9\B85D \D56D\BAA9\C744 \B204\B97C \B54C \D638\CD9C\D560 \B300\C0C1 \D398\C774\C9C0\B97C \C785\B825\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325839689500405.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>170
,p_prompt=>unistr('\BD84\D560 \B2E8\CD94 \B300\C0C1')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SPLIT_BUTTON'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\C0AC\C6A9\C790\AC00 \BAA9\B85D \D56D\BAA9\C744 \B204\B97C \B54C \D638\CD9C\D560 \B300\C0C1 \D398\C774\C9C0\B97C \C785\B825\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24021612683850679.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_prompt=>unistr('\AC80\C0C9 \C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SERVER_EXACT_IGNORE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AC80\C0C9 \C218\D589 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\D074\B77C\C774\C5B8\D2B8\CE21 \AC80\C0C9\C740 \C0AC\C6A9\C790\AC00 \C785\B825\C744 \C2DC\C791\D558\B294 \C989\C2DC \C218\D589\B429\B2C8\B2E4. \BAA8\B4E0 \C11C\BC84 \AE30\BC18 \AC80\C0C9\C758 \ACBD\C6B0 \C0AC\C6A9\C790\AC00 Enter\B97C \B20C\B7EC\C57C \AC80\C0C9 \ACB0\ACFC\AC00 \D45C\C2DC\B429\B2C8\B2E4. \C11C\BC84 \AE30\BC18 \AC80\C0C9\C5D0\C11C\B9CC \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D574 \C815\C758\B41C \BB38\C790 \AC12 \BE44\AD50 \C804\C5ED\D654 \C18D\C131\C774 \ACE0\B824\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022326881854766.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D074\B77C\C774\C5B8\D2B8\CE21')
,p_return_value=>'CLIENT'
,p_help_text=>unistr('\BE0C\B77C\C6B0\C800 \AE30\BC18 \AC80\C0C9\C744 \C218\D589\D558\B824\BA74 \BAA8\B4E0 \BAA9\B85D \BCF4\AE30 \D56D\BAA9\C774 \BE0C\B77C\C6B0\C800\C5D0 \B85C\B4DC\B418\C5B4 \C788\C5B4\C57C \D569\B2C8\B2E4(\C774 \ACBD\C6B0 "\C778\CD9C\B41C \D589 \C218" \C18D\C131\C740 \BB34\C2DC\B428). \D398\C774\C9C0 \B85C\B4DC\AC00 \BD88\D544\C694\D558\AC8C \C624\B798 \AC78\B9AC\C9C0 \C54A\B3C4\B85D \D558\B824\BA74 \BAA9\B85D \D56D\BAA9 \C218\AC00 \C801\C740 \ACBD\C6B0\C5D0\B9CC \C774 \AC80\C0C9 \C635\C158\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022823811882269.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C11C\BC84: \C815\D655 \BC0F \B300\C18C\BB38\C790 \AD6C\BD84')
,p_return_value=>'SERVER_EXACT_CASE'
,p_help_text=>unistr('\AC80\C0C9 \C2DC LIKE [\AC80\C0C9 \AC12]%\B97C \C0AC\C6A9\D574\C11C \ACB0\ACFC\B97C \C9C8\C758\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023232469884808.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\C11C\BC84: \C815\D655 \BC0F \B300\C18C\BB38\C790 \BB34\C2DC')
,p_return_value=>'SERVER_EXACT_IGNORE'
,p_help_text=>unistr('\AC80\C0C9 \C2DC LIKE UPPER([\AC80\C0C9 \AC12])%\B97C \C0AC\C6A9\D574\C11C \ACB0\ACFC\B97C \C9C8\C758\D569\B2C8\B2E4. UPPER \D45C\D604\C2DD\C744 \C0AC\C6A9\D55C \D568\C218 \AE30\BC18 \C778\B371\C2A4\AC00 \C544\B2CC \D55C \C5F4\C758 \AE30\C874 \C778\B371\C2A4\AC00 \C0AC\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023619787890578.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4419)
,p_display_sequence=>50
,p_display_value=>unistr('\C11C\BC84: \C720\C0AC \BC0F \B300\C18C\BB38\C790 \AD6C\BD84')
,p_return_value=>'SERVER_LIKE_CASE'
,p_help_text=>unistr('\AC80\C0C9 \C2DC LIKE %[\AC80\C0C9 \AC12]%\C744 \C0AC\C6A9\D574\C11C \ACB0\ACFC\B97C \C9C8\C758\D569\B2C8\B2E4. \C774\B807\AC8C \D558\BA74 \D574\B2F9 \C5F4\C5D0\C11C \AE30\C874 \C778\B371\C2A4 \C0AC\C6A9\C744 \BC29\C9C0\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24024029483893440.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4419)
,p_display_sequence=>60
,p_display_value=>unistr('\C11C\BC84: \C720\C0AC \BC0F \B300\C18C\BB38\C790 \BB34\C2DC')
,p_return_value=>'SERVER_LIKE_IGNORE'
,p_help_text=>unistr('\AC80\C0C9 \C2DC LIKE %UPPER([\AC80\C0C9 \AC12])%\B97C \C0AC\C6A9\D574\C11C \ACB0\ACFC\B97C \C9C8\C758\D569\B2C8\B2E4. \C774\B807\AC8C \D558\BA74 \D574\B2F9 \C5F4\C5D0\C11C \AE30\C874 \C778\B371\C2A4 \C0AC\C6A9\C744 \BC29\C9C0\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10775027534399383.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>190
,p_prompt=>unistr('\C5F4 \AC80\C0C9')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('\AC80\C0C9\C5D0 \C0AC\C6A9\B418\B294 \B300\CCB4 \B370\C774\D130\BCA0\C774\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C544\BB34 \AC83\B3C4 \C9C0\C815\D558\C9C0 \C54A\C73C\BA74 \D14D\C2A4\D2B8 \C5F4\C774 \C0AC\C6A9\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37327132202507698.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_prompt=>unistr('\AC80\C0C9 \C0C1\C790 \C704\CE58 \D45C\C2DC\C790')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('\AC80\C0C9 \C0C1\C790\C5D0 \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \AC12\C744 \C9C0\C815\D558\C9C0 \C54A\C73C\BA74 \C2DC\C2A4\D15C \BA54\C2DC\C9C0 <strong>APEX.REGION.JQM_LIST_VIEW.SEARCH</strong>\C758 \AC12\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325332071498117.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>210
,p_prompt=>unistr('\C911\CCA9\B41C \BAA9\B85D \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NESTED'
,p_help_text=>unistr('\C911\CCA9\B41C \C9C8\C758\C758 \ACC4\CE35 \B808\BCA8\C744 \D3EC\D568\D558\B294 \B370\C774\D130\BCA0\C774\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. CONNECT BY \C9C8\C758\B97C \C0AC\C6A9\D560 \ACBD\C6B0 \C758\C0AC \C5F4 <code>LEVEL</code>\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(644548607716477014.4419)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4419)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C774\B984\C73C\B85C \C815\B82C\B41C \BAA8\B4E0 \C9C1\C6D0 \D45C\C2DC</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>\C774\B984\C73C\B85C \C815\B82C\B41C \D604\C7AC \BD80\C11C\C758 \BAA8\B4E0 \C9C1\C6D0 \D45C\C2DC</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>\BC14\C778\B4DC \BCC0\C218\B97C \C0AC\C6A9\D574\C11C \D398\C774\C9C0 \D56D\BAA9\C744 \CC38\C870\D560 \B54C\B294 <strong>\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9</strong>\C73C\B85C \C9C0\C815\D569\B2C8\B2E4.</p>'),
'</dd>',
unistr('<dt>\AE30\BCF8 \D0A4 \C5F4\B85C ROWID \C0AC\C6A9</dt>'),
'<dd><pre>',
'SELECT a.rowid as pk_rowid, ',
'       a.* ',
'  FROM emp a ',
'ORDER BY a.ename',
'</pre>',
unistr('<p>ROWID\B97C \C0AC\C6A9\D560 \B54C\B294 \C5F4 \BCC4\CE6D\C774 \D544\C694\D569\B2C8\B2E4.</p>'),
'</dd>',
unistr('<dt>\BAA8\B4E0 \C9C1\C6D0\C744 \BC18\D658\D558\B294 \C911\CCA9 \C9C8\C758</dt>'),
'<dd><pre>',
' select ename,',
'        level',
'   from emp',
'connect by prior empno = mgr',
'  start with mgr is null',
' order siblings by ename',
'</pre></dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/close_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276595215456808.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLOSE_REGION'
,p_display_name=>unistr('\C601\C5ED \B2EB\AE30')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLOSE_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C5F4 \C218 \C788\C73C\BA70, \C5F4\B824 \C788\ACE0, \CD95\C18C \AC00\B2A5\D55C \C601\C5ED(\C608: \C778\B77C\C778 \B300\D654\C0C1\C790 \B610\B294 \C778\B77C\C778 \D31D\C5C5)\C744 \B2EB\C2B5\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/open_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276779733456826.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'OPEN_REGION'
,p_display_name=>unistr('\C601\C5ED \C5F4\AE30')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','OPEN_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C5F4 \C218 \C788\C73C\BA70, \CD95\C18C \AC00\B2A5\D55C \C601\C5ED(\C608: \C778\B77C\C778 \B300\D654\C0C1\C790 \B610\B294 \C778\B77C\C778 \D31D\C5C5)\C744 \C5FD\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132376923088056966.4419)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_IN_GROUP'
,p_display_name=>unistr('\B864 \B610\B294 \ADF8\B8F9\C5D0 \D3EC\D568')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(132377321338088226.4419)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C774\B984')
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\D558\B098 \C774\C0C1\C758 \CF64\B9C8\B85C \AD6C\BD84\B41C \ADF8\B8F9 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91772529032268265.4419)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('\C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91772831765269995.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \B864')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773214348271589.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C791\C5C5\C601\C5ED \ADF8\B8F9')
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773695579272344.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C0AC\C6A9\C790\C815\C758')
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_not_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132377111646077506.4419)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_NOT_IN_GROUP'
,p_display_name=>unistr('\B864 \B610\B294 \ADF8\B8F9\C5D0 \D3EC\D568 \C548\B428')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_NOT_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(135876608363708702.4419)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C774\B984')
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\D558\B098 \C774\C0C1\C758 \CF64\B9C8\B85C \AD6C\BD84\B41C \ADF8\B8F9 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91774410321279131.4419)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('\C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91774719920280165.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \B864')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775192472281109.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C791\C5C5\C601\C5ED \ADF8\B8F9')
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775511878281830.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C0AC\C6A9\C790\C815\C758')
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker_jet
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(144248864922483430.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER_JET'
,p_display_name=>unistr('\B0A0\C9DC \C120\D0DD\AE30')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER_JET'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2EC\B825 \C544\C774\CF58\C774 \C788\B294 \D14D\C2A4\D2B8 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\B294 \D14D\C2A4\D2B8 \D56D\BAA9\C5D0 \B0A0\C9DC\B97C \C9C1\C811 \C785\B825\D558\AC70\B098 \B2EC\B825 \C544\C774\CF58\C744 \B204\B974\ACE0 \B2EC\B825 \D31D\C5C5\C5D0\C11C \B0A0\C9DC \BC0F \C2DC\AC04(\C120\D0DD\C0AC\D56D)\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C2DC\AC04\C740 \C774 \D56D\BAA9\C5D0 \B300\D55C <em>\D615\C2DD \B9C8\C2A4\D06C</em>\C5D0 \C2DC\AC04 \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B41C \ACBD\C6B0\C5D0\B9CC \B2EC\B825 \D31D\C5C5\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142750950234528930.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\BAA8\C591')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B0A0\C9DC \C120\D0DD\C5D0 \C0AC\C6A9\B418\B294 \B2EC\B825\C758 \BAA8\C591\C744 \C81C\C5B4\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: ''\D45C\C2DC \D615\C2DD''\C774 ''\D31D\C5C5'' \B610\B294 ''\C778\B77C\C778''\C778 \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142751748618530462.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C8FC \D45C\C2DC')
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('\C5F0\AC04 \C8FC \D45C\C2DC \C5EC\BD80\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752536880532293.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C6D4 \C120\D0DD\AE30')
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('\C6D4\C744 \D14D\C2A4\D2B8 \B300\C2E0 \C120\D0DD\C744 \D5C8\C6A9\D558\B294 \B2E8\CD94\B85C \B80C\B354\B9C1\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752956214532903.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C5F0\B3C4 \C120\D0DD\AE30')
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('\C5F0\B3C4\B97C \D14D\C2A4\D2B8 \B300\C2E0 \C120\D0DD\C744 \D5C8\C6A9\D558\B294 \B2E8\CD94\B85C \B80C\B354\B9C1\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(143948862668782714.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C6D4\C744 \BC97\C5B4\B098\B294 \C77C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D604\C7AC \D45C\C2DC\B418\B294 \C6D4\C744 \BC97\C5B4\B098\B294 \C77C\C758 \B3D9\C791\C744 \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: ''\D45C\C2DC \D615\C2DD''\C774 ''\D31D\C5C5'' \B610\B294 ''\C778\B77C\C778''\C778 \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949419755783405.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C228\AE40')
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('\D604\C7AC \D45C\C2DC\B418\B294 \C6D4\C744 \BC97\C5B4\B098\B294 \C77C\C774 \C228\ACA8\C9D1\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949752332784630.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C120\D0DD \AC00\B2A5')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('\D604\C7AC \D45C\C2DC\B418\B294 \C6D4\C744 \BC97\C5B4\B098\B294 \C77C\C774 \D45C\C2DC\B418\C5B4 \C120\D0DD \AC00\B2A5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143950165800785286.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\D45C\C2DC')
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('\D604\C7AC \D45C\C2DC\B418\B294 \C6D4\C744 \BC97\C5B4\B098\B294 \C77C\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142148878705941262.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C2DC\AC04 \C99D\BD84')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'15'
,p_display_length=>10
,p_max_length=>2
,p_unit=>unistr('\BD84')
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C2DC\AC04 \C120\D0DD \CF58\D2B8\B864\C5D0 \C0AC\C6A9\B418\B294 \C2DC\AC04 \C99D\BD84(\BD84)\C785\B2C8\B2E4. \CC38\ACE0: \C2DC\AC04 \C120\D0DD\C5D0 \C0AC\C6A9\B418\B294 \CF58\D2B8\B864\B9CC \C81C\C5B4\D558\BA70, \C774\B7EC\D55C \C99D\BD84\C744 \BC97\C5B4\B09C \C2DC\AC04\C740 \C5EC\C804\D788 \C218\B3D9\C73C\B85C \C785\B825\D558\ACE0 \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: ''\D45C\C2DC \D615\C2DD''\C774 ''\D31D\C5C5'' \B610\B294 ''\C778\B77C\C778''\C774\ACE0 \B610\D55C ''''\C2DC\AC04 \D45C\C2DC''\AC00 \C124\C815\B418\C5B4 \C788\C744 \B54C\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267715778102442717.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\D45C\C2DC \C2DC\AE30')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\B2EC\B825 \D31D\C5C5\C774 \D45C\C2DC\B418\B294 \C2DC\AE30\B97C \C81C\C5B4\D569\B2C8\B2E4. \CC38\ACE0: ''\D45C\C2DC \D615\C2DD''\C774 ''\D31D\C5C5'' \B610\B294 ''\C778\B77C\C778''\C778 \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716390932439526.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D56D\BAA9 \D3EC\CEE4\C2A4')
,p_return_value=>'FOCUS'
,p_help_text=>unistr('\D56D\BAA9\C774 \D3EC\CEE4\C2A4\B97C \BC1B\C744 \B54C \B610\B294 \B2EC\B825 \C544\C774\CF58\C744 \B204\B97C \B54C\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716858979438151.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C544\C774\CF58 \B204\B974\AE30')
,p_return_value=>'IMAGE'
,p_help_text=>unistr('\B2EC\B825 \C544\C774\CF58\C744 \B204\B97C \B54C\B9CC \C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141154378544914000.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C2DC\AC04 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\C2DC\AC04 \C815\BCF4 \D3EC\D568 \C5EC\BD80.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144250268701483448.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D45C\C2DC \D615\C2DD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\B0A0\C9DC \C120\D0DD\AE30\C758 \D45C\C2DC \BAA8\B4DC\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144250658827483448.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D31D\C5C5')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\D56D\BAA9\C774 \D3EC\CEE4\C2A4\B97C \BC1B\AC70\B098 \B2EC\B825 \C544\C774\CF58\C744 \B204\B974\BA74 \B2EC\B825\C774 \D31D\C5C5\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144252202058483449.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C778\B77C\C778')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\B2EC\B825\C740 \D398\C774\C9C0\C5D0 \D56D\C0C1 \C778\B77C\C778\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4. \D14D\C2A4\D2B8 \D544\B4DC\B294 \D45C\C2DC\B418\C9C0 \C54A\C73C\BA70 \D604\C7AC \C120\D0DD\B41C \B0A0\C9DC\B294 \B2EC\B825\C5D0 \AC15\C870 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142151127231126342.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\AE30\BCF8 HTML')
,p_return_value=>'NATIVE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BE0C\B77C\C6B0\C800\C5D0\C11C \C9C0\C6D0\D558\B294 \ACBD\C6B0 \AE30\BCF8 HTML \C785\B825 \B0A0\C9DC \C720\D615\C744 \C0AC\C6A9\D558\C5EC \B80C\B354\B9C1\D569\B2C8\B2E4. ''\C2DC\AC04 \D45C\C2DC''\AC00 \D574\C81C\B418\C5B4 \C788\C73C\BA74 ''date'' \C720\D615\C744 \B80C\B354\B9C1\D558\ACE0, ''\C2DC\AC04 \D45C\C2DC''\AC00 \C124\C815\B418\C5B4 \C788\C73C\BA74 ''datetime-local'' \C720\D615\C744 \B80C\B354\B9C1\D569\B2C8\B2E4. \CC38\ACE0: \B0A0\C9DC \C720\D615\C758 \C815\D655\D55C \D45C\C2DC\B294 \BE0C\B77C\C6B0\C800\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4. \BAA8\BC14\C77C \C7A5\CE58\C5D0\C11C \C571\C744 \C0AC\C6A9\D560 \B54C\B294 \AE30\BCF8 HTML\C774 \C120\D638 \C635\C158\C77C \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\AE30\BCF8 \B0A0\C9DC \C720\D615\C740 \D544\C694\D55C \B0A0\C9DC \D615\C2DD\C5D0 \B300\D574 \B9E4\C6B0 \D2B9\C815\C801\C774\AE30 \B54C\BB38\C5D0 ''\AE30\BCF8 HTML''\C744 \C0AC\C6A9\D560 \B54C \D56D\BAA9\C758 ''\D615\C2DD \B9C8\C2A4\D06C''\B294 APEX\C5D0\C11C \C790\B3D9\C73C\B85C \C124\C815\B418\BA70, \C0AC\C6A9\C790\AC00 \C774\B97C \BCC0\ACBD\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \ADF8\B7EC\B098 \C774\AC83\C740 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\B294 \D615\C2DD\C774 \C544\B2D9\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\B294 \D604\C7AC \B85C\CF00\C77C\C5D0 \C801\D569\D55C \D615\C2DD\C73C\B85C \B0A0\C9DC\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141749600267473768.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\CD5C\C18C \B0A0\C9DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C774 \D56D\BAA9\C5D0 \CD5C\C18C \B0A0\C9DC\AC00 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750147879475182.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C5C6\C74C')
,p_return_value=>'NONE'
,p_help_text=>unistr('\C815\C758\B41C \CD5C\C18C \B0A0\C9DC\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750575076477005.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D56D\BAA9')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\CD5C\C18C \B0A0\C9DC\AC00 \B2E4\B978 \D56D\BAA9\C758 \AC12\C5D0\C11C \B3D9\C801\C73C\B85C \D30C\C0DD\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750953061477828.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C815\C801')
,p_return_value=>'STATIC'
,p_help_text=>unistr('\CD5C\C18C \B0A0\C9DC\AC00 \C808\B300 \AC12 \B610\B294 \C624\B298 \B0A0\C9DC\C5D0 \B300\D55C \C0C1\B300 \AC12\C73C\B85C \C815\C758\B418\B294 \C815\C801 \AC12\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249127342483446.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\CD5C\C18C \C815\C801')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C785\B825 \B610\B294 \C120\D0DD\D560 \C218 \C788\B294 \CD5C\C18C \B0A0\C9DC\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\B0A0\C9DC \AC12\C740 <code>''YYYY-MM-DDTHH24:MI:SS''</code> \B610\B294 <code>''YYYYMMDDHH24MI''</code> \D615\C2DD\C758 \C808\B300 \AC12\C774\AC70\B098 \C624\B298 \B0A0\C9DC\B97C \AE30\C900\C73C\B85C \D558\B294 \C0C1\B300 \AC12(\C608: <code>+7d</code>) \B610\B294 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D55C \B3D9\C801 \AC12\C77C \C218 \C788\C2B5\B2C8\B2E4(\B300\CCB4 \AD6C\BB38\C774 \C62C\BC14\B978 \B0A0\C9DC \D615\C2DD \B610\B294 \C0C1\B300 \AC12\C744 \BC18\D658\D558\B294 \ACBD\C6B0).</p>'),
unistr('<p>\C0C1\B300\C801 \B0A0\C9DC \AC12\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C5F0\B3C4 \C218 + / -</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \AC1C\C6D4 \C218 + / -</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C8FC \C218 + / -</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C77C \C218 + / -</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141754177794489952.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\CD5C\C18C \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>\CD5C\C18C \D5C8\C6A9 \AC12\C744 \ACB0\C815\D558\B294 \D56D\BAA9\C785\B2C8\B2E4. \D604\C7AC \D398\C774\C9C0 \B610\B294 \C804\C5ED \D398\C774\C9C0\C5D0 \C788\B294 \D398\C774\C9C0 \D56D\BAA9\C774\C5B4\C57C \D569\B2C8\B2E4.<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141850062850547994.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\CD5C\B300 \B0A0\C9DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C774 \D56D\BAA9\C5D0 \CD5C\B300 \B0A0\C9DC\AC00 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850596251549117.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C5C6\C74C')
,p_return_value=>'NONE'
,p_help_text=>unistr('\C815\C758\B41C \CD5C\B300 \B0A0\C9DC\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850928550550352.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D56D\BAA9')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\CD5C\B300 \B0A0\C9DC\AC00 \B2E4\B978 \D56D\BAA9\C758 \AC12\C5D0\C11C \B3D9\C801\C73C\B85C \D30C\C0DD\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141851351298550860.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C815\C801')
,p_return_value=>'STATIC'
,p_help_text=>unistr('\CD5C\B300 \B0A0\C9DC\AC00 \C808\B300 \AC12 \B610\B294 \C624\B298 \B0A0\C9DC\C5D0 \B300\D55C \C0C1\B300 \AC12\C73C\B85C \C815\C758\B418\B294 \C815\C801 \AC12\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249516166483447.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\CD5C\B300 \C815\C801')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C785\B825 \B610\B294 \C120\D0DD\D560 \C218 \C788\B294 \CD5C\B300 \B0A0\C9DC\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\B0A0\C9DC \AC12\C740 <code>''YYYY-MM-DDTHH24:MI:SS''</code> \B610\B294 <code>''YYYYMMDDHH24MI''</code> \D615\C2DD\C758 \C808\B300 \AC12\C774\AC70\B098 \C624\B298 \B0A0\C9DC\B97C \AE30\C900\C73C\B85C \D558\B294 \C0C1\B300 \AC12(\C608: <code>+7d</code>) \B610\B294 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D55C \B3D9\C801 \AC12\C77C \C218 \C788\C2B5\B2C8\B2E4(\B300\CCB4 \AD6C\BB38\C774 \C62C\BC14\B978 \B0A0\C9DC \D615\C2DD \B610\B294 \C0C1\B300 \AC12\C744 \BC18\D658\D558\B294 \ACBD\C6B0).</p>'),
unistr('<p>\C0C1\B300\C801 \B0A0\C9DC \AC12\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C5F0\B3C4 \C218 + / -</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \AC1C\C6D4 \C218 + / -</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C8FC \C218 + / -</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C77C \C218 + / -</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141853413671557712.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\CD5C\B300 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>\CD5C\B300 \D5C8\C6A9 \AC12\C744 \ACB0\C815\D558\B294 \D56D\BAA9\C785\B2C8\B2E4. \D604\C7AC \D398\C774\C9C0 \B610\B294 \C804\C5ED \D398\C774\C9C0\C5D0 \C788\B294 \D398\C774\C9C0 \D56D\BAA9\C774\C5B4\C57C \D569\B2C8\B2E4.<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146749239835527240.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\C5EC\B7EC \B2EC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(144250268701483448.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'POPUP,INLINE'
,p_help_text=>unistr('\B2EC\B825\C5D0 \C5EC\B7EC \B2EC\C774 \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144253456913483450.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\C6D4 \C218')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146749239835527240.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\D55C \BC88\C5D0 \D45C\C2DC\D560 \AC1C\C6D4 \C218\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142950502812595734.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\AE30\BCF8\AC12 \C0AC\C6A9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('[\ACF5\C720 \AD6C\C131\C694\C18C] > [\AD6C\C131\C694\C18C \C124\C815] \B610\B294 \C0AC\C6A9\C790\C815\C758 \C124\C815\C5D0\C11C \C774 \AD6C\C131\C694\C18C\C5D0 \B300\D574 \C815\C758\B41C \AE30\BCF8\AC12\C744 \C0AC\C6A9\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142548837341436051.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\BAA8\C591')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B0A0\C9DC \C120\D0DD\C5D0 \C0AC\C6A9\B418\B294 \B2EC\B825\C758 \BAA8\C591\C744 \C81C\C5B4\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: ''\D45C\C2DC \D615\C2DD''\C774 ''\D31D\C5C5'' \B610\B294 ''\C778\B77C\C778''\C778 \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549209563439534.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C8FC \D45C\C2DC')
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('\C5F0\AC04 \C8FC \D45C\C2DC \C5EC\BD80\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549539424440887.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C6D4 \C120\D0DD\AE30')
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('\C6D4\C744 \D14D\C2A4\D2B8 \B300\C2E0 \C120\D0DD\C744 \D5C8\C6A9\D558\B294 \B2E8\CD94\B85C \B80C\B354\B9C1\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549996724441519.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C5F0\B3C4 \C120\D0DD\AE30')
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('\C5F0\B3C4\B97C \D14D\C2A4\D2B8 \B300\C2E0 \C120\D0DD\C744 \D5C8\C6A9\D558\B294 \B2E8\CD94\B85C \B80C\B354\B9C1\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144048842685822298.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\C6D4\C744 \BC97\C5B4\B098\B294 \C77C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D604\C7AC \D45C\C2DC\B418\B294 \C6D4\C744 \BC97\C5B4\B098\B294 \C77C\C758 \B3D9\C791\C744 \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: ''\D45C\C2DC \D615\C2DD''\C774 ''\D31D\C5C5'' \B610\B294 ''\C778\B77C\C778''\C778 \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049355435823179.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C228\AE40')
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('\D604\C7AC \D45C\C2DC\B418\B294 \C6D4\C744 \BC97\C5B4\B098\B294 \C77C\C774 \C228\ACA8\C9D1\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049732421823927.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C120\D0DD \AC00\B2A5')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('\D604\C7AC \D45C\C2DC\B418\B294 \C6D4\C744 \BC97\C5B4\B098\B294 \C77C\C774 \D45C\C2DC\B418\C5B4 \C120\D0DD \AC00\B2A5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144050133633824443.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\D45C\C2DC')
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('\D604\C7AC \D45C\C2DC\B418\B294 \C6D4\C744 \BC97\C5B4\B098\B294 \C77C\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141748859804709713.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\C2DC\AC04 \C99D\BD84')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>2
,p_unit=>unistr('\BD84')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C2DC\AC04 \C120\D0DD \CF58\D2B8\B864\C5D0 \C0AC\C6A9\B418\B294 \C2DC\AC04 \C99D\BD84(\BD84)\C785\B2C8\B2E4. \CC38\ACE0: \C2DC\AC04 \C120\D0DD\C5D0 \C0AC\C6A9\B418\B294 \CF58\D2B8\B864\B9CC \C81C\C5B4\D558\BA70, \C774\B7EC\D55C \C99D\BD84\C744 \BC97\C5B4\B09C \C2DC\AC04\C740 \C5EC\C804\D788 \C218\B3D9\C73C\B85C \C785\B825\D558\ACE0 \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: ''\D45C\C2DC \D615\C2DD''\C774 ''\D31D\C5C5'' \B610\B294 ''\C778\B77C\C778''\C774\ACE0 \B610\D55C ''''\C2DC\AC04 \D45C\C2DC''\AC00 \C124\C815\B418\C5B4 \C788\C744 \B54C\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267717248823433082.4419)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\D45C\C2DC \C2DC\AE30')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\B2EC\B825 \D31D\C5C5\C774 \D45C\C2DC\B418\B294 \C2DC\AE30\B97C \C81C\C5B4\D569\B2C8\B2E4. \CC38\ACE0: ''\D45C\C2DC \D615\C2DD''\C774 ''\D31D\C5C5'' \B610\B294 ''\C778\B77C\C778''\C778 \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267717787671430611.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D56D\BAA9 \D3EC\CEE4\C2A4')
,p_return_value=>'FOCUS'
,p_help_text=>unistr('\D56D\BAA9\C774 \D3EC\CEE4\C2A4\B97C \BC1B\C744 \B54C \B610\B294 \B2EC\B825 \C544\C774\CF58\C744 \B204\B97C \B54C\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267718203365429155.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C544\C774\CF58 \B204\B974\AE30')
,p_return_value=>'IMAGE'
,p_help_text=>unistr('\B2EC\B825 \C544\C774\CF58\C744 \B204\B97C \B54C\B9CC \C785\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/item_type/single_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(146860542307282603.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SINGLE_CHECKBOX'
,p_display_name=>unistr('\CCB4\D06C\BC15\C2A4')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACET_GRP_ITEMS:APEX_APPL_PAGE_SFILTER_GRP_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SINGLE_CHECKBOX'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C0AC\C6A9\C790\AC00 \C120\D0DD \B610\B294 \C120\D0DD \CDE8\C18C\D560 \C218 \C788\B294 \B2E8\C77C \CCB4\D06C\BC15\C2A4\B97C \D45C\C2DC\D569\B2C8\B2E4. \C815\C758\B41C \C120\D0DD \B610\B294 \C120\D0DD \CDE8\C18C\B41C \AC12\C740 \C81C\CD9C \C2DC \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146860884924292553.4419)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C120\D0DD\B41C \AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D560 \ACBD\C6B0 \D398\C774\C9C0 \D56D\BAA9\C5D0 \C800\C7A5\B418\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4. \AC12\C740 \CD5C\B300 255\C790\C77C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146861562091295771.4419)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C120\D0DD \D574\C81C\B41C \AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\C0AC\C6A9\C790\AC00 \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD \CDE8\C18C\D560 \ACBD\C6B0 \D398\C774\C9C0 \D56D\BAA9\C5D0 \C800\C7A5\B418\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C120\D0DD \CDE8\C18C\D588\C744 \B54C <code>NULL</code>\C744 \C800\C7A5\D558\B824\B294 \ACBD\C6B0\C5D0\B294 \C774 \C18D\C131\C744 \BE44\C6CC \B458 \C218\B3C4 \C788\C2B5\B2C8\B2E4. \AC12\C740 \CD5C\B300 255\C790\C77C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146862485248305221.4419)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\AE30\BCF8\AC12 \C0AC\C6A9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('[\ACF5\C720 \AD6C\C131\C694\C18C] > [\AD6C\C131\C694\C18C \C124\C815] \B610\B294 \C0AC\C6A9\C790\C815\C758 \C124\C815\C5D0\C11C \C774 \AD6C\C131\C694\C18C\C5D0 \B300\D574 \C815\C758\B41C \AE30\BCF8\AC12\C744 \C0AC\C6A9\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146864548825351464.4419)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C120\D0DD\B41C \AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\C0AC\C6A9\C790\AC00 \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D558\B294 \ACBD\C6B0 \D398\C774\C9C0 \D56D\BAA9\C5D0 \C800\C7A5\B418\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4. \AC12\C740 \CD5C\B300 255\C790\C77C \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<p>',
unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9 \D398\C774\C9C0\C5D0\C11C \D328\C2EF\C774 <em>\AC12 \BAA9\B85D\C744 \AE30\BC18\C73C\B85C</em> \C9C8\C758 \C5F4\C744 \D544\D130\B9C1\D558\BA74 \C774 \AC12\C740 LOV \D45C\C2DC \BC0F \BC18\D658 \AC12 <em>\BAA8\B450</em>\C640 \C77C\CE58\D574\C57C \D569\B2C8\B2E4. \D45C\C2DC \AC12\ACFC \BC18\D658 \AC12\C774 \B2E4\B97C \ACBD\C6B0 \C774 \C5F4\C5D0 \B300\D55C \D574\B2F9 \D328\C2EF \C720\D615\C744 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \B300\C2E0 <strong>\CCB4\D06C\BC15\C2A4 \ADF8\B8F9</strong> \D328\C2EF\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146865043227355165.4419)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C120\D0DD \D574\C81C\B41C \AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>19
,p_max_length=>255
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0AC\C6A9\C790\AC00 \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD \CDE8\C18C\D560 \ACBD\C6B0 \D398\C774\C9C0 \D56D\BAA9\C5D0 \C800\C7A5\B418\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C120\D0DD \CDE8\C18C\D588\C744 \B54C <code>NULL</code>\C744 \C800\C7A5\D558\B824\B294 \ACBD\C6B0\C5D0\B294 \C774 \C18D\C131\C744 \BE44\C6CC \B458 \C218\B3C4 \C788\C2B5\B2C8\B2E4. \AC12\C740 \CD5C\B300 255\C790\C77C \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: \C774 \AC12\C740 \D398\C774\C9C0 \D56D\BAA9\C774 <strong>\C120\D0DD\B41C \AC12</strong> \B610\B294 <strong>\C120\D0DD \CDE8\C18C\B41C \AC12</strong>\ACFC \C77C\CE58\D558\C9C0 \C54A\B294 \AC12\C73C\B85C \CC44\C6CC\C9C8 \ACBD\C6B0 \C0AC\C6A9\B429\B2C8\B2E4.</em></p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/ig
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(230331270232947234.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IG'
,p_display_name=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IG'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B7F0\D0C0\C784\C5D0 \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\B294 \B2E4\C591\D55C \AE30\B2A5\C744 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \C81C\ACF5\D558\B294 SQL \C9C8\C758 \AE30\BC18\C758 \D3EC\AD04\C801\C778 \C628\B77C\C778 \B2E4\C911 \D589 \C601\C5ED\C785\B2C8\B2E4. \C601\C5ED\C740 \D3B8\C9D1 \AC00\B2A5 \B610\B294 \C77D\AE30 \C804\C6A9\C73C\B85C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\C758 \D2B9\C815 \BCF4\ACE0 \C694\AD6C\C0AC\D56D\C744 \CDA9\C871\D558\AE30 \C704\D574 \C5EC\B7EC \AC00\C9C0 \C870\AC74\C744 \D3EC\D568\D558\B294 \C5EC\B7EC \AC1C\C758 \BE44\C2B7\D55C \C601\C5ED\C744 \AC1C\BC1C\D560 \D544\C694 \C5C6\C774 \B2E8\C77C \B300\D654\C2DD \ADF8\B9AC\B4DC\B97C \C815\C758\D558\ACE0 \D2B9\C815 \C694\AD6C\C0AC\D56D\C744 \CDA9\C871\D558\AE30 \C704\D574 \C77C\BC18 \C0AC\C6A9\C790\AC00 \B370\C774\D130 \D45C\C2DC\B97C \C870\C791\D560 \C218 \C788\B3C4\B85D \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(465646569260662699.4419)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4419)
,p_name=>'SOURCE_LOCATION'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936016374443633302.4419)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4419)
,p_name=>'apexbeginrecordedit'
,p_display_name=>unistr('\D589 \CD08\AE30\D654')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322074007251020.4419)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4419)
,p_name=>'gridpagechange'
,p_display_name=>unistr('\D398\C774\C9C0 \BCC0\ACBD')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233321734838250996.4419)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4419)
,p_name=>'interactivegridmodechange'
,p_display_name=>unistr('\BAA8\B4DC \BCC0\ACBD')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322895758251022.4419)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4419)
,p_name=>'interactivegridreportchange'
,p_display_name=>unistr('\BCF4\ACE0\C11C \BCC0\ACBD')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(230312956793621156.4419)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4419)
,p_name=>'interactivegridsave'
,p_display_name=>unistr('\C800\C7A5')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936015222634633296.4419)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4419)
,p_name=>'interactivegridselectionchange'
,p_display_name=>unistr('\C120\D0DD \BCC0\ACBD')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322485880251022.4419)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4419)
,p_name=>'interactivegridviewchange'
,p_display_name=>unistr('\BDF0 \BCC0\ACBD')
);
end;
/
prompt --application/shared_components/plugins/item_type/row_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253123678064187648.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_SELECTOR'
,p_display_name=>unistr('\D589 \C120\D0DD\AE30')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_SELECTOR'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B300\D654\C2DD \ADF8\B9AC\B4DC\C758 \AC01 \D589\C5D0 \CCB4\D06C\BC15\C2A4\B97C \D45C\C2DC\D558\C5EC \D589 \C870\C791\C744 \C704\D574 \D2B9\C815 \D589\C744 \C120\D0DD\D560 \C218 \C788\B3C4\B85D \D569\B2C8\B2E4.</p>'),
unistr('<p>\AE30\BCF8\C801\C73C\B85C APEX$ROW_SELECTOR \C5F4\C740 \D589 \C120\D0DD\AE30 \C720\D615\C73C\B85C \C124\C815\B429\B2C8\B2E4. \C774 \C5F4\C740 \B300\D654\C2DD \ADF8\B9AC\B4DC\AC00 \D3B8\C9D1 \AC00\B2A5\C774 \B418\BA74 \C790\B3D9\C73C\B85C \CD94\AC00\B429\B2C8\B2E4.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253123956742195925.4419)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B2E4\C911 \C120\D0DD \C0AC\C6A9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\B2E4\C911 \D589 \C120\D0DD\C744 \D5C8\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253124243508199498.4419)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\BAA8\B450 \C120\D0DD \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(253123956742195925.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Ctrl+A\B97C \C0AC\C6A9\D558\AC70\B098 <em>\CF58\D2B8\B864 \C228\AE30\AE30</em>\AC00 <em>\C544\B2C8\C624</em>\C778 \ACBD\C6B0 \C5F4 \BA38\B9AC\AE00\C758 \CCB4\D06C\BC15\C2A4\B97C \C0AC\C6A9\D558\C5EC \C0AC\C6A9\C790\AC00 \BAA8\B4E0 \D589\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(276642483200371586.4419)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\CEE8\D2B8\B864 \C228\AE30\AE30')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\AC01 \D589\C5D0 \D45C\C2DC\B418\B294 \CCB4\D06C\BC15\C2A4 \B610\B294 \B77C\B514\C624 \CEE8\D2B8\B864\C744 \C228\AE41\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/item_type/row_action
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253124868675308889.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_ACTION'
,p_display_name=>unistr('\C791\C5C5 \BA54\B274')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_ACTION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B300\D654\C2DD \ADF8\B9AC\B4DC\C758 \AC01 \D589\C5D0 \C791\C5C5 \C544\C774\CF58(\D584\BC84\AC70)\C744 \D45C\C2DC\D569\B2C8\B2E4. '),
unistr('\C791\C5C5 \BA54\B274\C5D0\B294 \ADF8\B9AC\B4DC \C18D\C131 \BC0F \C77C\BC18 \C0AC\C6A9\C790 \AD8C\D55C \BD80\C5EC\C5D0 \B530\B77C \B2E8\C77C \D589 \BDF0, \D589 \CD94\AC00, \D589 \C0AD\C81C, \D589 \C0C8\B85C\ACE0\CE68 \B4F1\ACFC \AC19\C740 \C635\C158\C774 \D3EC\D568\B429\B2C8\B2E4. \C774\B7EC\D55C \BA54\B274 \C635\C158\C744 \D1B5\D574 \C77C\BC18 \C0AC\C6A9\C790\B294 \ADF8\B9AC\B4DC\C5D0\C11C \D604\C7AC \D589\C5D0 \B300\D55C \D2B9\C815 \C791\C5C5\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C791\C5C5 \BA54\B274\B294 \D3B8\C9D1 \AC00\B2A5 \BC0F \D3B8\C9D1 \BD88\AC00\B2A5 \B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0\C11C \C0AC\C6A9\D560 \C218 \C788\C9C0\B9CC \C774\C5D0 \B530\B77C \BA54\B274 \C635\C158\C774 \B2E4\B985\B2C8\B2E4. \D3B8\C9D1 \BD88\AC00\B2A5 \B300\D654\C2DD \ADF8\B9AC\B4DC\C758 \ACBD\C6B0 \BA54\B274\C5D0 \C635\C158 \D558\C704 \C9D1\D569(\C608: \B2E8\C77C \D589 \BDF0 \BC0F \D589 \C0C8\B85C\ACE0\CE68)\C774 \C788\C9C0\B9CC \D3B8\C9D1 \AC00\B2A5 \D2B9\C815 \C791\C5C5(\C608: \D589 \CD94\AC00, \D589 \C0AD\C81C \B4F1)\C774 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4 </p>'),
unistr('<p>\B300\D654\C2DD \ADF8\B9AC\B4DC\B97C \D3B8\C9D1\D560 \C218 \C788\C744 \ACBD\C6B0 APEX$ROW_ACTION \C5F4\C774 \C790\B3D9\C73C\B85C \CD94\AC00\B418\ACE0 \C791\C5C5 \BA54\B274 \C720\D615\C73C\B85C \C124\C815\B429\B2C8\B2E4. \D3B8\C9D1 \BD88\AC00\B2A5 \B300\D654\C2DD \ADF8\B9AC\B4DC\C758 \ACBD\C6B0 \C774 \C5F4\C744 \C218\B3D9\C73C\B85C \CD94\AC00\D574\C57C \D569\B2C8\B2E4.</p>')))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jet_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258086019711957603.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JET_CHART'
,p_display_name=>unistr('\CC28\D2B8')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JET_CHART'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C5EC\B7EC \AC00\C9C0 \B0B4\C7A5\B41C \CC28\D2B8 \C720\D615\C744 \C0AC\C6A9\D574\C11C \B370\C774\D130\B97C \D45C\C2DC\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(608666764128858384.4419)
,p_plugin_id=>wwv_flow_api.id(258086019711957603.4419)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/hide
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258533608465739815.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'HIDE'
,p_display_name=>unistr('\C228\AE30\AE30')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','HIDE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\B97C \C228\AE41\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262136912621901373.4419)
,p_plugin_id=>wwv_flow_api.id(258533608465739815.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B3D9\C77C \D589\C5D0 \C788\B294 \BAA8\B4E0 \D398\C774\C9C0 \D56D\BAA9 \C228\AE30\AE30')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C601\D5A5\C744 \BC1B\B294 \C694\C18C\C640 \B3D9\C77C\D55C \D589\C5D0 \C788\B294 \BAA8\B4E0 \D398\C774\C9C0 \D56D\BAA9 \BC0F \B808\C774\BE14\C744 \C228\AE38\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C774 \C18D\C131\C740 \D3FC \D56D\BAA9\C744 \D45C\C2DC\D558\AE30 \C704\D574 \D14C\C774\BE14 \ADF8\B9AC\B4DC\B97C \C0AC\C6A9\D558\C9C0 \C54A\B294 \D398\C774\C9C0\C758 \D56D\BAA9\C5D0 \B300\D574\C11C\B294 \C791\B3D9\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \C5EC\AE30\C5D0\B294 \BAA8\BC14\C77C \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D558\B294 \BAA8\B4E0 \D398\C774\C9C0\AC00 \D3EC\D568\B429\B2C8\B2E4.</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/enable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537221774904509.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ENABLE'
,p_display_name=>unistr('\C0AC\C6A9')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ENABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/disable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537428700906571.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DISABLE'
,p_display_name=>unistr('\C0AC\C6A9 \C548\D568')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DISABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\B97C \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4. \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D558\BA74 \C774\B7EC\D55C \C694\C18C\AC00 \D3B8\C9D1 \BD88\AC00\B2A5\D558\AC8C \B418\BBC0\B85C \D398\C774\C9C0\B97C \C81C\CD9C\D560 \B54C \D56D\BAA9 \AC12\C774 \BCF4\C874\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538225714915177.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_VALUE'
,p_display_name=>unistr('\AC12 \C124\C815')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_VALUE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD:STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\C758 \AC12\C744 \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262584206591281622.4419)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C720\D615 \C124\C815')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC_ASSIGNMENT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C124\C815\D560 \AC12\C758 \D30C\C0DD \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262584812132283213.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C815\C801 \C9C0\C815')
,p_return_value=>'STATIC_ASSIGNMENT'
,p_help_text=>unistr('\B2E8\C77C \C815\C801 \AC12\C744 \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585623560286495.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_display_sequence=>15
,p_display_value=>unistr('JavaScript \D45C\D604\C2DD')
,p_return_value=>'JAVASCRIPT_EXPRESSION'
,p_help_text=>unistr('JavaScript\C5D0\C11C \D30C\C0DD\B418\AC70\B098 \ACC4\C0B0\B41C \D558\B098 \C774\C0C1\C758 \AC12\C744 \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585216634284505.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_display_sequence=>20
,p_display_value=>unistr('SQL \BB38')
,p_return_value=>'SQL_STATEMENT'
,p_help_text=>unistr('SQL \C9C8\C758 \ACB0\ACFC\B97C \AE30\C900\C73C\B85C \D558\B098 \C774\C0C1\C758 \AC12\C744 \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427666425507065443.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_display_sequence=>40
,p_display_value=>unistr('PL/SQL \D45C\D604\C2DD')
,p_return_value=>'PLSQL_EXPRESSION'
,p_help_text=>unistr('PL/SQL \D45C\D604\C2DD\C758 \ACB0\ACFC\B97C \AE30\C900\C73C\B85C \B2E8\C77C \AC12\C744 \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427667018365072832.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_display_sequence=>50
,p_display_value=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
,p_return_value=>'FUNCTION_BODY'
,p_help_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38\C758 \ACB0\ACFC\B97C \AE30\C900\C73C\B85C \B2E8\C77C \AC12\C744 \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1295383602600152012.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_display_sequence=>60
,p_display_value=>unistr('\B300\D654\C0C1\C790 \BC18\D658 \D56D\BAA9')
,p_return_value=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('\B300\D654\C0C1\C790\C758 \BC18\D658 \D56D\BAA9\C5D0 \B530\B77C \B2E8\C77C \AC12\C744 \C124\C815\D569\B2C8\B2E4. \CC38\ACE0: \C774 \C720\D615\C740 <strong>\B300\D654\C0C1\C790 \B2EB\D798</strong> \C774\BCA4\D2B8\C5D0 \B300\D574 \B3D9\C801 \C791\C5C5\C774 \C2E4\D589\B418\B294 \ACBD\C6B0\C5D0\B9CC \C791\B3D9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539307968928889.4419)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC_ASSIGNMENT'
,p_help_text=>unistr('\C815\C801 \AC12\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262586323439352724.4419)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('SQL \BB38')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>100
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_STATEMENT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select loc,',
'       dname',
'  from dept ',
' where deptno = :P1_DEPTNO',
'</pre>',
unistr('<p>\C774 \C608\C81C\C5D0\C11C\B294 <strong>\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9</strong>\C5D0 <code>P1_DEPTNO</code>\B97C \C785\B825\D569\B2C8\B2E4. \B610\D55C \AC01 <code>loc</code> \BC0F <code>dname</code> \C5F4\C5D0 \B300\D574 2\AC1C\C758 <em>\C601\D5A5\C744 \BC1B\B294 \C694\C18C</em>\B97C \C120\D0DD\D574\C57C \D569\B2C8\B2E4(\C608: P1_LOC \BC0F P1_DNAME).</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>1\C5D0\C11C 100\AC1C \C0AC\C774\C758 \C5F4\C744 \BC18\D658\D558\B294 SQL \BB38\C744 \C785\B825\D569\B2C8\B2E4. SQL \BB38\C73C\B85C \C120\D0DD\D55C \C5F4\C740 <strong>\C601\D5A5\C744 \BC1B\B294 \C694\C18C</strong>\C5D0\C11C \C120\D0DD\D558\B294 \D398\C774\C9C0 \D56D\BAA9\ACFC \C704\CE58\AC00 \C77C\CE58\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9</strong>\C5D0 \D3EC\D568\D560 \ACBD\C6B0, \BC14\C778\B4DC \AD6C\BB38\C744 \C0AC\C6A9\D574\C11C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: SQL \BB38\C774 \D589\C744 \D558\B098\B9CC \BC18\D658\D560 \ACBD\C6B0 \C774 \D589\C774 \AC12\C73C\B85C \C124\C815\B429\B2C8\B2E4. \C5EC\B7EC \D589\C774 \BC18\D658\B420 \ACBD\C6B0 \AC12 \C9D1\D569\C740 \AC01 \AC12\C5D0 \B300\D55C \BAA8\B4E0 \D589\C758 \CF64\B9C8\B85C \AD6C\BD84\B41C \BB38\C790\C5F4\C785\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662501518001786.4419)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('PL/SQL \D45C\D604\C2DD')
,p_attribute_type=>'PLSQL EXPRESSION'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'nvl(:P1_SAL, 0)',
'</pre>',
unistr('<p>\C774 \C608\C81C\C5D0\C11C\B294 <strong>\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9</strong>\C5D0 <code>P1_SAL</code>\C744 \C785\B825\D569\B2C8\B2E4.')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AC12\C744 \C124\C815\D558\B294 \B370 \C0AC\C6A9\B418\B294 PL/SQL \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9</strong>\C5D0 \D3EC\D568\D560 \ACBD\C6B0, \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(293265419645253258.4419)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('JavaScript \D45C\D604\C2DD')
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \CF54\B4DC\B294 \B2E4\C74C \B3D9\C801 \C791\C5C5 \AD00\B828 \C18D\C131\C5D0 \B300\D55C \C561\C138\C2A4 \AD8C\D55C\C744 \AC16\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>\B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D55C \C694\C18C\C758 DOM \AC1D\CCB4\C5D0 \B300\D55C \CC38\C870\C785\B2C8\B2E4.</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>\BAA8\B4E0 \C601\D5A5\C744 \BC1B\B294 \C694\C18C\B97C \D3EC\D568\D558\B294 jQuery \AC1D\CCB4\C785\B2C8\B2E4.</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>\C791\C5C5 \C774\B984 \BC0F \CD94\AC00 \C18D\C131\AC12\ACFC \AC19\C740 \C138\BD80\C815\BCF4\B97C \D3EC\D568\D558\B294 \C791\C5C5 \AC1D\CCB4\C785\B2C8\B2E4.</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>\C774\BCA4\D2B8\B97C \D2B8\B9AC\AC70\D55C \C774\BCA4\D2B8\C758 \C774\BCA4\D2B8 \AC1D\CCB4\C785\B2C8\B2E4. \CC38\ACE0: \B85C\B4DC \C2DC \C774 \AC12\C740 ''load''\C640 \B3D9\C77C\D569\B2C8\B2E4.</dd>'),
'  <dt><code>this.data</code></dt>',
unistr('    <dd>\C774\BCA4\D2B8 \CC98\B9AC\AE30\C5D0\C11C \C804\B2EC\B420 \C218 \C788\B294 \C120\D0DD\C801\C778 \CD94\AC00 \B370\C774\D130\C785\B2C8\B2E4.</dd>'),
'</dl>'))
,p_help_text=>unistr('\AC12\C744 \C124\C815\D558\B294 \B370 \C0AC\C6A9\B418\B294 JavaScript \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4. \C774 \D45C\D604\C2DD\C740 \B2E8\C77C \AC12 \B610\B294 \AC12 \BC30\C5F4(\C154\D2C0\ACFC \AC19\C774 \C124\C815 \C911\C778 \D56D\BAA9\C774 \C5EC\B7EC \AC12\C744 \C9C0\C6D0\D558\B294 \ACBD\C6B0)\C744 \AC00\C838\C62C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662910653013912.4419)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FUNCTION_BODY'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'return getCommission(:P1_SAL, :P1_JOB);',
'</pre>',
unistr('<p>\C774 \C608\C81C\C5D0\C11C\B294 <strong>\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9</strong>\C5D0 <code>P1_SAL</code> \BC0F <code>P1_JOB</code>\B97C \C785\B825\D569\B2C8\B2E4.')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AC12\C744 \C124\C815\D558\B294 \B370 \C0AC\C6A9\B418\B294 PL/SQL \D568\C218 \BCF8\BB38\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9</strong>\C5D0 \D3EC\D568\D560 \ACBD\C6B0, \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262597322287494361.4419)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\C81C\CD9C\D560 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('\C774 \C791\C5C5\C744 \C218\D589\D560 \B54C \C81C\CD9C\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \D56D\BAA9\C774 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \AC01 \D56D\BAA9 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4. \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \B54C \C774\BBF8 \C785\B825\B41C \D14D\C2A4\D2B8\AC00 \C788\C73C\BA74 \AE30\C874 \D14D\C2A4\D2B8 \B05D\C5D0 \CF64\B9C8\AC00 \D45C\C2DC\B418\ACE0 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \D56D\BAA9 \C774\B984\C774 \CD94\AC00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(618758229653179194.4419)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\C774\C2A4\CF00\C774\D504 \D2B9\C218 \BB38\C790')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('HTML \D2B9\C218 \BB38\C790\B97C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. Oracle\C740 XSS(\C0AC\C774\D2B8\AC04 \C2A4\D06C\B9BD\D305) \ACF5\ACA9\C744 \BC29\C9C0\D558\AE30 \C704\D574 \C774 \C18D\C131\C744 <strong>\C608</strong>\B85C \C124\C815\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(399189606786047634.4419)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\BCC0\ACBD \C774\BCA4\D2B8 \C228\AE30\AE30')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('<strong>\BC18\D658\D560 \D398\C774\C9C0 \D56D\BAA9</strong>\C5D0 \C9C0\C815\B41C \D56D\BAA9\C5D0\C11C \BCC0\ACBD \C774\BCA4\D2B8\AC00 \D45C\C2DC\B418\C9C0 \C54A\B3C4\B85D \D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C774\B807\AC8C \D558\BA74 \D574\B2F9 \D56D\BAA9\C5D0 \B300\D574 \C774\D6C4\C758 <em>\BCC0\ACBD</em> \AE30\BC18 \B3D9\C801 \C791\C5C5\C774 \C2E4\D589\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1295495331704184122.4419)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>75
,p_prompt=>unistr('\BC18\D658 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('\AC12 \C124\C815\C5D0 \C0AC\C6A9\B41C \B300\D654\C0C1\C790\C5D0\C11C \BC18\D658\B418\B294 \D398\C774\C9C0 \D56D\BAA9 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/javascript_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538732294917000.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'JAVASCRIPT_CODE'
,p_display_name=>unistr('JavaScript \CF54\B4DC \C2E4\D589')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','JAVASCRIPT_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\B3D9\C801 \C791\C5C5 \D504\B808\C784\C6CC\D06C \B0B4\C5D0\C11C \C0AC\C6A9\D560 \C0AC\C6A9\C790\C815\C758 \D398\C774\C9C0 \D2B9\C815 JavaScript \CF54\B4DC\B97C \C815\C758\D558\AC70\B098 \D638\CD9C\D560 \C218 \C788\C2B5\B2C8\B2E4. \D55C \D398\C774\C9C0\C5D0\B9CC \C801\C6A9\B418\B294 JavaScript \CF54\B4DC\B97C \C815\C758\D560 \ACBD\C6B0 \D398\C774\C9C0 \B808\BCA8 \C18D\C131 <em>\D568\C218 \BC0F \C804\C5ED \BCC0\C218 \C120\C5B8</em>\C744 \C0AC\C6A9\D574\C11C \C774\B97C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4. \ADF8\B7F0 \B2E4\C74C \C5EC\AE30\C5D0 \C815\C758\B41C \D568\C218 \BC0F \BCC0\C218\B97C \C774 \C791\C5C5\C5D0\C11C \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539816972931512.4419)
,p_plugin_id=>wwv_flow_api.id(258538732294917000.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\CF54\B4DC')
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \CF54\B4DC\B294 \B2E4\C74C \B3D9\C801 \C791\C5C5 \AD00\B828 \C18D\C131\C5D0 \B300\D55C \C561\C138\C2A4 \AD8C\D55C\C744 \AC16\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>\B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D55C \C694\C18C\C758 DOM \AC1D\CCB4\C5D0 \B300\D55C \CC38\C870\C785\B2C8\B2E4.</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>\BAA8\B4E0 \C601\D5A5\C744 \BC1B\B294 \C694\C18C\B97C \D3EC\D568\D558\B294 jQuery \AC1D\CCB4\C785\B2C8\B2E4.</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>\C791\C5C5 \C774\B984 \BC0F \CD94\AC00 \C18D\C131\AC12\ACFC \AC19\C740 \C138\BD80\C815\BCF4\B97C \D3EC\D568\D558\B294 \C791\C5C5 \AC1D\CCB4\C785\B2C8\B2E4.</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>\C774\BCA4\D2B8\B97C \D2B8\B9AC\AC70\D55C \C774\BCA4\D2B8\C758 \C774\BCA4\D2B8 \AC1D\CCB4\C785\B2C8\B2E4. \CC38\ACE0: \B85C\B4DC \C2DC \C774 \AC12\C740 ''load''\C640 \B3D9\C77C\D569\B2C8\B2E4.</dd>'),
'  <dt><code>this.data</code></dt>',
unistr('    <dd>\C774\BCA4\D2B8 \CC98\B9AC\AE30\C5D0\C11C \C804\B2EC\B420 \C218 \C788\B294 \C120\D0DD\C801\C778 \CD94\AC00 \B370\C774\D130\C785\B2C8\B2E4.</dd>'),
'</dl>'))
,p_help_text=>unistr('\D398\C774\C9C0 \B610\B294 \B3D9\C801 \C791\C5C5\ACFC \AD00\B828\B41C \C0AC\C6A9\C790\C815\C758 JavaScript\B97C \C785\B825\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/process_type/ig_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(260818839554927396.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'IG_DML'
,p_display_name=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC - \C790\B3D9 \D589 \D504\B85C\C138\C2F1(DML)')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','IG_DML'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC \D589\C744 \C0BD\C785, \C5C5\B370\C774\D2B8 \B610\B294 \C0AD\C81C\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260819106949935652.4419)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B300\C0C1 \C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0 \B300\D55C \B370\C774\D130 \BCC0\ACBD\C0AC\D56D\C744 \C800\C7A5\D558\AE30 \C704\D574 \C218\D589\B418\B294 \D589 \D504\B85C\C138\C2F1 \AE30\C220\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819425689937336.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C601\C5ED \C18C\C2A4')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0BD\C785, \C5C5\B370\C774\D2B8 \BC0F \C0AD\C81C\B294 \C601\C5ED \C18C\C2A4 SQL \C9C8\C758\B97C \D65C\C6A9\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0 - \C0BD\C785\C774\B098 \C5C5\B370\C774\D2B8\AC00 \AC00\B2A5\D558\C9C0 \C54A\C740 \C5F4\C758 \ACBD\C6B0 <strong>\C9C8\C758 \C804\C6A9</strong>\C744 <code>\C608</code>\B85C \C124\C815\D558\C5EC \CC98\B9AC\C5D0\C11C \C81C\C678\B418\B3C4\B85D \D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819835191938290.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D14C\C774\BE14/\BDF0')
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0BD\C785, \C5C5\B370\C774\D2B8 \BC0F \C0AD\C81C\B294 \C601\C5ED \C18C\C2A4 SQL \C9C8\C758\C5D0\C11C \C815\C758\B41C \AC83\ACFC \B2E4\B978 \D14C\C774\BE14\C774\B098 \BDF0\B97C \D65C\C6A9\D569\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, SQL \C9C8\C758\AC00 \D14C\C774\BE14 \C870\C778 \B610\B294 \C5C5\B370\C774\D2B8 \BD88\AC00\B2A5\D55C \BDF0\C5D0\C11C \B370\C774\D130\B97C \AC80\C0C9\D558\ACE0 DML \D504\B85C\C138\C2F1\C744 \B2E8\C77C \AE30\BCF8 \D14C\C774\BE14 \B610\B294 \C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BDF0\C5D0 \B300\D574 \C218\D589\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0 - \C0BD\C785\C774\B098 \C5C5\B370\C774\D2B8\AC00 \AC00\B2A5\D558\C9C0 \C54A\C740 \C5F4\C758 \ACBD\C6B0 <strong>\C9C8\C758 \C804\C6A9</strong>\C744 <code>\C608</code>\B85C \C124\C815\D558\C5EC \CC98\B9AC\C5D0\C11C \C81C\C678\B418\B3C4\B85D \D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260820229830940047.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4419)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \CF54\B4DC')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D504\B85C\C138\C2F1\C774 \C0AC\C6A9\C790\C815\C758 PL/SQL \CF54\B4DC\B97C \AE30\BC18\C73C\B85C \D569\B2C8\B2E4. \C774 \C635\C158\C744 \D1B5\D574 PL/SQL \CF54\B4DC\B97C \C2E4\D589\D568\C73C\B85C\C368 \AE30\BCF8 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \B370\C774\D130 \C870\C791\C744 \AD6C\D604\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C635\C158\C740 \D14C\C774\BE14 API \B610\B294 RESTful \C6F9 \C11C\BE44\C2A4 \D638\CD9C\ACFC \AC19\C740 \B370\C774\D130\BCA0\C774\C2A4 \D328\D0A4\C9C0\B97C \C0AC\C6A9\D558\C5EC \BE44\C988\B2C8\C2A4 \B17C\B9AC\B97C \AD6C\D604\D560 \B54C \D65C\C6A9\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0 - PL/SQL \CF54\B4DC\B294 \C0BD\C785, \C5C5\B370\C774\D2B8 \B610\B294 \C0AD\C81C\B41C \AC01 \D589\C5D0 \B300\D574 \D638\CD9C\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260820699209949601.4419)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D14C\C774\BE14 \C18C\C720\C790')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\D14C\C774\BE14 \C18C\C720\C790(\C2A4\D0A4\B9C8) \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260821252819962990.4419)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\D14C\C774\BE14 \C774\B984')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(260820699209949601.4419)
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\B294 \D14C\C774\BE14 \B610\B294 \BDF0 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261083814084772472.4419)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C0BD\C785/\C5C5\B370\C774\D2B8/\C0AD\C81C\B97C \C704\D55C PL/SQL \CF54\B4DC')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0\C11C \C870\C791\B41C \B370\C774\D130\C758 \AC01 \D589\C744 \CC98\B9AC\D558\AE30 \C704\D55C PL/SQL \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C5F4 \C774\B984\C744 \BC14\C778\B4DC \BCC0\C218\B85C \C0AC\C6A9\D558\C5EC \C5F4\C758 \AC12\C5D0 \C561\C138\C2A4\D569\B2C8\B2E4. \C2DC\C2A4\D15C \BCC0\C218 <code>APEX$ROW_STATUS</code>\B294 \D589\C758 \C0C1\D0DC\B97C \BC18\D658\D558\BA70 \D589\C774 \C0DD\C131, \C5C5\B370\C774\D2B8 \B610\B294 \C0AD\C81C\B418\C5C8\B294\C9C0 \C5EC\BD80\B97C \D655\C778\D558\B294 \B370 \C0AC\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4(\D655\C778 \BC29\BC95\C740 \C544\B798 \C608\C81C \CC38\C870).</p>'),
unistr('<p><em>\CC38\ACE0:</em> \AE30\BCF8 \D0A4 \C5F4\C774 \D2B8\B9AC\AC70 \B610\B294 PL/SQL \CF54\B4DC\B85C \CC44\C6CC\C9C0\B294 \ACBD\C6B0 \AE30\BCF8 \D0A4 \C5F4\C758 \BC14\C778\B4DC \BCC0\C218\C5D0 \C0C8 \AC12\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4. &PRODUCT_NAME.\C5D0\C11C\B294 \C774\B7EC\D55C \AC12\C744 \C0AC\C6A9\D558\C5EC \C0BD\C785 \B610\B294 \C5C5\B370\C774\D2B8 \C774\D6C4\C5D0 \D589\C744 \C778\CD9C\D569\B2C8\B2E4.</p>'),
unistr('<p>Oracle\C740 \C7AC\C0AC\C6A9 \BC0F \C720\C9C0 \AD00\B9AC\C131\C774 \C6A9\C774\D558\B3C4\B85D PL/SQL \D328\D0A4\C9C0 \B0B4\C758 \D504\B85C\C2DC\C800 \B610\B294 \D568\C218\B97C \D638\CD9C\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261084825593778341.4419)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\C190\C2E4\B41C \C5C5\B370\C774\D2B8 \BC29\C9C0')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C5EC\B7EC \C0AC\C6A9\C790\AC00 \B3D9\C77C\D55C \B370\C774\D130\BCA0\C774\C2A4 \B808\CF54\B4DC\B97C \C5C5\B370\C774\D2B8\D560 \B54C \D504\B85C\C138\C2F1\C5D0\C11C \C5C5\B370\C774\D2B8\AC00 \C190\C2E4\B418\C9C0 \C54A\B3C4\B85D \D574\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p> '),
unistr('<p>\C190\C2E4\B41C \C5C5\B370\C774\D2B8\B294 2\BA85 \C774\C0C1\C758 \C0AC\B78C\C774 \B3D9\C77C\D55C \B370\C774\D130\B97C \C5C5\B370\C774\D2B8\D558\B824\ACE0 \C2DC\B3C4\D558\ACE0 \CD5C\C885 \C5C5\B370\C774\D2B8\AC00 \CCAB\BC88\C9F8 \C0AC\C6A9\C790\C758 \C5C5\B370\C774\D2B8\B97C \ACB9\CCD0\C4F0\BA74\C11C \BCC0\ACBD\C0AC\D56D\C744 \C800\C7A5\D560 \B54C \BC1C\C0DD\D569\B2C8\B2E4. \C774 \C0C1\D669\C774 \BC1C\C0DD\D558\C9C0 \C54A\B3C4\B85D \B9C9\AE30 \C704\D574 \C5C5\B370\C774\D2B8\C5D0\C11C\B294 \B370\C774\D130\BCA0\C774\C2A4\C758 \AE30\C874 \C5F4 \AC12\ACFC \D589\C774 \CC98\C74C\C5D0 \C9C8\C758\B420 \B54C \AC80\C0C9\B41C \AC12\C744 \BE44\AD50\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C608:'),
'  <ol>',
unistr('    <li>\C0AC\C6A9\C790 A\AC00 \C9C1\C6D0(EMP) \B808\CF54\B4DC\B97C \C9C8\C758\D569\B2C8\B2E4.</li>'),
unistr('    <li>\C0AC\C6A9\C790 B\AC00 \B3D9\C77C\D55C \C9C1\C6D0 \B808\CF54\B4DC\B97C \C9C8\C758\D569\B2C8\B2E4.</li>'),
unistr('    <li>\C0AC\C6A9\C790 B\AC00 EMPNO = 7839\C5D0 \B300\D55C \C9C1\C6D0 \C138\BD80\C815\BCF4\B97C \C5C5\B370\C774\D2B8\D558\ACE0 \BCC0\ACBD\C0AC\D56D\C744 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C801\C6A9(\CEE4\BC0B)\D569\B2C8\B2E4.</li>'),
unistr('    <li>\C0AC\C6A9\C790 A\AC00 EMPNO = 7839\C5D0 \B300\D55C \C9C1\C6D0 \C138\BD80\C815\BCF4\B97C \C5C5\B370\C774\D2B8\D558\ACE0 \BCC0\ACBD\C0AC\D56D\C744 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C801\C6A9\D558\B824\ACE0 \C2DC\B3C4 \C911\C785\B2C8\B2E4.</li>'),
'  </ol>',
unistr('\C0AC\C6A9\C790 A\AC00 \B3D9\C77C\D55C \D589\C744 \C131\ACF5\C801\C73C\B85C \C5C5\B370\C774\D2B8\D560 \ACBD\C6B0 \C0AC\C6A9\C790 B\C758 \BCC0\ACBD\C0AC\D56D\C740 \C190\C2E4\B429\B2C8\B2E4.'),
unistr('\C0AC\C6A9\C790 A\AC00 \C9C1\C6D0 \D589\C744 \C800\C7A5\D558\B824\ACE0 \C2DC\B3C4 \C911\C77C \B54C \B370\C774\D130\BCA0\C774\C2A4\C758 \B370\C774\D130\B294 \C0AC\C6A9\C790 A\AC00 \CC98\C74C\C5D0 \C9C8\C758\D588\C744 \B54C\C640 \B2E4\B985\B2C8\B2E4. \C704\C758 \B2E8\ACC4 1\C5D0\C11C \C0AC\C6A9\C790 A\AC00 \CC98\C74C\C5D0 \C9C8\C758\D55C \C5F4 \AC12\C744 \CEA1\CC98\D560 \C218 \C788\C2B5\B2C8\B2E4. \ADF8\B7F0 \B2E4\C74C \C704\C758 \B2E8\ACC4 4\C5D0\C11C \AC12\C744 \B370\C774\D130\BCA0\C774\C2A4\C758 \D604\C7AC \AC12\ACFC \BE44\AD50\D560 \C218 \C788\C2B5\B2C8\B2E4. \B370\C774\D130\BCA0\C774\C2A4 \AC12\C774 \B2E8\ACC4 3\C5D0\C11C \C0AC\C6A9\C790 B\C5D0 \C758\D574 \C5C5\B370\C774\D2B8\B418\C5C8\C73C\BBC0\B85C \C774 \BE44\AD50\B294 \C0AC\C6A9\C790 A\C5D0 \B300\D55C \C624\B958\B97C \BC1C\C0DD\C2DC\D0B5\B2C8\B2E4. \ADF8\B7EC\BA74 \D55C \C0AC\C6A9\C790\AC00 \B2E4\B978 \C0AC\C6A9\C790\C758 \BCC0\ACBD\C0AC\D56D\C744 \B3D9\C77C\D55C \D589\C5D0 \ACB9')
||unistr('\CCD0\C4F0\C9C0 \BABB\D558\AC8C \B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0 - \C190\C2E4\B41C \C5C5\B370\C774\D2B8\AC00 \AC10\C9C0\B418\B294 \BC29\C2DD\C740 <strong>\C190\C2E4\B41C \C5C5\B370\C774\D2B8 \C720\D615</strong>\C5D0 \B300\D55C \C124\C815\C744 \AE30\C900\C73C\B85C \B300\D654\C2DD \ADF8\B9AC\B4DC \C601\C5ED\C5D0 \B300\D55C \C18D\C131\C5D0\C11C \C9C0\C815\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261085131500782260.4419)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\D589 \C7A0\ADF8\AE30')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\D589\C744 \CC98\B9AC\D558\AE30 \C804\C5D0 \C5C5\B370\C774\D2B8\D558\AC70\B098 \C0AD\C81C\D560 \AC01 \D589\C774 \AE30\BCF8 \D14C\C774\BE14\C5D0\C11C \C7A0\AE30\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085409986783810.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C608')
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C5C5\B370\C774\D2B8\B418\AC70\B098 \C0AD\C81C\B420 \D589\C774 SELECT ... FOR UPDATE\B97C \C0AC\C6A9\D558\C5EC \C7A0\AE40\C73C\B85C\C368 \D2B8\B79C\C7AD\C158\C774 \CEE4\BC0B\B420 \B54C\AE4C\C9C0 \D574\B2F9 \D589\C5D0\C11C \B2E4\B978 \D2B8\B79C\C7AD\C158\C774 \C218\D589\B418\C9C0 \C54A\B3C4\B85D \D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0 - \C7A0\AE08\C744 \C9C0\C6D0\D558\C9C0 \C54A\B294 \C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BDF0\C758 \ACBD\C6B0\C640 \AC19\C774 \C624\B958\AC00 \BC1C\C0DD\D558\BA74 PL/SQL \CF54\B4DC\B97C \D65C\C6A9\D558\C5EC \AD6C\B3D9 \D14C\C774\BE14\C744 \C7A0\AE00 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085868401784451.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C544\B2C8\C624')
,p_return_value=>'N'
,p_help_text=>unistr('\D589\C774 \C7A0\AE30\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261086261920786764.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4419)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \CF54\B4DC')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('\C0AC\C6A9\C790\C815\C758 PL/SQL \CF54\B4DC\B97C \C0AC\C6A9\D558\C5EC \D2B8\B79C\C7AD\C158\C774 \CEE4\BC0B\B420 \B54C\AE4C\C9C0 \D589\C744 \C7A0\AE09\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261087562475803605.4419)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\D589 \C7A0\ADF8\AE30\B97C \C704\D55C PL/SQL \CF54\B4DC')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(261085131500782260.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('\C5C5\B370\C774\D2B8 \BC0F \C0AD\C81C\D560 \B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14 \D589\C744 \C7A0\ADF8\B824\BA74 PL/SQL \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(352431952250846035.4419)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\C0BD\C785 \D6C4 \AE30\BCF8 \D0A4 \BC18\D658')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D589\C774 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C0BD\C785\B418\BA74 \AE30\BCF8 \D0A4 \C5F4\C774 \D574\B2F9\D558\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC \D589\C5D0 \BC18\D658\B418\C5B4\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.'),
unistr('\C77C\BC18\C801\C73C\B85C \C774 \C635\C158\C740 \AE30\BCF8 \D0A4 \C5F4\C774 \B370\C774\D130\BCA0\C774\C2A4 \D2B8\B9AC\AC70 \B610\B294 Oracle Database 12 <em>c</em> ID \C5F4\C5D0\C11C \CC44\C6CC\C9C8 \B54C \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0 - RETURNING INTO \C808\C774 \D5C8\C6A9\B418\C9C0 \C54A\B294\B2E4\B294 \C624\B958\AC00 \BC1C\C0DD\D560 \ACBD\C6B0 \C774 \C635\C158\C744 [\C544\B2C8\C624]\B85C \C124\C815\D558\ACE0 \AE30\BCF8 \D0A4 \C5F4\C744 \BBF8\B9AC \CC44\C6CC\C57C \D569\B2C8\B2E4.</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/add_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261340108358474705.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ADD_CLASS'
,p_display_name=>unistr('\D074\B798\C2A4 \CD94\AC00')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ADD_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\C5D0 \D558\B098 \C774\C0C1\C758 CSS \D074\B798\C2A4\B97C \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261340305288502177.4419)
,p_plugin_id=>wwv_flow_api.id(261340108358474705.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D074\B798\C2A4')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('CSS \D074\B798\C2A4 <code>articlenumber</code> \BC0F <code>highlight</code>\B97C \C601\D5A5\C744 \BC1B\B294 \C694\C18C\C758 HTML \D0DC\ADF8\C5D0 \CD94\AC00\D569\B2C8\B2E4.'),
'<pre>articlenumber highlight</pre>'))
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\C5D0 \C801\C6A9\D560 \D558\B098 \C774\C0C1\C758 \D074\B798\C2A4\B97C \C9C0\C815\D569\B2C8\B2E4. \B450 \AC1C \C774\C0C1 \C9C0\C815\D560 \ACBD\C6B0\C5D0\B294 \ACF5\BC31\C744 \C0AC\C6A9\D574\C11C \D074\B798\C2A4 \C774\B984\C744 \AD6C\BD84\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/remove_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261349722930705968.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REMOVE_CLASS'
,p_display_name=>unistr('\D074\B798\C2A4 \C81C\AC70')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REMOVE_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\C5D0\C11C \D558\B098 \C774\C0C1\C758 CSS \D074\B798\C2A4\B97C \C81C\AC70\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261350305185719779.4419)
,p_plugin_id=>wwv_flow_api.id(261349722930705968.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D074\B798\C2A4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('<p>\C601\D5A5\C744 \BC1B\B294 \C694\C18C\C5D0\C11C \C81C\AC70\D560 \D558\B098 \C774\C0C1\C758 \D074\B798\C2A4 \C774\B984\C744 \C9C0\C815\D569\B2C8\B2E4. \B450 \AC1C \C774\C0C1 \C9C0\C815\D560 \ACBD\C6B0\C5D0\B294 \ACF5\BC31\C744 \C0AC\C6A9\D574\C11C \D074\B798\C2A4 \C774\B984\C744 \AD6C\BD84\D569\B2C8\B2E4. \C601\D5A5\C744 \BC1B\B294 \C694\C18C\C5D0\C11C \BAA8\B4E0 \D074\B798\C2A4 \C774\B984\C744 \C81C\AC70\D558\B824\BA74 \BE44\C6CC \B461\B2C8\B2E4.</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_css
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261356726281848792.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_CSS'
,p_display_name=>unistr('\C2A4\D0C0\C77C \C124\C815')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_CSS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\C5D0 \C2A4\D0C0\C77C(CSS) \C18D\C131\C744 \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261356901132851044.4419)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C2A4\D0C0\C77C \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\C5D0 \B300\D574 \C124\C815\D558\B824\B294 \C2A4\D0C0\C77C(CSS) \C18D\C131\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261357406326852547.4419)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\C5D0 \B300\D574 \C2A4\D0C0\C77C \C18D\C131\C744 \C124\C815\D560 \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C601\D5A5\C744 \BC1B\B294 \C694\C18C\C5D0\C11C \C2A4\D0C0\C77C \C18D\C131\C744 \C81C\AC70\D558\B824\BA74 \BE44\C6CC \B461\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/custom
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(352953211423309033.4419)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'CUSTOM'
,p_display_name=>unistr('\C0AC\C6A9\C790\C815\C758')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','CUSTOM'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C0AC\C6A9\C790 \C778\C99D\C744 \D655\C778\D558\AE30 \C704\D574 \ACE0\C720\D55C PL/SQL \D568\C218\B97C \C815\C758\D560 \C218 \C788\AC8C \D574\C8FC\B294 \C778\C99D \CCB4\ACC4\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353179625368369848.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\AC10\C2DC \D568\C218 \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>''PL/SQL \CF54\B4DC'' \B0B4\C5D0\C11C \BD80\C6B8 \AC12\C744 \BC18\D658\D558\B294 PL/SQL \CF54\B4DC\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
'<pre>',
'function sentry_basic_auth',
'return boolean',
'is',
'    c_auth_header   constant varchar2(4000) := owa_util.get_cgi_env(''AUTHORIZATION'');',
'    l_user_pass     varchar2(4000);',
'    l_separator_pos pls_integer;',
'begin',
'    if apex_application.g_user <> ''nobody'' then',
'        return true;',
'    end if;',
'',
'    if c_auth_header like ''Basic %'' then',
'        l_user_pass := utl_encode.text_decode (',
'                           buf      => substr(c_auth_header, 7),',
'                           encoding => utl_encode.base64 );',
'        l_separator_pos := instr(l_user_pass, '':'');',
'        if l_separator_pos > 0 then',
'            apex_authentication.login (',
'                p_username => substr(l_user_pass, 1, l_separator_pos-1),',
'                p_password => substr(l_user_pass, l_separator_pos+1) );',
'            return true;',
'        end if;',
'    end if;',
'',
'    return false;',
'end sentry_basic_auth;',
'</pre>',
unistr('<p>PL/SQL \B370\C774\D130\BCA0\C774\C2A4 \D568\C218\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
'<pre>',
'sentry_basic_auth',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>&PRODUCT_NAME. \C5D4\C9C4\C5D0 \B300\D55C \C694\CCAD\C774 \C2DC\C791\B420 \B54C(\C608: \AC01 \D398\C774\C9C0\AC00 \D45C\C2DC\B418\AC70\B098 \CC98\B9AC\B418\AE30 \C804 \B610\B294 AJAX \C694\CCAD\C774 \C2E4\D589\B418\AE30 \C804), \C774 \C5D4\C9C4\C5D0\C11C \C218\D589\B418\B294 \D568\C218\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. '),
unistr('\C774 \D568\C218 \C774\B984\C740 \D328\D0A4\C9C0 \B0B4\C5D0\C11C \B610\B294 \B0B4\C7A5 \D568\C218\B85C \C778\C99D\C758 PL/SQL \CF54\B4DC\C5D0 \C815\C758\B418\C5C8\C744 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('<p>\C774 \D568\C218\AC00 false\B97C \BC18\D658\D560 \ACBD\C6B0(\C0AC\C6A9\C790\AC00 \B85C\ADF8\C778\B418\C9C0 \C54A\C558\C74C\C744 \B098\D0C0\B0C4), \C138\C158\C774 \BD80\C801\D569\D55C \C138\C158\C73C\B85C \D45C\C2DC\B418\ACE0 <em>\BD80\C801\D569\D55C \C138\C158 \D504\B85C\C2DC\C800</em>\AC00 \D638\CD9C\B429\B2C8\B2E4.'),
unistr('\C774\D6C4\C5D0\B294 &PRODUCT_NAME.\C774(\AC00) ''\BD80\C801\D569\D55C \C138\C158 > \C774\B3D9''\C5D0 \C815\C758\B41C URL\B85C \C7AC\C9C0\C815\B429\B2C8\B2E4.'),
unistr('\C774 \D544\B4DC\C758 \AC12\C774 \BE44\C5B4 \C788\B294 \ACBD\C6B0,'),
unistr('\B0B4\BD80 \AE30\BCF8 \AC10\C2DC\AC00 \D638\CD9C\B418\C5B4 URL\C758 \C138\C158 ID\C640 \C778\C99D \CCB4\ACC4 \CFE0\D0A4(\C2E4\D328\D560 \ACBD\C6B0 &PRODUCT_NAME. \C791\C131\AE30 \CFE0\D0A4\AC00 \B300\C2E0 \C0AC\C6A9\B428)\C758 \C138\C158 \C815\BCF4\B97C \BE44\AD50\D558\C5EC \C801\D569\D55C \C138\C158\C744 \C124\C815\D558\B824\ACE0 \C2DC\B3C4\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551983430308015470.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\BD80\C801\D569\D55C \C138\C158 \D504\B85C\C2DC\C800 \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'procedure invalid_session_basic_auth',
'is',
'begin',
'    owa_util.status_line (',
'        nstatus       => 401,',
'        creason       => ''Basic Authentication required'',',
'        bclose_header => false);',
'    htp.p(''WWW-Authenticate: Basic realm="protected realm"'');',
'    apex_application.stop_apex_engine;',
'end invalid_session_basic_auth;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BD80\C801\D569\D55C \C138\C158\C774 \BC1C\ACAC\B41C \ACBD\C6B0\C5D0 \D638\CD9C\B418\B294 PL/SQL \D504\B85C\C2DC\C800\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.'),
'',
unistr('<p>\C775\BA85 PL/SQL \CF54\B4DC \BE14\B85D\C758 \D568\C218, \D328\D0A4\C9C0 \D568\C218 \B610\B294 \B370\C774\D130\BCA0\C774\C2A4\C758 \B3C5\B9BD\D615 \D568\C218\B97C \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4. \C608: <code>invalid_session_basic_auth</code></p>'),
'',
unistr('<p>\B370\C774\D130\BCA0\C774\C2A4 PL/SQL \D328\D0A4\C9C0 \B610\B294 \B3C5\B9BD\D615 \D568\C218\B97C \CC38\C870\D560 \ACBD\C6B0 <code>#OWNER#</code> \B300\CCB4 \BB38\C790\C5F4\C744 \C0AC\C6A9\D558\C5EC \D604\C7AC \C560\D50C\B9AC\CF00\C774\C158\C758 \AD6C\BB38 \BD84\C11D \C2A4\D0A4\B9C8\B97C \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4. \C608: <code>#OWNER#.invalid_session_basic_auth</code></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353293115026395181.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C778\C99D \D568\C218 \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>''PL/SQL \CF54\B4DC'' \D14D\C2A4\D2B8 \C601\C5ED\C5D0 \B2E4\C74C \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
'<pre>',
'function my_authentication (',
'    p_username in varchar2,',
'    p_password in varchar2 )',
'    return boolean',
'is',
'    l_user my_users.user_name%type := upper(p_username);',
'    l_id   my_users.id%type;',
'    l_hash my_users.password_hash%type;',
'begin',
'    begin',
'        select id  , password_hash',
'          into l_id, l_hash',
'          from my_users',
'         where user_name = l_user;',
'    exception when no_data_found then',
'        l_hash := ''-invalid-'';',
'    end;',
'',
'    return l_hash = rawtohex(sys.dbms_crypto.hash (',
'                        sys.utl_raw.cast_to_raw (',
'                            p_password||l_id||l_user ),',
'                        sys.dbms_crypto.hash_sh512 ));',
'end;',
'</pre>',
'',
unistr('<p>\ADF8\B9AC\ACE0 <code>my_authentication</code>\C744 ''\C778\C99D \D568\C218''\B85C \C785\B825\D569\B2C8\B2E4.')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B85C\ADF8\C778 \D398\C774\C9C0\C5D0 \C785\B825\B41C \D6C4 \C0AC\C6A9\C790\C758 \C0AC\C6A9\C790 \C774\B984\ACFC \BE44\BC00\BC88\D638\B97C \D655\C778\D560 \D568\C218\C758 \C774\B984\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C544\BB34 \AC83\B3C4 \C785\B825\D558\C9C0 \C54A\C73C\BA74 \BAA8\B4E0 \C0AC\C6A9\C790 \C774\B984/\BE44\BC00\BC88\D638\AC00 \C131\ACF5\D569\B2C8\B2E4.'),
unistr('\D568\C218 \C790\CCB4\B294 \D328\D0A4\C9C0 \B0B4\C5D0\C11C \B610\B294 \B0B4\C7A5 \D568\C218\B85C \C778\C99D\C758 ''PL/SQL \CF54\B4DC'' \D14D\C2A4\D2B8 \C601\C5ED\C5D0 \C815\C758\B420 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\C774 \D568\C218\B294 \D638\CD9C\D558\B294 \B85C\ADF8\C778 \D504\B85C\C2DC\C800\C5D0 \BD80\C6B8 \AC12\C744 \BC18\D658\D574\C57C \D569\B2C8\B2E4. \C5EC\AE30\C5D0\B294 \C77C\BC18 \C0AC\C6A9\C790\AC00 \B85C\ADF8\C778 \D398\C774\C9C0\C5D0 \C785\B825\D55C \AC12\C5D0 \C561\C138\C2A4\D558\AE30 \C704\D574 \C0AC\C6A9\D560 \C218 \C788\B294 ''p_username'' \BC0F ''p_password'' \C785\B825 \B9E4\AC1C\BCC0\C218 2\AC1C\AC00 \D3EC\D568\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353301225415398269.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C0AC\D6C4 \B85C\ADF8\C544\C6C3 \D504\B85C\C2DC\C800 \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>''PL/SQL \CF54\B4DC'' \D14D\C2A4\D2B8 \C601\C5ED\C5D0 \B2E4\C74C \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
'<pre>',
'procedure my_post_logout',
'is',
'begin',
'    insert into logout_log (',
'        application_id,',
'        session_id,',
'        logout_time,',
'        user_name',
'    ) values (',
'        :APP_ID,',
'        :APP_SESSION,',
'        sysdate,',
'        :APP_USER );',
'end;',
'</pre>',
'',
unistr('<p>\ADF8\B9AC\ACE0 <code>my_post_logout</code>\C744 ''\C0AC\D6C4 \B85C\ADF8\C544\C6C3 \D504\B85C\C2DC\C800''\B85C \C785\B825\D569\B2C8\B2E4.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \B85C\ADF8\C544\C6C3 URL\C744 \B204\B978 \B2E4\C74C \D638\CD9C\B418\B294 \D504\B85C\C2DC\C800 \C774\B984\C785\B2C8\B2E4. \C774 \C774\B984\C740 \B85C\AE45\C5D0 \C0AC\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\D504\B85C\C2DC\C800 \C790\CCB4\B294 \D328\D0A4\C9C0 \B0B4\C5D0\C11C \B610\B294 \B0B4\C7A5 \D568\C218\B85C \C778\C99D\C758 ''PL/SQL \CF54\B4DC'' \D14D\C2A4\D2B8 \C601\C5ED\C5D0 \C815\C758\B420 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629094915193552126.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\B808\AC70\C2DC \C778\C99D \C18D\C131\C744 \C0AC\C6A9\C73C\B85C \C124\C815')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \C120\D0DD \BAA9\B85D\C774 "\C608"\B85C \C124\C815\B418\BA74 \CD94\AC00 \C778\C99D \C18D\C131\C774 \D45C\C2DC\B429\B2C8\B2E4. '),
unistr('\C774 \C18D\C131\C740 \C8FC\B85C &PRODUCT_NAME. 4.0 \C774\C804\C5D0\C11C \D3EC\D305\B41C \C0AC\C6A9\C790\C815\C758 \C778\C99D\C5D0 \D574\B2F9\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629174621211563368.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('SSO \D611\B825 \C560\D50C\B9AC\CF00\C774\C158 \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Oracle Application Server Single Sign-On\C744 \C0AC\C6A9\D558\C5EC \C778\C99D\C744 \C218\D589\D558\BA70 \C0AC\C6A9\C790\C758 \C560\D50C\B9AC\CF00\C774\C158\C774 SSO\C5D0 \B4F1\B85D\B41C \D611\B825 \C560\D50C\B9AC\CF00\C774\C158\C778 \ACBD\C6B0, SSO\C5D0 \D611\B825 \C560\D50C\B9AC\CF00\C774\C158\C744 \B4F1\B85D\D560 \B54C \C0AC\C6A9\D55C \AC83\ACFC \C815\D655\D788 \B3D9\C77C\D55C \C774\B984\C744 \C785\B825\D558\C2ED\C2DC\C624.'),
'',
unistr('Application Express\B97C \B4F1\B85D\B41C \D611\B825 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \C0AC\C6A9\D558\B294 \ACBD\C6B0\C5D0\B294 \C774 \D544\B4DC\B97C \BE44\C6CC \B450\C2ED\C2DC\C624.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629550107668606770.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('LDAP \D638\C2A4\D2B8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('LDAP \B514\B809\D1A0\B9AC \C11C\BC84\C758 \D638\C2A4\D2B8 \C774\B984\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629554415286608926.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('LDAP \D3EC\D2B8')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('LDAP \B514\B809\D1A0\B9AC \D638\C2A4\D2B8\C758 \D3EC\D2B8 \BC88\D638\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629644211608617346.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('SSL \C0AC\C6A9')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('LDAP \B515\C154\B108\B9AC \BC14\C778\B4DC\B97C \C704\D574 SSL\C744 \C0AC\C6A9\D560\C9C0 \C5EC\BD80\B97C \C120\D0DD\D558\C2ED\C2DC\C624. [SSL(\C778\C99D)]\C744 \C120\D0DD\D560 \ACBD\C6B0 Application Express \C778\C2A4\D134\C2A4\C5D0 \B300\D55C \C804\C790 \C9C0\AC11\C744 \AD6C\C131\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629669815417618470.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4419)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629680822344620420.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4419)
,p_display_sequence=>20
,p_display_value=>unistr('SSL(\C778\C99D \D3EC\D568)')
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629685004813624810.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4419)
,p_display_sequence=>30
,p_display_value=>unistr('SSL \C5C6\C74C')
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629825611870636385.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('LDAP DN \BB38\C790\C5F4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\C815\D655\D55C DN</dt>'),
'  <dd><code>cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com</code></dd>',
unistr('  <dt>\C815\D655\D558\C9C0 \C54A\C740 DN(\AC80\C0C9 \AE30\C900)</dt>'),
'  <dd><code>dc=yourdomain,dc=com</code></dd>',
'</dl>'))
,p_help_text=>unistr('\C815\D655\D55C DN\C744 \C0AC\C6A9\D560 \ACBD\C6B0 DBMS_LDAP.SIMPLE_BIND_S\C5D0 \B300\D55C \C804\CCB4 DN(\C2DD\BCC4 \C774\B984) \BB38\C790\C5F4\C744 \C0DD\C131\D558\ACE0 \BD80\C815\D655\D55C DN\C744 \C0AC\C6A9\D558\B294 \ACBD\C6B0 \AC80\C0C9 \AE30\C900\C744 \C0DD\C131\D558\B294 \B370 \C0AC\C6A9\B418\B294 \D328\D134\C744 \C785\B825\D569\B2C8\B2E4. \C0AC\C6A9\C790 \C774\B984\C5D0 \B300\D55C \C704\CE58 \D45C\C2DC\C790\B85C <strong>%LDAP_USER%</strong>\B97C \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629787303213633849.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\C815\D655\D55C \C2DD\BCC4 \C774\B984(DN) \C0AC\C6A9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('LDAP \C2DD\BCC4 \C774\B984(DN) \BB38\C790\C5F4\C774 \C815\D655\D55C\C9C0 \C5EC\BD80\B97C \C120\D0DD\D558\C2ED\C2DC\C624. \BD80\C815\D655\D55C \BB38\C790\C5F4\C778 \ACBD\C6B0 LDAP \C2DD\BCC4 \C774\B984(DN)\C774 \AC80\C0C9 \AE30\C900\C774\BA70 \AC80\C0C9 \D544\D130\B97C \C81C\ACF5\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(741851526139627010.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\AC80\C0C9 \D544\D130')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629787303213633849.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'cn=%LDAP_USER%',
'</pre>'))
,p_help_text=>unistr('\C815\D655\D55C DN(\C2DD\BCC4 \C774\B984)\C744 \C0AC\C6A9\D558\C9C0 \C54A\B294 \ACBD\C6B0 \AC80\C0C9 \D544\D130\B97C \C785\B825\D569\B2C8\B2E4. <b>%LDAP_USER%</b>\B97C \C0AC\C6A9\C790 \C774\B984\C758 \C704\CE58 \D45C\C2DC\C790\B85C \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629863429878641530.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('LDAP \C0AC\C6A9\C790 \C774\B984 \D3B8\C9D1 \D568\C218')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2E4\C74C \CF54\B4DC\B294 DN \BB38\C790\C5F4\C5D0\C11C \BAA8\B4E0 "."\B97C "_"\B85C \BC14\AFB8\B294 \D568\C218\B97C \D638\CD9C\D569\B2C8\B2E4.</p>'),
'<pre>',
'return apex_custom_auth.ldap_dnprep;',
'</pre>'))
,p_help_text=>unistr('\C2E4\D589\D560 \CD94\AC00 \CF54\B4DC\B97C \C81C\ACF5\D558\C5EC LDAP \B514\B809\D1A0\B9AC \D56D\BAA9 \B610\B294 LDAP \C0AC\C6A9\C790 \C774\B984\C5D0 \AC00\C7A5 \C801\D569\D55C \D615\C2DD\C73C\B85C \C0AC\C6A9\C790 \C774\B984\C744 \BCC0\D658\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38291032596231774.4419)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\C0AC\C6A9\C790 \C774\B984 \C774\C2A4\CF00\C774\D504')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('LDAP \C2DD\BCC4 \C774\B984 \BC0F \AC80\C0C9 \BB38\C790\C5F4\C5D0\C11C <code><strong>%LDAP_USER%</strong></code>\B97C \BC14\AFB8\AE30 \C804\C5D0'),
unistr('&PRODUCT_NAME.\C740(\B294) \C0AC\C6A9\C790 \C774\B984\C5D0 \D3EC\D568\B41C \D2B9\C218 \BB38\C790\B97C \C790\B3D9\C73C\B85C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291304329233033.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D45C\C900')
,p_return_value=>'STD'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('RFC 4514(\C2DD\BCC4 \C774\B984) \BC0F RFC 4515(\AC80\C0C9 \BB38\C790\C5F4)\C5D0 \B530\B77C \D2B9\C218 \BB38\C790\B97C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D569\B2C8\B2E4.'),
unistr('\B610\D55C \C720\B2C8\CF54\B4DC \BB38\C790\B3C4 \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D569\B2C8\B2E4.'),
unistr('\C774 \C124\C815\C740 \AC00\C7A5 \C548\C804\D55C \C124\C815\C774\C9C0\B9CC \C77C\BD80 LDAP \C11C\BC84\C5D0\C11C \BB38\C81C\AC00 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291708139234196.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D2B9\C218 \BB38\C790\B9CC')
,p_return_value=>'ONLY'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('RFC 4514(\C2DD\BCC4 \C774\B984) \BC0F RFC 4515(\AC80\C0C9 \BB38\C790\C5F4)\C5D0 \B530\B77C \D2B9\C218 \BB38\C790\B97C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D569\B2C8\B2E4.'),
unistr('\C720\B2C8\CF54\B4DC \BB38\C790\B294 \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38292111602235122.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C774\C2A4\CF00\C774\D504 \C5C6\C74C')
,p_return_value=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\BB38\C790\B97C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \C774 \C124\C815\C740 \C0AC\C6A9\C790 \C774\B984\C744 \C774\BBF8'),
unistr('\C774\C2A4\CF00\C774\D504 \CC98\B9AC\D558\B294 <strong>\C0AC\C6A9\C790 \C774\B984 \D3B8\C9D1 \D568\C218</strong>\AC00 \C801\C6A9\B418\C9C0 \C54A\C740 \D55C \C7A0\C7AC\C801\C73C\B85C'),
unistr('\C548\C804\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \C608: <code>apex_escape.ldap_dn</code> \B610\B294 <code>apex_escape.ldap_search_filter</code>.')))
);
end;
/
prompt --application/shared_components/plugins/process_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(360896225809711408.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('\CF54\B4DC \C2E4\D589')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('PL/SQL \CF54\B4DC\B97C \C2E4\D589\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/process_type/close_window
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361240401142661438.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'CLOSE_WINDOW'
,p_display_name=>unistr('\B300\D654\C0C1\C790 \B2EB\AE30')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','CLOSE_WINDOW'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\D604\C7AC \BAA8\B2EC \B610\B294 \BE44\BAA8\B2EC \B300\D654\C0C1\C790 \D398\C774\C9C0\B97C \B2EB\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(369154203766535800.4419)
,p_plugin_id=>wwv_flow_api.id(361240401142661438.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\BC18\D658\D560 \D56D\BAA9 ')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D574\B2F9 \B300\D654\C0C1\C790\B85C \BC18\D658\D560 \D558\B098 \C774\C0C1\C758 \D398\C774\C9C0 \D56D\BAA9\C758 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \D56D\BAA9\C774 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \AC01 \D56D\BAA9 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\B300\D654\C0C1\C790 \BC18\D658 \D56D\BAA9</strong>\C758 <strong>\AC12 \C124\C815</strong> \BC0F <em>\C720\D615 \C124\C815</em> \C791\C5C5\ACFC \D568\AED8 \C694\C18C\C5D0\C11C \B300\D654\C0C1\C790\B97C \C5EC\B294 <strong>\B300\D654\C0C1\C790 \B2EB\D798</strong> \C774\BCA4\D2B8 \BC1C\C0DD \C2DC \B3D9\C801 \C791\C5C5\C774 \C2E4\D589\B418\B3C4\B85D \C815\C758\D558\C5EC \BC18\D658\B41C \D56D\BAA9 \AC12\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/session_state
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361248208719417603.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SESSION_STATE'
,p_display_name=>unistr('\C138\C158 \C0C1\D0DC \C9C0\C6B0\AE30')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SESSION_STATE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('&PRODUCT_NAME. \B0B4\C5D0 \C800\C7A5\B41C \C138\C158 \C0C1\D0DC\B97C \C9C0\C6B0\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361248525085440449.4419)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CLEAR_CACHE_CURRENT_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C9C0\C6B0\B824\B294 \C138\C158 \C0C1\D0DC \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361259116722915252.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4419)
,p_display_sequence=>1
,p_display_value=>unistr('\D604\C7AC \D398\C774\C9C0\C758 \BAA8\B4E0 \D56D\BAA9 \C9C0\C6B0\AE30')
,p_return_value=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250412576446197.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4419)
,p_display_sequence=>3
,p_display_value=>unistr('\D398\C774\C9C0\C758 \BAA8\B4E0 \D56D\BAA9 \C9C0\C6B0\AE30')
,p_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250015380444942.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4419)
,p_display_sequence=>5
,p_display_value=>unistr('\D56D\BAA9 \C9C0\C6B0\AE30')
,p_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249617968443751.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4419)
,p_display_sequence=>7
,p_display_value=>unistr('\D604\C7AC \C138\C158 \C9C0\C6B0\AE30')
,p_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249219909442830.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4419)
,p_display_sequence=>9
,p_display_value=>unistr('\D604\C7AC \C560\D50C\B9AC\CF00\C774\C158 \C9C0\C6B0\AE30')
,p_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361248822065441760.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C9C0\C6B0\AE30')
,p_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361253232596482537.4419)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C560\D50C\B9AC\CF00\C774\C158')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_FLOWS'
,p_help_text=>unistr('\CF64\B9C8\B85C \AD6C\BD84\B41C \C560\D50C\B9AC\CF00\C774\C158 ID \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4. \C608: <code>100,101,105</code>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361254917715489399.4419)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\D56D\BAA9')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_ITEMS'
,p_help_text=>unistr('\C138\C158 \C0C1\D0DC\C5D0\C11C \C9C0\C6B0\B824\B294 \D398\C774\C9C0 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4. \C608: <code>P1_EMPNO,P1_ENAME</code>. \D56D\BAA9\C774 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \AC01 \D56D\BAA9 \C774\B984\C744 \CF64\B9C8\B85C \AD6C\BD84\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361255209304493322.4419)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\D398\C774\C9C0')
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_PAGES'
,p_help_text=>unistr('\CF64\B9C8\B85C \AD6C\BD84\B41C \D398\C774\C9C0 \BC88\D638 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4. \C608: <code>1,2,5</code>.')
);
end;
/
prompt --application/shared_components/plugins/process_type/reset_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361603521916198029.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'RESET_PAGINATION'
,p_display_name=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C7AC\C124\C815')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','RESET_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D604\C7AC \D398\C774\C9C0\C5D0\C11C \BCF4\ACE0\C11C \D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C744 \C7AC\C124\C815\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361603814800201390.4419)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B300\C0C1')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THIS_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\BAA8\B4E0 \D398\C774\C9C0, \C77C\BD80 \D398\C774\C9C0 \B610\B294 \D604\C7AC \D398\C774\C9C0\C5D0\C11C \D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C744 \C7AC\C124\C815\D574\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604111996202714.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C774 \D398\C774\C9C0')
,p_return_value=>'THIS_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604905742205597.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D398\C774\C9C0')
,p_return_value=>'PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604508330204363.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\BAA8\B4E0 \D398\C774\C9C0')
,p_return_value=>'ALL_PAGES'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361606225139211720.4419)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D398\C774\C9C0')
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361603814800201390.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGES'
,p_help_text=>unistr('\CF64\B9C8\B85C \AD6C\BD84\B41C \D398\C774\C9C0 \BC88\D638 \BAA9\B85D\C744 \C785\B825\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_add_rows
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361705302264974293.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_ADD_ROWS'
,p_display_name=>unistr('\D45C \D615\C2DD \D3FC - \D589 \CD94\AC00')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_ADD_ROWS'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\D45C \D615\C2DD \D3FC \C601\C5ED\C5D0 \D589\C744 \CD94\AC00\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361705527915977613.4419)
,p_plugin_id=>wwv_flow_api.id(361705302264974293.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D589 \C218')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_help_text=>unistr('\D589 \C218\B97C \C785\B825\D558\C2ED\C2DC\C624.')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_update
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361709604296657121.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_UPDATE'
,p_display_name=>unistr('\D45C \D615\C2DD \D3FC - \B2E4\C911 \D589 \C5C5\B370\C774\D2B8')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_UPDATE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\D45C \D615\C2DD \D3FC \C601\C5ED\C5D0\C11C \C5EC\B7EC \D589\C744 \C5C5\B370\C774\D2B8\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4. \C774 \D504\B85C\C138\C2A4\B294 \C601\C5ED\C5D0 \CD94\AC00\B41C \B808\CF54\B4DC\B3C4 \C0BD\C785\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361709824771662765.4419)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D14C\C774\BE14 \C18C\C720\C790')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\D14C\C774\BE14 \C18C\C720\C790(\C2A4\D0A4\B9C8) \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710119164665443.4419)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D14C\C774\BE14 \C774\B984')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361709824771662765.4419)
,p_help_text=>unistr('\B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\B294 \D14C\C774\BE14 \B610\B294 \BDF0 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710408812670214.4419)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\AE30\BCF8 \D0A4 \C5F4')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4419)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AE30\BCF8 \D0A4 \AC12\C774 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \B450 \BD80\BD84 \C774\C0C1\C758 \AE30\BCF8 \D0A4\AC00 \D3EC\D568\B41C \D14C\C774\BE14\C758 \ACBD\C6B0 <strong>ROWID</strong>\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\AE30\BCF8 \D0A4\B294 \C5C5\B370\C774\D2B8\D560 \D589\C744 \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\B418\BA70 \D45C \D615\C2DD \D3FC\C5D0\C11C \D3B8\C9D1\D560 \C218 \C5C6\C5B4\C57C \D569\B2C8\B2E4. \C0C8 \D589\C758 \ACBD\C6B0 \AE30\BCF8 \D0A4 \AC12\C774 \BE44\C5B4 \C788\C5B4\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710732738674350.4419)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\BCF4\C870 \D0A4 \C5F4')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4419)
,p_help_text=>unistr('\B450\BC88\C9F8 \AE30\BCF8 \D0A4 \AC12\C774 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C18D\C131\C740 \AE30\BCF8 \D0A4\AC00 \B450 \AC1C \C5F4\B85C \AD6C\C131\B41C \ACBD\C6B0\C5D0\B9CC \CC44\C6CC\C838\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361711421080694858.4419)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\B7F0\D0C0\C784 Where \C808')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2E4\C74C\C744 \C0AC\C6A9\D574\C11C \BD80\C11C\B97C \C81C\D55C\D569\B2C8\B2E4.'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('\C0DD\C131\B41C \BAA8\B4E0 INSERT \BC0F UPDATE \BB38\C5D0 \CD94\AC00\D560 SQL WHERE \C808\C744 \C785\B825\D569\B2C8\B2E4. \C790\B3D9 \C0DD\C131\B41C SQL \D638\CD9C\C5D0\C11C \C0AC\C6A9\B418\B294 \B808\CF54\B4DC\B97C \C81C\D55C\D558\B824\BA74 \C774 \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_fetch
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361799714569626543.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_FETCH'
,p_display_name=>unistr('\C790\B3D9 \D589 \C778\CD9C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_FETCH'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\B2E8\C77C \B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \B808\CF54\B4DC\B97C \AC80\C0C9\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4. \C774 \D504\B85C\C138\C2A4\B294 <strong>\B370\C774\D130\BCA0\C774\C2A4 \C5F4</strong> \C720\D615\C758 \C18C\C2A4\B97C \D3FC \D56D\BAA9\C5D0 \CC44\C6B0\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800032025633659.4419)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D14C\C774\BE14 \C18C\C720\C790')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\D14C\C774\BE14 \C18C\C720\C790(\C2A4\D0A4\B9C8) \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800327927635543.4419)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D14C\C774\BE14 \C774\B984')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800032025633659.4419)
,p_help_text=>unistr('\B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\B294 \D14C\C774\BE14 \B610\B294 \BDF0 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800622105638213.4419)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\AE30\BCF8 \D0A4 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\AE30\BCF8 \D0A4 \C5F4 \AC12\C744 \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
,p_attribute_comment=>'$$$ DJP - Pop-up LOV allows selection of Custom Page, Global Page, Application Items as well - Shouldn''t it only be Page Items?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800918654639837.4419)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>25
,p_prompt=>unistr('\AE30\BCF8 \D0A4 \C5F4 ')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4419)
,p_help_text=>unistr('\AE30\BCF8 \D0A4 \AC12\C774 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \B450 \BD80\BD84 \C774\C0C1\C758 \AE30\BCF8 \D0A4\AC00 \D3EC\D568\B41C \D14C\C774\BE14\C758 \ACBD\C6B0 <strong>ROWID</strong>\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801213910642088.4419)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\BCF4\C870 \D0A4 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361801505499645968.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\B450\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4 \AC12\C744 \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801505499645968.4419)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>40
,p_prompt=>unistr('\BCF4\C870 \D0A4 \C5F4')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4419)
,p_depending_on_attribute_id=>wwv_flow_api.id(361800918654639837.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('\B450\BC88\C9F8 \AE30\BCF8 \D0A4 \AC12\C774 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C18D\C131\C740 \AE30\BCF8 \D0A4\AC00 \B450 \AC1C \C5F4\B85C \AD6C\C131\B41C \ACBD\C6B0\C5D0\B9CC \CC44\C6CC\C838\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361805328759939092.4419)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\D589 \BC84\C804 \C5F4')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4419)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D589 \BC84\C804\C744 \C2DD\BCC4\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C5F4\C740 \D398\C774\C9C0\C5D0 \C788\C9C0 \C54A\C544\B3C4 \B429\B2C8\B2E4. \B0B4\C7A5\B41C \CCB4\D06C\C12C\C744 \C0AC\C6A9\D558\B824\BA74 \C774 \C18D\C131\C744 \BE44\C6CC\B461\B2C8\B2E4.</p>'),
unistr('<p>\B099\AD00\C801 \C7A0\AE08\C740 \B204\B77D\B41C \C5C5\B370\C774\D2B8 \AC10\C9C0\B97C \C0AC\C6A9\D574\C11C \B370\C774\D130\AC00 \B3D9\C2DC\C5D0 \C561\C138\C2A4\B420 \C218 \C788\B294 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \B370\C774\D130 \BB34\ACB0\C131\C744 \BCF4\C7A5\D569\B2C8\B2E4. &PRODUCT_NAME.\C740(\B294) \B0B4\C7A5\B41C \CCB4\D06C\C12C\C744 \C0AC\C6A9\D574\C11C \B204\B77D\B41C \C5C5\B370\C774\D2B8 \AC10\C9C0\B97C \C218\D589\D558\ACE0 \D589 \BC84\C804\C744 \D655\C778\D569\B2C8\B2E4. \CCB4\D06C\C12C\C740 \D2B9\C815 \D14C\C774\BE14 \D589\C5D0 \B300\D55C \BAA8\B4E0 \C5F4 \AC12\C758 \D574\C2DC \D568\C218\C785\B2C8\B2E4. \B808\CF54\B4DC\AC00 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \C9C8\C758\B420 \B54C \AC80\C0C9\B41C \D6C4, <em>\C790\B3D9 \D589 \D504\B85C\C138\C2F1</em> \C911\C5D0 \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C788\B294 \D604\C7AC \B808\CF54\B4DC\C758 \D574\C2DC\C640 \BE44\AD50\B429\B2C8\B2E4')
||unistr('. \B450 \AC12\C774 \B3D9\C77C\D558\BA74 \C5C5\B370\C774\D2B8\AC00 \ACC4\C18D \C218\D589\B418\ACE0, \ADF8\B807\C9C0 \C54A\C73C\BA74 \C790\B3D9 \D589 \D504\B85C\C138\C2F1\C5D0\C11C \C624\B958\AC00 \BC1C\C0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C18D\C131\C744 \C0AC\C6A9\D558\BA74 \B0B4\C7A5\B41C \CCB4\D06C\C12C \D504\B85C\C138\C2F1\C744 \C0AC\C6A9\D558\B294 \B300\C2E0 \D589 \BC84\C804\C744 \C800\C7A5\D558\B294 \B2E8\C77C \C5F4\C744 \C9C0\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \C5F4\C740 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \B808\CF54\B4DC\AC00 \C5C5\B370\C774\D2B8\B420 \B54C\B9C8\B2E4 \C5C5\B370\C774\D2B8\B418\C5B4\C57C \D569\B2C8\B2E4. Oracle\C740 \D589 \BC84\C804 \C5F4\C744 \C99D\BD84 \B610\B294 \C5C5\B370\C774\D2B8\D558\AE30 \C704\D574 \D14C\C774\BE14\C5D0\C11C ''\C5C5\B370\C774\D2B8 \C774\C804'' \B370\C774\D130\BCA0\C774\C2A4 \D2B8\B9AC\AC70\B97C \AD6C\D604\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4. NUMBER \C5F4\C740 \D589\C758 \C2DC\D000\C2A4 \BC88\D638\B97C \D3EC\D568\D55C\B2E4\ACE0 \AC00\C815\B429\B2C8\B2E4. \D558\C9C0\B9CC DATE \BC0F TIMESTAMP \C5F4\B3C4 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
||unistr(' \B2E8\C77C \C5F4\C744 \C0AC\C6A9\D560 \B54C\C758 \C7A5\C810\C740 &PRODUCT_NAME. \C5D4\C9C4\C774 \C804\CCB4 \D589\C758 \D574\C2DC\B97C \C218\D589\D560 \D544\C694\AC00 \C5C6\C73C\BA70, \B300\C2E0 \B2E8\C77C \C5F4 \AC12\C744 \BE44\AD50\D560 \C218 \C788\B2E4\B294 \AC83\C785\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361804814168854679.4419)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\B7F0\D0C0\C784 Where \C808')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2E4\C74C\C744 \C0AC\C6A9\D574\C11C \BD80\C11C\B97C \C81C\D55C\D569\B2C8\B2E4.'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('\C0DD\C131\B41C SELECT \BB38\C5D0 \CD94\AC00\D560 SQL WHERE \C808\C744 \C785\B825\D569\B2C8\B2E4. \C790\B3D9 \C0DD\C131\B41C SQL \D638\CD9C\C5D0\C11C \C0AC\C6A9\B418\B294 \B808\CF54\B4DC\B97C \C81C\D55C\D558\B824\BA74 \C774 \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361802100261724338.4419)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\C778\CD9C \BAA8\B4DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'D'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\C774 \C635\C158\C740 \C5ED \D638\D658\C131\C744 \C704\D574\C11C\B9CC \C874\C7AC\D569\B2C8\B2E4.'),
unistr('\C0C8\B85C\C6B4 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C\B294 \C774 \C124\C815\C744 \D56D\C0C1 \BE44\C6CC \B450\C5B4\C57C \D569\B2C8\B2E4.'),
unistr('"\D45C\C2DC \C2DC \BA54\BAA8\B9AC \CE90\C2DC \C124\C815" \C635\C158\C740 \B354 \C774\C0C1 \C0AC\C6A9\B418\C9C0 \C54A\C73C\BA70 \C774 \B9B4\B9AC\C2A4\C758 &PRODUCT_NAME.\C5D0\C11C \C0DD\C131\B41C \D504\B85C\C138\C2A4\C5D0\C11C \C0AC\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.'),
'</p>',
'<p>',
unistr('\C790\B3D9 \D589 \C778\CD9C \D504\B85C\C138\C2A4\AC00 \D589\C744 \C120\D0DD\D558\BA74 \D574\B2F9 \D398\C774\C9C0 \D56D\BAA9\C774 \C778\CD9C\B41C \C5F4 \AC12\C73C\B85C \C124\C815\B429\B2C8\B2E4. DML \C778\CD9C \BAA8\B4DC \C124\C815\C5D0 \B530\B77C \C778\CD9C \C2DC\C810\C774 \ACB0\C815\B429\B2C8\B2E4. \AE30\BCF8 \BAA8\B4DC\C5D0\C11C\B294 \D589\C774 \C778\CD9C\B420 \B54C \C989\C2DC \C778\BA54\BAA8\B9AC \C138\C158 \C0C1\D0DC\B97C \C5C5\B370\C774\D2B8\D569\B2C8\B2E4. ''\D45C\C2DC \C2DC \BA54\BAA8\B9AC \CE90\C2DC \C124\C815'' \BAA8\B4DC\C5D0\C11C\B294 \D56D\BAA9\C774 \B80C\B354\B9C1\B420 \B54C\B9CC \C774 \C138\C158 \C0C1\D0DC\B97C \C5C5\B370\C774\D2B8\D569\B2C8\B2E4. \D589 \C778\CD9C \C2DC\AC04\ACFC \D56D\BAA9 \B80C\B354\B9C1 \C2DC\AC04 \C0AC\C774\C5D0 \BC14\C778\B4DC \BCC0\C218 \B610\B294 <code>v(''ITEM_NAME'')</code> \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC \C778\CD9C\B41C ')
||unistr('\D56D\BAA9 \AC12\C744 \CC38\C870\D574\C57C \D560 \ACBD\C6B0, \AE30\BCF8 \C778\CD9C \BAA8\B4DC\B97C \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4. \C0C8\B85C\C6B4 \C790\B3D9 \D589 \C778\CD9C \D504\B85C\C138\C2A4\B97C \C0DD\C131\D560 \ACBD\C6B0 \D574\B2F9 \C778\CD9C \BAA8\B4DC\B294 \C774 \AE30\BCF8 \BAA8\B4DC\B85C \C124\C815\B429\B2C8\B2E4. \D398\C774\C9C0 \B17C\B9AC\AC00 "\D45C\C2DC \C2DC" \B3D9\C791\C5D0 \C758\C874\D558\ACE0 \C788\C9C0 \C54A\B2E4\BA74 \CD5C\B300\D55C \C720\C5F0\D558\AC8C \D398\C774\C9C0\AC00 \B80C\B354\B9C1\B418\B294 \B3D9\C548 \C778\CD9C\B41C \C5F4 \AC12\C744 \CC38\C870\D560 \C218 \C788\B3C4\B85D \AE30\BCF8 \B3D9\C791\C744 \C0AC\C6A9\D558\B3C4\B85D \C774 \D504\B85C\C138\C2A4\B97C \C5C5\B370\C774\D2B8\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.'),
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361803025912727611.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(361802100261724338.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D45C\C2DC \C2DC \BA54\BAA8\B9AC \CE90\C2DC \C124\C815 [\C0AC\C6A9\B418\C9C0 \C54A\C74C]')
,p_return_value=>'D'
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361898027238424612.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE'
,p_display_name=>unistr('\C6F9 \C11C\BE44\C2A4')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C9C0\C815\B41C \C6F9 \C11C\BE44\C2A4\B97C \C0AC\C6A9\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361898312142431520.4419)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C6F9 \C11C\BE44\C2A4 \C791\C5C5')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_translatable=>false
,p_lov_type=>'COMPONENT'
,p_lov_component_type_id=>3541
,p_help_text=>unistr('\C6F9 \C11C\BE44\C2A4 \C791\C5C5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703289302749886160.4419)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\ACB0\ACFC \C800\C7A5 \C704\CE58')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703289611172888366.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D56D\BAA9')
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703290033944889185.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\BAA8\C74C')
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703290641370900883.4419)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\BAA8\C74C \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(703289302749886160.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362034004386015380.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PAGINATION'
,p_display_name=>unistr('\D3FC \D398\C774\C9C0 \BC88\D638 \B9E4\AE40')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14 \B610\B294 \BDF0\C5D0\C11C \C774\C804 \B610\B294 \B2E4\C74C \B808\CF54\B4DC\B97C \AC80\C0C9\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4. \C774 \D504\B85C\C138\C2A4\B97C \C0AC\C6A9\D558\BA74 \D3FC \D398\C774\C9C0\C5D0 \D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C744 \C81C\ACF5\D560 \C218 \C788\C73C\BBC0\B85C \C77C\BC18 \C0AC\C6A9\C790\AC00 \BCF4\ACE0\C11C\B85C \B2E4\C2DC \C774\B3D9\D558\C9C0 \C54A\C544\B3C4 \C774\C804 \B610\B294 \B2E4\C74C \B808\CF54\B4DC\B97C \AC80\C0C9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: \D3FC\C5D0\C11C \B370\C774\D130 \C5C5\B370\C774\D2B8\AC00 \D5C8\C6A9\B418\B294 \ACBD\C6B0\C5D0\B294 \C77C\BC18\C801\C73C\B85C \C774 \D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \D504\B85C\C138\C2A4\B97C \C2E4\D589\D558\AE30 \C804\C5D0 \C801\D569\D55C \D3FC \CC98\B9AC\AC00 \C218\D589\B418\B294\C9C0 \D655\C778\D574\C57C \D569\B2C8\B2E4. \ADF8\B807\C9C0 \C54A\C73C\BA74 \C77C\BC18 \C0AC\C6A9\C790\AC00 \B2E4\B978 \B808\CF54\B4DC\B85C \C774\B3D9\D560 \B54C \C774\C804\C5D0 \C5C5\B370\C774\D2B8\D55C \D56D\BAA9\C774 \C190\C2E4\B429\B2C8\B2E4.</em></p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034324862021077.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D14C\C774\BE14 \C18C\C720\C790')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\D14C\C774\BE14 \C18C\C720\C790(\C2A4\D0A4\B9C8) \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034618176024149.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D14C\C774\BE14 \C774\B984')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034324862021077.4419)
,p_help_text=>unistr('\B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\B294 \D14C\C774\BE14 \B610\B294 \BDF0 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035122261037451.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\AE30\BCF8 \D0A4 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\AE30\BCF8 \D0A4 \C5F4 \AC12\C744 \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035415360040649.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('\AE30\BCF8 \D0A4 \C5F4')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_default_value=>'ROWID'
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4419)
,p_help_text=>unistr('\AE30\BCF8 \D0A4 \AC12\C774 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \B450 \BD80\BD84 \C774\C0C1\C758 \AE30\BCF8 \D0A4\AC00 \D3EC\D568\B41C \D14C\C774\BE14\C758 \ACBD\C6B0 <strong>ROWID</strong>\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035708675043722.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('\BCF4\C870 \D0A4 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\B450\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4 \AC12\C744 \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362036002636046567.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('\BCF4\C870 \D0A4 \C5F4')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4419)
,p_depending_on_attribute_id=>wwv_flow_api.id(362035415360040649.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('\B450\BC88\C9F8 \AE30\BCF8 \D0A4 \AC12\C774 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C18D\C131\C740 \AE30\BCF8 \D0A4\AC00 \B450 \AC1C \C5F4\B85C \AD6C\C131\B41C \ACBD\C6B0\C5D0\B9CC \CC44\C6CC\C838\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362067915033505841.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\D0D0\C0C9 \C21C\C11C \C5F4')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4419)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D0D0\C0C9 \C21C\C11C \AC12\C774 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C5F4\C740 \C774\C804 \BC0F \B2E4\C74C \D589\C744 \D655\C778\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4. \B530\B77C\C11C <code>DISPLAY_SEQ</code>\C640 \AC19\C740 \C5F4\C744 \C0AC\C6A9\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4. \C0DD\C131\B41C \C21C\C11C\B300\B85C \B808\CF54\B4DC\B97C \C815\B82C\D558\B824\BA74 \C2DC\D000\C2A4\B85C\BD80\D130 \B610\B294 Oracle Database 12<em>c</em> ID \C5F4\C744 \AE30\BC18\C73C\B85C \CC44\C6B8 \B54C <code>CREATED</code> \B610\B294 <code>ID</code>\C640 \AC19\C740 \C5F4\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \D558\C9C0\B9CC <code>JOB</code> \BC0F <code>DEPT')
||unistr('NO</code>\C640 \AC19\C774 \C5B4\B5A0\D55C \B450 \C5F4\C5D0\C11C\B3C4 \B808\CF54\B4DC\B97C \C720\C5F0\D558\AC8C \C815\B82C\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: \D0D0\C0C9 \C21C\C11C \C5F4\C740 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \D3FC\C5D0 \C5F0\ACB0\D558\AE30 \C704\D574 \D0D0\C0C9\D55C \BCF4\ACE0\C11C\B97C \C815\B82C\D558\B294 \B370 \C0AC\C6A9\B418\B294 \AE30\BCF8 \C5F4\ACFC \C77C\CE58\D574\C57C \D569\B2C8\B2E4. \B610\B294 \B2E8\CD94 \B808\C774\BE14 \B610\B294 \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8\B97C \C0AC\C6A9\D574\C11C \C774\C804 \BC0F \B2E4\C74C \D589\C758 \D655\C778 \BC29\BC95\C744 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C774\D574\D560 \C218 \C788\B3C4\B85D \D574\C57C \D569\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068209426508489.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\BCF4\C870 \D0D0\C0C9 \C21C\C11C \C5F4')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4419)
,p_help_text=>unistr('\B450\BC88\C9F8 \D0D0\C0C9 \C21C\C11C \AC12\C774 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C18D\C131\C740 \D0D0\C0C9 \D0A4\AC00 \B450 \AC1C \C5F4\B85C \AD6C\C131\B41C \ACBD\C6B0\C5D0\B9CC \CC44\C6CC\C838\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068730117514082.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\B2E4\C74C \AE30\BCF8 \D0A4 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('<em>\B2E4\C74C</em> \B808\CF54\B4DC\C5D0 \B300\D55C \AE30\BCF8 \D0A4 \C5F4 \AC12\C744 \C800\C7A5\D558\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069024510516623.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\C774\C804 \AE30\BCF8 \D0A4 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('<em>\C774\C804</em> \B808\CF54\B4DC\C5D0 \B300\D55C \AE30\BCF8 \D0A4 \C5F4 \AC12\C744 \C800\C7A5\D558\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069318687519376.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\B2E4\C74C \BCF4\C870 \D0A4 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('<em>\B2E4\C74C</em> \B808\CF54\B4DC\C5D0 \B300\D55C \B450\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4 \AC12\C744 \C800\C7A5\D558\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069614158521442.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\C774\C804 \BCF4\C870 \D0A4 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('<em>\C774\C804</em> \B808\CF54\B4DC\C5D0 \B300\D55C \B450\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4 \AC12\C744 \C800\C7A5\D558\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070100572527702.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\D604\C7AC \D589 \C218 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CD1D \B808\CF54\B4DC \C218 \AC12\C744 \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\ACB0\ACFC \C9D1\D569\C5D0 10,000\AC1C\AC00 \B118\B294 \D589\C774 \D3EC\D568\B418\C5B4 \C788\C744 \ACBD\C6B0 \C774 \D56D\BAA9\C744 \C815\C758\D558\BA74 \C131\B2A5\C774 \C800\D558\B420 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070418675534553.4419)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\B7F0\D0C0\C784 Where \C808')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'deptno = :P1_DEPTNO',
'</pre>'))
,p_help_text=>unistr('\C9C8\C758\C5D0\C11C \BC18\D658\B418\B294 \B808\CF54\B4DC\B97C \C81C\D55C\D558\AE30 \C704\D55C SQL \BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362310022409142749.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE_LEGACY'
,p_display_name=>unistr('\B808\AC70\C2DC \C6F9 \C11C\BE44\C2A4')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\C9C0\C815\B41C \C6F9 \C11C\BE44\C2A4\B97C \C0AC\C6A9\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4. Oracle\C740 \C774 \D504\B85C\C138\C2A4\B97C <strong>\C6F9 \C11C\BE44\C2A4</strong>\B85C \C5C5\B370\C774\D2B8\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362310307960149400.4419)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C6F9 \C11C\BE44\C2A4 \CC38\C870')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C6F9 \C11C\BE44\C2A4 \CC38\C870 \BC88\D638\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704862682583352671.4419)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\ACB0\ACFC \C800\C7A5 \C704\CE58')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704862979987353733.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D56D\BAA9')
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704863378280354870.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\BAA8\C74C')
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704864081757360262.4419)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\BAA8\C74C \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(704862682583352671.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/textarea
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(376364131288521442.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXTAREA'
,p_display_name=>unistr('\D14D\C2A4\D2B8 \C601\C5ED')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXTAREA'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\B2E4\C911 \D589 \D14D\C2A4\D2B8 \C601\C5ED\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376904739508510313.4419)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D06C\AE30 \C870\C815 \AC00\B2A5')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\B9C8\C6B0\C2A4\B97C \C0AC\C6A9\D55C \D14D\C2A4\D2B8 \C601\C5ED \D06C\AE30 \C870\C815\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905227172516182.4419)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C790\B3D9 \B192\C774')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\D14D\C2A4\D2B8 \C601\C5ED\C758 \B192\C774\AC00 \D45C\C2DC\B41C \D14D\C2A4\D2B8 \C591\C5D0 \B530\B77C \B2EC\B77C\C9C0\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \B370\C774\D130 \C591\C5D0 \B9DE\AC8C \D14D\C2A4\D2B8 \C601\C5ED \D06C\AE30\B97C \C870\C815\D558\B824\BA74 \C774 \C635\C158\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905734098518181.4419)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\BB38\C790 \CE74\C6B4\D130')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\D14D\C2A4\D2B8 \C601\C5ED \C544\B798\C5D0 \CE74\C6B4\D130\AC00 \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \CE74\C6B4\D130\C5D0\B294 \D544\B4DC\C5D0 \C785\B825\B41C \BB38\C790 \C218 \BC0F \D5C8\C6A9\B418\B294 \CD1D \BB38\C790 \C218\AC00 \D45C\C2DC\B429\B2C8\B2E4(\C608: <code>123 of 4000</code>). \C124\C815\D560 \ACBD\C6B0 \CD5C\B300 \AE38\C774 \C18D\C131\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362202612251785897.4419)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\ACF5\AC04 \C790\B974\AE30')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D398\C774\C9C0 \C81C\CD9C \D6C4 \D56D\BAA9 \AC12\C744 \C790\B974\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C124\C815\C740 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0\C11C \ACF5\BC31, \D0ED \BC0F \C904\BC14\AFC8\C744 \C790\B985\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362202910095786913.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C120\D589')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203307938787882.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D6C4\D589')
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203705781788933.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C120\D589 \BC0F \D6C4\D589')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362204104056789676.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\C5C6\C74C')
,p_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/plugins/region_type/sql_report
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380028817628072908.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SQL_REPORT'
,p_display_name=>unistr('\D074\B798\C2DD \BCF4\ACE0\C11C')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SQL_REPORT'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('SQL \C9C8\C758\B97C \AE30\C900\C73C\B85C \AC04\C18C\D654\B41C \BCF4\ACE0\C11C\C785\B2C8\B2E4. \D074\B798\C2DD \BCF4\ACE0\C11C\B294 \B300\D654\C2DD \BCF4\ACE0\C11C\C640 \BE44\C2B7\D558\C9C0\B9CC \B300\D654\C2DD \BCF4\ACE0\C11C\C5D0\C11C \C81C\ACF5\B418\B294 \B2E4\C591\D55C \C77C\BC18 \C0AC\C6A9\C790 \C0AC\C6A9\C790\C815\C758 \C635\C158\C744 \D3EC\D568\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234584057047894023.4419)
,p_plugin_id=>wwv_flow_api.id(380028817628072908.4419)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/tabform
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380029119558081299.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TABFORM'
,p_display_name=>unistr('\D45C \D615\C2DD \D3FC')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TABFORM'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \ADF8\B9AC\B4DC \C694\C18C \C548\C5D0\C11C \C9C1\C811 \AC12\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C788\B294 \ADF8\B9AC\B4DC \B808\C774\C544\C6C3\C5D0 \C5EC\B7EC \B370\C774\D130 \D589\C744 \D45C\C2DC\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153406632834485.4419)
,p_plugin_id=>wwv_flow_api.id(380029119558081299.4419)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/ir
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380454112071587884.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IR'
,p_display_name=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IR'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BCF4\ACE0\C11C \B808\C774\C544\C6C3\C744 \B7F0\D0C0\C784\C5D0 \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\B294 \B2E4\C591\D55C \AE30\B2A5\C744 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \C81C\ACF5\D558\B294 SQL \C9C8\C758 \AE30\BC18\C758 \D3EC\AD04\C801\C778 \C628\B77C\C778 \BCF4\ACE0\C11C\C785\B2C8\B2E4. \C5EC\B7EC \BCF4\ACE0\C11C \C0AC\C6A9\C790\C815\C758 \C635\C158\C744 \C0AC\C6A9 \B610\B294 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D558\C5EC \C77C\BC18 \C0AC\C6A9\C790 \AE30\B2A5\C744 \C81C\C5B4\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\C758 \D2B9\C815 \BCF4\ACE0 \C694\AD6C\C0AC\D56D\C744 \CDA9\C871\D558\AE30 \C704\D574 \C5EC\B7EC \AC00\C9C0 \C870\AC74\C744 \D3EC\D568\D558\B294 \C5EC\B7EC \AC1C\C758 \BE44\C2B7\D55C \BCF4\ACE0\C11C\B97C \AC1C\BC1C\D560 \D544\C694 \C5C6\C774 \B2E8\C77C \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C815\C758\D558\ACE0 \D2B9\C815 \BCF4\ACE0 \C694\AD6C\C0AC\D56D\C744 \CDA9\C871\D558\AE30 \C704\D574 \C77C\BC18 \C0AC\C6A9\C790\AC00 \B370\C774\D130 \D45C\C2DC\B97C \C870\C791\D560 \C218 \C788\B3C4\B85D \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1831648887398980457.4419)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C791\C5C5 \BA54\B274 \AD6C\C870')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IG'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C791\C5C5 \BA54\B274 \AD6C\C870\AC00 \B300\D654\C2DD \ADF8\B9AC\B4DC \AD6C\C131\C694\C18C\C640 \C77C\CE58\D558\B294\C9C0 \C5EC\BD80, \B610\B294 \B808\AC70\C2DC \AD6C\C870\B97C \C0AC\C6A9\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831649884271983182.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\B808\AC70\C2DC')
,p_return_value=>'LEGACY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831650362309985149.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC')
,p_return_value=>'IG'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234862891586787752.4419)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4419)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/static
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(384582062506273077.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'STATIC'
,p_display_name=>unistr('\C815\C801 \CF58\D150\CE20')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','STATIC'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\D398\C774\C9C0 \D56D\BAA9\C5D0 \B300\D55C \C601\C5ED \CEE8\D14C\C774\B108 \B610\B294 \D14D\C2A4\D2B8 \CF58\D150\CE20\B97C \D45C\C2DC\D569\B2C8\B2E4. HTML \B9C8\D06C\C5C5\C744 \CD9C\B825\D558\ACE0 \CF58\D150\CE20\AC00 \C774\C2A4\CF00\C774\D504 \CC98\B9AC\B418\C9C0 \C54A\B3C4\B85D \D558\B824\BA74 <em>\CD9C\B825 \D615\C2DD</em>\C744 <strong>HTML</strong>\B85C \C124\C815\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(384582415870309214.4419)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>30
,p_prompt=>unistr('\BC14\B85C\AC00\AE30 \D655\C7A5')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_help_text=>unistr('&PRODUCT_NAME.\C774(\AC00) HTML \BCF8\BB38\C5D0\C11C \BC14\B85C\AC00\AE30\B97C \D655\C7A5\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481599132721933414.4419)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\CD9C\B825 \D615\C2DD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D14D\C2A4\D2B8 \CF58\D150\CE20\C758 \CD9C\B825 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481599442113934184.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D14D\C2A4\D2B8(\C774\C2A4\CF00\C774\D504 \D2B9\C218 \BB38\C790)')
,p_return_value=>'TEXT'
,p_help_text=>unistr('&PRODUCT_NAME.\C740(\B294) \C601\C5ED \C18C\C2A4\B97C \B0B4\BCF4\B0BC \B54C \D2B9\C218 HTML \BB38\C790(\C608: <code>"<", ">", "&"</code>)\B97C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481600445121939808.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4419)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('&PRODUCT_NAME.\C740(\B294) \C601\C5ED \C18C\C2A4\B97C \B0B4\BCF4\B0BC \B54C HTML \B9C8\D06C\C5C5\C744 \D3EC\D568\D569\B2C8\B2E4. \C774\B807\AC8C \D558\BA74 \C601\C5ED\C774 \C0AC\C774\D2B8\AC04 \C2A4\D06C\B9BD\D305\C5D0 \CDE8\C57D\D574\C9C8 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481600813887948606.4419)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('\C904 \BC14\AFC8 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('\C601\C5ED \C18C\C2A4\C758 \C904 \BC14\AFC8\C73C\B85C \C778\D574 \C601\C5ED \CD9C\B825\C5D0\C11C\B3C4 \C904 \BC14\AFC8\C774 \C801\C6A9\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(105618485369724390.4419)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4419)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385049040242438541.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('PL/SQL \B3D9\C801 \CF58\D150\CE20')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_PLSQL'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('PL/SQL \CF54\B4DC\C5D0\C11C HTML \CD9C\B825\C744 \D45C\C2DC\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153863368834496.4419)
,p_plugin_id=>wwv_flow_api.id(385049040242438541.4419)
,p_name=>'SOURCE_PLSQL'
);
end;
/
prompt --application/shared_components/plugins/region_type/svg_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385104627384108788.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SVG_CHART'
,p_display_name=>unistr('SVG \CC28\D2B8')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SVG_CHART'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\B370\C774\D130\B97C SVG \CC28\D2B8\C5D0 \D45C\C2DC\D569\B2C8\B2E4. \C774 \C601\C5ED \C720\D615\C740 \B354 \C774\C0C1 \C0AC\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \C0C8 \CC28\D2B8 \C601\C5ED\C5D0 \B300\D574\C11C\B294 <em>\CC28\D2B8</em> \C601\C5ED\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624. Oracle\C740 <em>\C5C5\ADF8\B808\C774\B4DC \C560\D50C\B9AC\CF00\C774\C158</em>\C744 \C0AC\C6A9\D574\C11C \C774\B7EC\D55C \C601\C5ED\C744 \C0C1\C751\D558\B294 \CC28\D2B8 \C601\C5ED\C73C\B85C \C5C5\B370\C774\D2B8\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153953839834498.4419)
,p_plugin_id=>wwv_flow_api.id(385104627384108788.4419)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/simple_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385106170962146118.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SIMPLE_CHART'
,p_display_name=>unistr('\AC04\B2E8\D55C \CC28\D2B8')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SIMPLE_CHART'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\B370\C774\D130\B97C HTML \CC28\D2B8\C5D0 \D45C\C2DC\D569\B2C8\B2E4. \C774 \C601\C5ED \C720\D615\C740 \B354 \C774\C0C1 \C0AC\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \C0C8 \CC28\D2B8 \C601\C5ED\C5D0 \B300\D574\C11C\B294 <em>\CC28\D2B8</em> \C601\C5ED\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624. Oracle\C740 <em>\C5C5\ADF8\B808\C774\B4DC \C560\D50C\B9AC\CF00\C774\C158</em>\C744 \C0AC\C6A9\D574\C11C \C774\B7EC\D55C \C601\C5ED\C744 \C0C1\C751\D558\B294 \CC28\D2B8 \C601\C5ED\C73C\B85C \C5C5\B370\C774\D2B8\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jstree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385504073407123938.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JSTREE'
,p_display_name=>unistr('\D2B8\B9AC')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JSTREE'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\B808\CF54\B4DC \C0AC\C774\C758 \C0C1\C704-\D558\C704 \AD00\ACC4\B97C \AE30\C900\C73C\B85C \ACC4\CE35 \AD6C\C870\B85C \B370\C774\D130\B97C \D45C\C2DC\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388222674242760077.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>450
,p_prompt=>unistr('\B178\B4DC \B9C1\D06C \D65C\C131\D654')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\D2B8\B9AC\C758 \B178\B4DC \B9C1\D06C\B97C \D65C\C131\D654\D558\B294 \B370 \D544\C694\D55C \C791\C5C5\C744 \C120\D0DD\D569\B2C8\B2E4. \D2B8\B9AC\B294 \C8FC\B85C \C120\D0DD/\D45C\C2DC \B610\B294 \D0D0\C0C9\C5D0 \C0AC\C6A9\B420 \C218 \C788\C2B5\B2C8\B2E4. \C120\D0DD\ACFC \D0D0\C0C9\C5D0 \BAA8\B450 \C0AC\C6A9\B418\B294 \ACBD\C6B0 [\B354\BE14\D074\B9AD]\C73C\B85C \C124\C815\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4. \ADF8\B7EC\BA74 \C2F1\AE00\D074\B9AD\C740 \B178\B4DC\B97C \C120\D0DD\D558\AE30\B9CC \D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388222945238760981.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C2F1\AE00\D074\B9AD')
,p_return_value=>'S'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388223328719761701.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\B354\BE14\D074\B9AD')
,p_return_value=>'D'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388223746905766372.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>600
,p_prompt=>unistr('\C120\D0DD\B41C \B178\B4DC \D398\C774\C9C0 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715830565095726781.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C120\D0DD\B41C \B178\B4DC \AC12\C744 \C800\C7A5\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774 \D56D\BAA9\C740 \B9C8\C9C0\B9C9\C73C\B85C \C120\D0DD\B41C \B178\B4DC\C758 \AC12\C744 \C800\C7A5\D558\C5EC \D2B8\B9AC \C0C1\D0DC\B97C \C800\C7A5\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4. \C120\D0DD\B41C \B178\B4DC\C758 \AC12\C740 \B178\B4DC \B9C1\D06C \C18D\C131 \B610\B294 \D398\C774\C9C0 \D504\B85C\C138\C2A4\B97C \D1B5\D574 \C120\D0DD\B41C \D56D\BAA9\C5D0 \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4. \D398\C774\C9C0\AC00 \B2E4\C2DC \B85C\B4DC\B418\BA74 \C120\D0DD\B41C \B178\B4DC \AC12\C73C\B85C \D2B8\B9AC\AC00 \C5F4\B9BD\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388224056018770786.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>400
,p_prompt=>unistr('\B3C4\AD6C \C124\BA85')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\B3C4\AD6C \C124\BA85\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80 \BC0F \B3C4\AD6C \C124\BA85\C758 \C18C\C2A4\B97C \C120\D0DD\D569\B2C8\B2E4. \B3C4\AD6C \C124\BA85\C774 \C815\C758\B41C \ACBD\C6B0 \C77C\BC18 \C0AC\C6A9\C790\AC00 \D3EC\CEE4\C2A4\B97C \C124\C815\D558\AC70\B098 \D2B8\B9AC \B178\B4DC \B808\C774\BE14 \C704\B85C \CEE4\C11C\B97C \AC00\C838\AC08 \B54C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224310716771380.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C5C6\C74C')
,p_return_value=>'N'
,p_help_text=>unistr('\B3C4\AD6C \C124\BA85\C774 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224757018772639.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\B808\AC70\C2DC \D15C\D50C\B9AC\D2B8')
,p_return_value=>'STATIC'
,p_is_deprecated=>true
,p_help_text=>unistr('\B370\C774\D130 \C18C\C2A4 \C5F4 \B300\CCB4(#VALUE#, #TITLE#, #LINK# \BC0F #TOOLTIP#)\C640 \D568\AED8 \C815\C801 \B3C4\AD6C \C124\BA85 \AC12 \C0AC\C6A9')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715829871157706251.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4419)
,p_display_sequence=>30
,p_display_value=>unistr('HTML \D45C\D604\C2DD')
,p_return_value=>'TEMPLATE'
,p_help_text=>unistr('\B3C4\AD6C \C124\BA85\C73C\B85C \C0AC\C6A9\D560 HTML \D45C\D604\C2DD\C744 \C81C\ACF5\D569\B2C8\B2E4. \B300\CCB4\AC00 \C218\D589\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388225194623774797.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C5F4')
,p_return_value=>'DB'
,p_help_text=>unistr('<strong>\B3C4\AD6C \C124\BA85 \C5F4</strong>\C758 \AC12\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388225546559783958.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>410
,p_prompt=>unistr('\B3C4\AD6C \C124\BA85 \AC12')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STATIC,TEMPLATE'
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \D2B8\B9AC \C694\C18C \C704\B85C \CEE4\C11C\B97C \AC00\C838\AC08 \B54C \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388410177919650647.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>900
,p_prompt=>unistr('\C815\C801 \D2B8\B9AC ID')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_deprecated_values=>'$NOT_NULL$'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D2B8\B9AC\C5D0 \B300\D55C \C120\D0DD\C801 \ACE0\C720 \C2DD\BCC4\C790\C785\B2C8\B2E4.</p>'),
unistr('<p>\C601\C5ED\C5D0 \C815\C801 ID\B97C \C9C0\C815\D558\ACE0 apex.region("<i>static-id</i>").widget() API\B97C \C0AC\C6A9\D558\C5EC \D2B8\B9AC \C694\C18C\C5D0 \C561\C138\C2A4\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1397688173262880316.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>520
,p_prompt=>unistr('\C544\C774\CF58 \C720\D615 CSS \D074\B798\C2A4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'a-Icon'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>'fa'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BAA8\B4E0 \B178\B4DC\C5D0 \C0AC\C6A9\B420 \C544\C774\CF58 \C720\D615\C744 \C9C0\C815\D558\B294 \B370 \C0AC\C6A9\B418\B294 CSS \D074\B798\C2A4\C785\B2C8\B2E4. \C774 \D074\B798\C2A4\B294 CSS \ADDC\CE59\C5D0\C11C \D574\B2F9 \C720\D615\C758 \BAA8\B4E0 \C544\C774\CF58\C5D0 \B300\D55C \C18D\C131\C744 \C9C0\C815\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4. \C601\C5ED \C18C\C2A4\C758 \C544\C774\CF58 \C5F4 \AC12 \BC0F \C544\C774\CF58 \C720\D615\C5D0 \B530\B77C \AC01 \B178\B4DC\C5D0 \C0AC\C6A9\B418\B294 \C544\C774\CF58 CSS \D074\B798\C2A4\AC00 \ACB0\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>\C77C\BC18\C801\C778 \AC12\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<ul>',
unistr('<li><strong><code>a-Icon</code></strong>: \C774 \AC12\C744 \C9C0\C815\D558\BA74 <code>icon-circle</code> \B610\B294 <code>icon-tree-folder</code>\C640 \AC19\C740 \C801\C740 \C218\C758 \B0B4\C7A5 APEX \C544\C774\CF58\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong><code>fa</code></strong>: \C774 \AC12\C744 \C9C0\C815\D558\BA74 \AE00\AF34 APEX \B610\B294 Font Awesome \C544\C774\CF58\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \BC94\C6A9 \D14C\B9C8\B97C \C0AC\C6A9\D558\BA74 \D574\B2F9 \C544\C774\CF58 \B77C\C774\BE0C\B7EC\B9AC \C911 \D558\B098\AC00 \C0AC\C6A9 \AC00\B2A5\D558\B3C4\B85D \C124\C815\B429\B2C8\B2E4.</li>'),
'</ul>',
unistr('<p>\AC12\C744 \C9C0\C815\D558\C9C0 \C54A\C744 \ACBD\C6B0 \C544\C774\CF58 \C720\D615\C774 \C9C0\C815\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \D544\C694\D55C \ACBD\C6B0 \C544\C774\CF58 \C720\D615 CSS \D074\B798\C2A4\B97C \C544\C774\CF58 \C5F4\C5D0 \D3EC\D568\D560 \C218 \C788\C2B5\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \C544\C774\CF58 \C5F4 \AC12\C774 "fa fa-user"\C77C \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C544\C774\CF58\C774 \C5C6\B294 \D2B8\B9AC\C758 \ACBD\C6B0 \C544\C774\CF58 \C720\D615 \BC0F \AE30\BCF8 \C544\C774\CF58 \C18D\C131\C744 \ACF5\BC31\C73C\B85C \C124\C815\D569\B2C8\B2E4. \B610\D55C SQL \C9C8\C758 \C18C\C2A4\C5D0\C11C \C544\C774\CF58 \C5F4\C774 \B110\C774\C5B4\C57C \D569\B2C8\B2E4.'),
unistr('\C0AC\C6A9\C790\C815\C758 \D14C\B9C8\B098 \D0C0\C0AC \D14C\B9C8\B294 \ACE0\C720\C758 \AE00\AF34 \B610\B294 CSS \C2A4\D504\B77C\C774\D2B8 \C544\C774\CF58 \B77C\C774\BE0C\B7EC\B9AC\B97C \D3EC\D568\D560 \C218 \C788\C73C\BA70 \C5EC\AE30\C11C \C9C0\C815 \AC00\B2A5\D55C \C5EC\B7EC \C544\C774\CF58 \C720\D615/\C811\B450\C5B4 \D074\B798\C2A4\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388198764505202174.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>510
,p_prompt=>unistr('\AE30\BCF8 \C544\C774\CF58 CSS \D074\B798\C2A4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'icon-tree-folder'
,p_is_translatable=>false
,p_examples=>unistr('<p>\C544\C774\CF58 \C720\D615\C774 \AE00\AF34 APEX\B97C \B098\D0C0\B0B4\B294 <code>fa</code>\C778 \ACBD\C6B0 <code>fa-user-circle-o</code>, <code>fa-file-o</code> \B610\B294 <code>fa-arrow-circle-right</code>\C640 \AC19\C740 \AC12\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \BAA8\B4E0 \C544\C774\CF58 \BAA9\B85D\C740 \BC94\C6A9 \D14C\B9C8 \C571\C744 \CC38\C870\D558\C2ED\C2DC\C624.</p>')
,p_help_text=>unistr('SQL \C9C8\C758 \C544\C774\CF58 \C5F4\C774 \B110\C77C \ACBD\C6B0 \C0AC\C6A9\D560 \AE30\BCF8 \C544\C774\CF58\C785\B2C8\B2E4. \AC12\C740 \D45C\C2DC\B420 \C544\C774\CF58\C744 \C9C0\C815\D558\B294 CSS \D074\B798\C2A4 \C774\B984\C785\B2C8\B2E4. \AC00\B2A5\D55C \AC12\C740 \C544\C774\CF58 \C720\D615\C5D0 \B530\B77C \B2E4\B985\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715809220298508190.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>310
,p_prompt=>unistr('\B178\B4DC \B808\C774\BE14 \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\B178\B4DC \B808\C774\BE14\C5D0 \B300\D55C \AC12\C744 \D3EC\D568\D558\B294 \B370\C774\D130 \C18C\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \AC12\C5D0\B294 \B9C8\D06C\C5C5\C774 \D3EC\D568\B420 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715811910493561671.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>380
,p_prompt=>unistr('\ACC4\CE35 \B808\BCA8 \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\B178\B4DC\C758 \ACC4\CE35 \B808\BCA8\C5D0 \B300\D55C \AC12\C744 \D3EC\D568\D558\B294 \B370\C774\D130 \C18C\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. <strong>\ACC4\CE35</strong> \C18D\C131\C774 <strong>\ACC4\C0B0\B418\C9C0 \C54A\C74C</strong>\C73C\B85C \C124\C815\B41C \ACBD\C6B0 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715813002119570686.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>500
,p_prompt=>unistr('\C544\C774\CF58 CSS \D074\B798\C2A4 \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\B178\B4DC\C5D0 \C801\C6A9\D560 \C544\C774\CF58 CSS \D074\B798\C2A4\C5D0 \B300\D55C \AC12\C744 \D3EC\D568\D558\B294 \B370\C774\D130 \C18C\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715814135069583776.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>330
,p_prompt=>unistr('\B178\B4DC ID \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\B178\B4DC\C5D0 \B300\D55C ID\B97C \D3EC\D568\D558\B294 \B370\C774\D130 \C18C\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. Application Express\AC00 \ACC4\CE35\C744 \ACC4\C0B0\D558\B294 \ACBD\C6B0 \D544\C694\D569\B2C8\B2E4. \C77C\BC18\C801\C73C\B85C \C5EC\AE30\C11C \AE30\BCF8 \D0A4 \C5F4\C774 \C120\D0DD\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715815231948590626.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>340
,p_prompt=>unistr('\C0C1\C704 \D0A4 \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\B178\B4DC\C758 \C0C1\C704 \D0A4\C5D0 \B300\D55C \AC12\C744 \D3EC\D568\D558\B294 \B370\C774\D130 \C18C\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. Application Express\AC00 \ACC4\CE35\C744 \ACC4\C0B0\D558\B294 \ACBD\C6B0 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715816326045601781.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>370
,p_prompt=>unistr('\B178\B4DC \C0C1\D0DC \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\B178\B4DC \C0C1\D0DC\C5D0 \B300\D55C \AC12\C744 \D3EC\D568\D558\B294 \B370\C774\D130 \C18C\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. <strong>\ACC4\CE35</strong> \C18D\C131\C774 <strong>\ACC4\C0B0\B418\C9C0 \C54A\C74C</strong>\C73C\B85C \C124\C815\B41C \ACBD\C6B0 \D544\C694\D569\B2C8\B2E4. \C5F4\C5D0\B294 <strong>0</strong>(\CD5C\D558\C704 \B178\B4DC\C758 \ACBD\C6B0) \BC0F <strong>1</strong>(\D558\C704 \D56D\BAA9\C774 \C788\B294 \B178\B4DC\C758 \ACBD\C6B0)\C774 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715817436034604662.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>350
,p_prompt=>unistr('\D2B8\B9AC \C2DC\C791 \AC12')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NULL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C774 \C18D\C131\C5D0 \B530\B77C \D2B8\B9AC\C758 \B8E8\D2B8 \ACC4\C0B0 \BC29\BC95\C774 \ACB0\C815\B429\B2C8\B2E4. <strong>\C0C1\C704 \D0A4</strong> \C5F4\C5D0 \C5EC\AE30\C11C \C815\C758\D558\B294 \AC12\C774 \D3EC\D568\B41C \B178\B4DC\AC00 \B8E8\D2B8 \B178\B4DC\B85C \AC04\C8FC\B429\B2C8\B2E4. \B2E4\C911 \B8E8\D2B8\AC00 \AC00\B2A5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818524967607963.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\AE30\C874 \D56D\BAA9 \AE30\BC18')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\D56D\BAA9 \AC12\C744 \C0AC\C6A9\D558\C5EC \D2B8\B9AC\B97C \C2DC\C791\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818952174610864.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4419)
,p_display_sequence=>20
,p_display_value=>unistr('SQL \C9C8\C758 \AE30\BC18')
,p_return_value=>'SQL'
,p_help_text=>unistr('SQL \C9C8\C758\B85C \BC18\D658\B41C \AC12\C744 \C0AC\C6A9\D558\C5EC \D2B8\B9AC\B97C \C2DC\C791\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819396180612829.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C815\C801 \AC12 \AE30\BC18')
,p_return_value=>'STATIC'
,p_help_text=>unistr('\C815\C801 \AC12\C744 \C0AC\C6A9\D558\C5EC \D2B8\B9AC\B97C \C2DC\C791\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819794480614454.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\AC12\C774 NULL\C784')
,p_return_value=>'NULL'
,p_help_text=>unistr('SQL NULL\C744 \C0AC\C6A9\D558\C5EC \D2B8\B9AC\B97C \C2DC\C791\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715821189465630260.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>351
,p_prompt=>unistr('\D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('\D2B8\B9AC\B97C \C2DC\C791\D560 \AC12\C744 \D3EC\D568\D558\B294 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715822207129637643.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>352
,p_prompt=>unistr('SQL \C9C8\C758')
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('\D2B8\B9AC\B97C \C2DC\C791\D560 \AC12\C744 \ACB0\C815\D558\B294 SQL \C9C8\C758\B97C \C9C0\C815\D569\B2C8\B2E4. SQL \C9C8\C758\B294 \D56D\C0C1 <em>\B85C\CEEC \B370\C774\D130\BCA0\C774\C2A4</em>\C5D0\C11C \C2E4\D589\B418\BA70 \C815\D655\D788 \D558\B098\C758 \C5F4\C744 \BC18\D658\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715823388473642206.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>353
,p_prompt=>unistr('\C815\C801 \AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('\D2B8\B9AC\B97C \C2DC\C791\D560 \C815\C801 \AC12\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715830565095726781.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>315
,p_prompt=>unistr('\B178\B4DC \AC12 \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:ROWID'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\B178\B4DC "value"\C5D0 \B300\D55C \AC12\C744 \D3EC\D568\D558\B294 \B370\C774\D130 \C18C\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \AC12\C740 \D45C\C2DC\B418\C9C0 \C54A\C9C0\B9CC JavaScript\B97C \D1B5\D574 \C561\C138\C2A4\D560 \C218 \C788\B294 \D2B8\B9AC \C5B4\B311\D130 \B178\B4DC ID \C18D\C131\C5D0 \CD94\AC00\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715824464978646322.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>460
,p_prompt=>unistr('\B9C1\D06C')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\B178\B4DC\B97C \B204\B97C \B54C \C2E4\D589\B420 \B9C1\D06C\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715825559244651508.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>420
,p_prompt=>unistr('\B3C4\AD6C \C124\BA85 \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:CLOB'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB'
,p_help_text=>unistr('\B178\B4DC \B3C4\AD6C \C124\BA85\C5D0 \B300\D55C \AC12\C744 \D3EC\D568\D558\B294 \B370\C774\D130 \C18C\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715810380689519088.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>320
,p_prompt=>unistr('\ACC4\CE35')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'SQL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Application Express\AC00 \B370\C774\D130\C5D0\C11C \D2B8\B9AC \ACC4\CE35\C744 \ACC4\C0B0\D574\C57C \D560\C9C0 \C5EC\BD80 \B610\B294 \B370\C774\D130\C5D0 \BAA8\B4E0 \ACC4\CE35 \C815\BCF4\AC00 \C774\BBF8 \D3EC\D568\B418\C5B4 \C788\B294\C9C0 \C5EC\BD80\B97C \B098\D0C0\B0C5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715810629237528987.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4419)
,p_display_sequence=>10
,p_display_value=>unistr('SQL\B85C \ACC4\C0B0\B428')
,p_return_value=>'SQL'
,p_help_text=>unistr('SQL START WITH CONNECT BY \C808\C744 \C0AC\C6A9\D558\C5EC \ACC4\CE35\C774 \ACC4\C0B0\B429\B2C8\B2E4. <strong>\C0C1\C704 \D0A4 \C5F4</strong>\C744 \C81C\ACF5\D574\C57C \D569\B2C8\B2E4. \C774 \C635\C158\C740 SQL \C9C8\C758\C5D0 START WITH CONNECT BY \C808\C774 \D3EC\D568\B418\C9C0 <em>\C54A\C740</em> \ACBD\C6B0\C5D0\B9CC \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715811097049545246.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\ACC4\C0B0\B418\C9C0 \C54A\C74C')
,p_return_value=>'LEVEL'
,p_help_text=>unistr('\BAA8\B4E0 \ACC4\CE35 \C815\BCF4\AC00 \B370\C774\D130\C5D0 \C774\BBF8 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4. \C774 \C635\C158\C744 \C0AC\C6A9\D558\B824\BA74 <strong>\B178\B4DC \B808\BCA8</strong> \BC0F <strong>\B178\B4DC \C0C1\D0DC</strong> \C5F4\C744 \B9E4\D551\D574\C57C \D569\B2C8\B2E4. <strong>\B178\B4DC \B808\BCA8</strong>\C5D0\B294 \ACC4\CE35 \B808\BCA8\C774 \C22B\C790 \AC12\C73C\B85C \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4. <strong>\B178\B4DC \C0C1\D0DC</strong>\C5D0\B294 <strong>0</strong>(\CD5C\D558\C704 \B178\B4DC\C758 \ACBD\C6B0) \BC0F <strong>1</strong>(\CD5C\D558\C704 \B178\B4DC\AC00 \C544\B2CC \ACBD\C6B0)\C774 \D3EC\D568\B418\C5B4\C57C')
||unistr(' \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715827441883672711.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>24
,p_display_sequence=>470
,p_prompt=>unistr('\B9C1\D06C \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715824464978646322.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('\B178\B4DC\B97C \B204\B97C \B54C \C2E4\D589\B420 \B9C1\D06C\C5D0 \B300\D55C \AC12\C744 \D3EC\D568\D558\B294 \B370\C774\D130 \C18C\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715828729502680591.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>25
,p_display_sequence=>360
,p_prompt=>unistr('\D615\C81C \C21C\C11C \C815\B82C')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('\C0C1\C704 \B178\B4DC \B0B4 \D558\C704 \D56D\BAA9\C744 \C815\B82C\D558\B294 \B370 \C0AC\C6A9\D560 \B370\C774\D130 \C18C\C2A4 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(381686476818136654.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.multiple = true;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D2B8\B9AC\C5D0 \B300\D55C \C635\C158 \AC1D\CCB4\B97C \AC00\C838\C628 \B2E4\C74C \D574\B2F9 \AC1D\CCB4\B97C \C218\C815\D558\C5EC \BC18\D658\D558\B294 JavaScript \D568\C218\B97C \C785\B825\D569\B2C8\B2E4. \C774 \D568\C218\B97C \C0AC\C6A9\D558\BA74 treeView \C704\C82F \CD08\AE30\D654 \C911 \D2B8\B9AC\C5D0 \B300\D55C \ACE0\AE09 \C0AC\C6A9\C790\C815\C758\AC00 \AC00\B2A5\D569\B2C8\B2E4. \C0AC\C6A9 \AC00\B2A5\D55C \C635\C158\C740 treeView \C704\C82F JavaScript API \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.<p>'),
unistr('<p>\D2B8\B9AC \C601\C5ED\C5D0\C11C \C815\C758\B41C \CD94\AC00 \C635\C158:</p>'),
'<ul>',
unistr('<li><strong>makeNodeAdapter</strong>: \C0AC\C6A9\C790\C815\C758 nodeAdapter\B97C \C815\C758\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4. \C774\B294 makeDefaultNodeAdapter\C640 \B3D9\C77C\D55C \C778\C218\B97C \C0AC\C6A9\D558\BA70 treeNodeAdapter \C778\D130\D398\C774\C2A4\B97C \BC18\D658\D574\C57C \D558\B294 \D568\C218\C785\B2C8\B2E4.</li>'),
unistr('<li><strong>initialSelectedNodeId</strong>: \C120\D0DD\D560 \B178\B4DC\C758 \AC12\C73C\B85C, \C120\D0DD\B41C \B178\B4DC \D398\C774\C9C0 \D56D\BAA9 \C18D\C131\C5D0 \B530\B77C \C124\C815\B429\B2C8\B2E4.</li>'),
unistr('<li><strong>nodeHasTooltip</strong>: \B3C4\AD6C \C124\BA85 \C18D\C131\C5D0 \B530\B77C \C124\C815\B418\BA70, \B178\B4DC\C5D0 \B3C4\AD6C \C124\BA85\C774 \C788\C744 \ACBD\C6B0 true\C774\ACE0 \ADF8\B807\C9C0 \C54A\C744 \ACBD\C6B0 false\C785\B2C8\B2E4.</li>'),
unistr('<li><strong>regionStaticId</strong>: \C774 \C601\C5ED\C5D0 \C0AC\C6A9\B418\B294 \C694\C18C ID\C785\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(715829199415682079.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\ACC4\CE35 \C18D\C131\C774 [SQL\B85C \ACC4\C0B0\B428]\C73C\B85C \C124\C815\B41C \ACBD\C6B0</dt>'),
'<dd><pre>',
' select ename, empno, mgr from emp',
'</pre>',
unistr('<p>\B178\B4DC ID \C5F4\C5D0 \B300\D55C EMPNO\B97C \C9C0\C815\D558\ACE0, \C0C1\C704 \D0A4 \C5F4 \C18D\C131\C73C\B85C MGR\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
'</dd>',
unistr('<dt>\ACC4\CE35 \C18D\C131\C774 [\ACC4\C0B0\B418\C9C0 \C54A\C74C]\C73C\B85C \C124\C815\B41C \ACBD\C6B0</dt>'),
'<dd><pre>',
' select case when connect_by_isleaf = 1 then 0 when level = 1 then 1 else -1 end as status,',
'        level,',
'        ename as title,',
'        ''icon-tree-folder'' as icon,',
'        empno as value,',
'        ename as tooltip,',
'        null  as link',
'   from emp',
'  start with mgr is null',
'connect by prior empno = mgr',
'  order siblings by ename',
'</pre>',
unistr('<p>\B178\B4DC \C0C1\D0DC \C5F4\C5D0 \B300\D55C STATUS, \ACC4\CE35 \B808\BCA8 \C5F4 \C18D\C131\C5D0 \B300\D55C LEVEL\C744 \C9C0\C815\D569\B2C8\B2E4.</p>'),
'</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(389020154426295680.4419)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4419)
,p_name=>'treeviewselectionchange'
,p_display_name=>unistr('\C120\D0DD \BCC0\ACBD')
);
end;
/
prompt --application/shared_components/plugins/region_type/calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516061640387971.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CALENDAR'
,p_display_name=>unistr('\B2EC\B825')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C5EC\B7EC \B2EC\B825 \BCF4\AE30\C5D0 \B0A0\C9DC \AE30\BC18 \D56D\BAA9\C744 \D45C\C2DC\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C8 \C601\C5ED\C744 \C0DD\C131\D560 \B54C\B294 \C774 \C601\C5ED \C720\D615 \B300\C2E0 <em>\B2EC\B825</em>\C744 \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4. \D074\B798\C2DD \B2EC\B825 \C601\C5ED\C740 \C77C\BC18\C801\C73C\B85C &PRODUCT_NAME. \B9B4\B9AC\C2A4 4.2 \C774\D558\C5D0\C11C \C0DD\C131\B41C \C601\C5ED\C785\B2C8\B2E4.</p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>'$$$ DJP - Shouldn''t this be ''Is Legacy'' = ''Yes''?'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154143004834501.4419)
,p_plugin_id=>wwv_flow_api.id(385516061640387971.4419)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/tree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516341883422042.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TREE'
,p_display_name=>unistr('\D074\B798\C2DD \D2B8\B9AC')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TREE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B808\CF54\B4DC \C0AC\C774\C758 \C0C1\C704-\D558\C704 \AD00\ACC4\B97C \AE30\C900\C73C\B85C \ACC4\CE35 \AD6C\C870\B85C \B370\C774\D130\B97C \D45C\C2DC\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0C8 \C601\C5ED\C744 \C0DD\C131\D560 \B54C\B294 \C774 \C601\C5ED \C720\D615 \B300\C2E0 <em>\D2B8\B9AC</em>\B97C \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4. </p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$$ DJP - Is the name Classic Tree in preparation for John''s tree being implemented as a standard component in 5.0?',
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(385518660732877617.4419)
,p_plugin_id=>wwv_flow_api.id(385516341883422042.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D2B8\B9AC \AD6C\C131\C694\C18C ID')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_expand
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388431570538859249.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_EXPAND'
,p_display_name=>unistr('\D2B8\B9AC \D655\C7A5')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_EXPAND'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D2B8\B9AC \C601\C5ED\C5D0\C11C \D604\C7AC \B178\B4DC\B97C \D655\C7A5\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_collapse
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388635386274723384.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_COLLAPSE'
,p_display_name=>unistr('\D2B8\B9AC \CD95\C18C')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_COLLAPSE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D2B8\B9AC \C601\C5ED\C5D0\C11C \D604\C7AC \B178\B4DC\B97C \CD95\C18C\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/password
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(435122514730662817.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PASSWORD'
,p_display_name=>unistr('\BE44\BC00\BC88\D638')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PASSWORD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('HTML \BE44\BC00\BC88\D638 \D3FC \C694\C18C\B97C \D45C\C2DC\D569\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\AC00 \D14D\C2A4\D2B8\B97C \C785\B825\D558\BA74 \C2E4\C81C \C785\B825 \BB38\C790 \B300\C2E0 \D574\B2F9 \BB38\C790\C5D0 \B300\D574 \AC80\C740\C0C9 \C810\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(435122925859694465.4419)
,p_plugin_id=>wwv_flow_api.id(435122514730662817.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Enter\B97C \B204\B97C \B54C \C81C\CD9C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \D544\B4DC\C5D0 \C788\B294 \B3D9\C548 <em>Enter</em> \D0A4\B97C \B20C\B7EC\C11C \D398\C774\C9C0\B97C \C790\B3D9\C73C\B85C \C81C\CD9C\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/item_type/stop_and_start_html_table
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(442021108862425785.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STOP_AND_START_HTML_TABLE'
,p_display_name=>unistr('\ADF8\B9AC\B4DC \B808\C774\C544\C6C3 \C815\C9C0 \BC0F \C2DC\C791')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STOP_AND_START_HTML_TABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774\C804 HTML \D14C\C774\BE14\C744 \C815\C9C0\D558\ACE0 \C0C8 HTML \D14C\C774\BE14\C744 \C2DC\C791\D558\AE30 \C704\D574 \C0AC\C6A9\B418\B294 \B808\AC70\C2DC \D56D\BAA9\C785\B2C8\B2E4. &PRODUCT_NAME. \B9B4\B9AC\C2A4 xx\C5D0 <em>\ADF8\B9AC\B4DC \B808\C774\C544\C6C3</em>\C774 \B3C4\C785\B418\AE30 \C804\C5D0\B294 \D398\C774\C9C0 \D56D\BAA9 \D45C\C2DC\B97C \C870\C815\D558\AE30 \C704\D574 \C774 \D56D\BAA9 \C720\D615\C774 \B2E4\C591\D558\AC8C \C0AC\C6A9\B418\C5C8\C2B5\B2C8\B2E4.</p>'),
unistr('<p>Oracle\C740 \D574\B2F9 \C601\C5ED\C5D0 \D45C\C2DC\B418\B294 \B2E4\C74C \D398\C774\C9C0 \D56D\BAA9\C5D0 \B300\D574 \C774\B7EC\D55C \B808\AC70\C2DC \D56D\BAA9 \C720\D615\C744 \C0AD\C81C\D558\ACE0 <em>\C0C8 \ADF8\B9AC\B4DC \C2DC\C791</em>\C744 <strong>\C608</strong>\B85C \C5C5\B370\C774\D2B8\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4. \C774 \AE30\B2A5\C740 \ADF8\B9AC\B4DC \B808\C774\C544\C6C3 \C815\C9C0 \BC0F \C2DC\C791 \D56D\BAA9\C744 \C0AC\C6A9\D558\B294 \AC83\ACFC \B3D9\C77C\D569\B2C8\B2E4.</p>')))
,p_plugin_comment=>'$$$ DJP - What APEX Release was Grid Layout introduced?'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/refresh
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(457584914213394021.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REFRESH'
,p_display_name=>unistr('\C0C8\B85C\ACE0\CE68')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REFRESH'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\C758 \C0C8\B85C\ACE0\CE68\C744 \D2B8\B9AC\AC70\D569\B2C8\B2E4. \C77C\BD80 \C694\C18C\C5D0\C11C\B294 \C0C8\B85C\ACE0\CE68 \C791\C5C5\C774 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \C774 \C791\C5C5\C744 \C0AC\C6A9\D558\C5EC \B300\D654\C2DD \BCF4\ACE0\C11C, \D074\B798\C2DD \BCF4\ACE0\C11C \BC0F \C885\C18D LOV\AC00 \C9C0\C6D0\B418\B294 \BAA8\B4E0 \D56D\BAA9 \C720\D615\C5D0\C11C \CF58\D150\CE20\B97C \C0C8\B85C\ACE0\CE68\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/show
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(517009436728139227.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SHOW'
,p_display_name=>unistr('\D45C\C2DC')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SHOW'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262167718423622079.4419)
,p_plugin_id=>wwv_flow_api.id(517009436728139227.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B3D9\C77C \D589\C5D0 \BAA8\B450 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C601\D5A5\C744 \BC1B\B294 \C694\C18C\C640 \B3D9\C77C\D55C \D589\C5D0 \C788\B294 \BAA8\B4E0 \D398\C774\C9C0 \D56D\BAA9 \BC0F \B808\C774\BE14\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C774 \C18D\C131\C740 \D3FC \D56D\BAA9\C744 \D45C\C2DC\D558\AE30 \C704\D574 \D14C\C774\BE14 \ADF8\B9AC\B4DC\B97C \C0AC\C6A9\D558\C9C0 \C54A\B294 \D398\C774\C9C0\C758 \D56D\BAA9\C5D0 \B300\D574\C11C\B294 \C791\B3D9\D558\C9C0 \C54A\C2B5\B2C8\B2E4. \C5EC\AE30\C5D0\B294 \BAA8\BC14\C77C \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\B97C \C0AC\C6A9\D558\B294 \BAA8\B4E0 \D398\C774\C9C0\AC00 \D3EC\D568\B429\B2C8\B2E4.</p>')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/http_header_variable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(552639319797428791.4419)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'HTTP_HEADER_VARIABLE'
,p_display_name=>unistr('HTTP \BA38\B9AC\AE00 \BCC0\C218')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','HTTP_HEADER_VARIABLE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C0AC\C6A9\C790 \C774\B984\C774 \C6F9 \C11C\BC84\C5D0\C11C \C124\C815\B41C HTTP \D5E4\B354 \BCC0\C218\C5D0 \C800\C7A5\B41C \ACBD\C6B0 \C678\BD80\C5D0\C11C \C778\C99D\C744 \C218\D589\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552647115426436957.4419)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('HTTP \D5E4\B354 \BCC0\C218 \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0AC\C6A9\C790 \C774\B984\C774 \D3EC\D568\B41C HTTP \D5E4\B354 \BCC0\C218\C758 \C774\B984\C744 \C9C0\C815\D569\B2C8\B2E4. \C9C0\C815\D558\C9C0 \C54A\C73C\BA74 REMOTE_USER\AC00 \C0AC\C6A9\B429\B2C8\B2E4.</p>'),
'',
unistr('<p>HTTP \D5E4\B354 \BCC0\C218\B294 \C6F9 \C11C\BC84\C5D0\C11C \C124\C815\B41C \BCC0\C218\C785\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552651403090442945.4419)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C0AC\C6A9\C790 \C774\B984\C774 \BE44\C5B4 \C788\B294 \ACBD\C6B0\C758 \C791\C5C5')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('HTTP \D5E4\B354 \BCC0\C218\C5D0 \C800\C7A5\B41C \C0AC\C6A9\C790 \C774\B984\C774 \BE44\C5B4 \C788\B294 \ACBD\C6B0 \C218\D589\B418\C5B4\C57C \D558\B294 \C791\C5C5\C744 \C9C0\C815\D569\B2C8\B2E4. \B2E4\C74C \C635\C158\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>\B0B4\C7A5 URL\B85C \C7AC\C9C0\C815</strong>\C740 \C6F9 \C11C\BC84\C5D0\C11C \B85C\ADF8\C778\C744 \C2DC\C791\D569\B2C8\B2E4. \C774 \B0B4\C7A5 URL\C740 \D638\CD9C\B418\C5C8\C744 \B54C \AC15\C81C \B85C\ADF8\C778\C744 \C2DC\B3C4\D560 \C218 \C788\B3C4\B85D \C6F9 \C11C\BC84\C5D0\C11C \BCF4\D638\B418\B3C4\B85D \C124\C815\B418\C5B4\C57C \D569\B2C8\B2E4. \B85C\ADF8\C778 \D6C4\C5D0\B294 \C6F9 \C11C\BC84\AC00 HTTP \D5E4\B354 \BCC0\C218\C5D0\C11C \C778\C99D \CCB4\ACC4\C5D0 \C81C\ACF5\D560 \C218 \C788\B3C4\B85D \AC80\C99D\B41C \C0AC\C6A9\C790 \C774\B984\C744 \C800\C7A5\D574\C57C \D569\B2C8\B2E4. \B0B4\C7A5 URL\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<pre>/apex/apex_authentication.callback</pre>',
unistr('\C811\B450\C5B4 <code>/apex/</code>\B294 \C11C\BC84 \AD6C\C131\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.'),
'</li>',
unistr('  <li><strong>URL\B85C \C7AC\C9C0\C815</strong>\C740 \C678\BD80 \C11C\BC84\C5D0\C11C \B85C\ADF8\C778\C744 \C2DC\C791\D558\ACE0, \C678\BD80 \C11C\BC84\B294 HTTP \D5E4\B354 \BCC0\C218\C5D0\C11C \AC80\C99D\B41C \C0AC\C6A9\C790 \C774\B984\C744 \C124\C815\D569\B2C8\B2E4. \C678\BD80 \C11C\BC84\B294 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C778\C99D\C744 \C644\B8CC\D558\AE30 \C704\D574 <code>#CALLBACK#</code> \C704\CE58 \D45C\C2DC\C790\B85C \C0DD\C131\B41C URL\C744 \C0AC\C6A9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \B2E4\C2DC \C7AC\C9C0\C815\D574\C57C \D569\B2C8\B2E4.</li>'),
unistr('  <li><strong>\C624\B958 \D45C\C2DC</strong>\B294 \C9C0\C815\B41C \C624\B958 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D558\BA70, \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \B85C\ADF8\C778\C774 \C218\D589\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552655716596446845.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\B0B4\C7A5 URL\B85C \C7AC\C9C0\C815')
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552667630233460180.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4419)
,p_display_sequence=>20
,p_display_value=>unistr('URL\B85C \C7AC\C9C0\C815')
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552687932441470278.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C624\B958 \BCF4\AE30')
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552699720929485951.4419)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'<pre>http://sso.example.com/?success=#CALLBACK#</pre>'
,p_help_text=>unistr('HTTP \D5E4\B354 \BCC0\C218\C5D0\C11C \AC80\C99D\B41C \C0AC\C6A9\C790 \C774\B984\C744 \C124\C815\D558\B294 \C678\BD80 \B85C\ADF8\C778 \C11C\BC84\C758 URL\C744 \C9C0\C815\D569\B2C8\B2E4. \C678\BD80 \C11C\BC84\B294 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C778\C99D\C744 \C644\B8CC\D558\AE30 \C704\D574 <code>#CALLBACK#</code> \C704\CE58 \D45C\C2DC\C790\B85C \C0DD\C131\B41C URL\C744 \C0AC\C6A9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \B2E4\C2DC \C7AC\C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552704028894488210.4419)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C624\B958 \BA54\C2DC\C9C0')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>unistr('HTTP \D5E4\B354 \BCC0\C218\C5D0 \AC12\C774 \D3EC\D568\B418\C9C0 \C54A\AC70\B098 HTTP \D5E4\B354 \BCC0\C218\AC00 \C874\C7AC\D558\C9C0 \C54A\B294 \ACBD\C6B0 \D45C\C2DC\D560 \C624\B958 \BA54\C2DC\C9C0\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(879327919421164751.4419)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\C0AC\C6A9\C790 \C774\B984 \D655\C778')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('HTTP \D5E4\B354 \BCC0\C218\C5D0 \C800\C7A5\B41C \C0AC\C6A9\C790 \C774\B984\C774 \D655\C778\B418\B294 \BE48\B3C4\B97C \C9C0\C815\D569\B2C8\B2E4. \B2E4\C74C \C635\C158\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>\AC01 \C694\CCAD</strong>\C5D0\C11C\B294 \C6F9 \C11C\BC84\AC00 \B85C\ADF8\C778\C744 \C218\D589\D558\B294 \C989\C2DC \D56D\C0C1 CGI \BCC0\C218\AC00 \C124\C815\B418\B294 \AC83\C73C\B85C \AE30\B300\D569\B2C8\B2E4. \C0AC\C6A9\C790 \C774\B984\C774 \D604\C7AC &PRODUCT_NAME. \C138\C158\C5D0 \C800\C7A5\B41C \AC83\ACFC \AC19\C9C0 \C54A\C73C\BA74 \C138\C158\C774 \BB34\D6A8\D654\B418\ACE0 \C0C8 \B85C\ADF8\C778\C774 \C2DC\C791\B429\B2C8\B2E4. \C774 \C635\C158\C740 \B85C\ADF8\C544\C6C3 \B610\B294 \C0AC\C6A9\C790 \BCC0\ACBD\C0AC\D56D\C744 \AC10\C9C0\D558\AE30 \B54C\BB38\C5D0 \AC00\C7A5 \C548\C804\D55C \C635\C158\C785\B2C8\B2E4.'),
'  </li>',
unistr('  <li><strong>\B85C\ADF8\C778 \D6C4</strong>\B294 \C6F9 \C11C\BC84\AC00 \B85C\ADF8\C778\C744 \C218\D589\D55C \B2E4\C74C &PRODUCT_NAME. \C138\C158\C5D0\C11C \C0AC\C6A9\C790 \C774\B984\C744 \D655\C778 \BC0F \C800\C7A5\B9CC \D558\ACE0, \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C778\C99D\C744 \C644\B8CC\D558\AE30 \C704\D574 \CF5C\BC31\C744 \D638\CD9C\D569\B2C8\B2E4. \CF5C\BC31\C5D0 \B300\D55C \C790\C138\D55C \B0B4\C6A9\C740 "\C0AC\C6A9\C790 \C774\B984\C774 \BE44\C5B4 \C788\B294 \ACBD\C6B0\C758 \C791\C5C5" \AD6C\C131\C744 \CC38\C870\D558\C2ED\C2DC\C624.'),
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879343501197168872.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\AC01 \C694\CCAD')
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879347807777170859.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\B85C\ADF8\C778 \D6C4')
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(39504908766917753.4419)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('SSO \C11C\BC84\C758 \B85C\ADF8\C544\C6C3 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Oracle Access Manager \AE30\BC18 SSO\C758 \ACBD\C6B0 \C608\B97C \B4E4\C5B4, \B2E4\C74C\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C778\C99D \CCB4\ACC4\AC00 Oracle Access Manager \B610\B294 \BE44\C2B7\D55C \C11C\BC84\B97C \AE30\BC18\C73C\B85C \D560 \ACBD\C6B0'),
unistr('\C774 \C18D\C131\C744 \C0AC\C6A9\D574\C11C \C911\C559 Single Sign-On \C11C\BC84\C5D0\C11C \B85C\ADF8\C544\C6C3\D558\AE30 \C704\D55C URL\C744 \C9C0\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\CE58\D658 \B9E4\AC1C\BCC0\C218 <code>%POST_LOGOUT_URL%</code>\C740 \C560\D50C\B9AC\CF00\C774\C158\C758 \B85C\ADF8\C778 \D398\C774\C9C0\C5D0 \B300\D55C \C778\CF54\B529\B41C URL\B85C \BC14\B01D\B2C8\B2E4.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/html_expression
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(562560582820583985.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HTML_EXPRESSION'
,p_display_name=>unistr('HTML \D45C\D604\C2DD')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HTML_EXPRESSION'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('HTML \D45C\D604\C2DD\C5D0 \C900\D558\C5EC \D3B8\C9D1 \BD88\AC00\B2A5\D55C \D56D\BAA9\C744 \D45C\C2DC\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(562566479673647057.4419)
,p_plugin_id=>wwv_flow_api.id(562560582820583985.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('HTML \D45C\D604\C2DD')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\BC30\ACBD \BC0F \D14D\C2A4\D2B8 \C0C9\C0C1 \BCC0\ACBD</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&amp;EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\C81C\BAA9 2 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;h2>&amp;EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL \C9C8\C758\C5D0\C11C \B3D9\C801 \D074\B798\C2A4 \C0AC\C6A9</dt>'),
'    <dd><pre>&lt;span class="&amp;COLUMN_CLASS!ATTR.">&amp;EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \C774 \C608\C81C\C758 <code>&amp;COLUMN_CLASS!ATTR.</code> \BC0F <code>&amp;EMPLOYEE_STATUS.</code> \B300\CCB4\B294 SQL \C9C8\C758\C5D0\C11C \C120\D0DD\D55C \C5F4\C785\B2C8\B2E4.</dd>'),
unistr('  <dt>\C774\BBF8\C9C0 \D45C\C2DC \BC0F \CEE4\C11C\B97C \C704\B85C \AC00\C838\AC08 \B54C \B3C4\AD6C \C124\BA85 \D45C\C2DC</dt>'),
'    <dd><pre>&lt;img src="&amp;IMAGE_NAME!ATTR." title="&amp;EMPLOYEE_NAME!ATTR."&gt;</pre></dd>',
'</dl>'))
,p_help_text=>unistr('\C774 \C5F4\C5D0 \D45C\C2DC\D560 HTML \D45C\D604\C2DD\C744 \C785\B825\D569\B2C8\B2E4. <code>&amp;COLUMN.</code> \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC HTML\C5D0 \C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/item_type/link
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(567106626791482337.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LINK'
,p_display_name=>unistr('\B9C1\D06C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LINK'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:ESCAPE_OUTPUT:SOURCE:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D3B8\C9D1 \BD88\AC00\B2A5\D55C \D56D\BAA9\C744 \B9C1\D06C\B85C \D45C\C2DC\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/clear
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823504054693040.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLEAR'
,p_display_name=>unistr('\C9C0\C6B0\AE30')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLEAR'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\B97C \C9C0\C6C1\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/alert
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823719638697634.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ALERT'
,p_display_name=>unistr('\ACBD\BCF4')
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ALERT'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\B2E8\C77C <em>\D655\C778</em> \B2E8\CD94\AC00 \C788\B294 \ACBD\BCF4 \BA54\C2DC\C9C0\B97C \D45C\C2DC\D569\B2C8\B2E4. \B2E8\CD94\B97C \B20C\B7EC\C11C \C751\B2F5\D574\C57C \D558\B294 \C815\BCF4\B97C \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\C9C0\B9CC \C774\BCA4\D2B8 \C2E4\D589\C740 \ACC4\C18D\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626823916999706267.4419)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\BA54\C2DC\C9C0')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>\C9C1\C6D0 &amp;P1_ENAME.\C740(\B294) \C0AD\C81C\D560 \C218 &lt;strong&gt;\C5C6\C2B5\B2C8\B2E4&lt;&#x2F;strong&gt;.</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\ACBD\BCF4 \B300\D654\C0C1\C790\C5D0 \D45C\C2DC\D560 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\B300\D654\C0C1\C790\AC00 \D45C\C2DC\B420 \B54C \D074\B77C\C774\C5B8\D2B8 \CE21\C5D0\C11C \D56D\BAA9 \B300\CCB4\AC00 \C218\D589\B429\B2C8\B2E4.</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701076455936800.4419)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\C81C\BAA9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>\C120\D0DD\C801\C73C\B85C \B300\D654\C0C1\C790 \C81C\BAA9\C744 \C81C\ACF5\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701701323970349.4419)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C2A4\D0C0\C77C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\AE30\BCF8\AC12')
,p_help_text=>unistr('\B300\D654\C0C1\C790 \C2A4\D0C0\C77C\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703043398973992.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C815\BCF4')
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702623945972615.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C704\D5D8')
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702291441971350.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\ACBD\ACE0')
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703410946975189.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\C131\ACF5')
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705287585006856.4419)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C544\C774\CF58')
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\C120\D0DD\C801 \B300\D654\C0C1\C790 \C544\C774\CF58\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3704914260003167.4419)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('CSS \D074\B798\C2A4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\B300\D654\C0C1\C790 \CEE8\D14C\C774\B108\C5D0 \C801\C6A9\D560 \C120\D0DD\C801 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705505358011056.4419)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\D655\C778 \B808\C774\BE14')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\D655\C778 \B2E8\CD94\C758 \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C544\BB34 \AC83\B3C4 \C81C\ACF5\D558\C9C0 \C54A\C73C\BA74 \D14D\C2A4\D2B8 \BA54\C2DC\C9C0 <code>APEX.DIALOG.OK</code> \AC12\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/confirm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626824429466709866.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CONFIRM'
,p_display_name=>unistr('\D655\C778')
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CONFIRM'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\CDE8\C18C \BC0F \D655\C778 \B2E8\CD94\AC00 \C788\B294 \D655\C778 \B300\D654\C0C1\C790\B97C \D45C\C2DC\D569\B2C8\B2E4. \C0AC\C6A9\C790\AC00 <em>\CDE8\C18C</em>\B97C \C120\D0DD\D558\BA74 \C9C4\D589 \C911\C778 \C791\C5C5\C774 \C2E4\D589\B418\C9C0 \C54A\ACE0 \D604\C7AC \C774\BCA4\D2B8\AC00 \CDE8\C18C\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626824618169716040.4419)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\BA54\C2DC\C9C0')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>\C9C1\C6D0 &amp;P1_ENAME.\C744(\B97C) &lt;strong&gt;\C0AD\C81C\D558\C2DC\ACA0\C2B5\B2C8\AE4C&lt;&#x2F;strong&gt;?</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D655\C778 \B300\D654\C0C1\C790\C5D0 \D45C\C2DC\D560 \BA54\C2DC\C9C0\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\B300\D654\C0C1\C790\AC00 \D45C\C2DC\B420 \B54C \D074\B77C\C774\C5B8\D2B8 \CE21\C5D0\C11C \D56D\BAA9 \B300\CCB4\AC00 \C218\D589\B429\B2C8\B2E4.</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2101389282482255.4419)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\C81C\BAA9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>\C120\D0DD\C801\C73C\B85C \B300\D654\C0C1\C790 \C81C\BAA9\C744 \C81C\ACF5\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2103085785653286.4419)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C2A4\D0C0\C77C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\AE30\BCF8\AC12')
,p_help_text=>unistr('\B300\D654\C0C1\C790 \C2A4\D0C0\C77C\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104149014656515.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C815\BCF4')
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103302674655458.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\ACBD\ACE0')
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103765346655897.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C704\D5D8')
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104502204657360.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\C131\ACF5')
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106373192721945.4419)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C544\C774\CF58')
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\C120\D0DD\C801 \B300\D654\C0C1\C790 \C544\C774\CF58\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106035369711819.4419)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('CSS \D074\B798\C2A4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\B300\D654\C0C1\C790 \CEE8\D14C\C774\B108\C5D0 \C801\C6A9\D560 \C120\D0DD\C801 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106917926775379.4419)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\D655\C778 \B808\C774\BE14')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\D655\C778 \B2E8\CD94\C758 \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C544\BB34 \AC83\B3C4 \C81C\ACF5\D558\C9C0 \C54A\C73C\BA74 \D14D\C2A4\D2B8 \BA54\C2DC\C9C0 <code>APEX.DIALOG.OK</code> \AC12\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106670847763561.4419)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\CDE8\C18C \B808\C774\BE14')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\CDE8\C18C \B2E8\CD94\C758 \B808\C774\BE14\C744 \C785\B825\D569\B2C8\B2E4. \C544\BB34 \AC83\B3C4 \C81C\ACF5\D558\C9C0 \C54A\C73C\BA74 \D14D\C2A4\D2B8 \BA54\C2DC\C9C0 <code>APEX.DIALOG.CANCEL</code> \AC12\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/process_type/parse_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(668666822163400066.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PARSE_UPLOADED_DATA'
,p_display_name=>unistr('\C5C5\B85C\B4DC\B41C \B370\C774\D130 \AD6C\BB38\BD84\C11D')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PARSE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\AE30\C874 \D14C\C774\BE14\C5D0 \B85C\B4DC\D558\B3C4\B85D \C900\BE44\B41C \C2A4\D504\B808\B4DC\C2DC\D2B8 \B370\C774\D130\B97C \AD6C\BB38\BD84\C11D\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4. \C774 \D504\B85C\C138\C2A4 \C720\D615\C740 <em>\B370\C774\D130 \B85C\B4DC</em>\B97C \C704\D574 \D398\C774\C9C0 \C0DD\C131 \B9C8\BC95\C0AC\C5D0\C11C \C0DD\C131\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668751414675407356.4419)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B370\C774\D130 \B85C\B4DC \C815\C758')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\ACF5\C720 \AD6C\C131\C694\C18C\C5D0\C11C \B85C\B4DC\D560 \D14C\C774\BE14\C744 \C815\C758\D558\B294 \B370\C774\D130 \B85C\B4DC \C815\C758\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668863505241423607.4419)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C784\D3EC\D2B8 \CD9C\CC98 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C120\D0DD\D55C <em>\C784\D3EC\D2B8 \CD9C\CC98</em> \C635\C158\C744 \C800\C7A5\D560 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714598810997211212.4419)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\AD6C\BD84 \AE30\D638 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C785\B825\D55C <em>\AD6C\BD84\C790</em> \D14D\C2A4\D2B8\B97C \C800\C7A5\D560 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714603217923213191.4419)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\B458\B7EC\C2F8\AE30 \BB38\C790 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C785\B825\D55C <em>\C120\D0DD\C801 \B458\B7EC\C2F8\AE30 \BB38\C790</em> \D14D\C2A4\D2B8\B97C \C800\C7A5\D560 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668904302255432174.4419)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\CCAB\BC88\C9F8 \D589 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C785\B825\D55C <em>\CCAB\BC88\C9F8 \D589\C5D0 \C5F4 \C774\B984 \D3EC\D568</em> \CCB4\D06C\BC15\C2A4 \AC12\C744 \C800\C7A5\D560 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668954022687438059.4419)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\D1B5\D654 \AE30\D638 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C785\B825\D55C <em>\D1B5\D654 \AE30\D638</em> \D14D\C2A4\D2B8\B97C \C800\C7A5\D560 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668962228228439718.4419)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\ADF8\B8F9 \AD6C\BD84 \AE30\D638 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C785\B825\D55C <em>\ADF8\B8F9 \AD6C\BD84\C790</em> \D14D\C2A4\D2B8\B97C \C800\C7A5\D560 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668977904810442452.4419)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\C18C\C218\C810 \BB38\C790 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C785\B825\D55C <em>\C18C\C218\C810 \BB38\C790</em> \D14D\C2A4\D2B8\B97C \C800\C7A5\D560 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668982211736444415.4419)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\D30C\C77C \C774\B984 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C785\B825\D55C <em>\D30C\C77C \C774\B984</em> \AC12\C744 \C800\C7A5\D560 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669001326628448680.4419)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\BCF5\C0AC \BC0F \BD99\C5EC\B123\AE30 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C785\B825\D55C <em>Copy and Paste Delimited Date</em> \D14D\C2A4\D2B8\B97C \C800\C7A5\D560 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24234014577732260.4419)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\BB38\C790\C138\D2B8 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C120\D0DD\D55C <em>\D30C\C77C \BB38\C790\C138\D2B8</em>\C744 \C800\C7A5\D560 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(48837321936282082.4419)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\B0A0\C9DC \D615\C2DD \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C785\B825\D55C <em>\B0A0\C9DC \D615\C2DD</em> \D14D\C2A4\D2B8\B97C \C800\C7A5\D560 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/region_type/data_upload_column_mapping
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669051019271465508.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_display_name=>unistr('\B370\C774\D130 \C5C5\B85C\B4DC \C5F4 \B9E4\D551')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DATA_UPLOAD_COLUMN_MAPPING'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\C5C5\B85C\B4DC\B41C \C2A4\D504\B808\B4DC\C2DC\D2B8 \C5F4\C744 \D14C\C774\BE14 \C5F4\B85C \B9E4\D551\D569\B2C8\B2E4. \C774 \C601\C5ED \C720\D615\C740 <em>\B370\C774\D130 \B85C\B4DC</em>\B97C \C704\D574 \D398\C774\C9C0 \C0DD\C131 \B9C8\BC95\C0AC\C5D0\C11C \C0DD\C131\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669071925851467433.4419)
,p_plugin_id=>wwv_flow_api.id(669051019271465508.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B370\C774\D130 \B85C\B4DC \C815\C758')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('<em>\B370\C774\D130 \B85C\B4DC</em> \D504\B85C\C138\C2A4\C5D0 \C815\C758\B41C \B370\C774\D130 \B85C\B4DC \C815\C758\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/process_type/prepare_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669101621133475493.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PREPARE_UPLOADED_DATA'
,p_display_name=>unistr('\C5C5\B85C\B4DC\B41C \B370\C774\D130 \C900\BE44')
,p_supported_ui_types=>'DESKTOP:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PREPARE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\AE30\C874 \D14C\C774\BE14\B85C \C5C5\B85C\B4DC\D560 \C2A4\D504\B808\B4DC\C2DC\D2B8 \B370\C774\D130\B97C \C900\BE44\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4. \C774 \D504\B85C\C138\C2A4 \C720\D615\C740 <em>\B370\C774\D130 \B85C\B4DC</em>\B97C \C704\D574 \D398\C774\C9C0 \C0DD\C131 \B9C8\BC95\C0AC\C5D0\C11C \C0DD\C131\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(670229105709707629.4419)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B370\C774\D130 \B85C\B4DC \C815\C758')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\ACF5\C720 \AD6C\C131\C694\C18C\C5D0\C11C \B85C\B4DC\D560 \D14C\C774\BE14\C744 \C815\C758\D558\B294 \B370\C774\D130 \B85C\B4DC \C815\C758\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468155644060156.4419)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C0BD\C785 \C218 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\C0BD\C785\D560 \B808\CF54\B4DC \C218\B97C \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468974968063264.4419)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C5C5\B370\C774\D2B8 \C218 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\C5C5\B370\C774\D2B8\D560 \B808\CF54\B4DC \C218\B97C \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380469514614067903.4419)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C624\B958 \C218 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\C624\B958\AC00 \BC1C\C0DD\D55C \B808\CF54\B4DC \C218\B97C \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380470030664073278.4419)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\AC80\D1A0 \C218 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\AC80\D1A0\D55C \B808\CF54\B4DC \C218\B97C \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/process_type/load_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669285217502512352.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'LOAD_UPLOADED_DATA'
,p_display_name=>unistr('\C5C5\B85C\B4DC\B41C \B370\C774\D130 \B85C\B4DC')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','LOAD_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\AD6C\BB38\BD84\C11D\B41C \C2A4\D504\B808\B4DC\C2DC\D2B8 \B370\C774\D130\B97C \AE30\C874 \D14C\C774\BE14 \B610\B294 \BDF0\C5D0 \B85C\B4DC\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4. \C774 \D504\B85C\C138\C2A4 \C720\D615\C740 <em>\B370\C774\D130 \B85C\B4DC</em>\B97C \C704\D574 \D398\C774\C9C0 \C0DD\C131 \B9C8\BC95\C0AC\C5D0\C11C \C0DD\C131\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669308626852514974.4419)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B370\C774\D130 \B85C\B4DC \C815\C758')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\ACF5\C720 \AD6C\C131\C694\C18C\C5D0\C11C \B85C\B4DC\D560 \D14C\C774\BE14\C744 \C815\C758\D558\B294 \B370\C774\D130 \B85C\B4DC \C815\C758\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669317208629519157.4419)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C0BD\C785 \C218 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\C0BD\C785\D55C \B808\CF54\B4DC \C218\B97C \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669321513477520652.4419)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C5C5\B370\C774\D2B8 \C218 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\C5C5\B370\C774\D2B8\D55C \B808\CF54\B4DC \C218\B97C \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669325819364522297.4419)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C624\B958 \C218 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C624\B958\AC00 \BC1C\C0DD\D55C \B808\CF54\B4DC \C218\B97C \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(208350031209048901.4419)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\AC80\D1A0 \C218 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\AC80\D1A0\D55C \B808\CF54\B4DC \C218\B97C \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/apex_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707619648734994478.4419)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'APEX_ACCOUNTS'
,p_display_name=>unistr('Application Express \ACC4\C815')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','APEX_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>&PRODUCT_NAME. \ACC4\C815\C5D0 \B300\D55C \C0AC\C6A9\C790 \C774\B984 \BC0F \BE44\BC00\BC88\D638\B97C \C785\B825\D569\B2C8\B2E4. \AC01 \C791\C5C5\C601\C5ED\C5D0\B294 \ACE0\C720 \C0AC\C6A9\C790 \ACC4\C815 \C800\C7A5\C18C\AC00 \C788\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\AC00 \B85C\ADF8\C778\D558\B294 \C560\D50C\B9AC\CF00\C774\C158\C740 &amp;F4155_WORKSPACE_NAME. \C791\C5C5\C601\C5ED\C5D0 \C18D\D569\B2C8\B2E4. \BE44\BC00\BC88\D638\B294 \B300\C18C\BB38\C790\B97C \AD6C\BD84\D569\B2C8\B2E4.</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/open_door
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707675753928996044.4419)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'OPEN_DOOR'
,p_display_name=>unistr('\ACF5\AC1C \C99D\BA85\C11C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','OPEN_DOOR'),'')
,p_api_version=>1
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\B204\AD6C\B098 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \C138\C158 \B3D9\C548 \C0AC\C6A9\C790\B97C \C560\D50C\B9AC\CF00\C774\C158 \C0AC\C6A9\C790\B85C \C2DD\BCC4\D558\B294 \C2DD\BCC4\C790\B97C \C785\B825\D558\C2ED\C2DC\C624. \ADF8\B7EC\BA74 APP_USER \BCC0\C218 \AC12\C774 \C124\C815\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/db_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707686311942002797.4419)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DB_ACCOUNTS'
,p_display_name=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \ACC4\C815')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DB_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C774 \C778\C99D \CCB4\ACC4\B97C \C0AC\C6A9\D558\B824\BA74 \B370\C774\D130\BCA0\C774\C2A4 \C0AC\C6A9\C790(\C2A4\D0A4\B9C8)\AC00 \B85C\CEEC \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C788\C5B4\C57C \D569\B2C8\B2E4. \C774 \BC29\BC95\C744 \C0AC\C6A9\D560 \ACBD\C6B0 \B370\C774\D130\BCA0\C774\C2A4 \ACC4\C815\C758 \C0AC\C6A9\C790 \C774\B984\ACFC \BE44\BC00\BC88\D638\B97C \C0AC\C6A9\D558\C5EC \C0AC\C6A9\C790\B97C \C778\C99D\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707764939992010930.4419)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'LDAP'
,p_display_name=>unistr('LDAP \B514\B809\D1A0\B9AC')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','LDAP'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('LDAP \C11C\BC84 \C778\C99D \C694\CCAD\C5D0 \B300\D55C \C0AC\C6A9\C790/\BE44\BC00\BC88\D638 \C778\C99D\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708018036276066565.4419)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D638\C2A4\D2B8')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('LDAP \B514\B809\D1A0\B9AC \C11C\BC84\C758 \D638\C2A4\D2B8 \C774\B984\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708026427403073465.4419)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D3EC\D2B8')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('LDAP \B514\B809\D1A0\B9AC \D638\C2A4\D2B8\C758 \D3EC\D2B8 \BC88\D638\C785\B2C8\B2E4. \AE30\BCF8\AC12\C740 389\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708041750260080084.4419)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('SSL \C0AC\C6A9')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('LDAP \B515\C154\B108\B9AC \BC14\C778\B4DC\B97C \C704\D574 SSL\C744 \C0AC\C6A9\D560\C9C0 \C5EC\BD80\B97C \C120\D0DD\D558\C2ED\C2DC\C624. [SSL(\C778\C99D)]\C744 \C120\D0DD\D560 \ACBD\C6B0 &PRODUCT_NAME. \C778\C2A4\D134\C2A4\C5D0 \B300\D55C \C804\C790 \C9C0\AC11\C744 \AD6C\C131\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708049024764082165.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4419)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708053230651083932.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4419)
,p_display_sequence=>20
,p_display_value=>unistr('SSL(\C778\C99D \D3EC\D568)')
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708057433075084636.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4419)
,p_display_sequence=>30
,p_display_value=>unistr('SSL \C5C6\C74C')
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708170045804107167.4419)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('DN(\C2DD\BCC4 \C774\B984) \BB38\C790\C5F4')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C815\D655\D55C DN\C744 \C0AC\C6A9\D558\B294 \ACBD\C6B0 DBMS_LDAP.SIMPLE_BIND_S\C5D0 \B300\D55C \C804\CCB4 DN(\C2DD\BCC4 \C774\B984) \BB38\C790\C5F4\C744, \BD80\C815\D655\D55C DN\C744 \C0AC\C6A9\D558\B294 \ACBD\C6B0 \AC80\C0C9 \AE30\C900\C744 \AD6C\C131\D558\B294 \B370 \C0AC\C6A9\B418\B294 \D328\D134\C744 \C785\B825\D558\C2ED\C2DC\C624. <strong>%LDAP_USER%</strong>\B97C \C0AC\C6A9\C790 \C774\B984\C758 \C704\CE58 \D45C\C2DC\C790\B85C \C0AC\C6A9\D558\C2ED\C2DC\C624. \C608\B97C \B4E4\BA74 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<p>',
unistr('<strong>\C815\D655\D55C DN</strong>'),
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
unistr('<strong>\BD80\C815\D655\D55C DN(\AC80\C0C9 \AE30\C900)</strong>'),
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708104537708095412.4419)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\C815\D655\D55C DN(\C2DD\BCC4 \C774\B984) \C0AC\C6A9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('LDAP \C2DD\BCC4 \C774\B984(DN) \BB38\C790\C5F4\C774 \C815\D655\D55C\C9C0 \C5EC\BD80\B97C \C120\D0DD\D558\C2ED\C2DC\C624. \BD80\C815\D655\D55C \BB38\C790\C5F4\C778 \ACBD\C6B0 LDAP \C2DD\BCC4 \C774\B984(DN)\C774 \AC80\C0C9 \AE30\C900\C774\BA70 \AC80\C0C9 \D544\D130\B97C \C81C\ACF5\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708207443165115942.4419)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\AC80\C0C9 \D544\D130')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(708104537708095412.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C815\D655\D55C DN(\C2DD\BCC4 \C774\B984)\C744 \C0AC\C6A9\D558\C9C0 \C54A\B294 \ACBD\C6B0 \AC80\C0C9 \D544\D130\B97C \C785\B825\D558\C2ED\C2DC\C624. <strong>%LDAP_USER%</strong>\B97C \C0AC\C6A9\C790 \C774\B984\C758 \C704\CE58 \D45C\C2DC\C790\B85C \C0AC\C6A9\D558\C2ED\C2DC\C624. \C608\B97C \B4E4\BA74 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708300825765129776.4419)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('LDAP \C0AC\C6A9\C790 \C774\B984 \D3B8\C9D1 \D568\C218')
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\C2E4\D589\D560 \CD94\AC00 \CF54\B4DC\B97C \C81C\ACF5\D558\C5EC LDAP \B514\B809\D1A0\B9AC \D56D\BAA9 \B610\B294 LDAP \C0AC\C6A9\C790 \C774\B984\C5D0 \AC00\C7A5 \C801\D569\D55C \D615\C2DD\C73C\B85C \C0AC\C6A9\C790 \C774\B984\C744 \BCC0\D658\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\BC14\C778\B4DC \BCC0\C218 :USERNAME\C5D0 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C9C0\C815\D55C \C774\B984\C774 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.'),
unistr('\C608\B97C \B4E4\C5B4, \B2E4\C74C \CF54\B4DC\B294 DN \BB38\C790\C5F4\C758 \BAA8\B4E0 "."\B97C "_"\B85C \BC14\AFB8\B294 \D568\C218\B97C \D638\CD9C\D569\B2C8\B2E4.</p>'),
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
unistr('<p>&PRODUCT_NAME.\C740(\B294) \C778\C99D \C18D\C131 <strong>\C0AC\C6A9\C790 \C774\B984 \C774\C2A4\CF00\C774\D504</strong>\C5D0 \B530\B77C \BC18\D658\B41C \C0AC\C6A9\C790 \C774\B984\C744 \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38288205752186126.4419)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\C0AC\C6A9\C790 \C774\B984 \C774\C2A4\CF00\C774\D504')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('LDAP \C2DD\BCC4 \C774\B984 \BC0F \AC80\C0C9 \BB38\C790\C5F4\C5D0\C11C <strong>%LDAP_USER%</strong>\B97C \BC14\AFB8\AE30 \C804\C5D0'),
unistr('&PRODUCT_NAME.\C740(\B294) \C0AC\C6A9\C790 \C774\B984\C5D0 \D3EC\D568\B41C \D2B9\C218 \BB38\C790\B97C \C790\B3D9\C73C\B85C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'<p/>',
unistr('\AC00\B2A5\D55C \C774\C2A4\CF00\C774\D504 \ADDC\CE59\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
unistr('<li><strong>\D45C\C900</strong>:'),
unistr('RFC 4514(\C2DD\BCC4 \C774\B984) \BC0F RFC 4515(\AC80\C0C9 \BB38\C790\C5F4)\C5D0 \B530\B77C \D2B9\C218 \BB38\C790\B97C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D569\B2C8\B2E4.'),
unistr('\B610\D55C \C720\B2C8\CF54\B4DC \BB38\C790\B3C4 \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D569\B2C8\B2E4.'),
unistr('\C774 \C124\C815\C740 \AC00\C7A5 \C548\C804\D55C \C124\C815\C774\C9C0\B9CC \C77C\BD80 LDAP \C11C\BC84\C5D0\C11C \BB38\C81C\AC00 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\D2B9\C218 \BB38\C790\B9CC</strong>:'),
unistr('RFC 4514(\C2DD\BCC4 \C774\B984) \BC0F RFC 4515(\AC80\C0C9 \BB38\C790\C5F4)\C5D0 \B530\B77C \D2B9\C218 \BB38\C790\B97C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D569\B2C8\B2E4.'),
unistr('\C720\B2C8\CF54\B4DC \BB38\C790\B294 \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\C774\C2A4\CF00\C774\D504 \C5C6\C74C</strong>:'),
unistr('\BB38\C790\B97C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.'),
unistr('\C774 \C124\C815\C740 \C0AC\C6A9\C790 \C774\B984(\C608: apex_escape.ldap_dn'),
unistr('\B610\B294 apex_escape.ldap_search_filter \D3EC\D568)\C744 \C774\BBF8 \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D558\B294'),
unistr('<strong>\C0AC\C6A9\C790 \C774\B984 \D3B8\C9D1 \D568\C218</strong>\B97C \C0AC\C6A9\D558\C9C0 \C54A\B294 \D55C \C7A0\C7AC\C801\C73C\B85C \BCF4\C548 \C218\C900\C774 \C800\D558\B420 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288513717188434.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D45C\C900')
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288919604190164.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D2B9\C218 \BB38\C790\B9CC')
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38289324453191614.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C774\C2A4\CF00\C774\D504 \C5C6\C74C')
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ias_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707826526617016488.4419)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'IAS_SSO'
,p_display_name=>'Oracle Application Server Single Sign-On'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','IAS_SSO'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C774 \D56D\BAA9\C740 Oracle AS SSO(Single Sign-On) \C11C\BC84\C5D0 \C778\C99D\C744 \C704\C784\D569\B2C8\B2E4. \C774 \C778\C99D \CCB4\ACC4\B97C \C0AC\C6A9\D558\B824\BA74 \C0AC\C774\D2B8\AC00 SSO \C11C\BC84\C5D0\C11C \D30C\D2B8\B108 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \B4F1\B85D\B418\C5B4 \C788\C5B4\C57C \D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(707874032982027788.4419)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D611\B825 \C560\D50C\B9AC\CF00\C774\C158 \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Oracle Application Server Single Sign-On\C744 \C0AC\C6A9\D558\C5EC \C778\C99D\C744 \C218\D589\D558\BA70 \C0AC\C6A9\C790\C758 \C560\D50C\B9AC\CF00\C774\C158\C774 SSO\C5D0 \B4F1\B85D\B41C \D611\B825 \C560\D50C\B9AC\CF00\C774\C158\C778 \ACBD\C6B0, SSO\C5D0 \D611\B825 \C560\D50C\B9AC\CF00\C774\C158\C744 \B4F1\B85D\D560 \B54C \C0AC\C6A9\D55C \AC83\ACFC \C815\D655\D788 \B3D9\C77C\D55C \C774\B984\C744 \C785\B825\D558\C2ED\C2DC\C624.'),
'</p>',
'<p>',
unistr('&PRODUCT_NAME.\C744(\B97C) \B4F1\B85D\B41C \D611\B825 \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \C0AC\C6A9\D558\B294 \ACBD\C6B0\C5D0\B294 \C774 \D544\B4DC\B97C \BE44\C6CC \B450\C2ED\C2DC\C624.'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477693327944088403.4419)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('SSO \C11C\BC84\C758 \B85C\ADF8\C544\C6C3 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>60
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SSO(Single Sign-On) \C11C\BC84\C758 \B85C\ADF8\C544\C6C3 \ACBD\B85C\B97C \C785\B825\D558\C2ED\C2DC\C624. \C608:'),
'<em>https://login.example.com/sso/logout</em>',
unistr('\C560\D50C\B9AC\CF00\C774\C158 \B85C\ADF8\C544\C6C3 \C2DC &PRODUCT_NAME.\C774(\AC00) \C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \B2E4\C2DC \C7AC\C9C0\C815\D558\AE30 \C804\C5D0 \C774 \AC12\C744 \C0AC\C6A9\D558\ACE0 ''?p_done_url='' \BC0F \C560\D50C\B9AC\CF00\C774\C158\C758 \B85C\ADF8\C778 URL\C744 \C5F0\ACB0\D558\ACE0 \ACB0\ACFC URL\C744 \C0AC\C6A9\D558\C5EC SSO(Single Sign-On)\C5D0\C11C \B85C\ADF8\C544\C6C3\D569\B2C8\B2E4.')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/dad
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707880052029033247.4419)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DAD'
,p_display_name=>unistr('\C778\C99D \C5C6\C74C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DAD'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D604\C7AC \B370\C774\D130\BCA0\C774\C2A4 \C0AC\C6A9\C790\B97C \C120\D0DD\D569\B2C8\B2E4. \C774 \D56D\BAA9\C740 \AE30\BCF8 \C778\C99D\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130\BCA0\C774\C2A4 \C138\C158 \C0AC\C6A9\C790\B97C \C124\C815\D558\B294 mod_plsql DAD \AD6C\C131\ACFC \D568\AED8 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38519294499392621.4419)
,p_plugin_id=>wwv_flow_api.id(707880052029033247.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C0AC\C6A9\C790 \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'nobody'
,p_is_translatable=>false
,p_help_text=>unistr('&PRODUCT_NAME. \C138\C158\C758 \C0AC\C6A9\C790 \C774\B984\C744 \C785\B825\D558\C2ED\C2DC\C624. \BE44\C5B4 \C788\C73C\BA74 &PRODUCT_NAME.\C5D0\C11C \B370\C774\D130\BCA0\C774\C2A4 \C138\C158 \C0AC\C6A9\C790(\C77C\BC18\C801\C73C\B85C APEX_PUBLIC_USER)\B97C \C0AC\C6A9\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/region_type/css_calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(716993259356536483.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CSS_CALENDAR'
,p_display_name=>unistr('\B2EC\B825')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CSS_CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C5EC\B7EC \B2EC\B825 \BCF4\AE30\C5D0 \B0A0\C9DC \AE30\BC18 \D56D\BAA9\C744 \D45C\C2DC\D569\B2C8\B2E4. \C885\B8CC \B0A0\C9DC\B97C \D3EC\D568\D574\C11C \B2EC\B825\C740 \AE30\AC04\BCC4 \C774\BCA4\D2B8\B97C \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4. \B610\D55C "\B04C\C5B4 \B193\AE30"\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0 \B2EC\B825\C5D0\C11C \B808\CF54\B4DC\B97C \C9C1\C811 \C5C5\B370\C774\D2B8\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1992827406647874094.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Google Calendar API \D0A4[\C0AC\C6A9\B418\C9C0 \C54A\C74C]')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C758 \B2EC\B825\C744 Google Calendar \B370\C774\D130\C640 \D1B5\D569\D560 \C218 \C788\B3C4\B85D \D558\B824\BA74 Google Calendar API \D0A4\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993576597543647.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>5
,p_prompt=>unistr('\C2DC\C791 \B0A0\C9DC \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \B2EC\B825\C5D0 \D45C\C2DC\B418\B294 \C774\BCA4\D2B8\C758 \C2DC\C791 \B0A0\C9DC\B97C \C800\C7A5\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993872715545529.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\C885\B8CC \B0A0\C9DC \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \B2EC\B825\C5D0 \D45C\C2DC\B418\B294 \C774\BCA4\D2B8\C5D0 \B300\D574 \C885\B8CC \B0A0\C9DC\B97C \C800\C7A5\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C18D\C131\C774 \C9C0\C815\B41C \ACBD\C6B0 \B2EC\B825\C5D0 \AE30\AC04\C744 \AE30\C900\C73C\B85C \C774\BCA4\D2B8\AC00 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994160638551031.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>2
,p_prompt=>unistr('\D45C\C2DC \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \B2EC\B825\C5D0\C11C \C774\BCA4\D2B8\C5D0 \B300\D574 \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\B97C \C800\C7A5\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994453521554330.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>12
,p_prompt=>unistr('\AE30\BCF8 \D0A4 \C5F4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2:NUMBER:ROWID'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2EC\B825 \C774\BCA4\D2B8\C5D0 \B300\D574 \AE30\BCF8 \D0A4 \AC12\C744 \C800\C7A5\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C5EC\B7EC \BD80\BD84\C73C\B85C \B41C \AE30\BCF8 \D0A4\AC00 \D14C\C774\BE14\C5D0 \D3EC\D568\B41C \ACBD\C6B0 <strong>ROWID</strong>\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C5F4\C758 \AC12\C740 <code>APEX$PK_VALUE</code> \CE58\D658 \BCC0\C218\C5D0 \BC18\D658\B429\B2C8\B2E4. <em>\CF54\B4DC \B04C\C5B4 \B193\AE30Code</em> \C18D\C131\C5D0\C11C \C774 \BCC0\C218\B97C \C0AC\C6A9\D558\C5EC \B2EC\B825\C5D0\C11C \B04C\C5B4 \B193\AE30 \C791\C5C5\C744 \C218\D589\D55C \D6C4 \C5C5\B370\C774\D2B8\D560 \B808\CF54\B4DC\B97C \C2DD\BCC4\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994772918560561.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>65
,p_prompt=>unistr('\B9C1\D06C \BCF4\AE30/\D3B8\C9D1')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\C0AC\C6A9\C790\AC00 \AE30\C874 \D56D\BAA9\C744 \B204\B97C \B54C \D638\CD9C\D560 \B300\C0C1 \D398\C774\C9C0\B97C \C785\B825\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995064292564584.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\B9C1\D06C \C0DD\C131')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0AC\C6A9\C790\AC00 \BE48 \C140\C744 \B204\B974\AC70\B098 \AE30\C874 \B2EC\B825 \D56D\BAA9 \C678\BD80\B97C \B204\B97C \B54C \D638\CD9C\D560 \B300\C0C1 \D398\C774\C9C0\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\D2B9\C218 \B2EC\B825 \CE58\D658 \BCC0\C218 <pre>&APEX$NEW_START_DATE.</pre> \BC0F <pre>&APEX$NEW_END_DATE.</pre>\C744 \C0AC\C6A9\D574\C57C \B2EC\B825\C5D0\C11C \C120\D0DD\D55C \B0A0\C9DC\B97C \B300\C0C1 \D398\C774\C9C0\B85C \C804\B2EC\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995378729573099.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>45
,p_prompt=>unistr('\B04C\C5B4 \B193\AE30')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716994453521554330.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B2EC\B825\C5D0\C11C \B04C\C5B4 \B193\AE30 \C791\C5C5\C774 \D5C8\C6A9\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: \B04C\C5B4 \B193\AE30\AC00 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0 \C774 \B2EC\B825\C5D0 \B300\D55C \BCF4\AE30 \AD8C\D55C\C774 \C788\B294 \BAA8\B4E0 \C77C\BC18 \C0AC\C6A9\C790\AC00 \B2EC\B825 \D56D\BAA9\C5D0 \B300\D55C \C5C5\B370\C774\D2B8 \AD8C\D55C\B3C4 \AC16\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995668377577896.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>55
,p_prompt=>unistr('PL/SQL \CF54\B4DC \B04C\C5B4 \B193\AE30')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716995378729573099.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C2DC\C791 \B0A0\C9DC\B9CC \D3EC\D568\B41C \C608\C81C(\BE44\AE30\AC04 \AE30\C900 \C774\BCA4\D2B8)</dt>'),
'<dd><pre>',
'begin',
'    update emp',
'       set hiredate = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS'')',
'     where empno = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
unistr('<dt>\C2DC\C791 \BC0F \C885\B8CC \B0A0\C9DC\B97C \D3EC\D568\D558\B294 \C608\C81C(\AE30\AC04 \AE30\C900 \C774\BCA4\D2B8)</dt>'),
'<dd><pre>',
'begin',
'    update projects',
'       set start_date = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS''),',
'           end_date = to_date(:APEX$NEW_END_DATE, ''YYYYMMDDHH24MISS'')',
'     where id = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B04C\C5B4 \B193\AE30\B97C \C0AC\C6A9\D574\C11C \B2EC\B825 \D56D\BAA9\C774 \C5C5\B370\C774\D2B8\B420 \B54C \AE30\BCF8 \D14C\C774\BE14 \B610\B294 \C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BDF0\B97C \C5C5\B370\C774\D2B8\D558\AE30 \C704\D55C PL/SQL \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \B2EC\B825\C5D0 \AE30\AC04 \AE30\BC18\C758 \C774\BCA4\D2B8\AC00 \D45C\C2DC\B420 \ACBD\C6B0(\C885\B8CC \B0A0\C9DC\C5D0 \B300\D55C \C5F4 \C120\D0DD), \D574\B2F9 PL/SQL \CF54\B4DC\B3C4 \C774 \AC12\C744 \C5C5\B370\C774\D2B8\D574\C57C \D569\B2C8\B2E4. \C804\CCB4 \C774\BCA4\D2B8\B97C \B04C\BA74 \C885\B8CC \B0A0\C9DC\C5D0 \D604\C7AC \AE30\AC04\C774 \C720\C9C0 \AD00\B9AC\B429\B2C8\B2E4. \C774\BCA4\D2B8\C758 \B05D\BD80\BD84\C744 \B04C\BA74 \D574\B2F9 \C774\BCA4\D2B8\C758 \AE30\AC04\C774 \C5C5\B370\C774\D2B8\B429\B2C8\B2E4. \ADF8\B7EC\D55C \ACBD\C6B0 \C2DC\C791 \B0A0\C9DC\B294 \BCC0\ACBD\B418\C9C0 \C54A\C9C0\B9CC \AC1C\C815\B41C \AE30\AC04\C5D0 \B9DE\AC8C \C885\B8CC \B0A0\C9DC\AC00 \C5C5\B370\C774\D2B8\B429\B2C8\B2E4.</p>'),
unistr('<p>\B2EC\B825 \CE58\D658 \BCC0\C218\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt>APEX$NEW_START_DATE</dt>',
unistr('    <dd>\AC1C\C815\B41C \C2DC\C791 \B0A0\C9DC\B97C \BC18\D658\D569\B2C8\B2E4. \C774 \B2EC\B825\C758 <em>\C2DC\AC04 \D45C\C2DC</em>\AC00 <strong>\C544\B2C8\C624</strong>\C778 \ACBD\C6B0\C5D0\B3C4 \B0A0\C9DC \D615\C2DD\C740 <code>''YYYYMMDDHH24MISS''</code>\C785\B2C8\B2E4.</dd>'),
'  <dt>APEX$NEW_END_DATE</dt>',
unistr('    <dd>\AE30\AC04 \AE30\BC18\C758 \C774\BCA4\D2B8\C5D0 \B300\D55C \AC1C\C815\B41C \C885\B8CC \B0A0\C9DC\B97C \BC18\D658\D569\B2C8\B2E4. \C774 \B2EC\B825\C758 <em>\C2DC\AC04 \D45C\C2DC</em>\AC00 <strong>\C544\B2C8\C624</strong>\C778 \ACBD\C6B0\C5D0\B3C4 \B0A0\C9DC \D615\C2DD\C740 <code>''YYYYMMDDHH24MISS''</code>\C785\B2C8\B2E4.</dd>'),
'  <dt>APEX$PK_VALUE</dt>',
unistr('    <dd>\AE30\BCF8 \D0A4 \C5F4\C5D0 \C9C0\C815\B41C \C5F4 \AC12\C744 \BC18\D658\D569\B2C8\B2E4.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995977422588893.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>40
,p_prompt=>unistr('\CD94\AC00 \B2EC\B825 \BCF4\AE30')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D45C\C2DC\D560 \CD94\AC00 \B2EC\B825 \BCF4\AE30\B97C \C120\D0DD\D569\B2C8\B2E4. \C6D4 \BCF4\AE30\B294 \D56D\C0C1 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C2DC\AC04 \D45C\C2DC\AC00 <strong>\C544\B2C8\C624</strong>\B85C \C9C0\C815\B41C \ACBD\C6B0 \C8FC\AC04 \BC0F \C77C\AC04 \BCF4\AE30\B97C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484632936569874213.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\BAA9\B85D')
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484633358657877168.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4419)
,p_display_sequence=>50
,p_display_value=>unistr('\D0D0\C0C9')
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716997678919603353.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\C775\C2A4\D3EC\D2B8')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2EC\B825 \C544\B798\C5D0 \C81C\ACF5\D560 \C775\C2A4\D3EC\D2B8 \B9C1\D06C\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: \ADF8\B7EC\BA74 \B2E8\C77C \B2EC\B825 \D56D\BAA9\C774 \C544\B2C8\B77C \D604\C7AC \D45C\C2DC\B41C \BAA8\B4E0 \B2EC\B825 \D56D\BAA9\C774 \C775\C2A4\D3EC\D2B8\B429\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716999168568608195.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4419)
,p_display_sequence=>10
,p_display_value=>'CSV'
,p_return_value=>'CSV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716997976116604645.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4419)
,p_display_sequence=>30
,p_display_value=>'iCal'
,p_return_value=>'ICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716998373959605713.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4419)
,p_display_sequence=>40
,p_display_value=>'XML'
,p_return_value=>'XML'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716999779985618067.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>40
,p_prompt=>unistr('\B2EC\B825 \C870\D68C \BC0F \D0D0\C0C9')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'month:week:day:list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\D45C\C2DC\D560 \B2EC\B825 \BCF4\AE30\B97C \C120\D0DD\D569\B2C8\B2E4. <strong>\C77C</strong>, <strong>\C8FC</strong> \B610\B294 <strong>\C6D4</strong> \C911 \D558\B098 \C774\C0C1\C744 \C120\D0DD\D574\C57C \D569\B2C8\B2E4. \ADF8\B807\C9C0 \C54A\C73C\BA74 \B2EC\B825\C5D0 <strong>\C6D4</strong> \BCF4\AE30\AC00 \C790\B3D9\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(772524462334484489.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C6D4')
,p_return_value=>'month'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000472653621483.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C8FC')
,p_return_value=>'week'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000871143622145.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C77C')
,p_return_value=>'day'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(696140132483024062.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4419)
,p_display_sequence=>35
,p_display_value=>unistr('\BAA9\B85D')
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717001267693623757.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\D0D0\C0C9')
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(718537383340695404.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Google Calendar ID'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_examples=>'<p>Google Calendar ID : abc123@group.calendar.google.com</p>'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B2EC\B825\C5D0 \D45C\C2DC\D560 \B2EC\B825 \B370\C774\D130 \D53C\B4DC\C5D0 \B300\D55C Google Calendar ID\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>Google Calendar \BCF4\C548 \C81C\D55C \C0AC\D56D\C744 \ACE0\B824\D558\BA74 \C774\B7EC\D55C \B2EC\B825\C740 \ACF5\C6A9 \B2EC\B825\C774\AC70\B098 \C774 \B2EC\B825\C758 \C77C\BC18 \C0AC\C6A9\C790 \BAA8\B450\AC00 \C0AC\C6A9\D560 \C218 \C788\C5B4\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: Google Calendar\AC00 \C62C\BC14\B85C \C791\B3D9\D558\B3C4\B85D Google Calendar API \D0A4\B97C \C785\B825\D574\C57C \D569\B2C8\B2E4. [\ACF5\C720 \AD6C\C131\C694\C18C] > [\AD6C\C131\C694\C18C \C124\C815] > [\B2EC\B825]\C73C\B85C \C774\B3D9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \D0A4\B97C \C124\C815\D558\C2ED\C2DC\C624.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(739025333221911743.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>15
,p_prompt=>unistr('\C2DC\AC04 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B0A0\C9DC\C758 \C2DC\AC04 \BD80\BD84\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. </p>'),
unistr('<p>\C8FC \BC0F \C77C \BCF4\AE30\B294 \C2DC\AC04 \D45C\C2DC\AC00 <strong>\C608</strong>\B85C \C124\C815\B41C \ACBD\C6B0\C5D0\B9CC \D45C\C2DC\B429\B2C8\B2E4. \C2DC\C791 \B0A0\C9DC \BC0F \C885\B8CC \B0A0\C9DC \C5F4\C5D0 \C2DC\AC04 \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B418\C9C0 \C54A\C740 \ACBD\C6B0 \C624\C804 12:00\B85C \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(163693512506908039.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>80
,p_prompt=>unistr('CSS \D074\B798\C2A4')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D504\B85C\C81D\D2B8 \C0C1\D0DC\B97C \AE30\C900\C73C\B85C \B2EC\B825 \C2A4\D0C0\C77C \C9C0\C815</p>'),
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \B2EC\B825\C5D0 \D45C\C2DC\B41C \C774\BCA4\D2B8\C758 \C2A4\D0C0\C77C\C744 \C9C0\C815\D560 CSS \D074\B798\C2A4\AC00 \C788\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. <br>'),
unistr('\B2E4\C74C\C740 \C0AC\C6A9 \AC00\B2A5\D55C \AE30\BCF8 \D074\B798\C2A4\C785\B2C8\B2E4.'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('\B354 \B9CE\C740 CSS \D074\B798\C2A4 \CD94\AC00\C5D0 \B300\D55C \B0B4\C6A9\C740 \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604378152305541.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('REST \C6F9 \C11C\BE44\C2A4(JSON)')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B2EC\B825\C5D0 \D45C\C2DC\D560 RESTful \C6F9 \C11C\BE44\C2A4 \D53C\B4DC\C758 URL\C744 \C785\B825\D569\B2C8\B2E4. \B2EC\B825\C740 \C678\BD80 \C18C\C2A4\C5D0\C11C \AC80\C0C9\B41C JSON \B370\C774\D130\B97C \B80C\B354\B9C1\D560 \C218 \C788\C2B5\B2C8\B2E4(\C608: Oracle REST \B370\C774\D130 \C11C\BE44\C2A4). \C774\B7EC\D55C \C6F9 \C11C\BE44\C2A4\B294 \ACF5\C6A9\C774\AC70\B098 \C774 \B2EC\B825\C758 \BAA8\B4E0 \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \C81C\ACF5\B418\C5B4\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>JSON \D53C\B4DC \D615\C2DD\C740 \B2E4\C74C\C744 \D3EC\D568\D558\B3C4\B85D \C9C0\C815\B418\C5B4\C57C \D569\B2C8\B2E4.</p>'),
'<ol>',
unistr('<li>\C774\BCA4\D2B8 \BC30\C5F4 \BAA9\B85D\C5D0 <code>items</code> \D3EC\D568</li>'),
unistr('<li>\AC01 \C774\BCA4\D2B8 \AC1D\CCB4\C5D0 <code>{ id, title, start, allday, end, description }</code> \D3EC\D568<br>\C81C\BAA9 \BC0F \C2DC\C791 \C18D\C131\C740 \D544\C218\C785\B2C8\B2E4.</li>'),
'</ol>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604471144293543.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>30
,p_prompt=>unistr('\BCF4\CDA9 \C815\BCF4')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_examples=>'&EMPNO.'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BAA9\B85D \BCF4\AE30 \BC0F \B3C4\AD6C \C124\BA85\C5D0 \D45C\C2DC\B418\B294 \CD94\AC00 HTML\C744 \C785\B825\D569\B2C8\B2E4. &COLUMN. \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC HTML\C5D0 \C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4. </p>'),
unistr('<p>\CC38\ACE0: \C774 \BCF4\CDA9 \C815\BCF4\AC00 \C6D4, \C8FC \BC0F \C77C \BCF4\AE30\C5D0 \D45C\C2DC\B418\B3C4\B85D \D558\B824\BA74 \B3C4\AD6C \C124\BA85 \D45C\C2DC\B97C <strong>\C608</strong>\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(491266533374023782.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>75
,p_prompt=>unistr('\C8FC\B9D0 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \B2EC\B825\C5D0 \B300\D574 \D1A0\C694\C77C \BC0F \C77C\C694\C77C\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(518889601605918244.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>20
,p_prompt=>unistr('\C2DC\AC04 \D615\C2DD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'00'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\C774 \B2EC\B825\C5D0 \B300\D574 \C774\BCA4\D2B8\C758 \C2DC\AC04 \BD80\BD84\C744 \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C2DC\AC04 \D615\C2DD\C744 \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518893959287938933.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\AE30\BCF8\AC12')
,p_return_value=>'00'
,p_help_text=>unistr('\C804\C5ED\D654 \C544\B798\C5D0 \C785\B825\B41C \C560\D50C\B9AC\CF00\C774\C158 \C2DC\AC04\AE30\B85D \D615\C2DD\C744 \C0AC\C6A9\D569\B2C8\B2E4. \C774 \C18D\C131\C774 \CC44\C6CC\C9C0\C9C0 \C54A\C558\C73C\BA74 \B370\C774\D130\BCA0\C774\C2A4 NLS \C124\C815\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914467554939737.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4419)
,p_display_sequence=>20
,p_display_value=>unistr('12\C2DC\AC04')
,p_return_value=>'12'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>a.m.(\C815\C624 \C774\C804\C744 \C758\BBF8\D558\B294 \B77C\D2F4\C5B4 <em>ante meridiem</em>\C758 \C57D\C5B4) \BC0F p.m.(\C815\C624 \C774\D6C4\B97C \C758\BBF8\D558\B294 <em>post meridiem</em>\C758 \C57D\C5B4)\C744 \D3EC\D568\D55C 12\C2DC\AC04 \C2DC\ACC4\B97C \C0AC\C6A9\D574\C11C \C2DC\AC04\C744 \D45C\C2DC\D569\B2C8\B2E4(\C608: 8:00 a.m. \BC0F 4:00 p.m.).</p>'),
unistr('<p>a.m./p.m.\C758 \C2E4\C81C \D45C\C2DC \D615\C2DD\C740 \C2DC\AC04\AE30\B85D \D615\C2DD\C5D0\C11C \D30C\C0DD\B429\B2C8\B2E4(\C608: \B300\BB38\C790\D654 \BC0F \B9C8\CE68\D45C).</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914796377940460.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4419)
,p_display_sequence=>30
,p_display_value=>unistr('24\C2DC\AC04')
,p_return_value=>'24'
,p_help_text=>unistr('24\C2DC\AC04 \C2DC\ACC4\B97C \C0AC\C6A9\D574\C11C \C2DC\AC04\C744 \D45C\C2DC\D569\B2C8\B2E4(\C608: 08:00 \BC0F 16:00).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(623002076135066927.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>35
,p_prompt=>unistr('\B3C4\AD6C \C124\BA85 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0AC\C6A9\C790\AC00 \C774 \B2EC\B825\C5D0\C11C \C774\BCA4\D2B8 \C704\B85C \CEE4\C11C\B97C \AC00\C838\AC08 \B54C \B3C4\AD6C \C124\BA85\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p><em>\B4DC\B86D\B2E4\C6B4 \B300\D654\C0C1\C790\C5D0 \C774\BCA4\D2B8 \C774\B984, \BCF4\CDA9 \C815\BCF4 \BC0F \B0A0\C9DC \C138\BD80\C815\BCF4\AC00 \D45C\C2DC\B429\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(673441164964154995.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>25
,p_prompt=>unistr('\CCAB\BC88\C9F8 \C2DC\AC04')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'9'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\C8FC \BC0F \C77C \B2EC\B825\C5D0 \D45C\C2DC\B418\B294 \CCAB\BC88\C9F8 \C2DC\AC04\C744 \C9C0\C815\D558\B824\BA74 0~23 \C0AC\C774\C758 \C815\C218\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1218336983535257968.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>70
,p_prompt=>unistr('\CD5C\B300 \C774\BCA4\D2B8/\C77C')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C6D4 \BCF4\AE30 \B0B4\C5D0\C11C \AC01 \C77C\C5D0 \B300\D574 \D45C\C2DC\B418\B294 \CD5C\B300 \C774\BCA4\D2B8 \C218\B97C \C785\B825\D569\B2C8\B2E4. </p>'),
unistr('<p>\D2B9\C815 \B0A0\C9DC\C5D0 \C9C0\C815\B41C \C774\BCA4\D2B8 \C218\BCF4\B2E4 \B9CE\C740 \C774\BCA4\D2B8\AC00 \C788\C73C\BA74 \D574\B2F9 \B0A0\C9DC\C5D0\B294 <strong>\B354 \BCF4\AE30...</strong>\AC00 \D3EC\D568\B429\B2C8\B2E4. \C774 \D56D\BAA9\C744 \B204\B974\BA74 \D574\B2F9 \B0A0\C9DC\C758 \BAA8\B4E0 \C774\BCA4\D2B8\AC00 \D3EC\D568\B41C \D31D\C5C5 \CC3D\C774 \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2080058124058207989.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>32
,p_prompt=>unistr('\B2E4\C911 \D589 \C774\BCA4\D2B8')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>[\D45C\C2DC \C5F4] \D14D\C2A4\D2B8 \AE38\C774\B97C \AE30\C900\C73C\B85C \B2E4\C911 \D589\C5D0 \C774\BCA4\D2B8\B97C \D45C\C2DC\D558\B824\BA74 <strong>\C608</strong>\B97C \C120\D0DD\D569\B2C8\B2E4. </p>'),
unistr('<p>\AC01 \C774\BCA4\D2B8\B97C \B2E8\C77C \D589\C5D0 \D45C\C2DC\D558\ACE0 \D45C\C2DC\C5D0 \B9DE\C9C0 \C54A\B294 \D14D\C2A4\D2B8\B294 \C790\B974\B824\B294 \ACBD\C6B0\C5D0\B9CC <strong>\C544\B2C8\C624</strong>\B97C \C120\D0DD\D569\B2C8\B2E4. \C804\CCB4 \D14D\C2A4\D2B8\B294 \B3C4\AD6C \C124\BA85\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \B2E4\C911 \D589 \C774\BCA4\D2B8 \C124\C815\C740 \C6D4\BCC4 \BCF4\AE30 \B0B4\C5D0\C11C\B9CC \C0AC\C6A9\B429\B2C8\B2E4. \C8FC \B2E8\C704 \BC0F \C77C \B2E8\C704 \BCF4\AE30\C758 \ACBD\C6B0 \C774\BCA4\D2B8 \AE30\AC04\C774 \D45C\C2DC\B41C \C774\BCA4\D2B8\C758 \B192\C774\B97C \ACB0\C815\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(5924531429537178.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>1
,p_prompt=>unistr('\BC84\C804')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'FullCalendar 5'
,p_deprecated_values=>'3'
,p_help_text=>unistr('<p>FullCalendar 3\B294 \C0AC\C6A9\C774 \C911\B2E8\B418\C5C8\C73C\BA70 \ACE7 FullCalendar 5\B85C \BC14\B01D\B2C8\B2E4. \B530\B77C\C11C \D6C4\C18D \BC84\C804\C5D0\C11C \C560\D50C\B9AC\CF00\C774\C158\C774 \C190\C0C1\B418\C9C0 \C54A\B3C4\B85D \C9C0\AE08 \C804\D658\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\C815\C758 \CD08\AE30\D654 Javascript \CF54\B4DC\B97C \C0AC\C6A9\D55C \ACBD\C6B0 FullCalendar API\AC00 \BCC0\ACBD\B418\ACE0 \CF54\B4DC\B97C \C870\C815\D574\C57C \D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
end;
/
begin
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(5925071337539542.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(5924531429537178.4419)
,p_display_sequence=>10
,p_display_value=>unistr('FullCalendar 3[\C0AC\C6A9\B418\C9C0 \C54A\C74C]')
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(848019138346305412.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function ( pOptions) {',
'    pOptions.titleFormat      = "[Conference Schedule]";                                // custom title',
'    pOptions.slotMinTime      = "07:00:00";                                             // hide slots before minTime',
'    pOptions.slotMaxTime      = "18:00:00";                                             // hide slots after maxTime',
'    pOptions.dayHeaderFormat  = { weekday: ''short'', month: ''numeric'', day: ''numeric'' }; // week view column headings',
'    pOptions.slotDuration     = "00:15:00";                                             // custom slot duration',
'    pOptions.weekNumbers      = true;                                                   // show week numbers',
'    pOptions.weekText         = "CW";                                    ',
'    return pOptions;',
'}',
'</pre>'))
,p_help_text=>unistr('\D45C\C900 FullCalendar \CD08\AE30\D654 \C18D\C131\C744 \BB34\D6A8\D654\D558\B824\BA74 JavaScript \D568\C218\B97C \C785\B825\D569\B2C8\B2E4. \C774 \D568\C218\B294 \B2EC\B825 \CD08\AE30\D654 \C18D\C131\C744 \B9E4\AC1C\BCC0\C218\B85C \D3EC\D568\D558\B294 \AC1D\CCB4\B97C \BC18\D658\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(236983483525335070.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D504\B85C\C81D\D2B8 \C0C1\D0DC\B97C \AE30\C900\C73C\B85C \B2EC\B825 \C2A4\D0C0\C77C \C9C0\C815</p>,'),
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B2EC\B825\C5D0 \D45C\C2DC\B41C \C774\BCA4\D2B8\C758 \C2A4\D0C0\C77C\C744 \C9C0\C815\D560 CSS \D074\B798\C2A4\AC00 \C788\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \B2E4\C74C\C740 \C0AC\C6A9 \AC00\B2A5\D55C \AE30\BCF8 \D074\B798\C2A4\C785\B2C8\B2E4.</p>'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('<p>\B354 \B9CE\C740 CSS \D074\B798\C2A4 \CD94\AC00\C5D0 \B300\D55C \B0B4\C6A9\C740 \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100634228105571.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_name=>'apexcalendardateselect'
,p_display_name=>unistr('\B0A0\C9DC\AC00 \C120\D0DD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100238395105571.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_name=>'apexcalendareventselect'
,p_display_name=>unistr('\C774\BCA4\D2B8\AC00 \C120\D0DD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493099818743105570.4419)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4419)
,p_name=>'apexcalendarviewchange'
,p_display_name=>unistr('\BDF0\AC00 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_delete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723477031014918732.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_DELETE'
,p_display_name=>unistr('\D45C \D615\C2DD \D3FC - \B2E4\C911 \D589 \C0AD\C81C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_DELETE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\D45C \D615\C2DD \D3FC \C601\C5ED\C5D0\C11C \C5EC\B7EC \D589\C744 \C0AD\C81C\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477251489924376.4419)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D14C\C774\BE14 \C18C\C720\C790')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\D14C\C774\BE14 \C18C\C720\C790(\C2A4\D0A4\B9C8) \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477545882927054.4419)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D14C\C774\BE14 \C774\B984')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477251489924376.4419)
,p_help_text=>unistr('\B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\B294 \D14C\C774\BE14 \B610\B294 \C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BDF0 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477835530931825.4419)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\AE30\BCF8 \D0A4 \C5F4')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4419)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AE30\BCF8 \D0A4 \AC12\C774 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \B450 \BD80\BD84 \C774\C0C1\C758 \AE30\BCF8 \D0A4\AC00 \D3EC\D568\B41C \D14C\C774\BE14\C758 \ACBD\C6B0 <strong>ROWID</strong>\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\AE30\BCF8 \D0A4\B294 \C0AD\C81C\D560 \D589\C744 \C2DD\BCC4\D558\B294 \B370 \C0AC\C6A9\B418\BA70 \D45C \D615\C2DD \D3FC\C5D0\C11C \D3B8\C9D1\D560 \C218 \C5C6\C5B4\C57C \D569\B2C8\B2E4. \C0C8 \D589\C758 \ACBD\C6B0 \AE30\BCF8 \D0A4 \AC12\C774 \BE44\C5B4 \C788\C5B4\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478159456935961.4419)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\BCF4\C870 \D0A4 \C5F4')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4419)
,p_help_text=>unistr('\B450\BC88\C9F8 \AE30\BCF8 \D0A4 \AC12\C774 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C18D\C131\C740 \AE30\BCF8 \D0A4\AC00 \B450 \AC1C \C5F4\B85C \AD6C\C131\B41C \ACBD\C6B0\C5D0\B9CC \CC44\C6CC\C838\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478847798956469.4419)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\B7F0\D0C0\C784 Where \C808')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B2E4\C74C\C744 \C0AC\C6A9\D574\C11C \BD80\C11C\B97C \C81C\D55C\D569\B2C8\B2E4.'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('\C0DD\C131\B41C DELETE \BB38\C5D0 \CD94\AC00\D560 SQL WHERE \C808\C744 \C785\B825\D569\B2C8\B2E4. \C790\B3D9 \C0DD\C131\B41C SQL \D638\CD9C\C5D0\C11C \C0AC\C6A9\B418\B294 \B808\CF54\B4DC\B97C \C81C\D55C\D558\B824\BA74 \C774 \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/process_type/user_preferences
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723624323202892766.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'USER_PREFERENCES'
,p_display_name=>unistr('\C0AC\C6A9\C790 \D658\ACBD\C124\C815')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','USER_PREFERENCES'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\C5D0 \B300\D574 \C0AC\C6A9\C790 \D658\ACBD\C124\C815\C744 \C124\C815\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723624639568915612.4419)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'RESET_USER_PREFERENCES'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C0AC\C6A9\C790 \D658\ACBD\C124\C815\C744 \C7AC\C124\C815 \B610\B294 \C124\C815\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723626924903922340.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D658\ACBD\C124\C815 \C7AC\C124\C815(\D604\C7AC \C0AC\C6A9\C790\C5D0 \B300\D55C \BAA8\B4E0 \D658\ACBD\C124\C815 \C81C\AC70)')
,p_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627321668923828.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D56D\BAA9 \AC12\C73C\B85C \C124\C815')
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627719296924995.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\B110\C774 \C544\B2CC \ACBD\C6B0 \D56D\BAA9 \AC12\C73C\B85C \C124\C815')
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631645557973527.4419)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D658\ACBD\C124\C815 \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_text_case=>'UPPER'
,p_help_text=>unistr('\D658\ACBD\C124\C815 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631934127978868.4419)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_help_text=>unistr('\D658\ACBD\C124\C815 \AC12\C744 \C800\C7A5\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C120\D0DD\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723640922660606468.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS'
,p_display_name=>unistr('\C790\B3D9 \D589 \D504\B85C\C138\C2F1(DML)')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\B2E8\C77C \B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14 \B610\B294 \C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BDF0\C5D0 \B300\D574 \B808\CF54\B4DC\B97C \C0BD\C785, \C5C5\B370\C774\D2B8 \B610\B294 \C0AD\C81C\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4. \C774 \D504\B85C\C138\C2A4\B294 <strong>\B370\C774\D130\BCA0\C774\C2A4 \C5F4</strong> \C720\D615\C758 \C18C\C2A4\B97C \D3EC\D568\D558\B294 \D3FC \D56D\BAA9\C744 \CC98\B9AC\D558\AE30 \C704\D574 \C0AC\C6A9\B429\B2C8\B2E4. \C774 \D504\B85C\C138\C2A4\C5D0 \B300\D574 \C785\B825\B41C \C18D\C131\C740 <em>\C790\B3D9 \D589 \C778\CD9C</em> \D504\B85C\C138\C2A4\C5D0 \C785\B825\B41C \C18D\C131\ACFC \C5F0\AD00\B418\C5B4\C57C \D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641240116613584.4419)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D14C\C774\BE14 \C18C\C720\C790')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\D14C\C774\BE14 \C18C\C720\C790(\C2A4\D0A4\B9C8) \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641536018615468.4419)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D14C\C774\BE14 \C774\B984')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641240116613584.4419)
,p_help_text=>unistr('\B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\B294 \D14C\C774\BE14 \B610\B294 \BDF0 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641830196618138.4419)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\AE30\BCF8 \D0A4 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\AE30\BCF8 \D0A4 \C5F4 \AC12\C744 \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642126745619762.4419)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('\AE30\BCF8 \D0A4 \C5F4 ')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4419)
,p_help_text=>unistr('\AE30\BCF8 \D0A4 \AC12\C774 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \B450 \BD80\BD84 \C774\C0C1\C758 \AE30\BCF8 \D0A4\AC00 \D3EC\D568\B41C \D14C\C774\BE14\C758 \ACBD\C6B0 <strong>ROWID</strong>\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642422001622013.4419)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('\BCF4\C870 \D0A4 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\BCF4\C870 \D0A4 \C5F4 \AC12\C744 \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642713590625893.4419)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('\BCF4\C870 \D0A4 \C5F4')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4419)
,p_depending_on_attribute_id=>wwv_flow_api.id(723642126745619762.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('\B450\BC88\C9F8 \AE30\BCF8 \D0A4 \AC12\C774 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C18D\C131\C740 \AE30\BCF8 \D0A4\AC00 \B450 \AC1C \C5F4\B85C \AD6C\C131\B41C \ACBD\C6B0\C5D0\B9CC \CC44\C6CC\C838\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646536850919017.4419)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\D589 \BC84\C804 \C5F4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D589 \BC84\C804\C744 \C2DD\BCC4\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C5F4\C740 \D398\C774\C9C0\C5D0 \C788\C9C0 \C54A\C544\B3C4 \B429\B2C8\B2E4. \B0B4\C7A5\B41C \CCB4\D06C\C12C\C744 \C0AC\C6A9\D558\B824\BA74 \C774 \C18D\C131\C744 \BE44\C6CC\B461\B2C8\B2E4.</p>'),
unistr('<p>\B099\AD00\C801 \C7A0\AE08\C740 \B204\B77D\B41C \C5C5\B370\C774\D2B8 \AC10\C9C0\B97C \C0AC\C6A9\D574\C11C \B370\C774\D130\AC00 \B3D9\C2DC\C5D0 \C561\C138\C2A4\B420 \C218 \C788\B294 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \B370\C774\D130 \BB34\ACB0\C131\C744 \BCF4\C7A5\D569\B2C8\B2E4. &PRODUCT_NAME.\C740(\B294) \B0B4\C7A5\B41C \CCB4\D06C\C12C\C744 \C0AC\C6A9\D574\C11C \B204\B77D\B41C \C5C5\B370\C774\D2B8 \AC10\C9C0\B97C \C218\D589\D558\ACE0 \D589 \BC84\C804\C744 \D655\C778\D569\B2C8\B2E4. \CCB4\D06C\C12C\C740 \D2B9\C815 \D14C\C774\BE14 \D589\C5D0 \B300\D55C \BAA8\B4E0 \C5F4 \AC12\C758 \D574\C2DC \D568\C218\C785\B2C8\B2E4. \B808\CF54\B4DC\AC00 <em>\C790\B3D9 \D589 \C778\CD9C</em>\C758 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \C9C8\C758\B420 \B54C \AC80\C0C9\B41C \D6C4 \D504\B85C\C138\C2A4\C758 \C77C\BD80\B85C \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C788\B294 \D604\C7AC \B808\CF54\B4DC\C758 \D574\C2DC\C640 ')
||unistr('\BE44\AD50\B429\B2C8\B2E4. \B450 \AC12\C774 \B3D9\C77C\D558\BA74 \C5C5\B370\C774\D2B8\AC00 \ACC4\C18D \C218\D589\B418\ACE0, \ADF8\B807\C9C0 \C54A\C73C\BA74 \C774 \D504\B85C\C138\C2A4\C5D0\C11C \C624\B958\AC00 \BC1C\C0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \C18D\C131\C744 \C0AC\C6A9\D558\BA74 \B0B4\C7A5\B41C \CCB4\D06C\C12C \D504\B85C\C138\C2F1\C744 \C0AC\C6A9\D558\B294 \B300\C2E0 \D589 \BC84\C804\C744 \C800\C7A5\D558\B294 \B2E8\C77C \C5F4\C744 \C9C0\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774 \C5F4\C740 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \B808\CF54\B4DC\AC00 \C5C5\B370\C774\D2B8\B420 \B54C\B9C8\B2E4 \C5C5\B370\C774\D2B8\B418\C5B4\C57C \D569\B2C8\B2E4. Oracle\C740 \D589 \BC84\C804 \C5F4\C744 \C99D\BD84 \B610\B294 \C5C5\B370\C774\D2B8\D558\AE30 \C704\D574 \D14C\C774\BE14\C5D0\C11C <em>\C5C5\B370\C774\D2B8 \C774\C804</en> \B370\C774\D130\BCA0\C774\C2A4 \D2B8\B9AC\AC70\B97C \AD6C\D604\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4. NUMBER \C5F4\C740 \D589\C758 \C2DC\D000\C2A4 \BC88\D638\B97C \D3EC\D568\D560 \AC83\C73C\B85C \CD94\C815\B429\B2C8\B2E4. \D558\C9C0\B9CC DATE \BC0F TIMESTAMP \C5F4\B3C4 \C0AC\C6A9')
||unistr('\D560 \C218 \C788\C2B5\B2C8\B2E4. \B2E8\C77C \C5F4\C744 \C0AC\C6A9\D560 \B54C\C758 \C7A5\C810\C740 &PRODUCT_NAME. \C5D4\C9C4\C774 \C804\CCB4 \D589\C758 \D574\C2DC\B97C \C218\D589\D560 \D544\C694\AC00 \C5C6\C73C\BA70, \B300\C2E0 \B2E8\C77C \C5F4 \AC12\C744 \BE44\AD50\D560 \C218 \C788\B2E4\B294 \AC83\C785\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646022259834604.4419)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\B7F0\D0C0\C784 Where \C808')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BD80\C11C\B97C \C81C\D55C\D569\B2C8\B2E4.</p>'),
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('\C0DD\C131\B41C \BAA8\B4E0 INSERT, UPDATE \BC0F DELETE \BB38\C5D0 \CD94\AC00\D560 SQL WHERE \C808\C744 \C785\B825\D569\B2C8\B2E4. \C790\B3D9 \C0DD\C131\B41C SQL \D638\CD9C\C5D0\C11C \C0AC\C6A9\B418\B294 \B808\CF54\B4DC\B97C \C81C\D55C\D558\B824\BA74 \C774 \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842218629998562.4419)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\D56D\BAA9\C5D0 \D0A4 \BC18\D658')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>SQL INSERT \BB38\C5D0\C11C \BC18\D658\B41C \AE30\BCF8 \D0A4 \C5F4 \AC12\C744 \C800\C7A5\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C2DC\D000\C2A4 \B610\B294 \B370\C774\D130\BCA0\C774\C2A4 \D2B8\B9AC\AC70\B85C \CC44\C6CC\C9C4 \AE30\BCF8 \D0A4 \D544\B4DC\B97C \B418\B3CC\B9AC\B824\BA74 \C774 \C5F4\C744 \C9C0\C815\D569\B2C8\B2E4. \C774 \AC12\C740 \D504\B85C\C138\C2A4\C5D0 \C758\D574 \C138\C158 \C0C1\D0DC\B85C \C124\C815\B429\B2C8\B2E4. </p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842512807001262.4419)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\D56D\BAA9\C5D0 \B450\BC88\C9F8 \D0A4 \BC18\D658')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('SQL INSERT \BB38\C5D0\C11C \BC18\D658\B41C \B450\BC88\C9F8 \AE30\BCF8 \D0A4 \C5F4 \AC12\C744 \C800\C7A5\D560 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361843216017030111.4419)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\C9C0\C6D0\B418\B294 \C791\C5C5')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>true
,p_default_value=>'I:U:D'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C9C0\C6D0\B418\B294 DML(\B370\C774\D130 \C870\C791 \C5B8\C5B4) \C791\C5C5\C744 \D655\C778\D569\B2C8\B2E4. \C774 \B370\C774\D130 \C870\C791 \D504\B85C\C138\C2A4\B294 \C694\CCAD \AC12\C774 \B098\C5F4\B41C \AC12 \C911 \D558\B098\C77C \B54C DML\C744 \C218\D589\D569\B2C8\B2E4. \B2E8\CD94\B97C \C0AC\C6A9\D574\C11C \C774 \D398\C774\C9C0\B97C \C81C\CD9C\D558\BA74 \C694\CCAD \AC12\C774 \D574\B2F9 \B2E8\CD94\C5D0 \C758\D574 \C124\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471227178028863.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C0BD\C785')
,p_return_value=>'I'
,p_help_text=>unistr('\C694\CCAD \AC12\C73C\B85C \D2B8\B9AC\AC70\B428: INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471623727030373.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C5C5\B370\C774\D2B8')
,p_return_value=>'U'
,p_help_text=>unistr('\C694\CCAD \AC12\C73C\B85C \D2B8\B9AC\AC70\B428: SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362472022649030909.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C0AD\C81C')
,p_return_value=>'D'
,p_help_text=>unistr('\C694\CCAD \AC12\C73C\B85C \D2B8\B9AC\AC70\B428: DELETE, REMOVE, DELETE ROW, DROP')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(216670983590615543.4419)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>105
,p_prompt=>unistr('\D589 \C7A0\ADF8\AE30')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('<p>\D589\C744 \CC98\B9AC\D558\AE30 \C804\C5D0 \C5C5\B370\C774\D2B8\D558\AC70\B098 \C0AD\C81C\D560 \AC01 \D589\C774 \AE30\BCF8 \D14C\C774\BE14\C5D0\C11C \C7A0\AE30\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_focus
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854773928315984269.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_FOCUS'
,p_display_name=>unistr('\D3EC\CEE4\C2A4 \C124\C815')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_FOCUS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C601\D5A5\C744 \BC1B\B294 \C694\C18C\B85C \D3EC\CEE4\C2A4\B97C \C124\C815\D569\B2C8\B2E4. \C601\D5A5\C744 \BC1B\B294 \C694\C18C\AC00 \C5EC\B7EC \AC1C \C788\C73C\BA74 \AE30\BCF8\C801\C73C\B85C \CCAB\BC88\C9F8 \C694\C18C\C5D0 \C801\C6A9\B429\B2C8\B2E4. \C774 \AE30\B2A5\C740 \C0AC\C6A9\C790\C5D0\AC8C \C801\D569\D55C \D56D\BAA9\C744 \C989\C2DC \D45C\C2DC\D558\AE30 \C704\D574 <em>\D45C\C2DC</em> \BC0F <em>\C0AC\C6A9\C73C\B85C \C124\C815</em> \C791\C5C5\ACFC \D568\AED8 \C0AC\C6A9\D560 \B54C \D2B9\D788 \C720\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/submit_page
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854776817374066356.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SUBMIT_PAGE'
,p_display_name=>unistr('\D398\C774\C9C0 \C81C\CD9C')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SUBMIT_PAGE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D398\C774\C9C0\B97C \C81C\CD9C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(854777422315124533.4419)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C694\CCAD/\B2E8\CD94 \C774\B984')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\D398\C774\C9C0 \C81C\CD9C\C744 \C704\D574 \C0AC\C6A9\B418\B294 \C694\CCAD \AC12\C744 \C785\B825\D569\B2C8\B2E4. \B2E8\CD94\AC00 \B3D9\C801 \C791\C5C5\C744 \D2B8\B9AC\AC70\D560 \ACBD\C6B0 \C774 \AC12\C744 \B2E8\CD94 \C774\B984\C73C\B85C \C124\C815\D569\B2C8\B2E4. \C774\B807\AC8C \D558\BA74 \D398\C774\C9C0 \CC98\B9AC \C911\C5D0 \B2E8\CD94\C758 <em>\C2E4\D589 \AC80\C99D</em> \C18D\C131\C774 \C801\C6A9\B418\B3C4\B85D \BCF4\C7A5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477648707512082509.4419)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\CC98\B9AC \C911 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\D604\C7AC \D398\C774\C9C0\B97C \D68C\C0C9 \CC98\B9AC\D558\ACE0 \D398\C774\C9C0 \C81C\CD9C \C911 ''\D504\B85C\C138\C2F1'' \C2A4\D0C0\C77C \C560\B2C8\BA54\C774\C158\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C774 \C635\C158\C740 \BCF4\ACE0\C11C\B97C \C0C8\B85C\ACE0\CE68\D558\B294 \C18D\B3C4\AC00 \B290\B9B4 \B54C \C77C\BC18 \C0AC\C6A9\C790\AC00 \AC80\C0C9 \B2E8\CD94\B97C \B2E4\C2DC \B204\B974\B294 \ACBD\C6B0\C640 \AC19\C774 \C7A5\AE30 \C2E4\D589 \C791\C5C5 \C911\C5D0 \C77C\BC18 \C0AC\C6A9\C790\C758 \C791\C5C5\C744 \BC29\C9C0\D558\B294 \B370 \C720\C6A9\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/item_type/number_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(858626633540183539.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'NUMBER_FIELD'
,p_display_name=>unistr('\C22B\C790 \D544\B4DC')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','NUMBER_FIELD'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_NUMBER:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\C22B\C790 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4. \C774 \D56D\BAA9 \C720\D615\C740 \AC12\C774 \C22B\C790\C778\C9C0 \C790\B3D9\C73C\B85C \AC80\C99D\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627014886206552.4419)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\CD5C\C18C\AC12')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>0</code></li>',
'<li><code>0.99</code></li>',
'<li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\D5C8\C6A9\B418\B294 \CD5C\C18C\AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C815\C801 \AC12\C774\AC70\B098 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D55C \B3D9\C801 \AC12\C77C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627524583209309.4419)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\CD5C\B300\AC12')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>1000</code></li>',
'<li><code>49.99</code></li>',
'<li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\D5C8\C6A9\B418\B294 \CD5C\B300\AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C815\C801 \AC12\C774\AC70\B098 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D55C \B3D9\C801 \AC12\C77C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858676504215733205.4419)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C22B\C790 \C815\B82C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'right'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D45C\C2DC\B418\B294 \C22B\C790\C758 \C815\B82C \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4. \D56D\BAA9\C774 <em>\C77D\AE30 \C804\C6A9</em>\C73C\B85C \B80C\B354\B9C1\B418\AC70\B098 <strong>HTML \D3FC \C694\C18C \C18D\C131</strong>\C774 \C9C0\C815\B418\B294 \ACBD\C6B0 \C774 \C124\C815\C774 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678212526735663.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C67C\CABD')
,p_return_value=>'left'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678618067737263.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\AC00\C6B4\B370')
,p_return_value=>'center'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858679023954738917.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C624\B978\CABD')
,p_return_value=>'right'
);
end;
/
prompt --application/shared_components/plugins/item_type/slider
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(880057283386968314.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SLIDER'
,p_display_name=>unistr('\C2AC\B77C\C774\B354')
,p_supported_ui_types=>'JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SLIDER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C0AC\C6A9\C790\AC00 \CF58\D2B8\B864\C744 \C67C\CABD \B610\B294 \C624\B978\CABD\C73C\B85C \BC00\C5B4\C11C \D56D\BAA9 \AC12\C744 \C5C5\B370\C774\D2B8\D560 \C218 \C788\AC8C \D574\C8FC\B294 \C2AC\B77C\C774\B354 \D56D\BAA9 \C720\D615\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880057664732991327.4419)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\CD5C\C18C\AC12')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'0'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>0</code></li>',
'  <li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\D5C8\C6A9\B418\B294 \CD5C\C18C\AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C815\C801 \AC12\C774\AC70\B098 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D55C \B3D9\C801 \AC12\C77C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880058174429994084.4419)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\CD5C\B300\AC12')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'100'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>100</code></li>',
'  <li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\D5C8\C6A9\B418\B294 \CD5C\B300\AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C815\C801 \AC12\C774\AC70\B098 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D55C \B3D9\C801 \AC12\C77C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880107154062517980.4419)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\B2E8\ACC4 \C99D\BD84')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>5</code></li>',
'  <li><code>&P1_STEP_SIZE.</code></li>',
'</ul>'))
,p_help_text=>unistr('\C2AC\B77C\C774\B354\B97C \D2B9\C815 \C99D\BD84\C73C\B85C \AC15\C81C \C2A4\B0C5\D558\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C774 \AC12\C740 \C815\C801 \AC12\C774\AC70\B098 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D55C \B3D9\C801 \AC12\C77C \C218 \C788\C2B5\B2C8\B2E4.')
,p_attribute_comment=>'$$$ DJP - No default value set = 1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10717732308427631.4419)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C120\D0DD\B41C \D56D\BAA9 \AC15\C870 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\C2AC\B77C\C774\B354\AC00 \D604\C7AC \C2AC\B77C\C774\B354 \D578\B4E4 \C704\CE58\AE4C\C9C0 \D2B8\B799\C744 \AC15\C870 \D45C\C2DC\D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/process_type/send_email
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(956011735689077213.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SEND_EMAIL'
,p_display_name=>unistr('\C804\C790\BA54\C77C \C804\C1A1')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SEND_EMAIL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C804\C790\BA54\C77C \BC0F \D558\B098 \C774\C0C1\C758 \CCA8\BD80 \D30C\C77C(\C120\D0DD\C0AC\D56D)\C744 \C804\C1A1\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956092037052376563.4419)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\CD9C\CC98')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'&APP_EMAIL.'
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>noreply@test.com</code></li>',
'<li><code>Do not reply &lt;noreply@test.com&gt;</code></li>',
'<li><code>&amp;P6_FROM.</code></li>',
'</ul>'))
,p_help_text=>unistr('\C804\C790\BA54\C77C\C758 \BCF4\B0B8 \C0AC\B78C\C73C\B85C \D45C\C2DC\D560 \C804\C790\BA54\C77C \C8FC\C18C\B97C \C785\B825\D569\B2C8\B2E4. \C774 \C804\C790\BA54\C77C \C8FC\C18C\B294 \C801\D569\D55C \C8FC\C18C\C5EC\C57C \D569\B2C8\B2E4. \ADF8\B807\C9C0 \C54A\C73C\BA74 \BA54\C2DC\C9C0\AC00 \C804\C1A1\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \B3D9\C801 \AC12\C744 \C0AC\C6A9\D558\B824\BA74 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956050619869980888.4419)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\BC1B\B294 \C0AC\B78C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('\D558\B098 \C774\C0C1\C758 \C804\C790\BA54\C77C \C8FC\C18C\B97C \C9C0\C815\D558\C5EC \C804\C790\BA54\C77C \BC1B\B294 \C0AC\B78C\C744 \C785\B825\D569\B2C8\B2E4. \C804\C790\BA54\C77C \C8FC\C18C\AC00 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \C0AC\C6A9\D569\B2C8\B2E4. \B3D9\C801 \AC12\C744 \C0AC\C6A9\D558\B824\BA74 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956051928180983251.4419)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\CC38\C870')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_CC.</code></li>',
'</ul>'))
,p_help_text=>unistr('\D558\B098 \C774\C0C1\C758 \C804\C790\BA54\C77C \C8FC\C18C\B97C \C9C0\C815\D558\C5EC \CC38\C870 \C804\C790\BA54\C77C \BC1B\B294 \C0AC\B78C\C744 \C785\B825\D569\B2C8\B2E4. \C804\C790\BA54\C77C \C8FC\C18C\AC00 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \C0AC\C6A9\D569\B2C8\B2E4. \B3D9\C801 \AC12\C744 \C0AC\C6A9\D558\B824\BA74 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956052531990984386.4419)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C228\C740 \CC38\C870')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_BCC.</code></li>',
'</ul>'))
,p_help_text=>unistr('\D558\B098 \C774\C0C1\C758 \C804\C790\BA54\C77C \C8FC\C18C\B97C \C9C0\C815\D558\C5EC \C228\C740 \CC38\C870 \C804\C790\BA54\C77C \BC1B\B294 \C0AC\B78C\C744 \C785\B825\D569\B2C8\B2E4. \C804\C790\BA54\C77C \C8FC\C18C\AC00 \C5EC\B7EC \AC1C\C778 \ACBD\C6B0 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C744 \C0AC\C6A9\D569\B2C8\B2E4. \B3D9\C801 \AC12\C744 \C0AC\C6A9\D558\B824\BA74 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082217032200544.4419)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\D68C\C2E0 \B300\C0C1')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_REPLY_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('\BC1B\B294 \C0AC\B78C\C774 \D68C\C2E0\D560 \C804\C790\BA54\C77C \C8FC\C18C\B97C \C785\B825\D569\B2C8\B2E4. \C9C0\C815\B418\C9C0 \C54A\C740 \ACBD\C6B0 <strong>\BCF4\B0B8 \C0AC\B78C</strong>\C5D0 \C785\B825\B41C \C804\C790\BA54\C77C \C8FC\C18C\AC00 \C0AC\C6A9\B429\B2C8\B2E4. \B3D9\C801 \AC12\C744 \C0AC\C6A9\D558\B824\BA74 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053241340987086.4419)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>unistr('\C81C\BAA9')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4419)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('\C804\C790\BA54\C77C\C758 \C81C\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \B3D9\C801 \AC12\C744 \D3EC\D568\D558\B824\BA74 <code>&amp;P6_PRODUCT_NAME.</code>\ACFC(\C640) \AC19\C740 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053823463991423.4419)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>80
,p_prompt=>unistr('\BCF8\BB38(\C77C\BC18 \D14D\C2A4\D2B8)')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C804\C790\BA54\C77C\C758 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \BC1B\B294 \C0AC\B78C\C758 \C804\C790\BA54\C77C \D074\B77C\C774\C5B8\D2B8\AC00 \C11C\C2DD \C788\B294 \D14D\C2A4\D2B8 \D45C\C2DC\B97C \C9C0\C6D0\D558\C9C0 \C54A\C744 \ACBD\C6B0 \C77C\BC18 \D14D\C2A4\D2B8 \BC84\C804\C774 \C0AC\C6A9\B429\B2C8\B2E4. \D14D\C2A4\D2B8\C5D0 \B3D9\C801 \CF58\D150\CE20\B97C \D3EC\D568\D558\B824\BA74 <code>&amp;P6_PRODUCT_NAME.</code>\ACFC(\C640) \AC19\C740 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: SMTP/MIME \C0AC\C591\C5D0\C11C\B294 \B2E8\C77C \D589\C774 1000\C790\B97C \CD08\ACFC\D574\C11C\B294 \C548\B429\B2C8\B2E4. \C774\B7EC\D55C \C81C\D55C\C744 \C900\C218\D558\AE30 \C704\D574\C11C\B294 \CE90\B9AC\C9C0 \B9AC\D134 \B610\B294 \C904 \BC14\AFC8 \BB38\C790\B97C \CD94\AC00\D558\C5EC \D14D\C2A4\D2B8\B97C 1000\C790 \BBF8\B9CC\C73C\B85C \BD84\D560\D574\C57C \D569\B2C8\B2E4. \C774\B807\AC8C \D558\C9C0 \C54A\C73C\BA74 \BA54\C2DC\C9C0\AC00 \C77C\BD80\B9CC \D45C\C2DC\B418\AC70\B098 \CD94\AC00 \D14D\C2A4\D2B8\C5D0 \B300\D574 \B290\B08C\D45C\AC00 \D45C\C2DC\B41C \BA54\C2DC\C9C0\B97C \D3EC\D568\D558\C5EC \C804\C790\BA54\C77C \BA54\C2DC\C9C0\C5D0\C11C \C624\B958\AC00 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082724997202851.4419)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>90
,p_prompt=>unistr('\BCF8\BB38(HTML)')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4419)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C77C\BC18 \D14D\C2A4\D2B8 \BC0F HTML \CF58\D150\CE20\B97C \BAA8\B450 \D3EC\D568\D558\B294 \C5EC\B7EC \BD80\BD84\C73C\B85C \AD6C\C131\B41C HTML \BA54\C2DC\C9C0\AC00 \C0DD\C131\B418\B3C4\B85D \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \BC1B\B294 \C0AC\B78C\C758 \C804\C790\BA54\C77C \D074\B77C\C774\C5B8\D2B8 \C124\C815 \BC0F \AE30\B2A5\C5D0 \B530\B77C \D45C\C2DC\B418\B294 \B0B4\C6A9\C774 \ACB0\C815\B429\B2C8\B2E4. \B300\BD80\BD84\C758 \CD5C\C2E0 \C804\C790\BA54\C77C \D074\B77C\C774\C5B8\D2B8\C5D0\C11C\B294 HTML \D615\C2DD\C758 \C804\C790\BA54\C77C\C744 \C77D\C744 \C218 \C788\C9C0\B9CC \C77C\BD80 \C0AC\C6A9\C790\B294 \BCF4\C548 \BB38\C81C\B97C \D574\ACB0\D558\AE30 \C704\D574 \C774 \AE30\B2A5\C744 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D558\AE30\B3C4 \D569\B2C8\B2E4. \D14D\C2A4\D2B8\C5D0 \B3D9\C801 \CF58\D150\CE20\B97C \D3EC\D568\D558\B824\BA74 <code>&amp;P6_PRODUCT')
||unistr('_NAME.</code>\ACFC(\C640) \AC19\C740 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
unistr('<p>&lt;img /&gt; \D0DC\ADF8\B97C \C0AC\C6A9\D574\C11C \C774\BBF8\C9C0\B97C \CC38\C870\D560 \B54C\B294 \C774\BBF8\C9C0\B97C \BCF4\AE30 \C704\D574 \BC1B\B294 \C0AC\B78C\C758 \C804\C790\BA54\C77C \D074\B77C\C774\C5B8\D2B8\C5D0\C11C \C774\BBF8\C9C0\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C5B4\C57C \D55C\B2E4\B294 \AC83\C5D0 \C8FC\C758\D558\C2ED\C2DC\C624. \C608\B97C \B4E4\C5B4, \B124\D2B8\C6CC\D06C\C5D0\C11C \B2E4\C74C\ACFC \AC19\C774 hello.gif\B77C\B294 \C774\BBF8\C9C0\B97C \CC38\C870\D55C\B2E4\ACE0 \AC00\C815\D574\BCF4\C2ED\C2DC\C624.</p>'),
'<pre>',
'&lt;img src=&quot;http://example.com/hello.gif&quot; alt=&quot;Hello&quot; /&gt;',
'</pre>',
unistr('<p>\C774 \C608\C81C\C5D0\C11C \C774\BBF8\C9C0\B294 \C804\C790\BA54\C77C\C5D0 \CCA8\BD80\B418\C9C0 \C54A\C9C0\B9CC \C804\C790\BA54\C77C\C5D0\C11C \CC38\C870\B429\B2C8\B2E4. \BC1B\B294 \C0AC\B78C\C774 \C774\BBF8\C9C0\B97C \BCFC \C218 \C788\C73C\B824\BA74 \C6F9 \BE0C\B77C\C6B0\C800\B97C \C0AC\C6A9\D574\C11C \C774\BBF8\C9C0\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C5B4\C57C \D569\B2C8\B2E4. \C774\BBF8\C9C0\AC00 \BC29\D654\BCBD \B0B4\C5D0 \C788\ACE0 \BC1B\B294 \C0AC\B78C\C774 \BC29\D654\BCBD \C678\BD80\C5D0 \C788\B294 \ACBD\C6B0 \C774\BBF8\C9C0\AC00 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \B530\B77C\C11C \C774 \ACBD\C6B0\C5D0\B294 \C774\BBF8\C9C0\B97C \C0AC\C6A9\D558\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4. \C774\BBF8\C9C0\B97C \BC18\B4DC\C2DC \D3EC\D568\D574\C57C \D560 \ACBD\C6B0\C5D0\B294 \C774\BBF8\C9C0\C5D0 \C561\C138\C2A4\D560 \C218 \C5C6\B294 \ACBD\C6B0\B97C \B300\BE44\D574\C11C ALT \C18D\C131\C744 \D3EC\D568\D558\C5EC \D14D\C2A4\D2B8 \C124\BA85\C744 \C81C\ACF5\D574')
||unistr('\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: SMTP/MIME \C0AC\C591\C5D0\C11C\B294 \B2E8\C77C \D589\C774 1000\C790\B97C \CD08\ACFC\D574\C11C\B294 \C548\B429\B2C8\B2E4. \C774\B7EC\D55C \C81C\D55C\C744 \C900\C218\D558\AE30 \C704\D574\C11C\B294 \CE90\B9AC\C9C0 \B9AC\D134 \B610\B294 \C904 \BC14\AFC8 \BB38\C790\B97C \CD94\AC00\D558\C5EC \D14D\C2A4\D2B8\B97C 1000\C790 \BBF8\B9CC\C73C\B85C \BD84\D560\D574\C57C \D569\B2C8\B2E4. \C774\B807\AC8C \D558\C9C0 \C54A\C73C\BA74 \BA54\C2DC\C9C0\AC00 \C77C\BD80\B9CC \D45C\C2DC\B418\AC70\B098 \CD94\AC00 \D14D\C2A4\D2B8\C5D0 \B300\D574 \B290\B08C\D45C\AC00 \D45C\C2DC\B41C \BA54\C2DC\C9C0\B97C \D3EC\D568\D558\C5EC \C804\C790\BA54\C77C \BA54\C2DC\C9C0\C5D0\C11C \C624\B958\AC00 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956084325437259694.4419)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>unistr('\CCA8\BD80 SQL')
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>SQL \BB38\C740 \B2E4\C74C \D615\C2DD\C774\C5B4\C57C \D569\B2C8\B2E4.</p>'),
'<pre>',
'select blob_column,',
'       file_name,',
'       mime_type,',
'       content_id',
'  from table',
'</pre>',
unistr('<p>mime_type \BC0F content_id \C5F4\C740 \C120\D0DD\C0AC\D56D\C785\B2C8\B2E4. content_id\AC00 \C788\C73C\BA74 \D30C\C77C\C774 \C778\B77C\C778\C73C\B85C \CCA8\BD80\B418\ACE0 content_id \AC12\C774 \CCA8\BD80 \D30C\C77C\C758 CID\C5D0 \C0AC\C6A9\B429\B2C8\B2E4.</p>'),
unistr('<p>content_id \C5F4\C5D0 ''my_inline_content'' \AC12\C774 \D3EC\D568\B41C \ACBD\C6B0 \D574\B2F9 \B2E4\C74C HTML\C744 \C0AC\C6A9\D558\C5EC \D574\B2F9 \C774\BBF8\C9C0\B97C \C804\C790\BA54\C77C\C5D0 \D3EC\D568\C2DC\D0AC \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<p>',
'<pre>',
'&lt;div&gt;',
unistr('&nbsp;&nbsp;&lt;h1&gt;\C77C\BD80 \D3EC\D568 \CF58\D150\CE20&lt;/h1&gt;'),
'&nbsp;&nbsp;&lt;p&gt;',
'&nbsp;&nbsp;&nbsp;&nbsp;&lt;img src="cid:my_inline_content" alt="Inline Image" &gt;',
'&nbsp;&nbsp;&lt;/p&gt;',
'&lt;/div&gt;',
'</pre>',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C804\C790\BA54\C77C\C5D0 \D30C\C77C\B85C \CCA8\BD80\B41C \D558\B098 \C774\C0C1\C758 BLOB\C744 \BC18\D658\D558\B294 SQL \BB38\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>content_id \C5F4\C5D0 \B110 \AC12\C774 \D3EC\D568\B41C \ACBD\C6B0 \C5F0\AD00\B41C \D30C\C77C\C740 \C77C\BC18 \CCA8\BD80 \D30C\C77C\C774 \B429\B2C8\B2E4. \BB38\C11C\B098 zip \C544\CE74\C774\BE0C\C640 \AC19\C740 \D30C\C77C\C774 \C77C\BC18\C801\C73C\B85C \C774\B7F0 \BC29\C2DD\C73C\B85C \CCA8\BD80\B429\B2C8\B2E4.</p>'),
unistr('<p>content_id \AC12\C774 \B110\C774 \C544\B2CC \ACBD\C6B0 \C5F0\AD00\B41C \D30C\C77C\C774 \C778\B77C\C778\C73C\B85C \CCA8\BD80\B41C \AC83\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4. content_id \C5F4\C758 \AC12\C740 \CCA8\BD80 \D30C\C77C\C758 CID(\CF58\D150\CE20 ID)\B85C \C0AC\C6A9\B429\B2C8\B2E4. \C774 CID \AC12\C744 \C804\C790\BA54\C77C\C758 HTML \CF54\B4DC\C5D0 \C0AC\C6A9\D558\C5EC \C804\C790\BA54\C77C \CF58\D150\CE20\C5D0 \C9C1\C811 \C774\BBF8\C9C0\B97C \D3EC\D568\C2DC\D0AC \C218 \C788\C2B5\B2C8\B2E4. \C77C\BD80 \C804\C790\BA54\C77C \D074\B77C\C774\C5B8\D2B8\C758 \ACBD\C6B0 \C778\B77C\C778 \CCA8\BD80 \D30C\C77C\C744 \C790\B3D9\C73C\B85C \D45C\C2DC\D558\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4. \B610\D55C \C804\C790\BA54\C77C \D45C\C900\C5D0 \CF58\D150\CE20 \C2DD\BCC4\C790 \D615\C2DD\C5D0 \B300\D55C \B2E4\C591\D55C \C694\AD6C\C0AC\D56D\C774 \C9C0\C815\B418\C5B4')
||unistr(' \C788\C2B5\B2C8\B2E4. Oracle Application Express\B294 \C774\B7EC\D55C \D45C\C900\C744 \AC15\C81C\B85C \C900\C218\D558\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(965817719331444057.4419)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>unistr('\C989\C2DC \C804\C1A1')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \C804\C790\BA54\C77C\C744 \C989\C2DC \C804\C1A1\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C989\C2DC \C804\C1A1\D558\B3C4\B85D \C9C0\C815\D558\BA74 \D604\C7AC &PRODUCT_NAME. \C804\C790\BA54\C77C \B300\AE30\C5F4 \D14C\C774\BE14\C5D0 \C788\B294 \BAA8\B4E0 \C804\C790\BA54\C77C\B3C4 \C804\C1A1\B429\B2C8\B2E4. \AE30\BCF8\C801\C73C\B85C &PRODUCT_NAME.\C740(\B294) \C2DC\C2A4\D15C \C131\B2A5 \D5A5\C0C1\C744 \C704\D574 \C804\C1A1\B418\C9C0 \C54A\C740 \C804\C790\BA54\C77C \BA54\C2DC\C9C0\B97C \D14C\C774\BE14\C5D0 \C800\C7A5\D588\B2E4\AC00 \C8FC\AE30\C801\C73C\B85C \C804\B2EC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801033763884282.4419)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>60
,p_prompt=>unistr('\C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8')
,p_attribute_type=>'EMAIL TEMPLATE ID'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\C0AC\C6A9\D560 \C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802168961897202.4419)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>100
,p_prompt=>unistr('\C704\CE58 \D45C\C2DC\C790 \AC12')
,p_attribute_type=>'PLACEHOLDER JSON'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\B300\CCB4\D560 \D15C\D50C\B9AC\D2B8 \C704\CE58 \D45C\C2DC\C790 \C774\B984\ACFC \AC12\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802477287905419.4419)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>110
,p_prompt=>unistr('\C5B8\C5B4 \C0C8\B85C \C785\B825')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C5B8\C5B4 \CF54\B4DC\AC00 \C9C0\C815\B41C \ACBD\C6B0 \D504\B85C\C138\C2A4\B294 \D574\B2F9 \C5B8\C5B4\C5D0 \B300\D55C \C560\D50C\B9AC\CF00\C774\C158 \BC88\C5ED\C5D0\C11C \D15C\D50C\B9AC\D2B8\B97C \C870\D68C\D569\B2C8\B2E4. \BC88\C5ED\C774 \C5C6\B294 \ACBD\C6B0 \D504\B85C\C138\C2A4\B294 \C560\D50C\B9AC\CF00\C774\C158\C758 \AE30\BCF8 \C5B8\C5B4\B97C \C0AC\C6A9\D569\B2C8\B2E4. \B300\CCB4 \AD6C\BB38\C774 \C9C0\C6D0\B429\B2C8\B2E4.</p>'),
unistr('<p>\C5B8\C5B4 \CF54\B4DC \ACC4\CE35\C774 \C9C0\C6D0\B429\B2C8\B2E4. "fr-ca"(\D504\B791\C2A4\C5B4 - \CE90\B098\B2E4) \AC12\C774 \C9C0\C815\B418\C5C8\C9C0\B9CC "fr"(\D504\B791\C2A4\C5B4) \BC88\C5ED\B9CC \C788\B294 \ACBD\C6B0 \C774 \BC88\C5ED\C774 \C0AC\C6A9\B429\B2C8\B2E4.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/file
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(961772418825259055.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'FILE'
,p_display_name=>unistr('\D30C\C77C \CC3E\C544\BCF4\AE30...')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','FILE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:ICON'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<em>\CC3E\C544\BCF4\AE30...</em> \B2E8\CD94\AC00 \D3EC\D568\B41C \D14D\C2A4\D2B8 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4. [\CC3E\C544\BCF4\AE30] \B2E8\CD94\B97C \C0AC\C6A9\D558\BA74 \C0AC\C6A9\C790\AC00 \B85C\CEEC \D30C\C77C \C2DC\C2A4\D15C\C5D0\C11C \D30C\C77C\C744 \CC3E\C544\C11C \C5C5\B85C\B4DC\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961797912421645170.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>40
,p_prompt=>unistr('\C800\C7A5 \C601\C5ED \C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C5C5\B85C\B4DC\D55C \D30C\C77C\C774 \C800\C7A5\B418\B294 \B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799013591654950.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D56D\BAA9 \C18C\C2A4 \C18D\C131\C5D0 \C9C0\C815\B41C BLOB \C5F4')
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('<strong>\C790\B3D9 \D589 \D504\B85C\C138\C2F1(DML)</strong> \D504\B85C\C138\C2A4\C5D0 \C0AC\C6A9\B418\B294 \D14C\C774\BE14 \BC0F \D56D\BAA9 \C18C\C2A4 \C18D\C131\C5D0 \C9C0\C815\B41C \C5F4\C5D0 \C5C5\B85C\B4DC\B41C \D30C\C77C\C744 \C800\C7A5\D569\B2C8\B2E4. \C5F4\C740 BLOB \B370\C774\D130 \C720\D615\C774\C5B4\C57C \D569\B2C8\B2E4. \D30C\C77C\C774 \B2E4\C6B4\B85C\B4DC\B418\BA74 <strong>\C790\B3D9 \D589 \C778\CD9C</strong> \D504\B85C\C138\C2A4\C758 \D14C\C774\BE14 \C774\B984\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728348831149058771.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4419)
,p_display_sequence=>20
,p_display_value=>unistr('APEX_APPLICATION_TEMP_FILES \D14C\C774\BE14')
,p_return_value=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C5C5\B85C\B4DC\B41C \D30C\C77C\C744 APEX_APPLICATION_TEMP_FILES. \BDF0\B85C \C561\C138\C2A4\D560 \C218 \C788\B294 \C784\C2DC \C704\CE58\C5D0 \C800\C7A5\D569\B2C8\B2E4. &PRODUCT_NAME.\C740(\B294) <strong>\B2E4\C74C\C5D0 \D30C\C77C \BE44\C6B0\AE30</strong>\C5D0\C11C \C0AC\C6A9\C790\AC00 \C120\D0DD\D55C \D56D\BAA9\C5D0 \B530\B77C \C138\C158 \C885\B8CC \C2DC \B610\B294 \C5C5\B85C\B4DC \C694\CCAD \C885\B8CC \C2DC \C790\B3D9\C73C\B85C \D574\B2F9 \D30C\C77C\C744 \C0AD\C81C\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\B2E4\C911 \D30C\C77C \D5C8\C6A9</strong>\C774 <strong>\C544\B2C8\C624</strong>\B85C \C124\C815\B41C \ACBD\C6B0 \D30C\C77C\C5D0 \C561\C138\C2A4\D558\B824\BA74 \B2E4\C74C\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624.</p>'),
'<pre>',
'select *',
'  from apex_application_temp_files',
' where name = :<em>page item name</em>;',
'</pre>',
unistr('<p><strong>\B2E4\C911 \D30C\C77C \D5C8\C6A9</strong>\C774 <strong>\C608</strong>\B85C \C124\C815\B41C \ACBD\C6B0 \D30C\C77C\C5D0 \C561\C138\C2A4\D558\B824\BA74 \B2E4\C74C\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624.</p>'),
'<pre>',
'declare',
'    l_file_names apex_t_varchar2;',
'    l_file       apex_application_temp_files%rowtype;',
'begin',
'    l_file_names := apex_string.split (',
'                        p_str => :<em>page item name</em>,',
'                        p_sep => '':'' );',
'    for i in 1 .. l_file_names.count loop',
'        select *',
'          into l_file',
'          from apex_application_temp_files',
'         where name = l_file_names(i);',
'        -- add code here to store the uploaded file in your own table',
'    end loop;',
'end;',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799722296685857.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4419)
,p_display_sequence=>30
,p_display_value=>unistr('WWV_FLOW_FILES \D14C\C774\BE14')
,p_return_value=>'WWV_FLOW_FILES'
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C5C5\B85C\B4DC\B41C \D30C\C77C\C744 &PRODUCT_NAME. \D14C\C774\BE14 <code>WWV_FLOW_FILES</code>\C5D0 \C800\C7A5\D569\B2C8\B2E4.</p>'),
unistr('<p>\D30C\C77C\C5D0 \C561\C138\C2A4\D558\B824\BA74 \B2E4\C74C\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
'<pre>',
'select *',
'  from wwv_flow_files',
' where name = :<em>page item name</em>;',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961780714070314496.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>50
,p_prompt=>unistr('MIME \C720\D615 \C5F4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\C5C5\B85C\B4DC\B41C \D30C\C77C\C758 mime \C720\D615\C744 \C800\C7A5\D558\B294 \B370 \C0AC\C6A9\B418\B294 \B300\BB38\C790 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. mime \C720\D615\C740 \D30C\C77C\C774 \B2E4\C6B4\B85C\B4DC\B418\C5C8\C744 \B54C BLOB\C758 \CF58\D150\CE20\B97C \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\D560 \C560\D50C\B9AC\CF00\C774\C158\C744 \BE0C\B77C\C6B0\C800\C5D0\C11C \C2DD\BCC4\D558\AE30 \C704\D574 \C0AC\C6A9\B429\B2C8\B2E4.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781218572315783.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>60
,p_prompt=>unistr('\D30C\C77C \C774\B984 \C5F4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\C5C5\B85C\B4DC\B41C \D30C\C77C\C758 \D30C\C77C \C774\B984\C744 \C800\C7A5\D558\B294 \B370 \C0AC\C6A9\B418\B294 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781726537318040.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>70
,p_prompt=>unistr('\BB38\C790\C138\D2B8 \C5F4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\C5C5\B85C\B4DC\B41C \D30C\C77C\C758 \BB38\C790\C138\D2B8\B97C \C800\C7A5\D558\B294 \B370 \C0AC\C6A9\B418\B294 \B300\BB38\C790 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. BLOB\C758 \BB38\C790\C138\D2B8\B294 \C5C5\B85C\B4DC \C2DC\C5D0 \C790\B3D9\C73C\B85C \C124\C815\B418\C9C0 \C54A\C2B5\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\AC00 \C790\C2E0\C774 \C5C5\B85C\B4DC\D558\B294 \BB38\C11C\C5D0 \B300\D574 \BB38\C790\C138\D2B8\B97C \C124\C815\D574\C57C \D569\B2C8\B2E4.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782232078319703.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>80
,p_prompt=>unistr('BLOB \CD5C\C885 \C5C5\B370\C774\D2B8 \C5F4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\D30C\C77C\C774 \C5C5\B85C\B4DC\B420 \B54C \D604\C7AC \C2DC\AC04\AE30\B85D\C744 \C800\C7A5\D558\B294 \B370 \C0AC\C6A9\B418\B294 \B300\BB38\C790 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774 \B0A0\C9DC \AC12\C740 \BE0C\B77C\C6B0\C800 \CE90\C2F1\C5D0 \C0AC\C6A9\B429\B2C8\B2E4.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961805334341783950.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>90
,p_prompt=>unistr('\B2E4\C6B4\B85C\B4DC \B9C1\D06C \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\C774 \D56D\BAA9\ACFC \C5F0\AD00\B41C \BE44\C5B4 \C788\C9C0 \C54A\C740 BLOB\AC00 \C788\C744 \ACBD\C6B0 \B2E4\C6B4\B85C\B4DC \B9C1\D06C\B97C \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961784310308341810.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>100
,p_prompt=>unistr('\B2E4\C6B4\B85C\B4DC \B9C1\D06C \D14D\C2A4\D2B8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\B2E4\C6B4\B85C\B4DC \B9C1\D06C\C758 \C77C\BD80\B85C \D45C\C2DC\D560 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \C9C0\C815\B418\C9C0 \C54A\C740 \ACBD\C6B0 \ACF5\C720 \AD6C\C131\C694\C18C \B0B4\C5D0\C11C <code>APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT</code>\C758 \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\C5D0 \C800\C7A5\B41C \D14D\C2A4\D2B8\AC00 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782727361327744.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>110
,p_prompt=>unistr('\CF58\D150\CE20 \CC98\B9AC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'attachment'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2E4\C6B4\B85C\B4DC\D560 \B54C \BE0C\B77C\C6B0\C800\C758 \CF58\D150\CE20 \CC98\B9AC \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: \C77C\BD80 \CF58\D150\CE20\B294 \C778\B77C\C778\C73C\B85C \D45C\C2DC\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4. \CF58\D150\CE20 \C778\B77C\C778 \D45C\C2DC \C9C0\C6D0\C740 \D574\B2F9 \BE0C\B77C\C6B0\C800\C5D0\C11C \D2B9\C815 mime \C720\D615\C774 \C9C0\C6D0\B418\B294\C9C0 \C5EC\BD80\C5D0 \B530\B77C \B2EC\B77C\C9D1\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783330131328554.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C778\B77C\C778')
,p_return_value=>'inline'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783735326330101.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\CCA8\BD80 \D30C\C77C')
,p_return_value=>'attachment'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728349541683084558.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>unistr('\B2E4\C74C\C5D0 \D30C\C77C \BE44\C6B0\AE30')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SESSION'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('&PRODUCT_NAME.\C5D0\C11C \C784\C2DC \D30C\C77C\C744 \C81C\AC70\D560 \C2DC\AC04\C744 \C815\C758\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728349853284087310.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C138\C158 \C885\B8CC')
,p_return_value=>'SESSION'
,p_help_text=>unistr('\D604\C7AC &PRODUCT_NAME. \C138\C158 \C885\B8CC \C2DC \D30C\C77C\C744 \C0AD\C81C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728350242833089332.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C694\CCAD \C885\B8CC')
,p_return_value=>'REQUEST'
,p_help_text=>unistr('\D604\C7AC HTTP \C694\CCAD \C885\B8CC \C2DC \D30C\C77C\C744 \C0AD\C81C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451543969001781322.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>unistr('\B2E4\C911 \D30C\C77C \D5C8\C6A9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C5EC\B7EC \AC1C\C758 \D30C\C77C\C744 \D55C \BC88\C5D0 \C5C5\B85C\B4DC\D560 \C218 \C788\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D558\C2ED\C2DC\C624.</p>'),
'',
unistr('<p>\CC38\ACE0 - \C5EC\B7EC \AC1C\C758 \D30C\C77C \C774\B984\C774 \D398\C774\C9C0 \D56D\BAA9\C5D0 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \BAA9\B85D\C73C\B85C \C800\C7A5\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451544768593842902.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>140
,p_prompt=>unistr('\D30C\C77C \C720\D615')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dt>\C774\BBF8\C9C0 \D30C\C77C\B9CC \D5C8\C6A9\B428\C744 \B098\D0C0\B0C5\B2C8\B2E4.</dt>'),
'<dd><pre>image/*</pre></dd>',
unistr('<dt>\C774\BBF8\C9C0 \BC0F \BE44\B514\C624 \D30C\C77C\B9CC \D5C8\C6A9\B428\C744 \B098\D0C0\B0C5\B2C8\B2E4.</dt>'),
'<dd><pre>image/*,video/*</pre></dd>',
unistr('<dt>PNG \C774\BBF8\C9C0 \D30C\C77C\B9CC \D5C8\C6A9\B428\C744 \B098\D0C0\B0C5\B2C8\B2E4.</dt>'),
'<dd><pre>image/png</pre></dd>'))
,p_help_text=>unistr('\C5C5\B85C\B4DC\D560 \C218 \C788\B294 \D30C\C77C\C744 \C81C\D55C\D558\B824\BA74 \BE0C\B77C\C6B0\C800\C5D0\C11C \C0AC\C6A9\D560 \C218 \C788\B294 \CF64\B9C8\B85C \AD6C\BD84\B41C \D30C\C77C \C720\D615 \BAA9\B85D\C744 \C9C0\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13629201915222128.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>10
,p_prompt=>unistr('\D45C\C2DC \D615\C2DD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INLINE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D30C\C77C \CC3E\C544\BCF4\AE30 \D56D\BAA9\C744 \D45C\C2DC\D560 \BC29\C2DD\C5D0 \B300\D55C \D45C\C2DC \C2A4\D0C0\C77C\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629582056224659.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C778\B77C\C778 \D30C\C77C \CC3E\C544\BCF4\AE30')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\D398\C774\C9C0\C758 \B2E4\B978 \D14D\C2A4\D2B8 \D544\B4DC \BC0F \D56D\BAA9\ACFC \C720\C0AC\D558\AC8C \D30C\C77C \CC3E\C544\BCF4\AE30 \C785\B825 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629902085226258.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C778\B77C\C778 \B193\AE30 \C601\C5ED')
,p_return_value=>'DROPZONE_INLINE'
,p_help_text=>unistr('\C81C\BAA9 \BC0F \C124\BA85\C774 \C81C\ACF5\B418\B3C4\B85D \C778\B77C\C778 \B193\AE30 \C601\C5ED\C73C\B85C \D30C\C77C \CC3E\C544\BCF4\AE30 \C785\B825 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13741737113486642.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\BE14\B85D \B193\AE30 \C601\C5ED')
,p_return_value=>'DROPZONE_BLOCK'
,p_help_text=>unistr('\C81C\BAA9 \BC0F \C124\BA85\ACFC \D30C\C77C \C120\D0DD \B2E8\CD94\B97C \C81C\ACF5\D558\B294 \B9C8\BC95\C0AC \C2A4\D0C0\C77C \B193\AE30 \C601\C5ED\C73C\B85C \D30C\C77C \CC3E\C544\BCF4\AE30 \C785\B825 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18970520653850634.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\ACE0\C720 \D30C\C77C \CC3E\C544\BCF4\AE30')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('\D30C\C77C \CC3E\C544\BCF4\AE30 \D56D\BAA9 \D45C\C2DC\C5D0 \BE0C\B77C\C6B0\C800\C758 \ACE0\C720 \D615\C2DD \C9C0\C815\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13631853022534008.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>20
,p_prompt=>unistr('\B193\AE30 \C601\C5ED \C81C\BAA9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'INLINE,DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B193\AE30 \C601\C5ED\C5D0 \B300\D55C \C81C\BAA9\C744 \C9C0\C815\D569\B2C8\B2E4.'),
unistr('\C774 \D544\B4DC\B97C \BE44\C6CC \B450\BA74 \AE30\BCF8\C801\C73C\B85C \D14D\C2A4\D2B8 \BA54\C2DC\C9C0 <code>APEX.ITEM.FILE.DROP_FILE</code> \B610\B294 <code>APEX.ITEM.FILE.DROP_FILES</code>\AC00 \C0AC\C6A9\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13643896497789547.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>30
,p_prompt=>unistr('\B193\AE30 \C601\C5ED \C124\BA85')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B193\AE30 \C601\C5ED\C5D0 \B300\D55C \C124\BA85 \D14D\C2A4\D2B8\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \D544\B4DC\B97C \BE44\C6CC \B450\BA74 \D45C\C2DC \D615\C2DD \C18D\C131\C5D0 \B530\B77C \AE30\BCF8\C801\C73C\B85C \B2E4\C74C \D14D\C2A4\D2B8 \BA54\C2DC\C9C0\AC00 \C0AC\C6A9\B429\B2C8\B2E4.</p>'),
unistr('<p><strong>\BE14\B85D \B193\AE30 \C601\C5ED</strong><br />'),
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES</code>',
'</p>',
unistr('<p><strong>\C778\B77C\C778 \B193\AE30 \C601\C5ED</strong><br />'),
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILES</code>',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13644378210801196.4419)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\CD5C\B300 \D30C\C77C \D06C\AE30')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'KB'
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \D56D\BAA9\C744 \D1B5\D574 \C5C5\B85C\B4DC\B41C \D30C\C77C\C5D0 \B300\D574 \C218\B77D\D574\C57C \D560 \CD5C\B300 \D30C\C77C \D06C\AE30(KB)\B97C \C785\B825\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/item_type/list_manager
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(973073216779459799.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LIST_MANAGER'
,p_display_name=>unistr('\BAA9\B85D \AD00\B9AC\C790')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LIST_MANAGER'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ELEMENT_OPTION:PLACEHOLDER:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AC12 \BAA9\B85D \D31D\C5C5 \C544\C774\CF58, <em>\CD94\AC00</em> \BC0F <em>\C81C\AC70</em> \B2E8\CD94, \C120\D0DD\D55C \AC12 \BAA9\B85D\C774 \D3EC\D568\B41C \D14D\C2A4\D2B8 \D56D\BAA9\C744 \D45C\C2DC\D569\B2C8\B2E4.</p>'),
unistr('<p>\AC12\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4. \ADF8\B7F0 \D6C4 \B2E8\CD94\B97C \C0AC\C6A9\D574\C11C \C120\D0DD\D55C \AC12\C744 \AD00\B9AC\D560 \C218 \C788\C2B5\B2C8\B2E4. \C120\D0DD\D55C \AC12\C740 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \B2E8\C77C \BB38\C790\C5F4\C5D0 \C800\C7A5\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973075623967480816.4419)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C778\CD9C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D31D\C5C5 LOV\B97C \C5F4 \B54C \B370\C774\D130\AC00 \D45C\C2DC\B418\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973076228816482253.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C778\CD9C \C5C6\C74C')
,p_return_value=>'NO_FETCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077034010483721.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\CCAB\BC88\C9F8 \D589 \C9D1\D569 \C778\CD9C')
,p_return_value=>'FIRST_ROWSET'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077408168485730.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\CCAB\BC88\C9F8 \D589 \C9D1\D569 \C778\CD9C \BC0F \D604\C7AC \AC12 \D544\D130\B9C1')
,p_return_value=>'FIRST_ROWSET_FILTER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973074833187474061.4419)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\B300\C18C\BB38\C790 \C720\C9C0')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\AC12\C744 \C785\B825\D55C \ADF8\B300\B85C \C720\C9C0\D558\AC70\B098 \B300\BB38\C790\B85C \BCC0\D658\D560\C9C0\B97C \C9C0\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154323494834504.4419)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4419)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL \C9C8\C758 \AE30\C900 \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\D45C\C2DC \BC0F \BC18\D658 \AC12\C774 \B3D9\C77C\D55C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: \D45C\C2DC \BC0F \BC18\D658 \AC12 \BAA8\B450 \B3D9\C77C\D55C \C5F4\C744 \C120\D0DD\D55C \ACBD\C6B0 \C5F4 \BCC4\CE6D\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
'</dd>',
unistr('<dt>\BC14\C778\B4DC \BCC0\C218\AC00 \D3EC\D568\B41C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: <code>P3_DEPTNO</code>\AC00 \B3D9\C77C\D55C \D398\C774\C9C0\C5D0 \C788\B294 \C218\C815 \AC00\B2A5\D55C \D398\C774\C9C0 \D56D\BAA9\C778 \ACBD\C6B0 <em>\C885\C18D LOV \C0C1\C704 \D56D\BAA9</em> \C18D\C131\C744 <code>P3_DEPTNO</code>\B85C \C124\C815\D569\B2C8\B2E4.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1086048547681945775.4419)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS_LEGACY'
,p_display_name=>unistr('\B808\AC70\C2DC \C790\B3D9 \D589 \D504\B85C\C138\C2F1')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\B2E8\C77C \B370\C774\D130\BCA0\C774\C2A4 \D14C\C774\BE14 \B610\B294 \C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BDF0\C5D0 \B300\D574 \B808\CF54\B4DC\B97C \C0BD\C785, \C5C5\B370\C774\D2B8 \B610\B294 \C0AD\C81C\D558\AE30 \C704\D55C \D504\B85C\C138\C2A4\C785\B2C8\B2E4. \C774 \D504\B85C\C138\C2A4\B294 <strong>\B370\C774\D130\BCA0\C774\C2A4 \C5F4</strong> \C720\D615\C758 \C18C\C2A4\B97C \D3EC\D568\D558\B294 \D3FC \D56D\BAA9\C744 \CC98\B9AC\D558\AE30 \C704\D574 \C0AC\C6A9\B429\B2C8\B2E4. Oracle\C740 \C774 \D504\B85C\C138\C2A4 \C720\D615\C744 <strong>\C790\B3D9 \D589 \D504\B85C\C138\C2F1(DML)</strong>\C73C\B85C \C5C5\B370\C774\D2B8\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(724250841038369418.4419)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSERT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C9C0\C6D0\B418\B294 DML(\B370\C774\D130 \C870\C791 \C5B8\C5B4) \C791\C5C5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408026159343735.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C0BD\C785')
,p_return_value=>'INSERT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408425080344291.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C5C5\B370\C774\D2B8')
,p_return_value=>'UPDATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408824002344800.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C0AD\C81C')
,p_return_value=>'DELETE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086048865137952891.4419)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D14C\C774\BE14 \C18C\C720\C790')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\D14C\C774\BE14 \C18C\C720\C790(\C2A4\D0A4\B9C8) \C774\B984\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049161039954775.4419)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\D14C\C774\BE14 \C774\B984')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086048865137952891.4419)
,p_help_text=>unistr('\B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\B294 \D14C\C774\BE14 \B610\B294 \BDF0 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049455217957445.4419)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>unistr('\AE30\BCF8 \D0A4 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\AE30\BCF8 \D0A4 \C5F4 \AC12\C744 \C800\C7A5\D558\AE30 \C704\D55C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. \C774\B984\C744 \C785\B825\D558\AC70\B098 \BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049751766959069.4419)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('\AE30\BCF8 \D0A4 \C5F4 ')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086049161039954775.4419)
,p_help_text=>unistr('\AE30\BCF8 \D0A4 \AC12\C774 \D3EC\D568\B41C \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4. \C5EC\B7EC \BD80\BD84\C73C\B85C \B41C \AE30\BCF8 \D0A4\AC00 \D14C\C774\BE14\C5D0 \D3EC\D568\B41C \ACBD\C6B0 <strong>ROWID</strong>\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086053647281173911.4419)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\B7F0\D0C0\C784 Where \C808')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BD80\C11C\B97C \C81C\D55C\D569\B2C8\B2E4.</p>'),
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('\C0DD\C131\B41C \BAA8\B4E0 SELECT, UPDATE \BC0F DELETE \BB38\C5D0 \CD94\AC00\D560 SQL WHERE \C808\C744 \C785\B825\D569\B2C8\B2E4. \C790\B3D9 \C0DD\C131\B41C SQL \D638\CD9C\C5D0\C11C \C0AC\C6A9\B418\B294 \B808\CF54\B4DC\B97C \C81C\D55C\D558\B824\BA74 \C774 \C18D\C131\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/cancel_event
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1112790930653153311.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CANCEL_EVENT'
,p_display_name=>unistr('\C774\BCA4\D2B8 \CDE8\C18C')
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CANCEL_EVENT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D604\C7AC \C774\BCA4\D2B8\B97C \CDE8\C18C\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1166598346362318406.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER'
,p_display_name=>unistr('\B0A0\C9DC \C120\D0DD\AE30(jQuery)')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2EC\B825 \C544\C774\CF58\C774 \C788\B294 \D14D\C2A4\D2B8 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\B294 \D14D\C2A4\D2B8 \D56D\BAA9\C5D0 \B0A0\C9DC\B97C \C9C1\C811 \C785\B825\D558\AC70\B098 \B2EC\B825 \C544\C774\CF58\C744 \B204\B974\ACE0 \B2EC\B825 \D31D\C5C5\C5D0\C11C \B0A0\C9DC \BC0F \C2DC\AC04(\C120\D0DD\C0AC\D56D)\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C2DC\AC04\C740 \C774 \D56D\BAA9\C5D0 \B300\D55C <em>\D615\C2DD \B9C8\C2A4\D06C</em>\C5D0 \C2DC\AC04 \AD6C\C131\C694\C18C\AC00 \D3EC\D568\B41C \ACBD\C6B0\C5D0\B9CC \B2EC\B825 \D31D\C5C5\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599468441343733.4419)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\AC15\C870 \D45C\C2DC\B41C \B0A0\C9DC')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>20090624</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_NEXT_AVAILABLE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2EC\B825 \D31D\C5C5\C774 \D638\CD9C\B420 \B54C \AC15\C870 \D45C\C2DC\D560 \AE30\BCF8 \B0A0\C9DC \AC12\C744 \C785\B825\D569\B2C8\B2E4. \C9C0\C815\B418\C9C0 \C54A\C558\C73C\BA74 \B2EC\B825\C5D0 \D604\C7AC \B0A0\C9DC \BC0F \C2DC\AC04\C774 \AC15\C870 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\AC12\C740 <code>''YYYYMMDDHH24MI''</code> \D615\C2DD\C758 \C808\B300 \AC12\C774\AC70\B098 \C624\B298 \B0A0\C9DC\B97C \AE30\C900\C73C\B85C \D558\B294 \C0C1\B300 \AC12(\C608: <code>+7d</code>) \B610\B294 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D55C \B3D9\C801 \AC12\C77C \C218 \C788\C2B5\B2C8\B2E4(\B300\CCB4 \AD6C\BB38\C774 \C62C\BC14\B978 \B0A0\C9DC \D615\C2DD \B610\B294 \C0C1\B300 \AC12\C744 \BC18\D658\D558\B294 \ACBD\C6B0).</p>'),
unistr('<p>\C0C1\B300\C801 \B0A0\C9DC \AC12\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C5F0\B3C4 \C218 + / -</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \AC1C\C6D4 \C218 + / -</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C8FC \C218 + / -</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C77C \C218 + / -</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598552726329767.4419)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\CD5C\C18C \B0A0\C9DC')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C785\B825 \B610\B294 \C120\D0DD\D560 \C218 \C788\B294 \CD5C\C18C \B0A0\C9DC\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\B0A0\C9DC \AC12\C740 <code>''YYYY-MM-DDTHH24:MI:SS''</code> \B610\B294 <code>''YYYYMMDDHH24MI''</code> \D615\C2DD\C758 \C808\B300 \AC12\C774\AC70\B098 \C624\B298 \B0A0\C9DC\B97C \AE30\C900\C73C\B85C \D558\B294 \C0C1\B300 \AC12(\C608: <code>+7d</code>) \B610\B294 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D55C \B3D9\C801 \AC12\C77C \C218 \C788\C2B5\B2C8\B2E4(\B300\CCB4 \AD6C\BB38\C774 \C62C\BC14\B978 \B0A0\C9DC \D615\C2DD \B610\B294 \C0C1\B300 \AC12\C744 \BC18\D658\D558\B294 \ACBD\C6B0).</p>'),
unistr('<p>\C0C1\B300\C801 \B0A0\C9DC \AC12\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C5F0\B3C4 \C218 + / -</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \AC1C\C6D4 \C218 + / -</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C8FC \C218 + / -</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C77C \C218 + / -</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598957228331042.4419)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\CD5C\B300 \B0A0\C9DC')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C785\B825 \B610\B294 \C120\D0DD\D560 \C218 \C788\B294 \CD5C\B300 \B0A0\C9DC\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\B0A0\C9DC \AC12\C740 <code>''YYYY-MM-DDTHH24:MI:SS''</code> \B610\B294 <code>''YYYYMMDDHH24MI''</code> \D615\C2DD\C758 \C808\B300 \AC12\C774\AC70\B098 \C624\B298 \B0A0\C9DC\B97C \AE30\C900\C73C\B85C \D558\B294 \C0C1\B300 \AC12(\C608: <code>+7d</code>) \B610\B294 \B300\CCB4 \AD6C\BB38\C744 \C0AC\C6A9\D55C \B3D9\C801 \AC12\C77C \C218 \C788\C2B5\B2C8\B2E4(\B300\CCB4 \AD6C\BB38\C774 \C62C\BC14\B978 \B0A0\C9DC \D615\C2DD \B610\B294 \C0C1\B300 \AC12\C744 \BC18\D658\D558\B294 \ACBD\C6B0).</p>'),
unistr('<p>\C0C1\B300\C801 \B0A0\C9DC \AC12\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C5F0\B3C4 \C218 + / -</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \AC1C\C6D4 \C218 + / -</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C8FC \C218 + / -</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\C624\B298 \B0A0\C9DC\C5D0\C11C \C77C \C218 + / -</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599961992351304.4419)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\D45C\C2DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'button'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\B0A0\C9DC \C120\D0DD\AE30 \D31D\C5C5 \B2EC\B825\C774 \D45C\C2DC\B418\B294 \ACBD\C6B0\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975967945937309446.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D3EC\CEE4\C2A4\B97C \C5BB\C744 \B54C')
,p_return_value=>'focus'
,p_help_text=>unistr('\D56D\BAA9\C774 \D3EC\CEE4\C2A4\B97C \BC1B\B294 \C989\C2DC \B2EC\B825 \D31D\C5C5\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968322865312246.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C544\C774\CF58 \B204\B97C \B54C')
,p_return_value=>'button'
,p_help_text=>unistr('\C544\C774\CF58\C744 \B204\B97C \B54C \B2EC\B825 \D31D\C5C5\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968729792314196.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\BAA8\B450')
,p_return_value=>'both'
,p_help_text=>unistr('\D56D\BAA9\C774 \D3EC\CEE4\C2A4\B97C \BC1B\C558\ACE0 \C544\C774\CF58\C744 \B204\B978 \D6C4 \C989\C2DC \B2EC\B825 \D31D\C5C5\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(977131519506267935.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\C778\B77C\C778')
,p_return_value=>'inline'
,p_help_text=>unistr('\B2EC\B825\C740 \D398\C774\C9C0\C5D0 \D56D\C0C1 \C778\B77C\C778\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4. \D14D\C2A4\D2B8 \D544\B4DC\B294 \D45C\C2DC\B418\C9C0 \C54A\C73C\BA70 \D604\C7AC \C120\D0DD\B41C \B0A0\C9DC\B294 \B2EC\B825\C5D0 \AC15\C870 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600445500356042.4419)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\AE30\D0C0 \C6D4 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\C774\C804 \B2EC\C758 \C120\D589 \B0A0\C9DC \BC0F \B2E4\C74C \B2EC\C758 \D6C4\D589 \B0A0\C9DC\AC00 \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C120\D589 \BC0F \D6C4\D589 \B0A0\C9DC\B294 \B2EC\B825\C758 \CC98\C74C \BC0F \B9C8\C9C0\B9C9 \D589\C744 \C644\C804\D788 \CC44\C6C1\B2C8\B2E4. \C608\B97C \B4E4\C5B4 \D574\B2F9 \C8FC\C758 \CCAB\BC88\C9F8 \C694\C77C\C774 \C77C\C694\C77C\C774\ACE0 \D45C\C2DC\B41C \D604\C7AC \C6D4\C758 \CCAB\BC88\C9F8 \C694\C77C\C774 \C218\C694\C77C\C774\BA74 \C774\C804 \B2EC\C758 \B9C8\C9C0\B9C9 3\C77C\C774 \C77C\C694\C77C, \C6D4\C694\C77C \BC0F \D654\C694\C77C\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166601947494375554.4419)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\C6D4 \C218')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166600445500356042.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>3</dt>',
unistr('    <dd>3\AC1C\C6D4\C744 \AC00\B85C\B85C \D45C\C2DC\D569\B2C8\B2E4.</dd>'),
'  <dt>[2,3]</dt>',
unistr('    <dd>6\AC1C\C6D4\C744 2\D589\ACFC 3\C5F4\B85C \D45C\C2DC\D569\B2C8\B2E4.</dd>'),
'  <dt>[4,3]</dt>',
unistr('    <dd>12\AC1C\C6D4\C744 4\D589\ACFC 3\C5F4\B85C \D45C\C2DC\D569\B2C8\B2E4.</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2EC\B825 \D31D\C5C5\C5D0 \D45C\C2DC\D560 \C6D4 \C218\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C815\C218 \AC12\C744 \C785\B825\D558\AC70\B098 <code>[<em>row,column</em>]</code>\C744 \C0AC\C6A9\D574\C11C 2\CC28\C6D0 \BC30\C5F4\C744 \C785\B825\D558\C5EC \D45C\C2DC\D560 \D589 \BC0F \C5F4 \C218\B97C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: <strong>\AC15\C870 \D45C\C2DC\B41C \B0A0\C9DC</strong> \C774\D6C4\C758 \C6D4\C774 \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166602447625385046.4419)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\D0D0\C0C9 \BAA9\B85D')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C6D4 \BC0F/\B610\B294 \C5F0\B3C4\C5D0 \B300\D574 \B2EC\B825 \D31D\C5C5 \B0B4\C5D0 \C120\D0DD \BAA9\B85D\C774 \C81C\ACF5\B418\B294\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072709337552768.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4419)
,p_display_sequence=>5
,p_display_value=>unistr('\C5C6\C74C')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071421673546859.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C6D4')
,p_return_value=>'MONTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071825829548006.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\B144')
,p_return_value=>'YEAR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072306567551978.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C6D4 \BC0F \C5F0\B3C4')
,p_return_value=>'MONTH_AND_YEAR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600943554364880.4419)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\C5F0\B3C4 \BC94\C704')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166602447625385046.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'YEAR,MONTH_AND_YEAR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>2000:2010</dt>',
unistr('    <dd>\C808\B300 \C5F0\B3C4\B97C \C0AC\C6A9\D574\C11C \D5C8\C6A9 \C5F0\B3C4\B97C 2000\B144\BD80\D130 2010\B144 \C0AC\C774(\D3EC\D568)\B85C \C81C\D55C\D569\B2C8\B2E4.</dd>'),
'  <dt>-05:+05</dt>',
unistr('    <dd>\C0C1\B300 \B0A0\C9DC\B97C \C0AC\C6A9\D574\C11C \D5C8\C6A9 \C5F0\B3C4\B97C \D604\C7AC \C5F0\B3C4\B85C\BD80\D130 +/- 5\B144\C73C\B85C \C81C\D55C\D569\B2C8\B2E4.</dd>'),
'  <dt>+01:+03</dt>',
unistr('    <dd>\C0C1\B300 \B0A0\C9DC\B97C \C0AC\C6A9\D574\C11C \D5C8\C6A9 \C5F0\B3C4\B97C \B2E4\C74C \C5F0\B3C4\C640 \CD94\AC00 2\B144\C73C\B85C \C81C\D55C\D569\B2C8\B2E4.</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B2EC\B825 \D31D\C5C5 \B0B4\C758 <strong>\C5F0\B3C4</strong> \C120\D0DD \BAA9\B85D\C5D0 \D45C\C2DC\B418\B294 \D5C8\C6A9\B418\B294 \C5F0\B3C4 \BC94\C704\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C5F0\B3C4 \AC12\C740 <code>''YYYY:YYYY''</code> \D615\C2DD\C758 \C808\B300 \AC12\C774\AC70\B098 	<code>''-nn:+nn''</code> \D615\C2DD\C744 \C0AC\C6A9\D55C \C0C1\B300 \AC12(\C5EC\AE30\C11C <code>nn</code>\C740 \C815\C218 \AC12)\C77C \C218 \C788\C2B5\B2C8\B2E4.')))
);
end;
/
prompt --application/shared_components/plugins/item_type/text_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230861140507488144.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXT_FIELD'
,p_display_name=>unistr('\D14D\C2A4\D2B8 \D544\B4DC')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXT_FIELD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\D14D\C2A4\D2B8 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861330595494795.4419)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('Enter\B97C \B204\B97C \B54C \C81C\CD9C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \D544\B4DC\C5D0 \C788\B294 \B3D9\C548 <em>Enter</em> \D0A4\B97C \B20C\B7EC\C11C \D398\C774\C9C0\B97C \C790\B3D9\C73C\B85C \C81C\CD9C\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861822761501984.4419)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('\C0AC\C6A9 \C548\D568')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \D56D\BAA9\C744 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D574\C11C \C77C\BC18 \C0AC\C6A9\C790\AC00 \AC12\C744 \BCC0\ACBD\D558\C9C0 \BABB\D558\B3C4\B85D \BC29\C9C0\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B41C \D14D\C2A4\D2B8 \D56D\BAA9\C740 HTML \D615\C2DD\C774 \C81C\AC70\B418\B294 <em>\D45C\C2DC \C804\C6A9</em> \D56D\BAA9 \C720\D615\ACFC \B2EC\B9AC \B3D9\C77C\D55C HTML \D615\C2DD\C744 \C0AC\C6A9\D574\C11C \ACC4\C18D \D45C\C2DC\B429\B2C8\B2E4. \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B41C \D14D\C2A4\D2B8 \D56D\BAA9\C740 \C138\C158 \C0C1\D0DC\B97C \D3C9\AC00\D560 \C218 \C788\B3C4\B85D \D398\C774\C9C0 \C18C\C2A4\C758 \C77C\BD80\C785\B2C8\B2E4. \BC18\B300\B85C, \D45C\C2DC \C804\C6A9 \D56D\BAA9\C740 \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
,p_attribute_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$ DJP  - Is this equivalent to specifying Read Only = Always?',
'If so do we need this attribute?'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230862319775510558.4419)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\D398\C774\C9C0 \C81C\CD9C \C2DC \C804\C1A1')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1230861822761501984.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\D398\C774\C9C0\AC00 \C81C\CD9C\B420 \B54C \D604\C7AC \D56D\BAA9 \AC12\C744 \C804\C1A1\D574\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
,p_attribute_comment=>'$$$ DJP - Why can this only be set when Disabled = Y?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2642009195904118.4419)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>10
,p_prompt=>unistr('\D558\C704 \C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('HTML5 \D14D\C2A4\D2B8 \D558\C704 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4. \C774\B807\AC8C \D558\BA74 \D654\BA74 \D0A4\BCF4\B4DC\AC00 \C788\B294 \C7A5\CE58\C5D0\C11C \B370\C774\D130\B97C \C27D\AC8C \C785\B825\D560 \C218 \C788\B3C4\B85D \D558\C704 \C720\D615\C5D0 \B530\B77C \CD5C\C801\D654\B41C \D0A4\BCF4\B4DC \B808\C774\C544\C6C3\C744 \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4. \D558\C704 \C720\D615 \C120\D0DD \D56D\BAA9\C740 \B610\D55C \C77D\AE30 \C804\C6A9\C73C\B85C \B80C\B354\B9C1\B420 \ACBD\C6B0 \D398\C774\C9C0 \D56D\BAA9\C758 \AC12\C73C\B85C \C801\D569\D55C \B9C1\D06C\B97C \B80C\B354\B9C1\D558\B294 \B370\C5D0\B3C4 \C0AC\C6A9\B429\B2C8\B2E4. \C774 \C18D\C131\C740 \BB3C\B9AC\C801 \D0A4\BCF4\B4DC\B97C \C0AC\C6A9\D560 \B54C \D14D\C2A4\D2B8 \D56D\BAA9 \B610\B294 \B370\C774\D130 \C785\B825\C744 \BCC0\ACBD\D558\C9C0 \C54A\C2B5\B2C8\B2E4.  '),
'</p>',
unistr('<p><strong><em>\CC38\ACE0:</strong> \C774 HTML5 \AE30\B2A5\C740 \CD5C\C2E0 \BE0C\B77C\C6B0\C800\C5D0\C11C\B9CC \C791\B3D9\D569\B2C8\B2E4. HTML5\C640 \D638\D658\B418\C9C0 \C54A\B294 \C624\B798\B41C \BE0C\B77C\C6B0\C800\B294 \C774 \C18D\C131\C744 \BB34\C2DC\D558\ACE0 \D398\C774\C9C0 \D56D\BAA9\C744 \C77C\BC18 \D14D\C2A4\D2B8 \D544\B4DC\B85C \B80C\B354\B9C1\D569\B2C8\B2E4.</em></p>')))
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be for Mobile UI only?'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4337919498933328.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4419)
,p_display_sequence=>5
,p_display_value=>unistr('\D14D\C2A4\D2B8')
,p_return_value=>'TEXT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643201361911326.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C804\C790\BA54\C77C')
,p_return_value=>'EMAIL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643606901912900.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C804\D654\BC88\D638')
,p_return_value=>'TEL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(228427524363055714.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4419)
,p_display_sequence=>25
,p_display_value=>unistr('\AC80\C0C9')
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2644810018913786.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4419)
,p_display_sequence=>30
,p_display_value=>'URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362145212820086745.4419)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>15
,p_prompt=>unistr('\ACF5\AC04 \C790\B974\AE30')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D398\C774\C9C0 \C81C\CD9C \D6C4 \D56D\BAA9 \AC12\C744 \C790\B974\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4. \C774 \C124\C815\C740 \C785\B825\D55C \D14D\C2A4\D2B8\C5D0\C11C \ACF5\BC31, \D0ED \BC0F \C904\BC14\AFC8\C744 \C790\B985\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145508722088644.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C120\D589')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145906566089618.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D6C4\D589')
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362146304625090506.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C120\D589 \BC0F \D6C4\D589')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362147027041095284.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\C5C6\C74C')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(580485075516965313.4419)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>16
,p_prompt=>unistr('\D14D\C2A4\D2B8 \B300\C18C\BB38\C790')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\BCC0\ACBD\C0AC\D56D \C5C6\C74C')
,p_help_text=>unistr('\D56D\BAA9 \AC12 \D14D\C2A4\D2B8 \B300\C18C\BB38\C790\C758 \BCC0\D658 \BC29\C2DD\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485397894966793.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C18C\BB38\C790')
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485762023967520.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\B300\BB38\C790')
,p_return_value=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/hidden
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230888011377927220.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HIDDEN'
,p_display_name=>unistr('\C228\AE40')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HIDDEN'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\D398\C774\C9C0 \C18C\C2A4 \B0B4\C5D0 \D3EC\D568\B418\C5C8\C9C0\B9CC \B80C\B354\B9C1\B418\C9C0 \C54A\C740 \D56D\BAA9\C785\B2C8\B2E4. \C228\ACA8\C9C4 \D56D\BAA9 \AC12\C740 \C138\C158 \C0C1\D0DC\B85C \C800\C7A5\B429\B2C8\B2E4. \C774\B7EC\D55C \D56D\BAA9\C740 \C77C\BC18\C801\C73C\B85C \D398\C774\C9C0 \CC98\B9AC \B610\B294 \AE30\D0C0 \D398\C774\C9C0 \D56D\BAA9\C5D0 \D544\C694\D558\C9C0\B9CC \C77C\BC18 \C0AC\C6A9\C790\C5D0\AC8C \D45C\C2DC\B418\C9C0 \C54A\C544\C57C \D558\B294 \AC12\C744 \C800\C7A5\D558\AE30 \C704\D574 \C0AC\C6A9\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230888530209942193.4419)
,p_plugin_id=>wwv_flow_api.id(1230888011377927220.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\BCF4\D638 \AC12')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\D56D\BAA9\C744 \BCF4\D638\D574\C11C \D398\C774\C9C0\AC00 \AC8C\C2DC\B420 \B54C \AC12\C774 \C870\C791\B418\C9C0 \C54A\B3C4\B85D \BC29\C9C0\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/item_type/display_image
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1411721528366264478.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_IMAGE'
,p_display_name=>unistr('\C774\BBF8\C9C0 \D45C\C2DC')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_IMAGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 BLOB \C5F4\C5D0 \C800\C7A5\B41C \C774\BBF8\C9C0 \B610\B294 \C774\BBF8\C9C0 URL \AE30\BC18\C758 \C774\BBF8\C9C0\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411722225512282537.4419)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\AE30\C900')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C774\BBF8\C9C0\B97C \AC80\C0C9\D560 \C704\CE58\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411722839364286570.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D398\C774\C9C0 \D56D\BAA9 \AC12\C5D0 \C800\C7A5\B41C \D398\C774\C9C0 URL')
,p_return_value=>'URL'
,p_help_text=>unistr('\C9C0\C815\B41C \D398\C774\C9C0 \D56D\BAA9\C5D0 \B300\D574 \C138\C158 \C0C1\D0DC\C5D0 \C800\C7A5\B41C \AC12\C5D0\C11C \C774\BBF8\C9C0 URL\C744 \C77D\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411723213999298173.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D56D\BAA9 \C18C\C2A4 \C18D\C131\C5D0 \C9C0\C815\B41C BLOB \C5F4')
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('<strong>\D56D\BAA9 \C18C\C2A4</strong> \C18D\C131\C5D0 \C9C0\C815\B41C BLOB \C5F4\C5D0\C11C \C774\BBF8\C9C0\B97C \C77D\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(967663732298251689.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4419)
,p_display_sequence=>30
,p_display_value=>unistr('SQL \BB38\C774 \BC18\D658\D558\B294 BLOB \C5F4')
,p_return_value=>'SQL'
,p_help_text=>unistr('\C9C0\C815\B41C SQL \BB38\C73C\B85C \BC18\D658\B41C BLOB \C5F4\C744 \AE30\C900\C73C\B85C \C774\BBF8\C9C0\B97C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411726413054354627.4419)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\B300\CCB4 \D14D\C2A4\D2B8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \D56D\BAA9\C73C\B85C \C774\B3D9\D560 \B54C \C2A4\D06C\B9B0 \B9AC\B354\C5D0\C11C \C77D\D600\C9C0\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(483911502060080155.4419)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\B300\CCB4 \D14D\C2A4\D2B8 \C5F4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\C774 \C774\BBF8\C9C0\C5D0 \B300\D55C \B300\CCB4 \D14D\C2A4\D2B8\B97C \C800\C7A5\D558\B294 \B300\BB38\C790\B85C \B41C \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. \C774 \D14D\C2A4\D2B8\B294 \C77C\BC18 \C0AC\C6A9\C790\AC00 \C774 \D56D\BAA9\C73C\B85C \C774\B3D9\D560 \B54C \C2A4\D06C\B9B0 \B9AC\B354\C5D0\C11C \C77D\D600\C9D1\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725016255336668.4419)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\D30C\C77C \C774\B984 \C5F4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('BLOB \C5F4\ACFC \C5F0\AD00\B41C \D30C\C77C \C774\B984 \C5F4 \AC12\C744 \C800\C7A5\D558\B294 \B300\BB38\C790 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.')
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725531492341063.4419)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('BLOB \CD5C\C885 \C5C5\B370\C774\D2B8 \C5F4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C5F0\AD00\B41C BLOB\AC00 \B9C8\C9C0\B9C9\C73C\B85C \C5C5\B370\C774\D2B8\B418\C5C8\C744 \B54C \B0A0\C9DC \C5F4 \AC12\C744 \C800\C7A5\D558\B294 \B300\BB38\C790 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\C774 \AC12\C740 \BE0C\B77C\C6B0\C800 \CE90\C2F1\C5D0 \C0AC\C6A9\B418\BA70 \BE0C\B77C\C6B0\C800\C758 \B9C8\C9C0\B9C9 \C694\CCAD \C774\D6C4\C5D0 \C774\BBF8\C9C0\AC00 \BCC0\ACBD\B418\C5C8\B294\C9C0 \C5EC\BD80\B97C \C2DD\BCC4\D558\AE30 \C704\D574 \C0AC\C6A9\B429\B2C8\B2E4. \C774\BBF8\C9C0\AC00 \C5C5\B370\C774\D2B8\B418\C5C8\C73C\BA74 \C774\BBF8\C9C0\AC00 \BE0C\B77C\C6B0\C800 \CE90\C2DC(\C0AC\C6A9 \AC00\B2A5\D55C \ACBD\C6B0)\C5D0\C11C \AC80\C0C9\B429\B2C8\B2E4.</p>')))
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(967666433253270876.4419)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>unistr('SQL \BB38')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select product_image,',
'       product_name as alt_text,',
'       filename,',
'       mimetype',
'  from demo_product_info',
' where product_id = :P6_PRODUCT_ID',
'</pre>'))
,p_help_text=>unistr('\C774\BBF8\C9C0\AC00 \D3EC\D568\B41C BLOB \C5F4\C744 \BC18\D658\D558\AE30 \C704\D55C SQL \BB38\C744 \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91302656605713331.4419)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>50
,p_prompt=>unistr('MIME \C720\D615 \C5F4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\C5C5\B85C\B4DC\B41C \D30C\C77C\C758 mime \C720\D615\C744 \C800\C7A5\D558\B294 \B370 \C0AC\C6A9\B418\B294 \B300\BB38\C790 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9 \C774\B984\C744 \C785\B825\D569\B2C8\B2E4. mime \C720\D615\C740 \D30C\C77C\C774 \B2E4\C6B4\B85C\B4DC\B418\C5C8\C744 \B54C BLOB\C758 \CF58\D150\CE20\B97C \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\D560 \C560\D50C\B9AC\CF00\C774\C158\C744 \BE0C\B77C\C6B0\C800\C5D0\C11C \C2DD\BCC4\D558\AE30 \C704\D574 \C0AC\C6A9\B429\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/item_type/auto_complete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1446346919506821055.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'AUTO_COMPLETE'
,p_display_name=>unistr('\D14D\C2A4\D2B8 \D544\B4DC(\C790\B3D9 \C644\C131 \C0AC\C6A9)')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','AUTO_COMPLETE'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.inputSearch#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:CASCADING_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C774\BBF8 \C785\B825\D55C \D14D\C2A4\D2B8\B97C \AE30\BC18\C73C\B85C \D14D\C2A4\D2B8 \D56D\BAA9\ACFC \D568\AED8 \AC00\B2A5\D55C \AC12 \BAA9\B85D\C744 \D45C\C2DC\D558\B294 \D14D\C2A4\D2B8 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4. \C774 \BAA9\B85D\C740 \C77C\BC18 \C0AC\C6A9\C790\AC00 \B354 \B9CE\C740 \D14D\C2A4\D2B8\B97C \C785\B825\D560\C218\B85D \C138\BD84\D654\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446356110531045518.4419)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\AC80\C0C9')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONTAINS_IGNORE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C785\B825\D55C \AC12\C5D0 \B300\D55C \AC80\C0C9\C774 \C218\D589\B418\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4. <em>\C9C0\C5F0 \B85C\B529</em>\C744 \C0AC\C6A9\D560 \B54C \C774 \C124\C815\C740 \C9C8\C758 \C131\B2A5\C5D0 \C601\D5A5\C744 \C904 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: <strong>\D3EC\D568 \BC0F \B300\C18C\BB38\C790 \AD6C\BD84</strong> \B610\B294 <strong>\D3EC\D568 \BC0F \B300\C18C\BB38\C790 \BB34\C2DC</strong>\B97C \C120\D0DD\D558\BA74 \C5F4 \C778\B371\C2A4 \C0AC\C6A9\C774 \BC29\C9C0\B429\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406465150066557.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D3EC\D568 \BC0F \B300\C18C\BB38\C790 \AD6C\BD84')
,p_return_value=>'CONTAINS_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406557760066557.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C815\D655 \BC0F \B300\C18C\BB38\C790 \AD6C\BD84')
,p_return_value=>'EXACT_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406651197066557.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\D3EC\D568 \BC0F \B300\C18C\BB38\C790 \BB34\C2DC')
,p_return_value=>'CONTAINS_IGNORE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406756688066558.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\C815\D655 \BC0F \B300\C18C\BB38\C790 \BB34\C2DC')
,p_return_value=>'EXACT_IGNORE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446360005383072413.4419)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C9C0\C5F0 \B85C\B529')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><em>\C9C0\C5F0 \B85C\B529</em> \AE30\BC95\C744 \C0AC\C6A9\D574\C11C \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \C77C\CE58\D558\B294 \AC12\C744 \AC80\C0C9\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C9C0\C5F0 \B85C\B529\C740 \C0AC\C6A9\C790\AC00 \BB38\C790\B97C \C785\B825\D560 \B54C\B9C8\B2E4 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \C77C\CE58\D558\B294 \B808\CF54\B4DC\B97C \AC80\C0C9\D569\B2C8\B2E4. \ADF8\B807\C9C0 \C54A\C73C\BA74 \BAA8\B4E0 \AC12 \BAA9\B85D\C774 \D398\C774\C9C0 \B85C\B4DC \C2DC\C5D0 \B85C\B4DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\B9CE\C740 \C218\C758 \B808\CF54\B4DC\B97C \B85C\B4DC\D558\BA74 \CC98\C74C\C5D0 \D398\C774\C9C0\B97C \B85C\B4DC\D558\B294 \C2DC\AC04\C5D0 \C601\D5A5\C744 \C904 \C218 \C788\C73C\BBC0\B85C Oracle\C740 \C120\D0DD \BAA9\B85D\C774 \D074 \ACBD\C6B0\C5D0 <em>\C9C0\C5F0 \B85C\B529</em>\C744 \C0AC\C6A9\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446361019928076629.4419)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\BAA9\B85D\C758 \CD5C\B300\AC12')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C120\D0DD \C0C1\C790\C5D0 \D45C\C2DC\D560 \CD5C\B300 \D56D\BAA9 \C218\B97C \C785\B825\D569\B2C8\B2E4.</p> '),
unistr('<p>\C774 \AC12\C740 \B108\BB34 \B9CE\C740 \D589\C744 \BC18\D658\D574\C11C \C131\B2A5 \BB38\C81C\AC00 \BC1C\C0DD\D558\C9C0 \C54A\B3C4\B85D \D558\ACE0, \CC98\C74C \BA87 \AE00\C790\B9CC \C785\B825\D588\C744 \B54C \B108\BB34 \D070 \C9D1\D569\C774 \BC18\D658\B418\C9C0 \C54A\B3C4\B85D \BC29\C9C0\D558\B294 \B370 \B3C4\C6C0\C774 \B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(224532777127157782.4419)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\CD5C\C18C \AC80\C0C9')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_show_in_wizard=>false
,p_unit=>unistr('\BB38\C790')
,p_is_translatable=>false
,p_help_text=>unistr('<p>\AC80\C0C9\C774 \C2E4\D589\B418\AE30 \C804 \C785\B825\D574\C57C \D558\B294 \CD5C\C18C \BB38\C790 \C218\B97C \C9C0\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388196560996701804.4419)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>45
,p_prompt=>unistr('\CE90\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\C9C0\C5F0 \B85C\B529\C744 \C0AC\C6A9\D558\C5EC \C77C\CE58\D558\B294 \B808\CF54\B4DC\B97C \AC80\C0C9\D560 \B54C \AC80\C0C9 \ACB0\ACFC\AC00 \CE90\C2DC\C5D0 \C800\C7A5\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845152901732834477.4419)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4419)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\D398\C774\C9C0 \D56D\BAA9\C5D0 \B3D9\C77C\D55C \AC12 \D45C\C2DC \BC0F \C800\C7A5</dt>'),
'<dd><pre>',
'select ename',
'  from emp',
' order by 1',
'</pre></dd>',
unistr('<dt>\BC14\C778\B4DC \BCC0\C218\B97C \C0AC\C6A9\D558\C5EC \D2B9\C815 \BD80\C11C\C758 \C9C1\C6D0 \D45C\C2DC</dt>'),
'<dd><pre>',
'select ename',
'  from emp',
' where deptno = :P3_DEPTNO',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: <code>P3_DEPTNO</code>\AC00 \B3D9\C77C\D55C \D398\C774\C9C0\C5D0 \C788\B294 \C218\C815 \AC00\B2A5\D55C \D398\C774\C9C0 \D56D\BAA9\C778 \ACBD\C6B0 <em>\C885\C18D LOV \C0C1\C704 \D56D\BAA9</em> \C18D\C131\C744 <code>P3_DEPTNO</code>\B85C \C124\C815\D569\B2C8\B2E4.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(345454551021287898.4419)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4419)
,p_name=>'ojupdate'
,p_display_name=>unistr('\C5C5\B370\C774\D2B8')
);
end;
/
prompt --application/shared_components/plugins/item_type/rich_text_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1630055805138100682.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RICH_TEXT_EDITOR'
,p_display_name=>unistr('\C11C\C2DD \C788\B294 \D14D\C2A4\D2B8 \D3B8\C9D1\AE30')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RICH_TEXT_EDITOR'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D3EC\AD04\C801\C778 \D14D\C2A4\D2B8 \D615\C2DD \C9C0\C815 \C635\C158\C73C\B85C \D14D\C2A4\D2B8 \C601\C5ED\C744 \D45C\C2DC\D569\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\B294 Microsoft Word\C640 \AC19\C740 \C6CC\B4DC \D504\B85C\C138\C11C\B97C \C0AC\C6A9\D560 \B54C\C640 \BE44\C2B7\D55C \BC29\C2DD\C73C\B85C \CF58\D150\CE20 \D45C\C2DC\B97C \D5A5\C0C1\C2DC\D0AC \C218 \C788\C2B5\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\B294 \B610\D55C RTF(\C11C\C2DD \C788\B294 \D14D\C2A4\D2B8 \D615\C2DD) \D30C\C77C \D615\C2DD\C758 \BB38\C11C\B97C \C774 \D56D\BAA9\C5D0 <em>\C798\B77C\B0B4\ACE0 \BD99\C5EC\B123\C744</em> \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1343844517421090812.4419)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\BC18\C751\D615[\C0AC\C6A9\B418\C9C0 \C54A\C74C]')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('\C11C\C2DD \C788\B294 \D14D\C2A4\D2B8 \D3B8\C9D1\AE30\AC00 \CEE8\D14C\C774\B108 \C601\C5ED \D06C\AE30\C5D0 \B9DE\AC8C \C790\B3D9\C73C\B85C \C870\C815\B418\C5B4\C57C \D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C774\B97C \C704\D574\C11C\B294 \C560\D50C\B9AC\CF00\C774\C158\C774 \BC94\C6A9 \D14C\B9C8 \B610\B294 \B2E4\B978 \C751\B2F5 \D14C\B9C8\B97C \C0AC\C6A9\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630056002845109474.4419)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\B3C4\AD6C \BAA8\C74C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Intermediate'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(635934396859331517.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D3B8\C9D1\AE30 \B0B4\C5D0\C11C \C81C\ACF5\B418\B294 \D14D\C2A4\D2B8 \D615\C2DD \C9C0\C815 \C635\C158 \C218\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056586699114299.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\AE30\BCF8')
,p_return_value=>'Basic'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1263397500002270668.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C911\AC04')
,p_return_value=>'Intermediate'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056989123115033.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C804\CCB4')
,p_return_value=>'Full'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630057694103125908.4419)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\B3C4\AD6C \BAA8\C74C \D655\C7A5\B428')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_help_text=>unistr('\D14D\C2A4\D2B8 \C601\C5ED \B0B4\C5D0\C11C \D3B8\C9D1\AE30\B97C \CC98\C74C\C5D0 \D655\C7A5\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630058192849134992.4419)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C2A4\D0A8')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D3B8\C9D1\AE30 \C2A4\D0C0\C77C \C9C0\C815\C5D0 \C0AC\C6A9\B418\B294 \D3B8\C9D1\AE30 \C2A4\D0A8\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630058796312136026.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4419)
,p_display_sequence=>1
,p_display_value=>'Moono'
,p_return_value=>'moono'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1637507209047437360.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4419)
,p_display_sequence=>2
,p_display_value=>unistr('Moono \C0C9\C0C1')
,p_return_value=>'moonocolor'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630059200467137193.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4419)
,p_display_sequence=>3
,p_display_value=>'Kama'
,p_return_value=>'kama'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1270283182212293963.4419)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\B3C4\AD6C \BAA8\C74C \C704\CE58')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'top'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D14D\C2A4\D2B8 \C601\C5ED\C5D0\C11C \D3B8\C9D1\AE30\AC00 \D45C\C2DC\B418\B294 \C704\CE58\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283477898295997.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\CD5C\C0C1\C704')
,p_return_value=>'top'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283876173296808.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C544\B798\CABD')
,p_return_value=>'bottom'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262285287257225297.4419)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_prompt=>unistr('\BC84\C804')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('CK \D3B8\C9D1\AE30 5')
,p_deprecated_values=>'4'
,p_help_text=>unistr('<p>CKEditor 4\B294 \C0AC\C6A9\C774 \C911\B2E8\B418\C5C8\C73C\BA70 \ACE7 CKEditor 5\B85C \BC14\B01D\B2C8\B2E4. \B530\B77C\C11C \D6C4\C18D \BC84\C804\C5D0\C11C \C560\D50C\B9AC\CF00\C774\C158\C774 \C190\C0C1\B418\C9C0 \C54A\B3C4\B85D \C9C0\AE08 \C804\D658\D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\C815\C758 \CD08\AE30\D654 JavaScript \CF54\B4DC\B97C \C0AC\C6A9\D55C \ACBD\C6B0 CKEditor\C758 API\AC00 \BCC0\ACBD\B418\ACE0 \CF54\B4DC\B97C \C870\C815\D574\C57C \D560 \C218 \C788\C2B5\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1262285918525227088.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1262285287257225297.4419)
,p_display_sequence=>10
,p_display_value=>unistr('CK \D3B8\C9D1\AE30 4[\C0AC\C6A9\B418\C9C0 \C54A\C74C]')
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262287152809234036.4419)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\CD5C\C18C \B192\C774')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'180'
,p_display_length=>100
,p_unit=>unistr('\D53D\C140')
,p_is_translatable=>false
,p_help_text=>unistr('\D3B8\C9D1 \AC00\B2A5\D55C \C601\C5ED\C758 \CD5C\C18C \B192\C774(\D53D\C140)\B97C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262288044006238954.4419)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\CD5C\B300 \B192\C774')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>100
,p_unit=>unistr('\D53D\C140')
,p_is_translatable=>false
,p_help_text=>unistr('\D3B8\C9D1 \AC00\B2A5\D55C \C601\C5ED\C758 \CD5C\B300 \B192\C774(\D53D\C140)\B97C \C124\C815\D569\B2C8\B2E4. \C774 \C18D\C131\C744 \BE44\C6CC \B450\BA74 \C785\B825\C5D0 \B530\B77C \D3B8\C9D1\AE30\AC00 \ACC4\C18D \CEE4\C9D1\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(635934396859331517.4419)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>1
,p_prompt=>unistr('\D615\C2DD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MARKDOWN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C11C\C2DD \C788\B294 \D14D\C2A4\D2B8 \D3B8\C9D1\AE30\C5D0 \C785\B825\B41C \CF58\D150\CE20\C758 \CD9C\B825 \D615\C2DD\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635934864536336814.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4419)
,p_display_sequence=>10
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('\C774 \C11C\C2DD \C788\B294 \D14D\C2A4\D2B8 \D3B8\C9D1\AE30\C758 \C18C\C2A4 \BC0F \CD9C\B825\C5D0 HTML\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635935286305339196.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\B9C8\D06C\B2E4\C6B4')
,p_return_value=>'MARKDOWN'
,p_help_text=>unistr('\C774 \C11C\C2DD \C788\B294 \D14D\C2A4\D2B8 \D3B8\C9D1\AE30\C758 \C18C\C2A4 \BC0F \CD9C\B825\C5D0 \B9C8\D06C\B2E4\C6B4 \D615\C2DD\C744 \C0AC\C6A9\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3112575602612766963.4419)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4419)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function(options){',
unistr('    // \C790\B3D9 \D615\C2DD \C9C0\C815 \D56D\BAA9\C744 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4.'),
'    options.editorOptions.removePlugins.push(''Autoformat'');',
unistr('    // \C0AC\C6A9\C790\C815\C758 \B3C4\AD6C \BAA8\C74C\C744 \C801\C6A9\D569\B2C8\B2E4.'),
'    options.editorOptions.toolbar = [',
'        ''heading'', ''bulletedList'', ''numberedList'', ''fontSize'', ''undo'', ''redo''',
'    ];',
'    return options;',
'}',
'</pre>'))
,p_help_text=>unistr('\D45C\C900 \D3B8\C9D1\AE30 \AD6C\C131\C744 \BB34\D6A8\D654\D558\AE30 \C704\D574 JavaScript \D568\C218\B97C \C785\B825\D569\B2C8\B2E4. CKEditor5 \D2B9\C815 \C635\C158\C740 <code>options.editorOptions</code>\C5D0 \C801\C6A9\D574\C57C \D569\B2C8\B2E4. \C790\C138\D55C \B0B4\C6A9\C740 CKEditor5 API \BB38\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.')
);
end;
/
prompt --application/shared_components/plugins/item_type/color_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1779772489424311086.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COLOR_PICKER'
,p_display_name=>unistr('\C0C9\C0C1 \C120\D0DD\AE30')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COLOR_PICKER'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C0AC\C6A9\C790\AC00 \C0C9\C0C1\C744 \C120\D0DD\D558\AC70\B098 \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4. \C0C9\C0C1\C740 \C0C9\C0C1 \C2A4\D399\D2B8\B7FC\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
,p_version_identifier=>'2.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550403250259918560.4419)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\BAA8\B4DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551367544301244965.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C0C9\C0C1 \C120\D0DD\AE30\C5D0 \D45C\C2DC\B420 \C815\BCF4\C758 \C591\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550403921767922285.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\B2E8\C21C')
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('\C0C9\C0C1 \C2A4\D399\D2B8\B7FC \CF58\D2B8\B864 \BC0F \C0C9\C0C1 \C0AC\C804 \C124\C815\B9CC \D45C\C2DC\D569\B2C8\B2E4(\C815\C758\B41C \ACBD\C6B0).')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550404269414923460.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C804\CCB4')
,p_return_value=>'FULL'
,p_help_text=>unistr('\AC12 \BC18\D658 \D615\C2DD\C5D0 \B530\B77C \C120\D0DD\C801 \C54C\D30C \AC12\C744 \C0AC\C6A9\D558\C5EC \C0C9\C0C1\C744 Hex, HSL \B610\B294 RGB \AC12\C73C\B85C \BCF4\AC70\B098 \C785\B825\D560 \C218 \C788\B294 \CD94\AC00 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4. \B610\D55C \CD08\AE30 \C0C9\C0C1\ACFC \D604\C7AC \C0C9\C0C1\B3C4 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551367544301244965.4419)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\D45C\C2DC \D615\C2DD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C0C9\C0C1 \C120\D0DD\AE30\AC00 \D45C\C2DC\B418\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368003116247557.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D31D\C5C5')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\C0C9\C0C1\C744 \D14D\C2A4\D2B8 \D544\B4DC\C5D0 \C785\B825\D558\AC70\B098 \D31D\C5C5 \C0C9\C0C1 \C120\D0DD\AE30\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368367822248327.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C778\B77C\C778')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\C0C9\C0C1 \C120\D0DD\AE30\AC00 \C778\B77C\C778\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368820390249888.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C0C9\C0C1\B9CC \D31D\C5C5')
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('\B2E8\CD94\B97C \B204\B974\BA74 \D31D\C5C5 \C0C9\C0C1 \C120\D0DD\AE30\AC00 \C5F4\B9BD\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551469948272853196.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\AE30\BCF8 \C0C9\C0C1 \C120\D0DD\AE30')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('\AE30\BCF8 \BE0C\B77C\C6B0\C800 \C0C9\C0C1 \C785\B825\C785\B2C8\B2E4. UI\B294 \BE0C\B77C\C6B0\C800\C5D0 \B530\B77C \B2E4\B985\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(630450561726642679.4419)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\AE30\BCF8\AC12 \C0AC\C6A9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('[\ACF5\C720 \AD6C\C131\C694\C18C] > [\AD6C\C131\C694\C18C \C124\C815] \B610\B294 \C0AC\C6A9\C790\C815\C758 \C124\C815\C5D0\C11C \C774 \AD6C\C131\C694\C18C\C5D0 \B300\D574 \C815\C758\B41C \AE30\BCF8\AC12\C744 \C0AC\C6A9\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550407832783006227.4419)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('\BAA8\B4DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0C9\C0C1 \C120\D0DD\AE30\C5D0 \D45C\C2DC\B418\B294 \C815\BCF4\C758 \C591\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p>\D45C\C2DC \D615\C2DD\C774 \AE30\BCF8 \C0C9\C0C1 \C120\D0DD\AE30\C774\BA74 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408418705007375.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\B2E8\C21C')
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('\C0C9\C0C1 \C2A4\D399\D2B8\B7FC \CF58\D2B8\B864 \BC0F \C0C9\C0C1 \C0AC\C804 \C124\C815\B9CC \D45C\C2DC\D569\B2C8\B2E4(\C815\C758\B41C \ACBD\C6B0).')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408900996015864.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C804\CCB4')
,p_return_value=>'FULL'
,p_help_text=>unistr('\AC12 \BC18\D658 \D615\C2DD\C5D0 \B530\B77C \C120\D0DD\C801 \C54C\D30C \AC12\C744 \C0AC\C6A9\D558\C5EC \C0C9\C0C1\C744 Hex, HSL \B610\B294 RGB \AC12\C73C\B85C \BCF4\AC70\B098 \C785\B825\D560 \C218 \C788\B294 \CD94\AC00 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4. \B610\D55C \CD08\AE30 \C0C9\C0C1\ACFC \D604\C7AC \C0C9\C0C1\B3C4 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550764493023397466.4419)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('\D45C\C2DC \D615\C2DD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C0C9\C0C1 \C120\D0DD\AE30\AC00 \D45C\C2DC\B418\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765244915400562.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D31D\C5C5')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\C0C9\C0C1\C744 \D14D\C2A4\D2B8 \D544\B4DC\C5D0 \C785\B825\D558\AC70\B098 \D31D\C5C5 \C0C9\C0C1 \C120\D0DD\AE30\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550764781445398986.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C778\B77C\C778')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\C0C9\C0C1 \C120\D0DD\AE30\AC00 \C778\B77C\C778\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765575345402504.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C0C9\C0C1\B9CC \D31D\C5C5')
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('\B2E8\CD94\B97C \B204\B974\BA74 \D31D\C5C5 \C0C9\C0C1 \C120\D0DD\AE30\AC00 \C5F4\B9BD\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551473676631880984.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\AE30\BCF8 \C0C9\C0C1 \C120\D0DD\AE30')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('\AE30\BCF8 \BE0C\B77C\C6B0\C800 \C0C9\C0C1 \C785\B825\C785\B2C8\B2E4. UI\B294 \BE0C\B77C\C6B0\C800\C5D0 \B530\B77C \B2E4\B985\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551688608315986495.4419)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C0C9\C0C1 \C0AC\C804 \C124\C815')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THEME_STYLE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C0C9\C0C1 \C120\D0DD\AE30\C5D0 \BBF8\B9AC \C815\C758\B41C \C0C9\C0C1 \C9D1\D569\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\C640 \D45C\C2DC\D560 \ACBD\C6B0 \D14C\B9C8 \B610\B294 \C0AC\C6A9\C790\C815\C758 \C0C9\C0C1\C5D0\C11C \AC00\C838\C62C\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689124385987538.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C5C6\C74C')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689545726989556.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C \C0C9\C0C1')
,p_return_value=>'THEME_STYLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689930702991102.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C0AC\C6A9\C790\C815\C758 \C0C9\C0C1')
,p_return_value=>'CUSTOM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690436138997704.4419)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\C0C9\C0C1')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551688608315986495.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CUSTOM'
,p_examples=>'#FF0000;#00FF00;#0000FF;rgb(27,204,119)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C0C9\C0C1 \C120\D0DD\AE30 \B300\D654\C0C1\C790\C5D0 \D45C\C2DC\D560 \C0AC\C804 \C124\C815\B41C \C0C9\C0C1 \BAA9\B85D\C785\B2C8\B2E4.'),
unistr('\C0C9\C0C1\C740 \C138\BBF8\CF5C\B860\C73C\B85C \AD6C\BD84\D569\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690938640005057.4419)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\B300\BE44 \B300\C0C1')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D56D\BAA9\C758 \C0C9\C0C1\C744 \B2E4\B978 \D56D\BAA9\C758 \C0C9\C0C1 \B610\B294 \C815\C801 \AC12\ACFC \BE44\AD50\D558\ACE0 \C0C9\C0C1 \C120\D0DD\AE30 UI\C5D0\C11C \C774\B4E4 \AC04\C758 \B300\BE44 \BE44\C728\C744 \D45C\C2DC\D560 \C218 \C788\C2B5\B2C8\B2E4. '),
unistr('\C774\B807\AC8C \D558\BA74 \BAA8\B4E0 \C0AC\C6A9\C790\AC00 \C561\C138\C2A4\D560 \C218 \C788\C744 \B9CC\D07C \B300\BE44\AC00 \CDA9\BD84\D55C \C0C9\C0C1\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691368715005731.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C5C6\C74C')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691786900007756.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D398\C774\C9C0 \D56D\BAA9')
,p_return_value=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551692243251008710.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C815\C801 \C0C9\C0C1')
,p_return_value=>'STATIC'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551692721781014969.4419)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\B300\BE44 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>unistr('\B300\BE44 \BE44\AD50\C5D0 \C0AC\C6A9\D560 \D56D\BAA9\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551693186879019659.4419)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\B300\BE44 \C0C9\C0C1')
,p_attribute_type=>'COLOR'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('\B300\BE44 \BE44\AD50\C5D0 \C0AC\C6A9\D560 \C0C9\C0C1\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549148889210907047.4419)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\AC12 \BC18\D658 \D615\C2DD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HEX'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C774 \D56D\BAA9\C774 \BC18\D658\D558\B294 \C0C9\C0C1 \AC12\C758 \D615\C2DD\C744 \C9C0\C815\D569\B2C8\B2E4. \C0C9\C0C1\C774 \B2E4\B978 \C801\D569\D55C \D615\C2DD\C73C\B85C \C785\B825\B41C \ACBD\C6B0\C5D0\B3C4 \C774 \D615\C2DD\C73C\B85C \D45C\C2DC, \BC18\D658 \BC0F \C11C\BC84\B85C \C804\C1A1\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149330423908665.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4419)
,p_display_sequence=>10
,p_display_value=>unistr('16\C9C4\C218')
,p_return_value=>'HEX'
,p_help_text=>unistr('16\C9C4\C218 \C0C9\C0C1 \AC12\C785\B2C8\B2E4. \C54C\D30C \AC12\C740 \D5C8\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4(\C608: #2244ee).')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149780463910228.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4419)
,p_display_sequence=>20
,p_display_value=>'rgb'
,p_return_value=>'RGB'
,p_help_text=>unistr('rgb \D568\C218 \D45C\AE30\BC95\C758 \BE68\AC04\C0C9, \B179\C0C9, \D30C\B780\C0C9\C785\B2C8\B2E4(\C608: rgb(34,68,238)).')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549320695805038594.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4419)
,p_display_sequence=>30
,p_display_value=>'rgb/rgba'
,p_return_value=>'RGBA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C120\D0DD\C801 \C54C\D30C(\D22C\BA85\B3C4)\B97C \C0AC\C6A9\D558\B294 rgb/rgba \D568\C218 \D45C\AE30\BC95\C758 \BE68\AC04\C0C9, \B179\C0C9, \D30C\B780\C0C9\C785\B2C8\B2E4.'),
unistr('\C0C9\C0C1\C5D0 \C54C\D30C(\C54C\D30C = 1)\AC00 \C5C6\C73C\BA74 rgb \D615\C2DD\C774 \C0AC\C6A9\B429\B2C8\B2E4.'),
unistr('\C0C9\C0C1\C5D0 \C54C\D30C\AC00 \C788\C73C\BA74 rgba \D615\C2DD\C774 \C0AC\C6A9\B429\B2C8\B2E4.'),
unistr('\C608: rgba(34,68,238,0.5)')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549150182877911677.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4419)
,p_display_sequence=>40
,p_display_value=>'hsl'
,p_return_value=>'HSL'
,p_help_text=>unistr('hsl \D568\C218 \D45C\AE30\BC95\C758 \C0C9\C870, \CC44\B3C4, \BC1D\AE30\C785\B2C8\B2E4(\C608: hsl(230,86,53)).')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321101724039553.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4419)
,p_display_sequence=>50
,p_display_value=>'hsl/hsla'
,p_return_value=>'HSLA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C120\D0DD\C801 \C54C\D30C(\D22C\BA85\B3C4)\B97C \C0AC\C6A9\D558\B294 hsl/hsla \D568\C218 \D45C\AE30\BC95\C758 \C0C9\B3C4, \CC44\B3C4, \BC1D\AE30\C785\B2C8\B2E4.'),
unistr('\C0C9\C0C1\C5D0 \C54C\D30C(\C54C\D30C = 1)\AC00 \C5C6\C73C\BA74 hsl \D615\C2DD\C774 \C0AC\C6A9\B429\B2C8\B2E4.'),
unistr('\C0C9\C0C1\C5D0 \C54C\D30C\AC00 \C788\C73C\BA74 hsla \D615\C2DD\C774 \C0AC\C6A9\B429\B2C8\B2E4.'),
unistr('\C608: hsla(230,86,53,0.5)')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321450357041193.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4419)
,p_display_sequence=>60
,p_display_value=>unistr('CSS \AC12')
,p_return_value=>'CSS'
,p_help_text=>unistr('\C0C9\C0C1 \C774\B984 \B610\B294 CSS \BCC0\C218\B97C \D3EC\D568\D55C \C801\D569\D55C CSS \C0C9\C0C1 \D615\C2DD\C785\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/item_type/popup_lov
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'POPUP_LOV'
,p_display_name=>unistr('\D31D\C5C5 LOV')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','POPUP_LOV'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\AC12 \BAA9\B85D \D31D\C5C5 \C544\C774\CF58\C774 \D3EC\D568\B41C \D14D\C2A4\D2B8 \D544\B4DC\B97C \D45C\C2DC\D569\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\AC00 \C544\C774\CF58\C744 \B204\B974\BA74 \AC80\C0C9 \D544\B4DC \BC0F \C9C0\C6D0\B418\B294 \AC12 \BAA9\B85D\C774 \D3EC\D568\B41C \D31D\C5C5 \CC3D\C774 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\C77C\BC18 \C0AC\C6A9\C790\AC00 \AC80\C0C9 \C870\AC74\C744 \C785\B825\D574\C11C \D45C\C2DC\B418\B294 \C0AC\C6A9 \AC00\B2A5\D55C \AC12\C744 \C904\C77C \C218 \C788\C73C\BBC0\B85C \D31D\C5C5 LOV\B294 \BAA9\B85D\C774 \D074\C218\B85D \B354 \C801\D569\D569\B2C8\B2E4. \BE44\AD50\C801 \C791\C740 \BAA9\B85D\C758 \ACBD\C6B0\C5D0\B294 <em>\C120\D0DD \BAA9\B85D</em>\C774 \B354 \C801\D569\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800068983311222289.4419)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\D45C\C2DC \D615\C2DD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D \D45C\C2DC \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069590238224258.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\BAA8\B2EC \B300\D654\C0C1\C790')
,p_return_value=>'DIALOG'
,p_help_text=>unistr('\AC12 \BAA9\B85D\C774 \BAA8\B2EC \B300\D654\C0C1\C790\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069993701225262.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C778\B77C\C778 \D31D\C5C5')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\AC12 \BAA9\B85D\C774 \D544\B4DC \C544\B798\C758 \C778\B77C\C778 \D31D\C5C5\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800067187898204706.4419)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\CD08\AE30 \C778\CD9C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\AC12 \BAA9\B85D\C5D0 \B300\D55C \CD08\AE30 \B370\C774\D130 \C778\CD9C \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4. \C774\B294 \D398\C774\C9C0\AC00 \B85C\B4DC\B418\AC70\B098 \ACC4\B2E8\C2DD \B4F1\C73C\B85C \C778\D574 \D56D\BAA9\C774 \C0C8\B85C\ACE0\CE68\B41C \D6C4 \CC98\C74C\C73C\B85C \D31D\C5C5\C774 \C5F4\B9B4 \B54C\B9CC \C801\C6A9\B429\B2C8\B2E4. \CD5C\C18C \BB38\C790 \C18D\C131\C744 \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800067791014205587.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C0AC\C6A9\C790 \C694\CCAD \C2DC')
,p_return_value=>'NO_FETCH'
,p_help_text=>unistr('\CC98\C74C\C5D0\B294 \AC80\C0C9\C5B4 \C0AC\C6A9 \C5EC\BD80\C5D0 \AD00\ACC4\C5C6\C774 \C0AC\C6A9\C790\AC00 \AC80\C0C9\D560 \B54C\AE4C\C9C0 \AC12 \BAA9\B85D\C774 \C778\CD9C\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068204174209405.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C790\B3D9')
,p_return_value=>'FIRST_ROWSET'
,p_help_text=>unistr('\CC98\C74C\C5D0\B294 \AC80\C0C9\C5B4\B97C \C0AC\C6A9\D558\C9C0 \C54A\ACE0 \AC12 \BAA9\B85D\C744 \C778\CD9C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068585605213520.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C790\B3D9(\D604\C7AC \AC12 \C0AC\C6A9)')
,p_return_value=>'FIRST_ROWSET_FILTER'
,p_help_text=>unistr('\CC98\C74C\C5D0\B294 \D604\C7AC \AC12\C744 \AC80\C0C9\C5B4\B85C \C0AC\C6A9\D558\C5EC \AC12 \BAA9\B85D\C744 \C778\CD9C\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(828501710103102611.4419)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\B2E4\C911 \AC12')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \D56D\BAA9\C5D0 \B2E4\C911 \AC12\C774 \D3EC\D568\B420 \C218 \C788\B294\C9C0 \C544\B2C8\BA74 \B2E8\C77C \AC12\B9CC \D3EC\D568\B420 \C218 \C788\B294\C9C0 \C9C0\C815\D569\B2C8\B2E4. \B2E4\C911 \AC12\C740 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C73C\B85C \BC18\D658\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037093113159140.4419)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C218\B3D9 \C785\B825')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\C218\B3D9 \C785\B825 \D5C8\C6A9 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4. [\C608]\C778 \ACBD\C6B0 \C0AC\C6A9\C790\B294 \D31D\C5C5 \AC12 \BAA9\B85D\C5D0\C11C \AE30\C874 \AC12\C744 \C120\D0DD\D558\AC70\B098 \C218\B3D9\C73C\B85C \AC12\C744 \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774\B294 \CF64\BCF4 \C0C1\C790\C640 \C720\C0AC\D569\B2C8\B2E4. [\C544\B2C8\C624]\C778 \ACBD\C6B0 \C0AC\C6A9\C790\B294 \D31D\C5C5 \AC12 \BAA9\B85D\C5D0\C11C \AC12\C744 \C120\D0DD\D560 \C218\B9CC \C788\C2B5\B2C8\B2E4. \C774\B294 \C120\D0DD \BAA9\B85D\ACFC \C720\C0AC\D569\B2C8\B2E4. \C218\B3D9 \C785\B825\C774 \D5C8\C6A9\B418\B294 \ACBD\C6B0 \D574\B2F9\D558\B294 \AC12 \BAA9\B85D\C758 \BC18\D658 \AC12\C774 \C785\B825\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037383318177266.4419)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\C785\B825\D55C \B300\B85C \AC80\C0C9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('[\C608]\C778 \ACBD\C6B0 \AC80\C0C9 \D544\B4DC\C5D0 \C785\B825\D55C \B300\B85C \AC12 \BAA9\B85D\C774 \D544\D130\B9C1\B429\B2C8\B2E4. [\C544\B2C8\C624]\C778 \ACBD\C6B0 \C0AC\C6A9\C790\AC00 Enter \B610\B294 \AC80\C0C9 \C544\C774\CF58 \B2E8\CD94\B97C \B204\B97C \B54C\AE4C\C9C0 \AC12 \BAA9\B85D\C774 \D544\D130\B9C1\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037699825192444.4419)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\CD5C\C18C \BB38\C790')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'0'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9037383318177266.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\AC12 \BAA9\B85D\C774 \C778\CD9C\B418\AE30 \C804 \AC80\C0C9\C5B4\C5D0 \D544\C694\D55C \CD5C\C18C \BB38\C790 \C218\B97C \C9C0\C815\D569\B2C8\B2E4. \C774\B294 LOV \C9C8\C758\AC00 \BD80\B2F4\C774 \D070 \C791\C5C5\C778 \ACBD\C6B0 \C218\D589\B418\B294 \AC80\C0C9\C758 \C591\C744 \C904\C774\B294 \B370 \C720\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \BAA9\B85D\C758 \BAA8\B4E0 \D45C\C2DC \AC12\C740 \C774 \CD5C\C18C \BB38\C790 \C218\BCF4\B2E4 \AE38\C5B4\C57C \D569\B2C8\B2E4. \C774\BCF4\B2E4 \C9E7\C740 \D45C\C2DC \AC12\C740 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9037973825195793.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\CD5C\C18C\AC12 \C5C6\C74C (0)')
,p_return_value=>'0'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038300277196807.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4419)
,p_display_sequence=>20
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038738010197706.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4419)
,p_display_sequence=>30
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039143176198691.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4419)
,p_display_sequence=>40
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039528380199625.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4419)
,p_display_sequence=>50
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039968403200723.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4419)
,p_display_sequence=>60
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040583894241082.4419)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\C81C\BAA9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\D31D\C5C5 \B300\D654\C0C1\C790 \C81C\BAA9\C785\B2C8\B2E4. \BE44\C6CC \B458 \ACBD\C6B0 \AE30\BCF8 \C81C\BAA9\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040894549248059.4419)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\D31D\C5C5 \B108\BE44')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>unistr('\D31D\C5C5 \B108\BE44\C785\B2C8\B2E4. \BE44\C6CC \B458 \ACBD\C6B0 \AE30\BCF8\AC12\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041180669256760.4419)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\D31D\C5C5 \B192\C774')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>unistr('\D31D\C5C5 \B192\C774\C785\B2C8\B2E4. \BE44\C6CC \B458 \ACBD\C6B0 \AE30\BCF8\AC12\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041484550137059.4419)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\CD94\AC00 \CD9C\B825')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>'COL1:P1_ITEM1,COL2:P1_ITEM2'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\CD94\AC00 LOV(\AC12 \BAA9\B85D) \C5F4\C744 \B2E4\B978 \D398\C774\C9C0 \D56D\BAA9 \BC0F \B300\D654\C2DD \ADF8\B9AC\B4DC \C5F4\C5D0 \BC18\D658\D569\B2C8\B2E4. LOV \C5F4 \C774\B984\ACFC \D398\C774\C9C0 \D56D\BAA9 \C774\B984 \B610\B294 \B300\D654\C2DD \ADF8\B9AC\B4DC \C5F4 \C815\C801 ID \AC04 \B9E4\D551\C744 \C815\C758\D569\B2C8\B2E4.</p>'),
unistr('<p>\CC38\ACE0: \C774 \C124\C815\C740 LOV \C815\C758\C5D0 \CD94\AC00 \C5F4\C774 \D3EC\D568\B41C \ACBD\C6B0\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(311784600505681020.4419)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>35
,p_prompt=>unistr('\AD6C\BD84 \AE30\D638')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>':'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(9034124600967605.4419)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function(options) {',
'    options.resizable = false;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D31D\C5C5 LOV \D56D\BAA9\C5D0 \B300\D55C \C635\C158 \AC1D\CCB4\B97C \AC00\C838\C628 \B2E4\C74C \AC1D\CCB4\B97C \C218\C815\D558\C5EC \BC18\D658\D558\B294 JavaScript \D568\C218\B97C \C785\B825\D569\B2C8\B2E4. \C774 \D568\C218\B97C \C0AC\C6A9\D558\BA74 \CD08\AE30\D654 \B3C4\C911 \D31D\C5C5 LOV \D56D\BAA9 \B300\D654\C0C1\C790 \BC0F \D574\B2F9 \CF58\D150\CE20\C5D0 \B300\D55C \ACE0\AE09 \C0AC\C6A9\C790\C815\C758\AC00 \AC00\B2A5\D569\B2C8\B2E4.</p>'),
'',
unistr('<p>\B2E4\C74C \C635\C158\C774 <code>popup</code> \C704\C82F \B610\B294 jQuery UI <code>dialog</code> \C704\C82F\C73C\B85C \C804\B2EC\B429\B2C8\B2E4.<br>'),
'draggable, resizable, width, height, minWidth, minHeight, maxWidth, and maxHeight<br>',
unistr('\C790\C138\D55C \B0B4\C6A9\C740 JQuery UI \B300\D654\C0C1\C790 \C704\C82F \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>'),
'',
unistr('<p>\ACB0\ACFC\AC00 \B2E8\C21C \BAA9\B85D\C5D0 \D45C\C2DC\B418\BA74 <code>defaultIconListOptions</code> \C635\C158\C740 <code>tableModelView</code> \C704\C82F\C73C\B85C \C804\B2EC\B418\B294 \AC1D\CCB4\C785\B2C8\B2E4. \C0AC\C6A9 \AC00\B2A5\D55C \C635\C158\C740 APEX tableModelView \C704\C82F \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>'),
'',
unistr('<p>\ACB0\ACFC\AC00 \ADF8\B9AC\B4DC\C5D0 \D45C\C2DC\B418\BA74 <code>defaultGridOptions</code> \C635\C158\C740 <code>grid</code> \C704\C82F\C73C\B85C \C804\B2EC\B418\B294 \AC1D\CCB4\C785\B2C8\B2E4.'),
unistr('\C0AC\C6A9 \AC00\B2A5\D55C \C635\C158\C740 APEX \ADF8\B9AC\B4DC \C704\C82F \C124\BA85\C11C\B97C \CC38\C870\D558\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153088232834479.4419)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4419)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL \C9C8\C758 \AE30\C900 \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\D45C\C2DC \BC0F \BC18\D658 \AC12\C774 \B3D9\C77C\D55C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: \D45C\C2DC \BC0F \BC18\D658 \AC12 \BAA8\B450 \B3D9\C77C\D55C \C5F4\C744 \C120\D0DD\D55C \ACBD\C6B0 \C5F4 \BCC4\CE6D\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
'</dd>',
unistr('<dt>\BC14\C778\B4DC \BCC0\C218\AC00 \D3EC\D568\B41C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: <code>P3_DEPTNO</code>\AC00 \B3D9\C77C\D55C \D398\C774\C9C0\C5D0 \C788\B294 \C218\C815 \AC00\B2A5\D55C \D398\C774\C9C0 \D56D\BAA9\C778 \ACBD\C6B0 <em>\C885\C18D LOV \C0C1\C704 \D56D\BAA9</em> \C18D\C131\C744 <code>P3_DEPTNO</code>\B85C \C124\C815\D569\B2C8\B2E4.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/execute_plsql_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1811565602388283608.4419)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'EXECUTE_PLSQL_CODE'
,p_display_name=>unistr('\C11C\BC84\CE21 \CF54\B4DC \C2E4\D589')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','EXECUTE_PLSQL_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C11C\BC84\C5D0\C11C \CF54\B4DC\B97C \C2E4\D589\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811566513386305684.4419)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('PL/SQL \CF54\B4DC')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\C784\AE08 \C778\C0C1\C5D0 \C801\ACA9\D55C \C9C1\C6D0\C5D0 \B300\D574 \C784\AE08\C744 3% \C778\C0C1\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>',
unistr('<p>\C774 \C608\C5D0\C11C\B294 <strong>\C81C\CD9C\D560 \D56D\BAA9</strong>\C5D0 <code>P2_DEPTNO</code>\B97C \C785\B825\D574\C57C \D569\B2C8\B2E4.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C11C\BC84\C5D0\C11C \C2E4\D589\B418\B294 \C2E4\D589 \C804\C6A9 PL/SQL \C775\BA85 \BE14\B85D\C744 \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\BC14\C778\B4DC \AD6C\BB38\C744 \C0AC\C6A9\D574\C11C \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0\C11C \B2E4\B978 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4(\C608: <code>:P1_MY_ITEM</code>). \B610\D55C \CC38\C870\B418\B294 \BAA8\B4E0 \D56D\BAA9\C740 <strong>\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9</strong>\C5D0 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700703882467720.4419)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>11
,p_prompt=>unistr('JavaScript \CF54\B4DC')
,p_attribute_type=>'MLE JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\C784\AE08 \C778\C0C1\C5D0 \C801\ACA9\D55C \C9C1\C6D0\C5D0 \B300\D574 \C784\AE08\C744 3% \C778\C0C1\D569\B2C8\B2E4.</dt>'),
'<dd><pre>',
'var rows;',
'function needsSalaryRaise( empno ) {',
'  // placeholder for some complicated logic to calculate if employee needs a raise',
'  return true;',
'}',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'  if ( needsSalaryRaise( row.EMPNO )) {',
'    apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'  }',
'}',
'</pre></dd>',
'</dl>',
unistr('<p>\C774 \C608\C5D0\C11C\B294 <strong>\C81C\CD9C\D560 \D56D\BAA9</strong>\C5D0 <code>P2_DEPTNO</code>\B97C \C785\B825\D574\C57C \D569\B2C8\B2E4.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C11C\BC84\C5D0\C11C \C2E4\D589\B418\B294 \C2E4\D589 \C804\C6A9 JavaScript \BE14\B85D\C744 \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\BC14\C778\B4DC \AD6C\BB38(\C608: <code>apex.env.P1_MY_ITEM</code>)\C744 \C0AC\C6A9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158 \B0B4\C5D0\C11C \B2E4\B978 \D398\C774\C9C0 \B610\B294 \C560\D50C\B9AC\CF00\C774\C158 \D56D\BAA9\C744 \CC38\C870\D560 \C218 \C788\C2B5\B2C8\B2E4. \B610\D55C \CC38\C870\B418\B294 \BAA8\B4E0 \D56D\BAA9\C740 <strong>\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9</strong>\C5D0 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811567115248315739.4419)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C81C\CD9C\D560 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C11C\BC84\C5D0 \C81C\CD9C\B418\C5B4 <strong>PL/SQL \CF54\B4DC</strong> \B0B4\C5D0\C11C \C0AC\C6A9\D560 \C218 \C788\B294 \B300\BB38\C790 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>\D56D\BAA9 \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \B54C \C774\BBF8 \C785\B825\B41C \D14D\C2A4\D2B8\AC00 \C788\C73C\BA74 \AE30\C874 \D14D\C2A4\D2B8 \B05D\C5D0 \CF64\B9C8\AC00 \D45C\C2DC\B418\ACE0 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \D56D\BAA9 \C774\B984\C774 \CD94\AC00\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(888122401495541038.4419)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\BC18\D658\D560 \D56D\BAA9')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'    apex_util.set_session_state(''P1_MY_ITEM'', ''New Value'');',
'</pre>',
'</p>',
unistr('<p>\C774 \C608\C81C\C5D0\C11C ''\C0C8 \AC12''\C744 \D398\C774\C9C0\C758 \D574\B2F9 \D56D\BAA9\C5D0 \D45C\C2DC\D558\B824\BA74 \C774 \C18D\C131\C5D0 <code>P1_MY_ITEM</code>\C744 \C785\B825\D569\B2C8\B2E4.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C138\C158 \C0C1\D0DC\C758 \D604\C7AC \AC12\C5D0 \B530\B77C \C11C\BC84 \D638\CD9C\C774 \BC18\D658\B420 \B54C \C124\C815\B418\B294 \B300\BB38\C790 \D398\C774\C9C0 \D56D\BAA9\C744 \C785\B825\D569\B2C8\B2E4. <strong>PL/SQL \CF54\B4DC</strong>\AC00 \C138\C158 \C0C1\D0DC\C758 \D398\C774\C9C0 \D56D\BAA9 \AC12\C744 \D558\B098 \C774\C0C1 \C124\C815\D560 \B54C\B294 \C774 \C18D\C131\C5D0\C11C \D56D\BAA9\C744 \C815\C758\D574\C57C \D569\B2C8\B2E4.</p>'),
unistr('<p>\D56D\BAA9 \C774\B984\C744 \C785\B825\D558\AC70\B098 \C0AC\C6A9 \AC00\B2A5\D55C \D56D\BAA9 \BAA9\B85D \C911\C5D0\C11C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\BAA9\B85D\C5D0\C11C \C120\D0DD\D560 \B54C \C774\BBF8 \C785\B825\B41C \D14D\C2A4\D2B8\AC00 \C788\C73C\BA74 \AE30\C874 \D14D\C2A4\D2B8 \B05D\C5D0 \CF64\B9C8\AC00 \D45C\C2DC\B418\ACE0 \BAA9\B85D\C5D0\C11C \BC18\D658\B41C \D56D\BAA9 \C774\B984\C774 \CD94\AC00\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1002790918416823799.4419)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\BCC0\ACBD \C774\BCA4\D2B8 \C228\AE30\AE30')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(888122401495541038.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('<strong>\BC18\D658\D560 \D398\C774\C9C0 \D56D\BAA9</strong>\C5D0 \C9C0\C815\B41C \D56D\BAA9\C5D0\C11C \BCC0\ACBD \C774\BCA4\D2B8\AC00 \D45C\C2DC\B418\C9C0 \C54A\B3C4\B85D \D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4. \C774\B807\AC8C \D558\BA74 \D574\B2F9 \D56D\BAA9\C5D0 \B300\D574 \C774\D6C4\C758 <em>\BCC0\ACBD</em> \AE30\BC18 \B3D9\C801 \C791\C5C5\C774 \C2E4\D589\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700405449462251.4419)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>5
,p_prompt=>unistr('\C5B8\C5B4')
,p_attribute_type=>'CODE LANGUAGE'
,p_is_required=>true
,p_default_value=>'PLSQL'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/item_type/display_only
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2248579157998483215.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_ONLY'
,p_display_name=>unistr('\D45C\C2DC \C804\C6A9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_ONLY'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:ICON:ENCRYPT:LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\C785\B825 \BD88\AC00\B2A5\D55C \D14D\C2A4\D2B8 \D56D\BAA9\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2248592969903496143.4419)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>50
,p_prompt=>unistr('\D398\C774\C9C0 \C81C\CD9C \C2DC \C804\C1A1')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('\D398\C774\C9C0\AC00 \C81C\CD9C\B420 \B54C \D604\C7AC \D56D\BAA9 \AC12\C744 \C804\C1A1\D574\C57C \D558\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803821466219365649.4419)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\AE30\C900')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(4800927632436292.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLAIN'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D45C\C2DC\D560 \AC12\C758 \ACB0\C815 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822070028366811.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\D56D\BAA9 \AC12')
,p_return_value=>'VALUE'
,p_help_text=>unistr('\D56D\BAA9\C758 \D604\C7AC \AC12\C774 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822445572369209.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\AC12 \BAA9\B85D \D45C\C2DC \AC12')
,p_return_value=>'LOV'
,p_help_text=>unistr('\D398\C774\C9C0 \D56D\BAA9\C758 \D604\C7AC \AC12\C774 \AC12 \BAA9\B85D\C744 \C0AC\C6A9\D574\C11C \B2E4\B978 \D45C\C2DC \AC12\C73C\B85C \B9E4\D551\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822855268372026.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4419)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \CF54\B4DC \CD9C\B825')
,p_return_value=>'PLSQL'
,p_is_deprecated=>true
,p_help_text=>unistr('\C9C0\C815\B41C PL/SQL \CF54\B4DC\AC00 \D45C\C2DC\B41C \CD9C\B825\C744 \B0B4\BCF4\B0C5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803823354360381170.4419)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('PL/SQL \CF54\B4DC')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>HTML \CF54\B4DC\B97C \B0B4\BCF4\B0B4\AE30 \C704\D574 <code>sys.htp.p</code> \B610\B294 <code>sys.htp.prn</code>\C744 \C0AC\C6A9\D574\C11C PL/SQL \CF54\B4DC\B97C \C785\B825\D569\B2C8\B2E4.</p>'),
unistr('<p>Oracle\C740 HTML \D0DC\ADF8\B97C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D560 \C218 \C788\B3C4\B85D <code>sys.htf.escape_sc</code>\B97C \C0AC\C6A9\D574\C11C \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \AC80\C0C9\B41C \B370\C774\D130\B97C \C774\C2A4\CF00\C774\D504 \CC98\B9AC\D560 \AC83\C744 \AD8C\C7A5\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1363556632373484636.4419)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C904 \BC14\AFC8 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE,LOV'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C904 \BC14\AFC8\C774 \CD9C\B825\C5D0 \BCF4\C874\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\D45C\C2DC\AC00 HTML\B85C \B80C\B354\B9C1\B418\AE30 \B54C\BB38\C5D0 <strong>\C608</strong>\B85C \C124\C815\B41C \ACBD\C6B0 \D45C\C2DC \AC12\C758 \C904 \BC14\AFC8\C774 \C62C\BC14\B974\AC8C \D45C\C2DC\B420 \C218 \C788\B3C4\B85D HTML \C904 \BC14\AFC8\C73C\B85C \BCC0\D658\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4800927632436292.4419)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>10
,p_prompt=>unistr('\D615\C2DD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801218870437281.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C77C\BC18 \D14D\C2A4\D2B8')
,p_return_value=>'PLAIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801656011439608.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4419)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4802071527441522.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\B9C8\D06C\B2E4\C6B4')
,p_return_value=>'MARKDOWN'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153181852834480.4419)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4419)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('<strong>\C608\C81C 1: SQL \C9C8\C758\B97C \AE30\C900\C73C\B85C \D558\B294 \AC12 \BAA9\B85D\C785\B2C8\B2E4.</strong>'),
'<pre>',
'SELECT dname, deptno from dept',
'</pre>',
'</p>',
'<p>',
unistr('<strong>\C608\C81C 2: \C815\C801 \BAA9\B85D \C608\C81C</strong>'),
'<ul>',
unistr('<li>STATIC:Yes;Y,No;N(Y \BC0F N \B300\C2E0 Yes/No \D45C\C2DC)</li>'),
'</ul>',
'</p>',
'',
'<p>',
unistr('<strong>\C608\C81C 3: \BC14\C778\B4DC \BCC0\C218\B97C \C0AC\C6A9\D55C \CD94\AC00 \C81C\D55C\C744 \D3EC\D568\D558\B294 \AC12 \BAA9\B85D</strong>'),
'<pre>',
'SELECT dname, deptno from dept where location=:P3_LOCATION',
'</pre>',
'</p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/star_rating
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STAR_RATING'
,p_display_name=>unistr('\BCC4\C810 \D3C9\AC00')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STAR_RATING'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ICON:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>\BAA8\B358 \BCC4\C810 \D3C9\AC00 \D56D\BAA9</strong></p>'),
unistr('<p>\C774 \D56D\BAA9\C740 \C22B\C790 \AC12\C744 \BCC4 \C218 \B610\B294 \B2E4\B978 \C544\C774\CF58\C73C\B85C \D45C\C2DC\D569\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\B294 \C6D0\D558\B294 \BCC4 \C218\B97C \C120\D0DD\D558\C5EC \AC12\C744 \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4. \B9C8\C6B0\C2A4 \B610\B294 \D0A4\BCF4\B4DC\B85C \BCC4 \C218\B97C \B20C\B7EC \AC12\C744 \C870\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\AD6C\C131\C694\C18C \C124\C815 \B610\B294 \AC1C\BCC4 \D56D\BAA9 \C124\C815\C5D0\C11C \D45C\C2DC\D560 \C544\C774\CF58, \BC30\ACBD\C0C9 \BC0F \C804\ACBD\C0C9\C744 \C870\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \AC1C\BCC4 \D56D\BAA9 \BC0F \C0C9\C0C1\C744 \C0AC\C6A9\D558\B824\BA74 <strong>\AD6C\C131\C694\C18C \AE30\BCF8\AC12 \C0AC\C6A9</strong> \C18D\C131\C744 <strong>\C544\B2C8\C624</strong>\B85C \C124\C815\D569\B2C8\B2E4.</p>'),
unistr('<p>\C544\C774\CF58\C73C\B85C \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C6A9 \AC00\B2A5\D55C \C544\C774\CF58 \AE00\AF34\C758 \BAA8\B4E0 \C544\C774\CF58\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \BC94\C6A9 \D14C\B9C8 \C560\D50C\B9AC\CF00\C774\C158\C758 \ACBD\C6B0 <em>\AE00\AF34 APEX</em> \B77C\C774\BE0C\B7EC\B9AC\C758 \C544\C774\CF58\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>')))
,p_version_identifier=>'1.0'
,p_files_version=>1149
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475527326399196418.4419)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\AE30\BCF8 \C544\C774\CF58')
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumbs-up',
'fa-database',
'</pre>'))
,p_help_text=>unistr('\C0AC\C6A9\D560 \AE30\BCF8 \C544\C774\CF58\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912433448449647.4419)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\D65C\C131 \C0C9\C0C1')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('\D65C\C131 \BCC4\C5D0 \B300\D55C \AE30\BCF8 \C0C9\C0C1\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912884614449648.4419)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\BE44\D65C\C131 \C0C9\C0C1')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('\BE44\D65C\C131 \BCC4\C5D0 \B300\D55C \AE30\BCF8 \C0C9\C0C1\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475538451111203492.4419)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\B3C4\AD6C \C124\BA85')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'#VALUE#'
,p_is_translatable=>false
,p_examples=>unistr('\D3C9\AC00: \BCC4\C810 #VALUE#\C785\B2C8\B2E4.')
,p_help_text=>unistr('\B3C4\AD6C \C124\BA85\C5D0 \B300\D55C \D15C\D50C\B9AC\D2B8\B97C \C9C0\C815\D569\B2C8\B2E4. #VALUE# \B300\CCB4\AC00 \D604\C7AC \D3C9\AC00 \AC12\C73C\B85C \BC14\B01D\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470180844645338807.4419)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\BCC4 \C218')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D45C\C2DC\D560 \CD1D \BCC4 \C218\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470251151324440675.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4419)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263362673575666.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4419)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263792668576010.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4419)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264197754576285.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4419)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264650749576748.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4419)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264961143577132.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4419)
,p_display_sequence=>60
,p_display_value=>'6'
,p_return_value=>'6'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265413888577465.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4419)
,p_display_sequence=>70
,p_display_value=>'7'
,p_return_value=>'7'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265803806577966.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4419)
,p_display_sequence=>80
,p_display_value=>'8'
,p_return_value=>'8'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266183252578379.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4419)
,p_display_sequence=>90
,p_display_value=>'9'
,p_return_value=>'9'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266568693578886.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4419)
,p_display_sequence=>100
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470195603586349451.4419)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\AE30\BCF8\AC12 \C0AC\C6A9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('[\ACF5\C720 \AD6C\C131\C694\C18C] > [\AD6C\C131\C694\C18C \C124\C815] \B610\B294 \C0AC\C6A9\C790\C815\C758 \C124\C815\C5D0\C11C \C774 \AD6C\C131\C694\C18C\C5D0 \B300\D574 \C815\C758\B41C \AE30\BCF8\AC12\C744 \C0AC\C6A9\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470360305601388583.4419)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C544\C774\CF58')
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumb-up',
'fa-database',
'</pre>'))
,p_help_text=>unistr('\C0AC\C6A9\D560 \C544\C774\CF58\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721914847860449650.4419)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\D65C\C131 \C0C9\C0C1')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\D65C\C131 \BCC4\C5D0 \B300\D55C \AE30\BCF8 \C0C9\C0C1\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915319189449650.4419)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\BE44\D65C\C131 \C0C9\C0C1')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\BE44\D65C\C131 \BCC4\C5D0 \B300\D55C \AE30\BCF8 \C0C9\C0C1\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915642741449650.4419)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\B3C4\AD6C \C124\BA85')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'#VALUE#'
,p_display_length=>30
,p_max_length=>50
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>unistr('\D3C9\AC00: \BCC4\C810\C774 #VALUE#\C785\B2C8\B2E4.')
,p_help_text=>unistr('\B3C4\AD6C \C124\BA85\C5D0 \B300\D55C \D15C\D50C\B9AC\D2B8\B97C \C9C0\C815\D569\B2C8\B2E4. #VALUE# \B300\CCB4\AC00 \D604\C7AC \D3C9\AC00 \AC12\C73C\B85C \BC14\B01D\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(576030049193688277.4419)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\C9C0\C6B0\AE30 \B2E8\CD94 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\C9C0\C6B0\AE30 \B2E8\CD94\B97C \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470218232268377857.4419)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\AC12 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\BCC4 \C606\C5D0 \AC12\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470221148895382244.4419)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\C77D\AE30 \C804\C6A9 \D45C\C2DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STARS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\D56D\BAA9\C774 \C77D\AE30 \C804\C6A9\C778 \ACBD\C6B0 \D45C\C2DC\D560 \B0B4\C6A9\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238266735410069.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\BCC4')
,p_return_value=>'STARS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238737727410979.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\AC12')
,p_return_value=>'VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239127391413405.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\BCC4 \BC0F \AC12')
,p_return_value=>'STARS_AND_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239521066415362.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4419)
,p_display_sequence=>50
,p_display_value=>unistr('\B2E8\C77C \BCC4 \BC0F \AC12')
,p_return_value=>'SINGLE_STAR_AND_VALUE'
);
end;
/
prompt --application/shared_components/plugins/item_type/checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2693981597889753854.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'CHECKBOX'
,p_display_name=>unistr('\CCB4\D06C\BC15\C2A4 \ADF8\B8F9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','CHECKBOX'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \C5EC\B7EC \AC12\C744 \C120\D0DD\D560 \C218 \C788\B3C4\B85D \C5EC\B7EC \AC12\C744 \CCB4\D06C\BC15\C2A4\B85C \D45C\C2DC\D569\B2C8\B2E4. \CCB4\D06C\BC15\C2A4\B85C \D45C\C2DC\B418\B294 \D56D\BAA9\C5D0\B294 \AC12 \BAA9\B85D\C774 \D544\C694\D569\B2C8\B2E4. \CCB4\D06C\BC15\C2A4\C5D0 \D574\B2F9\B418\B294 \AC12\C740 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \B2E8\C77C \BB38\C790\C5F4\C5D0 \C800\C7A5\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(911353315791136342.4419)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C5F4 \C218')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('\CCB4\D06C\BC15\C2A4\B97C \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \B808\C774\C544\C6C3 \C5F4 \C218\B97C \C785\B825\D569\B2C8\B2E4. \C608\B97C \B4E4\C5B4, \AC12 2\B294 \CCB4\D06C\BC15\C2A4\C5D0\C11C 2\AC1C\C758 \C5F4\C744 \D45C\C2DC\D569\B2C8\B2E4. \AE30\BCF8\C801\C73C\B85C \BAA8\B4E0 \AC12\C774 \D558\B098\C758 \C5F4\C5D0 \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12186014788201255.4419)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('\D45C\C2DC \BC29\D5A5')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\CCB4\D06C\BC15\C2A4\C758 \B80C\B354\B9C1 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186517905202120.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C218\C9C1')
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186921368203093.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C218\D3C9')
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156526173834547.4419)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4419)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL \C9C8\C758 \AE30\C900 \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\D45C\C2DC \BC0F \BC18\D658 \AC12\C774 \B3D9\C77C\D55C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: \D45C\C2DC \BC0F \BC18\D658 \AC12 \BAA8\B450 \B3D9\C77C\D55C \C5F4\C744 \C120\D0DD\D55C \ACBD\C6B0 \C5F4 \BCC4\CE6D\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
'</dd>',
unistr('<dt>\BC14\C778\B4DC \BCC0\C218\AC00 \D3EC\D568\B41C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: <code>P3_DEPTNO</code>\AC00 \B3D9\C77C\D55C \D398\C774\C9C0\C5D0 \C788\B294 \C218\C815 \AC00\B2A5\D55C \D398\C774\C9C0 \D56D\BAA9\C778 \ACBD\C6B0 <em>\C885\C18D LOV \C0C1\C704 \D56D\BAA9</em> \C18D\C131\C744 <code>P3_DEPTNO</code>\B85C \C124\C815\D569\B2C8\B2E4.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/select_list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2698572619073428716.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SELECT_LIST'
,p_display_name=>unistr('\C120\D0DD \BAA9\B85D')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SELECT_LIST'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B0B4\C7A5\B41C \AC12 \C120\D0DD\AE30 \BAA9\B85D\C774 \D3EC\D568\B41C \D56D\BAA9\C744 \D45C\C2DC\D569\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\AC00 \D56D\BAA9\C744 \B204\B974\BA74 \D604\C7AC \D56D\BAA9\ACFC \D568\AED8 \C9C0\C6D0\B418\B294 \AC12 \BAA9\B85D\C774 \C9C1\C811 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
unistr('<p>\BE44\AD50\C801 \C791\ACE0 \C5F0\C18D\C801\C774\C9C0 \C54A\C740 \BAA9\B85D\C758 \ACBD\C6B0\C5D0\B294 \C120\D0DD \BAA9\B85D\C774 \AC00\C7A5 \C801\D569\D569\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\B294 \D3EC\CEE4\C2A4\B97C \D31D\C5C5 \B300\D654\C0C1\C790\B85C \BCC0\ACBD\D560 \D544\C694 \C5C6\C774 \BAA9\B85D\C5D0\C11C \AC12\C744 \B9E4\C6B0 \BE60\B974\AC8C \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4. \D070 \BAA9\B85D\C758 \ACBD\C6B0 <em>\D31D\C5C5 LOV</em>\AC00 \B354 \C801\D569\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2698572905698434305.4419)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C120\D0DD \C2DC \D398\C774\C9C0 \C791\C5C5')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\BAA9\B85D \AC12\C744 \C120\D0DD\D560 \B54C \C218\D589\D560 \C791\C5C5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2264411080592689929.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4419)
,p_display_sequence=>1
,p_display_value=>unistr('\C5C6\C74C')
,p_return_value=>'NONE'
,p_help_text=>unistr('\AC12\C774 \BCC0\ACBD\B420 \B54C \C989\AC01\C801\C778 \C791\C5C5\C774 \C218\D589\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698575413579455462.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4419)
,p_display_sequence=>5
,p_display_value=>unistr('\D398\C774\C9C0 \C81C\CD9C')
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 \D398\C774\C9C0 \D56D\BAA9 \C774\B984\C73C\B85C \C124\C815\B41C \C0C1\D0DC\B85C \D398\C774\C9C0\AC00 \C81C\CD9C\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574606653453436.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4419)
,p_display_sequence=>7
,p_display_value=>unistr('\C7AC\C9C0\C815 \BC0F \AC12 \C124\C815')
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('\BE0C\B77C\C6B0\C800\AC00 \D604\C7AC \D398\C774\C9C0\B85C \C7AC\C9C0\C815\B418\ACE0 \D604\C7AC \D56D\BAA9\C758 \C138\C158 \C0C1\D0DC\AC00 \C120\D0DD\B41C \AC12\C73C\B85C \C124\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574220720448121.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4419)
,p_display_sequence=>9
,p_display_value=>unistr('\D398\C774\C9C0 \C7AC\C9C0\C815')
,p_return_value=>'REDIRECT_PAGE'
,p_help_text=>unistr('\BE0C\B77C\C6B0\C800\AC00 \C120\D0DD\B41C \AC12\C5D0 \D3EC\D568\B41C \D398\C774\C9C0\B85C \C7AC\C9C0\C815\B429\B2C8\B2E4. \BAA9\B85D\C758 \BC18\D658 \AC12\C5D0\B294 \C801\D569\D55C \D398\C774\C9C0 \BC88\D638 \B610\B294 \D398\C774\C9C0 \BCC4\CE6D\C774 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698573815526446624.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4419)
,p_display_sequence=>10
,p_display_value=>unistr('URL\B85C \C7AC\C9C0\C815')
,p_return_value=>'REDIRECT_URL'
,p_help_text=>unistr('\BE0C\B77C\C6B0\C800\AC00 \C120\D0DD\B41C \AC12\C5D0 \D3EC\D568\B41C URL\B85C \C7AC\C9C0\C815\B429\B2C8\B2E4. \BAA9\B85D\C758 \BC18\D658 \AC12\C5D0\B294 \C801\D569\D55C URL\C774 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(912506420442525842.4419)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\B2E4\C911 \C120\D0DD \D5C8\C6A9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NONE'
,p_help_text=>unistr('\AC12 \BAA9\B85D\C5D0\C11C \C5EC\B7EC \AC12\C744 \C120\D0DD\D558\AC70\B098 \B2E8\C77C \AC12\B9CC \C120\D0DD\D560 \C218 \C788\B294\C9C0 \C9C0\C815\D569\B2C8\B2E4. \C5EC\B7EC \AC12\C740 \CF64\B9C8\B85C \AD6C\BD84\B41C \BAA9\B85D\C73C\B85C \BC18\D658\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459061412834919653.4419)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\AC80\C99D \C2E4\D589')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('\D398\C774\C9C0\AC00 \C81C\CD9C\B420 \B54C <strong>\D398\C774\C9C0 \C81C\CD9C</strong>\C758 \D398\C774\C9C0 \C791\C5C5 \C124\C815\C5D0 \B530\B77C \AC80\C99D\C744 \C218\D589\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156662497834548.4419)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4419)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL \C9C8\C758 \AE30\C900 \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\D45C\C2DC \BC0F \BC18\D658 \AC12\C774 \B3D9\C77C\D55C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: \D45C\C2DC \BC0F \BC18\D658 \AC12 \BAA8\B450 \B3D9\C77C\D55C \C5F4\C744 \C120\D0DD\D55C \ACBD\C6B0 \C5F4 \BCC4\CE6D\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
'</dd>',
unistr('<dt>\BC14\C778\B4DC \BCC0\C218\AC00 \D3EC\D568\B41C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: <code>P3_DEPTNO</code>\AC00 \B3D9\C77C\D55C \D398\C774\C9C0\C5D0 \C788\B294 \C218\C815 \AC00\B2A5\D55C \D398\C774\C9C0 \D56D\BAA9\C778 \ACBD\C6B0 <em>\C885\C18D LOV \C0C1\C704 \D56D\BAA9</em> \C18D\C131\C744 <code>P3_DEPTNO</code>\B85C \C124\C815\D569\B2C8\B2E4.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_column_toggle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_COLUMN_TOGGLE'
,p_display_name=>unistr('\C5F4 \D1A0\AE00 \BCF4\ACE0\C11C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_COLUMN_TOGGLE'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \B7F0\D0C0\C784\C5D0 \D45C\C2DC\D560 \C5F4\C744 \C120\D0DD\D560 \C218 \C788\B294 \BCF4\ACE0\C11C\B97C \D45C\C2DC\D569\B2C8\B2E4. \ADF8\B7F0 \B2E4\C74C \C77C\BC18 \C0AC\C6A9\C790\B294 \BCF4\ACE0\C11C \D45C\C2DC\B97C \C704\D574 \C790\C2E0\C774 \C0AC\C6A9 \C911\C778 \D654\BA74\C758 \B108\BE44 \BC0F \BC29\D5A5\C744 \AE30\C900\C73C\B85C \C5F4\C744 \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823587226519967208.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C774 \BCF4\ACE0\C11C \C5F4\C758 \AE30\C900\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587544288968547.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C77C\BC18 \D14D\C2A4\D2B8')
,p_return_value=>'PLAIN'
,p_help_text=>unistr('\C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587907770969285.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\B9C1\D06C')
,p_return_value=>'LINK'
,p_help_text=>unistr('\C5F4\C744 \B9C1\D06C\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1305234852618727263.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\BE44\C728 \ADF8\B798\D504')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('\C5F4\C744 \BC31\BD84\C728 \ADF8\B798\D504\B85C \D45C\C2DC\D569\B2C8\B2E4. \AC80\C0C9\B41C \AC12\C740 0\C5D0\C11C 100 \C0AC\C774\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823588275617978359.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\B300\C0C1')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\C0AC\C6A9\C790\AC00 \AE30\C874 \D56D\BAA9\C744 \B204\B97C \B54C \D638\CD9C\D560 \B300\C0C1 \D398\C774\C9C0\B97C \C785\B825\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238927721819003883.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\B9C1\D06C \D14D\C2A4\D2B8')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\B9C1\D06C\B85C \D45C\C2DC\B420 HTML \D14D\C2A4\D2B8\B97C \C785\B825\D558\C2ED\C2DC\C624. \C774\BBF8\C9C0 \D0DC\ADF8\B97C \C0AC\C6A9\D558\C5EC \C774\BBF8\C9C0\B97C \D45C\C2DC\D558\AC70\B098, \AE30\BCF8 \C774\BBF8\C9C0 \BAA9\B85D\C5D0\C11C \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238931409403155860.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\B9C1\D06C \C18D\C131')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\B9C1\D06C \B300\C0C1, \D074\B798\C2A4 \B610\B294 \C2A4\D0C0\C77C\C744 \D3EC\D568\D574\C11C <code>&lt;a href=...&gt;</code> \D0DC\ADF8\C5D0 \D3EC\D568\D560 \CD94\AC00 \C5F4 \B9C1\D06C \C18D\C131\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305278757261772485.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\BC30\ACBD\C0C9')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\AC80\C815\C0C9&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\BE68\AC04\C0C9&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\B178\B780\C0C9&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\C5F0\B450\C0C9&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\B179\C0C9&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\CCAD\B85D\C0C9&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\D30C\B780\C0C9&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\B0A8\C0C9&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\D770\C0C9&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \ADF8\B798\D504\C758 \BC30\ACBD\C5D0 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 3\AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305279121857779186.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\C804\ACBD\C0C9')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\AC80\C815\C0C9&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\BE68\AC04\C0C9&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\B178\B780\C0C9&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\C5F0\B450\C0C9&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\B179\C0C9&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\CCAD\B85D\C0C9&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\D30C\B780\C0C9&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\B0A8\C0C9&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\D770\C0C9&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \ADF8\B798\D504\C758 \C804\ACBD\C5D0 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 3\AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305282212210798696.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\B9C9\B300 \B108\BE44')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>unistr('\D53D\C140')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('\C774 \B9C9\B300 \CC28\D2B8\C758 \B108\BE44(\D53D\C140)\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149106414354906696.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\D589 \BA38\B9AC\AE00\B85C \C0AC\C6A9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\D589\C758 \CF58\D150\CE20\B97C \AC00\C7A5 \C798 \B098\D0C0\B0B4\B294 \C5F4\C744 \C2DD\BCC4\D558\AE30 \C704\D574 \C811\ADFC\C131\C5D0 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2695400128710862038.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>25
,p_display_sequence=>250
,p_prompt=>unistr('\C6B0\C120\C21C\C704')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BCF4\ACE0\C11C\B294 \C0AC\C6A9 \AC00\B2A5\D55C \D654\BA74 \B108\BE44\C640 \C0AC\C6A9\C790\AC00 \C5F4 \C120\D0DD\AE30 \BA54\B274\C5D0\C11C \C120\D0DD\D558\AC70\B098 \C120\D0DD \D574\C81C\D55C \D45C\C2DC \C5F4 \B450 \AC00\C9C0\B97C \AE30\C900\C73C\B85C \C5F4\C744 \C228\AE30\ACE0 \D45C\C2DC\D569\B2C8\B2E4. \C0AC\C6A9\C790\C758 \C120\D0DD\C5D0 \B530\B77C \D45C\C2DC\D558\B824\B294 \AC01 \C5F4\C5D0 \B300\D55C \C6B0\C120\C21C\C704 \AC12\C744 \C120\D0DD\D558\C2ED\C2DC\C624. \C6B0\C120\C21C\C704\AC00 \BD80\C5EC\B41C \BAA8\B4E0 \C5F4\C740 \C5F4 \C120\D0DD\AE30 \BA54\B274\C5D0 \C81C\ACF5\B429\B2C8\B2E4.<p>'),
'',
unistr('<p>\C5F4\C744 \D56D\C0C1 \C720\C9C0\D558\ACE0 \C228\AE38 \C218 \C5C6\AC8C \D558\B824\BA74 <strong>\D56D\C0C1 \D45C\C2DC</strong>\B97C \C120\D0DD\D558\C2ED\C2DC\C624. \C774\B807\AC8C \D558\BA74 \C5F4\C774 \C5F4 \C120\D0DD\AE30 \BA54\B274\C5D0 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(686758760912714500.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4419)
,p_display_sequence=>5
,p_display_value=>unistr('\D56D\C0C1 \D45C\C2DC')
,p_return_value=>'ALWAYS'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557520909123628.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4419)
,p_display_sequence=>10
,p_display_value=>unistr('1 - \B9C8\C9C0\B9C9 \C228\AE30\AE30')
,p_return_value=>'1'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557959195124246.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4419)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558584414124867.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4419)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558946802125444.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4419)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559350856125993.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4419)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559812372127827.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4419)
,p_display_sequence=>60
,p_display_value=>unistr('6 - \CCAB\BC88\C9F8 \C228\AE30\AE30')
,p_return_value=>'6'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823549938363826650.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B808\C774\C544\C6C3 \C635\C158')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\CD94\AC00 \BCF4\ACE0\C11C \B808\C774\C544\C6C3 \C635\C158\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238928674387055064.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C904\BB34\B2AC')
,p_return_value=>'STRIPE'
,p_help_text=>unistr('\AC01 \D589\C5D0 \AD50\B300\B85C \BC18\BCF5\B418\B294 \D589 \C904\BB34\B2AC\B97C \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238929097998055827.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D68D')
,p_return_value=>'STROKE'
,p_help_text=>unistr('\AC01 \D589 \C0AC\C774\C5D0 \AC00\B85C \C904\C744 \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929416131062515.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('CSS \D074\B798\C2A4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\AD6C\C131\C694\C18C\C5D0 \D3EC\D568\D560 \ACF5\BC31\C73C\B85C \AD6C\BD84\B41C \CD94\AC00 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929773245063952.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C0AC\C6A9\C790\C815\C758 \C18D\C131')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>\D14C\C774\BE14 HTML \D0DC\ADF8\C5D0 \D3EC\D568\D560 \CD94\AC00 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4. \D074\B798\C2A4 HTML \C18D\C131\C740 \C0DD\C131\B418\BBC0\B85C \C81C\ACF5\D558\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4. \B300\C2E0 \C804\C6A9 <em>CSS \D074\B798\C2A4</em> \C18D\C131\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(106020849730927710.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\C5F4 \B2E8\CD94 \D14D\C2A4\D2B8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_help_text=>unistr('\C5F4 \C120\D0DD \D31D\C5C5\C744 \C5EC\B294 \B2E8\CD94\C5D0 \C0AC\C6A9\D560 \B808\C774\BE14\C785\B2C8\B2E4. \C81C\ACF5\B41C \D14D\C2A4\D2B8\AC00 \C5C6\C744 \ACBD\C6B0 \AE30\BCF8 \B808\C774\BE14\C774 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107062574864851281.4419)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4419)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C774\B984\C73C\B85C \C815\B82C\B41C \BAA8\B4E0 \C9C1\C6D0 \D45C\C2DC</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>\C774\B984\C73C\B85C \C815\B82C\B41C \D604\C7AC \BD80\C11C\C758 \BAA8\B4E0 \C9C1\C6D0 \D45C\C2DC</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>\BC14\C778\B4DC \BCC0\C218\B97C \C0AC\C6A9\D574\C11C \D398\C774\C9C0 \D56D\BAA9\C744 \CC38\C870\D560 \B54C\B294 <strong>\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9</strong>\C73C\B85C \C9C0\C815\D569\B2C8\B2E4.</p>'),
'</dd>',
'</dl>',
''))
);
end;
/
prompt --application/shared_components/plugins/item_type/shuttle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3601651046632666378.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SHUTTLE'
,p_display_name=>unistr('\C154\D2C0')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SHUTTLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\BAA9\B85D\C744 \D3EC\D568\D558\B294 \B450 \AC1C\C758 \C0C1\C790\AC00 \B4E4\C5B4 \C788\B294 \B2E4\C911 \C120\D0DD \BAA9\B85D\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4. \C67C\CABD \BAA9\B85D\C5D0\B294 \C120\D0DD\B418\C9C0 \C54A\C740 \C18C\C2A4 \AC12 \BAA9\B85D\C774 \D45C\C2DC\B418\ACE0, \C624\B978\CABD \BAA9\B85D\C5D0\B294 \D604\C7AC \C120\D0DD\B41C \AC12\C774 \D45C\C2DC\B429\B2C8\B2E4. \C77C\BC18 \C0AC\C6A9\C790\B294 \BAA9\B85D\C5D0\C11C \D558\B098 \C774\C0C1\C758 \AC12\C744 \C120\D0DD\D55C \D6C4 \C154\D2C0 \CF58\D2B8\B864\C744 \C0AC\C6A9\D574\C11C \C120\D0DD\D55C \AC12 \B610\B294 \BAA8\B4E0 \AC12\C744 \C774\B3D9\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\D604\C7AC \AC12\C740 \CF5C\B860\C73C\B85C \AD6C\BD84\B41C \B2E8\C77C \BB38\C790\C5F4\C5D0 \C800\C7A5\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1815740271128931626.4419)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\CF58\D2B8\B864 \D45C\C2DC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C154\D2C0 \AC00\C6B4\B370\C5D0 \D45C\C2DC\B418\B294 \B370\C774\D130 \C774\B3D9 \CF58\D2B8\B864\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815740874245932549.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\BAA8\B450')
,p_return_value=>'ALL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741286365936063.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C774\B3D9 \C804\C6A9')
,p_return_value=>'MOVE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741691214937407.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C815\B82C \C804\C6A9')
,p_return_value=>'ORDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815746874076970329.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\C5C6\C74C')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156821574834552.4419)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4419)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL \C9C8\C758 \AE30\C900 \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\D45C\C2DC \BC0F \BC18\D658 \AC12\C774 \B3D9\C77C\D55C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: \D45C\C2DC \BC0F \BC18\D658 \AC12 \BAA8\B450 \B3D9\C77C\D55C \C5F4\C744 \C120\D0DD\D55C \ACBD\C6B0 \C5F4 \BCC4\CE6D\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
'</dd>',
unistr('<dt>\BC14\C778\B4DC \BCC0\C218\AC00 \D3EC\D568\B41C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: <code>P3_DEPTNO</code>\AC00 \B3D9\C77C\D55C \D398\C774\C9C0\C5D0 \C788\B294 \C218\C815 \AC00\B2A5\D55C \D398\C774\C9C0 \D56D\BAA9\C778 \ACBD\C6B0 <em>\C885\C18D LOV \C0C1\C704 \D56D\BAA9</em> \C18D\C131\C744 <code>P3_DEPTNO</code>\B85C \C124\C815\D569\B2C8\B2E4.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1815705269182590478.4419)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4419)
,p_name=>'shuttlechangeorder'
,p_display_name=>unistr('\C21C\C11C \BCC0\ACBD')
);
end;
/
prompt --application/shared_components/plugins/item_type/radiogroup
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3605341835055239817.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RADIOGROUP'
,p_display_name=>unistr('\B77C\B514\C624 \ADF8\B8F9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RADIOGROUP'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 \B2E8\C77C \AC12\C744 \C120\D0DD\D560 \C218 \C788\B3C4\B85D \C5EC\B7EC \AC12\C744 \B77C\B514\C624 \ADF8\B8F9 \C635\C158\C73C\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1822713552956622305.4419)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C5F4 \C218')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('\D45C\C2DC\D560 \B77C\B514\C624 \ADF8\B8F9 \C5F4 \C218\B97C \C785\B825\D569\B2C8\B2E4. \C608\B97C \B4E4\C5B4, <code>2</code> \AC12\C740 2\AC1C \C5F4\C744 \D45C\C2DC\D558\BBC0\B85C, \AC12\C774 5\AC1C\BA74 3\AC1C \D589\C5D0 \AC78\CCD0\C11C \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823061668632450689.4419)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C120\D0DD \C2DC \D398\C774\C9C0 \C791\C5C5')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\B77C\B514\C624 \ADF8\B8F9 \AC12\C744 \C120\D0DD\D560 \B54C \C218\D589\D560 \C791\C5C5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062574865452418.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C5C6\C74C')
,p_return_value=>'NONE'
,p_help_text=>unistr('\AC12\C774 \BCC0\ACBD\B420 \B54C \C989\AC01\C801\C778 \C791\C5C5\C774 \C218\D589\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062977982453399.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D398\C774\C9C0 \C81C\CD9C')
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('\D398\C774\C9C0 \C694\CCAD\C774 \D398\C774\C9C0 \D56D\BAA9 \C774\B984\C73C\B85C \C124\C815\B41C \C0C1\D0DC\B85C \D398\C774\C9C0\AC00 \C81C\CD9C\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823063380406454049.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\C7AC\C9C0\C815 \BC0F \AC12 \C124\C815')
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('\BE0C\B77C\C6B0\C800\AC00 \D604\C7AC \D398\C774\C9C0\B85C \C7AC\C9C0\C815\B418\ACE0 \D604\C7AC \D56D\BAA9\C758 \C138\C158 \C0C1\D0DC\AC00 \C120\D0DD\B41C \AC12\C73C\B85C \C124\C815\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459060107939889859.4419)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\AC80\C99D \C2E4\D589')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823061668632450689.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('\D398\C774\C9C0\AC00 \C81C\CD9C\B420 \B54C \D398\C774\C9C0 \C791\C5C5 \C124\C815 <strong>\D398\C774\C9C0 \C81C\CD9C</strong>\B85C \C778\D574 \AC80\C99D\C744 \C218\D589\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12184106346189362.4419)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>5
,p_prompt=>unistr('\D45C\C2DC \BC29\D5A5')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\B77C\B514\C624 \ADF8\B8F9 \AC12\C744 \D45C\C2DC\D560 \BC29\D5A5\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12184610155190440.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C218\C9C1')
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12185014311191660.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C218\D3C9')
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728745079326901742.4419)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\B77C\B514\C624 \B2E8\CD94 \C228\AE30\AE30')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156982734834553.4419)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4419)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL \C9C8\C758 \AE30\C900 \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\D45C\C2DC \BC0F \BC18\D658 \AC12\C774 \B3D9\C77C\D55C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: \D45C\C2DC \BC0F \BC18\D658 \AC12 \BAA8\B450 \B3D9\C77C\D55C \C5F4\C744 \C120\D0DD\D55C \ACBD\C6B0 \C5F4 \BCC4\CE6D\C744 \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
'</dd>',
unistr('<dt>\BC14\C778\B4DC \BCC0\C218\AC00 \D3EC\D568\B41C \AC12 \BAA9\B85D</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\CC38\ACE0: <code>P3_DEPTNO</code>\AC00 \B3D9\C77C\D55C \D398\C774\C9C0\C5D0 \C788\B294 \C218\C815 \AC00\B2A5\D55C \D398\C774\C9C0 \D56D\BAA9\C778 \ACBD\C6B0 <em>\C885\C18D LOV \C0C1\C704 \D56D\BAA9</em> \C18D\C131\C744 <code>P3_DEPTNO</code>\B85C \C124\C815\D569\B2C8\B2E4.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_reflow
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4136056421507264989.4419)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_REFLOW'
,p_display_name=>unistr('\C7AC\BC30\CE58 \BCF4\ACE0\C11C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_REFLOW'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\C791\C740 \BE0C\B77C\C6B0\C800(\D654\BA74) \D06C\AE30\B85C \BCF4\ACE0\C11C\B97C \D45C\C2DC\D558\AE30 \C704\D574 \C5F4\C744 \D589\C73C\B85C \BCC0\D658\D558\B294 \C751\B2F5 \BCF4\ACE0\C11C\B97C \D45C\C2DC\D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477435524770686441.4419)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C720\D615')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\C774 \BCF4\ACE0\C11C \C5F4\C758 \AE30\C900\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477435842539687780.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C77C\BC18 \D14D\C2A4\D2B8')
,p_return_value=>'PLAIN'
,p_help_text=>unistr('\C5F4 \AC12\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477436206021688518.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\B9C1\D06C')
,p_return_value=>'LINK'
,p_help_text=>unistr('\C5F4\C744 \B9C1\D06C\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1959083150869446496.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4419)
,p_display_sequence=>30
,p_display_value=>unistr('\BE44\C728 \ADF8\B798\D504')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('\C5F4\C744 \BC31\BD84\C728 \ADF8\B798\D504\B85C \D45C\C2DC\D569\B2C8\B2E4. \AC80\C0C9\B41C \AC12\C740 0\C5D0\C11C 100 \C0AC\C774\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477436573868697592.4419)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\B300\C0C1')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\C0AC\C6A9\C790\AC00 \AE30\C874 \D56D\BAA9\C744 \B204\B97C \B54C \D638\CD9C\D560 \B300\C0C1 \D398\C774\C9C0\B97C \C785\B825\D569\B2C8\B2E4.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892776020069723116.4419)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\B9C1\D06C \D14D\C2A4\D2B8')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\B9C1\D06C\B85C \D45C\C2DC\B420 HTML \D14D\C2A4\D2B8\B97C \C785\B825\D558\C2ED\C2DC\C624. \C774\BBF8\C9C0 \D0DC\ADF8\B97C \C0AC\C6A9\D558\C5EC \C774\BBF8\C9C0\B97C \D45C\C2DC\D558\AC70\B098, \AE30\BCF8 \C774\BBF8\C9C0 \BAA9\B85D\C5D0\C11C \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892779707653875093.4419)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\B9C1\D06C \C18D\C131')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\B9C1\D06C \B300\C0C1, \D074\B798\C2A4 \B610\B294 \C2A4\D0C0\C77C\C744 \D3EC\D568\D574\C11C <code>&lt;a href=...&gt;</code> \D0DC\ADF8\C5D0 \D3EC\D568\D560 \CD94\AC00 \C5F4 \B9C1\D06C \C18D\C131\C744 \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127055512491718.4419)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\BC30\ACBD\C0C9')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\AC80\C815\C0C9&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\BE68\AC04\C0C9&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\B178\B780\C0C9&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\C5F0\B450\C0C9&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\B179\C0C9&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\CCAD\B85D\C0C9&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\D30C\B780\C0C9&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\B0A8\C0C9&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\D770\C0C9&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \ADF8\B798\D504\C758 \BC30\ACBD\C5D0 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 3\AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127420108498419.4419)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\C804\ACBD\C0C9')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C8FC\C694 HTML \C0C9\C0C1 \CF54\B4DC \C608\B294 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\AC80\C815\C0C9&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\BE68\AC04\C0C9&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\B178\B780\C0C9&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\C5F0\B450\C0C9&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\B179\C0C9&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\CCAD\B85D\C0C9&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\D30C\B780\C0C9&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\B0A8\C0C9&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\D770\C0C9&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \ADF8\B798\D504\C758 \C804\ACBD\C5D0 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 3\AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959130510461517929.4419)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\B9C9\B300 \B108\BE44')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>unistr('\D53D\C140')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('\C774 \B9C9\B300 \CC28\D2B8\C758 \B108\BE44(\D53D\C140)\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149105606951887044.4419)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4419)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\D589 \BA38\B9AC\AE00\B85C \C0AC\C6A9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\D589\C758 \CF58\D150\CE20\B97C \AC00\C7A5 \C798 \B098\D0C0\B0B4\B294 \C5F4\C744 \C2DD\BCC4\D558\AE30 \C704\D574 \C811\ADFC\C131\C5D0 \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477398236614545883.4419)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B808\C774\C544\C6C3 \C635\C158')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\CD94\AC00 \BCF4\ACE0\C11C \B808\C774\C544\C6C3 \C635\C158\C744 \C120\D0DD\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892776972637774297.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C904\BB34\B2AC')
,p_return_value=>'STRIPE'
,p_help_text=>unistr('\AC01 \D589\C5D0 \AD50\B300\B85C \BC18\BCF5\B418\B294 \D589 \C904\BB34\B2AC\B97C \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892777396248775060.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\D68D')
,p_return_value=>'STROKE'
,p_help_text=>unistr('\AC01 \D589 \C0AC\C774\C5D0 \AC00\B85C \C904\C744 \CD94\AC00\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892777714381781748.4419)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('CSS \D074\B798\C2A4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\AD6C\C131\C694\C18C\C5D0 \D3EC\D568\D560 \ACF5\BC31\C73C\B85C \AD6C\BD84\B41C \CD94\AC00 CSS \D074\B798\C2A4\B97C \C785\B825\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892778071495783185.4419)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C0AC\C6A9\C790\C815\C758 \C18D\C131')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>\D14C\C774\BE14 HTML \D0DC\ADF8\C5D0 \D3EC\D568\D560 \CD94\AC00 \C18D\C131\C744 \C785\B825\D569\B2C8\B2E4. \D074\B798\C2A4 HTML \C18D\C131\C740 \C0DD\C131\B418\BBC0\B85C \C81C\ACF5\D558\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4. \B300\C2E0 \C804\C6A9 <em>CSS \D074\B798\C2A4</em> \C18D\C131\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107061404414844166.4419)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4419)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\C774\B984\C73C\B85C \C815\B82C\B41C \BAA8\B4E0 \C9C1\C6D0 \D45C\C2DC</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>\C774\B984\C73C\B85C \C815\B82C\B41C \D604\C7AC \BD80\C11C\C758 \BAA8\B4E0 \C9C1\C6D0 \D45C\C2DC</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>\BC14\C778\B4DC \BCC0\C218\B97C \C0AC\C6A9\D574\C11C \D398\C774\C9C0 \D56D\BAA9\C744 \CC38\C870\D560 \B54C\B294 <strong>\C81C\CD9C\D560 \D398\C774\C9C0 \D56D\BAA9</strong>\C73C\B85C \C9C0\C815\D569\B2C8\B2E4.</p>'),
'</dd>',
'</dl>',
''))
);
end;
/
prompt --application/shared_components/plugins/item_type/pct_graph
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(6012795064666735813.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PCT_GRAPH'
,p_display_name=>unistr('\BE44\C728 \ADF8\B798\D504')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PCT_GRAPH'),'')
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.pctGraph#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\AC12\C744 \BC31\BD84\C728 \ADF8\B798\D504\B85C \D45C\C2DC\D569\B2C8\B2E4. \AC80\C0C9\B41C \AC12\C740 0\C5D0\C11C 100 \C0AC\C774\C5EC\C57C \D569\B2C8\B2E4.')
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760373882350100186.4419)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\AC12 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\D37C\C13C\D2B8 \AC12\C744 \D45C\C2DC\D560\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925486701799362.4419)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\BC30\ACBD\C0C9')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \ADF8\B798\D504\C758 \BC30\ACBD\C5D0 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 3\AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925773847803225.4419)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\C804\ACBD\C0C9')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \ADF8\B798\D504\C758 \C804\ACBD\C5D0 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 3\AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760374133781106494.4419)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\D14D\C2A4\D2B8 \C0C9\C0C1')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1760373882350100186.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \ADF8\B798\D504\C758 \D14D\C2A4\D2B8\C5D0 \C0AC\C6A9\B418\B294 \C0C9\C0C1\C744 \C785\B825\D569\B2C8\B2E4.'),
unistr('\C0C9\C0C1\C740 16\C9C4\C218(hex) \D45C\AE30\BC95, RGB \C0C9\C0C1 \CF54\B4DC \B610\B294 HTML \C0C9\C0C1 \C774\B984\C744 \C0AC\C6A9\D574\C11C \C9C0\C815\B429\B2C8\B2E4.</p>'),
unistr('<p>16\C9C4\C218 \D45C\AE30\BC95\C740 #xxyyzz(# \B2E4\C74C\C5D0 3\AC1C\C758 \B450 \C790\B9BF\C218 16\C9C4\C218 \C22B\C790\AC00 \C634)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xx, yy \BC0F zz\B294 \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 2\C790\B85C \B41C 16\C9C4\C218 \AC12\C785\B2C8\B2E4.'),
unistr('RGB \CF54\B4DC\B294 RGB(xxx,xxx,xxx)\B85C \C815\C758\B429\B2C8\B2E4. \C5EC\AE30\C11C xxx\B294 0~255 \C0AC\C774\C758 \C22B\C790\C774\BA70, \AC01\AC01 \BE68\AC04\C0C9, \B179\C0C9 \BC0F \D30C\B780\C0C9\C758 \B2E8\C77C 8\BE44\D2B8 \BC14\C774\D2B8 \AC12\C744 \B098\D0C0\B0C5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9\D558\B824\B294 \C0C9\C0C1\C5D0 \D574\B2F9\D558\B294 16\C9C4\C218 \CF54\B4DC \B610\B294 RGB \CF54\B4DC\B97C \CC3E\C544\BCF4\B824\BA74 \C778\D130\B137\C5D0\C11C ''HTML \C0C9\C0C1 \CF54\B4DC''\B97C \AC80\C0C9\D574\BCF4\C2ED\C2DC\C624.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765926334751816120.4419)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\B9C9\B300 \B108\BE44')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>3
,p_unit=>unistr('\D53D\C140')
,p_is_translatable=>false
,p_help_text=>unistr('\C774 \B9C9\B300 \CC28\D2B8\C758 \B108\BE44(\D53D\C140)\B97C \C785\B825\D569\B2C8\B2E4.')
);
end;
/
prompt --application/shared_components/plugins/item_type/markdown_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8511644498934019458.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'MARKDOWN_EDITOR'
,p_display_name=>unistr('\B9C8\D06C\B2E4\C6B4 \D3B8\C9D1\AE30')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','MARKDOWN_EDITOR'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:PLACEHOLDER:ENCRYPT:FILTER:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\D14D\C2A4\D2B8 \D615\C2DD \C9C0\C815 \C635\C158, \C774\BBF8\C9C0 \D3EC\D568 \C9C0\C6D0 \BC0F \D615\C2DD \C9C0\C815\B41C \D14D\C2A4\D2B8\B97C \BCFC \BBF8\B9AC\BCF4\AE30 \C635\C158\ACFC \D568\AED8 \B9C8\D06C\B2E4\C6B4 \C785\B825\C744 \C9C0\C6D0\D558\B294 \D14D\C2A4\D2B8 \C601\C5ED\C744 \D45C\C2DC\D569\B2C8\B2E4. \B9C8\D06C\B2E4\C6B4 \D3B8\C9D1\AE30\B97C \D1B5\D574 \AC04\D3B8\D55C \C77D\AE30/\C4F0\AE30\B97C \C0AC\C6A9\D558\C5EC \C77C\BC18 \D14D\C2A4\D2B8\B97C \C791\C131\D55C \D6C4 \C81C\ACF5\B41C \B2E4\C591\D55C \C635\C158\ACFC \C9C0\C6D0\B418\B294 \AD6C\BB38\C744 \C0AC\C6A9\D558\C5EC \AD6C\C870\C801\C73C\B85C \C801\D569\D55C HTML\B85C \BCC0\D658\D560 \C218 \C788\C2B5\B2C8\B2E4.')
,p_version_identifier=>'1.0.0'
,p_files_version=>408
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(34405931740234149.4419)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\B3C4\AD6C \BAA8\C74C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SIMPLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\B9C8\D06C\B2E4\C6B4 \D3B8\C9D1\AE30\C5D0 \B300\D55C \B3C4\AD6C\BAA8\C74C\C744 \AD6C\C131\D560 \B2E4\C591\D55C \C635\C158\C744 \C81C\ACF5\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408106298242570.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\B2E8\C21C')
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('\B3C4\AD6C\BAA8\C74C\C5D0 \AE30\BCF8 \D615\C2DD \C9C0\C815 \CF58\D2B8\B864\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408560093252260.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C804\CCB4')
,p_return_value=>'FULL'
,p_help_text=>unistr('\B3C4\AD6C\BAA8\C74C\C5D0 \C804\CCB4 \D615\C2DD \C9C0\C815 \CF58\D2B8\B864 \C9D1\D569\C744 \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408916632257999.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4419)
,p_display_sequence=>40
,p_display_value=>unistr('\C5C6\C74C')
,p_return_value=>'NONE'
,p_help_text=>unistr('\B3C4\AD6C\BAA8\C74C\C744 \C228\AE41\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(590983936587988716.4419)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\AD6C\BB38 \AC15\C870 \D45C\C2DC')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D2B9\C815 \B9C8\D06C\B2E4\C6B4 \C694\C18C\C5D0 \AD75\C740\CCB4, \AE30\C6B8\C784\AF34, \CF54\B4DC \BE14\B85D \B4F1\ACFC \AC19\C740 \AD6C\BB38 \AC15\C870 \D45C\C2DC\B97C \C801\C6A9\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4.</p>'),
unistr('<p>\AC15\C870 \D45C\C2DC\B294 4000\C790 \BBF8\B9CC\C758 \CF58\D150\CE20\C5D0\B9CC \C801\C6A9\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(55495142284465026.4419)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4419)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function( options ) {',
'    options.toolbar.widgetOptions.actions.push( {',
'        name: ''custom'',',
'        action: function(){',
'            alert( ''custom'' );',
'        }',
'    } );',
'    options.toolbar.widgetOptions.data.push( {',
'        groupTogether: true,',
'        controls: [',
'            {',
'                type: ''BUTTON'',',
'                label: ''Custom Button'',',
'                iconOnly: true,',
'                icon: ''fa fa-file-o'',',
'                action: ''custom''',
'            }',
'        ]',
'    } );',
'',
'    return options;',
'}</pre>'))
,p_help_text=>unistr('<p>\B9C8\D06C\B2E4\C6B4 \D3B8\C9D1\AE30\C5D0 \B300\D55C \AD6C\C131 \AC1D\CCB4\B97C \AC00\C838\C628 \B2E4\C74C \AC1D\CCB4\B97C \C218\C815\D558\C5EC \BC18\D658\D558\B294 JavaScript \D568\C218\B97C \C785\B825\D569\B2C8\B2E4. \C774 \D568\C218\B97C \C0AC\C6A9\D558\BA74 \B9C8\D06C\B2E4\C6B4 \D3B8\C9D1\AE30\C758 \BAA8\C591, \AE30\B2A5 \BC0F \B3D9\C791(\B3C4\AD6C\BAA8\C74C, \BA54\B274, \C791\C5C5 \B4F1)\C5D0 \B300\D55C \ACE0\AE09 \C0AC\C6A9\C790\C815\C758\AC00 \AC00\B2A5\D569\B2C8\B2E4.<p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(9126110225642555867.4419)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4419)
,p_name=>'markdownified'
,p_display_name=>'markdownified'
);
end;
/
prompt --application/shared_components/plugins/item_type/yes_no
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(16382027049111291021.4419)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'YES_NO'
,p_display_name=>unistr('\C2A4\C704\CE58')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','YES_NO'),'')
,p_api_version=>2
,p_render_function=>'D'
,p_validation_function=>'validate_yes_no'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\BC29\D5A5 \BC14\AFB8\AE30 \C2A4\C704\CE58\B85C \D45C\C2DC\B429\B2C8\B2E4.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14841509770799749.4419)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\C124\C815 \AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\C77C\BC18 \C0AC\C6A9\C790\AC00 <strong>\C124\C815</strong> \C635\C158\C744 \C120\D0DD\D560 \ACBD\C6B0 \D398\C774\C9C0 \D56D\BAA9\C5D0 \C800\C7A5\B418\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4. \AC12\C740 \CD5C\B300 255\C790\C77C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842132411815696.4419)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\B808\C774\BE14 \C124\C815')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\C124\C815</strong> \C635\C158\C5D0 \B300\D574 \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \D14D\C2A4\D2B8\B97C \C785\B825\D558\C9C0 \C54A\C73C\BA74 \C2DC\C2A4\D15C \AE30\BCF8 \B808\C774\BE14\C774 \C0AC\C6A9\B429\B2C8\B2E4.'),
unistr('<p>\CC38\ACE0: \AD6C\C131\C694\C18C \C124\C815 ''\D45C\C2DC \C2A4\D0C0\C77C''\C774 <strong>\C2A4\C704\CE58</strong>\C778 \ACBD\C6B0 \C774 \C18D\C131\C740 \B300\D654\C2DD \ADF8\B9AC\B4DC \C5F4\C758 \D45C\C2DC \AC12\C73C\B85C\B9CC \C0AC\C6A9\B429\B2C8\B2E4. \C77C\BC18 \D398\C774\C9C0 \D56D\BAA9\C5D0\B294 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842724970851430.4419)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\D574\C81C \AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C0AC\C6A9\C790\AC00 <strong>\D574\C81C</strong> \C635\C158\C744 \C120\D0DD\D560 \ACBD\C6B0 \D398\C774\C9C0 \D56D\BAA9\C5D0 \C800\C7A5\B418\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4. \AC12\C740 \CD5C\B300 255\C790\C77C \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: \C774 \AC12\C740 \D398\C774\C9C0 \D56D\BAA9\C774 <strong>\C124\C815 \AC12</strong> \B610\B294 <strong>\D574\C81C \AC12</strong>\ACFC \C77C\CE58\D558\C9C0 \C54A\B294 \AC12\C73C\B85C \CC44\C6CC\C9C8 \ACBD\C6B0 \C0AC\C6A9\B429\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14843532719863116.4419)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\B808\C774\BE14 \D574\C81C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\D574\C81C</strong> \C635\C158\C5D0 \B300\D574 \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4. \D14D\C2A4\D2B8\B97C \C785\B825\D558\C9C0 \C54A\C73C\BA74 \C2DC\C2A4\D15C \AE30\BCF8 \B808\C774\BE14\C774 \C0AC\C6A9\B429\B2C8\B2E4.'),
unistr('<p>\CC38\ACE0: \AD6C\C131\C694\C18C \C124\C815 ''\D45C\C2DC \C2A4\D0C0\C77C''\C774 <strong>\C2A4\C704\CE58</strong>\C778 \ACBD\C6B0 \C774 \C18D\C131\C740 \B300\D654\C2DD \ADF8\B9AC\B4DC \C5F4\C758 \D45C\C2DC \AC12\C73C\B85C\B9CC \C0AC\C6A9\B429\B2C8\B2E4. \C77C\BC18 \D398\C774\C9C0 \D56D\BAA9\C5D0\B294 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2089613064757884864.4419)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4419)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>1
,p_prompt=>unistr('\D45C\C2DC \C2A4\D0C0\C77C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'SWITCH_CB'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(306600152922320417.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4419)
,p_display_sequence=>5
,p_display_value=>unistr('\C2A4\C704\CE58')
,p_return_value=>'SWITCH_CB'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613549171886868.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4419)
,p_display_sequence=>10
,p_display_value=>unistr('\C54C\C57D \BAA8\C591 \B2E8\CD94')
,p_return_value=>'SWITCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613999173888214.4419)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4419)
,p_display_sequence=>20
,p_display_value=>unistr('\C120\D0DD \BAA9\B85D')
,p_return_value=>'SELECT_LIST'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10610711090664543.4419)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\AE30\BCF8\AC12 \C0AC\C6A9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('[\ACF5\C720 \AD6C\C131\C694\C18C] > [\AD6C\C131\C694\C18C \C124\C815] \B610\B294 \C0AC\C6A9\C790\C815\C758 \C124\C815\C5D0\C11C \C774 \AD6C\C131\C694\C18C\C5D0 \B300\D574 \C815\C758\B41C \AE30\BCF8\AC12\C744 \C0AC\C6A9\D560\C9C0 \C5EC\BD80\C785\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382071946350365830.4419)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\C124\C815 \AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\C0AC\C6A9\C790\AC00 <strong>\C124\C815</strong> \C635\C158\C744 \C120\D0DD\D560 \ACBD\C6B0 \D398\C774\C9C0 \D56D\BAA9\C5D0 \C800\C7A5\B418\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4. \AC12\C740 \CD5C\B300 255\C790\C77C \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382622645104567710.4419)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\B808\C774\BE14 \C124\C815')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\C124\C815</strong> \C635\C158\C5D0 \B300\D574 \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('<p>\CC38\ACE0: \AD6C\C131\C694\C18C \C124\C815 ''\D45C\C2DC \C2A4\D0C0\C77C''\C774 <strong>\C2A4\C704\CE58</strong>\C778 \ACBD\C6B0 \C774 \C18D\C131\C740 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382623150298569207.4419)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\D574\C81C \AC12')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C0AC\C6A9\C790\AC00 <strong>\D574\C81C</strong> \C635\C158\C744 \C120\D0DD\D560 \ACBD\C6B0 \D398\C774\C9C0 \D56D\BAA9\C5D0 \C800\C7A5\B418\B294 \AC12\C744 \C785\B825\D569\B2C8\B2E4. \D574\C81C \C635\C158\C744 \C120\D0DD\D588\C744 \B54C <code>NULL</code>\C744 \C800\C7A5\D558\B824\B294 \ACBD\C6B0\C5D0\B294 \C774 \C18D\C131\C744 \BE44\C6CC \B458 \C218\B3C4 \C788\C2B5\B2C8\B2E4. \AC12\C740 \CD5C\B300 255\C790\C77C \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p><em>\CC38\ACE0: \C774 \AC12\C740 \D398\C774\C9C0 \D56D\BAA9\C774 <strong>\C124\C815 \AC12</strong> \B610\B294 <strong>\D574\C81C \AC12</strong>\ACFC \C77C\CE58\D558\C9C0 \C54A\B294 \AC12\C73C\B85C \CC44\C6CC\C9C8 \ACBD\C6B0 \C0AC\C6A9\B429\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(21162632375092489.4419)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4419)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\B808\C774\BE14 \D574\C81C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4419)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\D574\C81C</strong> \C635\C158\C5D0 \B300\D574 \D45C\C2DC\B418\B294 \D14D\C2A4\D2B8\B97C \C785\B825\D569\B2C8\B2E4.'),
unistr('<p>\CC38\ACE0: \AD6C\C131\C694\C18C \C124\C815 ''\D45C\C2DC \C2A4\D0C0\C77C''\C774 <strong>\C2A4\C704\CE58</strong>\C778 \ACBD\C6B0 \C774 \C18D\C131\C740 \C801\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>')))
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4968506573302342.4419)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('\B370\C2A4\D06C\D1B1')
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>1
,p_home_url=>'f?p=4411:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4419
,p_user_interface_id=>wwv_flow_api.id(4968506573302342.4419)
,p_name=>unistr('\BA54\C2DC\C9C0')
,p_step_title=>unistr('\BA54\C2DC\C9C0')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(91626406749381989.4419)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
