prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4478
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4478 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4478
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116102680965403673')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'ko'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4478)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113351'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4478)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4478)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4478)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4478)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4478)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4478)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4478)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4478)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4478)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4478)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4478)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4478)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4478)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.ko'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4478
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4478)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4478)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4478)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4478)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4478)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4478)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4478)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.ko'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4478
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4478)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4478)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4478)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4478)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4478)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4478)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4478)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.ko'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4478
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4478)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4478)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4478)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4478)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4478)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4478)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4478)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4478)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4478)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4478)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4478)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4478)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4478)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4478)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4478)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4478)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4478)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.ko'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4478
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4478)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4478)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4478)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4478)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4478)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4478)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4478)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4478)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4478)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4478)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4478)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4478)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4478)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4478)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4478)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.ko'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4478
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4478)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4478)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4478)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4478)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4478)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4478)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4478)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4478)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4478)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4478)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4478)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4478)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4478)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4478)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4478)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.ko'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4478
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4478)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4478)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4478)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4478)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4478)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4478)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4478)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4478)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4478)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4478)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4478)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4478)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4478)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4478)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4478)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.ko'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4478
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4478)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4478)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4478)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4478)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4478)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4478)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4478)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4478)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4478)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4478)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4478)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4478)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4478)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4478)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4478)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4478
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4478)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4478
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4478)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4478
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4478)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4478
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4478)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4478
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4478)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4478
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4478)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4478
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4478)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4478)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4478)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4478)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4478)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4478)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4478)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4478)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4478)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4478)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4478)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4478)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4478)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4478)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4478
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4478)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4478)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4478)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4478)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4478)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4478)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4478)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4478)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4478)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4478
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4478)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4478)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4478)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4478)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4478)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4478)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4478)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4478)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4478)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4478)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4478)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4478)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4478)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4478)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4478)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4478)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4478)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4478)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4478)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4478)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4478)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4478)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4478)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4478)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4478)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4478
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4478)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4478)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4478)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4478)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4478)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4478)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4478)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4478)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4478)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4478)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4478
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4478)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4478)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4478)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4478)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4478)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4478
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4478)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4478)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4478)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4478)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4478)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4478)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4478)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4478
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4478)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4478)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4478)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4478)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4478)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4478
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4478)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4478)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4478)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4478)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4478)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4478
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4478)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4478)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4478)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4478)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4478)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4478)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4478)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4478)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4478)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4478
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4478)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4478)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4478)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4478)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4478)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4478)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4478)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4478)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4478)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4478)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4478)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4478)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4478)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4478)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4478
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4478)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4478)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4478)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4478)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4478)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4478
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4478)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4478
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4478)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4478
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4478)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4478
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4478)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4478
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4478)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4478
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4478)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4478)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4478)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4478)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4478)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4478)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4478)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4478)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4478)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4478
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4478)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4478)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4478)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4478)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4478)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4478)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4478)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4478
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4478)
,p_page_name=>'winlov'
,p_page_title=>unistr('\AC80\C0C9 \B300\D654\C0C1\C790')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('\AC80\C0C9')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('\B2EB\AE30')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('\B2E4\C74C &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; \C774\C804')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">\D589 #FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4478
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4478)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4478
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4478)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4478)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4478)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4478)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4478)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4478)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4478)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4478)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4478)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4478)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4478)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4478)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4478)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4478)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4478)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4478)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4478)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4478)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4478)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4478)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4478)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4478)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4478)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4478)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4478)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4478)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4478)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4478)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4478)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4478)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4478)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4478)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4478)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4478)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4478)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4478)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4478)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4478)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4478)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4478)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4478)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4478)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4478)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4478)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4478)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4478)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4478)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4478)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4478)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4478)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4478)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4478)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4478)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4478)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4478)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4478)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4478)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4478)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4478)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4478)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4478)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4478)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4478)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4478)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4478)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4478)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4478)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4478)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4478)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4478)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4478)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4478)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4478)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4478)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4478)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4478)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4478)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4478)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4478)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4478)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4478)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4478)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4478)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4478)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4478)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4478)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4478)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4478)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4478)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4478)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4478)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4478)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4478)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4478)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4478)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4478)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4478)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4478)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4478)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4478)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4478)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4478)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4478)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4478)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4478)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4478)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4478)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4478)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4478)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4478)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4478)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4478)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4478)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4478)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4478)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4478)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4478)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4478)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4478)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4478)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4478)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4478)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4478)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4478)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4478)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4478)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4478)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4478)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4478)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4478)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4478)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4478)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4478)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4478)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4478)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4478)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4478)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4478)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4478)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4478)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4478)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4478)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4478)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4478)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4478)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4478)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4478)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4478)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4478)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4478)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4478)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4478)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4478)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4478)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4478)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4478)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4478)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4478)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4478)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4478)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4478)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4478)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4478)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4478)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4478)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4478)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4478)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4478)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4478)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4478)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4478)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4478)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4478)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4478)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4478)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4478)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4478)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4478)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4478)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4478)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4478)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4478)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4478)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4478)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4478)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4478)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4478)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4478)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4478)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4478)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4478)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4478)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4478)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4478)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4478)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4478)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4478)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4478)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4478)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4478)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4478)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4478)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4478)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4478)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4478)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4478)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4478)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113073656690400654)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113060716962400645)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113060654523400645)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113117987378400687)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C561\C138\C2A4\AC00 \AC70\BD80\B428')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113077687088400657)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \ACC4\C815\C774 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113063246878400647)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C815\C774 \C7A0\ACBC\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113053171925400640)
,p_name=>'AM_PM'
,p_message_language=>'ko'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113187524119400738)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D1A0\AE00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113195609799400744)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'ko'
,p_message_text=>unistr('(\D65C\C131)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113165163744400721)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('Ajax \D638\CD9C\C774 %1\C5D0 \B300\D574 \C11C\BC84 \C624\B958 %0\C744(\B97C) \BC18\D658\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113095926836400670)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BCC4\CE6D "%0"\C744(\B97C) \ACE0\C720 \C560\D50C\B9AC\CF00\C774\C158 ID\B85C \BCC0\D658\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113096098228400670)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4\CE6D\C774 "%0"\C778 \C560\D50C\B9AC\CF00\C774\C158\C774 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113085646258400663)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1816 \C560\D50C\B9AC\CF00\C774\C158 \BCC4\CE6D p_flow_alias_or_id(%0)\B97C \BCC0\D658\D558\B294 \C911 \C608\C0C1\CE58 \C54A\C740 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113178596935400731)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \CCB4\D06C\C12C\C740 \C791\C5C5\C601\C5ED\C5D0 \B3D9\C77C\D55C \C560\D50C\B9AC\CF00\C774\C158\C774 \BC30\CE58\B418\C5C8\B294\C9C0 \C5EC\BD80\B97C \C27D\AC8C \D655\C778\D560 \C218 \C788\B294 \BC29\BC95\C744 \C81C\ACF5\D569\B2C8\B2E4. \C774 \CCB4\D06C\C12C\C744 \BE44\AD50\D558\C5EC \C77C\CE58\D558\B294 \D56D\BAA9\C774 \C788\B294\C9C0 \D655\C778\D560 \C218 \C788\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113071436495400653)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \D568\C218\B97C \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113056868138400642)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \D568\C218\B97C \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113220386991400762)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Cloud ID \AD00\B9AC\C5D0\C11C \BC18\D658\B41C \D14C\B10C\D2B8 \C774\B984 %0\C5D0 %1 \B3C4\BA54\C778\C5D0 \B300\D55C \AD8C\D55C\C774 \BD80\C5EC\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.<br/><a href="&LOGOUT_URL.">\B2E4\C2DC \B85C\ADF8\C778</a>\D558\ACE0 \C778\C99D\B41C \D14C\B10C\D2B8 \C774\B984\C744 \C9C0\C815\D558\AC70\B098 URL\C744 \BCC0\ACBD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113054581139400641)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \ACC4\C815\C5D0 "%1" \C791\C5C5\C601\C5ED\C5D0 \D544\C694\D55C \AC1C\BC1C \AD8C\D55C(DB_DEVELOPER \B610\B294 DB_ADMINISTRATOR)\C774 \C5C6\C2B5\B2C8\B2E4.<br/> \AD8C\D55C\C774 \C81C\ACF5\B41C \D6C4\C5D0 <a href="&LOGOUT_URL.">\B2E4\C2DC \B85C\ADF8\C778</a>\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113053666205400640)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('Oracle Cloud ID \AD00\B9AC\C5D0\C11C \BC18\D658\B41C \D14C\B10C\D2B8 \C774\B984\C5D0 \D604\C7AC \C791\C5C5\C601\C5ED\C5D0 \B300\D574 \AD8C\D55C\C774 \BD80\C5EC\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.<br/><a href="&LOGOUT_URL.">\B2E4\C2DC \B85C\ADF8\C778</a>\D558\ACE0 \C778\C99D\B41C \D14C\B10C\D2B8 \C774\B984\C744 \C9C0\C815\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113054637859400641)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548\C0C1\C758 \C774\C720\B85C \C774 \C791\C5C5\C601\C5ED\C758 \C560\D50C\B9AC\CF00\C774\C158\C744 URL\C758 \B3C4\BA54\C778\C744 \D1B5\D574 \C2E4\D589\D558\B294 \AC83\C740 \D5C8\C6A9\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113071156745400652)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'ko'
,p_message_text=>unistr('DBA\C5D0\AC8C $OH/rdbms/admin/catldap.sql \C2E4\D589\C744 \C694\CCAD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113071074118400652)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'ko'
,p_message_text=>unistr('SYS.DBMS_LDAP \D328\D0A4\C9C0\AC00 \C874\C7AC\D558\C9C0 \C54A\AC70\B098 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113070987694400652)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('LDAP \C0AC\C6A9\C790 \D3B8\C9D1 \D568\C218\B97C \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113071247281400653)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('LDAP \C778\C99D\C744 \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113072029969400653)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'ko'
,p_message_text=>unistr('login_page \D504\B85C\C2DC\C800\C5D0 \B300\D55C p_flow_page \C778\C218\C5D0 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113071695705400653)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'ko'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1\C758 p_session\C774 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113119537006400688)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'ko'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2\C5D0 \B300\D55C \C778\C218 \D615\C2DD\C774 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113071752223400653)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 \D504\B85C\C2DC\C800\C5D0 \B110 \C0AC\C6A9\C790 \C774\B984\C774 \C804\B2EC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113060544096400645)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'ko'
,p_message_text=>unistr('<span id="apex_login_throttle_sec">%0</span>\CD08 \AE30\B2E4\B838\B2E4\AC00 \B2E4\C2DC \C0AC\C778\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113061843616400646)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778 \C2DC\B3C4\AC00 \CC28\B2E8\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113117390250400686)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \C778\C99D\C744 \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113062121187400646)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\C548 \ADF8\B8F9 ID\AC00 \B110\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113071528132400653)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\D6C4 \C778\C99D \D504\B85C\C138\C2A4\B97C \C2E4\D589\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113071352251400653)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C804 \C778\C99D \D504\B85C\C138\C2A4\B97C \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113072528199400653)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\BE44\BC00\BC88\D638 \C7AC\C124\C815 \C694\CCAD\C744 \C2DC\C791\D55C \B3D9\C77C \BE0C\B77C\C6B0\C800\C5D0\C11C URL\C744 \C5EC\C2ED\C2DC\C624. \BE44\BC00\BC88\D638 \C7AC\C124\C815 URL\C744 \B204\B974\ACE0'),
unistr('\B85C\ADF8\C778 \D398\C774\C9C0\B85C \C7AC\C9C0\C815\B420 \ACBD\C6B0 \BE44\BC00\BC88\D638 \C7AC\C124\C815\C744 \B2E4\C2DC \C2DC\C791\D558\ACE0'),
unistr('\BE0C\B77C\C6B0\C800\B97C \C5F4\C5B4 \B450\C2ED\C2DC\C624.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113217837361400760)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638 \C7AC\C124\C815 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113054897597400641)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9AC\C18C\C2A4 \AD00\B9AC\C790 \C18C\BE44\C790 \ADF8\B8F9 %0\C5D0\AC8C %1\C774(\AC00) \BD80\C5EC\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113054982432400641)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\B77D\B41C \AD8C\D55C\C744 \BD80\C5EC\D558\B824\BA74 DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113082911614400661)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \AC10\C2DC \D568\C218\B97C \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113083080953400661)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \D655\C778 \D568\C218\B97C \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113083210288400661)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \AD00\B9AC\C790\C5D0\AC8C Oracle Application Server Single Sign-On \C5D4\C9C4 \AD6C\C131\C744 \C694\CCAD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113092795674400668)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D1A0\D070\C758 \C798\BABB\B41C %0\C774(\AC00) SSO\C5D0 \C758\D574 \BC18\D658\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113071922899400653)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4\B97C \D3B8\C9D1\D558\ACE0 \C560\D50C\B9AC\CF00\C774\C158 \C774\B984\C744 \CD94\AC00\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113092441813400668)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D504\B85C\C2DC\C800\C758 \C798\BABB\B41C \D638\CD9C\C790:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113092625857400668)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('URLC \D1A0\D070\C5D0 \BD80\C801\D569\D55C \C560\D50C\B9AC\CF00\C774\C158 \C138\C158\C774 \C788\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113092212135400668)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'ko'
,p_message_text=>unistr('portal_sso_redirect\C5D0\C11C \C624\B958 \BC1C\C0DD: \C560\D50C\B9AC\CF00\C774\C158 \B4F1\B85D \C815\BCF4 \B204\B77D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113083133803400661)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'ko'
,p_message_text=>unistr('WWSEC_SSO_ENABLER_PRIVATE \D328\D0A4\C9C0\AC00 \C874\C7AC\D558\C9C0 \C54A\AC70\B098 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113071831036400653)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D \CCB4\ACC4\C5D0\C11C \B4F1\B85D\B41C \D611\B825 \C560\D50C\B9AC\CF00\C774\C158 \C774\B984\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113092382705400668)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\CE58 \C124\BA85\C11C\C5D0 \C124\BA85\B41C \B300\B85C \C774 \C560\D50C\B9AC\CF00\C774\C158\C744 \B4F1\B85D\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113083333682400661)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('SSO \C778\C99D\C744 \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113192721718400742)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\B418\C9C0 \C54A\C740 URL: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113082776177400661)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\C744 \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113054789651400641)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \C791\C5C5\C601\C5ED\C774 \BE44\D65C\C131 \C0C1\D0DC\C785\B2C8\B2E4. \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113055191880400641)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'ko'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113061513239400646)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BCF4\C548 \AC80\C0AC\C5D0 \C758\D574 \C561\C138\C2A4\AC00 \AC70\BD80\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113061660768400646)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCF4\C548 \AC80\C0AC\C5D0 \C758\D574 \C561\C138\C2A4\AC00 \AC70\BD80\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113061727418400646)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \BD80\C5EC\B97C \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113125156524400692)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'ko'
,p_message_text=>unistr('%1\C744(\B97C) \C0AC\C6A9\D558\C5EC %0(\C73C)\B85C \AD6C\CD95\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113125224056400692)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'ko'
,p_message_text=>'love'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113183053517400735)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \C124\BA85')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113182815387400734)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113183186809400735)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 ID')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113182756656400734)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113182978215400734)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \C81C\BAA9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113073527865400654)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\C12C \CF58\D150\CE20 \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113073435912400654)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCB4\D06C\C12C \D615\C2DD \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113137416892400701)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B9BD\BCF4\B4DC\C5D0 \BCF5\C0AC\B428.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113137197228400701)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BE0C\B77C\C6B0\C800\B294 \B2E8\CD94 \B610\B294 \BA54\B274\B97C \D1B5\D55C \BCF5\C0AC\B97C \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4. Ctrl+C \B610\B294 Command+C\B97C \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113125610695400693)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C9C0 \B2EB\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113181667299400734)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\BE44')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113176149907400729)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113176095894400729)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113180275173400733)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740(\B294) \C801\D569\D55C \C0C9\C0C1\C774\C5B4\C57C \D569\B2C8\B2E4. \C608: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113175907844400729)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113176299445400729)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1 \D615\C2DD \BCC0\ACBD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113215414852400758)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113215599521400758)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \BAA9\B85D \C5F4\AE30: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113195761499400744)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'ko'
,p_message_text=>unistr('(\C644\B8CC\B428)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113088099807400665)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113102449757400675)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\C5D0\AC8C \C5F0\B77D\D558\C2ED\C2DC\C624.'),
unistr('\C774 \C7A5\C560\C5D0 \B300\D55C \C138\BD80\C815\BCF4\B294 \B514\BC84\ADF8 ID "%0"\C744(\B97C) \D1B5\D574 \C81C\ACF5\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113180560832400733)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\D558\AE30 \C804\C5D0 \C624\B958\B97C \C218\C815\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113126551123400693)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C \C77C\CE58\D56D\BAA9\C774 \BC1C\ACAC\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113126456711400693)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\CE58\D56D\BAA9\C744 \CC3E\C744 \C218 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113196281937400744)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C9C4\D589\B960')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113180967083400733)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D56D\BAA9\C5D0 \C9C0\C815\B41C \D30C\C77C\C774 APEX_APPLICATION_TEMP_FILES\C5D0 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113169493211400725)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C5C5\B370\C774\D2B8 \D504\B85C\C138\C2A4\B97C \C2DC\C791\D588\C73C\BBC0\B85C \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C788\B294 \B370\C774\D130\C758 \D604\C7AC \BC84\C804\C774 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113138516559400702)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\B4DC \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113185517809400736)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D589 \CC98\B9AC \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113185316411400736)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C0BD\C785')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113199497895400746)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4: \C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113185460717400736)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113126993325400693)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \B2EC\B825: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113049503895400637)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113049694350400637)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113185742925400736)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL# \AC12\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113185622225400736)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740(\B294) \C801\D569\D55C \B0A0\C9DC\C5EC\C57C \D569\B2C8\B2E4. \C608: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113053298836400640)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740(\B294) %0 - %1 \BC94\C704\C758 \AC12\C774\C5B4\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113053352159400640)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740(\B294) %0 \B610\B294 \ADF8 \C774\D6C4\C5EC\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113053480161400640)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740(\B294) %0 \B610\B294 \ADF8 \C774\C804\C774\C5B4\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113130413303400696)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C774 \C9C0\C815\B41C \CD5C\B300 \B0A0\C9DC %0\BCF4\B2E4 \C774\D6C4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113130836635400696)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C774 \D615\C2DD %0\ACFC(\C640) \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113130326479400696)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C774 \C9C0\C815\B41C \CD5C\C18C \B0A0\C9DC %0\BCF4\B2E4 \C774\C804\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113130555318400696)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C774 %0\BD80\D130 %1\AE4C\C9C0\C758 \C801\D569\D55C \BC94\C704\C5D0 \C18D\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113130725899400696)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C774 %0\ACFC(\C640) %1 \C0AC\C774\C758 \C801\D569\D55C \C5F0\B3C4 \BC94\C704\C5D0 \C18D\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113180899852400733)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113208020992400753)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EB\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113210052589400754)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113180674266400733)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113180764815400733)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113086931500400664)
,p_name=>'APEX.ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113054356911400640)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \CC98\B9AC \CF5C\BC31\C744 \C2E4\D589\D558\B294 \C911 \B2E4\C74C \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113063015097400647)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \D398\C774\C9C0\B97C \C791\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113055030107400641)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\BD80 \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113194816524400743)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\AD00\B9AC\C790\C5D0\AC8C \C5F0\B77D\D558\C2ED\C2DC\C624.'),
unistr('\C774 \C7A5\C560\C5D0 \B300\D55C \C138\BD80\C815\BCF4\B294 \B514\BC84\ADF8 ID "%0"\C744(\B97C) \D1B5\D574 \C81C\ACF5\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113189191649400739)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4\AC00 \C77D\AE30 \C804\C6A9 \C561\C138\C2A4\B85C \C5F4\B838\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113219718945400761)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'ko'
,p_message_text=>unistr('ORA-28353: \C804\C790 \C9C0\AC11 \C5F4\AE30\B97C \C2E4\D328\D588\C2B5\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158 \B370\C774\D130\C5D0 \D604\C7AC \C561\C138\C2A4\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113189233803400739)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8C4\C1A1\D569\B2C8\B2E4. \C774 \D398\C774\C9C0\B97C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113056746211400642)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C220 \C815\BCF4(\AC1C\BC1C\C790\C5D0\AC8C\B9CC \D45C\C2DC\B428)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113152806563400712)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958 \BA54\C2DC\C9C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113166723429400723)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C694\D55C \D615\C2DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113133491964400698)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0 \C774\BBF8 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113133367832400698)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C %0\BA85\C758 \C0AC\C6A9\C790\B97C <strong>%1</strong> \C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0 \CD94\AC00\D560\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113133802383400699)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\BCF5 \C0AC\C6A9\C790\AC00 \C874\C7AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113133573351400698)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C8FC\C18C\C5D0 at \AE30\D638(@)\AC00 \B204\B77D\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113133694877400698)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C8FC\C18C\C5D0 \B9C8\CE68\D45C(.)\AC00 \B204\B77D\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113133711094400699)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984\C774 \B108\BB34 \AE41\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113134019321400699)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C561\C138\C2A4 \C81C\C5B4 \BAA9\B85D\C5D0 \C815\C758\B41C \C0AC\C6A9\C790\B9CC \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113134140840400699)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608\C0C1\CE58 \C54A\C740 \C561\C138\C2A4 \C81C\C5B4 \C124\C815 \AC12: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113133999539400699)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\B41C \BAA8\B4E0 \C0AC\C6A9\C790\AC00 \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113176730524400730)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113176675379400730)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113176967131400730)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0: \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113176831434400730)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0: \C0AC\C6A9\C73C\B85C \C124\C815\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113176585725400730)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113169606720400725)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113126128277400693)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\C6A9\B41C \D544\D130 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113167200840400723)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\C6A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113052162894400639)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300 \CC28\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113179926052400732)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\D0C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113052279835400639)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C774 \CC28\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113178680038400731)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113051923849400639)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C218')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113167741809400723)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6B0\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113167823867400723)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \C9C0\C6B0\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113167936877400723)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C9C0\C6B0\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113185166589400736)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D328\C2EF\C774 \CC38\C870\D558\B294 %1 \C5F4\C744 \C0AC\C6A9\D560 \C218 \C5C6\AC70\B098 \D574\B2F9 \C5F4\C5D0 \B300\D55C \AD8C\D55C\C774 \BD80\C5EC\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113042389490400632)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\D560 \D544\D130 \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113124318328400692)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C \ACB0\ACFC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113124428548400692)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C \C120\D0DD\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113127029061400694)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D544\D130')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113043851476400633)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \BAA9\B85D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113183673066400735)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \D328\C2EF\C5D0 \B300\D55C \ACE0\C720 \AC12 \C81C\D55C(%0)\C774 \CD08\ACFC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113169207603400724)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D328\C2EF\C740 DATE \B610\B294 TIMESTAMP \C5F4\C5D0 \B300\D574 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113167357291400723)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D544\D130\B9C1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113167451453400723)
,p_name=>'APEX.FS.GO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113168831163400724)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\ACFC(\C640) \AC19\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113052964000400639)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D3EC\D568')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113052612688400639)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CD08\ACFC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113052709124400639)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BCF4\B2E4 \D06C\AC70\B098 \AC19\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113052432647400639)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \BBF8\B9CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113052561597400639)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BCF4\B2E4 \C791\AC70\B098 \AC19\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113052893618400639)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'ko'
,p_message_text=>unistr('%0(\C73C)\B85C \C2DC\C791')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113055376170400641)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B370\C774\D130 \C720\D615(%1)\C740 \C785\B825 \D544\B4DC \D328\C2EF\C5D0 \B300\D574 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113045529903400634)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \AC12 \D328\C2EF\C5D0\B294 12.2 \C774\C0C1\C758 \B370\C774\D130\BCA0\C774\C2A4\AC00 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113169097167400724)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D328\C2EF\C5D0 \B300\D574 \C81C\ACF5\B41C \AC80\C0C9 \C5F4\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113042455914400632)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \D544\D130')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113124514547400692)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C704 \C2DC\C791')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113168565968400724)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'ko'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113168623181400724)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C774\C0C1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113168722158400724)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C774\D558')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113124627846400692)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C704 \B05D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113187429550400738)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C704 \D328\C2EF %0\C5D0 \B300\D55C LOV \D56D\BAA9 #%2("%1")\C774(\AC00) \BD80\C801\D569\D569\B2C8\B2E4("|" \AD6C\BD84 \AE30\D638 \B204\B77D).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113168924555400724)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\C774 DATE \B610\B294 TIMESTAMP\C774\BBC0\B85C \BC94\C704 \D328\C2EF %0\C5D0 \B300\D55C \C218\B3D9 \C785\B825\C740 \D604\C7AC \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113168258367400724)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'ko'
,p_message_text=>'-'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113052025463400639)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C81C\AC70')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113121118698400689)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113167660705400723)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113167541530400723)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113168400464400724)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'ko'
,p_message_text=>unistr('- \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113051841110400639)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \D45C\C2DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113168064267400723)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC04\B2E8\D788 \D45C\C2DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113168111203400724)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B354 \BCF4\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113168315481400724)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC4 %0\AC1C \C774\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113126064605400693)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \C81C\C548\C0AC\D56D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113169101905400724)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \D544\B4DC \D328\C2EF %0\C740(\B294) \D604\C7AC NUMBER \C5F4\C5D0 \B300\D574\C11C\B9CC \C9C0\C6D0\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113042244511400632)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \D589 \C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113185293574400736)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B370\C774\D130 \C720\D615(%1)\C740 \D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9\C5D0 \B300\D574 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113177167820400730)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958\B85C \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113134784617400699)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D1\ACC4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113142379628400705)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \CC28\B2E8 \CD95\C18C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113134838562400699)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \CC28\B2E8.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113142250379400705)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \CC28\B2E8 \D655\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113220986555400762)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113142009897400705)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C \D589\C774 \C0AD\C81C\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113212484206400756)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\BCF5 ID')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113131705679400697)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113135090348400699)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \BA38\B9AC\AE00.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113134954823400699)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113131804918400697)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113151867556400711)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \D589 \B85C\B4DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113131551605400697)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113135180118400700)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113131965391400697)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'ko'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113132056319400697)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'ko'
,p_message_text=>'%0-%1/%2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113188061789400738)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C120\D0DD\C0AC\D56D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113131682003400697)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113212263230400756)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113212313582400756)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113220758186400762)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 %0, \C5F4 %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113220863395400762)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113212144824400756)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113135348124400700)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BA38\B9AC\AE00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113130969317400696)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C \C140\C774 \C120\D0DD\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113132179507400697)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C \D589\C774 \C120\D0DD\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113172482273400727)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113142197328400705)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113135220649400700)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113135480961400700)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B984\CC28\C21C\C73C\B85C \C815\B82C\B428 - %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113135586718400700)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\B9BC\CC28\C21C\C73C\B85C \C815\B82C\B428 - %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113131068845400697)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B984\CC28\C21C \C815\B82C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113131354101400697)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B984\CC28\C21C \C815\B82C %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113131187728400697)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\B9BC\CC28\C21C \C815\B82C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113131448639400697)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\B9BC\CC28\C21C \C815\B82C %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113131231836400697)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \C548\D568')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113141981016400704)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D\ACC4 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113068396262400650)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0"\C5D0 \B300\D55C HTTP \C694\CCAD\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113209656368400754)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B9AC\B4DC \C120\D0DD \BAA9\B85D %0 \C5F4 %1 \D589. \D654\C0B4\D45C \D0A4 \C0AC\C6A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113141839084400704)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD \BAA9\B85D %0 \D589. \D654\C0B4\D45C \D0A4 \C0AC\C6A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113220501323400762)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113128648916400695)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113129627279400695)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113129530265400695)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \CD94\AC00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113214034807400757)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D1\ACC4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113199545150400746)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D1\ACC4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113201211568400748)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113157647297400716)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \D14D\C2A4\D2B8 \C5F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113158845217400717)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113159915654400717)
,p_name=>'APEX.IG.AND'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113179371715400732)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\B7B5\C801 \ACE0\C720 \AC1C\C218')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113215024084400758)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \B300\B7B5\C801 \ACE0\C720 \AC1C\C218')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113198105627400745)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113200008928400747)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B984\CC28\C21C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113158919091400717)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113214156915400757)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113179747804400732)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3C9\ADE0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113214700115400758)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \D3C9\ADE0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113197605191400745)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14 \CD95 \C81C\BAA9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113197877883400745)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C218\C810 \C790\B9AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113197748834400745)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \CD95 \C81C\BAA9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113203886912400750)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\ACBD\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113198252796400746)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113154234529400713)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C0AC\C774')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113205023081400751)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113198307124400746)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\BE14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113129887694400696)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113159835106400717)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C18C\BB38\C790 \AD6C\BD84')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113215692620400758)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'ko'
,p_message_text=>unistr('(\B300\C18C\BB38\C790 \AD6C\BD84)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113186504916400737)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD\C0AC\D56D\C774 \C800\C7A5\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113130276442400696)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30 \BCC0\ACBD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113160953438400718)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113157416494400716)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \C9C8\C758\B294 \CC28\D2B8\B2F9 \CD5C\B300 \B370\C774\D130 \D3EC\C778\D2B8 \C218 %0\AC1C\B97C \CD08\ACFC\D569\B2C8\B2E4. \AE30\BCF8 \C9C8\C758\C758 \B808\CF54\B4DC \C218\B97C \C904\C774\B824\BA74 \D544\D130\B97C \C801\C6A9\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113128544204400695)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \BCF4\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113135840831400700)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6B0\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113197109720400745)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\AC00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113204098080400750)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C9\C0C1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113180177688400732)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\B9AC\BCF4\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113159204270400717)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113128764746400695)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113205873092400751)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C6A9\B3C4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113159341783400717)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\D569')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113128977569400695)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113154808134400714)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C744 \D3EC\D568')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113161160584400718)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \CC28\B2E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113135675219400700)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D074\B9BD\BCF4\B4DC\B85C \BCF5\C0AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113135796870400700)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C0AC')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113179197536400732)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C218')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113179276461400732)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \AC1C\C218')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113214908273400758)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \ACE0\C720 \AC1C\C218')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113214879183400758)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \AC1C\C218')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113212524283400756)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0DD\C131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113157834938400716)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113205610710400751)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C720\D615')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113205226718400751)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113186336855400737)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \B0A0\C9DC \AC12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113155559041400714)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113158523367400716)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113158304591400716)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \C720\D615')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113129794764400696)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113206828244400752)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BCF4\ACE0\C11C\B97C \C0AD\C81C\D558\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113162922277400720)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C0AD\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113161786544400719)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C0AD\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113200150624400747)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\B9BC\CC28\C21C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113160658390400718)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113128220615400694)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \BCF4\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113188830225400739)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\D5A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113160337597400718)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113154947062400714)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C744 \D3EC\D568\D558\C9C0 \C54A\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113155105609400714)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C73C\B85C \C2DC\C791\B418\C9C0 \C54A\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113198473974400746)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\B11B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113161358648400719)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113060042847400645)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B9CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113207877133400753)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113072606689400654)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC \D615\C2DD %0\C774(\AC00) \C0AC\C6A9\C73C\B85C \C124\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113200841304400747)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\BCF5 \C9D1\ACC4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113200943040400748)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\BCF5 \C81C\C5B4 \CC28\B2E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113162821151400720)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BCF5\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113161672965400719)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\BCF5 \D589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113129374053400695)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113199976949400747)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \D3B8\C9D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113211438011400755)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900 \D3B8\C9D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113207422017400752)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\C740 \CC38\C870(bcc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113207682507400752)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113207348670400752)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870(cc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113207069890400752)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C\C774 \C804\C1A1\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113207554059400752)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113207272109400752)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C2E0\C790(\BC1B\B294 \C0AC\B78C)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113160088431400718)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113153228083400713)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC19\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113206430931400752)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113160100444400718)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113206361853400752)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113172343351400727)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C774 \C900\BE44\B418\C5C8\C2B5\B2C8\B2E4. \B2E4\C6B4\B85C\B4DC\B97C \C2DC\C791\D558\B294 \C911\C785\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113135946686400700)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC44\C6B0\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113137045289400701)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C73C\B85C \C120\D0DD \CC44\C6B0\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113136930188400701)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD \CC44\C6B0\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113128814514400695)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113159443397400717)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113214466272400757)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113200347961400747)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCAB\BC88\C9F8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113129006224400695)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B798\C2DC\BC31')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113157969462400716)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113204914599400751)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \B9C8\C2A4\D06C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113206746358400752)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'ko'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113206618123400752)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'ko'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113119465070400688)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'ko'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113058729786400644)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'ko'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113162517851400719)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113160281586400718)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \BC0F \C5F0\C0B0\C790')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113198521939400746)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D37C\B110')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113179080332400732)
,p_name=>'APEX.IG.GO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113153890870400713)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\B2E4 \D07C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113153921036400713)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\B2E4 \D06C\AC70\B098 \AC19\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113160527998400718)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B9AC\B4DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113128035572400694)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B9AC\B4DC \BDF0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113201181035400748)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113160726853400718)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113128364445400695)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900 \BCF4\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113205526272400751)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74 \C720\D615')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113204466761400750)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113204698225400750)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA38\B9AC\AE00 \B9DE\CDA4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113214373061400757)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113209817912400754)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0\C11C \B370\C774\D130\B97C \C9C1\C811 \C0BD\C785, \C5C5\B370\C774\D2B8 \BC0F \C0AD\C81C\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\D589 \CD94\AC00 \B2E8\CD94\B97C \B20C\B7EC\C11C \C0C8 \D589\C744 \C0BD\C785\D569\B2C8\B2E4.</p>'),
'',
unistr('<p>\D2B9\C815 \C140\C744 \B450 \BC88 \B20C\B7EC\C11C \AE30\C874 \B370\C774\D130\B97C \D3B8\C9D1\D569\B2C8\B2E4. \B300\ADDC\BAA8 \D3B8\C9D1 \C791\C5C5\C758 \ACBD\C6B0 \D3B8\C9D1\C744 \B20C\B7EC\C11C \D3B8\C9D1 \BAA8\B4DC\B85C \C804\D658\D569\B2C8\B2E4. \D3B8\C9D1 \BAA8\B4DC\C5D0\C11C \C140\C744 \D55C \BC88 \B204\B974\AC70\B098 \D0A4\BCF4\B4DC\B97C \C0AC\C6A9\D558\C5EC \D2B9\C815 \C140\C744 \D3B8\C9D1\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\BCC0\ACBD \BA54\B274\B97C \C0AC\C6A9\D558\C5EC \D589\C744 \BCF5\C81C\D558\AC70\B098 \C0AD\C81C\D569\B2C8\B2E4. \BCC0\ACBD \BA54\B274\B97C \C0AC\C6A9\C73C\B85C \C124\C815\D558\B824\BA74 \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D558\C5EC \D558\B098 \C774\C0C1\C758 \D589\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
'',
unistr('<p>\BCC0\ACBD \BA54\B274\B97C \B204\B974\ACE0 \D589 \BCF5\C81C\B97C \C120\D0DD\D558\C5EC \C120\D0DD\D55C \D589\C744 \BCF5\C81C\D569\B2C8\B2E4. \BCC0\ACBD \BA54\B274\B97C \B204\B974\ACE0 \D589 \C0AD\C81C\B97C \C120\D0DD\D558\C5EC \C120\D0DD\D55C \D589\C744 \C0AD\C81C\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113211969096400756)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113212083804400756)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B300\D654\C2DD \ADF8\B9AC\B4DC\C5D0\B294 \B370\C774\D130 \C138\D2B8\AC00 \AC80\C0C9 \AC00\B2A5\D55C \C0AC\C6A9\C790\C815\C758 \BCF4\ACE0\C11C\B85C \D45C\C2DC\B429\B2C8\B2E4. \BC18\D658\B418\B294 \B808\CF54\B4DC\B97C \C81C\D55C\D558\ACE0 \B370\C774\D130 \D45C\C2DC \BC29\BC95\C744 \BCC0\ACBD\D558\B294 \B2E4\C591\D55C \C791\C5C5\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\AC80\C0C9 \D544\B4DC\B97C \C0AC\C6A9\D558\C5EC \BC18\D658\B418\B294 \B808\CF54\B4DC\B97C \D544\D130\B9C1\D569\B2C8\B2E4. \C791\C5C5\C744 \B20C\B7EC\C11C \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C744 \C218\C815\D560 \C218 \C788\B294 \B2E4\C591\D55C \C635\C158\C5D0 \C561\C138\C2A4\D558\AC70\B098, \D45C\C2DC\B41C \C5F4\C5D0\C11C \C5F4 \BA38\B9AC\AE00 \BA54\B274\B97C \C0AC\C6A9\D569\B2C8\B2E4.</p>'),
'',
unistr('<p>\BCF4\ACE0\C11C \C124\C815\C744 \C0AC\C6A9\D558\C5EC \C0AC\C6A9\C790\C815\C758\B97C \BCF4\ACE0\C11C\C5D0 \C800\C7A5\D569\B2C8\B2E4. \BCF4\ACE0\C11C\C758 \B370\C774\D130\B97C \C678\BD80 \D30C\C77C\B85C \B2E4\C6B4\B85C\B4DC\D558\AC70\B098 \B370\C774\D130\B97C \B098 \C790\C2E0\C774\B098 \B2E4\B978 \C0AC\C6A9\C790\C5D0\AC8C \C804\C790\BA54\C77C\B85C \BCF4\B0BC \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\C790\C138\D55C \B0B4\C6A9\C740 <em>Oracle Application Express End User''s Guide</em>\C758 "Using Interactive Grids"\B97C \CC38\C870\D558\C2ED\C2DC\C624.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113211761067400756)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113209729806400754)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B0B4\C7A5 \AE30\B2A5\C744 \C0AC\C6A9\D558\C5EC \B370\C774\D130\B97C \B2E4\C591\D55C \BC29\C2DD\C73C\B85C \D45C\C2DC\D558\B3C4\B85D \B300\D654\C2DD \ADF8\B9AC\B4DC\B97C \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\C5F4 \BA38\B9AC\AE00 \BA54\B274 \B610\B294 \C791\C5C5 \BA54\B274\B97C \C0AC\C6A9\D558\C5EC \D45C\C2DC\D560 \C5F4 \BC0F \C21C\C11C\B97C \ACB0\C815\D558\ACE0 \C5F4\C744 \ACE0\C815\D569\B2C8\B2E4. \B2E4\C591\D55C \B370\C774\D130 \D544\D130\B97C \C815\C758\D558\ACE0 \BC18\D658\B418\B294 \B370\C774\D130\B97C \C815\B82C\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\AC80\C0C9 \D544\B4DC \C606\C5D0 \C788\B294 \BCF4\AE30 \B2E8\CD94\B97C \C0AC\C6A9\D558\C5EC \C560\D50C\B9AC\CF00\C774\C158 \AC1C\BC1C\C790\AC00 \C815\C758\D55C \B2E4\B978 \B370\C774\D130 \BCF4\AE30\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4. \CC28\D2B8\B97C \C0DD\C131\D558\AC70\B098 \AE30\C874 \CC28\D2B8\B97C \C870\D68C\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>  '),
'',
unistr('<p><em>\CC38\ACE0: \B300\D654\C2DD \ADF8\B9AC\B4DC \B300\D654\C0C1\C790\C5D0\C11C <strong>\B3C4\C6C0\B9D0</strong>\C744 \B20C\B7EC\C11C \C120\D0DD\D55C \D568\C218\C5D0 \B300\D55C \C138\BD80\C815\BCF4\B97C \D655\C778\D560 \C218 \C788\C2B5\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113211839085400756)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\B2A5 \BCF4\ACE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113161537349400719)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC \B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113208659021400753)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C0C1\C790\B97C \C0AC\C6A9\D558\C5EC \C5F4\C744 \C9D1\ACC4\D569\B2C8\B2E4. \C9D1\ACC4\B41C \AC12\C740 \B370\C774\D130 \D558\B2E8 \B610\B294 \AC01 \AD6C\BD84\C120 \D558\B2E8(\C81C\C5B4 \CC28\B2E8\C774 \C815\C758\B418\C5B4 \C788\B294 \ACBD\C6B0)\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C9D1\ACC4 \BAA9\B85D</strong><br>'),
unistr('\C9D1\ACC4 \BAA9\B85D\C5D0\B294 \C815\C758\B41C \C9D1\ACC4\AC00 \D45C\C2DC\B429\B2C8\B2E4. \C9D1\ACC4\B97C \C120\D0DD \D574\C81C\D558\C5EC \AE30\C874 \C9D1\ACC4\B97C \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4.<br>'),
unistr('\C0C8 \C9D1\ACC4\B97C \C0DD\C131\D558\B824\BA74 \CD94\AC00( &plus; )\B97C \B204\B974\ACE0 \AE30\C874 \C9D1\ACC4\B97C \C81C\AC70\D558\B824\BA74 \C0AD\C81C( &minus; )\B97C \B204\B985\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C9D1\ACC4 \C124\C815</strong><br>'),
unistr('\C624\B978\CABD\C5D0 \C788\B294 \D3FC\C744 \C0AC\C6A9\D558\C5EC \C9D1\ACC4\B97C \C815\C758\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \C774\B984\ACFC \C9D1\ACC4 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('\C9D1\ACC4\C5D0 \B300\D55C \B3C4\AD6C \C124\BA85\C744 \C785\B825\D569\B2C8\B2E4(\C120\D0DD\C0AC\D56D).<br>'),
unistr('\C81C\C5B4 \CC28\B2E8\C744 \C815\C758\D55C \ACBD\C6B0 <strong>\C804\CCB4 \AC12 \D45C\C2DC</strong>\B97C \C120\D0DD\D558\BA74 \B370\C774\D130 \D558\B2E8\C5D0 \C804\CCB4 \D3C9\ADE0, \CD1D\ACC4 \B610\B294 \C774\C640 \C720\C0AC\D55C \AC12\C774 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
'',
unistr('<p><em>\CC38\ACE0: \C5F4 \BA38\B9AC\AE00 \BC0F \D569\ACC4( &sum; )\B97C \B204\B974\AC70\B098 \C791\C5C5 \BA54\B274\C5D0\C11C \C9D1\ACC4 \B300\D654\C0C1\C790\C5D0 \C561\C138\C2A4\D569\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113210831839400755)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D1\ACC4 \B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113209383053400754)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C0C1\C790\B97C \C0AC\C6A9\D558\C5EC \BCC4\B3C4\C758 \B370\C774\D130 \BCF4\AE30\B85C \D45C\C2DC\B418\B294 \CC28\D2B8\B97C \C815\C758\D569\B2C8\B2E4.<br>'),
unistr('\CC28\D2B8 \C720\D615\ACFC \CC28\D2B8 \C18D\C131\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
unistr('<p><strong>\CC28\D2B8 \C18D\C131</strong></br>'),
unistr('\C0AC\C6A9 \AC00\B2A5\D55C \CC28\D2B8 \C18D\C131\C740 \CC28\D2B8 \C720\D615\C5D0 \B530\B77C \B2E4\B985\B2C8\B2E4.</p>'),
'<p>',
'<ul>',
unistr('  <li>\C18D\C131 \AC12\C744 \D3EC\D568\D558\B294 \C5F4\C744 \C120\D0DD\D569\B2C8\B2E4.'),
'    <ul>',
unistr('      <li>\B808\C774\BE14 - \AC01 \B370\C774\D130 \D3EC\C778\D2B8\C5D0 \B300\D55C \D14D\C2A4\D2B8.</li>'),
unistr('      <li>\AC12 - \AD6C\D68D\D560 \B370\C774\D130.</li>'),
unistr('      <li>\ACC4\C5F4 - \B2E4\C911 \ACC4\C5F4 \B3D9\C801 \C9C8\C758\B97C \C815\C758\D560 \BAA9\C801.</li>'),
unistr('      <li>\C2DC\AC00 - \C77C\BCC4 \C8FC\C2DD \AC1C\C7A5 \AC00\ACA9(\C8FC\C2DD \C804\C6A9).</li>'),
unistr('      <li>\C885\AC00 - \C77C\BCC4 \C8FC\C2DD \B9C8\AC10 \AC00\ACA9(\C8FC\C2DD \C804\C6A9).</li>'),
unistr('      <li>\ACE0\AC00 - \C0C1\C704 \AC12(\BC94\C704 \BC0F \C8FC\C2DD \C804\C6A9).</li>'),
unistr('      <li>\C800\AC00 - \D558\C704 \AC12(\BC94\C704 \BC0F \C8FC\C2DD \C804\C6A9).</li>'),
unistr('      <li>\AC70\B798\B7C9 - \C77C\BCC4 \C8FC\C2DD \AC70\B798\B7C9(\C8FC\C2DD \C804\C6A9).</li>'),
unistr('      <li>\BAA9\D45C - \BAA9\D45C \AC12(\D37C\B110 \C804\C6A9).</li>'),
unistr('      <li>X - x\CD95 \AC12(\BC84\BE14 \BC0F \C0B0\D3EC \C804\C6A9).</li>'),
unistr('      <li>Y - y\CD95 \AC12(\BC84\BE14 \BC0F \C0B0\D3EC \C804\C6A9).</li>'),
unistr('      <li>Z - \B9C9\B300 \B108\BE44 \B610\B294 \BC84\BE14 \BC18\C9C0\B984(\B9C9\B300, \BC84\BE14 \BC0F \BC94\C704 \C804\C6A9).</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\BC29\D5A5 - \C138\B85C \B610\B294 \AC00\B85C.</li>'),
unistr('  <li>\C9D1\ACC4 - \CC28\D2B8 \AC12\C744 \C9D1\ACC4\D558\B294 \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('  <li>\C2A4\D0DD - \B370\C774\D130 \D56D\BAA9\C774 \B204\C801\B418\B294\C9C0 \C5EC\BD80\B97C \C9C0\C815\D569\B2C8\B2E4.</li>'),
unistr('  <li>\C815\B82C \AE30\C900 - \B808\C774\BE14 \B610\B294 \AC12\C744 \AE30\C900\C73C\B85C \C815\B82C\D569\B2C8\B2E4.'),
'    <ul>',
unistr('      <li>\BC29\D5A5 - \C624\B984\CC28\C21C \B610\B294 \B0B4\B9BC\CC28\C21C\C73C\B85C \AC12\C744 \C815\B82C\D569\B2C8\B2E4.</li>'),
unistr('      <li>\B110 - \B110\C774 \C544\B2CC \AC12\C744 \AC00\C9C4 \B808\CF54\B4DC\B97C \AE30\C900\C73C\B85C \B110 \AC12\C744 \AC00\C9C4 \B808\CF54\B4DC\B97C \C815\B82C\D560 \BC29\BC95\C744 \C9C0\C815\D569\B2C8\B2E4.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\C18C\C218\C810 \C790\B9AC</li>'),
unistr('  <li>\B808\C774\BE14 \CD95 \C81C\BAA9</li>'),
unistr('  <li>\AC12 \CD95 \C81C\BAA9</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113211230667400755)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113208323738400753)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C0C1\C790\B97C \C0AC\C6A9\D558\C5EC \D45C\C2DC\B418\B294 \C5F4 \BC0F \C21C\C11C\B97C \C120\D0DD\D569\B2C8\B2E4.</p>'),
'',
unistr('<p>\C5F4\C744 \C120\D0DD \D574\C81C\D558\C5EC \C228\AE41\B2C8\B2E4.<br>'),
unistr('\C704\B85C \C774\B3D9( &uarr; ) \B610\B294 \C544\B798\B85C \C774\B3D9( &darr; )\C744 \B20C\B7EC\C11C \C5F4\C744 \C7AC\C815\B82C\D569\B2C8\B2E4.<br>'),
unistr('\B4DC\B86D\B2E4\C6B4 \C120\D0DD\AE30\B97C \C0AC\C6A9\D558\C5EC \BAA8\B4E0 \C5F4, \D45C\C2DC\B41C \C5F4 \B610\B294 \D45C\C2DC\B418\C9C0 \C54A\C740 \C5F4\C744 \B098\C5F4\D569\B2C8\B2E4.</p>'),
'',
unistr('<p>\D3FC\C744 \C0AC\C6A9\D558\C5EC \C5F4\C758 \CD5C\C18C \B108\BE44(\D53D\C140)\B97C \C9C0\C815\D569\B2C8\B2E4(\C120\D0DD\C0AC\D56D).</p>'),
'',
unistr('<p><em>\CC38\ACE0: \C5F4 \BA38\B9AC\AE00\C758 \B9E8 \C55E\C5D0 \C788\B294 \B04C\AE30 \D578\B4E4\C744 \B204\B974\ACE0 \C5F4\C744 \C67C\CABD \B610\B294 \C624\B978\CABD\C73C\B85C \B04C\C5B4\C11C \D45C\C2DC\B41C \C5F4\C744 \C7AC\C815\B82C\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4. \BA38\B9AC\AE00 \C0AC\C774\C758 \C5F4 \AD6C\BD84 \AE30\D638\B97C \C120\D0DD\D558\ACE0 \C67C\CABD \B610\B294 \C624\B978\CABD\C73C\B85C \C774\B3D9\D558\C5EC \D45C\C2DC\B41C \C5F4\C758 \B108\BE44\B97C \BCC0\ACBD\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113211161752400755)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113208765625400753)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C0C1\C790\B97C \C0AC\C6A9\D558\C5EC \AE30\C874 \C5F4\C5D0 \B300\D574 \C218\D589\B41C \C218\D559 \BC0F \D568\C218 \ACC4\C0B0\C744 \AE30\C900\C73C\B85C \CD94\AC00 \C5F4\C744 \C815\C758\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\ACC4\C0B0 \BAA9\B85D</strong><br>'),
unistr('\ACC4\C0B0 \BAA9\B85D\C5D0\B294 \C815\C758\B41C \ACC4\C0B0\C774 \D45C\C2DC\B429\B2C8\B2E4. \ACC4\C0B0\C744 \C120\D0DD \D574\C81C\D558\C5EC \AE30\C874 \ACC4\C0B0\C744 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4.<br>'),
unistr('\C0C8 \ACC4\C0B0\C744 \CD94\AC00\D558\B824\BA74 \CD94\AC00( &plus; )\B97C \B204\B974\ACE0, \AE30\C874 \ACC4\C0B0\C744 \C81C\AC70\D558\B824\BA74 \C0AD\C81C( &minus; )\B97C \B204\B985\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\ACC4\C0B0 \C124\C815</strong><br>'),
unistr('\D3FC\C744 \C0AC\C6A9\D558\C5EC \ACC4\C0B0\C744 \C815\C758\D569\B2C8\B2E4.<br>'),
unistr('\C5F4 \C138\BD80\C815\BCF4(\C608: \BA38\B9AC\AE00, \B808\C774\BE14)\B97C \C785\B825\D558\ACE0 \C815\B82C \C124\C815\C744 \C120\D0DD\D569\B2C8\B2E4.<br> '),
unistr('\D45C\D604\C2DD \D14D\C2A4\D2B8 \C601\C5ED\C744 \C0AC\C6A9\D558\C5EC \ACC4\C0B0\C744 \C704\D55C \C5F4 \BC0F \C5F0\ACB0\B41C \D568\C218\B97C \C785\B825\D569\B2C8\B2E4.<br>'),
unistr('\C0C8 \C5F4\C5D0 \B300\D574 \C801\D569\D55C \B370\C774\D130 \C720\D615 \BC0F \D615\C2DD \B9C8\C2A4\D06C(\C120\D0DD\C0AC\D56D)\B97C \C120\D0DD\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113210763459400755)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113209066803400754)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C0C1\C790\B97C \C0AC\C6A9\D558\C5EC \D558\B098 \C774\C0C1\C758 \C5F4\C5D0 \B300\D55C \C81C\C5B4 \CC28\B2E8\C744 \C815\C758\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C81C\C5B4 \CC28\B2E8 \BAA9\B85D</strong><br>'),
unistr('\C81C\C5B4 \CC28\B2E8 \BAA9\B85D\C5D0\B294 \C815\C758\B41C \C81C\C5B4 \CC28\B2E8\C774 \D45C\C2DC\B429\B2C8\B2E4. \C81C\C5B4 \CC28\B2E8 \C5F4\C744 \C120\D0DD \D574\C81C\D558\C5EC \AE30\C874 \C81C\C5B4 \CC28\B2E8 \C5F4\C744 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4.<br>'),
unistr('\C81C\C5B4 \CC28\B2E8\C5D0 \C0C8 \C5F4\C744 \D3EC\D568\D558\B824\BA74 \CD94\AC00( &plus; )\B97C \B204\B974\ACE0, \C81C\C5B4 \CC28\B2E8\C5D0\C11C \AE30\C874 \C5F4\C744 \C81C\AC70\D558\B824\BA74 \C0AD\C81C( &minus; )\B97C \B204\B985\B2C8\B2E4.<br>'),
unistr('\C5F4\C744 \C7AC\C815\B82C\D558\B824\BA74 \C704\B85C \C774\B3D9( &uarr; ) \B610\B294 \C544\B798\B85C \C774\B3D9( &darr; )\C744 \B20C\B7EC\C11C \B2E4\B978 \C5F4\C744 \AE30\C900\C73C\B85C \C120\D0DD\B41C \C5F4\C744 \C704 \B610\B294 \C544\B798\B85C \C774\B3D9\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\C81C\C5B4 \CC28\B2E8 \C124\C815</strong><br>'),
unistr('\D3FC\C744 \C0AC\C6A9\D558\C5EC \C81C\C5B4 \CC28\B2E8 \C5F4\C744 \C815\C758\D569\B2C8\B2E4.<br>'),
unistr('\C81C\C5B4 \CC28\B2E8 \C5F4, \C815\B82C \BC29\D5A5 \BC0F \B110 \C5F4(\AC12\C774 \C5C6\B294 \C5F4) \C815\B82C \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><em>\CC38\ACE0: \B300\D654\C2DD \ADF8\B9AC\B4DC\B97C \C870\D68C\D560 \B54C \C5F4 \BA38\B9AC\AE00\C744 \B204\B974\ACE0 \C81C\C5B4 \CC28\B2E8 \C544\C774\CF58\C744 \C120\D0DD\D558\C5EC \C81C\C5B4 \CC28\B2E8\C744 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113210499599400755)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \CC28\B2E8 \B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113209204775400754)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C0C1\C790\B97C \C0AC\C6A9\D558\C5EC \BAA8\B4E0 \D604\C7AC \D589\C744 \C678\BD80 \D30C\C77C\B85C \B2E4\C6B4\B85C\B4DC\D569\B2C8\B2E4. \B370\C774\D130\C5D0 \C801\C6A9\B41C \D544\D130\C640 \C815\B82C\C744 \C0AC\C6A9\D558\C5EC \D30C\C77C\C5D0\B294 \D604\C7AC \D45C\C2DC\B41C \C5F4\B9CC \D3EC\D568\B429\B2C8\B2E4.</p>'),
'',
unistr('<p>\D30C\C77C \D615\C2DD\C744 \C120\D0DD\D558\ACE0 \B2E4\C6B4\B85C\B4DC\B97C \B204\B985\B2C8\B2E4.<br>'),
unistr('\CC38\ACE0: CSV\C5D0\B294 \D14D\C2A4\D2B8 \D615\C2DD(\C608: \C9D1\ACC4 \BC0F \C81C\C5B4 \CC28\B2E8)\C740 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
'',
unistr('<p>\D30C\C77C\C744 \C804\C790\BA54\C77C\B85C \BCF4\B0B4\B824\BA74 \C804\C790\BA54\C77C\B85C \C804\C1A1\C744 \C120\D0DD\D558\ACE0 \C804\C790\BA54\C77C \C138\BD80\C815\BCF4(\C218\C2E0\C790, \C81C\BAA9, \BA54\C2DC\C9C0)\B97C \C785\B825\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113210299390400754)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC \B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113208477231400753)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C0C1\C790\B97C \C0AC\C6A9\D558\C5EC \BC18\D658\B418\B294 \D589\C744 \C81C\D55C\D558\B294 \B370\C774\D130 \D544\D130\B97C \AD6C\C131\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\D544\D130 \BAA9\B85D</strong><br>'),
unistr('\D544\D130 \BAA9\B85D\C740 \C815\C758\B41C \D544\D130\B97C \D45C\C2DC\D569\B2C8\B2E4. \D544\D130\B97C \C120\D0DD \D574\C81C\D558\C5EC \AE30\C874 \D544\D130\B97C \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4.<br>'),
unistr('\C0C8 \D544\D130\B97C \C0DD\C131\D558\B824\BA74 \CD94\AC00( &plus; )\B97C \B204\B974\ACE0, \AE30\C874 \D544\D130\B97C \C81C\AC70\D558\B824\BA74 \C0AD\C81C( &minus; )\B97C \B204\B985\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\D544\D130 \C124\C815</strong><br>'),
unistr('\D3FC\C744 \C0AC\C6A9\D558\C5EC \D544\D130 \C18D\C131\C744 \C815\C758\D569\B2C8\B2E4.<br>'),
unistr('\C801\D569\D55C \D544\D130 \C720\D615\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('&nbsp;&nbsp;&nbsp;\D589 - \D544\D130\B9C1 \AC00\B2A5\D55C \C5F4\C758 \C6A9\C5B4\C5D0 \B300\D574 \D544\D130\B9C1\D569\B2C8\B2E4.<br>'),
unistr('&nbsp;&nbsp;&nbsp;\C5F4 - \C9C0\C815\B41C \C5F0\C0B0\C790\C640 \AC12\C744 \C0AC\C6A9\D558\C5EC \D2B9\C815 \C5F4\C744 \D544\D130\B9C1\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><em>\CC38\ACE0: \B300\D654\C2DD \ADF8\B9AC\B4DC\B97C \C870\D68C\D560 \B54C \AC80\C0C9 \D544\B4DC\C5D0 \C9C1\C811 \C785\B825\D558\C5EC \D589 \D544\D130\B97C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4. [\AC80\C0C9\D560 \C5F4 \C120\D0DD]\C744 \B20C\B7EC\C11C \AC80\C0C9\C744 \D2B9\C815 \C5F4\B85C \C81C\D55C\D560 \C218 \C788\C2B5\B2C8\B2E4. \B610\B294 \C5F4 \BA38\B9AC\AE00 \BA54\B274\B97C \C5F4\ACE0 \C5F4 \D544\D130\B97C \C0DD\C131\D560 \AC12\C744 \C120\D0DD\D569\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113211070701400755)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113208853959400753)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C0C1\C790\B97C \C0AC\C6A9\D558\C5EC \B370\C774\D130\B97C \C774\C804 \C2DC\C810\C5D0 \C874\C7AC\D55C \ADF8\B300\B85C \BCFC \C218 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C774\C804 \C2DC\AC04(\BD84)\C744 \C785\B825\D558\C5EC \D50C\B798\C2DC\BC31 \C9C8\C758\B97C \C2E4\D589\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113210664980400755)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B798\C2DC\BC31 \B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113211303374400755)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900 \B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113208971340400753)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C0C1\C790\B97C \C0AC\C6A9\D558\C5EC \C785\B825\B41C \C870\AC74\C744 \AE30\C900\C73C\B85C \B370\C774\D130 \D589 \B610\B294 \C5F4\C744 \AC15\C870 \D45C\C2DC\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\AC15\C870 \D45C\C2DC \BAA9\B85D</strong><br>'),
unistr('\AC15\C870 \D45C\C2DC \BAA9\B85D\C5D0\B294 \C815\C758\B41C \AC15\C870 \D45C\C2DC\AC00 \D45C\C2DC\B429\B2C8\B2E4. \AC15\C870 \D45C\C2DC\B97C \C120\D0DD \D574\C81C\D558\C5EC \AE30\C874 \AC15\C870 \D45C\C2DC\B97C \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4.<br>'),
unistr('\C0C8 \AC15\C870 \D45C\C2DC\B97C \C0DD\C131\D558\B824\BA74 \CD94\AC00( &plus; )\B97C \B204\B974\ACE0 \AE30\C874 \AC15\C870 \D45C\C2DC\B97C \C81C\AC70\D558\B824\BA74 \C0AD\C81C( &minus; )\B97C \B204\B985\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\AC15\C870 \D45C\C2DC \C124\C815</strong><br>'),
unistr('\D3FC\C744 \C0AC\C6A9\D558\C5EC \AC15\C870 \D45C\C2DC \C18D\C131\C744 \C815\C758\D569\B2C8\B2E4.<br>'),
unistr('\C774\B984\C744 \C785\B825\D558\ACE0, \D589 \B610\B294 \C5F4\C744 \C120\D0DD\D558\ACE0, \BC30\ACBD \BC0F \D14D\C2A4\D2B8\C5D0 \B300\D55C HTML \C0C9\C0C1 \CF54\B4DC\B97C \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('\D2B9\C815 \B370\C774\D130\B97C \AC15\C870 \D45C\C2DC\D558\B294 \B370 \C801\D569\D55C <strong>\C870\AC74 \C720\D615</strong>\C744 \C120\D0DD\D569\B2C8\B2E4.<br>'),
unistr('&nbsp;&nbsp;&nbsp;\D589 - \C5F4\C5D0\C11C \C6A9\C5B4\B97C \AC15\C870 \D45C\C2DC\D569\B2C8\B2E4.<br>'),
unistr('&nbsp;&nbsp;&nbsp;\C5F4 - \C9C0\C815\B41C \C5F0\C0B0\C790 \BC0F \AC12\C744 \AE30\C900\C73C\B85C \D2B9\C815 \C5F4\C758 \B0B4\BD80\B97C \AC15\C870 \D45C\C2DC\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113210530222400755)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC \B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113209197734400754)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C0C1\C790\B97C \C0AC\C6A9\D558\C5EC \D604\C7AC \ADF8\B9AC\B4DC \B808\C774\C544\C6C3 \BC0F \AD6C\C131\C5D0 \B300\D55C \BCC0\ACBD\C0AC\D56D\C744 \C800\C7A5\D569\B2C8\B2E4.<br>'),
unistr('\C560\D50C\B9AC\CF00\C774\C158 \AC1C\BC1C\C790\B294 \C5EC\B7EC \B300\CCB4 \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C744 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4. \D5C8\C6A9\B418\B294 \ACBD\C6B0 \C0AC\C6A9\C790\C640 \B2E4\B978 \C77C\BC18 \C0AC\C6A9\C790\AC00 \BCF4\ACE0\C11C\B97C \ACF5\C6A9\C73C\B85C \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4. \ADF8\B7EC\BA74 \BAA8\B4E0 \ADF8\B9AC\B4DC \C0AC\C6A9\C790\AC00 \BCF4\ACE0\C11C\B97C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \BCF4\ACE0\C11C\B97C \BCF8\C778\B9CC \BCFC \C218 \C788\B3C4\B85D \C804\C6A9 \BCF4\ACE0\C11C\B85C \C800\C7A5\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\C0AC\C6A9 \AC00\B2A5\D55C \C720\D615\C744 \C120\D0DD\D558\ACE0 \C800\C7A5\B41C \BCF4\ACE0\C11C\C5D0 \B300\D55C \C774\B984\C744 \C785\B825\D569\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113210307431400755)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\BCF4\ACE0\C11C \B3C4\C6C0\B9D0'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113208501851400753)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774 \B300\D654\C0C1\C790\B97C \C0AC\C6A9\D558\C5EC \D45C\C2DC \C21C\C11C\B97C \C124\C815\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><strong>\BAA9\B85D \C815\B82C</strong><br>'),
unistr('\C815\B82C \B300\D654\C0C1\C790\C5D0\B294 \AD6C\C131\B41C \C815\B82C \ADDC\CE59 \BAA9\B85D\C774 \D45C\C2DC\B429\B2C8\B2E4.<br>'),
unistr('\C815\B82C \C5F4\C744 \C0DD\C131\D558\B824\BA74 \CD94\AC00( &plus; )\B97C \B204\B974\ACE0 \C815\B82C \C5F4\C744 \C81C\AC70\D558\B824\BA74 \C0AD\C81C( &minus; )\B97C \B204\B985\B2C8\B2E4.<br>'),
unistr('\C704\B85C \C774\B3D9( &uarr; ) \BC0F \C544\B798\B85C \C774\B3D9( &darr; )\C744 \B20C\B7EC\C11C \B2E4\B978 \C815\B82C \C5F4\C744 \AE30\C900\C73C\B85C \C120\D0DD\D55C \C5F4\C744 \C704 \B610\B294 \C544\B798\B85C \C774\B3D9\D569\B2C8\B2E4s.</p>'),
'',
unistr('<p><strong>\C815\B82C \C124\C815</strong><br>'),
unistr('\C815\B82C \C5F4, \C815\B82C \BC29\D5A5 \BC0F \B110 \C5F4(\AC12\C774 \C5C6\B294 \C5F4) \C815\B82C \BC29\BC95\C744 \C120\D0DD\D569\B2C8\B2E4.</p>'),
'',
unistr('<p><em>\CC38\ACE0: \D45C\C2DC\B418\C9C0 \C54A\C740 \C5F4\C744 \AE30\C900\C73C\B85C \B370\C774\D130\B97C \C815\B82C\D560 \C218 \C788\C9C0\B9CC, \C774 \ACBD\C6B0 \C77C\BD80 \C5F4\C774 \C815\B82C\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4.</em><br>'),
unistr('<em>\C5F4 \BA38\B9AC\AE00\C758 \B9E8 \B05D\C5D0 \C788\B294 \C704\CABD(\C624\B984\CC28\C21C) \B610\B294 \C544\B798\CABD(\B0B4\B9BC\CC28\C21C) \D654\C0B4\D45C\B97C \B20C\B7EC\C11C \D45C\C2DC\B41C \C5F4\C744 \C815\B82C\D560 \C218 \C788\C2B5\B2C8\B2E4. \AE30\C874 \C815\B82C\C5D0 \D6C4\C18D \C5F4\C744 \CD94\AC00\D558\B824\BA74 Shift \D0A4\B97C \B204\B974\ACE0 \C704\CABD \B610\B294 \C544\B798\CABD \D654\C0B4\D45C\B97C \B204\B985\B2C8\B2E4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113210997838400755)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113210183878400754)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\C6A9 \B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113162430350400719)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE30\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113129266895400695)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113197227865400745)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AC00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113198055128400745)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\B85C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113155438789400714)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113160442188400718)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113128139266400694)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \BCF4\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113153673361400713)
,p_name=>'APEX.IG.IN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C5D0 \C18D\D568')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113162036836400719)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\D65C\C131 \C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113162190785400719)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\D65C\C131 \C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113169714659400725)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC \C694\CCAD\C744 \CC98\B9AC\D558\B294 \C911 \B0B4\BD80 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113065565616400648)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C5F4\C5D0 \B300\D574\C11C\B294 \C5F4 \D544\D130 \C720\D615 "%0"\C774(\AC00) \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113209936632400754)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \B0A0\C9DC \D615\C2DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113184182753400735)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC\B294 %0 \C5F4\C5D0 \B300\D55C \D544\D130 \C815\C758\B97C \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113184053956400735)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \B300\D654\C2DD \ADF8\B9AC\B4DC \D544\D130 \C815\C758\C5D0 \C801\D569\D55C \D544\D130 \C720\D615\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113070646009400652)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C22B\C790 \D615\C2DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113212641982400756)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113212734945400756)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113203779989400750)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \AE30\C900\C774 %0(\C73C)\B85C \C124\C815\B418\C5B4 \C788\C9C0\B9CC %0\C5D0 \B300\D574 \C120\D0DD\B41C \C5F4\C774 \C5C6\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113201053735400748)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \AC12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113196188310400744)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\B418\C9C0 \C54A\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113154493268400713)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC \AE30\AC04\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113154668697400714)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C5D0\C11C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113153570939400713)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C5B4 \C788\C9C0 \C54A\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113153405246400713)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C5B4 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113204544220400750)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113196547299400744)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113200498334400747)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C9C0\B9C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113143716477400706)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC 1\C77C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113143978255400706)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C \C2DC\AC04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113144422666400706)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC 1\BD84')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113143458668400706)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C \B2EC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113143528009400706)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C \C8FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113143656534400706)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C %0\C77C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113143890733400706)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C %0\C2DC\AC04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113144532360400706)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC %0\BD84')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113144378821400706)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C %0\AC1C\C6D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113144292641400706)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C %0\C8FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113143258164400705)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C %0\B144')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113143399023400705)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC 1\B144')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113204701386400750)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C140 \B9DE\CDA4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113204849883400750)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \C6A9\B3C4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113154028813400713)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\B2E4 \C791\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113154131212400713)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\B2E4 \C791\AC70\B098 \AC19\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113198654112400746)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113198776750400746)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\ACFC \C601\C5ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113205148402400751)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'ko'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113197369854400745)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\AC00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113207725463400753)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\C18C\AC00 \C5EC\B7EC \AC1C\C77C \ACBD\C6B0 \CF64\B9C8\B85C \AD6C\BD84\D558\C2ED\C2DC\C624')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113155299833400714)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\ADDC \D45C\D604\C2DD \C77C\CE58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113179696374400732)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300\AC12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113215255166400758)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \CD5C\B300\AC12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113179801862400732)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\AC04\AC12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113215343156400758)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \C911\AC04\AC12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113179597651400732)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C\AC12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113155358180400714)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113180304285400733)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84 \C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113215107815400758)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \CD5C\C18C\AC12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113155798112400714)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C6D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113162365008400719)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B294 \D5C8\C6A9\B418\B294 \CD5C\B300\AC12\C744 \CD08\ACFC\D558\B294 %0 \C774\C0C1\C758 \D589\C744 \D3EC\D568\D569\B2C8\B2E4. \ACB0\ACFC\B97C \BCF4\B824\BA74 \CD94\AC00 \D544\D130\B97C \C801\C6A9\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113189081948400739)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C5D0 \C5EC\B7EC \B300\D654\C2DD \ADF8\B9AC\B4DC\AC00 \D3EC\D568\B418\C5B4 \C788\C73C\BBC0\B85C \C601\C5ED \C815\C801 ID\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113158476368400716)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113158649649400716)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 \C9C0\C815\B41C \BCF4\ACE0\C11C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113142605363400705)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C77C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113142497547400705)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C2DC\AC04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113144691250400706)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C 1\BD84')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113142962541400705)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C6D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113142851969400705)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C8FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113142767843400705)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C %0\C77C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113142540163400705)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C %0\C2DC\AC04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113144753486400706)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C %0\BD84')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113144087111400706)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C %0\AC1C\C6D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113144108568400706)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C %0\C8FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113143146928400705)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C %0\B144')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113143056726400705)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C5F0\B3C4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113154324760400713)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C0AC\C774\AC00 \C544\B2D8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113153324902400713)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC19\C9C0 \C54A\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113219508106400761)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('ID %0\C758 \C601\C5ED\C740 \B300\D654\C2DD \ADF8\B9AC\B4DC \C601\C5ED\C774 \C544\B2C8\AC70\B098 %1 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113153792050400713)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C5D0 \C18D\D558\C9C0 \C54A\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113154559589400713)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC \AE30\AC04\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113154793895400714)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \AE30\AC04\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113162249819400719)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113200269184400747)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113205320231400751)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C22B\C790')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113200587291400747)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113200626987400747)
,p_name=>'APEX.IG.ON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113152559086400712)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('1\BD84 \C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113208236192400753)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\B9B0 \C0C9\C0C1 \C120\D0DD\AE30: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113197025899400745)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113159545822400717)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\C0B0\C790')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113196421920400744)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\D5A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113198882071400746)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C774')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113160811614400718)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113128478083400695)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97 \BCF4\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113208142512400753)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C744 "%0"(\C73C)\B85C \AD6C\BD84')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113198910008400746)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF9\C120')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113204265736400750)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C6B4\B370')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113204320570400750)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113204185358400750)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113158773284400717)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113159086895400717)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \AE30\BCF8\AC12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113175528536400729)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BCF4\ACE0\C11C')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113057710064400643)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C811\ADFC\C131 \D0DC\ADF8 \D3EC\D568')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113056497235400642)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\B85C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113056568184400642)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\B85C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113056353760400642)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC29\D5A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113056254691400642)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'ko'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113056144681400642)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'ko'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113057802776400643)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113055990811400642)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'ko'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113055886175400642)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'ko'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113056056502400642)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'ko'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113055779644400641)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D06C\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113045960490400634)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\C2DD \C788\B294 \D14D\C2A4\D2B8 \C81C\AC70')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113199016222400746)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\C0AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113199147660400746)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C704')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113209483190400754)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C\ACE0\CE68')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113163037048400720)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C0C8\B85C\ACE0\CE68')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113161803693400719)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C0C8\B85C\ACE0\CE68')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113167001761400723)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC \C601\C5ED\C774 %0 \C560\D50C\B9AC\CF00\C774\C158, %1 \D398\C774\C9C0 \BC0F %2 \C601\C5ED\C5D0 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113129975739400696)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C81C\AC70')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113158114833400716)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113218771380400761)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\AC00 \C0AD\C81C\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113218472470400760)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C0AC\C6A9\C790\C5D0 \B300\D55C \B300\CCB4 \BCF4\ACE0\C11C\AC00 \C800\C7A5\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113218344666400760)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C0AC\C6A9\C790\C5D0 \B300\D55C \AE30\BCF8 \BCF4\ACE0\C11C\AC00 \C800\C7A5\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113218651783400761)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C6A9 \BCF4\ACE0\C11C\AC00 \C800\C7A5\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113218544109400760)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C0AC\C6A9\C790\C5D0 \B300\D55C \ACF5\C6A9 \BCF4\ACE0\C11C\AC00 \C800\C7A5\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113167178305400723)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 %0\C778 \C800\C7A5\B41C \B300\D654\C2DD \ADF8\B9AC\B4DC\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113152436000400712)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BD84 \C804\C758 \BCF4\ACE0\C11C \B370\C774\D130\C785\B2C8\B2E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113152386571400712)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('1\BD84 \C804\C758 \BCF4\ACE0\C11C \B370\C774\D130')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113092001024400667)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC \BCF4\ACE0\C11C\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113211666232400755)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C - \D3B8\C9D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113166905255400723)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('ID\AC00 %0\C778 \C800\C7A5\B41C \B300\D654\C2DD \ADF8\B9AC\B4DC\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113211541085400755)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C - \B2E4\B978 \C774\B984\C73C\B85C \C800\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113130008870400696)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113219623128400761)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\C801 ID %0(\C73C)\B85C \C800\C7A5\B41C \B300\D654\C2DD \ADF8\B9AC\B4DC\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113214552930400758)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \BCF4\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113129117312400695)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113163163759400720)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD\C0AC\D56D \BCF5\C6D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113161923785400719)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \BCF5\C6D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113159103102400717)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113158078163400716)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B2F9 \D589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113219287386400761)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C791\C5C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113220493708400762)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D589\C5D0 \B300\D55C \C791\C5C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113129444069400695)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113172152780400727)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113127606438400694)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B41C \BCF4\ACE0\C11C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113127730519400694)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113102299900400675)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 %0\C778 \C800\C7A5\B41C \BCF4\ACE0\C11C\AC00 \C874\C7AC\D569\B2C8\B2E4. \C0C8 \C774\B984\C744 \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113127884477400694)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C6A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113127917341400694)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113214226032400757)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\B978 \C774\B984\C73C\B85C \C800\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113161279362400718)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C124\C815 \C800\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113199253310400746)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0B0\D3EC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113127503638400694)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113206510612400752)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9: \BAA8\B4E0 \D14D\C2A4\D2B8 \C5F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113127492257400694)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113205731062400751)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9: \C804\CCB4 \D14D\C2A4\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113152266213400712)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'ko'
,p_message_text=>unistr('''%0'' \AC80\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113195828293400744)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'ko'
,p_message_text=>unistr('- \C120\D0DD -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113136089231400700)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD \C0AC\D56D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113188756494400739)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C2A4\D130 \C601\C5ED\C5D0\C11C 1\AC1C\C758 \D589 \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113127380370400694)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\D560 \C5F4\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113218983205400761)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD \C791\C5C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113136287664400700)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C140 \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113136156266400700)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113207185830400752)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C\B85C \C804\C1A1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113199696383400747)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C5F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113125390130400692)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113177919678400731)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \AC12 \D45C\C2DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113162752560400720)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C \D589 \BCF4\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113161030860400718)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113199766731400747)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \AE30\C900')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113219396140400761)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4\B2F9 \D558\B098\C758 \C815\B82C\B9CC \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113219191902400761)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\B274 \BCC0\ACBD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113200749621400747)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B204\C801')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113155037915400714)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C73C\B85C \C2DC\C791')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113199344355400746)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\C2DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113120374944400689)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \B108\BE44 \B298\C774\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113161437658400719)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\C6A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113179452505400732)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D569\ACC4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113220658869400762)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \ADF8\B9AC\B4DC\C785\B2C8\B2E4. \BCF4\ACE0\C11C: %0, \BDF0: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113214630823400758)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\CCB4 \D569\ACC4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113197571856400745)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\D45C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113203923420400750)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \C0C9\C0C1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113130166385400696)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1A0\AE00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113177817650400731)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\AD6C \C124\BA85')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113158218677400716)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C720\D615')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113162635657400720)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C815 \D574\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113159758040400717)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C704')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113206971770400752)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D\C774 \C788\C2B5\B2C8\B2E4. \ACC4\C18D\D558\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113159624501400717)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113196606778400744)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113201599138400748)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C774 \D544\C694\D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113186489904400737)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12(\C2DC\AC04\B300\B97C \BCC0\ACBD\D560 \C218 \C5C6\C74C)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113205485108400751)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113197989543400745)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\B85C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113157700152400716)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113195945194400744)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113197497693400745)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCFC\B968')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113155643901400714)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113196067445400744)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C \C5F4 \B108\BE44(\D53D\C140)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113146848796400708)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) %1 - %2 \BC94\C704\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113146511894400708)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B2E4\C74C\C774 \D3EC\D568\B428: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113146688232400708)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C\C744 \D3EC\D568\D558\C9C0 \C54A\C74C %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113124735139400692)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) %1(\C73C)\B85C \C2DC\C791\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113145311812400707)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C\ACFC \AC19\C74C: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113145594251400707)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C\BCF4\B2E4 \D07C: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113145601851400707)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C\BCF4\B2E4 \D06C\AC70\B098 \AC19\C74C %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113146379568400708)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C\C5D0 \C18D\D568: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113147503798400708)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC %1\C77C \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113147393679400708)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC %1\C2DC\AC04 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113147163909400708)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC %1\BD84 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113147950277400709)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC %1\AC1C\C6D4 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113147714461400709)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC %1\C8FC \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113148134396400709)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC %1\B144 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113147435448400708)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC 1\C77C \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113147205979400708)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC 1\C2DC\AC04 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113147089853400708)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC 1\BD84 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113147864083400709)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC 1\AC1C\C6D4 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113147644153400709)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC 1\C8FC \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113148086418400709)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC 1\B144 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113149910156400710)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1\C77C \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113149719328400710)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1\C2DC\AC04 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113149543743400710)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1\BD84 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113150345181400710)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1\AC1C\C6D4 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113150115352400710)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1\C8FC \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113150580644400711)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1\B144 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113149808266400710)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C 1\C77C \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113149644108400710)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C 1\C2DC\AC04 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113149481733400710)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C 1\BD84 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113150259963400710)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C 1\AC1C\C6D4 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113150011633400710)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C 1\C8FC \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113150451705400710)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C 1\B144 \C774\B0B4\C5D0 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113146064906400707)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \BE44\C5B4 \C788\C9C0 \C54A\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113145990759400707)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \BE44\C5B4 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113145721042400707)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C\BCF4\B2E4 \C791\C74C: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113145839150400707)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C\BCF4\B2E4 \C791\AC70\B098 \AC19\C74C %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113146145659400707)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C\ACFC \C720\C0AC\D568: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113146759737400708)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C \C815\ADDC \D45C\D604\C2DD\ACFC \C77C\CE58\D568 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113152629538400712)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BD84 \C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113146910753400708)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) %1 \BC0F %2 \C0AC\C774 \C544\B2D8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113145451084400707)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C\ACFC \AC19\C9C0 \C54A\C74C: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113146450308400708)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C\C5D0 \C18D\D558\C9C0 \C54A\C74C: %1')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113148720146400709)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC %1\C77C \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113148588895400709)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC %1\C2DC\AC04 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113148319213400709)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC %1\BD84 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113149158921400710)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC %1\AC1C\C6D4 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113148949319400709)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC %1\C8FC \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113149362771400710)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC %1\B144 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113148681065400709)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC 1\C77C \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113148469680400709)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC 1\C2DC\AC04 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113148244727400709)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC 1\BD84 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113149064703400709)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC 1\AC1C\C6D4 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113148859944400709)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC 1\C8FC \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113149206005400710)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \CD5C\ADFC 1\B144 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113151194668400711)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1\C77C \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113150976739400711)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1\C2DC\AC04 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113150775382400711)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1\BD84 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113151523522400711)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1\AC1C\C6D4 \C774\B0B4\C5D0 \C5C6\C74C ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113151304327400711)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1\C8FC \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113151782606400711)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1\B144 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113151019551400711)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C 1\C77C \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113150869499400711)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C 1\C2DC\AC04 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113150637488400711)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C 1\BD84 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113151476846400711)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C 1\AC1C\C6D4 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113151242607400711)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C 1\C8FC \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113151640196400711)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C 1\B144 \C774\B0B4\C5D0 \C5C6\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113146222497400708)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C\ACFC \C720\C0AC\D558\C9C0 \C54A\C74C: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113153115627400712)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B2E4\C74C\C73C\B85C \C2DC\C791 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113196776302400744)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'ko'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113155894117400714)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B144')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113196859093400745)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'ko'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113196907969400745)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'ko'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113205989309400751)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'ko'
,p_message_text=>unistr('2016\B144 1\C6D4 12\C77C \C6D4\C694\C77C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113206072246400751)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'ko'
,p_message_text=>unistr('1\C6D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113206154143400751)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'ko'
,p_message_text=>unistr('16\C2DC\AC04 \C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113206264341400751)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'ko'
,p_message_text=>unistr('16\C2DC\AC04 \B0B4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113061244374400645)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C720\D615\C774 \BD80\C801\D569\D569\B2C8\B2E4. \C9C0\C6D0\B418\B294 \D30C\C77C \C720\D615\C740 %0\C785\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113188105314400738)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC3E\C544\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113187832195400738)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113187900716400738)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113061089481400645)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B04C\C5B4 \B193\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113061494185400646)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \B04C\C5B4 \B193\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113062680187400646)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C744 \C120\D0DD\D558\AC70\B098 \C5EC\AE30\C5D0 \B04C\C5B4 \B193\AE30.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113062716474400646)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C744 \C120\D0DD\D558\AC70\B098 \C5EC\AE30\C5D0 \B04C\C5B4 \B193\AE30.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113062819748400647)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C744 \C120\D0DD\D558\AC70\B098 \C5EC\AE30\C5D0 \B04C\C5B4 \B193\AE30.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113062901097400647)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C744 \C120\D0DD\D558\AC70\B098 \C5EC\AE30\C5D0 \B04C\C5B4 \B193\AE30.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113061342080400645)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D30C\C77C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113061109098400645)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C774 \B108\BB34 \D07D\B2C8\B2E4. \CD5C\B300 \D30C\C77C \D06C\AE30\B294 %0\C785\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113048927078400637)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\C18C\B294 \D544\C218\C785\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113047887614400636)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C/\AD70/\C2DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113048252556400636)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6D\AC00 \CF54\B4DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113047902182400636)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D638')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113048824631400637)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\B3C4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113048741920400636)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\B3C4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113048617382400636)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B3C4\C5D0 \D45C\C2DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113048313258400636)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C810\C218')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113048056372400636)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6B0\D3B8 \BC88\D638')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113048161968400636)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC/\B3C4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113047786230400636)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3D9/\B9AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113047605587400636)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C624\CF54\B529 \ACB0\ACFC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113060282370400645)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C624\CF54\B529\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113060306231400645)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C624\CF54\B529\B418\C9C0 \C54A\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113048509444400636)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B3C4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113048486873400636)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1C\ACAC\B41C \C8FC\C18C \C5C6\C74C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113049023731400637)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \D544\C218\C785\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113218809165400761)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0 \D14D\C2A4\D2B8: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113112272117400682)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113112380946400682)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD \CDE8\C18C\B428')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113058238975400643)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C774 %0\BD80\D130 %1\AE4C\C9C0\C758 \C801\D569\D55C \BC94\C704\C5D0 \C18D\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113058378491400643)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C774 %0\C758 \BC30\C218\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113057998606400643)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C774 \AC12 %0 \BC0F %1\ACFC(\C640) \C77C\CE58\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113058163562400643)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113136420472400700)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113136579213400701)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113058073228400643)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113041430891400631)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113170614443400725)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113170704980400725)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113041536248400631)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113174492555400728)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\AE09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113174777906400728)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113174543665400728)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BC18 \C0AC\D56D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113174884959400728)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B77C\C774\BE0C \D15C\D50C\B9AC\D2B8 \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113175446696400729)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \AD6C\C131\C694\C18C\B294 \D398\C774\C9C0\C5D0\C11C \B80C\B354\B9C1\B418\C9C0 \C54A\C73C\BBC0\B85C \D15C\D50C\B9AC\D2B8 \C635\C158\C744 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113174362423400728)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D15C\D50C\B9AC\D2B8 \C635\C158\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113174688143400728)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113049985526400637)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0 \C9C0\C6B0\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113051715246400639)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758 \C2A4\D0C0\C77C\C774 \C801\D569\D55C JSON\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113050217999400638)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC70\B9AC \B3C4\AD6C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113050090352400637)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D0 \ADF8\B9AC\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113042664140400632)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D328\C2EF\C774 \C9C0\C815\B41C \AC80\C0C9\C740 \C601\C5ED \B808\BCA8\C5D0 \B370\C774\D130 \C18C\C2A4\AC00 \C788\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113045261256400634)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C704\CE58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113046394022400635)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \C704\CE58 \C88C\D45C\AC00 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113043757917400633)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30 \C704\CE58\B294 \D3EC\C778\D2B8 \B3C4\BA74\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113046137849400635)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0AC\B85C\BBF8\D130')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113044784420400634)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113178095262400731)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE35: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113049303530400637)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B3C4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113042503438400632)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113046248514400635)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C8\C77C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113177056415400730)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B294 \D5C8\C6A9\B418\B294 \CD5C\B300\AC12\C744 \CD08\ACFC\D558\B294 %0 \C774\C0C1\C758 \D589\C744 \D3EC\D568\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113044502748400633)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'ko'
,p_message_text=>'&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Terms</a> &nbsp;&nbsp; Map data &copy; 2017 HERE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113043497415400633)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('SDO_GEOMETRY \B370\C774\D130 \C720\D615\C740 \C774 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113044667489400633)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap \C81C\ACF5\C790 </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113044816004400634)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\C778\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113178188009400731)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D3EC\C778\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113050187025400637)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C1\C0AC\AC01\D615 \D655\B300/\CD95\C18C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113049819638400637)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\AC70')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113045109792400634)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCA0\C5B4\B9C1\C744 \BD81\CABD\C73C\B85C \C7AC\C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113125465697400692)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('2D \BAA8\B4DC\B85C \D1A0\AE00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113125592709400692)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'ko'
,p_message_text=>unistr('3D \BAA8\B4DC\B85C \D1A0\AE00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113049784001400637)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C791\AD8C \D1B5\C9C0 \D1A0\AE00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113050310797400638)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \AC70\B9AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113044909033400634)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\B300')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113045018788400634)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95\C18C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113172587465400727)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD75\C740\CCB4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113173482748400727)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113173043231400727)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\B77C\C778 \CF54\B4DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113186675518400737)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8\C9C0 \C0BD\C785')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113186776192400737)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C \C0BD\C785')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113172635490400727)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C6B8\C784\AF34')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113187333680400738)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C1\D06C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113173332302400727)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113173288439400727)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C21C\CC28 \BAA9\B85D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113172742455400727)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\B9AC\BCF4\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113172873366400727)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\B9AC \BCFC \D56D\BAA9 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113172987062400727)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C\C120')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113173160388400727)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\C21C\CC28 \BAA9\B85D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113152005211400712)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113209519546400754)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B354 \BCF4\AE30...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113151938238400712)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\B4DC \C911')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113183707204400735)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1B5\C9C0 \BA54\C2DC\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113157002301400715)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740(\B294) %0\BCF4\B2E4 \C791\AC70\B098 \AC19\C740 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113157153116400715)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740(\B294) \C801\D569\D55C \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113157205865400715)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C774 \C22B\C790 \D615\C2DD %0\ACFC(\C640) \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4(\C608: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113156931119400715)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740(\B294) %0\BCF4\B2E4 \D06C\AC70\B098 \AC19\C740 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113156880016400715)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL#\C740(\B294) %0\C5D0\C11C %1\C0AC\C774\C758 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113152191925400712)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \CC3D\C5D0\C11C \C5F4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113105324422400677)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'ko'
,p_message_text=>unistr(' \C774 \D398\C774\C9C0\B294 \C774\BBF8 \C81C\CD9C\B418\C5C8\C73C\BA70 \B2E4\C2DC \C81C\CD9C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113087993172400664)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \C560\D50C\B9AC\CF00\C774\C158 "%1" \D398\C774\C9C0\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113121758738400690)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('#LABEL# \AC12\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113065042854400648)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113171011996400726)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EB\AE30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113170955934400726)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CC3E\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113171285617400726)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113171181294400726)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113057116272400642)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\C5B4\B97C %0\C790 \C774\C0C1 \C785\B825\D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113126683661400693)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D31D\C5C5 \AC12 \BAA9\B85D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113057238648400643)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\C5B4\B97C \C785\B825\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113057060519400642)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACB0\ACFC\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113056948628400642)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C81C\AC70')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113144801867400707)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\C5B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113170871748400726)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113181511799400733)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2F1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113055506125400641)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648 \D654\BA74\C5D0 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113051593366400638)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\C0AC\C6A9 \C911\C778 \C7A5\CE58 \B610\B294 \BE0C\B77C\C6B0\C800\C5D0\C11C \D604\C7AC \D504\B85C\ADF8\B808\C2DC\BE0C \C6F9 \C571 \C124\CE58\B97C \C9C0\C6D0\D558\C9C0 \C54A\B294 \AC83 \AC19\C2B5\B2C8\B2E4.</p>'),
unistr('    <p class="a-pwaDialog-intro">\C774 \C560\D50C\B9AC\CF00\C774\C158\C774 \C774\BBF8 \C7A5\CE58\C5D0 \C124\CE58\B418\C5B4 \C788\B294 \ACBD\C6B0 \D648 \D654\BA74\C5D0\C11C \C5EC\C2ED\C2DC\C624.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113051197121400638)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\C774 \C6F9\C0AC\C774\D2B8\C5D0\B294 \C571 \AE30\B2A5\C774 \C788\C2B5\B2C8\B2E4. \C804\CCB4 \D654\BA74\C5D0\C11C \C0AC\C6A9\D558\B824\BA74 \D648 \D654\BA74\C5D0 \CD94\AC00\D558\C2ED\C2DC\C624.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \C544\B798\CABD \D0D0\C0C9\C5D0\C11C <strong>\BA54\B274</strong> \C544\C774\CF58\C744 \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>\C124\CE58</strong>\B97C \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. <strong>\CD94\AC00</strong>\B97C \B20C\B7EC \D655\C778\D569\B2C8\B2E4.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113051207724400638)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\C774 \C6F9\C0AC\C774\D2B8\C5D0\B294 Chrome \B610\B294 Edge\C5D0\C11C \AC00\C7A5 \C798 \ACBD\D5D8\D560 \C218 \C788\B294 \C571 \AE30\B2A5\C774 \C788\C2B5\B2C8\B2E4.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \C8FC\C18C \D45C\C2DC\C904 \C606\C5D0 \C788\B294 <strong>\BA54\B274</strong> \C544\C774\CF58\C744 \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>\C124\CE58</strong>\B97C \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113050814056400638)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\C774 \C6F9\C0AC\C774\D2B8\C5D0\B294 Safari\C5D0\C11C \AC00\C7A5 \C798 \ACBD\D5D8\D560 \C218 \C788\B294 \C571 \AE30\B2A5\C774 \C788\C2B5\B2C8\B2E4.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \C544\B798\CABD \D0D0\C0C9\C5D0\C11C <strong>\ACF5\C720</strong> \C544\C774\CF58\C744 \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>Safari\C5D0\C11C \C5F4\AE30</strong>\B97C \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113050582628400638)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\C774 \C6F9\C0AC\C774\D2B8\C5D0\B294 \C571 \AE30\B2A5\C774 \C788\C2B5\B2C8\B2E4. \CD5C\ACE0\C758 \ACBD\D5D8\C744 \C704\D574 \D648 \D654\BA74\C5D0 \CD94\AC00\D558\C2ED\C2DC\C624.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \C8FC\C18C \D45C\C2DC\C904 \C606\C5D0 \C788\B294 <strong>\ACF5\C720</strong> \C544\C774\CF58\C744 \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>\D648 \D654\BA74\C5D0 \CD94\AC00</strong>\B97C \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. <strong style="color:#007AE1;">\CD94\AC00</strong>\B97C \B20C\B7EC \D655\C778\D569\B2C8\B2E4.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113050447148400638)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\C774 \C6F9\C0AC\C774\D2B8\C5D0\B294 \C571 \AE30\B2A5\C774 \C788\C2B5\B2C8\B2E4. \CD5C\ACE0\C758 \ACBD\D5D8\C744 \C704\D574 \D648 \D654\BA74\C5D0 \CD94\AC00\D558\C2ED\C2DC\C624.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \C544\B798\CABD \D0D0\C0C9\C5D0\C11C <strong>\ACF5\C720</strong> \C544\C774\CF58\C744 \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \C544\B798\B85C \C774\B3D9\D558\C5EC <strong>\D648 \D654\BA74\C5D0 \CD94\AC00</strong>\B97C \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. <strong style="color:#007AE1;">\CD94\AC00</strong>\B97C \B20C\B7EC \D655\C778\D569\B2C8\B2E4.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113045427171400634)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\C774 \C6F9\C0AC\C774\D2B8\C5D0\B294 \C571 \AE30\B2A5\C774 \C788\C2B5\B2C8\B2E4. \CD5C\ACE0\C758 \ACBD\D5D8\C744 \C704\D574 \D648 \D654\BA74\C5D0 \CD94\AC00\D558\C2ED\C2DC\C624.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \C8FC\C18C \D45C\C2DC\C904 \C606\C5D0 \C788\B294 <strong>\C790\C138\D788</strong> \C544\C774\CF58\C744 \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>\D648 \D654\BA74\C5D0 \CD94\AC00</strong>\B97C \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. <strong style="color:#007AE1;">\CD94\AC00</strong>\B97C \B20C\B7EC \D655\C778\D569\B2C8\B2E4.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113050733128400638)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\C774 \C6F9\C0AC\C774\D2B8\C5D0\B294 \C571 \AE30\B2A5\C774 \C788\C2B5\B2C8\B2E4. \CD5C\ACE0\C758 \ACBD\D5D8\C744 \C704\D574 \D648 \D654\BA74\C5D0 \CD94\AC00\D558\C2ED\C2DC\C624.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\C8FC\C18C \D45C\C2DC\C904 \C606\C5D0 \C788\B294 <strong>\ACF5\C720</strong> \C544\C774\CF58\C744 \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText"><strong>Safari\C5D0\C11C \C5F4\AE30</strong>\B97C \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113050625478400638)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\C774 \C6F9\C0AC\C774\D2B8\C5D0\B294 \C571 \AE30\B2A5\C774 \C788\C2B5\B2C8\B2E4. \CD5C\ACE0\C758 \ACBD\D5D8\C744 \C704\D574 \D648 \D654\BA74\C5D0 \CD94\AC00\D558\C2ED\C2DC\C624.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\C544\B798\CABD \D0D0\C0C9\C5D0\C11C <strong>\ACF5\C720</strong> \C544\C774\CF58\C744 \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText"><strong>Safari\C5D0\C11C \C5F4\AE30</strong>\B97C \B204\B985\B2C8\B2E4.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113051441034400638)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\C774 \C6F9\C0AC\C774\D2B8\C5D0\B294 Chrome\C5D0\C11C \AC00\C7A5 \C798 \ACBD\D5D8\D560 \C218 \C788\B294 \C571 \AE30\B2A5\C774 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox\C758 \ACBD\C6B0 \D604\C7AC \C6F9 \C571 \C124\CE58\B97C \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113050972754400638)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\C774 \C6F9\C0AC\C774\D2B8\C5D0\B294 Chrome \B610\B294 Edge\C5D0\C11C \AC00\C7A5 \C798 \ACBD\D5D8\D560 \C218 \C788\B294 \C571 \AE30\B2A5\C774 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox\C758 \ACBD\C6B0 \D604\C7AC macOS\C5D0\C11C \C6F9 \C571 \C124\CE58\B97C \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113051008757400638)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\C774 \C6F9\C0AC\C774\D2B8\C5D0\B294 Chrome \B610\B294 Edge\C5D0\C11C \AC00\C7A5 \C798 \ACBD\D5D8\D560 \C218 \C788\B294 \C571 \AE30\B2A5\C774 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari\C758 \ACBD\C6B0 \D604\C7AC macOS\C5D0\C11C \C6F9 \C571 \C124\CE58\B97C \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113051359558400638)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\C774 \C6F9\C0AC\C774\D2B8\C5D0\B294 Chrome \B610\B294 Edge\C5D0\C11C \AC00\C7A5 \C798 \ACBD\D5D8\D560 \C218 \C788\B294 \C571 \AE30\B2A5\C774 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox\C758 \ACBD\C6B0 \D604\C7AC Windows\C5D0\C11C \C6F9 \C571 \C124\CE58\B97C \C9C0\C6D0\D558\C9C0 \C54A\C2B5\B2C8\B2E4.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113053838631400640)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>\C811\C18D\D560 \C218 \C5C6\C74C</h1>'),
unistr('    <p>\C774 \C571\C744 \C0AC\C6A9\D558\B824\BA74 \C778\D130\B137 \C811\C18D\C774 \D544\C694\D569\B2C8\B2E4.</p>'),
unistr('    <button type="button">\C7AC\C2DC\B3C4</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113053765483400640)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C811\C18D\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113193550323400742)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113137946401400702)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B8E8 \C885\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113216847520400759)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\B300 \C804\C1A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113216685689400759)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113139711053400703)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\C77C \C77C\AC04 \BCF4\AE30 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113139584755400703)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04 \D3EC\D568 \C77C\AC04 \B370\C774\D130 \BCF4\AE30 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113184416616400736)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113178833076400731)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113069431748400651)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'ko'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113069205162400651)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'ko'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113069177249400651)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'ko'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113069335155400651)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'ko'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113068844843400651)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113069061039400651)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113216705551400759)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113184579883400736)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113184236444400735)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113187028095400737)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113201307674400748)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BCA4\D2B8 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113217063907400759)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \C774\BCA4\D2B8\B97C \D3B8\C9D1\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113216992005400759)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C\C744 \D1B5\D574 \CD08\B300\B97C \C804\C1A1\D558\B294 \C911\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113187142797400737)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113195139883400743)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C804\C1A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113194959271400743)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C804\C1A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113217790219400760)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \D544\B4DC\B294 \D544\C218\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113217609175400760)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\B300 \C804\C1A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113216590027400759)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113195049771400743)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1B\B294 \C0AC\B78C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113068977199400651)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113192891904400742)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \D3FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113139344087400703)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113187234636400738)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B298')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113185096958400736)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113184397431400735)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113139620005400703)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\C77C \C8FC\AC04 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113139498104400703)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04 \D3EC\D568 \C8FC\AC04 \B370\C774\D130 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113184948255400736)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113184647929400736)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113184792806400736)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \B85C\B4DC...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113116881025400686)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4A4\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113063195460400647)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \B85C\B4DC...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113065296233400648)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113184869524400736)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00 \B85C\B4DC...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113186945353400737)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED ID %0\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113065100465400648)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113089209292400665)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C744 \C7AC\C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113057487067400643)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D398\C774\C9C0 \BC88\D638 \B9E4\AE40\C744 \C124\C815\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113178234076400731)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113186804603400737)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C720\D615 %0\C740(\B294) \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113057309479400643)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('"#COMPONENT_NAME#" \C601\C5ED\C744 \B80C\B354\B9C1\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113121821663400690)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('#COLUMN_HEADER# \AC12\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113216168813400759)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0, \C11C\C2DD \C788\B294 \D14D\C2A4\D2B8 \D3B8\C9D1\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113123995609400691)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\C2DD \C788\B294 \D14D\C2A4\D2B8 HTML \B9C8\D06C\C5C5\C774 \D56D\BAA9\C758 \CD5C\B300 \AE38\C774\B97C \CD08\ACFC\D568(\C2E4\C81C %0\C790, \D5C8\C6A9\B41C %1\C790)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113183883495400735)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113175662434400729)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113173944184400728)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\B41C \C5F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113173812488400728)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \AC12 \C81C\C678')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113183960568400735)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\AC00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113137501417400701)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\B85C \C774\B3D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113137672099400701)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\B85C \C774\B3D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113173636064400728)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113174232437400728)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\D0C0 \C5F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113173785618400728)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113174030413400728)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113174128849400728)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0/%1 \D589')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113175744557400729)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C\ACE0\CE68')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113175871829400729)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\ACBD\C0AC\D56D \BCF5\C6D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113173501885400727)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\C815 \BA54\B274')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113134573508400699)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113042048822400632)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C2DC \C0AC\C778\C778')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113041977297400632)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158\C774 \C885\B8CC\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113042142628400632)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113041729670400631)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158\C774 %0\C5D0 \C885\B8CC\B429\B2C8\B2E4. \D655\C7A5\D558\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113041891362400631)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158\C774 %0\C5D0 \C885\B8CC\B418\BA70 \D655\C7A5\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \B370\C774\D130\AC00 \C190\C2E4\B418\C9C0 \C54A\B3C4\B85D \BC14\B85C \C791\C5C5\C744 \C800\C7A5\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113194756553400743)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C138\C158 \C815\B9AC \CF54\B4DC\B97C \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113087844157400664)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\BCA0\C774\C2A4 \C138\C158 \C124\C815 \CF54\B4DC\B97C \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113061954979400646)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158\C774 \C885\B8CC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113193683201400742)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \B300\D654\C0C1\C790\B97C \B2EB\ACE0 \BE0C\B77C\C6B0\C800\C758 \B2E4\C2DC \B85C\B4DC \B2E8\CD94\B97C \B20C\B7EC\C11C \C0C8 \C138\C158\C744 \AC00\C838\C624\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113212931392400756)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C138\C158\C744 \C0DD\C131\D558\B824\BA74 <a href="%0">\C5EC\AE30</a>\B97C \B204\B985\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113099540078400673)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C138\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113139071131400702)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 "%0"\C5D0 \B300\D574 Real Application Security \C138\C158\C5D0\C11C \B3D9\C801 \B864\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113085779118400663)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-99900 \ACE0\C720 \C138\C158 ID\B97C \C0DD\C131\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113102011933400675)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC \BCF4\D638 \C704\BC18: \BCF4\D638\B41C \D398\C774\C9C0 \D56D\BAA9 %0\C744(\B97C) \C218\B3D9\C73C\B85C \BCC0\ACBD\D588\AE30 \B54C\BB38\C77C \C218 \C788\C2B5\B2C8\B2E4. \C774 \C624\B958\C758 \C6D0\C778\C744 \C54C \C218 \C5C6\B294 \ACBD\C6B0\C5D0\B294 \C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\C5D0\AC8C \B3C4\C6C0\C744 \C694\CCAD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113221132410400762)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BCF4\D638 \C704\BC18: \B85C\B4DC\AC00 \C644\B8CC\B418\C9C0 \C54A\C740 \D398\C774\C9C0\B97C \C81C\CD9C\D558\AC70\B098 \BCF4\D638\B41C \D398\C774\C9C0 \D56D\BAA9\C744 \C218\B3D9\C73C\B85C \BCC0\ACBD\D588\AE30 \B54C\BB38\C77C \C218 \C788\C2B5\B2C8\B2E4. \CD94\AC00 \B3C4\C6C0\C774 \D544\C694\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113220125594400762)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \BD80\C801\D569\D55C \BB38\C790\C778 &<>"/;,*|=% \B610\B294 -- \BB38\C790 \C911 \D558\B098\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113220206587400762)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \BD80\C801\D569\D55C \BB38\C790\C778 &<>"/;,*|=% or -- \B610\B294 \C0C8 \D589 \C911 \D558\B098\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113219913289400761)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \D2B9\C218 \BB38\C790\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4. \BB38\C790 a-Z, 0-9 \BC0F \ACF5\BC31\B9CC \D5C8\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113220089065400762)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \BD80\C801\D569\D55C \BB38\C790\C778 <, > \B610\B294 "\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113064171407400647)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B098 \C774\C0C1\C758 \C694\CCAD, \CE90\C2DC \BE44\C6B0\AE30 \B610\B294 \C778\C218 \AC12\C774 \B9E4\AC1C\BCC0\C218\B85C \C804\B2EC\B420 \B54C \CCB4\D06C\C12C\C774 \D544\C694\D55C \D398\C774\C9C0\C5D0 \B300\D55C \D45C\C2DC \D504\B85C\C138\C2F1\C5D0 \CCB4\D06C\C12C\C774 \C81C\ACF5\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113096994804400671)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\C158 \C0C1\D0DC \BCF4\D638 \C704\BC18: \CCB4\D06C\C12C\C774 \D3EC\D568\B41C URL\C744 \C218\B3D9\C73C\B85C \BCC0\ACBD\D558\AC70\B098, \CCB4\D06C\C12C\C774 \C798\BABB\B418\C5C8\AC70\B098 \B204\B77D\B41C \B9C1\D06C\B97C \C0AC\C6A9\D588\AE30 \B54C\BB38\C77C \C218 \C788\C2B5\B2C8\B2E4. \C774 \C624\B958\C758 \C6D0\C778\C744 \C54C \C218 \C5C6\B294 \ACBD\C6B0\C5D0\B294 \C560\D50C\B9AC\CF00\C774\C158 \AD00\B9AC\C790\C5D0\AC8C \B3C4\C6C0\C744 \C694\CCAD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113174978392400729)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\B300\BE44 \BAA8\B4DC \D574\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113175091115400729)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\B300\BE44 \BAA8\B4DC \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113093614601400669)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E8 \C544\B798\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113093893231400669)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113093965782400669)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113094088804400669)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113094167799400669)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113094276330400669)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113094377126400669)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113093553689400668)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E8 \C704\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113093738963400669)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113202680010400749)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'ko'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113203398641400749)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C77C \B0B4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113202522119400749)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'ko'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113203409366400749)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C2DC\AC04 \B0B4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113202323873400749)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'ko'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113203519927400749)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BD84 \B0B4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113202979701400749)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C6D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113203126791400749)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C6D4 \B0B4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113202466060400749)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'ko'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113203220722400749)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0s \B0B4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113202700116400749)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'ko'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113203656137400750)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C8FC \B0B4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113202844741400749)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'ko'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113203088135400749)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\B144 \B0B4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113042977384400632)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'ko'
,p_message_text=>unistr('[\C120]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113043313167400633)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'ko'
,p_message_text=>unistr('[\B2E4\C911 \C120]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113043113886400632)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'ko'
,p_message_text=>unistr('[\B2E4\C911 \D3EC\C778\D2B8]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113043599246400633)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'ko'
,p_message_text=>unistr('[\B2E4\C911 \B2E4\AC01\D615]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113043632306400633)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'ko'
,p_message_text=>unistr('[\B3C4\BA74 \AC1D\CCB4]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113042879051400632)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'ko'
,p_message_text=>unistr('[\D3EC\C778\D2B8 (%0,%1)]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113043038380400632)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'ko'
,p_message_text=>unistr('[\B2E4\AC01\D615]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113120277075400689)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD95\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113120143881400688)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C6D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113166606968400722)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3C9\AC00 \C9C0\C6B0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113156547296400715)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \C801\D569\D55C \B4F1\AE09 \BC94\C704 1 - %1\C5D0 \C18D\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113156665783400715)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C740(\B294) \C22B\C790\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113152752459400712)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C131\ACF5 \BA54\C2DC\C9C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113215856820400758)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113215784840400758)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113201404308400748)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\AD6C \BAA8\C74C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113216253031400759)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0D0\C0C9 \D655\C7A5/\CD95\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113216373726400759)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CE21\BA74 \C5F4 \D655\C7A5/\CD95\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113125994976400693)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \D0D0\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113132900906400698)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('1\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113132728261400698)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'ko'
,p_message_text=>unistr('1\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113133047060400698)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113132899537400698)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113132690586400698)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BD84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113133264403400698)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113133139167400698)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'ko'
,p_message_text=>unistr('1\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113219430303400761)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C2DC\C791')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113081416204400660)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113055223874400641)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\C744 \CC98\B9AC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113134623743400699)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C218 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113217597879400760)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\AC00 \C644\C804\D788 \B85C\B4DC\B420 \B54C\AE4C\C9C0 \AE30\B2E4\B9B0 \D6C4 \B2E4\C2DC \C2DC\B3C4\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113177702211400731)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0 \C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D\C774 \C788\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113058662547400644)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6CC\D06C\BD81\C5D0 \D65C\C131 \C6CC\D06C\C2DC\D2B8\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113058543742400643)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6CC\D06C\BD81\C774 \CD08\AE30\D654\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113058450709400643)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('XLSX \D30C\C77C\C744 \C0DD\C131\D558\B294 \C911 \B0B4\BD80 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113060974606400645)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113192687567400741)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113110147822400681)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BA54\B274')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113105889831400678)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113105716012400678)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900 \C5F4 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113139981903400703)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97 \C5F4 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113140050593400703)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C5F4 \CD94\AC00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113080299645400659)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D1\ACC4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113116389961400686)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D1\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113097414413400671)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3C9\ADE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113101749087400675)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113097576242400671)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113097782277400672)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\AC04\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113097637332400671)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113097368914400671)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D569\ACC4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113098488148400672)
,p_name=>'APEXIR_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113079519111400658)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113062030771400646)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4E0 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113189642708400739)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113191298159400740)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4 \AE30\BCF8\AC12: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113092167451400667)
,p_name=>'APEXIR_AND'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113081626025400660)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\C6A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113075373551400655)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B984\CC28\C21C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113094999445400669)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C810: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113191865544400741)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3C9\ADE0 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113183270791400735)
,p_name=>'APEXIR_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113081008633400659)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C704:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113074171542400655)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC30\ACBD\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113076071881400656)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113107720338400679)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E8 \C544\B798\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113076679905400656)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CDE8\C18C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113082518941400661)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC94\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113074080507400655)
,p_name=>'APEXIR_CELL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C140')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113098392419400672)
,p_name=>'APEXIR_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113108625339400680)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\AE30\D654 \C911...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113144943443400707)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \B808\C774\BE14\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113157355040400715)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D574\B2F9 \C9C8\C758\B294 \CC28\D2B8\B2F9 \CD5C\B300 \B370\C774\D130 \D3EC\C778\D2B8 \C218 %0\AC1C\B97C \CD08\ACFC\D569\B2C8\B2E4. \AE30\BCF8 \C9C8\C758\C758 \B808\CF54\B4DC \C218\B97C \C904\C774\B824\BA74 \D544\D130\B97C \C801\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113156215223400715)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C9C8\C758\C5D0 \B300\D55C \CD5C\B300 \D589 \C218\B294 \D45C\C2DC\B418\B294 \D589 \C218\AC00 \C544\B2CC \AE30\BCF8 \C9C8\C758\C758 \D589 \C218\B97C \C81C\D55C\D569\B2C8\B2E4. \AE30\BCF8 \C9C8\C758\AC00 \CD5C\B300 \D589 \C218 %0\AC1C\B97C \CD08\ACFC\D569\B2C8\B2E4. \AE30\BCF8 \C9C8\C758\C758 \B808\CF54\B4DC \C218\B97C \C904\C774\B824\BA74 \D544\D130\B97C \C801\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113079630293400658)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113152963104400712)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113095384263400670)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D615\C2DD \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113102748388400675)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6B0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113076552058400656)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113113953185400684)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113186295604400737)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113104702422400677)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \BA38\B9AC\AE00 \BA54\B274')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113108444439400680)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C815\BCF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113188596990400738)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113106182573400678)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113090212961400666)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113091171571400667)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3EC\D568\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113075016455400655)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C5D0 \C18D\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113091362026400667)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C774 \B9C8\C9C0\B9C9\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113099838237400673)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C774 \CC28\AE30\AC00 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113091293975400667)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C774 \B9C8\C9C0\B9C9\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113099711333400673)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C774 \CC28\AE30\C784')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113074983399400655)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113074819859400655)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113074695187400655)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\ACFC \C720\C0AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113075168743400655)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C5D0 \C18D\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113074725274400655)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\ACFC \C720\C0AC\D558\C9C0 \C54A\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113090582335400666)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\ADDC \D45C\D604\C2DD \C77C\CE58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113095290448400670)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113155900924400714)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113114240921400684)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \BCC4\CE6D\C744 \C0AC\C6A9\D558\C5EC \ACC4\C0B0\C744 \C0DD\C131\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113114315995400684)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'ko'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113114427482400684)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'ko'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113114527015400684)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'ko'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113060461082400645)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'ko'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113099148130400673)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113106744135400678)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \CC28\B2E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113109751543400680)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \CC28\B2E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113194168156400743)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \CC28\B2E8 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113057510192400643)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \AC1C\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113192363517400741)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACE0\C720 \AC1C\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113192244981400741)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C218 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113164306852400721)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BCC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113219025349400761)
,p_name=>'APEXIR_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113108587697400680)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BD84 \C804\C758 \BCF4\ACE0\C11C \B370\C774\D130\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113182072851400734)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \ADF8\B9AC\B4DC \B3C4\C6C0\B9D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113080375197400659)
,p_name=>'APEXIR_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113112404427400683)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113189434952400739)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BCF4\ACE0\C11C \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113076760489400656)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113080653074400659)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BCF4\ACE0\C11C \C124\C815\C744 \C0AD\C81C\D558\ACA0\C2B5\B2C8\AE4C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113175330047400729)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BCF4\ACE0\C11C \C0AD\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113106438783400678)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C0AD\C81C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113075476297400656)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\B9BC\CC28\C21C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113082613185400661)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113104698908400677)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C \D589 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113112904555400683)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\D5A5: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113113873395400684)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113076204104400656)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113079439565400658)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\B41C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113112800915400683)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C5D0 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113107622436400679)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113099222250400673)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113112790882400683)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113178717160400731)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\AC74\C774 \B3D9\C77C\D55C \AC15\C870 \D45C\C2DC\AC00 \C874\C7AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113194333941400743)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\BCF5\B41C \D53C\BC97 \C5F4\C774 \C788\C2B5\B2C8\B2E4. \D53C\BC97 \C5F4 \BAA9\B85D\C740 \ACE0\C720\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113194579512400743)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113108753461400680)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C124\C815 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113115303083400685)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113115766049400685)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113170129724400725)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113115673273400685)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113140207454400703)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97 \D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113189710092400739)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113068447325400651)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C8FC\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113190090900400740)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\C740 \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113190272054400740)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF8\BB38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113189991417400739)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113190752670400740)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE48\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113072160656400653)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C\C774 \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D574 \AD6C\C131\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113163626020400720)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C8FC\C18C\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113190317373400740)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \CC38\C870')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113190112047400740)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113164648032400721)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C81C\BAA9\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113189829367400739)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC1B\B294 \C0AC\B78C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113073862148400654)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113115540663400685)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9/\C0AC\C6A9 \C548\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113115087945400685)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113114634307400684)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113115490827400685)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113079315230400658)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \AC12 \C81C\C678')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113116025696400685)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C7A5/\CD95\C18C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113113643051400683)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113098733577400672)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113109697762400680)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113119991614400688)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \D45C\D604\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113216491239400759)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \D45C\D604\C2DD\C774 \B108\BB34 \AE41\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113119844257400688)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113116215127400685)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9\D560 \C5F4\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113099068470400672)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B798\C2DC\BC31')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113113445019400683)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B798\C2DC\BC31 \C9C8\C758\B97C \C0AC\C6A9\D558\BA74 \C774\C804 \C2DC\C810\C5D0 \C874\C7AC\D55C \ADF8\B300\B85C \B370\C774\D130\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113164052974400721)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B798\C2DC\BC31 \AE30\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113165417032400722)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113095163701400670)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D615\C2DD \B9C8\C2A4\D06C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113106312871400678)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113114106422400684)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113189384122400739)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D568\C218/\C5F0\C0B0\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113106097481400678)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D568\C218')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113098571877400672)
,p_name=>'APEXIR_GO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113074351909400655)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B179\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113057685312400643)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113190497566400740)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900 \C5F4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113145047876400707)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900 \C5F4\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113156104602400715)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\BCC4 \ADF8\B8F9\C758 \CD5C\B300 \D589 \C218\B294 \D45C\C2DC\B418\B294 \D589 \C218\AC00 \C544\B2CC \AE30\BCF8 \C9C8\C758\C758 \D589 \C218\B97C \C81C\D55C\D569\B2C8\B2E4. \AE30\BCF8 \C9C8\C758\AC00 \CD5C\B300 \D589 \C218 %0\AC1C\B97C \CD08\ACFC\D569\B2C8\B2E4. \AE30\BCF8 \C9C8\C758\C758 \B808\CF54\B4DC \C218\B97C \C904\C774\B824\BA74 \D544\D130\B97C \C801\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113136718919400701)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C\BCC4 \ADF8\B8F9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113194216174400743)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900 \C815\B82C \C21C\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113079703365400659)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\D3C9 \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113111326721400682)
,p_name=>'APEXIR_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113103192550400676)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B300\D654\C2DD \BCF4\ACE0\C11C\C5D0\C11C\B294 \C77C\BC18 \C0AC\C6A9\C790\AC00 \BCF4\ACE0\C11C\B97C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\B294 \C5F4\C744 \C120\D0DD\D558\ACE0, \D544\D130\B97C \C801\C6A9\D558\ACE0, \AC15\C870 \D45C\C2DC \BC0F \C815\B82C\C744 \C218\D589\D558\C5EC \BCF4\ACE0\C11C \B370\C774\D130\C758 \B808\C774\C544\C6C3\C744 \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\B294 \B610\D55C \C911\B2E8\C810, \C9D1\ACC4, \CC28\D2B8, \ADF8\B8F9 \AE30\C900\C744 \C815\C758\D558\ACE0 \ACE0\C720 \ACC4\C0B0\C744 \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\B294 \C9C0\C815\B41C \AC04\ACA9\C5D0 \B530\B77C \BCF4\ACE0\C11C\C758 HTML \BC84\C804\C744 \C804\C790\BA54\C77C\B85C \BCF4\B0B4\B3C4\B85D \AC00\C785\C744 \C124\C815\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\B294 \BCF4\ACE0\C11C\B97C \C5EC\B7EC \AC00\C9C0 \D615\D0DC\B85C \C0DD\C131\D558\ACE0 \ACF5\C6A9 \B610\B294 \C804\C6A9 \BCF4\AE30')
||unistr('\B97C \C704\D574 \C774\B984\C774 \C9C0\C815\B41C \BCF4\ACE0\C11C\B85C \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4. '),
'<p/>',
unistr('\C774\D6C4 \C139\C158\C5D0\C11C\B294 \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\B294 \BC29\BC95\C744 \C694\C57D\D574\C11C \BCF4\C5EC\C90D\B2C8\B2E4. \C790\C138\D55C \B0B4\C6A9\C740 <i>Oracle Application Express End User''s Guide</i></a>\C5D0\C11C "Using Interactive Reports"\B97C \CC38\C870\D558\C2ED\C2DC\C624.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113110245149400681)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BA54\B274\B294 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C758 [\C2E4\D589] \B2E8\CD94 \C624\B978\CABD\C5D0 \D45C\C2DC\B429\B2C8\B2E4. \C774 \BA54\B274\B97C \C0AC\C6A9\D558\C5EC \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C0AC\C6A9\C790\C815\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113103978512400676)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C9D1\ACC4\B294 \C5F4\C5D0 \B300\D574 \C218\D589\B418\B294 \C218\D559 \ACC4\C0B0\C785\B2C8\B2E4. \C9D1\ACC4\B294 \C815\C758\B41C \C5F4 \B0B4\C5D0\C11C \AC01 \C81C\C5B4 \CC28\B2E8 \B4A4\C640 \BCF4\ACE0\C11C \B05D\C5D0 \D45C\C2DC\B429\B2C8\B2E4. \C635\C158\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<p>',
'</p><ul>',
unistr('<li><strong>\C9D1\ACC4</strong>\B97C \C0AC\C6A9\D558\BA74 \C774\C804\C5D0 \C815\C758\B41C \C9D1\ACC4\B97C '),
unistr('\C120\D0DD\D558\C5EC \D3B8\C9D1\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\D568\C218</strong>\B294 \C218\D589\D560 \D568\C218(\C608: SUM, MIN)\C785\B2C8\B2E4.</li>'),
unistr('<li><strong>\C5F4</strong>\C740 \C218\D559 \D568\C218\B97C \C801\C6A9\D560 \C5F4\C744 \C120\D0DD\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4. '),
unistr('\C22B\C790 \C5F4\B9CC \D45C\C2DC\B429\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113104055833400676)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C800\C7A5\B41C \BCF4\ACE0\C11C\B2F9 \D558\B098\C758 \CC28\D2B8\B97C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4. \CC28\D2B8\AC00'),
unistr('\C815\C758\B418\BA74 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C5D0 \C788\B294 \BCF4\AE30 \C544\C774\CF58\C744 \C0AC\C6A9\D574\C11C \CC28\D2B8 \BCF4\AE30 \B610\B294 \BCF4\ACE0\C11C \BCF4\AE30\B85C \C804\D658\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\C635\C158\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4. '),
'<p>',
'</p><ul>',
unistr('<li><strong>\CC28\D2B8 \C720\D615</strong>\C740 \D3EC\D568\C2DC\D0AC \CC28\D2B8 \C720\D615\C744 \C2DD\BCC4\D569\B2C8\B2E4.'),
unistr('\AC00\B85C \B9C9\B300, \C138\B85C \B9C9\B300, \D30C\C774 \B610\B294 \C120 \C911\C5D0\C11C \C120\D0DD\D558\C2ED\C2DC\C624.</li>'),
unistr('<li><strong>\B808\C774\BE14</strong>\C744 \C0AC\C6A9\D558\BA74 \B808\C774\BE14\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\B808\C774\BE14\C5D0 \B300\D55C \CD95 \C81C\BAA9</strong>\C740 \B808\C774\BE14\C5D0 \B300\D574 \C120\D0DD\D55C \C5F4\ACFC \C5F0\AD00\B41C \CD95\C5D0 \D45C\C2DC\B420 \C81C\BAA9\C785\B2C8\B2E4.'),
unistr('\D30C\C774 \CC28\D2B8\C5D0 \B300\D574\C11C\B294 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\AC12</strong>\C744 \C0AC\C6A9\D558\BA74 \AC12\C73C\B85C \C0AC\C6A9\D560 \C5F4\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4. \D568\C218\AC00 COUNT\C778 \ACBD\C6B0 \AC12\C744'),
unistr('\C120\D0DD\D558\C9C0 \C54A\C544\B3C4 \B429\B2C8\B2E4.</li>'),
unistr('<li><strong>\AC12\C5D0 \B300\D55C \CD95 \C81C\BAA9</strong>\C740 \AC12\C5D0 \B300\D574 \C120\D0DD\B41C \C5F4\ACFC \C5F0\AD00\B41C \CD95\C5D0 \D45C\C2DC\B420 \C81C\BAA9\C785\B2C8\B2E4.'),
unistr('\D30C\C774 \CC28\D2B8\C5D0 \B300\D574\C11C\B294 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\D568\C218</strong>\B294 \AC12\C5D0 \B300\D574 \C120\D0DD\B41C \C5F4\C5D0\C11C \C218\D589\D560 \C120\D0DD\C801 \D568\C218\C785\B2C8\B2E4.</li>'),
unistr('<li><strong>\C815\B82C</strong>\C744 \C0AC\C6A9\D558\BA74 \ACB0\ACFC \C9D1\D569\C744 \C815\B82C\D560 \C218 \C788\C2B5\B2C8\B2E4.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113103399585400676)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C784\C758\C758 \C5F4 \BA38\B9AC\AE00\C744 \B204\B974\BA74 \C5F4 \BA38\B9AC\AE00 \BA54\B274\AC00 \D45C\C2DC\B429\B2C8\B2E4. \C635\C158\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<p></p>',
'<ul>',
unistr('<li><strong>\C624\B984\CC28\C21C \C815\B82C \C544\C774\CF58</strong>\C744 \B204\B974\BA74 \BCF4\ACE0\C11C\AC00 \C5F4\C744 \AE30\C900\C73C\B85C \C624\B984\CC28\C21C\C73C\B85C \C815\B82C\B429\B2C8\B2E4.</li>'),
unistr('<li><strong>\B0B4\B9BC\CC28\C21C \C815\B82C \C544\C774\CF58</strong>\C744 \B204\B974\BA74 \BCF4\ACE0\C11C\AC00 \C5F4\C744 \AE30\C900\C73C\B85C \B0B4\B9BC\CC28\C21C\C73C\B85C \C815\B82C\B429\B2C8\B2E4.</li>'),
unistr('<li><strong>\C5F4 \C228\AE30\AE30</strong>\B97C \B204\B974\BA74 \C5F4\C774 \C228\ACA8\C9D1\B2C8\B2E4. \C77C\BD80 \C5F4\C740 \C228\AE38 \C218 \C5C6\C2B5\B2C8\B2E4. \C5F4\C744 \C228\AE38 \C218 \C5C6\B294 \ACBD\C6B0 \C5F4 \C228\AE30\AE30 \C544\C774\CF58\C774 \D45C\C2DC\B418\C9C0 \C54A\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\AD6C\BD84 \C5F4</strong>\C744 \B204\B974\BA74 \C5F4\C5D0 \AD6C\BD84 \ADF8\B8F9\C774 \C0DD\C131\B429\B2C8\B2E4. \C774\B294 \BCF4\ACE0\C11C\C758 \C5F4\C744 \B9C8\C2A4\D130 \B808\CF54\B4DC\B85C \AC00\C838\C635\B2C8\B2E4.</li>'),
unistr('<li><strong>\C5F4 \C815\BCF4</strong>\B97C \B204\B974\BA74 \C5F4\C5D0 \B300\D55C \B3C4\C6C0\B9D0 \D14D\C2A4\D2B8(\C0AC\C6A9 \AC00\B2A5\D55C \ACBD\C6B0)\AC00 \D45C\C2DC\B429\B2C8\B2E4.</li>'),
unistr('<li><strong>\D14D\C2A4\D2B8 \C601\C5ED</strong>\C740 \B300\C18C\BB38\C790 \AD6C\BD84 \C5C6\C774 \AC80\C0C9 \C870\AC74(\C640\C77C\B4DC \CE74\B4DC \BB38\C790 \D544\C694 \C5C6\C74C)\C744 '),
unistr('\C785\B825\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4. \AC12\C744 \C785\B825\D558\BA74 \BA54\B274 \D558\B2E8\C758 \AC12 \BAA9\B85D\C774 \C904\C5B4\B4ED\B2C8\B2E4. '),
unistr('\ADF8\B7F0 \B2E4\C74C \D558\B2E8\C5D0\C11C \AC12\C744 \C120\D0DD\D560 \C218 \C788\C73C\BA70 \C120\D0DD\D55C \AC12\C740 ''=''\B97C \C0AC\C6A9\D558\B294'),
unistr('\D544\D130(\C608: <code>column = ''ABC''</code>)\B85C \C0DD\C131\B429\B2C8\B2E4. \B610\B294 \D45C\C2DC\B4F1 \C544\C774\CF58\C744 \B204\B97C \C218 \C788\B294\B370, \C774 \ACBD\C6B0 \C785\B825\D55C \AC12\C740 ''LIKE'' \C218\C815\C790\AC00 \C788\B294 '),
unistr('\D544\D130(\C608: <code>column LIKE ''%ABC%''</code>)\B85C \C0DD\C131\B429\B2C8\B2E4.</li>'),
unistr('<li><b>\ACE0\C720 \AC12 \BAA9\B85D</b>\C5D0\B294 \D544\D130\B97C \CDA9\C871\D558\B294 \CC98\C74C 500\AC1C\C758 \ACE0\C720 \AC12\C774 \D3EC\D568\B429\B2C8\B2E4. '),
unistr('\B0A0\C9DC \C5F4\C778 \ACBD\C6B0\C5D0\B294 \B0A0\C9DC \BC94\C704 \BAA9\B85D\C774 \B300\C2E0 \D45C\C2DC\B429\B2C8\B2E4. \AC12\C744 \C120\D0DD\D558\BA74 ''=''\B97C '),
unistr('\C0AC\C6A9\D558\B294 \D544\D130(\C608: <code>column = ''ABC''</code>)\AC00 \C0DD\C131\B429\B2C8\B2E4.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113103804317400676)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\BCF4\ACE0\C11C\C5D0 \ACC4\C0B0\B41C \C5F4\C744 \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774\B7EC\D55C \C5F4\C740 \C0B0\C220 \ACC4\C0B0(\C608: <code>NBR_HOURS/24</code>)\C774\AC70\B098 \AE30\C874 \C5F4\C5D0 \C801\C6A9\B41C \D45C\C900 Oracle \D568\C218\C77C'),
unistr('\C218 \C788\C2B5\B2C8\B2E4. \C77C\BD80\B294 \C608\C81C \BC0F \AE30\D0C0 \D56D\BAA9(\C608: <code>TO_DATE</code>\B97C \C0AC\C6A9\D560 \C218 \C788\C74C)\C73C\B85C \D45C\C2DC\B420 \C218 \C788\C2B5\B2C8\B2E4. \C635\C158\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.'),
'<p></p>',
'<ul>',
unistr('<li><strong>\ACC4\C0B0</strong> - \C774\C804\C5D0 \C815\C758\B41C \ACC4\C0B0\C744 \C120\D0DD\D558\C5EC \D3B8\C9D1\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\C5F4 \C81C\BAA9</strong> - \C0C8 \C5F4\C5D0 \B300\D55C \C5F4 \C81C\BAA9\C785\B2C8\B2E4.</li>'),
unistr('<li><strong>\D615\C2DD \B9C8\C2A4\D06C</strong> - \C5F4\C5D0 \B300\D574 \C801\C6A9\D560 Oracle \D615\C2DD \B9C8\C2A4\D06C\C785\B2C8\B2E4(\C608: S9999).</li>'),
unistr('<li><strong>\ACC4\C0B0</strong> - \C218\D589\D560 \ACC4\C0B0\C785\B2C8\B2E4. \ACC4\C0B0 \B0B4\C5D0\C11C \C5F4\C740 \D45C\C2DC\B41C \BCC4\CE6D\C744 \C0AC\C6A9\D558\C5EC \CC38\C870\B429\B2C8\B2E4.</li>'),
'</ul>',
unistr('<p>\ACC4\C0B0 \C544\B798\C5D0\C11C \C9C8\C758\C5D0 \C788\B294 \C5F4\C740 \D574\B2F9 \C5F0\AD00\B41C \BCC4\CE6D\ACFC \D568\AED8'),
unistr('\D45C\C2DC\B429\B2C8\B2E4. \C5F4 \C774\B984 \B610\B294 \BCC4\CE6D\C744 \B204\B974\BA74 \D574\B2F9 \D56D\BAA9\C774'),
unistr('\ACC4\C0B0\C5D0 \D3EC\D568\B429\B2C8\B2E4. \C5F4 \C606\C5D0\B294 \D0A4\D328\B4DC\AC00 \C788\C2B5\B2C8\B2E4. \C774 \D0A4\D328\B4DC\B294 \C77C\BC18\C801\C73C\B85C'),
unistr('\C0AC\C6A9\B418\B294 \D0A4\C5D0 \B300\D55C \B2E8\CD95\D0A4 \AE30\B2A5\C744 \C218\D589\D569\B2C8\B2E4. \C624\B978\CABD \B05D\C5D0\B294 \D568\C218\AC00 \C788\C2B5\B2C8\B2E4.</p>'),
unistr('<p>\B2E4\C74C \C608\C81C \ACC4\C0B0\C5D0\C11C\B294 \CD1D \BCF4\C0C1\C744 \D45C\C2DC\D558\B294 \BC29\BC95\C744 \BCF4\C5EC \C90D\B2C8\B2E4.</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(\C5EC\AE30\C11C A\B294 ORGANIZATION, B\B294 SALARY, C\B294 COMMISSION\C785\B2C8\B2E4.)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113110323231400681)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B098 \C774\C0C1\C758 \C5F4\C5D0 \AD6C\BD84 \ADF8\B8F9\C744 \C0DD\C131\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4. \C774\B294 \B300\D654\C2DD \BCF4\ACE0\C11C\C758 \C5F4\C744 \AC00\C838\C640\C11C \B9C8\C2A4\D130 \B808\CF54\B4DC\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113104575860400677)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D55C \BC88\C5D0 \B2E8\C77C \D589\C758 \C138\BD80\C815\BCF4\B97C \BCF4\B824\BA74 \D655\C778\D558\B824\B294 \D589\C5D0\C11C \B2E8\C77C \D589 \BCF4\AE30 \C544\C774\CF58\C744 \B204\B974\C2ED\C2DC\C624. \C0AC\C6A9 \AC00\B2A5\D55C \ACBD\C6B0 \B2E8\C77C \D589 \BCF4\AE30\B294 \D56D\C0C1 \CCAB\BC88\C9F8 \C5F4\C785\B2C8\B2E4. \B300\D654\C2DD \BCF4\ACE0\C11C\C758 \C0AC\C6A9\C790\C815\C758\C5D0 \B530\B77C \B2E8\C77C \D589 \BCF4\AE30\B294 \D45C\C900 \BCF4\AE30\AC00 \B418\AC70\B098 \C5C5\B370\C774\D2B8\B97C \D5C8\C6A9\D558\B294 \C0AC\C6A9\C790\C815\C758 \D398\C774\C9C0\AC00 \B420 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113104486346400677)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D604\C7AC \ACB0\ACFC \C9D1\D569\C744 \B2E4\C6B4\B85C\B4DC\D560 \C218 \C788\C2B5\B2C8\B2E4. \B2E4\C6B4\B85C\B4DC \D615\C2DD\C740 \C124\CE58 \BC0F '),
unistr('\BCF4\ACE0\C11C \C815\C758\C5D0 \B530\B77C \B2E4\B974\C9C0\B9CC CSV, HTML, Email, XLS, PDF \B610\B294 RTF '),
unistr('\B4F1\C77C \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113103593509400676)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C9C8\C758\C5D0 <code>WHERE</code> \C808\C744 \CD94\AC00\D558\AC70\B098 \C218\C815\D558\C5EC \BCF4\ACE0\C11C\C5D0 \D3EC\CEE4\C2A4\B97C \C124\C815\D569\B2C8\B2E4. \D55C \C5F4\C5D0\C11C \B610\B294 \D589\C744 \AE30\C900\C73C\B85C \D544\D130\B9C1\D560 \C218 \C788\C2B5\B2C8\B2E4.  '),
unistr('<p>\C5F4\C744 \AE30\C900\C73C\B85C \D544\D130\B9C1\D560 \ACBD\C6B0\C5D0\B294 \C5F4(\D45C\C2DC\B41C \C5F4\C77C \D544\C694\B294'),
unistr('\C5C6\C74C)\C744 \C120\D0DD\D558\ACE0, \D45C\C900 Oracle \C5F0\C0B0\C790(=, !=, \B2E4\C74C\C5D0 \C18D\D558\C9C0 \C54A\C74C, \B2E4\C74C \C0AC\C774)\B97C \C120\D0DD\D558\ACE0 \BE44\AD50\D560 \D45C\D604\C2DD\C744 \C785\B825\D558\C2ED\C2DC\C624. \D45C\D604\C2DD\C740 \B300\C18C\BB38\C790\B97C \AD6C\BD84\D569\B2C8\B2E4. %\B97C \C640\C77C\B4DC \CE74\B4DC \BB38\C790\B85C \C0AC\C6A9\D558\C2ED\C2DC\C624(\C608: <code>STATE_NAME'),
'like A%)</code>.</p>',
unistr('<p>\D589\C744 \AE30\C900\C73C\B85C \D544\D130\B9C1\D560 \ACBD\C6B0\C5D0\B294 \C5F4 \BCC4\CE6D \BC0F \C784\C758\C758 Oracle \D568\C218 \B610\B294 \C5F0\C0B0\C790\B97C'),
unistr('\C0AC\C6A9\D558\C5EC \BCF5\C7A1\D55C <code>WHERE</code> \C808\C744 \C0DD\C131\D560 \C218 \C788\C2B5\B2C8\B2E4(\C608: <code>G = ''VA'' or G = ''CT''</code>, \C5EC\AE30\C11C'),
unistr('<code>G</code>\B294 <code>CUSTOMER_STATE</code>\C5D0 \B300\D55C \BCC4\CE6D).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113104140555400676)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D50C\B798\C2DC\BC31 \C9C8\C758\B97C \C0AC\C6A9\D558\BA74 \C774\C804 \C2DC\C810\C5D0 \C874\C7AC\D55C \ADF8\B300\B85C \B370\C774\D130\B97C \BCFC \C218 \C788\C2B5\B2C8\B2E4. '),
unistr('\D50C\B798\C2DC\BC31\D560 \C218 \C788\B294 \C2DC\AC04\C758 \AE30\BCF8 \C591\C740 3\C2DC\AC04(\B610\B294 180\BD84)\C774\C9C0\B9CC \C2E4\C81C \C591\C740 \AC01 '),
unistr('\B370\C774\D130\BCA0\C774\C2A4\C5D0 \B530\B77C \B2E4\B985\B2C8\B2E4.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113165358095400722)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D615\C2DD\C744 \C0AC\C6A9\D558\BA74 \BCF4\ACE0\C11C\C758 \D45C\C2DC\B97C \C0AC\C6A9\C790\AC00 \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
unistr('\D615\C2DD\C5D0\B294 \B2E4\C74C\ACFC \AC19\C740 \D558\C704 \BA54\B274\AC00 \D3EC\D568\B429\B2C8\B2E4.</p>'),
unistr('<ul><li>\C815\B82C</li>'),
unistr('<li>\C81C\C5B4 \CC28\B2E8</li>'),
unistr('<li>\AC15\C870 \D45C\C2DC</li>'),
unistr('<li>\ACC4\C0B0</li>'),
unistr('<li>\C9D1\ACC4</li>'),
unistr('<li>\CC28\D2B8</li>'),
unistr('<li>\ADF8\B8F9 \AE30\C900</li>'),
unistr('<li>\D53C\BC97</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113163565229400720)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C800\C7A5\B41C \BCF4\ACE0\C11C\B2F9 \D558\B098\C758 \ADF8\B8F9 \AE30\C900 \BCF4\AE30\B97C \C815\C758\D560 \C218'),
unistr('\C788\C2B5\B2C8\B2E4. \C815\C758\D55C \B2E4\C74C\C5D0\B294 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C5D0\C11C \BCF4\AE30 \C544\C774\CF58\C744 \C0AC\C6A9\D558\C5EC'),
unistr('\ADF8\B8F9 \AE30\C900 \B610\B294 \BCF4\ACE0\C11C \BCF4\AE30\B85C \C804\D658\D560 \C218 \C788\C2B5\B2C8\B2E4. \ADF8\B8F9 \AE30\C900 \BCF4\AE30\B97C \C0DD\C131\D558\B824\BA74'),
unistr('\B2E4\C74C\C744 \C120\D0DD\D569\B2C8\B2E4.'),
'<p></p><ul>',
unistr('<li>\ADF8\B8F9\D654\D560 \C5F4</li>'),
unistr('<li>\C218\D589\D560 \D568\C218\C640 \D568\AED8 \C9D1\ACC4\D560 \C5F4(\D3C9\ADE0, \D569\ACC4, \AC1C\C218 \B4F1)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113103700913400676)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\D544\D130\B97C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4. \D544\D130 \C870\AC74 \D45C\C2DC\B97C \CDA9\C871\D558\B294 \D589\C740 \D544\D130\C640 \C5F0\AD00\B41C \D2B9\C131\C744 \C0AC\C6A9\D558\C5EC \AC15\C870 \D45C\C2DC\B429\B2C8\B2E4. \C635\C158\C740 \B2E4\C74C\ACFC \AC19\C2B5\B2C8\B2E4.</p>'),
'<ul>',
unistr('<li><strong>\C774\B984</strong>\C740 \D45C\C2DC\C5D0\B9CC \C0AC\C6A9\B429\B2C8\B2E4.</li>'),
unistr('<li><strong>\C2DC\D000\C2A4</strong>\B294 \ADDC\CE59 \D3C9\AC00 \C21C\C11C\B97C \C2DD\BCC4\D569\B2C8\B2E4.</li>'),
unistr('<li><strong>\C0AC\C6A9\C73C\B85C \C124\C815\B428</strong>\C740 \ADDC\CE59\C774 \C0AC\C6A9\C73C\B85C \C124\C815\B418\C5C8\B294\C9C0 \B610\B294 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B418\C5C8\B294\C9C0 \C2DD\BCC4\D569\B2C8\B2E4.</li>'),
unistr('<li><strong>\AC15\C870 \D45C\C2DC \C720\D615</strong>\C740 \D589 \B610\B294 \C140\C774 \AC15\C870 \D45C\C2DC\B418\B294\C9C0 \C5EC\BD80\B97C '),
unistr('\C2DD\BCC4\D569\B2C8\B2E4. \C140\C774 \C120\D0DD\B41C \ACBD\C6B0 \AC15\C870 \D45C\C2DC \C870\AC74\C5D0\C11C \CC38\C870\B41C '),
unistr('\C5F4\C774 \AC15\C870 \D45C\C2DC\B429\B2C8\B2E4.</li>'),
unistr('<li><strong>\BC30\ACBD\C0C9</strong>\C740 \AC15\C870 \D45C\C2DC\B41C \C601\C5ED\C758 \C0C8 \BC30\ACBD\C0C9\C785\B2C8\B2E4.</li>'),
unistr('<li><strong>\D14D\C2A4\D2B8 \C0C9\C0C1</strong>\C740 \AC15\C870 \D45C\C2DC\B41C \C601\C5ED\C758 \C0C8 \D14D\C2A4\D2B8 \C0C9\C0C1\C785\B2C8\B2E4.</li>'),
unistr('<li><strong>\AC15\C870 \D45C\C2DC \C870\AC74</strong>\C740 \D544\D130 \C870\AC74\C744 \C815\C758\D569\B2C8\B2E4.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113041356247400631)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C800\C7A5\B41C \BCF4\ACE0\C11C\B2F9 \D558\B098\C758 \D53C\BC97 \BCF4\AE30\B97C \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4. \C815\C758\B41C \D6C4\C5D0\B294 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C5D0 \C788\B294 \BCF4\AE30 \C544\C774\CF58\C744 \C0AC\C6A9\D574\C11C \D53C\BC97 \BCF4\AE30 \B610\B294 \BCF4\ACE0\C11C \BCF4\AE30\B85C \C804\D658\D560 \C218 \C788\C2B5\B2C8\B2E4. \D53C\BC97 \BCF4\AE30\B97C \C0DD\C131\D558\B824\BA74 \B2E4\C74C\C744 \C120\D0DD\D569\B2C8\B2E4. '),
'<p></p>',
'<ul>',
unistr('<li>\D53C\BC97\D560 \C5F4</li>'),
unistr('<li>\D589\C73C\B85C \D45C\C2DC\D560 \C5F4</li>'),
unistr('<li>\C218\D589\D560 \D568\C218\C640 \D568\AED8 \C9D1\ACC4\D560 \C5F4(\D3C9\ADE0, \D569\ACC4, \AC1C\C218 \B4F1)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113114845765400684)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C0AC\C6A9\C790\AC00 \C815\C758\D560 \ACBD\C6B0 \BCF4\ACE0\C11C \C124\C815\C774 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C'),
unistr('\C544\B798 \BC0F \BCF4\ACE0\C11C \C704\C5D0 \D45C\C2DC\B429\B2C8\B2E4. \C774 \C601\C5ED\C740 \C67C\CABD\C5D0 \C788\B294 \C544\C774\CF58\C744 \C0AC\C6A9\D558\C5EC \CD95\C18C \BC0F \D655\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'<p>',
unistr('\AC01 \BCF4\ACE0\C11C \C124\C815\C5D0\C11C\B294 \B2E4\C74C\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'</p><ul>',
unistr('<li>\C774\B984\C744 \B20C\B7EC \C124\C815\C744 \D3B8\C9D1\D569\B2C8\B2E4.</li>'),
unistr('<li>[\C0AC\C6A9/\C0AC\C6A9 \C548\D568] \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D558\AC70\B098 \C120\D0DD\C744 \CDE8\C18C\D558\C5EC \C124\C815\C744 \C0AC\C6A9/\C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\D569\B2C8\B2E4. \C774 \CF58\D2B8\B864\C744 \C0AC\C6A9\D558\C5EC \C124\C815\C744 \C77C\C2DC\C801\C73C\B85C \C124\C815\D558\AC70\B098 \D574\C81C\D569\B2C8\B2E4.</li>'),
unistr('<li>[\C81C\AC70] \C544\C774\CF58\C744 \B20C\B7EC \C124\C815\C744 \C81C\AC70\D569\B2C8\B2E4.</li>'),
'</ul>',
unistr('<p>\CC28\D2B8, \ADF8\B8F9 \AE30\C900 \B610\B294 \D53C\BC97\C744 \C0DD\C131\D55C \ACBD\C6B0 \C624\B978\CABD\C5D0 \D45C\C2DC\B41C [\BCF4\ACE0\C11C \BCF4\AE30],'),
unistr('[\CC28\D2B8 \BCF4\AE30], [\ADF8\B8F9 \AE30\C900 \BCF4\AE30] \BC0F [\D53C\BC97 \BCF4\AE30]\B97C \C0AC\C6A9\D558\C5EC \C774\B7EC\D55C \D56D\BAA9\ACFC \AE30\C900 \BCF4\ACE0\C11C'),
unistr('\C0AC\C774\B97C \D1A0\AE00\D560 \C218 \C788\C2B5\B2C8\B2E4. \CC28\D2B8, \ADF8\B8F9 \AE30\C900 \B610\B294 \D53C\BC97\C774 \D45C\C2DC\B41C \C0C1\D0DC\C5D0\C11C [\D3B8\C9D1]'),
unistr('\B9C1\D06C\B97C \C0AC\C6A9\D558\C5EC \C124\C815\C744 \D3B8\C9D1\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113104316141400677)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \B2E4\C2DC \C7AC\C124\C815\D558\C5EC \C0AC\C6A9\C790\AC00 \C815\C758\D55C \C0AC\D56D\C744 \BAA8\B450 \C81C\AC70\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113165607514400722)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\BCC4\B85C \D45C\C2DC\D560 \B808\CF54\B4DC \C218\B97C \C124\C815\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113104270002400676)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774\D6C4 \C0AC\C6A9\C744 \C704\D574 \C0AC\C6A9\C790\C815\C758\B41C \BCF4\ACE0\C11C\B97C \C800\C7A5\D569\B2C8\B2E4. \C774\B984 \BC0F \C120\D0DD\C801\C778 \C124\BA85\C744 \C81C\ACF5\D558\ACE0 \BCF4\ACE0\C11C\B97C \C77C\BC18\C5D0 \C561\C138\C2A4\D560 \C218 \C788\B3C4\B85D \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \C989, \BAA8\B4E0 \C0AC\C6A9\C790\AC00 \AE30\BCF8 \BCF4\ACE0\C11C\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4. \B2E4\C74C \B124 \AC00\C9C0 \C720\D615\C758 \B300\D654\C2DD \BCF4\ACE0\C11C\B97C \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<ul>',
unistr('<li><strong>\AE30\BCF8</strong>(\AC1C\BC1C\C790 \C804\C6A9). \AE30\BCF8\C740 \CC98\C74C\C5D0 \D45C\C2DC\B418\B294 \BCF4\ACE0\C11C\C785\B2C8\B2E4. \AE30\BCF8 \BCF4\ACE0\C11C\B294 \C774\B984\C744 \BC14\AFB8\AC70\B098 \C0AD\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\B300\CCB4 \BCF4\ACE0\C11C</strong>(\AC1C\BC1C\C790 \C804\C6A9). \AC1C\BC1C\C790\AC00 \C5EC\B7EC \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C744 \C0DD\C131\D560 \C218 \C788\C2B5\B2C8\B2E4. \AC1C\BC1C\C790\B9CC \B300\CCB4 \BCF4\ACE0\C11C\B97C \C800\C7A5, \C774\B984 \BC14\AFB8\AE30 \B610\B294 \C0AD\C81C\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\ACF5\C6A9 \BCF4\ACE0\C11C</strong>(\C77C\BC18 \C0AC\C6A9\C790). \BCF4\ACE0\C11C\B97C \C0DD\C131\D55C \C77C\BC18 \C0AC\C6A9\C790\AC00 \C800\C7A5, \C774\B984 \BC14\AFB8\AE30 \B610\B294 \C0AD\C81C\D560 \C218 \C788\C2B5\B2C8\B2E4. \B2E4\B978 \C0AC\C6A9\C790\B294 \B808\C774\C544\C6C3\C744 \BCF4\ACE0 \B2E4\B978 \BCF4\ACE0\C11C\B85C \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\C804\C6A9 \BCF4\ACE0\C11C</strong>(\C77C\BC18 \C0AC\C6A9\C790). \BCF4\ACE0\C11C\B97C \C0DD\C131\D55C \C77C\BC18 \C0AC\C6A9\C790\B9CC \BCF4\ACE0\C11C\B97C \BCF4\ACE0, \C800\C7A5, \C774\B984 \BC14\AFB8\AE30 \B610\B294 \C0AD\C81C\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
'</ul>',
unistr('<p>\C0AC\C6A9\C790\C815\C758\B41C \BCF4\ACE0\C11C\B97C \C800\C7A5\D55C \ACBD\C6B0 \BCF4\ACE0\C11C \C120\D0DD\AE30\B294 \D589 \C120\D0DD\AE30(\C774 \AE30\B2A5\C774 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0) \D589 \C120\D0DD\AE30\C758 \C67C\CABD\C5D0 \C788\B294 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113103205970400676)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC01 \BCF4\ACE0\C11C \D398\C774\C9C0\C758 \C0C1\B2E8\C5D0\B294 \AC80\C0C9 \C601\C5ED\C774 \C788\C2B5\B2C8\B2E4. \C774 \C601\C5ED(\B610\B294 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C)\C5D0\C11C\B294 \B2E4\C74C\ACFC \AC19\C740 \AE30\B2A5\C774 \C81C\ACF5\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113166214301400722)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('<li><strong>\C791\C5C5 \BA54\B274</strong>\B97C \C0AC\C6A9\D558\BA74 \BCF4\ACE0\C11C\B97C \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4. \C774\D6C4 \D45C\C2DC\B418\B294 \C139\C158\C744 \CC38\C870\D558\C2ED\C2DC\C624.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113165756231400722)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'ko'
,p_message_text=>unistr('<li><strong>\C5F4 \C120\D0DD \C544\C774\CF58</strong>\C744 \C0AC\C6A9\D558\BA74 \AC80\C0C9\D560 \C5F4 \B610\B294 \BAA8\B4E0 \C5F4\C744 \C2DD\BCC4\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113166030333400722)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'ko'
,p_message_text=>unistr('<li><strong>\BCF4\ACE0\C11C</strong>\B294 \B300\CCB4 \AE30\BCF8\AC12 \BC0F \C800\C7A5\B41C \C804\C6A9 \B610\B294 \ACF5\C6A9 \BCF4\ACE0\C11C\B97C \D45C\C2DC\D569\B2C8\B2E4.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113165984266400722)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('<li><strong>\D589</strong>\C740 \D398\C774\C9C0\B2F9 \D45C\C2DC\D560 \B808\CF54\B4DC \C218\B97C \C124\C815\D569\B2C8\B2E4.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113165842800400722)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>\D14D\C2A4\D2B8 \C601\C5ED</strong>\C744 \C0AC\C6A9\D558\BA74 \B300\C18C\BB38\C790\B97C \AD6C\BD84\D558\C9C0 \C54A\B294 \AC80\C0C9 \C870\AC74(\C640\C77C\B4DC \CE74\B4DC \BB38\C790 \C0AC\C6A9)\C744 \C785\B825\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\C2E4\D589 \B2E8\CD94</strong> - \AC80\C0C9\C744 \C2E4\D589\D569\B2C8\B2E4. Enter \D0A4\B97C \B204\B974\BA74 \CEE4\C11C\AC00 \AC80\C0C9 \D14C\C2A4\D2B8 \C601\C5ED \C548\C5D0 \C788\C744 \ACBD\C6B0 \AC80\C0C9\C774 \C2E4\D589\B429\B2C8\B2E4.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113166124992400722)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('<li><strong>\BCF4\AE30 \C544\C774\CF58</strong>\C740 \C544\C774\CF58, \BCF4\ACE0\C11C, \C138\BD80\C815\BCF4, \CC28\D2B8, \ADF8\B8F9 \AE30\C900 \BC0F \BCF4\ACE0\C11C\C758 \D53C\BC97 \BCF4\AE30(\C815\C758\B41C \ACBD\C6B0)\B85C \C804\D658\B429\B2C8\B2E4.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113182134080400734)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('<li><strong>\AD00\B9AC</strong>\C5D0\C11C\B294 \C18D\C131, \C5F4, \D589\C744 \AD00\B9AC\D558\ACE0 \BCF4\ACE0\C11C \B610\B294 \B370\C774\D130 \ADF8\B9AC\B4DC\C5D0 \B300\D55C \B0B4\C5ED\C744 \BCFC \C218 \C788\C2B5\B2C8\B2E4.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113103467886400676)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\B41C \C5F4\C744 \C218\C815\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4. \C624\B978\CABD\C5D0 \C788\B294 \C5F4\C740 \D45C\C2DC\B429\B2C8\B2E4. \C67C\CABD\C5D0 \C788\B294 \C5F4\C740 \C228\ACA8\C9D1\B2C8\B2E4. \B9E8 \C624\B978\CABD\C5D0 \C788\B294 \D654\C0B4\D45C\B97C \C0AC\C6A9\D558\C5EC \D45C\C2DC\B41C \C5F4\C744 \C7AC\C815\B82C\D560 \C218 \C788\C2B5\B2C8\B2E4. \ACC4\C0B0\B41C \C5F4 \C55E\C5D0\B294 <strong>**</strong>\AC00 \BD99\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113103671551400676)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C815\B82C\D560 \C5F4\C744 \BCC0\ACBD\D558\B294 \B370 \C0AC\C6A9\B418\BA70, \C624\B984\CC28\C21C \B610\B294 \B0B4\B9BC\CC28\C21C\C73C\B85C'),
unistr('\C815\B82C\D560\C9C0\B97C \ACB0\C815\D569\B2C8\B2E4. \B610\D55C <code>NULL</code>\C758 \CC98\B9AC \BC29\BC95\B3C4'),
unistr('\C9C0\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \AE30\BCF8 \C124\C815\C740 \D56D\C0C1 <code>NULL</code>\C744 \B9C8\C9C0\B9C9\C73C\B85C \D45C\C2DC\D558\AC70\B098 \BA3C\C800 \D45C\C2DC\D569\B2C8\B2E4. \ACB0\ACFC \C815\B82C\C740 \BCF4\ACE0\C11C\C5D0\C11C \C5F4 \C81C\BAA9 \C624\B978\CABD\C5D0'),
unistr('\D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113163369320400720)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C785\C744 \CD94\AC00\D560 \ACBD\C6B0 \C804\C790\BA54\C77C \C8FC\C18C(\B610\B294 \CF64\B9C8\B85C \AD6C\BD84\B41C \C5EC\B7EC \C804\C790\BA54\C77C \C8FC\C18C), \C804\C790\BA54\C77C \C81C\BAA9, \BE48\B3C4 \BC0F \C2DC\C791/\C885\B8CC \B0A0\C9DC\B97C \C81C\ACF5\D558\C2ED\C2DC\C624. \ACB0\ACFC \C804\C790\BA54\C77C\C740 \AC00\C785\C744 \CD94\AC00\D560 \B54C \C81C\ACF5\B41C \BCF4\ACE0\C11C \C124\C815\C744 \C0AC\C6A9\D558\C5EC \D604\C7AC \B370\C774\D130\B97C \D3EC\D568\D558\B294 \B300\D654\C2DD \BCF4\ACE0\C11C\C758 HTML \BC84\C804\C744 \D3EC\D568\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113181972982400734)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B370\C774\D130 \ADF8\B9AC\B4DC\B294 \AE30\BCF8\C801\C73C\B85C \D3B8\C9D1 \AC00\B2A5\D55C \BCF4\ACE0\C11C\B85C \C0AC\C6A9\C790\C815\C758 \C131\B2A5\C774 \B6F0\C5B4\B0A9\B2C8\B2E4. \C0AC\C6A9\C790\B294 \C5F4\C744 \C120\D0DD\D558\ACE0, \D544\D130\B97C \C801\C6A9\D558\ACE0, \AC15\C870 \D45C\C2DC \BC0F \C815\B82C\D558\C5EC \BCF4\ACE0\C11C \B370\C774\D130\C758 \B808\C774\C544\C6C3\C744 \BCC0\ACBD\D560 \C218 \C788\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\B294 \B610\D55C \C911\B2E8\C810, \C9D1\ACC4, \CC28\D2B8, \ADF8\B8F9 \AE30\C900\C744 \C815\C758\D558\ACE0 \ACE0\C720 \ACC4\C0B0\C744 \CD94\AC00\D560 \C218 \C788\C2B5\B2C8\B2E4. \C0AC\C6A9\C790\B294 \BCF4\ACE0\C11C\C758 \C5EC\B7EC \AC00\C9C0 \D615\D0DC\B85C \C0DD\C131\D558\ACE0 \C804\C6A9 \BCF4\AE30\B97C \C704\D574 \C774\B984\C774 \C9C0\C815\B41C \BCF4\ACE0\C11C\B85C \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4. '),
'<p/>',
unistr('\B370\C774\D130 \ADF8\B9AC\B4DC\B294 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C, \C791\C5C5 \BA54\B274, \AD00\B9AC \BA54\B274 \B610\B294 \C5F4 \C81C\BAA9 \BA54\B274\B97C \C0AC\C6A9\D558\C5EC \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C788\C2B5\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113193709442400742)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BA54\B274\B294 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C758 [\C2E4\D589] \B2E8\CD94 \C624\B978\CABD\C5D0 \D45C\C2DC\B429\B2C8\B2E4. \C774 \BA54\B274\B97C \C0AC\C6A9\D558\C5EC \B370\C774\D130 \ADF8\B9AC\B4DC \BCF4\ACE0\C11C\B97C \C0AC\C6A9\C790\C815\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113182443652400734)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \D398\C774\C9C0 \CD94\AC00/\D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113182586195400734)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\B370\C774\D130 \ADF8\B9AC\B4DC\C5D0 \D589\C744 \CD94\AC00\D558\B824\BA74 [\D589 \CD94\AC00]\B97C \B204\B974\C2ED\C2DC\C624. \D589\C758 \C138\BD80\C815\BCF4\B97C \D3B8\C9D1\D558\B824\BA74 \D3B8\C9D1\D558\B824\B294 \D589\C5D0\C11C \D589 \D3B8\C9D1 \C544\C774\CF58(\CCAB\BC88\C9F8 \C5F4)\C744 \B204\B974\C2ED\C2DC\C624. \B370\C774\D130 \ADF8\B9AC\B4DC\C758 \C5F4\C774 \D45C\C2DC\B41C [\D589 \CD94\AC00/\D3B8\C9D1] \D398\C774\C9C0\AC00 \D45C\C2DC\B429\B2C8\B2E4. </p>'),
'',
unistr('<p>\D589\C744 \D3B8\C9D1\D560 \B54C\B294 \B2E4\C74C\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'',
'<p><ul>',
unistr('<li>\D589\C744 <strong>\C0AD\C81C</strong>\D569\B2C8\B2E4.</li>'),
unistr('<li>\D589\C5D0\C11C \C218\D589\D55C \BCC0\ACBD\C0AC\D56D\C744 \C800\C7A5\D558\B3C4\B85D <strong>\BCC0\ACBD\C0AC\D56D\C744 \C801\C6A9</strong>\D569\B2C8\B2E4.</li>'),
unistr('<li><strong>\C791\C5C5</strong> \B0B4\C5D0\C11C \D589 \CD94\AC00, \D30C\C77C, \BA54\BAA8, \B9C1\D06C \B610\B294 \D0DC\ADF8 \CD94\AC00 \BC0F \B0B4\C5ED \AC80\D1A0\B97C \C218\D589\D569\B2C8\B2E4.</li>'),
unistr('<li><strong>\B2E4\C74C \BC0F \C774\C804</strong> \D589\C73C\B85C \C774\B3D9\D569\B2C8\B2E4.</li>'),
unistr('<li><strong>\AD00\B9AC</strong> \B0B4\C5D0\C11C \C5F4 \C18D\C131, \C5F4 \ADF8\B8F9, \AC80\C99D \BC0F \AC12 \BAA9\B85D\C744 \C124\C815\D569\B2C8\B2E4.</li>'),
'</ul></p>',
'',
unistr('<p>\D398\C774\C9C0 \C544\B798\C5D0 \C8FC\C11D \C601\C5ED\C5D0\B294 \D604\C7AC \D589\ACFC \C5F0\AD00\B41C \BAA8\B4E0 \D30C\C77C, \BA54\BAA8, \B9C1\D06C \B610\B294 \D0DC\ADF8\AC00 \D45C\C2DC\B429\B2C8\B2E4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113193863626400742)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\B098 \C774\C0C1\C758 \C5F4\C5D0 \AD6C\BD84 \ADF8\B8F9\C744 \C0DD\C131\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4. \C774\B294 \B370\C774\D130 \ADF8\B9AC\B4DC\C758 \C5F4\C744 \AC00\C838\C640\C11C \B9C8\C2A4\D130 \B808\CF54\B4DC\B85C \D45C\C2DC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113182362509400734)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\D604\C7AC \ACB0\ACFC \C9D1\D569\C744 \B2E4\C6B4\B85C\B4DC\D560 \C218 \C788\C2B5\B2C8\B2E4. \B2E4\C6B4\B85C\B4DC \D615\C2DD\C5D0\B294'),
unistr('CSV, HTML \B610\B294 \C804\C790\BA54\C77C\C774 \D3EC\D568\B429\B2C8\B2E4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113193984929400742)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\B370\C774\D130 \ADF8\B9AC\B4DC \BCF4\ACE0\C11C\B97C \C0AC\C6A9\C790\AC00 \C815\C758\D560 \ACBD\C6B0 \BCF4\ACE0\C11C \C124\C815\C774 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C'),
unistr('\C544\B798 \BC0F \BCF4\ACE0\C11C \C704\C5D0 \D45C\C2DC\B429\B2C8\B2E4. \C774 \C601\C5ED\C740 \C67C\CABD\C5D0 \C788\B294 \C544\C774\CF58\C744 \C0AC\C6A9\D558\C5EC \CD95\C18C \BC0F \D655\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'<p>',
unistr('\AC01 \BCF4\ACE0\C11C \C124\C815\C5D0\C11C\B294 \B2E4\C74C\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.'),
'</p><ul>',
unistr('<li>\C774\B984\C744 \B20C\B7EC \C124\C815\C744 \D3B8\C9D1\D569\B2C8\B2E4.</li>'),
unistr('<li>[\C0AC\C6A9/\C0AC\C6A9 \C548\D568] \D655\C778\B780\C744 \C120\D0DD\D558\AC70\B098 \C120\D0DD\C744 \CDE8\C18C\D558\C5EC \C124\C815\C744 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815/\C0AC\C6A9\C73C\B85C \C124\C815\D569\B2C8\B2E4. \C774 \CF58\D2B8\B864\C744 \C0AC\C6A9\D558\C5EC \C124\C815\C744 \C77C\C2DC\C801\C73C\B85C \C124\C815\D558\AC70\B098 \D574\C81C\D569\B2C8\B2E4.</li>'),
unistr('<li>[\C81C\AC70] \C544\C774\CF58\C744 \B20C\B7EC \C124\C815\C744 \C81C\AC70\D569\B2C8\B2E4.</li>'),
'</ul>',
unistr('<p>\CC28\D2B8 \B610\B294 \ADF8\B8F9 \AE30\C900\C744 \C0DD\C131\D55C \ACBD\C6B0 \C624\B978\CABD\C5D0 \D45C\C2DC\B41C [\BCF4\ACE0\C11C \BCF4\AE30],'),
unistr('[\CC28\D2B8 \BCF4\AE30], [\ADF8\B8F9 \AE30\C900 \BCF4\AE30] \B9C1\D06C\B97C \C0AC\C6A9\D558\C5EC \CC28\D2B8 \B610\B294 \ADF8\B8F9 \AE30\C900\ACFC \AE30\C900 \BCF4\ACE0\C11C'),
unistr('\C0AC\C774\B97C \D1A0\AE00\D560 \C218 \C788\C2B5\B2C8\B2E4. \CC28\D2B8 \B610\B294 \ADF8\B8F9 \AE30\C900\C774 \D45C\C2DC\B41C \C0C1\D0DC\C5D0\C11C [\D3B8\C9D1]'),
unistr('\B9C1\D06C\B97C \C0AC\C6A9\D558\C5EC \C124\C815\C744 \D3B8\C9D1\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113182291567400734)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C774\D6C4 \C0AC\C6A9\C744 \C704\D574 \C0AC\C6A9\C790\C815\C758\B41C \B370\C774\D130 \ADF8\B9AC\B4DC \BCF4\ACE0\C11C\B97C \C800\C7A5\D569\B2C8\B2E4. \C774\B984 \BC0F \C120\D0DD\C801 \C124\BA85\C744 \C81C\ACF5\D569\B2C8\B2E4. \B2E4\C74C \C138 \AC00\C9C0 \C720\D615\C758 \B370\C774\D130 \ADF8\B9AC\B4DC \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C744 \C800\C7A5\D560 \C218 \C788\C2B5\B2C8\B2E4.</p>'),
'<ul>',
unistr('<li><strong>\AE30\BCF8</strong>(\AD00\B9AC\C790 \C804\C6A9). \AE30\BCF8\C740 \CC98\C74C\C5D0 \D45C\C2DC\B418\B294 \B808\C774\C544\C6C3\C785\B2C8\B2E4. \AE30\BCF8 \BCF4\ACE0\C11C\B294 \C774\B984\C744 \BC14\AFB8\AC70\B098 \C0AD\C81C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\B300\CCB4 \BCF4\ACE0\C11C</strong>(\AD00\B9AC\C790 \C804\C6A9). \AD00\B9AC\C790\AC00 \C5EC\B7EC \BCF4\ACE0\C11C \B808\C774\C544\C6C3\C744 \C0DD\C131\D560 \C218 \C788\C2B5\B2C8\B2E4. \AD00\B9AC\C790\B9CC \B300\CCB4 \BCF4\ACE0\C11C\B97C \C800\C7A5, \C774\B984 \BC14\AFB8\AE30 \B610\B294 \C0AD\C81C\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('<li><strong>\C804\C6A9 \BCF4\ACE0\C11C</strong>(\BAA8\B4E0 \C0AC\C6A9\C790). \BCF4\ACE0\C11C\B97C \C0DD\C131\D55C \C0AC\C6A9\C790\AC00 \BCF4\ACE0\C11C\B97C \BCF4\ACE0, \C800\C7A5, \C774\B984 \BC14\AFB8\AE30 \B610\B294 \C0AD\C81C\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
'</ul>',
unistr('<p>\C0AC\C6A9\C790\C815\C758\B41C \BCF4\ACE0\C11C\B97C \C800\C7A5\D55C \ACBD\C6B0 \BCF4\ACE0\C11C \C120\D0DD\AE30\B294 \D589 \C120\D0DD\AE30(\C774 \AE30\B2A5\C774 \C0AC\C6A9\C73C\B85C \C124\C815\B41C \ACBD\C6B0) \D589 \C120\D0DD\AE30\C758 \C67C\CABD\C5D0 \C788\B294 \AC80\C0C9 \B3C4\AD6C \BAA8\C74C\C5D0 \D45C\C2DC\B429\B2C8\B2E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113108337317400679)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C228\AE30\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113098986035400672)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113109872517400681)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113114960091400684)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC \C870\AC74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113163954445400720)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC \C2A4\D0C0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113073960839400654)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113183448647400735)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113213062434400756)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('1\AC1C \BE44\D65C\C131 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113213170084400757)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C \BE44\D65C\C131 \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113104958723400677)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C \B3C4\C6C0\B9D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113115922218400685)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113109317811400680)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C0B0 \D45C\D604\C2DD\C774 \BD80\C801\D569\D569\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113068734739400651)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC \B0A0\C9DC\B294 \C2DC\C791 \B0A0\C9DC \C774\D6C4\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113123609552400691)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \D544\D130 \D45C\D604\C2DD\C785\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113191486798400741)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \D544\D130 \C9C8\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113213268299400757)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('1\AC1C \BD80\C801\D569\D55C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113213325241400757)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C \BD80\C801\D569\D55C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113164171814400721)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('(\BD84)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113181150716400733)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B9C8\C9C0\B9C9 %1 \C774\B0B4\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113181387801400733)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1 \C774\B0B4\C5D0 \C788\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113181232195400733)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B9C8\C9C0\B9C9 %1 \C774\B0B4\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113181454714400733)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \B2E4\C74C %1 \C774\B0B4\C5D0 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113114084962400684)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0A4\D328\B4DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113080171613400659)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113107929439400679)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14\C5D0 \B300\D55C \CD95 \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113100476678400674)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC 1\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113100618359400674)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113100144815400673)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C \B2EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113100251664400673)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C \C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113100335704400673)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C %0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113100569996400674)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C %0\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113099935794400673)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C %0\B144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113100028143400673)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC 1\B144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113080029155400659)
,p_name=>'APEXIR_LINE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113076850041400657)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\ACFC \C601\C5ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113191307500400740)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\D551')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113108876678400680)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\AC00 \D5C8\C6A9\B41C \CD5C\B300 \B9AC\C18C\C2A4\B97C \CD08\ACFC\D560 \AC83\C73C\B85C \C608\C0C1\B429\B2C8\B2E4. \BCF4\ACE0\C11C \C124\C815\C744 \C218\C815\D558\ACE0 \B2E4\C2DC \C2DC\B3C4\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113091017212400667)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BCF4\ACE0\C11C\C758 \CD5C\B300 \D589 \C218\B294 %0\AC1C \D589\C785\B2C8\B2E4. \C9C8\C758 \B808\CF54\B4DC \C218\B97C \C904\C774\B824\BA74 \D544\D130\B97C \C801\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113191937867400741)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300\AC12 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113192127035400741)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\C911\AC04\AC12 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113095047315400670)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BD84 \C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113192066539400741)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\C18C\AC12 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113191083925400740)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113164550156400721)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4\BCC4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113107125218400679)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113107032720400678)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113218229350400760)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\C5D0 \C5EC\B7EC \B300\D654\C2DD \BCF4\ACE0\C11C\AC00 \C788\C73C\BBC0\B85C \C601\C5ED \C815\C801 ID\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113075542042400656)
,p_name=>'APEXIR_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113102980232400675)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \C9D1\ACC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113213927592400757)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \BC94\C8FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113103035028400675)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \ACC4\C0B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113097868429400672)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113100962313400674)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113100736618400674)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113101207949400674)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C6D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113101103253400674)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113101079753400674)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C %0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113100863064400674)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C %0\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113101452369400674)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C %0\B144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113101340502400674)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C5F0\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113075840518400656)
,p_name=>'APEXIR_NO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113116138589400685)
,p_name=>'APEXIR_NONE'
,p_message_language=>'ko'
,p_message_text=>unistr('- \C5C6\C74C -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113163795802400720)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \C804\C790\BA54\C77C \C8FC\C18C\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113112614015400683)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110\C774 \D56D\C0C1 \CC98\C74C\C5D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113112528627400683)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110\C774 \D56D\C0C1 \B9C8\C9C0\B9C9\C5D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113113057713400683)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110 \C815\B82C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113109458734400680)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B798\C2DC\BC31 \C2DC\AC04\C740 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113109012920400680)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4\B294 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113113583104400683)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\C0B0\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113074463115400655)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B80C\C9C0\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113183376434400735)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC29\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113076308606400656)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\D0C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113059177770400644)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC29\D5A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113059809710400644)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113059982661400645)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113059010982400644)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D06C\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113059658526400644)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'ko'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113059513528400644)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'ko'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113059767095400644)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113059356890400644)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'ko'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113059248547400644)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'ko'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113059425267400644)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'ko'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113192461343400741)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \CD1D \AC1C\C218 \BE44\C728(%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113191639277400741)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \CD1D\ACC4 \BE44\C728(%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113190651303400740)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D \AC1C\C218 \BE44\C728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113190589508400740)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D\ACC4 \BE44\C728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113079967067400659)
,p_name=>'APEXIR_PIE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C774')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113139868073400703)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113141369427400704)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9D1\ACC4\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113141517965400704)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C5F4\B85C \C120\D0DD\B41C \C5F4\C5D0\C11C\B294 \C9D1\ACC4\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113140738039400704)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113140570701400703)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97 \C5F4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113141181519400704)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97 \C5F4\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113041228992400631)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97 \C9C8\C758\C5D0 \B300\D55C \CD5C\B300 \D589 \C218\B294 \D45C\C2DC\B418\B294 \D589 \C218\AC00 \C544\B2CC \AE30\BCF8 \C9C8\C758\C758 \D589 \C218\B97C \C81C\D55C\D569\B2C8\B2E4. \AE30\BCF8 \C9C8\C758\AC00 \CD5C\B300 \D589 \C218 %0\AC1C\B97C \CD08\ACFC\D569\B2C8\B2E4. \AE30\BCF8 \C9C8\C758\C758 \B808\CF54\B4DC \C218\B97C \C904\C774\B824\BA74 \D544\D130\B97C \C801\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113141030164400704)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97 \C815\B82C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113110452073400681)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97 \C5F4\C5D0 \ACE0\C720 \AC12\C774 \B108\BB34 \B9CE\C774 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4. \D53C\BC97 SQL\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113163849140400720)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BBF8\B9AC\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113097911427400672)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113189522051400739)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113164851977400721)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113058939691400644)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C811\ADFC\C131 \D0DC\ADF8 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113045868657400634)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\C2DD \C788\B294 \D14D\C2A4\D2B8 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113122678237400690)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113080501618400659)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113076112279400656)
,p_name=>'APEXIR_RED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE68\AC04\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113218174723400760)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \C815\C801 ID %0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113107269013400679)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113107316679400679)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113213416868400757)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113106805280400678)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\C5B4 \CC28\B2E8 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113106576418400678)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\D130 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113106637815400678)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B798\C2DC\BC31 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113213576439400757)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113106996045400678)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113213693492400757)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97 \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113194664749400743)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C81C\AC70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113175286439400729)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BCF4\ACE0\C11C \C774\B984 \BC14\AFB8\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113116409472400686)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C774\B984 \BC14\AFB8\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113098211302400672)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113192590752400741)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113072718457400654)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \BCC4\CE6D\ACFC \D568\AED8 \C800\C7A5\B41C \B300\D654\C2DD \BCF4\ACE0\C11C\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113122957417400691)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113072817094400654)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B41C \B300\D654\C2DD \BCF4\ACE0\C11C ID %0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113114706167400684)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113095581174400670)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113099429771400673)
,p_name=>'APEXIR_RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C124\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113080760956400659)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\B97C \AE30\BCF8 \C124\C815\C73C\B85C \BCF5\C6D0\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113075963492400656)
,p_name=>'APEXIR_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113188643323400739)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4\C5D0 \B300\D55C \AE30\BCF8 \D0A4 \C5F4\B85C ROWID\B97C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113105908593400678)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113165567763400722)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0\B2F9 \D589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113140853732400704)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113140698204400703)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C5F4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113141297020400704)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C5F4\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113141436516400704)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C5F4\C740 \D53C\BC97 \C5F4\ACFC \B2EC\B77C\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113120081306400688)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \D544\D130')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113095653671400670)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'ko'
,p_message_text=>unistr('%0/%1 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113099662760400673)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \D14D\C2A4\D2B8\AC00 \B2E4\C74C\C744 \D3EC\D568')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113075284765400655)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113110050357400681)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B41C \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113109915408400681)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5\B41C \BCF4\ACE0\C11C = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113112188995400682)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \BCF4\ACE0\C11C \C124\C815\C774 \BAA8\B4E0 \C0AC\C6A9\C790\C5D0 \B300\D55C \AE30\BCF8\AC12\C73C\B85C \C0AC\C6A9\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113175121919400729)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BCF4\ACE0\C11C \C800\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113099369382400673)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C800\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113213846724400757)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C800\C7A5 *')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113166523552400722)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113104833107400677)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \B3C4\AD6C \BAA8\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113213739308400757)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113172094996400726)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113156008232400715)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\D55C \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113076973608400657)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('- \C5F4 \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113098678058400672)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113080462913400659)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('- \D568\C218 \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113105659327400677)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('- \ADF8\B8F9 \AE30\C900 \C5F4 \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113140388155400703)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('- \D53C\BC97 \C5F4 \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113191569408400741)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113140461948400703)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('- \D53C\BC97 \D589 \C120\D0DD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113049194985400637)
,p_name=>'APEXIR_SEND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C1A1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113055444105400641)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C\B85C \C804\C1A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113075689971400656)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\D000\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113098896184400672)
,p_name=>'APEXIR_SORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113108102479400679)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B984\CC28\C21C \C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113108247750400679)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\B9BC\CC28\C21C \C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113194032265400742)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C815\B82C \C21C\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113102627074400675)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\BC31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113113763497400684)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\D0DC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113164295104400721)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\C6A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113190908600400740)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113045394281400634)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\B294 \ACBD\C6B0 \AC74\B108\B6F0\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113190895116400740)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113191772682400741)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'ko'
,p_message_text=>unistr('\D569\ACC4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113181775997400734)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED = %0, \BCF4\ACE0\C11C = %1, \BCF4\AE30 = %2, \D45C\C2DC\B41C \D589 \C2DC\C791 = %3, \D45C\C2DC\B41C \D589 \C885\B8CC = %4, \CD1D \D589 \C218 = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113102327259400675)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED = %0, \BCF4\ACE0\C11C = %1, \BDF0 = %2, \D45C\C2DC\B41C \D589 \C2DC\C791 = %3, \D45C\C2DC\B41C \D589 \C885\B8CC = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113074522606400655)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14D\C2A4\D2B8 \C0C9\C0C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113091659578400667)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113091570052400667)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113091408804400667)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113091804445400667)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C6D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113091796239400667)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113091997042400667)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113194492318400743)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D1A0\AE00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113107476705400679)
,p_name=>'APEXIR_TOP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E8 \C704\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113187680456400738)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9\D654\B418\C9C0 \C54A\C740 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113108965455400680)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC15\C870 \D45C\C2DC \C774\B984\C740 \ACE0\C720\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113079216039400658)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0\B418\C9C0 \C54A\B294 \B370\C774\D130 \C720\D615')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113107519079400679)
,p_name=>'APEXIR_UP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C704\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113109115098400680)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \C0C9\C0C1\C744 \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113109202567400680)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \D615\C2DD \B9C8\C2A4\D06C\B97C \C785\B825\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113076420765400656)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113108053674400679)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C5D0 \B300\D55C \CD95 \C81C\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113115834494400685)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C218 \AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113079854903400659)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C218\C9C1 \B9C9\B300')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113183508084400735)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113115129048400685)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113170365846400725)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80\C815\BCF4 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113215907931400759)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C\C5D0 %0 \BCF4\AE30\AC00 \C815\C758\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113170472828400725)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B8F9 \AE30\C900 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113170245801400725)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\C774\CF58 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113140142299400703)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D53C\BC97 \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113115236769400685)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113164448819400721)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\BCC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113098132186400672)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5 \BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113193146119400742)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113193002681400742)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113192988090400742)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BD84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113193319864400742)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C6D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113193211258400742)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C8FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113193485526400742)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\B144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113191155846400740)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\B3C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113074234056400655)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\B178\B780\C0C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113075783326400656)
,p_name=>'APEXIR_YES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113107888779400679)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \BD80\C801\D569\D55C \BB38\C790\C778 < \B610\B294 >\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113130632843400696)
,p_name=>'APEX_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113058846453400644)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'ko'
,p_message_text=>unistr('API \C0AC\C804 \C870\AC74 \C704\BC18')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113078304986400658)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B41C \BE4C\B4DC \C635\C158\C774 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B418\C5C8\C73C\BBC0\B85C \C560\D50C\B9AC\CF00\C774\C158 \C124\C815 %0\C5D0 \B300\D55C \AC12\C744 \AC00\C838\C62C \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113078207591400657)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F0\AD00\B41C \BE4C\B4DC \C635\C158\C774 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B418\C5C8\C73C\BBC0\B85C \C560\D50C\B9AC\CF00\C774\C158 \C124\C815 %0\C5D0 \B300\D55C \AC12\C744 \C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113185989652400737)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C124\C815 %0 \AC12\C774 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113185847947400737)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\B41C \C560\D50C\B9AC\CF00\C774\C158 \C124\C815 %0\C774(\AC00) \C815\C758\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113186042700400737)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \C124\C815 %0\C744(\B97C) \B110 \AC12\C73C\B85C \C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113066904960400649)
,p_name=>'BACK'
,p_message_language=>'ko'
,p_message_text=>unistr('\B4A4\B85C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113053943438400640)
,p_name=>'BUILDER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\AE30')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113118089641400687)
,p_name=>'BUTTON LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 \B808\C774\BE14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113053059862400640)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\CD94 CSS \D074\B798\C2A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113082264446400660)
,p_name=>'BUTTON_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\B41C \B2E8\CD94 ID\B294 \C815\C758\B41C \ACBD\C6B0 \B2E8\CD94\C758 \C815\C801 ID\AC00 \B418\BA70, \C815\C758\B418\C9C0 \C54A\C740 \ACBD\C6B0 ''B'' || [Internal Button ID] \D615\C2DD\C758 \B0B4\BD80\C801\C73C\B85C \C0DD\C131\B41C ID\AC00 \B429\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113045769601400634)
,p_name=>'CANDLESTICK'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1B\B300')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113127292811400694)
,p_name=>'CENTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC00\C6B4\B370')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113077213212400657)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C694\CCAD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113068684398400651)
,p_name=>'CHECK$'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C120\D0DD\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113187762330400738)
,p_name=>'CHECKED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B428')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113163288648400720)
,p_name=>'COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113123760499400691)
,p_name=>'COMMENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113105269330400677)
,p_name=>'CONTINUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACC4\C18D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113067254819400650)
,p_name=>'COPYRIGHT'
,p_message_language=>'ko'
,p_message_text=>'Copyright &copy; %0, All rights reserved.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113110999287400681)
,p_name=>'COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C218')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113117674693400687)
,p_name=>'CREATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113169990705400725)
,p_name=>'CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113170002617400725)
,p_name=>'CREATED_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113094822225400669)
,p_name=>'CREATED_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131 \B0A0\C9DC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113105484408400677)
,p_name=>'CUSTOM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113116642241400686)
,p_name=>'CUSTOMIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\C815\C758')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113118220756400687)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AC\C6A9\C790\C5D0 \B300\D574 \D398\C774\C9C0 \D658\ACBD\C124\C815\C774 \C7AC\C124\C815\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113118354994400687)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AC\C6A9\C790\C5D0 \B300\D574 \D658\ACBD\C124\C815\C774 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113118115524400687)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C0AC\C6A9\C790\C5D0 \B300\D574 \D398\C774\C9C0 \D658\ACBD\C124\C815\C774 \C7AC\C124\C815\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113081997493400660)
,p_name=>'DAILY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\BCC4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113053511543400640)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B85C\B4DC\B41C \D30C\C77C\C774 \BD80\C801\D569\D558\AC70\B098 \C798\BABB\B41C \D655\C7A5\C790\B97C \AC00\C9D1\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113077470152400657)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C XML \B610\B294 JSON \C120\D0DD\AE30\AC00 \C0AC\C6A9\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113046734844400635)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \D504\B85C\D30C\C77C \BC0F \C5C5\B85C\B4DC\B41C \D30C\C77C\C5D0\B294 \B300\C0C1 \D14C\C774\BE14 \C5F4\C774 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113132448751400698)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B85C\B4DC\B41C \D30C\C77C\C5D0\C11C \B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113132508517400698)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \C6CC\D06C\C2DC\D2B8\C5D0\C11C \B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113052333293400639)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \D30C\C77C\C740 XLSX \D30C\C77C\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113042777888400632)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C644\B8CC\B428: %0\AC1C \D589\C774 \CC98\B9AC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113043991297400633)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C644\B8CC\B428: 1\AC1C \C624\B958\C640 \D568\AED8 %0\AC1C \D589\C774 \CC98\B9AC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113044256246400633)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C644\B8CC\B428: %1\AC1C \C624\B958\C640 \D568\AED8 %0\AC1C \D589\C774 \CC98\B9AC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113044031972400633)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C644\B8CC\B428: 1\AC1C \D589\C774 \CC98\B9AC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113047008189400635)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C644\B8CC\B428: \C624\B958\C640 \D568\AED8 1\AC1C \D589\C774 \CC98\B9AC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113044174133400633)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC \C644\B8CC\B428: \C624\B958 \C5C6\C774 1\AC1C \D589\C774 \CC98\B9AC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113137714278400701)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\C0C1 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113137876542400701)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C18C\C2A4 \C5F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113138680533400702)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC/\C22B\C790 \D615\C2DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113202095317400748)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C870\D68C \AC12 \AC80\C0C9\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113170566353400725)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130/\D14C\C774\BE14 \B9E4\D551')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113138735749400702)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113134272987400699)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D328\D55C \BCC0\D658 \ADDC\CE59\C785\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113110532628400681)
,p_name=>'DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0A0\C9DC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113084623521400662)
,p_name=>'DAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113084789654400662)
,p_name=>'DAYS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113123416748400691)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \B514\BC84\AE45\C774 \C0AC\C6A9\C73C\B85C \C124\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113172283020400727)
,p_name=>'DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113085417178400663)
,p_name=>'DELETE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AD\C81C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113045605216400634)
,p_name=>'DIAL_PCT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C774\C5BC(\D37C\C13C\D2B8)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113060178834400645)
,p_name=>'DOWNLOAD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C6B4\B85C\B4DC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113171355618400726)
,p_name=>'DUP_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D \B0B4\C5D0\C11C \C0AC\C6A9\C790 \C774\B984\C774 \C911\BCF5\B429\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113067749658400650)
,p_name=>'EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113077142480400657)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C8FC\C18C "%0"\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113062245219400646)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C804\C790\BA54\C77C\C740 %0\C774(\AC00) \BCF4\B0C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113171537921400726)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C8FC\C18C\AC00 \B108\BB34 \AE41\B2C8\B2E4. \C81C\D55C\C740 240\C790\C785\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113105179853400677)
,p_name=>'ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113134360960400699)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\BD84 \D398\C774\C9C0 \C0C8\B85C\ACE0\CE68 \C601\C5ED\C5D0 \B300\D55C \D398\C774\C9C0 \D56D\BAA9 \C18C\C2A4 \AC12\C744 \C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113096618997400671)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113062587311400646)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\AC00 \B9CC\B8CC\B428')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113056682677400642)
,p_name=>'FILE_EMPTY'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C\C774 \BE44\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113136801090400701)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B85C\B4DC\B41C \D30C\C77C \D06C\AE30\AC00 %0MB \C774\C0C1\C785\B2C8\B2E4. \B354 \C791\C740 \D30C\C77C\C744 \C5C5\B85C\B4DC\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113064694432400648)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C778\C99D\C744 \C2E4\D328\D588\C73C\BA70 \D558\B098 \C774\C0C1\C758 \D30C\C77C\C774 \C5C5\B85C\B4DC\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113064795215400648)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C778\C2A4\D134\C2A4\B294 \C778\C99D\B418\C9C0 \C54A\C740 \C0AC\C6A9\C790\AC00 \D30C\C77C\C744 \C5C5\B85C\B4DC\D558\B3C4\B85D \D5C8\C6A9\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113117766143400687)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('1\AC1C\C758 \C624\B958\AC00 \BC1C\C0DD\D568')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113116962551400686)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C624\B958 \BC1C\C0DD')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113067199001400650)
,p_name=>'FORM_OF'
,p_message_language=>'ko'
,p_message_text=>'%0/%1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113101877081400675)
,p_name=>'GO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113201638730400748)
,p_name=>'HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113054056217400640)
,p_name=>'HOME'
,p_message_language=>'ko'
,p_message_text=>unistr('\D648')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113084420859400662)
,p_name=>'HOUR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113084589198400662)
,p_name=>'HOURS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\AC04')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113068573849400651)
,p_name=>'ICON'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C544\C774\CF58')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113118501191400687)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \B85C\ADF8\C778 \C778\C99D\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113218022415400760)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9E4\AC1C\BCC0\C218\C5D0 \BD80\C801\D569\D55C \AC12: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113113269777400683)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \BCF4\ACE0\C11C \C124\C815\C73C\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113113368027400683)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984\C774 \C9C0\C815\B41C \BCF4\ACE0\C11C\B85C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113095727534400670)
,p_name=>'IR_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C624\B958. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113095445340400670)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3FC \D0D0\C0C9\C744 \ACC4\C0B0\D560 \C218 \C5C6\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113073082192400654)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113072488224400653)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\D654\C2DD \BCF4\ACE0\C11C \C601\C5ED\C774 %0 \C560\D50C\B9AC\CF00\C774\C158, %1 \D398\C774\C9C0 \BC0F %2 \C601\C5ED\C5D0 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113113186258400683)
,p_name=>'IR_STAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\BC1C\C790\C5D0 \B300\D574\C11C\B9CC \D45C\C2DC\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113101553065400674)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C9C8\C758\C5D0\B294 \AC01 \D589\C744 \C2DD\BCC4\D558\B294 \ACE0\C720 \D0A4\AC00 \D544\C694\D569\B2C8\B2E4. \C81C\ACF5\B41C \D0A4\B294 \C774 \C9C8\C758\C5D0 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \ACE0\C720 \D0A4 \C5F4\C744 \C815\C758\D558\C2ED\C2DC\C624. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113101622684400674)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C9C8\C758\C5D0\B294 \AC01 \D589\C744 \C2DD\BCC4\D558\B294 \ACE0\C720 \D0A4\AC00 \D544\C694\D569\B2C8\B2E4. \C81C\ACF5\B41C \D0A4\B294 \C774 \C9C8\C758\C5D0 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \ACE0\C720 \D0A4 \C5F4\C744 \C815\C758\D558\B824\BA74 \BCF4\ACE0\C11C \C18D\C131\C744 \D3B8\C9D1\D558\C2ED\C2DC\C624. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113138928269400702)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D30C\C77C \C120\D0DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113138886800400702)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5EC\AE30\B85C \D30C\C77C \B04C\C5B4 \B193\AE30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113067453089400650)
,p_name=>'ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113096889176400671)
,p_name=>'ITEM_VALUE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 \AC12')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113111231935400682)
,p_name=>'LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B808\C774\BE14')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113123327276400691)
,p_name=>'LANGUAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5B8\C5B4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113085134411400662)
,p_name=>'LAST'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\ADFC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113064555730400648)
,p_name=>'LENGTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE38\C774')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113117872641400687)
,p_name=>'LOGIN'
,p_message_language=>'ko'
,p_message_text=>unistr('\B85C\ADF8\C778')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113156421773400715)
,p_name=>'MANAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113221088640400762)
,p_name=>'MAXIMIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300\D654')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113084215203400662)
,p_name=>'MINUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113084390016400662)
,p_name=>'MINUTES'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD84')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113171761907400726)
,p_name=>'MISSING_AT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C8FC\C18C \B3C4\BA54\C778\C5D0 "@"\C774 \B204\B77D\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113171913029400726)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0: %1 \C560\D50C\B9AC\CF00\C774\C158\C758 \B300\D654\C0C1\C790 \D398\C774\C9C0 %0\C5D0 \B300\D574 \C815\C758\B41C \B300\D654\C0C1\C790 \D398\C774\C9C0 \D15C\D50C\B9AC\D2B8\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113171628760400726)
,p_name=>'MISSING_DOT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C8FC\C18C \B3C4\BA54\C778\C5D0 "."\C774 \B204\B77D\B418\C5C8\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113120889731400689)
,p_name=>'MODULE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B4C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113077926971400657)
,p_name=>'MONTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113081797342400660)
,p_name=>'MONTHLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C6D4\BCC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113078044386400657)
,p_name=>'MONTHS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC1C\C6D4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113110864569400681)
,p_name=>'MOVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113178343474400731)
,p_name=>'MOVE_FROM'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \CD9C\CC98')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113178482164400731)
,p_name=>'MOVE_TO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B3D9 \B300\C0C1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113098067242400672)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \D589 \C0AD\C81C \C791\C5C5 \C911 \C624\B958 \BC1C\C0DD: \D589= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113097026437400671)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACF5\AC1C \C0AC\C6A9\C790\AC00 \C544\B2C8\C5B4\C57C \D568')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113054215754400640)
,p_name=>'NAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113111043394400681)
,p_name=>'NEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8\B85C \B9CC\B4E4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113077717067400657)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C\C73C\B85C \C774\B3D9\D558\C5EC %0\C5D0 \B85C\ADF8\C778\D560 \C218 \C788\C74C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113077848726400657)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 %0 \ACC4\C815 \D1B5\C9C0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113201826578400748)
,p_name=>'NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113120784551400689)
,p_name=>'NO'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2C8\C624')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113216099440400759)
,p_name=>'NOBODY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\BB34\B3C4 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113085596762400663)
,p_name=>'NOT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113126317706400693)
,p_name=>'NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B110\C774 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113097116954400671)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C544\B2D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113116765217400686)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113125876278400693)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BCF4\ACE0\C11C\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. ''\C5C5\B370\C774\D2B8 \AC00\B2A5\D55C \BCF4\ACE0\C11C'' \C720\D615\C758 \D45C \D615\C2DD \D3FC\C5D0 \B300\D574\C11C\B9CC \B2E4\C911 \D589 \C5C5\B370\C774\D2B8 \BC0F \C0AD\C81C \C791\C5C5\C744 \C218\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113126776766400693)
,p_name=>'OK'
,p_message_language=>'ko'
,p_message_text=>unistr('\D655\C778')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113122498549400690)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'ko'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113219896550400761)
,p_name=>'ORA_06550'
,p_message_language=>'ko'
,p_message_text=>unistr('ORA-06550: %0\D589, %1\C5F4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113169383419400724)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804 \BC84\C804\C758 \C6F9 \BE0C\B77C\C6B0\C800\B97C \C0AC\C6A9\D558\ACE0 \C788\C2B5\B2C8\B2E4. \C9C0\C6D0\B418\B294 \BE0C\B77C\C6B0\C800 \BAA9\B85D\C740 Oracle Application Express Installation Guide\B97C \CC38\C870\D558\C2ED\C2DC\C624.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113070755022400652)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \D589 \C9D1\D569\C774 \C694\CCAD\B418\C5C8\C2B5\B2C8\B2E4. \BCF4\ACE0\C11C\C758 \C18C\C2A4 \B370\C774\D130\AC00 \C218\C815\B418\C5C8\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113090880345400667)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569\D55C \D398\C774\C9C0 \BC88\D638\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4. (\C608: p?n=1234)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113094409042400669)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113094566771400669)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C74C \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113094696328400669)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113094758438400669)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804 \C9D1\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113201716529400748)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B9E4\AE40 \C120\D0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113132340606400697)
,p_name=>'PASSWORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113077035409400657)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \BE44\BC00\BC88\D638\AC00 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113066827576400649)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\AC00 \C774 \C0AC\C774\D2B8\C758 \BE44\BC00\BC88\D638 \BCF5\C7A1\C131 \ADDC\CE59\C744 \C900\C218\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113065911289400649)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \BE44\BC00\BC88\D638\B294 \C774\C804 \BE44\BC00\BC88\D638\C640 %0\C790 \C774\C0C1 \B2EC\B77C\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113066509173400649)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\C5D0\B294 \C0AC\C6A9\C790 \C774\B984\C774 \D3EC\D568\B418\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113066734276400649)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\C5D0 \D5C8\C6A9\B418\C9C0 \C54A\B294 \B2E8\C21C\D55C \B2E8\C5B4\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113066625709400649)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\C5D0\B294 \C791\C5C5\C601\C5ED \C774\B984\C774 \D3EC\D568\B418\C9C0 \C54A\C544\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113065894912400649)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\B294 %0\C790 \C774\C0C1\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113066025958400649)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\C5D0\B294 \D558\B098 \C774\C0C1\C758 \C601\BB38\C790(%0)\AC00 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113066404509400649)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\C5D0\B294 \D558\B098 \C774\C0C1\C758 \C18C\BB38\C790(\C601\BB38\C790)\AC00 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113066157099400649)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\C5D0\B294 \D558\B098 \C774\C0C1\C758 \C22B\C790(0123456789)\AC00 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113066265692400649)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\C5D0\B294 \D558\B098 \C774\C0C1\C758 \AD6C\B450\C810 \BB38\C790(%0)\AC00 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113066317874400649)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638\C5D0\B294 \D558\B098 \C774\C0C1\C758 \B300\BB38\C790(\C601\BB38\C790)\AC00 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113077571991400657)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638 \C7AC\C124\C815 \D1B5\C9C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113064819501400648)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\B09C %0\C77C \C774\B0B4\C5D0 \BE44\BC00\BC88\D638\B97C \C0AC\C6A9\D588\C73C\BBC0\B85C \D574\B2F9 \BE44\BC00\BC88\D638\B97C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113145103110400707)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113145230256400707)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113122260263400690)
,p_name=>'PERCENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D37C\C13C\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113092584071400668)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113201959995400748)
,p_name=>'PREVIOUS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\C804')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113137383984400701)
,p_name=>'PRINT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C1C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113121000210400689)
,p_name=>'PRIVILEGES'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113090927785400667)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \CC38\C870')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113111148385400682)
,p_name=>'REPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113120934388400689)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0 \AE30\AC04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113202146960400748)
,p_name=>'REPORT_LABEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113121696008400690)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \D569\ACC4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113070819401400652)
,p_name=>'RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113096750464400671)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \C7AC\C124\C815')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113125751396400693)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638 \C7AC\C124\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113102564317400675)
,p_name=>'RESTORE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF5\C6D0')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113134440119400699)
,p_name=>'RESULTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACB0\ACFC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113126874413400693)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C73C\B85C \B3CC\C544\AC00\C2ED\C2DC\C624.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113127125807400694)
,p_name=>'RIGHT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B978\CABD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113156752443400715)
,p_name=>'ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113110774244400681)
,p_name=>'ROW_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C218')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113126240440400693)
,p_name=>'SAVE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C800\C7A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113122842799400690)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B300\CCB4 \AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113123276308400691)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C124\BA85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113122742305400690)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8 \AE30\BCF8\AC12')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113123570275400691)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\BCF4\B2E4 \B9CE\C740 \D589\C744 \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. \D589 \C120\D0DD\AE30\B97C \B298\B824 \D589\C744 \B354 \D45C\C2DC\D558\C2ED\C2DC\C624.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113188900153400739)
,p_name=>'SEARCH'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C0C9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113084136761400662)
,p_name=>'SECONDS'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113122342034400690)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CCA8\BD80 \CC38\C870')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113180022905400732)
,p_name=>'SELECT_ROW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C120\D0DD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113122089619400690)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'ko'
,p_message_text=>unistr('\D654\BA74 \D310\B3C5\AE30 \BAA8\B4DC \D574\C81C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113122154830400690)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'ko'
,p_message_text=>unistr('\D654\BA74 \D310\B3C5\AE30 \BAA8\B4DC \C124\C815')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113118404339400687)
,p_name=>'SHOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113181844595400734)
,p_name=>'SHOW_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \D45C\C2DC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113207967503400753)
,p_name=>'SIGN_IN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C778\C778')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113157573223400716)
,p_name=>'SIGN_OUT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C778\C544\C6C3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113111709226400682)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C77C \C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113118966863400688)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\AE08\BD80\D130 %0\C77C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113111688786400682)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C2DC\AC04 \C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113118887725400687)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\AE08\BD80\D130 %0\C2DC\AC04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113111507776400682)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BD84 \C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113118783030400687)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\AE08\BD80\D130 %0\BD84')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113111983757400682)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C6D4 \C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113119167651400688)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\AE08\BD80\D130 %0\AC1C\C6D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113119305766400688)
,p_name=>'SINCE_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\AE08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113111453947400682)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\CD08 \C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113118677769400687)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\AE08\BD80\D130 %0\CD08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113111875261400682)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C8FC \C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113119044335400688)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\AE08\BD80\D130 %0\C8FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113112073850400682)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\B144 \C804')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113119273610400688)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\AE08\BD80\D130 %0\B144')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113105592537400677)
,p_name=>'STANDARD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C900')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113121938251400690)
,p_name=>'START_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791 \B0A0\C9DC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113062482449400646)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C774(\AC00) \C0DD\C131\D55C \B300\D654\C2DD \BCF4\ACE0\C11C \B4F1\B85D\C73C\B85C\BD80\D130 \C774 \C804\C790\BA54\C77C\C744 \BC1B\ACE0 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113217103052400759)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\C6A9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113165239710400721)
,p_name=>'TAB'
,p_message_language=>'ko'
,p_message_text=>unistr('\D0ED')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113084097961400662)
,p_name=>'TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\BAA9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113067039337400650)
,p_name=>'TODAY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B298')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113121590990400690)
,p_name=>'TOTAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD1D\ACC4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113068089402400650)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD5C\B300 %0\AC1C\C758 \C5F4\C744 \C120\D0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113046570834400635)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \CD95\C18C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113046876636400635)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\C5D0 \BAA8\B450 \CD95\C18C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113046438309400635)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \D655\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113046651685400635)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C544\B798\C5D0 \BAA8\B450 \D655\C7A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113046949851400635)
,p_name=>'TREE.REPARENT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C1\C704 \C7AC\C9C0\C815')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113139195737400702)
,p_name=>'TREES'
,p_message_language=>'ko'
,p_message_text=>unistr('\D2B8\B9AC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113182692561400734)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D544\C218')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113106268401400678)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C \C5C6\C74C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113153037019400712)
,p_name=>'UNAVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\D560 \C218 \C5C6\C74C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113119779061400688)
,p_name=>'UNKNOWN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113063366425400647)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C \C218 \C5C6\B294 \C778\C99D \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113065347920400648)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'ko'
,p_message_text=>unistr('\B354 \C774\C0C1 \C804\C790\BA54\C77C\C744 \BC1B\C9C0 \C54A\C73C\B824\BA74 <a href="%0">\AC00\C785 \D574\C81C</a>\B97C \B20C\B7EC \AC00\C785\C744 \AD00\B9AC\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113062342197400646)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\B354 \C774\C0C1 \C804\C790\BA54\C77C\C744 \BC1B\C9C0 \C54A\C73C\B824\BA74 \B2E4\C74C URL\B85C \C774\B3D9\D558\C5EC \AC00\C785\C744 \AD00\B9AC\D558\C2ED\C2DC\C624.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113097292009400671)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C6D0\B418\C9C0 \C54A\B294 \B370\C774\D130 \C720\D615')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113085344356400663)
,p_name=>'UPDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113083980113400662)
,p_name=>'UPDATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8 \B0A0\C9DC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113090600332400666)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\D55C URL\C740 \AE08\C9C0\B418\C5C8\C2B5\B2C8\B2E4. \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113110637819400681)
,p_name=>'USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113132269157400697)
,p_name=>'USERNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113171876380400726)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984\C774 \B108\BB34 \AE41\B2C8\B2E4. \C81C\D55C\C740 %0\C790\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113117439337400686)
,p_name=>'USERS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113171442521400726)
,p_name=>'USER_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984\C774 \C874\C7AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113186109432400737)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 %0\C5D0 \B300\D55C \D504\B85C\D30C\C77C \C774\BBF8\C9C0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113073782617400654)
,p_name=>'VALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C801\D569')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113067347133400650)
,p_name=>'VALIDATIONS'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC80\C99D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113123098441400691)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113166401304400722)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D55C \AC12\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113092913486400668)
,p_name=>'VERTICAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\B85C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113085295566400663)
,p_name=>'VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113117573286400686)
,p_name=>'VIEWS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113123894279400691)
,p_name=>'VIEW_ALL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B450 \BCF4\AE30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113105015391400677)
,p_name=>'WARNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\ACBD\ACE0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113084820532400662)
,p_name=>'WEEK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113081833141400660)
,p_name=>'WEEKLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\BCC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113084946161400662)
,p_name=>'WEEKS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113123137618400691)
,p_name=>'WELCOME_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2DC\C791: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113121367395400689)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \AC12\C774 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4. \C785\B825\B41C \B370\C774\D130\B97C \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113121498199400689)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \AC12\C774 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4. \C785\B825\B41C \B370\C774\D130\B97C \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113064484983400648)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \B0A0\C9DC \AC12\C774 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4. \B0A0\C9DC \D615\C2DD\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113121219936400689)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C22B\C790 \AC12\C774 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4. \C22B\C790 \D615\C2DD\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113073351947400654)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C2DC\AC04\AE30\B85D \AC12\C774 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4. \C2DC\AC04\AE30\B85D \D615\C2DD\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113095830769400670)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0"\C744(\B97C) \BC14\C778\B4DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \BA40\D2F0 \BC14\C774\D2B8 \D56D\BAA9\C5D0 \B300\D574 \D070 \B530\C634\D45C\B97C \C0AC\C6A9\D558\AC70\B098 \D56D\BAA9 \AE38\C774\AC00 30\BC14\C774\D2B8 \C774\D558\C778\C9C0 \D655\C778\D558\C2ED\C2DC\C624. \AE38\C774\AC00 30\BC14\C774\D2B8\B97C \CD08\ACFC\D558\B294 \D56D\BAA9\C744 \CC38\C870\D558\B824\BA74 v() \AD6C\BB38\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113086360244400663)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \BCF4\C548 \AC80\C0AC\C5D0 \C758\D574 \C561\C138\C2A4\AC00 \AC70\BD80\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113088820716400665)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C744 \C0AC\C6A9\D560 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113087241757400664)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1014 \C560\D50C\B9AC\CF00\C774\C158\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113087370960400664)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158=%0  \C791\C5C5\C601\C5ED=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113087715338400664)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \B300\D55C \C561\C138\C2A4\AC00 \C81C\D55C\B429\B2C8\B2E4. \B098\C911\C5D0 \B2E4\C2DC \C2DC\B3C4\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113087686007400664)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AC1C\BC1C\C790\B9CC \C774 \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C561\C138\C2A4\D560 \C218 \C788\C2B5\B2C8\B2E4. \B098\C911\C5D0 \B2E4\C2DC \C2DC\B3C4\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113086827603400664)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-7744 URL\C744 \BC18\D658\D558\B294 \D568\C218\B85C\C758 \BD84\AE30\B97C \CC98\B9AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113086753821400664)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-7744 \D398\C774\C9C0\B97C \BC18\D658\D558\B294 \D568\C218\B85C\C758 \BD84\AE30\B97C \CC98\B9AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113087089730400664)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1430 \D398\C774\C9C0 \D504\B85C\C138\C2A4\C5D0\C11C \D45C\C2DC\D558\AE30 \C704\D55C \D638\CD9C\C774 \C9C0\C6D0\B418\C9C0 \C54A\C74C: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113088135823400665)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1018 \B2E8\ACC4 \CE90\C2DC\B97C \C9C0\C6B0\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113086592846400663)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1005 \C54C \C218 \C5C6\B294 \ACC4\C0B0 \C720\D615\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113087496304400664)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1201 \C0AC\C6A9\C790\C815\C758 \C778\C99D\C5D0\C11C \C138\C158 ID\AC00 \C124\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113087592166400664)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113087177913400664)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-7620 \C560\D50C\B9AC\CF00\C774\C158(%0)\C5D0 \B300\D55C \C791\C5C5\C601\C5ED\C744 \D655\C778\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113069520708400651)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D3B8\C9D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113086288869400663)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1802 \D56D\BAA9 ID "%0"\C744(\B97C) \CC3E\C744 \C218 \C5C6\C74C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113085998751400663)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1002 "%1" \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C "%0" \D56D\BAA9\C5D0 \B300\D55C \D56D\BAA9 ID\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113086028296400663)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608\C0C1\CE58 \C54A\C740 \C624\B958\C785\B2C8\B2E4. \C560\D50C\B9AC\CF00\C774\C158 \B610\B294 \D398\C774\C9C0 \B808\BCA8\C5D0\C11C \D56D\BAA9 \C774\B984\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113086495990400663)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\BBF8 \B370\C774\D130\C758 \CCAB\BC88\C9F8 \D398\C774\C9C0\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113101900003400675)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9 ID(%0)\AC00 \D604\C7AC \D398\C774\C9C0\C5D0 \C815\C758\B41C \D56D\BAA9\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113064012897400647)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C218\B97C \C560\D50C\B9AC\CF00\C774\C158\C5D0 \C804\B2EC\D558\BA74 \D56D\BAA9\C744 \C124\C815\D558\C9C0 \BABB\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113064347331400648)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'ko'
,p_message_text=>unistr('(\C81C\ACF5\B41C \CCB4\D06C\C12C\C774 \C5C6\C2B5\B2C8\B2E4.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113063849115400647)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'ko'
,p_message_text=>unistr('"\C0AC\C6A9\C790 \B808\BCA8 \CC45\AC08\D53C" \CCB4\D06C\C12C\ACFC \D568\AED8 \C0AC\C6A9\B420 \ACBD\C6B0 \D56D\BAA9\C744 \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113063776768400647)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'ko'
,p_message_text=>unistr('"\C560\D50C\B9AC\CF00\C774\C158 \B808\BCA8 \CC45\AC08\D53C" \CCB4\D06C\C12C\ACFC \D568\AED8 \C0AC\C6A9\B420 \ACBD\C6B0 \D56D\BAA9\C744 \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113063964494400647)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('"\C138\C158" \CCB4\D06C\C12C\ACFC \D568\AED8 \C0AC\C6A9\B420 \ACBD\C6B0 \D56D\BAA9\C744 \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113063683576400647)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D56D\BAA9\C5D0 \C124\C815\B41C \BCF4\D638\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113088276052400665)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \B3C4\C6C0\B9D0\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113077364963400657)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C791\C5C5\C601\C5ED\C5D0\B294 %1 \C2A4\D0A4\B9C8\B97C \C2E4\D589\D560 \C218 \C788\B294 \AD8C\D55C\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113086683355400664)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1010 \D398\C774\C9C0 \D5C8\C6A9 \D504\B85C\C138\C2F1\C73C\B85C \BD84\AE30 \C21C\D658 \D55C\ACC4\B97C \CD08\ACFC\D588\C2B5\B2C8\B2E4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113064277688400648)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B294 URL \B610\B294 \D45C\C2DC \D504\B85C\C2DC\C800\C5D0 \B300\D55C GET/POST\B97C \C0AC\C6A9\D558\C5EC \D638\CD9C\D560 \C218 \C5C6\C2B5\B2C8\B2E4. "\D398\C774\C9C0 \BD84\AE30" \BD84\AE30 \C720\D615\C744 \C0AC\C6A9\D558\C5EC \D638\CD9C\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113140954267400704)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D56D\BAA9\C5D0 \C22B\C790\AC00 \C544\B2CC \AC12\C744 \C800\C7A5\D558\B824\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113079054327400658)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158\C758 \AD6C\BB38 \BD84\C11D \C2A4\D0A4\B9C8 "%0"\C774(\AC00) \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113079174324400658)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'ko'
,p_message_text=>unistr('INTERNAL \C791\C5C5\C601\C5ED\C758 \ACC4\C815\C740 &PRODUCT_NAME. <a href="%0">\AD00\B9AC \C11C\BE44\C2A4</a>\C5D0 \C561\C138\C2A4\D558\AE30 \C704\D55C \C6A9\B3C4\B85C\B9CC \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113085829210400663)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-1029 \C138\C158 \C815\BCF4\B97C \C800\C7A5\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C138\C158=%0 \D56D\BAA9=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113088959562400665)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD94\C801\C744 \C815\C9C0\D560 \C218 \C5C6\C74C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113086175169400663)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608\C0C1\CE58 \C54A\C740 \C624\B958')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113096113746400670)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('update_substitution_cache\C5D0 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113089082221400665)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B3C4\C6C0\B9D0\C744 \BCF4\B824\BA74 \C560\D50C\B9AC\CF00\C774\C158 \BC0F \D398\C774\C9C0\B97C \C81C\ACF5\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113109552909400680)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\C790\B3D9\D654\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113090108963400666)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\AC1C\C758 \C138\C158\C774 \BE44\C6CC\C84C\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113049418327400637)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \CF54\B4DC\B97C \C2E4\D589\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \C9C0\C6D0\B418\C9C0 \C54A\C73C\BA70 \C778\C2A4\D134\C2A4 \B9E4\AC1C\BCC0\C218 MLE_LANGUAGES\C5D0 \C758\D574 \C0AC\C6A9\C73C\B85C \C124\C815\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113049279496400637)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\AD6D\C5B4 \C5D4\C9C4\C740 \C774 \B370\C774\D130\BCA0\C774\C2A4 \BC84\C804\C5D0\C11C \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113070003803400652)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BAA8\C74C \BC30\C5F4\C740 \B110\C774\BA74 \C548\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113069871500400652)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \BA64\BC84 \C18D\C131 \BC88\D638 %0\C740(\B294) \BD80\C801\D569\D569\B2C8\B2E4. \C18D\C131 \BC88\D638\B294 1\ACFC %1 \C0AC\C774\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113070340930400652)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BAA8\C74C\C774 \C874\C7AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113070138848400652)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C74C \C774\B984\C740 \B110\C77C \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113070292785400652)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C74C \C774\B984\C740 255\C790\B97C \CD08\ACFC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113069661041400651)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BAA8\C74C %0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113070476261400652)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\CEE4\C11C\AC00 \C544\C9C1 \C5F4\B824 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113069760831400651)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C560\D50C\B9AC\CF00\C774\C158 \BAA8\C74C %1\C5D0 \BA64\BC84 \C2DC\D000\C2A4 %0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113069976483400652)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \BAA8\C74C "%1"\C5D0 \BA64\BC84 \C2DC\D000\C2A4 %0\C774(\AC00) \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113141788566400704)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\C554\D638\D654 \D568\C218 "%0"\C740(\B294) \C774 \C2DC\C2A4\D15C\C5D0\C11C \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113195218852400743)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C811\ADFC\C131 \D14C\C2A4\D2B8\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113089669771400666)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2EB\AE30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113089755087400666)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \C0AC\C6A9\C790\C815\C758 \C635\C158')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113089804392400666)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\BCF8\AC12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113089996419400666)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'ko'
,p_message_text=>unistr('\D45C\C2DC\B428')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113090095587400666)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C228\AE40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113089496366400666)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\C5D0 \D3EC\D568\C2DC\D0A4\B824\B294 \C601\C5ED\C744 \C120\D0DD\D558\C2ED\C2DC\C624. \C801\C808\D55C \C560\D50C\B9AC\CF00\C774\C158 \CEE8\D14D\C2A4\D2B8\C5D0 \C788\C9C0 \C54A\AC70\B098 \C801\C808\D55C \AD8C\D55C\C774 \C5C6\B294 \ACBD\C6B0 \C120\D0DD\B41C \C601\C5ED\C774 \D45C\C2DC\B418\C9C0 \C54A\C744 \C218 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113089591000400666)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D398\C774\C9C0\B294 \C0AC\C6A9\C790\AC00 \C815\C758\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113195543871400744)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'ko'
,p_message_text=>unistr('\D14C\B9C8 \C2A4\D0C0\C77C\C744 \BCC0\ACBD\D558\C5EC \C774 \C560\D50C\B9AC\CF00\C774\C158\C758 \BAA8\C591\C744 \AC1C\C778 \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4. \C544\B798 \BAA9\B85D\C5D0\C11C \D14C\B9C8 \C2A4\D0C0\C77C\C744 \C120\D0DD\D558\ACE0 \BCC0\ACBD\C0AC\D56D \C801\C6A9\C744 \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113196365616400744)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C601\C5ED \D45C\C2DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113195453398400743)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 \AE30\BCF8 \C2A4\D0C0\C77C \C0AC\C6A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113195384529400743)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\C591 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113138308854400702)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C9D1\ACC4\C5D0\C11C \CC38\C870\B41C \C5F4 \C778\B371\C2A4\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113041604329400631)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D615\C2DD\C5D0 \B300\D574\C11C\B294 CLOB \CD9C\B825\C774 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113138009539400702)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AD6C\BD84\C120\C740 \C5F4 \BC30\C5F4\C758 \CC98\C74C\C5D0 \C788\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113138189155400702)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0\C11C \CC38\C870\B41C \C5F4 \ADF8\B8F9 \C778\B371\C2A4\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113055624737400641)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C775\C2A4\D3EC\D2B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113060852370400645)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'ko'
,p_message_text=>unistr('\C775\C2A4\D3EC\D2B8 \D615\C2DD\C740 ORDS\B97C \C778\C1C4 \C11C\BC84\B85C \C0AC\C6A9\D558\B294 XML\C774\C5B4\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113138472055400702)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \AC15\C870 \D45C\C2DC\C5D0\C11C \CC38\C870\B41C \C5F4 \C778\B371\C2A4\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113054167855400640)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \C775\C2A4\D3EC\D2B8 \D615\C2DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113138260273400702)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0\C11C \CC38\C870\B41C \C0C1\C704 \ADF8\B8F9 \C778\B371\C2A4\AC00 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113163468523400720)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D14C\C774\BE14\C758 %1 \C5F4\C740 "GENERATED ALWAYS" ID \C5F4\C785\B2C8\B2E4. \AD6C\C131 \B300\D654\C0C1\C790\C5D0\C11C %1 \C5F4\C5D0 \B9E4\D551\B41C \C18C\C2A4 \C5F4\C774 \C5C6\B294\C9C0 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113080858395400659)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \CEE4\BC0B \AC04\ACA9\C774 \B108\BB34 \B0AE\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113080982043400659)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \B85C\B4DC\C5D0 \B300\D574 \C81C\ACF5\B41C \C5F4\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113082168631400660)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\D589 \C120\D0DD\AE30 "%0"\C5D0 \B300\D55C \C5F4\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C790\B3D9 \AC10\C9C0\B97C \C2DC\B3C4\D558\AC70\B098 JSON \AD6C\C870\B97C \AC80\D1A0\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113090469932400666)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('XLSX \D30C\C77C\C5D0\C11C \C6CC\D06C\C2DC\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113090340774400666)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C0\C815\B41C \C6CC\D06C\C2DC\D2B8\AC00 XLSX \D30C\C77C\C5D0 \C874\C7AC\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113070529768400652)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\AC00 \C5C5\B370\C774\D2B8 \D504\B85C\C138\C2A4\B97C \C2DC\C791\D588\C73C\BBC0\B85C \B370\C774\D130\BCA0\C774\C2A4\C5D0 \C788\B294 \B370\C774\D130\C758 \D604\C7AC \BC84\C804\C774 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113072927163400654)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \C5F4\C744 \C5C5\B370\C774\D2B8\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113177666222400731)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C744(\B97C) SDO_GEOMETRY\B85C \BCC0\D658\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113117174139400686)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C720\D615\C774 %1\C778 %0 \C5F4\C740 VARCHAR2\B85C \BCC0\D658\D560 \C218 \C5C6\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113124167414400691)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C18D\C131\C5D0 \B300\D574 \C9C0\C815\B41C "%0" \C5F4\C744 \B370\C774\D130 \C18C\C2A4\C5D0\C11C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113065461166400648)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \AC12 \C5F4\C5D0 \B300\D574\C11C\B294 \D544\D130 \C720\D615 %0\C774(\AC00) \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113181023397400733)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'ko'
,p_message_text=>unistr('"\B2E4\C74C \C0AC\C774" \D544\D130\AC00 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113047567943400636)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C LOV \C720\D615\C774 \C9C0\C815\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113047486563400635)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \C720\D615\C774 \BD80\C801\D569\D569\B2C8\B2E4. \C9C8\C758 \C720\D615\C740 \D14C\C774\BE14, SQL \C9C8\C758 \B610\B294 SQL \C9C8\C758\B97C \BC18\D658\D558\B294 PL/SQL \D568\C218\C5EC\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113117270798400686)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL \C9C8\C758 \AD6C\BB38\BD84\C11D \C2E4\D328!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113124228241400691)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C18D\C131\C5D0 \B300\D574 \C9C0\C815\B41C \C5F4 \C704\CE58 %0\C744(\B97C) SQL \BB38\C5D0\C11C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113046040447400634)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \AC12 \D544\D130\C5D0 \B108\BB34 \B9CE\C740 \D56D\BAA9\C774 \C0AC\C6A9\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113124095339400691)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \C18D\C131\C5D0 \B300\D574 \C9C0\C815\B41C \C5F4\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113047369781400635)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38\C774 \AC12\C744 \BC18\D658\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113137260733400701)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4\C5D0 \C694\CCAD\B41C DML \C791\C5C5\C744 \CC98\B9AC\D558\AE30 \C704\D55C \C791\C5C5\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113043200924400632)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('GeoJSON\C5D0\C11C SDO_GEOMETRY\B85C\C758 \BCC0\D658(\C5F4 %0)\C740 \C774 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \C81C\ACF5\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113044369050400633)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'ko'
,p_message_text=>unistr('SDO_GEOMETRY \BCC0\D658(\C5F4 %0)\C740 XML \B370\C774\D130 \C18C\C2A4\C5D0 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113051619897400639)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \BB38\C790\B294 \B2E4\C911 \AC12 \AD6C\BD84 \AE30\D638\B85C \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113178949483400732)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D568\C218\B294 \C9C8\C758 \CEE8\D14D\C2A4\D2B8\C5D0 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113044433680400633)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \B370\C774\D130 \C720\D615\C774 \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113047248531400635)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B0B4\BD80 ORDS OUT \BC14\C778\B4DC \C81C\D55C\C774 \CD08\ACFC\B418\C5C8\C2B5\B2C8\B2E4. DML \D589 \C218\B97C \C904\C774\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113125047358400692)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C6D0\ACA9 \C11C\BC84\B85C\BD80\D130\C758 JSON \C751\B2F5\C744 \AD6C\BB38\BD84\C11D\D560 \C218 \C5C6\C2B5\B2C8\B2E4. '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113047185362400635)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C54C \C218 \C5C6\AC70\B098 \C798\BABB\B41C \CEE8\D14D\C2A4\D2B8 \C720\D615\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113141629517400704)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D30C\C77C \C720\D615\C740 \AD6C\BB38 \BD84\C11D\AE30\C5D0\C11C \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113096216779400670)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\B418\C9C0 \C54A\C740 \C561\C138\C2A4\C785\B2C8\B2E4. (wwv_flow_api.set_credentials\AC00 \C124\C815\B418\C9C0 \C54A\C74C)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113073246599400654)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C874\C7AC\D558\B294 \C791\C5C5\C601\C5ED\C774\BBC0\B85C \C0DD\C131\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113073136464400654)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C874\C7AC\D558\B294 \C0AC\C6A9\C790 \ADF8\B8F9\C774\BBC0\B85C \C0DD\C131\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113083474670400661)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D574 \C911\BCF5\B41C \C0AC\C6A9\C790 \C774\B984\C774 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113083596352400661)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790\B97C \B85C\B4DC\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. %0 \C0AC\C6A9\C790\C5D0 \B300\D574 \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113093425778400668)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\BA85\C758 \C0AC\C6A9\C790\B97C \B85C\B4DC\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113093299404400668)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'ko'
,p_message_text=>unistr('\BE44\BC00\BC88\D638')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113093371606400668)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD8C\D55C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113093033926400668)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113169507554400725)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 "#COMPONENT_NAME#"\C744 \B80C\B354\B9C1\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113089149670400665)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('HTML \D3FC\C774 \C544\C9C1 \C5F4\B9AC\C9C0 \C54A\C558\AE30 \B54C\BB38\C5D0 \D398\C774\C9C0 \D56D\BAA9\C744 \D45C\C2DC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113054461044400641)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 #COMPONENT_NAME#\C5D0 \B300\D55C \D56D\BAA9 \AE30\BCF8\AC12\C744 \ACC4\C0B0\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113088402761400665)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 #COMPONENT_NAME#\C5D0 \B300\D55C \D56D\BAA9 \C0AC\D6C4 \ACC4\C0B0\C5D0\C11C \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113088304227400665)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 #COMPONENT_NAME#\C5D0 \B300\D55C \D56D\BAA9 \C18C\C2A4 \AC12\C744 \ACC4\C0B0\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113068166036400650)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\B418\C9C0 \C54A\C740 \C561\C138\C2A4\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113088609641400665)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('JavaScript\AC00 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113088767463400665)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA9\B85D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113089367206400665)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758\B97C \CD08\AE30\D654\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113096501703400671)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C5C5\B370\C774\D2B8\B294 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113090726389400666)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\BD80\C801\D569\D55C \D56D\BAA9 ID: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113117048410400686)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D56D\BAA9\C5D0 \B300\D55C \B3C4\C6C0\B9D0\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113081581990400660)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\CC28\D2B8 \C9C8\C758 \C0DD\C131\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4. \C18C\C2A4 \BC0F \C5F4 \B9E4\D551 \C124\C815\C744 \D655\C778\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113176362771400730)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0MB \D06C\AE30\C758 \CCA8\BD80\AC00 \CD5C\B300 \CCA8\BD80 \D06C\AE30 %1MB\B97C \CD08\ACFC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113082486307400661)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'ko'
,p_message_text=>unistr('p_mail_id \B9E4\AC1C\BCC0\C218\C5D0 \BD80\C801\D569\D55C \AC12: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113199818935400747)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\B2F9 \CD5C\B300 \C804\C790\BA54\C77C \BA54\C2DC\C9C0 \C218\B97C \CD08\ACFC\D588\C2B5\B2C8\B2E4. \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113063476028400647)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D504\B85C\C2DC\C800\B294 \C560\D50C\B9AC\CF00\C774\C158 \C138\C158 \B0B4\C5D0\C11C \D638\CD9C\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113082309866400660)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \B9E4\AC1C\BCC0\C218\C5D0 \B300\D574 \B110 \AC12\C774 \C81C\ACF5\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113136374078400700)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('%1 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C804\C790\BA54\C77C \D15C\D50C\B9AC\D2B8 "%0"\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113212887588400756)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C77C\C744 \C804\C1A1\D558\B824\BA74 SMTP_HOST_ADDRESS \C778\C2A4\D134\C2A4 \B9E4\AC1C\BCC0\C218\B97C \C124\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113082032587400660)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C77C\C744 \C804\C1A1\D558\B824\BA74 \BA54\C2DC\C9C0 \BC1B\B294 \C0AC\B78C\C744 \C785\B825\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113202233749400749)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AD6C\C131\B41C \C804\C790\BA54\C77C \C11C\BC84\B97C \C0AC\C6A9\D558\C5EC SMTP \C811\C18D\C744 \C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113176418658400730)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'ko'
,p_message_text=>unistr('Ajax \D638\CD9C\C774 \BD80\C801\D569\D569\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113067880288400650)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D50C\B7EC\ADF8\C778\C5D0 \B300\D574 \C815\C758\B41C Ajax \D568\C218\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113166851734400723)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D50C\B7EC\ADF8\C778\C5D0 \B300\D574 \C815\C758\B41C \C2E4\D589 \D568\C218\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113067983801400650)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \D50C\B7EC\ADF8\C778\C5D0 \B300\D574 \C815\C758\B41C \B80C\B354\B9C1 \D568\C218\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113177327703400730)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4 \D50C\B7EC\ADF8\C778 "%0"\C5D0 "\AE30\B2A5" \D568\C218\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113177225814400730)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4 \D50C\B7EC\ADF8\C778 "%0"\C5D0 DML \D568\C218\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113177470290400730)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4 \D50C\B7EC\ADF8\C778 "%0"\C5D0\B294 \C2E4\D589 \D568\C218\AC00 \D3EC\D568\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113177512821400730)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4 \D50C\B7EC\ADF8\C778 "%0"\C5D0 \C778\CD9C \D568\C218\AC00 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113065670147400649)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B7EC\ADF8\C778 \CC98\B9AC \C911\C5D0 \BC1C\C0DD\D55C PLSQL \CF54\B4DC\C5D0 \C624\B958\AC00 \C788\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113072292457400653)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113102835106400675)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'ko'
,p_message_text=>unistr('\B370\C774\D130 \C720\D615 %0\C740(\B294) VARCHAR2\B85C \BCC0\D658\D560 \C218 \C5C6\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113188404631400738)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C18D\C131\C5D0 \B300\D574 \C9C0\C815\B41C "%0" \C5F4\C744 SQL \BB38\C5D0\C11C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113164712919400721)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'ko'
,p_message_text=>unistr('LOV(\AC12 \BAA9\B85D) \C9C8\C758 \B610\B294 \C774\B984\C774 \C9C0\C815\B41C \AC12 \BAA9\B85D\C744 %0\C5D0 \B300\D574 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113166329202400722)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C5D0 \B300\D574 LOV SQL \C9C8\C758\C5D0\C11C \C120\D0DD\B41C \C5F4 \C218\AC00 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4. \C801\D569\D55C \BA85\B839\BB38\C740 \C608\C81C\B97C \CC38\C870\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113188259268400738)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \C18D\C131\C5D0 \B300\D574 \C9C0\C815\B41C \C5F4\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113217981791400760)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C18D\C131\C5D0 \C785\B825\D55C \AC12 %0\C740(\B294) \C22B\C790\AC00 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113169874780400725)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('%0\C758 SQL \BB38\C5D0\C11C \B370\C774\D130 \C720\D615\C774 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4. Column# %1\C740(\B294) %2\C778\B370 %3\C774(\AC00) \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113188339059400738)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'ko'
,p_message_text=>unistr('"%1" \C18D\C131\C5D0 \B300\D574 \C9C0\C815\B41C "%0" \C5F4\C758 \B370\C774\D130 \C720\D615\C774 %2\C774\C9C0\B9CC %3\C774(\AC00) \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113064948489400648)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \B808\C774\C544\C6C3\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113124910560400692)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'ko'
,p_message_text=>unistr('REST \B370\C774\D130 \C18C\C2A4 \AE30\BC18 \BCF4\ACE0\C11C\C5D0\B294 \D569\ACC4 \ACC4\C0B0 \AE30\B2A5\C744 \C0AC\C6A9\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113088556673400665)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('ERR-2904 \B2E8\CD95\D0A4 \AC12\C744 \C124\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113092883224400668)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958: \C54C \C218 \C5C6\B294 \B2E8\CD95\D0A4 \C720\D615\C785\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113082854896400661)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C authentication_scheme\C744 \C778\CD9C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113156347761400715)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \C138\C158\C5D0 \B300\D55C \D14C\B10C\D2B8 ID\AC00 \C874\C7AC\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113093196878400668)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113217378504400760)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C99D\C744 \C2E4\D328\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113119646766400688)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'ko'
,p_message_text=>unistr('apex_util.g_request_cookies\C5D0 \C124\C815\B41C \D558\B098 \C774\C0C1\C758 \CFE0\D0A4\C5D0 \BD80\C801\D569\D55C \AC12\C774 \D3EC\D568\B429\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113102102813400675)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'ko'
,p_message_text=>unistr('UDDI \B808\C9C0\C2A4\D2B8\B9AC\C758 \C751\B2F5\C774 \BD80\C801\D569\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113065778296400649)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C81C\ACF5\B41C URL\C774 \C801\D569\D55C WSDL \BB38\C11C\B97C \BC18\D658\D558\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113068205664400650)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'ko'
,p_message_text=>unistr('WSDL \BB38\C11C\C5D0 \C5EC\B7EC SOAP \BC14\C778\B529\C774 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4. &PRODUCT_NAME.\C5D0\C11C\B294 SOAP \BC14\C778\B529\C774 \D558\B098\C778 WSDL\B9CC \C9C0\C6D0\D569\B2C8\B2E4. \C774 \C11C\BE44\C2A4\C5D0 \B300\D55C \CC38\C870 \C0DD\C131\C744 \ACC4\C18D\D558\B824\BA74 <b>\C218\B3D9\C73C\B85C \C6F9 \C11C\BE44\C2A4 \CC38\C870 \C0DD\C131</b>\C744 \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113136640975400701)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\BE44\C2A4\C758 \C751\B2F5\C774 XML\C774 \C544\B2D9\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113217274280400759)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'ko'
,p_message_text=>unistr('OAuth \C561\C138\C2A4 \D1A0\D070\C774 \C0AC\C6A9\D560 \C218 \C5C6\AC70\B098 \B9CC\B8CC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113180411434400733)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5\C601\C5ED\B2F9 \CD5C\B300 \C6F9 \C11C\BE44\C2A4 \C694\CCAD \C218\B97C \CD08\ACFC\D588\C2B5\B2C8\B2E4. \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113217479219400760)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C11C\BC84\AC00 \C9C0\C6D0\B418\C9C0 \C54A\B294 OAuth \D1A0\D070 \C720\D615\C73C\B85C \C751\B2F5\D588\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113067643632400650)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'ko'
,p_message_text=>unistr('WSDL \BB38\C11C\C5D0 \CC38\C870\B97C \CD94\AC00\D558\B294 \B370 \D544\C694\D55C SOAP \BC14\C778\B529\C774 \D3EC\D568\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113063529405400647)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 WSDL\C740 \C99D\BA85\C11C\B97C \D544\C694\B85C \D569\B2C8\B2E4. \C544\B798\C5D0 \C0AC\C6A9\C790 \C774\B984 \BC0F \BE44\BC00\BC88\D638\B97C \C81C\ACF5\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113072362635400653)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'ko'
,p_message_text=>unistr('\B80C\B354\B9C1 \C5D4\C9C4\C5D0\C11C WSDL \BB38\C11C\B97C \C778\C2DD\D558\C9C0 \BABB\D588\C2B5\B2C8\B2E4. \C774 \C11C\BE44\C2A4\C5D0 \B300\D55C \CC38\C870 \C0DD\C131\C744 \ACC4\C18D\D558\B824\BA74 <b>\C218\B3D9\C73C\B85C \C6F9 \C11C\BE44\C2A4 \CC38\C870 \C0DD\C131</b>\C744 \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113139217301400702)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5C5\B370\C774\D2B8\B97C \CC98\B9AC\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113165071512400721)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D\C758 \BC18\D658 \BC0F \D45C\C2DC \C5F4\C774 \B3D9\C77C\D569\B2C8\B2E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113164970178400721)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12 \BAA9\B85D\C5D0 \BC18\D658 \C5F4\C774 \C5C6\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113096460561400671)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C5F4 \AC12\C744 \C778\CD9C\D558\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113120419194400689)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'ko'
,p_message_text=>unistr('\D604\C7AC \D45C \D615\C2DD \D3FC \B370\C774\D130\AC00 \B108\BB34 \C624\B798\B418\C5C8\C2B5\B2C8\B2E4. \C18C\C2A4 \B370\C774\D130\AC00 \C218\C815\B418\C5C8\C2B5\B2C8\B2E4.<br/> \BCC0\ACBD\C0AC\D56D\C744 \BB34\C2DC\D558\ACE0 \B370\C774\D130\BCA0\C774\C2A4\C5D0\C11C \B370\C774\D130\B97C \C7AC\B85C\B4DC\D558\B824\BA74 <strong><a href="%0">\C5EC\AE30</a></strong>\B97C \B204\B974\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113078564903400658)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\D398\C774\C9C0 \BC88\D638 \B9E4\AE40 \BB38\C790\C5F4\C744 \D655\C778\D558\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113078448061400658)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C9C8\C758 \BA38\B9AC\AE00\C744 \D655\C778\D560 \C218 \C5C6\C74C:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113078636220400658)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\ACE0\C11C \BC14\B2E5\AE00\C744 \BC14\AFB8\B294 \C911 \C624\B958 \BC1C\C0DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113078774018400658)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL \C9C8\C758 \AD6C\BB38\BD84\C11D \C2E4\D328:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113083777680400661)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C694\CCAD\B41C \CD5C\C18C \D589: %0, \AC80\C0C9\B418\C5C8\C9C0\B9CC \D45C\C2DC\B418\C9C0 \C54A\C740 \D589: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113081299714400660)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \C5F4 #%0(%1)\C774(\AC00) \BD80\C801\D569\D569\B2C8\B2E4. HTML\C744 \C0AC\C6A9\D558\B294 \C5F4\C5D0\B294 \BCC4\CE6D \C774\B984\C774 \D544\C694\D569\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113096328691400670)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \BA38\B9AC\AE00\C744 \AC00\C838\C624\B294 \C911 \C624\B958 \BC1C\C0DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113078894721400658)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\BCF4\ACE0\C11C \C624\B958:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113116547830400686)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C5F4\C744 \AE30\C900\C73C\B85C \C815\B82C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113081378279400660)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\C9C8\C758 \AD6C\BB38\C744 \BD84\C11D\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C9C8\C758 \AD6C\BB38\C744 \D655\C778\D558\C2ED\C2DC\C624.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113120522087400689)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D3FC\C5D0\B294 \C800\C7A5\B418\C9C0 \C54A\C740 \BCC0\ACBD\C0AC\D56D\C774 \D3EC\D568\B429\B2C8\B2E4. \BCC0\ACBD\C0AC\D56D\C744 \C800\C7A5\D558\C9C0 \C54A\ACE0 \ACC4\C18D\D558\B824\BA74 "\D655\C778"\C744 \B204\B974\C2ED\C2DC\C624. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113124893993400692)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'ko'
,p_message_text=>unistr('\C120\D0DD\B41C \B370\C774\D130 \C18C\C2A4\C5D0\B294 \BCF4\ACE0\C11C \D398\C774\C9C0 \B9E4\AE40 \CCB4\ACC4(%0)\AC00 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113081130911400660)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C9C8\C758 \C5F4 #%0(%1)\C774(\AC00) \BD80\C801\D569\D569\B2C8\B2E4. \C5F4 \BCC4\CE6D\C744 \C0AC\C6A9\D558\C2ED\C2DC\C624.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113083882335400662)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'ko'
,p_message_text=>unistr('%0-%1/ %2\D589 \CD08\ACFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113122595664400690)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'ko'
,p_message_text=>unistr('%2 \CD08\ACFC %0 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113083626164400661)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'ko'
,p_message_text=>unistr('%0-%1/%2 \D589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113067593104400650)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'ko'
,p_message_text=>'%0-%1/%2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113078939530400658)
,p_name=>'Y'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113085097382400662)
,p_name=>'YEAR'
,p_message_language=>'ko'
,p_message_text=>unistr('\B144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113078119215400657)
,p_name=>'YEARS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113120618797400689)
,p_name=>'YES'
,p_message_language=>'ko'
,p_message_text=>unistr('\C608')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4478)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4478)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('\B370\C2A4\D06C\D1B1')
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4478
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4478)
,p_name=>unistr('\BA54\C2DC\C9C0')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('\BA54\C2DC\C9C0')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
