prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4494
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4494 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4494
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116102776023403691')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'nl'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4494)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113352'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4494)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4494)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4494)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4494)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4494)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4494)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4494)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4494)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4494)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4494)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4494)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4494)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4494)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.nl'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4494
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4494)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4494)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4494)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4494)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4494)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4494)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4494)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.nl'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4494
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4494)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4494)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4494)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4494)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4494)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4494)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4494)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.nl'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4494
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4494)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4494)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4494)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4494)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4494)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4494)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4494)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4494)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4494)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4494)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4494)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4494)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4494)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4494)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4494)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4494)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4494)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.nl'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4494
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4494)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4494)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4494)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4494)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4494)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4494)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4494)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4494)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4494)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4494)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4494)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4494)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4494)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4494)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4494)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.nl'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4494
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4494)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4494)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4494)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4494)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4494)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4494)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4494)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4494)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4494)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4494)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4494)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4494)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4494)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4494)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4494)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.nl'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4494
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4494)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4494)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4494)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4494)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4494)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4494)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4494)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4494)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4494)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4494)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4494)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4494)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4494)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4494)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4494)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.nl'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4494
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4494)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4494)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4494)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4494)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4494)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4494)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4494)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4494)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4494)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4494)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4494)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4494)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4494)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4494)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4494)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4494
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4494)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4494
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4494)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4494
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4494)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4494
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4494)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4494
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4494)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4494
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4494)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4494
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4494)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4494)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4494)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4494)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4494)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4494)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4494)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4494)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4494)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4494)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4494)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4494)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4494)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4494)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4494
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4494)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4494)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4494)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4494)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4494)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4494)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4494)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4494)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4494)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4494
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4494)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4494)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4494)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4494)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4494)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4494)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4494)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4494)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4494)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4494)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4494)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4494)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4494)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4494)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4494)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4494)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4494)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4494)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4494)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4494)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4494)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4494)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4494)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4494)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4494)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4494
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4494)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4494)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4494)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4494)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4494)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4494)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4494)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4494)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4494)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4494)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4494
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4494)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4494)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4494)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4494)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4494)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4494
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4494)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4494)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4494)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4494)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4494)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4494)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4494)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4494
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4494)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4494)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4494)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4494)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4494)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4494
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4494)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4494)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4494)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4494)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4494)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4494
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4494)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4494)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4494)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4494)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4494)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4494)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4494)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4494)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4494)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4494
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4494)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4494)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4494)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4494)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4494)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4494)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4494)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4494)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4494)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4494)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4494)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4494)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4494)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4494)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4494
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4494)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4494)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4494)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4494)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4494)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4494
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4494)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4494
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4494)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4494
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4494)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4494
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4494)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4494
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4494)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4494
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4494)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4494)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4494)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4494)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4494)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4494)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4494)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4494)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4494)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4494
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4494)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4494)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4494)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4494)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4494)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4494)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4494)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4494
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4494)
,p_page_name=>'winlov'
,p_page_title=>'Dialoogvenster Zoeken'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Zoeken'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Sluiten'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Volgende &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Vorige'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Rij(en) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4494
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4494)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4494
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4494)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4494)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4494)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4494)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4494)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4494)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4494)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4494)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4494)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4494)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4494)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4494)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4494)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4494)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4494)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4494)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4494)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4494)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4494)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4494)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4494)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4494)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4494)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4494)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4494)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4494)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4494)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4494)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4494)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4494)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4494)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4494)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4494)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4494)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4494)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4494)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4494)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4494)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4494)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4494)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4494)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4494)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4494)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4494)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4494)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4494)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4494)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4494)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4494)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4494)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4494)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4494)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4494)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4494)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4494)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4494)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4494)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4494)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4494)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4494)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4494)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4494)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4494)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4494)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4494)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4494)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4494)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4494)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4494)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4494)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4494)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4494)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4494)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4494)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4494)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4494)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4494)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4494)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4494)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4494)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4494)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4494)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4494)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4494)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4494)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4494)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4494)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4494)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4494)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4494)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4494)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4494)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4494)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4494)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4494)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4494)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4494)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4494)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4494)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4494)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4494)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4494)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4494)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4494)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4494)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4494)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4494)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4494)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4494)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4494)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4494)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4494)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4494)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4494)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4494)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4494)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4494)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4494)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4494)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4494)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4494)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4494)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4494)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4494)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4494)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4494)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4494)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4494)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4494)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4494)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4494)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4494)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4494)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4494)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4494)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4494)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4494)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4494)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4494)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4494)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4494)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4494)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4494)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4494)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4494)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4494)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4494)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4494)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4494)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4494)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4494)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4494)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4494)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4494)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4494)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4494)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4494)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4494)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4494)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4494)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4494)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4494)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4494)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4494)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4494)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4494)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4494)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4494)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4494)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4494)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4494)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4494)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4494)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4494)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4494)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4494)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4494)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4494)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4494)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4494)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4494)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4494)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4494)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4494)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4494)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4494)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4494)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4494)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4494)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4494)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4494)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4494)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4494)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4494)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4494)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4494)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4494)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4494)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4494)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4494)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4494)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4494)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4494)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4494)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4494)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4494)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4494)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113253645022400794)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'nl'
,p_message_text=>'Kolom %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113240772273400784)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'nl'
,p_message_text=>'Beheerder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113240689952400784)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'nl'
,p_message_text=>'Gebruikersnaam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113297987560400828)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'nl'
,p_message_text=>'Toegang geweigerd'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113257682512400798)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'nl'
,p_message_text=>'Uw %0 account is gemaakt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113243279567400786)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'nl'
,p_message_text=>'De account is vergrendeld.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113233101257400778)
,p_name=>'AM_PM'
,p_message_language=>'nl'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113367595990400879)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'nl'
,p_message_text=>'%0 in-/uitschakelen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113375631310400885)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'nl'
,p_message_text=>'(Actief)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113345192617400863)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Ajax-aanroep heeft serverfout %0 geretourneerd voor %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113275998613400812)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'nl'
,p_message_text=>'De applicatiealias "%0" kan niet worden geconverteerd naar een unieke applicatie-ID.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113276003288400812)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Er bestaat geen applicatie met de alias "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113265619188400804)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'ERR-1816 Er is een onverwachte fout opgetreden bij het converteren van de applicatiealias p_flow_alias_or_id (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113358527429400873)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'nl'
,p_message_text=>unistr('Met de controletelling voor de applicatie kan eenvoudig worden bepaald of dezelfde applicatie in meerdere werkruimten wordt ge\00EFmplementeerd. U kunt deze controletelling vergelijken om te bepalen of er een overeenkomst is. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113251494178400793)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het verwerken van de verificatiefunctie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113236899174400781)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het verwerken van de verificatiefunctie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113400336558400904)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'nl'
,p_message_text=>'De tenantnaam %0 die door Oracle Cloud Identity Management is geretourneerd, is niet geautoriseerd voor het domein %1.<br/><a href="&LOGOUT_URL.">Log opnieuw in</a> en geef een geautoriseerde tenantnaam op of wijzig de URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113234539480400779)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'nl'
,p_message_text=>'Uw account "%0" heeft niet de benodigde ontwikkelrechten (DB_DEVELOPER of DB_ADMINISTRATOR)<br/>voor werkruimte "%1". <a href="&LOGOUT_URL.">Log opnieuw in</a> nadat de rechten zijn verkregen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113233626122400779)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'nl'
,p_message_text=>'De tenantnaam die door Oracle Cloud Identity Management is geretourneerd, is niet geautoriseerd voor de huidige werkruimte.<br/><a href="&LOGOUT_URL.">Log opnieuw in</a> en geef een geautoriseerde tenantnaam op.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113234648389400779)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'nl'
,p_message_text=>'Om beveiligingsredenen is het niet toegestaan applicaties van deze werkruimte uit te voeren via het domein in de URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113251196042400793)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'nl'
,p_message_text=>'Vraag de databasebeheerder om $OH/rdbms/admin/catldap.sql uit te voeren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113251067719400792)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'nl'
,p_message_text=>'Het SYS.DBMS_LDAP-package bestaat niet of is ongeldig.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113250995632400792)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het verwerken van de bewerking van de LDAP-gebruikersfunctie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113251231347400793)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het verwerken van de LDAP-verificatie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113252005805400793)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden in argument p_flow_page voor de login_page-procedure.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113251636270400793)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige p_session op wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113299558079400829)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'nl'
,p_message_text=>'Onjuist argument voor wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113251783311400793)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'nl'
,p_message_text=>'Er is een NULL-gebruikersnaam doorgegeven aan de inlogprocedure.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113240526954400784)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'nl'
,p_message_text=>'Wacht <span id="apex_login_throttle_sec">%0</span> seconden voordat u opnieuw inlogt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113241875301400785)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'nl'
,p_message_text=>'De inlogpoging is geblokkeerd.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113297336387400827)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Verificatie "%0" is niet gevonden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113242195088400785)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'nl'
,p_message_text=>'De ID van de beveiligingsgroep is NULL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113251593753400793)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het uitvoeren van het proces voor verificatie achteraf.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113251313480400793)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het verwerken van het proces voor verificatie vooraf.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113252504167400794)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Open de URL in dezelfde browser waarin u de aanvraag voor het opnieuw instellen van het wachtwoord hebt gestart. Als u op de URL voor het  opnieuw instellen van het wachtwoord klikt en wordt omgeleid naar',
'de inlogpagina, start u de aanvraag voor het opnieuw instellen van het wachtwoord opnieuw en laat u de',
'browser open.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113397805189400902)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'nl'
,p_message_text=>'URL voor opnieuw instellen van wachtwoord'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113234842555400780)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'nl'
,p_message_text=>'Gebruikersgroep %0 van de resourcemanager is niet toegekend aan %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113234938044400780)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'nl'
,p_message_text=>'Gebruik DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP om de ontbrekende rechten toe te kennen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113262904064400802)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het verwerken van de sessiesentryfunctie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113263086360400802)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het verwerken van de sessieverificatiefunctie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113263288707400802)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'nl'
,p_message_text=>'Vraag de %0 beheerder om de engine voor Single Sign-On van Oracle Application Server te configureren:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113272762523400809)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige %0 in %1-token dat via SSO is geretourneerd'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113251968160400793)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'nl'
,p_message_text=>'Bewerk het verificatieschema en voeg de applicatienaam toe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113272448647400809)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige aanroeper van procedure %0:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113272694245400809)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige applicatiesessie in URLC-token: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113272287815400809)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'nl'
,p_message_text=>'Fout bij portal_sso_redirect: applicatieregistratiegegevens ontbreken: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113263109130400802)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'nl'
,p_message_text=>'Het WWSEC_SSO_ENABLER_PRIVATE-package bestaat niet of is ongeldig.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113251895027400793)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'nl'
,p_message_text=>'De naam van de geregistreerde partnerapplicatie is niet gevonden in het verificatieschema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113272390644400809)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'nl'
,p_message_text=>'Registreer deze applicatie zoals beschreven in de installatiehandleiding.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113263359535400802)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het verwerken van de SSO-verificatie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113372793112400883)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'nl'
,p_message_text=>'Niet-geautoriseerde URL: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113262786416400801)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het verwerken van de verificatie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113234793775400780)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'nl'
,p_message_text=>'Werkruimte "%0" is inactief. Neem contact op met de beheerder.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113235191873400780)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'nl'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113241515088400785)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'nl'
,p_message_text=>'Toegang is geweigerd door beveiligingscontrole van de applicatie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113241655561400785)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'nl'
,p_message_text=>'Toegang is geweigerd door beveiligingscontrole van de pagina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113241762051400785)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het verwerken van de autorisatie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113305181089400833)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'nl'
,p_message_text=>'Opgebouwd met %0 met behulp van %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113305224155400833)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'nl'
,p_message_text=>'love'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113363051681400876)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'nl'
,p_message_text=>'Eventbeschrijving'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113362871560400876)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'nl'
,p_message_text=>'Einddatum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113363115818400876)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'nl'
,p_message_text=>'Event-ID'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113362771116400876)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'nl'
,p_message_text=>'Begindatum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113362994788400876)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Titel activiteit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113253552609400794)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Fout in inhoud controletelling'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113253417927400794)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Fout in indeling controletelling'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113317416243400842)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'nl'
,p_message_text=>'Gekopieerd naar klembord'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113317161764400842)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'nl'
,p_message_text=>unistr('In deze browser wordt kopi\00EBren via een knop of menu niet ondersteund. Probeer Ctrl+C of Command+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113305680636400833)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'nl'
,p_message_text=>'Melding sluiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113361667176400875)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'nl'
,p_message_text=>'Contrast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113356138294400871)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'nl'
,p_message_text=>'Huidige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113356081382400871)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'nl'
,p_message_text=>'Oorspronkelijke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113360212004400874)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# moet een geldige kleur zijn. Bijvoorbeeld: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113355954022400871)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'nl'
,p_message_text=>'Kleur kiezen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113356282936400871)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Kleuropmaak wijzigen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113395480574400900)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'nl'
,p_message_text=>'Waardelijst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113395573361400900)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'nl'
,p_message_text=>'Lijst openen voor: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113375783193400885)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'nl'
,p_message_text=>'(Voltooid)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113268074065400806)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'nl'
,p_message_text=>'Neem contact op met de applicatiebeheerder.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113282471215400816)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Neem contact op met de applicatiebeheerder.',
'Details van dit incident zijn beschikbaar via foutenopsporings-ID "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113360524530400874)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'nl'
,p_message_text=>'Corrigeer de fouten voordat u doorgaat.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113306581090400834)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'nl'
,p_message_text=>'%0 matches gevonden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113306493850400834)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'nl'
,p_message_text=>'Geen matches gevonden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113376204904400886)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'nl'
,p_message_text=>'Huidige voortgang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113360975042400875)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Het bestand dat is opgegeven in item %0 bestaat niet in APEX_APPLICATION_TEMP_FILES.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113349471744400866)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'nl'
,p_message_text=>'De huidige versie van de gegevens in de database is gewijzigd nadat de gebruiker het updateproces heeft gestart.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113318580173400843)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'nl'
,p_message_text=>'Niet laden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113365509586400878)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'nl'
,p_message_text=>'Fout bij voorverwerking'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113365314966400878)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'nl'
,p_message_text=>'Rij invoegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113379425859400888)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'nl'
,p_message_text=>'Volgnummer : Actie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113365499870400878)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'nl'
,p_message_text=>'Rij bijwerken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113306963144400834)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'nl'
,p_message_text=>'Pop-upkalender: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113229568665400775)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'nl'
,p_message_text=>'Volgende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113229636323400775)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'nl'
,p_message_text=>'Vorige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113365769129400878)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# moet een waarde hebben.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113365639286400878)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# moet een geldige datum zijn. Bijvoorbeeld: %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113233241432400778)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# moet tussen %0 en %1 liggen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113233359246400778)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# moet gelijk zijn aan of later zijn dan %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113233432341400779)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# moet gelijk zijn aan of eerder zijn dan %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113310415730400837)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# is later dan de opgegeven maximumdatum %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113310895831400837)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# komt niet overeen met de indeling %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113310338970400837)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# is eerder dan de opgegeven minimumdatum %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113310572192400837)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# bevindt zich niet in het geldige bereik van %0 t/m %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113310729698400837)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# bevindt zich niet binnen het geldige jaarbereik van %0 en %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113360834788400874)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'nl'
,p_message_text=>'Annuleren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113388020615400894)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'nl'
,p_message_text=>'Sluiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113390036944400896)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'nl'
,p_message_text=>'Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113360644361400874)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'nl'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113360763887400874)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'nl'
,p_message_text=>'Opslaan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113266999191400805)
,p_name=>'APEX.ERROR'
,p_message_language=>'nl'
,p_message_text=>'Fout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113234302615400779)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'nl'
,p_message_text=>'De volgende fout heeft zich voorgedaan bij de uitvoering van de foutafhandelingscallback: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113243080063400786)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het opbouwen van de foutpagina: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113235044782400780)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'nl'
,p_message_text=>'Interne fout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113374896793400885)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Neem contact op met de beheerder.',
'Details van dit incident zijn beschikbaar via foutenopsporings-ID "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113369140844400880)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'nl'
,p_message_text=>'De database is open voor alleen-lezentoegang.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113399711512400903)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'nl'
,p_message_text=>'ORA-28353: wallet is niet geopend. Applicatiegegevens zijn momenteel niet toegankelijk.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113369271681400881)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'nl'
,p_message_text=>'Deze pagina is niet beschikbaar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113236796523400781)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'nl'
,p_message_text=>'Technische informatie (alleen zichtbaar voor ontwikkelaars)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113332814985400854)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'nl'
,p_message_text=>'Foutmelding'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113346757419400864)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'nl'
,p_message_text=>'Verwachte indeling: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113313419047400839)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'nl'
,p_message_text=>'De gebruiker staat al op de toegangscontrolelijst.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113313317065400839)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'nl'
,p_message_text=>'Bevestig dat u de volgende %0 gebruiker(s) wilt toevoegen aan de toegangscontrolelijst <strong>%1</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113313876260400839)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'nl'
,p_message_text=>'Er bestaat een dubbele gebruiker.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113313505795400839)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'nl'
,p_message_text=>'Ontbrekend apenstaartje (@) in e-mailadres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113313675342400839)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'nl'
,p_message_text=>'Ontbrekende punt (.) in e-mailadres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113313724309400839)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'nl'
,p_message_text=>'Gebruikersnaam is te lang.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113314021903400839)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'nl'
,p_message_text=>'Alleen gebruikers die zijn gedefinieerd in de toegangscontrolelijst van de applicatie hebben toegang tot deze applicatie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113314159084400839)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'nl'
,p_message_text=>'Onverwachte waarde in toegangscontrole-instelling: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113313965881400839)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'nl'
,p_message_text=>'Alle geverifieerde gebruikers hebben toegang tot deze applicatie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113356778176400871)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'nl'
,p_message_text=>'Inactief'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113356693322400871)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'nl'
,p_message_text=>'Geactiveerd'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113356998200400872)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'nl'
,p_message_text=>'%0: is inactief'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113356885652400871)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'nl'
,p_message_text=>'%0: is geactiveerd'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113356544887400871)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'nl'
,p_message_text=>unistr('niet ge\00EFdentificeerd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113349632729400866)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'nl'
,p_message_text=>'Downloaden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113306196209400834)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'nl'
,p_message_text=>'Toegepast filter %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113347203645400864)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'nl'
,p_message_text=>'Toepassen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113232176682400777)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'nl'
,p_message_text=>'Staafdiagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113359962184400874)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'nl'
,p_message_text=>'Overige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113232271679400778)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'nl'
,p_message_text=>'Cirkeldiagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113358618982400873)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Grafiek'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113231968038400777)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Aantal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113347705365400865)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'nl'
,p_message_text=>'Wissen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113347825397400865)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'nl'
,p_message_text=>'Alles wissen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113347947551400865)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'nl'
,p_message_text=>'%0 wissen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113365109911400878)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'nl'
,p_message_text=>'Kolom %1, waarnaar wordt verwezen door facet %0, is niet beschikbaar of niet-geautoriseerd.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113222354119400770)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Te tonen filters kiezen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113304349849400832)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'nl'
,p_message_text=>'%0 resultaten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113304493102400832)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'nl'
,p_message_text=>'%0 geselecteerd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113307078619400834)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'nl'
,p_message_text=>'Huidige filters'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113223811597400771)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'nl'
,p_message_text=>'Filterlijst'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113363624369400876)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'nl'
,p_message_text=>'Afzonderlijke waardelimiet (%0) overschreden voor facet %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113349241182400866)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Facet %0 wordt niet ondersteund voor DATE- of TIMESTAMP-kolommen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113347379320400865)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'nl'
,p_message_text=>'Filter %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113347448203400865)
,p_name=>'APEX.FS.GO'
,p_message_language=>'nl'
,p_message_text=>'Uitvoeren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113348813028400866)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'nl'
,p_message_text=>'is gelijk aan %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113232903740400778)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'nl'
,p_message_text=>'bevat %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113232636644400778)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'nl'
,p_message_text=>'groter dan %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113232769565400778)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'nl'
,p_message_text=>'is groter dan of gelijk aan %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113232440043400778)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'nl'
,p_message_text=>'kleiner dan %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113232590714400778)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'nl'
,p_message_text=>'is kleiner dan of gelijk aan %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113232817261400778)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'nl'
,p_message_text=>'begint met %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113235383050400780)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Het gegevenstype %0 (%1) wordt niet ondersteund voor het invoerveldfacet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113225566952400772)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'nl'
,p_message_text=>'Voor facetten met meerdere waarden is database 12.2 of hoger vereist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113349053943400866)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'nl'
,p_message_text=>'Er zijn geen zoekkolommen opgegeven voor facet %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113222481767400770)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'nl'
,p_message_text=>'Meer filters'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113304549118400832)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'nl'
,p_message_text=>'Begin bereik:'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113348534224400865)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'nl'
,p_message_text=>'%0 t/m %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113348688500400865)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'nl'
,p_message_text=>'Meer dan %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113348719142400866)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'nl'
,p_message_text=>'Minder dan %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113304605453400832)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'nl'
,p_message_text=>'Einde bereik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113367409876400879)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'nl'
,p_message_text=>'Waardelijstitem #%2 ("%1") voor bereikfacet %0 is ongeldig (scheidingsteken "|" ontbreekt).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113348966183400866)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'nl'
,p_message_text=>'Handmatige invoer voor bereikfacet %0 wordt momenteel niet ondersteund, aangezien de kolom een DATE- of TIMESTAMP-kolom is.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113348260166400865)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'nl'
,p_message_text=>'t/m'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113232007266400777)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'nl'
,p_message_text=>'Grafiek verwijderen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113301156105400830)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'nl'
,p_message_text=>'Opnieuw instellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113347688763400865)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Zoeken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113347516457400865)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'nl'
,p_message_text=>'Bezig met zoeken...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113348490781400865)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'nl'
,p_message_text=>'- Selecteren -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113231869648400777)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'nl'
,p_message_text=>'Grafiek tonen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113348032395400865)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'nl'
,p_message_text=>'Minder tonen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113348147214400865)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'nl'
,p_message_text=>'Meer tonen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113348382851400865)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'nl'
,p_message_text=>'%0 en meer sterren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113306009409400833)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'nl'
,p_message_text=>'Filtersuggesties'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113349154314400866)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Tekstveldfacet %0 wordt momenteel alleen ondersteund voor NUMBER-kolommen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113222294399400770)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Totaal aantal rijen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113365200203400878)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Het gegevenstype %0 (%1) wordt niet ondersteund voor gefacetteerd zoeken.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113357186704400872)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Ga naar fout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113314736213400840)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'nl'
,p_message_text=>'Aggregatie.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113322346168400846)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'nl'
,p_message_text=>'Groepsverandering samenvouwen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113314858720400840)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'nl'
,p_message_text=>'Groepsverandering.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113322204693400846)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'nl'
,p_message_text=>'Groepsverandering uitvouwen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113400959470400904)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'nl'
,p_message_text=>'Kolom %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113322012808400846)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'nl'
,p_message_text=>'%0 rijen verwijderd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113392416309400898)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'nl'
,p_message_text=>'Dubbele identiteit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113311761094400838)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'nl'
,p_message_text=>'Eerste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113315091286400840)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'nl'
,p_message_text=>'Groepskoptekst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113314902535400840)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'nl'
,p_message_text=>'Koptekst.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113311845043400838)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'nl'
,p_message_text=>'Laatste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113331898937400853)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'nl'
,p_message_text=>'Meer rijen laden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113311579789400838)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'nl'
,p_message_text=>'Volgende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113315145756400840)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'nl'
,p_message_text=>'Paginarijen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113311982226400838)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'nl'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113312052184400838)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'nl'
,p_message_text=>'%0 - %1 van %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113368018005400880)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'nl'
,p_message_text=>'Paginaselectie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113311654654400838)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'nl'
,p_message_text=>'Vorige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113392287094400898)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'nl'
,p_message_text=>'Toegevoegd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113392328593400898)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'nl'
,p_message_text=>'Gewijzigd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113400796522400904)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'nl'
,p_message_text=>'Rij %0, kolom %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113400838316400904)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'nl'
,p_message_text=>'Rij %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113392143711400898)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'nl'
,p_message_text=>'Verwijderd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113315370522400840)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'nl'
,p_message_text=>'Rijkoptekst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113310962142400837)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'nl'
,p_message_text=>'%0 cellen geselecteerd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113312194409400838)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'nl'
,p_message_text=>'%0 rijen geselecteerd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113352489889400868)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'nl'
,p_message_text=>'Alles selecteren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113322170176400846)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'nl'
,p_message_text=>'Pagina %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113315267150400840)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'nl'
,p_message_text=>'Rij selecteren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113315428449400841)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'nl'
,p_message_text=>'Oplopend gesorteerd %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113315576147400841)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'nl'
,p_message_text=>'Aflopend gesorteerd %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113311070554400837)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'nl'
,p_message_text=>'Oplopend sorteren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113311329641400837)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'nl'
,p_message_text=>'Oplopend sorteren %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113311165554400837)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'nl'
,p_message_text=>'Aflopend sorteren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113311494195400837)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'nl'
,p_message_text=>'Aflopend sorteren %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113311221221400837)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'nl'
,p_message_text=>'Niet sorteren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113321927903400846)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'nl'
,p_message_text=>'Totaal %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113248317516400790)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'nl'
,p_message_text=>'De HTTP-aanvraag bij "%0" is mislukt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113389633137400896)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'nl'
,p_message_text=>'Rasterselectielijst %0 kolommen %1 rijen. Gebruik pijltoetsen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113321866409400846)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'nl'
,p_message_text=>'Selectielijst %0 rijen. Gebruik pijltoetsen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113400525749400904)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Interactief raster %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113308630501400835)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'nl'
,p_message_text=>'Acties'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113309680895400836)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'nl'
,p_message_text=>'Toevoegen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113309577701400836)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'nl'
,p_message_text=>'Rij toevoegen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113394091116400899)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'nl'
,p_message_text=>'Aggregatie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113379595780400888)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'nl'
,p_message_text=>'Aggregatie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113381250097400889)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'nl'
,p_message_text=>'Alles'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113337671020400857)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Alle tekstkolommen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113338861005400858)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'nl'
,p_message_text=>'Alternatief'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113339921788400859)
,p_name=>'APEX.IG.AND'
,p_message_language=>'nl'
,p_message_text=>'en'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113359388009400873)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'nl'
,p_message_text=>'Aantal verschillende waarden (ongeveer)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113395019884400900)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'nl'
,p_message_text=>'Algeheel aantal verschillende waarden (ongeveer)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113378128092400887)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'nl'
,p_message_text=>'Vlak'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113380005141400889)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'nl'
,p_message_text=>'Oplopend'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113338972939400858)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'nl'
,p_message_text=>'Autorisatie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113394199904400899)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'nl'
,p_message_text=>'Automatisch'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113359709311400874)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'nl'
,p_message_text=>'Gemiddelde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113394775922400900)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'nl'
,p_message_text=>'Algeheel gemiddelde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113377626784400887)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Titel labelas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113377859305400887)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'nl'
,p_message_text=>'Decimalen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113377757195400887)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Titel waardeas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113383895131400891)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'nl'
,p_message_text=>'Achtergrondkleur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113378232922400887)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'nl'
,p_message_text=>'Staaf'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113334200412400855)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'nl'
,p_message_text=>'tussen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113385041780400892)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'nl'
,p_message_text=>'Beide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113378355274400887)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'nl'
,p_message_text=>'Bellen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113309834486400836)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'nl'
,p_message_text=>'Annuleren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113339809838400859)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'nl'
,p_message_text=>'Hoofdlettergevoelig'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113395695961400900)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'nl'
,p_message_text=>'(Hoofdlettergevoelig)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113366590284400879)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'nl'
,p_message_text=>'Wijzigingen zijn opgeslagen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113310221483400837)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'nl'
,p_message_text=>'Weergave wijzigen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113340931421400860)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'nl'
,p_message_text=>'Grafiek'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113337481490400857)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'nl'
,p_message_text=>'Uw query overschrijdt het maximum van %0 gegevenspunten per grafiek. Pas een filter toe om het aantal records in uw basisquery te verminderen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113308591701400835)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'nl'
,p_message_text=>'Grafiekweergave'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113315838310400841)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'nl'
,p_message_text=>'Wissen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113377176777400886)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Sluiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113384040221400891)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'nl'
,p_message_text=>'Kleuren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113360129913400874)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'nl'
,p_message_text=>'Voorbeeld'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113339205677400858)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Kolom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113308708346400835)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Kolommen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113385867124400893)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Kolomdoel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113339387211400859)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'nl'
,p_message_text=>'Complex'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113308925527400836)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'nl'
,p_message_text=>'Berekenen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113334807963400855)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'nl'
,p_message_text=>'bevat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113341105872400860)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'nl'
,p_message_text=>'Groepsverandering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113315615817400841)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'nl'
,p_message_text=>unistr('Naar klembord kopi\00EBren')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113315716869400841)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'nl'
,p_message_text=>unistr('Omlaag kopi\00EBren')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113359102940400873)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'nl'
,p_message_text=>'Aantal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113359284822400873)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'nl'
,p_message_text=>'Aantal verschillende waarden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113394930669400900)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'nl'
,p_message_text=>'Algeheel aantal verschillende waarden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113394871576400900)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'nl'
,p_message_text=>'Algeheel aantal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113392505258400898)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'nl'
,p_message_text=>'%0 maken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113337830761400857)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'nl'
,p_message_text=>'Gegevens'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113385664998400893)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Gegevenssoort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113385260283400892)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'nl'
,p_message_text=>'Datum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113366371466400878)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige datumwaarde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113335500016400856)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'nl'
,p_message_text=>'dagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113338598720400858)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'nl'
,p_message_text=>'Standaardinstellingen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113338363917400858)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Standaardtype'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113309759975400836)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'nl'
,p_message_text=>'Verwijderen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113386815503400894)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'nl'
,p_message_text=>'Wilt u dit rapport verwijderen?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113342938195400861)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'nl'
,p_message_text=>'Rij verwijderen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113341702762400860)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'nl'
,p_message_text=>'Rijen verwijderen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113380102006400889)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'nl'
,p_message_text=>'Aflopend'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113340669860400859)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'nl'
,p_message_text=>'Detail'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113308204726400835)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'nl'
,p_message_text=>'Detailweergave'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113368814988400880)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'nl'
,p_message_text=>'Richting'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113340359785400859)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'nl'
,p_message_text=>'Inactief'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113334953821400855)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'nl'
,p_message_text=>'bevat niet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113335134462400856)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'nl'
,p_message_text=>'begint niet met'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113378404922400887)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'nl'
,p_message_text=>'Ring'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113341306087400860)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'nl'
,p_message_text=>'Downloaden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113240022631400784)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'nl'
,p_message_text=>'Alleen gegevens'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113387802693400894)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'nl'
,p_message_text=>'Indeling kiezen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113252695433400794)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'nl'
,p_message_text=>'Downloadindeling %0 is niet actief.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113380880202400889)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'nl'
,p_message_text=>'Dubbele aggregatie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113380937444400889)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'nl'
,p_message_text=>'Dubbele groepsverandering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113342895390400861)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'nl'
,p_message_text=>'Dubbele rij'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113341624471400860)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'nl'
,p_message_text=>'Dubbele rijen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113309352298400836)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'nl'
,p_message_text=>'Bewerken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113379910899400888)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'nl'
,p_message_text=>'Grafiek bewerken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113391443811400897)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'nl'
,p_message_text=>'GROUP BY bewerken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113387403935400894)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'nl'
,p_message_text=>'Blinde kopie (BCC)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113387610960400894)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'nl'
,p_message_text=>'Bericht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113387373313400894)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'nl'
,p_message_text=>'Kopie (CC)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113387049120400894)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'nl'
,p_message_text=>'Het e-mailbericht is verstuurd.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113387565841400894)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'nl'
,p_message_text=>'Onderwerp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113387227420400894)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'nl'
,p_message_text=>'Ontvangers (t/m)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113340034655400859)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'nl'
,p_message_text=>'Geactiveerd'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113333296508400854)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'nl'
,p_message_text=>'is gelijk aan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113386485340400893)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'nl'
,p_message_text=>'Voorbeeld'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113340156003400859)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'nl'
,p_message_text=>'Uitdrukking'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113386385686400893)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113352333418400868)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'nl'
,p_message_text=>'Het bestand is voorbereid. Het downloaden wordt gestart.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113315953927400841)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'nl'
,p_message_text=>'Opvulling'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113317050006400842)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Selectie opvullen met'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113316962700400842)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Selectie opvullen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113308890544400836)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'nl'
,p_message_text=>'Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113339486215400859)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'nl'
,p_message_text=>'Filters'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113394401328400899)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'nl'
,p_message_text=>'Filteren...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113380344776400889)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'nl'
,p_message_text=>'Eerste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113309086358400836)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'nl'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113337968356400858)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'nl'
,p_message_text=>'Opmaak'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113384925667400892)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'nl'
,p_message_text=>'Opmaakmasker'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113386785004400893)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'nl'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113386636197400893)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'nl'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113299402790400829)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'nl'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113238719946400783)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'nl'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113342547115400861)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'nl'
,p_message_text=>'Blokkeren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113340267701400859)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'nl'
,p_message_text=>'Functies en operators'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113378516060400887)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'nl'
,p_message_text=>'Trechter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113359055145400873)
,p_name=>'APEX.IG.GO'
,p_message_language=>'nl'
,p_message_text=>'Uitvoeren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113333843343400855)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'nl'
,p_message_text=>'groter dan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113333960082400855)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'nl'
,p_message_text=>'is groter dan of gelijk aan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113340504618400859)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'nl'
,p_message_text=>'Raster'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113308066829400835)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'nl'
,p_message_text=>'Rasterweergave'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113381146365400889)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'nl'
,p_message_text=>'Groep'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113340722801400860)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'nl'
,p_message_text=>'Groeperen op'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113308394670400835)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'nl'
,p_message_text=>'GROUP BY-weergave'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113385517849400893)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Voorwaardetype'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113384460084400892)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'nl'
,p_message_text=>'Koptekst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113384637050400892)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'nl'
,p_message_text=>'Koptekstuitlijning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113394330923400899)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'nl'
,p_message_text=>'Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113389870102400896)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>U kunt gegevens rechtstreeks in dit interactieve raster invoegen, bijwerken en verwijderen.</p>',
'',
'<p>U voegt een nieuwe rij in door op de knop ''Rij toevoegen'' te klikken.</p>',
'',
'<p>Bestaande gegevens bewerkt u door te dubbelklikken op een specifieke cel. Als u uitgebreidere bewerkingen wilt uitvoeren, klikt u op ''Bewerken'' om naar de bewerkingsmodus te schakelen. In de bewerkingsmodus kunt u specifieke cellen bewerken door e'
||'rop te klikken of het toetsenbord te gebruiken.</p>',
'',
'<p>Via het menu ''Wijzigen'' kunt u rijen dupliceren en verwijderen. U activeert het menu ''Wijzigen'' als u de selectievakjes inschakelt om een of meer rijen te selecteren.</p>',
'',
'<p>Als u een geselecteerde rij wilt dupliceren, klikt u op het menu ''Wijzigen'' en selecteert u ''Dubbele rijen''. Als u een geselecteerde rij wilt verwijderen, klikt u op het menu ''Wijzigen'' en selecteert u ''Rij verwijderen''.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113391963542400897)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'nl'
,p_message_text=>'Bewerkingsmogelijkheden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113392039759400898)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In een interactief raster wordt een set gegevens in een zoekbaar, aanpasbaar rapport gepresenteerd. U kunt diverse bewerkingen uitvoeren om de geretourneerde records te beperken. Daarnaast kunt u de manier wijzigen waarop de gegevens worden weerge'
||'geven, .</p>',
'',
'<p>Met het zoekveld kunt u de geretourneerde records filteren. Klik op ''Acties'' om toegang te krijgen tot diverse opties voor het wijzigen van de rapportlay-out of gebruik de kolomkopmenu''s van de weergegeven kolommen.</p>',
'',
'<p>Met ''Rapportinstellingen'' kunt u uw aanpassingen opslaan in een rapport. U kunt ook de gegevens uit het rapport downloaden naar een extern bestand of de gegevens via e-mail naar uzelf of anderen versturen.</p>',
'',
'<p>Zie "Using Interactive Grids" in <em>Oracle Application Express End User''s Guide</em> voor meer informatie.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113391744564400897)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'nl'
,p_message_text=>'Overzicht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113389799235400896)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Met de ingebouwde mogelijkheden kunt u het interactieve raster aanpassen, zodat gegevens op verschillende manieren worden weergegeven.</p>',
'',
unistr('<p>In de kolomkoptekstmenu''s of het menu ''Acties'' kunt u bepalen welke kolommen moeten worden weergegeven, in welke volgorde ze moeten worden weergegeven en welke kolommen moeten worden bevroren. U kunt ook verschillende gegevensfilters defini\00EBren en')
||' de geretourneerde gegevens sorteren.</p>',
'',
'<p>Met de Knop ''Bekijken'' (naast het zoekveld) kunt u andere gegevensweergaven openen die mogelijk door de applicatieontwikkelaar zijn gedefinieerd. U kunt ook een grafiek maken of een bestaande grafiek bekijken.</p>  ',
'',
'<p><em>Opmerking: klik op <strong>Help</strong> in de dialoogvensters van het interactieve raster voor meer informatie over de geselecteerde functie.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113391853024400897)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'nl'
,p_message_text=>'Rapportagemogelijkheden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113341566858400860)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Help bij interactieve rasters'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113388612233400895)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In dit dialoogvenster aggregeert u kolommen. Geaggregeerde waarden worden onderaan de gegevens weergegeven of, als er groepsveranderingen zijn gedefinieerd, onderaan elke verandering.</p>',
'',
'<p><strong>Aggregatielijst</strong><br>',
'In de aggregatielijst worden gedefinieerde aggregaties weergegeven. U deactiveert een bestaande aggregatie door de selectie ervan op te heffen.<br>',
'Klik op ''Toevoegen'' ( &plus; ) om een nieuwe aggregatie te maken of op ''Verwijderen'' ( &minus; ) om een bestaande aggregatie te verwijderen.</p>',
'',
'<p><strong>Aggregatie-instellingen</strong><br>',
'In het scherm aan de rechterkant definieert u de aggregatie.<br>',
'Selecteer de kolomnaam en het aggregatietype.<br>',
'Desgewenst kunt u functie-info voor de aggregatie invoeren.<br>',
'Als u een groepsverandering hebt gedefinieerd en u <strong>Algehele waarde tonen</strong> selecteert, wordt de algehele gemiddelde, totale of dezelfde waarde onderaan de gegevens weergegeven.</p>',
'',
'<p><em>Opmerking: u kunt het dialoogvenster ''Aggregatie'' openen via het menu ''Acties'' of door op de kolomkoptekst en ''Som'' ( &sum; ) te klikken.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113390889584400897)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Help bij aggregatie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113389356468400895)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><p>In dit dialoogvenster definieert u een grafiek die wordt weergegeven als een aparte gegevensweergave.<br> ',
'Selecteer een grafiektype en grafiekattributen.</p>',
'<p><strong>Grafiekattributen</strong></br>',
'De beschikbare grafiekattributen zijn afhankelijk van het grafiektype.</p>',
'<p>',
'<ul>',
'  <li>Selecteer de kolom die de waarde voor het attribuut bevat:',
'    <ul>',
'      <li>Label - De tekst voor elk gegevenspunt.</li>',
'      <li>Waarde - De gegevens die moeten worden geplot.</li>',
unistr('      <li>Reeks - Voor het defini\00EBren van een dynamische zoekopdracht met meerdere reeksen.</li>'),
'      <li>Openen - De dagelijkse openingsprijs van een aandeel (alleen aandelengrafieken).</li>',
'      <li>Sluiten - De dagelijkse sluitingsprijs van een aandeel (alleen aandelengrafieken).</li>',
'      <li>T/m - De t/m-waarde (alleen bereik- en aandelengrafieken).</li>',
'      <li>Vanaf - De vanaf-waarde (alleen bereik- en aandelengrafieken).</li>',
'      <li>Volume - Het dagelijks aandelenvolume (alleen aandelengrafieken).</li>',
'      <li>Doel - De doelwaarde (alleen trechtergrafieken).</li>',
'      <li>X - De x-aswaarde (alleen ballon- en spreidingsdiagrammen).</li>',
'      <li>Y - De y-aswaarde (alleen ballon- en spreidingsdiagrammen).</li>',
'      <li>Z - De breedte van de staaf of straal van de ballon (alleen staaf-, ballon- en bereikdiagrammen).</li>',
'    </ul>',
'  </li>',
'  <li>Richting - Verticaal of horizontaal.</li>',
'  <li>Aggregatie - Selecteer hoe de grafiekwaarden moeten worden geaggregeerd.</li>',
'  <li>Stapel - Geef op of de gegevensitems moeten worden gestapeld.</li>',
'  <li>Sorteren op - Sorteren op het label of op de waarde(n).',
'    <ul>',
'      <li>Richting - Waarden sorteren in oplopende of aflopende volgorde.</li>',
'      <li>NULL-waarden - Geef op hoe records met NULL-waarden moeten worden gesorteerd in vergelijking met records met niet-NULL-waarden.</li>',
'    </ul>',
'  </li>',
'  <li>Decimalen</li>',
'  <li>Titel labelas</li>',
'  <li>Titel waarde-as</li>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113391205017400897)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Help bij grafieken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113388360692400895)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In dit dialoogvenster kiest u welke kolommen moeten worden weergegeven en in welke volgorde.</p>',
'',
'<p>U verbergt een kolom door de selectie ervan op te heffen.<br>',
'U kunt kolommen opnieuw ordenen door op ''Omhoog verplaatsen'' ( &uarr; ) of ''Omlaag verplaatsen'' ( &darr; ) te klikken.<br>',
'Met de dropdownselectie kunt u alle kolommen, weergegeven kolommen of niet-weergegeven kolommen in een lijst plaatsen.</p>',
'',
'<p>Desgewenst kunt u in het scherm de minimum breedte van een kolom in pixels opgeven.</p>',
'',
'<p><em>Opmerking: u kunt ook weergegeven kolommen opnieuw ordenen door op de greep voor slepen (aan het begin van de kolomkop) te klikken en de kolom naar links of rechts te slepen. U kunt ook de kolombreedte van weergegeven kolommen wijzigen door he'
||'t kolomscheidingsteken (tussen kopteksten) te selecteren en naar links of rechts te verplaatsen.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113391111681400897)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Help bij kolommen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113388798649400895)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In dit dialoogvenster definieert u aanvullende kolommen op basis van wiskundige en functionele berekeningen die op bestaande kolommen worden uitgevoerd.</p>',
'',
'<p><strong>Berekeningenlijst</strong><br>',
'In de berekeningenlijst worden gedefinieerde berekeningen weergegeven. U deactiveert een bestaande berekening door de selectie ervan op te heffen.<br>',
'Klik op ''Toevoegen'' ( &plus; ) om een nieuwe berekening toe te voegen of op ''Verwijderen'' ( &minus; ) om een bestaande berekening te verwijderen.</p>',
'',
'<p><strong>Berekeningsinstellingen</strong><br>',
unistr('Gebruik het scherm om de berekening te defini\00EBren.<br>'),
'Voer de kolomdetails in zoals koptekst en label, en selecteer de uitlijningsinstellingen.<br> ',
'In het tekstgebied ''Uitdrukking'' voert u de kolom(men) en bijbehorende functies voor de berekening in.<br>',
'Selecteer het gewenste gegevenstype en desgewenst een opmaakmasker voor de nieuwe kolom.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113390705470400897)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Help bij berekenen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113389007631400895)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In dit dialoogvenster definieert u een groepsverandering voor een of meer kolommen.</p>',
'',
'<p><strong>Lijst met groepsveranderingen</strong><br>',
'In de lijst met groepsveranderingen worden gedefinieerde groepsveranderingen weergegeven. U deactiveert een bestaande groepsveranderingskolom door de selectie ervan op te heffen.<br>',
'Klik op ''Toevoegen'' ( &plus; ) om een nieuwe kolom op te nemen in de groepsverandering of op ''Verwijderen'' ( &minus; ) om een bestaande kolom uit de groepsverandering te verwijderen.<br>',
'Als u kolommen opnieuw wilt ordenen, klikt u op ''Omhoog verplaatsen'' ( &uarr; ) of ''Omlaag verplaatsen'' ( &darr; ) om de geselecteerde kolom omhoog of omlaag te verplaatsen ten opzichte van de andere kolommen.</p>',
'',
'<p><strong>Instellingen voor groepsveranderingen</strong><br>',
unistr('Gebruik het scherm om de groepsveranderingskolom te defini\00EBren.<br>'),
'Selecteer een groepsveranderingskolom, de sorteerrichting en hoe NULL-kolommen (kolommen zonder waarde) moeten worden geordend.</p>',
'',
unistr('<p><em>Opmerking: wanneer u het interactieve raster bekijkt, kunt u een groepsverandering defini\00EBren door op een kolomkoptekst te klikken en het groepsveranderingspictogram te selecteren.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113390408091400896)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Help bij groepsverandering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113389254526400895)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In dit dialoogvenster downloadt u de huidige rijen naar een extern bestand. Het bestand bevat alleen de kolommen die momenteel worden weergegeven, inclusief filters en sorteringen die op de gegevens zijn toegepast.</p>',
'',
'<p>Selecteer de bestandsindeling en klik op ''Downloaden''.<br>',
'Opmerking: een CSV-bestand bevat geen tekstopmaak zoals aggregaties en groepsveranderingen.</p>',
'',
'<p>Als u het bestand via e-mail wilt versturen, selecteert u ''Versturen als e-mail'' en voert u de e-mailgegevens in (ontvanger, onderwerp en bericht).</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113390284472400896)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Help bij downloaden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113388447685400895)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In dit dialoogvenster configureert u gegevensfilters om de geretourneerde rijen te beperken.</p>',
'',
'<p><strong>Filterlijst</strong><br>',
'In de filterlijst worden gedefinieerde filters weergegeven. U deactiveert een bestaand filter door de selectie ervan op te heffen.<br>',
'Klik op ''Toevoegen'' ( &plus; ) om een nieuw filter te maken of op ''Verwijderen'' ( &minus; ) om een bestaand filter te verwijderen.</p>',
'',
'<p><strong>Filterinstellingen</strong><br>',
unistr('In het scherm kunt u de filtereigenschappen defini\00EBren.<br>'),
'Selecteer het gewenste filtertype:<br>',
'&nbsp;&nbsp;&nbsp;Rij: filteren op een term in filterbare kolommen.<br>',
'&nbsp;&nbsp;&nbsp;Kolom: een specifieke kolom filteren met een opgegeven operator en waarde.</p>',
'',
unistr('<p><em>Opmerking: wanneer u het interactieve raster bekijkt, kunt u rijfilters defini\00EBren door rechtstreeks in het veld ''Zoeken'' te typen. Klik op ''Te doorzoeken kolommen selecteren'' om de zoekopdracht te beperken tot een specifieke kolom. Desgewenst')
||' kunt u een kolomkoptekstmenu openen en een waarde selecteren om een kolomfilter te maken.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113391051464400897)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Help bij filteren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113388833118400895)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In dit dialoogvenster kunt u de gegevens bekijken zoals deze waren op een eerder tijdstip.</p>',
'<p>Voer het aantal minuten in het verleden in om de flashback-query uit te voeren.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113390660382400896)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Help bij flashbacks'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113391305513400897)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Help bij GROUP BY'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113388968682400895)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In dit dialoogvenster markeert u rijen of kolommen met gegevens op basis van de ingevoerde voorwaarde.</p>',
'',
'<p><strong>Markeringenlijst</strong><br>',
'In de markeringenlijst worden gedefinieerde markeringen weergegeven. U deactiveert een bestaande markering door de selectie ervan op te heffen.<br>',
'Klik op ''Toevoegen'' ( &plus; ) om een nieuwe markering te maken of op ''Verwijderen'' ( &minus; ) om een bestaande markering te verwijderen.</p>',
'',
'<p><strong>Markeringsinstellingen</strong><br>',
unistr('Gebruik het scherm om de markeringseigenschappen te defini\00EBren.<br>'),
'Voer de naam in, selecteer ''Rij'' of ''Kolom'' en selecteer de HTML-kleurcodes voor de achtergrond en tekst.<br>',
'Selecteer het gewenste <strong>voorwaardetype</strong> om specifieke gegevens te markeren:<br>',
'&nbsp;&nbsp;&nbsp;Rij: de term in kolommen markeren.<br>',
'&nbsp;&nbsp;&nbsp;Kolom: markeren in een specifieke kolom op basis van de opgegeven operator en waarde.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113390500243400896)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Help bij markeringen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113389177356400895)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In dit dialoogvenster slaat u wijzigingen op die u hebt aangebracht in de lay-out en configuratie van het huidige raster.<br>',
unistr('Applicatieontwikkelaars kunnen meerdere alternatieve rapportlay-outs defini\00EBren. Wanneer dit is toegestaan, kunnen u en andere eindgebruikers een rapport opslaan als ''Openbaar''. Het rapport is dan beschikbaar voor alle overige gebruikers van het rast')
||unistr('er. U kunt een rapport ook opslaan als priv\00E9rapport dat alleen u kunt inzien.</p>'),
'<p>Selecteer een beschikbaar type en voer een naam in voor het opgeslagen rapport.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113390351285400896)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Help bij rapporten',
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113388504515400895)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In dit dialoogvenster stelt u de weergavevolgorde in.</p>',
'',
'<p><strong>Sorteerlijst</strong><br>',
'In het dialoogvenster ''Sorteren'' wordt een lijst weergegeven met geconfigureerde sorteerregels.<br>',
'Klik op ''Toevoegen'' ( &plus; ) om een sorteerkolom te maken of op ''Verwijderen'' ( &minus; ) om een sorteerkolom te verwijderen.<br>',
'Klik op ''Omhoog verplaatsen'' ( &uarr; ) en ''Omlaag verplaatsen'' ( &darr; ) om de geselecteerde sorteerkolom omhoog of omlaag te verplaatsen ten opzichte van de andere sorteerkolommen.</p>',
'',
'<p><strong>Sorteerinstellingen</strong><br>',
'Selecteer een sorteerkolom, de sorteerrichting en hoe NULL-kolommen (kolommen zonder waarde) moeten worden geordend.</p>',
'',
'<p><em>Opmerking: gegevens kunnen worden gesorteerd met kolommen die niet worden weergegeven. Niet alle kolommen zijn echter sorteerbaar.</em><br>',
'<em>U kunt weergegeven kolommen sorteren door op de pijl omhoog (oplopend) of omlaag (aflopend) aan het einde van de kolomkopteksten te klikken. Als u een volgende kolom wilt toevoegen aan een bestaande sortering, houd u Shift-toets ingedrukt en klik'
||'t u op de pijl omhoog of omlaag.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113390965327400897)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Help bij sorteren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113390179500400896)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Help bij abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113342412592400861)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'nl'
,p_message_text=>'Verbergen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113309243259400836)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'nl'
,p_message_text=>'Markering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113377230886400886)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Hoog'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113378071820400887)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'nl'
,p_message_text=>'Horizontaal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113335417310400856)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'nl'
,p_message_text=>'uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113340403788400859)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'nl'
,p_message_text=>'Pictogram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113308110746400835)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'nl'
,p_message_text=>'Pictogramweergave'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113333640876400854)
,p_name=>'APEX.IG.IN'
,p_message_language=>'nl'
,p_message_text=>'in'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113342062895400861)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'nl'
,p_message_text=>'Inactieve instelling'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113342194560400861)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'nl'
,p_message_text=>'Inactieve instellingen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113349731570400866)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een interne fout opgetreden bij het verwerken van de aanvraag voor het interactieve raster.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113245572101400788)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Kolomfiltertype "%0" wordt niet ondersteund voor kolom "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113389983822400896)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige datumnotatie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113364100644400877)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'nl'
,p_message_text=>unistr('Bij interactieve rasters wordt het defini\00EBren van een filter voor kolom %0 niet ondersteund.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113364072765400877)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'nl'
,p_message_text=>unistr('%0 is geen geldig filtertype voor het defini\00EBren van een filter voor een interactief raster.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113250674151400792)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige getalnotatie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113392690431400898)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige instelling'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113392716608400898)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige instellingen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113383745810400891)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'nl'
,p_message_text=>'''Sorteren op'' is ingesteld op %0, maar er is geen kolom geselecteerd voor %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113381075417400889)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige waarde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113376130959400886)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'nl'
,p_message_text=>'Niet weergegeven'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113334453554400855)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'nl'
,p_message_text=>'in de afgelopen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113334622770400855)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'nl'
,p_message_text=>'in de komende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113333586285400854)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'nl'
,p_message_text=>'is niet leeg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113333487657400854)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'nl'
,p_message_text=>'is leeg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113384543828400892)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'nl'
,p_message_text=>'Label'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113376568100400886)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Label'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113380400999400889)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'nl'
,p_message_text=>'Laatste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113323740722400847)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen dag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113323936898400847)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen uur'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113324469012400847)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen minuut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113323476615400847)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'nl'
,p_message_text=>'Vorige maand'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113323576509400847)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'nl'
,p_message_text=>'Vorige week'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113323609439400847)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen %0 dagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113323870998400847)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen %0 uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113324586846400848)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen %0 minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113324305821400847)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen %0 maanden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113324221990400847)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen %0 weken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113323288760400847)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen %0 jaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113323385604400847)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'nl'
,p_message_text=>'Vorig jaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113384794869400892)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'nl'
,p_message_text=>'Celuitlijning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113384860909400892)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'nl'
,p_message_text=>'Groep gebruiken voor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113334049687400855)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'nl'
,p_message_text=>'kleiner dan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113334181479400855)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'nl'
,p_message_text=>'is kleiner dan of gelijk aan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113378654632400887)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'nl'
,p_message_text=>'Lijn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113378704469400888)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'nl'
,p_message_text=>'Lijn met vlak'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113385109896400892)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'nl'
,p_message_text=>'LISTAGG'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113377314353400887)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Laag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113387720257400894)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'nl'
,p_message_text=>'Meerdere adressen van elkaar scheiden met komma''s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113335267719400856)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'nl'
,p_message_text=>'komt overeen met reguliere expressie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113359688786400874)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'nl'
,p_message_text=>'Maximum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113395258547400900)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'nl'
,p_message_text=>'Algeheel maximum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113359843557400874)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'nl'
,p_message_text=>'Mediaan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113395362337400900)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'nl'
,p_message_text=>'Algehele mediaan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113359560678400873)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'nl'
,p_message_text=>'Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113335324531400856)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'nl'
,p_message_text=>'minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113360395392400874)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'nl'
,p_message_text=>'Minuten geleden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113395182661400900)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'nl'
,p_message_text=>'Algeheel minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113335751616400856)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'nl'
,p_message_text=>'maanden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113342344075400861)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'nl'
,p_message_text=>'De gegevens bevatten meer dan %0 rijen, wat het toegestane maximum overschrijdt. Pas meer filters toe om de resultaten te bekijken.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113369075714400880)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'De statische regio-ID moet worden opgegeven omdat de pagina meerdere interactieve rasters bevat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113338452066400858)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'nl'
,p_message_text=>'Naam'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113338623296400858)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Benoemd rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113322617069400846)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'nl'
,p_message_text=>'Volgende dag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113322436626400846)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'nl'
,p_message_text=>'Komende uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113324611455400848)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'nl'
,p_message_text=>'Komende minuut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113322930171400846)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'nl'
,p_message_text=>'Volgende maand'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113322895682400846)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'nl'
,p_message_text=>'Volgende week'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113322735198400846)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'nl'
,p_message_text=>'Komende %0 dagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113322537451400846)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'nl'
,p_message_text=>'Komende %0 uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113324712452400848)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'nl'
,p_message_text=>'Komende % minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113324095952400847)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'nl'
,p_message_text=>'Komende %0 maanden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113324120932400847)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'nl'
,p_message_text=>'Komende %0 weken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113323133040400847)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'nl'
,p_message_text=>'Komende %0 jaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113323050850400846)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'nl'
,p_message_text=>'Volgend jaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113334322485400855)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'nl'
,p_message_text=>'niet tussen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113333354485400854)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'nl'
,p_message_text=>'is niet gelijk aan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113399546376400903)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Regio met ID %0 is geen interactief-rasterregio of bestaat niet in applicatie %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113333758590400855)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'nl'
,p_message_text=>'niet in'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113334542027400855)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'nl'
,p_message_text=>'niet in de afgelopen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113334771528400855)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'nl'
,p_message_text=>'niet in de komende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113342206599400861)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Geen gegevens gevonden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113380214423400889)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'nl'
,p_message_text=>'NULL-waarden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113385339145400892)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'nl'
,p_message_text=>'Numeriek'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113380561332400889)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'nl'
,p_message_text=>'Uit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113380660564400889)
,p_name=>'APEX.IG.ON'
,p_message_language=>'nl'
,p_message_text=>'Aan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113332550561400854)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'nl'
,p_message_text=>'1 minuut geleden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113388277696400895)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'nl'
,p_message_text=>'Kleurenkiezer openen: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113377063270400886)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Openen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113339510608400859)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'nl'
,p_message_text=>'Operator'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113376405041400886)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'nl'
,p_message_text=>'Afdrukstand'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113378818792400888)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'nl'
,p_message_text=>'Cirkel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113340862810400860)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'nl'
,p_message_text=>'Draaitabel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113308466248400835)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'nl'
,p_message_text=>'Draaitabelweergave'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113388111307400895)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'nl'
,p_message_text=>'Waarden scheiden met "%0"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113378930762400888)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'nl'
,p_message_text=>'Polair'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113384294295400892)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'nl'
,p_message_text=>'Midden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113384316974400892)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'nl'
,p_message_text=>'Einde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113384135446400892)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'nl'
,p_message_text=>'Begin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113338792367400858)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'nl'
,p_message_text=>'Primair'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113339094292400858)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'nl'
,p_message_text=>'Primair standaardrapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113355582672400870)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Primair rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113237730414400782)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'nl'
,p_message_text=>'Toegankelijkheidstags opnemen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113236418996400781)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'nl'
,p_message_text=>'Liggend'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113236547580400781)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'nl'
,p_message_text=>'Staand'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113236305943400781)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'nl'
,p_message_text=>'Afdrukstand pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113236293667400781)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'nl'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113236116450400781)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'nl'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113237875931400782)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'nl'
,p_message_text=>'Aangepast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113235947552400780)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'nl'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113235828901400780)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'nl'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113236065212400781)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'nl'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113235705439400780)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'nl'
,p_message_text=>'Paginagrootte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113225963124400773)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'nl'
,p_message_text=>'Opmaak verwijderen uit opgemaakte tekst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113379051231400888)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'nl'
,p_message_text=>'Radar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113379126838400888)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'nl'
,p_message_text=>'Bereik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113389402564400896)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'nl'
,p_message_text=>'Vernieuwen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113343023340400861)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'nl'
,p_message_text=>'Rij vernieuwen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113341894733400860)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'nl'
,p_message_text=>'Rijen vernieuwen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113347032000400864)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Interactief-rasterregio bestaat niet in applicatie %0, pagina %1 en regio %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113309926593400836)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'nl'
,p_message_text=>'%0 verwijderen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113338103440400858)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'nl'
,p_message_text=>'Rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113398786020400902)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'nl'
,p_message_text=>'Rapport verwijderd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113398482720400902)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'nl'
,p_message_text=>'Alternatief rapport opgeslagen voor alle gebruikers'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113398332599400902)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'nl'
,p_message_text=>'Standaardrapport opgeslagen voor alle gebruikers'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113398699640400902)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'nl'
,p_message_text=>unistr('Priv\00E9rapport opgeslagen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113398521318400902)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'nl'
,p_message_text=>'Openbaar rapport opgeslagen voor alle gebruikers'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113347157576400864)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Opgeslagen interactief raster met naam %0 bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113332484890400854)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'nl'
,p_message_text=>'Rapportgegevens van %0 minuten geleden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113332378658400853)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'nl'
,p_message_text=>'Rapportgegevens van 1 minuut geleden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113272020573400809)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Het interactieve rasterrapport bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113391613130400897)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'nl'
,p_message_text=>'Rapport - Bewerken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113346900590400864)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Opgeslagen interactief raster met ID %0 bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113391589519400897)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'nl'
,p_message_text=>'Rapport - Opslaan als'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113310036137400836)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'nl'
,p_message_text=>'Rapportinstellingen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113399689744400903)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Opgeslagen interactief raster met statische ID %0 bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113394534606400899)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'nl'
,p_message_text=>'Rapportweergave'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113309179156400836)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'nl'
,p_message_text=>'Opnieuw instellen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113343144058400861)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'nl'
,p_message_text=>'Wijzigingen terugdraaien'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113341994484400860)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'nl'
,p_message_text=>'Rijen terugdraaien'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113339198808400858)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'nl'
,p_message_text=>'Rij'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113338019877400858)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'nl'
,p_message_text=>'Rijen per pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113399289167400903)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'nl'
,p_message_text=>'Rijacties'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113400488384400904)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'nl'
,p_message_text=>'Acties voor rij %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113309402897400836)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'nl'
,p_message_text=>'Opslaan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113352188171400868)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'nl'
,p_message_text=>'opgeslagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113307646405400835)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'nl'
,p_message_text=>'Opgeslagen rapporten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113307736019400835)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'nl'
,p_message_text=>'Standaard'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113282241981400816)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'nl'
,p_message_text=>'Er bestaat al een opgeslagen rapport met de naam %0. Voer een nieuwe naam in.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113307851157400835)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'nl'
,p_message_text=>unistr('Priv\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113307947309400835)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'nl'
,p_message_text=>'Openbaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113394260904400899)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'nl'
,p_message_text=>'Opslaan als'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113341264054400860)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'nl'
,p_message_text=>'Rapportinstellingen opslaan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113379260603400888)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'nl'
,p_message_text=>'Spreiding'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113307517769400835)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'nl'
,p_message_text=>'Zoeken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113386541978400893)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Zoeken: Alle tekstkolommen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113307489127400834)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Zoeken: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113385739105400893)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'nl'
,p_message_text=>'Zoeken: Volledige tekst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113332207228400853)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'nl'
,p_message_text=>'Zoeken naar ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113375815803400885)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'nl'
,p_message_text=>'- Selecteren -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113316038962400841)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'nl'
,p_message_text=>'Selectie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113368797781400880)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'nl'
,p_message_text=>'Selecteer 1 rij in de hoofdregio.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113307320550400834)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'nl'
,p_message_text=>'Te doorzoeken kolommen selecteren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113398970791400903)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'nl'
,p_message_text=>'Selectie-acties'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113316294104400841)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'nl'
,p_message_text=>'Celselectie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113316164061400841)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'nl'
,p_message_text=>'Rijselectie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113387155469400894)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'nl'
,p_message_text=>'Versturen als e-mail'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113379615259400888)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Reeks'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113305315698400833)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'nl'
,p_message_text=>'Tonen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113357974500400872)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'nl'
,p_message_text=>'Algehele waarde tonen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113342709771400861)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'nl'
,p_message_text=>unistr('Weergave met \00E9\00E9n rij')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113341082588400860)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'nl'
,p_message_text=>'Sorteren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113379701682400888)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'nl'
,p_message_text=>'Sorteren op'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113399350973400903)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'nl'
,p_message_text=>unistr('U kunt slechts \00E9\00E9n sortering per kolom defini\00EBren.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113399133239400903)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'nl'
,p_message_text=>'Menu wijzigen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113380724270400889)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'nl'
,p_message_text=>'Stapel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113335011537400855)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'nl'
,p_message_text=>'begint met'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113379360197400888)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'nl'
,p_message_text=>'Aandelen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113300344763400829)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Kolommen verbreden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113341402834400860)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'nl'
,p_message_text=>'Abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113359471770400873)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'nl'
,p_message_text=>'Som'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113400630790400904)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'nl'
,p_message_text=>'Interactief raster. Rapport: %0, weergave: %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113394648758400899)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'nl'
,p_message_text=>'Algehele som'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113377532694400887)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Doel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113383921209400891)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'nl'
,p_message_text=>'Tekstkleur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113310183604400836)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'nl'
,p_message_text=>'In-/Uitschakelen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113357890834400872)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'nl'
,p_message_text=>'Functie-info'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113338250133400858)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'nl'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113342665417400861)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'nl'
,p_message_text=>'Blokkering opheffen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113339730866400859)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'nl'
,p_message_text=>'Eenheid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113386996418400894)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'nl'
,p_message_text=>'Er zijn niet-opgeslagen wijzigingen. Wilt u doorgaan?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113339631078400859)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'nl'
,p_message_text=>'Waarde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113376609252400886)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Waarde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113381542699400890)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'Een waarde is verplicht.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113366466465400878)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'nl'
,p_message_text=>'Waarde (tijdzone kan niet worden gewijzigd)'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113385447811400893)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'nl'
,p_message_text=>'Tekst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113377938060400887)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'nl'
,p_message_text=>'Verticaal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113337784879400857)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'nl'
,p_message_text=>'Weergeven'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113375935323400885)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'nl'
,p_message_text=>'Weergegeven'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113377492732400887)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Volume'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113335621583400856)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'nl'
,p_message_text=>'weken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113376083703400886)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'nl'
,p_message_text=>'Minimumkolombreedte (pixels)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113326892649400849)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'nl'
,p_message_text=>'%0 tussen %1 en %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113326596065400849)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 bevat %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113326623291400849)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 bevat niet %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113304713218400833)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 begint niet met %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113325395665400848)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 is gelijk aan %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113325514718400848)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 groter dan %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113325676987400848)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 groter dan of gelijk aan %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113326381250400849)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 in %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113327510309400850)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'nl'
,p_message_text=>'%0 in de afgelopen %1 dagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113327393438400850)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'nl'
,p_message_text=>'%0 in de afgelopen %1 uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113327158698400850)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'nl'
,p_message_text=>'%0 in de afgelopen %1 minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113327928285400850)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'nl'
,p_message_text=>'%0 in de afgelopen %1 maanden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113327706044400850)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'nl'
,p_message_text=>'%0 in de afgelopen %1 weken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113328189333400850)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'nl'
,p_message_text=>'%0 in de afgelopen %1 jaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113327439046400850)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'nl'
,p_message_text=>'%0 in de afgelopen dag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113327244434400850)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'nl'
,p_message_text=>'%0 in het afgelopen uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113327082614400849)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'nl'
,p_message_text=>'%0 in de afgelopen minuut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113327873878400850)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'nl'
,p_message_text=>'%0 in de afgelopen maand'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113327668710400850)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'nl'
,p_message_text=>'%0 in de afgelopen week'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113328035440400850)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'nl'
,p_message_text=>'%0 in het afgelopen jaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113329929864400852)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'nl'
,p_message_text=>'%0 in de komende %1 dagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113329741609400851)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'nl'
,p_message_text=>'%0 in de komende %1 uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113329505220400851)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'nl'
,p_message_text=>'%0 in de komende %1 minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113330310119400852)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'nl'
,p_message_text=>'%0 in de komende %1 maanden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113330133432400852)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'nl'
,p_message_text=>'%0 in de komende %1 weken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113330509778400852)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'nl'
,p_message_text=>'%0 in de komende %1 jaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113329816322400852)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'nl'
,p_message_text=>'%0 in de komende dag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113329611380400851)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'nl'
,p_message_text=>'%0 in het komende uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113329429752400851)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'nl'
,p_message_text=>'%0 in de komende minuut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113330259475400852)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'nl'
,p_message_text=>'%0 in de komende maand'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113330080486400852)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'nl'
,p_message_text=>'%0 in de komende week'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113330438216400852)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'nl'
,p_message_text=>'%0 in het komende jaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113326000204400849)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'nl'
,p_message_text=>'%0 Is niet leeg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113325949573400849)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'nl'
,p_message_text=>'%0 is leeg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113325713515400849)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 kleiner dan %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113325859179400849)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 kleiner dan of gelijk aan %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113326169523400849)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 ongeveer gelijk aan %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113326754621400849)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 komt overeen met reguliere expressie %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113332614961400854)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0 minuten geleden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113326978571400849)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'nl'
,p_message_text=>'%0 niet tussen %1 en %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113325428443400848)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 is niet gelijk aan %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113326450878400849)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113328786726400851)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de afgelopen %1 dagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113328589937400851)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de afgelopen %1 uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113328343776400850)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de afgelopen %1 minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113329191324400851)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de afgelopen %1 maanden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113328925661400851)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de afgelopen %1 weken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113329341721400851)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de afgelopen %1 jaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113328627153400851)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de afgelopen dag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113328463878400851)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in het afgelopen uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113328204650400850)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de afgelopen minuut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113329087868400851)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de afgelopen maand'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113328871107400851)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de afgelopen week'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113329216988400851)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in het afgelopen jaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113331116214400853)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de komende %1 dagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113330999712400852)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de komende %1 uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113330748297400852)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de komende %1 minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113331502380400853)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de komende %1 maanden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113331394479400853)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de komende %1 weken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113331770854400853)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de komende %1 jaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113331041956400852)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de komende dag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113330883463400852)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in het komende uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113330699660400852)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de komende minuut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113331431220400853)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de komende maand'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113331243214400853)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in de komende week'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113331618259400853)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'nl'
,p_message_text=>'%0 niet in het komende jaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113326215927400849)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 niet ongeveer gelijk aan %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113333139364400854)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'nl'
,p_message_text=>'%0 begint met %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113376754213400886)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113335897881400856)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'nl'
,p_message_text=>'jaar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113376861144400886)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113376901060400886)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113385957499400893)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'nl'
,p_message_text=>'Maandag 12 januari 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113386085818400893)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'nl'
,p_message_text=>'Januari'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113386174805400893)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'nl'
,p_message_text=>'16 uur geleden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113386242600400893)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'nl'
,p_message_text=>'over 16 uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113241268729400785)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'nl'
,p_message_text=>'Ongeldig bestandstype. Ondersteunde bestandstypen zijn %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113368106973400880)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'nl'
,p_message_text=>'Bladeren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113367800040400880)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'nl'
,p_message_text=>'Bestand kiezen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113367970682400880)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'nl'
,p_message_text=>'Bestanden kiezen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113241086329400785)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'nl'
,p_message_text=>'Slepen en neerzetten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113241405003400785)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'nl'
,p_message_text=>'Bestanden slepen en neerzetten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113242649371400786)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'nl'
,p_message_text=>'Selecteer een bestand of zet er een hier neer.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113242726748400786)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'nl'
,p_message_text=>'Selecteer bestanden of zet deze hier neer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113242881986400786)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'nl'
,p_message_text=>'Selecteer een bestand of zet er een hier neer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113242961973400786)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'nl'
,p_message_text=>'Selecteer bestanden of zet deze hier neer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113241368969400785)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'nl'
,p_message_text=>'%0 bestanden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113241178862400785)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'nl'
,p_message_text=>'Het bestand is te groot. De maximumgrootte is %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113228908232400775)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'Adres is vereist.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113227849871400774)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'nl'
,p_message_text=>'Plaats'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113228252153400774)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'nl'
,p_message_text=>'Landcode'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113227929639400774)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'nl'
,p_message_text=>'Huisnummer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113228820814400775)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'nl'
,p_message_text=>'Breedte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113228794497400775)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'nl'
,p_message_text=>'Lengte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113228624235400774)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'nl'
,p_message_text=>'Op kaart tonen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113228362878400774)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'nl'
,p_message_text=>'Score'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113228043052400774)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'nl'
,p_message_text=>'Postcode'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113228135523400774)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'nl'
,p_message_text=>'Staat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113227766925400774)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'nl'
,p_message_text=>'Adres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113227663046400774)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Regiocoderesultaten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113240242193400784)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'nl'
,p_message_text=>'Gegeocodeerd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113240349263400784)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'nl'
,p_message_text=>'Niet geogecodeerd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113228544932400774)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Kaart'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113228476128400774)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Er zijn geen adressen gevonden.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113229017777400775)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'%0 is vereist.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113398822847400903)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'nl'
,p_message_text=>'Helptekst: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113292205798400824)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'nl'
,p_message_text=>'Ingeschakeld'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113292339759400824)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'nl'
,p_message_text=>'Uitgeschakeld'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113238250177400782)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# bevindt zich niet in het geldige bereik van %0 t/m %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113238348539400782)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# is geen veelvoud van %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113237983956400782)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# moet overeenkomen met de waarden %0 en %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113238149611400782)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Nee'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113316409693400841)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Uit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113316548376400841)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Aan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113238077366400782)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113221417667400769)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'nl'
,p_message_text=>'Ingang toevoegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113350617726400867)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'nl'
,p_message_text=>'Toevoegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113350789909400867)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'nl'
,p_message_text=>'Verwijderen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113221550816400769)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'nl'
,p_message_text=>'Geselecteerde invoergegevens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113354424464400870)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'nl'
,p_message_text=>'Geavanceerd'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113354742283400870)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'nl'
,p_message_text=>'Annuleren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113354552732400870)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'nl'
,p_message_text=>'Algemeen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113354821908400870)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'nl'
,p_message_text=>'Live sjabloonopties'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113355457375400870)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'nl'
,p_message_text=>'Er zijn geen sjabloonopties beschikbaar, omdat deze component niet op de pagina wordt weergegeven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113354336292400870)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Er zijn geen sjabloonopties gevonden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113354613364400870)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'nl'
,p_message_text=>'Opslaan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113229995458400775)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'nl'
,p_message_text=>'Cirkel wissen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113231794706400777)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'nl'
,p_message_text=>'''Aangepaste stijlen'' is geen geldige JSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113230241386400776)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'nl'
,p_message_text=>'Afstandfunctie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113230092264400775)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'nl'
,p_message_text=>'Cirkel tekenen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113222696601400770)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'nl'
,p_message_text=>'Voor gefacetteerd zoeken is een gegevensbron op regioniveau vereist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113225204134400772)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'nl'
,p_message_text=>'Huidige locatie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113226359303400773)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'nl'
,p_message_text=>unistr('De co\00F6rdinaten van de initi\00EBle positie zijn ongeldig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113223789903400771)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>unistr('De initi\00EBle positie moet een puntvorm zijn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113226127889400773)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'nl'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113224786825400772)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'nl'
,p_message_text=>'Laag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113358090569400872)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'nl'
,p_message_text=>'Laag: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113229378254400775)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'nl'
,p_message_text=>'Kaart'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113222589761400770)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'nl'
,p_message_text=>'Berichten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113226244382400773)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'nl'
,p_message_text=>'mijl'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113357059817400872)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'nl'
,p_message_text=>'De gegevens bevatten meer dan %0 rijen, wat het toegestane maximum overschrijdt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113224581347400771)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'nl'
,p_message_text=>'(c) 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Voorwaarden</a> &nbsp;&nbsp; Kaartgegevens (c) 2017 HERE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113223447791400771)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'nl'
,p_message_text=>'Gegevenstype SDO_GEOMETRY is niet beschikbaar in deze database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113224634381400772)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'nl'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> (c) OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> (c) OpenStreetMap-bijdragers</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113224821586400772)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'nl'
,p_message_text=>'Punten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113358152309400872)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'nl'
,p_message_text=>'%0 punten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113230106116400776)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'nl'
,p_message_text=>'Rechthoek zoomen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113229826713400775)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'nl'
,p_message_text=>'Verwijderen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113225174301400772)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'nl'
,p_message_text=>'Peiling weer instellen op noorden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113305465637400833)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'nl'
,p_message_text=>'Overschakelen op 2D-modus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113305523932400833)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'nl'
,p_message_text=>'Overschakelen op 3D-modus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113229716338400775)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'nl'
,p_message_text=>'Copyrightverklaring weergeven/verbergen'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113230338859400776)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'nl'
,p_message_text=>'Totale afstand'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113224950382400772)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'nl'
,p_message_text=>'Inzoomen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113225068508400772)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'nl'
,p_message_text=>'Uitzoomen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113352521279400868)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'nl'
,p_message_text=>'Vet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113353406426400869)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'nl'
,p_message_text=>'Afbeelding'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113353004513400869)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'nl'
,p_message_text=>'Inline code'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113366629484400879)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'nl'
,p_message_text=>'Afbeelding invoegen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113366730693400879)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'nl'
,p_message_text=>'Koppeling invoegen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113352681566400868)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'nl'
,p_message_text=>'Cursief'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113367330281400879)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'nl'
,p_message_text=>'Koppeling'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113353357333400869)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'nl'
,p_message_text=>'Lijst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113353228717400869)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'nl'
,p_message_text=>'Geordende lijst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113352718086400868)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'nl'
,p_message_text=>'Voorbeeld'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113352816556400869)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'nl'
,p_message_text=>'Er is geen voorbeeld om weer te geven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113352930443400869)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'nl'
,p_message_text=>'Doorhalen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113353134214400869)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'nl'
,p_message_text=>'Niet-geordende lijst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113332013874400853)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'nl'
,p_message_text=>'huidige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113389567151400896)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Meer...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113331993420400853)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'nl'
,p_message_text=>'Laden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113363723828400877)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'nl'
,p_message_text=>'Meldingsbericht'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113337016180400857)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# moet een getal zijn dat kleiner is dan of gelijk is aan %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113337130615400857)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# moet een geldig getal zijn.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113337213116400857)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# komt niet overeen met getalnotatie %0 (voorbeeld: %1).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113336960805400857)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# moet een getal zijn dat groter is dan of gelijk is aan %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113336838315400857)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# moet een getal zijn tussen %0 en %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113332124739400853)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'nl'
,p_message_text=>'wordt geopend in een nieuw venster'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113285332772400818)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'nl'
,p_message_text=>'Deze pagina is al verstuurd en kan niet opnieuw worden verstuurd.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113267916623400805)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Applicatie "%0" pagina "%1" is niet gevonden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113301728528400830)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'#LABEL# moet een waarde hebben.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113245052766400788)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'nl'
,p_message_text=>'Zoeken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113351014164400867)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'nl'
,p_message_text=>'Sluiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113350986293400867)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'nl'
,p_message_text=>'Zoeken%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113351294498400867)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'nl'
,p_message_text=>'Volgende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113351158429400867)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'nl'
,p_message_text=>'Vorige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113237134312400781)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'nl'
,p_message_text=>'Voer een zoekterm in van minimaal %0 tekens.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113306680565400834)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'nl'
,p_message_text=>'Pop-upwaardelijst: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113237230785400781)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'nl'
,p_message_text=>'Voer een zoekterm in.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113237063191400781)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'nl'
,p_message_text=>'Er zijn geen resultaten gevonden.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113236909788400781)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'nl'
,p_message_text=>'%0 verwijderen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113324895932400848)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'nl'
,p_message_text=>'Zoekterm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113350806965400867)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'nl'
,p_message_text=>'Zoeken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113361501051400875)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'nl'
,p_message_text=>'Bezig met verwerken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113235575088400780)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'nl'
,p_message_text=>'Toevoegen aan beginscherm'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113231556121400777)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Het lijkt erop dat installatie van Progressive Web Apps momenteel niet wordt ondersteund op uw apparaat of in uw browser.</p>',
unistr('    <p class="a-pwaDialog-intro">Open deze applicatie vanaf uw beginscherm als deze al op uw apparaat is ge\00EFnstalleerd.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113231160703400776)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Deze website heeft app-functionaliteit. Voeg de site toe aan uw beginscherm om deze te gebruiken op het volledige scherm.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tik op het pictogram <strong>Menu</strong> in de onderste navigatie.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tik op <strong>Installeren</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Tik ter bevestiging op <strong>Toevoegen</strong>.</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113231264172400776)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Deze website heeft app-functionaliteit die het best werkt in Chrome of Edge.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tik op het pictogram <strong>Menu</strong> naast de adresbalk.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tik op <strong>Installeren.</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113230849743400776)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Deze website heeft app-functionaliteit die het best werkt in Safari.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Tik op het pictogram <strong>Delen</strong> in de onderste navigatie.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Tik op <strong>Open in Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113230599307400776)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Deze website heeft app-functionaliteit. Voeg de site toe aan uw beginscherm voor de beste ervaring.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tik op het pictogram <strong>Meer</strong> naast de adresbalk.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tik op <strong>Toevoegen aan beginscherm</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Tik ter bevestiging op <strong style="color:#007AE1;">Toevoegen</strong>.</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113230458862400776)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Deze website heeft app-functionaliteit. Voeg de site toe aan uw beginscherm voor de beste ervaring.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tik op het pictogram <strong>Delen</strong> in de onderste navigatie.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Schuif omlaag en tik op  <strong>Toevoegen aan beginscherm.</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Tik ter bevestiging op <strong style="color:#007AE1;">Toevoegen</strong>.</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113225455458400772)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Deze website heeft app-functionaliteit. Voeg de site toe aan uw beginscherm voor de beste ervaring.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tik op het pictogram <strong>Meer</strong> naast de adresbalk.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tik op <strong>Toevoegen aan beginscherm</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Tik ter bevestiging op <strong style="color:#007AE1;">Toevoegen</strong>.</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113230705706400776)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Deze website heeft app-functionaliteit. Voeg de site toe aan uw beginscherm voor de beste ervaring.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Tik op het pictogram <strong>Delen</strong> naast de adresbalk.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Tik op <strong>Open in Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113230642214400776)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Deze website heeft app-functionaliteit. Voeg de site toe aan uw beginscherm voor de beste ervaring.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Tik op het pictogram <strong>Delen</strong> in de onderste navigatie.</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Tik op <strong>Open in Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113231402233400777)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Deze website bevat app-functionaliteit die het best werkt in Chrome.</p>',
'    <p class="a-pwaDialog-intro">Firefox ondersteunt momenteel geen webapp-installatie.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113230947622400776)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Deze website bevat app-functionaliteit die het best werkt in Chrome of Edge.</p>',
'    <p class="a-pwaDialog-intro">Firefox ondersteunt momenteel geen webapp-installatie in macOS.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113231090057400776)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Deze website bevat app-functionaliteit die het best werkt in Chrome of Edge.</p>',
'    <p class="a-pwaDialog-intro">Safari ondersteunt momenteel geen webapp-installatie in macOS.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113231396841400776)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Deze website bevat app-functionaliteit die het best werkt in Chrome of Edge.</p>',
'    <p class="a-pwaDialog-intro">Firefox ondersteunt momenteel geen webapp-installatie in Windows.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113233846953400779)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
'    <h1>Kan geen verbinding maken</h1>',
'    <p>U hebt een internetverbinding nodig om deze app te gebruiken.</p>',
'    <button type="button">Opnieuw</button>',
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113233774173400779)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'nl'
,p_message_text=>'Kan geen verbinding maken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113373558680400884)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'nl'
,p_message_text=>'Toevoegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113317928751400842)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'nl'
,p_message_text=>'Hele dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113396801391400901)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'nl'
,p_message_text=>'Uitnodiging versturen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113396621350400901)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'nl'
,p_message_text=>'Opties'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113319724846400844)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'nl'
,p_message_text=>'Dagoverzicht voor de hele dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113319537508400844)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'nl'
,p_message_text=>'Dagoverzicht voor gegevens met tijd'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113364441559400877)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'nl'
,p_message_text=>'Dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113358845457400873)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'nl'
,p_message_text=>'Beschrijving'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113249479444400791)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'nl'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113249200521400791)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'nl'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113249199307400791)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'nl'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113249307157400791)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'nl'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113248894053400791)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'nl'
,p_message_text=>'Einddatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113249033648400791)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'nl'
,p_message_text=>'Eventnaam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113396794138400901)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'nl'
,p_message_text=>'Uitnodiging'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113364557405400877)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'nl'
,p_message_text=>'Lijst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113364202351400877)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'nl'
,p_message_text=>'Maand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113367071931400879)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'nl'
,p_message_text=>'Volgende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113381301305400890)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'nl'
,p_message_text=>'Geen events'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113397045752400901)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'nl'
,p_message_text=>'Een bestaand event bewerken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113396928705400901)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'nl'
,p_message_text=>'Een uitnodiging versturen via e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113367116143400879)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'nl'
,p_message_text=>'Vorige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113375195156400885)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'nl'
,p_message_text=>'E-mail versturen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113374976491400885)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'nl'
,p_message_text=>'E-mail versturen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113397732791400902)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'Alle velden zijn verplicht.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113397607905400902)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'nl'
,p_message_text=>'Uitnodiging versturen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113396549872400901)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'nl'
,p_message_text=>'Onderwerp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113375071978400885)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'nl'
,p_message_text=>'Aan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113248928143400791)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'nl'
,p_message_text=>'Begindatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113372818565400883)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'nl'
,p_message_text=>'Scherm bij %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113319359982400844)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'nl'
,p_message_text=>'Tijd'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113367260424400879)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'nl'
,p_message_text=>'Vandaag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113365027997400877)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'nl'
,p_message_text=>'Weergeven'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113364348668400877)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'nl'
,p_message_text=>'Week'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113319697472400844)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'nl'
,p_message_text=>'Weekoverzicht voor de hele dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113319444000400844)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'nl'
,p_message_text=>'Weekoverzicht voor gegevens met tijd'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113364927528400877)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'nl'
,p_message_text=>'Jaar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113364689152400877)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Kolommen...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113364798966400877)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'nl'
,p_message_text=>'Meer laden...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113296896140400827)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'nl'
,p_message_text=>'Terug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113243171167400786)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'nl'
,p_message_text=>'Meer laden...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113245209549400788)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'nl'
,p_message_text=>'Bezig met zoeken...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113364898158400877)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'nl'
,p_message_text=>'Meer laden...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113366908430400879)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Regio-ID %0 is niet gevonden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113245105897400788)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'nl'
,p_message_text=>'Geen gegevens gevonden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113269295391400806)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'nl'
,p_message_text=>'De regiopaginering kan niet opnieuw worden ingesteld.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113237466001400782)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het instellen van de regiopaginering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113358241361400872)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Kolommen...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113366864802400879)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'nl'
,p_message_text=>'Regiotype %0 wordt niet ondersteund.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113237378982400782)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het weergeven van regio "#COMPONENT_NAME#".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113301854184400830)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'#COLUMN_HEADER# moet een waarde hebben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113396157867400901)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'nl'
,p_message_text=>'%0, RTF-editor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113303968402400832)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'nl'
,p_message_text=>'De opgemaakte tekst in HTML-markup overschrijdt de maximumlengte van het item (werkelijk aantal tekens %0, toegestaan aantal %1).'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113363806983400877)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'nl'
,p_message_text=>'Verwijderen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113355697697400871)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'nl'
,p_message_text=>'Dupliceren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113353964532400869)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'nl'
,p_message_text=>'Weergegeven kolommen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113353818855400869)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'nl'
,p_message_text=>'NULL-waarden uitsluiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113363992709400877)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'nl'
,p_message_text=>'Toevoegen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113317537450400842)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'nl'
,p_message_text=>'Omlaag verplaatsen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113317639409400842)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'nl'
,p_message_text=>'Omhoog verplaatsen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113353628480400869)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'nl'
,p_message_text=>'Volgende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113354294135400870)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Overige kolommen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113353731716400869)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'nl'
,p_message_text=>'Vorige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113354029837400869)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'nl'
,p_message_text=>'Rij %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113354184565400870)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'nl'
,p_message_text=>'Rij %0 van %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113355725373400871)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'nl'
,p_message_text=>'Vernieuwen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113355894296400871)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'nl'
,p_message_text=>'Wijzigingen terugdraaien'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113353515230400869)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'nl'
,p_message_text=>'Menu ''Instellingen'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113314518986400840)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'nl'
,p_message_text=>'Bijvoorbeeld %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113222095838400770)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'nl'
,p_message_text=>'Opnieuw aanmelden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113221996429400770)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'nl'
,p_message_text=>unistr('Uw sessie is be\00EBindigd.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113222104585400770)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'nl'
,p_message_text=>'Verlengen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113221736146400769)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'nl'
,p_message_text=>'Uw sessie loopt af om %0. Wilt u de sessie verlengen?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113221836578400770)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'nl'
,p_message_text=>'Uw sessie loopt af om %0, en kan niet worden verlengd. Sla uw werk op om te voorkomen dat u gegevens verliest.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113374765293400885)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het verwerken van de opschoningscode voor de databasesessie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113267869352400805)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het verwerken van de instellingscode voor de databasesessie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113241923655400785)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'nl'
,p_message_text=>unistr('Uw sessie is be\00EBindigd.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113373603588400884)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'nl'
,p_message_text=>'Sluit dit dialoogvenster en klik op de knop van uw browser voor opnieuw laden om een nieuwe sessie te verkrijgen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113392974648400898)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'nl'
,p_message_text=>'Klik <a href="%0">hier</a> om een nieuwe sessie te maken.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113279566140400814)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'nl'
,p_message_text=>'Sessie niet geldig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113319023256400843)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'nl'
,p_message_text=>'Activeren van dynamische rollen is mislukt in de Real Application Security sessie voor gebruiker "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113265766823400804)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'ERR-99900 Unieke sessie-ID: %0 kan niet worden gemaakt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113282080248400816)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'nl'
,p_message_text=>'Schending van de sessiestatusbeveiliging. Dit wordt mogelijk veroorzaakt door een handmatige wijziging van het beveiligde pagina-item %0. Neem voor hulp contact op met de applicatiebeheerder als u niet weet waardoor deze fout is veroorzaakt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113401132154400904)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'nl'
,p_message_text=>'Schending van de paginabeveiliging. Dit wordt mogelijk veroorzaakt doordat een pagina wordt  verstuurd die nog niet volledig was geladen of door een handmatige wijziging van de beveiligde pagina-items. Neem voor hulp contact op met de applicatiebehee'
||'rder.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113400119879400904)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'nl'
,p_message_text=>'%0 bevat een van de volgende ongeldige tekens &<>"/;,*|=% of --'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113400255641400904)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'nl'
,p_message_text=>'%0 bevat een van de volgende ongeldige tekens &<>"/;,*|=% of -- of bevat een nieuwe regel.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113399953054400903)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'nl'
,p_message_text=>'%0 bevat speciale tekens. Alleen de tekens a-Z, 0-9 en spaties zijn toegestaan.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113400050968400903)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'nl'
,p_message_text=>'%0 bevat <, > of ", wat ongeldige tekens zijn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113244129536400787)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'nl'
,p_message_text=>'Er is geen controletelling opgegeven om de verwerking te tonen van een pagina waarvoor een controletelling is vereist wanneer een of meer aanvraagwaarden, cache-wiswaarden of argumentwaarden worden doorgegeven als parameters.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113276974419400812)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'nl'
,p_message_text=>'Schending van de sessiestatusbeveiliging. Dit wordt mogelijk veroorzaakt door een handmatige wijziging van een URL die een controletelling bevat of door gebruik van een koppeling met een onjuiste of ontbrekende controletelling. Neem voor hulp contact'
||' op met de applicatiebeheerder als u niet weet waardoor deze fout is veroorzaakt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113354987190400870)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'nl'
,p_message_text=>'Modus voor hoog contrast uitschakelen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113355067101400870)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'nl'
,p_message_text=>'Modus voor hoog contrast inschakelen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113273679533400810)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'nl'
,p_message_text=>'Onderaan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113273840516400810)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'nl'
,p_message_text=>'Omlaag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113273996837400810)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'nl'
,p_message_text=>'Verplaatsen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113274021151400810)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'nl'
,p_message_text=>'Alles verplaatsen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113274111045400810)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'nl'
,p_message_text=>'Verwijderen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113274250164400810)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'nl'
,p_message_text=>'Alles verwijderen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113274316188400810)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'nl'
,p_message_text=>'Opnieuw instellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113273578807400810)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'nl'
,p_message_text=>'Bovenaan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113273731179400810)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'nl'
,p_message_text=>'Omhoog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113382678756400890)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113383333253400891)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'over %0 dgn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113382521594400890)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113383447169400891)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'over %0 uur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113382327786400890)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113383580348400891)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'over %0 min'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113382988658400891)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0 mnd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113383106479400891)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'over %0 mnd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113382454411400890)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113383249676400891)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'over %0 sec'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113382712872400891)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113383633103400891)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'over %0 wkn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113382825251400891)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113383073725400891)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'over %0 jr'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113222943979400770)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'nl'
,p_message_text=>'[Regel]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113223320816400771)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'nl'
,p_message_text=>'[Meerdere regels]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113223184636400770)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'nl'
,p_message_text=>'[Meerdere punten]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113223511777400771)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'nl'
,p_message_text=>'[Meerdere veelhoeken]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113223664453400771)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'nl'
,p_message_text=>'[Geometrisch object]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113222805695400770)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'nl'
,p_message_text=>'[Punt (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113223084993400770)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'nl'
,p_message_text=>'[Veelhoek]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113300214608400829)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'nl'
,p_message_text=>'Samenvouwen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113300129152400829)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'nl'
,p_message_text=>'Herstellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113346615738400864)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'nl'
,p_message_text=>'Score wissen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113336539924400857)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'nl'
,p_message_text=>'%0 valt niet binnen het geldige scorebereik van 1 - %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113336646496400857)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'nl'
,p_message_text=>'%0 is niet numeriek.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113332762722400854)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'nl'
,p_message_text=>'Voltooiingsbericht'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113395832951400900)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'nl'
,p_message_text=>'Volgende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113395706236400900)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'nl'
,p_message_text=>'Vorige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113381454686400890)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'nl'
,p_message_text=>'Werkbalk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113396212076400901)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Navigatie uitvouwen/samenvouwen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113396372141400901)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Zijkolom uitvouwen/samenvouwen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113305939689400833)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Hoofdnavigatie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113312935344400839)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'nl'
,p_message_text=>'1 dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113312737919400838)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'nl'
,p_message_text=>'1 uur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113313047977400839)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'nl'
,p_message_text=>'%0 dagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113312844086400838)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'nl'
,p_message_text=>'%0 uur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113312659336400838)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'nl'
,p_message_text=>'%0 minuten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113313243549400839)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'nl'
,p_message_text=>'%0 weken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113313154533400839)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'nl'
,p_message_text=>'1 week'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113399404354400903)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'nl'
,p_message_text=>'Begin van pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113261464719400800)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'nl'
,p_message_text=>'Geactiveerd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113235237604400780)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het verwerken van de aanvraag.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113314674800400840)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'Waarde vereist'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113397518710400902)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'nl'
,p_message_text=>'Wacht tot de pagina volledig is geladen en probeer het opnieuw.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113357768871400872)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'nl'
,p_message_text=>'Deze pagina bevat niet-opgeslagen wijzigingen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113238646290400783)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'nl'
,p_message_text=>'De werkmap bevat geen actief werkblad.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113238500226400783)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'nl'
,p_message_text=>unistr('De werkmap is niet ge\00EFnitialiseerd.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113238486302400782)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een interne fout opgetreden bij het maken van het XLSX-bestand.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113240981634400785)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'nl'
,p_message_text=>'Werkblad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113372608588400883)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'nl'
,p_message_text=>'Acties'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113290107373400822)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'nl'
,p_message_text=>'Actiemenu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113285899491400819)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'nl'
,p_message_text=>'Functie toevoegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113285734222400819)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'GROUP BY-kolom toevoegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113319938000400844)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Draaikolom toevoegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113320023330400844)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Rijkolom toevoegen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113260207183400799)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'nl'
,p_message_text=>'Aggregatie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113296331773400826)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'nl'
,p_message_text=>'Aggregatie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113277451253400813)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'nl'
,p_message_text=>'Gemiddelde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113281747180400816)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'nl'
,p_message_text=>'Aantal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113277597414400813)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'nl'
,p_message_text=>'Maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113277731605400813)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'nl'
,p_message_text=>'Mediaan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113277678162400813)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'nl'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113277327450400813)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'nl'
,p_message_text=>'Som %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113278462133400813)
,p_name=>'APEXIR_ALL'
,p_message_language=>'nl'
,p_message_text=>'Alles'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113259516097400799)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Alle kolommen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113242030947400785)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'nl'
,p_message_text=>'Alle rijen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113369669845400881)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'nl'
,p_message_text=>'Alternatief'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113371214903400882)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'nl'
,p_message_text=>'Alternatief standaardrapport: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113272171285400809)
,p_name=>'APEXIR_AND'
,p_message_language=>'nl'
,p_message_text=>'en'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113261649091400801)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'nl'
,p_message_text=>'Toepassen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113255332234400796)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'nl'
,p_message_text=>'Oplopend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113274932271400811)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'nl'
,p_message_text=>'Peildatum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113371842641400882)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'nl'
,p_message_text=>'Gemiddelde %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113363286244400876)
,p_name=>'APEXIR_BAR'
,p_message_language=>'nl'
,p_message_text=>'Staaf'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113261020732400800)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'nl'
,p_message_text=>'tussen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113254196993400795)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'nl'
,p_message_text=>'Achtergrondkleur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113256071738400796)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'nl'
,p_message_text=>'blauw'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113287783255400820)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'nl'
,p_message_text=>'Onderaan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113256675966400797)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'nl'
,p_message_text=>'Annuleren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113262581074400801)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'nl'
,p_message_text=>'Categorie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113254090288400795)
,p_name=>'APEXIR_CELL'
,p_message_language=>'nl'
,p_message_text=>'Cel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113278337580400813)
,p_name=>'APEXIR_CHART'
,p_message_language=>'nl'
,p_message_text=>'Grafiek'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113288616846400821)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'nl'
,p_message_text=>'Bezig met initialiseren...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113324939461400848)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'nl'
,p_message_text=>'Er moet een grafieklabel worden opgegeven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113337314664400857)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'nl'
,p_message_text=>'Uw query overschrijdt het maximum van %0 gegevenspunten per grafiek. Pas een filter toe om het aantal records in uw basisquery te verminderen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113336277247400856)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'nl'
,p_message_text=>'Het maximum aantal rijen voor een grafiekquery beperkt het aantal rijen en de basisquery, niet het aantal weergegeven rijen. Uw basisquery overschrijdt het maximum aantal rijen, %0. Pas een filter toe om het aantal records in uw basisquery te vermind'
||'eren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113259629144400799)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Grafiektype'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113332995303400854)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'nl'
,p_message_text=>'Alles inschakelen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113275335491400811)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'nl'
,p_message_text=>'Rapportindeling kiezen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113282708713400816)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'nl'
,p_message_text=>'wissen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113256551187400797)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Kolom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113293973337400825)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Kolommen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113366268653400878)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'nl'
,p_message_text=>'Filteren...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113284766497400818)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'nl'
,p_message_text=>'Kolomkopmenu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113288407612400821)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'nl'
,p_message_text=>'Kolomgegevens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113368507966400880)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Kolomlabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113286142910400819)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'nl'
,p_message_text=>'Kolom %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113270234051400807)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'nl'
,p_message_text=>'bevat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113271121540400808)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'nl'
,p_message_text=>'bevat niet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113255068697400796)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'nl'
,p_message_text=>'in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113271347687400808)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'nl'
,p_message_text=>'is niet in de afgelopen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113279866041400814)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'nl'
,p_message_text=>'is niet in de komende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113271213236400808)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'nl'
,p_message_text=>'is in de afgelopen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113279719318400814)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'nl'
,p_message_text=>'is in de komende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113254951915400795)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'nl'
,p_message_text=>'is niet NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113254895218400795)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'nl'
,p_message_text=>'is NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113254621927400795)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'nl'
,p_message_text=>'ongeveer gelijk aan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113255178703400796)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'nl'
,p_message_text=>'niet in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113254783038400795)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'nl'
,p_message_text=>'niet als'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113270529988400807)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'nl'
,p_message_text=>'komt overeen met reguliere expressie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113275206211400811)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'nl'
,p_message_text=>'Berekening'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113335901779400856)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'nl'
,p_message_text=>'Berekeningsuitdrukking'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113294265674400825)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'nl'
,p_message_text=>'Maak een berekening met behulp van kolomaliassen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113294360058400825)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'nl'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113294448472400825)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'nl'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113294537570400825)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'nl'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113240480212400784)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'nl'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113279152950400814)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'nl'
,p_message_text=>'Berekenen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113286779144400819)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'nl'
,p_message_text=>'Groepsverandering'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113289757327400822)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'nl'
,p_message_text=>'Groepsveranderingen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113374111714400884)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Groepsveranderingkolommen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113237590132400782)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'nl'
,p_message_text=>'Aantal verschillende waarden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113372306110400883)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'nl'
,p_message_text=>'Aantal verschillende waarden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113372240995400883)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'nl'
,p_message_text=>'Aantal %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113344337411400862)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'nl'
,p_message_text=>'Dagelijks'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113399034382400903)
,p_name=>'APEXIR_DATA'
,p_message_language=>'nl'
,p_message_text=>'Gegevens'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113288550379400821)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'nl'
,p_message_text=>'Rapportgegevens van %0 minuten geleden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113362036491400875)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'nl'
,p_message_text=>'Help bij gegevensraster'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113260355042400800)
,p_name=>'APEXIR_DATE'
,p_message_language=>'nl'
,p_message_text=>'Datum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113292400810400824)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'nl'
,p_message_text=>'Standaard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113369447912400881)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Standaardrapporttype'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113256783868400797)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'nl'
,p_message_text=>'Verwijderen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113260621430400800)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'nl'
,p_message_text=>'Wilt u deze rapportinstellingen verwijderen?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113355311769400870)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Standaardrapport verwijderen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113286499398400819)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Rapport verwijderen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113255471496400796)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'nl'
,p_message_text=>'Aflopend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113262670199400801)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'nl'
,p_message_text=>'Beschrijving'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113284633517400818)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'nl'
,p_message_text=>unistr('Weergave met \00E9\00E9n rij')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113292905422400824)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'nl'
,p_message_text=>'Richting %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113293848331400825)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'nl'
,p_message_text=>'Inactief'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113256217679400796)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'nl'
,p_message_text=>'Weergegeven'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113259466799400799)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Weergegeven kolommen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113292883251400824)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Weergeven in rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113287670548400820)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'nl'
,p_message_text=>'Omlaag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113279298431400814)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'nl'
,p_message_text=>'Downloaden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113292778884400824)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'nl'
,p_message_text=>'Niet weergeven'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113358734782400873)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'nl'
,p_message_text=>'Er bestaat al een markering met dezelfde voorwaarde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113374301019400884)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Dubbele draaikolom. De lijst met draaikolommen moet uniek zijn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113374549315400884)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'nl'
,p_message_text=>'Bewerken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113288703432400821)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'nl'
,p_message_text=>'Grafiekinstellingen bewerken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113295322619400826)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'nl'
,p_message_text=>'Grafiek bewerken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113295782719400826)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'nl'
,p_message_text=>'Filter bewerken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113350142757400867)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'nl'
,p_message_text=>'GROUP BY bewerken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113295601921400826)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'nl'
,p_message_text=>'Markering bewerken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113320276184400844)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'nl'
,p_message_text=>'Draaitabel bewerken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113369741864400881)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'nl'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113248446786400790)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'nl'
,p_message_text=>'E-mailadres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113370014906400881)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'nl'
,p_message_text=>'BCC'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113370226750400881)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'nl'
,p_message_text=>'Hoofdtekst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113369905317400881)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'nl'
,p_message_text=>'CC'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113370708528400882)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'nl'
,p_message_text=>'Frequentie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113252101707400793)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'nl'
,p_message_text=>'Er is geen e-mail geconfigureerd voor deze applicatie. Neem contact op met de beheerder.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113343621862400862)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'E-mailadres moet worden opgegeven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113370367929400881)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'nl'
,p_message_text=>'Zie bijlage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113370194706400881)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'nl'
,p_message_text=>'Onderwerp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113344644253400862)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'E-mailonderwerp moet worden opgegeven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113369876337400881)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'nl'
,p_message_text=>'Aan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113253827099400795)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'nl'
,p_message_text=>'Geactiveerd'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113295535092400826)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'nl'
,p_message_text=>'Activeren/Deactiveren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113295025597400826)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Fout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113294670435400825)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'nl'
,p_message_text=>'Voorbeelden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113295424337400826)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'nl'
,p_message_text=>'Voorbeelden:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113259302148400799)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'nl'
,p_message_text=>'NULL-waarden uitsluiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113296032148400826)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'nl'
,p_message_text=>'Uitvouwen/Samenvouwen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113293653155400825)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'nl'
,p_message_text=>'Uitdrukking'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113278751906400814)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'nl'
,p_message_text=>'Filteren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113289637370400822)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'nl'
,p_message_text=>'Filters'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113299921687400829)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'nl'
,p_message_text=>'Filteruitdrukking'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113396422394400901)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'nl'
,p_message_text=>'De filteruitdrukking is te lang.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113299888052400829)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Filtertype'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113296212053400826)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'nl'
,p_message_text=>'Te doorzoeken kolommen selecteren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113279059398400814)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'nl'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113293454045400824)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'nl'
,p_message_text=>'Met een flashback-query kunt u de gegevens bekijken zoals deze waren op een eerder tijdstip.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113344077780400862)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Duur flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113345433613400863)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'nl'
,p_message_text=>'Opmaak'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113275125560400811)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'nl'
,p_message_text=>'Opmaakmasker %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113286312674400819)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'nl'
,p_message_text=>'Functie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113294124839400825)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'nl'
,p_message_text=>'Functies %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113369312114400881)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'nl'
,p_message_text=>'Functies/Operators'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113286052103400819)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'nl'
,p_message_text=>'Functie %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113278568235400813)
,p_name=>'APEXIR_GO'
,p_message_language=>'nl'
,p_message_text=>'Uitvoeren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113254334078400795)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'nl'
,p_message_text=>'groen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113237624762400782)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'nl'
,p_message_text=>'Groeperen op'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113370463417400881)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Groeperen op kolom %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113325047614400848)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'nl'
,p_message_text=>'GROUP BY-kolom moet worden opgegeven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113336111934400856)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'nl'
,p_message_text=>'Het maximum aantal rijen voor een GROUP BY-query beperkt het aantal rijen en de basisquery, niet het aantal weergegeven rijen. Uw basisquery overschrijdt het maximum aantal rijen, %0. Pas een filter toe om het aantal records in uw basisquery te vermi'
||'nderen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113316793140400842)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'nl'
,p_message_text=>'GROUP BY-sortering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113374281339400884)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'nl'
,p_message_text=>'Sorteervolgorde GROUP BY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113259756039400799)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'nl'
,p_message_text=>'Horizontale kolom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113291370546400823)
,p_name=>'APEXIR_HELP'
,p_message_language=>'nl'
,p_message_text=>'Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113283118456400817)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Met interactieve rapporten kunnen eindgebruikers rapporten aanpassen. Gebruikers kunnen de lay-out van rapportgegevens wijzigen door kolommen te selecteren, filters toe te passen, markeringen aan te brengen en te sorteren. Gebruikers kunnen ook onder'
||unistr('brekingspunten, aggregaties, grafieken en GROUP BY''s defini\00EBren, en eigen berekeningen toevoegen. Gebruikers kunnen ook een abonnement instellen om met een bepaald interval per e-mail een HTML-versie van het rapport te krijgen toegezonden. Gebruikers')
||unistr(' kunnen meerdere versie van een rapport maken en deze opslaan als benoemde rapporten, om openbaar of priv\00E9 te bekijken. '),
'<p/>',
'In de volgende secties wordt een samenvatting gegeven van manieren waarop u een interactief rapport kunt aanpassen Zie "Using Interactive Reports" in <i>Oracle Application Express End User''s Guide</i></a> voor meer informatie.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113290244168400822)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'nl'
,p_message_text=>'Het Actiemenu staat rechts van de knop ''Uitvoeren'' op de zoekbalk. Gebruik dit menu om een interactief rapport aan te passen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113283959639400817)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Aggregaties zijn wiskundige berekeningen die op een kolom worden uitgevoerd. Aggregaties worden weergegeven na elke groepsverandering en aan het einde van het rapport weergegeven in de kolom waarin ze zijn gedefinieerd. Opties zijn:',
'<p>',
'</p><ul>',
'<li><strong>Aggregatie</strong>: hiermee kunt u een eerder gedefinieerde aggregatie selecteren om te bewerken.</li>',
'<li><strong>Functie</strong> is de uit te voeren functie (bijvoorbeeld: SOM, MIN).</li>',
'<li><strong>Kolom</strong> wordt gebruikt om de kolom te selecteren waarop de wiskundige functie moet worden toegepast. Alleen numerieke kolommen worden weergegeven.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113284022438400817)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('U kunt \00E9\00E9n grafiek per opgeslagen rapport defini\00EBren.'),
'Nadat de grafiek is gedefinieerd, kunt u schakelen tussen de grafiek- en rapportweergave met behulp van de weergaveknoppen in de zoekbalk.',
'Opties zijn:  ',
'<p>',
'</p><ul>',
'<li><strong>Grafiektype</strong>: identificeert het op te nemen grafiektype.',
'Kies uit horizontale staaf, verticale staaf, cirkel of lijn.</li>',
'<li><strong>Label</strong>: hiermee kunt u de kolom selecteren die moet worden gebruikt als label.</li>',
'<li><strong>Astitel voor label</strong> is de titel die wordt weergegeven op de as die is gekoppeld aan de kolom die is geselecteerd als label. Niet beschikbaar voor cirkeldiagrammen.</li>',
'<li><strong>Waarde</strong>: hiermee kunt u de kolom selecteren die moet worden gebruikt als de waarde. Als het om een COUNT-functie gaat, hoeft er geen waarde te worden geselecteerd.</li>',
'<li><strong>Astitel voor waarde</strong> is de titel die wordt weergegeven op de as die is gekoppeld aan de kolom die is geselecteerd voor de waarde. Niet beschikbaar voor cirkeldiagrammen.</li>',
'<li><strong>Functie</strong> is een optionele functie die moet worden uitgevoerd op de kolom die is geselecteerd voor de waarde.</li>',
'<li><strong>Sorteren</strong>: hiermee kunt u uw resultatenset sorteren.</li></ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113283322724400817)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Door op een kolomkop te klikken wordt een kolomkopmenu zichtbaar. Opties zijn:',
'<p></p>',
'<ul>',
'<li><strong>Oplopend sorteren</strong>. Met dit pictogram wordt het rapport in oplopende volgorde op de kolom gesorteerd.</li>',
'<li><strong>Aflopend sorteren</strong>.Met dit pictogram wordt het rapport in aflopende volgorde op de kolom gesorteerd.</li>',
'<li><strong>Kolom verbergen</strong> verbergt de kolom. Niet alle kolommen kunnen worden verborgen. Als een kolom niet kan worden verborgen, is het pictogram ''Kolom verbergen'' niet aanwezig.</li>',
'<li><strong>Onderbrekingskolom</strong> maakt een onderbrekingsgroep in de kolom. Hierdoor wordt de kolom uit het rapport gehaald als een hoofdrecord.</li>',
'<li><strong>Kolomgegevens</strong> geeft helptekst over de kolom weer, indien aanwezig.</li>',
'<li><strong>Tekstgebied</strong> wordt gebruikt om niet-hoofdlettergevoelige zoekcriteria in te voeren (geen jokertekens nodig). Door een waarde in te voeren vermindert de lijst met waarden onderaan het menu. Vervolgens kunt u onderaan een waarde sel'
||'ecteren, waarna de geselecteerde waarde wordt gebruikt als een filter met ''='' (bijvoorbeeld: <code>kolom = ''ABC''</code>). U kunt ook op de zaklantaarnknop klikken en een waarde invoeren om te gebruiken als filter met het sleutelwoord ''LIKE (bijvoorbe'
||'eld: <code>kolom LIKE ''%ABC%''</code>).</li>',
'<li><b>Lijst met unieke waarden</b> bevat de eerste 500 unieke waarden die aan uw filtercriterium voldoen. Als de kolom een datum is, wordt in plaats daarvan een lijst met datumbereiken weergegeven. Als u een waarde selecteert, wordt er een filter ge'
||'maakt met ''='' (bijvoorbeeld: <code>kolom = ''ABC''</code>).</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113283854072400817)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hiermee kunt u berekende kolommen toevoegen aan uw rapport. Dit kunnen wiskundige berekeningen zijn (bijvoorbeeld: <code>NBR_HOURS/24</code>) of standaard Oracle ',
'functies die op bestaande kolommen worden toegepast. Sommige worden weergegeven als voorbeelden, en andere, zoals <code>TO_DATE)</code> kunnen ook worden gebruikt). Opties zijn:',
'<p></p>',
'<ul>',
'<li>Met <strong>Berekening</strong> kunt u een eerder gedefinieerde berekening selecteren om te bewerken.</li>',
'<li><strong>Kolomkop</strong> is de kolomkop voor de nieuwe kolom.</li>',
'<li><strong>Opmaakmasker</strong> is een Oracle opmaakmasker om toe te passen op de kolom (bijvoorbeeld: S9999).</li>',
'<li><strong>Berekening</strong> is de uit te voeren berekening. Binnen de berekening wordt naar kolommen verwezen met de weergegeven aliassen.</li>',
'</ul>',
'<p>Onder de berekening worden de kolommen in uw query weergegeven met de bijbehorende aliassen. Door op een kolomnaam of alias te klikken, wordt deze opgenomen in de berekening. Naast Kolommen bevindt zich een toetsenblok. Dit toetsenblok werkt als e'
||'en snelkoppeling naar veelgebruikte toetsen. Uiterst rechts bevinden zich functies.</p>',
'<p>In de volgende voorbeeldberekening ziet u hoe u totale beloning kunt weergeven:</p>',
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
'(waarbij A staat voor ORGANIZATION, B voor SALARY en C voor COMMISSION)</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113290350650400822)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'nl'
,p_message_text=>'Wordt gebruikt om een onderbrekingsgroep voor een of meer kolommen te maken. Dit haalt de kolommen uit het interactieve rapport en geeft ze weer als hoofdrecord.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113284521835400818)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'nl'
,p_message_text=>unistr('Als u de gegevens van \00E9\00E9n rij tegelijk wilt bekijken, klikt u bij de rij die u wilt bekijken op het pictogram voor het weergeven van \00E9\00E9n rij. Indien beschikbaar, is de weergave met \00E9\00E9n rij altijd de eerste kolom. Afhankelijk van de aanpassing van het')
||unistr(' interactieve rapport kan de weergave met \00E9\00E9n rij de standaardweergave zijn, of een aangepaste pagina  die kan worden bijgewerkt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113284486825400818)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'nl'
,p_message_text=>'Hiermee kan de huidige resultatenset worden gedownload. De downloadindeling hangt af van uw installatie en de rapportdefinitie, maar kan CSV, HTML, e-mail, XLS, PDF of RTF zijn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113283572335400817)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hiermee wordt het rapport toegespitst door de <code>WHERE</code>-clausule van de query te wijzigen. U kunt filteren op een kolom of per rij. ',
'<p>Als u op kolom filtert, selecteert u een kolom (dit hoeft er niet een te zijn die wordt weergegeven), selecteert u een standaard Oracle operator (=, !=, niet in, tussen), en voert u een uitdrukking in om mee te vergelijken. Uitdrukkingen zijn hoof'
||'dlettergevoelig. Gebruik % als jokerteken (bijvoorbeeld: <code>STATE_NAME',
'LIKE A%)</code>.</p>',
'<p>Als u op rij filtert, kunt u complexe <code>WHERE</code>-clausules maken met behulp van kolomaliassen en alle gewenste Oracle functies of operators (bijvoorbeeld: <code>G = ''VA'' or G = ''CT''</code>, waarbij',
'<code>G</code> de alias voor <code>CUSTOMER_STATE</code> is).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113284148578400818)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'nl'
,p_message_text=>'Met een flashback-query kunt u de gegevens bekijken zoals ze waren op een bepaald tijdstip in het verleden. De standaardtijd die u kunt teruggaan is 3 uur (180 minuten), maar de werkelijke tijd verschilt voor elke database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113345330401400863)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Met ''Opmaak'' kunt u de weergave van het rapport aanpassen. ''Opmaak'' bevat het volgende submenu:</p>',
'<ul><li>Sorteren</li>',
'<li>Groepsverandering</li>',
'<li>Markering</li>',
'<li>Berekenen</li>',
'<li>Aggregatie</li>',
'<li>Grafiek</li>',
'<li>Groeperen op</li>',
'<li>Draaien</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113343594237400862)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('U kunt \00E9\00E9n GROUP BY-weergave per opgeslagen rapport maken. Nadat deze is gedefinieerd, kunt u tussen de GROUP BY- en rapportweergave schakelen met behulp van de weergavepictogrammen op de zoekbalk. Als u een GROUP BY-weergave wilt maken, selecteert u'),
'<p></p>',
'<ul>',
'<li>de kolommen die u wilt groeperen</li>',
'<li>de te aggregeren kolommen en de te gebruiken functie (gemiddelde, som, aantal, enzovoort)</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113283784840400817)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Hiermee kunt u een filter defini\00EBren. De rijen die voldoen aan de filtercriteria worden gemarkeerd weergeven met behulp van de aan het filter gekoppelde kenmerken. Opties zijn:</p>'),
'<ul>',
'<li><strong>Naam</strong> wordt alleen gebruikt voor weergave.</li>',
unistr('<li><strong>Volgorde</strong> geeft de volgorde aan waarin de regels worden ge\00EBvalueerd.</li>'),
'<li><strong>Geactiveerd</strong> geeft aan of een regel actief of inactief is.</li>',
'<li><strong>Type markering</strong> bepaalt of de rij of cel moet worden gemarkeerd. Als ''Cel'' is geselecteerd, wordt de kolom gemarkeerd waarnaar in de markeringsvoorwaarde wordt verwezen.</li>',
'<li><strong>Achtergrondkleur</strong> is de nieuwe kleur voor de achtergrond van het gemarkeerde gebied.</li>',
'<li><strong>Tekstkleur</strong> is de nieuwe kleur voor de tekst in het gemarkeerde gebied.</li>',
'<li><strong>Markeringsvoorwaarde</strong> definieert uw filtervoorwaarde.</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113221386486400769)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('U kunt \00E9\00E9n draaitabelweergave per opgeslagen rapport maken. Nadat deze is gedefinieerd, kunt u tussen de draaitabel- en rapportweergave schakelen met behulp van de weergavepictogrammen op de zoekbalk. Als u een draaitabelweergave wilt maken, selectee')
||'rt u',
'<p></p>',
'<ul>',
'<li>de kolommen waarover u wilt draaien</li>',
'<li>de kolommen die als rijen moeten worden weergegeven</li>',
'<li>de te aggregeren kolommen en de te gebruiken functie (gemiddelde, som, aantal, enzovoort)</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113294878300400825)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Als u een interactief rapport aanpast, worden de rapportinstellingen weergegeven onder de zoekbalk en boven het rapport. Dit gebied kan worden samen- en uitgevouwen met behulp van het pictogram links.',
'<p>',
'Voor elke rapportinstelling kunt u:',
'</p><ul>',
'<li>Een instelling bewerken door op de naam te klikken..</li>',
'<li>Een instelling activeren/deactiveren door het selectievakje activeren/deactiveren in- of uit te schakelen.</li>',
'<li>Een instelling verwijderen door op het pictogram ''Verwijderen'' te klikken.</li>',
'</ul>',
'<p>Als u een grafiek, GROUP BY of draaitabel hebt gemaakt, kunt u schakelen tussen deze en het basisrapport met behulp van de koppelingen ''Rapportweergave'', ''Grafiekweergave'', ''GROUP BY-weergave'' en ''Draaitabelweergave'' die rechts worden weergegeven.'
||' Als u de grafiek, GROUP BY of draaitabel bekijkt, kunt u ook de koppeling ''Bewerking'' gebruiken om de instellingen te bewerken.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113284320819400818)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'nl'
,p_message_text=>'Hiermee wordt het rapport weer ingesteld op de standaardinstellingen, en eventuele aanpassingen die u hebt gedaan, worden verwijderd.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113345692136400863)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'nl'
,p_message_text=>'Hiermee wordt het aantal per pagina weer te geven records ingesteld.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113284248571400818)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Hiermee wordt het aangepaste rapport opgeslagen voor toekomstig gebruik. U geeft een naam en desgewenst een beschrijving op, en u kunt het rapport toegankelijk maken voor het publiek (dat wil zeggen, alle gebruikers die toegang hebben tot het prim'
||'aire standaardrapport). U kunt vier typen interactieve rapporten opslaan:</p>',
'<ul>',
'<li><strong>Primair standaardrapport</strong> (alleen ontwikkelaar). Het primaire standaardrapport is het rapport dat aanvankelijk wordt weergegeven. Primaire standaardrapporten kunnen niet worden hernoemd of verwijderd.</li>',
'<li><strong>Alternatief rapport</strong> (alleen ontwikkelaar). Hiermee kunnen ontwikkelaars meerdere rapportlay-outs maken. Alleen ontwikkelaars kunnen een alternatief rapport opslaan, hernoemen of verwijderen.</li>',
'<li><strong>Openbaar rapport</strong> (eindgebruiker). Kan worden opgeslagen, hernoemd of verwijderd door de eindgebruiker die het heeft gemaakt. Andere gebruikers kunnen de lay-out bekijken en opslaan als een ander rapport.</li>',
unistr('<li><strong>Priv\00E9rapport</strong> (eindgebruiker). Alleen de eindgebruiker die het rapport heeft gemaakt, kan het rapport bekijken, opslaan, hernoemen of verwijderen.</li>'),
'</ul>',
'<p>Als u aangepaste rapporten opslaat, wordt er een rapportselector weergegeven in de zoekbalk, links van de rijselector (als deze functie geactiveerd is).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113283254232400817)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'nl'
,p_message_text=>'Bovenaan elke rapportpagina bevindt zich een zoekregio. Deze regio (zoekbalk) bevat de volgende functies:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113346270558400864)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'nl'
,p_message_text=>'<li>Met het <strong>Actiemenu</strong> kunt u een rapport aanpassen. Zie de secties hieronder.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113345721054400863)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'nl'
,p_message_text=>'<li>Met het <strong>pictogram ''Kolommen selecteren''</strong> kunt u de kolommen selecteren waarin u wilt zoeken (dit kunnen ook alle kolommen zijn).</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113346011687400864)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'nl'
,p_message_text=>unistr('<li>Met <strong>Rapporten</strong> worden het alternatieve standaardrapport en opgeslagen priv\00E9- of openbare rapporten weergegeven.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113345947775400863)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'nl'
,p_message_text=>'<li>Met <strong>Rijen</strong> stelt u het aantal weer te geven records per pagina in.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113345868109400863)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>In het <strong>Tekstgebied</strong> kunt u niet-hoofdlettergevoelige zoekcriteria invoeren (jokertekens zijn impliciet).</li>',
'<li>Met de <strong>knop ''Uitvoeren''</strong> wordt de zoekopdracht uitgevoerd. De zoekopdracht kan ook worden uitgevoerd door op Enter te drukken wanneer de cursor zich in het zoektekstgebied bevindt.</li>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113346193149400864)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'nl'
,p_message_text=>'<li>Met <strong>Weergavepictogrammen</strong> schakelt u tussen de pictogram-, rapport-, detail-, grafiek-, GROUP BY- en draaitabelweergave van het rapport indien deze zijn gedefinieerd.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113362191286400875)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'nl'
,p_message_text=>'<li>Met <strong>Beheren</strong> kunt u de eigenschappen, kolommen, rijen en weergavehistorie voor het rapport of gegevensraster beheren.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113283488711400817)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Wordt gebruikt om de weergegeven kolommen te wijzigen. De kolommen aan de rechterkant worden weergegeven. De kolommen aan de linkerkant worden verborgen. U kunt de volgorde van de weergegeven kolommen wijzigen met behulp van de pijlen uiterst rechts.'
||' Berekende kolommen worden voorafgegaan door <strong>**</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113283630871400817)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Wordt gebruikt om de kolommen te wijzigen waarop wordt gesorteerd, en bepaalt of in oplopende of aflopende volgorde wordt gesorteerd. U kunt ook opgeven hoe',
'<code>NULL-waarden</code> worden behandeld. Bij de standaardinstelling worden <code>NULL-waarden</code> altijd het laatste of altijd het eerst weergegeven. De resulterende sortering wordt in het rapport rechts van de kolomkoppen weergegeven.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113343322868400861)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'nl'
,p_message_text=>'Wanneer u een abonnement toevoegt, geeft u een e-mailadres op (of meerdere e-mailadressen, gescheiden door komma''s), een e-mailonderwerp, frequentie en begin- en einddatum. De resulterende e-mailberichten bevatten een HTML-versie van het interactieve'
||' rapport met de huidige gegevens en de rapportinstellingen die aanwezig waren toen het abonnement werd toegevoegd.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113361903641400875)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Gegevensrasters zijn eigenlijk bewerkbare rapporten die uitgebreid kunnen worden aangepast. Gebruikers kunnen de lay-out van rapportgegevens wijzigen door kolommen te selecteren, filters toe te passen, markeringen aan te brengen en te sorteren. Gebru'
||unistr('ikers kunnen ook onderbrekingspunten, aggregaties, grafieken en GROUP BY''s defini\00EBren, en hun eigen berekeningen toevoegen. Gebruikers kunnen '),
unistr('meerdere versies van een rapport maken en deze opslaan als benoemde rapporten om priv\00E9 te bekijken. '),
'<p/>',
'Een gegevensraster kan worden aangepast met behulp van de zoekbalk, het Actiemenu, het menu ''Beheren'' of een kolomkopmenu.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113373797947400884)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'nl'
,p_message_text=>'Het Actiemenu staat rechts van de knop ''Uitvoeren'' op de zoekbalk. Gebruik dit menu om een gegevensrasterrapport aan te passen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113362431947400876)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'nl'
,p_message_text=>'Pagina ''Rij toevoegen/bewerken'''
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113362561333400876)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Klik op ''Rij toevoegen'' om een rij toe te voegen aan het gegevensraster. Als u de details van een rij wilt bewerken, klikt u op het pictogram ''Rij bewerken'' (eerste kolom) van de rij die u wilt bewerken. De pagina ''Rij toevoegen/bewerken'' wordt we'
||'ergegeven met de kolommen van het gegevensraster. </p>',
'',
'<p>Bij het bewerken van een rij kunt u:</p>',
'',
'<p><ul>',
'<li>De rij <strong>Verwijderen</strong>.</li>',
'<li><strong>Wijzigingen toepassen</strong> om de in de rij aangebrachte wijzigingen op te slaan.</li>',
'<li>Binnen <strong>Acties</strong> kunt u een rij toevoegen, bestanden, notities, koppelingen of tags toevoegen en de historie bekijken.</li>',
'<li>Navigeren naar de <strong>Volgende en Vorige</strong> rij.</li>',
'<li>Binnen <strong>Beheren</strong> kunt u kolomeigenschappen, kolomgroepen, validaties en waardelijsten instellen.</li>',
'</ul></p>',
'',
'<p>In de regio ''Aantekenen'' onderaan de pagina worden bestanden, notities, koppelingen en tags weergegeven die aan de huidige rij zijn gekoppeld.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113373867144400884)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'nl'
,p_message_text=>'Wordt gebruikt om een onderbrekingsgroep voor een of meer kolommen te maken. Dit haalt de kolommen uit het gegevensraster en geeft ze weer als hoofdrecord.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113362379390400876)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'nl'
,p_message_text=>'Hiermee kan de huidige resultatenset worden gedownload. De downloadindelingen zijn CSV, HTML of  e-mail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113373963432400884)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Als u een gegevensrasterrapport aanpast, worden de rapportinstellingen weergegeven onder de zoekbalk en boven het rapport. Dit gebied kan worden samen- en uitgevouwen met behulp van het pictogram links.',
'<p>',
'Voor elke rapportinstelling kunt u:',
'</p><ul>',
'<li>Een instelling bewerken door op de naam te klikken..</li>',
'<li>Een instelling activeren/deactiveren door het selectievakje activeren/deactiveren in- of uit te schakelen.</li>',
'<li>Een instelling verwijderen door op het pictogram ''Verwijderen'' te klikken.</li>',
'</ul>',
'<p>Als u een grafiek of GROUP BY hebt gemaakt, kunt u schakelen tussen deze en het basisrapport met behulp van de koppelingen ''Rapportweergave'', ''Grafiekweergave'' en ''GROUP BY-weergave'' die rechts worden weergegeven. Als u de grafiek of GROUP BY beki'
||'jkt, kunt u ook de koppeling ''Bewerking'' gebruiken om de instellingen te bewerken.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113362249994400875)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Hiermee wordt het aangepaste rapport opgeslagen voor toekomstig gebruik. U geeft een naam en desgewenst een beschrijving op. U kunt drie typen rapportlay-outs voor gegevensrasters opslaan:</p>',
'<ul>',
'<li><strong>Primair standaardrapport</strong> (alleen beheerder). Het primaire standaardrapport is de lay-out die aanvankelijk wordt weergegeven. Primaire standaardrapporten kunnen niet worden hernoemd of verwijderd.</li>',
'<li><strong>Alternatief rapport</strong> (alleen beheerder). Hiermee kunnen beheerders meerdere rapportlay-outs maken. Alleen beheerders kunnen een alternatief rapport opslaan, hernoemen of verwijderen.</li>',
unistr('<li><strong>Priv\00E9rapport</strong> (alle gebruikers). De gebruiker die de rapportlay-out heeft gemaakt kan het rapport weergeven, opslaan, hernoemen of verwijderen.</li>'),
'</ul>',
'<p>Als u aangepaste rapporten opslaat, wordt er een rapportselector weergegeven in de zoekbalk, links van de rijselector (als deze functie geactiveerd is).</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113288398012400821)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Kolom verbergen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113278954015400814)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'nl'
,p_message_text=>'Markering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113289834877400822)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'nl'
,p_message_text=>'Markeringen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113294903389400825)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'nl'
,p_message_text=>'Markeringsvoorwaarde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113343976860400862)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'nl'
,p_message_text=>'Markeringsstijl'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113253979903400795)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Type markering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113363439850400876)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'nl'
,p_message_text=>'Horizontaal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113393068893400898)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'nl'
,p_message_text=>'1 inactieve instelling'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113393181801400898)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'nl'
,p_message_text=>'%0 inactieve instellingen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113284935123400818)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'nl'
,p_message_text=>'Help bij interactieve rapporten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113295931479400826)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'nl'
,p_message_text=>'Ongeldig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113289396427400821)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'nl'
,p_message_text=>'Ongeldig berekeningsuitdrukking. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113248726004400791)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'nl'
,p_message_text=>'De einddatum moet later zijn dan de begindatum.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113303614371400832)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige filteruitdrukking. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113371404541400882)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige filterquery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113393210803400898)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'nl'
,p_message_text=>'1 ongeldige instellingen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113393300599400899)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'nl'
,p_message_text=>'%0 ongeldige instellingen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113344154866400862)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'nl'
,p_message_text=>'(in minuten)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113361113629400875)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'nl'
,p_message_text=>'%0 is in de afgelopen %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113361360910400875)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'nl'
,p_message_text=>'%0 is in de komende %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113361204452400875)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'nl'
,p_message_text=>'%0 is niet in de afgelopen %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113361476540400875)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'nl'
,p_message_text=>'%0 is niet in de komende %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113294041654400825)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'nl'
,p_message_text=>'Toetsenblok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113260177868400799)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Label %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113287973519400820)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Astitel voor label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113280410706400815)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113280690735400815)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen uur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113280133084400815)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'nl'
,p_message_text=>'Vorige maand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113280218965400815)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'nl'
,p_message_text=>'Vorige week'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113280337907400815)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen %0 dagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113280521212400815)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen %0 uur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113279954557400814)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'nl'
,p_message_text=>'Afgelopen %0 jaar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113280014567400815)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'nl'
,p_message_text=>'Vorig jaar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113260031152400799)
,p_name=>'APEXIR_LINE'
,p_message_language=>'nl'
,p_message_text=>'Lijn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113256848630400797)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'nl'
,p_message_text=>'Lijn met vlak'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113371314120400882)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'nl'
,p_message_text=>'Toewijzen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113288859510400821)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'nl'
,p_message_text=>'De query zal waarschijnlijk meer dan de maximaal toegestane resources verbruiken. Wijzig uw rapportinstellingen en probeer het opnieuw.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113271095589400808)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'nl'
,p_message_text=>'Het maximum aantal rijen voor dit rapport is %0. Pas een filter toe om het aantal records in uw query te verminderen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113371902331400883)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'nl'
,p_message_text=>'Maximum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113372180088400883)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'nl'
,p_message_text=>'Mediaan %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113275082070400811)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0 minuten geleden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113372088140400883)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'nl'
,p_message_text=>'Minimum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113371087225400882)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'nl'
,p_message_text=>'Maand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113344530510400862)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'nl'
,p_message_text=>'Maandelijks'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113287120884400820)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'nl'
,p_message_text=>'Verplaatsen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113287046106400820)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'nl'
,p_message_text=>'Alles verplaatsen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113398291394400902)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'De statische regio-ID moet worden opgegeven, omdat de pagina meerdere interactieve rapporten bevat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113255509863400796)
,p_name=>'APEXIR_NAME'
,p_message_language=>'nl'
,p_message_text=>'Naam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113282901529400817)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'nl'
,p_message_text=>'Nieuwe aggregatie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113393945835400899)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Nieuwe categorie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113283062242400817)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'nl'
,p_message_text=>'Nieuwe berekening'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113277836096400813)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'nl'
,p_message_text=>'Volgende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113280973024400815)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'nl'
,p_message_text=>'Volgende dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113280752439400815)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'nl'
,p_message_text=>'Komende uur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113281229583400815)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'nl'
,p_message_text=>'Volgende maand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113281174833400815)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'nl'
,p_message_text=>'Volgende week'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113281063184400815)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'nl'
,p_message_text=>'Komende %0 dagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113280800652400815)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'nl'
,p_message_text=>'Komende %0 uur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113281460078400816)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'nl'
,p_message_text=>'Komende %0 jaar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113281314658400815)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'nl'
,p_message_text=>'Volgend jaar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113255803137400796)
,p_name=>'APEXIR_NO'
,p_message_language=>'nl'
,p_message_text=>'Nee'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113296185232400826)
,p_name=>'APEXIR_NONE'
,p_message_language=>'nl'
,p_message_text=>'- Geen -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113343732137400862)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'nl'
,p_message_text=>'Geen geldig e-mailadres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113292693109400824)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'nl'
,p_message_text=>'NULL-waarden altijd eerst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113292586654400824)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'nl'
,p_message_text=>'NULL-waarden altijd laatst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113293067935400824)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'nl'
,p_message_text=>'NULL-waardensortering %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113289444106400821)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'nl'
,p_message_text=>'Flashback-tijd moet numeriek zijn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113289020424400821)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'nl'
,p_message_text=>'Volgnummer moet numeriek zijn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113293571071400824)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'nl'
,p_message_text=>'Operator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113254459061400795)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'nl'
,p_message_text=>'oranje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113363317288400876)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'nl'
,p_message_text=>'Afdrukstand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113256339131400797)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'nl'
,p_message_text=>'Anders'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113239109471400783)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'nl'
,p_message_text=>'Afdrukstand pagina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113239800868400784)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'nl'
,p_message_text=>'Liggend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113239954402400784)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'nl'
,p_message_text=>'Staand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113239042496400783)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'nl'
,p_message_text=>'Paginagrootte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113239621790400783)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'nl'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113239546082400783)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'nl'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113239762717400784)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'nl'
,p_message_text=>'Aangepast'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113239397619400783)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'nl'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113239238647400783)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'nl'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113239494995400783)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'nl'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113372449156400883)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'nl'
,p_message_text=>'Percentage van totaal aantal %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113371694623400882)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'nl'
,p_message_text=>'Percentage van totale som %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113370655397400882)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'nl'
,p_message_text=>'Percentage van totaal aantal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113370525864400882)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'nl'
,p_message_text=>'Percentage van totale som'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113259938879400799)
,p_name=>'APEXIR_PIE'
,p_message_language=>'nl'
,p_message_text=>'Cirkel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113319873351400844)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'nl'
,p_message_text=>'Draaitabel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113321322860400845)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'nl'
,p_message_text=>'Aggregatie moet worden opgegeven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113321525889400845)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'nl'
,p_message_text=>'U kunt niet aggregeren op een kolom die is geselecteerd als rijkolom.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113320744558400845)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Draaikolommen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113320573622400845)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'nl'
,p_message_text=>'Draaikolom %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113321177804400845)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'nl'
,p_message_text=>'Draaikolom moet worden opgegeven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113221297222400769)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'nl'
,p_message_text=>'Het maximum aantal rijen voor een draaitabelquery beperkt het aantal rijen en de basisquery, niet het aantal weergegeven rijen. Uw basisquery overschrijdt het maximum aantal rijen, %0. Pas een filter toe om het aantal records in uw basisquery te verm'
||'inderen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113321014422400845)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'nl'
,p_message_text=>'Sortering draaitabel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113290430119400822)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'nl'
,p_message_text=>'De draaikolom bevat te veel afzonderlijke waarden. De draai-SQL kan niet worden gegenereerd.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113343805079400862)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'nl'
,p_message_text=>'Voorbeeld'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113277920957400813)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'nl'
,p_message_text=>'Vorige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113369538753400881)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'nl'
,p_message_text=>'Primair'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113344817350400863)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Primair rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113238970408400783)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'nl'
,p_message_text=>'Toegankelijkheidstags opnemen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113225812214400772)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'nl'
,p_message_text=>'Opmaak verwijderen uit opgemaakte tekst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113302607431400831)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'nl'
,p_message_text=>unistr('Priv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113260588916400800)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'nl'
,p_message_text=>'Openbaar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113256101393400796)
,p_name=>'APEXIR_RED'
,p_message_language=>'nl'
,p_message_text=>'rood'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113398154597400902)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Statische regio-ID %0 bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113287292318400820)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'nl'
,p_message_text=>'Verwijderen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113287313345400820)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'nl'
,p_message_text=>'Alles verwijderen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113393494702400899)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'nl'
,p_message_text=>'Grafiek verwijderen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113286810007400820)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'nl'
,p_message_text=>'Groepsverandering verwijderen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113286589242400819)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'nl'
,p_message_text=>'Filter verwijderen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113286666865400819)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'nl'
,p_message_text=>'Flashback verwijderen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113393561441400899)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'nl'
,p_message_text=>'GROUP BY verwijderen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113286919788400820)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'nl'
,p_message_text=>'Markering verwijderen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113393677183400899)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'nl'
,p_message_text=>'Draaitabel verwijderen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113374696346400885)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Rapport verwijderen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113355243375400870)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Standaardrapport hernoemen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113296449938400827)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Rapport hernoemen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113278279267400813)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113372521870400883)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'nl'
,p_message_text=>'Rapporten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113252765724400794)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Opgeslagen interactief rapport met alias %0 bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113302901165400831)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Rapport bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113252811006400794)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Opgeslagen interactief rapport met ID %0 bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113294717983400825)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'nl'
,p_message_text=>'Rapportinstellingen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113275555736400811)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'nl'
,p_message_text=>'Rapportweergave'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113279464431400814)
,p_name=>'APEXIR_RESET'
,p_message_language=>'nl'
,p_message_text=>'Opnieuw instellen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113260733161400800)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'nl'
,p_message_text=>'Herstel de standaardinstellingen van het rapport.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113255957916400796)
,p_name=>'APEXIR_ROW'
,p_message_language=>'nl'
,p_message_text=>'Rij'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113368618698400880)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'nl'
,p_message_text=>'U kunt ROWID niet gebruiken als de primaire sleutelkolom voor een REST-gegevensbron.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113285956809400819)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'nl'
,p_message_text=>'Rijen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113345512323400863)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'nl'
,p_message_text=>'Rijen per pagina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113320888047400845)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Rijkolommen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113320630585400845)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'nl'
,p_message_text=>'Rijkolom %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113321291675400845)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'nl'
,p_message_text=>'Rijkolom moet worden opgegeven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113321406274400845)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'nl'
,p_message_text=>'De rijkolom moet verschillen van de draaikolom.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113300038422400829)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'nl'
,p_message_text=>'Rijfilter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113275620489400811)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'nl'
,p_message_text=>'Rij %0 van %1'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113279685394400814)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'nl'
,p_message_text=>'Rijtekst bevat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113255246153400796)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'nl'
,p_message_text=>'Opslaan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113290005895400822)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Opgeslagen rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113289930677400822)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'nl'
,p_message_text=>'Opgeslagen rapport = "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113292172961400823)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'nl'
,p_message_text=>'De huidige rapportinstellingen worden gebruikt als de standaardinstellingen voor alle gebruikers.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113355160694400870)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Standaardrapport opslaan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113279321190400814)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Rapport opslaan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113393806747400899)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'nl'
,p_message_text=>'Rapport opslaan *'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113346541567400864)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'nl'
,p_message_text=>'Zoeken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113284840727400818)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'nl'
,p_message_text=>'Zoekbalk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113393797782400899)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Zoeken: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113352032618400868)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Zoekrapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113336023973400856)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Geselecteerde kolommen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113256957561400797)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'- Selecteer kolom -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113278689781400814)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Kolommen selecteren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113260464816400800)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'nl'
,p_message_text=>'- Functie selecteren -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113285657709400819)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'- Selecteer kolom om op te groeperen -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113320374822400844)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'- Selecteer draaikolom -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113371556746400882)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'nl'
,p_message_text=>'Rij selecteren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113320402024400844)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'- Selecteer rijkolom -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113229152064400775)
,p_name=>'APEXIR_SEND'
,p_message_language=>'nl'
,p_message_text=>'Versturen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113235465802400780)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'nl'
,p_message_text=>'Versturen als e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113255606759400796)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'nl'
,p_message_text=>'Volgnummer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113278881998400814)
,p_name=>'APEXIR_SORT'
,p_message_language=>'nl'
,p_message_text=>'Sorteren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113288144999400820)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'nl'
,p_message_text=>'Oplopend sorteren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113288239010400821)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'nl'
,p_message_text=>'Aflopend sorteren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113374016387400884)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'nl'
,p_message_text=>'Sorteervolgorde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113282651210400816)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'nl'
,p_message_text=>'spatie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113293795824400825)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'nl'
,p_message_text=>'Status %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113344299024400862)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'nl'
,p_message_text=>'Abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113370930739400882)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'nl'
,p_message_text=>'T/m'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113225349461400772)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'nl'
,p_message_text=>'Overslaan als geen gegevens zijn gevonden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113370893725400882)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'nl'
,p_message_text=>'Beginnend bij'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113371762248400882)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'nl'
,p_message_text=>'Som %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113361790945400875)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'nl'
,p_message_text=>'Regio = %0, Rapport = %1, Weergave= %2, Begin weergegeven rijen = %3, Einde weergegeven rijen = %4, Totaal aantal rijen = %5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113282305620400816)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'nl'
,p_message_text=>'Regio = %0, Rapport = %1, Weergave= %2, Begin weergegeven rijen = %3, Einde weergegeven rijen = %4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113254532730400795)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'nl'
,p_message_text=>'Tekstkleur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113271617339400808)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'nl'
,p_message_text=>'dagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113271535079400808)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'nl'
,p_message_text=>'uur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113271458550400808)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'nl'
,p_message_text=>'minuten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113271890102400808)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'nl'
,p_message_text=>'maanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113271781576400808)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'nl'
,p_message_text=>'weken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113271916755400808)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'nl'
,p_message_text=>'jaar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113374400721400884)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'nl'
,p_message_text=>'In-/Uitschakelen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113287400044400820)
,p_name=>'APEXIR_TOP'
,p_message_language=>'nl'
,p_message_text=>'Bovenaan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113367667282400879)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Niet-gegroepeerde kolom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113288919290400821)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'nl'
,p_message_text=>'De naam van de markering moet uniek zijn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113259229928400799)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'nl'
,p_message_text=>'niet-ondersteund gegevenssoort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113287531847400820)
,p_name=>'APEXIR_UP'
,p_message_language=>'nl'
,p_message_text=>'Omhoog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113289145663400821)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'nl'
,p_message_text=>'Geef een geldige kleur op.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113289257633400821)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'nl'
,p_message_text=>'Voer een geldig opmaakmasker in.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113256454620400797)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'nl'
,p_message_text=>'Waarde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113288028250400820)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'nl'
,p_message_text=>'Astitel voor waarde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113295888915400826)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'Waarde vereist'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113259846620400799)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'nl'
,p_message_text=>'Verticale kolom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113363523161400876)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'nl'
,p_message_text=>'Verticaal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113295125359400826)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'nl'
,p_message_text=>'Grafiek weergeven'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113350381140400867)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'nl'
,p_message_text=>'Detail weergeven'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113395911703400900)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Er is geen %0-weergave gedefinieerd voor het rapport.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113350465377400867)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'nl'
,p_message_text=>'GROUP BY weergeven'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113350205053400867)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'nl'
,p_message_text=>'Weergavepictogrammen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113320105504400844)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'nl'
,p_message_text=>'Draaitabel weergeven'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113295211686400826)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Rapport weergeven'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113344459629400862)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'nl'
,p_message_text=>'Wekelijks'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113278113320400813)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Werkrapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113373109926400883)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'nl'
,p_message_text=>'%0 dagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113373071392400883)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'nl'
,p_message_text=>'%0 uur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113372917300400883)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'nl'
,p_message_text=>'%0 minuten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113373348528400884)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'nl'
,p_message_text=>'%0 maanden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113373237866400884)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'nl'
,p_message_text=>'%0 weken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113373457521400884)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'nl'
,p_message_text=>'%0 jaar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113371169352400882)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'nl'
,p_message_text=>'Jaar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113254228067400795)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'nl'
,p_message_text=>'geel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113255751435400796)
,p_name=>'APEXIR_YES'
,p_message_language=>'nl'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113287819865400820)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'nl'
,p_message_text=>'%0 bevat < of >, wat ongeldige tekens zijn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113310659188400837)
,p_name=>'APEX_REGION'
,p_message_language=>'nl'
,p_message_text=>'Regio'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113238887227400783)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'nl'
,p_message_text=>'API-voorwaarde vooraf overtreden'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113258364945400798)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'nl'
,p_message_text=>'De waarde voor applicatie-instelling %0 kan niet worden opgehaald, omdat de gekoppelde build-optie inactief is.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113258281574400798)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'nl'
,p_message_text=>'De waarde voor applicatie-instelling %0 kan niet worden ingesteld, omdat de gekoppelde build-optie inactief is.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113365993902400878)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'nl'
,p_message_text=>'De waarde van applicatie-instelling 0% is ongeldig.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113365897216400878)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'nl'
,p_message_text=>'Gevraagde applicatie-instelling %0 is niet gedefinieerd.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113366036756400878)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'nl'
,p_message_text=>'Applicatie-instelling %0 mag niet worden ingesteld op een NULL-waarde.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113246976668400789)
,p_name=>'BACK'
,p_message_language=>'nl'
,p_message_text=>'Terug'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113233960705400779)
,p_name=>'BUILDER'
,p_message_language=>'nl'
,p_message_text=>'Builder'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113298063417400828)
,p_name=>'BUTTON LABEL'
,p_message_language=>'nl'
,p_message_text=>'Knoplabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113233012613400778)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'nl'
,p_message_text=>'CSS-klassen voor knoppen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113262295076400801)
,p_name=>'BUTTON_ID'
,p_message_language=>'nl'
,p_message_text=>'De gegenereerde knop-ID is de statische ID van de knop als deze is gedefinieerd, of anders een intern gegenereerde ID met de notatie ''B'' || [interne knop-ID].'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113225789019400772)
,p_name=>'CANDLESTICK'
,p_message_language=>'nl'
,p_message_text=>'Kaars'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113307249055400834)
,p_name=>'CENTER'
,p_message_language=>'nl'
,p_message_text=>'Midden'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113257230457400797)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'nl'
,p_message_text=>'%0 Aanvraag'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113248693032400791)
,p_name=>'CHECK$'
,p_message_language=>'nl'
,p_message_text=>'rijselector'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113367711009400879)
,p_name=>'CHECKED'
,p_message_language=>'nl'
,p_message_text=>'ingeschakeld'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113343247867400861)
,p_name=>'COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Kolom'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113303746196400832)
,p_name=>'COMMENTS'
,p_message_language=>'nl'
,p_message_text=>'Toelichting'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113285296004400818)
,p_name=>'CONTINUE'
,p_message_language=>'nl'
,p_message_text=>'Doorgaan'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113247266491400789)
,p_name=>'COPYRIGHT'
,p_message_language=>'nl'
,p_message_text=>'Copyright (c) %0, Alle rechten voorbehouden.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113290967833400823)
,p_name=>'COUNT'
,p_message_language=>'nl'
,p_message_text=>'Aantal'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113297645628400827)
,p_name=>'CREATE'
,p_message_language=>'nl'
,p_message_text=>'Maken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113349950034400866)
,p_name=>'CREATED'
,p_message_language=>'nl'
,p_message_text=>'Gemaakt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113350091116400866)
,p_name=>'CREATED_BY'
,p_message_language=>'nl'
,p_message_text=>'Gemaakt door'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113274889453400811)
,p_name=>'CREATED_ON'
,p_message_language=>'nl'
,p_message_text=>'Gemaakt op'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113285488163400818)
,p_name=>'CUSTOM'
,p_message_language=>'nl'
,p_message_text=>'Aangepast'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113296662710400827)
,p_name=>'CUSTOMIZE'
,p_message_language=>'nl'
,p_message_text=>'Aanpassen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113298219452400828)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'nl'
,p_message_text=>'Paginavoorkeuren voor gebruiker %0 opnieuw ingesteld.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113298343704400828)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'nl'
,p_message_text=>'Voorkeuren voor gebruiker %0 gewijzigd.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113298147944400828)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'nl'
,p_message_text=>'Paginavoorkeuren voor gebruiker %0 opnieuw ingesteld.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113261996345400801)
,p_name=>'DAILY'
,p_message_language=>'nl'
,p_message_text=>'Dagelijks'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113233522114400779)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'nl'
,p_message_text=>'Geladen bestand is ongeldig of heeft een onjuiste extensie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113257442255400797)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige XML- of JSON-selector gebruikt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113226795830400773)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'nl'
,p_message_text=>'Gegevensprofiel en geladen bestand bevatten geen doeltabelkolom.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113312436180400838)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'nl'
,p_message_text=>'Er zijn geen gegevens gevonden in het geladen bestand.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113312502219400838)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'nl'
,p_message_text=>'Er zijn geen gegevens gevonden op het werkblad "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113232327161400778)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'nl'
,p_message_text=>'Het opgegeven bestand is geen XLSX-bestand.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113222706505400770)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'nl'
,p_message_text=>'Laden van gegevens is voltooid. %0 rijen verwerkt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113223986046400771)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'nl'
,p_message_text=>'Laden van gegevens is voltooid. %0 rijen verwerkt met 1 fout.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113224285001400771)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'nl'
,p_message_text=>'Laden van gegevens is voltooid. %0 rijen verwerkt met %1 fouten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113224005809400771)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'nl'
,p_message_text=>'Laden van gegevens is voltooid. 1 rij verwerkt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113227029065400773)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'nl'
,p_message_text=>'Laden van gegevens is voltooid. 1 rij verwerkt met fouten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113224176262400771)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'nl'
,p_message_text=>'Laden van gegevens is voltooid. 1 rij verwerkt zonder fouten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113317792701400842)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'nl'
,p_message_text=>'Doelkolom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113317879051400842)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'nl'
,p_message_text=>'Bronkolom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113318656341400843)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'nl'
,p_message_text=>'Datum-/Getalnotatie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113382005842400890)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'nl'
,p_message_text=>'Het ophalen van de referentiewaarde is mislukt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113350557338400867)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'nl'
,p_message_text=>'Gegevens-/Tabelafstemming'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113318799518400843)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'nl'
,p_message_text=>'Rij'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113314222459400840)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'nl'
,p_message_text=>'De transformatieregel is mislukt.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113290582650400822)
,p_name=>'DATE'
,p_message_language=>'nl'
,p_message_text=>'Datum'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113264683151400803)
,p_name=>'DAY'
,p_message_language=>'nl'
,p_message_text=>'dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113264724448400803)
,p_name=>'DAYS'
,p_message_language=>'nl'
,p_message_text=>'dagen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113303416462400832)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'nl'
,p_message_text=>'Foutopsporing is niet geactiveerd voor deze applicatie.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113352252406400868)
,p_name=>'DEFAULT'
,p_message_language=>'nl'
,p_message_text=>'Standaard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113265416106400804)
,p_name=>'DELETE'
,p_message_language=>'nl'
,p_message_text=>'verwijderen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113225600984400772)
,p_name=>'DIAL_PCT'
,p_message_language=>'nl'
,p_message_text=>'Wijzer (percentage)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113240168321400784)
,p_name=>'DOWNLOAD'
,p_message_language=>'nl'
,p_message_text=>'Download'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113351339412400867)
,p_name=>'DUP_USER'
,p_message_language=>'nl'
,p_message_text=>'Dubbele gebruikersnaam in lijst'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113247707481400790)
,p_name=>'EDIT'
,p_message_language=>'nl'
,p_message_text=>'Bewerken'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113257166946400797)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'nl'
,p_message_text=>'E-mailadres "%0" is niet gevonden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113242270520400786)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'nl'
,p_message_text=>'Dit e-mailbericht is verzonden door %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113351562457400868)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'nl'
,p_message_text=>'Het e-mailadres is te lang. De limiet is 240 tekens.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113285120552400818)
,p_name=>'ERROR'
,p_message_language=>'nl'
,p_message_text=>'Fout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113314335166400840)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'nl'
,p_message_text=>'Kan de bronwaarde van het pagina-item voor de regio voor gedeeltelijk vernieuwen van de pagina niet instellen.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113276665300400812)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'nl'
,p_message_text=>'Gemaakt door'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113242554482400786)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'nl'
,p_message_text=>'Wachtwoord verlopen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113236684434400781)
,p_name=>'FILE_EMPTY'
,p_message_language=>'nl'
,p_message_text=>'Het bestand is leeg.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113316808280400842)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'nl'
,p_message_text=>'Het geladen bestand was groter dan %0 MB. Upload een kleiner bestand.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113244663761400787)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'nl'
,p_message_text=>'De gebruikersverificatie is mislukt en een of meer bestanden zijn niet geladen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113244780836400788)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'nl'
,p_message_text=>'In deze instance mogen niet-geverifieerde gebruikers geen bestanden laden.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113297796311400828)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is 1 fout opgetreden.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113296912944400827)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er zijn %0 fouten opgetreden.'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113247193208400789)
,p_name=>'FORM_OF'
,p_message_language=>'nl'
,p_message_text=>'%0 van %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113281848652400816)
,p_name=>'GO'
,p_message_language=>'nl'
,p_message_text=>'Uitvoeren'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113381623142400890)
,p_name=>'HELP'
,p_message_language=>'nl'
,p_message_text=>'Help'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113234068878400779)
,p_name=>'HOME'
,p_message_language=>'nl'
,p_message_text=>'Beginpagina'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113264419705400803)
,p_name=>'HOUR'
,p_message_language=>'nl'
,p_message_text=>'uur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113264513558400803)
,p_name=>'HOURS'
,p_message_language=>'nl'
,p_message_text=>'uur'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113248534885400791)
,p_name=>'ICON'
,p_message_language=>'nl'
,p_message_text=>'Pictogram %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113298509874400828)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige inlogreferenties'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113398024818400902)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige waarde voor parameter: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113293242804400824)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'nl'
,p_message_text=>'Als standaardrapportinstellingen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113293352821400824)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'nl'
,p_message_text=>'Als benoemd rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113275744496400811)
,p_name=>'IR_ERROR'
,p_message_language=>'nl'
,p_message_text=>'%0-fout. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113275409686400811)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Schermnavigatie kan niet worden berekend. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113253051916400794)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Interactief rapport niet gevonden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113252459175400794)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Interactieve rapportregio bestaat niet in applicatie %0, pagina %1 en regio %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113293112497400824)
,p_name=>'IR_STAR'
,p_message_language=>'nl'
,p_message_text=>'Alleen weergegeven aan ontwikkelaars'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113281506815400816)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'nl'
,p_message_text=>'De rapportquery moet een unieke sleutel bevatten om elke rij te identificeren. De opgegeven sleutel kan niet voor deze query worden gebruikt. Definieer een unieke sleutelkolom. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113281616061400816)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'nl'
,p_message_text=>unistr('De rapportquery moet een unieke sleutel bevatten om elke rij te identificeren. De opgegeven sleutel kan niet voor deze query worden gebruikt. Bewerk de rapportattributen om een unieke sleutelkolom te defini\00EBren. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113318960900400843)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'nl'
,p_message_text=>'Bestand kiezen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113318816009400843)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'nl'
,p_message_text=>'Bestand slepen en hier neerzetten of'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113247429449400790)
,p_name=>'ITEMS'
,p_message_language=>'nl'
,p_message_text=>'Items'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113276850190400812)
,p_name=>'ITEM_VALUE'
,p_message_language=>'nl'
,p_message_text=>'Itemwaarde'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113291290031400823)
,p_name=>'LABEL'
,p_message_language=>'nl'
,p_message_text=>'Label'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113303318034400832)
,p_name=>'LANGUAGE'
,p_message_language=>'nl'
,p_message_text=>'Taal'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113265142303400803)
,p_name=>'LAST'
,p_message_language=>'nl'
,p_message_text=>'laatste'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113244534722400787)
,p_name=>'LENGTH'
,p_message_language=>'nl'
,p_message_text=>'Lengte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113297823713400828)
,p_name=>'LOGIN'
,p_message_language=>'nl'
,p_message_text=>'Inloggen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113336450473400856)
,p_name=>'MANAGE'
,p_message_language=>'nl'
,p_message_text=>'Beheren'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113401033335400904)
,p_name=>'MAXIMIZE'
,p_message_language=>'nl'
,p_message_text=>'Maximaliseren'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113264296877400803)
,p_name=>'MINUTE'
,p_message_language=>'nl'
,p_message_text=>' minuut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113264373090400803)
,p_name=>'MINUTES'
,p_message_language=>'nl'
,p_message_text=>'minuten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113351795459400868)
,p_name=>'MISSING_AT'
,p_message_language=>'nl'
,p_message_text=>'Het "@" ontbreekt in het e-mailadres.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113351901817400868)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'nl'
,p_message_text=>'Waarschuwing: er is geen dialoogpaginasjabloon gedefinieerd voor dialoogpagina %0 in applicatie %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113351624230400868)
,p_name=>'MISSING_DOT'
,p_message_language=>'nl'
,p_message_text=>'De "." ontbreekt in het domein van het e-mailadres.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113300889331400830)
,p_name=>'MODULE'
,p_message_language=>'nl'
,p_message_text=>'Module'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113257956210400798)
,p_name=>'MONTH'
,p_message_language=>'nl'
,p_message_text=>'Maand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113261784409400801)
,p_name=>'MONTHLY'
,p_message_language=>'nl'
,p_message_text=>'Maandelijks'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113258047896400798)
,p_name=>'MONTHS'
,p_message_language=>'nl'
,p_message_text=>'maanden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113290871544400823)
,p_name=>'MOVE'
,p_message_language=>'nl'
,p_message_text=>'Verplaatsen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113358352722400873)
,p_name=>'MOVE_FROM'
,p_message_language=>'nl'
,p_message_text=>'Verplaatsen van'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113358492090400873)
,p_name=>'MOVE_TO'
,p_message_language=>'nl'
,p_message_text=>'Verplaatsen naar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113278055718400813)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'nl'
,p_message_text=>'Fout bij verwijderen meerdere rijen: rij= %0, %1, %2'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113277022688400812)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'nl'
,p_message_text=>'Mag geen openbare gebruiker zijn.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113234264190400779)
,p_name=>'NAME'
,p_message_language=>'nl'
,p_message_text=>'Naam'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113291094429400823)
,p_name=>'NEW'
,p_message_language=>'nl'
,p_message_text=>'Nieuw'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113257751880400798)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'nl'
,p_message_text=>'Ga om u aan te melden bij %0 naar:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113257844738400798)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'nl'
,p_message_text=>'Melding over nieuwe %0 account'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113381849659400890)
,p_name=>'NEXT'
,p_message_language=>'nl'
,p_message_text=>'Volgende'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113300741319400830)
,p_name=>'NO'
,p_message_language=>'nl'
,p_message_text=>'Nee'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113396027564400901)
,p_name=>'NOBODY'
,p_message_language=>'nl'
,p_message_text=>'niemand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113265505948400804)
,p_name=>'NOT'
,p_message_language=>'nl'
,p_message_text=>'Niet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113306321809400834)
,p_name=>'NOT_NULL'
,p_message_language=>'nl'
,p_message_text=>'Niet NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113277131275400812)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'nl'
,p_message_text=>'Niet %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113296784949400827)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'nl'
,p_message_text=>'geen gegevens gevonden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113305876310400833)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Er is geen rapport gevonden dat kan worden bijgewerkt. Bewerkingen voor het bijwerken of verwijderen van meerdere rijen kunnen alleen worden uitgevoerd op tabelschermen van het type ''Bijwerkbaar rapport''.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113306719362400834)
,p_name=>'OK'
,p_message_language=>'nl'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113302426417400831)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'nl'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113399815093400903)
,p_name=>'ORA_06550'
,p_message_language=>'nl'
,p_message_text=>'ORA-06550: regel %0, kolom %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113349354851400866)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'nl'
,p_message_text=>'U gebruikt een verouderde webbrowser. Zie de Oracle Application Express Installation Guide voor een lijst met ondersteunde browsers.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113250779085400792)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige set rijen opgevraagd, de brongegevens van het rapport zijn gewijzigd.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113270824823400808)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'nl'
,p_message_text=>'Er moet een geldig paginanummer worden opgegeven. Voorbeeld: p?n=1234.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113274495251400810)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'nl'
,p_message_text=>'Volgende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113274569262400810)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'nl'
,p_message_text=>'Volgende set'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113274675872400811)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'nl'
,p_message_text=>'Vorige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113274738669400811)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'nl'
,p_message_text=>'Vorige set'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113381723640400890)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'nl'
,p_message_text=>'Paginering selecteren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113312388205400838)
,p_name=>'PASSWORD'
,p_message_language=>'nl'
,p_message_text=>'Wachtwoord'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113257053895400797)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'nl'
,p_message_text=>'Uw wachtwoord voor %0 is gewijzigd.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113246816334400789)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Het wachtwoord voldoet niet aan de complexiteitsregels van deze site.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113245991545400789)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'nl'
,p_message_text=>'Het nieuwe wachtwoord moet met ten minste %0 tekens verschillen van het oude wachtwoord.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113246557742400789)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'nl'
,p_message_text=>'De gebruikersnaam mag geen deel uitmaken van het wachtwoord.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113246776602400789)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'nl'
,p_message_text=>'Het wachtwoord bevat een verboden eenvoudig woord.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113246628799400789)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'nl'
,p_message_text=>'De naam van de werkruimte mag geen deel uitmaken van het wachtwoord.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113245893635400788)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'nl'
,p_message_text=>'Het wachtwoord moet ten minste %0 tekens bevatten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113246011763400789)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'nl'
,p_message_text=>unistr('Het wachtwoord moet ten minste \00E9\00E9n letter (%0) bevatten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113246473810400789)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'nl'
,p_message_text=>unistr('Het wachtwoord moet ten minste \00E9\00E9n kleine letter bevatten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113246103539400789)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'nl'
,p_message_text=>unistr('Het wachtwoord moet ten minste \00E9\00E9n cijfer bevatten (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113246258092400789)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'nl'
,p_message_text=>unistr('Het wachtwoord moet ten minste \00E9\00E9n interpunctieteken (%0) bevatten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113246324340400789)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'nl'
,p_message_text=>unistr('Het wachtwoord moet ten minste \00E9\00E9n hoofdletter bevatten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113257541807400797)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'nl'
,p_message_text=>'Melding over opnieuw instellen wachtwoord'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113244819806400788)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Het wachtwoord kan niet worden gebruikt, omdat het in de afgelopen %0 dagen is gebruikt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113325151029400848)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'nl'
,p_message_text=>'Items'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113325260586400848)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'nl'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113302221617400831)
,p_name=>'PERCENT'
,p_message_language=>'nl'
,p_message_text=>'Percentage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113272579157400809)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'nl'
,p_message_text=>'Neem contact op met de beheerder.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113381936936400890)
,p_name=>'PREVIOUS'
,p_message_language=>'nl'
,p_message_text=>'Vorige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113317356186400842)
,p_name=>'PRINT'
,p_message_language=>'nl'
,p_message_text=>'Afdrukken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113301063406400830)
,p_name=>'PRIVILEGES'
,p_message_language=>'nl'
,p_message_text=>'Rechten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113270961634400808)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'nl'
,p_message_text=>'Regioreferenties'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113291109499400823)
,p_name=>'REPORT'
,p_message_language=>'nl'
,p_message_text=>'Rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113300905913400830)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'nl'
,p_message_text=>'Rapportageperiode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113382116123400890)
,p_name=>'REPORT_LABEL'
,p_message_language=>'nl'
,p_message_text=>'Rapport: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113301662158400830)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'nl'
,p_message_text=>'Totaal rapport'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113250897584400792)
,p_name=>'RESET'
,p_message_language=>'nl'
,p_message_text=>'Paginering opnieuw instellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113276714921400812)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'nl'
,p_message_text=>'Paginering opnieuw instellen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113305705024400833)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'nl'
,p_message_text=>'Wachtwoord opnieuw instellen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113282513734400816)
,p_name=>'RESTORE'
,p_message_language=>'nl'
,p_message_text=>'Herstellen'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113314490829400840)
,p_name=>'RESULTS'
,p_message_language=>'nl'
,p_message_text=>'Resultaten'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113306881860400834)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'nl'
,p_message_text=>'Terug naar applicatie'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113307198026400834)
,p_name=>'RIGHT'
,p_message_language=>'nl'
,p_message_text=>'Rechts'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113336703331400857)
,p_name=>'ROW'
,p_message_language=>'nl'
,p_message_text=>'Rij %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113290727574400822)
,p_name=>'ROW_COUNT'
,p_message_language=>'nl'
,p_message_text=>'Aantal rijen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113306215084400834)
,p_name=>'SAVE'
,p_message_language=>'nl'
,p_message_text=>'Opslaan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113302811538400831)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'nl'
,p_message_text=>'Alternatief standaardrapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113303251688400831)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'nl'
,p_message_text=>'Beschrijving'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113302766695400831)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'nl'
,p_message_text=>'Primair standaardrapport'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113303580207400832)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'nl'
,p_message_text=>'Er zijn meer dan %0 rijen beschikbaar. Verhoog de rijselector om meer rijen te zien.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113368969806400880)
,p_name=>'SEARCH'
,p_message_language=>'nl'
,p_message_text=>'Zoeken'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113264165094400803)
,p_name=>'SECONDS'
,p_message_language=>'nl'
,p_message_text=>'seconden'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113302313146400831)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'nl'
,p_message_text=>'Zie bijlage'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113360017960400874)
,p_name=>'SELECT_ROW'
,p_message_language=>'nl'
,p_message_text=>'Rij selecteren'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113302002446400831)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'nl'
,p_message_text=>'Schermlezermodus uitzetten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113302153196400831)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'nl'
,p_message_text=>'Schermlezermodus aanzetten'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113298424063400828)
,p_name=>'SHOW'
,p_message_language=>'nl'
,p_message_text=>'Tonen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113361828877400875)
,p_name=>'SHOW_ALL'
,p_message_language=>'nl'
,p_message_text=>'Alles tonen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113387948139400894)
,p_name=>'SIGN_IN'
,p_message_language=>'nl'
,p_message_text=>'Aanmelden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113337516149400857)
,p_name=>'SIGN_OUT'
,p_message_language=>'nl'
,p_message_text=>'Afmelden'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113291715614400823)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0 dagen geleden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113298981658400828)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'%0 dagen na nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113291605863400823)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0 uur geleden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113298825993400828)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'%0 uur na nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113291514054400823)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0 minuten geleden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113298794356400828)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'%0 minuten na nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113291966750400823)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0 maanden geleden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113299162987400829)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'%0 maanden na nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113299322924400829)
,p_name=>'SINCE_NOW'
,p_message_language=>'nl'
,p_message_text=>'Nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113291472029400823)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0 seconden geleden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113298612704400828)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'%0 seconden na nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113291829092400823)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0 weken geleden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113299007758400828)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'%0 weken na nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113292028013400823)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'nl'
,p_message_text=>'%0 jaar geleden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113299257469400829)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'nl'
,p_message_text=>'%0 jaar na nu'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113285515572400819)
,p_name=>'STANDARD'
,p_message_language=>'nl'
,p_message_text=>'Standaard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113301922804400831)
,p_name=>'START_DATE'
,p_message_language=>'nl'
,p_message_text=>'Begindatum'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113242410309400786)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'nl'
,p_message_text=>'U ontvangt dit e-mailbericht vanwege een abonnement op een interactief rapport dat gemaakt is door %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113397145727400901)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'nl'
,p_message_text=>'Abonnementen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113345229096400863)
,p_name=>'TAB'
,p_message_language=>'nl'
,p_message_text=>'Tab'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113264031647400802)
,p_name=>'TITLE'
,p_message_language=>'nl'
,p_message_text=>'Titel'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113247002414400789)
,p_name=>'TODAY'
,p_message_language=>'nl'
,p_message_text=>'Vandaag'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113301506633400830)
,p_name=>'TOTAL'
,p_message_language=>'nl'
,p_message_text=>'Totaal'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113248090194400790)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'nl'
,p_message_text=>'U kunt maximaal %0 kolommen selecteren.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113226549579400773)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'nl'
,p_message_text=>'Alles samenvouwen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113226803124400773)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'nl'
,p_message_text=>'Alle onderstaande samenvouwen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113226475722400773)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'nl'
,p_message_text=>'Alles uitvouwen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113226606243400773)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'nl'
,p_message_text=>'Alle onderstaande uitvouwen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113226958084400773)
,p_name=>'TREE.REPARENT'
,p_message_language=>'nl'
,p_message_text=>'Verplaatsen naar ander bovenliggend item'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113319184087400843)
,p_name=>'TREES'
,p_message_language=>'nl'
,p_message_text=>'Boomstructuren'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113362646725400876)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'Vereist'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113286220658400819)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'nl'
,p_message_text=>'Niet geautoriseerd'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113333093135400854)
,p_name=>'UNAVAILABLE'
,p_message_language=>'nl'
,p_message_text=>'Niet beschikbaar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113299757036400829)
,p_name=>'UNKNOWN'
,p_message_language=>'nl'
,p_message_text=>'Onbekend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113243354853400786)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een niet-herkende verificatiefout opgetreden.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113245394161400788)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'nl'
,p_message_text=>'Als u deze e-mailberichten niet meer wilt ontvangen, klikt u op <a href="%0">afmelden</a> om uw abonnement te beheren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113242331291400786)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'nl'
,p_message_text=>'Als u deze e-mailberichten niet meer wilt ontvangen, ga dan naar de volgende URL om uw abonnement te beheren:'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113277270519400812)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'nl'
,p_message_text=>'niet-ondersteund gegevenssoort'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113265351600400803)
,p_name=>'UPDATE'
,p_message_language=>'nl'
,p_message_text=>'bijwerken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113263989697400802)
,p_name=>'UPDATED'
,p_message_language=>'nl'
,p_message_text=>'Bijgewerkt'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113270684708400808)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'nl'
,p_message_text=>'De gevraagde URL is verboden. Neem contact op met de beheerder.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113290675296400822)
,p_name=>'USER'
,p_message_language=>'nl'
,p_message_text=>'Gebruiker'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113312261759400838)
,p_name=>'USERNAME'
,p_message_language=>'nl'
,p_message_text=>'Gebruikersnaam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113351805332400868)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'nl'
,p_message_text=>'De gebruikersnaam is te lang. De limiet is %0 tekens.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113297415945400827)
,p_name=>'USERS'
,p_message_language=>'nl'
,p_message_text=>'gebruikers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113351495536400868)
,p_name=>'USER_EXISTS'
,p_message_language=>'nl'
,p_message_text=>'Gebruikersnaam bestaat al.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113366190937400878)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'nl'
,p_message_text=>'Profielafbeelding voor gebruiker %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113253704115400795)
,p_name=>'VALID'
,p_message_language=>'nl'
,p_message_text=>'Geldig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113247345939400790)
,p_name=>'VALIDATIONS'
,p_message_language=>'nl'
,p_message_text=>'Validaties'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113303042636400831)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'nl'
,p_message_text=>'Er moet een waarde worden opgegeven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113346407137400864)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'nl'
,p_message_text=>'Er moet een waarde worden opgegeven voor %0.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113272944433400809)
,p_name=>'VERTICAL'
,p_message_language=>'nl'
,p_message_text=>'verticaal'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113265255194400803)
,p_name=>'VIEW'
,p_message_language=>'nl'
,p_message_text=>'weergeven'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113297535767400827)
,p_name=>'VIEWS'
,p_message_language=>'nl'
,p_message_text=>'weergaven'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113303837904400832)
,p_name=>'VIEW_ALL'
,p_message_language=>'nl'
,p_message_text=>'Alles weergeven'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113285039542400818)
,p_name=>'WARNING'
,p_message_language=>'nl'
,p_message_text=>'Waarschuwing'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113264813444400803)
,p_name=>'WEEK'
,p_message_language=>'nl'
,p_message_text=>'week'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113261847944400801)
,p_name=>'WEEKLY'
,p_message_language=>'nl'
,p_message_text=>'Wekelijks'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113264970047400803)
,p_name=>'WEEKS'
,p_message_language=>'nl'
,p_message_text=>'weken'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113303180847400831)
,p_name=>'WELCOME_USER'
,p_message_language=>'nl'
,p_message_text=>'Welkom: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113301365430400830)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige waarde aangetroffen. Controleer de ingevoerde gegevens.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113301447985400830)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige waarde aangetroffen. Controleer de ingevoerde gegevens.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113244415789400787)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige datumwaarde aangetroffen. Controleer de datumnotatie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113301268850400830)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige getalwaarde aangetroffen. Controleer de getalnotatie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113253376393400794)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige tijdstempelwaarde aangetroffen. Controleer de datumnotatie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113275897348400811)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'nl'
,p_message_text=>'Kan "%0" niet binden. Gebruik dubbele aanhalingstekens voor items die uit meerdere bytes bestaan, of controleer of het item 30 bytes of minder is. Gebruik de syntaxis v() om te verwijzen naar items van meer dan 30 bytes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113266361480400804)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'nl'
,p_message_text=>'Toegang geweigerd door %0 beveiligingscontrole'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113268899330400806)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'nl'
,p_message_text=>'Applicatie niet beschikbaar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113267226917400805)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'nl'
,p_message_text=>'ERR-1014: applicatie is niet gevonden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113267366925400805)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'nl'
,p_message_text=>'applicatie=%0  werkruimte=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113267791893400805)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'nl'
,p_message_text=>'Toegang tot deze applicatie is beperkt. Probeer het later opnieuw.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113267610491400805)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'nl'
,p_message_text=>'Toegang tot deze applicatie is beperkt tot applicatieontwikkelaars. Probeer het later opnieuw.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113266828184400805)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'nl'
,p_message_text=>'ERR-7744: vertakking naar URL-retournerende functie kan niet worden verwerkt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113266731977400805)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'nl'
,p_message_text=>'ERR-7744: vertakking naar pagina-retournerende functie kan niet worden verwerkt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113267065690400805)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'nl'
,p_message_text=>'ERR-1430: aanroep voor weergave van paginaproces niet ondersteund: G_FLOW_STEP_ID (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113268129305400806)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'nl'
,p_message_text=>'ERR-1018: fout bij wissen stapcache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113266595391400804)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'nl'
,p_message_text=>'ERR-1005: onbekend berekeningstype.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113267452330400805)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'nl'
,p_message_text=>'ERR-1201: sessie-ID niet ingesteld in aangepaste verificatie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113267580810400805)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'nl'
,p_message_text=>'pagina=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113267184268400805)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'nl'
,p_message_text=>'ERR-7620: werkruimte voor applicatie (%0) kan niet worden bepaald.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113249538767400791)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'nl'
,p_message_text=>'Bewerken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113266255482400804)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'nl'
,p_message_text=>'ERR-1802: kan item-ID "%0" niet vinden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113265950800400804)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'nl'
,p_message_text=>'ERR-1002: kan geen item-ID vinden voor item "%0" in applicatie "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113266094425400804)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'nl'
,p_message_text=>'Onverwachte fout: kan itemnaam niet vinden op applicatie- of paginaniveau.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113266493878400804)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'nl'
,p_message_text=>'U bent al bij de eerste pagina met gegevens.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113281974434400816)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'nl'
,p_message_text=>'Item-ID (%0) is geen item dat op de huidige pagina is gedefinieerd.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113244000607400787)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'nl'
,p_message_text=>'Item kan niet worden ingesteld door argumenten door te geven aan de applicatie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113244361241400787)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'nl'
,p_message_text=>'(Er is geen controletelling opgegeven.)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113243841122400787)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'nl'
,p_message_text=>'Item kan worden ingesteld indien vergezeld van een "user-level bookmark"-controletelling.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113243750743400787)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'nl'
,p_message_text=>'Item kan worden ingesteld indien vergezeld van een "application-level bookmark"-controletelling.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113243988955400787)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'nl'
,p_message_text=>'Item kan worden ingesteld indien vergezeld van een "session"-controletelling.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113243631470400787)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'nl'
,p_message_text=>'Item heeft geen bescherming.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113268267216400806)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'nl'
,p_message_text=>'Er is geen pagina-help beschikbaar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113257316556400797)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'nl'
,p_message_text=>'Werkruimte %0 heeft niet de rechten om te worden ontleed als schema %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113266673232400804)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'nl'
,p_message_text=>'ERR-1010: recursielimiet voor vertakking naar verwerking pagina-acceptatie overschreden. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113244294678400787)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'nl'
,p_message_text=>'Deze pagina kan niet worden aangeroepen via een URL of met een GET of POST naar de weergaveprocedure; hij moet worden aangeroepen met behulp van het vertakkingstype "Branch to Page".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113320985624400845)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'nl'
,p_message_text=>'Fout bij poging een niet-numerieke waarde op te slaan in item %0. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113259088908400799)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'nl'
,p_message_text=>'Ontleedschema "%0" van de applicatie bestaat niet in de database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113259133381400799)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'nl'
,p_message_text=>'Accounts in de werkruimte INTERNAL kunnen alleen worden gebruikt om toegang te krijgen tot &PRODUCT_NAME. <a href="%0">Administration Services</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113265819151400804)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'nl'
,p_message_text=>'ERR-1029: kan sessiegegevens niet opslaan. sessie=%0 item=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113268920227400806)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'nl'
,p_message_text=>'Kan tracering niet stoppen: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113266176820400804)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'nl'
,p_message_text=>'Onverwachte fout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113276112373400812)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'nl'
,p_message_text=>'Fout in update_substitution_cache: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113269059143400806)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'nl'
,p_message_text=>'Applicatie en pagina moeten worden opgegeven om help te bekijken.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113289505499400822)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Automatisering niet gevonden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113270162554400807)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'nl'
,p_message_text=>'%0 sessies opgeschoond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113229407873400775)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'nl'
,p_message_text=>'Kan %0 code niet uitvoeren. Deze wordt niet ondersteund door de database of is niet ingeschakeld door de instanceparameter MLE_LANGUAGES.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113229213542400775)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'nl'
,p_message_text=>'Multi Lingual Engine is niet beschikbaar voor deze databaseversie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113250044402400792)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'nl'
,p_message_text=>'Applicatieverzamelingsreeks %0 bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113249886048400791)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'nl'
,p_message_text=>'Het opgegeven onderdeelattribuutnummer, %0, is ongeldig. Het attribuutnummer moet tussen 1 en %1 liggen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113250379821400792)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'nl'
,p_message_text=>'Applicatieverzameling bestaat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113250110059400792)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'nl'
,p_message_text=>'Verzamelingsnaam mag niet NULL zijn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113250268715400792)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'nl'
,p_message_text=>'Verzamelingsnaam mag niet langer zijn dan 255 tekens.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113249678943400791)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Applicatieverzameling %0 bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113250406860400792)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'nl'
,p_message_text=>'Cursor is nog niet open.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113249794116400791)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Onderdeelvolgnummer %0 bestaat niet in applicatieverzameling %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113249918776400792)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'nl'
,p_message_text=>'Onderdeelvolgnummer %0 bestaat niet in applicatieverzameling "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113321704139400845)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'nl'
,p_message_text=>'De cryptografische functie ''%0"wordt niet ondersteund op dit systeem.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113375203291400885)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'nl'
,p_message_text=>'Toegankelijkheid getest'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113269681138400807)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'nl'
,p_message_text=>'Sluiten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113269718291400807)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'nl'
,p_message_text=>'Pagina-aanpassingsopties'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113269829808400807)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'nl'
,p_message_text=>'Standaard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113269909127400807)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'nl'
,p_message_text=>'Weergegeven'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113270017674400807)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'nl'
,p_message_text=>'Verborgen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113269465704400807)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'nl'
,p_message_text=>'Schakel de regio''s in die u op deze pagina wilt weergeven. Ingeschakelde regio''s worden mogelijk niet weergegeven als u zich niet in de juiste applicatiecontext bevindt of als u niet de juiste rechten hebt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113269531476400807)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'nl'
,p_message_text=>'Deze pagina kan niet worden aangepast.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113375524274400885)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'nl'
,p_message_text=>'U kunt het uiterlijk van deze applicatie aanpassen door de themastijl te wijzigen. Selecteer een themastijl in de onderstaande lijst en klik op ''Wijzigingen toepassen''.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113376352228400886)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'nl'
,p_message_text=>'Regioweergave'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113375473528400885)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'nl'
,p_message_text=>'Standaardstijl van applicatie gebruiken'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113375322111400885)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'nl'
,p_message_text=>'Vormgeving '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113318304478400843)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'De kolomindex waarnaar wordt verwezen in aggregatie %0 bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113221668234400769)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'nl'
,p_message_text=>'CLOB-uitvoer wordt niet ondersteund voor de uitvoerindeling %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113318072265400843)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'nl'
,p_message_text=>'Het kolomeinde moet aan het begin van de kolommenreeks staan.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113318101363400843)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'De kolomgroepindex waarnaar in %0 wordt verwezen bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113235641686400780)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'nl'
,p_message_text=>'exporteren'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113240885146400784)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'nl'
,p_message_text=>'De uitvoerindeling moet XML zijn, en ORDS moet worden gebruikt als afdrukserver.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113318465302400843)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'De kolomindex waarnaar wordt verwezen in markering %0 bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113234156432400779)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige exportindeling: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113318248097400843)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'De bovenliggende groepindex waarnaar in %0 wordt verwezen bestaat niet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113343435952400862)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Kolom %1 van tabel %0 is een ID-kolom die altijd wordt gegenereerd ("GENERATED ALWAYS"). Zorg ervoor dat er geen bronkolom wordt afgestemd op kolom %1 in het dialoogvenster ''Configureren''.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113260847326400800)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'nl'
,p_message_text=>'Het opgegeven vastleginterval is te klein.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113260960105400800)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'nl'
,p_message_text=>'Er zijn geen kolommen opgegeven voor het laden van gegevens.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113262167546400801)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Geen kolommen gevonden voor rijselector "%0". Probeer automatisch te detecteren of controleer de JSON-structuur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113270404656400807)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Geen werkbladen gevonden in XLSX-bestand'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113270368430400807)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'nl'
,p_message_text=>'Het opgegeven werkblad bevindt zich niet in het XLSX-bestand.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113250511987400792)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'nl'
,p_message_text=>'De huidige versie van de gegevens in de database is gewijzigd nadat de gebruiker het updateproces heeft gestart.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113252925419400794)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'nl'
,p_message_text=>'Fout bij bijwerken van kolommen: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113357653636400872)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'nl'
,p_message_text=>'%0 kan niet worden geconverteerd naar SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113297180461400827)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'nl'
,p_message_text=>'Kolom %0 met gegevenssoort %1 kan niet worden geconverteerd naar VARCHAR2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113304191021400832)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Kolom "%0" die is opgegeven voor attribuut "%1" is niet gevonden in de gegevensbron.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113245453532400788)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'nl'
,p_message_text=>'Filtertype %0 wordt niet ondersteund voor kolommen met meerder waarden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113361052954400875)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'nl'
,p_message_text=>'Ongeldig "tussen"-filter.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113227519068400774)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'nl'
,p_message_text=>'Ongeldig waardelijsttype opgegeven'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113227495242400774)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Ongeldig querytype. Het querytype moet Tabel, SQL-query of een PL/SQL-functie die een SQL-query retourneert zijn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113297234812400827)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Ontleden van SQL-query is mislukt.',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113304266126400832)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'nl'
,p_message_text=>'De opgegeven kolompositie %0 voor attribuut "%1" is niet gevonden in het SQL-statement.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113226017554400773)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'nl'
,p_message_text=>'Te veel items gebruikt in meerwaardig filter.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113304090248400832)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'nl'
,p_message_text=>'Er is geen kolom opgegeven voor attribuut "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113227394074400774)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'nl'
,p_message_text=>'Hoofdtekst PL/SQL-functie heeft geen waarde geretourneerd.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113317216362400842)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'nl'
,p_message_text=>'De REST-gegevensbron bevat geen bewerking voor het afhandelen van de gevraagde DML-actie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113223287799400771)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'nl'
,p_message_text=>'Conversie van GeoJSON naar SDO_GEOMETRY (kolom %0) is niet beschikbaar in deze database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113224390467400771)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'nl'
,p_message_text=>'SDO_GEOMETRY-conversie (column %0) wordt niet ondersteund voor XML-gegevensbronnen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113231625169400777)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'nl'
,p_message_text=>'Het teken %0 wordt niet ondersteund als scheidingsteken voor meerdere waarden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113358908143400873)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Deze functie kan niet worden gebruikt in een querycontext.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113224471478400771)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Niet-overeenkomend kolomgegevenssoort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113227267391400773)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'nl'
,p_message_text=>'Interne ORDS OUT bindlimieten overschreden. Verminder het aantal DML-rijen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113305014428400833)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'De JSON-respons van de externe server kan niet worden ontleed: ',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113227170479400773)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'nl'
,p_message_text=>'Onbekend of onjuist contexttype'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113321618306400845)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Dit bestandstype wordt niet ondersteund door de parser.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113276259356400812)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'nl'
,p_message_text=>'Niet-geautoriseerde toegang (wwv_flow_api.set_credentials niet ingesteld).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113253221806400794)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'nl'
,p_message_text=>'Werkruimte is niet gemaakt, omdat deze al bestaat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113253170061400794)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'nl'
,p_message_text=>'Gebruikersgroep is niet gemaakt, omdat deze al bestaat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113263457484400802)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'nl'
,p_message_text=>'Er is een dubbele gebruikersnaam gevonden voor %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113263546802400802)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'nl'
,p_message_text=>'Fout bij laden van gebruikers. Mislukt bij gebruiker %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113273465575400810)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'nl'
,p_message_text=>'Zou %0 gebruikers hebben geladen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113273260854400809)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'nl'
,p_message_text=>'Wachtwoord'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113273325071400810)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'nl'
,p_message_text=>'Rechten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113273019500400809)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'nl'
,p_message_text=>'Gebruikersnaam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113349591750400866)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Er is een fout opgetreden bij het weergeven van pagina-item #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113269144005400806)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'nl'
,p_message_text=>'Kan pagina-item niet weergeven, omdat het HTML-scherm nog niet was geopend.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113234473596400779)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'nl'
,p_message_text=>'Fout bij berekenen van standaardwaarde item voor pagina-item #COMPONENT_NAME#'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113268449739400806)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'nl'
,p_message_text=>'Fout in naberekening van item voor pagina-item #COMPONENT_NAME#'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113268320227400806)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'nl'
,p_message_text=>'Fout bij berekenen van itembronwaarde voor pagina-item #COMPONENT_NAME#'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113248147383400790)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'nl'
,p_message_text=>'Niet-geautoriseerde toegang'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113268664403400806)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'nl'
,p_message_text=>'JavaScript wordt niet ondersteund.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113268794669400806)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'nl'
,p_message_text=>'Weergeven'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113269348696400807)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'nl'
,p_message_text=>unistr('De query kan niet worden ge\00EFnitialiseerd.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113276536807400812)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'nl'
,p_message_text=>'Bijwerken van %0 wordt niet ondersteund.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113270769492400808)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige item-ID: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113297017281400827)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'nl'
,p_message_text=>'Voor dit item is geen helptekst beschikbaar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113261539185400801)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'nl'
,p_message_text=>'Genereren van grafiekquery is mislukt. Controleer de instellingen voor het afstemmen van bron en kolommen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113356365827400871)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'nl'
,p_message_text=>'De bijlage van %0 MB overschrijdt de maximale bijlagegrootte van %1 MB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113262474050400801)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige waarde voor parameter p_mail_id: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113379884088400888)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'nl'
,p_message_text=>'Het maximum aantal e-mailberichten per werkruimte is overschreden. Neem contact op met de beheerder.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113243491850400787)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'nl'
,p_message_text=>'Deze procedure moet worden aangeroepen vanuit een applicatiesessie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113262341311400801)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'nl'
,p_message_text=>'Er is een NULL-waarde opgegeven voor de parameter %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113316333494400841)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'nl'
,p_message_text=>'E-mailsjabloon"%0" niet gevonden in applicatie %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113392816204400898)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'De instanceparameter SMTP_HOST_ADDRESS moet zijn ingesteld om e-mailberichten te kunnen versturen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113262070300400801)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'U moet een ontvanger voor het bericht opgeven om e-mail te verzenden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113382291602400890)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'nl'
,p_message_text=>'Kan geen SMTP-verbinding tot stand brengen met de geconfigureerde e-mailserver.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113356472230400871)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'nl'
,p_message_text=>'Ongeldige Ajax-aanroep'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113247873704400790)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'nl'
,p_message_text=>'Er is geen Ajax-functie gedefinieerd voor de plug-in %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113346819369400864)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'nl'
,p_message_text=>'Er is geen uitvoeringsfunctie gedefinieerd voor de plug-in %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113247983592400790)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'nl'
,p_message_text=>'Er is geen weergavefunctie gedefinieerd voor de plug-in %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113357369625400872)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'nl'
,p_message_text=>'De REST-gegevensbronplug-in "%0" bevat geen "Capabilities"-functie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113357261087400872)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'nl'
,p_message_text=>'De REST-gegevensbronplug-in "%0" bevat geen DML-functie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113357422808400872)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'nl'
,p_message_text=>'De REST-gegevensbronplug-in "%0" bevat geen uitvoeringsfunctie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113357586838400872)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'nl'
,p_message_text=>'De REST-gegevensbronplug-in "%0" bevat geen ophaalfunctie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113245660485400788)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'nl'
,p_message_text=>'Fout in PLSQL-code opgetreden tijdens verwerking plug-in.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113252208105400793)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'Er moet een waarde worden opgegeven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113282849394400817)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'nl'
,p_message_text=>'Gegevenssoort %0 kan niet worden geconverteerd naar VARCHAR2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113368497374400880)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'nl'
,p_message_text=>'Kolom "%0" die is opgegeven voor attribuut "%1" is niet gevonden in het SQL-statement.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113344715961400862)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'nl'
,p_message_text=>'Er moet een waardelijstquery of benoemde waardelijst worden opgegeven voor %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113346339653400864)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'nl'
,p_message_text=>'Onjuist aantal kolommen geselecteerd in de waardelijst-SQL-query voor %0. Zie voorbeelden voor geldige statements.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113368231867400880)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'nl'
,p_message_text=>'Er is geen kolom opgegeven voor attribuut "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113397943725400902)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'nl'
,p_message_text=>'Ingevoerde waarde %0 voor attribuut "%1" is niet numeriek.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113349899252400866)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'nl'
,p_message_text=>'%0 heeft een onjuist gegevenssoort in het SQL-statement. Kolomnummer %1 is %2, maar %3 wordt verwacht.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113368364065400880)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'nl'
,p_message_text=>'Kolom "%0" die is opgegeven voor attribuut "%1" heeft het gegevenssoort %2, maar dit zou %3 moeten zijn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113244905961400788)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'nl'
,p_message_text=>'De rapportlay-out is niet gevonden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113304948480400833)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'nl'
,p_message_text=>'De functie ''Som berekenen'' kan niet worden gebruikt voor rapporten op basis van een REST-gegevensbron.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113268532952400806)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'nl'
,p_message_text=>'ERR-2904: waarde snelkoppeling kan niet worden ingesteld.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113272815394400809)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'nl'
,p_message_text=>'Fout: Onbekend type snelkoppeling:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113262808682400801)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'nl'
,p_message_text=>'Kan authentication_scheme % niet ophalen in applicatie %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113336379298400856)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'nl'
,p_message_text=>'De tenant-ID bestaat al voor de huidige sessie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113273193368400809)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'nl'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113397315198400901)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'nl'
,p_message_text=>'Verificatie is mislukt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113299610590400829)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'nl'
,p_message_text=>'Een of meer in apex_util.g_request_cookies ingestelde cookies bevatten een ongeldige waarde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113282178112400816)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'nl'
,p_message_text=>'De respons van het UDDI-register was ongeldig.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113245798740400788)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'nl'
,p_message_text=>'De opgegeven URL heeft geen geldig WSDL-document geretourneerd.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113248229630400790)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'nl'
,p_message_text=>unistr('Het WSDL-document bevat meerdere SOAP-bindingen. &PRODUCT_NAME. ondersteunt alleen WSDL''s met \00E9\00E9n SOAP binding. Klik op ''Handmatig webservicereferentie maken'' om door te gaan met het maken van een referentie voor deze service.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113316647809400841)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'nl'
,p_message_text=>'De respons van de service was geen XML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113397264347400901)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'nl'
,p_message_text=>'OAuth-toegangstoken is niet beschikbaar of is verlopen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113360469345400874)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'nl'
,p_message_text=>'Het maximum aantal webserviceaanvragen per werkruimte is overschreden. Neem contact op met de beheerder.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113397405598400902)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'nl'
,p_message_text=>'Server heeft gereageerd met een niet-ondersteund type OAuth-token.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113247614335400790)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'nl'
,p_message_text=>'Het WSDL-document bevatte geen binding voor SOAP, die vereist is om de referentie toe te voegen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113243591355400787)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'nl'
,p_message_text=>'Er zijn verificatiereferenties vereist voor deze WSDL. Geef hieronder de gebruikersnaam en het wachtwoord op.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113252388833400793)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'nl'
,p_message_text=>unistr('Het WSDL-document kan niet worden ge\00EFnterpreteerd door de weergave-engine. Klik op ''Handmatig webservicereferentie maken'' om door te gaan met het maken van een referentie voor deze service.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113319227396400843)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'nl'
,p_message_text=>'Update kan niet worden verwerkt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113345016907400863)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'nl'
,p_message_text=>'De retour- en weergavekolom van de waardelijst zijn hetzelfde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113344925762400863)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'De waardelijst heeft geen retourkolom.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113276487474400812)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'nl'
,p_message_text=>'Fout bij ophalen kolomwaarde: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113300425609400829)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'nl'
,p_message_text=>'De huidige gegevens in het tabelscherm zijn verouderd; de brongegevens zijn gewijzigd.<br/> Klik <strong><a href="%0">hier</a></strong> om uw wijzigingen te negeren en de gegevens opnieuw te laden vanuit de database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113258527177400798)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'nl'
,p_message_text=>'Fout bij bepalen pagineringsstring'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113258417705400798)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'querykopteksten kunnen niet worden bepaald:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113258633141400798)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'nl'
,p_message_text=>'fout bij uitvoeren vervanging rapportvoettekst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113258761290400798)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ontleden SQL-query mislukt:',
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113263736568400802)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'nl'
,p_message_text=>'Minimumrij gevraagd: %0, rijen gevonden maar niet weergegeven: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113261227792400800)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'nl'
,p_message_text=>'querykolom #%0 (%1) is ongeldig; kolommen waar HTML wordt gebruikt moeten aliasnamen hebben.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113276357135400812)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'nl'
,p_message_text=>'Fout bij ophalen querykopteksten: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113258852606400798)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fout rapporteren:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113296555441400827)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'nl'
,p_message_text=>'Sorteren op deze kolom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113261318949400800)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'nl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Query kan niet worden ontleed. Controleer de syntaxis van uw query.',
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113300541909400830)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'nl'
,p_message_text=>'Dit scherm bevat niet-opgeslagen wijzigingen. Klik op OK om door te gaan zonder uw wijzigingen op te slaan. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113304820168400833)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'nl'
,p_message_text=>'Het rapportpagineringsschema (%0) wordt niet ondersteund met de gekozen gegevensbron.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113261148216400800)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'nl'
,p_message_text=>'querykolom #%0 (%1) is ongeldig, gebruik kolomalias.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113263801884400802)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'nl'
,p_message_text=>'rij(en) %0 - %1 van meer dan %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113302508792400831)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'nl'
,p_message_text=>'%0 - %1 van meer dan %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113263692607400802)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'nl'
,p_message_text=>'rij(en) %0 - %1 van %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113247591316400790)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'nl'
,p_message_text=>'%0 - %1 van %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113258905309400799)
,p_name=>'Y'
,p_message_language=>'nl'
,p_message_text=>'J'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113265041545400803)
,p_name=>'YEAR'
,p_message_language=>'nl'
,p_message_text=>'jaar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113258191692400798)
,p_name=>'YEARS'
,p_message_language=>'nl'
,p_message_text=>'jaar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113300663595400830)
,p_name=>'YES'
,p_message_language=>'nl'
,p_message_text=>'Ja'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4494)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4494)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Bureaublad'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4494
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4494)
,p_name=>'Berichten'
,p_alias=>'MESSAGES'
,p_step_title=>'Berichten'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
