prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4483
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4483 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4483
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116102833769403709')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'no'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4483)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113352'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4483)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4483)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4483)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4483)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4483)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4483)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4483)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4483)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4483)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4483)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4483)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4483)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4483)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.no'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4483
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4483)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4483)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4483)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4483)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4483)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4483)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4483)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.no'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4483
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4483)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4483)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4483)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4483)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4483)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4483)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4483)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.no'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4483
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4483)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4483)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4483)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4483)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4483)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4483)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4483)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4483)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4483)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4483)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4483)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4483)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4483)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4483)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4483)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4483)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4483)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.no'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4483
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4483)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4483)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4483)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4483)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4483)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4483)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4483)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4483)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4483)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4483)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4483)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4483)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4483)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4483)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4483)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.no'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4483
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4483)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4483)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4483)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4483)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4483)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4483)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4483)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4483)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4483)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4483)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4483)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4483)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4483)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4483)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4483)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.no'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4483
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4483)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4483)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4483)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4483)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4483)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4483)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4483)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4483)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4483)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4483)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4483)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4483)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4483)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4483)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4483)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.no'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4483
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4483)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4483)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4483)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4483)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4483)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4483)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4483)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4483)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4483)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4483)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4483)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4483)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4483)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4483)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4483)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4483
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4483)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4483
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4483)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4483
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4483)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4483
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4483)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4483
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4483)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4483
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4483)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4483
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4483)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4483)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4483)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4483)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4483)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4483)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4483)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4483)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4483)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4483)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4483)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4483)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4483)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4483)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4483
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4483)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4483)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4483)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4483)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4483)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4483)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4483)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4483)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4483)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4483
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4483)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4483)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4483)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4483)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4483)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4483)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4483)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4483)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4483)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4483)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4483)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4483)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4483)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4483)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4483)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4483)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4483)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4483)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4483)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4483)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4483)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4483)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4483)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4483)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4483)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4483
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4483)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4483)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4483)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4483)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4483)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4483)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4483)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4483)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4483)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4483)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4483
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4483)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4483)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4483)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4483)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4483)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4483
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4483)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4483)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4483)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4483)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4483)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4483)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4483)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4483
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4483)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4483)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4483)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4483)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4483)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4483
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4483)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4483)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4483)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4483)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4483)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4483
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4483)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4483)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4483)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4483)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4483)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4483)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4483)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4483)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4483)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4483
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4483)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4483)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4483)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4483)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4483)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4483)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4483)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4483)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4483)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4483)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4483)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4483)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4483)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4483)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4483
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4483)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4483)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4483)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4483)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4483)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4483
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4483)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4483
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4483)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4483
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4483)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4483
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4483)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4483
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4483)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4483
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4483)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4483)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4483)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4483)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4483)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4483)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4483)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4483)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4483)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4483
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4483)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4483)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4483)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4483)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4483)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4483)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4483)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4483
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4483)
,p_page_name=>'winlov'
,p_page_title=>unistr('S\00F8kedialogboks')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('S\00F8k')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Lukk'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Neste &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Forrige'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Rad #FIRST_ROW#-#LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4483
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4483)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4483
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4483)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4483)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4483)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4483)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4483)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4483)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4483)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4483)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4483)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4483)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4483)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4483)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4483)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4483)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4483)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4483)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4483)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4483)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4483)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4483)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4483)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4483)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4483)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4483)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4483)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4483)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4483)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4483)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4483)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4483)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4483)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4483)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4483)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4483)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4483)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4483)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4483)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4483)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4483)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4483)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4483)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4483)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4483)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4483)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4483)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4483)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4483)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4483)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4483)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4483)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4483)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4483)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4483)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4483)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4483)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4483)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4483)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4483)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4483)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4483)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4483)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4483)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4483)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4483)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4483)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4483)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4483)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4483)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4483)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4483)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4483)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4483)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4483)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4483)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4483)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4483)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4483)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4483)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4483)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4483)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4483)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4483)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4483)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4483)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4483)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4483)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4483)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4483)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4483)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4483)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4483)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4483)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4483)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4483)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4483)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4483)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4483)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4483)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4483)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4483)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4483)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4483)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4483)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4483)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4483)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4483)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4483)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4483)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4483)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4483)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4483)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4483)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4483)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4483)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4483)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4483)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4483)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4483)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4483)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4483)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4483)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4483)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4483)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4483)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4483)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4483)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4483)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4483)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4483)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4483)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4483)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4483)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4483)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4483)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4483)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4483)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4483)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4483)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4483)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4483)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4483)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4483)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4483)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4483)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4483)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4483)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4483)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4483)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4483)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4483)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4483)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4483)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4483)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4483)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4483)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4483)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4483)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4483)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4483)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4483)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4483)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4483)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4483)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4483)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4483)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4483)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4483)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4483)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4483)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4483)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4483)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4483)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4483)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4483)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4483)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4483)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4483)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4483)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4483)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4483)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4483)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4483)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4483)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4483)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4483)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4483)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4483)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4483)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4483)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4483)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4483)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4483)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4483)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4483)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4483)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4483)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4483)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4483)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4483)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4483)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4483)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4483)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4483)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4483)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4483)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4483)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4483)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113433676359400935)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'no'
,p_message_text=>'Kolonne - %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113420723065400925)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'no'
,p_message_text=>'Administrator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113420625147400925)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'no'
,p_message_text=>'Brukernavn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113477955632400967)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'no'
,p_message_text=>'Ingen tilgang'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113437622232400937)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'no'
,p_message_text=>'%0-kontoen er opprettet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113423265217400927)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'no'
,p_message_text=>unistr('Kontoen er l\00E5st.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113413143464400919)
,p_name=>'AM_PM'
,p_message_language=>'no'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113547596083401019)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'no'
,p_message_text=>unistr('Sl\00E5 p\00E5/av %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113555690175401025)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'no'
,p_message_text=>'(Aktiv)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113525183205401002)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'no'
,p_message_text=>'Ajax-kallet returnerte tjenerfeilen %0 for %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113455997095400951)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'no'
,p_message_text=>'Applikasjonsaliaset %0 kan ikke konverteres til en unik applikasjons-ID.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113456077572400951)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'no'
,p_message_text=>'Applikasjonen med aliaset %0 finnes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113445601356400943)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>'ERR-1816 Uventet feil ved konvertering av applikasjonsaliaset p_flow_alias_or_id (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113538500709401012)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'no'
,p_message_text=>unistr('Applikasjonskontrollsummen gir en enkel metode for \00E5 finne ut om samme applikasjon er implementert p\00E5 tvers av arbeidsomr\00E5der. Du kan sammenligne denne kontrollsummen og finne ut om det finnes samsvar. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113431457331400933)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>'Feil ved behandling av autentiseringsfunksjon.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113416819793400922)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>'Feil ved behandling av autentiseringsfunksjon.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113580350485401043)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'no'
,p_message_text=>unistr('Leiernavnet %0 som ble returnert av Oracle Cloud Identity Management, er ikke autorisert for domenet %1.<br/><a href="&LOGOUT_URL.">Logg p\00E5 p\00E5 nytt</a>, og angi et autorisert leiernavn, eller endre URL-adressen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113414559769400920)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'no'
,p_message_text=>unistr('Kontoen %0 har ikke de n\00F8dvendige utviklingsprivilegiene (DB_DEVELOPER eller DB_ADMINISTRATOR)<br/>for arbeidsomr\00E5det %1. <a href="&LOGOUT_URL.">Logg p\00E5 p\00E5 nytt</a> n\00E5r privilegiene er angitt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113413691864400920)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'no'
,p_message_text=>unistr('Leiernavnet som ble returnert av Oracle Cloud Identity Management, er ikke autorisert for det gjeldende arbeidsomr\00E5det.<br/><a href="&LOGOUT_URL.">Logg p\00E5 p\00E5 nytt</a>, og angi et autorisert leiernavn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113414660009400921)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'no'
,p_message_text=>unistr('Av sikkerhetshensyn er det ikke tillatt \00E5 kj\00F8re applikasjoner i dette arbeidsomr\00E5det via domenet i URL-adressen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113431141576400932)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'no'
,p_message_text=>unistr('Be databaseadministratoren om \00E5 kj\00F8re $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113431083251400932)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'no'
,p_message_text=>'Pakken SYS.DBMS_LDAP finnes ikke, eller den er ugyldig.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113430939666400932)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>'Feil ved behandling av brukerfunksjon for redigering av LDAP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113431299577400932)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>'Feil ved behandling av LDAP-autentisering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113432030341400933)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'no'
,p_message_text=>'Feil i argumentet p_flow_page til prosedyren login_page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113431611192400933)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'no'
,p_message_text=>'Ugyldig p_session i wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113479581859400968)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'no'
,p_message_text=>'Argument med ugyldig format til wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113431736012400933)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'no'
,p_message_text=>unistr('Null-brukernavn ble sendt til p\00E5loggingsprosedyren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113420576527400925)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'no'
,p_message_text=>unistr('Vent <span id="apex_login_throttle_sec">%0</span> sekunder f\00F8r du logger p\00E5 p\00E5 nytt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113421843018400926)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('P\00E5loggingsfors\00F8ket ble blokkert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113477384987400967)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'no'
,p_message_text=>'Finner ikke autentiseringen %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113422134701400926)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'no'
,p_message_text=>'ID-en for sikkerhetsgruppen er null.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113431504982400933)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Feil ved utf\00F8relse av prosess etter autentisering.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113431387136400933)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Feil ved behandling av prosess f\00F8r autentisering.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113432588597400933)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00C5pne URL-adressen i samme nettleser som du startet foresp\00F8rselen om tilbakestilling av passord i. Hvis du klikker p\00E5 URL-adressen Tilbakestill passord og blir omdirigert til'),
unistr('p\00E5loggingssiden, starter du Tilbakestill passord p\00E5 nytt og lar'),
unistr('nettleseren v\00E6re \00E5pen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113577889828401041)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'no'
,p_message_text=>'URL-adresse for tilbakestilling av passord'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113414896683400921)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'no'
,p_message_text=>'Forbrukergruppen %0 for ressursstyreren er ikke tildelt til %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113414944341400921)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'no'
,p_message_text=>unistr('Bruk DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP til \00E5 tildele det manglende privilegiet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113442927461400941)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Feil ved behandling av Sentry-funksjon for \00F8kt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113443007835400941)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Feil ved behandling av \00F8ktverifiseringsfunksjon.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113443232413400942)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'no'
,p_message_text=>unistr('Be administratoren for %0 om \00E5 konfigurere motoren for Oracle Application Server Single Sign-On.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113452721901400948)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'no'
,p_message_text=>unistr('Ugyldig %0 i symbolet %1 som ble returnert ved engangsp\00E5logging.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113431981066400933)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'no'
,p_message_text=>'Rediger autentiseringsskjemaet, og legg til applikasjonsnavnet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113452470933400948)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'no'
,p_message_text=>'Ugyldig anroper for prosedyren %0:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113452610990400948)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'no'
,p_message_text=>unistr('Ugyldig app\00F8kt i URLC-symbolet: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113452294579400948)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'no'
,p_message_text=>'Feil i portal_sso_redirect: Opplysninger for applikasjonsregistering mangler: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113443150948400942)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'no'
,p_message_text=>'Pakken WWSEC_SSO_ENABLER_PRIVATE finnes ikke, eller den er ugyldig.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113431864939400933)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'no'
,p_message_text=>unistr('Finner ikke registrert navn p\00E5 partnerapplikasjon i autentiseringsskjemaet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113452388159400948)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'no'
,p_message_text=>'Registrer denne applikasjonen som beskrevet i installasjonsveiledningen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113443341778400942)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Feil ved behandling av autentisering av engangsp\00E5logging.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113552723742401023)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'no'
,p_message_text=>'Uautorisert URL-adresse: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113442710291400941)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>'Feil ved behandling av autentisering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113414714236400921)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'no'
,p_message_text=>unistr('Arbeidsomr\00E5det %0 er inaktivt. Kontakt administratoren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113415175797400921)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'no'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113421505904400925)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'no'
,p_message_text=>'Tilgang ble nektet av sikkerhetskontroll for applikasjonen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113421640854400926)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'no'
,p_message_text=>'Tilgang ble nektet av sikkerhetskontroll for siden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113421720599400926)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>'Feil ved behandling av autorisasjonen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113485159020400972)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'no'
,p_message_text=>'Bygget med %0 ved hjelp av %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113485215802400972)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'no'
,p_message_text=>'hjerte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113543082018401015)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'no'
,p_message_text=>'Hendelsesbeskrivelse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113542894125401015)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'no'
,p_message_text=>'Sluttdato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113543151896401016)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'no'
,p_message_text=>'Hendelses-ID'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113542778180401015)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'no'
,p_message_text=>'Startdato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113542970190401015)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hendelsestittel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113433553185400935)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'no'
,p_message_text=>'Innholdsfeil i kontrollsum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113433412987400935)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'no'
,p_message_text=>'Formatfeil i kontrollsum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113497417957400981)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'no'
,p_message_text=>'Kopiert til utklippstavlen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113497143933400981)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'no'
,p_message_text=>unistr('Denne nettleseren st\00F8tter ikke kopiering fra en knapp eller meny. Pr\00F8v Ctrl+C eller Command+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113485654793400973)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'no'
,p_message_text=>'Lukk varsling'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113541696917401014)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'no'
,p_message_text=>'Kontrast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113536185251401010)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'no'
,p_message_text=>'Gjeldende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113536087413401010)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'no'
,p_message_text=>'Opprinnelig'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113540246142401013)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# m\00E5 v\00E6re en gyldig farge. Eksempel: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113535960050401010)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'no'
,p_message_text=>'Velg en farge'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113536239980401010)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'no'
,p_message_text=>'Endre fargeformat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113575403215401040)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'no'
,p_message_text=>'Verdiliste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113575557279401040)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'no'
,p_message_text=>unistr('\00C5pne liste for: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113555724913401025)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'no'
,p_message_text=>unistr('(Fullf\00F8rt)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113448014627400945)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'no'
,p_message_text=>'Kontakt applikasjonsadministrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113462442364400955)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Kontakt applikasjonsadministratoren.',
'Detaljer om denne hendelsen er tilgjengelige via feilletings-ID-en %0.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113540584248401014)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'no'
,p_message_text=>unistr('Rett feilene f\00F8r du lagrer.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113486539761400973)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'no'
,p_message_text=>'Finner %0 treff'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113486482642400973)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'no'
,p_message_text=>'Finner ingen treff'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113556250616401025)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'no'
,p_message_text=>'Fremdrift hittil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113540911489401014)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Filen som er angitt i elementet %0, finnes ikke i APEX_APPLICATION_TEMP_FILES.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113529416037401005)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'no'
,p_message_text=>'Gjeldende versjon av data i databasen er endret siden brukeren initierte oppdateringsprosessen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113498536044400982)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'no'
,p_message_text=>'Ikke last'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113545590315401017)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'no'
,p_message_text=>'Feil i forbehandling'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113545352090401017)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'no'
,p_message_text=>'Sett inn rad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113559404503401028)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'no'
,p_message_text=>unistr('Rekkef\00F8lge : Handling')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113545453983401017)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'no'
,p_message_text=>'Oppdater rad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113486994131400974)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'no'
,p_message_text=>'Hurtigkalender: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113409563812400917)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'no'
,p_message_text=>'Neste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113409654569400917)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'no'
,p_message_text=>'Forrige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113545727737401017)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# m\00E5 ha verdi.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113545603595401017)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# m\00E5 v\00E6re en gyldig dato, for eksempel %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113413267256400920)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# m\00E5 v\00E6re mellom %0 og %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113413354838400920)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# m\00E5 v\00E6re p\00E5 eller etter %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113413437667400920)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# m\00E5 v\00E6re p\00E5 eller f\00F8r %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113490494019400976)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'no'
,p_message_text=>'#LABEL# er senere enn den angitte seneste datoen %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113490855387400977)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'no'
,p_message_text=>'#LABEL# samsvarer ikke med formatet %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113490312905400976)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'no'
,p_message_text=>'#LABEL# er tidligere enn den angitte tidligste datoen %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113490521819400976)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# er ikke innenfor det gyldige omr\00E5det fra %0 til %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113490799037400977)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# er ikke innenfor det gyldige \00E5rsomr\00E5det %0 og %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113540815633401014)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'no'
,p_message_text=>'Avbryt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113568059583401034)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'no'
,p_message_text=>'Lukk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113570007514401036)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'no'
,p_message_text=>'Hjelp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113540671727401014)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'no'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113540700252401014)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'no'
,p_message_text=>'Lagre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113446985280400944)
,p_name=>'APEX.ERROR'
,p_message_language=>'no'
,p_message_text=>'Feil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113414379083400920)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'no'
,p_message_text=>unistr('F\00F8lgende feil oppstod ved utf\00F8relse av tilbakekall for feilh\00E5ndtering: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113423081258400927)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>'Det oppstod en feil ved maling av feilside: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113415002541400921)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'no'
,p_message_text=>'Intern feil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113554823007401024)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Kontakt administratoren.',
'Detaljer om denne hendelsen er tilgjengelige via feilletings-ID-en %0.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113549187880401020)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'no'
,p_message_text=>unistr('Databasen er \00E5pen med lesetilgang.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113579771051401043)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'no'
,p_message_text=>unistr('ORA-28353: Kan ikke \00E5pne lommeboken. Applikasjonsdataene er ikke tilgjengelige for \00F8yeblikket.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113549231057401020)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'no'
,p_message_text=>'Denne siden er ikke tilgjengelig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113416776815400922)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'no'
,p_message_text=>'Teknisk info (bare synlig for utviklere)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113512844630400993)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'no'
,p_message_text=>'Feilmelding'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113526781558401003)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'no'
,p_message_text=>'Forventet format: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113493427264400978)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'no'
,p_message_text=>'Brukeren finnes allerede i tilgangskontrollisten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113493392596400978)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'no'
,p_message_text=>unistr('Bekreft at du vil legge til f\00F8lgende %0 bruker(e) i tilgangskontrollisten for <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113493802802400979)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'no'
,p_message_text=>'Det finnes en duplisert bruker'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113493560649400979)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'no'
,p_message_text=>unistr('Mangler kr\00F8llalfa (@) i e-postadressen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113493693906400979)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'no'
,p_message_text=>'Mangler punktum (.) i e-postadressen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113493712596400979)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'no'
,p_message_text=>'Brukernavnet er for langt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113494089216400979)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'no'
,p_message_text=>unistr('Bare brukere som er definert i tilgangskontrollisten for applikasjonen, kan f\00E5 tilgang til denne applikasjonen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113494143917400979)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'no'
,p_message_text=>'Uventet verdi for tilgangskontrollinnstilling: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113493953045400979)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'no'
,p_message_text=>'Alle autentiserte brukere har tilgang til denne applikasjonen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113536706939401011)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'no'
,p_message_text=>'Deaktivert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113536625845401011)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'no'
,p_message_text=>'Aktivert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113536923777401011)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'no'
,p_message_text=>'%0 er deaktivert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113536889148401011)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'no'
,p_message_text=>'%0 er aktivert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113536582909401011)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'no'
,p_message_text=>'ikke identifisert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113529617995401005)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'no'
,p_message_text=>'Last ned'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113486164221400973)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'no'
,p_message_text=>'Brukt filter %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113527287305401004)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'no'
,p_message_text=>'Bruk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113412199566400919)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'no'
,p_message_text=>'Stolpediagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113539982647401013)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'no'
,p_message_text=>'Andre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113412215411400919)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'no'
,p_message_text=>'Sektordiagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113538691557401012)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'no'
,p_message_text=>'Diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113411969638400919)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'no'
,p_message_text=>'Antall'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113527736642401004)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'no'
,p_message_text=>'Nullstill'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113527842165401004)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'no'
,p_message_text=>'Nullstill alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113527962029401004)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'no'
,p_message_text=>'Nullstill %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113545196092401017)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'no'
,p_message_text=>'Kolonnen %1, som fasetten %0 refererer til, er utilgjengelig eller ikke autorisert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113402312430400912)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'no'
,p_message_text=>'Velg filtre som skal vises'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113484321776400972)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'no'
,p_message_text=>'%0 resultater'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113484401031400972)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'no'
,p_message_text=>'%0 valgt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113487022957400974)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'no'
,p_message_text=>'Gjeldende filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113403872179400913)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'no'
,p_message_text=>'Filterliste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113543677359401016)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'no'
,p_message_text=>'Unik verdigrense (%0) overskredet for fasetten %1.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113529297469401005)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'no'
,p_message_text=>unistr('Fasetten %0 st\00F8ttes ikke for kolonner av typen DATE eller TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113527375993401004)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'no'
,p_message_text=>'Filtrer %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113527417086401004)
,p_name=>'APEX.FS.GO'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113528856688401005)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'no'
,p_message_text=>'er lik %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113412956395400919)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'no'
,p_message_text=>'inneholder %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113412691252400919)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'no'
,p_message_text=>unistr('st\00F8rre enn %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113412798711400919)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'no'
,p_message_text=>unistr('st\00F8rre enn eller lik %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113412466816400919)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'no'
,p_message_text=>'mindre enn %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113412538878400919)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'no'
,p_message_text=>'mindre enn eller lik %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113412815736400919)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'no'
,p_message_text=>'begynner med %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113415357698400921)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'no'
,p_message_text=>unistr('Datatypen %0 (%1) st\00F8ttes ikke for fasetten Inndatafelt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113405569784400914)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'no'
,p_message_text=>'Fasetter med flere verdier trenger databaser av versjon 12.2 eller senere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113529015936401005)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'no'
,p_message_text=>unistr('Ingen s\00F8kekolonner er angitt for fasetten %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113402489720400912)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'no'
,p_message_text=>'Flere filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113484568572400972)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'no'
,p_message_text=>'Intervallet starter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113528559419401005)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'no'
,p_message_text=>'%0 til %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113528677243401005)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'no'
,p_message_text=>'Over %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113528738428401005)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'no'
,p_message_text=>'Under %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113484647191400972)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'no'
,p_message_text=>'Intervallet slutter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113547458230401019)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'no'
,p_message_text=>unistr('Verdilisteelement nr. %2 (%1) for omr\00E5defasetten %0 er ugyldig (mangler skilletegnet |).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113528916998401005)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'no'
,p_message_text=>unistr('Manuelle inndata for omr\00E5defasetten %0 st\00F8ttes ikke for \00F8yeblikket, ettersom kolonnen er av typen DATE eller TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113528227866401004)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'no'
,p_message_text=>'til'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113412009532400919)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'no'
,p_message_text=>'Fjern diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113481180683400969)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'no'
,p_message_text=>'Tilbakestill'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113527613528401004)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113527581625401004)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113528401558401005)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'no'
,p_message_text=>'- Velg -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113411890204400919)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'no'
,p_message_text=>'Vis diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113528089445401004)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'no'
,p_message_text=>unistr('Vis f\00E6rre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113528153052401004)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'no'
,p_message_text=>'Vis flere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113528308506401005)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'no'
,p_message_text=>unistr('%0 stjerner og h\00F8yere')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113486009504400973)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'no'
,p_message_text=>'Filterforslag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113529171001401005)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'no'
,p_message_text=>unistr('Tekstfeltfasetten %0 st\00F8ttes for \00F8yeblikket bare for kolonner av typen NUMBER.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113402237085400912)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'no'
,p_message_text=>'Totalt radantall'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113545257001401017)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'no'
,p_message_text=>unistr('Datatypen %0 (%1) st\00F8ttes ikke for fasettert s\00F8k.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113537184435401011)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('G\00E5 til feil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113494772095400979)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'no'
,p_message_text=>'Aggreger.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113502330217400985)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'no'
,p_message_text=>'Trekk sammen kontrollskift'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113494823195400980)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'no'
,p_message_text=>'Kontrollskift.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113502263491400985)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'no'
,p_message_text=>'Utvid kontrollskift'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113580959746401044)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'no'
,p_message_text=>'Kolonne - %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113502055564400985)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'no'
,p_message_text=>'%0 rader er slettet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113572489760401037)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'no'
,p_message_text=>'Duplisert identitet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113491759659400977)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'no'
,p_message_text=>unistr('F\00F8rst')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113495059098400980)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'no'
,p_message_text=>'Gruppeoverskrift.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113494999450400980)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'no'
,p_message_text=>'Overskrift.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113491800651400977)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'no'
,p_message_text=>'Siste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113511899881400992)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'no'
,p_message_text=>'Last flere rader '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113491529502400977)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'no'
,p_message_text=>'Neste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113495176480400980)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'no'
,p_message_text=>'Siderader'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113491960933400977)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'no'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113492042498400977)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'no'
,p_message_text=>'%0-%1 av %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113548088196401019)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'no'
,p_message_text=>'Sidevalg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113491679041400977)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'no'
,p_message_text=>'Forrige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113572206277401037)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'no'
,p_message_text=>'Lagt til'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113572330350401037)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'no'
,p_message_text=>'Endret'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113580744550401044)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'no'
,p_message_text=>'Rad - %0, kolonne - %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113580885860401044)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'no'
,p_message_text=>'Rad - %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113572194423401037)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'no'
,p_message_text=>'Slettet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113495330324400980)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'no'
,p_message_text=>'Radoverskrift'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113490991110400977)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'no'
,p_message_text=>'%0 celler er valgt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113492145079400977)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'no'
,p_message_text=>'%0 rader er valgt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113532455183401008)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'no'
,p_message_text=>'Velg alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113502157554400985)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'no'
,p_message_text=>'Side %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113495222981400980)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'no'
,p_message_text=>'Velg rad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113495465938400980)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'no'
,p_message_text=>'Sortert stigende - %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113495585160400980)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'no'
,p_message_text=>'Sortert synkende - %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113491011131400977)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'no'
,p_message_text=>'Sorter stigende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113491374703400977)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'no'
,p_message_text=>'Sorter stigende - %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113491128674400977)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'no'
,p_message_text=>'Sorter synkende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113491488081400977)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'no'
,p_message_text=>'Sorter synkende - %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113491249094400977)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'no'
,p_message_text=>'Ikke sorter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113501969851400985)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'no'
,p_message_text=>'Totalt %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113428347570400930)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'no'
,p_message_text=>unistr('HTTP-foresp\00F8rselen til %0 mislyktes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113569679394401035)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'no'
,p_message_text=>'Liste for rutenettvalg, %0 kolonner, %1 rader. Bruk piltastene'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113501840100400985)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'no'
,p_message_text=>'Velg rader i listen %0. Bruk piltastene'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113580505994401044)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'no'
,p_message_text=>'Interaktivt rutenett %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113488693607400975)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'no'
,p_message_text=>'Handlinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113489646837400976)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'no'
,p_message_text=>'Legg til'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113489539166400976)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'no'
,p_message_text=>'Legg til rad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113574081328401039)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'no'
,p_message_text=>'Aggreger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113559528188401028)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'no'
,p_message_text=>'Aggregering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113561212579401029)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'no'
,p_message_text=>'Alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113517655541400997)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'no'
,p_message_text=>'Alle tekstkolonner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113518855879400997)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'no'
,p_message_text=>'Alternativ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113519993390400998)
,p_name=>'APEX.IG.AND'
,p_message_language=>'no'
,p_message_text=>'og'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113539371342401013)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'no'
,p_message_text=>unistr('Tiln\00E6rmet antall unike')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113575096479401039)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'no'
,p_message_text=>unistr('Samlet tiln\00E6rmet antall unike')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113558153982401027)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'no'
,p_message_text=>'Areal '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113560082575401028)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'no'
,p_message_text=>'Stigende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113518979721400998)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'no'
,p_message_text=>'Autorisering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113574196738401039)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'no'
,p_message_text=>'Automatisk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113539710802401013)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'no'
,p_message_text=>'Gjennomsnitt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113574727243401039)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'no'
,p_message_text=>'Samlet gjennomsnitt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113557664274401026)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'no'
,p_message_text=>unistr('Tittel p\00E5 etikettakse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113557818364401027)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'no'
,p_message_text=>'Desimalplasser'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113557712960401026)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'no'
,p_message_text=>unistr('Tittel p\00E5 verdiakse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113563840855401031)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'no'
,p_message_text=>'Bakgrunnsfarge'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113558212317401027)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'no'
,p_message_text=>'Stolpe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113514292973400994)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'no'
,p_message_text=>'mellom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113565013004401032)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'no'
,p_message_text=>'Begge'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113558391033401027)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'no'
,p_message_text=>'Boble'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113489851113400976)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'no'
,p_message_text=>'Avbryt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113519897378400998)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'no'
,p_message_text=>unistr('Skill mellom store og sm\00E5 bokstaver')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113575691153401040)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'no'
,p_message_text=>unistr('(Skiller mellom store og sm\00E5 bokstaver)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113546518984401018)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'no'
,p_message_text=>'Endringene er lagret'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113490249749400976)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'no'
,p_message_text=>'Endre visning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113520912832400999)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'no'
,p_message_text=>'Diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113517410026400996)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'no'
,p_message_text=>unistr('Sp\00F8rringen har overskredet maksimum, som er %0 datapunkt per diagram. Bruk et filter for \00E5 redusere antall poster i basissp\00F8rringen.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113488534708400975)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'no'
,p_message_text=>'Diagramvisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113495832556400980)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'no'
,p_message_text=>'Nullstill'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113557173547401026)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Lukk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113564075204401031)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'no'
,p_message_text=>'Farger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113540157832401013)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'no'
,p_message_text=>unistr('Forh\00E5ndsvis')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113519294480400998)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'no'
,p_message_text=>'Kolonne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113488793284400975)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'no'
,p_message_text=>'Kolonner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113565897122401033)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'no'
,p_message_text=>unistr('Kolonne - form\00E5l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113519366739400998)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'no'
,p_message_text=>'Kompleks'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113488932654400975)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'no'
,p_message_text=>'Beregn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113514859505400995)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'no'
,p_message_text=>'inneholder'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113521117584400999)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'no'
,p_message_text=>'Kontrollskift'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113495650638400980)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'no'
,p_message_text=>'Kopier til utklippstavle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113495713677400980)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'no'
,p_message_text=>'Kopier ned'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113539161038401013)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'no'
,p_message_text=>'Antall'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113539202632401013)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'no'
,p_message_text=>'Antall unike'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113574984921401039)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'no'
,p_message_text=>'Samlet antall unike'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113574852744401039)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'no'
,p_message_text=>'Samlet antall'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113572599911401038)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'no'
,p_message_text=>'Opprett %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113517801671400997)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'no'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113565667656401032)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'no'
,p_message_text=>'Datatype'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113565293522401032)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'no'
,p_message_text=>'Dato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113546385643401018)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'no'
,p_message_text=>'Ugyldig datoverdi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113515517797400995)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'no'
,p_message_text=>'dager'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113518512295400997)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'no'
,p_message_text=>'Standardinnstillinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113518362764400997)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'no'
,p_message_text=>'Standardtype'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113489755622400976)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'no'
,p_message_text=>'Slett'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113566869149401033)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'no'
,p_message_text=>unistr('Er du sikker p\00E5 at du vil slette denne rapporten?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113522965626401001)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'no'
,p_message_text=>'Slett rad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113521745736401000)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'no'
,p_message_text=>'Slett rader'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113560154444401028)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'no'
,p_message_text=>'Synkende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113520608601400999)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'no'
,p_message_text=>'Detalj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113488274871400975)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'no'
,p_message_text=>'Detaljvisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113548880062401020)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'no'
,p_message_text=>'Retning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113520327487400999)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'no'
,p_message_text=>'Deaktivert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113514981368400995)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'no'
,p_message_text=>'inneholder ikke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113515137985400995)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'no'
,p_message_text=>'begynner ikke med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113558454390401027)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'no'
,p_message_text=>'Hjul'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113521315900400999)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'no'
,p_message_text=>'Last ned'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113420051154400924)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'no'
,p_message_text=>'Bare data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113567847016401034)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'no'
,p_message_text=>'Velg format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113432615599400933)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'no'
,p_message_text=>'Nedlastingsformatet %0 er ikke aktivert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113560872089401029)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'no'
,p_message_text=>'Duplisert aggregering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113560996300401029)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'no'
,p_message_text=>'Duplisert kontrollskift'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113522824080401000)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'no'
,p_message_text=>'Dupliser rad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113521662526401000)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'no'
,p_message_text=>'Dupliserte rader'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113489338038400975)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'no'
,p_message_text=>'Rediger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113559909545401028)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'no'
,p_message_text=>'Rediger diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113571412215401037)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'no'
,p_message_text=>'Rediger Grupper etter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113567416091401034)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'no'
,p_message_text=>'Blindkopi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113567613892401034)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'no'
,p_message_text=>'Melding'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113567389566401034)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'no'
,p_message_text=>'Kopi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113567021738401034)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'no'
,p_message_text=>'E-post er sendt.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113567592819401034)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'no'
,p_message_text=>'Emne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113567225671401034)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'no'
,p_message_text=>'Mottaker (til)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113520019863400998)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'no'
,p_message_text=>'Aktivert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113513265143400993)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'no'
,p_message_text=>'er lik'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113566480434401033)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'no'
,p_message_text=>'Eksempel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113520163119400998)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'no'
,p_message_text=>'Uttrykk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113566361309401033)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'no'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113532365928401007)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'no'
,p_message_text=>'Filen er klargjort. Starter nedlasting.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113495944264400980)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'no'
,p_message_text=>'Fyll'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113497049238400981)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'no'
,p_message_text=>'Fyll ut utvalg med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113496960271400981)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'no'
,p_message_text=>'Fyll ut utvalg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113488812451400975)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'no'
,p_message_text=>'Filtrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113519459062400998)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'no'
,p_message_text=>'Filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113574451945401039)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'no'
,p_message_text=>'Filtrer ...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113560367734401028)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'no'
,p_message_text=>unistr('F\00F8rst')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113489049839400975)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'no'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113517923447400997)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'no'
,p_message_text=>'Formater'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113564993921401032)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'no'
,p_message_text=>'Formatmaske'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113566788353401033)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'no'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113566660349401033)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'no'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113479423844400968)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'no'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113418784140400923)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'no'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113522500478401000)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'no'
,p_message_text=>unistr('L\00E5s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113520237557400999)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'no'
,p_message_text=>'Funksjoner og operatorer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113558521457401027)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'no'
,p_message_text=>'Trakt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113539016908401012)
,p_name=>'APEX.IG.GO'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113513812715400994)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'no'
,p_message_text=>unistr('st\00F8rre enn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113513969683400994)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'no'
,p_message_text=>unistr('st\00F8rre enn eller lik')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113520546868400999)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'no'
,p_message_text=>'Rutenett'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113488041622400975)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'no'
,p_message_text=>'Rutenettvisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113561116069401029)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'no'
,p_message_text=>'Gruppe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113520760302400999)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'no'
,p_message_text=>'Grupper etter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113488366154400975)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'no'
,p_message_text=>'Grupper etter-visning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113565570632401032)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'no'
,p_message_text=>'Betingelsestype'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113564413015401032)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'no'
,p_message_text=>'Overskrift'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113564699923401032)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'no'
,p_message_text=>'Overskriftsjustering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113574382771401039)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'no'
,p_message_text=>'Hjelp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113569862248401036)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Du kan sette inn, oppdatere og slette data direkte i dette interaktive rutenettet.</p>',
'',
unistr('<p>Sett inn en ny rad ved \00E5 klikke p\00E5 knappen Legg til rad.</p>'),
'',
unistr('<p>Rediger eksisterende data ved \00E5 dobbeltklikke i en bestemt celle. Ved st\00F8rre redigeringsarbeid klikker du p\00E5 Rediger for \00E5 g\00E5 inn i redigeringsmodus. I redigeringsmodus kan du klikke \00E9n gang eller bruke tastaturet til \00E5 redigere bestemte celler.</')
||'p>',
'',
unistr('<p>Bruk menyen Endre til \00E5 duplisere og slette rader. Du aktiverer menyen Endre ved \00E5 bruke avmerkingsboksene til \00E5 velge \00E9n eller flere rader.</p>'),
'',
unistr('<p>Dupliser en valgt rad ved \00E5 klikke p\00E5 menyen Endre og velge Dupliserte rader. Slett en valgt rad ved \00E5 klikke p\00E5 menyen Endre og velge Slett rad.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113571995176401037)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'no'
,p_message_text=>'Redigeringsfunksjoner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113572062839401037)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Et interaktivt rutenett presenterer et sett med data i en rapport som kan tilpasses og s\00F8kes i. Du kan utf\00F8re flere operasjoner som begrenser postene som returneres, og du kan endre hvordan dataene vises.</p>'),
'',
unistr('<p>Bruk s\00F8kefeltet til \00E5 filtrere postene som returneres. Klikk p\00E5 Handlinger for \00E5 \00E5pne flere valg for endring av rapportoppsettet, eller bruk kolonneoverskriftmenyene i viste kolonner.</p>'),
'',
unistr('<p>Bruk Rapportinnstillinger til \00E5 lagre tilpasningene av en rapport. Du kan ogs\00E5 laste ned dataene fra rapporten til en ekstern fil eller sende dataene via e-post til deg selv eller andre.</p>'),
'',
'<p>Hvis du vil vite mer, kan du se Bruke interaktive rutenett i <em>sluttbrukerveiledningen for Oracle Application Express</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113571725148401037)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'no'
,p_message_text=>'Oversikt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113569737842401036)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Du kan tilpasse det interaktive rutenettet til \00E5 vise data p\00E5 ulike m\00E5ter ved hjelp av de innebygde funksjonene.</p>'),
'',
unistr('<p>Bruk kolonneoverskriftmenyene eller menyen Handlinger til \00E5 fastsette hvilke kolonner som skal vises, i hvilken rekkef\00F8lge de skal vises, og hvilke kolonner som skal l\00E5ses. Du kan ogs\00E5 definere ulike datafiltre og sortere dataene som returneres.</')
||'p>',
'',
unistr('<p>Bruk knappen Vis (ved siden av feltet S\00F8k) til \00E5 f\00E5 tilgang til andre datavisninger som kan v\00E6re definert av applikasjonsutvikleren. Du kan ogs\00E5 opprette et diagram eller vise et eksisterende diagram.</p>  '),
'',
unistr('<p><em>Merknad: Klikk p\00E5 <strong>Hjelp</strong> i dialogboksen for det interaktive rutenettet hvis du vil vise mer detaljerte opplysninger om den valgte funksjonen.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113571864654401037)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'no'
,p_message_text=>'Rapporteringsfunksjoner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113521569690401000)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hjelp til interaktive rutenett'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113568629372401035)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bruk denne dialogboksen til \00E5 aggregere kolonner. Aggregerte verdier vises nederst i dataene. Hvis kontrollskift er definert, vises de nederst i hvert enkelt skift.</p>'),
'',
'<p><strong>Aggregeringsliste</strong><br>',
unistr('Aggregeringslisten viser definerte aggregeringer. Deaktiver en eksisterende aggregering ved \00E5 oppheve valget av den.<br>'),
unistr('Klikk p\00E5 Legg til ( &plus; ) hvis du vil opprette en ny aggregering, eller klikk p\00E5 Slett ( &minus; ) hvis du vil fjerne en eksisterende aggregering.</p>'),
'',
'<p><strong>Aggregeringsinnstillinger</strong><br>',
unistr('Bruk skjemaet til h\00F8yre til \00E5 definere aggregeringen.<br>'),
'Velg kolonnenavnet og aggregeringstypen.<br>',
unistr('Du kan velge \00E5 angi et verkt\00F8ytips for aggregeringen.<br>'),
'Hvis du har definert et kontrollskift, vil valg av <strong>Vis total verdi</strong> vise det totale gjennomsnittet, totalsummen eller en lignende verdi nederst i dataene.</p>',
'',
unistr('<p><em>Merknad: \00C5pne dialogboksen Aggregering p\00E5 menyen Handlinger eller ved \00E5 klikke p\00E5 kolonneoverskriften og sum ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113570856378401036)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hjelp til aggregering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113569352094401035)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bruk denne dialogboksen til \00E5 definere et diagram som skal vises som en separat datavisning.<br>'),
'Velg en diagramtype og diagramattributter.</p>',
'<p><strong>Diagramattributter</strong></br>',
'Hvilke diagramattributter som er tilgjengelige, varierer etter diagramtype.</p>',
'<p>',
'<ul>',
'  <li>Velg kolonnen som inneholder verdien for attributtet:',
'    <ul>',
unistr('      <li>Etikett \2013 Tekst for hvert datapunkt.</li>'),
unistr('      <li>Verdi \2013 Data som skal plottes.</li>'),
unistr('      <li>Serie \2013 For \00E5 definere en dynamisk sp\00F8rring med flere serier.</li>'),
unistr('      <li>\00C5pning \2013 Daglig \00E5pningskurs (bare Aksje).</li>'),
unistr('      <li>Lukking \2013 Daglig lukkingskurs (bare Aksje).</li>'),
unistr('      <li>H\00F8y \2013 H\00F8y verdi (bare Intervall og Aksje).</li>'),
unistr('      <li>Lav \2013 Lav verdi (bare Intervall og Aksje).</li>'),
unistr('      <li>Volum \2013 Daglig aksjevolum (bare Aksje).</li>'),
unistr('      <li>M\00E5l \2013 M\00E5lverdi (bare Trakt.)</li>'),
unistr('      <li>X \2013 X-akseverdi (bare Boble og Punkt).</li>'),
unistr('      <li>Y \2013 Y-akseverdi (bare Boble og Punkt).</li>'),
unistr('      <li>Z \2013 Stolpebredde eller bobleradius (bare Stolpe, Boble og Intervall).</li>'),
'    </ul>',
'  </li>',
unistr('  <li>Retning \2013 Loddrett eller vannrett.</li>'),
unistr('  <li>Aggregering \2013 Velg hvordan diagramverdiene skal aggregeres..</li>'),
unistr('  <li>Stablet \2013 Angi om dataelementene skal v\00E6re stablet.</li>'),
unistr('  <li>Sorter etter \2013 Sorter etter etiketten eller verdien(e).'),
'    <ul>',
unistr('      <li>Rekkef\00F8lge \2013 Sortering i stigende eller synkende verdier.</li>'),
unistr('      <li>Nullverdier \2013 Angi hvordan poster med nullverdier skal sorteres i forhold til poster med ikke-nullverdier.</li>'),
'    </ul>',
'  </li>',
'  <li>Desimalplasser</li>',
unistr('  <li>Tittel p\00E5 etikettakse</li>'),
unistr('  <li>Tittel p\00E5 verdiakse</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113571236397401037)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hjelp til diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113568364282401034)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bruk denne dialogboksen til \00E5 velge hvilke kolonner som skal vises, og i hvilken rekkef\00F8lge.</p>'),
'',
unistr('<p>Skjul en kolonne ved \00E5 oppheve valget av den.<br>'),
unistr('Endre rekkef\00F8lgen p\00E5 kolonner ved \00E5 klikke p\00E5 Flytt opp ( &uarr; ) eller Flytt ned ( &darr; ).<br>'),
unistr('Bruk rullegardinvelgeren til \00E5 vise alle kolonner, viste kolonner eller ikke viste kolonner.</p>'),
'',
unistr('<p>Du kan ogs\00E5 bruke skjermbildet til \00E5 angi minimumsbredden for en kolonne i piksler.</p>'),
'',
unistr('<p><em>Merknad: Du kan ogs\00E5 endre rekkef\00F8lgen p\00E5 viste kolonner ved \00E5 klikke p\00E5 drah\00E5ndtaket (ved starten av kolonneoverskriften) og dra kolonnen mot venstre eller h\00F8yre. Du kan ogs\00E5 endre kolonnebredden for viste kolonner ved \00E5 velge kolonneskillete')
||unistr('gnet mellom overskrifter og flytte det mot venstre eller h\00F8yre.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113571121544401037)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hjelp for kolonner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113568701058401035)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bruk denne dialogboksen til \00E5 definere flere kolonner basert p\00E5 matematiske og funksjonelle beregninger som utf\00F8res mot eksisterende kolonner.</p>'),
'',
'<p><strong>Beregningsliste</strong><br>',
unistr('Beregningslisten viser definerte beregninger. Deaktiver en eksisterende beregning ved \00E5 oppheve valget av den.<br>'),
unistr('Klikk p\00E5 Legg til ( &plus; ) hvis du vil legge til en ny beregning, eller klikk p\00E5 Slett ( &minus; ) hvis du vil fjerne en eksisterende beregning.</p>'),
'',
'<p><strong>Beregningsinnstillinger</strong><br>',
unistr('Bruk skjemaet til \00E5 definere beregningen.<br>'),
'Angi kolonnedetaljene, for eksempel overskrift og etikett, og velg justeringsinnstillinger.<br> ',
unistr('Bruk tekstomr\00E5det Uttrykk til \00E5 angi kolonnen(e) og de tilknyttede funksjonene for beregningen.<br>'),
'Velg den egnede datatypen, og eventuelt en formatmaske, for den nye kolonnen.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113570799158401036)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hjelp til beregning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113569040754401035)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bruk denne dialogboksen til \00E5 definere et kontrollskift i \00E9n eller flere kolonner.</p>'),
'',
'<p><strong>Kontrollskiftliste</strong><br>',
unistr('Kontrollskiftlisten viser definerte kontrollskift. Deaktiver en eksisterende kontrollskiftkolonne ved \00E5 oppheve valget av den.<br>'),
unistr('Klikk p\00E5 Legg til ( &plus; ) hvis du vil inkludere en ny kolonne i kontrollskiftet, eller klikk p\00E5 Slett ( &minus; ) hvis du vil fjerne en eksisterende kolonne fra kontrollskiftet.<br>'),
unistr('Hvis du vil endre rekkef\00F8lgen p\00E5 kolonner, klikker du p\00E5 Flytt opp ( &uarr; ) eller Flytt ned ( &darr; ) for \00E5 flytte den valgte kolonne opp eller ned i forhold til andre kolonner.</p>'),
'',
'<p><strong>Kontrollskiftinnstillinger</strong><br>',
unistr('Bruk skjemaet til \00E5 definere kontrollskiftkolonnen.<br>'),
'Velg en kontrollskiftkolonne, sorteringsretningen og hvordan nullkolonner (kolonner uten verdier) skal sorteres.</p>',
'',
unistr('<p><em>Merknad: N\00E5r du viser det interaktive rutenettet, kan du definere et kontrollskift ved \00E5 klikke p\00E5 en kolonneoverskrift og velge kontrollskiftikonet.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113570499956401036)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hjelp til kontrollskift'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113569229258401035)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bruk denne dialogboksen til \00E5 laste ned alle de gjeldende radene i en ekstern fil. Filen inneholder bare de gjeldende viste kolonnene, ved hjelp av eventuelle filtre og sorteringer som er brukt p\00E5 dataene.</p>'),
'',
unistr('<p>Velg filformatet, og klikk p\00E5 Last ned.<br>'),
'Merknad: CSV inkluderer ikke tekstformatering som aggregater og kontrollskift.</p>',
'',
'<p>Hvis du vil sende filen via e-post, velger du Send som e-post og angir e-postdetaljene (mottaker, emne og melding).</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113570228873401036)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hjelp til nedlasting'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113568475683401035)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bruk denne dialogboksen til \00E5 konfigurere datafiltre som begrenser radene som returneres.</p>'),
'',
'<p><strong>Filterliste</strong><br>',
unistr('Filterlisten viser definerte filtre. Deaktiver et eksisterende filter ved \00E5 oppheve valget av det.<br>'),
unistr('Klikk p\00E5 Legg til ( &plus; ) hvis du vil opprette et nytt filter, eller klikk p\00E5 Slett ( &minus; ) hvis du vil fjerne et eksisterende filter.</p>'),
'',
'<p><strong>Filterinnstillinger</strong><br>',
unistr('Bruk skjemaet til \00E5 definere filteregenskapene.<br>'),
'Velg den egnede filtertypen:<br>',
'&nbsp;&nbsp;&nbsp;Rad - filtrer etter et begrep i hvilken som helst kolonne som kan filtreres.<br>',
'&nbsp;&nbsp;&nbsp;Kolonne - filtrer en bestemt kolonne med en angitt operator og verdi.</p>',
'',
unistr('<p><em>Merknad: N\00E5r du viser det interaktive rutenettet, kan du definere radfiltre ved \00E5 skrive direkte inn i feltet S\00F8k. Klikk p\00E5 Velg kolonner for s\00F8king hvis du vil begrense s\00F8ket til en bestemt kolonne. Du kan ogs\00E5 \00E5pne en kolonneoverskriftmeny o')
||unistr('g velge en verdi for \00E5 opprette et kolonnefilter.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113571020416401036)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hjelp til filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113568869309401035)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bruk denne dialogboksen til \00E5 vise dataene slik de var p\00E5 et tidligere tidspunkt.</p>'),
unistr('<p>Angi hvor mange minutter tidligere Flashback-sp\00F8rringen skal utf\00F8res.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113570630817401036)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hjelp til flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113571327080401037)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hjelp til Grupper etter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113568992085401035)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bruk denne dialogboksen til \00E5 utheve rader eller kolonner med data basert p\00E5 den angitte betingelsen.</p>'),
'',
'<p><strong>Uthevingsliste</strong><br>',
unistr('Uthevingslisten viser definerte uthevinger. Deaktiver en eksisterende utheving ved \00E5 oppheve valget av den.<br>'),
unistr('Klikk p\00E5 Legg til ( &plus; ) hvis du vil opprette en ny utheving, eller klikk p\00E5 Slett ( &minus; ) hvis du vil fjerne en eksisterende utheving.</p>'),
'',
'<p><strong>Uthevingsinnstillinger</strong><br>',
unistr('Bruk skjemaet til \00E5 definere uthevingsegenskapene.<br>'),
'Angi navnet, velg Rad eller Kolonne, og velg HTML-fargekodene for bakgrunnen og teksten.<br>',
unistr('Angi et egnet valg for <strong>Betingelsestype</strong> for \00E5 utheve bestemte data:<br>'),
'&nbsp;&nbsp;&nbsp;Rad - uthev begrepet i hvilken som helst kolonne.<br>',
unistr('&nbsp;&nbsp;&nbsp;Kolonne - uthev i en bestemt kolonne, basert p\00E5 den angitte operatoren og verdien.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113570504116401036)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hjelp til utheving'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113569104254401035)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bruk denne dialogboksen til \00E5 lagre endringene du har gjort i gjeldende oppsett og konfigurasjon.<br>'),
unistr('Applikasjonsutviklere kan definere flere alternative rapportoppsett. N\00E5r det er tillatt, kan du og andre sluttbrukere lagre en rapport som Offentlig, noe som gj\00F8r rapporten tilgjengelig for alle andre brukere av rutenettet. Du kan ogs\00E5 lagre en rappo')
||'rt som en privat rapport som bare du kan vise.</p>',
'<p>Velg mellom de tilgjengelige typene, og angi et navn for den lagrede rapporten.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113570376299401036)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hjelp til rapporter',
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113568574126401035)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bruk denne dialogboksen til \00E5 angi visningsrekkef\00F8lgen.</p>'),
'',
'<p><strong>Sorteringsliste</strong><br>',
'Dialogboksen Sorter viser en liste over konfigurerte sorteringsregler.<br>',
unistr('Klikk p\00E5 Legg til ( &plus; ) hvis du vil opprette en sorteringskolonne, eller klikk p\00E5 Slett ( &minus; ) hvis du vil fjerne en sorteringskolonne.<br>'),
unistr('Klikk p\00E5 Flytt opp ( &uarr; ) og Flytt ned ( &darr; ) hvis du vil flytte den valgte sorteringskolonnen opp og ned i forhold til andre sorteringskolonner.</p>'),
'',
'<p><strong>Sorteringsinnstillinger</strong><br>',
unistr('Velg en sorteringskolonne, sorteringsretningen og hvilke rekkef\00F8lge nullkolonnene (kolonner uten verdier) skal ha.</p>'),
'',
'<p><em>Merknad: Data kan sorteres etter kolonner som ikke vises, men det kan hende at ikke alle kolonner kan sorteres.</em><br>',
unistr('<em>Viste kolonner kan sorteres ved \00E5 trykke p\00E5 pil opp (stigende) eller pil ned (synkende) p\00E5 slutten av kolonneoverskriftene. Hvis du vil legge til en etterf\00F8lgende kolonne i en eksisterende sortering, holder du inne tasten Skift og klikker p\00E5 pil ')
||'opp eller pil ned.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113570980081401036)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hjelp til sortering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113570180678401036)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'no'
,p_message_text=>'Hjelp til abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113522463423401000)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'no'
,p_message_text=>'Skjul'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113489235082400975)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'no'
,p_message_text=>'Uthev'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113557295671401026)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'no'
,p_message_text=>unistr('H\00F8y')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113558063597401027)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'no'
,p_message_text=>'Vannrett'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113515475332400995)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'no'
,p_message_text=>'timer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113520496011400999)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'no'
,p_message_text=>'Ikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113488183172400975)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'no'
,p_message_text=>'Ikonvisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113513643000400994)
,p_name=>'APEX.IG.IN'
,p_message_language=>'no'
,p_message_text=>'i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113522018042401000)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'no'
,p_message_text=>'Inaktiv innstilling'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113522131081401000)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'no'
,p_message_text=>'Inaktive innstillinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113529712462401006)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Det oppstod en intern feil ved behandling av foresp\00F8rselen om interaktivt rutenett.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113425571135400928)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'no'
,p_message_text=>unistr('Kolonnefiltertypen %0 st\00F8ttes ikke for kolonnen %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113569922848401036)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'no'
,p_message_text=>'Ugyldig datoformat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113544102302401016)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'no'
,p_message_text=>unistr('Interaktivt rutenett st\00F8tter ikke definisjon av et filter i kolonnen %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113544083739401016)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'no'
,p_message_text=>'%0 er ikke en gyldig filtertype for definisjon av et filter for interaktivt rutenett.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113430642553400932)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'no'
,p_message_text=>'Ugyldig tallformat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113572693556401038)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'no'
,p_message_text=>'Ugyldig innstilling'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113572702212401038)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'no'
,p_message_text=>'Ugyldige innstillinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113563790270401031)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'no'
,p_message_text=>'Sorter etter er satt til %0, men ingen kolonne er valgt for %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113561050180401029)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'no'
,p_message_text=>'Ugyldig verdi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113556183455401025)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'no'
,p_message_text=>'Vises ikke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113514441824400994)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'no'
,p_message_text=>unistr('er i l\00F8pet av siste')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113514672275400994)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'no'
,p_message_text=>'i neste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113513519753400994)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'no'
,p_message_text=>'er ikke tom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113513492169400994)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'no'
,p_message_text=>'er tom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113564535648401032)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'no'
,p_message_text=>'Etikett'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113556574602401026)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Etikett'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113560437152401028)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'no'
,p_message_text=>'Sist'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113503742701400986)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'no'
,p_message_text=>'Siste dag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113503985095400986)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'no'
,p_message_text=>'Siste time'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113504465132400987)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'no'
,p_message_text=>'Siste minutt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113503440536400986)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'no'
,p_message_text=>unistr('Siste m\00E5ned')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113503527950400986)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'no'
,p_message_text=>'Siste uke'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113503621399400986)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'no'
,p_message_text=>'Siste %0 dager'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113503884521400986)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'no'
,p_message_text=>'Siste %0 timer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113504591083400987)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'no'
,p_message_text=>'Siste %0 minutter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113504344123400987)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'no'
,p_message_text=>unistr('Siste %0 m\00E5neder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113504269315400986)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'no'
,p_message_text=>'Siste %0 uker'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113503228704400986)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'no'
,p_message_text=>unistr('Siste %0 \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113503307431400986)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'no'
,p_message_text=>unistr('Siste \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113564702751401032)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'no'
,p_message_text=>'Cellejustering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113564874596401032)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'no'
,p_message_text=>'Bruk gruppe for'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113514011299400994)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'no'
,p_message_text=>'mindre enn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113514110617400994)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'no'
,p_message_text=>'mindre enn eller lik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113558630925401027)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'no'
,p_message_text=>'Linje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113558787662401027)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'no'
,p_message_text=>'Linje med areal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113565172138401032)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'no'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113557354615401026)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Lav'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113567703417401034)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'no'
,p_message_text=>'Skill flere adresser med komma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113515259210400995)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'no'
,p_message_text=>unistr('samsvarer med regul\00E6rt uttrykk')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113539600987401013)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'no'
,p_message_text=>'Maksimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113575276704401040)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'no'
,p_message_text=>'Samlet maksimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113539852292401013)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'no'
,p_message_text=>'Median'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113575334246401040)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'no'
,p_message_text=>'Samlet median'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113539579416401013)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'no'
,p_message_text=>'Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113515300740400995)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'no'
,p_message_text=>'minutter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113540327010401013)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'no'
,p_message_text=>'minutter siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113575186006401039)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'no'
,p_message_text=>'Samlet minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113515769848400995)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'no'
,p_message_text=>unistr('m\00E5neder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113522341592401000)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'no'
,p_message_text=>unistr('Dataene inneholder mer enn %0 rader. Det overskrider maksimum. Du m\00E5 bruke tilleggsfiltre n\00E5r du skal vise resultatene.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113549085327401020)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('Statisk ID for omr\00E5det m\00E5 angis fordi siden inneholder flere interaktive rutenett.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113518430159400997)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'no'
,p_message_text=>'Navn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113518635915400997)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'no'
,p_message_text=>'Navngitt rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113502661252400985)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'no'
,p_message_text=>'Neste dag'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113502478163400985)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'no'
,p_message_text=>'Neste time'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113504664350400987)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'no'
,p_message_text=>'Neste minutt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113502973998400985)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'no'
,p_message_text=>unistr('Neste m\00E5ned')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113502889781400985)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'no'
,p_message_text=>'Neste uke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113502781824400985)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'no'
,p_message_text=>'Neste %0 dager'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113502516899400985)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'no'
,p_message_text=>'Neste %0 timer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113504708385400987)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'no'
,p_message_text=>'Neste %0 minutter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113504069550400986)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'no'
,p_message_text=>unistr('Neste %0 m\00E5neder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113504177465400986)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'no'
,p_message_text=>'Neste %0 uker'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113503179871400986)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'no'
,p_message_text=>unistr('Neste %0 \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113503036984400986)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'no'
,p_message_text=>unistr('Neste \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113514303046400994)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'no'
,p_message_text=>'ikke mellom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113513399483400993)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'no'
,p_message_text=>'er ikke lik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113579586065401043)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>unistr('Omr\00E5det med ID-en %0 er ikke et omr\00E5de med interaktivt rutenett, eller det finnes ikke i applikasjonen %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113513750842400994)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'no'
,p_message_text=>'ikke i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113514575622400994)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'no'
,p_message_text=>unistr('er ikke i l\00F8pet av siste')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113514721933400994)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'no'
,p_message_text=>unistr('er ikke i l\00F8pet av neste')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113522203672401000)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'no'
,p_message_text=>'Ingen data funnet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113560294138401028)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'no'
,p_message_text=>'Nullverdier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113565390298401032)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'no'
,p_message_text=>'Numerisk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113560580590401029)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'no'
,p_message_text=>'Av'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113560635822401029)
,p_name=>'APEX.IG.ON'
,p_message_language=>'no'
,p_message_text=>unistr('P\00E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113512595146400993)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'no'
,p_message_text=>'For 1 minutt siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113568274431401034)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'no'
,p_message_text=>unistr('\00C5pne fargevelger: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113557096338401026)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'no'
,p_message_text=>unistr('\00C5pne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113519542766400998)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'no'
,p_message_text=>'Operator'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113556491398401025)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'no'
,p_message_text=>'Retning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113558859262401027)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'no'
,p_message_text=>'Sektor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113520868677400999)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'no'
,p_message_text=>'Pivoter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113488487253400975)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'no'
,p_message_text=>'Pivotvisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113568173382401034)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'no'
,p_message_text=>'Skill verdier med %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113558920316401027)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'no'
,p_message_text=>'Polar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113564255274401031)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'no'
,p_message_text=>'Midtstilt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113564329028401031)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'no'
,p_message_text=>'Slutt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113564175711401031)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'no'
,p_message_text=>'Start'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113518728458400997)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'no'
,p_message_text=>unistr('Prim\00E6r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113519089130400998)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'no'
,p_message_text=>unistr('Prim\00E6r standard')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113535546451401010)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'no'
,p_message_text=>unistr('Prim\00E6r rapport')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113417777156400923)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'no'
,p_message_text=>'Inkluder tilgjengelighetskoder'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113416482685400922)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'no'
,p_message_text=>'Liggende '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113416561795400922)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'no'
,p_message_text=>unistr('St\00E5ende')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113416341652400922)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'no'
,p_message_text=>'Sideretning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113416247054400922)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'no'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113416120253400922)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'no'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113417872226400923)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'no'
,p_message_text=>'Egendefinert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113415925840400921)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'no'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113415857965400921)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'no'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113416026818400922)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'no'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113415728646400921)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'no'
,p_message_text=>unistr('Sidest\00F8rrelse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113405982542400914)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'no'
,p_message_text=>'Fjern rik tekst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113559073240401027)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'no'
,p_message_text=>'Radar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113559131422401027)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'no'
,p_message_text=>'Intervall'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113569405877401035)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'no'
,p_message_text=>'Oppfrisk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113523021015401001)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'no'
,p_message_text=>'Oppfrisk rad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113521863706401000)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'no'
,p_message_text=>'Oppfrisk rader'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113527026851401004)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>unistr('Omr\00E5de for interaktivt rutenett finnes ikke i applikasjonen %0, siden %1 og omr\00E5det %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113489968862400976)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'no'
,p_message_text=>'Fjern %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113518126950400997)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'no'
,p_message_text=>'Rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113578745294401042)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'no'
,p_message_text=>'Rapporten er slettet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113578456637401042)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'no'
,p_message_text=>'Alternativ rapport som er lagret for alle brukere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113578346943401042)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'no'
,p_message_text=>'Standardrapport som er lagret for alle brukere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113578658809401042)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'no'
,p_message_text=>'Privat rapport er lagret'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113578511864401042)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'no'
,p_message_text=>'Offentlig rapport som er lagret for alle brukere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113527179906401004)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Lagret interaktivt rutenett med navnet %0 finnes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113512452441400993)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'no'
,p_message_text=>'Rapportdata for %0 minutter siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113512346890400993)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'no'
,p_message_text=>'Rapportdata for 1 minutt siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113452064746400948)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Den interaktive rutenettrapporten finnes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113571665075401037)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'no'
,p_message_text=>'Rapport - Rediger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113526934797401004)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Lagret interaktivt rutenett med ID-en %0 finnes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113571530322401037)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'no'
,p_message_text=>'Rapport - Lagre som'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113490084469400976)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'no'
,p_message_text=>'Rapportinnstillinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113579641634401043)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Lagret interaktivt rutenett med den statiske ID-en %0 finnes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113574555558401039)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'no'
,p_message_text=>'Rapportvisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113489193124400975)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'no'
,p_message_text=>'Tilbakestill'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113523131544401001)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'no'
,p_message_text=>'Tilbakestill endringer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113521987827401000)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'no'
,p_message_text=>'Tilbakestill rader'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113519123486400998)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'no'
,p_message_text=>'Rad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113518019958400997)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'no'
,p_message_text=>'Rader per side'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113579220523401043)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'no'
,p_message_text=>'Radhandlinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113580438855401043)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'no'
,p_message_text=>'Handlinger for raden %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113489453912400976)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'no'
,p_message_text=>'Lagre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113532185539401007)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'no'
,p_message_text=>'lagret'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113487682061400974)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'no'
,p_message_text=>'Lagrede rapporter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113487723496400974)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'no'
,p_message_text=>'Standard'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113462257488400955)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'no'
,p_message_text=>'Det finnes allerede en lagret rapport med navnet %0. Angi et nytt navn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113487879706400974)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'no'
,p_message_text=>'Privat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113487928443400974)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'no'
,p_message_text=>'Offentlig'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113574277925401039)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'no'
,p_message_text=>'Lagre som'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113521227285400999)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'no'
,p_message_text=>'Lagre rapportinnstillinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113559281625401027)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'no'
,p_message_text=>'Punkt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113487527845400974)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113566521610401033)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k: Alle tekstkolonner')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113487480573400974)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k etter: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113565703196401032)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k: Fullstendig tekst')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113512256130400993)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k etter %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113555846843401025)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'no'
,p_message_text=>'- Velg -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113496098200400980)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'no'
,p_message_text=>'Utvalg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113548793186401020)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'no'
,p_message_text=>unistr('Velg 1 rad i hovedomr\00E5det')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113487361898400974)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'no'
,p_message_text=>unistr('Velg kolonner for s\00F8k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113578997978401042)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'no'
,p_message_text=>'Handlinger i utvalget'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113496209551400981)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'no'
,p_message_text=>'Celleutvalg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113496197259400980)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'no'
,p_message_text=>'Radvalg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113567112709401034)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'no'
,p_message_text=>'Send som e-post'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113559621757401028)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Serie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113485332935400973)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'no'
,p_message_text=>'Vis'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113537941508401012)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'no'
,p_message_text=>'Vis samlet verdi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113522715897401000)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'no'
,p_message_text=>'Enkeltradvisning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113521065014400999)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'no'
,p_message_text=>'Sorter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113559771695401028)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'no'
,p_message_text=>'Sorter etter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113579365602401043)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'no'
,p_message_text=>unistr('Du kan bare definere \00E9n sortering per kolonne.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113579133905401042)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'no'
,p_message_text=>'Menyen Endre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113560749238401029)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'no'
,p_message_text=>'Stakk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113515002142400995)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'no'
,p_message_text=>'begynner med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113559396616401028)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'no'
,p_message_text=>'Aksje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113480319103400969)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'no'
,p_message_text=>'Strekk kolonnebredder'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113521469701400999)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'no'
,p_message_text=>'Abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113539446311401013)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'no'
,p_message_text=>'Sum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113580637248401044)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'no'
,p_message_text=>'Interaktivt rutenett. Rapport: %0, visning: %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113574669780401039)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'no'
,p_message_text=>'Samlet sum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113557548488401026)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'no'
,p_message_text=>unistr('M\00E5l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113563978074401031)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'no'
,p_message_text=>'Tekstfarge'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113490165112400976)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'no'
,p_message_text=>unistr('Sl\00E5 p\00E5/av')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113537882724401012)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'no'
,p_message_text=>unistr('Verkt\00F8ytips')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113518225368400997)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'no'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113522615346401000)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'no'
,p_message_text=>unistr('L\00E5s opp')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113519732978400998)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'no'
,p_message_text=>'Enhet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113566913893401033)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'no'
,p_message_text=>'Det finnes ulagrede endringer. Vil du fortsette?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113519658952400998)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'no'
,p_message_text=>'Verdi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113556622968401026)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Verdi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113561530008401029)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('Det m\00E5 angis en verdi.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113546431764401018)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'no'
,p_message_text=>'Verdi (tidssone kan ikke endres)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113565465117401032)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'no'
,p_message_text=>'Tekst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113557943526401027)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'no'
,p_message_text=>'Loddrett'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113517786213400997)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'no'
,p_message_text=>'Vis'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113555910835401025)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'no'
,p_message_text=>'Vist'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113557407207401026)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Volum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113515678494400995)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'no'
,p_message_text=>'uker'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113556016810401025)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'no'
,p_message_text=>'Minste kolonnebredde (piksel)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113506836080400988)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'no'
,p_message_text=>'%0 er mellom %1 og %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113506505412400988)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'no'
,p_message_text=>'%0 inneholder %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113506698687400988)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'no'
,p_message_text=>'%0 inneholder ikke %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113484734905400972)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'no'
,p_message_text=>'%0 begynner ikke med %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113505313312400987)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'no'
,p_message_text=>'%0 er lik %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113505510286400987)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er st\00F8rre enn %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113505689902400988)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er st\00F8rre enn eller lik %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113506319098400988)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'no'
,p_message_text=>'%0 er i %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113507529638400989)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de siste %1 dagene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113507302274400989)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de siste %1 timene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113507154992400989)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de siste %1 minuttene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113507901893400989)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de siste %1 m\00E5nedene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113507720884400989)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de siste %1 ukene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113508127268400990)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de siste %1 \00E5rene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113507499837400989)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av den siste dagen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113507233480400989)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av den siste timen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113507018143400989)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av det siste minuttet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113507810623400989)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av den siste m\00E5neden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113507635225400989)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av den siste uken')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113508059095400989)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av det siste \00E5ret')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113509971088400991)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de neste %1 dagene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113509767816400991)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de neste %1 timene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113509585864400991)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de neste %1 minuttene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113510382228400991)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de neste %1 m\00E5nedene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113510186951400991)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de neste %1 ukene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113510533681400991)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de neste %1 \00E5rene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113509826451400991)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av den neste dagen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113509671060400991)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av den neste timen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113509476238400991)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av det neste minuttet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113510254355400991)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av den neste m\00E5neden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113510009642400991)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av den neste uken')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113510472530400991)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av det neste \00E5ret')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113506061726400988)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'no'
,p_message_text=>'%0 er ikke tom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113505967715400988)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'no'
,p_message_text=>'%0 er tom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113505788061400988)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'no'
,p_message_text=>'%0 er mindre enn %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113505866948400988)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'no'
,p_message_text=>'%0 er mindre enn eller lik %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113506191637400988)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'no'
,p_message_text=>'%0 ligner %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113506732878400988)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'no'
,p_message_text=>unistr('%0 samsvarer med det regul\00E6re uttrykket %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113512697715400993)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'no'
,p_message_text=>'For %0 minutter siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113506971255400989)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'no'
,p_message_text=>'%0 er ikke mellom %1 og %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113505485786400987)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'no'
,p_message_text=>'%0 er ikke lik %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113506419545400988)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'no'
,p_message_text=>'%0 er ikke i %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113508741031400990)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de siste %1 dagene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113508519471400990)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de siste %1 timene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113508326188400990)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de siste %1 minuttene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113509148540400990)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de siste %1 m\00E5nedene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113508909247400990)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de siste %1 ukene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113509351385400990)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de siste %1 \00E5rene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113508699871400990)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av den siste dagen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113508498568400990)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av den siste timen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113508286190400990)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av det siste minuttet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113509033590400990)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av den siste m\00E5neden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113508854924400990)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av den siste uken')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113509206170400990)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av det siste \00E5ret')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113511189080400992)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de neste %1 dagene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113510982946400992)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de neste %1 timene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113510764209400991)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de neste %1 minuttene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113511525880400992)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de neste %1 m\00E5nedene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113511399983400992)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de neste %1 ukene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113511740379400992)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de neste %1 \00E5rene')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113511025650400992)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av den neste dagen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113510884128400992)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av den neste timen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113510680217400991)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av det neste minuttet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113511411663400992)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av den neste m\00E5neden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113511258323400992)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av den neste uken')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113511637726400992)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av det neste \00E5ret')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113506211471400988)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'no'
,p_message_text=>'%0 ligner ikke %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113513172264400993)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'no'
,p_message_text=>'%0 begynner med %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113556727358401026)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'no'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113515842900400995)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'no'
,p_message_text=>unistr('\00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113556832754401026)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113556962264401026)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113565905412401033)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'no'
,p_message_text=>'Mandag 12. januar 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113566097516401033)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'no'
,p_message_text=>'Januar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113566195398401033)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'no'
,p_message_text=>'16 timer siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113566287885401033)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'no'
,p_message_text=>'om 16 t'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113421225750400925)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'no'
,p_message_text=>unistr('Ugyldig filtype. St\00F8ttede filtyper: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113548182471401019)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'no'
,p_message_text=>'Bla gjennom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113547890826401019)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'no'
,p_message_text=>'Velg fil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113547999027401019)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'no'
,p_message_text=>'Velg filer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113421020822400925)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'no'
,p_message_text=>'Dra og slipp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113421400139400925)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'no'
,p_message_text=>'Dra og slipp filer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113422632349400926)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'no'
,p_message_text=>'Velg en fil, eller slipp en fil her.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113422704726400926)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'no'
,p_message_text=>'Velg eller slipp filer her.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113422885421400926)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'no'
,p_message_text=>'Velg en fil, eller slipp en fil her.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113422973685400926)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'no'
,p_message_text=>'Velg eller slipp filer her.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113421335517400925)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'no'
,p_message_text=>'%0 filer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113421168096400925)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'no'
,p_message_text=>unistr('Filen er for stor. Maksimal filst\00F8rrelse er %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113408964593400916)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'no'
,p_message_text=>'Adresse er obligatorisk.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113407880539400916)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'no'
,p_message_text=>'By'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113408223650400916)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'no'
,p_message_text=>'Landskode'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113407921245400916)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'no'
,p_message_text=>'Husnummer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113408875745400916)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'no'
,p_message_text=>'Breddegrad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113408700614400916)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'no'
,p_message_text=>'Lengdegrad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113408659182400916)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'no'
,p_message_text=>unistr('Vis p\00E5 kart')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113408338588400916)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'no'
,p_message_text=>'Poeng'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113408086468400916)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'no'
,p_message_text=>'Postnummer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113408185259400916)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'no'
,p_message_text=>'Delstat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113407779968400916)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'no'
,p_message_text=>'Gate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113407626611400915)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'no'
,p_message_text=>'Resultater av geokoding'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113420298633400925)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'no'
,p_message_text=>'Geokodet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113420387694400925)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'no'
,p_message_text=>'Ikke geokodet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113408520477400916)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'no'
,p_message_text=>'Kart'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113408441353400916)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'no'
,p_message_text=>'Finner ingen adresser.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113409066428400916)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'no'
,p_message_text=>'%0 er obligatorisk.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113578814485401042)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'no'
,p_message_text=>'Hjelpetekst: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113472260441400963)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'no'
,p_message_text=>'Merket av'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113472300975400963)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'no'
,p_message_text=>'Ikke merket av'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113418269566400923)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# er ikke innenfor det gyldige omr\00E5det fra %0 til %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113418358459400923)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'no'
,p_message_text=>'#LABEL# er ikke et multiplum av %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113417906063400923)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# m\00E5 samsvare med verdiene %0 og %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113418130728400923)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'no'
,p_message_text=>'Nei'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113496453051400981)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'no'
,p_message_text=>'Av'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113496521369400981)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'no'
,p_message_text=>unistr('P\00E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113418044318400923)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'no'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113401413872400911)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'no'
,p_message_text=>unistr('Legg til oppf\00F8ring')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113530600184401006)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'no'
,p_message_text=>'Legg til'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113530721247401006)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'no'
,p_message_text=>'Fjern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113401557981400911)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'no'
,p_message_text=>unistr('Valgte oppf\00F8ringer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113534451846401009)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'no'
,p_message_text=>'Avansert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113534702293401009)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'no'
,p_message_text=>'Avbryt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113534543911401009)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'no'
,p_message_text=>'Felles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113534836248401009)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'no'
,p_message_text=>'Valg for direktemaler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113535462535401010)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'no'
,p_message_text=>unistr('Malvalg er ikke tilgjengelige fordi denne komponenten ikke er gjengitt p\00E5 siden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113534315942401009)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'no'
,p_message_text=>'Finner ingen malvalg.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113534645868401009)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'no'
,p_message_text=>'Lagre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113409990436400917)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'no'
,p_message_text=>'Nullstill sirkel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113411715233400918)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'no'
,p_message_text=>'Egendefinerte stiler har ikke gyldig JSON-format.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113410284533400917)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'no'
,p_message_text=>unistr('Avstandsverkt\00F8y')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113410032027400917)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'no'
,p_message_text=>'Tegn sirkel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113402664924400912)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'no'
,p_message_text=>unistr('Fasettert s\00F8k trenger en datakilde p\00E5 omr\00E5deniv\00E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113405211719400914)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'no'
,p_message_text=>'Gjeldende plassering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113406399061400915)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'no'
,p_message_text=>unistr('Koordinatene i f\00F8rste posisjon er ugyldige.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113403714412400913)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('F\00F8rste posisjon m\00E5 v\00E6re en punktgeometri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113406132808400914)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'no'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113404798249400913)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'no'
,p_message_text=>'Lag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113538001520401012)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'no'
,p_message_text=>'Lag: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113409303347400917)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'no'
,p_message_text=>'Kart'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113402560330400912)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'no'
,p_message_text=>'Meldinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113406247567400915)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'no'
,p_message_text=>'miles'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113537055869401011)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'no'
,p_message_text=>'Dataene inneholder flere enn %0 rader, noe som overskrider den tillatte maksimumsverdien.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113404554050400913)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'no'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Vilk\00E5r</a> &nbsp;&nbsp; Tilordne data &copy; 2017 HER')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113403415438400913)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'no'
,p_message_text=>'Datatypen SDO_GEOMETRY er ikke tilgjengelig i denne databasen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113404660659400913)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'no'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; Bidragsytere til OpenStreetMap </a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113404823229400914)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'no'
,p_message_text=>'Punkt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113538105148401012)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'no'
,p_message_text=>'%0 punkt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113410194479400917)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'no'
,p_message_text=>'Rektangelzoom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113409876261400917)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'no'
,p_message_text=>'Fjern'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113405191451400914)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'no'
,p_message_text=>'Tilbakestill peiling nordover'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113485489478400973)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'no'
,p_message_text=>'Bytt til 2D-modus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113485533963400973)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'no'
,p_message_text=>'Bytt til 3D-modus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113409795000400917)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'no'
,p_message_text=>unistr('Vis/skjul opphavsrettserkl\00E6ring')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113410378053400917)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'no'
,p_message_text=>'Total avstand'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113404948312400914)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'no'
,p_message_text=>'Zoom inn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113405055218400914)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'no'
,p_message_text=>'Zoom ut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113532581834401008)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'no'
,p_message_text=>'Fet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113533490026401008)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'no'
,p_message_text=>'Bilde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113533017868401008)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'no'
,p_message_text=>'Innebygd kode'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113546647114401018)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'no'
,p_message_text=>'Sett inn bilde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113546730807401018)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'no'
,p_message_text=>'Sett inn kobling'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113532655123401008)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'no'
,p_message_text=>'Kursiv'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113547300394401019)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'no'
,p_message_text=>'Kobling'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113533360710401008)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'no'
,p_message_text=>'Liste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113533276531401008)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'no'
,p_message_text=>'Sortert liste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113532778310401008)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'no'
,p_message_text=>unistr('Forh\00E5ndsvis')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113532815190401008)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'no'
,p_message_text=>unistr('Ingenting \00E5 forh\00E5ndsvise')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113532925487401008)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'no'
,p_message_text=>'Gjennomstreking'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113533121339401008)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'no'
,p_message_text=>'Usortert liste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113512093849400992)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'no'
,p_message_text=>'gjeldende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113569581076401035)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'no'
,p_message_text=>'Mer ...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113511908242400992)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'no'
,p_message_text=>'Laster'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113543767417401016)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'no'
,p_message_text=>'Varselmelding'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113517083381400996)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# m\00E5 v\00E6re et tall som er mindre enn eller lik %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113517136603400996)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# m\00E5 v\00E6re et gyldig tall.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113517294705400996)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'no'
,p_message_text=>'#LABEL# samsvarer ikke med tallformatet %0 (eksempel: %1).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113516914093400996)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# m\00E5 v\00E6re et tall som er st\00F8rre enn eller lik %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113516852639400996)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# m\00E5 v\00E6re et tall mellom %0 og %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113512149695400993)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'no'
,p_message_text=>unistr('\00E5pnes i et nytt vindu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113465382252400958)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'no'
,p_message_text=>unistr('Denne siden er allerede sendt inn og kan ikke sendes inn p\00E5 nytt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113447917146400945)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'no'
,p_message_text=>'Finner ikke siden %1 i applikasjonen %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113481778900400970)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('#LABEL# m\00E5 ha verdi.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113425008243400928)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113531033019401006)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'no'
,p_message_text=>'Lukk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113530983515401006)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k etter %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113531299588401007)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'no'
,p_message_text=>'Neste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113531188653401007)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'no'
,p_message_text=>'Forrige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113417138181400922)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'no'
,p_message_text=>unistr('Angi et s\00F8kebegrep med minst %0 tegn.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113486623763400974)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'no'
,p_message_text=>'Hurtigliste med verdier: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113417215410400922)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'no'
,p_message_text=>unistr('Angi et s\00F8kebegrep.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113417081461400922)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'no'
,p_message_text=>'Finner ingen resultater.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113416953797400922)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'no'
,p_message_text=>'Fjern %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113504824334400987)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8kebegrep')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113530845088401006)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113541551202401014)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'no'
,p_message_text=>'Behandler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113415504798400921)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'no'
,p_message_text=>unistr('Legg til p\00E5 Hjem-skjerm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113411504569400918)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Det ser ut til at enheten eller nettleseren for \00F8yeblikket ikke st\00F8tter installasjon av progressive Web-apper.</p>'),
unistr('    <p class="a-pwaDialog-intro">Hvis denne applikasjonen allerede er installert p\00E5 enheten, \00E5pner du den fra startskjermen.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113411130678400918)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Dette Web-omr\00E5det har appfunksjonalitet. Legg det til p\00E5 startskjermen, slik at du kan bruke det i fullskjerm.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Trykk p\00E5 ikonet <strong>Meny</strong> i den nedre navigeringen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Trykk p\00E5 <strong>Installer</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Bekreft ved \00E5 trykke p\00E5 <strong>Legg til</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113411231397400918)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Dette Web-omr\00E5det har appfunksjonalitet som gir en best mulig opplevelse i Chrome eller Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Trykk p\00E5 ikonet <strong>Meny</strong> ved siden av adresselinjen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Trykk p\00E5 <strong>Installer</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113410888439400918)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Dette Web-omr\00E5det har appfunksjonalitet som gir en best mulig opplevelse i Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Trykk p\00E5 ikonet <strong>Del</strong> i den nedre navigeringen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Trykk p\00E5 <strong>\00C5pne i Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113410518112400918)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Dette Web-omr\00E5det har appfunksjonalitet. Legg det til p\00E5 startskjermen, slik at du f\00E5r en best mulig opplevelse.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Trykk p\00E5 ikonet <strong>Del</strong> ved siden av adresselinjen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Trykk p\00E5 <strong>Legg til p\00E5 startskjerm</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Bekreft ved \00E5 trykke p\00E5 <strong style="color:#007AE1;">Legg til</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113410426233400917)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Dette Web-omr\00E5det har appfunksjonalitet. Legg det til p\00E5 startskjermen, slik at du f\00E5r en best mulig opplevelse.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Trykk p\00E5 ikonet <strong>Del</strong> i den nedre navigeringen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Rull ned og trykk p\00E5 <strong>Legg til p\00E5 startskjerm</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Bekreft ved \00E5 trykke p\00E5 <strong style="color:#007AE1;">Legg til</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113405472184400914)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Dette Web-omr\00E5det har appfunksjonalitet. Legg det til p\00E5 startskjermen, slik at du f\00E5r en best mulig opplevelse.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Trykk p\00E5 ikonet <strong>Mer</strong> ved siden av adresselinjen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Trykk p\00E5 <strong>Legg til p\00E5 startskjerm</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Bekreft ved \00E5 trykke p\00E5 <strong style="color:#007AE1;">Legg til</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113410781907400918)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Dette Web-omr\00E5det har appfunksjonalitet. Legg det til p\00E5 startskjermen, slik at du f\00E5r en best mulig opplevelse.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Trykk p\00E5 ikonet <strong>Del</strong> ved siden av adresselinjen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Trykk p\00E5 <strong>\00C5pne i Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113410665387400918)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Dette Web-omr\00E5det har appfunksjonalitet. Legg det til p\00E5 startskjermen, slik at du f\00E5r en best mulig opplevelse.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Trykk p\00E5 ikonet <strong>Del</strong> i den nedre navigeringen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Trykk p\00E5 <strong>\00C5pne i Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113411467424400918)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Dette Web-omr\00E5det har appfunksjonalitet som gir en best mulig opplevelse i Chrome.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox st\00F8tter for \00F8yeblikket ikke installasjon av Web-apper.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113410928683400918)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Dette Web-omr\00E5det har appfunksjonalitet som gir en best mulig opplevelse i Chrome eller Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox st\00F8tter for \00F8yeblikket ikke installasjon av Web-apper i macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113411011400400918)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Dette Web-omr\00E5det har appfunksjonalitet som gir en best mulig opplevelse i Chrome eller Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari st\00F8tter for \00F8yeblikket ikke installasjon av Web-apper i macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113411376547400918)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Dette Web-omr\00E5det har appfunksjonalitet som gir en best mulig opplevelse i Chrome eller Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox st\00F8tter for \00F8yeblikket ikke installasjon av Web-apper i Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113413855079400920)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
'    <h1>Kan ikke koble til</h1>',
unistr('    <p>Du m\00E5 ha en Internett-tilkobling for \00E5 kunne bruke denne appen.</p>'),
unistr('    <button type="button">Pr\00F8v p\00E5 nytt</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113413754011400920)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'no'
,p_message_text=>'Kan ikke koble til'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113553573301401023)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'no'
,p_message_text=>'Legg til'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113497950553400982)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'no'
,p_message_text=>'Hele dagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113576864952401041)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'no'
,p_message_text=>'Send invitasjon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113576678859401041)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'no'
,p_message_text=>'Valg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113499756090400983)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'no'
,p_message_text=>'Daglig visning for hele dagen '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113499545723400983)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'no'
,p_message_text=>'Daglig visning for data med tidspunkt '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113544441271401016)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'no'
,p_message_text=>'Dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113538898466401012)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'no'
,p_message_text=>'Beskrivelse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113429489451400931)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'no'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113429206615400931)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'no'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113429111275400931)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'no'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113429345550400931)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'no'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113428848701400931)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'no'
,p_message_text=>'Sluttdato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113429058747400931)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'no'
,p_message_text=>'Hendelsesnavn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113576780104401041)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'no'
,p_message_text=>'Invitasjon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113544563029401017)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'no'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113544258328401016)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'no'
,p_message_text=>unistr('M\00E5ned')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113547014507401018)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'no'
,p_message_text=>'Neste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113561347990401029)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'no'
,p_message_text=>'Ingen hendelser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113577003898401041)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'no'
,p_message_text=>'Rediger en eksisterende hendelse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113576982872401041)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'no'
,p_message_text=>'Sender en invitasjon via e-post.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113547134837401019)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'no'
,p_message_text=>'Forrige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113555126122401024)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'no'
,p_message_text=>'Send e-post'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113554916586401024)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'no'
,p_message_text=>'Send e-post'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113577757954401041)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'no'
,p_message_text=>'Alle felt er obligatoriske.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113577644052401041)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'no'
,p_message_text=>'Send invitasjon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113576533197401041)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'no'
,p_message_text=>'Emne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113555036457401024)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'no'
,p_message_text=>'Til'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113428932561400931)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'no'
,p_message_text=>'Startdato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113552883937401023)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'no'
,p_message_text=>unistr('Skjema p\00E5 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113499379503400983)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'no'
,p_message_text=>'Tidspunkt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113547221011401019)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'no'
,p_message_text=>'I dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113545071185401017)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'no'
,p_message_text=>'Vis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113544397577401016)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'no'
,p_message_text=>'Uke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113499663738400983)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'no'
,p_message_text=>'Ukentlig visning for hele dagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113499410482400983)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'no'
,p_message_text=>'Ukentlig visning for data med tidspunkt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113544983055401017)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'no'
,p_message_text=>unistr('\00C5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113544622439401017)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'no'
,p_message_text=>'Kolonner ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113544723871401017)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'no'
,p_message_text=>'Last flere ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113476814858400966)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'no'
,p_message_text=>'Tilbake'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113423111945400927)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'no'
,p_message_text=>'Last flere ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113425212640400928)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113544888701401017)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'no'
,p_message_text=>'Last flere ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113546973734401018)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'no'
,p_message_text=>unistr('Finner ikke omr\00E5de-ID-en %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113425170543400928)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'no'
,p_message_text=>'Finner ingen data'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113449200981400946)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Kan ikke tilbakestille omr\00E5depagineringen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113417458410400923)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Feil ved angivelse av omr\00E5depaginering.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113538257724401012)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'no'
,p_message_text=>'Kolonner ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113546802105401018)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'no'
,p_message_text=>unistr('Omr\00E5detypen %0 st\00F8ttes ikke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113417367665400922)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Feil ved gjengivelse av omr\00E5det #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113481838992400970)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('#COLUMN_HEADER# m\00E5 ha verdi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113576183956401040)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'no'
,p_message_text=>'%0, redigeringsprogram for rik tekst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113483925419400971)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'no'
,p_message_text=>'HTML-koden for rik tekst overskrider elementets maksimumslengde (faktisk %0, tillatt %1 tegn)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113543813502401016)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'no'
,p_message_text=>'Slett'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113535670229401010)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'no'
,p_message_text=>'Dupliser'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113533971531401009)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'no'
,p_message_text=>'Viste kolonner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113533800626401009)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'no'
,p_message_text=>'Utelat nullverdier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113543971811401016)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'no'
,p_message_text=>'Legg til'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113497538915400981)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'no'
,p_message_text=>'Flytt ned'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113497646871400982)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'no'
,p_message_text=>'Flytt opp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113533643569401008)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'no'
,p_message_text=>'Neste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113534201102401009)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'no'
,p_message_text=>'Andre kolonner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113533775179401008)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'no'
,p_message_text=>'Forrige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113534020966401009)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'no'
,p_message_text=>'Rad - %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113534127244401009)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'no'
,p_message_text=>'Rad %0 av %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113535750709401010)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'no'
,p_message_text=>'Oppfrisk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113535851023401010)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'no'
,p_message_text=>'Tilbakestill endringer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113533550166401008)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'no'
,p_message_text=>'Menyen Innstillinger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113494594470400979)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'no'
,p_message_text=>'Eksempel: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113402097554400912)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'no'
,p_message_text=>unistr('Logg p\00E5 igjen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113401952346400911)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'no'
,p_message_text=>unistr('\00D8kten er avsluttet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113402154272400912)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'no'
,p_message_text=>'Forleng'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113401728107400911)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'no'
,p_message_text=>unistr('\00D8kten blir avsluttet %0. Vil du forlenge den?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113401893422400911)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'no'
,p_message_text=>unistr('\00D8kten blir avsluttet %0, og den kan ikke forlenges. Lagre arbeidet n\00E5, slik at du unng\00E5r \00E5 miste noen data')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113554707171401024)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Feil ved behandling av oppryddingskode for database\00F8kt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113447854702400945)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Feil ved behandling av oppsettskode for database\00F8kt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113421952148400926)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'no'
,p_message_text=>unistr('\00D8kten er avsluttet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113553645673401023)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'no'
,p_message_text=>unistr('Lukk denne dialogboksen og trykk p\00E5 knappen for ny lasting i nettleseren for \00E5 hente en ny \00F8kt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113572917036401038)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'no'
,p_message_text=>unistr('Klikk <a href="%0">her</a> hvis du vil opprette en ny \00F8kt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113459554580400953)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'no'
,p_message_text=>unistr('\00D8kten er ikke gyldig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113499063268400983)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'no'
,p_message_text=>unistr('Kan ikke aktivere noen dynamiske roller i Real Application Security-\00F8kten for brukeren %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113445709705400943)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('ERR-99900 Kan ikke opprette unik \00F8kt-ID: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113462013199400955)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'no'
,p_message_text=>unistr('Brudd p\00E5 beskyttelse av \00F8kttilstand: Dette kan skyldes manuell endring av det beskyttede sideelementet %0. Hvis du er usikker p\00E5 hva feilen skyldes, kontakter du applikasjonsadministratoren for \00E5 f\00E5 hjelp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113581178009401044)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'no'
,p_message_text=>unistr('Brudd p\00E5 sidebeskyttelse: Dette kan skyldes innsending av en side som ikke var fullstendig lastet, eller manuell endring av beskyttede sideelementer. Hvis du trenger mer hjelp, kontakter du applikasjonsadministratoren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113580195426401043)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'no'
,p_message_text=>unistr('%0 inneholder ett av f\00F8lgende ugyldige tegn: &<>"/;,*|=% eller --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113580263046401043)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'no'
,p_message_text=>unistr('%0 inneholder ett av f\00F8lgende ugyldige tegn: &<>"/;,*|=% eller -- eller en ny linje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113579961635401043)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'no'
,p_message_text=>unistr('%0 inneholder spesialtegn. Bare tegnene a-\00E5, 0-9 og mellomrom er tillatt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113580080408401043)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'no'
,p_message_text=>'%0 inneholder <, > eller ", som er ugyldige tegn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113424165635400927)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'no'
,p_message_text=>unistr('Det ble ikke angitt noen kontrollsum for \00E5 vise behandling for en side som trenger en kontrollsum n\00E5r \00E9n eller flere verdier for foresp\00F8rsler, nullstilt hurtigbuffer eller argument sendes som parametre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113456900773400951)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'no'
,p_message_text=>unistr('Brudd p\00E5 beskyttelse av \00F8kttilstand: Dette kan skyldes manuell endring av en URL-adresse som inneholder en kontrollsom, eller bruk av en kobling med feil eller manglende kontrollsum. Hvis du er usikker p\00E5 hva feilen skyldes, kontakter du applikasjons')
||unistr('administratoren for \00E5 f\00E5 hjelp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113534996543401009)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'no'
,p_message_text=>unistr('Sl\00E5 av modusen H\00F8y kontrast')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113535006135401009)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'no'
,p_message_text=>unistr('Sl\00E5 p\00E5 modusen H\00F8y kontrast')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113453634826400949)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'no'
,p_message_text=>'Nederst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113453885370400949)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'no'
,p_message_text=>'Ned'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113453965372400949)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'no'
,p_message_text=>'Flytt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113454011720400949)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'no'
,p_message_text=>'Flytt alle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113454170318400949)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'no'
,p_message_text=>'Fjern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113454228359400950)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'no'
,p_message_text=>'Fjern alle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113454330956400950)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'no'
,p_message_text=>'Tilbakestill'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113453585092400949)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'no'
,p_message_text=>unistr('\00D8verst')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113453734373400949)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'no'
,p_message_text=>'Opp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113562605584401030)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'no'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113563369469401031)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>'i %0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113562503500401030)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'no'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113563476027401031)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>'i %0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113562364080401030)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'no'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113563507554401031)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>'i %0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113562937368401030)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'no'
,p_message_text=>'%0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113563119202401031)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>'i %0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113562402901401030)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'no'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113563268744401031)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>'i %0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113562788088401030)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'no'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113563606656401031)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>'i %0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113562879535401030)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'no'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113563030683401031)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>'i %0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113402954263400912)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'no'
,p_message_text=>'[Linje]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113403395711400912)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'no'
,p_message_text=>'[Flere linjer]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113403109909400912)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'no'
,p_message_text=>'[Flere punkt]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113403561432400913)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'no'
,p_message_text=>'[Flere polygoner]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113403675267400913)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'no'
,p_message_text=>'[Geometriobjekt]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113402899030400912)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'no'
,p_message_text=>'[Punkt (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113403021797400912)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'no'
,p_message_text=>'[Polygon]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113480281548400969)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'no'
,p_message_text=>'Trekk sammen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113480163165400969)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'no'
,p_message_text=>'Gjenopprett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113526646903401003)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'no'
,p_message_text=>'Fjern vurdering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113516515517400996)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke innenfor det gyldige vurderingsomr\00E5det fra 1 til %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113516649813400996)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'no'
,p_message_text=>'%0 er ikke numerisk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113512798063400993)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'no'
,p_message_text=>'Meldingen Vellykket'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113575857528401040)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'no'
,p_message_text=>'Neste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113575700812401040)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'no'
,p_message_text=>'Forrige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113561415390401029)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'no'
,p_message_text=>unistr('Verkt\00F8ylinje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113576214993401040)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'no'
,p_message_text=>'Utvid / trekk sammen navigering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113576316679401040)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'no'
,p_message_text=>'Utvid / trekk sammen sidekolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113485917739400973)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'no'
,p_message_text=>'Hovednavigering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113492986208400978)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'no'
,p_message_text=>'1 dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113492725509400978)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'no'
,p_message_text=>'1 time'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113493092402400978)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'no'
,p_message_text=>'%0 dager'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113492861029400978)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'no'
,p_message_text=>'%0 timer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113492682339400978)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'no'
,p_message_text=>'%0 minutter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113493259107400978)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'no'
,p_message_text=>'%0 uker'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113493181525400978)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'no'
,p_message_text=>'1 uke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113579473838401043)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'no'
,p_message_text=>'Begynnelsen av siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113441466476400940)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'no'
,p_message_text=>'Aktivert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113415250151400921)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Feil ved behandling av foresp\00F8rselen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113494615362400979)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('N\00F8dvendig verdi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113577506806401041)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'no'
,p_message_text=>unistr('Vent til siden er fullstendig lastet, og pr\00F8v p\00E5 nytt.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113537778709401011)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'no'
,p_message_text=>'Denne siden har ulagrede endringer.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113418659721400923)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'no'
,p_message_text=>'Arbeidsboken har ingen aktive regneark.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113418566828400923)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'no'
,p_message_text=>'Arbeidsboken er ikke initialisert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113418416938400923)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'no'
,p_message_text=>'Det oppstod en intern feil ved opprettelse av XLSX-filen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113420989542400925)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'no'
,p_message_text=>'Ark'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113552619161401023)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'no'
,p_message_text=>'Handlinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113470112900400961)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'no'
,p_message_text=>'Menyen Handlinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113465880735400958)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'no'
,p_message_text=>'Legg til funksjon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113465711426400958)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Legg til Grupper etter-kolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113499975625400983)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Legg til pivotkolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113500064622400983)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Legg til radkolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113440213344400939)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'no'
,p_message_text=>'Aggreger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113476393485400966)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'no'
,p_message_text=>'Aggregering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113457434323400952)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'no'
,p_message_text=>'Gjennomsnitt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113461793825400955)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'no'
,p_message_text=>'Antall'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113457589121400952)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'no'
,p_message_text=>'Maksimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113457791061400952)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'no'
,p_message_text=>'Median'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113457667092400952)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'no'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113457333835400952)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'no'
,p_message_text=>'Sum - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113458440512400953)
,p_name=>'APEXIR_ALL'
,p_message_language=>'no'
,p_message_text=>'Alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113439597662400939)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'no'
,p_message_text=>'Alle kolonner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113422071531400926)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'no'
,p_message_text=>'Alle rader'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113549629516401020)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'no'
,p_message_text=>'Alternativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113551224488401022)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'no'
,p_message_text=>'Alternativ standard - %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113452105816400948)
,p_name=>'APEXIR_AND'
,p_message_language=>'no'
,p_message_text=>'og'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113441675602400940)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'no'
,p_message_text=>'Bruk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113435329947400936)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'no'
,p_message_text=>'Stigende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113454996718400950)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'no'
,p_message_text=>'For %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113551824786401022)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'no'
,p_message_text=>'Gjennomsnitt - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113543222278401016)
,p_name=>'APEXIR_BAR'
,p_message_language=>'no'
,p_message_text=>'Stolpe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113441092032400940)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'no'
,p_message_text=>'mellom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113434133118400935)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'no'
,p_message_text=>'Bakgrunnsfarge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113436030738400936)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'no'
,p_message_text=>unistr('bl\00E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113467736501400960)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'no'
,p_message_text=>'Nederst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113436644250400937)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'no'
,p_message_text=>'Avbryt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113442568293400941)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'no'
,p_message_text=>'Kategori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113434083620400935)
,p_name=>'APEXIR_CELL'
,p_message_language=>'no'
,p_message_text=>'Celle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113458371768400952)
,p_name=>'APEXIR_CHART'
,p_message_language=>'no'
,p_message_text=>'Diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113468632735400960)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'no'
,p_message_text=>'Initialiserer ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113504924430400987)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'no'
,p_message_text=>unistr('Diagrametikett m\00E5 angis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113517331416400996)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'no'
,p_message_text=>unistr('Sp\00F8rringen har overskredet maksimum, som er %0 datapunkt per diagram. Bruk et filter for \00E5 redusere antall poster i basissp\00F8rringen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113516200570400996)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Maksimalt antall rader for en diagramsp\00F8rring begrenser antall rader i basissp\00F8rringen, ikke antall viste rader.  '),
unistr('Basissp\00F8rringen overskrider maksimalt antall rader, som er %0. Bruk et filter for \00E5 redusere antall poster i basissp\00F8rringen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113439668234400939)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'no'
,p_message_text=>'Diagramtype'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113512947758400993)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'no'
,p_message_text=>'Merk alle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113455342756400950)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'no'
,p_message_text=>'Velg rapportformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113462723135400956)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'no'
,p_message_text=>'nullstill'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113436582347400937)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Kolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113473904081400964)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'no'
,p_message_text=>'Kolonner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113546203750401018)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'no'
,p_message_text=>'Filtrer ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113464767597400957)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'no'
,p_message_text=>'Kolonneoverskriftsmenyen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113468436880400960)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'no'
,p_message_text=>'Kolonneopplysninger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113548555303401020)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'no'
,p_message_text=>'Kolonneetikett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113466142855400958)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'no'
,p_message_text=>'Kolonne - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113450272156400947)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'no'
,p_message_text=>'inneholder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113451159499400947)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'no'
,p_message_text=>'inneholder ikke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113435007114400936)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'no'
,p_message_text=>'i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113451396249400947)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'no'
,p_message_text=>unistr('er ikke i l\00F8pet av siste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113459897848400954)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'no'
,p_message_text=>unistr('er ikke i l\00F8pet av neste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113451232134400947)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'no'
,p_message_text=>unistr('er i l\00F8pet av siste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113459795834400953)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'no'
,p_message_text=>unistr('er i l\00F8pet av neste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113434907480400936)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'no'
,p_message_text=>'er ikke null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113434807943400936)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'no'
,p_message_text=>'er null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113434679968400935)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'no'
,p_message_text=>'ligner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113435115377400936)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'no'
,p_message_text=>'ikke i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113434710032400935)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'no'
,p_message_text=>'ligner ikke'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113450572079400947)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'no'
,p_message_text=>unistr('samsvarer med regul\00E6rt uttrykk')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113455265512400950)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'no'
,p_message_text=>'Beregning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113515950008400995)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'no'
,p_message_text=>'Beregningsuttrykk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113474279612400964)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'no'
,p_message_text=>'Opprett en beregning ved hjelp av kolonnealiaser.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113474344350400964)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'no'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113474469747400964)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'no'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113474562768400965)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'no'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113420458322400925)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'no'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113459139066400953)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'no'
,p_message_text=>'Beregn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113466707278400959)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'no'
,p_message_text=>'Kontrollskift'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113469727820400961)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'no'
,p_message_text=>'Kontrollskift'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113554189513401024)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'no'
,p_message_text=>'Kontrollskiftkolonner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113417530664400923)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'no'
,p_message_text=>'Antall unike'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113552348003401022)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'no'
,p_message_text=>'Antall unike'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113552276547401022)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'no'
,p_message_text=>'Antall - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113524334685401002)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'no'
,p_message_text=>'Daglig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113579025483401042)
,p_name=>'APEXIR_DATA'
,p_message_language=>'no'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113468530887400960)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'no'
,p_message_text=>'Rapportdata for %0 minutter siden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113542039984401015)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'no'
,p_message_text=>'Hjelp til datarutenett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113440315658400940)
,p_name=>'APEXIR_DATE'
,p_message_language=>'no'
,p_message_text=>'Dato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113472458168400963)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'no'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113549405595401020)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'no'
,p_message_text=>'Standard rapporttype'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113436733942400937)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'no'
,p_message_text=>'Slett'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113440690792400940)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'no'
,p_message_text=>'Vil du slette disse rapportinnstillingene?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113535351601401010)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'no'
,p_message_text=>'Slett standardrapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113466414030400959)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'no'
,p_message_text=>'Slett rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113435434655400936)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'no'
,p_message_text=>'Synkende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113442637259400941)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'no'
,p_message_text=>'Beskrivelse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113464681779400957)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'no'
,p_message_text=>'Enkeltradvisning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113472937930400963)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'no'
,p_message_text=>'Retning - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113473857115400964)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'no'
,p_message_text=>'Deaktivert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113436226072400937)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'no'
,p_message_text=>'Vist'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113439410787400939)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'no'
,p_message_text=>'Viste kolonner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113472835488400963)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'no'
,p_message_text=>'Vis i rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113467660739400960)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'no'
,p_message_text=>'Ned'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113459255176400953)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'no'
,p_message_text=>'Last ned'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113472703521400963)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'no'
,p_message_text=>'Ikke vis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113538724748401012)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'no'
,p_message_text=>'Utheving med samme betingelse finnes allerede.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113554309995401024)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'no'
,p_message_text=>unistr('Duplisert pivotkolonne. Listen over pivotkolonner m\00E5 v\00E6re unik.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113554561553401024)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'no'
,p_message_text=>'Rediger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113468736846400960)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'no'
,p_message_text=>'Rediger diagraminnstillinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113475330247400965)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'no'
,p_message_text=>'Rediger diagram'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113475752074400965)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'no'
,p_message_text=>'Rediger filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113530113952401006)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'no'
,p_message_text=>'Rediger Grupper etter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113475644463400965)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'no'
,p_message_text=>'Rediger utheving'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113500224801400983)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'no'
,p_message_text=>'Rediger pivotering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113549704526401020)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'no'
,p_message_text=>'E-post'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113428462574400931)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'no'
,p_message_text=>'E-postadresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113550023414401021)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'no'
,p_message_text=>'Blindkopi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113550296240401021)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'no'
,p_message_text=>'Tekst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113549955891401021)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'no'
,p_message_text=>'Kopi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113550787101401021)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'no'
,p_message_text=>'Hyppighet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113432125209400933)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'no'
,p_message_text=>'E-post er ikke konfigurert for denne applikasjonen. Ta kontakt med administratoren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113523683217401001)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('E-postadresse m\00E5 angis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113550345681401021)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'no'
,p_message_text=>'Se vedlegg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113550119063401021)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'no'
,p_message_text=>'Emne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113524610702401002)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('E-postemne m\00E5 angis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113549883371401021)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'no'
,p_message_text=>'Til'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113433817410400935)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'no'
,p_message_text=>'Aktivert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113475597956400965)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'no'
,p_message_text=>'Aktiver/deaktiver'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113475029178400965)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'no'
,p_message_text=>'Feil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113474636081400965)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'no'
,p_message_text=>'Eksempler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113475470130400965)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'no'
,p_message_text=>'Eksempler:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113439310910400939)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'no'
,p_message_text=>'Utelat nullverdier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113476054972400966)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'no'
,p_message_text=>'Utvid / trekk sammen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113473672657400964)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'no'
,p_message_text=>'Uttrykk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113458775138400953)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'no'
,p_message_text=>'Filtrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113469653477400961)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'no'
,p_message_text=>'Filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113479962668400968)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'no'
,p_message_text=>'Filteruttrykk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113576453463401040)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'no'
,p_message_text=>'Filteruttrykket er for langt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113479829284400968)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'no'
,p_message_text=>'Filtertype'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113476203718400966)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'no'
,p_message_text=>unistr('Velg kolonner for s\00F8k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113459000080400953)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'no'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113473448850400964)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'no'
,p_message_text=>unistr('Med en flashback-sp\00F8rring kan du vise dataene som fantes p\00E5 et tidligere tidspunkt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113524024399401001)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'no'
,p_message_text=>'Varighet for flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113525421026401002)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'no'
,p_message_text=>'Formater'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113455137079400950)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'no'
,p_message_text=>'Formatmaske - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113466387581400959)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'no'
,p_message_text=>'Funksjon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113474109243400964)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'no'
,p_message_text=>'Funksjoner - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113549336547401020)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'no'
,p_message_text=>'Funksjoner/operatorer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113466063711400958)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'no'
,p_message_text=>'Funksjon - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113458582817400953)
,p_name=>'APEXIR_GO'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113434327457400935)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'no'
,p_message_text=>unistr('gr\00F8nn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113417639049400923)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'no'
,p_message_text=>'Grupper etter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113550478480401021)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Grupper etter-kolonne - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113505003296400987)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'no'
,p_message_text=>unistr('Grupper etter-kolonne m\00E5 angis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113516177558400995)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'no'
,p_message_text=>unistr('Maksimalt antall rader for en Grupper etter-sp\00F8rring begrenser antall rader i basissp\00F8rringen, ikke antall viste rader. Basissp\00F8rringen overskrider maksimalt antall rader, som er %0. Bruk et filter for \00E5 redusere antall poster i basissp\00F8rringen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113496795541400981)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'no'
,p_message_text=>'Grupper etter-sortering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113554270386401024)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'no'
,p_message_text=>unistr('Sorteringsrekkef\00F8lge for Grupper etter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113439793141400939)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'no'
,p_message_text=>'Vannrett kolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113471304607400962)
,p_name=>'APEXIR_HELP'
,p_message_language=>'no'
,p_message_text=>'Hjelp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113463101562400956)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ved hjelp av interaktive rapporter kan sluttbrukere tilpasse rapporter. Brukerne kan endre oppsettet for rapportdata ved \00E5 velge kolonner, bruke filtre, utheve og sortere. Brukerne kan ogs\00E5 definere skift, aggregeringer, diagrammer og grupperinger og')
||unistr(' legge til egne beregninger. De kan ogs\00E5 sette opp et abonnement, slik at en HTML-versjon av rapporten blir sendt med e-post til dem med bestemte intervaller. Brukerne kan opprette flere varianter av en rapport og lagre dem som navngitte rapporter, f')
||'or enten offentlig eller privat visning. ',
'<p/>',
unistr('De f\00F8lgende avsnittene oppsummerer hvordan du kan tilpasse en interaktiv rapport. Hvis du vil l\00E6re mer, kan du se Using Interactive Reports i <i>Oracle Application Express End User''s Guide</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113470286912400961)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'no'
,p_message_text=>unistr('Menyen Handlinger vises til h\00F8yre for knappen S\00F8k p\00E5 s\00F8kelinjen. Bruk denne menyen til \00E5 tilpasse en interaktiv rapport.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113463979367400957)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Aggregeringer er matematiske beregninger som er utf\00F8rt mot en kolonne. Aggregeringer vises etter hvert kontrollskift og p\00E5 slutten av rapporten i kolonnen der de er definert. Valgene omfatter f\00F8lgende:'),
'<p>',
'</p><ul>',
'<li>Med <strong>Aggregering</strong> kan du velge en tidligere',
'definert aggregering du vil redigere.</li>',
unistr('<li><strong>Funksjon</strong> er funksjonen som skal utf\00F8res (for eksempel SUM, MIN).</li>'),
unistr('<li><strong>Kolonne</strong> brukes til \00E5 velge kolonnen den matematiske funksjonen skal brukes p\00E5. Bare numeriske'),
'kolonner vises.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113464094320400957)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Du kan definere ett diagram per lagret rapport. N\00E5r dette er'),
unistr('definert, kan du veksle mellom diagram- og rapportvisning ved hjelp av visningsikonene p\00E5 s\00F8kelinjen.'),
unistr('Valgene omfatter f\00F8lgende:  '),
'<p>',
'</p><ul>',
'<li><strong>Diagramtype</strong> identifiserer diagramtypen som skal inkluderes.',
'Velg mellom vannrett stolpe, loddrett stolpe, sektor eller linje.</li>',
'<li>Med <strong>Etikett</strong> kan du velge kolonnen som skal brukes som etikett.</li>',
unistr('<li><strong>Aksetittel for etikett</strong> er tittelen som vises p\00E5 aksen som er knyttet til kolonnen som er valgt for'),
'etiketten. Dette er ikke tilgjengelig for et sektordiagram.</li>',
'<li>Med <strong>Verdi</strong> kan du velge kolonnen som skal brukes som verdi. Hvis funksjonen',
unistr('er COUNT, trenger du ikke \00E5 velge en verdi.</li>'),
unistr('<li><strong>Aksetittel for verdi</strong> er tittelen som vises p\00E5 aksen som er knyttet til kolonnen som er valgt for'),
'verdien. Dette er ikke tilgjengelig for et sektordiagram.</li>',
unistr('<li><strong>Funksjon</strong> er en valgfri funksjon som skal utf\00F8res p\00E5 kolonnen som er valgt for verdien.</li>'),
'<li>Med <strong>Sorter</strong> kan du sortere resultatsettet.</li></ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113463373075400956)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Hvis du klikker p\00E5 en hvilken som helst kolonneoverskrift, vises en kolonneoverskriftsmeny. Valgene omfatter f\00F8lgende:'),
'<p></p>',
'<ul>',
unistr('<li>Ikonet <strong>Sorter stigende</strong> sorterer rapporten etter kolonnen i stigende rekkef\00F8lge.</li>'),
unistr('<li>Ikonet <strong>Sorter synkende</strong> sorterer rapporten etter kolonnen i synkende rekkef\00F8lge.</li>'),
'<li><strong>Skjul kolonne</strong> skjuler kolonnen. Ikke alle kolonner kan skjules. Hvis en kolonne ikke kan skjules, finnes det ikke noe Skjul kolonne-ikon.</li>',
unistr('<li><strong>Bryt kolonne</strong> oppretter en bruddgruppe p\00E5 kolonnen. Kolonnen trekkes ut av rapporten som en hovedpost.</li>'),
'<li><strong>Kolonneopplysninger</strong> viser hjelpetekst om kolonnen, hvis tilgjengelig.</li>',
unistr('<li><strong>Tekstomr\00E5de</strong> brukes til \00E5 angi s\00F8kekriterier som ikke skiller mellom sm\00E5 og store bokstaver'),
'(ikke behov for jokertegn). Hvis du angir en verdi, reduseres listen over',
'verdier nederst i menyen. Du kan da velge en verdi fra',
'bunnen, og den valgte verdien blir opprettet som et filter ved hjelp av =',
unistr('(for eksempel <code>column = ''ABC''</code>). Du kan ogs\00E5 klikke p\00E5 lommelyktikonet og angi en verdi som skal opprettes som et filter med modifikatoren LIKE'),
'(for eksempel <code>column LIKE ''%ABC%''</code>).</li>',
unistr('<li><b>Liste over unike verdier</b> inneholder de f\00F8rste 500 unike'),
'verdiene som oppfyller filterkriteriene. Hvis det er en datokolonne, vises en liste over datointervaller',
'i stedet. Hvis du velger en verdi, blir det opprettet et filter',
'ved hjelp av = (for eksempel <code>column = ''ABC''</code>).</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113463871008400957)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Gj\00F8r at du kan legge til beregnede kolonner i rapporten. Disse kan v\00E6re matematiske beregninger (for eksempel <code>NBR_HOURS/24</code>) eller standard'),
unistr('Oracle-funksjoner som er brukt p\00E5 eksisterende kolonner. Noen vises som eksempler, og andre (som <code>TO_DATE)</code> kan ogs\00E5 brukes. Valgene omfatter f\00F8lgende:'),
'<p></p>',
'<ul>',
'<li>Med <strong>Beregning</strong> kan du velge en tidligere definert beregning du vil redigere.</li>',
'<li><strong>Kolonneoverskrift</strong> er kolonneoverskriften for den nye kolonnen.</li>',
'<li><strong>Formatmaske</strong> er en Oracle-formatmaske som kan brukes mot kolonnen (for eksempel S9999).</li>',
unistr('<li><strong>Beregning</strong> er beregningen som skal utf\00F8res. I beregningen refereres det til kolonner ved hjelp av de viste aliasene.</li>'),
'</ul>',
unistr('<p>Under Beregning vises kolonnene i sp\00F8rringen med tilknyttede'),
unistr('aliaser. Hvis du klikker p\00E5 kolonnenavnet eller aliaset, inkluderes de'),
'i beregningen. Ved siden av Kolonner vises et tastatur. Dette tastaturet fungerer som',
unistr('en snarvei til taster som brukes ofte. Lengst til h\00F8yre ser du Funksjoner.</p>'),
unistr('<p>F\00F8lgende eksempel p\00E5 beregning viser hvordan total kompensasjon skal vises:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
'(der A er ORGANIZATION, B er SALARY og C er COMMISSION)</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113470311747400961)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'no'
,p_message_text=>unistr('Brukes til \00E5 opprette en bruddgruppe i \00E9n eller flere kolonner. Kolonnene trekkes ut av den interaktive rapporten og vises som en hovedpost.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113464540425400957)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'no'
,p_message_text=>unistr('Hvis du vil vise detaljene for en enkelt rad om gangen, klikker du p\00E5 ikonet for enkeltradvisning i raden du vil vise. Hvis den er tilgjengelig, er enkeltradvisningen alltid f\00F8rste kolonne. Avhengig av tilpasningen av den interaktive rapporten kan en')
||unistr('keltradvisningen v\00E6re standardvisningen eller en egendefinert side som kan tillate oppdatering.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113464402514400957)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Gj\00F8r at det gjeldende resultatsettet kan lastes ned. Nedlastingsformatene'),
'er forskjellige avhengig av installasjonen og rapportdefinisjonen, men',
'de omfatter CSV, HTML, E-post, XLS, PDF og RTF.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113463599465400956)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Fokuserer rapporten ved \00E5 legge til eller endre <code>WHERE</code>-leddet i sp\00F8rringen. Du kan filtrere p\00E5 en kolonne eller etter rad. '),
unistr('<p>Hvis du filtrerer etter kolonne, velger du en kolonne (det trenger ikke \00E5 v\00E6re'),
unistr('den som vises), velger en standard Oracle-operator (=, !=, not in, between) og angir et uttrykk for sammenligning. Det skilles mellom sm\00E5 og store bokstaver i uttrykk. Bruk % som jokertegn (for eksempel <code>STATE_NAME'),
'som A%)</code>.</p>',
'<p>Hvis du filtrerer etter rad, kan du opprette komplekse <code>WHERE</code>-ledd ved hjelp av',
'kolonnealiaser og hvilke som helst Oracle-funksjoner eller -operatorer (for eksempel <code>G = ''VA'' eller G = ''CT''</code>, der',
'<code>G</code> er alias for <code>CUSTOMER_STATE</code>).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113464118994400957)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Med en flashback-sp\00F8rring kan du vise data slik de var p\00E5 et tidligere'),
'tidspunkt. Standardtiden i en flashback er 3 timer (eller 180',
'minutter), men den faktiske tiden er forskjellig for hver database.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113525334995401002)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Med Formater kan du tilpasse visningen av rapporten.',
unistr('Formater inneholder f\00F8lgende undermeny:</p>'),
'<ul><li>Sorter</li>',
'<li>Kontrollskift</li>',
'<li>Uthev</li>',
'<li>Beregn</li>',
'<li>Aggreger</li>',
'<li>Diagram</li>',
'<li>Grupper etter</li>',
'<li>Pivoter</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113523568806401001)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Du kan definere \00E9n Grupper etter-visning per lagret'),
unistr('rapport. N\00E5r den er definert, kan du veksle mellom Grupper etter- og rapportvisningen'),
unistr('ved hjelp av visningsikoner p\00E5 s\00F8kelinjen. N\00E5r du skal opprette en Grupper etter-visning, velger du'),
'<p></p>',
'<ul>',
'<li>kolonnene du vil gruppere i</li>',
unistr('<li>kolonnene som skal aggregeres, sammen med funksjonen som skal utf\00F8res (gjennomsnitt, sum, antall osv.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113463720225400957)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Gj\00F8r at du kan definere et filter. Radene som oppfyller filterkriteriene, vises som uthevet med kjennetegnene som er knyttet til filteret. Valgene omfatter f\00F8lgende:</p>'),
'<ul>',
'<li><strong>Navn</strong> brukes bare til visning.</li>',
unistr('<li><strong>Rekkef\00F8lge</strong> identifiserer rekkef\00F8lgen som reglene evalueres i.</li>'),
'<li><strong>Aktivert</strong> identifiserer om en regel er aktivert eller deaktivert.</li>',
unistr('<li><strong>Uthevingstype</strong> identifiserer om raden eller cellen skal v\00E6re'),
'uthevet. Hvis Celle er valgt, utheves kolonnen det refereres til i',
'Betingelse for utheving.</li>',
unistr('<li><strong>Bakgrunnsfarge</strong> er den nye fargen for bakgrunnen til det uthevede omr\00E5det.</li>'),
unistr('<li><strong>Tekstfarge</strong> er den nye fargen for teksten i det uthevede omr\00E5det.</li>'),
'<li><strong>Betingelse for utheving</strong> definerer filterbetingelsen.</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113401375787400911)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Du kan definere \00E9n pivotvisning per lagret rapport. N\00E5r den er definert, kan du veksle mellom pivot- og rapportvisningen ved hjelp av visningsikoner p\00E5 s\00F8kelinjen. N\00E5r du skal opprette en pivotvisning, velger du '),
'<p></p>',
'<ul>',
'<li>kolonnene du vil pivotere i</li>',
'<li>kolonnene som skal vises som rader</li>',
unistr('<li>kolonnene som skal aggregeres, sammen med funksjonen som skal utf\00F8res (gjennomsnitt, sum, antall osv.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113474807289400965)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hvis du tilpasser en interaktiv rapport, vises rapportinnstillingene under',
unistr('s\00F8kelinjen og over rapporten. Dette omr\00E5det kan trekkes sammen og utvides ved hjelp av ikonet til venstre.'),
'<p>',
unistr('For hver rapportinnstilling kan du gj\00F8re f\00F8lgende:'),
'</p><ul>',
unistr('<li>Redigere en innstilling ved \00E5 klikke p\00E5 navnet.</li>'),
unistr('<li>Deaktivere/aktivere en innstilling ved \00E5 merke av eller fjerne merket i avmerkingsboksen Aktiver/Deaktiver. Bruk denne kontrollen til \00E5 sl\00E5 en innstilling midlertidig av og p\00E5.</li>'),
unistr('<li>Fjerne en innstilling ved \00E5 klikke p\00E5 ikonet Fjern.</li>'),
'</ul>',
'<p>Hvis du har opprettet et diagram, en gruppering eller en pivotering, kan du veksle mellom dem',
'og basisrapporten ved hjelp av koblingene for Rapport-, Diagram-, Grupper etter- og Pivot-visningen',
unistr('som vises til h\00F8yre. Hvis du viser diagrammet, grupperingen eller pivoteringen, kan du'),
unistr('ogs\00E5 redigere innstillingene ved hjelp av redigeringskoblingen.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113464393476400957)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'no'
,p_message_text=>'Tilbakestiller rapporten til standardinnstillingene og fjerner alle tilpasninger du har gjort.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113525641843401003)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'no'
,p_message_text=>'Angir antall poster som skal vises per side.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113464261867400957)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Lagrer den tilpassede rapporten for fremtidig bruk. Du angir et navn og en valgfri beskrivelse, og du kan gj\00F8re rapporten offentlig tilgjengelig (det vil si for alle brukere som har tilgang til den prim\00E6re standardrapporten). Du kan lagre fire typ')
||'er interaktive rapporter:</p>',
'<ul>',
unistr('<li><strong>Prim\00E6r standard</strong> (bare utviklere). Prim\00E6r standard er rapporten som vises f\00F8rst. Det er ikke mulig \00E5 gi nytt navn til eller slette rapporter av typen Prim\00E6r standard.</li>'),
unistr('<li><strong>Alternativ rapport</strong> (bare utviklere). Gj\00F8r det mulig for utviklere \00E5 opprette flere rapportoppsett. Bare utviklere kan lagre, gi nytt navn til eller slette en alternativ rapport.</li>'),
unistr('<li><strong>Offentlig rapport</strong> (sluttbrukere). Kan lagres, f\00E5 nytt navn eller slettes av sluttbrukeren som opprettet den. Andre brukere kan vise og lagre oppsettet som en annen rapport.</li>'),
'<li><strong>Privat rapport</strong> (sluttbrukere). Bare sluttbrukeren som opprettet rapporten, kan vise, lagre, gi nytt navn til eller slette rapporten.</li>',
'</ul>',
unistr('<p>Hvis du lagrer tilpassede rapporter, vises en rapportvelger p\00E5 s\00F8kelinjen til venstre for radvelgeren (hvis denne funksjonen er aktivert).</p>'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113463260072400956)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'no'
,p_message_text=>unistr('\00D8verst p\00E5 hver rapportside finnes et s\00F8keomr\00E5de. Dette omr\00E5det (eller s\00F8kelinjen) har f\00F8lgende funksjoner:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113526292597401003)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'no'
,p_message_text=>unistr('<li>Med menyen <strong>Handlinger</strong> kan du tilpasse en rapport. Se f\00F8lgende avsnitt.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113525774748401003)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'no'
,p_message_text=>unistr('<li>Med ikonet <strong>Velg kolonner</strong> kan du identifisere hvilken kolonne det skal s\00F8kes i (eller alle).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113526062448401003)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'no'
,p_message_text=>'<li><strong>Rapporter</strong> viser alternativ standard og lagrede private eller offentlige rapporter.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113525918856401003)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'no'
,p_message_text=>'<li><strong>Rader</strong> angir antall poster som skal vises per side.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113525861072401003)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li>Med <strong>Tekstomr\00E5de</strong> kan du angi s\00F8kekriterier som ikke skiller mellom sm\00E5 og store bokstaver (jokertegn er underforst\00E5tt).</li>'),
unistr('S\00F8ket startes med <li>knappen <strong>S\00F8k</strong>. Hvis du trykker p\00E5 Enter, blir s\00F8ket ogs\00E5 utf\00F8rt n\00E5r mark\00F8ren er i s\00F8ketekstomr\00E5det.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113526120980401003)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'no'
,p_message_text=>'<li><strong>Visningsikoner</strong> bytter mellom ikon-, rapport-, detalj-, diagram-, Grupper etter- og pivotvisningen av rapporten, hvis definert.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113542155071401015)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'no'
,p_message_text=>'<li>Med <strong>Administrer</strong> kan du administrere egenskapene, kolonnene, radene og visningshistorikken for rapporten eller datarutenettet.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113463467153400956)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'no'
,p_message_text=>unistr('Brukes til \00E5 endre de viste kolonnene. Kolonnene til h\00F8yre vises. Kolonnene til venstre er skjult. Du kan endre rekkef\00F8lgen p\00E5 de viste kolonnene ved hjelp av pilene lengst til h\00F8yre. Beregnede kolonner f\00E5r prefikset <strong>**</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113463648060400957)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Brukes til \00E5 endre kolonnene det skal sorteres etter, og bestemmer om'),
unistr('det skal sorteres i stigende eller synkende rekkef\00F8lge. Du kan ogs\00E5 angi hvordan du vil h\00E5ndtere'),
unistr('<code>NULL</code>-verdier. Med standardinnstillingen vises alltid <code>NULL</code>-verdier sist, eller de kan vises alltid f\00F8rst. Den resulterende sorteringsrekkef\00F8lgen'),
unistr('vises til h\00F8yre for kolonneoverskriftene i rapporten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113523315407401001)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'no'
,p_message_text=>unistr('N\00E5r du legger til et abonnement, angir du en e-postadresse (eller flere e-postadresser adskilt med komma), et e-postemne, hyppighet og start- og sluttdato. De resulterende e-postene omfatter en HTML-versjon av den interaktive rapporten som inneholder')
||' de gjeldende dataene med rapportinnstillingen som fantes da abonnementet ble lagt til.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113541933141401015)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Datarutenett er redigerbare rapporter som er sv\00E6rt tilpassbare. Brukerne kan endre oppsettet for rapportdata ved \00E5 velge kolonner, bruke filtre, utheve og sortere. Brukerne kan ogs\00E5 definere skift, aggregeringer, diagrammer og grupperinger og legge t')
||'il egne beregninger. Brukerne kan opprette flere varianter av en rapport og lagre dem som navngitte rapporter for privat visning. ',
'<p/>',
unistr('Et datarutenett kan tilpasses ved hjelp av s\00F8kelinjen, menyen Handlinger, menyen Administrer eller menyen Kolonneoverskrift.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113553728083401023)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'no'
,p_message_text=>unistr('Menyen Handlinger vises til h\00F8yre for knappen S\00F8k p\00E5 s\00F8kelinjen. Bruk denne menyen til \00E5 tilpasse en datarutenettrapport.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113542444930401015)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'no'
,p_message_text=>'Siden Legg til rad / Rediger rad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113542549452401015)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Hvis du vil legge til en rad i datarutenettet, klikker du p\00E5 Legg til rad. Hvis du vil redigere detaljene for en rad, klikker du p\00E5 ikonet Rediger rad (f\00F8rste kolonne) i raden du vil redigere. Siden Legg til rad / Rediger rad vises. Den viser kolo')
||'nnene i datarutenettet. </p>',
'',
unistr('<p>N\00E5r du redigerer en rad, kan du gj\00F8re f\00F8lgende:</p>'),
'',
'<p><ul>',
'<li><strong>Slette</strong> raden.</li>',
unistr('<li><strong>Bruke endringer</strong> for \00E5 lagre endringene som er gjort i raden.</li>'),
'<li>I <strong>Handlinger</strong> kan du legge til en rad, filer, merknader, koblinger eller koder og se gjennom historikken.</li>',
'<li>Navigere til radene <strong>Neste og Forrige</strong>.</li>',
'<li>I <strong>Administrer</strong> kan du angi kolonneegenskaper, kolonnegrupper, valideringer og verdilister.</li>',
'</ul></p>',
'',
unistr('<p>Omr\00E5det Merknader nederst p\00E5 siden viser filer, merknader, koblinger eller koder som er knyttet til den gjeldende raden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113553876094401024)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'no'
,p_message_text=>unistr('Brukes til \00E5 opprette en bruddgruppe i \00E9n eller flere kolonner. Kolonnene trekkes ut av datarutenettet og vises som en hovedpost.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113542311835401015)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Gj\00F8r at det gjeldende resultatsettet kan lastes ned. Nedlastingsformatene'),
'omfatter CSV, HTML og E-post.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113553961353401024)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hvis du tilpasser en datarutenettrapport, vises rapportinnstillingene under',
unistr('s\00F8kelinjen og over rapporten. Dette omr\00E5det kan trekkes sammen og utvides ved hjelp av ikonet til venstre.'),
'<p>',
unistr('For hver rapportinnstilling kan du gj\00F8re f\00F8lgende:'),
'</p><ul>',
unistr('<li>Redigere en innstilling ved \00E5 klikke p\00E5 navnet.</li>'),
unistr('<li>Deaktivere/aktivere en innstilling ved \00E5 merke av eller fjerne merket i avmerkingsboksen Aktiver/Deaktiver. Bruk denne kontrollen til \00E5 sl\00E5 en innstilling midlertidig av og p\00E5.</li>'),
unistr('<li>Fjerne en innstilling ved \00E5 klikke p\00E5 ikonet Fjern.</li>'),
'</ul>',
'<p>Hvis du har opprettet et diagram eller en gruppering, kan du veksle mellom dem',
'og basisrapporten ved hjelp av koblingene for Rapport-, Diagram- og Grupper etter-visningen',
unistr('som vises til h\00F8yre. Hvis du viser diagrammet eller grupperingen, kan du'),
unistr('ogs\00E5 bruke redigeringskoblingen til \00E5 redigere innstillingene.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113542257595401015)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Lagrer det tilpassede oppsettet for datarutenettrapporter for fremtidig bruk. Du angir et navn og en valgfri beskrivelse. Du kan lagre tre typer oppsett for datarutenettrapporter:</p>',
'<ul>',
unistr('<li><strong>Prim\00E6r standard</strong> (bare administrator). Prim\00E6r standard er oppsettet som vises f\00F8rst. Det er ikke mulig \00E5 slette eller gi nytt navn til rapporter av typen Prim\00E6r standard.</li>'),
unistr('<li><strong>Alternativ rapport</strong> (bare administrator). Gj\00F8r at administratorer kan opprette flere rapportoppsett. Bare administratorer kan lagre, gi nytt navn til eller slette en alternativ rapport.</li>'),
'<li><strong>Privat rapport</strong> (alle brukere). Brukeren som opprettet rapportoppsettet, kan vise, lagre, gi nytt navn til eller slette rapporten.</li>',
'</ul>',
unistr('<p>Hvis du lagrer tilpassede rapporter, vises det en rapportvelger p\00E5 s\00F8kelinjen til venstre for radvelgeren (hvis denne funksjonen er aktivert).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113468320500400960)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Skjul kolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113458915725400953)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'no'
,p_message_text=>'Uthev'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113469892047400961)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'no'
,p_message_text=>'Uthevinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113474924918400965)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'no'
,p_message_text=>'Betingelse for utheving'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113523913515401001)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'no'
,p_message_text=>'Uthevingsstil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113433940206400935)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'no'
,p_message_text=>'Uthevingstype'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113543457399401016)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'no'
,p_message_text=>'Vannrett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113573056450401038)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'no'
,p_message_text=>'1 inaktiv innstilling'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113573166406401038)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'no'
,p_message_text=>'%0 inaktive innstillinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113464941174400958)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'no'
,p_message_text=>'Hjelp til interaktive rapporter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113475968049400966)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'no'
,p_message_text=>'Ugyldig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113469355862400961)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'no'
,p_message_text=>'Ugyldig beregningsuttrykk. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113428782706400931)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'no'
,p_message_text=>unistr('Sluttdatoen m\00E5 v\00E6re senere enn startdatoen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113483636324400971)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'no'
,p_message_text=>'Ugyldig filteruttrykk. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113551437112401022)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'no'
,p_message_text=>unistr('Ugyldig filtersp\00F8rring')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113573208086401038)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'no'
,p_message_text=>'1 ugyldig innstilling'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113573337609401038)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'no'
,p_message_text=>'%0 ugyldige innstillinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113524141286401001)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'no'
,p_message_text=>'(i minutter)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113541157533401014)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de siste %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113541387134401014)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er i l\00F8pet av de neste %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113541204254401014)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de siste %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113541402718401014)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'no'
,p_message_text=>unistr('%0 er ikke i l\00F8pet av de neste %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113474057986400964)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'no'
,p_message_text=>'Tastatur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113440112928400939)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'no'
,p_message_text=>'Etiketten %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113467993649400960)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'no'
,p_message_text=>'Aksetittel for etikett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113460447279400954)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'no'
,p_message_text=>'Siste dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113460684765400954)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'no'
,p_message_text=>'Siste time'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113460186918400954)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'no'
,p_message_text=>unistr('Siste m\00E5ned')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113460201740400954)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'no'
,p_message_text=>'Siste uke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113460366793400954)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'no'
,p_message_text=>'Siste %0 dager'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113460506922400954)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'no'
,p_message_text=>'Siste %0 timer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113459938567400954)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'no'
,p_message_text=>unistr('Siste %0 \00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113460086296400954)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'no'
,p_message_text=>unistr('Siste \00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113440004881400939)
,p_name=>'APEXIR_LINE'
,p_message_language=>'no'
,p_message_text=>'Linje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113436881421400937)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'no'
,p_message_text=>'Linje med areal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113551385937401022)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'no'
,p_message_text=>unistr('Utf\00F8r tilordning')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113468816808400960)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'no'
,p_message_text=>unistr('Det er estimert at sp\00F8rringen overskrider maksimumsressursene. Endre rapportinnstillingene, og pr\00F8v p\00E5 nytt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113451003353400947)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'no'
,p_message_text=>unistr('Maksimalt antall rader for denne rapporten er %0. Bruk et filter for \00E5 redusere antall poster i sp\00F8rringen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113551944792401022)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'no'
,p_message_text=>'Maksimum - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113552100861401022)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'no'
,p_message_text=>'Median - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113455090755400950)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'no'
,p_message_text=>'%0 minutter siden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113552027809401022)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'no'
,p_message_text=>'Minimum - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113551086167401021)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'no'
,p_message_text=>unistr('M\00E5ned')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113524559517401002)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'no'
,p_message_text=>unistr('M\00E5nedlig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113467176905400959)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'no'
,p_message_text=>'Flytt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113467001443400959)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'no'
,p_message_text=>'Flytt alle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113578205121401042)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('Statisk ID for omr\00E5det m\00E5 angis fordi siden inneholder flere interaktive rapporter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113435599508400936)
,p_name=>'APEXIR_NAME'
,p_message_language=>'no'
,p_message_text=>'Navn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113462970329400956)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'no'
,p_message_text=>'Ny aggregering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113573964850401039)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'no'
,p_message_text=>'Ny kategori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113463026279400956)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'no'
,p_message_text=>'Ny beregning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113457844329400952)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'no'
,p_message_text=>'Neste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113460961929400954)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'no'
,p_message_text=>'Neste dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113460714875400954)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'no'
,p_message_text=>'Neste time'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113461299845400955)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'no'
,p_message_text=>unistr('Neste m\00E5ned')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113461179978400955)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'no'
,p_message_text=>'Neste uke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113461089512400954)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'no'
,p_message_text=>'Neste %0 dager'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113460806270400954)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'no'
,p_message_text=>'Neste %0 timer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113461487537400955)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'no'
,p_message_text=>unistr('Neste %0 \00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113461361775400955)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'no'
,p_message_text=>unistr('Neste \00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113435848203400936)
,p_name=>'APEXIR_NO'
,p_message_language=>'no'
,p_message_text=>'Nei'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113476143734400966)
,p_name=>'APEXIR_NONE'
,p_message_language=>'no'
,p_message_text=>'- Ingen -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113523761628401001)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'no'
,p_message_text=>'Ikke en gyldig e-postadresse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113472609348400963)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'no'
,p_message_text=>unistr('Nullverdier alltid f\00F8rst')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113472592798400963)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'no'
,p_message_text=>'Nullverdier alltid sist'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113473002372400963)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'no'
,p_message_text=>'Nullsortering - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113469445080400961)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'no'
,p_message_text=>unistr('Flashback-tiden m\00E5 v\00E6re numerisk.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113469037594400961)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'no'
,p_message_text=>unistr('Rekkef\00F8lgen m\00E5 v\00E6re numerisk.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113473596080400964)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'no'
,p_message_text=>'Operator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113434471204400935)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'no'
,p_message_text=>'oransje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113543335291401016)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'no'
,p_message_text=>'Retning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113436385770400937)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'no'
,p_message_text=>'Annet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113419199814400924)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'no'
,p_message_text=>'Sideretning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113419857233400924)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'no'
,p_message_text=>'Liggende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113419905447400924)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'no'
,p_message_text=>unistr('St\00E5ende')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113419085355400924)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'no'
,p_message_text=>unistr('Sidest\00F8rrelse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113419633908400924)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'no'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113419542712400924)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'no'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113419703829400924)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'no'
,p_message_text=>'Egendefinert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113419381298400924)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'no'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113419255589400924)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'no'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113419405942400924)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'no'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113552461978401023)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'no'
,p_message_text=>'Prosent av totalt antall - %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113551647057401022)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'no'
,p_message_text=>'Prosent av totalsum %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113550681626401021)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'no'
,p_message_text=>'Prosent av totalt antall'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113550589808401021)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'no'
,p_message_text=>'Prosent av totalsum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113439931370400939)
,p_name=>'APEXIR_PIE'
,p_message_language=>'no'
,p_message_text=>'Sektor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113499894285400983)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'no'
,p_message_text=>'Pivoter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113501342841400984)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'no'
,p_message_text=>unistr('Aggregering m\00E5 angis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113501535224400984)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'no'
,p_message_text=>unistr('Du kan ikke aggregere p\00E5 en kolonne som er valgt som radkolonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113500778344400984)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'no'
,p_message_text=>'Pivotkolonner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113500503408400984)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'no'
,p_message_text=>'Pivotkolonne - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113501123460400984)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'no'
,p_message_text=>unistr('Pivotkolonne m\00E5 angis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113401238409400911)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'no'
,p_message_text=>unistr('Maksimalt antall rader for en pivotsp\00F8rring begrenser antall rader i basissp\00F8rringen, ikke antall viste rader. Basissp\00F8rringen overskrider maksimalt antall rader, som er %0. Bruk et filter for \00E5 redusere antall poster i basissp\00F8rringen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113501055202400984)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'no'
,p_message_text=>'Pivotsortering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113470447251400962)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'no'
,p_message_text=>'Pivotkolonnen inneholder for mange unike verdier - kan ikke generere pivot-SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113523837996401001)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'no'
,p_message_text=>unistr('Forh\00E5ndsvis')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113457929037400952)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'no'
,p_message_text=>'Forrige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113549577046401020)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'no'
,p_message_text=>unistr('Prim\00E6r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113524854136401002)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'no'
,p_message_text=>unistr('Prim\00E6r rapport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113418963240400924)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'no'
,p_message_text=>'Inkluder tilgjengelighetskoder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113405820960400914)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'no'
,p_message_text=>'Fjern rik tekst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113482691195400971)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'no'
,p_message_text=>'Privat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113440559615400940)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'no'
,p_message_text=>'Offentlig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113436134789400936)
,p_name=>'APEXIR_RED'
,p_message_language=>'no'
,p_message_text=>unistr('r\00F8d')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113578183835401042)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>unistr('Den statiske ID-en %0 for omr\00E5det finnes ikke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113467227539400959)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'no'
,p_message_text=>'Fjern'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113467319718400959)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'no'
,p_message_text=>'Fjern alle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113573486424401038)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'no'
,p_message_text=>'Fjern diagram'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113466813165400959)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'no'
,p_message_text=>'Fjern kontrollskift'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113466530834400959)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'no'
,p_message_text=>'Fjern filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113466623375400959)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'no'
,p_message_text=>'Fjern flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113573574529401038)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'no'
,p_message_text=>'Fjern Grupper etter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113466949292400959)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'no'
,p_message_text=>'Fjern utheving'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113573624147401038)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'no'
,p_message_text=>'Fjern pivotering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113554635722401024)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'no'
,p_message_text=>'Fjern rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113535283939401010)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'no'
,p_message_text=>'Gi nytt navn til standardrapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113476413408400966)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'no'
,p_message_text=>'Gi nytt navn til rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113458295740400952)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'no'
,p_message_text=>'Rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113552590929401023)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'no'
,p_message_text=>'Rapporter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113432701661400934)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Lagret interaktiv rapport med aliaset %0 finnes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113482914176400971)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Rapporten finnes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113432875630400934)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'ID-en %0 for lagret interaktiv rapport finnes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113474742307400965)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'no'
,p_message_text=>'Rapportinnstillinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113455500011400950)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'no'
,p_message_text=>'Rapportvisning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113459463125400953)
,p_name=>'APEXIR_RESET'
,p_message_language=>'no'
,p_message_text=>'Tilbakestill'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113440771689400940)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'no'
,p_message_text=>'Gjenopprett rapporten til standardinnstillingene.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113435973787400936)
,p_name=>'APEXIR_ROW'
,p_message_language=>'no'
,p_message_text=>'Rad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113548641097401020)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'no'
,p_message_text=>unistr('Du kan ikke bruke ROWID som prim\00E6rn\00F8kkelkolonne for en REST-datakilde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113465958020400958)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'no'
,p_message_text=>'Rader'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113525558117401002)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'no'
,p_message_text=>'Rader per side'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113500806176400984)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'no'
,p_message_text=>'Radkolonner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113500692935400984)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'no'
,p_message_text=>'Radkolonne - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113501272127400984)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'no'
,p_message_text=>unistr('Radkolonne m\00E5 angis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113501458537400984)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'no'
,p_message_text=>unistr('Radkolonnen m\00E5 v\00E6re forskjellig fra pivotkolonnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113480050874400969)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'no'
,p_message_text=>'Radfilter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113455659975400951)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'no'
,p_message_text=>'Rad %0 av %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113459618819400953)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'no'
,p_message_text=>'Radteksten inneholder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113435262744400936)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'no'
,p_message_text=>'Lagre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113470015237400961)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'no'
,p_message_text=>'Lagret rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113469992932400961)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'no'
,p_message_text=>'Lagret rapport = %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113472114244400963)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'no'
,p_message_text=>'De gjeldende rapportinnstillingene blir brukt som standard for alle brukere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113535156288401010)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'no'
,p_message_text=>'Lagre standardrapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113459305861400953)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'no'
,p_message_text=>'Lagre rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113573820985401039)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'no'
,p_message_text=>'Lagre rapport *'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113526573896401003)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113464899275400957)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8kelinje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113573722613401038)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k etter: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113532007831401007)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8kerapport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113516058156400995)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'no'
,p_message_text=>'Valgte kolonner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113436969135400937)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'no'
,p_message_text=>'- Velg kolonne -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113458680309400953)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'no'
,p_message_text=>'Velg kolonner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113440468849400940)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'no'
,p_message_text=>'- Velg funksjon -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113465654371400958)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'no'
,p_message_text=>'- Velg Grupper etter-kolonne -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113500359519400984)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'no'
,p_message_text=>'- Velg pivotkolonne -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113551571064401022)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'no'
,p_message_text=>'Velg rad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113500468052400984)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'no'
,p_message_text=>'- Velg radkolonne -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113409115231400917)
,p_name=>'APEXIR_SEND'
,p_message_language=>'no'
,p_message_text=>'Send'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113415428017400921)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'no'
,p_message_text=>'Send som e-post'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113435634787400936)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'no'
,p_message_text=>unistr('Rekkef\00F8lge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113458812535400953)
,p_name=>'APEXIR_SORT'
,p_message_language=>'no'
,p_message_text=>'Sorter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113468141580400960)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'no'
,p_message_text=>'Sorter stigende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113468226628400960)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'no'
,p_message_text=>'Sorter synkende'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113554089596401024)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'no'
,p_message_text=>unistr('Sorteringsrekkef\00F8lge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113462678041400956)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'no'
,p_message_text=>'mellomrom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113473799303400964)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'no'
,p_message_text=>'Status - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113524202934401002)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'no'
,p_message_text=>'Abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113550925780401021)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'no'
,p_message_text=>'Slutter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113405374405400914)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'no'
,p_message_text=>'Hopp over hvis ingen data blir funnet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113550867661401021)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'no'
,p_message_text=>'Starter fra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113551741101401022)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'no'
,p_message_text=>'Sum - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113541782408401014)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'no'
,p_message_text=>unistr('Omr\00E5de = %0, Rapport = %1, Visning = %2, Start for viste rader = %3, Slutt for viste rader = %4, Totalt antall rader = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113462382748400955)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'no'
,p_message_text=>unistr('Omr\00E5de = %0, Rapport = %1, Visning = %2, Start for viste rader = %3, Slutt for viste rader = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113434518132400935)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'no'
,p_message_text=>'Tekstfarge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113451650892400948)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'no'
,p_message_text=>'dager'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113451558836400948)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'no'
,p_message_text=>'timer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113451446266400948)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'no'
,p_message_text=>'minutter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113451820748400948)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'no'
,p_message_text=>unistr('m\00E5neder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113451761935400948)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'no'
,p_message_text=>'uker'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113451950508400948)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'no'
,p_message_text=>unistr('\00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113554475234401024)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'no'
,p_message_text=>unistr('Sl\00E5 p\00E5/av')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113467432055400959)
,p_name=>'APEXIR_TOP'
,p_message_language=>'no'
,p_message_text=>unistr('\00D8verst')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113547697932401019)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Ugruppert kolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113468986104400960)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'no'
,p_message_text=>unistr('Uthevingsnavn m\00E5 v\00E6re unikt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113439294182400939)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'no'
,p_message_text=>unistr('ikke-st\00F8ttet datatype')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113467510164400959)
,p_name=>'APEXIR_UP'
,p_message_language=>'no'
,p_message_text=>'Opp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113469167367400961)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'no'
,p_message_text=>'Angi en gyldig farge.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113469296050400961)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'no'
,p_message_text=>'Angi en gyldig formatmaske.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113436458531400937)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'no'
,p_message_text=>'Verdi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113468035535400960)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'no'
,p_message_text=>'Aksetittel for verdi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113475875177400965)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('N\00F8dvendig verdi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113439898751400939)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'no'
,p_message_text=>'Loddrett kolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113543568625401016)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'no'
,p_message_text=>'Loddrett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113475103337400965)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'no'
,p_message_text=>'Vis diagram'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113530367933401006)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'no'
,p_message_text=>'Vis detaljer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113575910708401040)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Rapporten har ikke %0-visning som er definert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113530403811401006)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'no'
,p_message_text=>'Vis Grupper etter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113530258979401006)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'no'
,p_message_text=>'Visningsikoner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113500193246400983)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'no'
,p_message_text=>'Vis pivotering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113475231517400965)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'no'
,p_message_text=>'Vis rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113524474780401002)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'no'
,p_message_text=>'Ukentlig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113458180744400952)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'no'
,p_message_text=>'Arbeidsrapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113553134242401023)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'no'
,p_message_text=>'%0 dager'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113553031943401023)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'no'
,p_message_text=>'%0 timer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113552943160401023)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'no'
,p_message_text=>'%0 minutter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113553339711401023)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 m\00E5neder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113553296148401023)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'no'
,p_message_text=>'%0 uker'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113553427858401023)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'no'
,p_message_text=>unistr('%0 \00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113551180476401022)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'no'
,p_message_text=>unistr('\00C5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113434250566400935)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'no'
,p_message_text=>'gul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113435771898400936)
,p_name=>'APEXIR_YES'
,p_message_language=>'no'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113467816628400960)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'no'
,p_message_text=>'%0 inneholder < eller >, som er ugyldige tegn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113490601904400976)
,p_name=>'APEX_REGION'
,p_message_language=>'no'
,p_message_text=>unistr('Omr\00E5de')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113418897539400924)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'no'
,p_message_text=>unistr('Brudd p\00E5 API-forh\00E5ndsbetingelse')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113438382250400938)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'no'
,p_message_text=>'Kan ikke hente verdi for applikasjonsinnstillingen %0 fordi tilknyttet byggevalg er deaktivert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113438203532400938)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'no'
,p_message_text=>'Kan ikke angi verdi for applikasjonsinnstillingen %0 fordi tilknyttet byggevalg er deaktivert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113545916817401018)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'no'
,p_message_text=>'Verdien %0 for applikasjonsinnstillingen er ugyldig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113545831976401018)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'no'
,p_message_text=>'Den forespurte applikasjonsinnstillingen, %0, er ikke definert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113546089181401018)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'no'
,p_message_text=>'Applikasjonsinnstillingen %0 kan ikke settes til en nullverdi'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113426981511400929)
,p_name=>'BACK'
,p_message_language=>'no'
,p_message_text=>'Tilbake'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113413947587400920)
,p_name=>'BUILDER'
,p_message_language=>'no'
,p_message_text=>'Bygger'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113478001322400967)
,p_name=>'BUTTON LABEL'
,p_message_language=>'no'
,p_message_text=>'Knappeetikett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113413005656400919)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'no'
,p_message_text=>'CSS-klasser for knapp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113442227508400941)
,p_name=>'BUTTON_ID'
,p_message_language=>'no'
,p_message_text=>'Den genererte knappe-ID-en er enten knappens statiske ID, hvis definert, eller, hvis ikke, en internt generert ID i formatet ''B'' || [intern knappe-ID]'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113405728020400914)
,p_name=>'CANDLESTICK'
,p_message_language=>'no'
,p_message_text=>'Lysestakediagram'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113487207012400974)
,p_name=>'CENTER'
,p_message_language=>'no'
,p_message_text=>'Midtstilt'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113437239930400937)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'no'
,p_message_text=>unistr('Foresp\00F8rsel om %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113428694994400931)
,p_name=>'CHECK$'
,p_message_language=>'no'
,p_message_text=>'radvelger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113547737400401019)
,p_name=>'CHECKED'
,p_message_language=>'no'
,p_message_text=>'avmerket'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113523293897401001)
,p_name=>'COLUMN'
,p_message_language=>'no'
,p_message_text=>'Kolonne'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113483746417400971)
,p_name=>'COMMENTS'
,p_message_language=>'no'
,p_message_text=>'Kommentarer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113465282879400958)
,p_name=>'CONTINUE'
,p_message_language=>'no'
,p_message_text=>'Fortsett'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113427240336400930)
,p_name=>'COPYRIGHT'
,p_message_language=>'no'
,p_message_text=>'Copyright &copy; %0. Med enerett.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113470940091400962)
,p_name=>'COUNT'
,p_message_language=>'no'
,p_message_text=>'Antall'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113477698076400967)
,p_name=>'CREATE'
,p_message_language=>'no'
,p_message_text=>'Opprett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113529991456401006)
,p_name=>'CREATED'
,p_message_language=>'no'
,p_message_text=>'Opprettet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113530046017401006)
,p_name=>'CREATED_BY'
,p_message_language=>'no'
,p_message_text=>'Opprettet av'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113454897449400950)
,p_name=>'CREATED_ON'
,p_message_language=>'no'
,p_message_text=>'Opprettet den'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113465494902400958)
,p_name=>'CUSTOM'
,p_message_language=>'no'
,p_message_text=>'Egendefinert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113476671460400966)
,p_name=>'CUSTOMIZE'
,p_message_language=>'no'
,p_message_text=>'Tilpass'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113478296226400967)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'no'
,p_message_text=>'Sidepreferanser er tilbakestilt for brukeren %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113478366860400967)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'no'
,p_message_text=>'Preferanser er endret for brukeren %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113478109617400967)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'no'
,p_message_text=>'Sidepreferanser er tilbakestilt for brukeren %0.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113441979336400941)
,p_name=>'DAILY'
,p_message_language=>'no'
,p_message_text=>'Daglig'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113413557015400920)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'no'
,p_message_text=>'Den lastede filen er ugyldig, eller den har feil filtype.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113437456717400937)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'no'
,p_message_text=>'Ugyldig XML- eller JSON-velger er brukt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113406701952400915)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'no'
,p_message_text=>unistr('Dataprofil og lastet fil inneholder ikke noen m\00E5ltabellkolonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113492442399400978)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'no'
,p_message_text=>'Finner ingen data i lastet fil.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113492569930400978)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'no'
,p_message_text=>'Finner ingen data i regnearket %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113412335513400919)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'no'
,p_message_text=>'Den angitte filen er ikke en XLSX-fil.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113402702383400912)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'no'
,p_message_text=>unistr('Datalasting er fullf\00F8rt. %0 rader er behandlet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113403964809400913)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'no'
,p_message_text=>unistr('Datalasting er fullf\00F8rt. %0 rader er behandlet med 1 feil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113404282490400913)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'no'
,p_message_text=>unistr('Datalasting er fullf\00F8rt. %0 rader er behandlet med %1 feil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113404019689400913)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'no'
,p_message_text=>unistr('Datalasting er fullf\00F8rt. 1 rad er behandlet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113407087204400915)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'no'
,p_message_text=>unistr('Datalasting er fullf\00F8rt. 1 rad er behandlet med feil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113404170222400913)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'no'
,p_message_text=>unistr('Datalasting er fullf\00F8rt. 1 rad er behandlet uten feil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113497726888400982)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'no'
,p_message_text=>unistr('M\00E5lkolonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113497871090400982)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'no'
,p_message_text=>'Kildekolonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113498656010400982)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'no'
,p_message_text=>'Dato- /tallformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113562061254401030)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'no'
,p_message_text=>'Kan ikke hente oppslagsverdien.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113530596524401006)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'no'
,p_message_text=>'Data-/tabelltilordning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113498754441400982)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'no'
,p_message_text=>'Rad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113494293458400979)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'no'
,p_message_text=>'Transformeringsregelen mislyktes'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113470522039400962)
,p_name=>'DATE'
,p_message_language=>'no'
,p_message_text=>'Dato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113444642122400943)
,p_name=>'DAY'
,p_message_language=>'no'
,p_message_text=>'dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113444765312400943)
,p_name=>'DAYS'
,p_message_language=>'no'
,p_message_text=>'dager'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113483417909400971)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'no'
,p_message_text=>'Feilleting er ikke aktivert for denne applikasjonen.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113532274538401007)
,p_name=>'DEFAULT'
,p_message_language=>'no'
,p_message_text=>'Standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113445419584400943)
,p_name=>'DELETE'
,p_message_language=>'no'
,p_message_text=>'slett'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113405611463400914)
,p_name=>'DIAL_PCT'
,p_message_language=>'no'
,p_message_text=>'Skive (prosent)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113420106643400924)
,p_name=>'DOWNLOAD'
,p_message_language=>'no'
,p_message_text=>'Last ned'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113531314012401007)
,p_name=>'DUP_USER'
,p_message_language=>'no'
,p_message_text=>'Duplisert brukernavn i listen.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113427766171400930)
,p_name=>'EDIT'
,p_message_language=>'no'
,p_message_text=>'Rediger'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113437169860400937)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'no'
,p_message_text=>'Finner ikke e-postadressen %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113422219382400926)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'no'
,p_message_text=>'Denne e-posten er sendt av %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113531544110401007)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'no'
,p_message_text=>'E-postadressen er for lang. Grensen er 240 tegn.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113465137559400958)
,p_name=>'ERROR'
,p_message_language=>'no'
,p_message_text=>'Feil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113494305829400979)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'no'
,p_message_text=>unistr('Kan ikke angi kildeverdi for sideelement for et bestemt sideoppfriskingsomr\00E5de')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113456655098400951)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'no'
,p_message_text=>'Opprettet av'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113422548608400926)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'no'
,p_message_text=>unistr('Passordet er utl\00F8pt')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113416677653400922)
,p_name=>'FILE_EMPTY'
,p_message_language=>'no'
,p_message_text=>'Filen er tom.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113496836762400981)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'no'
,p_message_text=>unistr('St\00F8rrelsen p\00E5 den lastede filen var over %0 MB. Last en mindre fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113424603722400928)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Brukerautentisering mislyktes, og \00E9n eller flere filer er ikke lastet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113424745034400928)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'no'
,p_message_text=>'Denne forekomsten tillater ikke at uautentiserte brukere laster filer.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113477756337400967)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Det har oppst\00E5tt 1 feil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113476998252400966)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Det har oppst\00E5tt %0 feil')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113427135081400930)
,p_name=>'FORM_OF'
,p_message_language=>'no'
,p_message_text=>'%0 av %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113461854734400955)
,p_name=>'GO'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113561676905401030)
,p_name=>'HELP'
,p_message_language=>'no'
,p_message_text=>'Hjelp'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113414011175400920)
,p_name=>'HOME'
,p_message_language=>'no'
,p_message_text=>'Start'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113444451558400942)
,p_name=>'HOUR'
,p_message_language=>'no'
,p_message_text=>'time'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113444559674400943)
,p_name=>'HOURS'
,p_message_language=>'no'
,p_message_text=>'timer'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113428515273400931)
,p_name=>'ICON'
,p_message_language=>'no'
,p_message_text=>'Ikonet %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113478504507400967)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'no'
,p_message_text=>unistr('Ugyldige p\00E5loggingsopplysninger')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113578097937401042)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'no'
,p_message_text=>'Ugyldig verdi for parameteren: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113473286282400964)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'no'
,p_message_text=>'Som standardrapportinnstillinger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113473393780400964)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'no'
,p_message_text=>'Som navngitt rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113455773178400951)
,p_name=>'IR_ERROR'
,p_message_language=>'no'
,p_message_text=>'%0-feil. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113455487791400950)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'no'
,p_message_text=>'Kan ikke beregne skjermbildenavigering. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113433027397400934)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'no'
,p_message_text=>'Finner ikke interaktiv rapport.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113432412530400933)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>unistr('Omr\00E5de for interaktiv rapport finnes ikke i applikasjonen %0, side %1 og omr\00E5det %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113473144400400964)
,p_name=>'IR_STAR'
,p_message_language=>'no'
,p_message_text=>'Vises bare for utviklere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113461507925400955)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Rapportsp\00F8rringen m\00E5 ha en unik n\00F8kkel for identifikasjon av hver rad. Den angitte n\00F8kkelen kan ikke brukes til denne sp\00F8rringen. Definer en kolonne for unik n\00F8kkel. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113461601191400955)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'no'
,p_message_text=>unistr('Rapportsp\00F8rringen m\00E5 ha en unik n\00F8kkel for identifikasjon av hver rad. Den angitte n\00F8kkelen kan ikke brukes til denne sp\00F8rringen. Rediger rapportattributtene slik at du definerer en kolonne for unik n\00F8kkel. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113498911906400982)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'no'
,p_message_text=>'Velg fil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113498832622400982)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'no'
,p_message_text=>'Dra filen og slipp den her eller'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113427487293400930)
,p_name=>'ITEMS'
,p_message_language=>'no'
,p_message_text=>'Elementer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113456890274400951)
,p_name=>'ITEM_VALUE'
,p_message_language=>'no'
,p_message_text=>'Elementverdi'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113471232612400962)
,p_name=>'LABEL'
,p_message_language=>'no'
,p_message_text=>'Etikett'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113483310968400971)
,p_name=>'LANGUAGE'
,p_message_language=>'no'
,p_message_text=>unistr('Spr\00E5k')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113445143683400943)
,p_name=>'LAST'
,p_message_language=>'no'
,p_message_text=>'siste'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113424553904400928)
,p_name=>'LENGTH'
,p_message_language=>'no'
,p_message_text=>'Lengde'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113477882769400967)
,p_name=>'LOGIN'
,p_message_language=>'no'
,p_message_text=>unistr('Logg p\00E5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113516420290400996)
,p_name=>'MANAGE'
,p_message_language=>'no'
,p_message_text=>'Administrer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113581060736401044)
,p_name=>'MAXIMIZE'
,p_message_language=>'no'
,p_message_text=>'Maksimer'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113444262103400942)
,p_name=>'MINUTE'
,p_message_language=>'no'
,p_message_text=>'minutt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113444347954400942)
,p_name=>'MINUTES'
,p_message_language=>'no'
,p_message_text=>'minutter'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113531776681401007)
,p_name=>'MISSING_AT'
,p_message_language=>'no'
,p_message_text=>'Mangler "@" i e-postadressen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113531924271401007)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'no'
,p_message_text=>'Advarsel: Det er ikke definert noen mal for dialogbokssider for dialogbokssiden %0 i applikasjonen %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113531651737401007)
,p_name=>'MISSING_DOT'
,p_message_language=>'no'
,p_message_text=>'Mangler "." i e-postadressedomenet.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113480807421400969)
,p_name=>'MODULE'
,p_message_language=>'no'
,p_message_text=>'Modul'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113437921459400938)
,p_name=>'MONTH'
,p_message_language=>'no'
,p_message_text=>unistr('M\00E5ned')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113441784697400941)
,p_name=>'MONTHLY'
,p_message_language=>'no'
,p_message_text=>unistr('M\00E5nedlig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113438054328400938)
,p_name=>'MONTHS'
,p_message_language=>'no'
,p_message_text=>unistr('m\00E5neder')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113470839079400962)
,p_name=>'MOVE'
,p_message_language=>'no'
,p_message_text=>'Flytt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113538304505401012)
,p_name=>'MOVE_FROM'
,p_message_language=>'no'
,p_message_text=>'Flytt fra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113538456616401012)
,p_name=>'MOVE_TO'
,p_message_language=>'no'
,p_message_text=>'Flytt til'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113458084245400952)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'no'
,p_message_text=>'Feil i sletteoperasjon for flere rader: rad = %0, %1, %2'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113457006715400952)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'no'
,p_message_text=>unistr('Kan ikke v\00E6re offentlig bruker')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113414274731400920)
,p_name=>'NAME'
,p_message_language=>'no'
,p_message_text=>'Navn'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113471045190400962)
,p_name=>'NEW'
,p_message_language=>'no'
,p_message_text=>'Ny(tt)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113437721963400938)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'no'
,p_message_text=>unistr('Du kan logge p\00E5 %0 ved \00E5 g\00E5 til:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113437805997400938)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'no'
,p_message_text=>'Varsling om ny %0-konto'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113561898526401030)
,p_name=>'NEXT'
,p_message_language=>'no'
,p_message_text=>'Neste'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113480735614400969)
,p_name=>'NO'
,p_message_language=>'no'
,p_message_text=>'Nei'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113576055613401040)
,p_name=>'NOBODY'
,p_message_language=>'no'
,p_message_text=>'ingen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113445583867400943)
,p_name=>'NOT'
,p_message_language=>'no'
,p_message_text=>'Ikke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113486373644400973)
,p_name=>'NOT_NULL'
,p_message_language=>'no'
,p_message_text=>'Ikke null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113457187334400952)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'no'
,p_message_text=>'Ikke %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113476781164400966)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'no'
,p_message_text=>'ingen data funnet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113485800716400973)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'no'
,p_message_text=>unistr('Finner ingen rapport som kan oppdateres. Operasjoner med oppdatering og sletting av flere rader kan bare utf\00F8res p\00E5 tabellskjermbilder av typen Oppdaterbar rapport.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113486734327400974)
,p_name=>'OK'
,p_message_language=>'no'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113482427834400970)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'no'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113579881285401043)
,p_name=>'ORA_06550'
,p_message_language=>'no'
,p_message_text=>'ORA-06550: linje %0, kolonne %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113529345979401005)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'no'
,p_message_text=>unistr('Du bruker en foreldet nettleser. Hvis du vil ha en liste over st\00F8ttede nettlesere, kan du se Oracle Application Express Installation Guide.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113430798284400932)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'no'
,p_message_text=>'Et ugyldig sett av rader er forespurt. Kildedataene for rapporten er endret.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113450807674400947)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Du m\00E5 angi et gyldig sidetall, for eksempel p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113454463210400950)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'no'
,p_message_text=>'Neste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113454588745400950)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'no'
,p_message_text=>'Neste sett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113454639230400950)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'no'
,p_message_text=>'Forrige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113454794709400950)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'no'
,p_message_text=>'Forrige sett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113561775774401030)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'no'
,p_message_text=>'Velg paginering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113492337939400978)
,p_name=>'PASSWORD'
,p_message_language=>'no'
,p_message_text=>'Passord'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113437010012400937)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'no'
,p_message_text=>'Passordet for %0 er endret.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113426868303400929)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'no'
,p_message_text=>'Passordet oppfyller ikke dette nettstedets regler for passordkompleksitet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113425949176400929)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Nytt passord m\00E5 ha minst %0 tegn som er forskjellige fra gammelt passord.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113426531324400929)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'no'
,p_message_text=>'Passordet kan ikke inneholde brukernavnet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113426711868400929)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'no'
,p_message_text=>'Passordet inneholder et forbudt enkelt ord.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113426689361400929)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Passordet kan ikke inneholde navnet p\00E5 arbeidsomr\00E5det.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113425824161400929)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Passordet m\00E5 inneholde minst %0 tegn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113426050452400929)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Passordet m\00E5 inneholde minst ett alfabetisk tegn (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113426441649400929)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Passordet m\00E5 inneholde minst \00E9n liten bokstav.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113426109769400929)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Passordet m\00E5 inneholde minst ett numerisk tegn (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113426272301400929)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Passordet m\00E5 inneholde minst ett skilletegn (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113426399725400929)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Passordet m\00E5 inneholde minst \00E9n stor bokstav.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113437519523400937)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'no'
,p_message_text=>'Varsling om tilbakestilling av passord'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113424881027400928)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Passordet kan ikke brukes fordi det er brukt i l\00F8pet av de siste %0 dagene.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113505109548400987)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'no'
,p_message_text=>'Elementer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113505214910400987)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'no'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113482258529400970)
,p_name=>'PERCENT'
,p_message_language=>'no'
,p_message_text=>'Prosent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113452507068400948)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'no'
,p_message_text=>'Ta kontakt med administratoren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113561933637401030)
,p_name=>'PREVIOUS'
,p_message_language=>'no'
,p_message_text=>'Forrige'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113497329445400981)
,p_name=>'PRINT'
,p_message_language=>'no'
,p_message_text=>'Skriv ut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113481070604400969)
,p_name=>'PRIVILEGES'
,p_message_language=>'no'
,p_message_text=>'Privilegier'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113450948883400947)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'no'
,p_message_text=>unistr('Omr\00E5dereferanser')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113471104374400962)
,p_name=>'REPORT'
,p_message_language=>'no'
,p_message_text=>'Rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113480992946400969)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'no'
,p_message_text=>'Rapporteringsperiode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113562154880401030)
,p_name=>'REPORT_LABEL'
,p_message_language=>'no'
,p_message_text=>'Rapport: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113481624008400970)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'no'
,p_message_text=>'Rapportsum'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113430852966400932)
,p_name=>'RESET'
,p_message_language=>'no'
,p_message_text=>'Tilbakestill paginering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113456761291400951)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'no'
,p_message_text=>'Tilbakestill paginering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113485771891400973)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'no'
,p_message_text=>'Tilbakestill passord'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113462571498400956)
,p_name=>'RESTORE'
,p_message_language=>'no'
,p_message_text=>'Gjenopprett'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113494462787400979)
,p_name=>'RESULTS'
,p_message_language=>'no'
,p_message_text=>'Resultater'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113486884654400974)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'no'
,p_message_text=>unistr('G\00E5 tilbake til applikasjonen.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113487124771400974)
,p_name=>'RIGHT'
,p_message_language=>'no'
,p_message_text=>unistr('H\00F8yre')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113516719631400996)
,p_name=>'ROW'
,p_message_language=>'no'
,p_message_text=>'Rad - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113470752440400962)
,p_name=>'ROW_COUNT'
,p_message_language=>'no'
,p_message_text=>'Antall rader'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113486226883400973)
,p_name=>'SAVE'
,p_message_language=>'no'
,p_message_text=>'Lagre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113482883645400971)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'no'
,p_message_text=>'Alternativ standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113483234168400971)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'no'
,p_message_text=>'Beskrivelse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113482779433400971)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'no'
,p_message_text=>unistr('Prim\00E6r standard')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113483565964400971)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'no'
,p_message_text=>unistr('Mer enn %0 rader er tilgjengelige. \00D8k radvelgeren hvis du vil vise flere rader.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113548995174401020)
,p_name=>'SEARCH'
,p_message_language=>'no'
,p_message_text=>unistr('S\00F8k')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113444107999400942)
,p_name=>'SECONDS'
,p_message_language=>'no'
,p_message_text=>'sekunder'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113482389153400970)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'no'
,p_message_text=>'Se vedlegg'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113540006681401013)
,p_name=>'SELECT_ROW'
,p_message_language=>'no'
,p_message_text=>'Velg rad'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113482027753400970)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'no'
,p_message_text=>unistr('Sl\00E5 av skjermlesermodus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113482117696400970)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'no'
,p_message_text=>unistr('Sl\00E5 p\00E5 skjermlesermodus')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113478452141400967)
,p_name=>'SHOW'
,p_message_language=>'no'
,p_message_text=>'Vis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113541871345401015)
,p_name=>'SHOW_ALL'
,p_message_language=>'no'
,p_message_text=>'Vis alle'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113567927247401034)
,p_name=>'SIGN_IN'
,p_message_language=>'no'
,p_message_text=>unistr('Logg p\00E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113517525824400996)
,p_name=>'SIGN_OUT'
,p_message_language=>'no'
,p_message_text=>'Logg av'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113471730304400962)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'no'
,p_message_text=>'For %0 dager siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113478966882400968)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>unistr('%0 dager fra n\00E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113471631386400962)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'no'
,p_message_text=>'For %0 timer siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113478860499400968)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>unistr('%0 timer fra n\00E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113471550765400962)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'no'
,p_message_text=>'For %0 minutter siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113478740304400968)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>unistr('%0 minutter fra n\00E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113471935315400963)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'no'
,p_message_text=>unistr('For %0 m\00E5neder siden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113479145389400968)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>unistr('%0 m\00E5neder fra n\00E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113479328987400968)
,p_name=>'SINCE_NOW'
,p_message_language=>'no'
,p_message_text=>unistr('N\00E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113471410318400962)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'no'
,p_message_text=>'For %0 sekunder siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113478683022400968)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>unistr('%0 sekunder fra n\00E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113471825636400963)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'no'
,p_message_text=>'For %0 uker siden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113479083045400968)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>unistr('%0 uker fra n\00E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113472096065400963)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'no'
,p_message_text=>unistr('For %0 \00E5r siden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113479291143400968)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'no'
,p_message_text=>unistr('%0 \00E5r fra n\00E5')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113465503793400958)
,p_name=>'STANDARD'
,p_message_language=>'no'
,p_message_text=>'Standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113481947519400970)
,p_name=>'START_DATE'
,p_message_language=>'no'
,p_message_text=>'Startdato'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113422443414400926)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'no'
,p_message_text=>'Du mottar denne e-posten fra et abonnement for interaktive rapporter opprettet av %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113577142210401041)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'no'
,p_message_text=>'Abonnementer'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113525282296401002)
,p_name=>'TAB'
,p_message_language=>'no'
,p_message_text=>'Tabulator'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113444033396400942)
,p_name=>'TITLE'
,p_message_language=>'no'
,p_message_text=>'Tittel'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113427094033400929)
,p_name=>'TODAY'
,p_message_language=>'no'
,p_message_text=>'I dag'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113481560266400970)
,p_name=>'TOTAL'
,p_message_language=>'no'
,p_message_text=>'Totalt'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113428099720400930)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'no'
,p_message_text=>'Maksimalt %0 kolonner kan velges.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113406559818400915)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'no'
,p_message_text=>'Trekk sammen alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113406825141400915)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'no'
,p_message_text=>'Trekk sammen alle nedenfor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113406443562400915)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'no'
,p_message_text=>'Utvid alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113406609264400915)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'no'
,p_message_text=>'Utvid alle nedenfor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113406963049400915)
,p_name=>'TREE.REPARENT'
,p_message_language=>'no'
,p_message_text=>unistr('Overordne p\00E5 nytt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113499163925400983)
,p_name=>'TREES'
,p_message_language=>'no'
,p_message_text=>unistr('Tr\00E6r')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113542676986401015)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'no'
,p_message_text=>'Obligatorisk'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113466223463400959)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'no'
,p_message_text=>'Uautorisert'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113513099003400993)
,p_name=>'UNAVAILABLE'
,p_message_language=>'no'
,p_message_text=>'Utilgjengelig'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113479758662400968)
,p_name=>'UNKNOWN'
,p_message_language=>'no'
,p_message_text=>'Ukjent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113423335207400927)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'no'
,p_message_text=>unistr('Det har oppst\00E5tt en ukjent autentiseringsfeil.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113425353522400928)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'no'
,p_message_text=>unistr('Hvis du ikke lenger \00F8nsker \00E5 motta e-postmeldinger, kan du klikke p\00E5 <a href="%0">Opphev abonnement</a> og administrere abonnementet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113422368395400926)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'no'
,p_message_text=>unistr('Hvis du ikke lenger \00F8nsker \00E5 motta e-postmeldinger, kan du g\00E5 til f\00F8lgende URL-adresse og administrere abonnementet:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113457287038400952)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'no'
,p_message_text=>unistr('ikke-st\00F8ttet datatype')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113445309623400943)
,p_name=>'UPDATE'
,p_message_language=>'no'
,p_message_text=>'oppdater'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113443978225400942)
,p_name=>'UPDATED'
,p_message_language=>'no'
,p_message_text=>'Oppdatert'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113450605716400947)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'no'
,p_message_text=>'Den forespurte URL-adressen kan ikke brukes. Ta kontakt med administratoren.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113470686694400962)
,p_name=>'USER'
,p_message_language=>'no'
,p_message_text=>'Bruker'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113492234567400978)
,p_name=>'USERNAME'
,p_message_language=>'no'
,p_message_text=>'Brukernavn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113531884324401007)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'no'
,p_message_text=>'Brukernavnet er for langt. Grensen er %0 tegn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113477462279400967)
,p_name=>'USERS'
,p_message_language=>'no'
,p_message_text=>'brukere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113531474406401007)
,p_name=>'USER_EXISTS'
,p_message_language=>'no'
,p_message_text=>'Brukernavnet finnes allerede.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113546111988401018)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'no'
,p_message_text=>'Profilbilde for brukeren %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113433769524400935)
,p_name=>'VALID'
,p_message_language=>'no'
,p_message_text=>'Gyldig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113427335148400930)
,p_name=>'VALIDATIONS'
,p_message_language=>'no'
,p_message_text=>'Valideringer'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113483034648400971)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'no'
,p_message_text=>unistr('Verdi m\00E5 angis')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113526412735401003)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'no'
,p_message_text=>unistr('Du m\00E5 angi en verdi for %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113452958483400949)
,p_name=>'VERTICAL'
,p_message_language=>'no'
,p_message_text=>'loddrett'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113445276167400943)
,p_name=>'VIEW'
,p_message_language=>'no'
,p_message_text=>'vis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113477539114400967)
,p_name=>'VIEWS'
,p_message_language=>'no'
,p_message_text=>'visninger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113483813367400971)
,p_name=>'VIEW_ALL'
,p_message_language=>'no'
,p_message_text=>'Vis alle'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113465049669400958)
,p_name=>'WARNING'
,p_message_language=>'no'
,p_message_text=>'Advarsel'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113444824857400943)
,p_name=>'WEEK'
,p_message_language=>'no'
,p_message_text=>'uke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113441837875400941)
,p_name=>'WEEKLY'
,p_message_language=>'no'
,p_message_text=>'Ukentlig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113444998738400943)
,p_name=>'WEEKS'
,p_message_language=>'no'
,p_message_text=>'uker'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113483198664400971)
,p_name=>'WELCOME_USER'
,p_message_language=>'no'
,p_message_text=>'Velkommen: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113481306387400970)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'no'
,p_message_text=>'Fant en ugyldig verdi, verifiser de angitte dataene.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113481434871400970)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'no'
,p_message_text=>'Fant en ugyldig verdi, verifiser de angitte dataene.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113424484389400928)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'no'
,p_message_text=>'Fant en ugyldig datoverdi, verifiser datoformatet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113481271117400970)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'no'
,p_message_text=>'Fant en ugyldig tallverdi, verifiser tallformatet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113433376992400934)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'no'
,p_message_text=>'Fant en ugyldig tidsstempelverdi, verifiser tidsstempelformatet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113455850293400951)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Kan ikke binde %0. Bruk doble anf\00F8rselstegn for elementer med flere byte, eller verifiser at lengden p\00E5 elementet er 30 byte eller mindre. Bruk syntaksen v() for \00E5 referere til elementer som er lengre enn 30 byte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113446363309400944)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'no'
,p_message_text=>'Tilgang ble nektet av sikkerhetskontroll for %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113448857178400946)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'no'
,p_message_text=>'Applikasjonen er ikke tilgjengelig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113447268534400945)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'no'
,p_message_text=>'ERR-1014 Finner ikke applikasjonen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113447309505400945)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('applikasjon=%0 arbeidsomr\00E5de=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113447746935400945)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'no'
,p_message_text=>unistr('Tilgang til denne applikasjonen er begrenset. Pr\00F8v p\00E5 nytt senere.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113447661221400945)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'no'
,p_message_text=>unistr('Tilgang til denne applikasjonen er begrenset til applikasjonsutviklere. Pr\00F8v p\00E5 nytt senere.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113446815273400944)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'no'
,p_message_text=>'ERR-7744 Kan ikke behandle retur-URL for forgrening til funksjon.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113446796979400944)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'no'
,p_message_text=>'ERR-7744 Kan ikke behandle returside for forgrening til funksjon.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113447054695400944)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('ERR-1430 Ikke-st\00F8ttet prosess for kall om visning fra side: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113448145814400945)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'no'
,p_message_text=>'ERR-1018 Feil ved nullstilling av trinnhurtigbuffer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113446594041400944)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'no'
,p_message_text=>'ERR-1005 Ukjent beregningstype.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113447432932400945)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('ERR-1201 \00D8kt-ID er ikke angitt for egendefinert autentisering.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113447565633400945)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'no'
,p_message_text=>'side=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113447108322400944)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('ERR-7620 Kan ikke bestemme arbeidsomr\00E5de for applikasjon (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113429568283400931)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'no'
,p_message_text=>'Rediger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113446272913400944)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'no'
,p_message_text=>'ERR-1802 Finner ikke element-ID-en %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113445987151400944)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'no'
,p_message_text=>'ERR-1002 Finner ikke element-ID for elementet %0 i applikasjonen %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113446036221400944)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'no'
,p_message_text=>unistr('Uventet feil. Finner ikke elementnavn p\00E5 applikasjons- eller sideniv\00E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113446429566400944)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Du er allerede p\00E5 f\00F8rste side av dataene.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113461919946400955)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'no'
,p_message_text=>unistr('Element-ID-en (%0) viser ikke til et element som er definert p\00E5 den gjeldende siden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113424004614400927)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'no'
,p_message_text=>unistr('Elementet kan ikke angis ved \00E5 sende argumenter til applikasjonen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113424382231400928)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'no'
,p_message_text=>'(Ingen kontrollsum er angitt)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113423880490400927)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'no'
,p_message_text=>unistr('Elementet kan angis n\00E5r det finnes en kontrollsum av typen bokmerke p\00E5 brukerniv\00E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113423794904400927)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'no'
,p_message_text=>unistr('Elementet kan angis n\00E5r det finnes en kontrollsum av typen bokmerke p\00E5 applikasjonsniv\00E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113423976226400927)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'no'
,p_message_text=>unistr('Elementet kan angis n\00E5r det finnes en kontrollsum av typen \00F8kt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113423664018400927)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'no'
,p_message_text=>'Elementet har ingen beskyttelse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113448296085400945)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'no'
,p_message_text=>'Ingen sidehjelp er tilgjengelig.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113437310661400937)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'no'
,p_message_text=>unistr('Arbeidsomr\00E5det %0 har ingen privilegier som skal analyseres som skjemaet %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113446621879400944)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'no'
,p_message_text=>'ERR-1010 Overskredet grense for godtatt behandlingsrekursjon ved forgrening til side. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113424206962400927)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'no'
,p_message_text=>unistr('Denne siden kan ikke \00E5pnes ved hjelp av en URL-adresse eller ved \00E5 bruke GET eller POST til visningsprosedyren. Den m\00E5 anropes ved hjelp av forgreningstypen Forgren til side.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113500943470400984)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Feil ved fors\00F8k p\00E5 \00E5 lagre en ikke-numerisk verdi i elementet %0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113439019431400939)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'no'
,p_message_text=>'Applikasjonens analyseskjema, %0, finnes ikke i databasen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113439187845400939)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'no'
,p_message_text=>unistr('Konti i INTERNAL-arbeidsomr\00E5det kan bare brukes til \00E5 f\00E5 tilgang til &PRODUCT_NAME. <a href="%0">Administration Services</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113445867637400943)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('ERR-1029 Kan ikke lagre \00F8ktopplysninger. \00F8kt=%0 element=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113448966050400946)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'no'
,p_message_text=>'Kan ikke stoppe sporing: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113446102305400944)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'no'
,p_message_text=>'Uventet feil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113456149655400951)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'no'
,p_message_text=>'Feil i update_substitution_cache: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113449049682400946)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Applikasjon og side m\00E5 angis hvis du skal vise hjelp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113469520086400961)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'no'
,p_message_text=>'Finner ikke automatisering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113450126709400947)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'no'
,p_message_text=>unistr('Ryddet %0 \00F8kter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113409475624400917)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'no'
,p_message_text=>unistr('Kan ikke utf\00F8re %0-kode. Den st\00F8ttes ikke av databasen, eller den er ikke aktivert av forekomstparameteren MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113409270925400917)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'no'
,p_message_text=>'Multilingual Engine er ikke tilgjengelig i denne databaseversjonen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113430028093400932)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'no'
,p_message_text=>unistr('Applikasjonssamlingsmatrise kan ikke v\00E6re null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113429845646400931)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'no'
,p_message_text=>unistr('Angitt medlemsattributtnummer, %0, er ugyldig. Attributtnumre m\00E5 v\00E6re mellom 1 og %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113430361492400932)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'no'
,p_message_text=>'Applikasjonssamlingen finnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113430100175400932)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'no'
,p_message_text=>unistr('Samlingsnavn kan ikke v\00E6re null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113430237275400932)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'no'
,p_message_text=>unistr('Navnet p\00E5 samlingen kan ikke v\00E6re st\00F8rre enn 255 tegn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113429692914400931)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Applikasjonssamlingen %0 finnes ikke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113430480108400932)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'no'
,p_message_text=>unistr('Mark\00F8ren er ikke \00E5pen enn\00E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113429789262400931)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Medlemssekvensen %0 finnes ikke i applikasjonssamlingen %1',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113429994480400932)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'no'
,p_message_text=>'Medlemssekvensen %0 finnes ikke i applikasjonssamlingen %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113501755851400985)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'no'
,p_message_text=>unistr('Den kryptografiske funksjonen %0 st\00F8ttes ikke p\00E5 dette systemet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113555248502401025)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'no'
,p_message_text=>'Tilgjengelighet er testet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113449646523400946)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'no'
,p_message_text=>'Lukk'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113449701920400946)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'no'
,p_message_text=>'Valg for sidetilpasning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113449858585400946)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'no'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113449993501400947)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'no'
,p_message_text=>'Vist'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113450069592400947)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'no'
,p_message_text=>'Skjult'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113449459420400946)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'no'
,p_message_text=>unistr('Merk av for omr\00E5dene du vil inkludere p\00E5 denne siden. Avmerkede omr\00E5der blir kanskje ikke vist hvis du ikke er i riktig applikasjonskontekst eller ikke har tilstrekkelige privilegier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113449552316400946)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'no'
,p_message_text=>'Denne siden kan ikke tilpasses.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113555531696401025)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'no'
,p_message_text=>unistr('Du kan tilpasse utseendet p\00E5 denne applikasjonen ved \00E5 bytte temastil. Velg en temastil fra listen nedenfor, og klikk p\00E5 Bruk endringer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113556301047401025)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'no'
,p_message_text=>unistr('Omr\00E5devisning')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113555488146401025)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'no'
,p_message_text=>'Bruk standardstil for applikasjonen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113555320900401025)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'no'
,p_message_text=>'Utseende '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113498303190400982)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Kolonneindeksen det refereres til i aggregeringen %0, finnes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113401651300400911)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'no'
,p_message_text=>unistr('CLOB-utdata st\00F8ttes ikke for %0-format.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113498035525400982)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'no'
,p_message_text=>unistr('Kolonneskiftet m\00E5 v\00E6re i begynnelsen av kolonnematrisen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113498166957400982)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Kolonnegruppeindeksen det refereres til i %0, finnes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113415674763400921)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'no'
,p_message_text=>'eksport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113420882446400925)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'no'
,p_message_text=>unistr('Eksportformatet m\00E5 v\00E6re XML med ORDS som utskriftstjener.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113498491254400982)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Kolonneindeksen det refereres til i uthevingen %0, finnes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113414117537400920)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'no'
,p_message_text=>'Ugyldig eksportformat: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113498203997400982)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Den overordnede gruppeindeksen det refereres til i %0, finnes ikke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113523470473401001)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Kolonnen %1 i tabellen %0 er en identitetskolonne av typen GENERATED ALWAYS. Forsikre deg om at ingen kildekolonne er tilordnet til kolonnen %1 i dialogboksen Konfigurer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113440863170400940)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'no'
,p_message_text=>'Det angitte lagringsintervallet er for lavt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113440949256400940)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'no'
,p_message_text=>'Ingen kolonner er angitt for datalasting.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113442193894400941)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'no'
,p_message_text=>unistr('Finner ingen kolonner for radvelgeren %0. Pr\00F8v \00E5 finne dem automatisk eller se gjennom JSON-strukturen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113450496504400947)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'no'
,p_message_text=>'Finner ingen regneark i XLSX-filen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113450320754400947)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'no'
,p_message_text=>'Det angitte regnearket finnes ikke i XLSX-filen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113430549410400932)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'no'
,p_message_text=>'Gjeldende versjon av data i databasen er endret siden brukeren initierte oppdateringsprosessen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113432920212400934)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'no'
,p_message_text=>'Feil ved oppdatering av rapportkolonner: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113537615478401011)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'no'
,p_message_text=>'Kan ikke konvertere %0 til SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113477151918400967)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'no'
,p_message_text=>'Kolonnen %0, som har datatypen %1, kan ikke konverteres til VARCHAR2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113484129526400972)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'no'
,p_message_text=>'Kolonnen %0, som er angitt for attributtet %1, ble ikke funnet i datakilden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113425428840400928)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'no'
,p_message_text=>unistr('Filtertypen %0 st\00F8ttes ikke for flerverdikolonner.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113541021125401014)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'no'
,p_message_text=>'Ugyldig "between"-filter.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113407543457400915)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'no'
,p_message_text=>'Ugyldig verdilistetype er angitt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113407403033400915)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'no'
,p_message_text=>unistr('Ugyldig sp\00F8rringstype. Sp\00F8rringstypen m\00E5 v\00E6re Tabell, SQL-sp\00F8rring eller PL/SQL-funksjon som returnerer SQL-sp\00F8rring.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113477284929400967)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Kan ikke analysere SQL-sp\00F8rringen.'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113484214967400972)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'no'
,p_message_text=>'Den angitte kolonneposisjonen %0 for attributtet %1 ble ikke funnet i SQL-setningen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113406025499400914)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'no'
,p_message_text=>'For mange elementer er brukt i filter for flere verdier.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113484021729400972)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'no'
,p_message_text=>'Det er ikke angitt noen kolonne for attributtet %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113407339450400915)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'no'
,p_message_text=>'Hoveddelen av PL/SQL-funksjonen returnerte ikke en verdi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113497244916400981)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'no'
,p_message_text=>unistr('REST-datakilden inneholder ikke en operasjon for h\00E5ndtering av den forespurte DML-handlingen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113403297764400912)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'no'
,p_message_text=>'Konvertering fra GeoJSON til SDO_GEOMETRY (kolonnen %0) er ikke tilgjengelig i denne databasen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113404322341400913)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'no'
,p_message_text=>unistr('SDO_GEOMETRY-konvertering (kolonnen %0) st\00F8ttes ikke for XML-datakilder.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113411684820400918)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'no'
,p_message_text=>unistr('Tegnet %0 st\00F8ttes ikke som et flerverdiskilletegn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113538921675401012)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'no'
,p_message_text=>unistr('Denne funksjonen kan ikke brukes i en sp\00F8rringskontekst.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113404489263400913)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'no'
,p_message_text=>'Ikke samsvarende kolonnedatatype.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113407248457400915)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'no'
,p_message_text=>'Interne bindingsgrenser for ORDS OUT er overskredet. Reduser mengden DML-rader.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113485075659400972)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'JSON-svaret fra den eksterne tjeneren kan ikke analyseres: ',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113407113848400915)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'no'
,p_message_text=>'Ukjent eller feil konteksttype.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113501655093400985)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'no'
,p_message_text=>unistr('Denne filtypen st\00F8ttes ikke av analysatoren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113456224975400951)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'no'
,p_message_text=>'Uautorisert tilgang (wwv_flow_api.set_credentials er ikke angitt).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113433207973400934)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'no'
,p_message_text=>unistr('Arbeidsomr\00E5det ble ikke opprettet fordi det allerede finnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113433187088400934)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'no'
,p_message_text=>'Brukergruppen ble ikke opprettet fordi den allerede finnes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113443451640400942)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'no'
,p_message_text=>'Fant et duplisert brukernavn for %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113443580027400942)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'no'
,p_message_text=>'Feil ved lasting av brukere. Mislyktes for brukeren %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113453424410400949)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'no'
,p_message_text=>'Ville lastet %0 brukere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113453210728400949)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'no'
,p_message_text=>'Passord'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113453339391400949)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'no'
,p_message_text=>'Privilegier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113453062520400949)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'no'
,p_message_text=>'Brukernavn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113529585004401005)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'no'
,p_message_text=>'Feil ved gjengivelse av sideelementet #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113449151576400946)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Kan ikke vise sideelementet fordi HTML-skjermbildet ikke er \00E5pnet enn\00E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113414496545400920)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'no'
,p_message_text=>'Feil ved beregning av standardelementverdi for sideelementet #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113448484732400945)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'no'
,p_message_text=>'Feil i elementetterberegning for sideelementet #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113448350244400945)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'no'
,p_message_text=>'Feil ved beregning av kildeelementverdi for sideelementet #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113428116825400930)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'no'
,p_message_text=>'Uautorisert tilgang.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113448682432400946)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'no'
,p_message_text=>unistr('JavaScript st\00F8ttes ikke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113448704079400946)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'no'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113449326748400946)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'no'
,p_message_text=>unistr('Kan ikke initialisere sp\00F8rring.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113456568323400951)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Oppdatering av %0 st\00F8ttes ikke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113450738734400947)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'no'
,p_message_text=>'Ugyldig element-ID: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113477048492400966)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'no'
,p_message_text=>'Det finnes ingen hjelp for dette elementet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113441588582400940)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'no'
,p_message_text=>unistr('Generering av diagramsp\00F8rring mislyktes. Kontroller innstillingene for kilde- og kolonnetilordning.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113536321356401010)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'no'
,p_message_text=>unistr('Vedlegget med en st\00F8rrelse p\00E5 %0 MB overskrider den maksimale vedleggsst\00F8rrelsen p\00E5 %1 MB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113442414685400941)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'no'
,p_message_text=>'Ugyldig verdi for parameteren p_mail_id: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113559828975401028)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'no'
,p_message_text=>unistr('Du har overskredet maksimalt antall e-postmeldinger per arbeidsomr\00E5de. Ta kontakt med administratoren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113423447129400927)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'no'
,p_message_text=>unistr('Denne prosedyren m\00E5 startes i en applikasjons\00F8kt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113442352756400941)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'no'
,p_message_text=>'Nullverdi er angitt for parameteren %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113496345374400981)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'no'
,p_message_text=>'Finner ikke e-postmalen %0 i applikasjonen %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113572814595401038)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('Forekomstparameteren SMTP_HOST_ADDRESS m\00E5 settes til sending av e-post.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113442094254400941)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('Du m\00E5 angi en meldingsmottaker hvis du skal sende e-post.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113562275752401030)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'no'
,p_message_text=>'Kan ikke opprette SMTP-tilkobling med den konfigurerte e-posttjeneren.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113536480442401011)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'no'
,p_message_text=>'Ugyldig Ajax-kall.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113427849178400930)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'no'
,p_message_text=>'Ingen Ajax-funksjon er definert for innpluggingsmodulen %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113526890165401003)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'no'
,p_message_text=>unistr('Ingen utf\00F8relsesfunksjon er definert for innpluggingsmodulen %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113427981849400930)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'no'
,p_message_text=>'Ingen gjengivelsesfunksjon er definert for innpluggingsmodulen %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113537334780401011)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'no'
,p_message_text=>'Innpluggingsmodulen %0 for REST-datakilden inneholder ikke en mulighetsfunksjon.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113537205968401011)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'no'
,p_message_text=>'Innpluggingsmodulen %0 for REST-datakilden inneholder ikke en DML-funksjon.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113537422749401011)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'no'
,p_message_text=>unistr('Innpluggingsmodulen %0 for REST-datakilden inneholder ikke en utf\00F8relsesfunksjon.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113537519312401011)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'no'
,p_message_text=>'Innpluggingsmodulen %0 for REST-datakilden inneholder ikke en hentefunksjon.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113425673444400928)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'no'
,p_message_text=>'Det oppstod feil i PLSQL-kode under behandling av innpluggingsmodulen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113432277302400933)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('Verdi m\00E5 angis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113462812450400956)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'no'
,p_message_text=>'Datatypen %0 kan ikke konverteres til VARCHAR2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113548442907401019)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'no'
,p_message_text=>'Kolonnen %0, som er angitt for attributtet %1, ble ikke funnet i SQL-setningen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113524757381401002)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'no'
,p_message_text=>unistr('En verdilistesp\00F8rring eller en navngitt verdiliste m\00E5 angis for %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113526308028401003)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'no'
,p_message_text=>unistr('Feil antall kolonner er valgt i SQL-verdilistesp\00F8rringen for %0. Se eksemplene for gyldige setninger.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113548238022401019)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'no'
,p_message_text=>'Det er ikke angitt noen kolonne for attributtet %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113577951589401042)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'no'
,p_message_text=>'Den angitte verdien %0 for attributtet %1 er ikke numerisk.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113529839576401006)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'no'
,p_message_text=>'%0 har en feilaktig datatype i SQL-setningen. Kolonne nr. %1 er %2, men %3 er forventet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113548345779401019)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'no'
,p_message_text=>'Kolonnen %0, som er angitt for attributtet %1, har datatypen %2, men burde hatt %3.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113424973725400928)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'no'
,p_message_text=>'Finner ikke rapportoppsettet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113484904897400972)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'no'
,p_message_text=>unistr('Funksjonen Beregn sum kan ikke brukes for rapporter som er basert p\00E5 en REST-datakilde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113448510180400945)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'no'
,p_message_text=>'ERR-2904 Kan ikke angi snarveisverdi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113452867211400949)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'no'
,p_message_text=>'Feil: Ukjent snarveistype.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113442819665400941)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'no'
,p_message_text=>'Kan ikke hente authentication_scheme i applikasjonen %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113516342502400996)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'no'
,p_message_text=>unistr('Leier-ID-en finnes allerede for den gjeldende \00F8kten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113453129014400949)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'no'
,p_message_text=>'E-post'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113577388719401041)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'no'
,p_message_text=>'Autentiseringen mislyktes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113479695840400968)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'no'
,p_message_text=>unistr('\00C9n eller flere informasjonskapsler som er angitt i apex_util.g_request_cookies, inneholder en ugyldig verdi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113462120062400955)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'no'
,p_message_text=>'Svaret fra UDDI-registeret var ugyldig.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113425735780400928)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'no'
,p_message_text=>'Den angitte URL-adressen returnerte ikke et gyldig WSDL-dokument.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113428284624400930)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'no'
,p_message_text=>unistr('WSDL-dokumentet inneholder flere SOAP-bindinger. &PRODUCT_NAME. st\00F8tter bare WSDL-er med \00E9n SOAP-binding. Klikk p\00E5 Opprett Web-tjenestereferanse manuelt hvis du vil fortsette \00E5 opprette en referanse for denne tjenesten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113496684357400981)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'no'
,p_message_text=>'Svaret fra tjenesten var ikke XML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113577213455401041)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'no'
,p_message_text=>unistr('OAuth-tilgangssymbolet er ikke tilgjengelig, eller det er utl\00F8pt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113540461703401013)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'no'
,p_message_text=>unistr('Du har overskredet maksimalt antall Web-tjenesteforesp\00F8rsler per arbeidsomr\00E5de. Ta kontakt med administratoren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113577473644401041)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'no'
,p_message_text=>unistr('Tjeneren svarte med ikke-st\00F8ttet OAuth-symboltype.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113427695038400930)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'no'
,p_message_text=>unistr('WSDL-dokumentet inneholdt ikke en binding for SOAP, noe som er n\00F8dvendig for at referansen skal kunne legges til.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113423567854400927)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'no'
,p_message_text=>'WSDL forutsetter autentisering her. Angi brukernavn og passord nedenfor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113432355568400933)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'no'
,p_message_text=>unistr('WSDL-dokumentet ble ikke forst\00E5tt av gjengivelsesmotoren. Klikk p\00E5 Opprett Web-tjenestereferanse manuelt hvis du vil fortsette \00E5 opprette en referanse for denne tjenesten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113499231644400983)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'no'
,p_message_text=>'Kan ikke behandle oppdateringen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113525035693401002)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'no'
,p_message_text=>'Verdilisteretur og visningskolonne er identisk.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113524991570401002)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Verdilisten har ikke en returkolonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113456479323400951)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'no'
,p_message_text=>'Feil ved henting av kolonneverdi: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113480455241400969)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'no'
,p_message_text=>unistr('De gjeldende tabellskjermbildedataene er for gamle. Kildedataene er endret.<br/> Klikk <strong><a href="%0">her</a></strong> hvis du vil forkaste endringene og laste dataene fra databasen p\00E5 nytt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113438518704400938)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'no'
,p_message_text=>unistr('Feil ved fors\00F8k p\00E5 \00E5 bestemme pagineringsstreng')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113438427805400938)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('kan ikke bestemme sp\00F8rringsoverskrifter:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113438697201400938)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'no'
,p_message_text=>'feil ved erstatning av rapportbunntekst'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113438762164400938)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('kan ikke analysere SQL-sp\00F8rringen:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113443731306400942)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'no'
,p_message_text=>'Minste antall rader forespurt: %0, rader funnet, men ikke vist: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113441290001400940)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'no'
,p_message_text=>unistr('sp\00F8rringskolonne nr. %0 (%1) er ugyldig, kolonner som bruker HTML, m\00E5 ha aliasnavn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113456331078400951)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'no'
,p_message_text=>unistr('Feil ved henting av sp\00F8rringsoverskrifter: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113438839932400938)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'rapportfeil:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113476544227400966)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'no'
,p_message_text=>'Sorter etter denne kolonnen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113441380339400940)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'no'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Kan ikke analysere sp\00F8rringen, kontroller syntaksen i sp\00F8rringen.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113480521601400969)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'no'
,p_message_text=>unistr('Dette skjermbildet inneholder ulagrede endringer. Velg OK hvis du vil fortsette uten \00E5 lagre endringene. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113484846113400972)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'no'
,p_message_text=>unistr('Pagineringsplanen for rapporten (%0) st\00F8ttes ikke med den valgte datakilden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113441122639400940)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'no'
,p_message_text=>unistr('sp\00F8rringskolonne nr. %0 (%1) er ugyldig, bruk kolonnealias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113443839042400942)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'no'
,p_message_text=>'rad %0-%1 av mer enn %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113482537825400970)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'no'
,p_message_text=>'%0-%1 av mer enn %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113443623416400942)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'no'
,p_message_text=>'rad %0-%1 av %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113427585588400930)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'no'
,p_message_text=>'%0-%1 av %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113438921223400938)
,p_name=>'Y'
,p_message_language=>'no'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113445041735400943)
,p_name=>'YEAR'
,p_message_language=>'no'
,p_message_text=>unistr('\00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113438120038400938)
,p_name=>'YEARS'
,p_message_language=>'no'
,p_message_text=>unistr('\00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113480600104400969)
,p_name=>'YES'
,p_message_language=>'no'
,p_message_text=>'Ja'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4483)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4483)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Skrivebord'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4483
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4483)
,p_name=>'Meldinger'
,p_alias=>'MESSAGES'
,p_step_title=>'Meldinger'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
