prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4484
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4484 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4484
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116102989628403726')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'pl'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4484)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113352'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4484)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4484)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4484)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4484)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4484)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4484)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4484)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4484)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4484)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4484)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4484)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4484)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4484)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.pl'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4484
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4484)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4484)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4484)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4484)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4484)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4484)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4484)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.pl'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4484
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4484)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4484)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4484)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4484)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4484)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4484)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4484)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.pl'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4484
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4484)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4484)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4484)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4484)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4484)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4484)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4484)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4484)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4484)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4484)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4484)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4484)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4484)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4484)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4484)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4484)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4484)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.pl'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4484
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4484)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4484)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4484)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4484)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4484)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4484)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4484)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4484)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4484)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4484)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4484)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4484)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4484)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4484)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4484)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.pl'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4484
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4484)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4484)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4484)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4484)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4484)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4484)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4484)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4484)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4484)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4484)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4484)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4484)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4484)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4484)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4484)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.pl'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4484
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4484)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4484)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4484)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4484)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4484)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4484)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4484)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4484)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4484)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4484)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4484)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4484)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4484)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4484)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4484)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.pl'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4484
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4484)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4484)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4484)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4484)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4484)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4484)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4484)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4484)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4484)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4484)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4484)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4484)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4484)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4484)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4484)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4484
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4484)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4484
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4484)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4484
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4484)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4484
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4484)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4484
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4484)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4484
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4484)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4484
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4484)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4484)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4484)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4484)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4484)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4484)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4484)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4484)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4484)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4484)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4484)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4484)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4484)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4484)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4484
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4484)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4484)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4484)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4484)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4484)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4484)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4484)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4484)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4484)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4484
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4484)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4484)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4484)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4484)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4484)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4484)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4484)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4484)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4484)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4484)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4484)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4484)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4484)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4484)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4484)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4484)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4484)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4484)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4484)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4484)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4484)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4484)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4484)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4484)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4484)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4484
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4484)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4484)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4484)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4484)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4484)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4484)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4484)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4484)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4484)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4484)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4484
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4484)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4484)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4484)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4484)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4484)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4484
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4484)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4484)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4484)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4484)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4484)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4484)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4484)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4484
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4484)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4484)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4484)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4484)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4484)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4484
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4484)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4484)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4484)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4484)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4484)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4484
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4484)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4484)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4484)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4484)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4484)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4484)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4484)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4484)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4484)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4484
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4484)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4484)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4484)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4484)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4484)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4484)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4484)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4484)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4484)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4484)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4484)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4484)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4484)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4484)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4484
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4484)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4484)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4484)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4484)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4484)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4484
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4484)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4484
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4484)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4484
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4484)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4484
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4484)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4484
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4484)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4484
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4484)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4484)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4484)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4484)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4484)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4484)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4484)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4484)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4484)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4484
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4484)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4484)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4484)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4484)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4484)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4484)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4484)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4484
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4484)
,p_page_name=>'winlov'
,p_page_title=>'Okno dialogowe wyszukiwania'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Szukaj'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Zamknij'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Dalej &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Wstecz'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Wiersze: #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4484
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4484)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4484
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4484)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4484)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4484)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4484)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4484)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4484)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4484)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4484)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4484)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4484)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4484)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4484)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4484)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4484)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4484)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4484)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4484)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4484)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4484)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4484)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4484)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4484)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4484)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4484)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4484)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4484)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4484)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4484)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4484)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4484)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4484)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4484)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4484)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4484)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4484)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4484)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4484)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4484)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4484)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4484)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4484)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4484)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4484)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4484)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4484)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4484)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4484)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4484)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4484)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4484)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4484)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4484)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4484)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4484)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4484)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4484)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4484)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4484)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4484)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4484)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4484)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4484)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4484)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4484)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4484)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4484)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4484)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4484)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4484)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4484)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4484)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4484)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4484)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4484)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4484)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4484)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4484)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4484)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4484)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4484)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4484)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4484)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4484)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4484)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4484)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4484)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4484)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4484)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4484)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4484)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4484)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4484)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4484)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4484)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4484)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4484)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4484)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4484)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4484)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4484)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4484)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4484)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4484)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4484)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4484)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4484)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4484)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4484)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4484)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4484)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4484)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4484)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4484)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4484)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4484)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4484)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4484)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4484)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4484)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4484)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4484)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4484)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4484)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4484)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4484)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4484)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4484)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4484)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4484)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4484)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4484)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4484)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4484)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4484)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4484)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4484)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4484)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4484)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4484)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4484)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4484)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4484)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4484)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4484)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4484)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4484)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4484)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4484)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4484)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4484)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4484)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4484)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4484)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4484)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4484)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4484)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4484)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4484)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4484)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4484)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4484)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4484)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4484)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4484)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4484)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4484)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4484)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4484)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4484)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4484)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4484)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4484)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4484)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4484)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4484)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4484)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4484)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4484)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4484)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4484)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4484)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4484)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4484)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4484)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4484)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4484)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4484)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4484)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4484)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4484)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4484)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4484)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4484)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4484)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4484)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4484)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4484)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4484)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4484)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4484)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4484)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4484)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4484)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4484)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4484)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4484)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4484)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113613623453401075)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'pl'
,p_message_text=>'Kolumna %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113600715929401065)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'pl'
,p_message_text=>'Administrator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113600663566401065)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'pl'
,p_message_text=>unistr('Nazwa u\017Cytkownika')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113657924378401107)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Odmowa dost\0119pu')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113617603489401078)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'pl'
,p_message_text=>unistr('Konto %0 zosta\0142o utworzone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113603222530401067)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'pl'
,p_message_text=>'Konto jest zablokowane.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113593162471401060)
,p_name=>'AM_PM'
,p_message_language=>'pl'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113727581731401159)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Prze\0142\0105cz: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113735602954401165)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'pl'
,p_message_text=>'(Aktywne)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113705133910401142)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Dla wywo\0142ania Ajax zosta\0142 zwr\00F3cony b\0142\0105d "%0" serwera dla "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113635977760401091)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna przekszta\0142ci\0107 aliasu "%0" aplikacji w unikatowy ID aplikacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113636084569401091)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'pl'
,p_message_text=>'Aplikacja z aliasem "%0" nie istnieje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113625639894401083)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('ERR-1816 Nieoczekiwany b\0142\0105d podczas przekszta\0142cania aliasu p_flow_alias_or_id (%0) aplikacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113718521091401152)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Za pomoc\0105 sumy kontrolnej mo\017Cna \0142atwo ustali\0107, czy ta sama aplikacja jest wdra\017Cana w r\00F3\017Cnych obszarach roboczych. Mo\017Cna por\00F3wnywa\0107 sumy kontrolne, aby stwierdzi\0107, czy s\0105 one identyczne. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113611430506401073)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania funkcji identyfikacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113596868505401062)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania funkcji identyfikacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113760337815401183)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'pl'
,p_message_text=>unistr('Zwr\00F3cona przez Oracle Cloud Identity Management nazwa dzier\017Cawy "%0" nie jest autoryzowana dla domeny %1.<br/>Prosz\0119 <a href="&LOGOUT_URL.">ponownie si\0119 zalogowa\0107</a>, u\017Cywaj\0105c autoryzowanej nazwy dzier\017Cawy lub zmieniaj\0105c URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113594552185401061)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'pl'
,p_message_text=>unistr('Konto "%0" nie ma wymaganych uprawnie\0144 programistycznych (DB_DEVELOPER lub DB_ADMINISTRATOR)<br/>dla obszaru roboczego "%1". Prosz\0119 <a href="&LOGOUT_URL.">ponownie si\0119 zalogowa\0107</a> po uzyskaniu uprawnie\0144.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113593695568401060)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'pl'
,p_message_text=>unistr('Zwr\00F3cona przez Oracle Cloud Identity Management nazwa dzier\017Cawy nie jest autoryzowana dla bie\017C\0105cego obszaru roboczego.<br/>Prosz\0119 <a href="&LOGOUT_URL.">ponownie si\0119 zalogowa\0107</a>, u\017Cywaj\0105c autoryzowanej nazwy dzier\017Cawy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113594643278401061)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'pl'
,p_message_text=>unistr('Ze wzgl\0119d\00F3w bezpiecze\0144stwa uruchamianie aplikacji z tego obszaru roboczego poprzez domen\0119 z adresu URL nie jest dozwolone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113611190205401073)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 si\0119 zwr\00F3ci\0107 do administratora bazy danych o uruchomienie $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113611008831401073)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'pl'
,p_message_text=>'Pakiet SYS.DBMS_LDAP nie istnieje lub jest niepoprawny.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113610900973401073)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania edycji funkcji u\017Cytkownika LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113611220114401073)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania identyfikacji LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113612041344401074)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d w argumencie p_flow_page przekazanym do procedury login_page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113611689836401073)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawny parametr p_session w wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113659520943401108)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'pl'
,p_message_text=>unistr('Niepoprawna posta\0107 argumentu dla wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113611721269401073)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'pl'
,p_message_text=>unistr('Do procedury logowania zosta\0142a przekazana nazwa u\017Cytkownika o warto\015Bci Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113600556592401065)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 poczeka\0107 <span id="apex_login_throttle_sec">%0</span> sekund(y), po czym si\0119 ponownie zalogowa\0107.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113601829768401066)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Pr\00F3ba zalogowania zosta\0142a zablokowana.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113657396470401107)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'pl'
,p_message_text=>'Nie znaleziono identyfikacji "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113602101205401066)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'pl'
,p_message_text=>unistr('ID grupy zabezpiecze\0144 ma warto\015B\0107 Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113611568845401073)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas wykonywania procesu po identyfikacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113611312905401073)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania procesu poprzedzaj\0105cego identyfikacj\0119.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113612570794401074)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Prosz\0119 otworzy\0107 URL w tej samej przegl\0105darce, z kt\00F3rej zosta\0142o zainicjowane \017C\0105danie zresetowania has\0142a. Je\015Bli po klikni\0119ciu "URL resetowania has\0142a" nast\0105pi'),
unistr('przekierowanie na stron\0119 logowania, prosz\0119 ponownie zainicjowa\0107 \017C\0105danie zresetowania has\0142a'),
unistr('i pozostawi\0107 przegl\0105dark\0119 otwart\0105.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113757879429401181)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'pl'
,p_message_text=>unistr('URL resetowania has\0142a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113594856284401061)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'pl'
,p_message_text=>unistr('Grupa "%0" konsument\00F3w mened\017Cera zasob\00F3w nie uzyska\0142a uprawnie\0144: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113594936369401061)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 przypisa\0107 brakuj\0105ce uprawnienie, u\017Cywaj\0105c procedury DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113622904135401081)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania funkcji sentry sesji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113623001413401081)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania funkcji weryfikacji sesji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113623254493401082)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 si\0119 zwr\00F3ci\0107 do administratora %0 o skonfigurowanie motoru dla us\0142ugi Oracle Application Server Single Sign-On.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113632785457401088)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'pl'
,p_message_text=>unistr('Niedozwolony wpis %0 w tokenie %1 zwr\00F3conym przez sso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113611932122401073)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 edytowa\0107 schemat identyfikacji i doda\0107 nazw\0119 aplikacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113632452968401088)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'pl'
,p_message_text=>unistr('Niedozwolony wywo\0142uj\0105cy procedur\0119 %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113632670722401088)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawna sesja aplikacji w tokenie urlc: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113632277538401088)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d w portal_sso_redirect: brak informacji o rejestracji aplikacji: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113623193197401082)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'pl'
,p_message_text=>'Pakiet WWSEC_SSO_ENABLER_PRIVATE nie istnieje lub jest niepoprawny.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113611820753401073)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'pl'
,p_message_text=>'W schemacie identyfikacji nie znaleziono zarejestrowanej nazwy aplikacji partnerskiej.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113632332254401088)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 zarejestrowa\0107 aplikacj\0119 zgodnie z opisem zawartym w podr\0119czniku instalacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113623346481401082)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania identyfikacji SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113732737756401163)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'pl'
,p_message_text=>'Nieautoryzowany URL: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113622778481401081)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania identyfikacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113594750237401061)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'pl'
,p_message_text=>unistr('Obszar roboczy "%0" jest nieaktywny. Prosz\0119 si\0119 skontaktowa\0107 z administratorem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113595111474401061)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'pl'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113601557491401066)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'pl'
,p_message_text=>unistr('Odmowa dost\0119pu ze wzgl\0119du na kontrol\0119 bezpiecze\0144stwa aplikacji')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113601683122401066)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'pl'
,p_message_text=>unistr('Odmowa dost\0119pu ze wzgl\0119du na kontrol\0119 bezpiecze\0144stwa strony')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113601770538401066)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania autoryzacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113665198761401113)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'pl'
,p_message_text=>unistr('Utworzono z %0, u\017Cywaj\0105c %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113665203287401113)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'pl'
,p_message_text=>unistr('mi\0142o\015Bci\0105')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113723078190401156)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'pl'
,p_message_text=>'Opis zdarzenia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113722814425401155)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'pl'
,p_message_text=>unistr('Data ko\0144cowa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113723197532401156)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'pl'
,p_message_text=>'ID zdarzenia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113722771932401155)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'pl'
,p_message_text=>unistr('Data pocz\0105tkowa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113722995571401156)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Tytu\0142 zdarzenia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113613569673401075)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d zawarto\015Bci sumy kontrolnej')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113613432191401075)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d formatu sumy kontrolnej')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113677432217401122)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'pl'
,p_message_text=>'Skopiowano do schowka.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113677192230401121)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'pl'
,p_message_text=>unistr('Ta przegl\0105darka nie obs\0142uguje kopiowania przy u\017Cyciu przycisku lub menu. Prosz\0119 spr\00F3bowa\0107 u\017Cy\0107 Ctrl+C lub Command+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113665622125401113)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'pl'
,p_message_text=>'Zamknij powiadomienie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113721649495401155)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'pl'
,p_message_text=>'Kontrast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113716197340401151)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'pl'
,p_message_text=>unistr('Bie\017C\0105cy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113716015161401150)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'pl'
,p_message_text=>unistr('Pocz\0105tkowy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113720215777401154)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# musi by\0107 poprawnym kolorem. Przyk\0142ad: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113715910849401150)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r koloru')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113716264929401151)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Zmie\0144 format koloru')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113755419865401179)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'pl'
,p_message_text=>unistr('Lista warto\015Bci')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113755584638401179)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'pl'
,p_message_text=>unistr('Otw\00F3rz list\0119 dla: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113735788503401165)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'pl'
,p_message_text=>unistr('(Uko\0144czone)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113628023534401085)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 si\0119 skontaktowa\0107 z administratorem aplikacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113642437662401095)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Prosz\0119 si\0119 skontaktowa\0107 z administratorem aplikacji.'),
unistr('Szczeg\00F3\0142y tego incydentu s\0105 dost\0119pne poprzez ID "%0" wykrywania b\0142\0119d\00F3w.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113720578303401154)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'pl'
,p_message_text=>unistr('Przed zapisaniem prosz\0119 poprawi\0107 b\0142\0119dy.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113666509448401114)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'pl'
,p_message_text=>'Znaleziono zgodnych: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113666476454401113)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'pl'
,p_message_text=>'Nie znaleziono zgodnych'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113736216445401165)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'pl'
,p_message_text=>unistr('Bie\017C\0105cy post\0119p')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113720930275401154)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'Podany w elemencie "%0" plik nie istnieje w APEX_APPLICATION_TEMP_FILES.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113709401829401145)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'pl'
,p_message_text=>unistr('Bie\017C\0105ca wersja danych w bazie danych uleg\0142a zmianie, poniewa\017C u\017Cytkownik zainicjowa\0142 proces aktualizacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113678538138401122)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie \0142aduj')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113725558552401157)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania wst\0119pnego')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113725382531401157)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'pl'
,p_message_text=>'Wstaw wiersz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113739416976401168)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Sekwencja: czynno\015B\0107')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113725476994401157)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'pl'
,p_message_text=>'Aktualizuj wiersz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113666934104401114)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'pl'
,p_message_text=>unistr('Kalendarz wyskakuj\0105cy: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113589564584401057)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'pl'
,p_message_text=>'Dalej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113589630407401057)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'pl'
,p_message_text=>'Wstecz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113725747571401158)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# musi mie\0107 jak\0105\015B warto\015B\0107.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113725682088401158)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# musi by\0107 poprawn\0105 dat\0105, na przyk\0142ad %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113593239531401060)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# musi si\0119 zawiera\0107 mi\0119dzy %0 a %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113593336545401060)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# nie mo\017Ce by\0107 wcze\015Bniejsza ni\017C %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113593428631401060)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# nie mo\017Ce by\0107 p\00F3\017Aniejsza ni\017C %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113670405267401117)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'pl'
,p_message_text=>'#LABEL# przypada po podanej maksymalnej dacie %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113670822087401117)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'pl'
,p_message_text=>'#LABEL# nie jest zgodna z formatem %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113670316175401116)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# przypada przed podan\0105 minimaln\0105 dat\0105 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113670588856401117)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# nie zawiera si\0119 w poprawnym przedziale od %0 do %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113670782715401117)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# nie zawiera si\0119 w poprawnym przedziale lat od %0 do %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113720888609401154)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'pl'
,p_message_text=>'Anuluj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113748043199401174)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'pl'
,p_message_text=>'Zamknij'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113750069150401175)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'pl'
,p_message_text=>'Pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113720620451401154)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'pl'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113720752997401154)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'pl'
,p_message_text=>'Zapisz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113626942637401084)
,p_name=>'APEX.ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113594334973401061)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'pl'
,p_message_text=>unistr('Podczas wykonywania wywo\0142ania zwrotnego w celu obs\0142ugi b\0142\0119du wyst\0105pi\0142 nast\0119puj\0105cy b\0142\0105d: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113603010243401067)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyst\0105pi\0142 b\0142\0105d podczas renderowania strony b\0142\0119du: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113595003126401061)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d wewn\0119trzny')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113734845005401164)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Prosz\0119 si\0119 skontaktowa\0107 z administratorem.'),
unistr('Szczeg\00F3\0142y tego incydentu s\0105 dost\0119pne poprzez ID "%0" wykrywania b\0142\0119d\00F3w.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113729178696401160)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'pl'
,p_message_text=>'Baza danych jest otwarta tylko do odczytu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113759785513401182)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'pl'
,p_message_text=>unistr('ORA-28353: Nie uda\0142o si\0119 otworzy\0107 portfela. Dane aplikacji nie s\0105 teraz dost\0119pne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113729293386401160)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Ta strona nie jest dost\0119pna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113596795215401062)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'pl'
,p_message_text=>unistr('Informacje techniczne (widoczne tylko dla programist\00F3w)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113692837217401133)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'pl'
,p_message_text=>unistr('Komunikat o b\0142\0119dzie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113706719328401143)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'pl'
,p_message_text=>'Oczekiwany format: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113673492104401119)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'pl'
,p_message_text=>unistr('U\017Cytkownik ju\017C si\0119 znajduje na li\015Bcie kontroli dost\0119pu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113673321853401119)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 potwierdzi\0107 dodanie poni\017Cszych u\017Cytkownik\00F3w (%0) do listy <strong>%1</strong> kontroli dost\0119pu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113673870893401119)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'pl'
,p_message_text=>unistr('Istnieje zduplikowany u\017Cytkownik')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113673541709401119)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'pl'
,p_message_text=>'Brak znaku "@" w adresie e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113673600608401119)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'pl'
,p_message_text=>'Brak kropki "." w adresie e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113673796095401119)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'pl'
,p_message_text=>unistr('Nazwa u\017Cytkownika jest zbyt d\0142uga')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113674065638401119)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'pl'
,p_message_text=>unistr('Dost\0119p do tej aplikacji maj\0105 tylko u\017Cytkownicy zdefiniowani na li\015Bcie kontroli dost\0119pu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113674194350401119)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'pl'
,p_message_text=>unistr('Nieoczekiwana warto\015B\0107 ustawienia listy kontrolnej: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113673926348401119)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'pl'
,p_message_text=>unistr('Dost\0119p do tej aplikacji maj\0105 wszyscy zidentyfikowani u\017Cytkownicy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113716733211401151)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\0142\0105czone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113716670980401151)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'pl'
,p_message_text=>unistr('W\0142\0105czone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113716948513401151)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'pl'
,p_message_text=>unistr('%0: jest wy\0142\0105czone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113716803376401151)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'pl'
,p_message_text=>unistr('%0: jest w\0142\0105czone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113716521904401151)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'pl'
,p_message_text=>'nie zidentyfikowano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113709619723401146)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'pl'
,p_message_text=>'Pobierz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113666136330401113)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'pl'
,p_message_text=>'Zastosowany filtr: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113707202160401144)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'pl'
,p_message_text=>'Zastosuj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113592102736401059)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'pl'
,p_message_text=>unistr('Wykres s\0142upkowy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113719937174401153)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'pl'
,p_message_text=>'Inne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113592232325401059)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wykres ko\0142owy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113718640346401152)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Wykres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113591916698401059)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'pl'
,p_message_text=>'Licznik'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113707789176401144)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyczy\015B\0107')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113707858262401144)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyczy\015B\0107 wszystkie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113707931958401144)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyczy\015B\0107: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113725111097401157)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'pl'
,p_message_text=>unistr('Kolumna "%1", do kt\00F3rej odwo\0142uje si\0119 faseta "%0", jest niedost\0119pna lub nieautoryzowana.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113582370040401052)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 wybra\0107 pokazywane filtry')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113664322749401112)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'pl'
,p_message_text=>unistr('Liczba wynik\00F3w: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113664478891401112)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'pl'
,p_message_text=>'Wybrano: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113667044589401114)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'pl'
,p_message_text=>unistr('Bie\017C\0105ce filtry')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113583805917401053)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'pl'
,p_message_text=>unistr('Lista filtr\00F3w')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113723673609401156)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'pl'
,p_message_text=>unistr('Przekroczono limit (%0) warto\015Bci dystynktywnych dla fasety "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113709286647401145)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>unistr('Faseta "%0" nie jest obs\0142ugiwana dla kolumn typu DATE lub TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113707377935401144)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'pl'
,p_message_text=>'Filtruj: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113707408701401144)
,p_name=>'APEX.FS.GO'
,p_message_language=>'pl'
,p_message_text=>'Wykonaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113708840804401145)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'pl'
,p_message_text=>unistr('r\00F3wna si\0119 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113592983562401060)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'pl'
,p_message_text=>'zawiera %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113592659611401059)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'pl'
,p_message_text=>unistr('wi\0119ksze ni\017C %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113592766593401059)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'pl'
,p_message_text=>unistr('wi\0119ksze ni\017C lub r\00F3wne %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113592424675401059)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'pl'
,p_message_text=>unistr('mniejsze ni\017C %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113592520011401059)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'pl'
,p_message_text=>unistr('mniejsze ni\017C lub r\00F3wne %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113592894298401059)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'pl'
,p_message_text=>unistr('zaczyna si\0119 od %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113595356239401061)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('Typ danych "%0" (%1) nie jest obs\0142ugiwany dla fasety "Pole wej\015Bciowe".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113585592689401054)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'pl'
,p_message_text=>unistr('Fasety wielowarto\015Bciowe wymagaj\0105 baz danych w wersji co najmniej 12.2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113709092468401145)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'pl'
,p_message_text=>unistr('Dla fasety "%0" nie podano \017Cadnych przeszukiwanych kolumn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113582494548401052)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'pl'
,p_message_text=>unistr('Wi\0119cej filtr\00F3w')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113664549485401112)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'pl'
,p_message_text=>unistr('Pocz\0105tek zakresu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113708532555401145)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'pl'
,p_message_text=>'%0 do %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113708674795401145)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'pl'
,p_message_text=>unistr('Powy\017Cej %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113708757850401145)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'pl'
,p_message_text=>unistr('Poni\017Cej %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113664631550401112)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'pl'
,p_message_text=>'Koniec zakresu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113727420180401159)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'pl'
,p_message_text=>unistr('Element #%2 ("%1") listy warto\015Bci dla fasety "%0" typu "Przedzia\0142" jest niepoprawny (brak separatora "|").')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113708988995401145)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'pl'
,p_message_text=>unistr('R\0119czne wprowadzanie danych do fasety "%0" typu "Przedzia\0142" nie jest obs\0142ugiwane, poniewa\017C typem kolumny jest DATE lub TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113708260114401144)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'pl'
,p_message_text=>'do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113592053973401059)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 wykres')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113661162758401110)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'pl'
,p_message_text=>'Resetuj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113707623469401144)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'pl'
,p_message_text=>'Szukaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113707555012401144)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'pl'
,p_message_text=>'Szukaj...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113708423422401144)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'pl'
,p_message_text=>unistr('- Wyb\00F3r -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113591889403401059)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'pl'
,p_message_text=>unistr('Poka\017C wykres')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113708092814401144)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'pl'
,p_message_text=>unistr('Poka\017C mniej')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113708163900401144)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'pl'
,p_message_text=>unistr('Poka\017C wi\0119cej')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113708345121401144)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 i wi\0119cej gwiazdek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113666081954401113)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'pl'
,p_message_text=>'Filtrowanie sugestii'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113709144348401145)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>unistr('Faseta "%0" typu "Pole tekstowe" jest obecnie obs\0142ugiwana tylko dla kolumn typu NUMBER.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113582277742401052)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'pl'
,p_message_text=>unistr('\0141\0105czna liczba wierszy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113725219308401157)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('Typ danych "%0" (%1) nie jest obs\0142ugiwany dla wyszukiwania fasetowego.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113717180215401151)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Przejd\017A do b\0142\0119du')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113674791511401120)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'pl'
,p_message_text=>'Agregacja.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113682363500401125)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'pl'
,p_message_text=>unistr('Zwi\0144 przerw\0119 kontroln\0105')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113674868435401120)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'pl'
,p_message_text=>'Przerwa kontrolna.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113682207831401125)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'pl'
,p_message_text=>unistr('Rozwi\0144 przerw\0119 kontroln\0105')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113760901040401183)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'pl'
,p_message_text=>'Kolumna %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113682055428401125)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'pl'
,p_message_text=>unistr('Liczba usuni\0119tych wierszy: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113752496411401177)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'pl'
,p_message_text=>unistr('Zduplikowana to\017Csamo\015B\0107')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113671779154401117)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'pl'
,p_message_text=>unistr('Na pocz\0105tku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113675084893401120)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'pl'
,p_message_text=>unistr('Nag\0142\00F3wek grupy.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113674923258401120)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'pl'
,p_message_text=>unistr('Nag\0142\00F3wek.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113671822103401118)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'pl'
,p_message_text=>unistr('Na ko\0144cu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113691870330401132)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'pl'
,p_message_text=>unistr('Za\0142aduj wi\0119cej wierszy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113671508750401117)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'pl'
,p_message_text=>'Dalej'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113675121411401120)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'pl'
,p_message_text=>'Wiersze strony'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113671902489401118)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'pl'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113672042723401118)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'pl'
,p_message_text=>'%0 - %1 z %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113728022857401159)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r strony')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113671627842401117)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'pl'
,p_message_text=>'Wstecz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113752271942401177)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'pl'
,p_message_text=>'Dodano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113752360349401177)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'pl'
,p_message_text=>'Zmieniono'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113760711886401183)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'pl'
,p_message_text=>'Wiersz %0, kolumna %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113760817300401183)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'pl'
,p_message_text=>'Wiersz %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113752143046401177)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'pl'
,p_message_text=>unistr('Usuni\0119to')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113675338915401120)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'pl'
,p_message_text=>unistr('Nag\0142\00F3wek wiersza')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113670981342401117)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'pl'
,p_message_text=>unistr('Liczba wybranych kom\00F3rek: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113672154408401118)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'pl'
,p_message_text=>'Liczba wybranych wierszy: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113712431105401148)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'pl'
,p_message_text=>'Wybierz wszystkie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113682105404401125)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'pl'
,p_message_text=>'Strona %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113675263807401120)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r wiersza')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113675460370401120)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'pl'
,p_message_text=>unistr('Sortowane rosn\0105co: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113675530234401120)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'pl'
,p_message_text=>unistr('Sortowane malej\0105co: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113671094885401117)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'pl'
,p_message_text=>unistr('Sortuj rosn\0105co')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113671329754401117)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'pl'
,p_message_text=>unistr('Sortuj rosn\0105co: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113671186198401117)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'pl'
,p_message_text=>unistr('Sortuj malej\0105co')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113671446178401117)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'pl'
,p_message_text=>unistr('Sortuj malej\0105co: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113671229521401117)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'pl'
,p_message_text=>'Nie sortuj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113681997553401125)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'pl'
,p_message_text=>'Razem: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113608310754401071)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'pl'
,p_message_text=>unistr('Niepowodzenie \017C\0105dania HTTP do "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113749678899401175)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'pl'
,p_message_text=>unistr('Tabela - lista wyboru (kolumny: %0, wiersze %1). Prosz\0119 u\017Cywa\0107 klawiszy ze strza\0142kami.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113681890340401125)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'pl'
,p_message_text=>unistr('Lista wyboru z %0 wierszami. Prosz\0119 u\017Cywa\0107 klawiszy ze strza\0142kami.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113760515599401183)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'pl'
,p_message_text=>'Tabela interaktywna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113668657476401115)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'pl'
,p_message_text=>unistr('Czynno\015Bci')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113669657572401116)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'pl'
,p_message_text=>'Dodaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113669535089401116)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'pl'
,p_message_text=>'Dodaj wiersz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113754010621401178)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'pl'
,p_message_text=>'Agregacja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113739528171401168)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'pl'
,p_message_text=>'Agregacja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113741294956401169)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'pl'
,p_message_text=>'Wszystkie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113697640129401137)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>'Wszystkie kolumny tekstowe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113698899691401137)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'pl'
,p_message_text=>'Alternatywny'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113699969319401138)
,p_name=>'APEX.IG.AND'
,p_message_language=>'pl'
,p_message_text=>'i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113719338474401153)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'pl'
,p_message_text=>unistr('Licznik dystynktywny przybli\017Cony')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113755011112401179)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Licznik dystynktywny og\00F3lny przybli\017Cony')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113738168242401167)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'pl'
,p_message_text=>'Warstwowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113740023908401168)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'pl'
,p_message_text=>unistr('Rosn\0105co')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113698940586401138)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'pl'
,p_message_text=>'Autoryzacja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113754185071401178)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'pl'
,p_message_text=>'Automatycznie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113719720484401153)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'pl'
,p_message_text=>unistr('\015Arednia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113754730669401179)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'pl'
,p_message_text=>unistr('\015Arednia og\00F3lna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113737620851401166)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Tytu\0142 osi etykiet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113737866197401166)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'pl'
,p_message_text=>unistr('Liczba miejsc dziesi\0119tnych')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113737751365401166)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Tytu\0142 osi warto\015Bci')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113743842301401171)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'pl'
,p_message_text=>unistr('Kolor t\0142a')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113738274614401167)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'pl'
,p_message_text=>unistr('S\0142upkowy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113694229626401134)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'pl'
,p_message_text=>unistr('mi\0119dzy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113745026350401172)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'pl'
,p_message_text=>'Obie opcje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113738335537401167)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'pl'
,p_message_text=>unistr('P\0119cherzykowy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113669849908401116)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'pl'
,p_message_text=>'Anuluj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113699866597401138)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'pl'
,p_message_text=>unistr('Uwzgl\0119dniana wielko\015B\0107 liter')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113755688988401179)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'pl'
,p_message_text=>unistr('(Z uwzgl\0119dnieniem wielko\015Bci liter)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113726565973401158)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'pl'
,p_message_text=>'Zmiany zapisane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113670262968401116)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'pl'
,p_message_text=>unistr('Zmie\0144 widok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113700935697401139)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'pl'
,p_message_text=>'Wykres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113697424455401136)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'pl'
,p_message_text=>unistr('Zapytanie przekracza maksymaln\0105 liczb\0119 punkt\00F3w danych (%0) przypadaj\0105cych na wykres. Prosz\0119 zastosowa\0107 filtr, aby ograniczy\0107 liczb\0119 rekord\00F3w dla zapytania.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113668541721401115)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'pl'
,p_message_text=>'Schemat organizacyjny'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113675815744401121)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyczy\015B\0107')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113737157560401166)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('Zamkni\0119cie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113744082087401171)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'pl'
,p_message_text=>'Kolory'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113720177412401153)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'pl'
,p_message_text=>unistr('Podgl\0105d')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113699295626401138)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Kolumna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113668790539401115)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'pl'
,p_message_text=>'Kolumny'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113745846813401172)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'pl'
,p_message_text=>'Przeznaczenie kolumny'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113699365927401138)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'pl'
,p_message_text=>unistr('Z\0142o\017Cony')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113668913145401115)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'pl'
,p_message_text=>'Oblicz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113694867250401135)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'pl'
,p_message_text=>'zawiera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113701187866401139)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'pl'
,p_message_text=>'Przerwa kontrolna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113675681805401120)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'pl'
,p_message_text=>'Kopiuj do Schowka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113675701685401120)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'pl'
,p_message_text=>unistr('Kopiuj w d\00F3\0142')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113719162865401153)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'pl'
,p_message_text=>'Licznik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113719292909401153)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'pl'
,p_message_text=>'Licznik dystynktywny'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113754933169401179)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Licznik dystynktywny og\00F3lny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113754853056401179)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Licznik og\00F3lny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113752515642401177)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'pl'
,p_message_text=>unistr('Utw\00F3rz: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113697878734401137)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'pl'
,p_message_text=>'Dane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113745672833401172)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'pl'
,p_message_text=>'Typ danych'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113745292556401172)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'pl'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113726301604401158)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'pl'
,p_message_text=>unistr('Niepoprawna warto\015B\0107 daty')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113695512063401135)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'pl'
,p_message_text=>'dni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113698506240401137)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'pl'
,p_message_text=>unistr('Ustawienia domy\015Blne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113698369706401137)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('Typ domy\015Blny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113669718394401116)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113746863853401173)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'pl'
,p_message_text=>unistr('Czy na pewno usun\0105\0107 ten raport?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113702990867401140)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 wiersz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113701780894401140)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 wiersze')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113740106166401168)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'pl'
,p_message_text=>unistr('Malej\0105co')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113700693458401139)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'pl'
,p_message_text=>unistr('Szczeg\00F3\0142y')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113668275066401115)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'pl'
,p_message_text=>unistr('Widok szczeg\00F3\0142\00F3w')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113728887086401160)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'pl'
,p_message_text=>'Kierunek'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113700369389401139)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\0142\0105czone')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113694906460401135)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'pl'
,p_message_text=>'nie zawiera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113695161163401135)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'pl'
,p_message_text=>unistr('nie zaczyna si\0119 od')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113738402863401167)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'pl'
,p_message_text=>'Torusowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113701363503401139)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'pl'
,p_message_text=>'Pobierz'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113600016537401065)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'pl'
,p_message_text=>'Tylko dane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113747862714401174)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r formatu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113612617735401074)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'pl'
,p_message_text=>unistr('Format pobierania "%0" nie jest w\0142\0105czony.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113740890517401169)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'pl'
,p_message_text=>'Zduplikowana agregacja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113740983227401169)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'pl'
,p_message_text=>'Zduplikowana przerwa kontrolna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113702862455401140)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'pl'
,p_message_text=>'Duplikuj wiersze'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113701626192401139)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'pl'
,p_message_text=>'Duplikuj wiersze'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113669363505401116)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'pl'
,p_message_text=>'Edytuj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113739912994401168)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'pl'
,p_message_text=>'Edytuj wykres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113751426718401176)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'pl'
,p_message_text=>'Edytuj "Grupuj wg"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113747428152401173)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'pl'
,p_message_text=>'Kopia ukryta (Udw)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113747616642401173)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'pl'
,p_message_text=>unistr('Wiadomo\015B\0107')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113747375291401173)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'pl'
,p_message_text=>'Kopia (Dw)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113747081049401173)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'pl'
,p_message_text=>unistr('E-mail wys\0142any.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113747519239401173)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'pl'
,p_message_text=>'Temat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113747276092401173)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'pl'
,p_message_text=>'Odbiorca (Do)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113700032641401138)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'pl'
,p_message_text=>unistr('W\0142\0105czone')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113693287683401133)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'pl'
,p_message_text=>unistr('r\00F3wna si\0119')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113746491454401173)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Przyk\0142ad')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113700105257401138)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyra\017Cenie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113746366691401172)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'pl'
,p_message_text=>'Typ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113712393529401148)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'pl'
,p_message_text=>'Plik przygotowany. Rozpoczynanie pobierania.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113675966792401121)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'pl'
,p_message_text=>unistr('Wype\0142nij')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113677096072401121)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'pl'
,p_message_text=>unistr('Wype\0142nij wyb\00F3r, u\017Cywaj\0105c:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113676939828401121)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wype\0142nij wyb\00F3r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113668845148401115)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'pl'
,p_message_text=>'Filtruj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113699413462401138)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'pl'
,p_message_text=>'Filtry'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113754400024401178)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'pl'
,p_message_text=>'Filtruj...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113740329759401168)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'pl'
,p_message_text=>unistr('Na pocz\0105tku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113669075738401115)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'pl'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113697996091401137)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'pl'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113744971646401171)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'pl'
,p_message_text=>'Maska formatu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113746760938401173)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'pl'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113746617421401173)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'pl'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113659440933401108)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'pl'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113598754666401064)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'pl'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113702529214401140)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'pl'
,p_message_text=>unistr('Zamro\017A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113700230223401138)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'pl'
,p_message_text=>'Funkcje i operatory'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113738519322401167)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'pl'
,p_message_text=>'Lejkowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113719027535401153)
,p_name=>'APEX.IG.GO'
,p_message_language=>'pl'
,p_message_text=>'Wykonaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113693881315401134)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'pl'
,p_message_text=>unistr('wi\0119ksze ni\017C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113693969205401134)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'pl'
,p_message_text=>unistr('wi\0119ksze ni\017C lub r\00F3wne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113700553474401139)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'pl'
,p_message_text=>'Tabela'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113668068156401115)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'pl'
,p_message_text=>'Widok tabeli'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113741187762401169)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'pl'
,p_message_text=>'Grupa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113700749329401139)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'pl'
,p_message_text=>'Grupuj wg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113668320206401115)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'pl'
,p_message_text=>'Widok grupowania wg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113745507526401172)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'pl'
,p_message_text=>'Typ warunku'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113744466652401171)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'pl'
,p_message_text=>unistr('Nag\0142\00F3wek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113744641291401171)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyr\00F3wnanie nag\0142\00F3wka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113754345250401178)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'pl'
,p_message_text=>'Pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113749819239401175)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>W tej tabeli interaktywnej mo\017Cna bezpo\015Brednio wstawia\0107, aktualizowa\0107 i usuwa\0107 dane.</p>'),
'',
unistr('<p>Aby wstawi\0107 nowy wiersz, nale\017Cy klikn\0105\0107 przycisk "Dodaj wiersz".</p>'),
'',
unistr('<p>Aby edytowa\0107 istniej\0105ce dane, nale\017Cy klikn\0105\0107 dwukrotnie odpowiedni\0105 kom\00F3rk\0119. Przy wi\0119kszych pracach edycyjnych mo\017Cna si\0119 prze\0142\0105czy\0107 do trybu edycji, klikaj\0105c "Edytuj". W trybie edycji mo\017Cna edytowa\0107 poszczeg\00F3lne kom\00F3rki, klikaj\0105c je lub korzystaj\0105')
||'c z klawiatury.</p>',
'',
unistr('<p>Do duplikowania lub usuwania wierszy nale\017Cy u\017Cy\0107 menu "Zmie\0144". Aby w\0142\0105czy\0107 menu "Zmie\0144", nale\017Cy wybra\0107 jeden lub wi\0119ksz\0105 liczb\0119 wierszy, zaznaczaj\0105c ich pola wyboru.</p>'),
'',
unistr('<p>Aby zduplikowa\0107 wybrany wiersz, nale\017Cy wybra\0107 z menu "Zmie\0144" opcj\0119 "Zduplikuj wiersze". Aby usun\0105\0107 wybrany wiersz, nale\017Cy wybra\0107 z menu "Zmie\0144" opcj\0119 "Usu\0144 wiersz".</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113751912451401176)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'pl'
,p_message_text=>unistr('Mo\017Cliwo\015Bci edycyjne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113752085377401177)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Tabela interaktywna przedstawia zbi\00F3r danych w postaci przeszukiwalnego, dostosowywalnego raportu. Mo\017Cna wykonywa\0107 r\00F3\017Cne operacje maj\0105ce na celu ograniczenie liczby zwracanych rekord\00F3w, a tak\017Ce zmienia\0107 spos\00F3b wy\015Bwietlania danych.</p>'),
'',
unistr('<p>Do filtrowania zwracanych rekord\00F3w s\0142u\017Cy pole "Szukaj". Klikaj\0105c "Czynno\015Bci", uzyskuje si\0119 dost\0119p do opcji umo\017Cliwiaj\0105cych modyfikowanie uk\0142adu raportu; mo\017Cna te\017C korzysta\0107 z menu "Nag\0142\00F3wek kolumny" z wy\015Bwietlanych kolumn.</p>'),
'',
unistr('<p>Z obszaru "Ustawienia raportu" mo\017Cna zapisa\0107 dostosowania raportu. Mo\017Cna tak\017Ce pobra\0107 dane z raportu do pliku zewn\0119trznego b\0105d\017A wys\0142a\0107 je e-mailem do siebie lub do innych u\017Cytkownik\00F3w.</p>'),
'',
unistr('<p>Wi\0119cej informacji mo\017Cna znale\017A\0107 w rozdziale "Using Interactive Grids" w podr\0119czniku <em>Oracle Application Express End User''s Guide</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113751729021401176)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'pl'
,p_message_text=>unistr('Przegl\0105d')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113749728407401175)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Korzystaj\0105c z wbudowanych mo\017Cliwo\015Bci, mo\017Cna dostosowa\0107 tabel\0119 interaktywn\0105, tak aby dane by\0142y wy\015Bwietlane w inny spos\00F3b.</p>'),
'',
unistr('<p>Za pomoc\0105 menu "Nag\0142\00F3wek kolumny" lub menu "Czynno\015Bci" mo\017Cna okre\015Bla\0107 wy\015Bwietlane kolumny oraz ich kolejno\015B\0107, a tak\017Ce zamra\017Ca\0107 kolumny. Mo\017Cna r\00F3wnie\017C definiowa\0107 r\00F3\017Cne filtry danych i sortowa\0107 zwracane dane.</p>'),
'',
unistr('<p>Za pomoc\0105 s\0105siaduj\0105cego z polem "Szukaj" przycisku "Widok" mo\017Cna uzyskiwa\0107 dost\0119p do innych widok\00F3w danych, kt\00F3re mog\0142y zosta\0107 zdefiniowane przez tw\00F3rc\0119 aplikacji. Mo\017Cna r\00F3wnie\017C utworzy\0107 wykres lub wy\015Bwietli\0107 ju\017C istniej\0105cy.</p>  '),
'',
unistr('<p><em>Uwaga: Klikaj\0105c <strong>Pomoc</strong> w okna dialogowych dla tabeli interaktywnej, mo\017Cna uzyska\0107 bardziej szczeg\00F3\0142owe informacje o wybranej funkcji.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113751807688401176)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'pl'
,p_message_text=>unistr('Mo\017Cliwo\015Bci raportowe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113701573259401139)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Tabela interaktywna - pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113748686401401174)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Za pomoc\0105 tego okna dialogowego mo\017Cna agregowa\0107 kolumny. Zagregowane warto\015Bci s\0105 wy\015Bwietlane na dole danych albo - je\015Bli zosta\0142y zdefiniowane przerwy kontrolne - na dole ka\017Cdej przerwy.</p>'),
'',
'<p><strong>Lista agregacji</strong><br>',
unistr('Na li\015Bcie agregacji s\0105 wy\015Bwietlane zdefiniowane agregacje. Mo\017Cna je wy\0142\0105cza\0107, czyszcz\0105c ich pola wyboru.<br>'),
unistr('Aby utworzy\0107 now\0105 agregacj\0119, nale\017Cy klikn\0105\0107 ikon\0119 "Dodaj" ( &plus; ); aby usun\0105\0107 istniej\0105c\0105 agregacj\0119 - ikon\0119 "Usu\0144" ( &minus; ).</p>'),
'',
'<p><strong>Ustawienia agregacji</strong><br>',
unistr('Za pomoc\0105 formularza, znajduj\0105cego si\0119 po prawej stronie, mo\017Cna zdefiniowa\0107 agregacj\0119.<br>'),
unistr('Nale\017Cy wybra\0107 nazw\0119 kolumny i typ agregacji.<br>'),
unistr('Opcjonalnie mo\017Cna wprowadzi\0107 etykietk\0119 agregacji.<br>'),
unistr('Je\015Bli zosta\0142a zdefiniowana przerwa kontrolna, to - gdy zostanie wybrana opcja <strong>Poka\017C warto\015B\0107 og\00F3ln\0105</strong> - na dole danych b\0119dzie wy\015Bwietlana \015Brednia og\00F3lna, podsumowanie og\00F3lne lub inna podobna warto\015B\0107.</p>'),
'',
unistr('<p><em>Uwaga: Dost\0119p do okna dialogowego agregacji mo\017Cna uzyska\0107 z menu "Czynno\015Bci" lub klikaj\0105c nag\0142\00F3wek kolumny i symbol sumy ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113750809070401176)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Agregacja - pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113749323642401175)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Za pomoc\0105 tego okna dialogowego mo\017Cna zdefiniowa\0107 wykres, kt\00F3ry ma by\0107 wy\015Bwietlany jako osobny widok danych.<br>'),
unistr('Nale\017Cy wybra\0107 typ i atrybuty wykresu.</p>'),
'<p><strong>Atrybuty wykresu</strong></br>',
unistr('W zale\017Cno\015Bci od typu wykresu s\0105 dost\0119pne r\00F3\017Cne atrybuty wykresu.</p>'),
'<p>',
'<ul>',
unistr('  <li>Nale\017Cy wybra\0107 kolumn\0119 zawieraj\0105c\0105 warto\015B\0107 atrybutu:'),
'    <ul>',
unistr('      <li>Etykieta - tekst dla ka\017Cdego z punkt\00F3w danych.</li>'),
unistr('      <li>Warto\015B\0107 - dane prezentowane na wykresie.</li>'),
unistr('      <li>Serie - u\017Cywane do definiowania wieloseryjnych zapyta\0144 dynamicznych.</li>'),
unistr('      <li>Otwarcie - dzienna gie\0142dowa cena otwarcia (tylko wykres gie\0142dowy)</li>'),
unistr('      <li>Zamkni\0119cie - dzienna gie\0142dowa cena zamkni\0119cia (tylko wykres gie\0142dowy)</li>'),
unistr('      <li>Maksimum - warto\015B\0107 maksymalna (tylko wykresy zakresowy i gie\0142dowy).</li>'),
unistr('      <li>Minimum - warto\015B\0107 minimalna (tylko wykresy zakresowy i gie\0142dowy).</li>'),
unistr('      <li>Wolumen - dzienny wolumen gie\0142dowy (tylko wykres gie\0142dowy).</li>'),
unistr('      <li>Cel - warto\015B\0107 celu (tylko wykres lejkowy).</li>'),
unistr('      <li>X - warto\015B\0107 na osi X (tylko wykresy p\0119cherzykowy i punktowy).</li>'),
unistr('      <li>Y - warto\015B\0107 na osi Y (tylko wykresy p\0119cherzykowy i punktowy).</li>'),
unistr('      <li>Z - szeroko\015B\0107 s\0142upka lub promie\0144 p\0119cherzyka (tylko wykresy s\0142upkowy, p\0119cherzykowy i zakresowy).</li>'),
'    </ul>',
'  </li>',
'  <li>Orientacja - pionowo lub poziomo.</li>',
unistr('  <li>Agregacja - wyb\00F3r sposobu agregowania powi\0105zanych warto\015Bci wykresu.</li>'),
unistr('  <li>Stos - okre\015Blenie, czy elementy danych maj\0105 by\0107 ustawiane w formie stosu.</li>'),
unistr('  <li>Sortuj wg - sortowanie wed\0142ug etykiety lub warto\015Bci.'),
'    <ul>',
unistr('      <li>Kierunek - sortowanie warto\015Bci w porz\0105dku rosn\0105cym lub malej\0105cym.</li>'),
unistr('      <li>Warto\015Bci Null - okre\015Blenie sposobu sortowania rekord\00F3w z warto\015Bciami Null wzgl\0119dem rekord\00F3w z warto\015Bciami innymi ni\017C Null.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>Liczba miejsc dziesi\0119tnych</li>'),
unistr('  <li>Tytu\0142 osi etykiet</li>'),
unistr('  <li>Tytu\0142 osi warto\015Bci</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113751276307401176)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Wykres - pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113748345673401174)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Za pomoc\0105 tego okna dialogowego mo\017Cna okre\015Bli\0107, kt\00F3re kolumny maj\0105 by\0107 wy\015Bwietlane i w jakiej kolejno\015Bci.</p>'),
'',
unistr('<p>Aby ukry\0107 kolumn\0119, nale\017Cy wyczy\015Bci\0107 jej pole wyboru.<br>'),
unistr('Aby zmieni\0107 kolejno\015B\0107 kolumn, nale\017Cy klika\0107 ikon\0119 "Przenie\015B w g\00F3r\0119" ( &uarr; ) lub "Przenie\015B w d\00F3\0142" ( &darr; ).<br>'),
unistr('Korzystaj\0105c z rozwijanego selektora, mo\017Cna wybra\0107 wszystkie kolumny, wy\015Bwietlane kolumny lub niewy\015Bwietlane kolumny.</p>'),
'',
unistr('<p>Opcjonalnie mo\017Cna za pomoc\0105 formularza okre\015Bli\0107 (w pikselach) minimaln\0105 szeroko\015B\0107 kolumny.</p>'),
'',
unistr('<p><em>Uwaga: Kolejno\015B\0107 wy\015Bwietlanych kolumn mo\017Cna zmieni\0107, klikaj\0105c uchwyt kolumny (na pocz\0105tku jej nag\0142\00F3wka) i przeci\0105gaj\0105c j\0105 w lewo lub w prawo. Szeroko\015B\0107 wy\015Bwietlanych kolumn mo\017Cna zmieni\0107, klikaj\0105c separator kolumn (mi\0119dzy nag\0142\00F3wkami kolumn) i ')
||unistr('przeci\0105gaj\0105c go w lewo lub w prawo.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113751154076401176)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Kolumny - pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113748782740401174)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Za pomoc\0105 tego okna dialogowego mo\017Cna zdefiniowa\0107 dodatkowe kolumny oparte na obliczeniach matematycznych i przeprowadzanych z u\017Cyciem funkcji w odniesieniu do istniej\0105cych kolumn.</p>'),
'',
unistr('<p><strong>Lista oblicze\0144</strong><br>'),
unistr('Na li\015Bcie oblicze\0144 s\0105 wy\015Bwietlane zdefiniowane obliczenia. Mo\017Cna je wy\0142\0105cza\0107, czyszcz\0105c ich pola wyboru.<br>'),
unistr('Aby utworzy\0107 nowe obliczenie, nale\017Cy klikn\0105\0107 ikon\0119 "Dodaj" ( &plus; ); aby usun\0105\0107 istniej\0105ce obliczenie - ikon\0119 "Usu\0144" ( &minus; ).</p>'),
'',
'<p><strong>Ustawienia obliczenia</strong><br>',
unistr('Za pomoc\0105 formularza mo\017Cna zdefiniowa\0107 obliczenie.<br>'),
unistr('Nale\017Cy wprowadzi\0107 szczeg\00F3\0142y kolumny (takie jak nag\0142\00F3wek i etykieta) oraz wybra\0107 ustawienia wyr\00F3wnania.<br>'),
unistr('W obszarze tekstowym "Wyra\017Cenie" nale\017Cy wprowadzi\0107 kolumny i powi\0105zane funkcje, u\017Cywane w obliczeniu.<br>'),
unistr('Nale\017Cy wybra\0107 dla nowej kolumny odpowiedni typ danych i - opcjonalnie - mask\0119 formatu.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113750714880401176)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Obliczanie - pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113749096158401174)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Za pomoc\0105 tego okna dialogowego mo\017Cna zdefiniowa\0107 przerw\0119 kontroln\0105 dla jednej kolumny lub wi\0119kszej ich liczby.</p>'),
'',
'<p><strong>Lista przerw kontrolnych</strong><br>',
unistr('Na li\015Bcie przerw kontrolnych s\0105 wy\015Bwietlane zdefiniowane przerwy kontrolne. Istniej\0105c\0105 kolumn\0119 przerwy kontrolnej mo\017Cna wy\0142\0105czy\0107, czyszcz\0105c pole wyboru kolumny.<br>'),
unistr('Aby doda\0107 do przerwy kontrolnej now\0105 kolumn\0119, nale\017Cy klikn\0105\0107 ikon\0119 "Dodaj" ( &plus; ); aby usun\0105\0107 istniej\0105c\0105 kolumny z przerwy kontrolnej - ikon\0119 "Usu\0144" ( &minus; ).<br>'),
unistr('Aby przenie\015B\0107 wybran\0105 kolumn\0119 w g\00F3r\0119 lub w d\00F3\0142 wzgl\0119dem innych kolumn, nale\017Cy klika\0107 ikon\0119 "Przenie\015B w g\00F3r\0119" ( &uarr; ) lub "Przenie\015B w d\00F3\0142" ( &darr; ).</p>'),
'',
'<p><strong>Ustawienia przerwy kontrolnej</strong><br>',
unistr('Za pomoc\0105 formularza mo\017Cna zdefiniowa\0107 kolumn\0119 przerwy kontrolnej.<br>'),
unistr('Nale\017Cy wybra\0107 kolumn\0119 przerwy kontrolnej, porz\0105dek sortowania oraz spos\00F3b porz\0105dkowania kolumn z warto\015Bciami Null (kolumny niezawieraj\0105ce warto\015Bci).</p>'),
'',
unistr('<p><em>Uwaga: Wy\015Bwietlaj\0105c tabel\0119 interaktywn\0105, mo\017Cna zdefiniowa\0107 przerw\0119 kontroln\0105, klikaj\0105c nag\0142\00F3wek kolumny i wybieraj\0105c ikon\0119 przerwy kontrolnej.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113750493538401175)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Przerwa kontrolna - pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113749237367401175)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Za pomoc\0105 tego okna dialogowego mo\017Cna pobra\0107 wszystkie bie\017C\0105ce wiersze do pliku zewn\0119trznego. Zostan\0105 w nim zawarte tylko obecnie wy\015Bwietlane kolumny z u\017Cyciem filtr\00F3w i sortowa\0144 zastosowanych do danych.</p>'),
'',
unistr('<p>Nale\017Cy wybra\0107 format pliku, po czym klikn\0105\0107 "Pobierz".<br>'),
unistr('Uwaga: Plik CSV nie b\0119dzie zawiera\0142 formatowania, takiego jak agregacje i przerwy kontrolne.</p>'),
'',
unistr('<p>Aby wys\0142a\0107 plik e-mailem, nale\017Cy wybra\0107 opcj\0119 "Wy\015Blij jako e-mail", po czym wprowadzi\0107 odbiorc\0119, temat i wiadomo\015B\0107.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113750299361401175)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Pobieranie - pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113748454959401174)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Za pomoc\0105 tego okna dialogowego mo\017Cna skonfigurowa\0107 filtry danych, ograniczaj\0105ce zwracane wiersze.</p>'),
'',
unistr('<p><strong>Lista filtr\00F3w</strong><br>'),
unistr('Na li\015Bcie filtr\00F3w s\0105 wy\015Bwietlane zdefiniowane filtry. Mo\017Cna je wy\0142\0105cza\0107, czyszcz\0105c ich pola wyboru.<br>'),
unistr('Aby utworzy\0107 nowy filtr, nale\017Cy klikn\0105\0107 ikon\0119 "Dodaj" ( &plus; ); aby usun\0105\0107 istniej\0105cy filtr - ikon\0119 "Usu\0144" ( &minus; ).</p>'),
'',
'<p><strong>Ustawienia filtra</strong><br>',
unistr('Za pomoc\0105 formularza mo\017Cna zdefiniowa\0107 w\0142a\015Bciwo\015Bci filtra.<br>'),
unistr('Nale\017Cy wybra\0107 odpowiedni typ filtra:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Wiersz - filtrowanie terminu wyst\0119puj\0105cego w dowolnej filtrowalnej kolumnie.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Kolumna - filtrowanie konkretnej kolumny przy u\017Cyciu okre\015Blonego operatora i okre\015Blonej warto\015Bci.</p>'),
'',
unistr('<p><em>Uwaga: Wy\015Bwietlaj\0105c tabel\0119 interaktywn\0105, mo\017Cna definiowa\0107 filtry wierszy, wpisuj\0105c termin bezpo\015Brednio w polu "Szukaj". Klikaj\0105c "Wyb\00F3r przeszukiwanych kolumn", mo\017Cna ograniczy\0107 wyszukiwanie do okre\015Blonej kolumny. Alternatywnie mo\017Cna - w celu ')
||unistr('utworzenia filtra kolumny - wybra\0107 z menu "Nag\0142\00F3wek kolumny" odpowiedni\0105 warto\015B\0107.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113751067830401176)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Filtrowanie - pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113748861734401174)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Za pomoc\0105 tego okna dialogowego mo\017Cna wy\015Bwietli\0107 dane tak, jak istnia\0142y we wcze\015Bniejszym punkcie w czasie.</p>'),
unistr('<p>Aby uruchomi\0107 zapytanie Flashback, prosz\0119 okre\015Bli\0107 punkt w przesz\0142o\015Bci, wprowadzaj\0105c odpowiedni\0105 liczb\0119 minut.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113750646109401176)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Flashback - pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113751371833401176)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Grupuj wg - pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113748931263401174)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Za pomoc\0105 tego okna dialogowego mo\017Cna wyr\00F3\017Cni\0107 wiersze lub kolumny danych na podstawie wprowadzonych warunk\00F3w.</p>'),
'',
unistr('<p><strong>Lista wyr\00F3\017Cnie\0144</strong><br>'),
unistr('Na li\015Bcie wyr\00F3\017Cnie\0144 s\0105 wy\015Bwietlane zdefiniowane wyr\00F3\017Cnienia. Mo\017Cna je wy\0142\0105cza\0107, czyszcz\0105c ich pola wyboru.<br>'),
unistr('Aby utworzy\0107 nowe wyr\00F3\017Cnienie, nale\017Cy klikn\0105\0107 ikon\0119 "Dodaj" ( &plus; ); aby usun\0105\0107 istniej\0105ce wyr\00F3\017Cnienie - ikon\0119 "Usu\0144" ( &minus; ).</p>'),
'',
unistr('<p><strong>Ustawienia wyr\00F3\017Cnienia</strong><br>'),
unistr('Za pomoc\0105 formularza mo\017Cna zdefiniowa\0107 w\0142a\015Bciwo\015Bci wyr\00F3\017Cnienia.<br>'),
unistr('Nale\017Cy wprowadzi\0107 nazw\0119, wybra\0107 opcj\0119 "Wiersz" lub "Kolumna", po czym wybra\0107 kody HTML kolor\00F3w t\0142a i tekstu.<br>'),
unistr('Aby wyr\00F3\017Cni\0107 okre\015Blone dane, nale\017Cy wybra\0107 odpowiedni <strong>Typ warunku</strong>:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Wiersz - wyr\00F3\017Cnianie terminu wyst\0119puj\0105cego w dowolnej kolumnie.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Kolumna - wyr\00F3\017Cnianie w konkretnej kolumnie przy u\017Cyciu okre\015Blonego operatora i okre\015Blonej warto\015Bci.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113750511885401175)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyr\00F3\017Cnianie - pomoc')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113749140309401174)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Za pomoc\0105 tego okna dialogowego mo\017Cna zapisa\0107 zmiany, kt\00F3re zosta\0142y dokonane w uk\0142adzie i konfiguracji bie\017C\0105cej tabeli.<br>'),
unistr('Tw\00F3rcy aplikacji mog\0105 definiowa\0107 r\00F3\017Cne alternatywne uk\0142ady raportu. Tam, gdzie jest to dozwolone, bie\017C\0105cy u\017Cytkownik i inni u\017Cytkownicy ko\0144cowi mog\0105 zapisa\0107 raport jako publiczny, wskutek czego staje si\0119 on dost\0119pny dla wszystkich innych u\017Cytkownik\00F3w')
||unistr(' tabeli. U\017Cytkownik mo\017Ce tak\017Ce zapisa\0107 raport jako prywatny i w\00F3wczas tylko ten u\017Cytkownik b\0119dzie m\00F3g\0142 go wy\015Bwietli\0107.</p>'),
unistr('<p>Nale\017Cy wybra\0107 jeden z dost\0119pnych typ\00F3w i wprowadzi\0107 nazw\0119 zapisywanego raportu.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113750307558401175)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Raport - pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113748507409401174)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Za pomoc\0105 tego okna dialogowego mo\017Cna okre\015Bli\0107 kolejno\015B\0107 wy\015Bwietlania.</p>'),
'',
'<p><strong>Lista sortowania</strong><br>',
unistr('W oknie dialogowym sortowania jest wy\015Bwietlana lista skonfigurowanych regu\0142 sortowania.<br>'),
unistr('Aby utworzy\0107 kolumn\0119 sortowania, nale\017Cy klikn\0105\0107 ikon\0119 "Dodaj" ( &plus; ); aby usun\0105\0107 kolumn\0119 sortowania - ikon\0119 "Usu\0144" ( &minus; ).<br>'),
unistr('Aby przenie\015B\0107 wybran\0105 kolumn\0119 sortowania w g\00F3r\0119 lub w d\00F3\0142 wzgl\0119dem innych kolumn sortowania, nale\017Cy klika\0107 ikon\0119 "Przenie\015B w g\00F3r\0119" ( &uarr; ) lub "Przenie\015B w d\00F3\0142" ( &darr; ).</p>'),
'',
'<p><strong>Ustawienia sortowania</strong><br>',
unistr('Nale\017Cy wybra\0107 kolumn\0119 sortowania, porz\0105dek sortowania oraz spos\00F3b porz\0105dkowania kolumn z warto\015Bciami Null (kolumny niezawieraj\0105ce warto\015Bci).</p>'),
'',
unistr('<p><em>Uwaga: Dane mo\017Cna sortowa\0107 wed\0142ug kolumn, kt\00F3re nie s\0105 wy\015Bwietlane; nie wszystkie jednak kolumny s\0105 sortowalne.</em><br>'),
unistr('<em>Wy\015Bwietlane kolumny mo\017Cna sortowa\0107, naciskaj\0105c strza\0142k\0119 skierowan\0105 w g\00F3r\0119 (porz\0105dek rosn\0105cy) lub w d\00F3\0142 (porz\0105dek malej\0105cy), wy\015Bwietlan\0105 na ko\0144cu nag\0142\00F3wka kolumny. Aby doda\0107 kolejn\0105 kolumn\0119 do istniej\0105cego sortowania, nale\017Cy przy naci\015Bni\0119tym klawi')
||unistr('szu Shift klikn\0105\0107 strza\0142k\0119 skierowan\0105 w d\00F3\0142 lub w g\00F3r\0119.</em></p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113750992781401176)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Sortowanie - pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113750140684401175)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Subskrypcja - pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113702405655401140)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'pl'
,p_message_text=>'Ukryj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113669229398401116)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyr\00F3\017Cnij')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113737256265401166)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Maksimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113738054845401166)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'pl'
,p_message_text=>'Poziomy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113695457759401135)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'pl'
,p_message_text=>'godz.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113700419810401139)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'pl'
,p_message_text=>'Ikona'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113668177911401115)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'pl'
,p_message_text=>'Widok ikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113693636885401134)
,p_name=>'APEX.IG.IN'
,p_message_language=>'pl'
,p_message_text=>'w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113702056056401140)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'pl'
,p_message_text=>'Ustawienie nieaktywne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113702146595401140)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'pl'
,p_message_text=>'Ustawienia nieaktywne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113709757307401146)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyst\0105pi\0142 b\0142\0105d wewn\0119trzny podczas przetwarzania \017C\0105dania zwi\0105zanego z tabel\0105 interaktywn\0105.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113605583691401069)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('Typ "%0" filtra kolumn nie jest obs\0142ugiwany dla kolumny "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113749937916401175)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawny format daty'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113724150174401156)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('Tabela interaktywna nie obs\0142uguje definiowania filtra opartego na kolumnie %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113724055539401156)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'pl'
,p_message_text=>'%0 nie jest poprawnym typem (typem filtra) do definiowania filtra tabeli interaktywnej.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113610664439401073)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawny format liczby'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113752665412401177)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawne ustawienie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113752744399401177)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawne ustawienia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113743724784401171)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'pl'
,p_message_text=>unistr('"Sortuj wg" ustawiono na "%0", lecz dla "%0" nie wybrano \017Cadnej kolumny.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113741080271401169)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'pl'
,p_message_text=>unistr('Niepoprawna warto\015B\0107')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113736117000401165)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Niewy\015Bwietlane')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113694457451401134)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'pl'
,p_message_text=>'w ostat.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113694619302401134)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'pl'
,p_message_text=>'w nast.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113693572216401134)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'pl'
,p_message_text=>'nie jest puste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113693451727401133)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'pl'
,p_message_text=>'jest puste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113744545724401171)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'pl'
,p_message_text=>'Etykieta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113736507274401165)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Etykieta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113740478856401168)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'pl'
,p_message_text=>unistr('Na ko\0144cu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113683701598401126)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'pl'
,p_message_text=>unistr('Ostatni dzie\0144')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113683952221401127)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'pl'
,p_message_text=>'Ostatnia godzina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113684414036401127)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'pl'
,p_message_text=>'Ostatnia minuta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113683477277401126)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'pl'
,p_message_text=>unistr('Ostatni miesi\0105c')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113683571472401126)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'pl'
,p_message_text=>unistr('Ostatni tydzie\0144')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113683600127401126)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'pl'
,p_message_text=>'Ostatnie dni (%0)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113683803606401126)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'pl'
,p_message_text=>'Ostatnie godziny (%0)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113684533560401127)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'pl'
,p_message_text=>'Ostanie minuty (%0)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113684320746401127)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'pl'
,p_message_text=>unistr('Ostatnie miesi\0105ce (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113684299404401127)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'pl'
,p_message_text=>'Ostatnie tygodnie (%0)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113683205389401126)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'pl'
,p_message_text=>'Ostatnie lata (%0)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113683373665401126)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'pl'
,p_message_text=>'Ostatni rok'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113744752530401171)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyr\00F3wnanie kom\00F3rki')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113744892953401171)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'pl'
,p_message_text=>unistr('U\017Cyj grupy dla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113694033012401134)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'pl'
,p_message_text=>unistr('mniejsze ni\017C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113694105465401134)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'pl'
,p_message_text=>unistr('mniejsze ni\017C lub r\00F3wne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113738652768401167)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'pl'
,p_message_text=>'Liniowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113738709649401167)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'pl'
,p_message_text=>'Liniowo-warstwowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113745172425401172)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'pl'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113737360002401166)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113747728949401173)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'pl'
,p_message_text=>unistr('Adresy nale\017Cy rozdzieli\0107 przecinkiem')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113695272157401135)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'pl'
,p_message_text=>unistr('zgodne z wyra\017Ceniem regularnym')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113719638307401153)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'pl'
,p_message_text=>'Maksimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113755254980401179)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Maksimum og\00F3lne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113719849048401153)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'pl'
,p_message_text=>'Mediana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113755368536401179)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Mediana og\00F3lna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113719559433401153)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'pl'
,p_message_text=>'Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113695344716401135)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'pl'
,p_message_text=>'min'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113720300826401154)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'pl'
,p_message_text=>'min temu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113755118877401179)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Minimum og\00F3lne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113695755730401135)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'pl'
,p_message_text=>'mies.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113702316072401140)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'pl'
,p_message_text=>unistr('Dane zawieraj\0105 ponad %0 wierszy, przekraczaj\0105c dozwolony limit. Aby mo\017Cna by\0142o wy\015Bwietli\0107 wyniki, prosz\0119 zastosowa\0107 dodatkowe filtry.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113729010819401160)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Trzeba okre\015Bli\0107 statyczny ID obszaru, poniewa\017C strona zawiera wi\0119cej ni\017C jedn\0105 tabel\0119 interaktywn\0105.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113698441149401137)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'pl'
,p_message_text=>'Nazwa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113698659701401137)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'pl'
,p_message_text=>'Nazwany raport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113682612061401126)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pny dzie\0144')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113682434360401125)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pna godzina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113684656414401127)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pna minuta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113682928237401126)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pny miesi\0105c')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113682832339401126)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pny tydzie\0144')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113682712520401126)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pne dni (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113682554674401126)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pne godziny (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113684700362401127)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pne minuty (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113684051433401127)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pne miesi\0105ce (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113684128810401127)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pne tygodnie (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113683172115401126)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pne lata (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113683021524401126)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pny rok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113694312619401134)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'pl'
,p_message_text=>unistr('nie mi\0119dzy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113693324539401133)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'pl'
,p_message_text=>unistr('nie r\00F3wna si\0119')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113759544565401182)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'Obszar z ID %0 nie jest obszarem tabeli interaktywnej lub nie istnieje w aplikacji %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113693701117401134)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'pl'
,p_message_text=>'nie w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113694593321401134)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'pl'
,p_message_text=>'nie w ostat.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113694788697401134)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'pl'
,p_message_text=>'nie w nast.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113702249419401140)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie znaleziono \017Cadnych danych')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113740273968401168)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'pl'
,p_message_text=>unistr('Warto\015Bci Null')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113745342156401172)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'pl'
,p_message_text=>'Liczbowe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113740532723401168)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\0142.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113740663716401168)
,p_name=>'APEX.IG.ON'
,p_message_language=>'pl'
,p_message_text=>unistr('W\0142.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113692526529401133)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'pl'
,p_message_text=>unistr('1 minut\0119 temu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113748208471401174)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'pl'
,p_message_text=>unistr('Otw\00F3rz selektor kolor\00F3w: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113737069856401166)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Otwarcie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113699593771401138)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'pl'
,p_message_text=>'Operator'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113736453077401165)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'pl'
,p_message_text=>'Orientacja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113738845281401167)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'pl'
,p_message_text=>unistr('Ko\0142owy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113700862341401139)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'pl'
,p_message_text=>'Tabela przestawna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113668494300401115)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'pl'
,p_message_text=>'Widok tabeli przestawnej'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113748160052401174)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 rozdzieli\0107 warto\015Bci znakiem "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113738923950401167)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'pl'
,p_message_text=>'Biegunowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113744276814401171)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'pl'
,p_message_text=>unistr('\015Arodek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113744363993401171)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'pl'
,p_message_text=>'Koniec'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113744195328401171)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'pl'
,p_message_text=>unistr('Pocz\0105tek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113698786279401137)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'pl'
,p_message_text=>'Podstawowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113699075763401138)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'pl'
,p_message_text=>unistr('Podstawowy domy\015Blny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113715559210401150)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'pl'
,p_message_text=>'Raport podstawowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113597749732401063)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'pl'
,p_message_text=>unistr('Do\0142\0105cz tagi u\0142atwie\0144 dost\0119pu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113596487561401062)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'pl'
,p_message_text=>'Poziomo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113596522791401062)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'pl'
,p_message_text=>'Pionowo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113596321345401062)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'pl'
,p_message_text=>'Orientacja strony'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113596208121401062)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'pl'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113596147645401062)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'pl'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113597824582401063)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'pl'
,p_message_text=>'Niestandardowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113595999402401062)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'pl'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113595894095401062)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'pl'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113596013462401062)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'pl'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113595745044401062)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'pl'
,p_message_text=>'Rozmiar strony'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113585955428401055)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'pl'
,p_message_text=>unistr('Roz\0142\00F3\017C tekst z formatowaniem')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113739076373401167)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'pl'
,p_message_text=>'Radarowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113739128316401167)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'pl'
,p_message_text=>'Zakresowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113749457543401175)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'pl'
,p_message_text=>unistr('Od\015Bwie\017C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113703059656401140)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'pl'
,p_message_text=>unistr('Od\015Bwie\017C wiersz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113701842928401140)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'pl'
,p_message_text=>unistr('Od\015Bwie\017C wiersze')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113707016522401143)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'Obszar tabeli interaktywnej nie istnieje w aplikacji %0 (strona %1 i obszar %2).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113669947051401116)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113698100530401137)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'pl'
,p_message_text=>'Raport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113758773065401181)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'pl'
,p_message_text=>unistr('Raport usuni\0119ty')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113758434479401181)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'pl'
,p_message_text=>unistr('Raport alternatywny zapisany dla wszystkich u\017Cytkownik\00F3w')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113758357427401181)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'pl'
,p_message_text=>unistr('Raport domy\015Blny zapisany dla wszystkich u\017Cytkownik\00F3w')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113758625361401181)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'pl'
,p_message_text=>'Raport prywatny zapisany'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113758559370401181)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'pl'
,p_message_text=>unistr('Raport publiczny zapisany dla wszystkich u\017Cytkownik\00F3w')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113707162875401143)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'Zapisana tabela interaktywna o nazwie "%0" nie istnieje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113692430590401133)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'pl'
,p_message_text=>'Dane raportu zgodne ze stanem %0 min temu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113692327591401133)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'pl'
,p_message_text=>unistr('Dane raportu zgodne ze stanem 1 minut\0119 temu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113632033011401088)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'Raport "tabela interaktywna" nie istnieje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113751694978401176)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'pl'
,p_message_text=>'Raport - edytuj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113706964769401143)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'Zapisana tabela interaktywna z ID %0 nie istnieje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113751533755401176)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'pl'
,p_message_text=>'Raport - zapisz jako'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113670054366401116)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'pl'
,p_message_text=>'Ustawienia raportu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113759644972401182)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'Zapisana tabela interaktywna ze statycznym ID %0 nie istnieje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113754511431401178)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'pl'
,p_message_text=>'Widok raportu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113669113110401116)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'pl'
,p_message_text=>'Resetuj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113703197073401140)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'pl'
,p_message_text=>'Wycofaj zmiany'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113701914154401140)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'pl'
,p_message_text=>unistr('Przywr\00F3\0107 wiersze')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113699173132401138)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'pl'
,p_message_text=>'Wiersz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113698027505401137)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'pl'
,p_message_text=>'Liczba wierszy na stronie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113759255618401182)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'pl'
,p_message_text=>unistr('Czynno\015Bci dot. wiersza')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113760437028401183)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'pl'
,p_message_text=>unistr('Czynno\015Bci dot. wiersza %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113669451621401116)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'pl'
,p_message_text=>'Zapisz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113712121412401147)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'pl'
,p_message_text=>'zapisany'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113667689329401114)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'pl'
,p_message_text=>'Zapisane raporty'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113667752648401114)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'pl'
,p_message_text=>unistr('Domy\015Blny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113642297459401095)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'pl'
,p_message_text=>unistr('Ju\017C istnieje zapisany raport o nazwie "%0". Prosz\0119 poda\0107 now\0105 nazw\0119.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113667885518401115)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'pl'
,p_message_text=>'Prywatny'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113667984379401115)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'pl'
,p_message_text=>'Publiczny'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113754207604401178)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'pl'
,p_message_text=>'Zapisz jako'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113701228626401139)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'pl'
,p_message_text=>'Zapisz ustawienia raportu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113739236904401167)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'pl'
,p_message_text=>'Punktowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113667575724401114)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'pl'
,p_message_text=>'Szukaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113746550719401173)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>'Szukaj: Wszystkie kolumny tekstowe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113667447849401114)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Szukaj: %0'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113745740177401172)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'pl'
,p_message_text=>unistr('Szukaj: Pe\0142ny tekst')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113692270218401133)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'pl'
,p_message_text=>'Szukaj: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113735845248401165)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'pl'
,p_message_text=>unistr('- Wyb\00F3r -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113676092809401121)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113728772584401160)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 wybra\0107 1 wiersz w obszarze nadrz\0119dnym')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113667307310401114)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r przeszukiwanych kolumn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113758930098401182)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'pl'
,p_message_text=>unistr('Czynno\015Bci wyboru')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113676225759401121)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r kom\00F3rek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113676152266401121)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r wierszy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113747112860401173)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Blij jako e-mail')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113739670827401168)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Seria'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113665376580401113)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'pl'
,p_message_text=>unistr('Poka\017C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113717938277401152)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'pl'
,p_message_text=>unistr('Poka\017C warto\015B\0107 og\00F3ln\0105')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113702705173401140)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'pl'
,p_message_text=>'Widok jednego wiersza'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113701001339401139)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'pl'
,p_message_text=>'Sortuj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113739745275401168)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'pl'
,p_message_text=>'Sortuj wg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113759331972401182)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('Dla kolumny mo\017Cna zdefiniowa\0107 tylko jedno sortowanie.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113759182015401182)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'pl'
,p_message_text=>'Menu "Zmiana"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113740758252401168)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'pl'
,p_message_text=>'Stos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113695008674401135)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'pl'
,p_message_text=>unistr('zaczyna si\0119 od')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113739372408401167)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'pl'
,p_message_text=>unistr('Gie\0142dowy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113660382247401109)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>unistr('Zwi\0119kszaj szeroko\015Bci kolumn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113701429790401139)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'pl'
,p_message_text=>'Subskrypcja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113719482920401153)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'pl'
,p_message_text=>'Suma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113760668878401183)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'pl'
,p_message_text=>'Tabela interaktywna. Raport: %0, widok: %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113754626636401178)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Suma og\00F3lna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113737589383401166)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Cel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113743944118401171)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'pl'
,p_message_text=>'Kolor tekstu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113670143705401116)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Prze\0142\0105cz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113717884798401152)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'pl'
,p_message_text=>'Etykietka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113698213081401137)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'pl'
,p_message_text=>'Typ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113702608209401140)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'pl'
,p_message_text=>unistr('Odmro\017A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113699742528401138)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'pl'
,p_message_text=>'Jednostka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113746963964401173)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'pl'
,p_message_text=>unistr('Istniej\0105 niezapisane zmiany. Czy kontynuowa\0107?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113699636554401138)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'pl'
,p_message_text=>unistr('Warto\015B\0107')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113736668274401165)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('Warto\015B\0107')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113741599283401169)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Warto\015B\0107 jest wymagana.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113726496950401158)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'pl'
,p_message_text=>unistr('Warto\015B\0107 (nie mo\017Cna zmieni\0107 strefy czasowej)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113745497304401172)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'pl'
,p_message_text=>'Tekstowe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113737927157401166)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'pl'
,p_message_text=>'Pionowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113697770778401137)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'pl'
,p_message_text=>'Widok'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113735991483401165)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Bwietlane')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113737430184401166)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Wolumen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113695621050401135)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'pl'
,p_message_text=>'tyg./tydz.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113736078716401165)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'pl'
,p_message_text=>unistr('Minimalna szeroko\015B\0107 kolumny (w pikselach)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113686802473401129)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 mi\0119dzy %1 a %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113686594992401128)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'pl'
,p_message_text=>'%0 zawiera %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113686669384401128)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'pl'
,p_message_text=>'%0 nie zawiera %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113664711468401112)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie zaczyna si\0119 od %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113685392980401128)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 r\00F3wna si\0119 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113685501533401128)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 wi\0119ksze ni\017C %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113685698017401128)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 wi\0119ksze ni\017C lub r\00F3wne %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113686323323401128)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'pl'
,p_message_text=>'%0 w %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113687523099401129)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'pl'
,p_message_text=>'%0 w ostatnich %1 dniach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113687346342401129)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'pl'
,p_message_text=>'%0 w ostatnich %1 godzinach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113687123717401129)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'pl'
,p_message_text=>'%0 w ostatnich %1 minutach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113687916075401129)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w ostatnich %1 miesi\0105cach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113687771693401129)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'pl'
,p_message_text=>'%0 w ostatnich %1 tygodniach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113688138523401130)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'pl'
,p_message_text=>'%0 w ostatnich %1 latach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113687476235401129)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'pl'
,p_message_text=>'%0 w ostatnim dniu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113687233944401129)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'pl'
,p_message_text=>'%0 w ostatniej godzinie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113687034341401129)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'pl'
,p_message_text=>'%0 w ostatniej minucie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113687899297401129)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w ostatnim miesi\0105cu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113687694816401129)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'pl'
,p_message_text=>'%0 w ostatnim tygodniu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113688093540401129)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'pl'
,p_message_text=>'%0 w ostatnim roku'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113689926532401131)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w nast\0119pnych %1 dniach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113689708306401131)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w nast\0119pnych %1 godzinach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113689576390401131)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w nast\0119pnych %1 minutach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113690300184401131)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w nast\0119pnych %1 miesi\0105cach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113690155062401131)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w nast\0119pnych %1 tygodniach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113690556074401131)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w nast\0119pnych %1 latach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113689851899401131)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w nast\0119pnym dniu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113689686323401131)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w nast\0119pnej godzinie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113689425124401131)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w nast\0119pnej minucie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113690275213401131)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w nast\0119pnym miesi\0105cu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113690005552401131)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w nast\0119pnym tygodniu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113690468573401131)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 w nast\0119pnym roku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113686055028401128)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'pl'
,p_message_text=>'%0 nie jest puste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113685942438401128)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'pl'
,p_message_text=>'%0 jest puste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113685785424401128)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 mniejsze ni\017C %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113685838388401128)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 mniejsze ni\017C lub r\00F3wne %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113686186123401128)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'pl'
,p_message_text=>'%0 podobne do %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113686736154401129)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 zgodne z wyra\017Ceniem regularnym %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113692693483401133)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0 min temu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113686904771401129)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie mi\0119dzy %1 a %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113685423707401128)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie r\00F3wna si\0119 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113686427976401128)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'pl'
,p_message_text=>'%0 nie w %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113688709323401130)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'pl'
,p_message_text=>'%0 nie w ostatnich %1 dniach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113688554620401130)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'pl'
,p_message_text=>'%0 nie w ostatnich %1 godzinach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113688324442401130)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'pl'
,p_message_text=>'%0 nie w ostatnich %1 minutach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113689189531401130)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w ostatnich %1 miesi\0105cach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113688973033401130)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'pl'
,p_message_text=>'%0 nie w ostatnich %1 tygodniach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113689362104401130)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'pl'
,p_message_text=>'%0 nie w ostatnich %1 latach'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113688645342401130)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'pl'
,p_message_text=>'%0 nie w ostatnim dniu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113688484080401130)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'pl'
,p_message_text=>'%0 nie w ostatniej godzinie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113688285935401130)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'pl'
,p_message_text=>'%0 nie w ostatniej minucie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113689085136401130)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w ostatnim miesi\0105cu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113688828585401130)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'pl'
,p_message_text=>'%0 nie w ostatnim tygodniu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113689250392401130)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'pl'
,p_message_text=>'%0 nie w ostatnim roku'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113691110965401132)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w nast\0119pnych %1 dniach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113690992825401132)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w nast\0119pnych %1 godzinach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113690794672401132)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w nast\0119pnych %1 minutach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113691571890401132)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w nast\0119pnych %1 miesi\0105cach ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113691365355401132)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w nast\0119pnych %1 tygodniach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113691755431401132)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w nast\0119pnych %1 latach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113691078235401132)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w nast\0119pnym dniu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113690849971401132)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w nast\0119pnej godzinie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113690611202401131)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w nast\0119pnej minucie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113691417848401132)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w nast\0119pnym miesi\0105cu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113691257420401132)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w nast\0119pnym tygodniu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113691662848401132)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie w nast\0119pnym roku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113686276466401128)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'pl'
,p_message_text=>'%0 niepodobne %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113693130815401133)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 zaczyna si\0119 od %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113736746455401166)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113695814045401135)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'pl'
,p_message_text=>'lat(a)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113736846307401166)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113736978235401166)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113745932134401172)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'pl'
,p_message_text=>unistr('Poniedzia\0142ek, 12 stycznia 2016')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113746017654401172)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'pl'
,p_message_text=>unistr('Stycze\0144')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113746162430401172)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'pl'
,p_message_text=>'16 godz. temu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113746235058401172)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'pl'
,p_message_text=>'za 16 godz.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113601287345401066)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'pl'
,p_message_text=>unistr('Niepoprawny typ pliku. Obs\0142ugiwane typy plik\00F3w: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113728158805401159)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'pl'
,p_message_text=>unistr('Przegl\0105daj')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113727881317401159)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r pliku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113727944496401159)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r plik\00F3w')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113601032477401065)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'pl'
,p_message_text=>unistr('Przeci\0105ganie i upuszczanie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113601441898401066)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'pl'
,p_message_text=>unistr('Przeci\0105ganie plik\00F3w')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113602689983401067)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 wybra\0107 plik lub go tutaj przeci\0105gn\0105\0107.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113602725576401067)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 wybra\0107 pliki lub je tutaj przeci\0105gn\0105\0107.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113602894100401067)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 wybra\0107 plik lub go tutaj przeci\0105gn\0105\0107.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113602965465401067)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 wybra\0107 pliki lub je tutaj przeci\0105gn\0105\0107.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113601390935401066)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'pl'
,p_message_text=>'Pliki: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113601165653401065)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'pl'
,p_message_text=>unistr('Zbyt du\017Cy plik. Maksymalny rozmiar pliku to %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113588999658401057)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>'Adres jest wymagany.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113587881180401056)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'pl'
,p_message_text=>unistr('Miejscowo\015B\0107')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113588264855401056)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'pl'
,p_message_text=>'Kod kraju'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113587985220401056)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'pl'
,p_message_text=>'Numer domu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113588842999401057)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'pl'
,p_message_text=>unistr('Szeroko\015B\0107 geograficzna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113588710768401057)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'pl'
,p_message_text=>unistr('D\0142ugo\015B\0107 geograficzna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113588608026401056)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'pl'
,p_message_text=>unistr('Poka\017C na mapie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113588346869401056)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'pl'
,p_message_text=>'Wynik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113588061789401056)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'pl'
,p_message_text=>'Kod pocztowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113588103897401056)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wojew\00F3dztwo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113587776414401056)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'pl'
,p_message_text=>'Ulica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113587680681401056)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Wyniki geokodowania'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113600215072401065)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'pl'
,p_message_text=>'Geokodowane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113600338098401065)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'pl'
,p_message_text=>'Niegeokodowane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113588556361401056)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'pl'
,p_message_text=>'Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113588491450401056)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie znaleziono \017Cadnego adresu.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113589069430401057)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Warto\015B\0107 "%0" jest wymagana.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113758890618401181)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'pl'
,p_message_text=>'Tekst pomocy: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113652298271401103)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'pl'
,p_message_text=>'Zaznaczone'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113652397187401103)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'pl'
,p_message_text=>'Niezaznaczone'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113598243351401063)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# nie zawiera si\0119 w poprawnym przedziale od %0 do %1.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113598310253401063)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# nie jest wielokrotno\015Bci\0105 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113597993839401063)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# musi by\0107 zgodna z warto\015Bciami %0 i %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113598105125401063)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'pl'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113676418714401121)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\0142.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113676537582401121)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'pl'
,p_message_text=>unistr('W\0142.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113598076546401063)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'pl'
,p_message_text=>'Tak'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113581410061401051)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'pl'
,p_message_text=>'Dodaj wpis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113710669848401146)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'pl'
,p_message_text=>'Dodaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113710718460401146)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113581565679401051)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'pl'
,p_message_text=>'Wybrane wpisy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113714401542401149)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'pl'
,p_message_text=>'Zaawansowane'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113714792564401149)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'pl'
,p_message_text=>'Anuluj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113714503727401149)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'pl'
,p_message_text=>unistr('Wsp\00F3lne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113714812928401150)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'pl'
,p_message_text=>'Aktywne opcje szablonu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113715498314401150)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Opcje szablonu nie s\0105 dost\0119pne, poniewa\017C ten sk\0142adnik nie jest renderowany na tej stronie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113714371343401149)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'pl'
,p_message_text=>'Nie znaleziono opcji szablonu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113714697262401149)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'pl'
,p_message_text=>'Zapisz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113589968351401057)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyczy\015B\0107 okr\0105g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113591711104401059)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'pl'
,p_message_text=>unistr('Style niestandardowe nie s\0105 podane w poprawnej notacji JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113590222494401058)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'pl'
,p_message_text=>unistr('Narz\0119dzie "Odleg\0142o\015B\0107"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113590055856401057)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Narysuj okr\0105g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113582678711401052)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyszukiwanie fasetowe wymaga \017Ar\00F3d\0142a danych na poziomie obszaru.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113585252723401054)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'pl'
,p_message_text=>unistr('Bie\017C\0105ca lokalizacja')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113586380922401055)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'pl'
,p_message_text=>unistr('Wsp\00F3\0142rz\0119dne pozycji pocz\0105tkowej s\0105 niepoprawne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113583704154401053)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Pozycja pocz\0105tkowa musi by\0107 geometri\0105 punktow\0105.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113586124959401055)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'pl'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113584781272401054)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'pl'
,p_message_text=>'Warstwa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113718067831401152)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'pl'
,p_message_text=>'Warstwa: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113589327022401057)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'pl'
,p_message_text=>'Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113582568863401052)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'pl'
,p_message_text=>'Komunikaty'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113586250097401055)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'pl'
,p_message_text=>'mile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113717032722401151)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'pl'
,p_message_text=>unistr('Dane zawieraj\0105 ponad %0 wierszy, przekraczaj\0105c dozwolony limit.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113584504105401054)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'pl'
,p_message_text=>'&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Warunki</a> &nbsp;&nbsp; Dane map &copy; 2017 HERE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113583440409401053)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Typ danych SDO_GEOMETRY nie jest dost\0119pny w tej bazie danych.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113584672588401054)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'pl'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap - wsp\00F3\0142tw\00F3rcy </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113584899709401054)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'pl'
,p_message_text=>'Punkty'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113718144187401152)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'pl'
,p_message_text=>'Punkty: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113590162625401058)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'pl'
,p_message_text=>unistr('Powi\0119kszanie prostok\0105tne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113589886406401057)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113585164043401054)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'pl'
,p_message_text=>unistr('Zresetuj kierunek na p\00F3\0142noc')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113665408062401113)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'pl'
,p_message_text=>unistr('Prze\0142\0105cz do trybu 2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113665583864401113)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'pl'
,p_message_text=>unistr('Prze\0142\0105cz do trybu 3D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113589784286401057)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'pl'
,p_message_text=>unistr('Prze\0142\0105cz o\015Bwiadczenie dotycz\0105ce praw autorskich')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113590348638401058)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'pl'
,p_message_text=>unistr('Odleg\0142o\015B\0107 ca\0142kowita')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113584924534401054)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'pl'
,p_message_text=>unistr('Powi\0119ksz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113585087914401054)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'pl'
,p_message_text=>'Pomniejsz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113712575763401148)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'pl'
,p_message_text=>'Pogrubienie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113713456889401148)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'pl'
,p_message_text=>'Obraz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113713061150401148)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'pl'
,p_message_text=>'Kod wstawkowy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113726668397401158)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'pl'
,p_message_text=>'Wstaw obraz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113726769549401158)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'pl'
,p_message_text=>unistr('Wstaw \0142\0105cze')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113712664808401148)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'pl'
,p_message_text=>'Kursywa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113727356603401159)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'pl'
,p_message_text=>unistr('\0141\0105cze')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113713379027401148)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'pl'
,p_message_text=>'Lista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113713282097401148)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'pl'
,p_message_text=>unistr('Lista uporz\0105dkowana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113712751632401148)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'pl'
,p_message_text=>unistr('Podgl\0105d')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113712830091401148)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie ma nic do podgl\0105du')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113712959027401148)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'pl'
,p_message_text=>unistr('Przekre\015Blenie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113713174933401148)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'pl'
,p_message_text=>unistr('Lista nieuporz\0105dkowana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113692072864401132)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'pl'
,p_message_text=>unistr('bie\017C\0105ce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113749504623401175)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'pl'
,p_message_text=>unistr('Wi\0119cej...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113691980549401132)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'pl'
,p_message_text=>unistr('\0141adowanie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113723718823401156)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'pl'
,p_message_text=>'Komunikat powiadomienia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113697002568401136)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# musi by\0107 liczb\0105 nie wi\0119ksz\0105 ni\017C %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113697143674401136)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# musi by\0107 poprawn\0105 liczb\0105.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113697286813401136)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# nie jest zgodna z formatem %0 liczb (przyk\0142ad: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113696985880401136)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# musi by\0107 liczb\0105 nie mniejsz\0105 ni\017C %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113696894720401136)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# musi by\0107 liczb\0105 z przedzia\0142u od %0 do %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113692136111401133)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'pl'
,p_message_text=>'otwiera w nowym oknie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113645342899401098)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'pl'
,p_message_text=>unistr('Ta strona zosta\0142a ju\017C przes\0142ana i nie mo\017Cna jej ponownie przes\0142a\0107.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113627973268401085)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'pl'
,p_message_text=>'Nie znaleziono strony "%1" aplikacji "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113661745835401110)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('#LABEL# musi mie\0107 jak\0105\015B warto\015B\0107.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113605053013401068)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'pl'
,p_message_text=>'Szukaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113711059415401147)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'pl'
,p_message_text=>'Zamknij'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113710962618401147)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'pl'
,p_message_text=>unistr('Znajd\017A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113711262646401147)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'pl'
,p_message_text=>'Dalej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113711153470401147)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'pl'
,p_message_text=>'Wstecz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113597174979401063)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 wprowadzi\0107 szukany termin sk\0142adaj\0105cy si\0119 z przynajmniej %0 znak\00F3w.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113666633778401114)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyskakuj\0105ca lista warto\015Bci: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113597231183401063)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 wprowadzi\0107 szukany termin.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113597053282401062)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'pl'
,p_message_text=>unistr('Brak wynik\00F3w.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113596922573401062)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113684800386401127)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'pl'
,p_message_text=>'Szukany termin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113710828061401146)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'pl'
,p_message_text=>'Szukaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113721592386401155)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'pl'
,p_message_text=>'Przetwarzanie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113595509665401061)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'pl'
,p_message_text=>'Dodaj do ekranu startowego'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113591512844401059)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">U\017Cywane urz\0105dzenie lub przegl\0105darka prawdopodobnie nie obs\0142uguj\0105 aplikacji PWA (Progressive Web App).</p>'),
unistr('    <p class="a-pwaDialog-intro">Je\015Bli ta aplikacja zosta\0142a zainstalowana w urz\0105dzeniu, prosz\0119 j\0105 otworzy\0107 z ekranu startowego.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113591188570401058)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ten serwis internetowy ma funkcjonalno\015B\0107 aplikacji. Aby mo\017Cna by\0142o jej u\017Cywa\0107 w trybie pe\0142noekranowym, prosz\0119 j\0105 doda\0107 do swojego ekranu startowego.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Stukn\0105\0107 w ikon\0119 <strong>Menu</strong> (w dolnej nawigacji)</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Stukn\0105\0107 w <strong>Instaluj</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Stukn\0105\0107 w <strong>Dodaj</strong>, aby potwierdzi\0107</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113591297808401058)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ten serwis internetowy ma funkcjonalno\015B\0107 aplikacji, kt\00F3ra najlepiej jest realizowana w przegl\0105darce Chrome lub Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Stukn\0105\0107 w ikon\0119 <strong>Menu</strong> (obok paska adresu)</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Stukn\0105\0107 w <strong>Instaluj</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113590801126401058)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ten serwis internetowy ma funkcjonalno\015B\0107 aplikacji, kt\00F3ra najlepiej jest realizowana w przegl\0105darce Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Stukn\0105\0107 w ikon\0119 <strong>Udost\0119pnij</strong> (w dolnej nawigacji)</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Stukn\0105\0107 w <strong>Otw\00F3rz w przegl\0105darce Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113590552919401058)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ten serwis internetowy ma funkcjonalno\015B\0107 aplikacji. W celu zapewnienia jak najlepszego dost\0119pu warto ten serwis doda\0107 do swojego ekranu startowego.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Stukn\0105\0107 w ikon\0119 <strong>Udost\0119pnij</strong> (obok paska adresu)</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Stukn\0105\0107 w <strong>Dodaj do ekranu startowego</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Stukn\0105\0107 w <strong style="color:#007AE1;">Dodaj</strong>, aby potwierdzi\0107</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113590416852401058)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ten serwis internetowy ma funkcjonalno\015B\0107 aplikacji. W celu zapewnienia jak najlepszego dost\0119pu warto ten serwis doda\0107 do swojego ekranu startowego.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Stukn\0105\0107 w ikon\0119 <strong>Udost\0119pnij</strong> (w dolnej nawigacji)</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Przewin\0105\0107 w d\00F3\0142, po czym stukn\0105\0107 w <strong>Dodaj do ekranu startowego</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Stukn\0105\0107 w <strong style="color:#007AE1;">Dodaj</strong>, aby potwierdzi\0107</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113585480707401054)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ten serwis internetowy ma funkcjonalno\015B\0107 aplikacji. W celu zapewnienia jak najlepszego dost\0119pu warto ten serwis doda\0107 do swojego ekranu startowego.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Stukn\0105\0107 w ikon\0119 <strong>Wi\0119cej</strong> (obok paska adresu)</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Stukn\0105\0107 w <strong>Dodaj do ekranu startowego</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Stukn\0105\0107 w <strong style="color:#007AE1;">Dodaj</strong>, aby potwierdzi\0107</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113590778644401058)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ten serwis internetowy ma funkcjonalno\015B\0107 aplikacji. W celu zapewnienia jak najlepszego dost\0119pu warto ten serwis doda\0107 do swojego ekranu startowego.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Stukn\0105\0107 w ikon\0119 <strong>Udost\0119pnij</strong> (obok paska adresu)</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Stukn\0105\0107 w <strong>Otw\00F3rz w przegl\0105darce Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113590624749401058)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ten serwis internetowy ma funkcjonalno\015B\0107 aplikacji. W celu zapewnienia jak najlepszego dost\0119pu warto ten serwis doda\0107 do swojego ekranu startowego.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Stukn\0105\0107 w ikon\0119 <strong>Udost\0119pnij</strong> (w dolnej nawigacji)</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Stukn\0105\0107 w <strong>Otw\00F3rz w przegl\0105darce Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113591402352401058)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ten serwis internetowy ma funkcjonalno\015B\0107 aplikacji, kt\00F3ra najlepiej jest realizowana w przegl\0105darce Chrome.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox obecnie nie obs\0142uguje instalacji aplikacji internetowych.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113590983637401058)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ten serwis internetowy ma funkcjonalno\015B\0107 aplikacji, kt\00F3ra najlepiej jest realizowana w przegl\0105darce Chrome lub Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox obecnie nie obs\0142uguje instalacji aplikacji internetowych w systemie macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113591013977401058)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ten serwis internetowy ma funkcjonalno\015B\0107 aplikacji, kt\00F3ra najlepiej jest realizowana w przegl\0105darce Chrome lub Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari obecnie nie obs\0142uguje instalacji aplikacji internetowych w systemie macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113591305745401058)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ten serwis internetowy ma funkcjonalno\015B\0107 aplikacji, kt\00F3ra najlepiej jest realizowana w przegl\0105darce Chrome lub Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox obecnie nie obs\0142uguje instalacji aplikacji internetowych w systemie Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113593805861401060)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>Nie mo\017Cna si\0119 po\0142\0105czy\0107</h1>'),
unistr('    <p>Do korzystania z tej aplikacji jest potrzebne po\0142\0105czenie internetowe.</p>'),
unistr('    <button type="button">Pon\00F3w pr\00F3b\0119</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113593796778401060)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna si\0119 po\0142\0105czy\0107')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113733555895401163)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'pl'
,p_message_text=>'Dodaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113677983089401122)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'pl'
,p_message_text=>unistr('Ca\0142odniowe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113756806921401180)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Blij zaproszenie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113756625943401180)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'pl'
,p_message_text=>'Opcje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113679704083401123)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'pl'
,p_message_text=>unistr('Widok dzienny dla ca\0142ego dnia ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113679505256401123)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'pl'
,p_message_text=>'Widok dzienny dla danych z czasem '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113724470658401157)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'pl'
,p_message_text=>unistr('Dzie\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113718811640401153)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'pl'
,p_message_text=>'Opis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113609452202401072)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'pl'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113609235588401071)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'pl'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113609120000401071)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'pl'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113609341447401072)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'pl'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113608844538401071)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'pl'
,p_message_text=>unistr('Data ko\0144cowa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113609035633401071)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'pl'
,p_message_text=>'Nazwa zdarzenia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113756789045401180)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'pl'
,p_message_text=>'Zaproszenie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113724545816401157)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'pl'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113724278103401157)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'pl'
,p_message_text=>unistr('Miesi\0105c')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113727076218401159)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'pl'
,p_message_text=>'Dalej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113741362338401169)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'pl'
,p_message_text=>unistr('Brak zdarze\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113757001542401180)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'pl'
,p_message_text=>unistr('Edycja istniej\0105cego zdarzenia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113756944136401180)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'pl'
,p_message_text=>unistr('Wysy\0142anie zaproszenia e-mailem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113727111916401159)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'pl'
,p_message_text=>'Wstecz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113735176022401164)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Blij e-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113734943493401164)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Blij e-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113757769968401181)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Wszystkie pola s\0105 wymagane.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113757649674401181)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Blij zaproszenie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113756509346401180)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'pl'
,p_message_text=>'Temat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113735099139401164)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'pl'
,p_message_text=>'Do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113608991957401071)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'pl'
,p_message_text=>unistr('Data pocz\0105tkowa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113732898574401163)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'pl'
,p_message_text=>'Formularz w: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113679337149401123)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'pl'
,p_message_text=>'Czas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113727291667401159)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'pl'
,p_message_text=>'Dzisiaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113725058270401157)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'pl'
,p_message_text=>'Widok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113724358960401157)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'pl'
,p_message_text=>unistr('Tydzie\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113679625576401123)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'pl'
,p_message_text=>unistr('Widok tygodniowy dla ca\0142ego dnia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113679418415401123)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'pl'
,p_message_text=>'Widok tygodniowy dla danych z czasem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113724980109401157)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'pl'
,p_message_text=>'Rok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113724694736401157)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'pl'
,p_message_text=>'Kolumny...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113724761270401157)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'pl'
,p_message_text=>unistr('Za\0142aduj wi\0119cej...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113656822808401106)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'pl'
,p_message_text=>'Wstecz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113603196399401067)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'pl'
,p_message_text=>unistr('Za\0142aduj wi\0119cej...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113605213148401069)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'pl'
,p_message_text=>'Szukaj...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113724803228401157)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'pl'
,p_message_text=>unistr('Za\0142aduj wi\0119cej...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113726936531401158)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'pl'
,p_message_text=>'Nie znaleziono ID %0 obszaru.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113605140672401068)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie znaleziono \017Cadnych danych')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113629298522401086)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna zresetowa\0107 paginacji obszaru.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113597463102401063)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas ustawiania paginacji obszaru.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113718246430401152)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'pl'
,p_message_text=>'Kolumny...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113726854165401158)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'pl'
,p_message_text=>unistr('Typ "%0" obszaru nie jest obs\0142ugiwany.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113597392919401063)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas renderowania obszaru "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113661843421401110)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('#COLUMN_HEADER# musi mie\0107 jak\0105\015B warto\015B\0107.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113756170918401180)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'pl'
,p_message_text=>unistr('%0, edytor tekst\00F3w z formatowaniem')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113663990666401112)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'pl'
,p_message_text=>unistr('Kod HTML formatowanego tekstu przekracza maksymaln\0105 d\0142ugo\015B\0107 elementu (obecnie: %0, liczba dozwolonych znak\00F3w: %1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113723804179401156)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113715683998401150)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'pl'
,p_message_text=>'Duplikuj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113713923028401149)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Bwietlane kolumny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113713817427401149)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyklucz warto\015Bci Null')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113723957245401156)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'pl'
,p_message_text=>'Dodaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113677534001401122)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'pl'
,p_message_text=>unistr('Przenie\015B w d\00F3\0142')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113677643662401122)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'pl'
,p_message_text=>unistr('Przenie\015B w g\00F3r\0119')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113713671992401149)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'pl'
,p_message_text=>'Dalej'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113714210791401149)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'pl'
,p_message_text=>'Inne kolumny'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113713767091401149)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'pl'
,p_message_text=>'Wstecz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113714020633401149)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'pl'
,p_message_text=>'Wiersz %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113714179895401149)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'pl'
,p_message_text=>'Wiersz %0 z %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113715797091401150)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'pl'
,p_message_text=>unistr('Od\015Bwie\017C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113715848951401150)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'pl'
,p_message_text=>'Wycofaj zmiany'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113713506922401149)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'pl'
,p_message_text=>'Menu "Ustawienia"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113674594162401120)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'pl'
,p_message_text=>unistr('Na przyk\0142ad: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113582015735401052)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 si\0119 ponownie zalogowa\0107')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113581963225401052)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Sesja zosta\0142a zako\0144czona')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113582153466401052)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'pl'
,p_message_text=>unistr('Przed\0142u\017C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113581768302401052)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'pl'
,p_message_text=>unistr('Sesja zako\0144czy si\0119 o %0. Czy j\0105 przed\0142u\017Cy\0107?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113581819203401052)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'pl'
,p_message_text=>unistr('Sesja zako\0144czy si\0119 o %0 i nie mo\017Cna jej przed\0142u\017Cy\0107. Aby unikn\0105\0107 utraty danych, prosz\0119 teraz zapisa\0107 swoj\0105 prac\0119.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113734775871401164)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania kodu czyszczenia sesji bazy danych.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113627837714401085)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania kodu konfiguracji sesji bazy danych.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113601973944401066)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Sesja zosta\0142a zako\0144czona')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113733613099401163)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 zamkn\0105\0107 to okno dialogowe, po czym - aby uzyska\0107 now\0105 sesj\0119 - nacisn\0105\0107 w przegl\0105darce przycisk ponownego \0142adowania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113752959058401177)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'pl'
,p_message_text=>unistr('Aby utworzy\0107 now\0105 sesj\0119, prosz\0119 klikn\0105\0107 <a href="%0">tutaj</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113639592383401093)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawna sesja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113679036164401123)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'pl'
,p_message_text=>unistr('W sesji Real Application Security dla u\017Cytkownika "%0" nie mog\0105 zosta\0107 w\0142\0105czone \017Cadne dynamiczne role.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113625766647401083)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('ERR-99900 Nie mo\017Cna by\0142o utworzy\0107 unikatowego ID sesji: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113642037696401095)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Naruszenie ochrony stanu sesji: Mo\017Ce by\0107 spowodowane r\0119czn\0105 modyfikacj\0105 elementu "%0" strony chronionej. Nie maj\0105c pewno\015Bci, co jest przyczyn\0105 tego b\0142\0119du, prosz\0119 si\0119 zwr\00F3ci\0107 do administratora aplikacji o pomoc.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113761123154401183)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Naruszenie ochrony strony: Mo\017Ce by\0107 spowodowane przes\0142aniem strony, kt\00F3ra jeszcze nie zosta\0142a w pe\0142ni za\0142adowana, albo r\0119czn\0105 modyfikacj\0105 element\00F3w strony chronionej. Aby uzyska\0107 dalsz\0105 pomoc, prosz\0119 si\0119 skontaktowa\0107 z administratorem aplikacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113760112778401182)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 zawiera jeden z nast\0119puj\0105cych niedozwolonych znak\00F3w: &<>"/;,*|=% lub --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113760207042401182)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 zawiera jeden z nast\0119puj\0105cych niedozwolonych znak\00F3w: &<>"/;,*|=% lub -- lub znak nowego wiersza.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113759967337401182)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 zawiera znaki specjalne. Dozwolone s\0105 tylko znaki a-Z, 0-9 i spacje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113760044734401182)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 zawiera <, > lub " (s\0105 to znaki niedozwolone).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113604120225401068)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie dostarczono sumy kontrolnej pokazuj\0105cej przetwarzanie strony, kt\00F3ra wymaga sumy kontrolnej, gdy jako parametry przekazano warto\015Bci argument\00F3w lub jedno lub wi\0119ksz\0105 liczb\0119 \017C\0105da\0144 wyczyszczenia pami\0119ci podr\0119cznej.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113636976946401091)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'pl'
,p_message_text=>unistr('Naruszenie ochrony stanu sesji: Mo\017Ce by\0107 spowodowane r\0119czn\0105 modyfikacj\0105 adresu URL zawieraj\0105cego sum\0119 kontroln\0105 albo u\017Cyciem \0142\0105cza z niepoprawn\0105 lub brakuj\0105c\0105 sum\0105 kontroln\0105. Nie maj\0105c pewno\015Bci, co jest przyczyn\0105 tego b\0142\0119du, prosz\0119 si\0119 zwr\00F3ci\0107 do adm')
||'inistratora aplikacji o pomoc.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113714941201401150)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\0142\0105cz tryb du\017Cego kontrastu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113715026637401150)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'pl'
,p_message_text=>unistr('W\0142\0105cz tryb du\017Cego kontrastu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113633608967401089)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'pl'
,p_message_text=>'Na koniec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113633808125401089)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'pl'
,p_message_text=>unistr('W d\00F3\0142')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113633982688401089)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'pl'
,p_message_text=>unistr('Przenie\015B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113634083348401089)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Przenie\015B wszystkie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113634102624401089)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113634274113401090)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 wszystkie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113634313422401090)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'pl'
,p_message_text=>'Resetuj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113633539109401089)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'pl'
,p_message_text=>unistr('Na pocz\0105tek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113633752702401089)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'pl'
,p_message_text=>unistr('W g\00F3r\0119')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113742635768401170)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113743321305401170)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'w %0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113742568250401170)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113743455354401170)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'w %0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113742316717401170)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113743594661401170)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'w %0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113742954270401170)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113743198953401170)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'w %0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113742403899401170)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113743295363401170)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'w %0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113742725774401170)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113743678695401171)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'w %0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113742892004401170)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113743000794401170)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'w %0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113582952659401052)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'pl'
,p_message_text=>'[Linia]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113583367945401053)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'pl'
,p_message_text=>'[Wiele linii]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113583127888401053)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'pl'
,p_message_text=>unistr('[Wiele punkt\00F3w]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113583524963401053)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'pl'
,p_message_text=>unistr('[Wiele wielok\0105t\00F3w]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113583684422401053)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'pl'
,p_message_text=>'[Obiekt geometrii]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113582894966401052)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'pl'
,p_message_text=>'[Punkt (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113583073856401052)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'pl'
,p_message_text=>unistr('[Wielok\0105t]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113660242886401109)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'pl'
,p_message_text=>unistr('Zwi\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113660150731401109)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'pl'
,p_message_text=>unistr('Odtw\00F3rz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113706658325401143)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyczy\015B\0107 ocen\0119')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113696573782401136)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie zawiera si\0119 w poprawnym przedziale ocen do 1 do %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113696676320401136)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 nie jest warto\015Bci\0105 liczbow\0105')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113692736231401133)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'pl'
,p_message_text=>'Komunikat o powodzeniu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113755868869401179)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'pl'
,p_message_text=>'Dalej'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113755783145401179)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'pl'
,p_message_text=>'Wstecz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113741452882401169)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'pl'
,p_message_text=>unistr('Pasek narz\0119dzi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113756285291401180)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'pl'
,p_message_text=>unistr('Rozwi\0144/zwi\0144 nawigacj\0119')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113756343241401180)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'pl'
,p_message_text=>unistr('Rozwi\0144/zwi\0144 kolumn\0119 boczn\0105')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113665984867401113)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'pl'
,p_message_text=>unistr('Nawigacja g\0142\00F3wna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113672917348401118)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'pl'
,p_message_text=>unistr('1 dzie\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113672756589401118)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'pl'
,p_message_text=>'1 godz.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113673091771401118)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'pl'
,p_message_text=>'%0 dni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113672844943401118)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'pl'
,p_message_text=>'%0 godz.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113672654152401118)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'pl'
,p_message_text=>'%0 min'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113673284383401119)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'pl'
,p_message_text=>'%0 tyg.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113673186903401118)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'pl'
,p_message_text=>'1 tydz.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113759405451401182)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'pl'
,p_message_text=>unistr('Pocz\0105tek strony')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113621459388401080)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'pl'
,p_message_text=>unistr('W\0142\0105czone')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113595268064401061)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas przetwarzania \017C\0105dania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113674601352401120)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Wymagana warto\015B\0107')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113757582993401181)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 poczeka\0107, a\017C strona zostanie ca\0142kowicie za\0142adowana, po czym ponowi\0107 pr\00F3b\0119.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113717798480401152)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'pl'
,p_message_text=>unistr('Na tej stronie wyst\0119puj\0105 niezapisane zmiany.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113598633907401064)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'pl'
,p_message_text=>'Skoroszyt nie zawiera aktywnego arkusza roboczego.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113598510261401064)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'pl'
,p_message_text=>unistr('Skoroszyt nie zosta\0142 zainicjalizowany.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113598417795401063)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyst\0105pi\0142 b\0142\0105d wewn\0119trzny podczas tworzenia pliku XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113600980518401065)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'pl'
,p_message_text=>'Arkusz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113732690742401163)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'pl'
,p_message_text=>unistr('Czynno\015Bci')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113650102368401101)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'pl'
,p_message_text=>unistr('Menu "Czynno\015Bci"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113645880173401098)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Dodaj funkcj\0119')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113645782833401098)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('Dodaj kolumn\0119 "Grupuj wg"')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113679936322401124)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('Dodaj kolumn\0119 przestawn\0105')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113680051642401124)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Dodaj wiersz przestawny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113620213350401080)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'pl'
,p_message_text=>'Agregacja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113656338699401106)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'pl'
,p_message_text=>'Agregacja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113637494065401092)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'pl'
,p_message_text=>unistr('\015Arednia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113641780391401095)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'pl'
,p_message_text=>'Licznik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113637539406401092)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'pl'
,p_message_text=>'Maksimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113637718752401092)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'pl'
,p_message_text=>'Mediana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113637691281401092)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'pl'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113637312224401092)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'pl'
,p_message_text=>'Suma %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113638452262401093)
,p_name=>'APEXIR_ALL'
,p_message_language=>'pl'
,p_message_text=>'Wszystkie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113619538687401079)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>'Wszystkie kolumny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113602051301401066)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'pl'
,p_message_text=>'Wszystkie wiersze'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113729617717401160)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'pl'
,p_message_text=>'Alternatywny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113731204776401162)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'pl'
,p_message_text=>unistr('Alternatywny domy\015Blny: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113632145931401088)
,p_name=>'APEXIR_AND'
,p_message_language=>'pl'
,p_message_text=>'i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113621600082401080)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'pl'
,p_message_text=>'Zastosuj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113615386329401076)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'pl'
,p_message_text=>unistr('Rosn\0105co')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113634902658401090)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'pl'
,p_message_text=>'Jak %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113731813564401162)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'pl'
,p_message_text=>unistr('\015Arednia %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113723236909401156)
,p_name=>'APEXIR_BAR'
,p_message_language=>'pl'
,p_message_text=>unistr('S\0142upkowy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113621036681401080)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'pl'
,p_message_text=>unistr('mi\0119dzy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113614100890401075)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'pl'
,p_message_text=>unistr('Kolor t\0142a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113616056969401076)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'pl'
,p_message_text=>'niebieski'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113647736357401099)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'pl'
,p_message_text=>'Na koniec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113616696054401077)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'pl'
,p_message_text=>'Anuluj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113622575510401081)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'pl'
,p_message_text=>'Kategoria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113614052207401075)
,p_name=>'APEXIR_CELL'
,p_message_language=>'pl'
,p_message_text=>unistr('Kom\00F3rka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113638314170401092)
,p_name=>'APEXIR_CHART'
,p_message_language=>'pl'
,p_message_text=>'Wykres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113648616391401100)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'pl'
,p_message_text=>'Inicjalizowanie...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113684982974401127)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'pl'
,p_message_text=>unistr('Trzeba okre\015Bli\0107 etykiet\0119 wykresu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113697364792401136)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'pl'
,p_message_text=>unistr('Zapytanie przekracza maksymaln\0105 liczb\0119 punkt\00F3w danych (%0) przypadaj\0105cych na wykres. Prosz\0119 zastosowa\0107 filtr, aby ograniczy\0107 liczb\0119 rekord\00F3w dla zapytania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113696258275401136)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'pl'
,p_message_text=>unistr('Maksymalna liczba wierszy dla zapytania dotycz\0105cego wykresu ogranicza nie liczb\0119 wy\015Bwietlanych wierszy, lecz liczb\0119 wierszy w zapytaniu podstawowym. Zapytanie podstawowe przekracza maksymaln\0105 liczb\0119 wierszy (%0). Prosz\0119 zastosowa\0107 filtr w celu ograni')
||unistr('czenia liczby rekord\00F3w w zapytaniu przestawnym.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113619620208401079)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'pl'
,p_message_text=>'Typ wykresu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113692942448401133)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'pl'
,p_message_text=>'Zaznacz wszystkie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113635355149401090)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r formatu raportu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113642714628401096)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'pl'
,p_message_text=>unistr('wyczy\015B\0107')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113616509203401077)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Kolumna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113653991647401104)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>'Kolumny'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113726290717401158)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'pl'
,p_message_text=>'Filtruj...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113644781086401097)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'pl'
,p_message_text=>unistr('Menu "Nag\0142\00F3wek kolumny"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113648461879401100)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'pl'
,p_message_text=>'Informacje o kolumnie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113728597730401160)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'pl'
,p_message_text=>'Etykieta kolumny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113646118414401098)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'pl'
,p_message_text=>'Kolumna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113630263573401086)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'pl'
,p_message_text=>'zawiera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113631130056401087)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'pl'
,p_message_text=>'nie zawiera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113615098002401076)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'pl'
,p_message_text=>'w'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113631339600401087)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'pl'
,p_message_text=>'nie jest w ostat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113639892749401094)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'pl'
,p_message_text=>'nie jest w nast.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113631293977401087)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'pl'
,p_message_text=>'jest w ostat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113639743422401093)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'pl'
,p_message_text=>'jest w nast.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113614929229401076)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'pl'
,p_message_text=>unistr('nie ma warto\015Bci Null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113614800689401076)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'pl'
,p_message_text=>unistr('ma warto\015B\0107 Null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113614665865401075)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'pl'
,p_message_text=>'podobne do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113615158772401076)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'pl'
,p_message_text=>'nie w'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113614731604401076)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'pl'
,p_message_text=>'niepodobne do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113630539161401087)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'pl'
,p_message_text=>unistr('zgodne z wyra\017Ceniem regularnym')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113635223937401090)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'pl'
,p_message_text=>'Obliczenie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113695908773401135)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyra\017Cenie obliczenia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113654250512401104)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 utworzy\0107 obliczenie, u\017Cywaj\0105c alias\00F3w kolumn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113654307766401104)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'pl'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113654402338401104)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'pl'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113654591629401105)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'pl'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113600403198401065)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'pl'
,p_message_text=>'ROUND(C/1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113639180796401093)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'pl'
,p_message_text=>'Oblicz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113646789599401099)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'pl'
,p_message_text=>'Przerwa kontrolna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113649787156401101)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'pl'
,p_message_text=>'Przerwy kontrolne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113734167051401164)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>'Kolumny przerwy kontrolnej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113597545612401063)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'pl'
,p_message_text=>'Licznik dystynktywny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113732315604401162)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'pl'
,p_message_text=>'Licznik dystynktywny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113732210864401162)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'pl'
,p_message_text=>'Licznik %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113704340407401141)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'pl'
,p_message_text=>unistr('Co dzie\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113759041512401182)
,p_name=>'APEXIR_DATA'
,p_message_language=>'pl'
,p_message_text=>'Dane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113648505707401100)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'pl'
,p_message_text=>'Dane raportu zgodne ze stanem %0 min temu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113722076855401155)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'pl'
,p_message_text=>'Tabela danych - pomoc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113620389982401080)
,p_name=>'APEXIR_DATE'
,p_message_language=>'pl'
,p_message_text=>'Data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113652467902401103)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'pl'
,p_message_text=>unistr('Domy\015Blne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113729437809401160)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('Typ raportu domy\015Blnego')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113616761568401077)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113620686207401080)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'pl'
,p_message_text=>unistr('Czy usun\0105\0107 te ustawienia raportu?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113715398332401150)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 raport domy\015Blny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113646470028401098)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 raport')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113615492800401076)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'pl'
,p_message_text=>unistr('Malej\0105co')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113622669392401081)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'pl'
,p_message_text=>'Opis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113644679248401097)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'pl'
,p_message_text=>'Widok jednego wiersza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113652968708401103)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'pl'
,p_message_text=>'Kierunek %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113653802884401104)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\0142\0105czone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113616210458401077)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Bwietlane')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113619484837401079)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Bwietlane kolumny')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113652860498401103)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Bwietl w raporcie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113647655174401099)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'pl'
,p_message_text=>unistr('W d\00F3\0142')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113639276352401093)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'pl'
,p_message_text=>'Pobierz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113652747361401103)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie wy\015Bwietlaj')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113718771907401152)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'pl'
,p_message_text=>unistr('Ju\017C istnieje wyr\00F3\017Cnienie z tym samym warunkiem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113734300400401164)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('Zduplikowana kolumna przestawna. Lista kolumn przestawnych musi zawiera\0107 unikatowe pozycje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113734540673401164)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'pl'
,p_message_text=>'Edytuj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113648781303401100)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'pl'
,p_message_text=>'Edytuj ustawienia wykresu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113655385127401105)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'pl'
,p_message_text=>'Edytuj wykres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113655727063401105)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'pl'
,p_message_text=>'Edytuj filtr'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113710127703401146)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'pl'
,p_message_text=>'Edytuj "Grupuj wg"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113655686573401105)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'pl'
,p_message_text=>unistr('Edytuj cech\0119')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113680256188401124)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'pl'
,p_message_text=>unistr('Edytuj tabel\0119 przestawn\0105')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113729794222401161)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'pl'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113608408011401071)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'pl'
,p_message_text=>'Adres e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113730022308401161)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'pl'
,p_message_text=>'Udw'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113730231742401161)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'pl'
,p_message_text=>unistr('Tre\015B\0107')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113729961128401161)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'pl'
,p_message_text=>'Dw'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113730716190401161)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'pl'
,p_message_text=>unistr('Cz\0119stotliwo\015B\0107')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113612150317401074)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'pl'
,p_message_text=>unistr('Dla tej aplikacji nie zosta\0142 skonfigurowany adres e-mail. Prosz\0119 si\0119 skontaktowa\0107 z administratorem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113703618900401141)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Trzeba okre\015Bli\0107 adres e-mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113730367260401161)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'pl'
,p_message_text=>unistr('Zob. za\0142\0105czone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113730126776401161)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'pl'
,p_message_text=>'Temat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113704637658401142)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Trzeba okre\015Bli\0107 temat e-maila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113729810889401161)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'pl'
,p_message_text=>'Do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113613888031401075)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'pl'
,p_message_text=>unistr('W\0142\0105czone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113655528977401105)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'pl'
,p_message_text=>unistr('W\0142\0105cz/wy\0142\0105cz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113655073279401105)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113654606632401105)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'pl'
,p_message_text=>unistr('Przyk\0142ady')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113655498462401105)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'pl'
,p_message_text=>unistr('Przyk\0142ady:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113619373503401079)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyklucz warto\015Bci Null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113656047131401106)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'pl'
,p_message_text=>unistr('Rozwi\0144/Zwi\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113653632944401104)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyra\017Cenie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113638764764401093)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'pl'
,p_message_text=>'Filtruj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113649637268401101)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'pl'
,p_message_text=>'Filtry'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113659915540401109)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyra\017Cenie filtra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113756496116401180)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyra\017Cenie filtra jest zbyt d\0142ugie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113659883323401109)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'pl'
,p_message_text=>'Typ filtra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113656211145401106)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r przeszukiwanych kolumn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113639009492401093)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'pl'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113653496631401104)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Zapytanie Flashback umo\017Cliwia wy\015Bwietlenie danych tak, jak istnia\0142y we wcze\015Bniejszym punkcie w czasie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113704098767401141)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'pl'
,p_message_text=>'Flashback - okres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113705498799401142)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'pl'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113635105913401090)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'pl'
,p_message_text=>'Maska formatu: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113646391405401098)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'pl'
,p_message_text=>'Funkcja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113654116618401104)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'pl'
,p_message_text=>'Funkcje %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113729325804401160)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'pl'
,p_message_text=>'Funkcje/operatory'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113646006856401098)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'pl'
,p_message_text=>'Funkcja %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113638587554401093)
,p_name=>'APEXIR_GO'
,p_message_language=>'pl'
,p_message_text=>'Wykonaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113614399475401075)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'pl'
,p_message_text=>'zielony'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113597620299401063)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'pl'
,p_message_text=>'Grupuj wg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113730442051401161)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Grupuj wg kolumny %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113685006031401127)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'pl'
,p_message_text=>unistr('Trzeba okre\015Bli\0107 kolumn\0119, wed\0142ug kt\00F3rej ma nast\0119powa\0107 grupowanie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113696129366401135)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'pl'
,p_message_text=>unistr('Maksymalna liczba wierszy dla zapytania "Grupuj wg" ogranicza nie liczb\0119 wy\015Bwietlanych wierszy, lecz liczb\0119 wierszy w zapytaniu podstawowym. Zapytanie podstawowe przekracza maksymaln\0105 liczb\0119 wierszy (%0). Prosz\0119 zastosowa\0107 filtr w celu ograniczenia l')
||unistr('iczby rekord\00F3w w zapytaniu przestawnym.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113676790098401121)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'pl'
,p_message_text=>'Sortowanie grupowania wg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113734244346401164)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'pl'
,p_message_text=>unistr('Grupuj wg - porz\0105dek sortowania')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113619777940401079)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'pl'
,p_message_text=>'Kolumna pozioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113651372808401102)
,p_name=>'APEXIR_HELP'
,p_message_language=>'pl'
,p_message_text=>'Pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113643159998401096)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Raporty interaktywne mog\0105 by\0107 dostosowywane przez u\017Cytkownik\00F3w. U\017Cytkownicy mog\0105 zmienia\0107 uk\0142ad danych w raporcie, wybieraj\0105c kolumny, stosuj\0105c filtry i wyr\00F3\017Cnienia, a tak\017Ce sortuj\0105c dane. Mog\0105 tak\017Ce definiowa\0107 podzia\0142y, agregacje, wykresy i grupowan')
||unistr('ia oraz dodawa\0107 w\0142asne obliczenia. Mog\0105 skonfigurowa\0107 subskrypcj\0119, tak aby by\0142a do nich przys\0142ana z okre\015Blon\0105 cz\0119stotliwo\015Bci\0105 wersja HTML raportu. Mog\0105 r\00F3wnie\017C tworzy\0107 r\00F3\017Cne odmiany raportu i zapisywa\0107 je jako nazwane raporty, przeznaczone do wy\015Bwiet')
||'lania publicznego lub prywatnego. ',
'<p/>',
unistr('W kolejnych sekcjach zosta\0142y podsumowane sposoby modyfikacji raportu interaktywnego. Wi\0119cej informacji mo\017Cna znale\017A\0107 w rozdziale "Using Interactive Reports" w podr\0119czniku <i>Oracle Application Express End User''s Guide</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113650288842401101)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'pl'
,p_message_text=>unistr('Menu "Czynno\015Bci" pojawia si\0119 z prawej strony przycisku "Wykonaj" na pasku wyszukiwania. Za pomoc\0105 opcji z tego menu mo\017Cna dostosowa\0107 raport interaktywny.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113643912536401097)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Agregacje s\0105 to obliczenia matematyczne, wykonywane w odniesieniu do kolumny. Agregacje s\0105 wy\015Bwietlane po ka\017Cdej przerwie kontrolnej i na ko\0144cu raportu w tych kolumnach, w kt\00F3rych zosta\0142y zdefiniowane. S\0105 dost\0119pne nast\0119puj\0105ce opcje:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Agregacja</strong> - umo\017Cliwia wybranie wcze\015Bniej zdefiniowanej agregacji do edycji.</li>'),
unistr('<li><strong>Funkcja</strong> - okre\015Bla funkcj\0119, kt\00F3ra ma zosta\0107 wykonana (na przyk\0142ad SUM, MIN).</li>'),
unistr('<li><strong>Kolumna</strong> - s\0142u\017Cy do wybrania kolumny, do kt\00F3rej ma zosta\0107 zastosowana funkcja matematyczna. '),
unistr('S\0105 wy\015Bwietlane tylko kolumny liczbowe.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113644006089401097)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Mo\017Cna zdefiniowa\0107 jeden wykres przypadaj\0105cy na jeden zapisany raport. Po zdefiniowaniu wykresu'),
unistr('mo\017Cna si\0119 prze\0142\0105cza\0107, za pomoc\0105 ikon widok\00F3w z paska wyszukiwania, mi\0119dzy widokiem wykresu i widokiem raportu.'),
unistr('Dost\0119pne s\0105 nast\0119puj\0105ce opcje:  '),
'<p>',
'</p><ul>',
unistr('<li><strong>Typ wykresu</strong> - okre\015Bla stosowany typ wykresu.'),
unistr('Mo\017Cna wybra\0107 wykres s\0142upkowy poziomy, s\0142upkowy pionowy, ko\0142owy lub liniowy.</li>'),
unistr('<li><strong>Etykieta</strong> - umo\017Cliwia wybranie kolumny, kt\00F3ra b\0119dzie u\017Cywana jako etykieta.</li>'),
unistr('<li><strong>Tytu\0142 osi dla etykiety</strong> - okre\015Bla tytu\0142 wy\015Bwietlany na osi powi\0105zanej z kolumn\0105 wybran\0105 na etykiet\0119. '),
unistr('Opcja ta nie jest dost\0119pna dla wykresu ko\0142owego.</li>'),
unistr('<li><strong>Warto\015B\0107</strong>  - umo\017Cliwia wybranie kolumny, kt\00F3ra b\0119dzie u\017Cywana jako warto\015B\0107.'),
unistr('Je\015Bli funkcj\0105 jest COUNT, nie trzeba wybiera\0107 warto\015Bci.</li>'),
unistr('<li><strong>Tytu\0142 osi dla warto\015Bci</strong> - okre\015Bla tytu\0142 wy\015Bwietlany na osi powi\0105zanej z kolumn\0105 wybran\0105 na warto\015B\0107.'),
unistr('Opcja ta nie jest dost\0119pna dla wykresu ko\0142owego.</li>'),
unistr('<li><strong>Funkcja</strong> - okre\015Bla opcjonaln\0105 funkcj\0119, kt\00F3ra ma zosta\0107 wykonana w odniesieniu do kolumny wybranej na warto\015B\0107.</li>'),
unistr('<li><strong>Sortuj</strong> - umo\017Cliwia posortowanie zbioru wynik\00F3w.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113643327346401096)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Klikaj\0105c nag\0142\00F3wek dowolnej kolumny, eksponuje si\0119 jego menu. S\0105 w nim dost\0119pne nast\0119puj\0105ce opcje:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Sortuj rosn\0105co</strong> - raport jest sortowany wed\0142ug danej kolumny w porz\0105dku rosn\0105cym.</li>'),
unistr('<li><strong>Sortuj malej\0105co</strong> - raport jest sortowany wed\0142ug danej kolumny w porz\0105dku malej\0105cym.</li>'),
unistr('<li><strong>Ukryj kolumn\0119</strong> - kolumna jest ukrywana. Nie ka\017Cd\0105 kolumn\0119 mo\017Cna ukry\0107. Je\015Bli kolumny nie mo\017Cna ukry\0107, to ikona "Ukryj kolumn\0119" nie pojawi si\0119.</li>'),
unistr('<li><strong>Podziel kolumn\0119</strong> - jest tworzona grupa podzia\0142u oparta na danej kolumnie. Kolumna ta jest wydobywana z raportu jako rekord nadrz\0119dny.</li>'),
unistr('<li><strong>Informacje o kolumnie</strong> - jest wy\015Bwietlany (o ile istnieje) tekst Pomocy dla kolumny.</li>'),
unistr('<li><strong>Obszar tekstowy</strong> - jest u\017Cywany do wprowadzania kryteri\00F3w wyszukiwania, w kt\00F3rych nie jest uwzgl\0119dniana wielko\015B\0107 liter'),
unistr('(nie trzeba stosowa\0107 wieloznacznik\00F3w). Wprowadzaj\0105c warto\015B\0107, ogranicza si\0119 list\0119 warto\015Bci'),
unistr('na dole menu. Mo\017Cna z niej wybra\0107 warto\015B\0107,'),
unistr('kt\00F3ra zostanie u\017Cyta do utworzenia filtra z u\017Cyciem znaku r\00F3wno\015Bci "="'),
unistr('(na przyk\0142ad <code>column = ''ABC''</code>). Mo\017Cna te\017C klikn\0105\0107 na ikonie "Wyr\00F3\017Cnienie" i wprowadzi\0107 warto\015B\0107, kt\00F3ra zostanie u\017Cyta do utworzenia filtra z modyfikatorem LIKE'),
unistr('(na przyk\0142ad <code>column LIKE ''%ABC%''</code>).</li>'),
unistr('<li><b>Lista unikatowych warto\015Bci</b> - zawiera 500 pierwszych unikatowych warto\015Bci'),
unistr('spe\0142niaj\0105cych kryteria filtrowania. Je\015Bli kolumna zawiera daty, zostanie wy\015Bwietlona lista przedzia\0142\00F3w dat. Je\015Bli jaka\015B warto\015B\0107 zostanie wybrana, zostanie utworzony filtr'),
unistr('z u\017Cyciem znaku r\00F3wno\015Bci "=" (na przyk\0142ad <code>column = ''ABC''</code>).</li>'),
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113643830245401096)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Umo\017Cliwia dodanie obliczanych kolumn do raportu. Mog\0105 to by\0107 obliczenia matematyczne (na przyk\0142ad <code>NBR_HOURS/24</code>) lub standardowe funkcje Oracle'),
unistr('zastosowane do istniej\0105cych kolumn. Niekt\00F3re s\0105 wy\015Bwietlane jako przyk\0142ady, ale mog\0105 zosta\0107 u\017Cyte tak\017Ce inne (takie jak <code>TO_DATE)</code>). Dost\0119pne s\0105 nast\0119puj\0105ce opcje:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Obliczenie</strong> - umo\017Cliwia wybranie wcze\015Bniej zdefiniowanego wyra\017Cenia do edycji.</li>'),
unistr('<li><strong>Nag\0142\00F3wek kolumny</strong> - umo\017Cliwia okre\015Blenie nag\0142\00F3wka nowej kolumny.</li>'),
unistr('<li><strong>Maska formatu</strong> - okre\015Bla mask\0119 formatu Oracle, kt\00F3ra ma zosta\0107 zastosowana do kolumny (na przyk\0142ad S9999).</li>'),
unistr('<li><strong>Obliczenie</strong> - okre\015Bla obliczenie, kt\00F3re ma zosta\0107 wykonane. W obliczeniu mo\017Cna si\0119 odwo\0142ywa\0107 do kolumn, u\017Cywaj\0105c ich wy\015Bwietlanych alias\00F3w.</li>'),
'</ul>',
unistr('<p>Wyst\0119puj\0105ce w zapytaniu kolumny s\0105 wy\015Bwietlane pod obliczeniem wraz z ich aliasami. Klikaj\0105c nazw\0119 kolumny lub alias,'),
unistr('zawiera si\0119 je w obliczeniu. Obok kolumn znajduje si\0119 klawiatura. Dzia\0142a ona jak'),
unistr('skr\00F3t do zazwyczaj u\017Cywanych funkcji. Po prawej stronie znajduje si\0119 obszar "Funkcje".</p>'),
unistr('<p>Nast\0119puj\0105cy przyk\0142ad obliczenia pokazuje, w jaki spos\00F3b mo\017Cna wy\015Bwietli\0107 \0142\0105czne wynagrodzenie:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
'(gdzie A to ORGANIZATION, B to SALARY, C to COMMISSION)</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113650391007401101)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'pl'
,p_message_text=>unistr('S\0142u\017Cy do utworzenia grupy podzia\0142u opartej na kolumnach (jednej lub wi\0119kszej ich liczbie). Kolumny te s\0105 wydobywane z raportu interaktywnego i wy\015Bwietlane jako rekordy nadrz\0119dne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113644530943401097)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'pl'
,p_message_text=>unistr('Aby wy\015Bwietli\0107 szczeg\00F3\0142y jednego wiersza, klikn\0105\0107 ikon\0119 "Widok jednego wiersza" w odpowiednim wierszu. Widok jednego wiersza, je\015Bli dost\0119pny, zawsze b\0119dzie pierwsz\0105 kolumn\0105. W zale\017Cno\015Bci od dostosowania raportu interaktywnego widok jednego wiersza mo')
||unistr('\017Ce by\0107 widokiem standardowym lub stron\0105 niestandardow\0105, kt\00F3re mog\0105 zezwala\0107 na aktualizacj\0119.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113644416800401097)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Umo\017Cliwia pobranie bie\017C\0105cego zbioru wynik\00F3w. Formaty pobierania'),
unistr('r\00F3\017Cni\0105 si\0119 w zale\017Cno\015Bci od instalacji i definicji raportu, ale'),
unistr('na og\00F3\0142 s\0105 dost\0119pne CSV, HTML, E-mail, XLS, PDF lub RTF.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113643526745401096)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Uszczeg\00F3\0142awia raport przez dodanie lub zmodyfikowanie klauzuli <code>WHERE</code> w zapytaniu. Mo\017Cna filtrowa\0107 wed\0142ug kolumny lub wiersza.  '),
unistr('<p>Filtruj\0105c wed\0142ug kolumny, nale\017Cy j\0105 wybra\0107 (nie musi by\0107 wy\015Bwietlana),'),
unistr('nast\0119pnie wybra\0107 standardowy operator Oracle (=, !=, nie\00A0w, mi\0119dzy), po czym wprowadzi\0107 wyra\017Cenie por\00F3wnawcze. W wyra\017Ceniach jest uwzgl\0119dniana wielko\015B\0107 liter. Mo\017Cna u\017Cy\0107 wieloznacznika % a (na przyk\0142ad <code>STATE_NAME'),
'like A%)</code>.</p>',
unistr('<p>Filtruj\0105c wed\0142ug wiersza, mo\017Cna tworzy\0107 z\0142o\017Cone klauzule <code>WHERE</code> z u\017Cyciem'),
unistr('alias\00F3w kolumn i dowolnych funkcji lub operator\00F3w Oracle, na przyk\0142ad <code>G = ''VA'' or G = ''CT''</code>, gdzie'),
'<code>G</code> jest aliasem kolumny <code>CUSTOMER_STATE</code>.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113644146964401097)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Zapytanie Flashback umo\017Cliwia wy\015Bwietlenie danych, kt\00F3re istnia\0142y w poprzednim punkcie w czasie.'),
unistr('Czas domy\015Blny, obj\0119ty zapytaniem Flashback, wynosi 3 godziny (180 minut),'),
unistr('ale faktyczny czas mo\017Ce si\0119 r\00F3\017Cni\0107 w zale\017Cno\015Bci od bazy danych.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113705389173401142)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Za pomoc\0105 menu "Format" mo\017Cna dostosowa\0107 wy\015Bwietlanie raportu.'),
unistr('Menu "Format" zawiera nast\0119puj\0105ce podmenu:</p>'),
'<ul><li>Sortuj</li>',
'<li>Przerwa kontrolna</li>',
unistr('<li>Wyr\00F3\017Cnij</li>'),
'<li>Oblicz</li>',
'<li>Agregacja</li>',
'<li>Wykres</li>',
'<li>Grupuj wg</li>',
'<li>Tabela przestawna</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113703554435401141)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Mo\017Cna zdefiniowa\0107 jeden widok grupowania wg przypadaj\0105cy na jeden zapisany raport. Po zdefiniowaniu widoku mo\017Cna si\0119 prze\0142\0105cza\0107, za pomoc\0105 ikon widok\00F3w z paska wyszukiwania, mi\0119dzy widokiem grupowania wg i widokiem raportu. Aby utworzy\0107 widok grupowa')
||unistr('nia wg, nale\017Cy wybra\0107: '),
'<p></p>',
'<ul>',
unistr('<li>kolumny u\017Cywane do grupowania</li>'),
unistr('<li>agregowane kolumny wraz z wykonywan\0105 funkcj\0105 (\015Brednia, suma, licznik itd.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113643771783401096)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Umo\017Cliwia zdefiniowanie filtra. Wiersze spe\0142niaj\0105ce kryteria filtrowania s\0105 wyr\00F3\017Cniane przy u\017Cyciu cech powi\0105zanych z filtrem. Dost\0119pne s\0105 nast\0119puj\0105ce opcje:</p>'),
'<ul>',
unistr('<li><strong>Nazwa</strong> - s\0142u\017Cy tylko do wy\015Bwietlania.</li>'),
unistr('<li><strong>Sekwencja</strong> - okre\015Bla kolejno\015B\0107 obliczania regu\0142.</li>'),
unistr('<li><strong>W\0142\0105czone</strong> - okre\015Bla, czy regu\0142a jest w\0142\0105czona czy wy\0142\0105czona.</li>'),
unistr('<li><strong>Typ wyr\00F3\017Cnienia</strong> - okre\015Bla, co ma by\0107 wyr\00F3\017Cniane: wiersz lub kom\00F3rka.'),
unistr('Je\015Bli zostanie wybrana opcja "Kom\00F3rka", b\0119dzie wyr\00F3\017Cniana kolumna, do kt\00F3rej odnosi si\0119'),
unistr('warunek wyr\00F3\017Cniania.</li>'),
unistr('<li><strong>Kolor t\0142a</strong> - okre\015Bla nowy kolor t\0142a wyr\00F3\017Cnionego obszaru.</li>'),
unistr('<li><strong>Kolor tekstu</strong> - okre\015Bla nowy kolor tekstu w wyr\00F3\017Cnionym obszarze.</li>'),
unistr('<li><strong>Warunek wyr\00F3\017Cnienia</strong> - okre\015Bla warunek filtrowania.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113581344638401051)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Mo\017Cna zdefiniowa\0107 jeden widok tabeli przestawnej przypadaj\0105cy na jeden zapisany raport. Po zdefiniowaniu widoku mo\017Cna si\0119 prze\0142\0105cza\0107, za pomoc\0105 ikon widok\00F3w z paska wyszukiwania, mi\0119dzy widokiem tabeli przestawnej i widokiem raportu. Aby utworzy\0107 wid')
||unistr('ok tabeli przestawnej, nale\017Cy wybra\0107: '),
'<p></p>',
'<ul>',
unistr('<li>kolumny u\017Cywane do przestawienia</li>'),
unistr('<li>kolumny do wy\015Bwietlenia jako wiersze</li>'),
unistr('<li>agregowane kolumny wraz z wykonywan\0105 funkcj\0105 (\015Brednia, suma, licznik itd.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113654837602401105)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Gdy raport interaktywny jest dostosowywany, jego ustawienia s\0105 wy\015Bwietlane'),
unistr('pod paskiem wyszukiwania i nad raportem. Obszar ten mo\017Cna zwin\0105\0107 lub rozwin\0105\0107, u\017Cywaj\0105c ikony wy\015Bwietlanej po lewej stronie.'),
'<p>',
unistr('Dla ka\017Cdego ustawienia raportu mo\017Cna:'),
'</p><ul>',
unistr('<li>Edytowa\0107 ustawienie, klikaj\0105c jego nazw\0119.</li>'),
unistr('<li>W\0142\0105czy\0107 lub wy\0142\0105czy\0107 ustawienie, zaznaczaj\0105c lub czyszcz\0105c pole wyboru "W\0142\0105cz/Wy\0142\0105cz". Za jego pomoc\0105 mo\017Cna tymczasowo w\0142\0105cza\0107 i wy\0142\0105cza\0107 ustawienie.</li>'),
unistr('<li>Usun\0105\0107 ustawienie, klikaj\0105c ikon\0119 "Usu\0144".</li>'),
'</ul>',
unistr('<p>Je\015Bli utworzono wykres, grupowanie wg lub tabel\0119 przestawn\0105, to mo\017Cna si\0119 prze\0142\0105cza\0107 mi\0119dzy nimi'),
unistr('a raportem podstawowym za pomoc\0105 \0142\0105czy "Widok raportu", "Widok wykresu", "Widok grupowania wg" i "Widok tabeli przestawnej",'),
unistr('wy\015Bwietlanych po prawej stronie. Je\015Bli jest wy\015Bwietlany wykres, grupowanie wg lub tabela przestawna,'),
unistr('mo\017Cna - w celu edycji ustawie\0144 - u\017Cy\0107 tak\017Ce \0142\0105cza "Edytuj".</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113644353925401097)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'pl'
,p_message_text=>unistr('Resetuje raport, przywracaj\0105c ustawienia domy\015Blne oraz usuwaj\0105c wszelkie wprowadzone dostosowania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113705650655401142)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'pl'
,p_message_text=>unistr('Okre\015Bla liczb\0119 rekord\00F3w wy\015Bwietlanych na stronie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113644235676401097)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zapisuje dostosowany raport do u\017Cycia w przysz\0142o\015Bci. Nale\017Cy poda\0107 nazw\0119 oraz mo\017Cna opcjonalnie wprowadzi\0107 opis i uczyni\0107 raport dost\0119pnym publicznie (znaczy to, \017Ce dost\0119p do podstawowego raportu domy\015Blnego b\0119d\0105 mie\0107 wszyscy u\017Cytkownicy). Mo\017Cna zap')
||unistr('isywa\0107 cztery typy raport\00F3w interaktywnych:</p>'),
'<ul>',
unistr('<li><strong>Podstawowy domy\015Blny</strong> (tylko programi\015Bci). Raport "Podstawowy domy\015Blny" jest raportem pocz\0105tkowo wy\015Bwietlanym. Nie mo\017Cna usuwa\0107 tych raport\00F3w ani zmienia\0107 ich nazw.</li>'),
unistr('<li><strong>Raport alternatywny</strong> (tylko programi\015Bci). Umo\017Cliwia programistom tworzenie r\00F3\017Cnych uk\0142ad\00F3w raportu. Tylko programi\015Bci mog\0105 taki raport zapisa\0107 lub usun\0105\0107 b\0105d\017A zmieni\0107 jego nazw\0119.</li>'),
unistr('<li><strong>Raport publiczny</strong> (u\017Cytkownicy ko\0144cowi). U\017Cytkownik ko\0144cowy, kt\00F3ry taki raport utworzy\0142, mo\017Ce go zapisa\0107 lub usun\0105\0107 b\0105d\017A zmieni\0107 jego nazw\0119. Inni u\017Cytkownicy mog\0105 go wy\015Bwietli\0107 i zapisa\0107 uk\0142ad jako inny raport.</li>'),
unistr('<li><strong>Raport prywatny</strong> (u\017Cytkownicy ko\0144cowi). Tylko u\017Cytkownik ko\0144cowy, kt\00F3ry taki raport utworzy\0142, mo\017Ce go wy\015Bwietli\0107, zapisa\0107 lub usun\0105\0107 b\0105d\017A zmieni\0107 jego nazw\0119.</li>'),
'</ul>',
unistr('<p>Gdy dostosowane raporty s\0105 zapisywane, na pasku wyszukiwania jest wy\015Bwietlany (po lewej stronie selektora wierszy) selektor raport\00F3w, o ile ta funkcja zosta\0142a w\0142\0105czona.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113643271373401096)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'pl'
,p_message_text=>unistr('Na g\00F3rze ka\017Cdej strony raportu znajduje si\0119 obszar wyszukiwania. W obszarze tym (lub na pasku wyszukiwania) s\0105 dost\0119pne nast\0119puj\0105ce funkcje:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113706249132401143)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'pl'
,p_message_text=>unistr('<li><strong>Menu czynno\015Bci</strong> - pozwala dostosowa\0107 raport. Zob. kolejne sekcje.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113705737676401142)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'pl'
,p_message_text=>unistr('<li><strong>Ikona wyboru kolumn</strong> - pozwala okre\015Bli\0107, kt\00F3re kolumny maj\0105 by\0107 przeszukiwane (lub wszystkie).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113706041390401143)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'pl'
,p_message_text=>unistr('<li><strong>Raporty</strong> - s\0105 tu wy\015Bwietlane raporty alternatywne domy\015Blne oraz zapisane raporty prywatne lub publiczne.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113705978887401143)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'pl'
,p_message_text=>unistr('<li><strong>Wiersze</strong> - okre\015Bla liczb\0119 rekord\00F3w wy\015Bwietlanych na stronie.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113705800672401143)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>Obszar tekstowy</strong> - umo\017Cliwia wprowadzenie kryteri\00F3w wyszukiwania, w kt\00F3rych nie jest uwzgl\0119dniana wielko\015B\0107 liter (wieloznaczniki s\0105 przyjmowane domy\015Blnie).</li>'),
unistr('<li>Przycisk <strong>Wykonaj</strong> - uruchamia wyszukiwanie. Tak\017Ce naci\015Bni\0119cie klawisza Enter uruchamia wyszukiwanie, je\015Bli kursor znajduje si\0119 w obszarze tekstowym wyszukiwania.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113706112344401143)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'pl'
,p_message_text=>unistr('<li><strong>Ikony widok\00F3w</strong> - umo\017Cliwiaj\0105 prze\0142\0105czanie si\0119 mi\0119dzy nast\0119puj\0105cymi widokami raportu (o ile zosta\0142y zdefiniowane): ikona, raport, szczeg\00F3\0142y, wykres, grupuj wg i tabela przestawna</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113722126173401155)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'pl'
,p_message_text=>unistr('<li><strong>Zarz\0105dzanie</strong> - umo\017Cliwia zarz\0105dzanie w\0142a\015Bciwo\015Bciami, kolumnami, wierszami i histori\0105 widok\00F3w dla raportu lub tabeli danych.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113643425495401096)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>unistr('S\0142u\017Cy do modyfikowania wy\015Bwietlanych kolumn. Kolumny po prawej stronie s\0105 wy\015Bwietlane. Kolumny po lewej stronie s\0105 ukryte. Za pomoc\0105 strza\0142ek (na ko\0144cu, po prawej stronie) mo\017Cna zmieni\0107 kolejno\015B\0107 wy\015Bwietlanych kolumn. Kolumny obliczane s\0105 poprzedzone')
||' znakami <strong>**</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113643680947401096)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Umo\017Cliwia zmian\0119 kolumn, wed\0142ug kt\00F3rych odbywa si\0119 sortowanie, oraz okre\015Blenie'),
unistr('porz\0105dku sortowania (rosn\0105co lub malej\0105co). Mo\017Cna okre\015Bli\0107, w jaki spos\00F3b maj\0105 by\0107 traktowane warto\015Bci'),
unistr('<code>NULL</code>. Przy ustawieniu domy\015Blnym warto\015Bci <code>NULL</code> s\0105 zawsze wy\015Bwietlane jako ostatnie,'),
unistr('ale mog\0105 by\0107 wy\015Bwietlane jako pierwsze. Wybrany spos\00F3b sortowania jest pokazywany z prawej strony nag\0142\00F3wk\00F3w kolumn w raporcie.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113703359028401141)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Dodaj\0105c subskrypcj\0119, nale\017Cy poda\0107 adres e-mail (lub adresy e-mail rozdzielone przecinkiem), temat e-maila, cz\0119stotliwo\015B\0107 oraz dat\0119 pocz\0105tkow\0105 i ko\0144cow\0105. Wynikowe e-maile b\0119d\0105 zawiera\0107 wersj\0119 HTML raportu interaktywnego, z aktualnymi danymi, zgodnie z')
||' jego ustawieniami w chwili dodania subskrypcji.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113721943477401155)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Tabele danych s\0105 w zasadzie edytowalnymi, wysoce dostosowywalnymi raportami. U\017Cytkownicy mog\0105 zmienia\0107 uk\0142ad danych w raporcie, wybieraj\0105c kolumny, stosuj\0105c filtry i wyr\00F3\017Cnienia, a tak\017Ce sortuj\0105c dane. Mog\0105 tak\017Ce definiowa\0107 podzia\0142y, agregacje, wykre')
||unistr('sy i grupowania oraz dodawa\0107 w\0142asne obliczenia. Mog\0105 skonfigurowa\0107 subskrypcj\0119, tak aby by\0142a do nich przys\0142ana z okre\015Blon\0105 cz\0119stotliwo\015Bci\0105 wersja HTML raportu. Mog\0105 r\00F3wnie\017C tworzy\0107 r\00F3\017Cne odmiany raportu i zapisywa\0107 je jako nazwane raporty, przeznaczo')
||unistr('ne do wy\015Bwietlania publicznego lub prywatnego. '),
'<p/>',
unistr('Tabel\0119 danych mo\017Cna dostosowa\0107, korzystaj\0105c z paska wyszukiwania, menu "Czynno\015Bci", menu "Zarz\0105dzanie" i menu "Nag\0142\00F3wek kolumny".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113733756415401163)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'pl'
,p_message_text=>unistr('Menu "Czynno\015Bci" pojawia si\0119 z prawej strony przycisku "Wykonaj" na pasku wyszukiwania. Za pomoc\0105 opcji z tego menu mo\017Cna dostosowa\0107 raport typu "tabela danych".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113722423275401155)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'pl'
,p_message_text=>'Strona "Dodawanie/edycja wiersza"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113722596524401155)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Aby doda\0107 wiersz do tabeli, klikn\0105\0107 "Dodaj wiersz". Aby edytowa\0107 szczeg\00F3\0142y wiersza, klikn\0105\0107 ikon\0119 "Edytuj wiersz" (pierwsza kolumna) w wierszu, kt\00F3ry b\0119dzie edytowany. Zostanie wy\015Bwietlona strona "Dodaj/Edytuj wiersz" z kolumnami z tabeli danych. ')
||'</p>',
'',
unistr('<p>Edytuj\0105c wiersz, mo\017Cna:</p>'),
'',
'<p><ul>',
unistr('<li><strong>Usun\0105\0107</strong> wiersz.</li>'),
unistr('<li><strong>Zastosowa\0107 zmiany</strong>, aby zapisa\0107 zmiany dokonane w wierszu.</li>'),
unistr('<li>W ramach <strong>czynno\015Bci</strong> doda\0107 wiersz, doda\0107 pliki, notatki, \0142\0105cza lub tagi oraz przejrze\0107 histori\0119.</li>'),
unistr('<li>Przechodzi\0107 do wiersza <strong>poprzedniego i nast\0119pnego</strong>.</li>'),
unistr('<li>W ramach <strong>zarz\0105dzania</strong> ustawi\0107 w\0142a\015Bciwo\015Bci kolumn, grupy kolumn, weryfikacje i listy warto\015Bci.</li>'),
'</ul></p>',
'',
unistr('<p>W obszarze "Adnotacje" (na dole strony) s\0105 wy\015Bwietlane pliki, notatki, \0142\0105cza i tagi powi\0105zane z bie\017C\0105cym wierszem.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113733815392401163)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'pl'
,p_message_text=>unistr('S\0142u\017Cy do utworzenia grupy podzia\0142u opartej na kolumnach (jednej lub wi\0119kszej ich liczbie). Kolumny te s\0105 wydobywane z tabeli danych i wy\015Bwietlane jako rekordy nadrz\0119dne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113722344208401155)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'pl'
,p_message_text=>unistr('Umo\017Cliwia pobranie bie\017C\0105cego zbioru wynik\00F3w. Dost\0119pne formaty pobierania to m.in. CSV, HTML i E-mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113733915844401164)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Gdy raport typu "tabela przestawna" jest dostosowywany, jego ustawienia s\0105 wy\015Bwietlane'),
unistr('pod paskiem wyszukiwania i nad raportem. Obszar ten mo\017Cna zwin\0105\0107 lub rozwin\0105\0107, u\017Cywaj\0105c ikony wy\015Bwietlanej po lewej stronie.'),
'<p>',
unistr('Dla ka\017Cdego ustawienia raportu mo\017Cna:'),
'</p><ul>',
unistr('<li>Edytowa\0107 ustawienie, klikaj\0105c jego nazw\0119.</li>'),
unistr('<li>W\0142\0105czy\0107 lub wy\0142\0105czy\0107 ustawienie, zaznaczaj\0105c lub czyszcz\0105c pole wyboru "W\0142\0105cz/Wy\0142\0105cz". Za jego pomoc\0105 mo\017Cna tymczasowo w\0142\0105cza\0107 i wy\0142\0105cza\0107 ustawienie.</li>'),
unistr('<li>Usun\0105\0107 ustawienie, klikaj\0105c ikon\0119 "Usu\0144".</li>'),
'</ul>',
unistr('<p>Je\015Bli utworzono wykres lub grupowanie wg, to mo\017Cna si\0119 prze\0142\0105cza\0107 mi\0119dzy nimi'),
unistr('a raportem podstawowym za pomoc\0105 \0142\0105czy "Widok raportu", "Widok wykresu" i "Widok grupowania wg",'),
unistr('wy\015Bwietlanych po prawej stronie. Je\015Bli jest wy\015Bwietlany wykres lub grupowanie wg,'),
unistr('mo\017Cna - w celu edycji ustawie\0144 - u\017Cy\0107 tak\017Ce \0142\0105cza "Edytuj".</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113722275120401155)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Zapisuje dostosowany raport typu "tabela danych" do u\017Cycia w przysz\0142o\015Bci. Nale\017Cy poda\0107 nazw\0119 oraz mo\017Cna opcjonalnie wprowadzi\0107 opis. Mo\017Cna zapisywa\0107 trzy uk\0142ady raport\00F3w typu "tabela danych":</p>'),
'<ul>',
unistr('<li><strong>Podstawowy domy\015Blny</strong> (tylko administrator). Raport "Podstawowy domy\015Blny" jest raportem pocz\0105tkowo wy\015Bwietlanym. Nie mo\017Cna usuwa\0107 tych raport\00F3w ani zmienia\0107 ich nazw.</li>'),
unistr('<li><strong>Raport alternatywny</strong> (tylko administrator). Umo\017Cliwia administratorom tworzenie r\00F3\017Cnych uk\0142ad\00F3w raportu. Tylko administratorzy mog\0105 taki raport zapisa\0107 lub usun\0105\0107 b\0105d\017A zmieni\0107 jego nazw\0119.</li>'),
unistr('<li><strong>Raport prywatny</strong> (wszyscy u\017Cytkownicy). U\017Cytkownik ko\0144cowy, kt\00F3ry taki raport utworzy\0142, mo\017Ce go wy\015Bwietli\0107, zapisa\0107 lub usun\0105\0107 b\0105d\017A zmieni\0107 jego nazw\0119.</li>'),
'</ul>',
unistr('<p>Gdy dostosowane raporty s\0105 zapisywane, na pasku wyszukiwania jest wy\015Bwietlany (po lewej stronie selektora wierszy) selektor raport\00F3w, o ile ta funkcja zosta\0142a w\0142\0105czona.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113648344867401100)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('Ukryj kolumn\0119')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113638982493401093)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyr\00F3\017Cnij')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113649849838401101)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyr\00F3\017Cnione')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113654925312401105)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'pl'
,p_message_text=>unistr('Typ wyr\00F3\017Cnienia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113703951580401141)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Styl wyr\00F3\017Cnienia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113613932353401075)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('Typ wyr\00F3\017Cnienia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113723433453401156)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'pl'
,p_message_text=>'Poziomo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113753001356401177)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'pl'
,p_message_text=>'Nieaktywne ustawienie (1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113753158826401177)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'pl'
,p_message_text=>'Nieaktywne ustawienia (%0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113644990943401097)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'pl'
,p_message_text=>'Raport interaktywny - pomoc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113655999183401106)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113649376153401101)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'pl'
,p_message_text=>unistr('Niepoprawne wyra\017Cenie obliczenia. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113608701352401071)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'pl'
,p_message_text=>unistr('Data ko\0144cowa musi przypada\0107 po dacie pocz\0105tkowej.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113663602429401111)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'pl'
,p_message_text=>unistr('Niepoprawne wyra\017Cenie filtra. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113731430904401162)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawne zapytanie filtrowania'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113753201992401177)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawne ustawienie (1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113753367590401178)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawne ustawienia (%0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113704123834401141)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'pl'
,p_message_text=>'(w minutach)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113721164531401154)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'pl'
,p_message_text=>'%0 jest w ostat. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113721384673401154)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'pl'
,p_message_text=>'%0 jest w nast. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113721207769401154)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'pl'
,p_message_text=>'%0 nie jest w ostat. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113721456743401154)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'pl'
,p_message_text=>'%0 nie jest w nast. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113654010219401104)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'pl'
,p_message_text=>'Klawiatura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113620105234401079)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'pl'
,p_message_text=>'Etykieta "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113647985853401100)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Tytu\0142 osi dla etykiety')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113640404629401094)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'pl'
,p_message_text=>unistr('Ostatni dzie\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113640653279401094)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'pl'
,p_message_text=>'Ostatnia godzina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113640131439401094)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'pl'
,p_message_text=>unistr('Ostatni miesi\0105c')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113640286276401094)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'pl'
,p_message_text=>unistr('Ostatni tydzie\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113640307059401094)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'pl'
,p_message_text=>'Ostatnie dni (%0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113640511712401094)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'pl'
,p_message_text=>'Ostatnie godziny (%0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113639991958401094)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'pl'
,p_message_text=>'Ostatnie lata (%0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113640011503401094)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'pl'
,p_message_text=>'Ostatni rok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113620040271401079)
,p_name=>'APEXIR_LINE'
,p_message_language=>'pl'
,p_message_text=>'Liniowy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113616844709401077)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'pl'
,p_message_text=>'Liniowo-warstwowy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113731360189401162)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'pl'
,p_message_text=>'Odwzoruj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113648882599401100)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'pl'
,p_message_text=>unistr('Wed\0142ug szacunk\00F3w zapytanie przekroczy dozwolon\0105 maksymaln\0105 liczb\0119 zasob\00F3w. Prosz\0119 zmodyfikowa\0107 ustawienia raportu, po czym ponowi\0107 pr\00F3b\0119.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113631073444401087)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'pl'
,p_message_text=>unistr('Maksymalna liczba wierszy dla tego raportu wynosi %0. Prosz\0119 zastosowa\0107 filtr, aby ograniczy\0107 liczb\0119 rekord\00F3w dla zapytania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113731953285401162)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'pl'
,p_message_text=>'Maksimum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113732195690401162)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'pl'
,p_message_text=>'Mediana %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113635000596401090)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0 min temu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113732051206401162)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'pl'
,p_message_text=>'Minimum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113731066506401161)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'pl'
,p_message_text=>unistr('Miesi\0105c')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113704517204401142)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'pl'
,p_message_text=>unistr('Co miesi\0105c')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113647115697401099)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'pl'
,p_message_text=>unistr('Przenie\015B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113647001859401099)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Przenie\015B wszystkie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113758255539401181)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Trzeba okre\015Bli\0107 statyczny ID obszaru, poniewa\017C strona zawiera wi\0119cej ni\017C jeden interaktywny raport.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113615537966401076)
,p_name=>'APEXIR_NAME'
,p_message_language=>'pl'
,p_message_text=>'Nazwa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113642940137401096)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'pl'
,p_message_text=>'Nowa agregacja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113753916561401178)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'pl'
,p_message_text=>'Nowa kategoria'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113643092006401096)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'pl'
,p_message_text=>'Nowe obliczenie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113637828168401092)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'pl'
,p_message_text=>'Dalej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113640959522401094)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pny dzie\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113640737281401094)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pna godzina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113641203994401095)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pny miesi\0105c')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113641131711401094)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pny tydzie\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113641014854401094)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pne dni (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113640807855401094)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pne godziny (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113641498776401095)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pne lata (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113641305933401095)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pny rok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113615859397401076)
,p_name=>'APEXIR_NO'
,p_message_language=>'pl'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113656123608401106)
,p_name=>'APEXIR_NONE'
,p_message_language=>'pl'
,p_message_text=>'- Brak -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113703753475401141)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawny adres e-mail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113652653534401103)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'pl'
,p_message_text=>unistr('Warto\015Bci Null zawsze pierwsze')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113652595611401103)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'pl'
,p_message_text=>unistr('Warto\015Bci Null zawsze ostatnie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113653093602401103)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'pl'
,p_message_text=>unistr('Sortowanie warto\015Bci Null: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113649419168401101)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'pl'
,p_message_text=>unistr('Czas operacji Flashback musi by\0107 okre\015Blony liczb\0105.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113649012685401100)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'pl'
,p_message_text=>unistr('Sekwencja musi by\0107 okre\015Blona liczb\0105.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113653509775401104)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'pl'
,p_message_text=>'Operator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113614485667401075)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'pl'
,p_message_text=>unistr('pomara\0144czowy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113723312502401156)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'pl'
,p_message_text=>'Orientacja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113616331156401077)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'pl'
,p_message_text=>'Inne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113599172118401064)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'pl'
,p_message_text=>'Orientacja strony'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113599813406401065)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'pl'
,p_message_text=>'Poziomo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113599941133401065)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'pl'
,p_message_text=>'Pionowo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113599047259401064)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'pl'
,p_message_text=>'Rozmiar strony'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113599644268401064)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'pl'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113599508481401064)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'pl'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113599716080401064)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'pl'
,p_message_text=>'Niestandardowy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113599397866401064)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'pl'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113599297162401064)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'pl'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113599409534401064)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'pl'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113732467426401162)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'pl'
,p_message_text=>unistr('Procent liczby \0142\0105cznej %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113731690877401162)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'pl'
,p_message_text=>unistr('Procent sumy \0142\0105cznej %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113730655964401161)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'pl'
,p_message_text=>unistr('Procent liczby \0142\0105cznej')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113730531866401161)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'pl'
,p_message_text=>unistr('Procent sumy \0142\0105cznej')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113619952533401079)
,p_name=>'APEXIR_PIE'
,p_message_language=>'pl'
,p_message_text=>unistr('Ko\0142owy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113679812301401124)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'pl'
,p_message_text=>'Tabela przestawna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113681323120401125)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'pl'
,p_message_text=>unistr('Trzeba okre\015Bli\0107 agregacj\0119.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113681569670401125)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna agregowa\0107 z u\017Cyciem kolumny wybranej jako kolumna wiersza.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113680709140401124)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>'Kolumny przestawne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113680559254401124)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'pl'
,p_message_text=>'Kolumna przestawna: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113681114029401124)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'pl'
,p_message_text=>unistr('Trzeba okre\015Bli\0107 kolumn\0119 przestawn\0105.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113581253107401051)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'pl'
,p_message_text=>unistr('Maksymalna liczba wierszy dla zapytania dot. tabeli przestawnej ogranicza nie liczb\0119 wy\015Bwietlanych wierszy, lecz liczb\0119 wierszy w zapytaniu podstawowym. Zapytanie podstawowe przekracza maksymaln\0105 liczb\0119 wierszy (%0). Prosz\0119 zastosowa\0107 filtr w celu og')
||unistr('raniczenia liczby rekord\00F3w w zapytaniu przestawnym.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113681037526401124)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'pl'
,p_message_text=>'Sortowanie tabeli przestawnej'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113650436261401101)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'pl'
,p_message_text=>unistr('Kolumna przestawna zawiera zbyt wiele r\00F3\017Cnych warto\015Bci - nie mo\017Cna wygenerowa\0107 kodu SQL przestawiania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113703849312401141)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'pl'
,p_message_text=>unistr('Podgl\0105d')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113637997644401092)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'pl'
,p_message_text=>'Wstecz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113729584598401160)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'pl'
,p_message_text=>'Podstawowy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113704873513401142)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'pl'
,p_message_text=>'Raport podstawowy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113598958460401064)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Do\0142\0105cz tagi u\0142atwie\0144 dost\0119pu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113585889021401054)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'pl'
,p_message_text=>unistr('Roz\0142\00F3\017C tekst z formatowaniem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113662685716401111)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'pl'
,p_message_text=>'Prywatny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113620561296401080)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'pl'
,p_message_text=>'Publiczny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113616196206401077)
,p_name=>'APEXIR_RED'
,p_message_language=>'pl'
,p_message_text=>'czerwony'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113758143427401181)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'Statyczny ID %0 obszaru nie istnieje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113647286967401099)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113647363825401099)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 wszystkie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113753423054401178)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 wykres')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113646832228401099)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 przerw\0119 kontroln\0105')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113646565709401098)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 filtr')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113646628116401099)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 Flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113753513071401178)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 "Grupuj wg"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113646929675401099)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 wyr\00F3\017Cnienie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113753601769401178)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 tabel\0119 przestawn\0105')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113734669569401164)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'pl'
,p_message_text=>unistr('Usu\0144 raport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113715229003401150)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'pl'
,p_message_text=>unistr('Zmie\0144 nazw\0119 raportu domy\015Blnego')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113656499857401106)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'pl'
,p_message_text=>unistr('Zmie\0144 nazw\0119 raportu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113638258883401092)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'pl'
,p_message_text=>'Raport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113732520509401163)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'pl'
,p_message_text=>'Raporty'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113612701322401074)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'Zapisany raport interaktywny z aliasem "%0" nie istnieje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113662966403401111)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'Raport nie istnieje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113612843261401074)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'ID %0 zapisanego raportu interaktywnego nie istnieje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113654750342401105)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'pl'
,p_message_text=>'Ustawienia raportu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113635558373401090)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'pl'
,p_message_text=>'Widok raportu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113639405376401093)
,p_name=>'APEXIR_RESET'
,p_message_language=>'pl'
,p_message_text=>'Resetuj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113620784637401080)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'pl'
,p_message_text=>unistr('Przywr\00F3\0107 ustawienia domy\015Blne raportu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113615924553401076)
,p_name=>'APEXIR_ROW'
,p_message_language=>'pl'
,p_message_text=>'Wiersz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113728604841401160)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'pl'
,p_message_text=>unistr('Kolumny ROWID nie mo\017Cna u\017Cy\0107 jako kolumny g\0142\00F3wnego klucza \017Ar\00F3d\0142a danych REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113645980407401098)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'pl'
,p_message_text=>'Wiersze'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113705542374401142)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'pl'
,p_message_text=>'Liczba wierszy na stronie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113680853434401124)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>'Kolumny wiersza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113680666903401124)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'pl'
,p_message_text=>'Kolumna wiersza: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113681237413401125)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'pl'
,p_message_text=>unistr('Trzeba okre\015Bli\0107 wiersz przestawny.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113681428690401125)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'pl'
,p_message_text=>unistr('Kolumna wiersza musi si\0119 r\00F3\017Cni\0107 od kolumny przestawnej.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113660035590401109)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'pl'
,p_message_text=>'Filtr wierszy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113635653132401091)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'pl'
,p_message_text=>'Wiersz %0 z %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113639609062401093)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'pl'
,p_message_text=>'Tekst wiersza zawiera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113615298433401076)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'pl'
,p_message_text=>'Zapisz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113650029155401101)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'pl'
,p_message_text=>'Zapisany raport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113649958694401101)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'pl'
,p_message_text=>'Zapisany raport = "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113652108645401103)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'pl'
,p_message_text=>unistr('Ustawienia bie\017C\0105cego raportu b\0119d\0105 u\017Cywane dla wszystkich u\017Cytkownik\00F3w jako domy\015Blne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113715143431401150)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'pl'
,p_message_text=>unistr('Zapisz raport domy\015Blny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113639357681401093)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'pl'
,p_message_text=>'Zapisz raport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113753805797401178)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'pl'
,p_message_text=>'Zapisz raport *'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113706519067401143)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'pl'
,p_message_text=>'Szukaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113644884455401097)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'pl'
,p_message_text=>'Pasek wyszukiwania'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113753737147401178)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Szukaj: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113712030922401147)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'pl'
,p_message_text=>'Wyszukaj raport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113696039432401135)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>'Wybrane kolumny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113616968202401077)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('- Wyb\00F3r kolumny -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113638678346401093)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r kolumn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113620441513401080)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'pl'
,p_message_text=>unistr('- Wyb\00F3r funkcji -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113645686599401098)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('- Wyb\00F3r kolumny "Grupuj wg" -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113680301734401124)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('- Wyb\00F3r kolumny przestawnej -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113731597063401162)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r wiersza')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113680439980401124)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('- Wyb\00F3r wiersza przestawnego -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113589150836401057)
,p_name=>'APEXIR_SEND'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Blij')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113595438592401061)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Blij jako e-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113615670645401076)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'pl'
,p_message_text=>'Sekwencja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113638868831401093)
,p_name=>'APEXIR_SORT'
,p_message_language=>'pl'
,p_message_text=>'Sortuj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113648120242401100)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'pl'
,p_message_text=>unistr('Sortuj rosn\0105co')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113648203033401100)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'pl'
,p_message_text=>unistr('Sortuj malej\0105co')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113734064244401164)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'pl'
,p_message_text=>unistr('Porz\0105dek sortowania')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113642634154401096)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'pl'
,p_message_text=>'spacja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113653773854401104)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'pl'
,p_message_text=>'Status %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113704254634401141)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'pl'
,p_message_text=>'Subskrypcja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113730904142401161)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'pl'
,p_message_text=>'Koniec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113585318085401054)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'pl'
,p_message_text=>unistr('Pomi\0144, je\015Bli nie znaleziono \017Cadnych danych')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113730829794401161)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'pl'
,p_message_text=>unistr('Pocz\0105tek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113731755038401162)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'pl'
,p_message_text=>'Suma %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113721774812401155)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'pl'
,p_message_text=>unistr('Obszar = %0, raport = %1, widok = %2, wy\015Bwietlane wiersze (pocz\0105tek)= %3, wy\015Bwietlane wiersze (koniec) = %4, \0142\0105czna liczba wierszy = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113642371705401095)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'pl'
,p_message_text=>unistr('Obszar = %0, raport = %1, widok = %2, pocz\0105tek wy\015Bwietlanych wierszy = %3, koniec wy\015Bwietlanych wierszy = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113614563582401075)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'pl'
,p_message_text=>'Kolor tekstu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113631627536401087)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'pl'
,p_message_text=>'dni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113631543872401087)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'pl'
,p_message_text=>'godz.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113631493449401087)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'pl'
,p_message_text=>'min'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113631857688401088)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'pl'
,p_message_text=>'mies.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113631737018401088)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'pl'
,p_message_text=>'tyg./tydz.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113631979718401088)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'pl'
,p_message_text=>'lat(a)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113734470900401164)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Prze\0142\0105cz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113647421438401099)
,p_name=>'APEXIR_TOP'
,p_message_language=>'pl'
,p_message_text=>unistr('Na pocz\0105tek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113727674231401159)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Kolumna niezgrupowana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113648992926401100)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'pl'
,p_message_text=>unistr('Nazwa wyr\00F3\017Cnienia musi by\0107 unikatowa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113619282400401079)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('nieobs\0142ugiwany typ danych')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113647596381401099)
,p_name=>'APEXIR_UP'
,p_message_language=>'pl'
,p_message_text=>unistr('W g\00F3r\0119')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113649112724401100)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 wprowadzi\0107 poprawny kolor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113649264015401100)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 wprowadzi\0107 poprawn\0105 mask\0119 formatu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113616487020401077)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'pl'
,p_message_text=>unistr('Warto\015B\0107')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113648026247401100)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Tytu\0142 osi dla warto\015Bci')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113655846827401106)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Wymagana warto\015B\0107')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113619838063401079)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'pl'
,p_message_text=>'Kolumna pionowa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113723516120401156)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'pl'
,p_message_text=>'Pionowo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113655138316401105)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Bwietl wykres')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113710370751401146)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'pl'
,p_message_text=>unistr('Poka\017C szczeg\00F3\0142y')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113755913794401179)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'Raport nie ma zdefiniowanego widoku "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113710408181401146)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Bwietl "Grupuj wg"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113710230609401146)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'pl'
,p_message_text=>unistr('Ikony widok\00F3w')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113680156058401124)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Bwietl tabel\0119 przestawn\0105')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113655217321401105)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Bwietl raport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113704433595401141)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'pl'
,p_message_text=>unistr('Co tydzie\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113638181355401092)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'pl'
,p_message_text=>'Raport roboczy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113733109184401163)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'pl'
,p_message_text=>'%0 dni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113733072108401163)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'pl'
,p_message_text=>'%0 godz.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113732973231401163)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'pl'
,p_message_text=>'%0 min'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113733329419401163)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'pl'
,p_message_text=>'%0 mies.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113733275852401163)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'pl'
,p_message_text=>'%0 tyg.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113733408818401163)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'pl'
,p_message_text=>'%0 lat(a)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113731172576401162)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'pl'
,p_message_text=>'Rok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113614213283401075)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'pl'
,p_message_text=>unistr('\017C\00F3\0142ty')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113615771447401076)
,p_name=>'APEXIR_YES'
,p_message_language=>'pl'
,p_message_text=>'Tak'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113647810314401099)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 zawiera < lub > (s\0105 to znaki niedozwolone).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113670682582401117)
,p_name=>'APEX_REGION'
,p_message_language=>'pl'
,p_message_text=>'Obszar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113598865515401064)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'pl'
,p_message_text=>unistr('Naruszenie wst\0119pnego warunku API')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113618393367401078)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna uzyska\0107 warto\015Bci ustawienia "%0" aplikacji, poniewa\017C powi\0105zana opcja kompilacji jest wy\0142\0105czona.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113618241076401078)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna ustawi\0107 warto\015Bci ustawienia "%0" aplikacji, poniewa\017C powi\0105zana opcja kompilacji jest wy\0142\0105czona.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113725945649401158)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'pl'
,p_message_text=>unistr('Warto\015B\0107 ustawienia "%0" aplikacji jest niepoprawna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113725819200401158)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'pl'
,p_message_text=>unistr('\017B\0105dane ustawienie "%0" aplikacji nie zosta\0142o zdefiniowane')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113726060958401158)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'pl'
,p_message_text=>unistr('Warto\015Bci\0105 ustawienia "%0" aplikacji nie mo\017Ce by\0107 Null')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113606918939401070)
,p_name=>'BACK'
,p_message_language=>'pl'
,p_message_text=>'Wstecz'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113593986637401060)
,p_name=>'BUILDER'
,p_message_language=>'pl'
,p_message_text=>'Konstruktor'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113658017591401107)
,p_name=>'BUTTON LABEL'
,p_message_language=>'pl'
,p_message_text=>'Etykieta przycisku'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113593057308401060)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'pl'
,p_message_text=>'Klasy CSS przycisku'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113622213456401081)
,p_name=>'BUTTON_ID'
,p_message_language=>'pl'
,p_message_text=>unistr('Wygenerowany ID przycisku b\0119dzie albo statycznym ID (o ile zdefiniowano) przycisku, albo nie b\0119dzie wewn\0119trznie wygenerowanym ID w formacie ''B'' || [Wewn\0119trzny ID przycisku]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113585740652401054)
,p_name=>'CANDLESTICK'
,p_message_language=>'pl'
,p_message_text=>unistr('\015Awiecowy')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113667285797401114)
,p_name=>'CENTER'
,p_message_language=>'pl'
,p_message_text=>unistr('\015Arodek')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113617285844401077)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'pl'
,p_message_text=>unistr('\017B\0105danie %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113608624448401071)
,p_name=>'CHECK$'
,p_message_language=>'pl'
,p_message_text=>'selektor wierszy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113727788968401159)
,p_name=>'CHECKED'
,p_message_language=>'pl'
,p_message_text=>'zaznaczone'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113703278915401141)
,p_name=>'COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Kolumna'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113663733386401111)
,p_name=>'COMMENTS'
,p_message_language=>'pl'
,p_message_text=>'Komentarze'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113645291098401097)
,p_name=>'CONTINUE'
,p_message_language=>'pl'
,p_message_text=>'Kontynuuj'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113607243385401070)
,p_name=>'COPYRIGHT'
,p_message_language=>'pl'
,p_message_text=>unistr('Copyright &copy; %0. Wszelkie prawa zastrze\017Cone.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113650907903401102)
,p_name=>'COUNT'
,p_message_language=>'pl'
,p_message_text=>'Licznik'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113657601535401107)
,p_name=>'CREATE'
,p_message_language=>'pl'
,p_message_text=>unistr('Utw\00F3rz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113709910712401146)
,p_name=>'CREATED'
,p_message_language=>'pl'
,p_message_text=>'Utworzono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113710036949401146)
,p_name=>'CREATED_BY'
,p_message_language=>'pl'
,p_message_text=>unistr('Tw\00F3rca')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113634856556401090)
,p_name=>'CREATED_ON'
,p_message_language=>'pl'
,p_message_text=>'Utworzono'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113645499979401098)
,p_name=>'CUSTOM'
,p_message_language=>'pl'
,p_message_text=>'Niestandardowe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113656684162401106)
,p_name=>'CUSTOMIZE'
,p_message_language=>'pl'
,p_message_text=>'Dostosuj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113658258689401107)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'pl'
,p_message_text=>unistr('Zresetowano dla u\017Cytkownika "%0" preferencje dot. strony.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113658362256401107)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'pl'
,p_message_text=>unistr('Zmieniono dla u\017Cytkownika "%0" preferencje dot. strony.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113658101709401107)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'pl'
,p_message_text=>unistr('Zresetowano dla u\017Cytkownika "%0" preferencje dot. strony.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113621937923401081)
,p_name=>'DAILY'
,p_message_language=>'pl'
,p_message_text=>unistr('Co dzie\0144')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113593548342401060)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wysy\0142any plik jest niepoprawny lub ma niew\0142a\015Bciwe rozszerzenie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113617455150401077)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'pl'
,p_message_text=>unistr('U\017Cyto niepoprawnego selektora XML lub JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113586753128401055)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'pl'
,p_message_text=>unistr('Profil danych i wys\0142any plik nie zawieraj\0105 \017Cadnej kolumny tabeli docelowej.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113672425295401118)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'pl'
,p_message_text=>unistr('W wys\0142anym pliku nie znaleziono \017Cadnych danych.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113672568048401118)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'pl'
,p_message_text=>unistr('W wys\0142anym arkuszu roboczym "%0" nie znaleziono \017Cadnych danych.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113592398607401059)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'pl'
,p_message_text=>'Podany plik nie jest plikiem XLSX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113582709441401052)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'pl'
,p_message_text=>unistr('\0141adowanie danych zako\0144czone; liczba przetworzonych wierszy: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113583954530401053)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'pl'
,p_message_text=>unistr('\0141adowanie danych zako\0144czone; liczba przetworzonych wierszy z 1 b\0142\0119dem: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113584200946401053)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'pl'
,p_message_text=>unistr('\0141adowanie danych zako\0144czone; liczba przetworzonych wierszy z %1 b\0142\0119dami: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113584090293401053)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'pl'
,p_message_text=>unistr('\0141adowanie danych zako\0144czone; liczba przetworzonych wierszy: 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113587054069401055)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'pl'
,p_message_text=>unistr('\0141adowanie danych zako\0144czone; liczba przetworzonych wierszy z b\0142\0119dem: 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113584108853401053)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'pl'
,p_message_text=>unistr('\0141adowanie danych zako\0144czone; liczba przetworzonych wierszy bez b\0142\0119du: 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113677743177401122)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'pl'
,p_message_text=>'Kolumna docelowa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113677801388401122)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'pl'
,p_message_text=>unistr('Kolumna \017Ar\00F3d\0142owa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113678666330401123)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'pl'
,p_message_text=>'Format daty/liczby'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113742080465401169)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie uda\0142o si\0119 pobra\0107 warto\015Bci wyszukiwania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113710562357401146)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'pl'
,p_message_text=>'Odwzorowanie dane/tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113678773793401123)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'pl'
,p_message_text=>'Wiersz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113674205689401119)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'pl'
,p_message_text=>unistr('Niepowodzenie regu\0142y transformacji')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113650515413401101)
,p_name=>'DATE'
,p_message_language=>'pl'
,p_message_text=>'Data'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113624622962401083)
,p_name=>'DAY'
,p_message_language=>'pl'
,p_message_text=>unistr('dzie\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113624749896401083)
,p_name=>'DAYS'
,p_message_language=>'pl'
,p_message_text=>'dni'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113663422860401111)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'pl'
,p_message_text=>unistr('Wykrywanie b\0142\0119d\00F3w nie jest w\0142\0105czone dla tej aplikacji.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113712233839401148)
,p_name=>'DEFAULT'
,p_message_language=>'pl'
,p_message_text=>unistr('Domy\015Blny')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113625479406401083)
,p_name=>'DELETE'
,p_message_language=>'pl'
,p_message_text=>unistr('usu\0144')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113585662693401054)
,p_name=>'DIAL_PCT'
,p_message_language=>'pl'
,p_message_text=>'Tarczowy (procent)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113600167512401065)
,p_name=>'DOWNLOAD'
,p_message_language=>'pl'
,p_message_text=>'Pobierz'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113711390900401147)
,p_name=>'DUP_USER'
,p_message_language=>'pl'
,p_message_text=>unistr('Zduplikowana nazwa u\017Cytkownika na li\015Bcie.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113607706864401070)
,p_name=>'EDIT'
,p_message_language=>'pl'
,p_message_text=>'Edytuj'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113617162350401077)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'pl'
,p_message_text=>'Nie znaleziono adresu e-mail "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113602260687401066)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'pl'
,p_message_text=>unistr('Nadawc\0105 tego e-maila jest %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113711548606401147)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'pl'
,p_message_text=>unistr('Adres e-mail jest zbyt d\0142ugi. Maksymalna liczba znak\00F3w to 240.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113645115348401097)
,p_name=>'ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113674335060401119)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna ustawi\0107 warto\015Bci \017Ar\00F3d\0142owej elementu dla obszaru obj\0119tego cz\0119\015Bciowym od\015Bwie\017Caniem strony')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113636630066401091)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'pl'
,p_message_text=>unistr('Tw\00F3rca')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113602565705401067)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o wygas\0142o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113596613759401062)
,p_name=>'FILE_EMPTY'
,p_message_language=>'pl'
,p_message_text=>'Plik jest pusty.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113676864528401121)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'pl'
,p_message_text=>unistr('Rozmiar wys\0142anego pliku by\0142 wi\0119kszy ni\017C %0\00A0MB. Prosz\0119 wys\0142a\0107 mniejszy plik.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113604608833401068)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie uda\0142o si\0119 zidentyfikowa\0107 u\017Cytkownika; nie wys\0142ano jednego lub wi\0119kszej liczby plik\00F3w.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113604712509401068)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Ta instancja nie zezwala na wysy\0142anie plik\00F3w przez niezidentyfikowanych u\017Cytkownik\00F3w.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113657742145401107)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyst\0105pi\0142 b\0142\0105d (1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113656978044401106)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyst\0105pi\0142y b\0142\0119dy (%0)')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113607136618401070)
,p_name=>'FORM_OF'
,p_message_language=>'pl'
,p_message_text=>'%0 z %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113641828400401095)
,p_name=>'GO'
,p_message_language=>'pl'
,p_message_text=>'Wykonaj'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113741645297401169)
,p_name=>'HELP'
,p_message_language=>'pl'
,p_message_text=>'Pomoc'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113594080799401060)
,p_name=>'HOME'
,p_message_language=>'pl'
,p_message_text=>'Strona startowa'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113624455014401082)
,p_name=>'HOUR'
,p_message_language=>'pl'
,p_message_text=>'godz.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113624584554401082)
,p_name=>'HOURS'
,p_message_language=>'pl'
,p_message_text=>'godz.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113608589686401071)
,p_name=>'ICON'
,p_message_language=>'pl'
,p_message_text=>'Ikona "%0"'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113658529738401108)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawne uwierzytelnienia logowania'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113758066794401181)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'pl'
,p_message_text=>unistr('Niepoprawna warto\015B\0107 parametru: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113653226045401103)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'pl'
,p_message_text=>unistr('Jak ustawienia domy\015Blne raportu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113653347515401104)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'pl'
,p_message_text=>'Jak nazwany raport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113635707188401091)
,p_name=>'IR_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 - b\0142\0105d. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113635423841401090)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna obliczy\0107 nawigacji po formularzu. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113613082147401074)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'pl'
,p_message_text=>'Nie znaleziono raportu interaktywnego.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113612499167401074)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'Obszar raportu interaktywnego nie istnieje w aplikacji %0 (strona %1 i obszar %2).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113653142139401103)
,p_name=>'IR_STAR'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Bwietlane tylko dla programist\00F3w')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113641590216401095)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Zapytanie raportu wymaga unikatowego klucza do identyfikowania poszczeg\00F3lnych wierszy. Dostarczonego klucza nie mo\017Cna u\017Cy\0107 dla tego zapytania. Prosz\0119 zdefiniowa\0107 kolumn\0119 unikatowego klucza. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113641656200401095)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'pl'
,p_message_text=>unistr('Zapytanie raportu wymaga unikatowego klucza do identyfikowania poszczeg\00F3lnych wierszy. Dostarczonego klucza nie mo\017Cna u\017Cy\0107 dla tego zapytania. Prosz\0119 - edytuj\0105c atrybuty raportu - zdefiniowa\0107 kolumn\0119 unikatowego klucza. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113678934384401123)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'pl'
,p_message_text=>unistr('wybra\0107 plik')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113678842575401123)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 tu przeci\0105gn\0105\0107 plik lub')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113607487328401070)
,p_name=>'ITEMS'
,p_message_language=>'pl'
,p_message_text=>'Elementy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113636884241401091)
,p_name=>'ITEM_VALUE'
,p_message_language=>'pl'
,p_message_text=>unistr('Warto\015B\0107 elementu')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113651224930401102)
,p_name=>'LABEL'
,p_message_language=>'pl'
,p_message_text=>'Etykieta'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113663399754401111)
,p_name=>'LANGUAGE'
,p_message_language=>'pl'
,p_message_text=>unistr('J\0119zyk')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113625113601401083)
,p_name=>'LAST'
,p_message_language=>'pl'
,p_message_text=>'ostatni(a)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113604508382401068)
,p_name=>'LENGTH'
,p_message_language=>'pl'
,p_message_text=>unistr('D\0142ugo\015B\0107')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113657896177401107)
,p_name=>'LOGIN'
,p_message_language=>'pl'
,p_message_text=>'Zaloguj'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113696486772401136)
,p_name=>'MANAGE'
,p_message_language=>'pl'
,p_message_text=>unistr('Zarz\0105dzanie')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113761073729401183)
,p_name=>'MAXIMIZE'
,p_message_language=>'pl'
,p_message_text=>'Maksymalizuj'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113624286774401082)
,p_name=>'MINUTE'
,p_message_language=>'pl'
,p_message_text=>'min'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113624375138401082)
,p_name=>'MINUTES'
,p_message_language=>'pl'
,p_message_text=>'min'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113711769424401147)
,p_name=>'MISSING_AT'
,p_message_language=>'pl'
,p_message_text=>'Brak "@" w adresie e-mail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113711993185401147)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'pl'
,p_message_text=>unistr('Ostrze\017Cenie: W aplikacji %1 nie zdefiniowano dla strony "Okno dialogowe" (%0) \017Cadnego szablonu strony "Okno dialogowe".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113711627252401147)
,p_name=>'MISSING_DOT'
,p_message_language=>'pl'
,p_message_text=>'Brak "." w domenie adresu e-mail.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113660821869401109)
,p_name=>'MODULE'
,p_message_language=>'pl'
,p_message_text=>unistr('Modu\0142')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113617919728401078)
,p_name=>'MONTH'
,p_message_language=>'pl'
,p_message_text=>unistr('Miesi\0105c')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113621787742401081)
,p_name=>'MONTHLY'
,p_message_language=>'pl'
,p_message_text=>unistr('Co miesi\0105c')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113618081214401078)
,p_name=>'MONTHS'
,p_message_language=>'pl'
,p_message_text=>'mies.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113650897899401102)
,p_name=>'MOVE'
,p_message_language=>'pl'
,p_message_text=>unistr('Przenie\015B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113718362271401152)
,p_name=>'MOVE_FROM'
,p_message_language=>'pl'
,p_message_text=>unistr('Przenie\015B z')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113718466585401152)
,p_name=>'MOVE_TO'
,p_message_language=>'pl'
,p_message_text=>unistr('Przenie\015B do')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113638072491401092)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas wykonywania operacji usuwania wielu wierszy: wiersz = %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113637073925401092)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Ce by\0107 u\017Cytkownikiem publicznym')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113594234219401061)
,p_name=>'NAME'
,p_message_language=>'pl'
,p_message_text=>'Nazwa'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113651001482401102)
,p_name=>'NEW'
,p_message_language=>'pl'
,p_message_text=>'Nowe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113617781986401078)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'pl'
,p_message_text=>unistr('Mo\017Cna si\0119 zalogowa\0107 do "%0", przechodz\0105c do:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113617853192401078)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'pl'
,p_message_text=>'Powiadomienie o nowym koncie (%0)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113741833047401169)
,p_name=>'NEXT'
,p_message_language=>'pl'
,p_message_text=>'Dalej'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113660798292401109)
,p_name=>'NO'
,p_message_language=>'pl'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113756085139401179)
,p_name=>'NOBODY'
,p_message_language=>'pl'
,p_message_text=>'nikt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113625572178401083)
,p_name=>'NOT'
,p_message_language=>'pl'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113666384600401113)
,p_name=>'NOT_NULL'
,p_message_language=>'pl'
,p_message_text=>'Nie Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113637146655401092)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'pl'
,p_message_text=>'Nie %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113656729895401106)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'pl'
,p_message_text=>'nie znaleziono danych'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113665827073401113)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie znaleziono \017Cadnego aktualizowalnego raportu. Operacje aktualizacji i usuwania wielu wierszy mog\0105 by\0107 wykonywane tylko w formularzach tabelarycznych typu "Raport aktualizowalny".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113666794088401114)
,p_name=>'OK'
,p_message_language=>'pl'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113662412820401111)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'pl'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113759861755401182)
,p_name=>'ORA_06550'
,p_message_language=>'pl'
,p_message_text=>'ORA-06550: linia %0, kolumna %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113709388599401145)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'pl'
,p_message_text=>unistr('Jest u\017Cywana nieaktualna przegl\0105darka internetowa. List\0119 obs\0142ugiwanych przegl\0105darek mo\017Cna znale\017A\0107 w podr\0119czniku Oracle Application Express Installation Guide.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113610733783401073)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'pl'
,p_message_text=>unistr('Zosta\0142 za\017C\0105dany niepoprawny zbi\00F3r wierszy - \017Ar\00F3d\0142o danych raportu zosta\0142o zmodyfikowane.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113630802676401087)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Trzeba poda\0107 poprawny numer strony, na przyk\0142ad p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113634431703401090)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'pl'
,p_message_text=>'Dalej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113634532503401090)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'pl'
,p_message_text=>unistr('Nast\0119pny zbi\00F3r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113634609446401090)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'pl'
,p_message_text=>'Wstecz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113634788792401090)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'pl'
,p_message_text=>unistr('Poprzedni zbi\00F3r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113741771209401169)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r paginacji')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113672347230401118)
,p_name=>'PASSWORD'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113617093960401077)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o do "%0" zosta\0142o zmienione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113606882794401070)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o nie spe\0142nia regu\0142 z\0142o\017Cono\015Bci has\0142a obowi\0105zuj\0105cych dla tego serwisu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113605916499401069)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nowe has\0142o musi si\0119 r\00F3\017Cni\0107 od starego przynajmniej %0 znakami.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113606500238401070)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o nie mo\017Ce zawiera\0107 nazwy u\017Cytkownika.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113606770017401070)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o zawiera niedozwolone zwyk\0142e s\0142owo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113606683647401070)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o nie mo\017Ce zawiera\0107 nazwy obszaru roboczego.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113605843461401069)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o musi si\0119 sk\0142ada\0107 z przynajmniej nast\0119puj\0105cej liczby znak\00F3w: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113606069894401069)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o musi zawiera\0107 przynajmniej jedn\0105 liter\0119 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113606405107401069)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o musi zawiera\0107 przynajmniej jedn\0105 ma\0142\0105 liter\0119.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113606114721401069)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o musi zawiera\0107 przynajmniej jedn\0105 cyfr\0119 (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113606219639401069)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o musi zawiera\0107 przynajmniej jeden znak przestankowy (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113606366378401069)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o musi zawiera\0107 przynajmniej jedn\0105 wielk\0105 liter\0119.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113617511003401078)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'pl'
,p_message_text=>unistr('Powiadomienie o zresetowaniu has\0142a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113604875800401068)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Tego has\0142a nie mo\017Cna u\017Cy\0107, poniewa\017C by\0142o ono u\017Cywane w ci\0105gu %0 ostatnich dni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113685125233401127)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'pl'
,p_message_text=>'Elementy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113685220850401127)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'pl'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113662234766401110)
,p_name=>'PERCENT'
,p_message_language=>'pl'
,p_message_text=>'Procent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113632599068401088)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 si\0119 skontaktowa\0107 z administratorem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113741956529401169)
,p_name=>'PREVIOUS'
,p_message_language=>'pl'
,p_message_text=>'Wstecz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113677341781401122)
,p_name=>'PRINT'
,p_message_language=>'pl'
,p_message_text=>'Drukuj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113661022400401109)
,p_name=>'PRIVILEGES'
,p_message_language=>'pl'
,p_message_text=>'Uprawnienia'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113630927481401087)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'pl'
,p_message_text=>unistr('Odwo\0142ania do obszaru')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113651176929401102)
,p_name=>'REPORT'
,p_message_language=>'pl'
,p_message_text=>'Raport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113660909028401109)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'pl'
,p_message_text=>'Okres raportowania'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113742171924401169)
,p_name=>'REPORT_LABEL'
,p_message_language=>'pl'
,p_message_text=>'Raport: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113661670403401110)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'pl'
,p_message_text=>'Podsumowanie raportu'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113610878707401073)
,p_name=>'RESET'
,p_message_language=>'pl'
,p_message_text=>unistr('Resetuj paginacj\0119')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113636760271401091)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'pl'
,p_message_text=>unistr('Resetuj paginacj\0119')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113665798801401113)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'pl'
,p_message_text=>unistr('Resetuj has\0142o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113642575961401095)
,p_name=>'RESTORE'
,p_message_language=>'pl'
,p_message_text=>unistr('Odtw\00F3rz')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113674400432401119)
,p_name=>'RESULTS'
,p_message_language=>'pl'
,p_message_text=>'Wyniki'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113666805561401114)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'pl'
,p_message_text=>unistr('Powr\00F3t do aplikacji.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113667161028401114)
,p_name=>'RIGHT'
,p_message_language=>'pl'
,p_message_text=>'Po prawej'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113696743977401136)
,p_name=>'ROW'
,p_message_language=>'pl'
,p_message_text=>'Wiersz %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113650742024401102)
,p_name=>'ROW_COUNT'
,p_message_language=>'pl'
,p_message_text=>'Liczba wierszy'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113666266933401113)
,p_name=>'SAVE'
,p_message_language=>'pl'
,p_message_text=>'Zapisz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113662814210401111)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'pl'
,p_message_text=>unistr('Alternatywny domy\015Blny')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113663215045401111)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'pl'
,p_message_text=>'Opis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113662705626401111)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'pl'
,p_message_text=>unistr('Podstawowy domy\015Blny')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113663575653401111)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'pl'
,p_message_text=>unistr('Liczba dost\0119pnych wierszy przekracza %0. Aby wy\015Bwietli\0107 wi\0119cej wierszy, prosz\0119 zwi\0119kszy\0107 warto\015B\0107 selektora wierszy.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113728953777401160)
,p_name=>'SEARCH'
,p_message_language=>'pl'
,p_message_text=>'Szukaj'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113624151731401082)
,p_name=>'SECONDS'
,p_message_language=>'pl'
,p_message_text=>'s'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113662397764401110)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'pl'
,p_message_text=>unistr('Zob. za\0142\0105czone')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113720070791401153)
,p_name=>'SELECT_ROW'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyb\00F3r wiersza')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113662081461401110)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\0142\0105cz tryb czytnika ekranu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113662153672401110)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'pl'
,p_message_text=>unistr('W\0142\0105cz tryb czytnika ekranu')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113658422352401108)
,p_name=>'SHOW'
,p_message_language=>'pl'
,p_message_text=>unistr('Poka\017C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113721859393401155)
,p_name=>'SHOW_ALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Poka\017C wszystkie')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113747910150401174)
,p_name=>'SIGN_IN'
,p_message_language=>'pl'
,p_message_text=>'Zaloguj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113697567857401136)
,p_name=>'SIGN_OUT'
,p_message_language=>'pl'
,p_message_text=>'Wyloguj'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113651773723401102)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0 dni temu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113658908702401108)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'%0 dni od teraz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113651607375401102)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0 godz. temu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113658832592401108)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'%0 godz. od teraz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113651514074401102)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0 min temu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113658756689401108)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'%0 min od teraz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113651921237401103)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0 mies. temu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113659115314401108)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'%0 mies. od teraz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113659393379401108)
,p_name=>'SINCE_NOW'
,p_message_language=>'pl'
,p_message_text=>'Teraz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113651403692401102)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0 s temu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113658684805401108)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'%0 s od teraz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113651831765401102)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0 tyg. temu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113659054409401108)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'%0 tyg. od teraz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113652046606401103)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'pl'
,p_message_text=>'%0 lat(a) temu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113659218432401108)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'pl'
,p_message_text=>'%0 lat(a) od teraz'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113645522970401098)
,p_name=>'STANDARD'
,p_message_language=>'pl'
,p_message_text=>'Standardowe'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113661944602401110)
,p_name=>'START_DATE'
,p_message_language=>'pl'
,p_message_text=>unistr('Data pocz\0105tkowa')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113602428214401067)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'pl'
,p_message_text=>unistr('Ta wiadomo\015B\0107 e-mail jest wysy\0142ana z subskrypcji raportu interaktywnego, utworzonej przez u\017Cytkownika %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113757110639401180)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'pl'
,p_message_text=>'Subskrypcje'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113705218039401142)
,p_name=>'TAB'
,p_message_language=>'pl'
,p_message_text=>'Tabulator'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113624056621401082)
,p_name=>'TITLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Tytu\0142')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113607057576401070)
,p_name=>'TODAY'
,p_message_language=>'pl'
,p_message_text=>'Dzisiaj'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113661543392401110)
,p_name=>'TOTAL'
,p_message_language=>'pl'
,p_message_text=>'Razem'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113608075633401071)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'pl'
,p_message_text=>unistr('Mo\017Cna wybra\0107 maksymalnie %0 kolumn(y).')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113586568170401055)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Zwi\0144 wszystkie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113586849572401055)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'pl'
,p_message_text=>unistr('Zwi\0144 wszystkie poni\017Cej')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113586457685401055)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Rozwi\0144 wszystkie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113586628068401055)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'pl'
,p_message_text=>unistr('Rozwi\0144 wszystkie poni\017Cej')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113586977587401055)
,p_name=>'TREE.REPARENT'
,p_message_language=>'pl'
,p_message_text=>'Zmiana rodzica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113679113411401123)
,p_name=>'TREES'
,p_message_language=>'pl'
,p_message_text=>'Drzewa'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113722626564401155)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'pl'
,p_message_text=>'Wymagane'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113646258527401098)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'pl'
,p_message_text=>'Brak autoryzacji'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113693060095401133)
,p_name=>'UNAVAILABLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Niedost\0119pne')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113659725180401108)
,p_name=>'UNKNOWN'
,p_message_language=>'pl'
,p_message_text=>'Nieznane'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113603338501401067)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Wyst\0105pi\0142 nieznany b\0142\0105d identyfikacji.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113605331681401069)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie chc\0105c ju\017C otrzymywa\0107 e-maili, prosz\0119 - w celu zarz\0105dzania swoj\0105 subskrypcj\0105 - klikn\0105\0107 <a href="%0">desubskrybuj</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113602350438401066)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie chc\0105c ju\017C otrzymywa\0107 e-maili, prosz\0119 - w celu zarz\0105dzania swoj\0105 subskrypcj\0105 - przej\015B\0107 pod nast\0119puj\0105cy adres URL:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113637267891401092)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('nieobs\0142ugiwany typ danych')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113625329194401083)
,p_name=>'UPDATE'
,p_message_language=>'pl'
,p_message_text=>'aktualizuj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113623972094401082)
,p_name=>'UPDATED'
,p_message_language=>'pl'
,p_message_text=>'Zaktualizowano'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113630698837401087)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'pl'
,p_message_text=>unistr('\017B\0105dany URL jest obj\0119ty zakazem dost\0119pu. Prosz\0119 si\0119 skontaktowa\0107 z administratorem.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113650684007401102)
,p_name=>'USER'
,p_message_language=>'pl'
,p_message_text=>unistr('U\017Cytkownik')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113672234939401118)
,p_name=>'USERNAME'
,p_message_language=>'pl'
,p_message_text=>unistr('Nazwa u\017Cytkownika')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113711871164401147)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'pl'
,p_message_text=>unistr('Nazwa u\017Cytkownika jest zbyt d\0142uga. Maksymalna liczba znak\00F3w to %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113657402303401107)
,p_name=>'USERS'
,p_message_language=>'pl'
,p_message_text=>unistr('u\017Cytkownicy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113711439251401147)
,p_name=>'USER_EXISTS'
,p_message_language=>'pl'
,p_message_text=>unistr('Nazwa u\017Cytkownika ju\017C istnieje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113726173733401158)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'pl'
,p_message_text=>unistr('Zdj\0119cie profilowe u\017Cytkownika %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113613717824401075)
,p_name=>'VALID'
,p_message_language=>'pl'
,p_message_text=>'Poprawne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113607343711401070)
,p_name=>'VALIDATIONS'
,p_message_language=>'pl'
,p_message_text=>'Weryfikacje'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113663066735401111)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'pl'
,p_message_text=>unistr('Trzeba okre\015Bli\0107 warto\015B\0107')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113706480518401143)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'pl'
,p_message_text=>unistr('Trzeba okre\015Bli\0107 warto\015B\0107 dla "%0"')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113632980989401088)
,p_name=>'VERTICAL'
,p_message_language=>'pl'
,p_message_text=>'pionowo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113625214496401083)
,p_name=>'VIEW'
,p_message_language=>'pl'
,p_message_text=>unistr('wy\015Bwietl')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113657577304401107)
,p_name=>'VIEWS'
,p_message_language=>'pl'
,p_message_text=>'widoki'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113663867729401112)
,p_name=>'VIEW_ALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Bwietl wszystkie')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113645028033401097)
,p_name=>'WARNING'
,p_message_language=>'pl'
,p_message_text=>unistr('Ostrze\017Cenie')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113624899448401083)
,p_name=>'WEEK'
,p_message_language=>'pl'
,p_message_text=>unistr('tydzie\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113621865815401081)
,p_name=>'WEEKLY'
,p_message_language=>'pl'
,p_message_text=>unistr('Co tydzie\0144')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113624979688401083)
,p_name=>'WEEKS'
,p_message_language=>'pl'
,p_message_text=>'tyg./tydz.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113663172975401111)
,p_name=>'WELCOME_USER'
,p_message_language=>'pl'
,p_message_text=>'Witamy: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113661394928401110)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'pl'
,p_message_text=>unistr('Wykryto niepoprawn\0105 warto\015B\0107; prosz\0119 sprawdzi\0107 wprowadzone dane.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113661426253401110)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wykryto niepoprawn\0105 warto\015B\0107; prosz\0119 sprawdzi\0107 wprowadzone dane.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113604498500401068)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wykryto niepoprawn\0105 warto\015B\0107 daty; prosz\0119 sprawdzi\0107 format daty.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113661263124401110)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'pl'
,p_message_text=>unistr('Wykryto niepoprawn\0105 warto\015B\0107 liczbow\0105; prosz\0119 sprawdzi\0107 format liczby.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113613328094401074)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'pl'
,p_message_text=>unistr('Wykryto niepoprawn\0105 warto\015B\0107 znacznika czasu; prosz\0119 sprawdzi\0107 format znacznika czasu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113635831682401091)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna powi\0105za\0107 "%0". Prosz\0119 uj\0105\0107 wielobajtowe elementy w cudzys\0142\00F3w oraz upewni\0107 si\0119, \017Ce d\0142ugo\015B\0107 elementu nie przekracza 30 bajt\00F3w. Dla element\00F3w o d\0142ugo\015Bci przekraczaj\0105cej 30 bajt\00F3w prosz\0119 u\017Cy\0107 sk\0142adni v().')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113626337554401084)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'pl'
,p_message_text=>unistr('Odmowa dost\0119pu ze wzgl\0119du na kontrol\0119 bezpiecze\0144stwa (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113628820637401086)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Aplikacja niedost\0119pna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113627255192401084)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'pl'
,p_message_text=>'ERR-1014 Nie znaleziono aplikacji.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113627380568401084)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'pl'
,p_message_text=>'aplikacja=%0 obszar roboczy=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113627797236401085)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'pl'
,p_message_text=>unistr('Dost\0119p do tej aplikacji jest ograniczony; prosz\0119 spr\00F3bowa\0107 p\00F3\017Aniej.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113627608241401085)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'pl'
,p_message_text=>unistr('Dost\0119p do tej aplikacji jest ograniczony do programist\00F3w aplikacji; prosz\0119 spr\00F3bowa\0107 p\00F3\017Aniej.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113626833601401084)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('ERR-7744 Nie mo\017Cna przetworzy\0107 odga\0142\0119zienia do funkcji zwracaj\0105cej URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113626708895401084)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('ERR-7744 Nie mo\017Cna przetworzy\0107 odga\0142\0119zienia do funkcji zwracaj\0105cej stron\0119.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113627007997401084)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('ERR-1430 Nieobs\0142ugiwane wywo\0142anie pokazania z procesu strony: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113628184428401085)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('ERR-1018 B\0142\0105d podczas czyszczenia pami\0119ci podr\0119cznej etapu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113626577331401084)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'pl'
,p_message_text=>'ERR-1005 Nieznany typ obliczenia.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113627442171401085)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'pl'
,p_message_text=>'ERR-1201 Nie ustawiono ID sesji dla identyfikacji niestandardowej.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113627581213401085)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'pl'
,p_message_text=>'strona=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113627168921401084)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('ERR-7620 Nie mo\017Cna ustali\0107 obszaru roboczego dla aplikacji (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113609529625401072)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'pl'
,p_message_text=>'Edytuj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113626229571401084)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'pl'
,p_message_text=>'ERR-1802 Nie znaleziono ID elementu "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113625952112401083)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'pl'
,p_message_text=>'ERR-1002 Nie znaleziono ID elementu "{%0}" w aplikacji "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113626061210401084)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'pl'
,p_message_text=>unistr('Nieoczekiwany b\0142\0105d, nie znaleziono nazwy elementu na poziomie aplikacji lub na poziomie strony.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113626454735401084)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'pl'
,p_message_text=>'To jest pierwsza strona danych.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113641976831401095)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'pl'
,p_message_text=>unistr('ID %0 elementu nie okre\015Bla elementu zdefiniowanego na bie\017C\0105cej stronie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113604076052401068)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna ustawi\0107 elementu, przekazuj\0105c argumenty do aplikacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113604354906401068)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'pl'
,p_message_text=>'(Nie podano sumy kontrolnej)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113603884412401068)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'pl'
,p_message_text=>unistr('Element mo\017Cna ustawi\0107, gdy towarzyszy mu suma kontrolna "zak\0142adka poziomu u\017Cytkownika".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113603785901401067)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'pl'
,p_message_text=>unistr('Element mo\017Cna ustawi\0107, gdy towarzyszy mu suma kontrolna "zak\0142adka poziomu aplikacji".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113603993371401068)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'pl'
,p_message_text=>unistr('Element mo\017Cna ustawi\0107, gdy towarzyszy mu suma kontrolna "sesja".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113603672215401067)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'pl'
,p_message_text=>'Element nie jest chroniony.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113628281436401085)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'pl'
,p_message_text=>unistr('Strona pomocy nie jest dost\0119pna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113617324096401077)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'pl'
,p_message_text=>unistr('Obszar roboczy "%0" nie ma uprawnie\0144 do rozk\0142adu jako schemat %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113626697620401084)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('ERR-1010 Przekroczono limit rekursji podczas przetwarzania akceptacji odga\0142\0119zienia do strony. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113604255579401068)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'pl'
,p_message_text=>unistr('Tej strony nie mo\017Cna wywo\0142a\0107 - aby pokaza\0107 procedur\0119 - u\017Cywaj\0105c adresu URL b\0105d\017A metody GET lub POST. Stron\0119 t\0119 trzeba wywo\0142a\0107, u\017Cywaj\0105c odga\0142\0119zienia typu "Odga\0142\0119zienie do strony".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113680937418401124)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas pr\00F3by zapisania warto\015Bci nieliczbowej w elemencie "%0". ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113619067873401079)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'pl'
,p_message_text=>unistr('Schemat "%0" rozk\0142adu aplikacji nie istnieje w bazie danych.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113619117126401079)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'pl'
,p_message_text=>unistr('Konta w obszarze roboczym INTERNAL mog\0105 by\0107 u\017Cywane tylko do uzyskiwania dost\0119pu do &PRODUCT_NAME. <a href="%0">Us\0142ugi administracyjne</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113625818438401083)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('ERR-1029 Nie mo\017Cna sk\0142adowa\0107 informacji o sesji. Sesja=%0, element=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113628942363401086)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna zatrzyma\0107 \015Bledzenia: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113626172342401084)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nieoczekiwany b\0142\0105d')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113636108471401091)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d w update_substitution_cache: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113629061908401086)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Aby mo\017Cna by\0142o wy\015Bwietli\0107 pomoc, trzeba okre\015Bli\0107 aplikacj\0119 i stron\0119.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113649549440401101)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'pl'
,p_message_text=>'Nie znaleziono automatyzacji.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113630132972401086)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'pl'
,p_message_text=>'Skasowane sesje: %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113589459193401057)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna wykona\0107 kodu %0. Kod ten nie jest obs\0142ugiwany przez baz\0119 danych albo nie zosta\0142 w\0142\0105czony przez parametr MLE_LANGUAGES instancji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113589201836401057)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'pl'
,p_message_text=>unistr('Motor wieloj\0119zyczny nie jest dost\0119pny w tej wersji bazy danych.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113610075819401072)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'pl'
,p_message_text=>unistr('Tablica kolekcji aplikacji nie mo\017Ce mie\0107 warto\015Bci Null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113609804745401072)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'pl'
,p_message_text=>unistr('Podany numer (%0) atrybutu jest niepoprawny. Numer atrybutu musi si\0119 zawiera\0107 w przedziale od 1 do %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113610374375401072)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'pl'
,p_message_text=>unistr('Kolekcja aplikacji ju\017C istnieje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113610189433401072)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'pl'
,p_message_text=>unistr('Nazwa kolekcji nie mo\017Ce mie\0107 warto\015Bci Null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113610224735401072)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'pl'
,p_message_text=>unistr('Nazwa kolekcji nie mo\017Ce przekracza\0107 255 znak\00F3w')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113609624553401072)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>'Kolekcja "%0" aplikacji nie istnieje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113610442341401072)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'pl'
,p_message_text=>'Kursor jeszcze nie jest otwarty'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113609733595401072)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sekwencja "%0" element\00F3w nie istnieje w kolekcji "%1" aplikacji'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113609953755401072)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sekwencja "%0" element\00F3w nie istnieje w kolekcji "%1" aplikacji'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113681771639401125)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Funkcja kryptograficzna "%0" nie jest obs\0142ugiwana w tym systemie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113735221570401164)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Przetestowano u\0142atwienia dost\0119pu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113629606258401086)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'pl'
,p_message_text=>'Zamknij'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113629790136401086)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'pl'
,p_message_text=>'Opcje dostosowywania strony'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113629865730401086)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'pl'
,p_message_text=>unistr('Domy\015Blne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113629996534401086)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Bwietlane')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113630057987401086)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'pl'
,p_message_text=>'Ukryte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113629440666401086)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'pl'
,p_message_text=>unistr('Prosz\0119 zaznaczy\0107 obszary, kt\00F3re maj\0105 zosta\0107 zawarte na stronie. Zaznaczone obszary mog\0105 nie zosta\0107 wy\015Bwietlone, je\015Bli jest to wykonywane w niew\0142a\015Bciwym kontek\015Bcie aplikacji albo je\015Bli bie\017C\0105cy u\017Cytkownik nie ma odpowiednich uprawnie\0144.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113629525617401086)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'pl'
,p_message_text=>unistr('Tej strony nie mo\017Cna dostosowywa\0107.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113735571234401165)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'pl'
,p_message_text=>unistr('Mo\017Cna spersonalizowa\0107 wygl\0105d tej aplikacji, zmieniaj\0105c styl motywu. Prosz\0119 wybra\0107 z poni\017Cszej listy styl motywu, po czym klikn\0105\0107 "Zastosuj zmiany".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113736326724401165)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'pl'
,p_message_text=>unistr('Wy\015Bwietlanie obszaru')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113735444786401165)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'pl'
,p_message_text=>unistr('U\017Cyj stylu domy\015Blnego aplikacji')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113735351384401165)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Wygl\0105d ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113678377963401122)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>unistr('Indeks kolumny, do kt\00F3rego odwo\0142uje si\0119 agregacja %0, nie istnieje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113581679886401051)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'pl'
,p_message_text=>unistr('Wynik w postaci obiektu CLOB nie jest obs\0142ugiwany dla formatu "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113678045441401122)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'pl'
,p_message_text=>unistr('Podzia\0142 kolumn musi si\0119 znajdowa\0107 na pocz\0105tku tablicy kolumn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113678124637401122)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>unistr('Indeks grupy kolumn, do kt\00F3rego odwo\0142uje si\0119 %0, nie istnieje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113595677253401062)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'pl'
,p_message_text=>'eksportuj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113600890723401065)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'pl'
,p_message_text=>unistr('Gdy jako serwer wydruku jest u\017Cywany ORDS, formatem eksportu musi by\0107 XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113678495215401122)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>unistr('Indeks kolumny, do kt\00F3rego odwo\0142uje si\0119 wyr\00F3\017Cnienie %0, nie istnieje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113594164797401060)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawny format eksportu: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113678200232401122)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>unistr('Indeks grupy nadrz\0119dnej, do kt\00F3rego odwo\0142uje si\0119 %0, nie istnieje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113703400441401141)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('Kolumna %1 z tabeli %0 jest kolumn\0105 to\017Csamo\015Bci "GENERATED ALWAYS". Prosz\0119 si\0119 upewni\0107, \017Ce \017Cadna kolumna \017Ar\00F3d\0142owa nie zosta\0142a w oknie dialogowym "Konfiguracja" odwzorowana na kolumn\0119 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113620856269401080)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'pl'
,p_message_text=>unistr('Podany interwa\0142 zatwierdzania jest za ma\0142y.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113620948061401080)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie podano kolumn do \0142adowania danych.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113622109252401081)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie znaleziono kolumn dla selektora wierszy "%0". Prosz\0119 spr\00F3bowa\0107 u\017Cy\0107 automatycznego wykrywania albo sprawdzi\0107 struktur\0119 JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113630410078401087)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'pl'
,p_message_text=>unistr('W pliku XLSX nie znaleziono \017Cadnych arkuszy roboczych.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113630397637401087)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'pl'
,p_message_text=>unistr('Podany arkusz roboczy nie wyst\0119puje w pliku XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113610585537401072)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'pl'
,p_message_text=>unistr('Bie\017C\0105ca wersja danych w bazie danych uleg\0142a zmianie, poniewa\017C u\017Cytkownik zainicjowa\0142 proces aktualizacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113612994226401074)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas aktualizowania kolumn raportu: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113717617546401152)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna przekszta\0142ci\0107: %0 w SDO_GEOMETRY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113657169696401107)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'pl'
,p_message_text=>unistr('Kolumny %0 o typie danych %1 nie mo\017Cna przekszta\0142ci\0107 w VARCHAR2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113664172861401112)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'pl'
,p_message_text=>unistr('W \017Ar\00F3dle danych nie znaleziono kolumny "%0" okre\015Blonej dla atrybutu "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113605482214401069)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'pl'
,p_message_text=>unistr('Typ filtra "%0" nie jest obs\0142ugiwany dla kolumn wielowarto\015Bciowych.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113721094489401154)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'pl'
,p_message_text=>unistr('Niepoprawny filtr "mi\0119dzy".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113587544708401056)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'pl'
,p_message_text=>unistr('Okre\015Blono niepoprawny typ listy warto\015Bci (LOV).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113587499217401056)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('Niepoprawny typ zapytania. Typem zapytania musi by\0107 tabela, zapytanie SQL lub funkcja PL/SQL zwracaj\0105ca zapytanie SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113657269064401107)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nie uda\0142o si\0119 wykona\0107 analizy sk\0142adniowej zapytania!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113664287980401112)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'pl'
,p_message_text=>unistr('Podana dla atrybutu "%1" pozycja "%0" kolumny nie zosta\0142a znaleziona w instrukcji SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113586057556401055)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'pl'
,p_message_text=>unistr('W filtrze wielowarto\015Bciowym u\017Cyto zbyt wiele element\00F3w.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113664024101401112)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie okre\015Blono kolumny dla atrybutu "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113587360703401056)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Tre\015B\0107 funkcji PL/SQL nie zwr\00F3ci\0142a warto\015Bci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113677254844401122)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'pl'
,p_message_text=>unistr('\0179r\00F3d\0142o danych REST nie zawiera funkcji operacji obs\0142ugi \017C\0105danej czynno\015Bci DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113583242140401053)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'pl'
,p_message_text=>unistr('Konwersja GeoJSON na SDO_GEOMETRY (kolumna %0) nie jest dost\0119pna w tej bazie danych.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113584317191401053)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'pl'
,p_message_text=>unistr('Konwersja SDO_GEOMETRY (kolumna %0) nie jest obs\0142ugiwana dla \017Ar\00F3de\0142 danych XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113591610475401059)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'pl'
,p_message_text=>unistr('Znak %0 nie jest obs\0142ugiwany jako separator warto\015Bci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113718994986401153)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('Tej funkcji nie mo\017Cna u\017Cy\0107 w kontek\015Bcie zapytania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113584469110401053)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('Niezgodno\015B\0107 typu danych kolumny.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113587262857401055)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'pl'
,p_message_text=>unistr('Przekroczono limity wi\0105za\0144 ORDS OUT. Prosz\0119 zmniejszy\0107 liczb\0119 wierszy DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113665089914401112)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nie uda\0142o si\0119 przeprowadzi\0107 analizy sk\0142adniowej odpowiedzi JSON, otrzymanej z odleg\0142ego serwera: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113587138373401055)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'pl'
,p_message_text=>'Nieznany lub niepoprawny typ kontekstu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113681615447401125)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('Ten typ pliku nie jest obs\0142ugiwany przez analizator sk\0142adni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113636232907401091)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nieautoryzowany dost\0119p (nie ustawiono wwv_flow_api.set_credentials).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113613273734401074)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'pl'
,p_message_text=>unistr('Obszar roboczy nie zosta\0142a utworzony, poniewa\017C ju\017C istnieje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113613144009401074)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'pl'
,p_message_text=>unistr('Grupa u\017Cytkownik\00F3w nie zosta\0142a utworzona, poniewa\017C ju\017C istnieje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113623430278401082)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'pl'
,p_message_text=>unistr('Wykryto zduplikowan\0105 nazw\0119 u\017Cytkownika dla "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113623586170401082)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas \0142adowania u\017Cytkownik\00F3w. Niepowodzenie przy u\017Cytkowniku %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113633418336401089)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'pl'
,p_message_text=>unistr('Za\0142adowano by %0 u\017Cytkownik\00F3w.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113633285612401089)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'pl'
,p_message_text=>unistr('Has\0142o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113633328801401089)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'pl'
,p_message_text=>'Uprawnienia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113633079616401089)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'pl'
,p_message_text=>unistr('Nazwa u\017Cytkownika')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113709563108401146)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas renderowania elementu "#COMPONENT_NAME#" strony.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113629119092401086)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna wy\015Bwietli\0107 elementu strony, poniewa\017C formularz HTML nie zosta\0142 jeszcze otwarty.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113594470024401061)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas obliczania warto\015Bci domy\015Blnej elementu #COMPONENT_NAME# strony.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113628457880401085)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas ko\0144cowego obliczania elementu #COMPONENT_NAME# strony.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113628372859401085)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas obliczania warto\015Bci \017Ar\00F3d\0142owej elementu #COMPONENT_NAME# strony.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113608145157401071)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'pl'
,p_message_text=>unistr('Nieautoryzowany dost\0119p.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113628661344401085)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'pl'
,p_message_text=>unistr('J\0119zyk JavaScript nie jest obs\0142ugiwany.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113628718633401085)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'pl'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113629364840401086)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna zainicjalizowa\0107 zapytania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113636599335401091)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 - aktualizacja nie jest obs\0142ugiwana.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113630744175401087)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'pl'
,p_message_text=>'Niepoprawny ID elementu: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113657037735401106)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'pl'
,p_message_text=>'Nie ma Pomocy dla tego elementu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113621589418401080)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie uda\0142o si\0119 wygenerowa\0107 zapytania dotycz\0105cego wykresu. Prosz\0119 sprawdzi\0107 ustawienia \017Ar\00F3d\0142a i odwzorowa\0144 kolumn.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113716337334401151)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'pl'
,p_message_text=>unistr('Rozmiar za\0142\0105cznika (%0\00A0MB) przekracza maksymalny dozwolony (%1\00A0MB).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113622486784401081)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'pl'
,p_message_text=>unistr('Niepoprawna warto\015B\0107 parametru p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113739898866401168)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'pl'
,p_message_text=>unistr('Przekroczono maksymaln\0105 liczb\0119 wiadomo\015Bci e-mail przypadaj\0105cych na obszar roboczy. Prosz\0119 si\0119 skontaktowa\0107 z administratorem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113603468266401067)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'pl'
,p_message_text=>unistr('Ta procedura musi by\0107 wywo\0142ywana z sesji aplikacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113622336050401081)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'pl'
,p_message_text=>unistr('Podano warto\015B\0107 Null parametru %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113676359280401121)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'pl'
,p_message_text=>'W aplikacji %1 nie znaleziono szablonu "%0" e-maili.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113752804262401177)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Aby mo\017Cna by\0142o wysy\0142a\0107 e-maile, trzeba ustawi\0107 parametr SMTP_HOST_ADDRESS instancji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113622091567401081)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Aby mo\017Cna by\0142o wys\0142a\0107 e-mail, trzeba poda\0107 odbiorc\0119 wiadomo\015Bci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113742285155401170)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna ustanowi\0107 po\0142\0105czenia SMTP ze skonfigurowanym serwerem poczty elektronicznej.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113716446398401151)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'pl'
,p_message_text=>unistr('Niepoprawne wywo\0142anie Ajax.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113607835294401070)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'pl'
,p_message_text=>'Nie zdefiniowano funkcji Ajax dla wtyczki %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113706848938401143)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'pl'
,p_message_text=>'Nie zdefiniowano funkcji wykonania dla wtyczki %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113607986561401071)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'pl'
,p_message_text=>'Nie zdefiniowano funkcji renderowania dla wtyczki %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113717358537401151)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Wtyczka "%0" \017Ar\00F3d\0142a danych REST nie zawiera funkcji "Mo\017Cliwo\015Bci".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113717267542401151)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Wtyczka "%0" \017Ar\00F3d\0142a danych REST nie zawiera funkcji DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113717470535401152)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Wtyczka "%0" \017Ar\00F3d\0142a danych REST nie zawiera funkcji wykonania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113717525147401152)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'pl'
,p_message_text=>unistr('Wtyczka "%0" \017Ar\00F3d\0142a danych REST nie zawiera funkcji pobierania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113605627055401069)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Podczas przetwarzania wtyczki zosta\0142 zg\0142oszony b\0142\0105d kodu PL/SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113612200172401074)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Trzeba okre\015Bli\0107 warto\015B\0107.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113642878574401096)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'pl'
,p_message_text=>unistr('Typu danych %0 nie mo\017Cna przekszta\0142ci\0107 w VARCHAR2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113728435207401160)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'pl'
,p_message_text=>unistr('W instrukcji SQL nie znaleziono kolumny "%0" okre\015Blonej dla atrybutu "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113704757269401142)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'pl'
,p_message_text=>unistr('Dla "%0" trzeba okre\015Bli\0107 zapytanie dot. listy warto\015Bci (LOV) albo nazwan\0105 list\0119 warto\015Bci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113706374806401143)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'pl'
,p_message_text=>unistr('W zapytaniu SQL dotycz\0105cym listy warto\015Bci (LOV) wybrano niepoprawn\0105 liczb\0119 kolumn dla "%0". Poprawne instrukcje s\0105 pokazane w przyk\0142adach.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113728214589401159)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie okre\015Blono kolumny dla atrybutu "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113757929476401181)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'pl'
,p_message_text=>unistr('Warto\015B\0107 "%0", wprowadzona dla atrybutu "%1", nie jest typu liczbowego.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113709812488401146)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'pl'
,p_message_text=>'%0 ma niepoprawny typ danych w instrukcji SQL. Kolumna %1 jest typu %2, a oczekiwano typu %3.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113728370806401160)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'pl'
,p_message_text=>unistr('Typem danych kolumny "%0", okre\015Blonej dla atrybutu "%1", jest "%2", a powinien to by\0107 typ "%3".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113604998332401068)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie znaleziono uk\0142adu raportu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113664947929401112)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'pl'
,p_message_text=>unistr('Funkcji "Oblicz sum\0119" nie mo\017Cna u\017Cy\0107 dla raport\00F3w opartych na \017Ar\00F3dle danych REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113628530672401085)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('ERR-2904 Nie mo\017Cna ustawi\0107 warto\015Bci skr\00F3tu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113632862577401088)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d: Nieznany typ skr\00F3tu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113622811585401081)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna pobra\0107 schematu authentication_scheme aplikacji %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113696365276401136)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'pl'
,p_message_text=>unistr('ID dzier\017Cawy ju\017C istnieje dla bie\017C\0105cej sesji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113633114804401089)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'pl'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113757338447401180)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'pl'
,p_message_text=>'Niepowodzenie identyfikacji.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113659673802401108)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'pl'
,p_message_text=>unistr('Jeden lub wi\0119ksza liczba plik\00F3w cookie w apex_util.g_request_cookies zawiera niepoprawn\0105 warto\015B\0107.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113642190093401095)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'pl'
,p_message_text=>unistr('Otrzymano niepoprawn\0105 odpowied\017A z rejestru UDDI.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113605770901401069)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'pl'
,p_message_text=>'Podany URL nie zwraca poprawnego dokumentu WSDL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113608273716401071)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'pl'
,p_message_text=>unistr('Dokument WSDL zawiera wi\0119cej ni\017C jedno wi\0105zanie SOAP. &PRODUCT_NAME. obs\0142uguje WSDL z tylko jednym wi\0105zaniem SOAP. Aby kontynuowa\0107 tworzenie odwo\0142ania do tej us\0142ugi, prosz\0119 klikn\0105\0107 "R\0119czne tworzenie odwo\0142ania do us\0142ugi internetowej".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113676617442401121)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'pl'
,p_message_text=>unistr('Odpowied\017A z us\0142ugi nie by\0142a w formacie XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113757255728401180)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'pl'
,p_message_text=>unistr('Token dost\0119pu OAuth nie jest dost\0119pny lub wygas\0142.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113720473157401154)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'pl'
,p_message_text=>unistr('Przekroczono maksymaln\0105 liczb\0119 \017C\0105da\0144 do us\0142ugi internetowej przypadaj\0105cych na obszar roboczy. Prosz\0119 si\0119 skontaktowa\0107 z administratorem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113757471766401180)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'pl'
,p_message_text=>unistr('Odpowied\017A serwera zawieraj\0105ca nieobs\0142ugiwany typ tokenu OAuth.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113607627492401070)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'pl'
,p_message_text=>unistr('Dokument WSDL nie zawiera\0142 wi\0105zania protoko\0142u SOAP, kt\00F3re jest wymagane, aby mo\017Cna by\0142o doda\0107 odwo\0142anie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113603567488401067)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'pl'
,p_message_text=>unistr('Ten kod WSDL wymaga uwierzytelnie\0144 identyfikuj\0105cych. Prosz\0119 poda\0107 poni\017Cej nazw\0119 u\017Cytkownika i has\0142o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113612396084401074)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'pl'
,p_message_text=>unistr('Motor renderowania nie zrozumia\0142 dokumentu WSDL. Aby kontynuowa\0107 tworzenie odwo\0142ania do tej us\0142ugi, prosz\0119 klikn\0105\0107 "R\0119czne tworzenie odwo\0142ania do us\0142ugi internetowej".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113679268463401123)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'pl'
,p_message_text=>unistr('Nie mo\017Cna przetworzy\0107 aktualizacji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113705065695401142)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'pl'
,p_message_text=>unistr('Zwracana i wy\015Bwietlana kolumna z listy warto\015Bci s\0105 t\0105 sam\0105 kolumn\0105.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113704927378401142)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'pl'
,p_message_text=>unistr('Lista warto\015Bci nie ma zwracanej kolumny.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113636483516401091)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas pobierania warto\015Bci kolumny: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113660425218401109)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'pl'
,p_message_text=>unistr('Obecne dane z formularza tabelarycznego s\0105 zbyt stare; \017Ar\00F3d\0142o danych zosta\0142o zmodyfikowane.<br/> Aby zrezygnowa\0107 z dokonanych zmian i ponownie za\0142adowa\0107 dane z bazy danych, prosz\0119 klikn\0105\0107 <strong><a href="%0">tutaj</a></strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113618505117401078)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas ustalania napisu wyznaczaj\0105cego paginacj\0119')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113618443432401078)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('nie mo\017Cna ustali\0107 nag\0142\00F3wk\00F3w zapytania:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113618620015401078)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'pl'
,p_message_text=>unistr('b\0142\0105d podczas zast\0119powania w stopce raportu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113618726004401078)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nie uda\0142o si\0119 wykona\0107 analizy sk\0142adniowej zapytania:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113623706637401082)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'pl'
,p_message_text=>unistr('Minimalna liczba \017C\0105danych wierszy: %0; wiersze znaleziono, ale nie wy\015Bwietlono: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113621273267401080)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'pl'
,p_message_text=>unistr('u\017Cyta w zapytaniu kolumna #%0 (%1) jest niepoprawna; dla kolumn u\017Cywaj\0105cych kodu HTML s\0105 wymagane aliasy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113636328234401091)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'pl'
,p_message_text=>unistr('B\0142\0105d podczas uzyskiwania nag\0142\00F3wk\00F3w zapytania: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113618868409401079)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('b\0142\0105d raportu:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113656566476401106)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'pl'
,p_message_text=>'Sortuj wg tej kolumny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113621335666401080)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'pl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Nie mo\017Cna wykona\0107 analizy sk\0142adniowej zapytania; prosz\0119 sprawdzi\0107 jego sk\0142adni\0119.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113660552886401109)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'pl'
,p_message_text=>unistr('Ten formularz zawiera niezapisane dane. Prosz\0119 nacisn\0105\0107 przycisk OK, aby kontynuowa\0107 bez zapisywania danych. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113664846562401112)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'pl'
,p_message_text=>unistr('Schemat "%0" paginacji raportu nie jest obs\0142ugiwany przy wybranym \017Ar\00F3dle danych.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113621118764401080)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'pl'
,p_message_text=>unistr('u\017Cyta w zapytaniu kolumna #%0 (%1) jest niepoprawna; prosz\0119 u\017Cy\0107 aliasu kolumny')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113623843391401082)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'pl'
,p_message_text=>'wiersz(e) %0 - %1 z ponad %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113662560635401111)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'pl'
,p_message_text=>unistr('%0 - %1 z wi\0119cej ni\017C %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113623609533401082)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'pl'
,p_message_text=>'wiersz(e) %0 - %1 z %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113607538327401070)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'pl'
,p_message_text=>'%0 - %1 z %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113618977705401079)
,p_name=>'Y'
,p_message_language=>'pl'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113625045634401083)
,p_name=>'YEAR'
,p_message_language=>'pl'
,p_message_text=>'rok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113618197669401078)
,p_name=>'YEARS'
,p_message_language=>'pl'
,p_message_text=>'lat(a)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113660683820401109)
,p_name=>'YES'
,p_message_language=>'pl'
,p_message_text=>'Tak'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4484)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4484)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4484
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4484)
,p_name=>'Komunikaty'
,p_alias=>'MESSAGES'
,p_step_title=>'Komunikaty'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
